#dialect "staticTypes"
import "exp+print" as baseExp
type Integer = baseExp.Integer
type Exp = baseExp.Exp
type Value = baseExp.Value

method add(l:Exp, r:Exp) -> Exp { baseExp.add(l, r) }
method lit(x:Integer) -> Exp { baseExp.lit(x) }

factory method bool(b:Boolean) -> Exp {
    method x -> Boolean { b }
    method eval -> Value { baseExp.value.fromBool(x) }
    method print -> String { b.asString }
}

factory method iff(cond:Exp)then(th:Exp)else(el:Exp) -> Exp {
    method eval -> Value {
        if (cond.eval.asBool) then { th.eval } else { el.eval }
    }
    method print -> String {
        "if ({cond.print}) then {th.print} else {el.print}"
    }
}

def threePlusFour:Exp = add(lit 3, lit 4)
def twoPlusSix:Exp = add(lit 2, lit 6)
def ifExpr:Exp = 
    iff(bool(true)) then(threePlusFour) else(twoPlusSix)
    
print "{ifExpr.print} = {ifExpr.eval.asInt}"
