#dialect "staticTypes"
import "exp" as baseExp
type Integer = baseExp.Integer
type Exp = baseExp.Exp & type { print -> String }
type Value = baseExp.Value

def value = baseExp.value

factory method lit(x':Integer) -> Exp {
    inherits baseExp.lit(x')
    method print { x.asString }
}

factory method add(l':Exp, r':Exp) -> Exp {
    inherits baseExp.add(l', r')
    method print { "{l.print} + {r.print}" }
}

// Demonstration:

def threePlusFour:Exp = add(lit 3, lit 4)
print "{threePlusFour.print} = {threePlusFour.eval.asInt}"

