#dialect "staticTypes"

type Integer = Number

type Value = {
    asInt -> Integer
    asBool -> Boolean
}

type Exp = {
    eval -> Value
}

def value = object {
    factory method fromInt(n:Integer) -> Value {
        method asInt -> Integer { n }
        method asBool -> Boolean {
            ProgrammingError.raise "Sorry, value is an Integer"
        }
    }
    factory method fromBool(b:Boolean) -> Value {
        method asInt -> Integer {
            ProgrammingError.raise "Sorry, value is a Boolean"
        }
        method asBool -> Boolean { b }
    }
}

factory method lit(x':Integer) -> Exp {
    method x -> Integer is confidential { x' }
    method eval -> Value { value.fromInt(x) }
}

factory method add(l':Exp, r':Exp) -> Exp {
    method l -> Exp is confidential { l' }
    method r -> Exp is confidential { r' }
    method eval -> Value {
        value.fromInt(l.eval.asInt + r.eval.asInt)
    }
}

// Demonstration:

def threePlusFour:Exp = add(lit 3, lit 4)
print "{threePlusFour} = {threePlusFour.eval.asInt}"
