#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "61482bce15cec41844a512fd6f07853796a59bdb";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "// #pragma noTypeChecks",
  "import \"util\" as util",
  "",
  "// This module contains pseudo-classes for all the AST nodes used",
  "// in the parser. The module predates the existence of classes in the",
  "// implementation, so they are written as object literals inside methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is:",
  "// dtype ASTNode {",
  "//   kind -> String // Used for pseudo-instanceof tests.",
  "//   register -> String // Used later on to hold the LLVM register of",
  "//                      // the resulting object.",
  "//   line -> Number // The source line the node came from.",
  "//   pretty(n:Number) -> String // Pretty-print of node at depth n,",
  "// }",
  "// Most also contain \"value\", with varied dtypes, holding the main value",
  "// in the node. Some contain other fields for their specific use: while has",
  "// both a value (the condition) and a \"body\", for example. None of the nodes",
  "// are particularly notable in any way.",
  "",
  "method listMap(l, b) parent(p) {",
  "    def newList = list.empty",
  "    for (l) do { nd -> newList.addLast(nd.map(b) parent(p)) }",
  "    if (newList.contains(done)) then {",
  "        print \"node list contains done!\"",
  "        print \"    original list = {l}\"",
  "        print \"    mapped list = {newList}\"",
  "    }",
  "    newList",
  "}",
  "method maybeMap(n, b) parent(p) {",
  "    if (n != false) then {",
  "        n.map(b) parent(p)",
  "    } else {",
  "        n",
  "    }",
  "}",
  "",
  "def emptySeq = sequence.empty",
  "",
  "type AstNode = type {",
  "    register -> String",
  "    line -> Number",
  "    line:=(ln:Number)",
  "    linePos -> Number",
  "    linePos:=(lp:Number)",
  "    hasSymbolTable -> Boolean",
  "    hasSymbolTable:=(st:Boolean)",
  "    parent -> AstNode",
  "    parent:=(p:AstNode)",
  "}",
  "",
  "class baseNode.new {",
  "    // the superclass of all AST nodes",
  "    var register is public := \"\"",
  "    var line is public := util.linenum",
  "    var linePos is public := util.linepos",
  "    var parent is public := nullNode",
  "    var hasSymbolTable is public := false",
  "",
  "    method isAppliedOccurenceOfIdentifier { false }",
  "    method isMatchingBlock { false }",
  "    method isFieldDec { false }",
  "    method isInherits { false }",
  "    method isMember { false }",
  "    method isCall { false }",
  "    method isClass { false }",
  "    method isBind { false }",
  "    method isObject { false }",
  "    method isIdentifier { false }",
  "    method definesObject { false }",
  "    method definesScope { false }",
  "    method usesAsType(aNode) { false }",
  "    method hash { line.hash * linePos.hash }",
  "    method asString { \"astNode {self.kind}\" }",
  "    method isWritable { true }",
  "    method isReadable { true }",
  "    method isPublic { true }",
  "    method isConfidential { isPublic.not }",
  "    method decType {",
  "        if (self.dtype == false) then {",
  "            return unknownType",
  "        }",
  "        return self.dtype",
  "    }",
  "    method accept(visitor) {",
  "        self.accept(visitor) from (nullNode)",
  "    }",
  "    method withParentRefs {",
  "        self.accept(addParentVisitor)",
  "        self",
  "    }",
  "    method declarationKind { self.kind }     // the kind of identifiers defined within me",
  "    method scope {",
  "        var node := self",
  "        while { node.hasSymbolTable.not } do { node := node.parent }",
  "        node.symbolTable",
  "        // TODO: add cache of this value, look at symboltable module",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p:AstNode){",
  "        register := other.register",
  "        line := other.line",
  "        linePos := other.linePos",
  "        parent := p",
  "        hasSymbolTable := other.hasSymbolTable",
  "        self",
  "    }",
  "    method pretty(depth) { ",
  "        \"{line}:{linePos} {self.kind}\"",
  "    }",
  "    method deepCopy {",
  "        self.map { each -> each } parent (nullNode)",
  "    }",
  "    method isUnder(lns) {",
  "        // lns is a list of strings representing kinds of AST node,",
  "        // from the bottom up.  Is this node a subtree of such a structure?",
  "        var nd := self",
  "        for (lns) do { each ->",
  "            nd := nd.parent",
  "            if (nd == nullNode) then { return false }",
  "            if (nd.kind != each) then { return false }",
  "        }",
  "        return true",
  "    }",
  "}",
  "",
  "class symbolTableNode.new {",
  "    // The superclass of all AST nodes that open a new scope,",
  "    // and thus may have a symbolTable.",
  "    inherits baseNode.new",
  "",
  "    var symbolTable'",
  "    method symbolTable { ",
  "        if (hasSymbolTable) then { symbolTable' } else {",
  "            ProgrammingError.raise \"Trying to get a non-existant symbolTable \"",
  "        }",
  "    }",
  "    method symbolTable:=(s) {",
  "        symbolTable' := s",
  "        s.node := self",
  "        hasSymbolTable := true",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p){",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        if (other.hasSymbolTable) then {",
  "            symbolTable' := other.symbolTable",
  "        }",
  "        self",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        if ((hasSymbolTable).andAlso{util.target == \"symbols\"}) then {",
  "            \"{super.pretty(depth)}\\n{spc}Symbols({symbolTable.variety}): {symbolTable'}{symbolTable'.elementScopesAsString}\"",
  "        } else {",
  "            super.pretty(depth)",
  "        }",
  "    }",
  "}",
  "",
  "def nullNode is public = object {",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"null\"",
  "    method toGrace(depth) {",
  "        \"// null\"",
  "    }",
  "}",
  "",
  "class ifNode.new(cond, thenblock', elseblock') {",
  "    inherits baseNode.new",
  "    def kind is public = \"if\"",
  "    var value is public := cond",
  "    var thenblock is public := thenblock'",
  "    var elseblock is public := elseblock'",
  "    var handledIdentifiers is public := false",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitIf(self) up(pNode)) then {",
  "            value.accept(visitor) from(self)",
  "            thenblock.accept(visitor) from(self)",
  "            elseblock.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.thenblock := thenblock.map(blk) parent(n)",
  "        n.elseblock := elseblock.map(blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ spc ++ \"Then: {thenblock.pretty(depth+2)}\\n\"",
  "            s := s ++ spc ++ \"Else: {elseblock.pretty(depth+2)}\"",
  "        } else {",
  "            s := s ++ spc ++ \"Then:\"",
  "            for (self.thenblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Else:\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock.body) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock.body) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        ifNode.new(nullNode, nullNode, nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        handledIdentifiers := other.handledIdentifiers",
  "        self",
  "    }",
  "}",
  "class blockNode.new(params', body') {",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"block\"",
  "    def value is public = \"block\"",
  "    var params is public := params'",
  "    var body is public := body'",
  "    def selfclosure is public = true",
  "    var matchingPattern is public := false",
  "    var extraRuntimeData is public := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor) from(self)",
  "    }",
  "    method declarationKind {",
  "        \"parameter\"",
  "    }",
  "    method isMatchingBlock { params.size == 1 }",
  "    method definesObject {",
  "        body.isEmpty.not.andAlso { body.last.definesObject }",
  "    }",
  "    method parametersDo(b) {",
  "        params.do(b)",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitBlock(self) up(pNode)) then {",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor) from(self)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(self)",
  "            }",
  "            if (self.matchingPattern != false) then {",
  "                self.matchingPattern.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.params := listMap(params, blk) parent(n)",
  "        n.body := listMap(body, blk) parent(n)",
  "        n.matchingPattern := maybeMap(matchingPattern, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        if (self.matchingPattern != false) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params[i]",
  "                if (self.matchingPattern != false) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" ->\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        blockNode.new(params, body).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        matchingPattern := other.matchingPattern",
  "        extraRuntimeData := other.extraRuntimeData",
  "        self",
  "    }",
  "}",
  "class catchCaseNode.new(block, cases', finally') {",
  "    inherits baseNode.new",
  "    def kind is public = \"catchcase\"",
  "    var value is public := block",
  "    var cases is public := cases'",
  "    var finally is public := finally'",
  "",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitCatchCase(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(self)",
  "            }",
  "            if (self.finally != false) then {",
  "                self.finally.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.cases := listMap(cases, blk) parent(n)",
  "        n.finally := maybeMap(finally, blk) parent(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"catch \" ++ self.value.toGrace(0) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.finally != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        catchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class matchCaseNode.new(matchee', cases', elsecase') {",
  "    inherits baseNode.new",
  "    def kind is public = \"matchcase\"",
  "    var value is public := matchee'",
  "    var cases is public := cases'",
  "    var elsecase is public := elsecase'",
  "    method matchee { value }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitMatchCase(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor) from(self)",
  "            }",
  "            if (self.elsecase != false) then {",
  "                self.elsecase.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.cases := listMap(cases, blk) parent(n)",
  "        n.elsecase := maybeMap(elsecase, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.elsecase != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        matchCaseNode.new(nullNode, emptySeq, false).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class methodTypeNode.new(name', signature', rtype') {",
  "    // Represents the signature of a method in a type literal",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"methodtype\"",
  "    var value is public := name'",
  "    var signature is public := signature'",
  "    var rtype is public := rtype'",
  "    var generics is public := sequence.empty",
  "    def nameString:String is public = value",
  "    method asString { \"MethodType {value} -> {rtype}\" }",
  "",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method declarationKind { \"typedec\" }",
  "    method typeParametersDo(b) {",
  "        if (false != generics) then {",
  "            generics.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitMethodType(self) up(pNode)) then {",
  "            if (rtype != false) then {",
  "                rtype.accept(visitor) from(self)",
  "            }",
  "            for (generics) do { each ->",
  "                each.accept(visitor) from(self)",
  "            }",
  "            for (signature) do { part ->",
  "                part.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.rtype := maybeMap(rtype, blk) parent(n)",
  "        n.signature := listMap(signature, blk) parent(n)",
  "        n.generics := listMap(generics, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (rtype != false) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\"",
  "        }",
  "        if (generics.isEmpty.not) then {",
  "            s := \"{s}\\n{spc}TypeParams:\"",
  "            for (generics) do { each -> ",
  "                s := \"{s}\\n{spc}  {each.pretty(depth + 2)}\"",
  "            }",
  "        }",
  "        s := \"{s}\\n{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}{part.pretty(depth + 2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.rtype != false) then {",
  "            s := s ++ \" -> \" ++ self.rtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        methodTypeNode.new(value, emptySeq, false).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class typeLiteralNode.new(methods', types') {",
  "    inherits baseNode.new",
  "    def kind is public = \"typeliteral\"",
  "    var methods is public := methods'",
  "    var types is public := types'",
  "    var nominal is public := false",
  "    var anonymous is public := true",
  "    var value is public := \"‹anon›\"",
  "    ",
  "    method name { value }",
  "    method name:=(n:String) {",
  "        value := n",
  "        anonymous := false",
  "    }",
  "    method asString {",
  "        \"TypeLiteral: methods = {methods}, types = {types}\"",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitTypeLiteral(self) up(pNode)) then {",
  "            for (self.methods) do { each ->",
  "                each.accept(visitor) from(self)",
  "            }",
  "            for (self.types) do { each ->",
  "                each.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.methods := listMap(methods, blk) parent (n)",
  "        n.types := listMap(types, blk) parent (n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}\\n\"",
  "        s := s ++ spc ++ \"Types:\"",
  "        for (types) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Methods:\"",
  "        for (methods) do { each ->",
  "            s := s ++ \"\\n  \"++ spc ++ each.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"type\"",
  "        if (self.generics.size > 0) then {",
  "            s := s ++ \"<\"",
  "            for (self.generics.indices) do { i ->",
  "                s := s ++ self.generics[i].value",
  "                if (i < self.generics.size) then {",
  "                    s := s ++ \", \"",
  "                }",
  "            }",
  "            s := s ++ \">\"",
  "        }",
  "        s := s ++ \" = \\{\"",
  "        for (self.methods) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        for (self.types) do { each ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ each.toGrace(depth + 1)",
  "        }",
  "        s ++ \"\\}\"",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        typeLiteralNode.new(emptySeq, emptySeq).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        nominal := other.nominal",
  "        anonymous := other.anonymous",
  "        value := other.value",
  "        self",
  "    }",
  "}",
  "",
  "class typeDecNode.new(name', typeValue) {",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"typedec\"",
  "    var name is public := name'",
  "    var value is public := typeValue",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "    var generics is public := list.empty",
  "",
  "    method declarationKind {",
  "        \"parameter\"",
  "    }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitTypeDec(self) up(pNode)) then {",
  "            value.accept(visitor) from(self)",
  "            generics.do { each -> each.accept(visitor) from(self) }",
  "            annotations.do { each -> each.accept(visitor) from(self) }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        if (name.kind != \"identifier\") then { ",
  "            print \"typeDecNode {nameString} does not contain an identifier\" ",
  "        }",
  "        n.name := name.map(blk) parent(n)",
  "        n.value := value.map(blk) parent(n)",
  "        n.annotations := listMap(annotations, blk) parent(n)",
  "        n.generics := listMap(generics, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1) ++ \"\\n\"",
  "        if (generics.size > 0) then {",
  "            s := \"{s}{spc}Generic parameters:\\n\"",
  "            for (generics) do {ut->",
  "                s := \"{s}{spc}  {ut}\\n\"",
  "            }",
  "        }",
  "        s := s ++ spc ++ \"Value:\"",
  "        s := s ++ value.pretty(depth+2)",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        s := \"type {self.name}\"",
  "        if (self.generics.size > 0) then {",
  "            s := s ++ \"<\"",
  "            for (self.generics.indices) do { i ->",
  "                s := s ++ self.generics[i].value",
  "                if (i < self.generics.size) then {",
  "                    s := s ++ \", \"",
  "                }",
  "            }",
  "            s := s ++ \">\"",
  "        }",
  "        s := s ++ \" = \" ++ value(toGrace(depth + 2))",
  "        s",
  "    }",
  "    method asString { \"TypeDec {nameString}\" }",
  "    method shallowCopyWithParent(p) {",
  "        typeDecNode.new(name, nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "",
  "class methodNode.new(name', signature', body', dtype') {",
  "    // Represents a method declaration",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"method\"",
  "    var value is public := name'",
  "    var signature is public := signature'",
  "    var body is public := body'",
  "    var dtype is public := dtype'",
  "    var varargs is public := false",
  "    var generics is public := sequence.empty",
  "    var selfclosure is public := false",
  "    def nameString:String is public = value.value",
  "    var annotations is public := list.empty",
  "    var isFresh is public := false      // a method is 'fresh' if it answers a new object",
  "",
  "    method declarationKind {",
  "        \"parameter\"",
  "    }",
  "    method isConfidential {",
  "        if (annotations.size == 0) then { return false }",
  "        findAnnotation(self, \"confidential\")",
  "    }",
  "    method isPublic { isConfidential.not }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method definesScope { ",
  "        body.isEmpty.not.andAlso {body.last.definesObject}",
  "    }",
  "    method objectScope {",
  "        scope.parent",
  "    }",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method typeParametersDo(b) {",
  "        if (false != generics) then {",
  "            generics.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitMethod(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(self)",
  "            }",
  "            for (generics) do { each ->",
  "                each.accept(visitor) from(self)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor) from(self)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor) from(self)",
  "                }",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p){",
  "        var n := shallowCopyWithParent(p)",
  "        n.body := listMap(body, blk) parent(n)",
  "        n.signature := listMap(signature, blk) parent(n)",
  "        n.annotations := listMap(annotations, blk) parent(n)",
  "        n.generics := listMap(generics, blk) parent(n)",
  "        n.dtype := maybeMap(dtype, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Name: \" ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (false != self.dtype) then {",
  "            s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "            s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "        }",
  "        if (isFresh) then { s := s ++ spc ++ \"Fresh\\n\" }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := \"{s}{spc}Generics:\"",
  "            for (generics) do {g->",
  "                s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "            }",
  "            s := s ++ \"\\n\"",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := \"{s}{spc}Annotations:\"",
  "            for (annotations) do {an->",
  "                s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "            }",
  "            s := s ++ \"\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"method \"",
  "        var firstPart := true",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if (firstPart.andAlso{generics.size != 0}) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            firstPart := false",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method asString { \"Method {nameString}\" }",
  "    method shallowCopyWithParent(p) {",
  "        methodNode.new(value, signature, body, dtype).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        isFresh := other.isFresh",
  "        selfclosure := other.selfclosure",
  "        self",
  "    }",
  "}",
  "class callNode.new(what, with') {",
  "    // requested as callNode.new(target:AstNode, parts:List)",
  "    // Represents a method request with arguments.",
  "    // The ‹target›.‹methodName› part is in `value`",
  "    // The argument list is in `with`, as a sequence of `callWithPart`s.",
  "    // [with]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         args := sequence.empty",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         args := sequence.empty",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind is public = \"call\"",
  "    var value is public := what        // method being requested",
  "    var with is public := with'        // arguments",
  "    var generics is public := false",
  "    var isPattern is public := false",
  "    def nameString:String is public = value.nameString",
  "    ",
  "    method target { value }",
  "    method isCall { true }",
  "    method definesObject {",
  "        value.isMember.andAlso { value.nameString == \"clone\" }",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitCall(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg ->",
  "                    arg.accept(visitor) from(self)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.with := listMap(with, blk) parent(n)",
  "        if (generics != false) then {",
  "            n.generics := listMap(generics, blk) parent(n)",
  "        }",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ \"Method Name: {self.value.pretty(depth + 1)}\"",
  "        s := s ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := s ++ spc ++ \"  Generics:\\n\"",
  "            for (generics) do {g->",
  "                s := s ++ spc ++ \"    \" ++ g.pretty(depth + 2) ++ \"\\n\"",
  "            }",
  "        }",
  "        s := s ++ spc ++ \"Arguments:\"",
  "        for (self.with) do { part ->",
  "            s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "            for (part.args) do { arg ->",
  "                s := s ++ \"\\n      \" ++ spc ++ arg.pretty(depth + 2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        // only the last member is the method call we need to handle",
  "        if (self.value.kind == \"member\") then {",
  "            var member := self.value",
  "            if (member.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := member.value.substringFrom(7)to(member.value.size)",
  "                return s ++ member.in.toGrace(0)",
  "            }",
  "            s := member.in.toGrace(0) ++ \".\"",
  "        }",
  "        var firstPart := true",
  "        for (self.with) do { part ->",
  "            s := s ++ part.name",
  "            if (firstPart.andAlso{generics != false}) then {",
  "                s := s ++ \"<\"",
  "                for (1..(generics.size - 1)) do {ix ->",
  "                    s := s ++ generics.at(ix).toGrace(depth + 1)",
  "                }",
  "                s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "            }",
  "            firstPart := false",
  "            if (part.args.size > 0) then {",
  "                s := s ++ \"(\"",
  "                for (part.args.indices) do { anr ->",
  "                    var arg := part.args[anr]",
  "                    s := s ++ arg.toGrace(depth + 1)",
  "                    if (anr < part.args.size) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method asString { \"Call {what.pretty(0)}\" }",
  "    method shallowCopyWithParent(p) {",
  "        callNode.new(value, with).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        isPattern := other.isPattern",
  "        self",
  "    }",
  "}",
  "class classNode.new(name', signature', body', superclass', constructor', dtype') {",
  "    // TODO  remove superclass as a parameter",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := sequence.empty",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"class\"",
  "    var value is public := body'",
  "    var name is public := name'",
  "    var constructor is public := constructor'",
  "    var signature is public := signature'",
  "    var dtype is public := dtype'",
  "    var generics is public := sequence.empty",
  "    var superclass is public := superclass'",
  "    var annotations is public := list.empty",
  "    def nameString:String is public = name.value",
  "",
  "    var data is public := false",
  "    ",
  "    method fullName { \"{nameString}.{constructor.nameString}\" }",
  "    method declarationKind {",
  "        \"method\"",
  "    }",
  "    method definesObject { true }",
  "    method isClass { true }",
  "    method isPublic {",
  "        // assume that classes are public by default",
  "        if (annotations.size == 0) then { return true }",
  "        findAnnotation(self, \"confidential\").not",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method parametersDo(b) {",
  "        signature.do { part -> ",
  "            part.params.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method typeParametersDo(b) {",
  "        if (false != generics) then {",
  "            generics.do { each -> b.apply(each) }",
  "        }",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitClass(self) up(pNode)) then {",
  "            self.name.accept(visitor) from(self)",
  "            self.constructor.accept(visitor) from(self)",
  "            if (self.superclass != false) then {",
  "                self.superclass.accept(visitor) from(self)",
  "            }",
  "            for (self.signature) do { partNode ->",
  "                partNode.accept(visitor) from(self)",
  "            }",
  "            for (self.value) do { each ->",
  "                each.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := listMap(value, blk) parent(n)",
  "        n.name := name.map(blk) parent(n)",
  "        n.signature := listMap(signature, blk) parent(n)",
  "        n.generics := listMap(generics, blk) parent(n)",
  "        n.annotations := listMap(annotations, blk) parent(n)",
  "        n.superclass := maybeMap(superclass, blk) parent(n)",
  "        n.constructor := constructor.map(blk) parent(n)",
  "        n.dtype := maybeMap(dtype, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := \"{s}{spc}Name: {self.name.pretty(0)}\"",
  "        if (util.target == \"symbols\") then {",
  "            s := s ++ \"\\n{spc}Parent Symbols({symbolTable'.parent.variety}): {symbolTable'.parent.keysAndValuesAsList}\"",
  "            s := s ++ \"\\n{spc}Parent^2 Symbols({symbolTable'.parent.parent.variety}): {symbolTable'.parent.parent.keysAndValuesAsList}\"",
  "        }",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := \"{s}{spc}Factory method: {constructor.pretty(0)}\\n\"",
  "        if(false != dtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{dtype.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        if (generics.isEmpty.not) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"TypeParams:\"",
  "            for (generics) do {g->",
  "                s := s ++ \"\\n  {spc}{g.pretty(0)}\"",
  "            }",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Annotations:\"",
  "            for (annotations) do {a->",
  "                s := s ++ \" {a.pretty(depth + 2)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n  \"++ spc ++ x.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"class {self.name.toGrace(0)}\"",
  "        if (self.name.kind != \"generic\") then {",
  "            // TODO generics + new-style constructors aren't possible at the moment",
  "            s := s ++ \".\"",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params[pnr]",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        s := s ++ \"*\" ++ part.vararg.value",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "        }",
  "        if(false != dtype) then {",
  "            s := \"{s} -> {dtype.toGrace(depth + 1)}\"",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.value) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        classNode.new(name, emptySeq, emptySeq, false, nullNode, false)",
  "            .shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        data := other.data",
  "        self",
  "    }",
  "}",
  "class objectNode.new(body, superclass') {",
  "    // TODO  remove superclass as a parameter",
  "    inherits symbolTableNode.new",
  "    def kind is public = \"object\"",
  "    var value is public := body",
  "    var superclass is public := superclass'",
  "    var classname is public := \"object\"",
  "    var data is public := false",
  "    ",
  "    method fullName { ",
  "        if (classname != \"object\") then { return classname }",
  "        if (parent.kind == \"defdec\") then { return parent.nameString }",
  "        return classname",
  "    }",
  "    method definesObject { true }",
  "    method isObject { true }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitObject(self) up(pNode)) then {",
  "            if (self.superclass != false) then {",
  "                self.superclass.accept(visitor) from(self)",
  "            }",
  "            for (self.value) do { x ->",
  "                x.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := listMap(value, blk) parent(n)",
  "        n.superclass := maybeMap(superclass, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth') {",
  "        var depth := depth'",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 1)",
  "            s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "            depth := depth + 1",
  "        }",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n\"++ spc ++ x.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"object \\{\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        objectNode.new(emptySeq, false).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        data := other.data",
  "        classname := other.classname",
  "        self",
  "    }",
  "    method asString {",
  "        \"object \\{{classname} inherits {superclass}\\}\"",
  "    }",
  "}",
  "class arrayNode.new(values) {",
  "    inherits baseNode.new",
  "    def kind is public = \"array\"",
  "    var value is public := values",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitArray(self) up(pNode)) then {",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := listMap(value, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value[i].toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        arrayNode.new(emptySeq).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class memberNode.new(what, in') {",
  "    // Represents a dotted request ‹in›.‹value›",
  "    inherits baseNode.new",
  "    def kind is public = \"member\"",
  "    var value is public := what  // NB: value is a String, not an Identifier",
  "    var in is public := in'",
  "    var generics is public := false",
  "",
  "    method target { in }",
  "    method nameString { value }",
  "    method isMember { true }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitMember(self) up(pNode)) then {",
  "            self.in.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.in := in.map(blk) parent(n)",
  "        if (generics != false) then {",
  "            n.generics := listMap(generics, blk) parent(n)",
  "        }",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\\n\"",
  "        s := s ++ spc ++ in.pretty(depth)",
  "        if (generics != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"  Generics:\"",
  "            for (generics) do {g->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ g.pretty(0)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "            s := self.value.substringFrom(7)to(value.size)",
  "            s := s ++ \" \" ++ self.in.toGrace(0)",
  "        } else {",
  "            s := self.in.toGrace(depth) ++ \".\" ++ self.value",
  "        }",
  "        if (generics != false) then {",
  "            s := s ++ \"<\"",
  "            for (1..(generics.size - 1)) do {ix ->",
  "                s := s ++ generics.at(ix).toGrace(depth + 1)",
  "            }",
  "            s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "        }",
  "        s",
  "    }",
  "    method asString { \"Member‹{value}›\" }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new(value, false)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        parent := self",
  "        return resultNode",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        memberNode.new(value, nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class genericNode.new(base, params') {",
  "    inherits baseNode.new",
  "    def kind is public = \"generic\"",
  "    var value is public := base        // APB: in a generic call, value is the called node",
  "                            // e.g. in List<Number>, value is Identifier‹List›",
  "    var params is public := params'",
  "    method nameString { value.nameString }",
  "    method asString { ",
  "        var s := \"{base}<\"",
  "        params.do { each -> s := \"{s}{each}\" } separatedBy { s := s ++ \", \" }",
  "        s ++ \">\"",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitGeneric(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            for (self.params) do { p ->",
  "                p.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.params := listMap(params, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"{super.pretty(depth)}‹self.value.value›<\"",
  "        for (self.params.indices) do { i ->",
  "            s := s ++ self.params[i].pretty(depth+2)",
  "            if (i < self.params.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \">\"",
  "        s",
  "",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := self.value.value ++ \"<\"",
  "        for (self.params.indices) do { i ->",
  "            s := s ++ self.params[i].toGrace(0)",
  "            if (i < self.params.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \">\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        genericNode.new(value, emptySeq).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class identifierNode.new(name, dtype') {",
  "    inherits baseNode.new",
  "    def kind is public = \"identifier\"",
  "    var value is public := name",
  "    var wildcard is public := false",
  "    var dtype is public := dtype'",
  "    var isBindingOccurrence is public := false",
  "    var isAssigned is public := false",
  "    var inRequest is public := false",
  "    var generics is public := false",
  "    var isDeclaredByParent is public := false",
  "",
  "    method nameString { value }     //  value changes when parsing \"[]\"",
  "    ",
  "    method isIdentifier { true }",
  "",
  "    method isAppliedOccurenceOfIdentifier {",
  "        if (wildcard) then { ",
  "            false ",
  "        } else {",
  "            isBindingOccurrence.not",
  "        }",
  "    }",
  "    method declarationKind {",
  "        parent.declarationKind",
  "    }",
  "    method inTypePosition {",
  "        // am I used by my parent node as a type?",
  "        // This is a hack, uses as a subsitute for having information in the .gct",
  "        // telling us which identifiers represent types",
  "        parent.usesAsType(self)",
  "    }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitIdentifier(self) up(pNode)) then {",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.dtype := maybeMap(dtype, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth)",
  "        if ( wildcard ) then {",
  "            s := s ++ \" Wildcard\"",
  "        } elseif { isBindingOccurrence } then {",
  "            s := s ++ \"Binding‹{value}›\"",
  "        } else {",
  "            s := s ++ \"‹{value}›\"",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"  Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != generics) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "            for (generics) do {g->",
  "                s := s ++ spc ++ \"  \" ++ g.pretty(depth + 2)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s",
  "        if(self.wildcard) then {",
  "            s := \"_\"",
  "        } else {",
  "            s := self.value",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "        }",
  "        if (false != generics) then {",
  "            s := s ++ \"<\"",
  "            for (1..(generics.size - 1)) do {ix ->",
  "                s := s ++ generics.at(ix).toGrace(depth + 1)",
  "            }",
  "            s := s ++ generics.last.toGrace(depth + 1) ++ \">\"",
  "        }",
  "        s",
  "    }",
  "",
  "    method asString { ",
  "        if (isBindingOccurrence) then {",
  "            \"IdentifierBinding‹{value}›\"",
  "        } else { ",
  "            \"Identifier‹{value}›\"",
  "        }",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        identifierNode.new(value, false).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        wildcard := other.wildcard",
  "        isBindingOccurrence := other.isBindingOccurrence",
  "        isDeclaredByParent := other.isDeclaredByParent",
  "        isAssigned := other.isAssigned",
  "        inRequest := other.inRequest",
  "        self",
  "    }",
  "}",
  "",
  "def typeType is public = identifierNode.new(\"Type\", false)",
  "def unknownType is public = identifierNode.new(\"Unknown\", typeType)",
  "",
  "class octetsNode.new(num) {",
  "    inherits baseNode.new",
  "    def kind is public = \"octets\"",
  "    var value is public := num",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        visitor.visitOctets(self) up(pNode)",
  "    }",
  "    method pretty(depth) {",
  "        \"{super.pretty(depth)}({self.value})\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        octetsNode.new(value).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class stringNode.new(v) {",
  "    inherits baseNode.new",
  "    def kind is public = \"string\"",
  "    var value is public := v",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        visitor.visitString(self) up(pNode)",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        \"{super.pretty(depth)}({self.value})\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\\\"\"",
  "        for (self.value) do { c ->",
  "            // TODO: what escapes are missing?",
  "            if (c == \"\\n\") then {",
  "                s := s ++ \"\\\\n\"",
  "            } elseif (c == \"\\t\") then {",
  "                s := s ++ \"\\\\t\"",
  "            } elseif (c == \"\\\"\") then {",
  "                s := s ++ \"\\\\\\\"\"",
  "            } elseif (c == \"\\\\\") then {",
  "                s := s ++ \"\\\\\\\\\"",
  "            } else {",
  "                s := s ++ c",
  "            }",
  "        }",
  "        s := s ++ \"\\\"\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        stringNode.new(value).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class numNode.new(val) {",
  "    inherits baseNode.new",
  "    def kind is public = \"num\"",
  "    var value is public := val",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        visitor.visitNum(self) up(pNode)",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        \"{super.pretty(depth)}({self.value})\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value.asString",
  "    }",
  "    method asString { \"Number {value}\" }",
  "    method shallowCopyWithParent(p) {",
  "        numNode.new(value).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class opNode.new(op, l, r) {",
  "    inherits baseNode.new",
  "    def kind is public = \"op\"",
  "    def value is public = op     // a String",
  "    var left is public := l",
  "    var right is public := r",
  "    method nameString { value }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitOp(self) up(pNode)) then {",
  "            self.left.accept(visitor) from(self)",
  "            self.right.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.left := left.map(blk) parent(n)",
  "        n.right := right.map(blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}‹\" ++ self.value ++ \"›\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && (self.left.value != self.value)) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && (self.right.value != self.value)) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "    method asIdentifier {",
  "        // make an identifiderNode with the same properties as me",
  "        def resultNode = identifierNode.new(value, false)",
  "        resultNode.inRequest := true",
  "        resultNode.line := line",
  "        resultNode.linePos := linePos",
  "        parent := self",
  "        return resultNode",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        opNode.new(value, nullNode, nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class indexNode.new(expr, index') {",
  "    // an expression in square brackets",
  "    inherits baseNode.new",
  "    def kind is public = \"index\"",
  "    var value is public := expr",
  "    var index is public := index'",
  "    ",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitIndex(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            self.index.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.index := index.map(blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.index.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.value.toGrace(depth + 1)",
  "        s := s ++ \"[\" ++ self.index.toGrace(depth + 1) ++ \"]\"",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        indexNode.new(nullNode, nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class bindNode.new(dest', val') {",
  "    // an assignment, or a request of a setter-method",
  "    inherits baseNode.new",
  "    def kind is public = \"bind\"",
  "    var dest is public := dest'",
  "    var value is public := val'",
  "    ",
  "    method isBind { true }",
  "    method asString { \"Bind {value}\" }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitBind(self) up(pNode)) then {",
  "            self.dest.accept(visitor) from(self)",
  "            self.value.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.dest := dest.map(blk) parent(n)",
  "        n.value := value.map(blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        bindNode.new(dest, value).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class defDecNode.new(name', val, dtype') {",
  "    inherits baseNode.new",
  "    def kind is public = \"defdec\"",
  "    var name is public := name'",
  "    var value is public := val",
  "    var dtype is public := dtype'",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "    var data is public := false",
  "    var startToken is public := false",
  "",
  "    method isPublic {",
  "        // defs are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        def res = findAnnotation(self, \"readable\")",
  "        if (nameString == \"bindings\") then {",
  "            print \"bindings is public\"",
  "        }",
  "        res",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method isFieldDec { ",
  "        if (parent.kind == \"object\") then { true }",
  "            elseif {parent.kind == \"class\"} then { true }",
  "            else { false }",
  "    }",
  "    method definesScope {",
  "        value.definesObject",
  "    }",
  "    method objectScope {",
  "        scope",
  "    }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitDefDec(self) up(pNode)) then {",
  "            self.name.accept(visitor) from(self)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(self)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.name := name.map(blk) parent(n)",
  "        n.value := value.map(blk) parent(n)",
  "        n.dtype := maybeMap(dtype, blk) parent(n)",
  "        n.annotations := listMap(annotations, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth)",
  "        if (dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \" ++ value.pretty(depth + 2)",
  "        }",
  "//        if (annotations.isEmpty.not) then {",
  "//            s := s ++ \"\\n{spc}Annotations:\"",
  "//            annotations.do { ann ->",
  "//                s := \"{s} {ann.pretty(depth + 2)}\"",
  "//            }",
  "//        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"def {self.name.toGrace(0)}\"",
  "        if (self.dtype.value != \"Unknown\") then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        defDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        data := other.data",
  "        startToken := other.startToken",
  "        self",
  "    }",
  "}",
  "class varDecNode.new(name', val', dtype') {",
  "    inherits baseNode.new",
  "    def kind is public = \"vardec\"",
  "    var name is public := name'",
  "    var value is public := val'",
  "    var dtype is public := dtype'",
  "    def nameString:String is public = name.value",
  "    var annotations is public := list.empty",
  "",
  "    method isPublic {",
  "        // vars are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"writable\")) then { return true }",
  "        false",
  "    }",
  "    method isReadable {",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        if (findAnnotation(self, \"readable\")) then { return true }",
  "        false",
  "    }",
  "    method isFieldDec { ",
  "        if (parent.kind == \"object\") then { true }",
  "            elseif {parent.kind == \"class\"} then { true }",
  "            else { false }",
  "    }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitVarDec(self) up(pNode)) then {",
  "            self.name.accept(visitor) from(self)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(self)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.name := name.map(blk) parent(n)",
  "        n.value := maybeMap(value, blk) parent(n)",
  "        n.dtype := maybeMap(dtype, blk) parent(n)",
  "        n.annotations := listMap(annotations, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type: \"",
  "            s := s ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Value: \"",
  "            s := s ++ self.value.pretty(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if (self.dtype.value != \"Unknown\") then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        varDecNode.new(name, value, dtype).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class importNode.new(path', name', dtype') {",
  "    inherits baseNode.new",
  "    def kind is public = \"import\"",
  "    var value is public := name'",
  "    var path is public := path'",
  "    var annotations is public := list.empty",
  "    var dtype is public := dtype'",
  "    method name { value }",
  "    method nameString { value.nameString }",
  "    method isPublic {",
  "        // imports, like defs, are confidential by default",
  "        if (annotations.size == 0) then { return false }",
  "        if (findAnnotation(self, \"public\")) then { return true }",
  "        findAnnotation(self, \"readable\")",
  "    }",
  "    method isWritable { false }",
  "    method isReadable { isPublic }",
  "    method declarationKind { \"defdec\" }",
  "    method usesAsType(aNode) {",
  "        aNode == dtype",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitImport(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor) from(self)",
  "            }",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n.dtype := maybeMap(dtype, blk) parent(n)",
  "        n.annotations := listMap(annotations, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {value}\\n\"",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"{spc}Anotations: {annotations}\\n\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {nameString}\"",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        importNode.new(path, nullNode, false).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class dialectNode.new(path') {",
  "    inherits baseNode.new",
  "    def kind is public = \"dialect\"",
  "    var value is public := path'",
  "    ",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        visitor.visitDialect(self) up(pNode)",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        dialectNode.new(value).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class returnNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind is public = \"return\"",
  "    var value is public := expr",
  "",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitReturn(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        returnNode.new(nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "class inheritsNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind is public = \"inherits\"",
  "    var value is public := expr",
  "    var providedNames is public := list.empty",
  "    ",
  "    method isInherits { true }",
  "    method inheritsFromMember { value.isMember }",
  "    method inheritsFromCall { value.isCall }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitInherits(self) up(pNode)) then {",
  "            self.value.accept(visitor) from(self)",
  "        }",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.value := value.map(blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := super.pretty(depth) ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        if (providedNames.isEmpty.not) then {",
  "            s := s ++ \"\\n{spc}Provided names: {providedNames}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"inherits {self.value.toGrace(0)}\"",
  "    }",
  "    method nameString { value.toGrace(0) }",
  "    method asString { \"Inherits {nameString}\" }",
  "    method shallowCopyWithParent(p) {",
  "        inheritsNode.new(nullNode).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        providedNames := other.providedNames",
  "        self",
  "    }",
  "}",
  "class blankNode.new {",
  "    inherits baseNode.new",
  "    def kind is public = \"blank\"",
  "    def value is public = \"blank\"",
  "    ",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "    }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"\"",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        blankNode.new.shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "}",
  "",
  "class signaturePart.new(*values) {",
  "    inherits baseNode.new",
  "    def kind is public = \"signaturepart\"",
  "    var name is public := \"\"",
  "    var params is public := list.empty",
  "    var vararg is public := false",
  "    var generics is public := list.empty",
  "    var lineLength is public := 0",
  "    if (values.size > 0) then {",
  "        name := values[1]",
  "    }",
  "    if (values.size > 1) then {",
  "        params := values[2]",
  "    }",
  "    if (values.size > 2) then {",
  "        vararg := values[3]",
  "    }",
  "    method accept(visitor : ASTVisitor) from(pNode) {",
  "        if (visitor.visitSignaturePart(self) up(pNode)) then {",
  "            params.do { p -> p.accept(visitor) from(self) }",
  "            if (false != vararg) then { vararg.accept(visitor) from(self) }",
  "            generics.do { g -> g.accept(visitor) from(self) }",
  "        }",
  "    }",
  "    method declarationKind { \"parameter\" }",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.params := listMap(params, blk) parent(n)",
  "        n.vararg := maybeMap(vararg, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}: {name}\"",
  "        s := \"{s}\\n{spc}Parameters:\"",
  "        for (params) do { p ->",
  "            s := \"{s}\\n  {spc}{p.pretty(depth + 2)}\"",
  "        }",
  "        if (vararg != false) then {",
  "            s := \"{s}\\n  {spc}Vararg: {vararg.pretty(depth + 1)}\"",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        signaturePart.new(name).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        lineLength := other.lineLength",
  "        self",
  "    }",
  "    method asString {",
  "        \"Part: {name}\"",
  "    }",
  "}",
  "",
  "class callWithPart.new(*values) {",
  "    // requested as",
  "    // - callWithPart.new(request:String), or",
  "    // - callWithPart.new(request:String, arguments:List)",
  "    // The first is equivalent to the second with an empty list of arguments",
  "    inherits baseNode.new",
  "    def kind is public = \"callwithpart\"",
  "    var name is public := \"\"",
  "    var args is public := list.empty",
  "    var lineLength is public := 0",
  "    if (values.size > 0) then {",
  "        name := values[1]",
  "    }",
  "    if (values.size > 1) then {",
  "        args := values[2]",
  "    }",
  "",
  "    method map(blk) parent(p) {",
  "        var n := shallowCopyWithParent(p)",
  "        n.args := listMap(args, blk) parent(n)",
  "        n := blk.apply(n)",
  "        n",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"{super.pretty(depth)}: {name}\"",
  "        s := \"{s}\\n    {spc}Args:\"",
  "        for (args) do { a ->",
  "            s := \"{s}\\n    {spc}{a.pretty(depth + 4)}\"",
  "        }",
  "        s",
  "    }",
  "    method shallowCopyWithParent(p) {",
  "        callWithPart.new(name).shallowCopyFieldsFrom(self) parent(p)",
  "    }",
  "    method shallowCopyFieldsFrom(other) parent(p) {",
  "        super.shallowCopyFieldsFrom(other) parent(p)",
  "        lineLength := other.lineLength",
  "        self",
  "    }",
  "}",
  "",
  "type ASTVisitor = {",
  "     visitIf(o) up(pNode) -> Boolean",
  "     visitBlock(o) up(pNode) -> Boolean",
  "     visitMatchCase(o) up(pNode) -> Boolean",
  "     visitCatchCase(o) up(pNode) -> Boolean",
  "     visitMethodType(o) up(pNode) -> Boolean",
  "     visitSignaturePart(o) up(pNode) -> Boolean",
  "     visitTypeLiteral(o) up(pNode) -> Boolean",
  "     visitTypeDec(o) up(pNode) -> Boolean",
  "     visitMethod(o) up(pNode) -> Boolean",
  "     visitCall(o) up(pNode) -> Boolean",
  "     visitClass(o) up(pNode) -> Boolean",
  "     visitObject(o) up(pNode) -> Boolean",
  "     visitArray(o) up(pNode) -> Boolean",
  "     visitMember(o) up(pNode) -> Boolean",
  "     visitGeneric(o) up(pNode) -> Boolean",
  "     visitIdentifier(o) up(pNode) -> Boolean",
  "     visitOctets(o) up(pNode) -> Boolean",
  "     visitString(o) up(pNode) -> Boolean",
  "     visitNum(o) up(pNode) -> Boolean",
  "     visitOp(o) up(pNode) -> Boolean",
  "     visitIndex(o) up(pNode) -> Boolean ",
  "     visitBind(o) up(pNode) -> Boolean",
  "     visitDefDec(o) up(pNode) -> Boolean",
  "     visitVarDec(o) up(pNode) -> Boolean",
  "     visitImport(o) up(pNode) -> Boolean",
  "     visitReturn(o) up(pNode) -> Boolean",
  "     visitInherits(o) up(pNode) -> Boolean",
  "     visitDialect(o) up(pNode) -> Boolean",
  "}",
  "factory method baseVisitor -> ASTVisitor {",
  "    method visitIf(o) up(pNode) { visitIf(o) }",
  "    method visitBlock(o) up(pNode) { visitBlock(o) }",
  "    method visitMatchCase(o) up(pNode) { visitMatchCase(o) }",
  "    method visitCatchCase(o) up(pNode) { visitCatchCase(o) }",
  "    method visitMethodType(o) up(pNode) { visitMethodType(o) }",
  "    method visitSignaturePart(o) up(pNode) { visitSignaturePart(o) }",
  "    method visitTypeDec(o) up(pNode) { visitTypeDec(o) }",
  "    method visitTypeLiteral(o) up(pNode) { visitTypeLiteral(o) }",
  "    method visitMethod(o) up(pNode) { visitMethod(o) }",
  "    method visitCall(o) up(pNode) { visitCall(o) }",
  "    method visitClass(o) up(pNode) { visitClass(o) }",
  "    method visitObject(o) up(pNode) { visitObject(o) }",
  "    method visitArray(o) up(pNode) { visitArray(o) }",
  "    method visitMember(o) up(pNode) { visitMember(o) }",
  "    method visitGeneric(o) up(pNode) { visitGeneric(o) }",
  "    method visitIdentifier(o) up(pNode) { visitIdentifier(o) }",
  "    method visitOctets(o) up(pNode) { visitOctets(o) }",
  "    method visitString(o) up(pNode) { visitString(o) }",
  "    method visitNum(o) up(pNode) { visitNum(o) }",
  "    method visitOp(o) up(pNode) { visitOp(o) }",
  "    method visitIndex(o) up(pNode) { visitIndex(o) }",
  "    method visitBind(o) up(pNode) { visitBind(o) }",
  "    method visitDefDec(o) up(pNode) { visitDefDec(o) }",
  "    method visitVarDec(o) up(pNode) { visitVarDec(o) }",
  "    method visitImport(o) up(pNode) { visitImport(o) }",
  "    method visitReturn(o) up(pNode) { visitReturn(o) }",
  "    method visitInherits(o) up(pNode) { visitInherits(o) }",
  "    method visitDialect(o) up(pNode) { visitDialect(o) }",
  "",
  "    method visitIf(o) -> Boolean { true }",
  "    method visitBlock(o) -> Boolean { true }",
  "    method visitMatchCase(o) -> Boolean { true }",
  "    method visitCatchCase(o) -> Boolean { true }",
  "    method visitMethodType(o) -> Boolean { true }",
  "    method visitSignaturePart(o) -> Boolean { true }",
  "    method visitTypeDec(o) -> Boolean { true }",
  "    method visitTypeLiteral(o) -> Boolean { true }",
  "    method visitMethod(o) -> Boolean { true }",
  "    method visitCall(o) -> Boolean { true }",
  "    method visitClass(o) -> Boolean { true }",
  "    method visitObject(o) -> Boolean { true }",
  "    method visitArray(o) -> Boolean { true }",
  "    method visitMember(o) -> Boolean { true }",
  "    method visitGeneric(o) -> Boolean { true }",
  "    method visitIdentifier(o) -> Boolean { true }",
  "    method visitOctets(o) -> Boolean { true }",
  "    method visitString(o) -> Boolean { true }",
  "    method visitNum(o) -> Boolean { true }",
  "    method visitOp(o) -> Boolean { true }",
  "    method visitIndex(o) -> Boolean { true }",
  "    method visitBind(o) -> Boolean { true }",
  "    method visitDefDec(o) -> Boolean { true }",
  "    method visitVarDec(o) -> Boolean { true }",
  "    method visitImport(o) -> Boolean { true }",
  "    method visitReturn(o) -> Boolean { true }",
  "    method visitInherits(o) -> Boolean { true }",
  "    method visitDialect(o) -> Boolean { true }",
  "}",
  "",
  "factory method addParentVisitor -> ASTVisitor {",
  "    method visitIdentifier(o) up(pNode) { o.parent := pNode; true }",
  "    method visitMethod(o) up(pNode) { o.parent := pNode; true }",
  "    method visitBlock(o) up(pNode) { o.parent := pNode; true }",
  "    method visitClass(o) up(pNode) { o.parent := pNode; true }",
  "    method visitObject(o) up(pNode) { o.parent := pNode; true }",
  "    method visitIf(o) up(pNode) { o.parent := pNode; true }",
  "    method visitMatchCase(o) up(pNode) { o.parent := pNode; true }",
  "    method visitCatchCase(o) up(pNode) { o.parent := pNode; true }",
  "    method visitMethodType(o) up(pNode) { o.parent := pNode; true }",
  "    method visitSignaturePart(o) up(pNode) { o.parent := pNode; true }",
  "    method visitTypeDec(o) up(pNode) { o.parent := pNode; true }",
  "    method visitTypeLiteral(o) up(pNode) { o.parent := pNode; true }",
  "    method visitCall(o) up(pNode) { o.parent := pNode; true }",
  "    method visitArray(o) up(pNode) { o.parent := pNode; true }",
  "    method visitMember(o) up(pNode) { o.parent := pNode; true }",
  "    method visitGeneric(o) up(pNode) { o.parent := pNode; true }",
  "    method visitOctets(o) up(pNode) { o.parent := pNode; true }",
  "    method visitString(o) up(pNode) { o.parent := pNode; true }",
  "    method visitNum(o) up(pNode) { o.parent := pNode; true }",
  "    method visitOp(o) up(pNode) { o.parent := pNode; true }",
  "    method visitIndex(o) up(pNode) { o.parent := pNode; true }",
  "    method visitBind(o) up(pNode) { o.parent := pNode; true }",
  "    method visitDefDec(o) up(pNode) { o.parent := pNode; true }",
  "    method visitVarDec(o) up(pNode) { o.parent := pNode; true }",
  "    method visitImport(o) up(pNode) { o.parent := pNode; true }",
  "    method visitReturn(o) up(pNode) { o.parent := pNode; true }",
  "    method visitInherits(o) up(pNode) { o.parent := pNode; true }",
  "    method visitDialect(o) up(pNode) { o.parent := pNode; true }",
  "}",
  "",
  "def patternMarkVisitor = object {",
  "    inherits baseVisitor",
  "    method visitCall(c) up(pNode) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\").andAlso {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  NULL
};
Object reader_ast_outer_47(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_191(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_329(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_330(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_349(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_349(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_parent_352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_parent_352(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_hasSymbolTable_353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_hasSymbolTable_353(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_542(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_545(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_symbolTable_39__546(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_symbolTable_39__546(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_outer_660(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_661(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_670(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_673(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_thenblock_676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_thenblock_676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elseblock_677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elseblock_677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_handledIdentifiers_678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_1032(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_1038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_1038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_1039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_1039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_selfclosure_1040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_1041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_1041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_1042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_1042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_1447(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1450(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1451(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1452(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1452(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_1453(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_1453(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_finally_1454(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_finally_1454(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_1744(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1747(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1748(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1749(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_1749(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_cases_1750(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_cases_1750(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_elsecase_1751(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_elsecase_1751(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_2043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2047(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_2048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_2049(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_2049(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_rtype_2050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_rtype_2050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_generics_2051(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_2051(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_2052(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_2530(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2533(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2534(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_methods_2535(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_methods_2535(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_types_2536(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_types_2536(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nominal_2537(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_nominal_2537(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_anonymous_2538(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_anonymous_2538(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_value_2539(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_value_2539(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_2881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2884(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2885(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_2886(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_2886(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_2887(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_2887(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_nameString_2888(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_annotations_2889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_annotations_2889(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_generics_2890(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_generics_2890(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_3260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3263(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3264(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3265(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_3265(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_signature_3266(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_signature_3266(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_body_3267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_body_3267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_3268(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_3268(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_varargs_3269(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_varargs_3269(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_3270(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_3270(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_selfclosure_3271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_selfclosure_3271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_nameString_3272(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_annotations_3273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_annotations_3273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_isFresh_3274(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_isFresh_3274(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_4248(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4252(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_4253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_with_4254(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_with_4254(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_4255(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_4255(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isPattern_4256(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isPattern_4256(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_nameString_4257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_outer_4740(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4743(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4744(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4745(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_4745(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_name_4746(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_name_4746(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_constructor_4747(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_constructor_4747(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_signature_4748(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_signature_4748(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_dtype_4749(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_dtype_4749(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_4750(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_4750(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_superclass_4751(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_superclass_4751(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_4752(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_annotations_4752(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_nameString_4753(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object reader_ast_data_4754(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_data_4754(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_5750(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5753(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5754(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5755(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5755(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_superclass_5756(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_superclass_5756(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_classname_5757(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_classname_5757(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_data_5758(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_data_5758(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_6041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6044(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6045(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6046(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6168(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6171(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6172(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6173(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6173(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_in_6174(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_in_6174(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_generics_6175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_6175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_6466(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6469(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6470(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6471(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6471(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_6472(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_6472(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_6671(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_6676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_6677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_6677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_6678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isBindingOccurrence_6679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isBindingOccurrence_6679(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_isAssigned_6680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_isAssigned_6680(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_inRequest_6681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_inRequest_6681(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_generics_6682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_generics_6682(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_isDeclaredByParent_6683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_isDeclaredByParent_6683(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_7045(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7049(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7202(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7205(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7206(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7207(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7207(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_7266(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7269(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7270(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7271(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_7272(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_left_7272(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_right_7273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_right_7273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_7531(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7534(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7535(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7536(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_7536(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_index_7537(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_index_7537(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7684(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7687(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7688(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_7689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_dest_7689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_7850(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7853(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7854(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_7856(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_7856(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_7857(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7857(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_7858(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_7859(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_7859(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_data_7860(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_data_7860(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_startToken_7861(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_startToken_7861(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_outer_8254(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8258(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_8259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_8259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_value_8260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_value_8260(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_8261(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_8261(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_nameString_8262(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_8263(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_annotations_8263(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_8691(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8694(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8695(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8696(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8696(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_path_8697(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_path_8697(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_annotations_8698(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_annotations_8698(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_dtype_8699(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_8699(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_8931(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_8934(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_8935(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_8936(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_8936(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9013(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9016(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9017(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9018(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9018(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_9096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9100(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_9101(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_providedNames_9102(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_providedNames_9102(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_9253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9256(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9257(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_9258(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_9280(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9283(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9284(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_9286(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_9286(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_vararg_9287(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_vararg_9287(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_generics_9288(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_9288(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_lineLength_9289(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_lineLength_9289(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_9551(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_9554(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_9555(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_9556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_9556(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_9557(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_9557(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_lineLength_9558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_lineLength_9558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_9712(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit17;
static Object strlit20;
static Object strlit24;
static Object strlit29;
static Object strlit33;
static ClassData objclass46;
static ClassData objclass190;
static Object strlit322;
static ClassData objclass328;
Object module_util;
Object module_util_init();
static ClassData objclass344;
static ClassData objclass347;
static Object strlit394;
static Object strlit400;
static Object strlit478;
static Object strlit485;
static Object strlit492;
static Object strlit498;
static Object strlit533;
static ClassData objclass541;
static ClassData objclass544;
static Object strlit554;
static Object strlit577;
static Object strlit586;
static Object strlit597;
static Object strlit607;
static Object strlit616;
static Object strlit623;
static Object strlit632;
static Object strlit637;
static Object strlit643;
static ClassData objclass659;
static Object strlit663;
static Object strlit666;
static ClassData objclass669;
static ClassData objclass672;
static Object strlit720;
static Object strlit729;
static Object strlit736;
static Object strlit757;
static Object strlit763;
static Object strlit770;
static Object strlit782;
static Object strlit793;
static Object strlit805;
static Object strlit815;
static Object strlit840;
static Object strlit849;
static Object strlit854;
static Object strlit879;
static Object strlit888;
static Object strlit901;
static Object strlit908;
static Object strlit917;
static Object strlit936;
static Object strlit941;
static Object strlit960;
static Object strlit965;
static Object strlit987;
static Object strlit992;
static Object strlit1002;
static Object strlit1007;
static Object strlit1027;
static ClassData objclass1031;
static ClassData objclass1034;
static Object strlit1044;
static Object strlit1147;
static Object strlit1156;
static Object strlit1163;
static Object strlit1169;
static Object strlit1192;
static Object strlit1201;
static Object strlit1206;
static Object strlit1229;
static Object strlit1245;
static Object strlit1250;
static Object strlit1270;
static Object strlit1277;
static Object strlit1290;
static Object strlit1296;
static Object strlit1307;
static Object strlit1329;
static Object strlit1337;
static Object strlit1359;
static Object strlit1364;
static Object strlit1384;
static Object strlit1389;
static Object strlit1399;
static Object strlit1404;
static Object strlit1432;
static Object strlit1433;
static ClassData objclass1446;
static ClassData objclass1449;
static Object strlit1513;
static Object strlit1522;
static Object strlit1529;
static Object strlit1535;
static Object strlit1560;
static Object strlit1571;
static Object strlit1576;
static Object strlit1580;
static Object strlit1601;
static Object strlit1614;
static Object strlit1619;
static Object strlit1623;
static Object strlit1634;
static Object strlit1647;
static Object strlit1654;
static Object strlit1663;
static Object strlit1680;
static Object strlit1683;
static Object strlit1688;
static Object strlit1716;
static Object strlit1719;
static Object strlit1724;
static Object strlit1740;
static ClassData objclass1743;
static ClassData objclass1746;
static Object strlit1816;
static Object strlit1825;
static Object strlit1832;
static Object strlit1859;
static Object strlit1870;
static Object strlit1875;
static Object strlit1879;
static Object strlit1900;
static Object strlit1913;
static Object strlit1918;
static Object strlit1922;
static Object strlit1933;
static Object strlit1946;
static Object strlit1953;
static Object strlit1962;
static Object strlit1979;
static Object strlit1982;
static Object strlit1987;
static Object strlit2015;
static Object strlit2018;
static Object strlit2023;
static Object strlit2039;
static ClassData objclass2042;
static ClassData objclass2045;
static Object strlit2055;
static Object strlit2062;
static Object strlit2068;
static Object strlit2091;
static Object strlit2179;
static Object strlit2188;
static Object strlit2195;
static Object strlit2201;
static Object strlit2208;
static Object strlit2213;
static Object strlit2217;
static Object strlit2233;
static Object strlit2246;
static Object strlit2251;
static Object strlit2256;
static Object strlit2260;
static Object strlit2278;
static Object strlit2283;
static Object strlit2287;
static Object strlit2299;
static Object strlit2310;
static Object strlit2315;
static Object strlit2319;
static Object strlit2330;
static Object strlit2335;
static Object strlit2339;
static Object strlit2351;
static Object strlit2362;
static Object strlit2367;
static Object strlit2371;
static Object strlit2382;
static Object strlit2413;
static Object strlit2455;
static Object strlit2475;
static Object strlit2481;
static Object strlit2505;
static Object strlit2520;
static ClassData objclass2529;
static ClassData objclass2532;
static Object strlit2551;
static Object strlit2558;
static Object strlit2564;
static Object strlit2618;
static Object strlit2627;
static Object strlit2634;
static Object strlit2640;
static Object strlit2644;
static Object strlit2667;
static Object strlit2676;
static Object strlit2681;
static Object strlit2703;
static Object strlit2712;
static Object strlit2717;
static Object strlit2730;
static Object strlit2736;
static Object strlit2747;
static Object strlit2776;
static Object strlit2783;
static Object strlit2788;
static Object strlit2806;
static Object strlit2811;
static Object strlit2834;
static Object strlit2839;
static Object strlit2849;
static Object strlit2874;
static Object strlit2877;
static ClassData objclass2880;
static ClassData objclass2883;
static Object strlit2892;
static Object strlit2905;
static Object strlit2952;
static Object strlit2960;
static Object strlit2966;
static Object strlit3006;
static Object strlit3015;
static Object strlit3022;
static Object strlit3028;
static Object strlit3056;
static Object strlit3061;
static Object strlit3065;
static Object strlit3077;
static Object strlit3082;
static Object strlit3087;
static Object strlit3091;
static Object strlit3102;
static Object strlit3122;
static Object strlit3127;
static Object strlit3140;
static Object strlit3146;
static Object strlit3148;
static Object strlit3154;
static Object strlit3168;
static Object strlit3197;
static Object strlit3204;
static Object strlit3219;
static Object strlit3226;
static Object strlit3232;
static Object strlit3244;
static ClassData objclass3259;
static ClassData objclass3262;
static Object strlit3276;
static Object strlit3289;
static Object strlit3489;
static Object strlit3498;
static Object strlit3505;
static Object strlit3521;
static Object strlit3530;
static Object strlit3542;
static Object strlit3547;
static Object strlit3557;
static Object strlit3576;
static Object strlit3584;
static Object strlit3589;
static Object strlit3593;
static Object strlit3605;
static Object strlit3612;
static Object strlit3617;
static Object strlit3621;
static Object strlit3630;
static Object strlit3635;
static Object strlit3639;
static Object strlit3651;
static Object strlit3662;
static Object strlit3667;
static Object strlit3671;
static Object strlit3689;
static Object strlit3702;
static Object strlit3707;
static Object strlit3711;
static Object strlit3722;
static Object strlit3734;
static Object strlit3739;
static Object strlit3743;
static Object strlit3755;
static Object strlit3763;
static Object strlit3768;
static Object strlit3772;
static Object strlit3783;
static Object strlit3797;
static Object strlit3802;
static Object strlit3806;
static Object strlit3818;
static Object strlit3829;
static Object strlit3834;
static Object strlit3838;
static Object strlit3849;
static Object strlit3854;
static Object strlit3877;
static Object strlit3886;
static Object strlit3899;
static Object strlit3905;
static Object strlit3933;
static Object strlit3969;
static Object strlit4007;
static Object strlit4049;
static Object strlit4069;
static Object strlit4075;
static Object strlit4090;
static Object strlit4099;
static Object strlit4115;
static Object strlit4121;
static Object strlit4131;
static Object strlit4135;
static Object strlit4138;
static Object strlit4148;
static Object strlit4166;
static Object strlit4171;
static Object strlit4181;
static Object strlit4186;
static Object strlit4194;
static Object strlit4200;
static Object strlit4229;
static ClassData objclass4247;
static ClassData objclass4250;
static Object strlit4268;
static Object strlit4345;
static Object strlit4354;
static Object strlit4361;
static Object strlit4368;
static Object strlit4380;
static Object strlit4390;
static Object strlit4402;
static Object strlit4415;
static Object strlit4426;
static Object strlit4438;
static Object strlit4455;
static Object strlit4460;
static Object strlit4483;
static Object strlit4494;
static Object strlit4507;
static Object strlit4513;
static Object strlit4516;
static Object strlit4527;
static Object strlit4555;
static Object strlit4589;
static Object strlit4625;
static Object strlit4654;
static Object strlit4687;
static Object strlit4694;
static Object strlit4702;
static Object strlit4709;
static Object strlit4730;
static ClassData objclass4739;
static ClassData objclass4742;
static Object strlit4757;
static Object strlit4766;
static Object strlit4772;
static Object strlit4778;
static Object strlit4796;
static Object strlit4968;
static Object strlit4977;
static Object strlit4984;
static Object strlit4990;
static Object strlit5000;
static Object strlit5005;
static Object strlit5009;
static Object strlit5019;
static Object strlit5026;
static Object strlit5037;
static Object strlit5048;
static Object strlit5052;
static Object strlit5064;
static Object strlit5077;
static Object strlit5090;
static Object strlit5094;
static Object strlit5112;
static Object strlit5117;
static Object strlit5136;
static Object strlit5143;
static Object strlit5148;
static Object strlit5158;
static Object strlit5163;
static Object strlit5167;
static Object strlit5183;
static Object strlit5196;
static Object strlit5201;
static Object strlit5206;
static Object strlit5210;
static Object strlit5221;
static Object strlit5226;
static Object strlit5230;
static Object strlit5242;
static Object strlit5249;
static Object strlit5254;
static Object strlit5258;
static Object strlit5267;
static Object strlit5272;
static Object strlit5276;
static Object strlit5288;
static Object strlit5299;
static Object strlit5304;
static Object strlit5308;
static Object strlit5326;
static Object strlit5339;
static Object strlit5344;
static Object strlit5348;
static Object strlit5366;
static Object strlit5371;
static Object strlit5384;
static Object strlit5392;
static Object strlit5396;
static Object strlit5416;
static Object strlit5421;
static Object strlit5434;
static Object strlit5444;
static Object strlit5453;
static Object strlit5458;
static Object strlit5480;
static Object strlit5489;
static Object strlit5502;
static Object strlit5509;
static Object strlit5518;
static Object strlit5523;
static Object strlit5531;
static Object strlit5565;
static Object strlit5607;
static Object strlit5627;
static Object strlit5633;
static Object strlit5647;
static Object strlit5660;
static Object strlit5664;
static Object strlit5671;
static Object strlit5689;
static Object strlit5694;
static Object strlit5704;
static Object strlit5709;
static Object strlit5733;
static ClassData objclass5749;
static ClassData objclass5752;
static Object strlit5762;
static Object strlit5771;
static Object strlit5839;
static Object strlit5848;
static Object strlit5864;
static Object strlit5869;
static Object strlit5888;
static Object strlit5895;
static Object strlit5900;
static Object strlit5927;
static Object strlit5936;
static Object strlit5949;
static Object strlit5955;
static Object strlit5970;
static Object strlit5975;
static Object strlit5985;
static Object strlit5990;
static Object strlit6015;
static Object strlit6022;
static Object strlit6028;
static Object strlit6035;
static Object strlit6036;
static ClassData objclass6040;
static ClassData objclass6043;
static Object strlit6077;
static Object strlit6086;
static Object strlit6110;
static Object strlit6119;
static Object strlit6146;
static Object strlit6153;
static Object strlit6164;
static ClassData objclass6167;
static ClassData objclass6170;
static Object strlit6222;
static Object strlit6231;
static Object strlit6238;
static Object strlit6245;
static Object strlit6251;
static Object strlit6275;
static Object strlit6280;
static Object strlit6297;
static Object strlit6302;
static Object strlit6312;
static Object strlit6315;
static Object strlit6342;
static Object strlit6352;
static Object strlit6369;
static Object strlit6405;
static Object strlit6424;
static Object strlit6430;
static Object strlit6461;
static ClassData objclass6465;
static ClassData objclass6468;
static Object strlit6480;
static Object strlit6484;
static Object strlit6491;
static Object strlit6496;
static Object strlit6500;
static Object strlit6510;
static Object strlit6519;
static Object strlit6563;
static Object strlit6569;
static Object strlit6601;
static Object strlit6608;
static Object strlit6614;
static Object strlit6647;
static Object strlit6654;
static Object strlit6667;
static ClassData objclass6670;
static ClassData objclass6673;
static Object strlit6746;
static Object strlit6755;
static Object strlit6767;
static Object strlit6776;
static Object strlit6782;
static Object strlit6790;
static Object strlit6796;
static Object strlit6810;
static Object strlit6815;
static Object strlit6841;
static Object strlit6846;
static Object strlit6866;
static Object strlit6880;
static Object strlit6903;
static Object strlit6916;
static Object strlit6952;
static Object strlit6974;
static Object strlit6980;
static Object strlit6984;
static Object strlit6990;
static Object strlit7026;
static Object strlit7035;
static Object strlit7040;
static ClassData objclass7044;
static ClassData objclass7047;
static Object strlit7056;
static Object strlit7063;
static Object strlit7069;
static Object strlit7092;
static ClassData objclass7095;
static ClassData objclass7098;
static Object strlit7113;
static Object strlit7120;
static Object strlit7126;
static Object strlit7132;
static Object strlit7140;
static Object strlit7144;
static Object strlit7150;
static Object strlit7154;
static Object strlit7160;
static Object strlit7164;
static Object strlit7170;
static Object strlit7174;
static Object strlit7185;
static Object strlit7198;
static ClassData objclass7201;
static ClassData objclass7204;
static Object strlit7219;
static Object strlit7226;
static Object strlit7232;
static Object strlit7244;
static Object strlit7250;
static Object strlit7262;
static ClassData objclass7265;
static ClassData objclass7268;
static Object strlit7308;
static Object strlit7317;
static Object strlit7324;
static Object strlit7331;
static Object strlit7337;
static Object strlit7343;
static Object strlit7363;
static Object strlit7383;
static Object strlit7397;
static Object strlit7406;
static Object strlit7415;
static Object strlit7427;
static Object strlit7439;
static Object strlit7446;
static Object strlit7465;
static Object strlit7474;
static Object strlit7484;
static Object strlit7527;
static ClassData objclass7530;
static ClassData objclass7533;
static Object strlit7569;
static Object strlit7578;
static Object strlit7585;
static Object strlit7606;
static Object strlit7626;
static Object strlit7639;
static Object strlit7654;
static Object strlit7667;
static Object strlit7680;
static ClassData objclass7683;
static ClassData objclass7686;
static Object strlit7695;
static Object strlit7701;
static Object strlit7735;
static Object strlit7744;
static Object strlit7751;
static Object strlit7772;
static Object strlit7792;
static Object strlit7805;
static Object strlit7830;
static Object strlit7846;
static ClassData objclass7849;
static ClassData objclass7852;
static Object strlit7875;
static Object strlit7883;
static Object strlit7891;
static Object strlit7896;
static Object strlit7906;
static Object strlit7916;
static Object strlit8008;
static Object strlit8017;
static Object strlit8024;
static Object strlit8058;
static Object strlit8063;
static Object strlit8088;
static Object strlit8093;
static Object strlit8101;
static Object strlit8114;
static Object strlit8121;
static Object strlit8130;
static Object strlit8135;
static Object strlit8150;
static Object strlit8165;
static Object strlit8171;
static Object strlit8181;
static Object strlit8185;
static Object strlit8188;
static Object strlit8211;
static Object strlit8240;
static ClassData objclass8253;
static ClassData objclass8256;
static Object strlit8277;
static Object strlit8285;
static Object strlit8304;
static Object strlit8313;
static Object strlit8334;
static Object strlit8343;
static Object strlit8354;
static Object strlit8364;
static Object strlit8452;
static Object strlit8461;
static Object strlit8468;
static Object strlit8496;
static Object strlit8501;
static Object strlit8527;
static Object strlit8532;
static Object strlit8551;
static Object strlit8564;
static Object strlit8571;
static Object strlit8580;
static Object strlit8585;
static Object strlit8600;
static Object strlit8615;
static Object strlit8621;
static Object strlit8631;
static Object strlit8635;
static Object strlit8638;
static Object strlit8661;
static Object strlit8679;
static ClassData objclass8690;
static ClassData objclass8693;
static Object strlit8721;
static Object strlit8729;
static Object strlit8741;
static Object strlit8800;
static Object strlit8809;
static Object strlit8816;
static Object strlit8823;
static Object strlit8830;
static Object strlit8834;
static Object strlit8844;
static Object strlit8851;
static Object strlit8855;
static Object strlit8874;
static Object strlit8881;
static Object strlit8885;
static Object strlit8895;
static Object strlit8902;
static Object strlit8908;
static Object strlit8923;
static ClassData objclass8930;
static ClassData objclass8933;
static Object strlit8947;
static Object strlit8956;
static Object strlit8963;
static Object strlit8970;
static Object strlit8977;
static Object strlit8981;
static Object strlit8991;
static Object strlit8997;
static Object strlit9009;
static ClassData objclass9012;
static ClassData objclass9015;
static Object strlit9040;
static Object strlit9049;
static Object strlit9056;
static Object strlit9083;
static Object strlit9092;
static ClassData objclass9095;
static ClassData objclass9098;
static Object strlit9136;
static Object strlit9145;
static Object strlit9152;
static Object strlit9181;
static Object strlit9188;
static Object strlit9192;
static Object strlit9202;
static Object strlit9211;
static Object strlit9222;
static Object strlit9228;
static Object strlit9245;
static ClassData objclass9252;
static ClassData objclass9255;
static Object strlit9267;
static Object strlit9275;
static Object strlit9276;
static ClassData objclass9279;
static ClassData objclass9282;
static Object strlit9324;
static Object strlit9352;
static Object strlit9361;
static Object strlit9368;
static Object strlit9375;
static Object strlit9381;
static Object strlit9387;
static Object strlit9392;
static Object strlit9396;
static Object strlit9408;
static Object strlit9419;
static Object strlit9424;
static Object strlit9428;
static Object strlit9446;
static Object strlit9459;
static Object strlit9464;
static Object strlit9468;
static Object strlit9492;
static Object strlit9498;
static Object strlit9503;
static Object strlit9504;
static ClassData objclass9550;
static ClassData objclass9553;
static Object strlit9576;
static Object strlit9585;
static Object strlit9592;
static Object strlit9599;
static Object strlit9605;
static Object strlit9611;
static Object strlit9616;
static Object strlit9620;
static Object strlit9632;
static Object strlit9643;
static Object strlit9648;
static Object strlit9652;
static Object strlit9678;
static Object strlit9679;
static ClassData objclass9711;
Object meth_ast__apply7(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_p = getfromclosure(closure, 1);
  Object *var_newList = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_nd = &(stackframe->slots[0]);
  *var_nd = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe8 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe9 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nd (depth = 6)
  params[0] = *var_b;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10 = callmethod(*var_nd, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe9);
// compiled call node returning call10 (depth = 5)
  gc_frame_newslot(call10);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newList (depth = 5)
  params[0] = call10;
  partcv[0] = 1;
  Object call11 = callmethod(*var_newList, "addLast",
    1, partcv, params);
  gc_frame_end(callframe8);
// compiled call node returning call11 (depth = 4)
  gc_frame_end(frame);
  return call11;
}
Object meth_ast_listMap_40__41_parent0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "listMap()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method listMap()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method listMap()parent");
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for listMap()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for listMap");
  Object *var_p = &(stackframe->slots[2]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newList = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newList");
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2);
// compiled call node returning call3 (depth = 6)
// compiled member node returning call3 (depth = 5)
  partcv[0] = 0;
  Object call4 = callmethod(call3, "empty",
    1, partcv, params);
  gc_frame_end(callframe1);
// compiled call node returning call4 (depth = 4)
// compiled member node returning call4 (depth = 3)
  *var_newList = call4;
  if (call4 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block6 = alloc_Block(NULL, NULL, "ast", 23);
  gc_frame_newslot(block6);
// method _apply
  block_savedest(block6);
  Object closure7 = createclosure(4, "_apply");
  setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_b);
  addtoclosure(closure7, var_p);
  addtoclosure(closure7, var_newList);
  addtoclosure(closure7, selfslot);
  struct UserObject *uo7 = (struct UserObject*)block6;
  uo7->data[0] = (Object)closure7;
  Method *meth_meth_ast__apply7 = addmethod2pos(block6, "_apply", &meth_ast__apply7, 0);
  int argcv_meth_ast__apply7[] = {1};
  meth_meth_ast__apply7->type = alloc_MethodType(1, argcv_meth_ast__apply7);
  meth_meth_ast__apply7->definitionModule = modulename;
  meth_meth_ast__apply7->definitionLine = 22;
// compiled block node returning block6 (depth = 3)
  gc_frame_newslot(block6);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block6;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call13 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5);
// compiled call node returning call13 (depth = 2)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe15 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  gc_frame_newslot(*var_done);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newList (depth = 4)
  params[0] = *var_done;
  partcv[0] = 1;
  Object call16 = callmethod(*var_newList, "contains",
    1, partcv, params);
  gc_frame_end(callframe15);
// compiled call node returning call16 (depth = 3)
  Object if14 = done;
  if (istrue(call16)) {
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit17 == NULL) {
    strlit17 = alloc_String("node list contains done!");
    gc_root(strlit17);
  }
// compiled string node returning strlit17 (depth = 4)
  params[0] = strlit17;
  Object call18 = gracelib_print(NULL, 1,  params);
// compiled call node returning call18 (depth = 3)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit20 == NULL) {
    strlit20 = alloc_String("");
    gc_root(strlit20);
  }
// compiled string node returning strlit20 (depth = 5)
  int op_slot_right_19 = gc_frame_newslot(strlit20);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  int op_slot_right_22 = gc_frame_newslot(*var_l);
// starting to compile string node (depth = 6)
  if (strlit24 == NULL) {
    strlit24 = alloc_String("    original list = ");
    gc_root(strlit24);
  }
// compiled string node returning strlit24 (depth = 6)
  int op_slot_left_22 = gc_frame_newslot(strlit24);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult25 = callmethod(strlit24, "++", 1, partcv, params);
// compiled op node returning opresult25 (depth = 5)
  int op_slot_left_19 = gc_frame_newslot(opresult25);
  params[0] = strlit20;
  partcv[0] = 1;
  Object opresult26 = callmethod(opresult25, "++", 1, partcv, params);
// compiled op node returning opresult26 (depth = 4)
  params[0] = opresult26;
  Object call27 = gracelib_print(NULL, 1,  params);
// compiled call node returning call27 (depth = 3)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit29 == NULL) {
    strlit29 = alloc_String("");
    gc_root(strlit29);
  }
// compiled string node returning strlit29 (depth = 5)
  int op_slot_right_28 = gc_frame_newslot(strlit29);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newList (depth = 6)
  int op_slot_right_31 = gc_frame_newslot(*var_newList);
// starting to compile string node (depth = 6)
  if (strlit33 == NULL) {
    strlit33 = alloc_String("    mapped list = ");
    gc_root(strlit33);
  }
// compiled string node returning strlit33 (depth = 6)
  int op_slot_left_31 = gc_frame_newslot(strlit33);
  params[0] = *var_newList;
  partcv[0] = 1;
  Object opresult34 = callmethod(strlit33, "++", 1, partcv, params);
// compiled op node returning opresult34 (depth = 5)
  int op_slot_left_28 = gc_frame_newslot(opresult34);
  params[0] = strlit29;
  partcv[0] = 1;
  Object opresult35 = callmethod(opresult34, "++", 1, partcv, params);
// compiled op node returning opresult35 (depth = 4)
  params[0] = opresult35;
  Object call36 = gracelib_print(NULL, 1,  params);
// compiled call node returning call36 (depth = 3)
    gc_frame_newslot(call36);
    if14 = call36;
  } else {
  }
// compiled if node returning if14 (depth = 2)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newList (depth = 2)
  gc_frame_end(frame);
  return *var_newList;
}
Object meth_ast_maybeMap_40__41_parent37(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method maybeMap()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method maybeMap()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for maybeMap()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for maybeMap");
  Object *var_p = &(stackframe->slots[2]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool40 = alloc_Boolean(0);
// compiled identifier node returning bool40 (depth = 4)
  int op_slot_right_39 = gc_frame_newslot(bool40);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_39 = gc_frame_newslot(*var_n);
  params[0] = bool40;
  partcv[0] = 1;
  Object opresult42 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult42 (depth = 3)
  Object if38 = done;
  if (istrue(opresult42)) {
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe43 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_p (depth = 4)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  params[0] = *var_b;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call44 = callmethod(*var_n, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe43);
// compiled call node returning call44 (depth = 3)
    gc_frame_newslot(call44);
    if38 = call44;
  } else {
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
    gc_frame_newslot(*var_n);
    if38 = *var_n;
  }
// compiled if node returning if38 (depth = 2)
  gc_frame_end(frame);
  return if38;
}
Object meth_ast_visitIf_40__41_up48(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIf");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe49 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call50 = callmethodflags(self, "visitIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe49);
// compiled call node returning call50 (depth = 2)
  gc_frame_end(frame);
  return call50;
}
Object meth_ast_visitBlock_40__41_up51(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlock");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe52 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call53 = callmethodflags(self, "visitBlock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe52);
// compiled call node returning call53 (depth = 2)
  gc_frame_end(frame);
  return call53;
}
Object meth_ast_visitMatchCase_40__41_up54(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMatchCase");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe55 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call56 = callmethodflags(self, "visitMatchCase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe55);
// compiled call node returning call56 (depth = 2)
  gc_frame_end(frame);
  return call56;
}
Object meth_ast_visitCatchCase_40__41_up57(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCatchCase");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe58 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call59 = callmethodflags(self, "visitCatchCase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe58);
// compiled call node returning call59 (depth = 2)
  gc_frame_end(frame);
  return call59;
}
Object meth_ast_visitMethodType_40__41_up60(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethodType");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe61 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call62 = callmethodflags(self, "visitMethodType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe61);
// compiled call node returning call62 (depth = 2)
  gc_frame_end(frame);
  return call62;
}
Object meth_ast_visitSignaturePart_40__41_up63(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitSignaturePart");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe64 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call65 = callmethodflags(self, "visitSignaturePart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe64);
// compiled call node returning call65 (depth = 2)
  gc_frame_end(frame);
  return call65;
}
Object meth_ast_visitTypeDec_40__41_up66(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeDec");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe67 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call68 = callmethodflags(self, "visitTypeDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe67);
// compiled call node returning call68 (depth = 2)
  gc_frame_end(frame);
  return call68;
}
Object meth_ast_visitTypeLiteral_40__41_up69(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeLiteral");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe70 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call71 = callmethodflags(self, "visitTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe70);
// compiled call node returning call71 (depth = 2)
  gc_frame_end(frame);
  return call71;
}
Object meth_ast_visitMethod_40__41_up72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethod");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe73 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call74 = callmethodflags(self, "visitMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe73);
// compiled call node returning call74 (depth = 2)
  gc_frame_end(frame);
  return call74;
}
Object meth_ast_visitCall_40__41_up75(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe76 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call77 = callmethodflags(self, "visitCall", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe76);
// compiled call node returning call77 (depth = 2)
  gc_frame_end(frame);
  return call77;
}
Object meth_ast_visitClass_40__41_up78(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitClass()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitClass");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe79 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call80 = callmethodflags(self, "visitClass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe79);
// compiled call node returning call80 (depth = 2)
  gc_frame_end(frame);
  return call80;
}
Object meth_ast_visitObject_40__41_up81(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitObject");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe82 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call83 = callmethodflags(self, "visitObject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe82);
// compiled call node returning call83 (depth = 2)
  gc_frame_end(frame);
  return call83;
}
Object meth_ast_visitArray_40__41_up84(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitArray");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe85 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call86 = callmethodflags(self, "visitArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe85);
// compiled call node returning call86 (depth = 2)
  gc_frame_end(frame);
  return call86;
}
Object meth_ast_visitMember_40__41_up87(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMember");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe88 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call89 = callmethodflags(self, "visitMember", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe88);
// compiled call node returning call89 (depth = 2)
  gc_frame_end(frame);
  return call89;
}
Object meth_ast_visitGeneric_40__41_up90(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitGeneric");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe91 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call92 = callmethodflags(self, "visitGeneric", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe91);
// compiled call node returning call92 (depth = 2)
  gc_frame_end(frame);
  return call92;
}
Object meth_ast_visitIdentifier_40__41_up93(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIdentifier");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe94 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call95 = callmethodflags(self, "visitIdentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe94);
// compiled call node returning call95 (depth = 2)
  gc_frame_end(frame);
  return call95;
}
Object meth_ast_visitOctets_40__41_up96(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOctets()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOctets()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitOctets()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitOctets()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOctets");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe97 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call98 = callmethodflags(self, "visitOctets", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe97);
// compiled call node returning call98 (depth = 2)
  gc_frame_end(frame);
  return call98;
}
Object meth_ast_visitString_40__41_up99(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitString()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitString");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe100 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call101 = callmethodflags(self, "visitString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call101 (depth = 2)
  gc_frame_end(frame);
  return call101;
}
Object meth_ast_visitNum_40__41_up102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitNum");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe103 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call104 = callmethodflags(self, "visitNum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe103);
// compiled call node returning call104 (depth = 2)
  gc_frame_end(frame);
  return call104;
}
Object meth_ast_visitOp_40__41_up105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOp");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe106 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call107 = callmethodflags(self, "visitOp", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe106);
// compiled call node returning call107 (depth = 2)
  gc_frame_end(frame);
  return call107;
}
Object meth_ast_visitIndex_40__41_up108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIndex()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIndex");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe109 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call110 = callmethodflags(self, "visitIndex", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe109);
// compiled call node returning call110 (depth = 2)
  gc_frame_end(frame);
  return call110;
}
Object meth_ast_visitBind_40__41_up111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBind");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe112 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call113 = callmethodflags(self, "visitBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe112);
// compiled call node returning call113 (depth = 2)
  gc_frame_end(frame);
  return call113;
}
Object meth_ast_visitDefDec_40__41_up114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDefDec");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe115 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call116 = callmethodflags(self, "visitDefDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe115);
// compiled call node returning call116 (depth = 2)
  gc_frame_end(frame);
  return call116;
}
Object meth_ast_visitVarDec_40__41_up117(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitVarDec");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe118 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call119 = callmethodflags(self, "visitVarDec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe118);
// compiled call node returning call119 (depth = 2)
  gc_frame_end(frame);
  return call119;
}
Object meth_ast_visitImport_40__41_up120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe121 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call122 = callmethodflags(self, "visitImport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe121);
// compiled call node returning call122 (depth = 2)
  gc_frame_end(frame);
  return call122;
}
Object meth_ast_visitReturn_40__41_up123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitReturn");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe124 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call125 = callmethodflags(self, "visitReturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe124);
// compiled call node returning call125 (depth = 2)
  gc_frame_end(frame);
  return call125;
}
Object meth_ast_visitInherits_40__41_up126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitInherits");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call128 = callmethodflags(self, "visitInherits", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe127);
// compiled call node returning call128 (depth = 2)
  gc_frame_end(frame);
  return call128;
}
Object meth_ast_visitDialect_40__41_up129(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDialect");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe130 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call131 = callmethodflags(self, "visitDialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe130);
// compiled call node returning call131 (depth = 2)
  gc_frame_end(frame);
  return call131;
}
Object meth_ast_visitIf132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIf");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool133 = alloc_Boolean(1);
// compiled identifier node returning bool133 (depth = 2)
  gc_frame_end(frame);
  return bool133;
}
Object meth_ast_visitBlock134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlock");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBlock (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlock");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(1);
// compiled identifier node returning bool135 (depth = 2)
  gc_frame_end(frame);
  return bool135;
}
Object meth_ast_visitMatchCase136(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMatchCase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool137 = alloc_Boolean(1);
// compiled identifier node returning bool137 (depth = 2)
  gc_frame_end(frame);
  return bool137;
}
Object meth_ast_visitCatchCase138(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCatchCase");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool139 = alloc_Boolean(1);
// compiled identifier node returning bool139 (depth = 2)
  gc_frame_end(frame);
  return bool139;
}
Object meth_ast_visitMethodType140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethodType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethodType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethodType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool141 = alloc_Boolean(1);
// compiled identifier node returning bool141 (depth = 2)
  gc_frame_end(frame);
  return bool141;
}
Object meth_ast_visitSignaturePart142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitSignaturePart");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitSignaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitSignaturePart");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool143 = alloc_Boolean(1);
// compiled identifier node returning bool143 (depth = 2)
  gc_frame_end(frame);
  return bool143;
}
Object meth_ast_visitTypeDec144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitTypeDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool145 = alloc_Boolean(1);
// compiled identifier node returning bool145 (depth = 2)
  gc_frame_end(frame);
  return bool145;
}
Object meth_ast_visitTypeLiteral146(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeLiteral");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool147 = alloc_Boolean(1);
// compiled identifier node returning bool147 (depth = 2)
  gc_frame_end(frame);
  return bool147;
}
Object meth_ast_visitMethod148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethod");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethod (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethod");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool149 = alloc_Boolean(1);
// compiled identifier node returning bool149 (depth = 2)
  gc_frame_end(frame);
  return bool149;
}
Object meth_ast_visitCall150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool151 = alloc_Boolean(1);
// compiled identifier node returning bool151 (depth = 2)
  gc_frame_end(frame);
  return bool151;
}
Object meth_ast_visitClass152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitClass");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitClass (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitClass");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool153 = alloc_Boolean(1);
// compiled identifier node returning bool153 (depth = 2)
  gc_frame_end(frame);
  return bool153;
}
Object meth_ast_visitObject154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitObject");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitObject (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitObject");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool155 = alloc_Boolean(1);
// compiled identifier node returning bool155 (depth = 2)
  gc_frame_end(frame);
  return bool155;
}
Object meth_ast_visitArray156(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitArray");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitArray");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool157 = alloc_Boolean(1);
// compiled identifier node returning bool157 (depth = 2)
  gc_frame_end(frame);
  return bool157;
}
Object meth_ast_visitMember158(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMember");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMember (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMember");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool159 = alloc_Boolean(1);
// compiled identifier node returning bool159 (depth = 2)
  gc_frame_end(frame);
  return bool159;
}
Object meth_ast_visitGeneric160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitGeneric");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitGeneric (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitGeneric");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool161 = alloc_Boolean(1);
// compiled identifier node returning bool161 (depth = 2)
  gc_frame_end(frame);
  return bool161;
}
Object meth_ast_visitIdentifier162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIdentifier");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIdentifier");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool163 = alloc_Boolean(1);
// compiled identifier node returning bool163 (depth = 2)
  gc_frame_end(frame);
  return bool163;
}
Object meth_ast_visitOctets164(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOctets");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOctets (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOctets");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool165 = alloc_Boolean(1);
// compiled identifier node returning bool165 (depth = 2)
  gc_frame_end(frame);
  return bool165;
}
Object meth_ast_visitString166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitString");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool167 = alloc_Boolean(1);
// compiled identifier node returning bool167 (depth = 2)
  gc_frame_end(frame);
  return bool167;
}
Object meth_ast_visitNum168(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitNum");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitNum (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitNum");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool169 = alloc_Boolean(1);
// compiled identifier node returning bool169 (depth = 2)
  gc_frame_end(frame);
  return bool169;
}
Object meth_ast_visitOp170(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOp");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool171 = alloc_Boolean(1);
// compiled identifier node returning bool171 (depth = 2)
  gc_frame_end(frame);
  return bool171;
}
Object meth_ast_visitIndex172(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIndex");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIndex (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIndex");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool173 = alloc_Boolean(1);
// compiled identifier node returning bool173 (depth = 2)
  gc_frame_end(frame);
  return bool173;
}
Object meth_ast_visitBind174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBind");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBind (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBind");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool175 = alloc_Boolean(1);
// compiled identifier node returning bool175 (depth = 2)
  gc_frame_end(frame);
  return bool175;
}
Object meth_ast_visitDefDec176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDefDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDefDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDefDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool177 = alloc_Boolean(1);
// compiled identifier node returning bool177 (depth = 2)
  gc_frame_end(frame);
  return bool177;
}
Object meth_ast_visitVarDec178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitVarDec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitVarDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitVarDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool179 = alloc_Boolean(1);
// compiled identifier node returning bool179 (depth = 2)
  gc_frame_end(frame);
  return bool179;
}
Object meth_ast_visitImport180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool181 = alloc_Boolean(1);
// compiled identifier node returning bool181 (depth = 2)
  gc_frame_end(frame);
  return bool181;
}
Object meth_ast_visitReturn182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitReturn");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitReturn (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitReturn");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool183 = alloc_Boolean(1);
// compiled identifier node returning bool183 (depth = 2)
  gc_frame_end(frame);
  return bool183;
}
Object meth_ast_visitInherits184(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitInherits");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitInherits (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitInherits");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool185 = alloc_Boolean(1);
// compiled identifier node returning bool185 (depth = 2)
  gc_frame_end(frame);
  return bool185;
}
Object meth_ast_visitDialect186(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDialect");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDialect (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDialect");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool187 = alloc_Boolean(1);
// compiled identifier node returning bool187 (depth = 2)
  gc_frame_end(frame);
  return bool187;
}
Object meth_ast_baseVisitor45(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject46 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj46 = alloc_userobj2(56,57, objclass46);
  gc_frame_newslot(obj46);
if (objclass46 == NULL) {
  glfree(obj46->class->name);
  obj46->class->name = "self.baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj46, self, 0);
  addmethodreal(obj46,"outer", &reader_ast_outer_47);
  Object oldself46 = self;
  struct StackFrameObject *oldstackframe46 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe46);
  gc_frame_newslot((Object)stackframe);
  self = obj46;
  Object *oldselfslot46 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter46 = (*(struct UserObject *)self).data[0], lowerouter46 = thisouter46;
  if (inheritingObject46) {
    struct UserObject *inho46 = (struct UserObject *)inheritingObject46;
    while (inho46->super != GraceDefaultObject) inho46 = (struct UserObject *)inho46->super;
    inho46->super = obj46;
    self = inheritingObject46;
    *selfslot = self;
    lowerouter46 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter46;
  }
// method visitIf()up
  struct UserObject *uo48 = (struct UserObject*)obj46;
  uo48->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up48 = addmethod2pos(obj46, "visitIf()up", &meth_ast_visitIf_40__41_up48, 1);
  int argcv_meth_ast_visitIf_40__41_up48[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up48->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up48);
  meth_meth_ast_visitIf_40__41_up48->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up48->definitionLine = 2362;
// method visitBlock()up
  struct UserObject *uo51 = (struct UserObject*)obj46;
  uo51->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up51 = addmethod2pos(obj46, "visitBlock()up", &meth_ast_visitBlock_40__41_up51, 2);
  int argcv_meth_ast_visitBlock_40__41_up51[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up51->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up51);
  meth_meth_ast_visitBlock_40__41_up51->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up51->definitionLine = 2363;
// method visitMatchCase()up
  struct UserObject *uo54 = (struct UserObject*)obj46;
  uo54->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up54 = addmethod2pos(obj46, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up54, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up54[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up54->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up54);
  meth_meth_ast_visitMatchCase_40__41_up54->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up54->definitionLine = 2364;
// method visitCatchCase()up
  struct UserObject *uo57 = (struct UserObject*)obj46;
  uo57->data[4] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase_40__41_up57 = addmethod2pos(obj46, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up57, 4);
  int argcv_meth_ast_visitCatchCase_40__41_up57[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up57->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up57);
  meth_meth_ast_visitCatchCase_40__41_up57->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up57->definitionLine = 2365;
// method visitMethodType()up
  struct UserObject *uo60 = (struct UserObject*)obj46;
  uo60->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up60 = addmethod2pos(obj46, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up60, 5);
  int argcv_meth_ast_visitMethodType_40__41_up60[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up60->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up60);
  meth_meth_ast_visitMethodType_40__41_up60->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up60->definitionLine = 2366;
// method visitSignaturePart()up
  struct UserObject *uo63 = (struct UserObject*)obj46;
  uo63->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up63 = addmethod2pos(obj46, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up63, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up63[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up63->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up63);
  meth_meth_ast_visitSignaturePart_40__41_up63->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up63->definitionLine = 2367;
// method visitTypeDec()up
  struct UserObject *uo66 = (struct UserObject*)obj46;
  uo66->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up66 = addmethod2pos(obj46, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up66, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up66[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up66->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up66);
  meth_meth_ast_visitTypeDec_40__41_up66->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up66->definitionLine = 2368;
// method visitTypeLiteral()up
  struct UserObject *uo69 = (struct UserObject*)obj46;
  uo69->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up69 = addmethod2pos(obj46, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up69, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up69[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up69->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up69);
  meth_meth_ast_visitTypeLiteral_40__41_up69->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up69->definitionLine = 2369;
// method visitMethod()up
  struct UserObject *uo72 = (struct UserObject*)obj46;
  uo72->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up72 = addmethod2pos(obj46, "visitMethod()up", &meth_ast_visitMethod_40__41_up72, 9);
  int argcv_meth_ast_visitMethod_40__41_up72[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up72->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up72);
  meth_meth_ast_visitMethod_40__41_up72->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up72->definitionLine = 2370;
// method visitCall()up
  struct UserObject *uo75 = (struct UserObject*)obj46;
  uo75->data[10] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up75 = addmethod2pos(obj46, "visitCall()up", &meth_ast_visitCall_40__41_up75, 10);
  int argcv_meth_ast_visitCall_40__41_up75[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up75->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up75);
  meth_meth_ast_visitCall_40__41_up75->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up75->definitionLine = 2371;
// method visitClass()up
  struct UserObject *uo78 = (struct UserObject*)obj46;
  uo78->data[11] = emptyclosure;
  Method *meth_meth_ast_visitClass_40__41_up78 = addmethod2pos(obj46, "visitClass()up", &meth_ast_visitClass_40__41_up78, 11);
  int argcv_meth_ast_visitClass_40__41_up78[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up78->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up78);
  meth_meth_ast_visitClass_40__41_up78->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up78->definitionLine = 2372;
// method visitObject()up
  struct UserObject *uo81 = (struct UserObject*)obj46;
  uo81->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up81 = addmethod2pos(obj46, "visitObject()up", &meth_ast_visitObject_40__41_up81, 12);
  int argcv_meth_ast_visitObject_40__41_up81[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up81->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up81);
  meth_meth_ast_visitObject_40__41_up81->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up81->definitionLine = 2373;
// method visitArray()up
  struct UserObject *uo84 = (struct UserObject*)obj46;
  uo84->data[13] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up84 = addmethod2pos(obj46, "visitArray()up", &meth_ast_visitArray_40__41_up84, 13);
  int argcv_meth_ast_visitArray_40__41_up84[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up84->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up84);
  meth_meth_ast_visitArray_40__41_up84->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up84->definitionLine = 2374;
// method visitMember()up
  struct UserObject *uo87 = (struct UserObject*)obj46;
  uo87->data[14] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up87 = addmethod2pos(obj46, "visitMember()up", &meth_ast_visitMember_40__41_up87, 14);
  int argcv_meth_ast_visitMember_40__41_up87[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up87->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up87);
  meth_meth_ast_visitMember_40__41_up87->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up87->definitionLine = 2375;
// method visitGeneric()up
  struct UserObject *uo90 = (struct UserObject*)obj46;
  uo90->data[15] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up90 = addmethod2pos(obj46, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up90, 15);
  int argcv_meth_ast_visitGeneric_40__41_up90[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up90->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up90);
  meth_meth_ast_visitGeneric_40__41_up90->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up90->definitionLine = 2376;
// method visitIdentifier()up
  struct UserObject *uo93 = (struct UserObject*)obj46;
  uo93->data[16] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up93 = addmethod2pos(obj46, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up93, 16);
  int argcv_meth_ast_visitIdentifier_40__41_up93[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up93->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up93);
  meth_meth_ast_visitIdentifier_40__41_up93->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up93->definitionLine = 2377;
// method visitOctets()up
  struct UserObject *uo96 = (struct UserObject*)obj46;
  uo96->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets_40__41_up96 = addmethod2pos(obj46, "visitOctets()up", &meth_ast_visitOctets_40__41_up96, 17);
  int argcv_meth_ast_visitOctets_40__41_up96[] = {1, 1};
  meth_meth_ast_visitOctets_40__41_up96->type = alloc_MethodType(2, argcv_meth_ast_visitOctets_40__41_up96);
  meth_meth_ast_visitOctets_40__41_up96->definitionModule = modulename;
  meth_meth_ast_visitOctets_40__41_up96->definitionLine = 2378;
// method visitString()up
  struct UserObject *uo99 = (struct UserObject*)obj46;
  uo99->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up99 = addmethod2pos(obj46, "visitString()up", &meth_ast_visitString_40__41_up99, 18);
  int argcv_meth_ast_visitString_40__41_up99[] = {1, 1};
  meth_meth_ast_visitString_40__41_up99->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up99);
  meth_meth_ast_visitString_40__41_up99->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up99->definitionLine = 2379;
// method visitNum()up
  struct UserObject *uo102 = (struct UserObject*)obj46;
  uo102->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up102 = addmethod2pos(obj46, "visitNum()up", &meth_ast_visitNum_40__41_up102, 19);
  int argcv_meth_ast_visitNum_40__41_up102[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up102->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up102);
  meth_meth_ast_visitNum_40__41_up102->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up102->definitionLine = 2380;
// method visitOp()up
  struct UserObject *uo105 = (struct UserObject*)obj46;
  uo105->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up105 = addmethod2pos(obj46, "visitOp()up", &meth_ast_visitOp_40__41_up105, 20);
  int argcv_meth_ast_visitOp_40__41_up105[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up105->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up105);
  meth_meth_ast_visitOp_40__41_up105->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up105->definitionLine = 2381;
// method visitIndex()up
  struct UserObject *uo108 = (struct UserObject*)obj46;
  uo108->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up108 = addmethod2pos(obj46, "visitIndex()up", &meth_ast_visitIndex_40__41_up108, 21);
  int argcv_meth_ast_visitIndex_40__41_up108[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up108->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up108);
  meth_meth_ast_visitIndex_40__41_up108->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up108->definitionLine = 2382;
// method visitBind()up
  struct UserObject *uo111 = (struct UserObject*)obj46;
  uo111->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up111 = addmethod2pos(obj46, "visitBind()up", &meth_ast_visitBind_40__41_up111, 22);
  int argcv_meth_ast_visitBind_40__41_up111[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up111->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up111);
  meth_meth_ast_visitBind_40__41_up111->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up111->definitionLine = 2383;
// method visitDefDec()up
  struct UserObject *uo114 = (struct UserObject*)obj46;
  uo114->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up114 = addmethod2pos(obj46, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up114, 23);
  int argcv_meth_ast_visitDefDec_40__41_up114[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up114->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up114);
  meth_meth_ast_visitDefDec_40__41_up114->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up114->definitionLine = 2384;
// method visitVarDec()up
  struct UserObject *uo117 = (struct UserObject*)obj46;
  uo117->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up117 = addmethod2pos(obj46, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up117, 24);
  int argcv_meth_ast_visitVarDec_40__41_up117[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up117->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up117);
  meth_meth_ast_visitVarDec_40__41_up117->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up117->definitionLine = 2385;
// method visitImport()up
  struct UserObject *uo120 = (struct UserObject*)obj46;
  uo120->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up120 = addmethod2pos(obj46, "visitImport()up", &meth_ast_visitImport_40__41_up120, 25);
  int argcv_meth_ast_visitImport_40__41_up120[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up120->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up120);
  meth_meth_ast_visitImport_40__41_up120->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up120->definitionLine = 2386;
// method visitReturn()up
  struct UserObject *uo123 = (struct UserObject*)obj46;
  uo123->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up123 = addmethod2pos(obj46, "visitReturn()up", &meth_ast_visitReturn_40__41_up123, 26);
  int argcv_meth_ast_visitReturn_40__41_up123[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up123->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up123);
  meth_meth_ast_visitReturn_40__41_up123->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up123->definitionLine = 2387;
// method visitInherits()up
  struct UserObject *uo126 = (struct UserObject*)obj46;
  uo126->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up126 = addmethod2pos(obj46, "visitInherits()up", &meth_ast_visitInherits_40__41_up126, 27);
  int argcv_meth_ast_visitInherits_40__41_up126[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up126->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up126);
  meth_meth_ast_visitInherits_40__41_up126->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up126->definitionLine = 2388;
// method visitDialect()up
  struct UserObject *uo129 = (struct UserObject*)obj46;
  uo129->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up129 = addmethod2pos(obj46, "visitDialect()up", &meth_ast_visitDialect_40__41_up129, 28);
  int argcv_meth_ast_visitDialect_40__41_up129[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up129->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up129);
  meth_meth_ast_visitDialect_40__41_up129->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up129->definitionLine = 2389;
// method visitIf
  struct UserObject *uo132 = (struct UserObject*)obj46;
  uo132->data[29] = emptyclosure;
  Method *meth_meth_ast_visitIf132 = addmethod2pos(obj46, "visitIf", &meth_ast_visitIf132, 29);
  int argcv_meth_ast_visitIf132[] = {1};
  meth_meth_ast_visitIf132->type = alloc_MethodType(1, argcv_meth_ast_visitIf132);
  meth_meth_ast_visitIf132->definitionModule = modulename;
  meth_meth_ast_visitIf132->definitionLine = 2391;
// method visitBlock
  struct UserObject *uo134 = (struct UserObject*)obj46;
  uo134->data[30] = emptyclosure;
  Method *meth_meth_ast_visitBlock134 = addmethod2pos(obj46, "visitBlock", &meth_ast_visitBlock134, 30);
  int argcv_meth_ast_visitBlock134[] = {1};
  meth_meth_ast_visitBlock134->type = alloc_MethodType(1, argcv_meth_ast_visitBlock134);
  meth_meth_ast_visitBlock134->definitionModule = modulename;
  meth_meth_ast_visitBlock134->definitionLine = 2392;
// method visitMatchCase
  struct UserObject *uo136 = (struct UserObject*)obj46;
  uo136->data[31] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase136 = addmethod2pos(obj46, "visitMatchCase", &meth_ast_visitMatchCase136, 31);
  int argcv_meth_ast_visitMatchCase136[] = {1};
  meth_meth_ast_visitMatchCase136->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase136);
  meth_meth_ast_visitMatchCase136->definitionModule = modulename;
  meth_meth_ast_visitMatchCase136->definitionLine = 2393;
// method visitCatchCase
  struct UserObject *uo138 = (struct UserObject*)obj46;
  uo138->data[32] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase138 = addmethod2pos(obj46, "visitCatchCase", &meth_ast_visitCatchCase138, 32);
  int argcv_meth_ast_visitCatchCase138[] = {1};
  meth_meth_ast_visitCatchCase138->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase138);
  meth_meth_ast_visitCatchCase138->definitionModule = modulename;
  meth_meth_ast_visitCatchCase138->definitionLine = 2394;
// method visitMethodType
  struct UserObject *uo140 = (struct UserObject*)obj46;
  uo140->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMethodType140 = addmethod2pos(obj46, "visitMethodType", &meth_ast_visitMethodType140, 33);
  int argcv_meth_ast_visitMethodType140[] = {1};
  meth_meth_ast_visitMethodType140->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType140);
  meth_meth_ast_visitMethodType140->definitionModule = modulename;
  meth_meth_ast_visitMethodType140->definitionLine = 2395;
// method visitSignaturePart
  struct UserObject *uo142 = (struct UserObject*)obj46;
  uo142->data[34] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart142 = addmethod2pos(obj46, "visitSignaturePart", &meth_ast_visitSignaturePart142, 34);
  int argcv_meth_ast_visitSignaturePart142[] = {1};
  meth_meth_ast_visitSignaturePart142->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart142);
  meth_meth_ast_visitSignaturePart142->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart142->definitionLine = 2396;
// method visitTypeDec
  struct UserObject *uo144 = (struct UserObject*)obj46;
  uo144->data[35] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec144 = addmethod2pos(obj46, "visitTypeDec", &meth_ast_visitTypeDec144, 35);
  int argcv_meth_ast_visitTypeDec144[] = {1};
  meth_meth_ast_visitTypeDec144->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec144);
  meth_meth_ast_visitTypeDec144->definitionModule = modulename;
  meth_meth_ast_visitTypeDec144->definitionLine = 2397;
// method visitTypeLiteral
  struct UserObject *uo146 = (struct UserObject*)obj46;
  uo146->data[36] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral146 = addmethod2pos(obj46, "visitTypeLiteral", &meth_ast_visitTypeLiteral146, 36);
  int argcv_meth_ast_visitTypeLiteral146[] = {1};
  meth_meth_ast_visitTypeLiteral146->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral146);
  meth_meth_ast_visitTypeLiteral146->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral146->definitionLine = 2398;
// method visitMethod
  struct UserObject *uo148 = (struct UserObject*)obj46;
  uo148->data[37] = emptyclosure;
  Method *meth_meth_ast_visitMethod148 = addmethod2pos(obj46, "visitMethod", &meth_ast_visitMethod148, 37);
  int argcv_meth_ast_visitMethod148[] = {1};
  meth_meth_ast_visitMethod148->type = alloc_MethodType(1, argcv_meth_ast_visitMethod148);
  meth_meth_ast_visitMethod148->definitionModule = modulename;
  meth_meth_ast_visitMethod148->definitionLine = 2399;
// method visitCall
  struct UserObject *uo150 = (struct UserObject*)obj46;
  uo150->data[38] = emptyclosure;
  Method *meth_meth_ast_visitCall150 = addmethod2pos(obj46, "visitCall", &meth_ast_visitCall150, 38);
  int argcv_meth_ast_visitCall150[] = {1};
  meth_meth_ast_visitCall150->type = alloc_MethodType(1, argcv_meth_ast_visitCall150);
  meth_meth_ast_visitCall150->definitionModule = modulename;
  meth_meth_ast_visitCall150->definitionLine = 2400;
// method visitClass
  struct UserObject *uo152 = (struct UserObject*)obj46;
  uo152->data[39] = emptyclosure;
  Method *meth_meth_ast_visitClass152 = addmethod2pos(obj46, "visitClass", &meth_ast_visitClass152, 39);
  int argcv_meth_ast_visitClass152[] = {1};
  meth_meth_ast_visitClass152->type = alloc_MethodType(1, argcv_meth_ast_visitClass152);
  meth_meth_ast_visitClass152->definitionModule = modulename;
  meth_meth_ast_visitClass152->definitionLine = 2401;
// method visitObject
  struct UserObject *uo154 = (struct UserObject*)obj46;
  uo154->data[40] = emptyclosure;
  Method *meth_meth_ast_visitObject154 = addmethod2pos(obj46, "visitObject", &meth_ast_visitObject154, 40);
  int argcv_meth_ast_visitObject154[] = {1};
  meth_meth_ast_visitObject154->type = alloc_MethodType(1, argcv_meth_ast_visitObject154);
  meth_meth_ast_visitObject154->definitionModule = modulename;
  meth_meth_ast_visitObject154->definitionLine = 2402;
// method visitArray
  struct UserObject *uo156 = (struct UserObject*)obj46;
  uo156->data[41] = emptyclosure;
  Method *meth_meth_ast_visitArray156 = addmethod2pos(obj46, "visitArray", &meth_ast_visitArray156, 41);
  int argcv_meth_ast_visitArray156[] = {1};
  meth_meth_ast_visitArray156->type = alloc_MethodType(1, argcv_meth_ast_visitArray156);
  meth_meth_ast_visitArray156->definitionModule = modulename;
  meth_meth_ast_visitArray156->definitionLine = 2403;
// method visitMember
  struct UserObject *uo158 = (struct UserObject*)obj46;
  uo158->data[42] = emptyclosure;
  Method *meth_meth_ast_visitMember158 = addmethod2pos(obj46, "visitMember", &meth_ast_visitMember158, 42);
  int argcv_meth_ast_visitMember158[] = {1};
  meth_meth_ast_visitMember158->type = alloc_MethodType(1, argcv_meth_ast_visitMember158);
  meth_meth_ast_visitMember158->definitionModule = modulename;
  meth_meth_ast_visitMember158->definitionLine = 2404;
// method visitGeneric
  struct UserObject *uo160 = (struct UserObject*)obj46;
  uo160->data[43] = emptyclosure;
  Method *meth_meth_ast_visitGeneric160 = addmethod2pos(obj46, "visitGeneric", &meth_ast_visitGeneric160, 43);
  int argcv_meth_ast_visitGeneric160[] = {1};
  meth_meth_ast_visitGeneric160->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric160);
  meth_meth_ast_visitGeneric160->definitionModule = modulename;
  meth_meth_ast_visitGeneric160->definitionLine = 2405;
// method visitIdentifier
  struct UserObject *uo162 = (struct UserObject*)obj46;
  uo162->data[44] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier162 = addmethod2pos(obj46, "visitIdentifier", &meth_ast_visitIdentifier162, 44);
  int argcv_meth_ast_visitIdentifier162[] = {1};
  meth_meth_ast_visitIdentifier162->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier162);
  meth_meth_ast_visitIdentifier162->definitionModule = modulename;
  meth_meth_ast_visitIdentifier162->definitionLine = 2406;
// method visitOctets
  struct UserObject *uo164 = (struct UserObject*)obj46;
  uo164->data[45] = emptyclosure;
  Method *meth_meth_ast_visitOctets164 = addmethod2pos(obj46, "visitOctets", &meth_ast_visitOctets164, 45);
  int argcv_meth_ast_visitOctets164[] = {1};
  meth_meth_ast_visitOctets164->type = alloc_MethodType(1, argcv_meth_ast_visitOctets164);
  meth_meth_ast_visitOctets164->definitionModule = modulename;
  meth_meth_ast_visitOctets164->definitionLine = 2407;
// method visitString
  struct UserObject *uo166 = (struct UserObject*)obj46;
  uo166->data[46] = emptyclosure;
  Method *meth_meth_ast_visitString166 = addmethod2pos(obj46, "visitString", &meth_ast_visitString166, 46);
  int argcv_meth_ast_visitString166[] = {1};
  meth_meth_ast_visitString166->type = alloc_MethodType(1, argcv_meth_ast_visitString166);
  meth_meth_ast_visitString166->definitionModule = modulename;
  meth_meth_ast_visitString166->definitionLine = 2408;
// method visitNum
  struct UserObject *uo168 = (struct UserObject*)obj46;
  uo168->data[47] = emptyclosure;
  Method *meth_meth_ast_visitNum168 = addmethod2pos(obj46, "visitNum", &meth_ast_visitNum168, 47);
  int argcv_meth_ast_visitNum168[] = {1};
  meth_meth_ast_visitNum168->type = alloc_MethodType(1, argcv_meth_ast_visitNum168);
  meth_meth_ast_visitNum168->definitionModule = modulename;
  meth_meth_ast_visitNum168->definitionLine = 2409;
// method visitOp
  struct UserObject *uo170 = (struct UserObject*)obj46;
  uo170->data[48] = emptyclosure;
  Method *meth_meth_ast_visitOp170 = addmethod2pos(obj46, "visitOp", &meth_ast_visitOp170, 48);
  int argcv_meth_ast_visitOp170[] = {1};
  meth_meth_ast_visitOp170->type = alloc_MethodType(1, argcv_meth_ast_visitOp170);
  meth_meth_ast_visitOp170->definitionModule = modulename;
  meth_meth_ast_visitOp170->definitionLine = 2410;
// method visitIndex
  struct UserObject *uo172 = (struct UserObject*)obj46;
  uo172->data[49] = emptyclosure;
  Method *meth_meth_ast_visitIndex172 = addmethod2pos(obj46, "visitIndex", &meth_ast_visitIndex172, 49);
  int argcv_meth_ast_visitIndex172[] = {1};
  meth_meth_ast_visitIndex172->type = alloc_MethodType(1, argcv_meth_ast_visitIndex172);
  meth_meth_ast_visitIndex172->definitionModule = modulename;
  meth_meth_ast_visitIndex172->definitionLine = 2411;
// method visitBind
  struct UserObject *uo174 = (struct UserObject*)obj46;
  uo174->data[50] = emptyclosure;
  Method *meth_meth_ast_visitBind174 = addmethod2pos(obj46, "visitBind", &meth_ast_visitBind174, 50);
  int argcv_meth_ast_visitBind174[] = {1};
  meth_meth_ast_visitBind174->type = alloc_MethodType(1, argcv_meth_ast_visitBind174);
  meth_meth_ast_visitBind174->definitionModule = modulename;
  meth_meth_ast_visitBind174->definitionLine = 2412;
// method visitDefDec
  struct UserObject *uo176 = (struct UserObject*)obj46;
  uo176->data[51] = emptyclosure;
  Method *meth_meth_ast_visitDefDec176 = addmethod2pos(obj46, "visitDefDec", &meth_ast_visitDefDec176, 51);
  int argcv_meth_ast_visitDefDec176[] = {1};
  meth_meth_ast_visitDefDec176->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec176);
  meth_meth_ast_visitDefDec176->definitionModule = modulename;
  meth_meth_ast_visitDefDec176->definitionLine = 2413;
// method visitVarDec
  struct UserObject *uo178 = (struct UserObject*)obj46;
  uo178->data[52] = emptyclosure;
  Method *meth_meth_ast_visitVarDec178 = addmethod2pos(obj46, "visitVarDec", &meth_ast_visitVarDec178, 52);
  int argcv_meth_ast_visitVarDec178[] = {1};
  meth_meth_ast_visitVarDec178->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec178);
  meth_meth_ast_visitVarDec178->definitionModule = modulename;
  meth_meth_ast_visitVarDec178->definitionLine = 2414;
// method visitImport
  struct UserObject *uo180 = (struct UserObject*)obj46;
  uo180->data[53] = emptyclosure;
  Method *meth_meth_ast_visitImport180 = addmethod2pos(obj46, "visitImport", &meth_ast_visitImport180, 53);
  int argcv_meth_ast_visitImport180[] = {1};
  meth_meth_ast_visitImport180->type = alloc_MethodType(1, argcv_meth_ast_visitImport180);
  meth_meth_ast_visitImport180->definitionModule = modulename;
  meth_meth_ast_visitImport180->definitionLine = 2415;
// method visitReturn
  struct UserObject *uo182 = (struct UserObject*)obj46;
  uo182->data[54] = emptyclosure;
  Method *meth_meth_ast_visitReturn182 = addmethod2pos(obj46, "visitReturn", &meth_ast_visitReturn182, 54);
  int argcv_meth_ast_visitReturn182[] = {1};
  meth_meth_ast_visitReturn182->type = alloc_MethodType(1, argcv_meth_ast_visitReturn182);
  meth_meth_ast_visitReturn182->definitionModule = modulename;
  meth_meth_ast_visitReturn182->definitionLine = 2416;
// method visitInherits
  struct UserObject *uo184 = (struct UserObject*)obj46;
  uo184->data[55] = emptyclosure;
  Method *meth_meth_ast_visitInherits184 = addmethod2pos(obj46, "visitInherits", &meth_ast_visitInherits184, 55);
  int argcv_meth_ast_visitInherits184[] = {1};
  meth_meth_ast_visitInherits184->type = alloc_MethodType(1, argcv_meth_ast_visitInherits184);
  meth_meth_ast_visitInherits184->definitionModule = modulename;
  meth_meth_ast_visitInherits184->definitionLine = 2417;
// method visitDialect
  struct UserObject *uo186 = (struct UserObject*)obj46;
  uo186->data[56] = emptyclosure;
  Method *meth_meth_ast_visitDialect186 = addmethod2pos(obj46, "visitDialect", &meth_ast_visitDialect186, 56);
  int argcv_meth_ast_visitDialect186[] = {1};
  meth_meth_ast_visitDialect186->type = alloc_MethodType(1, argcv_meth_ast_visitDialect186);
  meth_meth_ast_visitDialect186->definitionModule = modulename;
  meth_meth_ast_visitDialect186->definitionLine = 2418;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
objclass46 = obj46->class;
  objclass46->definitionModule = modulename;
  objclass46->definitionLine = 2361;
  (*(struct UserObject *)self).data[0] = lowerouter46;
  self = oldself46;
  selfslot = oldselfslot46;
  stackframe = oldstackframe46;
  gc_frame_end(frame);
  return obj46;
}
Object meth_ast_baseVisitor45_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject46 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj46 = alloc_userobj2(56,57, objclass46);
  gc_frame_newslot(obj46);
if (objclass46 == NULL) {
  glfree(obj46->class->name);
  obj46->class->name = "self.baseVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj46, self, 0);
  addmethodreal(obj46,"outer", &reader_ast_outer_47);
  Object oldself46 = self;
  struct StackFrameObject *oldstackframe46 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe46);
  gc_frame_newslot((Object)stackframe);
  self = obj46;
  Object *oldselfslot46 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter46 = (*(struct UserObject *)self).data[0], lowerouter46 = thisouter46;
  if (inheritingObject46) {
    struct UserObject *inho46 = (struct UserObject *)inheritingObject46;
    while (inho46->super != GraceDefaultObject) inho46 = (struct UserObject *)inho46->super;
    inho46->super = obj46;
    self = inheritingObject46;
    *selfslot = self;
    lowerouter46 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter46;
  }
// method visitIf()up
  struct UserObject *uo48 = (struct UserObject*)obj46;
  uo48->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up48 = addmethod2pos(obj46, "visitIf()up", &meth_ast_visitIf_40__41_up48, 1);
  int argcv_meth_ast_visitIf_40__41_up48[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up48->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up48);
  meth_meth_ast_visitIf_40__41_up48->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up48->definitionLine = 2362;
// method visitBlock()up
  struct UserObject *uo51 = (struct UserObject*)obj46;
  uo51->data[2] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up51 = addmethod2pos(obj46, "visitBlock()up", &meth_ast_visitBlock_40__41_up51, 2);
  int argcv_meth_ast_visitBlock_40__41_up51[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up51->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up51);
  meth_meth_ast_visitBlock_40__41_up51->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up51->definitionLine = 2363;
// method visitMatchCase()up
  struct UserObject *uo54 = (struct UserObject*)obj46;
  uo54->data[3] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up54 = addmethod2pos(obj46, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up54, 3);
  int argcv_meth_ast_visitMatchCase_40__41_up54[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up54->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up54);
  meth_meth_ast_visitMatchCase_40__41_up54->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up54->definitionLine = 2364;
// method visitCatchCase()up
  struct UserObject *uo57 = (struct UserObject*)obj46;
  uo57->data[4] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase_40__41_up57 = addmethod2pos(obj46, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up57, 4);
  int argcv_meth_ast_visitCatchCase_40__41_up57[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up57->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up57);
  meth_meth_ast_visitCatchCase_40__41_up57->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up57->definitionLine = 2365;
// method visitMethodType()up
  struct UserObject *uo60 = (struct UserObject*)obj46;
  uo60->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up60 = addmethod2pos(obj46, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up60, 5);
  int argcv_meth_ast_visitMethodType_40__41_up60[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up60->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up60);
  meth_meth_ast_visitMethodType_40__41_up60->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up60->definitionLine = 2366;
// method visitSignaturePart()up
  struct UserObject *uo63 = (struct UserObject*)obj46;
  uo63->data[6] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up63 = addmethod2pos(obj46, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up63, 6);
  int argcv_meth_ast_visitSignaturePart_40__41_up63[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up63->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up63);
  meth_meth_ast_visitSignaturePart_40__41_up63->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up63->definitionLine = 2367;
// method visitTypeDec()up
  struct UserObject *uo66 = (struct UserObject*)obj46;
  uo66->data[7] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up66 = addmethod2pos(obj46, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up66, 7);
  int argcv_meth_ast_visitTypeDec_40__41_up66[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up66->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up66);
  meth_meth_ast_visitTypeDec_40__41_up66->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up66->definitionLine = 2368;
// method visitTypeLiteral()up
  struct UserObject *uo69 = (struct UserObject*)obj46;
  uo69->data[8] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up69 = addmethod2pos(obj46, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up69, 8);
  int argcv_meth_ast_visitTypeLiteral_40__41_up69[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up69->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up69);
  meth_meth_ast_visitTypeLiteral_40__41_up69->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up69->definitionLine = 2369;
// method visitMethod()up
  struct UserObject *uo72 = (struct UserObject*)obj46;
  uo72->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up72 = addmethod2pos(obj46, "visitMethod()up", &meth_ast_visitMethod_40__41_up72, 9);
  int argcv_meth_ast_visitMethod_40__41_up72[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up72->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up72);
  meth_meth_ast_visitMethod_40__41_up72->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up72->definitionLine = 2370;
// method visitCall()up
  struct UserObject *uo75 = (struct UserObject*)obj46;
  uo75->data[10] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up75 = addmethod2pos(obj46, "visitCall()up", &meth_ast_visitCall_40__41_up75, 10);
  int argcv_meth_ast_visitCall_40__41_up75[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up75->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up75);
  meth_meth_ast_visitCall_40__41_up75->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up75->definitionLine = 2371;
// method visitClass()up
  struct UserObject *uo78 = (struct UserObject*)obj46;
  uo78->data[11] = emptyclosure;
  Method *meth_meth_ast_visitClass_40__41_up78 = addmethod2pos(obj46, "visitClass()up", &meth_ast_visitClass_40__41_up78, 11);
  int argcv_meth_ast_visitClass_40__41_up78[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up78->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up78);
  meth_meth_ast_visitClass_40__41_up78->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up78->definitionLine = 2372;
// method visitObject()up
  struct UserObject *uo81 = (struct UserObject*)obj46;
  uo81->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up81 = addmethod2pos(obj46, "visitObject()up", &meth_ast_visitObject_40__41_up81, 12);
  int argcv_meth_ast_visitObject_40__41_up81[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up81->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up81);
  meth_meth_ast_visitObject_40__41_up81->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up81->definitionLine = 2373;
// method visitArray()up
  struct UserObject *uo84 = (struct UserObject*)obj46;
  uo84->data[13] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up84 = addmethod2pos(obj46, "visitArray()up", &meth_ast_visitArray_40__41_up84, 13);
  int argcv_meth_ast_visitArray_40__41_up84[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up84->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up84);
  meth_meth_ast_visitArray_40__41_up84->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up84->definitionLine = 2374;
// method visitMember()up
  struct UserObject *uo87 = (struct UserObject*)obj46;
  uo87->data[14] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up87 = addmethod2pos(obj46, "visitMember()up", &meth_ast_visitMember_40__41_up87, 14);
  int argcv_meth_ast_visitMember_40__41_up87[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up87->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up87);
  meth_meth_ast_visitMember_40__41_up87->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up87->definitionLine = 2375;
// method visitGeneric()up
  struct UserObject *uo90 = (struct UserObject*)obj46;
  uo90->data[15] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up90 = addmethod2pos(obj46, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up90, 15);
  int argcv_meth_ast_visitGeneric_40__41_up90[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up90->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up90);
  meth_meth_ast_visitGeneric_40__41_up90->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up90->definitionLine = 2376;
// method visitIdentifier()up
  struct UserObject *uo93 = (struct UserObject*)obj46;
  uo93->data[16] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up93 = addmethod2pos(obj46, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up93, 16);
  int argcv_meth_ast_visitIdentifier_40__41_up93[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up93->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up93);
  meth_meth_ast_visitIdentifier_40__41_up93->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up93->definitionLine = 2377;
// method visitOctets()up
  struct UserObject *uo96 = (struct UserObject*)obj46;
  uo96->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets_40__41_up96 = addmethod2pos(obj46, "visitOctets()up", &meth_ast_visitOctets_40__41_up96, 17);
  int argcv_meth_ast_visitOctets_40__41_up96[] = {1, 1};
  meth_meth_ast_visitOctets_40__41_up96->type = alloc_MethodType(2, argcv_meth_ast_visitOctets_40__41_up96);
  meth_meth_ast_visitOctets_40__41_up96->definitionModule = modulename;
  meth_meth_ast_visitOctets_40__41_up96->definitionLine = 2378;
// method visitString()up
  struct UserObject *uo99 = (struct UserObject*)obj46;
  uo99->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up99 = addmethod2pos(obj46, "visitString()up", &meth_ast_visitString_40__41_up99, 18);
  int argcv_meth_ast_visitString_40__41_up99[] = {1, 1};
  meth_meth_ast_visitString_40__41_up99->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up99);
  meth_meth_ast_visitString_40__41_up99->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up99->definitionLine = 2379;
// method visitNum()up
  struct UserObject *uo102 = (struct UserObject*)obj46;
  uo102->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up102 = addmethod2pos(obj46, "visitNum()up", &meth_ast_visitNum_40__41_up102, 19);
  int argcv_meth_ast_visitNum_40__41_up102[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up102->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up102);
  meth_meth_ast_visitNum_40__41_up102->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up102->definitionLine = 2380;
// method visitOp()up
  struct UserObject *uo105 = (struct UserObject*)obj46;
  uo105->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up105 = addmethod2pos(obj46, "visitOp()up", &meth_ast_visitOp_40__41_up105, 20);
  int argcv_meth_ast_visitOp_40__41_up105[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up105->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up105);
  meth_meth_ast_visitOp_40__41_up105->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up105->definitionLine = 2381;
// method visitIndex()up
  struct UserObject *uo108 = (struct UserObject*)obj46;
  uo108->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up108 = addmethod2pos(obj46, "visitIndex()up", &meth_ast_visitIndex_40__41_up108, 21);
  int argcv_meth_ast_visitIndex_40__41_up108[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up108->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up108);
  meth_meth_ast_visitIndex_40__41_up108->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up108->definitionLine = 2382;
// method visitBind()up
  struct UserObject *uo111 = (struct UserObject*)obj46;
  uo111->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up111 = addmethod2pos(obj46, "visitBind()up", &meth_ast_visitBind_40__41_up111, 22);
  int argcv_meth_ast_visitBind_40__41_up111[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up111->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up111);
  meth_meth_ast_visitBind_40__41_up111->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up111->definitionLine = 2383;
// method visitDefDec()up
  struct UserObject *uo114 = (struct UserObject*)obj46;
  uo114->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up114 = addmethod2pos(obj46, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up114, 23);
  int argcv_meth_ast_visitDefDec_40__41_up114[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up114->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up114);
  meth_meth_ast_visitDefDec_40__41_up114->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up114->definitionLine = 2384;
// method visitVarDec()up
  struct UserObject *uo117 = (struct UserObject*)obj46;
  uo117->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up117 = addmethod2pos(obj46, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up117, 24);
  int argcv_meth_ast_visitVarDec_40__41_up117[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up117->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up117);
  meth_meth_ast_visitVarDec_40__41_up117->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up117->definitionLine = 2385;
// method visitImport()up
  struct UserObject *uo120 = (struct UserObject*)obj46;
  uo120->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up120 = addmethod2pos(obj46, "visitImport()up", &meth_ast_visitImport_40__41_up120, 25);
  int argcv_meth_ast_visitImport_40__41_up120[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up120->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up120);
  meth_meth_ast_visitImport_40__41_up120->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up120->definitionLine = 2386;
// method visitReturn()up
  struct UserObject *uo123 = (struct UserObject*)obj46;
  uo123->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up123 = addmethod2pos(obj46, "visitReturn()up", &meth_ast_visitReturn_40__41_up123, 26);
  int argcv_meth_ast_visitReturn_40__41_up123[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up123->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up123);
  meth_meth_ast_visitReturn_40__41_up123->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up123->definitionLine = 2387;
// method visitInherits()up
  struct UserObject *uo126 = (struct UserObject*)obj46;
  uo126->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up126 = addmethod2pos(obj46, "visitInherits()up", &meth_ast_visitInherits_40__41_up126, 27);
  int argcv_meth_ast_visitInherits_40__41_up126[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up126->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up126);
  meth_meth_ast_visitInherits_40__41_up126->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up126->definitionLine = 2388;
// method visitDialect()up
  struct UserObject *uo129 = (struct UserObject*)obj46;
  uo129->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up129 = addmethod2pos(obj46, "visitDialect()up", &meth_ast_visitDialect_40__41_up129, 28);
  int argcv_meth_ast_visitDialect_40__41_up129[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up129->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up129);
  meth_meth_ast_visitDialect_40__41_up129->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up129->definitionLine = 2389;
// method visitIf
  struct UserObject *uo132 = (struct UserObject*)obj46;
  uo132->data[29] = emptyclosure;
  Method *meth_meth_ast_visitIf132 = addmethod2pos(obj46, "visitIf", &meth_ast_visitIf132, 29);
  int argcv_meth_ast_visitIf132[] = {1};
  meth_meth_ast_visitIf132->type = alloc_MethodType(1, argcv_meth_ast_visitIf132);
  meth_meth_ast_visitIf132->definitionModule = modulename;
  meth_meth_ast_visitIf132->definitionLine = 2391;
// method visitBlock
  struct UserObject *uo134 = (struct UserObject*)obj46;
  uo134->data[30] = emptyclosure;
  Method *meth_meth_ast_visitBlock134 = addmethod2pos(obj46, "visitBlock", &meth_ast_visitBlock134, 30);
  int argcv_meth_ast_visitBlock134[] = {1};
  meth_meth_ast_visitBlock134->type = alloc_MethodType(1, argcv_meth_ast_visitBlock134);
  meth_meth_ast_visitBlock134->definitionModule = modulename;
  meth_meth_ast_visitBlock134->definitionLine = 2392;
// method visitMatchCase
  struct UserObject *uo136 = (struct UserObject*)obj46;
  uo136->data[31] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase136 = addmethod2pos(obj46, "visitMatchCase", &meth_ast_visitMatchCase136, 31);
  int argcv_meth_ast_visitMatchCase136[] = {1};
  meth_meth_ast_visitMatchCase136->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase136);
  meth_meth_ast_visitMatchCase136->definitionModule = modulename;
  meth_meth_ast_visitMatchCase136->definitionLine = 2393;
// method visitCatchCase
  struct UserObject *uo138 = (struct UserObject*)obj46;
  uo138->data[32] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase138 = addmethod2pos(obj46, "visitCatchCase", &meth_ast_visitCatchCase138, 32);
  int argcv_meth_ast_visitCatchCase138[] = {1};
  meth_meth_ast_visitCatchCase138->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase138);
  meth_meth_ast_visitCatchCase138->definitionModule = modulename;
  meth_meth_ast_visitCatchCase138->definitionLine = 2394;
// method visitMethodType
  struct UserObject *uo140 = (struct UserObject*)obj46;
  uo140->data[33] = emptyclosure;
  Method *meth_meth_ast_visitMethodType140 = addmethod2pos(obj46, "visitMethodType", &meth_ast_visitMethodType140, 33);
  int argcv_meth_ast_visitMethodType140[] = {1};
  meth_meth_ast_visitMethodType140->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType140);
  meth_meth_ast_visitMethodType140->definitionModule = modulename;
  meth_meth_ast_visitMethodType140->definitionLine = 2395;
// method visitSignaturePart
  struct UserObject *uo142 = (struct UserObject*)obj46;
  uo142->data[34] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart142 = addmethod2pos(obj46, "visitSignaturePart", &meth_ast_visitSignaturePart142, 34);
  int argcv_meth_ast_visitSignaturePart142[] = {1};
  meth_meth_ast_visitSignaturePart142->type = alloc_MethodType(1, argcv_meth_ast_visitSignaturePart142);
  meth_meth_ast_visitSignaturePart142->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart142->definitionLine = 2396;
// method visitTypeDec
  struct UserObject *uo144 = (struct UserObject*)obj46;
  uo144->data[35] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec144 = addmethod2pos(obj46, "visitTypeDec", &meth_ast_visitTypeDec144, 35);
  int argcv_meth_ast_visitTypeDec144[] = {1};
  meth_meth_ast_visitTypeDec144->type = alloc_MethodType(1, argcv_meth_ast_visitTypeDec144);
  meth_meth_ast_visitTypeDec144->definitionModule = modulename;
  meth_meth_ast_visitTypeDec144->definitionLine = 2397;
// method visitTypeLiteral
  struct UserObject *uo146 = (struct UserObject*)obj46;
  uo146->data[36] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral146 = addmethod2pos(obj46, "visitTypeLiteral", &meth_ast_visitTypeLiteral146, 36);
  int argcv_meth_ast_visitTypeLiteral146[] = {1};
  meth_meth_ast_visitTypeLiteral146->type = alloc_MethodType(1, argcv_meth_ast_visitTypeLiteral146);
  meth_meth_ast_visitTypeLiteral146->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral146->definitionLine = 2398;
// method visitMethod
  struct UserObject *uo148 = (struct UserObject*)obj46;
  uo148->data[37] = emptyclosure;
  Method *meth_meth_ast_visitMethod148 = addmethod2pos(obj46, "visitMethod", &meth_ast_visitMethod148, 37);
  int argcv_meth_ast_visitMethod148[] = {1};
  meth_meth_ast_visitMethod148->type = alloc_MethodType(1, argcv_meth_ast_visitMethod148);
  meth_meth_ast_visitMethod148->definitionModule = modulename;
  meth_meth_ast_visitMethod148->definitionLine = 2399;
// method visitCall
  struct UserObject *uo150 = (struct UserObject*)obj46;
  uo150->data[38] = emptyclosure;
  Method *meth_meth_ast_visitCall150 = addmethod2pos(obj46, "visitCall", &meth_ast_visitCall150, 38);
  int argcv_meth_ast_visitCall150[] = {1};
  meth_meth_ast_visitCall150->type = alloc_MethodType(1, argcv_meth_ast_visitCall150);
  meth_meth_ast_visitCall150->definitionModule = modulename;
  meth_meth_ast_visitCall150->definitionLine = 2400;
// method visitClass
  struct UserObject *uo152 = (struct UserObject*)obj46;
  uo152->data[39] = emptyclosure;
  Method *meth_meth_ast_visitClass152 = addmethod2pos(obj46, "visitClass", &meth_ast_visitClass152, 39);
  int argcv_meth_ast_visitClass152[] = {1};
  meth_meth_ast_visitClass152->type = alloc_MethodType(1, argcv_meth_ast_visitClass152);
  meth_meth_ast_visitClass152->definitionModule = modulename;
  meth_meth_ast_visitClass152->definitionLine = 2401;
// method visitObject
  struct UserObject *uo154 = (struct UserObject*)obj46;
  uo154->data[40] = emptyclosure;
  Method *meth_meth_ast_visitObject154 = addmethod2pos(obj46, "visitObject", &meth_ast_visitObject154, 40);
  int argcv_meth_ast_visitObject154[] = {1};
  meth_meth_ast_visitObject154->type = alloc_MethodType(1, argcv_meth_ast_visitObject154);
  meth_meth_ast_visitObject154->definitionModule = modulename;
  meth_meth_ast_visitObject154->definitionLine = 2402;
// method visitArray
  struct UserObject *uo156 = (struct UserObject*)obj46;
  uo156->data[41] = emptyclosure;
  Method *meth_meth_ast_visitArray156 = addmethod2pos(obj46, "visitArray", &meth_ast_visitArray156, 41);
  int argcv_meth_ast_visitArray156[] = {1};
  meth_meth_ast_visitArray156->type = alloc_MethodType(1, argcv_meth_ast_visitArray156);
  meth_meth_ast_visitArray156->definitionModule = modulename;
  meth_meth_ast_visitArray156->definitionLine = 2403;
// method visitMember
  struct UserObject *uo158 = (struct UserObject*)obj46;
  uo158->data[42] = emptyclosure;
  Method *meth_meth_ast_visitMember158 = addmethod2pos(obj46, "visitMember", &meth_ast_visitMember158, 42);
  int argcv_meth_ast_visitMember158[] = {1};
  meth_meth_ast_visitMember158->type = alloc_MethodType(1, argcv_meth_ast_visitMember158);
  meth_meth_ast_visitMember158->definitionModule = modulename;
  meth_meth_ast_visitMember158->definitionLine = 2404;
// method visitGeneric
  struct UserObject *uo160 = (struct UserObject*)obj46;
  uo160->data[43] = emptyclosure;
  Method *meth_meth_ast_visitGeneric160 = addmethod2pos(obj46, "visitGeneric", &meth_ast_visitGeneric160, 43);
  int argcv_meth_ast_visitGeneric160[] = {1};
  meth_meth_ast_visitGeneric160->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric160);
  meth_meth_ast_visitGeneric160->definitionModule = modulename;
  meth_meth_ast_visitGeneric160->definitionLine = 2405;
// method visitIdentifier
  struct UserObject *uo162 = (struct UserObject*)obj46;
  uo162->data[44] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier162 = addmethod2pos(obj46, "visitIdentifier", &meth_ast_visitIdentifier162, 44);
  int argcv_meth_ast_visitIdentifier162[] = {1};
  meth_meth_ast_visitIdentifier162->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier162);
  meth_meth_ast_visitIdentifier162->definitionModule = modulename;
  meth_meth_ast_visitIdentifier162->definitionLine = 2406;
// method visitOctets
  struct UserObject *uo164 = (struct UserObject*)obj46;
  uo164->data[45] = emptyclosure;
  Method *meth_meth_ast_visitOctets164 = addmethod2pos(obj46, "visitOctets", &meth_ast_visitOctets164, 45);
  int argcv_meth_ast_visitOctets164[] = {1};
  meth_meth_ast_visitOctets164->type = alloc_MethodType(1, argcv_meth_ast_visitOctets164);
  meth_meth_ast_visitOctets164->definitionModule = modulename;
  meth_meth_ast_visitOctets164->definitionLine = 2407;
// method visitString
  struct UserObject *uo166 = (struct UserObject*)obj46;
  uo166->data[46] = emptyclosure;
  Method *meth_meth_ast_visitString166 = addmethod2pos(obj46, "visitString", &meth_ast_visitString166, 46);
  int argcv_meth_ast_visitString166[] = {1};
  meth_meth_ast_visitString166->type = alloc_MethodType(1, argcv_meth_ast_visitString166);
  meth_meth_ast_visitString166->definitionModule = modulename;
  meth_meth_ast_visitString166->definitionLine = 2408;
// method visitNum
  struct UserObject *uo168 = (struct UserObject*)obj46;
  uo168->data[47] = emptyclosure;
  Method *meth_meth_ast_visitNum168 = addmethod2pos(obj46, "visitNum", &meth_ast_visitNum168, 47);
  int argcv_meth_ast_visitNum168[] = {1};
  meth_meth_ast_visitNum168->type = alloc_MethodType(1, argcv_meth_ast_visitNum168);
  meth_meth_ast_visitNum168->definitionModule = modulename;
  meth_meth_ast_visitNum168->definitionLine = 2409;
// method visitOp
  struct UserObject *uo170 = (struct UserObject*)obj46;
  uo170->data[48] = emptyclosure;
  Method *meth_meth_ast_visitOp170 = addmethod2pos(obj46, "visitOp", &meth_ast_visitOp170, 48);
  int argcv_meth_ast_visitOp170[] = {1};
  meth_meth_ast_visitOp170->type = alloc_MethodType(1, argcv_meth_ast_visitOp170);
  meth_meth_ast_visitOp170->definitionModule = modulename;
  meth_meth_ast_visitOp170->definitionLine = 2410;
// method visitIndex
  struct UserObject *uo172 = (struct UserObject*)obj46;
  uo172->data[49] = emptyclosure;
  Method *meth_meth_ast_visitIndex172 = addmethod2pos(obj46, "visitIndex", &meth_ast_visitIndex172, 49);
  int argcv_meth_ast_visitIndex172[] = {1};
  meth_meth_ast_visitIndex172->type = alloc_MethodType(1, argcv_meth_ast_visitIndex172);
  meth_meth_ast_visitIndex172->definitionModule = modulename;
  meth_meth_ast_visitIndex172->definitionLine = 2411;
// method visitBind
  struct UserObject *uo174 = (struct UserObject*)obj46;
  uo174->data[50] = emptyclosure;
  Method *meth_meth_ast_visitBind174 = addmethod2pos(obj46, "visitBind", &meth_ast_visitBind174, 50);
  int argcv_meth_ast_visitBind174[] = {1};
  meth_meth_ast_visitBind174->type = alloc_MethodType(1, argcv_meth_ast_visitBind174);
  meth_meth_ast_visitBind174->definitionModule = modulename;
  meth_meth_ast_visitBind174->definitionLine = 2412;
// method visitDefDec
  struct UserObject *uo176 = (struct UserObject*)obj46;
  uo176->data[51] = emptyclosure;
  Method *meth_meth_ast_visitDefDec176 = addmethod2pos(obj46, "visitDefDec", &meth_ast_visitDefDec176, 51);
  int argcv_meth_ast_visitDefDec176[] = {1};
  meth_meth_ast_visitDefDec176->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec176);
  meth_meth_ast_visitDefDec176->definitionModule = modulename;
  meth_meth_ast_visitDefDec176->definitionLine = 2413;
// method visitVarDec
  struct UserObject *uo178 = (struct UserObject*)obj46;
  uo178->data[52] = emptyclosure;
  Method *meth_meth_ast_visitVarDec178 = addmethod2pos(obj46, "visitVarDec", &meth_ast_visitVarDec178, 52);
  int argcv_meth_ast_visitVarDec178[] = {1};
  meth_meth_ast_visitVarDec178->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec178);
  meth_meth_ast_visitVarDec178->definitionModule = modulename;
  meth_meth_ast_visitVarDec178->definitionLine = 2414;
// method visitImport
  struct UserObject *uo180 = (struct UserObject*)obj46;
  uo180->data[53] = emptyclosure;
  Method *meth_meth_ast_visitImport180 = addmethod2pos(obj46, "visitImport", &meth_ast_visitImport180, 53);
  int argcv_meth_ast_visitImport180[] = {1};
  meth_meth_ast_visitImport180->type = alloc_MethodType(1, argcv_meth_ast_visitImport180);
  meth_meth_ast_visitImport180->definitionModule = modulename;
  meth_meth_ast_visitImport180->definitionLine = 2415;
// method visitReturn
  struct UserObject *uo182 = (struct UserObject*)obj46;
  uo182->data[54] = emptyclosure;
  Method *meth_meth_ast_visitReturn182 = addmethod2pos(obj46, "visitReturn", &meth_ast_visitReturn182, 54);
  int argcv_meth_ast_visitReturn182[] = {1};
  meth_meth_ast_visitReturn182->type = alloc_MethodType(1, argcv_meth_ast_visitReturn182);
  meth_meth_ast_visitReturn182->definitionModule = modulename;
  meth_meth_ast_visitReturn182->definitionLine = 2416;
// method visitInherits
  struct UserObject *uo184 = (struct UserObject*)obj46;
  uo184->data[55] = emptyclosure;
  Method *meth_meth_ast_visitInherits184 = addmethod2pos(obj46, "visitInherits", &meth_ast_visitInherits184, 55);
  int argcv_meth_ast_visitInherits184[] = {1};
  meth_meth_ast_visitInherits184->type = alloc_MethodType(1, argcv_meth_ast_visitInherits184);
  meth_meth_ast_visitInherits184->definitionModule = modulename;
  meth_meth_ast_visitInherits184->definitionLine = 2417;
// method visitDialect
  struct UserObject *uo186 = (struct UserObject*)obj46;
  uo186->data[56] = emptyclosure;
  Method *meth_meth_ast_visitDialect186 = addmethod2pos(obj46, "visitDialect", &meth_ast_visitDialect186, 56);
  int argcv_meth_ast_visitDialect186[] = {1};
  meth_meth_ast_visitDialect186->type = alloc_MethodType(1, argcv_meth_ast_visitDialect186);
  meth_meth_ast_visitDialect186->definitionModule = modulename;
  meth_meth_ast_visitDialect186->definitionLine = 2418;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
  sourceObject = obj46;
objclass46 = obj46->class;
  objclass46->definitionModule = modulename;
  objclass46->definitionLine = 2361;
  (*(struct UserObject *)self).data[0] = lowerouter46;
  self = oldself46;
  selfslot = oldselfslot46;
  stackframe = oldstackframe46;
  gc_frame_end(frame);
  return obj46;
}
Object meth_ast_visitIdentifier_40__41_up192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIdentifier()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIdentifier()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIdentifier");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe193 = gc_frame_new();
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call194 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe193);
// compiled call node returning call194 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool195 = alloc_Boolean(1);
// compiled identifier node returning bool195 (depth = 2)
  gc_frame_end(frame);
  return bool195;
}
Object meth_ast_visitMethod_40__41_up196(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethod()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethod()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethod");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe197 = gc_frame_new();
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call198 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe197);
// compiled call node returning call198 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool199 = alloc_Boolean(1);
// compiled identifier node returning bool199 (depth = 2)
  gc_frame_end(frame);
  return bool199;
}
Object meth_ast_visitBlock_40__41_up200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBlock()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBlock()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBlock");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe201 = gc_frame_new();
// Begin line 2424
  setline(2424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call202 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe201);
// compiled call node returning call202 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool203 = alloc_Boolean(1);
// compiled identifier node returning bool203 (depth = 2)
  gc_frame_end(frame);
  return bool203;
}
Object meth_ast_visitClass_40__41_up204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitClass()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitClass()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitClass");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe205 = gc_frame_new();
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call206 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe205);
// compiled call node returning call206 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool207 = alloc_Boolean(1);
// compiled identifier node returning bool207 (depth = 2)
  gc_frame_end(frame);
  return bool207;
}
Object meth_ast_visitObject_40__41_up208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitObject()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitObject()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitObject");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe209 = gc_frame_new();
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call210 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe209);
// compiled call node returning call210 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool211 = alloc_Boolean(1);
// compiled identifier node returning bool211 (depth = 2)
  gc_frame_end(frame);
  return bool211;
}
Object meth_ast_visitIf_40__41_up212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIf()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIf()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIf");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe213 = gc_frame_new();
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call214 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe213);
// compiled call node returning call214 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool215 = alloc_Boolean(1);
// compiled identifier node returning bool215 (depth = 2)
  gc_frame_end(frame);
  return bool215;
}
Object meth_ast_visitMatchCase_40__41_up216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMatchCase");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe217 = gc_frame_new();
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call218 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe217);
// compiled call node returning call218 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool219 = alloc_Boolean(1);
// compiled identifier node returning bool219 (depth = 2)
  gc_frame_end(frame);
  return bool219;
}
Object meth_ast_visitCatchCase_40__41_up220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCatchCase()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCatchCase()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCatchCase");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe221 = gc_frame_new();
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call222 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe221);
// compiled call node returning call222 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool223 = alloc_Boolean(1);
// compiled identifier node returning bool223 (depth = 2)
  gc_frame_end(frame);
  return bool223;
}
Object meth_ast_visitMethodType_40__41_up224(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMethodType()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMethodType()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMethodType");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe225 = gc_frame_new();
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call226 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe225);
// compiled call node returning call226 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool227 = alloc_Boolean(1);
// compiled identifier node returning bool227 (depth = 2)
  gc_frame_end(frame);
  return bool227;
}
Object meth_ast_visitSignaturePart_40__41_up228(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitSignaturePart()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitSignaturePart()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitSignaturePart()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitSignaturePart");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe229 = gc_frame_new();
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call230 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe229);
// compiled call node returning call230 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool231 = alloc_Boolean(1);
// compiled identifier node returning bool231 (depth = 2)
  gc_frame_end(frame);
  return bool231;
}
Object meth_ast_visitTypeDec_40__41_up232(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeDec");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe233 = gc_frame_new();
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call234 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe233);
// compiled call node returning call234 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool235 = alloc_Boolean(1);
// compiled identifier node returning bool235 (depth = 2)
  gc_frame_end(frame);
  return bool235;
}
Object meth_ast_visitTypeLiteral_40__41_up236(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitTypeLiteral()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitTypeLiteral()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitTypeLiteral()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitTypeLiteral");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe237 = gc_frame_new();
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call238 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe237);
// compiled call node returning call238 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool239 = alloc_Boolean(1);
// compiled identifier node returning bool239 (depth = 2)
  gc_frame_end(frame);
  return bool239;
}
Object meth_ast_visitCall_40__41_up240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe241 = gc_frame_new();
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call242 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe241);
// compiled call node returning call242 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool243 = alloc_Boolean(1);
// compiled identifier node returning bool243 (depth = 2)
  gc_frame_end(frame);
  return bool243;
}
Object meth_ast_visitArray_40__41_up244(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitArray()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitArray()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitArray");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe245 = gc_frame_new();
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call246 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe245);
// compiled call node returning call246 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool247 = alloc_Boolean(1);
// compiled identifier node returning bool247 (depth = 2)
  gc_frame_end(frame);
  return bool247;
}
Object meth_ast_visitMember_40__41_up248(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitMember()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitMember()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitMember");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe249 = gc_frame_new();
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call250 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe249);
// compiled call node returning call250 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool251 = alloc_Boolean(1);
// compiled identifier node returning bool251 (depth = 2)
  gc_frame_end(frame);
  return bool251;
}
Object meth_ast_visitGeneric_40__41_up252(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitGeneric()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitGeneric()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitGeneric");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe253 = gc_frame_new();
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call254 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe253);
// compiled call node returning call254 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool255 = alloc_Boolean(1);
// compiled identifier node returning bool255 (depth = 2)
  gc_frame_end(frame);
  return bool255;
}
Object meth_ast_visitOctets_40__41_up256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOctets()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOctets()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitOctets()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitOctets()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOctets");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe257 = gc_frame_new();
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call258 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe257);
// compiled call node returning call258 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool259 = alloc_Boolean(1);
// compiled identifier node returning bool259 (depth = 2)
  gc_frame_end(frame);
  return bool259;
}
Object meth_ast_visitString_40__41_up260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitString()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitString()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitString()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitString");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe261 = gc_frame_new();
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call262 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe261);
// compiled call node returning call262 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool263 = alloc_Boolean(1);
// compiled identifier node returning bool263 (depth = 2)
  gc_frame_end(frame);
  return bool263;
}
Object meth_ast_visitNum_40__41_up264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitNum()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitNum()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitNum");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe265 = gc_frame_new();
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call266 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe265);
// compiled call node returning call266 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool267 = alloc_Boolean(1);
// compiled identifier node returning bool267 (depth = 2)
  gc_frame_end(frame);
  return bool267;
}
Object meth_ast_visitOp_40__41_up268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitOp()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitOp()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitOp");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe269 = gc_frame_new();
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call270 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe269);
// compiled call node returning call270 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool271 = alloc_Boolean(1);
// compiled identifier node returning bool271 (depth = 2)
  gc_frame_end(frame);
  return bool271;
}
Object meth_ast_visitIndex_40__41_up272(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitIndex()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitIndex()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitIndex");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe273 = gc_frame_new();
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call274 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe273);
// compiled call node returning call274 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool275 = alloc_Boolean(1);
// compiled identifier node returning bool275 (depth = 2)
  gc_frame_end(frame);
  return bool275;
}
Object meth_ast_visitBind_40__41_up276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitBind()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitBind()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitBind");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe277 = gc_frame_new();
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call278 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe277);
// compiled call node returning call278 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool279 = alloc_Boolean(1);
// compiled identifier node returning bool279 (depth = 2)
  gc_frame_end(frame);
  return bool279;
}
Object meth_ast_visitDefDec_40__41_up280(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDefDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDefDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDefDec");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe281 = gc_frame_new();
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call282 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe281);
// compiled call node returning call282 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool283 = alloc_Boolean(1);
// compiled identifier node returning bool283 (depth = 2)
  gc_frame_end(frame);
  return bool283;
}
Object meth_ast_visitVarDec_40__41_up284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitVarDec()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitVarDec()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitVarDec");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe285 = gc_frame_new();
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call286 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe285);
// compiled call node returning call286 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool287 = alloc_Boolean(1);
// compiled identifier node returning bool287 (depth = 2)
  gc_frame_end(frame);
  return bool287;
}
Object meth_ast_visitImport_40__41_up288(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitImport()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitImport()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitImport");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe289 = gc_frame_new();
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call290 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe289);
// compiled call node returning call290 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool291 = alloc_Boolean(1);
// compiled identifier node returning bool291 (depth = 2)
  gc_frame_end(frame);
  return bool291;
}
Object meth_ast_visitReturn_40__41_up292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitReturn()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitReturn()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitReturn");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe293 = gc_frame_new();
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call294 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe293);
// compiled call node returning call294 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool295 = alloc_Boolean(1);
// compiled identifier node returning bool295 (depth = 2)
  gc_frame_end(frame);
  return bool295;
}
Object meth_ast_visitInherits_40__41_up296(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitInherits()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitInherits()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitInherits");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe297 = gc_frame_new();
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call298 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe297);
// compiled call node returning call298 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool299 = alloc_Boolean(1);
// compiled identifier node returning bool299 (depth = 2)
  gc_frame_end(frame);
  return bool299;
}
Object meth_ast_visitDialect_40__41_up300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitDialect()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitDialect()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitDialect");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe301 = gc_frame_new();
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pNode (depth = 4)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = *var_pNode;
  partcv[0] = 1;
  Object call302 = callmethod(*var_o, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe301);
// compiled call node returning call302 (depth = 3)
// compiled bind node returning done (depth = 2)
// starting to compile identifier node (depth = 2)
  Object bool303 = alloc_Boolean(1);
// compiled identifier node returning bool303 (depth = 2)
  gc_frame_end(frame);
  return bool303;
}
Object meth_ast_addParentVisitor189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addParentVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addParentVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for addParentVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject190 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj190 = alloc_userobj2(28,29, objclass190);
  gc_frame_newslot(obj190);
if (objclass190 == NULL) {
  glfree(obj190->class->name);
  obj190->class->name = "self.addParentVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj190, self, 0);
  addmethodreal(obj190,"outer", &reader_ast_outer_191);
  Object oldself190 = self;
  struct StackFrameObject *oldstackframe190 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe190);
  gc_frame_newslot((Object)stackframe);
  self = obj190;
  Object *oldselfslot190 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter190 = (*(struct UserObject *)self).data[0], lowerouter190 = thisouter190;
  if (inheritingObject190) {
    struct UserObject *inho190 = (struct UserObject *)inheritingObject190;
    while (inho190->super != GraceDefaultObject) inho190 = (struct UserObject *)inho190->super;
    inho190->super = obj190;
    self = inheritingObject190;
    *selfslot = self;
    lowerouter190 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter190;
  }
// method visitIdentifier()up
  struct UserObject *uo192 = (struct UserObject*)obj190;
  uo192->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up192 = addmethod2pos(obj190, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up192, 1);
  int argcv_meth_ast_visitIdentifier_40__41_up192[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up192->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up192);
  meth_meth_ast_visitIdentifier_40__41_up192->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up192->definitionLine = 2422;
// method visitMethod()up
  struct UserObject *uo196 = (struct UserObject*)obj190;
  uo196->data[2] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up196 = addmethod2pos(obj190, "visitMethod()up", &meth_ast_visitMethod_40__41_up196, 2);
  int argcv_meth_ast_visitMethod_40__41_up196[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up196->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up196);
  meth_meth_ast_visitMethod_40__41_up196->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up196->definitionLine = 2423;
// method visitBlock()up
  struct UserObject *uo200 = (struct UserObject*)obj190;
  uo200->data[3] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up200 = addmethod2pos(obj190, "visitBlock()up", &meth_ast_visitBlock_40__41_up200, 3);
  int argcv_meth_ast_visitBlock_40__41_up200[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up200->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up200);
  meth_meth_ast_visitBlock_40__41_up200->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up200->definitionLine = 2424;
// method visitClass()up
  struct UserObject *uo204 = (struct UserObject*)obj190;
  uo204->data[4] = emptyclosure;
  Method *meth_meth_ast_visitClass_40__41_up204 = addmethod2pos(obj190, "visitClass()up", &meth_ast_visitClass_40__41_up204, 4);
  int argcv_meth_ast_visitClass_40__41_up204[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up204->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up204);
  meth_meth_ast_visitClass_40__41_up204->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up204->definitionLine = 2425;
// method visitObject()up
  struct UserObject *uo208 = (struct UserObject*)obj190;
  uo208->data[5] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up208 = addmethod2pos(obj190, "visitObject()up", &meth_ast_visitObject_40__41_up208, 5);
  int argcv_meth_ast_visitObject_40__41_up208[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up208->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up208);
  meth_meth_ast_visitObject_40__41_up208->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up208->definitionLine = 2426;
// method visitIf()up
  struct UserObject *uo212 = (struct UserObject*)obj190;
  uo212->data[6] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up212 = addmethod2pos(obj190, "visitIf()up", &meth_ast_visitIf_40__41_up212, 6);
  int argcv_meth_ast_visitIf_40__41_up212[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up212->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up212);
  meth_meth_ast_visitIf_40__41_up212->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up212->definitionLine = 2427;
// method visitMatchCase()up
  struct UserObject *uo216 = (struct UserObject*)obj190;
  uo216->data[7] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up216 = addmethod2pos(obj190, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up216, 7);
  int argcv_meth_ast_visitMatchCase_40__41_up216[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up216->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up216);
  meth_meth_ast_visitMatchCase_40__41_up216->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up216->definitionLine = 2428;
// method visitCatchCase()up
  struct UserObject *uo220 = (struct UserObject*)obj190;
  uo220->data[8] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase_40__41_up220 = addmethod2pos(obj190, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up220, 8);
  int argcv_meth_ast_visitCatchCase_40__41_up220[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up220->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up220);
  meth_meth_ast_visitCatchCase_40__41_up220->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up220->definitionLine = 2429;
// method visitMethodType()up
  struct UserObject *uo224 = (struct UserObject*)obj190;
  uo224->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up224 = addmethod2pos(obj190, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up224, 9);
  int argcv_meth_ast_visitMethodType_40__41_up224[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up224->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up224);
  meth_meth_ast_visitMethodType_40__41_up224->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up224->definitionLine = 2430;
// method visitSignaturePart()up
  struct UserObject *uo228 = (struct UserObject*)obj190;
  uo228->data[10] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up228 = addmethod2pos(obj190, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up228, 10);
  int argcv_meth_ast_visitSignaturePart_40__41_up228[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up228->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up228);
  meth_meth_ast_visitSignaturePart_40__41_up228->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up228->definitionLine = 2431;
// method visitTypeDec()up
  struct UserObject *uo232 = (struct UserObject*)obj190;
  uo232->data[11] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up232 = addmethod2pos(obj190, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up232, 11);
  int argcv_meth_ast_visitTypeDec_40__41_up232[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up232->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up232);
  meth_meth_ast_visitTypeDec_40__41_up232->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up232->definitionLine = 2432;
// method visitTypeLiteral()up
  struct UserObject *uo236 = (struct UserObject*)obj190;
  uo236->data[12] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up236 = addmethod2pos(obj190, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up236, 12);
  int argcv_meth_ast_visitTypeLiteral_40__41_up236[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up236->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up236);
  meth_meth_ast_visitTypeLiteral_40__41_up236->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up236->definitionLine = 2433;
// method visitCall()up
  struct UserObject *uo240 = (struct UserObject*)obj190;
  uo240->data[13] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up240 = addmethod2pos(obj190, "visitCall()up", &meth_ast_visitCall_40__41_up240, 13);
  int argcv_meth_ast_visitCall_40__41_up240[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up240->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up240);
  meth_meth_ast_visitCall_40__41_up240->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up240->definitionLine = 2434;
// method visitArray()up
  struct UserObject *uo244 = (struct UserObject*)obj190;
  uo244->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up244 = addmethod2pos(obj190, "visitArray()up", &meth_ast_visitArray_40__41_up244, 14);
  int argcv_meth_ast_visitArray_40__41_up244[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up244->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up244);
  meth_meth_ast_visitArray_40__41_up244->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up244->definitionLine = 2435;
// method visitMember()up
  struct UserObject *uo248 = (struct UserObject*)obj190;
  uo248->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up248 = addmethod2pos(obj190, "visitMember()up", &meth_ast_visitMember_40__41_up248, 15);
  int argcv_meth_ast_visitMember_40__41_up248[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up248->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up248);
  meth_meth_ast_visitMember_40__41_up248->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up248->definitionLine = 2436;
// method visitGeneric()up
  struct UserObject *uo252 = (struct UserObject*)obj190;
  uo252->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up252 = addmethod2pos(obj190, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up252, 16);
  int argcv_meth_ast_visitGeneric_40__41_up252[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up252->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up252);
  meth_meth_ast_visitGeneric_40__41_up252->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up252->definitionLine = 2437;
// method visitOctets()up
  struct UserObject *uo256 = (struct UserObject*)obj190;
  uo256->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets_40__41_up256 = addmethod2pos(obj190, "visitOctets()up", &meth_ast_visitOctets_40__41_up256, 17);
  int argcv_meth_ast_visitOctets_40__41_up256[] = {1, 1};
  meth_meth_ast_visitOctets_40__41_up256->type = alloc_MethodType(2, argcv_meth_ast_visitOctets_40__41_up256);
  meth_meth_ast_visitOctets_40__41_up256->definitionModule = modulename;
  meth_meth_ast_visitOctets_40__41_up256->definitionLine = 2438;
// method visitString()up
  struct UserObject *uo260 = (struct UserObject*)obj190;
  uo260->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up260 = addmethod2pos(obj190, "visitString()up", &meth_ast_visitString_40__41_up260, 18);
  int argcv_meth_ast_visitString_40__41_up260[] = {1, 1};
  meth_meth_ast_visitString_40__41_up260->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up260);
  meth_meth_ast_visitString_40__41_up260->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up260->definitionLine = 2439;
// method visitNum()up
  struct UserObject *uo264 = (struct UserObject*)obj190;
  uo264->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up264 = addmethod2pos(obj190, "visitNum()up", &meth_ast_visitNum_40__41_up264, 19);
  int argcv_meth_ast_visitNum_40__41_up264[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up264->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up264);
  meth_meth_ast_visitNum_40__41_up264->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up264->definitionLine = 2440;
// method visitOp()up
  struct UserObject *uo268 = (struct UserObject*)obj190;
  uo268->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up268 = addmethod2pos(obj190, "visitOp()up", &meth_ast_visitOp_40__41_up268, 20);
  int argcv_meth_ast_visitOp_40__41_up268[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up268->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up268);
  meth_meth_ast_visitOp_40__41_up268->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up268->definitionLine = 2441;
// method visitIndex()up
  struct UserObject *uo272 = (struct UserObject*)obj190;
  uo272->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up272 = addmethod2pos(obj190, "visitIndex()up", &meth_ast_visitIndex_40__41_up272, 21);
  int argcv_meth_ast_visitIndex_40__41_up272[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up272->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up272);
  meth_meth_ast_visitIndex_40__41_up272->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up272->definitionLine = 2442;
// method visitBind()up
  struct UserObject *uo276 = (struct UserObject*)obj190;
  uo276->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up276 = addmethod2pos(obj190, "visitBind()up", &meth_ast_visitBind_40__41_up276, 22);
  int argcv_meth_ast_visitBind_40__41_up276[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up276->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up276);
  meth_meth_ast_visitBind_40__41_up276->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up276->definitionLine = 2443;
// method visitDefDec()up
  struct UserObject *uo280 = (struct UserObject*)obj190;
  uo280->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up280 = addmethod2pos(obj190, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up280, 23);
  int argcv_meth_ast_visitDefDec_40__41_up280[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up280->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up280);
  meth_meth_ast_visitDefDec_40__41_up280->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up280->definitionLine = 2444;
// method visitVarDec()up
  struct UserObject *uo284 = (struct UserObject*)obj190;
  uo284->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up284 = addmethod2pos(obj190, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up284, 24);
  int argcv_meth_ast_visitVarDec_40__41_up284[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up284->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up284);
  meth_meth_ast_visitVarDec_40__41_up284->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up284->definitionLine = 2445;
// method visitImport()up
  struct UserObject *uo288 = (struct UserObject*)obj190;
  uo288->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up288 = addmethod2pos(obj190, "visitImport()up", &meth_ast_visitImport_40__41_up288, 25);
  int argcv_meth_ast_visitImport_40__41_up288[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up288->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up288);
  meth_meth_ast_visitImport_40__41_up288->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up288->definitionLine = 2446;
// method visitReturn()up
  struct UserObject *uo292 = (struct UserObject*)obj190;
  uo292->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up292 = addmethod2pos(obj190, "visitReturn()up", &meth_ast_visitReturn_40__41_up292, 26);
  int argcv_meth_ast_visitReturn_40__41_up292[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up292->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up292);
  meth_meth_ast_visitReturn_40__41_up292->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up292->definitionLine = 2447;
// method visitInherits()up
  struct UserObject *uo296 = (struct UserObject*)obj190;
  uo296->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up296 = addmethod2pos(obj190, "visitInherits()up", &meth_ast_visitInherits_40__41_up296, 27);
  int argcv_meth_ast_visitInherits_40__41_up296[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up296->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up296);
  meth_meth_ast_visitInherits_40__41_up296->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up296->definitionLine = 2448;
// method visitDialect()up
  struct UserObject *uo300 = (struct UserObject*)obj190;
  uo300->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up300 = addmethod2pos(obj190, "visitDialect()up", &meth_ast_visitDialect_40__41_up300, 28);
  int argcv_meth_ast_visitDialect_40__41_up300[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up300->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up300);
  meth_meth_ast_visitDialect_40__41_up300->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up300->definitionLine = 2449;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
objclass190 = obj190->class;
  objclass190->definitionModule = modulename;
  objclass190->definitionLine = 2421;
  (*(struct UserObject *)self).data[0] = lowerouter190;
  self = oldself190;
  selfslot = oldselfslot190;
  stackframe = oldstackframe190;
  gc_frame_end(frame);
  return obj190;
}
Object meth_ast_addParentVisitor189_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addParentVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for addParentVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for addParentVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject190 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj190 = alloc_userobj2(28,29, objclass190);
  gc_frame_newslot(obj190);
if (objclass190 == NULL) {
  glfree(obj190->class->name);
  obj190->class->name = "self.addParentVisitor";
}
// OBJECT OUTER DEC outer
  adddatum2(obj190, self, 0);
  addmethodreal(obj190,"outer", &reader_ast_outer_191);
  Object oldself190 = self;
  struct StackFrameObject *oldstackframe190 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe190);
  gc_frame_newslot((Object)stackframe);
  self = obj190;
  Object *oldselfslot190 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter190 = (*(struct UserObject *)self).data[0], lowerouter190 = thisouter190;
  if (inheritingObject190) {
    struct UserObject *inho190 = (struct UserObject *)inheritingObject190;
    while (inho190->super != GraceDefaultObject) inho190 = (struct UserObject *)inho190->super;
    inho190->super = obj190;
    self = inheritingObject190;
    *selfslot = self;
    lowerouter190 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter190;
  }
// method visitIdentifier()up
  struct UserObject *uo192 = (struct UserObject*)obj190;
  uo192->data[1] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier_40__41_up192 = addmethod2pos(obj190, "visitIdentifier()up", &meth_ast_visitIdentifier_40__41_up192, 1);
  int argcv_meth_ast_visitIdentifier_40__41_up192[] = {1, 1};
  meth_meth_ast_visitIdentifier_40__41_up192->type = alloc_MethodType(2, argcv_meth_ast_visitIdentifier_40__41_up192);
  meth_meth_ast_visitIdentifier_40__41_up192->definitionModule = modulename;
  meth_meth_ast_visitIdentifier_40__41_up192->definitionLine = 2422;
// method visitMethod()up
  struct UserObject *uo196 = (struct UserObject*)obj190;
  uo196->data[2] = emptyclosure;
  Method *meth_meth_ast_visitMethod_40__41_up196 = addmethod2pos(obj190, "visitMethod()up", &meth_ast_visitMethod_40__41_up196, 2);
  int argcv_meth_ast_visitMethod_40__41_up196[] = {1, 1};
  meth_meth_ast_visitMethod_40__41_up196->type = alloc_MethodType(2, argcv_meth_ast_visitMethod_40__41_up196);
  meth_meth_ast_visitMethod_40__41_up196->definitionModule = modulename;
  meth_meth_ast_visitMethod_40__41_up196->definitionLine = 2423;
// method visitBlock()up
  struct UserObject *uo200 = (struct UserObject*)obj190;
  uo200->data[3] = emptyclosure;
  Method *meth_meth_ast_visitBlock_40__41_up200 = addmethod2pos(obj190, "visitBlock()up", &meth_ast_visitBlock_40__41_up200, 3);
  int argcv_meth_ast_visitBlock_40__41_up200[] = {1, 1};
  meth_meth_ast_visitBlock_40__41_up200->type = alloc_MethodType(2, argcv_meth_ast_visitBlock_40__41_up200);
  meth_meth_ast_visitBlock_40__41_up200->definitionModule = modulename;
  meth_meth_ast_visitBlock_40__41_up200->definitionLine = 2424;
// method visitClass()up
  struct UserObject *uo204 = (struct UserObject*)obj190;
  uo204->data[4] = emptyclosure;
  Method *meth_meth_ast_visitClass_40__41_up204 = addmethod2pos(obj190, "visitClass()up", &meth_ast_visitClass_40__41_up204, 4);
  int argcv_meth_ast_visitClass_40__41_up204[] = {1, 1};
  meth_meth_ast_visitClass_40__41_up204->type = alloc_MethodType(2, argcv_meth_ast_visitClass_40__41_up204);
  meth_meth_ast_visitClass_40__41_up204->definitionModule = modulename;
  meth_meth_ast_visitClass_40__41_up204->definitionLine = 2425;
// method visitObject()up
  struct UserObject *uo208 = (struct UserObject*)obj190;
  uo208->data[5] = emptyclosure;
  Method *meth_meth_ast_visitObject_40__41_up208 = addmethod2pos(obj190, "visitObject()up", &meth_ast_visitObject_40__41_up208, 5);
  int argcv_meth_ast_visitObject_40__41_up208[] = {1, 1};
  meth_meth_ast_visitObject_40__41_up208->type = alloc_MethodType(2, argcv_meth_ast_visitObject_40__41_up208);
  meth_meth_ast_visitObject_40__41_up208->definitionModule = modulename;
  meth_meth_ast_visitObject_40__41_up208->definitionLine = 2426;
// method visitIf()up
  struct UserObject *uo212 = (struct UserObject*)obj190;
  uo212->data[6] = emptyclosure;
  Method *meth_meth_ast_visitIf_40__41_up212 = addmethod2pos(obj190, "visitIf()up", &meth_ast_visitIf_40__41_up212, 6);
  int argcv_meth_ast_visitIf_40__41_up212[] = {1, 1};
  meth_meth_ast_visitIf_40__41_up212->type = alloc_MethodType(2, argcv_meth_ast_visitIf_40__41_up212);
  meth_meth_ast_visitIf_40__41_up212->definitionModule = modulename;
  meth_meth_ast_visitIf_40__41_up212->definitionLine = 2427;
// method visitMatchCase()up
  struct UserObject *uo216 = (struct UserObject*)obj190;
  uo216->data[7] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase_40__41_up216 = addmethod2pos(obj190, "visitMatchCase()up", &meth_ast_visitMatchCase_40__41_up216, 7);
  int argcv_meth_ast_visitMatchCase_40__41_up216[] = {1, 1};
  meth_meth_ast_visitMatchCase_40__41_up216->type = alloc_MethodType(2, argcv_meth_ast_visitMatchCase_40__41_up216);
  meth_meth_ast_visitMatchCase_40__41_up216->definitionModule = modulename;
  meth_meth_ast_visitMatchCase_40__41_up216->definitionLine = 2428;
// method visitCatchCase()up
  struct UserObject *uo220 = (struct UserObject*)obj190;
  uo220->data[8] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase_40__41_up220 = addmethod2pos(obj190, "visitCatchCase()up", &meth_ast_visitCatchCase_40__41_up220, 8);
  int argcv_meth_ast_visitCatchCase_40__41_up220[] = {1, 1};
  meth_meth_ast_visitCatchCase_40__41_up220->type = alloc_MethodType(2, argcv_meth_ast_visitCatchCase_40__41_up220);
  meth_meth_ast_visitCatchCase_40__41_up220->definitionModule = modulename;
  meth_meth_ast_visitCatchCase_40__41_up220->definitionLine = 2429;
// method visitMethodType()up
  struct UserObject *uo224 = (struct UserObject*)obj190;
  uo224->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethodType_40__41_up224 = addmethod2pos(obj190, "visitMethodType()up", &meth_ast_visitMethodType_40__41_up224, 9);
  int argcv_meth_ast_visitMethodType_40__41_up224[] = {1, 1};
  meth_meth_ast_visitMethodType_40__41_up224->type = alloc_MethodType(2, argcv_meth_ast_visitMethodType_40__41_up224);
  meth_meth_ast_visitMethodType_40__41_up224->definitionModule = modulename;
  meth_meth_ast_visitMethodType_40__41_up224->definitionLine = 2430;
// method visitSignaturePart()up
  struct UserObject *uo228 = (struct UserObject*)obj190;
  uo228->data[10] = emptyclosure;
  Method *meth_meth_ast_visitSignaturePart_40__41_up228 = addmethod2pos(obj190, "visitSignaturePart()up", &meth_ast_visitSignaturePart_40__41_up228, 10);
  int argcv_meth_ast_visitSignaturePart_40__41_up228[] = {1, 1};
  meth_meth_ast_visitSignaturePart_40__41_up228->type = alloc_MethodType(2, argcv_meth_ast_visitSignaturePart_40__41_up228);
  meth_meth_ast_visitSignaturePart_40__41_up228->definitionModule = modulename;
  meth_meth_ast_visitSignaturePart_40__41_up228->definitionLine = 2431;
// method visitTypeDec()up
  struct UserObject *uo232 = (struct UserObject*)obj190;
  uo232->data[11] = emptyclosure;
  Method *meth_meth_ast_visitTypeDec_40__41_up232 = addmethod2pos(obj190, "visitTypeDec()up", &meth_ast_visitTypeDec_40__41_up232, 11);
  int argcv_meth_ast_visitTypeDec_40__41_up232[] = {1, 1};
  meth_meth_ast_visitTypeDec_40__41_up232->type = alloc_MethodType(2, argcv_meth_ast_visitTypeDec_40__41_up232);
  meth_meth_ast_visitTypeDec_40__41_up232->definitionModule = modulename;
  meth_meth_ast_visitTypeDec_40__41_up232->definitionLine = 2432;
// method visitTypeLiteral()up
  struct UserObject *uo236 = (struct UserObject*)obj190;
  uo236->data[12] = emptyclosure;
  Method *meth_meth_ast_visitTypeLiteral_40__41_up236 = addmethod2pos(obj190, "visitTypeLiteral()up", &meth_ast_visitTypeLiteral_40__41_up236, 12);
  int argcv_meth_ast_visitTypeLiteral_40__41_up236[] = {1, 1};
  meth_meth_ast_visitTypeLiteral_40__41_up236->type = alloc_MethodType(2, argcv_meth_ast_visitTypeLiteral_40__41_up236);
  meth_meth_ast_visitTypeLiteral_40__41_up236->definitionModule = modulename;
  meth_meth_ast_visitTypeLiteral_40__41_up236->definitionLine = 2433;
// method visitCall()up
  struct UserObject *uo240 = (struct UserObject*)obj190;
  uo240->data[13] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up240 = addmethod2pos(obj190, "visitCall()up", &meth_ast_visitCall_40__41_up240, 13);
  int argcv_meth_ast_visitCall_40__41_up240[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up240->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up240);
  meth_meth_ast_visitCall_40__41_up240->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up240->definitionLine = 2434;
// method visitArray()up
  struct UserObject *uo244 = (struct UserObject*)obj190;
  uo244->data[14] = emptyclosure;
  Method *meth_meth_ast_visitArray_40__41_up244 = addmethod2pos(obj190, "visitArray()up", &meth_ast_visitArray_40__41_up244, 14);
  int argcv_meth_ast_visitArray_40__41_up244[] = {1, 1};
  meth_meth_ast_visitArray_40__41_up244->type = alloc_MethodType(2, argcv_meth_ast_visitArray_40__41_up244);
  meth_meth_ast_visitArray_40__41_up244->definitionModule = modulename;
  meth_meth_ast_visitArray_40__41_up244->definitionLine = 2435;
// method visitMember()up
  struct UserObject *uo248 = (struct UserObject*)obj190;
  uo248->data[15] = emptyclosure;
  Method *meth_meth_ast_visitMember_40__41_up248 = addmethod2pos(obj190, "visitMember()up", &meth_ast_visitMember_40__41_up248, 15);
  int argcv_meth_ast_visitMember_40__41_up248[] = {1, 1};
  meth_meth_ast_visitMember_40__41_up248->type = alloc_MethodType(2, argcv_meth_ast_visitMember_40__41_up248);
  meth_meth_ast_visitMember_40__41_up248->definitionModule = modulename;
  meth_meth_ast_visitMember_40__41_up248->definitionLine = 2436;
// method visitGeneric()up
  struct UserObject *uo252 = (struct UserObject*)obj190;
  uo252->data[16] = emptyclosure;
  Method *meth_meth_ast_visitGeneric_40__41_up252 = addmethod2pos(obj190, "visitGeneric()up", &meth_ast_visitGeneric_40__41_up252, 16);
  int argcv_meth_ast_visitGeneric_40__41_up252[] = {1, 1};
  meth_meth_ast_visitGeneric_40__41_up252->type = alloc_MethodType(2, argcv_meth_ast_visitGeneric_40__41_up252);
  meth_meth_ast_visitGeneric_40__41_up252->definitionModule = modulename;
  meth_meth_ast_visitGeneric_40__41_up252->definitionLine = 2437;
// method visitOctets()up
  struct UserObject *uo256 = (struct UserObject*)obj190;
  uo256->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets_40__41_up256 = addmethod2pos(obj190, "visitOctets()up", &meth_ast_visitOctets_40__41_up256, 17);
  int argcv_meth_ast_visitOctets_40__41_up256[] = {1, 1};
  meth_meth_ast_visitOctets_40__41_up256->type = alloc_MethodType(2, argcv_meth_ast_visitOctets_40__41_up256);
  meth_meth_ast_visitOctets_40__41_up256->definitionModule = modulename;
  meth_meth_ast_visitOctets_40__41_up256->definitionLine = 2438;
// method visitString()up
  struct UserObject *uo260 = (struct UserObject*)obj190;
  uo260->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString_40__41_up260 = addmethod2pos(obj190, "visitString()up", &meth_ast_visitString_40__41_up260, 18);
  int argcv_meth_ast_visitString_40__41_up260[] = {1, 1};
  meth_meth_ast_visitString_40__41_up260->type = alloc_MethodType(2, argcv_meth_ast_visitString_40__41_up260);
  meth_meth_ast_visitString_40__41_up260->definitionModule = modulename;
  meth_meth_ast_visitString_40__41_up260->definitionLine = 2439;
// method visitNum()up
  struct UserObject *uo264 = (struct UserObject*)obj190;
  uo264->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum_40__41_up264 = addmethod2pos(obj190, "visitNum()up", &meth_ast_visitNum_40__41_up264, 19);
  int argcv_meth_ast_visitNum_40__41_up264[] = {1, 1};
  meth_meth_ast_visitNum_40__41_up264->type = alloc_MethodType(2, argcv_meth_ast_visitNum_40__41_up264);
  meth_meth_ast_visitNum_40__41_up264->definitionModule = modulename;
  meth_meth_ast_visitNum_40__41_up264->definitionLine = 2440;
// method visitOp()up
  struct UserObject *uo268 = (struct UserObject*)obj190;
  uo268->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp_40__41_up268 = addmethod2pos(obj190, "visitOp()up", &meth_ast_visitOp_40__41_up268, 20);
  int argcv_meth_ast_visitOp_40__41_up268[] = {1, 1};
  meth_meth_ast_visitOp_40__41_up268->type = alloc_MethodType(2, argcv_meth_ast_visitOp_40__41_up268);
  meth_meth_ast_visitOp_40__41_up268->definitionModule = modulename;
  meth_meth_ast_visitOp_40__41_up268->definitionLine = 2441;
// method visitIndex()up
  struct UserObject *uo272 = (struct UserObject*)obj190;
  uo272->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex_40__41_up272 = addmethod2pos(obj190, "visitIndex()up", &meth_ast_visitIndex_40__41_up272, 21);
  int argcv_meth_ast_visitIndex_40__41_up272[] = {1, 1};
  meth_meth_ast_visitIndex_40__41_up272->type = alloc_MethodType(2, argcv_meth_ast_visitIndex_40__41_up272);
  meth_meth_ast_visitIndex_40__41_up272->definitionModule = modulename;
  meth_meth_ast_visitIndex_40__41_up272->definitionLine = 2442;
// method visitBind()up
  struct UserObject *uo276 = (struct UserObject*)obj190;
  uo276->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind_40__41_up276 = addmethod2pos(obj190, "visitBind()up", &meth_ast_visitBind_40__41_up276, 22);
  int argcv_meth_ast_visitBind_40__41_up276[] = {1, 1};
  meth_meth_ast_visitBind_40__41_up276->type = alloc_MethodType(2, argcv_meth_ast_visitBind_40__41_up276);
  meth_meth_ast_visitBind_40__41_up276->definitionModule = modulename;
  meth_meth_ast_visitBind_40__41_up276->definitionLine = 2443;
// method visitDefDec()up
  struct UserObject *uo280 = (struct UserObject*)obj190;
  uo280->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec_40__41_up280 = addmethod2pos(obj190, "visitDefDec()up", &meth_ast_visitDefDec_40__41_up280, 23);
  int argcv_meth_ast_visitDefDec_40__41_up280[] = {1, 1};
  meth_meth_ast_visitDefDec_40__41_up280->type = alloc_MethodType(2, argcv_meth_ast_visitDefDec_40__41_up280);
  meth_meth_ast_visitDefDec_40__41_up280->definitionModule = modulename;
  meth_meth_ast_visitDefDec_40__41_up280->definitionLine = 2444;
// method visitVarDec()up
  struct UserObject *uo284 = (struct UserObject*)obj190;
  uo284->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec_40__41_up284 = addmethod2pos(obj190, "visitVarDec()up", &meth_ast_visitVarDec_40__41_up284, 24);
  int argcv_meth_ast_visitVarDec_40__41_up284[] = {1, 1};
  meth_meth_ast_visitVarDec_40__41_up284->type = alloc_MethodType(2, argcv_meth_ast_visitVarDec_40__41_up284);
  meth_meth_ast_visitVarDec_40__41_up284->definitionModule = modulename;
  meth_meth_ast_visitVarDec_40__41_up284->definitionLine = 2445;
// method visitImport()up
  struct UserObject *uo288 = (struct UserObject*)obj190;
  uo288->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport_40__41_up288 = addmethod2pos(obj190, "visitImport()up", &meth_ast_visitImport_40__41_up288, 25);
  int argcv_meth_ast_visitImport_40__41_up288[] = {1, 1};
  meth_meth_ast_visitImport_40__41_up288->type = alloc_MethodType(2, argcv_meth_ast_visitImport_40__41_up288);
  meth_meth_ast_visitImport_40__41_up288->definitionModule = modulename;
  meth_meth_ast_visitImport_40__41_up288->definitionLine = 2446;
// method visitReturn()up
  struct UserObject *uo292 = (struct UserObject*)obj190;
  uo292->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn_40__41_up292 = addmethod2pos(obj190, "visitReturn()up", &meth_ast_visitReturn_40__41_up292, 26);
  int argcv_meth_ast_visitReturn_40__41_up292[] = {1, 1};
  meth_meth_ast_visitReturn_40__41_up292->type = alloc_MethodType(2, argcv_meth_ast_visitReturn_40__41_up292);
  meth_meth_ast_visitReturn_40__41_up292->definitionModule = modulename;
  meth_meth_ast_visitReturn_40__41_up292->definitionLine = 2447;
// method visitInherits()up
  struct UserObject *uo296 = (struct UserObject*)obj190;
  uo296->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits_40__41_up296 = addmethod2pos(obj190, "visitInherits()up", &meth_ast_visitInherits_40__41_up296, 27);
  int argcv_meth_ast_visitInherits_40__41_up296[] = {1, 1};
  meth_meth_ast_visitInherits_40__41_up296->type = alloc_MethodType(2, argcv_meth_ast_visitInherits_40__41_up296);
  meth_meth_ast_visitInherits_40__41_up296->definitionModule = modulename;
  meth_meth_ast_visitInherits_40__41_up296->definitionLine = 2448;
// method visitDialect()up
  struct UserObject *uo300 = (struct UserObject*)obj190;
  uo300->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect_40__41_up300 = addmethod2pos(obj190, "visitDialect()up", &meth_ast_visitDialect_40__41_up300, 28);
  int argcv_meth_ast_visitDialect_40__41_up300[] = {1, 1};
  meth_meth_ast_visitDialect_40__41_up300->type = alloc_MethodType(2, argcv_meth_ast_visitDialect_40__41_up300);
  meth_meth_ast_visitDialect_40__41_up300->definitionModule = modulename;
  meth_meth_ast_visitDialect_40__41_up300->definitionLine = 2449;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
  sourceObject = obj190;
objclass190 = obj190->class;
  objclass190->definitionModule = modulename;
  objclass190->definitionLine = 2421;
  (*(struct UserObject *)self).data[0] = lowerouter190;
  self = oldself190;
  selfslot = oldselfslot190;
  stackframe = oldstackframe190;
  gc_frame_end(frame);
  return obj190;
}
Object meth_ast__apply314(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_annName (depth = 8)
  int op_slot_right_315 = gc_frame_newslot(*var_annName);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe317 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ann (depth = 10)
  partcv[0] = 0;
  Object call318 = callmethod(*var_ann, "value",
    1, partcv, params);
  gc_frame_end(callframe317);
// compiled call node returning call318 (depth = 9)
// compiled member node returning call318 (depth = 8)
  int op_slot_left_315 = gc_frame_newslot(call318);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult319 = callmethod(call318, "==", 1, partcv, params);
// compiled op node returning opresult319 (depth = 7)
  gc_frame_end(frame);
  return opresult319;
}
Object meth_ast__apply310(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe312 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block313 = alloc_Block(NULL, NULL, "ast", 2462);
  gc_frame_newslot(block313);
// method _apply
  block_savedest(block313);
  Object closure314 = createclosure(3, "_apply");
  setclosureframe(closure314, stackframe);
  addtoclosure(closure314, var_annName);
  addtoclosure(closure314, var_ann);
  addtoclosure(closure314, selfslot);
  struct UserObject *uo314 = (struct UserObject*)block313;
  uo314->data[0] = (Object)closure314;
  Method *meth_meth_ast__apply314 = addmethod2pos(block313, "_apply", &meth_ast__apply314, 0);
  int argcv_meth_ast__apply314[] = {0};
  meth_meth_ast__apply314->type = alloc_MethodType(1, argcv_meth_ast__apply314);
  meth_meth_ast__apply314->definitionModule = modulename;
  meth_meth_ast__apply314->definitionLine = 2461;
// compiled block node returning block313 (depth = 6)
  gc_frame_newslot(block313);
// call case 6: other member request
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit322 == NULL) {
    strlit322 = alloc_String("identifier");
    gc_root(strlit322);
  }
// compiled string node returning strlit322 (depth = 7)
  int op_slot_right_321 = gc_frame_newslot(strlit322);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ann (depth = 9)
  partcv[0] = 0;
  Object call325 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe324);
// compiled call node returning call325 (depth = 8)
// compiled member node returning call325 (depth = 7)
  int op_slot_left_321 = gc_frame_newslot(call325);
  params[0] = strlit322;
  partcv[0] = 1;
  Object opresult326 = callmethod(call325, "==", 1, partcv, params);
// compiled op node returning opresult326 (depth = 6)
  params[0] = block313;
  partcv[0] = 1;
  Object call327 = callmethod(opresult326, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe312);
// compiled call node returning call327 (depth = 5)
  Object if311 = done;
  if (istrue(call327)) {
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile object node (depth = 6)
  Object inheritingObject328 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj328 = alloc_userobj2(2,4, objclass328);
  gc_frame_newslot(obj328);
// OBJECT OUTER DEC outer
  adddatum2(obj328, self, 0);
  addmethodreal(obj328,"outer", &reader_ast_outer_329);
  Object oldself328 = self;
  struct StackFrameObject *oldstackframe328 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe328);
  gc_frame_newslot((Object)stackframe);
  self = obj328;
  Object *oldselfslot328 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter328 = (*(struct UserObject *)self).data[0], lowerouter328 = thisouter328;
  if (inheritingObject328) {
    struct UserObject *inho328 = (struct UserObject *)inheritingObject328;
    while (inho328->super != GraceDefaultObject) inho328 = (struct UserObject *)inho328->super;
    inho328->super = obj328;
    self = inheritingObject328;
    *selfslot = self;
    lowerouter328 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter328;
  }
if (objclass328 == NULL) {
  Method *reader330 = addmethodrealflags(obj328, "value",&reader_ast_value_330, MFLAG_DEF);
  reader330->definitionModule = modulename;
  reader330->definitionLine = 2467;
}
adddatum2(obj328, alloc_Undefined(), 1);
  sourceObject = obj328;
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool331 = alloc_Boolean(1);
// compiled identifier node returning bool331 (depth = 7)
  struct UserObject *obj328_uo = (struct UserObject *)obj328;
  obj328_uo->super = bool331;
  sourceObject = obj328;
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ann (depth = 7)
  adddatum2(obj328, *var_ann, 1);
objclass328 = obj328->class;
  objclass328->definitionModule = modulename;
  objclass328->definitionLine = 2464;
  (*(struct UserObject *)self).data[0] = lowerouter328;
  self = oldself328;
  selfslot = oldselfslot328;
  stackframe = oldstackframe328;
// compiled object node returning obj328 (depth = 6)
  block_return(realself, obj328);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if311 = undefined;
  } else {
  }
// compiled if node returning if311 (depth = 4)
  gc_frame_end(frame);
  return if311;
}
Object meth_ast_findAnnotation305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method findAnnotation");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for findAnnotation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe306 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe307 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call308 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe307);
// compiled call node returning call308 (depth = 4)
// compiled member node returning call308 (depth = 3)
  gc_frame_newslot(call308);
// starting to compile block node (depth = 3)
  Object block309 = alloc_Block(NULL, NULL, "ast", 2461);
  gc_frame_newslot(block309);
// method _apply
  block_savedest(block309);
  Object closure310 = createclosure(2, "_apply");
  setclosureframe(closure310, stackframe);
  addtoclosure(closure310, var_annName);
  addtoclosure(closure310, selfslot);
  struct UserObject *uo310 = (struct UserObject*)block309;
  uo310->data[0] = (Object)closure310;
  Method *meth_meth_ast__apply310 = addmethod2pos(block309, "_apply", &meth_ast__apply310, 0);
  int argcv_meth_ast__apply310[] = {1};
  meth_meth_ast__apply310->type = alloc_MethodType(1, argcv_meth_ast__apply310);
  meth_meth_ast__apply310->definitionModule = modulename;
  meth_meth_ast__apply310->definitionLine = 2461;
// compiled block node returning block309 (depth = 3)
  gc_frame_newslot(block309);
// call case 5: prelude request
  params[0] = call308;
  params[1] = block309;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call333 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe306);
// compiled call node returning call333 (depth = 2)
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool334 = alloc_Boolean(0);
// compiled identifier node returning bool334 (depth = 2)
  gc_frame_end(frame);
  return bool334;
}
Object meth_ast_emptySeq339(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySeq");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySeq = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for emptySeq (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹emptySeq›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySeq (depth = 3)
  gc_frame_end(frame);
  return *var_emptySeq;
}
Object meth_ast_AstNode342(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "AstNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_AstNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for AstNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹AstNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_AstNode (depth = 3)
  gc_frame_end(frame);
  return *var_AstNode;
}
Object meth_ast_baseNode343(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_baseNode (depth = 3)
  gc_frame_end(frame);
  return *var_baseNode;
}
Object meth_ast_isAppliedOccurenceOfIdentifier354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool355 = alloc_Boolean(0);
// compiled identifier node returning bool355 (depth = 4)
  gc_frame_end(frame);
  return bool355;
}
Object meth_ast_isMatchingBlock356(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool357 = alloc_Boolean(0);
// compiled identifier node returning bool357 (depth = 4)
  gc_frame_end(frame);
  return bool357;
}
Object meth_ast_isFieldDec358(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool359 = alloc_Boolean(0);
// compiled identifier node returning bool359 (depth = 4)
  gc_frame_end(frame);
  return bool359;
}
Object meth_ast_isInherits360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool361 = alloc_Boolean(0);
// compiled identifier node returning bool361 (depth = 4)
  gc_frame_end(frame);
  return bool361;
}
Object meth_ast_isMember362(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool363 = alloc_Boolean(0);
// compiled identifier node returning bool363 (depth = 4)
  gc_frame_end(frame);
  return bool363;
}
Object meth_ast_isCall364(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool365 = alloc_Boolean(0);
// compiled identifier node returning bool365 (depth = 4)
  gc_frame_end(frame);
  return bool365;
}
Object meth_ast_isClass366(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool367 = alloc_Boolean(0);
// compiled identifier node returning bool367 (depth = 4)
  gc_frame_end(frame);
  return bool367;
}
Object meth_ast_isBind368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool369 = alloc_Boolean(0);
// compiled identifier node returning bool369 (depth = 4)
  gc_frame_end(frame);
  return bool369;
}
Object meth_ast_isObject370(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool371 = alloc_Boolean(0);
// compiled identifier node returning bool371 (depth = 4)
  gc_frame_end(frame);
  return bool371;
}
Object meth_ast_isIdentifier372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool373 = alloc_Boolean(0);
// compiled identifier node returning bool373 (depth = 4)
  gc_frame_end(frame);
  return bool373;
}
Object meth_ast_definesObject374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool375 = alloc_Boolean(0);
// compiled identifier node returning bool375 (depth = 4)
  gc_frame_end(frame);
  return bool375;
}
Object meth_ast_definesScope376(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool377 = alloc_Boolean(0);
// compiled identifier node returning bool377 (depth = 4)
  gc_frame_end(frame);
  return bool377;
}
Object meth_ast_usesAsType378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool379 = alloc_Boolean(0);
// compiled identifier node returning bool379 (depth = 4)
  gc_frame_end(frame);
  return bool379;
}
Object meth_ast_hash380(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe382 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call384 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe383);
// compiled call node returning call384 (depth = 8)
// compiled member node returning call384 (depth = 7)
  partcv[0] = 0;
  Object call385 = callmethod(call384, "hash",
    1, partcv, params);
  gc_frame_end(callframe382);
// compiled call node returning call385 (depth = 6)
// compiled member node returning call385 (depth = 5)
  int op_slot_right_381 = gc_frame_newslot(call385);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe387 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call389 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe388);
// compiled call node returning call389 (depth = 8)
// compiled member node returning call389 (depth = 7)
  partcv[0] = 0;
  Object call390 = callmethod(call389, "hash",
    1, partcv, params);
  gc_frame_end(callframe387);
// compiled call node returning call390 (depth = 6)
// compiled member node returning call390 (depth = 5)
  int op_slot_left_381 = gc_frame_newslot(call390);
  params[0] = call385;
  partcv[0] = 1;
  Object prod391 = callmethod(call390, "*", 1, partcv, params);
// compiled op node returning prod391 (depth = 4)
  gc_frame_end(frame);
  return prod391;
}
Object meth_ast_asString392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit394 == NULL) {
    strlit394 = alloc_String("");
    gc_root(strlit394);
  }
// compiled string node returning strlit394 (depth = 5)
  int op_slot_right_393 = gc_frame_newslot(strlit394);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call398 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe397);
// compiled call node returning call398 (depth = 7)
// compiled member node returning call398 (depth = 6)
  int op_slot_right_396 = gc_frame_newslot(call398);
// starting to compile string node (depth = 6)
  if (strlit400 == NULL) {
    strlit400 = alloc_String("astNode ");
    gc_root(strlit400);
  }
// compiled string node returning strlit400 (depth = 6)
  int op_slot_left_396 = gc_frame_newslot(strlit400);
  params[0] = call398;
  partcv[0] = 1;
  Object opresult401 = callmethod(strlit400, "++", 1, partcv, params);
// compiled op node returning opresult401 (depth = 5)
  int op_slot_left_393 = gc_frame_newslot(opresult401);
  params[0] = strlit394;
  partcv[0] = 1;
  Object opresult402 = callmethod(opresult401, "++", 1, partcv, params);
// compiled op node returning opresult402 (depth = 4)
  gc_frame_end(frame);
  return opresult402;
}
Object meth_ast_isWritable403(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool404 = alloc_Boolean(1);
// compiled identifier node returning bool404 (depth = 4)
  gc_frame_end(frame);
  return bool404;
}
Object meth_ast_isReadable405(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool406 = alloc_Boolean(1);
// compiled identifier node returning bool406 (depth = 4)
  gc_frame_end(frame);
  return bool406;
}
Object meth_ast_isPublic407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool408 = alloc_Boolean(1);
// compiled identifier node returning bool408 (depth = 4)
  gc_frame_end(frame);
  return bool408;
}
Object meth_ast_isConfidential409(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe410 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call412 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe411);
// compiled call node returning call412 (depth = 7)
// compiled member node returning call412 (depth = 6)
  partcv[0] = 0;
  Object call413 = callmethod(call412, "not",
    1, partcv, params);
  gc_frame_end(callframe410);
// compiled call node returning call413 (depth = 5)
// compiled member node returning call413 (depth = 4)
  gc_frame_end(frame);
  return call413;
}
Object meth_ast_decType414(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool417 = alloc_Boolean(0);
// compiled identifier node returning bool417 (depth = 6)
  int op_slot_right_416 = gc_frame_newslot(bool417);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe419 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call420 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe419);
// compiled call node returning call420 (depth = 7)
// compiled member node returning call420 (depth = 6)
  int op_slot_left_416 = gc_frame_newslot(call420);
  params[0] = bool417;
  partcv[0] = 1;
  Object opresult421 = callmethod(call420, "==", 1, partcv, params);
// compiled op node returning opresult421 (depth = 5)
  Object if415 = done;
  if (istrue(opresult421)) {
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unknownType (depth = 6)
  return *var_unknownType;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if415 = undefined;
  } else {
  }
// compiled if node returning if415 (depth = 4)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call423 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe422);
// compiled call node returning call423 (depth = 6)
// compiled member node returning call423 (depth = 5)
  return call423;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_accept424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe425 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 4: self request
  params[0] = *var_visitor;
  params[1] = *var_nullNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call426 = callmethodflags(self, "accept()from", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe425);
// compiled call node returning call426 (depth = 4)
  gc_frame_end(frame);
  return call426;
}
Object meth_ast_withParentRefs427(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withParentRefs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for withParentRefs (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for withParentRefs");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe428 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe429 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe430 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe431 = gc_frame_new();
// call case 3: self.outer request
  Object call432 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe431);
// compiled call node returning call432 (depth = 10)
// compiled member node returning call432 (depth = 9)
  partcv[0] = 0;
  Object call433 = callmethodflags(call432, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe430);
// compiled call node returning call433 (depth = 8)
// compiled member node returning call433 (depth = 7)
  partcv[0] = 0;
  Object call434 = callmethodflags(call433, "addParentVisitor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe429);
// compiled call node returning call434 (depth = 6)
// compiled member node returning call434 (depth = 5)
  gc_frame_newslot(call434);
// call case 4: self request
  params[0] = call434;
  partcv[0] = 1;
  Object call435 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe428);
// compiled call node returning call435 (depth = 4)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_declarationKind436(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe437 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call438 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe437);
// compiled call node returning call438 (depth = 5)
// compiled member node returning call438 (depth = 4)
  gc_frame_end(frame);
  return call438;
}
Object meth_ast__apply442(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_node = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe443 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_node (depth = 10)
  partcv[0] = 0;
  Object call445 = callmethod(*var_node, "hasSymbolTable",
    1, partcv, params);
  gc_frame_end(callframe444);
// compiled call node returning call445 (depth = 9)
// compiled member node returning call445 (depth = 8)
  partcv[0] = 0;
  Object call446 = callmethod(call445, "not",
    1, partcv, params);
  gc_frame_end(callframe443);
// compiled call node returning call446 (depth = 7)
// compiled member node returning call446 (depth = 6)
  gc_frame_end(frame);
  return call446;
}
Object meth_ast__apply449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_node = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_node (depth = 9)
  partcv[0] = 0;
  Object call451 = callmethod(*var_node, "parent",
    1, partcv, params);
  gc_frame_end(callframe450);
// compiled call node returning call451 (depth = 8)
// compiled member node returning call451 (depth = 7)
  *var_node = call451;
  if (call451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_scope439(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "scope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for scope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_node = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "node");
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  *var_node = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe440 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block441 = alloc_Block(NULL, NULL, "ast", 96);
  gc_frame_newslot(block441);
// method _apply
  block_savedest(block441);
  Object closure442 = createclosure(2, "_apply");
  setclosureframe(closure442, stackframe);
  addtoclosure(closure442, var_node);
  addtoclosure(closure442, selfslot);
  struct UserObject *uo442 = (struct UserObject*)block441;
  uo442->data[0] = (Object)closure442;
  Method *meth_meth_ast__apply442 = addmethod2pos(block441, "_apply", &meth_ast__apply442, 0);
  int argcv_meth_ast__apply442[] = {0};
  meth_meth_ast__apply442->type = alloc_MethodType(1, argcv_meth_ast__apply442);
  meth_meth_ast__apply442->definitionModule = modulename;
  meth_meth_ast__apply442->definitionLine = 93;
// compiled block node returning block441 (depth = 5)
  gc_frame_newslot(block441);
// starting to compile block node (depth = 5)
  Object block448 = alloc_Block(NULL, NULL, "ast", 96);
  gc_frame_newslot(block448);
// method _apply
  block_savedest(block448);
  Object closure449 = createclosure(2, "_apply");
  setclosureframe(closure449, stackframe);
  addtoclosure(closure449, var_node);
  addtoclosure(closure449, selfslot);
  struct UserObject *uo449 = (struct UserObject*)block448;
  uo449->data[0] = (Object)closure449;
  Method *meth_meth_ast__apply449 = addmethod2pos(block448, "_apply", &meth_ast__apply449, 0);
  int argcv_meth_ast__apply449[] = {0};
  meth_meth_ast__apply449->type = alloc_MethodType(1, argcv_meth_ast__apply449);
  meth_meth_ast__apply449->definitionModule = modulename;
  meth_meth_ast__apply449->definitionLine = 96;
// compiled block node returning block448 (depth = 5)
  gc_frame_newslot(block448);
// call case 5: prelude request
  params[0] = block441;
  params[1] = block448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call454 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe440);
// compiled call node returning call454 (depth = 4)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe455 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_node (depth = 6)
  partcv[0] = 0;
  Object call456 = callmethod(*var_node, "symbolTable",
    1, partcv, params);
  gc_frame_end(callframe455);
// compiled call node returning call456 (depth = 5)
// compiled member node returning call456 (depth = 4)
  gc_frame_end(frame);
  return call456;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent457(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe458 = gc_frame_new();
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call460 = callmethod(*var_other, "register",
    1, partcv, params);
  gc_frame_end(callframe459);
// compiled call node returning call460 (depth = 7)
// compiled member node returning call460 (depth = 6)
  gc_frame_newslot(call460);
// call case 4: self request
  params[0] = call460;
  partcv[0] = 1;
  Object call461 = callmethodflags(self, "register:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe458);
// compiled call node returning call461 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe462 = gc_frame_new();
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe463 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call464 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe463);
// compiled call node returning call464 (depth = 7)
// compiled member node returning call464 (depth = 6)
  gc_frame_newslot(call464);
// call case 4: self request
  params[0] = call464;
  partcv[0] = 1;
  Object call465 = callmethodflags(self, "line:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe462);
// compiled call node returning call465 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe466 = gc_frame_new();
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call468 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe467);
// compiled call node returning call468 (depth = 7)
// compiled member node returning call468 (depth = 6)
  gc_frame_newslot(call468);
// call case 4: self request
  params[0] = call468;
  partcv[0] = 1;
  Object call469 = callmethodflags(self, "linePos:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe466);
// compiled call node returning call469 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe470 = gc_frame_new();
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call471 = callmethodflags(self, "parent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe470);
// compiled call node returning call471 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe472 = gc_frame_new();
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call474 = callmethod(*var_other, "hasSymbolTable",
    1, partcv, params);
  gc_frame_end(callframe473);
// compiled call node returning call474 (depth = 7)
// compiled member node returning call474 (depth = 6)
  gc_frame_newslot(call474);
// call case 4: self request
  params[0] = call474;
  partcv[0] = 1;
  Object call475 = callmethodflags(self, "hasSymbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe472);
// compiled call node returning call475 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_pretty476(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit478 == NULL) {
    strlit478 = alloc_String("");
    gc_root(strlit478);
  }
// compiled string node returning strlit478 (depth = 5)
  int op_slot_right_477 = gc_frame_newslot(strlit478);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe481 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call482 = callmethodflags(self, "kind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe481);
// compiled call node returning call482 (depth = 7)
// compiled member node returning call482 (depth = 6)
  int op_slot_right_480 = gc_frame_newslot(call482);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit485 == NULL) {
    strlit485 = alloc_String(" ");
    gc_root(strlit485);
  }
// compiled string node returning strlit485 (depth = 7)
  int op_slot_right_484 = gc_frame_newslot(strlit485);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call489 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe488);
// compiled call node returning call489 (depth = 9)
// compiled member node returning call489 (depth = 8)
  int op_slot_right_487 = gc_frame_newslot(call489);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit492 == NULL) {
    strlit492 = alloc_String(":");
    gc_root(strlit492);
  }
// compiled string node returning strlit492 (depth = 9)
  int op_slot_right_491 = gc_frame_newslot(strlit492);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe495 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call496 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe495);
// compiled call node returning call496 (depth = 11)
// compiled member node returning call496 (depth = 10)
  int op_slot_right_494 = gc_frame_newslot(call496);
// starting to compile string node (depth = 10)
  if (strlit498 == NULL) {
    strlit498 = alloc_String("");
    gc_root(strlit498);
  }
// compiled string node returning strlit498 (depth = 10)
  int op_slot_left_494 = gc_frame_newslot(strlit498);
  params[0] = call496;
  partcv[0] = 1;
  Object opresult499 = callmethod(strlit498, "++", 1, partcv, params);
// compiled op node returning opresult499 (depth = 9)
  int op_slot_left_491 = gc_frame_newslot(opresult499);
  params[0] = strlit492;
  partcv[0] = 1;
  Object opresult500 = callmethod(opresult499, "++", 1, partcv, params);
// compiled op node returning opresult500 (depth = 8)
  int op_slot_left_487 = gc_frame_newslot(opresult500);
  params[0] = call489;
  partcv[0] = 1;
  Object opresult501 = callmethod(opresult500, "++", 1, partcv, params);
// compiled op node returning opresult501 (depth = 7)
  int op_slot_left_484 = gc_frame_newslot(opresult501);
  params[0] = strlit485;
  partcv[0] = 1;
  Object opresult502 = callmethod(opresult501, "++", 1, partcv, params);
// compiled op node returning opresult502 (depth = 6)
  int op_slot_left_480 = gc_frame_newslot(opresult502);
  params[0] = call482;
  partcv[0] = 1;
  Object opresult503 = callmethod(opresult502, "++", 1, partcv, params);
// compiled op node returning opresult503 (depth = 5)
  int op_slot_left_477 = gc_frame_newslot(opresult503);
  params[0] = strlit478;
  partcv[0] = 1;
  Object opresult504 = callmethod(opresult503, "++", 1, partcv, params);
// compiled op node returning opresult504 (depth = 4)
  gc_frame_end(frame);
  return opresult504;
}
Object meth_ast__apply508(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_end(frame);
  return *var_each;
}
Object meth_ast_deepCopy505(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "deepCopy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for deepCopy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for deepCopy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe506 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block507 = alloc_Block(NULL, NULL, "ast", 112);
  gc_frame_newslot(block507);
// method _apply
  block_savedest(block507);
  Object closure508 = createclosure(1, "_apply");
  setclosureframe(closure508, stackframe);
  addtoclosure(closure508, selfslot);
  struct UserObject *uo508 = (struct UserObject*)block507;
  uo508->data[0] = (Object)closure508;
  Method *meth_meth_ast__apply508 = addmethod2pos(block507, "_apply", &meth_ast__apply508, 0);
  int argcv_meth_ast__apply508[] = {1};
  meth_meth_ast__apply508->type = alloc_MethodType(1, argcv_meth_ast__apply508);
  meth_meth_ast__apply508->definitionModule = modulename;
  meth_meth_ast__apply508->definitionLine = 109;
// compiled block node returning block507 (depth = 5)
  gc_frame_newslot(block507);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nullNode (depth = 5)
  gc_frame_newslot(*var_nullNode);
// call case 4: self request
  params[0] = block507;
  params[1] = *var_nullNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call510 = callmethodflags(self, "map()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe506);
// compiled call node returning call510 (depth = 4)
  gc_frame_end(frame);
  return call510;
}
Object meth_ast__apply514(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_nd = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe515 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nd (depth = 9)
  partcv[0] = 0;
  Object call516 = callmethod(*var_nd, "parent",
    1, partcv, params);
  gc_frame_end(callframe515);
// compiled call node returning call516 (depth = 8)
// compiled member node returning call516 (depth = 7)
  *var_nd = call516;
  if (call516 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nullNode (depth = 8)
  int op_slot_right_519 = gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nd (depth = 8)
  int op_slot_left_519 = gc_frame_newslot(*var_nd);
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object opresult521 = callmethod(*var_nd, "==", 1, partcv, params);
// compiled op node returning opresult521 (depth = 7)
  Object if518 = done;
  if (istrue(opresult521)) {
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool522 = alloc_Boolean(0);
// compiled identifier node returning bool522 (depth = 8)
  block_return(realself, bool522);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if518 = undefined;
  } else {
  }
// compiled if node returning if518 (depth = 6)
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  int op_slot_right_524 = gc_frame_newslot(*var_each);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nd (depth = 10)
  partcv[0] = 0;
  Object call527 = callmethod(*var_nd, "kind",
    1, partcv, params);
  gc_frame_end(callframe526);
// compiled call node returning call527 (depth = 9)
// compiled member node returning call527 (depth = 8)
  int op_slot_left_524 = gc_frame_newslot(call527);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult528 = callmethod(call527, "!=", 1, partcv, params);
// compiled op node returning opresult528 (depth = 7)
  Object if523 = done;
  if (istrue(opresult528)) {
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool529 = alloc_Boolean(0);
// compiled identifier node returning bool529 (depth = 8)
  block_return(realself, bool529);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if523 = undefined;
  } else {
  }
// compiled if node returning if523 (depth = 6)
  gc_frame_end(frame);
  return if523;
}
Object meth_ast_isUnder511(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isUnder");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method isUnder");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isUnder (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lns = &(stackframe->slots[0]);
  *var_lns = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for isUnder");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nd");
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  *var_nd = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe512 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lns (depth = 5)
  gc_frame_newslot(*var_lns);
// starting to compile block node (depth = 5)
  Object block513 = alloc_Block(NULL, NULL, "ast", 118);
  gc_frame_newslot(block513);
// method _apply
  block_savedest(block513);
  Object closure514 = createclosure(3, "_apply");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, var_nd);
  addtoclosure(closure514, var_nullNode);
  addtoclosure(closure514, selfslot);
  struct UserObject *uo514 = (struct UserObject*)block513;
  uo514->data[0] = (Object)closure514;
  Method *meth_meth_ast__apply514 = addmethod2pos(block513, "_apply", &meth_ast__apply514, 0);
  int argcv_meth_ast__apply514[] = {1};
  meth_meth_ast__apply514->type = alloc_MethodType(1, argcv_meth_ast__apply514);
  meth_meth_ast__apply514->definitionModule = modulename;
  meth_meth_ast__apply514->definitionLine = 109;
// compiled block node returning block513 (depth = 5)
  gc_frame_newslot(block513);
// call case 5: prelude request
  params[0] = *var_lns;
  params[1] = block513;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call531 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe512);
// compiled call node returning call531 (depth = 4)
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool532 = alloc_Boolean(1);
// compiled identifier node returning bool532 (depth = 5)
  return bool532;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_new346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject347 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj347 = alloc_userobj2(38,34, objclass347);
  gc_frame_newslot(obj347);
if (objclass347 == NULL) {
  glfree(obj347->class->name);
  obj347->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj347, self, 0);
  addmethodreal(obj347,"outer", &reader_ast_outer_348);
  Object oldself347 = self;
  struct StackFrameObject *oldstackframe347 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe347);
  gc_frame_newslot((Object)stackframe);
  self = obj347;
  Object *oldselfslot347 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter347 = (*(struct UserObject *)self).data[0], lowerouter347 = thisouter347;
  if (inheritingObject347) {
    struct UserObject *inho347 = (struct UserObject *)inheritingObject347;
    while (inho347->super != GraceDefaultObject) inho347 = (struct UserObject *)inho347->super;
    inho347->super = obj347;
    self = inheritingObject347;
    *selfslot = self;
    lowerouter347 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter347;
  }
if (objclass347 == NULL) {
  Method *reader349 = addmethodrealflags(obj347, "register",&reader_ast_register_349, 0);
  Method *writer349 = addmethodrealflags(obj347, "register:=",&writer_ast_register_349, 0);
  reader349->definitionModule = modulename;
  writer349->definitionModule = modulename;
  reader349->definitionLine = 56;
  writer349->definitionLine = 56;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 1);
if (objclass347 == NULL) {
  Method *reader350 = addmethodrealflags(obj347, "line",&reader_ast_line_350, 0);
  Method *writer350 = addmethodrealflags(obj347, "line:=",&writer_ast_line_350, 0);
  reader350->definitionModule = modulename;
  writer350->definitionModule = modulename;
  reader350->definitionLine = 57;
  writer350->definitionLine = 57;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 2);
if (objclass347 == NULL) {
  Method *reader351 = addmethodrealflags(obj347, "linePos",&reader_ast_linePos_351, 0);
  Method *writer351 = addmethodrealflags(obj347, "linePos:=",&writer_ast_linePos_351, 0);
  reader351->definitionModule = modulename;
  writer351->definitionModule = modulename;
  reader351->definitionLine = 58;
  writer351->definitionLine = 58;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 3);
if (objclass347 == NULL) {
  Method *reader352 = addmethodrealflags(obj347, "parent",&reader_ast_parent_352, 0);
  Method *writer352 = addmethodrealflags(obj347, "parent:=",&writer_ast_parent_352, 0);
  reader352->definitionModule = modulename;
  writer352->definitionModule = modulename;
  reader352->definitionLine = 59;
  writer352->definitionLine = 59;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 4);
if (objclass347 == NULL) {
  Method *reader353 = addmethodrealflags(obj347, "hasSymbolTable",&reader_ast_hasSymbolTable_353, 0);
  Method *writer353 = addmethodrealflags(obj347, "hasSymbolTable:=",&writer_ast_hasSymbolTable_353, 0);
  reader353->definitionModule = modulename;
  writer353->definitionModule = modulename;
  reader353->definitionLine = 61;
  writer353->definitionLine = 61;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 5);
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo354 = (struct UserObject*)obj347;
  uo354->data[6] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier354 = addmethod2pos(obj347, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier354, 6);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier354[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier354->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier354);
  meth_meth_ast_isAppliedOccurenceOfIdentifier354->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier354->definitionLine = 61;
// method isMatchingBlock
  struct UserObject *uo356 = (struct UserObject*)obj347;
  uo356->data[7] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock356 = addmethod2pos(obj347, "isMatchingBlock", &meth_ast_isMatchingBlock356, 7);
  int argcv_meth_ast_isMatchingBlock356[] = {0};
  meth_meth_ast_isMatchingBlock356->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock356);
  meth_meth_ast_isMatchingBlock356->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock356->definitionLine = 62;
// method isFieldDec
  struct UserObject *uo358 = (struct UserObject*)obj347;
  uo358->data[8] = emptyclosure;
  Method *meth_meth_ast_isFieldDec358 = addmethod2pos(obj347, "isFieldDec", &meth_ast_isFieldDec358, 8);
  int argcv_meth_ast_isFieldDec358[] = {0};
  meth_meth_ast_isFieldDec358->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec358);
  meth_meth_ast_isFieldDec358->definitionModule = modulename;
  meth_meth_ast_isFieldDec358->definitionLine = 63;
// method isInherits
  struct UserObject *uo360 = (struct UserObject*)obj347;
  uo360->data[9] = emptyclosure;
  Method *meth_meth_ast_isInherits360 = addmethod2pos(obj347, "isInherits", &meth_ast_isInherits360, 9);
  int argcv_meth_ast_isInherits360[] = {0};
  meth_meth_ast_isInherits360->type = alloc_MethodType(1, argcv_meth_ast_isInherits360);
  meth_meth_ast_isInherits360->definitionModule = modulename;
  meth_meth_ast_isInherits360->definitionLine = 64;
// method isMember
  struct UserObject *uo362 = (struct UserObject*)obj347;
  uo362->data[10] = emptyclosure;
  Method *meth_meth_ast_isMember362 = addmethod2pos(obj347, "isMember", &meth_ast_isMember362, 10);
  int argcv_meth_ast_isMember362[] = {0};
  meth_meth_ast_isMember362->type = alloc_MethodType(1, argcv_meth_ast_isMember362);
  meth_meth_ast_isMember362->definitionModule = modulename;
  meth_meth_ast_isMember362->definitionLine = 65;
// method isCall
  struct UserObject *uo364 = (struct UserObject*)obj347;
  uo364->data[11] = emptyclosure;
  Method *meth_meth_ast_isCall364 = addmethod2pos(obj347, "isCall", &meth_ast_isCall364, 11);
  int argcv_meth_ast_isCall364[] = {0};
  meth_meth_ast_isCall364->type = alloc_MethodType(1, argcv_meth_ast_isCall364);
  meth_meth_ast_isCall364->definitionModule = modulename;
  meth_meth_ast_isCall364->definitionLine = 66;
// method isClass
  struct UserObject *uo366 = (struct UserObject*)obj347;
  uo366->data[12] = emptyclosure;
  Method *meth_meth_ast_isClass366 = addmethod2pos(obj347, "isClass", &meth_ast_isClass366, 12);
  int argcv_meth_ast_isClass366[] = {0};
  meth_meth_ast_isClass366->type = alloc_MethodType(1, argcv_meth_ast_isClass366);
  meth_meth_ast_isClass366->definitionModule = modulename;
  meth_meth_ast_isClass366->definitionLine = 67;
// method isBind
  struct UserObject *uo368 = (struct UserObject*)obj347;
  uo368->data[13] = emptyclosure;
  Method *meth_meth_ast_isBind368 = addmethod2pos(obj347, "isBind", &meth_ast_isBind368, 13);
  int argcv_meth_ast_isBind368[] = {0};
  meth_meth_ast_isBind368->type = alloc_MethodType(1, argcv_meth_ast_isBind368);
  meth_meth_ast_isBind368->definitionModule = modulename;
  meth_meth_ast_isBind368->definitionLine = 68;
// method isObject
  struct UserObject *uo370 = (struct UserObject*)obj347;
  uo370->data[14] = emptyclosure;
  Method *meth_meth_ast_isObject370 = addmethod2pos(obj347, "isObject", &meth_ast_isObject370, 14);
  int argcv_meth_ast_isObject370[] = {0};
  meth_meth_ast_isObject370->type = alloc_MethodType(1, argcv_meth_ast_isObject370);
  meth_meth_ast_isObject370->definitionModule = modulename;
  meth_meth_ast_isObject370->definitionLine = 69;
// method isIdentifier
  struct UserObject *uo372 = (struct UserObject*)obj347;
  uo372->data[15] = emptyclosure;
  Method *meth_meth_ast_isIdentifier372 = addmethod2pos(obj347, "isIdentifier", &meth_ast_isIdentifier372, 15);
  int argcv_meth_ast_isIdentifier372[] = {0};
  meth_meth_ast_isIdentifier372->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier372);
  meth_meth_ast_isIdentifier372->definitionModule = modulename;
  meth_meth_ast_isIdentifier372->definitionLine = 70;
// method definesObject
  struct UserObject *uo374 = (struct UserObject*)obj347;
  uo374->data[16] = emptyclosure;
  Method *meth_meth_ast_definesObject374 = addmethod2pos(obj347, "definesObject", &meth_ast_definesObject374, 16);
  int argcv_meth_ast_definesObject374[] = {0};
  meth_meth_ast_definesObject374->type = alloc_MethodType(1, argcv_meth_ast_definesObject374);
  meth_meth_ast_definesObject374->definitionModule = modulename;
  meth_meth_ast_definesObject374->definitionLine = 71;
// method definesScope
  struct UserObject *uo376 = (struct UserObject*)obj347;
  uo376->data[17] = emptyclosure;
  Method *meth_meth_ast_definesScope376 = addmethod2pos(obj347, "definesScope", &meth_ast_definesScope376, 17);
  int argcv_meth_ast_definesScope376[] = {0};
  meth_meth_ast_definesScope376->type = alloc_MethodType(1, argcv_meth_ast_definesScope376);
  meth_meth_ast_definesScope376->definitionModule = modulename;
  meth_meth_ast_definesScope376->definitionLine = 72;
// method usesAsType
  struct UserObject *uo378 = (struct UserObject*)obj347;
  uo378->data[18] = emptyclosure;
  Method *meth_meth_ast_usesAsType378 = addmethod2pos(obj347, "usesAsType", &meth_ast_usesAsType378, 18);
  int argcv_meth_ast_usesAsType378[] = {1};
  meth_meth_ast_usesAsType378->type = alloc_MethodType(1, argcv_meth_ast_usesAsType378);
  meth_meth_ast_usesAsType378->definitionModule = modulename;
  meth_meth_ast_usesAsType378->definitionLine = 73;
// method hash
  struct UserObject *uo380 = (struct UserObject*)obj347;
  uo380->data[19] = emptyclosure;
  Method *meth_meth_ast_hash380 = addmethod2pos(obj347, "hash", &meth_ast_hash380, 19);
  int argcv_meth_ast_hash380[] = {0};
  meth_meth_ast_hash380->type = alloc_MethodType(1, argcv_meth_ast_hash380);
  meth_meth_ast_hash380->definitionModule = modulename;
  meth_meth_ast_hash380->definitionLine = 74;
// method asString
  struct UserObject *uo392 = (struct UserObject*)obj347;
  uo392->data[20] = emptyclosure;
  Method *meth_meth_ast_asString392 = addmethod2pos(obj347, "asString", &meth_ast_asString392, 20);
  int argcv_meth_ast_asString392[] = {0};
  meth_meth_ast_asString392->type = alloc_MethodType(1, argcv_meth_ast_asString392);
  meth_meth_ast_asString392->definitionModule = modulename;
  meth_meth_ast_asString392->definitionLine = 75;
// method isWritable
  struct UserObject *uo403 = (struct UserObject*)obj347;
  uo403->data[21] = emptyclosure;
  Method *meth_meth_ast_isWritable403 = addmethod2pos(obj347, "isWritable", &meth_ast_isWritable403, 21);
  int argcv_meth_ast_isWritable403[] = {0};
  meth_meth_ast_isWritable403->type = alloc_MethodType(1, argcv_meth_ast_isWritable403);
  meth_meth_ast_isWritable403->definitionModule = modulename;
  meth_meth_ast_isWritable403->definitionLine = 76;
// method isReadable
  struct UserObject *uo405 = (struct UserObject*)obj347;
  uo405->data[22] = emptyclosure;
  Method *meth_meth_ast_isReadable405 = addmethod2pos(obj347, "isReadable", &meth_ast_isReadable405, 22);
  int argcv_meth_ast_isReadable405[] = {0};
  meth_meth_ast_isReadable405->type = alloc_MethodType(1, argcv_meth_ast_isReadable405);
  meth_meth_ast_isReadable405->definitionModule = modulename;
  meth_meth_ast_isReadable405->definitionLine = 77;
// method isPublic
  struct UserObject *uo407 = (struct UserObject*)obj347;
  uo407->data[23] = emptyclosure;
  Method *meth_meth_ast_isPublic407 = addmethod2pos(obj347, "isPublic", &meth_ast_isPublic407, 23);
  int argcv_meth_ast_isPublic407[] = {0};
  meth_meth_ast_isPublic407->type = alloc_MethodType(1, argcv_meth_ast_isPublic407);
  meth_meth_ast_isPublic407->definitionModule = modulename;
  meth_meth_ast_isPublic407->definitionLine = 78;
// method isConfidential
  struct UserObject *uo409 = (struct UserObject*)obj347;
  uo409->data[24] = emptyclosure;
  Method *meth_meth_ast_isConfidential409 = addmethod2pos(obj347, "isConfidential", &meth_ast_isConfidential409, 24);
  int argcv_meth_ast_isConfidential409[] = {0};
  meth_meth_ast_isConfidential409->type = alloc_MethodType(1, argcv_meth_ast_isConfidential409);
  meth_meth_ast_isConfidential409->definitionModule = modulename;
  meth_meth_ast_isConfidential409->definitionLine = 79;
// method decType
  block_savedest(obj347);
  Object closure414 = createclosure(1, "decType");
  setclosureframe(closure414, stackframe);
  addtoclosure(closure414, var_unknownType);
  struct UserObject *uo414 = (struct UserObject*)obj347;
  uo414->data[25] = (Object)closure414;
  Method *meth_meth_ast_decType414 = addmethod2pos(obj347, "decType", &meth_ast_decType414, 25);
  int argcv_meth_ast_decType414[] = {0};
  meth_meth_ast_decType414->type = alloc_MethodType(1, argcv_meth_ast_decType414);
  meth_meth_ast_decType414->definitionModule = modulename;
  meth_meth_ast_decType414->definitionLine = 80;
// method accept
  block_savedest(obj347);
  Object closure424 = createclosure(1, "accept");
  setclosureframe(closure424, stackframe);
  addtoclosure(closure424, var_nullNode);
  struct UserObject *uo424 = (struct UserObject*)obj347;
  uo424->data[26] = (Object)closure424;
  Method *meth_meth_ast_accept424 = addmethod2pos(obj347, "accept", &meth_ast_accept424, 26);
  int argcv_meth_ast_accept424[] = {1};
  meth_meth_ast_accept424->type = alloc_MethodType(1, argcv_meth_ast_accept424);
  meth_meth_ast_accept424->definitionModule = modulename;
  meth_meth_ast_accept424->definitionLine = 86;
// method withParentRefs
  struct UserObject *uo427 = (struct UserObject*)obj347;
  uo427->data[27] = emptyclosure;
  Method *meth_meth_ast_withParentRefs427 = addmethod2pos(obj347, "withParentRefs", &meth_ast_withParentRefs427, 27);
  int argcv_meth_ast_withParentRefs427[] = {0};
  meth_meth_ast_withParentRefs427->type = alloc_MethodType(1, argcv_meth_ast_withParentRefs427);
  meth_meth_ast_withParentRefs427->definitionModule = modulename;
  meth_meth_ast_withParentRefs427->definitionLine = 89;
// method declarationKind
  struct UserObject *uo436 = (struct UserObject*)obj347;
  uo436->data[28] = emptyclosure;
  Method *meth_meth_ast_declarationKind436 = addmethod2pos(obj347, "declarationKind", &meth_ast_declarationKind436, 28);
  int argcv_meth_ast_declarationKind436[] = {0};
  meth_meth_ast_declarationKind436->type = alloc_MethodType(1, argcv_meth_ast_declarationKind436);
  meth_meth_ast_declarationKind436->definitionModule = modulename;
  meth_meth_ast_declarationKind436->definitionLine = 93;
// method scope
  struct UserObject *uo439 = (struct UserObject*)obj347;
  uo439->data[29] = emptyclosure;
  Method *meth_meth_ast_scope439 = addmethod2pos(obj347, "scope", &meth_ast_scope439, 29);
  int argcv_meth_ast_scope439[] = {0};
  meth_meth_ast_scope439->type = alloc_MethodType(1, argcv_meth_ast_scope439);
  meth_meth_ast_scope439->definitionModule = modulename;
  meth_meth_ast_scope439->definitionLine = 94;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo457 = (struct UserObject*)obj347;
  uo457->data[30] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457 = addmethod2pos(obj347, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent457, 30);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent457[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent457);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457->definitionLine = 100;
// method pretty
  struct UserObject *uo476 = (struct UserObject*)obj347;
  uo476->data[31] = emptyclosure;
  Method *meth_meth_ast_pretty476 = addmethod2pos(obj347, "pretty", &meth_ast_pretty476, 31);
  int argcv_meth_ast_pretty476[] = {1};
  meth_meth_ast_pretty476->type = alloc_MethodType(1, argcv_meth_ast_pretty476);
  meth_meth_ast_pretty476->definitionModule = modulename;
  meth_meth_ast_pretty476->definitionLine = 108;
// method deepCopy
  block_savedest(obj347);
  Object closure505 = createclosure(1, "deepCopy");
  setclosureframe(closure505, stackframe);
  addtoclosure(closure505, var_nullNode);
  struct UserObject *uo505 = (struct UserObject*)obj347;
  uo505->data[32] = (Object)closure505;
  Method *meth_meth_ast_deepCopy505 = addmethod2pos(obj347, "deepCopy", &meth_ast_deepCopy505, 32);
  int argcv_meth_ast_deepCopy505[] = {0};
  meth_meth_ast_deepCopy505->type = alloc_MethodType(1, argcv_meth_ast_deepCopy505);
  meth_meth_ast_deepCopy505->definitionModule = modulename;
  meth_meth_ast_deepCopy505->definitionLine = 111;
// method isUnder
  block_savedest(obj347);
  Object closure511 = createclosure(1, "isUnder");
  setclosureframe(closure511, stackframe);
  addtoclosure(closure511, var_nullNode);
  struct UserObject *uo511 = (struct UserObject*)obj347;
  uo511->data[33] = (Object)closure511;
  Method *meth_meth_ast_isUnder511 = addmethod2pos(obj347, "isUnder", &meth_ast_isUnder511, 33);
  int argcv_meth_ast_isUnder511[] = {1};
  meth_meth_ast_isUnder511->type = alloc_MethodType(1, argcv_meth_ast_isUnder511);
  meth_meth_ast_isUnder511->definitionModule = modulename;
  meth_meth_ast_isUnder511->definitionLine = 114;
  sourceObject = obj347;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit533 == NULL) {
    strlit533 = alloc_String("");
    gc_root(strlit533);
  }
// compiled string node returning strlit533 (depth = 4)
  adddatum2(obj347, strlit533, 1);
  sourceObject = obj347;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call535 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe534);
// compiled call node returning call535 (depth = 5)
// compiled member node returning call535 (depth = 4)
  adddatum2(obj347, call535, 2);
  sourceObject = obj347;
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call537 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe536);
// compiled call node returning call537 (depth = 5)
// compiled member node returning call537 (depth = 4)
  adddatum2(obj347, call537, 3);
  sourceObject = obj347;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nullNode (depth = 4)
  adddatum2(obj347, *var_nullNode, 4);
  sourceObject = obj347;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool538 = alloc_Boolean(0);
// compiled identifier node returning bool538 (depth = 4)
  adddatum2(obj347, bool538, 5);
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
objclass347 = obj347->class;
  objclass347->definitionModule = modulename;
  objclass347->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter347;
  self = oldself347;
  selfslot = oldselfslot347;
  stackframe = oldstackframe347;
  gc_frame_end(frame);
  return obj347;
}
Object meth_ast_new346_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject347 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj347 = alloc_userobj2(38,34, objclass347);
  gc_frame_newslot(obj347);
if (objclass347 == NULL) {
  glfree(obj347->class->name);
  obj347->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj347, self, 0);
  addmethodreal(obj347,"outer", &reader_ast_outer_348);
  Object oldself347 = self;
  struct StackFrameObject *oldstackframe347 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe347);
  gc_frame_newslot((Object)stackframe);
  self = obj347;
  Object *oldselfslot347 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter347 = (*(struct UserObject *)self).data[0], lowerouter347 = thisouter347;
  if (inheritingObject347) {
    struct UserObject *inho347 = (struct UserObject *)inheritingObject347;
    while (inho347->super != GraceDefaultObject) inho347 = (struct UserObject *)inho347->super;
    inho347->super = obj347;
    self = inheritingObject347;
    *selfslot = self;
    lowerouter347 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter347;
  }
if (objclass347 == NULL) {
  Method *reader349 = addmethodrealflags(obj347, "register",&reader_ast_register_349, 0);
  Method *writer349 = addmethodrealflags(obj347, "register:=",&writer_ast_register_349, 0);
  reader349->definitionModule = modulename;
  writer349->definitionModule = modulename;
  reader349->definitionLine = 56;
  writer349->definitionLine = 56;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 1);
if (objclass347 == NULL) {
  Method *reader350 = addmethodrealflags(obj347, "line",&reader_ast_line_350, 0);
  Method *writer350 = addmethodrealflags(obj347, "line:=",&writer_ast_line_350, 0);
  reader350->definitionModule = modulename;
  writer350->definitionModule = modulename;
  reader350->definitionLine = 57;
  writer350->definitionLine = 57;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 2);
if (objclass347 == NULL) {
  Method *reader351 = addmethodrealflags(obj347, "linePos",&reader_ast_linePos_351, 0);
  Method *writer351 = addmethodrealflags(obj347, "linePos:=",&writer_ast_linePos_351, 0);
  reader351->definitionModule = modulename;
  writer351->definitionModule = modulename;
  reader351->definitionLine = 58;
  writer351->definitionLine = 58;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 3);
if (objclass347 == NULL) {
  Method *reader352 = addmethodrealflags(obj347, "parent",&reader_ast_parent_352, 0);
  Method *writer352 = addmethodrealflags(obj347, "parent:=",&writer_ast_parent_352, 0);
  reader352->definitionModule = modulename;
  writer352->definitionModule = modulename;
  reader352->definitionLine = 59;
  writer352->definitionLine = 59;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 4);
if (objclass347 == NULL) {
  Method *reader353 = addmethodrealflags(obj347, "hasSymbolTable",&reader_ast_hasSymbolTable_353, 0);
  Method *writer353 = addmethodrealflags(obj347, "hasSymbolTable:=",&writer_ast_hasSymbolTable_353, 0);
  reader353->definitionModule = modulename;
  writer353->definitionModule = modulename;
  reader353->definitionLine = 61;
  writer353->definitionLine = 61;
}
obj347->flags |= OFLAG_MUTABLE;
adddatum2(obj347, alloc_Undefined(), 5);
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo354 = (struct UserObject*)obj347;
  uo354->data[6] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier354 = addmethod2pos(obj347, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier354, 6);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier354[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier354->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier354);
  meth_meth_ast_isAppliedOccurenceOfIdentifier354->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier354->definitionLine = 61;
// method isMatchingBlock
  struct UserObject *uo356 = (struct UserObject*)obj347;
  uo356->data[7] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock356 = addmethod2pos(obj347, "isMatchingBlock", &meth_ast_isMatchingBlock356, 7);
  int argcv_meth_ast_isMatchingBlock356[] = {0};
  meth_meth_ast_isMatchingBlock356->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock356);
  meth_meth_ast_isMatchingBlock356->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock356->definitionLine = 62;
// method isFieldDec
  struct UserObject *uo358 = (struct UserObject*)obj347;
  uo358->data[8] = emptyclosure;
  Method *meth_meth_ast_isFieldDec358 = addmethod2pos(obj347, "isFieldDec", &meth_ast_isFieldDec358, 8);
  int argcv_meth_ast_isFieldDec358[] = {0};
  meth_meth_ast_isFieldDec358->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec358);
  meth_meth_ast_isFieldDec358->definitionModule = modulename;
  meth_meth_ast_isFieldDec358->definitionLine = 63;
// method isInherits
  struct UserObject *uo360 = (struct UserObject*)obj347;
  uo360->data[9] = emptyclosure;
  Method *meth_meth_ast_isInherits360 = addmethod2pos(obj347, "isInherits", &meth_ast_isInherits360, 9);
  int argcv_meth_ast_isInherits360[] = {0};
  meth_meth_ast_isInherits360->type = alloc_MethodType(1, argcv_meth_ast_isInherits360);
  meth_meth_ast_isInherits360->definitionModule = modulename;
  meth_meth_ast_isInherits360->definitionLine = 64;
// method isMember
  struct UserObject *uo362 = (struct UserObject*)obj347;
  uo362->data[10] = emptyclosure;
  Method *meth_meth_ast_isMember362 = addmethod2pos(obj347, "isMember", &meth_ast_isMember362, 10);
  int argcv_meth_ast_isMember362[] = {0};
  meth_meth_ast_isMember362->type = alloc_MethodType(1, argcv_meth_ast_isMember362);
  meth_meth_ast_isMember362->definitionModule = modulename;
  meth_meth_ast_isMember362->definitionLine = 65;
// method isCall
  struct UserObject *uo364 = (struct UserObject*)obj347;
  uo364->data[11] = emptyclosure;
  Method *meth_meth_ast_isCall364 = addmethod2pos(obj347, "isCall", &meth_ast_isCall364, 11);
  int argcv_meth_ast_isCall364[] = {0};
  meth_meth_ast_isCall364->type = alloc_MethodType(1, argcv_meth_ast_isCall364);
  meth_meth_ast_isCall364->definitionModule = modulename;
  meth_meth_ast_isCall364->definitionLine = 66;
// method isClass
  struct UserObject *uo366 = (struct UserObject*)obj347;
  uo366->data[12] = emptyclosure;
  Method *meth_meth_ast_isClass366 = addmethod2pos(obj347, "isClass", &meth_ast_isClass366, 12);
  int argcv_meth_ast_isClass366[] = {0};
  meth_meth_ast_isClass366->type = alloc_MethodType(1, argcv_meth_ast_isClass366);
  meth_meth_ast_isClass366->definitionModule = modulename;
  meth_meth_ast_isClass366->definitionLine = 67;
// method isBind
  struct UserObject *uo368 = (struct UserObject*)obj347;
  uo368->data[13] = emptyclosure;
  Method *meth_meth_ast_isBind368 = addmethod2pos(obj347, "isBind", &meth_ast_isBind368, 13);
  int argcv_meth_ast_isBind368[] = {0};
  meth_meth_ast_isBind368->type = alloc_MethodType(1, argcv_meth_ast_isBind368);
  meth_meth_ast_isBind368->definitionModule = modulename;
  meth_meth_ast_isBind368->definitionLine = 68;
// method isObject
  struct UserObject *uo370 = (struct UserObject*)obj347;
  uo370->data[14] = emptyclosure;
  Method *meth_meth_ast_isObject370 = addmethod2pos(obj347, "isObject", &meth_ast_isObject370, 14);
  int argcv_meth_ast_isObject370[] = {0};
  meth_meth_ast_isObject370->type = alloc_MethodType(1, argcv_meth_ast_isObject370);
  meth_meth_ast_isObject370->definitionModule = modulename;
  meth_meth_ast_isObject370->definitionLine = 69;
// method isIdentifier
  struct UserObject *uo372 = (struct UserObject*)obj347;
  uo372->data[15] = emptyclosure;
  Method *meth_meth_ast_isIdentifier372 = addmethod2pos(obj347, "isIdentifier", &meth_ast_isIdentifier372, 15);
  int argcv_meth_ast_isIdentifier372[] = {0};
  meth_meth_ast_isIdentifier372->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier372);
  meth_meth_ast_isIdentifier372->definitionModule = modulename;
  meth_meth_ast_isIdentifier372->definitionLine = 70;
// method definesObject
  struct UserObject *uo374 = (struct UserObject*)obj347;
  uo374->data[16] = emptyclosure;
  Method *meth_meth_ast_definesObject374 = addmethod2pos(obj347, "definesObject", &meth_ast_definesObject374, 16);
  int argcv_meth_ast_definesObject374[] = {0};
  meth_meth_ast_definesObject374->type = alloc_MethodType(1, argcv_meth_ast_definesObject374);
  meth_meth_ast_definesObject374->definitionModule = modulename;
  meth_meth_ast_definesObject374->definitionLine = 71;
// method definesScope
  struct UserObject *uo376 = (struct UserObject*)obj347;
  uo376->data[17] = emptyclosure;
  Method *meth_meth_ast_definesScope376 = addmethod2pos(obj347, "definesScope", &meth_ast_definesScope376, 17);
  int argcv_meth_ast_definesScope376[] = {0};
  meth_meth_ast_definesScope376->type = alloc_MethodType(1, argcv_meth_ast_definesScope376);
  meth_meth_ast_definesScope376->definitionModule = modulename;
  meth_meth_ast_definesScope376->definitionLine = 72;
// method usesAsType
  struct UserObject *uo378 = (struct UserObject*)obj347;
  uo378->data[18] = emptyclosure;
  Method *meth_meth_ast_usesAsType378 = addmethod2pos(obj347, "usesAsType", &meth_ast_usesAsType378, 18);
  int argcv_meth_ast_usesAsType378[] = {1};
  meth_meth_ast_usesAsType378->type = alloc_MethodType(1, argcv_meth_ast_usesAsType378);
  meth_meth_ast_usesAsType378->definitionModule = modulename;
  meth_meth_ast_usesAsType378->definitionLine = 73;
// method hash
  struct UserObject *uo380 = (struct UserObject*)obj347;
  uo380->data[19] = emptyclosure;
  Method *meth_meth_ast_hash380 = addmethod2pos(obj347, "hash", &meth_ast_hash380, 19);
  int argcv_meth_ast_hash380[] = {0};
  meth_meth_ast_hash380->type = alloc_MethodType(1, argcv_meth_ast_hash380);
  meth_meth_ast_hash380->definitionModule = modulename;
  meth_meth_ast_hash380->definitionLine = 74;
// method asString
  struct UserObject *uo392 = (struct UserObject*)obj347;
  uo392->data[20] = emptyclosure;
  Method *meth_meth_ast_asString392 = addmethod2pos(obj347, "asString", &meth_ast_asString392, 20);
  int argcv_meth_ast_asString392[] = {0};
  meth_meth_ast_asString392->type = alloc_MethodType(1, argcv_meth_ast_asString392);
  meth_meth_ast_asString392->definitionModule = modulename;
  meth_meth_ast_asString392->definitionLine = 75;
// method isWritable
  struct UserObject *uo403 = (struct UserObject*)obj347;
  uo403->data[21] = emptyclosure;
  Method *meth_meth_ast_isWritable403 = addmethod2pos(obj347, "isWritable", &meth_ast_isWritable403, 21);
  int argcv_meth_ast_isWritable403[] = {0};
  meth_meth_ast_isWritable403->type = alloc_MethodType(1, argcv_meth_ast_isWritable403);
  meth_meth_ast_isWritable403->definitionModule = modulename;
  meth_meth_ast_isWritable403->definitionLine = 76;
// method isReadable
  struct UserObject *uo405 = (struct UserObject*)obj347;
  uo405->data[22] = emptyclosure;
  Method *meth_meth_ast_isReadable405 = addmethod2pos(obj347, "isReadable", &meth_ast_isReadable405, 22);
  int argcv_meth_ast_isReadable405[] = {0};
  meth_meth_ast_isReadable405->type = alloc_MethodType(1, argcv_meth_ast_isReadable405);
  meth_meth_ast_isReadable405->definitionModule = modulename;
  meth_meth_ast_isReadable405->definitionLine = 77;
// method isPublic
  struct UserObject *uo407 = (struct UserObject*)obj347;
  uo407->data[23] = emptyclosure;
  Method *meth_meth_ast_isPublic407 = addmethod2pos(obj347, "isPublic", &meth_ast_isPublic407, 23);
  int argcv_meth_ast_isPublic407[] = {0};
  meth_meth_ast_isPublic407->type = alloc_MethodType(1, argcv_meth_ast_isPublic407);
  meth_meth_ast_isPublic407->definitionModule = modulename;
  meth_meth_ast_isPublic407->definitionLine = 78;
// method isConfidential
  struct UserObject *uo409 = (struct UserObject*)obj347;
  uo409->data[24] = emptyclosure;
  Method *meth_meth_ast_isConfidential409 = addmethod2pos(obj347, "isConfidential", &meth_ast_isConfidential409, 24);
  int argcv_meth_ast_isConfidential409[] = {0};
  meth_meth_ast_isConfidential409->type = alloc_MethodType(1, argcv_meth_ast_isConfidential409);
  meth_meth_ast_isConfidential409->definitionModule = modulename;
  meth_meth_ast_isConfidential409->definitionLine = 79;
// method decType
  block_savedest(obj347);
  Object closure414 = createclosure(1, "decType");
  setclosureframe(closure414, stackframe);
  addtoclosure(closure414, var_unknownType);
  struct UserObject *uo414 = (struct UserObject*)obj347;
  uo414->data[25] = (Object)closure414;
  Method *meth_meth_ast_decType414 = addmethod2pos(obj347, "decType", &meth_ast_decType414, 25);
  int argcv_meth_ast_decType414[] = {0};
  meth_meth_ast_decType414->type = alloc_MethodType(1, argcv_meth_ast_decType414);
  meth_meth_ast_decType414->definitionModule = modulename;
  meth_meth_ast_decType414->definitionLine = 80;
// method accept
  block_savedest(obj347);
  Object closure424 = createclosure(1, "accept");
  setclosureframe(closure424, stackframe);
  addtoclosure(closure424, var_nullNode);
  struct UserObject *uo424 = (struct UserObject*)obj347;
  uo424->data[26] = (Object)closure424;
  Method *meth_meth_ast_accept424 = addmethod2pos(obj347, "accept", &meth_ast_accept424, 26);
  int argcv_meth_ast_accept424[] = {1};
  meth_meth_ast_accept424->type = alloc_MethodType(1, argcv_meth_ast_accept424);
  meth_meth_ast_accept424->definitionModule = modulename;
  meth_meth_ast_accept424->definitionLine = 86;
// method withParentRefs
  struct UserObject *uo427 = (struct UserObject*)obj347;
  uo427->data[27] = emptyclosure;
  Method *meth_meth_ast_withParentRefs427 = addmethod2pos(obj347, "withParentRefs", &meth_ast_withParentRefs427, 27);
  int argcv_meth_ast_withParentRefs427[] = {0};
  meth_meth_ast_withParentRefs427->type = alloc_MethodType(1, argcv_meth_ast_withParentRefs427);
  meth_meth_ast_withParentRefs427->definitionModule = modulename;
  meth_meth_ast_withParentRefs427->definitionLine = 89;
// method declarationKind
  struct UserObject *uo436 = (struct UserObject*)obj347;
  uo436->data[28] = emptyclosure;
  Method *meth_meth_ast_declarationKind436 = addmethod2pos(obj347, "declarationKind", &meth_ast_declarationKind436, 28);
  int argcv_meth_ast_declarationKind436[] = {0};
  meth_meth_ast_declarationKind436->type = alloc_MethodType(1, argcv_meth_ast_declarationKind436);
  meth_meth_ast_declarationKind436->definitionModule = modulename;
  meth_meth_ast_declarationKind436->definitionLine = 93;
// method scope
  struct UserObject *uo439 = (struct UserObject*)obj347;
  uo439->data[29] = emptyclosure;
  Method *meth_meth_ast_scope439 = addmethod2pos(obj347, "scope", &meth_ast_scope439, 29);
  int argcv_meth_ast_scope439[] = {0};
  meth_meth_ast_scope439->type = alloc_MethodType(1, argcv_meth_ast_scope439);
  meth_meth_ast_scope439->definitionModule = modulename;
  meth_meth_ast_scope439->definitionLine = 94;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo457 = (struct UserObject*)obj347;
  uo457->data[30] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457 = addmethod2pos(obj347, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent457, 30);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent457[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent457);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent457->definitionLine = 100;
// method pretty
  struct UserObject *uo476 = (struct UserObject*)obj347;
  uo476->data[31] = emptyclosure;
  Method *meth_meth_ast_pretty476 = addmethod2pos(obj347, "pretty", &meth_ast_pretty476, 31);
  int argcv_meth_ast_pretty476[] = {1};
  meth_meth_ast_pretty476->type = alloc_MethodType(1, argcv_meth_ast_pretty476);
  meth_meth_ast_pretty476->definitionModule = modulename;
  meth_meth_ast_pretty476->definitionLine = 108;
// method deepCopy
  block_savedest(obj347);
  Object closure505 = createclosure(1, "deepCopy");
  setclosureframe(closure505, stackframe);
  addtoclosure(closure505, var_nullNode);
  struct UserObject *uo505 = (struct UserObject*)obj347;
  uo505->data[32] = (Object)closure505;
  Method *meth_meth_ast_deepCopy505 = addmethod2pos(obj347, "deepCopy", &meth_ast_deepCopy505, 32);
  int argcv_meth_ast_deepCopy505[] = {0};
  meth_meth_ast_deepCopy505->type = alloc_MethodType(1, argcv_meth_ast_deepCopy505);
  meth_meth_ast_deepCopy505->definitionModule = modulename;
  meth_meth_ast_deepCopy505->definitionLine = 111;
// method isUnder
  block_savedest(obj347);
  Object closure511 = createclosure(1, "isUnder");
  setclosureframe(closure511, stackframe);
  addtoclosure(closure511, var_nullNode);
  struct UserObject *uo511 = (struct UserObject*)obj347;
  uo511->data[33] = (Object)closure511;
  Method *meth_meth_ast_isUnder511 = addmethod2pos(obj347, "isUnder", &meth_ast_isUnder511, 33);
  int argcv_meth_ast_isUnder511[] = {1};
  meth_meth_ast_isUnder511->type = alloc_MethodType(1, argcv_meth_ast_isUnder511);
  meth_meth_ast_isUnder511->definitionModule = modulename;
  meth_meth_ast_isUnder511->definitionLine = 114;
  sourceObject = obj347;
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit533 == NULL) {
    strlit533 = alloc_String("");
    gc_root(strlit533);
  }
// compiled string node returning strlit533 (depth = 4)
  adddatum2(obj347, strlit533, 1);
  sourceObject = obj347;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call535 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe534);
// compiled call node returning call535 (depth = 5)
// compiled member node returning call535 (depth = 4)
  adddatum2(obj347, call535, 2);
  sourceObject = obj347;
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe536 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call537 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe536);
// compiled call node returning call537 (depth = 5)
// compiled member node returning call537 (depth = 4)
  adddatum2(obj347, call537, 3);
  sourceObject = obj347;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nullNode (depth = 4)
  adddatum2(obj347, *var_nullNode, 4);
  sourceObject = obj347;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool538 = alloc_Boolean(0);
// compiled identifier node returning bool538 (depth = 4)
  adddatum2(obj347, bool538, 5);
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
  sourceObject = obj347;
objclass347 = obj347->class;
  objclass347->definitionModule = modulename;
  objclass347->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter347;
  self = oldself347;
  selfslot = oldselfslot347;
  stackframe = oldstackframe347;
  gc_frame_end(frame);
  return obj347;
}
Object meth_ast_symbolTableNode540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "symbolTableNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_symbolTableNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for symbolTableNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for symbolTableNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_symbolTableNode (depth = 3)
  gc_frame_end(frame);
  return *var_symbolTableNode;
}
Object meth_ast_symbolTable547(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "symbolTable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for symbolTable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for symbolTable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe549 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call550 = callmethodflags(self, "hasSymbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe549);
// compiled call node returning call550 (depth = 6)
// compiled member node returning call550 (depth = 5)
  Object if548 = done;
  if (istrue(call550)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe551 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call552 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe551);
// compiled call node returning call552 (depth = 6)
// compiled member node returning call552 (depth = 5)
    gc_frame_newslot(call552);
    if548 = call552;
  } else {
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe553 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit554 == NULL) {
    strlit554 = alloc_String("Trying to get a non-existant symbolTable ");
    gc_root(strlit554);
  }
// compiled string node returning strlit554 (depth = 6)
  gc_frame_newslot(strlit554);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe555 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call556 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe555);
// compiled call node returning call556 (depth = 7)
// compiled member node returning call556 (depth = 6)
  params[0] = strlit554;
  partcv[0] = 1;
  Object call557 = callmethod(call556, "raise",
    1, partcv, params);
  gc_frame_end(callframe553);
// compiled call node returning call557 (depth = 5)
    gc_frame_newslot(call557);
    if548 = call557;
  }
// compiled if node returning if548 (depth = 4)
  gc_frame_end(frame);
  return if548;
}
Object meth_ast_symbolTable_58__61_558(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "symbolTable:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method symbolTable:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for symbolTable:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for symbolTable:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe559 = gc_frame_new();
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_s;
  partcv[0] = 1;
  Object call560 = callmethodflags(self, "symbolTable':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe559);
// compiled call node returning call560 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe561 = gc_frame_new();
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  params[0] = self;
  partcv[0] = 1;
  Object call562 = callmethod(*var_s, "node:=",
    1, partcv, params);
  gc_frame_end(callframe561);
// compiled call node returning call562 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe563 = gc_frame_new();
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool564 = alloc_Boolean(1);
// compiled identifier node returning bool564 (depth = 6)
  gc_frame_newslot(bool564);
// call case 4: self request
  params[0] = bool564;
  partcv[0] = 1;
  Object call565 = callmethodflags(self, "hasSymbolTable:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe563);
// compiled call node returning call565 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe567 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call568 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe567);
// compiled call node returning call568 (depth = 4)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call571 = callmethod(*var_other, "hasSymbolTable",
    1, partcv, params);
  gc_frame_end(callframe570);
// compiled call node returning call571 (depth = 6)
// compiled member node returning call571 (depth = 5)
  Object if569 = done;
  if (istrue(call571)) {
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe572 = gc_frame_new();
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe573 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_other (depth = 9)
  partcv[0] = 0;
  Object call574 = callmethod(*var_other, "symbolTable",
    1, partcv, params);
  gc_frame_end(callframe573);
// compiled call node returning call574 (depth = 8)
// compiled member node returning call574 (depth = 7)
  gc_frame_newslot(call574);
// call case 4: self request
  params[0] = call574;
  partcv[0] = 1;
  Object call575 = callmethodflags(self, "symbolTable':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe572);
// compiled call node returning call575 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if569 = done;
  } else {
  }
// compiled if node returning if569 (depth = 4)
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply584(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit586 == NULL) {
    strlit586 = alloc_String("  ");
    gc_root(strlit586);
  }
// compiled string node returning strlit586 (depth = 8)
  int op_slot_right_585 = gc_frame_newslot(strlit586);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_585 = gc_frame_newslot(*var_spc);
  params[0] = strlit586;
  partcv[0] = 1;
  Object opresult588 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult588 (depth = 7)
  *var_spc = opresult588;
  if (opresult588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply595(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit597 == NULL) {
    strlit597 = alloc_String("symbols");
    gc_root(strlit597);
  }
// compiled string node returning strlit597 (depth = 8)
  int op_slot_right_596 = gc_frame_newslot(strlit597);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call600 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe599);
// compiled call node returning call600 (depth = 9)
// compiled member node returning call600 (depth = 8)
  int op_slot_left_596 = gc_frame_newslot(call600);
  params[0] = strlit597;
  partcv[0] = 1;
  Object opresult601 = callmethod(call600, "==", 1, partcv, params);
// compiled op node returning opresult601 (depth = 7)
  gc_frame_end(frame);
  return opresult601;
}
Object meth_ast_pretty576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit577 == NULL) {
    strlit577 = alloc_String("");
    gc_root(strlit577);
  }
// compiled string node returning strlit577 (depth = 5)
  *var_spc = strlit577;
  if (strlit577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe578 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_579 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num581 = alloc_Float64(0);
// compiled num node returning num581 (depth = 6)
  int op_slot_left_579 = gc_frame_newslot(num581);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult582 = callmethod(num581, "..", 1, partcv, params);
// compiled op node returning opresult582 (depth = 5)
  gc_frame_newslot(opresult582);
// starting to compile block node (depth = 5)
  Object block583 = alloc_Block(NULL, NULL, "ast", 152);
  gc_frame_newslot(block583);
// method _apply
  block_savedest(block583);
  Object closure584 = createclosure(2, "_apply");
  setclosureframe(closure584, stackframe);
  addtoclosure(closure584, var_spc);
  addtoclosure(closure584, selfslot);
  struct UserObject *uo584 = (struct UserObject*)block583;
  uo584->data[0] = (Object)closure584;
  Method *meth_meth_ast__apply584 = addmethod2pos(block583, "_apply", &meth_ast__apply584, 0);
  int argcv_meth_ast__apply584[] = {1};
  meth_meth_ast__apply584->type = alloc_MethodType(1, argcv_meth_ast__apply584);
  meth_meth_ast__apply584->definitionModule = modulename;
  meth_meth_ast__apply584->definitionLine = 146;
// compiled block node returning block583 (depth = 5)
  gc_frame_newslot(block583);
// call case 5: prelude request
  params[0] = opresult582;
  params[1] = block583;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call591 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe578);
// compiled call node returning call591 (depth = 4)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe593 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block594 = alloc_Block(NULL, NULL, "ast", 155);
  gc_frame_newslot(block594);
// method _apply
  block_savedest(block594);
  Object closure595 = createclosure(2, "_apply");
  setclosureframe(closure595, stackframe);
  addtoclosure(closure595, var_util);
  addtoclosure(closure595, selfslot);
  struct UserObject *uo595 = (struct UserObject*)block594;
  uo595->data[0] = (Object)closure595;
  Method *meth_meth_ast__apply595 = addmethod2pos(block594, "_apply", &meth_ast__apply595, 0);
  int argcv_meth_ast__apply595[] = {0};
  meth_meth_ast__apply595->type = alloc_MethodType(1, argcv_meth_ast__apply595);
  meth_meth_ast__apply595->definitionModule = modulename;
  meth_meth_ast__apply595->definitionLine = 146;
// compiled block node returning block594 (depth = 6)
  gc_frame_newslot(block594);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call604 = callmethodflags(self, "hasSymbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe603);
// compiled call node returning call604 (depth = 7)
// compiled member node returning call604 (depth = 6)
  params[0] = block594;
  partcv[0] = 1;
  Object call605 = callmethod(call604, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe593);
// compiled call node returning call605 (depth = 5)
  Object if592 = done;
  if (istrue(call605)) {
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit607 == NULL) {
    strlit607 = alloc_String("");
    gc_root(strlit607);
  }
// compiled string node returning strlit607 (depth = 6)
  int op_slot_right_606 = gc_frame_newslot(strlit607);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe610 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe611 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call612 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe611);
// compiled call node returning call612 (depth = 10)
// compiled member node returning call612 (depth = 9)
  partcv[0] = 0;
  Object call613 = callmethod(call612, "elementScopesAsString",
    1, partcv, params);
  gc_frame_end(callframe610);
// compiled call node returning call613 (depth = 8)
// compiled member node returning call613 (depth = 7)
  int op_slot_right_609 = gc_frame_newslot(call613);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit616 == NULL) {
    strlit616 = alloc_String("");
    gc_root(strlit616);
  }
// compiled string node returning strlit616 (depth = 8)
  int op_slot_right_615 = gc_frame_newslot(strlit616);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe619 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call620 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe619);
// compiled call node returning call620 (depth = 10)
// compiled member node returning call620 (depth = 9)
  int op_slot_right_618 = gc_frame_newslot(call620);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit623 == NULL) {
    strlit623 = alloc_String("): ");
    gc_root(strlit623);
  }
// compiled string node returning strlit623 (depth = 10)
  int op_slot_right_622 = gc_frame_newslot(strlit623);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe626 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call628 = callmethodflags(self, "symbolTable", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe627);
// compiled call node returning call628 (depth = 14)
// compiled member node returning call628 (depth = 13)
  partcv[0] = 0;
  Object call629 = callmethod(call628, "variety",
    1, partcv, params);
  gc_frame_end(callframe626);
// compiled call node returning call629 (depth = 12)
// compiled member node returning call629 (depth = 11)
  int op_slot_right_625 = gc_frame_newslot(call629);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit632 == NULL) {
    strlit632 = alloc_String("Symbols(");
    gc_root(strlit632);
  }
// compiled string node returning strlit632 (depth = 12)
  int op_slot_right_631 = gc_frame_newslot(strlit632);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_634 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit637 == NULL) {
    strlit637 = alloc_String("""\x0a""");
    gc_root(strlit637);
  }
// compiled string node returning strlit637 (depth = 14)
  int op_slot_right_636 = gc_frame_newslot(strlit637);
// starting to compile op node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe640 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_depth (depth = 16)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call641 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe640);
// compiled call node returning call641 (depth = 15)
  int op_slot_right_639 = gc_frame_newslot(call641);
// starting to compile string node (depth = 15)
  if (strlit643 == NULL) {
    strlit643 = alloc_String("");
    gc_root(strlit643);
  }
// compiled string node returning strlit643 (depth = 15)
  int op_slot_left_639 = gc_frame_newslot(strlit643);
  params[0] = call641;
  partcv[0] = 1;
  Object opresult644 = callmethod(strlit643, "++", 1, partcv, params);
// compiled op node returning opresult644 (depth = 14)
  int op_slot_left_636 = gc_frame_newslot(opresult644);
  params[0] = strlit637;
  partcv[0] = 1;
  Object opresult645 = callmethod(opresult644, "++", 1, partcv, params);
// compiled op node returning opresult645 (depth = 13)
  int op_slot_left_634 = gc_frame_newslot(opresult645);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult646 = callmethod(opresult645, "++", 1, partcv, params);
// compiled op node returning opresult646 (depth = 12)
  int op_slot_left_631 = gc_frame_newslot(opresult646);
  params[0] = strlit632;
  partcv[0] = 1;
  Object opresult647 = callmethod(opresult646, "++", 1, partcv, params);
// compiled op node returning opresult647 (depth = 11)
  int op_slot_left_625 = gc_frame_newslot(opresult647);
  params[0] = call629;
  partcv[0] = 1;
  Object opresult648 = callmethod(opresult647, "++", 1, partcv, params);
// compiled op node returning opresult648 (depth = 10)
  int op_slot_left_622 = gc_frame_newslot(opresult648);
  params[0] = strlit623;
  partcv[0] = 1;
  Object opresult649 = callmethod(opresult648, "++", 1, partcv, params);
// compiled op node returning opresult649 (depth = 9)
  int op_slot_left_618 = gc_frame_newslot(opresult649);
  params[0] = call620;
  partcv[0] = 1;
  Object opresult650 = callmethod(opresult649, "++", 1, partcv, params);
// compiled op node returning opresult650 (depth = 8)
  int op_slot_left_615 = gc_frame_newslot(opresult650);
  params[0] = strlit616;
  partcv[0] = 1;
  Object opresult651 = callmethod(opresult650, "++", 1, partcv, params);
// compiled op node returning opresult651 (depth = 7)
  int op_slot_left_609 = gc_frame_newslot(opresult651);
  params[0] = call613;
  partcv[0] = 1;
  Object opresult652 = callmethod(opresult651, "++", 1, partcv, params);
// compiled op node returning opresult652 (depth = 6)
  int op_slot_left_606 = gc_frame_newslot(opresult652);
  params[0] = strlit607;
  partcv[0] = 1;
  Object opresult653 = callmethod(opresult652, "++", 1, partcv, params);
// compiled op node returning opresult653 (depth = 5)
    gc_frame_newslot(opresult653);
    if592 = opresult653;
  } else {
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe654 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call655 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe654);
// compiled call node returning call655 (depth = 5)
    gc_frame_newslot(call655);
    if592 = call655;
  }
// compiled if node returning if592 (depth = 4)
  gc_frame_end(frame);
  return if592;
}
Object meth_ast_new543(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject544 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj544 = alloc_userobj2(7,7, objclass544);
  gc_frame_newslot(obj544);
if (objclass544 == NULL) {
  glfree(obj544->class->name);
  obj544->class->name = "symbolTableNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj544, self, 0);
  addmethodreal(obj544,"outer", &reader_ast_outer_545);
  Object oldself544 = self;
  struct StackFrameObject *oldstackframe544 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe544);
  gc_frame_newslot((Object)stackframe);
  self = obj544;
  Object *oldselfslot544 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter544 = (*(struct UserObject *)self).data[0], lowerouter544 = thisouter544;
  if (inheritingObject544) {
    struct UserObject *inho544 = (struct UserObject *)inheritingObject544;
    while (inho544->super != GraceDefaultObject) inho544 = (struct UserObject *)inho544->super;
    inho544->super = obj544;
    self = inheritingObject544;
    *selfslot = self;
    lowerouter544 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter544;
  }
if (objclass544 == NULL) {
  Method *reader546 = addmethodrealflags(obj544, "symbolTable'",&reader_ast_symbolTable_39__546, MFLAG_CONFIDENTIAL);
  Method *writer546 = addmethodrealflags(obj544, "symbolTable':=",&writer_ast_symbolTable_39__546, MFLAG_CONFIDENTIAL);
  reader546->definitionModule = modulename;
  writer546->definitionModule = modulename;
  reader546->definitionLine = 133;
  writer546->definitionLine = 133;
}
obj544->flags |= OFLAG_MUTABLE;
adddatum2(obj544, alloc_Undefined(), 1);
// method symbolTable
  struct UserObject *uo547 = (struct UserObject*)obj544;
  uo547->data[2] = emptyclosure;
  Method *meth_meth_ast_symbolTable547 = addmethod2pos(obj544, "symbolTable", &meth_ast_symbolTable547, 2);
  int argcv_meth_ast_symbolTable547[] = {0};
  meth_meth_ast_symbolTable547->type = alloc_MethodType(1, argcv_meth_ast_symbolTable547);
  meth_meth_ast_symbolTable547->definitionModule = modulename;
  meth_meth_ast_symbolTable547->definitionLine = 133;
// method symbolTable:=
  struct UserObject *uo558 = (struct UserObject*)obj544;
  uo558->data[3] = emptyclosure;
  Method *meth_meth_ast_symbolTable_58__61_558 = addmethod2pos(obj544, "symbolTable:=", &meth_ast_symbolTable_58__61_558, 3);
  int argcv_meth_ast_symbolTable_58__61_558[] = {1};
  meth_meth_ast_symbolTable_58__61_558->type = alloc_MethodType(1, argcv_meth_ast_symbolTable_58__61_558);
  meth_meth_ast_symbolTable_58__61_558->definitionModule = modulename;
  meth_meth_ast_symbolTable_58__61_558->definitionLine = 138;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo566 = (struct UserObject*)obj544;
  uo566->data[4] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566 = addmethod2pos(obj544, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent566, 4);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent566[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent566);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566->definitionLine = 143;
// method pretty
  block_savedest(obj544);
  Object closure576 = createclosure(1, "pretty");
  setclosureframe(closure576, stackframe);
  addtoclosure(closure576, var_util);
  struct UserObject *uo576 = (struct UserObject*)obj544;
  uo576->data[5] = (Object)closure576;
  Method *meth_meth_ast_pretty576 = addmethod2pos(obj544, "pretty", &meth_ast_pretty576, 5);
  int argcv_meth_ast_pretty576[] = {1};
  meth_meth_ast_pretty576->type = alloc_MethodType(1, argcv_meth_ast_pretty576);
  meth_meth_ast_pretty576->definitionModule = modulename;
  meth_meth_ast_pretty576->definitionLine = 150;
  sourceObject = obj544;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe656 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call657 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe656);
// compiled call node returning call657 (depth = 4)
  struct UserObject *obj544_uo = (struct UserObject *)obj544;
  obj544_uo->super = call657;
  sourceObject = obj544;
  adddatum2(obj544, undefined, 1);
  sourceObject = obj544;
  sourceObject = obj544;
  sourceObject = obj544;
  sourceObject = obj544;
objclass544 = obj544->class;
  objclass544->definitionModule = modulename;
  objclass544->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter544;
  self = oldself544;
  selfslot = oldselfslot544;
  stackframe = oldstackframe544;
  gc_frame_end(frame);
  return obj544;
}
Object meth_ast_new543_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject544 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj544 = alloc_userobj2(7,7, objclass544);
  gc_frame_newslot(obj544);
if (objclass544 == NULL) {
  glfree(obj544->class->name);
  obj544->class->name = "symbolTableNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj544, self, 0);
  addmethodreal(obj544,"outer", &reader_ast_outer_545);
  Object oldself544 = self;
  struct StackFrameObject *oldstackframe544 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe544);
  gc_frame_newslot((Object)stackframe);
  self = obj544;
  Object *oldselfslot544 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter544 = (*(struct UserObject *)self).data[0], lowerouter544 = thisouter544;
  if (inheritingObject544) {
    struct UserObject *inho544 = (struct UserObject *)inheritingObject544;
    while (inho544->super != GraceDefaultObject) inho544 = (struct UserObject *)inho544->super;
    inho544->super = obj544;
    self = inheritingObject544;
    *selfslot = self;
    lowerouter544 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter544;
  }
if (objclass544 == NULL) {
  Method *reader546 = addmethodrealflags(obj544, "symbolTable'",&reader_ast_symbolTable_39__546, MFLAG_CONFIDENTIAL);
  Method *writer546 = addmethodrealflags(obj544, "symbolTable':=",&writer_ast_symbolTable_39__546, MFLAG_CONFIDENTIAL);
  reader546->definitionModule = modulename;
  writer546->definitionModule = modulename;
  reader546->definitionLine = 133;
  writer546->definitionLine = 133;
}
obj544->flags |= OFLAG_MUTABLE;
adddatum2(obj544, alloc_Undefined(), 1);
// method symbolTable
  struct UserObject *uo547 = (struct UserObject*)obj544;
  uo547->data[2] = emptyclosure;
  Method *meth_meth_ast_symbolTable547 = addmethod2pos(obj544, "symbolTable", &meth_ast_symbolTable547, 2);
  int argcv_meth_ast_symbolTable547[] = {0};
  meth_meth_ast_symbolTable547->type = alloc_MethodType(1, argcv_meth_ast_symbolTable547);
  meth_meth_ast_symbolTable547->definitionModule = modulename;
  meth_meth_ast_symbolTable547->definitionLine = 133;
// method symbolTable:=
  struct UserObject *uo558 = (struct UserObject*)obj544;
  uo558->data[3] = emptyclosure;
  Method *meth_meth_ast_symbolTable_58__61_558 = addmethod2pos(obj544, "symbolTable:=", &meth_ast_symbolTable_58__61_558, 3);
  int argcv_meth_ast_symbolTable_58__61_558[] = {1};
  meth_meth_ast_symbolTable_58__61_558->type = alloc_MethodType(1, argcv_meth_ast_symbolTable_58__61_558);
  meth_meth_ast_symbolTable_58__61_558->definitionModule = modulename;
  meth_meth_ast_symbolTable_58__61_558->definitionLine = 138;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo566 = (struct UserObject*)obj544;
  uo566->data[4] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566 = addmethod2pos(obj544, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent566, 4);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent566[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent566);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent566->definitionLine = 143;
// method pretty
  block_savedest(obj544);
  Object closure576 = createclosure(1, "pretty");
  setclosureframe(closure576, stackframe);
  addtoclosure(closure576, var_util);
  struct UserObject *uo576 = (struct UserObject*)obj544;
  uo576->data[5] = (Object)closure576;
  Method *meth_meth_ast_pretty576 = addmethod2pos(obj544, "pretty", &meth_ast_pretty576, 5);
  int argcv_meth_ast_pretty576[] = {1};
  meth_meth_ast_pretty576->type = alloc_MethodType(1, argcv_meth_ast_pretty576);
  meth_meth_ast_pretty576->definitionModule = modulename;
  meth_meth_ast_pretty576->definitionLine = 150;
  sourceObject = obj544;
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe656 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call657 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe656);
// compiled call node returning call657 (depth = 4)
  struct UserObject *obj544_uo = (struct UserObject *)obj544;
  obj544_uo->super = call657;
  sourceObject = obj544;
  adddatum2(obj544, undefined, 1);
  sourceObject = obj544;
  sourceObject = obj544;
  sourceObject = obj544;
  sourceObject = obj544;
objclass544 = obj544->class;
  objclass544->definitionModule = modulename;
  objclass544->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter544;
  self = oldself544;
  selfslot = oldselfslot544;
  stackframe = oldstackframe544;
  gc_frame_end(frame);
  return obj544;
}
Object meth_ast_toGrace662(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit663 == NULL) {
    strlit663 = alloc_String("// null");
    gc_root(strlit663);
  }
// compiled string node returning strlit663 (depth = 3)
  gc_frame_end(frame);
  return strlit663;
}
Object meth_ast_nullNode667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nullNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nullNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nullNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹nullNode›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_nullNode (depth = 3)
  gc_frame_end(frame);
  return *var_nullNode;
}
Object meth_ast_ifNode668(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ifNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for ifNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ifNode (depth = 3)
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast_accept_40__41_from679(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe681 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call682 = callmethod(*var_visitor, "visitIf()up",
    2, partcv, params);
  gc_frame_end(callframe681);
// compiled call node returning call682 (depth = 5)
  Object if680 = done;
  if (istrue(call682)) {
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe683 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe684 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call685 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe684);
// compiled call node returning call685 (depth = 7)
// compiled member node returning call685 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call686 = callmethod(call685, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe683);
// compiled call node returning call686 (depth = 5)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe687 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call689 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe688);
// compiled call node returning call689 (depth = 7)
// compiled member node returning call689 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call690 = callmethod(call689, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe687);
// compiled call node returning call690 (depth = 5)
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe691 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe692 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call693 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe692);
// compiled call node returning call693 (depth = 7)
// compiled member node returning call693 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call694 = callmethod(call693, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe691);
// compiled call node returning call694 (depth = 5)
    gc_frame_newslot(call694);
    if680 = call694;
  } else {
  }
// compiled if node returning if680 (depth = 4)
  gc_frame_end(frame);
  return if680;
}
Object meth_ast_map_40__41_parent695(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe696 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call697 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe696);
// compiled call node returning call697 (depth = 5)
  *var_n = call697;
  if (call697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe698 = gc_frame_new();
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe699 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call701 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe700);
// compiled call node returning call701 (depth = 8)
// compiled member node returning call701 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call702 = callmethod(call701, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe699);
// compiled call node returning call702 (depth = 6)
  gc_frame_newslot(call702);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call702;
  partcv[0] = 1;
  Object call703 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe698);
// compiled call node returning call703 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe704 = gc_frame_new();
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe705 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe706 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call707 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe706);
// compiled call node returning call707 (depth = 8)
// compiled member node returning call707 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call708 = callmethod(call707, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe705);
// compiled call node returning call708 (depth = 6)
  gc_frame_newslot(call708);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call708;
  partcv[0] = 1;
  Object call709 = callmethod(*var_n, "thenblock:=",
    1, partcv, params);
  gc_frame_end(callframe704);
// compiled call node returning call709 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe710 = gc_frame_new();
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe711 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe712 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call713 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe712);
// compiled call node returning call713 (depth = 8)
// compiled member node returning call713 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call714 = callmethod(call713, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe711);
// compiled call node returning call714 (depth = 6)
  gc_frame_newslot(call714);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call714;
  partcv[0] = 1;
  Object call715 = callmethod(*var_n, "elseblock:=",
    1, partcv, params);
  gc_frame_end(callframe710);
// compiled call node returning call715 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe716 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call717 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe716);
// compiled call node returning call717 (depth = 5)
  *var_n = call717;
  if (call717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit729 == NULL) {
    strlit729 = alloc_String("  ");
    gc_root(strlit729);
  }
// compiled string node returning strlit729 (depth = 8)
  int op_slot_right_728 = gc_frame_newslot(strlit729);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_728 = gc_frame_newslot(*var_spc);
  params[0] = strlit729;
  partcv[0] = 1;
  Object opresult731 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult731 (depth = 7)
  *var_spc = opresult731;
  if (opresult731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply828(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe830 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num832 = alloc_Float64(2);
// compiled num node returning num832 (depth = 11)
  int op_slot_right_831 = gc_frame_newslot(num832);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_831 = gc_frame_newslot(*var_depth);
  params[0] = num832;
  partcv[0] = 1;
  Object sum834 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum834 (depth = 10)
  gc_frame_newslot(sum834);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  params[0] = sum834;
  partcv[0] = 1;
  Object call835 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe830);
// compiled call node returning call835 (depth = 9)
  int op_slot_right_829 = gc_frame_newslot(call835);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_837 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit840 == NULL) {
    strlit840 = alloc_String("""\x0a""  ");
    gc_root(strlit840);
  }
// compiled string node returning strlit840 (depth = 11)
  int op_slot_right_839 = gc_frame_newslot(strlit840);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_839 = gc_frame_newslot(*var_s);
  params[0] = strlit840;
  partcv[0] = 1;
  Object opresult842 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult842 (depth = 10)
  int op_slot_left_837 = gc_frame_newslot(opresult842);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult843 = callmethod(opresult842, "++", 1, partcv, params);
// compiled op node returning opresult843 (depth = 9)
  int op_slot_left_829 = gc_frame_newslot(opresult843);
  params[0] = call835;
  partcv[0] = 1;
  Object opresult844 = callmethod(opresult843, "++", 1, partcv, params);
// compiled op node returning opresult844 (depth = 8)
  *var_s = opresult844;
  if (opresult844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply867(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe869 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num871 = alloc_Float64(2);
// compiled num node returning num871 (depth = 11)
  int op_slot_right_870 = gc_frame_newslot(num871);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_870 = gc_frame_newslot(*var_depth);
  params[0] = num871;
  partcv[0] = 1;
  Object sum873 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum873 (depth = 10)
  gc_frame_newslot(sum873);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  params[0] = sum873;
  partcv[0] = 1;
  Object call874 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe869);
// compiled call node returning call874 (depth = 9)
  int op_slot_right_868 = gc_frame_newslot(call874);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_876 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit879 == NULL) {
    strlit879 = alloc_String("""\x0a""  ");
    gc_root(strlit879);
  }
// compiled string node returning strlit879 (depth = 11)
  int op_slot_right_878 = gc_frame_newslot(strlit879);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_878 = gc_frame_newslot(*var_s);
  params[0] = strlit879;
  partcv[0] = 1;
  Object opresult881 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult881 (depth = 10)
  int op_slot_left_876 = gc_frame_newslot(opresult881);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult882 = callmethod(opresult881, "++", 1, partcv, params);
// compiled op node returning opresult882 (depth = 9)
  int op_slot_left_868 = gc_frame_newslot(opresult882);
  params[0] = call874;
  partcv[0] = 1;
  Object opresult883 = callmethod(opresult882, "++", 1, partcv, params);
// compiled op node returning opresult883 (depth = 8)
  *var_s = opresult883;
  if (opresult883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty719(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit720 == NULL) {
    strlit720 = alloc_String("");
    gc_root(strlit720);
  }
// compiled string node returning strlit720 (depth = 5)
  *var_spc = strlit720;
  if (strlit720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe721 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_722 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num724 = alloc_Float64(0);
// compiled num node returning num724 (depth = 6)
  int op_slot_left_722 = gc_frame_newslot(num724);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult725 = callmethod(num724, "..", 1, partcv, params);
// compiled op node returning opresult725 (depth = 5)
  gc_frame_newslot(opresult725);
// starting to compile block node (depth = 5)
  Object block726 = alloc_Block(NULL, NULL, "ast", 195);
  gc_frame_newslot(block726);
// method _apply
  block_savedest(block726);
  Object closure727 = createclosure(2, "_apply");
  setclosureframe(closure727, stackframe);
  addtoclosure(closure727, var_spc);
  addtoclosure(closure727, selfslot);
  struct UserObject *uo727 = (struct UserObject*)block726;
  uo727->data[0] = (Object)closure727;
  Method *meth_meth_ast__apply727 = addmethod2pos(block726, "_apply", &meth_ast__apply727, 0);
  int argcv_meth_ast__apply727[] = {1};
  meth_meth_ast__apply727->type = alloc_MethodType(1, argcv_meth_ast__apply727);
  meth_meth_ast__apply727->definitionModule = modulename;
  meth_meth_ast__apply727->definitionLine = 189;
// compiled block node returning block726 (depth = 5)
  gc_frame_newslot(block726);
// call case 5: prelude request
  params[0] = opresult725;
  params[1] = block726;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call734 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe721);
// compiled call node returning call734 (depth = 4)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit736 == NULL) {
    strlit736 = alloc_String("""\x0a""");
    gc_root(strlit736);
  }
// compiled string node returning strlit736 (depth = 6)
  int op_slot_right_735 = gc_frame_newslot(strlit736);
// starting to compile call node (depth = 6)
  int callframe738 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call739 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled call node returning call739 (depth = 6)
  int op_slot_left_735 = gc_frame_newslot(call739);
  params[0] = strlit736;
  partcv[0] = 1;
  Object opresult740 = callmethod(call739, "++", 1, partcv, params);
// compiled op node returning opresult740 (depth = 5)
  *var_s = opresult740;
  if (opresult740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe742 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num744 = alloc_Float64(1);
// compiled num node returning num744 (depth = 8)
  int op_slot_right_743 = gc_frame_newslot(num744);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_743 = gc_frame_newslot(*var_depth);
  params[0] = num744;
  partcv[0] = 1;
  Object sum746 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum746 (depth = 7)
  gc_frame_newslot(sum746);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call748 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe747);
// compiled call node returning call748 (depth = 8)
// compiled member node returning call748 (depth = 7)
  params[0] = sum746;
  partcv[0] = 1;
  Object call749 = callmethod(call748, "pretty",
    1, partcv, params);
  gc_frame_end(callframe742);
// compiled call node returning call749 (depth = 6)
  int op_slot_right_741 = gc_frame_newslot(call749);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_751 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_751 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult753 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult753 (depth = 6)
  int op_slot_left_741 = gc_frame_newslot(opresult753);
  params[0] = call749;
  partcv[0] = 1;
  Object opresult754 = callmethod(opresult753, "++", 1, partcv, params);
// compiled op node returning opresult754 (depth = 5)
  *var_s = opresult754;
  if (opresult754 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit757 == NULL) {
    strlit757 = alloc_String("""\x0a""");
    gc_root(strlit757);
  }
// compiled string node returning strlit757 (depth = 6)
  int op_slot_right_756 = gc_frame_newslot(strlit757);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_756 = gc_frame_newslot(*var_s);
  params[0] = strlit757;
  partcv[0] = 1;
  Object opresult759 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult759 (depth = 5)
  *var_s = opresult759;
  if (opresult759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit763 == NULL) {
    strlit763 = alloc_String("symbols");
    gc_root(strlit763);
  }
// compiled string node returning strlit763 (depth = 6)
  int op_slot_right_762 = gc_frame_newslot(strlit763);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe765 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call766 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe765);
// compiled call node returning call766 (depth = 7)
// compiled member node returning call766 (depth = 6)
  int op_slot_left_762 = gc_frame_newslot(call766);
  params[0] = strlit763;
  partcv[0] = 1;
  Object opresult767 = callmethod(call766, "==", 1, partcv, params);
// compiled op node returning opresult767 (depth = 5)
  Object if761 = done;
  if (istrue(opresult767)) {
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit770 == NULL) {
    strlit770 = alloc_String("""\x0a""");
    gc_root(strlit770);
  }
// compiled string node returning strlit770 (depth = 8)
  int op_slot_right_769 = gc_frame_newslot(strlit770);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe773 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num775 = alloc_Float64(2);
// compiled num node returning num775 (depth = 11)
  int op_slot_right_774 = gc_frame_newslot(num775);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_774 = gc_frame_newslot(*var_depth);
  params[0] = num775;
  partcv[0] = 1;
  Object sum777 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum777 (depth = 10)
  gc_frame_newslot(sum777);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe778 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call779 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe778);
// compiled call node returning call779 (depth = 11)
// compiled member node returning call779 (depth = 10)
  params[0] = sum777;
  partcv[0] = 1;
  Object call780 = callmethod(call779, "pretty",
    1, partcv, params);
  gc_frame_end(callframe773);
// compiled call node returning call780 (depth = 9)
  int op_slot_right_772 = gc_frame_newslot(call780);
// starting to compile string node (depth = 9)
  if (strlit782 == NULL) {
    strlit782 = alloc_String("Then: ");
    gc_root(strlit782);
  }
// compiled string node returning strlit782 (depth = 9)
  int op_slot_left_772 = gc_frame_newslot(strlit782);
  params[0] = call780;
  partcv[0] = 1;
  Object opresult783 = callmethod(strlit782, "++", 1, partcv, params);
// compiled op node returning opresult783 (depth = 8)
  int op_slot_left_769 = gc_frame_newslot(opresult783);
  params[0] = strlit770;
  partcv[0] = 1;
  Object opresult784 = callmethod(opresult783, "++", 1, partcv, params);
// compiled op node returning opresult784 (depth = 7)
  int op_slot_right_768 = gc_frame_newslot(opresult784);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_786 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_786 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult788 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult788 (depth = 7)
  int op_slot_left_768 = gc_frame_newslot(opresult788);
  params[0] = opresult784;
  partcv[0] = 1;
  Object opresult789 = callmethod(opresult788, "++", 1, partcv, params);
// compiled op node returning opresult789 (depth = 6)
  *var_s = opresult789;
  if (opresult789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit793 == NULL) {
    strlit793 = alloc_String("");
    gc_root(strlit793);
  }
// compiled string node returning strlit793 (depth = 8)
  int op_slot_right_792 = gc_frame_newslot(strlit793);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe796 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num798 = alloc_Float64(2);
// compiled num node returning num798 (depth = 11)
  int op_slot_right_797 = gc_frame_newslot(num798);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_797 = gc_frame_newslot(*var_depth);
  params[0] = num798;
  partcv[0] = 1;
  Object sum800 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum800 (depth = 10)
  gc_frame_newslot(sum800);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe801 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call802 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe801);
// compiled call node returning call802 (depth = 11)
// compiled member node returning call802 (depth = 10)
  params[0] = sum800;
  partcv[0] = 1;
  Object call803 = callmethod(call802, "pretty",
    1, partcv, params);
  gc_frame_end(callframe796);
// compiled call node returning call803 (depth = 9)
  int op_slot_right_795 = gc_frame_newslot(call803);
// starting to compile string node (depth = 9)
  if (strlit805 == NULL) {
    strlit805 = alloc_String("Else: ");
    gc_root(strlit805);
  }
// compiled string node returning strlit805 (depth = 9)
  int op_slot_left_795 = gc_frame_newslot(strlit805);
  params[0] = call803;
  partcv[0] = 1;
  Object opresult806 = callmethod(strlit805, "++", 1, partcv, params);
// compiled op node returning opresult806 (depth = 8)
  int op_slot_left_792 = gc_frame_newslot(opresult806);
  params[0] = strlit793;
  partcv[0] = 1;
  Object opresult807 = callmethod(opresult806, "++", 1, partcv, params);
// compiled op node returning opresult807 (depth = 7)
  int op_slot_right_791 = gc_frame_newslot(opresult807);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_809 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_809 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult811 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult811 (depth = 7)
  int op_slot_left_791 = gc_frame_newslot(opresult811);
  params[0] = opresult807;
  partcv[0] = 1;
  Object opresult812 = callmethod(opresult811, "++", 1, partcv, params);
// compiled op node returning opresult812 (depth = 6)
  *var_s = opresult812;
  if (opresult812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if761 = done;
  } else {
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit815 == NULL) {
    strlit815 = alloc_String("Then:");
    gc_root(strlit815);
  }
// compiled string node returning strlit815 (depth = 7)
  int op_slot_right_814 = gc_frame_newslot(strlit815);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_817 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_817 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult819 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult819 (depth = 7)
  int op_slot_left_814 = gc_frame_newslot(opresult819);
  params[0] = strlit815;
  partcv[0] = 1;
  Object opresult820 = callmethod(opresult819, "++", 1, partcv, params);
// compiled op node returning opresult820 (depth = 6)
  *var_s = opresult820;
  if (opresult820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe822 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe823 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe824 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call825 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe824);
// compiled call node returning call825 (depth = 9)
// compiled member node returning call825 (depth = 8)
  partcv[0] = 0;
  Object call826 = callmethod(call825, "body",
    1, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call826 (depth = 7)
// compiled member node returning call826 (depth = 6)
  gc_frame_newslot(call826);
// starting to compile block node (depth = 6)
  Object block827 = alloc_Block(NULL, NULL, "ast", 206);
  gc_frame_newslot(block827);
// method _apply
  block_savedest(block827);
  Object closure828 = createclosure(4, "_apply");
  setclosureframe(closure828, stackframe);
  addtoclosure(closure828, var_depth);
  addtoclosure(closure828, var_spc);
  addtoclosure(closure828, var_s);
  addtoclosure(closure828, selfslot);
  struct UserObject *uo828 = (struct UserObject*)block827;
  uo828->data[0] = (Object)closure828;
  Method *meth_meth_ast__apply828 = addmethod2pos(block827, "_apply", &meth_ast__apply828, 0);
  int argcv_meth_ast__apply828[] = {1};
  meth_meth_ast__apply828->type = alloc_MethodType(1, argcv_meth_ast__apply828);
  meth_meth_ast__apply828->definitionModule = modulename;
  meth_meth_ast__apply828->definitionLine = 206;
// compiled block node returning block827 (depth = 6)
  gc_frame_newslot(block827);
// call case 5: prelude request
  params[0] = call826;
  params[1] = block827;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call847 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe822);
// compiled call node returning call847 (depth = 5)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit849 == NULL) {
    strlit849 = alloc_String("""\x0a""");
    gc_root(strlit849);
  }
// compiled string node returning strlit849 (depth = 7)
  int op_slot_right_848 = gc_frame_newslot(strlit849);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_848 = gc_frame_newslot(*var_s);
  params[0] = strlit849;
  partcv[0] = 1;
  Object opresult851 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult851 (depth = 6)
  *var_s = opresult851;
  if (opresult851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit854 == NULL) {
    strlit854 = alloc_String("Else:");
    gc_root(strlit854);
  }
// compiled string node returning strlit854 (depth = 7)
  int op_slot_right_853 = gc_frame_newslot(strlit854);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_856 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_856 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult858 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult858 (depth = 7)
  int op_slot_left_853 = gc_frame_newslot(opresult858);
  params[0] = strlit854;
  partcv[0] = 1;
  Object opresult859 = callmethod(opresult858, "++", 1, partcv, params);
// compiled op node returning opresult859 (depth = 6)
  *var_s = opresult859;
  if (opresult859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe861 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe862 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call864 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe863);
// compiled call node returning call864 (depth = 9)
// compiled member node returning call864 (depth = 8)
  partcv[0] = 0;
  Object call865 = callmethod(call864, "body",
    1, partcv, params);
  gc_frame_end(callframe862);
// compiled call node returning call865 (depth = 7)
// compiled member node returning call865 (depth = 6)
  gc_frame_newslot(call865);
// starting to compile block node (depth = 6)
  Object block866 = alloc_Block(NULL, NULL, "ast", 211);
  gc_frame_newslot(block866);
// method _apply
  block_savedest(block866);
  Object closure867 = createclosure(4, "_apply");
  setclosureframe(closure867, stackframe);
  addtoclosure(closure867, var_depth);
  addtoclosure(closure867, var_spc);
  addtoclosure(closure867, var_s);
  addtoclosure(closure867, selfslot);
  struct UserObject *uo867 = (struct UserObject*)block866;
  uo867->data[0] = (Object)closure867;
  Method *meth_meth_ast__apply867 = addmethod2pos(block866, "_apply", &meth_ast__apply867, 0);
  int argcv_meth_ast__apply867[] = {1};
  meth_meth_ast__apply867->type = alloc_MethodType(1, argcv_meth_ast__apply867);
  meth_meth_ast__apply867->definitionModule = modulename;
  meth_meth_ast__apply867->definitionLine = 211;
// compiled block node returning block866 (depth = 6)
  gc_frame_newslot(block866);
// call case 5: prelude request
  params[0] = call865;
  params[1] = block866;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call886 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe861);
// compiled call node returning call886 (depth = 5)
    gc_frame_newslot(call886);
    if761 = call886;
  }
// compiled if node returning if761 (depth = 4)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply899(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit901 == NULL) {
    strlit901 = alloc_String("    ");
    gc_root(strlit901);
  }
// compiled string node returning strlit901 (depth = 8)
  int op_slot_right_900 = gc_frame_newslot(strlit901);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_900 = gc_frame_newslot(*var_spc);
  params[0] = strlit901;
  partcv[0] = 1;
  Object opresult903 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult903 (depth = 7)
  *var_spc = opresult903;
  if (opresult903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply926(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe928 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num930 = alloc_Float64(1);
// compiled num node returning num930 (depth = 10)
  int op_slot_right_929 = gc_frame_newslot(num930);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_929 = gc_frame_newslot(*var_depth);
  params[0] = num930;
  partcv[0] = 1;
  Object sum932 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum932 (depth = 9)
  gc_frame_newslot(sum932);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  params[0] = sum932;
  partcv[0] = 1;
  Object call933 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe928);
// compiled call node returning call933 (depth = 8)
  int op_slot_right_927 = gc_frame_newslot(call933);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit936 == NULL) {
    strlit936 = alloc_String("    ");
    gc_root(strlit936);
  }
// compiled string node returning strlit936 (depth = 9)
  int op_slot_right_935 = gc_frame_newslot(strlit936);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_938 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit941 == NULL) {
    strlit941 = alloc_String("""\x0a""");
    gc_root(strlit941);
  }
// compiled string node returning strlit941 (depth = 11)
  int op_slot_right_940 = gc_frame_newslot(strlit941);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_940 = gc_frame_newslot(*var_s);
  params[0] = strlit941;
  partcv[0] = 1;
  Object opresult943 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult943 (depth = 10)
  int op_slot_left_938 = gc_frame_newslot(opresult943);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult944 = callmethod(opresult943, "++", 1, partcv, params);
// compiled op node returning opresult944 (depth = 9)
  int op_slot_left_935 = gc_frame_newslot(opresult944);
  params[0] = strlit936;
  partcv[0] = 1;
  Object opresult945 = callmethod(opresult944, "++", 1, partcv, params);
// compiled op node returning opresult945 (depth = 8)
  int op_slot_left_927 = gc_frame_newslot(opresult945);
  params[0] = call933;
  partcv[0] = 1;
  Object opresult946 = callmethod(opresult945, "++", 1, partcv, params);
// compiled op node returning opresult946 (depth = 7)
  *var_s = opresult946;
  if (opresult946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply977(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe979 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num981 = alloc_Float64(1);
// compiled num node returning num981 (depth = 11)
  int op_slot_right_980 = gc_frame_newslot(num981);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_980 = gc_frame_newslot(*var_depth);
  params[0] = num981;
  partcv[0] = 1;
  Object sum983 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum983 (depth = 10)
  gc_frame_newslot(sum983);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  params[0] = sum983;
  partcv[0] = 1;
  Object call984 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe979);
// compiled call node returning call984 (depth = 9)
  int op_slot_right_978 = gc_frame_newslot(call984);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit987 == NULL) {
    strlit987 = alloc_String("    ");
    gc_root(strlit987);
  }
// compiled string node returning strlit987 (depth = 10)
  int op_slot_right_986 = gc_frame_newslot(strlit987);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_989 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit992 == NULL) {
    strlit992 = alloc_String("""\x0a""");
    gc_root(strlit992);
  }
// compiled string node returning strlit992 (depth = 12)
  int op_slot_right_991 = gc_frame_newslot(strlit992);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_991 = gc_frame_newslot(*var_s);
  params[0] = strlit992;
  partcv[0] = 1;
  Object opresult994 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult994 (depth = 11)
  int op_slot_left_989 = gc_frame_newslot(opresult994);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult995 = callmethod(opresult994, "++", 1, partcv, params);
// compiled op node returning opresult995 (depth = 10)
  int op_slot_left_986 = gc_frame_newslot(opresult995);
  params[0] = strlit987;
  partcv[0] = 1;
  Object opresult996 = callmethod(opresult995, "++", 1, partcv, params);
// compiled op node returning opresult996 (depth = 9)
  int op_slot_left_978 = gc_frame_newslot(opresult996);
  params[0] = call984;
  partcv[0] = 1;
  Object opresult997 = callmethod(opresult996, "++", 1, partcv, params);
// compiled op node returning opresult997 (depth = 8)
  *var_s = opresult997;
  if (opresult997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit888 == NULL) {
    strlit888 = alloc_String("");
    gc_root(strlit888);
  }
// compiled string node returning strlit888 (depth = 5)
  *var_spc = strlit888;
  if (strlit888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe889 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num892 = alloc_Float64(1);
// compiled num node returning num892 (depth = 7)
  int op_slot_right_891 = gc_frame_newslot(num892);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_891 = gc_frame_newslot(*var_depth);
  params[0] = num892;
  partcv[0] = 1;
  Object diff894 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff894 (depth = 6)
  int op_slot_right_890 = gc_frame_newslot(diff894);
// starting to compile num node (depth = 6)
  Object num896 = alloc_Float64(0);
// compiled num node returning num896 (depth = 6)
  int op_slot_left_890 = gc_frame_newslot(num896);
  params[0] = diff894;
  partcv[0] = 1;
  Object opresult897 = callmethod(num896, "..", 1, partcv, params);
// compiled op node returning opresult897 (depth = 5)
  gc_frame_newslot(opresult897);
// starting to compile block node (depth = 5)
  Object block898 = alloc_Block(NULL, NULL, "ast", 219);
  gc_frame_newslot(block898);
// method _apply
  block_savedest(block898);
  Object closure899 = createclosure(2, "_apply");
  setclosureframe(closure899, stackframe);
  addtoclosure(closure899, var_spc);
  addtoclosure(closure899, selfslot);
  struct UserObject *uo899 = (struct UserObject*)block898;
  uo899->data[0] = (Object)closure899;
  Method *meth_meth_ast__apply899 = addmethod2pos(block898, "_apply", &meth_ast__apply899, 0);
  int argcv_meth_ast__apply899[] = {1};
  meth_meth_ast__apply899->type = alloc_MethodType(1, argcv_meth_ast__apply899);
  meth_meth_ast__apply899->definitionModule = modulename;
  meth_meth_ast__apply899->definitionLine = 211;
// compiled block node returning block898 (depth = 5)
  gc_frame_newslot(block898);
// call case 5: prelude request
  params[0] = opresult897;
  params[1] = block898;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call906 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe889);
// compiled call node returning call906 (depth = 4)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit908 == NULL) {
    strlit908 = alloc_String(") then {");
    gc_root(strlit908);
  }
// compiled string node returning strlit908 (depth = 6)
  int op_slot_right_907 = gc_frame_newslot(strlit908);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe911 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num912 = alloc_Float64(0);
// compiled num node returning num912 (depth = 8)
  gc_frame_newslot(num912);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe913 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call914 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe913);
// compiled call node returning call914 (depth = 9)
// compiled member node returning call914 (depth = 8)
  params[0] = num912;
  partcv[0] = 1;
  Object call915 = callmethod(call914, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe911);
// compiled call node returning call915 (depth = 7)
  int op_slot_right_910 = gc_frame_newslot(call915);
// starting to compile string node (depth = 7)
  if (strlit917 == NULL) {
    strlit917 = alloc_String("if (");
    gc_root(strlit917);
  }
// compiled string node returning strlit917 (depth = 7)
  int op_slot_left_910 = gc_frame_newslot(strlit917);
  params[0] = call915;
  partcv[0] = 1;
  Object opresult918 = callmethod(strlit917, "++", 1, partcv, params);
// compiled op node returning opresult918 (depth = 6)
  int op_slot_left_907 = gc_frame_newslot(opresult918);
  params[0] = strlit908;
  partcv[0] = 1;
  Object opresult919 = callmethod(opresult918, "++", 1, partcv, params);
// compiled op node returning opresult919 (depth = 5)
  *var_s = opresult919;
  if (opresult919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe920 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe921 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe922 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call923 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe922);
// compiled call node returning call923 (depth = 8)
// compiled member node returning call923 (depth = 7)
  partcv[0] = 0;
  Object call924 = callmethod(call923, "body",
    1, partcv, params);
  gc_frame_end(callframe921);
// compiled call node returning call924 (depth = 6)
// compiled member node returning call924 (depth = 5)
  gc_frame_newslot(call924);
// starting to compile block node (depth = 5)
  Object block925 = alloc_Block(NULL, NULL, "ast", 223);
  gc_frame_newslot(block925);
// method _apply
  block_savedest(block925);
  Object closure926 = createclosure(4, "_apply");
  setclosureframe(closure926, stackframe);
  addtoclosure(closure926, var_depth);
  addtoclosure(closure926, var_spc);
  addtoclosure(closure926, var_s);
  addtoclosure(closure926, selfslot);
  struct UserObject *uo926 = (struct UserObject*)block925;
  uo926->data[0] = (Object)closure926;
  Method *meth_meth_ast__apply926 = addmethod2pos(block925, "_apply", &meth_ast__apply926, 0);
  int argcv_meth_ast__apply926[] = {1};
  meth_meth_ast__apply926->type = alloc_MethodType(1, argcv_meth_ast__apply926);
  meth_meth_ast__apply926->definitionModule = modulename;
  meth_meth_ast__apply926->definitionLine = 223;
// compiled block node returning block925 (depth = 5)
  gc_frame_newslot(block925);
// call case 5: prelude request
  params[0] = call924;
  params[1] = block925;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call949 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compiled call node returning call949 (depth = 4)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num952 = alloc_Float64(0);
// compiled num node returning num952 (depth = 6)
  int op_slot_right_951 = gc_frame_newslot(num952);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe954 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe955 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call956 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe955);
// compiled call node returning call956 (depth = 9)
// compiled member node returning call956 (depth = 8)
  partcv[0] = 0;
  Object call957 = callmethod(call956, "size",
    1, partcv, params);
  gc_frame_end(callframe954);
// compiled call node returning call957 (depth = 7)
// compiled member node returning call957 (depth = 6)
  int op_slot_left_951 = gc_frame_newslot(call957);
  params[0] = num952;
  partcv[0] = 1;
  Object opresult958 = callmethod(call957, ">", 1, partcv, params);
// compiled op node returning opresult958 (depth = 5)
  Object if950 = done;
  if (istrue(opresult958)) {
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit960 == NULL) {
    strlit960 = alloc_String("} else {");
    gc_root(strlit960);
  }
// compiled string node returning strlit960 (depth = 7)
  int op_slot_right_959 = gc_frame_newslot(strlit960);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_962 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit965 == NULL) {
    strlit965 = alloc_String("""\x0a""");
    gc_root(strlit965);
  }
// compiled string node returning strlit965 (depth = 9)
  int op_slot_right_964 = gc_frame_newslot(strlit965);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_964 = gc_frame_newslot(*var_s);
  params[0] = strlit965;
  partcv[0] = 1;
  Object opresult967 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult967 (depth = 8)
  int op_slot_left_962 = gc_frame_newslot(opresult967);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult968 = callmethod(opresult967, "++", 1, partcv, params);
// compiled op node returning opresult968 (depth = 7)
  int op_slot_left_959 = gc_frame_newslot(opresult968);
  params[0] = strlit960;
  partcv[0] = 1;
  Object opresult969 = callmethod(opresult968, "++", 1, partcv, params);
// compiled op node returning opresult969 (depth = 6)
  *var_s = opresult969;
  if (opresult969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe971 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe972 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe973 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call974 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe973);
// compiled call node returning call974 (depth = 9)
// compiled member node returning call974 (depth = 8)
  partcv[0] = 0;
  Object call975 = callmethod(call974, "body",
    1, partcv, params);
  gc_frame_end(callframe972);
// compiled call node returning call975 (depth = 7)
// compiled member node returning call975 (depth = 6)
  gc_frame_newslot(call975);
// starting to compile block node (depth = 6)
  Object block976 = alloc_Block(NULL, NULL, "ast", 228);
  gc_frame_newslot(block976);
// method _apply
  block_savedest(block976);
  Object closure977 = createclosure(4, "_apply");
  setclosureframe(closure977, stackframe);
  addtoclosure(closure977, var_depth);
  addtoclosure(closure977, var_spc);
  addtoclosure(closure977, var_s);
  addtoclosure(closure977, selfslot);
  struct UserObject *uo977 = (struct UserObject*)block976;
  uo977->data[0] = (Object)closure977;
  Method *meth_meth_ast__apply977 = addmethod2pos(block976, "_apply", &meth_ast__apply977, 0);
  int argcv_meth_ast__apply977[] = {1};
  meth_meth_ast__apply977->type = alloc_MethodType(1, argcv_meth_ast__apply977);
  meth_meth_ast__apply977->definitionModule = modulename;
  meth_meth_ast__apply977->definitionLine = 228;
// compiled block node returning block976 (depth = 6)
  gc_frame_newslot(block976);
// call case 5: prelude request
  params[0] = call975;
  params[1] = block976;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1000 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe971);
// compiled call node returning call1000 (depth = 5)
    gc_frame_newslot(call1000);
    if950 = call1000;
  } else {
  }
// compiled if node returning if950 (depth = 4)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1002 == NULL) {
    strlit1002 = alloc_String("}");
    gc_root(strlit1002);
  }
// compiled string node returning strlit1002 (depth = 6)
  int op_slot_right_1001 = gc_frame_newslot(strlit1002);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1004 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1007 == NULL) {
    strlit1007 = alloc_String("""\x0a""");
    gc_root(strlit1007);
  }
// compiled string node returning strlit1007 (depth = 8)
  int op_slot_right_1006 = gc_frame_newslot(strlit1007);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1006 = gc_frame_newslot(*var_s);
  params[0] = strlit1007;
  partcv[0] = 1;
  Object opresult1009 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1009 (depth = 7)
  int op_slot_left_1004 = gc_frame_newslot(opresult1009);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1010 = callmethod(opresult1009, "++", 1, partcv, params);
// compiled op node returning opresult1010 (depth = 6)
  int op_slot_left_1001 = gc_frame_newslot(opresult1010);
  params[0] = strlit1002;
  partcv[0] = 1;
  Object opresult1011 = callmethod(opresult1010, "++", 1, partcv, params);
// compiled op node returning opresult1011 (depth = 5)
  *var_s = opresult1011;
  if (opresult1011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent1013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_ifNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1014 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1015 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ifNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call1016 = callmethod(*var_ifNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1015);
// compiled call node returning call1016 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1017 = callmethod(call1016, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe1014);
// compiled call node returning call1017 (depth = 4)
  gc_frame_end(frame);
  return call1017;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent1018(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1019 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1020 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1019);
// compiled call node returning call1020 (depth = 4)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1021 = gc_frame_new();
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call1023 = callmethod(*var_other, "handledIdentifiers",
    1, partcv, params);
  gc_frame_end(callframe1022);
// compiled call node returning call1023 (depth = 7)
// compiled member node returning call1023 (depth = 6)
  gc_frame_newslot(call1023);
// call case 4: self request
  params[0] = call1023;
  partcv[0] = 1;
  Object call1024 = callmethodflags(self, "handledIdentifiers:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1021);
// compiled call node returning call1024 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new671(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject672 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj672 = alloc_userobj2(16,13, objclass672);
  gc_frame_newslot(obj672);
if (objclass672 == NULL) {
  glfree(obj672->class->name);
  obj672->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj672, self, 0);
  addmethodreal(obj672,"outer", &reader_ast_outer_673);
  Object oldself672 = self;
  struct StackFrameObject *oldstackframe672 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe672);
  gc_frame_newslot((Object)stackframe);
  self = obj672;
  Object *oldselfslot672 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter672 = (*(struct UserObject *)self).data[0], lowerouter672 = thisouter672;
  if (inheritingObject672) {
    struct UserObject *inho672 = (struct UserObject *)inheritingObject672;
    while (inho672->super != GraceDefaultObject) inho672 = (struct UserObject *)inho672->super;
    inho672->super = obj672;
    self = inheritingObject672;
    *selfslot = self;
    lowerouter672 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter672;
  }
if (objclass672 == NULL) {
  Method *reader674 = addmethodrealflags(obj672, "kind",&reader_ast_kind_674, MFLAG_DEF);
  reader674->definitionModule = modulename;
  reader674->definitionLine = 174;
}
adddatum2(obj672, alloc_Undefined(), 1);
if (objclass672 == NULL) {
  Method *reader675 = addmethodrealflags(obj672, "value",&reader_ast_value_675, 0);
  Method *writer675 = addmethodrealflags(obj672, "value:=",&writer_ast_value_675, 0);
  reader675->definitionModule = modulename;
  writer675->definitionModule = modulename;
  reader675->definitionLine = 175;
  writer675->definitionLine = 175;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 2);
if (objclass672 == NULL) {
  Method *reader676 = addmethodrealflags(obj672, "thenblock",&reader_ast_thenblock_676, 0);
  Method *writer676 = addmethodrealflags(obj672, "thenblock:=",&writer_ast_thenblock_676, 0);
  reader676->definitionModule = modulename;
  writer676->definitionModule = modulename;
  reader676->definitionLine = 176;
  writer676->definitionLine = 176;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 3);
if (objclass672 == NULL) {
  Method *reader677 = addmethodrealflags(obj672, "elseblock",&reader_ast_elseblock_677, 0);
  Method *writer677 = addmethodrealflags(obj672, "elseblock:=",&writer_ast_elseblock_677, 0);
  reader677->definitionModule = modulename;
  writer677->definitionModule = modulename;
  reader677->definitionLine = 177;
  writer677->definitionLine = 177;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 4);
if (objclass672 == NULL) {
  Method *reader678 = addmethodrealflags(obj672, "handledIdentifiers",&reader_ast_handledIdentifiers_678, 0);
  Method *writer678 = addmethodrealflags(obj672, "handledIdentifiers:=",&writer_ast_handledIdentifiers_678, 0);
  reader678->definitionModule = modulename;
  writer678->definitionModule = modulename;
  reader678->definitionLine = 178;
  writer678->definitionLine = 178;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 5);
// method accept()from
  struct UserObject *uo679 = (struct UserObject*)obj672;
  uo679->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from679 = addmethod2pos(obj672, "accept()from", &meth_ast_accept_40__41_from679, 6);
  int argcv_meth_ast_accept_40__41_from679[] = {1, 1};
  meth_meth_ast_accept_40__41_from679->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from679);
  meth_meth_ast_accept_40__41_from679->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from679->definitionLine = 178;
// method map()parent
  struct UserObject *uo695 = (struct UserObject*)obj672;
  uo695->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent695 = addmethod2pos(obj672, "map()parent", &meth_ast_map_40__41_parent695, 7);
  int argcv_meth_ast_map_40__41_parent695[] = {1, 1};
  meth_meth_ast_map_40__41_parent695->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent695);
  meth_meth_ast_map_40__41_parent695->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent695->definitionLine = 185;
// method pretty
  block_savedest(obj672);
  Object closure719 = createclosure(1, "pretty");
  setclosureframe(closure719, stackframe);
  addtoclosure(closure719, var_util);
  struct UserObject *uo719 = (struct UserObject*)obj672;
  uo719->data[8] = (Object)closure719;
  Method *meth_meth_ast_pretty719 = addmethod2pos(obj672, "pretty", &meth_ast_pretty719, 8);
  int argcv_meth_ast_pretty719[] = {1};
  meth_meth_ast_pretty719->type = alloc_MethodType(1, argcv_meth_ast_pretty719);
  meth_meth_ast_pretty719->definitionModule = modulename;
  meth_meth_ast_pretty719->definitionLine = 193;
// method toGrace
  struct UserObject *uo887 = (struct UserObject*)obj672;
  uo887->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace887 = addmethod2pos(obj672, "toGrace", &meth_ast_toGrace887, 9);
  int argcv_meth_ast_toGrace887[] = {1};
  meth_meth_ast_toGrace887->type = alloc_MethodType(1, argcv_meth_ast_toGrace887);
meth_meth_ast_toGrace887->type->types[0] = type_Number;
meth_meth_ast_toGrace887->type->names[0] = "depth";
  meth_meth_ast_toGrace887->definitionModule = modulename;
  meth_meth_ast_toGrace887->definitionLine = 217;
// method shallowCopyWithParent
  block_savedest(obj672);
  Object closure1013 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure1013, stackframe);
  addtoclosure(closure1013, var_nullNode);
  addtoclosure(closure1013, var_ifNode);
  struct UserObject *uo1013 = (struct UserObject*)obj672;
  uo1013->data[10] = (Object)closure1013;
  Method *meth_meth_ast_shallowCopyWithParent1013 = addmethod2pos(obj672, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent1013, 10);
  int argcv_meth_ast_shallowCopyWithParent1013[] = {1};
  meth_meth_ast_shallowCopyWithParent1013->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent1013);
  meth_meth_ast_shallowCopyWithParent1013->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent1013->definitionLine = 235;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo1018 = (struct UserObject*)obj672;
  uo1018->data[11] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018 = addmethod2pos(obj672, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent1018, 11);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1018[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1018);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018->definitionLine = 238;
  sourceObject = obj672;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1025 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1026 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1025);
// compiled call node returning call1026 (depth = 4)
  struct UserObject *obj672_uo = (struct UserObject *)obj672;
  obj672_uo->super = call1026;
  sourceObject = obj672;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1027 == NULL) {
    strlit1027 = alloc_String("if");
    gc_root(strlit1027);
  }
// compiled string node returning strlit1027 (depth = 4)
  adddatum2(obj672, strlit1027, 1);
  sourceObject = obj672;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cond (depth = 4)
  adddatum2(obj672, *var_cond, 2);
  sourceObject = obj672;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenblock_39_ (depth = 4)
  adddatum2(obj672, *var_thenblock_39_, 3);
  sourceObject = obj672;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock_39_ (depth = 4)
  adddatum2(obj672, *var_elseblock_39_, 4);
  sourceObject = obj672;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1028 = alloc_Boolean(0);
// compiled identifier node returning bool1028 (depth = 4)
  adddatum2(obj672, bool1028, 5);
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
objclass672 = obj672->class;
  objclass672->definitionModule = modulename;
  objclass672->definitionLine = 171;
  (*(struct UserObject *)self).data[0] = lowerouter672;
  self = oldself672;
  selfslot = oldselfslot672;
  stackframe = oldstackframe672;
  gc_frame_end(frame);
  return obj672;
}
Object meth_ast_new671_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_ifNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject672 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj672 = alloc_userobj2(16,13, objclass672);
  gc_frame_newslot(obj672);
if (objclass672 == NULL) {
  glfree(obj672->class->name);
  obj672->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj672, self, 0);
  addmethodreal(obj672,"outer", &reader_ast_outer_673);
  Object oldself672 = self;
  struct StackFrameObject *oldstackframe672 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe672);
  gc_frame_newslot((Object)stackframe);
  self = obj672;
  Object *oldselfslot672 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter672 = (*(struct UserObject *)self).data[0], lowerouter672 = thisouter672;
  if (inheritingObject672) {
    struct UserObject *inho672 = (struct UserObject *)inheritingObject672;
    while (inho672->super != GraceDefaultObject) inho672 = (struct UserObject *)inho672->super;
    inho672->super = obj672;
    self = inheritingObject672;
    *selfslot = self;
    lowerouter672 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter672;
  }
if (objclass672 == NULL) {
  Method *reader674 = addmethodrealflags(obj672, "kind",&reader_ast_kind_674, MFLAG_DEF);
  reader674->definitionModule = modulename;
  reader674->definitionLine = 174;
}
adddatum2(obj672, alloc_Undefined(), 1);
if (objclass672 == NULL) {
  Method *reader675 = addmethodrealflags(obj672, "value",&reader_ast_value_675, 0);
  Method *writer675 = addmethodrealflags(obj672, "value:=",&writer_ast_value_675, 0);
  reader675->definitionModule = modulename;
  writer675->definitionModule = modulename;
  reader675->definitionLine = 175;
  writer675->definitionLine = 175;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 2);
if (objclass672 == NULL) {
  Method *reader676 = addmethodrealflags(obj672, "thenblock",&reader_ast_thenblock_676, 0);
  Method *writer676 = addmethodrealflags(obj672, "thenblock:=",&writer_ast_thenblock_676, 0);
  reader676->definitionModule = modulename;
  writer676->definitionModule = modulename;
  reader676->definitionLine = 176;
  writer676->definitionLine = 176;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 3);
if (objclass672 == NULL) {
  Method *reader677 = addmethodrealflags(obj672, "elseblock",&reader_ast_elseblock_677, 0);
  Method *writer677 = addmethodrealflags(obj672, "elseblock:=",&writer_ast_elseblock_677, 0);
  reader677->definitionModule = modulename;
  writer677->definitionModule = modulename;
  reader677->definitionLine = 177;
  writer677->definitionLine = 177;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 4);
if (objclass672 == NULL) {
  Method *reader678 = addmethodrealflags(obj672, "handledIdentifiers",&reader_ast_handledIdentifiers_678, 0);
  Method *writer678 = addmethodrealflags(obj672, "handledIdentifiers:=",&writer_ast_handledIdentifiers_678, 0);
  reader678->definitionModule = modulename;
  writer678->definitionModule = modulename;
  reader678->definitionLine = 178;
  writer678->definitionLine = 178;
}
obj672->flags |= OFLAG_MUTABLE;
adddatum2(obj672, alloc_Undefined(), 5);
// method accept()from
  struct UserObject *uo679 = (struct UserObject*)obj672;
  uo679->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from679 = addmethod2pos(obj672, "accept()from", &meth_ast_accept_40__41_from679, 6);
  int argcv_meth_ast_accept_40__41_from679[] = {1, 1};
  meth_meth_ast_accept_40__41_from679->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from679);
  meth_meth_ast_accept_40__41_from679->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from679->definitionLine = 178;
// method map()parent
  struct UserObject *uo695 = (struct UserObject*)obj672;
  uo695->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent695 = addmethod2pos(obj672, "map()parent", &meth_ast_map_40__41_parent695, 7);
  int argcv_meth_ast_map_40__41_parent695[] = {1, 1};
  meth_meth_ast_map_40__41_parent695->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent695);
  meth_meth_ast_map_40__41_parent695->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent695->definitionLine = 185;
// method pretty
  block_savedest(obj672);
  Object closure719 = createclosure(1, "pretty");
  setclosureframe(closure719, stackframe);
  addtoclosure(closure719, var_util);
  struct UserObject *uo719 = (struct UserObject*)obj672;
  uo719->data[8] = (Object)closure719;
  Method *meth_meth_ast_pretty719 = addmethod2pos(obj672, "pretty", &meth_ast_pretty719, 8);
  int argcv_meth_ast_pretty719[] = {1};
  meth_meth_ast_pretty719->type = alloc_MethodType(1, argcv_meth_ast_pretty719);
  meth_meth_ast_pretty719->definitionModule = modulename;
  meth_meth_ast_pretty719->definitionLine = 193;
// method toGrace
  struct UserObject *uo887 = (struct UserObject*)obj672;
  uo887->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace887 = addmethod2pos(obj672, "toGrace", &meth_ast_toGrace887, 9);
  int argcv_meth_ast_toGrace887[] = {1};
  meth_meth_ast_toGrace887->type = alloc_MethodType(1, argcv_meth_ast_toGrace887);
meth_meth_ast_toGrace887->type->types[0] = type_Number;
meth_meth_ast_toGrace887->type->names[0] = "depth";
  meth_meth_ast_toGrace887->definitionModule = modulename;
  meth_meth_ast_toGrace887->definitionLine = 217;
// method shallowCopyWithParent
  block_savedest(obj672);
  Object closure1013 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure1013, stackframe);
  addtoclosure(closure1013, var_nullNode);
  addtoclosure(closure1013, var_ifNode);
  struct UserObject *uo1013 = (struct UserObject*)obj672;
  uo1013->data[10] = (Object)closure1013;
  Method *meth_meth_ast_shallowCopyWithParent1013 = addmethod2pos(obj672, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent1013, 10);
  int argcv_meth_ast_shallowCopyWithParent1013[] = {1};
  meth_meth_ast_shallowCopyWithParent1013->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent1013);
  meth_meth_ast_shallowCopyWithParent1013->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent1013->definitionLine = 235;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo1018 = (struct UserObject*)obj672;
  uo1018->data[11] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018 = addmethod2pos(obj672, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent1018, 11);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1018[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1018);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1018->definitionLine = 238;
  sourceObject = obj672;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1025 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1026 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1025);
// compiled call node returning call1026 (depth = 4)
  struct UserObject *obj672_uo = (struct UserObject *)obj672;
  obj672_uo->super = call1026;
  sourceObject = obj672;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1027 == NULL) {
    strlit1027 = alloc_String("if");
    gc_root(strlit1027);
  }
// compiled string node returning strlit1027 (depth = 4)
  adddatum2(obj672, strlit1027, 1);
  sourceObject = obj672;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cond (depth = 4)
  adddatum2(obj672, *var_cond, 2);
  sourceObject = obj672;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenblock_39_ (depth = 4)
  adddatum2(obj672, *var_thenblock_39_, 3);
  sourceObject = obj672;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock_39_ (depth = 4)
  adddatum2(obj672, *var_elseblock_39_, 4);
  sourceObject = obj672;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1028 = alloc_Boolean(0);
// compiled identifier node returning bool1028 (depth = 4)
  adddatum2(obj672, bool1028, 5);
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
  sourceObject = obj672;
objclass672 = obj672->class;
  objclass672->definitionModule = modulename;
  objclass672->definitionLine = 171;
  (*(struct UserObject *)self).data[0] = lowerouter672;
  self = oldself672;
  selfslot = oldselfslot672;
  stackframe = oldstackframe672;
  gc_frame_end(frame);
  return obj672;
}
Object meth_ast_blockNode1030(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blockNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for blockNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blockNode (depth = 3)
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast_declarationKind1043(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1044 == NULL) {
    strlit1044 = alloc_String("parameter");
    gc_root(strlit1044);
  }
// compiled string node returning strlit1044 (depth = 4)
  gc_frame_end(frame);
  return strlit1044;
}
Object meth_ast_isMatchingBlock1045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMatchingBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMatchingBlock (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMatchingBlock");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1047 = alloc_Float64(1);
// compiled num node returning num1047 (depth = 5)
  int op_slot_right_1046 = gc_frame_newslot(num1047);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1049 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1050 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1051 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1050);
// compiled call node returning call1051 (depth = 8)
// compiled member node returning call1051 (depth = 7)
  partcv[0] = 0;
  Object call1052 = callmethod(call1051, "size",
    1, partcv, params);
  gc_frame_end(callframe1049);
// compiled call node returning call1052 (depth = 6)
// compiled member node returning call1052 (depth = 5)
  int op_slot_left_1046 = gc_frame_newslot(call1052);
  params[0] = num1047;
  partcv[0] = 1;
  Object opresult1053 = callmethod(call1052, "==", 1, partcv, params);
// compiled op node returning opresult1053 (depth = 4)
  gc_frame_end(frame);
  return opresult1053;
}
Object meth_ast__apply1057(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1058 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1059 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1060 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1061 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1060);
// compiled call node returning call1061 (depth = 11)
// compiled member node returning call1061 (depth = 10)
  partcv[0] = 0;
  Object call1062 = callmethod(call1061, "last",
    1, partcv, params);
  gc_frame_end(callframe1059);
// compiled call node returning call1062 (depth = 9)
// compiled member node returning call1062 (depth = 8)
  partcv[0] = 0;
  Object call1063 = callmethod(call1062, "definesObject",
    1, partcv, params);
  gc_frame_end(callframe1058);
// compiled call node returning call1063 (depth = 7)
// compiled member node returning call1063 (depth = 6)
  gc_frame_end(frame);
  return call1063;
}
Object meth_ast_definesObject1054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1055 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1056 = alloc_Block(NULL, NULL, "ast", 261);
  gc_frame_newslot(block1056);
// method _apply
  block_savedest(block1056);
  Object closure1057 = createclosure(1, "_apply");
  setclosureframe(closure1057, stackframe);
  addtoclosure(closure1057, selfslot);
  struct UserObject *uo1057 = (struct UserObject*)block1056;
  uo1057->data[0] = (Object)closure1057;
  Method *meth_meth_ast__apply1057 = addmethod2pos(block1056, "_apply", &meth_ast__apply1057, 0);
  int argcv_meth_ast__apply1057[] = {0};
  meth_meth_ast__apply1057->type = alloc_MethodType(1, argcv_meth_ast__apply1057);
  meth_meth_ast__apply1057->definitionModule = modulename;
  meth_meth_ast__apply1057->definitionLine = 259;
// compiled block node returning block1056 (depth = 5)
  gc_frame_newslot(block1056);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1065 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1066 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1068 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1067);
// compiled call node returning call1068 (depth = 10)
// compiled member node returning call1068 (depth = 9)
  partcv[0] = 0;
  Object call1069 = callmethod(call1068, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe1066);
// compiled call node returning call1069 (depth = 8)
// compiled member node returning call1069 (depth = 7)
  partcv[0] = 0;
  Object call1070 = callmethod(call1069, "not",
    1, partcv, params);
  gc_frame_end(callframe1065);
// compiled call node returning call1070 (depth = 6)
// compiled member node returning call1070 (depth = 5)
  params[0] = block1056;
  partcv[0] = 1;
  Object call1071 = callmethod(call1070, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1055);
// compiled call node returning call1071 (depth = 4)
  gc_frame_end(frame);
  return call1071;
}
Object meth_ast_parametersDo1072(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1073 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1074 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1075 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1074);
// compiled call node returning call1075 (depth = 6)
// compiled member node returning call1075 (depth = 5)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call1076 = callmethod(call1075, "do",
    1, partcv, params);
  gc_frame_end(callframe1073);
// compiled call node returning call1076 (depth = 4)
  gc_frame_end(frame);
  return call1076;
}
Object meth_ast__apply1085(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1086 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1087 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1086);
// compiled call node returning call1087 (depth = 7)
  gc_frame_end(frame);
  return call1087;
}
Object meth_ast__apply1094(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1095 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1096 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1095);
// compiled call node returning call1096 (depth = 7)
  gc_frame_end(frame);
  return call1096;
}
Object meth_ast_accept_40__41_from1077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1079 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1080 = callmethod(*var_visitor, "visitBlock()up",
    2, partcv, params);
  gc_frame_end(callframe1079);
// compiled call node returning call1080 (depth = 5)
  Object if1078 = done;
  if (istrue(call1080)) {
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1081 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1082 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1083 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1082);
// compiled call node returning call1083 (depth = 7)
// compiled member node returning call1083 (depth = 6)
  gc_frame_newslot(call1083);
// starting to compile block node (depth = 6)
  Object block1084 = alloc_Block(NULL, NULL, "ast", 268);
  gc_frame_newslot(block1084);
// method _apply
  block_savedest(block1084);
  Object closure1085 = createclosure(2, "_apply");
  setclosureframe(closure1085, stackframe);
  addtoclosure(closure1085, var_visitor);
  addtoclosure(closure1085, selfslot);
  struct UserObject *uo1085 = (struct UserObject*)block1084;
  uo1085->data[0] = (Object)closure1085;
  Method *meth_meth_ast__apply1085 = addmethod2pos(block1084, "_apply", &meth_ast__apply1085, 0);
  int argcv_meth_ast__apply1085[] = {1};
  meth_meth_ast__apply1085->type = alloc_MethodType(1, argcv_meth_ast__apply1085);
  meth_meth_ast__apply1085->definitionModule = modulename;
  meth_meth_ast__apply1085->definitionLine = 268;
// compiled block node returning block1084 (depth = 6)
  gc_frame_newslot(block1084);
// call case 5: prelude request
  params[0] = call1083;
  params[1] = block1084;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1089 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1081);
// compiled call node returning call1089 (depth = 5)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1090 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1091 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1092 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1091);
// compiled call node returning call1092 (depth = 7)
// compiled member node returning call1092 (depth = 6)
  gc_frame_newslot(call1092);
// starting to compile block node (depth = 6)
  Object block1093 = alloc_Block(NULL, NULL, "ast", 271);
  gc_frame_newslot(block1093);
// method _apply
  block_savedest(block1093);
  Object closure1094 = createclosure(2, "_apply");
  setclosureframe(closure1094, stackframe);
  addtoclosure(closure1094, var_visitor);
  addtoclosure(closure1094, selfslot);
  struct UserObject *uo1094 = (struct UserObject*)block1093;
  uo1094->data[0] = (Object)closure1094;
  Method *meth_meth_ast__apply1094 = addmethod2pos(block1093, "_apply", &meth_ast__apply1094, 0);
  int argcv_meth_ast__apply1094[] = {1};
  meth_meth_ast__apply1094->type = alloc_MethodType(1, argcv_meth_ast__apply1094);
  meth_meth_ast__apply1094->definitionModule = modulename;
  meth_meth_ast__apply1094->definitionLine = 271;
// compiled block node returning block1093 (depth = 6)
  gc_frame_newslot(block1093);
// call case 5: prelude request
  params[0] = call1092;
  params[1] = block1093;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1098 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1090);
// compiled call node returning call1098 (depth = 5)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1101 = alloc_Boolean(0);
// compiled identifier node returning bool1101 (depth = 7)
  int op_slot_right_1100 = gc_frame_newslot(bool1101);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1103 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1104 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1103);
// compiled call node returning call1104 (depth = 8)
// compiled member node returning call1104 (depth = 7)
  int op_slot_left_1100 = gc_frame_newslot(call1104);
  params[0] = bool1101;
  partcv[0] = 1;
  Object opresult1105 = callmethod(call1104, "!=", 1, partcv, params);
// compiled op node returning opresult1105 (depth = 6)
  Object if1099 = done;
  if (istrue(opresult1105)) {
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1106 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1108 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1107);
// compiled call node returning call1108 (depth = 8)
// compiled member node returning call1108 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1109 = callmethod(call1108, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1106);
// compiled call node returning call1109 (depth = 6)
    gc_frame_newslot(call1109);
    if1099 = call1109;
  } else {
  }
// compiled if node returning if1099 (depth = 5)
    gc_frame_newslot(if1099);
    if1078 = if1099;
  } else {
  }
// compiled if node returning if1078 (depth = 4)
  gc_frame_end(frame);
  return if1078;
}
Object meth_ast_map_40__41_parent1110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1111 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call1112 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1111);
// compiled call node returning call1112 (depth = 5)
  *var_n = call1112;
  if (call1112 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1113 = gc_frame_new();
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1114 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1115 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1116 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1115);
// compiled call node returning call1116 (depth = 8)
// compiled member node returning call1116 (depth = 7)
  gc_frame_newslot(call1116);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1117 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1118 = gc_frame_new();
// call case 3: self.outer request
  Object call1119 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1118);
// compiled call node returning call1119 (depth = 10)
// compiled member node returning call1119 (depth = 9)
  partcv[0] = 0;
  Object call1120 = callmethodflags(call1119, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1117);
// compiled call node returning call1120 (depth = 8)
// compiled member node returning call1120 (depth = 7)
  params[0] = call1116;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1121 = callmethodflags(call1120, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1114);
// compiled call node returning call1121 (depth = 6)
  gc_frame_newslot(call1121);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1121;
  partcv[0] = 1;
  Object call1122 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe1113);
// compiled call node returning call1122 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1123 = gc_frame_new();
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1124 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1125 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1126 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1125);
// compiled call node returning call1126 (depth = 8)
// compiled member node returning call1126 (depth = 7)
  gc_frame_newslot(call1126);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1127 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1128 = gc_frame_new();
// call case 3: self.outer request
  Object call1129 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1128);
// compiled call node returning call1129 (depth = 10)
// compiled member node returning call1129 (depth = 9)
  partcv[0] = 0;
  Object call1130 = callmethodflags(call1129, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1127);
// compiled call node returning call1130 (depth = 8)
// compiled member node returning call1130 (depth = 7)
  params[0] = call1126;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1131 = callmethodflags(call1130, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1124);
// compiled call node returning call1131 (depth = 6)
  gc_frame_newslot(call1131);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1131;
  partcv[0] = 1;
  Object call1132 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe1123);
// compiled call node returning call1132 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1133 = gc_frame_new();
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1134 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1136 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1135);
// compiled call node returning call1136 (depth = 8)
// compiled member node returning call1136 (depth = 7)
  gc_frame_newslot(call1136);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1137 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1138 = gc_frame_new();
// call case 3: self.outer request
  Object call1139 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1138);
// compiled call node returning call1139 (depth = 10)
// compiled member node returning call1139 (depth = 9)
  partcv[0] = 0;
  Object call1140 = callmethodflags(call1139, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1137);
// compiled call node returning call1140 (depth = 8)
// compiled member node returning call1140 (depth = 7)
  params[0] = call1136;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1141 = callmethodflags(call1140, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1134);
// compiled call node returning call1141 (depth = 6)
  gc_frame_newslot(call1141);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1141;
  partcv[0] = 1;
  Object call1142 = callmethod(*var_n, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1133);
// compiled call node returning call1142 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1143 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1144 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1143);
// compiled call node returning call1144 (depth = 5)
  *var_n = call1144;
  if (call1144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1154(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1156 == NULL) {
    strlit1156 = alloc_String("  ");
    gc_root(strlit1156);
  }
// compiled string node returning strlit1156 (depth = 8)
  int op_slot_right_1155 = gc_frame_newslot(strlit1156);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1155 = gc_frame_newslot(*var_spc);
  params[0] = strlit1156;
  partcv[0] = 1;
  Object opresult1158 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1158 (depth = 7)
  *var_spc = opresult1158;
  if (opresult1158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1180(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1182 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1184 = alloc_Float64(2);
// compiled num node returning num1184 (depth = 10)
  int op_slot_right_1183 = gc_frame_newslot(num1184);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1183 = gc_frame_newslot(*var_depth);
  params[0] = num1184;
  partcv[0] = 1;
  Object sum1186 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1186 (depth = 9)
  gc_frame_newslot(sum1186);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum1186;
  partcv[0] = 1;
  Object call1187 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1182);
// compiled call node returning call1187 (depth = 8)
  int op_slot_right_1181 = gc_frame_newslot(call1187);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1189 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1192 == NULL) {
    strlit1192 = alloc_String("""\x0a""  ");
    gc_root(strlit1192);
  }
// compiled string node returning strlit1192 (depth = 10)
  int op_slot_right_1191 = gc_frame_newslot(strlit1192);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1191 = gc_frame_newslot(*var_s);
  params[0] = strlit1192;
  partcv[0] = 1;
  Object opresult1194 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1194 (depth = 9)
  int op_slot_left_1189 = gc_frame_newslot(opresult1194);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1195 = callmethod(opresult1194, "++", 1, partcv, params);
// compiled op node returning opresult1195 (depth = 8)
  int op_slot_left_1181 = gc_frame_newslot(opresult1195);
  params[0] = call1187;
  partcv[0] = 1;
  Object opresult1196 = callmethod(opresult1195, "++", 1, partcv, params);
// compiled op node returning opresult1196 (depth = 7)
  *var_s = opresult1196;
  if (opresult1196 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1217(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1219 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1221 = alloc_Float64(2);
// compiled num node returning num1221 (depth = 10)
  int op_slot_right_1220 = gc_frame_newslot(num1221);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1220 = gc_frame_newslot(*var_depth);
  params[0] = num1221;
  partcv[0] = 1;
  Object sum1223 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1223 (depth = 9)
  gc_frame_newslot(sum1223);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum1223;
  partcv[0] = 1;
  Object call1224 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1219);
// compiled call node returning call1224 (depth = 8)
  int op_slot_right_1218 = gc_frame_newslot(call1224);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_1226 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1229 == NULL) {
    strlit1229 = alloc_String("""\x0a""  ");
    gc_root(strlit1229);
  }
// compiled string node returning strlit1229 (depth = 10)
  int op_slot_right_1228 = gc_frame_newslot(strlit1229);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1228 = gc_frame_newslot(*var_s);
  params[0] = strlit1229;
  partcv[0] = 1;
  Object opresult1231 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1231 (depth = 9)
  int op_slot_left_1226 = gc_frame_newslot(opresult1231);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1232 = callmethod(opresult1231, "++", 1, partcv, params);
// compiled op node returning opresult1232 (depth = 8)
  int op_slot_left_1218 = gc_frame_newslot(opresult1232);
  params[0] = call1224;
  partcv[0] = 1;
  Object opresult1233 = callmethod(opresult1232, "++", 1, partcv, params);
// compiled op node returning opresult1233 (depth = 7)
  *var_s = opresult1233;
  if (opresult1233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1146(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1147 == NULL) {
    strlit1147 = alloc_String("");
    gc_root(strlit1147);
  }
// compiled string node returning strlit1147 (depth = 5)
  *var_spc = strlit1147;
  if (strlit1147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1148 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_1149 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num1151 = alloc_Float64(0);
// compiled num node returning num1151 (depth = 6)
  int op_slot_left_1149 = gc_frame_newslot(num1151);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1152 = callmethod(num1151, "..", 1, partcv, params);
// compiled op node returning opresult1152 (depth = 5)
  gc_frame_newslot(opresult1152);
// starting to compile block node (depth = 5)
  Object block1153 = alloc_Block(NULL, NULL, "ast", 289);
  gc_frame_newslot(block1153);
// method _apply
  block_savedest(block1153);
  Object closure1154 = createclosure(2, "_apply");
  setclosureframe(closure1154, stackframe);
  addtoclosure(closure1154, var_spc);
  addtoclosure(closure1154, selfslot);
  struct UserObject *uo1154 = (struct UserObject*)block1153;
  uo1154->data[0] = (Object)closure1154;
  Method *meth_meth_ast__apply1154 = addmethod2pos(block1153, "_apply", &meth_ast__apply1154, 0);
  int argcv_meth_ast__apply1154[] = {1};
  meth_meth_ast__apply1154->type = alloc_MethodType(1, argcv_meth_ast__apply1154);
  meth_meth_ast__apply1154->definitionModule = modulename;
  meth_meth_ast__apply1154->definitionLine = 283;
// compiled block node returning block1153 (depth = 5)
  gc_frame_newslot(block1153);
// call case 5: prelude request
  params[0] = opresult1152;
  params[1] = block1153;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1161 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1148);
// compiled call node returning call1161 (depth = 4)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1163 == NULL) {
    strlit1163 = alloc_String("""\x0a""");
    gc_root(strlit1163);
  }
// compiled string node returning strlit1163 (depth = 6)
  int op_slot_right_1162 = gc_frame_newslot(strlit1163);
// starting to compile call node (depth = 6)
  int callframe1165 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1166 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1165);
// compiled call node returning call1166 (depth = 6)
  int op_slot_left_1162 = gc_frame_newslot(call1166);
  params[0] = strlit1163;
  partcv[0] = 1;
  Object opresult1167 = callmethod(call1166, "++", 1, partcv, params);
// compiled op node returning opresult1167 (depth = 5)
  *var_s = opresult1167;
  if (opresult1167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1169 == NULL) {
    strlit1169 = alloc_String("Parameters:");
    gc_root(strlit1169);
  }
// compiled string node returning strlit1169 (depth = 6)
  int op_slot_right_1168 = gc_frame_newslot(strlit1169);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1171 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1171 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1173 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1173 (depth = 6)
  int op_slot_left_1168 = gc_frame_newslot(opresult1173);
  params[0] = strlit1169;
  partcv[0] = 1;
  Object opresult1174 = callmethod(opresult1173, "++", 1, partcv, params);
// compiled op node returning opresult1174 (depth = 5)
  *var_s = opresult1174;
  if (opresult1174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1176 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1178 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1177);
// compiled call node returning call1178 (depth = 6)
// compiled member node returning call1178 (depth = 5)
  gc_frame_newslot(call1178);
// starting to compile block node (depth = 5)
  Object block1179 = alloc_Block(NULL, NULL, "ast", 294);
  gc_frame_newslot(block1179);
// method _apply
  block_savedest(block1179);
  Object closure1180 = createclosure(4, "_apply");
  setclosureframe(closure1180, stackframe);
  addtoclosure(closure1180, var_depth);
  addtoclosure(closure1180, var_spc);
  addtoclosure(closure1180, var_s);
  addtoclosure(closure1180, selfslot);
  struct UserObject *uo1180 = (struct UserObject*)block1179;
  uo1180->data[0] = (Object)closure1180;
  Method *meth_meth_ast__apply1180 = addmethod2pos(block1179, "_apply", &meth_ast__apply1180, 0);
  int argcv_meth_ast__apply1180[] = {1};
  meth_meth_ast__apply1180->type = alloc_MethodType(1, argcv_meth_ast__apply1180);
  meth_meth_ast__apply1180->definitionModule = modulename;
  meth_meth_ast__apply1180->definitionLine = 294;
// compiled block node returning block1179 (depth = 5)
  gc_frame_newslot(block1179);
// call case 5: prelude request
  params[0] = call1178;
  params[1] = block1179;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1199 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1176);
// compiled call node returning call1199 (depth = 4)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1201 == NULL) {
    strlit1201 = alloc_String("""\x0a""");
    gc_root(strlit1201);
  }
// compiled string node returning strlit1201 (depth = 6)
  int op_slot_right_1200 = gc_frame_newslot(strlit1201);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1200 = gc_frame_newslot(*var_s);
  params[0] = strlit1201;
  partcv[0] = 1;
  Object opresult1203 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1203 (depth = 5)
  *var_s = opresult1203;
  if (opresult1203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1206 == NULL) {
    strlit1206 = alloc_String("Body:");
    gc_root(strlit1206);
  }
// compiled string node returning strlit1206 (depth = 6)
  int op_slot_right_1205 = gc_frame_newslot(strlit1206);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1208 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1208 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1210 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1210 (depth = 6)
  int op_slot_left_1205 = gc_frame_newslot(opresult1210);
  params[0] = strlit1206;
  partcv[0] = 1;
  Object opresult1211 = callmethod(opresult1210, "++", 1, partcv, params);
// compiled op node returning opresult1211 (depth = 5)
  *var_s = opresult1211;
  if (opresult1211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1213 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1214 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1215 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1214);
// compiled call node returning call1215 (depth = 6)
// compiled member node returning call1215 (depth = 5)
  gc_frame_newslot(call1215);
// starting to compile block node (depth = 5)
  Object block1216 = alloc_Block(NULL, NULL, "ast", 299);
  gc_frame_newslot(block1216);
// method _apply
  block_savedest(block1216);
  Object closure1217 = createclosure(4, "_apply");
  setclosureframe(closure1217, stackframe);
  addtoclosure(closure1217, var_depth);
  addtoclosure(closure1217, var_spc);
  addtoclosure(closure1217, var_s);
  addtoclosure(closure1217, selfslot);
  struct UserObject *uo1217 = (struct UserObject*)block1216;
  uo1217->data[0] = (Object)closure1217;
  Method *meth_meth_ast__apply1217 = addmethod2pos(block1216, "_apply", &meth_ast__apply1217, 0);
  int argcv_meth_ast__apply1217[] = {1};
  meth_meth_ast__apply1217->type = alloc_MethodType(1, argcv_meth_ast__apply1217);
  meth_meth_ast__apply1217->definitionModule = modulename;
  meth_meth_ast__apply1217->definitionLine = 299;
// compiled block node returning block1216 (depth = 5)
  gc_frame_newslot(block1216);
// call case 5: prelude request
  params[0] = call1215;
  params[1] = block1216;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1236 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1213);
// compiled call node returning call1236 (depth = 4)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1239 = alloc_Boolean(0);
// compiled identifier node returning bool1239 (depth = 6)
  int op_slot_right_1238 = gc_frame_newslot(bool1239);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1242 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1241);
// compiled call node returning call1242 (depth = 7)
// compiled member node returning call1242 (depth = 6)
  int op_slot_left_1238 = gc_frame_newslot(call1242);
  params[0] = bool1239;
  partcv[0] = 1;
  Object opresult1243 = callmethod(call1242, "!=", 1, partcv, params);
// compiled op node returning opresult1243 (depth = 5)
  Object if1237 = done;
  if (istrue(opresult1243)) {
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1245 == NULL) {
    strlit1245 = alloc_String("""\x0a""");
    gc_root(strlit1245);
  }
// compiled string node returning strlit1245 (depth = 7)
  int op_slot_right_1244 = gc_frame_newslot(strlit1245);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1244 = gc_frame_newslot(*var_s);
  params[0] = strlit1245;
  partcv[0] = 1;
  Object opresult1247 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 6)
  *var_s = opresult1247;
  if (opresult1247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1250 == NULL) {
    strlit1250 = alloc_String("Pattern:");
    gc_root(strlit1250);
  }
// compiled string node returning strlit1250 (depth = 7)
  int op_slot_right_1249 = gc_frame_newslot(strlit1250);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1252 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1252 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1254 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1254 (depth = 7)
  int op_slot_left_1249 = gc_frame_newslot(opresult1254);
  params[0] = strlit1250;
  partcv[0] = 1;
  Object opresult1255 = callmethod(opresult1254, "++", 1, partcv, params);
// compiled op node returning opresult1255 (depth = 6)
  *var_s = opresult1255;
  if (opresult1255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1258 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1260 = alloc_Float64(2);
// compiled num node returning num1260 (depth = 9)
  int op_slot_right_1259 = gc_frame_newslot(num1260);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1259 = gc_frame_newslot(*var_depth);
  params[0] = num1260;
  partcv[0] = 1;
  Object sum1262 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1262 (depth = 8)
  gc_frame_newslot(sum1262);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1264 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1263);
// compiled call node returning call1264 (depth = 9)
// compiled member node returning call1264 (depth = 8)
  params[0] = sum1262;
  partcv[0] = 1;
  Object call1265 = callmethod(call1264, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1258);
// compiled call node returning call1265 (depth = 7)
  int op_slot_right_1257 = gc_frame_newslot(call1265);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_1267 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1270 == NULL) {
    strlit1270 = alloc_String("""\x0a""  ");
    gc_root(strlit1270);
  }
// compiled string node returning strlit1270 (depth = 9)
  int op_slot_right_1269 = gc_frame_newslot(strlit1270);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_1269 = gc_frame_newslot(*var_s);
  params[0] = strlit1270;
  partcv[0] = 1;
  Object opresult1272 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1272 (depth = 8)
  int op_slot_left_1267 = gc_frame_newslot(opresult1272);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1273 = callmethod(opresult1272, "++", 1, partcv, params);
// compiled op node returning opresult1273 (depth = 7)
  int op_slot_left_1257 = gc_frame_newslot(opresult1273);
  params[0] = call1265;
  partcv[0] = 1;
  Object opresult1274 = callmethod(opresult1273, "++", 1, partcv, params);
// compiled op node returning opresult1274 (depth = 6)
  *var_s = opresult1274;
  if (opresult1274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1237 = done;
  } else {
  }
// compiled if node returning if1237 (depth = 4)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1288(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1290 == NULL) {
    strlit1290 = alloc_String("    ");
    gc_root(strlit1290);
  }
// compiled string node returning strlit1290 (depth = 8)
  int op_slot_right_1289 = gc_frame_newslot(strlit1290);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1289 = gc_frame_newslot(*var_spc);
  params[0] = strlit1290;
  partcv[0] = 1;
  Object opresult1292 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1292 (depth = 7)
  *var_spc = opresult1292;
  if (opresult1292 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1317(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile index node (depth = 8)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1318 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1319 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1318);
// compiled call node returning call1319 (depth = 10)
// compiled member node returning call1319 (depth = 9)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1320 = callmethod(call1319, "[]", 1, partcv, params);
// compiled index node returning idxres1320 (depth = 8)
  *var_p = idxres1320;
  if (idxres1320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1323 = alloc_Boolean(0);
// compiled identifier node returning bool1323 (depth = 9)
  int op_slot_right_1322 = gc_frame_newslot(bool1323);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1325 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1326 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1325);
// compiled call node returning call1326 (depth = 10)
// compiled member node returning call1326 (depth = 9)
  int op_slot_left_1322 = gc_frame_newslot(call1326);
  params[0] = bool1323;
  partcv[0] = 1;
  Object opresult1327 = callmethod(call1326, "!=", 1, partcv, params);
// compiled op node returning opresult1327 (depth = 8)
  Object if1321 = done;
  if (istrue(opresult1327)) {
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1329 == NULL) {
    strlit1329 = alloc_String(")");
    gc_root(strlit1329);
  }
// compiled string node returning strlit1329 (depth = 10)
  int op_slot_right_1328 = gc_frame_newslot(strlit1329);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1332 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num1333 = alloc_Float64(0);
// compiled num node returning num1333 (depth = 12)
  gc_frame_newslot(num1333);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = num1333;
  partcv[0] = 1;
  Object call1334 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1332);
// compiled call node returning call1334 (depth = 11)
  int op_slot_right_1331 = gc_frame_newslot(call1334);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1337 == NULL) {
    strlit1337 = alloc_String("(");
    gc_root(strlit1337);
  }
// compiled string node returning strlit1337 (depth = 12)
  int op_slot_right_1336 = gc_frame_newslot(strlit1337);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_1336 = gc_frame_newslot(*var_s);
  params[0] = strlit1337;
  partcv[0] = 1;
  Object opresult1339 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1339 (depth = 11)
  int op_slot_left_1331 = gc_frame_newslot(opresult1339);
  params[0] = call1334;
  partcv[0] = 1;
  Object opresult1340 = callmethod(opresult1339, "++", 1, partcv, params);
// compiled op node returning opresult1340 (depth = 10)
  int op_slot_left_1328 = gc_frame_newslot(opresult1340);
  params[0] = strlit1329;
  partcv[0] = 1;
  Object opresult1341 = callmethod(opresult1340, "++", 1, partcv, params);
// compiled op node returning opresult1341 (depth = 9)
  *var_s = opresult1341;
  if (opresult1341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1321 = done;
  } else {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1344 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num1345 = alloc_Float64(0);
// compiled num node returning num1345 (depth = 11)
  gc_frame_newslot(num1345);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_p (depth = 11)
  params[0] = num1345;
  partcv[0] = 1;
  Object call1346 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1344);
// compiled call node returning call1346 (depth = 10)
  int op_slot_right_1343 = gc_frame_newslot(call1346);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1343 = gc_frame_newslot(*var_s);
  params[0] = call1346;
  partcv[0] = 1;
  Object opresult1348 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1348 (depth = 9)
  *var_s = opresult1348;
  if (opresult1348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1321 = done;
  }
// compiled if node returning if1321 (depth = 7)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1352 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1353 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1354 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1353);
// compiled call node returning call1354 (depth = 12)
// compiled member node returning call1354 (depth = 11)
  partcv[0] = 0;
  Object call1355 = callmethod(call1354, "size",
    1, partcv, params);
  gc_frame_end(callframe1352);
// compiled call node returning call1355 (depth = 10)
// compiled member node returning call1355 (depth = 9)
  int op_slot_right_1351 = gc_frame_newslot(call1355);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1351 = gc_frame_newslot(*var_i);
  params[0] = call1355;
  partcv[0] = 1;
  Object opresult1357 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1357 (depth = 8)
  Object if1350 = done;
  if (istrue(opresult1357)) {
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1359 == NULL) {
    strlit1359 = alloc_String(", ");
    gc_root(strlit1359);
  }
// compiled string node returning strlit1359 (depth = 10)
  int op_slot_right_1358 = gc_frame_newslot(strlit1359);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1358 = gc_frame_newslot(*var_s);
  params[0] = strlit1359;
  partcv[0] = 1;
  Object opresult1361 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1361 (depth = 9)
  *var_s = opresult1361;
  if (opresult1361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1350 = done;
  } else {
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1364 == NULL) {
    strlit1364 = alloc_String(" ->");
    gc_root(strlit1364);
  }
// compiled string node returning strlit1364 (depth = 10)
  int op_slot_right_1363 = gc_frame_newslot(strlit1364);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1363 = gc_frame_newslot(*var_s);
  params[0] = strlit1364;
  partcv[0] = 1;
  Object opresult1366 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1366 (depth = 9)
  *var_s = opresult1366;
  if (opresult1366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1350 = done;
  }
// compiled if node returning if1350 (depth = 7)
  gc_frame_end(frame);
  return if1350;
}
Object meth_ast__apply1374(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1376 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1378 = alloc_Float64(1);
// compiled num node returning num1378 (depth = 10)
  int op_slot_right_1377 = gc_frame_newslot(num1378);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1377 = gc_frame_newslot(*var_depth);
  params[0] = num1378;
  partcv[0] = 1;
  Object sum1380 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1380 (depth = 9)
  gc_frame_newslot(sum1380);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum1380;
  partcv[0] = 1;
  Object call1381 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1376);
// compiled call node returning call1381 (depth = 8)
  int op_slot_right_1375 = gc_frame_newslot(call1381);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1384 == NULL) {
    strlit1384 = alloc_String("    ");
    gc_root(strlit1384);
  }
// compiled string node returning strlit1384 (depth = 9)
  int op_slot_right_1383 = gc_frame_newslot(strlit1384);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1386 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1389 == NULL) {
    strlit1389 = alloc_String("""\x0a""");
    gc_root(strlit1389);
  }
// compiled string node returning strlit1389 (depth = 11)
  int op_slot_right_1388 = gc_frame_newslot(strlit1389);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1388 = gc_frame_newslot(*var_s);
  params[0] = strlit1389;
  partcv[0] = 1;
  Object opresult1391 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1391 (depth = 10)
  int op_slot_left_1386 = gc_frame_newslot(opresult1391);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1392 = callmethod(opresult1391, "++", 1, partcv, params);
// compiled op node returning opresult1392 (depth = 9)
  int op_slot_left_1383 = gc_frame_newslot(opresult1392);
  params[0] = strlit1384;
  partcv[0] = 1;
  Object opresult1393 = callmethod(opresult1392, "++", 1, partcv, params);
// compiled op node returning opresult1393 (depth = 8)
  int op_slot_left_1375 = gc_frame_newslot(opresult1393);
  params[0] = call1381;
  partcv[0] = 1;
  Object opresult1394 = callmethod(opresult1393, "++", 1, partcv, params);
// compiled op node returning opresult1394 (depth = 7)
  *var_s = opresult1394;
  if (opresult1394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1276(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1277 == NULL) {
    strlit1277 = alloc_String("");
    gc_root(strlit1277);
  }
// compiled string node returning strlit1277 (depth = 5)
  *var_spc = strlit1277;
  if (strlit1277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1278 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1281 = alloc_Float64(1);
// compiled num node returning num1281 (depth = 7)
  int op_slot_right_1280 = gc_frame_newslot(num1281);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1280 = gc_frame_newslot(*var_depth);
  params[0] = num1281;
  partcv[0] = 1;
  Object diff1283 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff1283 (depth = 6)
  int op_slot_right_1279 = gc_frame_newslot(diff1283);
// starting to compile num node (depth = 6)
  Object num1285 = alloc_Float64(0);
// compiled num node returning num1285 (depth = 6)
  int op_slot_left_1279 = gc_frame_newslot(num1285);
  params[0] = diff1283;
  partcv[0] = 1;
  Object opresult1286 = callmethod(num1285, "..", 1, partcv, params);
// compiled op node returning opresult1286 (depth = 5)
  gc_frame_newslot(opresult1286);
// starting to compile block node (depth = 5)
  Object block1287 = alloc_Block(NULL, NULL, "ast", 311);
  gc_frame_newslot(block1287);
// method _apply
  block_savedest(block1287);
  Object closure1288 = createclosure(2, "_apply");
  setclosureframe(closure1288, stackframe);
  addtoclosure(closure1288, var_spc);
  addtoclosure(closure1288, selfslot);
  struct UserObject *uo1288 = (struct UserObject*)block1287;
  uo1288->data[0] = (Object)closure1288;
  Method *meth_meth_ast__apply1288 = addmethod2pos(block1287, "_apply", &meth_ast__apply1288, 0);
  int argcv_meth_ast__apply1288[] = {1};
  meth_meth_ast__apply1288->type = alloc_MethodType(1, argcv_meth_ast__apply1288);
  meth_meth_ast__apply1288->definitionModule = modulename;
  meth_meth_ast__apply1288->definitionLine = 305;
// compiled block node returning block1287 (depth = 5)
  gc_frame_newslot(block1287);
// call case 5: prelude request
  params[0] = opresult1286;
  params[1] = block1287;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1295 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1278);
// compiled call node returning call1295 (depth = 4)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1296 == NULL) {
    strlit1296 = alloc_String("{");
    gc_root(strlit1296);
  }
// compiled string node returning strlit1296 (depth = 5)
  *var_s = strlit1296;
  if (strlit1296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1299 = alloc_Float64(0);
// compiled num node returning num1299 (depth = 6)
  int op_slot_right_1298 = gc_frame_newslot(num1299);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1301 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1303 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1302);
// compiled call node returning call1303 (depth = 9)
// compiled member node returning call1303 (depth = 8)
  partcv[0] = 0;
  Object call1304 = callmethod(call1303, "size",
    1, partcv, params);
  gc_frame_end(callframe1301);
// compiled call node returning call1304 (depth = 7)
// compiled member node returning call1304 (depth = 6)
  int op_slot_left_1298 = gc_frame_newslot(call1304);
  params[0] = num1299;
  partcv[0] = 1;
  Object opresult1305 = callmethod(call1304, ">", 1, partcv, params);
// compiled op node returning opresult1305 (depth = 5)
  Object if1297 = done;
  if (istrue(opresult1305)) {
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1307 == NULL) {
    strlit1307 = alloc_String(" ");
    gc_root(strlit1307);
  }
// compiled string node returning strlit1307 (depth = 7)
  int op_slot_right_1306 = gc_frame_newslot(strlit1307);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1306 = gc_frame_newslot(*var_s);
  params[0] = strlit1307;
  partcv[0] = 1;
  Object opresult1309 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1309 (depth = 6)
  *var_s = opresult1309;
  if (opresult1309 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1311 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1312 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1313 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1314 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1313);
// compiled call node returning call1314 (depth = 9)
// compiled member node returning call1314 (depth = 8)
  partcv[0] = 0;
  Object call1315 = callmethod(call1314, "indices",
    1, partcv, params);
  gc_frame_end(callframe1312);
// compiled call node returning call1315 (depth = 7)
// compiled member node returning call1315 (depth = 6)
  gc_frame_newslot(call1315);
// starting to compile block node (depth = 6)
  Object block1316 = alloc_Block(NULL, NULL, "ast", 317);
  gc_frame_newslot(block1316);
// method _apply
  block_savedest(block1316);
  Object closure1317 = createclosure(2, "_apply");
  setclosureframe(closure1317, stackframe);
  addtoclosure(closure1317, var_s);
  addtoclosure(closure1317, selfslot);
  struct UserObject *uo1317 = (struct UserObject*)block1316;
  uo1317->data[0] = (Object)closure1317;
  Method *meth_meth_ast__apply1317 = addmethod2pos(block1316, "_apply", &meth_ast__apply1317, 0);
  int argcv_meth_ast__apply1317[] = {1};
  meth_meth_ast__apply1317->type = alloc_MethodType(1, argcv_meth_ast__apply1317);
  meth_meth_ast__apply1317->definitionModule = modulename;
  meth_meth_ast__apply1317->definitionLine = 317;
// compiled block node returning block1316 (depth = 6)
  gc_frame_newslot(block1316);
// call case 5: prelude request
  params[0] = call1315;
  params[1] = block1316;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1369 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1311);
// compiled call node returning call1369 (depth = 5)
    gc_frame_newslot(call1369);
    if1297 = call1369;
  } else {
  }
// compiled if node returning if1297 (depth = 4)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1370 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1372 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1371);
// compiled call node returning call1372 (depth = 6)
// compiled member node returning call1372 (depth = 5)
  gc_frame_newslot(call1372);
// starting to compile block node (depth = 5)
  Object block1373 = alloc_Block(NULL, NULL, "ast", 331);
  gc_frame_newslot(block1373);
// method _apply
  block_savedest(block1373);
  Object closure1374 = createclosure(4, "_apply");
  setclosureframe(closure1374, stackframe);
  addtoclosure(closure1374, var_depth);
  addtoclosure(closure1374, var_spc);
  addtoclosure(closure1374, var_s);
  addtoclosure(closure1374, selfslot);
  struct UserObject *uo1374 = (struct UserObject*)block1373;
  uo1374->data[0] = (Object)closure1374;
  Method *meth_meth_ast__apply1374 = addmethod2pos(block1373, "_apply", &meth_ast__apply1374, 0);
  int argcv_meth_ast__apply1374[] = {1};
  meth_meth_ast__apply1374->type = alloc_MethodType(1, argcv_meth_ast__apply1374);
  meth_meth_ast__apply1374->definitionModule = modulename;
  meth_meth_ast__apply1374->definitionLine = 331;
// compiled block node returning block1373 (depth = 5)
  gc_frame_newslot(block1373);
// call case 5: prelude request
  params[0] = call1372;
  params[1] = block1373;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1397 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1370);
// compiled call node returning call1397 (depth = 4)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1399 == NULL) {
    strlit1399 = alloc_String("}");
    gc_root(strlit1399);
  }
// compiled string node returning strlit1399 (depth = 6)
  int op_slot_right_1398 = gc_frame_newslot(strlit1399);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1401 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1404 == NULL) {
    strlit1404 = alloc_String("""\x0a""");
    gc_root(strlit1404);
  }
// compiled string node returning strlit1404 (depth = 8)
  int op_slot_right_1403 = gc_frame_newslot(strlit1404);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1403 = gc_frame_newslot(*var_s);
  params[0] = strlit1404;
  partcv[0] = 1;
  Object opresult1406 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1406 (depth = 7)
  int op_slot_left_1401 = gc_frame_newslot(opresult1406);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1407 = callmethod(opresult1406, "++", 1, partcv, params);
// compiled op node returning opresult1407 (depth = 6)
  int op_slot_left_1398 = gc_frame_newslot(opresult1407);
  params[0] = strlit1399;
  partcv[0] = 1;
  Object opresult1408 = callmethod(opresult1407, "++", 1, partcv, params);
// compiled op node returning opresult1408 (depth = 5)
  *var_s = opresult1408;
  if (opresult1408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent1410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1411 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1412 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1413 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1414 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1413);
// compiled call node returning call1414 (depth = 7)
// compiled member node returning call1414 (depth = 6)
  gc_frame_newslot(call1414);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1415 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1416 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1415);
// compiled call node returning call1416 (depth = 7)
// compiled member node returning call1416 (depth = 6)
  gc_frame_newslot(call1416);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blockNode (depth = 6)
  params[0] = call1414;
  params[1] = call1416;
  partcv[0] = 2;
  Object call1417 = callmethod(*var_blockNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1412);
// compiled call node returning call1417 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1418 = callmethod(call1417, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe1411);
// compiled call node returning call1418 (depth = 4)
  gc_frame_end(frame);
  return call1418;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent1419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1420 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1421 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1420);
// compiled call node returning call1421 (depth = 4)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1422 = gc_frame_new();
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call1424 = callmethod(*var_other, "matchingPattern",
    1, partcv, params);
  gc_frame_end(callframe1423);
// compiled call node returning call1424 (depth = 7)
// compiled member node returning call1424 (depth = 6)
  gc_frame_newslot(call1424);
// call case 4: self request
  params[0] = call1424;
  partcv[0] = 1;
  Object call1425 = callmethodflags(self, "matchingPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1422);
// compiled call node returning call1425 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1426 = gc_frame_new();
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1427 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call1428 = callmethod(*var_other, "extraRuntimeData",
    1, partcv, params);
  gc_frame_end(callframe1427);
// compiled call node returning call1428 (depth = 7)
// compiled member node returning call1428 (depth = 6)
  gc_frame_newslot(call1428);
// call case 4: self request
  params[0] = call1428;
  partcv[0] = 1;
  Object call1429 = callmethodflags(self, "extraRuntimeData:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1426);
// compiled call node returning call1429 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply1439(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1440 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_patternMarkVisitor (depth = 7)
  gc_frame_newslot(*var_patternMarkVisitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  params[0] = *var_patternMarkVisitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1441 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1440);
// compiled call node returning call1441 (depth = 6)
  gc_frame_end(frame);
  return call1441;
}
Object meth_ast_new1033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_symbolTableNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1034 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1034 = alloc_userobj2(23,20, objclass1034);
  gc_frame_newslot(obj1034);
if (objclass1034 == NULL) {
  glfree(obj1034->class->name);
  obj1034->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1034, self, 0);
  addmethodreal(obj1034,"outer", &reader_ast_outer_1035);
  Object oldself1034 = self;
  struct StackFrameObject *oldstackframe1034 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1034);
  gc_frame_newslot((Object)stackframe);
  self = obj1034;
  Object *oldselfslot1034 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1034 = (*(struct UserObject *)self).data[0], lowerouter1034 = thisouter1034;
  if (inheritingObject1034) {
    struct UserObject *inho1034 = (struct UserObject *)inheritingObject1034;
    while (inho1034->super != GraceDefaultObject) inho1034 = (struct UserObject *)inho1034->super;
    inho1034->super = obj1034;
    self = inheritingObject1034;
    *selfslot = self;
    lowerouter1034 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1034;
  }
if (objclass1034 == NULL) {
  Method *reader1036 = addmethodrealflags(obj1034, "kind",&reader_ast_kind_1036, MFLAG_DEF);
  reader1036->definitionModule = modulename;
  reader1036->definitionLine = 247;
}
adddatum2(obj1034, alloc_Undefined(), 1);
if (objclass1034 == NULL) {
  Method *reader1037 = addmethodrealflags(obj1034, "value",&reader_ast_value_1037, MFLAG_DEF);
  reader1037->definitionModule = modulename;
  reader1037->definitionLine = 248;
}
adddatum2(obj1034, alloc_Undefined(), 2);
if (objclass1034 == NULL) {
  Method *reader1038 = addmethodrealflags(obj1034, "params",&reader_ast_params_1038, 0);
  Method *writer1038 = addmethodrealflags(obj1034, "params:=",&writer_ast_params_1038, 0);
  reader1038->definitionModule = modulename;
  writer1038->definitionModule = modulename;
  reader1038->definitionLine = 249;
  writer1038->definitionLine = 249;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 3);
if (objclass1034 == NULL) {
  Method *reader1039 = addmethodrealflags(obj1034, "body",&reader_ast_body_1039, 0);
  Method *writer1039 = addmethodrealflags(obj1034, "body:=",&writer_ast_body_1039, 0);
  reader1039->definitionModule = modulename;
  writer1039->definitionModule = modulename;
  reader1039->definitionLine = 250;
  writer1039->definitionLine = 250;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 4);
if (objclass1034 == NULL) {
  Method *reader1040 = addmethodrealflags(obj1034, "selfclosure",&reader_ast_selfclosure_1040, MFLAG_DEF);
  reader1040->definitionModule = modulename;
  reader1040->definitionLine = 251;
}
adddatum2(obj1034, alloc_Undefined(), 5);
if (objclass1034 == NULL) {
  Method *reader1041 = addmethodrealflags(obj1034, "matchingPattern",&reader_ast_matchingPattern_1041, 0);
  Method *writer1041 = addmethodrealflags(obj1034, "matchingPattern:=",&writer_ast_matchingPattern_1041, 0);
  reader1041->definitionModule = modulename;
  writer1041->definitionModule = modulename;
  reader1041->definitionLine = 252;
  writer1041->definitionLine = 252;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 6);
if (objclass1034 == NULL) {
  Method *reader1042 = addmethodrealflags(obj1034, "extraRuntimeData",&reader_ast_extraRuntimeData_1042, 0);
  Method *writer1042 = addmethodrealflags(obj1034, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1042, 0);
  reader1042->definitionModule = modulename;
  writer1042->definitionModule = modulename;
  reader1042->definitionLine = 253;
  writer1042->definitionLine = 253;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 7);
// method declarationKind
  struct UserObject *uo1043 = (struct UserObject*)obj1034;
  uo1043->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKind1043 = addmethod2pos(obj1034, "declarationKind", &meth_ast_declarationKind1043, 8);
  int argcv_meth_ast_declarationKind1043[] = {0};
  meth_meth_ast_declarationKind1043->type = alloc_MethodType(1, argcv_meth_ast_declarationKind1043);
  meth_meth_ast_declarationKind1043->definitionModule = modulename;
  meth_meth_ast_declarationKind1043->definitionLine = 256;
// method isMatchingBlock
  struct UserObject *uo1045 = (struct UserObject*)obj1034;
  uo1045->data[9] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1045 = addmethod2pos(obj1034, "isMatchingBlock", &meth_ast_isMatchingBlock1045, 9);
  int argcv_meth_ast_isMatchingBlock1045[] = {0};
  meth_meth_ast_isMatchingBlock1045->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1045);
  meth_meth_ast_isMatchingBlock1045->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1045->definitionLine = 259;
// method definesObject
  struct UserObject *uo1054 = (struct UserObject*)obj1034;
  uo1054->data[10] = emptyclosure;
  Method *meth_meth_ast_definesObject1054 = addmethod2pos(obj1034, "definesObject", &meth_ast_definesObject1054, 10);
  int argcv_meth_ast_definesObject1054[] = {0};
  meth_meth_ast_definesObject1054->type = alloc_MethodType(1, argcv_meth_ast_definesObject1054);
  meth_meth_ast_definesObject1054->definitionModule = modulename;
  meth_meth_ast_definesObject1054->definitionLine = 260;
// method parametersDo
  struct UserObject *uo1072 = (struct UserObject*)obj1034;
  uo1072->data[11] = emptyclosure;
  Method *meth_meth_ast_parametersDo1072 = addmethod2pos(obj1034, "parametersDo", &meth_ast_parametersDo1072, 11);
  int argcv_meth_ast_parametersDo1072[] = {1};
  meth_meth_ast_parametersDo1072->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1072);
  meth_meth_ast_parametersDo1072->definitionModule = modulename;
  meth_meth_ast_parametersDo1072->definitionLine = 263;
// method accept()from
  struct UserObject *uo1077 = (struct UserObject*)obj1034;
  uo1077->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1077 = addmethod2pos(obj1034, "accept()from", &meth_ast_accept_40__41_from1077, 12);
  int argcv_meth_ast_accept_40__41_from1077[] = {1, 1};
  meth_meth_ast_accept_40__41_from1077->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1077);
  meth_meth_ast_accept_40__41_from1077->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1077->definitionLine = 266;
// method map()parent
  struct UserObject *uo1110 = (struct UserObject*)obj1034;
  uo1110->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent1110 = addmethod2pos(obj1034, "map()parent", &meth_ast_map_40__41_parent1110, 13);
  int argcv_meth_ast_map_40__41_parent1110[] = {1, 1};
  meth_meth_ast_map_40__41_parent1110->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent1110);
  meth_meth_ast_map_40__41_parent1110->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent1110->definitionLine = 279;
// method pretty
  struct UserObject *uo1146 = (struct UserObject*)obj1034;
  uo1146->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty1146 = addmethod2pos(obj1034, "pretty", &meth_ast_pretty1146, 14);
  int argcv_meth_ast_pretty1146[] = {1};
  meth_meth_ast_pretty1146->type = alloc_MethodType(1, argcv_meth_ast_pretty1146);
  meth_meth_ast_pretty1146->definitionModule = modulename;
  meth_meth_ast_pretty1146->definitionLine = 287;
// method toGrace
  struct UserObject *uo1276 = (struct UserObject*)obj1034;
  uo1276->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace1276 = addmethod2pos(obj1034, "toGrace", &meth_ast_toGrace1276, 15);
  int argcv_meth_ast_toGrace1276[] = {1};
  meth_meth_ast_toGrace1276->type = alloc_MethodType(1, argcv_meth_ast_toGrace1276);
meth_meth_ast_toGrace1276->type->types[0] = type_Number;
meth_meth_ast_toGrace1276->type->names[0] = "depth";
  meth_meth_ast_toGrace1276->definitionModule = modulename;
  meth_meth_ast_toGrace1276->definitionLine = 309;
// method shallowCopyWithParent
  block_savedest(obj1034);
  Object closure1410 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure1410, stackframe);
  addtoclosure(closure1410, var_blockNode);
  struct UserObject *uo1410 = (struct UserObject*)obj1034;
  uo1410->data[16] = (Object)closure1410;
  Method *meth_meth_ast_shallowCopyWithParent1410 = addmethod2pos(obj1034, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent1410, 16);
  int argcv_meth_ast_shallowCopyWithParent1410[] = {1};
  meth_meth_ast_shallowCopyWithParent1410->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent1410);
  meth_meth_ast_shallowCopyWithParent1410->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent1410->definitionLine = 337;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo1419 = (struct UserObject*)obj1034;
  uo1419->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419 = addmethod2pos(obj1034, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent1419, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1419[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1419);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419->definitionLine = 340;
  sourceObject = obj1034;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1430 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1431 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1430);
// compiled call node returning call1431 (depth = 4)
  struct UserObject *obj1034_uo = (struct UserObject *)obj1034;
  obj1034_uo->super = call1431;
  sourceObject = obj1034;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1432 == NULL) {
    strlit1432 = alloc_String("block");
    gc_root(strlit1432);
  }
// compiled string node returning strlit1432 (depth = 4)
  adddatum2(obj1034, strlit1432, 1);
  sourceObject = obj1034;
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1433 == NULL) {
    strlit1433 = alloc_String("block");
    gc_root(strlit1433);
  }
// compiled string node returning strlit1433 (depth = 4)
  adddatum2(obj1034, strlit1433, 2);
  sourceObject = obj1034;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj1034, *var_params_39_, 3);
  sourceObject = obj1034;
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj1034, *var_body_39_, 4);
  sourceObject = obj1034;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1434 = alloc_Boolean(1);
// compiled identifier node returning bool1434 (depth = 4)
  adddatum2(obj1034, bool1434, 5);
  sourceObject = obj1034;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1435 = alloc_Boolean(0);
// compiled identifier node returning bool1435 (depth = 4)
  adddatum2(obj1034, bool1435, 6);
  sourceObject = obj1034;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1436 = alloc_Boolean(0);
// compiled identifier node returning bool1436 (depth = 4)
  adddatum2(obj1034, bool1436, 7);
  sourceObject = obj1034;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1437 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params_39_ (depth = 5)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 5)
  Object block1438 = alloc_Block(NULL, NULL, "ast", 253);
  gc_frame_newslot(block1438);
// method _apply
  block_savedest(block1438);
  Object closure1439 = createclosure(2, "_apply");
  setclosureframe(closure1439, stackframe);
  addtoclosure(closure1439, var_patternMarkVisitor);
  addtoclosure(closure1439, selfslot);
  struct UserObject *uo1439 = (struct UserObject*)block1438;
  uo1439->data[0] = (Object)closure1439;
  Method *meth_meth_ast__apply1439 = addmethod2pos(block1438, "_apply", &meth_ast__apply1439, 0);
  int argcv_meth_ast__apply1439[] = {1};
  meth_meth_ast__apply1439->type = alloc_MethodType(1, argcv_meth_ast__apply1439);
  meth_meth_ast__apply1439->definitionModule = modulename;
  meth_meth_ast__apply1439->definitionLine = 343;
// compiled block node returning block1438 (depth = 5)
  gc_frame_newslot(block1438);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1438;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1443 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1437);
// compiled call node returning call1443 (depth = 4)
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
objclass1034 = obj1034->class;
  objclass1034->definitionModule = modulename;
  objclass1034->definitionLine = 244;
  (*(struct UserObject *)self).data[0] = lowerouter1034;
  self = oldself1034;
  selfslot = oldselfslot1034;
  stackframe = oldstackframe1034;
  gc_frame_end(frame);
  return obj1034;
}
Object meth_ast_new1033_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_symbolTableNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1034 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1034 = alloc_userobj2(23,20, objclass1034);
  gc_frame_newslot(obj1034);
if (objclass1034 == NULL) {
  glfree(obj1034->class->name);
  obj1034->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1034, self, 0);
  addmethodreal(obj1034,"outer", &reader_ast_outer_1035);
  Object oldself1034 = self;
  struct StackFrameObject *oldstackframe1034 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1034);
  gc_frame_newslot((Object)stackframe);
  self = obj1034;
  Object *oldselfslot1034 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1034 = (*(struct UserObject *)self).data[0], lowerouter1034 = thisouter1034;
  if (inheritingObject1034) {
    struct UserObject *inho1034 = (struct UserObject *)inheritingObject1034;
    while (inho1034->super != GraceDefaultObject) inho1034 = (struct UserObject *)inho1034->super;
    inho1034->super = obj1034;
    self = inheritingObject1034;
    *selfslot = self;
    lowerouter1034 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1034;
  }
if (objclass1034 == NULL) {
  Method *reader1036 = addmethodrealflags(obj1034, "kind",&reader_ast_kind_1036, MFLAG_DEF);
  reader1036->definitionModule = modulename;
  reader1036->definitionLine = 247;
}
adddatum2(obj1034, alloc_Undefined(), 1);
if (objclass1034 == NULL) {
  Method *reader1037 = addmethodrealflags(obj1034, "value",&reader_ast_value_1037, MFLAG_DEF);
  reader1037->definitionModule = modulename;
  reader1037->definitionLine = 248;
}
adddatum2(obj1034, alloc_Undefined(), 2);
if (objclass1034 == NULL) {
  Method *reader1038 = addmethodrealflags(obj1034, "params",&reader_ast_params_1038, 0);
  Method *writer1038 = addmethodrealflags(obj1034, "params:=",&writer_ast_params_1038, 0);
  reader1038->definitionModule = modulename;
  writer1038->definitionModule = modulename;
  reader1038->definitionLine = 249;
  writer1038->definitionLine = 249;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 3);
if (objclass1034 == NULL) {
  Method *reader1039 = addmethodrealflags(obj1034, "body",&reader_ast_body_1039, 0);
  Method *writer1039 = addmethodrealflags(obj1034, "body:=",&writer_ast_body_1039, 0);
  reader1039->definitionModule = modulename;
  writer1039->definitionModule = modulename;
  reader1039->definitionLine = 250;
  writer1039->definitionLine = 250;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 4);
if (objclass1034 == NULL) {
  Method *reader1040 = addmethodrealflags(obj1034, "selfclosure",&reader_ast_selfclosure_1040, MFLAG_DEF);
  reader1040->definitionModule = modulename;
  reader1040->definitionLine = 251;
}
adddatum2(obj1034, alloc_Undefined(), 5);
if (objclass1034 == NULL) {
  Method *reader1041 = addmethodrealflags(obj1034, "matchingPattern",&reader_ast_matchingPattern_1041, 0);
  Method *writer1041 = addmethodrealflags(obj1034, "matchingPattern:=",&writer_ast_matchingPattern_1041, 0);
  reader1041->definitionModule = modulename;
  writer1041->definitionModule = modulename;
  reader1041->definitionLine = 252;
  writer1041->definitionLine = 252;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 6);
if (objclass1034 == NULL) {
  Method *reader1042 = addmethodrealflags(obj1034, "extraRuntimeData",&reader_ast_extraRuntimeData_1042, 0);
  Method *writer1042 = addmethodrealflags(obj1034, "extraRuntimeData:=",&writer_ast_extraRuntimeData_1042, 0);
  reader1042->definitionModule = modulename;
  writer1042->definitionModule = modulename;
  reader1042->definitionLine = 253;
  writer1042->definitionLine = 253;
}
obj1034->flags |= OFLAG_MUTABLE;
adddatum2(obj1034, alloc_Undefined(), 7);
// method declarationKind
  struct UserObject *uo1043 = (struct UserObject*)obj1034;
  uo1043->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKind1043 = addmethod2pos(obj1034, "declarationKind", &meth_ast_declarationKind1043, 8);
  int argcv_meth_ast_declarationKind1043[] = {0};
  meth_meth_ast_declarationKind1043->type = alloc_MethodType(1, argcv_meth_ast_declarationKind1043);
  meth_meth_ast_declarationKind1043->definitionModule = modulename;
  meth_meth_ast_declarationKind1043->definitionLine = 256;
// method isMatchingBlock
  struct UserObject *uo1045 = (struct UserObject*)obj1034;
  uo1045->data[9] = emptyclosure;
  Method *meth_meth_ast_isMatchingBlock1045 = addmethod2pos(obj1034, "isMatchingBlock", &meth_ast_isMatchingBlock1045, 9);
  int argcv_meth_ast_isMatchingBlock1045[] = {0};
  meth_meth_ast_isMatchingBlock1045->type = alloc_MethodType(1, argcv_meth_ast_isMatchingBlock1045);
  meth_meth_ast_isMatchingBlock1045->definitionModule = modulename;
  meth_meth_ast_isMatchingBlock1045->definitionLine = 259;
// method definesObject
  struct UserObject *uo1054 = (struct UserObject*)obj1034;
  uo1054->data[10] = emptyclosure;
  Method *meth_meth_ast_definesObject1054 = addmethod2pos(obj1034, "definesObject", &meth_ast_definesObject1054, 10);
  int argcv_meth_ast_definesObject1054[] = {0};
  meth_meth_ast_definesObject1054->type = alloc_MethodType(1, argcv_meth_ast_definesObject1054);
  meth_meth_ast_definesObject1054->definitionModule = modulename;
  meth_meth_ast_definesObject1054->definitionLine = 260;
// method parametersDo
  struct UserObject *uo1072 = (struct UserObject*)obj1034;
  uo1072->data[11] = emptyclosure;
  Method *meth_meth_ast_parametersDo1072 = addmethod2pos(obj1034, "parametersDo", &meth_ast_parametersDo1072, 11);
  int argcv_meth_ast_parametersDo1072[] = {1};
  meth_meth_ast_parametersDo1072->type = alloc_MethodType(1, argcv_meth_ast_parametersDo1072);
  meth_meth_ast_parametersDo1072->definitionModule = modulename;
  meth_meth_ast_parametersDo1072->definitionLine = 263;
// method accept()from
  struct UserObject *uo1077 = (struct UserObject*)obj1034;
  uo1077->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1077 = addmethod2pos(obj1034, "accept()from", &meth_ast_accept_40__41_from1077, 12);
  int argcv_meth_ast_accept_40__41_from1077[] = {1, 1};
  meth_meth_ast_accept_40__41_from1077->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1077);
  meth_meth_ast_accept_40__41_from1077->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1077->definitionLine = 266;
// method map()parent
  struct UserObject *uo1110 = (struct UserObject*)obj1034;
  uo1110->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent1110 = addmethod2pos(obj1034, "map()parent", &meth_ast_map_40__41_parent1110, 13);
  int argcv_meth_ast_map_40__41_parent1110[] = {1, 1};
  meth_meth_ast_map_40__41_parent1110->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent1110);
  meth_meth_ast_map_40__41_parent1110->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent1110->definitionLine = 279;
// method pretty
  struct UserObject *uo1146 = (struct UserObject*)obj1034;
  uo1146->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty1146 = addmethod2pos(obj1034, "pretty", &meth_ast_pretty1146, 14);
  int argcv_meth_ast_pretty1146[] = {1};
  meth_meth_ast_pretty1146->type = alloc_MethodType(1, argcv_meth_ast_pretty1146);
  meth_meth_ast_pretty1146->definitionModule = modulename;
  meth_meth_ast_pretty1146->definitionLine = 287;
// method toGrace
  struct UserObject *uo1276 = (struct UserObject*)obj1034;
  uo1276->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace1276 = addmethod2pos(obj1034, "toGrace", &meth_ast_toGrace1276, 15);
  int argcv_meth_ast_toGrace1276[] = {1};
  meth_meth_ast_toGrace1276->type = alloc_MethodType(1, argcv_meth_ast_toGrace1276);
meth_meth_ast_toGrace1276->type->types[0] = type_Number;
meth_meth_ast_toGrace1276->type->names[0] = "depth";
  meth_meth_ast_toGrace1276->definitionModule = modulename;
  meth_meth_ast_toGrace1276->definitionLine = 309;
// method shallowCopyWithParent
  block_savedest(obj1034);
  Object closure1410 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure1410, stackframe);
  addtoclosure(closure1410, var_blockNode);
  struct UserObject *uo1410 = (struct UserObject*)obj1034;
  uo1410->data[16] = (Object)closure1410;
  Method *meth_meth_ast_shallowCopyWithParent1410 = addmethod2pos(obj1034, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent1410, 16);
  int argcv_meth_ast_shallowCopyWithParent1410[] = {1};
  meth_meth_ast_shallowCopyWithParent1410->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent1410);
  meth_meth_ast_shallowCopyWithParent1410->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent1410->definitionLine = 337;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo1419 = (struct UserObject*)obj1034;
  uo1419->data[17] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419 = addmethod2pos(obj1034, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent1419, 17);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1419[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent1419);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent1419->definitionLine = 340;
  sourceObject = obj1034;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1430 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1431 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1430);
// compiled call node returning call1431 (depth = 4)
  struct UserObject *obj1034_uo = (struct UserObject *)obj1034;
  obj1034_uo->super = call1431;
  sourceObject = obj1034;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1432 == NULL) {
    strlit1432 = alloc_String("block");
    gc_root(strlit1432);
  }
// compiled string node returning strlit1432 (depth = 4)
  adddatum2(obj1034, strlit1432, 1);
  sourceObject = obj1034;
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1433 == NULL) {
    strlit1433 = alloc_String("block");
    gc_root(strlit1433);
  }
// compiled string node returning strlit1433 (depth = 4)
  adddatum2(obj1034, strlit1433, 2);
  sourceObject = obj1034;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj1034, *var_params_39_, 3);
  sourceObject = obj1034;
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj1034, *var_body_39_, 4);
  sourceObject = obj1034;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1434 = alloc_Boolean(1);
// compiled identifier node returning bool1434 (depth = 4)
  adddatum2(obj1034, bool1434, 5);
  sourceObject = obj1034;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1435 = alloc_Boolean(0);
// compiled identifier node returning bool1435 (depth = 4)
  adddatum2(obj1034, bool1435, 6);
  sourceObject = obj1034;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1436 = alloc_Boolean(0);
// compiled identifier node returning bool1436 (depth = 4)
  adddatum2(obj1034, bool1436, 7);
  sourceObject = obj1034;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1437 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params_39_ (depth = 5)
  gc_frame_newslot(*var_params_39_);
// starting to compile block node (depth = 5)
  Object block1438 = alloc_Block(NULL, NULL, "ast", 253);
  gc_frame_newslot(block1438);
// method _apply
  block_savedest(block1438);
  Object closure1439 = createclosure(2, "_apply");
  setclosureframe(closure1439, stackframe);
  addtoclosure(closure1439, var_patternMarkVisitor);
  addtoclosure(closure1439, selfslot);
  struct UserObject *uo1439 = (struct UserObject*)block1438;
  uo1439->data[0] = (Object)closure1439;
  Method *meth_meth_ast__apply1439 = addmethod2pos(block1438, "_apply", &meth_ast__apply1439, 0);
  int argcv_meth_ast__apply1439[] = {1};
  meth_meth_ast__apply1439->type = alloc_MethodType(1, argcv_meth_ast__apply1439);
  meth_meth_ast__apply1439->definitionModule = modulename;
  meth_meth_ast__apply1439->definitionLine = 343;
// compiled block node returning block1438 (depth = 5)
  gc_frame_newslot(block1438);
// call case 5: prelude request
  params[0] = *var_params_39_;
  params[1] = block1438;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1443 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1437);
// compiled call node returning call1443 (depth = 4)
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
  sourceObject = obj1034;
objclass1034 = obj1034->class;
  objclass1034->definitionModule = modulename;
  objclass1034->definitionLine = 244;
  (*(struct UserObject *)self).data[0] = lowerouter1034;
  self = oldself1034;
  selfslot = oldselfslot1034;
  stackframe = oldstackframe1034;
  gc_frame_end(frame);
  return obj1034;
}
Object meth_ast_catchCaseNode1445(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for catchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_catchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_catchCaseNode;
}
Object meth_ast__apply1467(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1468 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1469 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1469 (depth = 7)
  gc_frame_end(frame);
  return call1469;
}
Object meth_ast_accept_40__41_from1455(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1457 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1458 = callmethod(*var_visitor, "visitCatchCase()up",
    2, partcv, params);
  gc_frame_end(callframe1457);
// compiled call node returning call1458 (depth = 5)
  Object if1456 = done;
  if (istrue(call1458)) {
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1459 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1461 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1460);
// compiled call node returning call1461 (depth = 7)
// compiled member node returning call1461 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1462 = callmethod(call1461, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1459);
// compiled call node returning call1462 (depth = 5)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1463 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1465 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1464);
// compiled call node returning call1465 (depth = 7)
// compiled member node returning call1465 (depth = 6)
  gc_frame_newslot(call1465);
// starting to compile block node (depth = 6)
  Object block1466 = alloc_Block(NULL, NULL, "ast", 357);
  gc_frame_newslot(block1466);
// method _apply
  block_savedest(block1466);
  Object closure1467 = createclosure(2, "_apply");
  setclosureframe(closure1467, stackframe);
  addtoclosure(closure1467, var_visitor);
  addtoclosure(closure1467, selfslot);
  struct UserObject *uo1467 = (struct UserObject*)block1466;
  uo1467->data[0] = (Object)closure1467;
  Method *meth_meth_ast__apply1467 = addmethod2pos(block1466, "_apply", &meth_ast__apply1467, 0);
  int argcv_meth_ast__apply1467[] = {1};
  meth_meth_ast__apply1467->type = alloc_MethodType(1, argcv_meth_ast__apply1467);
  meth_meth_ast__apply1467->definitionModule = modulename;
  meth_meth_ast__apply1467->definitionLine = 357;
// compiled block node returning block1466 (depth = 6)
  gc_frame_newslot(block1466);
// call case 5: prelude request
  params[0] = call1465;
  params[1] = block1466;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1471 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1463);
// compiled call node returning call1471 (depth = 5)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1474 = alloc_Boolean(0);
// compiled identifier node returning bool1474 (depth = 7)
  int op_slot_right_1473 = gc_frame_newslot(bool1474);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1476 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1477 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1476);
// compiled call node returning call1477 (depth = 8)
// compiled member node returning call1477 (depth = 7)
  int op_slot_left_1473 = gc_frame_newslot(call1477);
  params[0] = bool1474;
  partcv[0] = 1;
  Object opresult1478 = callmethod(call1477, "!=", 1, partcv, params);
// compiled op node returning opresult1478 (depth = 6)
  Object if1472 = done;
  if (istrue(opresult1478)) {
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1479 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1481 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1480);
// compiled call node returning call1481 (depth = 8)
// compiled member node returning call1481 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1482 = callmethod(call1481, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1479);
// compiled call node returning call1482 (depth = 6)
    gc_frame_newslot(call1482);
    if1472 = call1482;
  } else {
  }
// compiled if node returning if1472 (depth = 5)
    gc_frame_newslot(if1472);
    if1456 = if1472;
  } else {
  }
// compiled if node returning if1456 (depth = 4)
  gc_frame_end(frame);
  return if1456;
}
Object meth_ast_map_40__41_parent1483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1484 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call1485 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1484);
// compiled call node returning call1485 (depth = 5)
  *var_n = call1485;
  if (call1485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1486 = gc_frame_new();
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1487 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1489 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1488);
// compiled call node returning call1489 (depth = 8)
// compiled member node returning call1489 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1490 = callmethod(call1489, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe1487);
// compiled call node returning call1490 (depth = 6)
  gc_frame_newslot(call1490);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1490;
  partcv[0] = 1;
  Object call1491 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1486);
// compiled call node returning call1491 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1492 = gc_frame_new();
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1493 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1494 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1495 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1494);
// compiled call node returning call1495 (depth = 8)
// compiled member node returning call1495 (depth = 7)
  gc_frame_newslot(call1495);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1496 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1497 = gc_frame_new();
// call case 3: self.outer request
  Object call1498 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1497);
// compiled call node returning call1498 (depth = 10)
// compiled member node returning call1498 (depth = 9)
  partcv[0] = 0;
  Object call1499 = callmethodflags(call1498, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1496);
// compiled call node returning call1499 (depth = 8)
// compiled member node returning call1499 (depth = 7)
  params[0] = call1495;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1500 = callmethodflags(call1499, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1493);
// compiled call node returning call1500 (depth = 6)
  gc_frame_newslot(call1500);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1500;
  partcv[0] = 1;
  Object call1501 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe1492);
// compiled call node returning call1501 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1502 = gc_frame_new();
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1503 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1504 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1505 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1504);
// compiled call node returning call1505 (depth = 8)
// compiled member node returning call1505 (depth = 7)
  gc_frame_newslot(call1505);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1506 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1507 = gc_frame_new();
// call case 3: self.outer request
  Object call1508 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1507);
// compiled call node returning call1508 (depth = 10)
// compiled member node returning call1508 (depth = 9)
  partcv[0] = 0;
  Object call1509 = callmethodflags(call1508, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1506);
// compiled call node returning call1509 (depth = 8)
// compiled member node returning call1509 (depth = 7)
  params[0] = call1505;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1510 = callmethodflags(call1509, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1503);
// compiled call node returning call1510 (depth = 6)
  gc_frame_newslot(call1510);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1510;
  partcv[0] = 1;
  Object call1511 = callmethod(*var_n, "finally:=",
    1, partcv, params);
  gc_frame_end(callframe1502);
// compiled call node returning call1511 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1520(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1522 == NULL) {
    strlit1522 = alloc_String("  ");
    gc_root(strlit1522);
  }
// compiled string node returning strlit1522 (depth = 8)
  int op_slot_right_1521 = gc_frame_newslot(strlit1522);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1521 = gc_frame_newslot(*var_spc);
  params[0] = strlit1522;
  partcv[0] = 1;
  Object opresult1524 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1524 (depth = 7)
  *var_spc = opresult1524;
  if (opresult1524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1557(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1560 == NULL) {
    strlit1560 = alloc_String("");
    gc_root(strlit1560);
  }
// compiled string node returning strlit1560 (depth = 9)
  int op_slot_right_1559 = gc_frame_newslot(strlit1560);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1563 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1565 = alloc_Float64(2);
// compiled num node returning num1565 (depth = 12)
  int op_slot_right_1564 = gc_frame_newslot(num1565);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_1564 = gc_frame_newslot(*var_depth);
  params[0] = num1565;
  partcv[0] = 1;
  Object sum1567 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1567 (depth = 11)
  gc_frame_newslot(sum1567);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mx (depth = 11)
  params[0] = sum1567;
  partcv[0] = 1;
  Object call1568 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1563);
// compiled call node returning call1568 (depth = 10)
  int op_slot_right_1562 = gc_frame_newslot(call1568);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1571 == NULL) {
    strlit1571 = alloc_String("  ");
    gc_root(strlit1571);
  }
// compiled string node returning strlit1571 (depth = 11)
  int op_slot_right_1570 = gc_frame_newslot(strlit1571);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_1573 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1576 == NULL) {
    strlit1576 = alloc_String("Case:""\x0a""");
    gc_root(strlit1576);
  }
// compiled string node returning strlit1576 (depth = 13)
  int op_slot_right_1575 = gc_frame_newslot(strlit1576);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_spc (depth = 14)
  int op_slot_right_1578 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 14)
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String("""\x0a""");
    gc_root(strlit1580);
  }
// compiled string node returning strlit1580 (depth = 14)
  int op_slot_left_1578 = gc_frame_newslot(strlit1580);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1581 = callmethod(strlit1580, "++", 1, partcv, params);
// compiled op node returning opresult1581 (depth = 13)
  int op_slot_left_1575 = gc_frame_newslot(opresult1581);
  params[0] = strlit1576;
  partcv[0] = 1;
  Object opresult1582 = callmethod(opresult1581, "++", 1, partcv, params);
// compiled op node returning opresult1582 (depth = 12)
  int op_slot_left_1573 = gc_frame_newslot(opresult1582);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1583 = callmethod(opresult1582, "++", 1, partcv, params);
// compiled op node returning opresult1583 (depth = 11)
  int op_slot_left_1570 = gc_frame_newslot(opresult1583);
  params[0] = strlit1571;
  partcv[0] = 1;
  Object opresult1584 = callmethod(opresult1583, "++", 1, partcv, params);
// compiled op node returning opresult1584 (depth = 10)
  int op_slot_left_1562 = gc_frame_newslot(opresult1584);
  params[0] = call1568;
  partcv[0] = 1;
  Object opresult1585 = callmethod(opresult1584, "++", 1, partcv, params);
// compiled op node returning opresult1585 (depth = 9)
  int op_slot_left_1559 = gc_frame_newslot(opresult1585);
  params[0] = strlit1560;
  partcv[0] = 1;
  Object opresult1586 = callmethod(opresult1585, "++", 1, partcv, params);
// compiled op node returning opresult1586 (depth = 8)
  int op_slot_right_1558 = gc_frame_newslot(opresult1586);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1558 = gc_frame_newslot(*var_s);
  params[0] = opresult1586;
  partcv[0] = 1;
  Object opresult1588 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1588 (depth = 7)
  *var_s = opresult1588;
  if (opresult1588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1512(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1513 == NULL) {
    strlit1513 = alloc_String("");
    gc_root(strlit1513);
  }
// compiled string node returning strlit1513 (depth = 5)
  *var_spc = strlit1513;
  if (strlit1513 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1514 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_1515 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num1517 = alloc_Float64(0);
// compiled num node returning num1517 (depth = 6)
  int op_slot_left_1515 = gc_frame_newslot(num1517);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1518 = callmethod(num1517, "..", 1, partcv, params);
// compiled op node returning opresult1518 (depth = 5)
  gc_frame_newslot(opresult1518);
// starting to compile block node (depth = 5)
  Object block1519 = alloc_Block(NULL, NULL, "ast", 374);
  gc_frame_newslot(block1519);
// method _apply
  block_savedest(block1519);
  Object closure1520 = createclosure(2, "_apply");
  setclosureframe(closure1520, stackframe);
  addtoclosure(closure1520, var_spc);
  addtoclosure(closure1520, selfslot);
  struct UserObject *uo1520 = (struct UserObject*)block1519;
  uo1520->data[0] = (Object)closure1520;
  Method *meth_meth_ast__apply1520 = addmethod2pos(block1519, "_apply", &meth_ast__apply1520, 0);
  int argcv_meth_ast__apply1520[] = {1};
  meth_meth_ast__apply1520->type = alloc_MethodType(1, argcv_meth_ast__apply1520);
  meth_meth_ast__apply1520->definitionModule = modulename;
  meth_meth_ast__apply1520->definitionLine = 369;
// compiled block node returning block1519 (depth = 5)
  gc_frame_newslot(block1519);
// call case 5: prelude request
  params[0] = opresult1518;
  params[1] = block1519;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1527 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1514);
// compiled call node returning call1527 (depth = 4)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1529 == NULL) {
    strlit1529 = alloc_String("""\x0a""");
    gc_root(strlit1529);
  }
// compiled string node returning strlit1529 (depth = 6)
  int op_slot_right_1528 = gc_frame_newslot(strlit1529);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1532 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1533 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1532);
// compiled call node returning call1533 (depth = 7)
  int op_slot_right_1531 = gc_frame_newslot(call1533);
// starting to compile string node (depth = 7)
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("");
    gc_root(strlit1535);
  }
// compiled string node returning strlit1535 (depth = 7)
  int op_slot_left_1531 = gc_frame_newslot(strlit1535);
  params[0] = call1533;
  partcv[0] = 1;
  Object opresult1536 = callmethod(strlit1535, "++", 1, partcv, params);
// compiled op node returning opresult1536 (depth = 6)
  int op_slot_left_1528 = gc_frame_newslot(opresult1536);
  params[0] = strlit1529;
  partcv[0] = 1;
  Object opresult1537 = callmethod(opresult1536, "++", 1, partcv, params);
// compiled op node returning opresult1537 (depth = 5)
  *var_s = opresult1537;
  if (opresult1537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1539 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1541 = alloc_Float64(2);
// compiled num node returning num1541 (depth = 8)
  int op_slot_right_1540 = gc_frame_newslot(num1541);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1540 = gc_frame_newslot(*var_depth);
  params[0] = num1541;
  partcv[0] = 1;
  Object sum1543 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1543 (depth = 7)
  gc_frame_newslot(sum1543);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1545 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1544);
// compiled call node returning call1545 (depth = 8)
// compiled member node returning call1545 (depth = 7)
  params[0] = sum1543;
  partcv[0] = 1;
  Object call1546 = callmethod(call1545, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1539);
// compiled call node returning call1546 (depth = 6)
  int op_slot_right_1538 = gc_frame_newslot(call1546);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1548 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1548 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1550 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1550 (depth = 6)
  int op_slot_left_1538 = gc_frame_newslot(opresult1550);
  params[0] = call1546;
  partcv[0] = 1;
  Object opresult1551 = callmethod(opresult1550, "++", 1, partcv, params);
// compiled op node returning opresult1551 (depth = 5)
  *var_s = opresult1551;
  if (opresult1551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1553 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1554 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1555 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1554);
// compiled call node returning call1555 (depth = 6)
// compiled member node returning call1555 (depth = 5)
  gc_frame_newslot(call1555);
// starting to compile block node (depth = 5)
  Object block1556 = alloc_Block(NULL, NULL, "ast", 379);
  gc_frame_newslot(block1556);
// method _apply
  block_savedest(block1556);
  Object closure1557 = createclosure(4, "_apply");
  setclosureframe(closure1557, stackframe);
  addtoclosure(closure1557, var_depth);
  addtoclosure(closure1557, var_spc);
  addtoclosure(closure1557, var_s);
  addtoclosure(closure1557, selfslot);
  struct UserObject *uo1557 = (struct UserObject*)block1556;
  uo1557->data[0] = (Object)closure1557;
  Method *meth_meth_ast__apply1557 = addmethod2pos(block1556, "_apply", &meth_ast__apply1557, 0);
  int argcv_meth_ast__apply1557[] = {1};
  meth_meth_ast__apply1557->type = alloc_MethodType(1, argcv_meth_ast__apply1557);
  meth_meth_ast__apply1557->definitionModule = modulename;
  meth_meth_ast__apply1557->definitionLine = 379;
// compiled block node returning block1556 (depth = 5)
  gc_frame_newslot(block1556);
// call case 5: prelude request
  params[0] = call1555;
  params[1] = block1556;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1591 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1553);
// compiled call node returning call1591 (depth = 4)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1594 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1595 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1594);
// compiled call node returning call1595 (depth = 7)
// compiled member node returning call1595 (depth = 6)
  int op_slot_right_1593 = gc_frame_newslot(call1595);
// starting to compile identifier node (depth = 6)
  Object bool1597 = alloc_Boolean(0);
// compiled identifier node returning bool1597 (depth = 6)
  int op_slot_left_1593 = gc_frame_newslot(bool1597);
  params[0] = call1595;
  partcv[0] = 1;
  Object opresult1598 = callmethod(bool1597, "!=", 1, partcv, params);
// compiled op node returning opresult1598 (depth = 5)
  Object if1592 = done;
  if (istrue(opresult1598)) {
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1601 == NULL) {
    strlit1601 = alloc_String("");
    gc_root(strlit1601);
  }
// compiled string node returning strlit1601 (depth = 8)
  int op_slot_right_1600 = gc_frame_newslot(strlit1601);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1604 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1606 = alloc_Float64(2);
// compiled num node returning num1606 (depth = 11)
  int op_slot_right_1605 = gc_frame_newslot(num1606);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1605 = gc_frame_newslot(*var_depth);
  params[0] = num1606;
  partcv[0] = 1;
  Object sum1608 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1608 (depth = 10)
  gc_frame_newslot(sum1608);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1609 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1610 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1609);
// compiled call node returning call1610 (depth = 11)
// compiled member node returning call1610 (depth = 10)
  params[0] = sum1608;
  partcv[0] = 1;
  Object call1611 = callmethod(call1610, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1604);
// compiled call node returning call1611 (depth = 9)
  int op_slot_right_1603 = gc_frame_newslot(call1611);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1614 == NULL) {
    strlit1614 = alloc_String("  ");
    gc_root(strlit1614);
  }
// compiled string node returning strlit1614 (depth = 10)
  int op_slot_right_1613 = gc_frame_newslot(strlit1614);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_1616 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1619 == NULL) {
    strlit1619 = alloc_String("Finally:""\x0a""");
    gc_root(strlit1619);
  }
// compiled string node returning strlit1619 (depth = 12)
  int op_slot_right_1618 = gc_frame_newslot(strlit1619);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_1621 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit1623 == NULL) {
    strlit1623 = alloc_String("""\x0a""");
    gc_root(strlit1623);
  }
// compiled string node returning strlit1623 (depth = 13)
  int op_slot_left_1621 = gc_frame_newslot(strlit1623);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1624 = callmethod(strlit1623, "++", 1, partcv, params);
// compiled op node returning opresult1624 (depth = 12)
  int op_slot_left_1618 = gc_frame_newslot(opresult1624);
  params[0] = strlit1619;
  partcv[0] = 1;
  Object opresult1625 = callmethod(opresult1624, "++", 1, partcv, params);
// compiled op node returning opresult1625 (depth = 11)
  int op_slot_left_1616 = gc_frame_newslot(opresult1625);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1626 = callmethod(opresult1625, "++", 1, partcv, params);
// compiled op node returning opresult1626 (depth = 10)
  int op_slot_left_1613 = gc_frame_newslot(opresult1626);
  params[0] = strlit1614;
  partcv[0] = 1;
  Object opresult1627 = callmethod(opresult1626, "++", 1, partcv, params);
// compiled op node returning opresult1627 (depth = 9)
  int op_slot_left_1603 = gc_frame_newslot(opresult1627);
  params[0] = call1611;
  partcv[0] = 1;
  Object opresult1628 = callmethod(opresult1627, "++", 1, partcv, params);
// compiled op node returning opresult1628 (depth = 8)
  int op_slot_left_1600 = gc_frame_newslot(opresult1628);
  params[0] = strlit1601;
  partcv[0] = 1;
  Object opresult1629 = callmethod(opresult1628, "++", 1, partcv, params);
// compiled op node returning opresult1629 (depth = 7)
  int op_slot_right_1599 = gc_frame_newslot(opresult1629);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1599 = gc_frame_newslot(*var_s);
  params[0] = opresult1629;
  partcv[0] = 1;
  Object opresult1631 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1631 (depth = 6)
  *var_s = opresult1631;
  if (opresult1631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1592 = done;
  } else {
  }
// compiled if node returning if1592 (depth = 4)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1647 == NULL) {
    strlit1647 = alloc_String("    ");
    gc_root(strlit1647);
  }
// compiled string node returning strlit1647 (depth = 8)
  int op_slot_right_1646 = gc_frame_newslot(strlit1647);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1646 = gc_frame_newslot(*var_spc);
  params[0] = strlit1647;
  partcv[0] = 1;
  Object opresult1649 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1649 (depth = 7)
  *var_spc = opresult1649;
  if (opresult1649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1670(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1672 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1674 = alloc_Float64(2);
// compiled num node returning num1674 (depth = 10)
  int op_slot_right_1673 = gc_frame_newslot(num1674);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1673 = gc_frame_newslot(*var_depth);
  params[0] = num1674;
  partcv[0] = 1;
  Object sum1676 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1676 (depth = 9)
  gc_frame_newslot(sum1676);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_case (depth = 9)
  params[0] = sum1676;
  partcv[0] = 1;
  Object call1677 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1672);
// compiled call node returning call1677 (depth = 8)
  int op_slot_right_1671 = gc_frame_newslot(call1677);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1680 == NULL) {
    strlit1680 = alloc_String("case ");
    gc_root(strlit1680);
  }
// compiled string node returning strlit1680 (depth = 9)
  int op_slot_right_1679 = gc_frame_newslot(strlit1680);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1683 == NULL) {
    strlit1683 = alloc_String("    ");
    gc_root(strlit1683);
  }
// compiled string node returning strlit1683 (depth = 10)
  int op_slot_right_1682 = gc_frame_newslot(strlit1683);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_1685 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1688 == NULL) {
    strlit1688 = alloc_String("""\x0a""");
    gc_root(strlit1688);
  }
// compiled string node returning strlit1688 (depth = 12)
  int op_slot_right_1687 = gc_frame_newslot(strlit1688);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_1687 = gc_frame_newslot(*var_s);
  params[0] = strlit1688;
  partcv[0] = 1;
  Object opresult1690 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1690 (depth = 11)
  int op_slot_left_1685 = gc_frame_newslot(opresult1690);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1691 = callmethod(opresult1690, "++", 1, partcv, params);
// compiled op node returning opresult1691 (depth = 10)
  int op_slot_left_1682 = gc_frame_newslot(opresult1691);
  params[0] = strlit1683;
  partcv[0] = 1;
  Object opresult1692 = callmethod(opresult1691, "++", 1, partcv, params);
// compiled op node returning opresult1692 (depth = 9)
  int op_slot_left_1679 = gc_frame_newslot(opresult1692);
  params[0] = strlit1680;
  partcv[0] = 1;
  Object opresult1693 = callmethod(opresult1692, "++", 1, partcv, params);
// compiled op node returning opresult1693 (depth = 8)
  int op_slot_left_1671 = gc_frame_newslot(opresult1693);
  params[0] = call1677;
  partcv[0] = 1;
  Object opresult1694 = callmethod(opresult1693, "++", 1, partcv, params);
// compiled op node returning opresult1694 (depth = 7)
  *var_s = opresult1694;
  if (opresult1694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1633(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1634 == NULL) {
    strlit1634 = alloc_String("");
    gc_root(strlit1634);
  }
// compiled string node returning strlit1634 (depth = 5)
  *var_spc = strlit1634;
  if (strlit1634 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1635 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1638 = alloc_Float64(1);
// compiled num node returning num1638 (depth = 7)
  int op_slot_right_1637 = gc_frame_newslot(num1638);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1637 = gc_frame_newslot(*var_depth);
  params[0] = num1638;
  partcv[0] = 1;
  Object diff1640 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff1640 (depth = 6)
  int op_slot_right_1636 = gc_frame_newslot(diff1640);
// starting to compile num node (depth = 6)
  Object num1642 = alloc_Float64(0);
// compiled num node returning num1642 (depth = 6)
  int op_slot_left_1636 = gc_frame_newslot(num1642);
  params[0] = diff1640;
  partcv[0] = 1;
  Object opresult1643 = callmethod(num1642, "..", 1, partcv, params);
// compiled op node returning opresult1643 (depth = 5)
  gc_frame_newslot(opresult1643);
// starting to compile block node (depth = 5)
  Object block1644 = alloc_Block(NULL, NULL, "ast", 389);
  gc_frame_newslot(block1644);
// method _apply
  block_savedest(block1644);
  Object closure1645 = createclosure(2, "_apply");
  setclosureframe(closure1645, stackframe);
  addtoclosure(closure1645, var_spc);
  addtoclosure(closure1645, selfslot);
  struct UserObject *uo1645 = (struct UserObject*)block1644;
  uo1645->data[0] = (Object)closure1645;
  Method *meth_meth_ast__apply1645 = addmethod2pos(block1644, "_apply", &meth_ast__apply1645, 0);
  int argcv_meth_ast__apply1645[] = {1};
  meth_meth_ast__apply1645->type = alloc_MethodType(1, argcv_meth_ast__apply1645);
  meth_meth_ast__apply1645->definitionModule = modulename;
  meth_meth_ast__apply1645->definitionLine = 383;
// compiled block node returning block1644 (depth = 5)
  gc_frame_newslot(block1644);
// call case 5: prelude request
  params[0] = opresult1643;
  params[1] = block1644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1652 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1635);
// compiled call node returning call1652 (depth = 4)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1654 == NULL) {
    strlit1654 = alloc_String(" ");
    gc_root(strlit1654);
  }
// compiled string node returning strlit1654 (depth = 6)
  int op_slot_right_1653 = gc_frame_newslot(strlit1654);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1657 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num1658 = alloc_Float64(0);
// compiled num node returning num1658 (depth = 8)
  gc_frame_newslot(num1658);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1659 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1660 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1659);
// compiled call node returning call1660 (depth = 9)
// compiled member node returning call1660 (depth = 8)
  params[0] = num1658;
  partcv[0] = 1;
  Object call1661 = callmethod(call1660, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1657);
// compiled call node returning call1661 (depth = 7)
  int op_slot_right_1656 = gc_frame_newslot(call1661);
// starting to compile string node (depth = 7)
  if (strlit1663 == NULL) {
    strlit1663 = alloc_String("catch ");
    gc_root(strlit1663);
  }
// compiled string node returning strlit1663 (depth = 7)
  int op_slot_left_1656 = gc_frame_newslot(strlit1663);
  params[0] = call1661;
  partcv[0] = 1;
  Object opresult1664 = callmethod(strlit1663, "++", 1, partcv, params);
// compiled op node returning opresult1664 (depth = 6)
  int op_slot_left_1653 = gc_frame_newslot(opresult1664);
  params[0] = strlit1654;
  partcv[0] = 1;
  Object opresult1665 = callmethod(opresult1664, "++", 1, partcv, params);
// compiled op node returning opresult1665 (depth = 5)
  *var_s = opresult1665;
  if (opresult1665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1666 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1667 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1668 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1667);
// compiled call node returning call1668 (depth = 6)
// compiled member node returning call1668 (depth = 5)
  gc_frame_newslot(call1668);
// starting to compile block node (depth = 5)
  Object block1669 = alloc_Block(NULL, NULL, "ast", 393);
  gc_frame_newslot(block1669);
// method _apply
  block_savedest(block1669);
  Object closure1670 = createclosure(4, "_apply");
  setclosureframe(closure1670, stackframe);
  addtoclosure(closure1670, var_depth);
  addtoclosure(closure1670, var_spc);
  addtoclosure(closure1670, var_s);
  addtoclosure(closure1670, selfslot);
  struct UserObject *uo1670 = (struct UserObject*)block1669;
  uo1670->data[0] = (Object)closure1670;
  Method *meth_meth_ast__apply1670 = addmethod2pos(block1669, "_apply", &meth_ast__apply1670, 0);
  int argcv_meth_ast__apply1670[] = {1};
  meth_meth_ast__apply1670->type = alloc_MethodType(1, argcv_meth_ast__apply1670);
  meth_meth_ast__apply1670->definitionModule = modulename;
  meth_meth_ast__apply1670->definitionLine = 393;
// compiled block node returning block1669 (depth = 5)
  gc_frame_newslot(block1669);
// call case 5: prelude request
  params[0] = call1668;
  params[1] = block1669;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1697 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1666);
// compiled call node returning call1697 (depth = 4)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1700 = alloc_Boolean(0);
// compiled identifier node returning bool1700 (depth = 6)
  int op_slot_right_1699 = gc_frame_newslot(bool1700);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1703 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1702);
// compiled call node returning call1703 (depth = 7)
// compiled member node returning call1703 (depth = 6)
  int op_slot_left_1699 = gc_frame_newslot(call1703);
  params[0] = bool1700;
  partcv[0] = 1;
  Object opresult1704 = callmethod(call1703, "!=", 1, partcv, params);
// compiled op node returning opresult1704 (depth = 5)
  Object if1698 = done;
  if (istrue(opresult1704)) {
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1706 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1708 = alloc_Float64(2);
// compiled num node returning num1708 (depth = 9)
  int op_slot_right_1707 = gc_frame_newslot(num1708);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_1707 = gc_frame_newslot(*var_depth);
  params[0] = num1708;
  partcv[0] = 1;
  Object sum1710 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1710 (depth = 8)
  gc_frame_newslot(sum1710);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1711 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1712 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1711);
// compiled call node returning call1712 (depth = 9)
// compiled member node returning call1712 (depth = 8)
  params[0] = sum1710;
  partcv[0] = 1;
  Object call1713 = callmethod(call1712, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1706);
// compiled call node returning call1713 (depth = 7)
  int op_slot_right_1705 = gc_frame_newslot(call1713);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1716 == NULL) {
    strlit1716 = alloc_String("finally ");
    gc_root(strlit1716);
  }
// compiled string node returning strlit1716 (depth = 8)
  int op_slot_right_1715 = gc_frame_newslot(strlit1716);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1719 == NULL) {
    strlit1719 = alloc_String("    ");
    gc_root(strlit1719);
  }
// compiled string node returning strlit1719 (depth = 9)
  int op_slot_right_1718 = gc_frame_newslot(strlit1719);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_1721 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1724 == NULL) {
    strlit1724 = alloc_String("""\x0a""");
    gc_root(strlit1724);
  }
// compiled string node returning strlit1724 (depth = 11)
  int op_slot_right_1723 = gc_frame_newslot(strlit1724);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1723 = gc_frame_newslot(*var_s);
  params[0] = strlit1724;
  partcv[0] = 1;
  Object opresult1726 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1726 (depth = 10)
  int op_slot_left_1721 = gc_frame_newslot(opresult1726);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1727 = callmethod(opresult1726, "++", 1, partcv, params);
// compiled op node returning opresult1727 (depth = 9)
  int op_slot_left_1718 = gc_frame_newslot(opresult1727);
  params[0] = strlit1719;
  partcv[0] = 1;
  Object opresult1728 = callmethod(opresult1727, "++", 1, partcv, params);
// compiled op node returning opresult1728 (depth = 8)
  int op_slot_left_1715 = gc_frame_newslot(opresult1728);
  params[0] = strlit1716;
  partcv[0] = 1;
  Object opresult1729 = callmethod(opresult1728, "++", 1, partcv, params);
// compiled op node returning opresult1729 (depth = 7)
  int op_slot_left_1705 = gc_frame_newslot(opresult1729);
  params[0] = call1713;
  partcv[0] = 1;
  Object opresult1730 = callmethod(opresult1729, "++", 1, partcv, params);
// compiled op node returning opresult1730 (depth = 6)
  *var_s = opresult1730;
  if (opresult1730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1698 = done;
  } else {
  }
// compiled if node returning if1698 (depth = 4)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent1732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_catchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1733 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1734 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool1735 = alloc_Boolean(0);
// compiled identifier node returning bool1735 (depth = 6)
  gc_frame_newslot(bool1735);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchCaseNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool1735;
  partcv[0] = 3;
  Object call1736 = callmethod(*var_catchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1734);
// compiled call node returning call1736 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1737 = callmethod(call1736, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe1733);
// compiled call node returning call1737 (depth = 4)
  gc_frame_end(frame);
  return call1737;
}
Object meth_ast_new1448(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_catchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1449 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1449 = alloc_userobj2(13,11, objclass1449);
  gc_frame_newslot(obj1449);
if (objclass1449 == NULL) {
  glfree(obj1449->class->name);
  obj1449->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1449, self, 0);
  addmethodreal(obj1449,"outer", &reader_ast_outer_1450);
  Object oldself1449 = self;
  struct StackFrameObject *oldstackframe1449 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1449);
  gc_frame_newslot((Object)stackframe);
  self = obj1449;
  Object *oldselfslot1449 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1449 = (*(struct UserObject *)self).data[0], lowerouter1449 = thisouter1449;
  if (inheritingObject1449) {
    struct UserObject *inho1449 = (struct UserObject *)inheritingObject1449;
    while (inho1449->super != GraceDefaultObject) inho1449 = (struct UserObject *)inho1449->super;
    inho1449->super = obj1449;
    self = inheritingObject1449;
    *selfslot = self;
    lowerouter1449 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1449;
  }
if (objclass1449 == NULL) {
  Method *reader1451 = addmethodrealflags(obj1449, "kind",&reader_ast_kind_1451, MFLAG_DEF);
  reader1451->definitionModule = modulename;
  reader1451->definitionLine = 350;
}
adddatum2(obj1449, alloc_Undefined(), 1);
if (objclass1449 == NULL) {
  Method *reader1452 = addmethodrealflags(obj1449, "value",&reader_ast_value_1452, 0);
  Method *writer1452 = addmethodrealflags(obj1449, "value:=",&writer_ast_value_1452, 0);
  reader1452->definitionModule = modulename;
  writer1452->definitionModule = modulename;
  reader1452->definitionLine = 351;
  writer1452->definitionLine = 351;
}
obj1449->flags |= OFLAG_MUTABLE;
adddatum2(obj1449, alloc_Undefined(), 2);
if (objclass1449 == NULL) {
  Method *reader1453 = addmethodrealflags(obj1449, "cases",&reader_ast_cases_1453, 0);
  Method *writer1453 = addmethodrealflags(obj1449, "cases:=",&writer_ast_cases_1453, 0);
  reader1453->definitionModule = modulename;
  writer1453->definitionModule = modulename;
  reader1453->definitionLine = 352;
  writer1453->definitionLine = 352;
}
obj1449->flags |= OFLAG_MUTABLE;
adddatum2(obj1449, alloc_Undefined(), 3);
if (objclass1449 == NULL) {
  Method *reader1454 = addmethodrealflags(obj1449, "finally",&reader_ast_finally_1454, 0);
  Method *writer1454 = addmethodrealflags(obj1449, "finally:=",&writer_ast_finally_1454, 0);
  reader1454->definitionModule = modulename;
  writer1454->definitionModule = modulename;
  reader1454->definitionLine = 354;
  writer1454->definitionLine = 354;
}
obj1449->flags |= OFLAG_MUTABLE;
adddatum2(obj1449, alloc_Undefined(), 4);
// method accept()from
  struct UserObject *uo1455 = (struct UserObject*)obj1449;
  uo1455->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1455 = addmethod2pos(obj1449, "accept()from", &meth_ast_accept_40__41_from1455, 5);
  int argcv_meth_ast_accept_40__41_from1455[] = {1, 1};
  meth_meth_ast_accept_40__41_from1455->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1455);
  meth_meth_ast_accept_40__41_from1455->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1455->definitionLine = 354;
// method map()parent
  struct UserObject *uo1483 = (struct UserObject*)obj1449;
  uo1483->data[6] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent1483 = addmethod2pos(obj1449, "map()parent", &meth_ast_map_40__41_parent1483, 6);
  int argcv_meth_ast_map_40__41_parent1483[] = {1, 1};
  meth_meth_ast_map_40__41_parent1483->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent1483);
  meth_meth_ast_map_40__41_parent1483->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent1483->definitionLine = 365;
// method pretty
  struct UserObject *uo1512 = (struct UserObject*)obj1449;
  uo1512->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty1512 = addmethod2pos(obj1449, "pretty", &meth_ast_pretty1512, 7);
  int argcv_meth_ast_pretty1512[] = {1};
  meth_meth_ast_pretty1512->type = alloc_MethodType(1, argcv_meth_ast_pretty1512);
  meth_meth_ast_pretty1512->definitionModule = modulename;
  meth_meth_ast_pretty1512->definitionLine = 372;
// method toGrace
  struct UserObject *uo1633 = (struct UserObject*)obj1449;
  uo1633->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace1633 = addmethod2pos(obj1449, "toGrace", &meth_ast_toGrace1633, 8);
  int argcv_meth_ast_toGrace1633[] = {1};
  meth_meth_ast_toGrace1633->type = alloc_MethodType(1, argcv_meth_ast_toGrace1633);
meth_meth_ast_toGrace1633->type->types[0] = type_Number;
meth_meth_ast_toGrace1633->type->names[0] = "depth";
  meth_meth_ast_toGrace1633->definitionModule = modulename;
  meth_meth_ast_toGrace1633->definitionLine = 387;
// method shallowCopyWithParent
  block_savedest(obj1449);
  Object closure1732 = createclosure(3, "shallowCopyWithParent");
  setclosureframe(closure1732, stackframe);
  addtoclosure(closure1732, var_nullNode);
  addtoclosure(closure1732, var_emptySeq);
  addtoclosure(closure1732, var_catchCaseNode);
  struct UserObject *uo1732 = (struct UserObject*)obj1449;
  uo1732->data[9] = (Object)closure1732;
  Method *meth_meth_ast_shallowCopyWithParent1732 = addmethod2pos(obj1449, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent1732, 9);
  int argcv_meth_ast_shallowCopyWithParent1732[] = {1};
  meth_meth_ast_shallowCopyWithParent1732->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent1732);
  meth_meth_ast_shallowCopyWithParent1732->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent1732->definitionLine = 401;
  sourceObject = obj1449;
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1738 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1739 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1738);
// compiled call node returning call1739 (depth = 4)
  struct UserObject *obj1449_uo = (struct UserObject *)obj1449;
  obj1449_uo->super = call1739;
  sourceObject = obj1449;
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1740 == NULL) {
    strlit1740 = alloc_String("catchcase");
    gc_root(strlit1740);
  }
// compiled string node returning strlit1740 (depth = 4)
  adddatum2(obj1449, strlit1740, 1);
  sourceObject = obj1449;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  adddatum2(obj1449, *var_block, 2);
  sourceObject = obj1449;
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj1449, *var_cases_39_, 3);
  sourceObject = obj1449;
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally_39_ (depth = 4)
  adddatum2(obj1449, *var_finally_39_, 4);
  sourceObject = obj1449;
  sourceObject = obj1449;
  sourceObject = obj1449;
  sourceObject = obj1449;
  sourceObject = obj1449;
objclass1449 = obj1449->class;
  objclass1449->definitionModule = modulename;
  objclass1449->definitionLine = 347;
  (*(struct UserObject *)self).data[0] = lowerouter1449;
  self = oldself1449;
  selfslot = oldselfslot1449;
  stackframe = oldstackframe1449;
  gc_frame_end(frame);
  return obj1449;
}
Object meth_ast_new1448_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_catchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1449 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1449 = alloc_userobj2(13,11, objclass1449);
  gc_frame_newslot(obj1449);
if (objclass1449 == NULL) {
  glfree(obj1449->class->name);
  obj1449->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1449, self, 0);
  addmethodreal(obj1449,"outer", &reader_ast_outer_1450);
  Object oldself1449 = self;
  struct StackFrameObject *oldstackframe1449 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1449);
  gc_frame_newslot((Object)stackframe);
  self = obj1449;
  Object *oldselfslot1449 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1449 = (*(struct UserObject *)self).data[0], lowerouter1449 = thisouter1449;
  if (inheritingObject1449) {
    struct UserObject *inho1449 = (struct UserObject *)inheritingObject1449;
    while (inho1449->super != GraceDefaultObject) inho1449 = (struct UserObject *)inho1449->super;
    inho1449->super = obj1449;
    self = inheritingObject1449;
    *selfslot = self;
    lowerouter1449 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1449;
  }
if (objclass1449 == NULL) {
  Method *reader1451 = addmethodrealflags(obj1449, "kind",&reader_ast_kind_1451, MFLAG_DEF);
  reader1451->definitionModule = modulename;
  reader1451->definitionLine = 350;
}
adddatum2(obj1449, alloc_Undefined(), 1);
if (objclass1449 == NULL) {
  Method *reader1452 = addmethodrealflags(obj1449, "value",&reader_ast_value_1452, 0);
  Method *writer1452 = addmethodrealflags(obj1449, "value:=",&writer_ast_value_1452, 0);
  reader1452->definitionModule = modulename;
  writer1452->definitionModule = modulename;
  reader1452->definitionLine = 351;
  writer1452->definitionLine = 351;
}
obj1449->flags |= OFLAG_MUTABLE;
adddatum2(obj1449, alloc_Undefined(), 2);
if (objclass1449 == NULL) {
  Method *reader1453 = addmethodrealflags(obj1449, "cases",&reader_ast_cases_1453, 0);
  Method *writer1453 = addmethodrealflags(obj1449, "cases:=",&writer_ast_cases_1453, 0);
  reader1453->definitionModule = modulename;
  writer1453->definitionModule = modulename;
  reader1453->definitionLine = 352;
  writer1453->definitionLine = 352;
}
obj1449->flags |= OFLAG_MUTABLE;
adddatum2(obj1449, alloc_Undefined(), 3);
if (objclass1449 == NULL) {
  Method *reader1454 = addmethodrealflags(obj1449, "finally",&reader_ast_finally_1454, 0);
  Method *writer1454 = addmethodrealflags(obj1449, "finally:=",&writer_ast_finally_1454, 0);
  reader1454->definitionModule = modulename;
  writer1454->definitionModule = modulename;
  reader1454->definitionLine = 354;
  writer1454->definitionLine = 354;
}
obj1449->flags |= OFLAG_MUTABLE;
adddatum2(obj1449, alloc_Undefined(), 4);
// method accept()from
  struct UserObject *uo1455 = (struct UserObject*)obj1449;
  uo1455->data[5] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1455 = addmethod2pos(obj1449, "accept()from", &meth_ast_accept_40__41_from1455, 5);
  int argcv_meth_ast_accept_40__41_from1455[] = {1, 1};
  meth_meth_ast_accept_40__41_from1455->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1455);
  meth_meth_ast_accept_40__41_from1455->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1455->definitionLine = 354;
// method map()parent
  struct UserObject *uo1483 = (struct UserObject*)obj1449;
  uo1483->data[6] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent1483 = addmethod2pos(obj1449, "map()parent", &meth_ast_map_40__41_parent1483, 6);
  int argcv_meth_ast_map_40__41_parent1483[] = {1, 1};
  meth_meth_ast_map_40__41_parent1483->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent1483);
  meth_meth_ast_map_40__41_parent1483->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent1483->definitionLine = 365;
// method pretty
  struct UserObject *uo1512 = (struct UserObject*)obj1449;
  uo1512->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty1512 = addmethod2pos(obj1449, "pretty", &meth_ast_pretty1512, 7);
  int argcv_meth_ast_pretty1512[] = {1};
  meth_meth_ast_pretty1512->type = alloc_MethodType(1, argcv_meth_ast_pretty1512);
  meth_meth_ast_pretty1512->definitionModule = modulename;
  meth_meth_ast_pretty1512->definitionLine = 372;
// method toGrace
  struct UserObject *uo1633 = (struct UserObject*)obj1449;
  uo1633->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace1633 = addmethod2pos(obj1449, "toGrace", &meth_ast_toGrace1633, 8);
  int argcv_meth_ast_toGrace1633[] = {1};
  meth_meth_ast_toGrace1633->type = alloc_MethodType(1, argcv_meth_ast_toGrace1633);
meth_meth_ast_toGrace1633->type->types[0] = type_Number;
meth_meth_ast_toGrace1633->type->names[0] = "depth";
  meth_meth_ast_toGrace1633->definitionModule = modulename;
  meth_meth_ast_toGrace1633->definitionLine = 387;
// method shallowCopyWithParent
  block_savedest(obj1449);
  Object closure1732 = createclosure(3, "shallowCopyWithParent");
  setclosureframe(closure1732, stackframe);
  addtoclosure(closure1732, var_nullNode);
  addtoclosure(closure1732, var_emptySeq);
  addtoclosure(closure1732, var_catchCaseNode);
  struct UserObject *uo1732 = (struct UserObject*)obj1449;
  uo1732->data[9] = (Object)closure1732;
  Method *meth_meth_ast_shallowCopyWithParent1732 = addmethod2pos(obj1449, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent1732, 9);
  int argcv_meth_ast_shallowCopyWithParent1732[] = {1};
  meth_meth_ast_shallowCopyWithParent1732->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent1732);
  meth_meth_ast_shallowCopyWithParent1732->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent1732->definitionLine = 401;
  sourceObject = obj1449;
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1738 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1739 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1738);
// compiled call node returning call1739 (depth = 4)
  struct UserObject *obj1449_uo = (struct UserObject *)obj1449;
  obj1449_uo->super = call1739;
  sourceObject = obj1449;
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1740 == NULL) {
    strlit1740 = alloc_String("catchcase");
    gc_root(strlit1740);
  }
// compiled string node returning strlit1740 (depth = 4)
  adddatum2(obj1449, strlit1740, 1);
  sourceObject = obj1449;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  adddatum2(obj1449, *var_block, 2);
  sourceObject = obj1449;
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj1449, *var_cases_39_, 3);
  sourceObject = obj1449;
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally_39_ (depth = 4)
  adddatum2(obj1449, *var_finally_39_, 4);
  sourceObject = obj1449;
  sourceObject = obj1449;
  sourceObject = obj1449;
  sourceObject = obj1449;
  sourceObject = obj1449;
objclass1449 = obj1449->class;
  objclass1449->definitionModule = modulename;
  objclass1449->definitionLine = 347;
  (*(struct UserObject *)self).data[0] = lowerouter1449;
  self = oldself1449;
  selfslot = oldselfslot1449;
  stackframe = oldstackframe1449;
  gc_frame_end(frame);
  return obj1449;
}
Object meth_ast_matchCaseNode1742(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for matchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_matchCaseNode (depth = 3)
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast_matchee1752(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "matchee");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchee (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for matchee");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1753 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1754 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1753);
// compiled call node returning call1754 (depth = 5)
// compiled member node returning call1754 (depth = 4)
  gc_frame_end(frame);
  return call1754;
}
Object meth_ast__apply1767(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1768 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1769 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1768);
// compiled call node returning call1769 (depth = 7)
  gc_frame_end(frame);
  return call1769;
}
Object meth_ast_accept_40__41_from1755(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1757 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1758 = callmethod(*var_visitor, "visitMatchCase()up",
    2, partcv, params);
  gc_frame_end(callframe1757);
// compiled call node returning call1758 (depth = 5)
  Object if1756 = done;
  if (istrue(call1758)) {
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1759 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1761 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1760);
// compiled call node returning call1761 (depth = 7)
// compiled member node returning call1761 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1762 = callmethod(call1761, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1759);
// compiled call node returning call1762 (depth = 5)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1763 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1764 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1765 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1764);
// compiled call node returning call1765 (depth = 7)
// compiled member node returning call1765 (depth = 6)
  gc_frame_newslot(call1765);
// starting to compile block node (depth = 6)
  Object block1766 = alloc_Block(NULL, NULL, "ast", 415);
  gc_frame_newslot(block1766);
// method _apply
  block_savedest(block1766);
  Object closure1767 = createclosure(2, "_apply");
  setclosureframe(closure1767, stackframe);
  addtoclosure(closure1767, var_visitor);
  addtoclosure(closure1767, selfslot);
  struct UserObject *uo1767 = (struct UserObject*)block1766;
  uo1767->data[0] = (Object)closure1767;
  Method *meth_meth_ast__apply1767 = addmethod2pos(block1766, "_apply", &meth_ast__apply1767, 0);
  int argcv_meth_ast__apply1767[] = {1};
  meth_meth_ast__apply1767->type = alloc_MethodType(1, argcv_meth_ast__apply1767);
  meth_meth_ast__apply1767->definitionModule = modulename;
  meth_meth_ast__apply1767->definitionLine = 415;
// compiled block node returning block1766 (depth = 6)
  gc_frame_newslot(block1766);
// call case 5: prelude request
  params[0] = call1765;
  params[1] = block1766;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1771 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1763);
// compiled call node returning call1771 (depth = 5)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1774 = alloc_Boolean(0);
// compiled identifier node returning bool1774 (depth = 7)
  int op_slot_right_1773 = gc_frame_newslot(bool1774);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1777 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1776);
// compiled call node returning call1777 (depth = 8)
// compiled member node returning call1777 (depth = 7)
  int op_slot_left_1773 = gc_frame_newslot(call1777);
  params[0] = bool1774;
  partcv[0] = 1;
  Object opresult1778 = callmethod(call1777, "!=", 1, partcv, params);
// compiled op node returning opresult1778 (depth = 6)
  Object if1772 = done;
  if (istrue(opresult1778)) {
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1779 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1780 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1781 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1780);
// compiled call node returning call1781 (depth = 8)
// compiled member node returning call1781 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1782 = callmethod(call1781, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe1779);
// compiled call node returning call1782 (depth = 6)
    gc_frame_newslot(call1782);
    if1772 = call1782;
  } else {
  }
// compiled if node returning if1772 (depth = 5)
    gc_frame_newslot(if1772);
    if1756 = if1772;
  } else {
  }
// compiled if node returning if1756 (depth = 4)
  gc_frame_end(frame);
  return if1756;
}
Object meth_ast_map_40__41_parent1783(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1784 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call1785 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1784);
// compiled call node returning call1785 (depth = 5)
  *var_n = call1785;
  if (call1785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1786 = gc_frame_new();
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1787 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1788 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1789 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1788);
// compiled call node returning call1789 (depth = 8)
// compiled member node returning call1789 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1790 = callmethod(call1789, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe1787);
// compiled call node returning call1790 (depth = 6)
  gc_frame_newslot(call1790);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1790;
  partcv[0] = 1;
  Object call1791 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe1786);
// compiled call node returning call1791 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1792 = gc_frame_new();
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1793 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1795 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1794);
// compiled call node returning call1795 (depth = 8)
// compiled member node returning call1795 (depth = 7)
  gc_frame_newslot(call1795);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1796 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1797 = gc_frame_new();
// call case 3: self.outer request
  Object call1798 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1797);
// compiled call node returning call1798 (depth = 10)
// compiled member node returning call1798 (depth = 9)
  partcv[0] = 0;
  Object call1799 = callmethodflags(call1798, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1796);
// compiled call node returning call1799 (depth = 8)
// compiled member node returning call1799 (depth = 7)
  params[0] = call1795;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1800 = callmethodflags(call1799, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1793);
// compiled call node returning call1800 (depth = 6)
  gc_frame_newslot(call1800);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1800;
  partcv[0] = 1;
  Object call1801 = callmethod(*var_n, "cases:=",
    1, partcv, params);
  gc_frame_end(callframe1792);
// compiled call node returning call1801 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1802 = gc_frame_new();
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1803 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1805 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1804);
// compiled call node returning call1805 (depth = 8)
// compiled member node returning call1805 (depth = 7)
  gc_frame_newslot(call1805);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1806 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1807 = gc_frame_new();
// call case 3: self.outer request
  Object call1808 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1807);
// compiled call node returning call1808 (depth = 10)
// compiled member node returning call1808 (depth = 9)
  partcv[0] = 0;
  Object call1809 = callmethodflags(call1808, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1806);
// compiled call node returning call1809 (depth = 8)
// compiled member node returning call1809 (depth = 7)
  params[0] = call1805;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1810 = callmethodflags(call1809, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1803);
// compiled call node returning call1810 (depth = 6)
  gc_frame_newslot(call1810);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call1810;
  partcv[0] = 1;
  Object call1811 = callmethod(*var_n, "elsecase:=",
    1, partcv, params);
  gc_frame_end(callframe1802);
// compiled call node returning call1811 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1812 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1813 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe1812);
// compiled call node returning call1813 (depth = 5)
  *var_n = call1813;
  if (call1813 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1823(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1825 == NULL) {
    strlit1825 = alloc_String("  ");
    gc_root(strlit1825);
  }
// compiled string node returning strlit1825 (depth = 8)
  int op_slot_right_1824 = gc_frame_newslot(strlit1825);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1824 = gc_frame_newslot(*var_spc);
  params[0] = strlit1825;
  partcv[0] = 1;
  Object opresult1827 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1827 (depth = 7)
  *var_spc = opresult1827;
  if (opresult1827 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1856(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1859 == NULL) {
    strlit1859 = alloc_String("");
    gc_root(strlit1859);
  }
// compiled string node returning strlit1859 (depth = 9)
  int op_slot_right_1858 = gc_frame_newslot(strlit1859);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1862 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1864 = alloc_Float64(2);
// compiled num node returning num1864 (depth = 12)
  int op_slot_right_1863 = gc_frame_newslot(num1864);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_1863 = gc_frame_newslot(*var_depth);
  params[0] = num1864;
  partcv[0] = 1;
  Object sum1866 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1866 (depth = 11)
  gc_frame_newslot(sum1866);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mx (depth = 11)
  params[0] = sum1866;
  partcv[0] = 1;
  Object call1867 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1862);
// compiled call node returning call1867 (depth = 10)
  int op_slot_right_1861 = gc_frame_newslot(call1867);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1870 == NULL) {
    strlit1870 = alloc_String("  ");
    gc_root(strlit1870);
  }
// compiled string node returning strlit1870 (depth = 11)
  int op_slot_right_1869 = gc_frame_newslot(strlit1870);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_1872 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1875 == NULL) {
    strlit1875 = alloc_String("Case:""\x0a""");
    gc_root(strlit1875);
  }
// compiled string node returning strlit1875 (depth = 13)
  int op_slot_right_1874 = gc_frame_newslot(strlit1875);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_spc (depth = 14)
  int op_slot_right_1877 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 14)
  if (strlit1879 == NULL) {
    strlit1879 = alloc_String("""\x0a""");
    gc_root(strlit1879);
  }
// compiled string node returning strlit1879 (depth = 14)
  int op_slot_left_1877 = gc_frame_newslot(strlit1879);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1880 = callmethod(strlit1879, "++", 1, partcv, params);
// compiled op node returning opresult1880 (depth = 13)
  int op_slot_left_1874 = gc_frame_newslot(opresult1880);
  params[0] = strlit1875;
  partcv[0] = 1;
  Object opresult1881 = callmethod(opresult1880, "++", 1, partcv, params);
// compiled op node returning opresult1881 (depth = 12)
  int op_slot_left_1872 = gc_frame_newslot(opresult1881);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1882 = callmethod(opresult1881, "++", 1, partcv, params);
// compiled op node returning opresult1882 (depth = 11)
  int op_slot_left_1869 = gc_frame_newslot(opresult1882);
  params[0] = strlit1870;
  partcv[0] = 1;
  Object opresult1883 = callmethod(opresult1882, "++", 1, partcv, params);
// compiled op node returning opresult1883 (depth = 10)
  int op_slot_left_1861 = gc_frame_newslot(opresult1883);
  params[0] = call1867;
  partcv[0] = 1;
  Object opresult1884 = callmethod(opresult1883, "++", 1, partcv, params);
// compiled op node returning opresult1884 (depth = 9)
  int op_slot_left_1858 = gc_frame_newslot(opresult1884);
  params[0] = strlit1859;
  partcv[0] = 1;
  Object opresult1885 = callmethod(opresult1884, "++", 1, partcv, params);
// compiled op node returning opresult1885 (depth = 8)
  int op_slot_right_1857 = gc_frame_newslot(opresult1885);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_1857 = gc_frame_newslot(*var_s);
  params[0] = opresult1885;
  partcv[0] = 1;
  Object opresult1887 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1887 (depth = 7)
  *var_s = opresult1887;
  if (opresult1887 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1815(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1816 == NULL) {
    strlit1816 = alloc_String("");
    gc_root(strlit1816);
  }
// compiled string node returning strlit1816 (depth = 5)
  *var_spc = strlit1816;
  if (strlit1816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1817 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_1818 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num1820 = alloc_Float64(0);
// compiled num node returning num1820 (depth = 6)
  int op_slot_left_1818 = gc_frame_newslot(num1820);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1821 = callmethod(num1820, "..", 1, partcv, params);
// compiled op node returning opresult1821 (depth = 5)
  gc_frame_newslot(opresult1821);
// starting to compile block node (depth = 5)
  Object block1822 = alloc_Block(NULL, NULL, "ast", 433);
  gc_frame_newslot(block1822);
// method _apply
  block_savedest(block1822);
  Object closure1823 = createclosure(2, "_apply");
  setclosureframe(closure1823, stackframe);
  addtoclosure(closure1823, var_spc);
  addtoclosure(closure1823, selfslot);
  struct UserObject *uo1823 = (struct UserObject*)block1822;
  uo1823->data[0] = (Object)closure1823;
  Method *meth_meth_ast__apply1823 = addmethod2pos(block1822, "_apply", &meth_ast__apply1823, 0);
  int argcv_meth_ast__apply1823[] = {1};
  meth_meth_ast__apply1823->type = alloc_MethodType(1, argcv_meth_ast__apply1823);
  meth_meth_ast__apply1823->definitionModule = modulename;
  meth_meth_ast__apply1823->definitionLine = 427;
// compiled block node returning block1822 (depth = 5)
  gc_frame_newslot(block1822);
// call case 5: prelude request
  params[0] = opresult1821;
  params[1] = block1822;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1830 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1817);
// compiled call node returning call1830 (depth = 4)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1832 == NULL) {
    strlit1832 = alloc_String("""\x0a""");
    gc_root(strlit1832);
  }
// compiled string node returning strlit1832 (depth = 6)
  int op_slot_right_1831 = gc_frame_newslot(strlit1832);
// starting to compile call node (depth = 6)
  int callframe1834 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call1835 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe1834);
// compiled call node returning call1835 (depth = 6)
  int op_slot_left_1831 = gc_frame_newslot(call1835);
  params[0] = strlit1832;
  partcv[0] = 1;
  Object opresult1836 = callmethod(call1835, "++", 1, partcv, params);
// compiled op node returning opresult1836 (depth = 5)
  *var_s = opresult1836;
  if (opresult1836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1838 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1840 = alloc_Float64(2);
// compiled num node returning num1840 (depth = 8)
  int op_slot_right_1839 = gc_frame_newslot(num1840);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_1839 = gc_frame_newslot(*var_depth);
  params[0] = num1840;
  partcv[0] = 1;
  Object sum1842 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1842 (depth = 7)
  gc_frame_newslot(sum1842);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1843 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1844 = callmethodflags(self, "matchee", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1844 (depth = 8)
// compiled member node returning call1844 (depth = 7)
  params[0] = sum1842;
  partcv[0] = 1;
  Object call1845 = callmethod(call1844, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1838);
// compiled call node returning call1845 (depth = 6)
  int op_slot_right_1837 = gc_frame_newslot(call1845);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_1847 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1847 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1849 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 6)
  int op_slot_left_1837 = gc_frame_newslot(opresult1849);
  params[0] = call1845;
  partcv[0] = 1;
  Object opresult1850 = callmethod(opresult1849, "++", 1, partcv, params);
// compiled op node returning opresult1850 (depth = 5)
  *var_s = opresult1850;
  if (opresult1850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1852 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1854 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1853);
// compiled call node returning call1854 (depth = 6)
// compiled member node returning call1854 (depth = 5)
  gc_frame_newslot(call1854);
// starting to compile block node (depth = 5)
  Object block1855 = alloc_Block(NULL, NULL, "ast", 438);
  gc_frame_newslot(block1855);
// method _apply
  block_savedest(block1855);
  Object closure1856 = createclosure(4, "_apply");
  setclosureframe(closure1856, stackframe);
  addtoclosure(closure1856, var_depth);
  addtoclosure(closure1856, var_spc);
  addtoclosure(closure1856, var_s);
  addtoclosure(closure1856, selfslot);
  struct UserObject *uo1856 = (struct UserObject*)block1855;
  uo1856->data[0] = (Object)closure1856;
  Method *meth_meth_ast__apply1856 = addmethod2pos(block1855, "_apply", &meth_ast__apply1856, 0);
  int argcv_meth_ast__apply1856[] = {1};
  meth_meth_ast__apply1856->type = alloc_MethodType(1, argcv_meth_ast__apply1856);
  meth_meth_ast__apply1856->definitionModule = modulename;
  meth_meth_ast__apply1856->definitionLine = 438;
// compiled block node returning block1855 (depth = 5)
  gc_frame_newslot(block1855);
// call case 5: prelude request
  params[0] = call1854;
  params[1] = block1855;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1890 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1852);
// compiled call node returning call1890 (depth = 4)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1893 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1894 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1893);
// compiled call node returning call1894 (depth = 7)
// compiled member node returning call1894 (depth = 6)
  int op_slot_right_1892 = gc_frame_newslot(call1894);
// starting to compile identifier node (depth = 6)
  Object bool1896 = alloc_Boolean(0);
// compiled identifier node returning bool1896 (depth = 6)
  int op_slot_left_1892 = gc_frame_newslot(bool1896);
  params[0] = call1894;
  partcv[0] = 1;
  Object opresult1897 = callmethod(bool1896, "!=", 1, partcv, params);
// compiled op node returning opresult1897 (depth = 5)
  Object if1891 = done;
  if (istrue(opresult1897)) {
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1900 == NULL) {
    strlit1900 = alloc_String("");
    gc_root(strlit1900);
  }
// compiled string node returning strlit1900 (depth = 8)
  int op_slot_right_1899 = gc_frame_newslot(strlit1900);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1903 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num1905 = alloc_Float64(2);
// compiled num node returning num1905 (depth = 11)
  int op_slot_right_1904 = gc_frame_newslot(num1905);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_1904 = gc_frame_newslot(*var_depth);
  params[0] = num1905;
  partcv[0] = 1;
  Object sum1907 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1907 (depth = 10)
  gc_frame_newslot(sum1907);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1908 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1909 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1908);
// compiled call node returning call1909 (depth = 11)
// compiled member node returning call1909 (depth = 10)
  params[0] = sum1907;
  partcv[0] = 1;
  Object call1910 = callmethod(call1909, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1903);
// compiled call node returning call1910 (depth = 9)
  int op_slot_right_1902 = gc_frame_newslot(call1910);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1913 == NULL) {
    strlit1913 = alloc_String("  ");
    gc_root(strlit1913);
  }
// compiled string node returning strlit1913 (depth = 10)
  int op_slot_right_1912 = gc_frame_newslot(strlit1913);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_1915 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1918 == NULL) {
    strlit1918 = alloc_String("Else:""\x0a""");
    gc_root(strlit1918);
  }
// compiled string node returning strlit1918 (depth = 12)
  int op_slot_right_1917 = gc_frame_newslot(strlit1918);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_1920 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit1922 == NULL) {
    strlit1922 = alloc_String("""\x0a""");
    gc_root(strlit1922);
  }
// compiled string node returning strlit1922 (depth = 13)
  int op_slot_left_1920 = gc_frame_newslot(strlit1922);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1923 = callmethod(strlit1922, "++", 1, partcv, params);
// compiled op node returning opresult1923 (depth = 12)
  int op_slot_left_1917 = gc_frame_newslot(opresult1923);
  params[0] = strlit1918;
  partcv[0] = 1;
  Object opresult1924 = callmethod(opresult1923, "++", 1, partcv, params);
// compiled op node returning opresult1924 (depth = 11)
  int op_slot_left_1915 = gc_frame_newslot(opresult1924);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1925 = callmethod(opresult1924, "++", 1, partcv, params);
// compiled op node returning opresult1925 (depth = 10)
  int op_slot_left_1912 = gc_frame_newslot(opresult1925);
  params[0] = strlit1913;
  partcv[0] = 1;
  Object opresult1926 = callmethod(opresult1925, "++", 1, partcv, params);
// compiled op node returning opresult1926 (depth = 9)
  int op_slot_left_1902 = gc_frame_newslot(opresult1926);
  params[0] = call1910;
  partcv[0] = 1;
  Object opresult1927 = callmethod(opresult1926, "++", 1, partcv, params);
// compiled op node returning opresult1927 (depth = 8)
  int op_slot_left_1899 = gc_frame_newslot(opresult1927);
  params[0] = strlit1900;
  partcv[0] = 1;
  Object opresult1928 = callmethod(opresult1927, "++", 1, partcv, params);
// compiled op node returning opresult1928 (depth = 7)
  int op_slot_right_1898 = gc_frame_newslot(opresult1928);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1898 = gc_frame_newslot(*var_s);
  params[0] = opresult1928;
  partcv[0] = 1;
  Object opresult1930 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1930 (depth = 6)
  *var_s = opresult1930;
  if (opresult1930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1891 = done;
  } else {
  }
// compiled if node returning if1891 (depth = 4)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1944(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit1946 == NULL) {
    strlit1946 = alloc_String("    ");
    gc_root(strlit1946);
  }
// compiled string node returning strlit1946 (depth = 8)
  int op_slot_right_1945 = gc_frame_newslot(strlit1946);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_1945 = gc_frame_newslot(*var_spc);
  params[0] = strlit1946;
  partcv[0] = 1;
  Object opresult1948 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult1948 (depth = 7)
  *var_spc = opresult1948;
  if (opresult1948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1969(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1971 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1973 = alloc_Float64(2);
// compiled num node returning num1973 (depth = 10)
  int op_slot_right_1972 = gc_frame_newslot(num1973);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_1972 = gc_frame_newslot(*var_depth);
  params[0] = num1973;
  partcv[0] = 1;
  Object sum1975 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum1975 (depth = 9)
  gc_frame_newslot(sum1975);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_case (depth = 9)
  params[0] = sum1975;
  partcv[0] = 1;
  Object call1976 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1971);
// compiled call node returning call1976 (depth = 8)
  int op_slot_right_1970 = gc_frame_newslot(call1976);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1979 == NULL) {
    strlit1979 = alloc_String("case ");
    gc_root(strlit1979);
  }
// compiled string node returning strlit1979 (depth = 9)
  int op_slot_right_1978 = gc_frame_newslot(strlit1979);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1982 == NULL) {
    strlit1982 = alloc_String("    ");
    gc_root(strlit1982);
  }
// compiled string node returning strlit1982 (depth = 10)
  int op_slot_right_1981 = gc_frame_newslot(strlit1982);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_1984 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1987 == NULL) {
    strlit1987 = alloc_String("""\x0a""");
    gc_root(strlit1987);
  }
// compiled string node returning strlit1987 (depth = 12)
  int op_slot_right_1986 = gc_frame_newslot(strlit1987);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_1986 = gc_frame_newslot(*var_s);
  params[0] = strlit1987;
  partcv[0] = 1;
  Object opresult1989 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1989 (depth = 11)
  int op_slot_left_1984 = gc_frame_newslot(opresult1989);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1990 = callmethod(opresult1989, "++", 1, partcv, params);
// compiled op node returning opresult1990 (depth = 10)
  int op_slot_left_1981 = gc_frame_newslot(opresult1990);
  params[0] = strlit1982;
  partcv[0] = 1;
  Object opresult1991 = callmethod(opresult1990, "++", 1, partcv, params);
// compiled op node returning opresult1991 (depth = 9)
  int op_slot_left_1978 = gc_frame_newslot(opresult1991);
  params[0] = strlit1979;
  partcv[0] = 1;
  Object opresult1992 = callmethod(opresult1991, "++", 1, partcv, params);
// compiled op node returning opresult1992 (depth = 8)
  int op_slot_left_1970 = gc_frame_newslot(opresult1992);
  params[0] = call1976;
  partcv[0] = 1;
  Object opresult1993 = callmethod(opresult1992, "++", 1, partcv, params);
// compiled op node returning opresult1993 (depth = 7)
  *var_s = opresult1993;
  if (opresult1993 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit1933 == NULL) {
    strlit1933 = alloc_String("");
    gc_root(strlit1933);
  }
// compiled string node returning strlit1933 (depth = 5)
  *var_spc = strlit1933;
  if (strlit1933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1934 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1937 = alloc_Float64(1);
// compiled num node returning num1937 (depth = 7)
  int op_slot_right_1936 = gc_frame_newslot(num1937);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_1936 = gc_frame_newslot(*var_depth);
  params[0] = num1937;
  partcv[0] = 1;
  Object diff1939 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff1939 (depth = 6)
  int op_slot_right_1935 = gc_frame_newslot(diff1939);
// starting to compile num node (depth = 6)
  Object num1941 = alloc_Float64(0);
// compiled num node returning num1941 (depth = 6)
  int op_slot_left_1935 = gc_frame_newslot(num1941);
  params[0] = diff1939;
  partcv[0] = 1;
  Object opresult1942 = callmethod(num1941, "..", 1, partcv, params);
// compiled op node returning opresult1942 (depth = 5)
  gc_frame_newslot(opresult1942);
// starting to compile block node (depth = 5)
  Object block1943 = alloc_Block(NULL, NULL, "ast", 448);
  gc_frame_newslot(block1943);
// method _apply
  block_savedest(block1943);
  Object closure1944 = createclosure(2, "_apply");
  setclosureframe(closure1944, stackframe);
  addtoclosure(closure1944, var_spc);
  addtoclosure(closure1944, selfslot);
  struct UserObject *uo1944 = (struct UserObject*)block1943;
  uo1944->data[0] = (Object)closure1944;
  Method *meth_meth_ast__apply1944 = addmethod2pos(block1943, "_apply", &meth_ast__apply1944, 0);
  int argcv_meth_ast__apply1944[] = {1};
  meth_meth_ast__apply1944->type = alloc_MethodType(1, argcv_meth_ast__apply1944);
  meth_meth_ast__apply1944->definitionModule = modulename;
  meth_meth_ast__apply1944->definitionLine = 442;
// compiled block node returning block1943 (depth = 5)
  gc_frame_newslot(block1943);
// call case 5: prelude request
  params[0] = opresult1942;
  params[1] = block1943;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1951 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled call node returning call1951 (depth = 4)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1953 == NULL) {
    strlit1953 = alloc_String(")");
    gc_root(strlit1953);
  }
// compiled string node returning strlit1953 (depth = 6)
  int op_slot_right_1952 = gc_frame_newslot(strlit1953);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1956 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num1957 = alloc_Float64(0);
// compiled num node returning num1957 (depth = 8)
  gc_frame_newslot(num1957);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1958 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1959 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1958);
// compiled call node returning call1959 (depth = 9)
// compiled member node returning call1959 (depth = 8)
  params[0] = num1957;
  partcv[0] = 1;
  Object call1960 = callmethod(call1959, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1956);
// compiled call node returning call1960 (depth = 7)
  int op_slot_right_1955 = gc_frame_newslot(call1960);
// starting to compile string node (depth = 7)
  if (strlit1962 == NULL) {
    strlit1962 = alloc_String("match(");
    gc_root(strlit1962);
  }
// compiled string node returning strlit1962 (depth = 7)
  int op_slot_left_1955 = gc_frame_newslot(strlit1962);
  params[0] = call1960;
  partcv[0] = 1;
  Object opresult1963 = callmethod(strlit1962, "++", 1, partcv, params);
// compiled op node returning opresult1963 (depth = 6)
  int op_slot_left_1952 = gc_frame_newslot(opresult1963);
  params[0] = strlit1953;
  partcv[0] = 1;
  Object opresult1964 = callmethod(opresult1963, "++", 1, partcv, params);
// compiled op node returning opresult1964 (depth = 5)
  *var_s = opresult1964;
  if (opresult1964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1965 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1966 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1967 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1966);
// compiled call node returning call1967 (depth = 6)
// compiled member node returning call1967 (depth = 5)
  gc_frame_newslot(call1967);
// starting to compile block node (depth = 5)
  Object block1968 = alloc_Block(NULL, NULL, "ast", 452);
  gc_frame_newslot(block1968);
// method _apply
  block_savedest(block1968);
  Object closure1969 = createclosure(4, "_apply");
  setclosureframe(closure1969, stackframe);
  addtoclosure(closure1969, var_depth);
  addtoclosure(closure1969, var_spc);
  addtoclosure(closure1969, var_s);
  addtoclosure(closure1969, selfslot);
  struct UserObject *uo1969 = (struct UserObject*)block1968;
  uo1969->data[0] = (Object)closure1969;
  Method *meth_meth_ast__apply1969 = addmethod2pos(block1968, "_apply", &meth_ast__apply1969, 0);
  int argcv_meth_ast__apply1969[] = {1};
  meth_meth_ast__apply1969->type = alloc_MethodType(1, argcv_meth_ast__apply1969);
  meth_meth_ast__apply1969->definitionModule = modulename;
  meth_meth_ast__apply1969->definitionLine = 452;
// compiled block node returning block1968 (depth = 5)
  gc_frame_newslot(block1968);
// call case 5: prelude request
  params[0] = call1967;
  params[1] = block1968;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1996 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1965);
// compiled call node returning call1996 (depth = 4)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1999 = alloc_Boolean(0);
// compiled identifier node returning bool1999 (depth = 6)
  int op_slot_right_1998 = gc_frame_newslot(bool1999);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2001 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2002 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2001);
// compiled call node returning call2002 (depth = 7)
// compiled member node returning call2002 (depth = 6)
  int op_slot_left_1998 = gc_frame_newslot(call2002);
  params[0] = bool1999;
  partcv[0] = 1;
  Object opresult2003 = callmethod(call2002, "!=", 1, partcv, params);
// compiled op node returning opresult2003 (depth = 5)
  Object if1997 = done;
  if (istrue(opresult2003)) {
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2005 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2007 = alloc_Float64(2);
// compiled num node returning num2007 (depth = 9)
  int op_slot_right_2006 = gc_frame_newslot(num2007);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2006 = gc_frame_newslot(*var_depth);
  params[0] = num2007;
  partcv[0] = 1;
  Object sum2009 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2009 (depth = 8)
  gc_frame_newslot(sum2009);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2011 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2010);
// compiled call node returning call2011 (depth = 9)
// compiled member node returning call2011 (depth = 8)
  params[0] = sum2009;
  partcv[0] = 1;
  Object call2012 = callmethod(call2011, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2005);
// compiled call node returning call2012 (depth = 7)
  int op_slot_right_2004 = gc_frame_newslot(call2012);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2015 == NULL) {
    strlit2015 = alloc_String("else ");
    gc_root(strlit2015);
  }
// compiled string node returning strlit2015 (depth = 8)
  int op_slot_right_2014 = gc_frame_newslot(strlit2015);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2018 == NULL) {
    strlit2018 = alloc_String("    ");
    gc_root(strlit2018);
  }
// compiled string node returning strlit2018 (depth = 9)
  int op_slot_right_2017 = gc_frame_newslot(strlit2018);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2020 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2023 == NULL) {
    strlit2023 = alloc_String("""\x0a""");
    gc_root(strlit2023);
  }
// compiled string node returning strlit2023 (depth = 11)
  int op_slot_right_2022 = gc_frame_newslot(strlit2023);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2022 = gc_frame_newslot(*var_s);
  params[0] = strlit2023;
  partcv[0] = 1;
  Object opresult2025 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2025 (depth = 10)
  int op_slot_left_2020 = gc_frame_newslot(opresult2025);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2026 = callmethod(opresult2025, "++", 1, partcv, params);
// compiled op node returning opresult2026 (depth = 9)
  int op_slot_left_2017 = gc_frame_newslot(opresult2026);
  params[0] = strlit2018;
  partcv[0] = 1;
  Object opresult2027 = callmethod(opresult2026, "++", 1, partcv, params);
// compiled op node returning opresult2027 (depth = 8)
  int op_slot_left_2014 = gc_frame_newslot(opresult2027);
  params[0] = strlit2015;
  partcv[0] = 1;
  Object opresult2028 = callmethod(opresult2027, "++", 1, partcv, params);
// compiled op node returning opresult2028 (depth = 7)
  int op_slot_left_2004 = gc_frame_newslot(opresult2028);
  params[0] = call2012;
  partcv[0] = 1;
  Object opresult2029 = callmethod(opresult2028, "++", 1, partcv, params);
// compiled op node returning opresult2029 (depth = 6)
  *var_s = opresult2029;
  if (opresult2029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1997 = done;
  } else {
  }
// compiled if node returning if1997 (depth = 4)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent2031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2032 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe2033 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool2034 = alloc_Boolean(0);
// compiled identifier node returning bool2034 (depth = 6)
  gc_frame_newslot(bool2034);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchCaseNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_emptySeq;
  params[2] = bool2034;
  partcv[0] = 3;
  Object call2035 = callmethod(*var_matchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2033);
// compiled call node returning call2035 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2036 = callmethod(call2035, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe2032);
// compiled call node returning call2036 (depth = 4)
  gc_frame_end(frame);
  return call2036;
}
Object meth_ast_new1745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1746 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1746 = alloc_userobj2(14,12, objclass1746);
  gc_frame_newslot(obj1746);
if (objclass1746 == NULL) {
  glfree(obj1746->class->name);
  obj1746->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1746, self, 0);
  addmethodreal(obj1746,"outer", &reader_ast_outer_1747);
  Object oldself1746 = self;
  struct StackFrameObject *oldstackframe1746 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1746);
  gc_frame_newslot((Object)stackframe);
  self = obj1746;
  Object *oldselfslot1746 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1746 = (*(struct UserObject *)self).data[0], lowerouter1746 = thisouter1746;
  if (inheritingObject1746) {
    struct UserObject *inho1746 = (struct UserObject *)inheritingObject1746;
    while (inho1746->super != GraceDefaultObject) inho1746 = (struct UserObject *)inho1746->super;
    inho1746->super = obj1746;
    self = inheritingObject1746;
    *selfslot = self;
    lowerouter1746 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1746;
  }
if (objclass1746 == NULL) {
  Method *reader1748 = addmethodrealflags(obj1746, "kind",&reader_ast_kind_1748, MFLAG_DEF);
  reader1748->definitionModule = modulename;
  reader1748->definitionLine = 408;
}
adddatum2(obj1746, alloc_Undefined(), 1);
if (objclass1746 == NULL) {
  Method *reader1749 = addmethodrealflags(obj1746, "value",&reader_ast_value_1749, 0);
  Method *writer1749 = addmethodrealflags(obj1746, "value:=",&writer_ast_value_1749, 0);
  reader1749->definitionModule = modulename;
  writer1749->definitionModule = modulename;
  reader1749->definitionLine = 409;
  writer1749->definitionLine = 409;
}
obj1746->flags |= OFLAG_MUTABLE;
adddatum2(obj1746, alloc_Undefined(), 2);
if (objclass1746 == NULL) {
  Method *reader1750 = addmethodrealflags(obj1746, "cases",&reader_ast_cases_1750, 0);
  Method *writer1750 = addmethodrealflags(obj1746, "cases:=",&writer_ast_cases_1750, 0);
  reader1750->definitionModule = modulename;
  writer1750->definitionModule = modulename;
  reader1750->definitionLine = 410;
  writer1750->definitionLine = 410;
}
obj1746->flags |= OFLAG_MUTABLE;
adddatum2(obj1746, alloc_Undefined(), 3);
if (objclass1746 == NULL) {
  Method *reader1751 = addmethodrealflags(obj1746, "elsecase",&reader_ast_elsecase_1751, 0);
  Method *writer1751 = addmethodrealflags(obj1746, "elsecase:=",&writer_ast_elsecase_1751, 0);
  reader1751->definitionModule = modulename;
  writer1751->definitionModule = modulename;
  reader1751->definitionLine = 411;
  writer1751->definitionLine = 411;
}
obj1746->flags |= OFLAG_MUTABLE;
adddatum2(obj1746, alloc_Undefined(), 4);
// method matchee
  struct UserObject *uo1752 = (struct UserObject*)obj1746;
  uo1752->data[5] = emptyclosure;
  Method *meth_meth_ast_matchee1752 = addmethod2pos(obj1746, "matchee", &meth_ast_matchee1752, 5);
  int argcv_meth_ast_matchee1752[] = {0};
  meth_meth_ast_matchee1752->type = alloc_MethodType(1, argcv_meth_ast_matchee1752);
  meth_meth_ast_matchee1752->definitionModule = modulename;
  meth_meth_ast_matchee1752->definitionLine = 411;
// method accept()from
  struct UserObject *uo1755 = (struct UserObject*)obj1746;
  uo1755->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1755 = addmethod2pos(obj1746, "accept()from", &meth_ast_accept_40__41_from1755, 6);
  int argcv_meth_ast_accept_40__41_from1755[] = {1, 1};
  meth_meth_ast_accept_40__41_from1755->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1755);
  meth_meth_ast_accept_40__41_from1755->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1755->definitionLine = 412;
// method map()parent
  struct UserObject *uo1783 = (struct UserObject*)obj1746;
  uo1783->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent1783 = addmethod2pos(obj1746, "map()parent", &meth_ast_map_40__41_parent1783, 7);
  int argcv_meth_ast_map_40__41_parent1783[] = {1, 1};
  meth_meth_ast_map_40__41_parent1783->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent1783);
  meth_meth_ast_map_40__41_parent1783->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent1783->definitionLine = 423;
// method pretty
  struct UserObject *uo1815 = (struct UserObject*)obj1746;
  uo1815->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1815 = addmethod2pos(obj1746, "pretty", &meth_ast_pretty1815, 8);
  int argcv_meth_ast_pretty1815[] = {1};
  meth_meth_ast_pretty1815->type = alloc_MethodType(1, argcv_meth_ast_pretty1815);
  meth_meth_ast_pretty1815->definitionModule = modulename;
  meth_meth_ast_pretty1815->definitionLine = 431;
// method toGrace
  struct UserObject *uo1932 = (struct UserObject*)obj1746;
  uo1932->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1932 = addmethod2pos(obj1746, "toGrace", &meth_ast_toGrace1932, 9);
  int argcv_meth_ast_toGrace1932[] = {1};
  meth_meth_ast_toGrace1932->type = alloc_MethodType(1, argcv_meth_ast_toGrace1932);
meth_meth_ast_toGrace1932->type->types[0] = type_Number;
meth_meth_ast_toGrace1932->type->names[0] = "depth";
  meth_meth_ast_toGrace1932->definitionModule = modulename;
  meth_meth_ast_toGrace1932->definitionLine = 446;
// method shallowCopyWithParent
  block_savedest(obj1746);
  Object closure2031 = createclosure(3, "shallowCopyWithParent");
  setclosureframe(closure2031, stackframe);
  addtoclosure(closure2031, var_nullNode);
  addtoclosure(closure2031, var_emptySeq);
  addtoclosure(closure2031, var_matchCaseNode);
  struct UserObject *uo2031 = (struct UserObject*)obj1746;
  uo2031->data[10] = (Object)closure2031;
  Method *meth_meth_ast_shallowCopyWithParent2031 = addmethod2pos(obj1746, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent2031, 10);
  int argcv_meth_ast_shallowCopyWithParent2031[] = {1};
  meth_meth_ast_shallowCopyWithParent2031->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent2031);
  meth_meth_ast_shallowCopyWithParent2031->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent2031->definitionLine = 460;
  sourceObject = obj1746;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2037 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2038 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2037);
// compiled call node returning call2038 (depth = 4)
  struct UserObject *obj1746_uo = (struct UserObject *)obj1746;
  obj1746_uo->super = call2038;
  sourceObject = obj1746;
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2039 == NULL) {
    strlit2039 = alloc_String("matchcase");
    gc_root(strlit2039);
  }
// compiled string node returning strlit2039 (depth = 4)
  adddatum2(obj1746, strlit2039, 1);
  sourceObject = obj1746;
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee_39_ (depth = 4)
  adddatum2(obj1746, *var_matchee_39_, 2);
  sourceObject = obj1746;
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj1746, *var_cases_39_, 3);
  sourceObject = obj1746;
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase_39_ (depth = 4)
  adddatum2(obj1746, *var_elsecase_39_, 4);
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
objclass1746 = obj1746->class;
  objclass1746->definitionModule = modulename;
  objclass1746->definitionLine = 405;
  (*(struct UserObject *)self).data[0] = lowerouter1746;
  self = oldself1746;
  selfslot = oldselfslot1746;
  stackframe = oldstackframe1746;
  gc_frame_end(frame);
  return obj1746;
}
Object meth_ast_new1745_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_matchCaseNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee_39_ = &(stackframe->slots[0]);
  *var_matchee_39_ = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1746 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1746 = alloc_userobj2(14,12, objclass1746);
  gc_frame_newslot(obj1746);
if (objclass1746 == NULL) {
  glfree(obj1746->class->name);
  obj1746->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1746, self, 0);
  addmethodreal(obj1746,"outer", &reader_ast_outer_1747);
  Object oldself1746 = self;
  struct StackFrameObject *oldstackframe1746 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1746);
  gc_frame_newslot((Object)stackframe);
  self = obj1746;
  Object *oldselfslot1746 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1746 = (*(struct UserObject *)self).data[0], lowerouter1746 = thisouter1746;
  if (inheritingObject1746) {
    struct UserObject *inho1746 = (struct UserObject *)inheritingObject1746;
    while (inho1746->super != GraceDefaultObject) inho1746 = (struct UserObject *)inho1746->super;
    inho1746->super = obj1746;
    self = inheritingObject1746;
    *selfslot = self;
    lowerouter1746 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1746;
  }
if (objclass1746 == NULL) {
  Method *reader1748 = addmethodrealflags(obj1746, "kind",&reader_ast_kind_1748, MFLAG_DEF);
  reader1748->definitionModule = modulename;
  reader1748->definitionLine = 408;
}
adddatum2(obj1746, alloc_Undefined(), 1);
if (objclass1746 == NULL) {
  Method *reader1749 = addmethodrealflags(obj1746, "value",&reader_ast_value_1749, 0);
  Method *writer1749 = addmethodrealflags(obj1746, "value:=",&writer_ast_value_1749, 0);
  reader1749->definitionModule = modulename;
  writer1749->definitionModule = modulename;
  reader1749->definitionLine = 409;
  writer1749->definitionLine = 409;
}
obj1746->flags |= OFLAG_MUTABLE;
adddatum2(obj1746, alloc_Undefined(), 2);
if (objclass1746 == NULL) {
  Method *reader1750 = addmethodrealflags(obj1746, "cases",&reader_ast_cases_1750, 0);
  Method *writer1750 = addmethodrealflags(obj1746, "cases:=",&writer_ast_cases_1750, 0);
  reader1750->definitionModule = modulename;
  writer1750->definitionModule = modulename;
  reader1750->definitionLine = 410;
  writer1750->definitionLine = 410;
}
obj1746->flags |= OFLAG_MUTABLE;
adddatum2(obj1746, alloc_Undefined(), 3);
if (objclass1746 == NULL) {
  Method *reader1751 = addmethodrealflags(obj1746, "elsecase",&reader_ast_elsecase_1751, 0);
  Method *writer1751 = addmethodrealflags(obj1746, "elsecase:=",&writer_ast_elsecase_1751, 0);
  reader1751->definitionModule = modulename;
  writer1751->definitionModule = modulename;
  reader1751->definitionLine = 411;
  writer1751->definitionLine = 411;
}
obj1746->flags |= OFLAG_MUTABLE;
adddatum2(obj1746, alloc_Undefined(), 4);
// method matchee
  struct UserObject *uo1752 = (struct UserObject*)obj1746;
  uo1752->data[5] = emptyclosure;
  Method *meth_meth_ast_matchee1752 = addmethod2pos(obj1746, "matchee", &meth_ast_matchee1752, 5);
  int argcv_meth_ast_matchee1752[] = {0};
  meth_meth_ast_matchee1752->type = alloc_MethodType(1, argcv_meth_ast_matchee1752);
  meth_meth_ast_matchee1752->definitionModule = modulename;
  meth_meth_ast_matchee1752->definitionLine = 411;
// method accept()from
  struct UserObject *uo1755 = (struct UserObject*)obj1746;
  uo1755->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from1755 = addmethod2pos(obj1746, "accept()from", &meth_ast_accept_40__41_from1755, 6);
  int argcv_meth_ast_accept_40__41_from1755[] = {1, 1};
  meth_meth_ast_accept_40__41_from1755->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from1755);
  meth_meth_ast_accept_40__41_from1755->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from1755->definitionLine = 412;
// method map()parent
  struct UserObject *uo1783 = (struct UserObject*)obj1746;
  uo1783->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent1783 = addmethod2pos(obj1746, "map()parent", &meth_ast_map_40__41_parent1783, 7);
  int argcv_meth_ast_map_40__41_parent1783[] = {1, 1};
  meth_meth_ast_map_40__41_parent1783->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent1783);
  meth_meth_ast_map_40__41_parent1783->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent1783->definitionLine = 423;
// method pretty
  struct UserObject *uo1815 = (struct UserObject*)obj1746;
  uo1815->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1815 = addmethod2pos(obj1746, "pretty", &meth_ast_pretty1815, 8);
  int argcv_meth_ast_pretty1815[] = {1};
  meth_meth_ast_pretty1815->type = alloc_MethodType(1, argcv_meth_ast_pretty1815);
  meth_meth_ast_pretty1815->definitionModule = modulename;
  meth_meth_ast_pretty1815->definitionLine = 431;
// method toGrace
  struct UserObject *uo1932 = (struct UserObject*)obj1746;
  uo1932->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1932 = addmethod2pos(obj1746, "toGrace", &meth_ast_toGrace1932, 9);
  int argcv_meth_ast_toGrace1932[] = {1};
  meth_meth_ast_toGrace1932->type = alloc_MethodType(1, argcv_meth_ast_toGrace1932);
meth_meth_ast_toGrace1932->type->types[0] = type_Number;
meth_meth_ast_toGrace1932->type->names[0] = "depth";
  meth_meth_ast_toGrace1932->definitionModule = modulename;
  meth_meth_ast_toGrace1932->definitionLine = 446;
// method shallowCopyWithParent
  block_savedest(obj1746);
  Object closure2031 = createclosure(3, "shallowCopyWithParent");
  setclosureframe(closure2031, stackframe);
  addtoclosure(closure2031, var_nullNode);
  addtoclosure(closure2031, var_emptySeq);
  addtoclosure(closure2031, var_matchCaseNode);
  struct UserObject *uo2031 = (struct UserObject*)obj1746;
  uo2031->data[10] = (Object)closure2031;
  Method *meth_meth_ast_shallowCopyWithParent2031 = addmethod2pos(obj1746, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent2031, 10);
  int argcv_meth_ast_shallowCopyWithParent2031[] = {1};
  meth_meth_ast_shallowCopyWithParent2031->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent2031);
  meth_meth_ast_shallowCopyWithParent2031->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent2031->definitionLine = 460;
  sourceObject = obj1746;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2037 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2038 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2037);
// compiled call node returning call2038 (depth = 4)
  struct UserObject *obj1746_uo = (struct UserObject *)obj1746;
  obj1746_uo->super = call2038;
  sourceObject = obj1746;
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2039 == NULL) {
    strlit2039 = alloc_String("matchcase");
    gc_root(strlit2039);
  }
// compiled string node returning strlit2039 (depth = 4)
  adddatum2(obj1746, strlit2039, 1);
  sourceObject = obj1746;
// Begin line 408
  setline(408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee_39_ (depth = 4)
  adddatum2(obj1746, *var_matchee_39_, 2);
  sourceObject = obj1746;
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases_39_ (depth = 4)
  adddatum2(obj1746, *var_cases_39_, 3);
  sourceObject = obj1746;
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase_39_ (depth = 4)
  adddatum2(obj1746, *var_elsecase_39_, 4);
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
  sourceObject = obj1746;
objclass1746 = obj1746->class;
  objclass1746->definitionModule = modulename;
  objclass1746->definitionLine = 405;
  (*(struct UserObject *)self).data[0] = lowerouter1746;
  self = oldself1746;
  selfslot = oldselfslot1746;
  stackframe = oldstackframe1746;
  gc_frame_end(frame);
  return obj1746;
}
Object meth_ast_methodTypeNode2041(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodTypeNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for methodTypeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodTypeNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast_asString2053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2055 == NULL) {
    strlit2055 = alloc_String("");
    gc_root(strlit2055);
  }
// compiled string node returning strlit2055 (depth = 5)
  int op_slot_right_2054 = gc_frame_newslot(strlit2055);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2059 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2058);
// compiled call node returning call2059 (depth = 7)
// compiled member node returning call2059 (depth = 6)
  int op_slot_right_2057 = gc_frame_newslot(call2059);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2062 == NULL) {
    strlit2062 = alloc_String(" -> ");
    gc_root(strlit2062);
  }
// compiled string node returning strlit2062 (depth = 7)
  int op_slot_right_2061 = gc_frame_newslot(strlit2062);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2065 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2066 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2065);
// compiled call node returning call2066 (depth = 9)
// compiled member node returning call2066 (depth = 8)
  int op_slot_right_2064 = gc_frame_newslot(call2066);
// starting to compile string node (depth = 8)
  if (strlit2068 == NULL) {
    strlit2068 = alloc_String("MethodType ");
    gc_root(strlit2068);
  }
// compiled string node returning strlit2068 (depth = 8)
  int op_slot_left_2064 = gc_frame_newslot(strlit2068);
  params[0] = call2066;
  partcv[0] = 1;
  Object opresult2069 = callmethod(strlit2068, "++", 1, partcv, params);
// compiled op node returning opresult2069 (depth = 7)
  int op_slot_left_2061 = gc_frame_newslot(opresult2069);
  params[0] = strlit2062;
  partcv[0] = 1;
  Object opresult2070 = callmethod(opresult2069, "++", 1, partcv, params);
// compiled op node returning opresult2070 (depth = 6)
  int op_slot_left_2057 = gc_frame_newslot(opresult2070);
  params[0] = call2059;
  partcv[0] = 1;
  Object opresult2071 = callmethod(opresult2070, "++", 1, partcv, params);
// compiled op node returning opresult2071 (depth = 5)
  int op_slot_left_2054 = gc_frame_newslot(opresult2071);
  params[0] = strlit2055;
  partcv[0] = 1;
  Object opresult2072 = callmethod(opresult2071, "++", 1, partcv, params);
// compiled op node returning opresult2072 (depth = 4)
  gc_frame_end(frame);
  return opresult2072;
}
Object meth_ast__apply2079(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe2080 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_b (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2081 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe2080);
// compiled call node returning call2081 (depth = 8)
  gc_frame_end(frame);
  return call2081;
}
Object meth_ast__apply2076(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2077 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2078 = alloc_Block(NULL, NULL, "ast", 492);
  gc_frame_newslot(block2078);
// method _apply
  block_savedest(block2078);
  Object closure2079 = createclosure(2, "_apply");
  setclosureframe(closure2079, stackframe);
  addtoclosure(closure2079, var_b);
  addtoclosure(closure2079, selfslot);
  struct UserObject *uo2079 = (struct UserObject*)block2078;
  uo2079->data[0] = (Object)closure2079;
  Method *meth_meth_ast__apply2079 = addmethod2pos(block2078, "_apply", &meth_ast__apply2079, 0);
  int argcv_meth_ast__apply2079[] = {1};
  meth_meth_ast__apply2079->type = alloc_MethodType(1, argcv_meth_ast__apply2079);
  meth_meth_ast__apply2079->definitionModule = modulename;
  meth_meth_ast__apply2079->definitionLine = 488;
// compiled block node returning block2078 (depth = 7)
  gc_frame_newslot(block2078);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call2084 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2083);
// compiled call node returning call2084 (depth = 8)
// compiled member node returning call2084 (depth = 7)
  params[0] = block2078;
  partcv[0] = 1;
  Object call2085 = callmethod(call2084, "do",
    1, partcv, params);
  gc_frame_end(callframe2077);
// compiled call node returning call2085 (depth = 6)
  gc_frame_end(frame);
  return call2085;
}
Object meth_ast_parametersDo2073(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2074 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2075 = alloc_Block(NULL, NULL, "ast", 491);
  gc_frame_newslot(block2075);
// method _apply
  block_savedest(block2075);
  Object closure2076 = createclosure(2, "_apply");
  setclosureframe(closure2076, stackframe);
  addtoclosure(closure2076, var_b);
  addtoclosure(closure2076, selfslot);
  struct UserObject *uo2076 = (struct UserObject*)block2075;
  uo2076->data[0] = (Object)closure2076;
  Method *meth_meth_ast__apply2076 = addmethod2pos(block2075, "_apply", &meth_ast__apply2076, 0);
  int argcv_meth_ast__apply2076[] = {1};
  meth_meth_ast__apply2076->type = alloc_MethodType(1, argcv_meth_ast__apply2076);
  meth_meth_ast__apply2076->definitionModule = modulename;
  meth_meth_ast__apply2076->definitionLine = 488;
// compiled block node returning block2075 (depth = 5)
  gc_frame_newslot(block2075);
// call case 6: other member request
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2088 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2087);
// compiled call node returning call2088 (depth = 6)
// compiled member node returning call2088 (depth = 5)
  params[0] = block2075;
  partcv[0] = 1;
  Object call2089 = callmethod(call2088, "do",
    1, partcv, params);
  gc_frame_end(callframe2074);
// compiled call node returning call2089 (depth = 4)
  gc_frame_end(frame);
  return call2089;
}
Object meth_ast_declarationKind2090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2091 == NULL) {
    strlit2091 = alloc_String("typedec");
    gc_root(strlit2091);
  }
// compiled string node returning strlit2091 (depth = 4)
  gc_frame_end(frame);
  return strlit2091;
}
Object meth_ast__apply2102(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2103 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2104 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe2103);
// compiled call node returning call2104 (depth = 7)
  gc_frame_end(frame);
  return call2104;
}
Object meth_ast_typeParametersDo2092(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "typeParametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method typeParametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeParametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for typeParametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2096 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2095);
// compiled call node returning call2096 (depth = 7)
// compiled member node returning call2096 (depth = 6)
  int op_slot_right_2094 = gc_frame_newslot(call2096);
// starting to compile identifier node (depth = 6)
  Object bool2098 = alloc_Boolean(0);
// compiled identifier node returning bool2098 (depth = 6)
  int op_slot_left_2094 = gc_frame_newslot(bool2098);
  params[0] = call2096;
  partcv[0] = 1;
  Object opresult2099 = callmethod(bool2098, "!=", 1, partcv, params);
// compiled op node returning opresult2099 (depth = 5)
  Object if2093 = done;
  if (istrue(opresult2099)) {
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2100 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2101 = alloc_Block(NULL, NULL, "ast", 498);
  gc_frame_newslot(block2101);
// method _apply
  block_savedest(block2101);
  Object closure2102 = createclosure(2, "_apply");
  setclosureframe(closure2102, stackframe);
  addtoclosure(closure2102, var_b);
  addtoclosure(closure2102, selfslot);
  struct UserObject *uo2102 = (struct UserObject*)block2101;
  uo2102->data[0] = (Object)closure2102;
  Method *meth_meth_ast__apply2102 = addmethod2pos(block2101, "_apply", &meth_ast__apply2102, 0);
  int argcv_meth_ast__apply2102[] = {1};
  meth_meth_ast__apply2102->type = alloc_MethodType(1, argcv_meth_ast__apply2102);
  meth_meth_ast__apply2102->definitionModule = modulename;
  meth_meth_ast__apply2102->definitionLine = 497;
// compiled block node returning block2101 (depth = 6)
  gc_frame_newslot(block2101);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2106 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2107 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2106);
// compiled call node returning call2107 (depth = 7)
// compiled member node returning call2107 (depth = 6)
  params[0] = block2101;
  partcv[0] = 1;
  Object call2108 = callmethod(call2107, "do",
    1, partcv, params);
  gc_frame_end(callframe2100);
// compiled call node returning call2108 (depth = 5)
    gc_frame_newslot(call2108);
    if2093 = call2108;
  } else {
  }
// compiled if node returning if2093 (depth = 4)
  gc_frame_end(frame);
  return if2093;
}
Object meth_ast__apply2128(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2129 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2130 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2129);
// compiled call node returning call2130 (depth = 7)
  gc_frame_end(frame);
  return call2130;
}
Object meth_ast__apply2137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2138 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2139 = callmethod(*var_part, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2138);
// compiled call node returning call2139 (depth = 7)
  gc_frame_end(frame);
  return call2139;
}
Object meth_ast_accept_40__41_from2109(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2111 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2112 = callmethod(*var_visitor, "visitMethodType()up",
    2, partcv, params);
  gc_frame_end(callframe2111);
// compiled call node returning call2112 (depth = 5)
  Object if2110 = done;
  if (istrue(call2112)) {
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2115 = alloc_Boolean(0);
// compiled identifier node returning bool2115 (depth = 7)
  int op_slot_right_2114 = gc_frame_newslot(bool2115);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2117 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2118 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2117);
// compiled call node returning call2118 (depth = 8)
// compiled member node returning call2118 (depth = 7)
  int op_slot_left_2114 = gc_frame_newslot(call2118);
  params[0] = bool2115;
  partcv[0] = 1;
  Object opresult2119 = callmethod(call2118, "!=", 1, partcv, params);
// compiled op node returning opresult2119 (depth = 6)
  Object if2113 = done;
  if (istrue(opresult2119)) {
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2120 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2121 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2122 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2121);
// compiled call node returning call2122 (depth = 8)
// compiled member node returning call2122 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2123 = callmethod(call2122, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2120);
// compiled call node returning call2123 (depth = 6)
    gc_frame_newslot(call2123);
    if2113 = call2123;
  } else {
  }
// compiled if node returning if2113 (depth = 5)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2124 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2125 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2126 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2125);
// compiled call node returning call2126 (depth = 7)
// compiled member node returning call2126 (depth = 6)
  gc_frame_newslot(call2126);
// starting to compile block node (depth = 6)
  Object block2127 = alloc_Block(NULL, NULL, "ast", 506);
  gc_frame_newslot(block2127);
// method _apply
  block_savedest(block2127);
  Object closure2128 = createclosure(2, "_apply");
  setclosureframe(closure2128, stackframe);
  addtoclosure(closure2128, var_visitor);
  addtoclosure(closure2128, selfslot);
  struct UserObject *uo2128 = (struct UserObject*)block2127;
  uo2128->data[0] = (Object)closure2128;
  Method *meth_meth_ast__apply2128 = addmethod2pos(block2127, "_apply", &meth_ast__apply2128, 0);
  int argcv_meth_ast__apply2128[] = {1};
  meth_meth_ast__apply2128->type = alloc_MethodType(1, argcv_meth_ast__apply2128);
  meth_meth_ast__apply2128->definitionModule = modulename;
  meth_meth_ast__apply2128->definitionLine = 506;
// compiled block node returning block2127 (depth = 6)
  gc_frame_newslot(block2127);
// call case 5: prelude request
  params[0] = call2126;
  params[1] = block2127;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2132 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2124);
// compiled call node returning call2132 (depth = 5)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2133 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2135 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2134);
// compiled call node returning call2135 (depth = 7)
// compiled member node returning call2135 (depth = 6)
  gc_frame_newslot(call2135);
// starting to compile block node (depth = 6)
  Object block2136 = alloc_Block(NULL, NULL, "ast", 509);
  gc_frame_newslot(block2136);
// method _apply
  block_savedest(block2136);
  Object closure2137 = createclosure(2, "_apply");
  setclosureframe(closure2137, stackframe);
  addtoclosure(closure2137, var_visitor);
  addtoclosure(closure2137, selfslot);
  struct UserObject *uo2137 = (struct UserObject*)block2136;
  uo2137->data[0] = (Object)closure2137;
  Method *meth_meth_ast__apply2137 = addmethod2pos(block2136, "_apply", &meth_ast__apply2137, 0);
  int argcv_meth_ast__apply2137[] = {1};
  meth_meth_ast__apply2137->type = alloc_MethodType(1, argcv_meth_ast__apply2137);
  meth_meth_ast__apply2137->definitionModule = modulename;
  meth_meth_ast__apply2137->definitionLine = 509;
// compiled block node returning block2136 (depth = 6)
  gc_frame_newslot(block2136);
// call case 5: prelude request
  params[0] = call2135;
  params[1] = block2136;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2141 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2133);
// compiled call node returning call2141 (depth = 5)
    gc_frame_newslot(call2141);
    if2110 = call2141;
  } else {
  }
// compiled if node returning if2110 (depth = 4)
  gc_frame_end(frame);
  return if2110;
}
Object meth_ast_map_40__41_parent2142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2143 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call2144 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2143);
// compiled call node returning call2144 (depth = 5)
  *var_n = call2144;
  if (call2144 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2145 = gc_frame_new();
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2146 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2147 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2148 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2147);
// compiled call node returning call2148 (depth = 8)
// compiled member node returning call2148 (depth = 7)
  gc_frame_newslot(call2148);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2149 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2150 = gc_frame_new();
// call case 3: self.outer request
  Object call2151 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2150);
// compiled call node returning call2151 (depth = 10)
// compiled member node returning call2151 (depth = 9)
  partcv[0] = 0;
  Object call2152 = callmethodflags(call2151, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2149);
// compiled call node returning call2152 (depth = 8)
// compiled member node returning call2152 (depth = 7)
  params[0] = call2148;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2153 = callmethodflags(call2152, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2146);
// compiled call node returning call2153 (depth = 6)
  gc_frame_newslot(call2153);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2153;
  partcv[0] = 1;
  Object call2154 = callmethod(*var_n, "rtype:=",
    1, partcv, params);
  gc_frame_end(callframe2145);
// compiled call node returning call2154 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2155 = gc_frame_new();
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2156 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2157 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2158 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2157);
// compiled call node returning call2158 (depth = 8)
// compiled member node returning call2158 (depth = 7)
  gc_frame_newslot(call2158);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2159 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2160 = gc_frame_new();
// call case 3: self.outer request
  Object call2161 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2160);
// compiled call node returning call2161 (depth = 10)
// compiled member node returning call2161 (depth = 9)
  partcv[0] = 0;
  Object call2162 = callmethodflags(call2161, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2159);
// compiled call node returning call2162 (depth = 8)
// compiled member node returning call2162 (depth = 7)
  params[0] = call2158;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2163 = callmethodflags(call2162, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2156);
// compiled call node returning call2163 (depth = 6)
  gc_frame_newslot(call2163);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2163;
  partcv[0] = 1;
  Object call2164 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe2155);
// compiled call node returning call2164 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2165 = gc_frame_new();
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2166 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2168 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2167);
// compiled call node returning call2168 (depth = 8)
// compiled member node returning call2168 (depth = 7)
  gc_frame_newslot(call2168);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2169 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2170 = gc_frame_new();
// call case 3: self.outer request
  Object call2171 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2170);
// compiled call node returning call2171 (depth = 10)
// compiled member node returning call2171 (depth = 9)
  partcv[0] = 0;
  Object call2172 = callmethodflags(call2171, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2169);
// compiled call node returning call2172 (depth = 8)
// compiled member node returning call2172 (depth = 7)
  params[0] = call2168;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2173 = callmethodflags(call2172, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2166);
// compiled call node returning call2173 (depth = 6)
  gc_frame_newslot(call2173);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2173;
  partcv[0] = 1;
  Object call2174 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe2165);
// compiled call node returning call2174 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2175 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2176 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2175);
// compiled call node returning call2176 (depth = 5)
  *var_n = call2176;
  if (call2176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply2186(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2188 == NULL) {
    strlit2188 = alloc_String("  ");
    gc_root(strlit2188);
  }
// compiled string node returning strlit2188 (depth = 8)
  int op_slot_right_2187 = gc_frame_newslot(strlit2188);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2187 = gc_frame_newslot(*var_spc);
  params[0] = strlit2188;
  partcv[0] = 1;
  Object opresult2190 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2190 (depth = 7)
  *var_spc = opresult2190;
  if (opresult2190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2297(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2299 == NULL) {
    strlit2299 = alloc_String("");
    gc_root(strlit2299);
  }
// compiled string node returning strlit2299 (depth = 9)
  int op_slot_right_2298 = gc_frame_newslot(strlit2299);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2302 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2304 = alloc_Float64(2);
// compiled num node returning num2304 (depth = 12)
  int op_slot_right_2303 = gc_frame_newslot(num2304);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_2303 = gc_frame_newslot(*var_depth);
  params[0] = num2304;
  partcv[0] = 1;
  Object sum2306 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2306 (depth = 11)
  gc_frame_newslot(sum2306);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_each (depth = 11)
  params[0] = sum2306;
  partcv[0] = 1;
  Object call2307 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2302);
// compiled call node returning call2307 (depth = 10)
  int op_slot_right_2301 = gc_frame_newslot(call2307);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2310 == NULL) {
    strlit2310 = alloc_String("  ");
    gc_root(strlit2310);
  }
// compiled string node returning strlit2310 (depth = 11)
  int op_slot_right_2309 = gc_frame_newslot(strlit2310);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2312 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2315 == NULL) {
    strlit2315 = alloc_String("""\x0a""");
    gc_root(strlit2315);
  }
// compiled string node returning strlit2315 (depth = 13)
  int op_slot_right_2314 = gc_frame_newslot(strlit2315);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_2317 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit2319 == NULL) {
    strlit2319 = alloc_String("");
    gc_root(strlit2319);
  }
// compiled string node returning strlit2319 (depth = 14)
  int op_slot_left_2317 = gc_frame_newslot(strlit2319);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2320 = callmethod(strlit2319, "++", 1, partcv, params);
// compiled op node returning opresult2320 (depth = 13)
  int op_slot_left_2314 = gc_frame_newslot(opresult2320);
  params[0] = strlit2315;
  partcv[0] = 1;
  Object opresult2321 = callmethod(opresult2320, "++", 1, partcv, params);
// compiled op node returning opresult2321 (depth = 12)
  int op_slot_left_2312 = gc_frame_newslot(opresult2321);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2322 = callmethod(opresult2321, "++", 1, partcv, params);
// compiled op node returning opresult2322 (depth = 11)
  int op_slot_left_2309 = gc_frame_newslot(opresult2322);
  params[0] = strlit2310;
  partcv[0] = 1;
  Object opresult2323 = callmethod(opresult2322, "++", 1, partcv, params);
// compiled op node returning opresult2323 (depth = 10)
  int op_slot_left_2301 = gc_frame_newslot(opresult2323);
  params[0] = call2307;
  partcv[0] = 1;
  Object opresult2324 = callmethod(opresult2323, "++", 1, partcv, params);
// compiled op node returning opresult2324 (depth = 9)
  int op_slot_left_2298 = gc_frame_newslot(opresult2324);
  params[0] = strlit2299;
  partcv[0] = 1;
  Object opresult2325 = callmethod(opresult2324, "++", 1, partcv, params);
// compiled op node returning opresult2325 (depth = 8)
  *var_s = opresult2325;
  if (opresult2325 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2351 == NULL) {
    strlit2351 = alloc_String("");
    gc_root(strlit2351);
  }
// compiled string node returning strlit2351 (depth = 8)
  int op_slot_right_2350 = gc_frame_newslot(strlit2351);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2354 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2356 = alloc_Float64(2);
// compiled num node returning num2356 (depth = 11)
  int op_slot_right_2355 = gc_frame_newslot(num2356);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_2355 = gc_frame_newslot(*var_depth);
  params[0] = num2356;
  partcv[0] = 1;
  Object sum2358 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2358 (depth = 10)
  gc_frame_newslot(sum2358);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  params[0] = sum2358;
  partcv[0] = 1;
  Object call2359 = callmethod(*var_part, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2354);
// compiled call node returning call2359 (depth = 9)
  int op_slot_right_2353 = gc_frame_newslot(call2359);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2362 == NULL) {
    strlit2362 = alloc_String("");
    gc_root(strlit2362);
  }
// compiled string node returning strlit2362 (depth = 10)
  int op_slot_right_2361 = gc_frame_newslot(strlit2362);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_2364 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2367 == NULL) {
    strlit2367 = alloc_String("""\x0a""  ");
    gc_root(strlit2367);
  }
// compiled string node returning strlit2367 (depth = 12)
  int op_slot_right_2366 = gc_frame_newslot(strlit2367);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_2369 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit2371 == NULL) {
    strlit2371 = alloc_String("");
    gc_root(strlit2371);
  }
// compiled string node returning strlit2371 (depth = 13)
  int op_slot_left_2369 = gc_frame_newslot(strlit2371);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2372 = callmethod(strlit2371, "++", 1, partcv, params);
// compiled op node returning opresult2372 (depth = 12)
  int op_slot_left_2366 = gc_frame_newslot(opresult2372);
  params[0] = strlit2367;
  partcv[0] = 1;
  Object opresult2373 = callmethod(opresult2372, "++", 1, partcv, params);
// compiled op node returning opresult2373 (depth = 11)
  int op_slot_left_2364 = gc_frame_newslot(opresult2373);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2374 = callmethod(opresult2373, "++", 1, partcv, params);
// compiled op node returning opresult2374 (depth = 10)
  int op_slot_left_2361 = gc_frame_newslot(opresult2374);
  params[0] = strlit2362;
  partcv[0] = 1;
  Object opresult2375 = callmethod(opresult2374, "++", 1, partcv, params);
// compiled op node returning opresult2375 (depth = 9)
  int op_slot_left_2353 = gc_frame_newslot(opresult2375);
  params[0] = call2359;
  partcv[0] = 1;
  Object opresult2376 = callmethod(opresult2375, "++", 1, partcv, params);
// compiled op node returning opresult2376 (depth = 8)
  int op_slot_left_2350 = gc_frame_newslot(opresult2376);
  params[0] = strlit2351;
  partcv[0] = 1;
  Object opresult2377 = callmethod(opresult2376, "++", 1, partcv, params);
// compiled op node returning opresult2377 (depth = 7)
  *var_s = opresult2377;
  if (opresult2377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2179 == NULL) {
    strlit2179 = alloc_String("");
    gc_root(strlit2179);
  }
// compiled string node returning strlit2179 (depth = 5)
  *var_spc = strlit2179;
  if (strlit2179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2180 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_2181 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num2183 = alloc_Float64(0);
// compiled num node returning num2183 (depth = 6)
  int op_slot_left_2181 = gc_frame_newslot(num2183);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2184 = callmethod(num2183, "..", 1, partcv, params);
// compiled op node returning opresult2184 (depth = 5)
  gc_frame_newslot(opresult2184);
// starting to compile block node (depth = 5)
  Object block2185 = alloc_Block(NULL, NULL, "ast", 524);
  gc_frame_newslot(block2185);
// method _apply
  block_savedest(block2185);
  Object closure2186 = createclosure(2, "_apply");
  setclosureframe(closure2186, stackframe);
  addtoclosure(closure2186, var_spc);
  addtoclosure(closure2186, selfslot);
  struct UserObject *uo2186 = (struct UserObject*)block2185;
  uo2186->data[0] = (Object)closure2186;
  Method *meth_meth_ast__apply2186 = addmethod2pos(block2185, "_apply", &meth_ast__apply2186, 0);
  int argcv_meth_ast__apply2186[] = {1};
  meth_meth_ast__apply2186->type = alloc_MethodType(1, argcv_meth_ast__apply2186);
  meth_meth_ast__apply2186->definitionModule = modulename;
  meth_meth_ast__apply2186->definitionLine = 518;
// compiled block node returning block2185 (depth = 5)
  gc_frame_newslot(block2185);
// call case 5: prelude request
  params[0] = opresult2184;
  params[1] = block2185;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2193 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2180);
// compiled call node returning call2193 (depth = 4)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2195 == NULL) {
    strlit2195 = alloc_String("""\x0a""");
    gc_root(strlit2195);
  }
// compiled string node returning strlit2195 (depth = 6)
  int op_slot_right_2194 = gc_frame_newslot(strlit2195);
// starting to compile call node (depth = 6)
  int callframe2197 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2198 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2197);
// compiled call node returning call2198 (depth = 6)
  int op_slot_left_2194 = gc_frame_newslot(call2198);
  params[0] = strlit2195;
  partcv[0] = 1;
  Object opresult2199 = callmethod(call2198, "++", 1, partcv, params);
// compiled op node returning opresult2199 (depth = 5)
  *var_s = opresult2199;
  if (opresult2199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2201 == NULL) {
    strlit2201 = alloc_String("""\x0a""");
    gc_root(strlit2201);
  }
// compiled string node returning strlit2201 (depth = 6)
  int op_slot_right_2200 = gc_frame_newslot(strlit2201);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2204 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2205 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2204);
// compiled call node returning call2205 (depth = 8)
// compiled member node returning call2205 (depth = 7)
  int op_slot_right_2203 = gc_frame_newslot(call2205);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2208 == NULL) {
    strlit2208 = alloc_String("Name: ");
    gc_root(strlit2208);
  }
// compiled string node returning strlit2208 (depth = 8)
  int op_slot_right_2207 = gc_frame_newslot(strlit2208);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2210 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2213 == NULL) {
    strlit2213 = alloc_String("");
    gc_root(strlit2213);
  }
// compiled string node returning strlit2213 (depth = 10)
  int op_slot_right_2212 = gc_frame_newslot(strlit2213);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_2215 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit2217 == NULL) {
    strlit2217 = alloc_String("");
    gc_root(strlit2217);
  }
// compiled string node returning strlit2217 (depth = 11)
  int op_slot_left_2215 = gc_frame_newslot(strlit2217);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2218 = callmethod(strlit2217, "++", 1, partcv, params);
// compiled op node returning opresult2218 (depth = 10)
  int op_slot_left_2212 = gc_frame_newslot(opresult2218);
  params[0] = strlit2213;
  partcv[0] = 1;
  Object opresult2219 = callmethod(opresult2218, "++", 1, partcv, params);
// compiled op node returning opresult2219 (depth = 9)
  int op_slot_left_2210 = gc_frame_newslot(opresult2219);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2220 = callmethod(opresult2219, "++", 1, partcv, params);
// compiled op node returning opresult2220 (depth = 8)
  int op_slot_left_2207 = gc_frame_newslot(opresult2220);
  params[0] = strlit2208;
  partcv[0] = 1;
  Object opresult2221 = callmethod(opresult2220, "++", 1, partcv, params);
// compiled op node returning opresult2221 (depth = 7)
  int op_slot_left_2203 = gc_frame_newslot(opresult2221);
  params[0] = call2205;
  partcv[0] = 1;
  Object opresult2222 = callmethod(opresult2221, "++", 1, partcv, params);
// compiled op node returning opresult2222 (depth = 6)
  int op_slot_left_2200 = gc_frame_newslot(opresult2222);
  params[0] = strlit2201;
  partcv[0] = 1;
  Object opresult2223 = callmethod(opresult2222, "++", 1, partcv, params);
// compiled op node returning opresult2223 (depth = 5)
  *var_s = opresult2223;
  if (opresult2223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2227 = alloc_Boolean(0);
// compiled identifier node returning bool2227 (depth = 6)
  int op_slot_right_2226 = gc_frame_newslot(bool2227);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2230 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2229);
// compiled call node returning call2230 (depth = 7)
// compiled member node returning call2230 (depth = 6)
  int op_slot_left_2226 = gc_frame_newslot(call2230);
  params[0] = bool2227;
  partcv[0] = 1;
  Object opresult2231 = callmethod(call2230, "!=", 1, partcv, params);
// compiled op node returning opresult2231 (depth = 5)
  Object if2225 = done;
  if (istrue(opresult2231)) {
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2233 == NULL) {
    strlit2233 = alloc_String("");
    gc_root(strlit2233);
  }
// compiled string node returning strlit2233 (depth = 7)
  int op_slot_right_2232 = gc_frame_newslot(strlit2233);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2236 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2238 = alloc_Float64(2);
// compiled num node returning num2238 (depth = 10)
  int op_slot_right_2237 = gc_frame_newslot(num2238);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2237 = gc_frame_newslot(*var_depth);
  params[0] = num2238;
  partcv[0] = 1;
  Object sum2240 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2240 (depth = 9)
  gc_frame_newslot(sum2240);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2242 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2241);
// compiled call node returning call2242 (depth = 10)
// compiled member node returning call2242 (depth = 9)
  params[0] = sum2240;
  partcv[0] = 1;
  Object call2243 = callmethod(call2242, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2236);
// compiled call node returning call2243 (depth = 8)
  int op_slot_right_2235 = gc_frame_newslot(call2243);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2246 == NULL) {
    strlit2246 = alloc_String("");
    gc_root(strlit2246);
  }
// compiled string node returning strlit2246 (depth = 9)
  int op_slot_right_2245 = gc_frame_newslot(strlit2246);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2248 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2251 == NULL) {
    strlit2251 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit2251);
  }
// compiled string node returning strlit2251 (depth = 11)
  int op_slot_right_2250 = gc_frame_newslot(strlit2251);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_2253 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2256 == NULL) {
    strlit2256 = alloc_String("");
    gc_root(strlit2256);
  }
// compiled string node returning strlit2256 (depth = 13)
  int op_slot_right_2255 = gc_frame_newslot(strlit2256);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_2258 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit2260 == NULL) {
    strlit2260 = alloc_String("");
    gc_root(strlit2260);
  }
// compiled string node returning strlit2260 (depth = 14)
  int op_slot_left_2258 = gc_frame_newslot(strlit2260);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2261 = callmethod(strlit2260, "++", 1, partcv, params);
// compiled op node returning opresult2261 (depth = 13)
  int op_slot_left_2255 = gc_frame_newslot(opresult2261);
  params[0] = strlit2256;
  partcv[0] = 1;
  Object opresult2262 = callmethod(opresult2261, "++", 1, partcv, params);
// compiled op node returning opresult2262 (depth = 12)
  int op_slot_left_2253 = gc_frame_newslot(opresult2262);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2263 = callmethod(opresult2262, "++", 1, partcv, params);
// compiled op node returning opresult2263 (depth = 11)
  int op_slot_left_2250 = gc_frame_newslot(opresult2263);
  params[0] = strlit2251;
  partcv[0] = 1;
  Object opresult2264 = callmethod(opresult2263, "++", 1, partcv, params);
// compiled op node returning opresult2264 (depth = 10)
  int op_slot_left_2248 = gc_frame_newslot(opresult2264);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2265 = callmethod(opresult2264, "++", 1, partcv, params);
// compiled op node returning opresult2265 (depth = 9)
  int op_slot_left_2245 = gc_frame_newslot(opresult2265);
  params[0] = strlit2246;
  partcv[0] = 1;
  Object opresult2266 = callmethod(opresult2265, "++", 1, partcv, params);
// compiled op node returning opresult2266 (depth = 8)
  int op_slot_left_2235 = gc_frame_newslot(opresult2266);
  params[0] = call2243;
  partcv[0] = 1;
  Object opresult2267 = callmethod(opresult2266, "++", 1, partcv, params);
// compiled op node returning opresult2267 (depth = 7)
  int op_slot_left_2232 = gc_frame_newslot(opresult2267);
  params[0] = strlit2233;
  partcv[0] = 1;
  Object opresult2268 = callmethod(opresult2267, "++", 1, partcv, params);
// compiled op node returning opresult2268 (depth = 6)
  *var_s = opresult2268;
  if (opresult2268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2225 = done;
  } else {
  }
// compiled if node returning if2225 (depth = 4)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2271 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2272 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2273 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2274 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2273);
// compiled call node returning call2274 (depth = 10)
// compiled member node returning call2274 (depth = 9)
  partcv[0] = 0;
  Object call2275 = callmethod(call2274, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe2272);
// compiled call node returning call2275 (depth = 8)
// compiled member node returning call2275 (depth = 7)
  partcv[0] = 0;
  Object call2276 = callmethod(call2275, "not",
    1, partcv, params);
  gc_frame_end(callframe2271);
// compiled call node returning call2276 (depth = 6)
// compiled member node returning call2276 (depth = 5)
  Object if2270 = done;
  if (istrue(call2276)) {
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2278 == NULL) {
    strlit2278 = alloc_String("TypeParams:");
    gc_root(strlit2278);
  }
// compiled string node returning strlit2278 (depth = 7)
  int op_slot_right_2277 = gc_frame_newslot(strlit2278);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_2280 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2283 == NULL) {
    strlit2283 = alloc_String("""\x0a""");
    gc_root(strlit2283);
  }
// compiled string node returning strlit2283 (depth = 9)
  int op_slot_right_2282 = gc_frame_newslot(strlit2283);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_2285 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit2287 == NULL) {
    strlit2287 = alloc_String("");
    gc_root(strlit2287);
  }
// compiled string node returning strlit2287 (depth = 10)
  int op_slot_left_2285 = gc_frame_newslot(strlit2287);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2288 = callmethod(strlit2287, "++", 1, partcv, params);
// compiled op node returning opresult2288 (depth = 9)
  int op_slot_left_2282 = gc_frame_newslot(opresult2288);
  params[0] = strlit2283;
  partcv[0] = 1;
  Object opresult2289 = callmethod(opresult2288, "++", 1, partcv, params);
// compiled op node returning opresult2289 (depth = 8)
  int op_slot_left_2280 = gc_frame_newslot(opresult2289);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2290 = callmethod(opresult2289, "++", 1, partcv, params);
// compiled op node returning opresult2290 (depth = 7)
  int op_slot_left_2277 = gc_frame_newslot(opresult2290);
  params[0] = strlit2278;
  partcv[0] = 1;
  Object opresult2291 = callmethod(opresult2290, "++", 1, partcv, params);
// compiled op node returning opresult2291 (depth = 6)
  *var_s = opresult2291;
  if (opresult2291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2293 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2294 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2295 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2294);
// compiled call node returning call2295 (depth = 7)
// compiled member node returning call2295 (depth = 6)
  gc_frame_newslot(call2295);
// starting to compile block node (depth = 6)
  Object block2296 = alloc_Block(NULL, NULL, "ast", 534);
  gc_frame_newslot(block2296);
// method _apply
  block_savedest(block2296);
  Object closure2297 = createclosure(4, "_apply");
  setclosureframe(closure2297, stackframe);
  addtoclosure(closure2297, var_depth);
  addtoclosure(closure2297, var_spc);
  addtoclosure(closure2297, var_s);
  addtoclosure(closure2297, selfslot);
  struct UserObject *uo2297 = (struct UserObject*)block2296;
  uo2297->data[0] = (Object)closure2297;
  Method *meth_meth_ast__apply2297 = addmethod2pos(block2296, "_apply", &meth_ast__apply2297, 0);
  int argcv_meth_ast__apply2297[] = {1};
  meth_meth_ast__apply2297->type = alloc_MethodType(1, argcv_meth_ast__apply2297);
  meth_meth_ast__apply2297->definitionModule = modulename;
  meth_meth_ast__apply2297->definitionLine = 534;
// compiled block node returning block2296 (depth = 6)
  gc_frame_newslot(block2296);
// call case 5: prelude request
  params[0] = call2295;
  params[1] = block2296;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2328 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2293);
// compiled call node returning call2328 (depth = 5)
    gc_frame_newslot(call2328);
    if2270 = call2328;
  } else {
  }
// compiled if node returning if2270 (depth = 4)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2330 == NULL) {
    strlit2330 = alloc_String("Signature:");
    gc_root(strlit2330);
  }
// compiled string node returning strlit2330 (depth = 6)
  int op_slot_right_2329 = gc_frame_newslot(strlit2330);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2332 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2335 == NULL) {
    strlit2335 = alloc_String("""\x0a""");
    gc_root(strlit2335);
  }
// compiled string node returning strlit2335 (depth = 8)
  int op_slot_right_2334 = gc_frame_newslot(strlit2335);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_2337 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit2339 == NULL) {
    strlit2339 = alloc_String("");
    gc_root(strlit2339);
  }
// compiled string node returning strlit2339 (depth = 9)
  int op_slot_left_2337 = gc_frame_newslot(strlit2339);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2340 = callmethod(strlit2339, "++", 1, partcv, params);
// compiled op node returning opresult2340 (depth = 8)
  int op_slot_left_2334 = gc_frame_newslot(opresult2340);
  params[0] = strlit2335;
  partcv[0] = 1;
  Object opresult2341 = callmethod(opresult2340, "++", 1, partcv, params);
// compiled op node returning opresult2341 (depth = 7)
  int op_slot_left_2332 = gc_frame_newslot(opresult2341);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2342 = callmethod(opresult2341, "++", 1, partcv, params);
// compiled op node returning opresult2342 (depth = 6)
  int op_slot_left_2329 = gc_frame_newslot(opresult2342);
  params[0] = strlit2330;
  partcv[0] = 1;
  Object opresult2343 = callmethod(opresult2342, "++", 1, partcv, params);
// compiled op node returning opresult2343 (depth = 5)
  *var_s = opresult2343;
  if (opresult2343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2345 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2347 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2346);
// compiled call node returning call2347 (depth = 6)
// compiled member node returning call2347 (depth = 5)
  gc_frame_newslot(call2347);
// starting to compile block node (depth = 5)
  Object block2348 = alloc_Block(NULL, NULL, "ast", 539);
  gc_frame_newslot(block2348);
// method _apply
  block_savedest(block2348);
  Object closure2349 = createclosure(4, "_apply");
  setclosureframe(closure2349, stackframe);
  addtoclosure(closure2349, var_depth);
  addtoclosure(closure2349, var_spc);
  addtoclosure(closure2349, var_s);
  addtoclosure(closure2349, selfslot);
  struct UserObject *uo2349 = (struct UserObject*)block2348;
  uo2349->data[0] = (Object)closure2349;
  Method *meth_meth_ast__apply2349 = addmethod2pos(block2348, "_apply", &meth_ast__apply2349, 0);
  int argcv_meth_ast__apply2349[] = {1};
  meth_meth_ast__apply2349->type = alloc_MethodType(1, argcv_meth_ast__apply2349);
  meth_meth_ast__apply2349->definitionModule = modulename;
  meth_meth_ast__apply2349->definitionLine = 539;
// compiled block node returning block2348 (depth = 5)
  gc_frame_newslot(block2348);
// call case 5: prelude request
  params[0] = call2347;
  params[1] = block2348;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2380 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2345);
// compiled call node returning call2380 (depth = 4)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2423(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile index node (depth = 10)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call2425 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2424);
// compiled call node returning call2425 (depth = 12)
// compiled member node returning call2425 (depth = 11)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pnr (depth = 11)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2426 = callmethod(call2425, "[]", 1, partcv, params);
// compiled index node returning idxres2426 (depth = 10)
  *var_p = idxres2426;
  if (idxres2426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2428 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2430 = alloc_Float64(1);
// compiled num node returning num2430 (depth = 13)
  int op_slot_right_2429 = gc_frame_newslot(num2430);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_2429 = gc_frame_newslot(*var_depth);
  params[0] = num2430;
  partcv[0] = 1;
  Object sum2432 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2432 (depth = 12)
  gc_frame_newslot(sum2432);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = sum2432;
  partcv[0] = 1;
  Object call2433 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2428);
// compiled call node returning call2433 (depth = 11)
  int op_slot_right_2427 = gc_frame_newslot(call2433);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2427 = gc_frame_newslot(*var_s);
  params[0] = call2433;
  partcv[0] = 1;
  Object opresult2435 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2435 (depth = 10)
  *var_s = opresult2435;
  if (opresult2435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
  Object bool2440 = alloc_Boolean(0);
// compiled identifier node returning bool2440 (depth = 12)
  int op_slot_right_2439 = gc_frame_newslot(bool2440);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2442 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call2443 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2442);
// compiled call node returning call2443 (depth = 13)
// compiled member node returning call2443 (depth = 12)
  int op_slot_left_2439 = gc_frame_newslot(call2443);
  params[0] = bool2440;
  partcv[0] = 1;
  Object opresult2444 = callmethod(call2443, "!=", 1, partcv, params);
// compiled op node returning opresult2444 (depth = 11)
  int op_slot_right_2438 = gc_frame_newslot(opresult2444);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2447 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_part (depth = 16)
  partcv[0] = 0;
  Object call2449 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2448);
// compiled call node returning call2449 (depth = 15)
// compiled member node returning call2449 (depth = 14)
  partcv[0] = 0;
  Object call2450 = callmethod(call2449, "size",
    1, partcv, params);
  gc_frame_end(callframe2447);
// compiled call node returning call2450 (depth = 13)
// compiled member node returning call2450 (depth = 12)
  int op_slot_right_2446 = gc_frame_newslot(call2450);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_pnr (depth = 12)
  int op_slot_left_2446 = gc_frame_newslot(*var_pnr);
  params[0] = call2450;
  partcv[0] = 1;
  Object opresult2452 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult2452 (depth = 11)
  int op_slot_left_2438 = gc_frame_newslot(opresult2452);
  params[0] = opresult2444;
  partcv[0] = 1;
  Object opresult2453 = callmethod(opresult2452, "||", 1, partcv, params);
// compiled op node returning opresult2453 (depth = 10)
  Object if2437 = done;
  if (istrue(opresult2453)) {
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2455 == NULL) {
    strlit2455 = alloc_String(", ");
    gc_root(strlit2455);
  }
// compiled string node returning strlit2455 (depth = 12)
  int op_slot_right_2454 = gc_frame_newslot(strlit2455);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_2454 = gc_frame_newslot(*var_s);
  params[0] = strlit2455;
  partcv[0] = 1;
  Object opresult2457 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2457 (depth = 11)
  *var_s = opresult2457;
  if (opresult2457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2437 = done;
  } else {
  }
// compiled if node returning if2437 (depth = 9)
  gc_frame_end(frame);
  return if2437;
}
Object meth_ast__apply2387(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call2390 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2389);
// compiled call node returning call2390 (depth = 9)
// compiled member node returning call2390 (depth = 8)
  int op_slot_right_2388 = gc_frame_newslot(call2390);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2388 = gc_frame_newslot(*var_s);
  params[0] = call2390;
  partcv[0] = 1;
  Object opresult2392 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2392 (depth = 7)
  *var_s = opresult2392;
  if (opresult2392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2397 = alloc_Boolean(0);
// compiled identifier node returning bool2397 (depth = 9)
  int op_slot_right_2396 = gc_frame_newslot(bool2397);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2400 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2399);
// compiled call node returning call2400 (depth = 10)
// compiled member node returning call2400 (depth = 9)
  int op_slot_left_2396 = gc_frame_newslot(call2400);
  params[0] = bool2397;
  partcv[0] = 1;
  Object opresult2401 = callmethod(call2400, "!=", 1, partcv, params);
// compiled op node returning opresult2401 (depth = 8)
  int op_slot_right_2395 = gc_frame_newslot(opresult2401);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2404 = alloc_Float64(0);
// compiled num node returning num2404 (depth = 9)
  int op_slot_right_2403 = gc_frame_newslot(num2404);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2406 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call2408 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2407);
// compiled call node returning call2408 (depth = 12)
// compiled member node returning call2408 (depth = 11)
  partcv[0] = 0;
  Object call2409 = callmethod(call2408, "size",
    1, partcv, params);
  gc_frame_end(callframe2406);
// compiled call node returning call2409 (depth = 10)
// compiled member node returning call2409 (depth = 9)
  int op_slot_left_2403 = gc_frame_newslot(call2409);
  params[0] = num2404;
  partcv[0] = 1;
  Object opresult2410 = callmethod(call2409, ">", 1, partcv, params);
// compiled op node returning opresult2410 (depth = 8)
  int op_slot_left_2395 = gc_frame_newslot(opresult2410);
  params[0] = opresult2401;
  partcv[0] = 1;
  Object opresult2411 = callmethod(opresult2410, "||", 1, partcv, params);
// compiled op node returning opresult2411 (depth = 7)
  Object if2394 = done;
  if (istrue(opresult2411)) {
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2413 == NULL) {
    strlit2413 = alloc_String("(");
    gc_root(strlit2413);
  }
// compiled string node returning strlit2413 (depth = 9)
  int op_slot_right_2412 = gc_frame_newslot(strlit2413);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2412 = gc_frame_newslot(*var_s);
  params[0] = strlit2413;
  partcv[0] = 1;
  Object opresult2415 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2415 (depth = 8)
  *var_s = opresult2415;
  if (opresult2415 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2417 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2418 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call2420 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2419);
// compiled call node returning call2420 (depth = 11)
// compiled member node returning call2420 (depth = 10)
  partcv[0] = 0;
  Object call2421 = callmethod(call2420, "indices",
    1, partcv, params);
  gc_frame_end(callframe2418);
// compiled call node returning call2421 (depth = 9)
// compiled member node returning call2421 (depth = 8)
  gc_frame_newslot(call2421);
// starting to compile block node (depth = 8)
  Object block2422 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2422);
// method _apply
  block_savedest(block2422);
  Object closure2423 = createclosure(4, "_apply");
  setclosureframe(closure2423, stackframe);
  addtoclosure(closure2423, var_part);
  addtoclosure(closure2423, var_depth);
  addtoclosure(closure2423, var_s);
  addtoclosure(closure2423, selfslot);
  struct UserObject *uo2423 = (struct UserObject*)block2422;
  uo2423->data[0] = (Object)closure2423;
  Method *meth_meth_ast__apply2423 = addmethod2pos(block2422, "_apply", &meth_ast__apply2423, 0);
  int argcv_meth_ast__apply2423[] = {1};
  meth_meth_ast__apply2423->type = alloc_MethodType(1, argcv_meth_ast__apply2423);
  meth_meth_ast__apply2423->definitionModule = modulename;
  meth_meth_ast__apply2423->definitionLine = 550;
// compiled block node returning block2422 (depth = 8)
  gc_frame_newslot(block2422);
// call case 5: prelude request
  params[0] = call2421;
  params[1] = block2422;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2460 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2417);
// compiled call node returning call2460 (depth = 7)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2463 = alloc_Boolean(0);
// compiled identifier node returning bool2463 (depth = 9)
  int op_slot_right_2462 = gc_frame_newslot(bool2463);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2465 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call2466 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2465);
// compiled call node returning call2466 (depth = 10)
// compiled member node returning call2466 (depth = 9)
  int op_slot_left_2462 = gc_frame_newslot(call2466);
  params[0] = bool2463;
  partcv[0] = 1;
  Object opresult2467 = callmethod(call2466, "!=", 1, partcv, params);
// compiled op node returning opresult2467 (depth = 8)
  Object if2461 = done;
  if (istrue(opresult2467)) {
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2469 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call2471 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2470);
// compiled call node returning call2471 (depth = 13)
// compiled member node returning call2471 (depth = 12)
  partcv[0] = 0;
  Object call2472 = callmethod(call2471, "value",
    1, partcv, params);
  gc_frame_end(callframe2469);
// compiled call node returning call2472 (depth = 11)
// compiled member node returning call2472 (depth = 10)
  int op_slot_right_2468 = gc_frame_newslot(call2472);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2475 == NULL) {
    strlit2475 = alloc_String("*");
    gc_root(strlit2475);
  }
// compiled string node returning strlit2475 (depth = 11)
  int op_slot_right_2474 = gc_frame_newslot(strlit2475);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2474 = gc_frame_newslot(*var_s);
  params[0] = strlit2475;
  partcv[0] = 1;
  Object opresult2477 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2477 (depth = 10)
  int op_slot_left_2468 = gc_frame_newslot(opresult2477);
  params[0] = call2472;
  partcv[0] = 1;
  Object opresult2478 = callmethod(opresult2477, "++", 1, partcv, params);
// compiled op node returning opresult2478 (depth = 9)
  *var_s = opresult2478;
  if (opresult2478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2461 = done;
  } else {
  }
// compiled if node returning if2461 (depth = 7)
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2481 == NULL) {
    strlit2481 = alloc_String(")");
    gc_root(strlit2481);
  }
// compiled string node returning strlit2481 (depth = 9)
  int op_slot_right_2480 = gc_frame_newslot(strlit2481);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2480 = gc_frame_newslot(*var_s);
  params[0] = strlit2481;
  partcv[0] = 1;
  Object opresult2483 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2483 (depth = 8)
  *var_s = opresult2483;
  if (opresult2483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2394 = done;
  } else {
  }
// compiled if node returning if2394 (depth = 6)
  gc_frame_end(frame);
  return if2394;
}
Object meth_ast_toGrace2381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2382 == NULL) {
    strlit2382 = alloc_String("");
    gc_root(strlit2382);
  }
// compiled string node returning strlit2382 (depth = 5)
  *var_s = strlit2382;
  if (strlit2382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2383 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2385 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2384);
// compiled call node returning call2385 (depth = 6)
// compiled member node returning call2385 (depth = 5)
  gc_frame_newslot(call2385);
// starting to compile block node (depth = 5)
  Object block2386 = alloc_Block(NULL, NULL, "ast", 546);
  gc_frame_newslot(block2386);
// method _apply
  block_savedest(block2386);
  Object closure2387 = createclosure(3, "_apply");
  setclosureframe(closure2387, stackframe);
  addtoclosure(closure2387, var_s);
  addtoclosure(closure2387, var_depth);
  addtoclosure(closure2387, selfslot);
  struct UserObject *uo2387 = (struct UserObject*)block2386;
  uo2387->data[0] = (Object)closure2387;
  Method *meth_meth_ast__apply2387 = addmethod2pos(block2386, "_apply", &meth_ast__apply2387, 0);
  int argcv_meth_ast__apply2387[] = {1};
  meth_meth_ast__apply2387->type = alloc_MethodType(1, argcv_meth_ast__apply2387);
  meth_meth_ast__apply2387->definitionModule = modulename;
  meth_meth_ast__apply2387->definitionLine = 546;
// compiled block node returning block2386 (depth = 5)
  gc_frame_newslot(block2386);
// call case 5: prelude request
  params[0] = call2385;
  params[1] = block2386;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2486 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2383);
// compiled call node returning call2486 (depth = 4)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2489 = alloc_Boolean(0);
// compiled identifier node returning bool2489 (depth = 6)
  int op_slot_right_2488 = gc_frame_newslot(bool2489);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2492 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2491);
// compiled call node returning call2492 (depth = 7)
// compiled member node returning call2492 (depth = 6)
  int op_slot_left_2488 = gc_frame_newslot(call2492);
  params[0] = bool2489;
  partcv[0] = 1;
  Object opresult2493 = callmethod(call2492, "!=", 1, partcv, params);
// compiled op node returning opresult2493 (depth = 5)
  Object if2487 = done;
  if (istrue(opresult2493)) {
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2495 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2497 = alloc_Float64(1);
// compiled num node returning num2497 (depth = 9)
  int op_slot_right_2496 = gc_frame_newslot(num2497);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_2496 = gc_frame_newslot(*var_depth);
  params[0] = num2497;
  partcv[0] = 1;
  Object sum2499 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2499 (depth = 8)
  gc_frame_newslot(sum2499);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2500 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2501 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2500);
// compiled call node returning call2501 (depth = 9)
// compiled member node returning call2501 (depth = 8)
  params[0] = sum2499;
  partcv[0] = 1;
  Object call2502 = callmethod(call2501, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2495);
// compiled call node returning call2502 (depth = 7)
  int op_slot_right_2494 = gc_frame_newslot(call2502);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2505 == NULL) {
    strlit2505 = alloc_String(" -> ");
    gc_root(strlit2505);
  }
// compiled string node returning strlit2505 (depth = 8)
  int op_slot_right_2504 = gc_frame_newslot(strlit2505);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2504 = gc_frame_newslot(*var_s);
  params[0] = strlit2505;
  partcv[0] = 1;
  Object opresult2507 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2507 (depth = 7)
  int op_slot_left_2494 = gc_frame_newslot(opresult2507);
  params[0] = call2502;
  partcv[0] = 1;
  Object opresult2508 = callmethod(opresult2507, "++", 1, partcv, params);
// compiled op node returning opresult2508 (depth = 6)
  *var_s = opresult2508;
  if (opresult2508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2487 = done;
  } else {
  }
// compiled if node returning if2487 (depth = 4)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent2510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2511 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe2512 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2513 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2514 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2513);
// compiled call node returning call2514 (depth = 7)
// compiled member node returning call2514 (depth = 6)
  gc_frame_newslot(call2514);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool2515 = alloc_Boolean(0);
// compiled identifier node returning bool2515 (depth = 6)
  gc_frame_newslot(bool2515);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodTypeNode (depth = 6)
  params[0] = call2514;
  params[1] = *var_emptySeq;
  params[2] = bool2515;
  partcv[0] = 3;
  Object call2516 = callmethod(*var_methodTypeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2512);
// compiled call node returning call2516 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2517 = callmethod(call2516, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe2511);
// compiled call node returning call2517 (depth = 4)
  gc_frame_end(frame);
  return call2517;
}
Object meth_ast_new2044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  Object *var_symbolTableNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2045 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2045 = alloc_userobj2(20,17, objclass2045);
  gc_frame_newslot(obj2045);
if (objclass2045 == NULL) {
  glfree(obj2045->class->name);
  obj2045->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2045, self, 0);
  addmethodreal(obj2045,"outer", &reader_ast_outer_2046);
  Object oldself2045 = self;
  struct StackFrameObject *oldstackframe2045 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2045);
  gc_frame_newslot((Object)stackframe);
  self = obj2045;
  Object *oldselfslot2045 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2045 = (*(struct UserObject *)self).data[0], lowerouter2045 = thisouter2045;
  if (inheritingObject2045) {
    struct UserObject *inho2045 = (struct UserObject *)inheritingObject2045;
    while (inho2045->super != GraceDefaultObject) inho2045 = (struct UserObject *)inho2045->super;
    inho2045->super = obj2045;
    self = inheritingObject2045;
    *selfslot = self;
    lowerouter2045 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2045;
  }
if (objclass2045 == NULL) {
  Method *reader2047 = addmethodrealflags(obj2045, "kind",&reader_ast_kind_2047, MFLAG_DEF);
  reader2047->definitionModule = modulename;
  reader2047->definitionLine = 483;
}
adddatum2(obj2045, alloc_Undefined(), 1);
if (objclass2045 == NULL) {
  Method *reader2048 = addmethodrealflags(obj2045, "value",&reader_ast_value_2048, 0);
  Method *writer2048 = addmethodrealflags(obj2045, "value:=",&writer_ast_value_2048, 0);
  reader2048->definitionModule = modulename;
  writer2048->definitionModule = modulename;
  reader2048->definitionLine = 484;
  writer2048->definitionLine = 484;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 2);
if (objclass2045 == NULL) {
  Method *reader2049 = addmethodrealflags(obj2045, "signature",&reader_ast_signature_2049, 0);
  Method *writer2049 = addmethodrealflags(obj2045, "signature:=",&writer_ast_signature_2049, 0);
  reader2049->definitionModule = modulename;
  writer2049->definitionModule = modulename;
  reader2049->definitionLine = 485;
  writer2049->definitionLine = 485;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 3);
if (objclass2045 == NULL) {
  Method *reader2050 = addmethodrealflags(obj2045, "rtype",&reader_ast_rtype_2050, 0);
  Method *writer2050 = addmethodrealflags(obj2045, "rtype:=",&writer_ast_rtype_2050, 0);
  reader2050->definitionModule = modulename;
  writer2050->definitionModule = modulename;
  reader2050->definitionLine = 486;
  writer2050->definitionLine = 486;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 4);
if (objclass2045 == NULL) {
  Method *reader2051 = addmethodrealflags(obj2045, "generics",&reader_ast_generics_2051, 0);
  Method *writer2051 = addmethodrealflags(obj2045, "generics:=",&writer_ast_generics_2051, 0);
  reader2051->definitionModule = modulename;
  writer2051->definitionModule = modulename;
  reader2051->definitionLine = 487;
  writer2051->definitionLine = 487;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 5);
if (objclass2045 == NULL) {
  Method *reader2052 = addmethodrealflags(obj2045, "nameString",&reader_ast_nameString_2052, MFLAG_DEF);
  reader2052->definitionModule = modulename;
  reader2052->definitionLine = 488;
}
adddatum2(obj2045, alloc_Undefined(), 6);
// method asString
  struct UserObject *uo2053 = (struct UserObject*)obj2045;
  uo2053->data[7] = emptyclosure;
  Method *meth_meth_ast_asString2053 = addmethod2pos(obj2045, "asString", &meth_ast_asString2053, 7);
  int argcv_meth_ast_asString2053[] = {0};
  meth_meth_ast_asString2053->type = alloc_MethodType(1, argcv_meth_ast_asString2053);
  meth_meth_ast_asString2053->definitionModule = modulename;
  meth_meth_ast_asString2053->definitionLine = 488;
// method parametersDo
  struct UserObject *uo2073 = (struct UserObject*)obj2045;
  uo2073->data[8] = emptyclosure;
  Method *meth_meth_ast_parametersDo2073 = addmethod2pos(obj2045, "parametersDo", &meth_ast_parametersDo2073, 8);
  int argcv_meth_ast_parametersDo2073[] = {1};
  meth_meth_ast_parametersDo2073->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2073);
  meth_meth_ast_parametersDo2073->definitionModule = modulename;
  meth_meth_ast_parametersDo2073->definitionLine = 490;
// method declarationKind
  struct UserObject *uo2090 = (struct UserObject*)obj2045;
  uo2090->data[9] = emptyclosure;
  Method *meth_meth_ast_declarationKind2090 = addmethod2pos(obj2045, "declarationKind", &meth_ast_declarationKind2090, 9);
  int argcv_meth_ast_declarationKind2090[] = {0};
  meth_meth_ast_declarationKind2090->type = alloc_MethodType(1, argcv_meth_ast_declarationKind2090);
  meth_meth_ast_declarationKind2090->definitionModule = modulename;
  meth_meth_ast_declarationKind2090->definitionLine = 495;
// method typeParametersDo
  struct UserObject *uo2092 = (struct UserObject*)obj2045;
  uo2092->data[10] = emptyclosure;
  Method *meth_meth_ast_typeParametersDo2092 = addmethod2pos(obj2045, "typeParametersDo", &meth_ast_typeParametersDo2092, 10);
  int argcv_meth_ast_typeParametersDo2092[] = {1};
  meth_meth_ast_typeParametersDo2092->type = alloc_MethodType(1, argcv_meth_ast_typeParametersDo2092);
  meth_meth_ast_typeParametersDo2092->definitionModule = modulename;
  meth_meth_ast_typeParametersDo2092->definitionLine = 496;
// method accept()from
  struct UserObject *uo2109 = (struct UserObject*)obj2045;
  uo2109->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2109 = addmethod2pos(obj2045, "accept()from", &meth_ast_accept_40__41_from2109, 11);
  int argcv_meth_ast_accept_40__41_from2109[] = {1, 1};
  meth_meth_ast_accept_40__41_from2109->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2109);
  meth_meth_ast_accept_40__41_from2109->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2109->definitionLine = 501;
// method map()parent
  struct UserObject *uo2142 = (struct UserObject*)obj2045;
  uo2142->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent2142 = addmethod2pos(obj2045, "map()parent", &meth_ast_map_40__41_parent2142, 12);
  int argcv_meth_ast_map_40__41_parent2142[] = {1, 1};
  meth_meth_ast_map_40__41_parent2142->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent2142);
  meth_meth_ast_map_40__41_parent2142->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent2142->definitionLine = 514;
// method pretty
  struct UserObject *uo2178 = (struct UserObject*)obj2045;
  uo2178->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2178 = addmethod2pos(obj2045, "pretty", &meth_ast_pretty2178, 13);
  int argcv_meth_ast_pretty2178[] = {1};
  meth_meth_ast_pretty2178->type = alloc_MethodType(1, argcv_meth_ast_pretty2178);
  meth_meth_ast_pretty2178->definitionModule = modulename;
  meth_meth_ast_pretty2178->definitionLine = 522;
// method toGrace
  struct UserObject *uo2381 = (struct UserObject*)obj2045;
  uo2381->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2381 = addmethod2pos(obj2045, "toGrace", &meth_ast_toGrace2381, 14);
  int argcv_meth_ast_toGrace2381[] = {1};
  meth_meth_ast_toGrace2381->type = alloc_MethodType(1, argcv_meth_ast_toGrace2381);
meth_meth_ast_toGrace2381->type->types[0] = type_Number;
meth_meth_ast_toGrace2381->type->names[0] = "depth";
  meth_meth_ast_toGrace2381->definitionModule = modulename;
  meth_meth_ast_toGrace2381->definitionLine = 544;
// method shallowCopyWithParent
  block_savedest(obj2045);
  Object closure2510 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure2510, stackframe);
  addtoclosure(closure2510, var_emptySeq);
  addtoclosure(closure2510, var_methodTypeNode);
  struct UserObject *uo2510 = (struct UserObject*)obj2045;
  uo2510->data[15] = (Object)closure2510;
  Method *meth_meth_ast_shallowCopyWithParent2510 = addmethod2pos(obj2045, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent2510, 15);
  int argcv_meth_ast_shallowCopyWithParent2510[] = {1};
  meth_meth_ast_shallowCopyWithParent2510->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent2510);
  meth_meth_ast_shallowCopyWithParent2510->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent2510->definitionLine = 568;
  sourceObject = obj2045;
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2518 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2519 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2518);
// compiled call node returning call2519 (depth = 4)
  struct UserObject *obj2045_uo = (struct UserObject *)obj2045;
  obj2045_uo->super = call2519;
  sourceObject = obj2045;
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2520 == NULL) {
    strlit2520 = alloc_String("methodtype");
    gc_root(strlit2520);
  }
// compiled string node returning strlit2520 (depth = 4)
  adddatum2(obj2045, strlit2520, 1);
  sourceObject = obj2045;
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj2045, *var_name_39_, 2);
  sourceObject = obj2045;
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj2045, *var_signature_39_, 3);
  sourceObject = obj2045;
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rtype_39_ (depth = 4)
  adddatum2(obj2045, *var_rtype_39_, 4);
  sourceObject = obj2045;
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2521 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2522 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2523 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2522);
// compiled call node returning call2523 (depth = 7)
// compiled member node returning call2523 (depth = 6)
  partcv[0] = 0;
  Object call2524 = callmethod(call2523, "empty",
    1, partcv, params);
  gc_frame_end(callframe2521);
// compiled call node returning call2524 (depth = 5)
// compiled member node returning call2524 (depth = 4)
  adddatum2(obj2045, call2524, 5);
  sourceObject = obj2045;
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2525 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2526 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2525);
// compiled call node returning call2526 (depth = 5)
// compiled member node returning call2526 (depth = 4)
  adddatum2(obj2045, call2526, 6);
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
objclass2045 = obj2045->class;
  objclass2045->definitionModule = modulename;
  objclass2045->definitionLine = 464;
  (*(struct UserObject *)self).data[0] = lowerouter2045;
  self = oldself2045;
  selfslot = oldselfslot2045;
  stackframe = oldstackframe2045;
  gc_frame_end(frame);
  return obj2045;
}
Object meth_ast_new2044_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_methodTypeNode = getfromclosure(closure, 1);
  Object *var_symbolTableNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2045 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2045 = alloc_userobj2(20,17, objclass2045);
  gc_frame_newslot(obj2045);
if (objclass2045 == NULL) {
  glfree(obj2045->class->name);
  obj2045->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2045, self, 0);
  addmethodreal(obj2045,"outer", &reader_ast_outer_2046);
  Object oldself2045 = self;
  struct StackFrameObject *oldstackframe2045 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2045);
  gc_frame_newslot((Object)stackframe);
  self = obj2045;
  Object *oldselfslot2045 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2045 = (*(struct UserObject *)self).data[0], lowerouter2045 = thisouter2045;
  if (inheritingObject2045) {
    struct UserObject *inho2045 = (struct UserObject *)inheritingObject2045;
    while (inho2045->super != GraceDefaultObject) inho2045 = (struct UserObject *)inho2045->super;
    inho2045->super = obj2045;
    self = inheritingObject2045;
    *selfslot = self;
    lowerouter2045 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2045;
  }
if (objclass2045 == NULL) {
  Method *reader2047 = addmethodrealflags(obj2045, "kind",&reader_ast_kind_2047, MFLAG_DEF);
  reader2047->definitionModule = modulename;
  reader2047->definitionLine = 483;
}
adddatum2(obj2045, alloc_Undefined(), 1);
if (objclass2045 == NULL) {
  Method *reader2048 = addmethodrealflags(obj2045, "value",&reader_ast_value_2048, 0);
  Method *writer2048 = addmethodrealflags(obj2045, "value:=",&writer_ast_value_2048, 0);
  reader2048->definitionModule = modulename;
  writer2048->definitionModule = modulename;
  reader2048->definitionLine = 484;
  writer2048->definitionLine = 484;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 2);
if (objclass2045 == NULL) {
  Method *reader2049 = addmethodrealflags(obj2045, "signature",&reader_ast_signature_2049, 0);
  Method *writer2049 = addmethodrealflags(obj2045, "signature:=",&writer_ast_signature_2049, 0);
  reader2049->definitionModule = modulename;
  writer2049->definitionModule = modulename;
  reader2049->definitionLine = 485;
  writer2049->definitionLine = 485;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 3);
if (objclass2045 == NULL) {
  Method *reader2050 = addmethodrealflags(obj2045, "rtype",&reader_ast_rtype_2050, 0);
  Method *writer2050 = addmethodrealflags(obj2045, "rtype:=",&writer_ast_rtype_2050, 0);
  reader2050->definitionModule = modulename;
  writer2050->definitionModule = modulename;
  reader2050->definitionLine = 486;
  writer2050->definitionLine = 486;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 4);
if (objclass2045 == NULL) {
  Method *reader2051 = addmethodrealflags(obj2045, "generics",&reader_ast_generics_2051, 0);
  Method *writer2051 = addmethodrealflags(obj2045, "generics:=",&writer_ast_generics_2051, 0);
  reader2051->definitionModule = modulename;
  writer2051->definitionModule = modulename;
  reader2051->definitionLine = 487;
  writer2051->definitionLine = 487;
}
obj2045->flags |= OFLAG_MUTABLE;
adddatum2(obj2045, alloc_Undefined(), 5);
if (objclass2045 == NULL) {
  Method *reader2052 = addmethodrealflags(obj2045, "nameString",&reader_ast_nameString_2052, MFLAG_DEF);
  reader2052->definitionModule = modulename;
  reader2052->definitionLine = 488;
}
adddatum2(obj2045, alloc_Undefined(), 6);
// method asString
  struct UserObject *uo2053 = (struct UserObject*)obj2045;
  uo2053->data[7] = emptyclosure;
  Method *meth_meth_ast_asString2053 = addmethod2pos(obj2045, "asString", &meth_ast_asString2053, 7);
  int argcv_meth_ast_asString2053[] = {0};
  meth_meth_ast_asString2053->type = alloc_MethodType(1, argcv_meth_ast_asString2053);
  meth_meth_ast_asString2053->definitionModule = modulename;
  meth_meth_ast_asString2053->definitionLine = 488;
// method parametersDo
  struct UserObject *uo2073 = (struct UserObject*)obj2045;
  uo2073->data[8] = emptyclosure;
  Method *meth_meth_ast_parametersDo2073 = addmethod2pos(obj2045, "parametersDo", &meth_ast_parametersDo2073, 8);
  int argcv_meth_ast_parametersDo2073[] = {1};
  meth_meth_ast_parametersDo2073->type = alloc_MethodType(1, argcv_meth_ast_parametersDo2073);
  meth_meth_ast_parametersDo2073->definitionModule = modulename;
  meth_meth_ast_parametersDo2073->definitionLine = 490;
// method declarationKind
  struct UserObject *uo2090 = (struct UserObject*)obj2045;
  uo2090->data[9] = emptyclosure;
  Method *meth_meth_ast_declarationKind2090 = addmethod2pos(obj2045, "declarationKind", &meth_ast_declarationKind2090, 9);
  int argcv_meth_ast_declarationKind2090[] = {0};
  meth_meth_ast_declarationKind2090->type = alloc_MethodType(1, argcv_meth_ast_declarationKind2090);
  meth_meth_ast_declarationKind2090->definitionModule = modulename;
  meth_meth_ast_declarationKind2090->definitionLine = 495;
// method typeParametersDo
  struct UserObject *uo2092 = (struct UserObject*)obj2045;
  uo2092->data[10] = emptyclosure;
  Method *meth_meth_ast_typeParametersDo2092 = addmethod2pos(obj2045, "typeParametersDo", &meth_ast_typeParametersDo2092, 10);
  int argcv_meth_ast_typeParametersDo2092[] = {1};
  meth_meth_ast_typeParametersDo2092->type = alloc_MethodType(1, argcv_meth_ast_typeParametersDo2092);
  meth_meth_ast_typeParametersDo2092->definitionModule = modulename;
  meth_meth_ast_typeParametersDo2092->definitionLine = 496;
// method accept()from
  struct UserObject *uo2109 = (struct UserObject*)obj2045;
  uo2109->data[11] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2109 = addmethod2pos(obj2045, "accept()from", &meth_ast_accept_40__41_from2109, 11);
  int argcv_meth_ast_accept_40__41_from2109[] = {1, 1};
  meth_meth_ast_accept_40__41_from2109->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2109);
  meth_meth_ast_accept_40__41_from2109->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2109->definitionLine = 501;
// method map()parent
  struct UserObject *uo2142 = (struct UserObject*)obj2045;
  uo2142->data[12] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent2142 = addmethod2pos(obj2045, "map()parent", &meth_ast_map_40__41_parent2142, 12);
  int argcv_meth_ast_map_40__41_parent2142[] = {1, 1};
  meth_meth_ast_map_40__41_parent2142->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent2142);
  meth_meth_ast_map_40__41_parent2142->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent2142->definitionLine = 514;
// method pretty
  struct UserObject *uo2178 = (struct UserObject*)obj2045;
  uo2178->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2178 = addmethod2pos(obj2045, "pretty", &meth_ast_pretty2178, 13);
  int argcv_meth_ast_pretty2178[] = {1};
  meth_meth_ast_pretty2178->type = alloc_MethodType(1, argcv_meth_ast_pretty2178);
  meth_meth_ast_pretty2178->definitionModule = modulename;
  meth_meth_ast_pretty2178->definitionLine = 522;
// method toGrace
  struct UserObject *uo2381 = (struct UserObject*)obj2045;
  uo2381->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2381 = addmethod2pos(obj2045, "toGrace", &meth_ast_toGrace2381, 14);
  int argcv_meth_ast_toGrace2381[] = {1};
  meth_meth_ast_toGrace2381->type = alloc_MethodType(1, argcv_meth_ast_toGrace2381);
meth_meth_ast_toGrace2381->type->types[0] = type_Number;
meth_meth_ast_toGrace2381->type->names[0] = "depth";
  meth_meth_ast_toGrace2381->definitionModule = modulename;
  meth_meth_ast_toGrace2381->definitionLine = 544;
// method shallowCopyWithParent
  block_savedest(obj2045);
  Object closure2510 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure2510, stackframe);
  addtoclosure(closure2510, var_emptySeq);
  addtoclosure(closure2510, var_methodTypeNode);
  struct UserObject *uo2510 = (struct UserObject*)obj2045;
  uo2510->data[15] = (Object)closure2510;
  Method *meth_meth_ast_shallowCopyWithParent2510 = addmethod2pos(obj2045, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent2510, 15);
  int argcv_meth_ast_shallowCopyWithParent2510[] = {1};
  meth_meth_ast_shallowCopyWithParent2510->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent2510);
  meth_meth_ast_shallowCopyWithParent2510->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent2510->definitionLine = 568;
  sourceObject = obj2045;
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2518 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2519 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2518);
// compiled call node returning call2519 (depth = 4)
  struct UserObject *obj2045_uo = (struct UserObject *)obj2045;
  obj2045_uo->super = call2519;
  sourceObject = obj2045;
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2520 == NULL) {
    strlit2520 = alloc_String("methodtype");
    gc_root(strlit2520);
  }
// compiled string node returning strlit2520 (depth = 4)
  adddatum2(obj2045, strlit2520, 1);
  sourceObject = obj2045;
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj2045, *var_name_39_, 2);
  sourceObject = obj2045;
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj2045, *var_signature_39_, 3);
  sourceObject = obj2045;
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_rtype_39_ (depth = 4)
  adddatum2(obj2045, *var_rtype_39_, 4);
  sourceObject = obj2045;
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2521 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2522 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call2523 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2522);
// compiled call node returning call2523 (depth = 7)
// compiled member node returning call2523 (depth = 6)
  partcv[0] = 0;
  Object call2524 = callmethod(call2523, "empty",
    1, partcv, params);
  gc_frame_end(callframe2521);
// compiled call node returning call2524 (depth = 5)
// compiled member node returning call2524 (depth = 4)
  adddatum2(obj2045, call2524, 5);
  sourceObject = obj2045;
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2525 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2526 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2525);
// compiled call node returning call2526 (depth = 5)
// compiled member node returning call2526 (depth = 4)
  adddatum2(obj2045, call2526, 6);
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
  sourceObject = obj2045;
objclass2045 = obj2045->class;
  objclass2045->definitionModule = modulename;
  objclass2045->definitionLine = 464;
  (*(struct UserObject *)self).data[0] = lowerouter2045;
  self = oldself2045;
  selfslot = oldselfslot2045;
  stackframe = oldstackframe2045;
  gc_frame_end(frame);
  return obj2045;
}
Object meth_ast_typeLiteralNode2528(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeLiteralNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeLiteralNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeLiteralNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeLiteralNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeLiteralNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeLiteralNode;
}
Object meth_ast_name2540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2541 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2542 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2541);
// compiled call node returning call2542 (depth = 5)
// compiled member node returning call2542 (depth = 4)
  gc_frame_end(frame);
  return call2542;
}
Object meth_ast_name_58__61_2543(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method name:=");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for name:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for name:=");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2544 = gc_frame_new();
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2545 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2544);
// compiled call node returning call2545 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2546 = gc_frame_new();
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool2547 = alloc_Boolean(0);
// compiled identifier node returning bool2547 (depth = 6)
  gc_frame_newslot(bool2547);
// call case 4: self request
  params[0] = bool2547;
  partcv[0] = 1;
  Object call2548 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2546);
// compiled call node returning call2548 (depth = 5)
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString2549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2551 == NULL) {
    strlit2551 = alloc_String("");
    gc_root(strlit2551);
  }
// compiled string node returning strlit2551 (depth = 5)
  int op_slot_right_2550 = gc_frame_newslot(strlit2551);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2554 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2555 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2554);
// compiled call node returning call2555 (depth = 7)
// compiled member node returning call2555 (depth = 6)
  int op_slot_right_2553 = gc_frame_newslot(call2555);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2558 == NULL) {
    strlit2558 = alloc_String(", types = ");
    gc_root(strlit2558);
  }
// compiled string node returning strlit2558 (depth = 7)
  int op_slot_right_2557 = gc_frame_newslot(strlit2558);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2561 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2562 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2561);
// compiled call node returning call2562 (depth = 9)
// compiled member node returning call2562 (depth = 8)
  int op_slot_right_2560 = gc_frame_newslot(call2562);
// starting to compile string node (depth = 8)
  if (strlit2564 == NULL) {
    strlit2564 = alloc_String("TypeLiteral: methods = ");
    gc_root(strlit2564);
  }
// compiled string node returning strlit2564 (depth = 8)
  int op_slot_left_2560 = gc_frame_newslot(strlit2564);
  params[0] = call2562;
  partcv[0] = 1;
  Object opresult2565 = callmethod(strlit2564, "++", 1, partcv, params);
// compiled op node returning opresult2565 (depth = 7)
  int op_slot_left_2557 = gc_frame_newslot(opresult2565);
  params[0] = strlit2558;
  partcv[0] = 1;
  Object opresult2566 = callmethod(opresult2565, "++", 1, partcv, params);
// compiled op node returning opresult2566 (depth = 6)
  int op_slot_left_2553 = gc_frame_newslot(opresult2566);
  params[0] = call2555;
  partcv[0] = 1;
  Object opresult2567 = callmethod(opresult2566, "++", 1, partcv, params);
// compiled op node returning opresult2567 (depth = 5)
  int op_slot_left_2550 = gc_frame_newslot(opresult2567);
  params[0] = strlit2551;
  partcv[0] = 1;
  Object opresult2568 = callmethod(opresult2567, "++", 1, partcv, params);
// compiled op node returning opresult2568 (depth = 4)
  gc_frame_end(frame);
  return opresult2568;
}
Object meth_ast__apply2577(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2578 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2579 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2578);
// compiled call node returning call2579 (depth = 7)
  gc_frame_end(frame);
  return call2579;
}
Object meth_ast__apply2586(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2587 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2588 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2587);
// compiled call node returning call2588 (depth = 7)
  gc_frame_end(frame);
  return call2588;
}
Object meth_ast_accept_40__41_from2569(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2571 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2572 = callmethod(*var_visitor, "visitTypeLiteral()up",
    2, partcv, params);
  gc_frame_end(callframe2571);
// compiled call node returning call2572 (depth = 5)
  Object if2570 = done;
  if (istrue(call2572)) {
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2573 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2575 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2574);
// compiled call node returning call2575 (depth = 7)
// compiled member node returning call2575 (depth = 6)
  gc_frame_newslot(call2575);
// starting to compile block node (depth = 6)
  Object block2576 = alloc_Block(NULL, NULL, "ast", 591);
  gc_frame_newslot(block2576);
// method _apply
  block_savedest(block2576);
  Object closure2577 = createclosure(2, "_apply");
  setclosureframe(closure2577, stackframe);
  addtoclosure(closure2577, var_visitor);
  addtoclosure(closure2577, selfslot);
  struct UserObject *uo2577 = (struct UserObject*)block2576;
  uo2577->data[0] = (Object)closure2577;
  Method *meth_meth_ast__apply2577 = addmethod2pos(block2576, "_apply", &meth_ast__apply2577, 0);
  int argcv_meth_ast__apply2577[] = {1};
  meth_meth_ast__apply2577->type = alloc_MethodType(1, argcv_meth_ast__apply2577);
  meth_meth_ast__apply2577->definitionModule = modulename;
  meth_meth_ast__apply2577->definitionLine = 591;
// compiled block node returning block2576 (depth = 6)
  gc_frame_newslot(block2576);
// call case 5: prelude request
  params[0] = call2575;
  params[1] = block2576;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2581 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2573);
// compiled call node returning call2581 (depth = 5)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2582 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2583 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2584 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2583);
// compiled call node returning call2584 (depth = 7)
// compiled member node returning call2584 (depth = 6)
  gc_frame_newslot(call2584);
// starting to compile block node (depth = 6)
  Object block2585 = alloc_Block(NULL, NULL, "ast", 594);
  gc_frame_newslot(block2585);
// method _apply
  block_savedest(block2585);
  Object closure2586 = createclosure(2, "_apply");
  setclosureframe(closure2586, stackframe);
  addtoclosure(closure2586, var_visitor);
  addtoclosure(closure2586, selfslot);
  struct UserObject *uo2586 = (struct UserObject*)block2585;
  uo2586->data[0] = (Object)closure2586;
  Method *meth_meth_ast__apply2586 = addmethod2pos(block2585, "_apply", &meth_ast__apply2586, 0);
  int argcv_meth_ast__apply2586[] = {1};
  meth_meth_ast__apply2586->type = alloc_MethodType(1, argcv_meth_ast__apply2586);
  meth_meth_ast__apply2586->definitionModule = modulename;
  meth_meth_ast__apply2586->definitionLine = 594;
// compiled block node returning block2585 (depth = 6)
  gc_frame_newslot(block2585);
// call case 5: prelude request
  params[0] = call2584;
  params[1] = block2585;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2590 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2582);
// compiled call node returning call2590 (depth = 5)
    gc_frame_newslot(call2590);
    if2570 = call2590;
  } else {
  }
// compiled if node returning if2570 (depth = 4)
  gc_frame_end(frame);
  return if2570;
}
Object meth_ast_map_40__41_parent2591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2592 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call2593 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2592);
// compiled call node returning call2593 (depth = 5)
  *var_n = call2593;
  if (call2593 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2594 = gc_frame_new();
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2595 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2596 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2597 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2596);
// compiled call node returning call2597 (depth = 8)
// compiled member node returning call2597 (depth = 7)
  gc_frame_newslot(call2597);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2598 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2599 = gc_frame_new();
// call case 3: self.outer request
  Object call2600 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2599);
// compiled call node returning call2600 (depth = 10)
// compiled member node returning call2600 (depth = 9)
  partcv[0] = 0;
  Object call2601 = callmethodflags(call2600, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2598);
// compiled call node returning call2601 (depth = 8)
// compiled member node returning call2601 (depth = 7)
  params[0] = call2597;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2602 = callmethodflags(call2601, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2595);
// compiled call node returning call2602 (depth = 6)
  gc_frame_newslot(call2602);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2602;
  partcv[0] = 1;
  Object call2603 = callmethod(*var_n, "methods:=",
    1, partcv, params);
  gc_frame_end(callframe2594);
// compiled call node returning call2603 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2604 = gc_frame_new();
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2605 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2607 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2606);
// compiled call node returning call2607 (depth = 8)
// compiled member node returning call2607 (depth = 7)
  gc_frame_newslot(call2607);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2608 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2609 = gc_frame_new();
// call case 3: self.outer request
  Object call2610 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2609);
// compiled call node returning call2610 (depth = 10)
// compiled member node returning call2610 (depth = 9)
  partcv[0] = 0;
  Object call2611 = callmethodflags(call2610, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2608);
// compiled call node returning call2611 (depth = 8)
// compiled member node returning call2611 (depth = 7)
  params[0] = call2607;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2612 = callmethodflags(call2611, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2605);
// compiled call node returning call2612 (depth = 6)
  gc_frame_newslot(call2612);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2612;
  partcv[0] = 1;
  Object call2613 = callmethod(*var_n, "types:=",
    1, partcv, params);
  gc_frame_end(callframe2604);
// compiled call node returning call2613 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2614 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2615 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2614);
// compiled call node returning call2615 (depth = 5)
  *var_n = call2615;
  if (call2615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply2625(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2627 == NULL) {
    strlit2627 = alloc_String("  ");
    gc_root(strlit2627);
  }
// compiled string node returning strlit2627 (depth = 8)
  int op_slot_right_2626 = gc_frame_newslot(strlit2627);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2626 = gc_frame_newslot(*var_spc);
  params[0] = strlit2627;
  partcv[0] = 1;
  Object opresult2629 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2629 (depth = 7)
  *var_spc = opresult2629;
  if (opresult2629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2655(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2657 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2659 = alloc_Float64(2);
// compiled num node returning num2659 (depth = 10)
  int op_slot_right_2658 = gc_frame_newslot(num2659);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2658 = gc_frame_newslot(*var_depth);
  params[0] = num2659;
  partcv[0] = 1;
  Object sum2661 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2661 (depth = 9)
  gc_frame_newslot(sum2661);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum2661;
  partcv[0] = 1;
  Object call2662 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2657);
// compiled call node returning call2662 (depth = 8)
  int op_slot_right_2656 = gc_frame_newslot(call2662);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2664 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2667 == NULL) {
    strlit2667 = alloc_String("""\x0a""  ");
    gc_root(strlit2667);
  }
// compiled string node returning strlit2667 (depth = 10)
  int op_slot_right_2666 = gc_frame_newslot(strlit2667);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2666 = gc_frame_newslot(*var_s);
  params[0] = strlit2667;
  partcv[0] = 1;
  Object opresult2669 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2669 (depth = 9)
  int op_slot_left_2664 = gc_frame_newslot(opresult2669);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2670 = callmethod(opresult2669, "++", 1, partcv, params);
// compiled op node returning opresult2670 (depth = 8)
  int op_slot_left_2656 = gc_frame_newslot(opresult2670);
  params[0] = call2662;
  partcv[0] = 1;
  Object opresult2671 = callmethod(opresult2670, "++", 1, partcv, params);
// compiled op node returning opresult2671 (depth = 7)
  *var_s = opresult2671;
  if (opresult2671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2691(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2693 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2695 = alloc_Float64(2);
// compiled num node returning num2695 (depth = 10)
  int op_slot_right_2694 = gc_frame_newslot(num2695);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2694 = gc_frame_newslot(*var_depth);
  params[0] = num2695;
  partcv[0] = 1;
  Object sum2697 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2697 (depth = 9)
  gc_frame_newslot(sum2697);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum2697;
  partcv[0] = 1;
  Object call2698 = callmethod(*var_each, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2693);
// compiled call node returning call2698 (depth = 8)
  int op_slot_right_2692 = gc_frame_newslot(call2698);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_2700 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2703 == NULL) {
    strlit2703 = alloc_String("""\x0a""  ");
    gc_root(strlit2703);
  }
// compiled string node returning strlit2703 (depth = 10)
  int op_slot_right_2702 = gc_frame_newslot(strlit2703);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2702 = gc_frame_newslot(*var_s);
  params[0] = strlit2703;
  partcv[0] = 1;
  Object opresult2705 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2705 (depth = 9)
  int op_slot_left_2700 = gc_frame_newslot(opresult2705);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2706 = callmethod(opresult2705, "++", 1, partcv, params);
// compiled op node returning opresult2706 (depth = 8)
  int op_slot_left_2692 = gc_frame_newslot(opresult2706);
  params[0] = call2698;
  partcv[0] = 1;
  Object opresult2707 = callmethod(opresult2706, "++", 1, partcv, params);
// compiled op node returning opresult2707 (depth = 7)
  *var_s = opresult2707;
  if (opresult2707 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2618 == NULL) {
    strlit2618 = alloc_String("");
    gc_root(strlit2618);
  }
// compiled string node returning strlit2618 (depth = 5)
  *var_spc = strlit2618;
  if (strlit2618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2619 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_2620 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num2622 = alloc_Float64(0);
// compiled num node returning num2622 (depth = 6)
  int op_slot_left_2620 = gc_frame_newslot(num2622);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2623 = callmethod(num2622, "..", 1, partcv, params);
// compiled op node returning opresult2623 (depth = 5)
  gc_frame_newslot(opresult2623);
// starting to compile block node (depth = 5)
  Object block2624 = alloc_Block(NULL, NULL, "ast", 608);
  gc_frame_newslot(block2624);
// method _apply
  block_savedest(block2624);
  Object closure2625 = createclosure(2, "_apply");
  setclosureframe(closure2625, stackframe);
  addtoclosure(closure2625, var_spc);
  addtoclosure(closure2625, selfslot);
  struct UserObject *uo2625 = (struct UserObject*)block2624;
  uo2625->data[0] = (Object)closure2625;
  Method *meth_meth_ast__apply2625 = addmethod2pos(block2624, "_apply", &meth_ast__apply2625, 0);
  int argcv_meth_ast__apply2625[] = {1};
  meth_meth_ast__apply2625->type = alloc_MethodType(1, argcv_meth_ast__apply2625);
  meth_meth_ast__apply2625->definitionModule = modulename;
  meth_meth_ast__apply2625->definitionLine = 602;
// compiled block node returning block2624 (depth = 5)
  gc_frame_newslot(block2624);
// call case 5: prelude request
  params[0] = opresult2623;
  params[1] = block2624;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2632 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2619);
// compiled call node returning call2632 (depth = 4)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2634 == NULL) {
    strlit2634 = alloc_String("""\x0a""");
    gc_root(strlit2634);
  }
// compiled string node returning strlit2634 (depth = 6)
  int op_slot_right_2633 = gc_frame_newslot(strlit2634);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2637 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call2638 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2637);
// compiled call node returning call2638 (depth = 7)
  int op_slot_right_2636 = gc_frame_newslot(call2638);
// starting to compile string node (depth = 7)
  if (strlit2640 == NULL) {
    strlit2640 = alloc_String("");
    gc_root(strlit2640);
  }
// compiled string node returning strlit2640 (depth = 7)
  int op_slot_left_2636 = gc_frame_newslot(strlit2640);
  params[0] = call2638;
  partcv[0] = 1;
  Object opresult2641 = callmethod(strlit2640, "++", 1, partcv, params);
// compiled op node returning opresult2641 (depth = 6)
  int op_slot_left_2633 = gc_frame_newslot(opresult2641);
  params[0] = strlit2634;
  partcv[0] = 1;
  Object opresult2642 = callmethod(opresult2641, "++", 1, partcv, params);
// compiled op node returning opresult2642 (depth = 5)
  *var_s = opresult2642;
  if (opresult2642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2644 == NULL) {
    strlit2644 = alloc_String("Types:");
    gc_root(strlit2644);
  }
// compiled string node returning strlit2644 (depth = 6)
  int op_slot_right_2643 = gc_frame_newslot(strlit2644);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2646 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2646 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2648 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2648 (depth = 6)
  int op_slot_left_2643 = gc_frame_newslot(opresult2648);
  params[0] = strlit2644;
  partcv[0] = 1;
  Object opresult2649 = callmethod(opresult2648, "++", 1, partcv, params);
// compiled op node returning opresult2649 (depth = 5)
  *var_s = opresult2649;
  if (opresult2649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2651 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2652 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2653 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2652);
// compiled call node returning call2653 (depth = 6)
// compiled member node returning call2653 (depth = 5)
  gc_frame_newslot(call2653);
// starting to compile block node (depth = 5)
  Object block2654 = alloc_Block(NULL, NULL, "ast", 613);
  gc_frame_newslot(block2654);
// method _apply
  block_savedest(block2654);
  Object closure2655 = createclosure(4, "_apply");
  setclosureframe(closure2655, stackframe);
  addtoclosure(closure2655, var_depth);
  addtoclosure(closure2655, var_spc);
  addtoclosure(closure2655, var_s);
  addtoclosure(closure2655, selfslot);
  struct UserObject *uo2655 = (struct UserObject*)block2654;
  uo2655->data[0] = (Object)closure2655;
  Method *meth_meth_ast__apply2655 = addmethod2pos(block2654, "_apply", &meth_ast__apply2655, 0);
  int argcv_meth_ast__apply2655[] = {1};
  meth_meth_ast__apply2655->type = alloc_MethodType(1, argcv_meth_ast__apply2655);
  meth_meth_ast__apply2655->definitionModule = modulename;
  meth_meth_ast__apply2655->definitionLine = 613;
// compiled block node returning block2654 (depth = 5)
  gc_frame_newslot(block2654);
// call case 5: prelude request
  params[0] = call2653;
  params[1] = block2654;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2674 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2651);
// compiled call node returning call2674 (depth = 4)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2676 == NULL) {
    strlit2676 = alloc_String("Methods:");
    gc_root(strlit2676);
  }
// compiled string node returning strlit2676 (depth = 6)
  int op_slot_right_2675 = gc_frame_newslot(strlit2676);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_2678 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2681 == NULL) {
    strlit2681 = alloc_String("""\x0a""");
    gc_root(strlit2681);
  }
// compiled string node returning strlit2681 (depth = 8)
  int op_slot_right_2680 = gc_frame_newslot(strlit2681);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_2680 = gc_frame_newslot(*var_s);
  params[0] = strlit2681;
  partcv[0] = 1;
  Object opresult2683 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2683 (depth = 7)
  int op_slot_left_2678 = gc_frame_newslot(opresult2683);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2684 = callmethod(opresult2683, "++", 1, partcv, params);
// compiled op node returning opresult2684 (depth = 6)
  int op_slot_left_2675 = gc_frame_newslot(opresult2684);
  params[0] = strlit2676;
  partcv[0] = 1;
  Object opresult2685 = callmethod(opresult2684, "++", 1, partcv, params);
// compiled op node returning opresult2685 (depth = 5)
  *var_s = opresult2685;
  if (opresult2685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2687 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2688 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2689 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2688);
// compiled call node returning call2689 (depth = 6)
// compiled member node returning call2689 (depth = 5)
  gc_frame_newslot(call2689);
// starting to compile block node (depth = 5)
  Object block2690 = alloc_Block(NULL, NULL, "ast", 617);
  gc_frame_newslot(block2690);
// method _apply
  block_savedest(block2690);
  Object closure2691 = createclosure(4, "_apply");
  setclosureframe(closure2691, stackframe);
  addtoclosure(closure2691, var_depth);
  addtoclosure(closure2691, var_spc);
  addtoclosure(closure2691, var_s);
  addtoclosure(closure2691, selfslot);
  struct UserObject *uo2691 = (struct UserObject*)block2690;
  uo2691->data[0] = (Object)closure2691;
  Method *meth_meth_ast__apply2691 = addmethod2pos(block2690, "_apply", &meth_ast__apply2691, 0);
  int argcv_meth_ast__apply2691[] = {1};
  meth_meth_ast__apply2691->type = alloc_MethodType(1, argcv_meth_ast__apply2691);
  meth_meth_ast__apply2691->definitionModule = modulename;
  meth_meth_ast__apply2691->definitionLine = 617;
// compiled block node returning block2690 (depth = 5)
  gc_frame_newslot(block2690);
// call case 5: prelude request
  params[0] = call2689;
  params[1] = block2690;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2710 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2687);
// compiled call node returning call2710 (depth = 4)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2712 == NULL) {
    strlit2712 = alloc_String("""\x0a""");
    gc_root(strlit2712);
  }
// compiled string node returning strlit2712 (depth = 6)
  int op_slot_right_2711 = gc_frame_newslot(strlit2712);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2711 = gc_frame_newslot(*var_s);
  params[0] = strlit2712;
  partcv[0] = 1;
  Object opresult2714 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2714 (depth = 5)
  *var_s = opresult2714;
  if (opresult2714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2728(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("    ");
    gc_root(strlit2730);
  }
// compiled string node returning strlit2730 (depth = 8)
  int op_slot_right_2729 = gc_frame_newslot(strlit2730);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_2729 = gc_frame_newslot(*var_spc);
  params[0] = strlit2730;
  partcv[0] = 1;
  Object opresult2732 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult2732 (depth = 7)
  *var_spc = opresult2732;
  if (opresult2732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2757(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2759 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2761 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2760);
// compiled call node returning call2761 (depth = 13)
// compiled member node returning call2761 (depth = 12)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2762 = callmethod(call2761, "[]", 1, partcv, params);
// compiled index node returning idxres2762 (depth = 11)
  partcv[0] = 0;
  Object call2763 = callmethod(idxres2762, "value",
    1, partcv, params);
  gc_frame_end(callframe2759);
// compiled call node returning call2763 (depth = 10)
// compiled member node returning call2763 (depth = 9)
  int op_slot_right_2758 = gc_frame_newslot(call2763);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_2758 = gc_frame_newslot(*var_s);
  params[0] = call2763;
  partcv[0] = 1;
  Object opresult2765 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2765 (depth = 8)
  *var_s = opresult2765;
  if (opresult2765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2769 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2770 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2771 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2770);
// compiled call node returning call2771 (depth = 12)
// compiled member node returning call2771 (depth = 11)
  partcv[0] = 0;
  Object call2772 = callmethod(call2771, "size",
    1, partcv, params);
  gc_frame_end(callframe2769);
// compiled call node returning call2772 (depth = 10)
// compiled member node returning call2772 (depth = 9)
  int op_slot_right_2768 = gc_frame_newslot(call2772);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_2768 = gc_frame_newslot(*var_i);
  params[0] = call2772;
  partcv[0] = 1;
  Object opresult2774 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult2774 (depth = 8)
  Object if2767 = done;
  if (istrue(opresult2774)) {
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2776 == NULL) {
    strlit2776 = alloc_String(", ");
    gc_root(strlit2776);
  }
// compiled string node returning strlit2776 (depth = 10)
  int op_slot_right_2775 = gc_frame_newslot(strlit2776);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_2775 = gc_frame_newslot(*var_s);
  params[0] = strlit2776;
  partcv[0] = 1;
  Object opresult2778 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2778 (depth = 9)
  *var_s = opresult2778;
  if (opresult2778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2767 = done;
  } else {
  }
// compiled if node returning if2767 (depth = 7)
  gc_frame_end(frame);
  return if2767;
}
Object meth_ast__apply2796(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2798 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2800 = alloc_Float64(1);
// compiled num node returning num2800 (depth = 10)
  int op_slot_right_2799 = gc_frame_newslot(num2800);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2799 = gc_frame_newslot(*var_depth);
  params[0] = num2800;
  partcv[0] = 1;
  Object sum2802 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2802 (depth = 9)
  gc_frame_newslot(sum2802);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum2802;
  partcv[0] = 1;
  Object call2803 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2798);
// compiled call node returning call2803 (depth = 8)
  int op_slot_right_2797 = gc_frame_newslot(call2803);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2806 == NULL) {
    strlit2806 = alloc_String("    ");
    gc_root(strlit2806);
  }
// compiled string node returning strlit2806 (depth = 9)
  int op_slot_right_2805 = gc_frame_newslot(strlit2806);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2808 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2811 == NULL) {
    strlit2811 = alloc_String("""\x0a""");
    gc_root(strlit2811);
  }
// compiled string node returning strlit2811 (depth = 11)
  int op_slot_right_2810 = gc_frame_newslot(strlit2811);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2810 = gc_frame_newslot(*var_s);
  params[0] = strlit2811;
  partcv[0] = 1;
  Object opresult2813 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2813 (depth = 10)
  int op_slot_left_2808 = gc_frame_newslot(opresult2813);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2814 = callmethod(opresult2813, "++", 1, partcv, params);
// compiled op node returning opresult2814 (depth = 9)
  int op_slot_left_2805 = gc_frame_newslot(opresult2814);
  params[0] = strlit2806;
  partcv[0] = 1;
  Object opresult2815 = callmethod(opresult2814, "++", 1, partcv, params);
// compiled op node returning opresult2815 (depth = 8)
  int op_slot_left_2797 = gc_frame_newslot(opresult2815);
  params[0] = call2803;
  partcv[0] = 1;
  Object opresult2816 = callmethod(opresult2815, "++", 1, partcv, params);
// compiled op node returning opresult2816 (depth = 7)
  *var_s = opresult2816;
  if (opresult2816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2824(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2826 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2828 = alloc_Float64(1);
// compiled num node returning num2828 (depth = 10)
  int op_slot_right_2827 = gc_frame_newslot(num2828);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_2827 = gc_frame_newslot(*var_depth);
  params[0] = num2828;
  partcv[0] = 1;
  Object sum2830 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum2830 (depth = 9)
  gc_frame_newslot(sum2830);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  params[0] = sum2830;
  partcv[0] = 1;
  Object call2831 = callmethod(*var_each, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2826);
// compiled call node returning call2831 (depth = 8)
  int op_slot_right_2825 = gc_frame_newslot(call2831);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2834 == NULL) {
    strlit2834 = alloc_String("    ");
    gc_root(strlit2834);
  }
// compiled string node returning strlit2834 (depth = 9)
  int op_slot_right_2833 = gc_frame_newslot(strlit2834);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_2836 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2839 == NULL) {
    strlit2839 = alloc_String("""\x0a""");
    gc_root(strlit2839);
  }
// compiled string node returning strlit2839 (depth = 11)
  int op_slot_right_2838 = gc_frame_newslot(strlit2839);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_2838 = gc_frame_newslot(*var_s);
  params[0] = strlit2839;
  partcv[0] = 1;
  Object opresult2841 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2841 (depth = 10)
  int op_slot_left_2836 = gc_frame_newslot(opresult2841);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2842 = callmethod(opresult2841, "++", 1, partcv, params);
// compiled op node returning opresult2842 (depth = 9)
  int op_slot_left_2833 = gc_frame_newslot(opresult2842);
  params[0] = strlit2834;
  partcv[0] = 1;
  Object opresult2843 = callmethod(opresult2842, "++", 1, partcv, params);
// compiled op node returning opresult2843 (depth = 8)
  int op_slot_left_2825 = gc_frame_newslot(opresult2843);
  params[0] = call2831;
  partcv[0] = 1;
  Object opresult2844 = callmethod(opresult2843, "++", 1, partcv, params);
// compiled op node returning opresult2844 (depth = 7)
  *var_s = opresult2844;
  if (opresult2844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2716(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2717 == NULL) {
    strlit2717 = alloc_String("");
    gc_root(strlit2717);
  }
// compiled string node returning strlit2717 (depth = 5)
  *var_spc = strlit2717;
  if (strlit2717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2718 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2721 = alloc_Float64(1);
// compiled num node returning num2721 (depth = 7)
  int op_slot_right_2720 = gc_frame_newslot(num2721);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_2720 = gc_frame_newslot(*var_depth);
  params[0] = num2721;
  partcv[0] = 1;
  Object diff2723 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff2723 (depth = 6)
  int op_slot_right_2719 = gc_frame_newslot(diff2723);
// starting to compile num node (depth = 6)
  Object num2725 = alloc_Float64(0);
// compiled num node returning num2725 (depth = 6)
  int op_slot_left_2719 = gc_frame_newslot(num2725);
  params[0] = diff2723;
  partcv[0] = 1;
  Object opresult2726 = callmethod(num2725, "..", 1, partcv, params);
// compiled op node returning opresult2726 (depth = 5)
  gc_frame_newslot(opresult2726);
// starting to compile block node (depth = 5)
  Object block2727 = alloc_Block(NULL, NULL, "ast", 625);
  gc_frame_newslot(block2727);
// method _apply
  block_savedest(block2727);
  Object closure2728 = createclosure(2, "_apply");
  setclosureframe(closure2728, stackframe);
  addtoclosure(closure2728, var_spc);
  addtoclosure(closure2728, selfslot);
  struct UserObject *uo2728 = (struct UserObject*)block2727;
  uo2728->data[0] = (Object)closure2728;
  Method *meth_meth_ast__apply2728 = addmethod2pos(block2727, "_apply", &meth_ast__apply2728, 0);
  int argcv_meth_ast__apply2728[] = {1};
  meth_meth_ast__apply2728->type = alloc_MethodType(1, argcv_meth_ast__apply2728);
  meth_meth_ast__apply2728->definitionModule = modulename;
  meth_meth_ast__apply2728->definitionLine = 617;
// compiled block node returning block2727 (depth = 5)
  gc_frame_newslot(block2727);
// call case 5: prelude request
  params[0] = opresult2726;
  params[1] = block2727;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2735 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2718);
// compiled call node returning call2735 (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2736 == NULL) {
    strlit2736 = alloc_String("type");
    gc_root(strlit2736);
  }
// compiled string node returning strlit2736 (depth = 5)
  *var_s = strlit2736;
  if (strlit2736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2739 = alloc_Float64(0);
// compiled num node returning num2739 (depth = 6)
  int op_slot_right_2738 = gc_frame_newslot(num2739);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2741 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2742 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2743 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2742);
// compiled call node returning call2743 (depth = 9)
// compiled member node returning call2743 (depth = 8)
  partcv[0] = 0;
  Object call2744 = callmethod(call2743, "size",
    1, partcv, params);
  gc_frame_end(callframe2741);
// compiled call node returning call2744 (depth = 7)
// compiled member node returning call2744 (depth = 6)
  int op_slot_left_2738 = gc_frame_newslot(call2744);
  params[0] = num2739;
  partcv[0] = 1;
  Object opresult2745 = callmethod(call2744, ">", 1, partcv, params);
// compiled op node returning opresult2745 (depth = 5)
  Object if2737 = done;
  if (istrue(opresult2745)) {
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit2747 == NULL) {
    strlit2747 = alloc_String("<");
    gc_root(strlit2747);
  }
// compiled string node returning strlit2747 (depth = 7)
  int op_slot_right_2746 = gc_frame_newslot(strlit2747);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2746 = gc_frame_newslot(*var_s);
  params[0] = strlit2747;
  partcv[0] = 1;
  Object opresult2749 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2749 (depth = 6)
  *var_s = opresult2749;
  if (opresult2749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2751 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2752 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2753 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2754 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2753);
// compiled call node returning call2754 (depth = 9)
// compiled member node returning call2754 (depth = 8)
  partcv[0] = 0;
  Object call2755 = callmethod(call2754, "indices",
    1, partcv, params);
  gc_frame_end(callframe2752);
// compiled call node returning call2755 (depth = 7)
// compiled member node returning call2755 (depth = 6)
  gc_frame_newslot(call2755);
// starting to compile block node (depth = 6)
  Object block2756 = alloc_Block(NULL, NULL, "ast", 631);
  gc_frame_newslot(block2756);
// method _apply
  block_savedest(block2756);
  Object closure2757 = createclosure(2, "_apply");
  setclosureframe(closure2757, stackframe);
  addtoclosure(closure2757, var_s);
  addtoclosure(closure2757, selfslot);
  struct UserObject *uo2757 = (struct UserObject*)block2756;
  uo2757->data[0] = (Object)closure2757;
  Method *meth_meth_ast__apply2757 = addmethod2pos(block2756, "_apply", &meth_ast__apply2757, 0);
  int argcv_meth_ast__apply2757[] = {1};
  meth_meth_ast__apply2757->type = alloc_MethodType(1, argcv_meth_ast__apply2757);
  meth_meth_ast__apply2757->definitionModule = modulename;
  meth_meth_ast__apply2757->definitionLine = 631;
// compiled block node returning block2756 (depth = 6)
  gc_frame_newslot(block2756);
// call case 5: prelude request
  params[0] = call2755;
  params[1] = block2756;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2781 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2751);
// compiled call node returning call2781 (depth = 5)
// Begin line 638
  setline(638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit2783 == NULL) {
    strlit2783 = alloc_String(">");
    gc_root(strlit2783);
  }
// compiled string node returning strlit2783 (depth = 7)
  int op_slot_right_2782 = gc_frame_newslot(strlit2783);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_2782 = gc_frame_newslot(*var_s);
  params[0] = strlit2783;
  partcv[0] = 1;
  Object opresult2785 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2785 (depth = 6)
  *var_s = opresult2785;
  if (opresult2785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2737 = done;
  } else {
  }
// compiled if node returning if2737 (depth = 4)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2788 == NULL) {
    strlit2788 = alloc_String(" = {");
    gc_root(strlit2788);
  }
// compiled string node returning strlit2788 (depth = 6)
  int op_slot_right_2787 = gc_frame_newslot(strlit2788);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2787 = gc_frame_newslot(*var_s);
  params[0] = strlit2788;
  partcv[0] = 1;
  Object opresult2790 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2790 (depth = 5)
  *var_s = opresult2790;
  if (opresult2790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2792 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2794 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2793);
// compiled call node returning call2794 (depth = 6)
// compiled member node returning call2794 (depth = 5)
  gc_frame_newslot(call2794);
// starting to compile block node (depth = 5)
  Object block2795 = alloc_Block(NULL, NULL, "ast", 640);
  gc_frame_newslot(block2795);
// method _apply
  block_savedest(block2795);
  Object closure2796 = createclosure(4, "_apply");
  setclosureframe(closure2796, stackframe);
  addtoclosure(closure2796, var_depth);
  addtoclosure(closure2796, var_spc);
  addtoclosure(closure2796, var_s);
  addtoclosure(closure2796, selfslot);
  struct UserObject *uo2796 = (struct UserObject*)block2795;
  uo2796->data[0] = (Object)closure2796;
  Method *meth_meth_ast__apply2796 = addmethod2pos(block2795, "_apply", &meth_ast__apply2796, 0);
  int argcv_meth_ast__apply2796[] = {1};
  meth_meth_ast__apply2796->type = alloc_MethodType(1, argcv_meth_ast__apply2796);
  meth_meth_ast__apply2796->definitionModule = modulename;
  meth_meth_ast__apply2796->definitionLine = 640;
// compiled block node returning block2795 (depth = 5)
  gc_frame_newslot(block2795);
// call case 5: prelude request
  params[0] = call2794;
  params[1] = block2795;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2819 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2792);
// compiled call node returning call2819 (depth = 4)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2820 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2821 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2822 = callmethodflags(self, "types", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2821);
// compiled call node returning call2822 (depth = 6)
// compiled member node returning call2822 (depth = 5)
  gc_frame_newslot(call2822);
// starting to compile block node (depth = 5)
  Object block2823 = alloc_Block(NULL, NULL, "ast", 643);
  gc_frame_newslot(block2823);
// method _apply
  block_savedest(block2823);
  Object closure2824 = createclosure(4, "_apply");
  setclosureframe(closure2824, stackframe);
  addtoclosure(closure2824, var_depth);
  addtoclosure(closure2824, var_spc);
  addtoclosure(closure2824, var_s);
  addtoclosure(closure2824, selfslot);
  struct UserObject *uo2824 = (struct UserObject*)block2823;
  uo2824->data[0] = (Object)closure2824;
  Method *meth_meth_ast__apply2824 = addmethod2pos(block2823, "_apply", &meth_ast__apply2824, 0);
  int argcv_meth_ast__apply2824[] = {1};
  meth_meth_ast__apply2824->type = alloc_MethodType(1, argcv_meth_ast__apply2824);
  meth_meth_ast__apply2824->definitionModule = modulename;
  meth_meth_ast__apply2824->definitionLine = 643;
// compiled block node returning block2823 (depth = 5)
  gc_frame_newslot(block2823);
// call case 5: prelude request
  params[0] = call2822;
  params[1] = block2823;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2847 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2820);
// compiled call node returning call2847 (depth = 4)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit2849 == NULL) {
    strlit2849 = alloc_String("}");
    gc_root(strlit2849);
  }
// compiled string node returning strlit2849 (depth = 5)
  int op_slot_right_2848 = gc_frame_newslot(strlit2849);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_2848 = gc_frame_newslot(*var_s);
  params[0] = strlit2849;
  partcv[0] = 1;
  Object opresult2851 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2851 (depth = 4)
  gc_frame_end(frame);
  return opresult2851;
}
Object meth_ast_shallowCopyWithParent2852(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2853 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe2854 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeLiteralNode (depth = 6)
  params[0] = *var_emptySeq;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call2855 = callmethod(*var_typeLiteralNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2854);
// compiled call node returning call2855 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2856 = callmethod(call2855, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe2853);
// compiled call node returning call2856 (depth = 4)
  gc_frame_end(frame);
  return call2856;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent2857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2858 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2859 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe2858);
// compiled call node returning call2859 (depth = 4)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2860 = gc_frame_new();
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call2862 = callmethod(*var_other, "nominal",
    1, partcv, params);
  gc_frame_end(callframe2861);
// compiled call node returning call2862 (depth = 7)
// compiled member node returning call2862 (depth = 6)
  gc_frame_newslot(call2862);
// call case 4: self request
  params[0] = call2862;
  partcv[0] = 1;
  Object call2863 = callmethodflags(self, "nominal:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2860);
// compiled call node returning call2863 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2864 = gc_frame_new();
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call2866 = callmethod(*var_other, "anonymous",
    1, partcv, params);
  gc_frame_end(callframe2865);
// compiled call node returning call2866 (depth = 7)
// compiled member node returning call2866 (depth = 6)
  gc_frame_newslot(call2866);
// call case 4: self request
  params[0] = call2866;
  partcv[0] = 1;
  Object call2867 = callmethodflags(self, "anonymous:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2864);
// compiled call node returning call2867 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2868 = gc_frame_new();
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2869 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call2870 = callmethod(*var_other, "value",
    1, partcv, params);
  gc_frame_end(callframe2869);
// compiled call node returning call2870 (depth = 7)
// compiled member node returning call2870 (depth = 6)
  gc_frame_newslot(call2870);
// call case 4: self request
  params[0] = call2870;
  partcv[0] = 1;
  Object call2871 = callmethodflags(self, "value:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2868);
// compiled call node returning call2871 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new2531(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2532 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2532 = alloc_userobj2(21,17, objclass2532);
  gc_frame_newslot(obj2532);
if (objclass2532 == NULL) {
  glfree(obj2532->class->name);
  obj2532->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2532, self, 0);
  addmethodreal(obj2532,"outer", &reader_ast_outer_2533);
  Object oldself2532 = self;
  struct StackFrameObject *oldstackframe2532 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2532);
  gc_frame_newslot((Object)stackframe);
  self = obj2532;
  Object *oldselfslot2532 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2532 = (*(struct UserObject *)self).data[0], lowerouter2532 = thisouter2532;
  if (inheritingObject2532) {
    struct UserObject *inho2532 = (struct UserObject *)inheritingObject2532;
    while (inho2532->super != GraceDefaultObject) inho2532 = (struct UserObject *)inho2532->super;
    inho2532->super = obj2532;
    self = inheritingObject2532;
    *selfslot = self;
    lowerouter2532 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2532;
  }
if (objclass2532 == NULL) {
  Method *reader2534 = addmethodrealflags(obj2532, "kind",&reader_ast_kind_2534, MFLAG_DEF);
  reader2534->definitionModule = modulename;
  reader2534->definitionLine = 575;
}
adddatum2(obj2532, alloc_Undefined(), 1);
if (objclass2532 == NULL) {
  Method *reader2535 = addmethodrealflags(obj2532, "methods",&reader_ast_methods_2535, 0);
  Method *writer2535 = addmethodrealflags(obj2532, "methods:=",&writer_ast_methods_2535, 0);
  reader2535->definitionModule = modulename;
  writer2535->definitionModule = modulename;
  reader2535->definitionLine = 576;
  writer2535->definitionLine = 576;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 2);
if (objclass2532 == NULL) {
  Method *reader2536 = addmethodrealflags(obj2532, "types",&reader_ast_types_2536, 0);
  Method *writer2536 = addmethodrealflags(obj2532, "types:=",&writer_ast_types_2536, 0);
  reader2536->definitionModule = modulename;
  writer2536->definitionModule = modulename;
  reader2536->definitionLine = 577;
  writer2536->definitionLine = 577;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 3);
if (objclass2532 == NULL) {
  Method *reader2537 = addmethodrealflags(obj2532, "nominal",&reader_ast_nominal_2537, 0);
  Method *writer2537 = addmethodrealflags(obj2532, "nominal:=",&writer_ast_nominal_2537, 0);
  reader2537->definitionModule = modulename;
  writer2537->definitionModule = modulename;
  reader2537->definitionLine = 578;
  writer2537->definitionLine = 578;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 4);
if (objclass2532 == NULL) {
  Method *reader2538 = addmethodrealflags(obj2532, "anonymous",&reader_ast_anonymous_2538, 0);
  Method *writer2538 = addmethodrealflags(obj2532, "anonymous:=",&writer_ast_anonymous_2538, 0);
  reader2538->definitionModule = modulename;
  writer2538->definitionModule = modulename;
  reader2538->definitionLine = 579;
  writer2538->definitionLine = 579;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 5);
if (objclass2532 == NULL) {
  Method *reader2539 = addmethodrealflags(obj2532, "value",&reader_ast_value_2539, 0);
  Method *writer2539 = addmethodrealflags(obj2532, "value:=",&writer_ast_value_2539, 0);
  reader2539->definitionModule = modulename;
  writer2539->definitionModule = modulename;
  reader2539->definitionLine = 581;
  writer2539->definitionLine = 581;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 6);
// method name
  struct UserObject *uo2540 = (struct UserObject*)obj2532;
  uo2540->data[7] = emptyclosure;
  Method *meth_meth_ast_name2540 = addmethod2pos(obj2532, "name", &meth_ast_name2540, 7);
  int argcv_meth_ast_name2540[] = {0};
  meth_meth_ast_name2540->type = alloc_MethodType(1, argcv_meth_ast_name2540);
  meth_meth_ast_name2540->definitionModule = modulename;
  meth_meth_ast_name2540->definitionLine = 581;
// method name:=
  struct UserObject *uo2543 = (struct UserObject*)obj2532;
  uo2543->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_2543 = addmethod2pos(obj2532, "name:=", &meth_ast_name_58__61_2543, 8);
  int argcv_meth_ast_name_58__61_2543[] = {1};
  meth_meth_ast_name_58__61_2543->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_2543);
meth_meth_ast_name_58__61_2543->type->types[0] = type_String;
meth_meth_ast_name_58__61_2543->type->names[0] = "n";
  meth_meth_ast_name_58__61_2543->definitionModule = modulename;
  meth_meth_ast_name_58__61_2543->definitionLine = 582;
// method asString
  struct UserObject *uo2549 = (struct UserObject*)obj2532;
  uo2549->data[9] = emptyclosure;
  Method *meth_meth_ast_asString2549 = addmethod2pos(obj2532, "asString", &meth_ast_asString2549, 9);
  int argcv_meth_ast_asString2549[] = {0};
  meth_meth_ast_asString2549->type = alloc_MethodType(1, argcv_meth_ast_asString2549);
  meth_meth_ast_asString2549->definitionModule = modulename;
  meth_meth_ast_asString2549->definitionLine = 586;
// method accept()from
  struct UserObject *uo2569 = (struct UserObject*)obj2532;
  uo2569->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2569 = addmethod2pos(obj2532, "accept()from", &meth_ast_accept_40__41_from2569, 10);
  int argcv_meth_ast_accept_40__41_from2569[] = {1, 1};
  meth_meth_ast_accept_40__41_from2569->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2569);
  meth_meth_ast_accept_40__41_from2569->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2569->definitionLine = 589;
// method map()parent
  struct UserObject *uo2591 = (struct UserObject*)obj2532;
  uo2591->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent2591 = addmethod2pos(obj2532, "map()parent", &meth_ast_map_40__41_parent2591, 11);
  int argcv_meth_ast_map_40__41_parent2591[] = {1, 1};
  meth_meth_ast_map_40__41_parent2591->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent2591);
  meth_meth_ast_map_40__41_parent2591->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent2591->definitionLine = 599;
// method pretty
  struct UserObject *uo2617 = (struct UserObject*)obj2532;
  uo2617->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty2617 = addmethod2pos(obj2532, "pretty", &meth_ast_pretty2617, 12);
  int argcv_meth_ast_pretty2617[] = {1};
  meth_meth_ast_pretty2617->type = alloc_MethodType(1, argcv_meth_ast_pretty2617);
  meth_meth_ast_pretty2617->definitionModule = modulename;
  meth_meth_ast_pretty2617->definitionLine = 606;
// method toGrace
  struct UserObject *uo2716 = (struct UserObject*)obj2532;
  uo2716->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace2716 = addmethod2pos(obj2532, "toGrace", &meth_ast_toGrace2716, 13);
  int argcv_meth_ast_toGrace2716[] = {1};
  meth_meth_ast_toGrace2716->type = alloc_MethodType(1, argcv_meth_ast_toGrace2716);
meth_meth_ast_toGrace2716->type->types[0] = type_Number;
meth_meth_ast_toGrace2716->type->names[0] = "depth";
  meth_meth_ast_toGrace2716->definitionModule = modulename;
  meth_meth_ast_toGrace2716->definitionLine = 623;
// method shallowCopyWithParent
  block_savedest(obj2532);
  Object closure2852 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure2852, stackframe);
  addtoclosure(closure2852, var_emptySeq);
  addtoclosure(closure2852, var_typeLiteralNode);
  struct UserObject *uo2852 = (struct UserObject*)obj2532;
  uo2852->data[14] = (Object)closure2852;
  Method *meth_meth_ast_shallowCopyWithParent2852 = addmethod2pos(obj2532, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent2852, 14);
  int argcv_meth_ast_shallowCopyWithParent2852[] = {1};
  meth_meth_ast_shallowCopyWithParent2852->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent2852);
  meth_meth_ast_shallowCopyWithParent2852->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent2852->definitionLine = 648;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo2857 = (struct UserObject*)obj2532;
  uo2857->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857 = addmethod2pos(obj2532, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent2857, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent2857[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent2857);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857->definitionLine = 651;
  sourceObject = obj2532;
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2872 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2873 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2872);
// compiled call node returning call2873 (depth = 4)
  struct UserObject *obj2532_uo = (struct UserObject *)obj2532;
  obj2532_uo->super = call2873;
  sourceObject = obj2532;
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2874 == NULL) {
    strlit2874 = alloc_String("typeliteral");
    gc_root(strlit2874);
  }
// compiled string node returning strlit2874 (depth = 4)
  adddatum2(obj2532, strlit2874, 1);
  sourceObject = obj2532;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methods_39_ (depth = 4)
  adddatum2(obj2532, *var_methods_39_, 2);
  sourceObject = obj2532;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_types_39_ (depth = 4)
  adddatum2(obj2532, *var_types_39_, 3);
  sourceObject = obj2532;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2875 = alloc_Boolean(0);
// compiled identifier node returning bool2875 (depth = 4)
  adddatum2(obj2532, bool2875, 4);
  sourceObject = obj2532;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2876 = alloc_Boolean(1);
// compiled identifier node returning bool2876 (depth = 4)
  adddatum2(obj2532, bool2876, 5);
  sourceObject = obj2532;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2877 == NULL) {
    strlit2877 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit2877);
  }
// compiled string node returning strlit2877 (depth = 4)
  adddatum2(obj2532, strlit2877, 6);
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
objclass2532 = obj2532->class;
  objclass2532->definitionModule = modulename;
  objclass2532->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter2532;
  self = oldself2532;
  selfslot = oldselfslot2532;
  stackframe = oldstackframe2532;
  gc_frame_end(frame);
  return obj2532;
}
Object meth_ast_new2531_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_typeLiteralNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_methods_39_ = &(stackframe->slots[0]);
  *var_methods_39_ = args[curarg];
  curarg++;
  Object *var_types_39_ = &(stackframe->slots[1]);
  *var_types_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2532 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2532 = alloc_userobj2(21,17, objclass2532);
  gc_frame_newslot(obj2532);
if (objclass2532 == NULL) {
  glfree(obj2532->class->name);
  obj2532->class->name = "typeLiteralNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2532, self, 0);
  addmethodreal(obj2532,"outer", &reader_ast_outer_2533);
  Object oldself2532 = self;
  struct StackFrameObject *oldstackframe2532 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2532);
  gc_frame_newslot((Object)stackframe);
  self = obj2532;
  Object *oldselfslot2532 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2532 = (*(struct UserObject *)self).data[0], lowerouter2532 = thisouter2532;
  if (inheritingObject2532) {
    struct UserObject *inho2532 = (struct UserObject *)inheritingObject2532;
    while (inho2532->super != GraceDefaultObject) inho2532 = (struct UserObject *)inho2532->super;
    inho2532->super = obj2532;
    self = inheritingObject2532;
    *selfslot = self;
    lowerouter2532 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2532;
  }
if (objclass2532 == NULL) {
  Method *reader2534 = addmethodrealflags(obj2532, "kind",&reader_ast_kind_2534, MFLAG_DEF);
  reader2534->definitionModule = modulename;
  reader2534->definitionLine = 575;
}
adddatum2(obj2532, alloc_Undefined(), 1);
if (objclass2532 == NULL) {
  Method *reader2535 = addmethodrealflags(obj2532, "methods",&reader_ast_methods_2535, 0);
  Method *writer2535 = addmethodrealflags(obj2532, "methods:=",&writer_ast_methods_2535, 0);
  reader2535->definitionModule = modulename;
  writer2535->definitionModule = modulename;
  reader2535->definitionLine = 576;
  writer2535->definitionLine = 576;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 2);
if (objclass2532 == NULL) {
  Method *reader2536 = addmethodrealflags(obj2532, "types",&reader_ast_types_2536, 0);
  Method *writer2536 = addmethodrealflags(obj2532, "types:=",&writer_ast_types_2536, 0);
  reader2536->definitionModule = modulename;
  writer2536->definitionModule = modulename;
  reader2536->definitionLine = 577;
  writer2536->definitionLine = 577;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 3);
if (objclass2532 == NULL) {
  Method *reader2537 = addmethodrealflags(obj2532, "nominal",&reader_ast_nominal_2537, 0);
  Method *writer2537 = addmethodrealflags(obj2532, "nominal:=",&writer_ast_nominal_2537, 0);
  reader2537->definitionModule = modulename;
  writer2537->definitionModule = modulename;
  reader2537->definitionLine = 578;
  writer2537->definitionLine = 578;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 4);
if (objclass2532 == NULL) {
  Method *reader2538 = addmethodrealflags(obj2532, "anonymous",&reader_ast_anonymous_2538, 0);
  Method *writer2538 = addmethodrealflags(obj2532, "anonymous:=",&writer_ast_anonymous_2538, 0);
  reader2538->definitionModule = modulename;
  writer2538->definitionModule = modulename;
  reader2538->definitionLine = 579;
  writer2538->definitionLine = 579;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 5);
if (objclass2532 == NULL) {
  Method *reader2539 = addmethodrealflags(obj2532, "value",&reader_ast_value_2539, 0);
  Method *writer2539 = addmethodrealflags(obj2532, "value:=",&writer_ast_value_2539, 0);
  reader2539->definitionModule = modulename;
  writer2539->definitionModule = modulename;
  reader2539->definitionLine = 581;
  writer2539->definitionLine = 581;
}
obj2532->flags |= OFLAG_MUTABLE;
adddatum2(obj2532, alloc_Undefined(), 6);
// method name
  struct UserObject *uo2540 = (struct UserObject*)obj2532;
  uo2540->data[7] = emptyclosure;
  Method *meth_meth_ast_name2540 = addmethod2pos(obj2532, "name", &meth_ast_name2540, 7);
  int argcv_meth_ast_name2540[] = {0};
  meth_meth_ast_name2540->type = alloc_MethodType(1, argcv_meth_ast_name2540);
  meth_meth_ast_name2540->definitionModule = modulename;
  meth_meth_ast_name2540->definitionLine = 581;
// method name:=
  struct UserObject *uo2543 = (struct UserObject*)obj2532;
  uo2543->data[8] = emptyclosure;
  Method *meth_meth_ast_name_58__61_2543 = addmethod2pos(obj2532, "name:=", &meth_ast_name_58__61_2543, 8);
  int argcv_meth_ast_name_58__61_2543[] = {1};
  meth_meth_ast_name_58__61_2543->type = alloc_MethodType(1, argcv_meth_ast_name_58__61_2543);
meth_meth_ast_name_58__61_2543->type->types[0] = type_String;
meth_meth_ast_name_58__61_2543->type->names[0] = "n";
  meth_meth_ast_name_58__61_2543->definitionModule = modulename;
  meth_meth_ast_name_58__61_2543->definitionLine = 582;
// method asString
  struct UserObject *uo2549 = (struct UserObject*)obj2532;
  uo2549->data[9] = emptyclosure;
  Method *meth_meth_ast_asString2549 = addmethod2pos(obj2532, "asString", &meth_ast_asString2549, 9);
  int argcv_meth_ast_asString2549[] = {0};
  meth_meth_ast_asString2549->type = alloc_MethodType(1, argcv_meth_ast_asString2549);
  meth_meth_ast_asString2549->definitionModule = modulename;
  meth_meth_ast_asString2549->definitionLine = 586;
// method accept()from
  struct UserObject *uo2569 = (struct UserObject*)obj2532;
  uo2569->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2569 = addmethod2pos(obj2532, "accept()from", &meth_ast_accept_40__41_from2569, 10);
  int argcv_meth_ast_accept_40__41_from2569[] = {1, 1};
  meth_meth_ast_accept_40__41_from2569->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2569);
  meth_meth_ast_accept_40__41_from2569->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2569->definitionLine = 589;
// method map()parent
  struct UserObject *uo2591 = (struct UserObject*)obj2532;
  uo2591->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent2591 = addmethod2pos(obj2532, "map()parent", &meth_ast_map_40__41_parent2591, 11);
  int argcv_meth_ast_map_40__41_parent2591[] = {1, 1};
  meth_meth_ast_map_40__41_parent2591->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent2591);
  meth_meth_ast_map_40__41_parent2591->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent2591->definitionLine = 599;
// method pretty
  struct UserObject *uo2617 = (struct UserObject*)obj2532;
  uo2617->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty2617 = addmethod2pos(obj2532, "pretty", &meth_ast_pretty2617, 12);
  int argcv_meth_ast_pretty2617[] = {1};
  meth_meth_ast_pretty2617->type = alloc_MethodType(1, argcv_meth_ast_pretty2617);
  meth_meth_ast_pretty2617->definitionModule = modulename;
  meth_meth_ast_pretty2617->definitionLine = 606;
// method toGrace
  struct UserObject *uo2716 = (struct UserObject*)obj2532;
  uo2716->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace2716 = addmethod2pos(obj2532, "toGrace", &meth_ast_toGrace2716, 13);
  int argcv_meth_ast_toGrace2716[] = {1};
  meth_meth_ast_toGrace2716->type = alloc_MethodType(1, argcv_meth_ast_toGrace2716);
meth_meth_ast_toGrace2716->type->types[0] = type_Number;
meth_meth_ast_toGrace2716->type->names[0] = "depth";
  meth_meth_ast_toGrace2716->definitionModule = modulename;
  meth_meth_ast_toGrace2716->definitionLine = 623;
// method shallowCopyWithParent
  block_savedest(obj2532);
  Object closure2852 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure2852, stackframe);
  addtoclosure(closure2852, var_emptySeq);
  addtoclosure(closure2852, var_typeLiteralNode);
  struct UserObject *uo2852 = (struct UserObject*)obj2532;
  uo2852->data[14] = (Object)closure2852;
  Method *meth_meth_ast_shallowCopyWithParent2852 = addmethod2pos(obj2532, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent2852, 14);
  int argcv_meth_ast_shallowCopyWithParent2852[] = {1};
  meth_meth_ast_shallowCopyWithParent2852->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent2852);
  meth_meth_ast_shallowCopyWithParent2852->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent2852->definitionLine = 648;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo2857 = (struct UserObject*)obj2532;
  uo2857->data[15] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857 = addmethod2pos(obj2532, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent2857, 15);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent2857[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent2857);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent2857->definitionLine = 651;
  sourceObject = obj2532;
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2872 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2873 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2872);
// compiled call node returning call2873 (depth = 4)
  struct UserObject *obj2532_uo = (struct UserObject *)obj2532;
  obj2532_uo->super = call2873;
  sourceObject = obj2532;
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2874 == NULL) {
    strlit2874 = alloc_String("typeliteral");
    gc_root(strlit2874);
  }
// compiled string node returning strlit2874 (depth = 4)
  adddatum2(obj2532, strlit2874, 1);
  sourceObject = obj2532;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methods_39_ (depth = 4)
  adddatum2(obj2532, *var_methods_39_, 2);
  sourceObject = obj2532;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_types_39_ (depth = 4)
  adddatum2(obj2532, *var_types_39_, 3);
  sourceObject = obj2532;
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2875 = alloc_Boolean(0);
// compiled identifier node returning bool2875 (depth = 4)
  adddatum2(obj2532, bool2875, 4);
  sourceObject = obj2532;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2876 = alloc_Boolean(1);
// compiled identifier node returning bool2876 (depth = 4)
  adddatum2(obj2532, bool2876, 5);
  sourceObject = obj2532;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2877 == NULL) {
    strlit2877 = alloc_String("""\xe2""""\x80""""\xb9""anon""\xe2""""\x80""""\xba""");
    gc_root(strlit2877);
  }
// compiled string node returning strlit2877 (depth = 4)
  adddatum2(obj2532, strlit2877, 6);
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
  sourceObject = obj2532;
objclass2532 = obj2532->class;
  objclass2532->definitionModule = modulename;
  objclass2532->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter2532;
  self = oldself2532;
  selfslot = oldselfslot2532;
  stackframe = oldstackframe2532;
  gc_frame_end(frame);
  return obj2532;
}
Object meth_ast_typeDecNode2879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_typeDecNode;
}
Object meth_ast_declarationKind2891(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2892 == NULL) {
    strlit2892 = alloc_String("parameter");
    gc_root(strlit2892);
  }
// compiled string node returning strlit2892 (depth = 4)
  gc_frame_end(frame);
  return strlit2892;
}
Object meth_ast_isConfidential2893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2896 = alloc_Float64(0);
// compiled num node returning num2896 (depth = 6)
  int op_slot_right_2895 = gc_frame_newslot(num2896);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2898 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2899 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2900 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2899);
// compiled call node returning call2900 (depth = 9)
// compiled member node returning call2900 (depth = 8)
  partcv[0] = 0;
  Object call2901 = callmethod(call2900, "size",
    1, partcv, params);
  gc_frame_end(callframe2898);
// compiled call node returning call2901 (depth = 7)
// compiled member node returning call2901 (depth = 6)
  int op_slot_left_2895 = gc_frame_newslot(call2901);
  params[0] = num2896;
  partcv[0] = 1;
  Object opresult2902 = callmethod(call2901, "==", 1, partcv, params);
// compiled op node returning opresult2902 (depth = 5)
  Object if2894 = done;
  if (istrue(opresult2902)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2903 = alloc_Boolean(0);
// compiled identifier node returning bool2903 (depth = 6)
  return bool2903;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2894 = undefined;
  } else {
  }
// compiled if node returning if2894 (depth = 4)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2904 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit2905 == NULL) {
    strlit2905 = alloc_String("confidential");
    gc_root(strlit2905);
  }
// compiled string node returning strlit2905 (depth = 5)
  gc_frame_newslot(strlit2905);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2906 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2907 = gc_frame_new();
// call case 3: self.outer request
  Object call2908 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2907);
// compiled call node returning call2908 (depth = 8)
// compiled member node returning call2908 (depth = 7)
  partcv[0] = 0;
  Object call2909 = callmethodflags(call2908, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2906);
// compiled call node returning call2909 (depth = 6)
// compiled member node returning call2909 (depth = 5)
  params[0] = self;
  params[1] = strlit2905;
  partcv[0] = 2;
  Object call2910 = callmethodflags(call2909, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2904);
// compiled call node returning call2910 (depth = 4)
  gc_frame_end(frame);
  return call2910;
}
Object meth_ast_isPublic2911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2912 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2913 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2914 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2913);
// compiled call node returning call2914 (depth = 7)
// compiled member node returning call2914 (depth = 6)
  partcv[0] = 0;
  Object call2915 = callmethod(call2914, "not",
    1, partcv, params);
  gc_frame_end(callframe2912);
// compiled call node returning call2915 (depth = 5)
// compiled member node returning call2915 (depth = 4)
  gc_frame_end(frame);
  return call2915;
}
Object meth_ast_isWritable2916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool2917 = alloc_Boolean(0);
// compiled identifier node returning bool2917 (depth = 4)
  gc_frame_end(frame);
  return bool2917;
}
Object meth_ast_isReadable2918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2920 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2919);
// compiled call node returning call2920 (depth = 5)
// compiled member node returning call2920 (depth = 4)
  gc_frame_end(frame);
  return call2920;
}
Object meth_ast__apply2931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2932 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2933 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2932);
// compiled call node returning call2933 (depth = 7)
  gc_frame_end(frame);
  return call2933;
}
Object meth_ast__apply2940(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe2941 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2942 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2941);
// compiled call node returning call2942 (depth = 7)
  gc_frame_end(frame);
  return call2942;
}
Object meth_ast_accept_40__41_from2921(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2923 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2924 = callmethod(*var_visitor, "visitTypeDec()up",
    2, partcv, params);
  gc_frame_end(callframe2923);
// compiled call node returning call2924 (depth = 5)
  Object if2922 = done;
  if (istrue(call2924)) {
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2925 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2927 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2926);
// compiled call node returning call2927 (depth = 7)
// compiled member node returning call2927 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2928 = callmethod(call2927, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe2925);
// compiled call node returning call2928 (depth = 5)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2929 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2930 = alloc_Block(NULL, NULL, "ast", 683);
  gc_frame_newslot(block2930);
// method _apply
  block_savedest(block2930);
  Object closure2931 = createclosure(2, "_apply");
  setclosureframe(closure2931, stackframe);
  addtoclosure(closure2931, var_visitor);
  addtoclosure(closure2931, selfslot);
  struct UserObject *uo2931 = (struct UserObject*)block2930;
  uo2931->data[0] = (Object)closure2931;
  Method *meth_meth_ast__apply2931 = addmethod2pos(block2930, "_apply", &meth_ast__apply2931, 0);
  int argcv_meth_ast__apply2931[] = {1};
  meth_meth_ast__apply2931->type = alloc_MethodType(1, argcv_meth_ast__apply2931);
  meth_meth_ast__apply2931->definitionModule = modulename;
  meth_meth_ast__apply2931->definitionLine = 682;
// compiled block node returning block2930 (depth = 6)
  gc_frame_newslot(block2930);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2935 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2936 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2935);
// compiled call node returning call2936 (depth = 7)
// compiled member node returning call2936 (depth = 6)
  params[0] = block2930;
  partcv[0] = 1;
  Object call2937 = callmethod(call2936, "do",
    1, partcv, params);
  gc_frame_end(callframe2929);
// compiled call node returning call2937 (depth = 5)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2938 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2939 = alloc_Block(NULL, NULL, "ast", 684);
  gc_frame_newslot(block2939);
// method _apply
  block_savedest(block2939);
  Object closure2940 = createclosure(2, "_apply");
  setclosureframe(closure2940, stackframe);
  addtoclosure(closure2940, var_visitor);
  addtoclosure(closure2940, selfslot);
  struct UserObject *uo2940 = (struct UserObject*)block2939;
  uo2940->data[0] = (Object)closure2940;
  Method *meth_meth_ast__apply2940 = addmethod2pos(block2939, "_apply", &meth_ast__apply2940, 0);
  int argcv_meth_ast__apply2940[] = {1};
  meth_meth_ast__apply2940->type = alloc_MethodType(1, argcv_meth_ast__apply2940);
  meth_meth_ast__apply2940->definitionModule = modulename;
  meth_meth_ast__apply2940->definitionLine = 683;
// compiled block node returning block2939 (depth = 6)
  gc_frame_newslot(block2939);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2945 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2945 (depth = 7)
// compiled member node returning call2945 (depth = 6)
  params[0] = block2939;
  partcv[0] = 1;
  Object call2946 = callmethod(call2945, "do",
    1, partcv, params);
  gc_frame_end(callframe2938);
// compiled call node returning call2946 (depth = 5)
    gc_frame_newslot(call2946);
    if2922 = call2946;
  } else {
  }
// compiled if node returning if2922 (depth = 4)
  gc_frame_end(frame);
  return if2922;
}
Object meth_ast_map_40__41_parent2947(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2948 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call2949 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2948);
// compiled call node returning call2949 (depth = 5)
  *var_n = call2949;
  if (call2949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2952 == NULL) {
    strlit2952 = alloc_String("identifier");
    gc_root(strlit2952);
  }
// compiled string node returning strlit2952 (depth = 6)
  int op_slot_right_2951 = gc_frame_newslot(strlit2952);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2954 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2955 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2956 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2955);
// compiled call node returning call2956 (depth = 9)
// compiled member node returning call2956 (depth = 8)
  partcv[0] = 0;
  Object call2957 = callmethod(call2956, "kind",
    1, partcv, params);
  gc_frame_end(callframe2954);
// compiled call node returning call2957 (depth = 7)
// compiled member node returning call2957 (depth = 6)
  int op_slot_left_2951 = gc_frame_newslot(call2957);
  params[0] = strlit2952;
  partcv[0] = 1;
  Object opresult2958 = callmethod(call2957, "!=", 1, partcv, params);
// compiled op node returning opresult2958 (depth = 5)
  Object if2950 = done;
  if (istrue(opresult2958)) {
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2960 == NULL) {
    strlit2960 = alloc_String(" does not contain an identifier");
    gc_root(strlit2960);
  }
// compiled string node returning strlit2960 (depth = 7)
  int op_slot_right_2959 = gc_frame_newslot(strlit2960);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2963 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2964 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2963);
// compiled call node returning call2964 (depth = 9)
// compiled member node returning call2964 (depth = 8)
  int op_slot_right_2962 = gc_frame_newslot(call2964);
// starting to compile string node (depth = 8)
  if (strlit2966 == NULL) {
    strlit2966 = alloc_String("typeDecNode ");
    gc_root(strlit2966);
  }
// compiled string node returning strlit2966 (depth = 8)
  int op_slot_left_2962 = gc_frame_newslot(strlit2966);
  params[0] = call2964;
  partcv[0] = 1;
  Object opresult2967 = callmethod(strlit2966, "++", 1, partcv, params);
// compiled op node returning opresult2967 (depth = 7)
  int op_slot_left_2959 = gc_frame_newslot(opresult2967);
  params[0] = strlit2960;
  partcv[0] = 1;
  Object opresult2968 = callmethod(opresult2967, "++", 1, partcv, params);
// compiled op node returning opresult2968 (depth = 6)
  params[0] = opresult2968;
  Object call2969 = gracelib_print(NULL, 1,  params);
// compiled call node returning call2969 (depth = 5)
    gc_frame_newslot(call2969);
    if2950 = call2969;
  } else {
  }
// compiled if node returning if2950 (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2970 = gc_frame_new();
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2971 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2973 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2972);
// compiled call node returning call2973 (depth = 8)
// compiled member node returning call2973 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2974 = callmethod(call2973, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe2971);
// compiled call node returning call2974 (depth = 6)
  gc_frame_newslot(call2974);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2974;
  partcv[0] = 1;
  Object call2975 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe2970);
// compiled call node returning call2975 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2976 = gc_frame_new();
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2977 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2979 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2978);
// compiled call node returning call2979 (depth = 8)
// compiled member node returning call2979 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2980 = callmethod(call2979, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe2977);
// compiled call node returning call2980 (depth = 6)
  gc_frame_newslot(call2980);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2980;
  partcv[0] = 1;
  Object call2981 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe2976);
// compiled call node returning call2981 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2982 = gc_frame_new();
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2983 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2984 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2985 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2984);
// compiled call node returning call2985 (depth = 8)
// compiled member node returning call2985 (depth = 7)
  gc_frame_newslot(call2985);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2986 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2987 = gc_frame_new();
// call case 3: self.outer request
  Object call2988 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2987);
// compiled call node returning call2988 (depth = 10)
// compiled member node returning call2988 (depth = 9)
  partcv[0] = 0;
  Object call2989 = callmethodflags(call2988, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2986);
// compiled call node returning call2989 (depth = 8)
// compiled member node returning call2989 (depth = 7)
  params[0] = call2985;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2990 = callmethodflags(call2989, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2983);
// compiled call node returning call2990 (depth = 6)
  gc_frame_newslot(call2990);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call2990;
  partcv[0] = 1;
  Object call2991 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe2982);
// compiled call node returning call2991 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2992 = gc_frame_new();
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2993 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2995 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2994);
// compiled call node returning call2995 (depth = 8)
// compiled member node returning call2995 (depth = 7)
  gc_frame_newslot(call2995);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2996 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2997 = gc_frame_new();
// call case 3: self.outer request
  Object call2998 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2997);
// compiled call node returning call2998 (depth = 10)
// compiled member node returning call2998 (depth = 9)
  partcv[0] = 0;
  Object call2999 = callmethodflags(call2998, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2996);
// compiled call node returning call2999 (depth = 8)
// compiled member node returning call2999 (depth = 7)
  params[0] = call2995;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3000 = callmethodflags(call2999, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2993);
// compiled call node returning call3000 (depth = 6)
  gc_frame_newslot(call3000);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3000;
  partcv[0] = 1;
  Object call3001 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe2992);
// compiled call node returning call3001 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3002 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3003 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3002);
// compiled call node returning call3003 (depth = 5)
  *var_n = call3003;
  if (call3003 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply3013(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3015 == NULL) {
    strlit3015 = alloc_String("  ");
    gc_root(strlit3015);
  }
// compiled string node returning strlit3015 (depth = 8)
  int op_slot_right_3014 = gc_frame_newslot(strlit3015);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3014 = gc_frame_newslot(*var_spc);
  params[0] = strlit3015;
  partcv[0] = 1;
  Object opresult3017 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3017 (depth = 7)
  *var_spc = opresult3017;
  if (opresult3017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3075(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3077 == NULL) {
    strlit3077 = alloc_String("""\x0a""");
    gc_root(strlit3077);
  }
// compiled string node returning strlit3077 (depth = 9)
  int op_slot_right_3076 = gc_frame_newslot(strlit3077);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ut (depth = 10)
  int op_slot_right_3079 = gc_frame_newslot(*var_ut);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3082 == NULL) {
    strlit3082 = alloc_String("  ");
    gc_root(strlit3082);
  }
// compiled string node returning strlit3082 (depth = 11)
  int op_slot_right_3081 = gc_frame_newslot(strlit3082);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_3084 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3087 == NULL) {
    strlit3087 = alloc_String("");
    gc_root(strlit3087);
  }
// compiled string node returning strlit3087 (depth = 13)
  int op_slot_right_3086 = gc_frame_newslot(strlit3087);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_3089 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit3091 == NULL) {
    strlit3091 = alloc_String("");
    gc_root(strlit3091);
  }
// compiled string node returning strlit3091 (depth = 14)
  int op_slot_left_3089 = gc_frame_newslot(strlit3091);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3092 = callmethod(strlit3091, "++", 1, partcv, params);
// compiled op node returning opresult3092 (depth = 13)
  int op_slot_left_3086 = gc_frame_newslot(opresult3092);
  params[0] = strlit3087;
  partcv[0] = 1;
  Object opresult3093 = callmethod(opresult3092, "++", 1, partcv, params);
// compiled op node returning opresult3093 (depth = 12)
  int op_slot_left_3084 = gc_frame_newslot(opresult3093);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3094 = callmethod(opresult3093, "++", 1, partcv, params);
// compiled op node returning opresult3094 (depth = 11)
  int op_slot_left_3081 = gc_frame_newslot(opresult3094);
  params[0] = strlit3082;
  partcv[0] = 1;
  Object opresult3095 = callmethod(opresult3094, "++", 1, partcv, params);
// compiled op node returning opresult3095 (depth = 10)
  int op_slot_left_3079 = gc_frame_newslot(opresult3095);
  params[0] = *var_ut;
  partcv[0] = 1;
  Object opresult3096 = callmethod(opresult3095, "++", 1, partcv, params);
// compiled op node returning opresult3096 (depth = 9)
  int op_slot_left_3076 = gc_frame_newslot(opresult3096);
  params[0] = strlit3077;
  partcv[0] = 1;
  Object opresult3097 = callmethod(opresult3096, "++", 1, partcv, params);
// compiled op node returning opresult3097 (depth = 8)
  *var_s = opresult3097;
  if (opresult3097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3006 == NULL) {
    strlit3006 = alloc_String("");
    gc_root(strlit3006);
  }
// compiled string node returning strlit3006 (depth = 5)
  *var_spc = strlit3006;
  if (strlit3006 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3007 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_3008 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num3010 = alloc_Float64(0);
// compiled num node returning num3010 (depth = 6)
  int op_slot_left_3008 = gc_frame_newslot(num3010);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3011 = callmethod(num3010, "..", 1, partcv, params);
// compiled op node returning opresult3011 (depth = 5)
  gc_frame_newslot(opresult3011);
// starting to compile block node (depth = 5)
  Object block3012 = alloc_Block(NULL, NULL, "ast", 701);
  gc_frame_newslot(block3012);
// method _apply
  block_savedest(block3012);
  Object closure3013 = createclosure(2, "_apply");
  setclosureframe(closure3013, stackframe);
  addtoclosure(closure3013, var_spc);
  addtoclosure(closure3013, selfslot);
  struct UserObject *uo3013 = (struct UserObject*)block3012;
  uo3013->data[0] = (Object)closure3013;
  Method *meth_meth_ast__apply3013 = addmethod2pos(block3012, "_apply", &meth_ast__apply3013, 0);
  int argcv_meth_ast__apply3013[] = {1};
  meth_meth_ast__apply3013->type = alloc_MethodType(1, argcv_meth_ast__apply3013);
  meth_meth_ast__apply3013->definitionModule = modulename;
  meth_meth_ast__apply3013->definitionLine = 695;
// compiled block node returning block3012 (depth = 5)
  gc_frame_newslot(block3012);
// call case 5: prelude request
  params[0] = opresult3011;
  params[1] = block3012;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3020 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3007);
// compiled call node returning call3020 (depth = 4)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3022 == NULL) {
    strlit3022 = alloc_String("""\x0a""");
    gc_root(strlit3022);
  }
// compiled string node returning strlit3022 (depth = 6)
  int op_slot_right_3021 = gc_frame_newslot(strlit3022);
// starting to compile call node (depth = 6)
  int callframe3024 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3025 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3024);
// compiled call node returning call3025 (depth = 6)
  int op_slot_left_3021 = gc_frame_newslot(call3025);
  params[0] = strlit3022;
  partcv[0] = 1;
  Object opresult3026 = callmethod(call3025, "++", 1, partcv, params);
// compiled op node returning opresult3026 (depth = 5)
  *var_s = opresult3026;
  if (opresult3026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3028 == NULL) {
    strlit3028 = alloc_String("""\x0a""");
    gc_root(strlit3028);
  }
// compiled string node returning strlit3028 (depth = 6)
  int op_slot_right_3027 = gc_frame_newslot(strlit3028);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3031 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3033 = alloc_Float64(1);
// compiled num node returning num3033 (depth = 9)
  int op_slot_right_3032 = gc_frame_newslot(num3033);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3032 = gc_frame_newslot(*var_depth);
  params[0] = num3033;
  partcv[0] = 1;
  Object sum3035 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3035 (depth = 8)
  gc_frame_newslot(sum3035);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3037 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3036);
// compiled call node returning call3037 (depth = 9)
// compiled member node returning call3037 (depth = 8)
  params[0] = sum3035;
  partcv[0] = 1;
  Object call3038 = callmethod(call3037, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3031);
// compiled call node returning call3038 (depth = 7)
  int op_slot_right_3030 = gc_frame_newslot(call3038);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3040 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3040 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3042 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3042 (depth = 7)
  int op_slot_left_3030 = gc_frame_newslot(opresult3042);
  params[0] = call3038;
  partcv[0] = 1;
  Object opresult3043 = callmethod(opresult3042, "++", 1, partcv, params);
// compiled op node returning opresult3043 (depth = 6)
  int op_slot_left_3027 = gc_frame_newslot(opresult3043);
  params[0] = strlit3028;
  partcv[0] = 1;
  Object opresult3044 = callmethod(opresult3043, "++", 1, partcv, params);
// compiled op node returning opresult3044 (depth = 5)
  *var_s = opresult3044;
  if (opresult3044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3048 = alloc_Float64(0);
// compiled num node returning num3048 (depth = 6)
  int op_slot_right_3047 = gc_frame_newslot(num3048);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3050 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3052 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3051);
// compiled call node returning call3052 (depth = 9)
// compiled member node returning call3052 (depth = 8)
  partcv[0] = 0;
  Object call3053 = callmethod(call3052, "size",
    1, partcv, params);
  gc_frame_end(callframe3050);
// compiled call node returning call3053 (depth = 7)
// compiled member node returning call3053 (depth = 6)
  int op_slot_left_3047 = gc_frame_newslot(call3053);
  params[0] = num3048;
  partcv[0] = 1;
  Object opresult3054 = callmethod(call3053, ">", 1, partcv, params);
// compiled op node returning opresult3054 (depth = 5)
  Object if3046 = done;
  if (istrue(opresult3054)) {
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3056 == NULL) {
    strlit3056 = alloc_String("Generic parameters:""\x0a""");
    gc_root(strlit3056);
  }
// compiled string node returning strlit3056 (depth = 7)
  int op_slot_right_3055 = gc_frame_newslot(strlit3056);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3058 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3061 == NULL) {
    strlit3061 = alloc_String("");
    gc_root(strlit3061);
  }
// compiled string node returning strlit3061 (depth = 9)
  int op_slot_right_3060 = gc_frame_newslot(strlit3061);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_3063 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit3065 == NULL) {
    strlit3065 = alloc_String("");
    gc_root(strlit3065);
  }
// compiled string node returning strlit3065 (depth = 10)
  int op_slot_left_3063 = gc_frame_newslot(strlit3065);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3066 = callmethod(strlit3065, "++", 1, partcv, params);
// compiled op node returning opresult3066 (depth = 9)
  int op_slot_left_3060 = gc_frame_newslot(opresult3066);
  params[0] = strlit3061;
  partcv[0] = 1;
  Object opresult3067 = callmethod(opresult3066, "++", 1, partcv, params);
// compiled op node returning opresult3067 (depth = 8)
  int op_slot_left_3058 = gc_frame_newslot(opresult3067);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3068 = callmethod(opresult3067, "++", 1, partcv, params);
// compiled op node returning opresult3068 (depth = 7)
  int op_slot_left_3055 = gc_frame_newslot(opresult3068);
  params[0] = strlit3056;
  partcv[0] = 1;
  Object opresult3069 = callmethod(opresult3068, "++", 1, partcv, params);
// compiled op node returning opresult3069 (depth = 6)
  *var_s = opresult3069;
  if (opresult3069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3071 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3073 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3072);
// compiled call node returning call3073 (depth = 7)
// compiled member node returning call3073 (depth = 6)
  gc_frame_newslot(call3073);
// starting to compile block node (depth = 6)
  Object block3074 = alloc_Block(NULL, NULL, "ast", 708);
  gc_frame_newslot(block3074);
// method _apply
  block_savedest(block3074);
  Object closure3075 = createclosure(3, "_apply");
  setclosureframe(closure3075, stackframe);
  addtoclosure(closure3075, var_spc);
  addtoclosure(closure3075, var_s);
  addtoclosure(closure3075, selfslot);
  struct UserObject *uo3075 = (struct UserObject*)block3074;
  uo3075->data[0] = (Object)closure3075;
  Method *meth_meth_ast__apply3075 = addmethod2pos(block3074, "_apply", &meth_ast__apply3075, 0);
  int argcv_meth_ast__apply3075[] = {1};
  meth_meth_ast__apply3075->type = alloc_MethodType(1, argcv_meth_ast__apply3075);
  meth_meth_ast__apply3075->definitionModule = modulename;
  meth_meth_ast__apply3075->definitionLine = 708;
// compiled block node returning block3074 (depth = 6)
  gc_frame_newslot(block3074);
// call case 5: prelude request
  params[0] = call3073;
  params[1] = block3074;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3100 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3071);
// compiled call node returning call3100 (depth = 5)
    gc_frame_newslot(call3100);
    if3046 = call3100;
  } else {
  }
// compiled if node returning if3046 (depth = 4)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3102 == NULL) {
    strlit3102 = alloc_String("Value:");
    gc_root(strlit3102);
  }
// compiled string node returning strlit3102 (depth = 6)
  int op_slot_right_3101 = gc_frame_newslot(strlit3102);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3104 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3104 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3106 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3106 (depth = 6)
  int op_slot_left_3101 = gc_frame_newslot(opresult3106);
  params[0] = strlit3102;
  partcv[0] = 1;
  Object opresult3107 = callmethod(opresult3106, "++", 1, partcv, params);
// compiled op node returning opresult3107 (depth = 5)
  *var_s = opresult3107;
  if (opresult3107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3110 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3112 = alloc_Float64(2);
// compiled num node returning num3112 (depth = 8)
  int op_slot_right_3111 = gc_frame_newslot(num3112);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3111 = gc_frame_newslot(*var_depth);
  params[0] = num3112;
  partcv[0] = 1;
  Object sum3114 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3114 (depth = 7)
  gc_frame_newslot(sum3114);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3115 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3116 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3115);
// compiled call node returning call3116 (depth = 8)
// compiled member node returning call3116 (depth = 7)
  params[0] = sum3114;
  partcv[0] = 1;
  Object call3117 = callmethod(call3116, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3110);
// compiled call node returning call3117 (depth = 6)
  int op_slot_right_3109 = gc_frame_newslot(call3117);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3109 = gc_frame_newslot(*var_s);
  params[0] = call3117;
  partcv[0] = 1;
  Object opresult3119 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3119 (depth = 5)
  *var_s = opresult3119;
  if (opresult3119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3122 == NULL) {
    strlit3122 = alloc_String("""\x0a""");
    gc_root(strlit3122);
  }
// compiled string node returning strlit3122 (depth = 6)
  int op_slot_right_3121 = gc_frame_newslot(strlit3122);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3121 = gc_frame_newslot(*var_s);
  params[0] = strlit3122;
  partcv[0] = 1;
  Object opresult3124 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3124 (depth = 5)
  *var_s = opresult3124;
  if (opresult3124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3140 == NULL) {
    strlit3140 = alloc_String("    ");
    gc_root(strlit3140);
  }
// compiled string node returning strlit3140 (depth = 8)
  int op_slot_right_3139 = gc_frame_newslot(strlit3140);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3139 = gc_frame_newslot(*var_spc);
  params[0] = strlit3140;
  partcv[0] = 1;
  Object opresult3142 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3142 (depth = 7)
  *var_spc = opresult3142;
  if (opresult3142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3178(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3180 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3182 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3181);
// compiled call node returning call3182 (depth = 13)
// compiled member node returning call3182 (depth = 12)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3183 = callmethod(call3182, "[]", 1, partcv, params);
// compiled index node returning idxres3183 (depth = 11)
  partcv[0] = 0;
  Object call3184 = callmethod(idxres3183, "value",
    1, partcv, params);
  gc_frame_end(callframe3180);
// compiled call node returning call3184 (depth = 10)
// compiled member node returning call3184 (depth = 9)
  int op_slot_right_3179 = gc_frame_newslot(call3184);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3179 = gc_frame_newslot(*var_s);
  params[0] = call3184;
  partcv[0] = 1;
  Object opresult3186 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3186 (depth = 8)
  *var_s = opresult3186;
  if (opresult3186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3190 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3192 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3191);
// compiled call node returning call3192 (depth = 12)
// compiled member node returning call3192 (depth = 11)
  partcv[0] = 0;
  Object call3193 = callmethod(call3192, "size",
    1, partcv, params);
  gc_frame_end(callframe3190);
// compiled call node returning call3193 (depth = 10)
// compiled member node returning call3193 (depth = 9)
  int op_slot_right_3189 = gc_frame_newslot(call3193);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_3189 = gc_frame_newslot(*var_i);
  params[0] = call3193;
  partcv[0] = 1;
  Object opresult3195 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult3195 (depth = 8)
  Object if3188 = done;
  if (istrue(opresult3195)) {
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit3197 == NULL) {
    strlit3197 = alloc_String(", ");
    gc_root(strlit3197);
  }
// compiled string node returning strlit3197 (depth = 10)
  int op_slot_right_3196 = gc_frame_newslot(strlit3197);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3196 = gc_frame_newslot(*var_s);
  params[0] = strlit3197;
  partcv[0] = 1;
  Object opresult3199 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3199 (depth = 9)
  *var_s = opresult3199;
  if (opresult3199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3188 = done;
  } else {
  }
// compiled if node returning if3188 (depth = 7)
  gc_frame_end(frame);
  return if3188;
}
Object meth_ast_toGrace3126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3127 == NULL) {
    strlit3127 = alloc_String("");
    gc_root(strlit3127);
  }
// compiled string node returning strlit3127 (depth = 5)
  *var_spc = strlit3127;
  if (strlit3127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3128 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3131 = alloc_Float64(1);
// compiled num node returning num3131 (depth = 7)
  int op_slot_right_3130 = gc_frame_newslot(num3131);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3130 = gc_frame_newslot(*var_depth);
  params[0] = num3131;
  partcv[0] = 1;
  Object diff3133 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3133 (depth = 6)
  int op_slot_right_3129 = gc_frame_newslot(diff3133);
// starting to compile num node (depth = 6)
  Object num3135 = alloc_Float64(0);
// compiled num node returning num3135 (depth = 6)
  int op_slot_left_3129 = gc_frame_newslot(num3135);
  params[0] = diff3133;
  partcv[0] = 1;
  Object opresult3136 = callmethod(num3135, "..", 1, partcv, params);
// compiled op node returning opresult3136 (depth = 5)
  gc_frame_newslot(opresult3136);
// starting to compile block node (depth = 5)
  Object block3137 = alloc_Block(NULL, NULL, "ast", 719);
  gc_frame_newslot(block3137);
// method _apply
  block_savedest(block3137);
  Object closure3138 = createclosure(2, "_apply");
  setclosureframe(closure3138, stackframe);
  addtoclosure(closure3138, var_spc);
  addtoclosure(closure3138, selfslot);
  struct UserObject *uo3138 = (struct UserObject*)block3137;
  uo3138->data[0] = (Object)closure3138;
  Method *meth_meth_ast__apply3138 = addmethod2pos(block3137, "_apply", &meth_ast__apply3138, 0);
  int argcv_meth_ast__apply3138[] = {1};
  meth_meth_ast__apply3138->type = alloc_MethodType(1, argcv_meth_ast__apply3138);
  meth_meth_ast__apply3138->definitionModule = modulename;
  meth_meth_ast__apply3138->definitionLine = 713;
// compiled block node returning block3137 (depth = 5)
  gc_frame_newslot(block3137);
// call case 5: prelude request
  params[0] = opresult3136;
  params[1] = block3137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3145 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3128);
// compiled call node returning call3145 (depth = 4)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3146 == NULL) {
    strlit3146 = alloc_String("");
    gc_root(strlit3146);
  }
// compiled string node returning strlit3146 (depth = 5)
  *var_s = strlit3146;
  if (strlit3146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3148 == NULL) {
    strlit3148 = alloc_String("");
    gc_root(strlit3148);
  }
// compiled string node returning strlit3148 (depth = 6)
  int op_slot_right_3147 = gc_frame_newslot(strlit3148);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3151 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3152 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3151);
// compiled call node returning call3152 (depth = 8)
// compiled member node returning call3152 (depth = 7)
  int op_slot_right_3150 = gc_frame_newslot(call3152);
// starting to compile string node (depth = 7)
  if (strlit3154 == NULL) {
    strlit3154 = alloc_String("type ");
    gc_root(strlit3154);
  }
// compiled string node returning strlit3154 (depth = 7)
  int op_slot_left_3150 = gc_frame_newslot(strlit3154);
  params[0] = call3152;
  partcv[0] = 1;
  Object opresult3155 = callmethod(strlit3154, "++", 1, partcv, params);
// compiled op node returning opresult3155 (depth = 6)
  int op_slot_left_3147 = gc_frame_newslot(opresult3155);
  params[0] = strlit3148;
  partcv[0] = 1;
  Object opresult3156 = callmethod(opresult3155, "++", 1, partcv, params);
// compiled op node returning opresult3156 (depth = 5)
  *var_s = opresult3156;
  if (opresult3156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3160 = alloc_Float64(0);
// compiled num node returning num3160 (depth = 6)
  int op_slot_right_3159 = gc_frame_newslot(num3160);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3162 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3164 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3163);
// compiled call node returning call3164 (depth = 9)
// compiled member node returning call3164 (depth = 8)
  partcv[0] = 0;
  Object call3165 = callmethod(call3164, "size",
    1, partcv, params);
  gc_frame_end(callframe3162);
// compiled call node returning call3165 (depth = 7)
// compiled member node returning call3165 (depth = 6)
  int op_slot_left_3159 = gc_frame_newslot(call3165);
  params[0] = num3160;
  partcv[0] = 1;
  Object opresult3166 = callmethod(call3165, ">", 1, partcv, params);
// compiled op node returning opresult3166 (depth = 5)
  Object if3158 = done;
  if (istrue(opresult3166)) {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3168 == NULL) {
    strlit3168 = alloc_String("<");
    gc_root(strlit3168);
  }
// compiled string node returning strlit3168 (depth = 7)
  int op_slot_right_3167 = gc_frame_newslot(strlit3168);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3167 = gc_frame_newslot(*var_s);
  params[0] = strlit3168;
  partcv[0] = 1;
  Object opresult3170 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3170 (depth = 6)
  *var_s = opresult3170;
  if (opresult3170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3172 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3173 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3174 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3175 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3174);
// compiled call node returning call3175 (depth = 9)
// compiled member node returning call3175 (depth = 8)
  partcv[0] = 0;
  Object call3176 = callmethod(call3175, "indices",
    1, partcv, params);
  gc_frame_end(callframe3173);
// compiled call node returning call3176 (depth = 7)
// compiled member node returning call3176 (depth = 6)
  gc_frame_newslot(call3176);
// starting to compile block node (depth = 6)
  Object block3177 = alloc_Block(NULL, NULL, "ast", 726);
  gc_frame_newslot(block3177);
// method _apply
  block_savedest(block3177);
  Object closure3178 = createclosure(2, "_apply");
  setclosureframe(closure3178, stackframe);
  addtoclosure(closure3178, var_s);
  addtoclosure(closure3178, selfslot);
  struct UserObject *uo3178 = (struct UserObject*)block3177;
  uo3178->data[0] = (Object)closure3178;
  Method *meth_meth_ast__apply3178 = addmethod2pos(block3177, "_apply", &meth_ast__apply3178, 0);
  int argcv_meth_ast__apply3178[] = {1};
  meth_meth_ast__apply3178->type = alloc_MethodType(1, argcv_meth_ast__apply3178);
  meth_meth_ast__apply3178->definitionModule = modulename;
  meth_meth_ast__apply3178->definitionLine = 726;
// compiled block node returning block3177 (depth = 6)
  gc_frame_newslot(block3177);
// call case 5: prelude request
  params[0] = call3176;
  params[1] = block3177;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3202 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3172);
// compiled call node returning call3202 (depth = 5)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3204 == NULL) {
    strlit3204 = alloc_String(">");
    gc_root(strlit3204);
  }
// compiled string node returning strlit3204 (depth = 7)
  int op_slot_right_3203 = gc_frame_newslot(strlit3204);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3203 = gc_frame_newslot(*var_s);
  params[0] = strlit3204;
  partcv[0] = 1;
  Object opresult3206 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3206 (depth = 6)
  *var_s = opresult3206;
  if (opresult3206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3158 = done;
  } else {
  }
// compiled if node returning if3158 (depth = 4)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3209 = gc_frame_new();
// starting to compile call node (depth = 7)
  int callframe3210 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3212 = alloc_Float64(2);
// compiled num node returning num3212 (depth = 9)
  int op_slot_right_3211 = gc_frame_newslot(num3212);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_3211 = gc_frame_newslot(*var_depth);
  params[0] = num3212;
  partcv[0] = 1;
  Object sum3214 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3214 (depth = 8)
  gc_frame_newslot(sum3214);
// call case 4: self request
  params[0] = sum3214;
  partcv[0] = 1;
  Object call3215 = callmethodflags(self, "toGrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3210);
// compiled call node returning call3215 (depth = 7)
  gc_frame_newslot(call3215);
// call case 4: self request
  params[0] = call3215;
  partcv[0] = 1;
  Object call3216 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3209);
// compiled call node returning call3216 (depth = 6)
  int op_slot_right_3208 = gc_frame_newslot(call3216);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3219 == NULL) {
    strlit3219 = alloc_String(" = ");
    gc_root(strlit3219);
  }
// compiled string node returning strlit3219 (depth = 7)
  int op_slot_right_3218 = gc_frame_newslot(strlit3219);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3218 = gc_frame_newslot(*var_s);
  params[0] = strlit3219;
  partcv[0] = 1;
  Object opresult3221 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3221 (depth = 6)
  int op_slot_left_3208 = gc_frame_newslot(opresult3221);
  params[0] = call3216;
  partcv[0] = 1;
  Object opresult3222 = callmethod(opresult3221, "++", 1, partcv, params);
// compiled op node returning opresult3222 (depth = 5)
  *var_s = opresult3222;
  if (opresult3222 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString3224(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3226 == NULL) {
    strlit3226 = alloc_String("");
    gc_root(strlit3226);
  }
// compiled string node returning strlit3226 (depth = 5)
  int op_slot_right_3225 = gc_frame_newslot(strlit3226);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3230 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3229);
// compiled call node returning call3230 (depth = 7)
// compiled member node returning call3230 (depth = 6)
  int op_slot_right_3228 = gc_frame_newslot(call3230);
// starting to compile string node (depth = 6)
  if (strlit3232 == NULL) {
    strlit3232 = alloc_String("TypeDec ");
    gc_root(strlit3232);
  }
// compiled string node returning strlit3232 (depth = 6)
  int op_slot_left_3228 = gc_frame_newslot(strlit3232);
  params[0] = call3230;
  partcv[0] = 1;
  Object opresult3233 = callmethod(strlit3232, "++", 1, partcv, params);
// compiled op node returning opresult3233 (depth = 5)
  int op_slot_left_3225 = gc_frame_newslot(opresult3233);
  params[0] = strlit3226;
  partcv[0] = 1;
  Object opresult3234 = callmethod(opresult3233, "++", 1, partcv, params);
// compiled op node returning opresult3234 (depth = 4)
  gc_frame_end(frame);
  return opresult3234;
}
Object meth_ast_shallowCopyWithParent3235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3236 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe3237 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3238 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3239 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3238);
// compiled call node returning call3239 (depth = 7)
// compiled member node returning call3239 (depth = 6)
  gc_frame_newslot(call3239);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_typeDecNode (depth = 6)
  params[0] = call3239;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call3240 = callmethod(*var_typeDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3237);
// compiled call node returning call3240 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3241 = callmethod(call3240, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe3236);
// compiled call node returning call3241 (depth = 4)
  gc_frame_end(frame);
  return call3241;
}
Object meth_ast_new2882(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  Object *var_symbolTableNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2883 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2883 = alloc_userobj2(22,19, objclass2883);
  gc_frame_newslot(obj2883);
if (objclass2883 == NULL) {
  glfree(obj2883->class->name);
  obj2883->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2883, self, 0);
  addmethodreal(obj2883,"outer", &reader_ast_outer_2884);
  Object oldself2883 = self;
  struct StackFrameObject *oldstackframe2883 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2883);
  gc_frame_newslot((Object)stackframe);
  self = obj2883;
  Object *oldselfslot2883 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2883 = (*(struct UserObject *)self).data[0], lowerouter2883 = thisouter2883;
  if (inheritingObject2883) {
    struct UserObject *inho2883 = (struct UserObject *)inheritingObject2883;
    while (inho2883->super != GraceDefaultObject) inho2883 = (struct UserObject *)inho2883->super;
    inho2883->super = obj2883;
    self = inheritingObject2883;
    *selfslot = self;
    lowerouter2883 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2883;
  }
if (objclass2883 == NULL) {
  Method *reader2885 = addmethodrealflags(obj2883, "kind",&reader_ast_kind_2885, MFLAG_DEF);
  reader2885->definitionModule = modulename;
  reader2885->definitionLine = 663;
}
adddatum2(obj2883, alloc_Undefined(), 1);
if (objclass2883 == NULL) {
  Method *reader2886 = addmethodrealflags(obj2883, "name",&reader_ast_name_2886, 0);
  Method *writer2886 = addmethodrealflags(obj2883, "name:=",&writer_ast_name_2886, 0);
  reader2886->definitionModule = modulename;
  writer2886->definitionModule = modulename;
  reader2886->definitionLine = 664;
  writer2886->definitionLine = 664;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 2);
if (objclass2883 == NULL) {
  Method *reader2887 = addmethodrealflags(obj2883, "value",&reader_ast_value_2887, 0);
  Method *writer2887 = addmethodrealflags(obj2883, "value:=",&writer_ast_value_2887, 0);
  reader2887->definitionModule = modulename;
  writer2887->definitionModule = modulename;
  reader2887->definitionLine = 665;
  writer2887->definitionLine = 665;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 3);
if (objclass2883 == NULL) {
  Method *reader2888 = addmethodrealflags(obj2883, "nameString",&reader_ast_nameString_2888, MFLAG_DEF);
  reader2888->definitionModule = modulename;
  reader2888->definitionLine = 666;
}
adddatum2(obj2883, alloc_Undefined(), 4);
if (objclass2883 == NULL) {
  Method *reader2889 = addmethodrealflags(obj2883, "annotations",&reader_ast_annotations_2889, 0);
  Method *writer2889 = addmethodrealflags(obj2883, "annotations:=",&writer_ast_annotations_2889, 0);
  reader2889->definitionModule = modulename;
  writer2889->definitionModule = modulename;
  reader2889->definitionLine = 667;
  writer2889->definitionLine = 667;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 5);
if (objclass2883 == NULL) {
  Method *reader2890 = addmethodrealflags(obj2883, "generics",&reader_ast_generics_2890, 0);
  Method *writer2890 = addmethodrealflags(obj2883, "generics:=",&writer_ast_generics_2890, 0);
  reader2890->definitionModule = modulename;
  writer2890->definitionModule = modulename;
  reader2890->definitionLine = 669;
  writer2890->definitionLine = 669;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 6);
// method declarationKind
  struct UserObject *uo2891 = (struct UserObject*)obj2883;
  uo2891->data[7] = emptyclosure;
  Method *meth_meth_ast_declarationKind2891 = addmethod2pos(obj2883, "declarationKind", &meth_ast_declarationKind2891, 7);
  int argcv_meth_ast_declarationKind2891[] = {0};
  meth_meth_ast_declarationKind2891->type = alloc_MethodType(1, argcv_meth_ast_declarationKind2891);
  meth_meth_ast_declarationKind2891->definitionModule = modulename;
  meth_meth_ast_declarationKind2891->definitionLine = 669;
// method isConfidential
  struct UserObject *uo2893 = (struct UserObject*)obj2883;
  uo2893->data[8] = emptyclosure;
  Method *meth_meth_ast_isConfidential2893 = addmethod2pos(obj2883, "isConfidential", &meth_ast_isConfidential2893, 8);
  int argcv_meth_ast_isConfidential2893[] = {0};
  meth_meth_ast_isConfidential2893->type = alloc_MethodType(1, argcv_meth_ast_isConfidential2893);
  meth_meth_ast_isConfidential2893->definitionModule = modulename;
  meth_meth_ast_isConfidential2893->definitionLine = 672;
// method isPublic
  struct UserObject *uo2911 = (struct UserObject*)obj2883;
  uo2911->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic2911 = addmethod2pos(obj2883, "isPublic", &meth_ast_isPublic2911, 9);
  int argcv_meth_ast_isPublic2911[] = {0};
  meth_meth_ast_isPublic2911->type = alloc_MethodType(1, argcv_meth_ast_isPublic2911);
  meth_meth_ast_isPublic2911->definitionModule = modulename;
  meth_meth_ast_isPublic2911->definitionLine = 676;
// method isWritable
  struct UserObject *uo2916 = (struct UserObject*)obj2883;
  uo2916->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable2916 = addmethod2pos(obj2883, "isWritable", &meth_ast_isWritable2916, 10);
  int argcv_meth_ast_isWritable2916[] = {0};
  meth_meth_ast_isWritable2916->type = alloc_MethodType(1, argcv_meth_ast_isWritable2916);
  meth_meth_ast_isWritable2916->definitionModule = modulename;
  meth_meth_ast_isWritable2916->definitionLine = 677;
// method isReadable
  struct UserObject *uo2918 = (struct UserObject*)obj2883;
  uo2918->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable2918 = addmethod2pos(obj2883, "isReadable", &meth_ast_isReadable2918, 11);
  int argcv_meth_ast_isReadable2918[] = {0};
  meth_meth_ast_isReadable2918->type = alloc_MethodType(1, argcv_meth_ast_isReadable2918);
  meth_meth_ast_isReadable2918->definitionModule = modulename;
  meth_meth_ast_isReadable2918->definitionLine = 678;
// method accept()from
  struct UserObject *uo2921 = (struct UserObject*)obj2883;
  uo2921->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2921 = addmethod2pos(obj2883, "accept()from", &meth_ast_accept_40__41_from2921, 12);
  int argcv_meth_ast_accept_40__41_from2921[] = {1, 1};
  meth_meth_ast_accept_40__41_from2921->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2921);
  meth_meth_ast_accept_40__41_from2921->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2921->definitionLine = 680;
// method map()parent
  struct UserObject *uo2947 = (struct UserObject*)obj2883;
  uo2947->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent2947 = addmethod2pos(obj2883, "map()parent", &meth_ast_map_40__41_parent2947, 13);
  int argcv_meth_ast_map_40__41_parent2947[] = {1, 1};
  meth_meth_ast_map_40__41_parent2947->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent2947);
  meth_meth_ast_map_40__41_parent2947->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent2947->definitionLine = 687;
// method pretty
  struct UserObject *uo3005 = (struct UserObject*)obj2883;
  uo3005->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty3005 = addmethod2pos(obj2883, "pretty", &meth_ast_pretty3005, 14);
  int argcv_meth_ast_pretty3005[] = {1};
  meth_meth_ast_pretty3005->type = alloc_MethodType(1, argcv_meth_ast_pretty3005);
  meth_meth_ast_pretty3005->definitionModule = modulename;
  meth_meth_ast_pretty3005->definitionLine = 699;
// method toGrace
  struct UserObject *uo3126 = (struct UserObject*)obj2883;
  uo3126->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace3126 = addmethod2pos(obj2883, "toGrace", &meth_ast_toGrace3126, 15);
  int argcv_meth_ast_toGrace3126[] = {1};
  meth_meth_ast_toGrace3126->type = alloc_MethodType(1, argcv_meth_ast_toGrace3126);
meth_meth_ast_toGrace3126->type->types[0] = type_Number;
meth_meth_ast_toGrace3126->type->names[0] = "depth";
  meth_meth_ast_toGrace3126->definitionModule = modulename;
  meth_meth_ast_toGrace3126->definitionLine = 717;
// method asString
  struct UserObject *uo3224 = (struct UserObject*)obj2883;
  uo3224->data[16] = emptyclosure;
  Method *meth_meth_ast_asString3224 = addmethod2pos(obj2883, "asString", &meth_ast_asString3224, 16);
  int argcv_meth_ast_asString3224[] = {0};
  meth_meth_ast_asString3224->type = alloc_MethodType(1, argcv_meth_ast_asString3224);
  meth_meth_ast_asString3224->definitionModule = modulename;
  meth_meth_ast_asString3224->definitionLine = 737;
// method shallowCopyWithParent
  block_savedest(obj2883);
  Object closure3235 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure3235, stackframe);
  addtoclosure(closure3235, var_nullNode);
  addtoclosure(closure3235, var_typeDecNode);
  struct UserObject *uo3235 = (struct UserObject*)obj2883;
  uo3235->data[17] = (Object)closure3235;
  Method *meth_meth_ast_shallowCopyWithParent3235 = addmethod2pos(obj2883, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent3235, 17);
  int argcv_meth_ast_shallowCopyWithParent3235[] = {1};
  meth_meth_ast_shallowCopyWithParent3235->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent3235);
  meth_meth_ast_shallowCopyWithParent3235->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent3235->definitionLine = 738;
  sourceObject = obj2883;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3242 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3243 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3242);
// compiled call node returning call3243 (depth = 4)
  struct UserObject *obj2883_uo = (struct UserObject *)obj2883;
  obj2883_uo->super = call3243;
  sourceObject = obj2883;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3244 == NULL) {
    strlit3244 = alloc_String("typedec");
    gc_root(strlit3244);
  }
// compiled string node returning strlit3244 (depth = 4)
  adddatum2(obj2883, strlit3244, 1);
  sourceObject = obj2883;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj2883, *var_name_39_, 2);
  sourceObject = obj2883;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeValue (depth = 4)
  adddatum2(obj2883, *var_typeValue, 3);
  sourceObject = obj2883;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3245 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3247 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3246);
// compiled call node returning call3247 (depth = 7)
// compiled member node returning call3247 (depth = 6)
  partcv[0] = 0;
  Object call3248 = callmethod(call3247, "value",
    1, partcv, params);
  gc_frame_end(callframe3245);
// compiled call node returning call3248 (depth = 5)
// compiled member node returning call3248 (depth = 4)
  adddatum2(obj2883, call3248, 4);
  sourceObject = obj2883;
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3249 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3250 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3251 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3250);
// compiled call node returning call3251 (depth = 7)
// compiled member node returning call3251 (depth = 6)
  partcv[0] = 0;
  Object call3252 = callmethod(call3251, "empty",
    1, partcv, params);
  gc_frame_end(callframe3249);
// compiled call node returning call3252 (depth = 5)
// compiled member node returning call3252 (depth = 4)
  adddatum2(obj2883, call3252, 5);
  sourceObject = obj2883;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3253 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3254 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3255 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3254);
// compiled call node returning call3255 (depth = 7)
// compiled member node returning call3255 (depth = 6)
  partcv[0] = 0;
  Object call3256 = callmethod(call3255, "empty",
    1, partcv, params);
  gc_frame_end(callframe3253);
// compiled call node returning call3256 (depth = 5)
// compiled member node returning call3256 (depth = 4)
  adddatum2(obj2883, call3256, 6);
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
objclass2883 = obj2883->class;
  objclass2883->definitionModule = modulename;
  objclass2883->definitionLine = 660;
  (*(struct UserObject *)self).data[0] = lowerouter2883;
  self = oldself2883;
  selfslot = oldselfslot2883;
  stackframe = oldstackframe2883;
  gc_frame_end(frame);
  return obj2883;
}
Object meth_ast_new2882_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_typeDecNode = getfromclosure(closure, 1);
  Object *var_symbolTableNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_typeValue = &(stackframe->slots[1]);
  *var_typeValue = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2883 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2883 = alloc_userobj2(22,19, objclass2883);
  gc_frame_newslot(obj2883);
if (objclass2883 == NULL) {
  glfree(obj2883->class->name);
  obj2883->class->name = "typeDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2883, self, 0);
  addmethodreal(obj2883,"outer", &reader_ast_outer_2884);
  Object oldself2883 = self;
  struct StackFrameObject *oldstackframe2883 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2883);
  gc_frame_newslot((Object)stackframe);
  self = obj2883;
  Object *oldselfslot2883 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2883 = (*(struct UserObject *)self).data[0], lowerouter2883 = thisouter2883;
  if (inheritingObject2883) {
    struct UserObject *inho2883 = (struct UserObject *)inheritingObject2883;
    while (inho2883->super != GraceDefaultObject) inho2883 = (struct UserObject *)inho2883->super;
    inho2883->super = obj2883;
    self = inheritingObject2883;
    *selfslot = self;
    lowerouter2883 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2883;
  }
if (objclass2883 == NULL) {
  Method *reader2885 = addmethodrealflags(obj2883, "kind",&reader_ast_kind_2885, MFLAG_DEF);
  reader2885->definitionModule = modulename;
  reader2885->definitionLine = 663;
}
adddatum2(obj2883, alloc_Undefined(), 1);
if (objclass2883 == NULL) {
  Method *reader2886 = addmethodrealflags(obj2883, "name",&reader_ast_name_2886, 0);
  Method *writer2886 = addmethodrealflags(obj2883, "name:=",&writer_ast_name_2886, 0);
  reader2886->definitionModule = modulename;
  writer2886->definitionModule = modulename;
  reader2886->definitionLine = 664;
  writer2886->definitionLine = 664;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 2);
if (objclass2883 == NULL) {
  Method *reader2887 = addmethodrealflags(obj2883, "value",&reader_ast_value_2887, 0);
  Method *writer2887 = addmethodrealflags(obj2883, "value:=",&writer_ast_value_2887, 0);
  reader2887->definitionModule = modulename;
  writer2887->definitionModule = modulename;
  reader2887->definitionLine = 665;
  writer2887->definitionLine = 665;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 3);
if (objclass2883 == NULL) {
  Method *reader2888 = addmethodrealflags(obj2883, "nameString",&reader_ast_nameString_2888, MFLAG_DEF);
  reader2888->definitionModule = modulename;
  reader2888->definitionLine = 666;
}
adddatum2(obj2883, alloc_Undefined(), 4);
if (objclass2883 == NULL) {
  Method *reader2889 = addmethodrealflags(obj2883, "annotations",&reader_ast_annotations_2889, 0);
  Method *writer2889 = addmethodrealflags(obj2883, "annotations:=",&writer_ast_annotations_2889, 0);
  reader2889->definitionModule = modulename;
  writer2889->definitionModule = modulename;
  reader2889->definitionLine = 667;
  writer2889->definitionLine = 667;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 5);
if (objclass2883 == NULL) {
  Method *reader2890 = addmethodrealflags(obj2883, "generics",&reader_ast_generics_2890, 0);
  Method *writer2890 = addmethodrealflags(obj2883, "generics:=",&writer_ast_generics_2890, 0);
  reader2890->definitionModule = modulename;
  writer2890->definitionModule = modulename;
  reader2890->definitionLine = 669;
  writer2890->definitionLine = 669;
}
obj2883->flags |= OFLAG_MUTABLE;
adddatum2(obj2883, alloc_Undefined(), 6);
// method declarationKind
  struct UserObject *uo2891 = (struct UserObject*)obj2883;
  uo2891->data[7] = emptyclosure;
  Method *meth_meth_ast_declarationKind2891 = addmethod2pos(obj2883, "declarationKind", &meth_ast_declarationKind2891, 7);
  int argcv_meth_ast_declarationKind2891[] = {0};
  meth_meth_ast_declarationKind2891->type = alloc_MethodType(1, argcv_meth_ast_declarationKind2891);
  meth_meth_ast_declarationKind2891->definitionModule = modulename;
  meth_meth_ast_declarationKind2891->definitionLine = 669;
// method isConfidential
  struct UserObject *uo2893 = (struct UserObject*)obj2883;
  uo2893->data[8] = emptyclosure;
  Method *meth_meth_ast_isConfidential2893 = addmethod2pos(obj2883, "isConfidential", &meth_ast_isConfidential2893, 8);
  int argcv_meth_ast_isConfidential2893[] = {0};
  meth_meth_ast_isConfidential2893->type = alloc_MethodType(1, argcv_meth_ast_isConfidential2893);
  meth_meth_ast_isConfidential2893->definitionModule = modulename;
  meth_meth_ast_isConfidential2893->definitionLine = 672;
// method isPublic
  struct UserObject *uo2911 = (struct UserObject*)obj2883;
  uo2911->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic2911 = addmethod2pos(obj2883, "isPublic", &meth_ast_isPublic2911, 9);
  int argcv_meth_ast_isPublic2911[] = {0};
  meth_meth_ast_isPublic2911->type = alloc_MethodType(1, argcv_meth_ast_isPublic2911);
  meth_meth_ast_isPublic2911->definitionModule = modulename;
  meth_meth_ast_isPublic2911->definitionLine = 676;
// method isWritable
  struct UserObject *uo2916 = (struct UserObject*)obj2883;
  uo2916->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable2916 = addmethod2pos(obj2883, "isWritable", &meth_ast_isWritable2916, 10);
  int argcv_meth_ast_isWritable2916[] = {0};
  meth_meth_ast_isWritable2916->type = alloc_MethodType(1, argcv_meth_ast_isWritable2916);
  meth_meth_ast_isWritable2916->definitionModule = modulename;
  meth_meth_ast_isWritable2916->definitionLine = 677;
// method isReadable
  struct UserObject *uo2918 = (struct UserObject*)obj2883;
  uo2918->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable2918 = addmethod2pos(obj2883, "isReadable", &meth_ast_isReadable2918, 11);
  int argcv_meth_ast_isReadable2918[] = {0};
  meth_meth_ast_isReadable2918->type = alloc_MethodType(1, argcv_meth_ast_isReadable2918);
  meth_meth_ast_isReadable2918->definitionModule = modulename;
  meth_meth_ast_isReadable2918->definitionLine = 678;
// method accept()from
  struct UserObject *uo2921 = (struct UserObject*)obj2883;
  uo2921->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from2921 = addmethod2pos(obj2883, "accept()from", &meth_ast_accept_40__41_from2921, 12);
  int argcv_meth_ast_accept_40__41_from2921[] = {1, 1};
  meth_meth_ast_accept_40__41_from2921->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from2921);
  meth_meth_ast_accept_40__41_from2921->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from2921->definitionLine = 680;
// method map()parent
  struct UserObject *uo2947 = (struct UserObject*)obj2883;
  uo2947->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent2947 = addmethod2pos(obj2883, "map()parent", &meth_ast_map_40__41_parent2947, 13);
  int argcv_meth_ast_map_40__41_parent2947[] = {1, 1};
  meth_meth_ast_map_40__41_parent2947->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent2947);
  meth_meth_ast_map_40__41_parent2947->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent2947->definitionLine = 687;
// method pretty
  struct UserObject *uo3005 = (struct UserObject*)obj2883;
  uo3005->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty3005 = addmethod2pos(obj2883, "pretty", &meth_ast_pretty3005, 14);
  int argcv_meth_ast_pretty3005[] = {1};
  meth_meth_ast_pretty3005->type = alloc_MethodType(1, argcv_meth_ast_pretty3005);
  meth_meth_ast_pretty3005->definitionModule = modulename;
  meth_meth_ast_pretty3005->definitionLine = 699;
// method toGrace
  struct UserObject *uo3126 = (struct UserObject*)obj2883;
  uo3126->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace3126 = addmethod2pos(obj2883, "toGrace", &meth_ast_toGrace3126, 15);
  int argcv_meth_ast_toGrace3126[] = {1};
  meth_meth_ast_toGrace3126->type = alloc_MethodType(1, argcv_meth_ast_toGrace3126);
meth_meth_ast_toGrace3126->type->types[0] = type_Number;
meth_meth_ast_toGrace3126->type->names[0] = "depth";
  meth_meth_ast_toGrace3126->definitionModule = modulename;
  meth_meth_ast_toGrace3126->definitionLine = 717;
// method asString
  struct UserObject *uo3224 = (struct UserObject*)obj2883;
  uo3224->data[16] = emptyclosure;
  Method *meth_meth_ast_asString3224 = addmethod2pos(obj2883, "asString", &meth_ast_asString3224, 16);
  int argcv_meth_ast_asString3224[] = {0};
  meth_meth_ast_asString3224->type = alloc_MethodType(1, argcv_meth_ast_asString3224);
  meth_meth_ast_asString3224->definitionModule = modulename;
  meth_meth_ast_asString3224->definitionLine = 737;
// method shallowCopyWithParent
  block_savedest(obj2883);
  Object closure3235 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure3235, stackframe);
  addtoclosure(closure3235, var_nullNode);
  addtoclosure(closure3235, var_typeDecNode);
  struct UserObject *uo3235 = (struct UserObject*)obj2883;
  uo3235->data[17] = (Object)closure3235;
  Method *meth_meth_ast_shallowCopyWithParent3235 = addmethod2pos(obj2883, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent3235, 17);
  int argcv_meth_ast_shallowCopyWithParent3235[] = {1};
  meth_meth_ast_shallowCopyWithParent3235->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent3235);
  meth_meth_ast_shallowCopyWithParent3235->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent3235->definitionLine = 738;
  sourceObject = obj2883;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3242 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3243 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3242);
// compiled call node returning call3243 (depth = 4)
  struct UserObject *obj2883_uo = (struct UserObject *)obj2883;
  obj2883_uo->super = call3243;
  sourceObject = obj2883;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3244 == NULL) {
    strlit3244 = alloc_String("typedec");
    gc_root(strlit3244);
  }
// compiled string node returning strlit3244 (depth = 4)
  adddatum2(obj2883, strlit3244, 1);
  sourceObject = obj2883;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj2883, *var_name_39_, 2);
  sourceObject = obj2883;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_typeValue (depth = 4)
  adddatum2(obj2883, *var_typeValue, 3);
  sourceObject = obj2883;
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3245 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3247 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3246);
// compiled call node returning call3247 (depth = 7)
// compiled member node returning call3247 (depth = 6)
  partcv[0] = 0;
  Object call3248 = callmethod(call3247, "value",
    1, partcv, params);
  gc_frame_end(callframe3245);
// compiled call node returning call3248 (depth = 5)
// compiled member node returning call3248 (depth = 4)
  adddatum2(obj2883, call3248, 4);
  sourceObject = obj2883;
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3249 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3250 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3251 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3250);
// compiled call node returning call3251 (depth = 7)
// compiled member node returning call3251 (depth = 6)
  partcv[0] = 0;
  Object call3252 = callmethod(call3251, "empty",
    1, partcv, params);
  gc_frame_end(callframe3249);
// compiled call node returning call3252 (depth = 5)
// compiled member node returning call3252 (depth = 4)
  adddatum2(obj2883, call3252, 5);
  sourceObject = obj2883;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3253 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3254 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3255 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3254);
// compiled call node returning call3255 (depth = 7)
// compiled member node returning call3255 (depth = 6)
  partcv[0] = 0;
  Object call3256 = callmethod(call3255, "empty",
    1, partcv, params);
  gc_frame_end(callframe3253);
// compiled call node returning call3256 (depth = 5)
// compiled member node returning call3256 (depth = 4)
  adddatum2(obj2883, call3256, 6);
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
  sourceObject = obj2883;
objclass2883 = obj2883->class;
  objclass2883->definitionModule = modulename;
  objclass2883->definitionLine = 660;
  (*(struct UserObject *)self).data[0] = lowerouter2883;
  self = oldself2883;
  selfslot = oldselfslot2883;
  stackframe = oldstackframe2883;
  gc_frame_end(frame);
  return obj2883;
}
Object meth_ast_methodNode3258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for methodNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_methodNode (depth = 3)
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast_declarationKind3275(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit3276 == NULL) {
    strlit3276 = alloc_String("parameter");
    gc_root(strlit3276);
  }
// compiled string node returning strlit3276 (depth = 4)
  gc_frame_end(frame);
  return strlit3276;
}
Object meth_ast_isConfidential3277(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isConfidential");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isConfidential (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isConfidential");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3280 = alloc_Float64(0);
// compiled num node returning num3280 (depth = 6)
  int op_slot_right_3279 = gc_frame_newslot(num3280);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3282 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3284 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3283);
// compiled call node returning call3284 (depth = 9)
// compiled member node returning call3284 (depth = 8)
  partcv[0] = 0;
  Object call3285 = callmethod(call3284, "size",
    1, partcv, params);
  gc_frame_end(callframe3282);
// compiled call node returning call3285 (depth = 7)
// compiled member node returning call3285 (depth = 6)
  int op_slot_left_3279 = gc_frame_newslot(call3285);
  params[0] = num3280;
  partcv[0] = 1;
  Object opresult3286 = callmethod(call3285, "==", 1, partcv, params);
// compiled op node returning opresult3286 (depth = 5)
  Object if3278 = done;
  if (istrue(opresult3286)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3287 = alloc_Boolean(0);
// compiled identifier node returning bool3287 (depth = 6)
  return bool3287;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3278 = undefined;
  } else {
  }
// compiled if node returning if3278 (depth = 4)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3288 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit3289 == NULL) {
    strlit3289 = alloc_String("confidential");
    gc_root(strlit3289);
  }
// compiled string node returning strlit3289 (depth = 5)
  gc_frame_newslot(strlit3289);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3290 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3291 = gc_frame_new();
// call case 3: self.outer request
  Object call3292 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3291);
// compiled call node returning call3292 (depth = 8)
// compiled member node returning call3292 (depth = 7)
  partcv[0] = 0;
  Object call3293 = callmethodflags(call3292, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3290);
// compiled call node returning call3293 (depth = 6)
// compiled member node returning call3293 (depth = 5)
  params[0] = self;
  params[1] = strlit3289;
  partcv[0] = 2;
  Object call3294 = callmethodflags(call3293, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3288);
// compiled call node returning call3294 (depth = 4)
  gc_frame_end(frame);
  return call3294;
}
Object meth_ast_isPublic3295(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3296 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3298 = callmethodflags(self, "isConfidential", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3297);
// compiled call node returning call3298 (depth = 7)
// compiled member node returning call3298 (depth = 6)
  partcv[0] = 0;
  Object call3299 = callmethod(call3298, "not",
    1, partcv, params);
  gc_frame_end(callframe3296);
// compiled call node returning call3299 (depth = 5)
// compiled member node returning call3299 (depth = 4)
  gc_frame_end(frame);
  return call3299;
}
Object meth_ast_isWritable3300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool3301 = alloc_Boolean(0);
// compiled identifier node returning bool3301 (depth = 4)
  gc_frame_end(frame);
  return bool3301;
}
Object meth_ast_isReadable3302(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3304 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3303);
// compiled call node returning call3304 (depth = 5)
// compiled member node returning call3304 (depth = 4)
  gc_frame_end(frame);
  return call3304;
}
Object meth_ast_usesAsType3305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3307 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3308 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3307);
// compiled call node returning call3308 (depth = 6)
// compiled member node returning call3308 (depth = 5)
  int op_slot_right_3306 = gc_frame_newslot(call3308);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_3306 = gc_frame_newslot(*var_aNode);
  params[0] = call3308;
  partcv[0] = 1;
  Object opresult3310 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult3310 (depth = 4)
  gc_frame_end(frame);
  return opresult3310;
}
Object meth_ast__apply3314(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3315 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3316 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3317 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3318 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3317);
// compiled call node returning call3318 (depth = 11)
// compiled member node returning call3318 (depth = 10)
  partcv[0] = 0;
  Object call3319 = callmethod(call3318, "last",
    1, partcv, params);
  gc_frame_end(callframe3316);
// compiled call node returning call3319 (depth = 9)
// compiled member node returning call3319 (depth = 8)
  partcv[0] = 0;
  Object call3320 = callmethod(call3319, "definesObject",
    1, partcv, params);
  gc_frame_end(callframe3315);
// compiled call node returning call3320 (depth = 7)
// compiled member node returning call3320 (depth = 6)
  gc_frame_end(frame);
  return call3320;
}
Object meth_ast_definesScope3311(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3312 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3313 = alloc_Block(NULL, NULL, "ast", 787);
  gc_frame_newslot(block3313);
// method _apply
  block_savedest(block3313);
  Object closure3314 = createclosure(1, "_apply");
  setclosureframe(closure3314, stackframe);
  addtoclosure(closure3314, selfslot);
  struct UserObject *uo3314 = (struct UserObject*)block3313;
  uo3314->data[0] = (Object)closure3314;
  Method *meth_meth_ast__apply3314 = addmethod2pos(block3313, "_apply", &meth_ast__apply3314, 0);
  int argcv_meth_ast__apply3314[] = {0};
  meth_meth_ast__apply3314->type = alloc_MethodType(1, argcv_meth_ast__apply3314);
  meth_meth_ast__apply3314->definitionModule = modulename;
  meth_meth_ast__apply3314->definitionLine = 784;
// compiled block node returning block3313 (depth = 5)
  gc_frame_newslot(block3313);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3322 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3323 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3324 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3325 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3324);
// compiled call node returning call3325 (depth = 10)
// compiled member node returning call3325 (depth = 9)
  partcv[0] = 0;
  Object call3326 = callmethod(call3325, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe3323);
// compiled call node returning call3326 (depth = 8)
// compiled member node returning call3326 (depth = 7)
  partcv[0] = 0;
  Object call3327 = callmethod(call3326, "not",
    1, partcv, params);
  gc_frame_end(callframe3322);
// compiled call node returning call3327 (depth = 6)
// compiled member node returning call3327 (depth = 5)
  params[0] = block3313;
  partcv[0] = 1;
  Object call3328 = callmethod(call3327, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3312);
// compiled call node returning call3328 (depth = 4)
  gc_frame_end(frame);
  return call3328;
}
Object meth_ast_objectScope3329(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "objectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for objectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for objectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3330 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3332 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3331);
// compiled call node returning call3332 (depth = 7)
// compiled member node returning call3332 (depth = 6)
  partcv[0] = 0;
  Object call3333 = callmethod(call3332, "parent",
    1, partcv, params);
  gc_frame_end(callframe3330);
// compiled call node returning call3333 (depth = 5)
// compiled member node returning call3333 (depth = 4)
  gc_frame_end(frame);
  return call3333;
}
Object meth_ast__apply3340(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe3341 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_b (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3342 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe3341);
// compiled call node returning call3342 (depth = 8)
  gc_frame_end(frame);
  return call3342;
}
Object meth_ast__apply3337(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3338 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3339 = alloc_Block(NULL, NULL, "ast", 794);
  gc_frame_newslot(block3339);
// method _apply
  block_savedest(block3339);
  Object closure3340 = createclosure(2, "_apply");
  setclosureframe(closure3340, stackframe);
  addtoclosure(closure3340, var_b);
  addtoclosure(closure3340, selfslot);
  struct UserObject *uo3340 = (struct UserObject*)block3339;
  uo3340->data[0] = (Object)closure3340;
  Method *meth_meth_ast__apply3340 = addmethod2pos(block3339, "_apply", &meth_ast__apply3340, 0);
  int argcv_meth_ast__apply3340[] = {1};
  meth_meth_ast__apply3340->type = alloc_MethodType(1, argcv_meth_ast__apply3340);
  meth_meth_ast__apply3340->definitionModule = modulename;
  meth_meth_ast__apply3340->definitionLine = 790;
// compiled block node returning block3339 (depth = 7)
  gc_frame_newslot(block3339);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3344 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call3345 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3344);
// compiled call node returning call3345 (depth = 8)
// compiled member node returning call3345 (depth = 7)
  params[0] = block3339;
  partcv[0] = 1;
  Object call3346 = callmethod(call3345, "do",
    1, partcv, params);
  gc_frame_end(callframe3338);
// compiled call node returning call3346 (depth = 6)
  gc_frame_end(frame);
  return call3346;
}
Object meth_ast_parametersDo3334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3335 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3336 = alloc_Block(NULL, NULL, "ast", 793);
  gc_frame_newslot(block3336);
// method _apply
  block_savedest(block3336);
  Object closure3337 = createclosure(2, "_apply");
  setclosureframe(closure3337, stackframe);
  addtoclosure(closure3337, var_b);
  addtoclosure(closure3337, selfslot);
  struct UserObject *uo3337 = (struct UserObject*)block3336;
  uo3337->data[0] = (Object)closure3337;
  Method *meth_meth_ast__apply3337 = addmethod2pos(block3336, "_apply", &meth_ast__apply3337, 0);
  int argcv_meth_ast__apply3337[] = {1};
  meth_meth_ast__apply3337->type = alloc_MethodType(1, argcv_meth_ast__apply3337);
  meth_meth_ast__apply3337->definitionModule = modulename;
  meth_meth_ast__apply3337->definitionLine = 790;
// compiled block node returning block3336 (depth = 5)
  gc_frame_newslot(block3336);
// call case 6: other member request
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3349 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3348);
// compiled call node returning call3349 (depth = 6)
// compiled member node returning call3349 (depth = 5)
  params[0] = block3336;
  partcv[0] = 1;
  Object call3350 = callmethod(call3349, "do",
    1, partcv, params);
  gc_frame_end(callframe3335);
// compiled call node returning call3350 (depth = 4)
  gc_frame_end(frame);
  return call3350;
}
Object meth_ast__apply3361(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3362 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3363 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe3362);
// compiled call node returning call3363 (depth = 7)
  gc_frame_end(frame);
  return call3363;
}
Object meth_ast_typeParametersDo3351(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "typeParametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method typeParametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeParametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for typeParametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3354 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3355 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3354);
// compiled call node returning call3355 (depth = 7)
// compiled member node returning call3355 (depth = 6)
  int op_slot_right_3353 = gc_frame_newslot(call3355);
// starting to compile identifier node (depth = 6)
  Object bool3357 = alloc_Boolean(0);
// compiled identifier node returning bool3357 (depth = 6)
  int op_slot_left_3353 = gc_frame_newslot(bool3357);
  params[0] = call3355;
  partcv[0] = 1;
  Object opresult3358 = callmethod(bool3357, "!=", 1, partcv, params);
// compiled op node returning opresult3358 (depth = 5)
  Object if3352 = done;
  if (istrue(opresult3358)) {
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3359 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3360 = alloc_Block(NULL, NULL, "ast", 799);
  gc_frame_newslot(block3360);
// method _apply
  block_savedest(block3360);
  Object closure3361 = createclosure(2, "_apply");
  setclosureframe(closure3361, stackframe);
  addtoclosure(closure3361, var_b);
  addtoclosure(closure3361, selfslot);
  struct UserObject *uo3361 = (struct UserObject*)block3360;
  uo3361->data[0] = (Object)closure3361;
  Method *meth_meth_ast__apply3361 = addmethod2pos(block3360, "_apply", &meth_ast__apply3361, 0);
  int argcv_meth_ast__apply3361[] = {1};
  meth_meth_ast__apply3361->type = alloc_MethodType(1, argcv_meth_ast__apply3361);
  meth_meth_ast__apply3361->definitionModule = modulename;
  meth_meth_ast__apply3361->definitionLine = 798;
// compiled block node returning block3360 (depth = 6)
  gc_frame_newslot(block3360);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3366 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3365);
// compiled call node returning call3366 (depth = 7)
// compiled member node returning call3366 (depth = 6)
  params[0] = block3360;
  partcv[0] = 1;
  Object call3367 = callmethod(call3366, "do",
    1, partcv, params);
  gc_frame_end(callframe3359);
// compiled call node returning call3367 (depth = 5)
    gc_frame_newslot(call3367);
    if3352 = call3367;
  } else {
  }
// compiled if node returning if3352 (depth = 4)
  gc_frame_end(frame);
  return if3352;
}
Object meth_ast__apply3391(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3392 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3393 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3392);
// compiled call node returning call3393 (depth = 7)
  gc_frame_end(frame);
  return call3393;
}
Object meth_ast__apply3405(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3406 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_visitor (depth = 10)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning self (depth = 10)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3407 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3406);
// compiled call node returning call3407 (depth = 9)
  gc_frame_end(frame);
  return call3407;
}
Object meth_ast__apply3400(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3401 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3403 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3402);
// compiled call node returning call3403 (depth = 9)
// compiled member node returning call3403 (depth = 8)
  gc_frame_newslot(call3403);
// starting to compile block node (depth = 8)
  Object block3404 = alloc_Block(NULL, NULL, "ast", 812);
  gc_frame_newslot(block3404);
// method _apply
  block_savedest(block3404);
  Object closure3405 = createclosure(2, "_apply");
  setclosureframe(closure3405, stackframe);
  addtoclosure(closure3405, var_visitor);
  addtoclosure(closure3405, selfslot);
  struct UserObject *uo3405 = (struct UserObject*)block3404;
  uo3405->data[0] = (Object)closure3405;
  Method *meth_meth_ast__apply3405 = addmethod2pos(block3404, "_apply", &meth_ast__apply3405, 0);
  int argcv_meth_ast__apply3405[] = {1};
  meth_meth_ast__apply3405->type = alloc_MethodType(1, argcv_meth_ast__apply3405);
  meth_meth_ast__apply3405->definitionModule = modulename;
  meth_meth_ast__apply3405->definitionLine = 812;
// compiled block node returning block3404 (depth = 8)
  gc_frame_newslot(block3404);
// call case 5: prelude request
  params[0] = call3403;
  params[1] = block3404;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3409 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3401);
// compiled call node returning call3409 (depth = 7)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3412 = alloc_Boolean(0);
// compiled identifier node returning bool3412 (depth = 9)
  int op_slot_right_3411 = gc_frame_newslot(bool3412);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call3415 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3414);
// compiled call node returning call3415 (depth = 10)
// compiled member node returning call3415 (depth = 9)
  int op_slot_left_3411 = gc_frame_newslot(call3415);
  params[0] = bool3412;
  partcv[0] = 1;
  Object opresult3416 = callmethod(call3415, "!=", 1, partcv, params);
// compiled op node returning opresult3416 (depth = 8)
  Object if3410 = done;
  if (istrue(opresult3416)) {
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3417 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_visitor (depth = 9)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning self (depth = 9)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call3419 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3418);
// compiled call node returning call3419 (depth = 10)
// compiled member node returning call3419 (depth = 9)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3420 = callmethod(call3419, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3417);
// compiled call node returning call3420 (depth = 8)
    gc_frame_newslot(call3420);
    if3410 = call3420;
  } else {
  }
// compiled if node returning if3410 (depth = 7)
  gc_frame_end(frame);
  return if3410;
}
Object meth_ast__apply3427(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3428 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mx (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3429 = callmethod(*var_mx, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3428);
// compiled call node returning call3429 (depth = 7)
  gc_frame_end(frame);
  return call3429;
}
Object meth_ast_accept_40__41_from3368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3370 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3371 = callmethod(*var_visitor, "visitMethod()up",
    2, partcv, params);
  gc_frame_end(callframe3370);
// compiled call node returning call3371 (depth = 5)
  Object if3369 = done;
  if (istrue(call3371)) {
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3372 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3374 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3373);
// compiled call node returning call3374 (depth = 7)
// compiled member node returning call3374 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3375 = callmethod(call3374, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3372);
// compiled call node returning call3375 (depth = 5)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3378 = alloc_Boolean(0);
// compiled identifier node returning bool3378 (depth = 7)
  int op_slot_right_3377 = gc_frame_newslot(bool3378);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3380 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3381 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3380);
// compiled call node returning call3381 (depth = 8)
// compiled member node returning call3381 (depth = 7)
  int op_slot_left_3377 = gc_frame_newslot(call3381);
  params[0] = bool3378;
  partcv[0] = 1;
  Object opresult3382 = callmethod(call3381, "!=", 1, partcv, params);
// compiled op node returning opresult3382 (depth = 6)
  Object if3376 = done;
  if (istrue(opresult3382)) {
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3383 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3385 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3384);
// compiled call node returning call3385 (depth = 8)
// compiled member node returning call3385 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3386 = callmethod(call3385, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe3383);
// compiled call node returning call3386 (depth = 6)
    gc_frame_newslot(call3386);
    if3376 = call3386;
  } else {
  }
// compiled if node returning if3376 (depth = 5)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3387 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3388 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3389 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3388);
// compiled call node returning call3389 (depth = 7)
// compiled member node returning call3389 (depth = 6)
  gc_frame_newslot(call3389);
// starting to compile block node (depth = 6)
  Object block3390 = alloc_Block(NULL, NULL, "ast", 808);
  gc_frame_newslot(block3390);
// method _apply
  block_savedest(block3390);
  Object closure3391 = createclosure(2, "_apply");
  setclosureframe(closure3391, stackframe);
  addtoclosure(closure3391, var_visitor);
  addtoclosure(closure3391, selfslot);
  struct UserObject *uo3391 = (struct UserObject*)block3390;
  uo3391->data[0] = (Object)closure3391;
  Method *meth_meth_ast__apply3391 = addmethod2pos(block3390, "_apply", &meth_ast__apply3391, 0);
  int argcv_meth_ast__apply3391[] = {1};
  meth_meth_ast__apply3391->type = alloc_MethodType(1, argcv_meth_ast__apply3391);
  meth_meth_ast__apply3391->definitionModule = modulename;
  meth_meth_ast__apply3391->definitionLine = 808;
// compiled block node returning block3390 (depth = 6)
  gc_frame_newslot(block3390);
// call case 5: prelude request
  params[0] = call3389;
  params[1] = block3390;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3395 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3387);
// compiled call node returning call3395 (depth = 5)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3396 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3398 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3397);
// compiled call node returning call3398 (depth = 7)
// compiled member node returning call3398 (depth = 6)
  gc_frame_newslot(call3398);
// starting to compile block node (depth = 6)
  Object block3399 = alloc_Block(NULL, NULL, "ast", 811);
  gc_frame_newslot(block3399);
// method _apply
  block_savedest(block3399);
  Object closure3400 = createclosure(2, "_apply");
  setclosureframe(closure3400, stackframe);
  addtoclosure(closure3400, var_visitor);
  addtoclosure(closure3400, selfslot);
  struct UserObject *uo3400 = (struct UserObject*)block3399;
  uo3400->data[0] = (Object)closure3400;
  Method *meth_meth_ast__apply3400 = addmethod2pos(block3399, "_apply", &meth_ast__apply3400, 0);
  int argcv_meth_ast__apply3400[] = {1};
  meth_meth_ast__apply3400->type = alloc_MethodType(1, argcv_meth_ast__apply3400);
  meth_meth_ast__apply3400->definitionModule = modulename;
  meth_meth_ast__apply3400->definitionLine = 811;
// compiled block node returning block3399 (depth = 6)
  gc_frame_newslot(block3399);
// call case 5: prelude request
  params[0] = call3398;
  params[1] = block3399;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3422 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3396);
// compiled call node returning call3422 (depth = 5)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3423 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3424 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3425 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compiled call node returning call3425 (depth = 7)
// compiled member node returning call3425 (depth = 6)
  gc_frame_newslot(call3425);
// starting to compile block node (depth = 6)
  Object block3426 = alloc_Block(NULL, NULL, "ast", 819);
  gc_frame_newslot(block3426);
// method _apply
  block_savedest(block3426);
  Object closure3427 = createclosure(2, "_apply");
  setclosureframe(closure3427, stackframe);
  addtoclosure(closure3427, var_visitor);
  addtoclosure(closure3427, selfslot);
  struct UserObject *uo3427 = (struct UserObject*)block3426;
  uo3427->data[0] = (Object)closure3427;
  Method *meth_meth_ast__apply3427 = addmethod2pos(block3426, "_apply", &meth_ast__apply3427, 0);
  int argcv_meth_ast__apply3427[] = {1};
  meth_meth_ast__apply3427->type = alloc_MethodType(1, argcv_meth_ast__apply3427);
  meth_meth_ast__apply3427->definitionModule = modulename;
  meth_meth_ast__apply3427->definitionLine = 819;
// compiled block node returning block3426 (depth = 6)
  gc_frame_newslot(block3426);
// call case 5: prelude request
  params[0] = call3425;
  params[1] = block3426;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3431 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3423);
// compiled call node returning call3431 (depth = 5)
    gc_frame_newslot(call3431);
    if3369 = call3431;
  } else {
  }
// compiled if node returning if3369 (depth = 4)
  gc_frame_end(frame);
  return if3369;
}
Object meth_ast_map_40__41_parent3432(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3433 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call3434 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3433);
// compiled call node returning call3434 (depth = 5)
  *var_n = call3434;
  if (call3434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3435 = gc_frame_new();
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3436 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3437 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3438 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3437);
// compiled call node returning call3438 (depth = 8)
// compiled member node returning call3438 (depth = 7)
  gc_frame_newslot(call3438);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3439 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3440 = gc_frame_new();
// call case 3: self.outer request
  Object call3441 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3440);
// compiled call node returning call3441 (depth = 10)
// compiled member node returning call3441 (depth = 9)
  partcv[0] = 0;
  Object call3442 = callmethodflags(call3441, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3439);
// compiled call node returning call3442 (depth = 8)
// compiled member node returning call3442 (depth = 7)
  params[0] = call3438;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3443 = callmethodflags(call3442, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3436);
// compiled call node returning call3443 (depth = 6)
  gc_frame_newslot(call3443);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3443;
  partcv[0] = 1;
  Object call3444 = callmethod(*var_n, "body:=",
    1, partcv, params);
  gc_frame_end(callframe3435);
// compiled call node returning call3444 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3445 = gc_frame_new();
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3446 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3447 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3448 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3447);
// compiled call node returning call3448 (depth = 8)
// compiled member node returning call3448 (depth = 7)
  gc_frame_newslot(call3448);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3449 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3450 = gc_frame_new();
// call case 3: self.outer request
  Object call3451 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3450);
// compiled call node returning call3451 (depth = 10)
// compiled member node returning call3451 (depth = 9)
  partcv[0] = 0;
  Object call3452 = callmethodflags(call3451, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3449);
// compiled call node returning call3452 (depth = 8)
// compiled member node returning call3452 (depth = 7)
  params[0] = call3448;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3453 = callmethodflags(call3452, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compiled call node returning call3453 (depth = 6)
  gc_frame_newslot(call3453);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3453;
  partcv[0] = 1;
  Object call3454 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe3445);
// compiled call node returning call3454 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3455 = gc_frame_new();
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3456 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3457 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3458 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3457);
// compiled call node returning call3458 (depth = 8)
// compiled member node returning call3458 (depth = 7)
  gc_frame_newslot(call3458);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3459 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3460 = gc_frame_new();
// call case 3: self.outer request
  Object call3461 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3460);
// compiled call node returning call3461 (depth = 10)
// compiled member node returning call3461 (depth = 9)
  partcv[0] = 0;
  Object call3462 = callmethodflags(call3461, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3459);
// compiled call node returning call3462 (depth = 8)
// compiled member node returning call3462 (depth = 7)
  params[0] = call3458;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3463 = callmethodflags(call3462, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3456);
// compiled call node returning call3463 (depth = 6)
  gc_frame_newslot(call3463);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3463;
  partcv[0] = 1;
  Object call3464 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe3455);
// compiled call node returning call3464 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3465 = gc_frame_new();
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3466 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3467 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3468 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3467);
// compiled call node returning call3468 (depth = 8)
// compiled member node returning call3468 (depth = 7)
  gc_frame_newslot(call3468);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3469 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3470 = gc_frame_new();
// call case 3: self.outer request
  Object call3471 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3470);
// compiled call node returning call3471 (depth = 10)
// compiled member node returning call3471 (depth = 9)
  partcv[0] = 0;
  Object call3472 = callmethodflags(call3471, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3469);
// compiled call node returning call3472 (depth = 8)
// compiled member node returning call3472 (depth = 7)
  params[0] = call3468;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3473 = callmethodflags(call3472, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3466);
// compiled call node returning call3473 (depth = 6)
  gc_frame_newslot(call3473);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3473;
  partcv[0] = 1;
  Object call3474 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe3465);
// compiled call node returning call3474 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3475 = gc_frame_new();
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3476 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3478 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3477);
// compiled call node returning call3478 (depth = 8)
// compiled member node returning call3478 (depth = 7)
  gc_frame_newslot(call3478);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3479 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3480 = gc_frame_new();
// call case 3: self.outer request
  Object call3481 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3480);
// compiled call node returning call3481 (depth = 10)
// compiled member node returning call3481 (depth = 9)
  partcv[0] = 0;
  Object call3482 = callmethodflags(call3481, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3479);
// compiled call node returning call3482 (depth = 8)
// compiled member node returning call3482 (depth = 7)
  params[0] = call3478;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call3483 = callmethodflags(call3482, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3476);
// compiled call node returning call3483 (depth = 6)
  gc_frame_newslot(call3483);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call3483;
  partcv[0] = 1;
  Object call3484 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe3475);
// compiled call node returning call3484 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3485 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3486 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3485);
// compiled call node returning call3486 (depth = 5)
  *var_n = call3486;
  if (call3486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply3496(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3498 == NULL) {
    strlit3498 = alloc_String("  ");
    gc_root(strlit3498);
  }
// compiled string node returning strlit3498 (depth = 8)
  int op_slot_right_3497 = gc_frame_newslot(strlit3498);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3497 = gc_frame_newslot(*var_spc);
  params[0] = strlit3498;
  partcv[0] = 1;
  Object opresult3500 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3500 (depth = 7)
  *var_spc = opresult3500;
  if (opresult3500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3649(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3651 == NULL) {
    strlit3651 = alloc_String("");
    gc_root(strlit3651);
  }
// compiled string node returning strlit3651 (depth = 10)
  int op_slot_right_3650 = gc_frame_newslot(strlit3651);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3654 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3656 = alloc_Float64(4);
// compiled num node returning num3656 (depth = 13)
  int op_slot_right_3655 = gc_frame_newslot(num3656);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_3655 = gc_frame_newslot(*var_depth);
  params[0] = num3656;
  partcv[0] = 1;
  Object sum3658 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3658 (depth = 12)
  gc_frame_newslot(sum3658);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = sum3658;
  partcv[0] = 1;
  Object call3659 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3654);
// compiled call node returning call3659 (depth = 11)
  int op_slot_right_3653 = gc_frame_newslot(call3659);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3662 == NULL) {
    strlit3662 = alloc_String("");
    gc_root(strlit3662);
  }
// compiled string node returning strlit3662 (depth = 12)
  int op_slot_right_3661 = gc_frame_newslot(strlit3662);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_3664 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3667 == NULL) {
    strlit3667 = alloc_String("""\x0a""      ");
    gc_root(strlit3667);
  }
// compiled string node returning strlit3667 (depth = 14)
  int op_slot_right_3666 = gc_frame_newslot(strlit3667);
// starting to compile op node (depth = 14)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_s (depth = 15)
  int op_slot_right_3669 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 15)
  if (strlit3671 == NULL) {
    strlit3671 = alloc_String("");
    gc_root(strlit3671);
  }
// compiled string node returning strlit3671 (depth = 15)
  int op_slot_left_3669 = gc_frame_newslot(strlit3671);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3672 = callmethod(strlit3671, "++", 1, partcv, params);
// compiled op node returning opresult3672 (depth = 14)
  int op_slot_left_3666 = gc_frame_newslot(opresult3672);
  params[0] = strlit3667;
  partcv[0] = 1;
  Object opresult3673 = callmethod(opresult3672, "++", 1, partcv, params);
// compiled op node returning opresult3673 (depth = 13)
  int op_slot_left_3664 = gc_frame_newslot(opresult3673);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3674 = callmethod(opresult3673, "++", 1, partcv, params);
// compiled op node returning opresult3674 (depth = 12)
  int op_slot_left_3661 = gc_frame_newslot(opresult3674);
  params[0] = strlit3662;
  partcv[0] = 1;
  Object opresult3675 = callmethod(opresult3674, "++", 1, partcv, params);
// compiled op node returning opresult3675 (depth = 11)
  int op_slot_left_3653 = gc_frame_newslot(opresult3675);
  params[0] = call3659;
  partcv[0] = 1;
  Object opresult3676 = callmethod(opresult3675, "++", 1, partcv, params);
// compiled op node returning opresult3676 (depth = 10)
  int op_slot_left_3650 = gc_frame_newslot(opresult3676);
  params[0] = strlit3651;
  partcv[0] = 1;
  Object opresult3677 = callmethod(opresult3676, "++", 1, partcv, params);
// compiled op node returning opresult3677 (depth = 9)
  *var_s = opresult3677;
  if (opresult3677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3603(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3605 == NULL) {
    strlit3605 = alloc_String("");
    gc_root(strlit3605);
  }
// compiled string node returning strlit3605 (depth = 8)
  int op_slot_right_3604 = gc_frame_newslot(strlit3605);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3608 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call3609 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3608);
// compiled call node returning call3609 (depth = 10)
// compiled member node returning call3609 (depth = 9)
  int op_slot_right_3607 = gc_frame_newslot(call3609);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3612 == NULL) {
    strlit3612 = alloc_String("Part: ");
    gc_root(strlit3612);
  }
// compiled string node returning strlit3612 (depth = 10)
  int op_slot_right_3611 = gc_frame_newslot(strlit3612);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_3614 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3617 == NULL) {
    strlit3617 = alloc_String("""\x0a""  ");
    gc_root(strlit3617);
  }
// compiled string node returning strlit3617 (depth = 12)
  int op_slot_right_3616 = gc_frame_newslot(strlit3617);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_3619 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit3621 == NULL) {
    strlit3621 = alloc_String("");
    gc_root(strlit3621);
  }
// compiled string node returning strlit3621 (depth = 13)
  int op_slot_left_3619 = gc_frame_newslot(strlit3621);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3622 = callmethod(strlit3621, "++", 1, partcv, params);
// compiled op node returning opresult3622 (depth = 12)
  int op_slot_left_3616 = gc_frame_newslot(opresult3622);
  params[0] = strlit3617;
  partcv[0] = 1;
  Object opresult3623 = callmethod(opresult3622, "++", 1, partcv, params);
// compiled op node returning opresult3623 (depth = 11)
  int op_slot_left_3614 = gc_frame_newslot(opresult3623);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3624 = callmethod(opresult3623, "++", 1, partcv, params);
// compiled op node returning opresult3624 (depth = 10)
  int op_slot_left_3611 = gc_frame_newslot(opresult3624);
  params[0] = strlit3612;
  partcv[0] = 1;
  Object opresult3625 = callmethod(opresult3624, "++", 1, partcv, params);
// compiled op node returning opresult3625 (depth = 9)
  int op_slot_left_3607 = gc_frame_newslot(opresult3625);
  params[0] = call3609;
  partcv[0] = 1;
  Object opresult3626 = callmethod(opresult3625, "++", 1, partcv, params);
// compiled op node returning opresult3626 (depth = 8)
  int op_slot_left_3604 = gc_frame_newslot(opresult3626);
  params[0] = strlit3605;
  partcv[0] = 1;
  Object opresult3627 = callmethod(opresult3626, "++", 1, partcv, params);
// compiled op node returning opresult3627 (depth = 7)
  *var_s = opresult3627;
  if (opresult3627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3630 == NULL) {
    strlit3630 = alloc_String("Parameters:");
    gc_root(strlit3630);
  }
// compiled string node returning strlit3630 (depth = 8)
  int op_slot_right_3629 = gc_frame_newslot(strlit3630);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3632 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3635 == NULL) {
    strlit3635 = alloc_String("""\x0a""    ");
    gc_root(strlit3635);
  }
// compiled string node returning strlit3635 (depth = 10)
  int op_slot_right_3634 = gc_frame_newslot(strlit3635);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_3637 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit3639 == NULL) {
    strlit3639 = alloc_String("");
    gc_root(strlit3639);
  }
// compiled string node returning strlit3639 (depth = 11)
  int op_slot_left_3637 = gc_frame_newslot(strlit3639);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3640 = callmethod(strlit3639, "++", 1, partcv, params);
// compiled op node returning opresult3640 (depth = 10)
  int op_slot_left_3634 = gc_frame_newslot(opresult3640);
  params[0] = strlit3635;
  partcv[0] = 1;
  Object opresult3641 = callmethod(opresult3640, "++", 1, partcv, params);
// compiled op node returning opresult3641 (depth = 9)
  int op_slot_left_3632 = gc_frame_newslot(opresult3641);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3642 = callmethod(opresult3641, "++", 1, partcv, params);
// compiled op node returning opresult3642 (depth = 8)
  int op_slot_left_3629 = gc_frame_newslot(opresult3642);
  params[0] = strlit3630;
  partcv[0] = 1;
  Object opresult3643 = callmethod(opresult3642, "++", 1, partcv, params);
// compiled op node returning opresult3643 (depth = 7)
  *var_s = opresult3643;
  if (opresult3643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3645 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call3647 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3646);
// compiled call node returning call3647 (depth = 8)
// compiled member node returning call3647 (depth = 7)
  gc_frame_newslot(call3647);
// starting to compile block node (depth = 7)
  Object block3648 = alloc_Block(NULL, NULL, "ast", 851);
  gc_frame_newslot(block3648);
// method _apply
  block_savedest(block3648);
  Object closure3649 = createclosure(4, "_apply");
  setclosureframe(closure3649, stackframe);
  addtoclosure(closure3649, var_depth);
  addtoclosure(closure3649, var_spc);
  addtoclosure(closure3649, var_s);
  addtoclosure(closure3649, selfslot);
  struct UserObject *uo3649 = (struct UserObject*)block3648;
  uo3649->data[0] = (Object)closure3649;
  Method *meth_meth_ast__apply3649 = addmethod2pos(block3648, "_apply", &meth_ast__apply3649, 0);
  int argcv_meth_ast__apply3649[] = {1};
  meth_meth_ast__apply3649->type = alloc_MethodType(1, argcv_meth_ast__apply3649);
  meth_meth_ast__apply3649->definitionModule = modulename;
  meth_meth_ast__apply3649->definitionLine = 851;
// compiled block node returning block3648 (depth = 7)
  gc_frame_newslot(block3648);
// call case 5: prelude request
  params[0] = call3647;
  params[1] = block3648;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3680 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3645);
// compiled call node returning call3680 (depth = 6)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3683 = alloc_Boolean(0);
// compiled identifier node returning bool3683 (depth = 8)
  int op_slot_right_3682 = gc_frame_newslot(bool3683);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3685 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3686 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3685);
// compiled call node returning call3686 (depth = 9)
// compiled member node returning call3686 (depth = 8)
  int op_slot_left_3682 = gc_frame_newslot(call3686);
  params[0] = bool3683;
  partcv[0] = 1;
  Object opresult3687 = callmethod(call3686, "!=", 1, partcv, params);
// compiled op node returning opresult3687 (depth = 7)
  Object if3681 = done;
  if (istrue(opresult3687)) {
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3689 == NULL) {
    strlit3689 = alloc_String("");
    gc_root(strlit3689);
  }
// compiled string node returning strlit3689 (depth = 9)
  int op_slot_right_3688 = gc_frame_newslot(strlit3689);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3692 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3694 = alloc_Float64(3);
// compiled num node returning num3694 (depth = 12)
  int op_slot_right_3693 = gc_frame_newslot(num3694);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_3693 = gc_frame_newslot(*var_depth);
  params[0] = num3694;
  partcv[0] = 1;
  Object sum3696 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3696 (depth = 11)
  gc_frame_newslot(sum3696);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3697 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call3698 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3697);
// compiled call node returning call3698 (depth = 12)
// compiled member node returning call3698 (depth = 11)
  params[0] = sum3696;
  partcv[0] = 1;
  Object call3699 = callmethod(call3698, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3692);
// compiled call node returning call3699 (depth = 10)
  int op_slot_right_3691 = gc_frame_newslot(call3699);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3702 == NULL) {
    strlit3702 = alloc_String("Vararg: ");
    gc_root(strlit3702);
  }
// compiled string node returning strlit3702 (depth = 11)
  int op_slot_right_3701 = gc_frame_newslot(strlit3702);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_3704 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3707 == NULL) {
    strlit3707 = alloc_String("""\x0a""    ");
    gc_root(strlit3707);
  }
// compiled string node returning strlit3707 (depth = 13)
  int op_slot_right_3706 = gc_frame_newslot(strlit3707);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_3709 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit3711 == NULL) {
    strlit3711 = alloc_String("");
    gc_root(strlit3711);
  }
// compiled string node returning strlit3711 (depth = 14)
  int op_slot_left_3709 = gc_frame_newslot(strlit3711);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3712 = callmethod(strlit3711, "++", 1, partcv, params);
// compiled op node returning opresult3712 (depth = 13)
  int op_slot_left_3706 = gc_frame_newslot(opresult3712);
  params[0] = strlit3707;
  partcv[0] = 1;
  Object opresult3713 = callmethod(opresult3712, "++", 1, partcv, params);
// compiled op node returning opresult3713 (depth = 12)
  int op_slot_left_3704 = gc_frame_newslot(opresult3713);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3714 = callmethod(opresult3713, "++", 1, partcv, params);
// compiled op node returning opresult3714 (depth = 11)
  int op_slot_left_3701 = gc_frame_newslot(opresult3714);
  params[0] = strlit3702;
  partcv[0] = 1;
  Object opresult3715 = callmethod(opresult3714, "++", 1, partcv, params);
// compiled op node returning opresult3715 (depth = 10)
  int op_slot_left_3691 = gc_frame_newslot(opresult3715);
  params[0] = call3699;
  partcv[0] = 1;
  Object opresult3716 = callmethod(opresult3715, "++", 1, partcv, params);
// compiled op node returning opresult3716 (depth = 9)
  int op_slot_left_3688 = gc_frame_newslot(opresult3716);
  params[0] = strlit3689;
  partcv[0] = 1;
  Object opresult3717 = callmethod(opresult3716, "++", 1, partcv, params);
// compiled op node returning opresult3717 (depth = 8)
  *var_s = opresult3717;
  if (opresult3717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3681 = done;
  } else {
  }
// compiled if node returning if3681 (depth = 6)
  gc_frame_end(frame);
  return if3681;
}
Object meth_ast__apply3753(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3755 == NULL) {
    strlit3755 = alloc_String("");
    gc_root(strlit3755);
  }
// compiled string node returning strlit3755 (depth = 9)
  int op_slot_right_3754 = gc_frame_newslot(strlit3755);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3758 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num3759 = alloc_Float64(0);
// compiled num node returning num3759 (depth = 11)
  gc_frame_newslot(num3759);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_g (depth = 11)
  params[0] = num3759;
  partcv[0] = 1;
  Object call3760 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3758);
// compiled call node returning call3760 (depth = 10)
  int op_slot_right_3757 = gc_frame_newslot(call3760);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3763 == NULL) {
    strlit3763 = alloc_String("  ");
    gc_root(strlit3763);
  }
// compiled string node returning strlit3763 (depth = 11)
  int op_slot_right_3762 = gc_frame_newslot(strlit3763);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_3765 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3768 == NULL) {
    strlit3768 = alloc_String("""\x0a""");
    gc_root(strlit3768);
  }
// compiled string node returning strlit3768 (depth = 13)
  int op_slot_right_3767 = gc_frame_newslot(strlit3768);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_3770 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit3772 == NULL) {
    strlit3772 = alloc_String("");
    gc_root(strlit3772);
  }
// compiled string node returning strlit3772 (depth = 14)
  int op_slot_left_3770 = gc_frame_newslot(strlit3772);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3773 = callmethod(strlit3772, "++", 1, partcv, params);
// compiled op node returning opresult3773 (depth = 13)
  int op_slot_left_3767 = gc_frame_newslot(opresult3773);
  params[0] = strlit3768;
  partcv[0] = 1;
  Object opresult3774 = callmethod(opresult3773, "++", 1, partcv, params);
// compiled op node returning opresult3774 (depth = 12)
  int op_slot_left_3765 = gc_frame_newslot(opresult3774);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3775 = callmethod(opresult3774, "++", 1, partcv, params);
// compiled op node returning opresult3775 (depth = 11)
  int op_slot_left_3762 = gc_frame_newslot(opresult3775);
  params[0] = strlit3763;
  partcv[0] = 1;
  Object opresult3776 = callmethod(opresult3775, "++", 1, partcv, params);
// compiled op node returning opresult3776 (depth = 10)
  int op_slot_left_3757 = gc_frame_newslot(opresult3776);
  params[0] = call3760;
  partcv[0] = 1;
  Object opresult3777 = callmethod(opresult3776, "++", 1, partcv, params);
// compiled op node returning opresult3777 (depth = 9)
  int op_slot_left_3754 = gc_frame_newslot(opresult3777);
  params[0] = strlit3755;
  partcv[0] = 1;
  Object opresult3778 = callmethod(opresult3777, "++", 1, partcv, params);
// compiled op node returning opresult3778 (depth = 8)
  *var_s = opresult3778;
  if (opresult3778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3816(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3818 == NULL) {
    strlit3818 = alloc_String("");
    gc_root(strlit3818);
  }
// compiled string node returning strlit3818 (depth = 9)
  int op_slot_right_3817 = gc_frame_newslot(strlit3818);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3821 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3823 = alloc_Float64(2);
// compiled num node returning num3823 (depth = 12)
  int op_slot_right_3822 = gc_frame_newslot(num3823);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_3822 = gc_frame_newslot(*var_depth);
  params[0] = num3823;
  partcv[0] = 1;
  Object sum3825 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3825 (depth = 11)
  gc_frame_newslot(sum3825);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_an (depth = 11)
  params[0] = sum3825;
  partcv[0] = 1;
  Object call3826 = callmethod(*var_an, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3821);
// compiled call node returning call3826 (depth = 10)
  int op_slot_right_3820 = gc_frame_newslot(call3826);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3829 == NULL) {
    strlit3829 = alloc_String("  ");
    gc_root(strlit3829);
  }
// compiled string node returning strlit3829 (depth = 11)
  int op_slot_right_3828 = gc_frame_newslot(strlit3829);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_3831 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3834 == NULL) {
    strlit3834 = alloc_String("""\x0a""");
    gc_root(strlit3834);
  }
// compiled string node returning strlit3834 (depth = 13)
  int op_slot_right_3833 = gc_frame_newslot(strlit3834);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_3836 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit3838 == NULL) {
    strlit3838 = alloc_String("");
    gc_root(strlit3838);
  }
// compiled string node returning strlit3838 (depth = 14)
  int op_slot_left_3836 = gc_frame_newslot(strlit3838);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3839 = callmethod(strlit3838, "++", 1, partcv, params);
// compiled op node returning opresult3839 (depth = 13)
  int op_slot_left_3833 = gc_frame_newslot(opresult3839);
  params[0] = strlit3834;
  partcv[0] = 1;
  Object opresult3840 = callmethod(opresult3839, "++", 1, partcv, params);
// compiled op node returning opresult3840 (depth = 12)
  int op_slot_left_3831 = gc_frame_newslot(opresult3840);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3841 = callmethod(opresult3840, "++", 1, partcv, params);
// compiled op node returning opresult3841 (depth = 11)
  int op_slot_left_3828 = gc_frame_newslot(opresult3841);
  params[0] = strlit3829;
  partcv[0] = 1;
  Object opresult3842 = callmethod(opresult3841, "++", 1, partcv, params);
// compiled op node returning opresult3842 (depth = 10)
  int op_slot_left_3820 = gc_frame_newslot(opresult3842);
  params[0] = call3826;
  partcv[0] = 1;
  Object opresult3843 = callmethod(opresult3842, "++", 1, partcv, params);
// compiled op node returning opresult3843 (depth = 9)
  int op_slot_left_3817 = gc_frame_newslot(opresult3843);
  params[0] = strlit3818;
  partcv[0] = 1;
  Object opresult3844 = callmethod(opresult3843, "++", 1, partcv, params);
// compiled op node returning opresult3844 (depth = 8)
  *var_s = opresult3844;
  if (opresult3844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3865(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3867 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3869 = alloc_Float64(2);
// compiled num node returning num3869 (depth = 10)
  int op_slot_right_3868 = gc_frame_newslot(num3869);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3868 = gc_frame_newslot(*var_depth);
  params[0] = num3869;
  partcv[0] = 1;
  Object sum3871 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3871 (depth = 9)
  gc_frame_newslot(sum3871);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum3871;
  partcv[0] = 1;
  Object call3872 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3867);
// compiled call node returning call3872 (depth = 8)
  int op_slot_right_3866 = gc_frame_newslot(call3872);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_3874 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3877 == NULL) {
    strlit3877 = alloc_String("""\x0a""  ");
    gc_root(strlit3877);
  }
// compiled string node returning strlit3877 (depth = 10)
  int op_slot_right_3876 = gc_frame_newslot(strlit3877);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3876 = gc_frame_newslot(*var_s);
  params[0] = strlit3877;
  partcv[0] = 1;
  Object opresult3879 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3879 (depth = 9)
  int op_slot_left_3874 = gc_frame_newslot(opresult3879);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3880 = callmethod(opresult3879, "++", 1, partcv, params);
// compiled op node returning opresult3880 (depth = 8)
  int op_slot_left_3866 = gc_frame_newslot(opresult3880);
  params[0] = call3872;
  partcv[0] = 1;
  Object opresult3881 = callmethod(opresult3880, "++", 1, partcv, params);
// compiled op node returning opresult3881 (depth = 7)
  *var_s = opresult3881;
  if (opresult3881 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3489 == NULL) {
    strlit3489 = alloc_String("");
    gc_root(strlit3489);
  }
// compiled string node returning strlit3489 (depth = 5)
  *var_spc = strlit3489;
  if (strlit3489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3490 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_3491 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num3493 = alloc_Float64(0);
// compiled num node returning num3493 (depth = 6)
  int op_slot_left_3491 = gc_frame_newslot(num3493);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3494 = callmethod(num3493, "..", 1, partcv, params);
// compiled op node returning opresult3494 (depth = 5)
  gc_frame_newslot(opresult3494);
// starting to compile block node (depth = 5)
  Object block3495 = alloc_Block(NULL, NULL, "ast", 836);
  gc_frame_newslot(block3495);
// method _apply
  block_savedest(block3495);
  Object closure3496 = createclosure(2, "_apply");
  setclosureframe(closure3496, stackframe);
  addtoclosure(closure3496, var_spc);
  addtoclosure(closure3496, selfslot);
  struct UserObject *uo3496 = (struct UserObject*)block3495;
  uo3496->data[0] = (Object)closure3496;
  Method *meth_meth_ast__apply3496 = addmethod2pos(block3495, "_apply", &meth_ast__apply3496, 0);
  int argcv_meth_ast__apply3496[] = {1};
  meth_meth_ast__apply3496->type = alloc_MethodType(1, argcv_meth_ast__apply3496);
  meth_meth_ast__apply3496->definitionModule = modulename;
  meth_meth_ast__apply3496->definitionLine = 830;
// compiled block node returning block3495 (depth = 5)
  gc_frame_newslot(block3495);
// call case 5: prelude request
  params[0] = opresult3494;
  params[1] = block3495;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3503 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3490);
// compiled call node returning call3503 (depth = 4)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3505 == NULL) {
    strlit3505 = alloc_String("""\x0a""");
    gc_root(strlit3505);
  }
// compiled string node returning strlit3505 (depth = 6)
  int op_slot_right_3504 = gc_frame_newslot(strlit3505);
// starting to compile call node (depth = 6)
  int callframe3507 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call3508 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe3507);
// compiled call node returning call3508 (depth = 6)
  int op_slot_left_3504 = gc_frame_newslot(call3508);
  params[0] = strlit3505;
  partcv[0] = 1;
  Object opresult3509 = callmethod(call3508, "++", 1, partcv, params);
// compiled op node returning opresult3509 (depth = 5)
  *var_s = opresult3509;
  if (opresult3509 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3511 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3513 = alloc_Float64(1);
// compiled num node returning num3513 (depth = 8)
  int op_slot_right_3512 = gc_frame_newslot(num3513);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_3512 = gc_frame_newslot(*var_depth);
  params[0] = num3513;
  partcv[0] = 1;
  Object sum3515 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3515 (depth = 7)
  gc_frame_newslot(sum3515);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3516 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3517 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3516);
// compiled call node returning call3517 (depth = 8)
// compiled member node returning call3517 (depth = 7)
  params[0] = sum3515;
  partcv[0] = 1;
  Object call3518 = callmethod(call3517, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3511);
// compiled call node returning call3518 (depth = 6)
  int op_slot_right_3510 = gc_frame_newslot(call3518);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3521 == NULL) {
    strlit3521 = alloc_String("Name: ");
    gc_root(strlit3521);
  }
// compiled string node returning strlit3521 (depth = 7)
  int op_slot_right_3520 = gc_frame_newslot(strlit3521);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3523 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3523 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3525 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3525 (depth = 7)
  int op_slot_left_3520 = gc_frame_newslot(opresult3525);
  params[0] = strlit3521;
  partcv[0] = 1;
  Object opresult3526 = callmethod(opresult3525, "++", 1, partcv, params);
// compiled op node returning opresult3526 (depth = 6)
  int op_slot_left_3510 = gc_frame_newslot(opresult3526);
  params[0] = call3518;
  partcv[0] = 1;
  Object opresult3527 = callmethod(opresult3526, "++", 1, partcv, params);
// compiled op node returning opresult3527 (depth = 5)
  *var_s = opresult3527;
  if (opresult3527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3530 == NULL) {
    strlit3530 = alloc_String("""\x0a""");
    gc_root(strlit3530);
  }
// compiled string node returning strlit3530 (depth = 6)
  int op_slot_right_3529 = gc_frame_newslot(strlit3530);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3529 = gc_frame_newslot(*var_s);
  params[0] = strlit3530;
  partcv[0] = 1;
  Object opresult3532 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3532 (depth = 5)
  *var_s = opresult3532;
  if (opresult3532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3536 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3537 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3536);
// compiled call node returning call3537 (depth = 7)
// compiled member node returning call3537 (depth = 6)
  int op_slot_right_3535 = gc_frame_newslot(call3537);
// starting to compile identifier node (depth = 6)
  Object bool3539 = alloc_Boolean(0);
// compiled identifier node returning bool3539 (depth = 6)
  int op_slot_left_3535 = gc_frame_newslot(bool3539);
  params[0] = call3537;
  partcv[0] = 1;
  Object opresult3540 = callmethod(bool3539, "!=", 1, partcv, params);
// compiled op node returning opresult3540 (depth = 5)
  Object if3534 = done;
  if (istrue(opresult3540)) {
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3542 == NULL) {
    strlit3542 = alloc_String("  ");
    gc_root(strlit3542);
  }
// compiled string node returning strlit3542 (depth = 7)
  int op_slot_right_3541 = gc_frame_newslot(strlit3542);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3544 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3547 == NULL) {
    strlit3547 = alloc_String("Returns:""\x0a""");
    gc_root(strlit3547);
  }
// compiled string node returning strlit3547 (depth = 9)
  int op_slot_right_3546 = gc_frame_newslot(strlit3547);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_3549 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3549 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3551 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3551 (depth = 9)
  int op_slot_left_3546 = gc_frame_newslot(opresult3551);
  params[0] = strlit3547;
  partcv[0] = 1;
  Object opresult3552 = callmethod(opresult3551, "++", 1, partcv, params);
// compiled op node returning opresult3552 (depth = 8)
  int op_slot_left_3544 = gc_frame_newslot(opresult3552);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3553 = callmethod(opresult3552, "++", 1, partcv, params);
// compiled op node returning opresult3553 (depth = 7)
  int op_slot_left_3541 = gc_frame_newslot(opresult3553);
  params[0] = strlit3542;
  partcv[0] = 1;
  Object opresult3554 = callmethod(opresult3553, "++", 1, partcv, params);
// compiled op node returning opresult3554 (depth = 6)
  *var_s = opresult3554;
  if (opresult3554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3557 == NULL) {
    strlit3557 = alloc_String("""\x0a""");
    gc_root(strlit3557);
  }
// compiled string node returning strlit3557 (depth = 7)
  int op_slot_right_3556 = gc_frame_newslot(strlit3557);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3560 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3562 = alloc_Float64(2);
// compiled num node returning num3562 (depth = 10)
  int op_slot_right_3561 = gc_frame_newslot(num3562);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_3561 = gc_frame_newslot(*var_depth);
  params[0] = num3562;
  partcv[0] = 1;
  Object sum3564 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3564 (depth = 9)
  gc_frame_newslot(sum3564);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3565 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3566 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3565);
// compiled call node returning call3566 (depth = 10)
// compiled member node returning call3566 (depth = 9)
  params[0] = sum3564;
  partcv[0] = 1;
  Object call3567 = callmethod(call3566, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3560);
// compiled call node returning call3567 (depth = 8)
  int op_slot_right_3559 = gc_frame_newslot(call3567);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3559 = gc_frame_newslot(*var_s);
  params[0] = call3567;
  partcv[0] = 1;
  Object opresult3569 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3569 (depth = 7)
  int op_slot_left_3556 = gc_frame_newslot(opresult3569);
  params[0] = strlit3557;
  partcv[0] = 1;
  Object opresult3570 = callmethod(opresult3569, "++", 1, partcv, params);
// compiled op node returning opresult3570 (depth = 6)
  *var_s = opresult3570;
  if (opresult3570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3534 = done;
  } else {
  }
// compiled if node returning if3534 (depth = 4)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3573 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3574 = callmethodflags(self, "isFresh", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3573);
// compiled call node returning call3574 (depth = 6)
// compiled member node returning call3574 (depth = 5)
  Object if3572 = done;
  if (istrue(call3574)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3576 == NULL) {
    strlit3576 = alloc_String("Fresh""\x0a""");
    gc_root(strlit3576);
  }
// compiled string node returning strlit3576 (depth = 7)
  int op_slot_right_3575 = gc_frame_newslot(strlit3576);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3578 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3578 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3580 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3580 (depth = 7)
  int op_slot_left_3575 = gc_frame_newslot(opresult3580);
  params[0] = strlit3576;
  partcv[0] = 1;
  Object opresult3581 = callmethod(opresult3580, "++", 1, partcv, params);
// compiled op node returning opresult3581 (depth = 6)
  *var_s = opresult3581;
  if (opresult3581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3572 = done;
  } else {
  }
// compiled if node returning if3572 (depth = 4)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3584 == NULL) {
    strlit3584 = alloc_String("Signature:");
    gc_root(strlit3584);
  }
// compiled string node returning strlit3584 (depth = 6)
  int op_slot_right_3583 = gc_frame_newslot(strlit3584);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3586 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3589 == NULL) {
    strlit3589 = alloc_String("");
    gc_root(strlit3589);
  }
// compiled string node returning strlit3589 (depth = 8)
  int op_slot_right_3588 = gc_frame_newslot(strlit3589);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_3591 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit3593 == NULL) {
    strlit3593 = alloc_String("");
    gc_root(strlit3593);
  }
// compiled string node returning strlit3593 (depth = 9)
  int op_slot_left_3591 = gc_frame_newslot(strlit3593);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3594 = callmethod(strlit3593, "++", 1, partcv, params);
// compiled op node returning opresult3594 (depth = 8)
  int op_slot_left_3588 = gc_frame_newslot(opresult3594);
  params[0] = strlit3589;
  partcv[0] = 1;
  Object opresult3595 = callmethod(opresult3594, "++", 1, partcv, params);
// compiled op node returning opresult3595 (depth = 7)
  int op_slot_left_3586 = gc_frame_newslot(opresult3595);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3596 = callmethod(opresult3595, "++", 1, partcv, params);
// compiled op node returning opresult3596 (depth = 6)
  int op_slot_left_3583 = gc_frame_newslot(opresult3596);
  params[0] = strlit3584;
  partcv[0] = 1;
  Object opresult3597 = callmethod(opresult3596, "++", 1, partcv, params);
// compiled op node returning opresult3597 (depth = 5)
  *var_s = opresult3597;
  if (opresult3597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3599 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3600 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3601 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3600);
// compiled call node returning call3601 (depth = 6)
// compiled member node returning call3601 (depth = 5)
  gc_frame_newslot(call3601);
// starting to compile block node (depth = 5)
  Object block3602 = alloc_Block(NULL, NULL, "ast", 848);
  gc_frame_newslot(block3602);
// method _apply
  block_savedest(block3602);
  Object closure3603 = createclosure(4, "_apply");
  setclosureframe(closure3603, stackframe);
  addtoclosure(closure3603, var_spc);
  addtoclosure(closure3603, var_s);
  addtoclosure(closure3603, var_depth);
  addtoclosure(closure3603, selfslot);
  struct UserObject *uo3603 = (struct UserObject*)block3602;
  uo3603->data[0] = (Object)closure3603;
  Method *meth_meth_ast__apply3603 = addmethod2pos(block3602, "_apply", &meth_ast__apply3603, 0);
  int argcv_meth_ast__apply3603[] = {1};
  meth_meth_ast__apply3603->type = alloc_MethodType(1, argcv_meth_ast__apply3603);
  meth_meth_ast__apply3603->definitionModule = modulename;
  meth_meth_ast__apply3603->definitionLine = 848;
// compiled block node returning block3602 (depth = 5)
  gc_frame_newslot(block3602);
// call case 5: prelude request
  params[0] = call3601;
  params[1] = block3602;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3720 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3599);
// compiled call node returning call3720 (depth = 4)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3722 == NULL) {
    strlit3722 = alloc_String("""\x0a""");
    gc_root(strlit3722);
  }
// compiled string node returning strlit3722 (depth = 6)
  int op_slot_right_3721 = gc_frame_newslot(strlit3722);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_3721 = gc_frame_newslot(*var_s);
  params[0] = strlit3722;
  partcv[0] = 1;
  Object opresult3724 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3724 (depth = 5)
  *var_s = opresult3724;
  if (opresult3724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3729 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3728);
// compiled call node returning call3729 (depth = 7)
// compiled member node returning call3729 (depth = 6)
  int op_slot_right_3727 = gc_frame_newslot(call3729);
// starting to compile identifier node (depth = 6)
  Object bool3731 = alloc_Boolean(0);
// compiled identifier node returning bool3731 (depth = 6)
  int op_slot_left_3727 = gc_frame_newslot(bool3731);
  params[0] = call3729;
  partcv[0] = 1;
  Object opresult3732 = callmethod(bool3731, "!=", 1, partcv, params);
// compiled op node returning opresult3732 (depth = 5)
  Object if3726 = done;
  if (istrue(opresult3732)) {
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3734 == NULL) {
    strlit3734 = alloc_String("Generics:");
    gc_root(strlit3734);
  }
// compiled string node returning strlit3734 (depth = 7)
  int op_slot_right_3733 = gc_frame_newslot(strlit3734);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3736 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3739 == NULL) {
    strlit3739 = alloc_String("");
    gc_root(strlit3739);
  }
// compiled string node returning strlit3739 (depth = 9)
  int op_slot_right_3738 = gc_frame_newslot(strlit3739);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_3741 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit3743 == NULL) {
    strlit3743 = alloc_String("");
    gc_root(strlit3743);
  }
// compiled string node returning strlit3743 (depth = 10)
  int op_slot_left_3741 = gc_frame_newslot(strlit3743);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3744 = callmethod(strlit3743, "++", 1, partcv, params);
// compiled op node returning opresult3744 (depth = 9)
  int op_slot_left_3738 = gc_frame_newslot(opresult3744);
  params[0] = strlit3739;
  partcv[0] = 1;
  Object opresult3745 = callmethod(opresult3744, "++", 1, partcv, params);
// compiled op node returning opresult3745 (depth = 8)
  int op_slot_left_3736 = gc_frame_newslot(opresult3745);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3746 = callmethod(opresult3745, "++", 1, partcv, params);
// compiled op node returning opresult3746 (depth = 7)
  int op_slot_left_3733 = gc_frame_newslot(opresult3746);
  params[0] = strlit3734;
  partcv[0] = 1;
  Object opresult3747 = callmethod(opresult3746, "++", 1, partcv, params);
// compiled op node returning opresult3747 (depth = 6)
  *var_s = opresult3747;
  if (opresult3747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3749 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3750 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3751 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3750);
// compiled call node returning call3751 (depth = 7)
// compiled member node returning call3751 (depth = 6)
  gc_frame_newslot(call3751);
// starting to compile block node (depth = 6)
  Object block3752 = alloc_Block(NULL, NULL, "ast", 861);
  gc_frame_newslot(block3752);
// method _apply
  block_savedest(block3752);
  Object closure3753 = createclosure(3, "_apply");
  setclosureframe(closure3753, stackframe);
  addtoclosure(closure3753, var_spc);
  addtoclosure(closure3753, var_s);
  addtoclosure(closure3753, selfslot);
  struct UserObject *uo3753 = (struct UserObject*)block3752;
  uo3753->data[0] = (Object)closure3753;
  Method *meth_meth_ast__apply3753 = addmethod2pos(block3752, "_apply", &meth_ast__apply3753, 0);
  int argcv_meth_ast__apply3753[] = {1};
  meth_meth_ast__apply3753->type = alloc_MethodType(1, argcv_meth_ast__apply3753);
  meth_meth_ast__apply3753->definitionModule = modulename;
  meth_meth_ast__apply3753->definitionLine = 861;
// compiled block node returning block3752 (depth = 6)
  gc_frame_newslot(block3752);
// call case 5: prelude request
  params[0] = call3751;
  params[1] = block3752;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3781 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3749);
// compiled call node returning call3781 (depth = 5)
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3783 == NULL) {
    strlit3783 = alloc_String("""\x0a""");
    gc_root(strlit3783);
  }
// compiled string node returning strlit3783 (depth = 7)
  int op_slot_right_3782 = gc_frame_newslot(strlit3783);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3782 = gc_frame_newslot(*var_s);
  params[0] = strlit3783;
  partcv[0] = 1;
  Object opresult3785 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3785 (depth = 6)
  *var_s = opresult3785;
  if (opresult3785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3726 = done;
  } else {
  }
// compiled if node returning if3726 (depth = 4)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3789 = alloc_Float64(0);
// compiled num node returning num3789 (depth = 6)
  int op_slot_right_3788 = gc_frame_newslot(num3789);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3791 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3792 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3793 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3792);
// compiled call node returning call3793 (depth = 9)
// compiled member node returning call3793 (depth = 8)
  partcv[0] = 0;
  Object call3794 = callmethod(call3793, "size",
    1, partcv, params);
  gc_frame_end(callframe3791);
// compiled call node returning call3794 (depth = 7)
// compiled member node returning call3794 (depth = 6)
  int op_slot_left_3788 = gc_frame_newslot(call3794);
  params[0] = num3789;
  partcv[0] = 1;
  Object opresult3795 = callmethod(call3794, ">", 1, partcv, params);
// compiled op node returning opresult3795 (depth = 5)
  Object if3787 = done;
  if (istrue(opresult3795)) {
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3797 == NULL) {
    strlit3797 = alloc_String("Annotations:");
    gc_root(strlit3797);
  }
// compiled string node returning strlit3797 (depth = 7)
  int op_slot_right_3796 = gc_frame_newslot(strlit3797);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_3799 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3802 == NULL) {
    strlit3802 = alloc_String("");
    gc_root(strlit3802);
  }
// compiled string node returning strlit3802 (depth = 9)
  int op_slot_right_3801 = gc_frame_newslot(strlit3802);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_3804 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit3806 == NULL) {
    strlit3806 = alloc_String("");
    gc_root(strlit3806);
  }
// compiled string node returning strlit3806 (depth = 10)
  int op_slot_left_3804 = gc_frame_newslot(strlit3806);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3807 = callmethod(strlit3806, "++", 1, partcv, params);
// compiled op node returning opresult3807 (depth = 9)
  int op_slot_left_3801 = gc_frame_newslot(opresult3807);
  params[0] = strlit3802;
  partcv[0] = 1;
  Object opresult3808 = callmethod(opresult3807, "++", 1, partcv, params);
// compiled op node returning opresult3808 (depth = 8)
  int op_slot_left_3799 = gc_frame_newslot(opresult3808);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3809 = callmethod(opresult3808, "++", 1, partcv, params);
// compiled op node returning opresult3809 (depth = 7)
  int op_slot_left_3796 = gc_frame_newslot(opresult3809);
  params[0] = strlit3797;
  partcv[0] = 1;
  Object opresult3810 = callmethod(opresult3809, "++", 1, partcv, params);
// compiled op node returning opresult3810 (depth = 6)
  *var_s = opresult3810;
  if (opresult3810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3812 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3813 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3814 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3813);
// compiled call node returning call3814 (depth = 7)
// compiled member node returning call3814 (depth = 6)
  gc_frame_newslot(call3814);
// starting to compile block node (depth = 6)
  Object block3815 = alloc_Block(NULL, NULL, "ast", 868);
  gc_frame_newslot(block3815);
// method _apply
  block_savedest(block3815);
  Object closure3816 = createclosure(4, "_apply");
  setclosureframe(closure3816, stackframe);
  addtoclosure(closure3816, var_depth);
  addtoclosure(closure3816, var_spc);
  addtoclosure(closure3816, var_s);
  addtoclosure(closure3816, selfslot);
  struct UserObject *uo3816 = (struct UserObject*)block3815;
  uo3816->data[0] = (Object)closure3816;
  Method *meth_meth_ast__apply3816 = addmethod2pos(block3815, "_apply", &meth_ast__apply3816, 0);
  int argcv_meth_ast__apply3816[] = {1};
  meth_meth_ast__apply3816->type = alloc_MethodType(1, argcv_meth_ast__apply3816);
  meth_meth_ast__apply3816->definitionModule = modulename;
  meth_meth_ast__apply3816->definitionLine = 868;
// compiled block node returning block3815 (depth = 6)
  gc_frame_newslot(block3815);
// call case 5: prelude request
  params[0] = call3814;
  params[1] = block3815;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3847 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3812);
// compiled call node returning call3847 (depth = 5)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit3849 == NULL) {
    strlit3849 = alloc_String("""\x0a""");
    gc_root(strlit3849);
  }
// compiled string node returning strlit3849 (depth = 7)
  int op_slot_right_3848 = gc_frame_newslot(strlit3849);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3848 = gc_frame_newslot(*var_s);
  params[0] = strlit3849;
  partcv[0] = 1;
  Object opresult3851 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3851 (depth = 6)
  *var_s = opresult3851;
  if (opresult3851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3787 = done;
  } else {
  }
// compiled if node returning if3787 (depth = 4)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3854 == NULL) {
    strlit3854 = alloc_String("Body:");
    gc_root(strlit3854);
  }
// compiled string node returning strlit3854 (depth = 6)
  int op_slot_right_3853 = gc_frame_newslot(strlit3854);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_3856 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3856 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3858 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3858 (depth = 6)
  int op_slot_left_3853 = gc_frame_newslot(opresult3858);
  params[0] = strlit3854;
  partcv[0] = 1;
  Object opresult3859 = callmethod(opresult3858, "++", 1, partcv, params);
// compiled op node returning opresult3859 (depth = 5)
  *var_s = opresult3859;
  if (opresult3859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3861 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3862 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3863 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3862);
// compiled call node returning call3863 (depth = 6)
// compiled member node returning call3863 (depth = 5)
  gc_frame_newslot(call3863);
// starting to compile block node (depth = 5)
  Object block3864 = alloc_Block(NULL, NULL, "ast", 874);
  gc_frame_newslot(block3864);
// method _apply
  block_savedest(block3864);
  Object closure3865 = createclosure(4, "_apply");
  setclosureframe(closure3865, stackframe);
  addtoclosure(closure3865, var_depth);
  addtoclosure(closure3865, var_spc);
  addtoclosure(closure3865, var_s);
  addtoclosure(closure3865, selfslot);
  struct UserObject *uo3865 = (struct UserObject*)block3864;
  uo3865->data[0] = (Object)closure3865;
  Method *meth_meth_ast__apply3865 = addmethod2pos(block3864, "_apply", &meth_ast__apply3865, 0);
  int argcv_meth_ast__apply3865[] = {1};
  meth_meth_ast__apply3865->type = alloc_MethodType(1, argcv_meth_ast__apply3865);
  meth_meth_ast__apply3865->definitionModule = modulename;
  meth_meth_ast__apply3865->definitionLine = 874;
// compiled block node returning block3864 (depth = 5)
  gc_frame_newslot(block3864);
// call case 5: prelude request
  params[0] = call3863;
  params[1] = block3864;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3884 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3861);
// compiled call node returning call3884 (depth = 4)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply3897(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3899 == NULL) {
    strlit3899 = alloc_String("    ");
    gc_root(strlit3899);
  }
// compiled string node returning strlit3899 (depth = 8)
  int op_slot_right_3898 = gc_frame_newslot(strlit3899);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_3898 = gc_frame_newslot(*var_spc);
  params[0] = strlit3899;
  partcv[0] = 1;
  Object opresult3901 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult3901 (depth = 7)
  *var_spc = opresult3901;
  if (opresult3901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3921(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3923 = alloc_Float64(0);
// compiled num node returning num3923 (depth = 10)
  int op_slot_right_3922 = gc_frame_newslot(num3923);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3927 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3926);
// compiled call node returning call3927 (depth = 13)
// compiled member node returning call3927 (depth = 12)
  partcv[0] = 0;
  Object call3928 = callmethod(call3927, "size",
    1, partcv, params);
  gc_frame_end(callframe3925);
// compiled call node returning call3928 (depth = 11)
// compiled member node returning call3928 (depth = 10)
  int op_slot_left_3922 = gc_frame_newslot(call3928);
  params[0] = num3923;
  partcv[0] = 1;
  Object opresult3929 = callmethod(call3928, "!=", 1, partcv, params);
// compiled op node returning opresult3929 (depth = 9)
  gc_frame_end(frame);
  return opresult3929;
}
Object meth_ast__apply3951(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3953 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num3955 = alloc_Float64(1);
// compiled num node returning num3955 (depth = 13)
  int op_slot_right_3954 = gc_frame_newslot(num3955);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_3954 = gc_frame_newslot(*var_depth);
  params[0] = num3955;
  partcv[0] = 1;
  Object sum3957 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3957 (depth = 12)
  gc_frame_newslot(sum3957);
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe3958 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ix (depth = 13)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3959 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3960 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3959);
// compiled call node returning call3960 (depth = 14)
// compiled member node returning call3960 (depth = 13)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call3961 = callmethod(call3960, "at",
    1, partcv, params);
  gc_frame_end(callframe3958);
// compiled call node returning call3961 (depth = 12)
  params[0] = sum3957;
  partcv[0] = 1;
  Object call3962 = callmethod(call3961, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3953);
// compiled call node returning call3962 (depth = 11)
  int op_slot_right_3952 = gc_frame_newslot(call3962);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_3952 = gc_frame_newslot(*var_s);
  params[0] = call3962;
  partcv[0] = 1;
  Object opresult3964 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3964 (depth = 10)
  *var_s = opresult3964;
  if (opresult3964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4017(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile index node (depth = 10)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4018 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4019 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4018);
// compiled call node returning call4019 (depth = 12)
// compiled member node returning call4019 (depth = 11)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_pnr (depth = 11)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4020 = callmethod(call4019, "[]", 1, partcv, params);
// compiled index node returning idxres4020 (depth = 10)
  *var_p = idxres4020;
  if (idxres4020 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4022 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num4024 = alloc_Float64(1);
// compiled num node returning num4024 (depth = 13)
  int op_slot_right_4023 = gc_frame_newslot(num4024);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_4023 = gc_frame_newslot(*var_depth);
  params[0] = num4024;
  partcv[0] = 1;
  Object sum4026 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4026 (depth = 12)
  gc_frame_newslot(sum4026);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = sum4026;
  partcv[0] = 1;
  Object call4027 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4022);
// compiled call node returning call4027 (depth = 11)
  int op_slot_right_4021 = gc_frame_newslot(call4027);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4021 = gc_frame_newslot(*var_s);
  params[0] = call4027;
  partcv[0] = 1;
  Object opresult4029 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4029 (depth = 10)
  *var_s = opresult4029;
  if (opresult4029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
  Object bool4034 = alloc_Boolean(0);
// compiled identifier node returning bool4034 (depth = 12)
  int op_slot_right_4033 = gc_frame_newslot(bool4034);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4036 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call4037 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4036);
// compiled call node returning call4037 (depth = 13)
// compiled member node returning call4037 (depth = 12)
  int op_slot_left_4033 = gc_frame_newslot(call4037);
  params[0] = bool4034;
  partcv[0] = 1;
  Object opresult4038 = callmethod(call4037, "!=", 1, partcv, params);
// compiled op node returning opresult4038 (depth = 11)
  int op_slot_right_4032 = gc_frame_newslot(opresult4038);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4041 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe4042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_part (depth = 16)
  partcv[0] = 0;
  Object call4043 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4042);
// compiled call node returning call4043 (depth = 15)
// compiled member node returning call4043 (depth = 14)
  partcv[0] = 0;
  Object call4044 = callmethod(call4043, "size",
    1, partcv, params);
  gc_frame_end(callframe4041);
// compiled call node returning call4044 (depth = 13)
// compiled member node returning call4044 (depth = 12)
  int op_slot_right_4040 = gc_frame_newslot(call4044);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_pnr (depth = 12)
  int op_slot_left_4040 = gc_frame_newslot(*var_pnr);
  params[0] = call4044;
  partcv[0] = 1;
  Object opresult4046 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult4046 (depth = 11)
  int op_slot_left_4032 = gc_frame_newslot(opresult4046);
  params[0] = opresult4038;
  partcv[0] = 1;
  Object opresult4047 = callmethod(opresult4046, "||", 1, partcv, params);
// compiled op node returning opresult4047 (depth = 10)
  Object if4031 = done;
  if (istrue(opresult4047)) {
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit4049 == NULL) {
    strlit4049 = alloc_String(", ");
    gc_root(strlit4049);
  }
// compiled string node returning strlit4049 (depth = 12)
  int op_slot_right_4048 = gc_frame_newslot(strlit4049);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_4048 = gc_frame_newslot(*var_s);
  params[0] = strlit4049;
  partcv[0] = 1;
  Object opresult4051 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4051 (depth = 11)
  *var_s = opresult4051;
  if (opresult4051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if4031 = done;
  } else {
  }
// compiled if node returning if4031 (depth = 9)
  gc_frame_end(frame);
  return if4031;
}
Object meth_ast__apply3911(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call3914 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3913);
// compiled call node returning call3914 (depth = 9)
// compiled member node returning call3914 (depth = 8)
  int op_slot_right_3912 = gc_frame_newslot(call3914);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3912 = gc_frame_newslot(*var_s);
  params[0] = call3914;
  partcv[0] = 1;
  Object opresult3916 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3916 (depth = 7)
  *var_s = opresult3916;
  if (opresult3916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3919 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3920 = alloc_Block(NULL, NULL, "ast", 888);
  gc_frame_newslot(block3920);
// method _apply
  block_savedest(block3920);
  Object closure3921 = createclosure(1, "_apply");
  setclosureframe(closure3921, stackframe);
  addtoclosure(closure3921, selfslot);
  struct UserObject *uo3921 = (struct UserObject*)block3920;
  uo3921->data[0] = (Object)closure3921;
  Method *meth_meth_ast__apply3921 = addmethod2pos(block3920, "_apply", &meth_ast__apply3921, 0);
  int argcv_meth_ast__apply3921[] = {0};
  meth_meth_ast__apply3921->type = alloc_MethodType(1, argcv_meth_ast__apply3921);
  meth_meth_ast__apply3921->definitionModule = modulename;
  meth_meth_ast__apply3921->definitionLine = 887;
// compiled block node returning block3920 (depth = 8)
  gc_frame_newslot(block3920);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_firstPart (depth = 8)
  params[0] = block3920;
  partcv[0] = 1;
  Object call3931 = callmethod(*var_firstPart, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe3919);
// compiled call node returning call3931 (depth = 7)
  Object if3918 = done;
  if (istrue(call3931)) {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3933 == NULL) {
    strlit3933 = alloc_String("<");
    gc_root(strlit3933);
  }
// compiled string node returning strlit3933 (depth = 9)
  int op_slot_right_3932 = gc_frame_newslot(strlit3933);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_3932 = gc_frame_newslot(*var_s);
  params[0] = strlit3933;
  partcv[0] = 1;
  Object opresult3935 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3935 (depth = 8)
  *var_s = opresult3935;
  if (opresult3935 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3937 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3940 = alloc_Float64(1);
// compiled num node returning num3940 (depth = 10)
  int op_slot_right_3939 = gc_frame_newslot(num3940);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3942 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3943 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3944 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3943);
// compiled call node returning call3944 (depth = 13)
// compiled member node returning call3944 (depth = 12)
  partcv[0] = 0;
  Object call3945 = callmethod(call3944, "size",
    1, partcv, params);
  gc_frame_end(callframe3942);
// compiled call node returning call3945 (depth = 11)
// compiled member node returning call3945 (depth = 10)
  int op_slot_left_3939 = gc_frame_newslot(call3945);
  params[0] = num3940;
  partcv[0] = 1;
  Object diff3946 = callmethod(call3945, "-", 1, partcv, params);
// compiled op node returning diff3946 (depth = 9)
  int op_slot_right_3938 = gc_frame_newslot(diff3946);
// starting to compile num node (depth = 9)
  Object num3948 = alloc_Float64(1);
// compiled num node returning num3948 (depth = 9)
  int op_slot_left_3938 = gc_frame_newslot(num3948);
  params[0] = diff3946;
  partcv[0] = 1;
  Object opresult3949 = callmethod(num3948, "..", 1, partcv, params);
// compiled op node returning opresult3949 (depth = 8)
  gc_frame_newslot(opresult3949);
// starting to compile block node (depth = 8)
  Object block3950 = alloc_Block(NULL, NULL, "ast", 890);
  gc_frame_newslot(block3950);
// method _apply
  block_savedest(block3950);
  Object closure3951 = createclosure(3, "_apply");
  setclosureframe(closure3951, stackframe);
  addtoclosure(closure3951, var_depth);
  addtoclosure(closure3951, var_s);
  addtoclosure(closure3951, selfslot);
  struct UserObject *uo3951 = (struct UserObject*)block3950;
  uo3951->data[0] = (Object)closure3951;
  Method *meth_meth_ast__apply3951 = addmethod2pos(block3950, "_apply", &meth_ast__apply3951, 0);
  int argcv_meth_ast__apply3951[] = {1};
  meth_meth_ast__apply3951->type = alloc_MethodType(1, argcv_meth_ast__apply3951);
  meth_meth_ast__apply3951->definitionModule = modulename;
  meth_meth_ast__apply3951->definitionLine = 890;
// compiled block node returning block3950 (depth = 8)
  gc_frame_newslot(block3950);
// call case 5: prelude request
  params[0] = opresult3949;
  params[1] = block3950;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3967 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3937);
// compiled call node returning call3967 (depth = 7)
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3969 == NULL) {
    strlit3969 = alloc_String(">");
    gc_root(strlit3969);
  }
// compiled string node returning strlit3969 (depth = 9)
  int op_slot_right_3968 = gc_frame_newslot(strlit3969);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3972 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3974 = alloc_Float64(1);
// compiled num node returning num3974 (depth = 12)
  int op_slot_right_3973 = gc_frame_newslot(num3974);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_3973 = gc_frame_newslot(*var_depth);
  params[0] = num3974;
  partcv[0] = 1;
  Object sum3976 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum3976 (depth = 11)
  gc_frame_newslot(sum3976);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3977 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3978 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3979 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3978);
// compiled call node returning call3979 (depth = 14)
// compiled member node returning call3979 (depth = 13)
  partcv[0] = 0;
  Object call3980 = callmethod(call3979, "last",
    1, partcv, params);
  gc_frame_end(callframe3977);
// compiled call node returning call3980 (depth = 12)
// compiled member node returning call3980 (depth = 11)
  params[0] = sum3976;
  partcv[0] = 1;
  Object call3981 = callmethod(call3980, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3972);
// compiled call node returning call3981 (depth = 10)
  int op_slot_right_3971 = gc_frame_newslot(call3981);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_3971 = gc_frame_newslot(*var_s);
  params[0] = call3981;
  partcv[0] = 1;
  Object opresult3983 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3983 (depth = 9)
  int op_slot_left_3968 = gc_frame_newslot(opresult3983);
  params[0] = strlit3969;
  partcv[0] = 1;
  Object opresult3984 = callmethod(opresult3983, "++", 1, partcv, params);
// compiled op node returning opresult3984 (depth = 8)
  *var_s = opresult3984;
  if (opresult3984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3918 = done;
  } else {
  }
// compiled if node returning if3918 (depth = 6)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool3986 = alloc_Boolean(0);
// compiled identifier node returning bool3986 (depth = 7)
  *var_firstPart = bool3986;
  if (bool3986 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool3991 = alloc_Boolean(0);
// compiled identifier node returning bool3991 (depth = 9)
  int op_slot_right_3990 = gc_frame_newslot(bool3991);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call3994 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3993);
// compiled call node returning call3994 (depth = 10)
// compiled member node returning call3994 (depth = 9)
  int op_slot_left_3990 = gc_frame_newslot(call3994);
  params[0] = bool3991;
  partcv[0] = 1;
  Object opresult3995 = callmethod(call3994, "!=", 1, partcv, params);
// compiled op node returning opresult3995 (depth = 8)
  int op_slot_right_3989 = gc_frame_newslot(opresult3995);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3998 = alloc_Float64(0);
// compiled num node returning num3998 (depth = 9)
  int op_slot_right_3997 = gc_frame_newslot(num3998);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4000 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4001 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4002 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4001);
// compiled call node returning call4002 (depth = 12)
// compiled member node returning call4002 (depth = 11)
  partcv[0] = 0;
  Object call4003 = callmethod(call4002, "size",
    1, partcv, params);
  gc_frame_end(callframe4000);
// compiled call node returning call4003 (depth = 10)
// compiled member node returning call4003 (depth = 9)
  int op_slot_left_3997 = gc_frame_newslot(call4003);
  params[0] = num3998;
  partcv[0] = 1;
  Object opresult4004 = callmethod(call4003, ">", 1, partcv, params);
// compiled op node returning opresult4004 (depth = 8)
  int op_slot_left_3989 = gc_frame_newslot(opresult4004);
  params[0] = opresult3995;
  partcv[0] = 1;
  Object opresult4005 = callmethod(opresult4004, "||", 1, partcv, params);
// compiled op node returning opresult4005 (depth = 7)
  Object if3988 = done;
  if (istrue(opresult4005)) {
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4007 == NULL) {
    strlit4007 = alloc_String("(");
    gc_root(strlit4007);
  }
// compiled string node returning strlit4007 (depth = 9)
  int op_slot_right_4006 = gc_frame_newslot(strlit4007);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4006 = gc_frame_newslot(*var_s);
  params[0] = strlit4007;
  partcv[0] = 1;
  Object opresult4009 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4009 (depth = 8)
  *var_s = opresult4009;
  if (opresult4009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4011 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4012 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4014 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4013);
// compiled call node returning call4014 (depth = 11)
// compiled member node returning call4014 (depth = 10)
  partcv[0] = 0;
  Object call4015 = callmethod(call4014, "indices",
    1, partcv, params);
  gc_frame_end(callframe4012);
// compiled call node returning call4015 (depth = 9)
// compiled member node returning call4015 (depth = 8)
  gc_frame_newslot(call4015);
// starting to compile block node (depth = 8)
  Object block4016 = alloc_Block(NULL, NULL, "ast", 898);
  gc_frame_newslot(block4016);
// method _apply
  block_savedest(block4016);
  Object closure4017 = createclosure(4, "_apply");
  setclosureframe(closure4017, stackframe);
  addtoclosure(closure4017, var_part);
  addtoclosure(closure4017, var_depth);
  addtoclosure(closure4017, var_s);
  addtoclosure(closure4017, selfslot);
  struct UserObject *uo4017 = (struct UserObject*)block4016;
  uo4017->data[0] = (Object)closure4017;
  Method *meth_meth_ast__apply4017 = addmethod2pos(block4016, "_apply", &meth_ast__apply4017, 0);
  int argcv_meth_ast__apply4017[] = {1};
  meth_meth_ast__apply4017->type = alloc_MethodType(1, argcv_meth_ast__apply4017);
  meth_meth_ast__apply4017->definitionModule = modulename;
  meth_meth_ast__apply4017->definitionLine = 898;
// compiled block node returning block4016 (depth = 8)
  gc_frame_newslot(block4016);
// call case 5: prelude request
  params[0] = call4015;
  params[1] = block4016;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4054 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4011);
// compiled call node returning call4054 (depth = 7)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool4057 = alloc_Boolean(0);
// compiled identifier node returning bool4057 (depth = 9)
  int op_slot_right_4056 = gc_frame_newslot(bool4057);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call4060 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4059);
// compiled call node returning call4060 (depth = 10)
// compiled member node returning call4060 (depth = 9)
  int op_slot_left_4056 = gc_frame_newslot(call4060);
  params[0] = bool4057;
  partcv[0] = 1;
  Object opresult4061 = callmethod(call4060, "!=", 1, partcv, params);
// compiled op node returning opresult4061 (depth = 8)
  Object if4055 = done;
  if (istrue(opresult4061)) {
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4063 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call4065 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4064);
// compiled call node returning call4065 (depth = 13)
// compiled member node returning call4065 (depth = 12)
  partcv[0] = 0;
  Object call4066 = callmethod(call4065, "value",
    1, partcv, params);
  gc_frame_end(callframe4063);
// compiled call node returning call4066 (depth = 11)
// compiled member node returning call4066 (depth = 10)
  int op_slot_right_4062 = gc_frame_newslot(call4066);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4069 == NULL) {
    strlit4069 = alloc_String("*");
    gc_root(strlit4069);
  }
// compiled string node returning strlit4069 (depth = 11)
  int op_slot_right_4068 = gc_frame_newslot(strlit4069);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4068 = gc_frame_newslot(*var_s);
  params[0] = strlit4069;
  partcv[0] = 1;
  Object opresult4071 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4071 (depth = 10)
  int op_slot_left_4062 = gc_frame_newslot(opresult4071);
  params[0] = call4066;
  partcv[0] = 1;
  Object opresult4072 = callmethod(opresult4071, "++", 1, partcv, params);
// compiled op node returning opresult4072 (depth = 9)
  *var_s = opresult4072;
  if (opresult4072 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if4055 = done;
  } else {
  }
// compiled if node returning if4055 (depth = 7)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4075 == NULL) {
    strlit4075 = alloc_String(")");
    gc_root(strlit4075);
  }
// compiled string node returning strlit4075 (depth = 9)
  int op_slot_right_4074 = gc_frame_newslot(strlit4075);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4074 = gc_frame_newslot(*var_s);
  params[0] = strlit4075;
  partcv[0] = 1;
  Object opresult4077 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4077 (depth = 8)
  *var_s = opresult4077;
  if (opresult4077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3988 = done;
  } else {
  }
// compiled if node returning if3988 (depth = 6)
  gc_frame_end(frame);
  return if3988;
}
Object meth_ast__apply4123(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4125 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num4126 = alloc_Float64(0);
// compiled num node returning num4126 (depth = 11)
  gc_frame_newslot(num4126);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_b (depth = 11)
  params[0] = num4126;
  partcv[0] = 1;
  Object call4127 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4125);
// compiled call node returning call4127 (depth = 10)
  int op_slot_right_4124 = gc_frame_newslot(call4127);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4131 == NULL) {
    strlit4131 = alloc_String("");
    gc_root(strlit4131);
  }
// compiled string node returning strlit4131 (depth = 12)
  int op_slot_right_4130 = gc_frame_newslot(strlit4131);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_4130 = gc_frame_newslot(*var_a);
  params[0] = strlit4131;
  partcv[0] = 1;
  Object opresult4133 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult4133 (depth = 11)
  Object if4129 = done;
struct StackFrameObject *iftmpstackframe4129 = stackframe;
  if (istrue(opresult4133)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4129);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4135 == NULL) {
    strlit4135 = alloc_String(", ");
    gc_root(strlit4135);
  }
// compiled string node returning strlit4135 (depth = 12)
  int op_slot_right_4134 = gc_frame_newslot(strlit4135);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_4134 = gc_frame_newslot(*var_a);
  params[0] = strlit4135;
  partcv[0] = 1;
  Object opresult4137 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult4137 (depth = 11)
    gc_frame_newslot(opresult4137);
    if4129 = opresult4137;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4129);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 11)
  if (strlit4138 == NULL) {
    strlit4138 = alloc_String("");
    gc_root(strlit4138);
  }
// compiled string node returning strlit4138 (depth = 11)
    gc_frame_newslot(strlit4138);
    if4129 = strlit4138;
  }
stackframe = iftmpstackframe4129;
// compiled if node returning if4129 (depth = 10)
  int op_slot_left_4124 = gc_frame_newslot(if4129);
  params[0] = call4127;
  partcv[0] = 1;
  Object opresult4139 = callmethod(if4129, "++", 1, partcv, params);
// compiled op node returning opresult4139 (depth = 9)
  gc_frame_end(frame);
  return opresult4139;
}
Object meth_ast__apply4156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4158 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4160 = alloc_Float64(1);
// compiled num node returning num4160 (depth = 10)
  int op_slot_right_4159 = gc_frame_newslot(num4160);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4159 = gc_frame_newslot(*var_depth);
  params[0] = num4160;
  partcv[0] = 1;
  Object sum4162 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4162 (depth = 9)
  gc_frame_newslot(sum4162);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum4162;
  partcv[0] = 1;
  Object call4163 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4158);
// compiled call node returning call4163 (depth = 8)
  int op_slot_right_4157 = gc_frame_newslot(call4163);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4166 == NULL) {
    strlit4166 = alloc_String("    ");
    gc_root(strlit4166);
  }
// compiled string node returning strlit4166 (depth = 9)
  int op_slot_right_4165 = gc_frame_newslot(strlit4166);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4168 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4171 == NULL) {
    strlit4171 = alloc_String("""\x0a""");
    gc_root(strlit4171);
  }
// compiled string node returning strlit4171 (depth = 11)
  int op_slot_right_4170 = gc_frame_newslot(strlit4171);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4170 = gc_frame_newslot(*var_s);
  params[0] = strlit4171;
  partcv[0] = 1;
  Object opresult4173 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4173 (depth = 10)
  int op_slot_left_4168 = gc_frame_newslot(opresult4173);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4174 = callmethod(opresult4173, "++", 1, partcv, params);
// compiled op node returning opresult4174 (depth = 9)
  int op_slot_left_4165 = gc_frame_newslot(opresult4174);
  params[0] = strlit4166;
  partcv[0] = 1;
  Object opresult4175 = callmethod(opresult4174, "++", 1, partcv, params);
// compiled op node returning opresult4175 (depth = 8)
  int op_slot_left_4157 = gc_frame_newslot(opresult4175);
  params[0] = call4163;
  partcv[0] = 1;
  Object opresult4176 = callmethod(opresult4175, "++", 1, partcv, params);
// compiled op node returning opresult4176 (depth = 7)
  *var_s = opresult4176;
  if (opresult4176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3885(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_firstPart = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "firstPart");
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3886 == NULL) {
    strlit3886 = alloc_String("");
    gc_root(strlit3886);
  }
// compiled string node returning strlit3886 (depth = 5)
  *var_spc = strlit3886;
  if (strlit3886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3887 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3890 = alloc_Float64(1);
// compiled num node returning num3890 (depth = 7)
  int op_slot_right_3889 = gc_frame_newslot(num3890);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_3889 = gc_frame_newslot(*var_depth);
  params[0] = num3890;
  partcv[0] = 1;
  Object diff3892 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff3892 (depth = 6)
  int op_slot_right_3888 = gc_frame_newslot(diff3892);
// starting to compile num node (depth = 6)
  Object num3894 = alloc_Float64(0);
// compiled num node returning num3894 (depth = 6)
  int op_slot_left_3888 = gc_frame_newslot(num3894);
  params[0] = diff3892;
  partcv[0] = 1;
  Object opresult3895 = callmethod(num3894, "..", 1, partcv, params);
// compiled op node returning opresult3895 (depth = 5)
  gc_frame_newslot(opresult3895);
// starting to compile block node (depth = 5)
  Object block3896 = alloc_Block(NULL, NULL, "ast", 881);
  gc_frame_newslot(block3896);
// method _apply
  block_savedest(block3896);
  Object closure3897 = createclosure(2, "_apply");
  setclosureframe(closure3897, stackframe);
  addtoclosure(closure3897, var_spc);
  addtoclosure(closure3897, selfslot);
  struct UserObject *uo3897 = (struct UserObject*)block3896;
  uo3897->data[0] = (Object)closure3897;
  Method *meth_meth_ast__apply3897 = addmethod2pos(block3896, "_apply", &meth_ast__apply3897, 0);
  int argcv_meth_ast__apply3897[] = {1};
  meth_meth_ast__apply3897->type = alloc_MethodType(1, argcv_meth_ast__apply3897);
  meth_meth_ast__apply3897->definitionModule = modulename;
  meth_meth_ast__apply3897->definitionLine = 874;
// compiled block node returning block3896 (depth = 5)
  gc_frame_newslot(block3896);
// call case 5: prelude request
  params[0] = opresult3895;
  params[1] = block3896;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3904 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3887);
// compiled call node returning call3904 (depth = 4)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit3905 == NULL) {
    strlit3905 = alloc_String("method ");
    gc_root(strlit3905);
  }
// compiled string node returning strlit3905 (depth = 5)
  *var_s = strlit3905;
  if (strlit3905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool3906 = alloc_Boolean(1);
// compiled identifier node returning bool3906 (depth = 5)
  *var_firstPart = bool3906;
  if (bool3906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3907 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3908 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3909 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3908);
// compiled call node returning call3909 (depth = 6)
// compiled member node returning call3909 (depth = 5)
  gc_frame_newslot(call3909);
// starting to compile block node (depth = 5)
  Object block3910 = alloc_Block(NULL, NULL, "ast", 886);
  gc_frame_newslot(block3910);
// method _apply
  block_savedest(block3910);
  Object closure3911 = createclosure(4, "_apply");
  setclosureframe(closure3911, stackframe);
  addtoclosure(closure3911, var_s);
  addtoclosure(closure3911, var_firstPart);
  addtoclosure(closure3911, var_depth);
  addtoclosure(closure3911, selfslot);
  struct UserObject *uo3911 = (struct UserObject*)block3910;
  uo3911->data[0] = (Object)closure3911;
  Method *meth_meth_ast__apply3911 = addmethod2pos(block3910, "_apply", &meth_ast__apply3911, 0);
  int argcv_meth_ast__apply3911[] = {1};
  meth_meth_ast__apply3911->type = alloc_MethodType(1, argcv_meth_ast__apply3911);
  meth_meth_ast__apply3911->definitionModule = modulename;
  meth_meth_ast__apply3911->definitionLine = 886;
// compiled block node returning block3910 (depth = 5)
  gc_frame_newslot(block3910);
// call case 5: prelude request
  params[0] = call3909;
  params[1] = block3910;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4080 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compiled call node returning call4080 (depth = 4)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4083 = alloc_Boolean(0);
// compiled identifier node returning bool4083 (depth = 6)
  int op_slot_right_4082 = gc_frame_newslot(bool4083);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4086 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4085);
// compiled call node returning call4086 (depth = 7)
// compiled member node returning call4086 (depth = 6)
  int op_slot_left_4082 = gc_frame_newslot(call4086);
  params[0] = bool4083;
  partcv[0] = 1;
  Object opresult4087 = callmethod(call4086, "!=", 1, partcv, params);
// compiled op node returning opresult4087 (depth = 5)
  Object if4081 = done;
  if (istrue(opresult4087)) {
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4090 == NULL) {
    strlit4090 = alloc_String("");
    gc_root(strlit4090);
  }
// compiled string node returning strlit4090 (depth = 8)
  int op_slot_right_4089 = gc_frame_newslot(strlit4090);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4093 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num4094 = alloc_Float64(0);
// compiled num node returning num4094 (depth = 10)
  gc_frame_newslot(num4094);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4096 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4095);
// compiled call node returning call4096 (depth = 11)
// compiled member node returning call4096 (depth = 10)
  params[0] = num4094;
  partcv[0] = 1;
  Object call4097 = callmethod(call4096, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4093);
// compiled call node returning call4097 (depth = 9)
  int op_slot_right_4092 = gc_frame_newslot(call4097);
// starting to compile string node (depth = 9)
  if (strlit4099 == NULL) {
    strlit4099 = alloc_String(" -> ");
    gc_root(strlit4099);
  }
// compiled string node returning strlit4099 (depth = 9)
  int op_slot_left_4092 = gc_frame_newslot(strlit4099);
  params[0] = call4097;
  partcv[0] = 1;
  Object opresult4100 = callmethod(strlit4099, "++", 1, partcv, params);
// compiled op node returning opresult4100 (depth = 8)
  int op_slot_left_4089 = gc_frame_newslot(opresult4100);
  params[0] = strlit4090;
  partcv[0] = 1;
  Object opresult4101 = callmethod(opresult4100, "++", 1, partcv, params);
// compiled op node returning opresult4101 (depth = 7)
  int op_slot_right_4088 = gc_frame_newslot(opresult4101);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4088 = gc_frame_newslot(*var_s);
  params[0] = opresult4101;
  partcv[0] = 1;
  Object opresult4103 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4103 (depth = 6)
  *var_s = opresult4103;
  if (opresult4103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4081 = done;
  } else {
  }
// compiled if node returning if4081 (depth = 4)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4107 = alloc_Float64(0);
// compiled num node returning num4107 (depth = 6)
  int op_slot_right_4106 = gc_frame_newslot(num4107);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4109 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4111 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4110);
// compiled call node returning call4111 (depth = 9)
// compiled member node returning call4111 (depth = 8)
  partcv[0] = 0;
  Object call4112 = callmethod(call4111, "size",
    1, partcv, params);
  gc_frame_end(callframe4109);
// compiled call node returning call4112 (depth = 7)
// compiled member node returning call4112 (depth = 6)
  int op_slot_left_4106 = gc_frame_newslot(call4112);
  params[0] = num4107;
  partcv[0] = 1;
  Object opresult4113 = callmethod(call4112, ">", 1, partcv, params);
// compiled op node returning opresult4113 (depth = 5)
  Object if4105 = done;
  if (istrue(opresult4113)) {
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4115 == NULL) {
    strlit4115 = alloc_String(" is ");
    gc_root(strlit4115);
  }
// compiled string node returning strlit4115 (depth = 7)
  int op_slot_right_4114 = gc_frame_newslot(strlit4115);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4114 = gc_frame_newslot(*var_s);
  params[0] = strlit4115;
  partcv[0] = 1;
  Object opresult4117 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4117 (depth = 6)
  *var_s = opresult4117;
  if (opresult4117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4120 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4121 == NULL) {
    strlit4121 = alloc_String("");
    gc_root(strlit4121);
  }
// compiled string node returning strlit4121 (depth = 8)
  gc_frame_newslot(strlit4121);
// starting to compile block node (depth = 8)
  Object block4122 = alloc_Block(NULL, NULL, "ast", 916);
  gc_frame_newslot(block4122);
// method _apply
  block_savedest(block4122);
  Object closure4123 = createclosure(1, "_apply");
  setclosureframe(closure4123, stackframe);
  addtoclosure(closure4123, selfslot);
  struct UserObject *uo4123 = (struct UserObject*)block4122;
  uo4123->data[0] = (Object)closure4123;
  Method *meth_meth_ast__apply4123 = addmethod2pos(block4122, "_apply", &meth_ast__apply4123, 0);
  int argcv_meth_ast__apply4123[] = {2};
  meth_meth_ast__apply4123->type = alloc_MethodType(1, argcv_meth_ast__apply4123);
  meth_meth_ast__apply4123->definitionModule = modulename;
  meth_meth_ast__apply4123->definitionLine = 914;
// compiled block node returning block4122 (depth = 8)
  gc_frame_newslot(block4122);
// call case 6: other member request
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4141 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4142 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4141);
// compiled call node returning call4142 (depth = 9)
// compiled member node returning call4142 (depth = 8)
  params[0] = strlit4121;
  params[1] = block4122;
  partcv[0] = 2;
  Object call4143 = callmethod(call4142, "reduce",
    1, partcv, params);
  gc_frame_end(callframe4120);
// compiled call node returning call4143 (depth = 7)
  int op_slot_right_4119 = gc_frame_newslot(call4143);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4119 = gc_frame_newslot(*var_s);
  params[0] = call4143;
  partcv[0] = 1;
  Object opresult4145 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4145 (depth = 6)
  *var_s = opresult4145;
  if (opresult4145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4105 = done;
  } else {
  }
// compiled if node returning if4105 (depth = 4)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4148 == NULL) {
    strlit4148 = alloc_String(" {");
    gc_root(strlit4148);
  }
// compiled string node returning strlit4148 (depth = 6)
  int op_slot_right_4147 = gc_frame_newslot(strlit4148);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4147 = gc_frame_newslot(*var_s);
  params[0] = strlit4148;
  partcv[0] = 1;
  Object opresult4150 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4150 (depth = 5)
  *var_s = opresult4150;
  if (opresult4150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4152 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4154 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4153);
// compiled call node returning call4154 (depth = 6)
// compiled member node returning call4154 (depth = 5)
  gc_frame_newslot(call4154);
// starting to compile block node (depth = 5)
  Object block4155 = alloc_Block(NULL, NULL, "ast", 920);
  gc_frame_newslot(block4155);
// method _apply
  block_savedest(block4155);
  Object closure4156 = createclosure(4, "_apply");
  setclosureframe(closure4156, stackframe);
  addtoclosure(closure4156, var_depth);
  addtoclosure(closure4156, var_spc);
  addtoclosure(closure4156, var_s);
  addtoclosure(closure4156, selfslot);
  struct UserObject *uo4156 = (struct UserObject*)block4155;
  uo4156->data[0] = (Object)closure4156;
  Method *meth_meth_ast__apply4156 = addmethod2pos(block4155, "_apply", &meth_ast__apply4156, 0);
  int argcv_meth_ast__apply4156[] = {1};
  meth_meth_ast__apply4156->type = alloc_MethodType(1, argcv_meth_ast__apply4156);
  meth_meth_ast__apply4156->definitionModule = modulename;
  meth_meth_ast__apply4156->definitionLine = 920;
// compiled block node returning block4155 (depth = 5)
  gc_frame_newslot(block4155);
// call case 5: prelude request
  params[0] = call4154;
  params[1] = block4155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4179 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4152);
// compiled call node returning call4179 (depth = 4)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4181 == NULL) {
    strlit4181 = alloc_String("}");
    gc_root(strlit4181);
  }
// compiled string node returning strlit4181 (depth = 6)
  int op_slot_right_4180 = gc_frame_newslot(strlit4181);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4183 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4186 == NULL) {
    strlit4186 = alloc_String("""\x0a""");
    gc_root(strlit4186);
  }
// compiled string node returning strlit4186 (depth = 8)
  int op_slot_right_4185 = gc_frame_newslot(strlit4186);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4185 = gc_frame_newslot(*var_s);
  params[0] = strlit4186;
  partcv[0] = 1;
  Object opresult4188 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4188 (depth = 7)
  int op_slot_left_4183 = gc_frame_newslot(opresult4188);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4189 = callmethod(opresult4188, "++", 1, partcv, params);
// compiled op node returning opresult4189 (depth = 6)
  int op_slot_left_4180 = gc_frame_newslot(opresult4189);
  params[0] = strlit4181;
  partcv[0] = 1;
  Object opresult4190 = callmethod(opresult4189, "++", 1, partcv, params);
// compiled op node returning opresult4190 (depth = 5)
  *var_s = opresult4190;
  if (opresult4190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString4192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4194 == NULL) {
    strlit4194 = alloc_String("");
    gc_root(strlit4194);
  }
// compiled string node returning strlit4194 (depth = 5)
  int op_slot_right_4193 = gc_frame_newslot(strlit4194);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4198 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4197);
// compiled call node returning call4198 (depth = 7)
// compiled member node returning call4198 (depth = 6)
  int op_slot_right_4196 = gc_frame_newslot(call4198);
// starting to compile string node (depth = 6)
  if (strlit4200 == NULL) {
    strlit4200 = alloc_String("Method ");
    gc_root(strlit4200);
  }
// compiled string node returning strlit4200 (depth = 6)
  int op_slot_left_4196 = gc_frame_newslot(strlit4200);
  params[0] = call4198;
  partcv[0] = 1;
  Object opresult4201 = callmethod(strlit4200, "++", 1, partcv, params);
// compiled op node returning opresult4201 (depth = 5)
  int op_slot_left_4193 = gc_frame_newslot(opresult4201);
  params[0] = strlit4194;
  partcv[0] = 1;
  Object opresult4202 = callmethod(opresult4201, "++", 1, partcv, params);
// compiled op node returning opresult4202 (depth = 4)
  gc_frame_end(frame);
  return opresult4202;
}
Object meth_ast_shallowCopyWithParent4203(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[4];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4204 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe4205 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4206 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4207 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4206);
// compiled call node returning call4207 (depth = 7)
// compiled member node returning call4207 (depth = 6)
  gc_frame_newslot(call4207);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4208 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4209 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4208);
// compiled call node returning call4209 (depth = 7)
// compiled member node returning call4209 (depth = 6)
  gc_frame_newslot(call4209);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4211 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4210);
// compiled call node returning call4211 (depth = 7)
// compiled member node returning call4211 (depth = 6)
  gc_frame_newslot(call4211);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4212 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4213 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4212);
// compiled call node returning call4213 (depth = 7)
// compiled member node returning call4213 (depth = 6)
  gc_frame_newslot(call4213);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodNode (depth = 6)
  params[0] = call4207;
  params[1] = call4209;
  params[2] = call4211;
  params[3] = call4213;
  partcv[0] = 4;
  Object call4214 = callmethod(*var_methodNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4205);
// compiled call node returning call4214 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4215 = callmethod(call4214, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe4204);
// compiled call node returning call4215 (depth = 4)
  gc_frame_end(frame);
  return call4215;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent4216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4217 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4218 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4217);
// compiled call node returning call4218 (depth = 4)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4219 = gc_frame_new();
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call4221 = callmethod(*var_other, "isFresh",
    1, partcv, params);
  gc_frame_end(callframe4220);
// compiled call node returning call4221 (depth = 7)
// compiled member node returning call4221 (depth = 6)
  gc_frame_newslot(call4221);
// call case 4: self request
  params[0] = call4221;
  partcv[0] = 1;
  Object call4222 = callmethodflags(self, "isFresh:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4219);
// compiled call node returning call4222 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4223 = gc_frame_new();
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call4225 = callmethod(*var_other, "selfclosure",
    1, partcv, params);
  gc_frame_end(callframe4224);
// compiled call node returning call4225 (depth = 7)
// compiled member node returning call4225 (depth = 6)
  gc_frame_newslot(call4225);
// call case 4: self request
  params[0] = call4225;
  partcv[0] = 1;
  Object call4226 = callmethodflags(self, "selfclosure:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4223);
// compiled call node returning call4226 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new3261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_symbolTableNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3262 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3262 = alloc_userobj2(38,30, objclass3262);
  gc_frame_newslot(obj3262);
if (objclass3262 == NULL) {
  glfree(obj3262->class->name);
  obj3262->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3262, self, 0);
  addmethodreal(obj3262,"outer", &reader_ast_outer_3263);
  Object oldself3262 = self;
  struct StackFrameObject *oldstackframe3262 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3262);
  gc_frame_newslot((Object)stackframe);
  self = obj3262;
  Object *oldselfslot3262 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3262 = (*(struct UserObject *)self).data[0], lowerouter3262 = thisouter3262;
  if (inheritingObject3262) {
    struct UserObject *inho3262 = (struct UserObject *)inheritingObject3262;
    while (inho3262->super != GraceDefaultObject) inho3262 = (struct UserObject *)inho3262->super;
    inho3262->super = obj3262;
    self = inheritingObject3262;
    *selfslot = self;
    lowerouter3262 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3262;
  }
if (objclass3262 == NULL) {
  Method *reader3264 = addmethodrealflags(obj3262, "kind",&reader_ast_kind_3264, MFLAG_DEF);
  reader3264->definitionModule = modulename;
  reader3264->definitionLine = 762;
}
adddatum2(obj3262, alloc_Undefined(), 1);
if (objclass3262 == NULL) {
  Method *reader3265 = addmethodrealflags(obj3262, "value",&reader_ast_value_3265, 0);
  Method *writer3265 = addmethodrealflags(obj3262, "value:=",&writer_ast_value_3265, 0);
  reader3265->definitionModule = modulename;
  writer3265->definitionModule = modulename;
  reader3265->definitionLine = 763;
  writer3265->definitionLine = 763;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 2);
if (objclass3262 == NULL) {
  Method *reader3266 = addmethodrealflags(obj3262, "signature",&reader_ast_signature_3266, 0);
  Method *writer3266 = addmethodrealflags(obj3262, "signature:=",&writer_ast_signature_3266, 0);
  reader3266->definitionModule = modulename;
  writer3266->definitionModule = modulename;
  reader3266->definitionLine = 764;
  writer3266->definitionLine = 764;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 3);
if (objclass3262 == NULL) {
  Method *reader3267 = addmethodrealflags(obj3262, "body",&reader_ast_body_3267, 0);
  Method *writer3267 = addmethodrealflags(obj3262, "body:=",&writer_ast_body_3267, 0);
  reader3267->definitionModule = modulename;
  writer3267->definitionModule = modulename;
  reader3267->definitionLine = 765;
  writer3267->definitionLine = 765;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 4);
if (objclass3262 == NULL) {
  Method *reader3268 = addmethodrealflags(obj3262, "dtype",&reader_ast_dtype_3268, 0);
  Method *writer3268 = addmethodrealflags(obj3262, "dtype:=",&writer_ast_dtype_3268, 0);
  reader3268->definitionModule = modulename;
  writer3268->definitionModule = modulename;
  reader3268->definitionLine = 766;
  writer3268->definitionLine = 766;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 5);
if (objclass3262 == NULL) {
  Method *reader3269 = addmethodrealflags(obj3262, "varargs",&reader_ast_varargs_3269, 0);
  Method *writer3269 = addmethodrealflags(obj3262, "varargs:=",&writer_ast_varargs_3269, 0);
  reader3269->definitionModule = modulename;
  writer3269->definitionModule = modulename;
  reader3269->definitionLine = 767;
  writer3269->definitionLine = 767;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 6);
if (objclass3262 == NULL) {
  Method *reader3270 = addmethodrealflags(obj3262, "generics",&reader_ast_generics_3270, 0);
  Method *writer3270 = addmethodrealflags(obj3262, "generics:=",&writer_ast_generics_3270, 0);
  reader3270->definitionModule = modulename;
  writer3270->definitionModule = modulename;
  reader3270->definitionLine = 768;
  writer3270->definitionLine = 768;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 7);
if (objclass3262 == NULL) {
  Method *reader3271 = addmethodrealflags(obj3262, "selfclosure",&reader_ast_selfclosure_3271, 0);
  Method *writer3271 = addmethodrealflags(obj3262, "selfclosure:=",&writer_ast_selfclosure_3271, 0);
  reader3271->definitionModule = modulename;
  writer3271->definitionModule = modulename;
  reader3271->definitionLine = 769;
  writer3271->definitionLine = 769;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 8);
if (objclass3262 == NULL) {
  Method *reader3272 = addmethodrealflags(obj3262, "nameString",&reader_ast_nameString_3272, MFLAG_DEF);
  reader3272->definitionModule = modulename;
  reader3272->definitionLine = 770;
}
adddatum2(obj3262, alloc_Undefined(), 9);
if (objclass3262 == NULL) {
  Method *reader3273 = addmethodrealflags(obj3262, "annotations",&reader_ast_annotations_3273, 0);
  Method *writer3273 = addmethodrealflags(obj3262, "annotations:=",&writer_ast_annotations_3273, 0);
  reader3273->definitionModule = modulename;
  writer3273->definitionModule = modulename;
  reader3273->definitionLine = 771;
  writer3273->definitionLine = 771;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 10);
if (objclass3262 == NULL) {
  Method *reader3274 = addmethodrealflags(obj3262, "isFresh",&reader_ast_isFresh_3274, 0);
  Method *writer3274 = addmethodrealflags(obj3262, "isFresh:=",&writer_ast_isFresh_3274, 0);
  reader3274->definitionModule = modulename;
  writer3274->definitionModule = modulename;
  reader3274->definitionLine = 773;
  writer3274->definitionLine = 773;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 11);
// method declarationKind
  struct UserObject *uo3275 = (struct UserObject*)obj3262;
  uo3275->data[12] = emptyclosure;
  Method *meth_meth_ast_declarationKind3275 = addmethod2pos(obj3262, "declarationKind", &meth_ast_declarationKind3275, 12);
  int argcv_meth_ast_declarationKind3275[] = {0};
  meth_meth_ast_declarationKind3275->type = alloc_MethodType(1, argcv_meth_ast_declarationKind3275);
  meth_meth_ast_declarationKind3275->definitionModule = modulename;
  meth_meth_ast_declarationKind3275->definitionLine = 773;
// method isConfidential
  struct UserObject *uo3277 = (struct UserObject*)obj3262;
  uo3277->data[13] = emptyclosure;
  Method *meth_meth_ast_isConfidential3277 = addmethod2pos(obj3262, "isConfidential", &meth_ast_isConfidential3277, 13);
  int argcv_meth_ast_isConfidential3277[] = {0};
  meth_meth_ast_isConfidential3277->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3277);
  meth_meth_ast_isConfidential3277->definitionModule = modulename;
  meth_meth_ast_isConfidential3277->definitionLine = 776;
// method isPublic
  struct UserObject *uo3295 = (struct UserObject*)obj3262;
  uo3295->data[14] = emptyclosure;
  Method *meth_meth_ast_isPublic3295 = addmethod2pos(obj3262, "isPublic", &meth_ast_isPublic3295, 14);
  int argcv_meth_ast_isPublic3295[] = {0};
  meth_meth_ast_isPublic3295->type = alloc_MethodType(1, argcv_meth_ast_isPublic3295);
  meth_meth_ast_isPublic3295->definitionModule = modulename;
  meth_meth_ast_isPublic3295->definitionLine = 780;
// method isWritable
  struct UserObject *uo3300 = (struct UserObject*)obj3262;
  uo3300->data[15] = emptyclosure;
  Method *meth_meth_ast_isWritable3300 = addmethod2pos(obj3262, "isWritable", &meth_ast_isWritable3300, 15);
  int argcv_meth_ast_isWritable3300[] = {0};
  meth_meth_ast_isWritable3300->type = alloc_MethodType(1, argcv_meth_ast_isWritable3300);
  meth_meth_ast_isWritable3300->definitionModule = modulename;
  meth_meth_ast_isWritable3300->definitionLine = 781;
// method isReadable
  struct UserObject *uo3302 = (struct UserObject*)obj3262;
  uo3302->data[16] = emptyclosure;
  Method *meth_meth_ast_isReadable3302 = addmethod2pos(obj3262, "isReadable", &meth_ast_isReadable3302, 16);
  int argcv_meth_ast_isReadable3302[] = {0};
  meth_meth_ast_isReadable3302->type = alloc_MethodType(1, argcv_meth_ast_isReadable3302);
  meth_meth_ast_isReadable3302->definitionModule = modulename;
  meth_meth_ast_isReadable3302->definitionLine = 782;
// method usesAsType
  struct UserObject *uo3305 = (struct UserObject*)obj3262;
  uo3305->data[17] = emptyclosure;
  Method *meth_meth_ast_usesAsType3305 = addmethod2pos(obj3262, "usesAsType", &meth_ast_usesAsType3305, 17);
  int argcv_meth_ast_usesAsType3305[] = {1};
  meth_meth_ast_usesAsType3305->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3305);
  meth_meth_ast_usesAsType3305->definitionModule = modulename;
  meth_meth_ast_usesAsType3305->definitionLine = 783;
// method definesScope
  struct UserObject *uo3311 = (struct UserObject*)obj3262;
  uo3311->data[18] = emptyclosure;
  Method *meth_meth_ast_definesScope3311 = addmethod2pos(obj3262, "definesScope", &meth_ast_definesScope3311, 18);
  int argcv_meth_ast_definesScope3311[] = {0};
  meth_meth_ast_definesScope3311->type = alloc_MethodType(1, argcv_meth_ast_definesScope3311);
  meth_meth_ast_definesScope3311->definitionModule = modulename;
  meth_meth_ast_definesScope3311->definitionLine = 786;
// method objectScope
  struct UserObject *uo3329 = (struct UserObject*)obj3262;
  uo3329->data[19] = emptyclosure;
  Method *meth_meth_ast_objectScope3329 = addmethod2pos(obj3262, "objectScope", &meth_ast_objectScope3329, 19);
  int argcv_meth_ast_objectScope3329[] = {0};
  meth_meth_ast_objectScope3329->type = alloc_MethodType(1, argcv_meth_ast_objectScope3329);
  meth_meth_ast_objectScope3329->definitionModule = modulename;
  meth_meth_ast_objectScope3329->definitionLine = 789;
// method parametersDo
  struct UserObject *uo3334 = (struct UserObject*)obj3262;
  uo3334->data[20] = emptyclosure;
  Method *meth_meth_ast_parametersDo3334 = addmethod2pos(obj3262, "parametersDo", &meth_ast_parametersDo3334, 20);
  int argcv_meth_ast_parametersDo3334[] = {1};
  meth_meth_ast_parametersDo3334->type = alloc_MethodType(1, argcv_meth_ast_parametersDo3334);
  meth_meth_ast_parametersDo3334->definitionModule = modulename;
  meth_meth_ast_parametersDo3334->definitionLine = 792;
// method typeParametersDo
  struct UserObject *uo3351 = (struct UserObject*)obj3262;
  uo3351->data[21] = emptyclosure;
  Method *meth_meth_ast_typeParametersDo3351 = addmethod2pos(obj3262, "typeParametersDo", &meth_ast_typeParametersDo3351, 21);
  int argcv_meth_ast_typeParametersDo3351[] = {1};
  meth_meth_ast_typeParametersDo3351->type = alloc_MethodType(1, argcv_meth_ast_typeParametersDo3351);
  meth_meth_ast_typeParametersDo3351->definitionModule = modulename;
  meth_meth_ast_typeParametersDo3351->definitionLine = 797;
// method accept()from
  struct UserObject *uo3368 = (struct UserObject*)obj3262;
  uo3368->data[22] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3368 = addmethod2pos(obj3262, "accept()from", &meth_ast_accept_40__41_from3368, 22);
  int argcv_meth_ast_accept_40__41_from3368[] = {1, 1};
  meth_meth_ast_accept_40__41_from3368->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3368);
  meth_meth_ast_accept_40__41_from3368->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3368->definitionLine = 802;
// method map()parent
  struct UserObject *uo3432 = (struct UserObject*)obj3262;
  uo3432->data[23] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent3432 = addmethod2pos(obj3262, "map()parent", &meth_ast_map_40__41_parent3432, 23);
  int argcv_meth_ast_map_40__41_parent3432[] = {1, 1};
  meth_meth_ast_map_40__41_parent3432->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent3432);
  meth_meth_ast_map_40__41_parent3432->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent3432->definitionLine = 824;
// method pretty
  struct UserObject *uo3488 = (struct UserObject*)obj3262;
  uo3488->data[24] = emptyclosure;
  Method *meth_meth_ast_pretty3488 = addmethod2pos(obj3262, "pretty", &meth_ast_pretty3488, 24);
  int argcv_meth_ast_pretty3488[] = {1};
  meth_meth_ast_pretty3488->type = alloc_MethodType(1, argcv_meth_ast_pretty3488);
  meth_meth_ast_pretty3488->definitionModule = modulename;
  meth_meth_ast_pretty3488->definitionLine = 834;
// method toGrace
  struct UserObject *uo3885 = (struct UserObject*)obj3262;
  uo3885->data[25] = emptyclosure;
  Method *meth_meth_ast_toGrace3885 = addmethod2pos(obj3262, "toGrace", &meth_ast_toGrace3885, 25);
  int argcv_meth_ast_toGrace3885[] = {1};
  meth_meth_ast_toGrace3885->type = alloc_MethodType(1, argcv_meth_ast_toGrace3885);
meth_meth_ast_toGrace3885->type->types[0] = type_Number;
meth_meth_ast_toGrace3885->type->names[0] = "depth";
  meth_meth_ast_toGrace3885->definitionModule = modulename;
  meth_meth_ast_toGrace3885->definitionLine = 879;
// method asString
  struct UserObject *uo4192 = (struct UserObject*)obj3262;
  uo4192->data[26] = emptyclosure;
  Method *meth_meth_ast_asString4192 = addmethod2pos(obj3262, "asString", &meth_ast_asString4192, 26);
  int argcv_meth_ast_asString4192[] = {0};
  meth_meth_ast_asString4192->type = alloc_MethodType(1, argcv_meth_ast_asString4192);
  meth_meth_ast_asString4192->definitionModule = modulename;
  meth_meth_ast_asString4192->definitionLine = 926;
// method shallowCopyWithParent
  block_savedest(obj3262);
  Object closure4203 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure4203, stackframe);
  addtoclosure(closure4203, var_methodNode);
  struct UserObject *uo4203 = (struct UserObject*)obj3262;
  uo4203->data[27] = (Object)closure4203;
  Method *meth_meth_ast_shallowCopyWithParent4203 = addmethod2pos(obj3262, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent4203, 27);
  int argcv_meth_ast_shallowCopyWithParent4203[] = {1};
  meth_meth_ast_shallowCopyWithParent4203->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent4203);
  meth_meth_ast_shallowCopyWithParent4203->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent4203->definitionLine = 927;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo4216 = (struct UserObject*)obj3262;
  uo4216->data[28] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216 = addmethod2pos(obj3262, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent4216, 28);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4216[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4216);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216->definitionLine = 930;
  sourceObject = obj3262;
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4227 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4228 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4227);
// compiled call node returning call4228 (depth = 4)
  struct UserObject *obj3262_uo = (struct UserObject *)obj3262;
  obj3262_uo->super = call4228;
  sourceObject = obj3262;
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4229 == NULL) {
    strlit4229 = alloc_String("method");
    gc_root(strlit4229);
  }
// compiled string node returning strlit4229 (depth = 4)
  adddatum2(obj3262, strlit4229, 1);
  sourceObject = obj3262;
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj3262, *var_name_39_, 2);
  sourceObject = obj3262;
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj3262, *var_signature_39_, 3);
  sourceObject = obj3262;
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj3262, *var_body_39_, 4);
  sourceObject = obj3262;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj3262, *var_dtype_39_, 5);
  sourceObject = obj3262;
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4230 = alloc_Boolean(0);
// compiled identifier node returning bool4230 (depth = 4)
  adddatum2(obj3262, bool4230, 6);
  sourceObject = obj3262;
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4231 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4232 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4233 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4232);
// compiled call node returning call4233 (depth = 7)
// compiled member node returning call4233 (depth = 6)
  partcv[0] = 0;
  Object call4234 = callmethod(call4233, "empty",
    1, partcv, params);
  gc_frame_end(callframe4231);
// compiled call node returning call4234 (depth = 5)
// compiled member node returning call4234 (depth = 4)
  adddatum2(obj3262, call4234, 7);
  sourceObject = obj3262;
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4235 = alloc_Boolean(0);
// compiled identifier node returning bool4235 (depth = 4)
  adddatum2(obj3262, bool4235, 8);
  sourceObject = obj3262;
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4236 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4238 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4237);
// compiled call node returning call4238 (depth = 7)
// compiled member node returning call4238 (depth = 6)
  partcv[0] = 0;
  Object call4239 = callmethod(call4238, "value",
    1, partcv, params);
  gc_frame_end(callframe4236);
// compiled call node returning call4239 (depth = 5)
// compiled member node returning call4239 (depth = 4)
  adddatum2(obj3262, call4239, 9);
  sourceObject = obj3262;
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4240 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4241 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4242 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4241);
// compiled call node returning call4242 (depth = 7)
// compiled member node returning call4242 (depth = 6)
  partcv[0] = 0;
  Object call4243 = callmethod(call4242, "empty",
    1, partcv, params);
  gc_frame_end(callframe4240);
// compiled call node returning call4243 (depth = 5)
// compiled member node returning call4243 (depth = 4)
  adddatum2(obj3262, call4243, 10);
  sourceObject = obj3262;
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4244 = alloc_Boolean(0);
// compiled identifier node returning bool4244 (depth = 4)
  adddatum2(obj3262, bool4244, 11);
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
objclass3262 = obj3262->class;
  objclass3262->definitionModule = modulename;
  objclass3262->definitionLine = 743;
  (*(struct UserObject *)self).data[0] = lowerouter3262;
  self = oldself3262;
  selfslot = oldselfslot3262;
  stackframe = oldstackframe3262;
  gc_frame_end(frame);
  return obj3262;
}
Object meth_ast_new3261_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_symbolTableNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 4)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3262 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3262 = alloc_userobj2(38,30, objclass3262);
  gc_frame_newslot(obj3262);
if (objclass3262 == NULL) {
  glfree(obj3262->class->name);
  obj3262->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3262, self, 0);
  addmethodreal(obj3262,"outer", &reader_ast_outer_3263);
  Object oldself3262 = self;
  struct StackFrameObject *oldstackframe3262 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3262);
  gc_frame_newslot((Object)stackframe);
  self = obj3262;
  Object *oldselfslot3262 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3262 = (*(struct UserObject *)self).data[0], lowerouter3262 = thisouter3262;
  if (inheritingObject3262) {
    struct UserObject *inho3262 = (struct UserObject *)inheritingObject3262;
    while (inho3262->super != GraceDefaultObject) inho3262 = (struct UserObject *)inho3262->super;
    inho3262->super = obj3262;
    self = inheritingObject3262;
    *selfslot = self;
    lowerouter3262 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3262;
  }
if (objclass3262 == NULL) {
  Method *reader3264 = addmethodrealflags(obj3262, "kind",&reader_ast_kind_3264, MFLAG_DEF);
  reader3264->definitionModule = modulename;
  reader3264->definitionLine = 762;
}
adddatum2(obj3262, alloc_Undefined(), 1);
if (objclass3262 == NULL) {
  Method *reader3265 = addmethodrealflags(obj3262, "value",&reader_ast_value_3265, 0);
  Method *writer3265 = addmethodrealflags(obj3262, "value:=",&writer_ast_value_3265, 0);
  reader3265->definitionModule = modulename;
  writer3265->definitionModule = modulename;
  reader3265->definitionLine = 763;
  writer3265->definitionLine = 763;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 2);
if (objclass3262 == NULL) {
  Method *reader3266 = addmethodrealflags(obj3262, "signature",&reader_ast_signature_3266, 0);
  Method *writer3266 = addmethodrealflags(obj3262, "signature:=",&writer_ast_signature_3266, 0);
  reader3266->definitionModule = modulename;
  writer3266->definitionModule = modulename;
  reader3266->definitionLine = 764;
  writer3266->definitionLine = 764;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 3);
if (objclass3262 == NULL) {
  Method *reader3267 = addmethodrealflags(obj3262, "body",&reader_ast_body_3267, 0);
  Method *writer3267 = addmethodrealflags(obj3262, "body:=",&writer_ast_body_3267, 0);
  reader3267->definitionModule = modulename;
  writer3267->definitionModule = modulename;
  reader3267->definitionLine = 765;
  writer3267->definitionLine = 765;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 4);
if (objclass3262 == NULL) {
  Method *reader3268 = addmethodrealflags(obj3262, "dtype",&reader_ast_dtype_3268, 0);
  Method *writer3268 = addmethodrealflags(obj3262, "dtype:=",&writer_ast_dtype_3268, 0);
  reader3268->definitionModule = modulename;
  writer3268->definitionModule = modulename;
  reader3268->definitionLine = 766;
  writer3268->definitionLine = 766;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 5);
if (objclass3262 == NULL) {
  Method *reader3269 = addmethodrealflags(obj3262, "varargs",&reader_ast_varargs_3269, 0);
  Method *writer3269 = addmethodrealflags(obj3262, "varargs:=",&writer_ast_varargs_3269, 0);
  reader3269->definitionModule = modulename;
  writer3269->definitionModule = modulename;
  reader3269->definitionLine = 767;
  writer3269->definitionLine = 767;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 6);
if (objclass3262 == NULL) {
  Method *reader3270 = addmethodrealflags(obj3262, "generics",&reader_ast_generics_3270, 0);
  Method *writer3270 = addmethodrealflags(obj3262, "generics:=",&writer_ast_generics_3270, 0);
  reader3270->definitionModule = modulename;
  writer3270->definitionModule = modulename;
  reader3270->definitionLine = 768;
  writer3270->definitionLine = 768;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 7);
if (objclass3262 == NULL) {
  Method *reader3271 = addmethodrealflags(obj3262, "selfclosure",&reader_ast_selfclosure_3271, 0);
  Method *writer3271 = addmethodrealflags(obj3262, "selfclosure:=",&writer_ast_selfclosure_3271, 0);
  reader3271->definitionModule = modulename;
  writer3271->definitionModule = modulename;
  reader3271->definitionLine = 769;
  writer3271->definitionLine = 769;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 8);
if (objclass3262 == NULL) {
  Method *reader3272 = addmethodrealflags(obj3262, "nameString",&reader_ast_nameString_3272, MFLAG_DEF);
  reader3272->definitionModule = modulename;
  reader3272->definitionLine = 770;
}
adddatum2(obj3262, alloc_Undefined(), 9);
if (objclass3262 == NULL) {
  Method *reader3273 = addmethodrealflags(obj3262, "annotations",&reader_ast_annotations_3273, 0);
  Method *writer3273 = addmethodrealflags(obj3262, "annotations:=",&writer_ast_annotations_3273, 0);
  reader3273->definitionModule = modulename;
  writer3273->definitionModule = modulename;
  reader3273->definitionLine = 771;
  writer3273->definitionLine = 771;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 10);
if (objclass3262 == NULL) {
  Method *reader3274 = addmethodrealflags(obj3262, "isFresh",&reader_ast_isFresh_3274, 0);
  Method *writer3274 = addmethodrealflags(obj3262, "isFresh:=",&writer_ast_isFresh_3274, 0);
  reader3274->definitionModule = modulename;
  writer3274->definitionModule = modulename;
  reader3274->definitionLine = 773;
  writer3274->definitionLine = 773;
}
obj3262->flags |= OFLAG_MUTABLE;
adddatum2(obj3262, alloc_Undefined(), 11);
// method declarationKind
  struct UserObject *uo3275 = (struct UserObject*)obj3262;
  uo3275->data[12] = emptyclosure;
  Method *meth_meth_ast_declarationKind3275 = addmethod2pos(obj3262, "declarationKind", &meth_ast_declarationKind3275, 12);
  int argcv_meth_ast_declarationKind3275[] = {0};
  meth_meth_ast_declarationKind3275->type = alloc_MethodType(1, argcv_meth_ast_declarationKind3275);
  meth_meth_ast_declarationKind3275->definitionModule = modulename;
  meth_meth_ast_declarationKind3275->definitionLine = 773;
// method isConfidential
  struct UserObject *uo3277 = (struct UserObject*)obj3262;
  uo3277->data[13] = emptyclosure;
  Method *meth_meth_ast_isConfidential3277 = addmethod2pos(obj3262, "isConfidential", &meth_ast_isConfidential3277, 13);
  int argcv_meth_ast_isConfidential3277[] = {0};
  meth_meth_ast_isConfidential3277->type = alloc_MethodType(1, argcv_meth_ast_isConfidential3277);
  meth_meth_ast_isConfidential3277->definitionModule = modulename;
  meth_meth_ast_isConfidential3277->definitionLine = 776;
// method isPublic
  struct UserObject *uo3295 = (struct UserObject*)obj3262;
  uo3295->data[14] = emptyclosure;
  Method *meth_meth_ast_isPublic3295 = addmethod2pos(obj3262, "isPublic", &meth_ast_isPublic3295, 14);
  int argcv_meth_ast_isPublic3295[] = {0};
  meth_meth_ast_isPublic3295->type = alloc_MethodType(1, argcv_meth_ast_isPublic3295);
  meth_meth_ast_isPublic3295->definitionModule = modulename;
  meth_meth_ast_isPublic3295->definitionLine = 780;
// method isWritable
  struct UserObject *uo3300 = (struct UserObject*)obj3262;
  uo3300->data[15] = emptyclosure;
  Method *meth_meth_ast_isWritable3300 = addmethod2pos(obj3262, "isWritable", &meth_ast_isWritable3300, 15);
  int argcv_meth_ast_isWritable3300[] = {0};
  meth_meth_ast_isWritable3300->type = alloc_MethodType(1, argcv_meth_ast_isWritable3300);
  meth_meth_ast_isWritable3300->definitionModule = modulename;
  meth_meth_ast_isWritable3300->definitionLine = 781;
// method isReadable
  struct UserObject *uo3302 = (struct UserObject*)obj3262;
  uo3302->data[16] = emptyclosure;
  Method *meth_meth_ast_isReadable3302 = addmethod2pos(obj3262, "isReadable", &meth_ast_isReadable3302, 16);
  int argcv_meth_ast_isReadable3302[] = {0};
  meth_meth_ast_isReadable3302->type = alloc_MethodType(1, argcv_meth_ast_isReadable3302);
  meth_meth_ast_isReadable3302->definitionModule = modulename;
  meth_meth_ast_isReadable3302->definitionLine = 782;
// method usesAsType
  struct UserObject *uo3305 = (struct UserObject*)obj3262;
  uo3305->data[17] = emptyclosure;
  Method *meth_meth_ast_usesAsType3305 = addmethod2pos(obj3262, "usesAsType", &meth_ast_usesAsType3305, 17);
  int argcv_meth_ast_usesAsType3305[] = {1};
  meth_meth_ast_usesAsType3305->type = alloc_MethodType(1, argcv_meth_ast_usesAsType3305);
  meth_meth_ast_usesAsType3305->definitionModule = modulename;
  meth_meth_ast_usesAsType3305->definitionLine = 783;
// method definesScope
  struct UserObject *uo3311 = (struct UserObject*)obj3262;
  uo3311->data[18] = emptyclosure;
  Method *meth_meth_ast_definesScope3311 = addmethod2pos(obj3262, "definesScope", &meth_ast_definesScope3311, 18);
  int argcv_meth_ast_definesScope3311[] = {0};
  meth_meth_ast_definesScope3311->type = alloc_MethodType(1, argcv_meth_ast_definesScope3311);
  meth_meth_ast_definesScope3311->definitionModule = modulename;
  meth_meth_ast_definesScope3311->definitionLine = 786;
// method objectScope
  struct UserObject *uo3329 = (struct UserObject*)obj3262;
  uo3329->data[19] = emptyclosure;
  Method *meth_meth_ast_objectScope3329 = addmethod2pos(obj3262, "objectScope", &meth_ast_objectScope3329, 19);
  int argcv_meth_ast_objectScope3329[] = {0};
  meth_meth_ast_objectScope3329->type = alloc_MethodType(1, argcv_meth_ast_objectScope3329);
  meth_meth_ast_objectScope3329->definitionModule = modulename;
  meth_meth_ast_objectScope3329->definitionLine = 789;
// method parametersDo
  struct UserObject *uo3334 = (struct UserObject*)obj3262;
  uo3334->data[20] = emptyclosure;
  Method *meth_meth_ast_parametersDo3334 = addmethod2pos(obj3262, "parametersDo", &meth_ast_parametersDo3334, 20);
  int argcv_meth_ast_parametersDo3334[] = {1};
  meth_meth_ast_parametersDo3334->type = alloc_MethodType(1, argcv_meth_ast_parametersDo3334);
  meth_meth_ast_parametersDo3334->definitionModule = modulename;
  meth_meth_ast_parametersDo3334->definitionLine = 792;
// method typeParametersDo
  struct UserObject *uo3351 = (struct UserObject*)obj3262;
  uo3351->data[21] = emptyclosure;
  Method *meth_meth_ast_typeParametersDo3351 = addmethod2pos(obj3262, "typeParametersDo", &meth_ast_typeParametersDo3351, 21);
  int argcv_meth_ast_typeParametersDo3351[] = {1};
  meth_meth_ast_typeParametersDo3351->type = alloc_MethodType(1, argcv_meth_ast_typeParametersDo3351);
  meth_meth_ast_typeParametersDo3351->definitionModule = modulename;
  meth_meth_ast_typeParametersDo3351->definitionLine = 797;
// method accept()from
  struct UserObject *uo3368 = (struct UserObject*)obj3262;
  uo3368->data[22] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from3368 = addmethod2pos(obj3262, "accept()from", &meth_ast_accept_40__41_from3368, 22);
  int argcv_meth_ast_accept_40__41_from3368[] = {1, 1};
  meth_meth_ast_accept_40__41_from3368->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from3368);
  meth_meth_ast_accept_40__41_from3368->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from3368->definitionLine = 802;
// method map()parent
  struct UserObject *uo3432 = (struct UserObject*)obj3262;
  uo3432->data[23] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent3432 = addmethod2pos(obj3262, "map()parent", &meth_ast_map_40__41_parent3432, 23);
  int argcv_meth_ast_map_40__41_parent3432[] = {1, 1};
  meth_meth_ast_map_40__41_parent3432->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent3432);
  meth_meth_ast_map_40__41_parent3432->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent3432->definitionLine = 824;
// method pretty
  struct UserObject *uo3488 = (struct UserObject*)obj3262;
  uo3488->data[24] = emptyclosure;
  Method *meth_meth_ast_pretty3488 = addmethod2pos(obj3262, "pretty", &meth_ast_pretty3488, 24);
  int argcv_meth_ast_pretty3488[] = {1};
  meth_meth_ast_pretty3488->type = alloc_MethodType(1, argcv_meth_ast_pretty3488);
  meth_meth_ast_pretty3488->definitionModule = modulename;
  meth_meth_ast_pretty3488->definitionLine = 834;
// method toGrace
  struct UserObject *uo3885 = (struct UserObject*)obj3262;
  uo3885->data[25] = emptyclosure;
  Method *meth_meth_ast_toGrace3885 = addmethod2pos(obj3262, "toGrace", &meth_ast_toGrace3885, 25);
  int argcv_meth_ast_toGrace3885[] = {1};
  meth_meth_ast_toGrace3885->type = alloc_MethodType(1, argcv_meth_ast_toGrace3885);
meth_meth_ast_toGrace3885->type->types[0] = type_Number;
meth_meth_ast_toGrace3885->type->names[0] = "depth";
  meth_meth_ast_toGrace3885->definitionModule = modulename;
  meth_meth_ast_toGrace3885->definitionLine = 879;
// method asString
  struct UserObject *uo4192 = (struct UserObject*)obj3262;
  uo4192->data[26] = emptyclosure;
  Method *meth_meth_ast_asString4192 = addmethod2pos(obj3262, "asString", &meth_ast_asString4192, 26);
  int argcv_meth_ast_asString4192[] = {0};
  meth_meth_ast_asString4192->type = alloc_MethodType(1, argcv_meth_ast_asString4192);
  meth_meth_ast_asString4192->definitionModule = modulename;
  meth_meth_ast_asString4192->definitionLine = 926;
// method shallowCopyWithParent
  block_savedest(obj3262);
  Object closure4203 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure4203, stackframe);
  addtoclosure(closure4203, var_methodNode);
  struct UserObject *uo4203 = (struct UserObject*)obj3262;
  uo4203->data[27] = (Object)closure4203;
  Method *meth_meth_ast_shallowCopyWithParent4203 = addmethod2pos(obj3262, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent4203, 27);
  int argcv_meth_ast_shallowCopyWithParent4203[] = {1};
  meth_meth_ast_shallowCopyWithParent4203->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent4203);
  meth_meth_ast_shallowCopyWithParent4203->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent4203->definitionLine = 927;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo4216 = (struct UserObject*)obj3262;
  uo4216->data[28] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216 = addmethod2pos(obj3262, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent4216, 28);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4216[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4216);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4216->definitionLine = 930;
  sourceObject = obj3262;
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4227 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4228 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4227);
// compiled call node returning call4228 (depth = 4)
  struct UserObject *obj3262_uo = (struct UserObject *)obj3262;
  obj3262_uo->super = call4228;
  sourceObject = obj3262;
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4229 == NULL) {
    strlit4229 = alloc_String("method");
    gc_root(strlit4229);
  }
// compiled string node returning strlit4229 (depth = 4)
  adddatum2(obj3262, strlit4229, 1);
  sourceObject = obj3262;
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj3262, *var_name_39_, 2);
  sourceObject = obj3262;
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj3262, *var_signature_39_, 3);
  sourceObject = obj3262;
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj3262, *var_body_39_, 4);
  sourceObject = obj3262;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj3262, *var_dtype_39_, 5);
  sourceObject = obj3262;
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4230 = alloc_Boolean(0);
// compiled identifier node returning bool4230 (depth = 4)
  adddatum2(obj3262, bool4230, 6);
  sourceObject = obj3262;
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4231 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4232 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4233 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4232);
// compiled call node returning call4233 (depth = 7)
// compiled member node returning call4233 (depth = 6)
  partcv[0] = 0;
  Object call4234 = callmethod(call4233, "empty",
    1, partcv, params);
  gc_frame_end(callframe4231);
// compiled call node returning call4234 (depth = 5)
// compiled member node returning call4234 (depth = 4)
  adddatum2(obj3262, call4234, 7);
  sourceObject = obj3262;
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4235 = alloc_Boolean(0);
// compiled identifier node returning bool4235 (depth = 4)
  adddatum2(obj3262, bool4235, 8);
  sourceObject = obj3262;
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4236 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4238 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4237);
// compiled call node returning call4238 (depth = 7)
// compiled member node returning call4238 (depth = 6)
  partcv[0] = 0;
  Object call4239 = callmethod(call4238, "value",
    1, partcv, params);
  gc_frame_end(callframe4236);
// compiled call node returning call4239 (depth = 5)
// compiled member node returning call4239 (depth = 4)
  adddatum2(obj3262, call4239, 9);
  sourceObject = obj3262;
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4240 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4241 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4242 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4241);
// compiled call node returning call4242 (depth = 7)
// compiled member node returning call4242 (depth = 6)
  partcv[0] = 0;
  Object call4243 = callmethod(call4242, "empty",
    1, partcv, params);
  gc_frame_end(callframe4240);
// compiled call node returning call4243 (depth = 5)
// compiled member node returning call4243 (depth = 4)
  adddatum2(obj3262, call4243, 10);
  sourceObject = obj3262;
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4244 = alloc_Boolean(0);
// compiled identifier node returning bool4244 (depth = 4)
  adddatum2(obj3262, bool4244, 11);
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
  sourceObject = obj3262;
objclass3262 = obj3262->class;
  objclass3262->definitionModule = modulename;
  objclass3262->definitionLine = 743;
  (*(struct UserObject *)self).data[0] = lowerouter3262;
  self = oldself3262;
  selfslot = oldselfslot3262;
  stackframe = oldstackframe3262;
  gc_frame_end(frame);
  return obj3262;
}
Object meth_ast_callNode4246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for callNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callNode (depth = 3)
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast_target4258(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4259 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4260 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4259);
// compiled call node returning call4260 (depth = 5)
// compiled member node returning call4260 (depth = 4)
  gc_frame_end(frame);
  return call4260;
}
Object meth_ast_isCall4261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4262 = alloc_Boolean(1);
// compiled identifier node returning bool4262 (depth = 4)
  gc_frame_end(frame);
  return bool4262;
}
Object meth_ast__apply4266(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4268 == NULL) {
    strlit4268 = alloc_String("clone");
    gc_root(strlit4268);
  }
// compiled string node returning strlit4268 (depth = 7)
  int op_slot_right_4267 = gc_frame_newslot(strlit4268);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4270 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4272 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4271);
// compiled call node returning call4272 (depth = 10)
// compiled member node returning call4272 (depth = 9)
  partcv[0] = 0;
  Object call4273 = callmethod(call4272, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4270);
// compiled call node returning call4273 (depth = 8)
// compiled member node returning call4273 (depth = 7)
  int op_slot_left_4267 = gc_frame_newslot(call4273);
  params[0] = strlit4268;
  partcv[0] = 1;
  Object opresult4274 = callmethod(call4273, "==", 1, partcv, params);
// compiled op node returning opresult4274 (depth = 6)
  gc_frame_end(frame);
  return opresult4274;
}
Object meth_ast_definesObject4263(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4264 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4265 = alloc_Block(NULL, NULL, "ast", 966);
  gc_frame_newslot(block4265);
// method _apply
  block_savedest(block4265);
  Object closure4266 = createclosure(1, "_apply");
  setclosureframe(closure4266, stackframe);
  addtoclosure(closure4266, selfslot);
  struct UserObject *uo4266 = (struct UserObject*)block4265;
  uo4266->data[0] = (Object)closure4266;
  Method *meth_meth_ast__apply4266 = addmethod2pos(block4265, "_apply", &meth_ast__apply4266, 0);
  int argcv_meth_ast__apply4266[] = {0};
  meth_meth_ast__apply4266->type = alloc_MethodType(1, argcv_meth_ast__apply4266);
  meth_meth_ast__apply4266->definitionModule = modulename;
  meth_meth_ast__apply4266->definitionLine = 963;
// compiled block node returning block4265 (depth = 5)
  gc_frame_newslot(block4265);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4276 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4278 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4277);
// compiled call node returning call4278 (depth = 8)
// compiled member node returning call4278 (depth = 7)
  partcv[0] = 0;
  Object call4279 = callmethod(call4278, "isMember",
    1, partcv, params);
  gc_frame_end(callframe4276);
// compiled call node returning call4279 (depth = 6)
// compiled member node returning call4279 (depth = 5)
  params[0] = block4265;
  partcv[0] = 1;
  Object call4280 = callmethod(call4279, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe4264);
// compiled call node returning call4280 (depth = 4)
  gc_frame_end(frame);
  return call4280;
}
Object meth_ast__apply4298(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4299 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_visitor (depth = 10)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning self (depth = 10)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_arg (depth = 10)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4300 = callmethod(*var_arg, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4299);
// compiled call node returning call4300 (depth = 9)
  gc_frame_end(frame);
  return call4300;
}
Object meth_ast__apply4293(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4294 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4296 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4295);
// compiled call node returning call4296 (depth = 9)
// compiled member node returning call4296 (depth = 8)
  gc_frame_newslot(call4296);
// starting to compile block node (depth = 8)
  Object block4297 = alloc_Block(NULL, NULL, "ast", 972);
  gc_frame_newslot(block4297);
// method _apply
  block_savedest(block4297);
  Object closure4298 = createclosure(2, "_apply");
  setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, var_visitor);
  addtoclosure(closure4298, selfslot);
  struct UserObject *uo4298 = (struct UserObject*)block4297;
  uo4298->data[0] = (Object)closure4298;
  Method *meth_meth_ast__apply4298 = addmethod2pos(block4297, "_apply", &meth_ast__apply4298, 0);
  int argcv_meth_ast__apply4298[] = {1};
  meth_meth_ast__apply4298->type = alloc_MethodType(1, argcv_meth_ast__apply4298);
  meth_meth_ast__apply4298->definitionModule = modulename;
  meth_meth_ast__apply4298->definitionLine = 972;
// compiled block node returning block4297 (depth = 8)
  gc_frame_newslot(block4297);
// call case 5: prelude request
  params[0] = call4296;
  params[1] = block4297;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4302 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4294);
// compiled call node returning call4302 (depth = 7)
  gc_frame_end(frame);
  return call4302;
}
Object meth_ast_accept_40__41_from4281(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4283 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4284 = callmethod(*var_visitor, "visitCall()up",
    2, partcv, params);
  gc_frame_end(callframe4283);
// compiled call node returning call4284 (depth = 5)
  Object if4282 = done;
  if (istrue(call4284)) {
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4285 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4287 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4286);
// compiled call node returning call4287 (depth = 7)
// compiled member node returning call4287 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4288 = callmethod(call4287, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4285);
// compiled call node returning call4288 (depth = 5)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4289 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4290 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4291 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4290);
// compiled call node returning call4291 (depth = 7)
// compiled member node returning call4291 (depth = 6)
  gc_frame_newslot(call4291);
// starting to compile block node (depth = 6)
  Object block4292 = alloc_Block(NULL, NULL, "ast", 971);
  gc_frame_newslot(block4292);
// method _apply
  block_savedest(block4292);
  Object closure4293 = createclosure(2, "_apply");
  setclosureframe(closure4293, stackframe);
  addtoclosure(closure4293, var_visitor);
  addtoclosure(closure4293, selfslot);
  struct UserObject *uo4293 = (struct UserObject*)block4292;
  uo4293->data[0] = (Object)closure4293;
  Method *meth_meth_ast__apply4293 = addmethod2pos(block4292, "_apply", &meth_ast__apply4293, 0);
  int argcv_meth_ast__apply4293[] = {1};
  meth_meth_ast__apply4293->type = alloc_MethodType(1, argcv_meth_ast__apply4293);
  meth_meth_ast__apply4293->definitionModule = modulename;
  meth_meth_ast__apply4293->definitionLine = 971;
// compiled block node returning block4292 (depth = 6)
  gc_frame_newslot(block4292);
// call case 5: prelude request
  params[0] = call4291;
  params[1] = block4292;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4304 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4289);
// compiled call node returning call4304 (depth = 5)
    gc_frame_newslot(call4304);
    if4282 = call4304;
  } else {
  }
// compiled if node returning if4282 (depth = 4)
  gc_frame_end(frame);
  return if4282;
}
Object meth_ast_map_40__41_parent4305(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4306 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call4307 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4306);
// compiled call node returning call4307 (depth = 5)
  *var_n = call4307;
  if (call4307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4308 = gc_frame_new();
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4309 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4310 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4311 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4310);
// compiled call node returning call4311 (depth = 8)
// compiled member node returning call4311 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4312 = callmethod(call4311, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe4309);
// compiled call node returning call4312 (depth = 6)
  gc_frame_newslot(call4312);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4312;
  partcv[0] = 1;
  Object call4313 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe4308);
// compiled call node returning call4313 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4314 = gc_frame_new();
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4315 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4317 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4316);
// compiled call node returning call4317 (depth = 8)
// compiled member node returning call4317 (depth = 7)
  gc_frame_newslot(call4317);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4318 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4319 = gc_frame_new();
// call case 3: self.outer request
  Object call4320 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4319);
// compiled call node returning call4320 (depth = 10)
// compiled member node returning call4320 (depth = 9)
  partcv[0] = 0;
  Object call4321 = callmethodflags(call4320, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4318);
// compiled call node returning call4321 (depth = 8)
// compiled member node returning call4321 (depth = 7)
  params[0] = call4317;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4322 = callmethodflags(call4321, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4315);
// compiled call node returning call4322 (depth = 6)
  gc_frame_newslot(call4322);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4322;
  partcv[0] = 1;
  Object call4323 = callmethod(*var_n, "with:=",
    1, partcv, params);
  gc_frame_end(callframe4314);
// compiled call node returning call4323 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4326 = alloc_Boolean(0);
// compiled identifier node returning bool4326 (depth = 6)
  int op_slot_right_4325 = gc_frame_newslot(bool4326);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4329 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4328);
// compiled call node returning call4329 (depth = 7)
// compiled member node returning call4329 (depth = 6)
  int op_slot_left_4325 = gc_frame_newslot(call4329);
  params[0] = bool4326;
  partcv[0] = 1;
  Object opresult4330 = callmethod(call4329, "!=", 1, partcv, params);
// compiled op node returning opresult4330 (depth = 5)
  Object if4324 = done;
  if (istrue(opresult4330)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4331 = gc_frame_new();
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4332 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4334 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4333);
// compiled call node returning call4334 (depth = 9)
// compiled member node returning call4334 (depth = 8)
  gc_frame_newslot(call4334);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blk (depth = 8)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4335 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4336 = gc_frame_new();
// call case 3: self.outer request
  Object call4337 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4336);
// compiled call node returning call4337 (depth = 11)
// compiled member node returning call4337 (depth = 10)
  partcv[0] = 0;
  Object call4338 = callmethodflags(call4337, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4335);
// compiled call node returning call4338 (depth = 9)
// compiled member node returning call4338 (depth = 8)
  params[0] = call4334;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4339 = callmethodflags(call4338, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4332);
// compiled call node returning call4339 (depth = 7)
  gc_frame_newslot(call4339);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = call4339;
  partcv[0] = 1;
  Object call4340 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe4331);
// compiled call node returning call4340 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4324 = done;
  } else {
  }
// compiled if node returning if4324 (depth = 4)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4341 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4342 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4341);
// compiled call node returning call4342 (depth = 5)
  *var_n = call4342;
  if (call4342 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply4352(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit4354 == NULL) {
    strlit4354 = alloc_String("  ");
    gc_root(strlit4354);
  }
// compiled string node returning strlit4354 (depth = 8)
  int op_slot_right_4353 = gc_frame_newslot(strlit4354);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_4353 = gc_frame_newslot(*var_spc);
  params[0] = strlit4354;
  partcv[0] = 1;
  Object opresult4356 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4356 (depth = 7)
  *var_spc = opresult4356;
  if (opresult4356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4413(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4415 == NULL) {
    strlit4415 = alloc_String("""\x0a""");
    gc_root(strlit4415);
  }
// compiled string node returning strlit4415 (depth = 9)
  int op_slot_right_4414 = gc_frame_newslot(strlit4415);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4418 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4420 = alloc_Float64(2);
// compiled num node returning num4420 (depth = 12)
  int op_slot_right_4419 = gc_frame_newslot(num4420);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4419 = gc_frame_newslot(*var_depth);
  params[0] = num4420;
  partcv[0] = 1;
  Object sum4422 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4422 (depth = 11)
  gc_frame_newslot(sum4422);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_g (depth = 11)
  params[0] = sum4422;
  partcv[0] = 1;
  Object call4423 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4418);
// compiled call node returning call4423 (depth = 10)
  int op_slot_right_4417 = gc_frame_newslot(call4423);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4426 == NULL) {
    strlit4426 = alloc_String("    ");
    gc_root(strlit4426);
  }
// compiled string node returning strlit4426 (depth = 11)
  int op_slot_right_4425 = gc_frame_newslot(strlit4426);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_4428 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_4428 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4430 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4430 (depth = 11)
  int op_slot_left_4425 = gc_frame_newslot(opresult4430);
  params[0] = strlit4426;
  partcv[0] = 1;
  Object opresult4431 = callmethod(opresult4430, "++", 1, partcv, params);
// compiled op node returning opresult4431 (depth = 10)
  int op_slot_left_4417 = gc_frame_newslot(opresult4431);
  params[0] = call4423;
  partcv[0] = 1;
  Object opresult4432 = callmethod(opresult4431, "++", 1, partcv, params);
// compiled op node returning opresult4432 (depth = 9)
  int op_slot_left_4414 = gc_frame_newslot(opresult4432);
  params[0] = strlit4415;
  partcv[0] = 1;
  Object opresult4433 = callmethod(opresult4432, "++", 1, partcv, params);
// compiled op node returning opresult4433 (depth = 8)
  *var_s = opresult4433;
  if (opresult4433 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4473 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4475 = alloc_Float64(2);
// compiled num node returning num4475 (depth = 12)
  int op_slot_right_4474 = gc_frame_newslot(num4475);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4474 = gc_frame_newslot(*var_depth);
  params[0] = num4475;
  partcv[0] = 1;
  Object sum4477 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4477 (depth = 11)
  gc_frame_newslot(sum4477);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  params[0] = sum4477;
  partcv[0] = 1;
  Object call4478 = callmethod(*var_arg, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4473);
// compiled call node returning call4478 (depth = 10)
  int op_slot_right_4472 = gc_frame_newslot(call4478);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_4480 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit4483 == NULL) {
    strlit4483 = alloc_String("""\x0a""      ");
    gc_root(strlit4483);
  }
// compiled string node returning strlit4483 (depth = 12)
  int op_slot_right_4482 = gc_frame_newslot(strlit4483);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_4482 = gc_frame_newslot(*var_s);
  params[0] = strlit4483;
  partcv[0] = 1;
  Object opresult4485 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4485 (depth = 11)
  int op_slot_left_4480 = gc_frame_newslot(opresult4485);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4486 = callmethod(opresult4485, "++", 1, partcv, params);
// compiled op node returning opresult4486 (depth = 10)
  int op_slot_left_4472 = gc_frame_newslot(opresult4486);
  params[0] = call4478;
  partcv[0] = 1;
  Object opresult4487 = callmethod(opresult4486, "++", 1, partcv, params);
// compiled op node returning opresult4487 (depth = 9)
  *var_s = opresult4487;
  if (opresult4487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4452 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4451);
// compiled call node returning call4452 (depth = 9)
// compiled member node returning call4452 (depth = 8)
  int op_slot_right_4450 = gc_frame_newslot(call4452);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4455 == NULL) {
    strlit4455 = alloc_String("Part: ");
    gc_root(strlit4455);
  }
// compiled string node returning strlit4455 (depth = 9)
  int op_slot_right_4454 = gc_frame_newslot(strlit4455);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_4457 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4460 == NULL) {
    strlit4460 = alloc_String("""\x0a""  ");
    gc_root(strlit4460);
  }
// compiled string node returning strlit4460 (depth = 11)
  int op_slot_right_4459 = gc_frame_newslot(strlit4460);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4459 = gc_frame_newslot(*var_s);
  params[0] = strlit4460;
  partcv[0] = 1;
  Object opresult4462 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4462 (depth = 10)
  int op_slot_left_4457 = gc_frame_newslot(opresult4462);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4463 = callmethod(opresult4462, "++", 1, partcv, params);
// compiled op node returning opresult4463 (depth = 9)
  int op_slot_left_4454 = gc_frame_newslot(opresult4463);
  params[0] = strlit4455;
  partcv[0] = 1;
  Object opresult4464 = callmethod(opresult4463, "++", 1, partcv, params);
// compiled op node returning opresult4464 (depth = 8)
  int op_slot_left_4450 = gc_frame_newslot(opresult4464);
  params[0] = call4452;
  partcv[0] = 1;
  Object opresult4465 = callmethod(opresult4464, "++", 1, partcv, params);
// compiled op node returning opresult4465 (depth = 7)
  *var_s = opresult4465;
  if (opresult4465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4467 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4469 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4468);
// compiled call node returning call4469 (depth = 8)
// compiled member node returning call4469 (depth = 7)
  gc_frame_newslot(call4469);
// starting to compile block node (depth = 7)
  Object block4470 = alloc_Block(NULL, NULL, "ast", 1005);
  gc_frame_newslot(block4470);
// method _apply
  block_savedest(block4470);
  Object closure4471 = createclosure(4, "_apply");
  setclosureframe(closure4471, stackframe);
  addtoclosure(closure4471, var_depth);
  addtoclosure(closure4471, var_spc);
  addtoclosure(closure4471, var_s);
  addtoclosure(closure4471, selfslot);
  struct UserObject *uo4471 = (struct UserObject*)block4470;
  uo4471->data[0] = (Object)closure4471;
  Method *meth_meth_ast__apply4471 = addmethod2pos(block4470, "_apply", &meth_ast__apply4471, 0);
  int argcv_meth_ast__apply4471[] = {1};
  meth_meth_ast__apply4471->type = alloc_MethodType(1, argcv_meth_ast__apply4471);
  meth_meth_ast__apply4471->definitionModule = modulename;
  meth_meth_ast__apply4471->definitionLine = 1005;
// compiled block node returning block4470 (depth = 7)
  gc_frame_newslot(block4470);
// call case 5: prelude request
  params[0] = call4469;
  params[1] = block4470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4490 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4467);
// compiled call node returning call4490 (depth = 6)
  gc_frame_end(frame);
  return call4490;
}
Object meth_ast_pretty4344(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4345 == NULL) {
    strlit4345 = alloc_String("");
    gc_root(strlit4345);
  }
// compiled string node returning strlit4345 (depth = 5)
  *var_spc = strlit4345;
  if (strlit4345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4346 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_4347 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num4349 = alloc_Float64(0);
// compiled num node returning num4349 (depth = 6)
  int op_slot_left_4347 = gc_frame_newslot(num4349);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4350 = callmethod(num4349, "..", 1, partcv, params);
// compiled op node returning opresult4350 (depth = 5)
  gc_frame_newslot(opresult4350);
// starting to compile block node (depth = 5)
  Object block4351 = alloc_Block(NULL, NULL, "ast", 990);
  gc_frame_newslot(block4351);
// method _apply
  block_savedest(block4351);
  Object closure4352 = createclosure(2, "_apply");
  setclosureframe(closure4352, stackframe);
  addtoclosure(closure4352, var_spc);
  addtoclosure(closure4352, selfslot);
  struct UserObject *uo4352 = (struct UserObject*)block4351;
  uo4352->data[0] = (Object)closure4352;
  Method *meth_meth_ast__apply4352 = addmethod2pos(block4351, "_apply", &meth_ast__apply4352, 0);
  int argcv_meth_ast__apply4352[] = {1};
  meth_meth_ast__apply4352->type = alloc_MethodType(1, argcv_meth_ast__apply4352);
  meth_meth_ast__apply4352->definitionModule = modulename;
  meth_meth_ast__apply4352->definitionLine = 983;
// compiled block node returning block4351 (depth = 5)
  gc_frame_newslot(block4351);
// call case 5: prelude request
  params[0] = opresult4350;
  params[1] = block4351;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4359 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4346);
// compiled call node returning call4359 (depth = 4)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4361 == NULL) {
    strlit4361 = alloc_String("""\x0a""");
    gc_root(strlit4361);
  }
// compiled string node returning strlit4361 (depth = 6)
  int op_slot_right_4360 = gc_frame_newslot(strlit4361);
// starting to compile call node (depth = 6)
  int callframe4363 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4364 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4363);
// compiled call node returning call4364 (depth = 6)
  int op_slot_left_4360 = gc_frame_newslot(call4364);
  params[0] = strlit4361;
  partcv[0] = 1;
  Object opresult4365 = callmethod(call4364, "++", 1, partcv, params);
// compiled op node returning opresult4365 (depth = 5)
  *var_s = opresult4365;
  if (opresult4365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4368 == NULL) {
    strlit4368 = alloc_String("");
    gc_root(strlit4368);
  }
// compiled string node returning strlit4368 (depth = 7)
  int op_slot_right_4367 = gc_frame_newslot(strlit4368);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4371 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4373 = alloc_Float64(1);
// compiled num node returning num4373 (depth = 10)
  int op_slot_right_4372 = gc_frame_newslot(num4373);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_4372 = gc_frame_newslot(*var_depth);
  params[0] = num4373;
  partcv[0] = 1;
  Object sum4375 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4375 (depth = 9)
  gc_frame_newslot(sum4375);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4377 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4376);
// compiled call node returning call4377 (depth = 10)
// compiled member node returning call4377 (depth = 9)
  params[0] = sum4375;
  partcv[0] = 1;
  Object call4378 = callmethod(call4377, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4371);
// compiled call node returning call4378 (depth = 8)
  int op_slot_right_4370 = gc_frame_newslot(call4378);
// starting to compile string node (depth = 8)
  if (strlit4380 == NULL) {
    strlit4380 = alloc_String("Method Name: ");
    gc_root(strlit4380);
  }
// compiled string node returning strlit4380 (depth = 8)
  int op_slot_left_4370 = gc_frame_newslot(strlit4380);
  params[0] = call4378;
  partcv[0] = 1;
  Object opresult4381 = callmethod(strlit4380, "++", 1, partcv, params);
// compiled op node returning opresult4381 (depth = 7)
  int op_slot_left_4367 = gc_frame_newslot(opresult4381);
  params[0] = strlit4368;
  partcv[0] = 1;
  Object opresult4382 = callmethod(opresult4381, "++", 1, partcv, params);
// compiled op node returning opresult4382 (depth = 6)
  int op_slot_right_4366 = gc_frame_newslot(opresult4382);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4384 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4384 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4386 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4386 (depth = 6)
  int op_slot_left_4366 = gc_frame_newslot(opresult4386);
  params[0] = opresult4382;
  partcv[0] = 1;
  Object opresult4387 = callmethod(opresult4386, "++", 1, partcv, params);
// compiled op node returning opresult4387 (depth = 5)
  *var_s = opresult4387;
  if (opresult4387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4390 == NULL) {
    strlit4390 = alloc_String("""\x0a""");
    gc_root(strlit4390);
  }
// compiled string node returning strlit4390 (depth = 6)
  int op_slot_right_4389 = gc_frame_newslot(strlit4390);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_4389 = gc_frame_newslot(*var_s);
  params[0] = strlit4390;
  partcv[0] = 1;
  Object opresult4392 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4392 (depth = 5)
  *var_s = opresult4392;
  if (opresult4392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4396 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4397 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4396);
// compiled call node returning call4397 (depth = 7)
// compiled member node returning call4397 (depth = 6)
  int op_slot_right_4395 = gc_frame_newslot(call4397);
// starting to compile identifier node (depth = 6)
  Object bool4399 = alloc_Boolean(0);
// compiled identifier node returning bool4399 (depth = 6)
  int op_slot_left_4395 = gc_frame_newslot(bool4399);
  params[0] = call4397;
  partcv[0] = 1;
  Object opresult4400 = callmethod(bool4399, "!=", 1, partcv, params);
// compiled op node returning opresult4400 (depth = 5)
  Object if4394 = done;
  if (istrue(opresult4400)) {
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4402 == NULL) {
    strlit4402 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit4402);
  }
// compiled string node returning strlit4402 (depth = 7)
  int op_slot_right_4401 = gc_frame_newslot(strlit4402);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_4404 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4404 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4406 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4406 (depth = 7)
  int op_slot_left_4401 = gc_frame_newslot(opresult4406);
  params[0] = strlit4402;
  partcv[0] = 1;
  Object opresult4407 = callmethod(opresult4406, "++", 1, partcv, params);
// compiled op node returning opresult4407 (depth = 6)
  *var_s = opresult4407;
  if (opresult4407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4409 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4410 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4411 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4410);
// compiled call node returning call4411 (depth = 7)
// compiled member node returning call4411 (depth = 6)
  gc_frame_newslot(call4411);
// starting to compile block node (depth = 6)
  Object block4412 = alloc_Block(NULL, NULL, "ast", 998);
  gc_frame_newslot(block4412);
// method _apply
  block_savedest(block4412);
  Object closure4413 = createclosure(4, "_apply");
  setclosureframe(closure4413, stackframe);
  addtoclosure(closure4413, var_depth);
  addtoclosure(closure4413, var_spc);
  addtoclosure(closure4413, var_s);
  addtoclosure(closure4413, selfslot);
  struct UserObject *uo4413 = (struct UserObject*)block4412;
  uo4413->data[0] = (Object)closure4413;
  Method *meth_meth_ast__apply4413 = addmethod2pos(block4412, "_apply", &meth_ast__apply4413, 0);
  int argcv_meth_ast__apply4413[] = {1};
  meth_meth_ast__apply4413->type = alloc_MethodType(1, argcv_meth_ast__apply4413);
  meth_meth_ast__apply4413->definitionModule = modulename;
  meth_meth_ast__apply4413->definitionLine = 998;
// compiled block node returning block4412 (depth = 6)
  gc_frame_newslot(block4412);
// call case 5: prelude request
  params[0] = call4411;
  params[1] = block4412;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4436 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4409);
// compiled call node returning call4436 (depth = 5)
    gc_frame_newslot(call4436);
    if4394 = call4436;
  } else {
  }
// compiled if node returning if4394 (depth = 4)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4438 == NULL) {
    strlit4438 = alloc_String("Arguments:");
    gc_root(strlit4438);
  }
// compiled string node returning strlit4438 (depth = 6)
  int op_slot_right_4437 = gc_frame_newslot(strlit4438);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_4440 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_4440 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4442 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4442 (depth = 6)
  int op_slot_left_4437 = gc_frame_newslot(opresult4442);
  params[0] = strlit4438;
  partcv[0] = 1;
  Object opresult4443 = callmethod(opresult4442, "++", 1, partcv, params);
// compiled op node returning opresult4443 (depth = 5)
  *var_s = opresult4443;
  if (opresult4443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4445 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4446 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4447 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4446);
// compiled call node returning call4447 (depth = 6)
// compiled member node returning call4447 (depth = 5)
  gc_frame_newslot(call4447);
// starting to compile block node (depth = 5)
  Object block4448 = alloc_Block(NULL, NULL, "ast", 1003);
  gc_frame_newslot(block4448);
// method _apply
  block_savedest(block4448);
  Object closure4449 = createclosure(4, "_apply");
  setclosureframe(closure4449, stackframe);
  addtoclosure(closure4449, var_spc);
  addtoclosure(closure4449, var_s);
  addtoclosure(closure4449, var_depth);
  addtoclosure(closure4449, selfslot);
  struct UserObject *uo4449 = (struct UserObject*)block4448;
  uo4449->data[0] = (Object)closure4449;
  Method *meth_meth_ast__apply4449 = addmethod2pos(block4448, "_apply", &meth_ast__apply4449, 0);
  int argcv_meth_ast__apply4449[] = {1};
  meth_meth_ast__apply4449->type = alloc_MethodType(1, argcv_meth_ast__apply4449);
  meth_meth_ast__apply4449->definitionModule = modulename;
  meth_meth_ast__apply4449->definitionLine = 1003;
// compiled block node returning block4448 (depth = 5)
  gc_frame_newslot(block4448);
// call case 5: prelude request
  params[0] = call4447;
  params[1] = block4448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4492 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4445);
// compiled call node returning call4492 (depth = 4)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4505(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit4507 == NULL) {
    strlit4507 = alloc_String("    ");
    gc_root(strlit4507);
  }
// compiled string node returning strlit4507 (depth = 8)
  int op_slot_right_4506 = gc_frame_newslot(strlit4507);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_4506 = gc_frame_newslot(*var_spc);
  params[0] = strlit4507;
  partcv[0] = 1;
  Object opresult4509 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4509 (depth = 7)
  *var_spc = opresult4509;
  if (opresult4509 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4579(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool4581 = alloc_Boolean(0);
// compiled identifier node returning bool4581 (depth = 10)
  int op_slot_right_4580 = gc_frame_newslot(bool4581);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4583 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4584 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4583);
// compiled call node returning call4584 (depth = 11)
// compiled member node returning call4584 (depth = 10)
  int op_slot_left_4580 = gc_frame_newslot(call4584);
  params[0] = bool4581;
  partcv[0] = 1;
  Object opresult4585 = callmethod(call4584, "!=", 1, partcv, params);
// compiled op node returning opresult4585 (depth = 9)
  gc_frame_end(frame);
  return opresult4585;
}
Object meth_ast__apply4607(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4609 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num4611 = alloc_Float64(1);
// compiled num node returning num4611 (depth = 13)
  int op_slot_right_4610 = gc_frame_newslot(num4611);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_4610 = gc_frame_newslot(*var_depth);
  params[0] = num4611;
  partcv[0] = 1;
  Object sum4613 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4613 (depth = 12)
  gc_frame_newslot(sum4613);
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe4614 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ix (depth = 13)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4615 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4616 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4615);
// compiled call node returning call4616 (depth = 14)
// compiled member node returning call4616 (depth = 13)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call4617 = callmethod(call4616, "at",
    1, partcv, params);
  gc_frame_end(callframe4614);
// compiled call node returning call4617 (depth = 12)
  params[0] = sum4613;
  partcv[0] = 1;
  Object call4618 = callmethod(call4617, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4609);
// compiled call node returning call4618 (depth = 11)
  int op_slot_right_4608 = gc_frame_newslot(call4618);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4608 = gc_frame_newslot(*var_s);
  params[0] = call4618;
  partcv[0] = 1;
  Object opresult4620 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4620 (depth = 10)
  *var_s = opresult4620;
  if (opresult4620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4664(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_anr = &(stackframe->slots[0]);
  *var_anr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "arg");
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// starting to compile index node (depth = 10)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4665 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call4666 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4665);
// compiled call node returning call4666 (depth = 12)
// compiled member node returning call4666 (depth = 11)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_anr (depth = 11)
  params[0] = *var_anr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4667 = callmethod(call4666, "[]", 1, partcv, params);
// compiled index node returning idxres4667 (depth = 10)
  *var_arg = idxres4667;
  if (idxres4667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4669 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num4671 = alloc_Float64(1);
// compiled num node returning num4671 (depth = 13)
  int op_slot_right_4670 = gc_frame_newslot(num4671);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_4670 = gc_frame_newslot(*var_depth);
  params[0] = num4671;
  partcv[0] = 1;
  Object sum4673 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4673 (depth = 12)
  gc_frame_newslot(sum4673);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_arg (depth = 12)
  params[0] = sum4673;
  partcv[0] = 1;
  Object call4674 = callmethod(*var_arg, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4669);
// compiled call node returning call4674 (depth = 11)
  int op_slot_right_4668 = gc_frame_newslot(call4674);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_4668 = gc_frame_newslot(*var_s);
  params[0] = call4674;
  partcv[0] = 1;
  Object opresult4676 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4676 (depth = 10)
  *var_s = opresult4676;
  if (opresult4676 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4681 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call4682 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4681);
// compiled call node returning call4682 (depth = 14)
// compiled member node returning call4682 (depth = 13)
  partcv[0] = 0;
  Object call4683 = callmethod(call4682, "size",
    1, partcv, params);
  gc_frame_end(callframe4680);
// compiled call node returning call4683 (depth = 12)
// compiled member node returning call4683 (depth = 11)
  int op_slot_right_4679 = gc_frame_newslot(call4683);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_anr (depth = 11)
  int op_slot_left_4679 = gc_frame_newslot(*var_anr);
  params[0] = call4683;
  partcv[0] = 1;
  Object opresult4685 = callmethod(*var_anr, "<", 1, partcv, params);
// compiled op node returning opresult4685 (depth = 10)
  Object if4678 = done;
  if (istrue(opresult4685)) {
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit4687 == NULL) {
    strlit4687 = alloc_String(", ");
    gc_root(strlit4687);
  }
// compiled string node returning strlit4687 (depth = 12)
  int op_slot_right_4686 = gc_frame_newslot(strlit4687);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_4686 = gc_frame_newslot(*var_s);
  params[0] = strlit4687;
  partcv[0] = 1;
  Object opresult4689 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4689 (depth = 11)
  *var_s = opresult4689;
  if (opresult4689 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if4678 = done;
  } else {
  }
// compiled if node returning if4678 (depth = 9)
  gc_frame_end(frame);
  return if4678;
}
Object meth_ast__apply4569(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_firstPart = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call4572 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4571);
// compiled call node returning call4572 (depth = 9)
// compiled member node returning call4572 (depth = 8)
  int op_slot_right_4570 = gc_frame_newslot(call4572);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4570 = gc_frame_newslot(*var_s);
  params[0] = call4572;
  partcv[0] = 1;
  Object opresult4574 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4574 (depth = 7)
  *var_s = opresult4574;
  if (opresult4574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4577 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block4578 = alloc_Block(NULL, NULL, "ast", 1029);
  gc_frame_newslot(block4578);
// method _apply
  block_savedest(block4578);
  Object closure4579 = createclosure(1, "_apply");
  setclosureframe(closure4579, stackframe);
  addtoclosure(closure4579, selfslot);
  struct UserObject *uo4579 = (struct UserObject*)block4578;
  uo4579->data[0] = (Object)closure4579;
  Method *meth_meth_ast__apply4579 = addmethod2pos(block4578, "_apply", &meth_ast__apply4579, 0);
  int argcv_meth_ast__apply4579[] = {0};
  meth_meth_ast__apply4579->type = alloc_MethodType(1, argcv_meth_ast__apply4579);
  meth_meth_ast__apply4579->definitionModule = modulename;
  meth_meth_ast__apply4579->definitionLine = 1028;
// compiled block node returning block4578 (depth = 8)
  gc_frame_newslot(block4578);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_firstPart (depth = 8)
  params[0] = block4578;
  partcv[0] = 1;
  Object call4587 = callmethod(*var_firstPart, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe4577);
// compiled call node returning call4587 (depth = 7)
  Object if4576 = done;
  if (istrue(call4587)) {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4589 == NULL) {
    strlit4589 = alloc_String("<");
    gc_root(strlit4589);
  }
// compiled string node returning strlit4589 (depth = 9)
  int op_slot_right_4588 = gc_frame_newslot(strlit4589);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4588 = gc_frame_newslot(*var_s);
  params[0] = strlit4589;
  partcv[0] = 1;
  Object opresult4591 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4591 (depth = 8)
  *var_s = opresult4591;
  if (opresult4591 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4593 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num4596 = alloc_Float64(1);
// compiled num node returning num4596 (depth = 10)
  int op_slot_right_4595 = gc_frame_newslot(num4596);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4598 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe4599 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4600 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4599);
// compiled call node returning call4600 (depth = 13)
// compiled member node returning call4600 (depth = 12)
  partcv[0] = 0;
  Object call4601 = callmethod(call4600, "size",
    1, partcv, params);
  gc_frame_end(callframe4598);
// compiled call node returning call4601 (depth = 11)
// compiled member node returning call4601 (depth = 10)
  int op_slot_left_4595 = gc_frame_newslot(call4601);
  params[0] = num4596;
  partcv[0] = 1;
  Object diff4602 = callmethod(call4601, "-", 1, partcv, params);
// compiled op node returning diff4602 (depth = 9)
  int op_slot_right_4594 = gc_frame_newslot(diff4602);
// starting to compile num node (depth = 9)
  Object num4604 = alloc_Float64(1);
// compiled num node returning num4604 (depth = 9)
  int op_slot_left_4594 = gc_frame_newslot(num4604);
  params[0] = diff4602;
  partcv[0] = 1;
  Object opresult4605 = callmethod(num4604, "..", 1, partcv, params);
// compiled op node returning opresult4605 (depth = 8)
  gc_frame_newslot(opresult4605);
// starting to compile block node (depth = 8)
  Object block4606 = alloc_Block(NULL, NULL, "ast", 1031);
  gc_frame_newslot(block4606);
// method _apply
  block_savedest(block4606);
  Object closure4607 = createclosure(3, "_apply");
  setclosureframe(closure4607, stackframe);
  addtoclosure(closure4607, var_depth);
  addtoclosure(closure4607, var_s);
  addtoclosure(closure4607, selfslot);
  struct UserObject *uo4607 = (struct UserObject*)block4606;
  uo4607->data[0] = (Object)closure4607;
  Method *meth_meth_ast__apply4607 = addmethod2pos(block4606, "_apply", &meth_ast__apply4607, 0);
  int argcv_meth_ast__apply4607[] = {1};
  meth_meth_ast__apply4607->type = alloc_MethodType(1, argcv_meth_ast__apply4607);
  meth_meth_ast__apply4607->definitionModule = modulename;
  meth_meth_ast__apply4607->definitionLine = 1031;
// compiled block node returning block4606 (depth = 8)
  gc_frame_newslot(block4606);
// call case 5: prelude request
  params[0] = opresult4605;
  params[1] = block4606;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4623 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4593);
// compiled call node returning call4623 (depth = 7)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4625 == NULL) {
    strlit4625 = alloc_String(">");
    gc_root(strlit4625);
  }
// compiled string node returning strlit4625 (depth = 9)
  int op_slot_right_4624 = gc_frame_newslot(strlit4625);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4628 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num4630 = alloc_Float64(1);
// compiled num node returning num4630 (depth = 12)
  int op_slot_right_4629 = gc_frame_newslot(num4630);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_4629 = gc_frame_newslot(*var_depth);
  params[0] = num4630;
  partcv[0] = 1;
  Object sum4632 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum4632 (depth = 11)
  gc_frame_newslot(sum4632);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4633 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe4634 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4635 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4634);
// compiled call node returning call4635 (depth = 14)
// compiled member node returning call4635 (depth = 13)
  partcv[0] = 0;
  Object call4636 = callmethod(call4635, "last",
    1, partcv, params);
  gc_frame_end(callframe4633);
// compiled call node returning call4636 (depth = 12)
// compiled member node returning call4636 (depth = 11)
  params[0] = sum4632;
  partcv[0] = 1;
  Object call4637 = callmethod(call4636, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4628);
// compiled call node returning call4637 (depth = 10)
  int op_slot_right_4627 = gc_frame_newslot(call4637);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_4627 = gc_frame_newslot(*var_s);
  params[0] = call4637;
  partcv[0] = 1;
  Object opresult4639 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4639 (depth = 9)
  int op_slot_left_4624 = gc_frame_newslot(opresult4639);
  params[0] = strlit4625;
  partcv[0] = 1;
  Object opresult4640 = callmethod(opresult4639, "++", 1, partcv, params);
// compiled op node returning opresult4640 (depth = 8)
  *var_s = opresult4640;
  if (opresult4640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if4576 = done;
  } else {
  }
// compiled if node returning if4576 (depth = 6)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool4642 = alloc_Boolean(0);
// compiled identifier node returning bool4642 (depth = 7)
  *var_firstPart = bool4642;
  if (bool4642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num4646 = alloc_Float64(0);
// compiled num node returning num4646 (depth = 8)
  int op_slot_right_4645 = gc_frame_newslot(num4646);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4648 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4650 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4649);
// compiled call node returning call4650 (depth = 11)
// compiled member node returning call4650 (depth = 10)
  partcv[0] = 0;
  Object call4651 = callmethod(call4650, "size",
    1, partcv, params);
  gc_frame_end(callframe4648);
// compiled call node returning call4651 (depth = 9)
// compiled member node returning call4651 (depth = 8)
  int op_slot_left_4645 = gc_frame_newslot(call4651);
  params[0] = num4646;
  partcv[0] = 1;
  Object opresult4652 = callmethod(call4651, ">", 1, partcv, params);
// compiled op node returning opresult4652 (depth = 7)
  Object if4644 = done;
  if (istrue(opresult4652)) {
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4654 == NULL) {
    strlit4654 = alloc_String("(");
    gc_root(strlit4654);
  }
// compiled string node returning strlit4654 (depth = 9)
  int op_slot_right_4653 = gc_frame_newslot(strlit4654);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4653 = gc_frame_newslot(*var_s);
  params[0] = strlit4654;
  partcv[0] = 1;
  Object opresult4656 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4656 (depth = 8)
  *var_s = opresult4656;
  if (opresult4656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4658 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4659 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call4661 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4660);
// compiled call node returning call4661 (depth = 11)
// compiled member node returning call4661 (depth = 10)
  partcv[0] = 0;
  Object call4662 = callmethod(call4661, "indices",
    1, partcv, params);
  gc_frame_end(callframe4659);
// compiled call node returning call4662 (depth = 9)
// compiled member node returning call4662 (depth = 8)
  gc_frame_newslot(call4662);
// starting to compile block node (depth = 8)
  Object block4663 = alloc_Block(NULL, NULL, "ast", 1039);
  gc_frame_newslot(block4663);
// method _apply
  block_savedest(block4663);
  Object closure4664 = createclosure(4, "_apply");
  setclosureframe(closure4664, stackframe);
  addtoclosure(closure4664, var_part);
  addtoclosure(closure4664, var_depth);
  addtoclosure(closure4664, var_s);
  addtoclosure(closure4664, selfslot);
  struct UserObject *uo4664 = (struct UserObject*)block4663;
  uo4664->data[0] = (Object)closure4664;
  Method *meth_meth_ast__apply4664 = addmethod2pos(block4663, "_apply", &meth_ast__apply4664, 0);
  int argcv_meth_ast__apply4664[] = {1};
  meth_meth_ast__apply4664->type = alloc_MethodType(1, argcv_meth_ast__apply4664);
  meth_meth_ast__apply4664->definitionModule = modulename;
  meth_meth_ast__apply4664->definitionLine = 1039;
// compiled block node returning block4663 (depth = 8)
  gc_frame_newslot(block4663);
// call case 5: prelude request
  params[0] = call4662;
  params[1] = block4663;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4692 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4658);
// compiled call node returning call4692 (depth = 7)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit4694 == NULL) {
    strlit4694 = alloc_String(")");
    gc_root(strlit4694);
  }
// compiled string node returning strlit4694 (depth = 9)
  int op_slot_right_4693 = gc_frame_newslot(strlit4694);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_4693 = gc_frame_newslot(*var_s);
  params[0] = strlit4694;
  partcv[0] = 1;
  Object opresult4696 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4696 (depth = 8)
  *var_s = opresult4696;
  if (opresult4696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if4644 = done;
  } else {
  }
// compiled if node returning if4644 (depth = 6)
  gc_frame_end(frame);
  return if4644;
}
Object meth_ast_toGrace4493(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_member = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "member");
  Object *var_firstPart = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "firstPart");
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4494 == NULL) {
    strlit4494 = alloc_String("");
    gc_root(strlit4494);
  }
// compiled string node returning strlit4494 (depth = 5)
  *var_spc = strlit4494;
  if (strlit4494 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4495 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num4498 = alloc_Float64(1);
// compiled num node returning num4498 (depth = 7)
  int op_slot_right_4497 = gc_frame_newslot(num4498);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_4497 = gc_frame_newslot(*var_depth);
  params[0] = num4498;
  partcv[0] = 1;
  Object diff4500 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff4500 (depth = 6)
  int op_slot_right_4496 = gc_frame_newslot(diff4500);
// starting to compile num node (depth = 6)
  Object num4502 = alloc_Float64(0);
// compiled num node returning num4502 (depth = 6)
  int op_slot_left_4496 = gc_frame_newslot(num4502);
  params[0] = diff4500;
  partcv[0] = 1;
  Object opresult4503 = callmethod(num4502, "..", 1, partcv, params);
// compiled op node returning opresult4503 (depth = 5)
  gc_frame_newslot(opresult4503);
// starting to compile block node (depth = 5)
  Object block4504 = alloc_Block(NULL, NULL, "ast", 1013);
  gc_frame_newslot(block4504);
// method _apply
  block_savedest(block4504);
  Object closure4505 = createclosure(2, "_apply");
  setclosureframe(closure4505, stackframe);
  addtoclosure(closure4505, var_spc);
  addtoclosure(closure4505, selfslot);
  struct UserObject *uo4505 = (struct UserObject*)block4504;
  uo4505->data[0] = (Object)closure4505;
  Method *meth_meth_ast__apply4505 = addmethod2pos(block4504, "_apply", &meth_ast__apply4505, 0);
  int argcv_meth_ast__apply4505[] = {1};
  meth_meth_ast__apply4505->type = alloc_MethodType(1, argcv_meth_ast__apply4505);
  meth_meth_ast__apply4505->definitionModule = modulename;
  meth_meth_ast__apply4505->definitionLine = 1005;
// compiled block node returning block4504 (depth = 5)
  gc_frame_newslot(block4504);
// call case 5: prelude request
  params[0] = opresult4503;
  params[1] = block4504;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4512 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4495);
// compiled call node returning call4512 (depth = 4)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4513 == NULL) {
    strlit4513 = alloc_String("");
    gc_root(strlit4513);
  }
// compiled string node returning strlit4513 (depth = 5)
  *var_s = strlit4513;
  if (strlit4513 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4516 == NULL) {
    strlit4516 = alloc_String("member");
    gc_root(strlit4516);
  }
// compiled string node returning strlit4516 (depth = 6)
  int op_slot_right_4515 = gc_frame_newslot(strlit4516);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4518 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4519 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4520 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4519);
// compiled call node returning call4520 (depth = 9)
// compiled member node returning call4520 (depth = 8)
  partcv[0] = 0;
  Object call4521 = callmethod(call4520, "kind",
    1, partcv, params);
  gc_frame_end(callframe4518);
// compiled call node returning call4521 (depth = 7)
// compiled member node returning call4521 (depth = 6)
  int op_slot_left_4515 = gc_frame_newslot(call4521);
  params[0] = strlit4516;
  partcv[0] = 1;
  Object opresult4522 = callmethod(call4521, "==", 1, partcv, params);
// compiled op node returning opresult4522 (depth = 5)
  Object if4514 = done;
  if (istrue(opresult4522)) {
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4523 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4524 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4523);
// compiled call node returning call4524 (depth = 7)
// compiled member node returning call4524 (depth = 6)
  *var_member = call4524;
  if (call4524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4527 == NULL) {
    strlit4527 = alloc_String("prefix");
    gc_root(strlit4527);
  }
// compiled string node returning strlit4527 (depth = 7)
  int op_slot_right_4526 = gc_frame_newslot(strlit4527);
// starting to compile call node (depth = 7)
  int callframe4529 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num4530 = alloc_Float64(1);
// compiled num node returning num4530 (depth = 8)
  gc_frame_newslot(num4530);
// starting to compile num node (depth = 8)
  Object num4531 = alloc_Float64(6);
// compiled num node returning num4531 (depth = 8)
  gc_frame_newslot(num4531);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_member (depth = 10)
  partcv[0] = 0;
  Object call4533 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4532);
// compiled call node returning call4533 (depth = 9)
// compiled member node returning call4533 (depth = 8)
  params[0] = num4530;
  params[1] = num4531;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4534 = callmethod(call4533, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4529);
// compiled call node returning call4534 (depth = 7)
  int op_slot_left_4526 = gc_frame_newslot(call4534);
  params[0] = strlit4527;
  partcv[0] = 1;
  Object opresult4535 = callmethod(call4534, "==", 1, partcv, params);
// compiled op node returning opresult4535 (depth = 6)
  Object if4525 = done;
  if (istrue(opresult4535)) {
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4536 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num4537 = alloc_Float64(7);
// compiled num node returning num4537 (depth = 8)
  gc_frame_newslot(num4537);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4538 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_member (depth = 12)
  partcv[0] = 0;
  Object call4540 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4539);
// compiled call node returning call4540 (depth = 11)
// compiled member node returning call4540 (depth = 10)
  partcv[0] = 0;
  Object call4541 = callmethod(call4540, "size",
    1, partcv, params);
  gc_frame_end(callframe4538);
// compiled call node returning call4541 (depth = 9)
// compiled member node returning call4541 (depth = 8)
  gc_frame_newslot(call4541);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_member (depth = 10)
  partcv[0] = 0;
  Object call4543 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4542);
// compiled call node returning call4543 (depth = 9)
// compiled member node returning call4543 (depth = 8)
  params[0] = num4537;
  params[1] = call4541;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4544 = callmethod(call4543, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4536);
// compiled call node returning call4544 (depth = 7)
  *var_s = call4544;
  if (call4544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4547 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num4548 = alloc_Float64(0);
// compiled num node returning num4548 (depth = 9)
  gc_frame_newslot(num4548);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_member (depth = 11)
  partcv[0] = 0;
  Object call4550 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4549);
// compiled call node returning call4550 (depth = 10)
// compiled member node returning call4550 (depth = 9)
  params[0] = num4548;
  partcv[0] = 1;
  Object call4551 = callmethod(call4550, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4547);
// compiled call node returning call4551 (depth = 8)
  int op_slot_right_4546 = gc_frame_newslot(call4551);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_4546 = gc_frame_newslot(*var_s);
  params[0] = call4551;
  partcv[0] = 1;
  Object opresult4553 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult4553 (depth = 7)
  return opresult4553;
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if4525 = undefined;
  } else {
  }
// compiled if node returning if4525 (depth = 5)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit4555 == NULL) {
    strlit4555 = alloc_String(".");
    gc_root(strlit4555);
  }
// compiled string node returning strlit4555 (depth = 7)
  int op_slot_right_4554 = gc_frame_newslot(strlit4555);
// starting to compile call node (depth = 7)
  int callframe4557 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num4558 = alloc_Float64(0);
// compiled num node returning num4558 (depth = 8)
  gc_frame_newslot(num4558);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_member (depth = 10)
  partcv[0] = 0;
  Object call4560 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4559);
// compiled call node returning call4560 (depth = 9)
// compiled member node returning call4560 (depth = 8)
  params[0] = num4558;
  partcv[0] = 1;
  Object call4561 = callmethod(call4560, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4557);
// compiled call node returning call4561 (depth = 7)
  int op_slot_left_4554 = gc_frame_newslot(call4561);
  params[0] = strlit4555;
  partcv[0] = 1;
  Object opresult4562 = callmethod(call4561, "++", 1, partcv, params);
// compiled op node returning opresult4562 (depth = 6)
  *var_s = opresult4562;
  if (opresult4562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if4514 = done;
  } else {
  }
// compiled if node returning if4514 (depth = 4)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool4564 = alloc_Boolean(1);
// compiled identifier node returning bool4564 (depth = 5)
  *var_firstPart = bool4564;
  if (bool4564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4565 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4566 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4567 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4566);
// compiled call node returning call4567 (depth = 6)
// compiled member node returning call4567 (depth = 5)
  gc_frame_newslot(call4567);
// starting to compile block node (depth = 5)
  Object block4568 = alloc_Block(NULL, NULL, "ast", 1027);
  gc_frame_newslot(block4568);
// method _apply
  block_savedest(block4568);
  Object closure4569 = createclosure(4, "_apply");
  setclosureframe(closure4569, stackframe);
  addtoclosure(closure4569, var_s);
  addtoclosure(closure4569, var_firstPart);
  addtoclosure(closure4569, var_depth);
  addtoclosure(closure4569, selfslot);
  struct UserObject *uo4569 = (struct UserObject*)block4568;
  uo4569->data[0] = (Object)closure4569;
  Method *meth_meth_ast__apply4569 = addmethod2pos(block4568, "_apply", &meth_ast__apply4569, 0);
  int argcv_meth_ast__apply4569[] = {1};
  meth_meth_ast__apply4569->type = alloc_MethodType(1, argcv_meth_ast__apply4569);
  meth_meth_ast__apply4569->definitionModule = modulename;
  meth_meth_ast__apply4569->definitionLine = 1027;
// compiled block node returning block4568 (depth = 5)
  gc_frame_newslot(block4568);
// call case 5: prelude request
  params[0] = call4567;
  params[1] = block4568;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4699 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4565);
// compiled call node returning call4699 (depth = 4)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString4700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_what = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4702 == NULL) {
    strlit4702 = alloc_String("");
    gc_root(strlit4702);
  }
// compiled string node returning strlit4702 (depth = 5)
  int op_slot_right_4701 = gc_frame_newslot(strlit4702);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4705 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num4706 = alloc_Float64(0);
// compiled num node returning num4706 (depth = 7)
  gc_frame_newslot(num4706);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_what (depth = 7)
  params[0] = num4706;
  partcv[0] = 1;
  Object call4707 = callmethod(*var_what, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4705);
// compiled call node returning call4707 (depth = 6)
  int op_slot_right_4704 = gc_frame_newslot(call4707);
// starting to compile string node (depth = 6)
  if (strlit4709 == NULL) {
    strlit4709 = alloc_String("Call ");
    gc_root(strlit4709);
  }
// compiled string node returning strlit4709 (depth = 6)
  int op_slot_left_4704 = gc_frame_newslot(strlit4709);
  params[0] = call4707;
  partcv[0] = 1;
  Object opresult4710 = callmethod(strlit4709, "++", 1, partcv, params);
// compiled op node returning opresult4710 (depth = 5)
  int op_slot_left_4701 = gc_frame_newslot(opresult4710);
  params[0] = strlit4702;
  partcv[0] = 1;
  Object opresult4711 = callmethod(opresult4710, "++", 1, partcv, params);
// compiled op node returning opresult4711 (depth = 4)
  gc_frame_end(frame);
  return opresult4711;
}
Object meth_ast_shallowCopyWithParent4712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4713 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe4714 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4715 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4716 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4715);
// compiled call node returning call4716 (depth = 7)
// compiled member node returning call4716 (depth = 6)
  gc_frame_newslot(call4716);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4717 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4718 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4717);
// compiled call node returning call4718 (depth = 7)
// compiled member node returning call4718 (depth = 6)
  gc_frame_newslot(call4718);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_callNode (depth = 6)
  params[0] = call4716;
  params[1] = call4718;
  partcv[0] = 2;
  Object call4719 = callmethod(*var_callNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4714);
// compiled call node returning call4719 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4720 = callmethod(call4719, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe4713);
// compiled call node returning call4720 (depth = 4)
  gc_frame_end(frame);
  return call4720;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent4721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4722 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4723 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4722);
// compiled call node returning call4723 (depth = 4)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4724 = gc_frame_new();
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call4726 = callmethod(*var_other, "isPattern",
    1, partcv, params);
  gc_frame_end(callframe4725);
// compiled call node returning call4726 (depth = 7)
// compiled member node returning call4726 (depth = 6)
  gc_frame_newslot(call4726);
// call case 4: self request
  params[0] = call4726;
  partcv[0] = 1;
  Object call4727 = callmethodflags(self, "isPattern:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4724);
// compiled call node returning call4727 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new4249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4250 = alloc_userobj2(21,18, objclass4250);
  gc_frame_newslot(obj4250);
if (objclass4250 == NULL) {
  glfree(obj4250->class->name);
  obj4250->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4250, self, 0);
  addmethodreal(obj4250,"outer", &reader_ast_outer_4251);
  Object oldself4250 = self;
  struct StackFrameObject *oldstackframe4250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4250);
  gc_frame_newslot((Object)stackframe);
  self = obj4250;
  Object *oldselfslot4250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4250 = (*(struct UserObject *)self).data[0], lowerouter4250 = thisouter4250;
  if (inheritingObject4250) {
    struct UserObject *inho4250 = (struct UserObject *)inheritingObject4250;
    while (inho4250->super != GraceDefaultObject) inho4250 = (struct UserObject *)inho4250->super;
    inho4250->super = obj4250;
    self = inheritingObject4250;
    *selfslot = self;
    lowerouter4250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4250;
  }
if (objclass4250 == NULL) {
  Method *reader4252 = addmethodrealflags(obj4250, "kind",&reader_ast_kind_4252, MFLAG_DEF);
  reader4252->definitionModule = modulename;
  reader4252->definitionLine = 957;
}
adddatum2(obj4250, alloc_Undefined(), 1);
if (objclass4250 == NULL) {
  Method *reader4253 = addmethodrealflags(obj4250, "value",&reader_ast_value_4253, 0);
  Method *writer4253 = addmethodrealflags(obj4250, "value:=",&writer_ast_value_4253, 0);
  reader4253->definitionModule = modulename;
  writer4253->definitionModule = modulename;
  reader4253->definitionLine = 958;
  writer4253->definitionLine = 958;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 2);
if (objclass4250 == NULL) {
  Method *reader4254 = addmethodrealflags(obj4250, "with",&reader_ast_with_4254, 0);
  Method *writer4254 = addmethodrealflags(obj4250, "with:=",&writer_ast_with_4254, 0);
  reader4254->definitionModule = modulename;
  writer4254->definitionModule = modulename;
  reader4254->definitionLine = 959;
  writer4254->definitionLine = 959;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 3);
if (objclass4250 == NULL) {
  Method *reader4255 = addmethodrealflags(obj4250, "generics",&reader_ast_generics_4255, 0);
  Method *writer4255 = addmethodrealflags(obj4250, "generics:=",&writer_ast_generics_4255, 0);
  reader4255->definitionModule = modulename;
  writer4255->definitionModule = modulename;
  reader4255->definitionLine = 960;
  writer4255->definitionLine = 960;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 4);
if (objclass4250 == NULL) {
  Method *reader4256 = addmethodrealflags(obj4250, "isPattern",&reader_ast_isPattern_4256, 0);
  Method *writer4256 = addmethodrealflags(obj4250, "isPattern:=",&writer_ast_isPattern_4256, 0);
  reader4256->definitionModule = modulename;
  writer4256->definitionModule = modulename;
  reader4256->definitionLine = 961;
  writer4256->definitionLine = 961;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 5);
if (objclass4250 == NULL) {
  Method *reader4257 = addmethodrealflags(obj4250, "nameString",&reader_ast_nameString_4257, MFLAG_DEF);
  reader4257->definitionModule = modulename;
  reader4257->definitionLine = 963;
}
adddatum2(obj4250, alloc_Undefined(), 6);
// method target
  struct UserObject *uo4258 = (struct UserObject*)obj4250;
  uo4258->data[7] = emptyclosure;
  Method *meth_meth_ast_target4258 = addmethod2pos(obj4250, "target", &meth_ast_target4258, 7);
  int argcv_meth_ast_target4258[] = {0};
  meth_meth_ast_target4258->type = alloc_MethodType(1, argcv_meth_ast_target4258);
  meth_meth_ast_target4258->definitionModule = modulename;
  meth_meth_ast_target4258->definitionLine = 963;
// method isCall
  struct UserObject *uo4261 = (struct UserObject*)obj4250;
  uo4261->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4261 = addmethod2pos(obj4250, "isCall", &meth_ast_isCall4261, 8);
  int argcv_meth_ast_isCall4261[] = {0};
  meth_meth_ast_isCall4261->type = alloc_MethodType(1, argcv_meth_ast_isCall4261);
  meth_meth_ast_isCall4261->definitionModule = modulename;
  meth_meth_ast_isCall4261->definitionLine = 964;
// method definesObject
  struct UserObject *uo4263 = (struct UserObject*)obj4250;
  uo4263->data[9] = emptyclosure;
  Method *meth_meth_ast_definesObject4263 = addmethod2pos(obj4250, "definesObject", &meth_ast_definesObject4263, 9);
  int argcv_meth_ast_definesObject4263[] = {0};
  meth_meth_ast_definesObject4263->type = alloc_MethodType(1, argcv_meth_ast_definesObject4263);
  meth_meth_ast_definesObject4263->definitionModule = modulename;
  meth_meth_ast_definesObject4263->definitionLine = 965;
// method accept()from
  struct UserObject *uo4281 = (struct UserObject*)obj4250;
  uo4281->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4281 = addmethod2pos(obj4250, "accept()from", &meth_ast_accept_40__41_from4281, 10);
  int argcv_meth_ast_accept_40__41_from4281[] = {1, 1};
  meth_meth_ast_accept_40__41_from4281->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4281);
  meth_meth_ast_accept_40__41_from4281->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4281->definitionLine = 968;
// method map()parent
  struct UserObject *uo4305 = (struct UserObject*)obj4250;
  uo4305->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent4305 = addmethod2pos(obj4250, "map()parent", &meth_ast_map_40__41_parent4305, 11);
  int argcv_meth_ast_map_40__41_parent4305[] = {1, 1};
  meth_meth_ast_map_40__41_parent4305->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent4305);
  meth_meth_ast_map_40__41_parent4305->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent4305->definitionLine = 978;
// method pretty
  struct UserObject *uo4344 = (struct UserObject*)obj4250;
  uo4344->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty4344 = addmethod2pos(obj4250, "pretty", &meth_ast_pretty4344, 12);
  int argcv_meth_ast_pretty4344[] = {1};
  meth_meth_ast_pretty4344->type = alloc_MethodType(1, argcv_meth_ast_pretty4344);
  meth_meth_ast_pretty4344->definitionModule = modulename;
  meth_meth_ast_pretty4344->definitionLine = 988;
// method toGrace
  struct UserObject *uo4493 = (struct UserObject*)obj4250;
  uo4493->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace4493 = addmethod2pos(obj4250, "toGrace", &meth_ast_toGrace4493, 13);
  int argcv_meth_ast_toGrace4493[] = {1};
  meth_meth_ast_toGrace4493->type = alloc_MethodType(1, argcv_meth_ast_toGrace4493);
meth_meth_ast_toGrace4493->type->types[0] = type_Number;
meth_meth_ast_toGrace4493->type->names[0] = "depth";
  meth_meth_ast_toGrace4493->definitionModule = modulename;
  meth_meth_ast_toGrace4493->definitionLine = 1011;
// method asString
  block_savedest(obj4250);
  Object closure4700 = createclosure(1, "asString");
  setclosureframe(closure4700, stackframe);
  addtoclosure(closure4700, var_what);
  struct UserObject *uo4700 = (struct UserObject*)obj4250;
  uo4700->data[14] = (Object)closure4700;
  Method *meth_meth_ast_asString4700 = addmethod2pos(obj4250, "asString", &meth_ast_asString4700, 14);
  int argcv_meth_ast_asString4700[] = {0};
  meth_meth_ast_asString4700->type = alloc_MethodType(1, argcv_meth_ast_asString4700);
  meth_meth_ast_asString4700->definitionModule = modulename;
  meth_meth_ast_asString4700->definitionLine = 1051;
// method shallowCopyWithParent
  block_savedest(obj4250);
  Object closure4712 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure4712, stackframe);
  addtoclosure(closure4712, var_callNode);
  struct UserObject *uo4712 = (struct UserObject*)obj4250;
  uo4712->data[15] = (Object)closure4712;
  Method *meth_meth_ast_shallowCopyWithParent4712 = addmethod2pos(obj4250, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent4712, 15);
  int argcv_meth_ast_shallowCopyWithParent4712[] = {1};
  meth_meth_ast_shallowCopyWithParent4712->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent4712);
  meth_meth_ast_shallowCopyWithParent4712->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent4712->definitionLine = 1052;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo4721 = (struct UserObject*)obj4250;
  uo4721->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721 = addmethod2pos(obj4250, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent4721, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4721[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4721);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721->definitionLine = 1055;
  sourceObject = obj4250;
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4728 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4729 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4728);
// compiled call node returning call4729 (depth = 4)
  struct UserObject *obj4250_uo = (struct UserObject *)obj4250;
  obj4250_uo->super = call4729;
  sourceObject = obj4250;
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4730 == NULL) {
    strlit4730 = alloc_String("call");
    gc_root(strlit4730);
  }
// compiled string node returning strlit4730 (depth = 4)
  adddatum2(obj4250, strlit4730, 1);
  sourceObject = obj4250;
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_what (depth = 4)
  adddatum2(obj4250, *var_what, 2);
  sourceObject = obj4250;
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_with_39_ (depth = 4)
  adddatum2(obj4250, *var_with_39_, 3);
  sourceObject = obj4250;
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4731 = alloc_Boolean(0);
// compiled identifier node returning bool4731 (depth = 4)
  adddatum2(obj4250, bool4731, 4);
  sourceObject = obj4250;
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4732 = alloc_Boolean(0);
// compiled identifier node returning bool4732 (depth = 4)
  adddatum2(obj4250, bool4732, 5);
  sourceObject = obj4250;
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4733 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4734 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4735 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4734);
// compiled call node returning call4735 (depth = 7)
// compiled member node returning call4735 (depth = 6)
  partcv[0] = 0;
  Object call4736 = callmethod(call4735, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4733);
// compiled call node returning call4736 (depth = 5)
// compiled member node returning call4736 (depth = 4)
  adddatum2(obj4250, call4736, 6);
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
objclass4250 = obj4250->class;
  objclass4250->definitionModule = modulename;
  objclass4250->definitionLine = 937;
  (*(struct UserObject *)self).data[0] = lowerouter4250;
  self = oldself4250;
  selfslot = oldselfslot4250;
  stackframe = oldstackframe4250;
  gc_frame_end(frame);
  return obj4250;
}
Object meth_ast_new4249_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4250 = alloc_userobj2(21,18, objclass4250);
  gc_frame_newslot(obj4250);
if (objclass4250 == NULL) {
  glfree(obj4250->class->name);
  obj4250->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4250, self, 0);
  addmethodreal(obj4250,"outer", &reader_ast_outer_4251);
  Object oldself4250 = self;
  struct StackFrameObject *oldstackframe4250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4250);
  gc_frame_newslot((Object)stackframe);
  self = obj4250;
  Object *oldselfslot4250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4250 = (*(struct UserObject *)self).data[0], lowerouter4250 = thisouter4250;
  if (inheritingObject4250) {
    struct UserObject *inho4250 = (struct UserObject *)inheritingObject4250;
    while (inho4250->super != GraceDefaultObject) inho4250 = (struct UserObject *)inho4250->super;
    inho4250->super = obj4250;
    self = inheritingObject4250;
    *selfslot = self;
    lowerouter4250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4250;
  }
if (objclass4250 == NULL) {
  Method *reader4252 = addmethodrealflags(obj4250, "kind",&reader_ast_kind_4252, MFLAG_DEF);
  reader4252->definitionModule = modulename;
  reader4252->definitionLine = 957;
}
adddatum2(obj4250, alloc_Undefined(), 1);
if (objclass4250 == NULL) {
  Method *reader4253 = addmethodrealflags(obj4250, "value",&reader_ast_value_4253, 0);
  Method *writer4253 = addmethodrealflags(obj4250, "value:=",&writer_ast_value_4253, 0);
  reader4253->definitionModule = modulename;
  writer4253->definitionModule = modulename;
  reader4253->definitionLine = 958;
  writer4253->definitionLine = 958;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 2);
if (objclass4250 == NULL) {
  Method *reader4254 = addmethodrealflags(obj4250, "with",&reader_ast_with_4254, 0);
  Method *writer4254 = addmethodrealflags(obj4250, "with:=",&writer_ast_with_4254, 0);
  reader4254->definitionModule = modulename;
  writer4254->definitionModule = modulename;
  reader4254->definitionLine = 959;
  writer4254->definitionLine = 959;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 3);
if (objclass4250 == NULL) {
  Method *reader4255 = addmethodrealflags(obj4250, "generics",&reader_ast_generics_4255, 0);
  Method *writer4255 = addmethodrealflags(obj4250, "generics:=",&writer_ast_generics_4255, 0);
  reader4255->definitionModule = modulename;
  writer4255->definitionModule = modulename;
  reader4255->definitionLine = 960;
  writer4255->definitionLine = 960;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 4);
if (objclass4250 == NULL) {
  Method *reader4256 = addmethodrealflags(obj4250, "isPattern",&reader_ast_isPattern_4256, 0);
  Method *writer4256 = addmethodrealflags(obj4250, "isPattern:=",&writer_ast_isPattern_4256, 0);
  reader4256->definitionModule = modulename;
  writer4256->definitionModule = modulename;
  reader4256->definitionLine = 961;
  writer4256->definitionLine = 961;
}
obj4250->flags |= OFLAG_MUTABLE;
adddatum2(obj4250, alloc_Undefined(), 5);
if (objclass4250 == NULL) {
  Method *reader4257 = addmethodrealflags(obj4250, "nameString",&reader_ast_nameString_4257, MFLAG_DEF);
  reader4257->definitionModule = modulename;
  reader4257->definitionLine = 963;
}
adddatum2(obj4250, alloc_Undefined(), 6);
// method target
  struct UserObject *uo4258 = (struct UserObject*)obj4250;
  uo4258->data[7] = emptyclosure;
  Method *meth_meth_ast_target4258 = addmethod2pos(obj4250, "target", &meth_ast_target4258, 7);
  int argcv_meth_ast_target4258[] = {0};
  meth_meth_ast_target4258->type = alloc_MethodType(1, argcv_meth_ast_target4258);
  meth_meth_ast_target4258->definitionModule = modulename;
  meth_meth_ast_target4258->definitionLine = 963;
// method isCall
  struct UserObject *uo4261 = (struct UserObject*)obj4250;
  uo4261->data[8] = emptyclosure;
  Method *meth_meth_ast_isCall4261 = addmethod2pos(obj4250, "isCall", &meth_ast_isCall4261, 8);
  int argcv_meth_ast_isCall4261[] = {0};
  meth_meth_ast_isCall4261->type = alloc_MethodType(1, argcv_meth_ast_isCall4261);
  meth_meth_ast_isCall4261->definitionModule = modulename;
  meth_meth_ast_isCall4261->definitionLine = 964;
// method definesObject
  struct UserObject *uo4263 = (struct UserObject*)obj4250;
  uo4263->data[9] = emptyclosure;
  Method *meth_meth_ast_definesObject4263 = addmethod2pos(obj4250, "definesObject", &meth_ast_definesObject4263, 9);
  int argcv_meth_ast_definesObject4263[] = {0};
  meth_meth_ast_definesObject4263->type = alloc_MethodType(1, argcv_meth_ast_definesObject4263);
  meth_meth_ast_definesObject4263->definitionModule = modulename;
  meth_meth_ast_definesObject4263->definitionLine = 965;
// method accept()from
  struct UserObject *uo4281 = (struct UserObject*)obj4250;
  uo4281->data[10] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4281 = addmethod2pos(obj4250, "accept()from", &meth_ast_accept_40__41_from4281, 10);
  int argcv_meth_ast_accept_40__41_from4281[] = {1, 1};
  meth_meth_ast_accept_40__41_from4281->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4281);
  meth_meth_ast_accept_40__41_from4281->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4281->definitionLine = 968;
// method map()parent
  struct UserObject *uo4305 = (struct UserObject*)obj4250;
  uo4305->data[11] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent4305 = addmethod2pos(obj4250, "map()parent", &meth_ast_map_40__41_parent4305, 11);
  int argcv_meth_ast_map_40__41_parent4305[] = {1, 1};
  meth_meth_ast_map_40__41_parent4305->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent4305);
  meth_meth_ast_map_40__41_parent4305->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent4305->definitionLine = 978;
// method pretty
  struct UserObject *uo4344 = (struct UserObject*)obj4250;
  uo4344->data[12] = emptyclosure;
  Method *meth_meth_ast_pretty4344 = addmethod2pos(obj4250, "pretty", &meth_ast_pretty4344, 12);
  int argcv_meth_ast_pretty4344[] = {1};
  meth_meth_ast_pretty4344->type = alloc_MethodType(1, argcv_meth_ast_pretty4344);
  meth_meth_ast_pretty4344->definitionModule = modulename;
  meth_meth_ast_pretty4344->definitionLine = 988;
// method toGrace
  struct UserObject *uo4493 = (struct UserObject*)obj4250;
  uo4493->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace4493 = addmethod2pos(obj4250, "toGrace", &meth_ast_toGrace4493, 13);
  int argcv_meth_ast_toGrace4493[] = {1};
  meth_meth_ast_toGrace4493->type = alloc_MethodType(1, argcv_meth_ast_toGrace4493);
meth_meth_ast_toGrace4493->type->types[0] = type_Number;
meth_meth_ast_toGrace4493->type->names[0] = "depth";
  meth_meth_ast_toGrace4493->definitionModule = modulename;
  meth_meth_ast_toGrace4493->definitionLine = 1011;
// method asString
  block_savedest(obj4250);
  Object closure4700 = createclosure(1, "asString");
  setclosureframe(closure4700, stackframe);
  addtoclosure(closure4700, var_what);
  struct UserObject *uo4700 = (struct UserObject*)obj4250;
  uo4700->data[14] = (Object)closure4700;
  Method *meth_meth_ast_asString4700 = addmethod2pos(obj4250, "asString", &meth_ast_asString4700, 14);
  int argcv_meth_ast_asString4700[] = {0};
  meth_meth_ast_asString4700->type = alloc_MethodType(1, argcv_meth_ast_asString4700);
  meth_meth_ast_asString4700->definitionModule = modulename;
  meth_meth_ast_asString4700->definitionLine = 1051;
// method shallowCopyWithParent
  block_savedest(obj4250);
  Object closure4712 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure4712, stackframe);
  addtoclosure(closure4712, var_callNode);
  struct UserObject *uo4712 = (struct UserObject*)obj4250;
  uo4712->data[15] = (Object)closure4712;
  Method *meth_meth_ast_shallowCopyWithParent4712 = addmethod2pos(obj4250, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent4712, 15);
  int argcv_meth_ast_shallowCopyWithParent4712[] = {1};
  meth_meth_ast_shallowCopyWithParent4712->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent4712);
  meth_meth_ast_shallowCopyWithParent4712->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent4712->definitionLine = 1052;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo4721 = (struct UserObject*)obj4250;
  uo4721->data[16] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721 = addmethod2pos(obj4250, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent4721, 16);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4721[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent4721);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent4721->definitionLine = 1055;
  sourceObject = obj4250;
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4728 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4729 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4728);
// compiled call node returning call4729 (depth = 4)
  struct UserObject *obj4250_uo = (struct UserObject *)obj4250;
  obj4250_uo->super = call4729;
  sourceObject = obj4250;
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4730 == NULL) {
    strlit4730 = alloc_String("call");
    gc_root(strlit4730);
  }
// compiled string node returning strlit4730 (depth = 4)
  adddatum2(obj4250, strlit4730, 1);
  sourceObject = obj4250;
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_what (depth = 4)
  adddatum2(obj4250, *var_what, 2);
  sourceObject = obj4250;
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_with_39_ (depth = 4)
  adddatum2(obj4250, *var_with_39_, 3);
  sourceObject = obj4250;
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4731 = alloc_Boolean(0);
// compiled identifier node returning bool4731 (depth = 4)
  adddatum2(obj4250, bool4731, 4);
  sourceObject = obj4250;
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4732 = alloc_Boolean(0);
// compiled identifier node returning bool4732 (depth = 4)
  adddatum2(obj4250, bool4732, 5);
  sourceObject = obj4250;
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4733 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4734 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4735 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4734);
// compiled call node returning call4735 (depth = 7)
// compiled member node returning call4735 (depth = 6)
  partcv[0] = 0;
  Object call4736 = callmethod(call4735, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4733);
// compiled call node returning call4736 (depth = 5)
// compiled member node returning call4736 (depth = 4)
  adddatum2(obj4250, call4736, 6);
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
  sourceObject = obj4250;
objclass4250 = obj4250->class;
  objclass4250->definitionModule = modulename;
  objclass4250->definitionLine = 937;
  (*(struct UserObject *)self).data[0] = lowerouter4250;
  self = oldself4250;
  selfslot = oldselfslot4250;
  stackframe = oldstackframe4250;
  gc_frame_end(frame);
  return obj4250;
}
Object meth_ast_classNode4738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "classNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_classNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for classNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for classNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_classNode (depth = 3)
  gc_frame_end(frame);
  return *var_classNode;
}
Object meth_ast_fullName4755(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fullName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fullName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for fullName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4757 == NULL) {
    strlit4757 = alloc_String("");
    gc_root(strlit4757);
  }
// compiled string node returning strlit4757 (depth = 5)
  int op_slot_right_4756 = gc_frame_newslot(strlit4757);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4760 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4761 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4762 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4761);
// compiled call node returning call4762 (depth = 9)
// compiled member node returning call4762 (depth = 8)
  partcv[0] = 0;
  Object call4763 = callmethod(call4762, "nameString",
    1, partcv, params);
  gc_frame_end(callframe4760);
// compiled call node returning call4763 (depth = 7)
// compiled member node returning call4763 (depth = 6)
  int op_slot_right_4759 = gc_frame_newslot(call4763);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4766 == NULL) {
    strlit4766 = alloc_String(".");
    gc_root(strlit4766);
  }
// compiled string node returning strlit4766 (depth = 7)
  int op_slot_right_4765 = gc_frame_newslot(strlit4766);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4769 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4770 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4769);
// compiled call node returning call4770 (depth = 9)
// compiled member node returning call4770 (depth = 8)
  int op_slot_right_4768 = gc_frame_newslot(call4770);
// starting to compile string node (depth = 8)
  if (strlit4772 == NULL) {
    strlit4772 = alloc_String("");
    gc_root(strlit4772);
  }
// compiled string node returning strlit4772 (depth = 8)
  int op_slot_left_4768 = gc_frame_newslot(strlit4772);
  params[0] = call4770;
  partcv[0] = 1;
  Object opresult4773 = callmethod(strlit4772, "++", 1, partcv, params);
// compiled op node returning opresult4773 (depth = 7)
  int op_slot_left_4765 = gc_frame_newslot(opresult4773);
  params[0] = strlit4766;
  partcv[0] = 1;
  Object opresult4774 = callmethod(opresult4773, "++", 1, partcv, params);
// compiled op node returning opresult4774 (depth = 6)
  int op_slot_left_4759 = gc_frame_newslot(opresult4774);
  params[0] = call4763;
  partcv[0] = 1;
  Object opresult4775 = callmethod(opresult4774, "++", 1, partcv, params);
// compiled op node returning opresult4775 (depth = 5)
  int op_slot_left_4756 = gc_frame_newslot(opresult4775);
  params[0] = strlit4757;
  partcv[0] = 1;
  Object opresult4776 = callmethod(opresult4775, "++", 1, partcv, params);
// compiled op node returning opresult4776 (depth = 4)
  gc_frame_end(frame);
  return opresult4776;
}
Object meth_ast_declarationKind4777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit4778 == NULL) {
    strlit4778 = alloc_String("method");
    gc_root(strlit4778);
  }
// compiled string node returning strlit4778 (depth = 4)
  gc_frame_end(frame);
  return strlit4778;
}
Object meth_ast_definesObject4779(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4780 = alloc_Boolean(1);
// compiled identifier node returning bool4780 (depth = 4)
  gc_frame_end(frame);
  return bool4780;
}
Object meth_ast_isClass4781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isClass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4782 = alloc_Boolean(1);
// compiled identifier node returning bool4782 (depth = 4)
  gc_frame_end(frame);
  return bool4782;
}
Object meth_ast_isPublic4783(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4786 = alloc_Float64(0);
// compiled num node returning num4786 (depth = 6)
  int op_slot_right_4785 = gc_frame_newslot(num4786);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4788 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4789 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4790 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4789);
// compiled call node returning call4790 (depth = 9)
// compiled member node returning call4790 (depth = 8)
  partcv[0] = 0;
  Object call4791 = callmethod(call4790, "size",
    1, partcv, params);
  gc_frame_end(callframe4788);
// compiled call node returning call4791 (depth = 7)
// compiled member node returning call4791 (depth = 6)
  int op_slot_left_4785 = gc_frame_newslot(call4791);
  params[0] = num4786;
  partcv[0] = 1;
  Object opresult4792 = callmethod(call4791, "==", 1, partcv, params);
// compiled op node returning opresult4792 (depth = 5)
  Object if4784 = done;
  if (istrue(opresult4792)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4793 = alloc_Boolean(1);
// compiled identifier node returning bool4793 (depth = 6)
  return bool4793;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4784 = undefined;
  } else {
  }
// compiled if node returning if4784 (depth = 4)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4794 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4795 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// starting to compile string node (depth = 7)
  if (strlit4796 == NULL) {
    strlit4796 = alloc_String("confidential");
    gc_root(strlit4796);
  }
// compiled string node returning strlit4796 (depth = 7)
  gc_frame_newslot(strlit4796);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4797 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4798 = gc_frame_new();
// call case 3: self.outer request
  Object call4799 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4798);
// compiled call node returning call4799 (depth = 10)
// compiled member node returning call4799 (depth = 9)
  partcv[0] = 0;
  Object call4800 = callmethodflags(call4799, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4797);
// compiled call node returning call4800 (depth = 8)
// compiled member node returning call4800 (depth = 7)
  params[0] = self;
  params[1] = strlit4796;
  partcv[0] = 2;
  Object call4801 = callmethodflags(call4800, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4795);
// compiled call node returning call4801 (depth = 6)
  partcv[0] = 0;
  Object call4802 = callmethod(call4801, "not",
    1, partcv, params);
  gc_frame_end(callframe4794);
// compiled call node returning call4802 (depth = 5)
// compiled member node returning call4802 (depth = 4)
  gc_frame_end(frame);
  return call4802;
}
Object meth_ast_isWritable4803(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool4804 = alloc_Boolean(0);
// compiled identifier node returning bool4804 (depth = 4)
  gc_frame_end(frame);
  return bool4804;
}
Object meth_ast_isReadable4805(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4807 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4806);
// compiled call node returning call4807 (depth = 5)
// compiled member node returning call4807 (depth = 4)
  gc_frame_end(frame);
  return call4807;
}
Object meth_ast_usesAsType4808(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4810 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4811 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4810);
// compiled call node returning call4811 (depth = 6)
// compiled member node returning call4811 (depth = 5)
  int op_slot_right_4809 = gc_frame_newslot(call4811);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_4809 = gc_frame_newslot(*var_aNode);
  params[0] = call4811;
  partcv[0] = 1;
  Object opresult4813 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult4813 (depth = 4)
  gc_frame_end(frame);
  return opresult4813;
}
Object meth_ast__apply4820(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4821 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_b (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4822 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe4821);
// compiled call node returning call4822 (depth = 8)
  gc_frame_end(frame);
  return call4822;
}
Object meth_ast__apply4817(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4818 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4819 = alloc_Block(NULL, NULL, "ast", 1110);
  gc_frame_newslot(block4819);
// method _apply
  block_savedest(block4819);
  Object closure4820 = createclosure(2, "_apply");
  setclosureframe(closure4820, stackframe);
  addtoclosure(closure4820, var_b);
  addtoclosure(closure4820, selfslot);
  struct UserObject *uo4820 = (struct UserObject*)block4819;
  uo4820->data[0] = (Object)closure4820;
  Method *meth_meth_ast__apply4820 = addmethod2pos(block4819, "_apply", &meth_ast__apply4820, 0);
  int argcv_meth_ast__apply4820[] = {1};
  meth_meth_ast__apply4820->type = alloc_MethodType(1, argcv_meth_ast__apply4820);
  meth_meth_ast__apply4820->definitionModule = modulename;
  meth_meth_ast__apply4820->definitionLine = 1106;
// compiled block node returning block4819 (depth = 7)
  gc_frame_newslot(block4819);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call4825 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4824);
// compiled call node returning call4825 (depth = 8)
// compiled member node returning call4825 (depth = 7)
  params[0] = block4819;
  partcv[0] = 1;
  Object call4826 = callmethod(call4825, "do",
    1, partcv, params);
  gc_frame_end(callframe4818);
// compiled call node returning call4826 (depth = 6)
  gc_frame_end(frame);
  return call4826;
}
Object meth_ast_parametersDo4814(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "parametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4815 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4816 = alloc_Block(NULL, NULL, "ast", 1109);
  gc_frame_newslot(block4816);
// method _apply
  block_savedest(block4816);
  Object closure4817 = createclosure(2, "_apply");
  setclosureframe(closure4817, stackframe);
  addtoclosure(closure4817, var_b);
  addtoclosure(closure4817, selfslot);
  struct UserObject *uo4817 = (struct UserObject*)block4816;
  uo4817->data[0] = (Object)closure4817;
  Method *meth_meth_ast__apply4817 = addmethod2pos(block4816, "_apply", &meth_ast__apply4817, 0);
  int argcv_meth_ast__apply4817[] = {1};
  meth_meth_ast__apply4817->type = alloc_MethodType(1, argcv_meth_ast__apply4817);
  meth_meth_ast__apply4817->definitionModule = modulename;
  meth_meth_ast__apply4817->definitionLine = 1106;
// compiled block node returning block4816 (depth = 5)
  gc_frame_newslot(block4816);
// call case 6: other member request
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4828 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4829 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4828);
// compiled call node returning call4829 (depth = 6)
// compiled member node returning call4829 (depth = 5)
  params[0] = block4816;
  partcv[0] = 1;
  Object call4830 = callmethod(call4829, "do",
    1, partcv, params);
  gc_frame_end(callframe4815);
// compiled call node returning call4830 (depth = 4)
  gc_frame_end(frame);
  return call4830;
}
Object meth_ast__apply4841(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_b = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4842 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_b (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4843 = callmethod(*var_b, "apply",
    1, partcv, params);
  gc_frame_end(callframe4842);
// compiled call node returning call4843 (depth = 7)
  gc_frame_end(frame);
  return call4843;
}
Object meth_ast_typeParametersDo4831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "typeParametersDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method typeParametersDo");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeParametersDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for typeParametersDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4834 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4835 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4834);
// compiled call node returning call4835 (depth = 7)
// compiled member node returning call4835 (depth = 6)
  int op_slot_right_4833 = gc_frame_newslot(call4835);
// starting to compile identifier node (depth = 6)
  Object bool4837 = alloc_Boolean(0);
// compiled identifier node returning bool4837 (depth = 6)
  int op_slot_left_4833 = gc_frame_newslot(bool4837);
  params[0] = call4835;
  partcv[0] = 1;
  Object opresult4838 = callmethod(bool4837, "!=", 1, partcv, params);
// compiled op node returning opresult4838 (depth = 5)
  Object if4832 = done;
  if (istrue(opresult4838)) {
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4839 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4840 = alloc_Block(NULL, NULL, "ast", 1115);
  gc_frame_newslot(block4840);
// method _apply
  block_savedest(block4840);
  Object closure4841 = createclosure(2, "_apply");
  setclosureframe(closure4841, stackframe);
  addtoclosure(closure4841, var_b);
  addtoclosure(closure4841, selfslot);
  struct UserObject *uo4841 = (struct UserObject*)block4840;
  uo4841->data[0] = (Object)closure4841;
  Method *meth_meth_ast__apply4841 = addmethod2pos(block4840, "_apply", &meth_ast__apply4841, 0);
  int argcv_meth_ast__apply4841[] = {1};
  meth_meth_ast__apply4841->type = alloc_MethodType(1, argcv_meth_ast__apply4841);
  meth_meth_ast__apply4841->definitionModule = modulename;
  meth_meth_ast__apply4841->definitionLine = 1114;
// compiled block node returning block4840 (depth = 6)
  gc_frame_newslot(block4840);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4845 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4846 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4845);
// compiled call node returning call4846 (depth = 7)
// compiled member node returning call4846 (depth = 6)
  params[0] = block4840;
  partcv[0] = 1;
  Object call4847 = callmethod(call4846, "do",
    1, partcv, params);
  gc_frame_end(callframe4839);
// compiled call node returning call4847 (depth = 5)
    gc_frame_newslot(call4847);
    if4832 = call4847;
  } else {
  }
// compiled if node returning if4832 (depth = 4)
  gc_frame_end(frame);
  return if4832;
}
Object meth_ast__apply4875(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_partNode = &(stackframe->slots[0]);
  *var_partNode = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4876 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_partNode (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4877 = callmethod(*var_partNode, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4876);
// compiled call node returning call4877 (depth = 7)
  gc_frame_end(frame);
  return call4877;
}
Object meth_ast__apply4884(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4885 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4886 = callmethod(*var_each, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4885);
// compiled call node returning call4886 (depth = 7)
  gc_frame_end(frame);
  return call4886;
}
Object meth_ast_accept_40__41_from4848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4850 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4851 = callmethod(*var_visitor, "visitClass()up",
    2, partcv, params);
  gc_frame_end(callframe4850);
// compiled call node returning call4851 (depth = 5)
  Object if4849 = done;
  if (istrue(call4851)) {
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4852 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4854 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4853);
// compiled call node returning call4854 (depth = 7)
// compiled member node returning call4854 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4855 = callmethod(call4854, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4852);
// compiled call node returning call4855 (depth = 5)
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4856 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4857 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4858 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4857);
// compiled call node returning call4858 (depth = 7)
// compiled member node returning call4858 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4859 = callmethod(call4858, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4856);
// compiled call node returning call4859 (depth = 5)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool4862 = alloc_Boolean(0);
// compiled identifier node returning bool4862 (depth = 7)
  int op_slot_right_4861 = gc_frame_newslot(bool4862);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4864 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4865 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4864);
// compiled call node returning call4865 (depth = 8)
// compiled member node returning call4865 (depth = 7)
  int op_slot_left_4861 = gc_frame_newslot(call4865);
  params[0] = bool4862;
  partcv[0] = 1;
  Object opresult4866 = callmethod(call4865, "!=", 1, partcv, params);
// compiled op node returning opresult4866 (depth = 6)
  Object if4860 = done;
  if (istrue(opresult4866)) {
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4867 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4869 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4868);
// compiled call node returning call4869 (depth = 8)
// compiled member node returning call4869 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4870 = callmethod(call4869, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe4867);
// compiled call node returning call4870 (depth = 6)
    gc_frame_newslot(call4870);
    if4860 = call4870;
  } else {
  }
// compiled if node returning if4860 (depth = 5)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4871 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4872 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4873 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4872);
// compiled call node returning call4873 (depth = 7)
// compiled member node returning call4873 (depth = 6)
  gc_frame_newslot(call4873);
// starting to compile block node (depth = 6)
  Object block4874 = alloc_Block(NULL, NULL, "ast", 1125);
  gc_frame_newslot(block4874);
// method _apply
  block_savedest(block4874);
  Object closure4875 = createclosure(2, "_apply");
  setclosureframe(closure4875, stackframe);
  addtoclosure(closure4875, var_visitor);
  addtoclosure(closure4875, selfslot);
  struct UserObject *uo4875 = (struct UserObject*)block4874;
  uo4875->data[0] = (Object)closure4875;
  Method *meth_meth_ast__apply4875 = addmethod2pos(block4874, "_apply", &meth_ast__apply4875, 0);
  int argcv_meth_ast__apply4875[] = {1};
  meth_meth_ast__apply4875->type = alloc_MethodType(1, argcv_meth_ast__apply4875);
  meth_meth_ast__apply4875->definitionModule = modulename;
  meth_meth_ast__apply4875->definitionLine = 1125;
// compiled block node returning block4874 (depth = 6)
  gc_frame_newslot(block4874);
// call case 5: prelude request
  params[0] = call4873;
  params[1] = block4874;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4879 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4871);
// compiled call node returning call4879 (depth = 5)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4880 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4881 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4882 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4881);
// compiled call node returning call4882 (depth = 7)
// compiled member node returning call4882 (depth = 6)
  gc_frame_newslot(call4882);
// starting to compile block node (depth = 6)
  Object block4883 = alloc_Block(NULL, NULL, "ast", 1128);
  gc_frame_newslot(block4883);
// method _apply
  block_savedest(block4883);
  Object closure4884 = createclosure(2, "_apply");
  setclosureframe(closure4884, stackframe);
  addtoclosure(closure4884, var_visitor);
  addtoclosure(closure4884, selfslot);
  struct UserObject *uo4884 = (struct UserObject*)block4883;
  uo4884->data[0] = (Object)closure4884;
  Method *meth_meth_ast__apply4884 = addmethod2pos(block4883, "_apply", &meth_ast__apply4884, 0);
  int argcv_meth_ast__apply4884[] = {1};
  meth_meth_ast__apply4884->type = alloc_MethodType(1, argcv_meth_ast__apply4884);
  meth_meth_ast__apply4884->definitionModule = modulename;
  meth_meth_ast__apply4884->definitionLine = 1128;
// compiled block node returning block4883 (depth = 6)
  gc_frame_newslot(block4883);
// call case 5: prelude request
  params[0] = call4882;
  params[1] = block4883;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4888 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4880);
// compiled call node returning call4888 (depth = 5)
    gc_frame_newslot(call4888);
    if4849 = call4888;
  } else {
  }
// compiled if node returning if4849 (depth = 4)
  gc_frame_end(frame);
  return if4849;
}
Object meth_ast_map_40__41_parent4889(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4890 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call4891 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4890);
// compiled call node returning call4891 (depth = 5)
  *var_n = call4891;
  if (call4891 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4892 = gc_frame_new();
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4893 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4895 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4894);
// compiled call node returning call4895 (depth = 8)
// compiled member node returning call4895 (depth = 7)
  gc_frame_newslot(call4895);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4896 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4897 = gc_frame_new();
// call case 3: self.outer request
  Object call4898 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4897);
// compiled call node returning call4898 (depth = 10)
// compiled member node returning call4898 (depth = 9)
  partcv[0] = 0;
  Object call4899 = callmethodflags(call4898, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4896);
// compiled call node returning call4899 (depth = 8)
// compiled member node returning call4899 (depth = 7)
  params[0] = call4895;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4900 = callmethodflags(call4899, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4893);
// compiled call node returning call4900 (depth = 6)
  gc_frame_newslot(call4900);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4900;
  partcv[0] = 1;
  Object call4901 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe4892);
// compiled call node returning call4901 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4902 = gc_frame_new();
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4903 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4904 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4905 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4904);
// compiled call node returning call4905 (depth = 8)
// compiled member node returning call4905 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4906 = callmethod(call4905, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe4903);
// compiled call node returning call4906 (depth = 6)
  gc_frame_newslot(call4906);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4906;
  partcv[0] = 1;
  Object call4907 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe4902);
// compiled call node returning call4907 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4908 = gc_frame_new();
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4909 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4911 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4910);
// compiled call node returning call4911 (depth = 8)
// compiled member node returning call4911 (depth = 7)
  gc_frame_newslot(call4911);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4912 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4913 = gc_frame_new();
// call case 3: self.outer request
  Object call4914 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4913);
// compiled call node returning call4914 (depth = 10)
// compiled member node returning call4914 (depth = 9)
  partcv[0] = 0;
  Object call4915 = callmethodflags(call4914, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4912);
// compiled call node returning call4915 (depth = 8)
// compiled member node returning call4915 (depth = 7)
  params[0] = call4911;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4916 = callmethodflags(call4915, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4909);
// compiled call node returning call4916 (depth = 6)
  gc_frame_newslot(call4916);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4916;
  partcv[0] = 1;
  Object call4917 = callmethod(*var_n, "signature:=",
    1, partcv, params);
  gc_frame_end(callframe4908);
// compiled call node returning call4917 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4918 = gc_frame_new();
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4919 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4920 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4921 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4920);
// compiled call node returning call4921 (depth = 8)
// compiled member node returning call4921 (depth = 7)
  gc_frame_newslot(call4921);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4922 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4923 = gc_frame_new();
// call case 3: self.outer request
  Object call4924 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4923);
// compiled call node returning call4924 (depth = 10)
// compiled member node returning call4924 (depth = 9)
  partcv[0] = 0;
  Object call4925 = callmethodflags(call4924, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4922);
// compiled call node returning call4925 (depth = 8)
// compiled member node returning call4925 (depth = 7)
  params[0] = call4921;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4926 = callmethodflags(call4925, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4919);
// compiled call node returning call4926 (depth = 6)
  gc_frame_newslot(call4926);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4926;
  partcv[0] = 1;
  Object call4927 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe4918);
// compiled call node returning call4927 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4928 = gc_frame_new();
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4929 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4930 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4931 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4930);
// compiled call node returning call4931 (depth = 8)
// compiled member node returning call4931 (depth = 7)
  gc_frame_newslot(call4931);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4932 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4933 = gc_frame_new();
// call case 3: self.outer request
  Object call4934 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4933);
// compiled call node returning call4934 (depth = 10)
// compiled member node returning call4934 (depth = 9)
  partcv[0] = 0;
  Object call4935 = callmethodflags(call4934, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4932);
// compiled call node returning call4935 (depth = 8)
// compiled member node returning call4935 (depth = 7)
  params[0] = call4931;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4936 = callmethodflags(call4935, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4929);
// compiled call node returning call4936 (depth = 6)
  gc_frame_newslot(call4936);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4936;
  partcv[0] = 1;
  Object call4937 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe4928);
// compiled call node returning call4937 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4938 = gc_frame_new();
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4939 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4940 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4941 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4940);
// compiled call node returning call4941 (depth = 8)
// compiled member node returning call4941 (depth = 7)
  gc_frame_newslot(call4941);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4942 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4943 = gc_frame_new();
// call case 3: self.outer request
  Object call4944 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4943);
// compiled call node returning call4944 (depth = 10)
// compiled member node returning call4944 (depth = 9)
  partcv[0] = 0;
  Object call4945 = callmethodflags(call4944, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4942);
// compiled call node returning call4945 (depth = 8)
// compiled member node returning call4945 (depth = 7)
  params[0] = call4941;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4946 = callmethodflags(call4945, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4939);
// compiled call node returning call4946 (depth = 6)
  gc_frame_newslot(call4946);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4946;
  partcv[0] = 1;
  Object call4947 = callmethod(*var_n, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe4938);
// compiled call node returning call4947 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4948 = gc_frame_new();
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4949 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4950 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4951 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4950);
// compiled call node returning call4951 (depth = 8)
// compiled member node returning call4951 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4952 = callmethod(call4951, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe4949);
// compiled call node returning call4952 (depth = 6)
  gc_frame_newslot(call4952);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4952;
  partcv[0] = 1;
  Object call4953 = callmethod(*var_n, "constructor:=",
    1, partcv, params);
  gc_frame_end(callframe4948);
// compiled call node returning call4953 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4954 = gc_frame_new();
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4955 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4956 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4957 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4956);
// compiled call node returning call4957 (depth = 8)
// compiled member node returning call4957 (depth = 7)
  gc_frame_newslot(call4957);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4958 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4959 = gc_frame_new();
// call case 3: self.outer request
  Object call4960 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4959);
// compiled call node returning call4960 (depth = 10)
// compiled member node returning call4960 (depth = 9)
  partcv[0] = 0;
  Object call4961 = callmethodflags(call4960, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4958);
// compiled call node returning call4961 (depth = 8)
// compiled member node returning call4961 (depth = 7)
  params[0] = call4957;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call4962 = callmethodflags(call4961, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4955);
// compiled call node returning call4962 (depth = 6)
  gc_frame_newslot(call4962);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call4962;
  partcv[0] = 1;
  Object call4963 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe4954);
// compiled call node returning call4963 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4964 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4965 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4964);
// compiled call node returning call4965 (depth = 5)
  *var_n = call4965;
  if (call4965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply4975(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit4977 == NULL) {
    strlit4977 = alloc_String("  ");
    gc_root(strlit4977);
  }
// compiled string node returning strlit4977 (depth = 8)
  int op_slot_right_4976 = gc_frame_newslot(strlit4977);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_4976 = gc_frame_newslot(*var_spc);
  params[0] = strlit4977;
  partcv[0] = 1;
  Object opresult4979 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult4979 (depth = 7)
  *var_spc = opresult4979;
  if (opresult4979 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5286(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5288 == NULL) {
    strlit5288 = alloc_String("");
    gc_root(strlit5288);
  }
// compiled string node returning strlit5288 (depth = 10)
  int op_slot_right_5287 = gc_frame_newslot(strlit5288);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5291 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num5293 = alloc_Float64(4);
// compiled num node returning num5293 (depth = 13)
  int op_slot_right_5292 = gc_frame_newslot(num5293);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_5292 = gc_frame_newslot(*var_depth);
  params[0] = num5293;
  partcv[0] = 1;
  Object sum5295 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5295 (depth = 12)
  gc_frame_newslot(sum5295);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = sum5295;
  partcv[0] = 1;
  Object call5296 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5291);
// compiled call node returning call5296 (depth = 11)
  int op_slot_right_5290 = gc_frame_newslot(call5296);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5299 == NULL) {
    strlit5299 = alloc_String("");
    gc_root(strlit5299);
  }
// compiled string node returning strlit5299 (depth = 12)
  int op_slot_right_5298 = gc_frame_newslot(strlit5299);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5301 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit5304 == NULL) {
    strlit5304 = alloc_String("""\x0a""      ");
    gc_root(strlit5304);
  }
// compiled string node returning strlit5304 (depth = 14)
  int op_slot_right_5303 = gc_frame_newslot(strlit5304);
// starting to compile op node (depth = 14)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_s (depth = 15)
  int op_slot_right_5306 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 15)
  if (strlit5308 == NULL) {
    strlit5308 = alloc_String("");
    gc_root(strlit5308);
  }
// compiled string node returning strlit5308 (depth = 15)
  int op_slot_left_5306 = gc_frame_newslot(strlit5308);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5309 = callmethod(strlit5308, "++", 1, partcv, params);
// compiled op node returning opresult5309 (depth = 14)
  int op_slot_left_5303 = gc_frame_newslot(opresult5309);
  params[0] = strlit5304;
  partcv[0] = 1;
  Object opresult5310 = callmethod(opresult5309, "++", 1, partcv, params);
// compiled op node returning opresult5310 (depth = 13)
  int op_slot_left_5301 = gc_frame_newslot(opresult5310);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5311 = callmethod(opresult5310, "++", 1, partcv, params);
// compiled op node returning opresult5311 (depth = 12)
  int op_slot_left_5298 = gc_frame_newslot(opresult5311);
  params[0] = strlit5299;
  partcv[0] = 1;
  Object opresult5312 = callmethod(opresult5311, "++", 1, partcv, params);
// compiled op node returning opresult5312 (depth = 11)
  int op_slot_left_5290 = gc_frame_newslot(opresult5312);
  params[0] = call5296;
  partcv[0] = 1;
  Object opresult5313 = callmethod(opresult5312, "++", 1, partcv, params);
// compiled op node returning opresult5313 (depth = 10)
  int op_slot_left_5287 = gc_frame_newslot(opresult5313);
  params[0] = strlit5288;
  partcv[0] = 1;
  Object opresult5314 = callmethod(opresult5313, "++", 1, partcv, params);
// compiled op node returning opresult5314 (depth = 9)
  *var_s = opresult5314;
  if (opresult5314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5240(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5242 == NULL) {
    strlit5242 = alloc_String("");
    gc_root(strlit5242);
  }
// compiled string node returning strlit5242 (depth = 8)
  int op_slot_right_5241 = gc_frame_newslot(strlit5242);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5246 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe5245);
// compiled call node returning call5246 (depth = 10)
// compiled member node returning call5246 (depth = 9)
  int op_slot_right_5244 = gc_frame_newslot(call5246);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5249 == NULL) {
    strlit5249 = alloc_String("Part: ");
    gc_root(strlit5249);
  }
// compiled string node returning strlit5249 (depth = 10)
  int op_slot_right_5248 = gc_frame_newslot(strlit5249);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_5251 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5254 == NULL) {
    strlit5254 = alloc_String("""\x0a""  ");
    gc_root(strlit5254);
  }
// compiled string node returning strlit5254 (depth = 12)
  int op_slot_right_5253 = gc_frame_newslot(strlit5254);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_5256 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit5258 == NULL) {
    strlit5258 = alloc_String("");
    gc_root(strlit5258);
  }
// compiled string node returning strlit5258 (depth = 13)
  int op_slot_left_5256 = gc_frame_newslot(strlit5258);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5259 = callmethod(strlit5258, "++", 1, partcv, params);
// compiled op node returning opresult5259 (depth = 12)
  int op_slot_left_5253 = gc_frame_newslot(opresult5259);
  params[0] = strlit5254;
  partcv[0] = 1;
  Object opresult5260 = callmethod(opresult5259, "++", 1, partcv, params);
// compiled op node returning opresult5260 (depth = 11)
  int op_slot_left_5251 = gc_frame_newslot(opresult5260);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5261 = callmethod(opresult5260, "++", 1, partcv, params);
// compiled op node returning opresult5261 (depth = 10)
  int op_slot_left_5248 = gc_frame_newslot(opresult5261);
  params[0] = strlit5249;
  partcv[0] = 1;
  Object opresult5262 = callmethod(opresult5261, "++", 1, partcv, params);
// compiled op node returning opresult5262 (depth = 9)
  int op_slot_left_5244 = gc_frame_newslot(opresult5262);
  params[0] = call5246;
  partcv[0] = 1;
  Object opresult5263 = callmethod(opresult5262, "++", 1, partcv, params);
// compiled op node returning opresult5263 (depth = 8)
  int op_slot_left_5241 = gc_frame_newslot(opresult5263);
  params[0] = strlit5242;
  partcv[0] = 1;
  Object opresult5264 = callmethod(opresult5263, "++", 1, partcv, params);
// compiled op node returning opresult5264 (depth = 7)
  *var_s = opresult5264;
  if (opresult5264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5267 == NULL) {
    strlit5267 = alloc_String("Parameters:");
    gc_root(strlit5267);
  }
// compiled string node returning strlit5267 (depth = 8)
  int op_slot_right_5266 = gc_frame_newslot(strlit5267);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5269 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String("""\x0a""    ");
    gc_root(strlit5272);
  }
// compiled string node returning strlit5272 (depth = 10)
  int op_slot_right_5271 = gc_frame_newslot(strlit5272);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_5274 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit5276 == NULL) {
    strlit5276 = alloc_String("");
    gc_root(strlit5276);
  }
// compiled string node returning strlit5276 (depth = 11)
  int op_slot_left_5274 = gc_frame_newslot(strlit5276);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5277 = callmethod(strlit5276, "++", 1, partcv, params);
// compiled op node returning opresult5277 (depth = 10)
  int op_slot_left_5271 = gc_frame_newslot(opresult5277);
  params[0] = strlit5272;
  partcv[0] = 1;
  Object opresult5278 = callmethod(opresult5277, "++", 1, partcv, params);
// compiled op node returning opresult5278 (depth = 9)
  int op_slot_left_5269 = gc_frame_newslot(opresult5278);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5279 = callmethod(opresult5278, "++", 1, partcv, params);
// compiled op node returning opresult5279 (depth = 8)
  int op_slot_left_5266 = gc_frame_newslot(opresult5279);
  params[0] = strlit5267;
  partcv[0] = 1;
  Object opresult5280 = callmethod(opresult5279, "++", 1, partcv, params);
// compiled op node returning opresult5280 (depth = 7)
  *var_s = opresult5280;
  if (opresult5280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5282 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call5284 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5283);
// compiled call node returning call5284 (depth = 8)
// compiled member node returning call5284 (depth = 7)
  gc_frame_newslot(call5284);
// starting to compile block node (depth = 7)
  Object block5285 = alloc_Block(NULL, NULL, "ast", 1170);
  gc_frame_newslot(block5285);
// method _apply
  block_savedest(block5285);
  Object closure5286 = createclosure(4, "_apply");
  setclosureframe(closure5286, stackframe);
  addtoclosure(closure5286, var_depth);
  addtoclosure(closure5286, var_spc);
  addtoclosure(closure5286, var_s);
  addtoclosure(closure5286, selfslot);
  struct UserObject *uo5286 = (struct UserObject*)block5285;
  uo5286->data[0] = (Object)closure5286;
  Method *meth_meth_ast__apply5286 = addmethod2pos(block5285, "_apply", &meth_ast__apply5286, 0);
  int argcv_meth_ast__apply5286[] = {1};
  meth_meth_ast__apply5286->type = alloc_MethodType(1, argcv_meth_ast__apply5286);
  meth_meth_ast__apply5286->definitionModule = modulename;
  meth_meth_ast__apply5286->definitionLine = 1170;
// compiled block node returning block5285 (depth = 7)
  gc_frame_newslot(block5285);
// call case 5: prelude request
  params[0] = call5284;
  params[1] = block5285;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5317 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5282);
// compiled call node returning call5317 (depth = 6)
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool5320 = alloc_Boolean(0);
// compiled identifier node returning bool5320 (depth = 8)
  int op_slot_right_5319 = gc_frame_newslot(bool5320);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5322 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call5323 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5322);
// compiled call node returning call5323 (depth = 9)
// compiled member node returning call5323 (depth = 8)
  int op_slot_left_5319 = gc_frame_newslot(call5323);
  params[0] = bool5320;
  partcv[0] = 1;
  Object opresult5324 = callmethod(call5323, "!=", 1, partcv, params);
// compiled op node returning opresult5324 (depth = 7)
  Object if5318 = done;
  if (istrue(opresult5324)) {
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5326 == NULL) {
    strlit5326 = alloc_String("");
    gc_root(strlit5326);
  }
// compiled string node returning strlit5326 (depth = 9)
  int op_slot_right_5325 = gc_frame_newslot(strlit5326);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5329 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num5331 = alloc_Float64(3);
// compiled num node returning num5331 (depth = 12)
  int op_slot_right_5330 = gc_frame_newslot(num5331);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_depth (depth = 12)
  int op_slot_left_5330 = gc_frame_newslot(*var_depth);
  params[0] = num5331;
  partcv[0] = 1;
  Object sum5333 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5333 (depth = 11)
  gc_frame_newslot(sum5333);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5334 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call5335 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5334);
// compiled call node returning call5335 (depth = 12)
// compiled member node returning call5335 (depth = 11)
  params[0] = sum5333;
  partcv[0] = 1;
  Object call5336 = callmethod(call5335, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5329);
// compiled call node returning call5336 (depth = 10)
  int op_slot_right_5328 = gc_frame_newslot(call5336);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5339 == NULL) {
    strlit5339 = alloc_String("Vararg: ");
    gc_root(strlit5339);
  }
// compiled string node returning strlit5339 (depth = 11)
  int op_slot_right_5338 = gc_frame_newslot(strlit5339);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_5341 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit5344 == NULL) {
    strlit5344 = alloc_String("""\x0a""    ");
    gc_root(strlit5344);
  }
// compiled string node returning strlit5344 (depth = 13)
  int op_slot_right_5343 = gc_frame_newslot(strlit5344);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_5346 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit5348 == NULL) {
    strlit5348 = alloc_String("");
    gc_root(strlit5348);
  }
// compiled string node returning strlit5348 (depth = 14)
  int op_slot_left_5346 = gc_frame_newslot(strlit5348);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5349 = callmethod(strlit5348, "++", 1, partcv, params);
// compiled op node returning opresult5349 (depth = 13)
  int op_slot_left_5343 = gc_frame_newslot(opresult5349);
  params[0] = strlit5344;
  partcv[0] = 1;
  Object opresult5350 = callmethod(opresult5349, "++", 1, partcv, params);
// compiled op node returning opresult5350 (depth = 12)
  int op_slot_left_5341 = gc_frame_newslot(opresult5350);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5351 = callmethod(opresult5350, "++", 1, partcv, params);
// compiled op node returning opresult5351 (depth = 11)
  int op_slot_left_5338 = gc_frame_newslot(opresult5351);
  params[0] = strlit5339;
  partcv[0] = 1;
  Object opresult5352 = callmethod(opresult5351, "++", 1, partcv, params);
// compiled op node returning opresult5352 (depth = 10)
  int op_slot_left_5328 = gc_frame_newslot(opresult5352);
  params[0] = call5336;
  partcv[0] = 1;
  Object opresult5353 = callmethod(opresult5352, "++", 1, partcv, params);
// compiled op node returning opresult5353 (depth = 9)
  int op_slot_left_5325 = gc_frame_newslot(opresult5353);
  params[0] = strlit5326;
  partcv[0] = 1;
  Object opresult5354 = callmethod(opresult5353, "++", 1, partcv, params);
// compiled op node returning opresult5354 (depth = 8)
  *var_s = opresult5354;
  if (opresult5354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if5318 = done;
  } else {
  }
// compiled if node returning if5318 (depth = 6)
  gc_frame_end(frame);
  return if5318;
}
Object meth_ast__apply5381(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5384 == NULL) {
    strlit5384 = alloc_String("");
    gc_root(strlit5384);
  }
// compiled string node returning strlit5384 (depth = 10)
  int op_slot_right_5383 = gc_frame_newslot(strlit5384);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5387 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num5388 = alloc_Float64(0);
// compiled num node returning num5388 (depth = 12)
  gc_frame_newslot(num5388);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_g (depth = 12)
  params[0] = num5388;
  partcv[0] = 1;
  Object call5389 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5387);
// compiled call node returning call5389 (depth = 11)
  int op_slot_right_5386 = gc_frame_newslot(call5389);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5392 == NULL) {
    strlit5392 = alloc_String("");
    gc_root(strlit5392);
  }
// compiled string node returning strlit5392 (depth = 12)
  int op_slot_right_5391 = gc_frame_newslot(strlit5392);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5394 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5396 == NULL) {
    strlit5396 = alloc_String("""\x0a""  ");
    gc_root(strlit5396);
  }
// compiled string node returning strlit5396 (depth = 13)
  int op_slot_left_5394 = gc_frame_newslot(strlit5396);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5397 = callmethod(strlit5396, "++", 1, partcv, params);
// compiled op node returning opresult5397 (depth = 12)
  int op_slot_left_5391 = gc_frame_newslot(opresult5397);
  params[0] = strlit5392;
  partcv[0] = 1;
  Object opresult5398 = callmethod(opresult5397, "++", 1, partcv, params);
// compiled op node returning opresult5398 (depth = 11)
  int op_slot_left_5386 = gc_frame_newslot(opresult5398);
  params[0] = call5389;
  partcv[0] = 1;
  Object opresult5399 = callmethod(opresult5398, "++", 1, partcv, params);
// compiled op node returning opresult5399 (depth = 10)
  int op_slot_left_5383 = gc_frame_newslot(opresult5399);
  params[0] = strlit5384;
  partcv[0] = 1;
  Object opresult5400 = callmethod(opresult5399, "++", 1, partcv, params);
// compiled op node returning opresult5400 (depth = 9)
  int op_slot_right_5382 = gc_frame_newslot(opresult5400);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5382 = gc_frame_newslot(*var_s);
  params[0] = opresult5400;
  partcv[0] = 1;
  Object opresult5402 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5402 (depth = 8)
  *var_s = opresult5402;
  if (opresult5402 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5431(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5434 == NULL) {
    strlit5434 = alloc_String("");
    gc_root(strlit5434);
  }
// compiled string node returning strlit5434 (depth = 10)
  int op_slot_right_5433 = gc_frame_newslot(strlit5434);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5437 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num5439 = alloc_Float64(2);
// compiled num node returning num5439 (depth = 13)
  int op_slot_right_5438 = gc_frame_newslot(num5439);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_depth (depth = 13)
  int op_slot_left_5438 = gc_frame_newslot(*var_depth);
  params[0] = num5439;
  partcv[0] = 1;
  Object sum5441 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5441 (depth = 12)
  gc_frame_newslot(sum5441);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  params[0] = sum5441;
  partcv[0] = 1;
  Object call5442 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5437);
// compiled call node returning call5442 (depth = 11)
  int op_slot_right_5436 = gc_frame_newslot(call5442);
// starting to compile string node (depth = 11)
  if (strlit5444 == NULL) {
    strlit5444 = alloc_String(" ");
    gc_root(strlit5444);
  }
// compiled string node returning strlit5444 (depth = 11)
  int op_slot_left_5436 = gc_frame_newslot(strlit5444);
  params[0] = call5442;
  partcv[0] = 1;
  Object opresult5445 = callmethod(strlit5444, "++", 1, partcv, params);
// compiled op node returning opresult5445 (depth = 10)
  int op_slot_left_5433 = gc_frame_newslot(opresult5445);
  params[0] = strlit5434;
  partcv[0] = 1;
  Object opresult5446 = callmethod(opresult5445, "++", 1, partcv, params);
// compiled op node returning opresult5446 (depth = 9)
  int op_slot_right_5432 = gc_frame_newslot(opresult5446);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5432 = gc_frame_newslot(*var_s);
  params[0] = opresult5446;
  partcv[0] = 1;
  Object opresult5448 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5448 (depth = 8)
  *var_s = opresult5448;
  if (opresult5448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5468(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5470 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5472 = alloc_Float64(2);
// compiled num node returning num5472 (depth = 10)
  int op_slot_right_5471 = gc_frame_newslot(num5472);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5471 = gc_frame_newslot(*var_depth);
  params[0] = num5472;
  partcv[0] = 1;
  Object sum5474 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5474 (depth = 9)
  gc_frame_newslot(sum5474);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  params[0] = sum5474;
  partcv[0] = 1;
  Object call5475 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5470);
// compiled call node returning call5475 (depth = 8)
  int op_slot_right_5469 = gc_frame_newslot(call5475);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5477 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5480 == NULL) {
    strlit5480 = alloc_String("""\x0a""  ");
    gc_root(strlit5480);
  }
// compiled string node returning strlit5480 (depth = 10)
  int op_slot_right_5479 = gc_frame_newslot(strlit5480);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5479 = gc_frame_newslot(*var_s);
  params[0] = strlit5480;
  partcv[0] = 1;
  Object opresult5482 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5482 (depth = 9)
  int op_slot_left_5477 = gc_frame_newslot(opresult5482);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5483 = callmethod(opresult5482, "++", 1, partcv, params);
// compiled op node returning opresult5483 (depth = 8)
  int op_slot_left_5469 = gc_frame_newslot(opresult5483);
  params[0] = call5475;
  partcv[0] = 1;
  Object opresult5484 = callmethod(opresult5483, "++", 1, partcv, params);
// compiled op node returning opresult5484 (depth = 7)
  *var_s = opresult5484;
  if (opresult5484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty4967(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4968 == NULL) {
    strlit4968 = alloc_String("");
    gc_root(strlit4968);
  }
// compiled string node returning strlit4968 (depth = 5)
  *var_spc = strlit4968;
  if (strlit4968 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4969 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_4970 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num4972 = alloc_Float64(0);
// compiled num node returning num4972 (depth = 6)
  int op_slot_left_4970 = gc_frame_newslot(num4972);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4973 = callmethod(num4972, "..", 1, partcv, params);
// compiled op node returning opresult4973 (depth = 5)
  gc_frame_newslot(opresult4973);
// starting to compile block node (depth = 5)
  Object block4974 = alloc_Block(NULL, NULL, "ast", 1148);
  gc_frame_newslot(block4974);
// method _apply
  block_savedest(block4974);
  Object closure4975 = createclosure(2, "_apply");
  setclosureframe(closure4975, stackframe);
  addtoclosure(closure4975, var_spc);
  addtoclosure(closure4975, selfslot);
  struct UserObject *uo4975 = (struct UserObject*)block4974;
  uo4975->data[0] = (Object)closure4975;
  Method *meth_meth_ast__apply4975 = addmethod2pos(block4974, "_apply", &meth_ast__apply4975, 0);
  int argcv_meth_ast__apply4975[] = {1};
  meth_meth_ast__apply4975->type = alloc_MethodType(1, argcv_meth_ast__apply4975);
  meth_meth_ast__apply4975->definitionModule = modulename;
  meth_meth_ast__apply4975->definitionLine = 1142;
// compiled block node returning block4974 (depth = 5)
  gc_frame_newslot(block4974);
// call case 5: prelude request
  params[0] = opresult4973;
  params[1] = block4974;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4982 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4969);
// compiled call node returning call4982 (depth = 4)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit4984 == NULL) {
    strlit4984 = alloc_String("""\x0a""");
    gc_root(strlit4984);
  }
// compiled string node returning strlit4984 (depth = 6)
  int op_slot_right_4983 = gc_frame_newslot(strlit4984);
// starting to compile call node (depth = 6)
  int callframe4986 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call4987 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4986);
// compiled call node returning call4987 (depth = 6)
  int op_slot_left_4983 = gc_frame_newslot(call4987);
  params[0] = strlit4984;
  partcv[0] = 1;
  Object opresult4988 = callmethod(call4987, "++", 1, partcv, params);
// compiled op node returning opresult4988 (depth = 5)
  *var_s = opresult4988;
  if (opresult4988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4990 == NULL) {
    strlit4990 = alloc_String("");
    gc_root(strlit4990);
  }
// compiled string node returning strlit4990 (depth = 6)
  int op_slot_right_4989 = gc_frame_newslot(strlit4990);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4993 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num4994 = alloc_Float64(0);
// compiled num node returning num4994 (depth = 8)
  gc_frame_newslot(num4994);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4995 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4996 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4995);
// compiled call node returning call4996 (depth = 9)
// compiled member node returning call4996 (depth = 8)
  params[0] = num4994;
  partcv[0] = 1;
  Object call4997 = callmethod(call4996, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4993);
// compiled call node returning call4997 (depth = 7)
  int op_slot_right_4992 = gc_frame_newslot(call4997);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5000 == NULL) {
    strlit5000 = alloc_String("Name: ");
    gc_root(strlit5000);
  }
// compiled string node returning strlit5000 (depth = 8)
  int op_slot_right_4999 = gc_frame_newslot(strlit5000);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5002 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5005 == NULL) {
    strlit5005 = alloc_String("");
    gc_root(strlit5005);
  }
// compiled string node returning strlit5005 (depth = 10)
  int op_slot_right_5004 = gc_frame_newslot(strlit5005);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_5007 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit5009 == NULL) {
    strlit5009 = alloc_String("");
    gc_root(strlit5009);
  }
// compiled string node returning strlit5009 (depth = 11)
  int op_slot_left_5007 = gc_frame_newslot(strlit5009);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5010 = callmethod(strlit5009, "++", 1, partcv, params);
// compiled op node returning opresult5010 (depth = 10)
  int op_slot_left_5004 = gc_frame_newslot(opresult5010);
  params[0] = strlit5005;
  partcv[0] = 1;
  Object opresult5011 = callmethod(opresult5010, "++", 1, partcv, params);
// compiled op node returning opresult5011 (depth = 9)
  int op_slot_left_5002 = gc_frame_newslot(opresult5011);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5012 = callmethod(opresult5011, "++", 1, partcv, params);
// compiled op node returning opresult5012 (depth = 8)
  int op_slot_left_4999 = gc_frame_newslot(opresult5012);
  params[0] = strlit5000;
  partcv[0] = 1;
  Object opresult5013 = callmethod(opresult5012, "++", 1, partcv, params);
// compiled op node returning opresult5013 (depth = 7)
  int op_slot_left_4992 = gc_frame_newslot(opresult5013);
  params[0] = call4997;
  partcv[0] = 1;
  Object opresult5014 = callmethod(opresult5013, "++", 1, partcv, params);
// compiled op node returning opresult5014 (depth = 6)
  int op_slot_left_4989 = gc_frame_newslot(opresult5014);
  params[0] = strlit4990;
  partcv[0] = 1;
  Object opresult5015 = callmethod(opresult5014, "++", 1, partcv, params);
// compiled op node returning opresult5015 (depth = 5)
  *var_s = opresult5015;
  if (opresult5015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5019 == NULL) {
    strlit5019 = alloc_String("symbols");
    gc_root(strlit5019);
  }
// compiled string node returning strlit5019 (depth = 6)
  int op_slot_right_5018 = gc_frame_newslot(strlit5019);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5021 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_util (depth = 8)
  partcv[0] = 0;
  Object call5022 = callmethod(*var_util, "target",
    1, partcv, params);
  gc_frame_end(callframe5021);
// compiled call node returning call5022 (depth = 7)
// compiled member node returning call5022 (depth = 6)
  int op_slot_left_5018 = gc_frame_newslot(call5022);
  params[0] = strlit5019;
  partcv[0] = 1;
  Object opresult5023 = callmethod(call5022, "==", 1, partcv, params);
// compiled op node returning opresult5023 (depth = 5)
  Object if5017 = done;
  if (istrue(opresult5023)) {
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5026 == NULL) {
    strlit5026 = alloc_String("");
    gc_root(strlit5026);
  }
// compiled string node returning strlit5026 (depth = 8)
  int op_slot_right_5025 = gc_frame_newslot(strlit5026);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5029 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5030 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5032 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5031);
// compiled call node returning call5032 (depth = 14)
// compiled member node returning call5032 (depth = 13)
  partcv[0] = 0;
  Object call5033 = callmethod(call5032, "parent",
    1, partcv, params);
  gc_frame_end(callframe5030);
// compiled call node returning call5033 (depth = 12)
// compiled member node returning call5033 (depth = 11)
  partcv[0] = 0;
  Object call5034 = callmethod(call5033, "keysAndValuesAsList",
    1, partcv, params);
  gc_frame_end(callframe5029);
// compiled call node returning call5034 (depth = 10)
// compiled member node returning call5034 (depth = 9)
  int op_slot_right_5028 = gc_frame_newslot(call5034);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5037 == NULL) {
    strlit5037 = alloc_String("): ");
    gc_root(strlit5037);
  }
// compiled string node returning strlit5037 (depth = 10)
  int op_slot_right_5036 = gc_frame_newslot(strlit5037);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5040 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5041 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5043 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5042);
// compiled call node returning call5043 (depth = 16)
// compiled member node returning call5043 (depth = 15)
  partcv[0] = 0;
  Object call5044 = callmethod(call5043, "parent",
    1, partcv, params);
  gc_frame_end(callframe5041);
// compiled call node returning call5044 (depth = 14)
// compiled member node returning call5044 (depth = 13)
  partcv[0] = 0;
  Object call5045 = callmethod(call5044, "variety",
    1, partcv, params);
  gc_frame_end(callframe5040);
// compiled call node returning call5045 (depth = 12)
// compiled member node returning call5045 (depth = 11)
  int op_slot_right_5039 = gc_frame_newslot(call5045);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5048 == NULL) {
    strlit5048 = alloc_String("Parent Symbols(");
    gc_root(strlit5048);
  }
// compiled string node returning strlit5048 (depth = 12)
  int op_slot_right_5047 = gc_frame_newslot(strlit5048);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5050 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5052 == NULL) {
    strlit5052 = alloc_String("""\x0a""");
    gc_root(strlit5052);
  }
// compiled string node returning strlit5052 (depth = 13)
  int op_slot_left_5050 = gc_frame_newslot(strlit5052);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5053 = callmethod(strlit5052, "++", 1, partcv, params);
// compiled op node returning opresult5053 (depth = 12)
  int op_slot_left_5047 = gc_frame_newslot(opresult5053);
  params[0] = strlit5048;
  partcv[0] = 1;
  Object opresult5054 = callmethod(opresult5053, "++", 1, partcv, params);
// compiled op node returning opresult5054 (depth = 11)
  int op_slot_left_5039 = gc_frame_newslot(opresult5054);
  params[0] = call5045;
  partcv[0] = 1;
  Object opresult5055 = callmethod(opresult5054, "++", 1, partcv, params);
// compiled op node returning opresult5055 (depth = 10)
  int op_slot_left_5036 = gc_frame_newslot(opresult5055);
  params[0] = strlit5037;
  partcv[0] = 1;
  Object opresult5056 = callmethod(opresult5055, "++", 1, partcv, params);
// compiled op node returning opresult5056 (depth = 9)
  int op_slot_left_5028 = gc_frame_newslot(opresult5056);
  params[0] = call5034;
  partcv[0] = 1;
  Object opresult5057 = callmethod(opresult5056, "++", 1, partcv, params);
// compiled op node returning opresult5057 (depth = 8)
  int op_slot_left_5025 = gc_frame_newslot(opresult5057);
  params[0] = strlit5026;
  partcv[0] = 1;
  Object opresult5058 = callmethod(opresult5057, "++", 1, partcv, params);
// compiled op node returning opresult5058 (depth = 7)
  int op_slot_right_5024 = gc_frame_newslot(opresult5058);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5024 = gc_frame_newslot(*var_s);
  params[0] = opresult5058;
  partcv[0] = 1;
  Object opresult5060 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5060 (depth = 6)
  *var_s = opresult5060;
  if (opresult5060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5064 == NULL) {
    strlit5064 = alloc_String("");
    gc_root(strlit5064);
  }
// compiled string node returning strlit5064 (depth = 8)
  int op_slot_right_5063 = gc_frame_newslot(strlit5064);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5067 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5068 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5069 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5070 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5071 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5070);
// compiled call node returning call5071 (depth = 16)
// compiled member node returning call5071 (depth = 15)
  partcv[0] = 0;
  Object call5072 = callmethod(call5071, "parent",
    1, partcv, params);
  gc_frame_end(callframe5069);
// compiled call node returning call5072 (depth = 14)
// compiled member node returning call5072 (depth = 13)
  partcv[0] = 0;
  Object call5073 = callmethod(call5072, "parent",
    1, partcv, params);
  gc_frame_end(callframe5068);
// compiled call node returning call5073 (depth = 12)
// compiled member node returning call5073 (depth = 11)
  partcv[0] = 0;
  Object call5074 = callmethod(call5073, "keysAndValuesAsList",
    1, partcv, params);
  gc_frame_end(callframe5067);
// compiled call node returning call5074 (depth = 10)
// compiled member node returning call5074 (depth = 9)
  int op_slot_right_5066 = gc_frame_newslot(call5074);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5077 == NULL) {
    strlit5077 = alloc_String("): ");
    gc_root(strlit5077);
  }
// compiled string node returning strlit5077 (depth = 10)
  int op_slot_right_5076 = gc_frame_newslot(strlit5077);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5080 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5081 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5082 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe5083 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5084 = callmethodflags(self, "symbolTable'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5083);
// compiled call node returning call5084 (depth = 18)
// compiled member node returning call5084 (depth = 17)
  partcv[0] = 0;
  Object call5085 = callmethod(call5084, "parent",
    1, partcv, params);
  gc_frame_end(callframe5082);
// compiled call node returning call5085 (depth = 16)
// compiled member node returning call5085 (depth = 15)
  partcv[0] = 0;
  Object call5086 = callmethod(call5085, "parent",
    1, partcv, params);
  gc_frame_end(callframe5081);
// compiled call node returning call5086 (depth = 14)
// compiled member node returning call5086 (depth = 13)
  partcv[0] = 0;
  Object call5087 = callmethod(call5086, "variety",
    1, partcv, params);
  gc_frame_end(callframe5080);
// compiled call node returning call5087 (depth = 12)
// compiled member node returning call5087 (depth = 11)
  int op_slot_right_5079 = gc_frame_newslot(call5087);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5090 == NULL) {
    strlit5090 = alloc_String("Parent^2 Symbols(");
    gc_root(strlit5090);
  }
// compiled string node returning strlit5090 (depth = 12)
  int op_slot_right_5089 = gc_frame_newslot(strlit5090);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_spc (depth = 13)
  int op_slot_right_5092 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 13)
  if (strlit5094 == NULL) {
    strlit5094 = alloc_String("""\x0a""");
    gc_root(strlit5094);
  }
// compiled string node returning strlit5094 (depth = 13)
  int op_slot_left_5092 = gc_frame_newslot(strlit5094);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5095 = callmethod(strlit5094, "++", 1, partcv, params);
// compiled op node returning opresult5095 (depth = 12)
  int op_slot_left_5089 = gc_frame_newslot(opresult5095);
  params[0] = strlit5090;
  partcv[0] = 1;
  Object opresult5096 = callmethod(opresult5095, "++", 1, partcv, params);
// compiled op node returning opresult5096 (depth = 11)
  int op_slot_left_5079 = gc_frame_newslot(opresult5096);
  params[0] = call5087;
  partcv[0] = 1;
  Object opresult5097 = callmethod(opresult5096, "++", 1, partcv, params);
// compiled op node returning opresult5097 (depth = 10)
  int op_slot_left_5076 = gc_frame_newslot(opresult5097);
  params[0] = strlit5077;
  partcv[0] = 1;
  Object opresult5098 = callmethod(opresult5097, "++", 1, partcv, params);
// compiled op node returning opresult5098 (depth = 9)
  int op_slot_left_5066 = gc_frame_newslot(opresult5098);
  params[0] = call5074;
  partcv[0] = 1;
  Object opresult5099 = callmethod(opresult5098, "++", 1, partcv, params);
// compiled op node returning opresult5099 (depth = 8)
  int op_slot_left_5063 = gc_frame_newslot(opresult5099);
  params[0] = strlit5064;
  partcv[0] = 1;
  Object opresult5100 = callmethod(opresult5099, "++", 1, partcv, params);
// compiled op node returning opresult5100 (depth = 7)
  int op_slot_right_5062 = gc_frame_newslot(opresult5100);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5062 = gc_frame_newslot(*var_s);
  params[0] = opresult5100;
  partcv[0] = 1;
  Object opresult5102 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5102 (depth = 6)
  *var_s = opresult5102;
  if (opresult5102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5017 = done;
  } else {
  }
// compiled if node returning if5017 (depth = 4)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5106 = alloc_Boolean(0);
// compiled identifier node returning bool5106 (depth = 6)
  int op_slot_right_5105 = gc_frame_newslot(bool5106);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5109 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5108);
// compiled call node returning call5109 (depth = 7)
// compiled member node returning call5109 (depth = 6)
  int op_slot_left_5105 = gc_frame_newslot(call5109);
  params[0] = bool5106;
  partcv[0] = 1;
  Object opresult5110 = callmethod(call5109, "!=", 1, partcv, params);
// compiled op node returning opresult5110 (depth = 5)
  Object if5104 = done;
  if (istrue(opresult5110)) {
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5112 == NULL) {
    strlit5112 = alloc_String("Superclass:");
    gc_root(strlit5112);
  }
// compiled string node returning strlit5112 (depth = 7)
  int op_slot_right_5111 = gc_frame_newslot(strlit5112);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5114 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5117 == NULL) {
    strlit5117 = alloc_String("""\x0a""");
    gc_root(strlit5117);
  }
// compiled string node returning strlit5117 (depth = 9)
  int op_slot_right_5116 = gc_frame_newslot(strlit5117);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5116 = gc_frame_newslot(*var_s);
  params[0] = strlit5117;
  partcv[0] = 1;
  Object opresult5119 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5119 (depth = 8)
  int op_slot_left_5114 = gc_frame_newslot(opresult5119);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5120 = callmethod(opresult5119, "++", 1, partcv, params);
// compiled op node returning opresult5120 (depth = 7)
  int op_slot_left_5111 = gc_frame_newslot(opresult5120);
  params[0] = strlit5112;
  partcv[0] = 1;
  Object opresult5121 = callmethod(opresult5120, "++", 1, partcv, params);
// compiled op node returning opresult5121 (depth = 6)
  *var_s = opresult5121;
  if (opresult5121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5124 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5126 = alloc_Float64(2);
// compiled num node returning num5126 (depth = 9)
  int op_slot_right_5125 = gc_frame_newslot(num5126);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5125 = gc_frame_newslot(*var_depth);
  params[0] = num5126;
  partcv[0] = 1;
  Object sum5128 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5128 (depth = 8)
  gc_frame_newslot(sum5128);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5130 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5129);
// compiled call node returning call5130 (depth = 9)
// compiled member node returning call5130 (depth = 8)
  params[0] = sum5128;
  partcv[0] = 1;
  Object call5131 = callmethod(call5130, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5124);
// compiled call node returning call5131 (depth = 7)
  int op_slot_right_5123 = gc_frame_newslot(call5131);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5133 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5136 == NULL) {
    strlit5136 = alloc_String("""\x0a""  ");
    gc_root(strlit5136);
  }
// compiled string node returning strlit5136 (depth = 9)
  int op_slot_right_5135 = gc_frame_newslot(strlit5136);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5135 = gc_frame_newslot(*var_s);
  params[0] = strlit5136;
  partcv[0] = 1;
  Object opresult5138 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5138 (depth = 8)
  int op_slot_left_5133 = gc_frame_newslot(opresult5138);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5139 = callmethod(opresult5138, "++", 1, partcv, params);
// compiled op node returning opresult5139 (depth = 7)
  int op_slot_left_5123 = gc_frame_newslot(opresult5139);
  params[0] = call5131;
  partcv[0] = 1;
  Object opresult5140 = callmethod(opresult5139, "++", 1, partcv, params);
// compiled op node returning opresult5140 (depth = 6)
  *var_s = opresult5140;
  if (opresult5140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5104 = done;
  } else {
  }
// compiled if node returning if5104 (depth = 4)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit5143 == NULL) {
    strlit5143 = alloc_String("""\x0a""");
    gc_root(strlit5143);
  }
// compiled string node returning strlit5143 (depth = 6)
  int op_slot_right_5142 = gc_frame_newslot(strlit5143);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5142 = gc_frame_newslot(*var_s);
  params[0] = strlit5143;
  partcv[0] = 1;
  Object opresult5145 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5145 (depth = 5)
  *var_s = opresult5145;
  if (opresult5145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5148 == NULL) {
    strlit5148 = alloc_String("""\x0a""");
    gc_root(strlit5148);
  }
// compiled string node returning strlit5148 (depth = 6)
  int op_slot_right_5147 = gc_frame_newslot(strlit5148);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5151 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5152 = alloc_Float64(0);
// compiled num node returning num5152 (depth = 8)
  gc_frame_newslot(num5152);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5153 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5154 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5153);
// compiled call node returning call5154 (depth = 9)
// compiled member node returning call5154 (depth = 8)
  params[0] = num5152;
  partcv[0] = 1;
  Object call5155 = callmethod(call5154, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5151);
// compiled call node returning call5155 (depth = 7)
  int op_slot_right_5150 = gc_frame_newslot(call5155);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5158 == NULL) {
    strlit5158 = alloc_String("Factory method: ");
    gc_root(strlit5158);
  }
// compiled string node returning strlit5158 (depth = 8)
  int op_slot_right_5157 = gc_frame_newslot(strlit5158);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5160 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5163 == NULL) {
    strlit5163 = alloc_String("");
    gc_root(strlit5163);
  }
// compiled string node returning strlit5163 (depth = 10)
  int op_slot_right_5162 = gc_frame_newslot(strlit5163);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_5165 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit5167 == NULL) {
    strlit5167 = alloc_String("");
    gc_root(strlit5167);
  }
// compiled string node returning strlit5167 (depth = 11)
  int op_slot_left_5165 = gc_frame_newslot(strlit5167);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5168 = callmethod(strlit5167, "++", 1, partcv, params);
// compiled op node returning opresult5168 (depth = 10)
  int op_slot_left_5162 = gc_frame_newslot(opresult5168);
  params[0] = strlit5163;
  partcv[0] = 1;
  Object opresult5169 = callmethod(opresult5168, "++", 1, partcv, params);
// compiled op node returning opresult5169 (depth = 9)
  int op_slot_left_5160 = gc_frame_newslot(opresult5169);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5170 = callmethod(opresult5169, "++", 1, partcv, params);
// compiled op node returning opresult5170 (depth = 8)
  int op_slot_left_5157 = gc_frame_newslot(opresult5170);
  params[0] = strlit5158;
  partcv[0] = 1;
  Object opresult5171 = callmethod(opresult5170, "++", 1, partcv, params);
// compiled op node returning opresult5171 (depth = 7)
  int op_slot_left_5150 = gc_frame_newslot(opresult5171);
  params[0] = call5155;
  partcv[0] = 1;
  Object opresult5172 = callmethod(opresult5171, "++", 1, partcv, params);
// compiled op node returning opresult5172 (depth = 6)
  int op_slot_left_5147 = gc_frame_newslot(opresult5172);
  params[0] = strlit5148;
  partcv[0] = 1;
  Object opresult5173 = callmethod(opresult5172, "++", 1, partcv, params);
// compiled op node returning opresult5173 (depth = 5)
  *var_s = opresult5173;
  if (opresult5173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5178 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5177);
// compiled call node returning call5178 (depth = 7)
// compiled member node returning call5178 (depth = 6)
  int op_slot_right_5176 = gc_frame_newslot(call5178);
// starting to compile identifier node (depth = 6)
  Object bool5180 = alloc_Boolean(0);
// compiled identifier node returning bool5180 (depth = 6)
  int op_slot_left_5176 = gc_frame_newslot(bool5180);
  params[0] = call5178;
  partcv[0] = 1;
  Object opresult5181 = callmethod(bool5180, "!=", 1, partcv, params);
// compiled op node returning opresult5181 (depth = 5)
  Object if5175 = done;
  if (istrue(opresult5181)) {
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5183 == NULL) {
    strlit5183 = alloc_String("""\x0a""");
    gc_root(strlit5183);
  }
// compiled string node returning strlit5183 (depth = 7)
  int op_slot_right_5182 = gc_frame_newslot(strlit5183);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5186 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5188 = alloc_Float64(2);
// compiled num node returning num5188 (depth = 10)
  int op_slot_right_5187 = gc_frame_newslot(num5188);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5187 = gc_frame_newslot(*var_depth);
  params[0] = num5188;
  partcv[0] = 1;
  Object sum5190 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5190 (depth = 9)
  gc_frame_newslot(sum5190);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5192 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5191);
// compiled call node returning call5192 (depth = 10)
// compiled member node returning call5192 (depth = 9)
  params[0] = sum5190;
  partcv[0] = 1;
  Object call5193 = callmethod(call5192, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5186);
// compiled call node returning call5193 (depth = 8)
  int op_slot_right_5185 = gc_frame_newslot(call5193);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5196 == NULL) {
    strlit5196 = alloc_String("");
    gc_root(strlit5196);
  }
// compiled string node returning strlit5196 (depth = 9)
  int op_slot_right_5195 = gc_frame_newslot(strlit5196);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_5198 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5201 == NULL) {
    strlit5201 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit5201);
  }
// compiled string node returning strlit5201 (depth = 11)
  int op_slot_right_5200 = gc_frame_newslot(strlit5201);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_spc (depth = 12)
  int op_slot_right_5203 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit5206 == NULL) {
    strlit5206 = alloc_String("");
    gc_root(strlit5206);
  }
// compiled string node returning strlit5206 (depth = 13)
  int op_slot_right_5205 = gc_frame_newslot(strlit5206);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_s (depth = 14)
  int op_slot_right_5208 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 14)
  if (strlit5210 == NULL) {
    strlit5210 = alloc_String("");
    gc_root(strlit5210);
  }
// compiled string node returning strlit5210 (depth = 14)
  int op_slot_left_5208 = gc_frame_newslot(strlit5210);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5211 = callmethod(strlit5210, "++", 1, partcv, params);
// compiled op node returning opresult5211 (depth = 13)
  int op_slot_left_5205 = gc_frame_newslot(opresult5211);
  params[0] = strlit5206;
  partcv[0] = 1;
  Object opresult5212 = callmethod(opresult5211, "++", 1, partcv, params);
// compiled op node returning opresult5212 (depth = 12)
  int op_slot_left_5203 = gc_frame_newslot(opresult5212);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5213 = callmethod(opresult5212, "++", 1, partcv, params);
// compiled op node returning opresult5213 (depth = 11)
  int op_slot_left_5200 = gc_frame_newslot(opresult5213);
  params[0] = strlit5201;
  partcv[0] = 1;
  Object opresult5214 = callmethod(opresult5213, "++", 1, partcv, params);
// compiled op node returning opresult5214 (depth = 10)
  int op_slot_left_5198 = gc_frame_newslot(opresult5214);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5215 = callmethod(opresult5214, "++", 1, partcv, params);
// compiled op node returning opresult5215 (depth = 9)
  int op_slot_left_5195 = gc_frame_newslot(opresult5215);
  params[0] = strlit5196;
  partcv[0] = 1;
  Object opresult5216 = callmethod(opresult5215, "++", 1, partcv, params);
// compiled op node returning opresult5216 (depth = 8)
  int op_slot_left_5185 = gc_frame_newslot(opresult5216);
  params[0] = call5193;
  partcv[0] = 1;
  Object opresult5217 = callmethod(opresult5216, "++", 1, partcv, params);
// compiled op node returning opresult5217 (depth = 7)
  int op_slot_left_5182 = gc_frame_newslot(opresult5217);
  params[0] = strlit5183;
  partcv[0] = 1;
  Object opresult5218 = callmethod(opresult5217, "++", 1, partcv, params);
// compiled op node returning opresult5218 (depth = 6)
  *var_s = opresult5218;
  if (opresult5218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5175 = done;
  } else {
  }
// compiled if node returning if5175 (depth = 4)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5221 == NULL) {
    strlit5221 = alloc_String("Signature:");
    gc_root(strlit5221);
  }
// compiled string node returning strlit5221 (depth = 6)
  int op_slot_right_5220 = gc_frame_newslot(strlit5221);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5223 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5226 == NULL) {
    strlit5226 = alloc_String("");
    gc_root(strlit5226);
  }
// compiled string node returning strlit5226 (depth = 8)
  int op_slot_right_5225 = gc_frame_newslot(strlit5226);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_5228 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit5230 == NULL) {
    strlit5230 = alloc_String("");
    gc_root(strlit5230);
  }
// compiled string node returning strlit5230 (depth = 9)
  int op_slot_left_5228 = gc_frame_newslot(strlit5230);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5231 = callmethod(strlit5230, "++", 1, partcv, params);
// compiled op node returning opresult5231 (depth = 8)
  int op_slot_left_5225 = gc_frame_newslot(opresult5231);
  params[0] = strlit5226;
  partcv[0] = 1;
  Object opresult5232 = callmethod(opresult5231, "++", 1, partcv, params);
// compiled op node returning opresult5232 (depth = 7)
  int op_slot_left_5223 = gc_frame_newslot(opresult5232);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5233 = callmethod(opresult5232, "++", 1, partcv, params);
// compiled op node returning opresult5233 (depth = 6)
  int op_slot_left_5220 = gc_frame_newslot(opresult5233);
  params[0] = strlit5221;
  partcv[0] = 1;
  Object opresult5234 = callmethod(opresult5233, "++", 1, partcv, params);
// compiled op node returning opresult5234 (depth = 5)
  *var_s = opresult5234;
  if (opresult5234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5236 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5238 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5237);
// compiled call node returning call5238 (depth = 6)
// compiled member node returning call5238 (depth = 5)
  gc_frame_newslot(call5238);
// starting to compile block node (depth = 5)
  Object block5239 = alloc_Block(NULL, NULL, "ast", 1167);
  gc_frame_newslot(block5239);
// method _apply
  block_savedest(block5239);
  Object closure5240 = createclosure(4, "_apply");
  setclosureframe(closure5240, stackframe);
  addtoclosure(closure5240, var_spc);
  addtoclosure(closure5240, var_s);
  addtoclosure(closure5240, var_depth);
  addtoclosure(closure5240, selfslot);
  struct UserObject *uo5240 = (struct UserObject*)block5239;
  uo5240->data[0] = (Object)closure5240;
  Method *meth_meth_ast__apply5240 = addmethod2pos(block5239, "_apply", &meth_ast__apply5240, 0);
  int argcv_meth_ast__apply5240[] = {1};
  meth_meth_ast__apply5240->type = alloc_MethodType(1, argcv_meth_ast__apply5240);
  meth_meth_ast__apply5240->definitionModule = modulename;
  meth_meth_ast__apply5240->definitionLine = 1167;
// compiled block node returning block5239 (depth = 5)
  gc_frame_newslot(block5239);
// call case 5: prelude request
  params[0] = call5238;
  params[1] = block5239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5357 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5236);
// compiled call node returning call5357 (depth = 4)
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5359 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5360 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5361 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5362 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5361);
// compiled call node returning call5362 (depth = 10)
// compiled member node returning call5362 (depth = 9)
  partcv[0] = 0;
  Object call5363 = callmethod(call5362, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe5360);
// compiled call node returning call5363 (depth = 8)
// compiled member node returning call5363 (depth = 7)
  partcv[0] = 0;
  Object call5364 = callmethod(call5363, "not",
    1, partcv, params);
  gc_frame_end(callframe5359);
// compiled call node returning call5364 (depth = 6)
// compiled member node returning call5364 (depth = 5)
  Object if5358 = done;
  if (istrue(call5364)) {
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5366 == NULL) {
    strlit5366 = alloc_String("TypeParams:");
    gc_root(strlit5366);
  }
// compiled string node returning strlit5366 (depth = 7)
  int op_slot_right_5365 = gc_frame_newslot(strlit5366);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5368 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5371 == NULL) {
    strlit5371 = alloc_String("""\x0a""");
    gc_root(strlit5371);
  }
// compiled string node returning strlit5371 (depth = 9)
  int op_slot_right_5370 = gc_frame_newslot(strlit5371);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5370 = gc_frame_newslot(*var_s);
  params[0] = strlit5371;
  partcv[0] = 1;
  Object opresult5373 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5373 (depth = 8)
  int op_slot_left_5368 = gc_frame_newslot(opresult5373);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5374 = callmethod(opresult5373, "++", 1, partcv, params);
// compiled op node returning opresult5374 (depth = 7)
  int op_slot_left_5365 = gc_frame_newslot(opresult5374);
  params[0] = strlit5366;
  partcv[0] = 1;
  Object opresult5375 = callmethod(opresult5374, "++", 1, partcv, params);
// compiled op node returning opresult5375 (depth = 6)
  *var_s = opresult5375;
  if (opresult5375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5377 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5378 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5379 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5378);
// compiled call node returning call5379 (depth = 7)
// compiled member node returning call5379 (depth = 6)
  gc_frame_newslot(call5379);
// starting to compile block node (depth = 6)
  Object block5380 = alloc_Block(NULL, NULL, "ast", 1179);
  gc_frame_newslot(block5380);
// method _apply
  block_savedest(block5380);
  Object closure5381 = createclosure(3, "_apply");
  setclosureframe(closure5381, stackframe);
  addtoclosure(closure5381, var_spc);
  addtoclosure(closure5381, var_s);
  addtoclosure(closure5381, selfslot);
  struct UserObject *uo5381 = (struct UserObject*)block5380;
  uo5381->data[0] = (Object)closure5381;
  Method *meth_meth_ast__apply5381 = addmethod2pos(block5380, "_apply", &meth_ast__apply5381, 0);
  int argcv_meth_ast__apply5381[] = {1};
  meth_meth_ast__apply5381->type = alloc_MethodType(1, argcv_meth_ast__apply5381);
  meth_meth_ast__apply5381->definitionModule = modulename;
  meth_meth_ast__apply5381->definitionLine = 1179;
// compiled block node returning block5380 (depth = 6)
  gc_frame_newslot(block5380);
// call case 5: prelude request
  params[0] = call5379;
  params[1] = block5380;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5405 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5377);
// compiled call node returning call5405 (depth = 5)
    gc_frame_newslot(call5405);
    if5358 = call5405;
  } else {
  }
// compiled if node returning if5358 (depth = 4)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5408 = alloc_Float64(0);
// compiled num node returning num5408 (depth = 6)
  int op_slot_right_5407 = gc_frame_newslot(num5408);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5410 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5412 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5411);
// compiled call node returning call5412 (depth = 9)
// compiled member node returning call5412 (depth = 8)
  partcv[0] = 0;
  Object call5413 = callmethod(call5412, "size",
    1, partcv, params);
  gc_frame_end(callframe5410);
// compiled call node returning call5413 (depth = 7)
// compiled member node returning call5413 (depth = 6)
  int op_slot_left_5407 = gc_frame_newslot(call5413);
  params[0] = num5408;
  partcv[0] = 1;
  Object opresult5414 = callmethod(call5413, ">", 1, partcv, params);
// compiled op node returning opresult5414 (depth = 5)
  Object if5406 = done;
  if (istrue(opresult5414)) {
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5416 == NULL) {
    strlit5416 = alloc_String("Annotations:");
    gc_root(strlit5416);
  }
// compiled string node returning strlit5416 (depth = 7)
  int op_slot_right_5415 = gc_frame_newslot(strlit5416);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5418 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5421 == NULL) {
    strlit5421 = alloc_String("""\x0a""");
    gc_root(strlit5421);
  }
// compiled string node returning strlit5421 (depth = 9)
  int op_slot_right_5420 = gc_frame_newslot(strlit5421);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5420 = gc_frame_newslot(*var_s);
  params[0] = strlit5421;
  partcv[0] = 1;
  Object opresult5423 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5423 (depth = 8)
  int op_slot_left_5418 = gc_frame_newslot(opresult5423);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5424 = callmethod(opresult5423, "++", 1, partcv, params);
// compiled op node returning opresult5424 (depth = 7)
  int op_slot_left_5415 = gc_frame_newslot(opresult5424);
  params[0] = strlit5416;
  partcv[0] = 1;
  Object opresult5425 = callmethod(opresult5424, "++", 1, partcv, params);
// compiled op node returning opresult5425 (depth = 6)
  *var_s = opresult5425;
  if (opresult5425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5427 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5428 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5429 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5428);
// compiled call node returning call5429 (depth = 7)
// compiled member node returning call5429 (depth = 6)
  gc_frame_newslot(call5429);
// starting to compile block node (depth = 6)
  Object block5430 = alloc_Block(NULL, NULL, "ast", 1185);
  gc_frame_newslot(block5430);
// method _apply
  block_savedest(block5430);
  Object closure5431 = createclosure(3, "_apply");
  setclosureframe(closure5431, stackframe);
  addtoclosure(closure5431, var_depth);
  addtoclosure(closure5431, var_s);
  addtoclosure(closure5431, selfslot);
  struct UserObject *uo5431 = (struct UserObject*)block5430;
  uo5431->data[0] = (Object)closure5431;
  Method *meth_meth_ast__apply5431 = addmethod2pos(block5430, "_apply", &meth_ast__apply5431, 0);
  int argcv_meth_ast__apply5431[] = {1};
  meth_meth_ast__apply5431->type = alloc_MethodType(1, argcv_meth_ast__apply5431);
  meth_meth_ast__apply5431->definitionModule = modulename;
  meth_meth_ast__apply5431->definitionLine = 1185;
// compiled block node returning block5430 (depth = 6)
  gc_frame_newslot(block5430);
// call case 5: prelude request
  params[0] = call5429;
  params[1] = block5430;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5451 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5427);
// compiled call node returning call5451 (depth = 5)
    gc_frame_newslot(call5451);
    if5406 = call5451;
  } else {
  }
// compiled if node returning if5406 (depth = 4)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit5453 == NULL) {
    strlit5453 = alloc_String("Body:");
    gc_root(strlit5453);
  }
// compiled string node returning strlit5453 (depth = 6)
  int op_slot_right_5452 = gc_frame_newslot(strlit5453);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5455 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5458 == NULL) {
    strlit5458 = alloc_String("""\x0a""");
    gc_root(strlit5458);
  }
// compiled string node returning strlit5458 (depth = 8)
  int op_slot_right_5457 = gc_frame_newslot(strlit5458);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5457 = gc_frame_newslot(*var_s);
  params[0] = strlit5458;
  partcv[0] = 1;
  Object opresult5460 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5460 (depth = 7)
  int op_slot_left_5455 = gc_frame_newslot(opresult5460);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5461 = callmethod(opresult5460, "++", 1, partcv, params);
// compiled op node returning opresult5461 (depth = 6)
  int op_slot_left_5452 = gc_frame_newslot(opresult5461);
  params[0] = strlit5453;
  partcv[0] = 1;
  Object opresult5462 = callmethod(opresult5461, "++", 1, partcv, params);
// compiled op node returning opresult5462 (depth = 5)
  *var_s = opresult5462;
  if (opresult5462 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5464 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5466 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5465);
// compiled call node returning call5466 (depth = 6)
// compiled member node returning call5466 (depth = 5)
  gc_frame_newslot(call5466);
// starting to compile block node (depth = 5)
  Object block5467 = alloc_Block(NULL, NULL, "ast", 1190);
  gc_frame_newslot(block5467);
// method _apply
  block_savedest(block5467);
  Object closure5468 = createclosure(4, "_apply");
  setclosureframe(closure5468, stackframe);
  addtoclosure(closure5468, var_depth);
  addtoclosure(closure5468, var_spc);
  addtoclosure(closure5468, var_s);
  addtoclosure(closure5468, selfslot);
  struct UserObject *uo5468 = (struct UserObject*)block5467;
  uo5468->data[0] = (Object)closure5468;
  Method *meth_meth_ast__apply5468 = addmethod2pos(block5467, "_apply", &meth_ast__apply5468, 0);
  int argcv_meth_ast__apply5468[] = {1};
  meth_meth_ast__apply5468->type = alloc_MethodType(1, argcv_meth_ast__apply5468);
  meth_meth_ast__apply5468->definitionModule = modulename;
  meth_meth_ast__apply5468->definitionLine = 1190;
// compiled block node returning block5467 (depth = 5)
  gc_frame_newslot(block5467);
// call case 5: prelude request
  params[0] = call5466;
  params[1] = block5467;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5487 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5464);
// compiled call node returning call5487 (depth = 4)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5500(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit5502 == NULL) {
    strlit5502 = alloc_String("    ");
    gc_root(strlit5502);
  }
// compiled string node returning strlit5502 (depth = 8)
  int op_slot_right_5501 = gc_frame_newslot(strlit5502);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_5501 = gc_frame_newslot(*var_spc);
  params[0] = strlit5502;
  partcv[0] = 1;
  Object opresult5504 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5504 (depth = 7)
  *var_spc = opresult5504;
  if (opresult5504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5575(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 10)
// starting to compile index node (depth = 11)
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call5577 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5576);
// compiled call node returning call5577 (depth = 13)
// compiled member node returning call5577 (depth = 12)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_pnr (depth = 12)
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5578 = callmethod(call5577, "[]", 1, partcv, params);
// compiled index node returning idxres5578 (depth = 11)
  *var_p = idxres5578;
  if (idxres5578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 10)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5580 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num5582 = alloc_Float64(1);
// compiled num node returning num5582 (depth = 14)
  int op_slot_right_5581 = gc_frame_newslot(num5582);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_depth (depth = 14)
  int op_slot_left_5581 = gc_frame_newslot(*var_depth);
  params[0] = num5582;
  partcv[0] = 1;
  Object sum5584 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5584 (depth = 13)
  gc_frame_newslot(sum5584);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_p (depth = 13)
  params[0] = sum5584;
  partcv[0] = 1;
  Object call5585 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5580);
// compiled call node returning call5585 (depth = 12)
  int op_slot_right_5579 = gc_frame_newslot(call5585);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_5579 = gc_frame_newslot(*var_s);
  params[0] = call5585;
  partcv[0] = 1;
  Object opresult5587 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5587 (depth = 11)
  *var_s = opresult5587;
  if (opresult5587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
  Object bool5592 = alloc_Boolean(0);
// compiled identifier node returning bool5592 (depth = 13)
  int op_slot_right_5591 = gc_frame_newslot(bool5592);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5594 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call5595 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5594);
// compiled call node returning call5595 (depth = 14)
// compiled member node returning call5595 (depth = 13)
  int op_slot_left_5591 = gc_frame_newslot(call5595);
  params[0] = bool5592;
  partcv[0] = 1;
  Object opresult5596 = callmethod(call5595, "!=", 1, partcv, params);
// compiled op node returning opresult5596 (depth = 12)
  int op_slot_right_5590 = gc_frame_newslot(opresult5596);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5599 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe5600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_part (depth = 17)
  partcv[0] = 0;
  Object call5601 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5600);
// compiled call node returning call5601 (depth = 16)
// compiled member node returning call5601 (depth = 15)
  partcv[0] = 0;
  Object call5602 = callmethod(call5601, "size",
    1, partcv, params);
  gc_frame_end(callframe5599);
// compiled call node returning call5602 (depth = 14)
// compiled member node returning call5602 (depth = 13)
  int op_slot_right_5598 = gc_frame_newslot(call5602);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_pnr (depth = 13)
  int op_slot_left_5598 = gc_frame_newslot(*var_pnr);
  params[0] = call5602;
  partcv[0] = 1;
  Object opresult5604 = callmethod(*var_pnr, "<", 1, partcv, params);
// compiled op node returning opresult5604 (depth = 12)
  int op_slot_left_5590 = gc_frame_newslot(opresult5604);
  params[0] = opresult5596;
  partcv[0] = 1;
  Object opresult5605 = callmethod(opresult5604, "||", 1, partcv, params);
// compiled op node returning opresult5605 (depth = 11)
  Object if5589 = done;
  if (istrue(opresult5605)) {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit5607 == NULL) {
    strlit5607 = alloc_String(", ");
    gc_root(strlit5607);
  }
// compiled string node returning strlit5607 (depth = 13)
  int op_slot_right_5606 = gc_frame_newslot(strlit5607);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_left_5606 = gc_frame_newslot(*var_s);
  params[0] = strlit5607;
  partcv[0] = 1;
  Object opresult5609 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5609 (depth = 12)
  *var_s = opresult5609;
  if (opresult5609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if5589 = done;
  } else {
  }
// compiled if node returning if5589 (depth = 10)
  gc_frame_end(frame);
  return if5589;
}
Object meth_ast__apply5539(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_part (depth = 11)
  partcv[0] = 0;
  Object call5542 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe5541);
// compiled call node returning call5542 (depth = 10)
// compiled member node returning call5542 (depth = 9)
  int op_slot_right_5540 = gc_frame_newslot(call5542);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5540 = gc_frame_newslot(*var_s);
  params[0] = call5542;
  partcv[0] = 1;
  Object opresult5544 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5544 (depth = 8)
  *var_s = opresult5544;
  if (opresult5544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool5549 = alloc_Boolean(0);
// compiled identifier node returning bool5549 (depth = 10)
  int op_slot_right_5548 = gc_frame_newslot(bool5549);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call5552 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5551);
// compiled call node returning call5552 (depth = 11)
// compiled member node returning call5552 (depth = 10)
  int op_slot_left_5548 = gc_frame_newslot(call5552);
  params[0] = bool5549;
  partcv[0] = 1;
  Object opresult5553 = callmethod(call5552, "!=", 1, partcv, params);
// compiled op node returning opresult5553 (depth = 9)
  int op_slot_right_5547 = gc_frame_newslot(opresult5553);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5556 = alloc_Float64(0);
// compiled num node returning num5556 (depth = 10)
  int op_slot_right_5555 = gc_frame_newslot(num5556);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5558 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_part (depth = 14)
  partcv[0] = 0;
  Object call5560 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5559);
// compiled call node returning call5560 (depth = 13)
// compiled member node returning call5560 (depth = 12)
  partcv[0] = 0;
  Object call5561 = callmethod(call5560, "size",
    1, partcv, params);
  gc_frame_end(callframe5558);
// compiled call node returning call5561 (depth = 11)
// compiled member node returning call5561 (depth = 10)
  int op_slot_left_5555 = gc_frame_newslot(call5561);
  params[0] = num5556;
  partcv[0] = 1;
  Object opresult5562 = callmethod(call5561, ">", 1, partcv, params);
// compiled op node returning opresult5562 (depth = 9)
  int op_slot_left_5547 = gc_frame_newslot(opresult5562);
  params[0] = opresult5553;
  partcv[0] = 1;
  Object opresult5563 = callmethod(opresult5562, "||", 1, partcv, params);
// compiled op node returning opresult5563 (depth = 8)
  Object if5546 = done;
  if (istrue(opresult5563)) {
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit5565 == NULL) {
    strlit5565 = alloc_String("(");
    gc_root(strlit5565);
  }
// compiled string node returning strlit5565 (depth = 10)
  int op_slot_right_5564 = gc_frame_newslot(strlit5565);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5564 = gc_frame_newslot(*var_s);
  params[0] = strlit5565;
  partcv[0] = 1;
  Object opresult5567 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5567 (depth = 9)
  *var_s = opresult5567;
  if (opresult5567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5569 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5570 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_part (depth = 13)
  partcv[0] = 0;
  Object call5572 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe5571);
// compiled call node returning call5572 (depth = 12)
// compiled member node returning call5572 (depth = 11)
  partcv[0] = 0;
  Object call5573 = callmethod(call5572, "indices",
    1, partcv, params);
  gc_frame_end(callframe5570);
// compiled call node returning call5573 (depth = 10)
// compiled member node returning call5573 (depth = 9)
  gc_frame_newslot(call5573);
// starting to compile block node (depth = 9)
  Object block5574 = alloc_Block(NULL, NULL, "ast", 1208);
  gc_frame_newslot(block5574);
// method _apply
  block_savedest(block5574);
  Object closure5575 = createclosure(4, "_apply");
  setclosureframe(closure5575, stackframe);
  addtoclosure(closure5575, var_part);
  addtoclosure(closure5575, var_depth);
  addtoclosure(closure5575, var_s);
  addtoclosure(closure5575, selfslot);
  struct UserObject *uo5575 = (struct UserObject*)block5574;
  uo5575->data[0] = (Object)closure5575;
  Method *meth_meth_ast__apply5575 = addmethod2pos(block5574, "_apply", &meth_ast__apply5575, 0);
  int argcv_meth_ast__apply5575[] = {1};
  meth_meth_ast__apply5575->type = alloc_MethodType(1, argcv_meth_ast__apply5575);
  meth_meth_ast__apply5575->definitionModule = modulename;
  meth_meth_ast__apply5575->definitionLine = 1208;
// compiled block node returning block5574 (depth = 9)
  gc_frame_newslot(block5574);
// call case 5: prelude request
  params[0] = call5573;
  params[1] = block5574;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5612 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5569);
// compiled call node returning call5612 (depth = 8)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool5615 = alloc_Boolean(0);
// compiled identifier node returning bool5615 (depth = 10)
  int op_slot_right_5614 = gc_frame_newslot(bool5615);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5617 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_part (depth = 12)
  partcv[0] = 0;
  Object call5618 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5617);
// compiled call node returning call5618 (depth = 11)
// compiled member node returning call5618 (depth = 10)
  int op_slot_left_5614 = gc_frame_newslot(call5618);
  params[0] = bool5615;
  partcv[0] = 1;
  Object opresult5619 = callmethod(call5618, "!=", 1, partcv, params);
// compiled op node returning opresult5619 (depth = 9)
  Object if5613 = done;
  if (istrue(opresult5619)) {
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5621 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_part (depth = 15)
  partcv[0] = 0;
  Object call5623 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe5622);
// compiled call node returning call5623 (depth = 14)
// compiled member node returning call5623 (depth = 13)
  partcv[0] = 0;
  Object call5624 = callmethod(call5623, "value",
    1, partcv, params);
  gc_frame_end(callframe5621);
// compiled call node returning call5624 (depth = 12)
// compiled member node returning call5624 (depth = 11)
  int op_slot_right_5620 = gc_frame_newslot(call5624);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5627 == NULL) {
    strlit5627 = alloc_String("*");
    gc_root(strlit5627);
  }
// compiled string node returning strlit5627 (depth = 12)
  int op_slot_right_5626 = gc_frame_newslot(strlit5627);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_5626 = gc_frame_newslot(*var_s);
  params[0] = strlit5627;
  partcv[0] = 1;
  Object opresult5629 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5629 (depth = 11)
  int op_slot_left_5620 = gc_frame_newslot(opresult5629);
  params[0] = call5624;
  partcv[0] = 1;
  Object opresult5630 = callmethod(opresult5629, "++", 1, partcv, params);
// compiled op node returning opresult5630 (depth = 10)
  *var_s = opresult5630;
  if (opresult5630 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if5613 = done;
  } else {
  }
// compiled if node returning if5613 (depth = 8)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit5633 == NULL) {
    strlit5633 = alloc_String(")");
    gc_root(strlit5633);
  }
// compiled string node returning strlit5633 (depth = 10)
  int op_slot_right_5632 = gc_frame_newslot(strlit5633);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5632 = gc_frame_newslot(*var_s);
  params[0] = strlit5633;
  partcv[0] = 1;
  Object opresult5635 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5635 (depth = 9)
  *var_s = opresult5635;
  if (opresult5635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if5546 = done;
  } else {
  }
// compiled if node returning if5546 (depth = 7)
  gc_frame_end(frame);
  return if5546;
}
Object meth_ast__apply5679(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5681 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5683 = alloc_Float64(1);
// compiled num node returning num5683 (depth = 10)
  int op_slot_right_5682 = gc_frame_newslot(num5683);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5682 = gc_frame_newslot(*var_depth);
  params[0] = num5683;
  partcv[0] = 1;
  Object sum5685 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5685 (depth = 9)
  gc_frame_newslot(sum5685);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mx (depth = 9)
  params[0] = sum5685;
  partcv[0] = 1;
  Object call5686 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5681);
// compiled call node returning call5686 (depth = 8)
  int op_slot_right_5680 = gc_frame_newslot(call5686);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5689 == NULL) {
    strlit5689 = alloc_String("    ");
    gc_root(strlit5689);
  }
// compiled string node returning strlit5689 (depth = 9)
  int op_slot_right_5688 = gc_frame_newslot(strlit5689);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_5691 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5694 == NULL) {
    strlit5694 = alloc_String("""\x0a""");
    gc_root(strlit5694);
  }
// compiled string node returning strlit5694 (depth = 11)
  int op_slot_right_5693 = gc_frame_newslot(strlit5694);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5693 = gc_frame_newslot(*var_s);
  params[0] = strlit5694;
  partcv[0] = 1;
  Object opresult5696 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5696 (depth = 10)
  int op_slot_left_5691 = gc_frame_newslot(opresult5696);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5697 = callmethod(opresult5696, "++", 1, partcv, params);
// compiled op node returning opresult5697 (depth = 9)
  int op_slot_left_5688 = gc_frame_newslot(opresult5697);
  params[0] = strlit5689;
  partcv[0] = 1;
  Object opresult5698 = callmethod(opresult5697, "++", 1, partcv, params);
// compiled op node returning opresult5698 (depth = 8)
  int op_slot_left_5680 = gc_frame_newslot(opresult5698);
  params[0] = call5686;
  partcv[0] = 1;
  Object opresult5699 = callmethod(opresult5698, "++", 1, partcv, params);
// compiled op node returning opresult5699 (depth = 7)
  *var_s = opresult5699;
  if (opresult5699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5488(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit5489 == NULL) {
    strlit5489 = alloc_String("");
    gc_root(strlit5489);
  }
// compiled string node returning strlit5489 (depth = 5)
  *var_spc = strlit5489;
  if (strlit5489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5490 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5493 = alloc_Float64(1);
// compiled num node returning num5493 (depth = 7)
  int op_slot_right_5492 = gc_frame_newslot(num5493);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_5492 = gc_frame_newslot(*var_depth);
  params[0] = num5493;
  partcv[0] = 1;
  Object diff5495 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff5495 (depth = 6)
  int op_slot_right_5491 = gc_frame_newslot(diff5495);
// starting to compile num node (depth = 6)
  Object num5497 = alloc_Float64(0);
// compiled num node returning num5497 (depth = 6)
  int op_slot_left_5491 = gc_frame_newslot(num5497);
  params[0] = diff5495;
  partcv[0] = 1;
  Object opresult5498 = callmethod(num5497, "..", 1, partcv, params);
// compiled op node returning opresult5498 (depth = 5)
  gc_frame_newslot(opresult5498);
// starting to compile block node (depth = 5)
  Object block5499 = alloc_Block(NULL, NULL, "ast", 1197);
  gc_frame_newslot(block5499);
// method _apply
  block_savedest(block5499);
  Object closure5500 = createclosure(2, "_apply");
  setclosureframe(closure5500, stackframe);
  addtoclosure(closure5500, var_spc);
  addtoclosure(closure5500, selfslot);
  struct UserObject *uo5500 = (struct UserObject*)block5499;
  uo5500->data[0] = (Object)closure5500;
  Method *meth_meth_ast__apply5500 = addmethod2pos(block5499, "_apply", &meth_ast__apply5500, 0);
  int argcv_meth_ast__apply5500[] = {1};
  meth_meth_ast__apply5500->type = alloc_MethodType(1, argcv_meth_ast__apply5500);
  meth_meth_ast__apply5500->definitionModule = modulename;
  meth_meth_ast__apply5500->definitionLine = 1190;
// compiled block node returning block5499 (depth = 5)
  gc_frame_newslot(block5499);
// call case 5: prelude request
  params[0] = opresult5498;
  params[1] = block5499;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5507 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5490);
// compiled call node returning call5507 (depth = 4)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5509 == NULL) {
    strlit5509 = alloc_String("");
    gc_root(strlit5509);
  }
// compiled string node returning strlit5509 (depth = 6)
  int op_slot_right_5508 = gc_frame_newslot(strlit5509);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5512 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num5513 = alloc_Float64(0);
// compiled num node returning num5513 (depth = 8)
  gc_frame_newslot(num5513);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5514 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5515 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5514);
// compiled call node returning call5515 (depth = 9)
// compiled member node returning call5515 (depth = 8)
  params[0] = num5513;
  partcv[0] = 1;
  Object call5516 = callmethod(call5515, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5512);
// compiled call node returning call5516 (depth = 7)
  int op_slot_right_5511 = gc_frame_newslot(call5516);
// starting to compile string node (depth = 7)
  if (strlit5518 == NULL) {
    strlit5518 = alloc_String("class ");
    gc_root(strlit5518);
  }
// compiled string node returning strlit5518 (depth = 7)
  int op_slot_left_5511 = gc_frame_newslot(strlit5518);
  params[0] = call5516;
  partcv[0] = 1;
  Object opresult5519 = callmethod(strlit5518, "++", 1, partcv, params);
// compiled op node returning opresult5519 (depth = 6)
  int op_slot_left_5508 = gc_frame_newslot(opresult5519);
  params[0] = strlit5509;
  partcv[0] = 1;
  Object opresult5520 = callmethod(opresult5519, "++", 1, partcv, params);
// compiled op node returning opresult5520 (depth = 5)
  *var_s = opresult5520;
  if (opresult5520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5523 == NULL) {
    strlit5523 = alloc_String("generic");
    gc_root(strlit5523);
  }
// compiled string node returning strlit5523 (depth = 6)
  int op_slot_right_5522 = gc_frame_newslot(strlit5523);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5525 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5527 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5526);
// compiled call node returning call5527 (depth = 9)
// compiled member node returning call5527 (depth = 8)
  partcv[0] = 0;
  Object call5528 = callmethod(call5527, "kind",
    1, partcv, params);
  gc_frame_end(callframe5525);
// compiled call node returning call5528 (depth = 7)
// compiled member node returning call5528 (depth = 6)
  int op_slot_left_5522 = gc_frame_newslot(call5528);
  params[0] = strlit5523;
  partcv[0] = 1;
  Object opresult5529 = callmethod(call5528, "!=", 1, partcv, params);
// compiled op node returning opresult5529 (depth = 5)
  Object if5521 = done;
  if (istrue(opresult5529)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5531 == NULL) {
    strlit5531 = alloc_String(".");
    gc_root(strlit5531);
  }
// compiled string node returning strlit5531 (depth = 7)
  int op_slot_right_5530 = gc_frame_newslot(strlit5531);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5530 = gc_frame_newslot(*var_s);
  params[0] = strlit5531;
  partcv[0] = 1;
  Object opresult5533 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5533 (depth = 6)
  *var_s = opresult5533;
  if (opresult5533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5535 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5536 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5537 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5536);
// compiled call node returning call5537 (depth = 7)
// compiled member node returning call5537 (depth = 6)
  gc_frame_newslot(call5537);
// starting to compile block node (depth = 6)
  Object block5538 = alloc_Block(NULL, NULL, "ast", 1204);
  gc_frame_newslot(block5538);
// method _apply
  block_savedest(block5538);
  Object closure5539 = createclosure(3, "_apply");
  setclosureframe(closure5539, stackframe);
  addtoclosure(closure5539, var_s);
  addtoclosure(closure5539, var_depth);
  addtoclosure(closure5539, selfslot);
  struct UserObject *uo5539 = (struct UserObject*)block5538;
  uo5539->data[0] = (Object)closure5539;
  Method *meth_meth_ast__apply5539 = addmethod2pos(block5538, "_apply", &meth_ast__apply5539, 0);
  int argcv_meth_ast__apply5539[] = {1};
  meth_meth_ast__apply5539->type = alloc_MethodType(1, argcv_meth_ast__apply5539);
  meth_meth_ast__apply5539->definitionModule = modulename;
  meth_meth_ast__apply5539->definitionLine = 1204;
// compiled block node returning block5538 (depth = 6)
  gc_frame_newslot(block5538);
// call case 5: prelude request
  params[0] = call5537;
  params[1] = block5538;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5638 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5535);
// compiled call node returning call5638 (depth = 5)
    gc_frame_newslot(call5638);
    if5521 = call5638;
  } else {
  }
// compiled if node returning if5521 (depth = 4)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5641 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5642 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5641);
// compiled call node returning call5642 (depth = 7)
// compiled member node returning call5642 (depth = 6)
  int op_slot_right_5640 = gc_frame_newslot(call5642);
// starting to compile identifier node (depth = 6)
  Object bool5644 = alloc_Boolean(0);
// compiled identifier node returning bool5644 (depth = 6)
  int op_slot_left_5640 = gc_frame_newslot(bool5644);
  params[0] = call5642;
  partcv[0] = 1;
  Object opresult5645 = callmethod(bool5644, "!=", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 5)
  Object if5639 = done;
  if (istrue(opresult5645)) {
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5647 == NULL) {
    strlit5647 = alloc_String("");
    gc_root(strlit5647);
  }
// compiled string node returning strlit5647 (depth = 7)
  int op_slot_right_5646 = gc_frame_newslot(strlit5647);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5650 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5652 = alloc_Float64(1);
// compiled num node returning num5652 (depth = 10)
  int op_slot_right_5651 = gc_frame_newslot(num5652);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5651 = gc_frame_newslot(*var_depth);
  params[0] = num5652;
  partcv[0] = 1;
  Object sum5654 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5654 (depth = 9)
  gc_frame_newslot(sum5654);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5655 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5656 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5655);
// compiled call node returning call5656 (depth = 10)
// compiled member node returning call5656 (depth = 9)
  params[0] = sum5654;
  partcv[0] = 1;
  Object call5657 = callmethod(call5656, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5650);
// compiled call node returning call5657 (depth = 8)
  int op_slot_right_5649 = gc_frame_newslot(call5657);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5660 == NULL) {
    strlit5660 = alloc_String(" -> ");
    gc_root(strlit5660);
  }
// compiled string node returning strlit5660 (depth = 9)
  int op_slot_right_5659 = gc_frame_newslot(strlit5660);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_right_5662 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 10)
  if (strlit5664 == NULL) {
    strlit5664 = alloc_String("");
    gc_root(strlit5664);
  }
// compiled string node returning strlit5664 (depth = 10)
  int op_slot_left_5662 = gc_frame_newslot(strlit5664);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult5665 = callmethod(strlit5664, "++", 1, partcv, params);
// compiled op node returning opresult5665 (depth = 9)
  int op_slot_left_5659 = gc_frame_newslot(opresult5665);
  params[0] = strlit5660;
  partcv[0] = 1;
  Object opresult5666 = callmethod(opresult5665, "++", 1, partcv, params);
// compiled op node returning opresult5666 (depth = 8)
  int op_slot_left_5649 = gc_frame_newslot(opresult5666);
  params[0] = call5657;
  partcv[0] = 1;
  Object opresult5667 = callmethod(opresult5666, "++", 1, partcv, params);
// compiled op node returning opresult5667 (depth = 7)
  int op_slot_left_5646 = gc_frame_newslot(opresult5667);
  params[0] = strlit5647;
  partcv[0] = 1;
  Object opresult5668 = callmethod(opresult5667, "++", 1, partcv, params);
// compiled op node returning opresult5668 (depth = 6)
  *var_s = opresult5668;
  if (opresult5668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5639 = done;
  } else {
  }
// compiled if node returning if5639 (depth = 4)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit5671 == NULL) {
    strlit5671 = alloc_String(" {");
    gc_root(strlit5671);
  }
// compiled string node returning strlit5671 (depth = 6)
  int op_slot_right_5670 = gc_frame_newslot(strlit5671);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_5670 = gc_frame_newslot(*var_s);
  params[0] = strlit5671;
  partcv[0] = 1;
  Object opresult5673 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5673 (depth = 5)
  *var_s = opresult5673;
  if (opresult5673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5675 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5676 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5677 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5676);
// compiled call node returning call5677 (depth = 6)
// compiled member node returning call5677 (depth = 5)
  gc_frame_newslot(call5677);
// starting to compile block node (depth = 5)
  Object block5678 = alloc_Block(NULL, NULL, "ast", 1226);
  gc_frame_newslot(block5678);
// method _apply
  block_savedest(block5678);
  Object closure5679 = createclosure(4, "_apply");
  setclosureframe(closure5679, stackframe);
  addtoclosure(closure5679, var_depth);
  addtoclosure(closure5679, var_spc);
  addtoclosure(closure5679, var_s);
  addtoclosure(closure5679, selfslot);
  struct UserObject *uo5679 = (struct UserObject*)block5678;
  uo5679->data[0] = (Object)closure5679;
  Method *meth_meth_ast__apply5679 = addmethod2pos(block5678, "_apply", &meth_ast__apply5679, 0);
  int argcv_meth_ast__apply5679[] = {1};
  meth_meth_ast__apply5679->type = alloc_MethodType(1, argcv_meth_ast__apply5679);
  meth_meth_ast__apply5679->definitionModule = modulename;
  meth_meth_ast__apply5679->definitionLine = 1226;
// compiled block node returning block5678 (depth = 5)
  gc_frame_newslot(block5678);
// call case 5: prelude request
  params[0] = call5677;
  params[1] = block5678;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5702 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5675);
// compiled call node returning call5702 (depth = 4)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit5704 == NULL) {
    strlit5704 = alloc_String("}");
    gc_root(strlit5704);
  }
// compiled string node returning strlit5704 (depth = 6)
  int op_slot_right_5703 = gc_frame_newslot(strlit5704);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5706 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5709 == NULL) {
    strlit5709 = alloc_String("""\x0a""");
    gc_root(strlit5709);
  }
// compiled string node returning strlit5709 (depth = 8)
  int op_slot_right_5708 = gc_frame_newslot(strlit5709);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5708 = gc_frame_newslot(*var_s);
  params[0] = strlit5709;
  partcv[0] = 1;
  Object opresult5711 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5711 (depth = 7)
  int op_slot_left_5706 = gc_frame_newslot(opresult5711);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5712 = callmethod(opresult5711, "++", 1, partcv, params);
// compiled op node returning opresult5712 (depth = 6)
  int op_slot_left_5703 = gc_frame_newslot(opresult5712);
  params[0] = strlit5704;
  partcv[0] = 1;
  Object opresult5713 = callmethod(opresult5712, "++", 1, partcv, params);
// compiled op node returning opresult5713 (depth = 5)
  *var_s = opresult5713;
  if (opresult5713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent5715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[6];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_classNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5716 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5717 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5718 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5719 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5718);
// compiled call node returning call5719 (depth = 7)
// compiled member node returning call5719 (depth = 6)
  gc_frame_newslot(call5719);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool5720 = alloc_Boolean(0);
// compiled identifier node returning bool5720 (depth = 6)
  gc_frame_newslot(bool5720);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
  Object bool5721 = alloc_Boolean(0);
// compiled identifier node returning bool5721 (depth = 6)
  gc_frame_newslot(bool5721);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_classNode (depth = 6)
  params[0] = call5719;
  params[1] = *var_emptySeq;
  params[2] = *var_emptySeq;
  params[3] = bool5720;
  params[4] = *var_nullNode;
  params[5] = bool5721;
  partcv[0] = 6;
  Object call5722 = callmethod(*var_classNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5717);
// compiled call node returning call5722 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5723 = callmethod(call5722, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe5716);
// compiled call node returning call5723 (depth = 4)
  gc_frame_end(frame);
  return call5723;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent5724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5725 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5726 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5725);
// compiled call node returning call5726 (depth = 4)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5727 = gc_frame_new();
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call5729 = callmethod(*var_other, "data",
    1, partcv, params);
  gc_frame_end(callframe5728);
// compiled call node returning call5729 (depth = 7)
// compiled member node returning call5729 (depth = 6)
  gc_frame_newslot(call5729);
// call case 4: self request
  params[0] = call5729;
  partcv[0] = 1;
  Object call5730 = callmethodflags(self, "data:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5727);
// compiled call node returning call5730 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new4741(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_classNode = getfromclosure(closure, 3);
  Object *var_symbolTableNode = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 6)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4742 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4742 = alloc_userobj2(37,29, objclass4742);
  gc_frame_newslot(obj4742);
if (objclass4742 == NULL) {
  glfree(obj4742->class->name);
  obj4742->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4742, self, 0);
  addmethodreal(obj4742,"outer", &reader_ast_outer_4743);
  Object oldself4742 = self;
  struct StackFrameObject *oldstackframe4742 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4742);
  gc_frame_newslot((Object)stackframe);
  self = obj4742;
  Object *oldselfslot4742 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4742 = (*(struct UserObject *)self).data[0], lowerouter4742 = thisouter4742;
  if (inheritingObject4742) {
    struct UserObject *inho4742 = (struct UserObject *)inheritingObject4742;
    while (inho4742->super != GraceDefaultObject) inho4742 = (struct UserObject *)inho4742->super;
    inho4742->super = obj4742;
    self = inheritingObject4742;
    *selfslot = self;
    lowerouter4742 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4742;
  }
if (objclass4742 == NULL) {
  Method *reader4744 = addmethodrealflags(obj4742, "kind",&reader_ast_kind_4744, MFLAG_DEF);
  reader4744->definitionModule = modulename;
  reader4744->definitionLine = 1080;
}
adddatum2(obj4742, alloc_Undefined(), 1);
if (objclass4742 == NULL) {
  Method *reader4745 = addmethodrealflags(obj4742, "value",&reader_ast_value_4745, 0);
  Method *writer4745 = addmethodrealflags(obj4742, "value:=",&writer_ast_value_4745, 0);
  reader4745->definitionModule = modulename;
  writer4745->definitionModule = modulename;
  reader4745->definitionLine = 1081;
  writer4745->definitionLine = 1081;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 2);
if (objclass4742 == NULL) {
  Method *reader4746 = addmethodrealflags(obj4742, "name",&reader_ast_name_4746, 0);
  Method *writer4746 = addmethodrealflags(obj4742, "name:=",&writer_ast_name_4746, 0);
  reader4746->definitionModule = modulename;
  writer4746->definitionModule = modulename;
  reader4746->definitionLine = 1082;
  writer4746->definitionLine = 1082;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 3);
if (objclass4742 == NULL) {
  Method *reader4747 = addmethodrealflags(obj4742, "constructor",&reader_ast_constructor_4747, 0);
  Method *writer4747 = addmethodrealflags(obj4742, "constructor:=",&writer_ast_constructor_4747, 0);
  reader4747->definitionModule = modulename;
  writer4747->definitionModule = modulename;
  reader4747->definitionLine = 1083;
  writer4747->definitionLine = 1083;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 4);
if (objclass4742 == NULL) {
  Method *reader4748 = addmethodrealflags(obj4742, "signature",&reader_ast_signature_4748, 0);
  Method *writer4748 = addmethodrealflags(obj4742, "signature:=",&writer_ast_signature_4748, 0);
  reader4748->definitionModule = modulename;
  writer4748->definitionModule = modulename;
  reader4748->definitionLine = 1084;
  writer4748->definitionLine = 1084;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 5);
if (objclass4742 == NULL) {
  Method *reader4749 = addmethodrealflags(obj4742, "dtype",&reader_ast_dtype_4749, 0);
  Method *writer4749 = addmethodrealflags(obj4742, "dtype:=",&writer_ast_dtype_4749, 0);
  reader4749->definitionModule = modulename;
  writer4749->definitionModule = modulename;
  reader4749->definitionLine = 1085;
  writer4749->definitionLine = 1085;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 6);
if (objclass4742 == NULL) {
  Method *reader4750 = addmethodrealflags(obj4742, "generics",&reader_ast_generics_4750, 0);
  Method *writer4750 = addmethodrealflags(obj4742, "generics:=",&writer_ast_generics_4750, 0);
  reader4750->definitionModule = modulename;
  writer4750->definitionModule = modulename;
  reader4750->definitionLine = 1086;
  writer4750->definitionLine = 1086;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 7);
if (objclass4742 == NULL) {
  Method *reader4751 = addmethodrealflags(obj4742, "superclass",&reader_ast_superclass_4751, 0);
  Method *writer4751 = addmethodrealflags(obj4742, "superclass:=",&writer_ast_superclass_4751, 0);
  reader4751->definitionModule = modulename;
  writer4751->definitionModule = modulename;
  reader4751->definitionLine = 1087;
  writer4751->definitionLine = 1087;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 8);
if (objclass4742 == NULL) {
  Method *reader4752 = addmethodrealflags(obj4742, "annotations",&reader_ast_annotations_4752, 0);
  Method *writer4752 = addmethodrealflags(obj4742, "annotations:=",&writer_ast_annotations_4752, 0);
  reader4752->definitionModule = modulename;
  writer4752->definitionModule = modulename;
  reader4752->definitionLine = 1088;
  writer4752->definitionLine = 1088;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 9);
if (objclass4742 == NULL) {
  Method *reader4753 = addmethodrealflags(obj4742, "nameString",&reader_ast_nameString_4753, MFLAG_DEF);
  reader4753->definitionModule = modulename;
  reader4753->definitionLine = 1090;
}
adddatum2(obj4742, alloc_Undefined(), 10);
if (objclass4742 == NULL) {
  Method *reader4754 = addmethodrealflags(obj4742, "data",&reader_ast_data_4754, 0);
  Method *writer4754 = addmethodrealflags(obj4742, "data:=",&writer_ast_data_4754, 0);
  reader4754->definitionModule = modulename;
  writer4754->definitionModule = modulename;
  reader4754->definitionLine = 1092;
  writer4754->definitionLine = 1092;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 11);
// method fullName
  struct UserObject *uo4755 = (struct UserObject*)obj4742;
  uo4755->data[12] = emptyclosure;
  Method *meth_meth_ast_fullName4755 = addmethod2pos(obj4742, "fullName", &meth_ast_fullName4755, 12);
  int argcv_meth_ast_fullName4755[] = {0};
  meth_meth_ast_fullName4755->type = alloc_MethodType(1, argcv_meth_ast_fullName4755);
  meth_meth_ast_fullName4755->definitionModule = modulename;
  meth_meth_ast_fullName4755->definitionLine = 1092;
// method declarationKind
  struct UserObject *uo4777 = (struct UserObject*)obj4742;
  uo4777->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKind4777 = addmethod2pos(obj4742, "declarationKind", &meth_ast_declarationKind4777, 13);
  int argcv_meth_ast_declarationKind4777[] = {0};
  meth_meth_ast_declarationKind4777->type = alloc_MethodType(1, argcv_meth_ast_declarationKind4777);
  meth_meth_ast_declarationKind4777->definitionModule = modulename;
  meth_meth_ast_declarationKind4777->definitionLine = 1093;
// method definesObject
  struct UserObject *uo4779 = (struct UserObject*)obj4742;
  uo4779->data[14] = emptyclosure;
  Method *meth_meth_ast_definesObject4779 = addmethod2pos(obj4742, "definesObject", &meth_ast_definesObject4779, 14);
  int argcv_meth_ast_definesObject4779[] = {0};
  meth_meth_ast_definesObject4779->type = alloc_MethodType(1, argcv_meth_ast_definesObject4779);
  meth_meth_ast_definesObject4779->definitionModule = modulename;
  meth_meth_ast_definesObject4779->definitionLine = 1096;
// method isClass
  struct UserObject *uo4781 = (struct UserObject*)obj4742;
  uo4781->data[15] = emptyclosure;
  Method *meth_meth_ast_isClass4781 = addmethod2pos(obj4742, "isClass", &meth_ast_isClass4781, 15);
  int argcv_meth_ast_isClass4781[] = {0};
  meth_meth_ast_isClass4781->type = alloc_MethodType(1, argcv_meth_ast_isClass4781);
  meth_meth_ast_isClass4781->definitionModule = modulename;
  meth_meth_ast_isClass4781->definitionLine = 1097;
// method isPublic
  struct UserObject *uo4783 = (struct UserObject*)obj4742;
  uo4783->data[16] = emptyclosure;
  Method *meth_meth_ast_isPublic4783 = addmethod2pos(obj4742, "isPublic", &meth_ast_isPublic4783, 16);
  int argcv_meth_ast_isPublic4783[] = {0};
  meth_meth_ast_isPublic4783->type = alloc_MethodType(1, argcv_meth_ast_isPublic4783);
  meth_meth_ast_isPublic4783->definitionModule = modulename;
  meth_meth_ast_isPublic4783->definitionLine = 1098;
// method isWritable
  struct UserObject *uo4803 = (struct UserObject*)obj4742;
  uo4803->data[17] = emptyclosure;
  Method *meth_meth_ast_isWritable4803 = addmethod2pos(obj4742, "isWritable", &meth_ast_isWritable4803, 17);
  int argcv_meth_ast_isWritable4803[] = {0};
  meth_meth_ast_isWritable4803->type = alloc_MethodType(1, argcv_meth_ast_isWritable4803);
  meth_meth_ast_isWritable4803->definitionModule = modulename;
  meth_meth_ast_isWritable4803->definitionLine = 1103;
// method isReadable
  struct UserObject *uo4805 = (struct UserObject*)obj4742;
  uo4805->data[18] = emptyclosure;
  Method *meth_meth_ast_isReadable4805 = addmethod2pos(obj4742, "isReadable", &meth_ast_isReadable4805, 18);
  int argcv_meth_ast_isReadable4805[] = {0};
  meth_meth_ast_isReadable4805->type = alloc_MethodType(1, argcv_meth_ast_isReadable4805);
  meth_meth_ast_isReadable4805->definitionModule = modulename;
  meth_meth_ast_isReadable4805->definitionLine = 1104;
// method usesAsType
  struct UserObject *uo4808 = (struct UserObject*)obj4742;
  uo4808->data[19] = emptyclosure;
  Method *meth_meth_ast_usesAsType4808 = addmethod2pos(obj4742, "usesAsType", &meth_ast_usesAsType4808, 19);
  int argcv_meth_ast_usesAsType4808[] = {1};
  meth_meth_ast_usesAsType4808->type = alloc_MethodType(1, argcv_meth_ast_usesAsType4808);
  meth_meth_ast_usesAsType4808->definitionModule = modulename;
  meth_meth_ast_usesAsType4808->definitionLine = 1105;
// method parametersDo
  struct UserObject *uo4814 = (struct UserObject*)obj4742;
  uo4814->data[20] = emptyclosure;
  Method *meth_meth_ast_parametersDo4814 = addmethod2pos(obj4742, "parametersDo", &meth_ast_parametersDo4814, 20);
  int argcv_meth_ast_parametersDo4814[] = {1};
  meth_meth_ast_parametersDo4814->type = alloc_MethodType(1, argcv_meth_ast_parametersDo4814);
  meth_meth_ast_parametersDo4814->definitionModule = modulename;
  meth_meth_ast_parametersDo4814->definitionLine = 1108;
// method typeParametersDo
  struct UserObject *uo4831 = (struct UserObject*)obj4742;
  uo4831->data[21] = emptyclosure;
  Method *meth_meth_ast_typeParametersDo4831 = addmethod2pos(obj4742, "typeParametersDo", &meth_ast_typeParametersDo4831, 21);
  int argcv_meth_ast_typeParametersDo4831[] = {1};
  meth_meth_ast_typeParametersDo4831->type = alloc_MethodType(1, argcv_meth_ast_typeParametersDo4831);
  meth_meth_ast_typeParametersDo4831->definitionModule = modulename;
  meth_meth_ast_typeParametersDo4831->definitionLine = 1113;
// method accept()from
  struct UserObject *uo4848 = (struct UserObject*)obj4742;
  uo4848->data[22] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4848 = addmethod2pos(obj4742, "accept()from", &meth_ast_accept_40__41_from4848, 22);
  int argcv_meth_ast_accept_40__41_from4848[] = {1, 1};
  meth_meth_ast_accept_40__41_from4848->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4848);
  meth_meth_ast_accept_40__41_from4848->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4848->definitionLine = 1118;
// method map()parent
  struct UserObject *uo4889 = (struct UserObject*)obj4742;
  uo4889->data[23] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent4889 = addmethod2pos(obj4742, "map()parent", &meth_ast_map_40__41_parent4889, 23);
  int argcv_meth_ast_map_40__41_parent4889[] = {1, 1};
  meth_meth_ast_map_40__41_parent4889->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent4889);
  meth_meth_ast_map_40__41_parent4889->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent4889->definitionLine = 1133;
// method pretty
  block_savedest(obj4742);
  Object closure4967 = createclosure(1, "pretty");
  setclosureframe(closure4967, stackframe);
  addtoclosure(closure4967, var_util);
  struct UserObject *uo4967 = (struct UserObject*)obj4742;
  uo4967->data[24] = (Object)closure4967;
  Method *meth_meth_ast_pretty4967 = addmethod2pos(obj4742, "pretty", &meth_ast_pretty4967, 24);
  int argcv_meth_ast_pretty4967[] = {1};
  meth_meth_ast_pretty4967->type = alloc_MethodType(1, argcv_meth_ast_pretty4967);
  meth_meth_ast_pretty4967->definitionModule = modulename;
  meth_meth_ast_pretty4967->definitionLine = 1146;
// method toGrace
  struct UserObject *uo5488 = (struct UserObject*)obj4742;
  uo5488->data[25] = emptyclosure;
  Method *meth_meth_ast_toGrace5488 = addmethod2pos(obj4742, "toGrace", &meth_ast_toGrace5488, 25);
  int argcv_meth_ast_toGrace5488[] = {1};
  meth_meth_ast_toGrace5488->type = alloc_MethodType(1, argcv_meth_ast_toGrace5488);
meth_meth_ast_toGrace5488->type->types[0] = type_Number;
meth_meth_ast_toGrace5488->type->names[0] = "depth";
  meth_meth_ast_toGrace5488->definitionModule = modulename;
  meth_meth_ast_toGrace5488->definitionLine = 1195;
// method shallowCopyWithParent
  block_savedest(obj4742);
  Object closure5715 = createclosure(3, "shallowCopyWithParent");
  setclosureframe(closure5715, stackframe);
  addtoclosure(closure5715, var_emptySeq);
  addtoclosure(closure5715, var_nullNode);
  addtoclosure(closure5715, var_classNode);
  struct UserObject *uo5715 = (struct UserObject*)obj4742;
  uo5715->data[26] = (Object)closure5715;
  Method *meth_meth_ast_shallowCopyWithParent5715 = addmethod2pos(obj4742, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent5715, 26);
  int argcv_meth_ast_shallowCopyWithParent5715[] = {1};
  meth_meth_ast_shallowCopyWithParent5715->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent5715);
  meth_meth_ast_shallowCopyWithParent5715->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent5715->definitionLine = 1232;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo5724 = (struct UserObject*)obj4742;
  uo5724->data[27] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724 = addmethod2pos(obj4742, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent5724, 27);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent5724[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent5724);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724->definitionLine = 1236;
  sourceObject = obj4742;
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5731 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5732 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5731);
// compiled call node returning call5732 (depth = 4)
  struct UserObject *obj4742_uo = (struct UserObject *)obj4742;
  obj4742_uo->super = call5732;
  sourceObject = obj4742;
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5733 == NULL) {
    strlit5733 = alloc_String("class");
    gc_root(strlit5733);
  }
// compiled string node returning strlit5733 (depth = 4)
  adddatum2(obj4742, strlit5733, 1);
  sourceObject = obj4742;
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj4742, *var_body_39_, 2);
  sourceObject = obj4742;
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj4742, *var_name_39_, 3);
  sourceObject = obj4742;
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_constructor_39_ (depth = 4)
  adddatum2(obj4742, *var_constructor_39_, 4);
  sourceObject = obj4742;
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj4742, *var_signature_39_, 5);
  sourceObject = obj4742;
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj4742, *var_dtype_39_, 6);
  sourceObject = obj4742;
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5734 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5735 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5736 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5735);
// compiled call node returning call5736 (depth = 7)
// compiled member node returning call5736 (depth = 6)
  partcv[0] = 0;
  Object call5737 = callmethod(call5736, "empty",
    1, partcv, params);
  gc_frame_end(callframe5734);
// compiled call node returning call5737 (depth = 5)
// compiled member node returning call5737 (depth = 4)
  adddatum2(obj4742, call5737, 7);
  sourceObject = obj4742;
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superclass_39_ (depth = 4)
  adddatum2(obj4742, *var_superclass_39_, 8);
  sourceObject = obj4742;
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5738 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5739 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5740 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5739);
// compiled call node returning call5740 (depth = 7)
// compiled member node returning call5740 (depth = 6)
  partcv[0] = 0;
  Object call5741 = callmethod(call5740, "empty",
    1, partcv, params);
  gc_frame_end(callframe5738);
// compiled call node returning call5741 (depth = 5)
// compiled member node returning call5741 (depth = 4)
  adddatum2(obj4742, call5741, 9);
  sourceObject = obj4742;
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5742 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5744 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5743);
// compiled call node returning call5744 (depth = 7)
// compiled member node returning call5744 (depth = 6)
  partcv[0] = 0;
  Object call5745 = callmethod(call5744, "value",
    1, partcv, params);
  gc_frame_end(callframe5742);
// compiled call node returning call5745 (depth = 5)
// compiled member node returning call5745 (depth = 4)
  adddatum2(obj4742, call5745, 10);
  sourceObject = obj4742;
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5746 = alloc_Boolean(0);
// compiled identifier node returning bool5746 (depth = 4)
  adddatum2(obj4742, bool5746, 11);
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
objclass4742 = obj4742->class;
  objclass4742->definitionModule = modulename;
  objclass4742->definitionLine = 1061;
  (*(struct UserObject *)self).data[0] = lowerouter4742;
  self = oldself4742;
  selfslot = oldselfslot4742;
  stackframe = oldstackframe4742;
  gc_frame_end(frame);
  return obj4742;
}
Object meth_ast_new4741_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_emptySeq = getfromclosure(closure, 1);
  Object *var_nullNode = getfromclosure(closure, 2);
  Object *var_classNode = getfromclosure(closure, 3);
  Object *var_symbolTableNode = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 6)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4742 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4742 = alloc_userobj2(37,29, objclass4742);
  gc_frame_newslot(obj4742);
if (objclass4742 == NULL) {
  glfree(obj4742->class->name);
  obj4742->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4742, self, 0);
  addmethodreal(obj4742,"outer", &reader_ast_outer_4743);
  Object oldself4742 = self;
  struct StackFrameObject *oldstackframe4742 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4742);
  gc_frame_newslot((Object)stackframe);
  self = obj4742;
  Object *oldselfslot4742 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4742 = (*(struct UserObject *)self).data[0], lowerouter4742 = thisouter4742;
  if (inheritingObject4742) {
    struct UserObject *inho4742 = (struct UserObject *)inheritingObject4742;
    while (inho4742->super != GraceDefaultObject) inho4742 = (struct UserObject *)inho4742->super;
    inho4742->super = obj4742;
    self = inheritingObject4742;
    *selfslot = self;
    lowerouter4742 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4742;
  }
if (objclass4742 == NULL) {
  Method *reader4744 = addmethodrealflags(obj4742, "kind",&reader_ast_kind_4744, MFLAG_DEF);
  reader4744->definitionModule = modulename;
  reader4744->definitionLine = 1080;
}
adddatum2(obj4742, alloc_Undefined(), 1);
if (objclass4742 == NULL) {
  Method *reader4745 = addmethodrealflags(obj4742, "value",&reader_ast_value_4745, 0);
  Method *writer4745 = addmethodrealflags(obj4742, "value:=",&writer_ast_value_4745, 0);
  reader4745->definitionModule = modulename;
  writer4745->definitionModule = modulename;
  reader4745->definitionLine = 1081;
  writer4745->definitionLine = 1081;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 2);
if (objclass4742 == NULL) {
  Method *reader4746 = addmethodrealflags(obj4742, "name",&reader_ast_name_4746, 0);
  Method *writer4746 = addmethodrealflags(obj4742, "name:=",&writer_ast_name_4746, 0);
  reader4746->definitionModule = modulename;
  writer4746->definitionModule = modulename;
  reader4746->definitionLine = 1082;
  writer4746->definitionLine = 1082;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 3);
if (objclass4742 == NULL) {
  Method *reader4747 = addmethodrealflags(obj4742, "constructor",&reader_ast_constructor_4747, 0);
  Method *writer4747 = addmethodrealflags(obj4742, "constructor:=",&writer_ast_constructor_4747, 0);
  reader4747->definitionModule = modulename;
  writer4747->definitionModule = modulename;
  reader4747->definitionLine = 1083;
  writer4747->definitionLine = 1083;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 4);
if (objclass4742 == NULL) {
  Method *reader4748 = addmethodrealflags(obj4742, "signature",&reader_ast_signature_4748, 0);
  Method *writer4748 = addmethodrealflags(obj4742, "signature:=",&writer_ast_signature_4748, 0);
  reader4748->definitionModule = modulename;
  writer4748->definitionModule = modulename;
  reader4748->definitionLine = 1084;
  writer4748->definitionLine = 1084;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 5);
if (objclass4742 == NULL) {
  Method *reader4749 = addmethodrealflags(obj4742, "dtype",&reader_ast_dtype_4749, 0);
  Method *writer4749 = addmethodrealflags(obj4742, "dtype:=",&writer_ast_dtype_4749, 0);
  reader4749->definitionModule = modulename;
  writer4749->definitionModule = modulename;
  reader4749->definitionLine = 1085;
  writer4749->definitionLine = 1085;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 6);
if (objclass4742 == NULL) {
  Method *reader4750 = addmethodrealflags(obj4742, "generics",&reader_ast_generics_4750, 0);
  Method *writer4750 = addmethodrealflags(obj4742, "generics:=",&writer_ast_generics_4750, 0);
  reader4750->definitionModule = modulename;
  writer4750->definitionModule = modulename;
  reader4750->definitionLine = 1086;
  writer4750->definitionLine = 1086;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 7);
if (objclass4742 == NULL) {
  Method *reader4751 = addmethodrealflags(obj4742, "superclass",&reader_ast_superclass_4751, 0);
  Method *writer4751 = addmethodrealflags(obj4742, "superclass:=",&writer_ast_superclass_4751, 0);
  reader4751->definitionModule = modulename;
  writer4751->definitionModule = modulename;
  reader4751->definitionLine = 1087;
  writer4751->definitionLine = 1087;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 8);
if (objclass4742 == NULL) {
  Method *reader4752 = addmethodrealflags(obj4742, "annotations",&reader_ast_annotations_4752, 0);
  Method *writer4752 = addmethodrealflags(obj4742, "annotations:=",&writer_ast_annotations_4752, 0);
  reader4752->definitionModule = modulename;
  writer4752->definitionModule = modulename;
  reader4752->definitionLine = 1088;
  writer4752->definitionLine = 1088;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 9);
if (objclass4742 == NULL) {
  Method *reader4753 = addmethodrealflags(obj4742, "nameString",&reader_ast_nameString_4753, MFLAG_DEF);
  reader4753->definitionModule = modulename;
  reader4753->definitionLine = 1090;
}
adddatum2(obj4742, alloc_Undefined(), 10);
if (objclass4742 == NULL) {
  Method *reader4754 = addmethodrealflags(obj4742, "data",&reader_ast_data_4754, 0);
  Method *writer4754 = addmethodrealflags(obj4742, "data:=",&writer_ast_data_4754, 0);
  reader4754->definitionModule = modulename;
  writer4754->definitionModule = modulename;
  reader4754->definitionLine = 1092;
  writer4754->definitionLine = 1092;
}
obj4742->flags |= OFLAG_MUTABLE;
adddatum2(obj4742, alloc_Undefined(), 11);
// method fullName
  struct UserObject *uo4755 = (struct UserObject*)obj4742;
  uo4755->data[12] = emptyclosure;
  Method *meth_meth_ast_fullName4755 = addmethod2pos(obj4742, "fullName", &meth_ast_fullName4755, 12);
  int argcv_meth_ast_fullName4755[] = {0};
  meth_meth_ast_fullName4755->type = alloc_MethodType(1, argcv_meth_ast_fullName4755);
  meth_meth_ast_fullName4755->definitionModule = modulename;
  meth_meth_ast_fullName4755->definitionLine = 1092;
// method declarationKind
  struct UserObject *uo4777 = (struct UserObject*)obj4742;
  uo4777->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKind4777 = addmethod2pos(obj4742, "declarationKind", &meth_ast_declarationKind4777, 13);
  int argcv_meth_ast_declarationKind4777[] = {0};
  meth_meth_ast_declarationKind4777->type = alloc_MethodType(1, argcv_meth_ast_declarationKind4777);
  meth_meth_ast_declarationKind4777->definitionModule = modulename;
  meth_meth_ast_declarationKind4777->definitionLine = 1093;
// method definesObject
  struct UserObject *uo4779 = (struct UserObject*)obj4742;
  uo4779->data[14] = emptyclosure;
  Method *meth_meth_ast_definesObject4779 = addmethod2pos(obj4742, "definesObject", &meth_ast_definesObject4779, 14);
  int argcv_meth_ast_definesObject4779[] = {0};
  meth_meth_ast_definesObject4779->type = alloc_MethodType(1, argcv_meth_ast_definesObject4779);
  meth_meth_ast_definesObject4779->definitionModule = modulename;
  meth_meth_ast_definesObject4779->definitionLine = 1096;
// method isClass
  struct UserObject *uo4781 = (struct UserObject*)obj4742;
  uo4781->data[15] = emptyclosure;
  Method *meth_meth_ast_isClass4781 = addmethod2pos(obj4742, "isClass", &meth_ast_isClass4781, 15);
  int argcv_meth_ast_isClass4781[] = {0};
  meth_meth_ast_isClass4781->type = alloc_MethodType(1, argcv_meth_ast_isClass4781);
  meth_meth_ast_isClass4781->definitionModule = modulename;
  meth_meth_ast_isClass4781->definitionLine = 1097;
// method isPublic
  struct UserObject *uo4783 = (struct UserObject*)obj4742;
  uo4783->data[16] = emptyclosure;
  Method *meth_meth_ast_isPublic4783 = addmethod2pos(obj4742, "isPublic", &meth_ast_isPublic4783, 16);
  int argcv_meth_ast_isPublic4783[] = {0};
  meth_meth_ast_isPublic4783->type = alloc_MethodType(1, argcv_meth_ast_isPublic4783);
  meth_meth_ast_isPublic4783->definitionModule = modulename;
  meth_meth_ast_isPublic4783->definitionLine = 1098;
// method isWritable
  struct UserObject *uo4803 = (struct UserObject*)obj4742;
  uo4803->data[17] = emptyclosure;
  Method *meth_meth_ast_isWritable4803 = addmethod2pos(obj4742, "isWritable", &meth_ast_isWritable4803, 17);
  int argcv_meth_ast_isWritable4803[] = {0};
  meth_meth_ast_isWritable4803->type = alloc_MethodType(1, argcv_meth_ast_isWritable4803);
  meth_meth_ast_isWritable4803->definitionModule = modulename;
  meth_meth_ast_isWritable4803->definitionLine = 1103;
// method isReadable
  struct UserObject *uo4805 = (struct UserObject*)obj4742;
  uo4805->data[18] = emptyclosure;
  Method *meth_meth_ast_isReadable4805 = addmethod2pos(obj4742, "isReadable", &meth_ast_isReadable4805, 18);
  int argcv_meth_ast_isReadable4805[] = {0};
  meth_meth_ast_isReadable4805->type = alloc_MethodType(1, argcv_meth_ast_isReadable4805);
  meth_meth_ast_isReadable4805->definitionModule = modulename;
  meth_meth_ast_isReadable4805->definitionLine = 1104;
// method usesAsType
  struct UserObject *uo4808 = (struct UserObject*)obj4742;
  uo4808->data[19] = emptyclosure;
  Method *meth_meth_ast_usesAsType4808 = addmethod2pos(obj4742, "usesAsType", &meth_ast_usesAsType4808, 19);
  int argcv_meth_ast_usesAsType4808[] = {1};
  meth_meth_ast_usesAsType4808->type = alloc_MethodType(1, argcv_meth_ast_usesAsType4808);
  meth_meth_ast_usesAsType4808->definitionModule = modulename;
  meth_meth_ast_usesAsType4808->definitionLine = 1105;
// method parametersDo
  struct UserObject *uo4814 = (struct UserObject*)obj4742;
  uo4814->data[20] = emptyclosure;
  Method *meth_meth_ast_parametersDo4814 = addmethod2pos(obj4742, "parametersDo", &meth_ast_parametersDo4814, 20);
  int argcv_meth_ast_parametersDo4814[] = {1};
  meth_meth_ast_parametersDo4814->type = alloc_MethodType(1, argcv_meth_ast_parametersDo4814);
  meth_meth_ast_parametersDo4814->definitionModule = modulename;
  meth_meth_ast_parametersDo4814->definitionLine = 1108;
// method typeParametersDo
  struct UserObject *uo4831 = (struct UserObject*)obj4742;
  uo4831->data[21] = emptyclosure;
  Method *meth_meth_ast_typeParametersDo4831 = addmethod2pos(obj4742, "typeParametersDo", &meth_ast_typeParametersDo4831, 21);
  int argcv_meth_ast_typeParametersDo4831[] = {1};
  meth_meth_ast_typeParametersDo4831->type = alloc_MethodType(1, argcv_meth_ast_typeParametersDo4831);
  meth_meth_ast_typeParametersDo4831->definitionModule = modulename;
  meth_meth_ast_typeParametersDo4831->definitionLine = 1113;
// method accept()from
  struct UserObject *uo4848 = (struct UserObject*)obj4742;
  uo4848->data[22] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from4848 = addmethod2pos(obj4742, "accept()from", &meth_ast_accept_40__41_from4848, 22);
  int argcv_meth_ast_accept_40__41_from4848[] = {1, 1};
  meth_meth_ast_accept_40__41_from4848->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from4848);
  meth_meth_ast_accept_40__41_from4848->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from4848->definitionLine = 1118;
// method map()parent
  struct UserObject *uo4889 = (struct UserObject*)obj4742;
  uo4889->data[23] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent4889 = addmethod2pos(obj4742, "map()parent", &meth_ast_map_40__41_parent4889, 23);
  int argcv_meth_ast_map_40__41_parent4889[] = {1, 1};
  meth_meth_ast_map_40__41_parent4889->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent4889);
  meth_meth_ast_map_40__41_parent4889->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent4889->definitionLine = 1133;
// method pretty
  block_savedest(obj4742);
  Object closure4967 = createclosure(1, "pretty");
  setclosureframe(closure4967, stackframe);
  addtoclosure(closure4967, var_util);
  struct UserObject *uo4967 = (struct UserObject*)obj4742;
  uo4967->data[24] = (Object)closure4967;
  Method *meth_meth_ast_pretty4967 = addmethod2pos(obj4742, "pretty", &meth_ast_pretty4967, 24);
  int argcv_meth_ast_pretty4967[] = {1};
  meth_meth_ast_pretty4967->type = alloc_MethodType(1, argcv_meth_ast_pretty4967);
  meth_meth_ast_pretty4967->definitionModule = modulename;
  meth_meth_ast_pretty4967->definitionLine = 1146;
// method toGrace
  struct UserObject *uo5488 = (struct UserObject*)obj4742;
  uo5488->data[25] = emptyclosure;
  Method *meth_meth_ast_toGrace5488 = addmethod2pos(obj4742, "toGrace", &meth_ast_toGrace5488, 25);
  int argcv_meth_ast_toGrace5488[] = {1};
  meth_meth_ast_toGrace5488->type = alloc_MethodType(1, argcv_meth_ast_toGrace5488);
meth_meth_ast_toGrace5488->type->types[0] = type_Number;
meth_meth_ast_toGrace5488->type->names[0] = "depth";
  meth_meth_ast_toGrace5488->definitionModule = modulename;
  meth_meth_ast_toGrace5488->definitionLine = 1195;
// method shallowCopyWithParent
  block_savedest(obj4742);
  Object closure5715 = createclosure(3, "shallowCopyWithParent");
  setclosureframe(closure5715, stackframe);
  addtoclosure(closure5715, var_emptySeq);
  addtoclosure(closure5715, var_nullNode);
  addtoclosure(closure5715, var_classNode);
  struct UserObject *uo5715 = (struct UserObject*)obj4742;
  uo5715->data[26] = (Object)closure5715;
  Method *meth_meth_ast_shallowCopyWithParent5715 = addmethod2pos(obj4742, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent5715, 26);
  int argcv_meth_ast_shallowCopyWithParent5715[] = {1};
  meth_meth_ast_shallowCopyWithParent5715->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent5715);
  meth_meth_ast_shallowCopyWithParent5715->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent5715->definitionLine = 1232;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo5724 = (struct UserObject*)obj4742;
  uo5724->data[27] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724 = addmethod2pos(obj4742, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent5724, 27);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent5724[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent5724);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent5724->definitionLine = 1236;
  sourceObject = obj4742;
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5731 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5732 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5731);
// compiled call node returning call5732 (depth = 4)
  struct UserObject *obj4742_uo = (struct UserObject *)obj4742;
  obj4742_uo->super = call5732;
  sourceObject = obj4742;
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit5733 == NULL) {
    strlit5733 = alloc_String("class");
    gc_root(strlit5733);
  }
// compiled string node returning strlit5733 (depth = 4)
  adddatum2(obj4742, strlit5733, 1);
  sourceObject = obj4742;
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body_39_ (depth = 4)
  adddatum2(obj4742, *var_body_39_, 2);
  sourceObject = obj4742;
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj4742, *var_name_39_, 3);
  sourceObject = obj4742;
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_constructor_39_ (depth = 4)
  adddatum2(obj4742, *var_constructor_39_, 4);
  sourceObject = obj4742;
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature_39_ (depth = 4)
  adddatum2(obj4742, *var_signature_39_, 5);
  sourceObject = obj4742;
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj4742, *var_dtype_39_, 6);
  sourceObject = obj4742;
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5734 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5735 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5736 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5735);
// compiled call node returning call5736 (depth = 7)
// compiled member node returning call5736 (depth = 6)
  partcv[0] = 0;
  Object call5737 = callmethod(call5736, "empty",
    1, partcv, params);
  gc_frame_end(callframe5734);
// compiled call node returning call5737 (depth = 5)
// compiled member node returning call5737 (depth = 4)
  adddatum2(obj4742, call5737, 7);
  sourceObject = obj4742;
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superclass_39_ (depth = 4)
  adddatum2(obj4742, *var_superclass_39_, 8);
  sourceObject = obj4742;
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5738 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5739 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5740 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5739);
// compiled call node returning call5740 (depth = 7)
// compiled member node returning call5740 (depth = 6)
  partcv[0] = 0;
  Object call5741 = callmethod(call5740, "empty",
    1, partcv, params);
  gc_frame_end(callframe5738);
// compiled call node returning call5741 (depth = 5)
// compiled member node returning call5741 (depth = 4)
  adddatum2(obj4742, call5741, 9);
  sourceObject = obj4742;
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5742 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5743 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5744 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5743);
// compiled call node returning call5744 (depth = 7)
// compiled member node returning call5744 (depth = 6)
  partcv[0] = 0;
  Object call5745 = callmethod(call5744, "value",
    1, partcv, params);
  gc_frame_end(callframe5742);
// compiled call node returning call5745 (depth = 5)
// compiled member node returning call5745 (depth = 4)
  adddatum2(obj4742, call5745, 10);
  sourceObject = obj4742;
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5746 = alloc_Boolean(0);
// compiled identifier node returning bool5746 (depth = 4)
  adddatum2(obj4742, bool5746, 11);
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
  sourceObject = obj4742;
objclass4742 = obj4742->class;
  objclass4742->definitionModule = modulename;
  objclass4742->definitionLine = 1061;
  (*(struct UserObject *)self).data[0] = lowerouter4742;
  self = oldself4742;
  selfslot = oldselfslot4742;
  stackframe = oldstackframe4742;
  gc_frame_end(frame);
  return obj4742;
}
Object meth_ast_objectNode5748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for objectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for objectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_objectNode (depth = 3)
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast_fullName5759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fullName");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fullName (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for fullName");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5762 == NULL) {
    strlit5762 = alloc_String("object");
    gc_root(strlit5762);
  }
// compiled string node returning strlit5762 (depth = 6)
  int op_slot_right_5761 = gc_frame_newslot(strlit5762);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5764 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5765 = callmethodflags(self, "classname", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5764);
// compiled call node returning call5765 (depth = 7)
// compiled member node returning call5765 (depth = 6)
  int op_slot_left_5761 = gc_frame_newslot(call5765);
  params[0] = strlit5762;
  partcv[0] = 1;
  Object opresult5766 = callmethod(call5765, "!=", 1, partcv, params);
// compiled op node returning opresult5766 (depth = 5)
  Object if5760 = done;
  if (istrue(opresult5766)) {
// starting to compile return node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5767 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5768 = callmethodflags(self, "classname", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5767);
// compiled call node returning call5768 (depth = 7)
// compiled member node returning call5768 (depth = 6)
  return call5768;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5760 = undefined;
  } else {
  }
// compiled if node returning if5760 (depth = 4)
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5771 == NULL) {
    strlit5771 = alloc_String("defdec");
    gc_root(strlit5771);
  }
// compiled string node returning strlit5771 (depth = 6)
  int op_slot_right_5770 = gc_frame_newslot(strlit5771);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5773 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5775 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5774);
// compiled call node returning call5775 (depth = 9)
// compiled member node returning call5775 (depth = 8)
  partcv[0] = 0;
  Object call5776 = callmethod(call5775, "kind",
    1, partcv, params);
  gc_frame_end(callframe5773);
// compiled call node returning call5776 (depth = 7)
// compiled member node returning call5776 (depth = 6)
  int op_slot_left_5770 = gc_frame_newslot(call5776);
  params[0] = strlit5771;
  partcv[0] = 1;
  Object opresult5777 = callmethod(call5776, "==", 1, partcv, params);
// compiled op node returning opresult5777 (depth = 5)
  Object if5769 = done;
  if (istrue(opresult5777)) {
// starting to compile return node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5778 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5780 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5779);
// compiled call node returning call5780 (depth = 9)
// compiled member node returning call5780 (depth = 8)
  partcv[0] = 0;
  Object call5781 = callmethod(call5780, "nameString",
    1, partcv, params);
  gc_frame_end(callframe5778);
// compiled call node returning call5781 (depth = 7)
// compiled member node returning call5781 (depth = 6)
  return call5781;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5769 = undefined;
  } else {
  }
// compiled if node returning if5769 (depth = 4)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5783 = callmethodflags(self, "classname", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5782);
// compiled call node returning call5783 (depth = 6)
// compiled member node returning call5783 (depth = 5)
  return call5783;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_definesObject5784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5785 = alloc_Boolean(1);
// compiled identifier node returning bool5785 (depth = 4)
  gc_frame_end(frame);
  return bool5785;
}
Object meth_ast_isObject5786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5787 = alloc_Boolean(1);
// compiled identifier node returning bool5787 (depth = 4)
  gc_frame_end(frame);
  return bool5787;
}
Object meth_ast__apply5807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5808 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_x (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5809 = callmethod(*var_x, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5808);
// compiled call node returning call5809 (depth = 7)
  gc_frame_end(frame);
  return call5809;
}
Object meth_ast_accept_40__41_from5788(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5790 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5791 = callmethod(*var_visitor, "visitObject()up",
    2, partcv, params);
  gc_frame_end(callframe5790);
// compiled call node returning call5791 (depth = 5)
  Object if5789 = done;
  if (istrue(call5791)) {
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5794 = alloc_Boolean(0);
// compiled identifier node returning bool5794 (depth = 7)
  int op_slot_right_5793 = gc_frame_newslot(bool5794);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5797 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5796);
// compiled call node returning call5797 (depth = 8)
// compiled member node returning call5797 (depth = 7)
  int op_slot_left_5793 = gc_frame_newslot(call5797);
  params[0] = bool5794;
  partcv[0] = 1;
  Object opresult5798 = callmethod(call5797, "!=", 1, partcv, params);
// compiled op node returning opresult5798 (depth = 6)
  Object if5792 = done;
  if (istrue(opresult5798)) {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5799 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5801 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5800);
// compiled call node returning call5801 (depth = 8)
// compiled member node returning call5801 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5802 = callmethod(call5801, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe5799);
// compiled call node returning call5802 (depth = 6)
    gc_frame_newslot(call5802);
    if5792 = call5802;
  } else {
  }
// compiled if node returning if5792 (depth = 5)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5803 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5804 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5805 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5804);
// compiled call node returning call5805 (depth = 7)
// compiled member node returning call5805 (depth = 6)
  gc_frame_newslot(call5805);
// starting to compile block node (depth = 6)
  Object block5806 = alloc_Block(NULL, NULL, "ast", 1263);
  gc_frame_newslot(block5806);
// method _apply
  block_savedest(block5806);
  Object closure5807 = createclosure(2, "_apply");
  setclosureframe(closure5807, stackframe);
  addtoclosure(closure5807, var_visitor);
  addtoclosure(closure5807, selfslot);
  struct UserObject *uo5807 = (struct UserObject*)block5806;
  uo5807->data[0] = (Object)closure5807;
  Method *meth_meth_ast__apply5807 = addmethod2pos(block5806, "_apply", &meth_ast__apply5807, 0);
  int argcv_meth_ast__apply5807[] = {1};
  meth_meth_ast__apply5807->type = alloc_MethodType(1, argcv_meth_ast__apply5807);
  meth_meth_ast__apply5807->definitionModule = modulename;
  meth_meth_ast__apply5807->definitionLine = 1263;
// compiled block node returning block5806 (depth = 6)
  gc_frame_newslot(block5806);
// call case 5: prelude request
  params[0] = call5805;
  params[1] = block5806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5811 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5803);
// compiled call node returning call5811 (depth = 5)
    gc_frame_newslot(call5811);
    if5789 = call5811;
  } else {
  }
// compiled if node returning if5789 (depth = 4)
  gc_frame_end(frame);
  return if5789;
}
Object meth_ast_map_40__41_parent5812(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5813 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call5814 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5813);
// compiled call node returning call5814 (depth = 5)
  *var_n = call5814;
  if (call5814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5815 = gc_frame_new();
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5816 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5817 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5818 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5817);
// compiled call node returning call5818 (depth = 8)
// compiled member node returning call5818 (depth = 7)
  gc_frame_newslot(call5818);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5819 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5820 = gc_frame_new();
// call case 3: self.outer request
  Object call5821 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5820);
// compiled call node returning call5821 (depth = 10)
// compiled member node returning call5821 (depth = 9)
  partcv[0] = 0;
  Object call5822 = callmethodflags(call5821, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5819);
// compiled call node returning call5822 (depth = 8)
// compiled member node returning call5822 (depth = 7)
  params[0] = call5818;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5823 = callmethodflags(call5822, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5816);
// compiled call node returning call5823 (depth = 6)
  gc_frame_newslot(call5823);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5823;
  partcv[0] = 1;
  Object call5824 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe5815);
// compiled call node returning call5824 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5825 = gc_frame_new();
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5826 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5828 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5827);
// compiled call node returning call5828 (depth = 8)
// compiled member node returning call5828 (depth = 7)
  gc_frame_newslot(call5828);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5829 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5830 = gc_frame_new();
// call case 3: self.outer request
  Object call5831 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5830);
// compiled call node returning call5831 (depth = 10)
// compiled member node returning call5831 (depth = 9)
  partcv[0] = 0;
  Object call5832 = callmethodflags(call5831, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5829);
// compiled call node returning call5832 (depth = 8)
// compiled member node returning call5832 (depth = 7)
  params[0] = call5828;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call5833 = callmethodflags(call5832, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5826);
// compiled call node returning call5833 (depth = 6)
  gc_frame_newslot(call5833);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call5833;
  partcv[0] = 1;
  Object call5834 = callmethod(*var_n, "superclass:=",
    1, partcv, params);
  gc_frame_end(callframe5825);
// compiled call node returning call5834 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5835 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5836 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5835);
// compiled call node returning call5836 (depth = 5)
  *var_n = call5836;
  if (call5836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit5848 == NULL) {
    strlit5848 = alloc_String("  ");
    gc_root(strlit5848);
  }
// compiled string node returning strlit5848 (depth = 8)
  int op_slot_right_5847 = gc_frame_newslot(strlit5848);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_5847 = gc_frame_newslot(*var_spc);
  params[0] = strlit5848;
  partcv[0] = 1;
  Object opresult5850 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5850 (depth = 7)
  *var_spc = opresult5850;
  if (opresult5850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5915(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5917 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5919 = alloc_Float64(1);
// compiled num node returning num5919 (depth = 10)
  int op_slot_right_5918 = gc_frame_newslot(num5919);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5918 = gc_frame_newslot(*var_depth);
  params[0] = num5919;
  partcv[0] = 1;
  Object sum5921 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5921 (depth = 9)
  gc_frame_newslot(sum5921);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  params[0] = sum5921;
  partcv[0] = 1;
  Object call5922 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5917);
// compiled call node returning call5922 (depth = 8)
  int op_slot_right_5916 = gc_frame_newslot(call5922);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_5924 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5927 == NULL) {
    strlit5927 = alloc_String("""\x0a""");
    gc_root(strlit5927);
  }
// compiled string node returning strlit5927 (depth = 10)
  int op_slot_right_5926 = gc_frame_newslot(strlit5927);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_5926 = gc_frame_newslot(*var_s);
  params[0] = strlit5927;
  partcv[0] = 1;
  Object opresult5929 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5929 (depth = 9)
  int op_slot_left_5924 = gc_frame_newslot(opresult5929);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5930 = callmethod(opresult5929, "++", 1, partcv, params);
// compiled op node returning opresult5930 (depth = 8)
  int op_slot_left_5916 = gc_frame_newslot(opresult5930);
  params[0] = call5922;
  partcv[0] = 1;
  Object opresult5931 = callmethod(opresult5930, "++", 1, partcv, params);
// compiled op node returning opresult5931 (depth = 7)
  *var_s = opresult5931;
  if (opresult5931 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_depth_39_ (depth = 5)
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit5839 == NULL) {
    strlit5839 = alloc_String("");
    gc_root(strlit5839);
  }
// compiled string node returning strlit5839 (depth = 5)
  *var_spc = strlit5839;
  if (strlit5839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5840 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_5841 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num5843 = alloc_Float64(0);
// compiled num node returning num5843 (depth = 6)
  int op_slot_left_5841 = gc_frame_newslot(num5843);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5844 = callmethod(num5843, "..", 1, partcv, params);
// compiled op node returning opresult5844 (depth = 5)
  gc_frame_newslot(opresult5844);
// starting to compile block node (depth = 5)
  Object block5845 = alloc_Block(NULL, NULL, "ast", 1278);
  gc_frame_newslot(block5845);
// method _apply
  block_savedest(block5845);
  Object closure5846 = createclosure(2, "_apply");
  setclosureframe(closure5846, stackframe);
  addtoclosure(closure5846, var_spc);
  addtoclosure(closure5846, selfslot);
  struct UserObject *uo5846 = (struct UserObject*)block5845;
  uo5846->data[0] = (Object)closure5846;
  Method *meth_meth_ast__apply5846 = addmethod2pos(block5845, "_apply", &meth_ast__apply5846, 0);
  int argcv_meth_ast__apply5846[] = {1};
  meth_meth_ast__apply5846->type = alloc_MethodType(1, argcv_meth_ast__apply5846);
  meth_meth_ast__apply5846->definitionModule = modulename;
  meth_meth_ast__apply5846->definitionLine = 1271;
// compiled block node returning block5845 (depth = 5)
  gc_frame_newslot(block5845);
// call case 5: prelude request
  params[0] = opresult5844;
  params[1] = block5845;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5853 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5840);
// compiled call node returning call5853 (depth = 4)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5854 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5855 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe5854);
// compiled call node returning call5855 (depth = 5)
  *var_s = call5855;
  if (call5855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5858 = alloc_Boolean(0);
// compiled identifier node returning bool5858 (depth = 6)
  int op_slot_right_5857 = gc_frame_newslot(bool5858);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5861 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5860);
// compiled call node returning call5861 (depth = 7)
// compiled member node returning call5861 (depth = 6)
  int op_slot_left_5857 = gc_frame_newslot(call5861);
  params[0] = bool5858;
  partcv[0] = 1;
  Object opresult5862 = callmethod(call5861, "!=", 1, partcv, params);
// compiled op node returning opresult5862 (depth = 5)
  Object if5856 = done;
  if (istrue(opresult5862)) {
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5864 == NULL) {
    strlit5864 = alloc_String("Superclass:");
    gc_root(strlit5864);
  }
// compiled string node returning strlit5864 (depth = 7)
  int op_slot_right_5863 = gc_frame_newslot(strlit5864);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5866 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5869 == NULL) {
    strlit5869 = alloc_String("""\x0a""");
    gc_root(strlit5869);
  }
// compiled string node returning strlit5869 (depth = 9)
  int op_slot_right_5868 = gc_frame_newslot(strlit5869);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5868 = gc_frame_newslot(*var_s);
  params[0] = strlit5869;
  partcv[0] = 1;
  Object opresult5871 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5871 (depth = 8)
  int op_slot_left_5866 = gc_frame_newslot(opresult5871);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5872 = callmethod(opresult5871, "++", 1, partcv, params);
// compiled op node returning opresult5872 (depth = 7)
  int op_slot_left_5863 = gc_frame_newslot(opresult5872);
  params[0] = strlit5864;
  partcv[0] = 1;
  Object opresult5873 = callmethod(opresult5872, "++", 1, partcv, params);
// compiled op node returning opresult5873 (depth = 6)
  *var_s = opresult5873;
  if (opresult5873 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5876 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num5878 = alloc_Float64(1);
// compiled num node returning num5878 (depth = 9)
  int op_slot_right_5877 = gc_frame_newslot(num5878);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_5877 = gc_frame_newslot(*var_depth);
  params[0] = num5878;
  partcv[0] = 1;
  Object sum5880 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5880 (depth = 8)
  gc_frame_newslot(sum5880);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5881 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5882 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5881);
// compiled call node returning call5882 (depth = 9)
// compiled member node returning call5882 (depth = 8)
  params[0] = sum5880;
  partcv[0] = 1;
  Object call5883 = callmethod(call5882, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5876);
// compiled call node returning call5883 (depth = 7)
  int op_slot_right_5875 = gc_frame_newslot(call5883);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5885 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5888 == NULL) {
    strlit5888 = alloc_String("""\x0a""  ");
    gc_root(strlit5888);
  }
// compiled string node returning strlit5888 (depth = 9)
  int op_slot_right_5887 = gc_frame_newslot(strlit5888);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5887 = gc_frame_newslot(*var_s);
  params[0] = strlit5888;
  partcv[0] = 1;
  Object opresult5890 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5890 (depth = 8)
  int op_slot_left_5885 = gc_frame_newslot(opresult5890);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5891 = callmethod(opresult5890, "++", 1, partcv, params);
// compiled op node returning opresult5891 (depth = 7)
  int op_slot_left_5875 = gc_frame_newslot(opresult5891);
  params[0] = call5883;
  partcv[0] = 1;
  Object opresult5892 = callmethod(opresult5891, "++", 1, partcv, params);
// compiled op node returning opresult5892 (depth = 6)
  *var_s = opresult5892;
  if (opresult5892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit5895 == NULL) {
    strlit5895 = alloc_String("Body:");
    gc_root(strlit5895);
  }
// compiled string node returning strlit5895 (depth = 7)
  int op_slot_right_5894 = gc_frame_newslot(strlit5895);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_5897 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5900 == NULL) {
    strlit5900 = alloc_String("""\x0a""");
    gc_root(strlit5900);
  }
// compiled string node returning strlit5900 (depth = 9)
  int op_slot_right_5899 = gc_frame_newslot(strlit5900);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_5899 = gc_frame_newslot(*var_s);
  params[0] = strlit5900;
  partcv[0] = 1;
  Object opresult5902 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5902 (depth = 8)
  int op_slot_left_5897 = gc_frame_newslot(opresult5902);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5903 = callmethod(opresult5902, "++", 1, partcv, params);
// compiled op node returning opresult5903 (depth = 7)
  int op_slot_left_5894 = gc_frame_newslot(opresult5903);
  params[0] = strlit5895;
  partcv[0] = 1;
  Object opresult5904 = callmethod(opresult5903, "++", 1, partcv, params);
// compiled op node returning opresult5904 (depth = 6)
  *var_s = opresult5904;
  if (opresult5904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num5907 = alloc_Float64(1);
// compiled num node returning num5907 (depth = 7)
  int op_slot_right_5906 = gc_frame_newslot(num5907);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_5906 = gc_frame_newslot(*var_depth);
  params[0] = num5907;
  partcv[0] = 1;
  Object sum5909 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5909 (depth = 6)
  *var_depth = sum5909;
  if (sum5909 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5856 = done;
  } else {
  }
// compiled if node returning if5856 (depth = 4)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5911 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5913 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5912);
// compiled call node returning call5913 (depth = 6)
// compiled member node returning call5913 (depth = 5)
  gc_frame_newslot(call5913);
// starting to compile block node (depth = 5)
  Object block5914 = alloc_Block(NULL, NULL, "ast", 1288);
  gc_frame_newslot(block5914);
// method _apply
  block_savedest(block5914);
  Object closure5915 = createclosure(4, "_apply");
  setclosureframe(closure5915, stackframe);
  addtoclosure(closure5915, var_depth);
  addtoclosure(closure5915, var_spc);
  addtoclosure(closure5915, var_s);
  addtoclosure(closure5915, selfslot);
  struct UserObject *uo5915 = (struct UserObject*)block5914;
  uo5915->data[0] = (Object)closure5915;
  Method *meth_meth_ast__apply5915 = addmethod2pos(block5914, "_apply", &meth_ast__apply5915, 0);
  int argcv_meth_ast__apply5915[] = {1};
  meth_meth_ast__apply5915->type = alloc_MethodType(1, argcv_meth_ast__apply5915);
  meth_meth_ast__apply5915->definitionModule = modulename;
  meth_meth_ast__apply5915->definitionLine = 1288;
// compiled block node returning block5914 (depth = 5)
  gc_frame_newslot(block5914);
// call case 5: prelude request
  params[0] = call5913;
  params[1] = block5914;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5934 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5911);
// compiled call node returning call5934 (depth = 4)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5947(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit5949 == NULL) {
    strlit5949 = alloc_String("    ");
    gc_root(strlit5949);
  }
// compiled string node returning strlit5949 (depth = 8)
  int op_slot_right_5948 = gc_frame_newslot(strlit5949);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_5948 = gc_frame_newslot(*var_spc);
  params[0] = strlit5949;
  partcv[0] = 1;
  Object opresult5951 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult5951 (depth = 7)
  *var_spc = opresult5951;
  if (opresult5951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5960(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5962 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num5964 = alloc_Float64(1);
// compiled num node returning num5964 (depth = 10)
  int op_slot_right_5963 = gc_frame_newslot(num5964);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_5963 = gc_frame_newslot(*var_depth);
  params[0] = num5964;
  partcv[0] = 1;
  Object sum5966 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum5966 (depth = 9)
  gc_frame_newslot(sum5966);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  params[0] = sum5966;
  partcv[0] = 1;
  Object call5967 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5962);
// compiled call node returning call5967 (depth = 8)
  int op_slot_right_5961 = gc_frame_newslot(call5967);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5970 == NULL) {
    strlit5970 = alloc_String("    ");
    gc_root(strlit5970);
  }
// compiled string node returning strlit5970 (depth = 9)
  int op_slot_right_5969 = gc_frame_newslot(strlit5970);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_5972 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit5975 == NULL) {
    strlit5975 = alloc_String("""\x0a""");
    gc_root(strlit5975);
  }
// compiled string node returning strlit5975 (depth = 11)
  int op_slot_right_5974 = gc_frame_newslot(strlit5975);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_5974 = gc_frame_newslot(*var_s);
  params[0] = strlit5975;
  partcv[0] = 1;
  Object opresult5977 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5977 (depth = 10)
  int op_slot_left_5972 = gc_frame_newslot(opresult5977);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5978 = callmethod(opresult5977, "++", 1, partcv, params);
// compiled op node returning opresult5978 (depth = 9)
  int op_slot_left_5969 = gc_frame_newslot(opresult5978);
  params[0] = strlit5970;
  partcv[0] = 1;
  Object opresult5979 = callmethod(opresult5978, "++", 1, partcv, params);
// compiled op node returning opresult5979 (depth = 8)
  int op_slot_left_5961 = gc_frame_newslot(opresult5979);
  params[0] = call5967;
  partcv[0] = 1;
  Object opresult5980 = callmethod(opresult5979, "++", 1, partcv, params);
// compiled op node returning opresult5980 (depth = 7)
  *var_s = opresult5980;
  if (opresult5980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5935(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit5936 == NULL) {
    strlit5936 = alloc_String("");
    gc_root(strlit5936);
  }
// compiled string node returning strlit5936 (depth = 5)
  *var_spc = strlit5936;
  if (strlit5936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5937 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5940 = alloc_Float64(1);
// compiled num node returning num5940 (depth = 7)
  int op_slot_right_5939 = gc_frame_newslot(num5940);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_5939 = gc_frame_newslot(*var_depth);
  params[0] = num5940;
  partcv[0] = 1;
  Object diff5942 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff5942 (depth = 6)
  int op_slot_right_5938 = gc_frame_newslot(diff5942);
// starting to compile num node (depth = 6)
  Object num5944 = alloc_Float64(0);
// compiled num node returning num5944 (depth = 6)
  int op_slot_left_5938 = gc_frame_newslot(num5944);
  params[0] = diff5942;
  partcv[0] = 1;
  Object opresult5945 = callmethod(num5944, "..", 1, partcv, params);
// compiled op node returning opresult5945 (depth = 5)
  gc_frame_newslot(opresult5945);
// starting to compile block node (depth = 5)
  Object block5946 = alloc_Block(NULL, NULL, "ast", 1295);
  gc_frame_newslot(block5946);
// method _apply
  block_savedest(block5946);
  Object closure5947 = createclosure(2, "_apply");
  setclosureframe(closure5947, stackframe);
  addtoclosure(closure5947, var_spc);
  addtoclosure(closure5947, selfslot);
  struct UserObject *uo5947 = (struct UserObject*)block5946;
  uo5947->data[0] = (Object)closure5947;
  Method *meth_meth_ast__apply5947 = addmethod2pos(block5946, "_apply", &meth_ast__apply5947, 0);
  int argcv_meth_ast__apply5947[] = {1};
  meth_meth_ast__apply5947->type = alloc_MethodType(1, argcv_meth_ast__apply5947);
  meth_meth_ast__apply5947->definitionModule = modulename;
  meth_meth_ast__apply5947->definitionLine = 1288;
// compiled block node returning block5946 (depth = 5)
  gc_frame_newslot(block5946);
// call case 5: prelude request
  params[0] = opresult5945;
  params[1] = block5946;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5954 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5937);
// compiled call node returning call5954 (depth = 4)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit5955 == NULL) {
    strlit5955 = alloc_String("object {");
    gc_root(strlit5955);
  }
// compiled string node returning strlit5955 (depth = 5)
  *var_s = strlit5955;
  if (strlit5955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5956 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5957 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5958 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5957);
// compiled call node returning call5958 (depth = 6)
// compiled member node returning call5958 (depth = 5)
  gc_frame_newslot(call5958);
// starting to compile block node (depth = 5)
  Object block5959 = alloc_Block(NULL, NULL, "ast", 1299);
  gc_frame_newslot(block5959);
// method _apply
  block_savedest(block5959);
  Object closure5960 = createclosure(4, "_apply");
  setclosureframe(closure5960, stackframe);
  addtoclosure(closure5960, var_depth);
  addtoclosure(closure5960, var_spc);
  addtoclosure(closure5960, var_s);
  addtoclosure(closure5960, selfslot);
  struct UserObject *uo5960 = (struct UserObject*)block5959;
  uo5960->data[0] = (Object)closure5960;
  Method *meth_meth_ast__apply5960 = addmethod2pos(block5959, "_apply", &meth_ast__apply5960, 0);
  int argcv_meth_ast__apply5960[] = {1};
  meth_meth_ast__apply5960->type = alloc_MethodType(1, argcv_meth_ast__apply5960);
  meth_meth_ast__apply5960->definitionModule = modulename;
  meth_meth_ast__apply5960->definitionLine = 1299;
// compiled block node returning block5959 (depth = 5)
  gc_frame_newslot(block5959);
// call case 5: prelude request
  params[0] = call5958;
  params[1] = block5959;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5983 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5956);
// compiled call node returning call5983 (depth = 4)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit5985 == NULL) {
    strlit5985 = alloc_String("}");
    gc_root(strlit5985);
  }
// compiled string node returning strlit5985 (depth = 6)
  int op_slot_right_5984 = gc_frame_newslot(strlit5985);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_5987 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5990 == NULL) {
    strlit5990 = alloc_String("""\x0a""");
    gc_root(strlit5990);
  }
// compiled string node returning strlit5990 (depth = 8)
  int op_slot_right_5989 = gc_frame_newslot(strlit5990);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_5989 = gc_frame_newslot(*var_s);
  params[0] = strlit5990;
  partcv[0] = 1;
  Object opresult5992 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5992 (depth = 7)
  int op_slot_left_5987 = gc_frame_newslot(opresult5992);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5993 = callmethod(opresult5992, "++", 1, partcv, params);
// compiled op node returning opresult5993 (depth = 6)
  int op_slot_left_5984 = gc_frame_newslot(opresult5993);
  params[0] = strlit5985;
  partcv[0] = 1;
  Object opresult5994 = callmethod(opresult5993, "++", 1, partcv, params);
// compiled op node returning opresult5994 (depth = 5)
  *var_s = opresult5994;
  if (opresult5994 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent5996(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5997 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe5998 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// starting to compile identifier node (depth = 6)
  Object bool5999 = alloc_Boolean(0);
// compiled identifier node returning bool5999 (depth = 6)
  gc_frame_newslot(bool5999);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_objectNode (depth = 6)
  params[0] = *var_emptySeq;
  params[1] = bool5999;
  partcv[0] = 2;
  Object call6000 = callmethod(*var_objectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5998);
// compiled call node returning call6000 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6001 = callmethod(call6000, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe5997);
// compiled call node returning call6001 (depth = 4)
  gc_frame_end(frame);
  return call6001;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent6002(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6003 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6004 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6003);
// compiled call node returning call6004 (depth = 4)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6005 = gc_frame_new();
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call6007 = callmethod(*var_other, "data",
    1, partcv, params);
  gc_frame_end(callframe6006);
// compiled call node returning call6007 (depth = 7)
// compiled member node returning call6007 (depth = 6)
  gc_frame_newslot(call6007);
// call case 4: self request
  params[0] = call6007;
  partcv[0] = 1;
  Object call6008 = callmethodflags(self, "data:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6005);
// compiled call node returning call6008 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6009 = gc_frame_new();
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call6011 = callmethod(*var_other, "classname",
    1, partcv, params);
  gc_frame_end(callframe6010);
// compiled call node returning call6011 (depth = 7)
// compiled member node returning call6011 (depth = 6)
  gc_frame_newslot(call6011);
// call case 4: self request
  params[0] = call6011;
  partcv[0] = 1;
  Object call6012 = callmethodflags(self, "classname:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6009);
// compiled call node returning call6012 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString6013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6015 == NULL) {
    strlit6015 = alloc_String("}");
    gc_root(strlit6015);
  }
// compiled string node returning strlit6015 (depth = 5)
  int op_slot_right_6014 = gc_frame_newslot(strlit6015);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6018 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6019 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6018);
// compiled call node returning call6019 (depth = 7)
// compiled member node returning call6019 (depth = 6)
  int op_slot_right_6017 = gc_frame_newslot(call6019);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6022 == NULL) {
    strlit6022 = alloc_String(" inherits ");
    gc_root(strlit6022);
  }
// compiled string node returning strlit6022 (depth = 7)
  int op_slot_right_6021 = gc_frame_newslot(strlit6022);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6025 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6026 = callmethodflags(self, "classname", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6025);
// compiled call node returning call6026 (depth = 9)
// compiled member node returning call6026 (depth = 8)
  int op_slot_right_6024 = gc_frame_newslot(call6026);
// starting to compile string node (depth = 8)
  if (strlit6028 == NULL) {
    strlit6028 = alloc_String("object {");
    gc_root(strlit6028);
  }
// compiled string node returning strlit6028 (depth = 8)
  int op_slot_left_6024 = gc_frame_newslot(strlit6028);
  params[0] = call6026;
  partcv[0] = 1;
  Object opresult6029 = callmethod(strlit6028, "++", 1, partcv, params);
// compiled op node returning opresult6029 (depth = 7)
  int op_slot_left_6021 = gc_frame_newslot(opresult6029);
  params[0] = strlit6022;
  partcv[0] = 1;
  Object opresult6030 = callmethod(opresult6029, "++", 1, partcv, params);
// compiled op node returning opresult6030 (depth = 6)
  int op_slot_left_6017 = gc_frame_newslot(opresult6030);
  params[0] = call6019;
  partcv[0] = 1;
  Object opresult6031 = callmethod(opresult6030, "++", 1, partcv, params);
// compiled op node returning opresult6031 (depth = 5)
  int op_slot_left_6014 = gc_frame_newslot(opresult6031);
  params[0] = strlit6015;
  partcv[0] = 1;
  Object opresult6032 = callmethod(opresult6031, "++", 1, partcv, params);
// compiled op node returning opresult6032 (depth = 4)
  gc_frame_end(frame);
  return opresult6032;
}
Object meth_ast_new5751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  Object *var_symbolTableNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5752 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5752 = alloc_userobj2(20,17, objclass5752);
  gc_frame_newslot(obj5752);
if (objclass5752 == NULL) {
  glfree(obj5752->class->name);
  obj5752->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5752, self, 0);
  addmethodreal(obj5752,"outer", &reader_ast_outer_5753);
  Object oldself5752 = self;
  struct StackFrameObject *oldstackframe5752 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5752);
  gc_frame_newslot((Object)stackframe);
  self = obj5752;
  Object *oldselfslot5752 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5752 = (*(struct UserObject *)self).data[0], lowerouter5752 = thisouter5752;
  if (inheritingObject5752) {
    struct UserObject *inho5752 = (struct UserObject *)inheritingObject5752;
    while (inho5752->super != GraceDefaultObject) inho5752 = (struct UserObject *)inho5752->super;
    inho5752->super = obj5752;
    self = inheritingObject5752;
    *selfslot = self;
    lowerouter5752 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5752;
  }
if (objclass5752 == NULL) {
  Method *reader5754 = addmethodrealflags(obj5752, "kind",&reader_ast_kind_5754, MFLAG_DEF);
  reader5754->definitionModule = modulename;
  reader5754->definitionLine = 1246;
}
adddatum2(obj5752, alloc_Undefined(), 1);
if (objclass5752 == NULL) {
  Method *reader5755 = addmethodrealflags(obj5752, "value",&reader_ast_value_5755, 0);
  Method *writer5755 = addmethodrealflags(obj5752, "value:=",&writer_ast_value_5755, 0);
  reader5755->definitionModule = modulename;
  writer5755->definitionModule = modulename;
  reader5755->definitionLine = 1247;
  writer5755->definitionLine = 1247;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 2);
if (objclass5752 == NULL) {
  Method *reader5756 = addmethodrealflags(obj5752, "superclass",&reader_ast_superclass_5756, 0);
  Method *writer5756 = addmethodrealflags(obj5752, "superclass:=",&writer_ast_superclass_5756, 0);
  reader5756->definitionModule = modulename;
  writer5756->definitionModule = modulename;
  reader5756->definitionLine = 1248;
  writer5756->definitionLine = 1248;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 3);
if (objclass5752 == NULL) {
  Method *reader5757 = addmethodrealflags(obj5752, "classname",&reader_ast_classname_5757, 0);
  Method *writer5757 = addmethodrealflags(obj5752, "classname:=",&writer_ast_classname_5757, 0);
  reader5757->definitionModule = modulename;
  writer5757->definitionModule = modulename;
  reader5757->definitionLine = 1249;
  writer5757->definitionLine = 1249;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 4);
if (objclass5752 == NULL) {
  Method *reader5758 = addmethodrealflags(obj5752, "data",&reader_ast_data_5758, 0);
  Method *writer5758 = addmethodrealflags(obj5752, "data:=",&writer_ast_data_5758, 0);
  reader5758->definitionModule = modulename;
  writer5758->definitionModule = modulename;
  reader5758->definitionLine = 1251;
  writer5758->definitionLine = 1251;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 5);
// method fullName
  struct UserObject *uo5759 = (struct UserObject*)obj5752;
  uo5759->data[6] = emptyclosure;
  Method *meth_meth_ast_fullName5759 = addmethod2pos(obj5752, "fullName", &meth_ast_fullName5759, 6);
  int argcv_meth_ast_fullName5759[] = {0};
  meth_meth_ast_fullName5759->type = alloc_MethodType(1, argcv_meth_ast_fullName5759);
  meth_meth_ast_fullName5759->definitionModule = modulename;
  meth_meth_ast_fullName5759->definitionLine = 1251;
// method definesObject
  struct UserObject *uo5784 = (struct UserObject*)obj5752;
  uo5784->data[7] = emptyclosure;
  Method *meth_meth_ast_definesObject5784 = addmethod2pos(obj5752, "definesObject", &meth_ast_definesObject5784, 7);
  int argcv_meth_ast_definesObject5784[] = {0};
  meth_meth_ast_definesObject5784->type = alloc_MethodType(1, argcv_meth_ast_definesObject5784);
  meth_meth_ast_definesObject5784->definitionModule = modulename;
  meth_meth_ast_definesObject5784->definitionLine = 1256;
// method isObject
  struct UserObject *uo5786 = (struct UserObject*)obj5752;
  uo5786->data[8] = emptyclosure;
  Method *meth_meth_ast_isObject5786 = addmethod2pos(obj5752, "isObject", &meth_ast_isObject5786, 8);
  int argcv_meth_ast_isObject5786[] = {0};
  meth_meth_ast_isObject5786->type = alloc_MethodType(1, argcv_meth_ast_isObject5786);
  meth_meth_ast_isObject5786->definitionModule = modulename;
  meth_meth_ast_isObject5786->definitionLine = 1257;
// method accept()from
  struct UserObject *uo5788 = (struct UserObject*)obj5752;
  uo5788->data[9] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5788 = addmethod2pos(obj5752, "accept()from", &meth_ast_accept_40__41_from5788, 9);
  int argcv_meth_ast_accept_40__41_from5788[] = {1, 1};
  meth_meth_ast_accept_40__41_from5788->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5788);
  meth_meth_ast_accept_40__41_from5788->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5788->definitionLine = 1258;
// method map()parent
  struct UserObject *uo5812 = (struct UserObject*)obj5752;
  uo5812->data[10] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent5812 = addmethod2pos(obj5752, "map()parent", &meth_ast_map_40__41_parent5812, 10);
  int argcv_meth_ast_map_40__41_parent5812[] = {1, 1};
  meth_meth_ast_map_40__41_parent5812->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent5812);
  meth_meth_ast_map_40__41_parent5812->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent5812->definitionLine = 1268;
// method pretty
  struct UserObject *uo5838 = (struct UserObject*)obj5752;
  uo5838->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty5838 = addmethod2pos(obj5752, "pretty", &meth_ast_pretty5838, 11);
  int argcv_meth_ast_pretty5838[] = {1};
  meth_meth_ast_pretty5838->type = alloc_MethodType(1, argcv_meth_ast_pretty5838);
  meth_meth_ast_pretty5838->definitionModule = modulename;
  meth_meth_ast_pretty5838->definitionLine = 1275;
// method toGrace
  struct UserObject *uo5935 = (struct UserObject*)obj5752;
  uo5935->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace5935 = addmethod2pos(obj5752, "toGrace", &meth_ast_toGrace5935, 12);
  int argcv_meth_ast_toGrace5935[] = {1};
  meth_meth_ast_toGrace5935->type = alloc_MethodType(1, argcv_meth_ast_toGrace5935);
meth_meth_ast_toGrace5935->type->types[0] = type_Number;
meth_meth_ast_toGrace5935->type->names[0] = "depth";
  meth_meth_ast_toGrace5935->definitionModule = modulename;
  meth_meth_ast_toGrace5935->definitionLine = 1293;
// method shallowCopyWithParent
  block_savedest(obj5752);
  Object closure5996 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure5996, stackframe);
  addtoclosure(closure5996, var_emptySeq);
  addtoclosure(closure5996, var_objectNode);
  struct UserObject *uo5996 = (struct UserObject*)obj5752;
  uo5996->data[13] = (Object)closure5996;
  Method *meth_meth_ast_shallowCopyWithParent5996 = addmethod2pos(obj5752, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent5996, 13);
  int argcv_meth_ast_shallowCopyWithParent5996[] = {1};
  meth_meth_ast_shallowCopyWithParent5996->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent5996);
  meth_meth_ast_shallowCopyWithParent5996->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent5996->definitionLine = 1305;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo6002 = (struct UserObject*)obj5752;
  uo6002->data[14] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002 = addmethod2pos(obj5752, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent6002, 14);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent6002[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent6002);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002->definitionLine = 1308;
// method asString
  struct UserObject *uo6013 = (struct UserObject*)obj5752;
  uo6013->data[15] = emptyclosure;
  Method *meth_meth_ast_asString6013 = addmethod2pos(obj5752, "asString", &meth_ast_asString6013, 15);
  int argcv_meth_ast_asString6013[] = {0};
  meth_meth_ast_asString6013->type = alloc_MethodType(1, argcv_meth_ast_asString6013);
  meth_meth_ast_asString6013->definitionModule = modulename;
  meth_meth_ast_asString6013->definitionLine = 1314;
  sourceObject = obj5752;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6033 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6034 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6033);
// compiled call node returning call6034 (depth = 4)
  struct UserObject *obj5752_uo = (struct UserObject *)obj5752;
  obj5752_uo->super = call6034;
  sourceObject = obj5752;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6035 == NULL) {
    strlit6035 = alloc_String("object");
    gc_root(strlit6035);
  }
// compiled string node returning strlit6035 (depth = 4)
  adddatum2(obj5752, strlit6035, 1);
  sourceObject = obj5752;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  adddatum2(obj5752, *var_body, 2);
  sourceObject = obj5752;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superclass_39_ (depth = 4)
  adddatum2(obj5752, *var_superclass_39_, 3);
  sourceObject = obj5752;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6036 == NULL) {
    strlit6036 = alloc_String("object");
    gc_root(strlit6036);
  }
// compiled string node returning strlit6036 (depth = 4)
  adddatum2(obj5752, strlit6036, 4);
  sourceObject = obj5752;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6037 = alloc_Boolean(0);
// compiled identifier node returning bool6037 (depth = 4)
  adddatum2(obj5752, bool6037, 5);
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
objclass5752 = obj5752->class;
  objclass5752->definitionModule = modulename;
  objclass5752->definitionLine = 1242;
  (*(struct UserObject *)self).data[0] = lowerouter5752;
  self = oldself5752;
  selfslot = oldselfslot5752;
  stackframe = oldstackframe5752;
  gc_frame_end(frame);
  return obj5752;
}
Object meth_ast_new5751_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_objectNode = getfromclosure(closure, 1);
  Object *var_symbolTableNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5752 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5752 = alloc_userobj2(20,17, objclass5752);
  gc_frame_newslot(obj5752);
if (objclass5752 == NULL) {
  glfree(obj5752->class->name);
  obj5752->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5752, self, 0);
  addmethodreal(obj5752,"outer", &reader_ast_outer_5753);
  Object oldself5752 = self;
  struct StackFrameObject *oldstackframe5752 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5752);
  gc_frame_newslot((Object)stackframe);
  self = obj5752;
  Object *oldselfslot5752 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5752 = (*(struct UserObject *)self).data[0], lowerouter5752 = thisouter5752;
  if (inheritingObject5752) {
    struct UserObject *inho5752 = (struct UserObject *)inheritingObject5752;
    while (inho5752->super != GraceDefaultObject) inho5752 = (struct UserObject *)inho5752->super;
    inho5752->super = obj5752;
    self = inheritingObject5752;
    *selfslot = self;
    lowerouter5752 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5752;
  }
if (objclass5752 == NULL) {
  Method *reader5754 = addmethodrealflags(obj5752, "kind",&reader_ast_kind_5754, MFLAG_DEF);
  reader5754->definitionModule = modulename;
  reader5754->definitionLine = 1246;
}
adddatum2(obj5752, alloc_Undefined(), 1);
if (objclass5752 == NULL) {
  Method *reader5755 = addmethodrealflags(obj5752, "value",&reader_ast_value_5755, 0);
  Method *writer5755 = addmethodrealflags(obj5752, "value:=",&writer_ast_value_5755, 0);
  reader5755->definitionModule = modulename;
  writer5755->definitionModule = modulename;
  reader5755->definitionLine = 1247;
  writer5755->definitionLine = 1247;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 2);
if (objclass5752 == NULL) {
  Method *reader5756 = addmethodrealflags(obj5752, "superclass",&reader_ast_superclass_5756, 0);
  Method *writer5756 = addmethodrealflags(obj5752, "superclass:=",&writer_ast_superclass_5756, 0);
  reader5756->definitionModule = modulename;
  writer5756->definitionModule = modulename;
  reader5756->definitionLine = 1248;
  writer5756->definitionLine = 1248;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 3);
if (objclass5752 == NULL) {
  Method *reader5757 = addmethodrealflags(obj5752, "classname",&reader_ast_classname_5757, 0);
  Method *writer5757 = addmethodrealflags(obj5752, "classname:=",&writer_ast_classname_5757, 0);
  reader5757->definitionModule = modulename;
  writer5757->definitionModule = modulename;
  reader5757->definitionLine = 1249;
  writer5757->definitionLine = 1249;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 4);
if (objclass5752 == NULL) {
  Method *reader5758 = addmethodrealflags(obj5752, "data",&reader_ast_data_5758, 0);
  Method *writer5758 = addmethodrealflags(obj5752, "data:=",&writer_ast_data_5758, 0);
  reader5758->definitionModule = modulename;
  writer5758->definitionModule = modulename;
  reader5758->definitionLine = 1251;
  writer5758->definitionLine = 1251;
}
obj5752->flags |= OFLAG_MUTABLE;
adddatum2(obj5752, alloc_Undefined(), 5);
// method fullName
  struct UserObject *uo5759 = (struct UserObject*)obj5752;
  uo5759->data[6] = emptyclosure;
  Method *meth_meth_ast_fullName5759 = addmethod2pos(obj5752, "fullName", &meth_ast_fullName5759, 6);
  int argcv_meth_ast_fullName5759[] = {0};
  meth_meth_ast_fullName5759->type = alloc_MethodType(1, argcv_meth_ast_fullName5759);
  meth_meth_ast_fullName5759->definitionModule = modulename;
  meth_meth_ast_fullName5759->definitionLine = 1251;
// method definesObject
  struct UserObject *uo5784 = (struct UserObject*)obj5752;
  uo5784->data[7] = emptyclosure;
  Method *meth_meth_ast_definesObject5784 = addmethod2pos(obj5752, "definesObject", &meth_ast_definesObject5784, 7);
  int argcv_meth_ast_definesObject5784[] = {0};
  meth_meth_ast_definesObject5784->type = alloc_MethodType(1, argcv_meth_ast_definesObject5784);
  meth_meth_ast_definesObject5784->definitionModule = modulename;
  meth_meth_ast_definesObject5784->definitionLine = 1256;
// method isObject
  struct UserObject *uo5786 = (struct UserObject*)obj5752;
  uo5786->data[8] = emptyclosure;
  Method *meth_meth_ast_isObject5786 = addmethod2pos(obj5752, "isObject", &meth_ast_isObject5786, 8);
  int argcv_meth_ast_isObject5786[] = {0};
  meth_meth_ast_isObject5786->type = alloc_MethodType(1, argcv_meth_ast_isObject5786);
  meth_meth_ast_isObject5786->definitionModule = modulename;
  meth_meth_ast_isObject5786->definitionLine = 1257;
// method accept()from
  struct UserObject *uo5788 = (struct UserObject*)obj5752;
  uo5788->data[9] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from5788 = addmethod2pos(obj5752, "accept()from", &meth_ast_accept_40__41_from5788, 9);
  int argcv_meth_ast_accept_40__41_from5788[] = {1, 1};
  meth_meth_ast_accept_40__41_from5788->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from5788);
  meth_meth_ast_accept_40__41_from5788->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from5788->definitionLine = 1258;
// method map()parent
  struct UserObject *uo5812 = (struct UserObject*)obj5752;
  uo5812->data[10] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent5812 = addmethod2pos(obj5752, "map()parent", &meth_ast_map_40__41_parent5812, 10);
  int argcv_meth_ast_map_40__41_parent5812[] = {1, 1};
  meth_meth_ast_map_40__41_parent5812->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent5812);
  meth_meth_ast_map_40__41_parent5812->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent5812->definitionLine = 1268;
// method pretty
  struct UserObject *uo5838 = (struct UserObject*)obj5752;
  uo5838->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty5838 = addmethod2pos(obj5752, "pretty", &meth_ast_pretty5838, 11);
  int argcv_meth_ast_pretty5838[] = {1};
  meth_meth_ast_pretty5838->type = alloc_MethodType(1, argcv_meth_ast_pretty5838);
  meth_meth_ast_pretty5838->definitionModule = modulename;
  meth_meth_ast_pretty5838->definitionLine = 1275;
// method toGrace
  struct UserObject *uo5935 = (struct UserObject*)obj5752;
  uo5935->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace5935 = addmethod2pos(obj5752, "toGrace", &meth_ast_toGrace5935, 12);
  int argcv_meth_ast_toGrace5935[] = {1};
  meth_meth_ast_toGrace5935->type = alloc_MethodType(1, argcv_meth_ast_toGrace5935);
meth_meth_ast_toGrace5935->type->types[0] = type_Number;
meth_meth_ast_toGrace5935->type->names[0] = "depth";
  meth_meth_ast_toGrace5935->definitionModule = modulename;
  meth_meth_ast_toGrace5935->definitionLine = 1293;
// method shallowCopyWithParent
  block_savedest(obj5752);
  Object closure5996 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure5996, stackframe);
  addtoclosure(closure5996, var_emptySeq);
  addtoclosure(closure5996, var_objectNode);
  struct UserObject *uo5996 = (struct UserObject*)obj5752;
  uo5996->data[13] = (Object)closure5996;
  Method *meth_meth_ast_shallowCopyWithParent5996 = addmethod2pos(obj5752, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent5996, 13);
  int argcv_meth_ast_shallowCopyWithParent5996[] = {1};
  meth_meth_ast_shallowCopyWithParent5996->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent5996);
  meth_meth_ast_shallowCopyWithParent5996->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent5996->definitionLine = 1305;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo6002 = (struct UserObject*)obj5752;
  uo6002->data[14] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002 = addmethod2pos(obj5752, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent6002, 14);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent6002[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent6002);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent6002->definitionLine = 1308;
// method asString
  struct UserObject *uo6013 = (struct UserObject*)obj5752;
  uo6013->data[15] = emptyclosure;
  Method *meth_meth_ast_asString6013 = addmethod2pos(obj5752, "asString", &meth_ast_asString6013, 15);
  int argcv_meth_ast_asString6013[] = {0};
  meth_meth_ast_asString6013->type = alloc_MethodType(1, argcv_meth_ast_asString6013);
  meth_meth_ast_asString6013->definitionModule = modulename;
  meth_meth_ast_asString6013->definitionLine = 1314;
  sourceObject = obj5752;
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6033 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_symbolTableNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6034 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6033);
// compiled call node returning call6034 (depth = 4)
  struct UserObject *obj5752_uo = (struct UserObject *)obj5752;
  obj5752_uo->super = call6034;
  sourceObject = obj5752;
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6035 == NULL) {
    strlit6035 = alloc_String("object");
    gc_root(strlit6035);
  }
// compiled string node returning strlit6035 (depth = 4)
  adddatum2(obj5752, strlit6035, 1);
  sourceObject = obj5752;
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_body (depth = 4)
  adddatum2(obj5752, *var_body, 2);
  sourceObject = obj5752;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_superclass_39_ (depth = 4)
  adddatum2(obj5752, *var_superclass_39_, 3);
  sourceObject = obj5752;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6036 == NULL) {
    strlit6036 = alloc_String("object");
    gc_root(strlit6036);
  }
// compiled string node returning strlit6036 (depth = 4)
  adddatum2(obj5752, strlit6036, 4);
  sourceObject = obj5752;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6037 = alloc_Boolean(0);
// compiled identifier node returning bool6037 (depth = 4)
  adddatum2(obj5752, bool6037, 5);
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
  sourceObject = obj5752;
objclass5752 = obj5752->class;
  objclass5752->definitionModule = modulename;
  objclass5752->definitionLine = 1242;
  (*(struct UserObject *)self).data[0] = lowerouter5752;
  self = oldself5752;
  selfslot = oldselfslot5752;
  stackframe = oldstackframe5752;
  gc_frame_end(frame);
  return obj5752;
}
Object meth_ast_arrayNode6039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for arrayNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for arrayNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arrayNode (depth = 3)
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast__apply6055(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6056 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ax (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6057 = callmethod(*var_ax, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6056);
// compiled call node returning call6057 (depth = 7)
  gc_frame_end(frame);
  return call6057;
}
Object meth_ast_accept_40__41_from6047(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6049 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6050 = callmethod(*var_visitor, "visitArray()up",
    2, partcv, params);
  gc_frame_end(callframe6049);
// compiled call node returning call6050 (depth = 5)
  Object if6048 = done;
  if (istrue(call6050)) {
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6051 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6052 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6053 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6052);
// compiled call node returning call6053 (depth = 7)
// compiled member node returning call6053 (depth = 6)
  gc_frame_newslot(call6053);
// starting to compile block node (depth = 6)
  Object block6054 = alloc_Block(NULL, NULL, "ast", 1324);
  gc_frame_newslot(block6054);
// method _apply
  block_savedest(block6054);
  Object closure6055 = createclosure(2, "_apply");
  setclosureframe(closure6055, stackframe);
  addtoclosure(closure6055, var_visitor);
  addtoclosure(closure6055, selfslot);
  struct UserObject *uo6055 = (struct UserObject*)block6054;
  uo6055->data[0] = (Object)closure6055;
  Method *meth_meth_ast__apply6055 = addmethod2pos(block6054, "_apply", &meth_ast__apply6055, 0);
  int argcv_meth_ast__apply6055[] = {1};
  meth_meth_ast__apply6055->type = alloc_MethodType(1, argcv_meth_ast__apply6055);
  meth_meth_ast__apply6055->definitionModule = modulename;
  meth_meth_ast__apply6055->definitionLine = 1324;
// compiled block node returning block6054 (depth = 6)
  gc_frame_newslot(block6054);
// call case 5: prelude request
  params[0] = call6053;
  params[1] = block6054;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6059 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6051);
// compiled call node returning call6059 (depth = 5)
    gc_frame_newslot(call6059);
    if6048 = call6059;
  } else {
  }
// compiled if node returning if6048 (depth = 4)
  gc_frame_end(frame);
  return if6048;
}
Object meth_ast_map_40__41_parent6060(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6061 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call6062 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6061);
// compiled call node returning call6062 (depth = 5)
  *var_n = call6062;
  if (call6062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6063 = gc_frame_new();
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6064 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6065 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6066 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6065);
// compiled call node returning call6066 (depth = 8)
// compiled member node returning call6066 (depth = 7)
  gc_frame_newslot(call6066);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6067 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6068 = gc_frame_new();
// call case 3: self.outer request
  Object call6069 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6068);
// compiled call node returning call6069 (depth = 10)
// compiled member node returning call6069 (depth = 9)
  partcv[0] = 0;
  Object call6070 = callmethodflags(call6069, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6067);
// compiled call node returning call6070 (depth = 8)
// compiled member node returning call6070 (depth = 7)
  params[0] = call6066;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6071 = callmethodflags(call6070, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6064);
// compiled call node returning call6071 (depth = 6)
  gc_frame_newslot(call6071);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call6071;
  partcv[0] = 1;
  Object call6072 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe6063);
// compiled call node returning call6072 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6073 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6074 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6073);
// compiled call node returning call6074 (depth = 5)
  *var_n = call6074;
  if (call6074 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6084(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit6086 == NULL) {
    strlit6086 = alloc_String("  ");
    gc_root(strlit6086);
  }
// compiled string node returning strlit6086 (depth = 8)
  int op_slot_right_6085 = gc_frame_newslot(strlit6086);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_6085 = gc_frame_newslot(*var_spc);
  params[0] = strlit6086;
  partcv[0] = 1;
  Object opresult6088 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6088 (depth = 7)
  *var_spc = opresult6088;
  if (opresult6088 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6098(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6100 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6102 = alloc_Float64(1);
// compiled num node returning num6102 (depth = 10)
  int op_slot_right_6101 = gc_frame_newslot(num6102);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6101 = gc_frame_newslot(*var_depth);
  params[0] = num6102;
  partcv[0] = 1;
  Object sum6104 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6104 (depth = 9)
  gc_frame_newslot(sum6104);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ax (depth = 9)
  params[0] = sum6104;
  partcv[0] = 1;
  Object call6105 = callmethod(*var_ax, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6100);
// compiled call node returning call6105 (depth = 8)
  int op_slot_right_6099 = gc_frame_newslot(call6105);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_6107 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6110 == NULL) {
    strlit6110 = alloc_String("""\x0a""");
    gc_root(strlit6110);
  }
// compiled string node returning strlit6110 (depth = 10)
  int op_slot_right_6109 = gc_frame_newslot(strlit6110);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_6109 = gc_frame_newslot(*var_s);
  params[0] = strlit6110;
  partcv[0] = 1;
  Object opresult6112 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6112 (depth = 9)
  int op_slot_left_6107 = gc_frame_newslot(opresult6112);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6113 = callmethod(opresult6112, "++", 1, partcv, params);
// compiled op node returning opresult6113 (depth = 8)
  int op_slot_left_6099 = gc_frame_newslot(opresult6113);
  params[0] = call6105;
  partcv[0] = 1;
  Object opresult6114 = callmethod(opresult6113, "++", 1, partcv, params);
// compiled op node returning opresult6114 (depth = 7)
  *var_s = opresult6114;
  if (opresult6114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6076(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6077 == NULL) {
    strlit6077 = alloc_String("");
    gc_root(strlit6077);
  }
// compiled string node returning strlit6077 (depth = 5)
  *var_spc = strlit6077;
  if (strlit6077 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6078 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_6079 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num6081 = alloc_Float64(0);
// compiled num node returning num6081 (depth = 6)
  int op_slot_left_6079 = gc_frame_newslot(num6081);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6082 = callmethod(num6081, "..", 1, partcv, params);
// compiled op node returning opresult6082 (depth = 5)
  gc_frame_newslot(opresult6082);
// starting to compile block node (depth = 5)
  Object block6083 = alloc_Block(NULL, NULL, "ast", 1337);
  gc_frame_newslot(block6083);
// method _apply
  block_savedest(block6083);
  Object closure6084 = createclosure(2, "_apply");
  setclosureframe(closure6084, stackframe);
  addtoclosure(closure6084, var_spc);
  addtoclosure(closure6084, selfslot);
  struct UserObject *uo6084 = (struct UserObject*)block6083;
  uo6084->data[0] = (Object)closure6084;
  Method *meth_meth_ast__apply6084 = addmethod2pos(block6083, "_apply", &meth_ast__apply6084, 0);
  int argcv_meth_ast__apply6084[] = {1};
  meth_meth_ast__apply6084->type = alloc_MethodType(1, argcv_meth_ast__apply6084);
  meth_meth_ast__apply6084->definitionModule = modulename;
  meth_meth_ast__apply6084->definitionLine = 1331;
// compiled block node returning block6083 (depth = 5)
  gc_frame_newslot(block6083);
// call case 5: prelude request
  params[0] = opresult6082;
  params[1] = block6083;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6091 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6078);
// compiled call node returning call6091 (depth = 4)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6092 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6093 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6092);
// compiled call node returning call6093 (depth = 5)
  *var_s = call6093;
  if (call6093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6094 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6095 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6096 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6095);
// compiled call node returning call6096 (depth = 6)
// compiled member node returning call6096 (depth = 5)
  gc_frame_newslot(call6096);
// starting to compile block node (depth = 5)
  Object block6097 = alloc_Block(NULL, NULL, "ast", 1341);
  gc_frame_newslot(block6097);
// method _apply
  block_savedest(block6097);
  Object closure6098 = createclosure(4, "_apply");
  setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, var_depth);
  addtoclosure(closure6098, var_spc);
  addtoclosure(closure6098, var_s);
  addtoclosure(closure6098, selfslot);
  struct UserObject *uo6098 = (struct UserObject*)block6097;
  uo6098->data[0] = (Object)closure6098;
  Method *meth_meth_ast__apply6098 = addmethod2pos(block6097, "_apply", &meth_ast__apply6098, 0);
  int argcv_meth_ast__apply6098[] = {1};
  meth_meth_ast__apply6098->type = alloc_MethodType(1, argcv_meth_ast__apply6098);
  meth_meth_ast__apply6098->definitionModule = modulename;
  meth_meth_ast__apply6098->definitionLine = 1341;
// compiled block node returning block6097 (depth = 5)
  gc_frame_newslot(block6097);
// call case 5: prelude request
  params[0] = call6096;
  params[1] = block6097;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6117 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6094);
// compiled call node returning call6117 (depth = 4)
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6126(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6128 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6129 = alloc_Float64(0);
// compiled num node returning num6129 (depth = 9)
  gc_frame_newslot(num6129);
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6130 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6131 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6130);
// compiled call node returning call6131 (depth = 11)
// compiled member node returning call6131 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres6132 = callmethod(call6131, "[]", 1, partcv, params);
// compiled index node returning idxres6132 (depth = 9)
  params[0] = num6129;
  partcv[0] = 1;
  Object call6133 = callmethod(idxres6132, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6128);
// compiled call node returning call6133 (depth = 8)
  int op_slot_right_6127 = gc_frame_newslot(call6133);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6127 = gc_frame_newslot(*var_s);
  params[0] = call6133;
  partcv[0] = 1;
  Object opresult6135 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6135 (depth = 7)
  *var_s = opresult6135;
  if (opresult6135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6139 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6140 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6141 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6140);
// compiled call node returning call6141 (depth = 11)
// compiled member node returning call6141 (depth = 10)
  partcv[0] = 0;
  Object call6142 = callmethod(call6141, "size",
    1, partcv, params);
  gc_frame_end(callframe6139);
// compiled call node returning call6142 (depth = 9)
// compiled member node returning call6142 (depth = 8)
  int op_slot_right_6138 = gc_frame_newslot(call6142);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_6138 = gc_frame_newslot(*var_i);
  params[0] = call6142;
  partcv[0] = 1;
  Object opresult6144 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult6144 (depth = 7)
  Object if6137 = done;
  if (istrue(opresult6144)) {
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit6146 == NULL) {
    strlit6146 = alloc_String(", ");
    gc_root(strlit6146);
  }
// compiled string node returning strlit6146 (depth = 9)
  int op_slot_right_6145 = gc_frame_newslot(strlit6146);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6145 = gc_frame_newslot(*var_s);
  params[0] = strlit6146;
  partcv[0] = 1;
  Object opresult6148 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6148 (depth = 8)
  *var_s = opresult6148;
  if (opresult6148 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if6137 = done;
  } else {
  }
// compiled if node returning if6137 (depth = 6)
  gc_frame_end(frame);
  return if6137;
}
Object meth_ast_toGrace6118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6119 == NULL) {
    strlit6119 = alloc_String("[");
    gc_root(strlit6119);
  }
// compiled string node returning strlit6119 (depth = 5)
  *var_s = strlit6119;
  if (strlit6119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6120 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6121 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6123 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6122);
// compiled call node returning call6123 (depth = 8)
// compiled member node returning call6123 (depth = 7)
  partcv[0] = 0;
  Object call6124 = callmethod(call6123, "indices",
    1, partcv, params);
  gc_frame_end(callframe6121);
// compiled call node returning call6124 (depth = 6)
// compiled member node returning call6124 (depth = 5)
  gc_frame_newslot(call6124);
// starting to compile block node (depth = 5)
  Object block6125 = alloc_Block(NULL, NULL, "ast", 1348);
  gc_frame_newslot(block6125);
// method _apply
  block_savedest(block6125);
  Object closure6126 = createclosure(2, "_apply");
  setclosureframe(closure6126, stackframe);
  addtoclosure(closure6126, var_s);
  addtoclosure(closure6126, selfslot);
  struct UserObject *uo6126 = (struct UserObject*)block6125;
  uo6126->data[0] = (Object)closure6126;
  Method *meth_meth_ast__apply6126 = addmethod2pos(block6125, "_apply", &meth_ast__apply6126, 0);
  int argcv_meth_ast__apply6126[] = {1};
  meth_meth_ast__apply6126->type = alloc_MethodType(1, argcv_meth_ast__apply6126);
  meth_meth_ast__apply6126->definitionModule = modulename;
  meth_meth_ast__apply6126->definitionLine = 1348;
// compiled block node returning block6125 (depth = 5)
  gc_frame_newslot(block6125);
// call case 5: prelude request
  params[0] = call6124;
  params[1] = block6125;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6151 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6120);
// compiled call node returning call6151 (depth = 4)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6153 == NULL) {
    strlit6153 = alloc_String("]");
    gc_root(strlit6153);
  }
// compiled string node returning strlit6153 (depth = 6)
  int op_slot_right_6152 = gc_frame_newslot(strlit6153);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6152 = gc_frame_newslot(*var_s);
  params[0] = strlit6153;
  partcv[0] = 1;
  Object opresult6155 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6155 (depth = 5)
  *var_s = opresult6155;
  if (opresult6155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent6157(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6158 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe6159 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arrayNode (depth = 6)
  params[0] = *var_emptySeq;
  partcv[0] = 1;
  Object call6160 = callmethod(*var_arrayNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6159);
// compiled call node returning call6160 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6161 = callmethod(call6160, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe6158);
// compiled call node returning call6161 (depth = 4)
  gc_frame_end(frame);
  return call6161;
}
Object meth_ast_new6042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6043 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6043 = alloc_userobj2(9,9, objclass6043);
  gc_frame_newslot(obj6043);
if (objclass6043 == NULL) {
  glfree(obj6043->class->name);
  obj6043->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6043, self, 0);
  addmethodreal(obj6043,"outer", &reader_ast_outer_6044);
  Object oldself6043 = self;
  struct StackFrameObject *oldstackframe6043 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6043);
  gc_frame_newslot((Object)stackframe);
  self = obj6043;
  Object *oldselfslot6043 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6043 = (*(struct UserObject *)self).data[0], lowerouter6043 = thisouter6043;
  if (inheritingObject6043) {
    struct UserObject *inho6043 = (struct UserObject *)inheritingObject6043;
    while (inho6043->super != GraceDefaultObject) inho6043 = (struct UserObject *)inho6043->super;
    inho6043->super = obj6043;
    self = inheritingObject6043;
    *selfslot = self;
    lowerouter6043 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6043;
  }
if (objclass6043 == NULL) {
  Method *reader6045 = addmethodrealflags(obj6043, "kind",&reader_ast_kind_6045, MFLAG_DEF);
  reader6045->definitionModule = modulename;
  reader6045->definitionLine = 1321;
}
adddatum2(obj6043, alloc_Undefined(), 1);
if (objclass6043 == NULL) {
  Method *reader6046 = addmethodrealflags(obj6043, "value",&reader_ast_value_6046, 0);
  Method *writer6046 = addmethodrealflags(obj6043, "value:=",&writer_ast_value_6046, 0);
  reader6046->definitionModule = modulename;
  writer6046->definitionModule = modulename;
  reader6046->definitionLine = 1322;
  writer6046->definitionLine = 1322;
}
obj6043->flags |= OFLAG_MUTABLE;
adddatum2(obj6043, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo6047 = (struct UserObject*)obj6043;
  uo6047->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6047 = addmethod2pos(obj6043, "accept()from", &meth_ast_accept_40__41_from6047, 3);
  int argcv_meth_ast_accept_40__41_from6047[] = {1, 1};
  meth_meth_ast_accept_40__41_from6047->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6047);
  meth_meth_ast_accept_40__41_from6047->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6047->definitionLine = 1322;
// method map()parent
  struct UserObject *uo6060 = (struct UserObject*)obj6043;
  uo6060->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6060 = addmethod2pos(obj6043, "map()parent", &meth_ast_map_40__41_parent6060, 4);
  int argcv_meth_ast_map_40__41_parent6060[] = {1, 1};
  meth_meth_ast_map_40__41_parent6060->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6060);
  meth_meth_ast_map_40__41_parent6060->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6060->definitionLine = 1329;
// method pretty
  struct UserObject *uo6076 = (struct UserObject*)obj6043;
  uo6076->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty6076 = addmethod2pos(obj6043, "pretty", &meth_ast_pretty6076, 5);
  int argcv_meth_ast_pretty6076[] = {1};
  meth_meth_ast_pretty6076->type = alloc_MethodType(1, argcv_meth_ast_pretty6076);
  meth_meth_ast_pretty6076->definitionModule = modulename;
  meth_meth_ast_pretty6076->definitionLine = 1335;
// method toGrace
  struct UserObject *uo6118 = (struct UserObject*)obj6043;
  uo6118->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace6118 = addmethod2pos(obj6043, "toGrace", &meth_ast_toGrace6118, 6);
  int argcv_meth_ast_toGrace6118[] = {1};
  meth_meth_ast_toGrace6118->type = alloc_MethodType(1, argcv_meth_ast_toGrace6118);
meth_meth_ast_toGrace6118->type->types[0] = type_Number;
meth_meth_ast_toGrace6118->type->names[0] = "depth";
  meth_meth_ast_toGrace6118->definitionModule = modulename;
  meth_meth_ast_toGrace6118->definitionLine = 1346;
// method shallowCopyWithParent
  block_savedest(obj6043);
  Object closure6157 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure6157, stackframe);
  addtoclosure(closure6157, var_emptySeq);
  addtoclosure(closure6157, var_arrayNode);
  struct UserObject *uo6157 = (struct UserObject*)obj6043;
  uo6157->data[7] = (Object)closure6157;
  Method *meth_meth_ast_shallowCopyWithParent6157 = addmethod2pos(obj6043, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6157, 7);
  int argcv_meth_ast_shallowCopyWithParent6157[] = {1};
  meth_meth_ast_shallowCopyWithParent6157->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6157);
  meth_meth_ast_shallowCopyWithParent6157->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6157->definitionLine = 1357;
  sourceObject = obj6043;
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6162 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6163 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6162);
// compiled call node returning call6163 (depth = 4)
  struct UserObject *obj6043_uo = (struct UserObject *)obj6043;
  obj6043_uo->super = call6163;
  sourceObject = obj6043;
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6164 == NULL) {
    strlit6164 = alloc_String("array");
    gc_root(strlit6164);
  }
// compiled string node returning strlit6164 (depth = 4)
  adddatum2(obj6043, strlit6164, 1);
  sourceObject = obj6043;
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  adddatum2(obj6043, *var_values, 2);
  sourceObject = obj6043;
  sourceObject = obj6043;
  sourceObject = obj6043;
  sourceObject = obj6043;
  sourceObject = obj6043;
objclass6043 = obj6043->class;
  objclass6043->definitionModule = modulename;
  objclass6043->definitionLine = 1318;
  (*(struct UserObject *)self).data[0] = lowerouter6043;
  self = oldself6043;
  selfslot = oldselfslot6043;
  stackframe = oldstackframe6043;
  gc_frame_end(frame);
  return obj6043;
}
Object meth_ast_new6042_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_arrayNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6043 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6043 = alloc_userobj2(9,9, objclass6043);
  gc_frame_newslot(obj6043);
if (objclass6043 == NULL) {
  glfree(obj6043->class->name);
  obj6043->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6043, self, 0);
  addmethodreal(obj6043,"outer", &reader_ast_outer_6044);
  Object oldself6043 = self;
  struct StackFrameObject *oldstackframe6043 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6043);
  gc_frame_newslot((Object)stackframe);
  self = obj6043;
  Object *oldselfslot6043 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6043 = (*(struct UserObject *)self).data[0], lowerouter6043 = thisouter6043;
  if (inheritingObject6043) {
    struct UserObject *inho6043 = (struct UserObject *)inheritingObject6043;
    while (inho6043->super != GraceDefaultObject) inho6043 = (struct UserObject *)inho6043->super;
    inho6043->super = obj6043;
    self = inheritingObject6043;
    *selfslot = self;
    lowerouter6043 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6043;
  }
if (objclass6043 == NULL) {
  Method *reader6045 = addmethodrealflags(obj6043, "kind",&reader_ast_kind_6045, MFLAG_DEF);
  reader6045->definitionModule = modulename;
  reader6045->definitionLine = 1321;
}
adddatum2(obj6043, alloc_Undefined(), 1);
if (objclass6043 == NULL) {
  Method *reader6046 = addmethodrealflags(obj6043, "value",&reader_ast_value_6046, 0);
  Method *writer6046 = addmethodrealflags(obj6043, "value:=",&writer_ast_value_6046, 0);
  reader6046->definitionModule = modulename;
  writer6046->definitionModule = modulename;
  reader6046->definitionLine = 1322;
  writer6046->definitionLine = 1322;
}
obj6043->flags |= OFLAG_MUTABLE;
adddatum2(obj6043, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo6047 = (struct UserObject*)obj6043;
  uo6047->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6047 = addmethod2pos(obj6043, "accept()from", &meth_ast_accept_40__41_from6047, 3);
  int argcv_meth_ast_accept_40__41_from6047[] = {1, 1};
  meth_meth_ast_accept_40__41_from6047->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6047);
  meth_meth_ast_accept_40__41_from6047->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6047->definitionLine = 1322;
// method map()parent
  struct UserObject *uo6060 = (struct UserObject*)obj6043;
  uo6060->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6060 = addmethod2pos(obj6043, "map()parent", &meth_ast_map_40__41_parent6060, 4);
  int argcv_meth_ast_map_40__41_parent6060[] = {1, 1};
  meth_meth_ast_map_40__41_parent6060->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6060);
  meth_meth_ast_map_40__41_parent6060->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6060->definitionLine = 1329;
// method pretty
  struct UserObject *uo6076 = (struct UserObject*)obj6043;
  uo6076->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty6076 = addmethod2pos(obj6043, "pretty", &meth_ast_pretty6076, 5);
  int argcv_meth_ast_pretty6076[] = {1};
  meth_meth_ast_pretty6076->type = alloc_MethodType(1, argcv_meth_ast_pretty6076);
  meth_meth_ast_pretty6076->definitionModule = modulename;
  meth_meth_ast_pretty6076->definitionLine = 1335;
// method toGrace
  struct UserObject *uo6118 = (struct UserObject*)obj6043;
  uo6118->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace6118 = addmethod2pos(obj6043, "toGrace", &meth_ast_toGrace6118, 6);
  int argcv_meth_ast_toGrace6118[] = {1};
  meth_meth_ast_toGrace6118->type = alloc_MethodType(1, argcv_meth_ast_toGrace6118);
meth_meth_ast_toGrace6118->type->types[0] = type_Number;
meth_meth_ast_toGrace6118->type->names[0] = "depth";
  meth_meth_ast_toGrace6118->definitionModule = modulename;
  meth_meth_ast_toGrace6118->definitionLine = 1346;
// method shallowCopyWithParent
  block_savedest(obj6043);
  Object closure6157 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure6157, stackframe);
  addtoclosure(closure6157, var_emptySeq);
  addtoclosure(closure6157, var_arrayNode);
  struct UserObject *uo6157 = (struct UserObject*)obj6043;
  uo6157->data[7] = (Object)closure6157;
  Method *meth_meth_ast_shallowCopyWithParent6157 = addmethod2pos(obj6043, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6157, 7);
  int argcv_meth_ast_shallowCopyWithParent6157[] = {1};
  meth_meth_ast_shallowCopyWithParent6157->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6157);
  meth_meth_ast_shallowCopyWithParent6157->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6157->definitionLine = 1357;
  sourceObject = obj6043;
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6162 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6163 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6162);
// compiled call node returning call6163 (depth = 4)
  struct UserObject *obj6043_uo = (struct UserObject *)obj6043;
  obj6043_uo->super = call6163;
  sourceObject = obj6043;
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6164 == NULL) {
    strlit6164 = alloc_String("array");
    gc_root(strlit6164);
  }
// compiled string node returning strlit6164 (depth = 4)
  adddatum2(obj6043, strlit6164, 1);
  sourceObject = obj6043;
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  adddatum2(obj6043, *var_values, 2);
  sourceObject = obj6043;
  sourceObject = obj6043;
  sourceObject = obj6043;
  sourceObject = obj6043;
  sourceObject = obj6043;
objclass6043 = obj6043->class;
  objclass6043->definitionModule = modulename;
  objclass6043->definitionLine = 1318;
  (*(struct UserObject *)self).data[0] = lowerouter6043;
  self = oldself6043;
  selfslot = oldselfslot6043;
  stackframe = oldstackframe6043;
  gc_frame_end(frame);
  return obj6043;
}
Object meth_ast_memberNode6166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for memberNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for memberNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_memberNode (depth = 3)
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_target6176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "target");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for target (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for target");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6177 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6178 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6177);
// compiled call node returning call6178 (depth = 5)
// compiled member node returning call6178 (depth = 4)
  gc_frame_end(frame);
  return call6178;
}
Object meth_ast_nameString6179(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6180 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6181 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6180);
// compiled call node returning call6181 (depth = 5)
// compiled member node returning call6181 (depth = 4)
  gc_frame_end(frame);
  return call6181;
}
Object meth_ast_isMember6182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6183 = alloc_Boolean(1);
// compiled identifier node returning bool6183 (depth = 4)
  gc_frame_end(frame);
  return bool6183;
}
Object meth_ast_accept_40__41_from6184(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6186 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6187 = callmethod(*var_visitor, "visitMember()up",
    2, partcv, params);
  gc_frame_end(callframe6186);
// compiled call node returning call6187 (depth = 5)
  Object if6185 = done;
  if (istrue(call6187)) {
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6188 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6189 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6190 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6189);
// compiled call node returning call6190 (depth = 7)
// compiled member node returning call6190 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6191 = callmethod(call6190, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6188);
// compiled call node returning call6191 (depth = 5)
    gc_frame_newslot(call6191);
    if6185 = call6191;
  } else {
  }
// compiled if node returning if6185 (depth = 4)
  gc_frame_end(frame);
  return if6185;
}
Object meth_ast_map_40__41_parent6192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6193 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call6194 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6193);
// compiled call node returning call6194 (depth = 5)
  *var_n = call6194;
  if (call6194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6195 = gc_frame_new();
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6196 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6198 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6197);
// compiled call node returning call6198 (depth = 8)
// compiled member node returning call6198 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6199 = callmethod(call6198, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe6196);
// compiled call node returning call6199 (depth = 6)
  gc_frame_newslot(call6199);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call6199;
  partcv[0] = 1;
  Object call6200 = callmethod(*var_n, "in:=",
    1, partcv, params);
  gc_frame_end(callframe6195);
// compiled call node returning call6200 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6203 = alloc_Boolean(0);
// compiled identifier node returning bool6203 (depth = 6)
  int op_slot_right_6202 = gc_frame_newslot(bool6203);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6205 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6206 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6205);
// compiled call node returning call6206 (depth = 7)
// compiled member node returning call6206 (depth = 6)
  int op_slot_left_6202 = gc_frame_newslot(call6206);
  params[0] = bool6203;
  partcv[0] = 1;
  Object opresult6207 = callmethod(call6206, "!=", 1, partcv, params);
// compiled op node returning opresult6207 (depth = 5)
  Object if6201 = done;
  if (istrue(opresult6207)) {
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6208 = gc_frame_new();
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6209 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6211 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6210);
// compiled call node returning call6211 (depth = 9)
// compiled member node returning call6211 (depth = 8)
  gc_frame_newslot(call6211);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blk (depth = 8)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6212 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6213 = gc_frame_new();
// call case 3: self.outer request
  Object call6214 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6213);
// compiled call node returning call6214 (depth = 11)
// compiled member node returning call6214 (depth = 10)
  partcv[0] = 0;
  Object call6215 = callmethodflags(call6214, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6212);
// compiled call node returning call6215 (depth = 9)
// compiled member node returning call6215 (depth = 8)
  params[0] = call6211;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6216 = callmethodflags(call6215, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6209);
// compiled call node returning call6216 (depth = 7)
  gc_frame_newslot(call6216);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  params[0] = call6216;
  partcv[0] = 1;
  Object call6217 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6208);
// compiled call node returning call6217 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6201 = done;
  } else {
  }
// compiled if node returning if6201 (depth = 4)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6218 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6219 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6218);
// compiled call node returning call6219 (depth = 5)
  *var_n = call6219;
  if (call6219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6229(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit6231 == NULL) {
    strlit6231 = alloc_String("  ");
    gc_root(strlit6231);
  }
// compiled string node returning strlit6231 (depth = 8)
  int op_slot_right_6230 = gc_frame_newslot(strlit6231);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_6230 = gc_frame_newslot(*var_spc);
  params[0] = strlit6231;
  partcv[0] = 1;
  Object opresult6233 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6233 (depth = 7)
  *var_spc = opresult6233;
  if (opresult6233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6290(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6292 = gc_frame_new();
// starting to compile num node (depth = 10)
  Object num6293 = alloc_Float64(0);
// compiled num node returning num6293 (depth = 10)
  gc_frame_newslot(num6293);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = num6293;
  partcv[0] = 1;
  Object call6294 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6292);
// compiled call node returning call6294 (depth = 9)
  int op_slot_right_6291 = gc_frame_newslot(call6294);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6297 == NULL) {
    strlit6297 = alloc_String("    ");
    gc_root(strlit6297);
  }
// compiled string node returning strlit6297 (depth = 10)
  int op_slot_right_6296 = gc_frame_newslot(strlit6297);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_6299 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit6302 == NULL) {
    strlit6302 = alloc_String("""\x0a""");
    gc_root(strlit6302);
  }
// compiled string node returning strlit6302 (depth = 12)
  int op_slot_right_6301 = gc_frame_newslot(strlit6302);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_6301 = gc_frame_newslot(*var_s);
  params[0] = strlit6302;
  partcv[0] = 1;
  Object opresult6304 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6304 (depth = 11)
  int op_slot_left_6299 = gc_frame_newslot(opresult6304);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6305 = callmethod(opresult6304, "++", 1, partcv, params);
// compiled op node returning opresult6305 (depth = 10)
  int op_slot_left_6296 = gc_frame_newslot(opresult6305);
  params[0] = strlit6297;
  partcv[0] = 1;
  Object opresult6306 = callmethod(opresult6305, "++", 1, partcv, params);
// compiled op node returning opresult6306 (depth = 9)
  int op_slot_left_6291 = gc_frame_newslot(opresult6306);
  params[0] = call6294;
  partcv[0] = 1;
  Object opresult6307 = callmethod(opresult6306, "++", 1, partcv, params);
// compiled op node returning opresult6307 (depth = 8)
  *var_s = opresult6307;
  if (opresult6307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6221(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6222 == NULL) {
    strlit6222 = alloc_String("");
    gc_root(strlit6222);
  }
// compiled string node returning strlit6222 (depth = 5)
  *var_spc = strlit6222;
  if (strlit6222 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6223 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_6224 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num6226 = alloc_Float64(0);
// compiled num node returning num6226 (depth = 6)
  int op_slot_left_6224 = gc_frame_newslot(num6226);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6227 = callmethod(num6226, "..", 1, partcv, params);
// compiled op node returning opresult6227 (depth = 5)
  gc_frame_newslot(opresult6227);
// starting to compile block node (depth = 5)
  Object block6228 = alloc_Block(NULL, NULL, "ast", 1388);
  gc_frame_newslot(block6228);
// method _apply
  block_savedest(block6228);
  Object closure6229 = createclosure(2, "_apply");
  setclosureframe(closure6229, stackframe);
  addtoclosure(closure6229, var_spc);
  addtoclosure(closure6229, selfslot);
  struct UserObject *uo6229 = (struct UserObject*)block6228;
  uo6229->data[0] = (Object)closure6229;
  Method *meth_meth_ast__apply6229 = addmethod2pos(block6228, "_apply", &meth_ast__apply6229, 0);
  int argcv_meth_ast__apply6229[] = {1};
  meth_meth_ast__apply6229->type = alloc_MethodType(1, argcv_meth_ast__apply6229);
  meth_meth_ast__apply6229->definitionModule = modulename;
  meth_meth_ast__apply6229->definitionLine = 1381;
// compiled block node returning block6228 (depth = 5)
  gc_frame_newslot(block6228);
// call case 5: prelude request
  params[0] = opresult6227;
  params[1] = block6228;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6236 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6223);
// compiled call node returning call6236 (depth = 4)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6238 == NULL) {
    strlit6238 = alloc_String("""\xe2""""\x80""""\xba""""\x0a""");
    gc_root(strlit6238);
  }
// compiled string node returning strlit6238 (depth = 6)
  int op_slot_right_6237 = gc_frame_newslot(strlit6238);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6242 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6241);
// compiled call node returning call6242 (depth = 8)
// compiled member node returning call6242 (depth = 7)
  int op_slot_right_6240 = gc_frame_newslot(call6242);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6245 == NULL) {
    strlit6245 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6245);
  }
// compiled string node returning strlit6245 (depth = 8)
  int op_slot_right_6244 = gc_frame_newslot(strlit6245);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6248 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6249 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6248);
// compiled call node returning call6249 (depth = 9)
  int op_slot_right_6247 = gc_frame_newslot(call6249);
// starting to compile string node (depth = 9)
  if (strlit6251 == NULL) {
    strlit6251 = alloc_String("");
    gc_root(strlit6251);
  }
// compiled string node returning strlit6251 (depth = 9)
  int op_slot_left_6247 = gc_frame_newslot(strlit6251);
  params[0] = call6249;
  partcv[0] = 1;
  Object opresult6252 = callmethod(strlit6251, "++", 1, partcv, params);
// compiled op node returning opresult6252 (depth = 8)
  int op_slot_left_6244 = gc_frame_newslot(opresult6252);
  params[0] = strlit6245;
  partcv[0] = 1;
  Object opresult6253 = callmethod(opresult6252, "++", 1, partcv, params);
// compiled op node returning opresult6253 (depth = 7)
  int op_slot_left_6240 = gc_frame_newslot(opresult6253);
  params[0] = call6242;
  partcv[0] = 1;
  Object opresult6254 = callmethod(opresult6253, "++", 1, partcv, params);
// compiled op node returning opresult6254 (depth = 6)
  int op_slot_left_6237 = gc_frame_newslot(opresult6254);
  params[0] = strlit6238;
  partcv[0] = 1;
  Object opresult6255 = callmethod(opresult6254, "++", 1, partcv, params);
// compiled op node returning opresult6255 (depth = 5)
  *var_s = opresult6255;
  if (opresult6255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6257 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6258 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6259 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6258);
// compiled call node returning call6259 (depth = 8)
// compiled member node returning call6259 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6260 = callmethod(call6259, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6257);
// compiled call node returning call6260 (depth = 6)
  int op_slot_right_6256 = gc_frame_newslot(call6260);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_6262 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6262 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6264 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6264 (depth = 6)
  int op_slot_left_6256 = gc_frame_newslot(opresult6264);
  params[0] = call6260;
  partcv[0] = 1;
  Object opresult6265 = callmethod(opresult6264, "++", 1, partcv, params);
// compiled op node returning opresult6265 (depth = 5)
  *var_s = opresult6265;
  if (opresult6265 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6269 = alloc_Boolean(0);
// compiled identifier node returning bool6269 (depth = 6)
  int op_slot_right_6268 = gc_frame_newslot(bool6269);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6272 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6271);
// compiled call node returning call6272 (depth = 7)
// compiled member node returning call6272 (depth = 6)
  int op_slot_left_6268 = gc_frame_newslot(call6272);
  params[0] = bool6269;
  partcv[0] = 1;
  Object opresult6273 = callmethod(call6272, "!=", 1, partcv, params);
// compiled op node returning opresult6273 (depth = 5)
  Object if6267 = done;
  if (istrue(opresult6273)) {
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6275 == NULL) {
    strlit6275 = alloc_String("  Generics:");
    gc_root(strlit6275);
  }
// compiled string node returning strlit6275 (depth = 7)
  int op_slot_right_6274 = gc_frame_newslot(strlit6275);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6277 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6280 == NULL) {
    strlit6280 = alloc_String("""\x0a""");
    gc_root(strlit6280);
  }
// compiled string node returning strlit6280 (depth = 9)
  int op_slot_right_6279 = gc_frame_newslot(strlit6280);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6279 = gc_frame_newslot(*var_s);
  params[0] = strlit6280;
  partcv[0] = 1;
  Object opresult6282 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6282 (depth = 8)
  int op_slot_left_6277 = gc_frame_newslot(opresult6282);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6283 = callmethod(opresult6282, "++", 1, partcv, params);
// compiled op node returning opresult6283 (depth = 7)
  int op_slot_left_6274 = gc_frame_newslot(opresult6283);
  params[0] = strlit6275;
  partcv[0] = 1;
  Object opresult6284 = callmethod(opresult6283, "++", 1, partcv, params);
// compiled op node returning opresult6284 (depth = 6)
  *var_s = opresult6284;
  if (opresult6284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6286 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6288 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6287);
// compiled call node returning call6288 (depth = 7)
// compiled member node returning call6288 (depth = 6)
  gc_frame_newslot(call6288);
// starting to compile block node (depth = 6)
  Object block6289 = alloc_Block(NULL, NULL, "ast", 1395);
  gc_frame_newslot(block6289);
// method _apply
  block_savedest(block6289);
  Object closure6290 = createclosure(3, "_apply");
  setclosureframe(closure6290, stackframe);
  addtoclosure(closure6290, var_spc);
  addtoclosure(closure6290, var_s);
  addtoclosure(closure6290, selfslot);
  struct UserObject *uo6290 = (struct UserObject*)block6289;
  uo6290->data[0] = (Object)closure6290;
  Method *meth_meth_ast__apply6290 = addmethod2pos(block6289, "_apply", &meth_ast__apply6290, 0);
  int argcv_meth_ast__apply6290[] = {1};
  meth_meth_ast__apply6290->type = alloc_MethodType(1, argcv_meth_ast__apply6290);
  meth_meth_ast__apply6290->definitionModule = modulename;
  meth_meth_ast__apply6290->definitionLine = 1395;
// compiled block node returning block6289 (depth = 6)
  gc_frame_newslot(block6289);
// call case 5: prelude request
  params[0] = call6288;
  params[1] = block6289;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6310 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6286);
// compiled call node returning call6310 (depth = 5)
    gc_frame_newslot(call6310);
    if6267 = call6310;
  } else {
  }
// compiled if node returning if6267 (depth = 4)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6387(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6389 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6391 = alloc_Float64(1);
// compiled num node returning num6391 (depth = 11)
  int op_slot_right_6390 = gc_frame_newslot(num6391);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_6390 = gc_frame_newslot(*var_depth);
  params[0] = num6391;
  partcv[0] = 1;
  Object sum6393 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6393 (depth = 10)
  gc_frame_newslot(sum6393);
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6394 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ix (depth = 11)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6396 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6395);
// compiled call node returning call6396 (depth = 12)
// compiled member node returning call6396 (depth = 11)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6397 = callmethod(call6396, "at",
    1, partcv, params);
  gc_frame_end(callframe6394);
// compiled call node returning call6397 (depth = 10)
  params[0] = sum6393;
  partcv[0] = 1;
  Object call6398 = callmethod(call6397, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6389);
// compiled call node returning call6398 (depth = 9)
  int op_slot_right_6388 = gc_frame_newslot(call6398);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6388 = gc_frame_newslot(*var_s);
  params[0] = call6398;
  partcv[0] = 1;
  Object opresult6400 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6400 (depth = 8)
  *var_s = opresult6400;
  if (opresult6400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6311(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6312 == NULL) {
    strlit6312 = alloc_String("");
    gc_root(strlit6312);
  }
// compiled string node returning strlit6312 (depth = 5)
  *var_s = strlit6312;
  if (strlit6312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6315 == NULL) {
    strlit6315 = alloc_String("prefix");
    gc_root(strlit6315);
  }
// compiled string node returning strlit6315 (depth = 6)
  int op_slot_right_6314 = gc_frame_newslot(strlit6315);
// starting to compile call node (depth = 6)
  int callframe6317 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6318 = alloc_Float64(1);
// compiled num node returning num6318 (depth = 7)
  gc_frame_newslot(num6318);
// starting to compile num node (depth = 7)
  Object num6319 = alloc_Float64(6);
// compiled num node returning num6319 (depth = 7)
  gc_frame_newslot(num6319);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6321 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6320);
// compiled call node returning call6321 (depth = 8)
// compiled member node returning call6321 (depth = 7)
  params[0] = num6318;
  params[1] = num6319;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6322 = callmethod(call6321, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6317);
// compiled call node returning call6322 (depth = 6)
  int op_slot_left_6314 = gc_frame_newslot(call6322);
  params[0] = strlit6315;
  partcv[0] = 1;
  Object opresult6323 = callmethod(call6322, "==", 1, partcv, params);
// compiled op node returning opresult6323 (depth = 5)
  Object if6313 = done;
  if (istrue(opresult6323)) {
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6324 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num6325 = alloc_Float64(7);
// compiled num node returning num6325 (depth = 7)
  gc_frame_newslot(num6325);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6326 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6328 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6327);
// compiled call node returning call6328 (depth = 10)
// compiled member node returning call6328 (depth = 9)
  partcv[0] = 0;
  Object call6329 = callmethod(call6328, "size",
    1, partcv, params);
  gc_frame_end(callframe6326);
// compiled call node returning call6329 (depth = 8)
// compiled member node returning call6329 (depth = 7)
  gc_frame_newslot(call6329);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6331 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6330);
// compiled call node returning call6331 (depth = 8)
// compiled member node returning call6331 (depth = 7)
  params[0] = num6325;
  params[1] = call6329;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6332 = callmethod(call6331, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe6324);
// compiled call node returning call6332 (depth = 6)
  *var_s = call6332;
  if (call6332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6335 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num6336 = alloc_Float64(0);
// compiled num node returning num6336 (depth = 8)
  gc_frame_newslot(num6336);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6337 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6338 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6337);
// compiled call node returning call6338 (depth = 9)
// compiled member node returning call6338 (depth = 8)
  params[0] = num6336;
  partcv[0] = 1;
  Object call6339 = callmethod(call6338, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6335);
// compiled call node returning call6339 (depth = 7)
  int op_slot_right_6334 = gc_frame_newslot(call6339);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6342 == NULL) {
    strlit6342 = alloc_String(" ");
    gc_root(strlit6342);
  }
// compiled string node returning strlit6342 (depth = 8)
  int op_slot_right_6341 = gc_frame_newslot(strlit6342);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6341 = gc_frame_newslot(*var_s);
  params[0] = strlit6342;
  partcv[0] = 1;
  Object opresult6344 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6344 (depth = 7)
  int op_slot_left_6334 = gc_frame_newslot(opresult6344);
  params[0] = call6339;
  partcv[0] = 1;
  Object opresult6345 = callmethod(opresult6344, "++", 1, partcv, params);
// compiled op node returning opresult6345 (depth = 6)
  *var_s = opresult6345;
  if (opresult6345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6313 = done;
  } else {
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6349 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6348);
// compiled call node returning call6349 (depth = 8)
// compiled member node returning call6349 (depth = 7)
  int op_slot_right_6347 = gc_frame_newslot(call6349);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6352 == NULL) {
    strlit6352 = alloc_String(".");
    gc_root(strlit6352);
  }
// compiled string node returning strlit6352 (depth = 8)
  int op_slot_right_6351 = gc_frame_newslot(strlit6352);
// starting to compile call node (depth = 8)
  int callframe6354 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6355 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6356 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6355);
// compiled call node returning call6356 (depth = 10)
// compiled member node returning call6356 (depth = 9)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6357 = callmethod(call6356, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6354);
// compiled call node returning call6357 (depth = 8)
  int op_slot_left_6351 = gc_frame_newslot(call6357);
  params[0] = strlit6352;
  partcv[0] = 1;
  Object opresult6358 = callmethod(call6357, "++", 1, partcv, params);
// compiled op node returning opresult6358 (depth = 7)
  int op_slot_left_6347 = gc_frame_newslot(opresult6358);
  params[0] = call6349;
  partcv[0] = 1;
  Object opresult6359 = callmethod(opresult6358, "++", 1, partcv, params);
// compiled op node returning opresult6359 (depth = 6)
  *var_s = opresult6359;
  if (opresult6359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6313 = done;
  }
// compiled if node returning if6313 (depth = 4)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6363 = alloc_Boolean(0);
// compiled identifier node returning bool6363 (depth = 6)
  int op_slot_right_6362 = gc_frame_newslot(bool6363);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6366 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6365);
// compiled call node returning call6366 (depth = 7)
// compiled member node returning call6366 (depth = 6)
  int op_slot_left_6362 = gc_frame_newslot(call6366);
  params[0] = bool6363;
  partcv[0] = 1;
  Object opresult6367 = callmethod(call6366, "!=", 1, partcv, params);
// compiled op node returning opresult6367 (depth = 5)
  Object if6361 = done;
  if (istrue(opresult6367)) {
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6369 == NULL) {
    strlit6369 = alloc_String("<");
    gc_root(strlit6369);
  }
// compiled string node returning strlit6369 (depth = 7)
  int op_slot_right_6368 = gc_frame_newslot(strlit6369);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6368 = gc_frame_newslot(*var_s);
  params[0] = strlit6369;
  partcv[0] = 1;
  Object opresult6371 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6371 (depth = 6)
  *var_s = opresult6371;
  if (opresult6371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6373 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6376 = alloc_Float64(1);
// compiled num node returning num6376 (depth = 8)
  int op_slot_right_6375 = gc_frame_newslot(num6376);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6378 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6379 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6380 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6379);
// compiled call node returning call6380 (depth = 11)
// compiled member node returning call6380 (depth = 10)
  partcv[0] = 0;
  Object call6381 = callmethod(call6380, "size",
    1, partcv, params);
  gc_frame_end(callframe6378);
// compiled call node returning call6381 (depth = 9)
// compiled member node returning call6381 (depth = 8)
  int op_slot_left_6375 = gc_frame_newslot(call6381);
  params[0] = num6376;
  partcv[0] = 1;
  Object diff6382 = callmethod(call6381, "-", 1, partcv, params);
// compiled op node returning diff6382 (depth = 7)
  int op_slot_right_6374 = gc_frame_newslot(diff6382);
// starting to compile num node (depth = 7)
  Object num6384 = alloc_Float64(1);
// compiled num node returning num6384 (depth = 7)
  int op_slot_left_6374 = gc_frame_newslot(num6384);
  params[0] = diff6382;
  partcv[0] = 1;
  Object opresult6385 = callmethod(num6384, "..", 1, partcv, params);
// compiled op node returning opresult6385 (depth = 6)
  gc_frame_newslot(opresult6385);
// starting to compile block node (depth = 6)
  Object block6386 = alloc_Block(NULL, NULL, "ast", 1411);
  gc_frame_newslot(block6386);
// method _apply
  block_savedest(block6386);
  Object closure6387 = createclosure(3, "_apply");
  setclosureframe(closure6387, stackframe);
  addtoclosure(closure6387, var_depth);
  addtoclosure(closure6387, var_s);
  addtoclosure(closure6387, selfslot);
  struct UserObject *uo6387 = (struct UserObject*)block6386;
  uo6387->data[0] = (Object)closure6387;
  Method *meth_meth_ast__apply6387 = addmethod2pos(block6386, "_apply", &meth_ast__apply6387, 0);
  int argcv_meth_ast__apply6387[] = {1};
  meth_meth_ast__apply6387->type = alloc_MethodType(1, argcv_meth_ast__apply6387);
  meth_meth_ast__apply6387->definitionModule = modulename;
  meth_meth_ast__apply6387->definitionLine = 1411;
// compiled block node returning block6386 (depth = 6)
  gc_frame_newslot(block6386);
// call case 5: prelude request
  params[0] = opresult6385;
  params[1] = block6386;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6403 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6373);
// compiled call node returning call6403 (depth = 5)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6405 == NULL) {
    strlit6405 = alloc_String(">");
    gc_root(strlit6405);
  }
// compiled string node returning strlit6405 (depth = 7)
  int op_slot_right_6404 = gc_frame_newslot(strlit6405);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6408 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6410 = alloc_Float64(1);
// compiled num node returning num6410 (depth = 10)
  int op_slot_right_6409 = gc_frame_newslot(num6410);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6409 = gc_frame_newslot(*var_depth);
  params[0] = num6410;
  partcv[0] = 1;
  Object sum6412 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6412 (depth = 9)
  gc_frame_newslot(sum6412);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6413 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6415 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6414);
// compiled call node returning call6415 (depth = 12)
// compiled member node returning call6415 (depth = 11)
  partcv[0] = 0;
  Object call6416 = callmethod(call6415, "last",
    1, partcv, params);
  gc_frame_end(callframe6413);
// compiled call node returning call6416 (depth = 10)
// compiled member node returning call6416 (depth = 9)
  params[0] = sum6412;
  partcv[0] = 1;
  Object call6417 = callmethod(call6416, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6408);
// compiled call node returning call6417 (depth = 8)
  int op_slot_right_6407 = gc_frame_newslot(call6417);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6407 = gc_frame_newslot(*var_s);
  params[0] = call6417;
  partcv[0] = 1;
  Object opresult6419 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6419 (depth = 7)
  int op_slot_left_6404 = gc_frame_newslot(opresult6419);
  params[0] = strlit6405;
  partcv[0] = 1;
  Object opresult6420 = callmethod(opresult6419, "++", 1, partcv, params);
// compiled op node returning opresult6420 (depth = 6)
  *var_s = opresult6420;
  if (opresult6420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6361 = done;
  } else {
  }
// compiled if node returning if6361 (depth = 4)
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6424 == NULL) {
    strlit6424 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6424);
  }
// compiled string node returning strlit6424 (depth = 5)
  int op_slot_right_6423 = gc_frame_newslot(strlit6424);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6427 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6428 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6427);
// compiled call node returning call6428 (depth = 7)
// compiled member node returning call6428 (depth = 6)
  int op_slot_right_6426 = gc_frame_newslot(call6428);
// starting to compile string node (depth = 6)
  if (strlit6430 == NULL) {
    strlit6430 = alloc_String("Member""\xe2""""\x80""""\xb9""");
    gc_root(strlit6430);
  }
// compiled string node returning strlit6430 (depth = 6)
  int op_slot_left_6426 = gc_frame_newslot(strlit6430);
  params[0] = call6428;
  partcv[0] = 1;
  Object opresult6431 = callmethod(strlit6430, "++", 1, partcv, params);
// compiled op node returning opresult6431 (depth = 5)
  int op_slot_left_6423 = gc_frame_newslot(opresult6431);
  params[0] = strlit6424;
  partcv[0] = 1;
  Object opresult6432 = callmethod(opresult6431, "++", 1, partcv, params);
// compiled op node returning opresult6432 (depth = 4)
  gc_frame_end(frame);
  return opresult6432;
}
Object meth_ast_asIdentifier6433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6434 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6435 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6436 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6435);
// compiled call node returning call6436 (depth = 7)
// compiled member node returning call6436 (depth = 6)
  gc_frame_newslot(call6436);
// starting to compile identifier node (depth = 6)
  Object bool6437 = alloc_Boolean(0);
// compiled identifier node returning bool6437 (depth = 6)
  gc_frame_newslot(bool6437);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call6436;
  params[1] = bool6437;
  partcv[0] = 2;
  Object call6438 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6434);
// compiled call node returning call6438 (depth = 5)
  *var_resultNode = call6438;
  if (call6438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6439 = gc_frame_new();
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool6440 = alloc_Boolean(1);
// compiled identifier node returning bool6440 (depth = 6)
  gc_frame_newslot(bool6440);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = bool6440;
  partcv[0] = 1;
  Object call6441 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe6439);
// compiled call node returning call6441 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6442 = gc_frame_new();
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6443 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6444 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6443);
// compiled call node returning call6444 (depth = 7)
// compiled member node returning call6444 (depth = 6)
  gc_frame_newslot(call6444);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = call6444;
  partcv[0] = 1;
  Object call6445 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6442);
// compiled call node returning call6445 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6446 = gc_frame_new();
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6447 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6448 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6447);
// compiled call node returning call6448 (depth = 7)
// compiled member node returning call6448 (depth = 6)
  gc_frame_newslot(call6448);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = call6448;
  partcv[0] = 1;
  Object call6449 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6446);
// compiled call node returning call6449 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6450 = gc_frame_new();
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 4: self request
  params[0] = self;
  partcv[0] = 1;
  Object call6451 = callmethodflags(self, "parent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6450);
// compiled call node returning call6451 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_resultNode (depth = 5)
  return *var_resultNode;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopyWithParent6452(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_memberNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6453 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe6454 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6456 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6455);
// compiled call node returning call6456 (depth = 7)
// compiled member node returning call6456 (depth = 6)
  gc_frame_newslot(call6456);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_memberNode (depth = 6)
  params[0] = call6456;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call6457 = callmethod(*var_memberNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6454);
// compiled call node returning call6457 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6458 = callmethod(call6457, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe6453);
// compiled call node returning call6458 (depth = 4)
  gc_frame_end(frame);
  return call6458;
}
Object meth_ast_new6169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_memberNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_in_39_ = &(stackframe->slots[1]);
  *var_in_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6170 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6170 = alloc_userobj2(18,16, objclass6170);
  gc_frame_newslot(obj6170);
if (objclass6170 == NULL) {
  glfree(obj6170->class->name);
  obj6170->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6170, self, 0);
  addmethodreal(obj6170,"outer", &reader_ast_outer_6171);
  Object oldself6170 = self;
  struct StackFrameObject *oldstackframe6170 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6170);
  gc_frame_newslot((Object)stackframe);
  self = obj6170;
  Object *oldselfslot6170 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6170 = (*(struct UserObject *)self).data[0], lowerouter6170 = thisouter6170;
  if (inheritingObject6170) {
    struct UserObject *inho6170 = (struct UserObject *)inheritingObject6170;
    while (inho6170->super != GraceDefaultObject) inho6170 = (struct UserObject *)inho6170->super;
    inho6170->super = obj6170;
    self = inheritingObject6170;
    *selfslot = self;
    lowerouter6170 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6170;
  }
if (objclass6170 == NULL) {
  Method *reader6172 = addmethodrealflags(obj6170, "kind",&reader_ast_kind_6172, MFLAG_DEF);
  reader6172->definitionModule = modulename;
  reader6172->definitionLine = 1365;
}
adddatum2(obj6170, alloc_Undefined(), 1);
if (objclass6170 == NULL) {
  Method *reader6173 = addmethodrealflags(obj6170, "value",&reader_ast_value_6173, 0);
  Method *writer6173 = addmethodrealflags(obj6170, "value:=",&writer_ast_value_6173, 0);
  reader6173->definitionModule = modulename;
  writer6173->definitionModule = modulename;
  reader6173->definitionLine = 1366;
  writer6173->definitionLine = 1366;
}
obj6170->flags |= OFLAG_MUTABLE;
adddatum2(obj6170, alloc_Undefined(), 2);
if (objclass6170 == NULL) {
  Method *reader6174 = addmethodrealflags(obj6170, "in",&reader_ast_in_6174, 0);
  Method *writer6174 = addmethodrealflags(obj6170, "in:=",&writer_ast_in_6174, 0);
  reader6174->definitionModule = modulename;
  writer6174->definitionModule = modulename;
  reader6174->definitionLine = 1367;
  writer6174->definitionLine = 1367;
}
obj6170->flags |= OFLAG_MUTABLE;
adddatum2(obj6170, alloc_Undefined(), 3);
if (objclass6170 == NULL) {
  Method *reader6175 = addmethodrealflags(obj6170, "generics",&reader_ast_generics_6175, 0);
  Method *writer6175 = addmethodrealflags(obj6170, "generics:=",&writer_ast_generics_6175, 0);
  reader6175->definitionModule = modulename;
  writer6175->definitionModule = modulename;
  reader6175->definitionLine = 1369;
  writer6175->definitionLine = 1369;
}
obj6170->flags |= OFLAG_MUTABLE;
adddatum2(obj6170, alloc_Undefined(), 4);
// method target
  struct UserObject *uo6176 = (struct UserObject*)obj6170;
  uo6176->data[5] = emptyclosure;
  Method *meth_meth_ast_target6176 = addmethod2pos(obj6170, "target", &meth_ast_target6176, 5);
  int argcv_meth_ast_target6176[] = {0};
  meth_meth_ast_target6176->type = alloc_MethodType(1, argcv_meth_ast_target6176);
  meth_meth_ast_target6176->definitionModule = modulename;
  meth_meth_ast_target6176->definitionLine = 1369;
// method nameString
  struct UserObject *uo6179 = (struct UserObject*)obj6170;
  uo6179->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString6179 = addmethod2pos(obj6170, "nameString", &meth_ast_nameString6179, 6);
  int argcv_meth_ast_nameString6179[] = {0};
  meth_meth_ast_nameString6179->type = alloc_MethodType(1, argcv_meth_ast_nameString6179);
  meth_meth_ast_nameString6179->definitionModule = modulename;
  meth_meth_ast_nameString6179->definitionLine = 1370;
// method isMember
  struct UserObject *uo6182 = (struct UserObject*)obj6170;
  uo6182->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember6182 = addmethod2pos(obj6170, "isMember", &meth_ast_isMember6182, 7);
  int argcv_meth_ast_isMember6182[] = {0};
  meth_meth_ast_isMember6182->type = alloc_MethodType(1, argcv_meth_ast_isMember6182);
  meth_meth_ast_isMember6182->definitionModule = modulename;
  meth_meth_ast_isMember6182->definitionLine = 1371;
// method accept()from
  struct UserObject *uo6184 = (struct UserObject*)obj6170;
  uo6184->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6184 = addmethod2pos(obj6170, "accept()from", &meth_ast_accept_40__41_from6184, 8);
  int argcv_meth_ast_accept_40__41_from6184[] = {1, 1};
  meth_meth_ast_accept_40__41_from6184->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6184);
  meth_meth_ast_accept_40__41_from6184->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6184->definitionLine = 1372;
// method map()parent
  struct UserObject *uo6192 = (struct UserObject*)obj6170;
  uo6192->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6192 = addmethod2pos(obj6170, "map()parent", &meth_ast_map_40__41_parent6192, 9);
  int argcv_meth_ast_map_40__41_parent6192[] = {1, 1};
  meth_meth_ast_map_40__41_parent6192->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6192);
  meth_meth_ast_map_40__41_parent6192->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6192->definitionLine = 1377;
// method pretty
  struct UserObject *uo6221 = (struct UserObject*)obj6170;
  uo6221->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6221 = addmethod2pos(obj6170, "pretty", &meth_ast_pretty6221, 10);
  int argcv_meth_ast_pretty6221[] = {1};
  meth_meth_ast_pretty6221->type = alloc_MethodType(1, argcv_meth_ast_pretty6221);
  meth_meth_ast_pretty6221->definitionModule = modulename;
  meth_meth_ast_pretty6221->definitionLine = 1386;
// method toGrace
  struct UserObject *uo6311 = (struct UserObject*)obj6170;
  uo6311->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6311 = addmethod2pos(obj6170, "toGrace", &meth_ast_toGrace6311, 11);
  int argcv_meth_ast_toGrace6311[] = {1};
  meth_meth_ast_toGrace6311->type = alloc_MethodType(1, argcv_meth_ast_toGrace6311);
meth_meth_ast_toGrace6311->type->types[0] = type_Number;
meth_meth_ast_toGrace6311->type->names[0] = "depth";
  meth_meth_ast_toGrace6311->definitionModule = modulename;
  meth_meth_ast_toGrace6311->definitionLine = 1401;
// method asString
  struct UserObject *uo6422 = (struct UserObject*)obj6170;
  uo6422->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6422 = addmethod2pos(obj6170, "asString", &meth_ast_asString6422, 12);
  int argcv_meth_ast_asString6422[] = {0};
  meth_meth_ast_asString6422->type = alloc_MethodType(1, argcv_meth_ast_asString6422);
  meth_meth_ast_asString6422->definitionModule = modulename;
  meth_meth_ast_asString6422->definitionLine = 1418;
// method asIdentifier
  block_savedest(obj6170);
  Object closure6433 = createclosure(1, "asIdentifier");
  setclosureframe(closure6433, stackframe);
  addtoclosure(closure6433, var_identifierNode);
  struct UserObject *uo6433 = (struct UserObject*)obj6170;
  uo6433->data[13] = (Object)closure6433;
  Method *meth_meth_ast_asIdentifier6433 = addmethod2pos(obj6170, "asIdentifier", &meth_ast_asIdentifier6433, 13);
  int argcv_meth_ast_asIdentifier6433[] = {0};
  meth_meth_ast_asIdentifier6433->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6433);
  meth_meth_ast_asIdentifier6433->definitionModule = modulename;
  meth_meth_ast_asIdentifier6433->definitionLine = 1419;
// method shallowCopyWithParent
  block_savedest(obj6170);
  Object closure6452 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure6452, stackframe);
  addtoclosure(closure6452, var_nullNode);
  addtoclosure(closure6452, var_memberNode);
  struct UserObject *uo6452 = (struct UserObject*)obj6170;
  uo6452->data[14] = (Object)closure6452;
  Method *meth_meth_ast_shallowCopyWithParent6452 = addmethod2pos(obj6170, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6452, 14);
  int argcv_meth_ast_shallowCopyWithParent6452[] = {1};
  meth_meth_ast_shallowCopyWithParent6452->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6452);
  meth_meth_ast_shallowCopyWithParent6452->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6452->definitionLine = 1428;
  sourceObject = obj6170;
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6459 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6460 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6459);
// compiled call node returning call6460 (depth = 4)
  struct UserObject *obj6170_uo = (struct UserObject *)obj6170;
  obj6170_uo->super = call6460;
  sourceObject = obj6170;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6461 == NULL) {
    strlit6461 = alloc_String("member");
    gc_root(strlit6461);
  }
// compiled string node returning strlit6461 (depth = 4)
  adddatum2(obj6170, strlit6461, 1);
  sourceObject = obj6170;
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_what (depth = 4)
  adddatum2(obj6170, *var_what, 2);
  sourceObject = obj6170;
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_in_39_ (depth = 4)
  adddatum2(obj6170, *var_in_39_, 3);
  sourceObject = obj6170;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6462 = alloc_Boolean(0);
// compiled identifier node returning bool6462 (depth = 4)
  adddatum2(obj6170, bool6462, 4);
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
objclass6170 = obj6170->class;
  objclass6170->definitionModule = modulename;
  objclass6170->definitionLine = 1361;
  (*(struct UserObject *)self).data[0] = lowerouter6170;
  self = oldself6170;
  selfslot = oldselfslot6170;
  stackframe = oldstackframe6170;
  gc_frame_end(frame);
  return obj6170;
}
Object meth_ast_new6169_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_memberNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_in_39_ = &(stackframe->slots[1]);
  *var_in_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6170 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6170 = alloc_userobj2(18,16, objclass6170);
  gc_frame_newslot(obj6170);
if (objclass6170 == NULL) {
  glfree(obj6170->class->name);
  obj6170->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6170, self, 0);
  addmethodreal(obj6170,"outer", &reader_ast_outer_6171);
  Object oldself6170 = self;
  struct StackFrameObject *oldstackframe6170 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6170);
  gc_frame_newslot((Object)stackframe);
  self = obj6170;
  Object *oldselfslot6170 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6170 = (*(struct UserObject *)self).data[0], lowerouter6170 = thisouter6170;
  if (inheritingObject6170) {
    struct UserObject *inho6170 = (struct UserObject *)inheritingObject6170;
    while (inho6170->super != GraceDefaultObject) inho6170 = (struct UserObject *)inho6170->super;
    inho6170->super = obj6170;
    self = inheritingObject6170;
    *selfslot = self;
    lowerouter6170 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6170;
  }
if (objclass6170 == NULL) {
  Method *reader6172 = addmethodrealflags(obj6170, "kind",&reader_ast_kind_6172, MFLAG_DEF);
  reader6172->definitionModule = modulename;
  reader6172->definitionLine = 1365;
}
adddatum2(obj6170, alloc_Undefined(), 1);
if (objclass6170 == NULL) {
  Method *reader6173 = addmethodrealflags(obj6170, "value",&reader_ast_value_6173, 0);
  Method *writer6173 = addmethodrealflags(obj6170, "value:=",&writer_ast_value_6173, 0);
  reader6173->definitionModule = modulename;
  writer6173->definitionModule = modulename;
  reader6173->definitionLine = 1366;
  writer6173->definitionLine = 1366;
}
obj6170->flags |= OFLAG_MUTABLE;
adddatum2(obj6170, alloc_Undefined(), 2);
if (objclass6170 == NULL) {
  Method *reader6174 = addmethodrealflags(obj6170, "in",&reader_ast_in_6174, 0);
  Method *writer6174 = addmethodrealflags(obj6170, "in:=",&writer_ast_in_6174, 0);
  reader6174->definitionModule = modulename;
  writer6174->definitionModule = modulename;
  reader6174->definitionLine = 1367;
  writer6174->definitionLine = 1367;
}
obj6170->flags |= OFLAG_MUTABLE;
adddatum2(obj6170, alloc_Undefined(), 3);
if (objclass6170 == NULL) {
  Method *reader6175 = addmethodrealflags(obj6170, "generics",&reader_ast_generics_6175, 0);
  Method *writer6175 = addmethodrealflags(obj6170, "generics:=",&writer_ast_generics_6175, 0);
  reader6175->definitionModule = modulename;
  writer6175->definitionModule = modulename;
  reader6175->definitionLine = 1369;
  writer6175->definitionLine = 1369;
}
obj6170->flags |= OFLAG_MUTABLE;
adddatum2(obj6170, alloc_Undefined(), 4);
// method target
  struct UserObject *uo6176 = (struct UserObject*)obj6170;
  uo6176->data[5] = emptyclosure;
  Method *meth_meth_ast_target6176 = addmethod2pos(obj6170, "target", &meth_ast_target6176, 5);
  int argcv_meth_ast_target6176[] = {0};
  meth_meth_ast_target6176->type = alloc_MethodType(1, argcv_meth_ast_target6176);
  meth_meth_ast_target6176->definitionModule = modulename;
  meth_meth_ast_target6176->definitionLine = 1369;
// method nameString
  struct UserObject *uo6179 = (struct UserObject*)obj6170;
  uo6179->data[6] = emptyclosure;
  Method *meth_meth_ast_nameString6179 = addmethod2pos(obj6170, "nameString", &meth_ast_nameString6179, 6);
  int argcv_meth_ast_nameString6179[] = {0};
  meth_meth_ast_nameString6179->type = alloc_MethodType(1, argcv_meth_ast_nameString6179);
  meth_meth_ast_nameString6179->definitionModule = modulename;
  meth_meth_ast_nameString6179->definitionLine = 1370;
// method isMember
  struct UserObject *uo6182 = (struct UserObject*)obj6170;
  uo6182->data[7] = emptyclosure;
  Method *meth_meth_ast_isMember6182 = addmethod2pos(obj6170, "isMember", &meth_ast_isMember6182, 7);
  int argcv_meth_ast_isMember6182[] = {0};
  meth_meth_ast_isMember6182->type = alloc_MethodType(1, argcv_meth_ast_isMember6182);
  meth_meth_ast_isMember6182->definitionModule = modulename;
  meth_meth_ast_isMember6182->definitionLine = 1371;
// method accept()from
  struct UserObject *uo6184 = (struct UserObject*)obj6170;
  uo6184->data[8] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6184 = addmethod2pos(obj6170, "accept()from", &meth_ast_accept_40__41_from6184, 8);
  int argcv_meth_ast_accept_40__41_from6184[] = {1, 1};
  meth_meth_ast_accept_40__41_from6184->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6184);
  meth_meth_ast_accept_40__41_from6184->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6184->definitionLine = 1372;
// method map()parent
  struct UserObject *uo6192 = (struct UserObject*)obj6170;
  uo6192->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6192 = addmethod2pos(obj6170, "map()parent", &meth_ast_map_40__41_parent6192, 9);
  int argcv_meth_ast_map_40__41_parent6192[] = {1, 1};
  meth_meth_ast_map_40__41_parent6192->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6192);
  meth_meth_ast_map_40__41_parent6192->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6192->definitionLine = 1377;
// method pretty
  struct UserObject *uo6221 = (struct UserObject*)obj6170;
  uo6221->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty6221 = addmethod2pos(obj6170, "pretty", &meth_ast_pretty6221, 10);
  int argcv_meth_ast_pretty6221[] = {1};
  meth_meth_ast_pretty6221->type = alloc_MethodType(1, argcv_meth_ast_pretty6221);
  meth_meth_ast_pretty6221->definitionModule = modulename;
  meth_meth_ast_pretty6221->definitionLine = 1386;
// method toGrace
  struct UserObject *uo6311 = (struct UserObject*)obj6170;
  uo6311->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace6311 = addmethod2pos(obj6170, "toGrace", &meth_ast_toGrace6311, 11);
  int argcv_meth_ast_toGrace6311[] = {1};
  meth_meth_ast_toGrace6311->type = alloc_MethodType(1, argcv_meth_ast_toGrace6311);
meth_meth_ast_toGrace6311->type->types[0] = type_Number;
meth_meth_ast_toGrace6311->type->names[0] = "depth";
  meth_meth_ast_toGrace6311->definitionModule = modulename;
  meth_meth_ast_toGrace6311->definitionLine = 1401;
// method asString
  struct UserObject *uo6422 = (struct UserObject*)obj6170;
  uo6422->data[12] = emptyclosure;
  Method *meth_meth_ast_asString6422 = addmethod2pos(obj6170, "asString", &meth_ast_asString6422, 12);
  int argcv_meth_ast_asString6422[] = {0};
  meth_meth_ast_asString6422->type = alloc_MethodType(1, argcv_meth_ast_asString6422);
  meth_meth_ast_asString6422->definitionModule = modulename;
  meth_meth_ast_asString6422->definitionLine = 1418;
// method asIdentifier
  block_savedest(obj6170);
  Object closure6433 = createclosure(1, "asIdentifier");
  setclosureframe(closure6433, stackframe);
  addtoclosure(closure6433, var_identifierNode);
  struct UserObject *uo6433 = (struct UserObject*)obj6170;
  uo6433->data[13] = (Object)closure6433;
  Method *meth_meth_ast_asIdentifier6433 = addmethod2pos(obj6170, "asIdentifier", &meth_ast_asIdentifier6433, 13);
  int argcv_meth_ast_asIdentifier6433[] = {0};
  meth_meth_ast_asIdentifier6433->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier6433);
  meth_meth_ast_asIdentifier6433->definitionModule = modulename;
  meth_meth_ast_asIdentifier6433->definitionLine = 1419;
// method shallowCopyWithParent
  block_savedest(obj6170);
  Object closure6452 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure6452, stackframe);
  addtoclosure(closure6452, var_nullNode);
  addtoclosure(closure6452, var_memberNode);
  struct UserObject *uo6452 = (struct UserObject*)obj6170;
  uo6452->data[14] = (Object)closure6452;
  Method *meth_meth_ast_shallowCopyWithParent6452 = addmethod2pos(obj6170, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6452, 14);
  int argcv_meth_ast_shallowCopyWithParent6452[] = {1};
  meth_meth_ast_shallowCopyWithParent6452->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6452);
  meth_meth_ast_shallowCopyWithParent6452->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6452->definitionLine = 1428;
  sourceObject = obj6170;
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6459 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6460 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6459);
// compiled call node returning call6460 (depth = 4)
  struct UserObject *obj6170_uo = (struct UserObject *)obj6170;
  obj6170_uo->super = call6460;
  sourceObject = obj6170;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6461 == NULL) {
    strlit6461 = alloc_String("member");
    gc_root(strlit6461);
  }
// compiled string node returning strlit6461 (depth = 4)
  adddatum2(obj6170, strlit6461, 1);
  sourceObject = obj6170;
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_what (depth = 4)
  adddatum2(obj6170, *var_what, 2);
  sourceObject = obj6170;
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_in_39_ (depth = 4)
  adddatum2(obj6170, *var_in_39_, 3);
  sourceObject = obj6170;
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6462 = alloc_Boolean(0);
// compiled identifier node returning bool6462 (depth = 4)
  adddatum2(obj6170, bool6462, 4);
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
  sourceObject = obj6170;
objclass6170 = obj6170->class;
  objclass6170->definitionModule = modulename;
  objclass6170->definitionLine = 1361;
  (*(struct UserObject *)self).data[0] = lowerouter6170;
  self = oldself6170;
  selfslot = oldselfslot6170;
  stackframe = oldstackframe6170;
  gc_frame_end(frame);
  return obj6170;
}
Object meth_ast_genericNode6464(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for genericNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for genericNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_genericNode (depth = 3)
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast_nameString6473(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6474 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6475 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6476 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6475);
// compiled call node returning call6476 (depth = 7)
// compiled member node returning call6476 (depth = 6)
  partcv[0] = 0;
  Object call6477 = callmethod(call6476, "nameString",
    1, partcv, params);
  gc_frame_end(callframe6474);
// compiled call node returning call6477 (depth = 5)
// compiled member node returning call6477 (depth = 4)
  gc_frame_end(frame);
  return call6477;
}
Object meth_ast__apply6489(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6491 == NULL) {
    strlit6491 = alloc_String("");
    gc_root(strlit6491);
  }
// compiled string node returning strlit6491 (depth = 8)
  int op_slot_right_6490 = gc_frame_newslot(strlit6491);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  int op_slot_right_6493 = gc_frame_newslot(*var_each);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6496 == NULL) {
    strlit6496 = alloc_String("");
    gc_root(strlit6496);
  }
// compiled string node returning strlit6496 (depth = 10)
  int op_slot_right_6495 = gc_frame_newslot(strlit6496);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_right_6498 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 11)
  if (strlit6500 == NULL) {
    strlit6500 = alloc_String("");
    gc_root(strlit6500);
  }
// compiled string node returning strlit6500 (depth = 11)
  int op_slot_left_6498 = gc_frame_newslot(strlit6500);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult6501 = callmethod(strlit6500, "++", 1, partcv, params);
// compiled op node returning opresult6501 (depth = 10)
  int op_slot_left_6495 = gc_frame_newslot(opresult6501);
  params[0] = strlit6496;
  partcv[0] = 1;
  Object opresult6502 = callmethod(opresult6501, "++", 1, partcv, params);
// compiled op node returning opresult6502 (depth = 9)
  int op_slot_left_6493 = gc_frame_newslot(opresult6502);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult6503 = callmethod(opresult6502, "++", 1, partcv, params);
// compiled op node returning opresult6503 (depth = 8)
  int op_slot_left_6490 = gc_frame_newslot(opresult6503);
  params[0] = strlit6491;
  partcv[0] = 1;
  Object opresult6504 = callmethod(opresult6503, "++", 1, partcv, params);
// compiled op node returning opresult6504 (depth = 7)
  *var_s = opresult6504;
  if (opresult6504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6508(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6510 == NULL) {
    strlit6510 = alloc_String(", ");
    gc_root(strlit6510);
  }
// compiled string node returning strlit6510 (depth = 8)
  int op_slot_right_6509 = gc_frame_newslot(strlit6510);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6509 = gc_frame_newslot(*var_s);
  params[0] = strlit6510;
  partcv[0] = 1;
  Object opresult6512 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6512 (depth = 7)
  *var_s = opresult6512;
  if (opresult6512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_asString6478(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_base = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6480 == NULL) {
    strlit6480 = alloc_String("<");
    gc_root(strlit6480);
  }
// compiled string node returning strlit6480 (depth = 6)
  int op_slot_right_6479 = gc_frame_newslot(strlit6480);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_right_6482 = gc_frame_newslot(*var_base);
// starting to compile string node (depth = 7)
  if (strlit6484 == NULL) {
    strlit6484 = alloc_String("");
    gc_root(strlit6484);
  }
// compiled string node returning strlit6484 (depth = 7)
  int op_slot_left_6482 = gc_frame_newslot(strlit6484);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult6485 = callmethod(strlit6484, "++", 1, partcv, params);
// compiled op node returning opresult6485 (depth = 6)
  int op_slot_left_6479 = gc_frame_newslot(opresult6485);
  params[0] = strlit6480;
  partcv[0] = 1;
  Object opresult6486 = callmethod(opresult6485, "++", 1, partcv, params);
// compiled op node returning opresult6486 (depth = 5)
  *var_s = opresult6486;
  if (opresult6486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6487 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6488 = alloc_Block(NULL, NULL, "ast", 1441);
  gc_frame_newslot(block6488);
// method _apply
  block_savedest(block6488);
  Object closure6489 = createclosure(2, "_apply");
  setclosureframe(closure6489, stackframe);
  addtoclosure(closure6489, var_s);
  addtoclosure(closure6489, selfslot);
  struct UserObject *uo6489 = (struct UserObject*)block6488;
  uo6489->data[0] = (Object)closure6489;
  Method *meth_meth_ast__apply6489 = addmethod2pos(block6488, "_apply", &meth_ast__apply6489, 0);
  int argcv_meth_ast__apply6489[] = {1};
  meth_meth_ast__apply6489->type = alloc_MethodType(1, argcv_meth_ast__apply6489);
  meth_meth_ast__apply6489->definitionModule = modulename;
  meth_meth_ast__apply6489->definitionLine = 1438;
// compiled block node returning block6488 (depth = 5)
  gc_frame_newslot(block6488);
// starting to compile block node (depth = 5)
  Object block6507 = alloc_Block(NULL, NULL, "ast", 1441);
  gc_frame_newslot(block6507);
// method _apply
  block_savedest(block6507);
  Object closure6508 = createclosure(2, "_apply");
  setclosureframe(closure6508, stackframe);
  addtoclosure(closure6508, var_s);
  addtoclosure(closure6508, selfslot);
  struct UserObject *uo6508 = (struct UserObject*)block6507;
  uo6508->data[0] = (Object)closure6508;
  Method *meth_meth_ast__apply6508 = addmethod2pos(block6507, "_apply", &meth_ast__apply6508, 0);
  int argcv_meth_ast__apply6508[] = {0};
  meth_meth_ast__apply6508->type = alloc_MethodType(1, argcv_meth_ast__apply6508);
  meth_meth_ast__apply6508->definitionModule = modulename;
  meth_meth_ast__apply6508->definitionLine = 1438;
// compiled block node returning block6507 (depth = 5)
  gc_frame_newslot(block6507);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6515 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6516 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6515);
// compiled call node returning call6516 (depth = 6)
// compiled member node returning call6516 (depth = 5)
  params[0] = block6488;
  params[1] = block6507;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6517 = callmethod(call6516, "do()separatedBy",
    2, partcv, params);
  gc_frame_end(callframe6487);
// compiled call node returning call6517 (depth = 4)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6519 == NULL) {
    strlit6519 = alloc_String(">");
    gc_root(strlit6519);
  }
// compiled string node returning strlit6519 (depth = 5)
  int op_slot_right_6518 = gc_frame_newslot(strlit6519);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_left_6518 = gc_frame_newslot(*var_s);
  params[0] = strlit6519;
  partcv[0] = 1;
  Object opresult6521 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6521 (depth = 4)
  gc_frame_end(frame);
  return opresult6521;
}
Object meth_ast__apply6534(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6535 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6536 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6535);
// compiled call node returning call6536 (depth = 7)
  gc_frame_end(frame);
  return call6536;
}
Object meth_ast_accept_40__41_from6522(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6524 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6525 = callmethod(*var_visitor, "visitGeneric()up",
    2, partcv, params);
  gc_frame_end(callframe6524);
// compiled call node returning call6525 (depth = 5)
  Object if6523 = done;
  if (istrue(call6525)) {
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6526 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6527 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6528 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6527);
// compiled call node returning call6528 (depth = 7)
// compiled member node returning call6528 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6529 = callmethod(call6528, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6526);
// compiled call node returning call6529 (depth = 5)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6530 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6532 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6531);
// compiled call node returning call6532 (depth = 7)
// compiled member node returning call6532 (depth = 6)
  gc_frame_newslot(call6532);
// starting to compile block node (depth = 6)
  Object block6533 = alloc_Block(NULL, NULL, "ast", 1447);
  gc_frame_newslot(block6533);
// method _apply
  block_savedest(block6533);
  Object closure6534 = createclosure(2, "_apply");
  setclosureframe(closure6534, stackframe);
  addtoclosure(closure6534, var_visitor);
  addtoclosure(closure6534, selfslot);
  struct UserObject *uo6534 = (struct UserObject*)block6533;
  uo6534->data[0] = (Object)closure6534;
  Method *meth_meth_ast__apply6534 = addmethod2pos(block6533, "_apply", &meth_ast__apply6534, 0);
  int argcv_meth_ast__apply6534[] = {1};
  meth_meth_ast__apply6534->type = alloc_MethodType(1, argcv_meth_ast__apply6534);
  meth_meth_ast__apply6534->definitionModule = modulename;
  meth_meth_ast__apply6534->definitionLine = 1447;
// compiled block node returning block6533 (depth = 6)
  gc_frame_newslot(block6533);
// call case 5: prelude request
  params[0] = call6532;
  params[1] = block6533;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6538 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6530);
// compiled call node returning call6538 (depth = 5)
    gc_frame_newslot(call6538);
    if6523 = call6538;
  } else {
  }
// compiled if node returning if6523 (depth = 4)
  gc_frame_end(frame);
  return if6523;
}
Object meth_ast_map_40__41_parent6539(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6540 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call6541 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6540);
// compiled call node returning call6541 (depth = 5)
  *var_n = call6541;
  if (call6541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6542 = gc_frame_new();
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6543 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6545 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6544);
// compiled call node returning call6545 (depth = 8)
// compiled member node returning call6545 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6546 = callmethod(call6545, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe6543);
// compiled call node returning call6546 (depth = 6)
  gc_frame_newslot(call6546);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call6546;
  partcv[0] = 1;
  Object call6547 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe6542);
// compiled call node returning call6547 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6548 = gc_frame_new();
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6549 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6550 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6551 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6550);
// compiled call node returning call6551 (depth = 8)
// compiled member node returning call6551 (depth = 7)
  gc_frame_newslot(call6551);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6552 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6553 = gc_frame_new();
// call case 3: self.outer request
  Object call6554 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6553);
// compiled call node returning call6554 (depth = 10)
// compiled member node returning call6554 (depth = 9)
  partcv[0] = 0;
  Object call6555 = callmethodflags(call6554, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6552);
// compiled call node returning call6555 (depth = 8)
// compiled member node returning call6555 (depth = 7)
  params[0] = call6551;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6556 = callmethodflags(call6555, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6549);
// compiled call node returning call6556 (depth = 6)
  gc_frame_newslot(call6556);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call6556;
  partcv[0] = 1;
  Object call6557 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe6548);
// compiled call node returning call6557 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6558 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6559 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6558);
// compiled call node returning call6559 (depth = 5)
  *var_n = call6559;
  if (call6559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6578(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6580 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6582 = alloc_Float64(2);
// compiled num node returning num6582 (depth = 10)
  int op_slot_right_6581 = gc_frame_newslot(num6582);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6581 = gc_frame_newslot(*var_depth);
  params[0] = num6582;
  partcv[0] = 1;
  Object sum6584 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6584 (depth = 9)
  gc_frame_newslot(sum6584);
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6585 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6586 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6585);
// compiled call node returning call6586 (depth = 11)
// compiled member node returning call6586 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres6587 = callmethod(call6586, "[]", 1, partcv, params);
// compiled index node returning idxres6587 (depth = 9)
  params[0] = sum6584;
  partcv[0] = 1;
  Object call6588 = callmethod(idxres6587, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6580);
// compiled call node returning call6588 (depth = 8)
  int op_slot_right_6579 = gc_frame_newslot(call6588);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6579 = gc_frame_newslot(*var_s);
  params[0] = call6588;
  partcv[0] = 1;
  Object opresult6590 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6590 (depth = 7)
  *var_s = opresult6590;
  if (opresult6590 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6594 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6595 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6596 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6595);
// compiled call node returning call6596 (depth = 11)
// compiled member node returning call6596 (depth = 10)
  partcv[0] = 0;
  Object call6597 = callmethod(call6596, "size",
    1, partcv, params);
  gc_frame_end(callframe6594);
// compiled call node returning call6597 (depth = 9)
// compiled member node returning call6597 (depth = 8)
  int op_slot_right_6593 = gc_frame_newslot(call6597);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_6593 = gc_frame_newslot(*var_i);
  params[0] = call6597;
  partcv[0] = 1;
  Object opresult6599 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult6599 (depth = 7)
  Object if6592 = done;
  if (istrue(opresult6599)) {
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit6601 == NULL) {
    strlit6601 = alloc_String(", ");
    gc_root(strlit6601);
  }
// compiled string node returning strlit6601 (depth = 9)
  int op_slot_right_6600 = gc_frame_newslot(strlit6601);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6600 = gc_frame_newslot(*var_s);
  params[0] = strlit6601;
  partcv[0] = 1;
  Object opresult6603 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6603 (depth = 8)
  *var_s = opresult6603;
  if (opresult6603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if6592 = done;
  } else {
  }
// compiled if node returning if6592 (depth = 6)
  gc_frame_end(frame);
  return if6592;
}
Object meth_ast_pretty6561(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6563 == NULL) {
    strlit6563 = alloc_String("""\xe2""""\x80""""\xb9""self.value.value""\xe2""""\x80""""\xba""<");
    gc_root(strlit6563);
  }
// compiled string node returning strlit6563 (depth = 6)
  int op_slot_right_6562 = gc_frame_newslot(strlit6563);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6566 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6567 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6566);
// compiled call node returning call6567 (depth = 7)
  int op_slot_right_6565 = gc_frame_newslot(call6567);
// starting to compile string node (depth = 7)
  if (strlit6569 == NULL) {
    strlit6569 = alloc_String("");
    gc_root(strlit6569);
  }
// compiled string node returning strlit6569 (depth = 7)
  int op_slot_left_6565 = gc_frame_newslot(strlit6569);
  params[0] = call6567;
  partcv[0] = 1;
  Object opresult6570 = callmethod(strlit6569, "++", 1, partcv, params);
// compiled op node returning opresult6570 (depth = 6)
  int op_slot_left_6562 = gc_frame_newslot(opresult6570);
  params[0] = strlit6563;
  partcv[0] = 1;
  Object opresult6571 = callmethod(opresult6570, "++", 1, partcv, params);
// compiled op node returning opresult6571 (depth = 5)
  *var_s = opresult6571;
  if (opresult6571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6572 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6573 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6575 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6574);
// compiled call node returning call6575 (depth = 8)
// compiled member node returning call6575 (depth = 7)
  partcv[0] = 0;
  Object call6576 = callmethod(call6575, "indices",
    1, partcv, params);
  gc_frame_end(callframe6573);
// compiled call node returning call6576 (depth = 6)
// compiled member node returning call6576 (depth = 5)
  gc_frame_newslot(call6576);
// starting to compile block node (depth = 5)
  Object block6577 = alloc_Block(NULL, NULL, "ast", 1461);
  gc_frame_newslot(block6577);
// method _apply
  block_savedest(block6577);
  Object closure6578 = createclosure(3, "_apply");
  setclosureframe(closure6578, stackframe);
  addtoclosure(closure6578, var_depth);
  addtoclosure(closure6578, var_s);
  addtoclosure(closure6578, selfslot);
  struct UserObject *uo6578 = (struct UserObject*)block6577;
  uo6578->data[0] = (Object)closure6578;
  Method *meth_meth_ast__apply6578 = addmethod2pos(block6577, "_apply", &meth_ast__apply6578, 0);
  int argcv_meth_ast__apply6578[] = {1};
  meth_meth_ast__apply6578->type = alloc_MethodType(1, argcv_meth_ast__apply6578);
  meth_meth_ast__apply6578->definitionModule = modulename;
  meth_meth_ast__apply6578->definitionLine = 1461;
// compiled block node returning block6577 (depth = 5)
  gc_frame_newslot(block6577);
// call case 5: prelude request
  params[0] = call6576;
  params[1] = block6577;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6606 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6572);
// compiled call node returning call6606 (depth = 4)
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6608 == NULL) {
    strlit6608 = alloc_String(">");
    gc_root(strlit6608);
  }
// compiled string node returning strlit6608 (depth = 6)
  int op_slot_right_6607 = gc_frame_newslot(strlit6608);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6607 = gc_frame_newslot(*var_s);
  params[0] = strlit6608;
  partcv[0] = 1;
  Object opresult6610 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6610 (depth = 5)
  *var_s = opresult6610;
  if (opresult6610 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6627(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6629 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num6630 = alloc_Float64(0);
// compiled num node returning num6630 (depth = 9)
  gc_frame_newslot(num6630);
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6631 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6632 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6631);
// compiled call node returning call6632 (depth = 11)
// compiled member node returning call6632 (depth = 10)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres6633 = callmethod(call6632, "[]", 1, partcv, params);
// compiled index node returning idxres6633 (depth = 9)
  params[0] = num6630;
  partcv[0] = 1;
  Object call6634 = callmethod(idxres6633, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6629);
// compiled call node returning call6634 (depth = 8)
  int op_slot_right_6628 = gc_frame_newslot(call6634);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6628 = gc_frame_newslot(*var_s);
  params[0] = call6634;
  partcv[0] = 1;
  Object opresult6636 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6636 (depth = 7)
  *var_s = opresult6636;
  if (opresult6636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6640 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6641 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6642 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6641);
// compiled call node returning call6642 (depth = 11)
// compiled member node returning call6642 (depth = 10)
  partcv[0] = 0;
  Object call6643 = callmethod(call6642, "size",
    1, partcv, params);
  gc_frame_end(callframe6640);
// compiled call node returning call6643 (depth = 9)
// compiled member node returning call6643 (depth = 8)
  int op_slot_right_6639 = gc_frame_newslot(call6643);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_6639 = gc_frame_newslot(*var_i);
  params[0] = call6643;
  partcv[0] = 1;
  Object opresult6645 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult6645 (depth = 7)
  Object if6638 = done;
  if (istrue(opresult6645)) {
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit6647 == NULL) {
    strlit6647 = alloc_String(", ");
    gc_root(strlit6647);
  }
// compiled string node returning strlit6647 (depth = 9)
  int op_slot_right_6646 = gc_frame_newslot(strlit6647);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6646 = gc_frame_newslot(*var_s);
  params[0] = strlit6647;
  partcv[0] = 1;
  Object opresult6649 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6649 (depth = 8)
  *var_s = opresult6649;
  if (opresult6649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if6638 = done;
  } else {
  }
// compiled if node returning if6638 (depth = 6)
  gc_frame_end(frame);
  return if6638;
}
Object meth_ast_toGrace6612(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6614 == NULL) {
    strlit6614 = alloc_String("<");
    gc_root(strlit6614);
  }
// compiled string node returning strlit6614 (depth = 6)
  int op_slot_right_6613 = gc_frame_newslot(strlit6614);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6616 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6617 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6618 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6617);
// compiled call node returning call6618 (depth = 9)
// compiled member node returning call6618 (depth = 8)
  partcv[0] = 0;
  Object call6619 = callmethod(call6618, "value",
    1, partcv, params);
  gc_frame_end(callframe6616);
// compiled call node returning call6619 (depth = 7)
// compiled member node returning call6619 (depth = 6)
  int op_slot_left_6613 = gc_frame_newslot(call6619);
  params[0] = strlit6614;
  partcv[0] = 1;
  Object opresult6620 = callmethod(call6619, "++", 1, partcv, params);
// compiled op node returning opresult6620 (depth = 5)
  *var_s = opresult6620;
  if (opresult6620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6621 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6622 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6624 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6623);
// compiled call node returning call6624 (depth = 8)
// compiled member node returning call6624 (depth = 7)
  partcv[0] = 0;
  Object call6625 = callmethod(call6624, "indices",
    1, partcv, params);
  gc_frame_end(callframe6622);
// compiled call node returning call6625 (depth = 6)
// compiled member node returning call6625 (depth = 5)
  gc_frame_newslot(call6625);
// starting to compile block node (depth = 5)
  Object block6626 = alloc_Block(NULL, NULL, "ast", 1473);
  gc_frame_newslot(block6626);
// method _apply
  block_savedest(block6626);
  Object closure6627 = createclosure(2, "_apply");
  setclosureframe(closure6627, stackframe);
  addtoclosure(closure6627, var_s);
  addtoclosure(closure6627, selfslot);
  struct UserObject *uo6627 = (struct UserObject*)block6626;
  uo6627->data[0] = (Object)closure6627;
  Method *meth_meth_ast__apply6627 = addmethod2pos(block6626, "_apply", &meth_ast__apply6627, 0);
  int argcv_meth_ast__apply6627[] = {1};
  meth_meth_ast__apply6627->type = alloc_MethodType(1, argcv_meth_ast__apply6627);
  meth_meth_ast__apply6627->definitionModule = modulename;
  meth_meth_ast__apply6627->definitionLine = 1473;
// compiled block node returning block6626 (depth = 5)
  gc_frame_newslot(block6626);
// call case 5: prelude request
  params[0] = call6625;
  params[1] = block6626;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6652 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6621);
// compiled call node returning call6652 (depth = 4)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6654 == NULL) {
    strlit6654 = alloc_String(">");
    gc_root(strlit6654);
  }
// compiled string node returning strlit6654 (depth = 6)
  int op_slot_right_6653 = gc_frame_newslot(strlit6654);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_6653 = gc_frame_newslot(*var_s);
  params[0] = strlit6654;
  partcv[0] = 1;
  Object opresult6656 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6656 (depth = 5)
  *var_s = opresult6656;
  if (opresult6656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent6658(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_genericNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6659 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe6660 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6662 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6661);
// compiled call node returning call6662 (depth = 7)
// compiled member node returning call6662 (depth = 6)
  gc_frame_newslot(call6662);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_emptySeq (depth = 6)
  gc_frame_newslot(*var_emptySeq);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_genericNode (depth = 6)
  params[0] = call6662;
  params[1] = *var_emptySeq;
  partcv[0] = 2;
  Object call6663 = callmethod(*var_genericNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6660);
// compiled call node returning call6663 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6664 = callmethod(call6663, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe6659);
// compiled call node returning call6664 (depth = 4)
  gc_frame_end(frame);
  return call6664;
}
Object meth_ast_new6467(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_genericNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6468 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6468 = alloc_userobj2(13,12, objclass6468);
  gc_frame_newslot(obj6468);
if (objclass6468 == NULL) {
  glfree(obj6468->class->name);
  obj6468->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6468, self, 0);
  addmethodreal(obj6468,"outer", &reader_ast_outer_6469);
  Object oldself6468 = self;
  struct StackFrameObject *oldstackframe6468 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6468);
  gc_frame_newslot((Object)stackframe);
  self = obj6468;
  Object *oldselfslot6468 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6468 = (*(struct UserObject *)self).data[0], lowerouter6468 = thisouter6468;
  if (inheritingObject6468) {
    struct UserObject *inho6468 = (struct UserObject *)inheritingObject6468;
    while (inho6468->super != GraceDefaultObject) inho6468 = (struct UserObject *)inho6468->super;
    inho6468->super = obj6468;
    self = inheritingObject6468;
    *selfslot = self;
    lowerouter6468 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6468;
  }
if (objclass6468 == NULL) {
  Method *reader6470 = addmethodrealflags(obj6468, "kind",&reader_ast_kind_6470, MFLAG_DEF);
  reader6470->definitionModule = modulename;
  reader6470->definitionLine = 1435;
}
adddatum2(obj6468, alloc_Undefined(), 1);
if (objclass6468 == NULL) {
  Method *reader6471 = addmethodrealflags(obj6468, "value",&reader_ast_value_6471, 0);
  Method *writer6471 = addmethodrealflags(obj6468, "value:=",&writer_ast_value_6471, 0);
  reader6471->definitionModule = modulename;
  writer6471->definitionModule = modulename;
  reader6471->definitionLine = 1437;
  writer6471->definitionLine = 1437;
}
obj6468->flags |= OFLAG_MUTABLE;
adddatum2(obj6468, alloc_Undefined(), 2);
if (objclass6468 == NULL) {
  Method *reader6472 = addmethodrealflags(obj6468, "params",&reader_ast_params_6472, 0);
  Method *writer6472 = addmethodrealflags(obj6468, "params:=",&writer_ast_params_6472, 0);
  reader6472->definitionModule = modulename;
  writer6472->definitionModule = modulename;
  reader6472->definitionLine = 1438;
  writer6472->definitionLine = 1438;
}
obj6468->flags |= OFLAG_MUTABLE;
adddatum2(obj6468, alloc_Undefined(), 3);
// method nameString
  struct UserObject *uo6473 = (struct UserObject*)obj6468;
  uo6473->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6473 = addmethod2pos(obj6468, "nameString", &meth_ast_nameString6473, 4);
  int argcv_meth_ast_nameString6473[] = {0};
  meth_meth_ast_nameString6473->type = alloc_MethodType(1, argcv_meth_ast_nameString6473);
  meth_meth_ast_nameString6473->definitionModule = modulename;
  meth_meth_ast_nameString6473->definitionLine = 1438;
// method asString
  block_savedest(obj6468);
  Object closure6478 = createclosure(1, "asString");
  setclosureframe(closure6478, stackframe);
  addtoclosure(closure6478, var_base);
  struct UserObject *uo6478 = (struct UserObject*)obj6468;
  uo6478->data[5] = (Object)closure6478;
  Method *meth_meth_ast_asString6478 = addmethod2pos(obj6468, "asString", &meth_ast_asString6478, 5);
  int argcv_meth_ast_asString6478[] = {0};
  meth_meth_ast_asString6478->type = alloc_MethodType(1, argcv_meth_ast_asString6478);
  meth_meth_ast_asString6478->definitionModule = modulename;
  meth_meth_ast_asString6478->definitionLine = 1439;
// method accept()from
  struct UserObject *uo6522 = (struct UserObject*)obj6468;
  uo6522->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6522 = addmethod2pos(obj6468, "accept()from", &meth_ast_accept_40__41_from6522, 6);
  int argcv_meth_ast_accept_40__41_from6522[] = {1, 1};
  meth_meth_ast_accept_40__41_from6522->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6522);
  meth_meth_ast_accept_40__41_from6522->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6522->definitionLine = 1444;
// method map()parent
  struct UserObject *uo6539 = (struct UserObject*)obj6468;
  uo6539->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6539 = addmethod2pos(obj6468, "map()parent", &meth_ast_map_40__41_parent6539, 7);
  int argcv_meth_ast_map_40__41_parent6539[] = {1, 1};
  meth_meth_ast_map_40__41_parent6539->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6539);
  meth_meth_ast_map_40__41_parent6539->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6539->definitionLine = 1452;
// method pretty
  struct UserObject *uo6561 = (struct UserObject*)obj6468;
  uo6561->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6561 = addmethod2pos(obj6468, "pretty", &meth_ast_pretty6561, 8);
  int argcv_meth_ast_pretty6561[] = {1};
  meth_meth_ast_pretty6561->type = alloc_MethodType(1, argcv_meth_ast_pretty6561);
  meth_meth_ast_pretty6561->definitionModule = modulename;
  meth_meth_ast_pretty6561->definitionLine = 1459;
// method toGrace
  struct UserObject *uo6612 = (struct UserObject*)obj6468;
  uo6612->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6612 = addmethod2pos(obj6468, "toGrace", &meth_ast_toGrace6612, 9);
  int argcv_meth_ast_toGrace6612[] = {1};
  meth_meth_ast_toGrace6612->type = alloc_MethodType(1, argcv_meth_ast_toGrace6612);
meth_meth_ast_toGrace6612->type->types[0] = type_Number;
meth_meth_ast_toGrace6612->type->names[0] = "depth";
  meth_meth_ast_toGrace6612->definitionModule = modulename;
  meth_meth_ast_toGrace6612->definitionLine = 1471;
// method shallowCopyWithParent
  block_savedest(obj6468);
  Object closure6658 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure6658, stackframe);
  addtoclosure(closure6658, var_emptySeq);
  addtoclosure(closure6658, var_genericNode);
  struct UserObject *uo6658 = (struct UserObject*)obj6468;
  uo6658->data[10] = (Object)closure6658;
  Method *meth_meth_ast_shallowCopyWithParent6658 = addmethod2pos(obj6468, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6658, 10);
  int argcv_meth_ast_shallowCopyWithParent6658[] = {1};
  meth_meth_ast_shallowCopyWithParent6658->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6658);
  meth_meth_ast_shallowCopyWithParent6658->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6658->definitionLine = 1482;
  sourceObject = obj6468;
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6665 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6666 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6665);
// compiled call node returning call6666 (depth = 4)
  struct UserObject *obj6468_uo = (struct UserObject *)obj6468;
  obj6468_uo->super = call6666;
  sourceObject = obj6468;
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6667 == NULL) {
    strlit6667 = alloc_String("generic");
    gc_root(strlit6667);
  }
// compiled string node returning strlit6667 (depth = 4)
  adddatum2(obj6468, strlit6667, 1);
  sourceObject = obj6468;
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_base (depth = 4)
  adddatum2(obj6468, *var_base, 2);
  sourceObject = obj6468;
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj6468, *var_params_39_, 3);
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
objclass6468 = obj6468->class;
  objclass6468->definitionModule = modulename;
  objclass6468->definitionLine = 1432;
  (*(struct UserObject *)self).data[0] = lowerouter6468;
  self = oldself6468;
  selfslot = oldselfslot6468;
  stackframe = oldstackframe6468;
  gc_frame_end(frame);
  return obj6468;
}
Object meth_ast_new6467_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_emptySeq = getfromclosure(closure, 0);
  Object *var_genericNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6468 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6468 = alloc_userobj2(13,12, objclass6468);
  gc_frame_newslot(obj6468);
if (objclass6468 == NULL) {
  glfree(obj6468->class->name);
  obj6468->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6468, self, 0);
  addmethodreal(obj6468,"outer", &reader_ast_outer_6469);
  Object oldself6468 = self;
  struct StackFrameObject *oldstackframe6468 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6468);
  gc_frame_newslot((Object)stackframe);
  self = obj6468;
  Object *oldselfslot6468 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6468 = (*(struct UserObject *)self).data[0], lowerouter6468 = thisouter6468;
  if (inheritingObject6468) {
    struct UserObject *inho6468 = (struct UserObject *)inheritingObject6468;
    while (inho6468->super != GraceDefaultObject) inho6468 = (struct UserObject *)inho6468->super;
    inho6468->super = obj6468;
    self = inheritingObject6468;
    *selfslot = self;
    lowerouter6468 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6468;
  }
if (objclass6468 == NULL) {
  Method *reader6470 = addmethodrealflags(obj6468, "kind",&reader_ast_kind_6470, MFLAG_DEF);
  reader6470->definitionModule = modulename;
  reader6470->definitionLine = 1435;
}
adddatum2(obj6468, alloc_Undefined(), 1);
if (objclass6468 == NULL) {
  Method *reader6471 = addmethodrealflags(obj6468, "value",&reader_ast_value_6471, 0);
  Method *writer6471 = addmethodrealflags(obj6468, "value:=",&writer_ast_value_6471, 0);
  reader6471->definitionModule = modulename;
  writer6471->definitionModule = modulename;
  reader6471->definitionLine = 1437;
  writer6471->definitionLine = 1437;
}
obj6468->flags |= OFLAG_MUTABLE;
adddatum2(obj6468, alloc_Undefined(), 2);
if (objclass6468 == NULL) {
  Method *reader6472 = addmethodrealflags(obj6468, "params",&reader_ast_params_6472, 0);
  Method *writer6472 = addmethodrealflags(obj6468, "params:=",&writer_ast_params_6472, 0);
  reader6472->definitionModule = modulename;
  writer6472->definitionModule = modulename;
  reader6472->definitionLine = 1438;
  writer6472->definitionLine = 1438;
}
obj6468->flags |= OFLAG_MUTABLE;
adddatum2(obj6468, alloc_Undefined(), 3);
// method nameString
  struct UserObject *uo6473 = (struct UserObject*)obj6468;
  uo6473->data[4] = emptyclosure;
  Method *meth_meth_ast_nameString6473 = addmethod2pos(obj6468, "nameString", &meth_ast_nameString6473, 4);
  int argcv_meth_ast_nameString6473[] = {0};
  meth_meth_ast_nameString6473->type = alloc_MethodType(1, argcv_meth_ast_nameString6473);
  meth_meth_ast_nameString6473->definitionModule = modulename;
  meth_meth_ast_nameString6473->definitionLine = 1438;
// method asString
  block_savedest(obj6468);
  Object closure6478 = createclosure(1, "asString");
  setclosureframe(closure6478, stackframe);
  addtoclosure(closure6478, var_base);
  struct UserObject *uo6478 = (struct UserObject*)obj6468;
  uo6478->data[5] = (Object)closure6478;
  Method *meth_meth_ast_asString6478 = addmethod2pos(obj6468, "asString", &meth_ast_asString6478, 5);
  int argcv_meth_ast_asString6478[] = {0};
  meth_meth_ast_asString6478->type = alloc_MethodType(1, argcv_meth_ast_asString6478);
  meth_meth_ast_asString6478->definitionModule = modulename;
  meth_meth_ast_asString6478->definitionLine = 1439;
// method accept()from
  struct UserObject *uo6522 = (struct UserObject*)obj6468;
  uo6522->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6522 = addmethod2pos(obj6468, "accept()from", &meth_ast_accept_40__41_from6522, 6);
  int argcv_meth_ast_accept_40__41_from6522[] = {1, 1};
  meth_meth_ast_accept_40__41_from6522->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6522);
  meth_meth_ast_accept_40__41_from6522->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6522->definitionLine = 1444;
// method map()parent
  struct UserObject *uo6539 = (struct UserObject*)obj6468;
  uo6539->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6539 = addmethod2pos(obj6468, "map()parent", &meth_ast_map_40__41_parent6539, 7);
  int argcv_meth_ast_map_40__41_parent6539[] = {1, 1};
  meth_meth_ast_map_40__41_parent6539->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6539);
  meth_meth_ast_map_40__41_parent6539->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6539->definitionLine = 1452;
// method pretty
  struct UserObject *uo6561 = (struct UserObject*)obj6468;
  uo6561->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6561 = addmethod2pos(obj6468, "pretty", &meth_ast_pretty6561, 8);
  int argcv_meth_ast_pretty6561[] = {1};
  meth_meth_ast_pretty6561->type = alloc_MethodType(1, argcv_meth_ast_pretty6561);
  meth_meth_ast_pretty6561->definitionModule = modulename;
  meth_meth_ast_pretty6561->definitionLine = 1459;
// method toGrace
  struct UserObject *uo6612 = (struct UserObject*)obj6468;
  uo6612->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6612 = addmethod2pos(obj6468, "toGrace", &meth_ast_toGrace6612, 9);
  int argcv_meth_ast_toGrace6612[] = {1};
  meth_meth_ast_toGrace6612->type = alloc_MethodType(1, argcv_meth_ast_toGrace6612);
meth_meth_ast_toGrace6612->type->types[0] = type_Number;
meth_meth_ast_toGrace6612->type->names[0] = "depth";
  meth_meth_ast_toGrace6612->definitionModule = modulename;
  meth_meth_ast_toGrace6612->definitionLine = 1471;
// method shallowCopyWithParent
  block_savedest(obj6468);
  Object closure6658 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure6658, stackframe);
  addtoclosure(closure6658, var_emptySeq);
  addtoclosure(closure6658, var_genericNode);
  struct UserObject *uo6658 = (struct UserObject*)obj6468;
  uo6658->data[10] = (Object)closure6658;
  Method *meth_meth_ast_shallowCopyWithParent6658 = addmethod2pos(obj6468, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6658, 10);
  int argcv_meth_ast_shallowCopyWithParent6658[] = {1};
  meth_meth_ast_shallowCopyWithParent6658->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6658);
  meth_meth_ast_shallowCopyWithParent6658->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6658->definitionLine = 1482;
  sourceObject = obj6468;
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6665 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6666 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6665);
// compiled call node returning call6666 (depth = 4)
  struct UserObject *obj6468_uo = (struct UserObject *)obj6468;
  obj6468_uo->super = call6666;
  sourceObject = obj6468;
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit6667 == NULL) {
    strlit6667 = alloc_String("generic");
    gc_root(strlit6667);
  }
// compiled string node returning strlit6667 (depth = 4)
  adddatum2(obj6468, strlit6667, 1);
  sourceObject = obj6468;
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_base (depth = 4)
  adddatum2(obj6468, *var_base, 2);
  sourceObject = obj6468;
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_params_39_ (depth = 4)
  adddatum2(obj6468, *var_params_39_, 3);
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
  sourceObject = obj6468;
objclass6468 = obj6468->class;
  objclass6468->definitionModule = modulename;
  objclass6468->definitionLine = 1432;
  (*(struct UserObject *)self).data[0] = lowerouter6468;
  self = oldself6468;
  selfslot = oldselfslot6468;
  stackframe = oldstackframe6468;
  gc_frame_end(frame);
  return obj6468;
}
Object meth_ast_identifierNode6669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifierNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifierNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_nameString6684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6685 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6686 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6685);
// compiled call node returning call6686 (depth = 5)
// compiled member node returning call6686 (depth = 4)
  gc_frame_end(frame);
  return call6686;
}
Object meth_ast_isIdentifier6687(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool6688 = alloc_Boolean(1);
// compiled identifier node returning bool6688 (depth = 4)
  gc_frame_end(frame);
  return bool6688;
}
Object meth_ast_isAppliedOccurenceOfIdentifier6689(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isAppliedOccurenceOfIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isAppliedOccurenceOfIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isAppliedOccurenceOfIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6691 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6692 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6691);
// compiled call node returning call6692 (depth = 6)
// compiled member node returning call6692 (depth = 5)
  Object if6690 = done;
  if (istrue(call6692)) {
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool6693 = alloc_Boolean(0);
// compiled identifier node returning bool6693 (depth = 5)
    gc_frame_newslot(bool6693);
    if6690 = bool6693;
  } else {
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6694 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6695 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6696 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6695);
// compiled call node returning call6696 (depth = 8)
// compiled member node returning call6696 (depth = 7)
  partcv[0] = 0;
  Object call6697 = callmethod(call6696, "not",
    1, partcv, params);
  gc_frame_end(callframe6694);
// compiled call node returning call6697 (depth = 6)
// compiled member node returning call6697 (depth = 5)
    gc_frame_newslot(call6697);
    if6690 = call6697;
  }
// compiled if node returning if6690 (depth = 4)
  gc_frame_end(frame);
  return if6690;
}
Object meth_ast_declarationKind6698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6699 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6701 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6700);
// compiled call node returning call6701 (depth = 7)
// compiled member node returning call6701 (depth = 6)
  partcv[0] = 0;
  Object call6702 = callmethod(call6701, "declarationKind",
    1, partcv, params);
  gc_frame_end(callframe6699);
// compiled call node returning call6702 (depth = 5)
// compiled member node returning call6702 (depth = 4)
  gc_frame_end(frame);
  return call6702;
}
Object meth_ast_inTypePosition6703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inTypePosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inTypePosition (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inTypePosition");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6704 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6705 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6706 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6705);
// compiled call node returning call6706 (depth = 6)
// compiled member node returning call6706 (depth = 5)
  params[0] = self;
  partcv[0] = 1;
  Object call6707 = callmethod(call6706, "usesAsType",
    1, partcv, params);
  gc_frame_end(callframe6704);
// compiled call node returning call6707 (depth = 4)
  gc_frame_end(frame);
  return call6707;
}
Object meth_ast_usesAsType6708(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6710 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6711 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6710);
// compiled call node returning call6711 (depth = 6)
// compiled member node returning call6711 (depth = 5)
  int op_slot_right_6709 = gc_frame_newslot(call6711);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_6709 = gc_frame_newslot(*var_aNode);
  params[0] = call6711;
  partcv[0] = 1;
  Object opresult6713 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult6713 (depth = 4)
  gc_frame_end(frame);
  return opresult6713;
}
Object meth_ast_accept_40__41_from6714(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6716 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6717 = callmethod(*var_visitor, "visitIdentifier()up",
    2, partcv, params);
  gc_frame_end(callframe6716);
// compiled call node returning call6717 (depth = 5)
  Object if6715 = done;
  if (istrue(call6717)) {
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool6720 = alloc_Boolean(0);
// compiled identifier node returning bool6720 (depth = 7)
  int op_slot_right_6719 = gc_frame_newslot(bool6720);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6723 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6722);
// compiled call node returning call6723 (depth = 8)
// compiled member node returning call6723 (depth = 7)
  int op_slot_left_6719 = gc_frame_newslot(call6723);
  params[0] = bool6720;
  partcv[0] = 1;
  Object opresult6724 = callmethod(call6723, "!=", 1, partcv, params);
// compiled op node returning opresult6724 (depth = 6)
  Object if6718 = done;
  if (istrue(opresult6724)) {
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6725 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6726 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6727 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6726);
// compiled call node returning call6727 (depth = 8)
// compiled member node returning call6727 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6728 = callmethod(call6727, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe6725);
// compiled call node returning call6728 (depth = 6)
    gc_frame_newslot(call6728);
    if6718 = call6728;
  } else {
  }
// compiled if node returning if6718 (depth = 5)
    gc_frame_newslot(if6718);
    if6715 = if6718;
  } else {
  }
// compiled if node returning if6715 (depth = 4)
  gc_frame_end(frame);
  return if6715;
}
Object meth_ast_map_40__41_parent6729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6730 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call6731 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6730);
// compiled call node returning call6731 (depth = 5)
  *var_n = call6731;
  if (call6731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6732 = gc_frame_new();
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6733 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6734 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6735 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6734);
// compiled call node returning call6735 (depth = 8)
// compiled member node returning call6735 (depth = 7)
  gc_frame_newslot(call6735);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6736 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6737 = gc_frame_new();
// call case 3: self.outer request
  Object call6738 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6737);
// compiled call node returning call6738 (depth = 10)
// compiled member node returning call6738 (depth = 9)
  partcv[0] = 0;
  Object call6739 = callmethodflags(call6738, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6736);
// compiled call node returning call6739 (depth = 8)
// compiled member node returning call6739 (depth = 7)
  params[0] = call6735;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call6740 = callmethodflags(call6739, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6733);
// compiled call node returning call6740 (depth = 6)
  gc_frame_newslot(call6740);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call6740;
  partcv[0] = 1;
  Object call6741 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6732);
// compiled call node returning call6741 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6742 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6743 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6742);
// compiled call node returning call6743 (depth = 5)
  *var_n = call6743;
  if (call6743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6753(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit6755 == NULL) {
    strlit6755 = alloc_String("  ");
    gc_root(strlit6755);
  }
// compiled string node returning strlit6755 (depth = 8)
  int op_slot_right_6754 = gc_frame_newslot(strlit6755);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_6754 = gc_frame_newslot(*var_spc);
  params[0] = strlit6755;
  partcv[0] = 1;
  Object opresult6757 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult6757 (depth = 7)
  *var_spc = opresult6757;
  if (opresult6757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6856(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6858 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6860 = alloc_Float64(2);
// compiled num node returning num6860 (depth = 11)
  int op_slot_right_6859 = gc_frame_newslot(num6860);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_6859 = gc_frame_newslot(*var_depth);
  params[0] = num6860;
  partcv[0] = 1;
  Object sum6862 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6862 (depth = 10)
  gc_frame_newslot(sum6862);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_g (depth = 10)
  params[0] = sum6862;
  partcv[0] = 1;
  Object call6863 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6858);
// compiled call node returning call6863 (depth = 9)
  int op_slot_right_6857 = gc_frame_newslot(call6863);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6866 == NULL) {
    strlit6866 = alloc_String("  ");
    gc_root(strlit6866);
  }
// compiled string node returning strlit6866 (depth = 10)
  int op_slot_right_6865 = gc_frame_newslot(strlit6866);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_6868 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_6868 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6870 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6870 (depth = 10)
  int op_slot_left_6865 = gc_frame_newslot(opresult6870);
  params[0] = strlit6866;
  partcv[0] = 1;
  Object opresult6871 = callmethod(opresult6870, "++", 1, partcv, params);
// compiled op node returning opresult6871 (depth = 9)
  int op_slot_left_6857 = gc_frame_newslot(opresult6871);
  params[0] = call6863;
  partcv[0] = 1;
  Object opresult6872 = callmethod(opresult6871, "++", 1, partcv, params);
// compiled op node returning opresult6872 (depth = 8)
  *var_s = opresult6872;
  if (opresult6872 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6746 == NULL) {
    strlit6746 = alloc_String("");
    gc_root(strlit6746);
  }
// compiled string node returning strlit6746 (depth = 5)
  *var_spc = strlit6746;
  if (strlit6746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6747 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_6748 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num6750 = alloc_Float64(0);
// compiled num node returning num6750 (depth = 6)
  int op_slot_left_6748 = gc_frame_newslot(num6750);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6751 = callmethod(num6750, "..", 1, partcv, params);
// compiled op node returning opresult6751 (depth = 5)
  gc_frame_newslot(opresult6751);
// starting to compile block node (depth = 5)
  Object block6752 = alloc_Block(NULL, NULL, "ast", 1536);
  gc_frame_newslot(block6752);
// method _apply
  block_savedest(block6752);
  Object closure6753 = createclosure(2, "_apply");
  setclosureframe(closure6753, stackframe);
  addtoclosure(closure6753, var_spc);
  addtoclosure(closure6753, selfslot);
  struct UserObject *uo6753 = (struct UserObject*)block6752;
  uo6753->data[0] = (Object)closure6753;
  Method *meth_meth_ast__apply6753 = addmethod2pos(block6752, "_apply", &meth_ast__apply6753, 0);
  int argcv_meth_ast__apply6753[] = {1};
  meth_meth_ast__apply6753->type = alloc_MethodType(1, argcv_meth_ast__apply6753);
  meth_meth_ast__apply6753->definitionModule = modulename;
  meth_meth_ast__apply6753->definitionLine = 1530;
// compiled block node returning block6752 (depth = 5)
  gc_frame_newslot(block6752);
// call case 5: prelude request
  params[0] = opresult6751;
  params[1] = block6752;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6760 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6747);
// compiled call node returning call6760 (depth = 4)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6761 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6762 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe6761);
// compiled call node returning call6762 (depth = 5)
  *var_s = call6762;
  if (call6762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6764 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6765 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6764);
// compiled call node returning call6765 (depth = 6)
// compiled member node returning call6765 (depth = 5)
  Object if6763 = done;
  if (istrue(call6765)) {
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6767 == NULL) {
    strlit6767 = alloc_String(" Wildcard");
    gc_root(strlit6767);
  }
// compiled string node returning strlit6767 (depth = 7)
  int op_slot_right_6766 = gc_frame_newslot(strlit6767);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6766 = gc_frame_newslot(*var_s);
  params[0] = strlit6767;
  partcv[0] = 1;
  Object opresult6769 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6769 (depth = 6)
  *var_s = opresult6769;
  if (opresult6769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6763 = done;
  } else {
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6773 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6772);
// compiled call node returning call6773 (depth = 7)
// compiled member node returning call6773 (depth = 6)
  Object if6771 = done;
  if (istrue(call6773)) {
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6776 == NULL) {
    strlit6776 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6776);
  }
// compiled string node returning strlit6776 (depth = 9)
  int op_slot_right_6775 = gc_frame_newslot(strlit6776);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6779 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6780 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6779);
// compiled call node returning call6780 (depth = 11)
// compiled member node returning call6780 (depth = 10)
  int op_slot_right_6778 = gc_frame_newslot(call6780);
// starting to compile string node (depth = 10)
  if (strlit6782 == NULL) {
    strlit6782 = alloc_String("Binding""\xe2""""\x80""""\xb9""");
    gc_root(strlit6782);
  }
// compiled string node returning strlit6782 (depth = 10)
  int op_slot_left_6778 = gc_frame_newslot(strlit6782);
  params[0] = call6780;
  partcv[0] = 1;
  Object opresult6783 = callmethod(strlit6782, "++", 1, partcv, params);
// compiled op node returning opresult6783 (depth = 9)
  int op_slot_left_6775 = gc_frame_newslot(opresult6783);
  params[0] = strlit6776;
  partcv[0] = 1;
  Object opresult6784 = callmethod(opresult6783, "++", 1, partcv, params);
// compiled op node returning opresult6784 (depth = 8)
  int op_slot_right_6774 = gc_frame_newslot(opresult6784);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6774 = gc_frame_newslot(*var_s);
  params[0] = opresult6784;
  partcv[0] = 1;
  Object opresult6786 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6786 (depth = 7)
  *var_s = opresult6786;
  if (opresult6786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6771 = done;
  } else {
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6790 == NULL) {
    strlit6790 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6790);
  }
// compiled string node returning strlit6790 (depth = 9)
  int op_slot_right_6789 = gc_frame_newslot(strlit6790);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6793 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6794 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6793);
// compiled call node returning call6794 (depth = 11)
// compiled member node returning call6794 (depth = 10)
  int op_slot_right_6792 = gc_frame_newslot(call6794);
// starting to compile string node (depth = 10)
  if (strlit6796 == NULL) {
    strlit6796 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit6796);
  }
// compiled string node returning strlit6796 (depth = 10)
  int op_slot_left_6792 = gc_frame_newslot(strlit6796);
  params[0] = call6794;
  partcv[0] = 1;
  Object opresult6797 = callmethod(strlit6796, "++", 1, partcv, params);
// compiled op node returning opresult6797 (depth = 9)
  int op_slot_left_6789 = gc_frame_newslot(opresult6797);
  params[0] = strlit6790;
  partcv[0] = 1;
  Object opresult6798 = callmethod(opresult6797, "++", 1, partcv, params);
// compiled op node returning opresult6798 (depth = 8)
  int op_slot_right_6788 = gc_frame_newslot(opresult6798);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6788 = gc_frame_newslot(*var_s);
  params[0] = opresult6798;
  partcv[0] = 1;
  Object opresult6800 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6800 (depth = 7)
  *var_s = opresult6800;
  if (opresult6800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if6771 = done;
  }
// compiled if node returning if6771 (depth = 5)
    gc_frame_newslot(if6771);
    if6763 = if6771;
  }
// compiled if node returning if6763 (depth = 4)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6804 = alloc_Boolean(0);
// compiled identifier node returning bool6804 (depth = 6)
  int op_slot_right_6803 = gc_frame_newslot(bool6804);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6807 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6806);
// compiled call node returning call6807 (depth = 7)
// compiled member node returning call6807 (depth = 6)
  int op_slot_left_6803 = gc_frame_newslot(call6807);
  params[0] = bool6804;
  partcv[0] = 1;
  Object opresult6808 = callmethod(call6807, "!=", 1, partcv, params);
// compiled op node returning opresult6808 (depth = 5)
  Object if6802 = done;
  if (istrue(opresult6808)) {
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6810 == NULL) {
    strlit6810 = alloc_String("  Type: ");
    gc_root(strlit6810);
  }
// compiled string node returning strlit6810 (depth = 7)
  int op_slot_right_6809 = gc_frame_newslot(strlit6810);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6812 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6815 == NULL) {
    strlit6815 = alloc_String("""\x0a""");
    gc_root(strlit6815);
  }
// compiled string node returning strlit6815 (depth = 9)
  int op_slot_right_6814 = gc_frame_newslot(strlit6815);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6814 = gc_frame_newslot(*var_s);
  params[0] = strlit6815;
  partcv[0] = 1;
  Object opresult6817 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6817 (depth = 8)
  int op_slot_left_6812 = gc_frame_newslot(opresult6817);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6818 = callmethod(opresult6817, "++", 1, partcv, params);
// compiled op node returning opresult6818 (depth = 7)
  int op_slot_left_6809 = gc_frame_newslot(opresult6818);
  params[0] = strlit6810;
  partcv[0] = 1;
  Object opresult6819 = callmethod(opresult6818, "++", 1, partcv, params);
// compiled op node returning opresult6819 (depth = 6)
  *var_s = opresult6819;
  if (opresult6819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6822 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6824 = alloc_Float64(2);
// compiled num node returning num6824 (depth = 9)
  int op_slot_right_6823 = gc_frame_newslot(num6824);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6823 = gc_frame_newslot(*var_depth);
  params[0] = num6824;
  partcv[0] = 1;
  Object sum6826 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6826 (depth = 8)
  gc_frame_newslot(sum6826);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6828 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6827);
// compiled call node returning call6828 (depth = 9)
// compiled member node returning call6828 (depth = 8)
  params[0] = sum6826;
  partcv[0] = 1;
  Object call6829 = callmethod(call6828, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6822);
// compiled call node returning call6829 (depth = 7)
  int op_slot_right_6821 = gc_frame_newslot(call6829);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6821 = gc_frame_newslot(*var_s);
  params[0] = call6829;
  partcv[0] = 1;
  Object opresult6831 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6831 (depth = 6)
  *var_s = opresult6831;
  if (opresult6831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6802 = done;
  } else {
  }
// compiled if node returning if6802 (depth = 4)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6835 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6836 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6835);
// compiled call node returning call6836 (depth = 7)
// compiled member node returning call6836 (depth = 6)
  int op_slot_right_6834 = gc_frame_newslot(call6836);
// starting to compile identifier node (depth = 6)
  Object bool6838 = alloc_Boolean(0);
// compiled identifier node returning bool6838 (depth = 6)
  int op_slot_left_6834 = gc_frame_newslot(bool6838);
  params[0] = call6836;
  partcv[0] = 1;
  Object opresult6839 = callmethod(bool6838, "!=", 1, partcv, params);
// compiled op node returning opresult6839 (depth = 5)
  Object if6833 = done;
  if (istrue(opresult6839)) {
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6841 == NULL) {
    strlit6841 = alloc_String("Generics:");
    gc_root(strlit6841);
  }
// compiled string node returning strlit6841 (depth = 7)
  int op_slot_right_6840 = gc_frame_newslot(strlit6841);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_6843 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6846 == NULL) {
    strlit6846 = alloc_String("""\x0a""");
    gc_root(strlit6846);
  }
// compiled string node returning strlit6846 (depth = 9)
  int op_slot_right_6845 = gc_frame_newslot(strlit6846);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6845 = gc_frame_newslot(*var_s);
  params[0] = strlit6846;
  partcv[0] = 1;
  Object opresult6848 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6848 (depth = 8)
  int op_slot_left_6843 = gc_frame_newslot(opresult6848);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6849 = callmethod(opresult6848, "++", 1, partcv, params);
// compiled op node returning opresult6849 (depth = 7)
  int op_slot_left_6840 = gc_frame_newslot(opresult6849);
  params[0] = strlit6841;
  partcv[0] = 1;
  Object opresult6850 = callmethod(opresult6849, "++", 1, partcv, params);
// compiled op node returning opresult6850 (depth = 6)
  *var_s = opresult6850;
  if (opresult6850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6852 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6853 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6854 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6853);
// compiled call node returning call6854 (depth = 7)
// compiled member node returning call6854 (depth = 6)
  gc_frame_newslot(call6854);
// starting to compile block node (depth = 6)
  Object block6855 = alloc_Block(NULL, NULL, "ast", 1553);
  gc_frame_newslot(block6855);
// method _apply
  block_savedest(block6855);
  Object closure6856 = createclosure(4, "_apply");
  setclosureframe(closure6856, stackframe);
  addtoclosure(closure6856, var_depth);
  addtoclosure(closure6856, var_spc);
  addtoclosure(closure6856, var_s);
  addtoclosure(closure6856, selfslot);
  struct UserObject *uo6856 = (struct UserObject*)block6855;
  uo6856->data[0] = (Object)closure6856;
  Method *meth_meth_ast__apply6856 = addmethod2pos(block6855, "_apply", &meth_ast__apply6856, 0);
  int argcv_meth_ast__apply6856[] = {1};
  meth_meth_ast__apply6856->type = alloc_MethodType(1, argcv_meth_ast__apply6856);
  meth_meth_ast__apply6856->definitionModule = modulename;
  meth_meth_ast__apply6856->definitionLine = 1553;
// compiled block node returning block6855 (depth = 6)
  gc_frame_newslot(block6855);
// call case 5: prelude request
  params[0] = call6854;
  params[1] = block6855;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6875 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6852);
// compiled call node returning call6875 (depth = 5)
    gc_frame_newslot(call6875);
    if6833 = call6875;
  } else {
  }
// compiled if node returning if6833 (depth = 4)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6934(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6936 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6938 = alloc_Float64(1);
// compiled num node returning num6938 (depth = 11)
  int op_slot_right_6937 = gc_frame_newslot(num6938);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_6937 = gc_frame_newslot(*var_depth);
  params[0] = num6938;
  partcv[0] = 1;
  Object sum6940 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6940 (depth = 10)
  gc_frame_newslot(sum6940);
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6941 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ix (depth = 11)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6942 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6943 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6942);
// compiled call node returning call6943 (depth = 12)
// compiled member node returning call6943 (depth = 11)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call6944 = callmethod(call6943, "at",
    1, partcv, params);
  gc_frame_end(callframe6941);
// compiled call node returning call6944 (depth = 10)
  params[0] = sum6940;
  partcv[0] = 1;
  Object call6945 = callmethod(call6944, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6936);
// compiled call node returning call6945 (depth = 9)
  int op_slot_right_6935 = gc_frame_newslot(call6945);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_6935 = gc_frame_newslot(*var_s);
  params[0] = call6945;
  partcv[0] = 1;
  Object opresult6947 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6947 (depth = 8)
  *var_s = opresult6947;
  if (opresult6947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6876(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_s = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6879 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6878);
// compiled call node returning call6879 (depth = 6)
// compiled member node returning call6879 (depth = 5)
  Object if6877 = done;
  if (istrue(call6879)) {
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6880 == NULL) {
    strlit6880 = alloc_String("_");
    gc_root(strlit6880);
  }
// compiled string node returning strlit6880 (depth = 6)
  *var_s = strlit6880;
  if (strlit6880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6877 = done;
  } else {
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6882 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6883 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6882);
// compiled call node returning call6883 (depth = 7)
// compiled member node returning call6883 (depth = 6)
  *var_s = call6883;
  if (call6883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6877 = done;
  }
// compiled if node returning if6877 (depth = 4)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6887 = alloc_Boolean(0);
// compiled identifier node returning bool6887 (depth = 6)
  int op_slot_right_6886 = gc_frame_newslot(bool6887);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6889 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6890 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6889);
// compiled call node returning call6890 (depth = 7)
// compiled member node returning call6890 (depth = 6)
  int op_slot_left_6886 = gc_frame_newslot(call6890);
  params[0] = bool6887;
  partcv[0] = 1;
  Object opresult6891 = callmethod(call6890, "!=", 1, partcv, params);
// compiled op node returning opresult6891 (depth = 5)
  Object if6885 = done;
  if (istrue(opresult6891)) {
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6893 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6895 = alloc_Float64(1);
// compiled num node returning num6895 (depth = 9)
  int op_slot_right_6894 = gc_frame_newslot(num6895);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_6894 = gc_frame_newslot(*var_depth);
  params[0] = num6895;
  partcv[0] = 1;
  Object sum6897 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6897 (depth = 8)
  gc_frame_newslot(sum6897);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6898 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6899 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6898);
// compiled call node returning call6899 (depth = 9)
// compiled member node returning call6899 (depth = 8)
  params[0] = sum6897;
  partcv[0] = 1;
  Object call6900 = callmethod(call6899, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6893);
// compiled call node returning call6900 (depth = 7)
  int op_slot_right_6892 = gc_frame_newslot(call6900);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6903 == NULL) {
    strlit6903 = alloc_String(" : ");
    gc_root(strlit6903);
  }
// compiled string node returning strlit6903 (depth = 8)
  int op_slot_right_6902 = gc_frame_newslot(strlit6903);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6902 = gc_frame_newslot(*var_s);
  params[0] = strlit6903;
  partcv[0] = 1;
  Object opresult6905 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6905 (depth = 7)
  int op_slot_left_6892 = gc_frame_newslot(opresult6905);
  params[0] = call6900;
  partcv[0] = 1;
  Object opresult6906 = callmethod(opresult6905, "++", 1, partcv, params);
// compiled op node returning opresult6906 (depth = 6)
  *var_s = opresult6906;
  if (opresult6906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6885 = done;
  } else {
  }
// compiled if node returning if6885 (depth = 4)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6910 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6911 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6910);
// compiled call node returning call6911 (depth = 7)
// compiled member node returning call6911 (depth = 6)
  int op_slot_right_6909 = gc_frame_newslot(call6911);
// starting to compile identifier node (depth = 6)
  Object bool6913 = alloc_Boolean(0);
// compiled identifier node returning bool6913 (depth = 6)
  int op_slot_left_6909 = gc_frame_newslot(bool6913);
  params[0] = call6911;
  partcv[0] = 1;
  Object opresult6914 = callmethod(bool6913, "!=", 1, partcv, params);
// compiled op node returning opresult6914 (depth = 5)
  Object if6908 = done;
  if (istrue(opresult6914)) {
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6916 == NULL) {
    strlit6916 = alloc_String("<");
    gc_root(strlit6916);
  }
// compiled string node returning strlit6916 (depth = 7)
  int op_slot_right_6915 = gc_frame_newslot(strlit6916);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_6915 = gc_frame_newslot(*var_s);
  params[0] = strlit6916;
  partcv[0] = 1;
  Object opresult6918 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6918 (depth = 6)
  *var_s = opresult6918;
  if (opresult6918 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6920 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num6923 = alloc_Float64(1);
// compiled num node returning num6923 (depth = 8)
  int op_slot_right_6922 = gc_frame_newslot(num6923);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6926 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6927 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6926);
// compiled call node returning call6927 (depth = 11)
// compiled member node returning call6927 (depth = 10)
  partcv[0] = 0;
  Object call6928 = callmethod(call6927, "size",
    1, partcv, params);
  gc_frame_end(callframe6925);
// compiled call node returning call6928 (depth = 9)
// compiled member node returning call6928 (depth = 8)
  int op_slot_left_6922 = gc_frame_newslot(call6928);
  params[0] = num6923;
  partcv[0] = 1;
  Object diff6929 = callmethod(call6928, "-", 1, partcv, params);
// compiled op node returning diff6929 (depth = 7)
  int op_slot_right_6921 = gc_frame_newslot(diff6929);
// starting to compile num node (depth = 7)
  Object num6931 = alloc_Float64(1);
// compiled num node returning num6931 (depth = 7)
  int op_slot_left_6921 = gc_frame_newslot(num6931);
  params[0] = diff6929;
  partcv[0] = 1;
  Object opresult6932 = callmethod(num6931, "..", 1, partcv, params);
// compiled op node returning opresult6932 (depth = 6)
  gc_frame_newslot(opresult6932);
// starting to compile block node (depth = 6)
  Object block6933 = alloc_Block(NULL, NULL, "ast", 1571);
  gc_frame_newslot(block6933);
// method _apply
  block_savedest(block6933);
  Object closure6934 = createclosure(3, "_apply");
  setclosureframe(closure6934, stackframe);
  addtoclosure(closure6934, var_depth);
  addtoclosure(closure6934, var_s);
  addtoclosure(closure6934, selfslot);
  struct UserObject *uo6934 = (struct UserObject*)block6933;
  uo6934->data[0] = (Object)closure6934;
  Method *meth_meth_ast__apply6934 = addmethod2pos(block6933, "_apply", &meth_ast__apply6934, 0);
  int argcv_meth_ast__apply6934[] = {1};
  meth_meth_ast__apply6934->type = alloc_MethodType(1, argcv_meth_ast__apply6934);
  meth_meth_ast__apply6934->definitionModule = modulename;
  meth_meth_ast__apply6934->definitionLine = 1571;
// compiled block node returning block6933 (depth = 6)
  gc_frame_newslot(block6933);
// call case 5: prelude request
  params[0] = opresult6932;
  params[1] = block6933;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6950 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6920);
// compiled call node returning call6950 (depth = 5)
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit6952 == NULL) {
    strlit6952 = alloc_String(">");
    gc_root(strlit6952);
  }
// compiled string node returning strlit6952 (depth = 7)
  int op_slot_right_6951 = gc_frame_newslot(strlit6952);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6955 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num6957 = alloc_Float64(1);
// compiled num node returning num6957 (depth = 10)
  int op_slot_right_6956 = gc_frame_newslot(num6957);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_6956 = gc_frame_newslot(*var_depth);
  params[0] = num6957;
  partcv[0] = 1;
  Object sum6959 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum6959 (depth = 9)
  gc_frame_newslot(sum6959);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6960 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6961 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6962 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6961);
// compiled call node returning call6962 (depth = 12)
// compiled member node returning call6962 (depth = 11)
  partcv[0] = 0;
  Object call6963 = callmethod(call6962, "last",
    1, partcv, params);
  gc_frame_end(callframe6960);
// compiled call node returning call6963 (depth = 10)
// compiled member node returning call6963 (depth = 9)
  params[0] = sum6959;
  partcv[0] = 1;
  Object call6964 = callmethod(call6963, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6955);
// compiled call node returning call6964 (depth = 8)
  int op_slot_right_6954 = gc_frame_newslot(call6964);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_6954 = gc_frame_newslot(*var_s);
  params[0] = call6964;
  partcv[0] = 1;
  Object opresult6966 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult6966 (depth = 7)
  int op_slot_left_6951 = gc_frame_newslot(opresult6966);
  params[0] = strlit6952;
  partcv[0] = 1;
  Object opresult6967 = callmethod(opresult6966, "++", 1, partcv, params);
// compiled op node returning opresult6967 (depth = 6)
  *var_s = opresult6967;
  if (opresult6967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6908 = done;
  } else {
  }
// compiled if node returning if6908 (depth = 4)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString6969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6971 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6972 = callmethodflags(self, "isBindingOccurrence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6971);
// compiled call node returning call6972 (depth = 6)
// compiled member node returning call6972 (depth = 5)
  Object if6970 = done;
  if (istrue(call6972)) {
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6974 == NULL) {
    strlit6974 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6974);
  }
// compiled string node returning strlit6974 (depth = 6)
  int op_slot_right_6973 = gc_frame_newslot(strlit6974);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6977 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6978 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6977);
// compiled call node returning call6978 (depth = 8)
// compiled member node returning call6978 (depth = 7)
  int op_slot_right_6976 = gc_frame_newslot(call6978);
// starting to compile string node (depth = 7)
  if (strlit6980 == NULL) {
    strlit6980 = alloc_String("IdentifierBinding""\xe2""""\x80""""\xb9""");
    gc_root(strlit6980);
  }
// compiled string node returning strlit6980 (depth = 7)
  int op_slot_left_6976 = gc_frame_newslot(strlit6980);
  params[0] = call6978;
  partcv[0] = 1;
  Object opresult6981 = callmethod(strlit6980, "++", 1, partcv, params);
// compiled op node returning opresult6981 (depth = 6)
  int op_slot_left_6973 = gc_frame_newslot(opresult6981);
  params[0] = strlit6974;
  partcv[0] = 1;
  Object opresult6982 = callmethod(opresult6981, "++", 1, partcv, params);
// compiled op node returning opresult6982 (depth = 5)
    gc_frame_newslot(opresult6982);
    if6970 = opresult6982;
  } else {
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6984 == NULL) {
    strlit6984 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit6984);
  }
// compiled string node returning strlit6984 (depth = 6)
  int op_slot_right_6983 = gc_frame_newslot(strlit6984);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6987 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6988 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6987);
// compiled call node returning call6988 (depth = 8)
// compiled member node returning call6988 (depth = 7)
  int op_slot_right_6986 = gc_frame_newslot(call6988);
// starting to compile string node (depth = 7)
  if (strlit6990 == NULL) {
    strlit6990 = alloc_String("Identifier""\xe2""""\x80""""\xb9""");
    gc_root(strlit6990);
  }
// compiled string node returning strlit6990 (depth = 7)
  int op_slot_left_6986 = gc_frame_newslot(strlit6990);
  params[0] = call6988;
  partcv[0] = 1;
  Object opresult6991 = callmethod(strlit6990, "++", 1, partcv, params);
// compiled op node returning opresult6991 (depth = 6)
  int op_slot_left_6983 = gc_frame_newslot(opresult6991);
  params[0] = strlit6984;
  partcv[0] = 1;
  Object opresult6992 = callmethod(opresult6991, "++", 1, partcv, params);
// compiled op node returning opresult6992 (depth = 5)
    gc_frame_newslot(opresult6992);
    if6970 = opresult6992;
  }
// compiled if node returning if6970 (depth = 4)
  gc_frame_end(frame);
  return if6970;
}
Object meth_ast_shallowCopyWithParent6993(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6994 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe6995 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6996 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6997 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6996);
// compiled call node returning call6997 (depth = 7)
// compiled member node returning call6997 (depth = 6)
  gc_frame_newslot(call6997);
// starting to compile identifier node (depth = 6)
  Object bool6998 = alloc_Boolean(0);
// compiled identifier node returning bool6998 (depth = 6)
  gc_frame_newslot(bool6998);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call6997;
  params[1] = bool6998;
  partcv[0] = 2;
  Object call6999 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6995);
// compiled call node returning call6999 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7000 = callmethod(call6999, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe6994);
// compiled call node returning call7000 (depth = 4)
  gc_frame_end(frame);
  return call7000;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent7001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7002 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7003 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7002);
// compiled call node returning call7003 (depth = 4)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7004 = gc_frame_new();
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call7006 = callmethod(*var_other, "wildcard",
    1, partcv, params);
  gc_frame_end(callframe7005);
// compiled call node returning call7006 (depth = 7)
// compiled member node returning call7006 (depth = 6)
  gc_frame_newslot(call7006);
// call case 4: self request
  params[0] = call7006;
  partcv[0] = 1;
  Object call7007 = callmethodflags(self, "wildcard:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7004);
// compiled call node returning call7007 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7008 = gc_frame_new();
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call7010 = callmethod(*var_other, "isBindingOccurrence",
    1, partcv, params);
  gc_frame_end(callframe7009);
// compiled call node returning call7010 (depth = 7)
// compiled member node returning call7010 (depth = 6)
  gc_frame_newslot(call7010);
// call case 4: self request
  params[0] = call7010;
  partcv[0] = 1;
  Object call7011 = callmethodflags(self, "isBindingOccurrence:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7008);
// compiled call node returning call7011 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7012 = gc_frame_new();
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7013 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call7014 = callmethod(*var_other, "isDeclaredByParent",
    1, partcv, params);
  gc_frame_end(callframe7013);
// compiled call node returning call7014 (depth = 7)
// compiled member node returning call7014 (depth = 6)
  gc_frame_newslot(call7014);
// call case 4: self request
  params[0] = call7014;
  partcv[0] = 1;
  Object call7015 = callmethodflags(self, "isDeclaredByParent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7012);
// compiled call node returning call7015 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7016 = gc_frame_new();
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7017 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call7018 = callmethod(*var_other, "isAssigned",
    1, partcv, params);
  gc_frame_end(callframe7017);
// compiled call node returning call7018 (depth = 7)
// compiled member node returning call7018 (depth = 6)
  gc_frame_newslot(call7018);
// call case 4: self request
  params[0] = call7018;
  partcv[0] = 1;
  Object call7019 = callmethodflags(self, "isAssigned:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7016);
// compiled call node returning call7019 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7020 = gc_frame_new();
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7021 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call7022 = callmethod(*var_other, "inRequest",
    1, partcv, params);
  gc_frame_end(callframe7021);
// compiled call node returning call7022 (depth = 7)
// compiled member node returning call7022 (depth = 6)
  gc_frame_newslot(call7022);
// call case 4: self request
  params[0] = call7022;
  partcv[0] = 1;
  Object call7023 = callmethodflags(self, "inRequest:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7020);
// compiled call node returning call7023 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new6672(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6673 = alloc_userobj2(31,24, objclass6673);
  gc_frame_newslot(obj6673);
if (objclass6673 == NULL) {
  glfree(obj6673->class->name);
  obj6673->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6673, self, 0);
  addmethodreal(obj6673,"outer", &reader_ast_outer_6674);
  Object oldself6673 = self;
  struct StackFrameObject *oldstackframe6673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6673);
  gc_frame_newslot((Object)stackframe);
  self = obj6673;
  Object *oldselfslot6673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6673 = (*(struct UserObject *)self).data[0], lowerouter6673 = thisouter6673;
  if (inheritingObject6673) {
    struct UserObject *inho6673 = (struct UserObject *)inheritingObject6673;
    while (inho6673->super != GraceDefaultObject) inho6673 = (struct UserObject *)inho6673->super;
    inho6673->super = obj6673;
    self = inheritingObject6673;
    *selfslot = self;
    lowerouter6673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6673;
  }
if (objclass6673 == NULL) {
  Method *reader6675 = addmethodrealflags(obj6673, "kind",&reader_ast_kind_6675, MFLAG_DEF);
  reader6675->definitionModule = modulename;
  reader6675->definitionLine = 1489;
}
adddatum2(obj6673, alloc_Undefined(), 1);
if (objclass6673 == NULL) {
  Method *reader6676 = addmethodrealflags(obj6673, "value",&reader_ast_value_6676, 0);
  Method *writer6676 = addmethodrealflags(obj6673, "value:=",&writer_ast_value_6676, 0);
  reader6676->definitionModule = modulename;
  writer6676->definitionModule = modulename;
  reader6676->definitionLine = 1490;
  writer6676->definitionLine = 1490;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 2);
if (objclass6673 == NULL) {
  Method *reader6677 = addmethodrealflags(obj6673, "wildcard",&reader_ast_wildcard_6677, 0);
  Method *writer6677 = addmethodrealflags(obj6673, "wildcard:=",&writer_ast_wildcard_6677, 0);
  reader6677->definitionModule = modulename;
  writer6677->definitionModule = modulename;
  reader6677->definitionLine = 1491;
  writer6677->definitionLine = 1491;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 3);
if (objclass6673 == NULL) {
  Method *reader6678 = addmethodrealflags(obj6673, "dtype",&reader_ast_dtype_6678, 0);
  Method *writer6678 = addmethodrealflags(obj6673, "dtype:=",&writer_ast_dtype_6678, 0);
  reader6678->definitionModule = modulename;
  writer6678->definitionModule = modulename;
  reader6678->definitionLine = 1492;
  writer6678->definitionLine = 1492;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 4);
if (objclass6673 == NULL) {
  Method *reader6679 = addmethodrealflags(obj6673, "isBindingOccurrence",&reader_ast_isBindingOccurrence_6679, 0);
  Method *writer6679 = addmethodrealflags(obj6673, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_6679, 0);
  reader6679->definitionModule = modulename;
  writer6679->definitionModule = modulename;
  reader6679->definitionLine = 1493;
  writer6679->definitionLine = 1493;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 5);
if (objclass6673 == NULL) {
  Method *reader6680 = addmethodrealflags(obj6673, "isAssigned",&reader_ast_isAssigned_6680, 0);
  Method *writer6680 = addmethodrealflags(obj6673, "isAssigned:=",&writer_ast_isAssigned_6680, 0);
  reader6680->definitionModule = modulename;
  writer6680->definitionModule = modulename;
  reader6680->definitionLine = 1494;
  writer6680->definitionLine = 1494;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 6);
if (objclass6673 == NULL) {
  Method *reader6681 = addmethodrealflags(obj6673, "inRequest",&reader_ast_inRequest_6681, 0);
  Method *writer6681 = addmethodrealflags(obj6673, "inRequest:=",&writer_ast_inRequest_6681, 0);
  reader6681->definitionModule = modulename;
  writer6681->definitionModule = modulename;
  reader6681->definitionLine = 1495;
  writer6681->definitionLine = 1495;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 7);
if (objclass6673 == NULL) {
  Method *reader6682 = addmethodrealflags(obj6673, "generics",&reader_ast_generics_6682, 0);
  Method *writer6682 = addmethodrealflags(obj6673, "generics:=",&writer_ast_generics_6682, 0);
  reader6682->definitionModule = modulename;
  writer6682->definitionModule = modulename;
  reader6682->definitionLine = 1496;
  writer6682->definitionLine = 1496;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 8);
if (objclass6673 == NULL) {
  Method *reader6683 = addmethodrealflags(obj6673, "isDeclaredByParent",&reader_ast_isDeclaredByParent_6683, 0);
  Method *writer6683 = addmethodrealflags(obj6673, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_6683, 0);
  reader6683->definitionModule = modulename;
  writer6683->definitionModule = modulename;
  reader6683->definitionLine = 1498;
  writer6683->definitionLine = 1498;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 9);
// method nameString
  struct UserObject *uo6684 = (struct UserObject*)obj6673;
  uo6684->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6684 = addmethod2pos(obj6673, "nameString", &meth_ast_nameString6684, 10);
  int argcv_meth_ast_nameString6684[] = {0};
  meth_meth_ast_nameString6684->type = alloc_MethodType(1, argcv_meth_ast_nameString6684);
  meth_meth_ast_nameString6684->definitionModule = modulename;
  meth_meth_ast_nameString6684->definitionLine = 1498;
// method isIdentifier
  struct UserObject *uo6687 = (struct UserObject*)obj6673;
  uo6687->data[11] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6687 = addmethod2pos(obj6673, "isIdentifier", &meth_ast_isIdentifier6687, 11);
  int argcv_meth_ast_isIdentifier6687[] = {0};
  meth_meth_ast_isIdentifier6687->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6687);
  meth_meth_ast_isIdentifier6687->definitionModule = modulename;
  meth_meth_ast_isIdentifier6687->definitionLine = 1500;
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo6689 = (struct UserObject*)obj6673;
  uo6689->data[12] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6689 = addmethod2pos(obj6673, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6689, 12);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6689[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6689->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6689);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6689->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6689->definitionLine = 1502;
// method declarationKind
  struct UserObject *uo6698 = (struct UserObject*)obj6673;
  uo6698->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKind6698 = addmethod2pos(obj6673, "declarationKind", &meth_ast_declarationKind6698, 13);
  int argcv_meth_ast_declarationKind6698[] = {0};
  meth_meth_ast_declarationKind6698->type = alloc_MethodType(1, argcv_meth_ast_declarationKind6698);
  meth_meth_ast_declarationKind6698->definitionModule = modulename;
  meth_meth_ast_declarationKind6698->definitionLine = 1509;
// method inTypePosition
  struct UserObject *uo6703 = (struct UserObject*)obj6673;
  uo6703->data[14] = emptyclosure;
  Method *meth_meth_ast_inTypePosition6703 = addmethod2pos(obj6673, "inTypePosition", &meth_ast_inTypePosition6703, 14);
  int argcv_meth_ast_inTypePosition6703[] = {0};
  meth_meth_ast_inTypePosition6703->type = alloc_MethodType(1, argcv_meth_ast_inTypePosition6703);
  meth_meth_ast_inTypePosition6703->definitionModule = modulename;
  meth_meth_ast_inTypePosition6703->definitionLine = 1512;
// method usesAsType
  struct UserObject *uo6708 = (struct UserObject*)obj6673;
  uo6708->data[15] = emptyclosure;
  Method *meth_meth_ast_usesAsType6708 = addmethod2pos(obj6673, "usesAsType", &meth_ast_usesAsType6708, 15);
  int argcv_meth_ast_usesAsType6708[] = {1};
  meth_meth_ast_usesAsType6708->type = alloc_MethodType(1, argcv_meth_ast_usesAsType6708);
  meth_meth_ast_usesAsType6708->definitionModule = modulename;
  meth_meth_ast_usesAsType6708->definitionLine = 1518;
// method accept()from
  struct UserObject *uo6714 = (struct UserObject*)obj6673;
  uo6714->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6714 = addmethod2pos(obj6673, "accept()from", &meth_ast_accept_40__41_from6714, 16);
  int argcv_meth_ast_accept_40__41_from6714[] = {1, 1};
  meth_meth_ast_accept_40__41_from6714->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6714);
  meth_meth_ast_accept_40__41_from6714->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6714->definitionLine = 1521;
// method map()parent
  struct UserObject *uo6729 = (struct UserObject*)obj6673;
  uo6729->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6729 = addmethod2pos(obj6673, "map()parent", &meth_ast_map_40__41_parent6729, 17);
  int argcv_meth_ast_map_40__41_parent6729[] = {1, 1};
  meth_meth_ast_map_40__41_parent6729->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6729);
  meth_meth_ast_map_40__41_parent6729->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6729->definitionLine = 1528;
// method pretty
  struct UserObject *uo6745 = (struct UserObject*)obj6673;
  uo6745->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty6745 = addmethod2pos(obj6673, "pretty", &meth_ast_pretty6745, 18);
  int argcv_meth_ast_pretty6745[] = {1};
  meth_meth_ast_pretty6745->type = alloc_MethodType(1, argcv_meth_ast_pretty6745);
  meth_meth_ast_pretty6745->definitionModule = modulename;
  meth_meth_ast_pretty6745->definitionLine = 1534;
// method toGrace
  struct UserObject *uo6876 = (struct UserObject*)obj6673;
  uo6876->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace6876 = addmethod2pos(obj6673, "toGrace", &meth_ast_toGrace6876, 19);
  int argcv_meth_ast_toGrace6876[] = {1};
  meth_meth_ast_toGrace6876->type = alloc_MethodType(1, argcv_meth_ast_toGrace6876);
meth_meth_ast_toGrace6876->type->types[0] = type_Number;
meth_meth_ast_toGrace6876->type->names[0] = "depth";
  meth_meth_ast_toGrace6876->definitionModule = modulename;
  meth_meth_ast_toGrace6876->definitionLine = 1559;
// method asString
  struct UserObject *uo6969 = (struct UserObject*)obj6673;
  uo6969->data[20] = emptyclosure;
  Method *meth_meth_ast_asString6969 = addmethod2pos(obj6673, "asString", &meth_ast_asString6969, 20);
  int argcv_meth_ast_asString6969[] = {0};
  meth_meth_ast_asString6969->type = alloc_MethodType(1, argcv_meth_ast_asString6969);
  meth_meth_ast_asString6969->definitionModule = modulename;
  meth_meth_ast_asString6969->definitionLine = 1579;
// method shallowCopyWithParent
  block_savedest(obj6673);
  Object closure6993 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure6993, stackframe);
  addtoclosure(closure6993, var_identifierNode);
  struct UserObject *uo6993 = (struct UserObject*)obj6673;
  uo6993->data[21] = (Object)closure6993;
  Method *meth_meth_ast_shallowCopyWithParent6993 = addmethod2pos(obj6673, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6993, 21);
  int argcv_meth_ast_shallowCopyWithParent6993[] = {1};
  meth_meth_ast_shallowCopyWithParent6993->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6993);
  meth_meth_ast_shallowCopyWithParent6993->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6993->definitionLine = 1586;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo7001 = (struct UserObject*)obj6673;
  uo7001->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001 = addmethod2pos(obj6673, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent7001, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent7001[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent7001);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001->definitionLine = 1589;
  sourceObject = obj6673;
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7024 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7025 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7024);
// compiled call node returning call7025 (depth = 4)
  struct UserObject *obj6673_uo = (struct UserObject *)obj6673;
  obj6673_uo->super = call7025;
  sourceObject = obj6673;
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7026 == NULL) {
    strlit7026 = alloc_String("identifier");
    gc_root(strlit7026);
  }
// compiled string node returning strlit7026 (depth = 4)
  adddatum2(obj6673, strlit7026, 1);
  sourceObject = obj6673;
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  adddatum2(obj6673, *var_name, 2);
  sourceObject = obj6673;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7027 = alloc_Boolean(0);
// compiled identifier node returning bool7027 (depth = 4)
  adddatum2(obj6673, bool7027, 3);
  sourceObject = obj6673;
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj6673, *var_dtype_39_, 4);
  sourceObject = obj6673;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7028 = alloc_Boolean(0);
// compiled identifier node returning bool7028 (depth = 4)
  adddatum2(obj6673, bool7028, 5);
  sourceObject = obj6673;
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7029 = alloc_Boolean(0);
// compiled identifier node returning bool7029 (depth = 4)
  adddatum2(obj6673, bool7029, 6);
  sourceObject = obj6673;
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7030 = alloc_Boolean(0);
// compiled identifier node returning bool7030 (depth = 4)
  adddatum2(obj6673, bool7030, 7);
  sourceObject = obj6673;
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7031 = alloc_Boolean(0);
// compiled identifier node returning bool7031 (depth = 4)
  adddatum2(obj6673, bool7031, 8);
  sourceObject = obj6673;
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7032 = alloc_Boolean(0);
// compiled identifier node returning bool7032 (depth = 4)
  adddatum2(obj6673, bool7032, 9);
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
objclass6673 = obj6673->class;
  objclass6673->definitionModule = modulename;
  objclass6673->definitionLine = 1486;
  (*(struct UserObject *)self).data[0] = lowerouter6673;
  self = oldself6673;
  selfslot = oldselfslot6673;
  stackframe = oldstackframe6673;
  gc_frame_end(frame);
  return obj6673;
}
Object meth_ast_new6672_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6673 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6673 = alloc_userobj2(31,24, objclass6673);
  gc_frame_newslot(obj6673);
if (objclass6673 == NULL) {
  glfree(obj6673->class->name);
  obj6673->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6673, self, 0);
  addmethodreal(obj6673,"outer", &reader_ast_outer_6674);
  Object oldself6673 = self;
  struct StackFrameObject *oldstackframe6673 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6673);
  gc_frame_newslot((Object)stackframe);
  self = obj6673;
  Object *oldselfslot6673 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6673 = (*(struct UserObject *)self).data[0], lowerouter6673 = thisouter6673;
  if (inheritingObject6673) {
    struct UserObject *inho6673 = (struct UserObject *)inheritingObject6673;
    while (inho6673->super != GraceDefaultObject) inho6673 = (struct UserObject *)inho6673->super;
    inho6673->super = obj6673;
    self = inheritingObject6673;
    *selfslot = self;
    lowerouter6673 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6673;
  }
if (objclass6673 == NULL) {
  Method *reader6675 = addmethodrealflags(obj6673, "kind",&reader_ast_kind_6675, MFLAG_DEF);
  reader6675->definitionModule = modulename;
  reader6675->definitionLine = 1489;
}
adddatum2(obj6673, alloc_Undefined(), 1);
if (objclass6673 == NULL) {
  Method *reader6676 = addmethodrealflags(obj6673, "value",&reader_ast_value_6676, 0);
  Method *writer6676 = addmethodrealflags(obj6673, "value:=",&writer_ast_value_6676, 0);
  reader6676->definitionModule = modulename;
  writer6676->definitionModule = modulename;
  reader6676->definitionLine = 1490;
  writer6676->definitionLine = 1490;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 2);
if (objclass6673 == NULL) {
  Method *reader6677 = addmethodrealflags(obj6673, "wildcard",&reader_ast_wildcard_6677, 0);
  Method *writer6677 = addmethodrealflags(obj6673, "wildcard:=",&writer_ast_wildcard_6677, 0);
  reader6677->definitionModule = modulename;
  writer6677->definitionModule = modulename;
  reader6677->definitionLine = 1491;
  writer6677->definitionLine = 1491;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 3);
if (objclass6673 == NULL) {
  Method *reader6678 = addmethodrealflags(obj6673, "dtype",&reader_ast_dtype_6678, 0);
  Method *writer6678 = addmethodrealflags(obj6673, "dtype:=",&writer_ast_dtype_6678, 0);
  reader6678->definitionModule = modulename;
  writer6678->definitionModule = modulename;
  reader6678->definitionLine = 1492;
  writer6678->definitionLine = 1492;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 4);
if (objclass6673 == NULL) {
  Method *reader6679 = addmethodrealflags(obj6673, "isBindingOccurrence",&reader_ast_isBindingOccurrence_6679, 0);
  Method *writer6679 = addmethodrealflags(obj6673, "isBindingOccurrence:=",&writer_ast_isBindingOccurrence_6679, 0);
  reader6679->definitionModule = modulename;
  writer6679->definitionModule = modulename;
  reader6679->definitionLine = 1493;
  writer6679->definitionLine = 1493;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 5);
if (objclass6673 == NULL) {
  Method *reader6680 = addmethodrealflags(obj6673, "isAssigned",&reader_ast_isAssigned_6680, 0);
  Method *writer6680 = addmethodrealflags(obj6673, "isAssigned:=",&writer_ast_isAssigned_6680, 0);
  reader6680->definitionModule = modulename;
  writer6680->definitionModule = modulename;
  reader6680->definitionLine = 1494;
  writer6680->definitionLine = 1494;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 6);
if (objclass6673 == NULL) {
  Method *reader6681 = addmethodrealflags(obj6673, "inRequest",&reader_ast_inRequest_6681, 0);
  Method *writer6681 = addmethodrealflags(obj6673, "inRequest:=",&writer_ast_inRequest_6681, 0);
  reader6681->definitionModule = modulename;
  writer6681->definitionModule = modulename;
  reader6681->definitionLine = 1495;
  writer6681->definitionLine = 1495;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 7);
if (objclass6673 == NULL) {
  Method *reader6682 = addmethodrealflags(obj6673, "generics",&reader_ast_generics_6682, 0);
  Method *writer6682 = addmethodrealflags(obj6673, "generics:=",&writer_ast_generics_6682, 0);
  reader6682->definitionModule = modulename;
  writer6682->definitionModule = modulename;
  reader6682->definitionLine = 1496;
  writer6682->definitionLine = 1496;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 8);
if (objclass6673 == NULL) {
  Method *reader6683 = addmethodrealflags(obj6673, "isDeclaredByParent",&reader_ast_isDeclaredByParent_6683, 0);
  Method *writer6683 = addmethodrealflags(obj6673, "isDeclaredByParent:=",&writer_ast_isDeclaredByParent_6683, 0);
  reader6683->definitionModule = modulename;
  writer6683->definitionModule = modulename;
  reader6683->definitionLine = 1498;
  writer6683->definitionLine = 1498;
}
obj6673->flags |= OFLAG_MUTABLE;
adddatum2(obj6673, alloc_Undefined(), 9);
// method nameString
  struct UserObject *uo6684 = (struct UserObject*)obj6673;
  uo6684->data[10] = emptyclosure;
  Method *meth_meth_ast_nameString6684 = addmethod2pos(obj6673, "nameString", &meth_ast_nameString6684, 10);
  int argcv_meth_ast_nameString6684[] = {0};
  meth_meth_ast_nameString6684->type = alloc_MethodType(1, argcv_meth_ast_nameString6684);
  meth_meth_ast_nameString6684->definitionModule = modulename;
  meth_meth_ast_nameString6684->definitionLine = 1498;
// method isIdentifier
  struct UserObject *uo6687 = (struct UserObject*)obj6673;
  uo6687->data[11] = emptyclosure;
  Method *meth_meth_ast_isIdentifier6687 = addmethod2pos(obj6673, "isIdentifier", &meth_ast_isIdentifier6687, 11);
  int argcv_meth_ast_isIdentifier6687[] = {0};
  meth_meth_ast_isIdentifier6687->type = alloc_MethodType(1, argcv_meth_ast_isIdentifier6687);
  meth_meth_ast_isIdentifier6687->definitionModule = modulename;
  meth_meth_ast_isIdentifier6687->definitionLine = 1500;
// method isAppliedOccurenceOfIdentifier
  struct UserObject *uo6689 = (struct UserObject*)obj6673;
  uo6689->data[12] = emptyclosure;
  Method *meth_meth_ast_isAppliedOccurenceOfIdentifier6689 = addmethod2pos(obj6673, "isAppliedOccurenceOfIdentifier", &meth_ast_isAppliedOccurenceOfIdentifier6689, 12);
  int argcv_meth_ast_isAppliedOccurenceOfIdentifier6689[] = {0};
  meth_meth_ast_isAppliedOccurenceOfIdentifier6689->type = alloc_MethodType(1, argcv_meth_ast_isAppliedOccurenceOfIdentifier6689);
  meth_meth_ast_isAppliedOccurenceOfIdentifier6689->definitionModule = modulename;
  meth_meth_ast_isAppliedOccurenceOfIdentifier6689->definitionLine = 1502;
// method declarationKind
  struct UserObject *uo6698 = (struct UserObject*)obj6673;
  uo6698->data[13] = emptyclosure;
  Method *meth_meth_ast_declarationKind6698 = addmethod2pos(obj6673, "declarationKind", &meth_ast_declarationKind6698, 13);
  int argcv_meth_ast_declarationKind6698[] = {0};
  meth_meth_ast_declarationKind6698->type = alloc_MethodType(1, argcv_meth_ast_declarationKind6698);
  meth_meth_ast_declarationKind6698->definitionModule = modulename;
  meth_meth_ast_declarationKind6698->definitionLine = 1509;
// method inTypePosition
  struct UserObject *uo6703 = (struct UserObject*)obj6673;
  uo6703->data[14] = emptyclosure;
  Method *meth_meth_ast_inTypePosition6703 = addmethod2pos(obj6673, "inTypePosition", &meth_ast_inTypePosition6703, 14);
  int argcv_meth_ast_inTypePosition6703[] = {0};
  meth_meth_ast_inTypePosition6703->type = alloc_MethodType(1, argcv_meth_ast_inTypePosition6703);
  meth_meth_ast_inTypePosition6703->definitionModule = modulename;
  meth_meth_ast_inTypePosition6703->definitionLine = 1512;
// method usesAsType
  struct UserObject *uo6708 = (struct UserObject*)obj6673;
  uo6708->data[15] = emptyclosure;
  Method *meth_meth_ast_usesAsType6708 = addmethod2pos(obj6673, "usesAsType", &meth_ast_usesAsType6708, 15);
  int argcv_meth_ast_usesAsType6708[] = {1};
  meth_meth_ast_usesAsType6708->type = alloc_MethodType(1, argcv_meth_ast_usesAsType6708);
  meth_meth_ast_usesAsType6708->definitionModule = modulename;
  meth_meth_ast_usesAsType6708->definitionLine = 1518;
// method accept()from
  struct UserObject *uo6714 = (struct UserObject*)obj6673;
  uo6714->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from6714 = addmethod2pos(obj6673, "accept()from", &meth_ast_accept_40__41_from6714, 16);
  int argcv_meth_ast_accept_40__41_from6714[] = {1, 1};
  meth_meth_ast_accept_40__41_from6714->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from6714);
  meth_meth_ast_accept_40__41_from6714->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from6714->definitionLine = 1521;
// method map()parent
  struct UserObject *uo6729 = (struct UserObject*)obj6673;
  uo6729->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent6729 = addmethod2pos(obj6673, "map()parent", &meth_ast_map_40__41_parent6729, 17);
  int argcv_meth_ast_map_40__41_parent6729[] = {1, 1};
  meth_meth_ast_map_40__41_parent6729->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent6729);
  meth_meth_ast_map_40__41_parent6729->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent6729->definitionLine = 1528;
// method pretty
  struct UserObject *uo6745 = (struct UserObject*)obj6673;
  uo6745->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty6745 = addmethod2pos(obj6673, "pretty", &meth_ast_pretty6745, 18);
  int argcv_meth_ast_pretty6745[] = {1};
  meth_meth_ast_pretty6745->type = alloc_MethodType(1, argcv_meth_ast_pretty6745);
  meth_meth_ast_pretty6745->definitionModule = modulename;
  meth_meth_ast_pretty6745->definitionLine = 1534;
// method toGrace
  struct UserObject *uo6876 = (struct UserObject*)obj6673;
  uo6876->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace6876 = addmethod2pos(obj6673, "toGrace", &meth_ast_toGrace6876, 19);
  int argcv_meth_ast_toGrace6876[] = {1};
  meth_meth_ast_toGrace6876->type = alloc_MethodType(1, argcv_meth_ast_toGrace6876);
meth_meth_ast_toGrace6876->type->types[0] = type_Number;
meth_meth_ast_toGrace6876->type->names[0] = "depth";
  meth_meth_ast_toGrace6876->definitionModule = modulename;
  meth_meth_ast_toGrace6876->definitionLine = 1559;
// method asString
  struct UserObject *uo6969 = (struct UserObject*)obj6673;
  uo6969->data[20] = emptyclosure;
  Method *meth_meth_ast_asString6969 = addmethod2pos(obj6673, "asString", &meth_ast_asString6969, 20);
  int argcv_meth_ast_asString6969[] = {0};
  meth_meth_ast_asString6969->type = alloc_MethodType(1, argcv_meth_ast_asString6969);
  meth_meth_ast_asString6969->definitionModule = modulename;
  meth_meth_ast_asString6969->definitionLine = 1579;
// method shallowCopyWithParent
  block_savedest(obj6673);
  Object closure6993 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure6993, stackframe);
  addtoclosure(closure6993, var_identifierNode);
  struct UserObject *uo6993 = (struct UserObject*)obj6673;
  uo6993->data[21] = (Object)closure6993;
  Method *meth_meth_ast_shallowCopyWithParent6993 = addmethod2pos(obj6673, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent6993, 21);
  int argcv_meth_ast_shallowCopyWithParent6993[] = {1};
  meth_meth_ast_shallowCopyWithParent6993->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent6993);
  meth_meth_ast_shallowCopyWithParent6993->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent6993->definitionLine = 1586;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo7001 = (struct UserObject*)obj6673;
  uo7001->data[22] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001 = addmethod2pos(obj6673, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent7001, 22);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent7001[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent7001);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent7001->definitionLine = 1589;
  sourceObject = obj6673;
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7024 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7025 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7024);
// compiled call node returning call7025 (depth = 4)
  struct UserObject *obj6673_uo = (struct UserObject *)obj6673;
  obj6673_uo->super = call7025;
  sourceObject = obj6673;
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7026 == NULL) {
    strlit7026 = alloc_String("identifier");
    gc_root(strlit7026);
  }
// compiled string node returning strlit7026 (depth = 4)
  adddatum2(obj6673, strlit7026, 1);
  sourceObject = obj6673;
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name (depth = 4)
  adddatum2(obj6673, *var_name, 2);
  sourceObject = obj6673;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7027 = alloc_Boolean(0);
// compiled identifier node returning bool7027 (depth = 4)
  adddatum2(obj6673, bool7027, 3);
  sourceObject = obj6673;
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj6673, *var_dtype_39_, 4);
  sourceObject = obj6673;
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7028 = alloc_Boolean(0);
// compiled identifier node returning bool7028 (depth = 4)
  adddatum2(obj6673, bool7028, 5);
  sourceObject = obj6673;
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7029 = alloc_Boolean(0);
// compiled identifier node returning bool7029 (depth = 4)
  adddatum2(obj6673, bool7029, 6);
  sourceObject = obj6673;
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7030 = alloc_Boolean(0);
// compiled identifier node returning bool7030 (depth = 4)
  adddatum2(obj6673, bool7030, 7);
  sourceObject = obj6673;
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7031 = alloc_Boolean(0);
// compiled identifier node returning bool7031 (depth = 4)
  adddatum2(obj6673, bool7031, 8);
  sourceObject = obj6673;
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7032 = alloc_Boolean(0);
// compiled identifier node returning bool7032 (depth = 4)
  adddatum2(obj6673, bool7032, 9);
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
  sourceObject = obj6673;
objclass6673 = obj6673->class;
  objclass6673->definitionModule = modulename;
  objclass6673->definitionLine = 1486;
  (*(struct UserObject *)self).data[0] = lowerouter6673;
  self = oldself6673;
  selfslot = oldselfslot6673;
  stackframe = oldstackframe6673;
  gc_frame_end(frame);
  return obj6673;
}
Object meth_ast_typeType7038(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹typeType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_end(frame);
  return *var_typeType;
}
Object meth_ast_unknownType7042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unknownType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unknownType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for unknownType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹unknownType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unknownType (depth = 3)
  gc_frame_end(frame);
  return *var_unknownType;
}
Object meth_ast_octetsNode7043(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "octetsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_octetsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for octetsNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for octetsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_octetsNode (depth = 3)
  gc_frame_end(frame);
  return *var_octetsNode;
}
Object meth_ast_accept_40__41_from7051(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7052 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pNode (depth = 5)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7053 = callmethod(*var_visitor, "visitOctets()up",
    2, partcv, params);
  gc_frame_end(callframe7052);
// compiled call node returning call7053 (depth = 4)
  gc_frame_end(frame);
  return call7053;
}
Object meth_ast_pretty7054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7056 == NULL) {
    strlit7056 = alloc_String(")");
    gc_root(strlit7056);
  }
// compiled string node returning strlit7056 (depth = 5)
  int op_slot_right_7055 = gc_frame_newslot(strlit7056);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7059 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7060 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7059);
// compiled call node returning call7060 (depth = 7)
// compiled member node returning call7060 (depth = 6)
  int op_slot_right_7058 = gc_frame_newslot(call7060);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7063 == NULL) {
    strlit7063 = alloc_String("(");
    gc_root(strlit7063);
  }
// compiled string node returning strlit7063 (depth = 7)
  int op_slot_right_7062 = gc_frame_newslot(strlit7063);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7066 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7067 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7066);
// compiled call node returning call7067 (depth = 8)
  int op_slot_right_7065 = gc_frame_newslot(call7067);
// starting to compile string node (depth = 8)
  if (strlit7069 == NULL) {
    strlit7069 = alloc_String("");
    gc_root(strlit7069);
  }
// compiled string node returning strlit7069 (depth = 8)
  int op_slot_left_7065 = gc_frame_newslot(strlit7069);
  params[0] = call7067;
  partcv[0] = 1;
  Object opresult7070 = callmethod(strlit7069, "++", 1, partcv, params);
// compiled op node returning opresult7070 (depth = 7)
  int op_slot_left_7062 = gc_frame_newslot(opresult7070);
  params[0] = strlit7063;
  partcv[0] = 1;
  Object opresult7071 = callmethod(opresult7070, "++", 1, partcv, params);
// compiled op node returning opresult7071 (depth = 6)
  int op_slot_left_7058 = gc_frame_newslot(opresult7071);
  params[0] = call7060;
  partcv[0] = 1;
  Object opresult7072 = callmethod(opresult7071, "++", 1, partcv, params);
// compiled op node returning opresult7072 (depth = 5)
  int op_slot_left_7055 = gc_frame_newslot(opresult7072);
  params[0] = strlit7056;
  partcv[0] = 1;
  Object opresult7073 = callmethod(opresult7072, "++", 1, partcv, params);
// compiled op node returning opresult7073 (depth = 4)
  gc_frame_end(frame);
  return opresult7073;
}
Object meth_ast_toGrace7074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7076 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7075);
// compiled call node returning call7076 (depth = 5)
// compiled member node returning call7076 (depth = 4)
  gc_frame_end(frame);
  return call7076;
}
Object meth_ast_map_40__41_parent7077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7078 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7079 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7078);
// compiled call node returning call7079 (depth = 5)
  *var_n = call7079;
  if (call7079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7080 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7081 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7080);
// compiled call node returning call7081 (depth = 5)
  *var_n = call7081;
  if (call7081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_shallowCopyWithParent7083(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_octetsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7084 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7085 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7086 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7087 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7086);
// compiled call node returning call7087 (depth = 7)
// compiled member node returning call7087 (depth = 6)
  gc_frame_newslot(call7087);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_octetsNode (depth = 6)
  params[0] = call7087;
  partcv[0] = 1;
  Object call7088 = callmethod(*var_octetsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7085);
// compiled call node returning call7088 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7089 = callmethod(call7088, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe7084);
// compiled call node returning call7089 (depth = 4)
  gc_frame_end(frame);
  return call7089;
}
Object meth_ast_new7046(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_octetsNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_num = &(stackframe->slots[0]);
  *var_num = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7047 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7047 = alloc_userobj2(9,9, objclass7047);
  gc_frame_newslot(obj7047);
if (objclass7047 == NULL) {
  glfree(obj7047->class->name);
  obj7047->class->name = "octetsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7047, self, 0);
  addmethodreal(obj7047,"outer", &reader_ast_outer_7048);
  Object oldself7047 = self;
  struct StackFrameObject *oldstackframe7047 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7047);
  gc_frame_newslot((Object)stackframe);
  self = obj7047;
  Object *oldselfslot7047 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7047 = (*(struct UserObject *)self).data[0], lowerouter7047 = thisouter7047;
  if (inheritingObject7047) {
    struct UserObject *inho7047 = (struct UserObject *)inheritingObject7047;
    while (inho7047->super != GraceDefaultObject) inho7047 = (struct UserObject *)inho7047->super;
    inho7047->super = obj7047;
    self = inheritingObject7047;
    *selfslot = self;
    lowerouter7047 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7047;
  }
if (objclass7047 == NULL) {
  Method *reader7049 = addmethodrealflags(obj7047, "kind",&reader_ast_kind_7049, MFLAG_DEF);
  reader7049->definitionModule = modulename;
  reader7049->definitionLine = 1606;
}
adddatum2(obj7047, alloc_Undefined(), 1);
if (objclass7047 == NULL) {
  Method *reader7050 = addmethodrealflags(obj7047, "value",&reader_ast_value_7050, 0);
  Method *writer7050 = addmethodrealflags(obj7047, "value:=",&writer_ast_value_7050, 0);
  reader7050->definitionModule = modulename;
  writer7050->definitionModule = modulename;
  reader7050->definitionLine = 1607;
  writer7050->definitionLine = 1607;
}
obj7047->flags |= OFLAG_MUTABLE;
adddatum2(obj7047, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7051 = (struct UserObject*)obj7047;
  uo7051->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7051 = addmethod2pos(obj7047, "accept()from", &meth_ast_accept_40__41_from7051, 3);
  int argcv_meth_ast_accept_40__41_from7051[] = {1, 1};
  meth_meth_ast_accept_40__41_from7051->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7051);
  meth_meth_ast_accept_40__41_from7051->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7051->definitionLine = 1607;
// method pretty
  struct UserObject *uo7054 = (struct UserObject*)obj7047;
  uo7054->data[4] = emptyclosure;
  Method *meth_meth_ast_pretty7054 = addmethod2pos(obj7047, "pretty", &meth_ast_pretty7054, 4);
  int argcv_meth_ast_pretty7054[] = {1};
  meth_meth_ast_pretty7054->type = alloc_MethodType(1, argcv_meth_ast_pretty7054);
  meth_meth_ast_pretty7054->definitionModule = modulename;
  meth_meth_ast_pretty7054->definitionLine = 1610;
// method toGrace
  struct UserObject *uo7074 = (struct UserObject*)obj7047;
  uo7074->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace7074 = addmethod2pos(obj7047, "toGrace", &meth_ast_toGrace7074, 5);
  int argcv_meth_ast_toGrace7074[] = {1};
  meth_meth_ast_toGrace7074->type = alloc_MethodType(1, argcv_meth_ast_toGrace7074);
meth_meth_ast_toGrace7074->type->types[0] = type_Number;
meth_meth_ast_toGrace7074->type->names[0] = "depth";
  meth_meth_ast_toGrace7074->definitionModule = modulename;
  meth_meth_ast_toGrace7074->definitionLine = 1613;
// method map()parent
  struct UserObject *uo7077 = (struct UserObject*)obj7047;
  uo7077->data[6] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7077 = addmethod2pos(obj7047, "map()parent", &meth_ast_map_40__41_parent7077, 6);
  int argcv_meth_ast_map_40__41_parent7077[] = {1, 1};
  meth_meth_ast_map_40__41_parent7077->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7077);
  meth_meth_ast_map_40__41_parent7077->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7077->definitionLine = 1616;
// method shallowCopyWithParent
  block_savedest(obj7047);
  Object closure7083 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7083, stackframe);
  addtoclosure(closure7083, var_octetsNode);
  struct UserObject *uo7083 = (struct UserObject*)obj7047;
  uo7083->data[7] = (Object)closure7083;
  Method *meth_meth_ast_shallowCopyWithParent7083 = addmethod2pos(obj7047, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7083, 7);
  int argcv_meth_ast_shallowCopyWithParent7083[] = {1};
  meth_meth_ast_shallowCopyWithParent7083->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7083);
  meth_meth_ast_shallowCopyWithParent7083->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7083->definitionLine = 1621;
  sourceObject = obj7047;
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7090 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7091 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7090);
// compiled call node returning call7091 (depth = 4)
  struct UserObject *obj7047_uo = (struct UserObject *)obj7047;
  obj7047_uo->super = call7091;
  sourceObject = obj7047;
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7092 == NULL) {
    strlit7092 = alloc_String("octets");
    gc_root(strlit7092);
  }
// compiled string node returning strlit7092 (depth = 4)
  adddatum2(obj7047, strlit7092, 1);
  sourceObject = obj7047;
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_num (depth = 4)
  adddatum2(obj7047, *var_num, 2);
  sourceObject = obj7047;
  sourceObject = obj7047;
  sourceObject = obj7047;
  sourceObject = obj7047;
  sourceObject = obj7047;
objclass7047 = obj7047->class;
  objclass7047->definitionModule = modulename;
  objclass7047->definitionLine = 1603;
  (*(struct UserObject *)self).data[0] = lowerouter7047;
  self = oldself7047;
  selfslot = oldselfslot7047;
  stackframe = oldstackframe7047;
  gc_frame_end(frame);
  return obj7047;
}
Object meth_ast_new7046_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_octetsNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_num = &(stackframe->slots[0]);
  *var_num = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7047 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7047 = alloc_userobj2(9,9, objclass7047);
  gc_frame_newslot(obj7047);
if (objclass7047 == NULL) {
  glfree(obj7047->class->name);
  obj7047->class->name = "octetsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7047, self, 0);
  addmethodreal(obj7047,"outer", &reader_ast_outer_7048);
  Object oldself7047 = self;
  struct StackFrameObject *oldstackframe7047 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7047);
  gc_frame_newslot((Object)stackframe);
  self = obj7047;
  Object *oldselfslot7047 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7047 = (*(struct UserObject *)self).data[0], lowerouter7047 = thisouter7047;
  if (inheritingObject7047) {
    struct UserObject *inho7047 = (struct UserObject *)inheritingObject7047;
    while (inho7047->super != GraceDefaultObject) inho7047 = (struct UserObject *)inho7047->super;
    inho7047->super = obj7047;
    self = inheritingObject7047;
    *selfslot = self;
    lowerouter7047 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7047;
  }
if (objclass7047 == NULL) {
  Method *reader7049 = addmethodrealflags(obj7047, "kind",&reader_ast_kind_7049, MFLAG_DEF);
  reader7049->definitionModule = modulename;
  reader7049->definitionLine = 1606;
}
adddatum2(obj7047, alloc_Undefined(), 1);
if (objclass7047 == NULL) {
  Method *reader7050 = addmethodrealflags(obj7047, "value",&reader_ast_value_7050, 0);
  Method *writer7050 = addmethodrealflags(obj7047, "value:=",&writer_ast_value_7050, 0);
  reader7050->definitionModule = modulename;
  writer7050->definitionModule = modulename;
  reader7050->definitionLine = 1607;
  writer7050->definitionLine = 1607;
}
obj7047->flags |= OFLAG_MUTABLE;
adddatum2(obj7047, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7051 = (struct UserObject*)obj7047;
  uo7051->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7051 = addmethod2pos(obj7047, "accept()from", &meth_ast_accept_40__41_from7051, 3);
  int argcv_meth_ast_accept_40__41_from7051[] = {1, 1};
  meth_meth_ast_accept_40__41_from7051->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7051);
  meth_meth_ast_accept_40__41_from7051->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7051->definitionLine = 1607;
// method pretty
  struct UserObject *uo7054 = (struct UserObject*)obj7047;
  uo7054->data[4] = emptyclosure;
  Method *meth_meth_ast_pretty7054 = addmethod2pos(obj7047, "pretty", &meth_ast_pretty7054, 4);
  int argcv_meth_ast_pretty7054[] = {1};
  meth_meth_ast_pretty7054->type = alloc_MethodType(1, argcv_meth_ast_pretty7054);
  meth_meth_ast_pretty7054->definitionModule = modulename;
  meth_meth_ast_pretty7054->definitionLine = 1610;
// method toGrace
  struct UserObject *uo7074 = (struct UserObject*)obj7047;
  uo7074->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace7074 = addmethod2pos(obj7047, "toGrace", &meth_ast_toGrace7074, 5);
  int argcv_meth_ast_toGrace7074[] = {1};
  meth_meth_ast_toGrace7074->type = alloc_MethodType(1, argcv_meth_ast_toGrace7074);
meth_meth_ast_toGrace7074->type->types[0] = type_Number;
meth_meth_ast_toGrace7074->type->names[0] = "depth";
  meth_meth_ast_toGrace7074->definitionModule = modulename;
  meth_meth_ast_toGrace7074->definitionLine = 1613;
// method map()parent
  struct UserObject *uo7077 = (struct UserObject*)obj7047;
  uo7077->data[6] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7077 = addmethod2pos(obj7047, "map()parent", &meth_ast_map_40__41_parent7077, 6);
  int argcv_meth_ast_map_40__41_parent7077[] = {1, 1};
  meth_meth_ast_map_40__41_parent7077->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7077);
  meth_meth_ast_map_40__41_parent7077->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7077->definitionLine = 1616;
// method shallowCopyWithParent
  block_savedest(obj7047);
  Object closure7083 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7083, stackframe);
  addtoclosure(closure7083, var_octetsNode);
  struct UserObject *uo7083 = (struct UserObject*)obj7047;
  uo7083->data[7] = (Object)closure7083;
  Method *meth_meth_ast_shallowCopyWithParent7083 = addmethod2pos(obj7047, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7083, 7);
  int argcv_meth_ast_shallowCopyWithParent7083[] = {1};
  meth_meth_ast_shallowCopyWithParent7083->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7083);
  meth_meth_ast_shallowCopyWithParent7083->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7083->definitionLine = 1621;
  sourceObject = obj7047;
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7090 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7091 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7090);
// compiled call node returning call7091 (depth = 4)
  struct UserObject *obj7047_uo = (struct UserObject *)obj7047;
  obj7047_uo->super = call7091;
  sourceObject = obj7047;
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7092 == NULL) {
    strlit7092 = alloc_String("octets");
    gc_root(strlit7092);
  }
// compiled string node returning strlit7092 (depth = 4)
  adddatum2(obj7047, strlit7092, 1);
  sourceObject = obj7047;
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_num (depth = 4)
  adddatum2(obj7047, *var_num, 2);
  sourceObject = obj7047;
  sourceObject = obj7047;
  sourceObject = obj7047;
  sourceObject = obj7047;
  sourceObject = obj7047;
objclass7047 = obj7047->class;
  objclass7047->definitionModule = modulename;
  objclass7047->definitionLine = 1603;
  (*(struct UserObject *)self).data[0] = lowerouter7047;
  self = oldself7047;
  selfslot = oldselfslot7047;
  stackframe = oldstackframe7047;
  gc_frame_end(frame);
  return obj7047;
}
Object meth_ast_stringNode7094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for stringNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for stringNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_stringNode (depth = 3)
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept_40__41_from7102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7103 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pNode (depth = 5)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7104 = callmethod(*var_visitor, "visitString()up",
    2, partcv, params);
  gc_frame_end(callframe7103);
// compiled call node returning call7104 (depth = 4)
  gc_frame_end(frame);
  return call7104;
}
Object meth_ast_map_40__41_parent7105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7106 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7107 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7106);
// compiled call node returning call7107 (depth = 5)
  *var_n = call7107;
  if (call7107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7108 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7109 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7108);
// compiled call node returning call7109 (depth = 5)
  *var_n = call7109;
  if (call7109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_pretty7111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7113 == NULL) {
    strlit7113 = alloc_String(")");
    gc_root(strlit7113);
  }
// compiled string node returning strlit7113 (depth = 5)
  int op_slot_right_7112 = gc_frame_newslot(strlit7113);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7117 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7116);
// compiled call node returning call7117 (depth = 7)
// compiled member node returning call7117 (depth = 6)
  int op_slot_right_7115 = gc_frame_newslot(call7117);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7120 == NULL) {
    strlit7120 = alloc_String("(");
    gc_root(strlit7120);
  }
// compiled string node returning strlit7120 (depth = 7)
  int op_slot_right_7119 = gc_frame_newslot(strlit7120);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7123 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7124 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7123);
// compiled call node returning call7124 (depth = 8)
  int op_slot_right_7122 = gc_frame_newslot(call7124);
// starting to compile string node (depth = 8)
  if (strlit7126 == NULL) {
    strlit7126 = alloc_String("");
    gc_root(strlit7126);
  }
// compiled string node returning strlit7126 (depth = 8)
  int op_slot_left_7122 = gc_frame_newslot(strlit7126);
  params[0] = call7124;
  partcv[0] = 1;
  Object opresult7127 = callmethod(strlit7126, "++", 1, partcv, params);
// compiled op node returning opresult7127 (depth = 7)
  int op_slot_left_7119 = gc_frame_newslot(opresult7127);
  params[0] = strlit7120;
  partcv[0] = 1;
  Object opresult7128 = callmethod(opresult7127, "++", 1, partcv, params);
// compiled op node returning opresult7128 (depth = 6)
  int op_slot_left_7115 = gc_frame_newslot(opresult7128);
  params[0] = call7117;
  partcv[0] = 1;
  Object opresult7129 = callmethod(opresult7128, "++", 1, partcv, params);
// compiled op node returning opresult7129 (depth = 5)
  int op_slot_left_7112 = gc_frame_newslot(opresult7129);
  params[0] = strlit7113;
  partcv[0] = 1;
  Object opresult7130 = callmethod(opresult7129, "++", 1, partcv, params);
// compiled op node returning opresult7130 (depth = 4)
  gc_frame_end(frame);
  return opresult7130;
}
Object meth_ast__apply7137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7140 == NULL) {
    strlit7140 = alloc_String("""\x0a""");
    gc_root(strlit7140);
  }
// compiled string node returning strlit7140 (depth = 8)
  int op_slot_right_7139 = gc_frame_newslot(strlit7140);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_7139 = gc_frame_newslot(*var_c);
  params[0] = strlit7140;
  partcv[0] = 1;
  Object opresult7142 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7142 (depth = 7)
  Object if7138 = done;
  if (istrue(opresult7142)) {
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit7144 == NULL) {
    strlit7144 = alloc_String("\\n");
    gc_root(strlit7144);
  }
// compiled string node returning strlit7144 (depth = 9)
  int op_slot_right_7143 = gc_frame_newslot(strlit7144);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7143 = gc_frame_newslot(*var_s);
  params[0] = strlit7144;
  partcv[0] = 1;
  Object opresult7146 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7146 (depth = 8)
  *var_s = opresult7146;
  if (opresult7146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if7138 = done;
  } else {
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7150 == NULL) {
    strlit7150 = alloc_String("""\x09""");
    gc_root(strlit7150);
  }
// compiled string node returning strlit7150 (depth = 9)
  int op_slot_right_7149 = gc_frame_newslot(strlit7150);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_7149 = gc_frame_newslot(*var_c);
  params[0] = strlit7150;
  partcv[0] = 1;
  Object opresult7152 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7152 (depth = 8)
  Object if7148 = done;
  if (istrue(opresult7152)) {
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit7154 == NULL) {
    strlit7154 = alloc_String("\\t");
    gc_root(strlit7154);
  }
// compiled string node returning strlit7154 (depth = 10)
  int op_slot_right_7153 = gc_frame_newslot(strlit7154);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_7153 = gc_frame_newslot(*var_s);
  params[0] = strlit7154;
  partcv[0] = 1;
  Object opresult7156 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7156 (depth = 9)
  *var_s = opresult7156;
  if (opresult7156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if7148 = done;
  } else {
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7160 == NULL) {
    strlit7160 = alloc_String("""\x22""");
    gc_root(strlit7160);
  }
// compiled string node returning strlit7160 (depth = 10)
  int op_slot_right_7159 = gc_frame_newslot(strlit7160);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_7159 = gc_frame_newslot(*var_c);
  params[0] = strlit7160;
  partcv[0] = 1;
  Object opresult7162 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7162 (depth = 9)
  Object if7158 = done;
  if (istrue(opresult7162)) {
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit7164 == NULL) {
    strlit7164 = alloc_String("\\""\x22""");
    gc_root(strlit7164);
  }
// compiled string node returning strlit7164 (depth = 11)
  int op_slot_right_7163 = gc_frame_newslot(strlit7164);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_7163 = gc_frame_newslot(*var_s);
  params[0] = strlit7164;
  partcv[0] = 1;
  Object opresult7166 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7166 (depth = 10)
  *var_s = opresult7166;
  if (opresult7166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if7158 = done;
  } else {
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit7170 == NULL) {
    strlit7170 = alloc_String("\\");
    gc_root(strlit7170);
  }
// compiled string node returning strlit7170 (depth = 11)
  int op_slot_right_7169 = gc_frame_newslot(strlit7170);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_7169 = gc_frame_newslot(*var_c);
  params[0] = strlit7170;
  partcv[0] = 1;
  Object opresult7172 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult7172 (depth = 10)
  Object if7168 = done;
  if (istrue(opresult7172)) {
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit7174 == NULL) {
    strlit7174 = alloc_String("\\\\");
    gc_root(strlit7174);
  }
// compiled string node returning strlit7174 (depth = 12)
  int op_slot_right_7173 = gc_frame_newslot(strlit7174);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_7173 = gc_frame_newslot(*var_s);
  params[0] = strlit7174;
  partcv[0] = 1;
  Object opresult7176 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7176 (depth = 11)
  *var_s = opresult7176;
  if (opresult7176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if7168 = done;
  } else {
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_right_7178 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_left_7178 = gc_frame_newslot(*var_s);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult7180 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7180 (depth = 11)
  *var_s = opresult7180;
  if (opresult7180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if7168 = done;
  }
// compiled if node returning if7168 (depth = 9)
    gc_frame_newslot(if7168);
    if7158 = if7168;
  }
// compiled if node returning if7158 (depth = 8)
    gc_frame_newslot(if7158);
    if7148 = if7158;
  }
// compiled if node returning if7148 (depth = 7)
    gc_frame_newslot(if7148);
    if7138 = if7148;
  }
// compiled if node returning if7138 (depth = 6)
  gc_frame_end(frame);
  return if7138;
}
Object meth_ast_toGrace7131(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7132 == NULL) {
    strlit7132 = alloc_String("""\x22""");
    gc_root(strlit7132);
  }
// compiled string node returning strlit7132 (depth = 5)
  *var_s = strlit7132;
  if (strlit7132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7133 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7134 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7135 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7134);
// compiled call node returning call7135 (depth = 6)
// compiled member node returning call7135 (depth = 5)
  gc_frame_newslot(call7135);
// starting to compile block node (depth = 5)
  Object block7136 = alloc_Block(NULL, NULL, "ast", 1642);
  gc_frame_newslot(block7136);
// method _apply
  block_savedest(block7136);
  Object closure7137 = createclosure(2, "_apply");
  setclosureframe(closure7137, stackframe);
  addtoclosure(closure7137, var_s);
  addtoclosure(closure7137, selfslot);
  struct UserObject *uo7137 = (struct UserObject*)block7136;
  uo7137->data[0] = (Object)closure7137;
  Method *meth_meth_ast__apply7137 = addmethod2pos(block7136, "_apply", &meth_ast__apply7137, 0);
  int argcv_meth_ast__apply7137[] = {1};
  meth_meth_ast__apply7137->type = alloc_MethodType(1, argcv_meth_ast__apply7137);
  meth_meth_ast__apply7137->definitionModule = modulename;
  meth_meth_ast__apply7137->definitionLine = 1642;
// compiled block node returning block7136 (depth = 5)
  gc_frame_newslot(block7136);
// call case 5: prelude request
  params[0] = call7135;
  params[1] = block7136;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7183 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7133);
// compiled call node returning call7183 (depth = 4)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7185 == NULL) {
    strlit7185 = alloc_String("""\x22""");
    gc_root(strlit7185);
  }
// compiled string node returning strlit7185 (depth = 6)
  int op_slot_right_7184 = gc_frame_newslot(strlit7185);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7184 = gc_frame_newslot(*var_s);
  params[0] = strlit7185;
  partcv[0] = 1;
  Object opresult7187 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7187 (depth = 5)
  *var_s = opresult7187;
  if (opresult7187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent7189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7190 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7191 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7192 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7193 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7192);
// compiled call node returning call7193 (depth = 7)
// compiled member node returning call7193 (depth = 6)
  gc_frame_newslot(call7193);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_stringNode (depth = 6)
  params[0] = call7193;
  partcv[0] = 1;
  Object call7194 = callmethod(*var_stringNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7191);
// compiled call node returning call7194 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7195 = callmethod(call7194, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe7190);
// compiled call node returning call7195 (depth = 4)
  gc_frame_end(frame);
  return call7195;
}
Object meth_ast_new7097(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7098 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7098 = alloc_userobj2(9,9, objclass7098);
  gc_frame_newslot(obj7098);
if (objclass7098 == NULL) {
  glfree(obj7098->class->name);
  obj7098->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7098, self, 0);
  addmethodreal(obj7098,"outer", &reader_ast_outer_7099);
  Object oldself7098 = self;
  struct StackFrameObject *oldstackframe7098 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7098);
  gc_frame_newslot((Object)stackframe);
  self = obj7098;
  Object *oldselfslot7098 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7098 = (*(struct UserObject *)self).data[0], lowerouter7098 = thisouter7098;
  if (inheritingObject7098) {
    struct UserObject *inho7098 = (struct UserObject *)inheritingObject7098;
    while (inho7098->super != GraceDefaultObject) inho7098 = (struct UserObject *)inho7098->super;
    inho7098->super = obj7098;
    self = inheritingObject7098;
    *selfslot = self;
    lowerouter7098 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7098;
  }
if (objclass7098 == NULL) {
  Method *reader7100 = addmethodrealflags(obj7098, "kind",&reader_ast_kind_7100, MFLAG_DEF);
  reader7100->definitionModule = modulename;
  reader7100->definitionLine = 1628;
}
adddatum2(obj7098, alloc_Undefined(), 1);
if (objclass7098 == NULL) {
  Method *reader7101 = addmethodrealflags(obj7098, "value",&reader_ast_value_7101, 0);
  Method *writer7101 = addmethodrealflags(obj7098, "value:=",&writer_ast_value_7101, 0);
  reader7101->definitionModule = modulename;
  writer7101->definitionModule = modulename;
  reader7101->definitionLine = 1629;
  writer7101->definitionLine = 1629;
}
obj7098->flags |= OFLAG_MUTABLE;
adddatum2(obj7098, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7102 = (struct UserObject*)obj7098;
  uo7102->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7102 = addmethod2pos(obj7098, "accept()from", &meth_ast_accept_40__41_from7102, 3);
  int argcv_meth_ast_accept_40__41_from7102[] = {1, 1};
  meth_meth_ast_accept_40__41_from7102->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7102);
  meth_meth_ast_accept_40__41_from7102->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7102->definitionLine = 1629;
// method map()parent
  struct UserObject *uo7105 = (struct UserObject*)obj7098;
  uo7105->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7105 = addmethod2pos(obj7098, "map()parent", &meth_ast_map_40__41_parent7105, 4);
  int argcv_meth_ast_map_40__41_parent7105[] = {1, 1};
  meth_meth_ast_map_40__41_parent7105->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7105);
  meth_meth_ast_map_40__41_parent7105->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7105->definitionLine = 1632;
// method pretty
  struct UserObject *uo7111 = (struct UserObject*)obj7098;
  uo7111->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7111 = addmethod2pos(obj7098, "pretty", &meth_ast_pretty7111, 5);
  int argcv_meth_ast_pretty7111[] = {1};
  meth_meth_ast_pretty7111->type = alloc_MethodType(1, argcv_meth_ast_pretty7111);
  meth_meth_ast_pretty7111->definitionModule = modulename;
  meth_meth_ast_pretty7111->definitionLine = 1637;
// method toGrace
  struct UserObject *uo7131 = (struct UserObject*)obj7098;
  uo7131->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7131 = addmethod2pos(obj7098, "toGrace", &meth_ast_toGrace7131, 6);
  int argcv_meth_ast_toGrace7131[] = {1};
  meth_meth_ast_toGrace7131->type = alloc_MethodType(1, argcv_meth_ast_toGrace7131);
meth_meth_ast_toGrace7131->type->types[0] = type_Number;
meth_meth_ast_toGrace7131->type->names[0] = "depth";
  meth_meth_ast_toGrace7131->definitionModule = modulename;
  meth_meth_ast_toGrace7131->definitionLine = 1640;
// method shallowCopyWithParent
  block_savedest(obj7098);
  Object closure7189 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7189, stackframe);
  addtoclosure(closure7189, var_stringNode);
  struct UserObject *uo7189 = (struct UserObject*)obj7098;
  uo7189->data[7] = (Object)closure7189;
  Method *meth_meth_ast_shallowCopyWithParent7189 = addmethod2pos(obj7098, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7189, 7);
  int argcv_meth_ast_shallowCopyWithParent7189[] = {1};
  meth_meth_ast_shallowCopyWithParent7189->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7189);
  meth_meth_ast_shallowCopyWithParent7189->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7189->definitionLine = 1659;
  sourceObject = obj7098;
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7196 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7197 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7196);
// compiled call node returning call7197 (depth = 4)
  struct UserObject *obj7098_uo = (struct UserObject *)obj7098;
  obj7098_uo->super = call7197;
  sourceObject = obj7098;
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7198 == NULL) {
    strlit7198 = alloc_String("string");
    gc_root(strlit7198);
  }
// compiled string node returning strlit7198 (depth = 4)
  adddatum2(obj7098, strlit7198, 1);
  sourceObject = obj7098;
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_v (depth = 4)
  adddatum2(obj7098, *var_v, 2);
  sourceObject = obj7098;
  sourceObject = obj7098;
  sourceObject = obj7098;
  sourceObject = obj7098;
  sourceObject = obj7098;
objclass7098 = obj7098->class;
  objclass7098->definitionModule = modulename;
  objclass7098->definitionLine = 1625;
  (*(struct UserObject *)self).data[0] = lowerouter7098;
  self = oldself7098;
  selfslot = oldselfslot7098;
  stackframe = oldstackframe7098;
  gc_frame_end(frame);
  return obj7098;
}
Object meth_ast_new7097_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_stringNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7098 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7098 = alloc_userobj2(9,9, objclass7098);
  gc_frame_newslot(obj7098);
if (objclass7098 == NULL) {
  glfree(obj7098->class->name);
  obj7098->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7098, self, 0);
  addmethodreal(obj7098,"outer", &reader_ast_outer_7099);
  Object oldself7098 = self;
  struct StackFrameObject *oldstackframe7098 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7098);
  gc_frame_newslot((Object)stackframe);
  self = obj7098;
  Object *oldselfslot7098 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7098 = (*(struct UserObject *)self).data[0], lowerouter7098 = thisouter7098;
  if (inheritingObject7098) {
    struct UserObject *inho7098 = (struct UserObject *)inheritingObject7098;
    while (inho7098->super != GraceDefaultObject) inho7098 = (struct UserObject *)inho7098->super;
    inho7098->super = obj7098;
    self = inheritingObject7098;
    *selfslot = self;
    lowerouter7098 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7098;
  }
if (objclass7098 == NULL) {
  Method *reader7100 = addmethodrealflags(obj7098, "kind",&reader_ast_kind_7100, MFLAG_DEF);
  reader7100->definitionModule = modulename;
  reader7100->definitionLine = 1628;
}
adddatum2(obj7098, alloc_Undefined(), 1);
if (objclass7098 == NULL) {
  Method *reader7101 = addmethodrealflags(obj7098, "value",&reader_ast_value_7101, 0);
  Method *writer7101 = addmethodrealflags(obj7098, "value:=",&writer_ast_value_7101, 0);
  reader7101->definitionModule = modulename;
  writer7101->definitionModule = modulename;
  reader7101->definitionLine = 1629;
  writer7101->definitionLine = 1629;
}
obj7098->flags |= OFLAG_MUTABLE;
adddatum2(obj7098, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7102 = (struct UserObject*)obj7098;
  uo7102->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7102 = addmethod2pos(obj7098, "accept()from", &meth_ast_accept_40__41_from7102, 3);
  int argcv_meth_ast_accept_40__41_from7102[] = {1, 1};
  meth_meth_ast_accept_40__41_from7102->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7102);
  meth_meth_ast_accept_40__41_from7102->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7102->definitionLine = 1629;
// method map()parent
  struct UserObject *uo7105 = (struct UserObject*)obj7098;
  uo7105->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7105 = addmethod2pos(obj7098, "map()parent", &meth_ast_map_40__41_parent7105, 4);
  int argcv_meth_ast_map_40__41_parent7105[] = {1, 1};
  meth_meth_ast_map_40__41_parent7105->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7105);
  meth_meth_ast_map_40__41_parent7105->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7105->definitionLine = 1632;
// method pretty
  struct UserObject *uo7111 = (struct UserObject*)obj7098;
  uo7111->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7111 = addmethod2pos(obj7098, "pretty", &meth_ast_pretty7111, 5);
  int argcv_meth_ast_pretty7111[] = {1};
  meth_meth_ast_pretty7111->type = alloc_MethodType(1, argcv_meth_ast_pretty7111);
  meth_meth_ast_pretty7111->definitionModule = modulename;
  meth_meth_ast_pretty7111->definitionLine = 1637;
// method toGrace
  struct UserObject *uo7131 = (struct UserObject*)obj7098;
  uo7131->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7131 = addmethod2pos(obj7098, "toGrace", &meth_ast_toGrace7131, 6);
  int argcv_meth_ast_toGrace7131[] = {1};
  meth_meth_ast_toGrace7131->type = alloc_MethodType(1, argcv_meth_ast_toGrace7131);
meth_meth_ast_toGrace7131->type->types[0] = type_Number;
meth_meth_ast_toGrace7131->type->names[0] = "depth";
  meth_meth_ast_toGrace7131->definitionModule = modulename;
  meth_meth_ast_toGrace7131->definitionLine = 1640;
// method shallowCopyWithParent
  block_savedest(obj7098);
  Object closure7189 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7189, stackframe);
  addtoclosure(closure7189, var_stringNode);
  struct UserObject *uo7189 = (struct UserObject*)obj7098;
  uo7189->data[7] = (Object)closure7189;
  Method *meth_meth_ast_shallowCopyWithParent7189 = addmethod2pos(obj7098, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7189, 7);
  int argcv_meth_ast_shallowCopyWithParent7189[] = {1};
  meth_meth_ast_shallowCopyWithParent7189->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7189);
  meth_meth_ast_shallowCopyWithParent7189->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7189->definitionLine = 1659;
  sourceObject = obj7098;
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7196 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7197 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7196);
// compiled call node returning call7197 (depth = 4)
  struct UserObject *obj7098_uo = (struct UserObject *)obj7098;
  obj7098_uo->super = call7197;
  sourceObject = obj7098;
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7198 == NULL) {
    strlit7198 = alloc_String("string");
    gc_root(strlit7198);
  }
// compiled string node returning strlit7198 (depth = 4)
  adddatum2(obj7098, strlit7198, 1);
  sourceObject = obj7098;
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_v (depth = 4)
  adddatum2(obj7098, *var_v, 2);
  sourceObject = obj7098;
  sourceObject = obj7098;
  sourceObject = obj7098;
  sourceObject = obj7098;
  sourceObject = obj7098;
objclass7098 = obj7098->class;
  objclass7098->definitionModule = modulename;
  objclass7098->definitionLine = 1625;
  (*(struct UserObject *)self).data[0] = lowerouter7098;
  self = oldself7098;
  selfslot = oldselfslot7098;
  stackframe = oldstackframe7098;
  gc_frame_end(frame);
  return obj7098;
}
Object meth_ast_numNode7200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for numNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for numNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_numNode (depth = 3)
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_accept_40__41_from7208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7209 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pNode (depth = 5)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7210 = callmethod(*var_visitor, "visitNum()up",
    2, partcv, params);
  gc_frame_end(callframe7209);
// compiled call node returning call7210 (depth = 4)
  gc_frame_end(frame);
  return call7210;
}
Object meth_ast_map_40__41_parent7211(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7212 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7213 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7212);
// compiled call node returning call7213 (depth = 5)
  *var_n = call7213;
  if (call7213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7214 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7215 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7214);
// compiled call node returning call7215 (depth = 5)
  *var_n = call7215;
  if (call7215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_pretty7217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7219 == NULL) {
    strlit7219 = alloc_String(")");
    gc_root(strlit7219);
  }
// compiled string node returning strlit7219 (depth = 5)
  int op_slot_right_7218 = gc_frame_newslot(strlit7219);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7222 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7223 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7222);
// compiled call node returning call7223 (depth = 7)
// compiled member node returning call7223 (depth = 6)
  int op_slot_right_7221 = gc_frame_newslot(call7223);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7226 == NULL) {
    strlit7226 = alloc_String("(");
    gc_root(strlit7226);
  }
// compiled string node returning strlit7226 (depth = 7)
  int op_slot_right_7225 = gc_frame_newslot(strlit7226);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7229 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7230 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7229);
// compiled call node returning call7230 (depth = 8)
  int op_slot_right_7228 = gc_frame_newslot(call7230);
// starting to compile string node (depth = 8)
  if (strlit7232 == NULL) {
    strlit7232 = alloc_String("");
    gc_root(strlit7232);
  }
// compiled string node returning strlit7232 (depth = 8)
  int op_slot_left_7228 = gc_frame_newslot(strlit7232);
  params[0] = call7230;
  partcv[0] = 1;
  Object opresult7233 = callmethod(strlit7232, "++", 1, partcv, params);
// compiled op node returning opresult7233 (depth = 7)
  int op_slot_left_7225 = gc_frame_newslot(opresult7233);
  params[0] = strlit7226;
  partcv[0] = 1;
  Object opresult7234 = callmethod(opresult7233, "++", 1, partcv, params);
// compiled op node returning opresult7234 (depth = 6)
  int op_slot_left_7221 = gc_frame_newslot(opresult7234);
  params[0] = call7223;
  partcv[0] = 1;
  Object opresult7235 = callmethod(opresult7234, "++", 1, partcv, params);
// compiled op node returning opresult7235 (depth = 5)
  int op_slot_left_7218 = gc_frame_newslot(opresult7235);
  params[0] = strlit7219;
  partcv[0] = 1;
  Object opresult7236 = callmethod(opresult7235, "++", 1, partcv, params);
// compiled op node returning opresult7236 (depth = 4)
  gc_frame_end(frame);
  return opresult7236;
}
Object meth_ast_toGrace7237(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7238 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7239 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7240 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7239);
// compiled call node returning call7240 (depth = 7)
// compiled member node returning call7240 (depth = 6)
  partcv[0] = 0;
  Object call7241 = callmethod(call7240, "asString",
    1, partcv, params);
  gc_frame_end(callframe7238);
// compiled call node returning call7241 (depth = 5)
// compiled member node returning call7241 (depth = 4)
  gc_frame_end(frame);
  return call7241;
}
Object meth_ast_asString7242(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7244 == NULL) {
    strlit7244 = alloc_String("");
    gc_root(strlit7244);
  }
// compiled string node returning strlit7244 (depth = 5)
  int op_slot_right_7243 = gc_frame_newslot(strlit7244);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7248 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7247);
// compiled call node returning call7248 (depth = 7)
// compiled member node returning call7248 (depth = 6)
  int op_slot_right_7246 = gc_frame_newslot(call7248);
// starting to compile string node (depth = 6)
  if (strlit7250 == NULL) {
    strlit7250 = alloc_String("Number ");
    gc_root(strlit7250);
  }
// compiled string node returning strlit7250 (depth = 6)
  int op_slot_left_7246 = gc_frame_newslot(strlit7250);
  params[0] = call7248;
  partcv[0] = 1;
  Object opresult7251 = callmethod(strlit7250, "++", 1, partcv, params);
// compiled op node returning opresult7251 (depth = 5)
  int op_slot_left_7243 = gc_frame_newslot(opresult7251);
  params[0] = strlit7244;
  partcv[0] = 1;
  Object opresult7252 = callmethod(opresult7251, "++", 1, partcv, params);
// compiled op node returning opresult7252 (depth = 4)
  gc_frame_end(frame);
  return opresult7252;
}
Object meth_ast_shallowCopyWithParent7253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7254 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7255 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7257 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7256);
// compiled call node returning call7257 (depth = 7)
// compiled member node returning call7257 (depth = 6)
  gc_frame_newslot(call7257);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numNode (depth = 6)
  params[0] = call7257;
  partcv[0] = 1;
  Object call7258 = callmethod(*var_numNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7255);
// compiled call node returning call7258 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7259 = callmethod(call7258, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe7254);
// compiled call node returning call7259 (depth = 4)
  gc_frame_end(frame);
  return call7259;
}
Object meth_ast_new7203(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7204 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7204 = alloc_userobj2(10,10, objclass7204);
  gc_frame_newslot(obj7204);
if (objclass7204 == NULL) {
  glfree(obj7204->class->name);
  obj7204->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7204, self, 0);
  addmethodreal(obj7204,"outer", &reader_ast_outer_7205);
  Object oldself7204 = self;
  struct StackFrameObject *oldstackframe7204 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7204);
  gc_frame_newslot((Object)stackframe);
  self = obj7204;
  Object *oldselfslot7204 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7204 = (*(struct UserObject *)self).data[0], lowerouter7204 = thisouter7204;
  if (inheritingObject7204) {
    struct UserObject *inho7204 = (struct UserObject *)inheritingObject7204;
    while (inho7204->super != GraceDefaultObject) inho7204 = (struct UserObject *)inho7204->super;
    inho7204->super = obj7204;
    self = inheritingObject7204;
    *selfslot = self;
    lowerouter7204 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7204;
  }
if (objclass7204 == NULL) {
  Method *reader7206 = addmethodrealflags(obj7204, "kind",&reader_ast_kind_7206, MFLAG_DEF);
  reader7206->definitionModule = modulename;
  reader7206->definitionLine = 1666;
}
adddatum2(obj7204, alloc_Undefined(), 1);
if (objclass7204 == NULL) {
  Method *reader7207 = addmethodrealflags(obj7204, "value",&reader_ast_value_7207, 0);
  Method *writer7207 = addmethodrealflags(obj7204, "value:=",&writer_ast_value_7207, 0);
  reader7207->definitionModule = modulename;
  writer7207->definitionModule = modulename;
  reader7207->definitionLine = 1667;
  writer7207->definitionLine = 1667;
}
obj7204->flags |= OFLAG_MUTABLE;
adddatum2(obj7204, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7208 = (struct UserObject*)obj7204;
  uo7208->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7208 = addmethod2pos(obj7204, "accept()from", &meth_ast_accept_40__41_from7208, 3);
  int argcv_meth_ast_accept_40__41_from7208[] = {1, 1};
  meth_meth_ast_accept_40__41_from7208->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7208);
  meth_meth_ast_accept_40__41_from7208->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7208->definitionLine = 1667;
// method map()parent
  struct UserObject *uo7211 = (struct UserObject*)obj7204;
  uo7211->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7211 = addmethod2pos(obj7204, "map()parent", &meth_ast_map_40__41_parent7211, 4);
  int argcv_meth_ast_map_40__41_parent7211[] = {1, 1};
  meth_meth_ast_map_40__41_parent7211->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7211);
  meth_meth_ast_map_40__41_parent7211->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7211->definitionLine = 1670;
// method pretty
  struct UserObject *uo7217 = (struct UserObject*)obj7204;
  uo7217->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7217 = addmethod2pos(obj7204, "pretty", &meth_ast_pretty7217, 5);
  int argcv_meth_ast_pretty7217[] = {1};
  meth_meth_ast_pretty7217->type = alloc_MethodType(1, argcv_meth_ast_pretty7217);
  meth_meth_ast_pretty7217->definitionModule = modulename;
  meth_meth_ast_pretty7217->definitionLine = 1675;
// method toGrace
  struct UserObject *uo7237 = (struct UserObject*)obj7204;
  uo7237->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7237 = addmethod2pos(obj7204, "toGrace", &meth_ast_toGrace7237, 6);
  int argcv_meth_ast_toGrace7237[] = {1};
  meth_meth_ast_toGrace7237->type = alloc_MethodType(1, argcv_meth_ast_toGrace7237);
meth_meth_ast_toGrace7237->type->types[0] = type_Number;
meth_meth_ast_toGrace7237->type->names[0] = "depth";
  meth_meth_ast_toGrace7237->definitionModule = modulename;
  meth_meth_ast_toGrace7237->definitionLine = 1678;
// method asString
  struct UserObject *uo7242 = (struct UserObject*)obj7204;
  uo7242->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7242 = addmethod2pos(obj7204, "asString", &meth_ast_asString7242, 7);
  int argcv_meth_ast_asString7242[] = {0};
  meth_meth_ast_asString7242->type = alloc_MethodType(1, argcv_meth_ast_asString7242);
  meth_meth_ast_asString7242->definitionModule = modulename;
  meth_meth_ast_asString7242->definitionLine = 1681;
// method shallowCopyWithParent
  block_savedest(obj7204);
  Object closure7253 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7253, stackframe);
  addtoclosure(closure7253, var_numNode);
  struct UserObject *uo7253 = (struct UserObject*)obj7204;
  uo7253->data[8] = (Object)closure7253;
  Method *meth_meth_ast_shallowCopyWithParent7253 = addmethod2pos(obj7204, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7253, 8);
  int argcv_meth_ast_shallowCopyWithParent7253[] = {1};
  meth_meth_ast_shallowCopyWithParent7253->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7253);
  meth_meth_ast_shallowCopyWithParent7253->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7253->definitionLine = 1682;
  sourceObject = obj7204;
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7260 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7261 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7260);
// compiled call node returning call7261 (depth = 4)
  struct UserObject *obj7204_uo = (struct UserObject *)obj7204;
  obj7204_uo->super = call7261;
  sourceObject = obj7204;
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7262 == NULL) {
    strlit7262 = alloc_String("num");
    gc_root(strlit7262);
  }
// compiled string node returning strlit7262 (depth = 4)
  adddatum2(obj7204, strlit7262, 1);
  sourceObject = obj7204;
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val (depth = 4)
  adddatum2(obj7204, *var_val, 2);
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
objclass7204 = obj7204->class;
  objclass7204->definitionModule = modulename;
  objclass7204->definitionLine = 1663;
  (*(struct UserObject *)self).data[0] = lowerouter7204;
  self = oldself7204;
  selfslot = oldselfslot7204;
  stackframe = oldstackframe7204;
  gc_frame_end(frame);
  return obj7204;
}
Object meth_ast_new7203_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_numNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7204 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7204 = alloc_userobj2(10,10, objclass7204);
  gc_frame_newslot(obj7204);
if (objclass7204 == NULL) {
  glfree(obj7204->class->name);
  obj7204->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7204, self, 0);
  addmethodreal(obj7204,"outer", &reader_ast_outer_7205);
  Object oldself7204 = self;
  struct StackFrameObject *oldstackframe7204 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7204);
  gc_frame_newslot((Object)stackframe);
  self = obj7204;
  Object *oldselfslot7204 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7204 = (*(struct UserObject *)self).data[0], lowerouter7204 = thisouter7204;
  if (inheritingObject7204) {
    struct UserObject *inho7204 = (struct UserObject *)inheritingObject7204;
    while (inho7204->super != GraceDefaultObject) inho7204 = (struct UserObject *)inho7204->super;
    inho7204->super = obj7204;
    self = inheritingObject7204;
    *selfslot = self;
    lowerouter7204 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7204;
  }
if (objclass7204 == NULL) {
  Method *reader7206 = addmethodrealflags(obj7204, "kind",&reader_ast_kind_7206, MFLAG_DEF);
  reader7206->definitionModule = modulename;
  reader7206->definitionLine = 1666;
}
adddatum2(obj7204, alloc_Undefined(), 1);
if (objclass7204 == NULL) {
  Method *reader7207 = addmethodrealflags(obj7204, "value",&reader_ast_value_7207, 0);
  Method *writer7207 = addmethodrealflags(obj7204, "value:=",&writer_ast_value_7207, 0);
  reader7207->definitionModule = modulename;
  writer7207->definitionModule = modulename;
  reader7207->definitionLine = 1667;
  writer7207->definitionLine = 1667;
}
obj7204->flags |= OFLAG_MUTABLE;
adddatum2(obj7204, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo7208 = (struct UserObject*)obj7204;
  uo7208->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7208 = addmethod2pos(obj7204, "accept()from", &meth_ast_accept_40__41_from7208, 3);
  int argcv_meth_ast_accept_40__41_from7208[] = {1, 1};
  meth_meth_ast_accept_40__41_from7208->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7208);
  meth_meth_ast_accept_40__41_from7208->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7208->definitionLine = 1667;
// method map()parent
  struct UserObject *uo7211 = (struct UserObject*)obj7204;
  uo7211->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7211 = addmethod2pos(obj7204, "map()parent", &meth_ast_map_40__41_parent7211, 4);
  int argcv_meth_ast_map_40__41_parent7211[] = {1, 1};
  meth_meth_ast_map_40__41_parent7211->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7211);
  meth_meth_ast_map_40__41_parent7211->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7211->definitionLine = 1670;
// method pretty
  struct UserObject *uo7217 = (struct UserObject*)obj7204;
  uo7217->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty7217 = addmethod2pos(obj7204, "pretty", &meth_ast_pretty7217, 5);
  int argcv_meth_ast_pretty7217[] = {1};
  meth_meth_ast_pretty7217->type = alloc_MethodType(1, argcv_meth_ast_pretty7217);
  meth_meth_ast_pretty7217->definitionModule = modulename;
  meth_meth_ast_pretty7217->definitionLine = 1675;
// method toGrace
  struct UserObject *uo7237 = (struct UserObject*)obj7204;
  uo7237->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace7237 = addmethod2pos(obj7204, "toGrace", &meth_ast_toGrace7237, 6);
  int argcv_meth_ast_toGrace7237[] = {1};
  meth_meth_ast_toGrace7237->type = alloc_MethodType(1, argcv_meth_ast_toGrace7237);
meth_meth_ast_toGrace7237->type->types[0] = type_Number;
meth_meth_ast_toGrace7237->type->names[0] = "depth";
  meth_meth_ast_toGrace7237->definitionModule = modulename;
  meth_meth_ast_toGrace7237->definitionLine = 1678;
// method asString
  struct UserObject *uo7242 = (struct UserObject*)obj7204;
  uo7242->data[7] = emptyclosure;
  Method *meth_meth_ast_asString7242 = addmethod2pos(obj7204, "asString", &meth_ast_asString7242, 7);
  int argcv_meth_ast_asString7242[] = {0};
  meth_meth_ast_asString7242->type = alloc_MethodType(1, argcv_meth_ast_asString7242);
  meth_meth_ast_asString7242->definitionModule = modulename;
  meth_meth_ast_asString7242->definitionLine = 1681;
// method shallowCopyWithParent
  block_savedest(obj7204);
  Object closure7253 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7253, stackframe);
  addtoclosure(closure7253, var_numNode);
  struct UserObject *uo7253 = (struct UserObject*)obj7204;
  uo7253->data[8] = (Object)closure7253;
  Method *meth_meth_ast_shallowCopyWithParent7253 = addmethod2pos(obj7204, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7253, 8);
  int argcv_meth_ast_shallowCopyWithParent7253[] = {1};
  meth_meth_ast_shallowCopyWithParent7253->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7253);
  meth_meth_ast_shallowCopyWithParent7253->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7253->definitionLine = 1682;
  sourceObject = obj7204;
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7260 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7261 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7260);
// compiled call node returning call7261 (depth = 4)
  struct UserObject *obj7204_uo = (struct UserObject *)obj7204;
  obj7204_uo->super = call7261;
  sourceObject = obj7204;
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7262 == NULL) {
    strlit7262 = alloc_String("num");
    gc_root(strlit7262);
  }
// compiled string node returning strlit7262 (depth = 4)
  adddatum2(obj7204, strlit7262, 1);
  sourceObject = obj7204;
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val (depth = 4)
  adddatum2(obj7204, *var_val, 2);
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
  sourceObject = obj7204;
objclass7204 = obj7204->class;
  objclass7204->definitionModule = modulename;
  objclass7204->definitionLine = 1663;
  (*(struct UserObject *)self).data[0] = lowerouter7204;
  self = oldself7204;
  selfslot = oldselfslot7204;
  stackframe = oldstackframe7204;
  gc_frame_end(frame);
  return obj7204;
}
Object meth_ast_opNode7264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for opNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for opNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_opNode (depth = 3)
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_nameString7274(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7275 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7276 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7275);
// compiled call node returning call7276 (depth = 5)
// compiled member node returning call7276 (depth = 4)
  gc_frame_end(frame);
  return call7276;
}
Object meth_ast_accept_40__41_from7277(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7279 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7280 = callmethod(*var_visitor, "visitOp()up",
    2, partcv, params);
  gc_frame_end(callframe7279);
// compiled call node returning call7280 (depth = 5)
  Object if7278 = done;
  if (istrue(call7280)) {
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7281 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7282 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7283 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7282);
// compiled call node returning call7283 (depth = 7)
// compiled member node returning call7283 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7284 = callmethod(call7283, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7281);
// compiled call node returning call7284 (depth = 5)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7285 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7287 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7286);
// compiled call node returning call7287 (depth = 7)
// compiled member node returning call7287 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7288 = callmethod(call7287, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7285);
// compiled call node returning call7288 (depth = 5)
    gc_frame_newslot(call7288);
    if7278 = call7288;
  } else {
  }
// compiled if node returning if7278 (depth = 4)
  gc_frame_end(frame);
  return if7278;
}
Object meth_ast_map_40__41_parent7289(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7290 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7291 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7290);
// compiled call node returning call7291 (depth = 5)
  *var_n = call7291;
  if (call7291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7292 = gc_frame_new();
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7293 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7294 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7295 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7294);
// compiled call node returning call7295 (depth = 8)
// compiled member node returning call7295 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7296 = callmethod(call7295, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7293);
// compiled call node returning call7296 (depth = 6)
  gc_frame_newslot(call7296);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7296;
  partcv[0] = 1;
  Object call7297 = callmethod(*var_n, "left:=",
    1, partcv, params);
  gc_frame_end(callframe7292);
// compiled call node returning call7297 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7298 = gc_frame_new();
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7299 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7300 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7301 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7300);
// compiled call node returning call7301 (depth = 8)
// compiled member node returning call7301 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7302 = callmethod(call7301, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7299);
// compiled call node returning call7302 (depth = 6)
  gc_frame_newslot(call7302);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7302;
  partcv[0] = 1;
  Object call7303 = callmethod(*var_n, "right:=",
    1, partcv, params);
  gc_frame_end(callframe7298);
// compiled call node returning call7303 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7304 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7305 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7304);
// compiled call node returning call7305 (depth = 5)
  *var_n = call7305;
  if (call7305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7315(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit7317 == NULL) {
    strlit7317 = alloc_String("  ");
    gc_root(strlit7317);
  }
// compiled string node returning strlit7317 (depth = 8)
  int op_slot_right_7316 = gc_frame_newslot(strlit7317);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7316 = gc_frame_newslot(*var_spc);
  params[0] = strlit7317;
  partcv[0] = 1;
  Object opresult7319 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7319 (depth = 7)
  *var_spc = opresult7319;
  if (opresult7319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7307(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7308 == NULL) {
    strlit7308 = alloc_String("");
    gc_root(strlit7308);
  }
// compiled string node returning strlit7308 (depth = 5)
  *var_spc = strlit7308;
  if (strlit7308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7309 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_7310 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num7312 = alloc_Float64(0);
// compiled num node returning num7312 (depth = 6)
  int op_slot_left_7310 = gc_frame_newslot(num7312);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7313 = callmethod(num7312, "..", 1, partcv, params);
// compiled op node returning opresult7313 (depth = 5)
  gc_frame_newslot(opresult7313);
// starting to compile block node (depth = 5)
  Object block7314 = alloc_Block(NULL, NULL, "ast", 1708);
  gc_frame_newslot(block7314);
// method _apply
  block_savedest(block7314);
  Object closure7315 = createclosure(2, "_apply");
  setclosureframe(closure7315, stackframe);
  addtoclosure(closure7315, var_spc);
  addtoclosure(closure7315, selfslot);
  struct UserObject *uo7315 = (struct UserObject*)block7314;
  uo7315->data[0] = (Object)closure7315;
  Method *meth_meth_ast__apply7315 = addmethod2pos(block7314, "_apply", &meth_ast__apply7315, 0);
  int argcv_meth_ast__apply7315[] = {1};
  meth_meth_ast__apply7315->type = alloc_MethodType(1, argcv_meth_ast__apply7315);
  meth_meth_ast__apply7315->definitionModule = modulename;
  meth_meth_ast__apply7315->definitionLine = 1702;
// compiled block node returning block7314 (depth = 5)
  gc_frame_newslot(block7314);
// call case 5: prelude request
  params[0] = opresult7313;
  params[1] = block7314;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7322 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7309);
// compiled call node returning call7322 (depth = 4)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7324 == NULL) {
    strlit7324 = alloc_String("""\xe2""""\x80""""\xba""");
    gc_root(strlit7324);
  }
// compiled string node returning strlit7324 (depth = 6)
  int op_slot_right_7323 = gc_frame_newslot(strlit7324);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7328 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7327);
// compiled call node returning call7328 (depth = 8)
// compiled member node returning call7328 (depth = 7)
  int op_slot_right_7326 = gc_frame_newslot(call7328);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7331 == NULL) {
    strlit7331 = alloc_String("""\xe2""""\x80""""\xb9""");
    gc_root(strlit7331);
  }
// compiled string node returning strlit7331 (depth = 8)
  int op_slot_right_7330 = gc_frame_newslot(strlit7331);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7334 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7335 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7334);
// compiled call node returning call7335 (depth = 9)
  int op_slot_right_7333 = gc_frame_newslot(call7335);
// starting to compile string node (depth = 9)
  if (strlit7337 == NULL) {
    strlit7337 = alloc_String("");
    gc_root(strlit7337);
  }
// compiled string node returning strlit7337 (depth = 9)
  int op_slot_left_7333 = gc_frame_newslot(strlit7337);
  params[0] = call7335;
  partcv[0] = 1;
  Object opresult7338 = callmethod(strlit7337, "++", 1, partcv, params);
// compiled op node returning opresult7338 (depth = 8)
  int op_slot_left_7330 = gc_frame_newslot(opresult7338);
  params[0] = strlit7331;
  partcv[0] = 1;
  Object opresult7339 = callmethod(opresult7338, "++", 1, partcv, params);
// compiled op node returning opresult7339 (depth = 7)
  int op_slot_left_7326 = gc_frame_newslot(opresult7339);
  params[0] = call7328;
  partcv[0] = 1;
  Object opresult7340 = callmethod(opresult7339, "++", 1, partcv, params);
// compiled op node returning opresult7340 (depth = 6)
  int op_slot_left_7323 = gc_frame_newslot(opresult7340);
  params[0] = strlit7324;
  partcv[0] = 1;
  Object opresult7341 = callmethod(opresult7340, "++", 1, partcv, params);
// compiled op node returning opresult7341 (depth = 5)
  *var_s = opresult7341;
  if (opresult7341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7343 == NULL) {
    strlit7343 = alloc_String("""\x0a""");
    gc_root(strlit7343);
  }
// compiled string node returning strlit7343 (depth = 6)
  int op_slot_right_7342 = gc_frame_newslot(strlit7343);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7342 = gc_frame_newslot(*var_s);
  params[0] = strlit7343;
  partcv[0] = 1;
  Object opresult7345 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7345 (depth = 5)
  *var_s = opresult7345;
  if (opresult7345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7348 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7350 = alloc_Float64(1);
// compiled num node returning num7350 (depth = 8)
  int op_slot_right_7349 = gc_frame_newslot(num7350);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7349 = gc_frame_newslot(*var_depth);
  params[0] = num7350;
  partcv[0] = 1;
  Object sum7352 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7352 (depth = 7)
  gc_frame_newslot(sum7352);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7353 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7354 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7353);
// compiled call node returning call7354 (depth = 8)
// compiled member node returning call7354 (depth = 7)
  params[0] = sum7352;
  partcv[0] = 1;
  Object call7355 = callmethod(call7354, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7348);
// compiled call node returning call7355 (depth = 6)
  int op_slot_right_7347 = gc_frame_newslot(call7355);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7357 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7357 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7359 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7359 (depth = 6)
  int op_slot_left_7347 = gc_frame_newslot(opresult7359);
  params[0] = call7355;
  partcv[0] = 1;
  Object opresult7360 = callmethod(opresult7359, "++", 1, partcv, params);
// compiled op node returning opresult7360 (depth = 5)
  *var_s = opresult7360;
  if (opresult7360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7363 == NULL) {
    strlit7363 = alloc_String("""\x0a""");
    gc_root(strlit7363);
  }
// compiled string node returning strlit7363 (depth = 6)
  int op_slot_right_7362 = gc_frame_newslot(strlit7363);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7362 = gc_frame_newslot(*var_s);
  params[0] = strlit7363;
  partcv[0] = 1;
  Object opresult7365 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7365 (depth = 5)
  *var_s = opresult7365;
  if (opresult7365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7368 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7370 = alloc_Float64(1);
// compiled num node returning num7370 (depth = 8)
  int op_slot_right_7369 = gc_frame_newslot(num7370);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7369 = gc_frame_newslot(*var_depth);
  params[0] = num7370;
  partcv[0] = 1;
  Object sum7372 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7372 (depth = 7)
  gc_frame_newslot(sum7372);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7373 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7374 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7373);
// compiled call node returning call7374 (depth = 8)
// compiled member node returning call7374 (depth = 7)
  params[0] = sum7372;
  partcv[0] = 1;
  Object call7375 = callmethod(call7374, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7368);
// compiled call node returning call7375 (depth = 6)
  int op_slot_right_7367 = gc_frame_newslot(call7375);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7377 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7377 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7379 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7379 (depth = 6)
  int op_slot_left_7367 = gc_frame_newslot(opresult7379);
  params[0] = call7375;
  partcv[0] = 1;
  Object opresult7380 = callmethod(opresult7379, "++", 1, partcv, params);
// compiled op node returning opresult7380 (depth = 5)
  *var_s = opresult7380;
  if (opresult7380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7382(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7383 == NULL) {
    strlit7383 = alloc_String("");
    gc_root(strlit7383);
  }
// compiled string node returning strlit7383 (depth = 5)
  *var_s = strlit7383;
  if (strlit7383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7388 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7387);
// compiled call node returning call7388 (depth = 8)
// compiled member node returning call7388 (depth = 7)
  int op_slot_right_7386 = gc_frame_newslot(call7388);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7390 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7391 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7392 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7391);
// compiled call node returning call7392 (depth = 10)
// compiled member node returning call7392 (depth = 9)
  partcv[0] = 0;
  Object call7393 = callmethod(call7392, "value",
    1, partcv, params);
  gc_frame_end(callframe7390);
// compiled call node returning call7393 (depth = 8)
// compiled member node returning call7393 (depth = 7)
  int op_slot_left_7386 = gc_frame_newslot(call7393);
  params[0] = call7388;
  partcv[0] = 1;
  Object opresult7394 = callmethod(call7393, "!=", 1, partcv, params);
// compiled op node returning opresult7394 (depth = 6)
  int op_slot_right_7385 = gc_frame_newslot(opresult7394);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7397 == NULL) {
    strlit7397 = alloc_String("op");
    gc_root(strlit7397);
  }
// compiled string node returning strlit7397 (depth = 7)
  int op_slot_right_7396 = gc_frame_newslot(strlit7397);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7399 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7401 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7400);
// compiled call node returning call7401 (depth = 10)
// compiled member node returning call7401 (depth = 9)
  partcv[0] = 0;
  Object call7402 = callmethod(call7401, "kind",
    1, partcv, params);
  gc_frame_end(callframe7399);
// compiled call node returning call7402 (depth = 8)
// compiled member node returning call7402 (depth = 7)
  int op_slot_left_7396 = gc_frame_newslot(call7402);
  params[0] = strlit7397;
  partcv[0] = 1;
  Object opresult7403 = callmethod(call7402, "==", 1, partcv, params);
// compiled op node returning opresult7403 (depth = 6)
  int op_slot_left_7385 = gc_frame_newslot(opresult7403);
  params[0] = opresult7394;
  partcv[0] = 1;
  Object opresult7404 = callmethod(opresult7403, "&&", 1, partcv, params);
// compiled op node returning opresult7404 (depth = 5)
  Object if7384 = done;
  if (istrue(opresult7404)) {
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7406 == NULL) {
    strlit7406 = alloc_String(")");
    gc_root(strlit7406);
  }
// compiled string node returning strlit7406 (depth = 7)
  int op_slot_right_7405 = gc_frame_newslot(strlit7406);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7409 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num7410 = alloc_Float64(0);
// compiled num node returning num7410 (depth = 9)
  gc_frame_newslot(num7410);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7412 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7411);
// compiled call node returning call7412 (depth = 10)
// compiled member node returning call7412 (depth = 9)
  params[0] = num7410;
  partcv[0] = 1;
  Object call7413 = callmethod(call7412, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7409);
// compiled call node returning call7413 (depth = 8)
  int op_slot_right_7408 = gc_frame_newslot(call7413);
// starting to compile string node (depth = 8)
  if (strlit7415 == NULL) {
    strlit7415 = alloc_String("(");
    gc_root(strlit7415);
  }
// compiled string node returning strlit7415 (depth = 8)
  int op_slot_left_7408 = gc_frame_newslot(strlit7415);
  params[0] = call7413;
  partcv[0] = 1;
  Object opresult7416 = callmethod(strlit7415, "++", 1, partcv, params);
// compiled op node returning opresult7416 (depth = 7)
  int op_slot_left_7405 = gc_frame_newslot(opresult7416);
  params[0] = strlit7406;
  partcv[0] = 1;
  Object opresult7417 = callmethod(opresult7416, "++", 1, partcv, params);
// compiled op node returning opresult7417 (depth = 6)
  *var_s = opresult7417;
  if (opresult7417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7384 = done;
  } else {
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7419 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num7420 = alloc_Float64(0);
// compiled num node returning num7420 (depth = 7)
  gc_frame_newslot(num7420);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7422 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7421);
// compiled call node returning call7422 (depth = 8)
// compiled member node returning call7422 (depth = 7)
  params[0] = num7420;
  partcv[0] = 1;
  Object call7423 = callmethod(call7422, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7419);
// compiled call node returning call7423 (depth = 6)
  *var_s = call7423;
  if (call7423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7384 = done;
  }
// compiled if node returning if7384 (depth = 4)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7427 == NULL) {
    strlit7427 = alloc_String("..");
    gc_root(strlit7427);
  }
// compiled string node returning strlit7427 (depth = 6)
  int op_slot_right_7426 = gc_frame_newslot(strlit7427);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7430 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7429);
// compiled call node returning call7430 (depth = 7)
// compiled member node returning call7430 (depth = 6)
  int op_slot_left_7426 = gc_frame_newslot(call7430);
  params[0] = strlit7427;
  partcv[0] = 1;
  Object opresult7431 = callmethod(call7430, "==", 1, partcv, params);
// compiled op node returning opresult7431 (depth = 5)
  Object if7425 = done;
  if (istrue(opresult7431)) {
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7433 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7434 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7433);
// compiled call node returning call7434 (depth = 8)
// compiled member node returning call7434 (depth = 7)
  int op_slot_right_7432 = gc_frame_newslot(call7434);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7432 = gc_frame_newslot(*var_s);
  params[0] = call7434;
  partcv[0] = 1;
  Object opresult7436 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7436 (depth = 6)
  *var_s = opresult7436;
  if (opresult7436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7425 = done;
  } else {
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7439 == NULL) {
    strlit7439 = alloc_String(" ");
    gc_root(strlit7439);
  }
// compiled string node returning strlit7439 (depth = 7)
  int op_slot_right_7438 = gc_frame_newslot(strlit7439);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7443 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7442);
// compiled call node returning call7443 (depth = 9)
// compiled member node returning call7443 (depth = 8)
  int op_slot_right_7441 = gc_frame_newslot(call7443);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7446 == NULL) {
    strlit7446 = alloc_String(" ");
    gc_root(strlit7446);
  }
// compiled string node returning strlit7446 (depth = 9)
  int op_slot_right_7445 = gc_frame_newslot(strlit7446);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7445 = gc_frame_newslot(*var_s);
  params[0] = strlit7446;
  partcv[0] = 1;
  Object opresult7448 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7448 (depth = 8)
  int op_slot_left_7441 = gc_frame_newslot(opresult7448);
  params[0] = call7443;
  partcv[0] = 1;
  Object opresult7449 = callmethod(opresult7448, "++", 1, partcv, params);
// compiled op node returning opresult7449 (depth = 7)
  int op_slot_left_7438 = gc_frame_newslot(opresult7449);
  params[0] = strlit7439;
  partcv[0] = 1;
  Object opresult7450 = callmethod(opresult7449, "++", 1, partcv, params);
// compiled op node returning opresult7450 (depth = 6)
  *var_s = opresult7450;
  if (opresult7450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7425 = done;
  }
// compiled if node returning if7425 (depth = 4)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7456 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7455);
// compiled call node returning call7456 (depth = 8)
// compiled member node returning call7456 (depth = 7)
  int op_slot_right_7454 = gc_frame_newslot(call7456);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7458 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7459 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7460 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7459);
// compiled call node returning call7460 (depth = 10)
// compiled member node returning call7460 (depth = 9)
  partcv[0] = 0;
  Object call7461 = callmethod(call7460, "value",
    1, partcv, params);
  gc_frame_end(callframe7458);
// compiled call node returning call7461 (depth = 8)
// compiled member node returning call7461 (depth = 7)
  int op_slot_left_7454 = gc_frame_newslot(call7461);
  params[0] = call7456;
  partcv[0] = 1;
  Object opresult7462 = callmethod(call7461, "!=", 1, partcv, params);
// compiled op node returning opresult7462 (depth = 6)
  int op_slot_right_7453 = gc_frame_newslot(opresult7462);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7465 == NULL) {
    strlit7465 = alloc_String("op");
    gc_root(strlit7465);
  }
// compiled string node returning strlit7465 (depth = 7)
  int op_slot_right_7464 = gc_frame_newslot(strlit7465);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7467 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7468 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7469 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7468);
// compiled call node returning call7469 (depth = 10)
// compiled member node returning call7469 (depth = 9)
  partcv[0] = 0;
  Object call7470 = callmethod(call7469, "kind",
    1, partcv, params);
  gc_frame_end(callframe7467);
// compiled call node returning call7470 (depth = 8)
// compiled member node returning call7470 (depth = 7)
  int op_slot_left_7464 = gc_frame_newslot(call7470);
  params[0] = strlit7465;
  partcv[0] = 1;
  Object opresult7471 = callmethod(call7470, "==", 1, partcv, params);
// compiled op node returning opresult7471 (depth = 6)
  int op_slot_left_7453 = gc_frame_newslot(opresult7471);
  params[0] = opresult7462;
  partcv[0] = 1;
  Object opresult7472 = callmethod(opresult7471, "&&", 1, partcv, params);
// compiled op node returning opresult7472 (depth = 5)
  Object if7452 = done;
  if (istrue(opresult7472)) {
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7474 == NULL) {
    strlit7474 = alloc_String(")");
    gc_root(strlit7474);
  }
// compiled string node returning strlit7474 (depth = 7)
  int op_slot_right_7473 = gc_frame_newslot(strlit7474);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7477 = gc_frame_new();
// starting to compile num node (depth = 9)
  Object num7478 = alloc_Float64(0);
// compiled num node returning num7478 (depth = 9)
  gc_frame_newslot(num7478);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7479 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7480 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7479);
// compiled call node returning call7480 (depth = 10)
// compiled member node returning call7480 (depth = 9)
  params[0] = num7478;
  partcv[0] = 1;
  Object call7481 = callmethod(call7480, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7477);
// compiled call node returning call7481 (depth = 8)
  int op_slot_right_7476 = gc_frame_newslot(call7481);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7484 == NULL) {
    strlit7484 = alloc_String("(");
    gc_root(strlit7484);
  }
// compiled string node returning strlit7484 (depth = 9)
  int op_slot_right_7483 = gc_frame_newslot(strlit7484);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_7483 = gc_frame_newslot(*var_s);
  params[0] = strlit7484;
  partcv[0] = 1;
  Object opresult7486 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7486 (depth = 8)
  int op_slot_left_7476 = gc_frame_newslot(opresult7486);
  params[0] = call7481;
  partcv[0] = 1;
  Object opresult7487 = callmethod(opresult7486, "++", 1, partcv, params);
// compiled op node returning opresult7487 (depth = 7)
  int op_slot_left_7473 = gc_frame_newslot(opresult7487);
  params[0] = strlit7474;
  partcv[0] = 1;
  Object opresult7488 = callmethod(opresult7487, "++", 1, partcv, params);
// compiled op node returning opresult7488 (depth = 6)
  *var_s = opresult7488;
  if (opresult7488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7452 = done;
  } else {
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7491 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num7492 = alloc_Float64(0);
// compiled num node returning num7492 (depth = 8)
  gc_frame_newslot(num7492);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7493 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7494 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7493);
// compiled call node returning call7494 (depth = 9)
// compiled member node returning call7494 (depth = 8)
  params[0] = num7492;
  partcv[0] = 1;
  Object call7495 = callmethod(call7494, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7491);
// compiled call node returning call7495 (depth = 7)
  int op_slot_right_7490 = gc_frame_newslot(call7495);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7490 = gc_frame_newslot(*var_s);
  params[0] = call7495;
  partcv[0] = 1;
  Object opresult7497 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7497 (depth = 6)
  *var_s = opresult7497;
  if (opresult7497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7452 = done;
  }
// compiled if node returning if7452 (depth = 4)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asIdentifier7499(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asIdentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_resultNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "resultNode");
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7500 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7501 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7502 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7501);
// compiled call node returning call7502 (depth = 7)
// compiled member node returning call7502 (depth = 6)
  gc_frame_newslot(call7502);
// starting to compile identifier node (depth = 6)
  Object bool7503 = alloc_Boolean(0);
// compiled identifier node returning bool7503 (depth = 6)
  gc_frame_newslot(bool7503);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_identifierNode (depth = 6)
  params[0] = call7502;
  params[1] = bool7503;
  partcv[0] = 2;
  Object call7504 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7500);
// compiled call node returning call7504 (depth = 5)
  *var_resultNode = call7504;
  if (call7504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7505 = gc_frame_new();
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool7506 = alloc_Boolean(1);
// compiled identifier node returning bool7506 (depth = 6)
  gc_frame_newslot(bool7506);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = bool7506;
  partcv[0] = 1;
  Object call7507 = callmethod(*var_resultNode, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe7505);
// compiled call node returning call7507 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7508 = gc_frame_new();
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7510 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7509);
// compiled call node returning call7510 (depth = 7)
// compiled member node returning call7510 (depth = 6)
  gc_frame_newslot(call7510);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = call7510;
  partcv[0] = 1;
  Object call7511 = callmethod(*var_resultNode, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7508);
// compiled call node returning call7511 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7512 = gc_frame_new();
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7513 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7514 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7513);
// compiled call node returning call7514 (depth = 7)
// compiled member node returning call7514 (depth = 6)
  gc_frame_newslot(call7514);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_resultNode (depth = 6)
  params[0] = call7514;
  partcv[0] = 1;
  Object call7515 = callmethod(*var_resultNode, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe7512);
// compiled call node returning call7515 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7516 = gc_frame_new();
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 4: self request
  params[0] = self;
  partcv[0] = 1;
  Object call7517 = callmethodflags(self, "parent:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7516);
// compiled call node returning call7517 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_resultNode (depth = 5)
  return *var_resultNode;
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_shallowCopyWithParent7518(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_opNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7519 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7520 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7522 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7521);
// compiled call node returning call7522 (depth = 7)
// compiled member node returning call7522 (depth = 6)
  gc_frame_newslot(call7522);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opNode (depth = 6)
  params[0] = call7522;
  params[1] = *var_nullNode;
  params[2] = *var_nullNode;
  partcv[0] = 3;
  Object call7523 = callmethod(*var_opNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7520);
// compiled call node returning call7523 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7524 = callmethod(call7523, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe7519);
// compiled call node returning call7524 (depth = 4)
  gc_frame_end(frame);
  return call7524;
}
Object meth_ast_new7267(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7268 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7268 = alloc_userobj2(14,13, objclass7268);
  gc_frame_newslot(obj7268);
if (objclass7268 == NULL) {
  glfree(obj7268->class->name);
  obj7268->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7268, self, 0);
  addmethodreal(obj7268,"outer", &reader_ast_outer_7269);
  Object oldself7268 = self;
  struct StackFrameObject *oldstackframe7268 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7268);
  gc_frame_newslot((Object)stackframe);
  self = obj7268;
  Object *oldselfslot7268 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7268 = (*(struct UserObject *)self).data[0], lowerouter7268 = thisouter7268;
  if (inheritingObject7268) {
    struct UserObject *inho7268 = (struct UserObject *)inheritingObject7268;
    while (inho7268->super != GraceDefaultObject) inho7268 = (struct UserObject *)inho7268->super;
    inho7268->super = obj7268;
    self = inheritingObject7268;
    *selfslot = self;
    lowerouter7268 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7268;
  }
if (objclass7268 == NULL) {
  Method *reader7270 = addmethodrealflags(obj7268, "kind",&reader_ast_kind_7270, MFLAG_DEF);
  reader7270->definitionModule = modulename;
  reader7270->definitionLine = 1689;
}
adddatum2(obj7268, alloc_Undefined(), 1);
if (objclass7268 == NULL) {
  Method *reader7271 = addmethodrealflags(obj7268, "value",&reader_ast_value_7271, MFLAG_DEF);
  reader7271->definitionModule = modulename;
  reader7271->definitionLine = 1690;
}
adddatum2(obj7268, alloc_Undefined(), 2);
if (objclass7268 == NULL) {
  Method *reader7272 = addmethodrealflags(obj7268, "left",&reader_ast_left_7272, 0);
  Method *writer7272 = addmethodrealflags(obj7268, "left:=",&writer_ast_left_7272, 0);
  reader7272->definitionModule = modulename;
  writer7272->definitionModule = modulename;
  reader7272->definitionLine = 1691;
  writer7272->definitionLine = 1691;
}
obj7268->flags |= OFLAG_MUTABLE;
adddatum2(obj7268, alloc_Undefined(), 3);
if (objclass7268 == NULL) {
  Method *reader7273 = addmethodrealflags(obj7268, "right",&reader_ast_right_7273, 0);
  Method *writer7273 = addmethodrealflags(obj7268, "right:=",&writer_ast_right_7273, 0);
  reader7273->definitionModule = modulename;
  writer7273->definitionModule = modulename;
  reader7273->definitionLine = 1692;
  writer7273->definitionLine = 1692;
}
obj7268->flags |= OFLAG_MUTABLE;
adddatum2(obj7268, alloc_Undefined(), 4);
// method nameString
  struct UserObject *uo7274 = (struct UserObject*)obj7268;
  uo7274->data[5] = emptyclosure;
  Method *meth_meth_ast_nameString7274 = addmethod2pos(obj7268, "nameString", &meth_ast_nameString7274, 5);
  int argcv_meth_ast_nameString7274[] = {0};
  meth_meth_ast_nameString7274->type = alloc_MethodType(1, argcv_meth_ast_nameString7274);
  meth_meth_ast_nameString7274->definitionModule = modulename;
  meth_meth_ast_nameString7274->definitionLine = 1692;
// method accept()from
  struct UserObject *uo7277 = (struct UserObject*)obj7268;
  uo7277->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7277 = addmethod2pos(obj7268, "accept()from", &meth_ast_accept_40__41_from7277, 6);
  int argcv_meth_ast_accept_40__41_from7277[] = {1, 1};
  meth_meth_ast_accept_40__41_from7277->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7277);
  meth_meth_ast_accept_40__41_from7277->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7277->definitionLine = 1693;
// method map()parent
  struct UserObject *uo7289 = (struct UserObject*)obj7268;
  uo7289->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7289 = addmethod2pos(obj7268, "map()parent", &meth_ast_map_40__41_parent7289, 7);
  int argcv_meth_ast_map_40__41_parent7289[] = {1, 1};
  meth_meth_ast_map_40__41_parent7289->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7289);
  meth_meth_ast_map_40__41_parent7289->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7289->definitionLine = 1699;
// method pretty
  struct UserObject *uo7307 = (struct UserObject*)obj7268;
  uo7307->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7307 = addmethod2pos(obj7268, "pretty", &meth_ast_pretty7307, 8);
  int argcv_meth_ast_pretty7307[] = {1};
  meth_meth_ast_pretty7307->type = alloc_MethodType(1, argcv_meth_ast_pretty7307);
  meth_meth_ast_pretty7307->definitionModule = modulename;
  meth_meth_ast_pretty7307->definitionLine = 1706;
// method toGrace
  struct UserObject *uo7382 = (struct UserObject*)obj7268;
  uo7382->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7382 = addmethod2pos(obj7268, "toGrace", &meth_ast_toGrace7382, 9);
  int argcv_meth_ast_toGrace7382[] = {1};
  meth_meth_ast_toGrace7382->type = alloc_MethodType(1, argcv_meth_ast_toGrace7382);
meth_meth_ast_toGrace7382->type->types[0] = type_Number;
meth_meth_ast_toGrace7382->type->names[0] = "depth";
  meth_meth_ast_toGrace7382->definitionModule = modulename;
  meth_meth_ast_toGrace7382->definitionLine = 1718;
// method asIdentifier
  block_savedest(obj7268);
  Object closure7499 = createclosure(1, "asIdentifier");
  setclosureframe(closure7499, stackframe);
  addtoclosure(closure7499, var_identifierNode);
  struct UserObject *uo7499 = (struct UserObject*)obj7268;
  uo7499->data[10] = (Object)closure7499;
  Method *meth_meth_ast_asIdentifier7499 = addmethod2pos(obj7268, "asIdentifier", &meth_ast_asIdentifier7499, 10);
  int argcv_meth_ast_asIdentifier7499[] = {0};
  meth_meth_ast_asIdentifier7499->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7499);
  meth_meth_ast_asIdentifier7499->definitionModule = modulename;
  meth_meth_ast_asIdentifier7499->definitionLine = 1737;
// method shallowCopyWithParent
  block_savedest(obj7268);
  Object closure7518 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure7518, stackframe);
  addtoclosure(closure7518, var_nullNode);
  addtoclosure(closure7518, var_opNode);
  struct UserObject *uo7518 = (struct UserObject*)obj7268;
  uo7518->data[11] = (Object)closure7518;
  Method *meth_meth_ast_shallowCopyWithParent7518 = addmethod2pos(obj7268, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7518, 11);
  int argcv_meth_ast_shallowCopyWithParent7518[] = {1};
  meth_meth_ast_shallowCopyWithParent7518->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7518);
  meth_meth_ast_shallowCopyWithParent7518->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7518->definitionLine = 1746;
  sourceObject = obj7268;
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7525 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7526 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7525);
// compiled call node returning call7526 (depth = 4)
  struct UserObject *obj7268_uo = (struct UserObject *)obj7268;
  obj7268_uo->super = call7526;
  sourceObject = obj7268;
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7527 == NULL) {
    strlit7527 = alloc_String("op");
    gc_root(strlit7527);
  }
// compiled string node returning strlit7527 (depth = 4)
  adddatum2(obj7268, strlit7527, 1);
  sourceObject = obj7268;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_op (depth = 4)
  adddatum2(obj7268, *var_op, 2);
  sourceObject = obj7268;
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  adddatum2(obj7268, *var_l, 3);
  sourceObject = obj7268;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_r (depth = 4)
  adddatum2(obj7268, *var_r, 4);
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
objclass7268 = obj7268->class;
  objclass7268->definitionModule = modulename;
  objclass7268->definitionLine = 1686;
  (*(struct UserObject *)self).data[0] = lowerouter7268;
  self = oldself7268;
  selfslot = oldselfslot7268;
  stackframe = oldstackframe7268;
  gc_frame_end(frame);
  return obj7268;
}
Object meth_ast_new7267_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_identifierNode = getfromclosure(closure, 0);
  Object *var_nullNode = getfromclosure(closure, 1);
  Object *var_opNode = getfromclosure(closure, 2);
  Object *var_baseNode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7268 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7268 = alloc_userobj2(14,13, objclass7268);
  gc_frame_newslot(obj7268);
if (objclass7268 == NULL) {
  glfree(obj7268->class->name);
  obj7268->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7268, self, 0);
  addmethodreal(obj7268,"outer", &reader_ast_outer_7269);
  Object oldself7268 = self;
  struct StackFrameObject *oldstackframe7268 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7268);
  gc_frame_newslot((Object)stackframe);
  self = obj7268;
  Object *oldselfslot7268 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7268 = (*(struct UserObject *)self).data[0], lowerouter7268 = thisouter7268;
  if (inheritingObject7268) {
    struct UserObject *inho7268 = (struct UserObject *)inheritingObject7268;
    while (inho7268->super != GraceDefaultObject) inho7268 = (struct UserObject *)inho7268->super;
    inho7268->super = obj7268;
    self = inheritingObject7268;
    *selfslot = self;
    lowerouter7268 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7268;
  }
if (objclass7268 == NULL) {
  Method *reader7270 = addmethodrealflags(obj7268, "kind",&reader_ast_kind_7270, MFLAG_DEF);
  reader7270->definitionModule = modulename;
  reader7270->definitionLine = 1689;
}
adddatum2(obj7268, alloc_Undefined(), 1);
if (objclass7268 == NULL) {
  Method *reader7271 = addmethodrealflags(obj7268, "value",&reader_ast_value_7271, MFLAG_DEF);
  reader7271->definitionModule = modulename;
  reader7271->definitionLine = 1690;
}
adddatum2(obj7268, alloc_Undefined(), 2);
if (objclass7268 == NULL) {
  Method *reader7272 = addmethodrealflags(obj7268, "left",&reader_ast_left_7272, 0);
  Method *writer7272 = addmethodrealflags(obj7268, "left:=",&writer_ast_left_7272, 0);
  reader7272->definitionModule = modulename;
  writer7272->definitionModule = modulename;
  reader7272->definitionLine = 1691;
  writer7272->definitionLine = 1691;
}
obj7268->flags |= OFLAG_MUTABLE;
adddatum2(obj7268, alloc_Undefined(), 3);
if (objclass7268 == NULL) {
  Method *reader7273 = addmethodrealflags(obj7268, "right",&reader_ast_right_7273, 0);
  Method *writer7273 = addmethodrealflags(obj7268, "right:=",&writer_ast_right_7273, 0);
  reader7273->definitionModule = modulename;
  writer7273->definitionModule = modulename;
  reader7273->definitionLine = 1692;
  writer7273->definitionLine = 1692;
}
obj7268->flags |= OFLAG_MUTABLE;
adddatum2(obj7268, alloc_Undefined(), 4);
// method nameString
  struct UserObject *uo7274 = (struct UserObject*)obj7268;
  uo7274->data[5] = emptyclosure;
  Method *meth_meth_ast_nameString7274 = addmethod2pos(obj7268, "nameString", &meth_ast_nameString7274, 5);
  int argcv_meth_ast_nameString7274[] = {0};
  meth_meth_ast_nameString7274->type = alloc_MethodType(1, argcv_meth_ast_nameString7274);
  meth_meth_ast_nameString7274->definitionModule = modulename;
  meth_meth_ast_nameString7274->definitionLine = 1692;
// method accept()from
  struct UserObject *uo7277 = (struct UserObject*)obj7268;
  uo7277->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7277 = addmethod2pos(obj7268, "accept()from", &meth_ast_accept_40__41_from7277, 6);
  int argcv_meth_ast_accept_40__41_from7277[] = {1, 1};
  meth_meth_ast_accept_40__41_from7277->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7277);
  meth_meth_ast_accept_40__41_from7277->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7277->definitionLine = 1693;
// method map()parent
  struct UserObject *uo7289 = (struct UserObject*)obj7268;
  uo7289->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7289 = addmethod2pos(obj7268, "map()parent", &meth_ast_map_40__41_parent7289, 7);
  int argcv_meth_ast_map_40__41_parent7289[] = {1, 1};
  meth_meth_ast_map_40__41_parent7289->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7289);
  meth_meth_ast_map_40__41_parent7289->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7289->definitionLine = 1699;
// method pretty
  struct UserObject *uo7307 = (struct UserObject*)obj7268;
  uo7307->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7307 = addmethod2pos(obj7268, "pretty", &meth_ast_pretty7307, 8);
  int argcv_meth_ast_pretty7307[] = {1};
  meth_meth_ast_pretty7307->type = alloc_MethodType(1, argcv_meth_ast_pretty7307);
  meth_meth_ast_pretty7307->definitionModule = modulename;
  meth_meth_ast_pretty7307->definitionLine = 1706;
// method toGrace
  struct UserObject *uo7382 = (struct UserObject*)obj7268;
  uo7382->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7382 = addmethod2pos(obj7268, "toGrace", &meth_ast_toGrace7382, 9);
  int argcv_meth_ast_toGrace7382[] = {1};
  meth_meth_ast_toGrace7382->type = alloc_MethodType(1, argcv_meth_ast_toGrace7382);
meth_meth_ast_toGrace7382->type->types[0] = type_Number;
meth_meth_ast_toGrace7382->type->names[0] = "depth";
  meth_meth_ast_toGrace7382->definitionModule = modulename;
  meth_meth_ast_toGrace7382->definitionLine = 1718;
// method asIdentifier
  block_savedest(obj7268);
  Object closure7499 = createclosure(1, "asIdentifier");
  setclosureframe(closure7499, stackframe);
  addtoclosure(closure7499, var_identifierNode);
  struct UserObject *uo7499 = (struct UserObject*)obj7268;
  uo7499->data[10] = (Object)closure7499;
  Method *meth_meth_ast_asIdentifier7499 = addmethod2pos(obj7268, "asIdentifier", &meth_ast_asIdentifier7499, 10);
  int argcv_meth_ast_asIdentifier7499[] = {0};
  meth_meth_ast_asIdentifier7499->type = alloc_MethodType(1, argcv_meth_ast_asIdentifier7499);
  meth_meth_ast_asIdentifier7499->definitionModule = modulename;
  meth_meth_ast_asIdentifier7499->definitionLine = 1737;
// method shallowCopyWithParent
  block_savedest(obj7268);
  Object closure7518 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure7518, stackframe);
  addtoclosure(closure7518, var_nullNode);
  addtoclosure(closure7518, var_opNode);
  struct UserObject *uo7518 = (struct UserObject*)obj7268;
  uo7518->data[11] = (Object)closure7518;
  Method *meth_meth_ast_shallowCopyWithParent7518 = addmethod2pos(obj7268, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7518, 11);
  int argcv_meth_ast_shallowCopyWithParent7518[] = {1};
  meth_meth_ast_shallowCopyWithParent7518->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7518);
  meth_meth_ast_shallowCopyWithParent7518->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7518->definitionLine = 1746;
  sourceObject = obj7268;
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7525 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7526 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7525);
// compiled call node returning call7526 (depth = 4)
  struct UserObject *obj7268_uo = (struct UserObject *)obj7268;
  obj7268_uo->super = call7526;
  sourceObject = obj7268;
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7527 == NULL) {
    strlit7527 = alloc_String("op");
    gc_root(strlit7527);
  }
// compiled string node returning strlit7527 (depth = 4)
  adddatum2(obj7268, strlit7527, 1);
  sourceObject = obj7268;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_op (depth = 4)
  adddatum2(obj7268, *var_op, 2);
  sourceObject = obj7268;
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  adddatum2(obj7268, *var_l, 3);
  sourceObject = obj7268;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_r (depth = 4)
  adddatum2(obj7268, *var_r, 4);
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
  sourceObject = obj7268;
objclass7268 = obj7268->class;
  objclass7268->definitionModule = modulename;
  objclass7268->definitionLine = 1686;
  (*(struct UserObject *)self).data[0] = lowerouter7268;
  self = oldself7268;
  selfslot = oldselfslot7268;
  stackframe = oldstackframe7268;
  gc_frame_end(frame);
  return obj7268;
}
Object meth_ast_indexNode7529(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indexNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for indexNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexNode (depth = 3)
  gc_frame_end(frame);
  return *var_indexNode;
}
Object meth_ast_accept_40__41_from7538(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7540 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7541 = callmethod(*var_visitor, "visitIndex()up",
    2, partcv, params);
  gc_frame_end(callframe7540);
// compiled call node returning call7541 (depth = 5)
  Object if7539 = done;
  if (istrue(call7541)) {
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7542 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7543 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7544 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7543);
// compiled call node returning call7544 (depth = 7)
// compiled member node returning call7544 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7545 = callmethod(call7544, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7542);
// compiled call node returning call7545 (depth = 5)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7546 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7547 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7548 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7547);
// compiled call node returning call7548 (depth = 7)
// compiled member node returning call7548 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7549 = callmethod(call7548, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7546);
// compiled call node returning call7549 (depth = 5)
    gc_frame_newslot(call7549);
    if7539 = call7549;
  } else {
  }
// compiled if node returning if7539 (depth = 4)
  gc_frame_end(frame);
  return if7539;
}
Object meth_ast_map_40__41_parent7550(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7551 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7552 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7551);
// compiled call node returning call7552 (depth = 5)
  *var_n = call7552;
  if (call7552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7553 = gc_frame_new();
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7554 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7555 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7556 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7555);
// compiled call node returning call7556 (depth = 8)
// compiled member node returning call7556 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7557 = callmethod(call7556, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7554);
// compiled call node returning call7557 (depth = 6)
  gc_frame_newslot(call7557);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7557;
  partcv[0] = 1;
  Object call7558 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7553);
// compiled call node returning call7558 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7559 = gc_frame_new();
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7560 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7561 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7562 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7561);
// compiled call node returning call7562 (depth = 8)
// compiled member node returning call7562 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7563 = callmethod(call7562, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7560);
// compiled call node returning call7563 (depth = 6)
  gc_frame_newslot(call7563);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7563;
  partcv[0] = 1;
  Object call7564 = callmethod(*var_n, "index:=",
    1, partcv, params);
  gc_frame_end(callframe7559);
// compiled call node returning call7564 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7565 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7566 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7565);
// compiled call node returning call7566 (depth = 5)
  *var_n = call7566;
  if (call7566 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7576(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit7578 == NULL) {
    strlit7578 = alloc_String("  ");
    gc_root(strlit7578);
  }
// compiled string node returning strlit7578 (depth = 8)
  int op_slot_right_7577 = gc_frame_newslot(strlit7578);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7577 = gc_frame_newslot(*var_spc);
  params[0] = strlit7578;
  partcv[0] = 1;
  Object opresult7580 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7580 (depth = 7)
  *var_spc = opresult7580;
  if (opresult7580 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7568(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7569 == NULL) {
    strlit7569 = alloc_String("");
    gc_root(strlit7569);
  }
// compiled string node returning strlit7569 (depth = 5)
  *var_spc = strlit7569;
  if (strlit7569 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7570 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_7571 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num7573 = alloc_Float64(0);
// compiled num node returning num7573 (depth = 6)
  int op_slot_left_7571 = gc_frame_newslot(num7573);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7574 = callmethod(num7573, "..", 1, partcv, params);
// compiled op node returning opresult7574 (depth = 5)
  gc_frame_newslot(opresult7574);
// starting to compile block node (depth = 5)
  Object block7575 = alloc_Block(NULL, NULL, "ast", 1772);
  gc_frame_newslot(block7575);
// method _apply
  block_savedest(block7575);
  Object closure7576 = createclosure(2, "_apply");
  setclosureframe(closure7576, stackframe);
  addtoclosure(closure7576, var_spc);
  addtoclosure(closure7576, selfslot);
  struct UserObject *uo7576 = (struct UserObject*)block7575;
  uo7576->data[0] = (Object)closure7576;
  Method *meth_meth_ast__apply7576 = addmethod2pos(block7575, "_apply", &meth_ast__apply7576, 0);
  int argcv_meth_ast__apply7576[] = {1};
  meth_meth_ast__apply7576->type = alloc_MethodType(1, argcv_meth_ast__apply7576);
  meth_meth_ast__apply7576->definitionModule = modulename;
  meth_meth_ast__apply7576->definitionLine = 1766;
// compiled block node returning block7575 (depth = 5)
  gc_frame_newslot(block7575);
// call case 5: prelude request
  params[0] = opresult7574;
  params[1] = block7575;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7583 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7570);
// compiled call node returning call7583 (depth = 4)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7585 == NULL) {
    strlit7585 = alloc_String("""\x0a""");
    gc_root(strlit7585);
  }
// compiled string node returning strlit7585 (depth = 6)
  int op_slot_right_7584 = gc_frame_newslot(strlit7585);
// starting to compile call node (depth = 6)
  int callframe7587 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7588 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7587);
// compiled call node returning call7588 (depth = 6)
  int op_slot_left_7584 = gc_frame_newslot(call7588);
  params[0] = strlit7585;
  partcv[0] = 1;
  Object opresult7589 = callmethod(call7588, "++", 1, partcv, params);
// compiled op node returning opresult7589 (depth = 5)
  *var_s = opresult7589;
  if (opresult7589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7591 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7593 = alloc_Float64(1);
// compiled num node returning num7593 (depth = 8)
  int op_slot_right_7592 = gc_frame_newslot(num7593);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7592 = gc_frame_newslot(*var_depth);
  params[0] = num7593;
  partcv[0] = 1;
  Object sum7595 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7595 (depth = 7)
  gc_frame_newslot(sum7595);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7596 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7597 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7596);
// compiled call node returning call7597 (depth = 8)
// compiled member node returning call7597 (depth = 7)
  params[0] = sum7595;
  partcv[0] = 1;
  Object call7598 = callmethod(call7597, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7591);
// compiled call node returning call7598 (depth = 6)
  int op_slot_right_7590 = gc_frame_newslot(call7598);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7600 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7600 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7602 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7602 (depth = 6)
  int op_slot_left_7590 = gc_frame_newslot(opresult7602);
  params[0] = call7598;
  partcv[0] = 1;
  Object opresult7603 = callmethod(opresult7602, "++", 1, partcv, params);
// compiled op node returning opresult7603 (depth = 5)
  *var_s = opresult7603;
  if (opresult7603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7606 == NULL) {
    strlit7606 = alloc_String("""\x0a""");
    gc_root(strlit7606);
  }
// compiled string node returning strlit7606 (depth = 6)
  int op_slot_right_7605 = gc_frame_newslot(strlit7606);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7605 = gc_frame_newslot(*var_s);
  params[0] = strlit7606;
  partcv[0] = 1;
  Object opresult7608 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7608 (depth = 5)
  *var_s = opresult7608;
  if (opresult7608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7611 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7613 = alloc_Float64(1);
// compiled num node returning num7613 (depth = 8)
  int op_slot_right_7612 = gc_frame_newslot(num7613);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7612 = gc_frame_newslot(*var_depth);
  params[0] = num7613;
  partcv[0] = 1;
  Object sum7615 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7615 (depth = 7)
  gc_frame_newslot(sum7615);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7616 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7617 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7616);
// compiled call node returning call7617 (depth = 8)
// compiled member node returning call7617 (depth = 7)
  params[0] = sum7615;
  partcv[0] = 1;
  Object call7618 = callmethod(call7617, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7611);
// compiled call node returning call7618 (depth = 6)
  int op_slot_right_7610 = gc_frame_newslot(call7618);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7620 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7620 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7622 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7622 (depth = 6)
  int op_slot_left_7610 = gc_frame_newslot(opresult7622);
  params[0] = call7618;
  partcv[0] = 1;
  Object opresult7623 = callmethod(opresult7622, "++", 1, partcv, params);
// compiled op node returning opresult7623 (depth = 5)
  *var_s = opresult7623;
  if (opresult7623 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7637(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit7639 == NULL) {
    strlit7639 = alloc_String("    ");
    gc_root(strlit7639);
  }
// compiled string node returning strlit7639 (depth = 8)
  int op_slot_right_7638 = gc_frame_newslot(strlit7639);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7638 = gc_frame_newslot(*var_spc);
  params[0] = strlit7639;
  partcv[0] = 1;
  Object opresult7641 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7641 (depth = 7)
  *var_spc = opresult7641;
  if (opresult7641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace7625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7626 == NULL) {
    strlit7626 = alloc_String("");
    gc_root(strlit7626);
  }
// compiled string node returning strlit7626 (depth = 5)
  *var_spc = strlit7626;
  if (strlit7626 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7627 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7630 = alloc_Float64(1);
// compiled num node returning num7630 (depth = 7)
  int op_slot_right_7629 = gc_frame_newslot(num7630);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7629 = gc_frame_newslot(*var_depth);
  params[0] = num7630;
  partcv[0] = 1;
  Object diff7632 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff7632 (depth = 6)
  int op_slot_right_7628 = gc_frame_newslot(diff7632);
// starting to compile num node (depth = 6)
  Object num7634 = alloc_Float64(0);
// compiled num node returning num7634 (depth = 6)
  int op_slot_left_7628 = gc_frame_newslot(num7634);
  params[0] = diff7632;
  partcv[0] = 1;
  Object opresult7635 = callmethod(num7634, "..", 1, partcv, params);
// compiled op node returning opresult7635 (depth = 5)
  gc_frame_newslot(opresult7635);
// starting to compile block node (depth = 5)
  Object block7636 = alloc_Block(NULL, NULL, "ast", 1783);
  gc_frame_newslot(block7636);
// method _apply
  block_savedest(block7636);
  Object closure7637 = createclosure(2, "_apply");
  setclosureframe(closure7637, stackframe);
  addtoclosure(closure7637, var_spc);
  addtoclosure(closure7637, selfslot);
  struct UserObject *uo7637 = (struct UserObject*)block7636;
  uo7637->data[0] = (Object)closure7637;
  Method *meth_meth_ast__apply7637 = addmethod2pos(block7636, "_apply", &meth_ast__apply7637, 0);
  int argcv_meth_ast__apply7637[] = {1};
  meth_meth_ast__apply7637->type = alloc_MethodType(1, argcv_meth_ast__apply7637);
  meth_meth_ast__apply7637->definitionModule = modulename;
  meth_meth_ast__apply7637->definitionLine = 1778;
// compiled block node returning block7636 (depth = 5)
  gc_frame_newslot(block7636);
// call case 5: prelude request
  params[0] = opresult7635;
  params[1] = block7636;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7644 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7627);
// compiled call node returning call7644 (depth = 4)
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7645 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7647 = alloc_Float64(1);
// compiled num node returning num7647 (depth = 7)
  int op_slot_right_7646 = gc_frame_newslot(num7647);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7646 = gc_frame_newslot(*var_depth);
  params[0] = num7647;
  partcv[0] = 1;
  Object sum7649 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7649 (depth = 6)
  gc_frame_newslot(sum7649);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7651 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7650);
// compiled call node returning call7651 (depth = 7)
// compiled member node returning call7651 (depth = 6)
  params[0] = sum7649;
  partcv[0] = 1;
  Object call7652 = callmethod(call7651, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7645);
// compiled call node returning call7652 (depth = 5)
  *var_s = call7652;
  if (call7652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7654 == NULL) {
    strlit7654 = alloc_String("]");
    gc_root(strlit7654);
  }
// compiled string node returning strlit7654 (depth = 6)
  int op_slot_right_7653 = gc_frame_newslot(strlit7654);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7657 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num7659 = alloc_Float64(1);
// compiled num node returning num7659 (depth = 9)
  int op_slot_right_7658 = gc_frame_newslot(num7659);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_7658 = gc_frame_newslot(*var_depth);
  params[0] = num7659;
  partcv[0] = 1;
  Object sum7661 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7661 (depth = 8)
  gc_frame_newslot(sum7661);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7662 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7663 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7662);
// compiled call node returning call7663 (depth = 9)
// compiled member node returning call7663 (depth = 8)
  params[0] = sum7661;
  partcv[0] = 1;
  Object call7664 = callmethod(call7663, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7657);
// compiled call node returning call7664 (depth = 7)
  int op_slot_right_7656 = gc_frame_newslot(call7664);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7667 == NULL) {
    strlit7667 = alloc_String("[");
    gc_root(strlit7667);
  }
// compiled string node returning strlit7667 (depth = 8)
  int op_slot_right_7666 = gc_frame_newslot(strlit7667);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_7666 = gc_frame_newslot(*var_s);
  params[0] = strlit7667;
  partcv[0] = 1;
  Object opresult7669 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7669 (depth = 7)
  int op_slot_left_7656 = gc_frame_newslot(opresult7669);
  params[0] = call7664;
  partcv[0] = 1;
  Object opresult7670 = callmethod(opresult7669, "++", 1, partcv, params);
// compiled op node returning opresult7670 (depth = 6)
  int op_slot_left_7653 = gc_frame_newslot(opresult7670);
  params[0] = strlit7654;
  partcv[0] = 1;
  Object opresult7671 = callmethod(opresult7670, "++", 1, partcv, params);
// compiled op node returning opresult7671 (depth = 5)
  *var_s = opresult7671;
  if (opresult7671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent7673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7674 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7675 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indexNode (depth = 6)
  params[0] = *var_nullNode;
  params[1] = *var_nullNode;
  partcv[0] = 2;
  Object call7676 = callmethod(*var_indexNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7675);
// compiled call node returning call7676 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7677 = callmethod(call7676, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe7674);
// compiled call node returning call7677 (depth = 4)
  gc_frame_end(frame);
  return call7677;
}
Object meth_ast_new7532(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7533 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7533 = alloc_userobj2(11,10, objclass7533);
  gc_frame_newslot(obj7533);
if (objclass7533 == NULL) {
  glfree(obj7533->class->name);
  obj7533->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7533, self, 0);
  addmethodreal(obj7533,"outer", &reader_ast_outer_7534);
  Object oldself7533 = self;
  struct StackFrameObject *oldstackframe7533 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7533);
  gc_frame_newslot((Object)stackframe);
  self = obj7533;
  Object *oldselfslot7533 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7533 = (*(struct UserObject *)self).data[0], lowerouter7533 = thisouter7533;
  if (inheritingObject7533) {
    struct UserObject *inho7533 = (struct UserObject *)inheritingObject7533;
    while (inho7533->super != GraceDefaultObject) inho7533 = (struct UserObject *)inho7533->super;
    inho7533->super = obj7533;
    self = inheritingObject7533;
    *selfslot = self;
    lowerouter7533 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7533;
  }
if (objclass7533 == NULL) {
  Method *reader7535 = addmethodrealflags(obj7533, "kind",&reader_ast_kind_7535, MFLAG_DEF);
  reader7535->definitionModule = modulename;
  reader7535->definitionLine = 1754;
}
adddatum2(obj7533, alloc_Undefined(), 1);
if (objclass7533 == NULL) {
  Method *reader7536 = addmethodrealflags(obj7533, "value",&reader_ast_value_7536, 0);
  Method *writer7536 = addmethodrealflags(obj7533, "value:=",&writer_ast_value_7536, 0);
  reader7536->definitionModule = modulename;
  writer7536->definitionModule = modulename;
  reader7536->definitionLine = 1755;
  writer7536->definitionLine = 1755;
}
obj7533->flags |= OFLAG_MUTABLE;
adddatum2(obj7533, alloc_Undefined(), 2);
if (objclass7533 == NULL) {
  Method *reader7537 = addmethodrealflags(obj7533, "index",&reader_ast_index_7537, 0);
  Method *writer7537 = addmethodrealflags(obj7533, "index:=",&writer_ast_index_7537, 0);
  reader7537->definitionModule = modulename;
  writer7537->definitionModule = modulename;
  reader7537->definitionLine = 1757;
  writer7537->definitionLine = 1757;
}
obj7533->flags |= OFLAG_MUTABLE;
adddatum2(obj7533, alloc_Undefined(), 3);
// method accept()from
  struct UserObject *uo7538 = (struct UserObject*)obj7533;
  uo7538->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7538 = addmethod2pos(obj7533, "accept()from", &meth_ast_accept_40__41_from7538, 4);
  int argcv_meth_ast_accept_40__41_from7538[] = {1, 1};
  meth_meth_ast_accept_40__41_from7538->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7538);
  meth_meth_ast_accept_40__41_from7538->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7538->definitionLine = 1757;
// method map()parent
  struct UserObject *uo7550 = (struct UserObject*)obj7533;
  uo7550->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7550 = addmethod2pos(obj7533, "map()parent", &meth_ast_map_40__41_parent7550, 5);
  int argcv_meth_ast_map_40__41_parent7550[] = {1, 1};
  meth_meth_ast_map_40__41_parent7550->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7550);
  meth_meth_ast_map_40__41_parent7550->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7550->definitionLine = 1763;
// method pretty
  struct UserObject *uo7568 = (struct UserObject*)obj7533;
  uo7568->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7568 = addmethod2pos(obj7533, "pretty", &meth_ast_pretty7568, 6);
  int argcv_meth_ast_pretty7568[] = {1};
  meth_meth_ast_pretty7568->type = alloc_MethodType(1, argcv_meth_ast_pretty7568);
  meth_meth_ast_pretty7568->definitionModule = modulename;
  meth_meth_ast_pretty7568->definitionLine = 1770;
// method toGrace
  struct UserObject *uo7625 = (struct UserObject*)obj7533;
  uo7625->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7625 = addmethod2pos(obj7533, "toGrace", &meth_ast_toGrace7625, 7);
  int argcv_meth_ast_toGrace7625[] = {1};
  meth_meth_ast_toGrace7625->type = alloc_MethodType(1, argcv_meth_ast_toGrace7625);
meth_meth_ast_toGrace7625->type->types[0] = type_Number;
meth_meth_ast_toGrace7625->type->names[0] = "depth";
  meth_meth_ast_toGrace7625->definitionModule = modulename;
  meth_meth_ast_toGrace7625->definitionLine = 1781;
// method shallowCopyWithParent
  block_savedest(obj7533);
  Object closure7673 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure7673, stackframe);
  addtoclosure(closure7673, var_nullNode);
  addtoclosure(closure7673, var_indexNode);
  struct UserObject *uo7673 = (struct UserObject*)obj7533;
  uo7673->data[8] = (Object)closure7673;
  Method *meth_meth_ast_shallowCopyWithParent7673 = addmethod2pos(obj7533, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7673, 8);
  int argcv_meth_ast_shallowCopyWithParent7673[] = {1};
  meth_meth_ast_shallowCopyWithParent7673->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7673);
  meth_meth_ast_shallowCopyWithParent7673->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7673->definitionLine = 1790;
  sourceObject = obj7533;
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7678 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7679 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7678);
// compiled call node returning call7679 (depth = 4)
  struct UserObject *obj7533_uo = (struct UserObject *)obj7533;
  obj7533_uo->super = call7679;
  sourceObject = obj7533;
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7680 == NULL) {
    strlit7680 = alloc_String("index");
    gc_root(strlit7680);
  }
// compiled string node returning strlit7680 (depth = 4)
  adddatum2(obj7533, strlit7680, 1);
  sourceObject = obj7533;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj7533, *var_expr, 2);
  sourceObject = obj7533;
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_index_39_ (depth = 4)
  adddatum2(obj7533, *var_index_39_, 3);
  sourceObject = obj7533;
  sourceObject = obj7533;
  sourceObject = obj7533;
  sourceObject = obj7533;
  sourceObject = obj7533;
objclass7533 = obj7533->class;
  objclass7533->definitionModule = modulename;
  objclass7533->definitionLine = 1750;
  (*(struct UserObject *)self).data[0] = lowerouter7533;
  self = oldself7533;
  selfslot = oldselfslot7533;
  stackframe = oldstackframe7533;
  gc_frame_end(frame);
  return obj7533;
}
Object meth_ast_new7532_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_indexNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7533 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7533 = alloc_userobj2(11,10, objclass7533);
  gc_frame_newslot(obj7533);
if (objclass7533 == NULL) {
  glfree(obj7533->class->name);
  obj7533->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7533, self, 0);
  addmethodreal(obj7533,"outer", &reader_ast_outer_7534);
  Object oldself7533 = self;
  struct StackFrameObject *oldstackframe7533 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7533);
  gc_frame_newslot((Object)stackframe);
  self = obj7533;
  Object *oldselfslot7533 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7533 = (*(struct UserObject *)self).data[0], lowerouter7533 = thisouter7533;
  if (inheritingObject7533) {
    struct UserObject *inho7533 = (struct UserObject *)inheritingObject7533;
    while (inho7533->super != GraceDefaultObject) inho7533 = (struct UserObject *)inho7533->super;
    inho7533->super = obj7533;
    self = inheritingObject7533;
    *selfslot = self;
    lowerouter7533 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7533;
  }
if (objclass7533 == NULL) {
  Method *reader7535 = addmethodrealflags(obj7533, "kind",&reader_ast_kind_7535, MFLAG_DEF);
  reader7535->definitionModule = modulename;
  reader7535->definitionLine = 1754;
}
adddatum2(obj7533, alloc_Undefined(), 1);
if (objclass7533 == NULL) {
  Method *reader7536 = addmethodrealflags(obj7533, "value",&reader_ast_value_7536, 0);
  Method *writer7536 = addmethodrealflags(obj7533, "value:=",&writer_ast_value_7536, 0);
  reader7536->definitionModule = modulename;
  writer7536->definitionModule = modulename;
  reader7536->definitionLine = 1755;
  writer7536->definitionLine = 1755;
}
obj7533->flags |= OFLAG_MUTABLE;
adddatum2(obj7533, alloc_Undefined(), 2);
if (objclass7533 == NULL) {
  Method *reader7537 = addmethodrealflags(obj7533, "index",&reader_ast_index_7537, 0);
  Method *writer7537 = addmethodrealflags(obj7533, "index:=",&writer_ast_index_7537, 0);
  reader7537->definitionModule = modulename;
  writer7537->definitionModule = modulename;
  reader7537->definitionLine = 1757;
  writer7537->definitionLine = 1757;
}
obj7533->flags |= OFLAG_MUTABLE;
adddatum2(obj7533, alloc_Undefined(), 3);
// method accept()from
  struct UserObject *uo7538 = (struct UserObject*)obj7533;
  uo7538->data[4] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7538 = addmethod2pos(obj7533, "accept()from", &meth_ast_accept_40__41_from7538, 4);
  int argcv_meth_ast_accept_40__41_from7538[] = {1, 1};
  meth_meth_ast_accept_40__41_from7538->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7538);
  meth_meth_ast_accept_40__41_from7538->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7538->definitionLine = 1757;
// method map()parent
  struct UserObject *uo7550 = (struct UserObject*)obj7533;
  uo7550->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7550 = addmethod2pos(obj7533, "map()parent", &meth_ast_map_40__41_parent7550, 5);
  int argcv_meth_ast_map_40__41_parent7550[] = {1, 1};
  meth_meth_ast_map_40__41_parent7550->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7550);
  meth_meth_ast_map_40__41_parent7550->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7550->definitionLine = 1763;
// method pretty
  struct UserObject *uo7568 = (struct UserObject*)obj7533;
  uo7568->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7568 = addmethod2pos(obj7533, "pretty", &meth_ast_pretty7568, 6);
  int argcv_meth_ast_pretty7568[] = {1};
  meth_meth_ast_pretty7568->type = alloc_MethodType(1, argcv_meth_ast_pretty7568);
  meth_meth_ast_pretty7568->definitionModule = modulename;
  meth_meth_ast_pretty7568->definitionLine = 1770;
// method toGrace
  struct UserObject *uo7625 = (struct UserObject*)obj7533;
  uo7625->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7625 = addmethod2pos(obj7533, "toGrace", &meth_ast_toGrace7625, 7);
  int argcv_meth_ast_toGrace7625[] = {1};
  meth_meth_ast_toGrace7625->type = alloc_MethodType(1, argcv_meth_ast_toGrace7625);
meth_meth_ast_toGrace7625->type->types[0] = type_Number;
meth_meth_ast_toGrace7625->type->names[0] = "depth";
  meth_meth_ast_toGrace7625->definitionModule = modulename;
  meth_meth_ast_toGrace7625->definitionLine = 1781;
// method shallowCopyWithParent
  block_savedest(obj7533);
  Object closure7673 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure7673, stackframe);
  addtoclosure(closure7673, var_nullNode);
  addtoclosure(closure7673, var_indexNode);
  struct UserObject *uo7673 = (struct UserObject*)obj7533;
  uo7673->data[8] = (Object)closure7673;
  Method *meth_meth_ast_shallowCopyWithParent7673 = addmethod2pos(obj7533, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7673, 8);
  int argcv_meth_ast_shallowCopyWithParent7673[] = {1};
  meth_meth_ast_shallowCopyWithParent7673->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7673);
  meth_meth_ast_shallowCopyWithParent7673->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7673->definitionLine = 1790;
  sourceObject = obj7533;
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7678 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7679 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7678);
// compiled call node returning call7679 (depth = 4)
  struct UserObject *obj7533_uo = (struct UserObject *)obj7533;
  obj7533_uo->super = call7679;
  sourceObject = obj7533;
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7680 == NULL) {
    strlit7680 = alloc_String("index");
    gc_root(strlit7680);
  }
// compiled string node returning strlit7680 (depth = 4)
  adddatum2(obj7533, strlit7680, 1);
  sourceObject = obj7533;
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj7533, *var_expr, 2);
  sourceObject = obj7533;
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_index_39_ (depth = 4)
  adddatum2(obj7533, *var_index_39_, 3);
  sourceObject = obj7533;
  sourceObject = obj7533;
  sourceObject = obj7533;
  sourceObject = obj7533;
  sourceObject = obj7533;
objclass7533 = obj7533->class;
  objclass7533->definitionModule = modulename;
  objclass7533->definitionLine = 1750;
  (*(struct UserObject *)self).data[0] = lowerouter7533;
  self = oldself7533;
  selfslot = oldselfslot7533;
  stackframe = oldstackframe7533;
  gc_frame_end(frame);
  return obj7533;
}
Object meth_ast_bindNode7682(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for bindNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_bindNode (depth = 3)
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_isBind7691(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isBind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isBind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7692 = alloc_Boolean(1);
// compiled identifier node returning bool7692 (depth = 4)
  gc_frame_end(frame);
  return bool7692;
}
Object meth_ast_asString7693(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7695 == NULL) {
    strlit7695 = alloc_String("");
    gc_root(strlit7695);
  }
// compiled string node returning strlit7695 (depth = 5)
  int op_slot_right_7694 = gc_frame_newslot(strlit7695);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7698 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7699 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7698);
// compiled call node returning call7699 (depth = 7)
// compiled member node returning call7699 (depth = 6)
  int op_slot_right_7697 = gc_frame_newslot(call7699);
// starting to compile string node (depth = 6)
  if (strlit7701 == NULL) {
    strlit7701 = alloc_String("Bind ");
    gc_root(strlit7701);
  }
// compiled string node returning strlit7701 (depth = 6)
  int op_slot_left_7697 = gc_frame_newslot(strlit7701);
  params[0] = call7699;
  partcv[0] = 1;
  Object opresult7702 = callmethod(strlit7701, "++", 1, partcv, params);
// compiled op node returning opresult7702 (depth = 5)
  int op_slot_left_7694 = gc_frame_newslot(opresult7702);
  params[0] = strlit7695;
  partcv[0] = 1;
  Object opresult7703 = callmethod(opresult7702, "++", 1, partcv, params);
// compiled op node returning opresult7703 (depth = 4)
  gc_frame_end(frame);
  return opresult7703;
}
Object meth_ast_accept_40__41_from7704(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7706 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7707 = callmethod(*var_visitor, "visitBind()up",
    2, partcv, params);
  gc_frame_end(callframe7706);
// compiled call node returning call7707 (depth = 5)
  Object if7705 = done;
  if (istrue(call7707)) {
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7708 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7709 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7710 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7709);
// compiled call node returning call7710 (depth = 7)
// compiled member node returning call7710 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7711 = callmethod(call7710, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7708);
// compiled call node returning call7711 (depth = 5)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7712 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7713 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7714 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7713);
// compiled call node returning call7714 (depth = 7)
// compiled member node returning call7714 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7715 = callmethod(call7714, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7712);
// compiled call node returning call7715 (depth = 5)
    gc_frame_newslot(call7715);
    if7705 = call7715;
  } else {
  }
// compiled if node returning if7705 (depth = 4)
  gc_frame_end(frame);
  return if7705;
}
Object meth_ast_map_40__41_parent7716(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7717 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7718 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7717);
// compiled call node returning call7718 (depth = 5)
  *var_n = call7718;
  if (call7718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7719 = gc_frame_new();
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7720 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7721 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7722 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7721);
// compiled call node returning call7722 (depth = 8)
// compiled member node returning call7722 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7723 = callmethod(call7722, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7720);
// compiled call node returning call7723 (depth = 6)
  gc_frame_newslot(call7723);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7723;
  partcv[0] = 1;
  Object call7724 = callmethod(*var_n, "dest:=",
    1, partcv, params);
  gc_frame_end(callframe7719);
// compiled call node returning call7724 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7725 = gc_frame_new();
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7726 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7727 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7728 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7727);
// compiled call node returning call7728 (depth = 8)
// compiled member node returning call7728 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7729 = callmethod(call7728, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7726);
// compiled call node returning call7729 (depth = 6)
  gc_frame_newslot(call7729);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7729;
  partcv[0] = 1;
  Object call7730 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7725);
// compiled call node returning call7730 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7731 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7732 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7731);
// compiled call node returning call7732 (depth = 5)
  *var_n = call7732;
  if (call7732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7742(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit7744 == NULL) {
    strlit7744 = alloc_String("  ");
    gc_root(strlit7744);
  }
// compiled string node returning strlit7744 (depth = 8)
  int op_slot_right_7743 = gc_frame_newslot(strlit7744);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7743 = gc_frame_newslot(*var_spc);
  params[0] = strlit7744;
  partcv[0] = 1;
  Object opresult7746 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7746 (depth = 7)
  *var_spc = opresult7746;
  if (opresult7746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7734(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7735 == NULL) {
    strlit7735 = alloc_String("");
    gc_root(strlit7735);
  }
// compiled string node returning strlit7735 (depth = 5)
  *var_spc = strlit7735;
  if (strlit7735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7736 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_7737 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num7739 = alloc_Float64(0);
// compiled num node returning num7739 (depth = 6)
  int op_slot_left_7737 = gc_frame_newslot(num7739);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7740 = callmethod(num7739, "..", 1, partcv, params);
// compiled op node returning opresult7740 (depth = 5)
  gc_frame_newslot(opresult7740);
// starting to compile block node (depth = 5)
  Object block7741 = alloc_Block(NULL, NULL, "ast", 1818);
  gc_frame_newslot(block7741);
// method _apply
  block_savedest(block7741);
  Object closure7742 = createclosure(2, "_apply");
  setclosureframe(closure7742, stackframe);
  addtoclosure(closure7742, var_spc);
  addtoclosure(closure7742, selfslot);
  struct UserObject *uo7742 = (struct UserObject*)block7741;
  uo7742->data[0] = (Object)closure7742;
  Method *meth_meth_ast__apply7742 = addmethod2pos(block7741, "_apply", &meth_ast__apply7742, 0);
  int argcv_meth_ast__apply7742[] = {1};
  meth_meth_ast__apply7742->type = alloc_MethodType(1, argcv_meth_ast__apply7742);
  meth_meth_ast__apply7742->definitionModule = modulename;
  meth_meth_ast__apply7742->definitionLine = 1812;
// compiled block node returning block7741 (depth = 5)
  gc_frame_newslot(block7741);
// call case 5: prelude request
  params[0] = opresult7740;
  params[1] = block7741;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7749 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7736);
// compiled call node returning call7749 (depth = 4)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7751 == NULL) {
    strlit7751 = alloc_String("""\x0a""");
    gc_root(strlit7751);
  }
// compiled string node returning strlit7751 (depth = 6)
  int op_slot_right_7750 = gc_frame_newslot(strlit7751);
// starting to compile call node (depth = 6)
  int callframe7753 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7754 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe7753);
// compiled call node returning call7754 (depth = 6)
  int op_slot_left_7750 = gc_frame_newslot(call7754);
  params[0] = strlit7751;
  partcv[0] = 1;
  Object opresult7755 = callmethod(call7754, "++", 1, partcv, params);
// compiled op node returning opresult7755 (depth = 5)
  *var_s = opresult7755;
  if (opresult7755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7757 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7759 = alloc_Float64(1);
// compiled num node returning num7759 (depth = 8)
  int op_slot_right_7758 = gc_frame_newslot(num7759);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7758 = gc_frame_newslot(*var_depth);
  params[0] = num7759;
  partcv[0] = 1;
  Object sum7761 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7761 (depth = 7)
  gc_frame_newslot(sum7761);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7762 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7763 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7762);
// compiled call node returning call7763 (depth = 8)
// compiled member node returning call7763 (depth = 7)
  params[0] = sum7761;
  partcv[0] = 1;
  Object call7764 = callmethod(call7763, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7757);
// compiled call node returning call7764 (depth = 6)
  int op_slot_right_7756 = gc_frame_newslot(call7764);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7766 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7766 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7768 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7768 (depth = 6)
  int op_slot_left_7756 = gc_frame_newslot(opresult7768);
  params[0] = call7764;
  partcv[0] = 1;
  Object opresult7769 = callmethod(opresult7768, "++", 1, partcv, params);
// compiled op node returning opresult7769 (depth = 5)
  *var_s = opresult7769;
  if (opresult7769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit7772 == NULL) {
    strlit7772 = alloc_String("""\x0a""");
    gc_root(strlit7772);
  }
// compiled string node returning strlit7772 (depth = 6)
  int op_slot_right_7771 = gc_frame_newslot(strlit7772);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_7771 = gc_frame_newslot(*var_s);
  params[0] = strlit7772;
  partcv[0] = 1;
  Object opresult7774 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7774 (depth = 5)
  *var_s = opresult7774;
  if (opresult7774 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7777 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7779 = alloc_Float64(1);
// compiled num node returning num7779 (depth = 8)
  int op_slot_right_7778 = gc_frame_newslot(num7779);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7778 = gc_frame_newslot(*var_depth);
  params[0] = num7779;
  partcv[0] = 1;
  Object sum7781 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7781 (depth = 7)
  gc_frame_newslot(sum7781);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7783 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7782);
// compiled call node returning call7783 (depth = 8)
// compiled member node returning call7783 (depth = 7)
  params[0] = sum7781;
  partcv[0] = 1;
  Object call7784 = callmethod(call7783, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7777);
// compiled call node returning call7784 (depth = 6)
  int op_slot_right_7776 = gc_frame_newslot(call7784);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_7786 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7786 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7788 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7788 (depth = 6)
  int op_slot_left_7776 = gc_frame_newslot(opresult7788);
  params[0] = call7784;
  partcv[0] = 1;
  Object opresult7789 = callmethod(opresult7788, "++", 1, partcv, params);
// compiled op node returning opresult7789 (depth = 5)
  *var_s = opresult7789;
  if (opresult7789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply7803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit7805 == NULL) {
    strlit7805 = alloc_String("    ");
    gc_root(strlit7805);
  }
// compiled string node returning strlit7805 (depth = 8)
  int op_slot_right_7804 = gc_frame_newslot(strlit7805);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_7804 = gc_frame_newslot(*var_spc);
  params[0] = strlit7805;
  partcv[0] = 1;
  Object opresult7807 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult7807 (depth = 7)
  *var_spc = opresult7807;
  if (opresult7807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace7791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7792 == NULL) {
    strlit7792 = alloc_String("");
    gc_root(strlit7792);
  }
// compiled string node returning strlit7792 (depth = 5)
  *var_spc = strlit7792;
  if (strlit7792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7793 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7796 = alloc_Float64(1);
// compiled num node returning num7796 (depth = 7)
  int op_slot_right_7795 = gc_frame_newslot(num7796);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7795 = gc_frame_newslot(*var_depth);
  params[0] = num7796;
  partcv[0] = 1;
  Object diff7798 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff7798 (depth = 6)
  int op_slot_right_7794 = gc_frame_newslot(diff7798);
// starting to compile num node (depth = 6)
  Object num7800 = alloc_Float64(0);
// compiled num node returning num7800 (depth = 6)
  int op_slot_left_7794 = gc_frame_newslot(num7800);
  params[0] = diff7798;
  partcv[0] = 1;
  Object opresult7801 = callmethod(num7800, "..", 1, partcv, params);
// compiled op node returning opresult7801 (depth = 5)
  gc_frame_newslot(opresult7801);
// starting to compile block node (depth = 5)
  Object block7802 = alloc_Block(NULL, NULL, "ast", 1829);
  gc_frame_newslot(block7802);
// method _apply
  block_savedest(block7802);
  Object closure7803 = createclosure(2, "_apply");
  setclosureframe(closure7803, stackframe);
  addtoclosure(closure7803, var_spc);
  addtoclosure(closure7803, selfslot);
  struct UserObject *uo7803 = (struct UserObject*)block7802;
  uo7803->data[0] = (Object)closure7803;
  Method *meth_meth_ast__apply7803 = addmethod2pos(block7802, "_apply", &meth_ast__apply7803, 0);
  int argcv_meth_ast__apply7803[] = {1};
  meth_meth_ast__apply7803->type = alloc_MethodType(1, argcv_meth_ast__apply7803);
  meth_meth_ast__apply7803->definitionModule = modulename;
  meth_meth_ast__apply7803->definitionLine = 1824;
// compiled block node returning block7802 (depth = 5)
  gc_frame_newslot(block7802);
// call case 5: prelude request
  params[0] = opresult7801;
  params[1] = block7802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7810 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7793);
// compiled call node returning call7810 (depth = 4)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7811 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7813 = alloc_Float64(1);
// compiled num node returning num7813 (depth = 7)
  int op_slot_right_7812 = gc_frame_newslot(num7813);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_7812 = gc_frame_newslot(*var_depth);
  params[0] = num7813;
  partcv[0] = 1;
  Object sum7815 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7815 (depth = 6)
  gc_frame_newslot(sum7815);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7817 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7816);
// compiled call node returning call7817 (depth = 7)
// compiled member node returning call7817 (depth = 6)
  params[0] = sum7815;
  partcv[0] = 1;
  Object call7818 = callmethod(call7817, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7811);
// compiled call node returning call7818 (depth = 5)
  *var_s = call7818;
  if (call7818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7820 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num7822 = alloc_Float64(1);
// compiled num node returning num7822 (depth = 8)
  int op_slot_right_7821 = gc_frame_newslot(num7822);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_7821 = gc_frame_newslot(*var_depth);
  params[0] = num7822;
  partcv[0] = 1;
  Object sum7824 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum7824 (depth = 7)
  gc_frame_newslot(sum7824);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7825 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7826 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7825);
// compiled call node returning call7826 (depth = 8)
// compiled member node returning call7826 (depth = 7)
  params[0] = sum7824;
  partcv[0] = 1;
  Object call7827 = callmethod(call7826, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7820);
// compiled call node returning call7827 (depth = 6)
  int op_slot_right_7819 = gc_frame_newslot(call7827);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7830 == NULL) {
    strlit7830 = alloc_String(" := ");
    gc_root(strlit7830);
  }
// compiled string node returning strlit7830 (depth = 7)
  int op_slot_right_7829 = gc_frame_newslot(strlit7830);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_7829 = gc_frame_newslot(*var_s);
  params[0] = strlit7830;
  partcv[0] = 1;
  Object opresult7832 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult7832 (depth = 6)
  int op_slot_left_7819 = gc_frame_newslot(opresult7832);
  params[0] = call7827;
  partcv[0] = 1;
  Object opresult7833 = callmethod(opresult7832, "++", 1, partcv, params);
// compiled op node returning opresult7833 (depth = 5)
  *var_s = opresult7833;
  if (opresult7833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent7835(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7836 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe7837 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7839 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7838);
// compiled call node returning call7839 (depth = 7)
// compiled member node returning call7839 (depth = 6)
  gc_frame_newslot(call7839);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7841 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7840);
// compiled call node returning call7841 (depth = 7)
// compiled member node returning call7841 (depth = 6)
  gc_frame_newslot(call7841);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_bindNode (depth = 6)
  params[0] = call7839;
  params[1] = call7841;
  partcv[0] = 2;
  Object call7842 = callmethod(*var_bindNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7837);
// compiled call node returning call7842 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7843 = callmethod(call7842, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe7836);
// compiled call node returning call7843 (depth = 4)
  gc_frame_end(frame);
  return call7843;
}
Object meth_ast_new7685(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7686 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7686 = alloc_userobj2(13,12, objclass7686);
  gc_frame_newslot(obj7686);
if (objclass7686 == NULL) {
  glfree(obj7686->class->name);
  obj7686->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7686, self, 0);
  addmethodreal(obj7686,"outer", &reader_ast_outer_7687);
  Object oldself7686 = self;
  struct StackFrameObject *oldstackframe7686 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7686);
  gc_frame_newslot((Object)stackframe);
  self = obj7686;
  Object *oldselfslot7686 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7686 = (*(struct UserObject *)self).data[0], lowerouter7686 = thisouter7686;
  if (inheritingObject7686) {
    struct UserObject *inho7686 = (struct UserObject *)inheritingObject7686;
    while (inho7686->super != GraceDefaultObject) inho7686 = (struct UserObject *)inho7686->super;
    inho7686->super = obj7686;
    self = inheritingObject7686;
    *selfslot = self;
    lowerouter7686 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7686;
  }
if (objclass7686 == NULL) {
  Method *reader7688 = addmethodrealflags(obj7686, "kind",&reader_ast_kind_7688, MFLAG_DEF);
  reader7688->definitionModule = modulename;
  reader7688->definitionLine = 1798;
}
adddatum2(obj7686, alloc_Undefined(), 1);
if (objclass7686 == NULL) {
  Method *reader7689 = addmethodrealflags(obj7686, "dest",&reader_ast_dest_7689, 0);
  Method *writer7689 = addmethodrealflags(obj7686, "dest:=",&writer_ast_dest_7689, 0);
  reader7689->definitionModule = modulename;
  writer7689->definitionModule = modulename;
  reader7689->definitionLine = 1799;
  writer7689->definitionLine = 1799;
}
obj7686->flags |= OFLAG_MUTABLE;
adddatum2(obj7686, alloc_Undefined(), 2);
if (objclass7686 == NULL) {
  Method *reader7690 = addmethodrealflags(obj7686, "value",&reader_ast_value_7690, 0);
  Method *writer7690 = addmethodrealflags(obj7686, "value:=",&writer_ast_value_7690, 0);
  reader7690->definitionModule = modulename;
  writer7690->definitionModule = modulename;
  reader7690->definitionLine = 1801;
  writer7690->definitionLine = 1801;
}
obj7686->flags |= OFLAG_MUTABLE;
adddatum2(obj7686, alloc_Undefined(), 3);
// method isBind
  struct UserObject *uo7691 = (struct UserObject*)obj7686;
  uo7691->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7691 = addmethod2pos(obj7686, "isBind", &meth_ast_isBind7691, 4);
  int argcv_meth_ast_isBind7691[] = {0};
  meth_meth_ast_isBind7691->type = alloc_MethodType(1, argcv_meth_ast_isBind7691);
  meth_meth_ast_isBind7691->definitionModule = modulename;
  meth_meth_ast_isBind7691->definitionLine = 1801;
// method asString
  struct UserObject *uo7693 = (struct UserObject*)obj7686;
  uo7693->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7693 = addmethod2pos(obj7686, "asString", &meth_ast_asString7693, 5);
  int argcv_meth_ast_asString7693[] = {0};
  meth_meth_ast_asString7693->type = alloc_MethodType(1, argcv_meth_ast_asString7693);
  meth_meth_ast_asString7693->definitionModule = modulename;
  meth_meth_ast_asString7693->definitionLine = 1802;
// method accept()from
  struct UserObject *uo7704 = (struct UserObject*)obj7686;
  uo7704->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7704 = addmethod2pos(obj7686, "accept()from", &meth_ast_accept_40__41_from7704, 6);
  int argcv_meth_ast_accept_40__41_from7704[] = {1, 1};
  meth_meth_ast_accept_40__41_from7704->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7704);
  meth_meth_ast_accept_40__41_from7704->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7704->definitionLine = 1803;
// method map()parent
  struct UserObject *uo7716 = (struct UserObject*)obj7686;
  uo7716->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7716 = addmethod2pos(obj7686, "map()parent", &meth_ast_map_40__41_parent7716, 7);
  int argcv_meth_ast_map_40__41_parent7716[] = {1, 1};
  meth_meth_ast_map_40__41_parent7716->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7716);
  meth_meth_ast_map_40__41_parent7716->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7716->definitionLine = 1809;
// method pretty
  struct UserObject *uo7734 = (struct UserObject*)obj7686;
  uo7734->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7734 = addmethod2pos(obj7686, "pretty", &meth_ast_pretty7734, 8);
  int argcv_meth_ast_pretty7734[] = {1};
  meth_meth_ast_pretty7734->type = alloc_MethodType(1, argcv_meth_ast_pretty7734);
  meth_meth_ast_pretty7734->definitionModule = modulename;
  meth_meth_ast_pretty7734->definitionLine = 1816;
// method toGrace
  struct UserObject *uo7791 = (struct UserObject*)obj7686;
  uo7791->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7791 = addmethod2pos(obj7686, "toGrace", &meth_ast_toGrace7791, 9);
  int argcv_meth_ast_toGrace7791[] = {1};
  meth_meth_ast_toGrace7791->type = alloc_MethodType(1, argcv_meth_ast_toGrace7791);
meth_meth_ast_toGrace7791->type->types[0] = type_Number;
meth_meth_ast_toGrace7791->type->names[0] = "depth";
  meth_meth_ast_toGrace7791->definitionModule = modulename;
  meth_meth_ast_toGrace7791->definitionLine = 1827;
// method shallowCopyWithParent
  block_savedest(obj7686);
  Object closure7835 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, var_bindNode);
  struct UserObject *uo7835 = (struct UserObject*)obj7686;
  uo7835->data[10] = (Object)closure7835;
  Method *meth_meth_ast_shallowCopyWithParent7835 = addmethod2pos(obj7686, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7835, 10);
  int argcv_meth_ast_shallowCopyWithParent7835[] = {1};
  meth_meth_ast_shallowCopyWithParent7835->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7835);
  meth_meth_ast_shallowCopyWithParent7835->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7835->definitionLine = 1836;
  sourceObject = obj7686;
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7844 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7845 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7844);
// compiled call node returning call7845 (depth = 4)
  struct UserObject *obj7686_uo = (struct UserObject *)obj7686;
  obj7686_uo->super = call7845;
  sourceObject = obj7686;
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7846 == NULL) {
    strlit7846 = alloc_String("bind");
    gc_root(strlit7846);
  }
// compiled string node returning strlit7846 (depth = 4)
  adddatum2(obj7686, strlit7846, 1);
  sourceObject = obj7686;
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dest_39_ (depth = 4)
  adddatum2(obj7686, *var_dest_39_, 2);
  sourceObject = obj7686;
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj7686, *var_val_39_, 3);
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
objclass7686 = obj7686->class;
  objclass7686->definitionModule = modulename;
  objclass7686->definitionLine = 1794;
  (*(struct UserObject *)self).data[0] = lowerouter7686;
  self = oldself7686;
  selfslot = oldselfslot7686;
  stackframe = oldstackframe7686;
  gc_frame_end(frame);
  return obj7686;
}
Object meth_ast_new7685_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7686 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7686 = alloc_userobj2(13,12, objclass7686);
  gc_frame_newslot(obj7686);
if (objclass7686 == NULL) {
  glfree(obj7686->class->name);
  obj7686->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7686, self, 0);
  addmethodreal(obj7686,"outer", &reader_ast_outer_7687);
  Object oldself7686 = self;
  struct StackFrameObject *oldstackframe7686 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7686);
  gc_frame_newslot((Object)stackframe);
  self = obj7686;
  Object *oldselfslot7686 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7686 = (*(struct UserObject *)self).data[0], lowerouter7686 = thisouter7686;
  if (inheritingObject7686) {
    struct UserObject *inho7686 = (struct UserObject *)inheritingObject7686;
    while (inho7686->super != GraceDefaultObject) inho7686 = (struct UserObject *)inho7686->super;
    inho7686->super = obj7686;
    self = inheritingObject7686;
    *selfslot = self;
    lowerouter7686 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7686;
  }
if (objclass7686 == NULL) {
  Method *reader7688 = addmethodrealflags(obj7686, "kind",&reader_ast_kind_7688, MFLAG_DEF);
  reader7688->definitionModule = modulename;
  reader7688->definitionLine = 1798;
}
adddatum2(obj7686, alloc_Undefined(), 1);
if (objclass7686 == NULL) {
  Method *reader7689 = addmethodrealflags(obj7686, "dest",&reader_ast_dest_7689, 0);
  Method *writer7689 = addmethodrealflags(obj7686, "dest:=",&writer_ast_dest_7689, 0);
  reader7689->definitionModule = modulename;
  writer7689->definitionModule = modulename;
  reader7689->definitionLine = 1799;
  writer7689->definitionLine = 1799;
}
obj7686->flags |= OFLAG_MUTABLE;
adddatum2(obj7686, alloc_Undefined(), 2);
if (objclass7686 == NULL) {
  Method *reader7690 = addmethodrealflags(obj7686, "value",&reader_ast_value_7690, 0);
  Method *writer7690 = addmethodrealflags(obj7686, "value:=",&writer_ast_value_7690, 0);
  reader7690->definitionModule = modulename;
  writer7690->definitionModule = modulename;
  reader7690->definitionLine = 1801;
  writer7690->definitionLine = 1801;
}
obj7686->flags |= OFLAG_MUTABLE;
adddatum2(obj7686, alloc_Undefined(), 3);
// method isBind
  struct UserObject *uo7691 = (struct UserObject*)obj7686;
  uo7691->data[4] = emptyclosure;
  Method *meth_meth_ast_isBind7691 = addmethod2pos(obj7686, "isBind", &meth_ast_isBind7691, 4);
  int argcv_meth_ast_isBind7691[] = {0};
  meth_meth_ast_isBind7691->type = alloc_MethodType(1, argcv_meth_ast_isBind7691);
  meth_meth_ast_isBind7691->definitionModule = modulename;
  meth_meth_ast_isBind7691->definitionLine = 1801;
// method asString
  struct UserObject *uo7693 = (struct UserObject*)obj7686;
  uo7693->data[5] = emptyclosure;
  Method *meth_meth_ast_asString7693 = addmethod2pos(obj7686, "asString", &meth_ast_asString7693, 5);
  int argcv_meth_ast_asString7693[] = {0};
  meth_meth_ast_asString7693->type = alloc_MethodType(1, argcv_meth_ast_asString7693);
  meth_meth_ast_asString7693->definitionModule = modulename;
  meth_meth_ast_asString7693->definitionLine = 1802;
// method accept()from
  struct UserObject *uo7704 = (struct UserObject*)obj7686;
  uo7704->data[6] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7704 = addmethod2pos(obj7686, "accept()from", &meth_ast_accept_40__41_from7704, 6);
  int argcv_meth_ast_accept_40__41_from7704[] = {1, 1};
  meth_meth_ast_accept_40__41_from7704->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7704);
  meth_meth_ast_accept_40__41_from7704->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7704->definitionLine = 1803;
// method map()parent
  struct UserObject *uo7716 = (struct UserObject*)obj7686;
  uo7716->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7716 = addmethod2pos(obj7686, "map()parent", &meth_ast_map_40__41_parent7716, 7);
  int argcv_meth_ast_map_40__41_parent7716[] = {1, 1};
  meth_meth_ast_map_40__41_parent7716->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7716);
  meth_meth_ast_map_40__41_parent7716->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7716->definitionLine = 1809;
// method pretty
  struct UserObject *uo7734 = (struct UserObject*)obj7686;
  uo7734->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty7734 = addmethod2pos(obj7686, "pretty", &meth_ast_pretty7734, 8);
  int argcv_meth_ast_pretty7734[] = {1};
  meth_meth_ast_pretty7734->type = alloc_MethodType(1, argcv_meth_ast_pretty7734);
  meth_meth_ast_pretty7734->definitionModule = modulename;
  meth_meth_ast_pretty7734->definitionLine = 1816;
// method toGrace
  struct UserObject *uo7791 = (struct UserObject*)obj7686;
  uo7791->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace7791 = addmethod2pos(obj7686, "toGrace", &meth_ast_toGrace7791, 9);
  int argcv_meth_ast_toGrace7791[] = {1};
  meth_meth_ast_toGrace7791->type = alloc_MethodType(1, argcv_meth_ast_toGrace7791);
meth_meth_ast_toGrace7791->type->types[0] = type_Number;
meth_meth_ast_toGrace7791->type->names[0] = "depth";
  meth_meth_ast_toGrace7791->definitionModule = modulename;
  meth_meth_ast_toGrace7791->definitionLine = 1827;
// method shallowCopyWithParent
  block_savedest(obj7686);
  Object closure7835 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, var_bindNode);
  struct UserObject *uo7835 = (struct UserObject*)obj7686;
  uo7835->data[10] = (Object)closure7835;
  Method *meth_meth_ast_shallowCopyWithParent7835 = addmethod2pos(obj7686, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent7835, 10);
  int argcv_meth_ast_shallowCopyWithParent7835[] = {1};
  meth_meth_ast_shallowCopyWithParent7835->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent7835);
  meth_meth_ast_shallowCopyWithParent7835->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent7835->definitionLine = 1836;
  sourceObject = obj7686;
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7844 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7845 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7844);
// compiled call node returning call7845 (depth = 4)
  struct UserObject *obj7686_uo = (struct UserObject *)obj7686;
  obj7686_uo->super = call7845;
  sourceObject = obj7686;
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit7846 == NULL) {
    strlit7846 = alloc_String("bind");
    gc_root(strlit7846);
  }
// compiled string node returning strlit7846 (depth = 4)
  adddatum2(obj7686, strlit7846, 1);
  sourceObject = obj7686;
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dest_39_ (depth = 4)
  adddatum2(obj7686, *var_dest_39_, 2);
  sourceObject = obj7686;
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj7686, *var_val_39_, 3);
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
  sourceObject = obj7686;
objclass7686 = obj7686->class;
  objclass7686->definitionModule = modulename;
  objclass7686->definitionLine = 1794;
  (*(struct UserObject *)self).data[0] = lowerouter7686;
  self = oldself7686;
  selfslot = oldselfslot7686;
  stackframe = oldstackframe7686;
  gc_frame_end(frame);
  return obj7686;
}
Object meth_ast_defDecNode7848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for defDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_isPublic7862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_res = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "res");
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7865 = alloc_Float64(0);
// compiled num node returning num7865 (depth = 6)
  int op_slot_right_7864 = gc_frame_newslot(num7865);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7867 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7869 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7868);
// compiled call node returning call7869 (depth = 9)
// compiled member node returning call7869 (depth = 8)
  partcv[0] = 0;
  Object call7870 = callmethod(call7869, "size",
    1, partcv, params);
  gc_frame_end(callframe7867);
// compiled call node returning call7870 (depth = 7)
// compiled member node returning call7870 (depth = 6)
  int op_slot_left_7864 = gc_frame_newslot(call7870);
  params[0] = num7865;
  partcv[0] = 1;
  Object opresult7871 = callmethod(call7870, "==", 1, partcv, params);
// compiled op node returning opresult7871 (depth = 5)
  Object if7863 = done;
  if (istrue(opresult7871)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7872 = alloc_Boolean(0);
// compiled identifier node returning bool7872 (depth = 6)
  return bool7872;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if7863 = undefined;
  } else {
  }
// compiled if node returning if7863 (depth = 4)
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7874 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit7875 == NULL) {
    strlit7875 = alloc_String("public");
    gc_root(strlit7875);
  }
// compiled string node returning strlit7875 (depth = 6)
  gc_frame_newslot(strlit7875);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7876 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7877 = gc_frame_new();
// call case 3: self.outer request
  Object call7878 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7877);
// compiled call node returning call7878 (depth = 9)
// compiled member node returning call7878 (depth = 8)
  partcv[0] = 0;
  Object call7879 = callmethodflags(call7878, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7876);
// compiled call node returning call7879 (depth = 7)
// compiled member node returning call7879 (depth = 6)
  params[0] = self;
  params[1] = strlit7875;
  partcv[0] = 2;
  Object call7880 = callmethodflags(call7879, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7874);
// compiled call node returning call7880 (depth = 5)
  Object if7873 = done;
  if (istrue(call7880)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7881 = alloc_Boolean(1);
// compiled identifier node returning bool7881 (depth = 6)
  return bool7881;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if7873 = undefined;
  } else {
  }
// compiled if node returning if7873 (depth = 4)
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7882 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit7883 == NULL) {
    strlit7883 = alloc_String("readable");
    gc_root(strlit7883);
  }
// compiled string node returning strlit7883 (depth = 6)
  gc_frame_newslot(strlit7883);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7884 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7885 = gc_frame_new();
// call case 3: self.outer request
  Object call7886 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7885);
// compiled call node returning call7886 (depth = 9)
// compiled member node returning call7886 (depth = 8)
  partcv[0] = 0;
  Object call7887 = callmethodflags(call7886, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7884);
// compiled call node returning call7887 (depth = 7)
// compiled member node returning call7887 (depth = 6)
  params[0] = self;
  params[1] = strlit7883;
  partcv[0] = 2;
  Object call7888 = callmethodflags(call7887, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7882);
// compiled call node returning call7888 (depth = 5)
  *var_res = call7888;
  if (call7888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7891 == NULL) {
    strlit7891 = alloc_String("bindings");
    gc_root(strlit7891);
  }
// compiled string node returning strlit7891 (depth = 6)
  int op_slot_right_7890 = gc_frame_newslot(strlit7891);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7893 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7894 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7893);
// compiled call node returning call7894 (depth = 7)
// compiled member node returning call7894 (depth = 6)
  int op_slot_left_7890 = gc_frame_newslot(call7894);
  params[0] = strlit7891;
  partcv[0] = 1;
  Object opresult7895 = callmethod(call7894, "==", 1, partcv, params);
// compiled op node returning opresult7895 (depth = 5)
  Object if7889 = done;
  if (istrue(opresult7895)) {
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7896 == NULL) {
    strlit7896 = alloc_String("bindings is public");
    gc_root(strlit7896);
  }
// compiled string node returning strlit7896 (depth = 6)
  params[0] = strlit7896;
  Object call7897 = gracelib_print(NULL, 1,  params);
// compiled call node returning call7897 (depth = 5)
    gc_frame_newslot(call7897);
    if7889 = call7897;
  } else {
  }
// compiled if node returning if7889 (depth = 4)
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_res (depth = 4)
  gc_frame_end(frame);
  return *var_res;
}
Object meth_ast_isWritable7898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7899 = alloc_Boolean(0);
// compiled identifier node returning bool7899 (depth = 4)
  gc_frame_end(frame);
  return bool7899;
}
Object meth_ast_isReadable7900(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7901 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7902 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7901);
// compiled call node returning call7902 (depth = 5)
// compiled member node returning call7902 (depth = 4)
  gc_frame_end(frame);
  return call7902;
}
Object meth_ast_isFieldDec7903(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7906 == NULL) {
    strlit7906 = alloc_String("object");
    gc_root(strlit7906);
  }
// compiled string node returning strlit7906 (depth = 6)
  int op_slot_right_7905 = gc_frame_newslot(strlit7906);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7908 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7909 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7910 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7909);
// compiled call node returning call7910 (depth = 9)
// compiled member node returning call7910 (depth = 8)
  partcv[0] = 0;
  Object call7911 = callmethod(call7910, "kind",
    1, partcv, params);
  gc_frame_end(callframe7908);
// compiled call node returning call7911 (depth = 7)
// compiled member node returning call7911 (depth = 6)
  int op_slot_left_7905 = gc_frame_newslot(call7911);
  params[0] = strlit7906;
  partcv[0] = 1;
  Object opresult7912 = callmethod(call7911, "==", 1, partcv, params);
// compiled op node returning opresult7912 (depth = 5)
  Object if7904 = done;
  if (istrue(opresult7912)) {
// starting to compile identifier node (depth = 5)
  Object bool7913 = alloc_Boolean(1);
// compiled identifier node returning bool7913 (depth = 5)
    gc_frame_newslot(bool7913);
    if7904 = bool7913;
  } else {
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7916 == NULL) {
    strlit7916 = alloc_String("class");
    gc_root(strlit7916);
  }
// compiled string node returning strlit7916 (depth = 7)
  int op_slot_right_7915 = gc_frame_newslot(strlit7916);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7918 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7920 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7919);
// compiled call node returning call7920 (depth = 10)
// compiled member node returning call7920 (depth = 9)
  partcv[0] = 0;
  Object call7921 = callmethod(call7920, "kind",
    1, partcv, params);
  gc_frame_end(callframe7918);
// compiled call node returning call7921 (depth = 8)
// compiled member node returning call7921 (depth = 7)
  int op_slot_left_7915 = gc_frame_newslot(call7921);
  params[0] = strlit7916;
  partcv[0] = 1;
  Object opresult7922 = callmethod(call7921, "==", 1, partcv, params);
// compiled op node returning opresult7922 (depth = 6)
  Object if7914 = done;
  if (istrue(opresult7922)) {
// starting to compile identifier node (depth = 6)
  Object bool7923 = alloc_Boolean(1);
// compiled identifier node returning bool7923 (depth = 6)
    gc_frame_newslot(bool7923);
    if7914 = bool7923;
  } else {
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool7924 = alloc_Boolean(0);
// compiled identifier node returning bool7924 (depth = 6)
    gc_frame_newslot(bool7924);
    if7914 = bool7924;
  }
// compiled if node returning if7914 (depth = 5)
    gc_frame_newslot(if7914);
    if7904 = if7914;
  }
// compiled if node returning if7904 (depth = 4)
  gc_frame_end(frame);
  return if7904;
}
Object meth_ast_definesScope7925(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "definesScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for definesScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for definesScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7926 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7927 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7928 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7927);
// compiled call node returning call7928 (depth = 7)
// compiled member node returning call7928 (depth = 6)
  partcv[0] = 0;
  Object call7929 = callmethod(call7928, "definesObject",
    1, partcv, params);
  gc_frame_end(callframe7926);
// compiled call node returning call7929 (depth = 5)
// compiled member node returning call7929 (depth = 4)
  gc_frame_end(frame);
  return call7929;
}
Object meth_ast_objectScope7930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "objectScope");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for objectScope (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for objectScope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7931 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7932 = callmethodflags(self, "scope", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7931);
// compiled call node returning call7932 (depth = 5)
// compiled member node returning call7932 (depth = 4)
  gc_frame_end(frame);
  return call7932;
}
Object meth_ast_usesAsType7933(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7935 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7936 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7935);
// compiled call node returning call7936 (depth = 6)
// compiled member node returning call7936 (depth = 5)
  int op_slot_right_7934 = gc_frame_newslot(call7936);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_7934 = gc_frame_newslot(*var_aNode);
  params[0] = call7936;
  partcv[0] = 1;
  Object opresult7938 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult7938 (depth = 4)
  gc_frame_end(frame);
  return opresult7938;
}
Object meth_ast_accept_40__41_from7939(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1878
  setline(1878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7941 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7942 = callmethod(*var_visitor, "visitDefDec()up",
    2, partcv, params);
  gc_frame_end(callframe7941);
// compiled call node returning call7942 (depth = 5)
  Object if7940 = done;
  if (istrue(call7942)) {
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7943 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7945 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7944);
// compiled call node returning call7945 (depth = 7)
// compiled member node returning call7945 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7946 = callmethod(call7945, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7943);
// compiled call node returning call7946 (depth = 5)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7949 = alloc_Boolean(0);
// compiled identifier node returning bool7949 (depth = 7)
  int op_slot_right_7948 = gc_frame_newslot(bool7949);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7951 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7952 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7951);
// compiled call node returning call7952 (depth = 8)
// compiled member node returning call7952 (depth = 7)
  int op_slot_left_7948 = gc_frame_newslot(call7952);
  params[0] = bool7949;
  partcv[0] = 1;
  Object opresult7953 = callmethod(call7952, "!=", 1, partcv, params);
// compiled op node returning opresult7953 (depth = 6)
  Object if7947 = done;
  if (istrue(opresult7953)) {
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7954 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7955 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7956 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7955);
// compiled call node returning call7956 (depth = 8)
// compiled member node returning call7956 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7957 = callmethod(call7956, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7954);
// compiled call node returning call7957 (depth = 6)
    gc_frame_newslot(call7957);
    if7947 = call7957;
  } else {
  }
// compiled if node returning if7947 (depth = 5)
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7960 = alloc_Boolean(0);
// compiled identifier node returning bool7960 (depth = 7)
  int op_slot_right_7959 = gc_frame_newslot(bool7960);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7962 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7963 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7962);
// compiled call node returning call7963 (depth = 8)
// compiled member node returning call7963 (depth = 7)
  int op_slot_left_7959 = gc_frame_newslot(call7963);
  params[0] = bool7960;
  partcv[0] = 1;
  Object opresult7964 = callmethod(call7963, "!=", 1, partcv, params);
// compiled op node returning opresult7964 (depth = 6)
  Object if7958 = done;
  if (istrue(opresult7964)) {
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7965 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7966 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7967 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7966);
// compiled call node returning call7967 (depth = 8)
// compiled member node returning call7967 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7968 = callmethod(call7967, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe7965);
// compiled call node returning call7968 (depth = 6)
    gc_frame_newslot(call7968);
    if7958 = call7968;
  } else {
  }
// compiled if node returning if7958 (depth = 5)
    gc_frame_newslot(if7958);
    if7940 = if7958;
  } else {
  }
// compiled if node returning if7940 (depth = 4)
  gc_frame_end(frame);
  return if7940;
}
Object meth_ast_map_40__41_parent7969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7970 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call7971 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7970);
// compiled call node returning call7971 (depth = 5)
  *var_n = call7971;
  if (call7971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7972 = gc_frame_new();
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7973 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7974 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7975 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7974);
// compiled call node returning call7975 (depth = 8)
// compiled member node returning call7975 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7976 = callmethod(call7975, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7973);
// compiled call node returning call7976 (depth = 6)
  gc_frame_newslot(call7976);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7976;
  partcv[0] = 1;
  Object call7977 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe7972);
// compiled call node returning call7977 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7978 = gc_frame_new();
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7979 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7980 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7981 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7980);
// compiled call node returning call7981 (depth = 8)
// compiled member node returning call7981 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7982 = callmethod(call7981, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe7979);
// compiled call node returning call7982 (depth = 6)
  gc_frame_newslot(call7982);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7982;
  partcv[0] = 1;
  Object call7983 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe7978);
// compiled call node returning call7983 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7984 = gc_frame_new();
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7985 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7986 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7987 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7986);
// compiled call node returning call7987 (depth = 8)
// compiled member node returning call7987 (depth = 7)
  gc_frame_newslot(call7987);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7988 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7989 = gc_frame_new();
// call case 3: self.outer request
  Object call7990 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7989);
// compiled call node returning call7990 (depth = 10)
// compiled member node returning call7990 (depth = 9)
  partcv[0] = 0;
  Object call7991 = callmethodflags(call7990, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7988);
// compiled call node returning call7991 (depth = 8)
// compiled member node returning call7991 (depth = 7)
  params[0] = call7987;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call7992 = callmethodflags(call7991, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7985);
// compiled call node returning call7992 (depth = 6)
  gc_frame_newslot(call7992);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call7992;
  partcv[0] = 1;
  Object call7993 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe7984);
// compiled call node returning call7993 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7994 = gc_frame_new();
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7995 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7996 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7997 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7996);
// compiled call node returning call7997 (depth = 8)
// compiled member node returning call7997 (depth = 7)
  gc_frame_newslot(call7997);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7998 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7999 = gc_frame_new();
// call case 3: self.outer request
  Object call8000 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7999);
// compiled call node returning call8000 (depth = 10)
// compiled member node returning call8000 (depth = 9)
  partcv[0] = 0;
  Object call8001 = callmethodflags(call8000, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7998);
// compiled call node returning call8001 (depth = 8)
// compiled member node returning call8001 (depth = 7)
  params[0] = call7997;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8002 = callmethodflags(call8001, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7995);
// compiled call node returning call8002 (depth = 6)
  gc_frame_newslot(call8002);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8002;
  partcv[0] = 1;
  Object call8003 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe7994);
// compiled call node returning call8003 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8004 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8005 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8004);
// compiled call node returning call8005 (depth = 5)
  *var_n = call8005;
  if (call8005 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply8015(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit8017 == NULL) {
    strlit8017 = alloc_String("  ");
    gc_root(strlit8017);
  }
// compiled string node returning strlit8017 (depth = 8)
  int op_slot_right_8016 = gc_frame_newslot(strlit8017);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8016 = gc_frame_newslot(*var_spc);
  params[0] = strlit8017;
  partcv[0] = 1;
  Object opresult8019 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8019 (depth = 7)
  *var_spc = opresult8019;
  if (opresult8019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8008 == NULL) {
    strlit8008 = alloc_String("");
    gc_root(strlit8008);
  }
// compiled string node returning strlit8008 (depth = 5)
  *var_spc = strlit8008;
  if (strlit8008 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8009 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_8010 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num8012 = alloc_Float64(0);
// compiled num node returning num8012 (depth = 6)
  int op_slot_left_8010 = gc_frame_newslot(num8012);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8013 = callmethod(num8012, "..", 1, partcv, params);
// compiled op node returning opresult8013 (depth = 5)
  gc_frame_newslot(opresult8013);
// starting to compile block node (depth = 5)
  Object block8014 = alloc_Block(NULL, NULL, "ast", 1899);
  gc_frame_newslot(block8014);
// method _apply
  block_savedest(block8014);
  Object closure8015 = createclosure(2, "_apply");
  setclosureframe(closure8015, stackframe);
  addtoclosure(closure8015, var_spc);
  addtoclosure(closure8015, selfslot);
  struct UserObject *uo8015 = (struct UserObject*)block8014;
  uo8015->data[0] = (Object)closure8015;
  Method *meth_meth_ast__apply8015 = addmethod2pos(block8014, "_apply", &meth_ast__apply8015, 0);
  int argcv_meth_ast__apply8015[] = {1};
  meth_meth_ast__apply8015->type = alloc_MethodType(1, argcv_meth_ast__apply8015);
  meth_meth_ast__apply8015->definitionModule = modulename;
  meth_meth_ast__apply8015->definitionLine = 1893;
// compiled block node returning block8014 (depth = 5)
  gc_frame_newslot(block8014);
// call case 5: prelude request
  params[0] = opresult8013;
  params[1] = block8014;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8022 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8009);
// compiled call node returning call8022 (depth = 4)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8024 == NULL) {
    strlit8024 = alloc_String("""\x0a""");
    gc_root(strlit8024);
  }
// compiled string node returning strlit8024 (depth = 6)
  int op_slot_right_8023 = gc_frame_newslot(strlit8024);
// starting to compile call node (depth = 6)
  int callframe8026 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8027 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8026);
// compiled call node returning call8027 (depth = 6)
  int op_slot_left_8023 = gc_frame_newslot(call8027);
  params[0] = strlit8024;
  partcv[0] = 1;
  Object opresult8028 = callmethod(call8027, "++", 1, partcv, params);
// compiled op node returning opresult8028 (depth = 5)
  *var_s = opresult8028;
  if (opresult8028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8030 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8032 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8031);
// compiled call node returning call8032 (depth = 8)
// compiled member node returning call8032 (depth = 7)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8033 = callmethod(call8032, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8030);
// compiled call node returning call8033 (depth = 6)
  int op_slot_right_8029 = gc_frame_newslot(call8033);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8035 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8035 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8037 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8037 (depth = 6)
  int op_slot_left_8029 = gc_frame_newslot(opresult8037);
  params[0] = call8033;
  partcv[0] = 1;
  Object opresult8038 = callmethod(opresult8037, "++", 1, partcv, params);
// compiled op node returning opresult8038 (depth = 5)
  *var_s = opresult8038;
  if (opresult8038 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8042 = alloc_Boolean(0);
// compiled identifier node returning bool8042 (depth = 6)
  int op_slot_right_8041 = gc_frame_newslot(bool8042);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8044 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8045 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8044);
// compiled call node returning call8045 (depth = 7)
// compiled member node returning call8045 (depth = 6)
  int op_slot_left_8041 = gc_frame_newslot(call8045);
  params[0] = bool8042;
  partcv[0] = 1;
  Object opresult8046 = callmethod(call8045, "!=", 1, partcv, params);
// compiled op node returning opresult8046 (depth = 5)
  Object if8040 = done;
  if (istrue(opresult8046)) {
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8048 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8050 = alloc_Float64(2);
// compiled num node returning num8050 (depth = 9)
  int op_slot_right_8049 = gc_frame_newslot(num8050);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_8049 = gc_frame_newslot(*var_depth);
  params[0] = num8050;
  partcv[0] = 1;
  Object sum8052 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8052 (depth = 8)
  gc_frame_newslot(sum8052);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8054 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8053);
// compiled call node returning call8054 (depth = 9)
// compiled member node returning call8054 (depth = 8)
  params[0] = sum8052;
  partcv[0] = 1;
  Object call8055 = callmethod(call8054, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8048);
// compiled call node returning call8055 (depth = 7)
  int op_slot_right_8047 = gc_frame_newslot(call8055);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8058 == NULL) {
    strlit8058 = alloc_String("Type: ");
    gc_root(strlit8058);
  }
// compiled string node returning strlit8058 (depth = 8)
  int op_slot_right_8057 = gc_frame_newslot(strlit8058);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_8060 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8063 == NULL) {
    strlit8063 = alloc_String("""\x0a""");
    gc_root(strlit8063);
  }
// compiled string node returning strlit8063 (depth = 10)
  int op_slot_right_8062 = gc_frame_newslot(strlit8063);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_8062 = gc_frame_newslot(*var_s);
  params[0] = strlit8063;
  partcv[0] = 1;
  Object opresult8065 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8065 (depth = 9)
  int op_slot_left_8060 = gc_frame_newslot(opresult8065);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8066 = callmethod(opresult8065, "++", 1, partcv, params);
// compiled op node returning opresult8066 (depth = 8)
  int op_slot_left_8057 = gc_frame_newslot(opresult8066);
  params[0] = strlit8058;
  partcv[0] = 1;
  Object opresult8067 = callmethod(opresult8066, "++", 1, partcv, params);
// compiled op node returning opresult8067 (depth = 7)
  int op_slot_left_8047 = gc_frame_newslot(opresult8067);
  params[0] = call8055;
  partcv[0] = 1;
  Object opresult8068 = callmethod(opresult8067, "++", 1, partcv, params);
// compiled op node returning opresult8068 (depth = 6)
  *var_s = opresult8068;
  if (opresult8068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8040 = done;
  } else {
  }
// compiled if node returning if8040 (depth = 4)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8072 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8073 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8072);
// compiled call node returning call8073 (depth = 7)
// compiled member node returning call8073 (depth = 6)
  int op_slot_right_8071 = gc_frame_newslot(call8073);
// starting to compile identifier node (depth = 6)
  Object bool8075 = alloc_Boolean(0);
// compiled identifier node returning bool8075 (depth = 6)
  int op_slot_left_8071 = gc_frame_newslot(bool8075);
  params[0] = call8073;
  partcv[0] = 1;
  Object opresult8076 = callmethod(bool8075, "!=", 1, partcv, params);
// compiled op node returning opresult8076 (depth = 5)
  Object if8070 = done;
  if (istrue(opresult8076)) {
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8078 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8080 = alloc_Float64(2);
// compiled num node returning num8080 (depth = 9)
  int op_slot_right_8079 = gc_frame_newslot(num8080);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_8079 = gc_frame_newslot(*var_depth);
  params[0] = num8080;
  partcv[0] = 1;
  Object sum8082 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8082 (depth = 8)
  gc_frame_newslot(sum8082);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8083 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8084 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8083);
// compiled call node returning call8084 (depth = 9)
// compiled member node returning call8084 (depth = 8)
  params[0] = sum8082;
  partcv[0] = 1;
  Object call8085 = callmethod(call8084, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8078);
// compiled call node returning call8085 (depth = 7)
  int op_slot_right_8077 = gc_frame_newslot(call8085);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8088 == NULL) {
    strlit8088 = alloc_String("Value: ");
    gc_root(strlit8088);
  }
// compiled string node returning strlit8088 (depth = 8)
  int op_slot_right_8087 = gc_frame_newslot(strlit8088);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_spc (depth = 9)
  int op_slot_right_8090 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8093 == NULL) {
    strlit8093 = alloc_String("""\x0a""");
    gc_root(strlit8093);
  }
// compiled string node returning strlit8093 (depth = 10)
  int op_slot_right_8092 = gc_frame_newslot(strlit8093);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_8092 = gc_frame_newslot(*var_s);
  params[0] = strlit8093;
  partcv[0] = 1;
  Object opresult8095 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8095 (depth = 9)
  int op_slot_left_8090 = gc_frame_newslot(opresult8095);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8096 = callmethod(opresult8095, "++", 1, partcv, params);
// compiled op node returning opresult8096 (depth = 8)
  int op_slot_left_8087 = gc_frame_newslot(opresult8096);
  params[0] = strlit8088;
  partcv[0] = 1;
  Object opresult8097 = callmethod(opresult8096, "++", 1, partcv, params);
// compiled op node returning opresult8097 (depth = 7)
  int op_slot_left_8077 = gc_frame_newslot(opresult8097);
  params[0] = call8085;
  partcv[0] = 1;
  Object opresult8098 = callmethod(opresult8097, "++", 1, partcv, params);
// compiled op node returning opresult8098 (depth = 6)
  *var_s = opresult8098;
  if (opresult8098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8070 = done;
  } else {
  }
// compiled if node returning if8070 (depth = 4)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8112(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit8114 == NULL) {
    strlit8114 = alloc_String("    ");
    gc_root(strlit8114);
  }
// compiled string node returning strlit8114 (depth = 8)
  int op_slot_right_8113 = gc_frame_newslot(strlit8114);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8113 = gc_frame_newslot(*var_spc);
  params[0] = strlit8114;
  partcv[0] = 1;
  Object opresult8116 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8116 (depth = 7)
  *var_spc = opresult8116;
  if (opresult8116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8173(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8175 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num8176 = alloc_Float64(0);
// compiled num node returning num8176 (depth = 11)
  gc_frame_newslot(num8176);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_b (depth = 11)
  params[0] = num8176;
  partcv[0] = 1;
  Object call8177 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8175);
// compiled call node returning call8177 (depth = 10)
  int op_slot_right_8174 = gc_frame_newslot(call8177);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit8181 == NULL) {
    strlit8181 = alloc_String("");
    gc_root(strlit8181);
  }
// compiled string node returning strlit8181 (depth = 12)
  int op_slot_right_8180 = gc_frame_newslot(strlit8181);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_8180 = gc_frame_newslot(*var_a);
  params[0] = strlit8181;
  partcv[0] = 1;
  Object opresult8183 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult8183 (depth = 11)
  Object if8179 = done;
struct StackFrameObject *iftmpstackframe8179 = stackframe;
  if (istrue(opresult8183)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8179);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit8185 == NULL) {
    strlit8185 = alloc_String(", ");
    gc_root(strlit8185);
  }
// compiled string node returning strlit8185 (depth = 12)
  int op_slot_right_8184 = gc_frame_newslot(strlit8185);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_8184 = gc_frame_newslot(*var_a);
  params[0] = strlit8185;
  partcv[0] = 1;
  Object opresult8187 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8187 (depth = 11)
    gc_frame_newslot(opresult8187);
    if8179 = opresult8187;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8179);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 11)
  if (strlit8188 == NULL) {
    strlit8188 = alloc_String("");
    gc_root(strlit8188);
  }
// compiled string node returning strlit8188 (depth = 11)
    gc_frame_newslot(strlit8188);
    if8179 = strlit8188;
  }
stackframe = iftmpstackframe8179;
// compiled if node returning if8179 (depth = 10)
  int op_slot_left_8174 = gc_frame_newslot(if8179);
  params[0] = call8177;
  partcv[0] = 1;
  Object opresult8189 = callmethod(if8179, "++", 1, partcv, params);
// compiled op node returning opresult8189 (depth = 9)
  gc_frame_end(frame);
  return opresult8189;
}
Object meth_ast_toGrace8100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8101 == NULL) {
    strlit8101 = alloc_String("");
    gc_root(strlit8101);
  }
// compiled string node returning strlit8101 (depth = 5)
  *var_spc = strlit8101;
  if (strlit8101 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8102 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8105 = alloc_Float64(1);
// compiled num node returning num8105 (depth = 7)
  int op_slot_right_8104 = gc_frame_newslot(num8105);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8104 = gc_frame_newslot(*var_depth);
  params[0] = num8105;
  partcv[0] = 1;
  Object diff8107 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff8107 (depth = 6)
  int op_slot_right_8103 = gc_frame_newslot(diff8107);
// starting to compile num node (depth = 6)
  Object num8109 = alloc_Float64(0);
// compiled num node returning num8109 (depth = 6)
  int op_slot_left_8103 = gc_frame_newslot(num8109);
  params[0] = diff8107;
  partcv[0] = 1;
  Object opresult8110 = callmethod(num8109, "..", 1, partcv, params);
// compiled op node returning opresult8110 (depth = 5)
  gc_frame_newslot(opresult8110);
// starting to compile block node (depth = 5)
  Object block8111 = alloc_Block(NULL, NULL, "ast", 1920);
  gc_frame_newslot(block8111);
// method _apply
  block_savedest(block8111);
  Object closure8112 = createclosure(2, "_apply");
  setclosureframe(closure8112, stackframe);
  addtoclosure(closure8112, var_spc);
  addtoclosure(closure8112, selfslot);
  struct UserObject *uo8112 = (struct UserObject*)block8111;
  uo8112->data[0] = (Object)closure8112;
  Method *meth_meth_ast__apply8112 = addmethod2pos(block8111, "_apply", &meth_ast__apply8112, 0);
  int argcv_meth_ast__apply8112[] = {1};
  meth_meth_ast__apply8112->type = alloc_MethodType(1, argcv_meth_ast__apply8112);
  meth_meth_ast__apply8112->definitionModule = modulename;
  meth_meth_ast__apply8112->definitionLine = 1908;
// compiled block node returning block8111 (depth = 5)
  gc_frame_newslot(block8111);
// call case 5: prelude request
  params[0] = opresult8110;
  params[1] = block8111;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8119 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8102);
// compiled call node returning call8119 (depth = 4)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8121 == NULL) {
    strlit8121 = alloc_String("");
    gc_root(strlit8121);
  }
// compiled string node returning strlit8121 (depth = 6)
  int op_slot_right_8120 = gc_frame_newslot(strlit8121);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8124 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8125 = alloc_Float64(0);
// compiled num node returning num8125 (depth = 8)
  gc_frame_newslot(num8125);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8126 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8127 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8126);
// compiled call node returning call8127 (depth = 9)
// compiled member node returning call8127 (depth = 8)
  params[0] = num8125;
  partcv[0] = 1;
  Object call8128 = callmethod(call8127, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8124);
// compiled call node returning call8128 (depth = 7)
  int op_slot_right_8123 = gc_frame_newslot(call8128);
// starting to compile string node (depth = 7)
  if (strlit8130 == NULL) {
    strlit8130 = alloc_String("def ");
    gc_root(strlit8130);
  }
// compiled string node returning strlit8130 (depth = 7)
  int op_slot_left_8123 = gc_frame_newslot(strlit8130);
  params[0] = call8128;
  partcv[0] = 1;
  Object opresult8131 = callmethod(strlit8130, "++", 1, partcv, params);
// compiled op node returning opresult8131 (depth = 6)
  int op_slot_left_8120 = gc_frame_newslot(opresult8131);
  params[0] = strlit8121;
  partcv[0] = 1;
  Object opresult8132 = callmethod(opresult8131, "++", 1, partcv, params);
// compiled op node returning opresult8132 (depth = 5)
  *var_s = opresult8132;
  if (opresult8132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8135 == NULL) {
    strlit8135 = alloc_String("Unknown");
    gc_root(strlit8135);
  }
// compiled string node returning strlit8135 (depth = 6)
  int op_slot_right_8134 = gc_frame_newslot(strlit8135);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8137 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8139 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8138);
// compiled call node returning call8139 (depth = 9)
// compiled member node returning call8139 (depth = 8)
  partcv[0] = 0;
  Object call8140 = callmethod(call8139, "value",
    1, partcv, params);
  gc_frame_end(callframe8137);
// compiled call node returning call8140 (depth = 7)
// compiled member node returning call8140 (depth = 6)
  int op_slot_left_8134 = gc_frame_newslot(call8140);
  params[0] = strlit8135;
  partcv[0] = 1;
  Object opresult8141 = callmethod(call8140, "!=", 1, partcv, params);
// compiled op node returning opresult8141 (depth = 5)
  Object if8133 = done;
  if (istrue(opresult8141)) {
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8143 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8144 = alloc_Float64(0);
// compiled num node returning num8144 (depth = 8)
  gc_frame_newslot(num8144);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8145 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8146 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8145);
// compiled call node returning call8146 (depth = 9)
// compiled member node returning call8146 (depth = 8)
  params[0] = num8144;
  partcv[0] = 1;
  Object call8147 = callmethod(call8146, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8143);
// compiled call node returning call8147 (depth = 7)
  int op_slot_right_8142 = gc_frame_newslot(call8147);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8150 == NULL) {
    strlit8150 = alloc_String(" : ");
    gc_root(strlit8150);
  }
// compiled string node returning strlit8150 (depth = 8)
  int op_slot_right_8149 = gc_frame_newslot(strlit8150);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8149 = gc_frame_newslot(*var_s);
  params[0] = strlit8150;
  partcv[0] = 1;
  Object opresult8152 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8152 (depth = 7)
  int op_slot_left_8142 = gc_frame_newslot(opresult8152);
  params[0] = call8147;
  partcv[0] = 1;
  Object opresult8153 = callmethod(opresult8152, "++", 1, partcv, params);
// compiled op node returning opresult8153 (depth = 6)
  *var_s = opresult8153;
  if (opresult8153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8133 = done;
  } else {
  }
// compiled if node returning if8133 (depth = 4)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8157 = alloc_Float64(0);
// compiled num node returning num8157 (depth = 6)
  int op_slot_right_8156 = gc_frame_newslot(num8157);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8159 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8161 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8160);
// compiled call node returning call8161 (depth = 9)
// compiled member node returning call8161 (depth = 8)
  partcv[0] = 0;
  Object call8162 = callmethod(call8161, "size",
    1, partcv, params);
  gc_frame_end(callframe8159);
// compiled call node returning call8162 (depth = 7)
// compiled member node returning call8162 (depth = 6)
  int op_slot_left_8156 = gc_frame_newslot(call8162);
  params[0] = num8157;
  partcv[0] = 1;
  Object opresult8163 = callmethod(call8162, ">", 1, partcv, params);
// compiled op node returning opresult8163 (depth = 5)
  Object if8155 = done;
  if (istrue(opresult8163)) {
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8165 == NULL) {
    strlit8165 = alloc_String(" is ");
    gc_root(strlit8165);
  }
// compiled string node returning strlit8165 (depth = 7)
  int op_slot_right_8164 = gc_frame_newslot(strlit8165);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8164 = gc_frame_newslot(*var_s);
  params[0] = strlit8165;
  partcv[0] = 1;
  Object opresult8167 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8167 (depth = 6)
  *var_s = opresult8167;
  if (opresult8167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8170 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8171 == NULL) {
    strlit8171 = alloc_String("");
    gc_root(strlit8171);
  }
// compiled string node returning strlit8171 (depth = 8)
  gc_frame_newslot(strlit8171);
// starting to compile block node (depth = 8)
  Object block8172 = alloc_Block(NULL, NULL, "ast", 1929);
  gc_frame_newslot(block8172);
// method _apply
  block_savedest(block8172);
  Object closure8173 = createclosure(1, "_apply");
  setclosureframe(closure8173, stackframe);
  addtoclosure(closure8173, selfslot);
  struct UserObject *uo8173 = (struct UserObject*)block8172;
  uo8173->data[0] = (Object)closure8173;
  Method *meth_meth_ast__apply8173 = addmethod2pos(block8172, "_apply", &meth_ast__apply8173, 0);
  int argcv_meth_ast__apply8173[] = {2};
  meth_meth_ast__apply8173->type = alloc_MethodType(1, argcv_meth_ast__apply8173);
  meth_meth_ast__apply8173->definitionModule = modulename;
  meth_meth_ast__apply8173->definitionLine = 1927;
// compiled block node returning block8172 (depth = 8)
  gc_frame_newslot(block8172);
// call case 6: other member request
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8192 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8191);
// compiled call node returning call8192 (depth = 9)
// compiled member node returning call8192 (depth = 8)
  params[0] = strlit8171;
  params[1] = block8172;
  partcv[0] = 2;
  Object call8193 = callmethod(call8192, "reduce",
    1, partcv, params);
  gc_frame_end(callframe8170);
// compiled call node returning call8193 (depth = 7)
  int op_slot_right_8169 = gc_frame_newslot(call8193);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8169 = gc_frame_newslot(*var_s);
  params[0] = call8193;
  partcv[0] = 1;
  Object opresult8195 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8195 (depth = 6)
  *var_s = opresult8195;
  if (opresult8195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8155 = done;
  } else {
  }
// compiled if node returning if8155 (depth = 4)
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8199 = alloc_Boolean(0);
// compiled identifier node returning bool8199 (depth = 6)
  int op_slot_right_8198 = gc_frame_newslot(bool8199);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8202 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8201);
// compiled call node returning call8202 (depth = 7)
// compiled member node returning call8202 (depth = 6)
  int op_slot_left_8198 = gc_frame_newslot(call8202);
  params[0] = bool8199;
  partcv[0] = 1;
  Object opresult8203 = callmethod(call8202, "!=", 1, partcv, params);
// compiled op node returning opresult8203 (depth = 5)
  Object if8197 = done;
  if (istrue(opresult8203)) {
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8205 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8206 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8207 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8206);
// compiled call node returning call8207 (depth = 9)
// compiled member node returning call8207 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8208 = callmethod(call8207, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8205);
// compiled call node returning call8208 (depth = 7)
  int op_slot_right_8204 = gc_frame_newslot(call8208);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8211 == NULL) {
    strlit8211 = alloc_String(" = ");
    gc_root(strlit8211);
  }
// compiled string node returning strlit8211 (depth = 8)
  int op_slot_right_8210 = gc_frame_newslot(strlit8211);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8210 = gc_frame_newslot(*var_s);
  params[0] = strlit8211;
  partcv[0] = 1;
  Object opresult8213 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8213 (depth = 7)
  int op_slot_left_8204 = gc_frame_newslot(opresult8213);
  params[0] = call8208;
  partcv[0] = 1;
  Object opresult8214 = callmethod(opresult8213, "++", 1, partcv, params);
// compiled op node returning opresult8214 (depth = 6)
  *var_s = opresult8214;
  if (opresult8214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8197 = done;
  } else {
  }
// compiled if node returning if8197 (depth = 4)
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent8216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8217 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8218 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8220 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8219);
// compiled call node returning call8220 (depth = 7)
// compiled member node returning call8220 (depth = 6)
  gc_frame_newslot(call8220);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8221 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8222 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8221);
// compiled call node returning call8222 (depth = 7)
// compiled member node returning call8222 (depth = 6)
  gc_frame_newslot(call8222);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8224 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8223);
// compiled call node returning call8224 (depth = 7)
// compiled member node returning call8224 (depth = 6)
  gc_frame_newslot(call8224);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defDecNode (depth = 6)
  params[0] = call8220;
  params[1] = call8222;
  params[2] = call8224;
  partcv[0] = 3;
  Object call8225 = callmethod(*var_defDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8218);
// compiled call node returning call8225 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8226 = callmethod(call8225, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe8217);
// compiled call node returning call8226 (depth = 4)
  gc_frame_end(frame);
  return call8226;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent8227(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8228 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8229 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8228);
// compiled call node returning call8229 (depth = 4)
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8230 = gc_frame_new();
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call8232 = callmethod(*var_other, "data",
    1, partcv, params);
  gc_frame_end(callframe8231);
// compiled call node returning call8232 (depth = 7)
// compiled member node returning call8232 (depth = 6)
  gc_frame_newslot(call8232);
// call case 4: self request
  params[0] = call8232;
  partcv[0] = 1;
  Object call8233 = callmethodflags(self, "data:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8230);
// compiled call node returning call8233 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8234 = gc_frame_new();
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8235 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call8236 = callmethod(*var_other, "startToken",
    1, partcv, params);
  gc_frame_end(callframe8235);
// compiled call node returning call8236 (depth = 7)
// compiled member node returning call8236 (depth = 6)
  gc_frame_newslot(call8236);
// call case 4: self request
  params[0] = call8236;
  partcv[0] = 1;
  Object call8237 = callmethodflags(self, "startToken:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8234);
// compiled call node returning call8237 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new7851(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7852 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7852 = alloc_userobj2(28,23, objclass7852);
  gc_frame_newslot(obj7852);
if (objclass7852 == NULL) {
  glfree(obj7852->class->name);
  obj7852->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7852, self, 0);
  addmethodreal(obj7852,"outer", &reader_ast_outer_7853);
  Object oldself7852 = self;
  struct StackFrameObject *oldstackframe7852 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7852);
  gc_frame_newslot((Object)stackframe);
  self = obj7852;
  Object *oldselfslot7852 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7852 = (*(struct UserObject *)self).data[0], lowerouter7852 = thisouter7852;
  if (inheritingObject7852) {
    struct UserObject *inho7852 = (struct UserObject *)inheritingObject7852;
    while (inho7852->super != GraceDefaultObject) inho7852 = (struct UserObject *)inho7852->super;
    inho7852->super = obj7852;
    self = inheritingObject7852;
    *selfslot = self;
    lowerouter7852 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7852;
  }
if (objclass7852 == NULL) {
  Method *reader7854 = addmethodrealflags(obj7852, "kind",&reader_ast_kind_7854, MFLAG_DEF);
  reader7854->definitionModule = modulename;
  reader7854->definitionLine = 1843;
}
adddatum2(obj7852, alloc_Undefined(), 1);
if (objclass7852 == NULL) {
  Method *reader7855 = addmethodrealflags(obj7852, "name",&reader_ast_name_7855, 0);
  Method *writer7855 = addmethodrealflags(obj7852, "name:=",&writer_ast_name_7855, 0);
  reader7855->definitionModule = modulename;
  writer7855->definitionModule = modulename;
  reader7855->definitionLine = 1844;
  writer7855->definitionLine = 1844;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 2);
if (objclass7852 == NULL) {
  Method *reader7856 = addmethodrealflags(obj7852, "value",&reader_ast_value_7856, 0);
  Method *writer7856 = addmethodrealflags(obj7852, "value:=",&writer_ast_value_7856, 0);
  reader7856->definitionModule = modulename;
  writer7856->definitionModule = modulename;
  reader7856->definitionLine = 1845;
  writer7856->definitionLine = 1845;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 3);
if (objclass7852 == NULL) {
  Method *reader7857 = addmethodrealflags(obj7852, "dtype",&reader_ast_dtype_7857, 0);
  Method *writer7857 = addmethodrealflags(obj7852, "dtype:=",&writer_ast_dtype_7857, 0);
  reader7857->definitionModule = modulename;
  writer7857->definitionModule = modulename;
  reader7857->definitionLine = 1846;
  writer7857->definitionLine = 1846;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 4);
if (objclass7852 == NULL) {
  Method *reader7858 = addmethodrealflags(obj7852, "nameString",&reader_ast_nameString_7858, MFLAG_DEF);
  reader7858->definitionModule = modulename;
  reader7858->definitionLine = 1847;
}
adddatum2(obj7852, alloc_Undefined(), 5);
if (objclass7852 == NULL) {
  Method *reader7859 = addmethodrealflags(obj7852, "annotations",&reader_ast_annotations_7859, 0);
  Method *writer7859 = addmethodrealflags(obj7852, "annotations:=",&writer_ast_annotations_7859, 0);
  reader7859->definitionModule = modulename;
  writer7859->definitionModule = modulename;
  reader7859->definitionLine = 1848;
  writer7859->definitionLine = 1848;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 6);
if (objclass7852 == NULL) {
  Method *reader7860 = addmethodrealflags(obj7852, "data",&reader_ast_data_7860, 0);
  Method *writer7860 = addmethodrealflags(obj7852, "data:=",&writer_ast_data_7860, 0);
  reader7860->definitionModule = modulename;
  writer7860->definitionModule = modulename;
  reader7860->definitionLine = 1849;
  writer7860->definitionLine = 1849;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 7);
if (objclass7852 == NULL) {
  Method *reader7861 = addmethodrealflags(obj7852, "startToken",&reader_ast_startToken_7861, 0);
  Method *writer7861 = addmethodrealflags(obj7852, "startToken:=",&writer_ast_startToken_7861, 0);
  reader7861->definitionModule = modulename;
  writer7861->definitionModule = modulename;
  reader7861->definitionLine = 1851;
  writer7861->definitionLine = 1851;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 8);
// method isPublic
  struct UserObject *uo7862 = (struct UserObject*)obj7852;
  uo7862->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic7862 = addmethod2pos(obj7852, "isPublic", &meth_ast_isPublic7862, 9);
  int argcv_meth_ast_isPublic7862[] = {0};
  meth_meth_ast_isPublic7862->type = alloc_MethodType(1, argcv_meth_ast_isPublic7862);
  meth_meth_ast_isPublic7862->definitionModule = modulename;
  meth_meth_ast_isPublic7862->definitionLine = 1851;
// method isWritable
  struct UserObject *uo7898 = (struct UserObject*)obj7852;
  uo7898->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7898 = addmethod2pos(obj7852, "isWritable", &meth_ast_isWritable7898, 10);
  int argcv_meth_ast_isWritable7898[] = {0};
  meth_meth_ast_isWritable7898->type = alloc_MethodType(1, argcv_meth_ast_isWritable7898);
  meth_meth_ast_isWritable7898->definitionModule = modulename;
  meth_meth_ast_isWritable7898->definitionLine = 1861;
// method isReadable
  struct UserObject *uo7900 = (struct UserObject*)obj7852;
  uo7900->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7900 = addmethod2pos(obj7852, "isReadable", &meth_ast_isReadable7900, 11);
  int argcv_meth_ast_isReadable7900[] = {0};
  meth_meth_ast_isReadable7900->type = alloc_MethodType(1, argcv_meth_ast_isReadable7900);
  meth_meth_ast_isReadable7900->definitionModule = modulename;
  meth_meth_ast_isReadable7900->definitionLine = 1862;
// method isFieldDec
  struct UserObject *uo7903 = (struct UserObject*)obj7852;
  uo7903->data[12] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7903 = addmethod2pos(obj7852, "isFieldDec", &meth_ast_isFieldDec7903, 12);
  int argcv_meth_ast_isFieldDec7903[] = {0};
  meth_meth_ast_isFieldDec7903->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7903);
  meth_meth_ast_isFieldDec7903->definitionModule = modulename;
  meth_meth_ast_isFieldDec7903->definitionLine = 1863;
// method definesScope
  struct UserObject *uo7925 = (struct UserObject*)obj7852;
  uo7925->data[13] = emptyclosure;
  Method *meth_meth_ast_definesScope7925 = addmethod2pos(obj7852, "definesScope", &meth_ast_definesScope7925, 13);
  int argcv_meth_ast_definesScope7925[] = {0};
  meth_meth_ast_definesScope7925->type = alloc_MethodType(1, argcv_meth_ast_definesScope7925);
  meth_meth_ast_definesScope7925->definitionModule = modulename;
  meth_meth_ast_definesScope7925->definitionLine = 1868;
// method objectScope
  struct UserObject *uo7930 = (struct UserObject*)obj7852;
  uo7930->data[14] = emptyclosure;
  Method *meth_meth_ast_objectScope7930 = addmethod2pos(obj7852, "objectScope", &meth_ast_objectScope7930, 14);
  int argcv_meth_ast_objectScope7930[] = {0};
  meth_meth_ast_objectScope7930->type = alloc_MethodType(1, argcv_meth_ast_objectScope7930);
  meth_meth_ast_objectScope7930->definitionModule = modulename;
  meth_meth_ast_objectScope7930->definitionLine = 1871;
// method usesAsType
  struct UserObject *uo7933 = (struct UserObject*)obj7852;
  uo7933->data[15] = emptyclosure;
  Method *meth_meth_ast_usesAsType7933 = addmethod2pos(obj7852, "usesAsType", &meth_ast_usesAsType7933, 15);
  int argcv_meth_ast_usesAsType7933[] = {1};
  meth_meth_ast_usesAsType7933->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7933);
  meth_meth_ast_usesAsType7933->definitionModule = modulename;
  meth_meth_ast_usesAsType7933->definitionLine = 1874;
// method accept()from
  struct UserObject *uo7939 = (struct UserObject*)obj7852;
  uo7939->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7939 = addmethod2pos(obj7852, "accept()from", &meth_ast_accept_40__41_from7939, 16);
  int argcv_meth_ast_accept_40__41_from7939[] = {1, 1};
  meth_meth_ast_accept_40__41_from7939->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7939);
  meth_meth_ast_accept_40__41_from7939->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7939->definitionLine = 1877;
// method map()parent
  struct UserObject *uo7969 = (struct UserObject*)obj7852;
  uo7969->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7969 = addmethod2pos(obj7852, "map()parent", &meth_ast_map_40__41_parent7969, 17);
  int argcv_meth_ast_map_40__41_parent7969[] = {1, 1};
  meth_meth_ast_map_40__41_parent7969->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7969);
  meth_meth_ast_map_40__41_parent7969->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7969->definitionLine = 1888;
// method pretty
  struct UserObject *uo8007 = (struct UserObject*)obj7852;
  uo8007->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty8007 = addmethod2pos(obj7852, "pretty", &meth_ast_pretty8007, 18);
  int argcv_meth_ast_pretty8007[] = {1};
  meth_meth_ast_pretty8007->type = alloc_MethodType(1, argcv_meth_ast_pretty8007);
  meth_meth_ast_pretty8007->definitionModule = modulename;
  meth_meth_ast_pretty8007->definitionLine = 1897;
// method toGrace
  struct UserObject *uo8100 = (struct UserObject*)obj7852;
  uo8100->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace8100 = addmethod2pos(obj7852, "toGrace", &meth_ast_toGrace8100, 19);
  int argcv_meth_ast_toGrace8100[] = {1};
  meth_meth_ast_toGrace8100->type = alloc_MethodType(1, argcv_meth_ast_toGrace8100);
meth_meth_ast_toGrace8100->type->types[0] = type_Number;
meth_meth_ast_toGrace8100->type->names[0] = "depth";
  meth_meth_ast_toGrace8100->definitionModule = modulename;
  meth_meth_ast_toGrace8100->definitionLine = 1918;
// method shallowCopyWithParent
  block_savedest(obj7852);
  Object closure8216 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure8216, stackframe);
  addtoclosure(closure8216, var_defDecNode);
  struct UserObject *uo8216 = (struct UserObject*)obj7852;
  uo8216->data[20] = (Object)closure8216;
  Method *meth_meth_ast_shallowCopyWithParent8216 = addmethod2pos(obj7852, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent8216, 20);
  int argcv_meth_ast_shallowCopyWithParent8216[] = {1};
  meth_meth_ast_shallowCopyWithParent8216->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent8216);
  meth_meth_ast_shallowCopyWithParent8216->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent8216->definitionLine = 1937;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo8227 = (struct UserObject*)obj7852;
  uo8227->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227 = addmethod2pos(obj7852, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent8227, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent8227[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent8227);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227->definitionLine = 1940;
  sourceObject = obj7852;
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8238 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8239 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8238);
// compiled call node returning call8239 (depth = 4)
  struct UserObject *obj7852_uo = (struct UserObject *)obj7852;
  obj7852_uo->super = call8239;
  sourceObject = obj7852;
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8240 == NULL) {
    strlit8240 = alloc_String("defdec");
    gc_root(strlit8240);
  }
// compiled string node returning strlit8240 (depth = 4)
  adddatum2(obj7852, strlit8240, 1);
  sourceObject = obj7852;
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj7852, *var_name_39_, 2);
  sourceObject = obj7852;
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val (depth = 4)
  adddatum2(obj7852, *var_val, 3);
  sourceObject = obj7852;
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj7852, *var_dtype_39_, 4);
  sourceObject = obj7852;
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8241 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8243 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8242);
// compiled call node returning call8243 (depth = 7)
// compiled member node returning call8243 (depth = 6)
  partcv[0] = 0;
  Object call8244 = callmethod(call8243, "value",
    1, partcv, params);
  gc_frame_end(callframe8241);
// compiled call node returning call8244 (depth = 5)
// compiled member node returning call8244 (depth = 4)
  adddatum2(obj7852, call8244, 5);
  sourceObject = obj7852;
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8245 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8246 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8247 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8246);
// compiled call node returning call8247 (depth = 7)
// compiled member node returning call8247 (depth = 6)
  partcv[0] = 0;
  Object call8248 = callmethod(call8247, "empty",
    1, partcv, params);
  gc_frame_end(callframe8245);
// compiled call node returning call8248 (depth = 5)
// compiled member node returning call8248 (depth = 4)
  adddatum2(obj7852, call8248, 6);
  sourceObject = obj7852;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8249 = alloc_Boolean(0);
// compiled identifier node returning bool8249 (depth = 4)
  adddatum2(obj7852, bool8249, 7);
  sourceObject = obj7852;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8250 = alloc_Boolean(0);
// compiled identifier node returning bool8250 (depth = 4)
  adddatum2(obj7852, bool8250, 8);
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
objclass7852 = obj7852->class;
  objclass7852->definitionModule = modulename;
  objclass7852->definitionLine = 1840;
  (*(struct UserObject *)self).data[0] = lowerouter7852;
  self = oldself7852;
  selfslot = oldselfslot7852;
  stackframe = oldstackframe7852;
  gc_frame_end(frame);
  return obj7852;
}
Object meth_ast_new7851_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7852 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7852 = alloc_userobj2(28,23, objclass7852);
  gc_frame_newslot(obj7852);
if (objclass7852 == NULL) {
  glfree(obj7852->class->name);
  obj7852->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7852, self, 0);
  addmethodreal(obj7852,"outer", &reader_ast_outer_7853);
  Object oldself7852 = self;
  struct StackFrameObject *oldstackframe7852 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7852);
  gc_frame_newslot((Object)stackframe);
  self = obj7852;
  Object *oldselfslot7852 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7852 = (*(struct UserObject *)self).data[0], lowerouter7852 = thisouter7852;
  if (inheritingObject7852) {
    struct UserObject *inho7852 = (struct UserObject *)inheritingObject7852;
    while (inho7852->super != GraceDefaultObject) inho7852 = (struct UserObject *)inho7852->super;
    inho7852->super = obj7852;
    self = inheritingObject7852;
    *selfslot = self;
    lowerouter7852 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7852;
  }
if (objclass7852 == NULL) {
  Method *reader7854 = addmethodrealflags(obj7852, "kind",&reader_ast_kind_7854, MFLAG_DEF);
  reader7854->definitionModule = modulename;
  reader7854->definitionLine = 1843;
}
adddatum2(obj7852, alloc_Undefined(), 1);
if (objclass7852 == NULL) {
  Method *reader7855 = addmethodrealflags(obj7852, "name",&reader_ast_name_7855, 0);
  Method *writer7855 = addmethodrealflags(obj7852, "name:=",&writer_ast_name_7855, 0);
  reader7855->definitionModule = modulename;
  writer7855->definitionModule = modulename;
  reader7855->definitionLine = 1844;
  writer7855->definitionLine = 1844;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 2);
if (objclass7852 == NULL) {
  Method *reader7856 = addmethodrealflags(obj7852, "value",&reader_ast_value_7856, 0);
  Method *writer7856 = addmethodrealflags(obj7852, "value:=",&writer_ast_value_7856, 0);
  reader7856->definitionModule = modulename;
  writer7856->definitionModule = modulename;
  reader7856->definitionLine = 1845;
  writer7856->definitionLine = 1845;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 3);
if (objclass7852 == NULL) {
  Method *reader7857 = addmethodrealflags(obj7852, "dtype",&reader_ast_dtype_7857, 0);
  Method *writer7857 = addmethodrealflags(obj7852, "dtype:=",&writer_ast_dtype_7857, 0);
  reader7857->definitionModule = modulename;
  writer7857->definitionModule = modulename;
  reader7857->definitionLine = 1846;
  writer7857->definitionLine = 1846;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 4);
if (objclass7852 == NULL) {
  Method *reader7858 = addmethodrealflags(obj7852, "nameString",&reader_ast_nameString_7858, MFLAG_DEF);
  reader7858->definitionModule = modulename;
  reader7858->definitionLine = 1847;
}
adddatum2(obj7852, alloc_Undefined(), 5);
if (objclass7852 == NULL) {
  Method *reader7859 = addmethodrealflags(obj7852, "annotations",&reader_ast_annotations_7859, 0);
  Method *writer7859 = addmethodrealflags(obj7852, "annotations:=",&writer_ast_annotations_7859, 0);
  reader7859->definitionModule = modulename;
  writer7859->definitionModule = modulename;
  reader7859->definitionLine = 1848;
  writer7859->definitionLine = 1848;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 6);
if (objclass7852 == NULL) {
  Method *reader7860 = addmethodrealflags(obj7852, "data",&reader_ast_data_7860, 0);
  Method *writer7860 = addmethodrealflags(obj7852, "data:=",&writer_ast_data_7860, 0);
  reader7860->definitionModule = modulename;
  writer7860->definitionModule = modulename;
  reader7860->definitionLine = 1849;
  writer7860->definitionLine = 1849;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 7);
if (objclass7852 == NULL) {
  Method *reader7861 = addmethodrealflags(obj7852, "startToken",&reader_ast_startToken_7861, 0);
  Method *writer7861 = addmethodrealflags(obj7852, "startToken:=",&writer_ast_startToken_7861, 0);
  reader7861->definitionModule = modulename;
  writer7861->definitionModule = modulename;
  reader7861->definitionLine = 1851;
  writer7861->definitionLine = 1851;
}
obj7852->flags |= OFLAG_MUTABLE;
adddatum2(obj7852, alloc_Undefined(), 8);
// method isPublic
  struct UserObject *uo7862 = (struct UserObject*)obj7852;
  uo7862->data[9] = emptyclosure;
  Method *meth_meth_ast_isPublic7862 = addmethod2pos(obj7852, "isPublic", &meth_ast_isPublic7862, 9);
  int argcv_meth_ast_isPublic7862[] = {0};
  meth_meth_ast_isPublic7862->type = alloc_MethodType(1, argcv_meth_ast_isPublic7862);
  meth_meth_ast_isPublic7862->definitionModule = modulename;
  meth_meth_ast_isPublic7862->definitionLine = 1851;
// method isWritable
  struct UserObject *uo7898 = (struct UserObject*)obj7852;
  uo7898->data[10] = emptyclosure;
  Method *meth_meth_ast_isWritable7898 = addmethod2pos(obj7852, "isWritable", &meth_ast_isWritable7898, 10);
  int argcv_meth_ast_isWritable7898[] = {0};
  meth_meth_ast_isWritable7898->type = alloc_MethodType(1, argcv_meth_ast_isWritable7898);
  meth_meth_ast_isWritable7898->definitionModule = modulename;
  meth_meth_ast_isWritable7898->definitionLine = 1861;
// method isReadable
  struct UserObject *uo7900 = (struct UserObject*)obj7852;
  uo7900->data[11] = emptyclosure;
  Method *meth_meth_ast_isReadable7900 = addmethod2pos(obj7852, "isReadable", &meth_ast_isReadable7900, 11);
  int argcv_meth_ast_isReadable7900[] = {0};
  meth_meth_ast_isReadable7900->type = alloc_MethodType(1, argcv_meth_ast_isReadable7900);
  meth_meth_ast_isReadable7900->definitionModule = modulename;
  meth_meth_ast_isReadable7900->definitionLine = 1862;
// method isFieldDec
  struct UserObject *uo7903 = (struct UserObject*)obj7852;
  uo7903->data[12] = emptyclosure;
  Method *meth_meth_ast_isFieldDec7903 = addmethod2pos(obj7852, "isFieldDec", &meth_ast_isFieldDec7903, 12);
  int argcv_meth_ast_isFieldDec7903[] = {0};
  meth_meth_ast_isFieldDec7903->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec7903);
  meth_meth_ast_isFieldDec7903->definitionModule = modulename;
  meth_meth_ast_isFieldDec7903->definitionLine = 1863;
// method definesScope
  struct UserObject *uo7925 = (struct UserObject*)obj7852;
  uo7925->data[13] = emptyclosure;
  Method *meth_meth_ast_definesScope7925 = addmethod2pos(obj7852, "definesScope", &meth_ast_definesScope7925, 13);
  int argcv_meth_ast_definesScope7925[] = {0};
  meth_meth_ast_definesScope7925->type = alloc_MethodType(1, argcv_meth_ast_definesScope7925);
  meth_meth_ast_definesScope7925->definitionModule = modulename;
  meth_meth_ast_definesScope7925->definitionLine = 1868;
// method objectScope
  struct UserObject *uo7930 = (struct UserObject*)obj7852;
  uo7930->data[14] = emptyclosure;
  Method *meth_meth_ast_objectScope7930 = addmethod2pos(obj7852, "objectScope", &meth_ast_objectScope7930, 14);
  int argcv_meth_ast_objectScope7930[] = {0};
  meth_meth_ast_objectScope7930->type = alloc_MethodType(1, argcv_meth_ast_objectScope7930);
  meth_meth_ast_objectScope7930->definitionModule = modulename;
  meth_meth_ast_objectScope7930->definitionLine = 1871;
// method usesAsType
  struct UserObject *uo7933 = (struct UserObject*)obj7852;
  uo7933->data[15] = emptyclosure;
  Method *meth_meth_ast_usesAsType7933 = addmethod2pos(obj7852, "usesAsType", &meth_ast_usesAsType7933, 15);
  int argcv_meth_ast_usesAsType7933[] = {1};
  meth_meth_ast_usesAsType7933->type = alloc_MethodType(1, argcv_meth_ast_usesAsType7933);
  meth_meth_ast_usesAsType7933->definitionModule = modulename;
  meth_meth_ast_usesAsType7933->definitionLine = 1874;
// method accept()from
  struct UserObject *uo7939 = (struct UserObject*)obj7852;
  uo7939->data[16] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from7939 = addmethod2pos(obj7852, "accept()from", &meth_ast_accept_40__41_from7939, 16);
  int argcv_meth_ast_accept_40__41_from7939[] = {1, 1};
  meth_meth_ast_accept_40__41_from7939->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from7939);
  meth_meth_ast_accept_40__41_from7939->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from7939->definitionLine = 1877;
// method map()parent
  struct UserObject *uo7969 = (struct UserObject*)obj7852;
  uo7969->data[17] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent7969 = addmethod2pos(obj7852, "map()parent", &meth_ast_map_40__41_parent7969, 17);
  int argcv_meth_ast_map_40__41_parent7969[] = {1, 1};
  meth_meth_ast_map_40__41_parent7969->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent7969);
  meth_meth_ast_map_40__41_parent7969->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent7969->definitionLine = 1888;
// method pretty
  struct UserObject *uo8007 = (struct UserObject*)obj7852;
  uo8007->data[18] = emptyclosure;
  Method *meth_meth_ast_pretty8007 = addmethod2pos(obj7852, "pretty", &meth_ast_pretty8007, 18);
  int argcv_meth_ast_pretty8007[] = {1};
  meth_meth_ast_pretty8007->type = alloc_MethodType(1, argcv_meth_ast_pretty8007);
  meth_meth_ast_pretty8007->definitionModule = modulename;
  meth_meth_ast_pretty8007->definitionLine = 1897;
// method toGrace
  struct UserObject *uo8100 = (struct UserObject*)obj7852;
  uo8100->data[19] = emptyclosure;
  Method *meth_meth_ast_toGrace8100 = addmethod2pos(obj7852, "toGrace", &meth_ast_toGrace8100, 19);
  int argcv_meth_ast_toGrace8100[] = {1};
  meth_meth_ast_toGrace8100->type = alloc_MethodType(1, argcv_meth_ast_toGrace8100);
meth_meth_ast_toGrace8100->type->types[0] = type_Number;
meth_meth_ast_toGrace8100->type->names[0] = "depth";
  meth_meth_ast_toGrace8100->definitionModule = modulename;
  meth_meth_ast_toGrace8100->definitionLine = 1918;
// method shallowCopyWithParent
  block_savedest(obj7852);
  Object closure8216 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure8216, stackframe);
  addtoclosure(closure8216, var_defDecNode);
  struct UserObject *uo8216 = (struct UserObject*)obj7852;
  uo8216->data[20] = (Object)closure8216;
  Method *meth_meth_ast_shallowCopyWithParent8216 = addmethod2pos(obj7852, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent8216, 20);
  int argcv_meth_ast_shallowCopyWithParent8216[] = {1};
  meth_meth_ast_shallowCopyWithParent8216->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent8216);
  meth_meth_ast_shallowCopyWithParent8216->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent8216->definitionLine = 1937;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo8227 = (struct UserObject*)obj7852;
  uo8227->data[21] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227 = addmethod2pos(obj7852, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent8227, 21);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent8227[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent8227);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent8227->definitionLine = 1940;
  sourceObject = obj7852;
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8238 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8239 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8238);
// compiled call node returning call8239 (depth = 4)
  struct UserObject *obj7852_uo = (struct UserObject *)obj7852;
  obj7852_uo->super = call8239;
  sourceObject = obj7852;
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8240 == NULL) {
    strlit8240 = alloc_String("defdec");
    gc_root(strlit8240);
  }
// compiled string node returning strlit8240 (depth = 4)
  adddatum2(obj7852, strlit8240, 1);
  sourceObject = obj7852;
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj7852, *var_name_39_, 2);
  sourceObject = obj7852;
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val (depth = 4)
  adddatum2(obj7852, *var_val, 3);
  sourceObject = obj7852;
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj7852, *var_dtype_39_, 4);
  sourceObject = obj7852;
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8241 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8243 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8242);
// compiled call node returning call8243 (depth = 7)
// compiled member node returning call8243 (depth = 6)
  partcv[0] = 0;
  Object call8244 = callmethod(call8243, "value",
    1, partcv, params);
  gc_frame_end(callframe8241);
// compiled call node returning call8244 (depth = 5)
// compiled member node returning call8244 (depth = 4)
  adddatum2(obj7852, call8244, 5);
  sourceObject = obj7852;
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8245 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8246 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8247 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8246);
// compiled call node returning call8247 (depth = 7)
// compiled member node returning call8247 (depth = 6)
  partcv[0] = 0;
  Object call8248 = callmethod(call8247, "empty",
    1, partcv, params);
  gc_frame_end(callframe8245);
// compiled call node returning call8248 (depth = 5)
// compiled member node returning call8248 (depth = 4)
  adddatum2(obj7852, call8248, 6);
  sourceObject = obj7852;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8249 = alloc_Boolean(0);
// compiled identifier node returning bool8249 (depth = 4)
  adddatum2(obj7852, bool8249, 7);
  sourceObject = obj7852;
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8250 = alloc_Boolean(0);
// compiled identifier node returning bool8250 (depth = 4)
  adddatum2(obj7852, bool8250, 8);
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
  sourceObject = obj7852;
objclass7852 = obj7852->class;
  objclass7852->definitionModule = modulename;
  objclass7852->definitionLine = 1840;
  (*(struct UserObject *)self).data[0] = lowerouter7852;
  self = oldself7852;
  selfslot = oldselfslot7852;
  stackframe = oldstackframe7852;
  gc_frame_end(frame);
  return obj7852;
}
Object meth_ast_varDecNode8252(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for varDecNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for varDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_varDecNode (depth = 3)
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_isPublic8264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8267 = alloc_Float64(0);
// compiled num node returning num8267 (depth = 6)
  int op_slot_right_8266 = gc_frame_newslot(num8267);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8269 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8270 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8271 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8270);
// compiled call node returning call8271 (depth = 9)
// compiled member node returning call8271 (depth = 8)
  partcv[0] = 0;
  Object call8272 = callmethod(call8271, "size",
    1, partcv, params);
  gc_frame_end(callframe8269);
// compiled call node returning call8272 (depth = 7)
// compiled member node returning call8272 (depth = 6)
  int op_slot_left_8266 = gc_frame_newslot(call8272);
  params[0] = num8267;
  partcv[0] = 1;
  Object opresult8273 = callmethod(call8272, "==", 1, partcv, params);
// compiled op node returning opresult8273 (depth = 5)
  Object if8265 = done;
  if (istrue(opresult8273)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8274 = alloc_Boolean(0);
// compiled identifier node returning bool8274 (depth = 6)
  return bool8274;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8265 = undefined;
  } else {
  }
// compiled if node returning if8265 (depth = 4)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8276 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8277 == NULL) {
    strlit8277 = alloc_String("public");
    gc_root(strlit8277);
  }
// compiled string node returning strlit8277 (depth = 6)
  gc_frame_newslot(strlit8277);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8278 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8279 = gc_frame_new();
// call case 3: self.outer request
  Object call8280 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8279);
// compiled call node returning call8280 (depth = 9)
// compiled member node returning call8280 (depth = 8)
  partcv[0] = 0;
  Object call8281 = callmethodflags(call8280, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8278);
// compiled call node returning call8281 (depth = 7)
// compiled member node returning call8281 (depth = 6)
  params[0] = self;
  params[1] = strlit8277;
  partcv[0] = 2;
  Object call8282 = callmethodflags(call8281, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8276);
// compiled call node returning call8282 (depth = 5)
  Object if8275 = done;
  if (istrue(call8282)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8283 = alloc_Boolean(1);
// compiled identifier node returning bool8283 (depth = 6)
  return bool8283;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8275 = undefined;
  } else {
  }
// compiled if node returning if8275 (depth = 4)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8284 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8285 == NULL) {
    strlit8285 = alloc_String("readable");
    gc_root(strlit8285);
  }
// compiled string node returning strlit8285 (depth = 5)
  gc_frame_newslot(strlit8285);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8286 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8287 = gc_frame_new();
// call case 3: self.outer request
  Object call8288 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8287);
// compiled call node returning call8288 (depth = 8)
// compiled member node returning call8288 (depth = 7)
  partcv[0] = 0;
  Object call8289 = callmethodflags(call8288, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8286);
// compiled call node returning call8289 (depth = 6)
// compiled member node returning call8289 (depth = 5)
  params[0] = self;
  params[1] = strlit8285;
  partcv[0] = 2;
  Object call8290 = callmethodflags(call8289, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8284);
// compiled call node returning call8290 (depth = 4)
  gc_frame_end(frame);
  return call8290;
}
Object meth_ast_isWritable8291(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8294 = alloc_Float64(0);
// compiled num node returning num8294 (depth = 6)
  int op_slot_right_8293 = gc_frame_newslot(num8294);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8296 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8298 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8297);
// compiled call node returning call8298 (depth = 9)
// compiled member node returning call8298 (depth = 8)
  partcv[0] = 0;
  Object call8299 = callmethod(call8298, "size",
    1, partcv, params);
  gc_frame_end(callframe8296);
// compiled call node returning call8299 (depth = 7)
// compiled member node returning call8299 (depth = 6)
  int op_slot_left_8293 = gc_frame_newslot(call8299);
  params[0] = num8294;
  partcv[0] = 1;
  Object opresult8300 = callmethod(call8299, "==", 1, partcv, params);
// compiled op node returning opresult8300 (depth = 5)
  Object if8292 = done;
  if (istrue(opresult8300)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8301 = alloc_Boolean(0);
// compiled identifier node returning bool8301 (depth = 6)
  return bool8301;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8292 = undefined;
  } else {
  }
// compiled if node returning if8292 (depth = 4)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8303 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8304 == NULL) {
    strlit8304 = alloc_String("public");
    gc_root(strlit8304);
  }
// compiled string node returning strlit8304 (depth = 6)
  gc_frame_newslot(strlit8304);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8305 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8306 = gc_frame_new();
// call case 3: self.outer request
  Object call8307 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8306);
// compiled call node returning call8307 (depth = 9)
// compiled member node returning call8307 (depth = 8)
  partcv[0] = 0;
  Object call8308 = callmethodflags(call8307, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8305);
// compiled call node returning call8308 (depth = 7)
// compiled member node returning call8308 (depth = 6)
  params[0] = self;
  params[1] = strlit8304;
  partcv[0] = 2;
  Object call8309 = callmethodflags(call8308, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8303);
// compiled call node returning call8309 (depth = 5)
  Object if8302 = done;
  if (istrue(call8309)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8310 = alloc_Boolean(1);
// compiled identifier node returning bool8310 (depth = 6)
  return bool8310;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8302 = undefined;
  } else {
  }
// compiled if node returning if8302 (depth = 4)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8312 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8313 == NULL) {
    strlit8313 = alloc_String("writable");
    gc_root(strlit8313);
  }
// compiled string node returning strlit8313 (depth = 6)
  gc_frame_newslot(strlit8313);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8314 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8315 = gc_frame_new();
// call case 3: self.outer request
  Object call8316 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8315);
// compiled call node returning call8316 (depth = 9)
// compiled member node returning call8316 (depth = 8)
  partcv[0] = 0;
  Object call8317 = callmethodflags(call8316, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8314);
// compiled call node returning call8317 (depth = 7)
// compiled member node returning call8317 (depth = 6)
  params[0] = self;
  params[1] = strlit8313;
  partcv[0] = 2;
  Object call8318 = callmethodflags(call8317, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8312);
// compiled call node returning call8318 (depth = 5)
  Object if8311 = done;
  if (istrue(call8318)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8319 = alloc_Boolean(1);
// compiled identifier node returning bool8319 (depth = 6)
  return bool8319;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8311 = undefined;
  } else {
  }
// compiled if node returning if8311 (depth = 4)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8320 = alloc_Boolean(0);
// compiled identifier node returning bool8320 (depth = 4)
  gc_frame_end(frame);
  return bool8320;
}
Object meth_ast_isReadable8321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8324 = alloc_Float64(0);
// compiled num node returning num8324 (depth = 6)
  int op_slot_right_8323 = gc_frame_newslot(num8324);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8326 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8328 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8327);
// compiled call node returning call8328 (depth = 9)
// compiled member node returning call8328 (depth = 8)
  partcv[0] = 0;
  Object call8329 = callmethod(call8328, "size",
    1, partcv, params);
  gc_frame_end(callframe8326);
// compiled call node returning call8329 (depth = 7)
// compiled member node returning call8329 (depth = 6)
  int op_slot_left_8323 = gc_frame_newslot(call8329);
  params[0] = num8324;
  partcv[0] = 1;
  Object opresult8330 = callmethod(call8329, "==", 1, partcv, params);
// compiled op node returning opresult8330 (depth = 5)
  Object if8322 = done;
  if (istrue(opresult8330)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8331 = alloc_Boolean(0);
// compiled identifier node returning bool8331 (depth = 6)
  return bool8331;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8322 = undefined;
  } else {
  }
// compiled if node returning if8322 (depth = 4)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8333 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8334 == NULL) {
    strlit8334 = alloc_String("public");
    gc_root(strlit8334);
  }
// compiled string node returning strlit8334 (depth = 6)
  gc_frame_newslot(strlit8334);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8335 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8336 = gc_frame_new();
// call case 3: self.outer request
  Object call8337 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8336);
// compiled call node returning call8337 (depth = 9)
// compiled member node returning call8337 (depth = 8)
  partcv[0] = 0;
  Object call8338 = callmethodflags(call8337, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8335);
// compiled call node returning call8338 (depth = 7)
// compiled member node returning call8338 (depth = 6)
  params[0] = self;
  params[1] = strlit8334;
  partcv[0] = 2;
  Object call8339 = callmethodflags(call8338, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8333);
// compiled call node returning call8339 (depth = 5)
  Object if8332 = done;
  if (istrue(call8339)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8340 = alloc_Boolean(1);
// compiled identifier node returning bool8340 (depth = 6)
  return bool8340;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8332 = undefined;
  } else {
  }
// compiled if node returning if8332 (depth = 4)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8342 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8343 == NULL) {
    strlit8343 = alloc_String("readable");
    gc_root(strlit8343);
  }
// compiled string node returning strlit8343 (depth = 6)
  gc_frame_newslot(strlit8343);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8344 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8345 = gc_frame_new();
// call case 3: self.outer request
  Object call8346 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8345);
// compiled call node returning call8346 (depth = 9)
// compiled member node returning call8346 (depth = 8)
  partcv[0] = 0;
  Object call8347 = callmethodflags(call8346, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8344);
// compiled call node returning call8347 (depth = 7)
// compiled member node returning call8347 (depth = 6)
  params[0] = self;
  params[1] = strlit8343;
  partcv[0] = 2;
  Object call8348 = callmethodflags(call8347, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8342);
// compiled call node returning call8348 (depth = 5)
  Object if8341 = done;
  if (istrue(call8348)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8349 = alloc_Boolean(1);
// compiled identifier node returning bool8349 (depth = 6)
  return bool8349;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8341 = undefined;
  } else {
  }
// compiled if node returning if8341 (depth = 4)
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8350 = alloc_Boolean(0);
// compiled identifier node returning bool8350 (depth = 4)
  gc_frame_end(frame);
  return bool8350;
}
Object meth_ast_isFieldDec8351(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isFieldDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isFieldDec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isFieldDec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8354 == NULL) {
    strlit8354 = alloc_String("object");
    gc_root(strlit8354);
  }
// compiled string node returning strlit8354 (depth = 6)
  int op_slot_right_8353 = gc_frame_newslot(strlit8354);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8356 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8357 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8358 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8357);
// compiled call node returning call8358 (depth = 9)
// compiled member node returning call8358 (depth = 8)
  partcv[0] = 0;
  Object call8359 = callmethod(call8358, "kind",
    1, partcv, params);
  gc_frame_end(callframe8356);
// compiled call node returning call8359 (depth = 7)
// compiled member node returning call8359 (depth = 6)
  int op_slot_left_8353 = gc_frame_newslot(call8359);
  params[0] = strlit8354;
  partcv[0] = 1;
  Object opresult8360 = callmethod(call8359, "==", 1, partcv, params);
// compiled op node returning opresult8360 (depth = 5)
  Object if8352 = done;
  if (istrue(opresult8360)) {
// starting to compile identifier node (depth = 5)
  Object bool8361 = alloc_Boolean(1);
// compiled identifier node returning bool8361 (depth = 5)
    gc_frame_newslot(bool8361);
    if8352 = bool8361;
  } else {
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8364 == NULL) {
    strlit8364 = alloc_String("class");
    gc_root(strlit8364);
  }
// compiled string node returning strlit8364 (depth = 7)
  int op_slot_right_8363 = gc_frame_newslot(strlit8364);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8366 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8367 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8368 = callmethodflags(self, "parent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8367);
// compiled call node returning call8368 (depth = 10)
// compiled member node returning call8368 (depth = 9)
  partcv[0] = 0;
  Object call8369 = callmethod(call8368, "kind",
    1, partcv, params);
  gc_frame_end(callframe8366);
// compiled call node returning call8369 (depth = 8)
// compiled member node returning call8369 (depth = 7)
  int op_slot_left_8363 = gc_frame_newslot(call8369);
  params[0] = strlit8364;
  partcv[0] = 1;
  Object opresult8370 = callmethod(call8369, "==", 1, partcv, params);
// compiled op node returning opresult8370 (depth = 6)
  Object if8362 = done;
  if (istrue(opresult8370)) {
// starting to compile identifier node (depth = 6)
  Object bool8371 = alloc_Boolean(1);
// compiled identifier node returning bool8371 (depth = 6)
    gc_frame_newslot(bool8371);
    if8362 = bool8371;
  } else {
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool8372 = alloc_Boolean(0);
// compiled identifier node returning bool8372 (depth = 6)
    gc_frame_newslot(bool8372);
    if8362 = bool8372;
  }
// compiled if node returning if8362 (depth = 5)
    gc_frame_newslot(if8362);
    if8352 = if8362;
  }
// compiled if node returning if8352 (depth = 4)
  gc_frame_end(frame);
  return if8352;
}
Object meth_ast_usesAsType8373(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8375 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8376 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8375);
// compiled call node returning call8376 (depth = 6)
// compiled member node returning call8376 (depth = 5)
  int op_slot_right_8374 = gc_frame_newslot(call8376);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_8374 = gc_frame_newslot(*var_aNode);
  params[0] = call8376;
  partcv[0] = 1;
  Object opresult8378 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8378 (depth = 4)
  gc_frame_end(frame);
  return opresult8378;
}
Object meth_ast_accept_40__41_from8379(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8381 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8382 = callmethod(*var_visitor, "visitVarDec()up",
    2, partcv, params);
  gc_frame_end(callframe8381);
// compiled call node returning call8382 (depth = 5)
  Object if8380 = done;
  if (istrue(call8382)) {
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8383 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8385 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8384);
// compiled call node returning call8385 (depth = 7)
// compiled member node returning call8385 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8386 = callmethod(call8385, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8383);
// compiled call node returning call8386 (depth = 5)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool8389 = alloc_Boolean(0);
// compiled identifier node returning bool8389 (depth = 7)
  int op_slot_right_8388 = gc_frame_newslot(bool8389);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8391 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8392 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8391);
// compiled call node returning call8392 (depth = 8)
// compiled member node returning call8392 (depth = 7)
  int op_slot_left_8388 = gc_frame_newslot(call8392);
  params[0] = bool8389;
  partcv[0] = 1;
  Object opresult8393 = callmethod(call8392, "!=", 1, partcv, params);
// compiled op node returning opresult8393 (depth = 6)
  Object if8387 = done;
  if (istrue(opresult8393)) {
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8394 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8396 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8395);
// compiled call node returning call8396 (depth = 8)
// compiled member node returning call8396 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8397 = callmethod(call8396, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8394);
// compiled call node returning call8397 (depth = 6)
    gc_frame_newslot(call8397);
    if8387 = call8397;
  } else {
  }
// compiled if node returning if8387 (depth = 5)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool8400 = alloc_Boolean(0);
// compiled identifier node returning bool8400 (depth = 7)
  int op_slot_right_8399 = gc_frame_newslot(bool8400);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8402 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8403 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8402);
// compiled call node returning call8403 (depth = 8)
// compiled member node returning call8403 (depth = 7)
  int op_slot_left_8399 = gc_frame_newslot(call8403);
  params[0] = bool8400;
  partcv[0] = 1;
  Object opresult8404 = callmethod(call8403, "!=", 1, partcv, params);
// compiled op node returning opresult8404 (depth = 6)
  Object if8398 = done;
  if (istrue(opresult8404)) {
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8405 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8406 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8407 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8406);
// compiled call node returning call8407 (depth = 8)
// compiled member node returning call8407 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8408 = callmethod(call8407, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8405);
// compiled call node returning call8408 (depth = 6)
    gc_frame_newslot(call8408);
    if8398 = call8408;
  } else {
  }
// compiled if node returning if8398 (depth = 5)
    gc_frame_newslot(if8398);
    if8380 = if8398;
  } else {
  }
// compiled if node returning if8380 (depth = 4)
  gc_frame_end(frame);
  return if8380;
}
Object meth_ast_map_40__41_parent8409(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8410 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call8411 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8410);
// compiled call node returning call8411 (depth = 5)
  *var_n = call8411;
  if (call8411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8412 = gc_frame_new();
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8413 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8415 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8414);
// compiled call node returning call8415 (depth = 8)
// compiled member node returning call8415 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8416 = callmethod(call8415, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe8413);
// compiled call node returning call8416 (depth = 6)
  gc_frame_newslot(call8416);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8416;
  partcv[0] = 1;
  Object call8417 = callmethod(*var_n, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8412);
// compiled call node returning call8417 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8418 = gc_frame_new();
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8419 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8421 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8420);
// compiled call node returning call8421 (depth = 8)
// compiled member node returning call8421 (depth = 7)
  gc_frame_newslot(call8421);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8422 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8423 = gc_frame_new();
// call case 3: self.outer request
  Object call8424 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8423);
// compiled call node returning call8424 (depth = 10)
// compiled member node returning call8424 (depth = 9)
  partcv[0] = 0;
  Object call8425 = callmethodflags(call8424, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8422);
// compiled call node returning call8425 (depth = 8)
// compiled member node returning call8425 (depth = 7)
  params[0] = call8421;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8426 = callmethodflags(call8425, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8419);
// compiled call node returning call8426 (depth = 6)
  gc_frame_newslot(call8426);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8426;
  partcv[0] = 1;
  Object call8427 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8418);
// compiled call node returning call8427 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8428 = gc_frame_new();
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8429 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8430 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8431 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8430);
// compiled call node returning call8431 (depth = 8)
// compiled member node returning call8431 (depth = 7)
  gc_frame_newslot(call8431);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8432 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8433 = gc_frame_new();
// call case 3: self.outer request
  Object call8434 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8433);
// compiled call node returning call8434 (depth = 10)
// compiled member node returning call8434 (depth = 9)
  partcv[0] = 0;
  Object call8435 = callmethodflags(call8434, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8432);
// compiled call node returning call8435 (depth = 8)
// compiled member node returning call8435 (depth = 7)
  params[0] = call8431;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8436 = callmethodflags(call8435, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8429);
// compiled call node returning call8436 (depth = 6)
  gc_frame_newslot(call8436);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8436;
  partcv[0] = 1;
  Object call8437 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8428);
// compiled call node returning call8437 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8438 = gc_frame_new();
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8439 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8440 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8441 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8440);
// compiled call node returning call8441 (depth = 8)
// compiled member node returning call8441 (depth = 7)
  gc_frame_newslot(call8441);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8442 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8443 = gc_frame_new();
// call case 3: self.outer request
  Object call8444 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8443);
// compiled call node returning call8444 (depth = 10)
// compiled member node returning call8444 (depth = 9)
  partcv[0] = 0;
  Object call8445 = callmethodflags(call8444, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8442);
// compiled call node returning call8445 (depth = 8)
// compiled member node returning call8445 (depth = 7)
  params[0] = call8441;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8446 = callmethodflags(call8445, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8439);
// compiled call node returning call8446 (depth = 6)
  gc_frame_newslot(call8446);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8446;
  partcv[0] = 1;
  Object call8447 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8438);
// compiled call node returning call8447 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8448 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8449 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8448);
// compiled call node returning call8449 (depth = 5)
  *var_n = call8449;
  if (call8449 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply8459(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit8461 == NULL) {
    strlit8461 = alloc_String("  ");
    gc_root(strlit8461);
  }
// compiled string node returning strlit8461 (depth = 8)
  int op_slot_right_8460 = gc_frame_newslot(strlit8461);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8460 = gc_frame_newslot(*var_spc);
  params[0] = strlit8461;
  partcv[0] = 1;
  Object opresult8463 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8463 (depth = 7)
  *var_spc = opresult8463;
  if (opresult8463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8452 == NULL) {
    strlit8452 = alloc_String("");
    gc_root(strlit8452);
  }
// compiled string node returning strlit8452 (depth = 5)
  *var_spc = strlit8452;
  if (strlit8452 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8453 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_8454 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num8456 = alloc_Float64(0);
// compiled num node returning num8456 (depth = 6)
  int op_slot_left_8454 = gc_frame_newslot(num8456);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8457 = callmethod(num8456, "..", 1, partcv, params);
// compiled op node returning opresult8457 (depth = 5)
  gc_frame_newslot(opresult8457);
// starting to compile block node (depth = 5)
  Object block8458 = alloc_Block(NULL, NULL, "ast", 2004);
  gc_frame_newslot(block8458);
// method _apply
  block_savedest(block8458);
  Object closure8459 = createclosure(2, "_apply");
  setclosureframe(closure8459, stackframe);
  addtoclosure(closure8459, var_spc);
  addtoclosure(closure8459, selfslot);
  struct UserObject *uo8459 = (struct UserObject*)block8458;
  uo8459->data[0] = (Object)closure8459;
  Method *meth_meth_ast__apply8459 = addmethod2pos(block8458, "_apply", &meth_ast__apply8459, 0);
  int argcv_meth_ast__apply8459[] = {1};
  meth_meth_ast__apply8459->type = alloc_MethodType(1, argcv_meth_ast__apply8459);
  meth_meth_ast__apply8459->definitionModule = modulename;
  meth_meth_ast__apply8459->definitionLine = 1998;
// compiled block node returning block8458 (depth = 5)
  gc_frame_newslot(block8458);
// call case 5: prelude request
  params[0] = opresult8457;
  params[1] = block8458;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8466 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8453);
// compiled call node returning call8466 (depth = 4)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8468 == NULL) {
    strlit8468 = alloc_String("""\x0a""");
    gc_root(strlit8468);
  }
// compiled string node returning strlit8468 (depth = 6)
  int op_slot_right_8467 = gc_frame_newslot(strlit8468);
// starting to compile call node (depth = 6)
  int callframe8470 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8471 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8470);
// compiled call node returning call8471 (depth = 6)
  int op_slot_left_8467 = gc_frame_newslot(call8471);
  params[0] = strlit8468;
  partcv[0] = 1;
  Object opresult8472 = callmethod(call8471, "++", 1, partcv, params);
// compiled op node returning opresult8472 (depth = 5)
  *var_s = opresult8472;
  if (opresult8472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8474 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8476 = alloc_Float64(1);
// compiled num node returning num8476 (depth = 8)
  int op_slot_right_8475 = gc_frame_newslot(num8476);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_8475 = gc_frame_newslot(*var_depth);
  params[0] = num8476;
  partcv[0] = 1;
  Object sum8478 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8478 (depth = 7)
  gc_frame_newslot(sum8478);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8479 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8480 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8479);
// compiled call node returning call8480 (depth = 8)
// compiled member node returning call8480 (depth = 7)
  params[0] = sum8478;
  partcv[0] = 1;
  Object call8481 = callmethod(call8480, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8474);
// compiled call node returning call8481 (depth = 6)
  int op_slot_right_8473 = gc_frame_newslot(call8481);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_8483 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8483 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8485 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8485 (depth = 6)
  int op_slot_left_8473 = gc_frame_newslot(opresult8485);
  params[0] = call8481;
  partcv[0] = 1;
  Object opresult8486 = callmethod(opresult8485, "++", 1, partcv, params);
// compiled op node returning opresult8486 (depth = 5)
  *var_s = opresult8486;
  if (opresult8486 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8490 = alloc_Boolean(0);
// compiled identifier node returning bool8490 (depth = 6)
  int op_slot_right_8489 = gc_frame_newslot(bool8490);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8492 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8493 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8492);
// compiled call node returning call8493 (depth = 7)
// compiled member node returning call8493 (depth = 6)
  int op_slot_left_8489 = gc_frame_newslot(call8493);
  params[0] = bool8490;
  partcv[0] = 1;
  Object opresult8494 = callmethod(call8493, "!=", 1, partcv, params);
// compiled op node returning opresult8494 (depth = 5)
  Object if8488 = done;
  if (istrue(opresult8494)) {
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8496 == NULL) {
    strlit8496 = alloc_String("Type: ");
    gc_root(strlit8496);
  }
// compiled string node returning strlit8496 (depth = 7)
  int op_slot_right_8495 = gc_frame_newslot(strlit8496);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8498 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8501 == NULL) {
    strlit8501 = alloc_String("""\x0a""");
    gc_root(strlit8501);
  }
// compiled string node returning strlit8501 (depth = 9)
  int op_slot_right_8500 = gc_frame_newslot(strlit8501);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8500 = gc_frame_newslot(*var_s);
  params[0] = strlit8501;
  partcv[0] = 1;
  Object opresult8503 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8503 (depth = 8)
  int op_slot_left_8498 = gc_frame_newslot(opresult8503);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8504 = callmethod(opresult8503, "++", 1, partcv, params);
// compiled op node returning opresult8504 (depth = 7)
  int op_slot_left_8495 = gc_frame_newslot(opresult8504);
  params[0] = strlit8496;
  partcv[0] = 1;
  Object opresult8505 = callmethod(opresult8504, "++", 1, partcv, params);
// compiled op node returning opresult8505 (depth = 6)
  *var_s = opresult8505;
  if (opresult8505 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8508 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8510 = alloc_Float64(2);
// compiled num node returning num8510 (depth = 9)
  int op_slot_right_8509 = gc_frame_newslot(num8510);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_8509 = gc_frame_newslot(*var_depth);
  params[0] = num8510;
  partcv[0] = 1;
  Object sum8512 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8512 (depth = 8)
  gc_frame_newslot(sum8512);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8513 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8514 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8513);
// compiled call node returning call8514 (depth = 9)
// compiled member node returning call8514 (depth = 8)
  params[0] = sum8512;
  partcv[0] = 1;
  Object call8515 = callmethod(call8514, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8508);
// compiled call node returning call8515 (depth = 7)
  int op_slot_right_8507 = gc_frame_newslot(call8515);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8507 = gc_frame_newslot(*var_s);
  params[0] = call8515;
  partcv[0] = 1;
  Object opresult8517 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8517 (depth = 6)
  *var_s = opresult8517;
  if (opresult8517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8488 = done;
  } else {
  }
// compiled if node returning if8488 (depth = 4)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8522 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8521);
// compiled call node returning call8522 (depth = 7)
// compiled member node returning call8522 (depth = 6)
  int op_slot_right_8520 = gc_frame_newslot(call8522);
// starting to compile identifier node (depth = 6)
  Object bool8524 = alloc_Boolean(0);
// compiled identifier node returning bool8524 (depth = 6)
  int op_slot_left_8520 = gc_frame_newslot(bool8524);
  params[0] = call8522;
  partcv[0] = 1;
  Object opresult8525 = callmethod(bool8524, "!=", 1, partcv, params);
// compiled op node returning opresult8525 (depth = 5)
  Object if8519 = done;
  if (istrue(opresult8525)) {
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8527 == NULL) {
    strlit8527 = alloc_String("Value: ");
    gc_root(strlit8527);
  }
// compiled string node returning strlit8527 (depth = 7)
  int op_slot_right_8526 = gc_frame_newslot(strlit8527);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_right_8529 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8532 == NULL) {
    strlit8532 = alloc_String("""\x0a""");
    gc_root(strlit8532);
  }
// compiled string node returning strlit8532 (depth = 9)
  int op_slot_right_8531 = gc_frame_newslot(strlit8532);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_left_8531 = gc_frame_newslot(*var_s);
  params[0] = strlit8532;
  partcv[0] = 1;
  Object opresult8534 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8534 (depth = 8)
  int op_slot_left_8529 = gc_frame_newslot(opresult8534);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8535 = callmethod(opresult8534, "++", 1, partcv, params);
// compiled op node returning opresult8535 (depth = 7)
  int op_slot_left_8526 = gc_frame_newslot(opresult8535);
  params[0] = strlit8527;
  partcv[0] = 1;
  Object opresult8536 = callmethod(opresult8535, "++", 1, partcv, params);
// compiled op node returning opresult8536 (depth = 6)
  *var_s = opresult8536;
  if (opresult8536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8539 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8541 = alloc_Float64(2);
// compiled num node returning num8541 (depth = 9)
  int op_slot_right_8540 = gc_frame_newslot(num8541);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_depth (depth = 9)
  int op_slot_left_8540 = gc_frame_newslot(*var_depth);
  params[0] = num8541;
  partcv[0] = 1;
  Object sum8543 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum8543 (depth = 8)
  gc_frame_newslot(sum8543);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8544 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8545 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8544);
// compiled call node returning call8545 (depth = 9)
// compiled member node returning call8545 (depth = 8)
  params[0] = sum8543;
  partcv[0] = 1;
  Object call8546 = callmethod(call8545, "pretty",
    1, partcv, params);
  gc_frame_end(callframe8539);
// compiled call node returning call8546 (depth = 7)
  int op_slot_right_8538 = gc_frame_newslot(call8546);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8538 = gc_frame_newslot(*var_s);
  params[0] = call8546;
  partcv[0] = 1;
  Object opresult8548 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8548 (depth = 6)
  *var_s = opresult8548;
  if (opresult8548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8519 = done;
  } else {
  }
// compiled if node returning if8519 (depth = 4)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply8562(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit8564 == NULL) {
    strlit8564 = alloc_String("    ");
    gc_root(strlit8564);
  }
// compiled string node returning strlit8564 (depth = 8)
  int op_slot_right_8563 = gc_frame_newslot(strlit8564);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8563 = gc_frame_newslot(*var_spc);
  params[0] = strlit8564;
  partcv[0] = 1;
  Object opresult8566 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8566 (depth = 7)
  *var_spc = opresult8566;
  if (opresult8566 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply8623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8625 = gc_frame_new();
// starting to compile num node (depth = 11)
  Object num8626 = alloc_Float64(0);
// compiled num node returning num8626 (depth = 11)
  gc_frame_newslot(num8626);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_b (depth = 11)
  params[0] = num8626;
  partcv[0] = 1;
  Object call8627 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8625);
// compiled call node returning call8627 (depth = 10)
  int op_slot_right_8624 = gc_frame_newslot(call8627);
// starting to compile if node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit8631 == NULL) {
    strlit8631 = alloc_String("");
    gc_root(strlit8631);
  }
// compiled string node returning strlit8631 (depth = 12)
  int op_slot_right_8630 = gc_frame_newslot(strlit8631);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_8630 = gc_frame_newslot(*var_a);
  params[0] = strlit8631;
  partcv[0] = 1;
  Object opresult8633 = callmethod(*var_a, "!=", 1, partcv, params);
// compiled op node returning opresult8633 (depth = 11)
  Object if8629 = done;
struct StackFrameObject *iftmpstackframe8629 = stackframe;
  if (istrue(opresult8633)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8629);
gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit8635 == NULL) {
    strlit8635 = alloc_String(", ");
    gc_root(strlit8635);
  }
// compiled string node returning strlit8635 (depth = 12)
  int op_slot_right_8634 = gc_frame_newslot(strlit8635);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  int op_slot_left_8634 = gc_frame_newslot(*var_a);
  params[0] = strlit8635;
  partcv[0] = 1;
  Object opresult8637 = callmethod(*var_a, "++", 1, partcv, params);
// compiled op node returning opresult8637 (depth = 11)
    gc_frame_newslot(opresult8637);
    if8629 = opresult8637;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8629);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 11)
  if (strlit8638 == NULL) {
    strlit8638 = alloc_String("");
    gc_root(strlit8638);
  }
// compiled string node returning strlit8638 (depth = 11)
    gc_frame_newslot(strlit8638);
    if8629 = strlit8638;
  }
stackframe = iftmpstackframe8629;
// compiled if node returning if8629 (depth = 10)
  int op_slot_left_8624 = gc_frame_newslot(if8629);
  params[0] = call8627;
  partcv[0] = 1;
  Object opresult8639 = callmethod(if8629, "++", 1, partcv, params);
// compiled op node returning opresult8639 (depth = 9)
  gc_frame_end(frame);
  return opresult8639;
}
Object meth_ast_toGrace8550(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8551 == NULL) {
    strlit8551 = alloc_String("");
    gc_root(strlit8551);
  }
// compiled string node returning strlit8551 (depth = 5)
  *var_spc = strlit8551;
  if (strlit8551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8552 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num8555 = alloc_Float64(1);
// compiled num node returning num8555 (depth = 7)
  int op_slot_right_8554 = gc_frame_newslot(num8555);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  int op_slot_left_8554 = gc_frame_newslot(*var_depth);
  params[0] = num8555;
  partcv[0] = 1;
  Object diff8557 = callmethod(*var_depth, "-", 1, partcv, params);
// compiled op node returning diff8557 (depth = 6)
  int op_slot_right_8553 = gc_frame_newslot(diff8557);
// starting to compile num node (depth = 6)
  Object num8559 = alloc_Float64(0);
// compiled num node returning num8559 (depth = 6)
  int op_slot_left_8553 = gc_frame_newslot(num8559);
  params[0] = diff8557;
  partcv[0] = 1;
  Object opresult8560 = callmethod(num8559, "..", 1, partcv, params);
// compiled op node returning opresult8560 (depth = 5)
  gc_frame_newslot(opresult8560);
// starting to compile block node (depth = 5)
  Object block8561 = alloc_Block(NULL, NULL, "ast", 2021);
  gc_frame_newslot(block8561);
// method _apply
  block_savedest(block8561);
  Object closure8562 = createclosure(2, "_apply");
  setclosureframe(closure8562, stackframe);
  addtoclosure(closure8562, var_spc);
  addtoclosure(closure8562, selfslot);
  struct UserObject *uo8562 = (struct UserObject*)block8561;
  uo8562->data[0] = (Object)closure8562;
  Method *meth_meth_ast__apply8562 = addmethod2pos(block8561, "_apply", &meth_ast__apply8562, 0);
  int argcv_meth_ast__apply8562[] = {1};
  meth_meth_ast__apply8562->type = alloc_MethodType(1, argcv_meth_ast__apply8562);
  meth_meth_ast__apply8562->definitionModule = modulename;
  meth_meth_ast__apply8562->definitionLine = 2015;
// compiled block node returning block8561 (depth = 5)
  gc_frame_newslot(block8561);
// call case 5: prelude request
  params[0] = opresult8560;
  params[1] = block8561;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8569 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8552);
// compiled call node returning call8569 (depth = 4)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8571 == NULL) {
    strlit8571 = alloc_String("");
    gc_root(strlit8571);
  }
// compiled string node returning strlit8571 (depth = 6)
  int op_slot_right_8570 = gc_frame_newslot(strlit8571);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8574 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8575 = alloc_Float64(0);
// compiled num node returning num8575 (depth = 8)
  gc_frame_newslot(num8575);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8577 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8576);
// compiled call node returning call8577 (depth = 9)
// compiled member node returning call8577 (depth = 8)
  params[0] = num8575;
  partcv[0] = 1;
  Object call8578 = callmethod(call8577, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8574);
// compiled call node returning call8578 (depth = 7)
  int op_slot_right_8573 = gc_frame_newslot(call8578);
// starting to compile string node (depth = 7)
  if (strlit8580 == NULL) {
    strlit8580 = alloc_String("var ");
    gc_root(strlit8580);
  }
// compiled string node returning strlit8580 (depth = 7)
  int op_slot_left_8573 = gc_frame_newslot(strlit8580);
  params[0] = call8578;
  partcv[0] = 1;
  Object opresult8581 = callmethod(strlit8580, "++", 1, partcv, params);
// compiled op node returning opresult8581 (depth = 6)
  int op_slot_left_8570 = gc_frame_newslot(opresult8581);
  params[0] = strlit8571;
  partcv[0] = 1;
  Object opresult8582 = callmethod(opresult8581, "++", 1, partcv, params);
// compiled op node returning opresult8582 (depth = 5)
  *var_s = opresult8582;
  if (opresult8582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8585 == NULL) {
    strlit8585 = alloc_String("Unknown");
    gc_root(strlit8585);
  }
// compiled string node returning strlit8585 (depth = 6)
  int op_slot_right_8584 = gc_frame_newslot(strlit8585);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8587 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8589 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8588);
// compiled call node returning call8589 (depth = 9)
// compiled member node returning call8589 (depth = 8)
  partcv[0] = 0;
  Object call8590 = callmethod(call8589, "value",
    1, partcv, params);
  gc_frame_end(callframe8587);
// compiled call node returning call8590 (depth = 7)
// compiled member node returning call8590 (depth = 6)
  int op_slot_left_8584 = gc_frame_newslot(call8590);
  params[0] = strlit8585;
  partcv[0] = 1;
  Object opresult8591 = callmethod(call8590, "!=", 1, partcv, params);
// compiled op node returning opresult8591 (depth = 5)
  Object if8583 = done;
  if (istrue(opresult8591)) {
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8593 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num8594 = alloc_Float64(0);
// compiled num node returning num8594 (depth = 8)
  gc_frame_newslot(num8594);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8595 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8596 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8595);
// compiled call node returning call8596 (depth = 9)
// compiled member node returning call8596 (depth = 8)
  params[0] = num8594;
  partcv[0] = 1;
  Object call8597 = callmethod(call8596, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8593);
// compiled call node returning call8597 (depth = 7)
  int op_slot_right_8592 = gc_frame_newslot(call8597);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8600 == NULL) {
    strlit8600 = alloc_String(" : ");
    gc_root(strlit8600);
  }
// compiled string node returning strlit8600 (depth = 8)
  int op_slot_right_8599 = gc_frame_newslot(strlit8600);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8599 = gc_frame_newslot(*var_s);
  params[0] = strlit8600;
  partcv[0] = 1;
  Object opresult8602 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8602 (depth = 7)
  int op_slot_left_8592 = gc_frame_newslot(opresult8602);
  params[0] = call8597;
  partcv[0] = 1;
  Object opresult8603 = callmethod(opresult8602, "++", 1, partcv, params);
// compiled op node returning opresult8603 (depth = 6)
  *var_s = opresult8603;
  if (opresult8603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8583 = done;
  } else {
  }
// compiled if node returning if8583 (depth = 4)
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8607 = alloc_Float64(0);
// compiled num node returning num8607 (depth = 6)
  int op_slot_right_8606 = gc_frame_newslot(num8607);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8609 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8610 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8611 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8610);
// compiled call node returning call8611 (depth = 9)
// compiled member node returning call8611 (depth = 8)
  partcv[0] = 0;
  Object call8612 = callmethod(call8611, "size",
    1, partcv, params);
  gc_frame_end(callframe8609);
// compiled call node returning call8612 (depth = 7)
// compiled member node returning call8612 (depth = 6)
  int op_slot_left_8606 = gc_frame_newslot(call8612);
  params[0] = num8607;
  partcv[0] = 1;
  Object opresult8613 = callmethod(call8612, ">", 1, partcv, params);
// compiled op node returning opresult8613 (depth = 5)
  Object if8605 = done;
  if (istrue(opresult8613)) {
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit8615 == NULL) {
    strlit8615 = alloc_String(" is ");
    gc_root(strlit8615);
  }
// compiled string node returning strlit8615 (depth = 7)
  int op_slot_right_8614 = gc_frame_newslot(strlit8615);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8614 = gc_frame_newslot(*var_s);
  params[0] = strlit8615;
  partcv[0] = 1;
  Object opresult8617 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8617 (depth = 6)
  *var_s = opresult8617;
  if (opresult8617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8620 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8621 == NULL) {
    strlit8621 = alloc_String("");
    gc_root(strlit8621);
  }
// compiled string node returning strlit8621 (depth = 8)
  gc_frame_newslot(strlit8621);
// starting to compile block node (depth = 8)
  Object block8622 = alloc_Block(NULL, NULL, "ast", 2030);
  gc_frame_newslot(block8622);
// method _apply
  block_savedest(block8622);
  Object closure8623 = createclosure(1, "_apply");
  setclosureframe(closure8623, stackframe);
  addtoclosure(closure8623, selfslot);
  struct UserObject *uo8623 = (struct UserObject*)block8622;
  uo8623->data[0] = (Object)closure8623;
  Method *meth_meth_ast__apply8623 = addmethod2pos(block8622, "_apply", &meth_ast__apply8623, 0);
  int argcv_meth_ast__apply8623[] = {2};
  meth_meth_ast__apply8623->type = alloc_MethodType(1, argcv_meth_ast__apply8623);
  meth_meth_ast__apply8623->definitionModule = modulename;
  meth_meth_ast__apply8623->definitionLine = 2028;
// compiled block node returning block8622 (depth = 8)
  gc_frame_newslot(block8622);
// call case 6: other member request
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8641 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8642 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8641);
// compiled call node returning call8642 (depth = 9)
// compiled member node returning call8642 (depth = 8)
  params[0] = strlit8621;
  params[1] = block8622;
  partcv[0] = 2;
  Object call8643 = callmethod(call8642, "reduce",
    1, partcv, params);
  gc_frame_end(callframe8620);
// compiled call node returning call8643 (depth = 7)
  int op_slot_right_8619 = gc_frame_newslot(call8643);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8619 = gc_frame_newslot(*var_s);
  params[0] = call8643;
  partcv[0] = 1;
  Object opresult8645 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8645 (depth = 6)
  *var_s = opresult8645;
  if (opresult8645 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8605 = done;
  } else {
  }
// compiled if node returning if8605 (depth = 4)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8649 = alloc_Boolean(0);
// compiled identifier node returning bool8649 (depth = 6)
  int op_slot_right_8648 = gc_frame_newslot(bool8649);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8652 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8651);
// compiled call node returning call8652 (depth = 7)
// compiled member node returning call8652 (depth = 6)
  int op_slot_left_8648 = gc_frame_newslot(call8652);
  params[0] = bool8649;
  partcv[0] = 1;
  Object opresult8653 = callmethod(call8652, "!=", 1, partcv, params);
// compiled op node returning opresult8653 (depth = 5)
  Object if8647 = done;
  if (istrue(opresult8653)) {
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8655 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8657 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8656);
// compiled call node returning call8657 (depth = 9)
// compiled member node returning call8657 (depth = 8)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8658 = callmethod(call8657, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe8655);
// compiled call node returning call8658 (depth = 7)
  int op_slot_right_8654 = gc_frame_newslot(call8658);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8661 == NULL) {
    strlit8661 = alloc_String(" := ");
    gc_root(strlit8661);
  }
// compiled string node returning strlit8661 (depth = 8)
  int op_slot_right_8660 = gc_frame_newslot(strlit8661);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_8660 = gc_frame_newslot(*var_s);
  params[0] = strlit8661;
  partcv[0] = 1;
  Object opresult8663 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8663 (depth = 7)
  int op_slot_left_8654 = gc_frame_newslot(opresult8663);
  params[0] = call8658;
  partcv[0] = 1;
  Object opresult8664 = callmethod(opresult8663, "++", 1, partcv, params);
// compiled op node returning opresult8664 (depth = 6)
  *var_s = opresult8664;
  if (opresult8664 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8647 = done;
  } else {
  }
// compiled if node returning if8647 (depth = 4)
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent8666(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8667 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8668 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8670 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8669);
// compiled call node returning call8670 (depth = 7)
// compiled member node returning call8670 (depth = 6)
  gc_frame_newslot(call8670);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8671 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8672 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8671);
// compiled call node returning call8672 (depth = 7)
// compiled member node returning call8672 (depth = 6)
  gc_frame_newslot(call8672);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8673 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8674 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8673);
// compiled call node returning call8674 (depth = 7)
// compiled member node returning call8674 (depth = 6)
  gc_frame_newslot(call8674);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varDecNode (depth = 6)
  params[0] = call8670;
  params[1] = call8672;
  params[2] = call8674;
  partcv[0] = 3;
  Object call8675 = callmethod(*var_varDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8668);
// compiled call node returning call8675 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8676 = callmethod(call8675, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe8667);
// compiled call node returning call8676 (depth = 4)
  gc_frame_end(frame);
  return call8676;
}
Object meth_ast_new8255(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8256 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8256 = alloc_userobj2(21,18, objclass8256);
  gc_frame_newslot(obj8256);
if (objclass8256 == NULL) {
  glfree(obj8256->class->name);
  obj8256->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8256, self, 0);
  addmethodreal(obj8256,"outer", &reader_ast_outer_8257);
  Object oldself8256 = self;
  struct StackFrameObject *oldstackframe8256 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8256);
  gc_frame_newslot((Object)stackframe);
  self = obj8256;
  Object *oldselfslot8256 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8256 = (*(struct UserObject *)self).data[0], lowerouter8256 = thisouter8256;
  if (inheritingObject8256) {
    struct UserObject *inho8256 = (struct UserObject *)inheritingObject8256;
    while (inho8256->super != GraceDefaultObject) inho8256 = (struct UserObject *)inho8256->super;
    inho8256->super = obj8256;
    self = inheritingObject8256;
    *selfslot = self;
    lowerouter8256 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8256;
  }
if (objclass8256 == NULL) {
  Method *reader8258 = addmethodrealflags(obj8256, "kind",&reader_ast_kind_8258, MFLAG_DEF);
  reader8258->definitionModule = modulename;
  reader8258->definitionLine = 1950;
}
adddatum2(obj8256, alloc_Undefined(), 1);
if (objclass8256 == NULL) {
  Method *reader8259 = addmethodrealflags(obj8256, "name",&reader_ast_name_8259, 0);
  Method *writer8259 = addmethodrealflags(obj8256, "name:=",&writer_ast_name_8259, 0);
  reader8259->definitionModule = modulename;
  writer8259->definitionModule = modulename;
  reader8259->definitionLine = 1951;
  writer8259->definitionLine = 1951;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 2);
if (objclass8256 == NULL) {
  Method *reader8260 = addmethodrealflags(obj8256, "value",&reader_ast_value_8260, 0);
  Method *writer8260 = addmethodrealflags(obj8256, "value:=",&writer_ast_value_8260, 0);
  reader8260->definitionModule = modulename;
  writer8260->definitionModule = modulename;
  reader8260->definitionLine = 1952;
  writer8260->definitionLine = 1952;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 3);
if (objclass8256 == NULL) {
  Method *reader8261 = addmethodrealflags(obj8256, "dtype",&reader_ast_dtype_8261, 0);
  Method *writer8261 = addmethodrealflags(obj8256, "dtype:=",&writer_ast_dtype_8261, 0);
  reader8261->definitionModule = modulename;
  writer8261->definitionModule = modulename;
  reader8261->definitionLine = 1953;
  writer8261->definitionLine = 1953;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 4);
if (objclass8256 == NULL) {
  Method *reader8262 = addmethodrealflags(obj8256, "nameString",&reader_ast_nameString_8262, MFLAG_DEF);
  reader8262->definitionModule = modulename;
  reader8262->definitionLine = 1954;
}
adddatum2(obj8256, alloc_Undefined(), 5);
if (objclass8256 == NULL) {
  Method *reader8263 = addmethodrealflags(obj8256, "annotations",&reader_ast_annotations_8263, 0);
  Method *writer8263 = addmethodrealflags(obj8256, "annotations:=",&writer_ast_annotations_8263, 0);
  reader8263->definitionModule = modulename;
  writer8263->definitionModule = modulename;
  reader8263->definitionLine = 1956;
  writer8263->definitionLine = 1956;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 6);
// method isPublic
  struct UserObject *uo8264 = (struct UserObject*)obj8256;
  uo8264->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8264 = addmethod2pos(obj8256, "isPublic", &meth_ast_isPublic8264, 7);
  int argcv_meth_ast_isPublic8264[] = {0};
  meth_meth_ast_isPublic8264->type = alloc_MethodType(1, argcv_meth_ast_isPublic8264);
  meth_meth_ast_isPublic8264->definitionModule = modulename;
  meth_meth_ast_isPublic8264->definitionLine = 1956;
// method isWritable
  struct UserObject *uo8291 = (struct UserObject*)obj8256;
  uo8291->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8291 = addmethod2pos(obj8256, "isWritable", &meth_ast_isWritable8291, 8);
  int argcv_meth_ast_isWritable8291[] = {0};
  meth_meth_ast_isWritable8291->type = alloc_MethodType(1, argcv_meth_ast_isWritable8291);
  meth_meth_ast_isWritable8291->definitionModule = modulename;
  meth_meth_ast_isWritable8291->definitionLine = 1962;
// method isReadable
  struct UserObject *uo8321 = (struct UserObject*)obj8256;
  uo8321->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8321 = addmethod2pos(obj8256, "isReadable", &meth_ast_isReadable8321, 9);
  int argcv_meth_ast_isReadable8321[] = {0};
  meth_meth_ast_isReadable8321->type = alloc_MethodType(1, argcv_meth_ast_isReadable8321);
  meth_meth_ast_isReadable8321->definitionModule = modulename;
  meth_meth_ast_isReadable8321->definitionLine = 1968;
// method isFieldDec
  struct UserObject *uo8351 = (struct UserObject*)obj8256;
  uo8351->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8351 = addmethod2pos(obj8256, "isFieldDec", &meth_ast_isFieldDec8351, 10);
  int argcv_meth_ast_isFieldDec8351[] = {0};
  meth_meth_ast_isFieldDec8351->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8351);
  meth_meth_ast_isFieldDec8351->definitionModule = modulename;
  meth_meth_ast_isFieldDec8351->definitionLine = 1974;
// method usesAsType
  struct UserObject *uo8373 = (struct UserObject*)obj8256;
  uo8373->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType8373 = addmethod2pos(obj8256, "usesAsType", &meth_ast_usesAsType8373, 11);
  int argcv_meth_ast_usesAsType8373[] = {1};
  meth_meth_ast_usesAsType8373->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8373);
  meth_meth_ast_usesAsType8373->definitionModule = modulename;
  meth_meth_ast_usesAsType8373->definitionLine = 1979;
// method accept()from
  struct UserObject *uo8379 = (struct UserObject*)obj8256;
  uo8379->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8379 = addmethod2pos(obj8256, "accept()from", &meth_ast_accept_40__41_from8379, 12);
  int argcv_meth_ast_accept_40__41_from8379[] = {1, 1};
  meth_meth_ast_accept_40__41_from8379->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8379);
  meth_meth_ast_accept_40__41_from8379->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8379->definitionLine = 1982;
// method map()parent
  struct UserObject *uo8409 = (struct UserObject*)obj8256;
  uo8409->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent8409 = addmethod2pos(obj8256, "map()parent", &meth_ast_map_40__41_parent8409, 13);
  int argcv_meth_ast_map_40__41_parent8409[] = {1, 1};
  meth_meth_ast_map_40__41_parent8409->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent8409);
  meth_meth_ast_map_40__41_parent8409->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent8409->definitionLine = 1993;
// method pretty
  struct UserObject *uo8451 = (struct UserObject*)obj8256;
  uo8451->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty8451 = addmethod2pos(obj8256, "pretty", &meth_ast_pretty8451, 14);
  int argcv_meth_ast_pretty8451[] = {1};
  meth_meth_ast_pretty8451->type = alloc_MethodType(1, argcv_meth_ast_pretty8451);
  meth_meth_ast_pretty8451->definitionModule = modulename;
  meth_meth_ast_pretty8451->definitionLine = 2002;
// method toGrace
  struct UserObject *uo8550 = (struct UserObject*)obj8256;
  uo8550->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace8550 = addmethod2pos(obj8256, "toGrace", &meth_ast_toGrace8550, 15);
  int argcv_meth_ast_toGrace8550[] = {1};
  meth_meth_ast_toGrace8550->type = alloc_MethodType(1, argcv_meth_ast_toGrace8550);
meth_meth_ast_toGrace8550->type->types[0] = type_Number;
meth_meth_ast_toGrace8550->type->names[0] = "depth";
  meth_meth_ast_toGrace8550->definitionModule = modulename;
  meth_meth_ast_toGrace8550->definitionLine = 2019;
// method shallowCopyWithParent
  block_savedest(obj8256);
  Object closure8666 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure8666, stackframe);
  addtoclosure(closure8666, var_varDecNode);
  struct UserObject *uo8666 = (struct UserObject*)obj8256;
  uo8666->data[16] = (Object)closure8666;
  Method *meth_meth_ast_shallowCopyWithParent8666 = addmethod2pos(obj8256, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent8666, 16);
  int argcv_meth_ast_shallowCopyWithParent8666[] = {1};
  meth_meth_ast_shallowCopyWithParent8666->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent8666);
  meth_meth_ast_shallowCopyWithParent8666->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent8666->definitionLine = 2038;
  sourceObject = obj8256;
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8677 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8678 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8677);
// compiled call node returning call8678 (depth = 4)
  struct UserObject *obj8256_uo = (struct UserObject *)obj8256;
  obj8256_uo->super = call8678;
  sourceObject = obj8256;
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8679 == NULL) {
    strlit8679 = alloc_String("vardec");
    gc_root(strlit8679);
  }
// compiled string node returning strlit8679 (depth = 4)
  adddatum2(obj8256, strlit8679, 1);
  sourceObject = obj8256;
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj8256, *var_name_39_, 2);
  sourceObject = obj8256;
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj8256, *var_val_39_, 3);
  sourceObject = obj8256;
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj8256, *var_dtype_39_, 4);
  sourceObject = obj8256;
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8682 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 7)
// compiled member node returning call8682 (depth = 6)
  partcv[0] = 0;
  Object call8683 = callmethod(call8682, "value",
    1, partcv, params);
  gc_frame_end(callframe8680);
// compiled call node returning call8683 (depth = 5)
// compiled member node returning call8683 (depth = 4)
  adddatum2(obj8256, call8683, 5);
  sourceObject = obj8256;
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8684 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8685 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8686 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8685);
// compiled call node returning call8686 (depth = 7)
// compiled member node returning call8686 (depth = 6)
  partcv[0] = 0;
  Object call8687 = callmethod(call8686, "empty",
    1, partcv, params);
  gc_frame_end(callframe8684);
// compiled call node returning call8687 (depth = 5)
// compiled member node returning call8687 (depth = 4)
  adddatum2(obj8256, call8687, 6);
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
objclass8256 = obj8256->class;
  objclass8256->definitionModule = modulename;
  objclass8256->definitionLine = 1947;
  (*(struct UserObject *)self).data[0] = lowerouter8256;
  self = oldself8256;
  selfslot = oldselfslot8256;
  stackframe = oldstackframe8256;
  gc_frame_end(frame);
  return obj8256;
}
Object meth_ast_new8255_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8256 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8256 = alloc_userobj2(21,18, objclass8256);
  gc_frame_newslot(obj8256);
if (objclass8256 == NULL) {
  glfree(obj8256->class->name);
  obj8256->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8256, self, 0);
  addmethodreal(obj8256,"outer", &reader_ast_outer_8257);
  Object oldself8256 = self;
  struct StackFrameObject *oldstackframe8256 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8256);
  gc_frame_newslot((Object)stackframe);
  self = obj8256;
  Object *oldselfslot8256 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8256 = (*(struct UserObject *)self).data[0], lowerouter8256 = thisouter8256;
  if (inheritingObject8256) {
    struct UserObject *inho8256 = (struct UserObject *)inheritingObject8256;
    while (inho8256->super != GraceDefaultObject) inho8256 = (struct UserObject *)inho8256->super;
    inho8256->super = obj8256;
    self = inheritingObject8256;
    *selfslot = self;
    lowerouter8256 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8256;
  }
if (objclass8256 == NULL) {
  Method *reader8258 = addmethodrealflags(obj8256, "kind",&reader_ast_kind_8258, MFLAG_DEF);
  reader8258->definitionModule = modulename;
  reader8258->definitionLine = 1950;
}
adddatum2(obj8256, alloc_Undefined(), 1);
if (objclass8256 == NULL) {
  Method *reader8259 = addmethodrealflags(obj8256, "name",&reader_ast_name_8259, 0);
  Method *writer8259 = addmethodrealflags(obj8256, "name:=",&writer_ast_name_8259, 0);
  reader8259->definitionModule = modulename;
  writer8259->definitionModule = modulename;
  reader8259->definitionLine = 1951;
  writer8259->definitionLine = 1951;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 2);
if (objclass8256 == NULL) {
  Method *reader8260 = addmethodrealflags(obj8256, "value",&reader_ast_value_8260, 0);
  Method *writer8260 = addmethodrealflags(obj8256, "value:=",&writer_ast_value_8260, 0);
  reader8260->definitionModule = modulename;
  writer8260->definitionModule = modulename;
  reader8260->definitionLine = 1952;
  writer8260->definitionLine = 1952;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 3);
if (objclass8256 == NULL) {
  Method *reader8261 = addmethodrealflags(obj8256, "dtype",&reader_ast_dtype_8261, 0);
  Method *writer8261 = addmethodrealflags(obj8256, "dtype:=",&writer_ast_dtype_8261, 0);
  reader8261->definitionModule = modulename;
  writer8261->definitionModule = modulename;
  reader8261->definitionLine = 1953;
  writer8261->definitionLine = 1953;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 4);
if (objclass8256 == NULL) {
  Method *reader8262 = addmethodrealflags(obj8256, "nameString",&reader_ast_nameString_8262, MFLAG_DEF);
  reader8262->definitionModule = modulename;
  reader8262->definitionLine = 1954;
}
adddatum2(obj8256, alloc_Undefined(), 5);
if (objclass8256 == NULL) {
  Method *reader8263 = addmethodrealflags(obj8256, "annotations",&reader_ast_annotations_8263, 0);
  Method *writer8263 = addmethodrealflags(obj8256, "annotations:=",&writer_ast_annotations_8263, 0);
  reader8263->definitionModule = modulename;
  writer8263->definitionModule = modulename;
  reader8263->definitionLine = 1956;
  writer8263->definitionLine = 1956;
}
obj8256->flags |= OFLAG_MUTABLE;
adddatum2(obj8256, alloc_Undefined(), 6);
// method isPublic
  struct UserObject *uo8264 = (struct UserObject*)obj8256;
  uo8264->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic8264 = addmethod2pos(obj8256, "isPublic", &meth_ast_isPublic8264, 7);
  int argcv_meth_ast_isPublic8264[] = {0};
  meth_meth_ast_isPublic8264->type = alloc_MethodType(1, argcv_meth_ast_isPublic8264);
  meth_meth_ast_isPublic8264->definitionModule = modulename;
  meth_meth_ast_isPublic8264->definitionLine = 1956;
// method isWritable
  struct UserObject *uo8291 = (struct UserObject*)obj8256;
  uo8291->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable8291 = addmethod2pos(obj8256, "isWritable", &meth_ast_isWritable8291, 8);
  int argcv_meth_ast_isWritable8291[] = {0};
  meth_meth_ast_isWritable8291->type = alloc_MethodType(1, argcv_meth_ast_isWritable8291);
  meth_meth_ast_isWritable8291->definitionModule = modulename;
  meth_meth_ast_isWritable8291->definitionLine = 1962;
// method isReadable
  struct UserObject *uo8321 = (struct UserObject*)obj8256;
  uo8321->data[9] = emptyclosure;
  Method *meth_meth_ast_isReadable8321 = addmethod2pos(obj8256, "isReadable", &meth_ast_isReadable8321, 9);
  int argcv_meth_ast_isReadable8321[] = {0};
  meth_meth_ast_isReadable8321->type = alloc_MethodType(1, argcv_meth_ast_isReadable8321);
  meth_meth_ast_isReadable8321->definitionModule = modulename;
  meth_meth_ast_isReadable8321->definitionLine = 1968;
// method isFieldDec
  struct UserObject *uo8351 = (struct UserObject*)obj8256;
  uo8351->data[10] = emptyclosure;
  Method *meth_meth_ast_isFieldDec8351 = addmethod2pos(obj8256, "isFieldDec", &meth_ast_isFieldDec8351, 10);
  int argcv_meth_ast_isFieldDec8351[] = {0};
  meth_meth_ast_isFieldDec8351->type = alloc_MethodType(1, argcv_meth_ast_isFieldDec8351);
  meth_meth_ast_isFieldDec8351->definitionModule = modulename;
  meth_meth_ast_isFieldDec8351->definitionLine = 1974;
// method usesAsType
  struct UserObject *uo8373 = (struct UserObject*)obj8256;
  uo8373->data[11] = emptyclosure;
  Method *meth_meth_ast_usesAsType8373 = addmethod2pos(obj8256, "usesAsType", &meth_ast_usesAsType8373, 11);
  int argcv_meth_ast_usesAsType8373[] = {1};
  meth_meth_ast_usesAsType8373->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8373);
  meth_meth_ast_usesAsType8373->definitionModule = modulename;
  meth_meth_ast_usesAsType8373->definitionLine = 1979;
// method accept()from
  struct UserObject *uo8379 = (struct UserObject*)obj8256;
  uo8379->data[12] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8379 = addmethod2pos(obj8256, "accept()from", &meth_ast_accept_40__41_from8379, 12);
  int argcv_meth_ast_accept_40__41_from8379[] = {1, 1};
  meth_meth_ast_accept_40__41_from8379->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8379);
  meth_meth_ast_accept_40__41_from8379->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8379->definitionLine = 1982;
// method map()parent
  struct UserObject *uo8409 = (struct UserObject*)obj8256;
  uo8409->data[13] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent8409 = addmethod2pos(obj8256, "map()parent", &meth_ast_map_40__41_parent8409, 13);
  int argcv_meth_ast_map_40__41_parent8409[] = {1, 1};
  meth_meth_ast_map_40__41_parent8409->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent8409);
  meth_meth_ast_map_40__41_parent8409->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent8409->definitionLine = 1993;
// method pretty
  struct UserObject *uo8451 = (struct UserObject*)obj8256;
  uo8451->data[14] = emptyclosure;
  Method *meth_meth_ast_pretty8451 = addmethod2pos(obj8256, "pretty", &meth_ast_pretty8451, 14);
  int argcv_meth_ast_pretty8451[] = {1};
  meth_meth_ast_pretty8451->type = alloc_MethodType(1, argcv_meth_ast_pretty8451);
  meth_meth_ast_pretty8451->definitionModule = modulename;
  meth_meth_ast_pretty8451->definitionLine = 2002;
// method toGrace
  struct UserObject *uo8550 = (struct UserObject*)obj8256;
  uo8550->data[15] = emptyclosure;
  Method *meth_meth_ast_toGrace8550 = addmethod2pos(obj8256, "toGrace", &meth_ast_toGrace8550, 15);
  int argcv_meth_ast_toGrace8550[] = {1};
  meth_meth_ast_toGrace8550->type = alloc_MethodType(1, argcv_meth_ast_toGrace8550);
meth_meth_ast_toGrace8550->type->types[0] = type_Number;
meth_meth_ast_toGrace8550->type->names[0] = "depth";
  meth_meth_ast_toGrace8550->definitionModule = modulename;
  meth_meth_ast_toGrace8550->definitionLine = 2019;
// method shallowCopyWithParent
  block_savedest(obj8256);
  Object closure8666 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure8666, stackframe);
  addtoclosure(closure8666, var_varDecNode);
  struct UserObject *uo8666 = (struct UserObject*)obj8256;
  uo8666->data[16] = (Object)closure8666;
  Method *meth_meth_ast_shallowCopyWithParent8666 = addmethod2pos(obj8256, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent8666, 16);
  int argcv_meth_ast_shallowCopyWithParent8666[] = {1};
  meth_meth_ast_shallowCopyWithParent8666->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent8666);
  meth_meth_ast_shallowCopyWithParent8666->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent8666->definitionLine = 2038;
  sourceObject = obj8256;
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8677 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8678 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8677);
// compiled call node returning call8678 (depth = 4)
  struct UserObject *obj8256_uo = (struct UserObject *)obj8256;
  obj8256_uo->super = call8678;
  sourceObject = obj8256;
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8679 == NULL) {
    strlit8679 = alloc_String("vardec");
    gc_root(strlit8679);
  }
// compiled string node returning strlit8679 (depth = 4)
  adddatum2(obj8256, strlit8679, 1);
  sourceObject = obj8256;
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj8256, *var_name_39_, 2);
  sourceObject = obj8256;
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_val_39_ (depth = 4)
  adddatum2(obj8256, *var_val_39_, 3);
  sourceObject = obj8256;
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj8256, *var_dtype_39_, 4);
  sourceObject = obj8256;
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8682 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 7)
// compiled member node returning call8682 (depth = 6)
  partcv[0] = 0;
  Object call8683 = callmethod(call8682, "value",
    1, partcv, params);
  gc_frame_end(callframe8680);
// compiled call node returning call8683 (depth = 5)
// compiled member node returning call8683 (depth = 4)
  adddatum2(obj8256, call8683, 5);
  sourceObject = obj8256;
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8684 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8685 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8686 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8685);
// compiled call node returning call8686 (depth = 7)
// compiled member node returning call8686 (depth = 6)
  partcv[0] = 0;
  Object call8687 = callmethod(call8686, "empty",
    1, partcv, params);
  gc_frame_end(callframe8684);
// compiled call node returning call8687 (depth = 5)
// compiled member node returning call8687 (depth = 4)
  adddatum2(obj8256, call8687, 6);
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
  sourceObject = obj8256;
objclass8256 = obj8256->class;
  objclass8256->definitionModule = modulename;
  objclass8256->definitionLine = 1947;
  (*(struct UserObject *)self).data[0] = lowerouter8256;
  self = oldself8256;
  selfslot = oldselfslot8256;
  stackframe = oldstackframe8256;
  gc_frame_end(frame);
  return obj8256;
}
Object meth_ast_importNode8689(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for importNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for importNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_importNode (depth = 3)
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_name8700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for name (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for name");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8701 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8702 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8701);
// compiled call node returning call8702 (depth = 5)
// compiled member node returning call8702 (depth = 4)
  gc_frame_end(frame);
  return call8702;
}
Object meth_ast_nameString8703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8704 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8705 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8706 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8705);
// compiled call node returning call8706 (depth = 7)
// compiled member node returning call8706 (depth = 6)
  partcv[0] = 0;
  Object call8707 = callmethod(call8706, "nameString",
    1, partcv, params);
  gc_frame_end(callframe8704);
// compiled call node returning call8707 (depth = 5)
// compiled member node returning call8707 (depth = 4)
  gc_frame_end(frame);
  return call8707;
}
Object meth_ast_isPublic8708(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isPublic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8711 = alloc_Float64(0);
// compiled num node returning num8711 (depth = 6)
  int op_slot_right_8710 = gc_frame_newslot(num8711);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8713 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8714 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8715 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8714);
// compiled call node returning call8715 (depth = 9)
// compiled member node returning call8715 (depth = 8)
  partcv[0] = 0;
  Object call8716 = callmethod(call8715, "size",
    1, partcv, params);
  gc_frame_end(callframe8713);
// compiled call node returning call8716 (depth = 7)
// compiled member node returning call8716 (depth = 6)
  int op_slot_left_8710 = gc_frame_newslot(call8716);
  params[0] = num8711;
  partcv[0] = 1;
  Object opresult8717 = callmethod(call8716, "==", 1, partcv, params);
// compiled op node returning opresult8717 (depth = 5)
  Object if8709 = done;
  if (istrue(opresult8717)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8718 = alloc_Boolean(0);
// compiled identifier node returning bool8718 (depth = 6)
  return bool8718;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8709 = undefined;
  } else {
  }
// compiled if node returning if8709 (depth = 4)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8720 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile string node (depth = 6)
  if (strlit8721 == NULL) {
    strlit8721 = alloc_String("public");
    gc_root(strlit8721);
  }
// compiled string node returning strlit8721 (depth = 6)
  gc_frame_newslot(strlit8721);
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8722 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8723 = gc_frame_new();
// call case 3: self.outer request
  Object call8724 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8723);
// compiled call node returning call8724 (depth = 9)
// compiled member node returning call8724 (depth = 8)
  partcv[0] = 0;
  Object call8725 = callmethodflags(call8724, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8722);
// compiled call node returning call8725 (depth = 7)
// compiled member node returning call8725 (depth = 6)
  params[0] = self;
  params[1] = strlit8721;
  partcv[0] = 2;
  Object call8726 = callmethodflags(call8725, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8720);
// compiled call node returning call8726 (depth = 5)
  Object if8719 = done;
  if (istrue(call8726)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8727 = alloc_Boolean(1);
// compiled identifier node returning bool8727 (depth = 6)
  return bool8727;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if8719 = undefined;
  } else {
  }
// compiled if node returning if8719 (depth = 4)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8728 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile string node (depth = 5)
  if (strlit8729 == NULL) {
    strlit8729 = alloc_String("readable");
    gc_root(strlit8729);
  }
// compiled string node returning strlit8729 (depth = 5)
  gc_frame_newslot(strlit8729);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8730 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8731 = gc_frame_new();
// call case 3: self.outer request
  Object call8732 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8731);
// compiled call node returning call8732 (depth = 8)
// compiled member node returning call8732 (depth = 7)
  partcv[0] = 0;
  Object call8733 = callmethodflags(call8732, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8730);
// compiled call node returning call8733 (depth = 6)
// compiled member node returning call8733 (depth = 5)
  params[0] = self;
  params[1] = strlit8729;
  partcv[0] = 2;
  Object call8734 = callmethodflags(call8733, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8728);
// compiled call node returning call8734 (depth = 4)
  gc_frame_end(frame);
  return call8734;
}
Object meth_ast_isWritable8735(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isWritable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool8736 = alloc_Boolean(0);
// compiled identifier node returning bool8736 (depth = 4)
  gc_frame_end(frame);
  return bool8736;
}
Object meth_ast_isReadable8737(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isReadable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isReadable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isReadable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8739 = callmethodflags(self, "isPublic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8738);
// compiled call node returning call8739 (depth = 5)
// compiled member node returning call8739 (depth = 4)
  gc_frame_end(frame);
  return call8739;
}
Object meth_ast_declarationKind8740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8741 == NULL) {
    strlit8741 = alloc_String("defdec");
    gc_root(strlit8741);
  }
// compiled string node returning strlit8741 (depth = 4)
  gc_frame_end(frame);
  return strlit8741;
}
Object meth_ast_usesAsType8742(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "usesAsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method usesAsType");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for usesAsType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aNode = &(stackframe->slots[0]);
  *var_aNode = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for usesAsType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8745 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8744);
// compiled call node returning call8745 (depth = 6)
// compiled member node returning call8745 (depth = 5)
  int op_slot_right_8743 = gc_frame_newslot(call8745);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aNode (depth = 5)
  int op_slot_left_8743 = gc_frame_newslot(*var_aNode);
  params[0] = call8745;
  partcv[0] = 1;
  Object opresult8747 = callmethod(*var_aNode, "==", 1, partcv, params);
// compiled op node returning opresult8747 (depth = 4)
  gc_frame_end(frame);
  return opresult8747;
}
Object meth_ast_accept_40__41_from8748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8750 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8751 = callmethod(*var_visitor, "visitImport()up",
    2, partcv, params);
  gc_frame_end(callframe8750);
// compiled call node returning call8751 (depth = 5)
  Object if8749 = done;
  if (istrue(call8751)) {
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8752 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8753 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8754 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8753);
// compiled call node returning call8754 (depth = 7)
// compiled member node returning call8754 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8755 = callmethod(call8754, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8752);
// compiled call node returning call8755 (depth = 5)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool8758 = alloc_Boolean(0);
// compiled identifier node returning bool8758 (depth = 7)
  int op_slot_right_8757 = gc_frame_newslot(bool8758);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8761 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8760);
// compiled call node returning call8761 (depth = 8)
// compiled member node returning call8761 (depth = 7)
  int op_slot_left_8757 = gc_frame_newslot(call8761);
  params[0] = bool8758;
  partcv[0] = 1;
  Object opresult8762 = callmethod(call8761, "!=", 1, partcv, params);
// compiled op node returning opresult8762 (depth = 6)
  Object if8756 = done;
  if (istrue(opresult8762)) {
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8763 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8764 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8765 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8764);
// compiled call node returning call8765 (depth = 8)
// compiled member node returning call8765 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8766 = callmethod(call8765, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe8763);
// compiled call node returning call8766 (depth = 6)
    gc_frame_newslot(call8766);
    if8756 = call8766;
  } else {
  }
// compiled if node returning if8756 (depth = 5)
    gc_frame_newslot(if8756);
    if8749 = if8756;
  } else {
  }
// compiled if node returning if8749 (depth = 4)
  gc_frame_end(frame);
  return if8749;
}
Object meth_ast_map_40__41_parent8767(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8768 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call8769 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8768);
// compiled call node returning call8769 (depth = 5)
  *var_n = call8769;
  if (call8769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8770 = gc_frame_new();
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8771 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8773 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8772);
// compiled call node returning call8773 (depth = 8)
// compiled member node returning call8773 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8774 = callmethod(call8773, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe8771);
// compiled call node returning call8774 (depth = 6)
  gc_frame_newslot(call8774);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8774;
  partcv[0] = 1;
  Object call8775 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe8770);
// compiled call node returning call8775 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8776 = gc_frame_new();
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8777 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8778 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8779 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8778);
// compiled call node returning call8779 (depth = 8)
// compiled member node returning call8779 (depth = 7)
  gc_frame_newslot(call8779);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8780 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8781 = gc_frame_new();
// call case 3: self.outer request
  Object call8782 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8781);
// compiled call node returning call8782 (depth = 10)
// compiled member node returning call8782 (depth = 9)
  partcv[0] = 0;
  Object call8783 = callmethodflags(call8782, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8780);
// compiled call node returning call8783 (depth = 8)
// compiled member node returning call8783 (depth = 7)
  params[0] = call8779;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8784 = callmethodflags(call8783, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8777);
// compiled call node returning call8784 (depth = 6)
  gc_frame_newslot(call8784);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8784;
  partcv[0] = 1;
  Object call8785 = callmethod(*var_n, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe8776);
// compiled call node returning call8785 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8786 = gc_frame_new();
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8787 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8788 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8789 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8788);
// compiled call node returning call8789 (depth = 8)
// compiled member node returning call8789 (depth = 7)
  gc_frame_newslot(call8789);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8790 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8791 = gc_frame_new();
// call case 3: self.outer request
  Object call8792 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe8791);
// compiled call node returning call8792 (depth = 10)
// compiled member node returning call8792 (depth = 9)
  partcv[0] = 0;
  Object call8793 = callmethodflags(call8792, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8790);
// compiled call node returning call8793 (depth = 8)
// compiled member node returning call8793 (depth = 7)
  params[0] = call8789;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call8794 = callmethodflags(call8793, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8787);
// compiled call node returning call8794 (depth = 6)
  gc_frame_newslot(call8794);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call8794;
  partcv[0] = 1;
  Object call8795 = callmethod(*var_n, "annotations:=",
    1, partcv, params);
  gc_frame_end(callframe8786);
// compiled call node returning call8795 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8796 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8797 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8796);
// compiled call node returning call8797 (depth = 5)
  *var_n = call8797;
  if (call8797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply8807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit8809 == NULL) {
    strlit8809 = alloc_String("  ");
    gc_root(strlit8809);
  }
// compiled string node returning strlit8809 (depth = 8)
  int op_slot_right_8808 = gc_frame_newslot(strlit8809);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8808 = gc_frame_newslot(*var_spc);
  params[0] = strlit8809;
  partcv[0] = 1;
  Object opresult8811 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8811 (depth = 7)
  *var_spc = opresult8811;
  if (opresult8811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8799(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8800 == NULL) {
    strlit8800 = alloc_String("");
    gc_root(strlit8800);
  }
// compiled string node returning strlit8800 (depth = 5)
  *var_spc = strlit8800;
  if (strlit8800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8801 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_8802 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num8804 = alloc_Float64(0);
// compiled num node returning num8804 (depth = 6)
  int op_slot_left_8802 = gc_frame_newslot(num8804);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8805 = callmethod(num8804, "..", 1, partcv, params);
// compiled op node returning opresult8805 (depth = 5)
  gc_frame_newslot(opresult8805);
// starting to compile block node (depth = 5)
  Object block8806 = alloc_Block(NULL, NULL, "ast", 2081);
  gc_frame_newslot(block8806);
// method _apply
  block_savedest(block8806);
  Object closure8807 = createclosure(2, "_apply");
  setclosureframe(closure8807, stackframe);
  addtoclosure(closure8807, var_spc);
  addtoclosure(closure8807, selfslot);
  struct UserObject *uo8807 = (struct UserObject*)block8806;
  uo8807->data[0] = (Object)closure8807;
  Method *meth_meth_ast__apply8807 = addmethod2pos(block8806, "_apply", &meth_ast__apply8807, 0);
  int argcv_meth_ast__apply8807[] = {1};
  meth_meth_ast__apply8807->type = alloc_MethodType(1, argcv_meth_ast__apply8807);
  meth_meth_ast__apply8807->definitionModule = modulename;
  meth_meth_ast__apply8807->definitionLine = 2075;
// compiled block node returning block8806 (depth = 5)
  gc_frame_newslot(block8806);
// call case 5: prelude request
  params[0] = opresult8805;
  params[1] = block8806;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8814 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8801);
// compiled call node returning call8814 (depth = 4)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8816 == NULL) {
    strlit8816 = alloc_String("""\x0a""");
    gc_root(strlit8816);
  }
// compiled string node returning strlit8816 (depth = 6)
  int op_slot_right_8815 = gc_frame_newslot(strlit8816);
// starting to compile call node (depth = 6)
  int callframe8818 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8819 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8818);
// compiled call node returning call8819 (depth = 6)
  int op_slot_left_8815 = gc_frame_newslot(call8819);
  params[0] = strlit8816;
  partcv[0] = 1;
  Object opresult8820 = callmethod(call8819, "++", 1, partcv, params);
// compiled op node returning opresult8820 (depth = 5)
  *var_s = opresult8820;
  if (opresult8820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8823 == NULL) {
    strlit8823 = alloc_String("""\x0a""");
    gc_root(strlit8823);
  }
// compiled string node returning strlit8823 (depth = 7)
  int op_slot_right_8822 = gc_frame_newslot(strlit8823);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8826 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8827 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8826);
// compiled call node returning call8827 (depth = 9)
// compiled member node returning call8827 (depth = 8)
  int op_slot_right_8825 = gc_frame_newslot(call8827);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8830 == NULL) {
    strlit8830 = alloc_String("Path: ");
    gc_root(strlit8830);
  }
// compiled string node returning strlit8830 (depth = 9)
  int op_slot_right_8829 = gc_frame_newslot(strlit8830);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_8832 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit8834 == NULL) {
    strlit8834 = alloc_String("");
    gc_root(strlit8834);
  }
// compiled string node returning strlit8834 (depth = 10)
  int op_slot_left_8832 = gc_frame_newslot(strlit8834);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8835 = callmethod(strlit8834, "++", 1, partcv, params);
// compiled op node returning opresult8835 (depth = 9)
  int op_slot_left_8829 = gc_frame_newslot(opresult8835);
  params[0] = strlit8830;
  partcv[0] = 1;
  Object opresult8836 = callmethod(opresult8835, "++", 1, partcv, params);
// compiled op node returning opresult8836 (depth = 8)
  int op_slot_left_8825 = gc_frame_newslot(opresult8836);
  params[0] = call8827;
  partcv[0] = 1;
  Object opresult8837 = callmethod(opresult8836, "++", 1, partcv, params);
// compiled op node returning opresult8837 (depth = 7)
  int op_slot_left_8822 = gc_frame_newslot(opresult8837);
  params[0] = strlit8823;
  partcv[0] = 1;
  Object opresult8838 = callmethod(opresult8837, "++", 1, partcv, params);
// compiled op node returning opresult8838 (depth = 6)
  int op_slot_right_8821 = gc_frame_newslot(opresult8838);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8821 = gc_frame_newslot(*var_s);
  params[0] = opresult8838;
  partcv[0] = 1;
  Object opresult8840 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8840 (depth = 5)
  *var_s = opresult8840;
  if (opresult8840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8844 == NULL) {
    strlit8844 = alloc_String("""\x0a""");
    gc_root(strlit8844);
  }
// compiled string node returning strlit8844 (depth = 7)
  int op_slot_right_8843 = gc_frame_newslot(strlit8844);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8847 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8848 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8847);
// compiled call node returning call8848 (depth = 9)
// compiled member node returning call8848 (depth = 8)
  int op_slot_right_8846 = gc_frame_newslot(call8848);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8851 == NULL) {
    strlit8851 = alloc_String("Identifier: ");
    gc_root(strlit8851);
  }
// compiled string node returning strlit8851 (depth = 9)
  int op_slot_right_8850 = gc_frame_newslot(strlit8851);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_8853 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit8855 == NULL) {
    strlit8855 = alloc_String("");
    gc_root(strlit8855);
  }
// compiled string node returning strlit8855 (depth = 10)
  int op_slot_left_8853 = gc_frame_newslot(strlit8855);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8856 = callmethod(strlit8855, "++", 1, partcv, params);
// compiled op node returning opresult8856 (depth = 9)
  int op_slot_left_8850 = gc_frame_newslot(opresult8856);
  params[0] = strlit8851;
  partcv[0] = 1;
  Object opresult8857 = callmethod(opresult8856, "++", 1, partcv, params);
// compiled op node returning opresult8857 (depth = 8)
  int op_slot_left_8846 = gc_frame_newslot(opresult8857);
  params[0] = call8848;
  partcv[0] = 1;
  Object opresult8858 = callmethod(opresult8857, "++", 1, partcv, params);
// compiled op node returning opresult8858 (depth = 7)
  int op_slot_left_8843 = gc_frame_newslot(opresult8858);
  params[0] = strlit8844;
  partcv[0] = 1;
  Object opresult8859 = callmethod(opresult8858, "++", 1, partcv, params);
// compiled op node returning opresult8859 (depth = 6)
  int op_slot_right_8842 = gc_frame_newslot(opresult8859);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8842 = gc_frame_newslot(*var_s);
  params[0] = opresult8859;
  partcv[0] = 1;
  Object opresult8861 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8861 (depth = 5)
  *var_s = opresult8861;
  if (opresult8861 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8865 = alloc_Float64(0);
// compiled num node returning num8865 (depth = 6)
  int op_slot_right_8864 = gc_frame_newslot(num8865);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8867 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8868 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8869 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8868);
// compiled call node returning call8869 (depth = 9)
// compiled member node returning call8869 (depth = 8)
  partcv[0] = 0;
  Object call8870 = callmethod(call8869, "size",
    1, partcv, params);
  gc_frame_end(callframe8867);
// compiled call node returning call8870 (depth = 7)
// compiled member node returning call8870 (depth = 6)
  int op_slot_left_8864 = gc_frame_newslot(call8870);
  params[0] = num8865;
  partcv[0] = 1;
  Object opresult8871 = callmethod(call8870, ">", 1, partcv, params);
// compiled op node returning opresult8871 (depth = 5)
  Object if8863 = done;
  if (istrue(opresult8871)) {
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8874 == NULL) {
    strlit8874 = alloc_String("""\x0a""");
    gc_root(strlit8874);
  }
// compiled string node returning strlit8874 (depth = 8)
  int op_slot_right_8873 = gc_frame_newslot(strlit8874);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8877 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8878 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8877);
// compiled call node returning call8878 (depth = 10)
// compiled member node returning call8878 (depth = 9)
  int op_slot_right_8876 = gc_frame_newslot(call8878);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit8881 == NULL) {
    strlit8881 = alloc_String("Anotations: ");
    gc_root(strlit8881);
  }
// compiled string node returning strlit8881 (depth = 10)
  int op_slot_right_8880 = gc_frame_newslot(strlit8881);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_8883 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 11)
  if (strlit8885 == NULL) {
    strlit8885 = alloc_String("");
    gc_root(strlit8885);
  }
// compiled string node returning strlit8885 (depth = 11)
  int op_slot_left_8883 = gc_frame_newslot(strlit8885);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8886 = callmethod(strlit8885, "++", 1, partcv, params);
// compiled op node returning opresult8886 (depth = 10)
  int op_slot_left_8880 = gc_frame_newslot(opresult8886);
  params[0] = strlit8881;
  partcv[0] = 1;
  Object opresult8887 = callmethod(opresult8886, "++", 1, partcv, params);
// compiled op node returning opresult8887 (depth = 9)
  int op_slot_left_8876 = gc_frame_newslot(opresult8887);
  params[0] = call8878;
  partcv[0] = 1;
  Object opresult8888 = callmethod(opresult8887, "++", 1, partcv, params);
// compiled op node returning opresult8888 (depth = 8)
  int op_slot_left_8873 = gc_frame_newslot(opresult8888);
  params[0] = strlit8874;
  partcv[0] = 1;
  Object opresult8889 = callmethod(opresult8888, "++", 1, partcv, params);
// compiled op node returning opresult8889 (depth = 7)
  int op_slot_right_8872 = gc_frame_newslot(opresult8889);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_8872 = gc_frame_newslot(*var_s);
  params[0] = opresult8889;
  partcv[0] = 1;
  Object opresult8891 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8891 (depth = 6)
  *var_s = opresult8891;
  if (opresult8891 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8863 = done;
  } else {
  }
// compiled if node returning if8863 (depth = 4)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace8893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8895 == NULL) {
    strlit8895 = alloc_String("");
    gc_root(strlit8895);
  }
// compiled string node returning strlit8895 (depth = 5)
  int op_slot_right_8894 = gc_frame_newslot(strlit8895);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8898 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8899 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8898);
// compiled call node returning call8899 (depth = 7)
// compiled member node returning call8899 (depth = 6)
  int op_slot_right_8897 = gc_frame_newslot(call8899);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8902 == NULL) {
    strlit8902 = alloc_String("""\x22"" as ");
    gc_root(strlit8902);
  }
// compiled string node returning strlit8902 (depth = 7)
  int op_slot_right_8901 = gc_frame_newslot(strlit8902);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8905 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8906 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8905);
// compiled call node returning call8906 (depth = 9)
// compiled member node returning call8906 (depth = 8)
  int op_slot_right_8904 = gc_frame_newslot(call8906);
// starting to compile string node (depth = 8)
  if (strlit8908 == NULL) {
    strlit8908 = alloc_String("import ""\x22""");
    gc_root(strlit8908);
  }
// compiled string node returning strlit8908 (depth = 8)
  int op_slot_left_8904 = gc_frame_newslot(strlit8908);
  params[0] = call8906;
  partcv[0] = 1;
  Object opresult8909 = callmethod(strlit8908, "++", 1, partcv, params);
// compiled op node returning opresult8909 (depth = 7)
  int op_slot_left_8901 = gc_frame_newslot(opresult8909);
  params[0] = strlit8902;
  partcv[0] = 1;
  Object opresult8910 = callmethod(opresult8909, "++", 1, partcv, params);
// compiled op node returning opresult8910 (depth = 6)
  int op_slot_left_8897 = gc_frame_newslot(opresult8910);
  params[0] = call8899;
  partcv[0] = 1;
  Object opresult8911 = callmethod(opresult8910, "++", 1, partcv, params);
// compiled op node returning opresult8911 (depth = 5)
  int op_slot_left_8894 = gc_frame_newslot(opresult8911);
  params[0] = strlit8895;
  partcv[0] = 1;
  Object opresult8912 = callmethod(opresult8911, "++", 1, partcv, params);
// compiled op node returning opresult8912 (depth = 4)
  gc_frame_end(frame);
  return opresult8912;
}
Object meth_ast_shallowCopyWithParent8913(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[3];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8914 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8915 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8916 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8917 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8916);
// compiled call node returning call8917 (depth = 7)
// compiled member node returning call8917 (depth = 6)
  gc_frame_newslot(call8917);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// starting to compile identifier node (depth = 6)
  Object bool8918 = alloc_Boolean(0);
// compiled identifier node returning bool8918 (depth = 6)
  gc_frame_newslot(bool8918);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_importNode (depth = 6)
  params[0] = call8917;
  params[1] = *var_nullNode;
  params[2] = bool8918;
  partcv[0] = 3;
  Object call8919 = callmethod(*var_importNode, "new",
    1, partcv, params);
  gc_frame_end(callframe8915);
// compiled call node returning call8919 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8920 = callmethod(call8919, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe8914);
// compiled call node returning call8920 (depth = 4)
  gc_frame_end(frame);
  return call8920;
}
Object meth_ast_new8692(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8693 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8693 = alloc_userobj2(22,19, objclass8693);
  gc_frame_newslot(obj8693);
if (objclass8693 == NULL) {
  glfree(obj8693->class->name);
  obj8693->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8693, self, 0);
  addmethodreal(obj8693,"outer", &reader_ast_outer_8694);
  Object oldself8693 = self;
  struct StackFrameObject *oldstackframe8693 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8693);
  gc_frame_newslot((Object)stackframe);
  self = obj8693;
  Object *oldselfslot8693 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8693 = (*(struct UserObject *)self).data[0], lowerouter8693 = thisouter8693;
  if (inheritingObject8693) {
    struct UserObject *inho8693 = (struct UserObject *)inheritingObject8693;
    while (inho8693->super != GraceDefaultObject) inho8693 = (struct UserObject *)inho8693->super;
    inho8693->super = obj8693;
    self = inheritingObject8693;
    *selfslot = self;
    lowerouter8693 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8693;
  }
if (objclass8693 == NULL) {
  Method *reader8695 = addmethodrealflags(obj8693, "kind",&reader_ast_kind_8695, MFLAG_DEF);
  reader8695->definitionModule = modulename;
  reader8695->definitionLine = 2045;
}
adddatum2(obj8693, alloc_Undefined(), 1);
if (objclass8693 == NULL) {
  Method *reader8696 = addmethodrealflags(obj8693, "value",&reader_ast_value_8696, 0);
  Method *writer8696 = addmethodrealflags(obj8693, "value:=",&writer_ast_value_8696, 0);
  reader8696->definitionModule = modulename;
  writer8696->definitionModule = modulename;
  reader8696->definitionLine = 2046;
  writer8696->definitionLine = 2046;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 2);
if (objclass8693 == NULL) {
  Method *reader8697 = addmethodrealflags(obj8693, "path",&reader_ast_path_8697, 0);
  Method *writer8697 = addmethodrealflags(obj8693, "path:=",&writer_ast_path_8697, 0);
  reader8697->definitionModule = modulename;
  writer8697->definitionModule = modulename;
  reader8697->definitionLine = 2047;
  writer8697->definitionLine = 2047;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 3);
if (objclass8693 == NULL) {
  Method *reader8698 = addmethodrealflags(obj8693, "annotations",&reader_ast_annotations_8698, 0);
  Method *writer8698 = addmethodrealflags(obj8693, "annotations:=",&writer_ast_annotations_8698, 0);
  reader8698->definitionModule = modulename;
  writer8698->definitionModule = modulename;
  reader8698->definitionLine = 2048;
  writer8698->definitionLine = 2048;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 4);
if (objclass8693 == NULL) {
  Method *reader8699 = addmethodrealflags(obj8693, "dtype",&reader_ast_dtype_8699, 0);
  Method *writer8699 = addmethodrealflags(obj8693, "dtype:=",&writer_ast_dtype_8699, 0);
  reader8699->definitionModule = modulename;
  writer8699->definitionModule = modulename;
  reader8699->definitionLine = 2049;
  writer8699->definitionLine = 2049;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 5);
// method name
  struct UserObject *uo8700 = (struct UserObject*)obj8693;
  uo8700->data[6] = emptyclosure;
  Method *meth_meth_ast_name8700 = addmethod2pos(obj8693, "name", &meth_ast_name8700, 6);
  int argcv_meth_ast_name8700[] = {0};
  meth_meth_ast_name8700->type = alloc_MethodType(1, argcv_meth_ast_name8700);
  meth_meth_ast_name8700->definitionModule = modulename;
  meth_meth_ast_name8700->definitionLine = 2049;
// method nameString
  struct UserObject *uo8703 = (struct UserObject*)obj8693;
  uo8703->data[7] = emptyclosure;
  Method *meth_meth_ast_nameString8703 = addmethod2pos(obj8693, "nameString", &meth_ast_nameString8703, 7);
  int argcv_meth_ast_nameString8703[] = {0};
  meth_meth_ast_nameString8703->type = alloc_MethodType(1, argcv_meth_ast_nameString8703);
  meth_meth_ast_nameString8703->definitionModule = modulename;
  meth_meth_ast_nameString8703->definitionLine = 2050;
// method isPublic
  struct UserObject *uo8708 = (struct UserObject*)obj8693;
  uo8708->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic8708 = addmethod2pos(obj8693, "isPublic", &meth_ast_isPublic8708, 8);
  int argcv_meth_ast_isPublic8708[] = {0};
  meth_meth_ast_isPublic8708->type = alloc_MethodType(1, argcv_meth_ast_isPublic8708);
  meth_meth_ast_isPublic8708->definitionModule = modulename;
  meth_meth_ast_isPublic8708->definitionLine = 2051;
// method isWritable
  struct UserObject *uo8735 = (struct UserObject*)obj8693;
  uo8735->data[9] = emptyclosure;
  Method *meth_meth_ast_isWritable8735 = addmethod2pos(obj8693, "isWritable", &meth_ast_isWritable8735, 9);
  int argcv_meth_ast_isWritable8735[] = {0};
  meth_meth_ast_isWritable8735->type = alloc_MethodType(1, argcv_meth_ast_isWritable8735);
  meth_meth_ast_isWritable8735->definitionModule = modulename;
  meth_meth_ast_isWritable8735->definitionLine = 2057;
// method isReadable
  struct UserObject *uo8737 = (struct UserObject*)obj8693;
  uo8737->data[10] = emptyclosure;
  Method *meth_meth_ast_isReadable8737 = addmethod2pos(obj8693, "isReadable", &meth_ast_isReadable8737, 10);
  int argcv_meth_ast_isReadable8737[] = {0};
  meth_meth_ast_isReadable8737->type = alloc_MethodType(1, argcv_meth_ast_isReadable8737);
  meth_meth_ast_isReadable8737->definitionModule = modulename;
  meth_meth_ast_isReadable8737->definitionLine = 2058;
// method declarationKind
  struct UserObject *uo8740 = (struct UserObject*)obj8693;
  uo8740->data[11] = emptyclosure;
  Method *meth_meth_ast_declarationKind8740 = addmethod2pos(obj8693, "declarationKind", &meth_ast_declarationKind8740, 11);
  int argcv_meth_ast_declarationKind8740[] = {0};
  meth_meth_ast_declarationKind8740->type = alloc_MethodType(1, argcv_meth_ast_declarationKind8740);
  meth_meth_ast_declarationKind8740->definitionModule = modulename;
  meth_meth_ast_declarationKind8740->definitionLine = 2059;
// method usesAsType
  struct UserObject *uo8742 = (struct UserObject*)obj8693;
  uo8742->data[12] = emptyclosure;
  Method *meth_meth_ast_usesAsType8742 = addmethod2pos(obj8693, "usesAsType", &meth_ast_usesAsType8742, 12);
  int argcv_meth_ast_usesAsType8742[] = {1};
  meth_meth_ast_usesAsType8742->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8742);
  meth_meth_ast_usesAsType8742->definitionModule = modulename;
  meth_meth_ast_usesAsType8742->definitionLine = 2060;
// method accept()from
  struct UserObject *uo8748 = (struct UserObject*)obj8693;
  uo8748->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8748 = addmethod2pos(obj8693, "accept()from", &meth_ast_accept_40__41_from8748, 13);
  int argcv_meth_ast_accept_40__41_from8748[] = {1, 1};
  meth_meth_ast_accept_40__41_from8748->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8748);
  meth_meth_ast_accept_40__41_from8748->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8748->definitionLine = 2063;
// method map()parent
  struct UserObject *uo8767 = (struct UserObject*)obj8693;
  uo8767->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent8767 = addmethod2pos(obj8693, "map()parent", &meth_ast_map_40__41_parent8767, 14);
  int argcv_meth_ast_map_40__41_parent8767[] = {1, 1};
  meth_meth_ast_map_40__41_parent8767->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent8767);
  meth_meth_ast_map_40__41_parent8767->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent8767->definitionLine = 2071;
// method pretty
  struct UserObject *uo8799 = (struct UserObject*)obj8693;
  uo8799->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty8799 = addmethod2pos(obj8693, "pretty", &meth_ast_pretty8799, 15);
  int argcv_meth_ast_pretty8799[] = {1};
  meth_meth_ast_pretty8799->type = alloc_MethodType(1, argcv_meth_ast_pretty8799);
  meth_meth_ast_pretty8799->definitionModule = modulename;
  meth_meth_ast_pretty8799->definitionLine = 2079;
// method toGrace
  struct UserObject *uo8893 = (struct UserObject*)obj8693;
  uo8893->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace8893 = addmethod2pos(obj8693, "toGrace", &meth_ast_toGrace8893, 16);
  int argcv_meth_ast_toGrace8893[] = {1};
  meth_meth_ast_toGrace8893->type = alloc_MethodType(1, argcv_meth_ast_toGrace8893);
meth_meth_ast_toGrace8893->type->types[0] = type_Number;
meth_meth_ast_toGrace8893->type->names[0] = "depth";
  meth_meth_ast_toGrace8893->definitionModule = modulename;
  meth_meth_ast_toGrace8893->definitionLine = 2092;
// method shallowCopyWithParent
  block_savedest(obj8693);
  Object closure8913 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure8913, stackframe);
  addtoclosure(closure8913, var_nullNode);
  addtoclosure(closure8913, var_importNode);
  struct UserObject *uo8913 = (struct UserObject*)obj8693;
  uo8913->data[17] = (Object)closure8913;
  Method *meth_meth_ast_shallowCopyWithParent8913 = addmethod2pos(obj8693, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent8913, 17);
  int argcv_meth_ast_shallowCopyWithParent8913[] = {1};
  meth_meth_ast_shallowCopyWithParent8913->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent8913);
  meth_meth_ast_shallowCopyWithParent8913->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent8913->definitionLine = 2095;
  sourceObject = obj8693;
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8921 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8922 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8921);
// compiled call node returning call8922 (depth = 4)
  struct UserObject *obj8693_uo = (struct UserObject *)obj8693;
  obj8693_uo->super = call8922;
  sourceObject = obj8693;
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8923 == NULL) {
    strlit8923 = alloc_String("import");
    gc_root(strlit8923);
  }
// compiled string node returning strlit8923 (depth = 4)
  adddatum2(obj8693, strlit8923, 1);
  sourceObject = obj8693;
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj8693, *var_name_39_, 2);
  sourceObject = obj8693;
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj8693, *var_path_39_, 3);
  sourceObject = obj8693;
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8924 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8925 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8926 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8925);
// compiled call node returning call8926 (depth = 7)
// compiled member node returning call8926 (depth = 6)
  partcv[0] = 0;
  Object call8927 = callmethod(call8926, "empty",
    1, partcv, params);
  gc_frame_end(callframe8924);
// compiled call node returning call8927 (depth = 5)
// compiled member node returning call8927 (depth = 4)
  adddatum2(obj8693, call8927, 4);
  sourceObject = obj8693;
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj8693, *var_dtype_39_, 5);
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
objclass8693 = obj8693->class;
  objclass8693->definitionModule = modulename;
  objclass8693->definitionLine = 2042;
  (*(struct UserObject *)self).data[0] = lowerouter8693;
  self = oldself8693;
  selfslot = oldselfslot8693;
  stackframe = oldstackframe8693;
  gc_frame_end(frame);
  return obj8693;
}
Object meth_ast_new8692_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_importNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name_39_ = &(stackframe->slots[1]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8693 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8693 = alloc_userobj2(22,19, objclass8693);
  gc_frame_newslot(obj8693);
if (objclass8693 == NULL) {
  glfree(obj8693->class->name);
  obj8693->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8693, self, 0);
  addmethodreal(obj8693,"outer", &reader_ast_outer_8694);
  Object oldself8693 = self;
  struct StackFrameObject *oldstackframe8693 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8693);
  gc_frame_newslot((Object)stackframe);
  self = obj8693;
  Object *oldselfslot8693 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8693 = (*(struct UserObject *)self).data[0], lowerouter8693 = thisouter8693;
  if (inheritingObject8693) {
    struct UserObject *inho8693 = (struct UserObject *)inheritingObject8693;
    while (inho8693->super != GraceDefaultObject) inho8693 = (struct UserObject *)inho8693->super;
    inho8693->super = obj8693;
    self = inheritingObject8693;
    *selfslot = self;
    lowerouter8693 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8693;
  }
if (objclass8693 == NULL) {
  Method *reader8695 = addmethodrealflags(obj8693, "kind",&reader_ast_kind_8695, MFLAG_DEF);
  reader8695->definitionModule = modulename;
  reader8695->definitionLine = 2045;
}
adddatum2(obj8693, alloc_Undefined(), 1);
if (objclass8693 == NULL) {
  Method *reader8696 = addmethodrealflags(obj8693, "value",&reader_ast_value_8696, 0);
  Method *writer8696 = addmethodrealflags(obj8693, "value:=",&writer_ast_value_8696, 0);
  reader8696->definitionModule = modulename;
  writer8696->definitionModule = modulename;
  reader8696->definitionLine = 2046;
  writer8696->definitionLine = 2046;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 2);
if (objclass8693 == NULL) {
  Method *reader8697 = addmethodrealflags(obj8693, "path",&reader_ast_path_8697, 0);
  Method *writer8697 = addmethodrealflags(obj8693, "path:=",&writer_ast_path_8697, 0);
  reader8697->definitionModule = modulename;
  writer8697->definitionModule = modulename;
  reader8697->definitionLine = 2047;
  writer8697->definitionLine = 2047;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 3);
if (objclass8693 == NULL) {
  Method *reader8698 = addmethodrealflags(obj8693, "annotations",&reader_ast_annotations_8698, 0);
  Method *writer8698 = addmethodrealflags(obj8693, "annotations:=",&writer_ast_annotations_8698, 0);
  reader8698->definitionModule = modulename;
  writer8698->definitionModule = modulename;
  reader8698->definitionLine = 2048;
  writer8698->definitionLine = 2048;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 4);
if (objclass8693 == NULL) {
  Method *reader8699 = addmethodrealflags(obj8693, "dtype",&reader_ast_dtype_8699, 0);
  Method *writer8699 = addmethodrealflags(obj8693, "dtype:=",&writer_ast_dtype_8699, 0);
  reader8699->definitionModule = modulename;
  writer8699->definitionModule = modulename;
  reader8699->definitionLine = 2049;
  writer8699->definitionLine = 2049;
}
obj8693->flags |= OFLAG_MUTABLE;
adddatum2(obj8693, alloc_Undefined(), 5);
// method name
  struct UserObject *uo8700 = (struct UserObject*)obj8693;
  uo8700->data[6] = emptyclosure;
  Method *meth_meth_ast_name8700 = addmethod2pos(obj8693, "name", &meth_ast_name8700, 6);
  int argcv_meth_ast_name8700[] = {0};
  meth_meth_ast_name8700->type = alloc_MethodType(1, argcv_meth_ast_name8700);
  meth_meth_ast_name8700->definitionModule = modulename;
  meth_meth_ast_name8700->definitionLine = 2049;
// method nameString
  struct UserObject *uo8703 = (struct UserObject*)obj8693;
  uo8703->data[7] = emptyclosure;
  Method *meth_meth_ast_nameString8703 = addmethod2pos(obj8693, "nameString", &meth_ast_nameString8703, 7);
  int argcv_meth_ast_nameString8703[] = {0};
  meth_meth_ast_nameString8703->type = alloc_MethodType(1, argcv_meth_ast_nameString8703);
  meth_meth_ast_nameString8703->definitionModule = modulename;
  meth_meth_ast_nameString8703->definitionLine = 2050;
// method isPublic
  struct UserObject *uo8708 = (struct UserObject*)obj8693;
  uo8708->data[8] = emptyclosure;
  Method *meth_meth_ast_isPublic8708 = addmethod2pos(obj8693, "isPublic", &meth_ast_isPublic8708, 8);
  int argcv_meth_ast_isPublic8708[] = {0};
  meth_meth_ast_isPublic8708->type = alloc_MethodType(1, argcv_meth_ast_isPublic8708);
  meth_meth_ast_isPublic8708->definitionModule = modulename;
  meth_meth_ast_isPublic8708->definitionLine = 2051;
// method isWritable
  struct UserObject *uo8735 = (struct UserObject*)obj8693;
  uo8735->data[9] = emptyclosure;
  Method *meth_meth_ast_isWritable8735 = addmethod2pos(obj8693, "isWritable", &meth_ast_isWritable8735, 9);
  int argcv_meth_ast_isWritable8735[] = {0};
  meth_meth_ast_isWritable8735->type = alloc_MethodType(1, argcv_meth_ast_isWritable8735);
  meth_meth_ast_isWritable8735->definitionModule = modulename;
  meth_meth_ast_isWritable8735->definitionLine = 2057;
// method isReadable
  struct UserObject *uo8737 = (struct UserObject*)obj8693;
  uo8737->data[10] = emptyclosure;
  Method *meth_meth_ast_isReadable8737 = addmethod2pos(obj8693, "isReadable", &meth_ast_isReadable8737, 10);
  int argcv_meth_ast_isReadable8737[] = {0};
  meth_meth_ast_isReadable8737->type = alloc_MethodType(1, argcv_meth_ast_isReadable8737);
  meth_meth_ast_isReadable8737->definitionModule = modulename;
  meth_meth_ast_isReadable8737->definitionLine = 2058;
// method declarationKind
  struct UserObject *uo8740 = (struct UserObject*)obj8693;
  uo8740->data[11] = emptyclosure;
  Method *meth_meth_ast_declarationKind8740 = addmethod2pos(obj8693, "declarationKind", &meth_ast_declarationKind8740, 11);
  int argcv_meth_ast_declarationKind8740[] = {0};
  meth_meth_ast_declarationKind8740->type = alloc_MethodType(1, argcv_meth_ast_declarationKind8740);
  meth_meth_ast_declarationKind8740->definitionModule = modulename;
  meth_meth_ast_declarationKind8740->definitionLine = 2059;
// method usesAsType
  struct UserObject *uo8742 = (struct UserObject*)obj8693;
  uo8742->data[12] = emptyclosure;
  Method *meth_meth_ast_usesAsType8742 = addmethod2pos(obj8693, "usesAsType", &meth_ast_usesAsType8742, 12);
  int argcv_meth_ast_usesAsType8742[] = {1};
  meth_meth_ast_usesAsType8742->type = alloc_MethodType(1, argcv_meth_ast_usesAsType8742);
  meth_meth_ast_usesAsType8742->definitionModule = modulename;
  meth_meth_ast_usesAsType8742->definitionLine = 2060;
// method accept()from
  struct UserObject *uo8748 = (struct UserObject*)obj8693;
  uo8748->data[13] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8748 = addmethod2pos(obj8693, "accept()from", &meth_ast_accept_40__41_from8748, 13);
  int argcv_meth_ast_accept_40__41_from8748[] = {1, 1};
  meth_meth_ast_accept_40__41_from8748->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8748);
  meth_meth_ast_accept_40__41_from8748->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8748->definitionLine = 2063;
// method map()parent
  struct UserObject *uo8767 = (struct UserObject*)obj8693;
  uo8767->data[14] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent8767 = addmethod2pos(obj8693, "map()parent", &meth_ast_map_40__41_parent8767, 14);
  int argcv_meth_ast_map_40__41_parent8767[] = {1, 1};
  meth_meth_ast_map_40__41_parent8767->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent8767);
  meth_meth_ast_map_40__41_parent8767->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent8767->definitionLine = 2071;
// method pretty
  struct UserObject *uo8799 = (struct UserObject*)obj8693;
  uo8799->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty8799 = addmethod2pos(obj8693, "pretty", &meth_ast_pretty8799, 15);
  int argcv_meth_ast_pretty8799[] = {1};
  meth_meth_ast_pretty8799->type = alloc_MethodType(1, argcv_meth_ast_pretty8799);
  meth_meth_ast_pretty8799->definitionModule = modulename;
  meth_meth_ast_pretty8799->definitionLine = 2079;
// method toGrace
  struct UserObject *uo8893 = (struct UserObject*)obj8693;
  uo8893->data[16] = emptyclosure;
  Method *meth_meth_ast_toGrace8893 = addmethod2pos(obj8693, "toGrace", &meth_ast_toGrace8893, 16);
  int argcv_meth_ast_toGrace8893[] = {1};
  meth_meth_ast_toGrace8893->type = alloc_MethodType(1, argcv_meth_ast_toGrace8893);
meth_meth_ast_toGrace8893->type->types[0] = type_Number;
meth_meth_ast_toGrace8893->type->names[0] = "depth";
  meth_meth_ast_toGrace8893->definitionModule = modulename;
  meth_meth_ast_toGrace8893->definitionLine = 2092;
// method shallowCopyWithParent
  block_savedest(obj8693);
  Object closure8913 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure8913, stackframe);
  addtoclosure(closure8913, var_nullNode);
  addtoclosure(closure8913, var_importNode);
  struct UserObject *uo8913 = (struct UserObject*)obj8693;
  uo8913->data[17] = (Object)closure8913;
  Method *meth_meth_ast_shallowCopyWithParent8913 = addmethod2pos(obj8693, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent8913, 17);
  int argcv_meth_ast_shallowCopyWithParent8913[] = {1};
  meth_meth_ast_shallowCopyWithParent8913->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent8913);
  meth_meth_ast_shallowCopyWithParent8913->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent8913->definitionLine = 2095;
  sourceObject = obj8693;
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8921 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call8922 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe8921);
// compiled call node returning call8922 (depth = 4)
  struct UserObject *obj8693_uo = (struct UserObject *)obj8693;
  obj8693_uo->super = call8922;
  sourceObject = obj8693;
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit8923 == NULL) {
    strlit8923 = alloc_String("import");
    gc_root(strlit8923);
  }
// compiled string node returning strlit8923 (depth = 4)
  adddatum2(obj8693, strlit8923, 1);
  sourceObject = obj8693;
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_name_39_ (depth = 4)
  adddatum2(obj8693, *var_name_39_, 2);
  sourceObject = obj8693;
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj8693, *var_path_39_, 3);
  sourceObject = obj8693;
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8924 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8925 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call8926 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8925);
// compiled call node returning call8926 (depth = 7)
// compiled member node returning call8926 (depth = 6)
  partcv[0] = 0;
  Object call8927 = callmethod(call8926, "empty",
    1, partcv, params);
  gc_frame_end(callframe8924);
// compiled call node returning call8927 (depth = 5)
// compiled member node returning call8927 (depth = 4)
  adddatum2(obj8693, call8927, 4);
  sourceObject = obj8693;
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype_39_ (depth = 4)
  adddatum2(obj8693, *var_dtype_39_, 5);
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
  sourceObject = obj8693;
objclass8693 = obj8693->class;
  objclass8693->definitionModule = modulename;
  objclass8693->definitionLine = 2042;
  (*(struct UserObject *)self).data[0] = lowerouter8693;
  self = oldself8693;
  selfslot = oldselfslot8693;
  stackframe = oldstackframe8693;
  gc_frame_end(frame);
  return obj8693;
}
Object meth_ast_dialectNode8929(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dialectNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dialectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_dialectNode (depth = 3)
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept_40__41_from8937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2105
  setline(2105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8938 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pNode (depth = 5)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_visitor (depth = 5)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8939 = callmethod(*var_visitor, "visitDialect()up",
    2, partcv, params);
  gc_frame_end(callframe8938);
// compiled call node returning call8939 (depth = 4)
  gc_frame_end(frame);
  return call8939;
}
Object meth_ast_map_40__41_parent8940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8941 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call8942 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8941);
// compiled call node returning call8942 (depth = 5)
  *var_n = call8942;
  if (call8942 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8943 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8944 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe8943);
// compiled call node returning call8944 (depth = 5)
  *var_n = call8944;
  if (call8944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply8954(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2116
  setline(2116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit8956 == NULL) {
    strlit8956 = alloc_String("  ");
    gc_root(strlit8956);
  }
// compiled string node returning strlit8956 (depth = 8)
  int op_slot_right_8955 = gc_frame_newslot(strlit8956);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_8955 = gc_frame_newslot(*var_spc);
  params[0] = strlit8956;
  partcv[0] = 1;
  Object opresult8958 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult8958 (depth = 7)
  *var_spc = opresult8958;
  if (opresult8958 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty8946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit8947 == NULL) {
    strlit8947 = alloc_String("");
    gc_root(strlit8947);
  }
// compiled string node returning strlit8947 (depth = 5)
  *var_spc = strlit8947;
  if (strlit8947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8948 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_8949 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num8951 = alloc_Float64(0);
// compiled num node returning num8951 (depth = 6)
  int op_slot_left_8949 = gc_frame_newslot(num8951);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult8952 = callmethod(num8951, "..", 1, partcv, params);
// compiled op node returning opresult8952 (depth = 5)
  gc_frame_newslot(opresult8952);
// starting to compile block node (depth = 5)
  Object block8953 = alloc_Block(NULL, NULL, "ast", 2114);
  gc_frame_newslot(block8953);
// method _apply
  block_savedest(block8953);
  Object closure8954 = createclosure(2, "_apply");
  setclosureframe(closure8954, stackframe);
  addtoclosure(closure8954, var_spc);
  addtoclosure(closure8954, selfslot);
  struct UserObject *uo8954 = (struct UserObject*)block8953;
  uo8954->data[0] = (Object)closure8954;
  Method *meth_meth_ast__apply8954 = addmethod2pos(block8953, "_apply", &meth_ast__apply8954, 0);
  int argcv_meth_ast__apply8954[] = {1};
  meth_meth_ast__apply8954->type = alloc_MethodType(1, argcv_meth_ast__apply8954);
  meth_meth_ast__apply8954->definitionModule = modulename;
  meth_meth_ast__apply8954->definitionLine = 2099;
// compiled block node returning block8953 (depth = 5)
  gc_frame_newslot(block8953);
// call case 5: prelude request
  params[0] = opresult8952;
  params[1] = block8953;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8961 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8948);
// compiled call node returning call8961 (depth = 4)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8963 == NULL) {
    strlit8963 = alloc_String("""\x0a""");
    gc_root(strlit8963);
  }
// compiled string node returning strlit8963 (depth = 6)
  int op_slot_right_8962 = gc_frame_newslot(strlit8963);
// starting to compile call node (depth = 6)
  int callframe8965 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call8966 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe8965);
// compiled call node returning call8966 (depth = 6)
  int op_slot_left_8962 = gc_frame_newslot(call8966);
  params[0] = strlit8963;
  partcv[0] = 1;
  Object opresult8967 = callmethod(call8966, "++", 1, partcv, params);
// compiled op node returning opresult8967 (depth = 5)
  *var_s = opresult8967;
  if (opresult8967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8970 == NULL) {
    strlit8970 = alloc_String("""\x0a""");
    gc_root(strlit8970);
  }
// compiled string node returning strlit8970 (depth = 7)
  int op_slot_right_8969 = gc_frame_newslot(strlit8970);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8973 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8974 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8973);
// compiled call node returning call8974 (depth = 9)
// compiled member node returning call8974 (depth = 8)
  int op_slot_right_8972 = gc_frame_newslot(call8974);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8977 == NULL) {
    strlit8977 = alloc_String("Path: ");
    gc_root(strlit8977);
  }
// compiled string node returning strlit8977 (depth = 9)
  int op_slot_right_8976 = gc_frame_newslot(strlit8977);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_8979 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 10)
  if (strlit8981 == NULL) {
    strlit8981 = alloc_String("");
    gc_root(strlit8981);
  }
// compiled string node returning strlit8981 (depth = 10)
  int op_slot_left_8979 = gc_frame_newslot(strlit8981);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult8982 = callmethod(strlit8981, "++", 1, partcv, params);
// compiled op node returning opresult8982 (depth = 9)
  int op_slot_left_8976 = gc_frame_newslot(opresult8982);
  params[0] = strlit8977;
  partcv[0] = 1;
  Object opresult8983 = callmethod(opresult8982, "++", 1, partcv, params);
// compiled op node returning opresult8983 (depth = 8)
  int op_slot_left_8972 = gc_frame_newslot(opresult8983);
  params[0] = call8974;
  partcv[0] = 1;
  Object opresult8984 = callmethod(opresult8983, "++", 1, partcv, params);
// compiled op node returning opresult8984 (depth = 7)
  int op_slot_left_8969 = gc_frame_newslot(opresult8984);
  params[0] = strlit8970;
  partcv[0] = 1;
  Object opresult8985 = callmethod(opresult8984, "++", 1, partcv, params);
// compiled op node returning opresult8985 (depth = 6)
  int op_slot_right_8968 = gc_frame_newslot(opresult8985);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_8968 = gc_frame_newslot(*var_s);
  params[0] = opresult8985;
  partcv[0] = 1;
  Object opresult8987 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult8987 (depth = 5)
  *var_s = opresult8987;
  if (opresult8987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace8989(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8991 == NULL) {
    strlit8991 = alloc_String("""\x22""");
    gc_root(strlit8991);
  }
// compiled string node returning strlit8991 (depth = 5)
  int op_slot_right_8990 = gc_frame_newslot(strlit8991);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8994 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8995 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8994);
// compiled call node returning call8995 (depth = 7)
// compiled member node returning call8995 (depth = 6)
  int op_slot_right_8993 = gc_frame_newslot(call8995);
// starting to compile string node (depth = 6)
  if (strlit8997 == NULL) {
    strlit8997 = alloc_String("dialect ""\x22""");
    gc_root(strlit8997);
  }
// compiled string node returning strlit8997 (depth = 6)
  int op_slot_left_8993 = gc_frame_newslot(strlit8997);
  params[0] = call8995;
  partcv[0] = 1;
  Object opresult8998 = callmethod(strlit8997, "++", 1, partcv, params);
// compiled op node returning opresult8998 (depth = 5)
  int op_slot_left_8990 = gc_frame_newslot(opresult8998);
  params[0] = strlit8991;
  partcv[0] = 1;
  Object opresult8999 = callmethod(opresult8998, "++", 1, partcv, params);
// compiled op node returning opresult8999 (depth = 4)
  gc_frame_end(frame);
  return opresult8999;
}
Object meth_ast_shallowCopyWithParent9000(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9001 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9002 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9003 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9004 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9003);
// compiled call node returning call9004 (depth = 7)
// compiled member node returning call9004 (depth = 6)
  gc_frame_newslot(call9004);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dialectNode (depth = 6)
  params[0] = call9004;
  partcv[0] = 1;
  Object call9005 = callmethod(*var_dialectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9002);
// compiled call node returning call9005 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9006 = callmethod(call9005, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe9001);
// compiled call node returning call9006 (depth = 4)
  gc_frame_end(frame);
  return call9006;
}
Object meth_ast_new8932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8933 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8933 = alloc_userobj2(9,9, objclass8933);
  gc_frame_newslot(obj8933);
if (objclass8933 == NULL) {
  glfree(obj8933->class->name);
  obj8933->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8933, self, 0);
  addmethodreal(obj8933,"outer", &reader_ast_outer_8934);
  Object oldself8933 = self;
  struct StackFrameObject *oldstackframe8933 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8933);
  gc_frame_newslot((Object)stackframe);
  self = obj8933;
  Object *oldselfslot8933 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8933 = (*(struct UserObject *)self).data[0], lowerouter8933 = thisouter8933;
  if (inheritingObject8933) {
    struct UserObject *inho8933 = (struct UserObject *)inheritingObject8933;
    while (inho8933->super != GraceDefaultObject) inho8933 = (struct UserObject *)inho8933->super;
    inho8933->super = obj8933;
    self = inheritingObject8933;
    *selfslot = self;
    lowerouter8933 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8933;
  }
if (objclass8933 == NULL) {
  Method *reader8935 = addmethodrealflags(obj8933, "kind",&reader_ast_kind_8935, MFLAG_DEF);
  reader8935->definitionModule = modulename;
  reader8935->definitionLine = 2102;
}
adddatum2(obj8933, alloc_Undefined(), 1);
if (objclass8933 == NULL) {
  Method *reader8936 = addmethodrealflags(obj8933, "value",&reader_ast_value_8936, 0);
  Method *writer8936 = addmethodrealflags(obj8933, "value:=",&writer_ast_value_8936, 0);
  reader8936->definitionModule = modulename;
  writer8936->definitionModule = modulename;
  reader8936->definitionLine = 2104;
  writer8936->definitionLine = 2104;
}
obj8933->flags |= OFLAG_MUTABLE;
adddatum2(obj8933, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo8937 = (struct UserObject*)obj8933;
  uo8937->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8937 = addmethod2pos(obj8933, "accept()from", &meth_ast_accept_40__41_from8937, 3);
  int argcv_meth_ast_accept_40__41_from8937[] = {1, 1};
  meth_meth_ast_accept_40__41_from8937->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8937);
  meth_meth_ast_accept_40__41_from8937->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8937->definitionLine = 2104;
// method map()parent
  struct UserObject *uo8940 = (struct UserObject*)obj8933;
  uo8940->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent8940 = addmethod2pos(obj8933, "map()parent", &meth_ast_map_40__41_parent8940, 4);
  int argcv_meth_ast_map_40__41_parent8940[] = {1, 1};
  meth_meth_ast_map_40__41_parent8940->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent8940);
  meth_meth_ast_map_40__41_parent8940->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent8940->definitionLine = 2107;
// method pretty
  struct UserObject *uo8946 = (struct UserObject*)obj8933;
  uo8946->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty8946 = addmethod2pos(obj8933, "pretty", &meth_ast_pretty8946, 5);
  int argcv_meth_ast_pretty8946[] = {1};
  meth_meth_ast_pretty8946->type = alloc_MethodType(1, argcv_meth_ast_pretty8946);
  meth_meth_ast_pretty8946->definitionModule = modulename;
  meth_meth_ast_pretty8946->definitionLine = 2112;
// method toGrace
  struct UserObject *uo8989 = (struct UserObject*)obj8933;
  uo8989->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace8989 = addmethod2pos(obj8933, "toGrace", &meth_ast_toGrace8989, 6);
  int argcv_meth_ast_toGrace8989[] = {1};
  meth_meth_ast_toGrace8989->type = alloc_MethodType(1, argcv_meth_ast_toGrace8989);
meth_meth_ast_toGrace8989->type->types[0] = type_Number;
meth_meth_ast_toGrace8989->type->names[0] = "depth";
  meth_meth_ast_toGrace8989->definitionModule = modulename;
  meth_meth_ast_toGrace8989->definitionLine = 2121;
// method shallowCopyWithParent
  block_savedest(obj8933);
  Object closure9000 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9000, stackframe);
  addtoclosure(closure9000, var_dialectNode);
  struct UserObject *uo9000 = (struct UserObject*)obj8933;
  uo9000->data[7] = (Object)closure9000;
  Method *meth_meth_ast_shallowCopyWithParent9000 = addmethod2pos(obj8933, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9000, 7);
  int argcv_meth_ast_shallowCopyWithParent9000[] = {1};
  meth_meth_ast_shallowCopyWithParent9000->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9000);
  meth_meth_ast_shallowCopyWithParent9000->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9000->definitionLine = 2124;
  sourceObject = obj8933;
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9007 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9008 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9007);
// compiled call node returning call9008 (depth = 4)
  struct UserObject *obj8933_uo = (struct UserObject *)obj8933;
  obj8933_uo->super = call9008;
  sourceObject = obj8933;
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9009 == NULL) {
    strlit9009 = alloc_String("dialect");
    gc_root(strlit9009);
  }
// compiled string node returning strlit9009 (depth = 4)
  adddatum2(obj8933, strlit9009, 1);
  sourceObject = obj8933;
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj8933, *var_path_39_, 2);
  sourceObject = obj8933;
  sourceObject = obj8933;
  sourceObject = obj8933;
  sourceObject = obj8933;
  sourceObject = obj8933;
objclass8933 = obj8933->class;
  objclass8933->definitionModule = modulename;
  objclass8933->definitionLine = 2099;
  (*(struct UserObject *)self).data[0] = lowerouter8933;
  self = oldself8933;
  selfslot = oldselfslot8933;
  stackframe = oldstackframe8933;
  gc_frame_end(frame);
  return obj8933;
}
Object meth_ast_new8932_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_dialectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject8933 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8933 = alloc_userobj2(9,9, objclass8933);
  gc_frame_newslot(obj8933);
if (objclass8933 == NULL) {
  glfree(obj8933->class->name);
  obj8933->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj8933, self, 0);
  addmethodreal(obj8933,"outer", &reader_ast_outer_8934);
  Object oldself8933 = self;
  struct StackFrameObject *oldstackframe8933 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8933);
  gc_frame_newslot((Object)stackframe);
  self = obj8933;
  Object *oldselfslot8933 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8933 = (*(struct UserObject *)self).data[0], lowerouter8933 = thisouter8933;
  if (inheritingObject8933) {
    struct UserObject *inho8933 = (struct UserObject *)inheritingObject8933;
    while (inho8933->super != GraceDefaultObject) inho8933 = (struct UserObject *)inho8933->super;
    inho8933->super = obj8933;
    self = inheritingObject8933;
    *selfslot = self;
    lowerouter8933 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8933;
  }
if (objclass8933 == NULL) {
  Method *reader8935 = addmethodrealflags(obj8933, "kind",&reader_ast_kind_8935, MFLAG_DEF);
  reader8935->definitionModule = modulename;
  reader8935->definitionLine = 2102;
}
adddatum2(obj8933, alloc_Undefined(), 1);
if (objclass8933 == NULL) {
  Method *reader8936 = addmethodrealflags(obj8933, "value",&reader_ast_value_8936, 0);
  Method *writer8936 = addmethodrealflags(obj8933, "value:=",&writer_ast_value_8936, 0);
  reader8936->definitionModule = modulename;
  writer8936->definitionModule = modulename;
  reader8936->definitionLine = 2104;
  writer8936->definitionLine = 2104;
}
obj8933->flags |= OFLAG_MUTABLE;
adddatum2(obj8933, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo8937 = (struct UserObject*)obj8933;
  uo8937->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from8937 = addmethod2pos(obj8933, "accept()from", &meth_ast_accept_40__41_from8937, 3);
  int argcv_meth_ast_accept_40__41_from8937[] = {1, 1};
  meth_meth_ast_accept_40__41_from8937->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from8937);
  meth_meth_ast_accept_40__41_from8937->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from8937->definitionLine = 2104;
// method map()parent
  struct UserObject *uo8940 = (struct UserObject*)obj8933;
  uo8940->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent8940 = addmethod2pos(obj8933, "map()parent", &meth_ast_map_40__41_parent8940, 4);
  int argcv_meth_ast_map_40__41_parent8940[] = {1, 1};
  meth_meth_ast_map_40__41_parent8940->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent8940);
  meth_meth_ast_map_40__41_parent8940->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent8940->definitionLine = 2107;
// method pretty
  struct UserObject *uo8946 = (struct UserObject*)obj8933;
  uo8946->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty8946 = addmethod2pos(obj8933, "pretty", &meth_ast_pretty8946, 5);
  int argcv_meth_ast_pretty8946[] = {1};
  meth_meth_ast_pretty8946->type = alloc_MethodType(1, argcv_meth_ast_pretty8946);
  meth_meth_ast_pretty8946->definitionModule = modulename;
  meth_meth_ast_pretty8946->definitionLine = 2112;
// method toGrace
  struct UserObject *uo8989 = (struct UserObject*)obj8933;
  uo8989->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace8989 = addmethod2pos(obj8933, "toGrace", &meth_ast_toGrace8989, 6);
  int argcv_meth_ast_toGrace8989[] = {1};
  meth_meth_ast_toGrace8989->type = alloc_MethodType(1, argcv_meth_ast_toGrace8989);
meth_meth_ast_toGrace8989->type->types[0] = type_Number;
meth_meth_ast_toGrace8989->type->names[0] = "depth";
  meth_meth_ast_toGrace8989->definitionModule = modulename;
  meth_meth_ast_toGrace8989->definitionLine = 2121;
// method shallowCopyWithParent
  block_savedest(obj8933);
  Object closure9000 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9000, stackframe);
  addtoclosure(closure9000, var_dialectNode);
  struct UserObject *uo9000 = (struct UserObject*)obj8933;
  uo9000->data[7] = (Object)closure9000;
  Method *meth_meth_ast_shallowCopyWithParent9000 = addmethod2pos(obj8933, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9000, 7);
  int argcv_meth_ast_shallowCopyWithParent9000[] = {1};
  meth_meth_ast_shallowCopyWithParent9000->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9000);
  meth_meth_ast_shallowCopyWithParent9000->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9000->definitionLine = 2124;
  sourceObject = obj8933;
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9007 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9008 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9007);
// compiled call node returning call9008 (depth = 4)
  struct UserObject *obj8933_uo = (struct UserObject *)obj8933;
  obj8933_uo->super = call9008;
  sourceObject = obj8933;
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9009 == NULL) {
    strlit9009 = alloc_String("dialect");
    gc_root(strlit9009);
  }
// compiled string node returning strlit9009 (depth = 4)
  adddatum2(obj8933, strlit9009, 1);
  sourceObject = obj8933;
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_path_39_ (depth = 4)
  adddatum2(obj8933, *var_path_39_, 2);
  sourceObject = obj8933;
  sourceObject = obj8933;
  sourceObject = obj8933;
  sourceObject = obj8933;
  sourceObject = obj8933;
objclass8933 = obj8933->class;
  objclass8933->definitionModule = modulename;
  objclass8933->definitionLine = 2099;
  (*(struct UserObject *)self).data[0] = lowerouter8933;
  self = oldself8933;
  selfslot = oldselfslot8933;
  stackframe = oldstackframe8933;
  gc_frame_end(frame);
  return obj8933;
}
Object meth_ast_returnNode9011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for returnNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_returnNode (depth = 3)
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_accept_40__41_from9019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9021 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9022 = callmethod(*var_visitor, "visitReturn()up",
    2, partcv, params);
  gc_frame_end(callframe9021);
// compiled call node returning call9022 (depth = 5)
  Object if9020 = done;
  if (istrue(call9022)) {
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9023 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9024 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9025 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9024);
// compiled call node returning call9025 (depth = 7)
// compiled member node returning call9025 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9026 = callmethod(call9025, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9023);
// compiled call node returning call9026 (depth = 5)
    gc_frame_newslot(call9026);
    if9020 = call9026;
  } else {
  }
// compiled if node returning if9020 (depth = 4)
  gc_frame_end(frame);
  return if9020;
}
Object meth_ast_map_40__41_parent9027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9028 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call9029 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9028);
// compiled call node returning call9029 (depth = 5)
  *var_n = call9029;
  if (call9029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9030 = gc_frame_new();
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9031 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9032 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9033 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9032);
// compiled call node returning call9033 (depth = 8)
// compiled member node returning call9033 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9034 = callmethod(call9033, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe9031);
// compiled call node returning call9034 (depth = 6)
  gc_frame_newslot(call9034);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9034;
  partcv[0] = 1;
  Object call9035 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9030);
// compiled call node returning call9035 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9036 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9037 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9036);
// compiled call node returning call9037 (depth = 5)
  *var_n = call9037;
  if (call9037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply9047(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit9049 == NULL) {
    strlit9049 = alloc_String("  ");
    gc_root(strlit9049);
  }
// compiled string node returning strlit9049 (depth = 8)
  int op_slot_right_9048 = gc_frame_newslot(strlit9049);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9048 = gc_frame_newslot(*var_spc);
  params[0] = strlit9049;
  partcv[0] = 1;
  Object opresult9051 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9051 (depth = 7)
  *var_spc = opresult9051;
  if (opresult9051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit9040 == NULL) {
    strlit9040 = alloc_String("");
    gc_root(strlit9040);
  }
// compiled string node returning strlit9040 (depth = 5)
  *var_spc = strlit9040;
  if (strlit9040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9041 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9042 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9044 = alloc_Float64(0);
// compiled num node returning num9044 (depth = 6)
  int op_slot_left_9042 = gc_frame_newslot(num9044);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9045 = callmethod(num9044, "..", 1, partcv, params);
// compiled op node returning opresult9045 (depth = 5)
  gc_frame_newslot(opresult9045);
// starting to compile block node (depth = 5)
  Object block9046 = alloc_Block(NULL, NULL, "ast", 2146);
  gc_frame_newslot(block9046);
// method _apply
  block_savedest(block9046);
  Object closure9047 = createclosure(2, "_apply");
  setclosureframe(closure9047, stackframe);
  addtoclosure(closure9047, var_spc);
  addtoclosure(closure9047, selfslot);
  struct UserObject *uo9047 = (struct UserObject*)block9046;
  uo9047->data[0] = (Object)closure9047;
  Method *meth_meth_ast__apply9047 = addmethod2pos(block9046, "_apply", &meth_ast__apply9047, 0);
  int argcv_meth_ast__apply9047[] = {1};
  meth_meth_ast__apply9047->type = alloc_MethodType(1, argcv_meth_ast__apply9047);
  meth_meth_ast__apply9047->definitionModule = modulename;
  meth_meth_ast__apply9047->definitionLine = 2140;
// compiled block node returning block9046 (depth = 5)
  gc_frame_newslot(block9046);
// call case 5: prelude request
  params[0] = opresult9045;
  params[1] = block9046;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9054 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9041);
// compiled call node returning call9054 (depth = 4)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9056 == NULL) {
    strlit9056 = alloc_String("""\x0a""");
    gc_root(strlit9056);
  }
// compiled string node returning strlit9056 (depth = 6)
  int op_slot_right_9055 = gc_frame_newslot(strlit9056);
// starting to compile call node (depth = 6)
  int callframe9058 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9059 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9058);
// compiled call node returning call9059 (depth = 6)
  int op_slot_left_9055 = gc_frame_newslot(call9059);
  params[0] = strlit9056;
  partcv[0] = 1;
  Object opresult9060 = callmethod(call9059, "++", 1, partcv, params);
// compiled op node returning opresult9060 (depth = 5)
  *var_s = opresult9060;
  if (opresult9060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9062 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9064 = alloc_Float64(1);
// compiled num node returning num9064 (depth = 8)
  int op_slot_right_9063 = gc_frame_newslot(num9064);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9063 = gc_frame_newslot(*var_depth);
  params[0] = num9064;
  partcv[0] = 1;
  Object sum9066 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9066 (depth = 7)
  gc_frame_newslot(sum9066);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9067 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9068 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9067);
// compiled call node returning call9068 (depth = 8)
// compiled member node returning call9068 (depth = 7)
  params[0] = sum9066;
  partcv[0] = 1;
  Object call9069 = callmethod(call9068, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9062);
// compiled call node returning call9069 (depth = 6)
  int op_slot_right_9061 = gc_frame_newslot(call9069);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9071 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9071 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9073 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9073 (depth = 6)
  int op_slot_left_9061 = gc_frame_newslot(opresult9073);
  params[0] = call9069;
  partcv[0] = 1;
  Object opresult9074 = callmethod(opresult9073, "++", 1, partcv, params);
// compiled op node returning opresult9074 (depth = 5)
  *var_s = opresult9074;
  if (opresult9074 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9076(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9078 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  gc_frame_newslot(*var_depth);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9080 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9079);
// compiled call node returning call9080 (depth = 7)
// compiled member node returning call9080 (depth = 6)
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9081 = callmethod(call9080, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9078);
// compiled call node returning call9081 (depth = 5)
  int op_slot_right_9077 = gc_frame_newslot(call9081);
// starting to compile string node (depth = 5)
  if (strlit9083 == NULL) {
    strlit9083 = alloc_String("return ");
    gc_root(strlit9083);
  }
// compiled string node returning strlit9083 (depth = 5)
  int op_slot_left_9077 = gc_frame_newslot(strlit9083);
  params[0] = call9081;
  partcv[0] = 1;
  Object opresult9084 = callmethod(strlit9083, "++", 1, partcv, params);
// compiled op node returning opresult9084 (depth = 4)
  gc_frame_end(frame);
  return opresult9084;
}
Object meth_ast_shallowCopyWithParent9085(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9086 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9087 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_returnNode (depth = 6)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9088 = callmethod(*var_returnNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9087);
// compiled call node returning call9088 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9089 = callmethod(call9088, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe9086);
// compiled call node returning call9089 (depth = 4)
  gc_frame_end(frame);
  return call9089;
}
Object meth_ast_new9014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9015 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9015 = alloc_userobj2(9,9, objclass9015);
  gc_frame_newslot(obj9015);
if (objclass9015 == NULL) {
  glfree(obj9015->class->name);
  obj9015->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9015, self, 0);
  addmethodreal(obj9015,"outer", &reader_ast_outer_9016);
  Object oldself9015 = self;
  struct StackFrameObject *oldstackframe9015 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9015);
  gc_frame_newslot((Object)stackframe);
  self = obj9015;
  Object *oldselfslot9015 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9015 = (*(struct UserObject *)self).data[0], lowerouter9015 = thisouter9015;
  if (inheritingObject9015) {
    struct UserObject *inho9015 = (struct UserObject *)inheritingObject9015;
    while (inho9015->super != GraceDefaultObject) inho9015 = (struct UserObject *)inho9015->super;
    inho9015->super = obj9015;
    self = inheritingObject9015;
    *selfslot = self;
    lowerouter9015 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9015;
  }
if (objclass9015 == NULL) {
  Method *reader9017 = addmethodrealflags(obj9015, "kind",&reader_ast_kind_9017, MFLAG_DEF);
  reader9017->definitionModule = modulename;
  reader9017->definitionLine = 2131;
}
adddatum2(obj9015, alloc_Undefined(), 1);
if (objclass9015 == NULL) {
  Method *reader9018 = addmethodrealflags(obj9015, "value",&reader_ast_value_9018, 0);
  Method *writer9018 = addmethodrealflags(obj9015, "value:=",&writer_ast_value_9018, 0);
  reader9018->definitionModule = modulename;
  writer9018->definitionModule = modulename;
  reader9018->definitionLine = 2133;
  writer9018->definitionLine = 2133;
}
obj9015->flags |= OFLAG_MUTABLE;
adddatum2(obj9015, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9019 = (struct UserObject*)obj9015;
  uo9019->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9019 = addmethod2pos(obj9015, "accept()from", &meth_ast_accept_40__41_from9019, 3);
  int argcv_meth_ast_accept_40__41_from9019[] = {1, 1};
  meth_meth_ast_accept_40__41_from9019->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9019);
  meth_meth_ast_accept_40__41_from9019->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9019->definitionLine = 2133;
// method map()parent
  struct UserObject *uo9027 = (struct UserObject*)obj9015;
  uo9027->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9027 = addmethod2pos(obj9015, "map()parent", &meth_ast_map_40__41_parent9027, 4);
  int argcv_meth_ast_map_40__41_parent9027[] = {1, 1};
  meth_meth_ast_map_40__41_parent9027->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9027);
  meth_meth_ast_map_40__41_parent9027->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9027->definitionLine = 2138;
// method pretty
  struct UserObject *uo9039 = (struct UserObject*)obj9015;
  uo9039->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty9039 = addmethod2pos(obj9015, "pretty", &meth_ast_pretty9039, 5);
  int argcv_meth_ast_pretty9039[] = {1};
  meth_meth_ast_pretty9039->type = alloc_MethodType(1, argcv_meth_ast_pretty9039);
  meth_meth_ast_pretty9039->definitionModule = modulename;
  meth_meth_ast_pretty9039->definitionLine = 2144;
// method toGrace
  struct UserObject *uo9076 = (struct UserObject*)obj9015;
  uo9076->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9076 = addmethod2pos(obj9015, "toGrace", &meth_ast_toGrace9076, 6);
  int argcv_meth_ast_toGrace9076[] = {1};
  meth_meth_ast_toGrace9076->type = alloc_MethodType(1, argcv_meth_ast_toGrace9076);
meth_meth_ast_toGrace9076->type->types[0] = type_Number;
meth_meth_ast_toGrace9076->type->names[0] = "depth";
  meth_meth_ast_toGrace9076->definitionModule = modulename;
  meth_meth_ast_toGrace9076->definitionLine = 2153;
// method shallowCopyWithParent
  block_savedest(obj9015);
  Object closure9085 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure9085, stackframe);
  addtoclosure(closure9085, var_nullNode);
  addtoclosure(closure9085, var_returnNode);
  struct UserObject *uo9085 = (struct UserObject*)obj9015;
  uo9085->data[7] = (Object)closure9085;
  Method *meth_meth_ast_shallowCopyWithParent9085 = addmethod2pos(obj9015, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9085, 7);
  int argcv_meth_ast_shallowCopyWithParent9085[] = {1};
  meth_meth_ast_shallowCopyWithParent9085->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9085);
  meth_meth_ast_shallowCopyWithParent9085->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9085->definitionLine = 2156;
  sourceObject = obj9015;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9090 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9091 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9090);
// compiled call node returning call9091 (depth = 4)
  struct UserObject *obj9015_uo = (struct UserObject *)obj9015;
  obj9015_uo->super = call9091;
  sourceObject = obj9015;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9092 == NULL) {
    strlit9092 = alloc_String("return");
    gc_root(strlit9092);
  }
// compiled string node returning strlit9092 (depth = 4)
  adddatum2(obj9015, strlit9092, 1);
  sourceObject = obj9015;
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj9015, *var_expr, 2);
  sourceObject = obj9015;
  sourceObject = obj9015;
  sourceObject = obj9015;
  sourceObject = obj9015;
  sourceObject = obj9015;
objclass9015 = obj9015->class;
  objclass9015->definitionModule = modulename;
  objclass9015->definitionLine = 2128;
  (*(struct UserObject *)self).data[0] = lowerouter9015;
  self = oldself9015;
  selfslot = oldselfslot9015;
  stackframe = oldstackframe9015;
  gc_frame_end(frame);
  return obj9015;
}
Object meth_ast_new9014_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_returnNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9015 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9015 = alloc_userobj2(9,9, objclass9015);
  gc_frame_newslot(obj9015);
if (objclass9015 == NULL) {
  glfree(obj9015->class->name);
  obj9015->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9015, self, 0);
  addmethodreal(obj9015,"outer", &reader_ast_outer_9016);
  Object oldself9015 = self;
  struct StackFrameObject *oldstackframe9015 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9015);
  gc_frame_newslot((Object)stackframe);
  self = obj9015;
  Object *oldselfslot9015 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9015 = (*(struct UserObject *)self).data[0], lowerouter9015 = thisouter9015;
  if (inheritingObject9015) {
    struct UserObject *inho9015 = (struct UserObject *)inheritingObject9015;
    while (inho9015->super != GraceDefaultObject) inho9015 = (struct UserObject *)inho9015->super;
    inho9015->super = obj9015;
    self = inheritingObject9015;
    *selfslot = self;
    lowerouter9015 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9015;
  }
if (objclass9015 == NULL) {
  Method *reader9017 = addmethodrealflags(obj9015, "kind",&reader_ast_kind_9017, MFLAG_DEF);
  reader9017->definitionModule = modulename;
  reader9017->definitionLine = 2131;
}
adddatum2(obj9015, alloc_Undefined(), 1);
if (objclass9015 == NULL) {
  Method *reader9018 = addmethodrealflags(obj9015, "value",&reader_ast_value_9018, 0);
  Method *writer9018 = addmethodrealflags(obj9015, "value:=",&writer_ast_value_9018, 0);
  reader9018->definitionModule = modulename;
  writer9018->definitionModule = modulename;
  reader9018->definitionLine = 2133;
  writer9018->definitionLine = 2133;
}
obj9015->flags |= OFLAG_MUTABLE;
adddatum2(obj9015, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9019 = (struct UserObject*)obj9015;
  uo9019->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9019 = addmethod2pos(obj9015, "accept()from", &meth_ast_accept_40__41_from9019, 3);
  int argcv_meth_ast_accept_40__41_from9019[] = {1, 1};
  meth_meth_ast_accept_40__41_from9019->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9019);
  meth_meth_ast_accept_40__41_from9019->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9019->definitionLine = 2133;
// method map()parent
  struct UserObject *uo9027 = (struct UserObject*)obj9015;
  uo9027->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9027 = addmethod2pos(obj9015, "map()parent", &meth_ast_map_40__41_parent9027, 4);
  int argcv_meth_ast_map_40__41_parent9027[] = {1, 1};
  meth_meth_ast_map_40__41_parent9027->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9027);
  meth_meth_ast_map_40__41_parent9027->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9027->definitionLine = 2138;
// method pretty
  struct UserObject *uo9039 = (struct UserObject*)obj9015;
  uo9039->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty9039 = addmethod2pos(obj9015, "pretty", &meth_ast_pretty9039, 5);
  int argcv_meth_ast_pretty9039[] = {1};
  meth_meth_ast_pretty9039->type = alloc_MethodType(1, argcv_meth_ast_pretty9039);
  meth_meth_ast_pretty9039->definitionModule = modulename;
  meth_meth_ast_pretty9039->definitionLine = 2144;
// method toGrace
  struct UserObject *uo9076 = (struct UserObject*)obj9015;
  uo9076->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace9076 = addmethod2pos(obj9015, "toGrace", &meth_ast_toGrace9076, 6);
  int argcv_meth_ast_toGrace9076[] = {1};
  meth_meth_ast_toGrace9076->type = alloc_MethodType(1, argcv_meth_ast_toGrace9076);
meth_meth_ast_toGrace9076->type->types[0] = type_Number;
meth_meth_ast_toGrace9076->type->names[0] = "depth";
  meth_meth_ast_toGrace9076->definitionModule = modulename;
  meth_meth_ast_toGrace9076->definitionLine = 2153;
// method shallowCopyWithParent
  block_savedest(obj9015);
  Object closure9085 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure9085, stackframe);
  addtoclosure(closure9085, var_nullNode);
  addtoclosure(closure9085, var_returnNode);
  struct UserObject *uo9085 = (struct UserObject*)obj9015;
  uo9085->data[7] = (Object)closure9085;
  Method *meth_meth_ast_shallowCopyWithParent9085 = addmethod2pos(obj9015, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9085, 7);
  int argcv_meth_ast_shallowCopyWithParent9085[] = {1};
  meth_meth_ast_shallowCopyWithParent9085->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9085);
  meth_meth_ast_shallowCopyWithParent9085->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9085->definitionLine = 2156;
  sourceObject = obj9015;
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9090 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9091 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9090);
// compiled call node returning call9091 (depth = 4)
  struct UserObject *obj9015_uo = (struct UserObject *)obj9015;
  obj9015_uo->super = call9091;
  sourceObject = obj9015;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9092 == NULL) {
    strlit9092 = alloc_String("return");
    gc_root(strlit9092);
  }
// compiled string node returning strlit9092 (depth = 4)
  adddatum2(obj9015, strlit9092, 1);
  sourceObject = obj9015;
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj9015, *var_expr, 2);
  sourceObject = obj9015;
  sourceObject = obj9015;
  sourceObject = obj9015;
  sourceObject = obj9015;
  sourceObject = obj9015;
objclass9015 = obj9015->class;
  objclass9015->definitionModule = modulename;
  objclass9015->definitionLine = 2128;
  (*(struct UserObject *)self).data[0] = lowerouter9015;
  self = oldself9015;
  selfslot = oldselfslot9015;
  stackframe = oldstackframe9015;
  gc_frame_end(frame);
  return obj9015;
}
Object meth_ast_inheritsNode9094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inheritsNode (depth = 3)
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_isInherits9103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isInherits (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for isInherits");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9104 = alloc_Boolean(1);
// compiled identifier node returning bool9104 (depth = 4)
  gc_frame_end(frame);
  return bool9104;
}
Object meth_ast_inheritsFromMember9105(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsFromMember (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsFromMember");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9106 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9108 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9107);
// compiled call node returning call9108 (depth = 7)
// compiled member node returning call9108 (depth = 6)
  partcv[0] = 0;
  Object call9109 = callmethod(call9108, "isMember",
    1, partcv, params);
  gc_frame_end(callframe9106);
// compiled call node returning call9109 (depth = 5)
// compiled member node returning call9109 (depth = 4)
  gc_frame_end(frame);
  return call9109;
}
Object meth_ast_inheritsFromCall9110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "inheritsFromCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsFromCall (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsFromCall");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9111 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9112 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9113 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9112);
// compiled call node returning call9113 (depth = 7)
// compiled member node returning call9113 (depth = 6)
  partcv[0] = 0;
  Object call9114 = callmethod(call9113, "isCall",
    1, partcv, params);
  gc_frame_end(callframe9111);
// compiled call node returning call9114 (depth = 5)
// compiled member node returning call9114 (depth = 4)
  gc_frame_end(frame);
  return call9114;
}
Object meth_ast_accept_40__41_from9115(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9117 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9118 = callmethod(*var_visitor, "visitInherits()up",
    2, partcv, params);
  gc_frame_end(callframe9117);
// compiled call node returning call9118 (depth = 5)
  Object if9116 = done;
  if (istrue(call9118)) {
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9119 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9121 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9120);
// compiled call node returning call9121 (depth = 7)
// compiled member node returning call9121 (depth = 6)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9122 = callmethod(call9121, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9119);
// compiled call node returning call9122 (depth = 5)
    gc_frame_newslot(call9122);
    if9116 = call9122;
  } else {
  }
// compiled if node returning if9116 (depth = 4)
  gc_frame_end(frame);
  return if9116;
}
Object meth_ast_map_40__41_parent9123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9124 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call9125 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9124);
// compiled call node returning call9125 (depth = 5)
  *var_n = call9125;
  if (call9125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9126 = gc_frame_new();
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9127 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9128 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9129 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9128);
// compiled call node returning call9129 (depth = 8)
// compiled member node returning call9129 (depth = 7)
  params[0] = *var_blk;
  params[1] = *var_n;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9130 = callmethod(call9129, "map()parent",
    2, partcv, params);
  gc_frame_end(callframe9127);
// compiled call node returning call9130 (depth = 6)
  gc_frame_newslot(call9130);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9130;
  partcv[0] = 1;
  Object call9131 = callmethod(*var_n, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9126);
// compiled call node returning call9131 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9132 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9133 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9132);
// compiled call node returning call9133 (depth = 5)
  *var_n = call9133;
  if (call9133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply9143(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit9145 == NULL) {
    strlit9145 = alloc_String("  ");
    gc_root(strlit9145);
  }
// compiled string node returning strlit9145 (depth = 8)
  int op_slot_right_9144 = gc_frame_newslot(strlit9145);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9144 = gc_frame_newslot(*var_spc);
  params[0] = strlit9145;
  partcv[0] = 1;
  Object opresult9147 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9147 (depth = 7)
  *var_spc = opresult9147;
  if (opresult9147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9135(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit9136 == NULL) {
    strlit9136 = alloc_String("");
    gc_root(strlit9136);
  }
// compiled string node returning strlit9136 (depth = 5)
  *var_spc = strlit9136;
  if (strlit9136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9137 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9138 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9140 = alloc_Float64(0);
// compiled num node returning num9140 (depth = 6)
  int op_slot_left_9138 = gc_frame_newslot(num9140);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9141 = callmethod(num9140, "..", 1, partcv, params);
// compiled op node returning opresult9141 (depth = 5)
  gc_frame_newslot(opresult9141);
// starting to compile block node (depth = 5)
  Object block9142 = alloc_Block(NULL, NULL, "ast", 2182);
  gc_frame_newslot(block9142);
// method _apply
  block_savedest(block9142);
  Object closure9143 = createclosure(2, "_apply");
  setclosureframe(closure9143, stackframe);
  addtoclosure(closure9143, var_spc);
  addtoclosure(closure9143, selfslot);
  struct UserObject *uo9143 = (struct UserObject*)block9142;
  uo9143->data[0] = (Object)closure9143;
  Method *meth_meth_ast__apply9143 = addmethod2pos(block9142, "_apply", &meth_ast__apply9143, 0);
  int argcv_meth_ast__apply9143[] = {1};
  meth_meth_ast__apply9143->type = alloc_MethodType(1, argcv_meth_ast__apply9143);
  meth_meth_ast__apply9143->definitionModule = modulename;
  meth_meth_ast__apply9143->definitionLine = 2176;
// compiled block node returning block9142 (depth = 5)
  gc_frame_newslot(block9142);
// call case 5: prelude request
  params[0] = opresult9141;
  params[1] = block9142;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9150 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9137);
// compiled call node returning call9150 (depth = 4)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9152 == NULL) {
    strlit9152 = alloc_String("""\x0a""");
    gc_root(strlit9152);
  }
// compiled string node returning strlit9152 (depth = 6)
  int op_slot_right_9151 = gc_frame_newslot(strlit9152);
// starting to compile call node (depth = 6)
  int callframe9154 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_depth (depth = 7)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9155 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9154);
// compiled call node returning call9155 (depth = 6)
  int op_slot_left_9151 = gc_frame_newslot(call9155);
  params[0] = strlit9152;
  partcv[0] = 1;
  Object opresult9156 = callmethod(call9155, "++", 1, partcv, params);
// compiled op node returning opresult9156 (depth = 5)
  *var_s = opresult9156;
  if (opresult9156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9158 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9160 = alloc_Float64(1);
// compiled num node returning num9160 (depth = 8)
  int op_slot_right_9159 = gc_frame_newslot(num9160);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_depth (depth = 8)
  int op_slot_left_9159 = gc_frame_newslot(*var_depth);
  params[0] = num9160;
  partcv[0] = 1;
  Object sum9162 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9162 (depth = 7)
  gc_frame_newslot(sum9162);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9163 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9164 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9163);
// compiled call node returning call9164 (depth = 8)
// compiled member node returning call9164 (depth = 7)
  params[0] = sum9162;
  partcv[0] = 1;
  Object call9165 = callmethod(call9164, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9158);
// compiled call node returning call9165 (depth = 6)
  int op_slot_right_9157 = gc_frame_newslot(call9165);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9167 = gc_frame_newslot(*var_spc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9167 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9169 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9169 (depth = 6)
  int op_slot_left_9157 = gc_frame_newslot(opresult9169);
  params[0] = call9165;
  partcv[0] = 1;
  Object opresult9170 = callmethod(opresult9169, "++", 1, partcv, params);
// compiled op node returning opresult9170 (depth = 5)
  *var_s = opresult9170;
  if (opresult9170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9173 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9174 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9175 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9176 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9175);
// compiled call node returning call9176 (depth = 10)
// compiled member node returning call9176 (depth = 9)
  partcv[0] = 0;
  Object call9177 = callmethod(call9176, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe9174);
// compiled call node returning call9177 (depth = 8)
// compiled member node returning call9177 (depth = 7)
  partcv[0] = 0;
  Object call9178 = callmethod(call9177, "not",
    1, partcv, params);
  gc_frame_end(callframe9173);
// compiled call node returning call9178 (depth = 6)
// compiled member node returning call9178 (depth = 5)
  Object if9172 = done;
  if (istrue(call9178)) {
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9181 == NULL) {
    strlit9181 = alloc_String("");
    gc_root(strlit9181);
  }
// compiled string node returning strlit9181 (depth = 8)
  int op_slot_right_9180 = gc_frame_newslot(strlit9181);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9184 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9185 = callmethodflags(self, "providedNames", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9184);
// compiled call node returning call9185 (depth = 10)
// compiled member node returning call9185 (depth = 9)
  int op_slot_right_9183 = gc_frame_newslot(call9185);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9188 == NULL) {
    strlit9188 = alloc_String("Provided names: ");
    gc_root(strlit9188);
  }
// compiled string node returning strlit9188 (depth = 10)
  int op_slot_right_9187 = gc_frame_newslot(strlit9188);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_9190 = gc_frame_newslot(*var_spc);
// starting to compile string node (depth = 11)
  if (strlit9192 == NULL) {
    strlit9192 = alloc_String("""\x0a""");
    gc_root(strlit9192);
  }
// compiled string node returning strlit9192 (depth = 11)
  int op_slot_left_9190 = gc_frame_newslot(strlit9192);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9193 = callmethod(strlit9192, "++", 1, partcv, params);
// compiled op node returning opresult9193 (depth = 10)
  int op_slot_left_9187 = gc_frame_newslot(opresult9193);
  params[0] = strlit9188;
  partcv[0] = 1;
  Object opresult9194 = callmethod(opresult9193, "++", 1, partcv, params);
// compiled op node returning opresult9194 (depth = 9)
  int op_slot_left_9183 = gc_frame_newslot(opresult9194);
  params[0] = call9185;
  partcv[0] = 1;
  Object opresult9195 = callmethod(opresult9194, "++", 1, partcv, params);
// compiled op node returning opresult9195 (depth = 8)
  int op_slot_left_9180 = gc_frame_newslot(opresult9195);
  params[0] = strlit9181;
  partcv[0] = 1;
  Object opresult9196 = callmethod(opresult9195, "++", 1, partcv, params);
// compiled op node returning opresult9196 (depth = 7)
  int op_slot_right_9179 = gc_frame_newslot(opresult9196);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_9179 = gc_frame_newslot(*var_s);
  params[0] = opresult9196;
  partcv[0] = 1;
  Object opresult9198 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult9198 (depth = 6)
  *var_s = opresult9198;
  if (opresult9198 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9172 = done;
  } else {
  }
// compiled if node returning if9172 (depth = 4)
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace9200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9202 == NULL) {
    strlit9202 = alloc_String("");
    gc_root(strlit9202);
  }
// compiled string node returning strlit9202 (depth = 5)
  int op_slot_right_9201 = gc_frame_newslot(strlit9202);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9205 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num9206 = alloc_Float64(0);
// compiled num node returning num9206 (depth = 7)
  gc_frame_newslot(num9206);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9207 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9208 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9207);
// compiled call node returning call9208 (depth = 8)
// compiled member node returning call9208 (depth = 7)
  params[0] = num9206;
  partcv[0] = 1;
  Object call9209 = callmethod(call9208, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9205);
// compiled call node returning call9209 (depth = 6)
  int op_slot_right_9204 = gc_frame_newslot(call9209);
// starting to compile string node (depth = 6)
  if (strlit9211 == NULL) {
    strlit9211 = alloc_String("inherits ");
    gc_root(strlit9211);
  }
// compiled string node returning strlit9211 (depth = 6)
  int op_slot_left_9204 = gc_frame_newslot(strlit9211);
  params[0] = call9209;
  partcv[0] = 1;
  Object opresult9212 = callmethod(strlit9211, "++", 1, partcv, params);
// compiled op node returning opresult9212 (depth = 5)
  int op_slot_left_9201 = gc_frame_newslot(opresult9212);
  params[0] = strlit9202;
  partcv[0] = 1;
  Object opresult9213 = callmethod(opresult9212, "++", 1, partcv, params);
// compiled op node returning opresult9213 (depth = 4)
  gc_frame_end(frame);
  return opresult9213;
}
Object meth_ast_nameString9214(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "nameString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for nameString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for nameString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9215 = gc_frame_new();
// starting to compile num node (depth = 5)
  Object num9216 = alloc_Float64(0);
// compiled num node returning num9216 (depth = 5)
  gc_frame_newslot(num9216);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9217 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9218 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9217);
// compiled call node returning call9218 (depth = 6)
// compiled member node returning call9218 (depth = 5)
  params[0] = num9216;
  partcv[0] = 1;
  Object call9219 = callmethod(call9218, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe9215);
// compiled call node returning call9219 (depth = 4)
  gc_frame_end(frame);
  return call9219;
}
Object meth_ast_asString9220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9222 == NULL) {
    strlit9222 = alloc_String("");
    gc_root(strlit9222);
  }
// compiled string node returning strlit9222 (depth = 5)
  int op_slot_right_9221 = gc_frame_newslot(strlit9222);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9225 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9226 = callmethodflags(self, "nameString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9225);
// compiled call node returning call9226 (depth = 7)
// compiled member node returning call9226 (depth = 6)
  int op_slot_right_9224 = gc_frame_newslot(call9226);
// starting to compile string node (depth = 6)
  if (strlit9228 == NULL) {
    strlit9228 = alloc_String("Inherits ");
    gc_root(strlit9228);
  }
// compiled string node returning strlit9228 (depth = 6)
  int op_slot_left_9224 = gc_frame_newslot(strlit9228);
  params[0] = call9226;
  partcv[0] = 1;
  Object opresult9229 = callmethod(strlit9228, "++", 1, partcv, params);
// compiled op node returning opresult9229 (depth = 5)
  int op_slot_left_9221 = gc_frame_newslot(opresult9229);
  params[0] = strlit9222;
  partcv[0] = 1;
  Object opresult9230 = callmethod(opresult9229, "++", 1, partcv, params);
// compiled op node returning opresult9230 (depth = 4)
  gc_frame_end(frame);
  return opresult9230;
}
Object meth_ast_shallowCopyWithParent9231(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9232 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9233 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nullNode (depth = 6)
  gc_frame_newslot(*var_nullNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inheritsNode (depth = 6)
  params[0] = *var_nullNode;
  partcv[0] = 1;
  Object call9234 = callmethod(*var_inheritsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9233);
// compiled call node returning call9234 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9235 = callmethod(call9234, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe9232);
// compiled call node returning call9235 (depth = 4)
  gc_frame_end(frame);
  return call9235;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent9236(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9237 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9238 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9237);
// compiled call node returning call9238 (depth = 4)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9239 = gc_frame_new();
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call9241 = callmethod(*var_other, "providedNames",
    1, partcv, params);
  gc_frame_end(callframe9240);
// compiled call node returning call9241 (depth = 7)
// compiled member node returning call9241 (depth = 6)
  gc_frame_newslot(call9241);
// call case 4: self request
  params[0] = call9241;
  partcv[0] = 1;
  Object call9242 = callmethodflags(self, "providedNames:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9239);
// compiled call node returning call9242 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new9097(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9098 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9098 = alloc_userobj2(17,16, objclass9098);
  gc_frame_newslot(obj9098);
if (objclass9098 == NULL) {
  glfree(obj9098->class->name);
  obj9098->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9098, self, 0);
  addmethodreal(obj9098,"outer", &reader_ast_outer_9099);
  Object oldself9098 = self;
  struct StackFrameObject *oldstackframe9098 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9098);
  gc_frame_newslot((Object)stackframe);
  self = obj9098;
  Object *oldselfslot9098 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9098 = (*(struct UserObject *)self).data[0], lowerouter9098 = thisouter9098;
  if (inheritingObject9098) {
    struct UserObject *inho9098 = (struct UserObject *)inheritingObject9098;
    while (inho9098->super != GraceDefaultObject) inho9098 = (struct UserObject *)inho9098->super;
    inho9098->super = obj9098;
    self = inheritingObject9098;
    *selfslot = self;
    lowerouter9098 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9098;
  }
if (objclass9098 == NULL) {
  Method *reader9100 = addmethodrealflags(obj9098, "kind",&reader_ast_kind_9100, MFLAG_DEF);
  reader9100->definitionModule = modulename;
  reader9100->definitionLine = 2163;
}
adddatum2(obj9098, alloc_Undefined(), 1);
if (objclass9098 == NULL) {
  Method *reader9101 = addmethodrealflags(obj9098, "value",&reader_ast_value_9101, 0);
  Method *writer9101 = addmethodrealflags(obj9098, "value:=",&writer_ast_value_9101, 0);
  reader9101->definitionModule = modulename;
  writer9101->definitionModule = modulename;
  reader9101->definitionLine = 2164;
  writer9101->definitionLine = 2164;
}
obj9098->flags |= OFLAG_MUTABLE;
adddatum2(obj9098, alloc_Undefined(), 2);
if (objclass9098 == NULL) {
  Method *reader9102 = addmethodrealflags(obj9098, "providedNames",&reader_ast_providedNames_9102, 0);
  Method *writer9102 = addmethodrealflags(obj9098, "providedNames:=",&writer_ast_providedNames_9102, 0);
  reader9102->definitionModule = modulename;
  writer9102->definitionModule = modulename;
  reader9102->definitionLine = 2166;
  writer9102->definitionLine = 2166;
}
obj9098->flags |= OFLAG_MUTABLE;
adddatum2(obj9098, alloc_Undefined(), 3);
// method isInherits
  struct UserObject *uo9103 = (struct UserObject*)obj9098;
  uo9103->data[4] = emptyclosure;
  Method *meth_meth_ast_isInherits9103 = addmethod2pos(obj9098, "isInherits", &meth_ast_isInherits9103, 4);
  int argcv_meth_ast_isInherits9103[] = {0};
  meth_meth_ast_isInherits9103->type = alloc_MethodType(1, argcv_meth_ast_isInherits9103);
  meth_meth_ast_isInherits9103->definitionModule = modulename;
  meth_meth_ast_isInherits9103->definitionLine = 2166;
// method inheritsFromMember
  struct UserObject *uo9105 = (struct UserObject*)obj9098;
  uo9105->data[5] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9105 = addmethod2pos(obj9098, "inheritsFromMember", &meth_ast_inheritsFromMember9105, 5);
  int argcv_meth_ast_inheritsFromMember9105[] = {0};
  meth_meth_ast_inheritsFromMember9105->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9105);
  meth_meth_ast_inheritsFromMember9105->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9105->definitionLine = 2167;
// method inheritsFromCall
  struct UserObject *uo9110 = (struct UserObject*)obj9098;
  uo9110->data[6] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9110 = addmethod2pos(obj9098, "inheritsFromCall", &meth_ast_inheritsFromCall9110, 6);
  int argcv_meth_ast_inheritsFromCall9110[] = {0};
  meth_meth_ast_inheritsFromCall9110->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9110);
  meth_meth_ast_inheritsFromCall9110->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9110->definitionLine = 2168;
// method accept()from
  struct UserObject *uo9115 = (struct UserObject*)obj9098;
  uo9115->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9115 = addmethod2pos(obj9098, "accept()from", &meth_ast_accept_40__41_from9115, 7);
  int argcv_meth_ast_accept_40__41_from9115[] = {1, 1};
  meth_meth_ast_accept_40__41_from9115->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9115);
  meth_meth_ast_accept_40__41_from9115->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9115->definitionLine = 2169;
// method map()parent
  struct UserObject *uo9123 = (struct UserObject*)obj9098;
  uo9123->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9123 = addmethod2pos(obj9098, "map()parent", &meth_ast_map_40__41_parent9123, 8);
  int argcv_meth_ast_map_40__41_parent9123[] = {1, 1};
  meth_meth_ast_map_40__41_parent9123->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9123);
  meth_meth_ast_map_40__41_parent9123->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9123->definitionLine = 2174;
// method pretty
  struct UserObject *uo9135 = (struct UserObject*)obj9098;
  uo9135->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty9135 = addmethod2pos(obj9098, "pretty", &meth_ast_pretty9135, 9);
  int argcv_meth_ast_pretty9135[] = {1};
  meth_meth_ast_pretty9135->type = alloc_MethodType(1, argcv_meth_ast_pretty9135);
  meth_meth_ast_pretty9135->definitionModule = modulename;
  meth_meth_ast_pretty9135->definitionLine = 2180;
// method toGrace
  struct UserObject *uo9200 = (struct UserObject*)obj9098;
  uo9200->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace9200 = addmethod2pos(obj9098, "toGrace", &meth_ast_toGrace9200, 10);
  int argcv_meth_ast_toGrace9200[] = {1};
  meth_meth_ast_toGrace9200->type = alloc_MethodType(1, argcv_meth_ast_toGrace9200);
meth_meth_ast_toGrace9200->type->types[0] = type_Number;
meth_meth_ast_toGrace9200->type->names[0] = "depth";
  meth_meth_ast_toGrace9200->definitionModule = modulename;
  meth_meth_ast_toGrace9200->definitionLine = 2192;
// method nameString
  struct UserObject *uo9214 = (struct UserObject*)obj9098;
  uo9214->data[11] = emptyclosure;
  Method *meth_meth_ast_nameString9214 = addmethod2pos(obj9098, "nameString", &meth_ast_nameString9214, 11);
  int argcv_meth_ast_nameString9214[] = {0};
  meth_meth_ast_nameString9214->type = alloc_MethodType(1, argcv_meth_ast_nameString9214);
  meth_meth_ast_nameString9214->definitionModule = modulename;
  meth_meth_ast_nameString9214->definitionLine = 2195;
// method asString
  struct UserObject *uo9220 = (struct UserObject*)obj9098;
  uo9220->data[12] = emptyclosure;
  Method *meth_meth_ast_asString9220 = addmethod2pos(obj9098, "asString", &meth_ast_asString9220, 12);
  int argcv_meth_ast_asString9220[] = {0};
  meth_meth_ast_asString9220->type = alloc_MethodType(1, argcv_meth_ast_asString9220);
  meth_meth_ast_asString9220->definitionModule = modulename;
  meth_meth_ast_asString9220->definitionLine = 2196;
// method shallowCopyWithParent
  block_savedest(obj9098);
  Object closure9231 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure9231, stackframe);
  addtoclosure(closure9231, var_nullNode);
  addtoclosure(closure9231, var_inheritsNode);
  struct UserObject *uo9231 = (struct UserObject*)obj9098;
  uo9231->data[13] = (Object)closure9231;
  Method *meth_meth_ast_shallowCopyWithParent9231 = addmethod2pos(obj9098, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9231, 13);
  int argcv_meth_ast_shallowCopyWithParent9231[] = {1};
  meth_meth_ast_shallowCopyWithParent9231->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9231);
  meth_meth_ast_shallowCopyWithParent9231->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9231->definitionLine = 2197;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo9236 = (struct UserObject*)obj9098;
  uo9236->data[14] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236 = addmethod2pos(obj9098, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent9236, 14);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9236[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9236);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236->definitionLine = 2200;
  sourceObject = obj9098;
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9244 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9243);
// compiled call node returning call9244 (depth = 4)
  struct UserObject *obj9098_uo = (struct UserObject *)obj9098;
  obj9098_uo->super = call9244;
  sourceObject = obj9098;
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9245 == NULL) {
    strlit9245 = alloc_String("inherits");
    gc_root(strlit9245);
  }
// compiled string node returning strlit9245 (depth = 4)
  adddatum2(obj9098, strlit9245, 1);
  sourceObject = obj9098;
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj9098, *var_expr, 2);
  sourceObject = obj9098;
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9246 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9247 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9248 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9247);
// compiled call node returning call9248 (depth = 7)
// compiled member node returning call9248 (depth = 6)
  partcv[0] = 0;
  Object call9249 = callmethod(call9248, "empty",
    1, partcv, params);
  gc_frame_end(callframe9246);
// compiled call node returning call9249 (depth = 5)
// compiled member node returning call9249 (depth = 4)
  adddatum2(obj9098, call9249, 3);
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
objclass9098 = obj9098->class;
  objclass9098->definitionModule = modulename;
  objclass9098->definitionLine = 2160;
  (*(struct UserObject *)self).data[0] = lowerouter9098;
  self = oldself9098;
  selfslot = oldselfslot9098;
  stackframe = oldstackframe9098;
  gc_frame_end(frame);
  return obj9098;
}
Object meth_ast_new9097_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_nullNode = getfromclosure(closure, 0);
  Object *var_inheritsNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9098 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9098 = alloc_userobj2(17,16, objclass9098);
  gc_frame_newslot(obj9098);
if (objclass9098 == NULL) {
  glfree(obj9098->class->name);
  obj9098->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9098, self, 0);
  addmethodreal(obj9098,"outer", &reader_ast_outer_9099);
  Object oldself9098 = self;
  struct StackFrameObject *oldstackframe9098 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9098);
  gc_frame_newslot((Object)stackframe);
  self = obj9098;
  Object *oldselfslot9098 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9098 = (*(struct UserObject *)self).data[0], lowerouter9098 = thisouter9098;
  if (inheritingObject9098) {
    struct UserObject *inho9098 = (struct UserObject *)inheritingObject9098;
    while (inho9098->super != GraceDefaultObject) inho9098 = (struct UserObject *)inho9098->super;
    inho9098->super = obj9098;
    self = inheritingObject9098;
    *selfslot = self;
    lowerouter9098 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9098;
  }
if (objclass9098 == NULL) {
  Method *reader9100 = addmethodrealflags(obj9098, "kind",&reader_ast_kind_9100, MFLAG_DEF);
  reader9100->definitionModule = modulename;
  reader9100->definitionLine = 2163;
}
adddatum2(obj9098, alloc_Undefined(), 1);
if (objclass9098 == NULL) {
  Method *reader9101 = addmethodrealflags(obj9098, "value",&reader_ast_value_9101, 0);
  Method *writer9101 = addmethodrealflags(obj9098, "value:=",&writer_ast_value_9101, 0);
  reader9101->definitionModule = modulename;
  writer9101->definitionModule = modulename;
  reader9101->definitionLine = 2164;
  writer9101->definitionLine = 2164;
}
obj9098->flags |= OFLAG_MUTABLE;
adddatum2(obj9098, alloc_Undefined(), 2);
if (objclass9098 == NULL) {
  Method *reader9102 = addmethodrealflags(obj9098, "providedNames",&reader_ast_providedNames_9102, 0);
  Method *writer9102 = addmethodrealflags(obj9098, "providedNames:=",&writer_ast_providedNames_9102, 0);
  reader9102->definitionModule = modulename;
  writer9102->definitionModule = modulename;
  reader9102->definitionLine = 2166;
  writer9102->definitionLine = 2166;
}
obj9098->flags |= OFLAG_MUTABLE;
adddatum2(obj9098, alloc_Undefined(), 3);
// method isInherits
  struct UserObject *uo9103 = (struct UserObject*)obj9098;
  uo9103->data[4] = emptyclosure;
  Method *meth_meth_ast_isInherits9103 = addmethod2pos(obj9098, "isInherits", &meth_ast_isInherits9103, 4);
  int argcv_meth_ast_isInherits9103[] = {0};
  meth_meth_ast_isInherits9103->type = alloc_MethodType(1, argcv_meth_ast_isInherits9103);
  meth_meth_ast_isInherits9103->definitionModule = modulename;
  meth_meth_ast_isInherits9103->definitionLine = 2166;
// method inheritsFromMember
  struct UserObject *uo9105 = (struct UserObject*)obj9098;
  uo9105->data[5] = emptyclosure;
  Method *meth_meth_ast_inheritsFromMember9105 = addmethod2pos(obj9098, "inheritsFromMember", &meth_ast_inheritsFromMember9105, 5);
  int argcv_meth_ast_inheritsFromMember9105[] = {0};
  meth_meth_ast_inheritsFromMember9105->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromMember9105);
  meth_meth_ast_inheritsFromMember9105->definitionModule = modulename;
  meth_meth_ast_inheritsFromMember9105->definitionLine = 2167;
// method inheritsFromCall
  struct UserObject *uo9110 = (struct UserObject*)obj9098;
  uo9110->data[6] = emptyclosure;
  Method *meth_meth_ast_inheritsFromCall9110 = addmethod2pos(obj9098, "inheritsFromCall", &meth_ast_inheritsFromCall9110, 6);
  int argcv_meth_ast_inheritsFromCall9110[] = {0};
  meth_meth_ast_inheritsFromCall9110->type = alloc_MethodType(1, argcv_meth_ast_inheritsFromCall9110);
  meth_meth_ast_inheritsFromCall9110->definitionModule = modulename;
  meth_meth_ast_inheritsFromCall9110->definitionLine = 2168;
// method accept()from
  struct UserObject *uo9115 = (struct UserObject*)obj9098;
  uo9115->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9115 = addmethod2pos(obj9098, "accept()from", &meth_ast_accept_40__41_from9115, 7);
  int argcv_meth_ast_accept_40__41_from9115[] = {1, 1};
  meth_meth_ast_accept_40__41_from9115->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9115);
  meth_meth_ast_accept_40__41_from9115->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9115->definitionLine = 2169;
// method map()parent
  struct UserObject *uo9123 = (struct UserObject*)obj9098;
  uo9123->data[8] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9123 = addmethod2pos(obj9098, "map()parent", &meth_ast_map_40__41_parent9123, 8);
  int argcv_meth_ast_map_40__41_parent9123[] = {1, 1};
  meth_meth_ast_map_40__41_parent9123->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9123);
  meth_meth_ast_map_40__41_parent9123->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9123->definitionLine = 2174;
// method pretty
  struct UserObject *uo9135 = (struct UserObject*)obj9098;
  uo9135->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty9135 = addmethod2pos(obj9098, "pretty", &meth_ast_pretty9135, 9);
  int argcv_meth_ast_pretty9135[] = {1};
  meth_meth_ast_pretty9135->type = alloc_MethodType(1, argcv_meth_ast_pretty9135);
  meth_meth_ast_pretty9135->definitionModule = modulename;
  meth_meth_ast_pretty9135->definitionLine = 2180;
// method toGrace
  struct UserObject *uo9200 = (struct UserObject*)obj9098;
  uo9200->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace9200 = addmethod2pos(obj9098, "toGrace", &meth_ast_toGrace9200, 10);
  int argcv_meth_ast_toGrace9200[] = {1};
  meth_meth_ast_toGrace9200->type = alloc_MethodType(1, argcv_meth_ast_toGrace9200);
meth_meth_ast_toGrace9200->type->types[0] = type_Number;
meth_meth_ast_toGrace9200->type->names[0] = "depth";
  meth_meth_ast_toGrace9200->definitionModule = modulename;
  meth_meth_ast_toGrace9200->definitionLine = 2192;
// method nameString
  struct UserObject *uo9214 = (struct UserObject*)obj9098;
  uo9214->data[11] = emptyclosure;
  Method *meth_meth_ast_nameString9214 = addmethod2pos(obj9098, "nameString", &meth_ast_nameString9214, 11);
  int argcv_meth_ast_nameString9214[] = {0};
  meth_meth_ast_nameString9214->type = alloc_MethodType(1, argcv_meth_ast_nameString9214);
  meth_meth_ast_nameString9214->definitionModule = modulename;
  meth_meth_ast_nameString9214->definitionLine = 2195;
// method asString
  struct UserObject *uo9220 = (struct UserObject*)obj9098;
  uo9220->data[12] = emptyclosure;
  Method *meth_meth_ast_asString9220 = addmethod2pos(obj9098, "asString", &meth_ast_asString9220, 12);
  int argcv_meth_ast_asString9220[] = {0};
  meth_meth_ast_asString9220->type = alloc_MethodType(1, argcv_meth_ast_asString9220);
  meth_meth_ast_asString9220->definitionModule = modulename;
  meth_meth_ast_asString9220->definitionLine = 2196;
// method shallowCopyWithParent
  block_savedest(obj9098);
  Object closure9231 = createclosure(2, "shallowCopyWithParent");
  setclosureframe(closure9231, stackframe);
  addtoclosure(closure9231, var_nullNode);
  addtoclosure(closure9231, var_inheritsNode);
  struct UserObject *uo9231 = (struct UserObject*)obj9098;
  uo9231->data[13] = (Object)closure9231;
  Method *meth_meth_ast_shallowCopyWithParent9231 = addmethod2pos(obj9098, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9231, 13);
  int argcv_meth_ast_shallowCopyWithParent9231[] = {1};
  meth_meth_ast_shallowCopyWithParent9231->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9231);
  meth_meth_ast_shallowCopyWithParent9231->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9231->definitionLine = 2197;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo9236 = (struct UserObject*)obj9098;
  uo9236->data[14] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236 = addmethod2pos(obj9098, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent9236, 14);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9236[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9236);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9236->definitionLine = 2200;
  sourceObject = obj9098;
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9244 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9243);
// compiled call node returning call9244 (depth = 4)
  struct UserObject *obj9098_uo = (struct UserObject *)obj9098;
  obj9098_uo->super = call9244;
  sourceObject = obj9098;
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9245 == NULL) {
    strlit9245 = alloc_String("inherits");
    gc_root(strlit9245);
  }
// compiled string node returning strlit9245 (depth = 4)
  adddatum2(obj9098, strlit9245, 1);
  sourceObject = obj9098;
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_expr (depth = 4)
  adddatum2(obj9098, *var_expr, 2);
  sourceObject = obj9098;
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9246 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9247 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9248 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9247);
// compiled call node returning call9248 (depth = 7)
// compiled member node returning call9248 (depth = 6)
  partcv[0] = 0;
  Object call9249 = callmethod(call9248, "empty",
    1, partcv, params);
  gc_frame_end(callframe9246);
// compiled call node returning call9249 (depth = 5)
// compiled member node returning call9249 (depth = 4)
  adddatum2(obj9098, call9249, 3);
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
  sourceObject = obj9098;
objclass9098 = obj9098->class;
  objclass9098->definitionModule = modulename;
  objclass9098->definitionLine = 2160;
  (*(struct UserObject *)self).data[0] = lowerouter9098;
  self = oldself9098;
  selfslot = oldselfslot9098;
  stackframe = oldstackframe9098;
  gc_frame_end(frame);
  return obj9098;
}
Object meth_ast_blankNode9251(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blankNode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for blankNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blankNode (depth = 3)
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_accept_40__41_from9259(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map_40__41_parent9260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9261 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call9262 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9261);
// compiled call node returning call9262 (depth = 5)
  *var_n = call9262;
  if (call9262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9263 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9264 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9263);
// compiled call node returning call9264 (depth = 5)
  *var_n = call9264;
  if (call9264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2216
  setline(2216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_toGrace9266(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toGrace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9267 == NULL) {
    strlit9267 = alloc_String("");
    gc_root(strlit9267);
  }
// compiled string node returning strlit9267 (depth = 4)
  gc_frame_end(frame);
  return strlit9267;
}
Object meth_ast_shallowCopyWithParent9268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9269 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9270 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blankNode (depth = 7)
  partcv[0] = 0;
  Object call9271 = callmethod(*var_blankNode, "new",
    1, partcv, params);
  gc_frame_end(callframe9270);
// compiled call node returning call9271 (depth = 6)
// compiled member node returning call9271 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9272 = callmethod(call9271, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe9269);
// compiled call node returning call9272 (depth = 4)
  gc_frame_end(frame);
  return call9272;
}
Object meth_ast_new9254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9255 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9255 = alloc_userobj2(7,8, objclass9255);
  gc_frame_newslot(obj9255);
if (objclass9255 == NULL) {
  glfree(obj9255->class->name);
  obj9255->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9255, self, 0);
  addmethodreal(obj9255,"outer", &reader_ast_outer_9256);
  Object oldself9255 = self;
  struct StackFrameObject *oldstackframe9255 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9255);
  gc_frame_newslot((Object)stackframe);
  self = obj9255;
  Object *oldselfslot9255 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9255 = (*(struct UserObject *)self).data[0], lowerouter9255 = thisouter9255;
  if (inheritingObject9255) {
    struct UserObject *inho9255 = (struct UserObject *)inheritingObject9255;
    while (inho9255->super != GraceDefaultObject) inho9255 = (struct UserObject *)inho9255->super;
    inho9255->super = obj9255;
    self = inheritingObject9255;
    *selfslot = self;
    lowerouter9255 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9255;
  }
if (objclass9255 == NULL) {
  Method *reader9257 = addmethodrealflags(obj9255, "kind",&reader_ast_kind_9257, MFLAG_DEF);
  reader9257->definitionModule = modulename;
  reader9257->definitionLine = 2209;
}
adddatum2(obj9255, alloc_Undefined(), 1);
if (objclass9255 == NULL) {
  Method *reader9258 = addmethodrealflags(obj9255, "value",&reader_ast_value_9258, MFLAG_DEF);
  reader9258->definitionModule = modulename;
  reader9258->definitionLine = 2211;
}
adddatum2(obj9255, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9259 = (struct UserObject*)obj9255;
  uo9259->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9259 = addmethod2pos(obj9255, "accept()from", &meth_ast_accept_40__41_from9259, 3);
  int argcv_meth_ast_accept_40__41_from9259[] = {1, 1};
  meth_meth_ast_accept_40__41_from9259->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9259);
  meth_meth_ast_accept_40__41_from9259->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9259->definitionLine = 2211;
// method map()parent
  struct UserObject *uo9260 = (struct UserObject*)obj9255;
  uo9260->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9260 = addmethod2pos(obj9255, "map()parent", &meth_ast_map_40__41_parent9260, 4);
  int argcv_meth_ast_map_40__41_parent9260[] = {1, 1};
  meth_meth_ast_map_40__41_parent9260->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9260);
  meth_meth_ast_map_40__41_parent9260->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9260->definitionLine = 2213;
// method toGrace
  struct UserObject *uo9266 = (struct UserObject*)obj9255;
  uo9266->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace9266 = addmethod2pos(obj9255, "toGrace", &meth_ast_toGrace9266, 5);
  int argcv_meth_ast_toGrace9266[] = {1};
  meth_meth_ast_toGrace9266->type = alloc_MethodType(1, argcv_meth_ast_toGrace9266);
meth_meth_ast_toGrace9266->type->types[0] = type_Number;
meth_meth_ast_toGrace9266->type->names[0] = "depth";
  meth_meth_ast_toGrace9266->definitionModule = modulename;
  meth_meth_ast_toGrace9266->definitionLine = 2218;
// method shallowCopyWithParent
  block_savedest(obj9255);
  Object closure9268 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9268, stackframe);
  addtoclosure(closure9268, var_blankNode);
  struct UserObject *uo9268 = (struct UserObject*)obj9255;
  uo9268->data[6] = (Object)closure9268;
  Method *meth_meth_ast_shallowCopyWithParent9268 = addmethod2pos(obj9255, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9268, 6);
  int argcv_meth_ast_shallowCopyWithParent9268[] = {1};
  meth_meth_ast_shallowCopyWithParent9268->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9268);
  meth_meth_ast_shallowCopyWithParent9268->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9268->definitionLine = 2221;
  sourceObject = obj9255;
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9273 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9274 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9273);
// compiled call node returning call9274 (depth = 4)
  struct UserObject *obj9255_uo = (struct UserObject *)obj9255;
  obj9255_uo->super = call9274;
  sourceObject = obj9255;
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9275 == NULL) {
    strlit9275 = alloc_String("blank");
    gc_root(strlit9275);
  }
// compiled string node returning strlit9275 (depth = 4)
  adddatum2(obj9255, strlit9275, 1);
  sourceObject = obj9255;
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9276 == NULL) {
    strlit9276 = alloc_String("blank");
    gc_root(strlit9276);
  }
// compiled string node returning strlit9276 (depth = 4)
  adddatum2(obj9255, strlit9276, 2);
  sourceObject = obj9255;
  sourceObject = obj9255;
  sourceObject = obj9255;
  sourceObject = obj9255;
objclass9255 = obj9255->class;
  objclass9255->definitionModule = modulename;
  objclass9255->definitionLine = 2206;
  (*(struct UserObject *)self).data[0] = lowerouter9255;
  self = oldself9255;
  selfslot = oldselfslot9255;
  stackframe = oldstackframe9255;
  gc_frame_end(frame);
  return obj9255;
}
Object meth_ast_new9254_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_blankNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9255 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9255 = alloc_userobj2(7,8, objclass9255);
  gc_frame_newslot(obj9255);
if (objclass9255 == NULL) {
  glfree(obj9255->class->name);
  obj9255->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9255, self, 0);
  addmethodreal(obj9255,"outer", &reader_ast_outer_9256);
  Object oldself9255 = self;
  struct StackFrameObject *oldstackframe9255 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9255);
  gc_frame_newslot((Object)stackframe);
  self = obj9255;
  Object *oldselfslot9255 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9255 = (*(struct UserObject *)self).data[0], lowerouter9255 = thisouter9255;
  if (inheritingObject9255) {
    struct UserObject *inho9255 = (struct UserObject *)inheritingObject9255;
    while (inho9255->super != GraceDefaultObject) inho9255 = (struct UserObject *)inho9255->super;
    inho9255->super = obj9255;
    self = inheritingObject9255;
    *selfslot = self;
    lowerouter9255 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9255;
  }
if (objclass9255 == NULL) {
  Method *reader9257 = addmethodrealflags(obj9255, "kind",&reader_ast_kind_9257, MFLAG_DEF);
  reader9257->definitionModule = modulename;
  reader9257->definitionLine = 2209;
}
adddatum2(obj9255, alloc_Undefined(), 1);
if (objclass9255 == NULL) {
  Method *reader9258 = addmethodrealflags(obj9255, "value",&reader_ast_value_9258, MFLAG_DEF);
  reader9258->definitionModule = modulename;
  reader9258->definitionLine = 2211;
}
adddatum2(obj9255, alloc_Undefined(), 2);
// method accept()from
  struct UserObject *uo9259 = (struct UserObject*)obj9255;
  uo9259->data[3] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9259 = addmethod2pos(obj9255, "accept()from", &meth_ast_accept_40__41_from9259, 3);
  int argcv_meth_ast_accept_40__41_from9259[] = {1, 1};
  meth_meth_ast_accept_40__41_from9259->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9259);
  meth_meth_ast_accept_40__41_from9259->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9259->definitionLine = 2211;
// method map()parent
  struct UserObject *uo9260 = (struct UserObject*)obj9255;
  uo9260->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9260 = addmethod2pos(obj9255, "map()parent", &meth_ast_map_40__41_parent9260, 4);
  int argcv_meth_ast_map_40__41_parent9260[] = {1, 1};
  meth_meth_ast_map_40__41_parent9260->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9260);
  meth_meth_ast_map_40__41_parent9260->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9260->definitionLine = 2213;
// method toGrace
  struct UserObject *uo9266 = (struct UserObject*)obj9255;
  uo9266->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace9266 = addmethod2pos(obj9255, "toGrace", &meth_ast_toGrace9266, 5);
  int argcv_meth_ast_toGrace9266[] = {1};
  meth_meth_ast_toGrace9266->type = alloc_MethodType(1, argcv_meth_ast_toGrace9266);
meth_meth_ast_toGrace9266->type->types[0] = type_Number;
meth_meth_ast_toGrace9266->type->names[0] = "depth";
  meth_meth_ast_toGrace9266->definitionModule = modulename;
  meth_meth_ast_toGrace9266->definitionLine = 2218;
// method shallowCopyWithParent
  block_savedest(obj9255);
  Object closure9268 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9268, stackframe);
  addtoclosure(closure9268, var_blankNode);
  struct UserObject *uo9268 = (struct UserObject*)obj9255;
  uo9268->data[6] = (Object)closure9268;
  Method *meth_meth_ast_shallowCopyWithParent9268 = addmethod2pos(obj9255, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9268, 6);
  int argcv_meth_ast_shallowCopyWithParent9268[] = {1};
  meth_meth_ast_shallowCopyWithParent9268->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9268);
  meth_meth_ast_shallowCopyWithParent9268->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9268->definitionLine = 2221;
  sourceObject = obj9255;
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9273 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9274 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9273);
// compiled call node returning call9274 (depth = 4)
  struct UserObject *obj9255_uo = (struct UserObject *)obj9255;
  obj9255_uo->super = call9274;
  sourceObject = obj9255;
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9275 == NULL) {
    strlit9275 = alloc_String("blank");
    gc_root(strlit9275);
  }
// compiled string node returning strlit9275 (depth = 4)
  adddatum2(obj9255, strlit9275, 1);
  sourceObject = obj9255;
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9276 == NULL) {
    strlit9276 = alloc_String("blank");
    gc_root(strlit9276);
  }
// compiled string node returning strlit9276 (depth = 4)
  adddatum2(obj9255, strlit9276, 2);
  sourceObject = obj9255;
  sourceObject = obj9255;
  sourceObject = obj9255;
  sourceObject = obj9255;
objclass9255 = obj9255->class;
  objclass9255->definitionModule = modulename;
  objclass9255->definitionLine = 2206;
  (*(struct UserObject *)self).data[0] = lowerouter9255;
  self = oldself9255;
  selfslot = oldselfslot9255;
  stackframe = oldstackframe9255;
  gc_frame_end(frame);
  return obj9255;
}
Object meth_ast_signaturePart9278(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for signaturePart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for signaturePart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signaturePart (depth = 3)
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast__apply9296(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe9297 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9298 = callmethod(*var_p, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9297);
// compiled call node returning call9298 (depth = 7)
  gc_frame_end(frame);
  return call9298;
}
Object meth_ast__apply9316(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe9317 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_visitor (depth = 8)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_g (depth = 8)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9318 = callmethod(*var_g, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9317);
// compiled call node returning call9318 (depth = 7)
  gc_frame_end(frame);
  return call9318;
}
Object meth_ast_accept_40__41_from9290(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept()from");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()from");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()from");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()from (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for from");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9292 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_pNode (depth = 6)
  gc_frame_newslot(*var_pNode);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_visitor (depth = 6)
  params[0] = self;
  params[1] = *var_pNode;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9293 = callmethod(*var_visitor, "visitSignaturePart()up",
    2, partcv, params);
  gc_frame_end(callframe9292);
// compiled call node returning call9293 (depth = 5)
  Object if9291 = done;
  if (istrue(call9293)) {
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9294 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9295 = alloc_Block(NULL, NULL, "ast", 2245);
  gc_frame_newslot(block9295);
// method _apply
  block_savedest(block9295);
  Object closure9296 = createclosure(2, "_apply");
  setclosureframe(closure9296, stackframe);
  addtoclosure(closure9296, var_visitor);
  addtoclosure(closure9296, selfslot);
  struct UserObject *uo9296 = (struct UserObject*)block9295;
  uo9296->data[0] = (Object)closure9296;
  Method *meth_meth_ast__apply9296 = addmethod2pos(block9295, "_apply", &meth_ast__apply9296, 0);
  int argcv_meth_ast__apply9296[] = {1};
  meth_meth_ast__apply9296->type = alloc_MethodType(1, argcv_meth_ast__apply9296);
  meth_meth_ast__apply9296->definitionModule = modulename;
  meth_meth_ast__apply9296->definitionLine = 2226;
// compiled block node returning block9295 (depth = 6)
  gc_frame_newslot(block9295);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9300 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9301 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9300);
// compiled call node returning call9301 (depth = 7)
// compiled member node returning call9301 (depth = 6)
  params[0] = block9295;
  partcv[0] = 1;
  Object call9302 = callmethod(call9301, "do",
    1, partcv, params);
  gc_frame_end(callframe9294);
// compiled call node returning call9302 (depth = 5)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9305 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9306 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9305);
// compiled call node returning call9306 (depth = 8)
// compiled member node returning call9306 (depth = 7)
  int op_slot_right_9304 = gc_frame_newslot(call9306);
// starting to compile identifier node (depth = 7)
  Object bool9308 = alloc_Boolean(0);
// compiled identifier node returning bool9308 (depth = 7)
  int op_slot_left_9304 = gc_frame_newslot(bool9308);
  params[0] = call9306;
  partcv[0] = 1;
  Object opresult9309 = callmethod(bool9308, "!=", 1, partcv, params);
// compiled op node returning opresult9309 (depth = 6)
  Object if9303 = done;
  if (istrue(opresult9309)) {
// starting to compile call node (depth = 6)
  int callframe9310 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_visitor (depth = 7)
  gc_frame_newslot(*var_visitor);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9311 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9312 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9311);
// compiled call node returning call9312 (depth = 8)
// compiled member node returning call9312 (depth = 7)
  params[0] = *var_visitor;
  params[1] = self;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9313 = callmethod(call9312, "accept()from",
    2, partcv, params);
  gc_frame_end(callframe9310);
// compiled call node returning call9313 (depth = 6)
    gc_frame_newslot(call9313);
    if9303 = call9313;
  } else {
  }
// compiled if node returning if9303 (depth = 5)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9314 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9315 = alloc_Block(NULL, NULL, "ast", 2247);
  gc_frame_newslot(block9315);
// method _apply
  block_savedest(block9315);
  Object closure9316 = createclosure(2, "_apply");
  setclosureframe(closure9316, stackframe);
  addtoclosure(closure9316, var_visitor);
  addtoclosure(closure9316, selfslot);
  struct UserObject *uo9316 = (struct UserObject*)block9315;
  uo9316->data[0] = (Object)closure9316;
  Method *meth_meth_ast__apply9316 = addmethod2pos(block9315, "_apply", &meth_ast__apply9316, 0);
  int argcv_meth_ast__apply9316[] = {1};
  meth_meth_ast__apply9316->type = alloc_MethodType(1, argcv_meth_ast__apply9316);
  meth_meth_ast__apply9316->definitionModule = modulename;
  meth_meth_ast__apply9316->definitionLine = 2246;
// compiled block node returning block9315 (depth = 6)
  gc_frame_newslot(block9315);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9320 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9321 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9320);
// compiled call node returning call9321 (depth = 7)
// compiled member node returning call9321 (depth = 6)
  params[0] = block9315;
  partcv[0] = 1;
  Object call9322 = callmethod(call9321, "do",
    1, partcv, params);
  gc_frame_end(callframe9314);
// compiled call node returning call9322 (depth = 5)
    gc_frame_newslot(call9322);
    if9291 = call9322;
  } else {
  }
// compiled if node returning if9291 (depth = 4)
  gc_frame_end(frame);
  return if9291;
}
Object meth_ast_declarationKind9323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "declarationKind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for declarationKind (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for declarationKind");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9324 == NULL) {
    strlit9324 = alloc_String("parameter");
    gc_root(strlit9324);
  }
// compiled string node returning strlit9324 (depth = 4)
  gc_frame_end(frame);
  return strlit9324;
}
Object meth_ast_map_40__41_parent9325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9326 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call9327 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9326);
// compiled call node returning call9327 (depth = 5)
  *var_n = call9327;
  if (call9327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9328 = gc_frame_new();
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9329 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9331 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9330);
// compiled call node returning call9331 (depth = 8)
// compiled member node returning call9331 (depth = 7)
  gc_frame_newslot(call9331);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9332 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9333 = gc_frame_new();
// call case 3: self.outer request
  Object call9334 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9333);
// compiled call node returning call9334 (depth = 10)
// compiled member node returning call9334 (depth = 9)
  partcv[0] = 0;
  Object call9335 = callmethodflags(call9334, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9332);
// compiled call node returning call9335 (depth = 8)
// compiled member node returning call9335 (depth = 7)
  params[0] = call9331;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9336 = callmethodflags(call9335, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9329);
// compiled call node returning call9336 (depth = 6)
  gc_frame_newslot(call9336);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9336;
  partcv[0] = 1;
  Object call9337 = callmethod(*var_n, "params:=",
    1, partcv, params);
  gc_frame_end(callframe9328);
// compiled call node returning call9337 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9338 = gc_frame_new();
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9339 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9340 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9341 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9340);
// compiled call node returning call9341 (depth = 8)
// compiled member node returning call9341 (depth = 7)
  gc_frame_newslot(call9341);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9342 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9343 = gc_frame_new();
// call case 3: self.outer request
  Object call9344 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9343);
// compiled call node returning call9344 (depth = 10)
// compiled member node returning call9344 (depth = 9)
  partcv[0] = 0;
  Object call9345 = callmethodflags(call9344, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9342);
// compiled call node returning call9345 (depth = 8)
// compiled member node returning call9345 (depth = 7)
  params[0] = call9341;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9346 = callmethodflags(call9345, "maybeMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9339);
// compiled call node returning call9346 (depth = 6)
  gc_frame_newslot(call9346);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9346;
  partcv[0] = 1;
  Object call9347 = callmethod(*var_n, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9338);
// compiled call node returning call9347 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9348 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9349 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9348);
// compiled call node returning call9349 (depth = 5)
  *var_n = call9349;
  if (call9349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply9359(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit9361 == NULL) {
    strlit9361 = alloc_String("  ");
    gc_root(strlit9361);
  }
// compiled string node returning strlit9361 (depth = 8)
  int op_slot_right_9360 = gc_frame_newslot(strlit9361);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9360 = gc_frame_newslot(*var_spc);
  params[0] = strlit9361;
  partcv[0] = 1;
  Object opresult9363 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9363 (depth = 7)
  *var_spc = opresult9363;
  if (opresult9363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9408 == NULL) {
    strlit9408 = alloc_String("");
    gc_root(strlit9408);
  }
// compiled string node returning strlit9408 (depth = 8)
  int op_slot_right_9407 = gc_frame_newslot(strlit9408);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9411 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num9413 = alloc_Float64(2);
// compiled num node returning num9413 (depth = 11)
  int op_slot_right_9412 = gc_frame_newslot(num9413);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_9412 = gc_frame_newslot(*var_depth);
  params[0] = num9413;
  partcv[0] = 1;
  Object sum9415 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9415 (depth = 10)
  gc_frame_newslot(sum9415);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  params[0] = sum9415;
  partcv[0] = 1;
  Object call9416 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9411);
// compiled call node returning call9416 (depth = 9)
  int op_slot_right_9410 = gc_frame_newslot(call9416);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9419 == NULL) {
    strlit9419 = alloc_String("");
    gc_root(strlit9419);
  }
// compiled string node returning strlit9419 (depth = 10)
  int op_slot_right_9418 = gc_frame_newslot(strlit9419);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_9421 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9424 == NULL) {
    strlit9424 = alloc_String("""\x0a""  ");
    gc_root(strlit9424);
  }
// compiled string node returning strlit9424 (depth = 12)
  int op_slot_right_9423 = gc_frame_newslot(strlit9424);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_9426 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit9428 == NULL) {
    strlit9428 = alloc_String("");
    gc_root(strlit9428);
  }
// compiled string node returning strlit9428 (depth = 13)
  int op_slot_left_9426 = gc_frame_newslot(strlit9428);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9429 = callmethod(strlit9428, "++", 1, partcv, params);
// compiled op node returning opresult9429 (depth = 12)
  int op_slot_left_9423 = gc_frame_newslot(opresult9429);
  params[0] = strlit9424;
  partcv[0] = 1;
  Object opresult9430 = callmethod(opresult9429, "++", 1, partcv, params);
// compiled op node returning opresult9430 (depth = 11)
  int op_slot_left_9421 = gc_frame_newslot(opresult9430);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9431 = callmethod(opresult9430, "++", 1, partcv, params);
// compiled op node returning opresult9431 (depth = 10)
  int op_slot_left_9418 = gc_frame_newslot(opresult9431);
  params[0] = strlit9419;
  partcv[0] = 1;
  Object opresult9432 = callmethod(opresult9431, "++", 1, partcv, params);
// compiled op node returning opresult9432 (depth = 9)
  int op_slot_left_9410 = gc_frame_newslot(opresult9432);
  params[0] = call9416;
  partcv[0] = 1;
  Object opresult9433 = callmethod(opresult9432, "++", 1, partcv, params);
// compiled op node returning opresult9433 (depth = 8)
  int op_slot_left_9407 = gc_frame_newslot(opresult9433);
  params[0] = strlit9408;
  partcv[0] = 1;
  Object opresult9434 = callmethod(opresult9433, "++", 1, partcv, params);
// compiled op node returning opresult9434 (depth = 7)
  *var_s = opresult9434;
  if (opresult9434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9351(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit9352 == NULL) {
    strlit9352 = alloc_String("");
    gc_root(strlit9352);
  }
// compiled string node returning strlit9352 (depth = 5)
  *var_spc = strlit9352;
  if (strlit9352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9353 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9354 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9356 = alloc_Float64(0);
// compiled num node returning num9356 (depth = 6)
  int op_slot_left_9354 = gc_frame_newslot(num9356);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9357 = callmethod(num9356, "..", 1, partcv, params);
// compiled op node returning opresult9357 (depth = 5)
  gc_frame_newslot(opresult9357);
// starting to compile block node (depth = 5)
  Object block9358 = alloc_Block(NULL, NULL, "ast", 2260);
  gc_frame_newslot(block9358);
// method _apply
  block_savedest(block9358);
  Object closure9359 = createclosure(2, "_apply");
  setclosureframe(closure9359, stackframe);
  addtoclosure(closure9359, var_spc);
  addtoclosure(closure9359, selfslot);
  struct UserObject *uo9359 = (struct UserObject*)block9358;
  uo9359->data[0] = (Object)closure9359;
  Method *meth_meth_ast__apply9359 = addmethod2pos(block9358, "_apply", &meth_ast__apply9359, 0);
  int argcv_meth_ast__apply9359[] = {1};
  meth_meth_ast__apply9359->type = alloc_MethodType(1, argcv_meth_ast__apply9359);
  meth_meth_ast__apply9359->definitionModule = modulename;
  meth_meth_ast__apply9359->definitionLine = 2254;
// compiled block node returning block9358 (depth = 5)
  gc_frame_newslot(block9358);
// call case 5: prelude request
  params[0] = opresult9357;
  params[1] = block9358;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9366 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9353);
// compiled call node returning call9366 (depth = 4)
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9368 == NULL) {
    strlit9368 = alloc_String("");
    gc_root(strlit9368);
  }
// compiled string node returning strlit9368 (depth = 6)
  int op_slot_right_9367 = gc_frame_newslot(strlit9368);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9372 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9371);
// compiled call node returning call9372 (depth = 8)
// compiled member node returning call9372 (depth = 7)
  int op_slot_right_9370 = gc_frame_newslot(call9372);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9375 == NULL) {
    strlit9375 = alloc_String(": ");
    gc_root(strlit9375);
  }
// compiled string node returning strlit9375 (depth = 8)
  int op_slot_right_9374 = gc_frame_newslot(strlit9375);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9378 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9379 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9378);
// compiled call node returning call9379 (depth = 9)
  int op_slot_right_9377 = gc_frame_newslot(call9379);
// starting to compile string node (depth = 9)
  if (strlit9381 == NULL) {
    strlit9381 = alloc_String("");
    gc_root(strlit9381);
  }
// compiled string node returning strlit9381 (depth = 9)
  int op_slot_left_9377 = gc_frame_newslot(strlit9381);
  params[0] = call9379;
  partcv[0] = 1;
  Object opresult9382 = callmethod(strlit9381, "++", 1, partcv, params);
// compiled op node returning opresult9382 (depth = 8)
  int op_slot_left_9374 = gc_frame_newslot(opresult9382);
  params[0] = strlit9375;
  partcv[0] = 1;
  Object opresult9383 = callmethod(opresult9382, "++", 1, partcv, params);
// compiled op node returning opresult9383 (depth = 7)
  int op_slot_left_9370 = gc_frame_newslot(opresult9383);
  params[0] = call9372;
  partcv[0] = 1;
  Object opresult9384 = callmethod(opresult9383, "++", 1, partcv, params);
// compiled op node returning opresult9384 (depth = 6)
  int op_slot_left_9367 = gc_frame_newslot(opresult9384);
  params[0] = strlit9368;
  partcv[0] = 1;
  Object opresult9385 = callmethod(opresult9384, "++", 1, partcv, params);
// compiled op node returning opresult9385 (depth = 5)
  *var_s = opresult9385;
  if (opresult9385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9387 == NULL) {
    strlit9387 = alloc_String("Parameters:");
    gc_root(strlit9387);
  }
// compiled string node returning strlit9387 (depth = 6)
  int op_slot_right_9386 = gc_frame_newslot(strlit9387);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9389 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9392 == NULL) {
    strlit9392 = alloc_String("""\x0a""");
    gc_root(strlit9392);
  }
// compiled string node returning strlit9392 (depth = 8)
  int op_slot_right_9391 = gc_frame_newslot(strlit9392);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9394 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9396 == NULL) {
    strlit9396 = alloc_String("");
    gc_root(strlit9396);
  }
// compiled string node returning strlit9396 (depth = 9)
  int op_slot_left_9394 = gc_frame_newslot(strlit9396);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9397 = callmethod(strlit9396, "++", 1, partcv, params);
// compiled op node returning opresult9397 (depth = 8)
  int op_slot_left_9391 = gc_frame_newslot(opresult9397);
  params[0] = strlit9392;
  partcv[0] = 1;
  Object opresult9398 = callmethod(opresult9397, "++", 1, partcv, params);
// compiled op node returning opresult9398 (depth = 7)
  int op_slot_left_9389 = gc_frame_newslot(opresult9398);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9399 = callmethod(opresult9398, "++", 1, partcv, params);
// compiled op node returning opresult9399 (depth = 6)
  int op_slot_left_9386 = gc_frame_newslot(opresult9399);
  params[0] = strlit9387;
  partcv[0] = 1;
  Object opresult9400 = callmethod(opresult9399, "++", 1, partcv, params);
// compiled op node returning opresult9400 (depth = 5)
  *var_s = opresult9400;
  if (opresult9400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9402 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9403 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9404 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9403);
// compiled call node returning call9404 (depth = 6)
// compiled member node returning call9404 (depth = 5)
  gc_frame_newslot(call9404);
// starting to compile block node (depth = 5)
  Object block9405 = alloc_Block(NULL, NULL, "ast", 2265);
  gc_frame_newslot(block9405);
// method _apply
  block_savedest(block9405);
  Object closure9406 = createclosure(4, "_apply");
  setclosureframe(closure9406, stackframe);
  addtoclosure(closure9406, var_depth);
  addtoclosure(closure9406, var_spc);
  addtoclosure(closure9406, var_s);
  addtoclosure(closure9406, selfslot);
  struct UserObject *uo9406 = (struct UserObject*)block9405;
  uo9406->data[0] = (Object)closure9406;
  Method *meth_meth_ast__apply9406 = addmethod2pos(block9405, "_apply", &meth_ast__apply9406, 0);
  int argcv_meth_ast__apply9406[] = {1};
  meth_meth_ast__apply9406->type = alloc_MethodType(1, argcv_meth_ast__apply9406);
  meth_meth_ast__apply9406->definitionModule = modulename;
  meth_meth_ast__apply9406->definitionLine = 2265;
// compiled block node returning block9405 (depth = 5)
  gc_frame_newslot(block9405);
// call case 5: prelude request
  params[0] = call9404;
  params[1] = block9405;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9437 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9402);
// compiled call node returning call9437 (depth = 4)
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9440 = alloc_Boolean(0);
// compiled identifier node returning bool9440 (depth = 6)
  int op_slot_right_9439 = gc_frame_newslot(bool9440);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9443 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9442);
// compiled call node returning call9443 (depth = 7)
// compiled member node returning call9443 (depth = 6)
  int op_slot_left_9439 = gc_frame_newslot(call9443);
  params[0] = bool9440;
  partcv[0] = 1;
  Object opresult9444 = callmethod(call9443, "!=", 1, partcv, params);
// compiled op node returning opresult9444 (depth = 5)
  Object if9438 = done;
  if (istrue(opresult9444)) {
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9446 == NULL) {
    strlit9446 = alloc_String("");
    gc_root(strlit9446);
  }
// compiled string node returning strlit9446 (depth = 7)
  int op_slot_right_9445 = gc_frame_newslot(strlit9446);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9449 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9451 = alloc_Float64(1);
// compiled num node returning num9451 (depth = 10)
  int op_slot_right_9450 = gc_frame_newslot(num9451);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  int op_slot_left_9450 = gc_frame_newslot(*var_depth);
  params[0] = num9451;
  partcv[0] = 1;
  Object sum9453 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9453 (depth = 9)
  gc_frame_newslot(sum9453);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9454 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9455 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9454);
// compiled call node returning call9455 (depth = 10)
// compiled member node returning call9455 (depth = 9)
  params[0] = sum9453;
  partcv[0] = 1;
  Object call9456 = callmethod(call9455, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9449);
// compiled call node returning call9456 (depth = 8)
  int op_slot_right_9448 = gc_frame_newslot(call9456);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9459 == NULL) {
    strlit9459 = alloc_String("Vararg: ");
    gc_root(strlit9459);
  }
// compiled string node returning strlit9459 (depth = 9)
  int op_slot_right_9458 = gc_frame_newslot(strlit9459);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_spc (depth = 10)
  int op_slot_right_9461 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit9464 == NULL) {
    strlit9464 = alloc_String("""\x0a""  ");
    gc_root(strlit9464);
  }
// compiled string node returning strlit9464 (depth = 11)
  int op_slot_right_9463 = gc_frame_newslot(strlit9464);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_s (depth = 12)
  int op_slot_right_9466 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 12)
  if (strlit9468 == NULL) {
    strlit9468 = alloc_String("");
    gc_root(strlit9468);
  }
// compiled string node returning strlit9468 (depth = 12)
  int op_slot_left_9466 = gc_frame_newslot(strlit9468);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9469 = callmethod(strlit9468, "++", 1, partcv, params);
// compiled op node returning opresult9469 (depth = 11)
  int op_slot_left_9463 = gc_frame_newslot(opresult9469);
  params[0] = strlit9464;
  partcv[0] = 1;
  Object opresult9470 = callmethod(opresult9469, "++", 1, partcv, params);
// compiled op node returning opresult9470 (depth = 10)
  int op_slot_left_9461 = gc_frame_newslot(opresult9470);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9471 = callmethod(opresult9470, "++", 1, partcv, params);
// compiled op node returning opresult9471 (depth = 9)
  int op_slot_left_9458 = gc_frame_newslot(opresult9471);
  params[0] = strlit9459;
  partcv[0] = 1;
  Object opresult9472 = callmethod(opresult9471, "++", 1, partcv, params);
// compiled op node returning opresult9472 (depth = 8)
  int op_slot_left_9448 = gc_frame_newslot(opresult9472);
  params[0] = call9456;
  partcv[0] = 1;
  Object opresult9473 = callmethod(opresult9472, "++", 1, partcv, params);
// compiled op node returning opresult9473 (depth = 7)
  int op_slot_left_9445 = gc_frame_newslot(opresult9473);
  params[0] = strlit9446;
  partcv[0] = 1;
  Object opresult9474 = callmethod(opresult9473, "++", 1, partcv, params);
// compiled op node returning opresult9474 (depth = 6)
  *var_s = opresult9474;
  if (opresult9474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9438 = done;
  } else {
  }
// compiled if node returning if9438 (depth = 4)
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent9476(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9477 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9478 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9479 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9480 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9479);
// compiled call node returning call9480 (depth = 7)
// compiled member node returning call9480 (depth = 6)
  gc_frame_newslot(call9480);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signaturePart (depth = 6)
  params[0] = call9480;
  partcv[0] = 1;
  Object call9481 = callmethod(*var_signaturePart, "new",
    1, partcv, params);
  gc_frame_end(callframe9478);
// compiled call node returning call9481 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9482 = callmethod(call9481, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe9477);
// compiled call node returning call9482 (depth = 4)
  gc_frame_end(frame);
  return call9482;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent9483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9484 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9485 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9484);
// compiled call node returning call9485 (depth = 4)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9486 = gc_frame_new();
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9487 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call9488 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe9487);
// compiled call node returning call9488 (depth = 7)
// compiled member node returning call9488 (depth = 6)
  gc_frame_newslot(call9488);
// call case 4: self request
  params[0] = call9488;
  partcv[0] = 1;
  Object call9489 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9486);
// compiled call node returning call9489 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_asString9490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9492 == NULL) {
    strlit9492 = alloc_String("");
    gc_root(strlit9492);
  }
// compiled string node returning strlit9492 (depth = 5)
  int op_slot_right_9491 = gc_frame_newslot(strlit9492);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9495 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9496 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9495);
// compiled call node returning call9496 (depth = 7)
// compiled member node returning call9496 (depth = 6)
  int op_slot_right_9494 = gc_frame_newslot(call9496);
// starting to compile string node (depth = 6)
  if (strlit9498 == NULL) {
    strlit9498 = alloc_String("Part: ");
    gc_root(strlit9498);
  }
// compiled string node returning strlit9498 (depth = 6)
  int op_slot_left_9494 = gc_frame_newslot(strlit9498);
  params[0] = call9496;
  partcv[0] = 1;
  Object opresult9499 = callmethod(strlit9498, "++", 1, partcv, params);
// compiled op node returning opresult9499 (depth = 5)
  int op_slot_left_9491 = gc_frame_newslot(opresult9499);
  params[0] = strlit9492;
  partcv[0] = 1;
  Object opresult9500 = callmethod(opresult9499, "++", 1, partcv, params);
// compiled op node returning opresult9500 (depth = 4)
  gc_frame_end(frame);
  return opresult9500;
}
Object meth_ast_new9281(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9282 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9282 = alloc_userobj2(22,18, objclass9282);
  gc_frame_newslot(obj9282);
if (objclass9282 == NULL) {
  glfree(obj9282->class->name);
  obj9282->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9282, self, 0);
  addmethodreal(obj9282,"outer", &reader_ast_outer_9283);
  Object oldself9282 = self;
  struct StackFrameObject *oldstackframe9282 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9282);
  gc_frame_newslot((Object)stackframe);
  self = obj9282;
  Object *oldselfslot9282 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9282 = (*(struct UserObject *)self).data[0], lowerouter9282 = thisouter9282;
  if (inheritingObject9282) {
    struct UserObject *inho9282 = (struct UserObject *)inheritingObject9282;
    while (inho9282->super != GraceDefaultObject) inho9282 = (struct UserObject *)inho9282->super;
    inho9282->super = obj9282;
    self = inheritingObject9282;
    *selfslot = self;
    lowerouter9282 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9282;
  }
if (objclass9282 == NULL) {
  Method *reader9284 = addmethodrealflags(obj9282, "kind",&reader_ast_kind_9284, MFLAG_DEF);
  reader9284->definitionModule = modulename;
  reader9284->definitionLine = 2229;
}
adddatum2(obj9282, alloc_Undefined(), 1);
if (objclass9282 == NULL) {
  Method *reader9285 = addmethodrealflags(obj9282, "name",&reader_ast_name_9285, 0);
  Method *writer9285 = addmethodrealflags(obj9282, "name:=",&writer_ast_name_9285, 0);
  reader9285->definitionModule = modulename;
  writer9285->definitionModule = modulename;
  reader9285->definitionLine = 2230;
  writer9285->definitionLine = 2230;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 2);
if (objclass9282 == NULL) {
  Method *reader9286 = addmethodrealflags(obj9282, "params",&reader_ast_params_9286, 0);
  Method *writer9286 = addmethodrealflags(obj9282, "params:=",&writer_ast_params_9286, 0);
  reader9286->definitionModule = modulename;
  writer9286->definitionModule = modulename;
  reader9286->definitionLine = 2231;
  writer9286->definitionLine = 2231;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 3);
if (objclass9282 == NULL) {
  Method *reader9287 = addmethodrealflags(obj9282, "vararg",&reader_ast_vararg_9287, 0);
  Method *writer9287 = addmethodrealflags(obj9282, "vararg:=",&writer_ast_vararg_9287, 0);
  reader9287->definitionModule = modulename;
  writer9287->definitionModule = modulename;
  reader9287->definitionLine = 2232;
  writer9287->definitionLine = 2232;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 4);
if (objclass9282 == NULL) {
  Method *reader9288 = addmethodrealflags(obj9282, "generics",&reader_ast_generics_9288, 0);
  Method *writer9288 = addmethodrealflags(obj9282, "generics:=",&writer_ast_generics_9288, 0);
  reader9288->definitionModule = modulename;
  writer9288->definitionModule = modulename;
  reader9288->definitionLine = 2233;
  writer9288->definitionLine = 2233;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 5);
if (objclass9282 == NULL) {
  Method *reader9289 = addmethodrealflags(obj9282, "lineLength",&reader_ast_lineLength_9289, 0);
  Method *writer9289 = addmethodrealflags(obj9282, "lineLength:=",&writer_ast_lineLength_9289, 0);
  reader9289->definitionModule = modulename;
  writer9289->definitionModule = modulename;
  reader9289->definitionLine = 2234;
  writer9289->definitionLine = 2234;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 6);
// method accept()from
  struct UserObject *uo9290 = (struct UserObject*)obj9282;
  uo9290->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9290 = addmethod2pos(obj9282, "accept()from", &meth_ast_accept_40__41_from9290, 7);
  int argcv_meth_ast_accept_40__41_from9290[] = {1, 1};
  meth_meth_ast_accept_40__41_from9290->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9290);
  meth_meth_ast_accept_40__41_from9290->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9290->definitionLine = 2243;
// method declarationKind
  struct UserObject *uo9323 = (struct UserObject*)obj9282;
  uo9323->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKind9323 = addmethod2pos(obj9282, "declarationKind", &meth_ast_declarationKind9323, 8);
  int argcv_meth_ast_declarationKind9323[] = {0};
  meth_meth_ast_declarationKind9323->type = alloc_MethodType(1, argcv_meth_ast_declarationKind9323);
  meth_meth_ast_declarationKind9323->definitionModule = modulename;
  meth_meth_ast_declarationKind9323->definitionLine = 2250;
// method map()parent
  struct UserObject *uo9325 = (struct UserObject*)obj9282;
  uo9325->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9325 = addmethod2pos(obj9282, "map()parent", &meth_ast_map_40__41_parent9325, 9);
  int argcv_meth_ast_map_40__41_parent9325[] = {1, 1};
  meth_meth_ast_map_40__41_parent9325->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9325);
  meth_meth_ast_map_40__41_parent9325->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9325->definitionLine = 2251;
// method pretty
  struct UserObject *uo9351 = (struct UserObject*)obj9282;
  uo9351->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty9351 = addmethod2pos(obj9282, "pretty", &meth_ast_pretty9351, 10);
  int argcv_meth_ast_pretty9351[] = {1};
  meth_meth_ast_pretty9351->type = alloc_MethodType(1, argcv_meth_ast_pretty9351);
  meth_meth_ast_pretty9351->definitionModule = modulename;
  meth_meth_ast_pretty9351->definitionLine = 2258;
// method shallowCopyWithParent
  block_savedest(obj9282);
  Object closure9476 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9476, stackframe);
  addtoclosure(closure9476, var_signaturePart);
  struct UserObject *uo9476 = (struct UserObject*)obj9282;
  uo9476->data[11] = (Object)closure9476;
  Method *meth_meth_ast_shallowCopyWithParent9476 = addmethod2pos(obj9282, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9476, 11);
  int argcv_meth_ast_shallowCopyWithParent9476[] = {1};
  meth_meth_ast_shallowCopyWithParent9476->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9476);
  meth_meth_ast_shallowCopyWithParent9476->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9476->definitionLine = 2273;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo9483 = (struct UserObject*)obj9282;
  uo9483->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483 = addmethod2pos(obj9282, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent9483, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9483[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9483);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483->definitionLine = 2276;
// method asString
  struct UserObject *uo9490 = (struct UserObject*)obj9282;
  uo9490->data[13] = emptyclosure;
  Method *meth_meth_ast_asString9490 = addmethod2pos(obj9282, "asString", &meth_ast_asString9490, 13);
  int argcv_meth_ast_asString9490[] = {0};
  meth_meth_ast_asString9490->type = alloc_MethodType(1, argcv_meth_ast_asString9490);
  meth_meth_ast_asString9490->definitionModule = modulename;
  meth_meth_ast_asString9490->definitionLine = 2281;
  sourceObject = obj9282;
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9501 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9502 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9501);
// compiled call node returning call9502 (depth = 4)
  struct UserObject *obj9282_uo = (struct UserObject *)obj9282;
  obj9282_uo->super = call9502;
  sourceObject = obj9282;
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9503 == NULL) {
    strlit9503 = alloc_String("signaturepart");
    gc_root(strlit9503);
  }
// compiled string node returning strlit9503 (depth = 4)
  adddatum2(obj9282, strlit9503, 1);
  sourceObject = obj9282;
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9504 == NULL) {
    strlit9504 = alloc_String("");
    gc_root(strlit9504);
  }
// compiled string node returning strlit9504 (depth = 4)
  adddatum2(obj9282, strlit9504, 2);
  sourceObject = obj9282;
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9505 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9506 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9507 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9506);
// compiled call node returning call9507 (depth = 7)
// compiled member node returning call9507 (depth = 6)
  partcv[0] = 0;
  Object call9508 = callmethod(call9507, "empty",
    1, partcv, params);
  gc_frame_end(callframe9505);
// compiled call node returning call9508 (depth = 5)
// compiled member node returning call9508 (depth = 4)
  adddatum2(obj9282, call9508, 3);
  sourceObject = obj9282;
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9509 = alloc_Boolean(0);
// compiled identifier node returning bool9509 (depth = 4)
  adddatum2(obj9282, bool9509, 4);
  sourceObject = obj9282;
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9510 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9511 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9512 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9511);
// compiled call node returning call9512 (depth = 7)
// compiled member node returning call9512 (depth = 6)
  partcv[0] = 0;
  Object call9513 = callmethod(call9512, "empty",
    1, partcv, params);
  gc_frame_end(callframe9510);
// compiled call node returning call9513 (depth = 5)
// compiled member node returning call9513 (depth = 4)
  adddatum2(obj9282, call9513, 5);
  sourceObject = obj9282;
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num9514 = alloc_Float64(0);
// compiled num node returning num9514 (depth = 4)
  adddatum2(obj9282, num9514, 6);
  sourceObject = obj9282;
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9517 = alloc_Float64(0);
// compiled num node returning num9517 (depth = 6)
  int op_slot_right_9516 = gc_frame_newslot(num9517);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9520 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9519);
// compiled call node returning call9520 (depth = 7)
// compiled member node returning call9520 (depth = 6)
  int op_slot_left_9516 = gc_frame_newslot(call9520);
  params[0] = num9517;
  partcv[0] = 1;
  Object opresult9521 = callmethod(call9520, ">", 1, partcv, params);
// compiled op node returning opresult9521 (depth = 5)
  Object if9515 = done;
struct StackFrameObject *iftmpstackframe9515 = stackframe;
  if (istrue(opresult9521)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9515);
gc_frame_newslot((Object)stackframe);
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9522 = gc_frame_new();
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9523 = alloc_Float64(1);
// compiled num node returning num9523 (depth = 8)
  params[0] = num9523;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9524 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9524 (depth = 7)
  gc_frame_newslot(idxres9524);
// call case 4: self request
  params[0] = idxres9524;
  partcv[0] = 1;
  Object call9525 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9522);
// compiled call node returning call9525 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9515 = done;
  } else {
  }
stackframe = iftmpstackframe9515;
// compiled if node returning if9515 (depth = 4)
  sourceObject = obj9282;
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9528 = alloc_Float64(1);
// compiled num node returning num9528 (depth = 6)
  int op_slot_right_9527 = gc_frame_newslot(num9528);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9531 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9530);
// compiled call node returning call9531 (depth = 7)
// compiled member node returning call9531 (depth = 6)
  int op_slot_left_9527 = gc_frame_newslot(call9531);
  params[0] = num9528;
  partcv[0] = 1;
  Object opresult9532 = callmethod(call9531, ">", 1, partcv, params);
// compiled op node returning opresult9532 (depth = 5)
  Object if9526 = done;
struct StackFrameObject *iftmpstackframe9526 = stackframe;
  if (istrue(opresult9532)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9526);
gc_frame_newslot((Object)stackframe);
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9533 = gc_frame_new();
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9534 = alloc_Float64(2);
// compiled num node returning num9534 (depth = 8)
  params[0] = num9534;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9535 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9535 (depth = 7)
  gc_frame_newslot(idxres9535);
// call case 4: self request
  params[0] = idxres9535;
  partcv[0] = 1;
  Object call9536 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9533);
// compiled call node returning call9536 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9526 = done;
  } else {
  }
stackframe = iftmpstackframe9526;
// compiled if node returning if9526 (depth = 4)
  sourceObject = obj9282;
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9539 = alloc_Float64(2);
// compiled num node returning num9539 (depth = 6)
  int op_slot_right_9538 = gc_frame_newslot(num9539);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9542 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9541);
// compiled call node returning call9542 (depth = 7)
// compiled member node returning call9542 (depth = 6)
  int op_slot_left_9538 = gc_frame_newslot(call9542);
  params[0] = num9539;
  partcv[0] = 1;
  Object opresult9543 = callmethod(call9542, ">", 1, partcv, params);
// compiled op node returning opresult9543 (depth = 5)
  Object if9537 = done;
struct StackFrameObject *iftmpstackframe9537 = stackframe;
  if (istrue(opresult9543)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9537);
gc_frame_newslot((Object)stackframe);
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9544 = gc_frame_new();
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9545 = alloc_Float64(3);
// compiled num node returning num9545 (depth = 8)
  params[0] = num9545;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9546 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9546 (depth = 7)
  gc_frame_newslot(idxres9546);
// call case 4: self request
  params[0] = idxres9546;
  partcv[0] = 1;
  Object call9547 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9544);
// compiled call node returning call9547 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9537 = done;
  } else {
  }
stackframe = iftmpstackframe9537;
// compiled if node returning if9537 (depth = 4)
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
objclass9282 = obj9282->class;
  objclass9282->definitionModule = modulename;
  objclass9282->definitionLine = 2226;
  (*(struct UserObject *)self).data[0] = lowerouter9282;
  self = oldself9282;
  selfslot = oldselfslot9282;
  stackframe = oldstackframe9282;
  gc_frame_end(frame);
  return obj9282;
}
Object meth_ast_new9281_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9282 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9282 = alloc_userobj2(22,18, objclass9282);
  gc_frame_newslot(obj9282);
if (objclass9282 == NULL) {
  glfree(obj9282->class->name);
  obj9282->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9282, self, 0);
  addmethodreal(obj9282,"outer", &reader_ast_outer_9283);
  Object oldself9282 = self;
  struct StackFrameObject *oldstackframe9282 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9282);
  gc_frame_newslot((Object)stackframe);
  self = obj9282;
  Object *oldselfslot9282 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9282 = (*(struct UserObject *)self).data[0], lowerouter9282 = thisouter9282;
  if (inheritingObject9282) {
    struct UserObject *inho9282 = (struct UserObject *)inheritingObject9282;
    while (inho9282->super != GraceDefaultObject) inho9282 = (struct UserObject *)inho9282->super;
    inho9282->super = obj9282;
    self = inheritingObject9282;
    *selfslot = self;
    lowerouter9282 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9282;
  }
if (objclass9282 == NULL) {
  Method *reader9284 = addmethodrealflags(obj9282, "kind",&reader_ast_kind_9284, MFLAG_DEF);
  reader9284->definitionModule = modulename;
  reader9284->definitionLine = 2229;
}
adddatum2(obj9282, alloc_Undefined(), 1);
if (objclass9282 == NULL) {
  Method *reader9285 = addmethodrealflags(obj9282, "name",&reader_ast_name_9285, 0);
  Method *writer9285 = addmethodrealflags(obj9282, "name:=",&writer_ast_name_9285, 0);
  reader9285->definitionModule = modulename;
  writer9285->definitionModule = modulename;
  reader9285->definitionLine = 2230;
  writer9285->definitionLine = 2230;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 2);
if (objclass9282 == NULL) {
  Method *reader9286 = addmethodrealflags(obj9282, "params",&reader_ast_params_9286, 0);
  Method *writer9286 = addmethodrealflags(obj9282, "params:=",&writer_ast_params_9286, 0);
  reader9286->definitionModule = modulename;
  writer9286->definitionModule = modulename;
  reader9286->definitionLine = 2231;
  writer9286->definitionLine = 2231;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 3);
if (objclass9282 == NULL) {
  Method *reader9287 = addmethodrealflags(obj9282, "vararg",&reader_ast_vararg_9287, 0);
  Method *writer9287 = addmethodrealflags(obj9282, "vararg:=",&writer_ast_vararg_9287, 0);
  reader9287->definitionModule = modulename;
  writer9287->definitionModule = modulename;
  reader9287->definitionLine = 2232;
  writer9287->definitionLine = 2232;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 4);
if (objclass9282 == NULL) {
  Method *reader9288 = addmethodrealflags(obj9282, "generics",&reader_ast_generics_9288, 0);
  Method *writer9288 = addmethodrealflags(obj9282, "generics:=",&writer_ast_generics_9288, 0);
  reader9288->definitionModule = modulename;
  writer9288->definitionModule = modulename;
  reader9288->definitionLine = 2233;
  writer9288->definitionLine = 2233;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 5);
if (objclass9282 == NULL) {
  Method *reader9289 = addmethodrealflags(obj9282, "lineLength",&reader_ast_lineLength_9289, 0);
  Method *writer9289 = addmethodrealflags(obj9282, "lineLength:=",&writer_ast_lineLength_9289, 0);
  reader9289->definitionModule = modulename;
  writer9289->definitionModule = modulename;
  reader9289->definitionLine = 2234;
  writer9289->definitionLine = 2234;
}
obj9282->flags |= OFLAG_MUTABLE;
adddatum2(obj9282, alloc_Undefined(), 6);
// method accept()from
  struct UserObject *uo9290 = (struct UserObject*)obj9282;
  uo9290->data[7] = emptyclosure;
  Method *meth_meth_ast_accept_40__41_from9290 = addmethod2pos(obj9282, "accept()from", &meth_ast_accept_40__41_from9290, 7);
  int argcv_meth_ast_accept_40__41_from9290[] = {1, 1};
  meth_meth_ast_accept_40__41_from9290->type = alloc_MethodType(2, argcv_meth_ast_accept_40__41_from9290);
  meth_meth_ast_accept_40__41_from9290->definitionModule = modulename;
  meth_meth_ast_accept_40__41_from9290->definitionLine = 2243;
// method declarationKind
  struct UserObject *uo9323 = (struct UserObject*)obj9282;
  uo9323->data[8] = emptyclosure;
  Method *meth_meth_ast_declarationKind9323 = addmethod2pos(obj9282, "declarationKind", &meth_ast_declarationKind9323, 8);
  int argcv_meth_ast_declarationKind9323[] = {0};
  meth_meth_ast_declarationKind9323->type = alloc_MethodType(1, argcv_meth_ast_declarationKind9323);
  meth_meth_ast_declarationKind9323->definitionModule = modulename;
  meth_meth_ast_declarationKind9323->definitionLine = 2250;
// method map()parent
  struct UserObject *uo9325 = (struct UserObject*)obj9282;
  uo9325->data[9] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9325 = addmethod2pos(obj9282, "map()parent", &meth_ast_map_40__41_parent9325, 9);
  int argcv_meth_ast_map_40__41_parent9325[] = {1, 1};
  meth_meth_ast_map_40__41_parent9325->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9325);
  meth_meth_ast_map_40__41_parent9325->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9325->definitionLine = 2251;
// method pretty
  struct UserObject *uo9351 = (struct UserObject*)obj9282;
  uo9351->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty9351 = addmethod2pos(obj9282, "pretty", &meth_ast_pretty9351, 10);
  int argcv_meth_ast_pretty9351[] = {1};
  meth_meth_ast_pretty9351->type = alloc_MethodType(1, argcv_meth_ast_pretty9351);
  meth_meth_ast_pretty9351->definitionModule = modulename;
  meth_meth_ast_pretty9351->definitionLine = 2258;
// method shallowCopyWithParent
  block_savedest(obj9282);
  Object closure9476 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9476, stackframe);
  addtoclosure(closure9476, var_signaturePart);
  struct UserObject *uo9476 = (struct UserObject*)obj9282;
  uo9476->data[11] = (Object)closure9476;
  Method *meth_meth_ast_shallowCopyWithParent9476 = addmethod2pos(obj9282, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9476, 11);
  int argcv_meth_ast_shallowCopyWithParent9476[] = {1};
  meth_meth_ast_shallowCopyWithParent9476->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9476);
  meth_meth_ast_shallowCopyWithParent9476->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9476->definitionLine = 2273;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo9483 = (struct UserObject*)obj9282;
  uo9483->data[12] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483 = addmethod2pos(obj9282, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent9483, 12);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9483[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9483);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9483->definitionLine = 2276;
// method asString
  struct UserObject *uo9490 = (struct UserObject*)obj9282;
  uo9490->data[13] = emptyclosure;
  Method *meth_meth_ast_asString9490 = addmethod2pos(obj9282, "asString", &meth_ast_asString9490, 13);
  int argcv_meth_ast_asString9490[] = {0};
  meth_meth_ast_asString9490->type = alloc_MethodType(1, argcv_meth_ast_asString9490);
  meth_meth_ast_asString9490->definitionModule = modulename;
  meth_meth_ast_asString9490->definitionLine = 2281;
  sourceObject = obj9282;
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9501 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9502 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9501);
// compiled call node returning call9502 (depth = 4)
  struct UserObject *obj9282_uo = (struct UserObject *)obj9282;
  obj9282_uo->super = call9502;
  sourceObject = obj9282;
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9503 == NULL) {
    strlit9503 = alloc_String("signaturepart");
    gc_root(strlit9503);
  }
// compiled string node returning strlit9503 (depth = 4)
  adddatum2(obj9282, strlit9503, 1);
  sourceObject = obj9282;
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9504 == NULL) {
    strlit9504 = alloc_String("");
    gc_root(strlit9504);
  }
// compiled string node returning strlit9504 (depth = 4)
  adddatum2(obj9282, strlit9504, 2);
  sourceObject = obj9282;
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9505 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9506 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9507 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9506);
// compiled call node returning call9507 (depth = 7)
// compiled member node returning call9507 (depth = 6)
  partcv[0] = 0;
  Object call9508 = callmethod(call9507, "empty",
    1, partcv, params);
  gc_frame_end(callframe9505);
// compiled call node returning call9508 (depth = 5)
// compiled member node returning call9508 (depth = 4)
  adddatum2(obj9282, call9508, 3);
  sourceObject = obj9282;
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9509 = alloc_Boolean(0);
// compiled identifier node returning bool9509 (depth = 4)
  adddatum2(obj9282, bool9509, 4);
  sourceObject = obj9282;
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9510 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9511 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9512 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9511);
// compiled call node returning call9512 (depth = 7)
// compiled member node returning call9512 (depth = 6)
  partcv[0] = 0;
  Object call9513 = callmethod(call9512, "empty",
    1, partcv, params);
  gc_frame_end(callframe9510);
// compiled call node returning call9513 (depth = 5)
// compiled member node returning call9513 (depth = 4)
  adddatum2(obj9282, call9513, 5);
  sourceObject = obj9282;
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num9514 = alloc_Float64(0);
// compiled num node returning num9514 (depth = 4)
  adddatum2(obj9282, num9514, 6);
  sourceObject = obj9282;
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9517 = alloc_Float64(0);
// compiled num node returning num9517 (depth = 6)
  int op_slot_right_9516 = gc_frame_newslot(num9517);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9520 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9519);
// compiled call node returning call9520 (depth = 7)
// compiled member node returning call9520 (depth = 6)
  int op_slot_left_9516 = gc_frame_newslot(call9520);
  params[0] = num9517;
  partcv[0] = 1;
  Object opresult9521 = callmethod(call9520, ">", 1, partcv, params);
// compiled op node returning opresult9521 (depth = 5)
  Object if9515 = done;
struct StackFrameObject *iftmpstackframe9515 = stackframe;
  if (istrue(opresult9521)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9515);
gc_frame_newslot((Object)stackframe);
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9522 = gc_frame_new();
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9523 = alloc_Float64(1);
// compiled num node returning num9523 (depth = 8)
  params[0] = num9523;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9524 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9524 (depth = 7)
  gc_frame_newslot(idxres9524);
// call case 4: self request
  params[0] = idxres9524;
  partcv[0] = 1;
  Object call9525 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9522);
// compiled call node returning call9525 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9515 = done;
  } else {
  }
stackframe = iftmpstackframe9515;
// compiled if node returning if9515 (depth = 4)
  sourceObject = obj9282;
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9528 = alloc_Float64(1);
// compiled num node returning num9528 (depth = 6)
  int op_slot_right_9527 = gc_frame_newslot(num9528);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9531 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9530);
// compiled call node returning call9531 (depth = 7)
// compiled member node returning call9531 (depth = 6)
  int op_slot_left_9527 = gc_frame_newslot(call9531);
  params[0] = num9528;
  partcv[0] = 1;
  Object opresult9532 = callmethod(call9531, ">", 1, partcv, params);
// compiled op node returning opresult9532 (depth = 5)
  Object if9526 = done;
struct StackFrameObject *iftmpstackframe9526 = stackframe;
  if (istrue(opresult9532)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9526);
gc_frame_newslot((Object)stackframe);
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9533 = gc_frame_new();
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9534 = alloc_Float64(2);
// compiled num node returning num9534 (depth = 8)
  params[0] = num9534;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9535 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9535 (depth = 7)
  gc_frame_newslot(idxres9535);
// call case 4: self request
  params[0] = idxres9535;
  partcv[0] = 1;
  Object call9536 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9533);
// compiled call node returning call9536 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9526 = done;
  } else {
  }
stackframe = iftmpstackframe9526;
// compiled if node returning if9526 (depth = 4)
  sourceObject = obj9282;
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9539 = alloc_Float64(2);
// compiled num node returning num9539 (depth = 6)
  int op_slot_right_9538 = gc_frame_newslot(num9539);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9541 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9542 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9541);
// compiled call node returning call9542 (depth = 7)
// compiled member node returning call9542 (depth = 6)
  int op_slot_left_9538 = gc_frame_newslot(call9542);
  params[0] = num9539;
  partcv[0] = 1;
  Object opresult9543 = callmethod(call9542, ">", 1, partcv, params);
// compiled op node returning opresult9543 (depth = 5)
  Object if9537 = done;
struct StackFrameObject *iftmpstackframe9537 = stackframe;
  if (istrue(opresult9543)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9537);
gc_frame_newslot((Object)stackframe);
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9544 = gc_frame_new();
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9545 = alloc_Float64(3);
// compiled num node returning num9545 (depth = 8)
  params[0] = num9545;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9546 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9546 (depth = 7)
  gc_frame_newslot(idxres9546);
// call case 4: self request
  params[0] = idxres9546;
  partcv[0] = 1;
  Object call9547 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9544);
// compiled call node returning call9547 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9537 = done;
  } else {
  }
stackframe = iftmpstackframe9537;
// compiled if node returning if9537 (depth = 4)
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
  sourceObject = obj9282;
objclass9282 = obj9282->class;
  objclass9282->definitionModule = modulename;
  objclass9282->definitionLine = 2226;
  (*(struct UserObject *)self).data[0] = lowerouter9282;
  self = oldself9282;
  selfslot = oldselfslot9282;
  stackframe = oldstackframe9282;
  gc_frame_end(frame);
  return obj9282;
}
Object meth_ast_callWithPart9549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_callWithPart (depth = 3)
  gc_frame_end(frame);
  return *var_callWithPart;
}
Object meth_ast_map_40__41_parent9559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method map()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method map()parent");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for map()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for map");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9560 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 4: self request
  params[0] = *var_p;
  partcv[0] = 1;
  Object call9561 = callmethodflags(self, "shallowCopyWithParent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9560);
// compiled call node returning call9561 (depth = 5)
  *var_n = call9561;
  if (call9561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9562 = gc_frame_new();
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9563 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9565 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9564);
// compiled call node returning call9565 (depth = 8)
// compiled member node returning call9565 (depth = 7)
  gc_frame_newslot(call9565);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  gc_frame_newslot(*var_n);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9566 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9567 = gc_frame_new();
// call case 3: self.outer request
  Object call9568 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9567);
// compiled call node returning call9568 (depth = 10)
// compiled member node returning call9568 (depth = 9)
  partcv[0] = 0;
  Object call9569 = callmethodflags(call9568, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9566);
// compiled call node returning call9569 (depth = 8)
// compiled member node returning call9569 (depth = 7)
  params[0] = call9565;
  params[1] = *var_blk;
  params[2] = *var_n;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9570 = callmethodflags(call9569, "listMap()parent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9563);
// compiled call node returning call9570 (depth = 6)
  gc_frame_newslot(call9570);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  params[0] = call9570;
  partcv[0] = 1;
  Object call9571 = callmethod(*var_n, "args:=",
    1, partcv, params);
  gc_frame_end(callframe9562);
// compiled call node returning call9571 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9572 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blk (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call9573 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe9572);
// compiled call node returning call9573 (depth = 5)
  *var_n = call9573;
  if (call9573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply9583(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit9585 == NULL) {
    strlit9585 = alloc_String("  ");
    gc_root(strlit9585);
  }
// compiled string node returning strlit9585 (depth = 8)
  int op_slot_right_9584 = gc_frame_newslot(strlit9585);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_spc (depth = 8)
  int op_slot_left_9584 = gc_frame_newslot(*var_spc);
  params[0] = strlit9585;
  partcv[0] = 1;
  Object opresult9587 = callmethod(*var_spc, "++", 1, partcv, params);
// compiled op node returning opresult9587 (depth = 7)
  *var_spc = opresult9587;
  if (opresult9587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply9630(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9632 == NULL) {
    strlit9632 = alloc_String("");
    gc_root(strlit9632);
  }
// compiled string node returning strlit9632 (depth = 8)
  int op_slot_right_9631 = gc_frame_newslot(strlit9632);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9635 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num9637 = alloc_Float64(4);
// compiled num node returning num9637 (depth = 11)
  int op_slot_right_9636 = gc_frame_newslot(num9637);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_depth (depth = 11)
  int op_slot_left_9636 = gc_frame_newslot(*var_depth);
  params[0] = num9637;
  partcv[0] = 1;
  Object sum9639 = callmethod(*var_depth, "+", 1, partcv, params);
// compiled op node returning sum9639 (depth = 10)
  gc_frame_newslot(sum9639);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  params[0] = sum9639;
  partcv[0] = 1;
  Object call9640 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe9635);
// compiled call node returning call9640 (depth = 9)
  int op_slot_right_9634 = gc_frame_newslot(call9640);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9643 == NULL) {
    strlit9643 = alloc_String("");
    gc_root(strlit9643);
  }
// compiled string node returning strlit9643 (depth = 10)
  int op_slot_right_9642 = gc_frame_newslot(strlit9643);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_spc (depth = 11)
  int op_slot_right_9645 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9648 == NULL) {
    strlit9648 = alloc_String("""\x0a""    ");
    gc_root(strlit9648);
  }
// compiled string node returning strlit9648 (depth = 12)
  int op_slot_right_9647 = gc_frame_newslot(strlit9648);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_s (depth = 13)
  int op_slot_right_9650 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 13)
  if (strlit9652 == NULL) {
    strlit9652 = alloc_String("");
    gc_root(strlit9652);
  }
// compiled string node returning strlit9652 (depth = 13)
  int op_slot_left_9650 = gc_frame_newslot(strlit9652);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9653 = callmethod(strlit9652, "++", 1, partcv, params);
// compiled op node returning opresult9653 (depth = 12)
  int op_slot_left_9647 = gc_frame_newslot(opresult9653);
  params[0] = strlit9648;
  partcv[0] = 1;
  Object opresult9654 = callmethod(opresult9653, "++", 1, partcv, params);
// compiled op node returning opresult9654 (depth = 11)
  int op_slot_left_9645 = gc_frame_newslot(opresult9654);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9655 = callmethod(opresult9654, "++", 1, partcv, params);
// compiled op node returning opresult9655 (depth = 10)
  int op_slot_left_9642 = gc_frame_newslot(opresult9655);
  params[0] = strlit9643;
  partcv[0] = 1;
  Object opresult9656 = callmethod(opresult9655, "++", 1, partcv, params);
// compiled op node returning opresult9656 (depth = 9)
  int op_slot_left_9634 = gc_frame_newslot(opresult9656);
  params[0] = call9640;
  partcv[0] = 1;
  Object opresult9657 = callmethod(opresult9656, "++", 1, partcv, params);
// compiled op node returning opresult9657 (depth = 8)
  int op_slot_left_9631 = gc_frame_newslot(opresult9657);
  params[0] = strlit9632;
  partcv[0] = 1;
  Object opresult9658 = callmethod(opresult9657, "++", 1, partcv, params);
// compiled op node returning opresult9658 (depth = 7)
  *var_s = opresult9658;
  if (opresult9658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty9575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method pretty");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit9576 == NULL) {
    strlit9576 = alloc_String("");
    gc_root(strlit9576);
  }
// compiled string node returning strlit9576 (depth = 5)
  *var_spc = strlit9576;
  if (strlit9576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9577 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_depth (depth = 6)
  int op_slot_right_9578 = gc_frame_newslot(*var_depth);
// starting to compile num node (depth = 6)
  Object num9580 = alloc_Float64(0);
// compiled num node returning num9580 (depth = 6)
  int op_slot_left_9578 = gc_frame_newslot(num9580);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult9581 = callmethod(num9580, "..", 1, partcv, params);
// compiled op node returning opresult9581 (depth = 5)
  gc_frame_newslot(opresult9581);
// starting to compile block node (depth = 5)
  Object block9582 = alloc_Block(NULL, NULL, "ast", 2311);
  gc_frame_newslot(block9582);
// method _apply
  block_savedest(block9582);
  Object closure9583 = createclosure(2, "_apply");
  setclosureframe(closure9583, stackframe);
  addtoclosure(closure9583, var_spc);
  addtoclosure(closure9583, selfslot);
  struct UserObject *uo9583 = (struct UserObject*)block9582;
  uo9583->data[0] = (Object)closure9583;
  Method *meth_meth_ast__apply9583 = addmethod2pos(block9582, "_apply", &meth_ast__apply9583, 0);
  int argcv_meth_ast__apply9583[] = {1};
  meth_meth_ast__apply9583->type = alloc_MethodType(1, argcv_meth_ast__apply9583);
  meth_meth_ast__apply9583->definitionModule = modulename;
  meth_meth_ast__apply9583->definitionLine = 2305;
// compiled block node returning block9582 (depth = 5)
  gc_frame_newslot(block9582);
// call case 5: prelude request
  params[0] = opresult9581;
  params[1] = block9582;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9590 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9577);
// compiled call node returning call9590 (depth = 4)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9592 == NULL) {
    strlit9592 = alloc_String("");
    gc_root(strlit9592);
  }
// compiled string node returning strlit9592 (depth = 6)
  int op_slot_right_9591 = gc_frame_newslot(strlit9592);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9595 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9596 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9595);
// compiled call node returning call9596 (depth = 8)
// compiled member node returning call9596 (depth = 7)
  int op_slot_right_9594 = gc_frame_newslot(call9596);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9599 == NULL) {
    strlit9599 = alloc_String(": ");
    gc_root(strlit9599);
  }
// compiled string node returning strlit9599 (depth = 8)
  int op_slot_right_9598 = gc_frame_newslot(strlit9599);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9602 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_depth (depth = 10)
  gc_frame_newslot(*var_depth);
// call case 1: super request
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call9603 = callmethod4(self, "pretty", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9602);
// compiled call node returning call9603 (depth = 9)
  int op_slot_right_9601 = gc_frame_newslot(call9603);
// starting to compile string node (depth = 9)
  if (strlit9605 == NULL) {
    strlit9605 = alloc_String("");
    gc_root(strlit9605);
  }
// compiled string node returning strlit9605 (depth = 9)
  int op_slot_left_9601 = gc_frame_newslot(strlit9605);
  params[0] = call9603;
  partcv[0] = 1;
  Object opresult9606 = callmethod(strlit9605, "++", 1, partcv, params);
// compiled op node returning opresult9606 (depth = 8)
  int op_slot_left_9598 = gc_frame_newslot(opresult9606);
  params[0] = strlit9599;
  partcv[0] = 1;
  Object opresult9607 = callmethod(opresult9606, "++", 1, partcv, params);
// compiled op node returning opresult9607 (depth = 7)
  int op_slot_left_9594 = gc_frame_newslot(opresult9607);
  params[0] = call9596;
  partcv[0] = 1;
  Object opresult9608 = callmethod(opresult9607, "++", 1, partcv, params);
// compiled op node returning opresult9608 (depth = 6)
  int op_slot_left_9591 = gc_frame_newslot(opresult9608);
  params[0] = strlit9592;
  partcv[0] = 1;
  Object opresult9609 = callmethod(opresult9608, "++", 1, partcv, params);
// compiled op node returning opresult9609 (depth = 5)
  *var_s = opresult9609;
  if (opresult9609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9611 == NULL) {
    strlit9611 = alloc_String("Args:");
    gc_root(strlit9611);
  }
// compiled string node returning strlit9611 (depth = 6)
  int op_slot_right_9610 = gc_frame_newslot(strlit9611);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_spc (depth = 7)
  int op_slot_right_9613 = gc_frame_newslot(*var_spc);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9616 == NULL) {
    strlit9616 = alloc_String("""\x0a""    ");
    gc_root(strlit9616);
  }
// compiled string node returning strlit9616 (depth = 8)
  int op_slot_right_9615 = gc_frame_newslot(strlit9616);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_9618 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit9620 == NULL) {
    strlit9620 = alloc_String("");
    gc_root(strlit9620);
  }
// compiled string node returning strlit9620 (depth = 9)
  int op_slot_left_9618 = gc_frame_newslot(strlit9620);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult9621 = callmethod(strlit9620, "++", 1, partcv, params);
// compiled op node returning opresult9621 (depth = 8)
  int op_slot_left_9615 = gc_frame_newslot(opresult9621);
  params[0] = strlit9616;
  partcv[0] = 1;
  Object opresult9622 = callmethod(opresult9621, "++", 1, partcv, params);
// compiled op node returning opresult9622 (depth = 7)
  int op_slot_left_9613 = gc_frame_newslot(opresult9622);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult9623 = callmethod(opresult9622, "++", 1, partcv, params);
// compiled op node returning opresult9623 (depth = 6)
  int op_slot_left_9610 = gc_frame_newslot(opresult9623);
  params[0] = strlit9611;
  partcv[0] = 1;
  Object opresult9624 = callmethod(opresult9623, "++", 1, partcv, params);
// compiled op node returning opresult9624 (depth = 5)
  *var_s = opresult9624;
  if (opresult9624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9626 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9627 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9628 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9627);
// compiled call node returning call9628 (depth = 6)
// compiled member node returning call9628 (depth = 5)
  gc_frame_newslot(call9628);
// starting to compile block node (depth = 5)
  Object block9629 = alloc_Block(NULL, NULL, "ast", 2316);
  gc_frame_newslot(block9629);
// method _apply
  block_savedest(block9629);
  Object closure9630 = createclosure(4, "_apply");
  setclosureframe(closure9630, stackframe);
  addtoclosure(closure9630, var_depth);
  addtoclosure(closure9630, var_spc);
  addtoclosure(closure9630, var_s);
  addtoclosure(closure9630, selfslot);
  struct UserObject *uo9630 = (struct UserObject*)block9629;
  uo9630->data[0] = (Object)closure9630;
  Method *meth_meth_ast__apply9630 = addmethod2pos(block9629, "_apply", &meth_ast__apply9630, 0);
  int argcv_meth_ast__apply9630[] = {1};
  meth_meth_ast__apply9630->type = alloc_MethodType(1, argcv_meth_ast__apply9630);
  meth_meth_ast__apply9630->definitionModule = modulename;
  meth_meth_ast__apply9630->definitionLine = 2316;
// compiled block node returning block9629 (depth = 5)
  gc_frame_newslot(block9629);
// call case 5: prelude request
  params[0] = call9628;
  params[1] = block9629;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9661 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9626);
// compiled call node returning call9661 (depth = 4)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_shallowCopyWithParent9662(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "shallowCopyWithParent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyWithParent");
  Object params[2];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for shallowCopyWithParent (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyWithParent");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9663 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe9664 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9665 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9666 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9665);
// compiled call node returning call9666 (depth = 7)
// compiled member node returning call9666 (depth = 6)
  gc_frame_newslot(call9666);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_callWithPart (depth = 6)
  params[0] = call9666;
  partcv[0] = 1;
  Object call9667 = callmethod(*var_callWithPart, "new",
    1, partcv, params);
  gc_frame_end(callframe9664);
// compiled call node returning call9667 (depth = 5)
  params[0] = self;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9668 = callmethod(call9667, "shallowCopyFieldsFrom()parent",
    2, partcv, params);
  gc_frame_end(callframe9663);
// compiled call node returning call9668 (depth = 4)
  gc_frame_end(frame);
  return call9668;
}
Object meth_ast_shallowCopyFieldsFrom_40__41_parent9669(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "shallowCopyFieldsFrom()parent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method shallowCopyFieldsFrom()parent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for shallowCopyFieldsFrom()parent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for shallowCopyFieldsFrom");
  Object *var_p = &(stackframe->slots[1]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for parent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9670 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_other (depth = 5)
  gc_frame_newslot(*var_other);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// call case 1: super request
  params[0] = *var_other;
  params[1] = *var_p;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9671 = callmethod4(self, "shallowCopyFieldsFrom()parent", 2, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe9670);
// compiled call node returning call9671 (depth = 4)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9672 = gc_frame_new();
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call9674 = callmethod(*var_other, "lineLength",
    1, partcv, params);
  gc_frame_end(callframe9673);
// compiled call node returning call9674 (depth = 7)
// compiled member node returning call9674 (depth = 6)
  gc_frame_newslot(call9674);
// call case 4: self request
  params[0] = call9674;
  partcv[0] = 1;
  Object call9675 = callmethodflags(self, "lineLength:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9672);
// compiled call node returning call9675 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_end(frame);
  return self;
}
Object meth_ast_new9552(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9553 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9553 = alloc_userobj2(14,12, objclass9553);
  gc_frame_newslot(obj9553);
if (objclass9553 == NULL) {
  glfree(obj9553->class->name);
  obj9553->class->name = "callWithPart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9553, self, 0);
  addmethodreal(obj9553,"outer", &reader_ast_outer_9554);
  Object oldself9553 = self;
  struct StackFrameObject *oldstackframe9553 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9553);
  gc_frame_newslot((Object)stackframe);
  self = obj9553;
  Object *oldselfslot9553 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9553 = (*(struct UserObject *)self).data[0], lowerouter9553 = thisouter9553;
  if (inheritingObject9553) {
    struct UserObject *inho9553 = (struct UserObject *)inheritingObject9553;
    while (inho9553->super != GraceDefaultObject) inho9553 = (struct UserObject *)inho9553->super;
    inho9553->super = obj9553;
    self = inheritingObject9553;
    *selfslot = self;
    lowerouter9553 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9553;
  }
if (objclass9553 == NULL) {
  Method *reader9555 = addmethodrealflags(obj9553, "kind",&reader_ast_kind_9555, MFLAG_DEF);
  reader9555->definitionModule = modulename;
  reader9555->definitionLine = 2293;
}
adddatum2(obj9553, alloc_Undefined(), 1);
if (objclass9553 == NULL) {
  Method *reader9556 = addmethodrealflags(obj9553, "name",&reader_ast_name_9556, 0);
  Method *writer9556 = addmethodrealflags(obj9553, "name:=",&writer_ast_name_9556, 0);
  reader9556->definitionModule = modulename;
  writer9556->definitionModule = modulename;
  reader9556->definitionLine = 2294;
  writer9556->definitionLine = 2294;
}
obj9553->flags |= OFLAG_MUTABLE;
adddatum2(obj9553, alloc_Undefined(), 2);
if (objclass9553 == NULL) {
  Method *reader9557 = addmethodrealflags(obj9553, "args",&reader_ast_args_9557, 0);
  Method *writer9557 = addmethodrealflags(obj9553, "args:=",&writer_ast_args_9557, 0);
  reader9557->definitionModule = modulename;
  writer9557->definitionModule = modulename;
  reader9557->definitionLine = 2295;
  writer9557->definitionLine = 2295;
}
obj9553->flags |= OFLAG_MUTABLE;
adddatum2(obj9553, alloc_Undefined(), 3);
if (objclass9553 == NULL) {
  Method *reader9558 = addmethodrealflags(obj9553, "lineLength",&reader_ast_lineLength_9558, 0);
  Method *writer9558 = addmethodrealflags(obj9553, "lineLength:=",&writer_ast_lineLength_9558, 0);
  reader9558->definitionModule = modulename;
  writer9558->definitionModule = modulename;
  reader9558->definitionLine = 2296;
  writer9558->definitionLine = 2296;
}
obj9553->flags |= OFLAG_MUTABLE;
adddatum2(obj9553, alloc_Undefined(), 4);
// method map()parent
  struct UserObject *uo9559 = (struct UserObject*)obj9553;
  uo9559->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9559 = addmethod2pos(obj9553, "map()parent", &meth_ast_map_40__41_parent9559, 5);
  int argcv_meth_ast_map_40__41_parent9559[] = {1, 1};
  meth_meth_ast_map_40__41_parent9559->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9559);
  meth_meth_ast_map_40__41_parent9559->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9559->definitionLine = 2303;
// method pretty
  struct UserObject *uo9575 = (struct UserObject*)obj9553;
  uo9575->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty9575 = addmethod2pos(obj9553, "pretty", &meth_ast_pretty9575, 6);
  int argcv_meth_ast_pretty9575[] = {1};
  meth_meth_ast_pretty9575->type = alloc_MethodType(1, argcv_meth_ast_pretty9575);
  meth_meth_ast_pretty9575->definitionModule = modulename;
  meth_meth_ast_pretty9575->definitionLine = 2309;
// method shallowCopyWithParent
  block_savedest(obj9553);
  Object closure9662 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9662, stackframe);
  addtoclosure(closure9662, var_callWithPart);
  struct UserObject *uo9662 = (struct UserObject*)obj9553;
  uo9662->data[7] = (Object)closure9662;
  Method *meth_meth_ast_shallowCopyWithParent9662 = addmethod2pos(obj9553, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9662, 7);
  int argcv_meth_ast_shallowCopyWithParent9662[] = {1};
  meth_meth_ast_shallowCopyWithParent9662->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9662);
  meth_meth_ast_shallowCopyWithParent9662->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9662->definitionLine = 2321;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo9669 = (struct UserObject*)obj9553;
  uo9669->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669 = addmethod2pos(obj9553, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent9669, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9669[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9669);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669->definitionLine = 2324;
  sourceObject = obj9553;
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9676 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9677 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9676);
// compiled call node returning call9677 (depth = 4)
  struct UserObject *obj9553_uo = (struct UserObject *)obj9553;
  obj9553_uo->super = call9677;
  sourceObject = obj9553;
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9678 == NULL) {
    strlit9678 = alloc_String("callwithpart");
    gc_root(strlit9678);
  }
// compiled string node returning strlit9678 (depth = 4)
  adddatum2(obj9553, strlit9678, 1);
  sourceObject = obj9553;
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9679 == NULL) {
    strlit9679 = alloc_String("");
    gc_root(strlit9679);
  }
// compiled string node returning strlit9679 (depth = 4)
  adddatum2(obj9553, strlit9679, 2);
  sourceObject = obj9553;
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9681 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9682 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9681);
// compiled call node returning call9682 (depth = 7)
// compiled member node returning call9682 (depth = 6)
  partcv[0] = 0;
  Object call9683 = callmethod(call9682, "empty",
    1, partcv, params);
  gc_frame_end(callframe9680);
// compiled call node returning call9683 (depth = 5)
// compiled member node returning call9683 (depth = 4)
  adddatum2(obj9553, call9683, 3);
  sourceObject = obj9553;
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num9684 = alloc_Float64(0);
// compiled num node returning num9684 (depth = 4)
  adddatum2(obj9553, num9684, 4);
  sourceObject = obj9553;
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9687 = alloc_Float64(0);
// compiled num node returning num9687 (depth = 6)
  int op_slot_right_9686 = gc_frame_newslot(num9687);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9690 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9689);
// compiled call node returning call9690 (depth = 7)
// compiled member node returning call9690 (depth = 6)
  int op_slot_left_9686 = gc_frame_newslot(call9690);
  params[0] = num9687;
  partcv[0] = 1;
  Object opresult9691 = callmethod(call9690, ">", 1, partcv, params);
// compiled op node returning opresult9691 (depth = 5)
  Object if9685 = done;
struct StackFrameObject *iftmpstackframe9685 = stackframe;
  if (istrue(opresult9691)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9685);
gc_frame_newslot((Object)stackframe);
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9692 = gc_frame_new();
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9693 = alloc_Float64(1);
// compiled num node returning num9693 (depth = 8)
  params[0] = num9693;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9694 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9694 (depth = 7)
  gc_frame_newslot(idxres9694);
// call case 4: self request
  params[0] = idxres9694;
  partcv[0] = 1;
  Object call9695 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9692);
// compiled call node returning call9695 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9685 = done;
  } else {
  }
stackframe = iftmpstackframe9685;
// compiled if node returning if9685 (depth = 4)
  sourceObject = obj9553;
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9698 = alloc_Float64(1);
// compiled num node returning num9698 (depth = 6)
  int op_slot_right_9697 = gc_frame_newslot(num9698);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9700 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9701 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9700);
// compiled call node returning call9701 (depth = 7)
// compiled member node returning call9701 (depth = 6)
  int op_slot_left_9697 = gc_frame_newslot(call9701);
  params[0] = num9698;
  partcv[0] = 1;
  Object opresult9702 = callmethod(call9701, ">", 1, partcv, params);
// compiled op node returning opresult9702 (depth = 5)
  Object if9696 = done;
struct StackFrameObject *iftmpstackframe9696 = stackframe;
  if (istrue(opresult9702)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9696);
gc_frame_newslot((Object)stackframe);
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9703 = gc_frame_new();
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9704 = alloc_Float64(2);
// compiled num node returning num9704 (depth = 8)
  params[0] = num9704;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9705 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9705 (depth = 7)
  gc_frame_newslot(idxres9705);
// call case 4: self request
  params[0] = idxres9705;
  partcv[0] = 1;
  Object call9706 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9703);
// compiled call node returning call9706 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9696 = done;
  } else {
  }
stackframe = iftmpstackframe9696;
// compiled if node returning if9696 (depth = 4)
  sourceObject = obj9553;
  sourceObject = obj9553;
  sourceObject = obj9553;
  sourceObject = obj9553;
objclass9553 = obj9553->class;
  objclass9553->definitionModule = modulename;
  objclass9553->definitionLine = 2286;
  (*(struct UserObject *)self).data[0] = lowerouter9553;
  self = oldself9553;
  selfslot = oldselfslot9553;
  stackframe = oldstackframe9553;
  gc_frame_end(frame);
  return obj9553;
}
Object meth_ast_new9552_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_callWithPart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9553 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9553 = alloc_userobj2(14,12, objclass9553);
  gc_frame_newslot(obj9553);
if (objclass9553 == NULL) {
  glfree(obj9553->class->name);
  obj9553->class->name = "callWithPart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9553, self, 0);
  addmethodreal(obj9553,"outer", &reader_ast_outer_9554);
  Object oldself9553 = self;
  struct StackFrameObject *oldstackframe9553 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9553);
  gc_frame_newslot((Object)stackframe);
  self = obj9553;
  Object *oldselfslot9553 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9553 = (*(struct UserObject *)self).data[0], lowerouter9553 = thisouter9553;
  if (inheritingObject9553) {
    struct UserObject *inho9553 = (struct UserObject *)inheritingObject9553;
    while (inho9553->super != GraceDefaultObject) inho9553 = (struct UserObject *)inho9553->super;
    inho9553->super = obj9553;
    self = inheritingObject9553;
    *selfslot = self;
    lowerouter9553 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9553;
  }
if (objclass9553 == NULL) {
  Method *reader9555 = addmethodrealflags(obj9553, "kind",&reader_ast_kind_9555, MFLAG_DEF);
  reader9555->definitionModule = modulename;
  reader9555->definitionLine = 2293;
}
adddatum2(obj9553, alloc_Undefined(), 1);
if (objclass9553 == NULL) {
  Method *reader9556 = addmethodrealflags(obj9553, "name",&reader_ast_name_9556, 0);
  Method *writer9556 = addmethodrealflags(obj9553, "name:=",&writer_ast_name_9556, 0);
  reader9556->definitionModule = modulename;
  writer9556->definitionModule = modulename;
  reader9556->definitionLine = 2294;
  writer9556->definitionLine = 2294;
}
obj9553->flags |= OFLAG_MUTABLE;
adddatum2(obj9553, alloc_Undefined(), 2);
if (objclass9553 == NULL) {
  Method *reader9557 = addmethodrealflags(obj9553, "args",&reader_ast_args_9557, 0);
  Method *writer9557 = addmethodrealflags(obj9553, "args:=",&writer_ast_args_9557, 0);
  reader9557->definitionModule = modulename;
  writer9557->definitionModule = modulename;
  reader9557->definitionLine = 2295;
  writer9557->definitionLine = 2295;
}
obj9553->flags |= OFLAG_MUTABLE;
adddatum2(obj9553, alloc_Undefined(), 3);
if (objclass9553 == NULL) {
  Method *reader9558 = addmethodrealflags(obj9553, "lineLength",&reader_ast_lineLength_9558, 0);
  Method *writer9558 = addmethodrealflags(obj9553, "lineLength:=",&writer_ast_lineLength_9558, 0);
  reader9558->definitionModule = modulename;
  writer9558->definitionModule = modulename;
  reader9558->definitionLine = 2296;
  writer9558->definitionLine = 2296;
}
obj9553->flags |= OFLAG_MUTABLE;
adddatum2(obj9553, alloc_Undefined(), 4);
// method map()parent
  struct UserObject *uo9559 = (struct UserObject*)obj9553;
  uo9559->data[5] = emptyclosure;
  Method *meth_meth_ast_map_40__41_parent9559 = addmethod2pos(obj9553, "map()parent", &meth_ast_map_40__41_parent9559, 5);
  int argcv_meth_ast_map_40__41_parent9559[] = {1, 1};
  meth_meth_ast_map_40__41_parent9559->type = alloc_MethodType(2, argcv_meth_ast_map_40__41_parent9559);
  meth_meth_ast_map_40__41_parent9559->definitionModule = modulename;
  meth_meth_ast_map_40__41_parent9559->definitionLine = 2303;
// method pretty
  struct UserObject *uo9575 = (struct UserObject*)obj9553;
  uo9575->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty9575 = addmethod2pos(obj9553, "pretty", &meth_ast_pretty9575, 6);
  int argcv_meth_ast_pretty9575[] = {1};
  meth_meth_ast_pretty9575->type = alloc_MethodType(1, argcv_meth_ast_pretty9575);
  meth_meth_ast_pretty9575->definitionModule = modulename;
  meth_meth_ast_pretty9575->definitionLine = 2309;
// method shallowCopyWithParent
  block_savedest(obj9553);
  Object closure9662 = createclosure(1, "shallowCopyWithParent");
  setclosureframe(closure9662, stackframe);
  addtoclosure(closure9662, var_callWithPart);
  struct UserObject *uo9662 = (struct UserObject*)obj9553;
  uo9662->data[7] = (Object)closure9662;
  Method *meth_meth_ast_shallowCopyWithParent9662 = addmethod2pos(obj9553, "shallowCopyWithParent", &meth_ast_shallowCopyWithParent9662, 7);
  int argcv_meth_ast_shallowCopyWithParent9662[] = {1};
  meth_meth_ast_shallowCopyWithParent9662->type = alloc_MethodType(1, argcv_meth_ast_shallowCopyWithParent9662);
  meth_meth_ast_shallowCopyWithParent9662->definitionModule = modulename;
  meth_meth_ast_shallowCopyWithParent9662->definitionLine = 2321;
// method shallowCopyFieldsFrom()parent
  struct UserObject *uo9669 = (struct UserObject*)obj9553;
  uo9669->data[8] = emptyclosure;
  Method *meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669 = addmethod2pos(obj9553, "shallowCopyFieldsFrom()parent", &meth_ast_shallowCopyFieldsFrom_40__41_parent9669, 8);
  int argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9669[] = {1, 1};
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669->type = alloc_MethodType(2, argcv_meth_ast_shallowCopyFieldsFrom_40__41_parent9669);
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669->definitionModule = modulename;
  meth_meth_ast_shallowCopyFieldsFrom_40__41_parent9669->definitionLine = 2324;
  sourceObject = obj9553;
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9676 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning self (depth = 5)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_baseNode (depth = 5)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9677 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe9676);
// compiled call node returning call9677 (depth = 4)
  struct UserObject *obj9553_uo = (struct UserObject *)obj9553;
  obj9553_uo->super = call9677;
  sourceObject = obj9553;
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9678 == NULL) {
    strlit9678 = alloc_String("callwithpart");
    gc_root(strlit9678);
  }
// compiled string node returning strlit9678 (depth = 4)
  adddatum2(obj9553, strlit9678, 1);
  sourceObject = obj9553;
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit9679 == NULL) {
    strlit9679 = alloc_String("");
    gc_root(strlit9679);
  }
// compiled string node returning strlit9679 (depth = 4)
  adddatum2(obj9553, strlit9679, 2);
  sourceObject = obj9553;
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9680 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9681 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9682 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9681);
// compiled call node returning call9682 (depth = 7)
// compiled member node returning call9682 (depth = 6)
  partcv[0] = 0;
  Object call9683 = callmethod(call9682, "empty",
    1, partcv, params);
  gc_frame_end(callframe9680);
// compiled call node returning call9683 (depth = 5)
// compiled member node returning call9683 (depth = 4)
  adddatum2(obj9553, call9683, 3);
  sourceObject = obj9553;
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num9684 = alloc_Float64(0);
// compiled num node returning num9684 (depth = 4)
  adddatum2(obj9553, num9684, 4);
  sourceObject = obj9553;
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9687 = alloc_Float64(0);
// compiled num node returning num9687 (depth = 6)
  int op_slot_right_9686 = gc_frame_newslot(num9687);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9690 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9689);
// compiled call node returning call9690 (depth = 7)
// compiled member node returning call9690 (depth = 6)
  int op_slot_left_9686 = gc_frame_newslot(call9690);
  params[0] = num9687;
  partcv[0] = 1;
  Object opresult9691 = callmethod(call9690, ">", 1, partcv, params);
// compiled op node returning opresult9691 (depth = 5)
  Object if9685 = done;
struct StackFrameObject *iftmpstackframe9685 = stackframe;
  if (istrue(opresult9691)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9685);
gc_frame_newslot((Object)stackframe);
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9692 = gc_frame_new();
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9693 = alloc_Float64(1);
// compiled num node returning num9693 (depth = 8)
  params[0] = num9693;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9694 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9694 (depth = 7)
  gc_frame_newslot(idxres9694);
// call case 4: self request
  params[0] = idxres9694;
  partcv[0] = 1;
  Object call9695 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9692);
// compiled call node returning call9695 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9685 = done;
  } else {
  }
stackframe = iftmpstackframe9685;
// compiled if node returning if9685 (depth = 4)
  sourceObject = obj9553;
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num9698 = alloc_Float64(1);
// compiled num node returning num9698 (depth = 6)
  int op_slot_right_9697 = gc_frame_newslot(num9698);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9700 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9701 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe9700);
// compiled call node returning call9701 (depth = 7)
// compiled member node returning call9701 (depth = 6)
  int op_slot_left_9697 = gc_frame_newslot(call9701);
  params[0] = num9698;
  partcv[0] = 1;
  Object opresult9702 = callmethod(call9701, ">", 1, partcv, params);
// compiled op node returning opresult9702 (depth = 5)
  Object if9696 = done;
struct StackFrameObject *iftmpstackframe9696 = stackframe;
  if (istrue(opresult9702)) {
stackframe = alloc_StackFrame(0, iftmpstackframe9696);
gc_frame_newslot((Object)stackframe);
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9703 = gc_frame_new();
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile index node (depth = 7)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
// starting to compile num node (depth = 8)
  Object num9704 = alloc_Float64(2);
// compiled num node returning num9704 (depth = 8)
  params[0] = num9704;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres9705 = callmethod(*var_values, "[]", 1, partcv, params);
// compiled index node returning idxres9705 (depth = 7)
  gc_frame_newslot(idxres9705);
// call case 4: self request
  params[0] = idxres9705;
  partcv[0] = 1;
  Object call9706 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9703);
// compiled call node returning call9706 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if9696 = done;
  } else {
  }
stackframe = iftmpstackframe9696;
// compiled if node returning if9696 (depth = 4)
  sourceObject = obj9553;
  sourceObject = obj9553;
  sourceObject = obj9553;
  sourceObject = obj9553;
objclass9553 = obj9553->class;
  objclass9553->definitionModule = modulename;
  objclass9553->definitionLine = 2286;
  (*(struct UserObject *)self).data[0] = lowerouter9553;
  self = oldself9553;
  selfslot = oldselfslot9553;
  stackframe = oldstackframe9553;
  gc_frame_end(frame);
  return obj9553;
}
Object meth_ast_ASTVisitor9710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ASTVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹ASTVisitor›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ASTVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitCall_40__41_up9713(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall()up");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method visitCall()up");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for visitCall()up (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for visitCall");
  Object *var_pNode = &(stackframe->slots[1]);
  *var_pNode = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for up");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9714 = gc_frame_new();
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool9715 = alloc_Boolean(1);
// compiled identifier node returning bool9715 (depth = 5)
  gc_frame_newslot(bool9715);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  params[0] = bool9715;
  partcv[0] = 1;
  Object call9716 = callmethod(*var_c, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe9714);
// compiled call node returning call9716 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9717 = alloc_Boolean(1);
// compiled identifier node returning bool9717 (depth = 3)
  gc_frame_end(frame);
  return bool9717;
}
Object meth_ast_patternMarkVisitor9722(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for patternMarkVisitor (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹patternMarkVisitor›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_patternMarkVisitor (depth = 3)
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(48, 48);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(48, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[2];
  int partcv[2];
Object *var_util = alloc_var();
  Object *var_emptySeq = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "emptySeq");
  Object *var_AstNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "AstNode");
  Object *var_baseNode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "baseNode");
  Object *var_symbolTableNode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "symbolTableNode");
  Object *var_nullNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nullNode");
  Object *var_ifNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ifNode");
  Object *var_blockNode = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "blockNode");
  Object *var_catchCaseNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "catchCaseNode");
  Object *var_matchCaseNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "methodTypeNode");
  Object *var_typeLiteralNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "typeLiteralNode");
  Object *var_typeDecNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "typeDecNode");
  Object *var_methodNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "methodNode");
  Object *var_callNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "callNode");
  Object *var_classNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "classNode");
  Object *var_objectNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "memberNode");
  Object *var_genericNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "genericNode");
  Object *var_identifierNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "identifierNode");
  Object *var_typeType = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "typeType");
  Object *var_unknownType = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "unknownType");
  Object *var_octetsNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "octetsNode");
  Object *var_stringNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "stringNode");
  Object *var_numNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "numNode");
  Object *var_opNode = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "opNode");
  Object *var_indexNode = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "indexNode");
  Object *var_bindNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "varDecNode");
  Object *var_importNode = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "importNode");
  Object *var_dialectNode = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "inheritsNode");
  Object *var_blankNode = &(stackframe->slots[35]);
  setframeelementname(stackframe, 35, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[36]);
  setframeelementname(stackframe, 36, "signaturePart");
  Object *var_callWithPart = &(stackframe->slots[37]);
  setframeelementname(stackframe, 37, "callWithPart");
  Object *var_ASTVisitor = &(stackframe->slots[38]);
  setframeelementname(stackframe, 38, "ASTVisitor");
  Object *var_patternMarkVisitor = &(stackframe->slots[39]);
  setframeelementname(stackframe, 39, "patternMarkVisitor");
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method listMap()parent
  block_savedest(self);
  Object closure0 = createclosure(1, "listMap()parent");
  setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_done);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_ast_listMap_40__41_parent0 = addmethod2pos(self, "listMap()parent", &meth_ast_listMap_40__41_parent0, 1);
  int argcv_meth_ast_listMap_40__41_parent0[] = {2, 1};
  meth_meth_ast_listMap_40__41_parent0->type = alloc_MethodType(2, argcv_meth_ast_listMap_40__41_parent0);
  meth_meth_ast_listMap_40__41_parent0->definitionModule = modulename;
  meth_meth_ast_listMap_40__41_parent0->definitionLine = 21;
// compiled method node returning  (depth = 1)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method maybeMap()parent
  struct UserObject *uo37 = (struct UserObject*)self;
  uo37->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap_40__41_parent37 = addmethod2pos(self, "maybeMap()parent", &meth_ast_maybeMap_40__41_parent37, 2);
  int argcv_meth_ast_maybeMap_40__41_parent37[] = {2, 1};
  meth_meth_ast_maybeMap_40__41_parent37->type = alloc_MethodType(2, argcv_meth_ast_maybeMap_40__41_parent37);
  meth_meth_ast_maybeMap_40__41_parent37->definitionModule = modulename;
  meth_meth_ast_maybeMap_40__41_parent37->definitionLine = 31;
// compiled method node returning  (depth = 1)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method baseVisitor
  struct UserObject *uo45 = (struct UserObject*)self;
  uo45->data[3] = emptyclosure;
  Method *meth_meth_ast_baseVisitor45 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor45, 3);
  int argcv_meth_ast_baseVisitor45[] = {0};
  meth_meth_ast_baseVisitor45->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor45);
  meth_meth_ast_baseVisitor45->definitionModule = modulename;
  meth_meth_ast_baseVisitor45->definitionLine = 2361;
  Method *meth_meth_ast_baseVisitor45_object = addmethod2pos(self, "baseVisitor()object", &meth_ast_baseVisitor45_object, 3);
  int argcv_meth_ast_baseVisitor45_object[] = {0};
  meth_meth_ast_baseVisitor45_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor45_object);
  meth_meth_ast_baseVisitor45_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor45_object->definitionLine = 2361;
// compiled method node returning  (depth = 1)
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method addParentVisitor
  struct UserObject *uo189 = (struct UserObject*)self;
  uo189->data[4] = emptyclosure;
  Method *meth_meth_ast_addParentVisitor189 = addmethod2pos(self, "addParentVisitor", &meth_ast_addParentVisitor189, 4);
  int argcv_meth_ast_addParentVisitor189[] = {0};
  meth_meth_ast_addParentVisitor189->type = alloc_MethodType(1, argcv_meth_ast_addParentVisitor189);
  meth_meth_ast_addParentVisitor189->definitionModule = modulename;
  meth_meth_ast_addParentVisitor189->definitionLine = 2421;
  Method *meth_meth_ast_addParentVisitor189_object = addmethod2pos(self, "addParentVisitor()object", &meth_ast_addParentVisitor189_object, 4);
  int argcv_meth_ast_addParentVisitor189_object[] = {0};
  meth_meth_ast_addParentVisitor189_object->type = alloc_MethodType(1, argcv_meth_ast_addParentVisitor189_object);
  meth_meth_ast_addParentVisitor189_object->definitionModule = modulename;
  meth_meth_ast_addParentVisitor189_object->definitionLine = 2421;
// compiled method node returning  (depth = 1)
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findAnnotation
  struct UserObject *uo305 = (struct UserObject*)self;
  uo305->data[5] = emptyclosure;
  Method *meth_meth_ast_findAnnotation305 = addmethod2pos(self, "findAnnotation", &meth_ast_findAnnotation305, 5);
  int argcv_meth_ast_findAnnotation305[] = {2};
  meth_meth_ast_findAnnotation305->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation305);
  meth_meth_ast_findAnnotation305->definitionModule = modulename;
  meth_meth_ast_findAnnotation305->definitionLine = 2460;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe335 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe336 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call337 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe336);
// compiled call node returning call337 (depth = 5)
// compiled member node returning call337 (depth = 4)
  partcv[0] = 0;
  Object call338 = callmethod(call337, "empty",
    1, partcv, params);
  gc_frame_end(callframe335);
// compiled call node returning call338 (depth = 3)
// compiled member node returning call338 (depth = 2)
  *var_emptySeq = call338;
  if (call338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method emptySeq
  block_savedest(self);
  Object closure339 = createclosure(1, "emptySeq");
  setclosureframe(closure339, stackframe);
  addtoclosure(closure339, var_emptySeq);
  struct UserObject *uo339 = (struct UserObject*)self;
  uo339->data[6] = (Object)closure339;
  Method *meth_meth_ast_emptySeq339 = addmethod2pos(self, "emptySeq", &meth_ast_emptySeq339, 6);
  int argcv_meth_ast_emptySeq339[] = {0};
  meth_meth_ast_emptySeq339->type = alloc_MethodType(1, argcv_meth_ast_emptySeq339);
  meth_meth_ast_emptySeq339->definitionModule = modulename;
  meth_meth_ast_emptySeq339->definitionLine = 39;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl AstNode
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type341 = alloc_Type("AstNode", 9);
    add_Method((ClassData)type341, "register", NULL);
    add_Method((ClassData)type341, "line", NULL);
    add_Method((ClassData)type341, "line:=", NULL);
    add_Method((ClassData)type341, "linePos", NULL);
    add_Method((ClassData)type341, "linePos:=", NULL);
    add_Method((ClassData)type341, "hasSymbolTable", NULL);
    add_Method((ClassData)type341, "hasSymbolTable:=", NULL);
    add_Method((ClassData)type341, "parent", NULL);
    add_Method((ClassData)type341, "parent:=", NULL);
// compiled typeliteral node returning type341 (depth = 2)
  *var_AstNode = type341;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method AstNode
  block_savedest(self);
  Object closure342 = createclosure(1, "AstNode");
  setclosureframe(closure342, stackframe);
  addtoclosure(closure342, var_AstNode);
  struct UserObject *uo342 = (struct UserObject*)self;
  uo342->data[7] = (Object)closure342;
  Method *meth_meth_ast_AstNode342 = addmethod2pos(self, "AstNode", &meth_ast_AstNode342, 7);
  int argcv_meth_ast_AstNode342[] = {0};
  meth_meth_ast_AstNode342->type = alloc_MethodType(1, argcv_meth_ast_AstNode342);
  meth_meth_ast_AstNode342->definitionModule = modulename;
  meth_meth_ast_AstNode342->definitionLine = 39;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method baseNode
  block_savedest(self);
  Object closure343 = createclosure(1, "baseNode");
  setclosureframe(closure343, stackframe);
  addtoclosure(closure343, var_baseNode);
  struct UserObject *uo343 = (struct UserObject*)self;
  uo343->data[8] = (Object)closure343;
  Method *meth_meth_ast_baseNode343 = addmethod2pos(self, "baseNode", &meth_ast_baseNode343, 8);
  int argcv_meth_ast_baseNode343[] = {0};
  meth_meth_ast_baseNode343->type = alloc_MethodType(1, argcv_meth_ast_baseNode343);
  meth_meth_ast_baseNode343->definitionModule = modulename;
  meth_meth_ast_baseNode343->definitionLine = 53;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject344 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj344 = alloc_userobj2(2,4, objclass344);
  gc_frame_newslot(obj344);
// OBJECT OUTER DEC outer
  adddatum2(obj344, self, 0);
  addmethodreal(obj344,"outer", &reader_ast_outer_345);
  Object oldself344 = self;
  struct StackFrameObject *oldstackframe344 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe344);
  gc_frame_newslot((Object)stackframe);
  self = obj344;
  Object *oldselfslot344 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter344 = (*(struct UserObject *)self).data[0], lowerouter344 = thisouter344;
  if (inheritingObject344) {
    struct UserObject *inho344 = (struct UserObject *)inheritingObject344;
    while (inho344->super != GraceDefaultObject) inho344 = (struct UserObject *)inho344->super;
    inho344->super = obj344;
    self = inheritingObject344;
    *selfslot = self;
    lowerouter344 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter344;
  }
// method new
  block_savedest(obj344);
  Object closure346 = createclosure(3, "new");
  setclosureframe(closure346, stackframe);
  addtoclosure(closure346, var_unknownType);
  addtoclosure(closure346, var_nullNode);
  addtoclosure(closure346, var_util);
  struct UserObject *uo346 = (struct UserObject*)obj344;
  uo346->data[1] = (Object)closure346;
  Method *meth_meth_ast_new346 = addmethod2pos(obj344, "new", &meth_ast_new346, 1);
  int argcv_meth_ast_new346[] = {0};
  meth_meth_ast_new346->type = alloc_MethodType(1, argcv_meth_ast_new346);
  meth_meth_ast_new346->definitionModule = modulename;
  meth_meth_ast_new346->definitionLine = 53;
  block_savedest(obj344);
  Object closure539 = createclosure(3, "new()object");
  setclosureframe(closure539, stackframe);
  addtoclosure(closure539, var_unknownType);
  addtoclosure(closure539, var_nullNode);
  addtoclosure(closure539, var_util);
  Method *meth_meth_ast_new346_object = addmethod2pos(obj344, "new()object", &meth_ast_new346_object, 1);
  meth_meth_ast_new346_object->definitionModule = modulename;
  meth_meth_ast_new346_object->definitionLine = 53;
  sourceObject = obj344;
objclass344 = obj344->class;
  objclass344->definitionModule = modulename;
  objclass344->definitionLine = 53;
  (*(struct UserObject *)self).data[0] = lowerouter344;
  self = oldself344;
  selfslot = oldselfslot344;
  stackframe = oldstackframe344;
// compiled object node returning obj344 (depth = 3)
  *var_baseNode = obj344;
  if (obj344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method symbolTableNode
  block_savedest(self);
  Object closure540 = createclosure(1, "symbolTableNode");
  setclosureframe(closure540, stackframe);
  addtoclosure(closure540, var_symbolTableNode);
  struct UserObject *uo540 = (struct UserObject*)self;
  uo540->data[9] = (Object)closure540;
  Method *meth_meth_ast_symbolTableNode540 = addmethod2pos(self, "symbolTableNode", &meth_ast_symbolTableNode540, 9);
  int argcv_meth_ast_symbolTableNode540[] = {0};
  meth_meth_ast_symbolTableNode540->type = alloc_MethodType(1, argcv_meth_ast_symbolTableNode540);
  meth_meth_ast_symbolTableNode540->definitionModule = modulename;
  meth_meth_ast_symbolTableNode540->definitionLine = 127;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject541 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj541 = alloc_userobj2(2,4, objclass541);
  gc_frame_newslot(obj541);
// OBJECT OUTER DEC outer
  adddatum2(obj541, self, 0);
  addmethodreal(obj541,"outer", &reader_ast_outer_542);
  Object oldself541 = self;
  struct StackFrameObject *oldstackframe541 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe541);
  gc_frame_newslot((Object)stackframe);
  self = obj541;
  Object *oldselfslot541 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter541 = (*(struct UserObject *)self).data[0], lowerouter541 = thisouter541;
  if (inheritingObject541) {
    struct UserObject *inho541 = (struct UserObject *)inheritingObject541;
    while (inho541->super != GraceDefaultObject) inho541 = (struct UserObject *)inho541->super;
    inho541->super = obj541;
    self = inheritingObject541;
    *selfslot = self;
    lowerouter541 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter541;
  }
// method new
  block_savedest(obj541);
  Object closure543 = createclosure(2, "new");
  setclosureframe(closure543, stackframe);
  addtoclosure(closure543, var_util);
  addtoclosure(closure543, var_baseNode);
  struct UserObject *uo543 = (struct UserObject*)obj541;
  uo543->data[1] = (Object)closure543;
  Method *meth_meth_ast_new543 = addmethod2pos(obj541, "new", &meth_ast_new543, 1);
  int argcv_meth_ast_new543[] = {0};
  meth_meth_ast_new543->type = alloc_MethodType(1, argcv_meth_ast_new543);
  meth_meth_ast_new543->definitionModule = modulename;
  meth_meth_ast_new543->definitionLine = 127;
  block_savedest(obj541);
  Object closure658 = createclosure(2, "new()object");
  setclosureframe(closure658, stackframe);
  addtoclosure(closure658, var_util);
  addtoclosure(closure658, var_baseNode);
  Method *meth_meth_ast_new543_object = addmethod2pos(obj541, "new()object", &meth_ast_new543_object, 1);
  meth_meth_ast_new543_object->definitionModule = modulename;
  meth_meth_ast_new543_object->definitionLine = 127;
  sourceObject = obj541;
objclass541 = obj541->class;
  objclass541->definitionModule = modulename;
  objclass541->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter541;
  self = oldself541;
  selfslot = oldselfslot541;
  stackframe = oldstackframe541;
// compiled object node returning obj541 (depth = 3)
  *var_symbolTableNode = obj541;
  if (obj541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject659 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj659 = alloc_userobj2(3,4, objclass659);
  gc_frame_newslot(obj659);
// OBJECT OUTER DEC outer
  adddatum2(obj659, self, 0);
  addmethodreal(obj659,"outer", &reader_ast_outer_660);
  Object oldself659 = self;
  struct StackFrameObject *oldstackframe659 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe659);
  gc_frame_newslot((Object)stackframe);
  self = obj659;
  Object *oldselfslot659 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter659 = (*(struct UserObject *)self).data[0], lowerouter659 = thisouter659;
  if (inheritingObject659) {
    struct UserObject *inho659 = (struct UserObject *)inheritingObject659;
    while (inho659->super != GraceDefaultObject) inho659 = (struct UserObject *)inho659->super;
    inho659->super = obj659;
    self = inheritingObject659;
    *selfslot = self;
    lowerouter659 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter659;
  }
if (objclass659 == NULL) {
  Method *reader661 = addmethodrealflags(obj659, "kind",&reader_ast_kind_661, MFLAG_DEF);
  reader661->definitionModule = modulename;
  reader661->definitionLine = 166;
}
adddatum2(obj659, alloc_Undefined(), 1);
// method toGrace
  struct UserObject *uo662 = (struct UserObject*)obj659;
  uo662->data[2] = emptyclosure;
  Method *meth_meth_ast_toGrace662 = addmethod2pos(obj659, "toGrace", &meth_ast_toGrace662, 2);
  int argcv_meth_ast_toGrace662[] = {1};
  meth_meth_ast_toGrace662->type = alloc_MethodType(1, argcv_meth_ast_toGrace662);
  meth_meth_ast_toGrace662->definitionModule = modulename;
  meth_meth_ast_toGrace662->definitionLine = 166;
  sourceObject = obj659;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe664 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_symbolTableNode (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call665 = callmethod(*var_symbolTableNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe664);
// compiled call node returning call665 (depth = 3)
  struct UserObject *obj659_uo = (struct UserObject *)obj659;
  obj659_uo->super = call665;
  sourceObject = obj659;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit666 == NULL) {
    strlit666 = alloc_String("null");
    gc_root(strlit666);
  }
// compiled string node returning strlit666 (depth = 3)
  adddatum2(obj659, strlit666, 1);
  sourceObject = obj659;
objclass659 = obj659->class;
  objclass659->definitionModule = modulename;
  objclass659->definitionLine = 163;
  (*(struct UserObject *)self).data[0] = lowerouter659;
  self = oldself659;
  selfslot = oldselfslot659;
  stackframe = oldstackframe659;
// compiled object node returning obj659 (depth = 2)
  *var_nullNode = obj659;
  if (obj659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method nullNode
  block_savedest(self);
  Object closure667 = createclosure(1, "nullNode");
  setclosureframe(closure667, stackframe);
  addtoclosure(closure667, var_nullNode);
  struct UserObject *uo667 = (struct UserObject*)self;
  uo667->data[10] = (Object)closure667;
  Method *meth_meth_ast_nullNode667 = addmethod2pos(self, "nullNode", &meth_ast_nullNode667, 10);
  int argcv_meth_ast_nullNode667[] = {0};
  meth_meth_ast_nullNode667->type = alloc_MethodType(1, argcv_meth_ast_nullNode667);
  meth_meth_ast_nullNode667->definitionModule = modulename;
  meth_meth_ast_nullNode667->definitionLine = 156;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method ifNode
  block_savedest(self);
  Object closure668 = createclosure(1, "ifNode");
  setclosureframe(closure668, stackframe);
  addtoclosure(closure668, var_ifNode);
  struct UserObject *uo668 = (struct UserObject*)self;
  uo668->data[11] = (Object)closure668;
  Method *meth_meth_ast_ifNode668 = addmethod2pos(self, "ifNode", &meth_ast_ifNode668, 11);
  int argcv_meth_ast_ifNode668[] = {0};
  meth_meth_ast_ifNode668->type = alloc_MethodType(1, argcv_meth_ast_ifNode668);
  meth_meth_ast_ifNode668->definitionModule = modulename;
  meth_meth_ast_ifNode668->definitionLine = 171;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject669 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj669 = alloc_userobj2(2,4, objclass669);
  gc_frame_newslot(obj669);
// OBJECT OUTER DEC outer
  adddatum2(obj669, self, 0);
  addmethodreal(obj669,"outer", &reader_ast_outer_670);
  Object oldself669 = self;
  struct StackFrameObject *oldstackframe669 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe669);
  gc_frame_newslot((Object)stackframe);
  self = obj669;
  Object *oldselfslot669 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter669 = (*(struct UserObject *)self).data[0], lowerouter669 = thisouter669;
  if (inheritingObject669) {
    struct UserObject *inho669 = (struct UserObject *)inheritingObject669;
    while (inho669->super != GraceDefaultObject) inho669 = (struct UserObject *)inho669->super;
    inho669->super = obj669;
    self = inheritingObject669;
    *selfslot = self;
    lowerouter669 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter669;
  }
// method new
  block_savedest(obj669);
  Object closure671 = createclosure(4, "new");
  setclosureframe(closure671, stackframe);
  addtoclosure(closure671, var_util);
  addtoclosure(closure671, var_nullNode);
  addtoclosure(closure671, var_ifNode);
  addtoclosure(closure671, var_baseNode);
  struct UserObject *uo671 = (struct UserObject*)obj669;
  uo671->data[1] = (Object)closure671;
  Method *meth_meth_ast_new671 = addmethod2pos(obj669, "new", &meth_ast_new671, 1);
  int argcv_meth_ast_new671[] = {3};
  meth_meth_ast_new671->type = alloc_MethodType(1, argcv_meth_ast_new671);
  meth_meth_ast_new671->definitionModule = modulename;
  meth_meth_ast_new671->definitionLine = 171;
  block_savedest(obj669);
  Object closure1029 = createclosure(4, "new()object");
  setclosureframe(closure1029, stackframe);
  addtoclosure(closure1029, var_util);
  addtoclosure(closure1029, var_nullNode);
  addtoclosure(closure1029, var_ifNode);
  addtoclosure(closure1029, var_baseNode);
  Method *meth_meth_ast_new671_object = addmethod2pos(obj669, "new()object", &meth_ast_new671_object, 1);
  meth_meth_ast_new671_object->definitionModule = modulename;
  meth_meth_ast_new671_object->definitionLine = 171;
  sourceObject = obj669;
objclass669 = obj669->class;
  objclass669->definitionModule = modulename;
  objclass669->definitionLine = 171;
  (*(struct UserObject *)self).data[0] = lowerouter669;
  self = oldself669;
  selfslot = oldselfslot669;
  stackframe = oldstackframe669;
// compiled object node returning obj669 (depth = 3)
  *var_ifNode = obj669;
  if (obj669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method blockNode
  block_savedest(self);
  Object closure1030 = createclosure(1, "blockNode");
  setclosureframe(closure1030, stackframe);
  addtoclosure(closure1030, var_blockNode);
  struct UserObject *uo1030 = (struct UserObject*)self;
  uo1030->data[12] = (Object)closure1030;
  Method *meth_meth_ast_blockNode1030 = addmethod2pos(self, "blockNode", &meth_ast_blockNode1030, 12);
  int argcv_meth_ast_blockNode1030[] = {0};
  meth_meth_ast_blockNode1030->type = alloc_MethodType(1, argcv_meth_ast_blockNode1030);
  meth_meth_ast_blockNode1030->definitionModule = modulename;
  meth_meth_ast_blockNode1030->definitionLine = 244;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1031 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1031 = alloc_userobj2(2,4, objclass1031);
  gc_frame_newslot(obj1031);
// OBJECT OUTER DEC outer
  adddatum2(obj1031, self, 0);
  addmethodreal(obj1031,"outer", &reader_ast_outer_1032);
  Object oldself1031 = self;
  struct StackFrameObject *oldstackframe1031 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1031);
  gc_frame_newslot((Object)stackframe);
  self = obj1031;
  Object *oldselfslot1031 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1031 = (*(struct UserObject *)self).data[0], lowerouter1031 = thisouter1031;
  if (inheritingObject1031) {
    struct UserObject *inho1031 = (struct UserObject *)inheritingObject1031;
    while (inho1031->super != GraceDefaultObject) inho1031 = (struct UserObject *)inho1031->super;
    inho1031->super = obj1031;
    self = inheritingObject1031;
    *selfslot = self;
    lowerouter1031 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1031;
  }
// method new
  block_savedest(obj1031);
  Object closure1033 = createclosure(3, "new");
  setclosureframe(closure1033, stackframe);
  addtoclosure(closure1033, var_blockNode);
  addtoclosure(closure1033, var_symbolTableNode);
  addtoclosure(closure1033, var_patternMarkVisitor);
  struct UserObject *uo1033 = (struct UserObject*)obj1031;
  uo1033->data[1] = (Object)closure1033;
  Method *meth_meth_ast_new1033 = addmethod2pos(obj1031, "new", &meth_ast_new1033, 1);
  int argcv_meth_ast_new1033[] = {2};
  meth_meth_ast_new1033->type = alloc_MethodType(1, argcv_meth_ast_new1033);
  meth_meth_ast_new1033->definitionModule = modulename;
  meth_meth_ast_new1033->definitionLine = 244;
  block_savedest(obj1031);
  Object closure1444 = createclosure(3, "new()object");
  setclosureframe(closure1444, stackframe);
  addtoclosure(closure1444, var_blockNode);
  addtoclosure(closure1444, var_symbolTableNode);
  addtoclosure(closure1444, var_patternMarkVisitor);
  Method *meth_meth_ast_new1033_object = addmethod2pos(obj1031, "new()object", &meth_ast_new1033_object, 1);
  meth_meth_ast_new1033_object->definitionModule = modulename;
  meth_meth_ast_new1033_object->definitionLine = 244;
  sourceObject = obj1031;
objclass1031 = obj1031->class;
  objclass1031->definitionModule = modulename;
  objclass1031->definitionLine = 244;
  (*(struct UserObject *)self).data[0] = lowerouter1031;
  self = oldself1031;
  selfslot = oldselfslot1031;
  stackframe = oldstackframe1031;
// compiled object node returning obj1031 (depth = 3)
  *var_blockNode = obj1031;
  if (obj1031 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method catchCaseNode
  block_savedest(self);
  Object closure1445 = createclosure(1, "catchCaseNode");
  setclosureframe(closure1445, stackframe);
  addtoclosure(closure1445, var_catchCaseNode);
  struct UserObject *uo1445 = (struct UserObject*)self;
  uo1445->data[13] = (Object)closure1445;
  Method *meth_meth_ast_catchCaseNode1445 = addmethod2pos(self, "catchCaseNode", &meth_ast_catchCaseNode1445, 13);
  int argcv_meth_ast_catchCaseNode1445[] = {0};
  meth_meth_ast_catchCaseNode1445->type = alloc_MethodType(1, argcv_meth_ast_catchCaseNode1445);
  meth_meth_ast_catchCaseNode1445->definitionModule = modulename;
  meth_meth_ast_catchCaseNode1445->definitionLine = 347;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1446 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1446 = alloc_userobj2(2,4, objclass1446);
  gc_frame_newslot(obj1446);
// OBJECT OUTER DEC outer
  adddatum2(obj1446, self, 0);
  addmethodreal(obj1446,"outer", &reader_ast_outer_1447);
  Object oldself1446 = self;
  struct StackFrameObject *oldstackframe1446 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1446);
  gc_frame_newslot((Object)stackframe);
  self = obj1446;
  Object *oldselfslot1446 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1446 = (*(struct UserObject *)self).data[0], lowerouter1446 = thisouter1446;
  if (inheritingObject1446) {
    struct UserObject *inho1446 = (struct UserObject *)inheritingObject1446;
    while (inho1446->super != GraceDefaultObject) inho1446 = (struct UserObject *)inho1446->super;
    inho1446->super = obj1446;
    self = inheritingObject1446;
    *selfslot = self;
    lowerouter1446 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1446;
  }
// method new
  block_savedest(obj1446);
  Object closure1448 = createclosure(4, "new");
  setclosureframe(closure1448, stackframe);
  addtoclosure(closure1448, var_nullNode);
  addtoclosure(closure1448, var_emptySeq);
  addtoclosure(closure1448, var_catchCaseNode);
  addtoclosure(closure1448, var_baseNode);
  struct UserObject *uo1448 = (struct UserObject*)obj1446;
  uo1448->data[1] = (Object)closure1448;
  Method *meth_meth_ast_new1448 = addmethod2pos(obj1446, "new", &meth_ast_new1448, 1);
  int argcv_meth_ast_new1448[] = {3};
  meth_meth_ast_new1448->type = alloc_MethodType(1, argcv_meth_ast_new1448);
  meth_meth_ast_new1448->definitionModule = modulename;
  meth_meth_ast_new1448->definitionLine = 347;
  block_savedest(obj1446);
  Object closure1741 = createclosure(4, "new()object");
  setclosureframe(closure1741, stackframe);
  addtoclosure(closure1741, var_nullNode);
  addtoclosure(closure1741, var_emptySeq);
  addtoclosure(closure1741, var_catchCaseNode);
  addtoclosure(closure1741, var_baseNode);
  Method *meth_meth_ast_new1448_object = addmethod2pos(obj1446, "new()object", &meth_ast_new1448_object, 1);
  meth_meth_ast_new1448_object->definitionModule = modulename;
  meth_meth_ast_new1448_object->definitionLine = 347;
  sourceObject = obj1446;
objclass1446 = obj1446->class;
  objclass1446->definitionModule = modulename;
  objclass1446->definitionLine = 347;
  (*(struct UserObject *)self).data[0] = lowerouter1446;
  self = oldself1446;
  selfslot = oldselfslot1446;
  stackframe = oldstackframe1446;
// compiled object node returning obj1446 (depth = 3)
  *var_catchCaseNode = obj1446;
  if (obj1446 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method matchCaseNode
  block_savedest(self);
  Object closure1742 = createclosure(1, "matchCaseNode");
  setclosureframe(closure1742, stackframe);
  addtoclosure(closure1742, var_matchCaseNode);
  struct UserObject *uo1742 = (struct UserObject*)self;
  uo1742->data[14] = (Object)closure1742;
  Method *meth_meth_ast_matchCaseNode1742 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode1742, 14);
  int argcv_meth_ast_matchCaseNode1742[] = {0};
  meth_meth_ast_matchCaseNode1742->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode1742);
  meth_meth_ast_matchCaseNode1742->definitionModule = modulename;
  meth_meth_ast_matchCaseNode1742->definitionLine = 405;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject1743 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1743 = alloc_userobj2(2,4, objclass1743);
  gc_frame_newslot(obj1743);
// OBJECT OUTER DEC outer
  adddatum2(obj1743, self, 0);
  addmethodreal(obj1743,"outer", &reader_ast_outer_1744);
  Object oldself1743 = self;
  struct StackFrameObject *oldstackframe1743 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1743);
  gc_frame_newslot((Object)stackframe);
  self = obj1743;
  Object *oldselfslot1743 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1743 = (*(struct UserObject *)self).data[0], lowerouter1743 = thisouter1743;
  if (inheritingObject1743) {
    struct UserObject *inho1743 = (struct UserObject *)inheritingObject1743;
    while (inho1743->super != GraceDefaultObject) inho1743 = (struct UserObject *)inho1743->super;
    inho1743->super = obj1743;
    self = inheritingObject1743;
    *selfslot = self;
    lowerouter1743 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1743;
  }
// method new
  block_savedest(obj1743);
  Object closure1745 = createclosure(4, "new");
  setclosureframe(closure1745, stackframe);
  addtoclosure(closure1745, var_nullNode);
  addtoclosure(closure1745, var_emptySeq);
  addtoclosure(closure1745, var_matchCaseNode);
  addtoclosure(closure1745, var_baseNode);
  struct UserObject *uo1745 = (struct UserObject*)obj1743;
  uo1745->data[1] = (Object)closure1745;
  Method *meth_meth_ast_new1745 = addmethod2pos(obj1743, "new", &meth_ast_new1745, 1);
  int argcv_meth_ast_new1745[] = {3};
  meth_meth_ast_new1745->type = alloc_MethodType(1, argcv_meth_ast_new1745);
  meth_meth_ast_new1745->definitionModule = modulename;
  meth_meth_ast_new1745->definitionLine = 405;
  block_savedest(obj1743);
  Object closure2040 = createclosure(4, "new()object");
  setclosureframe(closure2040, stackframe);
  addtoclosure(closure2040, var_nullNode);
  addtoclosure(closure2040, var_emptySeq);
  addtoclosure(closure2040, var_matchCaseNode);
  addtoclosure(closure2040, var_baseNode);
  Method *meth_meth_ast_new1745_object = addmethod2pos(obj1743, "new()object", &meth_ast_new1745_object, 1);
  meth_meth_ast_new1745_object->definitionModule = modulename;
  meth_meth_ast_new1745_object->definitionLine = 405;
  sourceObject = obj1743;
objclass1743 = obj1743->class;
  objclass1743->definitionModule = modulename;
  objclass1743->definitionLine = 405;
  (*(struct UserObject *)self).data[0] = lowerouter1743;
  self = oldself1743;
  selfslot = oldselfslot1743;
  stackframe = oldstackframe1743;
// compiled object node returning obj1743 (depth = 3)
  *var_matchCaseNode = obj1743;
  if (obj1743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method methodTypeNode
  block_savedest(self);
  Object closure2041 = createclosure(1, "methodTypeNode");
  setclosureframe(closure2041, stackframe);
  addtoclosure(closure2041, var_methodTypeNode);
  struct UserObject *uo2041 = (struct UserObject*)self;
  uo2041->data[15] = (Object)closure2041;
  Method *meth_meth_ast_methodTypeNode2041 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode2041, 15);
  int argcv_meth_ast_methodTypeNode2041[] = {0};
  meth_meth_ast_methodTypeNode2041->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode2041);
  meth_meth_ast_methodTypeNode2041->definitionModule = modulename;
  meth_meth_ast_methodTypeNode2041->definitionLine = 464;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject2042 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2042 = alloc_userobj2(2,4, objclass2042);
  gc_frame_newslot(obj2042);
// OBJECT OUTER DEC outer
  adddatum2(obj2042, self, 0);
  addmethodreal(obj2042,"outer", &reader_ast_outer_2043);
  Object oldself2042 = self;
  struct StackFrameObject *oldstackframe2042 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2042);
  gc_frame_newslot((Object)stackframe);
  self = obj2042;
  Object *oldselfslot2042 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2042 = (*(struct UserObject *)self).data[0], lowerouter2042 = thisouter2042;
  if (inheritingObject2042) {
    struct UserObject *inho2042 = (struct UserObject *)inheritingObject2042;
    while (inho2042->super != GraceDefaultObject) inho2042 = (struct UserObject *)inho2042->super;
    inho2042->super = obj2042;
    self = inheritingObject2042;
    *selfslot = self;
    lowerouter2042 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2042;
  }
// method new
  block_savedest(obj2042);
  Object closure2044 = createclosure(3, "new");
  setclosureframe(closure2044, stackframe);
  addtoclosure(closure2044, var_emptySeq);
  addtoclosure(closure2044, var_methodTypeNode);
  addtoclosure(closure2044, var_symbolTableNode);
  struct UserObject *uo2044 = (struct UserObject*)obj2042;
  uo2044->data[1] = (Object)closure2044;
  Method *meth_meth_ast_new2044 = addmethod2pos(obj2042, "new", &meth_ast_new2044, 1);
  int argcv_meth_ast_new2044[] = {3};
  meth_meth_ast_new2044->type = alloc_MethodType(1, argcv_meth_ast_new2044);
  meth_meth_ast_new2044->definitionModule = modulename;
  meth_meth_ast_new2044->definitionLine = 464;
  block_savedest(obj2042);
  Object closure2527 = createclosure(3, "new()object");
  setclosureframe(closure2527, stackframe);
  addtoclosure(closure2527, var_emptySeq);
  addtoclosure(closure2527, var_methodTypeNode);
  addtoclosure(closure2527, var_symbolTableNode);
  Method *meth_meth_ast_new2044_object = addmethod2pos(obj2042, "new()object", &meth_ast_new2044_object, 1);
  meth_meth_ast_new2044_object->definitionModule = modulename;
  meth_meth_ast_new2044_object->definitionLine = 464;
  sourceObject = obj2042;
objclass2042 = obj2042->class;
  objclass2042->definitionModule = modulename;
  objclass2042->definitionLine = 464;
  (*(struct UserObject *)self).data[0] = lowerouter2042;
  self = oldself2042;
  selfslot = oldselfslot2042;
  stackframe = oldstackframe2042;
// compiled object node returning obj2042 (depth = 3)
  *var_methodTypeNode = obj2042;
  if (obj2042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method typeLiteralNode
  block_savedest(self);
  Object closure2528 = createclosure(1, "typeLiteralNode");
  setclosureframe(closure2528, stackframe);
  addtoclosure(closure2528, var_typeLiteralNode);
  struct UserObject *uo2528 = (struct UserObject*)self;
  uo2528->data[16] = (Object)closure2528;
  Method *meth_meth_ast_typeLiteralNode2528 = addmethod2pos(self, "typeLiteralNode", &meth_ast_typeLiteralNode2528, 16);
  int argcv_meth_ast_typeLiteralNode2528[] = {0};
  meth_meth_ast_typeLiteralNode2528->type = alloc_MethodType(1, argcv_meth_ast_typeLiteralNode2528);
  meth_meth_ast_typeLiteralNode2528->definitionModule = modulename;
  meth_meth_ast_typeLiteralNode2528->definitionLine = 572;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject2529 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2529 = alloc_userobj2(2,4, objclass2529);
  gc_frame_newslot(obj2529);
// OBJECT OUTER DEC outer
  adddatum2(obj2529, self, 0);
  addmethodreal(obj2529,"outer", &reader_ast_outer_2530);
  Object oldself2529 = self;
  struct StackFrameObject *oldstackframe2529 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2529);
  gc_frame_newslot((Object)stackframe);
  self = obj2529;
  Object *oldselfslot2529 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2529 = (*(struct UserObject *)self).data[0], lowerouter2529 = thisouter2529;
  if (inheritingObject2529) {
    struct UserObject *inho2529 = (struct UserObject *)inheritingObject2529;
    while (inho2529->super != GraceDefaultObject) inho2529 = (struct UserObject *)inho2529->super;
    inho2529->super = obj2529;
    self = inheritingObject2529;
    *selfslot = self;
    lowerouter2529 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2529;
  }
// method new
  block_savedest(obj2529);
  Object closure2531 = createclosure(3, "new");
  setclosureframe(closure2531, stackframe);
  addtoclosure(closure2531, var_emptySeq);
  addtoclosure(closure2531, var_typeLiteralNode);
  addtoclosure(closure2531, var_baseNode);
  struct UserObject *uo2531 = (struct UserObject*)obj2529;
  uo2531->data[1] = (Object)closure2531;
  Method *meth_meth_ast_new2531 = addmethod2pos(obj2529, "new", &meth_ast_new2531, 1);
  int argcv_meth_ast_new2531[] = {2};
  meth_meth_ast_new2531->type = alloc_MethodType(1, argcv_meth_ast_new2531);
  meth_meth_ast_new2531->definitionModule = modulename;
  meth_meth_ast_new2531->definitionLine = 572;
  block_savedest(obj2529);
  Object closure2878 = createclosure(3, "new()object");
  setclosureframe(closure2878, stackframe);
  addtoclosure(closure2878, var_emptySeq);
  addtoclosure(closure2878, var_typeLiteralNode);
  addtoclosure(closure2878, var_baseNode);
  Method *meth_meth_ast_new2531_object = addmethod2pos(obj2529, "new()object", &meth_ast_new2531_object, 1);
  meth_meth_ast_new2531_object->definitionModule = modulename;
  meth_meth_ast_new2531_object->definitionLine = 572;
  sourceObject = obj2529;
objclass2529 = obj2529->class;
  objclass2529->definitionModule = modulename;
  objclass2529->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter2529;
  self = oldself2529;
  selfslot = oldselfslot2529;
  stackframe = oldstackframe2529;
// compiled object node returning obj2529 (depth = 3)
  *var_typeLiteralNode = obj2529;
  if (obj2529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method typeDecNode
  block_savedest(self);
  Object closure2879 = createclosure(1, "typeDecNode");
  setclosureframe(closure2879, stackframe);
  addtoclosure(closure2879, var_typeDecNode);
  struct UserObject *uo2879 = (struct UserObject*)self;
  uo2879->data[17] = (Object)closure2879;
  Method *meth_meth_ast_typeDecNode2879 = addmethod2pos(self, "typeDecNode", &meth_ast_typeDecNode2879, 17);
  int argcv_meth_ast_typeDecNode2879[] = {0};
  meth_meth_ast_typeDecNode2879->type = alloc_MethodType(1, argcv_meth_ast_typeDecNode2879);
  meth_meth_ast_typeDecNode2879->definitionModule = modulename;
  meth_meth_ast_typeDecNode2879->definitionLine = 660;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject2880 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2880 = alloc_userobj2(2,4, objclass2880);
  gc_frame_newslot(obj2880);
// OBJECT OUTER DEC outer
  adddatum2(obj2880, self, 0);
  addmethodreal(obj2880,"outer", &reader_ast_outer_2881);
  Object oldself2880 = self;
  struct StackFrameObject *oldstackframe2880 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2880);
  gc_frame_newslot((Object)stackframe);
  self = obj2880;
  Object *oldselfslot2880 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2880 = (*(struct UserObject *)self).data[0], lowerouter2880 = thisouter2880;
  if (inheritingObject2880) {
    struct UserObject *inho2880 = (struct UserObject *)inheritingObject2880;
    while (inho2880->super != GraceDefaultObject) inho2880 = (struct UserObject *)inho2880->super;
    inho2880->super = obj2880;
    self = inheritingObject2880;
    *selfslot = self;
    lowerouter2880 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2880;
  }
// method new
  block_savedest(obj2880);
  Object closure2882 = createclosure(3, "new");
  setclosureframe(closure2882, stackframe);
  addtoclosure(closure2882, var_nullNode);
  addtoclosure(closure2882, var_typeDecNode);
  addtoclosure(closure2882, var_symbolTableNode);
  struct UserObject *uo2882 = (struct UserObject*)obj2880;
  uo2882->data[1] = (Object)closure2882;
  Method *meth_meth_ast_new2882 = addmethod2pos(obj2880, "new", &meth_ast_new2882, 1);
  int argcv_meth_ast_new2882[] = {2};
  meth_meth_ast_new2882->type = alloc_MethodType(1, argcv_meth_ast_new2882);
  meth_meth_ast_new2882->definitionModule = modulename;
  meth_meth_ast_new2882->definitionLine = 660;
  block_savedest(obj2880);
  Object closure3257 = createclosure(3, "new()object");
  setclosureframe(closure3257, stackframe);
  addtoclosure(closure3257, var_nullNode);
  addtoclosure(closure3257, var_typeDecNode);
  addtoclosure(closure3257, var_symbolTableNode);
  Method *meth_meth_ast_new2882_object = addmethod2pos(obj2880, "new()object", &meth_ast_new2882_object, 1);
  meth_meth_ast_new2882_object->definitionModule = modulename;
  meth_meth_ast_new2882_object->definitionLine = 660;
  sourceObject = obj2880;
objclass2880 = obj2880->class;
  objclass2880->definitionModule = modulename;
  objclass2880->definitionLine = 660;
  (*(struct UserObject *)self).data[0] = lowerouter2880;
  self = oldself2880;
  selfslot = oldselfslot2880;
  stackframe = oldstackframe2880;
// compiled object node returning obj2880 (depth = 3)
  *var_typeDecNode = obj2880;
  if (obj2880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method methodNode
  block_savedest(self);
  Object closure3258 = createclosure(1, "methodNode");
  setclosureframe(closure3258, stackframe);
  addtoclosure(closure3258, var_methodNode);
  struct UserObject *uo3258 = (struct UserObject*)self;
  uo3258->data[18] = (Object)closure3258;
  Method *meth_meth_ast_methodNode3258 = addmethod2pos(self, "methodNode", &meth_ast_methodNode3258, 18);
  int argcv_meth_ast_methodNode3258[] = {0};
  meth_meth_ast_methodNode3258->type = alloc_MethodType(1, argcv_meth_ast_methodNode3258);
  meth_meth_ast_methodNode3258->definitionModule = modulename;
  meth_meth_ast_methodNode3258->definitionLine = 743;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject3259 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3259 = alloc_userobj2(2,4, objclass3259);
  gc_frame_newslot(obj3259);
// OBJECT OUTER DEC outer
  adddatum2(obj3259, self, 0);
  addmethodreal(obj3259,"outer", &reader_ast_outer_3260);
  Object oldself3259 = self;
  struct StackFrameObject *oldstackframe3259 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3259);
  gc_frame_newslot((Object)stackframe);
  self = obj3259;
  Object *oldselfslot3259 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3259 = (*(struct UserObject *)self).data[0], lowerouter3259 = thisouter3259;
  if (inheritingObject3259) {
    struct UserObject *inho3259 = (struct UserObject *)inheritingObject3259;
    while (inho3259->super != GraceDefaultObject) inho3259 = (struct UserObject *)inho3259->super;
    inho3259->super = obj3259;
    self = inheritingObject3259;
    *selfslot = self;
    lowerouter3259 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3259;
  }
// method new
  block_savedest(obj3259);
  Object closure3261 = createclosure(2, "new");
  setclosureframe(closure3261, stackframe);
  addtoclosure(closure3261, var_methodNode);
  addtoclosure(closure3261, var_symbolTableNode);
  struct UserObject *uo3261 = (struct UserObject*)obj3259;
  uo3261->data[1] = (Object)closure3261;
  Method *meth_meth_ast_new3261 = addmethod2pos(obj3259, "new", &meth_ast_new3261, 1);
  int argcv_meth_ast_new3261[] = {4};
  meth_meth_ast_new3261->type = alloc_MethodType(1, argcv_meth_ast_new3261);
  meth_meth_ast_new3261->definitionModule = modulename;
  meth_meth_ast_new3261->definitionLine = 743;
  block_savedest(obj3259);
  Object closure4245 = createclosure(2, "new()object");
  setclosureframe(closure4245, stackframe);
  addtoclosure(closure4245, var_methodNode);
  addtoclosure(closure4245, var_symbolTableNode);
  Method *meth_meth_ast_new3261_object = addmethod2pos(obj3259, "new()object", &meth_ast_new3261_object, 1);
  meth_meth_ast_new3261_object->definitionModule = modulename;
  meth_meth_ast_new3261_object->definitionLine = 743;
  sourceObject = obj3259;
objclass3259 = obj3259->class;
  objclass3259->definitionModule = modulename;
  objclass3259->definitionLine = 743;
  (*(struct UserObject *)self).data[0] = lowerouter3259;
  self = oldself3259;
  selfslot = oldselfslot3259;
  stackframe = oldstackframe3259;
// compiled object node returning obj3259 (depth = 3)
  *var_methodNode = obj3259;
  if (obj3259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method callNode
  block_savedest(self);
  Object closure4246 = createclosure(1, "callNode");
  setclosureframe(closure4246, stackframe);
  addtoclosure(closure4246, var_callNode);
  struct UserObject *uo4246 = (struct UserObject*)self;
  uo4246->data[19] = (Object)closure4246;
  Method *meth_meth_ast_callNode4246 = addmethod2pos(self, "callNode", &meth_ast_callNode4246, 19);
  int argcv_meth_ast_callNode4246[] = {0};
  meth_meth_ast_callNode4246->type = alloc_MethodType(1, argcv_meth_ast_callNode4246);
  meth_meth_ast_callNode4246->definitionModule = modulename;
  meth_meth_ast_callNode4246->definitionLine = 937;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject4247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4247 = alloc_userobj2(2,4, objclass4247);
  gc_frame_newslot(obj4247);
// OBJECT OUTER DEC outer
  adddatum2(obj4247, self, 0);
  addmethodreal(obj4247,"outer", &reader_ast_outer_4248);
  Object oldself4247 = self;
  struct StackFrameObject *oldstackframe4247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4247);
  gc_frame_newslot((Object)stackframe);
  self = obj4247;
  Object *oldselfslot4247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4247 = (*(struct UserObject *)self).data[0], lowerouter4247 = thisouter4247;
  if (inheritingObject4247) {
    struct UserObject *inho4247 = (struct UserObject *)inheritingObject4247;
    while (inho4247->super != GraceDefaultObject) inho4247 = (struct UserObject *)inho4247->super;
    inho4247->super = obj4247;
    self = inheritingObject4247;
    *selfslot = self;
    lowerouter4247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4247;
  }
// method new
  block_savedest(obj4247);
  Object closure4249 = createclosure(2, "new");
  setclosureframe(closure4249, stackframe);
  addtoclosure(closure4249, var_callNode);
  addtoclosure(closure4249, var_baseNode);
  struct UserObject *uo4249 = (struct UserObject*)obj4247;
  uo4249->data[1] = (Object)closure4249;
  Method *meth_meth_ast_new4249 = addmethod2pos(obj4247, "new", &meth_ast_new4249, 1);
  int argcv_meth_ast_new4249[] = {2};
  meth_meth_ast_new4249->type = alloc_MethodType(1, argcv_meth_ast_new4249);
  meth_meth_ast_new4249->definitionModule = modulename;
  meth_meth_ast_new4249->definitionLine = 937;
  block_savedest(obj4247);
  Object closure4737 = createclosure(2, "new()object");
  setclosureframe(closure4737, stackframe);
  addtoclosure(closure4737, var_callNode);
  addtoclosure(closure4737, var_baseNode);
  Method *meth_meth_ast_new4249_object = addmethod2pos(obj4247, "new()object", &meth_ast_new4249_object, 1);
  meth_meth_ast_new4249_object->definitionModule = modulename;
  meth_meth_ast_new4249_object->definitionLine = 937;
  sourceObject = obj4247;
objclass4247 = obj4247->class;
  objclass4247->definitionModule = modulename;
  objclass4247->definitionLine = 937;
  (*(struct UserObject *)self).data[0] = lowerouter4247;
  self = oldself4247;
  selfslot = oldselfslot4247;
  stackframe = oldstackframe4247;
// compiled object node returning obj4247 (depth = 3)
  *var_callNode = obj4247;
  if (obj4247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method classNode
  block_savedest(self);
  Object closure4738 = createclosure(1, "classNode");
  setclosureframe(closure4738, stackframe);
  addtoclosure(closure4738, var_classNode);
  struct UserObject *uo4738 = (struct UserObject*)self;
  uo4738->data[20] = (Object)closure4738;
  Method *meth_meth_ast_classNode4738 = addmethod2pos(self, "classNode", &meth_ast_classNode4738, 20);
  int argcv_meth_ast_classNode4738[] = {0};
  meth_meth_ast_classNode4738->type = alloc_MethodType(1, argcv_meth_ast_classNode4738);
  meth_meth_ast_classNode4738->definitionModule = modulename;
  meth_meth_ast_classNode4738->definitionLine = 1061;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject4739 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4739 = alloc_userobj2(2,4, objclass4739);
  gc_frame_newslot(obj4739);
// OBJECT OUTER DEC outer
  adddatum2(obj4739, self, 0);
  addmethodreal(obj4739,"outer", &reader_ast_outer_4740);
  Object oldself4739 = self;
  struct StackFrameObject *oldstackframe4739 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4739);
  gc_frame_newslot((Object)stackframe);
  self = obj4739;
  Object *oldselfslot4739 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4739 = (*(struct UserObject *)self).data[0], lowerouter4739 = thisouter4739;
  if (inheritingObject4739) {
    struct UserObject *inho4739 = (struct UserObject *)inheritingObject4739;
    while (inho4739->super != GraceDefaultObject) inho4739 = (struct UserObject *)inho4739->super;
    inho4739->super = obj4739;
    self = inheritingObject4739;
    *selfslot = self;
    lowerouter4739 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4739;
  }
// method new
  block_savedest(obj4739);
  Object closure4741 = createclosure(5, "new");
  setclosureframe(closure4741, stackframe);
  addtoclosure(closure4741, var_util);
  addtoclosure(closure4741, var_emptySeq);
  addtoclosure(closure4741, var_nullNode);
  addtoclosure(closure4741, var_classNode);
  addtoclosure(closure4741, var_symbolTableNode);
  struct UserObject *uo4741 = (struct UserObject*)obj4739;
  uo4741->data[1] = (Object)closure4741;
  Method *meth_meth_ast_new4741 = addmethod2pos(obj4739, "new", &meth_ast_new4741, 1);
  int argcv_meth_ast_new4741[] = {6};
  meth_meth_ast_new4741->type = alloc_MethodType(1, argcv_meth_ast_new4741);
  meth_meth_ast_new4741->definitionModule = modulename;
  meth_meth_ast_new4741->definitionLine = 1061;
  block_savedest(obj4739);
  Object closure5747 = createclosure(5, "new()object");
  setclosureframe(closure5747, stackframe);
  addtoclosure(closure5747, var_util);
  addtoclosure(closure5747, var_emptySeq);
  addtoclosure(closure5747, var_nullNode);
  addtoclosure(closure5747, var_classNode);
  addtoclosure(closure5747, var_symbolTableNode);
  Method *meth_meth_ast_new4741_object = addmethod2pos(obj4739, "new()object", &meth_ast_new4741_object, 1);
  meth_meth_ast_new4741_object->definitionModule = modulename;
  meth_meth_ast_new4741_object->definitionLine = 1061;
  sourceObject = obj4739;
objclass4739 = obj4739->class;
  objclass4739->definitionModule = modulename;
  objclass4739->definitionLine = 1061;
  (*(struct UserObject *)self).data[0] = lowerouter4739;
  self = oldself4739;
  selfslot = oldselfslot4739;
  stackframe = oldstackframe4739;
// compiled object node returning obj4739 (depth = 3)
  *var_classNode = obj4739;
  if (obj4739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method objectNode
  block_savedest(self);
  Object closure5748 = createclosure(1, "objectNode");
  setclosureframe(closure5748, stackframe);
  addtoclosure(closure5748, var_objectNode);
  struct UserObject *uo5748 = (struct UserObject*)self;
  uo5748->data[21] = (Object)closure5748;
  Method *meth_meth_ast_objectNode5748 = addmethod2pos(self, "objectNode", &meth_ast_objectNode5748, 21);
  int argcv_meth_ast_objectNode5748[] = {0};
  meth_meth_ast_objectNode5748->type = alloc_MethodType(1, argcv_meth_ast_objectNode5748);
  meth_meth_ast_objectNode5748->definitionModule = modulename;
  meth_meth_ast_objectNode5748->definitionLine = 1242;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject5749 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5749 = alloc_userobj2(2,4, objclass5749);
  gc_frame_newslot(obj5749);
// OBJECT OUTER DEC outer
  adddatum2(obj5749, self, 0);
  addmethodreal(obj5749,"outer", &reader_ast_outer_5750);
  Object oldself5749 = self;
  struct StackFrameObject *oldstackframe5749 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5749);
  gc_frame_newslot((Object)stackframe);
  self = obj5749;
  Object *oldselfslot5749 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5749 = (*(struct UserObject *)self).data[0], lowerouter5749 = thisouter5749;
  if (inheritingObject5749) {
    struct UserObject *inho5749 = (struct UserObject *)inheritingObject5749;
    while (inho5749->super != GraceDefaultObject) inho5749 = (struct UserObject *)inho5749->super;
    inho5749->super = obj5749;
    self = inheritingObject5749;
    *selfslot = self;
    lowerouter5749 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5749;
  }
// method new
  block_savedest(obj5749);
  Object closure5751 = createclosure(3, "new");
  setclosureframe(closure5751, stackframe);
  addtoclosure(closure5751, var_emptySeq);
  addtoclosure(closure5751, var_objectNode);
  addtoclosure(closure5751, var_symbolTableNode);
  struct UserObject *uo5751 = (struct UserObject*)obj5749;
  uo5751->data[1] = (Object)closure5751;
  Method *meth_meth_ast_new5751 = addmethod2pos(obj5749, "new", &meth_ast_new5751, 1);
  int argcv_meth_ast_new5751[] = {2};
  meth_meth_ast_new5751->type = alloc_MethodType(1, argcv_meth_ast_new5751);
  meth_meth_ast_new5751->definitionModule = modulename;
  meth_meth_ast_new5751->definitionLine = 1242;
  block_savedest(obj5749);
  Object closure6038 = createclosure(3, "new()object");
  setclosureframe(closure6038, stackframe);
  addtoclosure(closure6038, var_emptySeq);
  addtoclosure(closure6038, var_objectNode);
  addtoclosure(closure6038, var_symbolTableNode);
  Method *meth_meth_ast_new5751_object = addmethod2pos(obj5749, "new()object", &meth_ast_new5751_object, 1);
  meth_meth_ast_new5751_object->definitionModule = modulename;
  meth_meth_ast_new5751_object->definitionLine = 1242;
  sourceObject = obj5749;
objclass5749 = obj5749->class;
  objclass5749->definitionModule = modulename;
  objclass5749->definitionLine = 1242;
  (*(struct UserObject *)self).data[0] = lowerouter5749;
  self = oldself5749;
  selfslot = oldselfslot5749;
  stackframe = oldstackframe5749;
// compiled object node returning obj5749 (depth = 3)
  *var_objectNode = obj5749;
  if (obj5749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method arrayNode
  block_savedest(self);
  Object closure6039 = createclosure(1, "arrayNode");
  setclosureframe(closure6039, stackframe);
  addtoclosure(closure6039, var_arrayNode);
  struct UserObject *uo6039 = (struct UserObject*)self;
  uo6039->data[22] = (Object)closure6039;
  Method *meth_meth_ast_arrayNode6039 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode6039, 22);
  int argcv_meth_ast_arrayNode6039[] = {0};
  meth_meth_ast_arrayNode6039->type = alloc_MethodType(1, argcv_meth_ast_arrayNode6039);
  meth_meth_ast_arrayNode6039->definitionModule = modulename;
  meth_meth_ast_arrayNode6039->definitionLine = 1318;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject6040 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6040 = alloc_userobj2(2,4, objclass6040);
  gc_frame_newslot(obj6040);
// OBJECT OUTER DEC outer
  adddatum2(obj6040, self, 0);
  addmethodreal(obj6040,"outer", &reader_ast_outer_6041);
  Object oldself6040 = self;
  struct StackFrameObject *oldstackframe6040 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6040);
  gc_frame_newslot((Object)stackframe);
  self = obj6040;
  Object *oldselfslot6040 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6040 = (*(struct UserObject *)self).data[0], lowerouter6040 = thisouter6040;
  if (inheritingObject6040) {
    struct UserObject *inho6040 = (struct UserObject *)inheritingObject6040;
    while (inho6040->super != GraceDefaultObject) inho6040 = (struct UserObject *)inho6040->super;
    inho6040->super = obj6040;
    self = inheritingObject6040;
    *selfslot = self;
    lowerouter6040 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6040;
  }
// method new
  block_savedest(obj6040);
  Object closure6042 = createclosure(3, "new");
  setclosureframe(closure6042, stackframe);
  addtoclosure(closure6042, var_emptySeq);
  addtoclosure(closure6042, var_arrayNode);
  addtoclosure(closure6042, var_baseNode);
  struct UserObject *uo6042 = (struct UserObject*)obj6040;
  uo6042->data[1] = (Object)closure6042;
  Method *meth_meth_ast_new6042 = addmethod2pos(obj6040, "new", &meth_ast_new6042, 1);
  int argcv_meth_ast_new6042[] = {1};
  meth_meth_ast_new6042->type = alloc_MethodType(1, argcv_meth_ast_new6042);
  meth_meth_ast_new6042->definitionModule = modulename;
  meth_meth_ast_new6042->definitionLine = 1318;
  block_savedest(obj6040);
  Object closure6165 = createclosure(3, "new()object");
  setclosureframe(closure6165, stackframe);
  addtoclosure(closure6165, var_emptySeq);
  addtoclosure(closure6165, var_arrayNode);
  addtoclosure(closure6165, var_baseNode);
  Method *meth_meth_ast_new6042_object = addmethod2pos(obj6040, "new()object", &meth_ast_new6042_object, 1);
  meth_meth_ast_new6042_object->definitionModule = modulename;
  meth_meth_ast_new6042_object->definitionLine = 1318;
  sourceObject = obj6040;
objclass6040 = obj6040->class;
  objclass6040->definitionModule = modulename;
  objclass6040->definitionLine = 1318;
  (*(struct UserObject *)self).data[0] = lowerouter6040;
  self = oldself6040;
  selfslot = oldselfslot6040;
  stackframe = oldstackframe6040;
// compiled object node returning obj6040 (depth = 3)
  *var_arrayNode = obj6040;
  if (obj6040 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method memberNode
  block_savedest(self);
  Object closure6166 = createclosure(1, "memberNode");
  setclosureframe(closure6166, stackframe);
  addtoclosure(closure6166, var_memberNode);
  struct UserObject *uo6166 = (struct UserObject*)self;
  uo6166->data[23] = (Object)closure6166;
  Method *meth_meth_ast_memberNode6166 = addmethod2pos(self, "memberNode", &meth_ast_memberNode6166, 23);
  int argcv_meth_ast_memberNode6166[] = {0};
  meth_meth_ast_memberNode6166->type = alloc_MethodType(1, argcv_meth_ast_memberNode6166);
  meth_meth_ast_memberNode6166->definitionModule = modulename;
  meth_meth_ast_memberNode6166->definitionLine = 1361;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject6167 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6167 = alloc_userobj2(2,4, objclass6167);
  gc_frame_newslot(obj6167);
// OBJECT OUTER DEC outer
  adddatum2(obj6167, self, 0);
  addmethodreal(obj6167,"outer", &reader_ast_outer_6168);
  Object oldself6167 = self;
  struct StackFrameObject *oldstackframe6167 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6167);
  gc_frame_newslot((Object)stackframe);
  self = obj6167;
  Object *oldselfslot6167 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6167 = (*(struct UserObject *)self).data[0], lowerouter6167 = thisouter6167;
  if (inheritingObject6167) {
    struct UserObject *inho6167 = (struct UserObject *)inheritingObject6167;
    while (inho6167->super != GraceDefaultObject) inho6167 = (struct UserObject *)inho6167->super;
    inho6167->super = obj6167;
    self = inheritingObject6167;
    *selfslot = self;
    lowerouter6167 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6167;
  }
// method new
  block_savedest(obj6167);
  Object closure6169 = createclosure(4, "new");
  setclosureframe(closure6169, stackframe);
  addtoclosure(closure6169, var_identifierNode);
  addtoclosure(closure6169, var_nullNode);
  addtoclosure(closure6169, var_memberNode);
  addtoclosure(closure6169, var_baseNode);
  struct UserObject *uo6169 = (struct UserObject*)obj6167;
  uo6169->data[1] = (Object)closure6169;
  Method *meth_meth_ast_new6169 = addmethod2pos(obj6167, "new", &meth_ast_new6169, 1);
  int argcv_meth_ast_new6169[] = {2};
  meth_meth_ast_new6169->type = alloc_MethodType(1, argcv_meth_ast_new6169);
  meth_meth_ast_new6169->definitionModule = modulename;
  meth_meth_ast_new6169->definitionLine = 1361;
  block_savedest(obj6167);
  Object closure6463 = createclosure(4, "new()object");
  setclosureframe(closure6463, stackframe);
  addtoclosure(closure6463, var_identifierNode);
  addtoclosure(closure6463, var_nullNode);
  addtoclosure(closure6463, var_memberNode);
  addtoclosure(closure6463, var_baseNode);
  Method *meth_meth_ast_new6169_object = addmethod2pos(obj6167, "new()object", &meth_ast_new6169_object, 1);
  meth_meth_ast_new6169_object->definitionModule = modulename;
  meth_meth_ast_new6169_object->definitionLine = 1361;
  sourceObject = obj6167;
objclass6167 = obj6167->class;
  objclass6167->definitionModule = modulename;
  objclass6167->definitionLine = 1361;
  (*(struct UserObject *)self).data[0] = lowerouter6167;
  self = oldself6167;
  selfslot = oldselfslot6167;
  stackframe = oldstackframe6167;
// compiled object node returning obj6167 (depth = 3)
  *var_memberNode = obj6167;
  if (obj6167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method genericNode
  block_savedest(self);
  Object closure6464 = createclosure(1, "genericNode");
  setclosureframe(closure6464, stackframe);
  addtoclosure(closure6464, var_genericNode);
  struct UserObject *uo6464 = (struct UserObject*)self;
  uo6464->data[24] = (Object)closure6464;
  Method *meth_meth_ast_genericNode6464 = addmethod2pos(self, "genericNode", &meth_ast_genericNode6464, 24);
  int argcv_meth_ast_genericNode6464[] = {0};
  meth_meth_ast_genericNode6464->type = alloc_MethodType(1, argcv_meth_ast_genericNode6464);
  meth_meth_ast_genericNode6464->definitionModule = modulename;
  meth_meth_ast_genericNode6464->definitionLine = 1432;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject6465 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6465 = alloc_userobj2(2,4, objclass6465);
  gc_frame_newslot(obj6465);
// OBJECT OUTER DEC outer
  adddatum2(obj6465, self, 0);
  addmethodreal(obj6465,"outer", &reader_ast_outer_6466);
  Object oldself6465 = self;
  struct StackFrameObject *oldstackframe6465 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6465);
  gc_frame_newslot((Object)stackframe);
  self = obj6465;
  Object *oldselfslot6465 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6465 = (*(struct UserObject *)self).data[0], lowerouter6465 = thisouter6465;
  if (inheritingObject6465) {
    struct UserObject *inho6465 = (struct UserObject *)inheritingObject6465;
    while (inho6465->super != GraceDefaultObject) inho6465 = (struct UserObject *)inho6465->super;
    inho6465->super = obj6465;
    self = inheritingObject6465;
    *selfslot = self;
    lowerouter6465 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6465;
  }
// method new
  block_savedest(obj6465);
  Object closure6467 = createclosure(3, "new");
  setclosureframe(closure6467, stackframe);
  addtoclosure(closure6467, var_emptySeq);
  addtoclosure(closure6467, var_genericNode);
  addtoclosure(closure6467, var_baseNode);
  struct UserObject *uo6467 = (struct UserObject*)obj6465;
  uo6467->data[1] = (Object)closure6467;
  Method *meth_meth_ast_new6467 = addmethod2pos(obj6465, "new", &meth_ast_new6467, 1);
  int argcv_meth_ast_new6467[] = {2};
  meth_meth_ast_new6467->type = alloc_MethodType(1, argcv_meth_ast_new6467);
  meth_meth_ast_new6467->definitionModule = modulename;
  meth_meth_ast_new6467->definitionLine = 1432;
  block_savedest(obj6465);
  Object closure6668 = createclosure(3, "new()object");
  setclosureframe(closure6668, stackframe);
  addtoclosure(closure6668, var_emptySeq);
  addtoclosure(closure6668, var_genericNode);
  addtoclosure(closure6668, var_baseNode);
  Method *meth_meth_ast_new6467_object = addmethod2pos(obj6465, "new()object", &meth_ast_new6467_object, 1);
  meth_meth_ast_new6467_object->definitionModule = modulename;
  meth_meth_ast_new6467_object->definitionLine = 1432;
  sourceObject = obj6465;
objclass6465 = obj6465->class;
  objclass6465->definitionModule = modulename;
  objclass6465->definitionLine = 1432;
  (*(struct UserObject *)self).data[0] = lowerouter6465;
  self = oldself6465;
  selfslot = oldselfslot6465;
  stackframe = oldstackframe6465;
// compiled object node returning obj6465 (depth = 3)
  *var_genericNode = obj6465;
  if (obj6465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method identifierNode
  block_savedest(self);
  Object closure6669 = createclosure(1, "identifierNode");
  setclosureframe(closure6669, stackframe);
  addtoclosure(closure6669, var_identifierNode);
  struct UserObject *uo6669 = (struct UserObject*)self;
  uo6669->data[25] = (Object)closure6669;
  Method *meth_meth_ast_identifierNode6669 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode6669, 25);
  int argcv_meth_ast_identifierNode6669[] = {0};
  meth_meth_ast_identifierNode6669->type = alloc_MethodType(1, argcv_meth_ast_identifierNode6669);
  meth_meth_ast_identifierNode6669->definitionModule = modulename;
  meth_meth_ast_identifierNode6669->definitionLine = 1486;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject6670 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6670 = alloc_userobj2(2,4, objclass6670);
  gc_frame_newslot(obj6670);
// OBJECT OUTER DEC outer
  adddatum2(obj6670, self, 0);
  addmethodreal(obj6670,"outer", &reader_ast_outer_6671);
  Object oldself6670 = self;
  struct StackFrameObject *oldstackframe6670 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6670);
  gc_frame_newslot((Object)stackframe);
  self = obj6670;
  Object *oldselfslot6670 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6670 = (*(struct UserObject *)self).data[0], lowerouter6670 = thisouter6670;
  if (inheritingObject6670) {
    struct UserObject *inho6670 = (struct UserObject *)inheritingObject6670;
    while (inho6670->super != GraceDefaultObject) inho6670 = (struct UserObject *)inho6670->super;
    inho6670->super = obj6670;
    self = inheritingObject6670;
    *selfslot = self;
    lowerouter6670 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6670;
  }
// method new
  block_savedest(obj6670);
  Object closure6672 = createclosure(2, "new");
  setclosureframe(closure6672, stackframe);
  addtoclosure(closure6672, var_identifierNode);
  addtoclosure(closure6672, var_baseNode);
  struct UserObject *uo6672 = (struct UserObject*)obj6670;
  uo6672->data[1] = (Object)closure6672;
  Method *meth_meth_ast_new6672 = addmethod2pos(obj6670, "new", &meth_ast_new6672, 1);
  int argcv_meth_ast_new6672[] = {2};
  meth_meth_ast_new6672->type = alloc_MethodType(1, argcv_meth_ast_new6672);
  meth_meth_ast_new6672->definitionModule = modulename;
  meth_meth_ast_new6672->definitionLine = 1486;
  block_savedest(obj6670);
  Object closure7033 = createclosure(2, "new()object");
  setclosureframe(closure7033, stackframe);
  addtoclosure(closure7033, var_identifierNode);
  addtoclosure(closure7033, var_baseNode);
  Method *meth_meth_ast_new6672_object = addmethod2pos(obj6670, "new()object", &meth_ast_new6672_object, 1);
  meth_meth_ast_new6672_object->definitionModule = modulename;
  meth_meth_ast_new6672_object->definitionLine = 1486;
  sourceObject = obj6670;
objclass6670 = obj6670->class;
  objclass6670->definitionModule = modulename;
  objclass6670->definitionLine = 1486;
  (*(struct UserObject *)self).data[0] = lowerouter6670;
  self = oldself6670;
  selfslot = oldselfslot6670;
  stackframe = oldstackframe6670;
// compiled object node returning obj6670 (depth = 3)
  *var_identifierNode = obj6670;
  if (obj6670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7034 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7035 == NULL) {
    strlit7035 = alloc_String("Type");
    gc_root(strlit7035);
  }
// compiled string node returning strlit7035 (depth = 3)
  gc_frame_newslot(strlit7035);
// starting to compile identifier node (depth = 3)
  Object bool7036 = alloc_Boolean(0);
// compiled identifier node returning bool7036 (depth = 3)
  gc_frame_newslot(bool7036);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7035;
  params[1] = bool7036;
  partcv[0] = 2;
  Object call7037 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7034);
// compiled call node returning call7037 (depth = 2)
  *var_typeType = call7037;
  if (call7037 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method typeType
  block_savedest(self);
  Object closure7038 = createclosure(1, "typeType");
  setclosureframe(closure7038, stackframe);
  addtoclosure(closure7038, var_typeType);
  struct UserObject *uo7038 = (struct UserObject*)self;
  uo7038->data[26] = (Object)closure7038;
  Method *meth_meth_ast_typeType7038 = addmethod2pos(self, "typeType", &meth_ast_typeType7038, 26);
  int argcv_meth_ast_typeType7038[] = {0};
  meth_meth_ast_typeType7038->type = alloc_MethodType(1, argcv_meth_ast_typeType7038);
  meth_meth_ast_typeType7038->definitionModule = modulename;
  meth_meth_ast_typeType7038->definitionLine = 1595;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe7039 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit7040 == NULL) {
    strlit7040 = alloc_String("Unknown");
    gc_root(strlit7040);
  }
// compiled string node returning strlit7040 (depth = 3)
  gc_frame_newslot(strlit7040);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_typeType (depth = 3)
  gc_frame_newslot(*var_typeType);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_identifierNode (depth = 3)
  params[0] = strlit7040;
  params[1] = *var_typeType;
  partcv[0] = 2;
  Object call7041 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7039);
// compiled call node returning call7041 (depth = 2)
  *var_unknownType = call7041;
  if (call7041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method unknownType
  block_savedest(self);
  Object closure7042 = createclosure(1, "unknownType");
  setclosureframe(closure7042, stackframe);
  addtoclosure(closure7042, var_unknownType);
  struct UserObject *uo7042 = (struct UserObject*)self;
  uo7042->data[27] = (Object)closure7042;
  Method *meth_meth_ast_unknownType7042 = addmethod2pos(self, "unknownType", &meth_ast_unknownType7042, 27);
  int argcv_meth_ast_unknownType7042[] = {0};
  meth_meth_ast_unknownType7042->type = alloc_MethodType(1, argcv_meth_ast_unknownType7042);
  meth_meth_ast_unknownType7042->definitionModule = modulename;
  meth_meth_ast_unknownType7042->definitionLine = 1595;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method octetsNode
  block_savedest(self);
  Object closure7043 = createclosure(1, "octetsNode");
  setclosureframe(closure7043, stackframe);
  addtoclosure(closure7043, var_octetsNode);
  struct UserObject *uo7043 = (struct UserObject*)self;
  uo7043->data[28] = (Object)closure7043;
  Method *meth_meth_ast_octetsNode7043 = addmethod2pos(self, "octetsNode", &meth_ast_octetsNode7043, 28);
  int argcv_meth_ast_octetsNode7043[] = {0};
  meth_meth_ast_octetsNode7043->type = alloc_MethodType(1, argcv_meth_ast_octetsNode7043);
  meth_meth_ast_octetsNode7043->definitionModule = modulename;
  meth_meth_ast_octetsNode7043->definitionLine = 1603;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7044 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7044 = alloc_userobj2(2,4, objclass7044);
  gc_frame_newslot(obj7044);
// OBJECT OUTER DEC outer
  adddatum2(obj7044, self, 0);
  addmethodreal(obj7044,"outer", &reader_ast_outer_7045);
  Object oldself7044 = self;
  struct StackFrameObject *oldstackframe7044 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7044);
  gc_frame_newslot((Object)stackframe);
  self = obj7044;
  Object *oldselfslot7044 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7044 = (*(struct UserObject *)self).data[0], lowerouter7044 = thisouter7044;
  if (inheritingObject7044) {
    struct UserObject *inho7044 = (struct UserObject *)inheritingObject7044;
    while (inho7044->super != GraceDefaultObject) inho7044 = (struct UserObject *)inho7044->super;
    inho7044->super = obj7044;
    self = inheritingObject7044;
    *selfslot = self;
    lowerouter7044 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7044;
  }
// method new
  block_savedest(obj7044);
  Object closure7046 = createclosure(2, "new");
  setclosureframe(closure7046, stackframe);
  addtoclosure(closure7046, var_octetsNode);
  addtoclosure(closure7046, var_baseNode);
  struct UserObject *uo7046 = (struct UserObject*)obj7044;
  uo7046->data[1] = (Object)closure7046;
  Method *meth_meth_ast_new7046 = addmethod2pos(obj7044, "new", &meth_ast_new7046, 1);
  int argcv_meth_ast_new7046[] = {1};
  meth_meth_ast_new7046->type = alloc_MethodType(1, argcv_meth_ast_new7046);
  meth_meth_ast_new7046->definitionModule = modulename;
  meth_meth_ast_new7046->definitionLine = 1603;
  block_savedest(obj7044);
  Object closure7093 = createclosure(2, "new()object");
  setclosureframe(closure7093, stackframe);
  addtoclosure(closure7093, var_octetsNode);
  addtoclosure(closure7093, var_baseNode);
  Method *meth_meth_ast_new7046_object = addmethod2pos(obj7044, "new()object", &meth_ast_new7046_object, 1);
  meth_meth_ast_new7046_object->definitionModule = modulename;
  meth_meth_ast_new7046_object->definitionLine = 1603;
  sourceObject = obj7044;
objclass7044 = obj7044->class;
  objclass7044->definitionModule = modulename;
  objclass7044->definitionLine = 1603;
  (*(struct UserObject *)self).data[0] = lowerouter7044;
  self = oldself7044;
  selfslot = oldselfslot7044;
  stackframe = oldstackframe7044;
// compiled object node returning obj7044 (depth = 3)
  *var_octetsNode = obj7044;
  if (obj7044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method stringNode
  block_savedest(self);
  Object closure7094 = createclosure(1, "stringNode");
  setclosureframe(closure7094, stackframe);
  addtoclosure(closure7094, var_stringNode);
  struct UserObject *uo7094 = (struct UserObject*)self;
  uo7094->data[29] = (Object)closure7094;
  Method *meth_meth_ast_stringNode7094 = addmethod2pos(self, "stringNode", &meth_ast_stringNode7094, 29);
  int argcv_meth_ast_stringNode7094[] = {0};
  meth_meth_ast_stringNode7094->type = alloc_MethodType(1, argcv_meth_ast_stringNode7094);
  meth_meth_ast_stringNode7094->definitionModule = modulename;
  meth_meth_ast_stringNode7094->definitionLine = 1625;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7095 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7095 = alloc_userobj2(2,4, objclass7095);
  gc_frame_newslot(obj7095);
// OBJECT OUTER DEC outer
  adddatum2(obj7095, self, 0);
  addmethodreal(obj7095,"outer", &reader_ast_outer_7096);
  Object oldself7095 = self;
  struct StackFrameObject *oldstackframe7095 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7095);
  gc_frame_newslot((Object)stackframe);
  self = obj7095;
  Object *oldselfslot7095 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7095 = (*(struct UserObject *)self).data[0], lowerouter7095 = thisouter7095;
  if (inheritingObject7095) {
    struct UserObject *inho7095 = (struct UserObject *)inheritingObject7095;
    while (inho7095->super != GraceDefaultObject) inho7095 = (struct UserObject *)inho7095->super;
    inho7095->super = obj7095;
    self = inheritingObject7095;
    *selfslot = self;
    lowerouter7095 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7095;
  }
// method new
  block_savedest(obj7095);
  Object closure7097 = createclosure(2, "new");
  setclosureframe(closure7097, stackframe);
  addtoclosure(closure7097, var_stringNode);
  addtoclosure(closure7097, var_baseNode);
  struct UserObject *uo7097 = (struct UserObject*)obj7095;
  uo7097->data[1] = (Object)closure7097;
  Method *meth_meth_ast_new7097 = addmethod2pos(obj7095, "new", &meth_ast_new7097, 1);
  int argcv_meth_ast_new7097[] = {1};
  meth_meth_ast_new7097->type = alloc_MethodType(1, argcv_meth_ast_new7097);
  meth_meth_ast_new7097->definitionModule = modulename;
  meth_meth_ast_new7097->definitionLine = 1625;
  block_savedest(obj7095);
  Object closure7199 = createclosure(2, "new()object");
  setclosureframe(closure7199, stackframe);
  addtoclosure(closure7199, var_stringNode);
  addtoclosure(closure7199, var_baseNode);
  Method *meth_meth_ast_new7097_object = addmethod2pos(obj7095, "new()object", &meth_ast_new7097_object, 1);
  meth_meth_ast_new7097_object->definitionModule = modulename;
  meth_meth_ast_new7097_object->definitionLine = 1625;
  sourceObject = obj7095;
objclass7095 = obj7095->class;
  objclass7095->definitionModule = modulename;
  objclass7095->definitionLine = 1625;
  (*(struct UserObject *)self).data[0] = lowerouter7095;
  self = oldself7095;
  selfslot = oldselfslot7095;
  stackframe = oldstackframe7095;
// compiled object node returning obj7095 (depth = 3)
  *var_stringNode = obj7095;
  if (obj7095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method numNode
  block_savedest(self);
  Object closure7200 = createclosure(1, "numNode");
  setclosureframe(closure7200, stackframe);
  addtoclosure(closure7200, var_numNode);
  struct UserObject *uo7200 = (struct UserObject*)self;
  uo7200->data[30] = (Object)closure7200;
  Method *meth_meth_ast_numNode7200 = addmethod2pos(self, "numNode", &meth_ast_numNode7200, 30);
  int argcv_meth_ast_numNode7200[] = {0};
  meth_meth_ast_numNode7200->type = alloc_MethodType(1, argcv_meth_ast_numNode7200);
  meth_meth_ast_numNode7200->definitionModule = modulename;
  meth_meth_ast_numNode7200->definitionLine = 1663;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7201 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7201 = alloc_userobj2(2,4, objclass7201);
  gc_frame_newslot(obj7201);
// OBJECT OUTER DEC outer
  adddatum2(obj7201, self, 0);
  addmethodreal(obj7201,"outer", &reader_ast_outer_7202);
  Object oldself7201 = self;
  struct StackFrameObject *oldstackframe7201 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7201);
  gc_frame_newslot((Object)stackframe);
  self = obj7201;
  Object *oldselfslot7201 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7201 = (*(struct UserObject *)self).data[0], lowerouter7201 = thisouter7201;
  if (inheritingObject7201) {
    struct UserObject *inho7201 = (struct UserObject *)inheritingObject7201;
    while (inho7201->super != GraceDefaultObject) inho7201 = (struct UserObject *)inho7201->super;
    inho7201->super = obj7201;
    self = inheritingObject7201;
    *selfslot = self;
    lowerouter7201 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7201;
  }
// method new
  block_savedest(obj7201);
  Object closure7203 = createclosure(2, "new");
  setclosureframe(closure7203, stackframe);
  addtoclosure(closure7203, var_numNode);
  addtoclosure(closure7203, var_baseNode);
  struct UserObject *uo7203 = (struct UserObject*)obj7201;
  uo7203->data[1] = (Object)closure7203;
  Method *meth_meth_ast_new7203 = addmethod2pos(obj7201, "new", &meth_ast_new7203, 1);
  int argcv_meth_ast_new7203[] = {1};
  meth_meth_ast_new7203->type = alloc_MethodType(1, argcv_meth_ast_new7203);
  meth_meth_ast_new7203->definitionModule = modulename;
  meth_meth_ast_new7203->definitionLine = 1663;
  block_savedest(obj7201);
  Object closure7263 = createclosure(2, "new()object");
  setclosureframe(closure7263, stackframe);
  addtoclosure(closure7263, var_numNode);
  addtoclosure(closure7263, var_baseNode);
  Method *meth_meth_ast_new7203_object = addmethod2pos(obj7201, "new()object", &meth_ast_new7203_object, 1);
  meth_meth_ast_new7203_object->definitionModule = modulename;
  meth_meth_ast_new7203_object->definitionLine = 1663;
  sourceObject = obj7201;
objclass7201 = obj7201->class;
  objclass7201->definitionModule = modulename;
  objclass7201->definitionLine = 1663;
  (*(struct UserObject *)self).data[0] = lowerouter7201;
  self = oldself7201;
  selfslot = oldselfslot7201;
  stackframe = oldstackframe7201;
// compiled object node returning obj7201 (depth = 3)
  *var_numNode = obj7201;
  if (obj7201 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method opNode
  block_savedest(self);
  Object closure7264 = createclosure(1, "opNode");
  setclosureframe(closure7264, stackframe);
  addtoclosure(closure7264, var_opNode);
  struct UserObject *uo7264 = (struct UserObject*)self;
  uo7264->data[31] = (Object)closure7264;
  Method *meth_meth_ast_opNode7264 = addmethod2pos(self, "opNode", &meth_ast_opNode7264, 31);
  int argcv_meth_ast_opNode7264[] = {0};
  meth_meth_ast_opNode7264->type = alloc_MethodType(1, argcv_meth_ast_opNode7264);
  meth_meth_ast_opNode7264->definitionModule = modulename;
  meth_meth_ast_opNode7264->definitionLine = 1686;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7265 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7265 = alloc_userobj2(2,4, objclass7265);
  gc_frame_newslot(obj7265);
// OBJECT OUTER DEC outer
  adddatum2(obj7265, self, 0);
  addmethodreal(obj7265,"outer", &reader_ast_outer_7266);
  Object oldself7265 = self;
  struct StackFrameObject *oldstackframe7265 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7265);
  gc_frame_newslot((Object)stackframe);
  self = obj7265;
  Object *oldselfslot7265 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7265 = (*(struct UserObject *)self).data[0], lowerouter7265 = thisouter7265;
  if (inheritingObject7265) {
    struct UserObject *inho7265 = (struct UserObject *)inheritingObject7265;
    while (inho7265->super != GraceDefaultObject) inho7265 = (struct UserObject *)inho7265->super;
    inho7265->super = obj7265;
    self = inheritingObject7265;
    *selfslot = self;
    lowerouter7265 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7265;
  }
// method new
  block_savedest(obj7265);
  Object closure7267 = createclosure(4, "new");
  setclosureframe(closure7267, stackframe);
  addtoclosure(closure7267, var_identifierNode);
  addtoclosure(closure7267, var_nullNode);
  addtoclosure(closure7267, var_opNode);
  addtoclosure(closure7267, var_baseNode);
  struct UserObject *uo7267 = (struct UserObject*)obj7265;
  uo7267->data[1] = (Object)closure7267;
  Method *meth_meth_ast_new7267 = addmethod2pos(obj7265, "new", &meth_ast_new7267, 1);
  int argcv_meth_ast_new7267[] = {3};
  meth_meth_ast_new7267->type = alloc_MethodType(1, argcv_meth_ast_new7267);
  meth_meth_ast_new7267->definitionModule = modulename;
  meth_meth_ast_new7267->definitionLine = 1686;
  block_savedest(obj7265);
  Object closure7528 = createclosure(4, "new()object");
  setclosureframe(closure7528, stackframe);
  addtoclosure(closure7528, var_identifierNode);
  addtoclosure(closure7528, var_nullNode);
  addtoclosure(closure7528, var_opNode);
  addtoclosure(closure7528, var_baseNode);
  Method *meth_meth_ast_new7267_object = addmethod2pos(obj7265, "new()object", &meth_ast_new7267_object, 1);
  meth_meth_ast_new7267_object->definitionModule = modulename;
  meth_meth_ast_new7267_object->definitionLine = 1686;
  sourceObject = obj7265;
objclass7265 = obj7265->class;
  objclass7265->definitionModule = modulename;
  objclass7265->definitionLine = 1686;
  (*(struct UserObject *)self).data[0] = lowerouter7265;
  self = oldself7265;
  selfslot = oldselfslot7265;
  stackframe = oldstackframe7265;
// compiled object node returning obj7265 (depth = 3)
  *var_opNode = obj7265;
  if (obj7265 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method indexNode
  block_savedest(self);
  Object closure7529 = createclosure(1, "indexNode");
  setclosureframe(closure7529, stackframe);
  addtoclosure(closure7529, var_indexNode);
  struct UserObject *uo7529 = (struct UserObject*)self;
  uo7529->data[32] = (Object)closure7529;
  Method *meth_meth_ast_indexNode7529 = addmethod2pos(self, "indexNode", &meth_ast_indexNode7529, 32);
  int argcv_meth_ast_indexNode7529[] = {0};
  meth_meth_ast_indexNode7529->type = alloc_MethodType(1, argcv_meth_ast_indexNode7529);
  meth_meth_ast_indexNode7529->definitionModule = modulename;
  meth_meth_ast_indexNode7529->definitionLine = 1750;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7530 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7530 = alloc_userobj2(2,4, objclass7530);
  gc_frame_newslot(obj7530);
// OBJECT OUTER DEC outer
  adddatum2(obj7530, self, 0);
  addmethodreal(obj7530,"outer", &reader_ast_outer_7531);
  Object oldself7530 = self;
  struct StackFrameObject *oldstackframe7530 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7530);
  gc_frame_newslot((Object)stackframe);
  self = obj7530;
  Object *oldselfslot7530 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7530 = (*(struct UserObject *)self).data[0], lowerouter7530 = thisouter7530;
  if (inheritingObject7530) {
    struct UserObject *inho7530 = (struct UserObject *)inheritingObject7530;
    while (inho7530->super != GraceDefaultObject) inho7530 = (struct UserObject *)inho7530->super;
    inho7530->super = obj7530;
    self = inheritingObject7530;
    *selfslot = self;
    lowerouter7530 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7530;
  }
// method new
  block_savedest(obj7530);
  Object closure7532 = createclosure(3, "new");
  setclosureframe(closure7532, stackframe);
  addtoclosure(closure7532, var_nullNode);
  addtoclosure(closure7532, var_indexNode);
  addtoclosure(closure7532, var_baseNode);
  struct UserObject *uo7532 = (struct UserObject*)obj7530;
  uo7532->data[1] = (Object)closure7532;
  Method *meth_meth_ast_new7532 = addmethod2pos(obj7530, "new", &meth_ast_new7532, 1);
  int argcv_meth_ast_new7532[] = {2};
  meth_meth_ast_new7532->type = alloc_MethodType(1, argcv_meth_ast_new7532);
  meth_meth_ast_new7532->definitionModule = modulename;
  meth_meth_ast_new7532->definitionLine = 1750;
  block_savedest(obj7530);
  Object closure7681 = createclosure(3, "new()object");
  setclosureframe(closure7681, stackframe);
  addtoclosure(closure7681, var_nullNode);
  addtoclosure(closure7681, var_indexNode);
  addtoclosure(closure7681, var_baseNode);
  Method *meth_meth_ast_new7532_object = addmethod2pos(obj7530, "new()object", &meth_ast_new7532_object, 1);
  meth_meth_ast_new7532_object->definitionModule = modulename;
  meth_meth_ast_new7532_object->definitionLine = 1750;
  sourceObject = obj7530;
objclass7530 = obj7530->class;
  objclass7530->definitionModule = modulename;
  objclass7530->definitionLine = 1750;
  (*(struct UserObject *)self).data[0] = lowerouter7530;
  self = oldself7530;
  selfslot = oldselfslot7530;
  stackframe = oldstackframe7530;
// compiled object node returning obj7530 (depth = 3)
  *var_indexNode = obj7530;
  if (obj7530 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method bindNode
  block_savedest(self);
  Object closure7682 = createclosure(1, "bindNode");
  setclosureframe(closure7682, stackframe);
  addtoclosure(closure7682, var_bindNode);
  struct UserObject *uo7682 = (struct UserObject*)self;
  uo7682->data[33] = (Object)closure7682;
  Method *meth_meth_ast_bindNode7682 = addmethod2pos(self, "bindNode", &meth_ast_bindNode7682, 33);
  int argcv_meth_ast_bindNode7682[] = {0};
  meth_meth_ast_bindNode7682->type = alloc_MethodType(1, argcv_meth_ast_bindNode7682);
  meth_meth_ast_bindNode7682->definitionModule = modulename;
  meth_meth_ast_bindNode7682->definitionLine = 1794;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7683 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7683 = alloc_userobj2(2,4, objclass7683);
  gc_frame_newslot(obj7683);
// OBJECT OUTER DEC outer
  adddatum2(obj7683, self, 0);
  addmethodreal(obj7683,"outer", &reader_ast_outer_7684);
  Object oldself7683 = self;
  struct StackFrameObject *oldstackframe7683 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7683);
  gc_frame_newslot((Object)stackframe);
  self = obj7683;
  Object *oldselfslot7683 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7683 = (*(struct UserObject *)self).data[0], lowerouter7683 = thisouter7683;
  if (inheritingObject7683) {
    struct UserObject *inho7683 = (struct UserObject *)inheritingObject7683;
    while (inho7683->super != GraceDefaultObject) inho7683 = (struct UserObject *)inho7683->super;
    inho7683->super = obj7683;
    self = inheritingObject7683;
    *selfslot = self;
    lowerouter7683 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7683;
  }
// method new
  block_savedest(obj7683);
  Object closure7685 = createclosure(2, "new");
  setclosureframe(closure7685, stackframe);
  addtoclosure(closure7685, var_bindNode);
  addtoclosure(closure7685, var_baseNode);
  struct UserObject *uo7685 = (struct UserObject*)obj7683;
  uo7685->data[1] = (Object)closure7685;
  Method *meth_meth_ast_new7685 = addmethod2pos(obj7683, "new", &meth_ast_new7685, 1);
  int argcv_meth_ast_new7685[] = {2};
  meth_meth_ast_new7685->type = alloc_MethodType(1, argcv_meth_ast_new7685);
  meth_meth_ast_new7685->definitionModule = modulename;
  meth_meth_ast_new7685->definitionLine = 1794;
  block_savedest(obj7683);
  Object closure7847 = createclosure(2, "new()object");
  setclosureframe(closure7847, stackframe);
  addtoclosure(closure7847, var_bindNode);
  addtoclosure(closure7847, var_baseNode);
  Method *meth_meth_ast_new7685_object = addmethod2pos(obj7683, "new()object", &meth_ast_new7685_object, 1);
  meth_meth_ast_new7685_object->definitionModule = modulename;
  meth_meth_ast_new7685_object->definitionLine = 1794;
  sourceObject = obj7683;
objclass7683 = obj7683->class;
  objclass7683->definitionModule = modulename;
  objclass7683->definitionLine = 1794;
  (*(struct UserObject *)self).data[0] = lowerouter7683;
  self = oldself7683;
  selfslot = oldselfslot7683;
  stackframe = oldstackframe7683;
// compiled object node returning obj7683 (depth = 3)
  *var_bindNode = obj7683;
  if (obj7683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method defDecNode
  block_savedest(self);
  Object closure7848 = createclosure(1, "defDecNode");
  setclosureframe(closure7848, stackframe);
  addtoclosure(closure7848, var_defDecNode);
  struct UserObject *uo7848 = (struct UserObject*)self;
  uo7848->data[34] = (Object)closure7848;
  Method *meth_meth_ast_defDecNode7848 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode7848, 34);
  int argcv_meth_ast_defDecNode7848[] = {0};
  meth_meth_ast_defDecNode7848->type = alloc_MethodType(1, argcv_meth_ast_defDecNode7848);
  meth_meth_ast_defDecNode7848->definitionModule = modulename;
  meth_meth_ast_defDecNode7848->definitionLine = 1840;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject7849 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7849 = alloc_userobj2(2,4, objclass7849);
  gc_frame_newslot(obj7849);
// OBJECT OUTER DEC outer
  adddatum2(obj7849, self, 0);
  addmethodreal(obj7849,"outer", &reader_ast_outer_7850);
  Object oldself7849 = self;
  struct StackFrameObject *oldstackframe7849 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7849);
  gc_frame_newslot((Object)stackframe);
  self = obj7849;
  Object *oldselfslot7849 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7849 = (*(struct UserObject *)self).data[0], lowerouter7849 = thisouter7849;
  if (inheritingObject7849) {
    struct UserObject *inho7849 = (struct UserObject *)inheritingObject7849;
    while (inho7849->super != GraceDefaultObject) inho7849 = (struct UserObject *)inho7849->super;
    inho7849->super = obj7849;
    self = inheritingObject7849;
    *selfslot = self;
    lowerouter7849 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7849;
  }
// method new
  block_savedest(obj7849);
  Object closure7851 = createclosure(2, "new");
  setclosureframe(closure7851, stackframe);
  addtoclosure(closure7851, var_defDecNode);
  addtoclosure(closure7851, var_baseNode);
  struct UserObject *uo7851 = (struct UserObject*)obj7849;
  uo7851->data[1] = (Object)closure7851;
  Method *meth_meth_ast_new7851 = addmethod2pos(obj7849, "new", &meth_ast_new7851, 1);
  int argcv_meth_ast_new7851[] = {3};
  meth_meth_ast_new7851->type = alloc_MethodType(1, argcv_meth_ast_new7851);
  meth_meth_ast_new7851->definitionModule = modulename;
  meth_meth_ast_new7851->definitionLine = 1840;
  block_savedest(obj7849);
  Object closure8251 = createclosure(2, "new()object");
  setclosureframe(closure8251, stackframe);
  addtoclosure(closure8251, var_defDecNode);
  addtoclosure(closure8251, var_baseNode);
  Method *meth_meth_ast_new7851_object = addmethod2pos(obj7849, "new()object", &meth_ast_new7851_object, 1);
  meth_meth_ast_new7851_object->definitionModule = modulename;
  meth_meth_ast_new7851_object->definitionLine = 1840;
  sourceObject = obj7849;
objclass7849 = obj7849->class;
  objclass7849->definitionModule = modulename;
  objclass7849->definitionLine = 1840;
  (*(struct UserObject *)self).data[0] = lowerouter7849;
  self = oldself7849;
  selfslot = oldselfslot7849;
  stackframe = oldstackframe7849;
// compiled object node returning obj7849 (depth = 3)
  *var_defDecNode = obj7849;
  if (obj7849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method varDecNode
  block_savedest(self);
  Object closure8252 = createclosure(1, "varDecNode");
  setclosureframe(closure8252, stackframe);
  addtoclosure(closure8252, var_varDecNode);
  struct UserObject *uo8252 = (struct UserObject*)self;
  uo8252->data[35] = (Object)closure8252;
  Method *meth_meth_ast_varDecNode8252 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode8252, 35);
  int argcv_meth_ast_varDecNode8252[] = {0};
  meth_meth_ast_varDecNode8252->type = alloc_MethodType(1, argcv_meth_ast_varDecNode8252);
  meth_meth_ast_varDecNode8252->definitionModule = modulename;
  meth_meth_ast_varDecNode8252->definitionLine = 1947;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject8253 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8253 = alloc_userobj2(2,4, objclass8253);
  gc_frame_newslot(obj8253);
// OBJECT OUTER DEC outer
  adddatum2(obj8253, self, 0);
  addmethodreal(obj8253,"outer", &reader_ast_outer_8254);
  Object oldself8253 = self;
  struct StackFrameObject *oldstackframe8253 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8253);
  gc_frame_newslot((Object)stackframe);
  self = obj8253;
  Object *oldselfslot8253 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8253 = (*(struct UserObject *)self).data[0], lowerouter8253 = thisouter8253;
  if (inheritingObject8253) {
    struct UserObject *inho8253 = (struct UserObject *)inheritingObject8253;
    while (inho8253->super != GraceDefaultObject) inho8253 = (struct UserObject *)inho8253->super;
    inho8253->super = obj8253;
    self = inheritingObject8253;
    *selfslot = self;
    lowerouter8253 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8253;
  }
// method new
  block_savedest(obj8253);
  Object closure8255 = createclosure(2, "new");
  setclosureframe(closure8255, stackframe);
  addtoclosure(closure8255, var_varDecNode);
  addtoclosure(closure8255, var_baseNode);
  struct UserObject *uo8255 = (struct UserObject*)obj8253;
  uo8255->data[1] = (Object)closure8255;
  Method *meth_meth_ast_new8255 = addmethod2pos(obj8253, "new", &meth_ast_new8255, 1);
  int argcv_meth_ast_new8255[] = {3};
  meth_meth_ast_new8255->type = alloc_MethodType(1, argcv_meth_ast_new8255);
  meth_meth_ast_new8255->definitionModule = modulename;
  meth_meth_ast_new8255->definitionLine = 1947;
  block_savedest(obj8253);
  Object closure8688 = createclosure(2, "new()object");
  setclosureframe(closure8688, stackframe);
  addtoclosure(closure8688, var_varDecNode);
  addtoclosure(closure8688, var_baseNode);
  Method *meth_meth_ast_new8255_object = addmethod2pos(obj8253, "new()object", &meth_ast_new8255_object, 1);
  meth_meth_ast_new8255_object->definitionModule = modulename;
  meth_meth_ast_new8255_object->definitionLine = 1947;
  sourceObject = obj8253;
objclass8253 = obj8253->class;
  objclass8253->definitionModule = modulename;
  objclass8253->definitionLine = 1947;
  (*(struct UserObject *)self).data[0] = lowerouter8253;
  self = oldself8253;
  selfslot = oldselfslot8253;
  stackframe = oldstackframe8253;
// compiled object node returning obj8253 (depth = 3)
  *var_varDecNode = obj8253;
  if (obj8253 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method importNode
  block_savedest(self);
  Object closure8689 = createclosure(1, "importNode");
  setclosureframe(closure8689, stackframe);
  addtoclosure(closure8689, var_importNode);
  struct UserObject *uo8689 = (struct UserObject*)self;
  uo8689->data[36] = (Object)closure8689;
  Method *meth_meth_ast_importNode8689 = addmethod2pos(self, "importNode", &meth_ast_importNode8689, 36);
  int argcv_meth_ast_importNode8689[] = {0};
  meth_meth_ast_importNode8689->type = alloc_MethodType(1, argcv_meth_ast_importNode8689);
  meth_meth_ast_importNode8689->definitionModule = modulename;
  meth_meth_ast_importNode8689->definitionLine = 2042;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject8690 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8690 = alloc_userobj2(2,4, objclass8690);
  gc_frame_newslot(obj8690);
// OBJECT OUTER DEC outer
  adddatum2(obj8690, self, 0);
  addmethodreal(obj8690,"outer", &reader_ast_outer_8691);
  Object oldself8690 = self;
  struct StackFrameObject *oldstackframe8690 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8690);
  gc_frame_newslot((Object)stackframe);
  self = obj8690;
  Object *oldselfslot8690 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8690 = (*(struct UserObject *)self).data[0], lowerouter8690 = thisouter8690;
  if (inheritingObject8690) {
    struct UserObject *inho8690 = (struct UserObject *)inheritingObject8690;
    while (inho8690->super != GraceDefaultObject) inho8690 = (struct UserObject *)inho8690->super;
    inho8690->super = obj8690;
    self = inheritingObject8690;
    *selfslot = self;
    lowerouter8690 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8690;
  }
// method new
  block_savedest(obj8690);
  Object closure8692 = createclosure(3, "new");
  setclosureframe(closure8692, stackframe);
  addtoclosure(closure8692, var_nullNode);
  addtoclosure(closure8692, var_importNode);
  addtoclosure(closure8692, var_baseNode);
  struct UserObject *uo8692 = (struct UserObject*)obj8690;
  uo8692->data[1] = (Object)closure8692;
  Method *meth_meth_ast_new8692 = addmethod2pos(obj8690, "new", &meth_ast_new8692, 1);
  int argcv_meth_ast_new8692[] = {3};
  meth_meth_ast_new8692->type = alloc_MethodType(1, argcv_meth_ast_new8692);
  meth_meth_ast_new8692->definitionModule = modulename;
  meth_meth_ast_new8692->definitionLine = 2042;
  block_savedest(obj8690);
  Object closure8928 = createclosure(3, "new()object");
  setclosureframe(closure8928, stackframe);
  addtoclosure(closure8928, var_nullNode);
  addtoclosure(closure8928, var_importNode);
  addtoclosure(closure8928, var_baseNode);
  Method *meth_meth_ast_new8692_object = addmethod2pos(obj8690, "new()object", &meth_ast_new8692_object, 1);
  meth_meth_ast_new8692_object->definitionModule = modulename;
  meth_meth_ast_new8692_object->definitionLine = 2042;
  sourceObject = obj8690;
objclass8690 = obj8690->class;
  objclass8690->definitionModule = modulename;
  objclass8690->definitionLine = 2042;
  (*(struct UserObject *)self).data[0] = lowerouter8690;
  self = oldself8690;
  selfslot = oldselfslot8690;
  stackframe = oldstackframe8690;
// compiled object node returning obj8690 (depth = 3)
  *var_importNode = obj8690;
  if (obj8690 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2099
  setline(2099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method dialectNode
  block_savedest(self);
  Object closure8929 = createclosure(1, "dialectNode");
  setclosureframe(closure8929, stackframe);
  addtoclosure(closure8929, var_dialectNode);
  struct UserObject *uo8929 = (struct UserObject*)self;
  uo8929->data[37] = (Object)closure8929;
  Method *meth_meth_ast_dialectNode8929 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode8929, 37);
  int argcv_meth_ast_dialectNode8929[] = {0};
  meth_meth_ast_dialectNode8929->type = alloc_MethodType(1, argcv_meth_ast_dialectNode8929);
  meth_meth_ast_dialectNode8929->definitionModule = modulename;
  meth_meth_ast_dialectNode8929->definitionLine = 2099;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject8930 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8930 = alloc_userobj2(2,4, objclass8930);
  gc_frame_newslot(obj8930);
// OBJECT OUTER DEC outer
  adddatum2(obj8930, self, 0);
  addmethodreal(obj8930,"outer", &reader_ast_outer_8931);
  Object oldself8930 = self;
  struct StackFrameObject *oldstackframe8930 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8930);
  gc_frame_newslot((Object)stackframe);
  self = obj8930;
  Object *oldselfslot8930 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8930 = (*(struct UserObject *)self).data[0], lowerouter8930 = thisouter8930;
  if (inheritingObject8930) {
    struct UserObject *inho8930 = (struct UserObject *)inheritingObject8930;
    while (inho8930->super != GraceDefaultObject) inho8930 = (struct UserObject *)inho8930->super;
    inho8930->super = obj8930;
    self = inheritingObject8930;
    *selfslot = self;
    lowerouter8930 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8930;
  }
// method new
  block_savedest(obj8930);
  Object closure8932 = createclosure(2, "new");
  setclosureframe(closure8932, stackframe);
  addtoclosure(closure8932, var_dialectNode);
  addtoclosure(closure8932, var_baseNode);
  struct UserObject *uo8932 = (struct UserObject*)obj8930;
  uo8932->data[1] = (Object)closure8932;
  Method *meth_meth_ast_new8932 = addmethod2pos(obj8930, "new", &meth_ast_new8932, 1);
  int argcv_meth_ast_new8932[] = {1};
  meth_meth_ast_new8932->type = alloc_MethodType(1, argcv_meth_ast_new8932);
  meth_meth_ast_new8932->definitionModule = modulename;
  meth_meth_ast_new8932->definitionLine = 2099;
  block_savedest(obj8930);
  Object closure9010 = createclosure(2, "new()object");
  setclosureframe(closure9010, stackframe);
  addtoclosure(closure9010, var_dialectNode);
  addtoclosure(closure9010, var_baseNode);
  Method *meth_meth_ast_new8932_object = addmethod2pos(obj8930, "new()object", &meth_ast_new8932_object, 1);
  meth_meth_ast_new8932_object->definitionModule = modulename;
  meth_meth_ast_new8932_object->definitionLine = 2099;
  sourceObject = obj8930;
objclass8930 = obj8930->class;
  objclass8930->definitionModule = modulename;
  objclass8930->definitionLine = 2099;
  (*(struct UserObject *)self).data[0] = lowerouter8930;
  self = oldself8930;
  selfslot = oldselfslot8930;
  stackframe = oldstackframe8930;
// compiled object node returning obj8930 (depth = 3)
  *var_dialectNode = obj8930;
  if (obj8930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method returnNode
  block_savedest(self);
  Object closure9011 = createclosure(1, "returnNode");
  setclosureframe(closure9011, stackframe);
  addtoclosure(closure9011, var_returnNode);
  struct UserObject *uo9011 = (struct UserObject*)self;
  uo9011->data[38] = (Object)closure9011;
  Method *meth_meth_ast_returnNode9011 = addmethod2pos(self, "returnNode", &meth_ast_returnNode9011, 38);
  int argcv_meth_ast_returnNode9011[] = {0};
  meth_meth_ast_returnNode9011->type = alloc_MethodType(1, argcv_meth_ast_returnNode9011);
  meth_meth_ast_returnNode9011->definitionModule = modulename;
  meth_meth_ast_returnNode9011->definitionLine = 2128;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9012 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9012 = alloc_userobj2(2,4, objclass9012);
  gc_frame_newslot(obj9012);
// OBJECT OUTER DEC outer
  adddatum2(obj9012, self, 0);
  addmethodreal(obj9012,"outer", &reader_ast_outer_9013);
  Object oldself9012 = self;
  struct StackFrameObject *oldstackframe9012 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9012);
  gc_frame_newslot((Object)stackframe);
  self = obj9012;
  Object *oldselfslot9012 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9012 = (*(struct UserObject *)self).data[0], lowerouter9012 = thisouter9012;
  if (inheritingObject9012) {
    struct UserObject *inho9012 = (struct UserObject *)inheritingObject9012;
    while (inho9012->super != GraceDefaultObject) inho9012 = (struct UserObject *)inho9012->super;
    inho9012->super = obj9012;
    self = inheritingObject9012;
    *selfslot = self;
    lowerouter9012 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9012;
  }
// method new
  block_savedest(obj9012);
  Object closure9014 = createclosure(3, "new");
  setclosureframe(closure9014, stackframe);
  addtoclosure(closure9014, var_nullNode);
  addtoclosure(closure9014, var_returnNode);
  addtoclosure(closure9014, var_baseNode);
  struct UserObject *uo9014 = (struct UserObject*)obj9012;
  uo9014->data[1] = (Object)closure9014;
  Method *meth_meth_ast_new9014 = addmethod2pos(obj9012, "new", &meth_ast_new9014, 1);
  int argcv_meth_ast_new9014[] = {1};
  meth_meth_ast_new9014->type = alloc_MethodType(1, argcv_meth_ast_new9014);
  meth_meth_ast_new9014->definitionModule = modulename;
  meth_meth_ast_new9014->definitionLine = 2128;
  block_savedest(obj9012);
  Object closure9093 = createclosure(3, "new()object");
  setclosureframe(closure9093, stackframe);
  addtoclosure(closure9093, var_nullNode);
  addtoclosure(closure9093, var_returnNode);
  addtoclosure(closure9093, var_baseNode);
  Method *meth_meth_ast_new9014_object = addmethod2pos(obj9012, "new()object", &meth_ast_new9014_object, 1);
  meth_meth_ast_new9014_object->definitionModule = modulename;
  meth_meth_ast_new9014_object->definitionLine = 2128;
  sourceObject = obj9012;
objclass9012 = obj9012->class;
  objclass9012->definitionModule = modulename;
  objclass9012->definitionLine = 2128;
  (*(struct UserObject *)self).data[0] = lowerouter9012;
  self = oldself9012;
  selfslot = oldselfslot9012;
  stackframe = oldstackframe9012;
// compiled object node returning obj9012 (depth = 3)
  *var_returnNode = obj9012;
  if (obj9012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method inheritsNode
  block_savedest(self);
  Object closure9094 = createclosure(1, "inheritsNode");
  setclosureframe(closure9094, stackframe);
  addtoclosure(closure9094, var_inheritsNode);
  struct UserObject *uo9094 = (struct UserObject*)self;
  uo9094->data[39] = (Object)closure9094;
  Method *meth_meth_ast_inheritsNode9094 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode9094, 39);
  int argcv_meth_ast_inheritsNode9094[] = {0};
  meth_meth_ast_inheritsNode9094->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode9094);
  meth_meth_ast_inheritsNode9094->definitionModule = modulename;
  meth_meth_ast_inheritsNode9094->definitionLine = 2160;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9095 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9095 = alloc_userobj2(2,4, objclass9095);
  gc_frame_newslot(obj9095);
// OBJECT OUTER DEC outer
  adddatum2(obj9095, self, 0);
  addmethodreal(obj9095,"outer", &reader_ast_outer_9096);
  Object oldself9095 = self;
  struct StackFrameObject *oldstackframe9095 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9095);
  gc_frame_newslot((Object)stackframe);
  self = obj9095;
  Object *oldselfslot9095 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9095 = (*(struct UserObject *)self).data[0], lowerouter9095 = thisouter9095;
  if (inheritingObject9095) {
    struct UserObject *inho9095 = (struct UserObject *)inheritingObject9095;
    while (inho9095->super != GraceDefaultObject) inho9095 = (struct UserObject *)inho9095->super;
    inho9095->super = obj9095;
    self = inheritingObject9095;
    *selfslot = self;
    lowerouter9095 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9095;
  }
// method new
  block_savedest(obj9095);
  Object closure9097 = createclosure(3, "new");
  setclosureframe(closure9097, stackframe);
  addtoclosure(closure9097, var_nullNode);
  addtoclosure(closure9097, var_inheritsNode);
  addtoclosure(closure9097, var_baseNode);
  struct UserObject *uo9097 = (struct UserObject*)obj9095;
  uo9097->data[1] = (Object)closure9097;
  Method *meth_meth_ast_new9097 = addmethod2pos(obj9095, "new", &meth_ast_new9097, 1);
  int argcv_meth_ast_new9097[] = {1};
  meth_meth_ast_new9097->type = alloc_MethodType(1, argcv_meth_ast_new9097);
  meth_meth_ast_new9097->definitionModule = modulename;
  meth_meth_ast_new9097->definitionLine = 2160;
  block_savedest(obj9095);
  Object closure9250 = createclosure(3, "new()object");
  setclosureframe(closure9250, stackframe);
  addtoclosure(closure9250, var_nullNode);
  addtoclosure(closure9250, var_inheritsNode);
  addtoclosure(closure9250, var_baseNode);
  Method *meth_meth_ast_new9097_object = addmethod2pos(obj9095, "new()object", &meth_ast_new9097_object, 1);
  meth_meth_ast_new9097_object->definitionModule = modulename;
  meth_meth_ast_new9097_object->definitionLine = 2160;
  sourceObject = obj9095;
objclass9095 = obj9095->class;
  objclass9095->definitionModule = modulename;
  objclass9095->definitionLine = 2160;
  (*(struct UserObject *)self).data[0] = lowerouter9095;
  self = oldself9095;
  selfslot = oldselfslot9095;
  stackframe = oldstackframe9095;
// compiled object node returning obj9095 (depth = 3)
  *var_inheritsNode = obj9095;
  if (obj9095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method blankNode
  block_savedest(self);
  Object closure9251 = createclosure(1, "blankNode");
  setclosureframe(closure9251, stackframe);
  addtoclosure(closure9251, var_blankNode);
  struct UserObject *uo9251 = (struct UserObject*)self;
  uo9251->data[40] = (Object)closure9251;
  Method *meth_meth_ast_blankNode9251 = addmethod2pos(self, "blankNode", &meth_ast_blankNode9251, 40);
  int argcv_meth_ast_blankNode9251[] = {0};
  meth_meth_ast_blankNode9251->type = alloc_MethodType(1, argcv_meth_ast_blankNode9251);
  meth_meth_ast_blankNode9251->definitionModule = modulename;
  meth_meth_ast_blankNode9251->definitionLine = 2206;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9252 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9252 = alloc_userobj2(2,4, objclass9252);
  gc_frame_newslot(obj9252);
// OBJECT OUTER DEC outer
  adddatum2(obj9252, self, 0);
  addmethodreal(obj9252,"outer", &reader_ast_outer_9253);
  Object oldself9252 = self;
  struct StackFrameObject *oldstackframe9252 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9252);
  gc_frame_newslot((Object)stackframe);
  self = obj9252;
  Object *oldselfslot9252 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9252 = (*(struct UserObject *)self).data[0], lowerouter9252 = thisouter9252;
  if (inheritingObject9252) {
    struct UserObject *inho9252 = (struct UserObject *)inheritingObject9252;
    while (inho9252->super != GraceDefaultObject) inho9252 = (struct UserObject *)inho9252->super;
    inho9252->super = obj9252;
    self = inheritingObject9252;
    *selfslot = self;
    lowerouter9252 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9252;
  }
// method new
  block_savedest(obj9252);
  Object closure9254 = createclosure(2, "new");
  setclosureframe(closure9254, stackframe);
  addtoclosure(closure9254, var_blankNode);
  addtoclosure(closure9254, var_baseNode);
  struct UserObject *uo9254 = (struct UserObject*)obj9252;
  uo9254->data[1] = (Object)closure9254;
  Method *meth_meth_ast_new9254 = addmethod2pos(obj9252, "new", &meth_ast_new9254, 1);
  int argcv_meth_ast_new9254[] = {0};
  meth_meth_ast_new9254->type = alloc_MethodType(1, argcv_meth_ast_new9254);
  meth_meth_ast_new9254->definitionModule = modulename;
  meth_meth_ast_new9254->definitionLine = 2206;
  block_savedest(obj9252);
  Object closure9277 = createclosure(2, "new()object");
  setclosureframe(closure9277, stackframe);
  addtoclosure(closure9277, var_blankNode);
  addtoclosure(closure9277, var_baseNode);
  Method *meth_meth_ast_new9254_object = addmethod2pos(obj9252, "new()object", &meth_ast_new9254_object, 1);
  meth_meth_ast_new9254_object->definitionModule = modulename;
  meth_meth_ast_new9254_object->definitionLine = 2206;
  sourceObject = obj9252;
objclass9252 = obj9252->class;
  objclass9252->definitionModule = modulename;
  objclass9252->definitionLine = 2206;
  (*(struct UserObject *)self).data[0] = lowerouter9252;
  self = oldself9252;
  selfslot = oldselfslot9252;
  stackframe = oldstackframe9252;
// compiled object node returning obj9252 (depth = 3)
  *var_blankNode = obj9252;
  if (obj9252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method signaturePart
  block_savedest(self);
  Object closure9278 = createclosure(1, "signaturePart");
  setclosureframe(closure9278, stackframe);
  addtoclosure(closure9278, var_signaturePart);
  struct UserObject *uo9278 = (struct UserObject*)self;
  uo9278->data[41] = (Object)closure9278;
  Method *meth_meth_ast_signaturePart9278 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart9278, 41);
  int argcv_meth_ast_signaturePart9278[] = {0};
  meth_meth_ast_signaturePart9278->type = alloc_MethodType(1, argcv_meth_ast_signaturePart9278);
  meth_meth_ast_signaturePart9278->definitionModule = modulename;
  meth_meth_ast_signaturePart9278->definitionLine = 2226;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9279 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9279 = alloc_userobj2(2,4, objclass9279);
  gc_frame_newslot(obj9279);
// OBJECT OUTER DEC outer
  adddatum2(obj9279, self, 0);
  addmethodreal(obj9279,"outer", &reader_ast_outer_9280);
  Object oldself9279 = self;
  struct StackFrameObject *oldstackframe9279 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9279);
  gc_frame_newslot((Object)stackframe);
  self = obj9279;
  Object *oldselfslot9279 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9279 = (*(struct UserObject *)self).data[0], lowerouter9279 = thisouter9279;
  if (inheritingObject9279) {
    struct UserObject *inho9279 = (struct UserObject *)inheritingObject9279;
    while (inho9279->super != GraceDefaultObject) inho9279 = (struct UserObject *)inho9279->super;
    inho9279->super = obj9279;
    self = inheritingObject9279;
    *selfslot = self;
    lowerouter9279 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9279;
  }
// method new
  block_savedest(obj9279);
  Object closure9281 = createclosure(2, "new");
  setclosureframe(closure9281, stackframe);
  addtoclosure(closure9281, var_signaturePart);
  addtoclosure(closure9281, var_baseNode);
  struct UserObject *uo9281 = (struct UserObject*)obj9279;
  uo9281->data[1] = (Object)closure9281;
  Method *meth_meth_ast_new9281 = addmethod2pos(obj9279, "new", &meth_ast_new9281, 1);
  int argcv_meth_ast_new9281[] = {0};
  meth_meth_ast_new9281->type = alloc_MethodType(1, argcv_meth_ast_new9281);
  meth_meth_ast_new9281->definitionModule = modulename;
  meth_meth_ast_new9281->definitionLine = 2226;
  block_savedest(obj9279);
  Object closure9548 = createclosure(2, "new()object");
  setclosureframe(closure9548, stackframe);
  addtoclosure(closure9548, var_signaturePart);
  addtoclosure(closure9548, var_baseNode);
  Method *meth_meth_ast_new9281_object = addmethod2pos(obj9279, "new()object", &meth_ast_new9281_object, 1);
  meth_meth_ast_new9281_object->definitionModule = modulename;
  meth_meth_ast_new9281_object->definitionLine = 2226;
  sourceObject = obj9279;
objclass9279 = obj9279->class;
  objclass9279->definitionModule = modulename;
  objclass9279->definitionLine = 2226;
  (*(struct UserObject *)self).data[0] = lowerouter9279;
  self = oldself9279;
  selfslot = oldselfslot9279;
  stackframe = oldstackframe9279;
// compiled object node returning obj9279 (depth = 3)
  *var_signaturePart = obj9279;
  if (obj9279 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 1)
// starting to compile method node (depth = 2)
// method callWithPart
  block_savedest(self);
  Object closure9549 = createclosure(1, "callWithPart");
  setclosureframe(closure9549, stackframe);
  addtoclosure(closure9549, var_callWithPart);
  struct UserObject *uo9549 = (struct UserObject*)self;
  uo9549->data[42] = (Object)closure9549;
  Method *meth_meth_ast_callWithPart9549 = addmethod2pos(self, "callWithPart", &meth_ast_callWithPart9549, 42);
  int argcv_meth_ast_callWithPart9549[] = {0};
  meth_meth_ast_callWithPart9549->type = alloc_MethodType(1, argcv_meth_ast_callWithPart9549);
  meth_meth_ast_callWithPart9549->definitionModule = modulename;
  meth_meth_ast_callWithPart9549->definitionLine = 2286;
// compiled method node returning  (depth = 2)
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9550 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9550 = alloc_userobj2(2,4, objclass9550);
  gc_frame_newslot(obj9550);
// OBJECT OUTER DEC outer
  adddatum2(obj9550, self, 0);
  addmethodreal(obj9550,"outer", &reader_ast_outer_9551);
  Object oldself9550 = self;
  struct StackFrameObject *oldstackframe9550 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9550);
  gc_frame_newslot((Object)stackframe);
  self = obj9550;
  Object *oldselfslot9550 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9550 = (*(struct UserObject *)self).data[0], lowerouter9550 = thisouter9550;
  if (inheritingObject9550) {
    struct UserObject *inho9550 = (struct UserObject *)inheritingObject9550;
    while (inho9550->super != GraceDefaultObject) inho9550 = (struct UserObject *)inho9550->super;
    inho9550->super = obj9550;
    self = inheritingObject9550;
    *selfslot = self;
    lowerouter9550 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9550;
  }
// method new
  block_savedest(obj9550);
  Object closure9552 = createclosure(2, "new");
  setclosureframe(closure9552, stackframe);
  addtoclosure(closure9552, var_callWithPart);
  addtoclosure(closure9552, var_baseNode);
  struct UserObject *uo9552 = (struct UserObject*)obj9550;
  uo9552->data[1] = (Object)closure9552;
  Method *meth_meth_ast_new9552 = addmethod2pos(obj9550, "new", &meth_ast_new9552, 1);
  int argcv_meth_ast_new9552[] = {0};
  meth_meth_ast_new9552->type = alloc_MethodType(1, argcv_meth_ast_new9552);
  meth_meth_ast_new9552->definitionModule = modulename;
  meth_meth_ast_new9552->definitionLine = 2286;
  block_savedest(obj9550);
  Object closure9707 = createclosure(2, "new()object");
  setclosureframe(closure9707, stackframe);
  addtoclosure(closure9707, var_callWithPart);
  addtoclosure(closure9707, var_baseNode);
  Method *meth_meth_ast_new9552_object = addmethod2pos(obj9550, "new()object", &meth_ast_new9552_object, 1);
  meth_meth_ast_new9552_object->definitionModule = modulename;
  meth_meth_ast_new9552_object->definitionLine = 2286;
  sourceObject = obj9550;
objclass9550 = obj9550->class;
  objclass9550->definitionModule = modulename;
  objclass9550->definitionLine = 2286;
  (*(struct UserObject *)self).data[0] = lowerouter9550;
  self = oldself9550;
  selfslot = oldselfslot9550;
  stackframe = oldstackframe9550;
// compiled object node returning obj9550 (depth = 3)
  *var_callWithPart = obj9550;
  if (obj9550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// compiled class node returning done (depth = 1)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ASTVisitor
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type9709 = alloc_Type("ASTVisitor", 28);
    add_Method((ClassData)type9709, "visitIf()up", NULL);
    add_Method((ClassData)type9709, "visitBlock()up", NULL);
    add_Method((ClassData)type9709, "visitMatchCase()up", NULL);
    add_Method((ClassData)type9709, "visitCatchCase()up", NULL);
    add_Method((ClassData)type9709, "visitMethodType()up", NULL);
    add_Method((ClassData)type9709, "visitSignaturePart()up", NULL);
    add_Method((ClassData)type9709, "visitTypeLiteral()up", NULL);
    add_Method((ClassData)type9709, "visitTypeDec()up", NULL);
    add_Method((ClassData)type9709, "visitMethod()up", NULL);
    add_Method((ClassData)type9709, "visitCall()up", NULL);
    add_Method((ClassData)type9709, "visitClass()up", NULL);
    add_Method((ClassData)type9709, "visitObject()up", NULL);
    add_Method((ClassData)type9709, "visitArray()up", NULL);
    add_Method((ClassData)type9709, "visitMember()up", NULL);
    add_Method((ClassData)type9709, "visitGeneric()up", NULL);
    add_Method((ClassData)type9709, "visitIdentifier()up", NULL);
    add_Method((ClassData)type9709, "visitOctets()up", NULL);
    add_Method((ClassData)type9709, "visitString()up", NULL);
    add_Method((ClassData)type9709, "visitNum()up", NULL);
    add_Method((ClassData)type9709, "visitOp()up", NULL);
    add_Method((ClassData)type9709, "visitIndex()up", NULL);
    add_Method((ClassData)type9709, "visitBind()up", NULL);
    add_Method((ClassData)type9709, "visitDefDec()up", NULL);
    add_Method((ClassData)type9709, "visitVarDec()up", NULL);
    add_Method((ClassData)type9709, "visitImport()up", NULL);
    add_Method((ClassData)type9709, "visitReturn()up", NULL);
    add_Method((ClassData)type9709, "visitInherits()up", NULL);
    add_Method((ClassData)type9709, "visitDialect()up", NULL);
// compiled typeliteral node returning type9709 (depth = 2)
  *var_ASTVisitor = type9709;
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method ASTVisitor
  block_savedest(self);
  Object closure9710 = createclosure(1, "ASTVisitor");
  setclosureframe(closure9710, stackframe);
  addtoclosure(closure9710, var_ASTVisitor);
  struct UserObject *uo9710 = (struct UserObject*)self;
  uo9710->data[43] = (Object)closure9710;
  Method *meth_meth_ast_ASTVisitor9710 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor9710, 43);
  int argcv_meth_ast_ASTVisitor9710[] = {0};
  meth_meth_ast_ASTVisitor9710->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor9710);
  meth_meth_ast_ASTVisitor9710->definitionModule = modulename;
  meth_meth_ast_ASTVisitor9710->definitionLine = 2299;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject9711 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9711 = alloc_userobj2(2,4, objclass9711);
  gc_frame_newslot(obj9711);
// OBJECT OUTER DEC outer
  adddatum2(obj9711, self, 0);
  addmethodreal(obj9711,"outer", &reader_ast_outer_9712);
  Object oldself9711 = self;
  struct StackFrameObject *oldstackframe9711 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9711);
  gc_frame_newslot((Object)stackframe);
  self = obj9711;
  Object *oldselfslot9711 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9711 = (*(struct UserObject *)self).data[0], lowerouter9711 = thisouter9711;
  if (inheritingObject9711) {
    struct UserObject *inho9711 = (struct UserObject *)inheritingObject9711;
    while (inho9711->super != GraceDefaultObject) inho9711 = (struct UserObject *)inho9711->super;
    inho9711->super = obj9711;
    self = inheritingObject9711;
    *selfslot = self;
    lowerouter9711 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9711;
  }
// method visitCall()up
  struct UserObject *uo9713 = (struct UserObject*)obj9711;
  uo9713->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall_40__41_up9713 = addmethod2pos(obj9711, "visitCall()up", &meth_ast_visitCall_40__41_up9713, 1);
  int argcv_meth_ast_visitCall_40__41_up9713[] = {1, 1};
  meth_meth_ast_visitCall_40__41_up9713->type = alloc_MethodType(2, argcv_meth_ast_visitCall_40__41_up9713);
  meth_meth_ast_visitCall_40__41_up9713->definitionModule = modulename;
  meth_meth_ast_visitCall_40__41_up9713->definitionLine = 2454;
  sourceObject = obj9711;
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9718 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9719 = gc_frame_new();
// call case 3: self.outer request
  Object call9720 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe9719);
// compiled call node returning call9720 (depth = 5)
// compiled member node returning call9720 (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call9721 = callmethodflags(call9720, "baseVisitor()object", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9718);
// compiled call node returning call9721 (depth = 3)
  struct UserObject *obj9711_uo = (struct UserObject *)obj9711;
  obj9711_uo->super = call9721;
  sourceObject = obj9711;
objclass9711 = obj9711->class;
  objclass9711->definitionModule = modulename;
  objclass9711->definitionLine = 2452;
  (*(struct UserObject *)self).data[0] = lowerouter9711;
  self = oldself9711;
  selfslot = oldselfslot9711;
  stackframe = oldstackframe9711;
// compiled object node returning obj9711 (depth = 2)
  *var_patternMarkVisitor = obj9711;
  if (obj9711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method patternMarkVisitor
  block_savedest(self);
  Object closure9722 = createclosure(1, "patternMarkVisitor");
  setclosureframe(closure9722, stackframe);
  addtoclosure(closure9722, var_patternMarkVisitor);
  struct UserObject *uo9722 = (struct UserObject*)self;
  uo9722->data[44] = (Object)closure9722;
  Method *meth_meth_ast_patternMarkVisitor9722 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor9722, 44);
  int argcv_meth_ast_patternMarkVisitor9722[] = {0};
  meth_meth_ast_patternMarkVisitor9722->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor9722);
  meth_meth_ast_patternMarkVisitor9722->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor9722->definitionLine = 2453;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
