#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "61482bce15cec41844a512fd6f07853796a59bdb";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "lexer";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"io\" as io",
  "import \"sys\" as sys",
  "import \"util\" as util",
  "import \"unicode\" as unicode",
  "import \"mgcollections\" as collections",
  "import \"errormessages\" as errormessages",
  "",
  "// Return the numeric value of the single hexadecimal character c.",
  "method hexdecchar(c) {",
  "    var chars := [\"0\", \"1\", \"2\", \"3\", \"4\", \"5\", \"6\", \"7\", \"8\",",
  "                 \"9\", \"a\", \"b\", \"c\", \"d\", \"e\", \"f\"]",
  "    var ret := 0",
  "    var i := 0",
  "    for (chars) do {cr->",
  "        if (cr == c) then {",
  "            ret := i",
  "        }",
  "        i := i + 1",
  "    }",
  "    ret",
  "}",
  "method padl(s, l, w) {",
  "    if (s.size >= l) then {",
  "        return s",
  "    }",
  "    var s' := s",
  "    while {s'.size < l} do {",
  "        s' := w ++ s'",
  "    }",
  "    return s'",
  "}",
  "",
  "def LexerClass = object {",
  "    method asString { \"LexerClass object\" }",
  "    method new {",
  "        var lineNumber := 1",
  "        var linePosition := 0",
  "        var startPosition := 1",
  "        var indentLevel := 0",
  "",
  "        class Token.new() {",
  "            def line = lineNumber",
  "            def indent = indentLevel",
  "            def linePos = startPosition",
  "",
  "            var next := false",
  "            var prev := false",
  "",
  "            method ==(other) {",
  "                if(other == false) then {",
  "                    false",
  "                } else {",
  "                    (other.line == line) && (other.linePos == linePos)",
  "                }",
  "            }",
  "        }",
  "",
  "        class IdentifierToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"identifier\"",
  "            def value = s",
  "            def size = s.size",
  "        }",
  "        class StringToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"string\"",
  "            def value = s",
  "            def size = s.size + 2",
  "        }",
  "        class CommentToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"comment\"",
  "            def value = s",
  "            def size = s.size + 2",
  "        }",
  "        class OctetsToken.new(s) {",
  "            inherits Token.new",
  "            def kind = \"octets\"",
  "            def value = s",
  "            def size = s.size + 3",
  "        }",
  "        class LBraceToken.new {",
  "            inherits Token.new",
  "            def kind = \"lbrace\"",
  "            def value = \"\\{\"",
  "            def size = 1",
  "        }",
  "        class RBraceToken.new {",
  "            inherits Token.new",
  "            def kind = \"rbrace\"",
  "            def value = \"}\"",
  "            def size = 1",
  "        }",
  "        class LParenToken.new {",
  "            inherits Token.new",
  "            def kind = \"lparen\"",
  "            def value = \"(\"",
  "            def size = 1",
  "        }",
  "        class RParenToken.new {",
  "            inherits Token.new",
  "            def kind = \"rparen\"",
  "            def value = \")\"",
  "            def size = 1",
  "        }",
  "        class LSquareToken.new {",
  "            inherits Token.new",
  "            def kind = \"lsquare\"",
  "            def value = \"[\"",
  "            def size = 1",
  "        }",
  "        class RSquareToken.new {",
  "            inherits Token.new",
  "            def kind = \"rsquare\"",
  "            def value = \"]\"",
  "            def size = 1",
  "        }",
  "        class CommaToken.new {",
  "            inherits Token.new",
  "            def kind = \"comma\"",
  "            def value = \",\"",
  "            def size = 1",
  "        }",
  "        class ColonToken.new {",
  "            inherits Token.new",
  "            def kind = \"colon\"",
  "            def value = \":\"",
  "            def size = 1",
  "        }",
  "        class DotToken.new {",
  "            inherits Token.new",
  "            def kind = \"dot\"",
  "            def value = \".\"",
  "            def size = 1",
  "        }",
  "        class NumToken.new(v, b) {",
  "            inherits Token.new",
  "            def kind = \"num\"",
  "            def value = v",
  "            def base = b",
  "            def size = linePosition - startPosition",
  "        }",
  "        class KeywordToken.new(v) {",
  "            inherits Token.new",
  "            def kind = \"keyword\"",
  "            def value = v",
  "            def size = v.size",
  "        }",
  "        class OpToken.new(v) {",
  "            inherits Token.new",
  "            def kind = \"op\"",
  "            def value = v",
  "            def size = v.size",
  "        }",
  "        class ArrowToken.new {",
  "            inherits Token.new",
  "            def kind = \"arrow\"",
  "            def value = \"->\"",
  "            def size = 2",
  "        }",
  "        class BindToken.new {",
  "            inherits Token.new",
  "            def kind = \"bind\"",
  "            def value = \":=\"",
  "            def size = 2",
  "        }",
  "        class SemicolonToken.new {",
  "            inherits Token.new",
  "            def kind = \"semicolon\"",
  "            def value = \";\"",
  "            def size = 1",
  "        }",
  "        class LGenericToken.new {",
  "            inherits Token.new",
  "            def kind = \"lgeneric\"",
  "            def value = \"<\"",
  "            def size = 1",
  "        }",
  "        class RGenericToken.new {",
  "            inherits Token.new",
  "            def kind = \"rgeneric\"",
  "            def value = \">\"",
  "            def size = 1",
  "        }",
  "",
  "        object {",
  "            // When a new lexical class has begun, add to the tokens list",
  "            // the token corresponding to the previous accumulated data.",
  "            // mode is the previous lexical mode (a string), and accum the",
  "            // accumulated characters since that mode began. Modes are:",
  "",
  "            //   n           Whitespace       i   Identifier",
  "            //   \"           Quoted string    x   Octets literal",
  "            //   m           Number           o   Any operator",
  "            //   p           Pragma           d   Indentation",
  "            //   c           Comment",
  "            //   ,.{}()[]<>; The corresponding literal character",
  "            //",
  "            // There are three special cases for mode o. If accum is \"->\",",
  "            // \":=\", or \"=\", the corresponding special token is created.",
  "            // For mode i, a keyword token is created for an identifier",
  "            // whose name is a reserved keyword.",
  "            method modechange(tokens, mode, accum) {",
  "                var isDone := false",
  "                var tok := 0",
  "                if ((mode != \"n\") || (accum.size > 0)) then {",
  "                    if (mode == \"i\") then {",
  "                        tok := IdentifierToken.new(accum)",
  "                        if ((accum == \"object\") || (accum == \"method\")",
  "                            || (accum == \"var\") || (accum == \"type\")",
  "                            || (accum == \"import\") || (accum == \"class\")",
  "                            || (accum == \"return\") || (accum == \"def\")",
  "                            || (accum == \"inherits\") || (accum == \"is\")",
  "                            || (accum == \"dialect\") || (accum == \"factory\")) then {",
  "                            tok := KeywordToken.new(accum)",
  "                        }",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    }",
  "                    if (mode == \"I\") then {",
  "                        tok := IdentifierToken.new(accum)",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"\\\"\") then {",
  "                        tok := StringToken.new(accum)",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"x\") then {",
  "                        tok := OctetsToken.new(accum)",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \",\") then {",
  "                        tok := CommaToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \".\") then {",
  "                        tok := DotToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"\\{\") then {",
  "                        tok := LBraceToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"}\") then {",
  "                        tok := RBraceToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"(\") then {",
  "                        tok := LParenToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \")\") then {",
  "                        tok := RParenToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"[\") then {",
  "                        tok := LSquareToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    }",
  "                    if (mode == \"]\") then {",
  "                        tok := RSquareToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"<\") then {",
  "                        tok := LGenericToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \">\") then {",
  "                        tok := RGenericToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \";\") then {",
  "                        tok := SemicolonToken.new",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"m\") then {",
  "                        if ((tokens.size > 1).andAlso {tokens.last.kind == \"dot\"}) then {",
  "                            def dot = tokens.pop",
  "                            if (tokens.last.kind == \"num\") then {",
  "                                if (tokens.last.base == 10) then {",
  "                                    tok := tokens.pop",
  "                                    var decimal := makeNumToken(accum)",
  "                                    if(decimal.base == 10) then {",
  "                                        tok := NumToken.new(tok.value ++ \".\" ++ accum, 10)",
  "                                    } else {",
  "                                        def suggestions = []",
  "                                        var suggestion := errormessages.suggestion.new",
  "                                        suggestion.replaceRange(dot.linePos + 1, linePosition - 1)with(decimal.value)onLine(lineNumber)",
  "                                        suggestions.push(suggestion)",
  "                                        suggestion := errormessages.suggestion.new",
  "                                        suggestion.deleteRange(dot.linePos, linePosition - 1)onLine(lineNumber)",
  "                                        suggestions.push(suggestion)",
  "                                        errormessages.syntaxError(\"The fractional part of a number must be in base 10.\")atRange(",
  "                                            lineNumber, dot.linePos + 1, linePosition - 1)withSuggestions(suggestions)",
  "                                    }",
  "                                } else {",
  "                                    def suggestions = []",
  "                                    var suggestion := errormessages.suggestion.new",
  "                                    suggestion.replaceRange(tokens.last.linePos, dot.linePos - 1)with(tokens.last.value)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.deleteChar(dot.linePos)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A number in base {tokens.last.base} cannot have a fractional part.\")atRange(",
  "                                        lineNumber, dot.linePos, linePosition - 1)withSuggestions(suggestions)",
  "                                }",
  "                            } else {",
  "                                if(tokens.last.kind == \"string\") then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceChar(dot.linePos)with(\"++\")onLine(dot.line)",
  "                                    errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'. \"",
  "                                        ++ \"To join a number to a string, use '++'.\")atRange(",
  "                                        dot.line, dot.linePos, dot.linePos)withSuggestion(suggestion)",
  "                                } elseif((tokens.last.kind == \"op\") || (tokens.last.kind == \"bind\")) then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.insert(\"0\")atPosition(dot.linePos)onLine(dot.line)",
  "                                    errormessages.syntaxError(\"A number must have a digit before the decimal point.\")atPosition(",
  "                                        dot.line, dot.linePos)withSuggestion(suggestion)",
  "                                } elseif(tokens.last.kind == \"identifier\") then {",
  "                                    def suggestions = []",
  "                                    if(tokens.last.value == \"o\") then {",
  "                                        def suggestion = errormessages.suggestion.new",
  "                                        suggestion.replaceChar(tokens.last.linePos)with(\"0\")onLine(tokens.last.line)",
  "                                        suggestions.push(suggestion)",
  "                                    }",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceRange(dot.linePos, linePosition - 1)with(\"({accum})\")onLine(tokens.last.line)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'.\")atRange(",
  "                                        dot.line, dot.linePos, dot.linePos)withSuggestions(suggestions)",
  "                                } else {",
  "                                    errormessages.syntaxError(\"A number may follow a '.' only if there is a number before the '.'.\")atRange(",
  "                                        dot.line, dot.linePos, dot.linePos)",
  "                                }",
  "                            }",
  "                        } else {",
  "                            tok := makeNumToken(accum)",
  "                        }",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"o\") then {",
  "                        tok := OpToken.new(accum)",
  "                        if (accum == \"->\") then {",
  "                            tok := ArrowToken.new",
  "                        } elseif (accum == \":=\") then {",
  "                            tok := BindToken.new",
  "                        } elseif (accum == \":\") then {",
  "                            tok := ColonToken.new",
  "                        }",
  "                        tokens.push(tok)",
  "                        isDone := true",
  "                    } elseif (mode == \"d\") then {",
  "                        indentLevel := linePosition - 1//accum.size",
  "                        isDone := true",
  "                    } elseif (mode == \"n\") then {",
  "                        isDone := true",
  "                    } elseif (mode == \"c\") then {",
  "                        def cmt = accum.substringFrom(3)to(accum.size)",
  "                        tokens.push(CommentToken.new(cmt))",
  "                        isDone := true",
  "                    } elseif (mode == \"p\") then {",
  "                        if (accum.substringFrom(1)to(8) == \"#pragma \") then {",
  "                            util.processExtension(",
  "                                accum.substringFrom(9)to(accum.size))",
  "                        }",
  "                    } elseif (isDone) then {",
  "                        //print(mode, accum, tokens)",
  "                    } else {",
  "                        errormessages.syntaxError(\"Lexing error: no handler for mode {mode} with accum {accum}.\")atPosition(lineNumber, linePosition)",
  "                    }",
  "                }",
  "                startPosition := linePosition",
  "            }",
  "",
  "            method fromBase(str, base) {",
  "                var val := 0",
  "                var i := 0",
  "                for (str) do {c->",
  "                    def n = c.ord",
  "                    val := val * base",
  "                    var inc := 0",
  "                    if ((n >= 48) && (n <= 57)) then {",
  "                        inc := n - 48 // 0",
  "                    } elseif((n >= 65) && (n <= 90)) then {",
  "                        inc := n - 55 // 'A' - 10",
  "                    } else {",
  "                        inc := n - 87 // 'a' - 10",
  "                    }",
  "                    if (inc >= base) then {",
  "                        if((str[1] == \"0\") && (inc < 16)) then {",
  "                            def suggestion = errormessages.suggestion.new",
  "                            suggestion.insert(\"x\")atPosition(linePosition - str.size + 1)onLine(lineNumber)",
  "                            errormessages.syntaxError(\"A number in base 16 must start with '0x'.\")atPosition(",
  "                                lineNumber, linePosition - str.size + 1)withSuggestion(suggestion)",
  "                        } else {",
  "                            def suggestion = errormessages.suggestion.new",
  "                            if(str.size == 1) then {",
  "                                suggestion.deleteRange(linePosition - str.size - 1, linePosition - 1)onLine(lineNumber)",
  "                            } else {",
  "                                suggestion.deleteChar(linePosition - str.size + i)onLine(lineNumber)",
  "                            }",
  "                            def validDigits = if(base <= 10) then {",
  "                                \"'0' to '{base - 1}'\"",
  "                            } else {",
  "                                \"'0' to '9', 'a' to '{unicode.create(87 + base)}'\"",
  "                            }",
  "                            errormessages.syntaxError(\"'{c}' is not a valid digit in base {base}. Valid digits are {validDigits}.\")atRange(",
  "                                lineNumber, linePosition - str.size + i, linePosition - str.size + i)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                    val := val + inc",
  "                    i := i + 1",
  "                }",
  "                val",
  "            }",
  "            method makeNumToken(accum) {",
  "                var base := 10",
  "                var baseSet := false",
  "                var sofar := \"\"",
  "                var i := 0",
  "                for (accum) do {c->",
  "                    if ((c == \"x\") && (!baseSet)) then {",
  "                        base := sofar.asNumber",
  "                        baseSet := true",
  "                        if (base == 0) then {",
  "                            base := 16",
  "                        }",
  "                        if((base < 2) || (base > 36)) then {",
  "                            def suggestions = []",
  "                            var suggestion := errormessages.suggestion.new",
  "                            suggestion.replaceChar(linePosition - accum.size + i)with(\"*\")onLine(lineNumber)",
  "                            suggestions.push(suggestion)",
  "                            suggestion := errormessages.suggestion.new",
  "                            suggestion.deleteRange(linePosition - accum.size, linePosition - accum.size + i)onLine(lineNumber)",
  "                            suggestions.push(suggestion)",
  "                            errormessages.syntaxError(\"Base {base} is not a valid numerical base.\")atRange(",
  "                                lineNumber, linePosition - accum.size, linePosition - accum.size + i - 1)withSuggestions(suggestions)",
  "                        }",
  "                        sofar := \"\"",
  "                    } else {",
  "                        sofar := sofar ++ c",
  "                    }",
  "                    i := i + 1",
  "                }",
  "                if(sofar == \"\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteRange(linePosition - accum.size + i - 1, linePosition - 1)onLine(lineNumber)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"0\")atPosition(linePosition)onLine(lineNumber)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"At least one digit must follow the 'x' in a number.\")atPosition(",
  "                        lineNumber, linePosition - accum.size + i)withSuggestions(suggestions)",
  "                }",
  "                NumToken.new(fromBase(sofar, base).asString, base)",
  "            }",
  "            // True if ov is a valid identifier character. Identifier",
  "            // characters are Unicode letters, Unicode numbers, apostrophe,",
  "            // and (currently) underscore.",
  "            method isidentifierchar(ov) {",
  "                if (unicode.isLetter(ov)) then {",
  "                    return true",
  "                }",
  "                if (unicode.isNumber(ov)) then {",
  "                    return true",
  "                }",
  "                if ((ov == 95) || (ov == 39)) then {",
  "                    // 95 is _, 39 is '",
  "                    true",
  "                } else {",
  "                    false",
  "                }",
  "            }",
  "",
  "            // True if c (with codepoint ordval) is a valid operator character.",
  "            method isoperatorchar(c, ordval) {",
  "                if ((c == \"-\") || (c == \"&\") || (c == \"|\") || (c == \":\")",
  "                    || (c == \"%\") || (c == \"^\") || (c == \"@\") || (c == \"?\")",
  "                    || (c == \"*\") || (c == \"/\") || (c == \"+\") || (c == \"!\")",
  "                    ) then {",
  "                    return true",
  "                }",
  "                if (unicode.isSymbolMathematical(ordval)) then {",
  "                    return true",
  "                } elseif (unicode.iscategory(c, \"So\")) then {",
  "                    return true",
  "                }",
  "                return false",
  "            }",
  "",
  "            // Read the program text from util.infile and return a list of",
  "            // tokens.",
  "            method lexfile(file) {",
  "                util.log_verbose(\"reading source.\")",
  "                def lines = []",
  "                def cLines = []",
  "                var line := \"\"",
  "                var cLine := \"\"",
  "                var source := \"\"",
  "                for(file.read) do { c ->",
  "                    if((c == \"\\n\") || (c == \"\\l\")) then {",
  "                        lines.push(line)",
  "                        cLines.push(cLine)",
  "                        line := \"\"",
  "                        cLine := \"\"",
  "                    } elseif(c == \"\\r\") then {",
  "                    } elseif(c == \"\\\\\") then {",
  "                        line := line ++ \"\\\\\"",
  "                        cLine := cLine ++ \"\\\\\\\\\"",
  "                    } elseif(c == \"\\\"\") then {",
  "                        line := line ++ \"\\\"\"",
  "                        cLine := cLine ++ \"\\\\\\\"\"",
  "                    } else {",
  "                        line := line ++ c",
  "                        cLine := cLine ++ c",
  "                    }",
  "                    source := source ++ c",
  "                }",
  "                if(line != \"\") then {",
  "                    lines.push(line)",
  "                    cLines.push(cLine)",
  "                }",
  "                util.lines := lines",
  "                util.cLines := cLines",
  "                lexinput(source)",
  "            }",
  "",
  "            method lexinput(input) {",
  "                // tokens is a doubly-linked list of tokens.",
  "                var tokens := object {",
  "                    var first := false",
  "                    var last := false",
  "                    var size' := 0",
  "",
  "                    method push(t) {",
  "                        if(first == false) then {",
  "                            first := t",
  "                            last := t",
  "                        } else {",
  "                            last.next := t",
  "                            t.prev := last",
  "                            last := t",
  "                        }",
  "                        size' := size' + 1",
  "                    }",
  "",
  "                    method pop {",
  "                        if(last != false) then {",
  "                            def popped = last",
  "                            last := last.prev",
  "                            if(last == false) then {",
  "                                first := false",
  "                            }",
  "                            size' := size' - 1",
  "                            popped",
  "                        }",
  "                    }",
  "",
  "                    method poll {",
  "                        if(first != false) then {",
  "                            def polled = first",
  "                            first := first.next",
  "                            if(first == false) then {",
  "                                last := false",
  "                            }",
  "                            size' := size' - 1",
  "                            polled",
  "                        }",
  "                    }",
  "",
  "                    method size {",
  "                        size' + 0",
  "                    }",
  "",
  "                    method iter {",
  "                        object {",
  "                            var n := first",
  "                            method havemore {",
  "                                n != false",
  "                            }",
  "                            method hasNext {",
  "                                n != false",
  "                            }",
  "                            method next {",
  "                                def ret = n",
  "                                n := n.next",
  "                                ret",
  "                            }",
  "                        }",
  "                    }",
  "",
  "                    method iterator {",
  "                        iter",
  "                    }",
  "                }",
  "",
  "                var mode := \"d\"",
  "                var newmode := mode",
  "                var instr := false",
  "                var inBackticks := false",
  "                var backtickIdent := false",
  "                var accum := \"\"",
  "                var escaped := false",
  "                var prev := \"\"",
  "                var unichars := 0",
  "                var codepoint := 0",
  "                var interpdepth := 0",
  "                var interpString := false",
  "                var atStart := true",
  "                linePosition := 0",
  "                util.log_verbose(\"lexing.\")",
  "                def badSeparator = unicode.pattern(\"Z\", 9)not(32, 8232)",
  "                def badControl =  unicode.pattern(\"C\")not(10, 13)",
  "                def selfModes = unicode.pattern(\"(\".ord, \")\".ord, \",\".ord,",
  "                    \".\".ord, \"\\{\".ord, \"}\".ord, \"[\".ord, \"]\".ord, \";\".ord)",
  "                def brackets = unicode.pattern(\"(\".ord, \")\".ord,",
  "                    \"\\{\".ord, \"}\".ord, \"[\".ord, \"]\".ord)",
  "                def identifierChar = unicode.pattern(\"L\", \"N\", 95, 39)",
  "                def digit = unicode.pattern(\"0\".ord, \"1\".ord, \"2\".ord, \"3\".ord,",
  "                    \"4\".ord, \"5\".ord, \"6\".ord, \"7\".ord, \"8\".ord, \"9\".ord)",
  "                def digitB = unicode.pattern(\"0\".ord, \"1\".ord, \"2\".ord, \"3\".ord,",
  "                    \"4\".ord, \"5\".ord, \"6\".ord, \"7\".ord, \"8\".ord, \"9\".ord)",
  "                def operatorChar = unicode.pattern(\"Sm\", \"So\",",
  "                    \"-\".ord, \"&\".ord, \"|\".ord, \":\".ord,",
  "                   \"%\".ord, \"^\".ord, \"@\".ord, \"?\".ord,",
  "                   \"*\".ord, \"/\".ord, \"+\".ord, \"!\".ord",
  "                    )",
  "                def iGTLT = unicode.pattern(\"i\".ord, \"<\".ord, \">\".ord)",
  "                def notcp = unicode.pattern()not(\"c\".ord, \"p\".ord)",
  "                def mainBlock = { c->",
  "                    var ct := \"\"",
  "                    var ordval := c.ord // String.ord gives the codepoint",
  "                    if (badSeparator.match(ordval)) then {",
  "                        // Character is whitespace, but not an ASCII space or",
  "                        // Unicode LINE SEPARATOR, or is a tab",
  "                        def suggestion = errormessages.suggestion.new",
  "                        suggestion.replaceChar(linePosition)with(\" \")onLine(lineNumber)",
  "                        if(ordval == 9) then {",
  "                            if (instr) then {",
  "                                suggestion.replaceRange(linePosition, linePosition)",
  "                                    with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                    onLine(lineNumber)",
  "                                errormessages.syntaxError(\"tabs cannot be \"",
  "                                    ++ \"written in the source code; \"",
  "                                    ++ \"use the Unicode escape \\\\u\"",
  "                                    ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                    ++ \" instead\")",
  "                                    atRange(lineNumber, linePosition, linePosition)",
  "                                    withSuggestion(suggestion)",
  "                            }",
  "                            errormessages.syntaxError(\"Tabs are not allowed; use spaces instead.\")atRange(lineNumber,",
  "                                linePosition, linePosition)withSuggestion(suggestion)",
  "                        } else {",
  "                            if (instr) then {",
  "                                suggestion.replaceRange(linePosition, linePosition)",
  "                                    with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                    onLine(lineNumber)",
  "                                errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                    ++ \"is not a valid whitespace character\"",
  "                                    ++ \" and cannot be \"",
  "                                    ++ \"written in the source code; \"",
  "                                    ++ \"use the Unicode escape \\\\u\"",
  "                                    ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                    ++ \" instead\")",
  "                                    atRange(lineNumber, linePosition, linePosition)",
  "                                    withSuggestion(suggestion)",
  "                            }",
  "                            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                ++ \"is not a valid whitespace character; use spaces instead.\")atRange(lineNumber,",
  "                                linePosition, linePosition)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                    if (badControl.match(ordval)) then {",
  "                        // Character is a control character other than",
  "                        // carriage return or line feed.",
  "                        def suggestion = errormessages.suggestion.new",
  "                        if (instr) then {",
  "                            suggestion.replaceRange(linePosition, linePosition)",
  "                                with(\"\\\\u{padl(ordval.inBase 16, 4, \"0\")}\")",
  "                                onLine(lineNumber)",
  "                            errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                ++ \"is a control character and cannot be \"",
  "                                ++ \"written in the source code; \"",
  "                                ++ \"use the Unicode escape \\\\u\"",
  "                                ++ padl(ordval.inBase 16, 4, \"0\")",
  "                                ++ \" instead\")",
  "                                atRange(lineNumber, linePosition, linePosition)",
  "                                withSuggestion(suggestion)",
  "                        }",
  "                        suggestion.deleteChar(linePosition)onLine(lineNumber)",
  "                        errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                            ++ \"is a control character and cannot be written in the source code; consider using spaces instead.\")atRange(lineNumber,",
  "                            linePosition, linePosition)withSuggestion(suggestion)",
  "                    }",
  "                    if (atStart) then {",
  "                        if (linePosition == 1) then {",
  "                            if (c == \"#\") then {",
  "                                mode := \"p\"",
  "                                newmode := mode",
  "                            } else {",
  "                                atStart := false",
  "                            }",
  "                        }",
  "                    }",
  "                    if (instr) then {",
  "",
  "                    } elseif ((mode != \"c\") && (mode != \"p\")) then {",
  "                        // Not in a comment, so look for a mode.",
  "                        if ((c == \" \") && (mode != \"d\")) then {",
  "                            newmode := \"n\"",
  "                        }",
  "                        if (c == \"\\\"\") then {",
  "                            // Beginning of a string",
  "                            newmode := \"\\\"\"",
  "                            instr := true",
  "                        }",
  "                        if (identifierChar.match(ordval)) then {",
  "                            newmode := \"i\"",
  "                        }",
  "                        ct := ((ordval >= 48) && (ordval <=57))",
  "                        if (digit.match(ordval)) then {",
  "                            if (mode != \"i\") then {",
  "                                newmode := \"m\"",
  "                            }",
  "                        }",
  "                        if (mode == \"m\") then {",
  "                            if ((ordval >= 97) && (ordval <=122)) then {",
  "                                newmode := \"m\"",
  "                            } else {",
  "                                if ((ordval >= 65) && (ordval <= 90)) then {",
  "                                    newmode := \"m\"",
  "                                }",
  "                            }",
  "                        }",
  "                        if ((mode == \"i\") && (c == \"<\")) then {",
  "                            newmode := \"<\"",
  "                        } elseif (iGTLT.match(mode)",
  "                            && (c == \">\")) then {",
  "                            if (mode == \">\") then {",
  "                                modechange(tokens, mode, accum)",
  "                            }",
  "                            newmode := \">\"",
  "                        } elseif (operatorChar.match(ordval)) then {",
  "                            newmode := \"o\"",
  "                        }",
  "                        if (selfModes.match(ordval)) then {",
  "                            newmode := c",
  "                        }",
  "                        if (c == \"#\") then {",
  "                            if (mode != \"p\") then {",
  "                                if(util.lines.at(lineNumber).substringFrom(1)to(7) == \"#pragma\") then {",
  "                                    if(tokens.size == 0) then {",
  "                                        def suggestion = errormessages.suggestion.new",
  "                                        suggestion.addLine(1, util.lines.at(lineNumber))",
  "                                        suggestion.addLine(lineNumber, \"\")",
  "                                        errormessages.syntaxError(\"Pragma directives must be at the start of the file.\")atLine(",
  "                                            lineNumber)withSuggestion(suggestion)",
  "                                    } else {",
  "                                        errormessages.syntaxError(\"Pragma directives must be at the start of the file.\")atLine(",
  "                                            lineNumber)",
  "                                    }",
  "                                } else {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.replaceChar(linePosition)with(\"//\")onLine(lineNumber)",
  "                                    errormessages.syntaxError(\"'#' is not allowed here. For a comment use '//'.\")atRange(",
  "                                        lineNumber, linePosition, linePosition)withSuggestion(suggestion)",
  "                                }",
  "                            }",
  "                        }",
  "                        if (c == \".\") then {",
  "                            if (accum == \".\") then {",
  "                                // Special handler for .. operator",
  "                                mode := \"o\"",
  "                                newmode := mode",
  "                            }",
  "                            if (accum == \"..\") then {",
  "                                // Special handler for ... identifier",
  "                                mode := \"n\"",
  "                                newmode := mode",
  "                                modechange(tokens, \"i\", \"...\")",
  "                                accum := \"\"",
  "                            }",
  "                        }",
  "                        if (c == \"/\") then {",
  "                            if (accum == \"/\") then {",
  "                                // Start of comment",
  "                                mode := \"c\"",
  "                                newmode := mode",
  "                            }",
  "                        }",
  "                        if (mode == \"n\") then {",
  "                            if (mode == newmode) then {",
  "                                if (unicode.isSeparator(ordval).not) then {",
  "                                    if (unicode.isControl(ordval).not) then {",
  "                                        if (ordval != 10) then {",
  "                                            if (ordval != 13) then {",
  "                                                if (ordval != 32) then {",
  "                                                    if (c != \".\") then{",
  "                                                        errormessages.syntaxError(\"{unicode.name(c)} (U+{padl(ordval.inBase 16, 4, \"0\")}) \"",
  "                                                            ++ \"is not a valid character; use spaces instead.\")atRange(",
  "                                                            lineNumber, linePosition, linePosition)",
  "                                                    }",
  "                                                }",
  "                                            }",
  "                                        }",
  "                                    }",
  "                                }",
  "                            }",
  "                        }",
  "                    }",
  "                    if (mode == \"\\\"\") then {",
  "                        if (c == \"\\\"\") then {",
  "                            if (escaped.not) then {",
  "                                // End of string literal",
  "                                newmode := \"n\"",
  "                                instr := false",
  "                                if (interpString) then {",
  "                                    modechange(tokens, mode, accum)",
  "                                    modechange(tokens, \")\", \")\")",
  "                                    mode := newmode",
  "                                    interpString := false",
  "                                }",
  "                            }",
  "                        }",
  "                    }",
  "                    if (newmode != mode) then {",
  "                        // This character is the beginning of a different",
  "                        // lexical mode - process the old one now.",
  "                        modechange(tokens, mode, accum)",
  "                        if (interpdepth > 0) then {",
  "                            if (newmode == \"}\") then {",
  "                                // Find the position of the opening brace to check in the interpolation is empty.",
  "                                if (util.lines.at(tokens.last.line)[tokens.last.linePos] == \"\\{\") then {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.deleteRange(linePosition - 1, linePosition)onLine(lineNumber)",
  "                                    errormessages.syntaxError(\"A string interpolation cannot be empty.\")atRange(",
  "                                        lineNumber, tokens.last.linePos, linePosition)withSuggestion(suggestion)",
  "                                }",
  "                                modechange(tokens, \")\", \")\")",
  "                                modechange(tokens, \"o\", \"++\")",
  "                                newmode := \"\\\"\"",
  "                                instr := true",
  "                                interpdepth := interpdepth - 1",
  "                            }",
  "                        }",
  "                        mode := newmode",
  "                        if (instr) then {",
  "                            // String accum should skip the opening quote, but",
  "                            // other modes' should include their first",
  "                            // character.",
  "                            accum := \"\"",
  "                        } else {",
  "                            accum := c",
  "                        }",
  "                        if (brackets.match(mode)) then {",
  "                            modechange(tokens, mode, accum)",
  "                            mode := \"n\"",
  "                            newmode := \"n\"",
  "                            accum := \"\"",
  "                        }",
  "                    } elseif (instr) then {",
  "                        if (c == \"\\n\") then {",
  "                            if (interpdepth > 0) then {",
  "                                // Find closest {.",
  "                                var line := lineNumber",
  "                                var i := util.lines.at(line).size",
  "                                while { util.lines.at(line)[i] != \"\\{\" } do {",
  "                                    i := i - 1",
  "                                    if(i == 0) then {",
  "                                        lineNumber := line - 1",
  "                                        i := util.lines.at(line).size",
  "                                    }",
  "                                }",
  "                                def suggestions = []",
  "                                var suggestion := errormessages.suggestion.new",
  "                                suggestion.insert(\"\\\\\")atPosition(i)onLine(line)",
  "                                suggestions.push(suggestion)",
  "                                if((line == lineNumber) && (i == (linePosition - 2))) then {",
  "                                    errormessages.syntaxError(\"For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                                        line, i)withSuggestions(suggestions)",
  "                                } else {",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.insert(\"}\")atPosition(linePosition - accum.size - 1)onLine(lineNumber)",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A string interpolation must end with a '}'. For a '\\{' character in a string use '\\\\\\{'.\")atPosition(",
  "                                        lineNumber, linePosition - accum.size - 1)withSuggestions(suggestions)",
  "                                }",
  "                            } else {",
  "                                def errorLine = util.lines.at(lineNumber)",
  "                                def nextLine = if(util.lines.size >= (lineNumber + 1)) then {",
  "                                    util.lines.at(lineNumber + 1)",
  "                                } else {",
  "                                    \"\"",
  "                                }",
  "                                // Count the number of literal quotes in the next line.",
  "                                var i := 1",
  "                                var count := 0",
  "                                while { i <= nextLine.size } do {",
  "                                    if(nextLine[i] == \"\\\"\") then { count := count + 1 }",
  "                                    elseif(nextLine[i] == \"\\\\\") then { i := i + 1 }",
  "                                    i := i + 1",
  "                                }",
  "                                if ((count % 2) == 1) then {",
  "                                    def suggestions = []",
  "                                    var suggestion := errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ nextLine)",
  "                                    suggestion.addLine(lineNumber + 1, \"\")",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                                    suggestion.addLine(lineNumber + 1, \"    ++ \\\"\" ++ nextLine)",
  "                                    suggestions.push(suggestion)",
  "                                    suggestion := errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ \"\\\\n\" ++ nextLine)",
  "                                    suggestion.addLine(lineNumber + 1, \"\")",
  "                                    suggestions.push(suggestion)",
  "                                    errormessages.syntaxError(\"A string must end with a '\\\"'. To insert a newline in a string use '\\\\n'. \"",
  "                                        ++ \"To split a string over multiple lines use '++' to join strings together.\")atRange(",
  "                                        lineNumber, linePosition, linePosition)withSuggestions(suggestions)",
  "                                } else {",
  "                                    def suggestion = errormessages.suggestion.new",
  "                                    suggestion.addLine(lineNumber, errorLine ++ \"\\\"\")",
  "                                    errormessages.syntaxError(\"A string must end with a '\\\"'.\")atPosition(",
  "                                        lineNumber, linePosition)withSuggestion(suggestion)",
  "                                }",
  "                            }",
  "                        }",
  "                        if (escaped) then {",
  "                            if (c == \"n\") then {",
  "                                // Newline escape",
  "                                accum := accum ++ \"\\u000a\"",
  "                            } elseif (c == \"u\") then {",
  "                                // Beginning of a four-digit Unicode escape",
  "                                // (for a BMP codepoint).",
  "                                unichars := 4",
  "                                codepoint := 0",
  "                            } elseif (c == \"U\") then {",
  "                                // Beginning of a six-digit Unicode escape",
  "                                // (for a general codepoint).",
  "                                unichars := 6",
  "                                codepoint := 0",
  "                            } elseif (c == \"t\") then {",
  "                                // Tab escape",
  "                                accum := accum ++ \"\\u0009\"",
  "                            } elseif (c == \"r\") then {",
  "                                // Carriage return escape",
  "                                accum := accum ++ \"\\u000d\"",
  "                            } elseif (c == \"b\") then {",
  "                                // Backspace escape",
  "                                accum := accum ++ \"\\u0008\"",
  "                            } elseif (c == \"l\") then {",
  "                                // LINE SEPARATOR escape",
  "                                accum := accum ++ \"\\u2028\"",
  "                            } elseif (c == \"f\") then {",
  "                                // Form feed/\"page down\" escape",
  "                                accum := accum ++ \"\\u000c\"",
  "                            } elseif (c == \"e\") then {",
  "                                // Escape escape",
  "                                accum := accum ++ \"\\u001b\"",
  "                            } else {",
  "                                // For any other character preceded by \\,",
  "                                // insert it literally.",
  "                                accum := accum ++ c",
  "                            }",
  "                            escaped := false",
  "                        } elseif (c == \"\\\\\") then {",
  "                            // Begin an escape sequence",
  "                            escaped := true",
  "                        } elseif (unichars > 0) then {",
  "                            // There are still hex digits to read for a",
  "                            // Unicode escape. Use the current character",
  "                            // as a hex digit and update the codepoint",
  "                            // being calculated with its value.",
  "                            unichars := unichars - 1",
  "                            codepoint := codepoint * 16",
  "                            codepoint := codepoint + hexdecchar(c)",
  "                            if (unichars == 0) then {",
  "                                // At the end of the sequence construct",
  "                                // the character in the unicode library.",
  "                                accum := accum ++ unicode.create(codepoint)",
  "                            }",
  "                        } elseif (c == \"\\{\") then {",
  "                            if (interpString.not) then {",
  "                                modechange(tokens, \"(\", \"(\")",
  "                                interpString := true",
  "                            }",
  "                            modechange(tokens, mode, accum)",
  "                            modechange(tokens, \"o\", \"++\")",
  "                            modechange(tokens, \"(\", \"(\")",
  "                            mode := \"n\"",
  "                            newmode := \"n\"",
  "                            accum := \"\"",
  "                            instr := false",
  "                            interpdepth := interpdepth + 1",
  "                        } else {",
  "                            accum := accum ++ c",
  "                        }",
  "                    } elseif ((c == \"\\n\") || (c == \"\\r\")) then {",
  "                        // Linebreaks terminate any open tokens",
  "                        modechange(tokens, mode, accum)",
  "                        mode := \"d\"",
  "                        newmode := \"d\"",
  "                        accum := \"\"",
  "                    } else {",
  "                        accum := accum ++ c",
  "                    }",
  "                    if (accum == \"...\") then {",
  "                        if (mode == \"o\") then {",
  "                            modechange(tokens, \"i\", \"...\")",
  "                            newmode := \"n\"",
  "                            mode := newmode",
  "                            accum := \"\"",
  "                        }",
  "                    }",
  "                    if (c == \"\\n\") then {",
  "                        // Linebreaks increment the line counter and insert a",
  "                        // special \"line\" token, which the parser can use to",
  "                        // track the origin of AST nodes for later error",
  "                        // reporting.",
  "                        lineNumber := lineNumber + 1",
  "                        linePosition := 0",
  "                        startPosition := 1",
  "                    }",
  "                }",
  "                for (input) do { c ->",
  "                    linePosition := linePosition + 1",
  "                    if (c == \" \") then {",
  "                        if (mode == \"d\") then {",
  "                        } else {",
  "                            if (mode != \"n\") then {",
  "                                mainBlock.apply(c)",
  "                            }",
  "                        }",
  "                    } else {",
  "                        mainBlock.apply(c)",
  "                    }",
  "                    prev := c",
  "                }",
  "                linePosition := linePosition + 1",
  "                if (instr) then {",
  "                    if (mode == \"\\\"\") then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        suggestion.addLine(lineNumber, util.lines.at(lineNumber) ++ \"\\\"\")",
  "                        errormessages.syntaxError(\"A string must end with a '\\\"'.\")atPosition(",
  "                            lineNumber, linePosition)withSuggestion(suggestion)",
  "                    }",
  "                    if (mode == \"x\") then {",
  "                        errormessages.syntaxError(\"Unfinished octets literal, expected '\\\"'.\")atPosition(lineNumber, linePosition)",
  "                    }",
  "                }",
  "                modechange(tokens, mode, accum)",
  "                tokens",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method Lexer {",
  "    LexerClass",
  "}",
  NULL
};
Object reader_lexer_outer_61(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_70(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_73(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_line_74(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_indent_75(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_linePos_76(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_next_77(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_lexer_next_77(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_lexer_prev_78(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_lexer_prev_78(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_lexer_outer_107(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_110(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_111(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_112(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_113(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_121(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_124(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_125(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_126(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_127(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_139(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_142(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_143(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_144(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_145(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_157(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_160(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_161(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_162(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_163(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_175(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_178(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_179(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_180(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_181(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_189(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_192(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_193(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_194(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_195(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_203(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_206(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_207(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_208(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_209(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_217(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_220(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_221(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_222(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_223(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_245(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_248(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_249(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_250(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_262(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_263(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_264(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_265(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_273(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_276(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_277(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_278(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_279(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_287(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_290(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_291(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_292(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_293(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_301(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_304(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_305(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_306(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_base_307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_size_308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_lexer_outer_317(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_320(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_321(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_322(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_323(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_331(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_334(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_335(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_336(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_337(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_345(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_348(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_349(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_350(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_351(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_359(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_362(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_363(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_364(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_365(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_373(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_376(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_377(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_378(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_379(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_390(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_391(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_392(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_393(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_401(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_404(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_kind_405(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_lexer_value_406(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_lexer_size_407(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_lexer_outer_415(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_outer_1752(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_first_1753(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_first_1753(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_lexer_last_1754(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_lexer_last_1754(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_lexer_size_39__1755(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_lexer_size_39__1755(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_lexer_outer_1863(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_lexer_n_1864(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_lexer_n_1864(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
static Object strlit2;
static Object strlit3;
static Object strlit4;
static Object strlit5;
static Object strlit6;
static Object strlit7;
static Object strlit8;
static Object strlit9;
static Object strlit10;
static Object strlit11;
static Object strlit12;
static Object strlit13;
static Object strlit14;
static Object strlit15;
static Object strlit16;
static Object strlit17;
Object module_io;
Object module_io_init();
Object module_sys;
Object module_sys_init();
Object module_util;
Object module_util_init();
Object module_unicode;
Object module_unicode_init();
Object module_mgcollections;
Object module_mgcollections_init();
Object module_errormessages;
Object module_errormessages_init();
static ClassData objclass60;
static Object strlit63;
static ClassData objclass69;
static ClassData objclass72;
static ClassData objclass106;
static ClassData objclass109;
static Object strlit116;
static ClassData objclass120;
static ClassData objclass123;
static Object strlit130;
static ClassData objclass138;
static ClassData objclass141;
static Object strlit148;
static ClassData objclass156;
static ClassData objclass159;
static Object strlit166;
static ClassData objclass174;
static ClassData objclass177;
static Object strlit184;
static Object strlit185;
static ClassData objclass188;
static ClassData objclass191;
static Object strlit198;
static Object strlit199;
static ClassData objclass202;
static ClassData objclass205;
static Object strlit212;
static Object strlit213;
static ClassData objclass216;
static ClassData objclass219;
static Object strlit226;
static Object strlit227;
static ClassData objclass230;
static ClassData objclass233;
static Object strlit240;
static Object strlit241;
static ClassData objclass244;
static ClassData objclass247;
static Object strlit254;
static Object strlit255;
static ClassData objclass258;
static ClassData objclass261;
static Object strlit268;
static Object strlit269;
static ClassData objclass272;
static ClassData objclass275;
static Object strlit282;
static Object strlit283;
static ClassData objclass286;
static ClassData objclass289;
static Object strlit296;
static Object strlit297;
static ClassData objclass300;
static ClassData objclass303;
static Object strlit311;
static ClassData objclass316;
static ClassData objclass319;
static Object strlit326;
static ClassData objclass330;
static ClassData objclass333;
static Object strlit340;
static ClassData objclass344;
static ClassData objclass347;
static Object strlit354;
static Object strlit355;
static ClassData objclass358;
static ClassData objclass361;
static Object strlit368;
static Object strlit369;
static ClassData objclass372;
static ClassData objclass375;
static Object strlit382;
static Object strlit383;
static ClassData objclass386;
static ClassData objclass389;
static Object strlit396;
static Object strlit397;
static ClassData objclass400;
static ClassData objclass403;
static Object strlit410;
static Object strlit411;
static ClassData objclass414;
static Object strlit429;
static Object strlit435;
static Object strlit444;
static Object strlit450;
static Object strlit456;
static Object strlit462;
static Object strlit468;
static Object strlit474;
static Object strlit480;
static Object strlit486;
static Object strlit492;
static Object strlit498;
static Object strlit504;
static Object strlit509;
static Object strlit532;
static Object strlit544;
static Object strlit556;
static Object strlit568;
static Object strlit580;
static Object strlit592;
static Object strlit604;
static Object strlit616;
static Object strlit628;
static Object strlit640;
static Object strlit652;
static Object strlit664;
static Object strlit676;
static Object strlit688;
static Object strlit700;
static Object strlit708;
static Object strlit727;
static Object strlit759;
static Object strlit805;
static Object strlit853;
static Object strlit861;
static Object strlit873;
static Object strlit887;
static Object strlit893;
static Object strlit895;
static Object strlit907;
static Object strlit916;
static Object strlit929;
static Object strlit936;
static Object strlit944;
static Object strlit954;
static Object strlit970;
static Object strlit990;
static Object strlit994;
static Object strlit1005;
static Object strlit1014;
static Object strlit1031;
static Object strlit1039;
static Object strlit1047;
static Object strlit1055;
static Object strlit1067;
static Object strlit1079;
static Object strlit1086;
static Object strlit1102;
static Object strlit1107;
static Object strlit1124;
static Object strlit1129;
static Object strlit1133;
static Object strlit1204;
static Object strlit1215;
static Object strlit1227;
static Object strlit1280;
static Object strlit1288;
static Object strlit1292;
static Object strlit1302;
static Object strlit1307;
static Object strlit1312;
static Object strlit1317;
static Object strlit1321;
static Object strlit1359;
static Object strlit1370;
static Object strlit1412;
static Object strlit1440;
static Object strlit1444;
static Object strlit1465;
static Object strlit1480;
static Object strlit1514;
static Object strlit1519;
static Object strlit1562;
static Object strlit1568;
static Object strlit1574;
static Object strlit1580;
static Object strlit1586;
static Object strlit1592;
static Object strlit1598;
static Object strlit1604;
static Object strlit1610;
static Object strlit1616;
static Object strlit1622;
static Object strlit1627;
static Object strlit1648;
static Object strlit1654;
static Object strlit1658;
static Object strlit1659;
static Object strlit1660;
static Object strlit1669;
static Object strlit1674;
static Object strlit1682;
static Object strlit1684;
static Object strlit1688;
static Object strlit1693;
static Object strlit1697;
static Object strlit1702;
static Object strlit1708;
static Object strlit1712;
static Object strlit1717;
static Object strlit1737;
static ClassData objclass1751;
static ClassData objclass1862;
static Object strlit1899;
static Object strlit1903;
static Object strlit1905;
static Object strlit1914;
static Object strlit1917;
static Object strlit1923;
static Object strlit1929;
static Object strlit1932;
static Object strlit1935;
static Object strlit1938;
static Object strlit1941;
static Object strlit1944;
static Object strlit1947;
static Object strlit1950;
static Object strlit1953;
static Object strlit1958;
static Object strlit1961;
static Object strlit1964;
static Object strlit1967;
static Object strlit1970;
static Object strlit1973;
static Object strlit1977;
static Object strlit1978;
static Object strlit1984;
static Object strlit1987;
static Object strlit1990;
static Object strlit1993;
static Object strlit1996;
static Object strlit1999;
static Object strlit2002;
static Object strlit2005;
static Object strlit2008;
static Object strlit2011;
static Object strlit2016;
static Object strlit2019;
static Object strlit2022;
static Object strlit2025;
static Object strlit2028;
static Object strlit2031;
static Object strlit2034;
static Object strlit2037;
static Object strlit2040;
static Object strlit2043;
static Object strlit2047;
static Object strlit2048;
static Object strlit2050;
static Object strlit2053;
static Object strlit2056;
static Object strlit2059;
static Object strlit2062;
static Object strlit2065;
static Object strlit2068;
static Object strlit2071;
static Object strlit2074;
static Object strlit2077;
static Object strlit2080;
static Object strlit2083;
static Object strlit2088;
static Object strlit2091;
static Object strlit2094;
static Object strlit2099;
static Object strlit2102;
static Object strlit2107;
static Object strlit2118;
static Object strlit2128;
static Object strlit2136;
static Object strlit2143;
static Object strlit2149;
static Object strlit2157;
static Object strlit2165;
static Object strlit2168;
static Object strlit2170;
static Object strlit2177;
static Object strlit2182;
static Object strlit2190;
static Object strlit2197;
static Object strlit2203;
static Object strlit2211;
static Object strlit2219;
static Object strlit2222;
static Object strlit2225;
static Object strlit2228;
static Object strlit2231;
static Object strlit2239;
static Object strlit2247;
static Object strlit2253;
static Object strlit2267;
static Object strlit2270;
static Object strlit2278;
static Object strlit2286;
static Object strlit2292;
static Object strlit2309;
static Object strlit2317;
static Object strlit2324;
static Object strlit2330;
static Object strlit2338;
static Object strlit2346;
static Object strlit2349;
static Object strlit2352;
static Object strlit2355;
static Object strlit2363;
static Object strlit2371;
static Object strlit2377;
static Object strlit2392;
static Object strlit2395;
static Object strlit2403;
static Object strlit2411;
static Object strlit2417;
static Object strlit2432;
static Object strlit2435;
static Object strlit2444;
static Object strlit2449;
static Object strlit2456;
static Object strlit2461;
static Object strlit2465;
static Object strlit2469;
static Object strlit2472;
static Object strlit2479;
static Object strlit2498;
static Object strlit2501;
static Object strlit2505;
static Object strlit2520;
static Object strlit2534;
static Object strlit2539;
static Object strlit2544;
static Object strlit2548;
static Object strlit2553;
static Object strlit2562;
static Object strlit2567;
static Object strlit2572;
static Object strlit2580;
static Object strlit2585;
static Object strlit2590;
static Object strlit2620;
static Object strlit2623;
static Object strlit2626;
static Object strlit2633;
static Object strlit2636;
static Object strlit2640;
static Object strlit2645;
static Object strlit2648;
static Object strlit2653;
static Object strlit2656;
static Object strlit2660;
static Object strlit2661;
static Object strlit2663;
static Object strlit2667;
static Object strlit2672;
static Object strlit2675;
static Object strlit2680;
static Object strlit2714;
static Object strlit2719;
static Object strlit2722;
static Object strlit2730;
static Object strlit2738;
static Object strlit2744;
static Object strlit2753;
static Object strlit2758;
static Object strlit2764;
static Object strlit2772;
static Object strlit2773;
static Object strlit2791;
static Object strlit2796;
static Object strlit2823;
static Object strlit2830;
static Object strlit2831;
static Object strlit2834;
static Object strlit2835;
static Object strlit2837;
static Object strlit2848;
static Object strlit2856;
static Object strlit2858;
static Object strlit2860;
static Object strlit2865;
static Object strlit2883;
static Object strlit2924;
static Object strlit2943;
static Object strlit2951;
static Object strlit2965;
static Object strlit3000;
static Object strlit3016;
static Object strlit3027;
static Object strlit3067;
static Object strlit3078;
static Object strlit3089;
static Object strlit3103;
static Object strlit3113;
static Object strlit3119;
static Object strlit3121;
static Object strlit3130;
static Object strlit3135;
static Object strlit3140;
static Object strlit3144;
static Object strlit3150;
static Object strlit3159;
static Object strlit3168;
static Object strlit3172;
static Object strlit3178;
static Object strlit3182;
static Object strlit3188;
static Object strlit3192;
static Object strlit3198;
static Object strlit3202;
static Object strlit3208;
static Object strlit3212;
static Object strlit3218;
static Object strlit3222;
static Object strlit3234;
static Object strlit3277;
static Object strlit3284;
static Object strlit3285;
static Object strlit3292;
static Object strlit3293;
static Object strlit3296;
static Object strlit3297;
static Object strlit3299;
static Object strlit3301;
static Object strlit3303;
static Object strlit3319;
static Object strlit3324;
static Object strlit3330;
static Object strlit3332;
static Object strlit3334;
static Object strlit3342;
static Object strlit3347;
static Object strlit3351;
static Object strlit3352;
static Object strlit3354;
static Object strlit3357;
static Object strlit3361;
static Object strlit3384;
static Object strlit3389;
static Object strlit3394;
static Object strlit3412;
static Object strlit3421;
static Object strlit3430;
static Object strlit3434;
static Object strlit3438;
Object meth_lexer__apply22(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_c = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object *var_ret = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_cr = &(stackframe->slots[0]);
  *var_cr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_right_24 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cr (depth = 6)
  int op_slot_left_24 = gc_frame_newslot(*var_cr);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult26 = callmethod(*var_cr, "==", 1, partcv, params);
// compiled op node returning opresult26 (depth = 5)
  Object if23 = done;
  if (istrue(opresult26)) {
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  *var_ret = *var_i;
  if (*var_i == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if23 = done;
  } else {
  }
// compiled if node returning if23 (depth = 4)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num29 = alloc_Float64(1);
// compiled num node returning num29 (depth = 6)
  int op_slot_right_28 = gc_frame_newslot(num29);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_28 = gc_frame_newslot(*var_i);
  params[0] = num29;
  partcv[0] = 1;
  Object sum31 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum31 (depth = 5)
  *var_i = sum31;
  if (sum31 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_hexdecchar0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hexdecchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method hexdecchar");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hexdecchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for hexdecchar");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_chars = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "chars");
  Object *var_ret = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ret");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1 = alloc_BuiltinList();
  gc_pause();
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit2 == NULL) {
    strlit2 = alloc_String("0");
    gc_root(strlit2);
  }
// compiled string node returning strlit2 (depth = 4)
  params[0] = strlit2;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit3 == NULL) {
    strlit3 = alloc_String("1");
    gc_root(strlit3);
  }
// compiled string node returning strlit3 (depth = 4)
  params[0] = strlit3;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit4 == NULL) {
    strlit4 = alloc_String("2");
    gc_root(strlit4);
  }
// compiled string node returning strlit4 (depth = 4)
  params[0] = strlit4;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit5 == NULL) {
    strlit5 = alloc_String("3");
    gc_root(strlit5);
  }
// compiled string node returning strlit5 (depth = 4)
  params[0] = strlit5;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit6 == NULL) {
    strlit6 = alloc_String("4");
    gc_root(strlit6);
  }
// compiled string node returning strlit6 (depth = 4)
  params[0] = strlit6;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit7 == NULL) {
    strlit7 = alloc_String("5");
    gc_root(strlit7);
  }
// compiled string node returning strlit7 (depth = 4)
  params[0] = strlit7;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit8 == NULL) {
    strlit8 = alloc_String("6");
    gc_root(strlit8);
  }
// compiled string node returning strlit8 (depth = 4)
  params[0] = strlit8;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit9 == NULL) {
    strlit9 = alloc_String("7");
    gc_root(strlit9);
  }
// compiled string node returning strlit9 (depth = 4)
  params[0] = strlit9;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit10 == NULL) {
    strlit10 = alloc_String("8");
    gc_root(strlit10);
  }
// compiled string node returning strlit10 (depth = 4)
  params[0] = strlit10;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit11 == NULL) {
    strlit11 = alloc_String("9");
    gc_root(strlit11);
  }
// compiled string node returning strlit11 (depth = 4)
  params[0] = strlit11;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit12 == NULL) {
    strlit12 = alloc_String("a");
    gc_root(strlit12);
  }
// compiled string node returning strlit12 (depth = 4)
  params[0] = strlit12;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit13 == NULL) {
    strlit13 = alloc_String("b");
    gc_root(strlit13);
  }
// compiled string node returning strlit13 (depth = 4)
  params[0] = strlit13;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit14 == NULL) {
    strlit14 = alloc_String("c");
    gc_root(strlit14);
  }
// compiled string node returning strlit14 (depth = 4)
  params[0] = strlit14;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit15 == NULL) {
    strlit15 = alloc_String("d");
    gc_root(strlit15);
  }
// compiled string node returning strlit15 (depth = 4)
  params[0] = strlit15;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit16 == NULL) {
    strlit16 = alloc_String("e");
    gc_root(strlit16);
  }
// compiled string node returning strlit16 (depth = 4)
  params[0] = strlit16;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit17 == NULL) {
    strlit17 = alloc_String("f");
    gc_root(strlit17);
  }
// compiled string node returning strlit17 (depth = 4)
  params[0] = strlit17;
  partcv[0] = 1;
  callmethod(array1, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array1 (depth = 3)
  *var_chars = array1;
  if (array1 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num18 = alloc_Float64(0);
// compiled num node returning num18 (depth = 3)
  *var_ret = num18;
  if (num18 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num19 = alloc_Float64(0);
// compiled num node returning num19 (depth = 3)
  *var_i = num19;
  if (num19 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe20 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_chars (depth = 3)
  gc_frame_newslot(*var_chars);
// starting to compile block node (depth = 3)
  Object block21 = alloc_Block(NULL, NULL, "lexer", 15);
  gc_frame_newslot(block21);
// method _apply
  block_savedest(block21);
  Object closure22 = createclosure(4, "_apply");
  setclosureframe(closure22, stackframe);
  addtoclosure(closure22, var_c);
  addtoclosure(closure22, var_i);
  addtoclosure(closure22, var_ret);
  addtoclosure(closure22, selfslot);
  struct UserObject *uo22 = (struct UserObject*)block21;
  uo22->data[0] = (Object)closure22;
  Method *meth_meth_lexer__apply22 = addmethod2pos(block21, "_apply", &meth_lexer__apply22, 0);
  int argcv_meth_lexer__apply22[] = {1};
  meth_meth_lexer__apply22->type = alloc_MethodType(1, argcv_meth_lexer__apply22);
  meth_meth_lexer__apply22->definitionModule = modulename;
  meth_meth_lexer__apply22->definitionLine = 1062;
// compiled block node returning block21 (depth = 3)
  gc_frame_newslot(block21);
// call case 5: prelude request
  params[0] = *var_chars;
  params[1] = block21;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call34 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe20);
// compiled call node returning call34 (depth = 2)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_lexer__apply44(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_l = getfromclosure(closure, 0);
  Object *var_s_39_ = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_l (depth = 5)
  int op_slot_right_45 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe47 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s_39_ (depth = 7)
  partcv[0] = 0;
  Object call48 = callmethod(*var_s_39_, "size",
    1, partcv, params);
  gc_frame_end(callframe47);
// compiled call node returning call48 (depth = 6)
// compiled member node returning call48 (depth = 5)
  int op_slot_left_45 = gc_frame_newslot(call48);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult49 = callmethod(call48, "<", 1, partcv, params);
// compiled op node returning opresult49 (depth = 4)
  gc_frame_end(frame);
  return opresult49;
}
Object meth_lexer__apply52(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s_39_ = getfromclosure(closure, 0);
  Object *var_w = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s_39_ (depth = 6)
  int op_slot_right_53 = gc_frame_newslot(*var_s_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_w (depth = 6)
  int op_slot_left_53 = gc_frame_newslot(*var_w);
  params[0] = *var_s_39_;
  partcv[0] = 1;
  Object opresult55 = callmethod(*var_w, "++", 1, partcv, params);
// compiled op node returning opresult55 (depth = 5)
  *var_s_39_ = opresult55;
  if (opresult55 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_padl35(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "padl");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method padl");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for padl (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_w = &(stackframe->slots[2]);
  *var_w = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for padl");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s'");
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  int op_slot_right_37 = gc_frame_newslot(*var_l);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe39 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call40 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe39);
// compiled call node returning call40 (depth = 5)
// compiled member node returning call40 (depth = 4)
  int op_slot_left_37 = gc_frame_newslot(call40);
  params[0] = *var_l;
  partcv[0] = 1;
  Object opresult41 = callmethod(call40, ">=", 1, partcv, params);
// compiled op node returning opresult41 (depth = 3)
  Object if36 = done;
  if (istrue(opresult41)) {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  return *var_s;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if36 = undefined;
  } else {
  }
// compiled if node returning if36 (depth = 2)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  *var_s_39_ = *var_s;
  if (*var_s == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe42 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block43 = alloc_Block(NULL, NULL, "lexer", 28);
  gc_frame_newslot(block43);
// method _apply
  block_savedest(block43);
  Object closure44 = createclosure(3, "_apply");
  setclosureframe(closure44, stackframe);
  addtoclosure(closure44, var_l);
  addtoclosure(closure44, var_s_39_);
  addtoclosure(closure44, selfslot);
  struct UserObject *uo44 = (struct UserObject*)block43;
  uo44->data[0] = (Object)closure44;
  Method *meth_meth_lexer__apply44 = addmethod2pos(block43, "_apply", &meth_lexer__apply44, 0);
  int argcv_meth_lexer__apply44[] = {0};
  meth_meth_lexer__apply44->type = alloc_MethodType(1, argcv_meth_lexer__apply44);
  meth_meth_lexer__apply44->definitionModule = modulename;
  meth_meth_lexer__apply44->definitionLine = 24;
// compiled block node returning block43 (depth = 3)
  gc_frame_newslot(block43);
// starting to compile block node (depth = 3)
  Object block51 = alloc_Block(NULL, NULL, "lexer", 28);
  gc_frame_newslot(block51);
// method _apply
  block_savedest(block51);
  Object closure52 = createclosure(3, "_apply");
  setclosureframe(closure52, stackframe);
  addtoclosure(closure52, var_s_39_);
  addtoclosure(closure52, var_w);
  addtoclosure(closure52, selfslot);
  struct UserObject *uo52 = (struct UserObject*)block51;
  uo52->data[0] = (Object)closure52;
  Method *meth_meth_lexer__apply52 = addmethod2pos(block51, "_apply", &meth_lexer__apply52, 0);
  int argcv_meth_lexer__apply52[] = {0};
  meth_meth_lexer__apply52->type = alloc_MethodType(1, argcv_meth_lexer__apply52);
  meth_meth_lexer__apply52->definitionModule = modulename;
  meth_meth_lexer__apply52->definitionLine = 28;
// compiled block node returning block51 (depth = 3)
  gc_frame_newslot(block51);
// call case 5: prelude request
  params[0] = block43;
  params[1] = block51;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call58 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe42);
// compiled call node returning call58 (depth = 2)
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s_39_ (depth = 3)
  return *var_s_39_;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer_Lexer59(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Lexer");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_LexerClass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for Lexer (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for Lexer");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_LexerClass (depth = 2)
  gc_frame_end(frame);
  return *var_LexerClass;
}
Object meth_lexer_asString62(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit63 == NULL) {
    strlit63 = alloc_String("LexerClass object");
    gc_root(strlit63);
  }
// compiled string node returning strlit63 (depth = 3)
  gc_frame_end(frame);
  return strlit63;
}
Object meth_lexer__61__61_79(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool82 = alloc_Boolean(0);
// compiled identifier node returning bool82 (depth = 8)
  int op_slot_right_81 = gc_frame_newslot(bool82);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  int op_slot_left_81 = gc_frame_newslot(*var_other);
  params[0] = bool82;
  partcv[0] = 1;
  Object opresult84 = callmethod(*var_other, "==", 1, partcv, params);
// compiled op node returning opresult84 (depth = 7)
  Object if80 = done;
  if (istrue(opresult84)) {
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool85 = alloc_Boolean(0);
// compiled identifier node returning bool85 (depth = 7)
    gc_frame_newslot(bool85);
    if80 = bool85;
  } else {
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe88 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call89 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe88);
// compiled call node returning call89 (depth = 10)
// compiled member node returning call89 (depth = 9)
  int op_slot_right_87 = gc_frame_newslot(call89);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe91 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_other (depth = 11)
  partcv[0] = 0;
  Object call92 = callmethod(*var_other, "linePos",
    1, partcv, params);
  gc_frame_end(callframe91);
// compiled call node returning call92 (depth = 10)
// compiled member node returning call92 (depth = 9)
  int op_slot_left_87 = gc_frame_newslot(call92);
  params[0] = call89;
  partcv[0] = 1;
  Object opresult93 = callmethod(call92, "==", 1, partcv, params);
// compiled op node returning opresult93 (depth = 8)
  int op_slot_right_86 = gc_frame_newslot(opresult93);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe96 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call97 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe96);
// compiled call node returning call97 (depth = 10)
// compiled member node returning call97 (depth = 9)
  int op_slot_right_95 = gc_frame_newslot(call97);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe99 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_other (depth = 11)
  partcv[0] = 0;
  Object call100 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 10)
// compiled member node returning call100 (depth = 9)
  int op_slot_left_95 = gc_frame_newslot(call100);
  params[0] = call97;
  partcv[0] = 1;
  Object opresult101 = callmethod(call100, "==", 1, partcv, params);
// compiled op node returning opresult101 (depth = 8)
  int op_slot_left_86 = gc_frame_newslot(opresult101);
  params[0] = opresult93;
  partcv[0] = 1;
  Object opresult102 = callmethod(opresult101, "&&", 1, partcv, params);
// compiled op node returning opresult102 (depth = 7)
    gc_frame_newslot(opresult102);
    if80 = opresult102;
  }
// compiled if node returning if80 (depth = 6)
  gc_frame_end(frame);
  return if80;
}
Object meth_lexer_new71(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_indentLevel = getfromclosure(closure, 1);
  Object *var_startPosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject72 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj72 = alloc_userobj2(8,7, objclass72);
  gc_frame_newslot(obj72);
if (objclass72 == NULL) {
  glfree(obj72->class->name);
  obj72->class->name = "Token";
}
// OBJECT OUTER DEC outer
  adddatum2(obj72, self, 0);
  addmethodreal(obj72,"outer", &reader_lexer_outer_73);
  Object oldself72 = self;
  struct StackFrameObject *oldstackframe72 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe72);
  gc_frame_newslot((Object)stackframe);
  self = obj72;
  Object *oldselfslot72 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter72 = (*(struct UserObject *)self).data[0], lowerouter72 = thisouter72;
  if (inheritingObject72) {
    struct UserObject *inho72 = (struct UserObject *)inheritingObject72;
    while (inho72->super != GraceDefaultObject) inho72 = (struct UserObject *)inho72->super;
    inho72->super = obj72;
    self = inheritingObject72;
    *selfslot = self;
    lowerouter72 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter72;
  }
if (objclass72 == NULL) {
  Method *reader74 = addmethodrealflags(obj72, "line",&reader_lexer_line_74, MFLAG_DEF);
  reader74->definitionModule = modulename;
  reader74->definitionLine = 44;
}
adddatum2(obj72, alloc_Undefined(), 1);
if (objclass72 == NULL) {
  Method *reader75 = addmethodrealflags(obj72, "indent",&reader_lexer_indent_75, MFLAG_DEF);
  reader75->definitionModule = modulename;
  reader75->definitionLine = 45;
}
adddatum2(obj72, alloc_Undefined(), 2);
if (objclass72 == NULL) {
  Method *reader76 = addmethodrealflags(obj72, "linePos",&reader_lexer_linePos_76, MFLAG_DEF);
  reader76->definitionModule = modulename;
  reader76->definitionLine = 47;
}
adddatum2(obj72, alloc_Undefined(), 3);
if (objclass72 == NULL) {
  Method *reader77 = addmethodrealflags(obj72, "next",&reader_lexer_next_77, 0);
  Method *writer77 = addmethodrealflags(obj72, "next:=",&writer_lexer_next_77, 0);
  reader77->definitionModule = modulename;
  writer77->definitionModule = modulename;
  reader77->definitionLine = 48;
  writer77->definitionLine = 48;
}
obj72->flags |= OFLAG_MUTABLE;
adddatum2(obj72, alloc_Undefined(), 4);
if (objclass72 == NULL) {
  Method *reader78 = addmethodrealflags(obj72, "prev",&reader_lexer_prev_78, 0);
  Method *writer78 = addmethodrealflags(obj72, "prev:=",&writer_lexer_prev_78, 0);
  reader78->definitionModule = modulename;
  writer78->definitionModule = modulename;
  reader78->definitionLine = 50;
  writer78->definitionLine = 50;
}
obj72->flags |= OFLAG_MUTABLE;
adddatum2(obj72, alloc_Undefined(), 5);
// method ==
  struct UserObject *uo79 = (struct UserObject*)obj72;
  uo79->data[6] = emptyclosure;
  Method *meth_meth_lexer__61__61_79 = addmethod2pos(obj72, "==", &meth_lexer__61__61_79, 6);
  int argcv_meth_lexer__61__61_79[] = {1};
  meth_meth_lexer__61__61_79->type = alloc_MethodType(1, argcv_meth_lexer__61__61_79);
  meth_meth_lexer__61__61_79->definitionModule = modulename;
  meth_meth_lexer__61__61_79->definitionLine = 50;
  sourceObject = obj72;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  adddatum2(obj72, *var_lineNumber, 1);
  sourceObject = obj72;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indentLevel (depth = 6)
  adddatum2(obj72, *var_indentLevel, 2);
  sourceObject = obj72;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPosition (depth = 6)
  adddatum2(obj72, *var_startPosition, 3);
  sourceObject = obj72;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool103 = alloc_Boolean(0);
// compiled identifier node returning bool103 (depth = 6)
  adddatum2(obj72, bool103, 4);
  sourceObject = obj72;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool104 = alloc_Boolean(0);
// compiled identifier node returning bool104 (depth = 6)
  adddatum2(obj72, bool104, 5);
  sourceObject = obj72;
objclass72 = obj72->class;
  objclass72->definitionModule = modulename;
  objclass72->definitionLine = 42;
  (*(struct UserObject *)self).data[0] = lowerouter72;
  self = oldself72;
  selfslot = oldselfslot72;
  stackframe = oldstackframe72;
  gc_frame_end(frame);
  return obj72;
}
Object meth_lexer_new71_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object *var_indentLevel = getfromclosure(closure, 1);
  Object *var_startPosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject72 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj72 = alloc_userobj2(8,7, objclass72);
  gc_frame_newslot(obj72);
if (objclass72 == NULL) {
  glfree(obj72->class->name);
  obj72->class->name = "Token";
}
// OBJECT OUTER DEC outer
  adddatum2(obj72, self, 0);
  addmethodreal(obj72,"outer", &reader_lexer_outer_73);
  Object oldself72 = self;
  struct StackFrameObject *oldstackframe72 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe72);
  gc_frame_newslot((Object)stackframe);
  self = obj72;
  Object *oldselfslot72 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter72 = (*(struct UserObject *)self).data[0], lowerouter72 = thisouter72;
  if (inheritingObject72) {
    struct UserObject *inho72 = (struct UserObject *)inheritingObject72;
    while (inho72->super != GraceDefaultObject) inho72 = (struct UserObject *)inho72->super;
    inho72->super = obj72;
    self = inheritingObject72;
    *selfslot = self;
    lowerouter72 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter72;
  }
if (objclass72 == NULL) {
  Method *reader74 = addmethodrealflags(obj72, "line",&reader_lexer_line_74, MFLAG_DEF);
  reader74->definitionModule = modulename;
  reader74->definitionLine = 44;
}
adddatum2(obj72, alloc_Undefined(), 1);
if (objclass72 == NULL) {
  Method *reader75 = addmethodrealflags(obj72, "indent",&reader_lexer_indent_75, MFLAG_DEF);
  reader75->definitionModule = modulename;
  reader75->definitionLine = 45;
}
adddatum2(obj72, alloc_Undefined(), 2);
if (objclass72 == NULL) {
  Method *reader76 = addmethodrealflags(obj72, "linePos",&reader_lexer_linePos_76, MFLAG_DEF);
  reader76->definitionModule = modulename;
  reader76->definitionLine = 47;
}
adddatum2(obj72, alloc_Undefined(), 3);
if (objclass72 == NULL) {
  Method *reader77 = addmethodrealflags(obj72, "next",&reader_lexer_next_77, 0);
  Method *writer77 = addmethodrealflags(obj72, "next:=",&writer_lexer_next_77, 0);
  reader77->definitionModule = modulename;
  writer77->definitionModule = modulename;
  reader77->definitionLine = 48;
  writer77->definitionLine = 48;
}
obj72->flags |= OFLAG_MUTABLE;
adddatum2(obj72, alloc_Undefined(), 4);
if (objclass72 == NULL) {
  Method *reader78 = addmethodrealflags(obj72, "prev",&reader_lexer_prev_78, 0);
  Method *writer78 = addmethodrealflags(obj72, "prev:=",&writer_lexer_prev_78, 0);
  reader78->definitionModule = modulename;
  writer78->definitionModule = modulename;
  reader78->definitionLine = 50;
  writer78->definitionLine = 50;
}
obj72->flags |= OFLAG_MUTABLE;
adddatum2(obj72, alloc_Undefined(), 5);
// method ==
  struct UserObject *uo79 = (struct UserObject*)obj72;
  uo79->data[6] = emptyclosure;
  Method *meth_meth_lexer__61__61_79 = addmethod2pos(obj72, "==", &meth_lexer__61__61_79, 6);
  int argcv_meth_lexer__61__61_79[] = {1};
  meth_meth_lexer__61__61_79->type = alloc_MethodType(1, argcv_meth_lexer__61__61_79);
  meth_meth_lexer__61__61_79->definitionModule = modulename;
  meth_meth_lexer__61__61_79->definitionLine = 50;
  sourceObject = obj72;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  adddatum2(obj72, *var_lineNumber, 1);
  sourceObject = obj72;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indentLevel (depth = 6)
  adddatum2(obj72, *var_indentLevel, 2);
  sourceObject = obj72;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPosition (depth = 6)
  adddatum2(obj72, *var_startPosition, 3);
  sourceObject = obj72;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool103 = alloc_Boolean(0);
// compiled identifier node returning bool103 (depth = 6)
  adddatum2(obj72, bool103, 4);
  sourceObject = obj72;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool104 = alloc_Boolean(0);
// compiled identifier node returning bool104 (depth = 6)
  adddatum2(obj72, bool104, 5);
  sourceObject = obj72;
objclass72 = obj72->class;
  objclass72->definitionModule = modulename;
  objclass72->definitionLine = 42;
  (*(struct UserObject *)self).data[0] = lowerouter72;
  self = oldself72;
  selfslot = oldselfslot72;
  stackframe = oldstackframe72;
  gc_frame_end(frame);
  return obj72;
}
Object meth_lexer_new108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject109 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj109 = alloc_userobj2(4,5, objclass109);
  gc_frame_newslot(obj109);
if (objclass109 == NULL) {
  glfree(obj109->class->name);
  obj109->class->name = "IdentifierToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj109, self, 0);
  addmethodreal(obj109,"outer", &reader_lexer_outer_110);
  Object oldself109 = self;
  struct StackFrameObject *oldstackframe109 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe109);
  gc_frame_newslot((Object)stackframe);
  self = obj109;
  Object *oldselfslot109 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter109 = (*(struct UserObject *)self).data[0], lowerouter109 = thisouter109;
  if (inheritingObject109) {
    struct UserObject *inho109 = (struct UserObject *)inheritingObject109;
    while (inho109->super != GraceDefaultObject) inho109 = (struct UserObject *)inho109->super;
    inho109->super = obj109;
    self = inheritingObject109;
    *selfslot = self;
    lowerouter109 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter109;
  }
if (objclass109 == NULL) {
  Method *reader111 = addmethodrealflags(obj109, "kind",&reader_lexer_kind_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 62;
}
adddatum2(obj109, alloc_Undefined(), 1);
if (objclass109 == NULL) {
  Method *reader112 = addmethodrealflags(obj109, "value",&reader_lexer_value_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 63;
}
adddatum2(obj109, alloc_Undefined(), 2);
if (objclass109 == NULL) {
  Method *reader113 = addmethodrealflags(obj109, "size",&reader_lexer_size_113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 64;
}
adddatum2(obj109, alloc_Undefined(), 3);
  sourceObject = obj109;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe114 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call115 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe114);
// compiled call node returning call115 (depth = 6)
  struct UserObject *obj109_uo = (struct UserObject *)obj109;
  obj109_uo->super = call115;
  sourceObject = obj109;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit116 == NULL) {
    strlit116 = alloc_String("identifier");
    gc_root(strlit116);
  }
// compiled string node returning strlit116 (depth = 6)
  adddatum2(obj109, strlit116, 1);
  sourceObject = obj109;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj109, *var_s, 2);
  sourceObject = obj109;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call118 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe117);
// compiled call node returning call118 (depth = 7)
// compiled member node returning call118 (depth = 6)
  adddatum2(obj109, call118, 3);
objclass109 = obj109->class;
  objclass109->definitionModule = modulename;
  objclass109->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter109;
  self = oldself109;
  selfslot = oldselfslot109;
  stackframe = oldstackframe109;
  gc_frame_end(frame);
  return obj109;
}
Object meth_lexer_new108_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject109 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj109 = alloc_userobj2(4,5, objclass109);
  gc_frame_newslot(obj109);
if (objclass109 == NULL) {
  glfree(obj109->class->name);
  obj109->class->name = "IdentifierToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj109, self, 0);
  addmethodreal(obj109,"outer", &reader_lexer_outer_110);
  Object oldself109 = self;
  struct StackFrameObject *oldstackframe109 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe109);
  gc_frame_newslot((Object)stackframe);
  self = obj109;
  Object *oldselfslot109 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter109 = (*(struct UserObject *)self).data[0], lowerouter109 = thisouter109;
  if (inheritingObject109) {
    struct UserObject *inho109 = (struct UserObject *)inheritingObject109;
    while (inho109->super != GraceDefaultObject) inho109 = (struct UserObject *)inho109->super;
    inho109->super = obj109;
    self = inheritingObject109;
    *selfslot = self;
    lowerouter109 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter109;
  }
if (objclass109 == NULL) {
  Method *reader111 = addmethodrealflags(obj109, "kind",&reader_lexer_kind_111, MFLAG_DEF);
  reader111->definitionModule = modulename;
  reader111->definitionLine = 62;
}
adddatum2(obj109, alloc_Undefined(), 1);
if (objclass109 == NULL) {
  Method *reader112 = addmethodrealflags(obj109, "value",&reader_lexer_value_112, MFLAG_DEF);
  reader112->definitionModule = modulename;
  reader112->definitionLine = 63;
}
adddatum2(obj109, alloc_Undefined(), 2);
if (objclass109 == NULL) {
  Method *reader113 = addmethodrealflags(obj109, "size",&reader_lexer_size_113, MFLAG_DEF);
  reader113->definitionModule = modulename;
  reader113->definitionLine = 64;
}
adddatum2(obj109, alloc_Undefined(), 3);
  sourceObject = obj109;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe114 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call115 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe114);
// compiled call node returning call115 (depth = 6)
  struct UserObject *obj109_uo = (struct UserObject *)obj109;
  obj109_uo->super = call115;
  sourceObject = obj109;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit116 == NULL) {
    strlit116 = alloc_String("identifier");
    gc_root(strlit116);
  }
// compiled string node returning strlit116 (depth = 6)
  adddatum2(obj109, strlit116, 1);
  sourceObject = obj109;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj109, *var_s, 2);
  sourceObject = obj109;
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  partcv[0] = 0;
  Object call118 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe117);
// compiled call node returning call118 (depth = 7)
// compiled member node returning call118 (depth = 6)
  adddatum2(obj109, call118, 3);
objclass109 = obj109->class;
  objclass109->definitionModule = modulename;
  objclass109->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter109;
  self = oldself109;
  selfslot = oldselfslot109;
  stackframe = oldstackframe109;
  gc_frame_end(frame);
  return obj109;
}
Object meth_lexer_new122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject123 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj123 = alloc_userobj2(4,5, objclass123);
  gc_frame_newslot(obj123);
if (objclass123 == NULL) {
  glfree(obj123->class->name);
  obj123->class->name = "StringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj123, self, 0);
  addmethodreal(obj123,"outer", &reader_lexer_outer_124);
  Object oldself123 = self;
  struct StackFrameObject *oldstackframe123 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe123);
  gc_frame_newslot((Object)stackframe);
  self = obj123;
  Object *oldselfslot123 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter123 = (*(struct UserObject *)self).data[0], lowerouter123 = thisouter123;
  if (inheritingObject123) {
    struct UserObject *inho123 = (struct UserObject *)inheritingObject123;
    while (inho123->super != GraceDefaultObject) inho123 = (struct UserObject *)inho123->super;
    inho123->super = obj123;
    self = inheritingObject123;
    *selfslot = self;
    lowerouter123 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter123;
  }
if (objclass123 == NULL) {
  Method *reader125 = addmethodrealflags(obj123, "kind",&reader_lexer_kind_125, MFLAG_DEF);
  reader125->definitionModule = modulename;
  reader125->definitionLine = 68;
}
adddatum2(obj123, alloc_Undefined(), 1);
if (objclass123 == NULL) {
  Method *reader126 = addmethodrealflags(obj123, "value",&reader_lexer_value_126, MFLAG_DEF);
  reader126->definitionModule = modulename;
  reader126->definitionLine = 69;
}
adddatum2(obj123, alloc_Undefined(), 2);
if (objclass123 == NULL) {
  Method *reader127 = addmethodrealflags(obj123, "size",&reader_lexer_size_127, MFLAG_DEF);
  reader127->definitionModule = modulename;
  reader127->definitionLine = 70;
}
adddatum2(obj123, alloc_Undefined(), 3);
  sourceObject = obj123;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe128 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call129 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe128);
// compiled call node returning call129 (depth = 6)
  struct UserObject *obj123_uo = (struct UserObject *)obj123;
  obj123_uo->super = call129;
  sourceObject = obj123;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit130 == NULL) {
    strlit130 = alloc_String("string");
    gc_root(strlit130);
  }
// compiled string node returning strlit130 (depth = 6)
  adddatum2(obj123, strlit130, 1);
  sourceObject = obj123;
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj123, *var_s, 2);
  sourceObject = obj123;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num132 = alloc_Float64(2);
// compiled num node returning num132 (depth = 7)
  int op_slot_right_131 = gc_frame_newslot(num132);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call135 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe134);
// compiled call node returning call135 (depth = 8)
// compiled member node returning call135 (depth = 7)
  int op_slot_left_131 = gc_frame_newslot(call135);
  params[0] = num132;
  partcv[0] = 1;
  Object sum136 = callmethod(call135, "+", 1, partcv, params);
// compiled op node returning sum136 (depth = 6)
  adddatum2(obj123, sum136, 3);
objclass123 = obj123->class;
  objclass123->definitionModule = modulename;
  objclass123->definitionLine = 65;
  (*(struct UserObject *)self).data[0] = lowerouter123;
  self = oldself123;
  selfslot = oldselfslot123;
  stackframe = oldstackframe123;
  gc_frame_end(frame);
  return obj123;
}
Object meth_lexer_new122_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject123 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj123 = alloc_userobj2(4,5, objclass123);
  gc_frame_newslot(obj123);
if (objclass123 == NULL) {
  glfree(obj123->class->name);
  obj123->class->name = "StringToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj123, self, 0);
  addmethodreal(obj123,"outer", &reader_lexer_outer_124);
  Object oldself123 = self;
  struct StackFrameObject *oldstackframe123 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe123);
  gc_frame_newslot((Object)stackframe);
  self = obj123;
  Object *oldselfslot123 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter123 = (*(struct UserObject *)self).data[0], lowerouter123 = thisouter123;
  if (inheritingObject123) {
    struct UserObject *inho123 = (struct UserObject *)inheritingObject123;
    while (inho123->super != GraceDefaultObject) inho123 = (struct UserObject *)inho123->super;
    inho123->super = obj123;
    self = inheritingObject123;
    *selfslot = self;
    lowerouter123 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter123;
  }
if (objclass123 == NULL) {
  Method *reader125 = addmethodrealflags(obj123, "kind",&reader_lexer_kind_125, MFLAG_DEF);
  reader125->definitionModule = modulename;
  reader125->definitionLine = 68;
}
adddatum2(obj123, alloc_Undefined(), 1);
if (objclass123 == NULL) {
  Method *reader126 = addmethodrealflags(obj123, "value",&reader_lexer_value_126, MFLAG_DEF);
  reader126->definitionModule = modulename;
  reader126->definitionLine = 69;
}
adddatum2(obj123, alloc_Undefined(), 2);
if (objclass123 == NULL) {
  Method *reader127 = addmethodrealflags(obj123, "size",&reader_lexer_size_127, MFLAG_DEF);
  reader127->definitionModule = modulename;
  reader127->definitionLine = 70;
}
adddatum2(obj123, alloc_Undefined(), 3);
  sourceObject = obj123;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe128 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call129 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe128);
// compiled call node returning call129 (depth = 6)
  struct UserObject *obj123_uo = (struct UserObject *)obj123;
  obj123_uo->super = call129;
  sourceObject = obj123;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit130 == NULL) {
    strlit130 = alloc_String("string");
    gc_root(strlit130);
  }
// compiled string node returning strlit130 (depth = 6)
  adddatum2(obj123, strlit130, 1);
  sourceObject = obj123;
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj123, *var_s, 2);
  sourceObject = obj123;
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num132 = alloc_Float64(2);
// compiled num node returning num132 (depth = 7)
  int op_slot_right_131 = gc_frame_newslot(num132);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call135 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe134);
// compiled call node returning call135 (depth = 8)
// compiled member node returning call135 (depth = 7)
  int op_slot_left_131 = gc_frame_newslot(call135);
  params[0] = num132;
  partcv[0] = 1;
  Object sum136 = callmethod(call135, "+", 1, partcv, params);
// compiled op node returning sum136 (depth = 6)
  adddatum2(obj123, sum136, 3);
objclass123 = obj123->class;
  objclass123->definitionModule = modulename;
  objclass123->definitionLine = 65;
  (*(struct UserObject *)self).data[0] = lowerouter123;
  self = oldself123;
  selfslot = oldselfslot123;
  stackframe = oldstackframe123;
  gc_frame_end(frame);
  return obj123;
}
Object meth_lexer_new140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject141 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj141 = alloc_userobj2(4,5, objclass141);
  gc_frame_newslot(obj141);
if (objclass141 == NULL) {
  glfree(obj141->class->name);
  obj141->class->name = "CommentToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj141, self, 0);
  addmethodreal(obj141,"outer", &reader_lexer_outer_142);
  Object oldself141 = self;
  struct StackFrameObject *oldstackframe141 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe141);
  gc_frame_newslot((Object)stackframe);
  self = obj141;
  Object *oldselfslot141 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter141 = (*(struct UserObject *)self).data[0], lowerouter141 = thisouter141;
  if (inheritingObject141) {
    struct UserObject *inho141 = (struct UserObject *)inheritingObject141;
    while (inho141->super != GraceDefaultObject) inho141 = (struct UserObject *)inho141->super;
    inho141->super = obj141;
    self = inheritingObject141;
    *selfslot = self;
    lowerouter141 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter141;
  }
if (objclass141 == NULL) {
  Method *reader143 = addmethodrealflags(obj141, "kind",&reader_lexer_kind_143, MFLAG_DEF);
  reader143->definitionModule = modulename;
  reader143->definitionLine = 74;
}
adddatum2(obj141, alloc_Undefined(), 1);
if (objclass141 == NULL) {
  Method *reader144 = addmethodrealflags(obj141, "value",&reader_lexer_value_144, MFLAG_DEF);
  reader144->definitionModule = modulename;
  reader144->definitionLine = 75;
}
adddatum2(obj141, alloc_Undefined(), 2);
if (objclass141 == NULL) {
  Method *reader145 = addmethodrealflags(obj141, "size",&reader_lexer_size_145, MFLAG_DEF);
  reader145->definitionModule = modulename;
  reader145->definitionLine = 76;
}
adddatum2(obj141, alloc_Undefined(), 3);
  sourceObject = obj141;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe146 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call147 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe146);
// compiled call node returning call147 (depth = 6)
  struct UserObject *obj141_uo = (struct UserObject *)obj141;
  obj141_uo->super = call147;
  sourceObject = obj141;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit148 == NULL) {
    strlit148 = alloc_String("comment");
    gc_root(strlit148);
  }
// compiled string node returning strlit148 (depth = 6)
  adddatum2(obj141, strlit148, 1);
  sourceObject = obj141;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj141, *var_s, 2);
  sourceObject = obj141;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num150 = alloc_Float64(2);
// compiled num node returning num150 (depth = 7)
  int op_slot_right_149 = gc_frame_newslot(num150);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call153 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe152);
// compiled call node returning call153 (depth = 8)
// compiled member node returning call153 (depth = 7)
  int op_slot_left_149 = gc_frame_newslot(call153);
  params[0] = num150;
  partcv[0] = 1;
  Object sum154 = callmethod(call153, "+", 1, partcv, params);
// compiled op node returning sum154 (depth = 6)
  adddatum2(obj141, sum154, 3);
objclass141 = obj141->class;
  objclass141->definitionModule = modulename;
  objclass141->definitionLine = 71;
  (*(struct UserObject *)self).data[0] = lowerouter141;
  self = oldself141;
  selfslot = oldselfslot141;
  stackframe = oldstackframe141;
  gc_frame_end(frame);
  return obj141;
}
Object meth_lexer_new140_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject141 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj141 = alloc_userobj2(4,5, objclass141);
  gc_frame_newslot(obj141);
if (objclass141 == NULL) {
  glfree(obj141->class->name);
  obj141->class->name = "CommentToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj141, self, 0);
  addmethodreal(obj141,"outer", &reader_lexer_outer_142);
  Object oldself141 = self;
  struct StackFrameObject *oldstackframe141 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe141);
  gc_frame_newslot((Object)stackframe);
  self = obj141;
  Object *oldselfslot141 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter141 = (*(struct UserObject *)self).data[0], lowerouter141 = thisouter141;
  if (inheritingObject141) {
    struct UserObject *inho141 = (struct UserObject *)inheritingObject141;
    while (inho141->super != GraceDefaultObject) inho141 = (struct UserObject *)inho141->super;
    inho141->super = obj141;
    self = inheritingObject141;
    *selfslot = self;
    lowerouter141 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter141;
  }
if (objclass141 == NULL) {
  Method *reader143 = addmethodrealflags(obj141, "kind",&reader_lexer_kind_143, MFLAG_DEF);
  reader143->definitionModule = modulename;
  reader143->definitionLine = 74;
}
adddatum2(obj141, alloc_Undefined(), 1);
if (objclass141 == NULL) {
  Method *reader144 = addmethodrealflags(obj141, "value",&reader_lexer_value_144, MFLAG_DEF);
  reader144->definitionModule = modulename;
  reader144->definitionLine = 75;
}
adddatum2(obj141, alloc_Undefined(), 2);
if (objclass141 == NULL) {
  Method *reader145 = addmethodrealflags(obj141, "size",&reader_lexer_size_145, MFLAG_DEF);
  reader145->definitionModule = modulename;
  reader145->definitionLine = 76;
}
adddatum2(obj141, alloc_Undefined(), 3);
  sourceObject = obj141;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe146 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call147 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe146);
// compiled call node returning call147 (depth = 6)
  struct UserObject *obj141_uo = (struct UserObject *)obj141;
  obj141_uo->super = call147;
  sourceObject = obj141;
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit148 == NULL) {
    strlit148 = alloc_String("comment");
    gc_root(strlit148);
  }
// compiled string node returning strlit148 (depth = 6)
  adddatum2(obj141, strlit148, 1);
  sourceObject = obj141;
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj141, *var_s, 2);
  sourceObject = obj141;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num150 = alloc_Float64(2);
// compiled num node returning num150 (depth = 7)
  int op_slot_right_149 = gc_frame_newslot(num150);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call153 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe152);
// compiled call node returning call153 (depth = 8)
// compiled member node returning call153 (depth = 7)
  int op_slot_left_149 = gc_frame_newslot(call153);
  params[0] = num150;
  partcv[0] = 1;
  Object sum154 = callmethod(call153, "+", 1, partcv, params);
// compiled op node returning sum154 (depth = 6)
  adddatum2(obj141, sum154, 3);
objclass141 = obj141->class;
  objclass141->definitionModule = modulename;
  objclass141->definitionLine = 71;
  (*(struct UserObject *)self).data[0] = lowerouter141;
  self = oldself141;
  selfslot = oldselfslot141;
  stackframe = oldstackframe141;
  gc_frame_end(frame);
  return obj141;
}
Object meth_lexer_new158(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject159 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj159 = alloc_userobj2(4,5, objclass159);
  gc_frame_newslot(obj159);
if (objclass159 == NULL) {
  glfree(obj159->class->name);
  obj159->class->name = "OctetsToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj159, self, 0);
  addmethodreal(obj159,"outer", &reader_lexer_outer_160);
  Object oldself159 = self;
  struct StackFrameObject *oldstackframe159 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe159);
  gc_frame_newslot((Object)stackframe);
  self = obj159;
  Object *oldselfslot159 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter159 = (*(struct UserObject *)self).data[0], lowerouter159 = thisouter159;
  if (inheritingObject159) {
    struct UserObject *inho159 = (struct UserObject *)inheritingObject159;
    while (inho159->super != GraceDefaultObject) inho159 = (struct UserObject *)inho159->super;
    inho159->super = obj159;
    self = inheritingObject159;
    *selfslot = self;
    lowerouter159 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter159;
  }
if (objclass159 == NULL) {
  Method *reader161 = addmethodrealflags(obj159, "kind",&reader_lexer_kind_161, MFLAG_DEF);
  reader161->definitionModule = modulename;
  reader161->definitionLine = 80;
}
adddatum2(obj159, alloc_Undefined(), 1);
if (objclass159 == NULL) {
  Method *reader162 = addmethodrealflags(obj159, "value",&reader_lexer_value_162, MFLAG_DEF);
  reader162->definitionModule = modulename;
  reader162->definitionLine = 81;
}
adddatum2(obj159, alloc_Undefined(), 2);
if (objclass159 == NULL) {
  Method *reader163 = addmethodrealflags(obj159, "size",&reader_lexer_size_163, MFLAG_DEF);
  reader163->definitionModule = modulename;
  reader163->definitionLine = 82;
}
adddatum2(obj159, alloc_Undefined(), 3);
  sourceObject = obj159;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe164 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call165 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe164);
// compiled call node returning call165 (depth = 6)
  struct UserObject *obj159_uo = (struct UserObject *)obj159;
  obj159_uo->super = call165;
  sourceObject = obj159;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit166 == NULL) {
    strlit166 = alloc_String("octets");
    gc_root(strlit166);
  }
// compiled string node returning strlit166 (depth = 6)
  adddatum2(obj159, strlit166, 1);
  sourceObject = obj159;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj159, *var_s, 2);
  sourceObject = obj159;
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num168 = alloc_Float64(3);
// compiled num node returning num168 (depth = 7)
  int op_slot_right_167 = gc_frame_newslot(num168);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe170 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call171 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 8)
// compiled member node returning call171 (depth = 7)
  int op_slot_left_167 = gc_frame_newslot(call171);
  params[0] = num168;
  partcv[0] = 1;
  Object sum172 = callmethod(call171, "+", 1, partcv, params);
// compiled op node returning sum172 (depth = 6)
  adddatum2(obj159, sum172, 3);
objclass159 = obj159->class;
  objclass159->definitionModule = modulename;
  objclass159->definitionLine = 77;
  (*(struct UserObject *)self).data[0] = lowerouter159;
  self = oldself159;
  selfslot = oldselfslot159;
  stackframe = oldstackframe159;
  gc_frame_end(frame);
  return obj159;
}
Object meth_lexer_new158_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject159 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj159 = alloc_userobj2(4,5, objclass159);
  gc_frame_newslot(obj159);
if (objclass159 == NULL) {
  glfree(obj159->class->name);
  obj159->class->name = "OctetsToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj159, self, 0);
  addmethodreal(obj159,"outer", &reader_lexer_outer_160);
  Object oldself159 = self;
  struct StackFrameObject *oldstackframe159 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe159);
  gc_frame_newslot((Object)stackframe);
  self = obj159;
  Object *oldselfslot159 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter159 = (*(struct UserObject *)self).data[0], lowerouter159 = thisouter159;
  if (inheritingObject159) {
    struct UserObject *inho159 = (struct UserObject *)inheritingObject159;
    while (inho159->super != GraceDefaultObject) inho159 = (struct UserObject *)inho159->super;
    inho159->super = obj159;
    self = inheritingObject159;
    *selfslot = self;
    lowerouter159 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter159;
  }
if (objclass159 == NULL) {
  Method *reader161 = addmethodrealflags(obj159, "kind",&reader_lexer_kind_161, MFLAG_DEF);
  reader161->definitionModule = modulename;
  reader161->definitionLine = 80;
}
adddatum2(obj159, alloc_Undefined(), 1);
if (objclass159 == NULL) {
  Method *reader162 = addmethodrealflags(obj159, "value",&reader_lexer_value_162, MFLAG_DEF);
  reader162->definitionModule = modulename;
  reader162->definitionLine = 81;
}
adddatum2(obj159, alloc_Undefined(), 2);
if (objclass159 == NULL) {
  Method *reader163 = addmethodrealflags(obj159, "size",&reader_lexer_size_163, MFLAG_DEF);
  reader163->definitionModule = modulename;
  reader163->definitionLine = 82;
}
adddatum2(obj159, alloc_Undefined(), 3);
  sourceObject = obj159;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe164 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call165 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe164);
// compiled call node returning call165 (depth = 6)
  struct UserObject *obj159_uo = (struct UserObject *)obj159;
  obj159_uo->super = call165;
  sourceObject = obj159;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit166 == NULL) {
    strlit166 = alloc_String("octets");
    gc_root(strlit166);
  }
// compiled string node returning strlit166 (depth = 6)
  adddatum2(obj159, strlit166, 1);
  sourceObject = obj159;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  adddatum2(obj159, *var_s, 2);
  sourceObject = obj159;
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num168 = alloc_Float64(3);
// compiled num node returning num168 (depth = 7)
  int op_slot_right_167 = gc_frame_newslot(num168);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe170 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call171 = callmethod(*var_s, "size",
    1, partcv, params);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 8)
// compiled member node returning call171 (depth = 7)
  int op_slot_left_167 = gc_frame_newslot(call171);
  params[0] = num168;
  partcv[0] = 1;
  Object sum172 = callmethod(call171, "+", 1, partcv, params);
// compiled op node returning sum172 (depth = 6)
  adddatum2(obj159, sum172, 3);
objclass159 = obj159->class;
  objclass159->definitionModule = modulename;
  objclass159->definitionLine = 77;
  (*(struct UserObject *)self).data[0] = lowerouter159;
  self = oldself159;
  selfslot = oldselfslot159;
  stackframe = oldstackframe159;
  gc_frame_end(frame);
  return obj159;
}
Object meth_lexer_new176(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject177 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj177 = alloc_userobj2(4,5, objclass177);
  gc_frame_newslot(obj177);
if (objclass177 == NULL) {
  glfree(obj177->class->name);
  obj177->class->name = "LBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj177, self, 0);
  addmethodreal(obj177,"outer", &reader_lexer_outer_178);
  Object oldself177 = self;
  struct StackFrameObject *oldstackframe177 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe177);
  gc_frame_newslot((Object)stackframe);
  self = obj177;
  Object *oldselfslot177 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter177 = (*(struct UserObject *)self).data[0], lowerouter177 = thisouter177;
  if (inheritingObject177) {
    struct UserObject *inho177 = (struct UserObject *)inheritingObject177;
    while (inho177->super != GraceDefaultObject) inho177 = (struct UserObject *)inho177->super;
    inho177->super = obj177;
    self = inheritingObject177;
    *selfslot = self;
    lowerouter177 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter177;
  }
if (objclass177 == NULL) {
  Method *reader179 = addmethodrealflags(obj177, "kind",&reader_lexer_kind_179, MFLAG_DEF);
  reader179->definitionModule = modulename;
  reader179->definitionLine = 86;
}
adddatum2(obj177, alloc_Undefined(), 1);
if (objclass177 == NULL) {
  Method *reader180 = addmethodrealflags(obj177, "value",&reader_lexer_value_180, MFLAG_DEF);
  reader180->definitionModule = modulename;
  reader180->definitionLine = 87;
}
adddatum2(obj177, alloc_Undefined(), 2);
if (objclass177 == NULL) {
  Method *reader181 = addmethodrealflags(obj177, "size",&reader_lexer_size_181, MFLAG_DEF);
  reader181->definitionModule = modulename;
  reader181->definitionLine = 88;
}
adddatum2(obj177, alloc_Undefined(), 3);
  sourceObject = obj177;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe182 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call183 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe182);
// compiled call node returning call183 (depth = 6)
  struct UserObject *obj177_uo = (struct UserObject *)obj177;
  obj177_uo->super = call183;
  sourceObject = obj177;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit184 == NULL) {
    strlit184 = alloc_String("lbrace");
    gc_root(strlit184);
  }
// compiled string node returning strlit184 (depth = 6)
  adddatum2(obj177, strlit184, 1);
  sourceObject = obj177;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit185 == NULL) {
    strlit185 = alloc_String("{");
    gc_root(strlit185);
  }
// compiled string node returning strlit185 (depth = 6)
  adddatum2(obj177, strlit185, 2);
  sourceObject = obj177;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num186 = alloc_Float64(1);
// compiled num node returning num186 (depth = 6)
  adddatum2(obj177, num186, 3);
objclass177 = obj177->class;
  objclass177->definitionModule = modulename;
  objclass177->definitionLine = 83;
  (*(struct UserObject *)self).data[0] = lowerouter177;
  self = oldself177;
  selfslot = oldselfslot177;
  stackframe = oldstackframe177;
  gc_frame_end(frame);
  return obj177;
}
Object meth_lexer_new176_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject177 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj177 = alloc_userobj2(4,5, objclass177);
  gc_frame_newslot(obj177);
if (objclass177 == NULL) {
  glfree(obj177->class->name);
  obj177->class->name = "LBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj177, self, 0);
  addmethodreal(obj177,"outer", &reader_lexer_outer_178);
  Object oldself177 = self;
  struct StackFrameObject *oldstackframe177 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe177);
  gc_frame_newslot((Object)stackframe);
  self = obj177;
  Object *oldselfslot177 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter177 = (*(struct UserObject *)self).data[0], lowerouter177 = thisouter177;
  if (inheritingObject177) {
    struct UserObject *inho177 = (struct UserObject *)inheritingObject177;
    while (inho177->super != GraceDefaultObject) inho177 = (struct UserObject *)inho177->super;
    inho177->super = obj177;
    self = inheritingObject177;
    *selfslot = self;
    lowerouter177 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter177;
  }
if (objclass177 == NULL) {
  Method *reader179 = addmethodrealflags(obj177, "kind",&reader_lexer_kind_179, MFLAG_DEF);
  reader179->definitionModule = modulename;
  reader179->definitionLine = 86;
}
adddatum2(obj177, alloc_Undefined(), 1);
if (objclass177 == NULL) {
  Method *reader180 = addmethodrealflags(obj177, "value",&reader_lexer_value_180, MFLAG_DEF);
  reader180->definitionModule = modulename;
  reader180->definitionLine = 87;
}
adddatum2(obj177, alloc_Undefined(), 2);
if (objclass177 == NULL) {
  Method *reader181 = addmethodrealflags(obj177, "size",&reader_lexer_size_181, MFLAG_DEF);
  reader181->definitionModule = modulename;
  reader181->definitionLine = 88;
}
adddatum2(obj177, alloc_Undefined(), 3);
  sourceObject = obj177;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe182 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call183 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe182);
// compiled call node returning call183 (depth = 6)
  struct UserObject *obj177_uo = (struct UserObject *)obj177;
  obj177_uo->super = call183;
  sourceObject = obj177;
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit184 == NULL) {
    strlit184 = alloc_String("lbrace");
    gc_root(strlit184);
  }
// compiled string node returning strlit184 (depth = 6)
  adddatum2(obj177, strlit184, 1);
  sourceObject = obj177;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit185 == NULL) {
    strlit185 = alloc_String("{");
    gc_root(strlit185);
  }
// compiled string node returning strlit185 (depth = 6)
  adddatum2(obj177, strlit185, 2);
  sourceObject = obj177;
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num186 = alloc_Float64(1);
// compiled num node returning num186 (depth = 6)
  adddatum2(obj177, num186, 3);
objclass177 = obj177->class;
  objclass177->definitionModule = modulename;
  objclass177->definitionLine = 83;
  (*(struct UserObject *)self).data[0] = lowerouter177;
  self = oldself177;
  selfslot = oldselfslot177;
  stackframe = oldstackframe177;
  gc_frame_end(frame);
  return obj177;
}
Object meth_lexer_new190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject191 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj191 = alloc_userobj2(4,5, objclass191);
  gc_frame_newslot(obj191);
if (objclass191 == NULL) {
  glfree(obj191->class->name);
  obj191->class->name = "RBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj191, self, 0);
  addmethodreal(obj191,"outer", &reader_lexer_outer_192);
  Object oldself191 = self;
  struct StackFrameObject *oldstackframe191 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe191);
  gc_frame_newslot((Object)stackframe);
  self = obj191;
  Object *oldselfslot191 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter191 = (*(struct UserObject *)self).data[0], lowerouter191 = thisouter191;
  if (inheritingObject191) {
    struct UserObject *inho191 = (struct UserObject *)inheritingObject191;
    while (inho191->super != GraceDefaultObject) inho191 = (struct UserObject *)inho191->super;
    inho191->super = obj191;
    self = inheritingObject191;
    *selfslot = self;
    lowerouter191 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter191;
  }
if (objclass191 == NULL) {
  Method *reader193 = addmethodrealflags(obj191, "kind",&reader_lexer_kind_193, MFLAG_DEF);
  reader193->definitionModule = modulename;
  reader193->definitionLine = 92;
}
adddatum2(obj191, alloc_Undefined(), 1);
if (objclass191 == NULL) {
  Method *reader194 = addmethodrealflags(obj191, "value",&reader_lexer_value_194, MFLAG_DEF);
  reader194->definitionModule = modulename;
  reader194->definitionLine = 93;
}
adddatum2(obj191, alloc_Undefined(), 2);
if (objclass191 == NULL) {
  Method *reader195 = addmethodrealflags(obj191, "size",&reader_lexer_size_195, MFLAG_DEF);
  reader195->definitionModule = modulename;
  reader195->definitionLine = 94;
}
adddatum2(obj191, alloc_Undefined(), 3);
  sourceObject = obj191;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe196 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call197 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe196);
// compiled call node returning call197 (depth = 6)
  struct UserObject *obj191_uo = (struct UserObject *)obj191;
  obj191_uo->super = call197;
  sourceObject = obj191;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit198 == NULL) {
    strlit198 = alloc_String("rbrace");
    gc_root(strlit198);
  }
// compiled string node returning strlit198 (depth = 6)
  adddatum2(obj191, strlit198, 1);
  sourceObject = obj191;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit199 == NULL) {
    strlit199 = alloc_String("}");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 6)
  adddatum2(obj191, strlit199, 2);
  sourceObject = obj191;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num200 = alloc_Float64(1);
// compiled num node returning num200 (depth = 6)
  adddatum2(obj191, num200, 3);
objclass191 = obj191->class;
  objclass191->definitionModule = modulename;
  objclass191->definitionLine = 89;
  (*(struct UserObject *)self).data[0] = lowerouter191;
  self = oldself191;
  selfslot = oldselfslot191;
  stackframe = oldstackframe191;
  gc_frame_end(frame);
  return obj191;
}
Object meth_lexer_new190_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject191 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj191 = alloc_userobj2(4,5, objclass191);
  gc_frame_newslot(obj191);
if (objclass191 == NULL) {
  glfree(obj191->class->name);
  obj191->class->name = "RBraceToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj191, self, 0);
  addmethodreal(obj191,"outer", &reader_lexer_outer_192);
  Object oldself191 = self;
  struct StackFrameObject *oldstackframe191 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe191);
  gc_frame_newslot((Object)stackframe);
  self = obj191;
  Object *oldselfslot191 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter191 = (*(struct UserObject *)self).data[0], lowerouter191 = thisouter191;
  if (inheritingObject191) {
    struct UserObject *inho191 = (struct UserObject *)inheritingObject191;
    while (inho191->super != GraceDefaultObject) inho191 = (struct UserObject *)inho191->super;
    inho191->super = obj191;
    self = inheritingObject191;
    *selfslot = self;
    lowerouter191 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter191;
  }
if (objclass191 == NULL) {
  Method *reader193 = addmethodrealflags(obj191, "kind",&reader_lexer_kind_193, MFLAG_DEF);
  reader193->definitionModule = modulename;
  reader193->definitionLine = 92;
}
adddatum2(obj191, alloc_Undefined(), 1);
if (objclass191 == NULL) {
  Method *reader194 = addmethodrealflags(obj191, "value",&reader_lexer_value_194, MFLAG_DEF);
  reader194->definitionModule = modulename;
  reader194->definitionLine = 93;
}
adddatum2(obj191, alloc_Undefined(), 2);
if (objclass191 == NULL) {
  Method *reader195 = addmethodrealflags(obj191, "size",&reader_lexer_size_195, MFLAG_DEF);
  reader195->definitionModule = modulename;
  reader195->definitionLine = 94;
}
adddatum2(obj191, alloc_Undefined(), 3);
  sourceObject = obj191;
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe196 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call197 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe196);
// compiled call node returning call197 (depth = 6)
  struct UserObject *obj191_uo = (struct UserObject *)obj191;
  obj191_uo->super = call197;
  sourceObject = obj191;
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit198 == NULL) {
    strlit198 = alloc_String("rbrace");
    gc_root(strlit198);
  }
// compiled string node returning strlit198 (depth = 6)
  adddatum2(obj191, strlit198, 1);
  sourceObject = obj191;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit199 == NULL) {
    strlit199 = alloc_String("}");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 6)
  adddatum2(obj191, strlit199, 2);
  sourceObject = obj191;
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num200 = alloc_Float64(1);
// compiled num node returning num200 (depth = 6)
  adddatum2(obj191, num200, 3);
objclass191 = obj191->class;
  objclass191->definitionModule = modulename;
  objclass191->definitionLine = 89;
  (*(struct UserObject *)self).data[0] = lowerouter191;
  self = oldself191;
  selfslot = oldselfslot191;
  stackframe = oldstackframe191;
  gc_frame_end(frame);
  return obj191;
}
Object meth_lexer_new204(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject205 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj205 = alloc_userobj2(4,5, objclass205);
  gc_frame_newslot(obj205);
if (objclass205 == NULL) {
  glfree(obj205->class->name);
  obj205->class->name = "LParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj205, self, 0);
  addmethodreal(obj205,"outer", &reader_lexer_outer_206);
  Object oldself205 = self;
  struct StackFrameObject *oldstackframe205 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe205);
  gc_frame_newslot((Object)stackframe);
  self = obj205;
  Object *oldselfslot205 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter205 = (*(struct UserObject *)self).data[0], lowerouter205 = thisouter205;
  if (inheritingObject205) {
    struct UserObject *inho205 = (struct UserObject *)inheritingObject205;
    while (inho205->super != GraceDefaultObject) inho205 = (struct UserObject *)inho205->super;
    inho205->super = obj205;
    self = inheritingObject205;
    *selfslot = self;
    lowerouter205 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter205;
  }
if (objclass205 == NULL) {
  Method *reader207 = addmethodrealflags(obj205, "kind",&reader_lexer_kind_207, MFLAG_DEF);
  reader207->definitionModule = modulename;
  reader207->definitionLine = 98;
}
adddatum2(obj205, alloc_Undefined(), 1);
if (objclass205 == NULL) {
  Method *reader208 = addmethodrealflags(obj205, "value",&reader_lexer_value_208, MFLAG_DEF);
  reader208->definitionModule = modulename;
  reader208->definitionLine = 99;
}
adddatum2(obj205, alloc_Undefined(), 2);
if (objclass205 == NULL) {
  Method *reader209 = addmethodrealflags(obj205, "size",&reader_lexer_size_209, MFLAG_DEF);
  reader209->definitionModule = modulename;
  reader209->definitionLine = 100;
}
adddatum2(obj205, alloc_Undefined(), 3);
  sourceObject = obj205;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe210 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call211 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe210);
// compiled call node returning call211 (depth = 6)
  struct UserObject *obj205_uo = (struct UserObject *)obj205;
  obj205_uo->super = call211;
  sourceObject = obj205;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit212 == NULL) {
    strlit212 = alloc_String("lparen");
    gc_root(strlit212);
  }
// compiled string node returning strlit212 (depth = 6)
  adddatum2(obj205, strlit212, 1);
  sourceObject = obj205;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit213 == NULL) {
    strlit213 = alloc_String("(");
    gc_root(strlit213);
  }
// compiled string node returning strlit213 (depth = 6)
  adddatum2(obj205, strlit213, 2);
  sourceObject = obj205;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num214 = alloc_Float64(1);
// compiled num node returning num214 (depth = 6)
  adddatum2(obj205, num214, 3);
objclass205 = obj205->class;
  objclass205->definitionModule = modulename;
  objclass205->definitionLine = 95;
  (*(struct UserObject *)self).data[0] = lowerouter205;
  self = oldself205;
  selfslot = oldselfslot205;
  stackframe = oldstackframe205;
  gc_frame_end(frame);
  return obj205;
}
Object meth_lexer_new204_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject205 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj205 = alloc_userobj2(4,5, objclass205);
  gc_frame_newslot(obj205);
if (objclass205 == NULL) {
  glfree(obj205->class->name);
  obj205->class->name = "LParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj205, self, 0);
  addmethodreal(obj205,"outer", &reader_lexer_outer_206);
  Object oldself205 = self;
  struct StackFrameObject *oldstackframe205 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe205);
  gc_frame_newslot((Object)stackframe);
  self = obj205;
  Object *oldselfslot205 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter205 = (*(struct UserObject *)self).data[0], lowerouter205 = thisouter205;
  if (inheritingObject205) {
    struct UserObject *inho205 = (struct UserObject *)inheritingObject205;
    while (inho205->super != GraceDefaultObject) inho205 = (struct UserObject *)inho205->super;
    inho205->super = obj205;
    self = inheritingObject205;
    *selfslot = self;
    lowerouter205 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter205;
  }
if (objclass205 == NULL) {
  Method *reader207 = addmethodrealflags(obj205, "kind",&reader_lexer_kind_207, MFLAG_DEF);
  reader207->definitionModule = modulename;
  reader207->definitionLine = 98;
}
adddatum2(obj205, alloc_Undefined(), 1);
if (objclass205 == NULL) {
  Method *reader208 = addmethodrealflags(obj205, "value",&reader_lexer_value_208, MFLAG_DEF);
  reader208->definitionModule = modulename;
  reader208->definitionLine = 99;
}
adddatum2(obj205, alloc_Undefined(), 2);
if (objclass205 == NULL) {
  Method *reader209 = addmethodrealflags(obj205, "size",&reader_lexer_size_209, MFLAG_DEF);
  reader209->definitionModule = modulename;
  reader209->definitionLine = 100;
}
adddatum2(obj205, alloc_Undefined(), 3);
  sourceObject = obj205;
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe210 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call211 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe210);
// compiled call node returning call211 (depth = 6)
  struct UserObject *obj205_uo = (struct UserObject *)obj205;
  obj205_uo->super = call211;
  sourceObject = obj205;
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit212 == NULL) {
    strlit212 = alloc_String("lparen");
    gc_root(strlit212);
  }
// compiled string node returning strlit212 (depth = 6)
  adddatum2(obj205, strlit212, 1);
  sourceObject = obj205;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit213 == NULL) {
    strlit213 = alloc_String("(");
    gc_root(strlit213);
  }
// compiled string node returning strlit213 (depth = 6)
  adddatum2(obj205, strlit213, 2);
  sourceObject = obj205;
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num214 = alloc_Float64(1);
// compiled num node returning num214 (depth = 6)
  adddatum2(obj205, num214, 3);
objclass205 = obj205->class;
  objclass205->definitionModule = modulename;
  objclass205->definitionLine = 95;
  (*(struct UserObject *)self).data[0] = lowerouter205;
  self = oldself205;
  selfslot = oldselfslot205;
  stackframe = oldstackframe205;
  gc_frame_end(frame);
  return obj205;
}
Object meth_lexer_new218(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject219 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj219 = alloc_userobj2(4,5, objclass219);
  gc_frame_newslot(obj219);
if (objclass219 == NULL) {
  glfree(obj219->class->name);
  obj219->class->name = "RParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj219, self, 0);
  addmethodreal(obj219,"outer", &reader_lexer_outer_220);
  Object oldself219 = self;
  struct StackFrameObject *oldstackframe219 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe219);
  gc_frame_newslot((Object)stackframe);
  self = obj219;
  Object *oldselfslot219 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter219 = (*(struct UserObject *)self).data[0], lowerouter219 = thisouter219;
  if (inheritingObject219) {
    struct UserObject *inho219 = (struct UserObject *)inheritingObject219;
    while (inho219->super != GraceDefaultObject) inho219 = (struct UserObject *)inho219->super;
    inho219->super = obj219;
    self = inheritingObject219;
    *selfslot = self;
    lowerouter219 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter219;
  }
if (objclass219 == NULL) {
  Method *reader221 = addmethodrealflags(obj219, "kind",&reader_lexer_kind_221, MFLAG_DEF);
  reader221->definitionModule = modulename;
  reader221->definitionLine = 104;
}
adddatum2(obj219, alloc_Undefined(), 1);
if (objclass219 == NULL) {
  Method *reader222 = addmethodrealflags(obj219, "value",&reader_lexer_value_222, MFLAG_DEF);
  reader222->definitionModule = modulename;
  reader222->definitionLine = 105;
}
adddatum2(obj219, alloc_Undefined(), 2);
if (objclass219 == NULL) {
  Method *reader223 = addmethodrealflags(obj219, "size",&reader_lexer_size_223, MFLAG_DEF);
  reader223->definitionModule = modulename;
  reader223->definitionLine = 106;
}
adddatum2(obj219, alloc_Undefined(), 3);
  sourceObject = obj219;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe224 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call225 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe224);
// compiled call node returning call225 (depth = 6)
  struct UserObject *obj219_uo = (struct UserObject *)obj219;
  obj219_uo->super = call225;
  sourceObject = obj219;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit226 == NULL) {
    strlit226 = alloc_String("rparen");
    gc_root(strlit226);
  }
// compiled string node returning strlit226 (depth = 6)
  adddatum2(obj219, strlit226, 1);
  sourceObject = obj219;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit227 == NULL) {
    strlit227 = alloc_String(")");
    gc_root(strlit227);
  }
// compiled string node returning strlit227 (depth = 6)
  adddatum2(obj219, strlit227, 2);
  sourceObject = obj219;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num228 = alloc_Float64(1);
// compiled num node returning num228 (depth = 6)
  adddatum2(obj219, num228, 3);
objclass219 = obj219->class;
  objclass219->definitionModule = modulename;
  objclass219->definitionLine = 101;
  (*(struct UserObject *)self).data[0] = lowerouter219;
  self = oldself219;
  selfslot = oldselfslot219;
  stackframe = oldstackframe219;
  gc_frame_end(frame);
  return obj219;
}
Object meth_lexer_new218_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject219 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj219 = alloc_userobj2(4,5, objclass219);
  gc_frame_newslot(obj219);
if (objclass219 == NULL) {
  glfree(obj219->class->name);
  obj219->class->name = "RParenToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj219, self, 0);
  addmethodreal(obj219,"outer", &reader_lexer_outer_220);
  Object oldself219 = self;
  struct StackFrameObject *oldstackframe219 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe219);
  gc_frame_newslot((Object)stackframe);
  self = obj219;
  Object *oldselfslot219 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter219 = (*(struct UserObject *)self).data[0], lowerouter219 = thisouter219;
  if (inheritingObject219) {
    struct UserObject *inho219 = (struct UserObject *)inheritingObject219;
    while (inho219->super != GraceDefaultObject) inho219 = (struct UserObject *)inho219->super;
    inho219->super = obj219;
    self = inheritingObject219;
    *selfslot = self;
    lowerouter219 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter219;
  }
if (objclass219 == NULL) {
  Method *reader221 = addmethodrealflags(obj219, "kind",&reader_lexer_kind_221, MFLAG_DEF);
  reader221->definitionModule = modulename;
  reader221->definitionLine = 104;
}
adddatum2(obj219, alloc_Undefined(), 1);
if (objclass219 == NULL) {
  Method *reader222 = addmethodrealflags(obj219, "value",&reader_lexer_value_222, MFLAG_DEF);
  reader222->definitionModule = modulename;
  reader222->definitionLine = 105;
}
adddatum2(obj219, alloc_Undefined(), 2);
if (objclass219 == NULL) {
  Method *reader223 = addmethodrealflags(obj219, "size",&reader_lexer_size_223, MFLAG_DEF);
  reader223->definitionModule = modulename;
  reader223->definitionLine = 106;
}
adddatum2(obj219, alloc_Undefined(), 3);
  sourceObject = obj219;
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe224 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call225 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe224);
// compiled call node returning call225 (depth = 6)
  struct UserObject *obj219_uo = (struct UserObject *)obj219;
  obj219_uo->super = call225;
  sourceObject = obj219;
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit226 == NULL) {
    strlit226 = alloc_String("rparen");
    gc_root(strlit226);
  }
// compiled string node returning strlit226 (depth = 6)
  adddatum2(obj219, strlit226, 1);
  sourceObject = obj219;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit227 == NULL) {
    strlit227 = alloc_String(")");
    gc_root(strlit227);
  }
// compiled string node returning strlit227 (depth = 6)
  adddatum2(obj219, strlit227, 2);
  sourceObject = obj219;
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num228 = alloc_Float64(1);
// compiled num node returning num228 (depth = 6)
  adddatum2(obj219, num228, 3);
objclass219 = obj219->class;
  objclass219->definitionModule = modulename;
  objclass219->definitionLine = 101;
  (*(struct UserObject *)self).data[0] = lowerouter219;
  self = oldself219;
  selfslot = oldselfslot219;
  stackframe = oldstackframe219;
  gc_frame_end(frame);
  return obj219;
}
Object meth_lexer_new232(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject233 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj233 = alloc_userobj2(4,5, objclass233);
  gc_frame_newslot(obj233);
if (objclass233 == NULL) {
  glfree(obj233->class->name);
  obj233->class->name = "LSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj233, self, 0);
  addmethodreal(obj233,"outer", &reader_lexer_outer_234);
  Object oldself233 = self;
  struct StackFrameObject *oldstackframe233 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe233);
  gc_frame_newslot((Object)stackframe);
  self = obj233;
  Object *oldselfslot233 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter233 = (*(struct UserObject *)self).data[0], lowerouter233 = thisouter233;
  if (inheritingObject233) {
    struct UserObject *inho233 = (struct UserObject *)inheritingObject233;
    while (inho233->super != GraceDefaultObject) inho233 = (struct UserObject *)inho233->super;
    inho233->super = obj233;
    self = inheritingObject233;
    *selfslot = self;
    lowerouter233 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter233;
  }
if (objclass233 == NULL) {
  Method *reader235 = addmethodrealflags(obj233, "kind",&reader_lexer_kind_235, MFLAG_DEF);
  reader235->definitionModule = modulename;
  reader235->definitionLine = 110;
}
adddatum2(obj233, alloc_Undefined(), 1);
if (objclass233 == NULL) {
  Method *reader236 = addmethodrealflags(obj233, "value",&reader_lexer_value_236, MFLAG_DEF);
  reader236->definitionModule = modulename;
  reader236->definitionLine = 111;
}
adddatum2(obj233, alloc_Undefined(), 2);
if (objclass233 == NULL) {
  Method *reader237 = addmethodrealflags(obj233, "size",&reader_lexer_size_237, MFLAG_DEF);
  reader237->definitionModule = modulename;
  reader237->definitionLine = 112;
}
adddatum2(obj233, alloc_Undefined(), 3);
  sourceObject = obj233;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe238 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call239 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe238);
// compiled call node returning call239 (depth = 6)
  struct UserObject *obj233_uo = (struct UserObject *)obj233;
  obj233_uo->super = call239;
  sourceObject = obj233;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit240 == NULL) {
    strlit240 = alloc_String("lsquare");
    gc_root(strlit240);
  }
// compiled string node returning strlit240 (depth = 6)
  adddatum2(obj233, strlit240, 1);
  sourceObject = obj233;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit241 == NULL) {
    strlit241 = alloc_String("[");
    gc_root(strlit241);
  }
// compiled string node returning strlit241 (depth = 6)
  adddatum2(obj233, strlit241, 2);
  sourceObject = obj233;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num242 = alloc_Float64(1);
// compiled num node returning num242 (depth = 6)
  adddatum2(obj233, num242, 3);
objclass233 = obj233->class;
  objclass233->definitionModule = modulename;
  objclass233->definitionLine = 107;
  (*(struct UserObject *)self).data[0] = lowerouter233;
  self = oldself233;
  selfslot = oldselfslot233;
  stackframe = oldstackframe233;
  gc_frame_end(frame);
  return obj233;
}
Object meth_lexer_new232_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject233 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj233 = alloc_userobj2(4,5, objclass233);
  gc_frame_newslot(obj233);
if (objclass233 == NULL) {
  glfree(obj233->class->name);
  obj233->class->name = "LSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj233, self, 0);
  addmethodreal(obj233,"outer", &reader_lexer_outer_234);
  Object oldself233 = self;
  struct StackFrameObject *oldstackframe233 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe233);
  gc_frame_newslot((Object)stackframe);
  self = obj233;
  Object *oldselfslot233 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter233 = (*(struct UserObject *)self).data[0], lowerouter233 = thisouter233;
  if (inheritingObject233) {
    struct UserObject *inho233 = (struct UserObject *)inheritingObject233;
    while (inho233->super != GraceDefaultObject) inho233 = (struct UserObject *)inho233->super;
    inho233->super = obj233;
    self = inheritingObject233;
    *selfslot = self;
    lowerouter233 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter233;
  }
if (objclass233 == NULL) {
  Method *reader235 = addmethodrealflags(obj233, "kind",&reader_lexer_kind_235, MFLAG_DEF);
  reader235->definitionModule = modulename;
  reader235->definitionLine = 110;
}
adddatum2(obj233, alloc_Undefined(), 1);
if (objclass233 == NULL) {
  Method *reader236 = addmethodrealflags(obj233, "value",&reader_lexer_value_236, MFLAG_DEF);
  reader236->definitionModule = modulename;
  reader236->definitionLine = 111;
}
adddatum2(obj233, alloc_Undefined(), 2);
if (objclass233 == NULL) {
  Method *reader237 = addmethodrealflags(obj233, "size",&reader_lexer_size_237, MFLAG_DEF);
  reader237->definitionModule = modulename;
  reader237->definitionLine = 112;
}
adddatum2(obj233, alloc_Undefined(), 3);
  sourceObject = obj233;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe238 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call239 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe238);
// compiled call node returning call239 (depth = 6)
  struct UserObject *obj233_uo = (struct UserObject *)obj233;
  obj233_uo->super = call239;
  sourceObject = obj233;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit240 == NULL) {
    strlit240 = alloc_String("lsquare");
    gc_root(strlit240);
  }
// compiled string node returning strlit240 (depth = 6)
  adddatum2(obj233, strlit240, 1);
  sourceObject = obj233;
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit241 == NULL) {
    strlit241 = alloc_String("[");
    gc_root(strlit241);
  }
// compiled string node returning strlit241 (depth = 6)
  adddatum2(obj233, strlit241, 2);
  sourceObject = obj233;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num242 = alloc_Float64(1);
// compiled num node returning num242 (depth = 6)
  adddatum2(obj233, num242, 3);
objclass233 = obj233->class;
  objclass233->definitionModule = modulename;
  objclass233->definitionLine = 107;
  (*(struct UserObject *)self).data[0] = lowerouter233;
  self = oldself233;
  selfslot = oldselfslot233;
  stackframe = oldstackframe233;
  gc_frame_end(frame);
  return obj233;
}
Object meth_lexer_new246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj247 = alloc_userobj2(4,5, objclass247);
  gc_frame_newslot(obj247);
if (objclass247 == NULL) {
  glfree(obj247->class->name);
  obj247->class->name = "RSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj247, self, 0);
  addmethodreal(obj247,"outer", &reader_lexer_outer_248);
  Object oldself247 = self;
  struct StackFrameObject *oldstackframe247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe247);
  gc_frame_newslot((Object)stackframe);
  self = obj247;
  Object *oldselfslot247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter247 = (*(struct UserObject *)self).data[0], lowerouter247 = thisouter247;
  if (inheritingObject247) {
    struct UserObject *inho247 = (struct UserObject *)inheritingObject247;
    while (inho247->super != GraceDefaultObject) inho247 = (struct UserObject *)inho247->super;
    inho247->super = obj247;
    self = inheritingObject247;
    *selfslot = self;
    lowerouter247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter247;
  }
if (objclass247 == NULL) {
  Method *reader249 = addmethodrealflags(obj247, "kind",&reader_lexer_kind_249, MFLAG_DEF);
  reader249->definitionModule = modulename;
  reader249->definitionLine = 116;
}
adddatum2(obj247, alloc_Undefined(), 1);
if (objclass247 == NULL) {
  Method *reader250 = addmethodrealflags(obj247, "value",&reader_lexer_value_250, MFLAG_DEF);
  reader250->definitionModule = modulename;
  reader250->definitionLine = 117;
}
adddatum2(obj247, alloc_Undefined(), 2);
if (objclass247 == NULL) {
  Method *reader251 = addmethodrealflags(obj247, "size",&reader_lexer_size_251, MFLAG_DEF);
  reader251->definitionModule = modulename;
  reader251->definitionLine = 118;
}
adddatum2(obj247, alloc_Undefined(), 3);
  sourceObject = obj247;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe252 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call253 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe252);
// compiled call node returning call253 (depth = 6)
  struct UserObject *obj247_uo = (struct UserObject *)obj247;
  obj247_uo->super = call253;
  sourceObject = obj247;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit254 == NULL) {
    strlit254 = alloc_String("rsquare");
    gc_root(strlit254);
  }
// compiled string node returning strlit254 (depth = 6)
  adddatum2(obj247, strlit254, 1);
  sourceObject = obj247;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit255 == NULL) {
    strlit255 = alloc_String("]");
    gc_root(strlit255);
  }
// compiled string node returning strlit255 (depth = 6)
  adddatum2(obj247, strlit255, 2);
  sourceObject = obj247;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num256 = alloc_Float64(1);
// compiled num node returning num256 (depth = 6)
  adddatum2(obj247, num256, 3);
objclass247 = obj247->class;
  objclass247->definitionModule = modulename;
  objclass247->definitionLine = 113;
  (*(struct UserObject *)self).data[0] = lowerouter247;
  self = oldself247;
  selfslot = oldselfslot247;
  stackframe = oldstackframe247;
  gc_frame_end(frame);
  return obj247;
}
Object meth_lexer_new246_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj247 = alloc_userobj2(4,5, objclass247);
  gc_frame_newslot(obj247);
if (objclass247 == NULL) {
  glfree(obj247->class->name);
  obj247->class->name = "RSquareToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj247, self, 0);
  addmethodreal(obj247,"outer", &reader_lexer_outer_248);
  Object oldself247 = self;
  struct StackFrameObject *oldstackframe247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe247);
  gc_frame_newslot((Object)stackframe);
  self = obj247;
  Object *oldselfslot247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter247 = (*(struct UserObject *)self).data[0], lowerouter247 = thisouter247;
  if (inheritingObject247) {
    struct UserObject *inho247 = (struct UserObject *)inheritingObject247;
    while (inho247->super != GraceDefaultObject) inho247 = (struct UserObject *)inho247->super;
    inho247->super = obj247;
    self = inheritingObject247;
    *selfslot = self;
    lowerouter247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter247;
  }
if (objclass247 == NULL) {
  Method *reader249 = addmethodrealflags(obj247, "kind",&reader_lexer_kind_249, MFLAG_DEF);
  reader249->definitionModule = modulename;
  reader249->definitionLine = 116;
}
adddatum2(obj247, alloc_Undefined(), 1);
if (objclass247 == NULL) {
  Method *reader250 = addmethodrealflags(obj247, "value",&reader_lexer_value_250, MFLAG_DEF);
  reader250->definitionModule = modulename;
  reader250->definitionLine = 117;
}
adddatum2(obj247, alloc_Undefined(), 2);
if (objclass247 == NULL) {
  Method *reader251 = addmethodrealflags(obj247, "size",&reader_lexer_size_251, MFLAG_DEF);
  reader251->definitionModule = modulename;
  reader251->definitionLine = 118;
}
adddatum2(obj247, alloc_Undefined(), 3);
  sourceObject = obj247;
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe252 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call253 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe252);
// compiled call node returning call253 (depth = 6)
  struct UserObject *obj247_uo = (struct UserObject *)obj247;
  obj247_uo->super = call253;
  sourceObject = obj247;
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit254 == NULL) {
    strlit254 = alloc_String("rsquare");
    gc_root(strlit254);
  }
// compiled string node returning strlit254 (depth = 6)
  adddatum2(obj247, strlit254, 1);
  sourceObject = obj247;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit255 == NULL) {
    strlit255 = alloc_String("]");
    gc_root(strlit255);
  }
// compiled string node returning strlit255 (depth = 6)
  adddatum2(obj247, strlit255, 2);
  sourceObject = obj247;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num256 = alloc_Float64(1);
// compiled num node returning num256 (depth = 6)
  adddatum2(obj247, num256, 3);
objclass247 = obj247->class;
  objclass247->definitionModule = modulename;
  objclass247->definitionLine = 113;
  (*(struct UserObject *)self).data[0] = lowerouter247;
  self = oldself247;
  selfslot = oldselfslot247;
  stackframe = oldstackframe247;
  gc_frame_end(frame);
  return obj247;
}
Object meth_lexer_new260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject261 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj261 = alloc_userobj2(4,5, objclass261);
  gc_frame_newslot(obj261);
if (objclass261 == NULL) {
  glfree(obj261->class->name);
  obj261->class->name = "CommaToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj261, self, 0);
  addmethodreal(obj261,"outer", &reader_lexer_outer_262);
  Object oldself261 = self;
  struct StackFrameObject *oldstackframe261 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe261);
  gc_frame_newslot((Object)stackframe);
  self = obj261;
  Object *oldselfslot261 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter261 = (*(struct UserObject *)self).data[0], lowerouter261 = thisouter261;
  if (inheritingObject261) {
    struct UserObject *inho261 = (struct UserObject *)inheritingObject261;
    while (inho261->super != GraceDefaultObject) inho261 = (struct UserObject *)inho261->super;
    inho261->super = obj261;
    self = inheritingObject261;
    *selfslot = self;
    lowerouter261 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter261;
  }
if (objclass261 == NULL) {
  Method *reader263 = addmethodrealflags(obj261, "kind",&reader_lexer_kind_263, MFLAG_DEF);
  reader263->definitionModule = modulename;
  reader263->definitionLine = 122;
}
adddatum2(obj261, alloc_Undefined(), 1);
if (objclass261 == NULL) {
  Method *reader264 = addmethodrealflags(obj261, "value",&reader_lexer_value_264, MFLAG_DEF);
  reader264->definitionModule = modulename;
  reader264->definitionLine = 123;
}
adddatum2(obj261, alloc_Undefined(), 2);
if (objclass261 == NULL) {
  Method *reader265 = addmethodrealflags(obj261, "size",&reader_lexer_size_265, MFLAG_DEF);
  reader265->definitionModule = modulename;
  reader265->definitionLine = 124;
}
adddatum2(obj261, alloc_Undefined(), 3);
  sourceObject = obj261;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe266 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call267 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe266);
// compiled call node returning call267 (depth = 6)
  struct UserObject *obj261_uo = (struct UserObject *)obj261;
  obj261_uo->super = call267;
  sourceObject = obj261;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit268 == NULL) {
    strlit268 = alloc_String("comma");
    gc_root(strlit268);
  }
// compiled string node returning strlit268 (depth = 6)
  adddatum2(obj261, strlit268, 1);
  sourceObject = obj261;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit269 == NULL) {
    strlit269 = alloc_String(",");
    gc_root(strlit269);
  }
// compiled string node returning strlit269 (depth = 6)
  adddatum2(obj261, strlit269, 2);
  sourceObject = obj261;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num270 = alloc_Float64(1);
// compiled num node returning num270 (depth = 6)
  adddatum2(obj261, num270, 3);
objclass261 = obj261->class;
  objclass261->definitionModule = modulename;
  objclass261->definitionLine = 119;
  (*(struct UserObject *)self).data[0] = lowerouter261;
  self = oldself261;
  selfslot = oldselfslot261;
  stackframe = oldstackframe261;
  gc_frame_end(frame);
  return obj261;
}
Object meth_lexer_new260_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject261 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj261 = alloc_userobj2(4,5, objclass261);
  gc_frame_newslot(obj261);
if (objclass261 == NULL) {
  glfree(obj261->class->name);
  obj261->class->name = "CommaToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj261, self, 0);
  addmethodreal(obj261,"outer", &reader_lexer_outer_262);
  Object oldself261 = self;
  struct StackFrameObject *oldstackframe261 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe261);
  gc_frame_newslot((Object)stackframe);
  self = obj261;
  Object *oldselfslot261 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter261 = (*(struct UserObject *)self).data[0], lowerouter261 = thisouter261;
  if (inheritingObject261) {
    struct UserObject *inho261 = (struct UserObject *)inheritingObject261;
    while (inho261->super != GraceDefaultObject) inho261 = (struct UserObject *)inho261->super;
    inho261->super = obj261;
    self = inheritingObject261;
    *selfslot = self;
    lowerouter261 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter261;
  }
if (objclass261 == NULL) {
  Method *reader263 = addmethodrealflags(obj261, "kind",&reader_lexer_kind_263, MFLAG_DEF);
  reader263->definitionModule = modulename;
  reader263->definitionLine = 122;
}
adddatum2(obj261, alloc_Undefined(), 1);
if (objclass261 == NULL) {
  Method *reader264 = addmethodrealflags(obj261, "value",&reader_lexer_value_264, MFLAG_DEF);
  reader264->definitionModule = modulename;
  reader264->definitionLine = 123;
}
adddatum2(obj261, alloc_Undefined(), 2);
if (objclass261 == NULL) {
  Method *reader265 = addmethodrealflags(obj261, "size",&reader_lexer_size_265, MFLAG_DEF);
  reader265->definitionModule = modulename;
  reader265->definitionLine = 124;
}
adddatum2(obj261, alloc_Undefined(), 3);
  sourceObject = obj261;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe266 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call267 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe266);
// compiled call node returning call267 (depth = 6)
  struct UserObject *obj261_uo = (struct UserObject *)obj261;
  obj261_uo->super = call267;
  sourceObject = obj261;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit268 == NULL) {
    strlit268 = alloc_String("comma");
    gc_root(strlit268);
  }
// compiled string node returning strlit268 (depth = 6)
  adddatum2(obj261, strlit268, 1);
  sourceObject = obj261;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit269 == NULL) {
    strlit269 = alloc_String(",");
    gc_root(strlit269);
  }
// compiled string node returning strlit269 (depth = 6)
  adddatum2(obj261, strlit269, 2);
  sourceObject = obj261;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num270 = alloc_Float64(1);
// compiled num node returning num270 (depth = 6)
  adddatum2(obj261, num270, 3);
objclass261 = obj261->class;
  objclass261->definitionModule = modulename;
  objclass261->definitionLine = 119;
  (*(struct UserObject *)self).data[0] = lowerouter261;
  self = oldself261;
  selfslot = oldselfslot261;
  stackframe = oldstackframe261;
  gc_frame_end(frame);
  return obj261;
}
Object meth_lexer_new274(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj275 = alloc_userobj2(4,5, objclass275);
  gc_frame_newslot(obj275);
if (objclass275 == NULL) {
  glfree(obj275->class->name);
  obj275->class->name = "ColonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj275, self, 0);
  addmethodreal(obj275,"outer", &reader_lexer_outer_276);
  Object oldself275 = self;
  struct StackFrameObject *oldstackframe275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe275);
  gc_frame_newslot((Object)stackframe);
  self = obj275;
  Object *oldselfslot275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter275 = (*(struct UserObject *)self).data[0], lowerouter275 = thisouter275;
  if (inheritingObject275) {
    struct UserObject *inho275 = (struct UserObject *)inheritingObject275;
    while (inho275->super != GraceDefaultObject) inho275 = (struct UserObject *)inho275->super;
    inho275->super = obj275;
    self = inheritingObject275;
    *selfslot = self;
    lowerouter275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter275;
  }
if (objclass275 == NULL) {
  Method *reader277 = addmethodrealflags(obj275, "kind",&reader_lexer_kind_277, MFLAG_DEF);
  reader277->definitionModule = modulename;
  reader277->definitionLine = 128;
}
adddatum2(obj275, alloc_Undefined(), 1);
if (objclass275 == NULL) {
  Method *reader278 = addmethodrealflags(obj275, "value",&reader_lexer_value_278, MFLAG_DEF);
  reader278->definitionModule = modulename;
  reader278->definitionLine = 129;
}
adddatum2(obj275, alloc_Undefined(), 2);
if (objclass275 == NULL) {
  Method *reader279 = addmethodrealflags(obj275, "size",&reader_lexer_size_279, MFLAG_DEF);
  reader279->definitionModule = modulename;
  reader279->definitionLine = 130;
}
adddatum2(obj275, alloc_Undefined(), 3);
  sourceObject = obj275;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe280 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call281 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe280);
// compiled call node returning call281 (depth = 6)
  struct UserObject *obj275_uo = (struct UserObject *)obj275;
  obj275_uo->super = call281;
  sourceObject = obj275;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit282 == NULL) {
    strlit282 = alloc_String("colon");
    gc_root(strlit282);
  }
// compiled string node returning strlit282 (depth = 6)
  adddatum2(obj275, strlit282, 1);
  sourceObject = obj275;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit283 == NULL) {
    strlit283 = alloc_String(":");
    gc_root(strlit283);
  }
// compiled string node returning strlit283 (depth = 6)
  adddatum2(obj275, strlit283, 2);
  sourceObject = obj275;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num284 = alloc_Float64(1);
// compiled num node returning num284 (depth = 6)
  adddatum2(obj275, num284, 3);
objclass275 = obj275->class;
  objclass275->definitionModule = modulename;
  objclass275->definitionLine = 125;
  (*(struct UserObject *)self).data[0] = lowerouter275;
  self = oldself275;
  selfslot = oldselfslot275;
  stackframe = oldstackframe275;
  gc_frame_end(frame);
  return obj275;
}
Object meth_lexer_new274_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject275 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj275 = alloc_userobj2(4,5, objclass275);
  gc_frame_newslot(obj275);
if (objclass275 == NULL) {
  glfree(obj275->class->name);
  obj275->class->name = "ColonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj275, self, 0);
  addmethodreal(obj275,"outer", &reader_lexer_outer_276);
  Object oldself275 = self;
  struct StackFrameObject *oldstackframe275 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe275);
  gc_frame_newslot((Object)stackframe);
  self = obj275;
  Object *oldselfslot275 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter275 = (*(struct UserObject *)self).data[0], lowerouter275 = thisouter275;
  if (inheritingObject275) {
    struct UserObject *inho275 = (struct UserObject *)inheritingObject275;
    while (inho275->super != GraceDefaultObject) inho275 = (struct UserObject *)inho275->super;
    inho275->super = obj275;
    self = inheritingObject275;
    *selfslot = self;
    lowerouter275 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter275;
  }
if (objclass275 == NULL) {
  Method *reader277 = addmethodrealflags(obj275, "kind",&reader_lexer_kind_277, MFLAG_DEF);
  reader277->definitionModule = modulename;
  reader277->definitionLine = 128;
}
adddatum2(obj275, alloc_Undefined(), 1);
if (objclass275 == NULL) {
  Method *reader278 = addmethodrealflags(obj275, "value",&reader_lexer_value_278, MFLAG_DEF);
  reader278->definitionModule = modulename;
  reader278->definitionLine = 129;
}
adddatum2(obj275, alloc_Undefined(), 2);
if (objclass275 == NULL) {
  Method *reader279 = addmethodrealflags(obj275, "size",&reader_lexer_size_279, MFLAG_DEF);
  reader279->definitionModule = modulename;
  reader279->definitionLine = 130;
}
adddatum2(obj275, alloc_Undefined(), 3);
  sourceObject = obj275;
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe280 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call281 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe280);
// compiled call node returning call281 (depth = 6)
  struct UserObject *obj275_uo = (struct UserObject *)obj275;
  obj275_uo->super = call281;
  sourceObject = obj275;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit282 == NULL) {
    strlit282 = alloc_String("colon");
    gc_root(strlit282);
  }
// compiled string node returning strlit282 (depth = 6)
  adddatum2(obj275, strlit282, 1);
  sourceObject = obj275;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit283 == NULL) {
    strlit283 = alloc_String(":");
    gc_root(strlit283);
  }
// compiled string node returning strlit283 (depth = 6)
  adddatum2(obj275, strlit283, 2);
  sourceObject = obj275;
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num284 = alloc_Float64(1);
// compiled num node returning num284 (depth = 6)
  adddatum2(obj275, num284, 3);
objclass275 = obj275->class;
  objclass275->definitionModule = modulename;
  objclass275->definitionLine = 125;
  (*(struct UserObject *)self).data[0] = lowerouter275;
  self = oldself275;
  selfslot = oldselfslot275;
  stackframe = oldstackframe275;
  gc_frame_end(frame);
  return obj275;
}
Object meth_lexer_new288(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject289 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj289 = alloc_userobj2(4,5, objclass289);
  gc_frame_newslot(obj289);
if (objclass289 == NULL) {
  glfree(obj289->class->name);
  obj289->class->name = "DotToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj289, self, 0);
  addmethodreal(obj289,"outer", &reader_lexer_outer_290);
  Object oldself289 = self;
  struct StackFrameObject *oldstackframe289 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe289);
  gc_frame_newslot((Object)stackframe);
  self = obj289;
  Object *oldselfslot289 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter289 = (*(struct UserObject *)self).data[0], lowerouter289 = thisouter289;
  if (inheritingObject289) {
    struct UserObject *inho289 = (struct UserObject *)inheritingObject289;
    while (inho289->super != GraceDefaultObject) inho289 = (struct UserObject *)inho289->super;
    inho289->super = obj289;
    self = inheritingObject289;
    *selfslot = self;
    lowerouter289 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter289;
  }
if (objclass289 == NULL) {
  Method *reader291 = addmethodrealflags(obj289, "kind",&reader_lexer_kind_291, MFLAG_DEF);
  reader291->definitionModule = modulename;
  reader291->definitionLine = 134;
}
adddatum2(obj289, alloc_Undefined(), 1);
if (objclass289 == NULL) {
  Method *reader292 = addmethodrealflags(obj289, "value",&reader_lexer_value_292, MFLAG_DEF);
  reader292->definitionModule = modulename;
  reader292->definitionLine = 135;
}
adddatum2(obj289, alloc_Undefined(), 2);
if (objclass289 == NULL) {
  Method *reader293 = addmethodrealflags(obj289, "size",&reader_lexer_size_293, MFLAG_DEF);
  reader293->definitionModule = modulename;
  reader293->definitionLine = 136;
}
adddatum2(obj289, alloc_Undefined(), 3);
  sourceObject = obj289;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe294 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call295 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe294);
// compiled call node returning call295 (depth = 6)
  struct UserObject *obj289_uo = (struct UserObject *)obj289;
  obj289_uo->super = call295;
  sourceObject = obj289;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit296 == NULL) {
    strlit296 = alloc_String("dot");
    gc_root(strlit296);
  }
// compiled string node returning strlit296 (depth = 6)
  adddatum2(obj289, strlit296, 1);
  sourceObject = obj289;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit297 == NULL) {
    strlit297 = alloc_String(".");
    gc_root(strlit297);
  }
// compiled string node returning strlit297 (depth = 6)
  adddatum2(obj289, strlit297, 2);
  sourceObject = obj289;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num298 = alloc_Float64(1);
// compiled num node returning num298 (depth = 6)
  adddatum2(obj289, num298, 3);
objclass289 = obj289->class;
  objclass289->definitionModule = modulename;
  objclass289->definitionLine = 131;
  (*(struct UserObject *)self).data[0] = lowerouter289;
  self = oldself289;
  selfslot = oldselfslot289;
  stackframe = oldstackframe289;
  gc_frame_end(frame);
  return obj289;
}
Object meth_lexer_new288_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject289 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj289 = alloc_userobj2(4,5, objclass289);
  gc_frame_newslot(obj289);
if (objclass289 == NULL) {
  glfree(obj289->class->name);
  obj289->class->name = "DotToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj289, self, 0);
  addmethodreal(obj289,"outer", &reader_lexer_outer_290);
  Object oldself289 = self;
  struct StackFrameObject *oldstackframe289 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe289);
  gc_frame_newslot((Object)stackframe);
  self = obj289;
  Object *oldselfslot289 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter289 = (*(struct UserObject *)self).data[0], lowerouter289 = thisouter289;
  if (inheritingObject289) {
    struct UserObject *inho289 = (struct UserObject *)inheritingObject289;
    while (inho289->super != GraceDefaultObject) inho289 = (struct UserObject *)inho289->super;
    inho289->super = obj289;
    self = inheritingObject289;
    *selfslot = self;
    lowerouter289 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter289;
  }
if (objclass289 == NULL) {
  Method *reader291 = addmethodrealflags(obj289, "kind",&reader_lexer_kind_291, MFLAG_DEF);
  reader291->definitionModule = modulename;
  reader291->definitionLine = 134;
}
adddatum2(obj289, alloc_Undefined(), 1);
if (objclass289 == NULL) {
  Method *reader292 = addmethodrealflags(obj289, "value",&reader_lexer_value_292, MFLAG_DEF);
  reader292->definitionModule = modulename;
  reader292->definitionLine = 135;
}
adddatum2(obj289, alloc_Undefined(), 2);
if (objclass289 == NULL) {
  Method *reader293 = addmethodrealflags(obj289, "size",&reader_lexer_size_293, MFLAG_DEF);
  reader293->definitionModule = modulename;
  reader293->definitionLine = 136;
}
adddatum2(obj289, alloc_Undefined(), 3);
  sourceObject = obj289;
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe294 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call295 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe294);
// compiled call node returning call295 (depth = 6)
  struct UserObject *obj289_uo = (struct UserObject *)obj289;
  obj289_uo->super = call295;
  sourceObject = obj289;
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit296 == NULL) {
    strlit296 = alloc_String("dot");
    gc_root(strlit296);
  }
// compiled string node returning strlit296 (depth = 6)
  adddatum2(obj289, strlit296, 1);
  sourceObject = obj289;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit297 == NULL) {
    strlit297 = alloc_String(".");
    gc_root(strlit297);
  }
// compiled string node returning strlit297 (depth = 6)
  adddatum2(obj289, strlit297, 2);
  sourceObject = obj289;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num298 = alloc_Float64(1);
// compiled num node returning num298 (depth = 6)
  adddatum2(obj289, num298, 3);
objclass289 = obj289->class;
  objclass289->definitionModule = modulename;
  objclass289->definitionLine = 131;
  (*(struct UserObject *)self).data[0] = lowerouter289;
  self = oldself289;
  selfslot = oldselfslot289;
  stackframe = oldstackframe289;
  gc_frame_end(frame);
  return obj289;
}
Object meth_lexer_new302(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startPosition = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject303 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj303 = alloc_userobj2(5,6, objclass303);
  gc_frame_newslot(obj303);
if (objclass303 == NULL) {
  glfree(obj303->class->name);
  obj303->class->name = "NumToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj303, self, 0);
  addmethodreal(obj303,"outer", &reader_lexer_outer_304);
  Object oldself303 = self;
  struct StackFrameObject *oldstackframe303 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe303);
  gc_frame_newslot((Object)stackframe);
  self = obj303;
  Object *oldselfslot303 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter303 = (*(struct UserObject *)self).data[0], lowerouter303 = thisouter303;
  if (inheritingObject303) {
    struct UserObject *inho303 = (struct UserObject *)inheritingObject303;
    while (inho303->super != GraceDefaultObject) inho303 = (struct UserObject *)inho303->super;
    inho303->super = obj303;
    self = inheritingObject303;
    *selfslot = self;
    lowerouter303 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter303;
  }
if (objclass303 == NULL) {
  Method *reader305 = addmethodrealflags(obj303, "kind",&reader_lexer_kind_305, MFLAG_DEF);
  reader305->definitionModule = modulename;
  reader305->definitionLine = 140;
}
adddatum2(obj303, alloc_Undefined(), 1);
if (objclass303 == NULL) {
  Method *reader306 = addmethodrealflags(obj303, "value",&reader_lexer_value_306, MFLAG_DEF);
  reader306->definitionModule = modulename;
  reader306->definitionLine = 141;
}
adddatum2(obj303, alloc_Undefined(), 2);
if (objclass303 == NULL) {
  Method *reader307 = addmethodrealflags(obj303, "base",&reader_lexer_base_307, MFLAG_DEF);
  reader307->definitionModule = modulename;
  reader307->definitionLine = 142;
}
adddatum2(obj303, alloc_Undefined(), 3);
if (objclass303 == NULL) {
  Method *reader308 = addmethodrealflags(obj303, "size",&reader_lexer_size_308, MFLAG_DEF);
  reader308->definitionModule = modulename;
  reader308->definitionLine = 143;
}
adddatum2(obj303, alloc_Undefined(), 4);
  sourceObject = obj303;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe309 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call310 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe309);
// compiled call node returning call310 (depth = 6)
  struct UserObject *obj303_uo = (struct UserObject *)obj303;
  obj303_uo->super = call310;
  sourceObject = obj303;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit311 == NULL) {
    strlit311 = alloc_String("num");
    gc_root(strlit311);
  }
// compiled string node returning strlit311 (depth = 6)
  adddatum2(obj303, strlit311, 1);
  sourceObject = obj303;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj303, *var_v, 2);
  sourceObject = obj303;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  adddatum2(obj303, *var_b, 3);
  sourceObject = obj303;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startPosition (depth = 7)
  int op_slot_right_312 = gc_frame_newslot(*var_startPosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_312 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_startPosition;
  partcv[0] = 1;
  Object diff314 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff314 (depth = 6)
  adddatum2(obj303, diff314, 4);
objclass303 = obj303->class;
  objclass303->definitionModule = modulename;
  objclass303->definitionLine = 137;
  (*(struct UserObject *)self).data[0] = lowerouter303;
  self = oldself303;
  selfslot = oldselfslot303;
  stackframe = oldstackframe303;
  gc_frame_end(frame);
  return obj303;
}
Object meth_lexer_new302_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  Object *var_startPosition = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject303 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj303 = alloc_userobj2(5,6, objclass303);
  gc_frame_newslot(obj303);
if (objclass303 == NULL) {
  glfree(obj303->class->name);
  obj303->class->name = "NumToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj303, self, 0);
  addmethodreal(obj303,"outer", &reader_lexer_outer_304);
  Object oldself303 = self;
  struct StackFrameObject *oldstackframe303 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe303);
  gc_frame_newslot((Object)stackframe);
  self = obj303;
  Object *oldselfslot303 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter303 = (*(struct UserObject *)self).data[0], lowerouter303 = thisouter303;
  if (inheritingObject303) {
    struct UserObject *inho303 = (struct UserObject *)inheritingObject303;
    while (inho303->super != GraceDefaultObject) inho303 = (struct UserObject *)inho303->super;
    inho303->super = obj303;
    self = inheritingObject303;
    *selfslot = self;
    lowerouter303 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter303;
  }
if (objclass303 == NULL) {
  Method *reader305 = addmethodrealflags(obj303, "kind",&reader_lexer_kind_305, MFLAG_DEF);
  reader305->definitionModule = modulename;
  reader305->definitionLine = 140;
}
adddatum2(obj303, alloc_Undefined(), 1);
if (objclass303 == NULL) {
  Method *reader306 = addmethodrealflags(obj303, "value",&reader_lexer_value_306, MFLAG_DEF);
  reader306->definitionModule = modulename;
  reader306->definitionLine = 141;
}
adddatum2(obj303, alloc_Undefined(), 2);
if (objclass303 == NULL) {
  Method *reader307 = addmethodrealflags(obj303, "base",&reader_lexer_base_307, MFLAG_DEF);
  reader307->definitionModule = modulename;
  reader307->definitionLine = 142;
}
adddatum2(obj303, alloc_Undefined(), 3);
if (objclass303 == NULL) {
  Method *reader308 = addmethodrealflags(obj303, "size",&reader_lexer_size_308, MFLAG_DEF);
  reader308->definitionModule = modulename;
  reader308->definitionLine = 143;
}
adddatum2(obj303, alloc_Undefined(), 4);
  sourceObject = obj303;
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe309 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call310 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe309);
// compiled call node returning call310 (depth = 6)
  struct UserObject *obj303_uo = (struct UserObject *)obj303;
  obj303_uo->super = call310;
  sourceObject = obj303;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit311 == NULL) {
    strlit311 = alloc_String("num");
    gc_root(strlit311);
  }
// compiled string node returning strlit311 (depth = 6)
  adddatum2(obj303, strlit311, 1);
  sourceObject = obj303;
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj303, *var_v, 2);
  sourceObject = obj303;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  adddatum2(obj303, *var_b, 3);
  sourceObject = obj303;
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_startPosition (depth = 7)
  int op_slot_right_312 = gc_frame_newslot(*var_startPosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_312 = gc_frame_newslot(*var_linePosition);
  params[0] = *var_startPosition;
  partcv[0] = 1;
  Object diff314 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff314 (depth = 6)
  adddatum2(obj303, diff314, 4);
objclass303 = obj303->class;
  objclass303->definitionModule = modulename;
  objclass303->definitionLine = 137;
  (*(struct UserObject *)self).data[0] = lowerouter303;
  self = oldself303;
  selfslot = oldselfslot303;
  stackframe = oldstackframe303;
  gc_frame_end(frame);
  return obj303;
}
Object meth_lexer_new318(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject319 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj319 = alloc_userobj2(4,5, objclass319);
  gc_frame_newslot(obj319);
if (objclass319 == NULL) {
  glfree(obj319->class->name);
  obj319->class->name = "KeywordToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj319, self, 0);
  addmethodreal(obj319,"outer", &reader_lexer_outer_320);
  Object oldself319 = self;
  struct StackFrameObject *oldstackframe319 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe319);
  gc_frame_newslot((Object)stackframe);
  self = obj319;
  Object *oldselfslot319 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter319 = (*(struct UserObject *)self).data[0], lowerouter319 = thisouter319;
  if (inheritingObject319) {
    struct UserObject *inho319 = (struct UserObject *)inheritingObject319;
    while (inho319->super != GraceDefaultObject) inho319 = (struct UserObject *)inho319->super;
    inho319->super = obj319;
    self = inheritingObject319;
    *selfslot = self;
    lowerouter319 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter319;
  }
if (objclass319 == NULL) {
  Method *reader321 = addmethodrealflags(obj319, "kind",&reader_lexer_kind_321, MFLAG_DEF);
  reader321->definitionModule = modulename;
  reader321->definitionLine = 147;
}
adddatum2(obj319, alloc_Undefined(), 1);
if (objclass319 == NULL) {
  Method *reader322 = addmethodrealflags(obj319, "value",&reader_lexer_value_322, MFLAG_DEF);
  reader322->definitionModule = modulename;
  reader322->definitionLine = 148;
}
adddatum2(obj319, alloc_Undefined(), 2);
if (objclass319 == NULL) {
  Method *reader323 = addmethodrealflags(obj319, "size",&reader_lexer_size_323, MFLAG_DEF);
  reader323->definitionModule = modulename;
  reader323->definitionLine = 149;
}
adddatum2(obj319, alloc_Undefined(), 3);
  sourceObject = obj319;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe324 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call325 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe324);
// compiled call node returning call325 (depth = 6)
  struct UserObject *obj319_uo = (struct UserObject *)obj319;
  obj319_uo->super = call325;
  sourceObject = obj319;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit326 == NULL) {
    strlit326 = alloc_String("keyword");
    gc_root(strlit326);
  }
// compiled string node returning strlit326 (depth = 6)
  adddatum2(obj319, strlit326, 1);
  sourceObject = obj319;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj319, *var_v, 2);
  sourceObject = obj319;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call328 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe327);
// compiled call node returning call328 (depth = 7)
// compiled member node returning call328 (depth = 6)
  adddatum2(obj319, call328, 3);
objclass319 = obj319->class;
  objclass319->definitionModule = modulename;
  objclass319->definitionLine = 144;
  (*(struct UserObject *)self).data[0] = lowerouter319;
  self = oldself319;
  selfslot = oldselfslot319;
  stackframe = oldstackframe319;
  gc_frame_end(frame);
  return obj319;
}
Object meth_lexer_new318_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject319 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj319 = alloc_userobj2(4,5, objclass319);
  gc_frame_newslot(obj319);
if (objclass319 == NULL) {
  glfree(obj319->class->name);
  obj319->class->name = "KeywordToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj319, self, 0);
  addmethodreal(obj319,"outer", &reader_lexer_outer_320);
  Object oldself319 = self;
  struct StackFrameObject *oldstackframe319 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe319);
  gc_frame_newslot((Object)stackframe);
  self = obj319;
  Object *oldselfslot319 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter319 = (*(struct UserObject *)self).data[0], lowerouter319 = thisouter319;
  if (inheritingObject319) {
    struct UserObject *inho319 = (struct UserObject *)inheritingObject319;
    while (inho319->super != GraceDefaultObject) inho319 = (struct UserObject *)inho319->super;
    inho319->super = obj319;
    self = inheritingObject319;
    *selfslot = self;
    lowerouter319 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter319;
  }
if (objclass319 == NULL) {
  Method *reader321 = addmethodrealflags(obj319, "kind",&reader_lexer_kind_321, MFLAG_DEF);
  reader321->definitionModule = modulename;
  reader321->definitionLine = 147;
}
adddatum2(obj319, alloc_Undefined(), 1);
if (objclass319 == NULL) {
  Method *reader322 = addmethodrealflags(obj319, "value",&reader_lexer_value_322, MFLAG_DEF);
  reader322->definitionModule = modulename;
  reader322->definitionLine = 148;
}
adddatum2(obj319, alloc_Undefined(), 2);
if (objclass319 == NULL) {
  Method *reader323 = addmethodrealflags(obj319, "size",&reader_lexer_size_323, MFLAG_DEF);
  reader323->definitionModule = modulename;
  reader323->definitionLine = 149;
}
adddatum2(obj319, alloc_Undefined(), 3);
  sourceObject = obj319;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe324 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call325 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe324);
// compiled call node returning call325 (depth = 6)
  struct UserObject *obj319_uo = (struct UserObject *)obj319;
  obj319_uo->super = call325;
  sourceObject = obj319;
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit326 == NULL) {
    strlit326 = alloc_String("keyword");
    gc_root(strlit326);
  }
// compiled string node returning strlit326 (depth = 6)
  adddatum2(obj319, strlit326, 1);
  sourceObject = obj319;
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj319, *var_v, 2);
  sourceObject = obj319;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call328 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe327);
// compiled call node returning call328 (depth = 7)
// compiled member node returning call328 (depth = 6)
  adddatum2(obj319, call328, 3);
objclass319 = obj319->class;
  objclass319->definitionModule = modulename;
  objclass319->definitionLine = 144;
  (*(struct UserObject *)self).data[0] = lowerouter319;
  self = oldself319;
  selfslot = oldselfslot319;
  stackframe = oldstackframe319;
  gc_frame_end(frame);
  return obj319;
}
Object meth_lexer_new332(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj333 = alloc_userobj2(4,5, objclass333);
  gc_frame_newslot(obj333);
if (objclass333 == NULL) {
  glfree(obj333->class->name);
  obj333->class->name = "OpToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj333, self, 0);
  addmethodreal(obj333,"outer", &reader_lexer_outer_334);
  Object oldself333 = self;
  struct StackFrameObject *oldstackframe333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe333);
  gc_frame_newslot((Object)stackframe);
  self = obj333;
  Object *oldselfslot333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter333 = (*(struct UserObject *)self).data[0], lowerouter333 = thisouter333;
  if (inheritingObject333) {
    struct UserObject *inho333 = (struct UserObject *)inheritingObject333;
    while (inho333->super != GraceDefaultObject) inho333 = (struct UserObject *)inho333->super;
    inho333->super = obj333;
    self = inheritingObject333;
    *selfslot = self;
    lowerouter333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter333;
  }
if (objclass333 == NULL) {
  Method *reader335 = addmethodrealflags(obj333, "kind",&reader_lexer_kind_335, MFLAG_DEF);
  reader335->definitionModule = modulename;
  reader335->definitionLine = 153;
}
adddatum2(obj333, alloc_Undefined(), 1);
if (objclass333 == NULL) {
  Method *reader336 = addmethodrealflags(obj333, "value",&reader_lexer_value_336, MFLAG_DEF);
  reader336->definitionModule = modulename;
  reader336->definitionLine = 154;
}
adddatum2(obj333, alloc_Undefined(), 2);
if (objclass333 == NULL) {
  Method *reader337 = addmethodrealflags(obj333, "size",&reader_lexer_size_337, MFLAG_DEF);
  reader337->definitionModule = modulename;
  reader337->definitionLine = 155;
}
adddatum2(obj333, alloc_Undefined(), 3);
  sourceObject = obj333;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe338 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call339 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe338);
// compiled call node returning call339 (depth = 6)
  struct UserObject *obj333_uo = (struct UserObject *)obj333;
  obj333_uo->super = call339;
  sourceObject = obj333;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit340 == NULL) {
    strlit340 = alloc_String("op");
    gc_root(strlit340);
  }
// compiled string node returning strlit340 (depth = 6)
  adddatum2(obj333, strlit340, 1);
  sourceObject = obj333;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj333, *var_v, 2);
  sourceObject = obj333;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call342 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 7)
// compiled member node returning call342 (depth = 6)
  adddatum2(obj333, call342, 3);
objclass333 = obj333->class;
  objclass333->definitionModule = modulename;
  objclass333->definitionLine = 150;
  (*(struct UserObject *)self).data[0] = lowerouter333;
  self = oldself333;
  selfslot = oldselfslot333;
  stackframe = oldstackframe333;
  gc_frame_end(frame);
  return obj333;
}
Object meth_lexer_new332_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method new()object");
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject333 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj333 = alloc_userobj2(4,5, objclass333);
  gc_frame_newslot(obj333);
if (objclass333 == NULL) {
  glfree(obj333->class->name);
  obj333->class->name = "OpToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj333, self, 0);
  addmethodreal(obj333,"outer", &reader_lexer_outer_334);
  Object oldself333 = self;
  struct StackFrameObject *oldstackframe333 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe333);
  gc_frame_newslot((Object)stackframe);
  self = obj333;
  Object *oldselfslot333 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter333 = (*(struct UserObject *)self).data[0], lowerouter333 = thisouter333;
  if (inheritingObject333) {
    struct UserObject *inho333 = (struct UserObject *)inheritingObject333;
    while (inho333->super != GraceDefaultObject) inho333 = (struct UserObject *)inho333->super;
    inho333->super = obj333;
    self = inheritingObject333;
    *selfslot = self;
    lowerouter333 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter333;
  }
if (objclass333 == NULL) {
  Method *reader335 = addmethodrealflags(obj333, "kind",&reader_lexer_kind_335, MFLAG_DEF);
  reader335->definitionModule = modulename;
  reader335->definitionLine = 153;
}
adddatum2(obj333, alloc_Undefined(), 1);
if (objclass333 == NULL) {
  Method *reader336 = addmethodrealflags(obj333, "value",&reader_lexer_value_336, MFLAG_DEF);
  reader336->definitionModule = modulename;
  reader336->definitionLine = 154;
}
adddatum2(obj333, alloc_Undefined(), 2);
if (objclass333 == NULL) {
  Method *reader337 = addmethodrealflags(obj333, "size",&reader_lexer_size_337, MFLAG_DEF);
  reader337->definitionModule = modulename;
  reader337->definitionLine = 155;
}
adddatum2(obj333, alloc_Undefined(), 3);
  sourceObject = obj333;
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe338 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call339 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe338);
// compiled call node returning call339 (depth = 6)
  struct UserObject *obj333_uo = (struct UserObject *)obj333;
  obj333_uo->super = call339;
  sourceObject = obj333;
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit340 == NULL) {
    strlit340 = alloc_String("op");
    gc_root(strlit340);
  }
// compiled string node returning strlit340 (depth = 6)
  adddatum2(obj333, strlit340, 1);
  sourceObject = obj333;
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  adddatum2(obj333, *var_v, 2);
  sourceObject = obj333;
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  partcv[0] = 0;
  Object call342 = callmethod(*var_v, "size",
    1, partcv, params);
  gc_frame_end(callframe341);
// compiled call node returning call342 (depth = 7)
// compiled member node returning call342 (depth = 6)
  adddatum2(obj333, call342, 3);
objclass333 = obj333->class;
  objclass333->definitionModule = modulename;
  objclass333->definitionLine = 150;
  (*(struct UserObject *)self).data[0] = lowerouter333;
  self = oldself333;
  selfslot = oldselfslot333;
  stackframe = oldstackframe333;
  gc_frame_end(frame);
  return obj333;
}
Object meth_lexer_new346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject347 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj347 = alloc_userobj2(4,5, objclass347);
  gc_frame_newslot(obj347);
if (objclass347 == NULL) {
  glfree(obj347->class->name);
  obj347->class->name = "ArrowToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj347, self, 0);
  addmethodreal(obj347,"outer", &reader_lexer_outer_348);
  Object oldself347 = self;
  struct StackFrameObject *oldstackframe347 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe347);
  gc_frame_newslot((Object)stackframe);
  self = obj347;
  Object *oldselfslot347 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter347 = (*(struct UserObject *)self).data[0], lowerouter347 = thisouter347;
  if (inheritingObject347) {
    struct UserObject *inho347 = (struct UserObject *)inheritingObject347;
    while (inho347->super != GraceDefaultObject) inho347 = (struct UserObject *)inho347->super;
    inho347->super = obj347;
    self = inheritingObject347;
    *selfslot = self;
    lowerouter347 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter347;
  }
if (objclass347 == NULL) {
  Method *reader349 = addmethodrealflags(obj347, "kind",&reader_lexer_kind_349, MFLAG_DEF);
  reader349->definitionModule = modulename;
  reader349->definitionLine = 159;
}
adddatum2(obj347, alloc_Undefined(), 1);
if (objclass347 == NULL) {
  Method *reader350 = addmethodrealflags(obj347, "value",&reader_lexer_value_350, MFLAG_DEF);
  reader350->definitionModule = modulename;
  reader350->definitionLine = 160;
}
adddatum2(obj347, alloc_Undefined(), 2);
if (objclass347 == NULL) {
  Method *reader351 = addmethodrealflags(obj347, "size",&reader_lexer_size_351, MFLAG_DEF);
  reader351->definitionModule = modulename;
  reader351->definitionLine = 161;
}
adddatum2(obj347, alloc_Undefined(), 3);
  sourceObject = obj347;
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe352 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call353 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe352);
// compiled call node returning call353 (depth = 6)
  struct UserObject *obj347_uo = (struct UserObject *)obj347;
  obj347_uo->super = call353;
  sourceObject = obj347;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit354 == NULL) {
    strlit354 = alloc_String("arrow");
    gc_root(strlit354);
  }
// compiled string node returning strlit354 (depth = 6)
  adddatum2(obj347, strlit354, 1);
  sourceObject = obj347;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit355 == NULL) {
    strlit355 = alloc_String("->");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 6)
  adddatum2(obj347, strlit355, 2);
  sourceObject = obj347;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num356 = alloc_Float64(2);
// compiled num node returning num356 (depth = 6)
  adddatum2(obj347, num356, 3);
objclass347 = obj347->class;
  objclass347->definitionModule = modulename;
  objclass347->definitionLine = 156;
  (*(struct UserObject *)self).data[0] = lowerouter347;
  self = oldself347;
  selfslot = oldselfslot347;
  stackframe = oldstackframe347;
  gc_frame_end(frame);
  return obj347;
}
Object meth_lexer_new346_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject347 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj347 = alloc_userobj2(4,5, objclass347);
  gc_frame_newslot(obj347);
if (objclass347 == NULL) {
  glfree(obj347->class->name);
  obj347->class->name = "ArrowToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj347, self, 0);
  addmethodreal(obj347,"outer", &reader_lexer_outer_348);
  Object oldself347 = self;
  struct StackFrameObject *oldstackframe347 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe347);
  gc_frame_newslot((Object)stackframe);
  self = obj347;
  Object *oldselfslot347 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter347 = (*(struct UserObject *)self).data[0], lowerouter347 = thisouter347;
  if (inheritingObject347) {
    struct UserObject *inho347 = (struct UserObject *)inheritingObject347;
    while (inho347->super != GraceDefaultObject) inho347 = (struct UserObject *)inho347->super;
    inho347->super = obj347;
    self = inheritingObject347;
    *selfslot = self;
    lowerouter347 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter347;
  }
if (objclass347 == NULL) {
  Method *reader349 = addmethodrealflags(obj347, "kind",&reader_lexer_kind_349, MFLAG_DEF);
  reader349->definitionModule = modulename;
  reader349->definitionLine = 159;
}
adddatum2(obj347, alloc_Undefined(), 1);
if (objclass347 == NULL) {
  Method *reader350 = addmethodrealflags(obj347, "value",&reader_lexer_value_350, MFLAG_DEF);
  reader350->definitionModule = modulename;
  reader350->definitionLine = 160;
}
adddatum2(obj347, alloc_Undefined(), 2);
if (objclass347 == NULL) {
  Method *reader351 = addmethodrealflags(obj347, "size",&reader_lexer_size_351, MFLAG_DEF);
  reader351->definitionModule = modulename;
  reader351->definitionLine = 161;
}
adddatum2(obj347, alloc_Undefined(), 3);
  sourceObject = obj347;
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe352 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call353 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe352);
// compiled call node returning call353 (depth = 6)
  struct UserObject *obj347_uo = (struct UserObject *)obj347;
  obj347_uo->super = call353;
  sourceObject = obj347;
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit354 == NULL) {
    strlit354 = alloc_String("arrow");
    gc_root(strlit354);
  }
// compiled string node returning strlit354 (depth = 6)
  adddatum2(obj347, strlit354, 1);
  sourceObject = obj347;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit355 == NULL) {
    strlit355 = alloc_String("->");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 6)
  adddatum2(obj347, strlit355, 2);
  sourceObject = obj347;
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num356 = alloc_Float64(2);
// compiled num node returning num356 (depth = 6)
  adddatum2(obj347, num356, 3);
objclass347 = obj347->class;
  objclass347->definitionModule = modulename;
  objclass347->definitionLine = 156;
  (*(struct UserObject *)self).data[0] = lowerouter347;
  self = oldself347;
  selfslot = oldselfslot347;
  stackframe = oldstackframe347;
  gc_frame_end(frame);
  return obj347;
}
Object meth_lexer_new360(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject361 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj361 = alloc_userobj2(4,5, objclass361);
  gc_frame_newslot(obj361);
if (objclass361 == NULL) {
  glfree(obj361->class->name);
  obj361->class->name = "BindToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj361, self, 0);
  addmethodreal(obj361,"outer", &reader_lexer_outer_362);
  Object oldself361 = self;
  struct StackFrameObject *oldstackframe361 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe361);
  gc_frame_newslot((Object)stackframe);
  self = obj361;
  Object *oldselfslot361 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter361 = (*(struct UserObject *)self).data[0], lowerouter361 = thisouter361;
  if (inheritingObject361) {
    struct UserObject *inho361 = (struct UserObject *)inheritingObject361;
    while (inho361->super != GraceDefaultObject) inho361 = (struct UserObject *)inho361->super;
    inho361->super = obj361;
    self = inheritingObject361;
    *selfslot = self;
    lowerouter361 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter361;
  }
if (objclass361 == NULL) {
  Method *reader363 = addmethodrealflags(obj361, "kind",&reader_lexer_kind_363, MFLAG_DEF);
  reader363->definitionModule = modulename;
  reader363->definitionLine = 165;
}
adddatum2(obj361, alloc_Undefined(), 1);
if (objclass361 == NULL) {
  Method *reader364 = addmethodrealflags(obj361, "value",&reader_lexer_value_364, MFLAG_DEF);
  reader364->definitionModule = modulename;
  reader364->definitionLine = 166;
}
adddatum2(obj361, alloc_Undefined(), 2);
if (objclass361 == NULL) {
  Method *reader365 = addmethodrealflags(obj361, "size",&reader_lexer_size_365, MFLAG_DEF);
  reader365->definitionModule = modulename;
  reader365->definitionLine = 167;
}
adddatum2(obj361, alloc_Undefined(), 3);
  sourceObject = obj361;
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe366 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call367 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe366);
// compiled call node returning call367 (depth = 6)
  struct UserObject *obj361_uo = (struct UserObject *)obj361;
  obj361_uo->super = call367;
  sourceObject = obj361;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit368 == NULL) {
    strlit368 = alloc_String("bind");
    gc_root(strlit368);
  }
// compiled string node returning strlit368 (depth = 6)
  adddatum2(obj361, strlit368, 1);
  sourceObject = obj361;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit369 == NULL) {
    strlit369 = alloc_String(":=");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 6)
  adddatum2(obj361, strlit369, 2);
  sourceObject = obj361;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num370 = alloc_Float64(2);
// compiled num node returning num370 (depth = 6)
  adddatum2(obj361, num370, 3);
objclass361 = obj361->class;
  objclass361->definitionModule = modulename;
  objclass361->definitionLine = 162;
  (*(struct UserObject *)self).data[0] = lowerouter361;
  self = oldself361;
  selfslot = oldselfslot361;
  stackframe = oldstackframe361;
  gc_frame_end(frame);
  return obj361;
}
Object meth_lexer_new360_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject361 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj361 = alloc_userobj2(4,5, objclass361);
  gc_frame_newslot(obj361);
if (objclass361 == NULL) {
  glfree(obj361->class->name);
  obj361->class->name = "BindToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj361, self, 0);
  addmethodreal(obj361,"outer", &reader_lexer_outer_362);
  Object oldself361 = self;
  struct StackFrameObject *oldstackframe361 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe361);
  gc_frame_newslot((Object)stackframe);
  self = obj361;
  Object *oldselfslot361 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter361 = (*(struct UserObject *)self).data[0], lowerouter361 = thisouter361;
  if (inheritingObject361) {
    struct UserObject *inho361 = (struct UserObject *)inheritingObject361;
    while (inho361->super != GraceDefaultObject) inho361 = (struct UserObject *)inho361->super;
    inho361->super = obj361;
    self = inheritingObject361;
    *selfslot = self;
    lowerouter361 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter361;
  }
if (objclass361 == NULL) {
  Method *reader363 = addmethodrealflags(obj361, "kind",&reader_lexer_kind_363, MFLAG_DEF);
  reader363->definitionModule = modulename;
  reader363->definitionLine = 165;
}
adddatum2(obj361, alloc_Undefined(), 1);
if (objclass361 == NULL) {
  Method *reader364 = addmethodrealflags(obj361, "value",&reader_lexer_value_364, MFLAG_DEF);
  reader364->definitionModule = modulename;
  reader364->definitionLine = 166;
}
adddatum2(obj361, alloc_Undefined(), 2);
if (objclass361 == NULL) {
  Method *reader365 = addmethodrealflags(obj361, "size",&reader_lexer_size_365, MFLAG_DEF);
  reader365->definitionModule = modulename;
  reader365->definitionLine = 167;
}
adddatum2(obj361, alloc_Undefined(), 3);
  sourceObject = obj361;
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe366 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call367 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe366);
// compiled call node returning call367 (depth = 6)
  struct UserObject *obj361_uo = (struct UserObject *)obj361;
  obj361_uo->super = call367;
  sourceObject = obj361;
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit368 == NULL) {
    strlit368 = alloc_String("bind");
    gc_root(strlit368);
  }
// compiled string node returning strlit368 (depth = 6)
  adddatum2(obj361, strlit368, 1);
  sourceObject = obj361;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit369 == NULL) {
    strlit369 = alloc_String(":=");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 6)
  adddatum2(obj361, strlit369, 2);
  sourceObject = obj361;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num370 = alloc_Float64(2);
// compiled num node returning num370 (depth = 6)
  adddatum2(obj361, num370, 3);
objclass361 = obj361->class;
  objclass361->definitionModule = modulename;
  objclass361->definitionLine = 162;
  (*(struct UserObject *)self).data[0] = lowerouter361;
  self = oldself361;
  selfslot = oldselfslot361;
  stackframe = oldstackframe361;
  gc_frame_end(frame);
  return obj361;
}
Object meth_lexer_new374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject375 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj375 = alloc_userobj2(4,5, objclass375);
  gc_frame_newslot(obj375);
if (objclass375 == NULL) {
  glfree(obj375->class->name);
  obj375->class->name = "SemicolonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj375, self, 0);
  addmethodreal(obj375,"outer", &reader_lexer_outer_376);
  Object oldself375 = self;
  struct StackFrameObject *oldstackframe375 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe375);
  gc_frame_newslot((Object)stackframe);
  self = obj375;
  Object *oldselfslot375 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter375 = (*(struct UserObject *)self).data[0], lowerouter375 = thisouter375;
  if (inheritingObject375) {
    struct UserObject *inho375 = (struct UserObject *)inheritingObject375;
    while (inho375->super != GraceDefaultObject) inho375 = (struct UserObject *)inho375->super;
    inho375->super = obj375;
    self = inheritingObject375;
    *selfslot = self;
    lowerouter375 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter375;
  }
if (objclass375 == NULL) {
  Method *reader377 = addmethodrealflags(obj375, "kind",&reader_lexer_kind_377, MFLAG_DEF);
  reader377->definitionModule = modulename;
  reader377->definitionLine = 171;
}
adddatum2(obj375, alloc_Undefined(), 1);
if (objclass375 == NULL) {
  Method *reader378 = addmethodrealflags(obj375, "value",&reader_lexer_value_378, MFLAG_DEF);
  reader378->definitionModule = modulename;
  reader378->definitionLine = 172;
}
adddatum2(obj375, alloc_Undefined(), 2);
if (objclass375 == NULL) {
  Method *reader379 = addmethodrealflags(obj375, "size",&reader_lexer_size_379, MFLAG_DEF);
  reader379->definitionModule = modulename;
  reader379->definitionLine = 173;
}
adddatum2(obj375, alloc_Undefined(), 3);
  sourceObject = obj375;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe380 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call381 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe380);
// compiled call node returning call381 (depth = 6)
  struct UserObject *obj375_uo = (struct UserObject *)obj375;
  obj375_uo->super = call381;
  sourceObject = obj375;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit382 == NULL) {
    strlit382 = alloc_String("semicolon");
    gc_root(strlit382);
  }
// compiled string node returning strlit382 (depth = 6)
  adddatum2(obj375, strlit382, 1);
  sourceObject = obj375;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit383 == NULL) {
    strlit383 = alloc_String(";");
    gc_root(strlit383);
  }
// compiled string node returning strlit383 (depth = 6)
  adddatum2(obj375, strlit383, 2);
  sourceObject = obj375;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num384 = alloc_Float64(1);
// compiled num node returning num384 (depth = 6)
  adddatum2(obj375, num384, 3);
objclass375 = obj375->class;
  objclass375->definitionModule = modulename;
  objclass375->definitionLine = 168;
  (*(struct UserObject *)self).data[0] = lowerouter375;
  self = oldself375;
  selfslot = oldselfslot375;
  stackframe = oldstackframe375;
  gc_frame_end(frame);
  return obj375;
}
Object meth_lexer_new374_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject375 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj375 = alloc_userobj2(4,5, objclass375);
  gc_frame_newslot(obj375);
if (objclass375 == NULL) {
  glfree(obj375->class->name);
  obj375->class->name = "SemicolonToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj375, self, 0);
  addmethodreal(obj375,"outer", &reader_lexer_outer_376);
  Object oldself375 = self;
  struct StackFrameObject *oldstackframe375 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe375);
  gc_frame_newslot((Object)stackframe);
  self = obj375;
  Object *oldselfslot375 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter375 = (*(struct UserObject *)self).data[0], lowerouter375 = thisouter375;
  if (inheritingObject375) {
    struct UserObject *inho375 = (struct UserObject *)inheritingObject375;
    while (inho375->super != GraceDefaultObject) inho375 = (struct UserObject *)inho375->super;
    inho375->super = obj375;
    self = inheritingObject375;
    *selfslot = self;
    lowerouter375 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter375;
  }
if (objclass375 == NULL) {
  Method *reader377 = addmethodrealflags(obj375, "kind",&reader_lexer_kind_377, MFLAG_DEF);
  reader377->definitionModule = modulename;
  reader377->definitionLine = 171;
}
adddatum2(obj375, alloc_Undefined(), 1);
if (objclass375 == NULL) {
  Method *reader378 = addmethodrealflags(obj375, "value",&reader_lexer_value_378, MFLAG_DEF);
  reader378->definitionModule = modulename;
  reader378->definitionLine = 172;
}
adddatum2(obj375, alloc_Undefined(), 2);
if (objclass375 == NULL) {
  Method *reader379 = addmethodrealflags(obj375, "size",&reader_lexer_size_379, MFLAG_DEF);
  reader379->definitionModule = modulename;
  reader379->definitionLine = 173;
}
adddatum2(obj375, alloc_Undefined(), 3);
  sourceObject = obj375;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe380 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call381 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe380);
// compiled call node returning call381 (depth = 6)
  struct UserObject *obj375_uo = (struct UserObject *)obj375;
  obj375_uo->super = call381;
  sourceObject = obj375;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit382 == NULL) {
    strlit382 = alloc_String("semicolon");
    gc_root(strlit382);
  }
// compiled string node returning strlit382 (depth = 6)
  adddatum2(obj375, strlit382, 1);
  sourceObject = obj375;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit383 == NULL) {
    strlit383 = alloc_String(";");
    gc_root(strlit383);
  }
// compiled string node returning strlit383 (depth = 6)
  adddatum2(obj375, strlit383, 2);
  sourceObject = obj375;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num384 = alloc_Float64(1);
// compiled num node returning num384 (depth = 6)
  adddatum2(obj375, num384, 3);
objclass375 = obj375->class;
  objclass375->definitionModule = modulename;
  objclass375->definitionLine = 168;
  (*(struct UserObject *)self).data[0] = lowerouter375;
  self = oldself375;
  selfslot = oldselfslot375;
  stackframe = oldstackframe375;
  gc_frame_end(frame);
  return obj375;
}
Object meth_lexer_new388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject389 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj389 = alloc_userobj2(4,5, objclass389);
  gc_frame_newslot(obj389);
if (objclass389 == NULL) {
  glfree(obj389->class->name);
  obj389->class->name = "LGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj389, self, 0);
  addmethodreal(obj389,"outer", &reader_lexer_outer_390);
  Object oldself389 = self;
  struct StackFrameObject *oldstackframe389 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe389);
  gc_frame_newslot((Object)stackframe);
  self = obj389;
  Object *oldselfslot389 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter389 = (*(struct UserObject *)self).data[0], lowerouter389 = thisouter389;
  if (inheritingObject389) {
    struct UserObject *inho389 = (struct UserObject *)inheritingObject389;
    while (inho389->super != GraceDefaultObject) inho389 = (struct UserObject *)inho389->super;
    inho389->super = obj389;
    self = inheritingObject389;
    *selfslot = self;
    lowerouter389 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter389;
  }
if (objclass389 == NULL) {
  Method *reader391 = addmethodrealflags(obj389, "kind",&reader_lexer_kind_391, MFLAG_DEF);
  reader391->definitionModule = modulename;
  reader391->definitionLine = 177;
}
adddatum2(obj389, alloc_Undefined(), 1);
if (objclass389 == NULL) {
  Method *reader392 = addmethodrealflags(obj389, "value",&reader_lexer_value_392, MFLAG_DEF);
  reader392->definitionModule = modulename;
  reader392->definitionLine = 178;
}
adddatum2(obj389, alloc_Undefined(), 2);
if (objclass389 == NULL) {
  Method *reader393 = addmethodrealflags(obj389, "size",&reader_lexer_size_393, MFLAG_DEF);
  reader393->definitionModule = modulename;
  reader393->definitionLine = 179;
}
adddatum2(obj389, alloc_Undefined(), 3);
  sourceObject = obj389;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe394 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call395 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe394);
// compiled call node returning call395 (depth = 6)
  struct UserObject *obj389_uo = (struct UserObject *)obj389;
  obj389_uo->super = call395;
  sourceObject = obj389;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit396 == NULL) {
    strlit396 = alloc_String("lgeneric");
    gc_root(strlit396);
  }
// compiled string node returning strlit396 (depth = 6)
  adddatum2(obj389, strlit396, 1);
  sourceObject = obj389;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("<");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 6)
  adddatum2(obj389, strlit397, 2);
  sourceObject = obj389;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num398 = alloc_Float64(1);
// compiled num node returning num398 (depth = 6)
  adddatum2(obj389, num398, 3);
objclass389 = obj389->class;
  objclass389->definitionModule = modulename;
  objclass389->definitionLine = 174;
  (*(struct UserObject *)self).data[0] = lowerouter389;
  self = oldself389;
  selfslot = oldselfslot389;
  stackframe = oldstackframe389;
  gc_frame_end(frame);
  return obj389;
}
Object meth_lexer_new388_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject389 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj389 = alloc_userobj2(4,5, objclass389);
  gc_frame_newslot(obj389);
if (objclass389 == NULL) {
  glfree(obj389->class->name);
  obj389->class->name = "LGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj389, self, 0);
  addmethodreal(obj389,"outer", &reader_lexer_outer_390);
  Object oldself389 = self;
  struct StackFrameObject *oldstackframe389 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe389);
  gc_frame_newslot((Object)stackframe);
  self = obj389;
  Object *oldselfslot389 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter389 = (*(struct UserObject *)self).data[0], lowerouter389 = thisouter389;
  if (inheritingObject389) {
    struct UserObject *inho389 = (struct UserObject *)inheritingObject389;
    while (inho389->super != GraceDefaultObject) inho389 = (struct UserObject *)inho389->super;
    inho389->super = obj389;
    self = inheritingObject389;
    *selfslot = self;
    lowerouter389 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter389;
  }
if (objclass389 == NULL) {
  Method *reader391 = addmethodrealflags(obj389, "kind",&reader_lexer_kind_391, MFLAG_DEF);
  reader391->definitionModule = modulename;
  reader391->definitionLine = 177;
}
adddatum2(obj389, alloc_Undefined(), 1);
if (objclass389 == NULL) {
  Method *reader392 = addmethodrealflags(obj389, "value",&reader_lexer_value_392, MFLAG_DEF);
  reader392->definitionModule = modulename;
  reader392->definitionLine = 178;
}
adddatum2(obj389, alloc_Undefined(), 2);
if (objclass389 == NULL) {
  Method *reader393 = addmethodrealflags(obj389, "size",&reader_lexer_size_393, MFLAG_DEF);
  reader393->definitionModule = modulename;
  reader393->definitionLine = 179;
}
adddatum2(obj389, alloc_Undefined(), 3);
  sourceObject = obj389;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe394 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call395 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe394);
// compiled call node returning call395 (depth = 6)
  struct UserObject *obj389_uo = (struct UserObject *)obj389;
  obj389_uo->super = call395;
  sourceObject = obj389;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit396 == NULL) {
    strlit396 = alloc_String("lgeneric");
    gc_root(strlit396);
  }
// compiled string node returning strlit396 (depth = 6)
  adddatum2(obj389, strlit396, 1);
  sourceObject = obj389;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit397 == NULL) {
    strlit397 = alloc_String("<");
    gc_root(strlit397);
  }
// compiled string node returning strlit397 (depth = 6)
  adddatum2(obj389, strlit397, 2);
  sourceObject = obj389;
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num398 = alloc_Float64(1);
// compiled num node returning num398 (depth = 6)
  adddatum2(obj389, num398, 3);
objclass389 = obj389->class;
  objclass389->definitionModule = modulename;
  objclass389->definitionLine = 174;
  (*(struct UserObject *)self).data[0] = lowerouter389;
  self = oldself389;
  selfslot = oldselfslot389;
  stackframe = oldstackframe389;
  gc_frame_end(frame);
  return obj389;
}
Object meth_lexer_new402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject403 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj403 = alloc_userobj2(4,5, objclass403);
  gc_frame_newslot(obj403);
if (objclass403 == NULL) {
  glfree(obj403->class->name);
  obj403->class->name = "RGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj403, self, 0);
  addmethodreal(obj403,"outer", &reader_lexer_outer_404);
  Object oldself403 = self;
  struct StackFrameObject *oldstackframe403 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe403);
  gc_frame_newslot((Object)stackframe);
  self = obj403;
  Object *oldselfslot403 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter403 = (*(struct UserObject *)self).data[0], lowerouter403 = thisouter403;
  if (inheritingObject403) {
    struct UserObject *inho403 = (struct UserObject *)inheritingObject403;
    while (inho403->super != GraceDefaultObject) inho403 = (struct UserObject *)inho403->super;
    inho403->super = obj403;
    self = inheritingObject403;
    *selfslot = self;
    lowerouter403 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter403;
  }
if (objclass403 == NULL) {
  Method *reader405 = addmethodrealflags(obj403, "kind",&reader_lexer_kind_405, MFLAG_DEF);
  reader405->definitionModule = modulename;
  reader405->definitionLine = 183;
}
adddatum2(obj403, alloc_Undefined(), 1);
if (objclass403 == NULL) {
  Method *reader406 = addmethodrealflags(obj403, "value",&reader_lexer_value_406, MFLAG_DEF);
  reader406->definitionModule = modulename;
  reader406->definitionLine = 184;
}
adddatum2(obj403, alloc_Undefined(), 2);
if (objclass403 == NULL) {
  Method *reader407 = addmethodrealflags(obj403, "size",&reader_lexer_size_407, MFLAG_DEF);
  reader407->definitionModule = modulename;
  reader407->definitionLine = 185;
}
adddatum2(obj403, alloc_Undefined(), 3);
  sourceObject = obj403;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe408 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call409 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe408);
// compiled call node returning call409 (depth = 6)
  struct UserObject *obj403_uo = (struct UserObject *)obj403;
  obj403_uo->super = call409;
  sourceObject = obj403;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit410 == NULL) {
    strlit410 = alloc_String("rgeneric");
    gc_root(strlit410);
  }
// compiled string node returning strlit410 (depth = 6)
  adddatum2(obj403, strlit410, 1);
  sourceObject = obj403;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit411 == NULL) {
    strlit411 = alloc_String(">");
    gc_root(strlit411);
  }
// compiled string node returning strlit411 (depth = 6)
  adddatum2(obj403, strlit411, 2);
  sourceObject = obj403;
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num412 = alloc_Float64(1);
// compiled num node returning num412 (depth = 6)
  adddatum2(obj403, num412, 3);
objclass403 = obj403->class;
  objclass403->definitionModule = modulename;
  objclass403->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter403;
  self = oldself403;
  selfslot = oldselfslot403;
  stackframe = oldstackframe403;
  gc_frame_end(frame);
  return obj403;
}
Object meth_lexer_new402_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_Token = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject403 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj403 = alloc_userobj2(4,5, objclass403);
  gc_frame_newslot(obj403);
if (objclass403 == NULL) {
  glfree(obj403->class->name);
  obj403->class->name = "RGenericToken";
}
// OBJECT OUTER DEC outer
  adddatum2(obj403, self, 0);
  addmethodreal(obj403,"outer", &reader_lexer_outer_404);
  Object oldself403 = self;
  struct StackFrameObject *oldstackframe403 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe403);
  gc_frame_newslot((Object)stackframe);
  self = obj403;
  Object *oldselfslot403 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter403 = (*(struct UserObject *)self).data[0], lowerouter403 = thisouter403;
  if (inheritingObject403) {
    struct UserObject *inho403 = (struct UserObject *)inheritingObject403;
    while (inho403->super != GraceDefaultObject) inho403 = (struct UserObject *)inho403->super;
    inho403->super = obj403;
    self = inheritingObject403;
    *selfslot = self;
    lowerouter403 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter403;
  }
if (objclass403 == NULL) {
  Method *reader405 = addmethodrealflags(obj403, "kind",&reader_lexer_kind_405, MFLAG_DEF);
  reader405->definitionModule = modulename;
  reader405->definitionLine = 183;
}
adddatum2(obj403, alloc_Undefined(), 1);
if (objclass403 == NULL) {
  Method *reader406 = addmethodrealflags(obj403, "value",&reader_lexer_value_406, MFLAG_DEF);
  reader406->definitionModule = modulename;
  reader406->definitionLine = 184;
}
adddatum2(obj403, alloc_Undefined(), 2);
if (objclass403 == NULL) {
  Method *reader407 = addmethodrealflags(obj403, "size",&reader_lexer_size_407, MFLAG_DEF);
  reader407->definitionModule = modulename;
  reader407->definitionLine = 185;
}
adddatum2(obj403, alloc_Undefined(), 3);
  sourceObject = obj403;
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe408 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_Token (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call409 = callmethod(*var_Token, "new()object",
    2, partcv, params);
  gc_frame_end(callframe408);
// compiled call node returning call409 (depth = 6)
  struct UserObject *obj403_uo = (struct UserObject *)obj403;
  obj403_uo->super = call409;
  sourceObject = obj403;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit410 == NULL) {
    strlit410 = alloc_String("rgeneric");
    gc_root(strlit410);
  }
// compiled string node returning strlit410 (depth = 6)
  adddatum2(obj403, strlit410, 1);
  sourceObject = obj403;
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit411 == NULL) {
    strlit411 = alloc_String(">");
    gc_root(strlit411);
  }
// compiled string node returning strlit411 (depth = 6)
  adddatum2(obj403, strlit411, 2);
  sourceObject = obj403;
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num412 = alloc_Float64(1);
// compiled num node returning num412 (depth = 6)
  adddatum2(obj403, num412, 3);
objclass403 = obj403->class;
  objclass403->definitionModule = modulename;
  objclass403->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter403;
  self = oldself403;
  selfslot = oldselfslot403;
  stackframe = oldstackframe403;
  gc_frame_end(frame);
  return obj403;
}
Object meth_lexer__apply706(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit708 == NULL) {
    strlit708 = alloc_String("dot");
    gc_root(strlit708);
  }
// compiled string node returning strlit708 (depth = 13)
  int op_slot_right_707 = gc_frame_newslot(strlit708);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe710 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe711 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call712 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe711);
// compiled call node returning call712 (depth = 16)
// compiled member node returning call712 (depth = 15)
  partcv[0] = 0;
  Object call713 = callmethod(call712, "kind",
    1, partcv, params);
  gc_frame_end(callframe710);
// compiled call node returning call713 (depth = 14)
// compiled member node returning call713 (depth = 13)
  int op_slot_left_707 = gc_frame_newslot(call713);
  params[0] = strlit708;
  partcv[0] = 1;
  Object opresult714 = callmethod(call713, "==", 1, partcv, params);
// compiled op node returning opresult714 (depth = 12)
  gc_frame_end(frame);
  return opresult714;
}
Object meth_lexer_modechange416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "modechange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method modechange");
  Object params[5];
  int partcv[3];
  Object *var_IdentifierToken = getfromclosure(closure, 0);
  Object *var_KeywordToken = getfromclosure(closure, 1);
  Object *var_StringToken = getfromclosure(closure, 2);
  Object *var_OctetsToken = getfromclosure(closure, 3);
  Object *var_CommaToken = getfromclosure(closure, 4);
  Object *var_DotToken = getfromclosure(closure, 5);
  Object *var_LBraceToken = getfromclosure(closure, 6);
  Object *var_RBraceToken = getfromclosure(closure, 7);
  Object *var_LParenToken = getfromclosure(closure, 8);
  Object *var_RParenToken = getfromclosure(closure, 9);
  Object *var_LSquareToken = getfromclosure(closure, 10);
  Object *var_RSquareToken = getfromclosure(closure, 11);
  Object *var_LGenericToken = getfromclosure(closure, 12);
  Object *var_RGenericToken = getfromclosure(closure, 13);
  Object *var_SemicolonToken = getfromclosure(closure, 14);
  Object *var_NumToken = getfromclosure(closure, 15);
  Object *var_errormessages = getfromclosure(closure, 16);
  Object *var_linePosition = getfromclosure(closure, 17);
  Object *var_lineNumber = getfromclosure(closure, 18);
  Object *var_OpToken = getfromclosure(closure, 19);
  Object *var_ArrowToken = getfromclosure(closure, 20);
  Object *var_BindToken = getfromclosure(closure, 21);
  Object *var_ColonToken = getfromclosure(closure, 22);
  Object *var_indentLevel = getfromclosure(closure, 23);
  Object *var_CommentToken = getfromclosure(closure, 24);
  Object *var_util = getfromclosure(closure, 25);
  Object *var_startPosition = getfromclosure(closure, 26);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for modechange (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokens = &(stackframe->slots[0]);
  *var_tokens = args[curarg];
  curarg++;
  Object *var_mode = &(stackframe->slots[1]);
  *var_mode = args[curarg];
  curarg++;
  Object *var_accum = &(stackframe->slots[2]);
  *var_accum = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for modechange");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isDone = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "isDone");
  Object *var_tok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "tok");
  Object *var_dot = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dot");
  Object *var_decimal = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "decimal");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
  Object *var_suggestion = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "suggestion");
  Object *var_cmt = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "cmt");
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool417 = alloc_Boolean(0);
// compiled identifier node returning bool417 (depth = 4)
  *var_isDone = bool417;
  if (bool417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num418 = alloc_Float64(0);
// compiled num node returning num418 (depth = 4)
  *var_tok = num418;
  if (num418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num422 = alloc_Float64(0);
// compiled num node returning num422 (depth = 6)
  int op_slot_right_421 = gc_frame_newslot(num422);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  partcv[0] = 0;
  Object call425 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe424);
// compiled call node returning call425 (depth = 7)
// compiled member node returning call425 (depth = 6)
  int op_slot_left_421 = gc_frame_newslot(call425);
  params[0] = num422;
  partcv[0] = 1;
  Object opresult426 = callmethod(call425, ">", 1, partcv, params);
// compiled op node returning opresult426 (depth = 5)
  int op_slot_right_420 = gc_frame_newslot(opresult426);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit429 == NULL) {
    strlit429 = alloc_String("n");
    gc_root(strlit429);
  }
// compiled string node returning strlit429 (depth = 6)
  int op_slot_right_428 = gc_frame_newslot(strlit429);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_428 = gc_frame_newslot(*var_mode);
  params[0] = strlit429;
  partcv[0] = 1;
  Object opresult431 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult431 (depth = 5)
  int op_slot_left_420 = gc_frame_newslot(opresult431);
  params[0] = opresult426;
  partcv[0] = 1;
  Object opresult432 = callmethod(opresult431, "||", 1, partcv, params);
// compiled op node returning opresult432 (depth = 4)
  Object if419 = done;
  if (istrue(opresult432)) {
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit435 == NULL) {
    strlit435 = alloc_String("i");
    gc_root(strlit435);
  }
// compiled string node returning strlit435 (depth = 6)
  int op_slot_right_434 = gc_frame_newslot(strlit435);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_434 = gc_frame_newslot(*var_mode);
  params[0] = strlit435;
  partcv[0] = 1;
  Object opresult437 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult437 (depth = 5)
  Object if433 = done;
  if (istrue(opresult437)) {
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe438 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_IdentifierToken (depth = 7)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call439 = callmethod(*var_IdentifierToken, "new",
    1, partcv, params);
  gc_frame_end(callframe438);
// compiled call node returning call439 (depth = 6)
  *var_tok = call439;
  if (call439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit444 == NULL) {
    strlit444 = alloc_String("factory");
    gc_root(strlit444);
  }
// compiled string node returning strlit444 (depth = 8)
  int op_slot_right_443 = gc_frame_newslot(strlit444);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  int op_slot_left_443 = gc_frame_newslot(*var_accum);
  params[0] = strlit444;
  partcv[0] = 1;
  Object opresult446 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult446 (depth = 7)
  int op_slot_right_442 = gc_frame_newslot(opresult446);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit450 == NULL) {
    strlit450 = alloc_String("dialect");
    gc_root(strlit450);
  }
// compiled string node returning strlit450 (depth = 9)
  int op_slot_right_449 = gc_frame_newslot(strlit450);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  int op_slot_left_449 = gc_frame_newslot(*var_accum);
  params[0] = strlit450;
  partcv[0] = 1;
  Object opresult452 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult452 (depth = 8)
  int op_slot_right_448 = gc_frame_newslot(opresult452);
// starting to compile op node (depth = 8)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit456 == NULL) {
    strlit456 = alloc_String("is");
    gc_root(strlit456);
  }
// compiled string node returning strlit456 (depth = 10)
  int op_slot_right_455 = gc_frame_newslot(strlit456);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_455 = gc_frame_newslot(*var_accum);
  params[0] = strlit456;
  partcv[0] = 1;
  Object opresult458 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult458 (depth = 9)
  int op_slot_right_454 = gc_frame_newslot(opresult458);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit462 == NULL) {
    strlit462 = alloc_String("inherits");
    gc_root(strlit462);
  }
// compiled string node returning strlit462 (depth = 11)
  int op_slot_right_461 = gc_frame_newslot(strlit462);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_461 = gc_frame_newslot(*var_accum);
  params[0] = strlit462;
  partcv[0] = 1;
  Object opresult464 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult464 (depth = 10)
  int op_slot_right_460 = gc_frame_newslot(opresult464);
// starting to compile op node (depth = 10)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit468 == NULL) {
    strlit468 = alloc_String("def");
    gc_root(strlit468);
  }
// compiled string node returning strlit468 (depth = 12)
  int op_slot_right_467 = gc_frame_newslot(strlit468);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_467 = gc_frame_newslot(*var_accum);
  params[0] = strlit468;
  partcv[0] = 1;
  Object opresult470 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult470 (depth = 11)
  int op_slot_right_466 = gc_frame_newslot(opresult470);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit474 == NULL) {
    strlit474 = alloc_String("return");
    gc_root(strlit474);
  }
// compiled string node returning strlit474 (depth = 13)
  int op_slot_right_473 = gc_frame_newslot(strlit474);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_473 = gc_frame_newslot(*var_accum);
  params[0] = strlit474;
  partcv[0] = 1;
  Object opresult476 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult476 (depth = 12)
  int op_slot_right_472 = gc_frame_newslot(opresult476);
// starting to compile op node (depth = 12)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit480 == NULL) {
    strlit480 = alloc_String("class");
    gc_root(strlit480);
  }
// compiled string node returning strlit480 (depth = 14)
  int op_slot_right_479 = gc_frame_newslot(strlit480);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_479 = gc_frame_newslot(*var_accum);
  params[0] = strlit480;
  partcv[0] = 1;
  Object opresult482 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult482 (depth = 13)
  int op_slot_right_478 = gc_frame_newslot(opresult482);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit486 == NULL) {
    strlit486 = alloc_String("import");
    gc_root(strlit486);
  }
// compiled string node returning strlit486 (depth = 15)
  int op_slot_right_485 = gc_frame_newslot(strlit486);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_left_485 = gc_frame_newslot(*var_accum);
  params[0] = strlit486;
  partcv[0] = 1;
  Object opresult488 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult488 (depth = 14)
  int op_slot_right_484 = gc_frame_newslot(opresult488);
// starting to compile op node (depth = 14)
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit492 == NULL) {
    strlit492 = alloc_String("type");
    gc_root(strlit492);
  }
// compiled string node returning strlit492 (depth = 16)
  int op_slot_right_491 = gc_frame_newslot(strlit492);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_left_491 = gc_frame_newslot(*var_accum);
  params[0] = strlit492;
  partcv[0] = 1;
  Object opresult494 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult494 (depth = 15)
  int op_slot_right_490 = gc_frame_newslot(opresult494);
// starting to compile op node (depth = 15)
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit498 == NULL) {
    strlit498 = alloc_String("var");
    gc_root(strlit498);
  }
// compiled string node returning strlit498 (depth = 17)
  int op_slot_right_497 = gc_frame_newslot(strlit498);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_497 = gc_frame_newslot(*var_accum);
  params[0] = strlit498;
  partcv[0] = 1;
  Object opresult500 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult500 (depth = 16)
  int op_slot_right_496 = gc_frame_newslot(opresult500);
// starting to compile op node (depth = 16)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit504 == NULL) {
    strlit504 = alloc_String("method");
    gc_root(strlit504);
  }
// compiled string node returning strlit504 (depth = 18)
  int op_slot_right_503 = gc_frame_newslot(strlit504);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_503 = gc_frame_newslot(*var_accum);
  params[0] = strlit504;
  partcv[0] = 1;
  Object opresult506 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult506 (depth = 17)
  int op_slot_right_502 = gc_frame_newslot(opresult506);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit509 == NULL) {
    strlit509 = alloc_String("object");
    gc_root(strlit509);
  }
// compiled string node returning strlit509 (depth = 18)
  int op_slot_right_508 = gc_frame_newslot(strlit509);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_508 = gc_frame_newslot(*var_accum);
  params[0] = strlit509;
  partcv[0] = 1;
  Object opresult511 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult511 (depth = 17)
  int op_slot_left_502 = gc_frame_newslot(opresult511);
  params[0] = opresult506;
  partcv[0] = 1;
  Object opresult512 = callmethod(opresult511, "||", 1, partcv, params);
// compiled op node returning opresult512 (depth = 16)
  int op_slot_left_496 = gc_frame_newslot(opresult512);
  params[0] = opresult500;
  partcv[0] = 1;
  Object opresult513 = callmethod(opresult512, "||", 1, partcv, params);
// compiled op node returning opresult513 (depth = 15)
  int op_slot_left_490 = gc_frame_newslot(opresult513);
  params[0] = opresult494;
  partcv[0] = 1;
  Object opresult514 = callmethod(opresult513, "||", 1, partcv, params);
// compiled op node returning opresult514 (depth = 14)
  int op_slot_left_484 = gc_frame_newslot(opresult514);
  params[0] = opresult488;
  partcv[0] = 1;
  Object opresult515 = callmethod(opresult514, "||", 1, partcv, params);
// compiled op node returning opresult515 (depth = 13)
  int op_slot_left_478 = gc_frame_newslot(opresult515);
  params[0] = opresult482;
  partcv[0] = 1;
  Object opresult516 = callmethod(opresult515, "||", 1, partcv, params);
// compiled op node returning opresult516 (depth = 12)
  int op_slot_left_472 = gc_frame_newslot(opresult516);
  params[0] = opresult476;
  partcv[0] = 1;
  Object opresult517 = callmethod(opresult516, "||", 1, partcv, params);
// compiled op node returning opresult517 (depth = 11)
  int op_slot_left_466 = gc_frame_newslot(opresult517);
  params[0] = opresult470;
  partcv[0] = 1;
  Object opresult518 = callmethod(opresult517, "||", 1, partcv, params);
// compiled op node returning opresult518 (depth = 10)
  int op_slot_left_460 = gc_frame_newslot(opresult518);
  params[0] = opresult464;
  partcv[0] = 1;
  Object opresult519 = callmethod(opresult518, "||", 1, partcv, params);
// compiled op node returning opresult519 (depth = 9)
  int op_slot_left_454 = gc_frame_newslot(opresult519);
  params[0] = opresult458;
  partcv[0] = 1;
  Object opresult520 = callmethod(opresult519, "||", 1, partcv, params);
// compiled op node returning opresult520 (depth = 8)
  int op_slot_left_448 = gc_frame_newslot(opresult520);
  params[0] = opresult452;
  partcv[0] = 1;
  Object opresult521 = callmethod(opresult520, "||", 1, partcv, params);
// compiled op node returning opresult521 (depth = 7)
  int op_slot_left_442 = gc_frame_newslot(opresult521);
  params[0] = opresult446;
  partcv[0] = 1;
  Object opresult522 = callmethod(opresult521, "||", 1, partcv, params);
// compiled op node returning opresult522 (depth = 6)
  Object if441 = done;
  if (istrue(opresult522)) {
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe523 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_KeywordToken (depth = 8)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call524 = callmethod(*var_KeywordToken, "new",
    1, partcv, params);
  gc_frame_end(callframe523);
// compiled call node returning call524 (depth = 7)
  *var_tok = call524;
  if (call524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if441 = done;
  } else {
  }
// compiled if node returning if441 (depth = 5)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe526 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call527 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe526);
// compiled call node returning call527 (depth = 5)
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool528 = alloc_Boolean(1);
// compiled identifier node returning bool528 (depth = 6)
  *var_isDone = bool528;
  if (bool528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if433 = done;
  } else {
  }
// compiled if node returning if433 (depth = 4)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit532 == NULL) {
    strlit532 = alloc_String("I");
    gc_root(strlit532);
  }
// compiled string node returning strlit532 (depth = 6)
  int op_slot_right_531 = gc_frame_newslot(strlit532);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_531 = gc_frame_newslot(*var_mode);
  params[0] = strlit532;
  partcv[0] = 1;
  Object opresult534 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult534 (depth = 5)
  Object if530 = done;
  if (istrue(opresult534)) {
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe535 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_IdentifierToken (depth = 7)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call536 = callmethod(*var_IdentifierToken, "new",
    1, partcv, params);
  gc_frame_end(callframe535);
// compiled call node returning call536 (depth = 6)
  *var_tok = call536;
  if (call536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe538 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call539 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe538);
// compiled call node returning call539 (depth = 5)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool540 = alloc_Boolean(1);
// compiled identifier node returning bool540 (depth = 6)
  *var_isDone = bool540;
  if (bool540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if530 = done;
  } else {
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit544 == NULL) {
    strlit544 = alloc_String("""\x22""");
    gc_root(strlit544);
  }
// compiled string node returning strlit544 (depth = 7)
  int op_slot_right_543 = gc_frame_newslot(strlit544);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_543 = gc_frame_newslot(*var_mode);
  params[0] = strlit544;
  partcv[0] = 1;
  Object opresult546 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult546 (depth = 6)
  Object if542 = done;
  if (istrue(opresult546)) {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe547 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_StringToken (depth = 8)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call548 = callmethod(*var_StringToken, "new",
    1, partcv, params);
  gc_frame_end(callframe547);
// compiled call node returning call548 (depth = 7)
  *var_tok = call548;
  if (call548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe550 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call551 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe550);
// compiled call node returning call551 (depth = 6)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool552 = alloc_Boolean(1);
// compiled identifier node returning bool552 (depth = 7)
  *var_isDone = bool552;
  if (bool552 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if542 = done;
  } else {
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit556 == NULL) {
    strlit556 = alloc_String("x");
    gc_root(strlit556);
  }
// compiled string node returning strlit556 (depth = 8)
  int op_slot_right_555 = gc_frame_newslot(strlit556);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_555 = gc_frame_newslot(*var_mode);
  params[0] = strlit556;
  partcv[0] = 1;
  Object opresult558 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult558 (depth = 7)
  Object if554 = done;
  if (istrue(opresult558)) {
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe559 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_OctetsToken (depth = 9)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call560 = callmethod(*var_OctetsToken, "new",
    1, partcv, params);
  gc_frame_end(callframe559);
// compiled call node returning call560 (depth = 8)
  *var_tok = call560;
  if (call560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe562 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call563 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe562);
// compiled call node returning call563 (depth = 7)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool564 = alloc_Boolean(1);
// compiled identifier node returning bool564 (depth = 8)
  *var_isDone = bool564;
  if (bool564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if554 = done;
  } else {
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit568 == NULL) {
    strlit568 = alloc_String(",");
    gc_root(strlit568);
  }
// compiled string node returning strlit568 (depth = 9)
  int op_slot_right_567 = gc_frame_newslot(strlit568);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_567 = gc_frame_newslot(*var_mode);
  params[0] = strlit568;
  partcv[0] = 1;
  Object opresult570 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult570 (depth = 8)
  Object if566 = done;
  if (istrue(opresult570)) {
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_CommaToken (depth = 11)
  partcv[0] = 0;
  Object call572 = callmethod(*var_CommaToken, "new",
    1, partcv, params);
  gc_frame_end(callframe571);
// compiled call node returning call572 (depth = 10)
// compiled member node returning call572 (depth = 9)
  *var_tok = call572;
  if (call572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe574 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call575 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe574);
// compiled call node returning call575 (depth = 8)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool576 = alloc_Boolean(1);
// compiled identifier node returning bool576 (depth = 9)
  *var_isDone = bool576;
  if (bool576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if566 = done;
  } else {
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit580 == NULL) {
    strlit580 = alloc_String(".");
    gc_root(strlit580);
  }
// compiled string node returning strlit580 (depth = 10)
  int op_slot_right_579 = gc_frame_newslot(strlit580);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_579 = gc_frame_newslot(*var_mode);
  params[0] = strlit580;
  partcv[0] = 1;
  Object opresult582 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult582 (depth = 9)
  Object if578 = done;
  if (istrue(opresult582)) {
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_DotToken (depth = 12)
  partcv[0] = 0;
  Object call584 = callmethod(*var_DotToken, "new",
    1, partcv, params);
  gc_frame_end(callframe583);
// compiled call node returning call584 (depth = 11)
// compiled member node returning call584 (depth = 10)
  *var_tok = call584;
  if (call584 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe586 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call587 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe586);
// compiled call node returning call587 (depth = 9)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool588 = alloc_Boolean(1);
// compiled identifier node returning bool588 (depth = 10)
  *var_isDone = bool588;
  if (bool588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if578 = done;
  } else {
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit592 == NULL) {
    strlit592 = alloc_String("{");
    gc_root(strlit592);
  }
// compiled string node returning strlit592 (depth = 11)
  int op_slot_right_591 = gc_frame_newslot(strlit592);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_591 = gc_frame_newslot(*var_mode);
  params[0] = strlit592;
  partcv[0] = 1;
  Object opresult594 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult594 (depth = 10)
  Object if590 = done;
  if (istrue(opresult594)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_LBraceToken (depth = 13)
  partcv[0] = 0;
  Object call596 = callmethod(*var_LBraceToken, "new",
    1, partcv, params);
  gc_frame_end(callframe595);
// compiled call node returning call596 (depth = 12)
// compiled member node returning call596 (depth = 11)
  *var_tok = call596;
  if (call596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe598 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call599 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe598);
// compiled call node returning call599 (depth = 10)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
  Object bool600 = alloc_Boolean(1);
// compiled identifier node returning bool600 (depth = 11)
  *var_isDone = bool600;
  if (bool600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if590 = done;
  } else {
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("}");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 12)
  int op_slot_right_603 = gc_frame_newslot(strlit604);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  int op_slot_left_603 = gc_frame_newslot(*var_mode);
  params[0] = strlit604;
  partcv[0] = 1;
  Object opresult606 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult606 (depth = 11)
  Object if602 = done;
  if (istrue(opresult606)) {
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_RBraceToken (depth = 14)
  partcv[0] = 0;
  Object call608 = callmethod(*var_RBraceToken, "new",
    1, partcv, params);
  gc_frame_end(callframe607);
// compiled call node returning call608 (depth = 13)
// compiled member node returning call608 (depth = 12)
  *var_tok = call608;
  if (call608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe610 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call611 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe610);
// compiled call node returning call611 (depth = 11)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
  Object bool612 = alloc_Boolean(1);
// compiled identifier node returning bool612 (depth = 12)
  *var_isDone = bool612;
  if (bool612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if602 = done;
  } else {
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit616 == NULL) {
    strlit616 = alloc_String("(");
    gc_root(strlit616);
  }
// compiled string node returning strlit616 (depth = 13)
  int op_slot_right_615 = gc_frame_newslot(strlit616);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_mode (depth = 13)
  int op_slot_left_615 = gc_frame_newslot(*var_mode);
  params[0] = strlit616;
  partcv[0] = 1;
  Object opresult618 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult618 (depth = 12)
  Object if614 = done;
  if (istrue(opresult618)) {
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe619 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_LParenToken (depth = 15)
  partcv[0] = 0;
  Object call620 = callmethod(*var_LParenToken, "new",
    1, partcv, params);
  gc_frame_end(callframe619);
// compiled call node returning call620 (depth = 14)
// compiled member node returning call620 (depth = 13)
  *var_tok = call620;
  if (call620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe622 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call623 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe622);
// compiled call node returning call623 (depth = 12)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
  Object bool624 = alloc_Boolean(1);
// compiled identifier node returning bool624 (depth = 13)
  *var_isDone = bool624;
  if (bool624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if614 = done;
  } else {
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit628 == NULL) {
    strlit628 = alloc_String(")");
    gc_root(strlit628);
  }
// compiled string node returning strlit628 (depth = 14)
  int op_slot_right_627 = gc_frame_newslot(strlit628);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_mode (depth = 14)
  int op_slot_left_627 = gc_frame_newslot(*var_mode);
  params[0] = strlit628;
  partcv[0] = 1;
  Object opresult630 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult630 (depth = 13)
  Object if626 = done;
  if (istrue(opresult630)) {
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe631 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_RParenToken (depth = 16)
  partcv[0] = 0;
  Object call632 = callmethod(*var_RParenToken, "new",
    1, partcv, params);
  gc_frame_end(callframe631);
// compiled call node returning call632 (depth = 15)
// compiled member node returning call632 (depth = 14)
  *var_tok = call632;
  if (call632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe634 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call635 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe634);
// compiled call node returning call635 (depth = 13)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
  Object bool636 = alloc_Boolean(1);
// compiled identifier node returning bool636 (depth = 14)
  *var_isDone = bool636;
  if (bool636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if626 = done;
  } else {
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit640 == NULL) {
    strlit640 = alloc_String("[");
    gc_root(strlit640);
  }
// compiled string node returning strlit640 (depth = 15)
  int op_slot_right_639 = gc_frame_newslot(strlit640);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_mode (depth = 15)
  int op_slot_left_639 = gc_frame_newslot(*var_mode);
  params[0] = strlit640;
  partcv[0] = 1;
  Object opresult642 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult642 (depth = 14)
  Object if638 = done;
  if (istrue(opresult642)) {
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe643 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_LSquareToken (depth = 17)
  partcv[0] = 0;
  Object call644 = callmethod(*var_LSquareToken, "new",
    1, partcv, params);
  gc_frame_end(callframe643);
// compiled call node returning call644 (depth = 16)
// compiled member node returning call644 (depth = 15)
  *var_tok = call644;
  if (call644 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe646 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call647 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe646);
// compiled call node returning call647 (depth = 14)
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
  Object bool648 = alloc_Boolean(1);
// compiled identifier node returning bool648 (depth = 15)
  *var_isDone = bool648;
  if (bool648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
    gc_frame_newslot(done);
    if638 = done;
  } else {
  }
// compiled if node returning if638 (depth = 13)
    gc_frame_newslot(if638);
    if626 = if638;
  }
// compiled if node returning if626 (depth = 12)
    gc_frame_newslot(if626);
    if614 = if626;
  }
// compiled if node returning if614 (depth = 11)
    gc_frame_newslot(if614);
    if602 = if614;
  }
// compiled if node returning if602 (depth = 10)
    gc_frame_newslot(if602);
    if590 = if602;
  }
// compiled if node returning if590 (depth = 9)
    gc_frame_newslot(if590);
    if578 = if590;
  }
// compiled if node returning if578 (depth = 8)
    gc_frame_newslot(if578);
    if566 = if578;
  }
// compiled if node returning if566 (depth = 7)
    gc_frame_newslot(if566);
    if554 = if566;
  }
// compiled if node returning if554 (depth = 6)
    gc_frame_newslot(if554);
    if542 = if554;
  }
// compiled if node returning if542 (depth = 5)
    gc_frame_newslot(if542);
    if530 = if542;
  }
// compiled if node returning if530 (depth = 4)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit652 == NULL) {
    strlit652 = alloc_String("]");
    gc_root(strlit652);
  }
// compiled string node returning strlit652 (depth = 6)
  int op_slot_right_651 = gc_frame_newslot(strlit652);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_651 = gc_frame_newslot(*var_mode);
  params[0] = strlit652;
  partcv[0] = 1;
  Object opresult654 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult654 (depth = 5)
  Object if650 = done;
  if (istrue(opresult654)) {
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe655 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_RSquareToken (depth = 8)
  partcv[0] = 0;
  Object call656 = callmethod(*var_RSquareToken, "new",
    1, partcv, params);
  gc_frame_end(callframe655);
// compiled call node returning call656 (depth = 7)
// compiled member node returning call656 (depth = 6)
  *var_tok = call656;
  if (call656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe658 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call659 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe658);
// compiled call node returning call659 (depth = 5)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool660 = alloc_Boolean(1);
// compiled identifier node returning bool660 (depth = 6)
  *var_isDone = bool660;
  if (bool660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if650 = done;
  } else {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit664 == NULL) {
    strlit664 = alloc_String("<");
    gc_root(strlit664);
  }
// compiled string node returning strlit664 (depth = 7)
  int op_slot_right_663 = gc_frame_newslot(strlit664);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_663 = gc_frame_newslot(*var_mode);
  params[0] = strlit664;
  partcv[0] = 1;
  Object opresult666 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult666 (depth = 6)
  Object if662 = done;
  if (istrue(opresult666)) {
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_LGenericToken (depth = 9)
  partcv[0] = 0;
  Object call668 = callmethod(*var_LGenericToken, "new",
    1, partcv, params);
  gc_frame_end(callframe667);
// compiled call node returning call668 (depth = 8)
// compiled member node returning call668 (depth = 7)
  *var_tok = call668;
  if (call668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe670 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call671 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe670);
// compiled call node returning call671 (depth = 6)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool672 = alloc_Boolean(1);
// compiled identifier node returning bool672 (depth = 7)
  *var_isDone = bool672;
  if (bool672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if662 = done;
  } else {
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit676 == NULL) {
    strlit676 = alloc_String(">");
    gc_root(strlit676);
  }
// compiled string node returning strlit676 (depth = 8)
  int op_slot_right_675 = gc_frame_newslot(strlit676);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_675 = gc_frame_newslot(*var_mode);
  params[0] = strlit676;
  partcv[0] = 1;
  Object opresult678 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult678 (depth = 7)
  Object if674 = done;
  if (istrue(opresult678)) {
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe679 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_RGenericToken (depth = 10)
  partcv[0] = 0;
  Object call680 = callmethod(*var_RGenericToken, "new",
    1, partcv, params);
  gc_frame_end(callframe679);
// compiled call node returning call680 (depth = 9)
// compiled member node returning call680 (depth = 8)
  *var_tok = call680;
  if (call680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe682 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call683 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe682);
// compiled call node returning call683 (depth = 7)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool684 = alloc_Boolean(1);
// compiled identifier node returning bool684 (depth = 8)
  *var_isDone = bool684;
  if (bool684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if674 = done;
  } else {
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit688 == NULL) {
    strlit688 = alloc_String(";");
    gc_root(strlit688);
  }
// compiled string node returning strlit688 (depth = 9)
  int op_slot_right_687 = gc_frame_newslot(strlit688);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_687 = gc_frame_newslot(*var_mode);
  params[0] = strlit688;
  partcv[0] = 1;
  Object opresult690 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult690 (depth = 8)
  Object if686 = done;
  if (istrue(opresult690)) {
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_SemicolonToken (depth = 11)
  partcv[0] = 0;
  Object call692 = callmethod(*var_SemicolonToken, "new",
    1, partcv, params);
  gc_frame_end(callframe691);
// compiled call node returning call692 (depth = 10)
// compiled member node returning call692 (depth = 9)
  *var_tok = call692;
  if (call692 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe694 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call695 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe694);
// compiled call node returning call695 (depth = 8)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool696 = alloc_Boolean(1);
// compiled identifier node returning bool696 (depth = 9)
  *var_isDone = bool696;
  if (bool696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if686 = done;
  } else {
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit700 == NULL) {
    strlit700 = alloc_String("m");
    gc_root(strlit700);
  }
// compiled string node returning strlit700 (depth = 10)
  int op_slot_right_699 = gc_frame_newslot(strlit700);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_699 = gc_frame_newslot(*var_mode);
  params[0] = strlit700;
  partcv[0] = 1;
  Object opresult702 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult702 (depth = 9)
  Object if698 = done;
  if (istrue(opresult702)) {
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe704 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block705 = alloc_Block(NULL, NULL, "lexer", 279);
  gc_frame_newslot(block705);
// method _apply
  block_savedest(block705);
  Object closure706 = createclosure(2, "_apply");
  setclosureframe(closure706, stackframe);
  addtoclosure(closure706, var_tokens);
  addtoclosure(closure706, selfslot);
  struct UserObject *uo706 = (struct UserObject*)block705;
  uo706->data[0] = (Object)closure706;
  Method *meth_meth_lexer__apply706 = addmethod2pos(block705, "_apply", &meth_lexer__apply706, 0);
  int argcv_meth_lexer__apply706[] = {0};
  meth_meth_lexer__apply706->type = alloc_MethodType(1, argcv_meth_lexer__apply706);
  meth_meth_lexer__apply706->definitionModule = modulename;
  meth_meth_lexer__apply706->definitionLine = 275;
// compiled block node returning block705 (depth = 11)
  gc_frame_newslot(block705);
// call case 6: other member request
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num717 = alloc_Float64(1);
// compiled num node returning num717 (depth = 12)
  int op_slot_right_716 = gc_frame_newslot(num717);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call720 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe719);
// compiled call node returning call720 (depth = 13)
// compiled member node returning call720 (depth = 12)
  int op_slot_left_716 = gc_frame_newslot(call720);
  params[0] = num717;
  partcv[0] = 1;
  Object opresult721 = callmethod(call720, ">", 1, partcv, params);
// compiled op node returning opresult721 (depth = 11)
  params[0] = block705;
  partcv[0] = 1;
  Object call722 = callmethod(opresult721, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe704);
// compiled call node returning call722 (depth = 10)
  Object if703 = done;
  if (istrue(call722)) {
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe723 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call724 = callmethod(*var_tokens, "pop",
    1, partcv, params);
  gc_frame_end(callframe723);
// compiled call node returning call724 (depth = 12)
// compiled member node returning call724 (depth = 11)
  *var_dot = call724;
  if (call724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit727 == NULL) {
    strlit727 = alloc_String("num");
    gc_root(strlit727);
  }
// compiled string node returning strlit727 (depth = 12)
  int op_slot_right_726 = gc_frame_newslot(strlit727);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe729 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call731 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe730);
// compiled call node returning call731 (depth = 15)
// compiled member node returning call731 (depth = 14)
  partcv[0] = 0;
  Object call732 = callmethod(call731, "kind",
    1, partcv, params);
  gc_frame_end(callframe729);
// compiled call node returning call732 (depth = 13)
// compiled member node returning call732 (depth = 12)
  int op_slot_left_726 = gc_frame_newslot(call732);
  params[0] = strlit727;
  partcv[0] = 1;
  Object opresult733 = callmethod(call732, "==", 1, partcv, params);
// compiled op node returning opresult733 (depth = 11)
  Object if725 = done;
  if (istrue(opresult733)) {
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num736 = alloc_Float64(10);
// compiled num node returning num736 (depth = 13)
  int op_slot_right_735 = gc_frame_newslot(num736);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe738 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call740 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe739);
// compiled call node returning call740 (depth = 16)
// compiled member node returning call740 (depth = 15)
  partcv[0] = 0;
  Object call741 = callmethod(call740, "base",
    1, partcv, params);
  gc_frame_end(callframe738);
// compiled call node returning call741 (depth = 14)
// compiled member node returning call741 (depth = 13)
  int op_slot_left_735 = gc_frame_newslot(call741);
  params[0] = num736;
  partcv[0] = 1;
  Object opresult742 = callmethod(call741, "==", 1, partcv, params);
// compiled op node returning opresult742 (depth = 12)
  Object if734 = done;
  if (istrue(opresult742)) {
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe743 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  partcv[0] = 0;
  Object call744 = callmethod(*var_tokens, "pop",
    1, partcv, params);
  gc_frame_end(callframe743);
// compiled call node returning call744 (depth = 14)
// compiled member node returning call744 (depth = 13)
  *var_tok = call744;
  if (call744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe746 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call747 = callmethodflags(self, "makeNumToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe746);
// compiled call node returning call747 (depth = 13)
  *var_decimal = call747;
  if (call747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 12)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num750 = alloc_Float64(10);
// compiled num node returning num750 (depth = 14)
  int op_slot_right_749 = gc_frame_newslot(num750);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe752 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_decimal (depth = 16)
  partcv[0] = 0;
  Object call753 = callmethod(*var_decimal, "base",
    1, partcv, params);
  gc_frame_end(callframe752);
// compiled call node returning call753 (depth = 15)
// compiled member node returning call753 (depth = 14)
  int op_slot_left_749 = gc_frame_newslot(call753);
  params[0] = num750;
  partcv[0] = 1;
  Object opresult754 = callmethod(call753, "==", 1, partcv, params);
// compiled op node returning opresult754 (depth = 13)
  Object if748 = done;
  if (istrue(opresult754)) {
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe755 = gc_frame_new();
// starting to compile op node (depth = 15)
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_right_756 = gc_frame_newslot(*var_accum);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit759 == NULL) {
    strlit759 = alloc_String(".");
    gc_root(strlit759);
  }
// compiled string node returning strlit759 (depth = 17)
  int op_slot_right_758 = gc_frame_newslot(strlit759);
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe761 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tok (depth = 19)
  partcv[0] = 0;
  Object call762 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe761);
// compiled call node returning call762 (depth = 18)
// compiled member node returning call762 (depth = 17)
  int op_slot_left_758 = gc_frame_newslot(call762);
  params[0] = strlit759;
  partcv[0] = 1;
  Object opresult763 = callmethod(call762, "++", 1, partcv, params);
// compiled op node returning opresult763 (depth = 16)
  int op_slot_left_756 = gc_frame_newslot(opresult763);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult764 = callmethod(opresult763, "++", 1, partcv, params);
// compiled op node returning opresult764 (depth = 15)
  gc_frame_newslot(opresult764);
// starting to compile num node (depth = 15)
  Object num765 = alloc_Float64(10);
// compiled num node returning num765 (depth = 15)
  gc_frame_newslot(num765);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_NumToken (depth = 15)
  params[0] = opresult764;
  params[1] = num765;
  partcv[0] = 2;
  Object call766 = callmethod(*var_NumToken, "new",
    1, partcv, params);
  gc_frame_end(callframe755);
// compiled call node returning call766 (depth = 14)
  *var_tok = call766;
  if (call766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if748 = done;
  } else {
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 14)
  Object array768 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array768 (depth = 14)
  *var_suggestions = array768;
  if (array768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 13)
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe769 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call771 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe770);
// compiled call node returning call771 (depth = 17)
// compiled member node returning call771 (depth = 16)
  partcv[0] = 0;
  Object call772 = callmethod(call771, "new",
    1, partcv, params);
  gc_frame_end(callframe769);
// compiled call node returning call772 (depth = 15)
// compiled member node returning call772 (depth = 14)
  *var_suggestion = call772;
  if (call772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 13)
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe773 = gc_frame_new();
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num775 = alloc_Float64(1);
// compiled num node returning num775 (depth = 15)
  int op_slot_right_774 = gc_frame_newslot(num775);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call778 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe777);
// compiled call node returning call778 (depth = 16)
// compiled member node returning call778 (depth = 15)
  int op_slot_left_774 = gc_frame_newslot(call778);
  params[0] = num775;
  partcv[0] = 1;
  Object sum779 = callmethod(call778, "+", 1, partcv, params);
// compiled op node returning sum779 (depth = 14)
  gc_frame_newslot(sum779);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num781 = alloc_Float64(1);
// compiled num node returning num781 (depth = 15)
  int op_slot_right_780 = gc_frame_newslot(num781);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_780 = gc_frame_newslot(*var_linePosition);
  params[0] = num781;
  partcv[0] = 1;
  Object diff783 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff783 (depth = 14)
  gc_frame_newslot(diff783);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_decimal (depth = 16)
  partcv[0] = 0;
  Object call785 = callmethod(*var_decimal, "value",
    1, partcv, params);
  gc_frame_end(callframe784);
// compiled call node returning call785 (depth = 15)
// compiled member node returning call785 (depth = 14)
  gc_frame_newslot(call785);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lineNumber (depth = 14)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = sum779;
  params[1] = diff783;
  params[2] = call785;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call786 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe773);
// compiled call node returning call786 (depth = 13)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe787 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call788 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe787);
// compiled call node returning call788 (depth = 13)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe789 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe790 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call791 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe790);
// compiled call node returning call791 (depth = 17)
// compiled member node returning call791 (depth = 16)
  partcv[0] = 0;
  Object call792 = callmethod(call791, "new",
    1, partcv, params);
  gc_frame_end(callframe789);
// compiled call node returning call792 (depth = 15)
// compiled member node returning call792 (depth = 14)
  *var_suggestion = call792;
  if (call792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe794 = gc_frame_new();
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call796 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe795);
// compiled call node returning call796 (depth = 15)
// compiled member node returning call796 (depth = 14)
  gc_frame_newslot(call796);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num798 = alloc_Float64(1);
// compiled num node returning num798 (depth = 15)
  int op_slot_right_797 = gc_frame_newslot(num798);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_797 = gc_frame_newslot(*var_linePosition);
  params[0] = num798;
  partcv[0] = 1;
  Object diff800 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff800 (depth = 14)
  gc_frame_newslot(diff800);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lineNumber (depth = 14)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = call796;
  params[1] = diff800;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call801 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe794);
// compiled call node returning call801 (depth = 13)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe802 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call803 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe802);
// compiled call node returning call803 (depth = 13)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe804 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit805 == NULL) {
    strlit805 = alloc_String("The fractional part of a number must be in base 10.");
    gc_root(strlit805);
  }
// compiled string node returning strlit805 (depth = 14)
  gc_frame_newslot(strlit805);
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lineNumber (depth = 14)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num807 = alloc_Float64(1);
// compiled num node returning num807 (depth = 15)
  int op_slot_right_806 = gc_frame_newslot(num807);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe809 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call810 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe809);
// compiled call node returning call810 (depth = 16)
// compiled member node returning call810 (depth = 15)
  int op_slot_left_806 = gc_frame_newslot(call810);
  params[0] = num807;
  partcv[0] = 1;
  Object sum811 = callmethod(call810, "+", 1, partcv, params);
// compiled op node returning sum811 (depth = 14)
  gc_frame_newslot(sum811);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num813 = alloc_Float64(1);
// compiled num node returning num813 (depth = 15)
  int op_slot_right_812 = gc_frame_newslot(num813);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_linePosition (depth = 15)
  int op_slot_left_812 = gc_frame_newslot(*var_linePosition);
  params[0] = num813;
  partcv[0] = 1;
  Object diff815 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff815 (depth = 14)
  gc_frame_newslot(diff815);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestions (depth = 14)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  params[0] = strlit805;
  params[1] = *var_lineNumber;
  params[2] = sum811;
  params[3] = diff815;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call816 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe804);
// compiled call node returning call816 (depth = 13)
    gc_frame_newslot(call816);
    if748 = call816;
  }
// compiled if node returning if748 (depth = 12)
    gc_frame_newslot(if748);
    if734 = if748;
  } else {
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 13)
  Object array817 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array817 (depth = 13)
  *var_suggestions = array817;
  if (array817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 12)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe818 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call820 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe819);
// compiled call node returning call820 (depth = 16)
// compiled member node returning call820 (depth = 15)
  partcv[0] = 0;
  Object call821 = callmethod(call820, "new",
    1, partcv, params);
  gc_frame_end(callframe818);
// compiled call node returning call821 (depth = 14)
// compiled member node returning call821 (depth = 13)
  *var_suggestion = call821;
  if (call821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 12)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe822 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe823 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call825 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe824);
// compiled call node returning call825 (depth = 16)
// compiled member node returning call825 (depth = 15)
  partcv[0] = 0;
  Object call826 = callmethod(call825, "linePos",
    1, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call826 (depth = 14)
// compiled member node returning call826 (depth = 13)
  gc_frame_newslot(call826);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num828 = alloc_Float64(1);
// compiled num node returning num828 (depth = 14)
  int op_slot_right_827 = gc_frame_newslot(num828);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call831 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe830);
// compiled call node returning call831 (depth = 15)
// compiled member node returning call831 (depth = 14)
  int op_slot_left_827 = gc_frame_newslot(call831);
  params[0] = num828;
  partcv[0] = 1;
  Object diff832 = callmethod(call831, "-", 1, partcv, params);
// compiled op node returning diff832 (depth = 13)
  gc_frame_newslot(diff832);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe833 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call835 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe834);
// compiled call node returning call835 (depth = 16)
// compiled member node returning call835 (depth = 15)
  partcv[0] = 0;
  Object call836 = callmethod(call835, "value",
    1, partcv, params);
  gc_frame_end(callframe833);
// compiled call node returning call836 (depth = 14)
// compiled member node returning call836 (depth = 13)
  gc_frame_newslot(call836);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call826;
  params[1] = diff832;
  params[2] = call836;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call837 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe822);
// compiled call node returning call837 (depth = 12)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe838 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call839 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe838);
// compiled call node returning call839 (depth = 12)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe840 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe841 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call842 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe841);
// compiled call node returning call842 (depth = 16)
// compiled member node returning call842 (depth = 15)
  partcv[0] = 0;
  Object call843 = callmethod(call842, "new",
    1, partcv, params);
  gc_frame_end(callframe840);
// compiled call node returning call843 (depth = 14)
// compiled member node returning call843 (depth = 13)
  *var_suggestion = call843;
  if (call843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe845 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe846 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call847 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe846);
// compiled call node returning call847 (depth = 14)
// compiled member node returning call847 (depth = 13)
  gc_frame_newslot(call847);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call847;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call848 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe845);
// compiled call node returning call848 (depth = 12)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe849 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call850 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe849);
// compiled call node returning call850 (depth = 12)
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe851 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit853 == NULL) {
    strlit853 = alloc_String(" cannot have a fractional part.");
    gc_root(strlit853);
  }
// compiled string node returning strlit853 (depth = 14)
  int op_slot_right_852 = gc_frame_newslot(strlit853);
// starting to compile op node (depth = 14)
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe856 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe857 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call858 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe857);
// compiled call node returning call858 (depth = 18)
// compiled member node returning call858 (depth = 17)
  partcv[0] = 0;
  Object call859 = callmethod(call858, "base",
    1, partcv, params);
  gc_frame_end(callframe856);
// compiled call node returning call859 (depth = 16)
// compiled member node returning call859 (depth = 15)
  int op_slot_right_855 = gc_frame_newslot(call859);
// starting to compile string node (depth = 15)
  if (strlit861 == NULL) {
    strlit861 = alloc_String("A number in base ");
    gc_root(strlit861);
  }
// compiled string node returning strlit861 (depth = 15)
  int op_slot_left_855 = gc_frame_newslot(strlit861);
  params[0] = call859;
  partcv[0] = 1;
  Object opresult862 = callmethod(strlit861, "++", 1, partcv, params);
// compiled op node returning opresult862 (depth = 14)
  int op_slot_left_852 = gc_frame_newslot(opresult862);
  params[0] = strlit853;
  partcv[0] = 1;
  Object opresult863 = callmethod(opresult862, "++", 1, partcv, params);
// compiled op node returning opresult863 (depth = 13)
  gc_frame_newslot(opresult863);
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call865 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe864);
// compiled call node returning call865 (depth = 14)
// compiled member node returning call865 (depth = 13)
  gc_frame_newslot(call865);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num867 = alloc_Float64(1);
// compiled num node returning num867 (depth = 14)
  int op_slot_right_866 = gc_frame_newslot(num867);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_linePosition (depth = 14)
  int op_slot_left_866 = gc_frame_newslot(*var_linePosition);
  params[0] = num867;
  partcv[0] = 1;
  Object diff869 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff869 (depth = 13)
  gc_frame_newslot(diff869);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestions (depth = 13)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  params[0] = opresult863;
  params[1] = *var_lineNumber;
  params[2] = call865;
  params[3] = diff869;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call870 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe851);
// compiled call node returning call870 (depth = 12)
    gc_frame_newslot(call870);
    if734 = call870;
  }
// compiled if node returning if734 (depth = 11)
    gc_frame_newslot(if734);
    if725 = if734;
  } else {
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit873 == NULL) {
    strlit873 = alloc_String("string");
    gc_root(strlit873);
  }
// compiled string node returning strlit873 (depth = 13)
  int op_slot_right_872 = gc_frame_newslot(strlit873);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe875 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe876 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_tokens (depth = 17)
  partcv[0] = 0;
  Object call877 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe876);
// compiled call node returning call877 (depth = 16)
// compiled member node returning call877 (depth = 15)
  partcv[0] = 0;
  Object call878 = callmethod(call877, "kind",
    1, partcv, params);
  gc_frame_end(callframe875);
// compiled call node returning call878 (depth = 14)
// compiled member node returning call878 (depth = 13)
  int op_slot_left_872 = gc_frame_newslot(call878);
  params[0] = strlit873;
  partcv[0] = 1;
  Object opresult879 = callmethod(call878, "==", 1, partcv, params);
// compiled op node returning opresult879 (depth = 12)
  Object if871 = done;
  if (istrue(opresult879)) {
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 12)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe880 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe881 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_errormessages (depth = 17)
  partcv[0] = 0;
  Object call882 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe881);
// compiled call node returning call882 (depth = 16)
// compiled member node returning call882 (depth = 15)
  partcv[0] = 0;
  Object call883 = callmethod(call882, "new",
    1, partcv, params);
  gc_frame_end(callframe880);
// compiled call node returning call883 (depth = 14)
// compiled member node returning call883 (depth = 13)
  *var_suggestion = call883;
  if (call883 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 12)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe884 = gc_frame_new();
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe885 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call886 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe885);
// compiled call node returning call886 (depth = 14)
// compiled member node returning call886 (depth = 13)
  gc_frame_newslot(call886);
// starting to compile string node (depth = 13)
  if (strlit887 == NULL) {
    strlit887 = alloc_String("++");
    gc_root(strlit887);
  }
// compiled string node returning strlit887 (depth = 13)
  gc_frame_newslot(strlit887);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call889 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe888);
// compiled call node returning call889 (depth = 14)
// compiled member node returning call889 (depth = 13)
  gc_frame_newslot(call889);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = call886;
  params[1] = strlit887;
  params[2] = call889;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call890 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe884);
// compiled call node returning call890 (depth = 12)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe891 = gc_frame_new();
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit893 == NULL) {
    strlit893 = alloc_String("To join a number to a string, use '++'.");
    gc_root(strlit893);
  }
// compiled string node returning strlit893 (depth = 14)
  int op_slot_right_892 = gc_frame_newslot(strlit893);
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit895 == NULL) {
    strlit895 = alloc_String("A number may follow a '.' only if there is a number before the '.'. ");
    gc_root(strlit895);
  }
// compiled string node returning strlit895 (depth = 14)
  int op_slot_left_892 = gc_frame_newslot(strlit895);
  params[0] = strlit893;
  partcv[0] = 1;
  Object opresult896 = callmethod(strlit895, "++", 1, partcv, params);
// compiled op node returning opresult896 (depth = 13)
  gc_frame_newslot(opresult896);
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe897 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call898 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe897);
// compiled call node returning call898 (depth = 14)
// compiled member node returning call898 (depth = 13)
  gc_frame_newslot(call898);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call900 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe899);
// compiled call node returning call900 (depth = 14)
// compiled member node returning call900 (depth = 13)
  gc_frame_newslot(call900);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_dot (depth = 15)
  partcv[0] = 0;
  Object call902 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe901);
// compiled call node returning call902 (depth = 14)
// compiled member node returning call902 (depth = 13)
  gc_frame_newslot(call902);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  params[0] = opresult896;
  params[1] = call898;
  params[2] = call900;
  params[3] = call902;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call903 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe891);
// compiled call node returning call903 (depth = 12)
    gc_frame_newslot(call903);
    if871 = call903;
  } else {
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit907 == NULL) {
    strlit907 = alloc_String("bind");
    gc_root(strlit907);
  }
// compiled string node returning strlit907 (depth = 15)
  int op_slot_right_906 = gc_frame_newslot(strlit907);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe909 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe910 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call911 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe910);
// compiled call node returning call911 (depth = 18)
// compiled member node returning call911 (depth = 17)
  partcv[0] = 0;
  Object call912 = callmethod(call911, "kind",
    1, partcv, params);
  gc_frame_end(callframe909);
// compiled call node returning call912 (depth = 16)
// compiled member node returning call912 (depth = 15)
  int op_slot_left_906 = gc_frame_newslot(call912);
  params[0] = strlit907;
  partcv[0] = 1;
  Object opresult913 = callmethod(call912, "==", 1, partcv, params);
// compiled op node returning opresult913 (depth = 14)
  int op_slot_right_905 = gc_frame_newslot(opresult913);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit916 == NULL) {
    strlit916 = alloc_String("op");
    gc_root(strlit916);
  }
// compiled string node returning strlit916 (depth = 15)
  int op_slot_right_915 = gc_frame_newslot(strlit916);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe918 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call920 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe919);
// compiled call node returning call920 (depth = 18)
// compiled member node returning call920 (depth = 17)
  partcv[0] = 0;
  Object call921 = callmethod(call920, "kind",
    1, partcv, params);
  gc_frame_end(callframe918);
// compiled call node returning call921 (depth = 16)
// compiled member node returning call921 (depth = 15)
  int op_slot_left_915 = gc_frame_newslot(call921);
  params[0] = strlit916;
  partcv[0] = 1;
  Object opresult922 = callmethod(call921, "==", 1, partcv, params);
// compiled op node returning opresult922 (depth = 14)
  int op_slot_left_905 = gc_frame_newslot(opresult922);
  params[0] = opresult913;
  partcv[0] = 1;
  Object opresult923 = callmethod(opresult922, "||", 1, partcv, params);
// compiled op node returning opresult923 (depth = 13)
  Object if904 = done;
  if (istrue(opresult923)) {
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe924 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_errormessages (depth = 18)
  partcv[0] = 0;
  Object call926 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe925);
// compiled call node returning call926 (depth = 17)
// compiled member node returning call926 (depth = 16)
  partcv[0] = 0;
  Object call927 = callmethod(call926, "new",
    1, partcv, params);
  gc_frame_end(callframe924);
// compiled call node returning call927 (depth = 15)
// compiled member node returning call927 (depth = 14)
  *var_suggestion = call927;
  if (call927 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe928 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit929 == NULL) {
    strlit929 = alloc_String("0");
    gc_root(strlit929);
  }
// compiled string node returning strlit929 (depth = 14)
  gc_frame_newslot(strlit929);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call931 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe930);
// compiled call node returning call931 (depth = 15)
// compiled member node returning call931 (depth = 14)
  gc_frame_newslot(call931);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe932 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call933 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe932);
// compiled call node returning call933 (depth = 15)
// compiled member node returning call933 (depth = 14)
  gc_frame_newslot(call933);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  params[0] = strlit929;
  params[1] = call931;
  params[2] = call933;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call934 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe928);
// compiled call node returning call934 (depth = 13)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe935 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit936 == NULL) {
    strlit936 = alloc_String("A number must have a digit before the decimal point.");
    gc_root(strlit936);
  }
// compiled string node returning strlit936 (depth = 14)
  gc_frame_newslot(strlit936);
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call938 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe937);
// compiled call node returning call938 (depth = 15)
// compiled member node returning call938 (depth = 14)
  gc_frame_newslot(call938);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_dot (depth = 16)
  partcv[0] = 0;
  Object call940 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe939);
// compiled call node returning call940 (depth = 15)
// compiled member node returning call940 (depth = 14)
  gc_frame_newslot(call940);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_suggestion (depth = 14)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  params[0] = strlit936;
  params[1] = call938;
  params[2] = call940;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call941 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe935);
// compiled call node returning call941 (depth = 13)
    gc_frame_newslot(call941);
    if904 = call941;
  } else {
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit944 == NULL) {
    strlit944 = alloc_String("identifier");
    gc_root(strlit944);
  }
// compiled string node returning strlit944 (depth = 15)
  int op_slot_right_943 = gc_frame_newslot(strlit944);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe946 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe947 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call948 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe947);
// compiled call node returning call948 (depth = 18)
// compiled member node returning call948 (depth = 17)
  partcv[0] = 0;
  Object call949 = callmethod(call948, "kind",
    1, partcv, params);
  gc_frame_end(callframe946);
// compiled call node returning call949 (depth = 16)
// compiled member node returning call949 (depth = 15)
  int op_slot_left_943 = gc_frame_newslot(call949);
  params[0] = strlit944;
  partcv[0] = 1;
  Object opresult950 = callmethod(call949, "==", 1, partcv, params);
// compiled op node returning opresult950 (depth = 14)
  Object if942 = done;
  if (istrue(opresult950)) {
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 14)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 15)
  Object array951 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array951 (depth = 15)
  *var_suggestions = array951;
  if (array951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 14)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit954 == NULL) {
    strlit954 = alloc_String("o");
    gc_root(strlit954);
  }
// compiled string node returning strlit954 (depth = 16)
  int op_slot_right_953 = gc_frame_newslot(strlit954);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe956 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_tokens (depth = 20)
  partcv[0] = 0;
  Object call958 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe957);
// compiled call node returning call958 (depth = 19)
// compiled member node returning call958 (depth = 18)
  partcv[0] = 0;
  Object call959 = callmethod(call958, "value",
    1, partcv, params);
  gc_frame_end(callframe956);
// compiled call node returning call959 (depth = 17)
// compiled member node returning call959 (depth = 16)
  int op_slot_left_953 = gc_frame_newslot(call959);
  params[0] = strlit954;
  partcv[0] = 1;
  Object opresult960 = callmethod(call959, "==", 1, partcv, params);
// compiled op node returning opresult960 (depth = 15)
  Object if952 = done;
  if (istrue(opresult960)) {
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 15)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe961 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_errormessages (depth = 20)
  partcv[0] = 0;
  Object call963 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe962);
// compiled call node returning call963 (depth = 19)
// compiled member node returning call963 (depth = 18)
  partcv[0] = 0;
  Object call964 = callmethod(call963, "new",
    1, partcv, params);
  gc_frame_end(callframe961);
// compiled call node returning call964 (depth = 17)
// compiled member node returning call964 (depth = 16)
  *var_suggestion = call964;
  if (call964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 15)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe965 = gc_frame_new();
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe966 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_tokens (depth = 20)
  partcv[0] = 0;
  Object call968 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe967);
// compiled call node returning call968 (depth = 19)
// compiled member node returning call968 (depth = 18)
  partcv[0] = 0;
  Object call969 = callmethod(call968, "linePos",
    1, partcv, params);
  gc_frame_end(callframe966);
// compiled call node returning call969 (depth = 17)
// compiled member node returning call969 (depth = 16)
  gc_frame_newslot(call969);
// starting to compile string node (depth = 16)
  if (strlit970 == NULL) {
    strlit970 = alloc_String("0");
    gc_root(strlit970);
  }
// compiled string node returning strlit970 (depth = 16)
  gc_frame_newslot(strlit970);
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe971 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_tokens (depth = 20)
  partcv[0] = 0;
  Object call973 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe972);
// compiled call node returning call973 (depth = 19)
// compiled member node returning call973 (depth = 18)
  partcv[0] = 0;
  Object call974 = callmethod(call973, "line",
    1, partcv, params);
  gc_frame_end(callframe971);
// compiled call node returning call974 (depth = 17)
// compiled member node returning call974 (depth = 16)
  gc_frame_newslot(call974);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_suggestion (depth = 16)
  params[0] = call969;
  params[1] = strlit970;
  params[2] = call974;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call975 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe965);
// compiled call node returning call975 (depth = 15)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe976 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_suggestion (depth = 16)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_suggestions (depth = 16)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call977 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe976);
// compiled call node returning call977 (depth = 15)
    gc_frame_newslot(call977);
    if952 = call977;
  } else {
  }
// compiled if node returning if952 (depth = 14)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 14)
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe978 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_errormessages (depth = 19)
  partcv[0] = 0;
  Object call980 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe979);
// compiled call node returning call980 (depth = 18)
// compiled member node returning call980 (depth = 17)
  partcv[0] = 0;
  Object call981 = callmethod(call980, "new",
    1, partcv, params);
  gc_frame_end(callframe978);
// compiled call node returning call981 (depth = 16)
// compiled member node returning call981 (depth = 15)
  *var_suggestion = call981;
  if (call981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 14)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe982 = gc_frame_new();
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call984 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe983);
// compiled call node returning call984 (depth = 16)
// compiled member node returning call984 (depth = 15)
  gc_frame_newslot(call984);
// starting to compile op node (depth = 15)
// starting to compile num node (depth = 16)
  Object num986 = alloc_Float64(1);
// compiled num node returning num986 (depth = 16)
  int op_slot_right_985 = gc_frame_newslot(num986);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  int op_slot_left_985 = gc_frame_newslot(*var_linePosition);
  params[0] = num986;
  partcv[0] = 1;
  Object diff988 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff988 (depth = 15)
  gc_frame_newslot(diff988);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit990 == NULL) {
    strlit990 = alloc_String(")");
    gc_root(strlit990);
  }
// compiled string node returning strlit990 (depth = 16)
  int op_slot_right_989 = gc_frame_newslot(strlit990);
// starting to compile op node (depth = 16)
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_right_992 = gc_frame_newslot(*var_accum);
// starting to compile string node (depth = 17)
  if (strlit994 == NULL) {
    strlit994 = alloc_String("(");
    gc_root(strlit994);
  }
// compiled string node returning strlit994 (depth = 17)
  int op_slot_left_992 = gc_frame_newslot(strlit994);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult995 = callmethod(strlit994, "++", 1, partcv, params);
// compiled op node returning opresult995 (depth = 16)
  int op_slot_left_989 = gc_frame_newslot(opresult995);
  params[0] = strlit990;
  partcv[0] = 1;
  Object opresult996 = callmethod(opresult995, "++", 1, partcv, params);
// compiled op node returning opresult996 (depth = 15)
  gc_frame_newslot(opresult996);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe997 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe998 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_tokens (depth = 19)
  partcv[0] = 0;
  Object call999 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe998);
// compiled call node returning call999 (depth = 18)
// compiled member node returning call999 (depth = 17)
  partcv[0] = 0;
  Object call1000 = callmethod(call999, "line",
    1, partcv, params);
  gc_frame_end(callframe997);
// compiled call node returning call1000 (depth = 16)
// compiled member node returning call1000 (depth = 15)
  gc_frame_newslot(call1000);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestion (depth = 15)
  params[0] = call984;
  params[1] = diff988;
  params[2] = opresult996;
  params[3] = call1000;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1001 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe982);
// compiled call node returning call1001 (depth = 14)
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1002 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestion (depth = 15)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestions (depth = 15)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1003 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1002);
// compiled call node returning call1003 (depth = 14)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1004 = gc_frame_new();
// starting to compile string node (depth = 15)
  if (strlit1005 == NULL) {
    strlit1005 = alloc_String("A number may follow a '.' only if there is a number before the '.'.");
    gc_root(strlit1005);
  }
// compiled string node returning strlit1005 (depth = 15)
  gc_frame_newslot(strlit1005);
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1007 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe1006);
// compiled call node returning call1007 (depth = 16)
// compiled member node returning call1007 (depth = 15)
  gc_frame_newslot(call1007);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1009 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1008);
// compiled call node returning call1009 (depth = 16)
// compiled member node returning call1009 (depth = 15)
  gc_frame_newslot(call1009);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1011 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1010);
// compiled call node returning call1011 (depth = 16)
// compiled member node returning call1011 (depth = 15)
  gc_frame_newslot(call1011);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_suggestions (depth = 15)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  params[0] = strlit1005;
  params[1] = call1007;
  params[2] = call1009;
  params[3] = call1011;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1012 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1004);
// compiled call node returning call1012 (depth = 14)
    gc_frame_newslot(call1012);
    if942 = call1012;
  } else {
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe1013 = gc_frame_new();
// starting to compile string node (depth = 15)
  if (strlit1014 == NULL) {
    strlit1014 = alloc_String("A number may follow a '.' only if there is a number before the '.'.");
    gc_root(strlit1014);
  }
// compiled string node returning strlit1014 (depth = 15)
  gc_frame_newslot(strlit1014);
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1015 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1016 = callmethod(*var_dot, "line",
    1, partcv, params);
  gc_frame_end(callframe1015);
// compiled call node returning call1016 (depth = 16)
// compiled member node returning call1016 (depth = 15)
  gc_frame_newslot(call1016);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1017 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1018 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1017);
// compiled call node returning call1018 (depth = 16)
// compiled member node returning call1018 (depth = 15)
  gc_frame_newslot(call1018);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_dot (depth = 17)
  partcv[0] = 0;
  Object call1020 = callmethod(*var_dot, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1019);
// compiled call node returning call1020 (depth = 16)
// compiled member node returning call1020 (depth = 15)
  gc_frame_newslot(call1020);
// call case 6: other member request
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  params[0] = strlit1014;
  params[1] = call1016;
  params[2] = call1018;
  params[3] = call1020;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call1021 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe1013);
// compiled call node returning call1021 (depth = 14)
    gc_frame_newslot(call1021);
    if942 = call1021;
  }
// compiled if node returning if942 (depth = 13)
    gc_frame_newslot(if942);
    if904 = if942;
  }
// compiled if node returning if904 (depth = 12)
    gc_frame_newslot(if904);
    if871 = if904;
  }
// compiled if node returning if871 (depth = 11)
    gc_frame_newslot(if871);
    if725 = if871;
  }
// compiled if node returning if725 (depth = 10)
    gc_frame_newslot(if725);
    if703 = if725;
  } else {
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1022 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call1023 = callmethodflags(self, "makeNumToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1022);
// compiled call node returning call1023 (depth = 11)
  *var_tok = call1023;
  if (call1023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if703 = done;
  }
// compiled if node returning if703 (depth = 9)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1025 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call1026 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1025);
// compiled call node returning call1026 (depth = 9)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool1027 = alloc_Boolean(1);
// compiled identifier node returning bool1027 (depth = 10)
  *var_isDone = bool1027;
  if (bool1027 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if698 = done;
  } else {
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1031 == NULL) {
    strlit1031 = alloc_String("o");
    gc_root(strlit1031);
  }
// compiled string node returning strlit1031 (depth = 11)
  int op_slot_right_1030 = gc_frame_newslot(strlit1031);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_1030 = gc_frame_newslot(*var_mode);
  params[0] = strlit1031;
  partcv[0] = 1;
  Object opresult1033 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1033 (depth = 10)
  Object if1029 = done;
  if (istrue(opresult1033)) {
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1034 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  gc_frame_newslot(*var_accum);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_OpToken (depth = 12)
  params[0] = *var_accum;
  partcv[0] = 1;
  Object call1035 = callmethod(*var_OpToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 11)
  *var_tok = call1035;
  if (call1035 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1039 == NULL) {
    strlit1039 = alloc_String("->");
    gc_root(strlit1039);
  }
// compiled string node returning strlit1039 (depth = 12)
  int op_slot_right_1038 = gc_frame_newslot(strlit1039);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  int op_slot_left_1038 = gc_frame_newslot(*var_accum);
  params[0] = strlit1039;
  partcv[0] = 1;
  Object opresult1041 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1041 (depth = 11)
  Object if1037 = done;
  if (istrue(opresult1041)) {
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ArrowToken (depth = 14)
  partcv[0] = 0;
  Object call1043 = callmethod(*var_ArrowToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1042);
// compiled call node returning call1043 (depth = 13)
// compiled member node returning call1043 (depth = 12)
  *var_tok = call1043;
  if (call1043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if1037 = done;
  } else {
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1047 == NULL) {
    strlit1047 = alloc_String(":=");
    gc_root(strlit1047);
  }
// compiled string node returning strlit1047 (depth = 13)
  int op_slot_right_1046 = gc_frame_newslot(strlit1047);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_1046 = gc_frame_newslot(*var_accum);
  params[0] = strlit1047;
  partcv[0] = 1;
  Object opresult1049 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1049 (depth = 12)
  Object if1045 = done;
  if (istrue(opresult1049)) {
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1050 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_BindToken (depth = 15)
  partcv[0] = 0;
  Object call1051 = callmethod(*var_BindToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1050);
// compiled call node returning call1051 (depth = 14)
// compiled member node returning call1051 (depth = 13)
  *var_tok = call1051;
  if (call1051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if1045 = done;
  } else {
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1055 == NULL) {
    strlit1055 = alloc_String(":");
    gc_root(strlit1055);
  }
// compiled string node returning strlit1055 (depth = 14)
  int op_slot_right_1054 = gc_frame_newslot(strlit1055);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_1054 = gc_frame_newslot(*var_accum);
  params[0] = strlit1055;
  partcv[0] = 1;
  Object opresult1057 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult1057 (depth = 13)
  Object if1053 = done;
  if (istrue(opresult1057)) {
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1058 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_ColonToken (depth = 16)
  partcv[0] = 0;
  Object call1059 = callmethod(*var_ColonToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1058);
// compiled call node returning call1059 (depth = 15)
// compiled member node returning call1059 (depth = 14)
  *var_tok = call1059;
  if (call1059 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if1053 = done;
  } else {
  }
// compiled if node returning if1053 (depth = 12)
    gc_frame_newslot(if1053);
    if1045 = if1053;
  }
// compiled if node returning if1045 (depth = 11)
    gc_frame_newslot(if1045);
    if1037 = if1045;
  }
// compiled if node returning if1037 (depth = 10)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1061 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  gc_frame_newslot(*var_tok);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  params[0] = *var_tok;
  partcv[0] = 1;
  Object call1062 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1061);
// compiled call node returning call1062 (depth = 10)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
  Object bool1063 = alloc_Boolean(1);
// compiled identifier node returning bool1063 (depth = 11)
  *var_isDone = bool1063;
  if (bool1063 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1029 = done;
  } else {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1067 == NULL) {
    strlit1067 = alloc_String("d");
    gc_root(strlit1067);
  }
// compiled string node returning strlit1067 (depth = 12)
  int op_slot_right_1066 = gc_frame_newslot(strlit1067);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  int op_slot_left_1066 = gc_frame_newslot(*var_mode);
  params[0] = strlit1067;
  partcv[0] = 1;
  Object opresult1069 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1069 (depth = 11)
  Object if1065 = done;
  if (istrue(opresult1069)) {
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num1071 = alloc_Float64(1);
// compiled num node returning num1071 (depth = 13)
  int op_slot_right_1070 = gc_frame_newslot(num1071);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_1070 = gc_frame_newslot(*var_linePosition);
  params[0] = num1071;
  partcv[0] = 1;
  Object diff1073 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1073 (depth = 12)
  *var_indentLevel = diff1073;
  if (diff1073 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
  Object bool1075 = alloc_Boolean(1);
// compiled identifier node returning bool1075 (depth = 12)
  *var_isDone = bool1075;
  if (bool1075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if1065 = done;
  } else {
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1079 == NULL) {
    strlit1079 = alloc_String("n");
    gc_root(strlit1079);
  }
// compiled string node returning strlit1079 (depth = 13)
  int op_slot_right_1078 = gc_frame_newslot(strlit1079);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_mode (depth = 13)
  int op_slot_left_1078 = gc_frame_newslot(*var_mode);
  params[0] = strlit1079;
  partcv[0] = 1;
  Object opresult1081 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1081 (depth = 12)
  Object if1077 = done;
  if (istrue(opresult1081)) {
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
  Object bool1082 = alloc_Boolean(1);
// compiled identifier node returning bool1082 (depth = 13)
  *var_isDone = bool1082;
  if (bool1082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if1077 = done;
  } else {
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1086 == NULL) {
    strlit1086 = alloc_String("c");
    gc_root(strlit1086);
  }
// compiled string node returning strlit1086 (depth = 14)
  int op_slot_right_1085 = gc_frame_newslot(strlit1086);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_mode (depth = 14)
  int op_slot_left_1085 = gc_frame_newslot(*var_mode);
  params[0] = strlit1086;
  partcv[0] = 1;
  Object opresult1088 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1088 (depth = 13)
  Object if1084 = done;
  if (istrue(opresult1088)) {
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1089 = gc_frame_new();
// starting to compile num node (depth = 15)
  Object num1090 = alloc_Float64(3);
// compiled num node returning num1090 (depth = 15)
  gc_frame_newslot(num1090);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe1091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  partcv[0] = 0;
  Object call1092 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1091);
// compiled call node returning call1092 (depth = 16)
// compiled member node returning call1092 (depth = 15)
  gc_frame_newslot(call1092);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  params[0] = num1090;
  params[1] = call1092;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1093 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1089);
// compiled call node returning call1093 (depth = 14)
  *var_cmt = call1093;
  if (call1093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 13)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe1094 = gc_frame_new();
// starting to compile call node (depth = 14)
  int callframe1095 = gc_frame_new();
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_cmt (depth = 15)
  gc_frame_newslot(*var_cmt);
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_CommentToken (depth = 15)
  params[0] = *var_cmt;
  partcv[0] = 1;
  Object call1096 = callmethod(*var_CommentToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1095);
// compiled call node returning call1096 (depth = 14)
  gc_frame_newslot(call1096);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  params[0] = call1096;
  partcv[0] = 1;
  Object call1097 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe1094);
// compiled call node returning call1097 (depth = 13)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 14)
  Object bool1098 = alloc_Boolean(1);
// compiled identifier node returning bool1098 (depth = 14)
  *var_isDone = bool1098;
  if (bool1098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if1084 = done;
  } else {
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1102 == NULL) {
    strlit1102 = alloc_String("p");
    gc_root(strlit1102);
  }
// compiled string node returning strlit1102 (depth = 15)
  int op_slot_right_1101 = gc_frame_newslot(strlit1102);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_mode (depth = 15)
  int op_slot_left_1101 = gc_frame_newslot(*var_mode);
  params[0] = strlit1102;
  partcv[0] = 1;
  Object opresult1104 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult1104 (depth = 14)
  Object if1100 = done;
  if (istrue(opresult1104)) {
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1107 == NULL) {
    strlit1107 = alloc_String("#pragma ");
    gc_root(strlit1107);
  }
// compiled string node returning strlit1107 (depth = 16)
  int op_slot_right_1106 = gc_frame_newslot(strlit1107);
// starting to compile call node (depth = 16)
  int callframe1109 = gc_frame_new();
// starting to compile num node (depth = 17)
  Object num1110 = alloc_Float64(1);
// compiled num node returning num1110 (depth = 17)
  gc_frame_newslot(num1110);
// starting to compile num node (depth = 17)
  Object num1111 = alloc_Float64(8);
// compiled num node returning num1111 (depth = 17)
  gc_frame_newslot(num1111);
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  params[0] = num1110;
  params[1] = num1111;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1112 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1109);
// compiled call node returning call1112 (depth = 16)
  int op_slot_left_1106 = gc_frame_newslot(call1112);
  params[0] = strlit1107;
  partcv[0] = 1;
  Object opresult1113 = callmethod(call1112, "==", 1, partcv, params);
// compiled op node returning opresult1113 (depth = 15)
  Object if1105 = done;
  if (istrue(opresult1113)) {
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe1114 = gc_frame_new();
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 16)
  int callframe1115 = gc_frame_new();
// starting to compile num node (depth = 17)
  Object num1116 = alloc_Float64(9);
// compiled num node returning num1116 (depth = 17)
  gc_frame_newslot(num1116);
// starting to compile member node (depth = 17)
// starting to compile call node (depth = 18)
  int callframe1117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  partcv[0] = 0;
  Object call1118 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1117);
// compiled call node returning call1118 (depth = 18)
// compiled member node returning call1118 (depth = 17)
  gc_frame_newslot(call1118);
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  params[0] = num1116;
  params[1] = call1118;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1119 = callmethod(*var_accum, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe1115);
// compiled call node returning call1119 (depth = 16)
  gc_frame_newslot(call1119);
// call case 6: other member request
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_util (depth = 16)
  params[0] = call1119;
  partcv[0] = 1;
  Object call1120 = callmethod(*var_util, "processExtension",
    1, partcv, params);
  gc_frame_end(callframe1114);
// compiled call node returning call1120 (depth = 15)
    gc_frame_newslot(call1120);
    if1105 = call1120;
  } else {
  }
// compiled if node returning if1105 (depth = 14)
    gc_frame_newslot(if1105);
    if1100 = if1105;
  } else {
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_isDone (depth = 15)
  Object if1121 = done;
  if (istrue(*var_isDone)) {
    gc_frame_newslot(done);
    if1121 = done;
  } else {
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe1122 = gc_frame_new();
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit1124 == NULL) {
    strlit1124 = alloc_String(".");
    gc_root(strlit1124);
  }
// compiled string node returning strlit1124 (depth = 17)
  int op_slot_right_1123 = gc_frame_newslot(strlit1124);
// starting to compile op node (depth = 17)
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_right_1126 = gc_frame_newslot(*var_accum);
// starting to compile op node (depth = 18)
// starting to compile string node (depth = 19)
  if (strlit1129 == NULL) {
    strlit1129 = alloc_String(" with accum ");
    gc_root(strlit1129);
  }
// compiled string node returning strlit1129 (depth = 19)
  int op_slot_right_1128 = gc_frame_newslot(strlit1129);
// starting to compile op node (depth = 19)
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_mode (depth = 20)
  int op_slot_right_1131 = gc_frame_newslot(*var_mode);
// starting to compile string node (depth = 20)
  if (strlit1133 == NULL) {
    strlit1133 = alloc_String("Lexing error: no handler for mode ");
    gc_root(strlit1133);
  }
// compiled string node returning strlit1133 (depth = 20)
  int op_slot_left_1131 = gc_frame_newslot(strlit1133);
  params[0] = *var_mode;
  partcv[0] = 1;
  Object opresult1134 = callmethod(strlit1133, "++", 1, partcv, params);
// compiled op node returning opresult1134 (depth = 19)
  int op_slot_left_1128 = gc_frame_newslot(opresult1134);
  params[0] = strlit1129;
  partcv[0] = 1;
  Object opresult1135 = callmethod(opresult1134, "++", 1, partcv, params);
// compiled op node returning opresult1135 (depth = 18)
  int op_slot_left_1126 = gc_frame_newslot(opresult1135);
  params[0] = *var_accum;
  partcv[0] = 1;
  Object opresult1136 = callmethod(opresult1135, "++", 1, partcv, params);
// compiled op node returning opresult1136 (depth = 17)
  int op_slot_left_1123 = gc_frame_newslot(opresult1136);
  params[0] = strlit1124;
  partcv[0] = 1;
  Object opresult1137 = callmethod(opresult1136, "++", 1, partcv, params);
// compiled op node returning opresult1137 (depth = 16)
  gc_frame_newslot(opresult1137);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_lineNumber (depth = 16)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  params[0] = opresult1137;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call1138 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe1122);
// compiled call node returning call1138 (depth = 15)
    gc_frame_newslot(call1138);
    if1121 = call1138;
  }
// compiled if node returning if1121 (depth = 14)
    gc_frame_newslot(if1121);
    if1100 = if1121;
  }
// compiled if node returning if1100 (depth = 13)
    gc_frame_newslot(if1100);
    if1084 = if1100;
  }
// compiled if node returning if1084 (depth = 12)
    gc_frame_newslot(if1084);
    if1077 = if1084;
  }
// compiled if node returning if1077 (depth = 11)
    gc_frame_newslot(if1077);
    if1065 = if1077;
  }
// compiled if node returning if1065 (depth = 10)
    gc_frame_newslot(if1065);
    if1029 = if1065;
  }
// compiled if node returning if1029 (depth = 9)
    gc_frame_newslot(if1029);
    if698 = if1029;
  }
// compiled if node returning if698 (depth = 8)
    gc_frame_newslot(if698);
    if686 = if698;
  }
// compiled if node returning if686 (depth = 7)
    gc_frame_newslot(if686);
    if674 = if686;
  }
// compiled if node returning if674 (depth = 6)
    gc_frame_newslot(if674);
    if662 = if674;
  }
// compiled if node returning if662 (depth = 5)
    gc_frame_newslot(if662);
    if650 = if662;
  }
// compiled if node returning if650 (depth = 4)
    gc_frame_newslot(if650);
    if419 = if650;
  } else {
  }
// compiled if node returning if419 (depth = 3)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_linePosition (depth = 4)
  *var_startPosition = *var_linePosition;
  if (*var_linePosition == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer__apply1145(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_base = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_str = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_linePosition = getfromclosure(closure, 4);
  Object *var_lineNumber = getfromclosure(closure, 5);
  Object *var_i = getfromclosure(closure, 6);
  Object *var_unicode = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_inc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "inc");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_validDigits = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "validDigits");
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  partcv[0] = 0;
  Object call1147 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe1146);
// compiled call node returning call1147 (depth = 7)
// compiled member node returning call1147 (depth = 6)
  *var_n = call1147;
  if (call1147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_right_1148 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_val (depth = 7)
  int op_slot_left_1148 = gc_frame_newslot(*var_val);
  params[0] = *var_base;
  partcv[0] = 1;
  Object prod1150 = callmethod(*var_val, "*", 1, partcv, params);
// compiled op node returning prod1150 (depth = 6)
  *var_val = prod1150;
  if (prod1150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1152 = alloc_Float64(0);
// compiled num node returning num1152 (depth = 6)
  *var_inc = num1152;
  if (num1152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1156 = alloc_Float64(57);
// compiled num node returning num1156 (depth = 8)
  int op_slot_right_1155 = gc_frame_newslot(num1156);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1155 = gc_frame_newslot(*var_n);
  params[0] = num1156;
  partcv[0] = 1;
  Object opresult1158 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1158 (depth = 7)
  int op_slot_right_1154 = gc_frame_newslot(opresult1158);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1161 = alloc_Float64(48);
// compiled num node returning num1161 (depth = 8)
  int op_slot_right_1160 = gc_frame_newslot(num1161);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1160 = gc_frame_newslot(*var_n);
  params[0] = num1161;
  partcv[0] = 1;
  Object opresult1163 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1163 (depth = 7)
  int op_slot_left_1154 = gc_frame_newslot(opresult1163);
  params[0] = opresult1158;
  partcv[0] = 1;
  Object opresult1164 = callmethod(opresult1163, "&&", 1, partcv, params);
// compiled op node returning opresult1164 (depth = 6)
  Object if1153 = done;
  if (istrue(opresult1164)) {
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num1166 = alloc_Float64(48);
// compiled num node returning num1166 (depth = 8)
  int op_slot_right_1165 = gc_frame_newslot(num1166);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_left_1165 = gc_frame_newslot(*var_n);
  params[0] = num1166;
  partcv[0] = 1;
  Object diff1168 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1168 (depth = 7)
  *var_inc = diff1168;
  if (diff1168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1153 = done;
  } else {
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1173 = alloc_Float64(90);
// compiled num node returning num1173 (depth = 9)
  int op_slot_right_1172 = gc_frame_newslot(num1173);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1172 = gc_frame_newslot(*var_n);
  params[0] = num1173;
  partcv[0] = 1;
  Object opresult1175 = callmethod(*var_n, "<=", 1, partcv, params);
// compiled op node returning opresult1175 (depth = 8)
  int op_slot_right_1171 = gc_frame_newslot(opresult1175);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1178 = alloc_Float64(65);
// compiled num node returning num1178 (depth = 9)
  int op_slot_right_1177 = gc_frame_newslot(num1178);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1177 = gc_frame_newslot(*var_n);
  params[0] = num1178;
  partcv[0] = 1;
  Object opresult1180 = callmethod(*var_n, ">=", 1, partcv, params);
// compiled op node returning opresult1180 (depth = 8)
  int op_slot_left_1171 = gc_frame_newslot(opresult1180);
  params[0] = opresult1175;
  partcv[0] = 1;
  Object opresult1181 = callmethod(opresult1180, "&&", 1, partcv, params);
// compiled op node returning opresult1181 (depth = 7)
  Object if1170 = done;
  if (istrue(opresult1181)) {
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1183 = alloc_Float64(55);
// compiled num node returning num1183 (depth = 9)
  int op_slot_right_1182 = gc_frame_newslot(num1183);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1182 = gc_frame_newslot(*var_n);
  params[0] = num1183;
  partcv[0] = 1;
  Object diff1185 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1185 (depth = 8)
  *var_inc = diff1185;
  if (diff1185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1170 = done;
  } else {
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1188 = alloc_Float64(87);
// compiled num node returning num1188 (depth = 9)
  int op_slot_right_1187 = gc_frame_newslot(num1188);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  int op_slot_left_1187 = gc_frame_newslot(*var_n);
  params[0] = num1188;
  partcv[0] = 1;
  Object diff1190 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1190 (depth = 8)
  *var_inc = diff1190;
  if (diff1190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1170 = done;
  }
// compiled if node returning if1170 (depth = 6)
    gc_frame_newslot(if1170);
    if1153 = if1170;
  }
// compiled if node returning if1153 (depth = 5)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  int op_slot_right_1193 = gc_frame_newslot(*var_base);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inc (depth = 7)
  int op_slot_left_1193 = gc_frame_newslot(*var_inc);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1195 = callmethod(*var_inc, ">=", 1, partcv, params);
// compiled op node returning opresult1195 (depth = 6)
  Object if1192 = done;
  if (istrue(opresult1195)) {
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1199 = alloc_Float64(16);
// compiled num node returning num1199 (depth = 9)
  int op_slot_right_1198 = gc_frame_newslot(num1199);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_inc (depth = 9)
  int op_slot_left_1198 = gc_frame_newslot(*var_inc);
  params[0] = num1199;
  partcv[0] = 1;
  Object opresult1201 = callmethod(*var_inc, "<", 1, partcv, params);
// compiled op node returning opresult1201 (depth = 8)
  int op_slot_right_1197 = gc_frame_newslot(opresult1201);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1204 == NULL) {
    strlit1204 = alloc_String("0");
    gc_root(strlit1204);
  }
// compiled string node returning strlit1204 (depth = 9)
  int op_slot_right_1203 = gc_frame_newslot(strlit1204);
// starting to compile index node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_str (depth = 10)
// starting to compile num node (depth = 10)
  Object num1206 = alloc_Float64(1);
// compiled num node returning num1206 (depth = 10)
  params[0] = num1206;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1207 = callmethod(*var_str, "[]", 1, partcv, params);
// compiled index node returning idxres1207 (depth = 9)
  int op_slot_left_1203 = gc_frame_newslot(idxres1207);
  params[0] = strlit1204;
  partcv[0] = 1;
  Object opresult1208 = callmethod(idxres1207, "==", 1, partcv, params);
// compiled op node returning opresult1208 (depth = 8)
  int op_slot_left_1197 = gc_frame_newslot(opresult1208);
  params[0] = opresult1201;
  partcv[0] = 1;
  Object opresult1209 = callmethod(opresult1208, "&&", 1, partcv, params);
// compiled op node returning opresult1209 (depth = 7)
  Object if1196 = done;
  if (istrue(opresult1209)) {
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1210 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1212 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1211);
// compiled call node returning call1212 (depth = 11)
// compiled member node returning call1212 (depth = 10)
  partcv[0] = 0;
  Object call1213 = callmethod(call1212, "new",
    1, partcv, params);
  gc_frame_end(callframe1210);
// compiled call node returning call1213 (depth = 9)
// compiled member node returning call1213 (depth = 8)
  *var_suggestion = call1213;
  if (call1213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1214 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1215 == NULL) {
    strlit1215 = alloc_String("x");
    gc_root(strlit1215);
  }
// compiled string node returning strlit1215 (depth = 8)
  gc_frame_newslot(strlit1215);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1217 = alloc_Float64(1);
// compiled num node returning num1217 (depth = 9)
  int op_slot_right_1216 = gc_frame_newslot(num1217);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1221 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1220);
// compiled call node returning call1221 (depth = 11)
// compiled member node returning call1221 (depth = 10)
  int op_slot_right_1219 = gc_frame_newslot(call1221);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1219 = gc_frame_newslot(*var_linePosition);
  params[0] = call1221;
  partcv[0] = 1;
  Object diff1223 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1223 (depth = 9)
  int op_slot_left_1216 = gc_frame_newslot(diff1223);
  params[0] = num1217;
  partcv[0] = 1;
  Object sum1224 = callmethod(diff1223, "+", 1, partcv, params);
// compiled op node returning sum1224 (depth = 8)
  gc_frame_newslot(sum1224);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1215;
  params[1] = sum1224;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1225 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe1214);
// compiled call node returning call1225 (depth = 7)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1226 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1227 == NULL) {
    strlit1227 = alloc_String("A number in base 16 must start with '0x'.");
    gc_root(strlit1227);
  }
// compiled string node returning strlit1227 (depth = 8)
  gc_frame_newslot(strlit1227);
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1229 = alloc_Float64(1);
// compiled num node returning num1229 (depth = 9)
  int op_slot_right_1228 = gc_frame_newslot(num1229);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1233 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1232);
// compiled call node returning call1233 (depth = 11)
// compiled member node returning call1233 (depth = 10)
  int op_slot_right_1231 = gc_frame_newslot(call1233);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1231 = gc_frame_newslot(*var_linePosition);
  params[0] = call1233;
  partcv[0] = 1;
  Object diff1235 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1235 (depth = 9)
  int op_slot_left_1228 = gc_frame_newslot(diff1235);
  params[0] = num1229;
  partcv[0] = 1;
  Object sum1236 = callmethod(diff1235, "+", 1, partcv, params);
// compiled op node returning sum1236 (depth = 8)
  gc_frame_newslot(sum1236);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1227;
  params[1] = *var_lineNumber;
  params[2] = sum1236;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1237 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1226);
// compiled call node returning call1237 (depth = 7)
    gc_frame_newslot(call1237);
    if1196 = call1237;
  } else {
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1238 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1240 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1239);
// compiled call node returning call1240 (depth = 11)
// compiled member node returning call1240 (depth = 10)
  partcv[0] = 0;
  Object call1241 = callmethod(call1240, "new",
    1, partcv, params);
  gc_frame_end(callframe1238);
// compiled call node returning call1241 (depth = 9)
// compiled member node returning call1241 (depth = 8)
  *var_suggestion = call1241;
  if (call1241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1244 = alloc_Float64(1);
// compiled num node returning num1244 (depth = 9)
  int op_slot_right_1243 = gc_frame_newslot(num1244);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1246 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_str (depth = 11)
  partcv[0] = 0;
  Object call1247 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1246);
// compiled call node returning call1247 (depth = 10)
// compiled member node returning call1247 (depth = 9)
  int op_slot_left_1243 = gc_frame_newslot(call1247);
  params[0] = num1244;
  partcv[0] = 1;
  Object opresult1248 = callmethod(call1247, "==", 1, partcv, params);
// compiled op node returning opresult1248 (depth = 8)
  Object if1242 = done;
  if (istrue(opresult1248)) {
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1249 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1251 = alloc_Float64(1);
// compiled num node returning num1251 (depth = 10)
  int op_slot_right_1250 = gc_frame_newslot(num1251);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_str (depth = 13)
  partcv[0] = 0;
  Object call1255 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1254);
// compiled call node returning call1255 (depth = 12)
// compiled member node returning call1255 (depth = 11)
  int op_slot_right_1253 = gc_frame_newslot(call1255);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_1253 = gc_frame_newslot(*var_linePosition);
  params[0] = call1255;
  partcv[0] = 1;
  Object diff1257 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1257 (depth = 10)
  int op_slot_left_1250 = gc_frame_newslot(diff1257);
  params[0] = num1251;
  partcv[0] = 1;
  Object diff1258 = callmethod(diff1257, "-", 1, partcv, params);
// compiled op node returning diff1258 (depth = 9)
  gc_frame_newslot(diff1258);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1260 = alloc_Float64(1);
// compiled num node returning num1260 (depth = 10)
  int op_slot_right_1259 = gc_frame_newslot(num1260);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1259 = gc_frame_newslot(*var_linePosition);
  params[0] = num1260;
  partcv[0] = 1;
  Object diff1262 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1262 (depth = 9)
  gc_frame_newslot(diff1262);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff1258;
  params[1] = diff1262;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1263 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1249);
// compiled call node returning call1263 (depth = 8)
    gc_frame_newslot(call1263);
    if1242 = call1263;
  } else {
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1264 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_right_1265 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1268 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_str (depth = 13)
  partcv[0] = 0;
  Object call1269 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1268);
// compiled call node returning call1269 (depth = 12)
// compiled member node returning call1269 (depth = 11)
  int op_slot_right_1267 = gc_frame_newslot(call1269);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_1267 = gc_frame_newslot(*var_linePosition);
  params[0] = call1269;
  partcv[0] = 1;
  Object diff1271 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1271 (depth = 10)
  int op_slot_left_1265 = gc_frame_newslot(diff1271);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1272 = callmethod(diff1271, "+", 1, partcv, params);
// compiled op node returning sum1272 (depth = 9)
  gc_frame_newslot(sum1272);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum1272;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1273 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe1264);
// compiled call node returning call1273 (depth = 8)
    gc_frame_newslot(call1273);
    if1242 = call1273;
  }
// compiled if node returning if1242 (depth = 7)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile if node (depth = 8)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1276 = alloc_Float64(10);
// compiled num node returning num1276 (depth = 10)
  int op_slot_right_1275 = gc_frame_newslot(num1276);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_base (depth = 10)
  int op_slot_left_1275 = gc_frame_newslot(*var_base);
  params[0] = num1276;
  partcv[0] = 1;
  Object opresult1278 = callmethod(*var_base, "<=", 1, partcv, params);
// compiled op node returning opresult1278 (depth = 9)
  Object if1274 = done;
struct StackFrameObject *iftmpstackframe1274 = stackframe;
  if (istrue(opresult1278)) {
stackframe = alloc_StackFrame(0, iftmpstackframe1274);
gc_frame_newslot((Object)stackframe);
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1280 == NULL) {
    strlit1280 = alloc_String("'");
    gc_root(strlit1280);
  }
// compiled string node returning strlit1280 (depth = 10)
  int op_slot_right_1279 = gc_frame_newslot(strlit1280);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1284 = alloc_Float64(1);
// compiled num node returning num1284 (depth = 12)
  int op_slot_right_1283 = gc_frame_newslot(num1284);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_base (depth = 12)
  int op_slot_left_1283 = gc_frame_newslot(*var_base);
  params[0] = num1284;
  partcv[0] = 1;
  Object diff1286 = callmethod(*var_base, "-", 1, partcv, params);
// compiled op node returning diff1286 (depth = 11)
  int op_slot_right_1282 = gc_frame_newslot(diff1286);
// starting to compile string node (depth = 11)
  if (strlit1288 == NULL) {
    strlit1288 = alloc_String("'0' to '");
    gc_root(strlit1288);
  }
// compiled string node returning strlit1288 (depth = 11)
  int op_slot_left_1282 = gc_frame_newslot(strlit1288);
  params[0] = diff1286;
  partcv[0] = 1;
  Object opresult1289 = callmethod(strlit1288, "++", 1, partcv, params);
// compiled op node returning opresult1289 (depth = 10)
  int op_slot_left_1279 = gc_frame_newslot(opresult1289);
  params[0] = strlit1280;
  partcv[0] = 1;
  Object opresult1290 = callmethod(opresult1289, "++", 1, partcv, params);
// compiled op node returning opresult1290 (depth = 9)
    gc_frame_newslot(opresult1290);
    if1274 = opresult1290;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe1274);
  gc_frame_newslot((Object)stackframe);
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1292 == NULL) {
    strlit1292 = alloc_String("'");
    gc_root(strlit1292);
  }
// compiled string node returning strlit1292 (depth = 10)
  int op_slot_right_1291 = gc_frame_newslot(strlit1292);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1295 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_base (depth = 13)
  int op_slot_right_1296 = gc_frame_newslot(*var_base);
// starting to compile num node (depth = 13)
  Object num1298 = alloc_Float64(87);
// compiled num node returning num1298 (depth = 13)
  int op_slot_left_1296 = gc_frame_newslot(num1298);
  params[0] = *var_base;
  partcv[0] = 1;
  Object sum1299 = callmethod(num1298, "+", 1, partcv, params);
// compiled op node returning sum1299 (depth = 12)
  gc_frame_newslot(sum1299);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unicode (depth = 12)
  params[0] = sum1299;
  partcv[0] = 1;
  Object call1300 = callmethod(*var_unicode, "create",
    1, partcv, params);
  gc_frame_end(callframe1295);
// compiled call node returning call1300 (depth = 11)
  int op_slot_right_1294 = gc_frame_newslot(call1300);
// starting to compile string node (depth = 11)
  if (strlit1302 == NULL) {
    strlit1302 = alloc_String("'0' to '9', 'a' to '");
    gc_root(strlit1302);
  }
// compiled string node returning strlit1302 (depth = 11)
  int op_slot_left_1294 = gc_frame_newslot(strlit1302);
  params[0] = call1300;
  partcv[0] = 1;
  Object opresult1303 = callmethod(strlit1302, "++", 1, partcv, params);
// compiled op node returning opresult1303 (depth = 10)
  int op_slot_left_1291 = gc_frame_newslot(opresult1303);
  params[0] = strlit1292;
  partcv[0] = 1;
  Object opresult1304 = callmethod(opresult1303, "++", 1, partcv, params);
// compiled op node returning opresult1304 (depth = 9)
    gc_frame_newslot(opresult1304);
    if1274 = opresult1304;
  }
stackframe = iftmpstackframe1274;
// compiled if node returning if1274 (depth = 8)
  *var_validDigits = if1274;
  if (if1274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1305 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1307 == NULL) {
    strlit1307 = alloc_String(".");
    gc_root(strlit1307);
  }
// compiled string node returning strlit1307 (depth = 9)
  int op_slot_right_1306 = gc_frame_newslot(strlit1307);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_validDigits (depth = 10)
  int op_slot_right_1309 = gc_frame_newslot(*var_validDigits);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1312 == NULL) {
    strlit1312 = alloc_String(". Valid digits are ");
    gc_root(strlit1312);
  }
// compiled string node returning strlit1312 (depth = 11)
  int op_slot_right_1311 = gc_frame_newslot(strlit1312);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_base (depth = 12)
  int op_slot_right_1314 = gc_frame_newslot(*var_base);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1317 == NULL) {
    strlit1317 = alloc_String("' is not a valid digit in base ");
    gc_root(strlit1317);
  }
// compiled string node returning strlit1317 (depth = 13)
  int op_slot_right_1316 = gc_frame_newslot(strlit1317);
// starting to compile op node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_right_1319 = gc_frame_newslot(*var_c);
// starting to compile string node (depth = 14)
  if (strlit1321 == NULL) {
    strlit1321 = alloc_String("'");
    gc_root(strlit1321);
  }
// compiled string node returning strlit1321 (depth = 14)
  int op_slot_left_1319 = gc_frame_newslot(strlit1321);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1322 = callmethod(strlit1321, "++", 1, partcv, params);
// compiled op node returning opresult1322 (depth = 13)
  int op_slot_left_1316 = gc_frame_newslot(opresult1322);
  params[0] = strlit1317;
  partcv[0] = 1;
  Object opresult1323 = callmethod(opresult1322, "++", 1, partcv, params);
// compiled op node returning opresult1323 (depth = 12)
  int op_slot_left_1314 = gc_frame_newslot(opresult1323);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1324 = callmethod(opresult1323, "++", 1, partcv, params);
// compiled op node returning opresult1324 (depth = 11)
  int op_slot_left_1311 = gc_frame_newslot(opresult1324);
  params[0] = strlit1312;
  partcv[0] = 1;
  Object opresult1325 = callmethod(opresult1324, "++", 1, partcv, params);
// compiled op node returning opresult1325 (depth = 10)
  int op_slot_left_1309 = gc_frame_newslot(opresult1325);
  params[0] = *var_validDigits;
  partcv[0] = 1;
  Object opresult1326 = callmethod(opresult1325, "++", 1, partcv, params);
// compiled op node returning opresult1326 (depth = 9)
  int op_slot_left_1306 = gc_frame_newslot(opresult1326);
  params[0] = strlit1307;
  partcv[0] = 1;
  Object opresult1327 = callmethod(opresult1326, "++", 1, partcv, params);
// compiled op node returning opresult1327 (depth = 8)
  gc_frame_newslot(opresult1327);
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1328 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1331 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1332 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1331);
// compiled call node returning call1332 (depth = 11)
// compiled member node returning call1332 (depth = 10)
  int op_slot_right_1330 = gc_frame_newslot(call1332);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1330 = gc_frame_newslot(*var_linePosition);
  params[0] = call1332;
  partcv[0] = 1;
  Object diff1334 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1334 (depth = 9)
  int op_slot_left_1328 = gc_frame_newslot(diff1334);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1335 = callmethod(diff1334, "+", 1, partcv, params);
// compiled op node returning sum1335 (depth = 8)
  gc_frame_newslot(sum1335);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1336 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1339 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_str (depth = 12)
  partcv[0] = 0;
  Object call1340 = callmethod(*var_str, "size",
    1, partcv, params);
  gc_frame_end(callframe1339);
// compiled call node returning call1340 (depth = 11)
// compiled member node returning call1340 (depth = 10)
  int op_slot_right_1338 = gc_frame_newslot(call1340);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1338 = gc_frame_newslot(*var_linePosition);
  params[0] = call1340;
  partcv[0] = 1;
  Object diff1342 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1342 (depth = 9)
  int op_slot_left_1336 = gc_frame_newslot(diff1342);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1343 = callmethod(diff1342, "+", 1, partcv, params);
// compiled op node returning sum1343 (depth = 8)
  gc_frame_newslot(sum1343);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult1327;
  params[1] = *var_lineNumber;
  params[2] = sum1335;
  params[3] = sum1343;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1344 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1305);
// compiled call node returning call1344 (depth = 7)
    gc_frame_newslot(call1344);
    if1196 = call1344;
  }
// compiled if node returning if1196 (depth = 6)
    gc_frame_newslot(if1196);
    if1192 = if1196;
  } else {
  }
// compiled if node returning if1192 (depth = 5)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_inc (depth = 7)
  int op_slot_right_1345 = gc_frame_newslot(*var_inc);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_val (depth = 7)
  int op_slot_left_1345 = gc_frame_newslot(*var_val);
  params[0] = *var_inc;
  partcv[0] = 1;
  Object sum1347 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum1347 (depth = 6)
  *var_val = sum1347;
  if (sum1347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num1350 = alloc_Float64(1);
// compiled num node returning num1350 (depth = 7)
  int op_slot_right_1349 = gc_frame_newslot(num1350);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_1349 = gc_frame_newslot(*var_i);
  params[0] = num1350;
  partcv[0] = 1;
  Object sum1352 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1352 (depth = 6)
  *var_i = sum1352;
  if (sum1352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_fromBase1140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromBase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method fromBase");
  Object params[2];
  int partcv[2];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_unicode = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for fromBase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_str = &(stackframe->slots[0]);
  *var_str = args[curarg];
  curarg++;
  Object *var_base = &(stackframe->slots[1]);
  *var_base = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for fromBase");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1141 = alloc_Float64(0);
// compiled num node returning num1141 (depth = 4)
  *var_val = num1141;
  if (num1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1142 = alloc_Float64(0);
// compiled num node returning num1142 (depth = 4)
  *var_i = num1142;
  if (num1142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1143 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_str (depth = 4)
  gc_frame_newslot(*var_str);
// starting to compile block node (depth = 4)
  Object block1144 = alloc_Block(NULL, NULL, "lexer", 380);
  gc_frame_newslot(block1144);
// method _apply
  block_savedest(block1144);
  Object closure1145 = createclosure(9, "_apply");
  setclosureframe(closure1145, stackframe);
  addtoclosure(closure1145, var_base);
  addtoclosure(closure1145, var_val);
  addtoclosure(closure1145, var_str);
  addtoclosure(closure1145, var_errormessages);
  addtoclosure(closure1145, var_linePosition);
  addtoclosure(closure1145, var_lineNumber);
  addtoclosure(closure1145, var_i);
  addtoclosure(closure1145, var_unicode);
  addtoclosure(closure1145, selfslot);
  struct UserObject *uo1145 = (struct UserObject*)block1144;
  uo1145->data[0] = (Object)closure1145;
  Method *meth_meth_lexer__apply1145 = addmethod2pos(block1144, "_apply", &meth_lexer__apply1145, 0);
  int argcv_meth_lexer__apply1145[] = {1};
  meth_meth_lexer__apply1145->type = alloc_MethodType(1, argcv_meth_lexer__apply1145);
  meth_meth_lexer__apply1145->definitionModule = modulename;
  meth_meth_lexer__apply1145->definitionLine = 366;
// compiled block node returning block1144 (depth = 4)
  gc_frame_newslot(block1144);
// call case 5: prelude request
  params[0] = *var_str;
  params[1] = block1144;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1355 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1143);
// compiled call node returning call1355 (depth = 3)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_val (depth = 3)
  gc_frame_end(frame);
  return *var_val;
}
Object meth_lexer__apply1363(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_baseSet = getfromclosure(closure, 0);
  Object *var_sofar = getfromclosure(closure, 1);
  Object *var_base = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_i = getfromclosure(closure, 4);
  Object *var_accum = getfromclosure(closure, 5);
  Object *var_linePosition = getfromclosure(closure, 6);
  Object *var_lineNumber = getfromclosure(closure, 7);
  Object self = *(getfromclosure(closure, 8));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_baseSet (depth = 8)
  partcv[0] = 0;
  Object call1367 = callmethod(*var_baseSet, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1366);
// compiled call node returning call1367 (depth = 7)
  int op_slot_right_1365 = gc_frame_newslot(call1367);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1370 == NULL) {
    strlit1370 = alloc_String("x");
    gc_root(strlit1370);
  }
// compiled string node returning strlit1370 (depth = 8)
  int op_slot_right_1369 = gc_frame_newslot(strlit1370);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1369 = gc_frame_newslot(*var_c);
  params[0] = strlit1370;
  partcv[0] = 1;
  Object opresult1372 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1372 (depth = 7)
  int op_slot_left_1365 = gc_frame_newslot(opresult1372);
  params[0] = call1367;
  partcv[0] = 1;
  Object opresult1373 = callmethod(opresult1372, "&&", 1, partcv, params);
// compiled op node returning opresult1373 (depth = 6)
  Object if1364 = done;
  if (istrue(opresult1373)) {
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sofar (depth = 9)
  partcv[0] = 0;
  Object call1375 = callmethod(*var_sofar, "asNumber",
    1, partcv, params);
  gc_frame_end(callframe1374);
// compiled call node returning call1375 (depth = 8)
// compiled member node returning call1375 (depth = 7)
  *var_base = call1375;
  if (call1375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool1377 = alloc_Boolean(1);
// compiled identifier node returning bool1377 (depth = 7)
  *var_baseSet = bool1377;
  if (bool1377 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1381 = alloc_Float64(0);
// compiled num node returning num1381 (depth = 8)
  int op_slot_right_1380 = gc_frame_newslot(num1381);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_base (depth = 8)
  int op_slot_left_1380 = gc_frame_newslot(*var_base);
  params[0] = num1381;
  partcv[0] = 1;
  Object opresult1383 = callmethod(*var_base, "==", 1, partcv, params);
// compiled op node returning opresult1383 (depth = 7)
  Object if1379 = done;
  if (istrue(opresult1383)) {
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num1384 = alloc_Float64(16);
// compiled num node returning num1384 (depth = 8)
  *var_base = num1384;
  if (num1384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1379 = done;
  } else {
  }
// compiled if node returning if1379 (depth = 6)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1389 = alloc_Float64(36);
// compiled num node returning num1389 (depth = 9)
  int op_slot_right_1388 = gc_frame_newslot(num1389);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_left_1388 = gc_frame_newslot(*var_base);
  params[0] = num1389;
  partcv[0] = 1;
  Object opresult1391 = callmethod(*var_base, ">", 1, partcv, params);
// compiled op node returning opresult1391 (depth = 8)
  int op_slot_right_1387 = gc_frame_newslot(opresult1391);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1394 = alloc_Float64(2);
// compiled num node returning num1394 (depth = 9)
  int op_slot_right_1393 = gc_frame_newslot(num1394);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_base (depth = 9)
  int op_slot_left_1393 = gc_frame_newslot(*var_base);
  params[0] = num1394;
  partcv[0] = 1;
  Object opresult1396 = callmethod(*var_base, "<", 1, partcv, params);
// compiled op node returning opresult1396 (depth = 8)
  int op_slot_left_1387 = gc_frame_newslot(opresult1396);
  params[0] = opresult1391;
  partcv[0] = 1;
  Object opresult1397 = callmethod(opresult1396, "||", 1, partcv, params);
// compiled op node returning opresult1397 (depth = 7)
  Object if1386 = done;
  if (istrue(opresult1397)) {
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array1398 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1398 (depth = 8)
  *var_suggestions = array1398;
  if (array1398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1399 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1400 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1401 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1400);
// compiled call node returning call1401 (depth = 11)
// compiled member node returning call1401 (depth = 10)
  partcv[0] = 0;
  Object call1402 = callmethod(call1401, "new",
    1, partcv, params);
  gc_frame_end(callframe1399);
// compiled call node returning call1402 (depth = 9)
// compiled member node returning call1402 (depth = 8)
  *var_suggestion = call1402;
  if (call1402 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1403 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1404 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  partcv[0] = 0;
  Object call1408 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1407);
// compiled call node returning call1408 (depth = 11)
// compiled member node returning call1408 (depth = 10)
  int op_slot_right_1406 = gc_frame_newslot(call1408);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1406 = gc_frame_newslot(*var_linePosition);
  params[0] = call1408;
  partcv[0] = 1;
  Object diff1410 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1410 (depth = 9)
  int op_slot_left_1404 = gc_frame_newslot(diff1410);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1411 = callmethod(diff1410, "+", 1, partcv, params);
// compiled op node returning sum1411 (depth = 8)
  gc_frame_newslot(sum1411);
// starting to compile string node (depth = 8)
  if (strlit1412 == NULL) {
    strlit1412 = alloc_String("*");
    gc_root(strlit1412);
  }
// compiled string node returning strlit1412 (depth = 8)
  gc_frame_newslot(strlit1412);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1411;
  params[1] = strlit1412;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1413 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe1403);
// compiled call node returning call1413 (depth = 7)
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1414 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1415 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1414);
// compiled call node returning call1415 (depth = 7)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1416 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1418 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1417);
// compiled call node returning call1418 (depth = 11)
// compiled member node returning call1418 (depth = 10)
  partcv[0] = 0;
  Object call1419 = callmethod(call1418, "new",
    1, partcv, params);
  gc_frame_end(callframe1416);
// compiled call node returning call1419 (depth = 9)
// compiled member node returning call1419 (depth = 8)
  *var_suggestion = call1419;
  if (call1419 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1421 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  partcv[0] = 0;
  Object call1424 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1423);
// compiled call node returning call1424 (depth = 10)
// compiled member node returning call1424 (depth = 9)
  int op_slot_right_1422 = gc_frame_newslot(call1424);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1422 = gc_frame_newslot(*var_linePosition);
  params[0] = call1424;
  partcv[0] = 1;
  Object diff1426 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1426 (depth = 8)
  gc_frame_newslot(diff1426);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_right_1427 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  partcv[0] = 0;
  Object call1431 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1430);
// compiled call node returning call1431 (depth = 11)
// compiled member node returning call1431 (depth = 10)
  int op_slot_right_1429 = gc_frame_newslot(call1431);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  int op_slot_left_1429 = gc_frame_newslot(*var_linePosition);
  params[0] = call1431;
  partcv[0] = 1;
  Object diff1433 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1433 (depth = 9)
  int op_slot_left_1427 = gc_frame_newslot(diff1433);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1434 = callmethod(diff1433, "+", 1, partcv, params);
// compiled op node returning sum1434 (depth = 8)
  gc_frame_newslot(sum1434);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = diff1426;
  params[1] = sum1434;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1435 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1421);
// compiled call node returning call1435 (depth = 7)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1436 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1437 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1436);
// compiled call node returning call1437 (depth = 7)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1438 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1440 == NULL) {
    strlit1440 = alloc_String(" is not a valid numerical base.");
    gc_root(strlit1440);
  }
// compiled string node returning strlit1440 (depth = 9)
  int op_slot_right_1439 = gc_frame_newslot(strlit1440);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_base (depth = 10)
  int op_slot_right_1442 = gc_frame_newslot(*var_base);
// starting to compile string node (depth = 10)
  if (strlit1444 == NULL) {
    strlit1444 = alloc_String("Base ");
    gc_root(strlit1444);
  }
// compiled string node returning strlit1444 (depth = 10)
  int op_slot_left_1442 = gc_frame_newslot(strlit1444);
  params[0] = *var_base;
  partcv[0] = 1;
  Object opresult1445 = callmethod(strlit1444, "++", 1, partcv, params);
// compiled op node returning opresult1445 (depth = 9)
  int op_slot_left_1439 = gc_frame_newslot(opresult1445);
  params[0] = strlit1440;
  partcv[0] = 1;
  Object opresult1446 = callmethod(opresult1445, "++", 1, partcv, params);
// compiled op node returning opresult1446 (depth = 8)
  gc_frame_newslot(opresult1446);
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  partcv[0] = 0;
  Object call1449 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1448);
// compiled call node returning call1449 (depth = 10)
// compiled member node returning call1449 (depth = 9)
  int op_slot_right_1447 = gc_frame_newslot(call1449);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  int op_slot_left_1447 = gc_frame_newslot(*var_linePosition);
  params[0] = call1449;
  partcv[0] = 1;
  Object diff1451 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1451 (depth = 8)
  gc_frame_newslot(diff1451);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1453 = alloc_Float64(1);
// compiled num node returning num1453 (depth = 9)
  int op_slot_right_1452 = gc_frame_newslot(num1453);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_right_1455 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  partcv[0] = 0;
  Object call1459 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1458);
// compiled call node returning call1459 (depth = 12)
// compiled member node returning call1459 (depth = 11)
  int op_slot_right_1457 = gc_frame_newslot(call1459);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_1457 = gc_frame_newslot(*var_linePosition);
  params[0] = call1459;
  partcv[0] = 1;
  Object diff1461 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1461 (depth = 10)
  int op_slot_left_1455 = gc_frame_newslot(diff1461);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1462 = callmethod(diff1461, "+", 1, partcv, params);
// compiled op node returning sum1462 (depth = 9)
  int op_slot_left_1452 = gc_frame_newslot(sum1462);
  params[0] = num1453;
  partcv[0] = 1;
  Object diff1463 = callmethod(sum1462, "-", 1, partcv, params);
// compiled op node returning diff1463 (depth = 8)
  gc_frame_newslot(diff1463);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult1446;
  params[1] = *var_lineNumber;
  params[2] = diff1451;
  params[3] = diff1463;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1464 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1438);
// compiled call node returning call1464 (depth = 7)
    gc_frame_newslot(call1464);
    if1386 = call1464;
  } else {
  }
// compiled if node returning if1386 (depth = 6)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1465 == NULL) {
    strlit1465 = alloc_String("");
    gc_root(strlit1465);
  }
// compiled string node returning strlit1465 (depth = 7)
  *var_sofar = strlit1465;
  if (strlit1465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1364 = done;
  } else {
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_right_1467 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sofar (depth = 8)
  int op_slot_left_1467 = gc_frame_newslot(*var_sofar);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1469 = callmethod(*var_sofar, "++", 1, partcv, params);
// compiled op node returning opresult1469 (depth = 7)
  *var_sofar = opresult1469;
  if (opresult1469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1364 = done;
  }
// compiled if node returning if1364 (depth = 5)
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num1472 = alloc_Float64(1);
// compiled num node returning num1472 (depth = 7)
  int op_slot_right_1471 = gc_frame_newslot(num1472);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_1471 = gc_frame_newslot(*var_i);
  params[0] = num1472;
  partcv[0] = 1;
  Object sum1474 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1474 (depth = 6)
  *var_i = sum1474;
  if (sum1474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_makeNumToken1356(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "makeNumToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method makeNumToken");
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_linePosition = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_NumToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for makeNumToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_accum = &(stackframe->slots[0]);
  *var_accum = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for makeNumToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_base = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "base");
  Object *var_baseSet = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "baseSet");
  Object *var_sofar = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sofar");
  Object *var_i = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "i");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
  Object *var_suggestion = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestion");
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1357 = alloc_Float64(10);
// compiled num node returning num1357 (depth = 4)
  *var_base = num1357;
  if (num1357 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1358 = alloc_Boolean(0);
// compiled identifier node returning bool1358 (depth = 4)
  *var_baseSet = bool1358;
  if (bool1358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1359 == NULL) {
    strlit1359 = alloc_String("");
    gc_root(strlit1359);
  }
// compiled string node returning strlit1359 (depth = 4)
  *var_sofar = strlit1359;
  if (strlit1359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1360 = alloc_Float64(0);
// compiled num node returning num1360 (depth = 4)
  *var_i = num1360;
  if (num1360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1361 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_accum (depth = 4)
  gc_frame_newslot(*var_accum);
// starting to compile block node (depth = 4)
  Object block1362 = alloc_Block(NULL, NULL, "lexer", 423);
  gc_frame_newslot(block1362);
// method _apply
  block_savedest(block1362);
  Object closure1363 = createclosure(9, "_apply");
  setclosureframe(closure1363, stackframe);
  addtoclosure(closure1363, var_baseSet);
  addtoclosure(closure1363, var_sofar);
  addtoclosure(closure1363, var_base);
  addtoclosure(closure1363, var_errormessages);
  addtoclosure(closure1363, var_i);
  addtoclosure(closure1363, var_accum);
  addtoclosure(closure1363, var_linePosition);
  addtoclosure(closure1363, var_lineNumber);
  addtoclosure(closure1363, selfslot);
  struct UserObject *uo1363 = (struct UserObject*)block1362;
  uo1363->data[0] = (Object)closure1363;
  Method *meth_meth_lexer__apply1363 = addmethod2pos(block1362, "_apply", &meth_lexer__apply1363, 0);
  int argcv_meth_lexer__apply1363[] = {1};
  meth_meth_lexer__apply1363->type = alloc_MethodType(1, argcv_meth_lexer__apply1363);
  meth_meth_lexer__apply1363->definitionModule = modulename;
  meth_meth_lexer__apply1363->definitionLine = 410;
// compiled block node returning block1362 (depth = 4)
  gc_frame_newslot(block1362);
// call case 5: prelude request
  params[0] = *var_accum;
  params[1] = block1362;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1477 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1361);
// compiled call node returning call1477 (depth = 3)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1480 == NULL) {
    strlit1480 = alloc_String("");
    gc_root(strlit1480);
  }
// compiled string node returning strlit1480 (depth = 5)
  int op_slot_right_1479 = gc_frame_newslot(strlit1480);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sofar (depth = 5)
  int op_slot_left_1479 = gc_frame_newslot(*var_sofar);
  params[0] = strlit1480;
  partcv[0] = 1;
  Object opresult1482 = callmethod(*var_sofar, "==", 1, partcv, params);
// compiled op node returning opresult1482 (depth = 4)
  Object if1478 = done;
  if (istrue(opresult1482)) {
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array1483 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1483 (depth = 5)
  *var_suggestions = array1483;
  if (array1483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1484 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1486 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1485);
// compiled call node returning call1486 (depth = 8)
// compiled member node returning call1486 (depth = 7)
  partcv[0] = 0;
  Object call1487 = callmethod(call1486, "new",
    1, partcv, params);
  gc_frame_end(callframe1484);
// compiled call node returning call1487 (depth = 6)
// compiled member node returning call1487 (depth = 5)
  *var_suggestion = call1487;
  if (call1487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1488 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1490 = alloc_Float64(1);
// compiled num node returning num1490 (depth = 6)
  int op_slot_right_1489 = gc_frame_newslot(num1490);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_right_1492 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  partcv[0] = 0;
  Object call1496 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1495);
// compiled call node returning call1496 (depth = 9)
// compiled member node returning call1496 (depth = 8)
  int op_slot_right_1494 = gc_frame_newslot(call1496);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_1494 = gc_frame_newslot(*var_linePosition);
  params[0] = call1496;
  partcv[0] = 1;
  Object diff1498 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1498 (depth = 7)
  int op_slot_left_1492 = gc_frame_newslot(diff1498);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1499 = callmethod(diff1498, "+", 1, partcv, params);
// compiled op node returning sum1499 (depth = 6)
  int op_slot_left_1489 = gc_frame_newslot(sum1499);
  params[0] = num1490;
  partcv[0] = 1;
  Object diff1500 = callmethod(sum1499, "-", 1, partcv, params);
// compiled op node returning diff1500 (depth = 5)
  gc_frame_newslot(diff1500);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1502 = alloc_Float64(1);
// compiled num node returning num1502 (depth = 6)
  int op_slot_right_1501 = gc_frame_newslot(num1502);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  int op_slot_left_1501 = gc_frame_newslot(*var_linePosition);
  params[0] = num1502;
  partcv[0] = 1;
  Object diff1504 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1504 (depth = 5)
  gc_frame_newslot(diff1504);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = diff1500;
  params[1] = diff1504;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call1505 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe1488);
// compiled call node returning call1505 (depth = 4)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1506 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1507 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1506);
// compiled call node returning call1507 (depth = 4)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1508 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1509 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1510 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1509);
// compiled call node returning call1510 (depth = 8)
// compiled member node returning call1510 (depth = 7)
  partcv[0] = 0;
  Object call1511 = callmethod(call1510, "new",
    1, partcv, params);
  gc_frame_end(callframe1508);
// compiled call node returning call1511 (depth = 6)
// compiled member node returning call1511 (depth = 5)
  *var_suggestion = call1511;
  if (call1511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1513 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1514 == NULL) {
    strlit1514 = alloc_String("0");
    gc_root(strlit1514);
  }
// compiled string node returning strlit1514 (depth = 5)
  gc_frame_newslot(strlit1514);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_linePosition (depth = 5)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1514;
  params[1] = *var_linePosition;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1515 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe1513);
// compiled call node returning call1515 (depth = 4)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1516 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1517 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1516);
// compiled call node returning call1517 (depth = 4)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1518 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1519 == NULL) {
    strlit1519 = alloc_String("At least one digit must follow the 'x' in a number.");
    gc_root(strlit1519);
  }
// compiled string node returning strlit1519 (depth = 5)
  gc_frame_newslot(strlit1519);
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_right_1520 = gc_frame_newslot(*var_i);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  partcv[0] = 0;
  Object call1524 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe1523);
// compiled call node returning call1524 (depth = 8)
// compiled member node returning call1524 (depth = 7)
  int op_slot_right_1522 = gc_frame_newslot(call1524);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_1522 = gc_frame_newslot(*var_linePosition);
  params[0] = call1524;
  partcv[0] = 1;
  Object diff1526 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff1526 (depth = 6)
  int op_slot_left_1520 = gc_frame_newslot(diff1526);
  params[0] = *var_i;
  partcv[0] = 1;
  Object sum1527 = callmethod(diff1526, "+", 1, partcv, params);
// compiled op node returning sum1527 (depth = 5)
  gc_frame_newslot(sum1527);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1519;
  params[1] = *var_lineNumber;
  params[2] = sum1527;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1528 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1518);
// compiled call node returning call1528 (depth = 4)
    gc_frame_newslot(call1528);
    if1478 = call1528;
  } else {
  }
// compiled if node returning if1478 (depth = 3)
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1529 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1530 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1531 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sofar (depth = 7)
  gc_frame_newslot(*var_sofar);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_base (depth = 7)
  gc_frame_newslot(*var_base);
// call case 4: self request
  params[0] = *var_sofar;
  params[1] = *var_base;
  partcv[0] = 2;
  Object call1532 = callmethodflags(self, "fromBase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1531);
// compiled call node returning call1532 (depth = 6)
  partcv[0] = 0;
  Object call1533 = callmethod(call1532, "asString",
    1, partcv, params);
  gc_frame_end(callframe1530);
// compiled call node returning call1533 (depth = 5)
// compiled member node returning call1533 (depth = 4)
  gc_frame_newslot(call1533);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_base (depth = 4)
  gc_frame_newslot(*var_base);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NumToken (depth = 4)
  params[0] = call1533;
  params[1] = *var_base;
  partcv[0] = 2;
  Object call1534 = callmethod(*var_NumToken, "new",
    1, partcv, params);
  gc_frame_end(callframe1529);
// compiled call node returning call1534 (depth = 3)
  gc_frame_end(frame);
  return call1534;
}
Object meth_lexer_isidentifierchar1535(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isidentifierchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method isidentifierchar");
  Object params[1];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isidentifierchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ov = &(stackframe->slots[0]);
  *var_ov = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for isidentifierchar");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1537 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ov (depth = 5)
  gc_frame_newslot(*var_ov);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_ov;
  partcv[0] = 1;
  Object call1538 = callmethod(*var_unicode, "isLetter",
    1, partcv, params);
  gc_frame_end(callframe1537);
// compiled call node returning call1538 (depth = 4)
  Object if1536 = done;
  if (istrue(call1538)) {
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1539 = alloc_Boolean(1);
// compiled identifier node returning bool1539 (depth = 5)
  return bool1539;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1536 = undefined;
  } else {
  }
// compiled if node returning if1536 (depth = 3)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1541 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ov (depth = 5)
  gc_frame_newslot(*var_ov);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_ov;
  partcv[0] = 1;
  Object call1542 = callmethod(*var_unicode, "isNumber",
    1, partcv, params);
  gc_frame_end(callframe1541);
// compiled call node returning call1542 (depth = 4)
  Object if1540 = done;
  if (istrue(call1542)) {
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1543 = alloc_Boolean(1);
// compiled identifier node returning bool1543 (depth = 5)
  return bool1543;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1540 = undefined;
  } else {
  }
// compiled if node returning if1540 (depth = 3)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1547 = alloc_Float64(39);
// compiled num node returning num1547 (depth = 6)
  int op_slot_right_1546 = gc_frame_newslot(num1547);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ov (depth = 6)
  int op_slot_left_1546 = gc_frame_newslot(*var_ov);
  params[0] = num1547;
  partcv[0] = 1;
  Object opresult1549 = callmethod(*var_ov, "==", 1, partcv, params);
// compiled op node returning opresult1549 (depth = 5)
  int op_slot_right_1545 = gc_frame_newslot(opresult1549);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1552 = alloc_Float64(95);
// compiled num node returning num1552 (depth = 6)
  int op_slot_right_1551 = gc_frame_newslot(num1552);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ov (depth = 6)
  int op_slot_left_1551 = gc_frame_newslot(*var_ov);
  params[0] = num1552;
  partcv[0] = 1;
  Object opresult1554 = callmethod(*var_ov, "==", 1, partcv, params);
// compiled op node returning opresult1554 (depth = 5)
  int op_slot_left_1545 = gc_frame_newslot(opresult1554);
  params[0] = opresult1549;
  partcv[0] = 1;
  Object opresult1555 = callmethod(opresult1554, "||", 1, partcv, params);
// compiled op node returning opresult1555 (depth = 4)
  Object if1544 = done;
  if (istrue(opresult1555)) {
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1556 = alloc_Boolean(1);
// compiled identifier node returning bool1556 (depth = 4)
    gc_frame_newslot(bool1556);
    if1544 = bool1556;
  } else {
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1557 = alloc_Boolean(0);
// compiled identifier node returning bool1557 (depth = 4)
    gc_frame_newslot(bool1557);
    if1544 = bool1557;
  }
// compiled if node returning if1544 (depth = 3)
  gc_frame_end(frame);
  return if1544;
}
Object meth_lexer_isoperatorchar1558(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isoperatorchar");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method isoperatorchar");
  Object params[2];
  int partcv[1];
  Object *var_unicode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isoperatorchar (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *var_ordval = &(stackframe->slots[1]);
  *var_ordval = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for isoperatorchar");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1562 == NULL) {
    strlit1562 = alloc_String("!");
    gc_root(strlit1562);
  }
// compiled string node returning strlit1562 (depth = 6)
  int op_slot_right_1561 = gc_frame_newslot(strlit1562);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  int op_slot_left_1561 = gc_frame_newslot(*var_c);
  params[0] = strlit1562;
  partcv[0] = 1;
  Object opresult1564 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1564 (depth = 5)
  int op_slot_right_1560 = gc_frame_newslot(opresult1564);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1568 == NULL) {
    strlit1568 = alloc_String("+");
    gc_root(strlit1568);
  }
// compiled string node returning strlit1568 (depth = 7)
  int op_slot_right_1567 = gc_frame_newslot(strlit1568);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_1567 = gc_frame_newslot(*var_c);
  params[0] = strlit1568;
  partcv[0] = 1;
  Object opresult1570 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1570 (depth = 6)
  int op_slot_right_1566 = gc_frame_newslot(opresult1570);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1574 == NULL) {
    strlit1574 = alloc_String("/");
    gc_root(strlit1574);
  }
// compiled string node returning strlit1574 (depth = 8)
  int op_slot_right_1573 = gc_frame_newslot(strlit1574);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1573 = gc_frame_newslot(*var_c);
  params[0] = strlit1574;
  partcv[0] = 1;
  Object opresult1576 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1576 (depth = 7)
  int op_slot_right_1572 = gc_frame_newslot(opresult1576);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String("*");
    gc_root(strlit1580);
  }
// compiled string node returning strlit1580 (depth = 9)
  int op_slot_right_1579 = gc_frame_newslot(strlit1580);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1579 = gc_frame_newslot(*var_c);
  params[0] = strlit1580;
  partcv[0] = 1;
  Object opresult1582 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1582 (depth = 8)
  int op_slot_right_1578 = gc_frame_newslot(opresult1582);
// starting to compile op node (depth = 8)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1586 == NULL) {
    strlit1586 = alloc_String("?");
    gc_root(strlit1586);
  }
// compiled string node returning strlit1586 (depth = 10)
  int op_slot_right_1585 = gc_frame_newslot(strlit1586);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1585 = gc_frame_newslot(*var_c);
  params[0] = strlit1586;
  partcv[0] = 1;
  Object opresult1588 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1588 (depth = 9)
  int op_slot_right_1584 = gc_frame_newslot(opresult1588);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1592 == NULL) {
    strlit1592 = alloc_String("@");
    gc_root(strlit1592);
  }
// compiled string node returning strlit1592 (depth = 11)
  int op_slot_right_1591 = gc_frame_newslot(strlit1592);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_1591 = gc_frame_newslot(*var_c);
  params[0] = strlit1592;
  partcv[0] = 1;
  Object opresult1594 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1594 (depth = 10)
  int op_slot_right_1590 = gc_frame_newslot(opresult1594);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1598 == NULL) {
    strlit1598 = alloc_String("^");
    gc_root(strlit1598);
  }
// compiled string node returning strlit1598 (depth = 12)
  int op_slot_right_1597 = gc_frame_newslot(strlit1598);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_1597 = gc_frame_newslot(*var_c);
  params[0] = strlit1598;
  partcv[0] = 1;
  Object opresult1600 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1600 (depth = 11)
  int op_slot_right_1596 = gc_frame_newslot(opresult1600);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit1604 == NULL) {
    strlit1604 = alloc_String("%");
    gc_root(strlit1604);
  }
// compiled string node returning strlit1604 (depth = 13)
  int op_slot_right_1603 = gc_frame_newslot(strlit1604);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_1603 = gc_frame_newslot(*var_c);
  params[0] = strlit1604;
  partcv[0] = 1;
  Object opresult1606 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1606 (depth = 12)
  int op_slot_right_1602 = gc_frame_newslot(opresult1606);
// starting to compile op node (depth = 12)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit1610 == NULL) {
    strlit1610 = alloc_String(":");
    gc_root(strlit1610);
  }
// compiled string node returning strlit1610 (depth = 14)
  int op_slot_right_1609 = gc_frame_newslot(strlit1610);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_1609 = gc_frame_newslot(*var_c);
  params[0] = strlit1610;
  partcv[0] = 1;
  Object opresult1612 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1612 (depth = 13)
  int op_slot_right_1608 = gc_frame_newslot(opresult1612);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit1616 == NULL) {
    strlit1616 = alloc_String("|");
    gc_root(strlit1616);
  }
// compiled string node returning strlit1616 (depth = 15)
  int op_slot_right_1615 = gc_frame_newslot(strlit1616);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_1615 = gc_frame_newslot(*var_c);
  params[0] = strlit1616;
  partcv[0] = 1;
  Object opresult1618 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1618 (depth = 14)
  int op_slot_right_1614 = gc_frame_newslot(opresult1618);
// starting to compile op node (depth = 14)
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1622 == NULL) {
    strlit1622 = alloc_String("&");
    gc_root(strlit1622);
  }
// compiled string node returning strlit1622 (depth = 16)
  int op_slot_right_1621 = gc_frame_newslot(strlit1622);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_1621 = gc_frame_newslot(*var_c);
  params[0] = strlit1622;
  partcv[0] = 1;
  Object opresult1624 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1624 (depth = 15)
  int op_slot_right_1620 = gc_frame_newslot(opresult1624);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit1627 == NULL) {
    strlit1627 = alloc_String("-");
    gc_root(strlit1627);
  }
// compiled string node returning strlit1627 (depth = 16)
  int op_slot_right_1626 = gc_frame_newslot(strlit1627);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_1626 = gc_frame_newslot(*var_c);
  params[0] = strlit1627;
  partcv[0] = 1;
  Object opresult1629 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1629 (depth = 15)
  int op_slot_left_1620 = gc_frame_newslot(opresult1629);
  params[0] = opresult1624;
  partcv[0] = 1;
  Object opresult1630 = callmethod(opresult1629, "||", 1, partcv, params);
// compiled op node returning opresult1630 (depth = 14)
  int op_slot_left_1614 = gc_frame_newslot(opresult1630);
  params[0] = opresult1618;
  partcv[0] = 1;
  Object opresult1631 = callmethod(opresult1630, "||", 1, partcv, params);
// compiled op node returning opresult1631 (depth = 13)
  int op_slot_left_1608 = gc_frame_newslot(opresult1631);
  params[0] = opresult1612;
  partcv[0] = 1;
  Object opresult1632 = callmethod(opresult1631, "||", 1, partcv, params);
// compiled op node returning opresult1632 (depth = 12)
  int op_slot_left_1602 = gc_frame_newslot(opresult1632);
  params[0] = opresult1606;
  partcv[0] = 1;
  Object opresult1633 = callmethod(opresult1632, "||", 1, partcv, params);
// compiled op node returning opresult1633 (depth = 11)
  int op_slot_left_1596 = gc_frame_newslot(opresult1633);
  params[0] = opresult1600;
  partcv[0] = 1;
  Object opresult1634 = callmethod(opresult1633, "||", 1, partcv, params);
// compiled op node returning opresult1634 (depth = 10)
  int op_slot_left_1590 = gc_frame_newslot(opresult1634);
  params[0] = opresult1594;
  partcv[0] = 1;
  Object opresult1635 = callmethod(opresult1634, "||", 1, partcv, params);
// compiled op node returning opresult1635 (depth = 9)
  int op_slot_left_1584 = gc_frame_newslot(opresult1635);
  params[0] = opresult1588;
  partcv[0] = 1;
  Object opresult1636 = callmethod(opresult1635, "||", 1, partcv, params);
// compiled op node returning opresult1636 (depth = 8)
  int op_slot_left_1578 = gc_frame_newslot(opresult1636);
  params[0] = opresult1582;
  partcv[0] = 1;
  Object opresult1637 = callmethod(opresult1636, "||", 1, partcv, params);
// compiled op node returning opresult1637 (depth = 7)
  int op_slot_left_1572 = gc_frame_newslot(opresult1637);
  params[0] = opresult1576;
  partcv[0] = 1;
  Object opresult1638 = callmethod(opresult1637, "||", 1, partcv, params);
// compiled op node returning opresult1638 (depth = 6)
  int op_slot_left_1566 = gc_frame_newslot(opresult1638);
  params[0] = opresult1570;
  partcv[0] = 1;
  Object opresult1639 = callmethod(opresult1638, "||", 1, partcv, params);
// compiled op node returning opresult1639 (depth = 5)
  int op_slot_left_1560 = gc_frame_newslot(opresult1639);
  params[0] = opresult1564;
  partcv[0] = 1;
  Object opresult1640 = callmethod(opresult1639, "||", 1, partcv, params);
// compiled op node returning opresult1640 (depth = 4)
  Object if1559 = done;
  if (istrue(opresult1640)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1641 = alloc_Boolean(1);
// compiled identifier node returning bool1641 (depth = 5)
  return bool1641;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1559 = undefined;
  } else {
  }
// compiled if node returning if1559 (depth = 3)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1643 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ordval (depth = 5)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call1644 = callmethod(*var_unicode, "isSymbolMathematical",
    1, partcv, params);
  gc_frame_end(callframe1643);
// compiled call node returning call1644 (depth = 4)
  Object if1642 = done;
  if (istrue(call1644)) {
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1645 = alloc_Boolean(1);
// compiled identifier node returning bool1645 (depth = 5)
  return bool1645;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if1642 = undefined;
  } else {
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1647 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  gc_frame_newslot(*var_c);
// starting to compile string node (depth = 6)
  if (strlit1648 == NULL) {
    strlit1648 = alloc_String("So");
    gc_root(strlit1648);
  }
// compiled string node returning strlit1648 (depth = 6)
  gc_frame_newslot(strlit1648);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unicode (depth = 6)
  params[0] = *var_c;
  params[1] = strlit1648;
  partcv[0] = 2;
  Object call1649 = callmethod(*var_unicode, "iscategory",
    1, partcv, params);
  gc_frame_end(callframe1647);
// compiled call node returning call1649 (depth = 5)
  Object if1646 = done;
  if (istrue(call1649)) {
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1650 = alloc_Boolean(1);
// compiled identifier node returning bool1650 (depth = 6)
  return bool1650;
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1646 = undefined;
  } else {
  }
// compiled if node returning if1646 (depth = 4)
    gc_frame_newslot(if1646);
    if1642 = if1646;
  }
// compiled if node returning if1642 (depth = 3)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1651 = alloc_Boolean(0);
// compiled identifier node returning bool1651 (depth = 4)
  return bool1651;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_lexer__apply1665(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_lines = getfromclosure(closure, 1);
  Object *var_cLine = getfromclosure(closure, 2);
  Object *var_cLines = getfromclosure(closure, 3);
  Object *var_source = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1669 == NULL) {
    strlit1669 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit1669);
  }
// compiled string node returning strlit1669 (depth = 8)
  int op_slot_right_1668 = gc_frame_newslot(strlit1669);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1668 = gc_frame_newslot(*var_c);
  params[0] = strlit1669;
  partcv[0] = 1;
  Object opresult1671 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1671 (depth = 7)
  int op_slot_right_1667 = gc_frame_newslot(opresult1671);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1674 == NULL) {
    strlit1674 = alloc_String("""\x0a""");
    gc_root(strlit1674);
  }
// compiled string node returning strlit1674 (depth = 8)
  int op_slot_right_1673 = gc_frame_newslot(strlit1674);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1673 = gc_frame_newslot(*var_c);
  params[0] = strlit1674;
  partcv[0] = 1;
  Object opresult1676 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1676 (depth = 7)
  int op_slot_left_1667 = gc_frame_newslot(opresult1676);
  params[0] = opresult1671;
  partcv[0] = 1;
  Object opresult1677 = callmethod(opresult1676, "||", 1, partcv, params);
// compiled op node returning opresult1677 (depth = 6)
  Object if1666 = done;
  if (istrue(opresult1677)) {
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1678 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lines (depth = 7)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1679 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1678);
// compiled call node returning call1679 (depth = 6)
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1680 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cLine (depth = 7)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cLines (depth = 7)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1681 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1680);
// compiled call node returning call1681 (depth = 6)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1682 == NULL) {
    strlit1682 = alloc_String("");
    gc_root(strlit1682);
  }
// compiled string node returning strlit1682 (depth = 7)
  *var_line = strlit1682;
  if (strlit1682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit1684 == NULL) {
    strlit1684 = alloc_String("");
    gc_root(strlit1684);
  }
// compiled string node returning strlit1684 (depth = 7)
  *var_cLine = strlit1684;
  if (strlit1684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1666 = done;
  } else {
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1688 == NULL) {
    strlit1688 = alloc_String("""\x0d""");
    gc_root(strlit1688);
  }
// compiled string node returning strlit1688 (depth = 8)
  int op_slot_right_1687 = gc_frame_newslot(strlit1688);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_1687 = gc_frame_newslot(*var_c);
  params[0] = strlit1688;
  partcv[0] = 1;
  Object opresult1690 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1690 (depth = 7)
  Object if1686 = done;
  if (istrue(opresult1690)) {
    gc_frame_newslot(done);
    if1686 = done;
  } else {
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1693 == NULL) {
    strlit1693 = alloc_String("\\");
    gc_root(strlit1693);
  }
// compiled string node returning strlit1693 (depth = 9)
  int op_slot_right_1692 = gc_frame_newslot(strlit1693);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_1692 = gc_frame_newslot(*var_c);
  params[0] = strlit1693;
  partcv[0] = 1;
  Object opresult1695 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1695 (depth = 8)
  Object if1691 = done;
  if (istrue(opresult1695)) {
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1697 == NULL) {
    strlit1697 = alloc_String("\\");
    gc_root(strlit1697);
  }
// compiled string node returning strlit1697 (depth = 10)
  int op_slot_right_1696 = gc_frame_newslot(strlit1697);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_1696 = gc_frame_newslot(*var_line);
  params[0] = strlit1697;
  partcv[0] = 1;
  Object opresult1699 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1699 (depth = 9)
  *var_line = opresult1699;
  if (opresult1699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit1702 == NULL) {
    strlit1702 = alloc_String("\\\\");
    gc_root(strlit1702);
  }
// compiled string node returning strlit1702 (depth = 10)
  int op_slot_right_1701 = gc_frame_newslot(strlit1702);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_cLine (depth = 10)
  int op_slot_left_1701 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1702;
  partcv[0] = 1;
  Object opresult1704 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1704 (depth = 9)
  *var_cLine = opresult1704;
  if (opresult1704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if1691 = done;
  } else {
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1708 == NULL) {
    strlit1708 = alloc_String("""\x22""");
    gc_root(strlit1708);
  }
// compiled string node returning strlit1708 (depth = 10)
  int op_slot_right_1707 = gc_frame_newslot(strlit1708);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_1707 = gc_frame_newslot(*var_c);
  params[0] = strlit1708;
  partcv[0] = 1;
  Object opresult1710 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult1710 (depth = 9)
  Object if1706 = done;
  if (istrue(opresult1710)) {
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit1712 == NULL) {
    strlit1712 = alloc_String("""\x22""");
    gc_root(strlit1712);
  }
// compiled string node returning strlit1712 (depth = 11)
  int op_slot_right_1711 = gc_frame_newslot(strlit1712);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1711 = gc_frame_newslot(*var_line);
  params[0] = strlit1712;
  partcv[0] = 1;
  Object opresult1714 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1714 (depth = 10)
  *var_line = opresult1714;
  if (opresult1714 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit1717 == NULL) {
    strlit1717 = alloc_String("\\""\x22""");
    gc_root(strlit1717);
  }
// compiled string node returning strlit1717 (depth = 11)
  int op_slot_right_1716 = gc_frame_newslot(strlit1717);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1716 = gc_frame_newslot(*var_cLine);
  params[0] = strlit1717;
  partcv[0] = 1;
  Object opresult1719 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1719 (depth = 10)
  *var_cLine = opresult1719;
  if (opresult1719 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1706 = done;
  } else {
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1721 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  int op_slot_left_1721 = gc_frame_newslot(*var_line);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1723 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult1723 (depth = 10)
  *var_line = opresult1723;
  if (opresult1723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_right_1725 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_cLine (depth = 11)
  int op_slot_left_1725 = gc_frame_newslot(*var_cLine);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1727 = callmethod(*var_cLine, "++", 1, partcv, params);
// compiled op node returning opresult1727 (depth = 10)
  *var_cLine = opresult1727;
  if (opresult1727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1706 = done;
  }
// compiled if node returning if1706 (depth = 8)
    gc_frame_newslot(if1706);
    if1691 = if1706;
  }
// compiled if node returning if1691 (depth = 7)
    gc_frame_newslot(if1691);
    if1686 = if1691;
  }
// compiled if node returning if1686 (depth = 6)
    gc_frame_newslot(if1686);
    if1666 = if1686;
  }
// compiled if node returning if1666 (depth = 5)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_right_1729 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_source (depth = 7)
  int op_slot_left_1729 = gc_frame_newslot(*var_source);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult1731 = callmethod(*var_source, "++", 1, partcv, params);
// compiled op node returning opresult1731 (depth = 6)
  *var_source = opresult1731;
  if (opresult1731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_lexfile1652(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexfile");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lexfile");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lexfile (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_file = &(stackframe->slots[0]);
  *var_file = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lexfile");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lines = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lines");
  Object *var_cLines = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "cLines");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_cLine = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cLine");
  Object *var_source = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "source");
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1653 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1654 == NULL) {
    strlit1654 = alloc_String("reading source.");
    gc_root(strlit1654);
  }
// compiled string node returning strlit1654 (depth = 4)
  gc_frame_newslot(strlit1654);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = strlit1654;
  partcv[0] = 1;
  Object call1655 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe1653);
// compiled call node returning call1655 (depth = 3)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1656 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1656 (depth = 4)
  *var_lines = array1656;
  if (array1656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1657 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1657 (depth = 4)
  *var_cLines = array1657;
  if (array1657 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1658 == NULL) {
    strlit1658 = alloc_String("");
    gc_root(strlit1658);
  }
// compiled string node returning strlit1658 (depth = 4)
  *var_line = strlit1658;
  if (strlit1658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1659 == NULL) {
    strlit1659 = alloc_String("");
    gc_root(strlit1659);
  }
// compiled string node returning strlit1659 (depth = 4)
  *var_cLine = strlit1659;
  if (strlit1659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1660 == NULL) {
    strlit1660 = alloc_String("");
    gc_root(strlit1660);
  }
// compiled string node returning strlit1660 (depth = 4)
  *var_source = strlit1660;
  if (strlit1660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1661 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_file (depth = 6)
  partcv[0] = 0;
  Object call1663 = callmethod(*var_file, "read",
    1, partcv, params);
  gc_frame_end(callframe1662);
// compiled call node returning call1663 (depth = 5)
// compiled member node returning call1663 (depth = 4)
  gc_frame_newslot(call1663);
// starting to compile block node (depth = 4)
  Object block1664 = alloc_Block(NULL, NULL, "lexer", 503);
  gc_frame_newslot(block1664);
// method _apply
  block_savedest(block1664);
  Object closure1665 = createclosure(6, "_apply");
  setclosureframe(closure1665, stackframe);
  addtoclosure(closure1665, var_line);
  addtoclosure(closure1665, var_lines);
  addtoclosure(closure1665, var_cLine);
  addtoclosure(closure1665, var_cLines);
  addtoclosure(closure1665, var_source);
  addtoclosure(closure1665, selfslot);
  struct UserObject *uo1665 = (struct UserObject*)block1664;
  uo1665->data[0] = (Object)closure1665;
  Method *meth_meth_lexer__apply1665 = addmethod2pos(block1664, "_apply", &meth_lexer__apply1665, 0);
  int argcv_meth_lexer__apply1665[] = {1};
  meth_meth_lexer__apply1665->type = alloc_MethodType(1, argcv_meth_lexer__apply1665);
  meth_meth_lexer__apply1665->definitionModule = modulename;
  meth_meth_lexer__apply1665->definitionLine = 503;
// compiled block node returning block1664 (depth = 4)
  gc_frame_newslot(block1664);
// call case 5: prelude request
  params[0] = call1663;
  params[1] = block1664;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1734 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1661);
// compiled call node returning call1734 (depth = 3)
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1737 == NULL) {
    strlit1737 = alloc_String("");
    gc_root(strlit1737);
  }
// compiled string node returning strlit1737 (depth = 5)
  int op_slot_right_1736 = gc_frame_newslot(strlit1737);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  int op_slot_left_1736 = gc_frame_newslot(*var_line);
  params[0] = strlit1737;
  partcv[0] = 1;
  Object opresult1739 = callmethod(*var_line, "!=", 1, partcv, params);
// compiled op node returning opresult1739 (depth = 4)
  Object if1735 = done;
  if (istrue(opresult1739)) {
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1740 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lines (depth = 5)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1741 = callmethod(*var_lines, "push",
    1, partcv, params);
  gc_frame_end(callframe1740);
// compiled call node returning call1741 (depth = 4)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1742 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cLine (depth = 5)
  gc_frame_newslot(*var_cLine);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cLines (depth = 5)
  params[0] = *var_cLine;
  partcv[0] = 1;
  Object call1743 = callmethod(*var_cLines, "push",
    1, partcv, params);
  gc_frame_end(callframe1742);
// compiled call node returning call1743 (depth = 4)
    gc_frame_newslot(call1743);
    if1735 = call1743;
  } else {
  }
// compiled if node returning if1735 (depth = 3)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1744 = gc_frame_new();
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lines (depth = 5)
  gc_frame_newslot(*var_lines);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_lines;
  partcv[0] = 1;
  Object call1745 = callmethod(*var_util, "lines:=",
    1, partcv, params);
  gc_frame_end(callframe1744);
// compiled call node returning call1745 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1746 = gc_frame_new();
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cLines (depth = 5)
  gc_frame_newslot(*var_cLines);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = *var_cLines;
  partcv[0] = 1;
  Object call1747 = callmethod(*var_util, "cLines:=",
    1, partcv, params);
  gc_frame_end(callframe1746);
// compiled call node returning call1747 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1748 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  gc_frame_newslot(*var_source);
// call case 4: self request
  params[0] = *var_source;
  partcv[0] = 1;
  Object call1749 = callmethodflags(self, "lexinput", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1748);
// compiled call node returning call1749 (depth = 3)
  gc_frame_end(frame);
  return call1749;
}
Object meth_lexer_push1756(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method push");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1759 = alloc_Boolean(0);
// compiled identifier node returning bool1759 (depth = 7)
  int op_slot_right_1758 = gc_frame_newslot(bool1759);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1761 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1762 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1761);
// compiled call node returning call1762 (depth = 8)
// compiled member node returning call1762 (depth = 7)
  int op_slot_left_1758 = gc_frame_newslot(call1762);
  params[0] = bool1759;
  partcv[0] = 1;
  Object opresult1763 = callmethod(call1762, "==", 1, partcv, params);
// compiled op node returning opresult1763 (depth = 6)
  Object if1757 = done;
  if (istrue(opresult1763)) {
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1764 = gc_frame_new();
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1765 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1764);
// compiled call node returning call1765 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1766 = gc_frame_new();
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1767 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1766);
// compiled call node returning call1767 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1757 = done;
  } else {
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1768 = gc_frame_new();
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1769 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1770 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1769);
// compiled call node returning call1770 (depth = 9)
// compiled member node returning call1770 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1771 = callmethod(call1770, "next:=",
    1, partcv, params);
  gc_frame_end(callframe1768);
// compiled call node returning call1771 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1772 = gc_frame_new();
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1773 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1774 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1773);
// compiled call node returning call1774 (depth = 9)
// compiled member node returning call1774 (depth = 8)
  gc_frame_newslot(call1774);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  params[0] = call1774;
  partcv[0] = 1;
  Object call1775 = callmethod(*var_t, "prev:=",
    1, partcv, params);
  gc_frame_end(callframe1772);
// compiled call node returning call1775 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1776 = gc_frame_new();
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 4: self request
  params[0] = *var_t;
  partcv[0] = 1;
  Object call1777 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1776);
// compiled call node returning call1777 (depth = 7)
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if1757 = done;
  }
// compiled if node returning if1757 (depth = 5)
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1778 = gc_frame_new();
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num1780 = alloc_Float64(1);
// compiled num node returning num1780 (depth = 8)
  int op_slot_right_1779 = gc_frame_newslot(num1780);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1782 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1783 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1782);
// compiled call node returning call1783 (depth = 9)
// compiled member node returning call1783 (depth = 8)
  int op_slot_left_1779 = gc_frame_newslot(call1783);
  params[0] = num1780;
  partcv[0] = 1;
  Object sum1784 = callmethod(call1783, "+", 1, partcv, params);
// compiled op node returning sum1784 (depth = 7)
  gc_frame_newslot(sum1784);
// call case 4: self request
  params[0] = sum1784;
  partcv[0] = 1;
  Object call1785 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1778);
// compiled call node returning call1785 (depth = 6)
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_pop1786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_popped = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "popped");
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1789 = alloc_Boolean(0);
// compiled identifier node returning bool1789 (depth = 7)
  int op_slot_right_1788 = gc_frame_newslot(bool1789);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1792 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1791);
// compiled call node returning call1792 (depth = 8)
// compiled member node returning call1792 (depth = 7)
  int op_slot_left_1788 = gc_frame_newslot(call1792);
  params[0] = bool1789;
  partcv[0] = 1;
  Object opresult1793 = callmethod(call1792, "!=", 1, partcv, params);
// compiled op node returning opresult1793 (depth = 6)
  Object if1787 = done;
  if (istrue(opresult1793)) {
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1795 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1794);
// compiled call node returning call1795 (depth = 8)
// compiled member node returning call1795 (depth = 7)
  *var_popped = call1795;
  if (call1795 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1796 = gc_frame_new();
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1797 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1798 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1799 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1798);
// compiled call node returning call1799 (depth = 11)
// compiled member node returning call1799 (depth = 10)
  partcv[0] = 0;
  Object call1800 = callmethod(call1799, "prev",
    1, partcv, params);
  gc_frame_end(callframe1797);
// compiled call node returning call1800 (depth = 9)
// compiled member node returning call1800 (depth = 8)
  gc_frame_newslot(call1800);
// call case 4: self request
  params[0] = call1800;
  partcv[0] = 1;
  Object call1801 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1796);
// compiled call node returning call1801 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1804 = alloc_Boolean(0);
// compiled identifier node returning bool1804 (depth = 8)
  int op_slot_right_1803 = gc_frame_newslot(bool1804);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1807 = callmethodflags(self, "last", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1806);
// compiled call node returning call1807 (depth = 9)
// compiled member node returning call1807 (depth = 8)
  int op_slot_left_1803 = gc_frame_newslot(call1807);
  params[0] = bool1804;
  partcv[0] = 1;
  Object opresult1808 = callmethod(call1807, "==", 1, partcv, params);
// compiled op node returning opresult1808 (depth = 7)
  Object if1802 = done;
  if (istrue(opresult1808)) {
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1809 = gc_frame_new();
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool1810 = alloc_Boolean(0);
// compiled identifier node returning bool1810 (depth = 9)
  gc_frame_newslot(bool1810);
// call case 4: self request
  params[0] = bool1810;
  partcv[0] = 1;
  Object call1811 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1809);
// compiled call node returning call1811 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1802 = done;
  } else {
  }
// compiled if node returning if1802 (depth = 6)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1812 = gc_frame_new();
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1814 = alloc_Float64(1);
// compiled num node returning num1814 (depth = 9)
  int op_slot_right_1813 = gc_frame_newslot(num1814);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1816 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1817 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1816);
// compiled call node returning call1817 (depth = 10)
// compiled member node returning call1817 (depth = 9)
  int op_slot_left_1813 = gc_frame_newslot(call1817);
  params[0] = num1814;
  partcv[0] = 1;
  Object diff1818 = callmethod(call1817, "-", 1, partcv, params);
// compiled op node returning diff1818 (depth = 8)
  gc_frame_newslot(diff1818);
// call case 4: self request
  params[0] = diff1818;
  partcv[0] = 1;
  Object call1819 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1812);
// compiled call node returning call1819 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_popped (depth = 6)
    gc_frame_newslot(*var_popped);
    if1787 = *var_popped;
  } else {
  }
// compiled if node returning if1787 (depth = 5)
  gc_frame_end(frame);
  return if1787;
}
Object meth_lexer_poll1820(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "poll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for poll (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for poll");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_polled = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "polled");
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1823 = alloc_Boolean(0);
// compiled identifier node returning bool1823 (depth = 7)
  int op_slot_right_1822 = gc_frame_newslot(bool1823);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1825 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1826 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1825);
// compiled call node returning call1826 (depth = 8)
// compiled member node returning call1826 (depth = 7)
  int op_slot_left_1822 = gc_frame_newslot(call1826);
  params[0] = bool1823;
  partcv[0] = 1;
  Object opresult1827 = callmethod(call1826, "!=", 1, partcv, params);
// compiled op node returning opresult1827 (depth = 6)
  Object if1821 = done;
  if (istrue(opresult1827)) {
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1828 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1829 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1828);
// compiled call node returning call1829 (depth = 8)
// compiled member node returning call1829 (depth = 7)
  *var_polled = call1829;
  if (call1829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1830 = gc_frame_new();
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1831 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1832 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1833 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1832);
// compiled call node returning call1833 (depth = 11)
// compiled member node returning call1833 (depth = 10)
  partcv[0] = 0;
  Object call1834 = callmethod(call1833, "next",
    1, partcv, params);
  gc_frame_end(callframe1831);
// compiled call node returning call1834 (depth = 9)
// compiled member node returning call1834 (depth = 8)
  gc_frame_newslot(call1834);
// call case 4: self request
  params[0] = call1834;
  partcv[0] = 1;
  Object call1835 = callmethodflags(self, "first:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1830);
// compiled call node returning call1835 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool1838 = alloc_Boolean(0);
// compiled identifier node returning bool1838 (depth = 8)
  int op_slot_right_1837 = gc_frame_newslot(bool1838);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1840 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1841 = callmethodflags(self, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1840);
// compiled call node returning call1841 (depth = 9)
// compiled member node returning call1841 (depth = 8)
  int op_slot_left_1837 = gc_frame_newslot(call1841);
  params[0] = bool1838;
  partcv[0] = 1;
  Object opresult1842 = callmethod(call1841, "==", 1, partcv, params);
// compiled op node returning opresult1842 (depth = 7)
  Object if1836 = done;
  if (istrue(opresult1842)) {
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1843 = gc_frame_new();
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool1844 = alloc_Boolean(0);
// compiled identifier node returning bool1844 (depth = 9)
  gc_frame_newslot(bool1844);
// call case 4: self request
  params[0] = bool1844;
  partcv[0] = 1;
  Object call1845 = callmethodflags(self, "last:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1845 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1836 = done;
  } else {
  }
// compiled if node returning if1836 (depth = 6)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1846 = gc_frame_new();
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num1848 = alloc_Float64(1);
// compiled num node returning num1848 (depth = 9)
  int op_slot_right_1847 = gc_frame_newslot(num1848);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1850 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1851 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1850);
// compiled call node returning call1851 (depth = 10)
// compiled member node returning call1851 (depth = 9)
  int op_slot_left_1847 = gc_frame_newslot(call1851);
  params[0] = num1848;
  partcv[0] = 1;
  Object diff1852 = callmethod(call1851, "-", 1, partcv, params);
// compiled op node returning diff1852 (depth = 8)
  gc_frame_newslot(diff1852);
// call case 4: self request
  params[0] = diff1852;
  partcv[0] = 1;
  Object call1853 = callmethodflags(self, "size':=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1846);
// compiled call node returning call1853 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_polled (depth = 6)
    gc_frame_newslot(*var_polled);
    if1821 = *var_polled;
  } else {
  }
// compiled if node returning if1821 (depth = 5)
  gc_frame_end(frame);
  return if1821;
}
Object meth_lexer_size1854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1856 = alloc_Float64(0);
// compiled num node returning num1856 (depth = 6)
  int op_slot_right_1855 = gc_frame_newslot(num1856);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1858 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1859 = callmethodflags(self, "size'", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1858);
// compiled call node returning call1859 (depth = 7)
// compiled member node returning call1859 (depth = 6)
  int op_slot_left_1855 = gc_frame_newslot(call1859);
  params[0] = num1856;
  partcv[0] = 1;
  Object sum1860 = callmethod(call1859, "+", 1, partcv, params);
// compiled op node returning sum1860 (depth = 5)
  gc_frame_end(frame);
  return sum1860;
}
Object meth_lexer_havemore1865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "havemore");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for havemore (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for havemore");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1867 = alloc_Boolean(0);
// compiled identifier node returning bool1867 (depth = 6)
  int op_slot_right_1866 = gc_frame_newslot(bool1867);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1869 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1870 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1869);
// compiled call node returning call1870 (depth = 7)
// compiled member node returning call1870 (depth = 6)
  int op_slot_left_1866 = gc_frame_newslot(call1870);
  params[0] = bool1867;
  partcv[0] = 1;
  Object opresult1871 = callmethod(call1870, "!=", 1, partcv, params);
// compiled op node returning opresult1871 (depth = 5)
  gc_frame_end(frame);
  return opresult1871;
}
Object meth_lexer_hasNext1872(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool1874 = alloc_Boolean(0);
// compiled identifier node returning bool1874 (depth = 6)
  int op_slot_right_1873 = gc_frame_newslot(bool1874);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1876 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1877 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1876);
// compiled call node returning call1877 (depth = 7)
// compiled member node returning call1877 (depth = 6)
  int op_slot_left_1873 = gc_frame_newslot(call1877);
  params[0] = bool1874;
  partcv[0] = 1;
  Object opresult1878 = callmethod(call1877, "!=", 1, partcv, params);
// compiled op node returning opresult1878 (depth = 5)
  gc_frame_end(frame);
  return opresult1878;
}
Object meth_lexer_next1879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1880 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1881 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1880);
// compiled call node returning call1881 (depth = 7)
// compiled member node returning call1881 (depth = 6)
  *var_ret = call1881;
  if (call1881 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1882 = gc_frame_new();
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1883 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1884 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1885 = callmethodflags(self, "n", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1884);
// compiled call node returning call1885 (depth = 10)
// compiled member node returning call1885 (depth = 9)
  partcv[0] = 0;
  Object call1886 = callmethod(call1885, "next",
    1, partcv, params);
  gc_frame_end(callframe1883);
// compiled call node returning call1886 (depth = 8)
// compiled member node returning call1886 (depth = 7)
  gc_frame_newslot(call1886);
// call case 4: self request
  params[0] = call1886;
  partcv[0] = 1;
  Object call1887 = callmethodflags(self, "n:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1882);
// compiled call node returning call1887 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ret (depth = 5)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_lexer_iter1861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1862 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1862 = alloc_userobj2(5,5, objclass1862);
  gc_frame_newslot(obj1862);
if (objclass1862 == NULL) {
  glfree(obj1862->class->name);
  obj1862->class->name = "obj1751.iter";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1862, self, 0);
  addmethodreal(obj1862,"outer", &reader_lexer_outer_1863);
  Object oldself1862 = self;
  struct StackFrameObject *oldstackframe1862 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1862);
  gc_frame_newslot((Object)stackframe);
  self = obj1862;
  Object *oldselfslot1862 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1862 = (*(struct UserObject *)self).data[0], lowerouter1862 = thisouter1862;
  if (inheritingObject1862) {
    struct UserObject *inho1862 = (struct UserObject *)inheritingObject1862;
    while (inho1862->super != GraceDefaultObject) inho1862 = (struct UserObject *)inho1862->super;
    inho1862->super = obj1862;
    self = inheritingObject1862;
    *selfslot = self;
    lowerouter1862 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1862;
  }
if (objclass1862 == NULL) {
  Method *reader1864 = addmethodrealflags(obj1862, "n",&reader_lexer_n_1864, 0);
  Method *writer1864 = addmethodrealflags(obj1862, "n:=",&writer_lexer_n_1864, 0);
  reader1864->definitionModule = modulename;
  writer1864->definitionModule = modulename;
  reader1864->definitionLine = 581;
  writer1864->definitionLine = 581;
}
obj1862->flags |= OFLAG_MUTABLE;
adddatum2(obj1862, alloc_Undefined(), 1);
// method havemore
  struct UserObject *uo1865 = (struct UserObject*)obj1862;
  uo1865->data[2] = emptyclosure;
  Method *meth_meth_lexer_havemore1865 = addmethod2pos(obj1862, "havemore", &meth_lexer_havemore1865, 2);
  int argcv_meth_lexer_havemore1865[] = {0};
  meth_meth_lexer_havemore1865->type = alloc_MethodType(1, argcv_meth_lexer_havemore1865);
  meth_meth_lexer_havemore1865->definitionModule = modulename;
  meth_meth_lexer_havemore1865->definitionLine = 581;
// method hasNext
  struct UserObject *uo1872 = (struct UserObject*)obj1862;
  uo1872->data[3] = emptyclosure;
  Method *meth_meth_lexer_hasNext1872 = addmethod2pos(obj1862, "hasNext", &meth_lexer_hasNext1872, 3);
  int argcv_meth_lexer_hasNext1872[] = {0};
  meth_meth_lexer_hasNext1872->type = alloc_MethodType(1, argcv_meth_lexer_hasNext1872);
  meth_meth_lexer_hasNext1872->definitionModule = modulename;
  meth_meth_lexer_hasNext1872->definitionLine = 584;
// method next
  struct UserObject *uo1879 = (struct UserObject*)obj1862;
  uo1879->data[4] = emptyclosure;
  Method *meth_meth_lexer_next1879 = addmethod2pos(obj1862, "next", &meth_lexer_next1879, 4);
  int argcv_meth_lexer_next1879[] = {0};
  meth_meth_lexer_next1879->type = alloc_MethodType(1, argcv_meth_lexer_next1879);
  meth_meth_lexer_next1879->definitionModule = modulename;
  meth_meth_lexer_next1879->definitionLine = 587;
  sourceObject = obj1862;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1888 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1889 = gc_frame_new();
// call case 3: self.outer request
  Object call1890 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1889);
// compiled call node returning call1890 (depth = 8)
// compiled member node returning call1890 (depth = 7)
  partcv[0] = 0;
  Object call1891 = callmethodflags(call1890, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1888);
// compiled call node returning call1891 (depth = 6)
// compiled member node returning call1891 (depth = 5)
  adddatum2(obj1862, call1891, 1);
  sourceObject = obj1862;
  sourceObject = obj1862;
  sourceObject = obj1862;
objclass1862 = obj1862->class;
  objclass1862->definitionModule = modulename;
  objclass1862->definitionLine = 579;
  (*(struct UserObject *)self).data[0] = lowerouter1862;
  self = oldself1862;
  selfslot = oldselfslot1862;
  stackframe = oldstackframe1862;
  gc_frame_end(frame);
  return obj1862;
}
Object meth_lexer_iter1861_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1862 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1862 = alloc_userobj2(5,5, objclass1862);
  gc_frame_newslot(obj1862);
if (objclass1862 == NULL) {
  glfree(obj1862->class->name);
  obj1862->class->name = "obj1751.iter";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1862, self, 0);
  addmethodreal(obj1862,"outer", &reader_lexer_outer_1863);
  Object oldself1862 = self;
  struct StackFrameObject *oldstackframe1862 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1862);
  gc_frame_newslot((Object)stackframe);
  self = obj1862;
  Object *oldselfslot1862 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1862 = (*(struct UserObject *)self).data[0], lowerouter1862 = thisouter1862;
  if (inheritingObject1862) {
    struct UserObject *inho1862 = (struct UserObject *)inheritingObject1862;
    while (inho1862->super != GraceDefaultObject) inho1862 = (struct UserObject *)inho1862->super;
    inho1862->super = obj1862;
    self = inheritingObject1862;
    *selfslot = self;
    lowerouter1862 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1862;
  }
if (objclass1862 == NULL) {
  Method *reader1864 = addmethodrealflags(obj1862, "n",&reader_lexer_n_1864, 0);
  Method *writer1864 = addmethodrealflags(obj1862, "n:=",&writer_lexer_n_1864, 0);
  reader1864->definitionModule = modulename;
  writer1864->definitionModule = modulename;
  reader1864->definitionLine = 581;
  writer1864->definitionLine = 581;
}
obj1862->flags |= OFLAG_MUTABLE;
adddatum2(obj1862, alloc_Undefined(), 1);
// method havemore
  struct UserObject *uo1865 = (struct UserObject*)obj1862;
  uo1865->data[2] = emptyclosure;
  Method *meth_meth_lexer_havemore1865 = addmethod2pos(obj1862, "havemore", &meth_lexer_havemore1865, 2);
  int argcv_meth_lexer_havemore1865[] = {0};
  meth_meth_lexer_havemore1865->type = alloc_MethodType(1, argcv_meth_lexer_havemore1865);
  meth_meth_lexer_havemore1865->definitionModule = modulename;
  meth_meth_lexer_havemore1865->definitionLine = 581;
// method hasNext
  struct UserObject *uo1872 = (struct UserObject*)obj1862;
  uo1872->data[3] = emptyclosure;
  Method *meth_meth_lexer_hasNext1872 = addmethod2pos(obj1862, "hasNext", &meth_lexer_hasNext1872, 3);
  int argcv_meth_lexer_hasNext1872[] = {0};
  meth_meth_lexer_hasNext1872->type = alloc_MethodType(1, argcv_meth_lexer_hasNext1872);
  meth_meth_lexer_hasNext1872->definitionModule = modulename;
  meth_meth_lexer_hasNext1872->definitionLine = 584;
// method next
  struct UserObject *uo1879 = (struct UserObject*)obj1862;
  uo1879->data[4] = emptyclosure;
  Method *meth_meth_lexer_next1879 = addmethod2pos(obj1862, "next", &meth_lexer_next1879, 4);
  int argcv_meth_lexer_next1879[] = {0};
  meth_meth_lexer_next1879->type = alloc_MethodType(1, argcv_meth_lexer_next1879);
  meth_meth_lexer_next1879->definitionModule = modulename;
  meth_meth_lexer_next1879->definitionLine = 587;
  sourceObject = obj1862;
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1888 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1889 = gc_frame_new();
// call case 3: self.outer request
  Object call1890 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1889);
// compiled call node returning call1890 (depth = 8)
// compiled member node returning call1890 (depth = 7)
  partcv[0] = 0;
  Object call1891 = callmethodflags(call1890, "first", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1888);
// compiled call node returning call1891 (depth = 6)
// compiled member node returning call1891 (depth = 5)
  adddatum2(obj1862, call1891, 1);
  sourceObject = obj1862;
  sourceObject = obj1862;
  sourceObject = obj1862;
objclass1862 = obj1862->class;
  objclass1862->definitionModule = modulename;
  objclass1862->definitionLine = 579;
  (*(struct UserObject *)self).data[0] = lowerouter1862;
  self = oldself1862;
  selfslot = oldselfslot1862;
  stackframe = oldstackframe1862;
  gc_frame_end(frame);
  return obj1862;
}
Object meth_lexer_iterator1893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1895 = callmethodflags(self, "iter", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1894);
// compiled call node returning call1895 (depth = 6)
// compiled member node returning call1895 (depth = 5)
  gc_frame_end(frame);
  return call1895;
}
Object meth_lexer__apply2881(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_i = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2883 == NULL) {
    strlit2883 = alloc_String("{");
    gc_root(strlit2883);
  }
// compiled string node returning strlit2883 (depth = 12)
  int op_slot_right_2882 = gc_frame_newslot(strlit2883);
// starting to compile index node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2885 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_line (depth = 14)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2886 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_util (depth = 16)
  partcv[0] = 0;
  Object call2887 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2886);
// compiled call node returning call2887 (depth = 15)
// compiled member node returning call2887 (depth = 14)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call2888 = callmethod(call2887, "at",
    1, partcv, params);
  gc_frame_end(callframe2885);
// compiled call node returning call2888 (depth = 13)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2889 = callmethod(call2888, "[]", 1, partcv, params);
// compiled index node returning idxres2889 (depth = 12)
  int op_slot_left_2882 = gc_frame_newslot(idxres2889);
  params[0] = strlit2883;
  partcv[0] = 1;
  Object opresult2890 = callmethod(idxres2889, "!=", 1, partcv, params);
// compiled op node returning opresult2890 (depth = 11)
  gc_frame_end(frame);
  return opresult2890;
}
Object meth_lexer__apply2893(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_line = getfromclosure(closure, 1);
  Object *var_lineNumber = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num2895 = alloc_Float64(1);
// compiled num node returning num2895 (depth = 13)
  int op_slot_right_2894 = gc_frame_newslot(num2895);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_left_2894 = gc_frame_newslot(*var_i);
  params[0] = num2895;
  partcv[0] = 1;
  Object diff2897 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff2897 (depth = 12)
  *var_i = diff2897;
  if (diff2897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2901 = alloc_Float64(0);
// compiled num node returning num2901 (depth = 13)
  int op_slot_right_2900 = gc_frame_newslot(num2901);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_left_2900 = gc_frame_newslot(*var_i);
  params[0] = num2901;
  partcv[0] = 1;
  Object opresult2903 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult2903 (depth = 12)
  Object if2899 = done;
  if (istrue(opresult2903)) {
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 14)
  Object num2905 = alloc_Float64(1);
// compiled num node returning num2905 (depth = 14)
  int op_slot_right_2904 = gc_frame_newslot(num2905);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_line (depth = 14)
  int op_slot_left_2904 = gc_frame_newslot(*var_line);
  params[0] = num2905;
  partcv[0] = 1;
  Object diff2907 = callmethod(*var_line, "-", 1, partcv, params);
// compiled op node returning diff2907 (depth = 13)
  *var_lineNumber = diff2907;
  if (diff2907 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2909 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 15)
  int callframe2910 = gc_frame_new();
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_line (depth = 16)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_util (depth = 18)
  partcv[0] = 0;
  Object call2912 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2911);
// compiled call node returning call2912 (depth = 17)
// compiled member node returning call2912 (depth = 16)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call2913 = callmethod(call2912, "at",
    1, partcv, params);
  gc_frame_end(callframe2910);
// compiled call node returning call2913 (depth = 15)
  partcv[0] = 0;
  Object call2914 = callmethod(call2913, "size",
    1, partcv, params);
  gc_frame_end(callframe2909);
// compiled call node returning call2914 (depth = 14)
// compiled member node returning call2914 (depth = 13)
  *var_i = call2914;
  if (call2914 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if2899 = done;
  } else {
  }
// compiled if node returning if2899 (depth = 11)
  gc_frame_end(frame);
  return if2899;
}
Object meth_lexer__apply3005(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextLine (depth = 14)
  partcv[0] = 0;
  Object call3008 = callmethod(*var_nextLine, "size",
    1, partcv, params);
  gc_frame_end(callframe3007);
// compiled call node returning call3008 (depth = 13)
// compiled member node returning call3008 (depth = 12)
  int op_slot_right_3006 = gc_frame_newslot(call3008);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_3006 = gc_frame_newslot(*var_i);
  params[0] = call3008;
  partcv[0] = 1;
  Object opresult3010 = callmethod(*var_i, "<=", 1, partcv, params);
// compiled op node returning opresult3010 (depth = 11)
  gc_frame_end(frame);
  return opresult3010;
}
Object meth_lexer__apply3013(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextLine = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object *var_count = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3016 == NULL) {
    strlit3016 = alloc_String("""\x22""");
    gc_root(strlit3016);
  }
// compiled string node returning strlit3016 (depth = 13)
  int op_slot_right_3015 = gc_frame_newslot(strlit3016);
// starting to compile index node (depth = 13)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextLine (depth = 14)
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3018 = callmethod(*var_nextLine, "[]", 1, partcv, params);
// compiled index node returning idxres3018 (depth = 13)
  int op_slot_left_3015 = gc_frame_newslot(idxres3018);
  params[0] = strlit3016;
  partcv[0] = 1;
  Object opresult3019 = callmethod(idxres3018, "==", 1, partcv, params);
// compiled op node returning opresult3019 (depth = 12)
  Object if3014 = done;
  if (istrue(opresult3019)) {
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num3021 = alloc_Float64(1);
// compiled num node returning num3021 (depth = 14)
  int op_slot_right_3020 = gc_frame_newslot(num3021);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_count (depth = 14)
  int op_slot_left_3020 = gc_frame_newslot(*var_count);
  params[0] = num3021;
  partcv[0] = 1;
  Object sum3023 = callmethod(*var_count, "+", 1, partcv, params);
// compiled op node returning sum3023 (depth = 13)
  *var_count = sum3023;
  if (sum3023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3014 = done;
  } else {
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3027 == NULL) {
    strlit3027 = alloc_String("\\");
    gc_root(strlit3027);
  }
// compiled string node returning strlit3027 (depth = 14)
  int op_slot_right_3026 = gc_frame_newslot(strlit3027);
// starting to compile index node (depth = 14)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_nextLine (depth = 15)
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_i (depth = 15)
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3029 = callmethod(*var_nextLine, "[]", 1, partcv, params);
// compiled index node returning idxres3029 (depth = 14)
  int op_slot_left_3026 = gc_frame_newslot(idxres3029);
  params[0] = strlit3027;
  partcv[0] = 1;
  Object opresult3030 = callmethod(idxres3029, "==", 1, partcv, params);
// compiled op node returning opresult3030 (depth = 13)
  Object if3025 = done;
  if (istrue(opresult3030)) {
// starting to compile bind node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num3032 = alloc_Float64(1);
// compiled num node returning num3032 (depth = 15)
  int op_slot_right_3031 = gc_frame_newslot(num3032);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_i (depth = 15)
  int op_slot_left_3031 = gc_frame_newslot(*var_i);
  params[0] = num3032;
  partcv[0] = 1;
  Object sum3034 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum3034 (depth = 14)
  *var_i = sum3034;
  if (sum3034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if3025 = done;
  } else {
  }
// compiled if node returning if3025 (depth = 12)
    gc_frame_newslot(if3025);
    if3014 = if3025;
  }
// compiled if node returning if3014 (depth = 11)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num3037 = alloc_Float64(1);
// compiled num node returning num3037 (depth = 13)
  int op_slot_right_3036 = gc_frame_newslot(num3037);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_left_3036 = gc_frame_newslot(*var_i);
  params[0] = num3037;
  partcv[0] = 1;
  Object sum3039 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum3039 (depth = 12)
  *var_i = sum3039;
  if (sum3039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer__apply2106(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(20, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_badSeparator = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_linePosition = getfromclosure(closure, 2);
  Object *var_lineNumber = getfromclosure(closure, 3);
  Object *var_instr = getfromclosure(closure, 4);
  Object *var_unicode = getfromclosure(closure, 5);
  Object *var_badControl = getfromclosure(closure, 6);
  Object *var_atStart = getfromclosure(closure, 7);
  Object *var_mode = getfromclosure(closure, 8);
  Object *var_newmode = getfromclosure(closure, 9);
  Object *var_identifierChar = getfromclosure(closure, 10);
  Object *var_digit = getfromclosure(closure, 11);
  Object *var_iGTLT = getfromclosure(closure, 12);
  Object *var_tokens = getfromclosure(closure, 13);
  Object *var_accum = getfromclosure(closure, 14);
  Object *var_operatorChar = getfromclosure(closure, 15);
  Object *var_selfModes = getfromclosure(closure, 16);
  Object *var_util = getfromclosure(closure, 17);
  Object *var_escaped = getfromclosure(closure, 18);
  Object *var_interpString = getfromclosure(closure, 19);
  Object *var_interpdepth = getfromclosure(closure, 20);
  Object *var_brackets = getfromclosure(closure, 21);
  Object *var_unichars = getfromclosure(closure, 22);
  Object *var_codepoint = getfromclosure(closure, 23);
  Object *var_startPosition = getfromclosure(closure, 24);
  Object self = *(getfromclosure(closure, 25));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ct = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ct");
  Object *var_ordval = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ordval");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_i = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "i");
  Object *var_suggestions = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestions");
  Object *var_errorLine = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "errorLine");
  Object *var_nextLine = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "nextLine");
  Object *var_count = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "count");
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit2107 == NULL) {
    strlit2107 = alloc_String("");
    gc_root(strlit2107);
  }
// compiled string node returning strlit2107 (depth = 6)
  *var_ct = strlit2107;
  if (strlit2107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  partcv[0] = 0;
  Object call2109 = callmethod(*var_c, "ord",
    1, partcv, params);
  gc_frame_end(callframe2108);
// compiled call node returning call2109 (depth = 7)
// compiled member node returning call2109 (depth = 6)
  *var_ordval = call2109;
  if (call2109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2111 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ordval (depth = 7)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_badSeparator (depth = 7)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2112 = callmethod(*var_badSeparator, "match",
    1, partcv, params);
  gc_frame_end(callframe2111);
// compiled call node returning call2112 (depth = 6)
  Object if2110 = done;
  if (istrue(call2112)) {
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2113 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2115 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2114);
// compiled call node returning call2115 (depth = 10)
// compiled member node returning call2115 (depth = 9)
  partcv[0] = 0;
  Object call2116 = callmethod(call2115, "new",
    1, partcv, params);
  gc_frame_end(callframe2113);
// compiled call node returning call2116 (depth = 8)
// compiled member node returning call2116 (depth = 7)
  *var_suggestion = call2116;
  if (call2116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2117 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile string node (depth = 7)
  if (strlit2118 == NULL) {
    strlit2118 = alloc_String(" ");
    gc_root(strlit2118);
  }
// compiled string node returning strlit2118 (depth = 7)
  gc_frame_newslot(strlit2118);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_linePosition;
  params[1] = strlit2118;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2119 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2117);
// compiled call node returning call2119 (depth = 6)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2122 = alloc_Float64(9);
// compiled num node returning num2122 (depth = 8)
  int op_slot_right_2121 = gc_frame_newslot(num2122);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ordval (depth = 8)
  int op_slot_left_2121 = gc_frame_newslot(*var_ordval);
  params[0] = num2122;
  partcv[0] = 1;
  Object opresult2124 = callmethod(*var_ordval, "==", 1, partcv, params);
// compiled op node returning opresult2124 (depth = 7)
  Object if2120 = done;
  if (istrue(opresult2124)) {
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_instr (depth = 8)
  Object if2125 = done;
  if (istrue(*var_instr)) {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2126 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2128 == NULL) {
    strlit2128 = alloc_String("");
    gc_root(strlit2128);
  }
// compiled string node returning strlit2128 (depth = 10)
  int op_slot_right_2127 = gc_frame_newslot(strlit2128);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2131 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2132 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2133 = alloc_Float64(16);
// compiled num node returning num2133 (depth = 13)
  gc_frame_newslot(num2133);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2133;
  partcv[0] = 1;
  Object call2134 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2132);
// compiled call node returning call2134 (depth = 12)
  gc_frame_newslot(call2134);
// starting to compile num node (depth = 12)
  Object num2135 = alloc_Float64(4);
// compiled num node returning num2135 (depth = 12)
  gc_frame_newslot(num2135);
// starting to compile string node (depth = 12)
  if (strlit2136 == NULL) {
    strlit2136 = alloc_String("0");
    gc_root(strlit2136);
  }
// compiled string node returning strlit2136 (depth = 12)
  gc_frame_newslot(strlit2136);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2137 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2138 = gc_frame_new();
// call case 3: self.outer request
  Object call2139 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2138);
// compiled call node returning call2139 (depth = 15)
// compiled member node returning call2139 (depth = 14)
  partcv[0] = 0;
  Object call2140 = callmethodflags(call2139, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2137);
// compiled call node returning call2140 (depth = 13)
// compiled member node returning call2140 (depth = 12)
  params[0] = call2134;
  params[1] = num2135;
  params[2] = strlit2136;
  partcv[0] = 3;
  Object call2141 = callmethodflags(call2140, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2131);
// compiled call node returning call2141 (depth = 11)
  int op_slot_right_2130 = gc_frame_newslot(call2141);
// starting to compile string node (depth = 11)
  if (strlit2143 == NULL) {
    strlit2143 = alloc_String("\\u");
    gc_root(strlit2143);
  }
// compiled string node returning strlit2143 (depth = 11)
  int op_slot_left_2130 = gc_frame_newslot(strlit2143);
  params[0] = call2141;
  partcv[0] = 1;
  Object opresult2144 = callmethod(strlit2143, "++", 1, partcv, params);
// compiled op node returning opresult2144 (depth = 10)
  int op_slot_left_2127 = gc_frame_newslot(opresult2144);
  params[0] = strlit2128;
  partcv[0] = 1;
  Object opresult2145 = callmethod(opresult2144, "++", 1, partcv, params);
// compiled op node returning opresult2145 (depth = 9)
  gc_frame_newslot(opresult2145);
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2145;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2146 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2126);
// compiled call node returning call2146 (depth = 8)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2147 = gc_frame_new();
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2149 == NULL) {
    strlit2149 = alloc_String(" instead");
    gc_root(strlit2149);
  }
// compiled string node returning strlit2149 (depth = 10)
  int op_slot_right_2148 = gc_frame_newslot(strlit2149);
// starting to compile op node (depth = 10)
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2152 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2153 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2154 = alloc_Float64(16);
// compiled num node returning num2154 (depth = 13)
  gc_frame_newslot(num2154);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2154;
  partcv[0] = 1;
  Object call2155 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2153);
// compiled call node returning call2155 (depth = 12)
  gc_frame_newslot(call2155);
// starting to compile num node (depth = 12)
  Object num2156 = alloc_Float64(4);
// compiled num node returning num2156 (depth = 12)
  gc_frame_newslot(num2156);
// starting to compile string node (depth = 12)
  if (strlit2157 == NULL) {
    strlit2157 = alloc_String("0");
    gc_root(strlit2157);
  }
// compiled string node returning strlit2157 (depth = 12)
  gc_frame_newslot(strlit2157);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2158 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2159 = gc_frame_new();
// call case 3: self.outer request
  Object call2160 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2159);
// compiled call node returning call2160 (depth = 15)
// compiled member node returning call2160 (depth = 14)
  partcv[0] = 0;
  Object call2161 = callmethodflags(call2160, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2158);
// compiled call node returning call2161 (depth = 13)
// compiled member node returning call2161 (depth = 12)
  params[0] = call2155;
  params[1] = num2156;
  params[2] = strlit2157;
  partcv[0] = 3;
  Object call2162 = callmethodflags(call2161, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2152);
// compiled call node returning call2162 (depth = 11)
  int op_slot_right_2151 = gc_frame_newslot(call2162);
// starting to compile op node (depth = 11)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2165 == NULL) {
    strlit2165 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2165);
  }
// compiled string node returning strlit2165 (depth = 12)
  int op_slot_right_2164 = gc_frame_newslot(strlit2165);
// starting to compile op node (depth = 12)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2168 == NULL) {
    strlit2168 = alloc_String("written in the source code; ");
    gc_root(strlit2168);
  }
// compiled string node returning strlit2168 (depth = 13)
  int op_slot_right_2167 = gc_frame_newslot(strlit2168);
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2170 == NULL) {
    strlit2170 = alloc_String("tabs cannot be ");
    gc_root(strlit2170);
  }
// compiled string node returning strlit2170 (depth = 13)
  int op_slot_left_2167 = gc_frame_newslot(strlit2170);
  params[0] = strlit2168;
  partcv[0] = 1;
  Object opresult2171 = callmethod(strlit2170, "++", 1, partcv, params);
// compiled op node returning opresult2171 (depth = 12)
  int op_slot_left_2164 = gc_frame_newslot(opresult2171);
  params[0] = strlit2165;
  partcv[0] = 1;
  Object opresult2172 = callmethod(opresult2171, "++", 1, partcv, params);
// compiled op node returning opresult2172 (depth = 11)
  int op_slot_left_2151 = gc_frame_newslot(opresult2172);
  params[0] = call2162;
  partcv[0] = 1;
  Object opresult2173 = callmethod(opresult2172, "++", 1, partcv, params);
// compiled op node returning opresult2173 (depth = 10)
  int op_slot_left_2148 = gc_frame_newslot(opresult2173);
  params[0] = strlit2149;
  partcv[0] = 1;
  Object opresult2174 = callmethod(opresult2173, "++", 1, partcv, params);
// compiled op node returning opresult2174 (depth = 9)
  gc_frame_newslot(opresult2174);
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult2174;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2175 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2147);
// compiled call node returning call2175 (depth = 8)
    gc_frame_newslot(call2175);
    if2125 = call2175;
  } else {
  }
// compiled if node returning if2125 (depth = 7)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2176 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2177 == NULL) {
    strlit2177 = alloc_String("Tabs are not allowed; use spaces instead.");
    gc_root(strlit2177);
  }
// compiled string node returning strlit2177 (depth = 8)
  gc_frame_newslot(strlit2177);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2177;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2178 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2176);
// compiled call node returning call2178 (depth = 7)
    gc_frame_newslot(call2178);
    if2120 = call2178;
  } else {
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_instr (depth = 8)
  Object if2179 = done;
  if (istrue(*var_instr)) {
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2180 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2182 == NULL) {
    strlit2182 = alloc_String("");
    gc_root(strlit2182);
  }
// compiled string node returning strlit2182 (depth = 10)
  int op_slot_right_2181 = gc_frame_newslot(strlit2182);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2185 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2186 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2187 = alloc_Float64(16);
// compiled num node returning num2187 (depth = 13)
  gc_frame_newslot(num2187);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2187;
  partcv[0] = 1;
  Object call2188 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2186);
// compiled call node returning call2188 (depth = 12)
  gc_frame_newslot(call2188);
// starting to compile num node (depth = 12)
  Object num2189 = alloc_Float64(4);
// compiled num node returning num2189 (depth = 12)
  gc_frame_newslot(num2189);
// starting to compile string node (depth = 12)
  if (strlit2190 == NULL) {
    strlit2190 = alloc_String("0");
    gc_root(strlit2190);
  }
// compiled string node returning strlit2190 (depth = 12)
  gc_frame_newslot(strlit2190);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2191 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2192 = gc_frame_new();
// call case 3: self.outer request
  Object call2193 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2192);
// compiled call node returning call2193 (depth = 15)
// compiled member node returning call2193 (depth = 14)
  partcv[0] = 0;
  Object call2194 = callmethodflags(call2193, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2191);
// compiled call node returning call2194 (depth = 13)
// compiled member node returning call2194 (depth = 12)
  params[0] = call2188;
  params[1] = num2189;
  params[2] = strlit2190;
  partcv[0] = 3;
  Object call2195 = callmethodflags(call2194, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2185);
// compiled call node returning call2195 (depth = 11)
  int op_slot_right_2184 = gc_frame_newslot(call2195);
// starting to compile string node (depth = 11)
  if (strlit2197 == NULL) {
    strlit2197 = alloc_String("\\u");
    gc_root(strlit2197);
  }
// compiled string node returning strlit2197 (depth = 11)
  int op_slot_left_2184 = gc_frame_newslot(strlit2197);
  params[0] = call2195;
  partcv[0] = 1;
  Object opresult2198 = callmethod(strlit2197, "++", 1, partcv, params);
// compiled op node returning opresult2198 (depth = 10)
  int op_slot_left_2181 = gc_frame_newslot(opresult2198);
  params[0] = strlit2182;
  partcv[0] = 1;
  Object opresult2199 = callmethod(opresult2198, "++", 1, partcv, params);
// compiled op node returning opresult2199 (depth = 9)
  gc_frame_newslot(opresult2199);
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2199;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2200 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2180);
// compiled call node returning call2200 (depth = 8)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2201 = gc_frame_new();
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2203 == NULL) {
    strlit2203 = alloc_String(" instead");
    gc_root(strlit2203);
  }
// compiled string node returning strlit2203 (depth = 10)
  int op_slot_right_2202 = gc_frame_newslot(strlit2203);
// starting to compile op node (depth = 10)
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2206 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2207 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2208 = alloc_Float64(16);
// compiled num node returning num2208 (depth = 13)
  gc_frame_newslot(num2208);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2208;
  partcv[0] = 1;
  Object call2209 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2207);
// compiled call node returning call2209 (depth = 12)
  gc_frame_newslot(call2209);
// starting to compile num node (depth = 12)
  Object num2210 = alloc_Float64(4);
// compiled num node returning num2210 (depth = 12)
  gc_frame_newslot(num2210);
// starting to compile string node (depth = 12)
  if (strlit2211 == NULL) {
    strlit2211 = alloc_String("0");
    gc_root(strlit2211);
  }
// compiled string node returning strlit2211 (depth = 12)
  gc_frame_newslot(strlit2211);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2212 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2213 = gc_frame_new();
// call case 3: self.outer request
  Object call2214 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2213);
// compiled call node returning call2214 (depth = 15)
// compiled member node returning call2214 (depth = 14)
  partcv[0] = 0;
  Object call2215 = callmethodflags(call2214, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2212);
// compiled call node returning call2215 (depth = 13)
// compiled member node returning call2215 (depth = 12)
  params[0] = call2209;
  params[1] = num2210;
  params[2] = strlit2211;
  partcv[0] = 3;
  Object call2216 = callmethodflags(call2215, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2206);
// compiled call node returning call2216 (depth = 11)
  int op_slot_right_2205 = gc_frame_newslot(call2216);
// starting to compile op node (depth = 11)
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2219 == NULL) {
    strlit2219 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2219);
  }
// compiled string node returning strlit2219 (depth = 12)
  int op_slot_right_2218 = gc_frame_newslot(strlit2219);
// starting to compile op node (depth = 12)
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2222 == NULL) {
    strlit2222 = alloc_String("written in the source code; ");
    gc_root(strlit2222);
  }
// compiled string node returning strlit2222 (depth = 13)
  int op_slot_right_2221 = gc_frame_newslot(strlit2222);
// starting to compile op node (depth = 13)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit2225 == NULL) {
    strlit2225 = alloc_String(" and cannot be ");
    gc_root(strlit2225);
  }
// compiled string node returning strlit2225 (depth = 14)
  int op_slot_right_2224 = gc_frame_newslot(strlit2225);
// starting to compile op node (depth = 14)
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 15)
  if (strlit2228 == NULL) {
    strlit2228 = alloc_String("is not a valid whitespace character");
    gc_root(strlit2228);
  }
// compiled string node returning strlit2228 (depth = 15)
  int op_slot_right_2227 = gc_frame_newslot(strlit2228);
// starting to compile op node (depth = 15)
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 16)
  if (strlit2231 == NULL) {
    strlit2231 = alloc_String(") ");
    gc_root(strlit2231);
  }
// compiled string node returning strlit2231 (depth = 16)
  int op_slot_right_2230 = gc_frame_newslot(strlit2231);
// starting to compile op node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2234 = gc_frame_new();
// starting to compile call node (depth = 18)
  int callframe2235 = gc_frame_new();
// starting to compile num node (depth = 19)
  Object num2236 = alloc_Float64(16);
// compiled num node returning num2236 (depth = 19)
  gc_frame_newslot(num2236);
// call case 6: other member request
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_ordval (depth = 19)
  params[0] = num2236;
  partcv[0] = 1;
  Object call2237 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2235);
// compiled call node returning call2237 (depth = 18)
  gc_frame_newslot(call2237);
// starting to compile num node (depth = 18)
  Object num2238 = alloc_Float64(4);
// compiled num node returning num2238 (depth = 18)
  gc_frame_newslot(num2238);
// starting to compile string node (depth = 18)
  if (strlit2239 == NULL) {
    strlit2239 = alloc_String("0");
    gc_root(strlit2239);
  }
// compiled string node returning strlit2239 (depth = 18)
  gc_frame_newslot(strlit2239);
// call case 2: outer request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2240 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 20)
// starting to compile call node (depth = 21)
  int callframe2241 = gc_frame_new();
// call case 3: self.outer request
  Object call2242 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2241);
// compiled call node returning call2242 (depth = 21)
// compiled member node returning call2242 (depth = 20)
  partcv[0] = 0;
  Object call2243 = callmethodflags(call2242, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2240);
// compiled call node returning call2243 (depth = 19)
// compiled member node returning call2243 (depth = 18)
  params[0] = call2237;
  params[1] = num2238;
  params[2] = strlit2239;
  partcv[0] = 3;
  Object call2244 = callmethodflags(call2243, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2234);
// compiled call node returning call2244 (depth = 17)
  int op_slot_right_2233 = gc_frame_newslot(call2244);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit2247 == NULL) {
    strlit2247 = alloc_String(" (U+");
    gc_root(strlit2247);
  }
// compiled string node returning strlit2247 (depth = 18)
  int op_slot_right_2246 = gc_frame_newslot(strlit2247);
// starting to compile op node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2250 = gc_frame_new();
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_c (depth = 20)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 20)
// compiled identifier node returning *var_unicode (depth = 20)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2251 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2250);
// compiled call node returning call2251 (depth = 19)
  int op_slot_right_2249 = gc_frame_newslot(call2251);
// starting to compile string node (depth = 19)
  if (strlit2253 == NULL) {
    strlit2253 = alloc_String("");
    gc_root(strlit2253);
  }
// compiled string node returning strlit2253 (depth = 19)
  int op_slot_left_2249 = gc_frame_newslot(strlit2253);
  params[0] = call2251;
  partcv[0] = 1;
  Object opresult2254 = callmethod(strlit2253, "++", 1, partcv, params);
// compiled op node returning opresult2254 (depth = 18)
  int op_slot_left_2246 = gc_frame_newslot(opresult2254);
  params[0] = strlit2247;
  partcv[0] = 1;
  Object opresult2255 = callmethod(opresult2254, "++", 1, partcv, params);
// compiled op node returning opresult2255 (depth = 17)
  int op_slot_left_2233 = gc_frame_newslot(opresult2255);
  params[0] = call2244;
  partcv[0] = 1;
  Object opresult2256 = callmethod(opresult2255, "++", 1, partcv, params);
// compiled op node returning opresult2256 (depth = 16)
  int op_slot_left_2230 = gc_frame_newslot(opresult2256);
  params[0] = strlit2231;
  partcv[0] = 1;
  Object opresult2257 = callmethod(opresult2256, "++", 1, partcv, params);
// compiled op node returning opresult2257 (depth = 15)
  int op_slot_left_2227 = gc_frame_newslot(opresult2257);
  params[0] = strlit2228;
  partcv[0] = 1;
  Object opresult2258 = callmethod(opresult2257, "++", 1, partcv, params);
// compiled op node returning opresult2258 (depth = 14)
  int op_slot_left_2224 = gc_frame_newslot(opresult2258);
  params[0] = strlit2225;
  partcv[0] = 1;
  Object opresult2259 = callmethod(opresult2258, "++", 1, partcv, params);
// compiled op node returning opresult2259 (depth = 13)
  int op_slot_left_2221 = gc_frame_newslot(opresult2259);
  params[0] = strlit2222;
  partcv[0] = 1;
  Object opresult2260 = callmethod(opresult2259, "++", 1, partcv, params);
// compiled op node returning opresult2260 (depth = 12)
  int op_slot_left_2218 = gc_frame_newslot(opresult2260);
  params[0] = strlit2219;
  partcv[0] = 1;
  Object opresult2261 = callmethod(opresult2260, "++", 1, partcv, params);
// compiled op node returning opresult2261 (depth = 11)
  int op_slot_left_2205 = gc_frame_newslot(opresult2261);
  params[0] = call2216;
  partcv[0] = 1;
  Object opresult2262 = callmethod(opresult2261, "++", 1, partcv, params);
// compiled op node returning opresult2262 (depth = 10)
  int op_slot_left_2202 = gc_frame_newslot(opresult2262);
  params[0] = strlit2203;
  partcv[0] = 1;
  Object opresult2263 = callmethod(opresult2262, "++", 1, partcv, params);
// compiled op node returning opresult2263 (depth = 9)
  gc_frame_newslot(opresult2263);
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lineNumber (depth = 9)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_linePosition (depth = 9)
  gc_frame_newslot(*var_linePosition);
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult2263;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2264 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2201);
// compiled call node returning call2264 (depth = 8)
    gc_frame_newslot(call2264);
    if2179 = call2264;
  } else {
  }
// compiled if node returning if2179 (depth = 7)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2265 = gc_frame_new();
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2267 == NULL) {
    strlit2267 = alloc_String("is not a valid whitespace character; use spaces instead.");
    gc_root(strlit2267);
  }
// compiled string node returning strlit2267 (depth = 9)
  int op_slot_right_2266 = gc_frame_newslot(strlit2267);
// starting to compile op node (depth = 9)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2270 == NULL) {
    strlit2270 = alloc_String(") ");
    gc_root(strlit2270);
  }
// compiled string node returning strlit2270 (depth = 10)
  int op_slot_right_2269 = gc_frame_newslot(strlit2270);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2273 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe2274 = gc_frame_new();
// starting to compile num node (depth = 13)
  Object num2275 = alloc_Float64(16);
// compiled num node returning num2275 (depth = 13)
  gc_frame_newslot(num2275);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  params[0] = num2275;
  partcv[0] = 1;
  Object call2276 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2274);
// compiled call node returning call2276 (depth = 12)
  gc_frame_newslot(call2276);
// starting to compile num node (depth = 12)
  Object num2277 = alloc_Float64(4);
// compiled num node returning num2277 (depth = 12)
  gc_frame_newslot(num2277);
// starting to compile string node (depth = 12)
  if (strlit2278 == NULL) {
    strlit2278 = alloc_String("0");
    gc_root(strlit2278);
  }
// compiled string node returning strlit2278 (depth = 12)
  gc_frame_newslot(strlit2278);
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2279 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2280 = gc_frame_new();
// call case 3: self.outer request
  Object call2281 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2280);
// compiled call node returning call2281 (depth = 15)
// compiled member node returning call2281 (depth = 14)
  partcv[0] = 0;
  Object call2282 = callmethodflags(call2281, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2279);
// compiled call node returning call2282 (depth = 13)
// compiled member node returning call2282 (depth = 12)
  params[0] = call2276;
  params[1] = num2277;
  params[2] = strlit2278;
  partcv[0] = 3;
  Object call2283 = callmethodflags(call2282, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2273);
// compiled call node returning call2283 (depth = 11)
  int op_slot_right_2272 = gc_frame_newslot(call2283);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2286 == NULL) {
    strlit2286 = alloc_String(" (U+");
    gc_root(strlit2286);
  }
// compiled string node returning strlit2286 (depth = 12)
  int op_slot_right_2285 = gc_frame_newslot(strlit2286);
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2289 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2290 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2289);
// compiled call node returning call2290 (depth = 13)
  int op_slot_right_2288 = gc_frame_newslot(call2290);
// starting to compile string node (depth = 13)
  if (strlit2292 == NULL) {
    strlit2292 = alloc_String("");
    gc_root(strlit2292);
  }
// compiled string node returning strlit2292 (depth = 13)
  int op_slot_left_2288 = gc_frame_newslot(strlit2292);
  params[0] = call2290;
  partcv[0] = 1;
  Object opresult2293 = callmethod(strlit2292, "++", 1, partcv, params);
// compiled op node returning opresult2293 (depth = 12)
  int op_slot_left_2285 = gc_frame_newslot(opresult2293);
  params[0] = strlit2286;
  partcv[0] = 1;
  Object opresult2294 = callmethod(opresult2293, "++", 1, partcv, params);
// compiled op node returning opresult2294 (depth = 11)
  int op_slot_left_2272 = gc_frame_newslot(opresult2294);
  params[0] = call2283;
  partcv[0] = 1;
  Object opresult2295 = callmethod(opresult2294, "++", 1, partcv, params);
// compiled op node returning opresult2295 (depth = 10)
  int op_slot_left_2269 = gc_frame_newslot(opresult2295);
  params[0] = strlit2270;
  partcv[0] = 1;
  Object opresult2296 = callmethod(opresult2295, "++", 1, partcv, params);
// compiled op node returning opresult2296 (depth = 9)
  int op_slot_left_2266 = gc_frame_newslot(opresult2296);
  params[0] = strlit2267;
  partcv[0] = 1;
  Object opresult2297 = callmethod(opresult2296, "++", 1, partcv, params);
// compiled op node returning opresult2297 (depth = 8)
  gc_frame_newslot(opresult2297);
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2297;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2298 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2265);
// compiled call node returning call2298 (depth = 7)
    gc_frame_newslot(call2298);
    if2120 = call2298;
  }
// compiled if node returning if2120 (depth = 6)
    gc_frame_newslot(if2120);
    if2110 = if2120;
  } else {
  }
// compiled if node returning if2110 (depth = 5)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2300 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ordval (depth = 7)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_badControl (depth = 7)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2301 = callmethod(*var_badControl, "match",
    1, partcv, params);
  gc_frame_end(callframe2300);
// compiled call node returning call2301 (depth = 6)
  Object if2299 = done;
  if (istrue(call2301)) {
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2302 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2303 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2304 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2303);
// compiled call node returning call2304 (depth = 10)
// compiled member node returning call2304 (depth = 9)
  partcv[0] = 0;
  Object call2305 = callmethod(call2304, "new",
    1, partcv, params);
  gc_frame_end(callframe2302);
// compiled call node returning call2305 (depth = 8)
// compiled member node returning call2305 (depth = 7)
  *var_suggestion = call2305;
  if (call2305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_instr (depth = 7)
  Object if2306 = done;
  if (istrue(*var_instr)) {
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2307 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2309 == NULL) {
    strlit2309 = alloc_String("");
    gc_root(strlit2309);
  }
// compiled string node returning strlit2309 (depth = 9)
  int op_slot_right_2308 = gc_frame_newslot(strlit2309);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2312 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2313 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2314 = alloc_Float64(16);
// compiled num node returning num2314 (depth = 12)
  gc_frame_newslot(num2314);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2314;
  partcv[0] = 1;
  Object call2315 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2313);
// compiled call node returning call2315 (depth = 11)
  gc_frame_newslot(call2315);
// starting to compile num node (depth = 11)
  Object num2316 = alloc_Float64(4);
// compiled num node returning num2316 (depth = 11)
  gc_frame_newslot(num2316);
// starting to compile string node (depth = 11)
  if (strlit2317 == NULL) {
    strlit2317 = alloc_String("0");
    gc_root(strlit2317);
  }
// compiled string node returning strlit2317 (depth = 11)
  gc_frame_newslot(strlit2317);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2318 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2319 = gc_frame_new();
// call case 3: self.outer request
  Object call2320 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2319);
// compiled call node returning call2320 (depth = 14)
// compiled member node returning call2320 (depth = 13)
  partcv[0] = 0;
  Object call2321 = callmethodflags(call2320, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2318);
// compiled call node returning call2321 (depth = 12)
// compiled member node returning call2321 (depth = 11)
  params[0] = call2315;
  params[1] = num2316;
  params[2] = strlit2317;
  partcv[0] = 3;
  Object call2322 = callmethodflags(call2321, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2312);
// compiled call node returning call2322 (depth = 10)
  int op_slot_right_2311 = gc_frame_newslot(call2322);
// starting to compile string node (depth = 10)
  if (strlit2324 == NULL) {
    strlit2324 = alloc_String("\\u");
    gc_root(strlit2324);
  }
// compiled string node returning strlit2324 (depth = 10)
  int op_slot_left_2311 = gc_frame_newslot(strlit2324);
  params[0] = call2322;
  partcv[0] = 1;
  Object opresult2325 = callmethod(strlit2324, "++", 1, partcv, params);
// compiled op node returning opresult2325 (depth = 9)
  int op_slot_left_2308 = gc_frame_newslot(opresult2325);
  params[0] = strlit2309;
  partcv[0] = 1;
  Object opresult2326 = callmethod(opresult2325, "++", 1, partcv, params);
// compiled op node returning opresult2326 (depth = 8)
  gc_frame_newslot(opresult2326);
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_linePosition;
  params[1] = *var_linePosition;
  params[2] = opresult2326;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2327 = callmethod(*var_suggestion, "replaceRange()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2307);
// compiled call node returning call2327 (depth = 7)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2328 = gc_frame_new();
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2330 == NULL) {
    strlit2330 = alloc_String(" instead");
    gc_root(strlit2330);
  }
// compiled string node returning strlit2330 (depth = 9)
  int op_slot_right_2329 = gc_frame_newslot(strlit2330);
// starting to compile op node (depth = 9)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2333 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2334 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2335 = alloc_Float64(16);
// compiled num node returning num2335 (depth = 12)
  gc_frame_newslot(num2335);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2335;
  partcv[0] = 1;
  Object call2336 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2334);
// compiled call node returning call2336 (depth = 11)
  gc_frame_newslot(call2336);
// starting to compile num node (depth = 11)
  Object num2337 = alloc_Float64(4);
// compiled num node returning num2337 (depth = 11)
  gc_frame_newslot(num2337);
// starting to compile string node (depth = 11)
  if (strlit2338 == NULL) {
    strlit2338 = alloc_String("0");
    gc_root(strlit2338);
  }
// compiled string node returning strlit2338 (depth = 11)
  gc_frame_newslot(strlit2338);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2339 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2340 = gc_frame_new();
// call case 3: self.outer request
  Object call2341 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2340);
// compiled call node returning call2341 (depth = 14)
// compiled member node returning call2341 (depth = 13)
  partcv[0] = 0;
  Object call2342 = callmethodflags(call2341, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2339);
// compiled call node returning call2342 (depth = 12)
// compiled member node returning call2342 (depth = 11)
  params[0] = call2336;
  params[1] = num2337;
  params[2] = strlit2338;
  partcv[0] = 3;
  Object call2343 = callmethodflags(call2342, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2333);
// compiled call node returning call2343 (depth = 10)
  int op_slot_right_2332 = gc_frame_newslot(call2343);
// starting to compile op node (depth = 10)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2346 == NULL) {
    strlit2346 = alloc_String("use the Unicode escape \\u");
    gc_root(strlit2346);
  }
// compiled string node returning strlit2346 (depth = 11)
  int op_slot_right_2345 = gc_frame_newslot(strlit2346);
// starting to compile op node (depth = 11)
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit2349 == NULL) {
    strlit2349 = alloc_String("written in the source code; ");
    gc_root(strlit2349);
  }
// compiled string node returning strlit2349 (depth = 12)
  int op_slot_right_2348 = gc_frame_newslot(strlit2349);
// starting to compile op node (depth = 12)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 13)
  if (strlit2352 == NULL) {
    strlit2352 = alloc_String("is a control character and cannot be ");
    gc_root(strlit2352);
  }
// compiled string node returning strlit2352 (depth = 13)
  int op_slot_right_2351 = gc_frame_newslot(strlit2352);
// starting to compile op node (depth = 13)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit2355 == NULL) {
    strlit2355 = alloc_String(") ");
    gc_root(strlit2355);
  }
// compiled string node returning strlit2355 (depth = 14)
  int op_slot_right_2354 = gc_frame_newslot(strlit2355);
// starting to compile op node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2358 = gc_frame_new();
// starting to compile call node (depth = 16)
  int callframe2359 = gc_frame_new();
// starting to compile num node (depth = 17)
  Object num2360 = alloc_Float64(16);
// compiled num node returning num2360 (depth = 17)
  gc_frame_newslot(num2360);
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_ordval (depth = 17)
  params[0] = num2360;
  partcv[0] = 1;
  Object call2361 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2359);
// compiled call node returning call2361 (depth = 16)
  gc_frame_newslot(call2361);
// starting to compile num node (depth = 16)
  Object num2362 = alloc_Float64(4);
// compiled num node returning num2362 (depth = 16)
  gc_frame_newslot(num2362);
// starting to compile string node (depth = 16)
  if (strlit2363 == NULL) {
    strlit2363 = alloc_String("0");
    gc_root(strlit2363);
  }
// compiled string node returning strlit2363 (depth = 16)
  gc_frame_newslot(strlit2363);
// call case 2: outer request
// starting to compile member node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2364 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2365 = gc_frame_new();
// call case 3: self.outer request
  Object call2366 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2365);
// compiled call node returning call2366 (depth = 19)
// compiled member node returning call2366 (depth = 18)
  partcv[0] = 0;
  Object call2367 = callmethodflags(call2366, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2364);
// compiled call node returning call2367 (depth = 17)
// compiled member node returning call2367 (depth = 16)
  params[0] = call2361;
  params[1] = num2362;
  params[2] = strlit2363;
  partcv[0] = 3;
  Object call2368 = callmethodflags(call2367, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2358);
// compiled call node returning call2368 (depth = 15)
  int op_slot_right_2357 = gc_frame_newslot(call2368);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit2371 == NULL) {
    strlit2371 = alloc_String(" (U+");
    gc_root(strlit2371);
  }
// compiled string node returning strlit2371 (depth = 16)
  int op_slot_right_2370 = gc_frame_newslot(strlit2371);
// starting to compile op node (depth = 16)
// starting to compile call node (depth = 17)
  int callframe2374 = gc_frame_new();
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_c (depth = 18)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_unicode (depth = 18)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2375 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2374);
// compiled call node returning call2375 (depth = 17)
  int op_slot_right_2373 = gc_frame_newslot(call2375);
// starting to compile string node (depth = 17)
  if (strlit2377 == NULL) {
    strlit2377 = alloc_String("");
    gc_root(strlit2377);
  }
// compiled string node returning strlit2377 (depth = 17)
  int op_slot_left_2373 = gc_frame_newslot(strlit2377);
  params[0] = call2375;
  partcv[0] = 1;
  Object opresult2378 = callmethod(strlit2377, "++", 1, partcv, params);
// compiled op node returning opresult2378 (depth = 16)
  int op_slot_left_2370 = gc_frame_newslot(opresult2378);
  params[0] = strlit2371;
  partcv[0] = 1;
  Object opresult2379 = callmethod(opresult2378, "++", 1, partcv, params);
// compiled op node returning opresult2379 (depth = 15)
  int op_slot_left_2357 = gc_frame_newslot(opresult2379);
  params[0] = call2368;
  partcv[0] = 1;
  Object opresult2380 = callmethod(opresult2379, "++", 1, partcv, params);
// compiled op node returning opresult2380 (depth = 14)
  int op_slot_left_2354 = gc_frame_newslot(opresult2380);
  params[0] = strlit2355;
  partcv[0] = 1;
  Object opresult2381 = callmethod(opresult2380, "++", 1, partcv, params);
// compiled op node returning opresult2381 (depth = 13)
  int op_slot_left_2351 = gc_frame_newslot(opresult2381);
  params[0] = strlit2352;
  partcv[0] = 1;
  Object opresult2382 = callmethod(opresult2381, "++", 1, partcv, params);
// compiled op node returning opresult2382 (depth = 12)
  int op_slot_left_2348 = gc_frame_newslot(opresult2382);
  params[0] = strlit2349;
  partcv[0] = 1;
  Object opresult2383 = callmethod(opresult2382, "++", 1, partcv, params);
// compiled op node returning opresult2383 (depth = 11)
  int op_slot_left_2345 = gc_frame_newslot(opresult2383);
  params[0] = strlit2346;
  partcv[0] = 1;
  Object opresult2384 = callmethod(opresult2383, "++", 1, partcv, params);
// compiled op node returning opresult2384 (depth = 10)
  int op_slot_left_2332 = gc_frame_newslot(opresult2384);
  params[0] = call2343;
  partcv[0] = 1;
  Object opresult2385 = callmethod(opresult2384, "++", 1, partcv, params);
// compiled op node returning opresult2385 (depth = 9)
  int op_slot_left_2329 = gc_frame_newslot(opresult2385);
  params[0] = strlit2330;
  partcv[0] = 1;
  Object opresult2386 = callmethod(opresult2385, "++", 1, partcv, params);
// compiled op node returning opresult2386 (depth = 8)
  gc_frame_newslot(opresult2386);
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  gc_frame_newslot(*var_linePosition);
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2386;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2387 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2328);
// compiled call node returning call2387 (depth = 7)
    gc_frame_newslot(call2387);
    if2306 = call2387;
  } else {
  }
// compiled if node returning if2306 (depth = 6)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2388 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_linePosition;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2389 = callmethod(*var_suggestion, "deleteChar()onLine",
    2, partcv, params);
  gc_frame_end(callframe2388);
// compiled call node returning call2389 (depth = 6)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2390 = gc_frame_new();
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2392 == NULL) {
    strlit2392 = alloc_String("is a control character and cannot be written in the source code; consider using spaces instead.");
    gc_root(strlit2392);
  }
// compiled string node returning strlit2392 (depth = 8)
  int op_slot_right_2391 = gc_frame_newslot(strlit2392);
// starting to compile op node (depth = 8)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2395 == NULL) {
    strlit2395 = alloc_String(") ");
    gc_root(strlit2395);
  }
// compiled string node returning strlit2395 (depth = 9)
  int op_slot_right_2394 = gc_frame_newslot(strlit2395);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2398 = gc_frame_new();
// starting to compile call node (depth = 11)
  int callframe2399 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2400 = alloc_Float64(16);
// compiled num node returning num2400 (depth = 12)
  gc_frame_newslot(num2400);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  params[0] = num2400;
  partcv[0] = 1;
  Object call2401 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2399);
// compiled call node returning call2401 (depth = 11)
  gc_frame_newslot(call2401);
// starting to compile num node (depth = 11)
  Object num2402 = alloc_Float64(4);
// compiled num node returning num2402 (depth = 11)
  gc_frame_newslot(num2402);
// starting to compile string node (depth = 11)
  if (strlit2403 == NULL) {
    strlit2403 = alloc_String("0");
    gc_root(strlit2403);
  }
// compiled string node returning strlit2403 (depth = 11)
  gc_frame_newslot(strlit2403);
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2404 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2405 = gc_frame_new();
// call case 3: self.outer request
  Object call2406 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2405);
// compiled call node returning call2406 (depth = 14)
// compiled member node returning call2406 (depth = 13)
  partcv[0] = 0;
  Object call2407 = callmethodflags(call2406, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2404);
// compiled call node returning call2407 (depth = 12)
// compiled member node returning call2407 (depth = 11)
  params[0] = call2401;
  params[1] = num2402;
  params[2] = strlit2403;
  partcv[0] = 3;
  Object call2408 = callmethodflags(call2407, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2398);
// compiled call node returning call2408 (depth = 10)
  int op_slot_right_2397 = gc_frame_newslot(call2408);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2411 == NULL) {
    strlit2411 = alloc_String(" (U+");
    gc_root(strlit2411);
  }
// compiled string node returning strlit2411 (depth = 11)
  int op_slot_right_2410 = gc_frame_newslot(strlit2411);
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2414 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2415 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2414);
// compiled call node returning call2415 (depth = 12)
  int op_slot_right_2413 = gc_frame_newslot(call2415);
// starting to compile string node (depth = 12)
  if (strlit2417 == NULL) {
    strlit2417 = alloc_String("");
    gc_root(strlit2417);
  }
// compiled string node returning strlit2417 (depth = 12)
  int op_slot_left_2413 = gc_frame_newslot(strlit2417);
  params[0] = call2415;
  partcv[0] = 1;
  Object opresult2418 = callmethod(strlit2417, "++", 1, partcv, params);
// compiled op node returning opresult2418 (depth = 11)
  int op_slot_left_2410 = gc_frame_newslot(opresult2418);
  params[0] = strlit2411;
  partcv[0] = 1;
  Object opresult2419 = callmethod(opresult2418, "++", 1, partcv, params);
// compiled op node returning opresult2419 (depth = 10)
  int op_slot_left_2397 = gc_frame_newslot(opresult2419);
  params[0] = call2408;
  partcv[0] = 1;
  Object opresult2420 = callmethod(opresult2419, "++", 1, partcv, params);
// compiled op node returning opresult2420 (depth = 9)
  int op_slot_left_2394 = gc_frame_newslot(opresult2420);
  params[0] = strlit2395;
  partcv[0] = 1;
  Object opresult2421 = callmethod(opresult2420, "++", 1, partcv, params);
// compiled op node returning opresult2421 (depth = 8)
  int op_slot_left_2391 = gc_frame_newslot(opresult2421);
  params[0] = strlit2392;
  partcv[0] = 1;
  Object opresult2422 = callmethod(opresult2421, "++", 1, partcv, params);
// compiled op node returning opresult2422 (depth = 7)
  gc_frame_newslot(opresult2422);
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult2422;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2423 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2390);
// compiled call node returning call2423 (depth = 6)
    gc_frame_newslot(call2423);
    if2299 = call2423;
  } else {
  }
// compiled if node returning if2299 (depth = 5)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_atStart (depth = 6)
  Object if2424 = done;
  if (istrue(*var_atStart)) {
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2427 = alloc_Float64(1);
// compiled num node returning num2427 (depth = 8)
  int op_slot_right_2426 = gc_frame_newslot(num2427);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_linePosition (depth = 8)
  int op_slot_left_2426 = gc_frame_newslot(*var_linePosition);
  params[0] = num2427;
  partcv[0] = 1;
  Object opresult2429 = callmethod(*var_linePosition, "==", 1, partcv, params);
// compiled op node returning opresult2429 (depth = 7)
  Object if2425 = done;
  if (istrue(opresult2429)) {
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2432 == NULL) {
    strlit2432 = alloc_String("#");
    gc_root(strlit2432);
  }
// compiled string node returning strlit2432 (depth = 9)
  int op_slot_right_2431 = gc_frame_newslot(strlit2432);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2431 = gc_frame_newslot(*var_c);
  params[0] = strlit2432;
  partcv[0] = 1;
  Object opresult2434 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2434 (depth = 8)
  Object if2430 = done;
  if (istrue(opresult2434)) {
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2435 == NULL) {
    strlit2435 = alloc_String("p");
    gc_root(strlit2435);
  }
// compiled string node returning strlit2435 (depth = 9)
  *var_mode = strlit2435;
  if (strlit2435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2430 = done;
  } else {
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2438 = alloc_Boolean(0);
// compiled identifier node returning bool2438 (depth = 9)
  *var_atStart = bool2438;
  if (bool2438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2430 = done;
  }
// compiled if node returning if2430 (depth = 7)
    gc_frame_newslot(if2430);
    if2425 = if2430;
  } else {
  }
// compiled if node returning if2425 (depth = 6)
    gc_frame_newslot(if2425);
    if2424 = if2425;
  } else {
  }
// compiled if node returning if2424 (depth = 5)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_instr (depth = 6)
  Object if2440 = done;
  if (istrue(*var_instr)) {
    gc_frame_newslot(done);
    if2440 = done;
  } else {
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2444 == NULL) {
    strlit2444 = alloc_String("p");
    gc_root(strlit2444);
  }
// compiled string node returning strlit2444 (depth = 9)
  int op_slot_right_2443 = gc_frame_newslot(strlit2444);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2443 = gc_frame_newslot(*var_mode);
  params[0] = strlit2444;
  partcv[0] = 1;
  Object opresult2446 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2446 (depth = 8)
  int op_slot_right_2442 = gc_frame_newslot(opresult2446);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2449 == NULL) {
    strlit2449 = alloc_String("c");
    gc_root(strlit2449);
  }
// compiled string node returning strlit2449 (depth = 9)
  int op_slot_right_2448 = gc_frame_newslot(strlit2449);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2448 = gc_frame_newslot(*var_mode);
  params[0] = strlit2449;
  partcv[0] = 1;
  Object opresult2451 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2451 (depth = 8)
  int op_slot_left_2442 = gc_frame_newslot(opresult2451);
  params[0] = opresult2446;
  partcv[0] = 1;
  Object opresult2452 = callmethod(opresult2451, "&&", 1, partcv, params);
// compiled op node returning opresult2452 (depth = 7)
  Object if2441 = done;
  if (istrue(opresult2452)) {
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2456 == NULL) {
    strlit2456 = alloc_String("d");
    gc_root(strlit2456);
  }
// compiled string node returning strlit2456 (depth = 10)
  int op_slot_right_2455 = gc_frame_newslot(strlit2456);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2455 = gc_frame_newslot(*var_mode);
  params[0] = strlit2456;
  partcv[0] = 1;
  Object opresult2458 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2458 (depth = 9)
  int op_slot_right_2454 = gc_frame_newslot(opresult2458);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2461 == NULL) {
    strlit2461 = alloc_String(" ");
    gc_root(strlit2461);
  }
// compiled string node returning strlit2461 (depth = 10)
  int op_slot_right_2460 = gc_frame_newslot(strlit2461);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2460 = gc_frame_newslot(*var_c);
  params[0] = strlit2461;
  partcv[0] = 1;
  Object opresult2463 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2463 (depth = 9)
  int op_slot_left_2454 = gc_frame_newslot(opresult2463);
  params[0] = opresult2458;
  partcv[0] = 1;
  Object opresult2464 = callmethod(opresult2463, "&&", 1, partcv, params);
// compiled op node returning opresult2464 (depth = 8)
  Object if2453 = done;
  if (istrue(opresult2464)) {
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2465 == NULL) {
    strlit2465 = alloc_String("n");
    gc_root(strlit2465);
  }
// compiled string node returning strlit2465 (depth = 9)
  *var_newmode = strlit2465;
  if (strlit2465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2453 = done;
  } else {
  }
// compiled if node returning if2453 (depth = 7)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2469 == NULL) {
    strlit2469 = alloc_String("""\x22""");
    gc_root(strlit2469);
  }
// compiled string node returning strlit2469 (depth = 9)
  int op_slot_right_2468 = gc_frame_newslot(strlit2469);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2468 = gc_frame_newslot(*var_c);
  params[0] = strlit2469;
  partcv[0] = 1;
  Object opresult2471 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2471 (depth = 8)
  Object if2467 = done;
  if (istrue(opresult2471)) {
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2472 == NULL) {
    strlit2472 = alloc_String("""\x22""");
    gc_root(strlit2472);
  }
// compiled string node returning strlit2472 (depth = 9)
  *var_newmode = strlit2472;
  if (strlit2472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2474 = alloc_Boolean(1);
// compiled identifier node returning bool2474 (depth = 9)
  *var_instr = bool2474;
  if (bool2474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2467 = done;
  } else {
  }
// compiled if node returning if2467 (depth = 7)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2477 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_identifierChar (depth = 9)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2478 = callmethod(*var_identifierChar, "match",
    1, partcv, params);
  gc_frame_end(callframe2477);
// compiled call node returning call2478 (depth = 8)
  Object if2476 = done;
  if (istrue(call2478)) {
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2479 == NULL) {
    strlit2479 = alloc_String("i");
    gc_root(strlit2479);
  }
// compiled string node returning strlit2479 (depth = 9)
  *var_newmode = strlit2479;
  if (strlit2479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2476 = done;
  } else {
  }
// compiled if node returning if2476 (depth = 7)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2483 = alloc_Float64(57);
// compiled num node returning num2483 (depth = 10)
  int op_slot_right_2482 = gc_frame_newslot(num2483);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  int op_slot_left_2482 = gc_frame_newslot(*var_ordval);
  params[0] = num2483;
  partcv[0] = 1;
  Object opresult2485 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2485 (depth = 9)
  int op_slot_right_2481 = gc_frame_newslot(opresult2485);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2488 = alloc_Float64(48);
// compiled num node returning num2488 (depth = 10)
  int op_slot_right_2487 = gc_frame_newslot(num2488);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ordval (depth = 10)
  int op_slot_left_2487 = gc_frame_newslot(*var_ordval);
  params[0] = num2488;
  partcv[0] = 1;
  Object opresult2490 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2490 (depth = 9)
  int op_slot_left_2481 = gc_frame_newslot(opresult2490);
  params[0] = opresult2485;
  partcv[0] = 1;
  Object opresult2491 = callmethod(opresult2490, "&&", 1, partcv, params);
// compiled op node returning opresult2491 (depth = 8)
  *var_ct = opresult2491;
  if (opresult2491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2494 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_digit (depth = 9)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2495 = callmethod(*var_digit, "match",
    1, partcv, params);
  gc_frame_end(callframe2494);
// compiled call node returning call2495 (depth = 8)
  Object if2493 = done;
  if (istrue(call2495)) {
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2498 == NULL) {
    strlit2498 = alloc_String("i");
    gc_root(strlit2498);
  }
// compiled string node returning strlit2498 (depth = 10)
  int op_slot_right_2497 = gc_frame_newslot(strlit2498);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2497 = gc_frame_newslot(*var_mode);
  params[0] = strlit2498;
  partcv[0] = 1;
  Object opresult2500 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2500 (depth = 9)
  Object if2496 = done;
  if (istrue(opresult2500)) {
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2501 == NULL) {
    strlit2501 = alloc_String("m");
    gc_root(strlit2501);
  }
// compiled string node returning strlit2501 (depth = 10)
  *var_newmode = strlit2501;
  if (strlit2501 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2496 = done;
  } else {
  }
// compiled if node returning if2496 (depth = 8)
    gc_frame_newslot(if2496);
    if2493 = if2496;
  } else {
  }
// compiled if node returning if2493 (depth = 7)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2505 == NULL) {
    strlit2505 = alloc_String("m");
    gc_root(strlit2505);
  }
// compiled string node returning strlit2505 (depth = 9)
  int op_slot_right_2504 = gc_frame_newslot(strlit2505);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2504 = gc_frame_newslot(*var_mode);
  params[0] = strlit2505;
  partcv[0] = 1;
  Object opresult2507 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2507 (depth = 8)
  Object if2503 = done;
  if (istrue(opresult2507)) {
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2511 = alloc_Float64(122);
// compiled num node returning num2511 (depth = 11)
  int op_slot_right_2510 = gc_frame_newslot(num2511);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  int op_slot_left_2510 = gc_frame_newslot(*var_ordval);
  params[0] = num2511;
  partcv[0] = 1;
  Object opresult2513 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2513 (depth = 10)
  int op_slot_right_2509 = gc_frame_newslot(opresult2513);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2516 = alloc_Float64(97);
// compiled num node returning num2516 (depth = 11)
  int op_slot_right_2515 = gc_frame_newslot(num2516);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  int op_slot_left_2515 = gc_frame_newslot(*var_ordval);
  params[0] = num2516;
  partcv[0] = 1;
  Object opresult2518 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2518 (depth = 10)
  int op_slot_left_2509 = gc_frame_newslot(opresult2518);
  params[0] = opresult2513;
  partcv[0] = 1;
  Object opresult2519 = callmethod(opresult2518, "&&", 1, partcv, params);
// compiled op node returning opresult2519 (depth = 9)
  Object if2508 = done;
  if (istrue(opresult2519)) {
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2520 == NULL) {
    strlit2520 = alloc_String("m");
    gc_root(strlit2520);
  }
// compiled string node returning strlit2520 (depth = 10)
  *var_newmode = strlit2520;
  if (strlit2520 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2508 = done;
  } else {
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2525 = alloc_Float64(90);
// compiled num node returning num2525 (depth = 12)
  int op_slot_right_2524 = gc_frame_newslot(num2525);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  int op_slot_left_2524 = gc_frame_newslot(*var_ordval);
  params[0] = num2525;
  partcv[0] = 1;
  Object opresult2527 = callmethod(*var_ordval, "<=", 1, partcv, params);
// compiled op node returning opresult2527 (depth = 11)
  int op_slot_right_2523 = gc_frame_newslot(opresult2527);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2530 = alloc_Float64(65);
// compiled num node returning num2530 (depth = 12)
  int op_slot_right_2529 = gc_frame_newslot(num2530);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ordval (depth = 12)
  int op_slot_left_2529 = gc_frame_newslot(*var_ordval);
  params[0] = num2530;
  partcv[0] = 1;
  Object opresult2532 = callmethod(*var_ordval, ">=", 1, partcv, params);
// compiled op node returning opresult2532 (depth = 11)
  int op_slot_left_2523 = gc_frame_newslot(opresult2532);
  params[0] = opresult2527;
  partcv[0] = 1;
  Object opresult2533 = callmethod(opresult2532, "&&", 1, partcv, params);
// compiled op node returning opresult2533 (depth = 10)
  Object if2522 = done;
  if (istrue(opresult2533)) {
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2534 == NULL) {
    strlit2534 = alloc_String("m");
    gc_root(strlit2534);
  }
// compiled string node returning strlit2534 (depth = 11)
  *var_newmode = strlit2534;
  if (strlit2534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2522 = done;
  } else {
  }
// compiled if node returning if2522 (depth = 9)
    gc_frame_newslot(if2522);
    if2508 = if2522;
  }
// compiled if node returning if2508 (depth = 8)
    gc_frame_newslot(if2508);
    if2503 = if2508;
  } else {
  }
// compiled if node returning if2503 (depth = 7)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2539 == NULL) {
    strlit2539 = alloc_String("<");
    gc_root(strlit2539);
  }
// compiled string node returning strlit2539 (depth = 10)
  int op_slot_right_2538 = gc_frame_newslot(strlit2539);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_2538 = gc_frame_newslot(*var_c);
  params[0] = strlit2539;
  partcv[0] = 1;
  Object opresult2541 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2541 (depth = 9)
  int op_slot_right_2537 = gc_frame_newslot(opresult2541);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2544 == NULL) {
    strlit2544 = alloc_String("i");
    gc_root(strlit2544);
  }
// compiled string node returning strlit2544 (depth = 10)
  int op_slot_right_2543 = gc_frame_newslot(strlit2544);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2543 = gc_frame_newslot(*var_mode);
  params[0] = strlit2544;
  partcv[0] = 1;
  Object opresult2546 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2546 (depth = 9)
  int op_slot_left_2537 = gc_frame_newslot(opresult2546);
  params[0] = opresult2541;
  partcv[0] = 1;
  Object opresult2547 = callmethod(opresult2546, "&&", 1, partcv, params);
// compiled op node returning opresult2547 (depth = 8)
  Object if2536 = done;
  if (istrue(opresult2547)) {
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2548 == NULL) {
    strlit2548 = alloc_String("<");
    gc_root(strlit2548);
  }
// compiled string node returning strlit2548 (depth = 9)
  *var_newmode = strlit2548;
  if (strlit2548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2536 = done;
  } else {
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2553 == NULL) {
    strlit2553 = alloc_String(">");
    gc_root(strlit2553);
  }
// compiled string node returning strlit2553 (depth = 11)
  int op_slot_right_2552 = gc_frame_newslot(strlit2553);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_2552 = gc_frame_newslot(*var_c);
  params[0] = strlit2553;
  partcv[0] = 1;
  Object opresult2555 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2555 (depth = 10)
  int op_slot_right_2551 = gc_frame_newslot(opresult2555);
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2557 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  gc_frame_newslot(*var_mode);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_iGTLT (depth = 11)
  params[0] = *var_mode;
  partcv[0] = 1;
  Object call2558 = callmethod(*var_iGTLT, "match",
    1, partcv, params);
  gc_frame_end(callframe2557);
// compiled call node returning call2558 (depth = 10)
  int op_slot_left_2551 = gc_frame_newslot(call2558);
  params[0] = opresult2555;
  partcv[0] = 1;
  Object opresult2559 = callmethod(call2558, "&&", 1, partcv, params);
// compiled op node returning opresult2559 (depth = 9)
  Object if2550 = done;
  if (istrue(opresult2559)) {
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2562 == NULL) {
    strlit2562 = alloc_String(">");
    gc_root(strlit2562);
  }
// compiled string node returning strlit2562 (depth = 11)
  int op_slot_right_2561 = gc_frame_newslot(strlit2562);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  int op_slot_left_2561 = gc_frame_newslot(*var_mode);
  params[0] = strlit2562;
  partcv[0] = 1;
  Object opresult2564 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2564 (depth = 10)
  Object if2560 = done;
  if (istrue(opresult2564)) {
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2565 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_mode (depth = 11)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2566 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2565);
// compiled call node returning call2566 (depth = 10)
    gc_frame_newslot(call2566);
    if2560 = call2566;
  } else {
  }
// compiled if node returning if2560 (depth = 9)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2567 == NULL) {
    strlit2567 = alloc_String(">");
    gc_root(strlit2567);
  }
// compiled string node returning strlit2567 (depth = 10)
  *var_newmode = strlit2567;
  if (strlit2567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2550 = done;
  } else {
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2570 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ordval (depth = 11)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_operatorChar (depth = 11)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2571 = callmethod(*var_operatorChar, "match",
    1, partcv, params);
  gc_frame_end(callframe2570);
// compiled call node returning call2571 (depth = 10)
  Object if2569 = done;
  if (istrue(call2571)) {
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit2572 == NULL) {
    strlit2572 = alloc_String("o");
    gc_root(strlit2572);
  }
// compiled string node returning strlit2572 (depth = 11)
  *var_newmode = strlit2572;
  if (strlit2572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if2569 = done;
  } else {
  }
// compiled if node returning if2569 (depth = 9)
    gc_frame_newslot(if2569);
    if2550 = if2569;
  }
// compiled if node returning if2550 (depth = 8)
    gc_frame_newslot(if2550);
    if2536 = if2550;
  }
// compiled if node returning if2536 (depth = 7)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2575 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ordval (depth = 9)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfModes (depth = 9)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2576 = callmethod(*var_selfModes, "match",
    1, partcv, params);
  gc_frame_end(callframe2575);
// compiled call node returning call2576 (depth = 8)
  Object if2574 = done;
  if (istrue(call2576)) {
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  *var_newmode = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2574 = done;
  } else {
  }
// compiled if node returning if2574 (depth = 7)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2580 == NULL) {
    strlit2580 = alloc_String("#");
    gc_root(strlit2580);
  }
// compiled string node returning strlit2580 (depth = 9)
  int op_slot_right_2579 = gc_frame_newslot(strlit2580);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2579 = gc_frame_newslot(*var_c);
  params[0] = strlit2580;
  partcv[0] = 1;
  Object opresult2582 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2582 (depth = 8)
  Object if2578 = done;
  if (istrue(opresult2582)) {
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2585 == NULL) {
    strlit2585 = alloc_String("p");
    gc_root(strlit2585);
  }
// compiled string node returning strlit2585 (depth = 10)
  int op_slot_right_2584 = gc_frame_newslot(strlit2585);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2584 = gc_frame_newslot(*var_mode);
  params[0] = strlit2585;
  partcv[0] = 1;
  Object opresult2587 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult2587 (depth = 9)
  Object if2583 = done;
  if (istrue(opresult2587)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2590 == NULL) {
    strlit2590 = alloc_String("#pragma");
    gc_root(strlit2590);
  }
// compiled string node returning strlit2590 (depth = 11)
  int op_slot_right_2589 = gc_frame_newslot(strlit2590);
// starting to compile call node (depth = 11)
  int callframe2592 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2593 = alloc_Float64(1);
// compiled num node returning num2593 (depth = 12)
  gc_frame_newslot(num2593);
// starting to compile num node (depth = 12)
  Object num2594 = alloc_Float64(7);
// compiled num node returning num2594 (depth = 12)
  gc_frame_newslot(num2594);
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2595 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2596 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call2597 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2596);
// compiled call node returning call2597 (depth = 14)
// compiled member node returning call2597 (depth = 13)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2598 = callmethod(call2597, "at",
    1, partcv, params);
  gc_frame_end(callframe2595);
// compiled call node returning call2598 (depth = 12)
  params[0] = num2593;
  params[1] = num2594;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2599 = callmethod(call2598, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2592);
// compiled call node returning call2599 (depth = 11)
  int op_slot_left_2589 = gc_frame_newslot(call2599);
  params[0] = strlit2590;
  partcv[0] = 1;
  Object opresult2600 = callmethod(call2599, "==", 1, partcv, params);
// compiled op node returning opresult2600 (depth = 10)
  Object if2588 = done;
  if (istrue(opresult2600)) {
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2603 = alloc_Float64(0);
// compiled num node returning num2603 (depth = 12)
  int op_slot_right_2602 = gc_frame_newslot(num2603);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call2606 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe2605);
// compiled call node returning call2606 (depth = 13)
// compiled member node returning call2606 (depth = 12)
  int op_slot_left_2602 = gc_frame_newslot(call2606);
  params[0] = num2603;
  partcv[0] = 1;
  Object opresult2607 = callmethod(call2606, "==", 1, partcv, params);
// compiled op node returning opresult2607 (depth = 11)
  Object if2601 = done;
  if (istrue(opresult2607)) {
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 11)
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2608 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  partcv[0] = 0;
  Object call2610 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2609);
// compiled call node returning call2610 (depth = 15)
// compiled member node returning call2610 (depth = 14)
  partcv[0] = 0;
  Object call2611 = callmethod(call2610, "new",
    1, partcv, params);
  gc_frame_end(callframe2608);
// compiled call node returning call2611 (depth = 13)
// compiled member node returning call2611 (depth = 12)
  *var_suggestion = call2611;
  if (call2611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 11)
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2612 = gc_frame_new();
// starting to compile num node (depth = 12)
  Object num2613 = alloc_Float64(1);
// compiled num node returning num2613 (depth = 12)
  gc_frame_newslot(num2613);
// starting to compile call node (depth = 12)
  int callframe2614 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call2616 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2615);
// compiled call node returning call2616 (depth = 14)
// compiled member node returning call2616 (depth = 13)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2617 = callmethod(call2616, "at",
    1, partcv, params);
  gc_frame_end(callframe2614);
// compiled call node returning call2617 (depth = 12)
  gc_frame_newslot(call2617);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = num2613;
  params[1] = call2617;
  partcv[0] = 2;
  Object call2618 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2612);
// compiled call node returning call2618 (depth = 11)
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2619 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// starting to compile string node (depth = 12)
  if (strlit2620 == NULL) {
    strlit2620 = alloc_String("");
    gc_root(strlit2620);
  }
// compiled string node returning strlit2620 (depth = 12)
  gc_frame_newslot(strlit2620);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = *var_lineNumber;
  params[1] = strlit2620;
  partcv[0] = 2;
  Object call2621 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2619);
// compiled call node returning call2621 (depth = 11)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2622 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2623 == NULL) {
    strlit2623 = alloc_String("Pragma directives must be at the start of the file.");
    gc_root(strlit2623);
  }
// compiled string node returning strlit2623 (depth = 12)
  gc_frame_newslot(strlit2623);
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  params[0] = strlit2623;
  params[1] = *var_lineNumber;
  params[2] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2624 = callmethod(*var_errormessages, "syntaxError()atLine()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2622);
// compiled call node returning call2624 (depth = 11)
    gc_frame_newslot(call2624);
    if2601 = call2624;
  } else {
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2625 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2626 == NULL) {
    strlit2626 = alloc_String("Pragma directives must be at the start of the file.");
    gc_root(strlit2626);
  }
// compiled string node returning strlit2626 (depth = 12)
  gc_frame_newslot(strlit2626);
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  params[0] = strlit2626;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2627 = callmethod(*var_errormessages, "syntaxError()atLine",
    2, partcv, params);
  gc_frame_end(callframe2625);
// compiled call node returning call2627 (depth = 11)
    gc_frame_newslot(call2627);
    if2601 = call2627;
  }
// compiled if node returning if2601 (depth = 10)
    gc_frame_newslot(if2601);
    if2588 = if2601;
  } else {
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2628 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call2630 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2629);
// compiled call node returning call2630 (depth = 14)
// compiled member node returning call2630 (depth = 13)
  partcv[0] = 0;
  Object call2631 = callmethod(call2630, "new",
    1, partcv, params);
  gc_frame_end(callframe2628);
// compiled call node returning call2631 (depth = 12)
// compiled member node returning call2631 (depth = 11)
  *var_suggestion = call2631;
  if (call2631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2632 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile string node (depth = 11)
  if (strlit2633 == NULL) {
    strlit2633 = alloc_String("//");
    gc_root(strlit2633);
  }
// compiled string node returning strlit2633 (depth = 11)
  gc_frame_newslot(strlit2633);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_linePosition;
  params[1] = strlit2633;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2634 = callmethod(*var_suggestion, "replaceChar()with()onLine",
    3, partcv, params);
  gc_frame_end(callframe2632);
// compiled call node returning call2634 (depth = 10)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2635 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2636 == NULL) {
    strlit2636 = alloc_String("'#' is not allowed here. For a comment use '//'.");
    gc_root(strlit2636);
  }
// compiled string node returning strlit2636 (depth = 11)
  gc_frame_newslot(strlit2636);
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit2636;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2637 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2635);
// compiled call node returning call2637 (depth = 10)
    gc_frame_newslot(call2637);
    if2588 = call2637;
  }
// compiled if node returning if2588 (depth = 9)
    gc_frame_newslot(if2588);
    if2583 = if2588;
  } else {
  }
// compiled if node returning if2583 (depth = 8)
    gc_frame_newslot(if2583);
    if2578 = if2583;
  } else {
  }
// compiled if node returning if2578 (depth = 7)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2640 == NULL) {
    strlit2640 = alloc_String(".");
    gc_root(strlit2640);
  }
// compiled string node returning strlit2640 (depth = 9)
  int op_slot_right_2639 = gc_frame_newslot(strlit2640);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2639 = gc_frame_newslot(*var_c);
  params[0] = strlit2640;
  partcv[0] = 1;
  Object opresult2642 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2642 (depth = 8)
  Object if2638 = done;
  if (istrue(opresult2642)) {
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2645 == NULL) {
    strlit2645 = alloc_String(".");
    gc_root(strlit2645);
  }
// compiled string node returning strlit2645 (depth = 10)
  int op_slot_right_2644 = gc_frame_newslot(strlit2645);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_2644 = gc_frame_newslot(*var_accum);
  params[0] = strlit2645;
  partcv[0] = 1;
  Object opresult2647 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2647 (depth = 9)
  Object if2643 = done;
  if (istrue(opresult2647)) {
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2648 == NULL) {
    strlit2648 = alloc_String("o");
    gc_root(strlit2648);
  }
// compiled string node returning strlit2648 (depth = 10)
  *var_mode = strlit2648;
  if (strlit2648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2643 = done;
  } else {
  }
// compiled if node returning if2643 (depth = 8)
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2653 == NULL) {
    strlit2653 = alloc_String("..");
    gc_root(strlit2653);
  }
// compiled string node returning strlit2653 (depth = 10)
  int op_slot_right_2652 = gc_frame_newslot(strlit2653);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_2652 = gc_frame_newslot(*var_accum);
  params[0] = strlit2653;
  partcv[0] = 1;
  Object opresult2655 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2655 (depth = 9)
  Object if2651 = done;
  if (istrue(opresult2655)) {
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2656 == NULL) {
    strlit2656 = alloc_String("n");
    gc_root(strlit2656);
  }
// compiled string node returning strlit2656 (depth = 10)
  *var_mode = strlit2656;
  if (strlit2656 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2659 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 10)
  if (strlit2660 == NULL) {
    strlit2660 = alloc_String("i");
    gc_root(strlit2660);
  }
// compiled string node returning strlit2660 (depth = 10)
  gc_frame_newslot(strlit2660);
// starting to compile string node (depth = 10)
  if (strlit2661 == NULL) {
    strlit2661 = alloc_String("...");
    gc_root(strlit2661);
  }
// compiled string node returning strlit2661 (depth = 10)
  gc_frame_newslot(strlit2661);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2660;
  params[2] = strlit2661;
  partcv[0] = 3;
  Object call2662 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2659);
// compiled call node returning call2662 (depth = 9)
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2663 == NULL) {
    strlit2663 = alloc_String("");
    gc_root(strlit2663);
  }
// compiled string node returning strlit2663 (depth = 10)
  *var_accum = strlit2663;
  if (strlit2663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2651 = done;
  } else {
  }
// compiled if node returning if2651 (depth = 8)
    gc_frame_newslot(if2651);
    if2638 = if2651;
  } else {
  }
// compiled if node returning if2638 (depth = 7)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2667 == NULL) {
    strlit2667 = alloc_String("/");
    gc_root(strlit2667);
  }
// compiled string node returning strlit2667 (depth = 9)
  int op_slot_right_2666 = gc_frame_newslot(strlit2667);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2666 = gc_frame_newslot(*var_c);
  params[0] = strlit2667;
  partcv[0] = 1;
  Object opresult2669 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2669 (depth = 8)
  Object if2665 = done;
  if (istrue(opresult2669)) {
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2672 == NULL) {
    strlit2672 = alloc_String("/");
    gc_root(strlit2672);
  }
// compiled string node returning strlit2672 (depth = 10)
  int op_slot_right_2671 = gc_frame_newslot(strlit2672);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_2671 = gc_frame_newslot(*var_accum);
  params[0] = strlit2672;
  partcv[0] = 1;
  Object opresult2674 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult2674 (depth = 9)
  Object if2670 = done;
  if (istrue(opresult2674)) {
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit2675 == NULL) {
    strlit2675 = alloc_String("c");
    gc_root(strlit2675);
  }
// compiled string node returning strlit2675 (depth = 10)
  *var_mode = strlit2675;
  if (strlit2675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2670 = done;
  } else {
  }
// compiled if node returning if2670 (depth = 8)
    gc_frame_newslot(if2670);
    if2665 = if2670;
  } else {
  }
// compiled if node returning if2665 (depth = 7)
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2680 == NULL) {
    strlit2680 = alloc_String("n");
    gc_root(strlit2680);
  }
// compiled string node returning strlit2680 (depth = 9)
  int op_slot_right_2679 = gc_frame_newslot(strlit2680);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_2679 = gc_frame_newslot(*var_mode);
  params[0] = strlit2680;
  partcv[0] = 1;
  Object opresult2682 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 8)
  Object if2678 = done;
  if (istrue(opresult2682)) {
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_newmode (depth = 10)
  int op_slot_right_2684 = gc_frame_newslot(*var_newmode);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  int op_slot_left_2684 = gc_frame_newslot(*var_mode);
  params[0] = *var_newmode;
  partcv[0] = 1;
  Object opresult2686 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2686 (depth = 9)
  Object if2683 = done;
  if (istrue(opresult2686)) {
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2688 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2689 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_unicode (depth = 13)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2690 = callmethod(*var_unicode, "isSeparator",
    1, partcv, params);
  gc_frame_end(callframe2689);
// compiled call node returning call2690 (depth = 12)
  partcv[0] = 0;
  Object call2691 = callmethod(call2690, "not",
    1, partcv, params);
  gc_frame_end(callframe2688);
// compiled call node returning call2691 (depth = 11)
// compiled member node returning call2691 (depth = 10)
  Object if2687 = done;
  if (istrue(call2691)) {
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2693 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 13)
  int callframe2694 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ordval (depth = 14)
  gc_frame_newslot(*var_ordval);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_ordval;
  partcv[0] = 1;
  Object call2695 = callmethod(*var_unicode, "isControl",
    1, partcv, params);
  gc_frame_end(callframe2694);
// compiled call node returning call2695 (depth = 13)
  partcv[0] = 0;
  Object call2696 = callmethod(call2695, "not",
    1, partcv, params);
  gc_frame_end(callframe2693);
// compiled call node returning call2696 (depth = 12)
// compiled member node returning call2696 (depth = 11)
  Object if2692 = done;
  if (istrue(call2696)) {
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2699 = alloc_Float64(10);
// compiled num node returning num2699 (depth = 13)
  int op_slot_right_2698 = gc_frame_newslot(num2699);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_ordval (depth = 13)
  int op_slot_left_2698 = gc_frame_newslot(*var_ordval);
  params[0] = num2699;
  partcv[0] = 1;
  Object opresult2701 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2701 (depth = 12)
  Object if2697 = done;
  if (istrue(opresult2701)) {
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num2704 = alloc_Float64(13);
// compiled num node returning num2704 (depth = 14)
  int op_slot_right_2703 = gc_frame_newslot(num2704);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_ordval (depth = 14)
  int op_slot_left_2703 = gc_frame_newslot(*var_ordval);
  params[0] = num2704;
  partcv[0] = 1;
  Object opresult2706 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2706 (depth = 13)
  Object if2702 = done;
  if (istrue(opresult2706)) {
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile num node (depth = 15)
  Object num2709 = alloc_Float64(32);
// compiled num node returning num2709 (depth = 15)
  int op_slot_right_2708 = gc_frame_newslot(num2709);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_ordval (depth = 15)
  int op_slot_left_2708 = gc_frame_newslot(*var_ordval);
  params[0] = num2709;
  partcv[0] = 1;
  Object opresult2711 = callmethod(*var_ordval, "!=", 1, partcv, params);
// compiled op node returning opresult2711 (depth = 14)
  Object if2707 = done;
  if (istrue(opresult2711)) {
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit2714 == NULL) {
    strlit2714 = alloc_String(".");
    gc_root(strlit2714);
  }
// compiled string node returning strlit2714 (depth = 16)
  int op_slot_right_2713 = gc_frame_newslot(strlit2714);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_2713 = gc_frame_newslot(*var_c);
  params[0] = strlit2714;
  partcv[0] = 1;
  Object opresult2716 = callmethod(*var_c, "!=", 1, partcv, params);
// compiled op node returning opresult2716 (depth = 15)
  Object if2712 = done;
  if (istrue(opresult2716)) {
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 15)
  int callframe2717 = gc_frame_new();
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit2719 == NULL) {
    strlit2719 = alloc_String("is not a valid character; use spaces instead.");
    gc_root(strlit2719);
  }
// compiled string node returning strlit2719 (depth = 17)
  int op_slot_right_2718 = gc_frame_newslot(strlit2719);
// starting to compile op node (depth = 17)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 18)
  if (strlit2722 == NULL) {
    strlit2722 = alloc_String(") ");
    gc_root(strlit2722);
  }
// compiled string node returning strlit2722 (depth = 18)
  int op_slot_right_2721 = gc_frame_newslot(strlit2722);
// starting to compile op node (depth = 18)
// starting to compile call node (depth = 19)
  int callframe2725 = gc_frame_new();
// starting to compile call node (depth = 20)
  int callframe2726 = gc_frame_new();
// starting to compile num node (depth = 21)
  Object num2727 = alloc_Float64(16);
// compiled num node returning num2727 (depth = 21)
  gc_frame_newslot(num2727);
// call case 6: other member request
// starting to compile identifier node (depth = 21)
// compiled identifier node returning *var_ordval (depth = 21)
  params[0] = num2727;
  partcv[0] = 1;
  Object call2728 = callmethod(*var_ordval, "inBase",
    1, partcv, params);
  gc_frame_end(callframe2726);
// compiled call node returning call2728 (depth = 20)
  gc_frame_newslot(call2728);
// starting to compile num node (depth = 20)
  Object num2729 = alloc_Float64(4);
// compiled num node returning num2729 (depth = 20)
  gc_frame_newslot(num2729);
// starting to compile string node (depth = 20)
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("0");
    gc_root(strlit2730);
  }
// compiled string node returning strlit2730 (depth = 20)
  gc_frame_newslot(strlit2730);
// call case 2: outer request
// starting to compile member node (depth = 20)
// starting to compile call node (depth = 21)
  int callframe2731 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 22)
// starting to compile call node (depth = 23)
  int callframe2732 = gc_frame_new();
// call case 3: self.outer request
  Object call2733 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2732);
// compiled call node returning call2733 (depth = 23)
// compiled member node returning call2733 (depth = 22)
  partcv[0] = 0;
  Object call2734 = callmethodflags(call2733, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2731);
// compiled call node returning call2734 (depth = 21)
// compiled member node returning call2734 (depth = 20)
  params[0] = call2728;
  params[1] = num2729;
  params[2] = strlit2730;
  partcv[0] = 3;
  Object call2735 = callmethodflags(call2734, "padl", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2725);
// compiled call node returning call2735 (depth = 19)
  int op_slot_right_2724 = gc_frame_newslot(call2735);
// starting to compile op node (depth = 19)
// starting to compile string node (depth = 20)
  if (strlit2738 == NULL) {
    strlit2738 = alloc_String(" (U+");
    gc_root(strlit2738);
  }
// compiled string node returning strlit2738 (depth = 20)
  int op_slot_right_2737 = gc_frame_newslot(strlit2738);
// starting to compile op node (depth = 20)
// starting to compile call node (depth = 21)
  int callframe2741 = gc_frame_new();
// starting to compile identifier node (depth = 22)
// compiled identifier node returning *var_c (depth = 22)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 22)
// compiled identifier node returning *var_unicode (depth = 22)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call2742 = callmethod(*var_unicode, "name",
    1, partcv, params);
  gc_frame_end(callframe2741);
// compiled call node returning call2742 (depth = 21)
  int op_slot_right_2740 = gc_frame_newslot(call2742);
// starting to compile string node (depth = 21)
  if (strlit2744 == NULL) {
    strlit2744 = alloc_String("");
    gc_root(strlit2744);
  }
// compiled string node returning strlit2744 (depth = 21)
  int op_slot_left_2740 = gc_frame_newslot(strlit2744);
  params[0] = call2742;
  partcv[0] = 1;
  Object opresult2745 = callmethod(strlit2744, "++", 1, partcv, params);
// compiled op node returning opresult2745 (depth = 20)
  int op_slot_left_2737 = gc_frame_newslot(opresult2745);
  params[0] = strlit2738;
  partcv[0] = 1;
  Object opresult2746 = callmethod(opresult2745, "++", 1, partcv, params);
// compiled op node returning opresult2746 (depth = 19)
  int op_slot_left_2724 = gc_frame_newslot(opresult2746);
  params[0] = call2735;
  partcv[0] = 1;
  Object opresult2747 = callmethod(opresult2746, "++", 1, partcv, params);
// compiled op node returning opresult2747 (depth = 18)
  int op_slot_left_2721 = gc_frame_newslot(opresult2747);
  params[0] = strlit2722;
  partcv[0] = 1;
  Object opresult2748 = callmethod(opresult2747, "++", 1, partcv, params);
// compiled op node returning opresult2748 (depth = 17)
  int op_slot_left_2718 = gc_frame_newslot(opresult2748);
  params[0] = strlit2719;
  partcv[0] = 1;
  Object opresult2749 = callmethod(opresult2748, "++", 1, partcv, params);
// compiled op node returning opresult2749 (depth = 16)
  gc_frame_newslot(opresult2749);
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_lineNumber (depth = 16)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_linePosition (depth = 16)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_errormessages (depth = 16)
  params[0] = opresult2749;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call2750 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe2717);
// compiled call node returning call2750 (depth = 15)
    gc_frame_newslot(call2750);
    if2712 = call2750;
  } else {
  }
// compiled if node returning if2712 (depth = 14)
    gc_frame_newslot(if2712);
    if2707 = if2712;
  } else {
  }
// compiled if node returning if2707 (depth = 13)
    gc_frame_newslot(if2707);
    if2702 = if2707;
  } else {
  }
// compiled if node returning if2702 (depth = 12)
    gc_frame_newslot(if2702);
    if2697 = if2702;
  } else {
  }
// compiled if node returning if2697 (depth = 11)
    gc_frame_newslot(if2697);
    if2692 = if2697;
  } else {
  }
// compiled if node returning if2692 (depth = 10)
    gc_frame_newslot(if2692);
    if2687 = if2692;
  } else {
  }
// compiled if node returning if2687 (depth = 9)
    gc_frame_newslot(if2687);
    if2683 = if2687;
  } else {
  }
// compiled if node returning if2683 (depth = 8)
    gc_frame_newslot(if2683);
    if2678 = if2683;
  } else {
  }
// compiled if node returning if2678 (depth = 7)
    gc_frame_newslot(if2678);
    if2441 = if2678;
  } else {
  }
// compiled if node returning if2441 (depth = 6)
    gc_frame_newslot(if2441);
    if2440 = if2441;
  }
// compiled if node returning if2440 (depth = 5)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2753 == NULL) {
    strlit2753 = alloc_String("""\x22""");
    gc_root(strlit2753);
  }
// compiled string node returning strlit2753 (depth = 7)
  int op_slot_right_2752 = gc_frame_newslot(strlit2753);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_left_2752 = gc_frame_newslot(*var_mode);
  params[0] = strlit2753;
  partcv[0] = 1;
  Object opresult2755 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult2755 (depth = 6)
  Object if2751 = done;
  if (istrue(opresult2755)) {
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2758 == NULL) {
    strlit2758 = alloc_String("""\x22""");
    gc_root(strlit2758);
  }
// compiled string node returning strlit2758 (depth = 8)
  int op_slot_right_2757 = gc_frame_newslot(strlit2758);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  int op_slot_left_2757 = gc_frame_newslot(*var_c);
  params[0] = strlit2758;
  partcv[0] = 1;
  Object opresult2760 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2760 (depth = 7)
  Object if2756 = done;
  if (istrue(opresult2760)) {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_escaped (depth = 10)
  partcv[0] = 0;
  Object call2763 = callmethod(*var_escaped, "not",
    1, partcv, params);
  gc_frame_end(callframe2762);
// compiled call node returning call2763 (depth = 9)
// compiled member node returning call2763 (depth = 8)
  Object if2761 = done;
  if (istrue(call2763)) {
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2764 == NULL) {
    strlit2764 = alloc_String("n");
    gc_root(strlit2764);
  }
// compiled string node returning strlit2764 (depth = 9)
  *var_newmode = strlit2764;
  if (strlit2764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2766 = alloc_Boolean(0);
// compiled identifier node returning bool2766 (depth = 9)
  *var_instr = bool2766;
  if (bool2766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_interpString (depth = 9)
  Object if2768 = done;
  if (istrue(*var_interpString)) {
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2769 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_mode (depth = 10)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2770 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2769);
// compiled call node returning call2770 (depth = 9)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2771 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 10)
  if (strlit2772 == NULL) {
    strlit2772 = alloc_String(")");
    gc_root(strlit2772);
  }
// compiled string node returning strlit2772 (depth = 10)
  gc_frame_newslot(strlit2772);
// starting to compile string node (depth = 10)
  if (strlit2773 == NULL) {
    strlit2773 = alloc_String(")");
    gc_root(strlit2773);
  }
// compiled string node returning strlit2773 (depth = 10)
  gc_frame_newslot(strlit2773);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2772;
  params[2] = strlit2773;
  partcv[0] = 3;
  Object call2774 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2771);
// compiled call node returning call2774 (depth = 9)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_newmode (depth = 10)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool2776 = alloc_Boolean(0);
// compiled identifier node returning bool2776 (depth = 10)
  *var_interpString = bool2776;
  if (bool2776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if2768 = done;
  } else {
  }
// compiled if node returning if2768 (depth = 8)
    gc_frame_newslot(if2768);
    if2761 = if2768;
  } else {
  }
// compiled if node returning if2761 (depth = 7)
    gc_frame_newslot(if2761);
    if2756 = if2761;
  } else {
  }
// compiled if node returning if2756 (depth = 6)
    gc_frame_newslot(if2756);
    if2751 = if2756;
  } else {
  }
// compiled if node returning if2751 (depth = 5)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  int op_slot_right_2779 = gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newmode (depth = 7)
  int op_slot_left_2779 = gc_frame_newslot(*var_newmode);
  params[0] = *var_mode;
  partcv[0] = 1;
  Object opresult2781 = callmethod(*var_newmode, "!=", 1, partcv, params);
// compiled op node returning opresult2781 (depth = 6)
  Object if2778 = done;
  if (istrue(opresult2781)) {
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2782 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mode (depth = 7)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2783 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2782);
// compiled call node returning call2783 (depth = 6)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2786 = alloc_Float64(0);
// compiled num node returning num2786 (depth = 8)
  int op_slot_right_2785 = gc_frame_newslot(num2786);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_interpdepth (depth = 8)
  int op_slot_left_2785 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2786;
  partcv[0] = 1;
  Object opresult2788 = callmethod(*var_interpdepth, ">", 1, partcv, params);
// compiled op node returning opresult2788 (depth = 7)
  Object if2784 = done;
  if (istrue(opresult2788)) {
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2791 == NULL) {
    strlit2791 = alloc_String("}");
    gc_root(strlit2791);
  }
// compiled string node returning strlit2791 (depth = 9)
  int op_slot_right_2790 = gc_frame_newslot(strlit2791);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newmode (depth = 9)
  int op_slot_left_2790 = gc_frame_newslot(*var_newmode);
  params[0] = strlit2791;
  partcv[0] = 1;
  Object opresult2793 = callmethod(*var_newmode, "==", 1, partcv, params);
// compiled op node returning opresult2793 (depth = 8)
  Object if2789 = done;
  if (istrue(opresult2793)) {
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2796 == NULL) {
    strlit2796 = alloc_String("{");
    gc_root(strlit2796);
  }
// compiled string node returning strlit2796 (depth = 10)
  int op_slot_right_2795 = gc_frame_newslot(strlit2796);
// starting to compile index node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2798 = gc_frame_new();
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2799 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_tokens (depth = 16)
  partcv[0] = 0;
  Object call2801 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2800);
// compiled call node returning call2801 (depth = 15)
// compiled member node returning call2801 (depth = 14)
  partcv[0] = 0;
  Object call2802 = callmethod(call2801, "line",
    1, partcv, params);
  gc_frame_end(callframe2799);
// compiled call node returning call2802 (depth = 13)
// compiled member node returning call2802 (depth = 12)
  gc_frame_newslot(call2802);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call2804 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2803);
// compiled call node returning call2804 (depth = 13)
// compiled member node returning call2804 (depth = 12)
  params[0] = call2802;
  partcv[0] = 1;
  Object call2805 = callmethod(call2804, "at",
    1, partcv, params);
  gc_frame_end(callframe2798);
// compiled call node returning call2805 (depth = 11)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2806 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tokens (depth = 15)
  partcv[0] = 0;
  Object call2808 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2807);
// compiled call node returning call2808 (depth = 14)
// compiled member node returning call2808 (depth = 13)
  partcv[0] = 0;
  Object call2809 = callmethod(call2808, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2806);
// compiled call node returning call2809 (depth = 12)
// compiled member node returning call2809 (depth = 11)
  params[0] = call2809;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2810 = callmethod(call2805, "[]", 1, partcv, params);
// compiled index node returning idxres2810 (depth = 10)
  int op_slot_left_2795 = gc_frame_newslot(idxres2810);
  params[0] = strlit2796;
  partcv[0] = 1;
  Object opresult2811 = callmethod(idxres2810, "==", 1, partcv, params);
// compiled op node returning opresult2811 (depth = 9)
  Object if2794 = done;
  if (istrue(opresult2811)) {
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2812 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2814 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2813);
// compiled call node returning call2814 (depth = 13)
// compiled member node returning call2814 (depth = 12)
  partcv[0] = 0;
  Object call2815 = callmethod(call2814, "new",
    1, partcv, params);
  gc_frame_end(callframe2812);
// compiled call node returning call2815 (depth = 11)
// compiled member node returning call2815 (depth = 10)
  *var_suggestion = call2815;
  if (call2815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2816 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2818 = alloc_Float64(1);
// compiled num node returning num2818 (depth = 11)
  int op_slot_right_2817 = gc_frame_newslot(num2818);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  int op_slot_left_2817 = gc_frame_newslot(*var_linePosition);
  params[0] = num2818;
  partcv[0] = 1;
  Object diff2820 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff2820 (depth = 10)
  gc_frame_newslot(diff2820);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = diff2820;
  params[1] = *var_linePosition;
  params[2] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call2821 = callmethod(*var_suggestion, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe2816);
// compiled call node returning call2821 (depth = 9)
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2822 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2823 == NULL) {
    strlit2823 = alloc_String("A string interpolation cannot be empty.");
    gc_root(strlit2823);
  }
// compiled string node returning strlit2823 (depth = 10)
  gc_frame_newslot(strlit2823);
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  gc_frame_newslot(*var_lineNumber);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2824 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tokens (depth = 14)
  partcv[0] = 0;
  Object call2826 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe2825);
// compiled call node returning call2826 (depth = 13)
// compiled member node returning call2826 (depth = 12)
  partcv[0] = 0;
  Object call2827 = callmethod(call2826, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2824);
// compiled call node returning call2827 (depth = 11)
// compiled member node returning call2827 (depth = 10)
  gc_frame_newslot(call2827);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_linePosition (depth = 10)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2823;
  params[1] = *var_lineNumber;
  params[2] = call2827;
  params[3] = *var_linePosition;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2828 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2822);
// compiled call node returning call2828 (depth = 9)
    gc_frame_newslot(call2828);
    if2794 = call2828;
  } else {
  }
// compiled if node returning if2794 (depth = 8)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2829 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 9)
  if (strlit2830 == NULL) {
    strlit2830 = alloc_String(")");
    gc_root(strlit2830);
  }
// compiled string node returning strlit2830 (depth = 9)
  gc_frame_newslot(strlit2830);
// starting to compile string node (depth = 9)
  if (strlit2831 == NULL) {
    strlit2831 = alloc_String(")");
    gc_root(strlit2831);
  }
// compiled string node returning strlit2831 (depth = 9)
  gc_frame_newslot(strlit2831);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2830;
  params[2] = strlit2831;
  partcv[0] = 3;
  Object call2832 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2829);
// compiled call node returning call2832 (depth = 8)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2833 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 9)
  if (strlit2834 == NULL) {
    strlit2834 = alloc_String("o");
    gc_root(strlit2834);
  }
// compiled string node returning strlit2834 (depth = 9)
  gc_frame_newslot(strlit2834);
// starting to compile string node (depth = 9)
  if (strlit2835 == NULL) {
    strlit2835 = alloc_String("++");
    gc_root(strlit2835);
  }
// compiled string node returning strlit2835 (depth = 9)
  gc_frame_newslot(strlit2835);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit2834;
  params[2] = strlit2835;
  partcv[0] = 3;
  Object call2836 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2833);
// compiled call node returning call2836 (depth = 8)
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit2837 == NULL) {
    strlit2837 = alloc_String("""\x22""");
    gc_root(strlit2837);
  }
// compiled string node returning strlit2837 (depth = 9)
  *var_newmode = strlit2837;
  if (strlit2837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool2839 = alloc_Boolean(1);
// compiled identifier node returning bool2839 (depth = 9)
  *var_instr = bool2839;
  if (bool2839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num2842 = alloc_Float64(1);
// compiled num node returning num2842 (depth = 10)
  int op_slot_right_2841 = gc_frame_newslot(num2842);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_interpdepth (depth = 10)
  int op_slot_left_2841 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2842;
  partcv[0] = 1;
  Object diff2844 = callmethod(*var_interpdepth, "-", 1, partcv, params);
// compiled op node returning diff2844 (depth = 9)
  *var_interpdepth = diff2844;
  if (diff2844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if2789 = done;
  } else {
  }
// compiled if node returning if2789 (depth = 7)
    gc_frame_newslot(if2789);
    if2784 = if2789;
  } else {
  }
// compiled if node returning if2784 (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newmode (depth = 7)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_instr (depth = 7)
  Object if2847 = done;
  if (istrue(*var_instr)) {
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2848 == NULL) {
    strlit2848 = alloc_String("");
    gc_root(strlit2848);
  }
// compiled string node returning strlit2848 (depth = 8)
  *var_accum = strlit2848;
  if (strlit2848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2847 = done;
  } else {
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_c (depth = 8)
  *var_accum = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2847 = done;
  }
// compiled if node returning if2847 (depth = 6)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2852 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  gc_frame_newslot(*var_mode);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_brackets (depth = 8)
  params[0] = *var_mode;
  partcv[0] = 1;
  Object call2853 = callmethod(*var_brackets, "match",
    1, partcv, params);
  gc_frame_end(callframe2852);
// compiled call node returning call2853 (depth = 7)
  Object if2851 = done;
  if (istrue(call2853)) {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2854 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_accum (depth = 8)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call2855 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2854);
// compiled call node returning call2855 (depth = 7)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2856 == NULL) {
    strlit2856 = alloc_String("n");
    gc_root(strlit2856);
  }
// compiled string node returning strlit2856 (depth = 8)
  *var_mode = strlit2856;
  if (strlit2856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2858 == NULL) {
    strlit2858 = alloc_String("n");
    gc_root(strlit2858);
  }
// compiled string node returning strlit2858 (depth = 8)
  *var_newmode = strlit2858;
  if (strlit2858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit2860 == NULL) {
    strlit2860 = alloc_String("");
    gc_root(strlit2860);
  }
// compiled string node returning strlit2860 (depth = 8)
  *var_accum = strlit2860;
  if (strlit2860 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2851 = done;
  } else {
  }
// compiled if node returning if2851 (depth = 6)
    gc_frame_newslot(if2851);
    if2778 = if2851;
  } else {
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_instr (depth = 7)
  Object if2862 = done;
  if (istrue(*var_instr)) {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2865 == NULL) {
    strlit2865 = alloc_String("""\x0a""");
    gc_root(strlit2865);
  }
// compiled string node returning strlit2865 (depth = 9)
  int op_slot_right_2864 = gc_frame_newslot(strlit2865);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  int op_slot_left_2864 = gc_frame_newslot(*var_c);
  params[0] = strlit2865;
  partcv[0] = 1;
  Object opresult2867 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult2867 (depth = 8)
  Object if2863 = done;
  if (istrue(opresult2867)) {
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2870 = alloc_Float64(0);
// compiled num node returning num2870 (depth = 10)
  int op_slot_right_2869 = gc_frame_newslot(num2870);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_interpdepth (depth = 10)
  int op_slot_left_2869 = gc_frame_newslot(*var_interpdepth);
  params[0] = num2870;
  partcv[0] = 1;
  Object opresult2872 = callmethod(*var_interpdepth, ">", 1, partcv, params);
// compiled op node returning opresult2872 (depth = 9)
  Object if2868 = done;
  if (istrue(opresult2872)) {
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  *var_line = *var_lineNumber;
  if (*var_lineNumber == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2873 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe2874 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_line (depth = 13)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2875 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_util (depth = 15)
  partcv[0] = 0;
  Object call2876 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2875);
// compiled call node returning call2876 (depth = 14)
// compiled member node returning call2876 (depth = 13)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call2877 = callmethod(call2876, "at",
    1, partcv, params);
  gc_frame_end(callframe2874);
// compiled call node returning call2877 (depth = 12)
  partcv[0] = 0;
  Object call2878 = callmethod(call2877, "size",
    1, partcv, params);
  gc_frame_end(callframe2873);
// compiled call node returning call2878 (depth = 11)
// compiled member node returning call2878 (depth = 10)
  *var_i = call2878;
  if (call2878 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2879 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2880 = alloc_Block(NULL, NULL, "lexer", 870);
  gc_frame_newslot(block2880);
// method _apply
  block_savedest(block2880);
  Object closure2881 = createclosure(4, "_apply");
  setclosureframe(closure2881, stackframe);
  addtoclosure(closure2881, var_line);
  addtoclosure(closure2881, var_util);
  addtoclosure(closure2881, var_i);
  addtoclosure(closure2881, selfslot);
  struct UserObject *uo2881 = (struct UserObject*)block2880;
  uo2881->data[0] = (Object)closure2881;
  Method *meth_meth_lexer__apply2881 = addmethod2pos(block2880, "_apply", &meth_lexer__apply2881, 0);
  int argcv_meth_lexer__apply2881[] = {0};
  meth_meth_lexer__apply2881->type = alloc_MethodType(1, argcv_meth_lexer__apply2881);
  meth_meth_lexer__apply2881->definitionModule = modulename;
  meth_meth_lexer__apply2881->definitionLine = 869;
// compiled block node returning block2880 (depth = 10)
  gc_frame_newslot(block2880);
// starting to compile block node (depth = 10)
  Object block2892 = alloc_Block(NULL, NULL, "lexer", 870);
  gc_frame_newslot(block2892);
// method _apply
  block_savedest(block2892);
  Object closure2893 = createclosure(5, "_apply");
  setclosureframe(closure2893, stackframe);
  addtoclosure(closure2893, var_i);
  addtoclosure(closure2893, var_line);
  addtoclosure(closure2893, var_lineNumber);
  addtoclosure(closure2893, var_util);
  addtoclosure(closure2893, selfslot);
  struct UserObject *uo2893 = (struct UserObject*)block2892;
  uo2893->data[0] = (Object)closure2893;
  Method *meth_meth_lexer__apply2893 = addmethod2pos(block2892, "_apply", &meth_lexer__apply2893, 0);
  int argcv_meth_lexer__apply2893[] = {0};
  meth_meth_lexer__apply2893->type = alloc_MethodType(1, argcv_meth_lexer__apply2893);
  meth_meth_lexer__apply2893->definitionModule = modulename;
  meth_meth_lexer__apply2893->definitionLine = 870;
// compiled block node returning block2892 (depth = 10)
  gc_frame_newslot(block2892);
// call case 5: prelude request
  params[0] = block2880;
  params[1] = block2892;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2917 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2879);
// compiled call node returning call2917 (depth = 9)
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 10)
  Object array2918 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2918 (depth = 10)
  *var_suggestions = array2918;
  if (array2918 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2919 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2921 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2920);
// compiled call node returning call2921 (depth = 13)
// compiled member node returning call2921 (depth = 12)
  partcv[0] = 0;
  Object call2922 = callmethod(call2921, "new",
    1, partcv, params);
  gc_frame_end(callframe2919);
// compiled call node returning call2922 (depth = 11)
// compiled member node returning call2922 (depth = 10)
  *var_suggestion = call2922;
  if (call2922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2923 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2924 == NULL) {
    strlit2924 = alloc_String("\\");
    gc_root(strlit2924);
  }
// compiled string node returning strlit2924 (depth = 10)
  gc_frame_newslot(strlit2924);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2924;
  params[1] = *var_i;
  params[2] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2925 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe2923);
// compiled call node returning call2925 (depth = 9)
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2926 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call2927 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe2926);
// compiled call node returning call2927 (depth = 9)
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2932 = alloc_Float64(2);
// compiled num node returning num2932 (depth = 13)
  int op_slot_right_2931 = gc_frame_newslot(num2932);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_2931 = gc_frame_newslot(*var_linePosition);
  params[0] = num2932;
  partcv[0] = 1;
  Object diff2934 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff2934 (depth = 12)
  int op_slot_right_2930 = gc_frame_newslot(diff2934);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_2930 = gc_frame_newslot(*var_i);
  params[0] = diff2934;
  partcv[0] = 1;
  Object opresult2936 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult2936 (depth = 11)
  int op_slot_right_2929 = gc_frame_newslot(opresult2936);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_right_2938 = gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_2938 = gc_frame_newslot(*var_line);
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object opresult2940 = callmethod(*var_line, "==", 1, partcv, params);
// compiled op node returning opresult2940 (depth = 11)
  int op_slot_left_2929 = gc_frame_newslot(opresult2940);
  params[0] = opresult2936;
  partcv[0] = 1;
  Object opresult2941 = callmethod(opresult2940, "&&", 1, partcv, params);
// compiled op node returning opresult2941 (depth = 10)
  Object if2928 = done;
  if (istrue(opresult2941)) {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2942 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2943 == NULL) {
    strlit2943 = alloc_String("For a '{' character in a string use '\\{'.");
    gc_root(strlit2943);
  }
// compiled string node returning strlit2943 (depth = 11)
  gc_frame_newslot(strlit2943);
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_line (depth = 11)
  gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit2943;
  params[1] = *var_line;
  params[2] = *var_i;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2944 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe2942);
// compiled call node returning call2944 (depth = 10)
    gc_frame_newslot(call2944);
    if2928 = call2944;
  } else {
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2945 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call2947 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2946);
// compiled call node returning call2947 (depth = 14)
// compiled member node returning call2947 (depth = 13)
  partcv[0] = 0;
  Object call2948 = callmethod(call2947, "new",
    1, partcv, params);
  gc_frame_end(callframe2945);
// compiled call node returning call2948 (depth = 12)
// compiled member node returning call2948 (depth = 11)
  *var_suggestion = call2948;
  if (call2948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2950 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2951 == NULL) {
    strlit2951 = alloc_String("}");
    gc_root(strlit2951);
  }
// compiled string node returning strlit2951 (depth = 11)
  gc_frame_newslot(strlit2951);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2953 = alloc_Float64(1);
// compiled num node returning num2953 (depth = 12)
  int op_slot_right_2952 = gc_frame_newslot(num2953);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  partcv[0] = 0;
  Object call2957 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe2956);
// compiled call node returning call2957 (depth = 14)
// compiled member node returning call2957 (depth = 13)
  int op_slot_right_2955 = gc_frame_newslot(call2957);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_2955 = gc_frame_newslot(*var_linePosition);
  params[0] = call2957;
  partcv[0] = 1;
  Object diff2959 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff2959 (depth = 12)
  int op_slot_left_2952 = gc_frame_newslot(diff2959);
  params[0] = num2953;
  partcv[0] = 1;
  Object diff2960 = callmethod(diff2959, "-", 1, partcv, params);
// compiled op node returning diff2960 (depth = 11)
  gc_frame_newslot(diff2960);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2951;
  params[1] = diff2960;
  params[2] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2961 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe2950);
// compiled call node returning call2961 (depth = 10)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2962 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call2963 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe2962);
// compiled call node returning call2963 (depth = 10)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2964 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2965 == NULL) {
    strlit2965 = alloc_String("A string interpolation must end with a '}'. For a '{' character in a string use '\\{'.");
    gc_root(strlit2965);
  }
// compiled string node returning strlit2965 (depth = 11)
  gc_frame_newslot(strlit2965);
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2967 = alloc_Float64(1);
// compiled num node returning num2967 (depth = 12)
  int op_slot_right_2966 = gc_frame_newslot(num2967);
// starting to compile op node (depth = 12)
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  partcv[0] = 0;
  Object call2971 = callmethod(*var_accum, "size",
    1, partcv, params);
  gc_frame_end(callframe2970);
// compiled call node returning call2971 (depth = 14)
// compiled member node returning call2971 (depth = 13)
  int op_slot_right_2969 = gc_frame_newslot(call2971);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_linePosition (depth = 13)
  int op_slot_left_2969 = gc_frame_newslot(*var_linePosition);
  params[0] = call2971;
  partcv[0] = 1;
  Object diff2973 = callmethod(*var_linePosition, "-", 1, partcv, params);
// compiled op node returning diff2973 (depth = 12)
  int op_slot_left_2966 = gc_frame_newslot(diff2973);
  params[0] = num2967;
  partcv[0] = 1;
  Object diff2974 = callmethod(diff2973, "-", 1, partcv, params);
// compiled op node returning diff2974 (depth = 11)
  gc_frame_newslot(diff2974);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit2965;
  params[1] = *var_lineNumber;
  params[2] = diff2974;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2975 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe2964);
// compiled call node returning call2975 (depth = 10)
    gc_frame_newslot(call2975);
    if2928 = call2975;
  }
// compiled if node returning if2928 (depth = 9)
    gc_frame_newslot(if2928);
    if2868 = if2928;
  } else {
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2976 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2977 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_util (depth = 13)
  partcv[0] = 0;
  Object call2978 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2977);
// compiled call node returning call2978 (depth = 12)
// compiled member node returning call2978 (depth = 11)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call2979 = callmethod(call2978, "at",
    1, partcv, params);
  gc_frame_end(callframe2976);
// compiled call node returning call2979 (depth = 10)
  *var_errorLine = call2979;
  if (call2979 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile if node (depth = 10)
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2983 = alloc_Float64(1);
// compiled num node returning num2983 (depth = 13)
  int op_slot_right_2982 = gc_frame_newslot(num2983);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  int op_slot_left_2982 = gc_frame_newslot(*var_lineNumber);
  params[0] = num2983;
  partcv[0] = 1;
  Object sum2985 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum2985 (depth = 12)
  int op_slot_right_2981 = gc_frame_newslot(sum2985);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2987 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_util (depth = 16)
  partcv[0] = 0;
  Object call2989 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2988);
// compiled call node returning call2989 (depth = 15)
// compiled member node returning call2989 (depth = 14)
  partcv[0] = 0;
  Object call2990 = callmethod(call2989, "size",
    1, partcv, params);
  gc_frame_end(callframe2987);
// compiled call node returning call2990 (depth = 13)
// compiled member node returning call2990 (depth = 12)
  int op_slot_left_2981 = gc_frame_newslot(call2990);
  params[0] = sum2985;
  partcv[0] = 1;
  Object opresult2991 = callmethod(call2990, ">=", 1, partcv, params);
// compiled op node returning opresult2991 (depth = 11)
  Object if2980 = done;
struct StackFrameObject *iftmpstackframe2980 = stackframe;
  if (istrue(opresult2991)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2980);
gc_frame_newslot((Object)stackframe);
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2992 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2994 = alloc_Float64(1);
// compiled num node returning num2994 (depth = 13)
  int op_slot_right_2993 = gc_frame_newslot(num2994);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lineNumber (depth = 13)
  int op_slot_left_2993 = gc_frame_newslot(*var_lineNumber);
  params[0] = num2994;
  partcv[0] = 1;
  Object sum2996 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum2996 (depth = 12)
  gc_frame_newslot(sum2996);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2997 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_util (depth = 14)
  partcv[0] = 0;
  Object call2998 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe2997);
// compiled call node returning call2998 (depth = 13)
// compiled member node returning call2998 (depth = 12)
  params[0] = sum2996;
  partcv[0] = 1;
  Object call2999 = callmethod(call2998, "at",
    1, partcv, params);
  gc_frame_end(callframe2992);
// compiled call node returning call2999 (depth = 11)
    gc_frame_newslot(call2999);
    if2980 = call2999;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2980);
  gc_frame_newslot((Object)stackframe);
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit3000 == NULL) {
    strlit3000 = alloc_String("");
    gc_root(strlit3000);
  }
// compiled string node returning strlit3000 (depth = 11)
    gc_frame_newslot(strlit3000);
    if2980 = strlit3000;
  }
stackframe = iftmpstackframe2980;
// compiled if node returning if2980 (depth = 10)
  *var_nextLine = if2980;
  if (if2980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num3001 = alloc_Float64(1);
// compiled num node returning num3001 (depth = 10)
  *var_i = num3001;
  if (num3001 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num3002 = alloc_Float64(0);
// compiled num node returning num3002 (depth = 10)
  *var_count = num3002;
  if (num3002 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe3003 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block3004 = alloc_Block(NULL, NULL, "lexer", 901);
  gc_frame_newslot(block3004);
// method _apply
  block_savedest(block3004);
  Object closure3005 = createclosure(3, "_apply");
  setclosureframe(closure3005, stackframe);
  addtoclosure(closure3005, var_nextLine);
  addtoclosure(closure3005, var_i);
  addtoclosure(closure3005, selfslot);
  struct UserObject *uo3005 = (struct UserObject*)block3004;
  uo3005->data[0] = (Object)closure3005;
  Method *meth_meth_lexer__apply3005 = addmethod2pos(block3004, "_apply", &meth_lexer__apply3005, 0);
  int argcv_meth_lexer__apply3005[] = {0};
  meth_meth_lexer__apply3005->type = alloc_MethodType(1, argcv_meth_lexer__apply3005);
  meth_meth_lexer__apply3005->definitionModule = modulename;
  meth_meth_lexer__apply3005->definitionLine = 894;
// compiled block node returning block3004 (depth = 10)
  gc_frame_newslot(block3004);
// starting to compile block node (depth = 10)
  Object block3012 = alloc_Block(NULL, NULL, "lexer", 901);
  gc_frame_newslot(block3012);
// method _apply
  block_savedest(block3012);
  Object closure3013 = createclosure(4, "_apply");
  setclosureframe(closure3013, stackframe);
  addtoclosure(closure3013, var_nextLine);
  addtoclosure(closure3013, var_i);
  addtoclosure(closure3013, var_count);
  addtoclosure(closure3013, selfslot);
  struct UserObject *uo3013 = (struct UserObject*)block3012;
  uo3013->data[0] = (Object)closure3013;
  Method *meth_meth_lexer__apply3013 = addmethod2pos(block3012, "_apply", &meth_lexer__apply3013, 0);
  int argcv_meth_lexer__apply3013[] = {0};
  meth_meth_lexer__apply3013->type = alloc_MethodType(1, argcv_meth_lexer__apply3013);
  meth_meth_lexer__apply3013->definitionModule = modulename;
  meth_meth_lexer__apply3013->definitionLine = 901;
// compiled block node returning block3012 (depth = 10)
  gc_frame_newslot(block3012);
// call case 5: prelude request
  params[0] = block3004;
  params[1] = block3012;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3042 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3003);
// compiled call node returning call3042 (depth = 9)
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3045 = alloc_Float64(1);
// compiled num node returning num3045 (depth = 11)
  int op_slot_right_3044 = gc_frame_newslot(num3045);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3048 = alloc_Float64(2);
// compiled num node returning num3048 (depth = 12)
  int op_slot_right_3047 = gc_frame_newslot(num3048);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_count (depth = 12)
  int op_slot_left_3047 = gc_frame_newslot(*var_count);
  params[0] = num3048;
  partcv[0] = 1;
  Object modulus3050 = callmethod(*var_count, "%", 1, partcv, params);
// compiled op node returning modulus3050 (depth = 11)
  int op_slot_left_3044 = gc_frame_newslot(modulus3050);
  params[0] = num3045;
  partcv[0] = 1;
  Object opresult3051 = callmethod(modulus3050, "==", 1, partcv, params);
// compiled op node returning opresult3051 (depth = 10)
  Object if3043 = done;
  if (istrue(opresult3051)) {
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 11)
  Object array3052 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3052 (depth = 11)
  *var_suggestions = array3052;
  if (array3052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 10)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3053 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3054 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3055 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3054);
// compiled call node returning call3055 (depth = 14)
// compiled member node returning call3055 (depth = 13)
  partcv[0] = 0;
  Object call3056 = callmethod(call3055, "new",
    1, partcv, params);
  gc_frame_end(callframe3053);
// compiled call node returning call3056 (depth = 12)
// compiled member node returning call3056 (depth = 11)
  *var_suggestion = call3056;
  if (call3056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 10)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3057 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextLine (depth = 12)
  int op_slot_right_3058 = gc_frame_newslot(*var_nextLine);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3058 = gc_frame_newslot(*var_errorLine);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3060 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3060 (depth = 11)
  gc_frame_newslot(opresult3060);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3060;
  partcv[0] = 2;
  Object call3061 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3057);
// compiled call node returning call3061 (depth = 10)
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3062 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3064 = alloc_Float64(1);
// compiled num node returning num3064 (depth = 12)
  int op_slot_right_3063 = gc_frame_newslot(num3064);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3063 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3064;
  partcv[0] = 1;
  Object sum3066 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3066 (depth = 11)
  gc_frame_newslot(sum3066);
// starting to compile string node (depth = 11)
  if (strlit3067 == NULL) {
    strlit3067 = alloc_String("");
    gc_root(strlit3067);
  }
// compiled string node returning strlit3067 (depth = 11)
  gc_frame_newslot(strlit3067);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3066;
  params[1] = strlit3067;
  partcv[0] = 2;
  Object call3068 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3062);
// compiled call node returning call3068 (depth = 10)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3069 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3070 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3069);
// compiled call node returning call3070 (depth = 10)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3071 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3072 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3073 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3072);
// compiled call node returning call3073 (depth = 14)
// compiled member node returning call3073 (depth = 13)
  partcv[0] = 0;
  Object call3074 = callmethod(call3073, "new",
    1, partcv, params);
  gc_frame_end(callframe3071);
// compiled call node returning call3074 (depth = 12)
// compiled member node returning call3074 (depth = 11)
  *var_suggestion = call3074;
  if (call3074 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3076 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3078 == NULL) {
    strlit3078 = alloc_String("""\x22""");
    gc_root(strlit3078);
  }
// compiled string node returning strlit3078 (depth = 12)
  int op_slot_right_3077 = gc_frame_newslot(strlit3078);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3077 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3078;
  partcv[0] = 1;
  Object opresult3080 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3080 (depth = 11)
  gc_frame_newslot(opresult3080);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3080;
  partcv[0] = 2;
  Object call3081 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3076);
// compiled call node returning call3081 (depth = 10)
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3082 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3084 = alloc_Float64(1);
// compiled num node returning num3084 (depth = 12)
  int op_slot_right_3083 = gc_frame_newslot(num3084);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3083 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3084;
  partcv[0] = 1;
  Object sum3086 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3086 (depth = 11)
  gc_frame_newslot(sum3086);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextLine (depth = 12)
  int op_slot_right_3087 = gc_frame_newslot(*var_nextLine);
// starting to compile string node (depth = 12)
  if (strlit3089 == NULL) {
    strlit3089 = alloc_String("    ++ ""\x22""");
    gc_root(strlit3089);
  }
// compiled string node returning strlit3089 (depth = 12)
  int op_slot_left_3087 = gc_frame_newslot(strlit3089);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3090 = callmethod(strlit3089, "++", 1, partcv, params);
// compiled op node returning opresult3090 (depth = 11)
  gc_frame_newslot(opresult3090);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3086;
  params[1] = opresult3090;
  partcv[0] = 2;
  Object call3091 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3082);
// compiled call node returning call3091 (depth = 10)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3092 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3093 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3092);
// compiled call node returning call3093 (depth = 10)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3094 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3095 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3096 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3095);
// compiled call node returning call3096 (depth = 14)
// compiled member node returning call3096 (depth = 13)
  partcv[0] = 0;
  Object call3097 = callmethod(call3096, "new",
    1, partcv, params);
  gc_frame_end(callframe3094);
// compiled call node returning call3097 (depth = 12)
// compiled member node returning call3097 (depth = 11)
  *var_suggestion = call3097;
  if (call3097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3099 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextLine (depth = 12)
  int op_slot_right_3100 = gc_frame_newslot(*var_nextLine);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3103 == NULL) {
    strlit3103 = alloc_String("\\n");
    gc_root(strlit3103);
  }
// compiled string node returning strlit3103 (depth = 13)
  int op_slot_right_3102 = gc_frame_newslot(strlit3103);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errorLine (depth = 13)
  int op_slot_left_3102 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3103;
  partcv[0] = 1;
  Object opresult3105 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3105 (depth = 12)
  int op_slot_left_3100 = gc_frame_newslot(opresult3105);
  params[0] = *var_nextLine;
  partcv[0] = 1;
  Object opresult3106 = callmethod(opresult3105, "++", 1, partcv, params);
// compiled op node returning opresult3106 (depth = 11)
  gc_frame_newslot(opresult3106);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3106;
  partcv[0] = 2;
  Object call3107 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3099);
// compiled call node returning call3107 (depth = 10)
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3108 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3110 = alloc_Float64(1);
// compiled num node returning num3110 (depth = 12)
  int op_slot_right_3109 = gc_frame_newslot(num3110);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lineNumber (depth = 12)
  int op_slot_left_3109 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3110;
  partcv[0] = 1;
  Object sum3112 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3112 (depth = 11)
  gc_frame_newslot(sum3112);
// starting to compile string node (depth = 11)
  if (strlit3113 == NULL) {
    strlit3113 = alloc_String("");
    gc_root(strlit3113);
  }
// compiled string node returning strlit3113 (depth = 11)
  gc_frame_newslot(strlit3113);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum3112;
  params[1] = strlit3113;
  partcv[0] = 2;
  Object call3114 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3108);
// compiled call node returning call3114 (depth = 10)
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3115 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3116 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3115);
// compiled call node returning call3116 (depth = 10)
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3117 = gc_frame_new();
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3119 == NULL) {
    strlit3119 = alloc_String("To split a string over multiple lines use '++' to join strings together.");
    gc_root(strlit3119);
  }
// compiled string node returning strlit3119 (depth = 12)
  int op_slot_right_3118 = gc_frame_newslot(strlit3119);
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3121 == NULL) {
    strlit3121 = alloc_String("A string must end with a '""\x22""'. To insert a newline in a string use '\\n'. ");
    gc_root(strlit3121);
  }
// compiled string node returning strlit3121 (depth = 12)
  int op_slot_left_3118 = gc_frame_newslot(strlit3121);
  params[0] = strlit3119;
  partcv[0] = 1;
  Object opresult3122 = callmethod(strlit3121, "++", 1, partcv, params);
// compiled op node returning opresult3122 (depth = 11)
  gc_frame_newslot(opresult3122);
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestions (depth = 11)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = opresult3122;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_linePosition;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3123 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3117);
// compiled call node returning call3123 (depth = 10)
    gc_frame_newslot(call3123);
    if3043 = call3123;
  } else {
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 10)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3124 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3125 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_errormessages (depth = 15)
  partcv[0] = 0;
  Object call3126 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3125);
// compiled call node returning call3126 (depth = 14)
// compiled member node returning call3126 (depth = 13)
  partcv[0] = 0;
  Object call3127 = callmethod(call3126, "new",
    1, partcv, params);
  gc_frame_end(callframe3124);
// compiled call node returning call3127 (depth = 12)
// compiled member node returning call3127 (depth = 11)
  *var_suggestion = call3127;
  if (call3127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 10)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3128 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3130 == NULL) {
    strlit3130 = alloc_String("""\x22""");
    gc_root(strlit3130);
  }
// compiled string node returning strlit3130 (depth = 12)
  int op_slot_right_3129 = gc_frame_newslot(strlit3130);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errorLine (depth = 12)
  int op_slot_left_3129 = gc_frame_newslot(*var_errorLine);
  params[0] = strlit3130;
  partcv[0] = 1;
  Object opresult3132 = callmethod(*var_errorLine, "++", 1, partcv, params);
// compiled op node returning opresult3132 (depth = 11)
  gc_frame_newslot(opresult3132);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_lineNumber;
  params[1] = opresult3132;
  partcv[0] = 2;
  Object call3133 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3128);
// compiled call node returning call3133 (depth = 10)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe3134 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit3135 == NULL) {
    strlit3135 = alloc_String("A string must end with a '""\x22""'.");
    gc_root(strlit3135);
  }
// compiled string node returning strlit3135 (depth = 11)
  gc_frame_newslot(strlit3135);
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lineNumber (depth = 11)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_linePosition (depth = 11)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  params[0] = strlit3135;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3136 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3134);
// compiled call node returning call3136 (depth = 10)
    gc_frame_newslot(call3136);
    if3043 = call3136;
  }
// compiled if node returning if3043 (depth = 9)
    gc_frame_newslot(if3043);
    if2868 = if3043;
  }
// compiled if node returning if2868 (depth = 8)
    gc_frame_newslot(if2868);
    if2863 = if2868;
  } else {
  }
// compiled if node returning if2863 (depth = 7)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_escaped (depth = 8)
  Object if3137 = done;
  if (istrue(*var_escaped)) {
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3140 == NULL) {
    strlit3140 = alloc_String("n");
    gc_root(strlit3140);
  }
// compiled string node returning strlit3140 (depth = 10)
  int op_slot_right_3139 = gc_frame_newslot(strlit3140);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3139 = gc_frame_newslot(*var_c);
  params[0] = strlit3140;
  partcv[0] = 1;
  Object opresult3142 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3142 (depth = 9)
  Object if3138 = done;
  if (istrue(opresult3142)) {
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit3144 == NULL) {
    strlit3144 = alloc_String("""\x0a""");
    gc_root(strlit3144);
  }
// compiled string node returning strlit3144 (depth = 11)
  int op_slot_right_3143 = gc_frame_newslot(strlit3144);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_accum (depth = 11)
  int op_slot_left_3143 = gc_frame_newslot(*var_accum);
  params[0] = strlit3144;
  partcv[0] = 1;
  Object opresult3146 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3146 (depth = 10)
  *var_accum = opresult3146;
  if (opresult3146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3138 = done;
  } else {
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3150 == NULL) {
    strlit3150 = alloc_String("u");
    gc_root(strlit3150);
  }
// compiled string node returning strlit3150 (depth = 11)
  int op_slot_right_3149 = gc_frame_newslot(strlit3150);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_c (depth = 11)
  int op_slot_left_3149 = gc_frame_newslot(*var_c);
  params[0] = strlit3150;
  partcv[0] = 1;
  Object opresult3152 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3152 (depth = 10)
  Object if3148 = done;
  if (istrue(opresult3152)) {
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 11)
  Object num3153 = alloc_Float64(4);
// compiled num node returning num3153 (depth = 11)
  *var_unichars = num3153;
  if (num3153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 11)
  Object num3155 = alloc_Float64(0);
// compiled num node returning num3155 (depth = 11)
  *var_codepoint = num3155;
  if (num3155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if3148 = done;
  } else {
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3159 == NULL) {
    strlit3159 = alloc_String("U");
    gc_root(strlit3159);
  }
// compiled string node returning strlit3159 (depth = 12)
  int op_slot_right_3158 = gc_frame_newslot(strlit3159);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_3158 = gc_frame_newslot(*var_c);
  params[0] = strlit3159;
  partcv[0] = 1;
  Object opresult3161 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3161 (depth = 11)
  Object if3157 = done;
  if (istrue(opresult3161)) {
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3162 = alloc_Float64(6);
// compiled num node returning num3162 (depth = 12)
  *var_unichars = num3162;
  if (num3162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3164 = alloc_Float64(0);
// compiled num node returning num3164 (depth = 12)
  *var_codepoint = num3164;
  if (num3164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3157 = done;
  } else {
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit3168 == NULL) {
    strlit3168 = alloc_String("t");
    gc_root(strlit3168);
  }
// compiled string node returning strlit3168 (depth = 13)
  int op_slot_right_3167 = gc_frame_newslot(strlit3168);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_left_3167 = gc_frame_newslot(*var_c);
  params[0] = strlit3168;
  partcv[0] = 1;
  Object opresult3170 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3170 (depth = 12)
  Object if3166 = done;
  if (istrue(opresult3170)) {
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// starting to compile op node (depth = 13)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 14)
  if (strlit3172 == NULL) {
    strlit3172 = alloc_String("""\x09""");
    gc_root(strlit3172);
  }
// compiled string node returning strlit3172 (depth = 14)
  int op_slot_right_3171 = gc_frame_newslot(strlit3172);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_accum (depth = 14)
  int op_slot_left_3171 = gc_frame_newslot(*var_accum);
  params[0] = strlit3172;
  partcv[0] = 1;
  Object opresult3174 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3174 (depth = 13)
  *var_accum = opresult3174;
  if (opresult3174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3166 = done;
  } else {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit3178 == NULL) {
    strlit3178 = alloc_String("r");
    gc_root(strlit3178);
  }
// compiled string node returning strlit3178 (depth = 14)
  int op_slot_right_3177 = gc_frame_newslot(strlit3178);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_c (depth = 14)
  int op_slot_left_3177 = gc_frame_newslot(*var_c);
  params[0] = strlit3178;
  partcv[0] = 1;
  Object opresult3180 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3180 (depth = 13)
  Object if3176 = done;
  if (istrue(opresult3180)) {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 13)
// starting to compile op node (depth = 14)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 15)
  if (strlit3182 == NULL) {
    strlit3182 = alloc_String("""\x0d""");
    gc_root(strlit3182);
  }
// compiled string node returning strlit3182 (depth = 15)
  int op_slot_right_3181 = gc_frame_newslot(strlit3182);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_accum (depth = 15)
  int op_slot_left_3181 = gc_frame_newslot(*var_accum);
  params[0] = strlit3182;
  partcv[0] = 1;
  Object opresult3184 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3184 (depth = 14)
  *var_accum = opresult3184;
  if (opresult3184 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 13)
    gc_frame_newslot(done);
    if3176 = done;
  } else {
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit3188 == NULL) {
    strlit3188 = alloc_String("b");
    gc_root(strlit3188);
  }
// compiled string node returning strlit3188 (depth = 15)
  int op_slot_right_3187 = gc_frame_newslot(strlit3188);
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_c (depth = 15)
  int op_slot_left_3187 = gc_frame_newslot(*var_c);
  params[0] = strlit3188;
  partcv[0] = 1;
  Object opresult3190 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3190 (depth = 14)
  Object if3186 = done;
  if (istrue(opresult3190)) {
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 14)
// starting to compile op node (depth = 15)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 16)
  if (strlit3192 == NULL) {
    strlit3192 = alloc_String("""\x08""");
    gc_root(strlit3192);
  }
// compiled string node returning strlit3192 (depth = 16)
  int op_slot_right_3191 = gc_frame_newslot(strlit3192);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_accum (depth = 16)
  int op_slot_left_3191 = gc_frame_newslot(*var_accum);
  params[0] = strlit3192;
  partcv[0] = 1;
  Object opresult3194 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3194 (depth = 15)
  *var_accum = opresult3194;
  if (opresult3194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 14)
    gc_frame_newslot(done);
    if3186 = done;
  } else {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 14)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 15)
// starting to compile string node (depth = 16)
  if (strlit3198 == NULL) {
    strlit3198 = alloc_String("l");
    gc_root(strlit3198);
  }
// compiled string node returning strlit3198 (depth = 16)
  int op_slot_right_3197 = gc_frame_newslot(strlit3198);
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_c (depth = 16)
  int op_slot_left_3197 = gc_frame_newslot(*var_c);
  params[0] = strlit3198;
  partcv[0] = 1;
  Object opresult3200 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3200 (depth = 15)
  Object if3196 = done;
  if (istrue(opresult3200)) {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 15)
// starting to compile op node (depth = 16)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 17)
  if (strlit3202 == NULL) {
    strlit3202 = alloc_String("""\xe2""""\x80""""\xa8""");
    gc_root(strlit3202);
  }
// compiled string node returning strlit3202 (depth = 17)
  int op_slot_right_3201 = gc_frame_newslot(strlit3202);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_accum (depth = 17)
  int op_slot_left_3201 = gc_frame_newslot(*var_accum);
  params[0] = strlit3202;
  partcv[0] = 1;
  Object opresult3204 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3204 (depth = 16)
  *var_accum = opresult3204;
  if (opresult3204 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 15)
    gc_frame_newslot(done);
    if3196 = done;
  } else {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 15)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 16)
// starting to compile string node (depth = 17)
  if (strlit3208 == NULL) {
    strlit3208 = alloc_String("f");
    gc_root(strlit3208);
  }
// compiled string node returning strlit3208 (depth = 17)
  int op_slot_right_3207 = gc_frame_newslot(strlit3208);
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_c (depth = 17)
  int op_slot_left_3207 = gc_frame_newslot(*var_c);
  params[0] = strlit3208;
  partcv[0] = 1;
  Object opresult3210 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3210 (depth = 16)
  Object if3206 = done;
  if (istrue(opresult3210)) {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 16)
// starting to compile op node (depth = 17)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 18)
  if (strlit3212 == NULL) {
    strlit3212 = alloc_String("""\x0c""");
    gc_root(strlit3212);
  }
// compiled string node returning strlit3212 (depth = 18)
  int op_slot_right_3211 = gc_frame_newslot(strlit3212);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_accum (depth = 18)
  int op_slot_left_3211 = gc_frame_newslot(*var_accum);
  params[0] = strlit3212;
  partcv[0] = 1;
  Object opresult3214 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3214 (depth = 17)
  *var_accum = opresult3214;
  if (opresult3214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 16)
    gc_frame_newslot(done);
    if3206 = done;
  } else {
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 16)
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 17)
// starting to compile string node (depth = 18)
  if (strlit3218 == NULL) {
    strlit3218 = alloc_String("e");
    gc_root(strlit3218);
  }
// compiled string node returning strlit3218 (depth = 18)
  int op_slot_right_3217 = gc_frame_newslot(strlit3218);
// starting to compile identifier node (depth = 18)
// compiled identifier node returning *var_c (depth = 18)
  int op_slot_left_3217 = gc_frame_newslot(*var_c);
  params[0] = strlit3218;
  partcv[0] = 1;
  Object opresult3220 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3220 (depth = 17)
  Object if3216 = done;
  if (istrue(opresult3220)) {
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 17)
// starting to compile op node (depth = 18)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 19)
  if (strlit3222 == NULL) {
    strlit3222 = alloc_String("""\x1b""");
    gc_root(strlit3222);
  }
// compiled string node returning strlit3222 (depth = 19)
  int op_slot_right_3221 = gc_frame_newslot(strlit3222);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  int op_slot_left_3221 = gc_frame_newslot(*var_accum);
  params[0] = strlit3222;
  partcv[0] = 1;
  Object opresult3224 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3224 (depth = 18)
  *var_accum = opresult3224;
  if (opresult3224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 17)
    gc_frame_newslot(done);
    if3216 = done;
  } else {
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 17)
// starting to compile op node (depth = 18)
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_c (depth = 19)
  int op_slot_right_3226 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 19)
// compiled identifier node returning *var_accum (depth = 19)
  int op_slot_left_3226 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3228 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3228 (depth = 18)
  *var_accum = opresult3228;
  if (opresult3228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 17)
    gc_frame_newslot(done);
    if3216 = done;
  }
// compiled if node returning if3216 (depth = 16)
    gc_frame_newslot(if3216);
    if3206 = if3216;
  }
// compiled if node returning if3206 (depth = 15)
    gc_frame_newslot(if3206);
    if3196 = if3206;
  }
// compiled if node returning if3196 (depth = 14)
    gc_frame_newslot(if3196);
    if3186 = if3196;
  }
// compiled if node returning if3186 (depth = 13)
    gc_frame_newslot(if3186);
    if3176 = if3186;
  }
// compiled if node returning if3176 (depth = 12)
    gc_frame_newslot(if3176);
    if3166 = if3176;
  }
// compiled if node returning if3166 (depth = 11)
    gc_frame_newslot(if3166);
    if3157 = if3166;
  }
// compiled if node returning if3157 (depth = 10)
    gc_frame_newslot(if3157);
    if3148 = if3157;
  }
// compiled if node returning if3148 (depth = 9)
    gc_frame_newslot(if3148);
    if3138 = if3148;
  }
// compiled if node returning if3138 (depth = 8)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool3230 = alloc_Boolean(0);
// compiled identifier node returning bool3230 (depth = 9)
  *var_escaped = bool3230;
  if (bool3230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3137 = done;
  } else {
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3234 == NULL) {
    strlit3234 = alloc_String("\\");
    gc_root(strlit3234);
  }
// compiled string node returning strlit3234 (depth = 10)
  int op_slot_right_3233 = gc_frame_newslot(strlit3234);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3233 = gc_frame_newslot(*var_c);
  params[0] = strlit3234;
  partcv[0] = 1;
  Object opresult3236 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3236 (depth = 9)
  Object if3232 = done;
  if (istrue(opresult3236)) {
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool3237 = alloc_Boolean(1);
// compiled identifier node returning bool3237 (depth = 10)
  *var_escaped = bool3237;
  if (bool3237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if3232 = done;
  } else {
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num3241 = alloc_Float64(0);
// compiled num node returning num3241 (depth = 11)
  int op_slot_right_3240 = gc_frame_newslot(num3241);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_unichars (depth = 11)
  int op_slot_left_3240 = gc_frame_newslot(*var_unichars);
  params[0] = num3241;
  partcv[0] = 1;
  Object opresult3243 = callmethod(*var_unichars, ">", 1, partcv, params);
// compiled op node returning opresult3243 (depth = 10)
  Object if3239 = done;
  if (istrue(opresult3243)) {
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3245 = alloc_Float64(1);
// compiled num node returning num3245 (depth = 12)
  int op_slot_right_3244 = gc_frame_newslot(num3245);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unichars (depth = 12)
  int op_slot_left_3244 = gc_frame_newslot(*var_unichars);
  params[0] = num3245;
  partcv[0] = 1;
  Object diff3247 = callmethod(*var_unichars, "-", 1, partcv, params);
// compiled op node returning diff3247 (depth = 11)
  *var_unichars = diff3247;
  if (diff3247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 12)
  Object num3250 = alloc_Float64(16);
// compiled num node returning num3250 (depth = 12)
  int op_slot_right_3249 = gc_frame_newslot(num3250);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_codepoint (depth = 12)
  int op_slot_left_3249 = gc_frame_newslot(*var_codepoint);
  params[0] = num3250;
  partcv[0] = 1;
  Object prod3252 = callmethod(*var_codepoint, "*", 1, partcv, params);
// compiled op node returning prod3252 (depth = 11)
  *var_codepoint = prod3252;
  if (prod3252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3255 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  gc_frame_newslot(*var_c);
// call case 2: outer request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe3256 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe3257 = gc_frame_new();
// call case 3: self.outer request
  Object call3258 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3257);
// compiled call node returning call3258 (depth = 16)
// compiled member node returning call3258 (depth = 15)
  partcv[0] = 0;
  Object call3259 = callmethodflags(call3258, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3256);
// compiled call node returning call3259 (depth = 14)
// compiled member node returning call3259 (depth = 13)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3260 = callmethodflags(call3259, "hexdecchar", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3255);
// compiled call node returning call3260 (depth = 12)
  int op_slot_right_3254 = gc_frame_newslot(call3260);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_codepoint (depth = 12)
  int op_slot_left_3254 = gc_frame_newslot(*var_codepoint);
  params[0] = call3260;
  partcv[0] = 1;
  Object sum3262 = callmethod(*var_codepoint, "+", 1, partcv, params);
// compiled op node returning sum3262 (depth = 11)
  *var_codepoint = sum3262;
  if (sum3262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num3266 = alloc_Float64(0);
// compiled num node returning num3266 (depth = 12)
  int op_slot_right_3265 = gc_frame_newslot(num3266);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_unichars (depth = 12)
  int op_slot_left_3265 = gc_frame_newslot(*var_unichars);
  params[0] = num3266;
  partcv[0] = 1;
  Object opresult3268 = callmethod(*var_unichars, "==", 1, partcv, params);
// compiled op node returning opresult3268 (depth = 11)
  Object if3264 = done;
  if (istrue(opresult3268)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3270 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_codepoint (depth = 14)
  gc_frame_newslot(*var_codepoint);
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_unicode (depth = 14)
  params[0] = *var_codepoint;
  partcv[0] = 1;
  Object call3271 = callmethod(*var_unicode, "create",
    1, partcv, params);
  gc_frame_end(callframe3270);
// compiled call node returning call3271 (depth = 13)
  int op_slot_right_3269 = gc_frame_newslot(call3271);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_3269 = gc_frame_newslot(*var_accum);
  params[0] = call3271;
  partcv[0] = 1;
  Object opresult3273 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3273 (depth = 12)
  *var_accum = opresult3273;
  if (opresult3273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3264 = done;
  } else {
  }
// compiled if node returning if3264 (depth = 10)
    gc_frame_newslot(if3264);
    if3239 = if3264;
  } else {
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3277 == NULL) {
    strlit3277 = alloc_String("{");
    gc_root(strlit3277);
  }
// compiled string node returning strlit3277 (depth = 12)
  int op_slot_right_3276 = gc_frame_newslot(strlit3277);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  int op_slot_left_3276 = gc_frame_newslot(*var_c);
  params[0] = strlit3277;
  partcv[0] = 1;
  Object opresult3279 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3279 (depth = 11)
  Object if3275 = done;
  if (istrue(opresult3279)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe3281 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_interpString (depth = 14)
  partcv[0] = 0;
  Object call3282 = callmethod(*var_interpString, "not",
    1, partcv, params);
  gc_frame_end(callframe3281);
// compiled call node returning call3282 (depth = 13)
// compiled member node returning call3282 (depth = 12)
  Object if3280 = done;
  if (istrue(call3282)) {
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe3283 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 13)
  if (strlit3284 == NULL) {
    strlit3284 = alloc_String("(");
    gc_root(strlit3284);
  }
// compiled string node returning strlit3284 (depth = 13)
  gc_frame_newslot(strlit3284);
// starting to compile string node (depth = 13)
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("(");
    gc_root(strlit3285);
  }
// compiled string node returning strlit3285 (depth = 13)
  gc_frame_newslot(strlit3285);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3284;
  params[2] = strlit3285;
  partcv[0] = 3;
  Object call3286 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3283);
// compiled call node returning call3286 (depth = 12)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 12)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
  Object bool3287 = alloc_Boolean(1);
// compiled identifier node returning bool3287 (depth = 13)
  *var_interpString = bool3287;
  if (bool3287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 12)
    gc_frame_newslot(done);
    if3280 = done;
  } else {
  }
// compiled if node returning if3280 (depth = 11)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3289 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_mode (depth = 12)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_accum (depth = 12)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3290 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3289);
// compiled call node returning call3290 (depth = 11)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3291 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 12)
  if (strlit3292 == NULL) {
    strlit3292 = alloc_String("o");
    gc_root(strlit3292);
  }
// compiled string node returning strlit3292 (depth = 12)
  gc_frame_newslot(strlit3292);
// starting to compile string node (depth = 12)
  if (strlit3293 == NULL) {
    strlit3293 = alloc_String("++");
    gc_root(strlit3293);
  }
// compiled string node returning strlit3293 (depth = 12)
  gc_frame_newslot(strlit3293);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3292;
  params[2] = strlit3293;
  partcv[0] = 3;
  Object call3294 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3291);
// compiled call node returning call3294 (depth = 11)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe3295 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 12)
  if (strlit3296 == NULL) {
    strlit3296 = alloc_String("(");
    gc_root(strlit3296);
  }
// compiled string node returning strlit3296 (depth = 12)
  gc_frame_newslot(strlit3296);
// starting to compile string node (depth = 12)
  if (strlit3297 == NULL) {
    strlit3297 = alloc_String("(");
    gc_root(strlit3297);
  }
// compiled string node returning strlit3297 (depth = 12)
  gc_frame_newslot(strlit3297);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3296;
  params[2] = strlit3297;
  partcv[0] = 3;
  Object call3298 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3295);
// compiled call node returning call3298 (depth = 11)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3299 == NULL) {
    strlit3299 = alloc_String("n");
    gc_root(strlit3299);
  }
// compiled string node returning strlit3299 (depth = 12)
  *var_mode = strlit3299;
  if (strlit3299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3301 == NULL) {
    strlit3301 = alloc_String("n");
    gc_root(strlit3301);
  }
// compiled string node returning strlit3301 (depth = 12)
  *var_newmode = strlit3301;
  if (strlit3301 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit3303 == NULL) {
    strlit3303 = alloc_String("");
    gc_root(strlit3303);
  }
// compiled string node returning strlit3303 (depth = 12)
  *var_accum = strlit3303;
  if (strlit3303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 12)
  Object bool3305 = alloc_Boolean(0);
// compiled identifier node returning bool3305 (depth = 12)
  *var_instr = bool3305;
  if (bool3305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 13)
  Object num3308 = alloc_Float64(1);
// compiled num node returning num3308 (depth = 13)
  int op_slot_right_3307 = gc_frame_newslot(num3308);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_interpdepth (depth = 13)
  int op_slot_left_3307 = gc_frame_newslot(*var_interpdepth);
  params[0] = num3308;
  partcv[0] = 1;
  Object sum3310 = callmethod(*var_interpdepth, "+", 1, partcv, params);
// compiled op node returning sum3310 (depth = 12)
  *var_interpdepth = sum3310;
  if (sum3310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3275 = done;
  } else {
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 11)
// starting to compile op node (depth = 12)
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_c (depth = 13)
  int op_slot_right_3312 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_accum (depth = 13)
  int op_slot_left_3312 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3314 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3314 (depth = 12)
  *var_accum = opresult3314;
  if (opresult3314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 11)
    gc_frame_newslot(done);
    if3275 = done;
  }
// compiled if node returning if3275 (depth = 10)
    gc_frame_newslot(if3275);
    if3239 = if3275;
  }
// compiled if node returning if3239 (depth = 9)
    gc_frame_newslot(if3239);
    if3232 = if3239;
  }
// compiled if node returning if3232 (depth = 8)
    gc_frame_newslot(if3232);
    if3137 = if3232;
  }
// compiled if node returning if3137 (depth = 7)
    gc_frame_newslot(if3137);
    if2862 = if3137;
  } else {
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3319 == NULL) {
    strlit3319 = alloc_String("""\x0d""");
    gc_root(strlit3319);
  }
// compiled string node returning strlit3319 (depth = 10)
  int op_slot_right_3318 = gc_frame_newslot(strlit3319);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3318 = gc_frame_newslot(*var_c);
  params[0] = strlit3319;
  partcv[0] = 1;
  Object opresult3321 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3321 (depth = 9)
  int op_slot_right_3317 = gc_frame_newslot(opresult3321);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3324 == NULL) {
    strlit3324 = alloc_String("""\x0a""");
    gc_root(strlit3324);
  }
// compiled string node returning strlit3324 (depth = 10)
  int op_slot_right_3323 = gc_frame_newslot(strlit3324);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_left_3323 = gc_frame_newslot(*var_c);
  params[0] = strlit3324;
  partcv[0] = 1;
  Object opresult3326 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3326 (depth = 9)
  int op_slot_left_3317 = gc_frame_newslot(opresult3326);
  params[0] = opresult3321;
  partcv[0] = 1;
  Object opresult3327 = callmethod(opresult3326, "||", 1, partcv, params);
// compiled op node returning opresult3327 (depth = 8)
  Object if3316 = done;
  if (istrue(opresult3327)) {
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3328 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_accum (depth = 9)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3329 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3328);
// compiled call node returning call3329 (depth = 8)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3330 == NULL) {
    strlit3330 = alloc_String("d");
    gc_root(strlit3330);
  }
// compiled string node returning strlit3330 (depth = 9)
  *var_mode = strlit3330;
  if (strlit3330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3332 == NULL) {
    strlit3332 = alloc_String("d");
    gc_root(strlit3332);
  }
// compiled string node returning strlit3332 (depth = 9)
  *var_newmode = strlit3332;
  if (strlit3332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit3334 == NULL) {
    strlit3334 = alloc_String("");
    gc_root(strlit3334);
  }
// compiled string node returning strlit3334 (depth = 9)
  *var_accum = strlit3334;
  if (strlit3334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3316 = done;
  } else {
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
  int op_slot_right_3336 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_accum (depth = 10)
  int op_slot_left_3336 = gc_frame_newslot(*var_accum);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult3338 = callmethod(*var_accum, "++", 1, partcv, params);
// compiled op node returning opresult3338 (depth = 9)
  *var_accum = opresult3338;
  if (opresult3338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if3316 = done;
  }
// compiled if node returning if3316 (depth = 7)
    gc_frame_newslot(if3316);
    if2862 = if3316;
  }
// compiled if node returning if2862 (depth = 6)
    gc_frame_newslot(if2862);
    if2778 = if2862;
  }
// compiled if node returning if2778 (depth = 5)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3342 == NULL) {
    strlit3342 = alloc_String("...");
    gc_root(strlit3342);
  }
// compiled string node returning strlit3342 (depth = 7)
  int op_slot_right_3341 = gc_frame_newslot(strlit3342);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_accum (depth = 7)
  int op_slot_left_3341 = gc_frame_newslot(*var_accum);
  params[0] = strlit3342;
  partcv[0] = 1;
  Object opresult3344 = callmethod(*var_accum, "==", 1, partcv, params);
// compiled op node returning opresult3344 (depth = 6)
  Object if3340 = done;
  if (istrue(opresult3344)) {
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3347 == NULL) {
    strlit3347 = alloc_String("o");
    gc_root(strlit3347);
  }
// compiled string node returning strlit3347 (depth = 8)
  int op_slot_right_3346 = gc_frame_newslot(strlit3347);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_3346 = gc_frame_newslot(*var_mode);
  params[0] = strlit3347;
  partcv[0] = 1;
  Object opresult3349 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3349 (depth = 7)
  Object if3345 = done;
  if (istrue(opresult3349)) {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3350 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  gc_frame_newslot(*var_tokens);
// starting to compile string node (depth = 8)
  if (strlit3351 == NULL) {
    strlit3351 = alloc_String("i");
    gc_root(strlit3351);
  }
// compiled string node returning strlit3351 (depth = 8)
  gc_frame_newslot(strlit3351);
// starting to compile string node (depth = 8)
  if (strlit3352 == NULL) {
    strlit3352 = alloc_String("...");
    gc_root(strlit3352);
  }
// compiled string node returning strlit3352 (depth = 8)
  gc_frame_newslot(strlit3352);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = strlit3351;
  params[2] = strlit3352;
  partcv[0] = 3;
  Object call3353 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3350);
// compiled call node returning call3353 (depth = 7)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3354 == NULL) {
    strlit3354 = alloc_String("n");
    gc_root(strlit3354);
  }
// compiled string node returning strlit3354 (depth = 8)
  *var_newmode = strlit3354;
  if (strlit3354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newmode (depth = 8)
  *var_mode = *var_newmode;
  if (*var_newmode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 8)
  if (strlit3357 == NULL) {
    strlit3357 = alloc_String("");
    gc_root(strlit3357);
  }
// compiled string node returning strlit3357 (depth = 8)
  *var_accum = strlit3357;
  if (strlit3357 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if3345 = done;
  } else {
  }
// compiled if node returning if3345 (depth = 6)
    gc_frame_newslot(if3345);
    if3340 = if3345;
  } else {
  }
// compiled if node returning if3340 (depth = 5)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3361 == NULL) {
    strlit3361 = alloc_String("""\x0a""");
    gc_root(strlit3361);
  }
// compiled string node returning strlit3361 (depth = 7)
  int op_slot_right_3360 = gc_frame_newslot(strlit3361);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_3360 = gc_frame_newslot(*var_c);
  params[0] = strlit3361;
  partcv[0] = 1;
  Object opresult3363 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3363 (depth = 6)
  Object if3359 = done;
  if (istrue(opresult3363)) {
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num3365 = alloc_Float64(1);
// compiled num node returning num3365 (depth = 8)
  int op_slot_right_3364 = gc_frame_newslot(num3365);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  int op_slot_left_3364 = gc_frame_newslot(*var_lineNumber);
  params[0] = num3365;
  partcv[0] = 1;
  Object sum3367 = callmethod(*var_lineNumber, "+", 1, partcv, params);
// compiled op node returning sum3367 (depth = 7)
  *var_lineNumber = sum3367;
  if (sum3367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num3369 = alloc_Float64(0);
// compiled num node returning num3369 (depth = 7)
  *var_linePosition = num3369;
  if (num3369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num3371 = alloc_Float64(1);
// compiled num node returning num3371 (depth = 7)
  *var_startPosition = num3371;
  if (num3371 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3359 = done;
  } else {
  }
// compiled if node returning if3359 (depth = 5)
  gc_frame_end(frame);
  return if3359;
}
Object meth_lexer__apply3376(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_mode = getfromclosure(closure, 1);
  Object *var_mainBlock = getfromclosure(closure, 2);
  Object *var_prev = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num3378 = alloc_Float64(1);
// compiled num node returning num3378 (depth = 7)
  int op_slot_right_3377 = gc_frame_newslot(num3378);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_linePosition (depth = 7)
  int op_slot_left_3377 = gc_frame_newslot(*var_linePosition);
  params[0] = num3378;
  partcv[0] = 1;
  Object sum3380 = callmethod(*var_linePosition, "+", 1, partcv, params);
// compiled op node returning sum3380 (depth = 6)
  *var_linePosition = sum3380;
  if (sum3380 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3384 == NULL) {
    strlit3384 = alloc_String(" ");
    gc_root(strlit3384);
  }
// compiled string node returning strlit3384 (depth = 7)
  int op_slot_right_3383 = gc_frame_newslot(strlit3384);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  int op_slot_left_3383 = gc_frame_newslot(*var_c);
  params[0] = strlit3384;
  partcv[0] = 1;
  Object opresult3386 = callmethod(*var_c, "==", 1, partcv, params);
// compiled op node returning opresult3386 (depth = 6)
  Object if3382 = done;
  if (istrue(opresult3386)) {
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3389 == NULL) {
    strlit3389 = alloc_String("d");
    gc_root(strlit3389);
  }
// compiled string node returning strlit3389 (depth = 8)
  int op_slot_right_3388 = gc_frame_newslot(strlit3389);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_mode (depth = 8)
  int op_slot_left_3388 = gc_frame_newslot(*var_mode);
  params[0] = strlit3389;
  partcv[0] = 1;
  Object opresult3391 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3391 (depth = 7)
  Object if3387 = done;
  if (istrue(opresult3391)) {
    gc_frame_newslot(done);
    if3387 = done;
  } else {
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3394 == NULL) {
    strlit3394 = alloc_String("n");
    gc_root(strlit3394);
  }
// compiled string node returning strlit3394 (depth = 9)
  int op_slot_right_3393 = gc_frame_newslot(strlit3394);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mode (depth = 9)
  int op_slot_left_3393 = gc_frame_newslot(*var_mode);
  params[0] = strlit3394;
  partcv[0] = 1;
  Object opresult3396 = callmethod(*var_mode, "!=", 1, partcv, params);
// compiled op node returning opresult3396 (depth = 8)
  Object if3392 = done;
  if (istrue(opresult3396)) {
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3397 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_c (depth = 9)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mainBlock (depth = 9)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3398 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3397);
// compiled call node returning call3398 (depth = 8)
    gc_frame_newslot(call3398);
    if3392 = call3398;
  } else {
  }
// compiled if node returning if3392 (depth = 7)
    gc_frame_newslot(if3392);
    if3387 = if3392;
  }
// compiled if node returning if3387 (depth = 6)
    gc_frame_newslot(if3387);
    if3382 = if3387;
  } else {
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3399 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_c (depth = 7)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_mainBlock (depth = 7)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call3400 = callmethod(*var_mainBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe3399);
// compiled call node returning call3400 (depth = 6)
    gc_frame_newslot(call3400);
    if3382 = call3400;
  }
// compiled if node returning if3382 (depth = 5)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_c (depth = 6)
  *var_prev = *var_c;
  if (*var_c == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_lexer_lexinput1750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(28, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lexinput");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lexinput");
  Object params[14];
  int partcv[3];
  Object *var_linePosition = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object *var_startPosition = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lexinput (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_input = &(stackframe->slots[0]);
  *var_input = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for lexinput");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tokens");
  Object *var_mode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "mode");
  Object *var_newmode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newmode");
  Object *var_instr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "instr");
  Object *var_inBackticks = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "inBackticks");
  Object *var_backtickIdent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "backtickIdent");
  Object *var_accum = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "accum");
  Object *var_escaped = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "escaped");
  Object *var_prev = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prev");
  Object *var_unichars = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "unichars");
  Object *var_codepoint = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "codepoint");
  Object *var_interpdepth = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "interpdepth");
  Object *var_interpString = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "interpString");
  Object *var_atStart = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "atStart");
  Object *var_badSeparator = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "badSeparator");
  Object *var_badControl = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "badControl");
  Object *var_selfModes = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "selfModes");
  Object *var_brackets = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "brackets");
  Object *var_identifierChar = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "identifierChar");
  Object *var_digit = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "digit");
  Object *var_digitB = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "digitB");
  Object *var_operatorChar = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "operatorChar");
  Object *var_iGTLT = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "iGTLT");
  Object *var_notcp = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "notcp");
  Object *var_mainBlock = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "mainBlock");
  Object *var_suggestion = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "suggestion");
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile object node (depth = 4)
  Object inheritingObject1751 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1751 = alloc_userobj2(13,11, objclass1751);
  gc_frame_newslot(obj1751);
// OBJECT OUTER DEC outer
  adddatum2(obj1751, self, 0);
  addmethodreal(obj1751,"outer", &reader_lexer_outer_1752);
  Object oldself1751 = self;
  struct StackFrameObject *oldstackframe1751 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1751);
  gc_frame_newslot((Object)stackframe);
  self = obj1751;
  Object *oldselfslot1751 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1751 = (*(struct UserObject *)self).data[0], lowerouter1751 = thisouter1751;
  if (inheritingObject1751) {
    struct UserObject *inho1751 = (struct UserObject *)inheritingObject1751;
    while (inho1751->super != GraceDefaultObject) inho1751 = (struct UserObject *)inho1751->super;
    inho1751->super = obj1751;
    self = inheritingObject1751;
    *selfslot = self;
    lowerouter1751 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1751;
  }
if (objclass1751 == NULL) {
  Method *reader1753 = addmethodrealflags(obj1751, "first",&reader_lexer_first_1753, 0);
  Method *writer1753 = addmethodrealflags(obj1751, "first:=",&writer_lexer_first_1753, 0);
  reader1753->definitionModule = modulename;
  writer1753->definitionModule = modulename;
  reader1753->definitionLine = 535;
  writer1753->definitionLine = 535;
}
obj1751->flags |= OFLAG_MUTABLE;
adddatum2(obj1751, alloc_Undefined(), 1);
if (objclass1751 == NULL) {
  Method *reader1754 = addmethodrealflags(obj1751, "last",&reader_lexer_last_1754, 0);
  Method *writer1754 = addmethodrealflags(obj1751, "last:=",&writer_lexer_last_1754, 0);
  reader1754->definitionModule = modulename;
  writer1754->definitionModule = modulename;
  reader1754->definitionLine = 536;
  writer1754->definitionLine = 536;
}
obj1751->flags |= OFLAG_MUTABLE;
adddatum2(obj1751, alloc_Undefined(), 2);
if (objclass1751 == NULL) {
  Method *reader1755 = addmethodrealflags(obj1751, "size'",&reader_lexer_size_39__1755, 0);
  Method *writer1755 = addmethodrealflags(obj1751, "size':=",&writer_lexer_size_39__1755, 0);
  reader1755->definitionModule = modulename;
  writer1755->definitionModule = modulename;
  reader1755->definitionLine = 538;
  writer1755->definitionLine = 538;
}
obj1751->flags |= OFLAG_MUTABLE;
adddatum2(obj1751, alloc_Undefined(), 3);
// method push
  struct UserObject *uo1756 = (struct UserObject*)obj1751;
  uo1756->data[4] = emptyclosure;
  Method *meth_meth_lexer_push1756 = addmethod2pos(obj1751, "push", &meth_lexer_push1756, 4);
  int argcv_meth_lexer_push1756[] = {1};
  meth_meth_lexer_push1756->type = alloc_MethodType(1, argcv_meth_lexer_push1756);
  meth_meth_lexer_push1756->definitionModule = modulename;
  meth_meth_lexer_push1756->definitionLine = 538;
// method pop
  struct UserObject *uo1786 = (struct UserObject*)obj1751;
  uo1786->data[5] = emptyclosure;
  Method *meth_meth_lexer_pop1786 = addmethod2pos(obj1751, "pop", &meth_lexer_pop1786, 5);
  int argcv_meth_lexer_pop1786[] = {0};
  meth_meth_lexer_pop1786->type = alloc_MethodType(1, argcv_meth_lexer_pop1786);
  meth_meth_lexer_pop1786->definitionModule = modulename;
  meth_meth_lexer_pop1786->definitionLine = 550;
// method poll
  struct UserObject *uo1820 = (struct UserObject*)obj1751;
  uo1820->data[6] = emptyclosure;
  Method *meth_meth_lexer_poll1820 = addmethod2pos(obj1751, "poll", &meth_lexer_poll1820, 6);
  int argcv_meth_lexer_poll1820[] = {0};
  meth_meth_lexer_poll1820->type = alloc_MethodType(1, argcv_meth_lexer_poll1820);
  meth_meth_lexer_poll1820->definitionModule = modulename;
  meth_meth_lexer_poll1820->definitionLine = 562;
// method size
  struct UserObject *uo1854 = (struct UserObject*)obj1751;
  uo1854->data[7] = emptyclosure;
  Method *meth_meth_lexer_size1854 = addmethod2pos(obj1751, "size", &meth_lexer_size1854, 7);
  int argcv_meth_lexer_size1854[] = {0};
  meth_meth_lexer_size1854->type = alloc_MethodType(1, argcv_meth_lexer_size1854);
  meth_meth_lexer_size1854->definitionModule = modulename;
  meth_meth_lexer_size1854->definitionLine = 574;
// method iter
  struct UserObject *uo1861 = (struct UserObject*)obj1751;
  uo1861->data[8] = emptyclosure;
  Method *meth_meth_lexer_iter1861 = addmethod2pos(obj1751, "iter", &meth_lexer_iter1861, 8);
  int argcv_meth_lexer_iter1861[] = {0};
  meth_meth_lexer_iter1861->type = alloc_MethodType(1, argcv_meth_lexer_iter1861);
  meth_meth_lexer_iter1861->definitionModule = modulename;
  meth_meth_lexer_iter1861->definitionLine = 578;
  Method *meth_meth_lexer_iter1861_object = addmethod2pos(obj1751, "iter()object", &meth_lexer_iter1861_object, 8);
  int argcv_meth_lexer_iter1861_object[] = {0};
  meth_meth_lexer_iter1861_object->type = alloc_MethodType(1, argcv_meth_lexer_iter1861_object);
  meth_meth_lexer_iter1861_object->definitionModule = modulename;
  meth_meth_lexer_iter1861_object->definitionLine = 578;
// method iterator
  struct UserObject *uo1893 = (struct UserObject*)obj1751;
  uo1893->data[9] = emptyclosure;
  Method *meth_meth_lexer_iterator1893 = addmethod2pos(obj1751, "iterator", &meth_lexer_iterator1893, 9);
  int argcv_meth_lexer_iterator1893[] = {0};
  meth_meth_lexer_iterator1893->type = alloc_MethodType(1, argcv_meth_lexer_iterator1893);
  meth_meth_lexer_iterator1893->definitionModule = modulename;
  meth_meth_lexer_iterator1893->definitionLine = 595;
  sourceObject = obj1751;
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1896 = alloc_Boolean(0);
// compiled identifier node returning bool1896 (depth = 5)
  adddatum2(obj1751, bool1896, 1);
  sourceObject = obj1751;
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1897 = alloc_Boolean(0);
// compiled identifier node returning bool1897 (depth = 5)
  adddatum2(obj1751, bool1897, 2);
  sourceObject = obj1751;
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1898 = alloc_Float64(0);
// compiled num node returning num1898 (depth = 5)
  adddatum2(obj1751, num1898, 3);
  sourceObject = obj1751;
  sourceObject = obj1751;
  sourceObject = obj1751;
  sourceObject = obj1751;
  sourceObject = obj1751;
  sourceObject = obj1751;
objclass1751 = obj1751->class;
  objclass1751->definitionModule = modulename;
  objclass1751->definitionLine = 533;
  (*(struct UserObject *)self).data[0] = lowerouter1751;
  self = oldself1751;
  selfslot = oldselfslot1751;
  stackframe = oldstackframe1751;
// compiled object node returning obj1751 (depth = 4)
  *var_tokens = obj1751;
  if (obj1751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1899 == NULL) {
    strlit1899 = alloc_String("d");
    gc_root(strlit1899);
  }
// compiled string node returning strlit1899 (depth = 4)
  *var_mode = strlit1899;
  if (strlit1899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mode (depth = 4)
  *var_newmode = *var_mode;
  if (*var_mode == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1900 = alloc_Boolean(0);
// compiled identifier node returning bool1900 (depth = 4)
  *var_instr = bool1900;
  if (bool1900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1901 = alloc_Boolean(0);
// compiled identifier node returning bool1901 (depth = 4)
  *var_inBackticks = bool1901;
  if (bool1901 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1902 = alloc_Boolean(0);
// compiled identifier node returning bool1902 (depth = 4)
  *var_backtickIdent = bool1902;
  if (bool1902 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1903 == NULL) {
    strlit1903 = alloc_String("");
    gc_root(strlit1903);
  }
// compiled string node returning strlit1903 (depth = 4)
  *var_accum = strlit1903;
  if (strlit1903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1904 = alloc_Boolean(0);
// compiled identifier node returning bool1904 (depth = 4)
  *var_escaped = bool1904;
  if (bool1904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit1905 == NULL) {
    strlit1905 = alloc_String("");
    gc_root(strlit1905);
  }
// compiled string node returning strlit1905 (depth = 4)
  *var_prev = strlit1905;
  if (strlit1905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1906 = alloc_Float64(0);
// compiled num node returning num1906 (depth = 4)
  *var_unichars = num1906;
  if (num1906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1907 = alloc_Float64(0);
// compiled num node returning num1907 (depth = 4)
  *var_codepoint = num1907;
  if (num1907 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1908 = alloc_Float64(0);
// compiled num node returning num1908 (depth = 4)
  *var_interpdepth = num1908;
  if (num1908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1909 = alloc_Boolean(0);
// compiled identifier node returning bool1909 (depth = 4)
  *var_interpString = bool1909;
  if (bool1909 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1910 = alloc_Boolean(1);
// compiled identifier node returning bool1910 (depth = 4)
  *var_atStart = bool1910;
  if (bool1910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1911 = alloc_Float64(0);
// compiled num node returning num1911 (depth = 4)
  *var_linePosition = num1911;
  if (num1911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1913 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1914 == NULL) {
    strlit1914 = alloc_String("lexing.");
    gc_root(strlit1914);
  }
// compiled string node returning strlit1914 (depth = 4)
  gc_frame_newslot(strlit1914);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = strlit1914;
  partcv[0] = 1;
  Object call1915 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe1913);
// compiled call node returning call1915 (depth = 3)
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1916 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1917 == NULL) {
    strlit1917 = alloc_String("Z");
    gc_root(strlit1917);
  }
// compiled string node returning strlit1917 (depth = 5)
  gc_frame_newslot(strlit1917);
// starting to compile num node (depth = 5)
  Object num1918 = alloc_Float64(9);
// compiled num node returning num1918 (depth = 5)
  gc_frame_newslot(num1918);
// starting to compile num node (depth = 5)
  Object num1919 = alloc_Float64(32);
// compiled num node returning num1919 (depth = 5)
  gc_frame_newslot(num1919);
// starting to compile num node (depth = 5)
  Object num1920 = alloc_Float64(8232);
// compiled num node returning num1920 (depth = 5)
  gc_frame_newslot(num1920);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit1917;
  params[1] = num1918;
  params[2] = num1919;
  params[3] = num1920;
  partcv[0] = 2;
  partcv[1] = 2;
  Object call1921 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe1916);
// compiled call node returning call1921 (depth = 4)
  *var_badSeparator = call1921;
  if (call1921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1922 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1923 == NULL) {
    strlit1923 = alloc_String("C");
    gc_root(strlit1923);
  }
// compiled string node returning strlit1923 (depth = 5)
  gc_frame_newslot(strlit1923);
// starting to compile num node (depth = 5)
  Object num1924 = alloc_Float64(10);
// compiled num node returning num1924 (depth = 5)
  gc_frame_newslot(num1924);
// starting to compile num node (depth = 5)
  Object num1925 = alloc_Float64(13);
// compiled num node returning num1925 (depth = 5)
  gc_frame_newslot(num1925);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit1923;
  params[1] = num1924;
  params[2] = num1925;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call1926 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe1922);
// compiled call node returning call1926 (depth = 4)
  *var_badControl = call1926;
  if (call1926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1927 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1928 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1929 == NULL) {
    strlit1929 = alloc_String("(");
    gc_root(strlit1929);
  }
// compiled string node returning strlit1929 (depth = 7)
  partcv[0] = 0;
  Object call1930 = callmethod(strlit1929, "ord",
    1, partcv, params);
  gc_frame_end(callframe1928);
// compiled call node returning call1930 (depth = 6)
// compiled member node returning call1930 (depth = 5)
  gc_frame_newslot(call1930);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1931 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1932 == NULL) {
    strlit1932 = alloc_String(")");
    gc_root(strlit1932);
  }
// compiled string node returning strlit1932 (depth = 7)
  partcv[0] = 0;
  Object call1933 = callmethod(strlit1932, "ord",
    1, partcv, params);
  gc_frame_end(callframe1931);
// compiled call node returning call1933 (depth = 6)
// compiled member node returning call1933 (depth = 5)
  gc_frame_newslot(call1933);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1934 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1935 == NULL) {
    strlit1935 = alloc_String(",");
    gc_root(strlit1935);
  }
// compiled string node returning strlit1935 (depth = 7)
  partcv[0] = 0;
  Object call1936 = callmethod(strlit1935, "ord",
    1, partcv, params);
  gc_frame_end(callframe1934);
// compiled call node returning call1936 (depth = 6)
// compiled member node returning call1936 (depth = 5)
  gc_frame_newslot(call1936);
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1937 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1938 == NULL) {
    strlit1938 = alloc_String(".");
    gc_root(strlit1938);
  }
// compiled string node returning strlit1938 (depth = 7)
  partcv[0] = 0;
  Object call1939 = callmethod(strlit1938, "ord",
    1, partcv, params);
  gc_frame_end(callframe1937);
// compiled call node returning call1939 (depth = 6)
// compiled member node returning call1939 (depth = 5)
  gc_frame_newslot(call1939);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1940 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1941 == NULL) {
    strlit1941 = alloc_String("{");
    gc_root(strlit1941);
  }
// compiled string node returning strlit1941 (depth = 7)
  partcv[0] = 0;
  Object call1942 = callmethod(strlit1941, "ord",
    1, partcv, params);
  gc_frame_end(callframe1940);
// compiled call node returning call1942 (depth = 6)
// compiled member node returning call1942 (depth = 5)
  gc_frame_newslot(call1942);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1943 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1944 == NULL) {
    strlit1944 = alloc_String("}");
    gc_root(strlit1944);
  }
// compiled string node returning strlit1944 (depth = 7)
  partcv[0] = 0;
  Object call1945 = callmethod(strlit1944, "ord",
    1, partcv, params);
  gc_frame_end(callframe1943);
// compiled call node returning call1945 (depth = 6)
// compiled member node returning call1945 (depth = 5)
  gc_frame_newslot(call1945);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1946 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1947 == NULL) {
    strlit1947 = alloc_String("[");
    gc_root(strlit1947);
  }
// compiled string node returning strlit1947 (depth = 7)
  partcv[0] = 0;
  Object call1948 = callmethod(strlit1947, "ord",
    1, partcv, params);
  gc_frame_end(callframe1946);
// compiled call node returning call1948 (depth = 6)
// compiled member node returning call1948 (depth = 5)
  gc_frame_newslot(call1948);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1949 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1950 == NULL) {
    strlit1950 = alloc_String("]");
    gc_root(strlit1950);
  }
// compiled string node returning strlit1950 (depth = 7)
  partcv[0] = 0;
  Object call1951 = callmethod(strlit1950, "ord",
    1, partcv, params);
  gc_frame_end(callframe1949);
// compiled call node returning call1951 (depth = 6)
// compiled member node returning call1951 (depth = 5)
  gc_frame_newslot(call1951);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1952 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1953 == NULL) {
    strlit1953 = alloc_String(";");
    gc_root(strlit1953);
  }
// compiled string node returning strlit1953 (depth = 7)
  partcv[0] = 0;
  Object call1954 = callmethod(strlit1953, "ord",
    1, partcv, params);
  gc_frame_end(callframe1952);
// compiled call node returning call1954 (depth = 6)
// compiled member node returning call1954 (depth = 5)
  gc_frame_newslot(call1954);
// call case 6: other member request
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call1930;
  params[1] = call1933;
  params[2] = call1936;
  params[3] = call1939;
  params[4] = call1942;
  params[5] = call1945;
  params[6] = call1948;
  params[7] = call1951;
  params[8] = call1954;
  partcv[0] = 9;
  Object call1955 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe1927);
// compiled call node returning call1955 (depth = 4)
  *var_selfModes = call1955;
  if (call1955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1956 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1957 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1958 == NULL) {
    strlit1958 = alloc_String("(");
    gc_root(strlit1958);
  }
// compiled string node returning strlit1958 (depth = 7)
  partcv[0] = 0;
  Object call1959 = callmethod(strlit1958, "ord",
    1, partcv, params);
  gc_frame_end(callframe1957);
// compiled call node returning call1959 (depth = 6)
// compiled member node returning call1959 (depth = 5)
  gc_frame_newslot(call1959);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1960 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1961 == NULL) {
    strlit1961 = alloc_String(")");
    gc_root(strlit1961);
  }
// compiled string node returning strlit1961 (depth = 7)
  partcv[0] = 0;
  Object call1962 = callmethod(strlit1961, "ord",
    1, partcv, params);
  gc_frame_end(callframe1960);
// compiled call node returning call1962 (depth = 6)
// compiled member node returning call1962 (depth = 5)
  gc_frame_newslot(call1962);
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1963 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1964 == NULL) {
    strlit1964 = alloc_String("{");
    gc_root(strlit1964);
  }
// compiled string node returning strlit1964 (depth = 7)
  partcv[0] = 0;
  Object call1965 = callmethod(strlit1964, "ord",
    1, partcv, params);
  gc_frame_end(callframe1963);
// compiled call node returning call1965 (depth = 6)
// compiled member node returning call1965 (depth = 5)
  gc_frame_newslot(call1965);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1966 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1967 == NULL) {
    strlit1967 = alloc_String("}");
    gc_root(strlit1967);
  }
// compiled string node returning strlit1967 (depth = 7)
  partcv[0] = 0;
  Object call1968 = callmethod(strlit1967, "ord",
    1, partcv, params);
  gc_frame_end(callframe1966);
// compiled call node returning call1968 (depth = 6)
// compiled member node returning call1968 (depth = 5)
  gc_frame_newslot(call1968);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1969 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1970 == NULL) {
    strlit1970 = alloc_String("[");
    gc_root(strlit1970);
  }
// compiled string node returning strlit1970 (depth = 7)
  partcv[0] = 0;
  Object call1971 = callmethod(strlit1970, "ord",
    1, partcv, params);
  gc_frame_end(callframe1969);
// compiled call node returning call1971 (depth = 6)
// compiled member node returning call1971 (depth = 5)
  gc_frame_newslot(call1971);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1972 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1973 == NULL) {
    strlit1973 = alloc_String("]");
    gc_root(strlit1973);
  }
// compiled string node returning strlit1973 (depth = 7)
  partcv[0] = 0;
  Object call1974 = callmethod(strlit1973, "ord",
    1, partcv, params);
  gc_frame_end(callframe1972);
// compiled call node returning call1974 (depth = 6)
// compiled member node returning call1974 (depth = 5)
  gc_frame_newslot(call1974);
// call case 6: other member request
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call1959;
  params[1] = call1962;
  params[2] = call1965;
  params[3] = call1968;
  params[4] = call1971;
  params[5] = call1974;
  partcv[0] = 6;
  Object call1975 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe1956);
// compiled call node returning call1975 (depth = 4)
  *var_brackets = call1975;
  if (call1975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1976 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1977 == NULL) {
    strlit1977 = alloc_String("L");
    gc_root(strlit1977);
  }
// compiled string node returning strlit1977 (depth = 5)
  gc_frame_newslot(strlit1977);
// starting to compile string node (depth = 5)
  if (strlit1978 == NULL) {
    strlit1978 = alloc_String("N");
    gc_root(strlit1978);
  }
// compiled string node returning strlit1978 (depth = 5)
  gc_frame_newslot(strlit1978);
// starting to compile num node (depth = 5)
  Object num1979 = alloc_Float64(95);
// compiled num node returning num1979 (depth = 5)
  gc_frame_newslot(num1979);
// starting to compile num node (depth = 5)
  Object num1980 = alloc_Float64(39);
// compiled num node returning num1980 (depth = 5)
  gc_frame_newslot(num1980);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit1977;
  params[1] = strlit1978;
  params[2] = num1979;
  params[3] = num1980;
  partcv[0] = 4;
  Object call1981 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe1976);
// compiled call node returning call1981 (depth = 4)
  *var_identifierChar = call1981;
  if (call1981 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1982 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1983 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1984 == NULL) {
    strlit1984 = alloc_String("0");
    gc_root(strlit1984);
  }
// compiled string node returning strlit1984 (depth = 7)
  partcv[0] = 0;
  Object call1985 = callmethod(strlit1984, "ord",
    1, partcv, params);
  gc_frame_end(callframe1983);
// compiled call node returning call1985 (depth = 6)
// compiled member node returning call1985 (depth = 5)
  gc_frame_newslot(call1985);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1986 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1987 == NULL) {
    strlit1987 = alloc_String("1");
    gc_root(strlit1987);
  }
// compiled string node returning strlit1987 (depth = 7)
  partcv[0] = 0;
  Object call1988 = callmethod(strlit1987, "ord",
    1, partcv, params);
  gc_frame_end(callframe1986);
// compiled call node returning call1988 (depth = 6)
// compiled member node returning call1988 (depth = 5)
  gc_frame_newslot(call1988);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1989 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1990 == NULL) {
    strlit1990 = alloc_String("2");
    gc_root(strlit1990);
  }
// compiled string node returning strlit1990 (depth = 7)
  partcv[0] = 0;
  Object call1991 = callmethod(strlit1990, "ord",
    1, partcv, params);
  gc_frame_end(callframe1989);
// compiled call node returning call1991 (depth = 6)
// compiled member node returning call1991 (depth = 5)
  gc_frame_newslot(call1991);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1992 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1993 == NULL) {
    strlit1993 = alloc_String("3");
    gc_root(strlit1993);
  }
// compiled string node returning strlit1993 (depth = 7)
  partcv[0] = 0;
  Object call1994 = callmethod(strlit1993, "ord",
    1, partcv, params);
  gc_frame_end(callframe1992);
// compiled call node returning call1994 (depth = 6)
// compiled member node returning call1994 (depth = 5)
  gc_frame_newslot(call1994);
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1995 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1996 == NULL) {
    strlit1996 = alloc_String("4");
    gc_root(strlit1996);
  }
// compiled string node returning strlit1996 (depth = 7)
  partcv[0] = 0;
  Object call1997 = callmethod(strlit1996, "ord",
    1, partcv, params);
  gc_frame_end(callframe1995);
// compiled call node returning call1997 (depth = 6)
// compiled member node returning call1997 (depth = 5)
  gc_frame_newslot(call1997);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1998 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit1999 == NULL) {
    strlit1999 = alloc_String("5");
    gc_root(strlit1999);
  }
// compiled string node returning strlit1999 (depth = 7)
  partcv[0] = 0;
  Object call2000 = callmethod(strlit1999, "ord",
    1, partcv, params);
  gc_frame_end(callframe1998);
// compiled call node returning call2000 (depth = 6)
// compiled member node returning call2000 (depth = 5)
  gc_frame_newslot(call2000);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2001 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2002 == NULL) {
    strlit2002 = alloc_String("6");
    gc_root(strlit2002);
  }
// compiled string node returning strlit2002 (depth = 7)
  partcv[0] = 0;
  Object call2003 = callmethod(strlit2002, "ord",
    1, partcv, params);
  gc_frame_end(callframe2001);
// compiled call node returning call2003 (depth = 6)
// compiled member node returning call2003 (depth = 5)
  gc_frame_newslot(call2003);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2004 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2005 == NULL) {
    strlit2005 = alloc_String("7");
    gc_root(strlit2005);
  }
// compiled string node returning strlit2005 (depth = 7)
  partcv[0] = 0;
  Object call2006 = callmethod(strlit2005, "ord",
    1, partcv, params);
  gc_frame_end(callframe2004);
// compiled call node returning call2006 (depth = 6)
// compiled member node returning call2006 (depth = 5)
  gc_frame_newslot(call2006);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2007 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2008 == NULL) {
    strlit2008 = alloc_String("8");
    gc_root(strlit2008);
  }
// compiled string node returning strlit2008 (depth = 7)
  partcv[0] = 0;
  Object call2009 = callmethod(strlit2008, "ord",
    1, partcv, params);
  gc_frame_end(callframe2007);
// compiled call node returning call2009 (depth = 6)
// compiled member node returning call2009 (depth = 5)
  gc_frame_newslot(call2009);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2010 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2011 == NULL) {
    strlit2011 = alloc_String("9");
    gc_root(strlit2011);
  }
// compiled string node returning strlit2011 (depth = 7)
  partcv[0] = 0;
  Object call2012 = callmethod(strlit2011, "ord",
    1, partcv, params);
  gc_frame_end(callframe2010);
// compiled call node returning call2012 (depth = 6)
// compiled member node returning call2012 (depth = 5)
  gc_frame_newslot(call2012);
// call case 6: other member request
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call1985;
  params[1] = call1988;
  params[2] = call1991;
  params[3] = call1994;
  params[4] = call1997;
  params[5] = call2000;
  params[6] = call2003;
  params[7] = call2006;
  params[8] = call2009;
  params[9] = call2012;
  partcv[0] = 10;
  Object call2013 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe1982);
// compiled call node returning call2013 (depth = 4)
  *var_digit = call2013;
  if (call2013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2014 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2015 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2016 == NULL) {
    strlit2016 = alloc_String("0");
    gc_root(strlit2016);
  }
// compiled string node returning strlit2016 (depth = 7)
  partcv[0] = 0;
  Object call2017 = callmethod(strlit2016, "ord",
    1, partcv, params);
  gc_frame_end(callframe2015);
// compiled call node returning call2017 (depth = 6)
// compiled member node returning call2017 (depth = 5)
  gc_frame_newslot(call2017);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2018 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2019 == NULL) {
    strlit2019 = alloc_String("1");
    gc_root(strlit2019);
  }
// compiled string node returning strlit2019 (depth = 7)
  partcv[0] = 0;
  Object call2020 = callmethod(strlit2019, "ord",
    1, partcv, params);
  gc_frame_end(callframe2018);
// compiled call node returning call2020 (depth = 6)
// compiled member node returning call2020 (depth = 5)
  gc_frame_newslot(call2020);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2021 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2022 == NULL) {
    strlit2022 = alloc_String("2");
    gc_root(strlit2022);
  }
// compiled string node returning strlit2022 (depth = 7)
  partcv[0] = 0;
  Object call2023 = callmethod(strlit2022, "ord",
    1, partcv, params);
  gc_frame_end(callframe2021);
// compiled call node returning call2023 (depth = 6)
// compiled member node returning call2023 (depth = 5)
  gc_frame_newslot(call2023);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2024 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2025 == NULL) {
    strlit2025 = alloc_String("3");
    gc_root(strlit2025);
  }
// compiled string node returning strlit2025 (depth = 7)
  partcv[0] = 0;
  Object call2026 = callmethod(strlit2025, "ord",
    1, partcv, params);
  gc_frame_end(callframe2024);
// compiled call node returning call2026 (depth = 6)
// compiled member node returning call2026 (depth = 5)
  gc_frame_newslot(call2026);
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2027 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2028 == NULL) {
    strlit2028 = alloc_String("4");
    gc_root(strlit2028);
  }
// compiled string node returning strlit2028 (depth = 7)
  partcv[0] = 0;
  Object call2029 = callmethod(strlit2028, "ord",
    1, partcv, params);
  gc_frame_end(callframe2027);
// compiled call node returning call2029 (depth = 6)
// compiled member node returning call2029 (depth = 5)
  gc_frame_newslot(call2029);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2030 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2031 == NULL) {
    strlit2031 = alloc_String("5");
    gc_root(strlit2031);
  }
// compiled string node returning strlit2031 (depth = 7)
  partcv[0] = 0;
  Object call2032 = callmethod(strlit2031, "ord",
    1, partcv, params);
  gc_frame_end(callframe2030);
// compiled call node returning call2032 (depth = 6)
// compiled member node returning call2032 (depth = 5)
  gc_frame_newslot(call2032);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2033 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2034 == NULL) {
    strlit2034 = alloc_String("6");
    gc_root(strlit2034);
  }
// compiled string node returning strlit2034 (depth = 7)
  partcv[0] = 0;
  Object call2035 = callmethod(strlit2034, "ord",
    1, partcv, params);
  gc_frame_end(callframe2033);
// compiled call node returning call2035 (depth = 6)
// compiled member node returning call2035 (depth = 5)
  gc_frame_newslot(call2035);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2036 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2037 == NULL) {
    strlit2037 = alloc_String("7");
    gc_root(strlit2037);
  }
// compiled string node returning strlit2037 (depth = 7)
  partcv[0] = 0;
  Object call2038 = callmethod(strlit2037, "ord",
    1, partcv, params);
  gc_frame_end(callframe2036);
// compiled call node returning call2038 (depth = 6)
// compiled member node returning call2038 (depth = 5)
  gc_frame_newslot(call2038);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2039 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2040 == NULL) {
    strlit2040 = alloc_String("8");
    gc_root(strlit2040);
  }
// compiled string node returning strlit2040 (depth = 7)
  partcv[0] = 0;
  Object call2041 = callmethod(strlit2040, "ord",
    1, partcv, params);
  gc_frame_end(callframe2039);
// compiled call node returning call2041 (depth = 6)
// compiled member node returning call2041 (depth = 5)
  gc_frame_newslot(call2041);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2042 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2043 == NULL) {
    strlit2043 = alloc_String("9");
    gc_root(strlit2043);
  }
// compiled string node returning strlit2043 (depth = 7)
  partcv[0] = 0;
  Object call2044 = callmethod(strlit2043, "ord",
    1, partcv, params);
  gc_frame_end(callframe2042);
// compiled call node returning call2044 (depth = 6)
// compiled member node returning call2044 (depth = 5)
  gc_frame_newslot(call2044);
// call case 6: other member request
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call2017;
  params[1] = call2020;
  params[2] = call2023;
  params[3] = call2026;
  params[4] = call2029;
  params[5] = call2032;
  params[6] = call2035;
  params[7] = call2038;
  params[8] = call2041;
  params[9] = call2044;
  partcv[0] = 10;
  Object call2045 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2014);
// compiled call node returning call2045 (depth = 4)
  *var_digitB = call2045;
  if (call2045 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2046 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit2047 == NULL) {
    strlit2047 = alloc_String("Sm");
    gc_root(strlit2047);
  }
// compiled string node returning strlit2047 (depth = 5)
  gc_frame_newslot(strlit2047);
// starting to compile string node (depth = 5)
  if (strlit2048 == NULL) {
    strlit2048 = alloc_String("So");
    gc_root(strlit2048);
  }
// compiled string node returning strlit2048 (depth = 5)
  gc_frame_newslot(strlit2048);
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2049 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2050 == NULL) {
    strlit2050 = alloc_String("-");
    gc_root(strlit2050);
  }
// compiled string node returning strlit2050 (depth = 7)
  partcv[0] = 0;
  Object call2051 = callmethod(strlit2050, "ord",
    1, partcv, params);
  gc_frame_end(callframe2049);
// compiled call node returning call2051 (depth = 6)
// compiled member node returning call2051 (depth = 5)
  gc_frame_newslot(call2051);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2052 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2053 == NULL) {
    strlit2053 = alloc_String("&");
    gc_root(strlit2053);
  }
// compiled string node returning strlit2053 (depth = 7)
  partcv[0] = 0;
  Object call2054 = callmethod(strlit2053, "ord",
    1, partcv, params);
  gc_frame_end(callframe2052);
// compiled call node returning call2054 (depth = 6)
// compiled member node returning call2054 (depth = 5)
  gc_frame_newslot(call2054);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2055 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2056 == NULL) {
    strlit2056 = alloc_String("|");
    gc_root(strlit2056);
  }
// compiled string node returning strlit2056 (depth = 7)
  partcv[0] = 0;
  Object call2057 = callmethod(strlit2056, "ord",
    1, partcv, params);
  gc_frame_end(callframe2055);
// compiled call node returning call2057 (depth = 6)
// compiled member node returning call2057 (depth = 5)
  gc_frame_newslot(call2057);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2058 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2059 == NULL) {
    strlit2059 = alloc_String(":");
    gc_root(strlit2059);
  }
// compiled string node returning strlit2059 (depth = 7)
  partcv[0] = 0;
  Object call2060 = callmethod(strlit2059, "ord",
    1, partcv, params);
  gc_frame_end(callframe2058);
// compiled call node returning call2060 (depth = 6)
// compiled member node returning call2060 (depth = 5)
  gc_frame_newslot(call2060);
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2061 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2062 == NULL) {
    strlit2062 = alloc_String("%");
    gc_root(strlit2062);
  }
// compiled string node returning strlit2062 (depth = 7)
  partcv[0] = 0;
  Object call2063 = callmethod(strlit2062, "ord",
    1, partcv, params);
  gc_frame_end(callframe2061);
// compiled call node returning call2063 (depth = 6)
// compiled member node returning call2063 (depth = 5)
  gc_frame_newslot(call2063);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2064 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2065 == NULL) {
    strlit2065 = alloc_String("^");
    gc_root(strlit2065);
  }
// compiled string node returning strlit2065 (depth = 7)
  partcv[0] = 0;
  Object call2066 = callmethod(strlit2065, "ord",
    1, partcv, params);
  gc_frame_end(callframe2064);
// compiled call node returning call2066 (depth = 6)
// compiled member node returning call2066 (depth = 5)
  gc_frame_newslot(call2066);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2067 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2068 == NULL) {
    strlit2068 = alloc_String("@");
    gc_root(strlit2068);
  }
// compiled string node returning strlit2068 (depth = 7)
  partcv[0] = 0;
  Object call2069 = callmethod(strlit2068, "ord",
    1, partcv, params);
  gc_frame_end(callframe2067);
// compiled call node returning call2069 (depth = 6)
// compiled member node returning call2069 (depth = 5)
  gc_frame_newslot(call2069);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2070 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2071 == NULL) {
    strlit2071 = alloc_String("?");
    gc_root(strlit2071);
  }
// compiled string node returning strlit2071 (depth = 7)
  partcv[0] = 0;
  Object call2072 = callmethod(strlit2071, "ord",
    1, partcv, params);
  gc_frame_end(callframe2070);
// compiled call node returning call2072 (depth = 6)
// compiled member node returning call2072 (depth = 5)
  gc_frame_newslot(call2072);
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2073 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2074 == NULL) {
    strlit2074 = alloc_String("*");
    gc_root(strlit2074);
  }
// compiled string node returning strlit2074 (depth = 7)
  partcv[0] = 0;
  Object call2075 = callmethod(strlit2074, "ord",
    1, partcv, params);
  gc_frame_end(callframe2073);
// compiled call node returning call2075 (depth = 6)
// compiled member node returning call2075 (depth = 5)
  gc_frame_newslot(call2075);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2076 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2077 == NULL) {
    strlit2077 = alloc_String("/");
    gc_root(strlit2077);
  }
// compiled string node returning strlit2077 (depth = 7)
  partcv[0] = 0;
  Object call2078 = callmethod(strlit2077, "ord",
    1, partcv, params);
  gc_frame_end(callframe2076);
// compiled call node returning call2078 (depth = 6)
// compiled member node returning call2078 (depth = 5)
  gc_frame_newslot(call2078);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2079 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2080 == NULL) {
    strlit2080 = alloc_String("+");
    gc_root(strlit2080);
  }
// compiled string node returning strlit2080 (depth = 7)
  partcv[0] = 0;
  Object call2081 = callmethod(strlit2080, "ord",
    1, partcv, params);
  gc_frame_end(callframe2079);
// compiled call node returning call2081 (depth = 6)
// compiled member node returning call2081 (depth = 5)
  gc_frame_newslot(call2081);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2082 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2083 == NULL) {
    strlit2083 = alloc_String("!");
    gc_root(strlit2083);
  }
// compiled string node returning strlit2083 (depth = 7)
  partcv[0] = 0;
  Object call2084 = callmethod(strlit2083, "ord",
    1, partcv, params);
  gc_frame_end(callframe2082);
// compiled call node returning call2084 (depth = 6)
// compiled member node returning call2084 (depth = 5)
  gc_frame_newslot(call2084);
// call case 6: other member request
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = strlit2047;
  params[1] = strlit2048;
  params[2] = call2051;
  params[3] = call2054;
  params[4] = call2057;
  params[5] = call2060;
  params[6] = call2063;
  params[7] = call2066;
  params[8] = call2069;
  params[9] = call2072;
  params[10] = call2075;
  params[11] = call2078;
  params[12] = call2081;
  params[13] = call2084;
  partcv[0] = 14;
  Object call2085 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2046);
// compiled call node returning call2085 (depth = 4)
  *var_operatorChar = call2085;
  if (call2085 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2086 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2087 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2088 == NULL) {
    strlit2088 = alloc_String("i");
    gc_root(strlit2088);
  }
// compiled string node returning strlit2088 (depth = 7)
  partcv[0] = 0;
  Object call2089 = callmethod(strlit2088, "ord",
    1, partcv, params);
  gc_frame_end(callframe2087);
// compiled call node returning call2089 (depth = 6)
// compiled member node returning call2089 (depth = 5)
  gc_frame_newslot(call2089);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2090 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2091 == NULL) {
    strlit2091 = alloc_String("<");
    gc_root(strlit2091);
  }
// compiled string node returning strlit2091 (depth = 7)
  partcv[0] = 0;
  Object call2092 = callmethod(strlit2091, "ord",
    1, partcv, params);
  gc_frame_end(callframe2090);
// compiled call node returning call2092 (depth = 6)
// compiled member node returning call2092 (depth = 5)
  gc_frame_newslot(call2092);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2093 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2094 == NULL) {
    strlit2094 = alloc_String(">");
    gc_root(strlit2094);
  }
// compiled string node returning strlit2094 (depth = 7)
  partcv[0] = 0;
  Object call2095 = callmethod(strlit2094, "ord",
    1, partcv, params);
  gc_frame_end(callframe2093);
// compiled call node returning call2095 (depth = 6)
// compiled member node returning call2095 (depth = 5)
  gc_frame_newslot(call2095);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call2089;
  params[1] = call2092;
  params[2] = call2095;
  partcv[0] = 3;
  Object call2096 = callmethod(*var_unicode, "pattern",
    1, partcv, params);
  gc_frame_end(callframe2086);
// compiled call node returning call2096 (depth = 4)
  *var_iGTLT = call2096;
  if (call2096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2097 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2098 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2099 == NULL) {
    strlit2099 = alloc_String("c");
    gc_root(strlit2099);
  }
// compiled string node returning strlit2099 (depth = 7)
  partcv[0] = 0;
  Object call2100 = callmethod(strlit2099, "ord",
    1, partcv, params);
  gc_frame_end(callframe2098);
// compiled call node returning call2100 (depth = 6)
// compiled member node returning call2100 (depth = 5)
  gc_frame_newslot(call2100);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2101 = gc_frame_new();
// call case 6: other member request
// starting to compile string node (depth = 7)
  if (strlit2102 == NULL) {
    strlit2102 = alloc_String("p");
    gc_root(strlit2102);
  }
// compiled string node returning strlit2102 (depth = 7)
  partcv[0] = 0;
  Object call2103 = callmethod(strlit2102, "ord",
    1, partcv, params);
  gc_frame_end(callframe2101);
// compiled call node returning call2103 (depth = 6)
// compiled member node returning call2103 (depth = 5)
  gc_frame_newslot(call2103);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unicode (depth = 5)
  params[0] = call2100;
  params[1] = call2103;
  partcv[0] = 0;
  partcv[1] = 2;
  Object call2104 = callmethod(*var_unicode, "pattern()not",
    2, partcv, params);
  gc_frame_end(callframe2097);
// compiled call node returning call2104 (depth = 4)
  *var_notcp = call2104;
  if (call2104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile block node (depth = 4)
  Object block2105 = alloc_Block(NULL, NULL, "lexer", 633);
  gc_frame_newslot(block2105);
// method _apply
  block_savedest(block2105);
  Object closure2106 = createclosure(26, "_apply");
  setclosureframe(closure2106, stackframe);
  addtoclosure(closure2106, var_badSeparator);
  addtoclosure(closure2106, var_errormessages);
  addtoclosure(closure2106, var_linePosition);
  addtoclosure(closure2106, var_lineNumber);
  addtoclosure(closure2106, var_instr);
  addtoclosure(closure2106, var_unicode);
  addtoclosure(closure2106, var_badControl);
  addtoclosure(closure2106, var_atStart);
  addtoclosure(closure2106, var_mode);
  addtoclosure(closure2106, var_newmode);
  addtoclosure(closure2106, var_identifierChar);
  addtoclosure(closure2106, var_digit);
  addtoclosure(closure2106, var_iGTLT);
  addtoclosure(closure2106, var_tokens);
  addtoclosure(closure2106, var_accum);
  addtoclosure(closure2106, var_operatorChar);
  addtoclosure(closure2106, var_selfModes);
  addtoclosure(closure2106, var_util);
  addtoclosure(closure2106, var_escaped);
  addtoclosure(closure2106, var_interpString);
  addtoclosure(closure2106, var_interpdepth);
  addtoclosure(closure2106, var_brackets);
  addtoclosure(closure2106, var_unichars);
  addtoclosure(closure2106, var_codepoint);
  addtoclosure(closure2106, var_startPosition);
  addtoclosure(closure2106, selfslot);
  struct UserObject *uo2106 = (struct UserObject*)block2105;
  uo2106->data[0] = (Object)closure2106;
  Method *meth_meth_lexer__apply2106 = addmethod2pos(block2105, "_apply", &meth_lexer__apply2106, 0);
  int argcv_meth_lexer__apply2106[] = {1};
  meth_meth_lexer__apply2106->type = alloc_MethodType(1, argcv_meth_lexer__apply2106);
  meth_meth_lexer__apply2106->definitionModule = modulename;
  meth_meth_lexer__apply2106->definitionLine = 632;
// compiled block node returning block2105 (depth = 4)
  *var_mainBlock = block2105;
  if (block2105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3374 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_input (depth = 4)
  gc_frame_newslot(*var_input);
// starting to compile block node (depth = 4)
  Object block3375 = alloc_Block(NULL, NULL, "lexer", 1028);
  gc_frame_newslot(block3375);
// method _apply
  block_savedest(block3375);
  Object closure3376 = createclosure(5, "_apply");
  setclosureframe(closure3376, stackframe);
  addtoclosure(closure3376, var_linePosition);
  addtoclosure(closure3376, var_mode);
  addtoclosure(closure3376, var_mainBlock);
  addtoclosure(closure3376, var_prev);
  addtoclosure(closure3376, selfslot);
  struct UserObject *uo3376 = (struct UserObject*)block3375;
  uo3376->data[0] = (Object)closure3376;
  Method *meth_meth_lexer__apply3376 = addmethod2pos(block3375, "_apply", &meth_lexer__apply3376, 0);
  int argcv_meth_lexer__apply3376[] = {1};
  meth_meth_lexer__apply3376->type = alloc_MethodType(1, argcv_meth_lexer__apply3376);
  meth_meth_lexer__apply3376->definitionModule = modulename;
  meth_meth_lexer__apply3376->definitionLine = 986;
// compiled block node returning block3375 (depth = 4)
  gc_frame_newslot(block3375);
// call case 5: prelude request
  params[0] = *var_input;
  params[1] = block3375;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3403 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3374);
// compiled call node returning call3403 (depth = 3)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num3405 = alloc_Float64(1);
// compiled num node returning num3405 (depth = 5)
  int op_slot_right_3404 = gc_frame_newslot(num3405);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_linePosition (depth = 5)
  int op_slot_left_3404 = gc_frame_newslot(*var_linePosition);
  params[0] = num3405;
  partcv[0] = 1;
  Object sum3407 = callmethod(*var_linePosition, "+", 1, partcv, params);
// compiled op node returning sum3407 (depth = 4)
  *var_linePosition = sum3407;
  if (sum3407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_instr (depth = 4)
  Object if3409 = done;
  if (istrue(*var_instr)) {
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3412 == NULL) {
    strlit3412 = alloc_String("""\x22""");
    gc_root(strlit3412);
  }
// compiled string node returning strlit3412 (depth = 6)
  int op_slot_right_3411 = gc_frame_newslot(strlit3412);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_3411 = gc_frame_newslot(*var_mode);
  params[0] = strlit3412;
  partcv[0] = 1;
  Object opresult3414 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3414 (depth = 5)
  Object if3410 = done;
  if (istrue(opresult3414)) {
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3415 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3417 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3416);
// compiled call node returning call3417 (depth = 9)
// compiled member node returning call3417 (depth = 8)
  partcv[0] = 0;
  Object call3418 = callmethod(call3417, "new",
    1, partcv, params);
  gc_frame_end(callframe3415);
// compiled call node returning call3418 (depth = 7)
// compiled member node returning call3418 (depth = 6)
  *var_suggestion = call3418;
  if (call3418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3419 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3421 == NULL) {
    strlit3421 = alloc_String("""\x22""");
    gc_root(strlit3421);
  }
// compiled string node returning strlit3421 (depth = 7)
  int op_slot_right_3420 = gc_frame_newslot(strlit3421);
// starting to compile call node (depth = 7)
  int callframe3423 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lineNumber (depth = 8)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call3425 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe3424);
// compiled call node returning call3425 (depth = 9)
// compiled member node returning call3425 (depth = 8)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call3426 = callmethod(call3425, "at",
    1, partcv, params);
  gc_frame_end(callframe3423);
// compiled call node returning call3426 (depth = 7)
  int op_slot_left_3420 = gc_frame_newslot(call3426);
  params[0] = strlit3421;
  partcv[0] = 1;
  Object opresult3427 = callmethod(call3426, "++", 1, partcv, params);
// compiled op node returning opresult3427 (depth = 6)
  gc_frame_newslot(opresult3427);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lineNumber;
  params[1] = opresult3427;
  partcv[0] = 2;
  Object call3428 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3419);
// compiled call node returning call3428 (depth = 5)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3429 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3430 == NULL) {
    strlit3430 = alloc_String("A string must end with a '""\x22""'.");
    gc_root(strlit3430);
  }
// compiled string node returning strlit3430 (depth = 6)
  gc_frame_newslot(strlit3430);
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  gc_frame_newslot(*var_linePosition);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3430;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3431 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3429);
// compiled call node returning call3431 (depth = 5)
    gc_frame_newslot(call3431);
    if3410 = call3431;
  } else {
  }
// compiled if node returning if3410 (depth = 4)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3434 == NULL) {
    strlit3434 = alloc_String("x");
    gc_root(strlit3434);
  }
// compiled string node returning strlit3434 (depth = 6)
  int op_slot_right_3433 = gc_frame_newslot(strlit3434);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_mode (depth = 6)
  int op_slot_left_3433 = gc_frame_newslot(*var_mode);
  params[0] = strlit3434;
  partcv[0] = 1;
  Object opresult3436 = callmethod(*var_mode, "==", 1, partcv, params);
// compiled op node returning opresult3436 (depth = 5)
  Object if3432 = done;
  if (istrue(opresult3436)) {
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3437 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3438 == NULL) {
    strlit3438 = alloc_String("Unfinished octets literal, expected '""\x22""'.");
    gc_root(strlit3438);
  }
// compiled string node returning strlit3438 (depth = 6)
  gc_frame_newslot(strlit3438);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_linePosition (depth = 6)
  gc_frame_newslot(*var_linePosition);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3438;
  params[1] = *var_lineNumber;
  params[2] = *var_linePosition;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call3439 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe3437);
// compiled call node returning call3439 (depth = 5)
    gc_frame_newslot(call3439);
    if3432 = call3439;
  } else {
  }
// compiled if node returning if3432 (depth = 4)
    gc_frame_newslot(if3432);
    if3409 = if3432;
  } else {
  }
// compiled if node returning if3409 (depth = 3)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3440 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokens (depth = 4)
  gc_frame_newslot(*var_tokens);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mode (depth = 4)
  gc_frame_newslot(*var_mode);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_accum (depth = 4)
  gc_frame_newslot(*var_accum);
// call case 4: self request
  params[0] = *var_tokens;
  params[1] = *var_mode;
  params[2] = *var_accum;
  partcv[0] = 3;
  Object call3441 = callmethodflags(self, "modechange", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3440);
// compiled call node returning call3441 (depth = 3)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_lexer_new64(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lineNumber = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineNumber");
  Object *var_linePosition = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "linePosition");
  Object *var_startPosition = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startPosition");
  Object *var_indentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentLevel");
  Object *var_Token = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "Token");
  Object *var_IdentifierToken = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "IdentifierToken");
  Object *var_StringToken = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "StringToken");
  Object *var_CommentToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "CommentToken");
  Object *var_OctetsToken = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "OctetsToken");
  Object *var_LBraceToken = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "LBraceToken");
  Object *var_RBraceToken = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "RBraceToken");
  Object *var_LParenToken = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "LParenToken");
  Object *var_RParenToken = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "RParenToken");
  Object *var_LSquareToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "LSquareToken");
  Object *var_RSquareToken = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "RSquareToken");
  Object *var_CommaToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "CommaToken");
  Object *var_ColonToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "ColonToken");
  Object *var_DotToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "DotToken");
  Object *var_NumToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "NumToken");
  Object *var_KeywordToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "KeywordToken");
  Object *var_OpToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "OpToken");
  Object *var_ArrowToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "ArrowToken");
  Object *var_BindToken = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "BindToken");
  Object *var_SemicolonToken = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "SemicolonToken");
  Object *var_LGenericToken = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "LGenericToken");
  Object *var_RGenericToken = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "RGenericToken");
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num65 = alloc_Float64(1);
// compiled num node returning num65 (depth = 4)
  *var_lineNumber = num65;
  if (num65 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num66 = alloc_Float64(0);
// compiled num node returning num66 (depth = 4)
  *var_linePosition = num66;
  if (num66 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num67 = alloc_Float64(1);
// compiled num node returning num67 (depth = 4)
  *var_startPosition = num67;
  if (num67 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num68 = alloc_Float64(0);
// compiled num node returning num68 (depth = 4)
  *var_indentLevel = num68;
  if (num68 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject69 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj69 = alloc_userobj2(2,4, objclass69);
  gc_frame_newslot(obj69);
// OBJECT OUTER DEC outer
  adddatum2(obj69, self, 0);
  addmethodreal(obj69,"outer", &reader_lexer_outer_70);
  Object oldself69 = self;
  struct StackFrameObject *oldstackframe69 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe69);
  gc_frame_newslot((Object)stackframe);
  self = obj69;
  Object *oldselfslot69 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter69 = (*(struct UserObject *)self).data[0], lowerouter69 = thisouter69;
  if (inheritingObject69) {
    struct UserObject *inho69 = (struct UserObject *)inheritingObject69;
    while (inho69->super != GraceDefaultObject) inho69 = (struct UserObject *)inho69->super;
    inho69->super = obj69;
    self = inheritingObject69;
    *selfslot = self;
    lowerouter69 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter69;
  }
// method new
  block_savedest(obj69);
  Object closure71 = createclosure(3, "new");
  setclosureframe(closure71, stackframe);
  addtoclosure(closure71, var_lineNumber);
  addtoclosure(closure71, var_indentLevel);
  addtoclosure(closure71, var_startPosition);
  struct UserObject *uo71 = (struct UserObject*)obj69;
  uo71->data[1] = (Object)closure71;
  Method *meth_meth_lexer_new71 = addmethod2pos(obj69, "new", &meth_lexer_new71, 1);
  int argcv_meth_lexer_new71[] = {0};
  meth_meth_lexer_new71->type = alloc_MethodType(1, argcv_meth_lexer_new71);
  meth_meth_lexer_new71->definitionModule = modulename;
  meth_meth_lexer_new71->definitionLine = 42;
  block_savedest(obj69);
  Object closure105 = createclosure(3, "new()object");
  setclosureframe(closure105, stackframe);
  addtoclosure(closure105, var_lineNumber);
  addtoclosure(closure105, var_indentLevel);
  addtoclosure(closure105, var_startPosition);
  Method *meth_meth_lexer_new71_object = addmethod2pos(obj69, "new()object", &meth_lexer_new71_object, 1);
  meth_meth_lexer_new71_object->definitionModule = modulename;
  meth_meth_lexer_new71_object->definitionLine = 42;
  sourceObject = obj69;
objclass69 = obj69->class;
  objclass69->definitionModule = modulename;
  objclass69->definitionLine = 42;
  (*(struct UserObject *)self).data[0] = lowerouter69;
  self = oldself69;
  selfslot = oldselfslot69;
  stackframe = oldstackframe69;
// compiled object node returning obj69 (depth = 5)
  *var_Token = obj69;
  if (obj69 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject106 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj106 = alloc_userobj2(2,4, objclass106);
  gc_frame_newslot(obj106);
// OBJECT OUTER DEC outer
  adddatum2(obj106, self, 0);
  addmethodreal(obj106,"outer", &reader_lexer_outer_107);
  Object oldself106 = self;
  struct StackFrameObject *oldstackframe106 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe106);
  gc_frame_newslot((Object)stackframe);
  self = obj106;
  Object *oldselfslot106 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter106 = (*(struct UserObject *)self).data[0], lowerouter106 = thisouter106;
  if (inheritingObject106) {
    struct UserObject *inho106 = (struct UserObject *)inheritingObject106;
    while (inho106->super != GraceDefaultObject) inho106 = (struct UserObject *)inho106->super;
    inho106->super = obj106;
    self = inheritingObject106;
    *selfslot = self;
    lowerouter106 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter106;
  }
// method new
  block_savedest(obj106);
  Object closure108 = createclosure(1, "new");
  setclosureframe(closure108, stackframe);
  addtoclosure(closure108, var_Token);
  struct UserObject *uo108 = (struct UserObject*)obj106;
  uo108->data[1] = (Object)closure108;
  Method *meth_meth_lexer_new108 = addmethod2pos(obj106, "new", &meth_lexer_new108, 1);
  int argcv_meth_lexer_new108[] = {1};
  meth_meth_lexer_new108->type = alloc_MethodType(1, argcv_meth_lexer_new108);
  meth_meth_lexer_new108->definitionModule = modulename;
  meth_meth_lexer_new108->definitionLine = 59;
  block_savedest(obj106);
  Object closure119 = createclosure(1, "new()object");
  setclosureframe(closure119, stackframe);
  addtoclosure(closure119, var_Token);
  Method *meth_meth_lexer_new108_object = addmethod2pos(obj106, "new()object", &meth_lexer_new108_object, 1);
  meth_meth_lexer_new108_object->definitionModule = modulename;
  meth_meth_lexer_new108_object->definitionLine = 59;
  sourceObject = obj106;
objclass106 = obj106->class;
  objclass106->definitionModule = modulename;
  objclass106->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter106;
  self = oldself106;
  selfslot = oldselfslot106;
  stackframe = oldstackframe106;
// compiled object node returning obj106 (depth = 5)
  *var_IdentifierToken = obj106;
  if (obj106 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject120 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj120 = alloc_userobj2(2,4, objclass120);
  gc_frame_newslot(obj120);
// OBJECT OUTER DEC outer
  adddatum2(obj120, self, 0);
  addmethodreal(obj120,"outer", &reader_lexer_outer_121);
  Object oldself120 = self;
  struct StackFrameObject *oldstackframe120 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe120);
  gc_frame_newslot((Object)stackframe);
  self = obj120;
  Object *oldselfslot120 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter120 = (*(struct UserObject *)self).data[0], lowerouter120 = thisouter120;
  if (inheritingObject120) {
    struct UserObject *inho120 = (struct UserObject *)inheritingObject120;
    while (inho120->super != GraceDefaultObject) inho120 = (struct UserObject *)inho120->super;
    inho120->super = obj120;
    self = inheritingObject120;
    *selfslot = self;
    lowerouter120 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter120;
  }
// method new
  block_savedest(obj120);
  Object closure122 = createclosure(1, "new");
  setclosureframe(closure122, stackframe);
  addtoclosure(closure122, var_Token);
  struct UserObject *uo122 = (struct UserObject*)obj120;
  uo122->data[1] = (Object)closure122;
  Method *meth_meth_lexer_new122 = addmethod2pos(obj120, "new", &meth_lexer_new122, 1);
  int argcv_meth_lexer_new122[] = {1};
  meth_meth_lexer_new122->type = alloc_MethodType(1, argcv_meth_lexer_new122);
  meth_meth_lexer_new122->definitionModule = modulename;
  meth_meth_lexer_new122->definitionLine = 65;
  block_savedest(obj120);
  Object closure137 = createclosure(1, "new()object");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_Token);
  Method *meth_meth_lexer_new122_object = addmethod2pos(obj120, "new()object", &meth_lexer_new122_object, 1);
  meth_meth_lexer_new122_object->definitionModule = modulename;
  meth_meth_lexer_new122_object->definitionLine = 65;
  sourceObject = obj120;
objclass120 = obj120->class;
  objclass120->definitionModule = modulename;
  objclass120->definitionLine = 65;
  (*(struct UserObject *)self).data[0] = lowerouter120;
  self = oldself120;
  selfslot = oldselfslot120;
  stackframe = oldstackframe120;
// compiled object node returning obj120 (depth = 5)
  *var_StringToken = obj120;
  if (obj120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject138 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj138 = alloc_userobj2(2,4, objclass138);
  gc_frame_newslot(obj138);
// OBJECT OUTER DEC outer
  adddatum2(obj138, self, 0);
  addmethodreal(obj138,"outer", &reader_lexer_outer_139);
  Object oldself138 = self;
  struct StackFrameObject *oldstackframe138 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe138);
  gc_frame_newslot((Object)stackframe);
  self = obj138;
  Object *oldselfslot138 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter138 = (*(struct UserObject *)self).data[0], lowerouter138 = thisouter138;
  if (inheritingObject138) {
    struct UserObject *inho138 = (struct UserObject *)inheritingObject138;
    while (inho138->super != GraceDefaultObject) inho138 = (struct UserObject *)inho138->super;
    inho138->super = obj138;
    self = inheritingObject138;
    *selfslot = self;
    lowerouter138 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter138;
  }
// method new
  block_savedest(obj138);
  Object closure140 = createclosure(1, "new");
  setclosureframe(closure140, stackframe);
  addtoclosure(closure140, var_Token);
  struct UserObject *uo140 = (struct UserObject*)obj138;
  uo140->data[1] = (Object)closure140;
  Method *meth_meth_lexer_new140 = addmethod2pos(obj138, "new", &meth_lexer_new140, 1);
  int argcv_meth_lexer_new140[] = {1};
  meth_meth_lexer_new140->type = alloc_MethodType(1, argcv_meth_lexer_new140);
  meth_meth_lexer_new140->definitionModule = modulename;
  meth_meth_lexer_new140->definitionLine = 71;
  block_savedest(obj138);
  Object closure155 = createclosure(1, "new()object");
  setclosureframe(closure155, stackframe);
  addtoclosure(closure155, var_Token);
  Method *meth_meth_lexer_new140_object = addmethod2pos(obj138, "new()object", &meth_lexer_new140_object, 1);
  meth_meth_lexer_new140_object->definitionModule = modulename;
  meth_meth_lexer_new140_object->definitionLine = 71;
  sourceObject = obj138;
objclass138 = obj138->class;
  objclass138->definitionModule = modulename;
  objclass138->definitionLine = 71;
  (*(struct UserObject *)self).data[0] = lowerouter138;
  self = oldself138;
  selfslot = oldselfslot138;
  stackframe = oldstackframe138;
// compiled object node returning obj138 (depth = 5)
  *var_CommentToken = obj138;
  if (obj138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject156 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj156 = alloc_userobj2(2,4, objclass156);
  gc_frame_newslot(obj156);
// OBJECT OUTER DEC outer
  adddatum2(obj156, self, 0);
  addmethodreal(obj156,"outer", &reader_lexer_outer_157);
  Object oldself156 = self;
  struct StackFrameObject *oldstackframe156 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe156);
  gc_frame_newslot((Object)stackframe);
  self = obj156;
  Object *oldselfslot156 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter156 = (*(struct UserObject *)self).data[0], lowerouter156 = thisouter156;
  if (inheritingObject156) {
    struct UserObject *inho156 = (struct UserObject *)inheritingObject156;
    while (inho156->super != GraceDefaultObject) inho156 = (struct UserObject *)inho156->super;
    inho156->super = obj156;
    self = inheritingObject156;
    *selfslot = self;
    lowerouter156 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter156;
  }
// method new
  block_savedest(obj156);
  Object closure158 = createclosure(1, "new");
  setclosureframe(closure158, stackframe);
  addtoclosure(closure158, var_Token);
  struct UserObject *uo158 = (struct UserObject*)obj156;
  uo158->data[1] = (Object)closure158;
  Method *meth_meth_lexer_new158 = addmethod2pos(obj156, "new", &meth_lexer_new158, 1);
  int argcv_meth_lexer_new158[] = {1};
  meth_meth_lexer_new158->type = alloc_MethodType(1, argcv_meth_lexer_new158);
  meth_meth_lexer_new158->definitionModule = modulename;
  meth_meth_lexer_new158->definitionLine = 77;
  block_savedest(obj156);
  Object closure173 = createclosure(1, "new()object");
  setclosureframe(closure173, stackframe);
  addtoclosure(closure173, var_Token);
  Method *meth_meth_lexer_new158_object = addmethod2pos(obj156, "new()object", &meth_lexer_new158_object, 1);
  meth_meth_lexer_new158_object->definitionModule = modulename;
  meth_meth_lexer_new158_object->definitionLine = 77;
  sourceObject = obj156;
objclass156 = obj156->class;
  objclass156->definitionModule = modulename;
  objclass156->definitionLine = 77;
  (*(struct UserObject *)self).data[0] = lowerouter156;
  self = oldself156;
  selfslot = oldselfslot156;
  stackframe = oldstackframe156;
// compiled object node returning obj156 (depth = 5)
  *var_OctetsToken = obj156;
  if (obj156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject174 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj174 = alloc_userobj2(2,4, objclass174);
  gc_frame_newslot(obj174);
// OBJECT OUTER DEC outer
  adddatum2(obj174, self, 0);
  addmethodreal(obj174,"outer", &reader_lexer_outer_175);
  Object oldself174 = self;
  struct StackFrameObject *oldstackframe174 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe174);
  gc_frame_newslot((Object)stackframe);
  self = obj174;
  Object *oldselfslot174 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter174 = (*(struct UserObject *)self).data[0], lowerouter174 = thisouter174;
  if (inheritingObject174) {
    struct UserObject *inho174 = (struct UserObject *)inheritingObject174;
    while (inho174->super != GraceDefaultObject) inho174 = (struct UserObject *)inho174->super;
    inho174->super = obj174;
    self = inheritingObject174;
    *selfslot = self;
    lowerouter174 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter174;
  }
// method new
  block_savedest(obj174);
  Object closure176 = createclosure(1, "new");
  setclosureframe(closure176, stackframe);
  addtoclosure(closure176, var_Token);
  struct UserObject *uo176 = (struct UserObject*)obj174;
  uo176->data[1] = (Object)closure176;
  Method *meth_meth_lexer_new176 = addmethod2pos(obj174, "new", &meth_lexer_new176, 1);
  int argcv_meth_lexer_new176[] = {0};
  meth_meth_lexer_new176->type = alloc_MethodType(1, argcv_meth_lexer_new176);
  meth_meth_lexer_new176->definitionModule = modulename;
  meth_meth_lexer_new176->definitionLine = 83;
  block_savedest(obj174);
  Object closure187 = createclosure(1, "new()object");
  setclosureframe(closure187, stackframe);
  addtoclosure(closure187, var_Token);
  Method *meth_meth_lexer_new176_object = addmethod2pos(obj174, "new()object", &meth_lexer_new176_object, 1);
  meth_meth_lexer_new176_object->definitionModule = modulename;
  meth_meth_lexer_new176_object->definitionLine = 83;
  sourceObject = obj174;
objclass174 = obj174->class;
  objclass174->definitionModule = modulename;
  objclass174->definitionLine = 83;
  (*(struct UserObject *)self).data[0] = lowerouter174;
  self = oldself174;
  selfslot = oldselfslot174;
  stackframe = oldstackframe174;
// compiled object node returning obj174 (depth = 5)
  *var_LBraceToken = obj174;
  if (obj174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject188 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj188 = alloc_userobj2(2,4, objclass188);
  gc_frame_newslot(obj188);
// OBJECT OUTER DEC outer
  adddatum2(obj188, self, 0);
  addmethodreal(obj188,"outer", &reader_lexer_outer_189);
  Object oldself188 = self;
  struct StackFrameObject *oldstackframe188 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe188);
  gc_frame_newslot((Object)stackframe);
  self = obj188;
  Object *oldselfslot188 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter188 = (*(struct UserObject *)self).data[0], lowerouter188 = thisouter188;
  if (inheritingObject188) {
    struct UserObject *inho188 = (struct UserObject *)inheritingObject188;
    while (inho188->super != GraceDefaultObject) inho188 = (struct UserObject *)inho188->super;
    inho188->super = obj188;
    self = inheritingObject188;
    *selfslot = self;
    lowerouter188 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter188;
  }
// method new
  block_savedest(obj188);
  Object closure190 = createclosure(1, "new");
  setclosureframe(closure190, stackframe);
  addtoclosure(closure190, var_Token);
  struct UserObject *uo190 = (struct UserObject*)obj188;
  uo190->data[1] = (Object)closure190;
  Method *meth_meth_lexer_new190 = addmethod2pos(obj188, "new", &meth_lexer_new190, 1);
  int argcv_meth_lexer_new190[] = {0};
  meth_meth_lexer_new190->type = alloc_MethodType(1, argcv_meth_lexer_new190);
  meth_meth_lexer_new190->definitionModule = modulename;
  meth_meth_lexer_new190->definitionLine = 89;
  block_savedest(obj188);
  Object closure201 = createclosure(1, "new()object");
  setclosureframe(closure201, stackframe);
  addtoclosure(closure201, var_Token);
  Method *meth_meth_lexer_new190_object = addmethod2pos(obj188, "new()object", &meth_lexer_new190_object, 1);
  meth_meth_lexer_new190_object->definitionModule = modulename;
  meth_meth_lexer_new190_object->definitionLine = 89;
  sourceObject = obj188;
objclass188 = obj188->class;
  objclass188->definitionModule = modulename;
  objclass188->definitionLine = 89;
  (*(struct UserObject *)self).data[0] = lowerouter188;
  self = oldself188;
  selfslot = oldselfslot188;
  stackframe = oldstackframe188;
// compiled object node returning obj188 (depth = 5)
  *var_RBraceToken = obj188;
  if (obj188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject202 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj202 = alloc_userobj2(2,4, objclass202);
  gc_frame_newslot(obj202);
// OBJECT OUTER DEC outer
  adddatum2(obj202, self, 0);
  addmethodreal(obj202,"outer", &reader_lexer_outer_203);
  Object oldself202 = self;
  struct StackFrameObject *oldstackframe202 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe202);
  gc_frame_newslot((Object)stackframe);
  self = obj202;
  Object *oldselfslot202 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter202 = (*(struct UserObject *)self).data[0], lowerouter202 = thisouter202;
  if (inheritingObject202) {
    struct UserObject *inho202 = (struct UserObject *)inheritingObject202;
    while (inho202->super != GraceDefaultObject) inho202 = (struct UserObject *)inho202->super;
    inho202->super = obj202;
    self = inheritingObject202;
    *selfslot = self;
    lowerouter202 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter202;
  }
// method new
  block_savedest(obj202);
  Object closure204 = createclosure(1, "new");
  setclosureframe(closure204, stackframe);
  addtoclosure(closure204, var_Token);
  struct UserObject *uo204 = (struct UserObject*)obj202;
  uo204->data[1] = (Object)closure204;
  Method *meth_meth_lexer_new204 = addmethod2pos(obj202, "new", &meth_lexer_new204, 1);
  int argcv_meth_lexer_new204[] = {0};
  meth_meth_lexer_new204->type = alloc_MethodType(1, argcv_meth_lexer_new204);
  meth_meth_lexer_new204->definitionModule = modulename;
  meth_meth_lexer_new204->definitionLine = 95;
  block_savedest(obj202);
  Object closure215 = createclosure(1, "new()object");
  setclosureframe(closure215, stackframe);
  addtoclosure(closure215, var_Token);
  Method *meth_meth_lexer_new204_object = addmethod2pos(obj202, "new()object", &meth_lexer_new204_object, 1);
  meth_meth_lexer_new204_object->definitionModule = modulename;
  meth_meth_lexer_new204_object->definitionLine = 95;
  sourceObject = obj202;
objclass202 = obj202->class;
  objclass202->definitionModule = modulename;
  objclass202->definitionLine = 95;
  (*(struct UserObject *)self).data[0] = lowerouter202;
  self = oldself202;
  selfslot = oldselfslot202;
  stackframe = oldstackframe202;
// compiled object node returning obj202 (depth = 5)
  *var_LParenToken = obj202;
  if (obj202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject216 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj216 = alloc_userobj2(2,4, objclass216);
  gc_frame_newslot(obj216);
// OBJECT OUTER DEC outer
  adddatum2(obj216, self, 0);
  addmethodreal(obj216,"outer", &reader_lexer_outer_217);
  Object oldself216 = self;
  struct StackFrameObject *oldstackframe216 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe216);
  gc_frame_newslot((Object)stackframe);
  self = obj216;
  Object *oldselfslot216 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter216 = (*(struct UserObject *)self).data[0], lowerouter216 = thisouter216;
  if (inheritingObject216) {
    struct UserObject *inho216 = (struct UserObject *)inheritingObject216;
    while (inho216->super != GraceDefaultObject) inho216 = (struct UserObject *)inho216->super;
    inho216->super = obj216;
    self = inheritingObject216;
    *selfslot = self;
    lowerouter216 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter216;
  }
// method new
  block_savedest(obj216);
  Object closure218 = createclosure(1, "new");
  setclosureframe(closure218, stackframe);
  addtoclosure(closure218, var_Token);
  struct UserObject *uo218 = (struct UserObject*)obj216;
  uo218->data[1] = (Object)closure218;
  Method *meth_meth_lexer_new218 = addmethod2pos(obj216, "new", &meth_lexer_new218, 1);
  int argcv_meth_lexer_new218[] = {0};
  meth_meth_lexer_new218->type = alloc_MethodType(1, argcv_meth_lexer_new218);
  meth_meth_lexer_new218->definitionModule = modulename;
  meth_meth_lexer_new218->definitionLine = 101;
  block_savedest(obj216);
  Object closure229 = createclosure(1, "new()object");
  setclosureframe(closure229, stackframe);
  addtoclosure(closure229, var_Token);
  Method *meth_meth_lexer_new218_object = addmethod2pos(obj216, "new()object", &meth_lexer_new218_object, 1);
  meth_meth_lexer_new218_object->definitionModule = modulename;
  meth_meth_lexer_new218_object->definitionLine = 101;
  sourceObject = obj216;
objclass216 = obj216->class;
  objclass216->definitionModule = modulename;
  objclass216->definitionLine = 101;
  (*(struct UserObject *)self).data[0] = lowerouter216;
  self = oldself216;
  selfslot = oldselfslot216;
  stackframe = oldstackframe216;
// compiled object node returning obj216 (depth = 5)
  *var_RParenToken = obj216;
  if (obj216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject230 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj230 = alloc_userobj2(2,4, objclass230);
  gc_frame_newslot(obj230);
// OBJECT OUTER DEC outer
  adddatum2(obj230, self, 0);
  addmethodreal(obj230,"outer", &reader_lexer_outer_231);
  Object oldself230 = self;
  struct StackFrameObject *oldstackframe230 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe230);
  gc_frame_newslot((Object)stackframe);
  self = obj230;
  Object *oldselfslot230 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter230 = (*(struct UserObject *)self).data[0], lowerouter230 = thisouter230;
  if (inheritingObject230) {
    struct UserObject *inho230 = (struct UserObject *)inheritingObject230;
    while (inho230->super != GraceDefaultObject) inho230 = (struct UserObject *)inho230->super;
    inho230->super = obj230;
    self = inheritingObject230;
    *selfslot = self;
    lowerouter230 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter230;
  }
// method new
  block_savedest(obj230);
  Object closure232 = createclosure(1, "new");
  setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_Token);
  struct UserObject *uo232 = (struct UserObject*)obj230;
  uo232->data[1] = (Object)closure232;
  Method *meth_meth_lexer_new232 = addmethod2pos(obj230, "new", &meth_lexer_new232, 1);
  int argcv_meth_lexer_new232[] = {0};
  meth_meth_lexer_new232->type = alloc_MethodType(1, argcv_meth_lexer_new232);
  meth_meth_lexer_new232->definitionModule = modulename;
  meth_meth_lexer_new232->definitionLine = 107;
  block_savedest(obj230);
  Object closure243 = createclosure(1, "new()object");
  setclosureframe(closure243, stackframe);
  addtoclosure(closure243, var_Token);
  Method *meth_meth_lexer_new232_object = addmethod2pos(obj230, "new()object", &meth_lexer_new232_object, 1);
  meth_meth_lexer_new232_object->definitionModule = modulename;
  meth_meth_lexer_new232_object->definitionLine = 107;
  sourceObject = obj230;
objclass230 = obj230->class;
  objclass230->definitionModule = modulename;
  objclass230->definitionLine = 107;
  (*(struct UserObject *)self).data[0] = lowerouter230;
  self = oldself230;
  selfslot = oldselfslot230;
  stackframe = oldstackframe230;
// compiled object node returning obj230 (depth = 5)
  *var_LSquareToken = obj230;
  if (obj230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject244 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj244 = alloc_userobj2(2,4, objclass244);
  gc_frame_newslot(obj244);
// OBJECT OUTER DEC outer
  adddatum2(obj244, self, 0);
  addmethodreal(obj244,"outer", &reader_lexer_outer_245);
  Object oldself244 = self;
  struct StackFrameObject *oldstackframe244 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe244);
  gc_frame_newslot((Object)stackframe);
  self = obj244;
  Object *oldselfslot244 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter244 = (*(struct UserObject *)self).data[0], lowerouter244 = thisouter244;
  if (inheritingObject244) {
    struct UserObject *inho244 = (struct UserObject *)inheritingObject244;
    while (inho244->super != GraceDefaultObject) inho244 = (struct UserObject *)inho244->super;
    inho244->super = obj244;
    self = inheritingObject244;
    *selfslot = self;
    lowerouter244 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter244;
  }
// method new
  block_savedest(obj244);
  Object closure246 = createclosure(1, "new");
  setclosureframe(closure246, stackframe);
  addtoclosure(closure246, var_Token);
  struct UserObject *uo246 = (struct UserObject*)obj244;
  uo246->data[1] = (Object)closure246;
  Method *meth_meth_lexer_new246 = addmethod2pos(obj244, "new", &meth_lexer_new246, 1);
  int argcv_meth_lexer_new246[] = {0};
  meth_meth_lexer_new246->type = alloc_MethodType(1, argcv_meth_lexer_new246);
  meth_meth_lexer_new246->definitionModule = modulename;
  meth_meth_lexer_new246->definitionLine = 113;
  block_savedest(obj244);
  Object closure257 = createclosure(1, "new()object");
  setclosureframe(closure257, stackframe);
  addtoclosure(closure257, var_Token);
  Method *meth_meth_lexer_new246_object = addmethod2pos(obj244, "new()object", &meth_lexer_new246_object, 1);
  meth_meth_lexer_new246_object->definitionModule = modulename;
  meth_meth_lexer_new246_object->definitionLine = 113;
  sourceObject = obj244;
objclass244 = obj244->class;
  objclass244->definitionModule = modulename;
  objclass244->definitionLine = 113;
  (*(struct UserObject *)self).data[0] = lowerouter244;
  self = oldself244;
  selfslot = oldselfslot244;
  stackframe = oldstackframe244;
// compiled object node returning obj244 (depth = 5)
  *var_RSquareToken = obj244;
  if (obj244 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject258 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj258 = alloc_userobj2(2,4, objclass258);
  gc_frame_newslot(obj258);
// OBJECT OUTER DEC outer
  adddatum2(obj258, self, 0);
  addmethodreal(obj258,"outer", &reader_lexer_outer_259);
  Object oldself258 = self;
  struct StackFrameObject *oldstackframe258 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe258);
  gc_frame_newslot((Object)stackframe);
  self = obj258;
  Object *oldselfslot258 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter258 = (*(struct UserObject *)self).data[0], lowerouter258 = thisouter258;
  if (inheritingObject258) {
    struct UserObject *inho258 = (struct UserObject *)inheritingObject258;
    while (inho258->super != GraceDefaultObject) inho258 = (struct UserObject *)inho258->super;
    inho258->super = obj258;
    self = inheritingObject258;
    *selfslot = self;
    lowerouter258 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter258;
  }
// method new
  block_savedest(obj258);
  Object closure260 = createclosure(1, "new");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_Token);
  struct UserObject *uo260 = (struct UserObject*)obj258;
  uo260->data[1] = (Object)closure260;
  Method *meth_meth_lexer_new260 = addmethod2pos(obj258, "new", &meth_lexer_new260, 1);
  int argcv_meth_lexer_new260[] = {0};
  meth_meth_lexer_new260->type = alloc_MethodType(1, argcv_meth_lexer_new260);
  meth_meth_lexer_new260->definitionModule = modulename;
  meth_meth_lexer_new260->definitionLine = 119;
  block_savedest(obj258);
  Object closure271 = createclosure(1, "new()object");
  setclosureframe(closure271, stackframe);
  addtoclosure(closure271, var_Token);
  Method *meth_meth_lexer_new260_object = addmethod2pos(obj258, "new()object", &meth_lexer_new260_object, 1);
  meth_meth_lexer_new260_object->definitionModule = modulename;
  meth_meth_lexer_new260_object->definitionLine = 119;
  sourceObject = obj258;
objclass258 = obj258->class;
  objclass258->definitionModule = modulename;
  objclass258->definitionLine = 119;
  (*(struct UserObject *)self).data[0] = lowerouter258;
  self = oldself258;
  selfslot = oldselfslot258;
  stackframe = oldstackframe258;
// compiled object node returning obj258 (depth = 5)
  *var_CommaToken = obj258;
  if (obj258 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject272 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj272 = alloc_userobj2(2,4, objclass272);
  gc_frame_newslot(obj272);
// OBJECT OUTER DEC outer
  adddatum2(obj272, self, 0);
  addmethodreal(obj272,"outer", &reader_lexer_outer_273);
  Object oldself272 = self;
  struct StackFrameObject *oldstackframe272 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe272);
  gc_frame_newslot((Object)stackframe);
  self = obj272;
  Object *oldselfslot272 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter272 = (*(struct UserObject *)self).data[0], lowerouter272 = thisouter272;
  if (inheritingObject272) {
    struct UserObject *inho272 = (struct UserObject *)inheritingObject272;
    while (inho272->super != GraceDefaultObject) inho272 = (struct UserObject *)inho272->super;
    inho272->super = obj272;
    self = inheritingObject272;
    *selfslot = self;
    lowerouter272 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter272;
  }
// method new
  block_savedest(obj272);
  Object closure274 = createclosure(1, "new");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_Token);
  struct UserObject *uo274 = (struct UserObject*)obj272;
  uo274->data[1] = (Object)closure274;
  Method *meth_meth_lexer_new274 = addmethod2pos(obj272, "new", &meth_lexer_new274, 1);
  int argcv_meth_lexer_new274[] = {0};
  meth_meth_lexer_new274->type = alloc_MethodType(1, argcv_meth_lexer_new274);
  meth_meth_lexer_new274->definitionModule = modulename;
  meth_meth_lexer_new274->definitionLine = 125;
  block_savedest(obj272);
  Object closure285 = createclosure(1, "new()object");
  setclosureframe(closure285, stackframe);
  addtoclosure(closure285, var_Token);
  Method *meth_meth_lexer_new274_object = addmethod2pos(obj272, "new()object", &meth_lexer_new274_object, 1);
  meth_meth_lexer_new274_object->definitionModule = modulename;
  meth_meth_lexer_new274_object->definitionLine = 125;
  sourceObject = obj272;
objclass272 = obj272->class;
  objclass272->definitionModule = modulename;
  objclass272->definitionLine = 125;
  (*(struct UserObject *)self).data[0] = lowerouter272;
  self = oldself272;
  selfslot = oldselfslot272;
  stackframe = oldstackframe272;
// compiled object node returning obj272 (depth = 5)
  *var_ColonToken = obj272;
  if (obj272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject286 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj286 = alloc_userobj2(2,4, objclass286);
  gc_frame_newslot(obj286);
// OBJECT OUTER DEC outer
  adddatum2(obj286, self, 0);
  addmethodreal(obj286,"outer", &reader_lexer_outer_287);
  Object oldself286 = self;
  struct StackFrameObject *oldstackframe286 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe286);
  gc_frame_newslot((Object)stackframe);
  self = obj286;
  Object *oldselfslot286 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter286 = (*(struct UserObject *)self).data[0], lowerouter286 = thisouter286;
  if (inheritingObject286) {
    struct UserObject *inho286 = (struct UserObject *)inheritingObject286;
    while (inho286->super != GraceDefaultObject) inho286 = (struct UserObject *)inho286->super;
    inho286->super = obj286;
    self = inheritingObject286;
    *selfslot = self;
    lowerouter286 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter286;
  }
// method new
  block_savedest(obj286);
  Object closure288 = createclosure(1, "new");
  setclosureframe(closure288, stackframe);
  addtoclosure(closure288, var_Token);
  struct UserObject *uo288 = (struct UserObject*)obj286;
  uo288->data[1] = (Object)closure288;
  Method *meth_meth_lexer_new288 = addmethod2pos(obj286, "new", &meth_lexer_new288, 1);
  int argcv_meth_lexer_new288[] = {0};
  meth_meth_lexer_new288->type = alloc_MethodType(1, argcv_meth_lexer_new288);
  meth_meth_lexer_new288->definitionModule = modulename;
  meth_meth_lexer_new288->definitionLine = 131;
  block_savedest(obj286);
  Object closure299 = createclosure(1, "new()object");
  setclosureframe(closure299, stackframe);
  addtoclosure(closure299, var_Token);
  Method *meth_meth_lexer_new288_object = addmethod2pos(obj286, "new()object", &meth_lexer_new288_object, 1);
  meth_meth_lexer_new288_object->definitionModule = modulename;
  meth_meth_lexer_new288_object->definitionLine = 131;
  sourceObject = obj286;
objclass286 = obj286->class;
  objclass286->definitionModule = modulename;
  objclass286->definitionLine = 131;
  (*(struct UserObject *)self).data[0] = lowerouter286;
  self = oldself286;
  selfslot = oldselfslot286;
  stackframe = oldstackframe286;
// compiled object node returning obj286 (depth = 5)
  *var_DotToken = obj286;
  if (obj286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj300 = alloc_userobj2(2,4, objclass300);
  gc_frame_newslot(obj300);
// OBJECT OUTER DEC outer
  adddatum2(obj300, self, 0);
  addmethodreal(obj300,"outer", &reader_lexer_outer_301);
  Object oldself300 = self;
  struct StackFrameObject *oldstackframe300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe300);
  gc_frame_newslot((Object)stackframe);
  self = obj300;
  Object *oldselfslot300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter300 = (*(struct UserObject *)self).data[0], lowerouter300 = thisouter300;
  if (inheritingObject300) {
    struct UserObject *inho300 = (struct UserObject *)inheritingObject300;
    while (inho300->super != GraceDefaultObject) inho300 = (struct UserObject *)inho300->super;
    inho300->super = obj300;
    self = inheritingObject300;
    *selfslot = self;
    lowerouter300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter300;
  }
// method new
  block_savedest(obj300);
  Object closure302 = createclosure(3, "new");
  setclosureframe(closure302, stackframe);
  addtoclosure(closure302, var_Token);
  addtoclosure(closure302, var_startPosition);
  addtoclosure(closure302, var_linePosition);
  struct UserObject *uo302 = (struct UserObject*)obj300;
  uo302->data[1] = (Object)closure302;
  Method *meth_meth_lexer_new302 = addmethod2pos(obj300, "new", &meth_lexer_new302, 1);
  int argcv_meth_lexer_new302[] = {2};
  meth_meth_lexer_new302->type = alloc_MethodType(1, argcv_meth_lexer_new302);
  meth_meth_lexer_new302->definitionModule = modulename;
  meth_meth_lexer_new302->definitionLine = 137;
  block_savedest(obj300);
  Object closure315 = createclosure(3, "new()object");
  setclosureframe(closure315, stackframe);
  addtoclosure(closure315, var_Token);
  addtoclosure(closure315, var_startPosition);
  addtoclosure(closure315, var_linePosition);
  Method *meth_meth_lexer_new302_object = addmethod2pos(obj300, "new()object", &meth_lexer_new302_object, 1);
  meth_meth_lexer_new302_object->definitionModule = modulename;
  meth_meth_lexer_new302_object->definitionLine = 137;
  sourceObject = obj300;
objclass300 = obj300->class;
  objclass300->definitionModule = modulename;
  objclass300->definitionLine = 137;
  (*(struct UserObject *)self).data[0] = lowerouter300;
  self = oldself300;
  selfslot = oldselfslot300;
  stackframe = oldstackframe300;
// compiled object node returning obj300 (depth = 5)
  *var_NumToken = obj300;
  if (obj300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject316 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj316 = alloc_userobj2(2,4, objclass316);
  gc_frame_newslot(obj316);
// OBJECT OUTER DEC outer
  adddatum2(obj316, self, 0);
  addmethodreal(obj316,"outer", &reader_lexer_outer_317);
  Object oldself316 = self;
  struct StackFrameObject *oldstackframe316 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe316);
  gc_frame_newslot((Object)stackframe);
  self = obj316;
  Object *oldselfslot316 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter316 = (*(struct UserObject *)self).data[0], lowerouter316 = thisouter316;
  if (inheritingObject316) {
    struct UserObject *inho316 = (struct UserObject *)inheritingObject316;
    while (inho316->super != GraceDefaultObject) inho316 = (struct UserObject *)inho316->super;
    inho316->super = obj316;
    self = inheritingObject316;
    *selfslot = self;
    lowerouter316 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter316;
  }
// method new
  block_savedest(obj316);
  Object closure318 = createclosure(1, "new");
  setclosureframe(closure318, stackframe);
  addtoclosure(closure318, var_Token);
  struct UserObject *uo318 = (struct UserObject*)obj316;
  uo318->data[1] = (Object)closure318;
  Method *meth_meth_lexer_new318 = addmethod2pos(obj316, "new", &meth_lexer_new318, 1);
  int argcv_meth_lexer_new318[] = {1};
  meth_meth_lexer_new318->type = alloc_MethodType(1, argcv_meth_lexer_new318);
  meth_meth_lexer_new318->definitionModule = modulename;
  meth_meth_lexer_new318->definitionLine = 144;
  block_savedest(obj316);
  Object closure329 = createclosure(1, "new()object");
  setclosureframe(closure329, stackframe);
  addtoclosure(closure329, var_Token);
  Method *meth_meth_lexer_new318_object = addmethod2pos(obj316, "new()object", &meth_lexer_new318_object, 1);
  meth_meth_lexer_new318_object->definitionModule = modulename;
  meth_meth_lexer_new318_object->definitionLine = 144;
  sourceObject = obj316;
objclass316 = obj316->class;
  objclass316->definitionModule = modulename;
  objclass316->definitionLine = 144;
  (*(struct UserObject *)self).data[0] = lowerouter316;
  self = oldself316;
  selfslot = oldselfslot316;
  stackframe = oldstackframe316;
// compiled object node returning obj316 (depth = 5)
  *var_KeywordToken = obj316;
  if (obj316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject330 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj330 = alloc_userobj2(2,4, objclass330);
  gc_frame_newslot(obj330);
// OBJECT OUTER DEC outer
  adddatum2(obj330, self, 0);
  addmethodreal(obj330,"outer", &reader_lexer_outer_331);
  Object oldself330 = self;
  struct StackFrameObject *oldstackframe330 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe330);
  gc_frame_newslot((Object)stackframe);
  self = obj330;
  Object *oldselfslot330 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter330 = (*(struct UserObject *)self).data[0], lowerouter330 = thisouter330;
  if (inheritingObject330) {
    struct UserObject *inho330 = (struct UserObject *)inheritingObject330;
    while (inho330->super != GraceDefaultObject) inho330 = (struct UserObject *)inho330->super;
    inho330->super = obj330;
    self = inheritingObject330;
    *selfslot = self;
    lowerouter330 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter330;
  }
// method new
  block_savedest(obj330);
  Object closure332 = createclosure(1, "new");
  setclosureframe(closure332, stackframe);
  addtoclosure(closure332, var_Token);
  struct UserObject *uo332 = (struct UserObject*)obj330;
  uo332->data[1] = (Object)closure332;
  Method *meth_meth_lexer_new332 = addmethod2pos(obj330, "new", &meth_lexer_new332, 1);
  int argcv_meth_lexer_new332[] = {1};
  meth_meth_lexer_new332->type = alloc_MethodType(1, argcv_meth_lexer_new332);
  meth_meth_lexer_new332->definitionModule = modulename;
  meth_meth_lexer_new332->definitionLine = 150;
  block_savedest(obj330);
  Object closure343 = createclosure(1, "new()object");
  setclosureframe(closure343, stackframe);
  addtoclosure(closure343, var_Token);
  Method *meth_meth_lexer_new332_object = addmethod2pos(obj330, "new()object", &meth_lexer_new332_object, 1);
  meth_meth_lexer_new332_object->definitionModule = modulename;
  meth_meth_lexer_new332_object->definitionLine = 150;
  sourceObject = obj330;
objclass330 = obj330->class;
  objclass330->definitionModule = modulename;
  objclass330->definitionLine = 150;
  (*(struct UserObject *)self).data[0] = lowerouter330;
  self = oldself330;
  selfslot = oldselfslot330;
  stackframe = oldstackframe330;
// compiled object node returning obj330 (depth = 5)
  *var_OpToken = obj330;
  if (obj330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject344 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj344 = alloc_userobj2(2,4, objclass344);
  gc_frame_newslot(obj344);
// OBJECT OUTER DEC outer
  adddatum2(obj344, self, 0);
  addmethodreal(obj344,"outer", &reader_lexer_outer_345);
  Object oldself344 = self;
  struct StackFrameObject *oldstackframe344 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe344);
  gc_frame_newslot((Object)stackframe);
  self = obj344;
  Object *oldselfslot344 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter344 = (*(struct UserObject *)self).data[0], lowerouter344 = thisouter344;
  if (inheritingObject344) {
    struct UserObject *inho344 = (struct UserObject *)inheritingObject344;
    while (inho344->super != GraceDefaultObject) inho344 = (struct UserObject *)inho344->super;
    inho344->super = obj344;
    self = inheritingObject344;
    *selfslot = self;
    lowerouter344 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter344;
  }
// method new
  block_savedest(obj344);
  Object closure346 = createclosure(1, "new");
  setclosureframe(closure346, stackframe);
  addtoclosure(closure346, var_Token);
  struct UserObject *uo346 = (struct UserObject*)obj344;
  uo346->data[1] = (Object)closure346;
  Method *meth_meth_lexer_new346 = addmethod2pos(obj344, "new", &meth_lexer_new346, 1);
  int argcv_meth_lexer_new346[] = {0};
  meth_meth_lexer_new346->type = alloc_MethodType(1, argcv_meth_lexer_new346);
  meth_meth_lexer_new346->definitionModule = modulename;
  meth_meth_lexer_new346->definitionLine = 156;
  block_savedest(obj344);
  Object closure357 = createclosure(1, "new()object");
  setclosureframe(closure357, stackframe);
  addtoclosure(closure357, var_Token);
  Method *meth_meth_lexer_new346_object = addmethod2pos(obj344, "new()object", &meth_lexer_new346_object, 1);
  meth_meth_lexer_new346_object->definitionModule = modulename;
  meth_meth_lexer_new346_object->definitionLine = 156;
  sourceObject = obj344;
objclass344 = obj344->class;
  objclass344->definitionModule = modulename;
  objclass344->definitionLine = 156;
  (*(struct UserObject *)self).data[0] = lowerouter344;
  self = oldself344;
  selfslot = oldselfslot344;
  stackframe = oldstackframe344;
// compiled object node returning obj344 (depth = 5)
  *var_ArrowToken = obj344;
  if (obj344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject358 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj358 = alloc_userobj2(2,4, objclass358);
  gc_frame_newslot(obj358);
// OBJECT OUTER DEC outer
  adddatum2(obj358, self, 0);
  addmethodreal(obj358,"outer", &reader_lexer_outer_359);
  Object oldself358 = self;
  struct StackFrameObject *oldstackframe358 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe358);
  gc_frame_newslot((Object)stackframe);
  self = obj358;
  Object *oldselfslot358 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter358 = (*(struct UserObject *)self).data[0], lowerouter358 = thisouter358;
  if (inheritingObject358) {
    struct UserObject *inho358 = (struct UserObject *)inheritingObject358;
    while (inho358->super != GraceDefaultObject) inho358 = (struct UserObject *)inho358->super;
    inho358->super = obj358;
    self = inheritingObject358;
    *selfslot = self;
    lowerouter358 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter358;
  }
// method new
  block_savedest(obj358);
  Object closure360 = createclosure(1, "new");
  setclosureframe(closure360, stackframe);
  addtoclosure(closure360, var_Token);
  struct UserObject *uo360 = (struct UserObject*)obj358;
  uo360->data[1] = (Object)closure360;
  Method *meth_meth_lexer_new360 = addmethod2pos(obj358, "new", &meth_lexer_new360, 1);
  int argcv_meth_lexer_new360[] = {0};
  meth_meth_lexer_new360->type = alloc_MethodType(1, argcv_meth_lexer_new360);
  meth_meth_lexer_new360->definitionModule = modulename;
  meth_meth_lexer_new360->definitionLine = 162;
  block_savedest(obj358);
  Object closure371 = createclosure(1, "new()object");
  setclosureframe(closure371, stackframe);
  addtoclosure(closure371, var_Token);
  Method *meth_meth_lexer_new360_object = addmethod2pos(obj358, "new()object", &meth_lexer_new360_object, 1);
  meth_meth_lexer_new360_object->definitionModule = modulename;
  meth_meth_lexer_new360_object->definitionLine = 162;
  sourceObject = obj358;
objclass358 = obj358->class;
  objclass358->definitionModule = modulename;
  objclass358->definitionLine = 162;
  (*(struct UserObject *)self).data[0] = lowerouter358;
  self = oldself358;
  selfslot = oldselfslot358;
  stackframe = oldstackframe358;
// compiled object node returning obj358 (depth = 5)
  *var_BindToken = obj358;
  if (obj358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject372 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj372 = alloc_userobj2(2,4, objclass372);
  gc_frame_newslot(obj372);
// OBJECT OUTER DEC outer
  adddatum2(obj372, self, 0);
  addmethodreal(obj372,"outer", &reader_lexer_outer_373);
  Object oldself372 = self;
  struct StackFrameObject *oldstackframe372 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe372);
  gc_frame_newslot((Object)stackframe);
  self = obj372;
  Object *oldselfslot372 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter372 = (*(struct UserObject *)self).data[0], lowerouter372 = thisouter372;
  if (inheritingObject372) {
    struct UserObject *inho372 = (struct UserObject *)inheritingObject372;
    while (inho372->super != GraceDefaultObject) inho372 = (struct UserObject *)inho372->super;
    inho372->super = obj372;
    self = inheritingObject372;
    *selfslot = self;
    lowerouter372 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter372;
  }
// method new
  block_savedest(obj372);
  Object closure374 = createclosure(1, "new");
  setclosureframe(closure374, stackframe);
  addtoclosure(closure374, var_Token);
  struct UserObject *uo374 = (struct UserObject*)obj372;
  uo374->data[1] = (Object)closure374;
  Method *meth_meth_lexer_new374 = addmethod2pos(obj372, "new", &meth_lexer_new374, 1);
  int argcv_meth_lexer_new374[] = {0};
  meth_meth_lexer_new374->type = alloc_MethodType(1, argcv_meth_lexer_new374);
  meth_meth_lexer_new374->definitionModule = modulename;
  meth_meth_lexer_new374->definitionLine = 168;
  block_savedest(obj372);
  Object closure385 = createclosure(1, "new()object");
  setclosureframe(closure385, stackframe);
  addtoclosure(closure385, var_Token);
  Method *meth_meth_lexer_new374_object = addmethod2pos(obj372, "new()object", &meth_lexer_new374_object, 1);
  meth_meth_lexer_new374_object->definitionModule = modulename;
  meth_meth_lexer_new374_object->definitionLine = 168;
  sourceObject = obj372;
objclass372 = obj372->class;
  objclass372->definitionModule = modulename;
  objclass372->definitionLine = 168;
  (*(struct UserObject *)self).data[0] = lowerouter372;
  self = oldself372;
  selfslot = oldselfslot372;
  stackframe = oldstackframe372;
// compiled object node returning obj372 (depth = 5)
  *var_SemicolonToken = obj372;
  if (obj372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject386 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj386 = alloc_userobj2(2,4, objclass386);
  gc_frame_newslot(obj386);
// OBJECT OUTER DEC outer
  adddatum2(obj386, self, 0);
  addmethodreal(obj386,"outer", &reader_lexer_outer_387);
  Object oldself386 = self;
  struct StackFrameObject *oldstackframe386 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe386);
  gc_frame_newslot((Object)stackframe);
  self = obj386;
  Object *oldselfslot386 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter386 = (*(struct UserObject *)self).data[0], lowerouter386 = thisouter386;
  if (inheritingObject386) {
    struct UserObject *inho386 = (struct UserObject *)inheritingObject386;
    while (inho386->super != GraceDefaultObject) inho386 = (struct UserObject *)inho386->super;
    inho386->super = obj386;
    self = inheritingObject386;
    *selfslot = self;
    lowerouter386 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter386;
  }
// method new
  block_savedest(obj386);
  Object closure388 = createclosure(1, "new");
  setclosureframe(closure388, stackframe);
  addtoclosure(closure388, var_Token);
  struct UserObject *uo388 = (struct UserObject*)obj386;
  uo388->data[1] = (Object)closure388;
  Method *meth_meth_lexer_new388 = addmethod2pos(obj386, "new", &meth_lexer_new388, 1);
  int argcv_meth_lexer_new388[] = {0};
  meth_meth_lexer_new388->type = alloc_MethodType(1, argcv_meth_lexer_new388);
  meth_meth_lexer_new388->definitionModule = modulename;
  meth_meth_lexer_new388->definitionLine = 174;
  block_savedest(obj386);
  Object closure399 = createclosure(1, "new()object");
  setclosureframe(closure399, stackframe);
  addtoclosure(closure399, var_Token);
  Method *meth_meth_lexer_new388_object = addmethod2pos(obj386, "new()object", &meth_lexer_new388_object, 1);
  meth_meth_lexer_new388_object->definitionModule = modulename;
  meth_meth_lexer_new388_object->definitionLine = 174;
  sourceObject = obj386;
objclass386 = obj386->class;
  objclass386->definitionModule = modulename;
  objclass386->definitionLine = 174;
  (*(struct UserObject *)self).data[0] = lowerouter386;
  self = oldself386;
  selfslot = oldselfslot386;
  stackframe = oldstackframe386;
// compiled object node returning obj386 (depth = 5)
  *var_LGenericToken = obj386;
  if (obj386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject400 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj400 = alloc_userobj2(2,4, objclass400);
  gc_frame_newslot(obj400);
// OBJECT OUTER DEC outer
  adddatum2(obj400, self, 0);
  addmethodreal(obj400,"outer", &reader_lexer_outer_401);
  Object oldself400 = self;
  struct StackFrameObject *oldstackframe400 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe400);
  gc_frame_newslot((Object)stackframe);
  self = obj400;
  Object *oldselfslot400 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter400 = (*(struct UserObject *)self).data[0], lowerouter400 = thisouter400;
  if (inheritingObject400) {
    struct UserObject *inho400 = (struct UserObject *)inheritingObject400;
    while (inho400->super != GraceDefaultObject) inho400 = (struct UserObject *)inho400->super;
    inho400->super = obj400;
    self = inheritingObject400;
    *selfslot = self;
    lowerouter400 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter400;
  }
// method new
  block_savedest(obj400);
  Object closure402 = createclosure(1, "new");
  setclosureframe(closure402, stackframe);
  addtoclosure(closure402, var_Token);
  struct UserObject *uo402 = (struct UserObject*)obj400;
  uo402->data[1] = (Object)closure402;
  Method *meth_meth_lexer_new402 = addmethod2pos(obj400, "new", &meth_lexer_new402, 1);
  int argcv_meth_lexer_new402[] = {0};
  meth_meth_lexer_new402->type = alloc_MethodType(1, argcv_meth_lexer_new402);
  meth_meth_lexer_new402->definitionModule = modulename;
  meth_meth_lexer_new402->definitionLine = 180;
  block_savedest(obj400);
  Object closure413 = createclosure(1, "new()object");
  setclosureframe(closure413, stackframe);
  addtoclosure(closure413, var_Token);
  Method *meth_meth_lexer_new402_object = addmethod2pos(obj400, "new()object", &meth_lexer_new402_object, 1);
  meth_meth_lexer_new402_object->definitionModule = modulename;
  meth_meth_lexer_new402_object->definitionLine = 180;
  sourceObject = obj400;
objclass400 = obj400->class;
  objclass400->definitionModule = modulename;
  objclass400->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter400;
  self = oldself400;
  selfslot = oldselfslot400;
  stackframe = oldstackframe400;
// compiled object node returning obj400 (depth = 5)
  *var_RGenericToken = obj400;
  if (obj400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject414 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj414 = alloc_userobj2(7,8, objclass414);
  gc_frame_newslot(obj414);
if (objclass414 == NULL) {
  glfree(obj414->class->name);
  obj414->class->name = "obj60.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj414, self, 0);
  addmethodreal(obj414,"outer", &reader_lexer_outer_415);
  Object oldself414 = self;
  struct StackFrameObject *oldstackframe414 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe414);
  gc_frame_newslot((Object)stackframe);
  self = obj414;
  Object *oldselfslot414 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter414 = (*(struct UserObject *)self).data[0], lowerouter414 = thisouter414;
  if (inheritingObject414) {
    struct UserObject *inho414 = (struct UserObject *)inheritingObject414;
    while (inho414->super != GraceDefaultObject) inho414 = (struct UserObject *)inho414->super;
    inho414->super = obj414;
    self = inheritingObject414;
    *selfslot = self;
    lowerouter414 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter414;
  }
// method modechange
  block_savedest(obj414);
  Object closure416 = createclosure(27, "modechange");
  setclosureframe(closure416, stackframe);
  addtoclosure(closure416, var_IdentifierToken);
  addtoclosure(closure416, var_KeywordToken);
  addtoclosure(closure416, var_StringToken);
  addtoclosure(closure416, var_OctetsToken);
  addtoclosure(closure416, var_CommaToken);
  addtoclosure(closure416, var_DotToken);
  addtoclosure(closure416, var_LBraceToken);
  addtoclosure(closure416, var_RBraceToken);
  addtoclosure(closure416, var_LParenToken);
  addtoclosure(closure416, var_RParenToken);
  addtoclosure(closure416, var_LSquareToken);
  addtoclosure(closure416, var_RSquareToken);
  addtoclosure(closure416, var_LGenericToken);
  addtoclosure(closure416, var_RGenericToken);
  addtoclosure(closure416, var_SemicolonToken);
  addtoclosure(closure416, var_NumToken);
  addtoclosure(closure416, var_errormessages);
  addtoclosure(closure416, var_linePosition);
  addtoclosure(closure416, var_lineNumber);
  addtoclosure(closure416, var_OpToken);
  addtoclosure(closure416, var_ArrowToken);
  addtoclosure(closure416, var_BindToken);
  addtoclosure(closure416, var_ColonToken);
  addtoclosure(closure416, var_indentLevel);
  addtoclosure(closure416, var_CommentToken);
  addtoclosure(closure416, var_util);
  addtoclosure(closure416, var_startPosition);
  struct UserObject *uo416 = (struct UserObject*)obj414;
  uo416->data[1] = (Object)closure416;
  Method *meth_meth_lexer_modechange416 = addmethod2pos(obj414, "modechange", &meth_lexer_modechange416, 1);
  int argcv_meth_lexer_modechange416[] = {3};
  meth_meth_lexer_modechange416->type = alloc_MethodType(1, argcv_meth_lexer_modechange416);
  meth_meth_lexer_modechange416->definitionModule = modulename;
  meth_meth_lexer_modechange416->definitionLine = 204;
// method fromBase
  block_savedest(obj414);
  Object closure1140 = createclosure(4, "fromBase");
  setclosureframe(closure1140, stackframe);
  addtoclosure(closure1140, var_errormessages);
  addtoclosure(closure1140, var_linePosition);
  addtoclosure(closure1140, var_lineNumber);
  addtoclosure(closure1140, var_unicode);
  struct UserObject *uo1140 = (struct UserObject*)obj414;
  uo1140->data[2] = (Object)closure1140;
  Method *meth_meth_lexer_fromBase1140 = addmethod2pos(obj414, "fromBase", &meth_lexer_fromBase1140, 2);
  int argcv_meth_lexer_fromBase1140[] = {2};
  meth_meth_lexer_fromBase1140->type = alloc_MethodType(1, argcv_meth_lexer_fromBase1140);
  meth_meth_lexer_fromBase1140->definitionModule = modulename;
  meth_meth_lexer_fromBase1140->definitionLine = 377;
// method makeNumToken
  block_savedest(obj414);
  Object closure1356 = createclosure(4, "makeNumToken");
  setclosureframe(closure1356, stackframe);
  addtoclosure(closure1356, var_errormessages);
  addtoclosure(closure1356, var_linePosition);
  addtoclosure(closure1356, var_lineNumber);
  addtoclosure(closure1356, var_NumToken);
  struct UserObject *uo1356 = (struct UserObject*)obj414;
  uo1356->data[3] = (Object)closure1356;
  Method *meth_meth_lexer_makeNumToken1356 = addmethod2pos(obj414, "makeNumToken", &meth_lexer_makeNumToken1356, 3);
  int argcv_meth_lexer_makeNumToken1356[] = {1};
  meth_meth_lexer_makeNumToken1356->type = alloc_MethodType(1, argcv_meth_lexer_makeNumToken1356);
  meth_meth_lexer_makeNumToken1356->definitionModule = modulename;
  meth_meth_lexer_makeNumToken1356->definitionLine = 418;
// method isidentifierchar
  block_savedest(obj414);
  Object closure1535 = createclosure(1, "isidentifierchar");
  setclosureframe(closure1535, stackframe);
  addtoclosure(closure1535, var_unicode);
  struct UserObject *uo1535 = (struct UserObject*)obj414;
  uo1535->data[4] = (Object)closure1535;
  Method *meth_meth_lexer_isidentifierchar1535 = addmethod2pos(obj414, "isidentifierchar", &meth_lexer_isidentifierchar1535, 4);
  int argcv_meth_lexer_isidentifierchar1535[] = {1};
  meth_meth_lexer_isidentifierchar1535->type = alloc_MethodType(1, argcv_meth_lexer_isidentifierchar1535);
  meth_meth_lexer_isidentifierchar1535->definitionModule = modulename;
  meth_meth_lexer_isidentifierchar1535->definitionLine = 463;
// method isoperatorchar
  block_savedest(obj414);
  Object closure1558 = createclosure(1, "isoperatorchar");
  setclosureframe(closure1558, stackframe);
  addtoclosure(closure1558, var_unicode);
  struct UserObject *uo1558 = (struct UserObject*)obj414;
  uo1558->data[5] = (Object)closure1558;
  Method *meth_meth_lexer_isoperatorchar1558 = addmethod2pos(obj414, "isoperatorchar", &meth_lexer_isoperatorchar1558, 5);
  int argcv_meth_lexer_isoperatorchar1558[] = {2};
  meth_meth_lexer_isoperatorchar1558->type = alloc_MethodType(1, argcv_meth_lexer_isoperatorchar1558);
  meth_meth_lexer_isoperatorchar1558->definitionModule = modulename;
  meth_meth_lexer_isoperatorchar1558->definitionLine = 479;
// method lexfile
  block_savedest(obj414);
  Object closure1652 = createclosure(1, "lexfile");
  setclosureframe(closure1652, stackframe);
  addtoclosure(closure1652, var_util);
  struct UserObject *uo1652 = (struct UserObject*)obj414;
  uo1652->data[6] = (Object)closure1652;
  Method *meth_meth_lexer_lexfile1652 = addmethod2pos(obj414, "lexfile", &meth_lexer_lexfile1652, 6);
  int argcv_meth_lexer_lexfile1652[] = {1};
  meth_meth_lexer_lexfile1652->type = alloc_MethodType(1, argcv_meth_lexer_lexfile1652);
  meth_meth_lexer_lexfile1652->definitionModule = modulename;
  meth_meth_lexer_lexfile1652->definitionLine = 496;
// method lexinput
  block_savedest(obj414);
  Object closure1750 = createclosure(6, "lexinput");
  setclosureframe(closure1750, stackframe);
  addtoclosure(closure1750, var_linePosition);
  addtoclosure(closure1750, var_util);
  addtoclosure(closure1750, var_unicode);
  addtoclosure(closure1750, var_errormessages);
  addtoclosure(closure1750, var_lineNumber);
  addtoclosure(closure1750, var_startPosition);
  struct UserObject *uo1750 = (struct UserObject*)obj414;
  uo1750->data[7] = (Object)closure1750;
  Method *meth_meth_lexer_lexinput1750 = addmethod2pos(obj414, "lexinput", &meth_lexer_lexinput1750, 7);
  int argcv_meth_lexer_lexinput1750[] = {1};
  meth_meth_lexer_lexinput1750->type = alloc_MethodType(1, argcv_meth_lexer_lexinput1750);
  meth_meth_lexer_lexinput1750->definitionModule = modulename;
  meth_meth_lexer_lexinput1750->definitionLine = 531;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
objclass414 = obj414->class;
  objclass414->definitionModule = modulename;
  objclass414->definitionLine = 187;
  (*(struct UserObject *)self).data[0] = lowerouter414;
  self = oldself414;
  selfslot = oldselfslot414;
  stackframe = oldstackframe414;
  gc_frame_end(frame);
  return obj414;
}
Object meth_lexer_new64_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_unicode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lineNumber = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lineNumber");
  Object *var_linePosition = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "linePosition");
  Object *var_startPosition = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startPosition");
  Object *var_indentLevel = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "indentLevel");
  Object *var_Token = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "Token");
  Object *var_IdentifierToken = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "IdentifierToken");
  Object *var_StringToken = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "StringToken");
  Object *var_CommentToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "CommentToken");
  Object *var_OctetsToken = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "OctetsToken");
  Object *var_LBraceToken = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "LBraceToken");
  Object *var_RBraceToken = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "RBraceToken");
  Object *var_LParenToken = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "LParenToken");
  Object *var_RParenToken = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "RParenToken");
  Object *var_LSquareToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "LSquareToken");
  Object *var_RSquareToken = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "RSquareToken");
  Object *var_CommaToken = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "CommaToken");
  Object *var_ColonToken = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "ColonToken");
  Object *var_DotToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "DotToken");
  Object *var_NumToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "NumToken");
  Object *var_KeywordToken = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "KeywordToken");
  Object *var_OpToken = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "OpToken");
  Object *var_ArrowToken = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "ArrowToken");
  Object *var_BindToken = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "BindToken");
  Object *var_SemicolonToken = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "SemicolonToken");
  Object *var_LGenericToken = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "LGenericToken");
  Object *var_RGenericToken = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "RGenericToken");
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num65 = alloc_Float64(1);
// compiled num node returning num65 (depth = 4)
  *var_lineNumber = num65;
  if (num65 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num66 = alloc_Float64(0);
// compiled num node returning num66 (depth = 4)
  *var_linePosition = num66;
  if (num66 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num67 = alloc_Float64(1);
// compiled num node returning num67 (depth = 4)
  *var_startPosition = num67;
  if (num67 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num68 = alloc_Float64(0);
// compiled num node returning num68 (depth = 4)
  *var_indentLevel = num68;
  if (num68 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject69 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj69 = alloc_userobj2(2,4, objclass69);
  gc_frame_newslot(obj69);
// OBJECT OUTER DEC outer
  adddatum2(obj69, self, 0);
  addmethodreal(obj69,"outer", &reader_lexer_outer_70);
  Object oldself69 = self;
  struct StackFrameObject *oldstackframe69 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe69);
  gc_frame_newslot((Object)stackframe);
  self = obj69;
  Object *oldselfslot69 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter69 = (*(struct UserObject *)self).data[0], lowerouter69 = thisouter69;
  if (inheritingObject69) {
    struct UserObject *inho69 = (struct UserObject *)inheritingObject69;
    while (inho69->super != GraceDefaultObject) inho69 = (struct UserObject *)inho69->super;
    inho69->super = obj69;
    self = inheritingObject69;
    *selfslot = self;
    lowerouter69 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter69;
  }
// method new
  block_savedest(obj69);
  Object closure71 = createclosure(3, "new");
  setclosureframe(closure71, stackframe);
  addtoclosure(closure71, var_lineNumber);
  addtoclosure(closure71, var_indentLevel);
  addtoclosure(closure71, var_startPosition);
  struct UserObject *uo71 = (struct UserObject*)obj69;
  uo71->data[1] = (Object)closure71;
  Method *meth_meth_lexer_new71 = addmethod2pos(obj69, "new", &meth_lexer_new71, 1);
  int argcv_meth_lexer_new71[] = {0};
  meth_meth_lexer_new71->type = alloc_MethodType(1, argcv_meth_lexer_new71);
  meth_meth_lexer_new71->definitionModule = modulename;
  meth_meth_lexer_new71->definitionLine = 42;
  block_savedest(obj69);
  Object closure105 = createclosure(3, "new()object");
  setclosureframe(closure105, stackframe);
  addtoclosure(closure105, var_lineNumber);
  addtoclosure(closure105, var_indentLevel);
  addtoclosure(closure105, var_startPosition);
  Method *meth_meth_lexer_new71_object = addmethod2pos(obj69, "new()object", &meth_lexer_new71_object, 1);
  meth_meth_lexer_new71_object->definitionModule = modulename;
  meth_meth_lexer_new71_object->definitionLine = 42;
  sourceObject = obj69;
objclass69 = obj69->class;
  objclass69->definitionModule = modulename;
  objclass69->definitionLine = 42;
  (*(struct UserObject *)self).data[0] = lowerouter69;
  self = oldself69;
  selfslot = oldselfslot69;
  stackframe = oldstackframe69;
// compiled object node returning obj69 (depth = 5)
  *var_Token = obj69;
  if (obj69 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject106 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj106 = alloc_userobj2(2,4, objclass106);
  gc_frame_newslot(obj106);
// OBJECT OUTER DEC outer
  adddatum2(obj106, self, 0);
  addmethodreal(obj106,"outer", &reader_lexer_outer_107);
  Object oldself106 = self;
  struct StackFrameObject *oldstackframe106 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe106);
  gc_frame_newslot((Object)stackframe);
  self = obj106;
  Object *oldselfslot106 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter106 = (*(struct UserObject *)self).data[0], lowerouter106 = thisouter106;
  if (inheritingObject106) {
    struct UserObject *inho106 = (struct UserObject *)inheritingObject106;
    while (inho106->super != GraceDefaultObject) inho106 = (struct UserObject *)inho106->super;
    inho106->super = obj106;
    self = inheritingObject106;
    *selfslot = self;
    lowerouter106 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter106;
  }
// method new
  block_savedest(obj106);
  Object closure108 = createclosure(1, "new");
  setclosureframe(closure108, stackframe);
  addtoclosure(closure108, var_Token);
  struct UserObject *uo108 = (struct UserObject*)obj106;
  uo108->data[1] = (Object)closure108;
  Method *meth_meth_lexer_new108 = addmethod2pos(obj106, "new", &meth_lexer_new108, 1);
  int argcv_meth_lexer_new108[] = {1};
  meth_meth_lexer_new108->type = alloc_MethodType(1, argcv_meth_lexer_new108);
  meth_meth_lexer_new108->definitionModule = modulename;
  meth_meth_lexer_new108->definitionLine = 59;
  block_savedest(obj106);
  Object closure119 = createclosure(1, "new()object");
  setclosureframe(closure119, stackframe);
  addtoclosure(closure119, var_Token);
  Method *meth_meth_lexer_new108_object = addmethod2pos(obj106, "new()object", &meth_lexer_new108_object, 1);
  meth_meth_lexer_new108_object->definitionModule = modulename;
  meth_meth_lexer_new108_object->definitionLine = 59;
  sourceObject = obj106;
objclass106 = obj106->class;
  objclass106->definitionModule = modulename;
  objclass106->definitionLine = 59;
  (*(struct UserObject *)self).data[0] = lowerouter106;
  self = oldself106;
  selfslot = oldselfslot106;
  stackframe = oldstackframe106;
// compiled object node returning obj106 (depth = 5)
  *var_IdentifierToken = obj106;
  if (obj106 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject120 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj120 = alloc_userobj2(2,4, objclass120);
  gc_frame_newslot(obj120);
// OBJECT OUTER DEC outer
  adddatum2(obj120, self, 0);
  addmethodreal(obj120,"outer", &reader_lexer_outer_121);
  Object oldself120 = self;
  struct StackFrameObject *oldstackframe120 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe120);
  gc_frame_newslot((Object)stackframe);
  self = obj120;
  Object *oldselfslot120 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter120 = (*(struct UserObject *)self).data[0], lowerouter120 = thisouter120;
  if (inheritingObject120) {
    struct UserObject *inho120 = (struct UserObject *)inheritingObject120;
    while (inho120->super != GraceDefaultObject) inho120 = (struct UserObject *)inho120->super;
    inho120->super = obj120;
    self = inheritingObject120;
    *selfslot = self;
    lowerouter120 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter120;
  }
// method new
  block_savedest(obj120);
  Object closure122 = createclosure(1, "new");
  setclosureframe(closure122, stackframe);
  addtoclosure(closure122, var_Token);
  struct UserObject *uo122 = (struct UserObject*)obj120;
  uo122->data[1] = (Object)closure122;
  Method *meth_meth_lexer_new122 = addmethod2pos(obj120, "new", &meth_lexer_new122, 1);
  int argcv_meth_lexer_new122[] = {1};
  meth_meth_lexer_new122->type = alloc_MethodType(1, argcv_meth_lexer_new122);
  meth_meth_lexer_new122->definitionModule = modulename;
  meth_meth_lexer_new122->definitionLine = 65;
  block_savedest(obj120);
  Object closure137 = createclosure(1, "new()object");
  setclosureframe(closure137, stackframe);
  addtoclosure(closure137, var_Token);
  Method *meth_meth_lexer_new122_object = addmethod2pos(obj120, "new()object", &meth_lexer_new122_object, 1);
  meth_meth_lexer_new122_object->definitionModule = modulename;
  meth_meth_lexer_new122_object->definitionLine = 65;
  sourceObject = obj120;
objclass120 = obj120->class;
  objclass120->definitionModule = modulename;
  objclass120->definitionLine = 65;
  (*(struct UserObject *)self).data[0] = lowerouter120;
  self = oldself120;
  selfslot = oldselfslot120;
  stackframe = oldstackframe120;
// compiled object node returning obj120 (depth = 5)
  *var_StringToken = obj120;
  if (obj120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject138 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj138 = alloc_userobj2(2,4, objclass138);
  gc_frame_newslot(obj138);
// OBJECT OUTER DEC outer
  adddatum2(obj138, self, 0);
  addmethodreal(obj138,"outer", &reader_lexer_outer_139);
  Object oldself138 = self;
  struct StackFrameObject *oldstackframe138 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe138);
  gc_frame_newslot((Object)stackframe);
  self = obj138;
  Object *oldselfslot138 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter138 = (*(struct UserObject *)self).data[0], lowerouter138 = thisouter138;
  if (inheritingObject138) {
    struct UserObject *inho138 = (struct UserObject *)inheritingObject138;
    while (inho138->super != GraceDefaultObject) inho138 = (struct UserObject *)inho138->super;
    inho138->super = obj138;
    self = inheritingObject138;
    *selfslot = self;
    lowerouter138 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter138;
  }
// method new
  block_savedest(obj138);
  Object closure140 = createclosure(1, "new");
  setclosureframe(closure140, stackframe);
  addtoclosure(closure140, var_Token);
  struct UserObject *uo140 = (struct UserObject*)obj138;
  uo140->data[1] = (Object)closure140;
  Method *meth_meth_lexer_new140 = addmethod2pos(obj138, "new", &meth_lexer_new140, 1);
  int argcv_meth_lexer_new140[] = {1};
  meth_meth_lexer_new140->type = alloc_MethodType(1, argcv_meth_lexer_new140);
  meth_meth_lexer_new140->definitionModule = modulename;
  meth_meth_lexer_new140->definitionLine = 71;
  block_savedest(obj138);
  Object closure155 = createclosure(1, "new()object");
  setclosureframe(closure155, stackframe);
  addtoclosure(closure155, var_Token);
  Method *meth_meth_lexer_new140_object = addmethod2pos(obj138, "new()object", &meth_lexer_new140_object, 1);
  meth_meth_lexer_new140_object->definitionModule = modulename;
  meth_meth_lexer_new140_object->definitionLine = 71;
  sourceObject = obj138;
objclass138 = obj138->class;
  objclass138->definitionModule = modulename;
  objclass138->definitionLine = 71;
  (*(struct UserObject *)self).data[0] = lowerouter138;
  self = oldself138;
  selfslot = oldselfslot138;
  stackframe = oldstackframe138;
// compiled object node returning obj138 (depth = 5)
  *var_CommentToken = obj138;
  if (obj138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject156 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj156 = alloc_userobj2(2,4, objclass156);
  gc_frame_newslot(obj156);
// OBJECT OUTER DEC outer
  adddatum2(obj156, self, 0);
  addmethodreal(obj156,"outer", &reader_lexer_outer_157);
  Object oldself156 = self;
  struct StackFrameObject *oldstackframe156 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe156);
  gc_frame_newslot((Object)stackframe);
  self = obj156;
  Object *oldselfslot156 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter156 = (*(struct UserObject *)self).data[0], lowerouter156 = thisouter156;
  if (inheritingObject156) {
    struct UserObject *inho156 = (struct UserObject *)inheritingObject156;
    while (inho156->super != GraceDefaultObject) inho156 = (struct UserObject *)inho156->super;
    inho156->super = obj156;
    self = inheritingObject156;
    *selfslot = self;
    lowerouter156 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter156;
  }
// method new
  block_savedest(obj156);
  Object closure158 = createclosure(1, "new");
  setclosureframe(closure158, stackframe);
  addtoclosure(closure158, var_Token);
  struct UserObject *uo158 = (struct UserObject*)obj156;
  uo158->data[1] = (Object)closure158;
  Method *meth_meth_lexer_new158 = addmethod2pos(obj156, "new", &meth_lexer_new158, 1);
  int argcv_meth_lexer_new158[] = {1};
  meth_meth_lexer_new158->type = alloc_MethodType(1, argcv_meth_lexer_new158);
  meth_meth_lexer_new158->definitionModule = modulename;
  meth_meth_lexer_new158->definitionLine = 77;
  block_savedest(obj156);
  Object closure173 = createclosure(1, "new()object");
  setclosureframe(closure173, stackframe);
  addtoclosure(closure173, var_Token);
  Method *meth_meth_lexer_new158_object = addmethod2pos(obj156, "new()object", &meth_lexer_new158_object, 1);
  meth_meth_lexer_new158_object->definitionModule = modulename;
  meth_meth_lexer_new158_object->definitionLine = 77;
  sourceObject = obj156;
objclass156 = obj156->class;
  objclass156->definitionModule = modulename;
  objclass156->definitionLine = 77;
  (*(struct UserObject *)self).data[0] = lowerouter156;
  self = oldself156;
  selfslot = oldselfslot156;
  stackframe = oldstackframe156;
// compiled object node returning obj156 (depth = 5)
  *var_OctetsToken = obj156;
  if (obj156 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject174 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj174 = alloc_userobj2(2,4, objclass174);
  gc_frame_newslot(obj174);
// OBJECT OUTER DEC outer
  adddatum2(obj174, self, 0);
  addmethodreal(obj174,"outer", &reader_lexer_outer_175);
  Object oldself174 = self;
  struct StackFrameObject *oldstackframe174 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe174);
  gc_frame_newslot((Object)stackframe);
  self = obj174;
  Object *oldselfslot174 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter174 = (*(struct UserObject *)self).data[0], lowerouter174 = thisouter174;
  if (inheritingObject174) {
    struct UserObject *inho174 = (struct UserObject *)inheritingObject174;
    while (inho174->super != GraceDefaultObject) inho174 = (struct UserObject *)inho174->super;
    inho174->super = obj174;
    self = inheritingObject174;
    *selfslot = self;
    lowerouter174 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter174;
  }
// method new
  block_savedest(obj174);
  Object closure176 = createclosure(1, "new");
  setclosureframe(closure176, stackframe);
  addtoclosure(closure176, var_Token);
  struct UserObject *uo176 = (struct UserObject*)obj174;
  uo176->data[1] = (Object)closure176;
  Method *meth_meth_lexer_new176 = addmethod2pos(obj174, "new", &meth_lexer_new176, 1);
  int argcv_meth_lexer_new176[] = {0};
  meth_meth_lexer_new176->type = alloc_MethodType(1, argcv_meth_lexer_new176);
  meth_meth_lexer_new176->definitionModule = modulename;
  meth_meth_lexer_new176->definitionLine = 83;
  block_savedest(obj174);
  Object closure187 = createclosure(1, "new()object");
  setclosureframe(closure187, stackframe);
  addtoclosure(closure187, var_Token);
  Method *meth_meth_lexer_new176_object = addmethod2pos(obj174, "new()object", &meth_lexer_new176_object, 1);
  meth_meth_lexer_new176_object->definitionModule = modulename;
  meth_meth_lexer_new176_object->definitionLine = 83;
  sourceObject = obj174;
objclass174 = obj174->class;
  objclass174->definitionModule = modulename;
  objclass174->definitionLine = 83;
  (*(struct UserObject *)self).data[0] = lowerouter174;
  self = oldself174;
  selfslot = oldselfslot174;
  stackframe = oldstackframe174;
// compiled object node returning obj174 (depth = 5)
  *var_LBraceToken = obj174;
  if (obj174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject188 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj188 = alloc_userobj2(2,4, objclass188);
  gc_frame_newslot(obj188);
// OBJECT OUTER DEC outer
  adddatum2(obj188, self, 0);
  addmethodreal(obj188,"outer", &reader_lexer_outer_189);
  Object oldself188 = self;
  struct StackFrameObject *oldstackframe188 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe188);
  gc_frame_newslot((Object)stackframe);
  self = obj188;
  Object *oldselfslot188 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter188 = (*(struct UserObject *)self).data[0], lowerouter188 = thisouter188;
  if (inheritingObject188) {
    struct UserObject *inho188 = (struct UserObject *)inheritingObject188;
    while (inho188->super != GraceDefaultObject) inho188 = (struct UserObject *)inho188->super;
    inho188->super = obj188;
    self = inheritingObject188;
    *selfslot = self;
    lowerouter188 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter188;
  }
// method new
  block_savedest(obj188);
  Object closure190 = createclosure(1, "new");
  setclosureframe(closure190, stackframe);
  addtoclosure(closure190, var_Token);
  struct UserObject *uo190 = (struct UserObject*)obj188;
  uo190->data[1] = (Object)closure190;
  Method *meth_meth_lexer_new190 = addmethod2pos(obj188, "new", &meth_lexer_new190, 1);
  int argcv_meth_lexer_new190[] = {0};
  meth_meth_lexer_new190->type = alloc_MethodType(1, argcv_meth_lexer_new190);
  meth_meth_lexer_new190->definitionModule = modulename;
  meth_meth_lexer_new190->definitionLine = 89;
  block_savedest(obj188);
  Object closure201 = createclosure(1, "new()object");
  setclosureframe(closure201, stackframe);
  addtoclosure(closure201, var_Token);
  Method *meth_meth_lexer_new190_object = addmethod2pos(obj188, "new()object", &meth_lexer_new190_object, 1);
  meth_meth_lexer_new190_object->definitionModule = modulename;
  meth_meth_lexer_new190_object->definitionLine = 89;
  sourceObject = obj188;
objclass188 = obj188->class;
  objclass188->definitionModule = modulename;
  objclass188->definitionLine = 89;
  (*(struct UserObject *)self).data[0] = lowerouter188;
  self = oldself188;
  selfslot = oldselfslot188;
  stackframe = oldstackframe188;
// compiled object node returning obj188 (depth = 5)
  *var_RBraceToken = obj188;
  if (obj188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject202 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj202 = alloc_userobj2(2,4, objclass202);
  gc_frame_newslot(obj202);
// OBJECT OUTER DEC outer
  adddatum2(obj202, self, 0);
  addmethodreal(obj202,"outer", &reader_lexer_outer_203);
  Object oldself202 = self;
  struct StackFrameObject *oldstackframe202 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe202);
  gc_frame_newslot((Object)stackframe);
  self = obj202;
  Object *oldselfslot202 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter202 = (*(struct UserObject *)self).data[0], lowerouter202 = thisouter202;
  if (inheritingObject202) {
    struct UserObject *inho202 = (struct UserObject *)inheritingObject202;
    while (inho202->super != GraceDefaultObject) inho202 = (struct UserObject *)inho202->super;
    inho202->super = obj202;
    self = inheritingObject202;
    *selfslot = self;
    lowerouter202 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter202;
  }
// method new
  block_savedest(obj202);
  Object closure204 = createclosure(1, "new");
  setclosureframe(closure204, stackframe);
  addtoclosure(closure204, var_Token);
  struct UserObject *uo204 = (struct UserObject*)obj202;
  uo204->data[1] = (Object)closure204;
  Method *meth_meth_lexer_new204 = addmethod2pos(obj202, "new", &meth_lexer_new204, 1);
  int argcv_meth_lexer_new204[] = {0};
  meth_meth_lexer_new204->type = alloc_MethodType(1, argcv_meth_lexer_new204);
  meth_meth_lexer_new204->definitionModule = modulename;
  meth_meth_lexer_new204->definitionLine = 95;
  block_savedest(obj202);
  Object closure215 = createclosure(1, "new()object");
  setclosureframe(closure215, stackframe);
  addtoclosure(closure215, var_Token);
  Method *meth_meth_lexer_new204_object = addmethod2pos(obj202, "new()object", &meth_lexer_new204_object, 1);
  meth_meth_lexer_new204_object->definitionModule = modulename;
  meth_meth_lexer_new204_object->definitionLine = 95;
  sourceObject = obj202;
objclass202 = obj202->class;
  objclass202->definitionModule = modulename;
  objclass202->definitionLine = 95;
  (*(struct UserObject *)self).data[0] = lowerouter202;
  self = oldself202;
  selfslot = oldselfslot202;
  stackframe = oldstackframe202;
// compiled object node returning obj202 (depth = 5)
  *var_LParenToken = obj202;
  if (obj202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject216 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj216 = alloc_userobj2(2,4, objclass216);
  gc_frame_newslot(obj216);
// OBJECT OUTER DEC outer
  adddatum2(obj216, self, 0);
  addmethodreal(obj216,"outer", &reader_lexer_outer_217);
  Object oldself216 = self;
  struct StackFrameObject *oldstackframe216 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe216);
  gc_frame_newslot((Object)stackframe);
  self = obj216;
  Object *oldselfslot216 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter216 = (*(struct UserObject *)self).data[0], lowerouter216 = thisouter216;
  if (inheritingObject216) {
    struct UserObject *inho216 = (struct UserObject *)inheritingObject216;
    while (inho216->super != GraceDefaultObject) inho216 = (struct UserObject *)inho216->super;
    inho216->super = obj216;
    self = inheritingObject216;
    *selfslot = self;
    lowerouter216 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter216;
  }
// method new
  block_savedest(obj216);
  Object closure218 = createclosure(1, "new");
  setclosureframe(closure218, stackframe);
  addtoclosure(closure218, var_Token);
  struct UserObject *uo218 = (struct UserObject*)obj216;
  uo218->data[1] = (Object)closure218;
  Method *meth_meth_lexer_new218 = addmethod2pos(obj216, "new", &meth_lexer_new218, 1);
  int argcv_meth_lexer_new218[] = {0};
  meth_meth_lexer_new218->type = alloc_MethodType(1, argcv_meth_lexer_new218);
  meth_meth_lexer_new218->definitionModule = modulename;
  meth_meth_lexer_new218->definitionLine = 101;
  block_savedest(obj216);
  Object closure229 = createclosure(1, "new()object");
  setclosureframe(closure229, stackframe);
  addtoclosure(closure229, var_Token);
  Method *meth_meth_lexer_new218_object = addmethod2pos(obj216, "new()object", &meth_lexer_new218_object, 1);
  meth_meth_lexer_new218_object->definitionModule = modulename;
  meth_meth_lexer_new218_object->definitionLine = 101;
  sourceObject = obj216;
objclass216 = obj216->class;
  objclass216->definitionModule = modulename;
  objclass216->definitionLine = 101;
  (*(struct UserObject *)self).data[0] = lowerouter216;
  self = oldself216;
  selfslot = oldselfslot216;
  stackframe = oldstackframe216;
// compiled object node returning obj216 (depth = 5)
  *var_RParenToken = obj216;
  if (obj216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject230 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj230 = alloc_userobj2(2,4, objclass230);
  gc_frame_newslot(obj230);
// OBJECT OUTER DEC outer
  adddatum2(obj230, self, 0);
  addmethodreal(obj230,"outer", &reader_lexer_outer_231);
  Object oldself230 = self;
  struct StackFrameObject *oldstackframe230 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe230);
  gc_frame_newslot((Object)stackframe);
  self = obj230;
  Object *oldselfslot230 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter230 = (*(struct UserObject *)self).data[0], lowerouter230 = thisouter230;
  if (inheritingObject230) {
    struct UserObject *inho230 = (struct UserObject *)inheritingObject230;
    while (inho230->super != GraceDefaultObject) inho230 = (struct UserObject *)inho230->super;
    inho230->super = obj230;
    self = inheritingObject230;
    *selfslot = self;
    lowerouter230 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter230;
  }
// method new
  block_savedest(obj230);
  Object closure232 = createclosure(1, "new");
  setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_Token);
  struct UserObject *uo232 = (struct UserObject*)obj230;
  uo232->data[1] = (Object)closure232;
  Method *meth_meth_lexer_new232 = addmethod2pos(obj230, "new", &meth_lexer_new232, 1);
  int argcv_meth_lexer_new232[] = {0};
  meth_meth_lexer_new232->type = alloc_MethodType(1, argcv_meth_lexer_new232);
  meth_meth_lexer_new232->definitionModule = modulename;
  meth_meth_lexer_new232->definitionLine = 107;
  block_savedest(obj230);
  Object closure243 = createclosure(1, "new()object");
  setclosureframe(closure243, stackframe);
  addtoclosure(closure243, var_Token);
  Method *meth_meth_lexer_new232_object = addmethod2pos(obj230, "new()object", &meth_lexer_new232_object, 1);
  meth_meth_lexer_new232_object->definitionModule = modulename;
  meth_meth_lexer_new232_object->definitionLine = 107;
  sourceObject = obj230;
objclass230 = obj230->class;
  objclass230->definitionModule = modulename;
  objclass230->definitionLine = 107;
  (*(struct UserObject *)self).data[0] = lowerouter230;
  self = oldself230;
  selfslot = oldselfslot230;
  stackframe = oldstackframe230;
// compiled object node returning obj230 (depth = 5)
  *var_LSquareToken = obj230;
  if (obj230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject244 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj244 = alloc_userobj2(2,4, objclass244);
  gc_frame_newslot(obj244);
// OBJECT OUTER DEC outer
  adddatum2(obj244, self, 0);
  addmethodreal(obj244,"outer", &reader_lexer_outer_245);
  Object oldself244 = self;
  struct StackFrameObject *oldstackframe244 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe244);
  gc_frame_newslot((Object)stackframe);
  self = obj244;
  Object *oldselfslot244 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter244 = (*(struct UserObject *)self).data[0], lowerouter244 = thisouter244;
  if (inheritingObject244) {
    struct UserObject *inho244 = (struct UserObject *)inheritingObject244;
    while (inho244->super != GraceDefaultObject) inho244 = (struct UserObject *)inho244->super;
    inho244->super = obj244;
    self = inheritingObject244;
    *selfslot = self;
    lowerouter244 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter244;
  }
// method new
  block_savedest(obj244);
  Object closure246 = createclosure(1, "new");
  setclosureframe(closure246, stackframe);
  addtoclosure(closure246, var_Token);
  struct UserObject *uo246 = (struct UserObject*)obj244;
  uo246->data[1] = (Object)closure246;
  Method *meth_meth_lexer_new246 = addmethod2pos(obj244, "new", &meth_lexer_new246, 1);
  int argcv_meth_lexer_new246[] = {0};
  meth_meth_lexer_new246->type = alloc_MethodType(1, argcv_meth_lexer_new246);
  meth_meth_lexer_new246->definitionModule = modulename;
  meth_meth_lexer_new246->definitionLine = 113;
  block_savedest(obj244);
  Object closure257 = createclosure(1, "new()object");
  setclosureframe(closure257, stackframe);
  addtoclosure(closure257, var_Token);
  Method *meth_meth_lexer_new246_object = addmethod2pos(obj244, "new()object", &meth_lexer_new246_object, 1);
  meth_meth_lexer_new246_object->definitionModule = modulename;
  meth_meth_lexer_new246_object->definitionLine = 113;
  sourceObject = obj244;
objclass244 = obj244->class;
  objclass244->definitionModule = modulename;
  objclass244->definitionLine = 113;
  (*(struct UserObject *)self).data[0] = lowerouter244;
  self = oldself244;
  selfslot = oldselfslot244;
  stackframe = oldstackframe244;
// compiled object node returning obj244 (depth = 5)
  *var_RSquareToken = obj244;
  if (obj244 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject258 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj258 = alloc_userobj2(2,4, objclass258);
  gc_frame_newslot(obj258);
// OBJECT OUTER DEC outer
  adddatum2(obj258, self, 0);
  addmethodreal(obj258,"outer", &reader_lexer_outer_259);
  Object oldself258 = self;
  struct StackFrameObject *oldstackframe258 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe258);
  gc_frame_newslot((Object)stackframe);
  self = obj258;
  Object *oldselfslot258 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter258 = (*(struct UserObject *)self).data[0], lowerouter258 = thisouter258;
  if (inheritingObject258) {
    struct UserObject *inho258 = (struct UserObject *)inheritingObject258;
    while (inho258->super != GraceDefaultObject) inho258 = (struct UserObject *)inho258->super;
    inho258->super = obj258;
    self = inheritingObject258;
    *selfslot = self;
    lowerouter258 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter258;
  }
// method new
  block_savedest(obj258);
  Object closure260 = createclosure(1, "new");
  setclosureframe(closure260, stackframe);
  addtoclosure(closure260, var_Token);
  struct UserObject *uo260 = (struct UserObject*)obj258;
  uo260->data[1] = (Object)closure260;
  Method *meth_meth_lexer_new260 = addmethod2pos(obj258, "new", &meth_lexer_new260, 1);
  int argcv_meth_lexer_new260[] = {0};
  meth_meth_lexer_new260->type = alloc_MethodType(1, argcv_meth_lexer_new260);
  meth_meth_lexer_new260->definitionModule = modulename;
  meth_meth_lexer_new260->definitionLine = 119;
  block_savedest(obj258);
  Object closure271 = createclosure(1, "new()object");
  setclosureframe(closure271, stackframe);
  addtoclosure(closure271, var_Token);
  Method *meth_meth_lexer_new260_object = addmethod2pos(obj258, "new()object", &meth_lexer_new260_object, 1);
  meth_meth_lexer_new260_object->definitionModule = modulename;
  meth_meth_lexer_new260_object->definitionLine = 119;
  sourceObject = obj258;
objclass258 = obj258->class;
  objclass258->definitionModule = modulename;
  objclass258->definitionLine = 119;
  (*(struct UserObject *)self).data[0] = lowerouter258;
  self = oldself258;
  selfslot = oldselfslot258;
  stackframe = oldstackframe258;
// compiled object node returning obj258 (depth = 5)
  *var_CommaToken = obj258;
  if (obj258 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject272 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj272 = alloc_userobj2(2,4, objclass272);
  gc_frame_newslot(obj272);
// OBJECT OUTER DEC outer
  adddatum2(obj272, self, 0);
  addmethodreal(obj272,"outer", &reader_lexer_outer_273);
  Object oldself272 = self;
  struct StackFrameObject *oldstackframe272 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe272);
  gc_frame_newslot((Object)stackframe);
  self = obj272;
  Object *oldselfslot272 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter272 = (*(struct UserObject *)self).data[0], lowerouter272 = thisouter272;
  if (inheritingObject272) {
    struct UserObject *inho272 = (struct UserObject *)inheritingObject272;
    while (inho272->super != GraceDefaultObject) inho272 = (struct UserObject *)inho272->super;
    inho272->super = obj272;
    self = inheritingObject272;
    *selfslot = self;
    lowerouter272 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter272;
  }
// method new
  block_savedest(obj272);
  Object closure274 = createclosure(1, "new");
  setclosureframe(closure274, stackframe);
  addtoclosure(closure274, var_Token);
  struct UserObject *uo274 = (struct UserObject*)obj272;
  uo274->data[1] = (Object)closure274;
  Method *meth_meth_lexer_new274 = addmethod2pos(obj272, "new", &meth_lexer_new274, 1);
  int argcv_meth_lexer_new274[] = {0};
  meth_meth_lexer_new274->type = alloc_MethodType(1, argcv_meth_lexer_new274);
  meth_meth_lexer_new274->definitionModule = modulename;
  meth_meth_lexer_new274->definitionLine = 125;
  block_savedest(obj272);
  Object closure285 = createclosure(1, "new()object");
  setclosureframe(closure285, stackframe);
  addtoclosure(closure285, var_Token);
  Method *meth_meth_lexer_new274_object = addmethod2pos(obj272, "new()object", &meth_lexer_new274_object, 1);
  meth_meth_lexer_new274_object->definitionModule = modulename;
  meth_meth_lexer_new274_object->definitionLine = 125;
  sourceObject = obj272;
objclass272 = obj272->class;
  objclass272->definitionModule = modulename;
  objclass272->definitionLine = 125;
  (*(struct UserObject *)self).data[0] = lowerouter272;
  self = oldself272;
  selfslot = oldselfslot272;
  stackframe = oldstackframe272;
// compiled object node returning obj272 (depth = 5)
  *var_ColonToken = obj272;
  if (obj272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject286 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj286 = alloc_userobj2(2,4, objclass286);
  gc_frame_newslot(obj286);
// OBJECT OUTER DEC outer
  adddatum2(obj286, self, 0);
  addmethodreal(obj286,"outer", &reader_lexer_outer_287);
  Object oldself286 = self;
  struct StackFrameObject *oldstackframe286 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe286);
  gc_frame_newslot((Object)stackframe);
  self = obj286;
  Object *oldselfslot286 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter286 = (*(struct UserObject *)self).data[0], lowerouter286 = thisouter286;
  if (inheritingObject286) {
    struct UserObject *inho286 = (struct UserObject *)inheritingObject286;
    while (inho286->super != GraceDefaultObject) inho286 = (struct UserObject *)inho286->super;
    inho286->super = obj286;
    self = inheritingObject286;
    *selfslot = self;
    lowerouter286 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter286;
  }
// method new
  block_savedest(obj286);
  Object closure288 = createclosure(1, "new");
  setclosureframe(closure288, stackframe);
  addtoclosure(closure288, var_Token);
  struct UserObject *uo288 = (struct UserObject*)obj286;
  uo288->data[1] = (Object)closure288;
  Method *meth_meth_lexer_new288 = addmethod2pos(obj286, "new", &meth_lexer_new288, 1);
  int argcv_meth_lexer_new288[] = {0};
  meth_meth_lexer_new288->type = alloc_MethodType(1, argcv_meth_lexer_new288);
  meth_meth_lexer_new288->definitionModule = modulename;
  meth_meth_lexer_new288->definitionLine = 131;
  block_savedest(obj286);
  Object closure299 = createclosure(1, "new()object");
  setclosureframe(closure299, stackframe);
  addtoclosure(closure299, var_Token);
  Method *meth_meth_lexer_new288_object = addmethod2pos(obj286, "new()object", &meth_lexer_new288_object, 1);
  meth_meth_lexer_new288_object->definitionModule = modulename;
  meth_meth_lexer_new288_object->definitionLine = 131;
  sourceObject = obj286;
objclass286 = obj286->class;
  objclass286->definitionModule = modulename;
  objclass286->definitionLine = 131;
  (*(struct UserObject *)self).data[0] = lowerouter286;
  self = oldself286;
  selfslot = oldselfslot286;
  stackframe = oldstackframe286;
// compiled object node returning obj286 (depth = 5)
  *var_DotToken = obj286;
  if (obj286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject300 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj300 = alloc_userobj2(2,4, objclass300);
  gc_frame_newslot(obj300);
// OBJECT OUTER DEC outer
  adddatum2(obj300, self, 0);
  addmethodreal(obj300,"outer", &reader_lexer_outer_301);
  Object oldself300 = self;
  struct StackFrameObject *oldstackframe300 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe300);
  gc_frame_newslot((Object)stackframe);
  self = obj300;
  Object *oldselfslot300 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter300 = (*(struct UserObject *)self).data[0], lowerouter300 = thisouter300;
  if (inheritingObject300) {
    struct UserObject *inho300 = (struct UserObject *)inheritingObject300;
    while (inho300->super != GraceDefaultObject) inho300 = (struct UserObject *)inho300->super;
    inho300->super = obj300;
    self = inheritingObject300;
    *selfslot = self;
    lowerouter300 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter300;
  }
// method new
  block_savedest(obj300);
  Object closure302 = createclosure(3, "new");
  setclosureframe(closure302, stackframe);
  addtoclosure(closure302, var_Token);
  addtoclosure(closure302, var_startPosition);
  addtoclosure(closure302, var_linePosition);
  struct UserObject *uo302 = (struct UserObject*)obj300;
  uo302->data[1] = (Object)closure302;
  Method *meth_meth_lexer_new302 = addmethod2pos(obj300, "new", &meth_lexer_new302, 1);
  int argcv_meth_lexer_new302[] = {2};
  meth_meth_lexer_new302->type = alloc_MethodType(1, argcv_meth_lexer_new302);
  meth_meth_lexer_new302->definitionModule = modulename;
  meth_meth_lexer_new302->definitionLine = 137;
  block_savedest(obj300);
  Object closure315 = createclosure(3, "new()object");
  setclosureframe(closure315, stackframe);
  addtoclosure(closure315, var_Token);
  addtoclosure(closure315, var_startPosition);
  addtoclosure(closure315, var_linePosition);
  Method *meth_meth_lexer_new302_object = addmethod2pos(obj300, "new()object", &meth_lexer_new302_object, 1);
  meth_meth_lexer_new302_object->definitionModule = modulename;
  meth_meth_lexer_new302_object->definitionLine = 137;
  sourceObject = obj300;
objclass300 = obj300->class;
  objclass300->definitionModule = modulename;
  objclass300->definitionLine = 137;
  (*(struct UserObject *)self).data[0] = lowerouter300;
  self = oldself300;
  selfslot = oldselfslot300;
  stackframe = oldstackframe300;
// compiled object node returning obj300 (depth = 5)
  *var_NumToken = obj300;
  if (obj300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject316 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj316 = alloc_userobj2(2,4, objclass316);
  gc_frame_newslot(obj316);
// OBJECT OUTER DEC outer
  adddatum2(obj316, self, 0);
  addmethodreal(obj316,"outer", &reader_lexer_outer_317);
  Object oldself316 = self;
  struct StackFrameObject *oldstackframe316 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe316);
  gc_frame_newslot((Object)stackframe);
  self = obj316;
  Object *oldselfslot316 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter316 = (*(struct UserObject *)self).data[0], lowerouter316 = thisouter316;
  if (inheritingObject316) {
    struct UserObject *inho316 = (struct UserObject *)inheritingObject316;
    while (inho316->super != GraceDefaultObject) inho316 = (struct UserObject *)inho316->super;
    inho316->super = obj316;
    self = inheritingObject316;
    *selfslot = self;
    lowerouter316 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter316;
  }
// method new
  block_savedest(obj316);
  Object closure318 = createclosure(1, "new");
  setclosureframe(closure318, stackframe);
  addtoclosure(closure318, var_Token);
  struct UserObject *uo318 = (struct UserObject*)obj316;
  uo318->data[1] = (Object)closure318;
  Method *meth_meth_lexer_new318 = addmethod2pos(obj316, "new", &meth_lexer_new318, 1);
  int argcv_meth_lexer_new318[] = {1};
  meth_meth_lexer_new318->type = alloc_MethodType(1, argcv_meth_lexer_new318);
  meth_meth_lexer_new318->definitionModule = modulename;
  meth_meth_lexer_new318->definitionLine = 144;
  block_savedest(obj316);
  Object closure329 = createclosure(1, "new()object");
  setclosureframe(closure329, stackframe);
  addtoclosure(closure329, var_Token);
  Method *meth_meth_lexer_new318_object = addmethod2pos(obj316, "new()object", &meth_lexer_new318_object, 1);
  meth_meth_lexer_new318_object->definitionModule = modulename;
  meth_meth_lexer_new318_object->definitionLine = 144;
  sourceObject = obj316;
objclass316 = obj316->class;
  objclass316->definitionModule = modulename;
  objclass316->definitionLine = 144;
  (*(struct UserObject *)self).data[0] = lowerouter316;
  self = oldself316;
  selfslot = oldselfslot316;
  stackframe = oldstackframe316;
// compiled object node returning obj316 (depth = 5)
  *var_KeywordToken = obj316;
  if (obj316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject330 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj330 = alloc_userobj2(2,4, objclass330);
  gc_frame_newslot(obj330);
// OBJECT OUTER DEC outer
  adddatum2(obj330, self, 0);
  addmethodreal(obj330,"outer", &reader_lexer_outer_331);
  Object oldself330 = self;
  struct StackFrameObject *oldstackframe330 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe330);
  gc_frame_newslot((Object)stackframe);
  self = obj330;
  Object *oldselfslot330 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter330 = (*(struct UserObject *)self).data[0], lowerouter330 = thisouter330;
  if (inheritingObject330) {
    struct UserObject *inho330 = (struct UserObject *)inheritingObject330;
    while (inho330->super != GraceDefaultObject) inho330 = (struct UserObject *)inho330->super;
    inho330->super = obj330;
    self = inheritingObject330;
    *selfslot = self;
    lowerouter330 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter330;
  }
// method new
  block_savedest(obj330);
  Object closure332 = createclosure(1, "new");
  setclosureframe(closure332, stackframe);
  addtoclosure(closure332, var_Token);
  struct UserObject *uo332 = (struct UserObject*)obj330;
  uo332->data[1] = (Object)closure332;
  Method *meth_meth_lexer_new332 = addmethod2pos(obj330, "new", &meth_lexer_new332, 1);
  int argcv_meth_lexer_new332[] = {1};
  meth_meth_lexer_new332->type = alloc_MethodType(1, argcv_meth_lexer_new332);
  meth_meth_lexer_new332->definitionModule = modulename;
  meth_meth_lexer_new332->definitionLine = 150;
  block_savedest(obj330);
  Object closure343 = createclosure(1, "new()object");
  setclosureframe(closure343, stackframe);
  addtoclosure(closure343, var_Token);
  Method *meth_meth_lexer_new332_object = addmethod2pos(obj330, "new()object", &meth_lexer_new332_object, 1);
  meth_meth_lexer_new332_object->definitionModule = modulename;
  meth_meth_lexer_new332_object->definitionLine = 150;
  sourceObject = obj330;
objclass330 = obj330->class;
  objclass330->definitionModule = modulename;
  objclass330->definitionLine = 150;
  (*(struct UserObject *)self).data[0] = lowerouter330;
  self = oldself330;
  selfslot = oldselfslot330;
  stackframe = oldstackframe330;
// compiled object node returning obj330 (depth = 5)
  *var_OpToken = obj330;
  if (obj330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject344 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj344 = alloc_userobj2(2,4, objclass344);
  gc_frame_newslot(obj344);
// OBJECT OUTER DEC outer
  adddatum2(obj344, self, 0);
  addmethodreal(obj344,"outer", &reader_lexer_outer_345);
  Object oldself344 = self;
  struct StackFrameObject *oldstackframe344 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe344);
  gc_frame_newslot((Object)stackframe);
  self = obj344;
  Object *oldselfslot344 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter344 = (*(struct UserObject *)self).data[0], lowerouter344 = thisouter344;
  if (inheritingObject344) {
    struct UserObject *inho344 = (struct UserObject *)inheritingObject344;
    while (inho344->super != GraceDefaultObject) inho344 = (struct UserObject *)inho344->super;
    inho344->super = obj344;
    self = inheritingObject344;
    *selfslot = self;
    lowerouter344 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter344;
  }
// method new
  block_savedest(obj344);
  Object closure346 = createclosure(1, "new");
  setclosureframe(closure346, stackframe);
  addtoclosure(closure346, var_Token);
  struct UserObject *uo346 = (struct UserObject*)obj344;
  uo346->data[1] = (Object)closure346;
  Method *meth_meth_lexer_new346 = addmethod2pos(obj344, "new", &meth_lexer_new346, 1);
  int argcv_meth_lexer_new346[] = {0};
  meth_meth_lexer_new346->type = alloc_MethodType(1, argcv_meth_lexer_new346);
  meth_meth_lexer_new346->definitionModule = modulename;
  meth_meth_lexer_new346->definitionLine = 156;
  block_savedest(obj344);
  Object closure357 = createclosure(1, "new()object");
  setclosureframe(closure357, stackframe);
  addtoclosure(closure357, var_Token);
  Method *meth_meth_lexer_new346_object = addmethod2pos(obj344, "new()object", &meth_lexer_new346_object, 1);
  meth_meth_lexer_new346_object->definitionModule = modulename;
  meth_meth_lexer_new346_object->definitionLine = 156;
  sourceObject = obj344;
objclass344 = obj344->class;
  objclass344->definitionModule = modulename;
  objclass344->definitionLine = 156;
  (*(struct UserObject *)self).data[0] = lowerouter344;
  self = oldself344;
  selfslot = oldselfslot344;
  stackframe = oldstackframe344;
// compiled object node returning obj344 (depth = 5)
  *var_ArrowToken = obj344;
  if (obj344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 162
  setline(162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject358 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj358 = alloc_userobj2(2,4, objclass358);
  gc_frame_newslot(obj358);
// OBJECT OUTER DEC outer
  adddatum2(obj358, self, 0);
  addmethodreal(obj358,"outer", &reader_lexer_outer_359);
  Object oldself358 = self;
  struct StackFrameObject *oldstackframe358 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe358);
  gc_frame_newslot((Object)stackframe);
  self = obj358;
  Object *oldselfslot358 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter358 = (*(struct UserObject *)self).data[0], lowerouter358 = thisouter358;
  if (inheritingObject358) {
    struct UserObject *inho358 = (struct UserObject *)inheritingObject358;
    while (inho358->super != GraceDefaultObject) inho358 = (struct UserObject *)inho358->super;
    inho358->super = obj358;
    self = inheritingObject358;
    *selfslot = self;
    lowerouter358 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter358;
  }
// method new
  block_savedest(obj358);
  Object closure360 = createclosure(1, "new");
  setclosureframe(closure360, stackframe);
  addtoclosure(closure360, var_Token);
  struct UserObject *uo360 = (struct UserObject*)obj358;
  uo360->data[1] = (Object)closure360;
  Method *meth_meth_lexer_new360 = addmethod2pos(obj358, "new", &meth_lexer_new360, 1);
  int argcv_meth_lexer_new360[] = {0};
  meth_meth_lexer_new360->type = alloc_MethodType(1, argcv_meth_lexer_new360);
  meth_meth_lexer_new360->definitionModule = modulename;
  meth_meth_lexer_new360->definitionLine = 162;
  block_savedest(obj358);
  Object closure371 = createclosure(1, "new()object");
  setclosureframe(closure371, stackframe);
  addtoclosure(closure371, var_Token);
  Method *meth_meth_lexer_new360_object = addmethod2pos(obj358, "new()object", &meth_lexer_new360_object, 1);
  meth_meth_lexer_new360_object->definitionModule = modulename;
  meth_meth_lexer_new360_object->definitionLine = 162;
  sourceObject = obj358;
objclass358 = obj358->class;
  objclass358->definitionModule = modulename;
  objclass358->definitionLine = 162;
  (*(struct UserObject *)self).data[0] = lowerouter358;
  self = oldself358;
  selfslot = oldselfslot358;
  stackframe = oldstackframe358;
// compiled object node returning obj358 (depth = 5)
  *var_BindToken = obj358;
  if (obj358 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject372 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj372 = alloc_userobj2(2,4, objclass372);
  gc_frame_newslot(obj372);
// OBJECT OUTER DEC outer
  adddatum2(obj372, self, 0);
  addmethodreal(obj372,"outer", &reader_lexer_outer_373);
  Object oldself372 = self;
  struct StackFrameObject *oldstackframe372 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe372);
  gc_frame_newslot((Object)stackframe);
  self = obj372;
  Object *oldselfslot372 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter372 = (*(struct UserObject *)self).data[0], lowerouter372 = thisouter372;
  if (inheritingObject372) {
    struct UserObject *inho372 = (struct UserObject *)inheritingObject372;
    while (inho372->super != GraceDefaultObject) inho372 = (struct UserObject *)inho372->super;
    inho372->super = obj372;
    self = inheritingObject372;
    *selfslot = self;
    lowerouter372 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter372;
  }
// method new
  block_savedest(obj372);
  Object closure374 = createclosure(1, "new");
  setclosureframe(closure374, stackframe);
  addtoclosure(closure374, var_Token);
  struct UserObject *uo374 = (struct UserObject*)obj372;
  uo374->data[1] = (Object)closure374;
  Method *meth_meth_lexer_new374 = addmethod2pos(obj372, "new", &meth_lexer_new374, 1);
  int argcv_meth_lexer_new374[] = {0};
  meth_meth_lexer_new374->type = alloc_MethodType(1, argcv_meth_lexer_new374);
  meth_meth_lexer_new374->definitionModule = modulename;
  meth_meth_lexer_new374->definitionLine = 168;
  block_savedest(obj372);
  Object closure385 = createclosure(1, "new()object");
  setclosureframe(closure385, stackframe);
  addtoclosure(closure385, var_Token);
  Method *meth_meth_lexer_new374_object = addmethod2pos(obj372, "new()object", &meth_lexer_new374_object, 1);
  meth_meth_lexer_new374_object->definitionModule = modulename;
  meth_meth_lexer_new374_object->definitionLine = 168;
  sourceObject = obj372;
objclass372 = obj372->class;
  objclass372->definitionModule = modulename;
  objclass372->definitionLine = 168;
  (*(struct UserObject *)self).data[0] = lowerouter372;
  self = oldself372;
  selfslot = oldselfslot372;
  stackframe = oldstackframe372;
// compiled object node returning obj372 (depth = 5)
  *var_SemicolonToken = obj372;
  if (obj372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject386 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj386 = alloc_userobj2(2,4, objclass386);
  gc_frame_newslot(obj386);
// OBJECT OUTER DEC outer
  adddatum2(obj386, self, 0);
  addmethodreal(obj386,"outer", &reader_lexer_outer_387);
  Object oldself386 = self;
  struct StackFrameObject *oldstackframe386 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe386);
  gc_frame_newslot((Object)stackframe);
  self = obj386;
  Object *oldselfslot386 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter386 = (*(struct UserObject *)self).data[0], lowerouter386 = thisouter386;
  if (inheritingObject386) {
    struct UserObject *inho386 = (struct UserObject *)inheritingObject386;
    while (inho386->super != GraceDefaultObject) inho386 = (struct UserObject *)inho386->super;
    inho386->super = obj386;
    self = inheritingObject386;
    *selfslot = self;
    lowerouter386 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter386;
  }
// method new
  block_savedest(obj386);
  Object closure388 = createclosure(1, "new");
  setclosureframe(closure388, stackframe);
  addtoclosure(closure388, var_Token);
  struct UserObject *uo388 = (struct UserObject*)obj386;
  uo388->data[1] = (Object)closure388;
  Method *meth_meth_lexer_new388 = addmethod2pos(obj386, "new", &meth_lexer_new388, 1);
  int argcv_meth_lexer_new388[] = {0};
  meth_meth_lexer_new388->type = alloc_MethodType(1, argcv_meth_lexer_new388);
  meth_meth_lexer_new388->definitionModule = modulename;
  meth_meth_lexer_new388->definitionLine = 174;
  block_savedest(obj386);
  Object closure399 = createclosure(1, "new()object");
  setclosureframe(closure399, stackframe);
  addtoclosure(closure399, var_Token);
  Method *meth_meth_lexer_new388_object = addmethod2pos(obj386, "new()object", &meth_lexer_new388_object, 1);
  meth_meth_lexer_new388_object->definitionModule = modulename;
  meth_meth_lexer_new388_object->definitionLine = 174;
  sourceObject = obj386;
objclass386 = obj386->class;
  objclass386->definitionModule = modulename;
  objclass386->definitionLine = 174;
  (*(struct UserObject *)self).data[0] = lowerouter386;
  self = oldself386;
  selfslot = oldselfslot386;
  stackframe = oldstackframe386;
// compiled object node returning obj386 (depth = 5)
  *var_LGenericToken = obj386;
  if (obj386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile class node (depth = 3)
// starting to compile defdec node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject400 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj400 = alloc_userobj2(2,4, objclass400);
  gc_frame_newslot(obj400);
// OBJECT OUTER DEC outer
  adddatum2(obj400, self, 0);
  addmethodreal(obj400,"outer", &reader_lexer_outer_401);
  Object oldself400 = self;
  struct StackFrameObject *oldstackframe400 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe400);
  gc_frame_newslot((Object)stackframe);
  self = obj400;
  Object *oldselfslot400 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter400 = (*(struct UserObject *)self).data[0], lowerouter400 = thisouter400;
  if (inheritingObject400) {
    struct UserObject *inho400 = (struct UserObject *)inheritingObject400;
    while (inho400->super != GraceDefaultObject) inho400 = (struct UserObject *)inho400->super;
    inho400->super = obj400;
    self = inheritingObject400;
    *selfslot = self;
    lowerouter400 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter400;
  }
// method new
  block_savedest(obj400);
  Object closure402 = createclosure(1, "new");
  setclosureframe(closure402, stackframe);
  addtoclosure(closure402, var_Token);
  struct UserObject *uo402 = (struct UserObject*)obj400;
  uo402->data[1] = (Object)closure402;
  Method *meth_meth_lexer_new402 = addmethod2pos(obj400, "new", &meth_lexer_new402, 1);
  int argcv_meth_lexer_new402[] = {0};
  meth_meth_lexer_new402->type = alloc_MethodType(1, argcv_meth_lexer_new402);
  meth_meth_lexer_new402->definitionModule = modulename;
  meth_meth_lexer_new402->definitionLine = 180;
  block_savedest(obj400);
  Object closure413 = createclosure(1, "new()object");
  setclosureframe(closure413, stackframe);
  addtoclosure(closure413, var_Token);
  Method *meth_meth_lexer_new402_object = addmethod2pos(obj400, "new()object", &meth_lexer_new402_object, 1);
  meth_meth_lexer_new402_object->definitionModule = modulename;
  meth_meth_lexer_new402_object->definitionLine = 180;
  sourceObject = obj400;
objclass400 = obj400->class;
  objclass400->definitionModule = modulename;
  objclass400->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter400;
  self = oldself400;
  selfslot = oldselfslot400;
  stackframe = oldstackframe400;
// compiled object node returning obj400 (depth = 5)
  *var_RGenericToken = obj400;
  if (obj400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// compiled class node returning done (depth = 3)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject414 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj414 = alloc_userobj2(7,8, objclass414);
  gc_frame_newslot(obj414);
if (objclass414 == NULL) {
  glfree(obj414->class->name);
  obj414->class->name = "obj60.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj414, self, 0);
  addmethodreal(obj414,"outer", &reader_lexer_outer_415);
  Object oldself414 = self;
  struct StackFrameObject *oldstackframe414 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe414);
  gc_frame_newslot((Object)stackframe);
  self = obj414;
  Object *oldselfslot414 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter414 = (*(struct UserObject *)self).data[0], lowerouter414 = thisouter414;
  if (inheritingObject414) {
    struct UserObject *inho414 = (struct UserObject *)inheritingObject414;
    while (inho414->super != GraceDefaultObject) inho414 = (struct UserObject *)inho414->super;
    inho414->super = obj414;
    self = inheritingObject414;
    *selfslot = self;
    lowerouter414 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter414;
  }
// method modechange
  block_savedest(obj414);
  Object closure416 = createclosure(27, "modechange");
  setclosureframe(closure416, stackframe);
  addtoclosure(closure416, var_IdentifierToken);
  addtoclosure(closure416, var_KeywordToken);
  addtoclosure(closure416, var_StringToken);
  addtoclosure(closure416, var_OctetsToken);
  addtoclosure(closure416, var_CommaToken);
  addtoclosure(closure416, var_DotToken);
  addtoclosure(closure416, var_LBraceToken);
  addtoclosure(closure416, var_RBraceToken);
  addtoclosure(closure416, var_LParenToken);
  addtoclosure(closure416, var_RParenToken);
  addtoclosure(closure416, var_LSquareToken);
  addtoclosure(closure416, var_RSquareToken);
  addtoclosure(closure416, var_LGenericToken);
  addtoclosure(closure416, var_RGenericToken);
  addtoclosure(closure416, var_SemicolonToken);
  addtoclosure(closure416, var_NumToken);
  addtoclosure(closure416, var_errormessages);
  addtoclosure(closure416, var_linePosition);
  addtoclosure(closure416, var_lineNumber);
  addtoclosure(closure416, var_OpToken);
  addtoclosure(closure416, var_ArrowToken);
  addtoclosure(closure416, var_BindToken);
  addtoclosure(closure416, var_ColonToken);
  addtoclosure(closure416, var_indentLevel);
  addtoclosure(closure416, var_CommentToken);
  addtoclosure(closure416, var_util);
  addtoclosure(closure416, var_startPosition);
  struct UserObject *uo416 = (struct UserObject*)obj414;
  uo416->data[1] = (Object)closure416;
  Method *meth_meth_lexer_modechange416 = addmethod2pos(obj414, "modechange", &meth_lexer_modechange416, 1);
  int argcv_meth_lexer_modechange416[] = {3};
  meth_meth_lexer_modechange416->type = alloc_MethodType(1, argcv_meth_lexer_modechange416);
  meth_meth_lexer_modechange416->definitionModule = modulename;
  meth_meth_lexer_modechange416->definitionLine = 204;
// method fromBase
  block_savedest(obj414);
  Object closure1140 = createclosure(4, "fromBase");
  setclosureframe(closure1140, stackframe);
  addtoclosure(closure1140, var_errormessages);
  addtoclosure(closure1140, var_linePosition);
  addtoclosure(closure1140, var_lineNumber);
  addtoclosure(closure1140, var_unicode);
  struct UserObject *uo1140 = (struct UserObject*)obj414;
  uo1140->data[2] = (Object)closure1140;
  Method *meth_meth_lexer_fromBase1140 = addmethod2pos(obj414, "fromBase", &meth_lexer_fromBase1140, 2);
  int argcv_meth_lexer_fromBase1140[] = {2};
  meth_meth_lexer_fromBase1140->type = alloc_MethodType(1, argcv_meth_lexer_fromBase1140);
  meth_meth_lexer_fromBase1140->definitionModule = modulename;
  meth_meth_lexer_fromBase1140->definitionLine = 377;
// method makeNumToken
  block_savedest(obj414);
  Object closure1356 = createclosure(4, "makeNumToken");
  setclosureframe(closure1356, stackframe);
  addtoclosure(closure1356, var_errormessages);
  addtoclosure(closure1356, var_linePosition);
  addtoclosure(closure1356, var_lineNumber);
  addtoclosure(closure1356, var_NumToken);
  struct UserObject *uo1356 = (struct UserObject*)obj414;
  uo1356->data[3] = (Object)closure1356;
  Method *meth_meth_lexer_makeNumToken1356 = addmethod2pos(obj414, "makeNumToken", &meth_lexer_makeNumToken1356, 3);
  int argcv_meth_lexer_makeNumToken1356[] = {1};
  meth_meth_lexer_makeNumToken1356->type = alloc_MethodType(1, argcv_meth_lexer_makeNumToken1356);
  meth_meth_lexer_makeNumToken1356->definitionModule = modulename;
  meth_meth_lexer_makeNumToken1356->definitionLine = 418;
// method isidentifierchar
  block_savedest(obj414);
  Object closure1535 = createclosure(1, "isidentifierchar");
  setclosureframe(closure1535, stackframe);
  addtoclosure(closure1535, var_unicode);
  struct UserObject *uo1535 = (struct UserObject*)obj414;
  uo1535->data[4] = (Object)closure1535;
  Method *meth_meth_lexer_isidentifierchar1535 = addmethod2pos(obj414, "isidentifierchar", &meth_lexer_isidentifierchar1535, 4);
  int argcv_meth_lexer_isidentifierchar1535[] = {1};
  meth_meth_lexer_isidentifierchar1535->type = alloc_MethodType(1, argcv_meth_lexer_isidentifierchar1535);
  meth_meth_lexer_isidentifierchar1535->definitionModule = modulename;
  meth_meth_lexer_isidentifierchar1535->definitionLine = 463;
// method isoperatorchar
  block_savedest(obj414);
  Object closure1558 = createclosure(1, "isoperatorchar");
  setclosureframe(closure1558, stackframe);
  addtoclosure(closure1558, var_unicode);
  struct UserObject *uo1558 = (struct UserObject*)obj414;
  uo1558->data[5] = (Object)closure1558;
  Method *meth_meth_lexer_isoperatorchar1558 = addmethod2pos(obj414, "isoperatorchar", &meth_lexer_isoperatorchar1558, 5);
  int argcv_meth_lexer_isoperatorchar1558[] = {2};
  meth_meth_lexer_isoperatorchar1558->type = alloc_MethodType(1, argcv_meth_lexer_isoperatorchar1558);
  meth_meth_lexer_isoperatorchar1558->definitionModule = modulename;
  meth_meth_lexer_isoperatorchar1558->definitionLine = 479;
// method lexfile
  block_savedest(obj414);
  Object closure1652 = createclosure(1, "lexfile");
  setclosureframe(closure1652, stackframe);
  addtoclosure(closure1652, var_util);
  struct UserObject *uo1652 = (struct UserObject*)obj414;
  uo1652->data[6] = (Object)closure1652;
  Method *meth_meth_lexer_lexfile1652 = addmethod2pos(obj414, "lexfile", &meth_lexer_lexfile1652, 6);
  int argcv_meth_lexer_lexfile1652[] = {1};
  meth_meth_lexer_lexfile1652->type = alloc_MethodType(1, argcv_meth_lexer_lexfile1652);
  meth_meth_lexer_lexfile1652->definitionModule = modulename;
  meth_meth_lexer_lexfile1652->definitionLine = 496;
// method lexinput
  block_savedest(obj414);
  Object closure1750 = createclosure(6, "lexinput");
  setclosureframe(closure1750, stackframe);
  addtoclosure(closure1750, var_linePosition);
  addtoclosure(closure1750, var_util);
  addtoclosure(closure1750, var_unicode);
  addtoclosure(closure1750, var_errormessages);
  addtoclosure(closure1750, var_lineNumber);
  addtoclosure(closure1750, var_startPosition);
  struct UserObject *uo1750 = (struct UserObject*)obj414;
  uo1750->data[7] = (Object)closure1750;
  Method *meth_meth_lexer_lexinput1750 = addmethod2pos(obj414, "lexinput", &meth_lexer_lexinput1750, 7);
  int argcv_meth_lexer_lexinput1750[] = {1};
  meth_meth_lexer_lexinput1750->type = alloc_MethodType(1, argcv_meth_lexer_lexinput1750);
  meth_meth_lexer_lexinput1750->definitionModule = modulename;
  meth_meth_lexer_lexinput1750->definitionLine = 531;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
  sourceObject = obj414;
objclass414 = obj414->class;
  objclass414->definitionModule = modulename;
  objclass414->definitionLine = 187;
  (*(struct UserObject *)self).data[0] = lowerouter414;
  self = oldself414;
  selfslot = oldselfslot414;
  stackframe = oldstackframe414;
  gc_frame_end(frame);
  return obj414;
}
Object meth_lexer_LexerClass3443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "LexerClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_LexerClass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for LexerClass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹LexerClass›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_LexerClass (depth = 3)
  gc_frame_end(frame);
  return *var_LexerClass;
}
Object module_lexer_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(6, 6);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<lexer>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
Object *var_io = alloc_var();
Object *var_sys = alloc_var();
Object *var_util = alloc_var();
Object *var_unicode = alloc_var();
Object *var_collections = alloc_var();
Object *var_errormessages = alloc_var();
  Object *var_LexerClass = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "LexerClass");
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method hexdecchar
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = emptyclosure;
  Method *meth_meth_lexer_hexdecchar0 = addmethod2pos(self, "hexdecchar", &meth_lexer_hexdecchar0, 1);
  int argcv_meth_lexer_hexdecchar0[] = {1};
  meth_meth_lexer_hexdecchar0->type = alloc_MethodType(1, argcv_meth_lexer_hexdecchar0);
  meth_meth_lexer_hexdecchar0->definitionModule = modulename;
  meth_meth_lexer_hexdecchar0->definitionLine = 10;
// compiled method node returning  (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method padl
  struct UserObject *uo35 = (struct UserObject*)self;
  uo35->data[2] = emptyclosure;
  Method *meth_meth_lexer_padl35 = addmethod2pos(self, "padl", &meth_lexer_padl35, 2);
  int argcv_meth_lexer_padl35[] = {3};
  meth_meth_lexer_padl35->type = alloc_MethodType(1, argcv_meth_lexer_padl35);
  meth_meth_lexer_padl35->definitionModule = modulename;
  meth_meth_lexer_padl35->definitionLine = 23;
// compiled method node returning  (depth = 1)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method Lexer
  block_savedest(self);
  Object closure59 = createclosure(1, "Lexer");
  setclosureframe(closure59, stackframe);
  addtoclosure(closure59, var_LexerClass);
  struct UserObject *uo59 = (struct UserObject*)self;
  uo59->data[3] = (Object)closure59;
  Method *meth_meth_lexer_Lexer59 = addmethod2pos(self, "Lexer", &meth_lexer_Lexer59, 3);
  int argcv_meth_lexer_Lexer59[] = {0};
  meth_meth_lexer_Lexer59->type = alloc_MethodType(1, argcv_meth_lexer_Lexer59);
  meth_meth_lexer_Lexer59->definitionModule = modulename;
  meth_meth_lexer_Lexer59->definitionLine = 1061;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of sys as sys
  if (module_sys == NULL)
    module_sys = module_sys_init();
  *var_sys = module_sys;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of unicode as unicode
  if (module_unicode == NULL)
    module_unicode = dlmodule("unicode");
  *var_unicode = module_unicode;
// compiled import node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of mgcollections as collections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_collections = module_mgcollections;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = module_errormessages_init();
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject60 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj60 = alloc_userobj2(3,4, objclass60);
  gc_frame_newslot(obj60);
// OBJECT OUTER DEC outer
  adddatum2(obj60, self, 0);
  addmethodreal(obj60,"outer", &reader_lexer_outer_61);
  Object oldself60 = self;
  struct StackFrameObject *oldstackframe60 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe60);
  gc_frame_newslot((Object)stackframe);
  self = obj60;
  Object *oldselfslot60 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter60 = (*(struct UserObject *)self).data[0], lowerouter60 = thisouter60;
  if (inheritingObject60) {
    struct UserObject *inho60 = (struct UserObject *)inheritingObject60;
    while (inho60->super != GraceDefaultObject) inho60 = (struct UserObject *)inho60->super;
    inho60->super = obj60;
    self = inheritingObject60;
    *selfslot = self;
    lowerouter60 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter60;
  }
// method asString
  struct UserObject *uo62 = (struct UserObject*)obj60;
  uo62->data[1] = emptyclosure;
  Method *meth_meth_lexer_asString62 = addmethod2pos(obj60, "asString", &meth_lexer_asString62, 1);
  int argcv_meth_lexer_asString62[] = {0};
  meth_meth_lexer_asString62->type = alloc_MethodType(1, argcv_meth_lexer_asString62);
  meth_meth_lexer_asString62->definitionModule = modulename;
  meth_meth_lexer_asString62->definitionLine = 35;
// method new
  block_savedest(obj60);
  Object closure64 = createclosure(3, "new");
  setclosureframe(closure64, stackframe);
  addtoclosure(closure64, var_errormessages);
  addtoclosure(closure64, var_util);
  addtoclosure(closure64, var_unicode);
  struct UserObject *uo64 = (struct UserObject*)obj60;
  uo64->data[2] = (Object)closure64;
  Method *meth_meth_lexer_new64 = addmethod2pos(obj60, "new", &meth_lexer_new64, 2);
  int argcv_meth_lexer_new64[] = {0};
  meth_meth_lexer_new64->type = alloc_MethodType(1, argcv_meth_lexer_new64);
  meth_meth_lexer_new64->definitionModule = modulename;
  meth_meth_lexer_new64->definitionLine = 36;
  block_savedest(obj60);
  Object closure3442 = createclosure(3, "new()object");
  setclosureframe(closure3442, stackframe);
  addtoclosure(closure3442, var_errormessages);
  addtoclosure(closure3442, var_util);
  addtoclosure(closure3442, var_unicode);
  Method *meth_meth_lexer_new64_object = addmethod2pos(obj60, "new()object", &meth_lexer_new64_object, 2);
  meth_meth_lexer_new64_object->definitionModule = modulename;
  meth_meth_lexer_new64_object->definitionLine = 36;
  sourceObject = obj60;
  sourceObject = obj60;
objclass60 = obj60->class;
  objclass60->definitionModule = modulename;
  objclass60->definitionLine = 34;
  (*(struct UserObject *)self).data[0] = lowerouter60;
  self = oldself60;
  selfslot = oldselfslot60;
  stackframe = oldstackframe60;
// compiled object node returning obj60 (depth = 2)
  *var_LexerClass = obj60;
  if (obj60 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method LexerClass
  block_savedest(self);
  Object closure3443 = createclosure(1, "LexerClass");
  setclosureframe(closure3443, stackframe);
  addtoclosure(closure3443, var_LexerClass);
  struct UserObject *uo3443 = (struct UserObject*)self;
  uo3443->data[4] = (Object)closure3443;
  Method *meth_meth_lexer_LexerClass3443 = addmethod2pos(self, "LexerClass", &meth_lexer_LexerClass3443, 4);
  int argcv_meth_lexer_LexerClass3443[] = {0};
  meth_meth_lexer_LexerClass3443->type = alloc_MethodType(1, argcv_meth_lexer_LexerClass3443);
  meth_meth_lexer_LexerClass3443->definitionModule = modulename;
  meth_meth_lexer_LexerClass3443->definitionLine = 1046;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
