#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "61482bce15cec41844a512fd6f07853796a59bdb";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"mgcollections\" as collections",
  "import \"errormessages\" as errormessages",
  "",
  "def don'tBreak = true",
  "var lastline := 0",
  "var linenum := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var tokens := false",
  "var values := []",
  "var auto_count := 0",
  "def noBlocks = false",
  "def blocksOK = true",
  "var braceIsType := false",
  "var defaultDefVisibility := \"confidential\"",
  "var defaultVarVisibility := \"confidential\"",
  "var defaultMethodVisibility := \"public\"",
  "",
  "// Global object containing the current token",
  "var sym",
  "var lastToken := object {",
  "    var kind := \"start\"",
  "    var line := 1",
  "    var linePos := 0",
  "    var indent := 0",
  "    var value := \"\"",
  "    def size = 0",
  "}",
  "",
  "var statementToken := lastToken",
  "var comment := false",
  "",
  "// Advance to the next token in the stream, with special handling",
  "// so the magic \"line\" tokens update the line number for error output.",
  "method next {",
  "    lastToken := sym",
  "    if (tokens.size > 0) then {",
  "        lastline := linenum",
  "        lastIndent := sym.indent",
  "        sym := tokens.poll",
  "        if (sym.kind == \"comment\") then {",
  "            comment := \"\"",
  "            while {(sym.kind == \"comment\").andAlso {tokens.size > 0}} do {",
  "                comment := comment ++ sym.value",
  "                sym := tokens.poll",
  "            }",
  "        }",
  "        linenum := sym.line",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } elseif { sym.kind == \"eof\" } then {",
  "        errormessages.syntaxError(\"Unexpetedly found the end of the input. This is often caused by a missing '\\}'\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "    } else {",
  "        sym := object {",
  "            var kind := \"eof\"",
  "            var line := lastToken.line",
  "            var linePos := util.lines[lastToken.line].size + 1",
  "            var indent := 0",
  "            var value := \"\"",
  "            def size = 0",
  "        }",
  "    }",
  "}",
  "",
  "// Search for the next token that the given block returns true for.",
  "// Used for generating suggestions.",
  "method findNextToken(tokenMatcher) {",
  "    if(tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }.andAlso { n.indent >= lastToken.indent }} do {",
  "        if(tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if(((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }} do {",
  "        if(((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(*validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = [\"dot\", \"comma\", \"colon\", \"rparen\", \"rbrace\", \"rsquare\", \"arrow\", \"bind\"];",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if(validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if(!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for token (that is the beginning of a control",
  "// structure) -- an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(token, inserted) {",
  "    var n := sym",
  "    var numOpening := if(inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found",
  "        var tok",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == token.line)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif(n.kind == \"rbrace\") then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > token.indent)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif(n.kind == \"rbrace\") then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    if(n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif((n.prev.kind == \"rbrace\") && (numOpening == numClosing)) then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "// True if the current token (next to be processed) is a t, where",
  "// t is \"num\", \"string\", \"method\", etc.",
  "method accept(t) {",
  "    sym.kind == t",
  "}",
  "",
  "// True if the current token is a t, and it is on the same logical",
  "// line (either because it's on the same physical line, or because",
  "// it's on an indented continuation line).",
  "method acceptSameLine(t) {",
  "    (sym.kind == t) && ((lastline == sym.line) ||",
  "        (sym.indent > lastIndent))",
  "}",
  "",
  "// True if the current token is a t, and it is on the same logical",
  "// line as a provided token.",
  "method accept(t)onLineOf(other) {",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "// True if the current token is a t, and it is on the same logical",
  "// line as a provided token.",
  "method accept(t)onLineOfLastOr(other) {",
  "    (sym.kind == t) && (((other.line == sym.line) ||",
  "        (sym.indent > other.indent)) || (lastToken.line == sym.line))",
  "}",
  "// True if there is a token on the same logical line",
  "method tokenOnSameLine {",
  "    (lastline == sym.line) || (sym.indent > lastIndent)",
  "}",
  "// Check if block did consume at least one token.",
  "method didConsume(ablock) {",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    tokens.size != sz",
  "}",
  "// Expect block to consume at least one token, or call fallback code.",
  "method ifConsume(ablock)then(tblock) {",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    if (tokens.size != sz) then {",
  "        tblock.apply",
  "    }",
  "}",
  "",
  "// Push the current token onto the output stack as a number",
  "method pushnum {",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an octet literal",
  "method pushoctets {",
  "    var o := ast.octetsNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as a string",
  "method pushstring {",
  "    var o := ast.stringNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var o := ast.identifierNode.new(sym.value, false)",
  "    if (o.value == \"_\") then {",
  "        o.value := \"__\" ++ auto_count",
  "        o.wildcard := true",
  "        auto_count := auto_count + 1",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "method adjustVisibilityOf(node) withSpecialDefault(sd) overriding(nd) {",
  "    // If a compiler directive has set a special default visibility, then",
  "    // translate this into an annotation.  The normal defaults are dealt with",
  "    // by methods on the ast nodes.",
  "    if (sd == nd) then { return done }",
  "    for (node.annotations) do {a->",
  "        if (a.kind == \"identifier\") then",
  "        {   if (a.value == \"public\") then { return done }",
  "            if (a.value == \"readable\") then { return done }",
  "            if (a.value == \"confidential\") then { return done }",
  "            if (a.value == \"writable\") then { return done }",
  "        }",
  "    }",
  "    def newAnn = ast.identifierNode.new(sd, false)",
  "    newAnn.parent := node",
  "    node.annotations.push(newAnn)",
  "}",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\").andAlso {a.dtype != false}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"An argument to an annotation cannot have a type.\")atRange(",
  "                        tok.line, tok.linePos, tok.next.linePos + tok.next.size - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if ((!accept(\"keyword\")).orElse {sym.value != \"is\"}) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = collections.list.new",
  "    if(didConsume({expression(noBlocks)}).not) then {",
  "        def suggestions = []",
  "        var suggestion := errormessages.suggestion.new",
  "        def nextTok = findNextValidToken(\"bind\")",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "        }",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"One or more annotations separated by commas must follow 'is'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"bind\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"One or more annotations separated by commas must follow 'is'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "    }",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method blank {",
  "    if (sym.line > (lastToken.line + 1)) then {",
  "        if (values.size > 0) then {",
  "            if (values.last.kind != \"blank\") then {",
  "                util.setPosition(lastToken.line + 1, 0)",
  "                values.push(ast.blankNode.new)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept(\"identifier\")) then {",
  "        pushidentifier",
  "        generic",
  "        dotrest(noBlocks)",
  "    } else {",
  "        if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "            dotypeLiteral",
  "        }",
  "    }",
  "}",
  "",
  "method typeexpression {",
  "    var sz := values.size",
  "    if (accept(\"lparen\")) then {",
  "        def prevStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if(didConsume({typeexpression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if (nextTok == sym) then {",
  "                suggestion.insert(\"«type expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«type expression»\")",
  "            }",
  "            errormessages.syntaxError(\"Parentheses must contain a valid type expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        statementToken := prevStatementToken",
  "        next",
  "    } else {",
  "        dotypeterm",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(noBlocks)",
  "        typeexpressionrest",
  "    }",
  "    // TODO: check that the expression doesn't contain requests or var references.",
  "    // This has to happen in the identifier resolution phase.",
  "}",
  "",
  "method newIf(cond, thenList, elseList) {",
  "    def thenBlock = ast.blockNode.new([], thenList)",
  "    def elseBlock = ast.blockNode.new([], elseList)",
  "    ast.ifNode.new(cond, thenBlock, elseBlock)",
  "}",
  "",
  "// Accept a block",
  "method block {",
  "    if (accept(\"lbrace\")) then {",
  "        def btok = sym",
  "        next",
  "        var minInd := statementIndent + 1",
  "        var startIndent := statementIndent",
  "        var expr1",
  "        var s := sym",
  "        var tmp",
  "        var params := []",
  "        var body := []",
  "        var havearrow := true",
  "        var found := false",
  "        var i := 0",
  "        var isMatchingBlock := false",
  "        statementToken := sym",
  "        if (sym.kind == \"lparen\") then {",
  "            isMatchingBlock := true",
  "        }",
  "        // Parsing the expression ‹(a)› will return an identifierNode‹a› .",
  "        // The paren lets us distinguish parameter ‹a› from pattern ‹(a)› .",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (accept(\"comma\") || accept(\"arrow\") || accept(\"colon\")) then {",
  "                // This block has parameters or patterns",
  "                expr1 := values.pop",
  "                if (accept(\"colon\")) then {",
  "                    // We allow an expression here for the case of v : T",
  "                    // patterns, where T may be \"Pair(hd, tl)\" or similar.",
  "                    next",
  "                    braceIsType := true",
  "                    if(didConsume({expression(blocksOK)}).not) then {",
  "                        def suggestions = []",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken(\"arrow\", \"rbrace\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"A block must have an expression after the ':'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestions(suggestions)",
  "                    }",
  "                    braceIsType := false",
  "                    expr1.dtype := values.pop",
  "                }",
  "                params.push(expr1)",
  "                if (isMatchingBlock.not && expr1.isIdentifier) then {",
  "                    expr1.isBindingOccurrence := true",
  "                } else {",
  "                    isMatchingBlock := true",
  "                }",
  "                if (isMatchingBlock && {accept(\"comma\")}) then {",
  "                    def suggestions = []",
  "                    var suggestion",
  "                    def arrow = findNextToken({ t -> t.kind == \"arrow\" })",
  "                    if(arrow != false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, arrow.prev)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" |\")",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A matching block may only have one parameter.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                while {accept(\"comma\")} do {",
  "                    // Keep doing the above for the rest of the parameters.",
  "                    next",
  "                    pushidentifier",
  "                    expr1 := values.pop",
  "                    expr1.isBindingOccurrence := true",
  "                    if (accept(\"colon\")) then {",
  "                        next",
  "                        typeexpression",
  "                        expr1.dtype := values.pop",
  "                    }",
  "                    params.push(expr1)",
  "                }",
  "                if ((accept(\"arrow\")).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "                        suggestion.replaceToken(sym)with(\"->\")",
  "                    } else {",
  "                        suggestion.insert(\" ->\")afterToken(lastToken)",
  "                    }",
  "                    errormessages.syntaxError(\"A block must have one or more parameters followed by '->' and an expression.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } elseif (accept(\"semicolon\")) then {",
  "                body.push(values.pop)",
  "                next",
  "                if (accept(\"semicolon\")) then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } elseif (((values.last.kind == \"member\")",
  "                || (values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var lhs := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var rhs := values.pop",
  "                body.push(ast.bindNode.new(lhs, rhs))",
  "                if (accept(\"semicolon\")) then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } else {",
  "                checkUnexpectedTokenAfterStatement",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        if (accept(\"arrow\")) then {",
  "            next",
  "        }",
  "        if (sym.line == lastToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := minInd",
  "        }",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // Take the body of the block",
  "            if(didConsume({statement}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"}\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A block must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            tmp := values.pop",
  "            body.push(tmp)",
  "        }",
  "        minIndentLevel := minInd - 1",
  "        statementIndent := startIndent",
  "        next",
  "        util.setline(btok.line)",
  "        var o := ast.blockNode.new(params, body)",
  "        if (isMatchingBlock) then {",
  "            if (params.size > 0) then {",
  "                o.matchingPattern := params.first",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" («expression») then \\{\")afterToken(btok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif(nextTok.kind == \"lbrace\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" («expression») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if(nextTok == false) then {",
  "                nextTok := findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atRange(",
  "                        sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 1",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if(sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"An if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if(didConsume({statement}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"An if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                def opener = if ((sym.kind == \"lparen\").orElse{sym.kind == \"lbrace\"}) ",
  "                                then { sym.value } else { \"-missing-\" }",
  "                def closer = if (opener == \"(\") then { \")\" }",
  "                                else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "                if (opener == \"-missing-\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if(nextTok == false) then {",
  "                        suggestion.insert(\" («expression») then \\{\")afterToken(statementToken)",
  "                    } elseif(nextTok.kind == \"rparen\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                        }",
  "                    } elseif(nextTok.kind == \"lbrace\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" («expression») then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif(nextTok.kind == \"identifier\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        ((t.kind == \"rparen\") || (t.kind == \"rbrace\"))})",
  "                    if(nextTok == false) then {",
  "                        nextTok := findNextValidToken(\"rparen\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if(sym.value != closer) then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An expression beginning with a '{opener}' must end with a '{closer}'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"An elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := newIf(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"An else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"An else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            var o := newIf(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"An if statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\" specially by",
  "// passing it to the method above.",
  "method identifier {",
  "    if (accept(\"identifier\")) then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    if (accept(\"op\")) then {",
  "        var op := sym.value",
  "        var val",
  "        next",
  "        if (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if(lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "        val := values.pop",
  "        var mem := ast.memberNode.new(\"prefix\" ++ op, val)",
  "        var call := ast.callNode.new(mem, [ast.callWithPart.new(mem.value)])",
  "        values.push(call)",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept(\"lgeneric\")) then {",
  "        def id = values.pop",
  "        def gens = list.empty",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                def memberNd = ast.memberNode.new(memberName.value, memberIn)",
  "                memberNd.line := memberName.line",
  "                memberNd.linePos := memberName.linePos",
  "                values.push(memberNd)",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept(\"comma\")) then {",
  "                next",
  "            } else {",
  "                if(sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"A type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"A type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept(\"identifier\") && (sym.value == \"try\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    if (accept(\"lbrace\")) then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rbrace\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(catchTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"A try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A try-finally statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    values.push(ast.catchCaseNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method catchcase { // TODO: This construct is DEPRECATED. Remove it.",
  "    if (!(accept(\"identifier\") && (sym.value == \"catch\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    util.warning(\"The catch-case statement is deprecated and will be \"",
  "        ++ \"removed in a future version of the compiler. Use try-catch \"",
  "        ++ \"instead.\")",
  "    if (accept(\"lbrace\")) then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or case.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rbrace\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    values.push(ast.catchCaseNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if(sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if(nextTok == false) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif(nextTok.kind == \"rparen\") then {",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif(nextTok.kind == \"identifier\") then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"A match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if(didConsume({expression(blocksOK)}).not) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken(\"rparen\")",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"A match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    var elsecase := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "//    if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "//        next",
  "//        if (accept(\"lbrace\")) then {",
  "//            block",
  "//        } elseif (accept(\"lparen\")) then {",
  "//            next",
  "//            if(didConsume({expression(blocksOK)}).not) then {",
  "//                def suggestion = errormessages.suggestion.new",
  "//                def nextTok = findNextValidToken(\"rparen\")",
  "//                if(nextTok == sym) then {",
  "//                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "//                } else {",
  "//                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "//                }",
  "//                errormessages.syntaxError(\"A match statement must have either a block or an expression in parentheses after the 'else'.\")atPosition(",
  "//                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "//            }",
  "//            if(sym.kind != \"rparen\") then {",
  "//                checkBadOperators",
  "//                def suggestion = errormessages.suggestion.new",
  "//                suggestion.insert(\")\")afterToken(lastToken)",
  "//                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "//                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "//            }",
  "//            next",
  "//        } else {",
  "//            def suggestions = []",
  "//            def nextTok = findNextTokenIndentedAt(lastToken)",
  "//            var suggestion := errormessages.suggestion.new",
  "//            if(nextTok == false) then {",
  "//                suggestion.insert(\" }\")afterToken(tokens.first)",
  "//                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            } elseif(nextTok == sym) then {",
  "//                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//                suggestion := errormessages.suggestion.new",
  "//                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            } else {",
  "//                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "//                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            }",
  "//            errormessages.syntaxError(\"A match statement must have either a block or an expression in parentheses after the 'else'.\")atPosition(",
  "//                sym.line, sym.linePos)withSuggestions(suggestions)",
  "//        }",
  "//        elsecase := values.pop",
  "//    }",
  "    values.push(ast.matchCaseNode.new(matchee, cases, elsecase))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept(\"num\")) then {",
  "        pushnum",
  "    } elseif (accept(\"string\")) then {",
  "        pushstring",
  "    } elseif (accept(\"octets\")) then {",
  "        pushoctets",
  "    } elseif(accept(\"identifier\") && (sym.value == \"match\")) then {",
  "        matchcase",
  "    } elseif(accept(\"identifier\") && (sym.value == \"catch\")) then {",
  "        catchcase",
  "    } elseif(accept(\"identifier\") && (sym.value == \"try\")) then {",
  "        trycatch",
  "    } elseif (accept(\"identifier\")) then {",
  "        identifier",
  "    } elseif (accept(\"keyword\") && (sym.value == \"object\")) then {",
  "        doobject",
  "    } elseif (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "        dotypeLiteral",
  "    } elseif (accept(\"lbrace\")) then {",
  "        block",
  "    } elseif (accept(\"lsquare\")) then {",
  "        doarray",
  "    } elseif (accept(\"op\")) then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression(acceptBlocks) {",
  "    var sz := values.size",
  "    util.setPosition(sym.line, sym.linePos)",
  "    if (accept(\"lparen\")) then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        util.setPosition(sym.line, sym.linePos)",
  "        next",
  "        if(didConsume({expression(acceptBlocks)}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        valueexpressionrest",
  "    }",
  "}",
  "",
  "// Accept postcircumfix square brackets (as in x[y]) and replace the",
  "// preceding expression with an index node into itself.",
  "method postfixsquare {",
  "    if (acceptSameLine(\"lsquare\")) then {",
  "        next",
  "        var expr := values.pop",
  "        if(didConsume({expression(blocksOK)}).not) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rsquare\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«index»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«index»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            if(nextTok.kind == \"rsquare\") then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        var index := values.pop",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var o := ast.indexNode.new(expr, index)",
  "        values.push(o)",
  "        dotrest(blocksOK)",
  "        callrest(blocksOK)",
  "        postfixsquare",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif (o == \"/\") then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "",
  "method typeexpressionrest {",
  "    if (acceptSameLine(\"op\")) then {",
  "        expressionrest \"type expression\" recursingWith {typeexpression} blocks (noBlocks)",
  "    }",
  "}",
  "",
  "method valueexpressionrest {",
  "    if (accept(\"op\")) then {",
  "        expressionrest \"expression\" recursingWith {expression(blocksOK)} blocks (blocksOK)",
  "    }",
  "}",
  "",
  "method expressionrest(name) recursingWith (recurse) blocks (acceptBlocks) {",
  "    // Process the rest of an operator expression using the shunting-yard",
  "    // algorithm. This method uses the oprec and toprec methods above to",
  "    // ensure the correct precedence, and treats all operators as",
  "    // left-associative.  It is parametrised so that it",
  "    // can be used for both type- and value- expressions.",
  "    var terms := [] // List of operands yet to be used",
  "    var ops := [] // Operator stack",
  "    var o",
  "    var o2",
  "    var tmp2",
  "    var tmp := values.pop",
  "    terms.push(tmp)",
  "    var prec",
  "    var allarith := true // Consists only of arithmetic operators",
  "    var opcount := 0",
  "    var opdtype := \"\" // The single operator being used in this expression",
  "    while {accept(\"op\")onLineOfLastOr(statementToken).andAlso",
  "            {sym.value != \"=\"}} do {",
  "        opcount := opcount + 1",
  "        o := sym.value",
  "        next",
  "        prec := oprec(o)",
  "        if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "            allarith := false",
  "        }",
  "        if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "            // If: this is not the first operator, it is not the same",
  "            // as the last operator, and the expression has not been",
  "            // entirely arithmetic, raise a syntax error.",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(sym)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken.prev)",
  "            suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"An expression containing both mathematical and non-mathematical operators requires parentheses.\")atPosition(",
  "                lastToken.prev.line, lastToken.prev.linePos)withSuggestions(suggestions)",
  "        }",
  "        opdtype := o",
  "        while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "            // Do the shunting: for as long as the current operator",
  "            // has lesser or equal precedence than the one on the",
  "            // top of the stack, take the operator off the stack and",
  "            // replace its two operands with the combined operator node.",
  "            // This corresponds to left-associative operators only.",
  "            o2 := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            tmp := ast.opNode.new(o2, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        ops.push(o)",
  "        if (accept(\"lparen\")) then {",
  "            // When a parenthesis is found, take an expression from",
  "            // *within* the parentheses and add it to the stack. Do",
  "            // not delegate entirely to expression, because it will",
  "            // then consume all the following operators and break",
  "            // precedence. Possibly parenthesised expressions could",
  "            // be allowed in term above?",
  "            next",
  "            if(didConsume(recurse).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«{name}»\")",
  "                }",
  "                errormessages.syntaxError(\"Parentheses must contain a valid {name}.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if (!tokenOnSameLine) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \" ++ util.lines[sym.line])afterToken(lastToken)",
  "                suggestion.deleteLine(sym.line)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"comma\", \"rparen\", \"rsquare\", \"rbrace\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «{name}»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «{name}»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A valid {name} must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "",
  "        // Regardless of where the last value came from, it may have",
  "        // method invocations, indexes, or method call happening to it,",
  "        // which should be applied and the result put into the operands",
  "        // list.",
  "        dotrest(acceptBlocks)",
  "        callrest(acceptBlocks)",
  "        postfixsquare",
  "        tmp := values.pop",
  "        terms.push(tmp)",
  "    }",
  "    while {ops.size > 0} do {",
  "        // Shunt off any remaining operators at the end",
  "        o := ops.pop",
  "        tmp2 := terms.pop",
  "        tmp := terms.pop",
  "        tmp := ast.opNode.new(o, tmp, tmp2)",
  "        terms.push(tmp)",
  "    }",
  "    tmp := terms.pop",
  "    values.push(tmp)",
  "    if (terms.size > 0) then {",
  "        errormessages.syntaxError(\"Values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "    }",
  "}",
  "",
  "// Accept a member lookup with \".\". This consumes the dot and",
  "// a following identifier, and will pass along to further lookups or",
  "// method calls on the result.",
  "method dotrest(acceptBlocks) {",
  "    if (acceptSameLine(\"dot\")) then {",
  "        util.setPosition(sym.line, sym.linePos)",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept(\"identifier\")) then {",
  "            util.setPosition(sym.line, sym.linePos)",
  "            var dro := ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept(\"dot\")) then {",
  "                dotrest(acceptBlocks)",
  "            } elseif (accept(\"lparen\") || (acceptBlocks && accept(\"lbrace\"))",
  "                || accept(\"num\") || accept(\"string\") || accept(\"lsquare\")",
  "                || accept(\"lgeneric\")",
  "                ) then {",
  "                callrest(acceptBlocks)",
  "            }",
  "        } else {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a method invocation indicated by parentheses. Unparenthesised",
  "// method calls are left as \"member\" AST nodes and processed correctly at",
  "// a later stage.",
  "method callrest(acceptBlocks) {",
  "    if (values.size == 0) then {",
  "        return 0",
  "    }",
  "    var meth := values.pop",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return 0",
  "        }",
  "    }",
  "    def lnum = meth.line",
  "    def lpos = meth.linePos",
  "    var methn := meth.value",
  "    def btok = sym",
  "    util.setPosition(sym.line, sym.linePos)",
  "    var signature := []",
  "    var part := ast.callWithPart.new",
  "    signature.push(part)",
  "    var hadcall := false",
  "    var tok := lastToken",
  "    var startInd := minIndentLevel",
  "    var genericIdents := false",
  "    if (acceptSameLine \"lgeneric\") then {",
  "        genericIdents := typeArgs",
  "    }",
  "    if (acceptSameLine(\"lparen\")) then {",
  "        part.line := sym.line",
  "        part.linePos := sym.linePos",
  "        part.name := methn",
  "        tok := sym",
  "        hadcall := true",
  "        parenthesizedArg(part)",
  "    } elseif (acceptBlocks.not && {accept(\"lbrace\")onLineOf(tok)}) then {",
  "        values.push(meth)",
  "    } elseif (accept(\"string\")onLineOf(tok) || accept(\"num\")onLineOf(tok)",
  "        || accept(\"lbrace\")onLineOf(tok)",
  "        || (accept(\"identifier\")onLineOf(tok) && ((sym.value == \"true\")",
  "                                   || (sym.value == \"false\")))) then {",
  "        tok := sym",
  "        hadcall := true",
  "        part.name := methn",
  "        term",
  "        var ar := values.pop",
  "        part.args.push(ar)",
  "    } elseif (meth.kind == \"identifier\") then {",
  "        values.push(meth)",
  "    } elseif (meth.kind == \"member\") then {",
  "        var root := meth.in",
  "        var outroot := meth",
  "        while {root.kind == \"member\"} do {",
  "            outroot := root",
  "            root := root.in",
  "        }",
  "        if (root.kind == \"identifier\") then {",
  "            values.push(meth)",
  "        } else {",
  "            meth.generics := genericIdents",
  "            values.push(meth)",
  "        }",
  "    }",
  "    if (hadcall) then {",
  "        if (accept(\"identifier\")onLineOfLastOr(tok)) then {",
  "            // Multi-part method name",
  "            def meth' = ast.identifierNode.new(methn, false)",
  "            meth'.line := lnum",
  "            meth'.linePos := lpos",
  "            methn := callmprest(meth', signature, tok)",
  "            if (meth.kind == \"member\") then {",
  "                // callmprest loses this information, so restore",
  "                // the member lookup (for x.between(3)and(10)-type",
  "                // calls).",
  "                meth := ast.memberNode.new(methn.value, meth.in)",
  "                meth.line := methn.line",
  "                meth.linePos := methn.linePos",
  "            } else {",
  "                meth := methn",
  "            }",
  "        }",
  "        util.setline(lnum)",
  "        def call = ast.callNode.new(meth, signature)",
  "        call.generics := genericIdents",
  "        values.push(call)",
  "    } elseif {genericIdents != false} then {",
  "        meth.generics := genericIdents",
  "    }",
  "    minIndentLevel := startInd",
  "    dotrest(acceptBlocks)",
  "}",
  "",
  "method parenthesizedArg(part) {",
  "    next",
  "    ifConsume {expression(blocksOK)} then {",
  "        // For matching blocks - same as below",
  "        if (accept(\"colon\")) then {",
  "            def expr = values.pop",
  "            if (expr.kind != \"identifier\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                if(sym.next.kind == \"identifier\") then {",
  "                    suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                checkBadTypeLiteral",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            expr.dtype := values.pop",
  "            values.push(expr)",
  "        }",
  "        while {accept(\"comma\")} do {",
  "            part.args.push(values.pop)",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A method request must have an expression after a ','.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestions(suggestions)",
  "            }",
  "            // For matching blocks - same as above",
  "            if (accept(\"colon\")) then {",
  "                def arg = values.pop",
  "                if (arg.kind != \"identifier\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.next.kind == \"identifier\") then {",
  "                        suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    checkBadTypeLiteral",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                arg.dtype := values.pop",
  "                values.push(arg)",
  "            }",
  "        }",
  "        part.args.push(values.pop)",
  "    }",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"A method request beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    if (sym.line == part.line) then {",
  "        part.lineLength := sym.linePos - part.linePos",
  "    }",
  "    next",
  "}",
  "",
  "method typeArgs {",
  "    // Parse one or more type arguments, if present, and answer them as a list.",
  "    def startToken = sym",
  "    def args = list.empty",
  "    if (sym.kind != \"lgeneric\") then { return args }",
  "    next",
  "    while {didConsume{typeArg}} do {",
  "        args.add(values.pop)",
  "        if (sym.kind == \"comma\") then { next }",
  "    }",
  "    if(sym.kind != \"rgeneric\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\">\")afterToken(lastToken)",
  "        def suggestion2 = errormessages.suggestion.new",
  "        suggestion2.insert(\" \")beforeToken(startToken)",
  "        def suggestions = [suggestion, suggestion2]",
  "        errormessages.syntaxError(\"A method request containing a '<' must have a matching '>'. \"",
  "            ++ \"If '<' is intended as an operator, precede it by a space.\")",
  "            atPosition(lastToken.line, lastToken.linePos + lastToken.size)",
  "            withSuggestions(suggestions)",
  "    }",
  "    next",
  "    return args",
  "}",
  "",
  "method typeArg {",
  "    // Parses a single type argument, and leave it on the values stack.",
  "    // TODO: 'identifier' could be a dotted identifier, ",
  "    //        or perhaps a type expression?",
  "    if (accept \"identifier\") then {",
  "        identifier",
  "        if (sym.kind == \"lgeneric\") then {",
  "            values.push(ast.genericNode.new(values.pop, typeArgs))",
  "        } else {",
  "            // values.push(values.pop)",
  "        }",
  "    } elseif {didConsume{dotypeLiteral}} then {",
  "        // values.push(values.pop)",
  "    }",
  "}",
  "",
  "method callmprest(meth, signature, tok) {",
  "    // Parses the rest of a multi-part method name.",
  "    // meth is an identifierNode representing the first part of the name.",
  "    // Returns a new identifierNode, representing the full method name,",
  "    // and updates signature.params with the parsed arguments.",
  "    var methname := meth.value",
  "    var nxt",
  "    var lp := meth.linePos",
  "    var part",
  "    while {accept(\"identifier\")onLineOf(tok)",
  "           || accept(\"identifier\")onLineOf(lastToken)} do {",
  "        // Each word must start on the same line as the preceding parameter",
  "        // ended.",
  "        part := ast.callWithPart.new",
  "        signature.push(part)",
  "        methname := methname ++ \"()\"",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var isTerm := false",
  "        if ((accept(\"lparen\")).not && (accept(\"lbrace\")).not",
  "            && accept(\"string\").not && accept(\"num\").not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"identifier\") then {",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                if(methname == \"while()do\") then {",
  "                    errormessages.syntaxError(\"A while loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif(methname == \"for()do\") then {",
  "                    errormessages.syntaxError(\"A for loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"Each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if(methname == \"while()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A while loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif(methname == \"for()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A for loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.insert(\"()\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A multi-part method request must end with '()'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (accept(\"lbrace\")onLineOfLastOr(tok)",
  "            || accept(\"string\")onLineOfLastOr(tok)",
  "            || accept(\"num\")onLineOfLastOr(tok)",
  "            || (accept(\"identifier\")onLineOfLastOr(tok)",
  "                && ((sym.value == \"true\")",
  "                    || (sym.value == \"false\")))) then {",
  "            isTerm := true",
  "        } else {",
  "            next",
  "        }",
  "        var isEmpty := false",
  "        if (accept \"rparen\") then {",
  "            isEmpty := true",
  "        }",
  "        if (isTerm) then {",
  "            term",
  "        } else {",
  "            if(sym.kind != \"rparen\") then {",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression or a ')' after a '('.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                nxt := values.pop",
  "                part.args.push(nxt)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (!isEmpty) then {",
  "            nxt := values.pop",
  "            part.args.push(nxt)",
  "        }",
  "        if (isTerm.not) then {",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A part of a multi-part method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        if (accept(\"rparen\") && isTerm.not) then {",
  "            next",
  "        }",
  "    }",
  "    def meth' = ast.identifierNode.new(methname, false)",
  "    meth'.line := meth.line",
  "    meth'.linePos := meth.linePos",
  "    meth'",
  "}",
  "",
  "// Accept a const declaration",
  "method defdec {",
  "    if (accept(\"keyword\") && (sym.value == \"def\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "                && (t.value == \"=\") && (t.line == sym.line)})",
  "            if(nextToken == false) then {",
  "                suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "            } elseif(nextToken == sym) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"A definition must have a name, '=', and a value after the 'def'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var dtype := ast.unknownType",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        if (accept(\"colon\")) then {",
  "            next",
  "            typeexpression",
  "            dtype := values.pop",
  "        }",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken()",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A definition must have a value after the '='.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            val := values.pop",
  "        } elseif (accept(\"bind\")) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(sym)with(\"=\")",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A definition must use '=' instead of ':='. A variable declaration uses 'var' and ':='.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + 1)withSuggestions(suggestions)",
  "        } else {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A definition must have '=' and a value after the name. \"",
  "                ++ \"A variable declaration does not require a value and uses 'var' instead of 'def'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        if (anns != false) then { o.annotations.extend(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultDefVisibility) overriding(\"confidential\")",
  "        o.startToken := defTok",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept a var declaration",
  "method vardec {",
  "    if (accept(\"keyword\") && (sym.value == \"var\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if((nextToken == false).orElse({nextToken == sym})) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"A variable declaration must have a name after the 'var'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var dtype := ast.unknownType",
  "        var name := values.pop",
  "        name.isBindingOccurrence := true",
  "        if (accept(\"colon\")) then {",
  "            next",
  "            typeexpression",
  "            dtype := values.pop",
  "        }",
  "        def anns = doannotation",
  "        if (accept(\"bind\")) then {",
  "            next",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken()",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        var o := ast.varDecNode.new(name, val, dtype)",
  "        if (anns != false) then { o.annotations.extend(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultVarVisibility) overriding(\"confidential\")",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept a square-bracketed list literal like [1,2,3].",
  "method doarray {",
  "    if (accept(\"lsquare\")) then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        ifConsume {expression(blocksOK)} then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rsquare\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A list must contain zero or more valid expressions separated by commas.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A list beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"dialect \"X\"\"",
  "method dodialect {",
  "    if (accept(\"keyword\") && (sym.value == \"dialect\")) then {",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"A dialect statement must have the name of the dialect in quotes after the 'dialect'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        values.push(ast.dialectNode.new(sym.value))",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"inherits X.new\"",
  "method inheritsdec {",
  "    if (accept(\"keyword\") && (sym.value == \"inherits\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        next",
  "        if(didConsume({expression(noBlocks)}).not) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rsquare\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"The inherits keyword must be followed by an expression that creates the object being inherited.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        util.setPosition(btok.line, btok.linePos)",
  "        def inhNode = ast.inheritsNode.new(values.pop)",
  "        values.push(inhNode)",
  "    }",
  "}",
  "",
  "// Accept an object literal.",
  "method doobject {",
  "    // doobject because \"object\" is a keyword",
  "    if (accept(\"keyword\") && (sym.value == \"object\")) then {",
  "        def btok = sym",
  "        def localMinIndentLevel = minIndentLevel",
  "        next",
  "        if(sym.kind != \"lbrace\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"rbrace\" })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"An object literal must have a '\\{' after the 'object'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        values.push(object {",
  "            var kind := \"lbrace\"",
  "            var register := \"\"",
  "        })",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        var sz := values.size",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // An object body contains zero or more var declarations,",
  "            // const declarations, and method declarations. If anything",
  "            // else appears before the closing brace, it is a syntax error.",
  "            methoddec",
  "            inheritsdec",
  "            statement",
  "            if (sym.kind == \"eof\") then {",
  "                if(sym.kind != \"rbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\"}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An object literal must end with a '}'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } elseif ((values.size == sz) && (lastToken.kind != \"semicolon\")) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"An object literal can contain only definitions, variable and method declarations, and statements.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestion(suggestion)",
  "            }",
  "            sz := values.size",
  "        }",
  "        next",
  "        var rbody := []",
  "        var n := values.pop",
  "        while {n.kind != \"lbrace\"} do {",
  "            rbody.push(n)",
  "            n := values.pop",
  "        }",
  "        var body := []",
  "        for (rbody.indices) do { x ->",
  "            // Reorder the list",
  "            var p := rbody.pop",
  "            body.push(p)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.objectNode.new(body, false)",
  "        values.push(o)",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a class declaration",
  "// Class declarations are currently of the form:",
  "//   class classname.methodName (param1, param2) {",
  "//     inherits foo.new(...)",
  "//     var x",
  "//     method y(z) { ... }",
  "//   }",
  "method doclass {",
  "    if (accept(\"keyword\") && (sym.value == \"class\")) then {",
  "        def btok = sym",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestions = []",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A class must have a name after the 'class'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        def cname = if (tokens.first.kind == \"dot\") then {",
  "            pushidentifier // A class must have a name",
  "            def cname' = values.pop",
  "            cname'.isBindingOccurrence := true",
  "            if (!accept(\"dot\")) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.replaceToken(sym) with(\".\")",
  "                errormessages.syntaxError \"A class must have a dot after the object name.\"",
  "                    atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                    withSuggestion(suggestion)",
  "            }",
  "            next",
  "            cname'",
  "        } else {",
  "            false",
  "        }",
  "        var s := methodsignature(false)",
  "        var csig := s.sig",
  "        var methodName := s.m",
  "        methodName.isBindingOccurrence := true",
  "        var dtype := s.rtype",
  "        def anns = doannotation",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A class must have a '\\{' after the method name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        def body = []",
  "        while {(accept(\"rbrace\")).not.andAlso{sym.kind != \"eof\"}} do {",
  "            ifConsume {methoddec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {inheritsdec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {statement} then {",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setline(btok.line)",
  "        def o = if (false == cname) then {",
  "            ast.methodNode.new(methodName, csig,",
  "                [ast.objectNode.new(body, false)], false)",
  "        } else {",
  "            ast.classNode.new(cname, csig, body, false, methodName, dtype)",
  "        }",
  "        o.generics := s.generics",
  "        if (false != anns) then {",
  "            o.annotations.extend(anns)",
  "        } else {",
  "            if (defaultMethodVisibility == \"confidential\") then {",
  "                o.annotations.push(ast.identifierNode.new(\"confidential\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(o)",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a factory method declaration",
  "method dofactoryMethod {",
  "    if ((accept(\"keyword\") && (sym.value == \"factory\")).andAlso{",
  "            tokens.first.kind == \"keyword\"}.andAlso{",
  "            tokens.first.value == \"method\"}) then {",
  "        def btok = sym",
  "        next",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestions = []",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «method name» \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A factory method must have a name after the 'method'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        var s := methodsignature(false)",
  "        var csig := s.sig",
  "        var methodName := s.m",
  "        methodName.isBindingOccurrence := true",
  "        var dtype := s.rtype",
  "        def anns = doannotation",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A factory method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        def body = []",
  "        while {(accept(\"rbrace\")).not} do {",
  "            ifConsume {methoddec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {inheritsdec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {statement} then {",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setline(btok.line)",
  "        def obj = ast.objectNode.new(body, false)",
  "        def meth = ast.methodNode.new(methodName, csig,",
  "            collections.list.new(obj), dtype)",
  "        meth.generics := s.generics",
  "        if (false != anns) then {",
  "            meth.annotations.extend(anns)",
  "        } else {",
  "            if (defaultMethodVisibility == \"confidential\") then {",
  "                meth.annotations.push(ast.identifierNode.new(\"confidential\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(meth)",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a method declaration",
  "method methoddec {",
  "    if (accept(\"keyword\") && (sym.value == \"method\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        statementToken := sym",
  "        var stok := sym",
  "        next",
  "        var m := methodsignature(false)",
  "        var meth := m.m",
  "        var signature := m.sig",
  "        var dtype := m.rtype",
  "        var varargs := m.v",
  "        var generics := m.generics",
  "        var body := []",
  "        var localMin",
  "        def anns = doannotation",
  "        if (accept(\"lbrace\")) then {",
  "            next",
  "            localMin := minIndentLevel",
  "            if (sym.line == stok.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := stok.indent + 1",
  "            }",
  "            values.push(object {",
  "                var kind := \"lbrace\"",
  "                var register := \"\"",
  "            })",
  "            statement",
  "            var s := values.pop",
  "            while {s.kind != \"lbrace\"} do {",
  "                // The body is a sequence of statements, and",
  "                // the method ends when no further statement",
  "                // is found.",
  "                body.push(s)",
  "                statement",
  "                s := values.pop",
  "            }",
  "            if(sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"A method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if(closingBrace.found == false) then {",
  "                if(closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"A method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.methodNode.new(meth, signature, body, dtype)",
  "        if (varargs) then {",
  "            o.varargs := true",
  "        }",
  "        o.generics := generics",
  "        if (anns != false) then { o.annotations.extend(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultMethodVisibility) overriding(\"public\")",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Process the declaration of a multi-part method name. These follow",
  "// mostly the same rules as calls, but aren't strictly enforced to be on",
  "// a single line (because they are ended by \"{\" or \"->\"). ",
  "// tm is a methodNode.  This method",
  "// returns a replacement method name identifier and modifies tm.params in",
  "// place.",
  "method parsempmndecrest(tm, sameline) {",
  "    var methname := tm.value.value",
  "    var signature := tm.signature",
  "    var nxt",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        methname := methname ++ \"()\"",
  "        var part := ast.signaturePart.new",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var vararg := false",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A multi-part method must have parentheses around each parameter list.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept(\"op\")) then {",
  "                next",
  "                vararg := true",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"A variable length parameter (a parameter beginning with '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            pushidentifier",
  "            nxt := values.pop",
  "            nxt.isBindingOccurrence := true",
  "            if (accept(\"colon\")) then {",
  "                next",
  "                typeexpression",
  "                var tp := values.pop",
  "                nxt.dtype := tp",
  "            }",
  "            if (vararg) then {",
  "                part.vararg := nxt",
  "                tm.varargs := true",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } else {",
  "                part.params.push(nxt)",
  "            }",
  "            if (accept(\"comma\")) then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "    def newName = ast.identifierNode.new(methname, false)",
  "    newName.isBindingOccurrence := true",
  "    newName",
  "}",
  "",
  "// Accept a method signature",
  "method methodsignature(sameline) {",
  "    if((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"A method name must start with an identifier, an operator, or '[]'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    pushidentifier",
  "    var meth := values.pop",
  "    meth.isBindingOccurrence := true",
  "    var signature := list.empty",
  "    var part := ast.signaturePart.new(meth.value)",
  "    var genericIdents := list.empty",
  "    signature.push(part)",
  "    if (meth.value == \"[\") then {",
  "        if(sym.kind != \"rsquare\") then {",
  "            if((sym.kind == \"identifier\") && ((tokens.size == 0).orElse",
  "                {tokens.first.kind == \"rsquare\"})) then {",
  "                def suggestions = list.empty",
  "                def suggestion = errormessages.suggestion.new",
  "                if(tokens.size == 0) then {",
  "                    suggestion.replaceToken(sym)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                } elseif(tokens.first.line == meth.line) then {",
  "                    suggestion.replaceTokenRange(sym, tokens.first)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A declaration of a method named '[]' must have the parameter name in parentheses after the '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"]\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A method name must start with either an identifier or '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        next",
  "        meth.value := \"[]\"",
  "    }",
  "    if (accept(\"lgeneric\")) then {",
  "        // Generic!",
  "        next",
  "        genericIdents := part.generics",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            def id = values.pop",
  "            id.isBindingOccurrence := true",
  "            genericIdents.push(id)",
  "            if (accept(\"comma\")) then {",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type containing a '<' must end with a '>'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    if (accept(\"bind\")) then {",
  "        next",
  "        meth.value := meth.value ++ \":=\"",
  "        part.name := part.name ++ \":=\"",
  "    } elseif (accept(\"op\") && (meth.value == \"prefix\")) then {",
  "        meth.value := meth.value ++ sym.value",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    var dtype := false",
  "    var varargs := false",
  "    var vararg := false",
  "    if (accept(\"lparen\")) then {",
  "        def lparen = sym",
  "        part.linePos := sym.linePos",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept(\"op\")) then {",
  "                next",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "                vararg := true",
  "                varargs := true",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            id.isBindingOccurrence := true",
  "            dtype := false",
  "            if (accept(\"colon\")) then {",
  "                next",
  "                if (didConsume { typeexpression }) then {",
  "                    dtype := values.pop",
  "                } else {",
  "                    checkBadTypeLiteral",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            id.dtype := dtype",
  "            if (vararg) then {",
  "                part.vararg := id",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == sym.line) })",
  "                    if((sym.kind == \"comma\") && (rparen != false)) then {",
  "                        suggestion.insert(\",*{id.value}\")beforeToken(rparen)",
  "                        suggestion.deleteTokenRange(lparen.next, sym)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.\")atRange(",
  "                            lastToken.line, sym.linePos, rparen.linePos - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.insert(\")\")afterToken(lastToken)",
  "                        errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "            } else {",
  "                part.params.push(id)",
  "            }",
  "            if (accept(\"comma\")) then {",
  "                comma := sym",
  "                next",
  "            } elseif (sym.kind != \"rparen\") then {",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if(rparen == false) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            var tm := ast.methodNode.new(meth, signature, [], false)",
  "            meth := parsempmndecrest(tm, sameline)",
  "            varargs := varargs || tm.varargs",
  "        }",
  "    }",
  "    if (accept(\"arrow\")) then {",
  "        // Return dtype",
  "        next",
  "        typeexpression",
  "        dtype := values.pop",
  "    } else {",
  "        dtype := false",
  "    }",
  "    var o := object {",
  "        var m := meth",
  "        var sig := signature",
  "        var rtype := dtype",
  "        var v := varargs",
  "        var generics := genericIdents",
  "    }",
  "    o",
  "}",
  "",
  "method doimport {",
  "    // Accept an import statement, which has the form",
  "    //      import ‹string› as ‹identifier›:‹type expression› is ‹annotation›",
  "    if (accept(\"keyword\") && (sym.value == \"import\")) then {",
  "        def importline = sym.line",
  "        var dtype := ast.unknownType",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def name = values.pop",
  "        name.isBindingOccurrence := true",
  "        if (accept(\"colon\")) then {",
  "            next",
  "            typeexpression",
  "            dtype := values.pop",
  "        }",
  "        util.setline(importline)",
  "        def o = ast.importNode.new(p.value, name, dtype)",
  "        def anns = doannotation",
  "        if (anns != false) then { o.annotations.extend(anns) }",
  "        adjustVisibilityOf(o) withSpecialDefault(defaultDefVisibility) overriding(\"confidential\")",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept a return statement. return takes a mandatory argument,",
  "// of the form \"return x\". x may be any expression.",
  "method doreturn {",
  "    if (accept(\"keyword\") && (sym.value == \"return\")) then {",
  "        next",
  "        var retval",
  "        if ((tokenOnSameLine).andAlso{accept(\"rbrace\").not}) then {",
  "            if(didConsume({expression(blocksOK)}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rbrace\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A return statement must have either an expression or a new-line after 'return'.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestions(suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false)",
  "        }",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    // parses a method in a type literal",
  "    var m := methodsignature(true)",
  "    var meth := m.m",
  "    var signature := m.sig",
  "    var dtype := m.rtype",
  "    var varargs := m.v",
  "    if (dtype == false) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    var o := ast.methodTypeNode.new(meth.value, signature, dtype)",
  "    o.generics := m.generics",
  "    values.push(o)",
  "    if (accept(\"semicolon\")) then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines[sym.line].substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"Methods in a type literal must be on separate lines, or separated by semicolons.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeLiteral {",
  "    // parses a type literal between braces, with optional leading 'type' keyword.",
  "    if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"type literals must open with a brace.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "            return",
  "        }",
  "    }",
  "    if (accept(\"lbrace\")) then {",
  "        def meths = []",
  "        def types = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "                typedec",
  "                types.push(values.pop)",
  "            } else {",
  "                domethodtype",
  "                meths.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        def t = ast.typeLiteralNode.new(meths, types)",
  "        values.push(t)",
  "    }",
  "}",
  "",
  "method typedec {",
  "    // Accept a declaration: 'type = <type expression>'",
  "    if (accept(\"keyword\") && (sym.value == \"type\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        generic",
  "        var p := values.pop",
  "        var gens := sequence.empty",
  "        if (p.kind == \"generic\") then {",
  "            gens := p.params",
  "            p := p.value",
  "        }",
  "        p.isBindingOccurrence := true",
  "        gens.do { each -> each.isBindingOccurrence := true }",
  "        def anns = doannotation",
  "        if((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if((nextTok == false).orElse({nextTok == sym})) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError(\"A type declaration must have a '=' after the type name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        // Special case for type Literals without leading 'type' keyword.",
  "        if (accept(\"lbrace\")) then {",
  "            dotypeLiteral",
  "        } else {",
  "            expression(noBlocks)",
  "        }",
  "        def nt = ast.typeDecNode.new(p, values.pop)",
  "        nt.generics := gens",
  "        if (false != anns) then {",
  "            nt.annotations.extend(anns)",
  "        }",
  "        values.push(nt)",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif (sym.kind == \"semicolon\") then {",
  "        // pass",
  "    } elseif ((sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "        || (sym.kind == \"rsquare\")) then {",
  "        // pass",
  "    } elseif (sym.kind == \"eof\") then {",
  "    } elseif (sym.indent < minIndentLevel) then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            for(1..(minIndentLevel - (sym.linePos - 1))) do { _ ->",
  "                suggestion.insert(\" \")atPosition(1)onLine(sym.line)",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { tok := tok.prev }",
  "            var line := \"\"",
  "            for(1..(tok.indent)) do { _ ->",
  "                line := line ++ \" \"",
  "            }",
  "            line := line ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"The indentation for this line must be at least {minIndentLevel}. This is often caused by a missing '}'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif (sym.indent > minIndentLevel) then {",
  "        minIndentLevel := sym.indent",
  "    }",
  "}",
  "",
  "// Accept a statement. A statement is any of the above that may exist",
  "// at the top level, and includes expressions.",
  "// A statement may also be a bind statement x := y, which creates a",
  "// bind AST node out of the expressions on either side (which at this point",
  "// can be any arbitrary expression).",
  "method statement {",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    checkIndent",
  "    if (accept(\"keyword\")) then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif (sym.value == \"def\") then {",
  "            defdec",
  "        } elseif (sym.value == \"import\") then {",
  "            doimport",
  "        } elseif (sym.value == \"dialect\") then {",
  "            dodialect",
  "        } elseif (sym.value == \"type\") then {",
  "            typedec",
  "        } elseif (sym.value == \"class\") then {",
  "            doclass",
  "        } elseif (sym.value == \"factory\") then {",
  "            dofactoryMethod",
  "        } elseif (sym.value == \"return\") then {",
  "            doreturn",
  "        } else {",
  "            expression(blocksOK)",
  "        }",
  "    } else {",
  "        ifConsume {expression(blocksOK)} then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                next",
  "                if(didConsume({expression(blocksOK)}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var val := values.pop",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    if (accept(\"eof\")) then {",
  "        return true",
  "    }",
  "    if (accept(\"semicolon\")) then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"Use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "    if (sym.kind == \"rgeneric\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\" \")beforeToken(sym)",
  "        errormessages.syntaxError(\"The '>' operator must be preceded by a space.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadTypeLiteral {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"type literals must start with the keyword 'type'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = []",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"Assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind == \"rgeneric\") then {",
  "            def sugg = errormessages.suggestion.new",
  "            sugg.insert(\" \")atPosition(sym.linePos)onLine(sym.line)",
  "            errormessages.syntaxError(",
  "                    \"The '>' operator must have a space before it.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestion(sugg)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = []",
  "            var suggestion",
  "            if ((values.size > 0).andAlso {",
  "                    (values.last.kind == \"identifier\").orElse {",
  "                        values.last.kind == \"member\"",
  "                    }.andAlso {",
  "                        sym.kind == \"identifier\"",
  "                    }",
  "                }) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken(\"rbrace\")",
  "            if(nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines[lastToken.line].substringFrom(1)to(lastToken.linePos + lastToken.size - 1))",
  "                def newLine = util.lines[sym.line].substringFrom(sym.linePos)to(util.lines[sym.line].size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"Multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Parse the given list of tokens, returning a list of AST nodes",
  "// corresponding to it.",
  "method parse(toks) {",
  "    util.log_verbose(\"processing tokens.\")",
  "    values := []",
  "    if (util.extensions.contains(\"DefaultVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultMethodVisibility := util.extensions.get(\"DefaultVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultDefVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultDefVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultVarVisibility\")) then {",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVarVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultMethodVisibility\")) then {",
  "        defaultMethodVisibility := util.extensions.get(\"DefaultMethodVisibility\")",
  "    }",
  "    if (toks.size == 0) then {",
  "        return []",
  "    }",
  "    tokens := toks",
  "    sym := tokens.first",
  "    if (sym.indent > 0) then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.deleteRange(1, sym.indent) onLine(sym.line)",
  "        errormessages.syntaxError(\"The first line must not be indented.\")",
  "            atRange(sym.line, 1, sym.indent)",
  "            withSuggestion(sugg)",
  "    }",
  "    sym.prev := lastToken",
  "// TODO: Do this in lexer.",
  "    tokens.push(object {",
  "        var kind := \"eof\"",
  "        var line := tokens.last.line",
  "        var linePos := util.lines[tokens.last.line].size + 1",
  "        var indent := 0",
  "        var value := \"\"",
  "        def size = 0",
  "        var next := false",
  "        var prev := false",
  "    })",
  "    util.log_verbose(\"parsing.\")",
  "    linenum := 1",
  "    next",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        blank",
  "        methoddec",
  "        blank",
  "        inheritsdec",
  "        blank",
  "        statement",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError(\"Invalid statement. This is often caused by an extra '}', ')', or ']'.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestion(suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    statement",
  "    values",
  "}",
  NULL
};
Object reader_parser_outer_85(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_86(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_86(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_line_87(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_line_87(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_linePos_88(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_linePos_88(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_indent_89(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_indent_89(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_value_90(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_value_90(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_size_91(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_parser_outer_281(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_282(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_283(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_283(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_7993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_7994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_7994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_register_7995(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_7995(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8824(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8825(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_8825(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_register_8826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8826(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_9989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_m_9990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_m_9990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_sig_9991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_sig_9991(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_rtype_9992(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_rtype_9992(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_v_9993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_v_9993(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_generics_9994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_generics_9994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_outer_11667(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11668(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_11668(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_line_11669(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_line_11669(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_linePos_11670(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_linePos_11670(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_indent_11671(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_indent_11671(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_value_11672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_value_11672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_size_11673(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_parser_next_11674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_parser_next_11674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_parser_prev_11675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_parser_prev_11675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_parser_outer_11832(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_11833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_line_11834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_line_11834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_linePos_11835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_linePos_11835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_indent_11836(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_indent_11836(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_value_11837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_value_11837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_size_11838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit18;
static Object strlit23;
static Object strlit39;
static Object strlit70;
static Object strlit76;
static ClassData objclass84;
static Object strlit92;
static Object strlit107;
static Object strlit159;
static Object strlit206;
static Object strlit238;
static Object strlit239;
static Object strlit240;
static Object strlit241;
static Object strlit242;
static Object strlit243;
static Object strlit244;
static Object strlit245;
static Object strlit250;
static ClassData objclass280;
static Object strlit297;
static Object strlit308;
static Object strlit320;
static Object strlit348;
static Object strlit359;
static Object strlit371;
static Object strlit388;
static Object strlit405;
static Object strlit603;
static Object strlit611;
static Object strlit638;
static Object strlit645;
static Object strlit652;
static Object strlit659;
static Object strlit666;
static Object strlit687;
static Object strlit714;
static Object strlit724;
static Object strlit748;
static Object strlit779;
static Object strlit787;
static Object strlit814;
static Object strlit821;
static Object strlit828;
static Object strlit846;
static Object strlit865;
static Object strlit894;
static Object strlit901;
static Object strlit908;
static Object strlit926;
static Object strlit971;
static Object strlit996;
static Object strlit1009;
static Object strlit1016;
static Object strlit1026;
static Object strlit1046;
static Object strlit1053;
static Object strlit1060;
static Object strlit1063;
static Object strlit1071;
static Object strlit1083;
static Object strlit1086;
static Object strlit1130;
static Object strlit1147;
static Object strlit1165;
static Object strlit1170;
static Object strlit1174;
static Object strlit1183;
static Object strlit1205;
static Object strlit1206;
static Object strlit1213;
static Object strlit1220;
static Object strlit1238;
static Object strlit1270;
static Object strlit1280;
static Object strlit1311;
static Object strlit1316;
static Object strlit1328;
static Object strlit1345;
static Object strlit1362;
static Object strlit1372;
static Object strlit1379;
static Object strlit1386;
static Object strlit1389;
static Object strlit1392;
static Object strlit1402;
static Object strlit1412;
static Object strlit1429;
static Object strlit1434;
static Object strlit1444;
static Object strlit1453;
static Object strlit1483;
static Object strlit1490;
static Object strlit1497;
static Object strlit1515;
static Object strlit1531;
static Object strlit1555;
static Object strlit1580;
static Object strlit1601;
static Object strlit1604;
static Object strlit1651;
static Object strlit1658;
static Object strlit1665;
static Object strlit1681;
static Object strlit1688;
static Object strlit1697;
static Object strlit1704;
static Object strlit1728;
static Object strlit1732;
static Object strlit1742;
static Object strlit1745;
static Object strlit1749;
static Object strlit1759;
static Object strlit1762;
static Object strlit1765;
static Object strlit1772;
static Object strlit1782;
static Object strlit1785;
static Object strlit1788;
static Object strlit1794;
static Object strlit1821;
static Object strlit1843;
static Object strlit1851;
static Object strlit1858;
static Object strlit1861;
static Object strlit1872;
static Object strlit1875;
static Object strlit1886;
static Object strlit1889;
static Object strlit1903;
static Object strlit1915;
static Object strlit1918;
static Object strlit1942;
static Object strlit1949;
static Object strlit1956;
static Object strlit1984;
static Object strlit1995;
static Object strlit2000;
static Object strlit2005;
static Object strlit2008;
static Object strlit2042;
static Object strlit2079;
static Object strlit2090;
static Object strlit2095;
static Object strlit2115;
static Object strlit2122;
static Object strlit2136;
static Object strlit2143;
static Object strlit2151;
static Object strlit2154;
static Object strlit2157;
static Object strlit2160;
static Object strlit2163;
static Object strlit2164;
static Object strlit2167;
static Object strlit2181;
static Object strlit2188;
static Object strlit2197;
static Object strlit2205;
static Object strlit2212;
static Object strlit2237;
static Object strlit2241;
static Object strlit2251;
static Object strlit2254;
static Object strlit2258;
static Object strlit2268;
static Object strlit2271;
static Object strlit2274;
static Object strlit2281;
static Object strlit2291;
static Object strlit2294;
static Object strlit2297;
static Object strlit2303;
static Object strlit2331;
static Object strlit2338;
static Object strlit2361;
static Object strlit2369;
static Object strlit2376;
static Object strlit2379;
static Object strlit2390;
static Object strlit2393;
static Object strlit2404;
static Object strlit2407;
static Object strlit2432;
static Object strlit2436;
static Object strlit2441;
static Object strlit2445;
static Object strlit2468;
static Object strlit2475;
static Object strlit2488;
static Object strlit2512;
static Object strlit2517;
static Object strlit2528;
static Object strlit2533;
static Object strlit2552;
static Object strlit2555;
static Object strlit2566;
static Object strlit2569;
static Object strlit2572;
static Object strlit2580;
static Object strlit2608;
static Object strlit2619;
static Object strlit2624;
static Object strlit2629;
static Object strlit2632;
static Object strlit2666;
static Object strlit2703;
static Object strlit2714;
static Object strlit2719;
static Object strlit2747;
static Object strlit2754;
static Object strlit2761;
static Object strlit2789;
static Object strlit2800;
static Object strlit2805;
static Object strlit2810;
static Object strlit2813;
static Object strlit2847;
static Object strlit2884;
static Object strlit2895;
static Object strlit2900;
static Object strlit2925;
static Object strlit2949;
static Object strlit2954;
static Object strlit2965;
static Object strlit2970;
static Object strlit2989;
static Object strlit2992;
static Object strlit3003;
static Object strlit3006;
static Object strlit3009;
static Object strlit3020;
static Object strlit3024;
static Object strlit3036;
static Object strlit3044;
static Object strlit3063;
static Object strlit3070;
static Object strlit3077;
static Object strlit3080;
static Object strlit3088;
static Object strlit3100;
static Object strlit3103;
static Object strlit3132;
static Object strlit3139;
static Object strlit3146;
static Object strlit3152;
static Object strlit3179;
static Object strlit3202;
static Object strlit3223;
static Object strlit3237;
static Object strlit3248;
static Object strlit3259;
static Object strlit3270;
static Object strlit3284;
static Object strlit3324;
static Object strlit3330;
static Object strlit3340;
static Object strlit3347;
static Object strlit3351;
static Object strlit3366;
static Object strlit3376;
static Object strlit3383;
static Object strlit3387;
static Object strlit3411;
static Object strlit3418;
static Object strlit3427;
static Object strlit3433;
static Object strlit3448;
static Object strlit3455;
static Object strlit3473;
static Object strlit3481;
static Object strlit3496;
static Object strlit3500;
static Object strlit3506;
static Object strlit3510;
static Object strlit3520;
static Object strlit3524;
static Object strlit3529;
static Object strlit3535;
static Object strlit3538;
static Object strlit3541;
static Object strlit3573;
static Object strlit3580;
static Object strlit3587;
static Object strlit3590;
static Object strlit3598;
static Object strlit3610;
static Object strlit3613;
static Object strlit3635;
static Object strlit3642;
static Object strlit3652;
static Object strlit3658;
static Object strlit3677;
static Object strlit3684;
static Object strlit3691;
static Object strlit3694;
static Object strlit3702;
static Object strlit3714;
static Object strlit3717;
static Object strlit3743;
static Object strlit3748;
static Object strlit3757;
static Object strlit3767;
static Object strlit3772;
static Object strlit3777;
static Object strlit3782;
static Object strlit3797;
static Object strlit3804;
static Object strlit3812;
static Object strlit3816;
static Object strlit3819;
static Object strlit3821;
static Object strlit3838;
static Object strlit3845;
static Object strlit3852;
static Object strlit3858;
static Object strlit3877;
static Object strlit3884;
static Object strlit3891;
static Object strlit3894;
static Object strlit3902;
static Object strlit3914;
static Object strlit3917;
static Object strlit3943;
static Object strlit3948;
static Object strlit3957;
static Object strlit3967;
static Object strlit3972;
static Object strlit3977;
static Object strlit3982;
static Object strlit4003;
static Object strlit4010;
static Object strlit4019;
static Object strlit4022;
static Object strlit4024;
static Object strlit4030;
static Object strlit4036;
static Object strlit4051;
static Object strlit4058;
static Object strlit4076;
static Object strlit4084;
static Object strlit4099;
static Object strlit4103;
static Object strlit4109;
static Object strlit4113;
static Object strlit4123;
static Object strlit4127;
static Object strlit4132;
static Object strlit4138;
static Object strlit4141;
static Object strlit4144;
static Object strlit4176;
static Object strlit4183;
static Object strlit4190;
static Object strlit4193;
static Object strlit4201;
static Object strlit4213;
static Object strlit4216;
static Object strlit4238;
static Object strlit4245;
static Object strlit4255;
static Object strlit4261;
static Object strlit4280;
static Object strlit4287;
static Object strlit4294;
static Object strlit4297;
static Object strlit4305;
static Object strlit4317;
static Object strlit4320;
static Object strlit4346;
static Object strlit4351;
static Object strlit4360;
static Object strlit4370;
static Object strlit4375;
static Object strlit4380;
static Object strlit4385;
static Object strlit4400;
static Object strlit4407;
static Object strlit4414;
static Object strlit4420;
static Object strlit4439;
static Object strlit4446;
static Object strlit4453;
static Object strlit4456;
static Object strlit4464;
static Object strlit4476;
static Object strlit4479;
static Object strlit4505;
static Object strlit4510;
static Object strlit4519;
static Object strlit4529;
static Object strlit4534;
static Object strlit4539;
static Object strlit4544;
static Object strlit4565;
static Object strlit4572;
static Object strlit4581;
static Object strlit4596;
static Object strlit4603;
static Object strlit4620;
static Object strlit4635;
static Object strlit4639;
static Object strlit4649;
static Object strlit4652;
static Object strlit4656;
static Object strlit4662;
static Object strlit4665;
static Object strlit4671;
static Object strlit4699;
static Object strlit4706;
static Object strlit4713;
static Object strlit4716;
static Object strlit4726;
static Object strlit4738;
static Object strlit4741;
static Object strlit4761;
static Object strlit4768;
static Object strlit4778;
static Object strlit4784;
static Object strlit4803;
static Object strlit4810;
static Object strlit4817;
static Object strlit4820;
static Object strlit4828;
static Object strlit4840;
static Object strlit4843;
static Object strlit4869;
static Object strlit4874;
static Object strlit4883;
static Object strlit4893;
static Object strlit4898;
static Object strlit4903;
static Object strlit4908;
static Object strlit4936;
static Object strlit4942;
static Object strlit4948;
static Object strlit4955;
static Object strlit4962;
static Object strlit4970;
static Object strlit4977;
static Object strlit4985;
static Object strlit4992;
static Object strlit4999;
static Object strlit5006;
static Object strlit5013;
static Object strlit5023;
static Object strlit5030;
static Object strlit5037;
static Object strlit5043;
static Object strlit5049;
static Object strlit5064;
static Object strlit5090;
static Object strlit5097;
static Object strlit5104;
static Object strlit5107;
static Object strlit5115;
static Object strlit5127;
static Object strlit5130;
static Object strlit5163;
static Object strlit5185;
static Object strlit5192;
static Object strlit5199;
static Object strlit5205;
static Object strlit5222;
static Object strlit5232;
static Object strlit5242;
static Object strlit5245;
static Object strlit5273;
static Object strlit5279;
static Object strlit5300;
static Object strlit5303;
static Object strlit5313;
static Object strlit5316;
static Object strlit5332;
static Object strlit5340;
static Object strlit5347;
static Object strlit5369;
static Object strlit5375;
static Object strlit5381;
static Object strlit5386;
static Object strlit5405;
static Object strlit5416;
static Object strlit5419;
static Object strlit5431;
static Object strlit5436;
static Object strlit5447;
static Object strlit5500;
static Object strlit5514;
static Object strlit5522;
static Object strlit5526;
static Object strlit5536;
static Object strlit5540;
static Object strlit5546;
static Object strlit5550;
static Object strlit5560;
static Object strlit5572;
static Object strlit5575;
static Object strlit5611;
static Object strlit5615;
static Object strlit5634;
static Object strlit5645;
static Object strlit5651;
static Object strlit5680;
static Object strlit5681;
static Object strlit5682;
static Object strlit5683;
static Object strlit5691;
static Object strlit5695;
static Object strlit5705;
static Object strlit5709;
static Object strlit5730;
static Object strlit5737;
static Object strlit5741;
static Object strlit5812;
static Object strlit5821;
static Object strlit5835;
static Object strlit5855;
static Object strlit5862;
static Object strlit5867;
static Object strlit5872;
static Object strlit5877;
static Object strlit5883;
static Object strlit5889;
static Object strlit5913;
static Object strlit5918;
static Object strlit5937;
static Object strlit5944;
static Object strlit5975;
static Object strlit5982;
static Object strlit6004;
static Object strlit6018;
static Object strlit6025;
static Object strlit6033;
static Object strlit6039;
static Object strlit6044;
static Object strlit6048;
static Object strlit6068;
static Object strlit6077;
static Object strlit6088;
static Object strlit6104;
static Object strlit6118;
static Object strlit6134;
static Object strlit6190;
static Object strlit6196;
static Object strlit6207;
static Object strlit6221;
static Object strlit6247;
static Object strlit6275;
static Object strlit6282;
static Object strlit6289;
static Object strlit6307;
static Object strlit6323;
static Object strlit6352;
static Object strlit6359;
static Object strlit6366;
static Object strlit6384;
static Object strlit6392;
static Object strlit6398;
static Object strlit6409;
static Object strlit6423;
static Object strlit6447;
static Object strlit6475;
static Object strlit6482;
static Object strlit6489;
static Object strlit6507;
static Object strlit6531;
static Object strlit6543;
static Object strlit6546;
static Object strlit6583;
static Object strlit6609;
static Object strlit6620;
static Object strlit6630;
static Object strlit6637;
static Object strlit6642;
static Object strlit6644;
static Object strlit6661;
static Object strlit6667;
static Object strlit6700;
static Object strlit6704;
static Object strlit6718;
static Object strlit6742;
static Object strlit6749;
static Object strlit6756;
static Object strlit6762;
static Object strlit6774;
static Object strlit6783;
static Object strlit6789;
static Object strlit6795;
static Object strlit6799;
static Object strlit6807;
static Object strlit6811;
static Object strlit6818;
static Object strlit6826;
static Object strlit6830;
static Object strlit6833;
static Object strlit6841;
static Object strlit6845;
static Object strlit6848;
static Object strlit6855;
static Object strlit6858;
static Object strlit6869;
static Object strlit6876;
static Object strlit6884;
static Object strlit6890;
static Object strlit6895;
static Object strlit6899;
static Object strlit6911;
static Object strlit6920;
static Object strlit6941;
static Object strlit6948;
static Object strlit6955;
static Object strlit6973;
static Object strlit6983;
static Object strlit7013;
static Object strlit7020;
static Object strlit7027;
static Object strlit7045;
static Object strlit7068;
static Object strlit7080;
static Object strlit7083;
static Object strlit7100;
static Object strlit7124;
static Object strlit7131;
static Object strlit7142;
static Object strlit7165;
static Object strlit7172;
static Object strlit7187;
static Object strlit7194;
static Object strlit7201;
static Object strlit7204;
static Object strlit7222;
static Object strlit7236;
static Object strlit7243;
static Object strlit7269;
static Object strlit7276;
static Object strlit7279;
static Object strlit7295;
static Object strlit7303;
static Object strlit7313;
static Object strlit7318;
static Object strlit7336;
static Object strlit7346;
static Object strlit7352;
static Object strlit7354;
static Object strlit7375;
static Object strlit7385;
static Object strlit7392;
static Object strlit7403;
static Object strlit7425;
static Object strlit7447;
static Object strlit7454;
static Object strlit7457;
static Object strlit7475;
static Object strlit7488;
static Object strlit7514;
static Object strlit7521;
static Object strlit7540;
static Object strlit7542;
static Object strlit7560;
static Object strlit7567;
static Object strlit7576;
static Object strlit7586;
static Object strlit7591;
static Object strlit7613;
static Object strlit7620;
static Object strlit7637;
static Object strlit7665;
static Object strlit7672;
static Object strlit7679;
static Object strlit7697;
static Object strlit7714;
static Object strlit7724;
static Object strlit7727;
static Object strlit7750;
static Object strlit7757;
static Object strlit7764;
static Object strlit7784;
static Object strlit7792;
static Object strlit7798;
static Object strlit7806;
static Object strlit7821;
static Object strlit7839;
static Object strlit7846;
static Object strlit7869;
static Object strlit7876;
static Object strlit7883;
static Object strlit7901;
static Object strlit7934;
static Object strlit7941;
static Object strlit7948;
static Object strlit7961;
static Object strlit7974;
static Object strlit7977;
static Object strlit7980;
static ClassData objclass7992;
static Object strlit7996;
static Object strlit7997;
static Object strlit8030;
static Object strlit8044;
static Object strlit8051;
static Object strlit8061;
static Object strlit8064;
static Object strlit8078;
static Object strlit8097;
static Object strlit8128;
static Object strlit8171;
static Object strlit8178;
static Object strlit8185;
static Object strlit8193;
static Object strlit8203;
static Object strlit8213;
static Object strlit8222;
static Object strlit8227;
static Object strlit8244;
static Object strlit8261;
static Object strlit8269;
static Object strlit8272;
static Object strlit8307;
static Object strlit8315;
static Object strlit8318;
static Object strlit8365;
static Object strlit8373;
static Object strlit8466;
static Object strlit8471;
static Object strlit8488;
static Object strlit8500;
static Object strlit8510;
static Object strlit8517;
static Object strlit8528;
static Object strlit8536;
static Object strlit8546;
static Object strlit8556;
static Object strlit8565;
static Object strlit8570;
static Object strlit8602;
static Object strlit8610;
static Object strlit8613;
static Object strlit8658;
static Object strlit8742;
static Object strlit8747;
static Object strlit8762;
static Object strlit8769;
static Object strlit8795;
static ClassData objclass8823;
static Object strlit8827;
static Object strlit8828;
static Object strlit8838;
static Object strlit8857;
static Object strlit8883;
static Object strlit8894;
static Object strlit8899;
static Object strlit8929;
static Object strlit8941;
static Object strlit8944;
static Object strlit8948;
static Object strlit8952;
static Object strlit8987;
static Object strlit9003;
static Object strlit9008;
static Object strlit9019;
static Object strlit9046;
static Object strlit9054;
static Object strlit9057;
static Object strlit9072;
static Object strlit9079;
static Object strlit9084;
static Object strlit9092;
static Object strlit9100;
static Object strlit9111;
static Object strlit9139;
static Object strlit9160;
static Object strlit9178;
static Object strlit9188;
static Object strlit9191;
static Object strlit9208;
static Object strlit9217;
static Object strlit9227;
static Object strlit9230;
static Object strlit9259;
static Object strlit9267;
static Object strlit9274;
static Object strlit9286;
static Object strlit9289;
static Object strlit9325;
static Object strlit9332;
static Object strlit9343;
static Object strlit9360;
static Object strlit9383;
static Object strlit9389;
static Object strlit9409;
static Object strlit9415;
static Object strlit9422;
static Object strlit9438;
static Object strlit9441;
static Object strlit9455;
static Object strlit9459;
static Object strlit9470;
static Object strlit9486;
static Object strlit9494;
static Object strlit9504;
static Object strlit9507;
static Object strlit9522;
static Object strlit9528;
static Object strlit9536;
static Object strlit9545;
static Object strlit9552;
static Object strlit9580;
static Object strlit9595;
static Object strlit9602;
static Object strlit9607;
static Object strlit9615;
static Object strlit9621;
static Object strlit9632;
static Object strlit9660;
static Object strlit9687;
static Object strlit9710;
static Object strlit9726;
static Object strlit9739;
static Object strlit9761;
static Object strlit9777;
static Object strlit9785;
static Object strlit9791;
static Object strlit9802;
static Object strlit9815;
static Object strlit9818;
static Object strlit9835;
static Object strlit9842;
static Object strlit9849;
static Object strlit9859;
static Object strlit9862;
static Object strlit9877;
static Object strlit9899;
static Object strlit9913;
static Object strlit9918;
static Object strlit9948;
static Object strlit9953;
static Object strlit9977;
static ClassData objclass9988;
static Object strlit9999;
static Object strlit10006;
static Object strlit10017;
static Object strlit10037;
static Object strlit10045;
static Object strlit10051;
static Object strlit10059;
static Object strlit10074;
static Object strlit10085;
static Object strlit10092;
static Object strlit10113;
static Object strlit10120;
static Object strlit10124;
static Object strlit10130;
static Object strlit10135;
static Object strlit10154;
static Object strlit10174;
static Object strlit10182;
static Object strlit10188;
static Object strlit10197;
static Object strlit10203;
static Object strlit10220;
static Object strlit10233;
static Object strlit10262;
static Object strlit10270;
static Object strlit10277;
static Object strlit10288;
static Object strlit10311;
static Object strlit10318;
static Object strlit10336;
static Object strlit10354;
static Object strlit10375;
static Object strlit10405;
static Object strlit10425;
static Object strlit10432;
static Object strlit10479;
static Object strlit10491;
static Object strlit10498;
static Object strlit10506;
static Object strlit10514;
static Object strlit10517;
static Object strlit10525;
static Object strlit10541;
static Object strlit10552;
static Object strlit10559;
static Object strlit10588;
static Object strlit10595;
static Object strlit10606;
static Object strlit10616;
static Object strlit10619;
static Object strlit10646;
static Object strlit10673;
static Object strlit10680;
static Object strlit10694;
static Object strlit10715;
static Object strlit10720;
static Object strlit10723;
static Object strlit10742;
static Object strlit10773;
static Object strlit10781;
static Object strlit10789;
static Object strlit10796;
static Object strlit10805;
static Object strlit10848;
static Object strlit10892;
static Object strlit10903;
static Object strlit10910;
static Object strlit10926;
static Object strlit10930;
static Object strlit10956;
static Object strlit10960;
static Object strlit10969;
static Object strlit10978;
static Object strlit10987;
static Object strlit10996;
static Object strlit11005;
static Object strlit11014;
static Object strlit11023;
static Object strlit11043;
static Object strlit11048;
static Object strlit11058;
static Object strlit11067;
static Object strlit11097;
static Object strlit11104;
static Object strlit11111;
static Object strlit11129;
static Object strlit11147;
static Object strlit11152;
static Object strlit11171;
static Object strlit11181;
static Object strlit11184;
static Object strlit11194;
static Object strlit11204;
static Object strlit11207;
static Object strlit11218;
static Object strlit11228;
static Object strlit11231;
static Object strlit11251;
static Object strlit11259;
static Object strlit11266;
static Object strlit11281;
static Object strlit11292;
static Object strlit11297;
static Object strlit11307;
static Object strlit11317;
static Object strlit11324;
static Object strlit11334;
static Object strlit11348;
static Object strlit11358;
static Object strlit11367;
static Object strlit11393;
static Object strlit11399;
static Object strlit11431;
static Object strlit11437;
static Object strlit11442;
static Object strlit11450;
static Object strlit11466;
static Object strlit11472;
static Object strlit11479;
static Object strlit11553;
static Object strlit11561;
static Object strlit11567;
static Object strlit11572;
static Object strlit11578;
static Object strlit11584;
static Object strlit11591;
static Object strlit11596;
static Object strlit11603;
static Object strlit11608;
static Object strlit11615;
static Object strlit11620;
static Object strlit11656;
static ClassData objclass11666;
static Object strlit11676;
static Object strlit11695;
static Object strlit11701;
static Object strlit11746;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_mgcollections;
Object module_mgcollections_init();
Object module_errormessages;
Object module_errormessages_init();
static Object strlit11816;
static Object strlit11820;
static Object strlit11824;
static ClassData objclass11831;
static Object strlit11839;
static Object strlit11843;
Object meth_parser__apply30(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num32 = alloc_Float64(0);
// compiled num node returning num32 (depth = 9)
  int op_slot_right_31 = gc_frame_newslot(num32);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe34 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  partcv[0] = 0;
  Object call35 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe34);
// compiled call node returning call35 (depth = 10)
// compiled member node returning call35 (depth = 9)
  int op_slot_left_31 = gc_frame_newslot(call35);
  params[0] = num32;
  partcv[0] = 1;
  Object opresult36 = callmethod(call35, ">", 1, partcv, params);
// compiled op node returning opresult36 (depth = 8)
  gc_frame_end(frame);
  return opresult36;
}
Object meth_parser__apply27(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe28 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block29 = alloc_Block(NULL, NULL, "parser", 49);
  gc_frame_newslot(block29);
// method _apply
  block_savedest(block29);
  Object closure30 = createclosure(2, "_apply");
  setclosureframe(closure30, stackframe);
  addtoclosure(closure30, var_tokens);
  addtoclosure(closure30, selfslot);
  struct UserObject *uo30 = (struct UserObject*)block29;
  uo30->data[0] = (Object)closure30;
  Method *meth_meth_parser__apply30 = addmethod2pos(block29, "_apply", &meth_parser__apply30, 0);
  int argcv_meth_parser__apply30[] = {0};
  meth_meth_parser__apply30->type = alloc_MethodType(1, argcv_meth_parser__apply30);
  meth_meth_parser__apply30->definitionModule = modulename;
  meth_meth_parser__apply30->definitionLine = 47;
// compiled block node returning block29 (depth = 7)
  gc_frame_newslot(block29);
// call case 6: other member request
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit39 == NULL) {
    strlit39 = alloc_String("comment");
    gc_root(strlit39);
  }
// compiled string node returning strlit39 (depth = 8)
  int op_slot_right_38 = gc_frame_newslot(strlit39);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe41 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call42 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe41);
// compiled call node returning call42 (depth = 9)
// compiled member node returning call42 (depth = 8)
  int op_slot_left_38 = gc_frame_newslot(call42);
  params[0] = strlit39;
  partcv[0] = 1;
  Object opresult43 = callmethod(call42, "==", 1, partcv, params);
// compiled op node returning opresult43 (depth = 7)
  params[0] = block29;
  partcv[0] = 1;
  Object call44 = callmethod(opresult43, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe28);
// compiled call node returning call44 (depth = 6)
  gc_frame_end(frame);
  return call44;
}
Object meth_parser__apply47(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_comment = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe49 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call50 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe49);
// compiled call node returning call50 (depth = 9)
// compiled member node returning call50 (depth = 8)
  int op_slot_right_48 = gc_frame_newslot(call50);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_comment (depth = 8)
  int op_slot_left_48 = gc_frame_newslot(*var_comment);
  params[0] = call50;
  partcv[0] = 1;
  Object opresult52 = callmethod(*var_comment, "++", 1, partcv, params);
// compiled op node returning opresult52 (depth = 7)
  *var_comment = opresult52;
  if (opresult52 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe54 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call55 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe54);
// compiled call node returning call55 (depth = 8)
// compiled member node returning call55 (depth = 7)
  *var_sym = call55;
  if (call55 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_next0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object *var_linenum = getfromclosure(closure, 3);
  Object *var_lastline = getfromclosure(closure, 4);
  Object *var_lastIndent = getfromclosure(closure, 5);
  Object *var_comment = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_errormessages = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4 = alloc_Float64(0);
// compiled num node returning num4 (depth = 4)
  int op_slot_right_3 = gc_frame_newslot(num4);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call7 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe6);
// compiled call node returning call7 (depth = 5)
// compiled member node returning call7 (depth = 4)
  int op_slot_left_3 = gc_frame_newslot(call7);
  params[0] = num4;
  partcv[0] = 1;
  Object opresult8 = callmethod(call7, ">", 1, partcv, params);
// compiled op node returning opresult8 (depth = 3)
  Object if2 = done;
  if (istrue(opresult8)) {
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_linenum (depth = 4)
  *var_lastline = *var_linenum;
  if (*var_linenum == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10);
// compiled call node returning call11 (depth = 5)
// compiled member node returning call11 (depth = 4)
  *var_lastIndent = call11;
  if (call11 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe13 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call14 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe13);
// compiled call node returning call14 (depth = 5)
// compiled member node returning call14 (depth = 4)
  *var_sym = call14;
  if (call14 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit18 == NULL) {
    strlit18 = alloc_String("comment");
    gc_root(strlit18);
  }
// compiled string node returning strlit18 (depth = 5)
  int op_slot_right_17 = gc_frame_newslot(strlit18);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe20 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call21 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe20);
// compiled call node returning call21 (depth = 6)
// compiled member node returning call21 (depth = 5)
  int op_slot_left_17 = gc_frame_newslot(call21);
  params[0] = strlit18;
  partcv[0] = 1;
  Object opresult22 = callmethod(call21, "==", 1, partcv, params);
// compiled op node returning opresult22 (depth = 4)
  Object if16 = done;
  if (istrue(opresult22)) {
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit23 == NULL) {
    strlit23 = alloc_String("");
    gc_root(strlit23);
  }
// compiled string node returning strlit23 (depth = 5)
  *var_comment = strlit23;
  if (strlit23 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe25 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block26 = alloc_Block(NULL, NULL, "parser", 49);
  gc_frame_newslot(block26);
// method _apply
  block_savedest(block26);
  Object closure27 = createclosure(3, "_apply");
  setclosureframe(closure27, stackframe);
  addtoclosure(closure27, var_tokens);
  addtoclosure(closure27, var_sym);
  addtoclosure(closure27, selfslot);
  struct UserObject *uo27 = (struct UserObject*)block26;
  uo27->data[0] = (Object)closure27;
  Method *meth_meth_parser__apply27 = addmethod2pos(block26, "_apply", &meth_parser__apply27, 0);
  int argcv_meth_parser__apply27[] = {0};
  meth_meth_parser__apply27->type = alloc_MethodType(1, argcv_meth_parser__apply27);
  meth_meth_parser__apply27->definitionModule = modulename;
  meth_meth_parser__apply27->definitionLine = 47;
// compiled block node returning block26 (depth = 5)
  gc_frame_newslot(block26);
// starting to compile block node (depth = 5)
  Object block46 = alloc_Block(NULL, NULL, "parser", 49);
  gc_frame_newslot(block46);
// method _apply
  block_savedest(block46);
  Object closure47 = createclosure(4, "_apply");
  setclosureframe(closure47, stackframe);
  addtoclosure(closure47, var_sym);
  addtoclosure(closure47, var_comment);
  addtoclosure(closure47, var_tokens);
  addtoclosure(closure47, selfslot);
  struct UserObject *uo47 = (struct UserObject*)block46;
  uo47->data[0] = (Object)closure47;
  Method *meth_meth_parser__apply47 = addmethod2pos(block46, "_apply", &meth_parser__apply47, 0);
  int argcv_meth_parser__apply47[] = {0};
  meth_meth_parser__apply47->type = alloc_MethodType(1, argcv_meth_parser__apply47);
  meth_meth_parser__apply47->definitionModule = modulename;
  meth_meth_parser__apply47->definitionLine = 49;
// compiled block node returning block46 (depth = 5)
  gc_frame_newslot(block46);
// call case 5: prelude request
  params[0] = block26;
  params[1] = block46;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call58 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe25);
// compiled call node returning call58 (depth = 4)
    gc_frame_newslot(call58);
    if16 = call58;
  } else {
  }
// compiled if node returning if16 (depth = 3)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe59 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call60 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe59);
// compiled call node returning call60 (depth = 5)
// compiled member node returning call60 (depth = 4)
  *var_linenum = call60;
  if (call60 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe62 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe63 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call64 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe63);
// compiled call node returning call64 (depth = 5)
// compiled member node returning call64 (depth = 4)
  gc_frame_newslot(call64);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe65 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call66 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe65);
// compiled call node returning call66 (depth = 5)
// compiled member node returning call66 (depth = 4)
  gc_frame_newslot(call66);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call64;
  params[1] = call66;
  partcv[0] = 2;
  Object call67 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe62);
// compiled call node returning call67 (depth = 3)
    gc_frame_newslot(call67);
    if2 = call67;
  } else {
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit70 == NULL) {
    strlit70 = alloc_String("eof");
    gc_root(strlit70);
  }
// compiled string node returning strlit70 (depth = 5)
  int op_slot_right_69 = gc_frame_newslot(strlit70);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe72 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call73 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe72);
// compiled call node returning call73 (depth = 6)
// compiled member node returning call73 (depth = 5)
  int op_slot_left_69 = gc_frame_newslot(call73);
  params[0] = strlit70;
  partcv[0] = 1;
  Object opresult74 = callmethod(call73, "==", 1, partcv, params);
// compiled op node returning opresult74 (depth = 4)
  Object if68 = done;
  if (istrue(opresult74)) {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe75 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit76 == NULL) {
    strlit76 = alloc_String("Unexpetedly found the end of the input. This is often caused by a missing '}'");
    gc_root(strlit76);
  }
// compiled string node returning strlit76 (depth = 5)
  gc_frame_newslot(strlit76);
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe77 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call78 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe77);
// compiled call node returning call78 (depth = 6)
// compiled member node returning call78 (depth = 5)
  gc_frame_newslot(call78);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe79 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call80 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe79);
// compiled call node returning call80 (depth = 6)
// compiled member node returning call80 (depth = 5)
  gc_frame_newslot(call80);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe81 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call82 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe81);
// compiled call node returning call82 (depth = 6)
// compiled member node returning call82 (depth = 5)
  gc_frame_newslot(call82);
// call case 6: other member request
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit76;
  params[1] = call78;
  params[2] = call80;
  params[3] = call82;
  partcv[0] = 1;
  partcv[1] = 3;
  Object call83 = callmethod(*var_errormessages, "syntaxError()atRange",
    2, partcv, params);
  gc_frame_end(callframe75);
// compiled call node returning call83 (depth = 4)
    gc_frame_newslot(call83);
    if68 = call83;
  } else {
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject84 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj84 = alloc_userobj2(11,7, objclass84);
  gc_frame_newslot(obj84);
// OBJECT OUTER DEC outer
  adddatum2(obj84, self, 0);
  addmethodreal(obj84,"outer", &reader_parser_outer_85);
  Object oldself84 = self;
  struct StackFrameObject *oldstackframe84 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe84);
  gc_frame_newslot((Object)stackframe);
  self = obj84;
  Object *oldselfslot84 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter84 = (*(struct UserObject *)self).data[0], lowerouter84 = thisouter84;
  if (inheritingObject84) {
    struct UserObject *inho84 = (struct UserObject *)inheritingObject84;
    while (inho84->super != GraceDefaultObject) inho84 = (struct UserObject *)inho84->super;
    inho84->super = obj84;
    self = inheritingObject84;
    *selfslot = self;
    lowerouter84 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter84;
  }
if (objclass84 == NULL) {
  Method *reader86 = addmethodrealflags(obj84, "kind",&reader_parser_kind_86, 0);
  Method *writer86 = addmethodrealflags(obj84, "kind:=",&writer_parser_kind_86, 0);
  reader86->definitionModule = modulename;
  writer86->definitionModule = modulename;
  reader86->definitionLine = 62;
  writer86->definitionLine = 62;
}
obj84->flags |= OFLAG_MUTABLE;
adddatum2(obj84, alloc_Undefined(), 1);
if (objclass84 == NULL) {
  Method *reader87 = addmethodrealflags(obj84, "line",&reader_parser_line_87, 0);
  Method *writer87 = addmethodrealflags(obj84, "line:=",&writer_parser_line_87, 0);
  reader87->definitionModule = modulename;
  writer87->definitionModule = modulename;
  reader87->definitionLine = 63;
  writer87->definitionLine = 63;
}
obj84->flags |= OFLAG_MUTABLE;
adddatum2(obj84, alloc_Undefined(), 2);
if (objclass84 == NULL) {
  Method *reader88 = addmethodrealflags(obj84, "linePos",&reader_parser_linePos_88, 0);
  Method *writer88 = addmethodrealflags(obj84, "linePos:=",&writer_parser_linePos_88, 0);
  reader88->definitionModule = modulename;
  writer88->definitionModule = modulename;
  reader88->definitionLine = 64;
  writer88->definitionLine = 64;
}
obj84->flags |= OFLAG_MUTABLE;
adddatum2(obj84, alloc_Undefined(), 3);
if (objclass84 == NULL) {
  Method *reader89 = addmethodrealflags(obj84, "indent",&reader_parser_indent_89, 0);
  Method *writer89 = addmethodrealflags(obj84, "indent:=",&writer_parser_indent_89, 0);
  reader89->definitionModule = modulename;
  writer89->definitionModule = modulename;
  reader89->definitionLine = 65;
  writer89->definitionLine = 65;
}
obj84->flags |= OFLAG_MUTABLE;
adddatum2(obj84, alloc_Undefined(), 4);
if (objclass84 == NULL) {
  Method *reader90 = addmethodrealflags(obj84, "value",&reader_parser_value_90, 0);
  Method *writer90 = addmethodrealflags(obj84, "value:=",&writer_parser_value_90, 0);
  reader90->definitionModule = modulename;
  writer90->definitionModule = modulename;
  reader90->definitionLine = 66;
  writer90->definitionLine = 66;
}
obj84->flags |= OFLAG_MUTABLE;
adddatum2(obj84, alloc_Undefined(), 5);
if (objclass84 == NULL) {
  Method *reader91 = addmethodrealflags(obj84, "size",&reader_parser_size_91, MFLAG_DEF);
  reader91->definitionModule = modulename;
  reader91->definitionLine = 67;
}
adddatum2(obj84, alloc_Undefined(), 6);
  sourceObject = obj84;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit92 == NULL) {
    strlit92 = alloc_String("eof");
    gc_root(strlit92);
  }
// compiled string node returning strlit92 (depth = 6)
  adddatum2(obj84, strlit92, 1);
  sourceObject = obj84;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe93 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call94 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe93);
// compiled call node returning call94 (depth = 7)
// compiled member node returning call94 (depth = 6)
  adddatum2(obj84, call94, 2);
  sourceObject = obj84;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num96 = alloc_Float64(1);
// compiled num node returning num96 (depth = 7)
  int op_slot_right_95 = gc_frame_newslot(num96);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe98 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe99 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call100 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 11)
// compiled member node returning call100 (depth = 10)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe101 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call102 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe101);
// compiled call node returning call102 (depth = 11)
// compiled member node returning call102 (depth = 10)
  params[0] = call102;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres103 = callmethod(call100, "[]", 1, partcv, params);
// compiled index node returning idxres103 (depth = 9)
  partcv[0] = 0;
  Object call104 = callmethod(idxres103, "size",
    1, partcv, params);
  gc_frame_end(callframe98);
// compiled call node returning call104 (depth = 8)
// compiled member node returning call104 (depth = 7)
  int op_slot_left_95 = gc_frame_newslot(call104);
  params[0] = num96;
  partcv[0] = 1;
  Object sum105 = callmethod(call104, "+", 1, partcv, params);
// compiled op node returning sum105 (depth = 6)
  adddatum2(obj84, sum105, 3);
  sourceObject = obj84;
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num106 = alloc_Float64(0);
// compiled num node returning num106 (depth = 6)
  adddatum2(obj84, num106, 4);
  sourceObject = obj84;
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit107 == NULL) {
    strlit107 = alloc_String("");
    gc_root(strlit107);
  }
// compiled string node returning strlit107 (depth = 6)
  adddatum2(obj84, strlit107, 5);
  sourceObject = obj84;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num108 = alloc_Float64(0);
// compiled num node returning num108 (depth = 6)
  adddatum2(obj84, num108, 6);
objclass84 = obj84->class;
  objclass84->definitionModule = modulename;
  objclass84->definitionLine = 60;
  (*(struct UserObject *)self).data[0] = lowerouter84;
  self = oldself84;
  selfslot = oldselfslot84;
  stackframe = oldstackframe84;
// compiled object node returning obj84 (depth = 5)
  *var_sym = obj84;
  if (obj84 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if68 = done;
  }
// compiled if node returning if68 (depth = 3)
    gc_frame_newslot(if68);
    if2 = if68;
  }
// compiled if node returning if2 (depth = 2)
  gc_frame_end(frame);
  return if2;
}
Object meth_parser__apply120(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call123 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe122);
// compiled call node returning call123 (depth = 8)
// compiled member node returning call123 (depth = 7)
  int op_slot_right_121 = gc_frame_newslot(call123);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe125 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call126 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe125);
// compiled call node returning call126 (depth = 8)
// compiled member node returning call126 (depth = 7)
  int op_slot_left_121 = gc_frame_newslot(call126);
  params[0] = call123;
  partcv[0] = 1;
  Object opresult127 = callmethod(call126, ">=", 1, partcv, params);
// compiled op node returning opresult127 (depth = 6)
  gc_frame_end(frame);
  return opresult127;
}
Object meth_parser__apply131(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool133 = alloc_Boolean(0);
// compiled identifier node returning bool133 (depth = 8)
  int op_slot_right_132 = gc_frame_newslot(bool133);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_132 = gc_frame_newslot(*var_nextTok);
  params[0] = bool133;
  partcv[0] = 1;
  Object opresult135 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult135 (depth = 7)
  gc_frame_end(frame);
  return opresult135;
}
Object meth_parser__apply117(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe118 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block119 = alloc_Block(NULL, NULL, "parser", 79);
  gc_frame_newslot(block119);
// method _apply
  block_savedest(block119);
  Object closure120 = createclosure(3, "_apply");
  setclosureframe(closure120, stackframe);
  addtoclosure(closure120, var_lastToken);
  addtoclosure(closure120, var_n);
  addtoclosure(closure120, selfslot);
  struct UserObject *uo120 = (struct UserObject*)block119;
  uo120->data[0] = (Object)closure120;
  Method *meth_meth_parser__apply120 = addmethod2pos(block119, "_apply", &meth_parser__apply120, 0);
  int argcv_meth_parser__apply120[] = {0};
  meth_meth_parser__apply120->type = alloc_MethodType(1, argcv_meth_parser__apply120);
  meth_meth_parser__apply120->definitionModule = modulename;
  meth_meth_parser__apply120->definitionLine = 63;
// compiled block node returning block119 (depth = 5)
  gc_frame_newslot(block119);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe129 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block130 = alloc_Block(NULL, NULL, "parser", 79);
  gc_frame_newslot(block130);
// method _apply
  block_savedest(block130);
  Object closure131 = createclosure(2, "_apply");
  setclosureframe(closure131, stackframe);
  addtoclosure(closure131, var_nextTok);
  addtoclosure(closure131, selfslot);
  struct UserObject *uo131 = (struct UserObject*)block130;
  uo131->data[0] = (Object)closure131;
  Method *meth_meth_parser__apply131 = addmethod2pos(block130, "_apply", &meth_parser__apply131, 0);
  int argcv_meth_parser__apply131[] = {0};
  meth_meth_parser__apply131->type = alloc_MethodType(1, argcv_meth_parser__apply131);
  meth_meth_parser__apply131->definitionModule = modulename;
  meth_meth_parser__apply131->definitionLine = 79;
// compiled block node returning block130 (depth = 6)
  gc_frame_newslot(block130);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool138 = alloc_Boolean(0);
// compiled identifier node returning bool138 (depth = 7)
  int op_slot_right_137 = gc_frame_newslot(bool138);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  int op_slot_left_137 = gc_frame_newslot(*var_n);
  params[0] = bool138;
  partcv[0] = 1;
  Object opresult140 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult140 (depth = 6)
  params[0] = block130;
  partcv[0] = 1;
  Object call141 = callmethod(opresult140, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe129);
// compiled call node returning call141 (depth = 5)
  params[0] = block119;
  partcv[0] = 1;
  Object call142 = callmethod(call141, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe118);
// compiled call node returning call142 (depth = 4)
  gc_frame_end(frame);
  return call142;
}
Object meth_parser__apply145(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe147 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokenMatcher (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call148 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe147);
// compiled call node returning call148 (depth = 5)
  Object if146 = done;
  if (istrue(call148)) {
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if146 = done;
  } else {
  }
// compiled if node returning if146 (depth = 4)
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call151 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe150);
// compiled call node returning call151 (depth = 6)
// compiled member node returning call151 (depth = 5)
  *var_n = call151;
  if (call151 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextToken110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findNextToken");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findNextToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe112 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tokenMatcher (depth = 4)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call113 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe112);
// compiled call node returning call113 (depth = 3)
  Object if111 = done;
  if (istrue(call113)) {
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if111 = undefined;
  } else {
  }
// compiled if node returning if111 (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool114 = alloc_Boolean(0);
// compiled identifier node returning bool114 (depth = 3)
  *var_nextTok = bool114;
  if (bool114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe115 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block116 = alloc_Block(NULL, NULL, "parser", 79);
  gc_frame_newslot(block116);
// method _apply
  block_savedest(block116);
  Object closure117 = createclosure(4, "_apply");
  setclosureframe(closure117, stackframe);
  addtoclosure(closure117, var_lastToken);
  addtoclosure(closure117, var_n);
  addtoclosure(closure117, var_nextTok);
  addtoclosure(closure117, selfslot);
  struct UserObject *uo117 = (struct UserObject*)block116;
  uo117->data[0] = (Object)closure117;
  Method *meth_meth_parser__apply117 = addmethod2pos(block116, "_apply", &meth_parser__apply117, 0);
  int argcv_meth_parser__apply117[] = {0};
  meth_meth_parser__apply117->type = alloc_MethodType(1, argcv_meth_parser__apply117);
  meth_meth_parser__apply117->definitionModule = modulename;
  meth_meth_parser__apply117->definitionLine = 63;
// compiled block node returning block116 (depth = 3)
  gc_frame_newslot(block116);
// starting to compile block node (depth = 3)
  Object block144 = alloc_Block(NULL, NULL, "parser", 79);
  gc_frame_newslot(block144);
// method _apply
  block_savedest(block144);
  Object closure145 = createclosure(4, "_apply");
  setclosureframe(closure145, stackframe);
  addtoclosure(closure145, var_n);
  addtoclosure(closure145, var_tokenMatcher);
  addtoclosure(closure145, var_nextTok);
  addtoclosure(closure145, selfslot);
  struct UserObject *uo145 = (struct UserObject*)block144;
  uo145->data[0] = (Object)closure145;
  Method *meth_meth_parser__apply145 = addmethod2pos(block144, "_apply", &meth_parser__apply145, 0);
  int argcv_meth_parser__apply145[] = {0};
  meth_meth_parser__apply145->type = alloc_MethodType(1, argcv_meth_parser__apply145);
  meth_meth_parser__apply145->definitionModule = modulename;
  meth_meth_parser__apply145->definitionLine = 79;
// compiled block node returning block144 (depth = 3)
  gc_frame_newslot(block144);
// call case 5: prelude request
  params[0] = block116;
  params[1] = block144;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call154 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe115);
// compiled call node returning call154 (depth = 2)
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply189(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool191 = alloc_Boolean(0);
// compiled identifier node returning bool191 (depth = 7)
  int op_slot_right_190 = gc_frame_newslot(bool191);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_190 = gc_frame_newslot(*var_nextTok);
  params[0] = bool191;
  partcv[0] = 1;
  Object opresult193 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult193 (depth = 6)
  gc_frame_end(frame);
  return opresult193;
}
Object meth_parser__apply186(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe187 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block188 = alloc_Block(NULL, NULL, "parser", 94);
  gc_frame_newslot(block188);
// method _apply
  block_savedest(block188);
  Object closure189 = createclosure(2, "_apply");
  setclosureframe(closure189, stackframe);
  addtoclosure(closure189, var_nextTok);
  addtoclosure(closure189, selfslot);
  struct UserObject *uo189 = (struct UserObject*)block188;
  uo189->data[0] = (Object)closure189;
  Method *meth_meth_parser__apply189 = addmethod2pos(block188, "_apply", &meth_parser__apply189, 0);
  int argcv_meth_parser__apply189[] = {0};
  meth_meth_parser__apply189->type = alloc_MethodType(1, argcv_meth_parser__apply189);
  meth_meth_parser__apply189->definitionModule = modulename;
  meth_meth_parser__apply189->definitionLine = 89;
// compiled block node returning block188 (depth = 5)
  gc_frame_newslot(block188);
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool196 = alloc_Boolean(0);
// compiled identifier node returning bool196 (depth = 6)
  int op_slot_right_195 = gc_frame_newslot(bool196);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_195 = gc_frame_newslot(*var_n);
  params[0] = bool196;
  partcv[0] = 1;
  Object opresult198 = callmethod(*var_n, "!=", 1, partcv, params);
// compiled op node returning opresult198 (depth = 5)
  params[0] = block188;
  partcv[0] = 1;
  Object call199 = callmethod(opresult198, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe187);
// compiled call node returning call199 (depth = 4)
  gc_frame_end(frame);
  return call199;
}
Object meth_parser__apply202(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit206 == NULL) {
    strlit206 = alloc_String("eof");
    gc_root(strlit206);
  }
// compiled string node returning strlit206 (depth = 7)
  int op_slot_right_205 = gc_frame_newslot(strlit206);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call209 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe208);
// compiled call node returning call209 (depth = 8)
// compiled member node returning call209 (depth = 7)
  int op_slot_left_205 = gc_frame_newslot(call209);
  params[0] = strlit206;
  partcv[0] = 1;
  Object opresult210 = callmethod(call209, "==", 1, partcv, params);
// compiled op node returning opresult210 (depth = 6)
  int op_slot_right_204 = gc_frame_newslot(opresult210);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe214 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call215 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe214);
// compiled call node returning call215 (depth = 9)
// compiled member node returning call215 (depth = 8)
  int op_slot_right_213 = gc_frame_newslot(call215);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe217 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call218 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe217);
// compiled call node returning call218 (depth = 9)
// compiled member node returning call218 (depth = 8)
  int op_slot_left_213 = gc_frame_newslot(call218);
  params[0] = call215;
  partcv[0] = 1;
  Object opresult219 = callmethod(call218, "<=", 1, partcv, params);
// compiled op node returning opresult219 (depth = 7)
  int op_slot_right_212 = gc_frame_newslot(opresult219);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call223 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe222);
// compiled call node returning call223 (depth = 9)
// compiled member node returning call223 (depth = 8)
  int op_slot_right_221 = gc_frame_newslot(call223);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call226 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe225);
// compiled call node returning call226 (depth = 9)
// compiled member node returning call226 (depth = 8)
  int op_slot_left_221 = gc_frame_newslot(call226);
  params[0] = call223;
  partcv[0] = 1;
  Object opresult227 = callmethod(call226, ">", 1, partcv, params);
// compiled op node returning opresult227 (depth = 7)
  int op_slot_left_212 = gc_frame_newslot(opresult227);
  params[0] = opresult219;
  partcv[0] = 1;
  Object opresult228 = callmethod(opresult227, "&&", 1, partcv, params);
// compiled op node returning opresult228 (depth = 6)
  int op_slot_left_204 = gc_frame_newslot(opresult228);
  params[0] = opresult210;
  partcv[0] = 1;
  Object opresult229 = callmethod(opresult228, "||", 1, partcv, params);
// compiled op node returning opresult229 (depth = 5)
  Object if203 = done;
  if (istrue(opresult229)) {
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if203 = done;
  } else {
  }
// compiled if node returning if203 (depth = 4)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call232 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe231);
// compiled call node returning call232 (depth = 6)
// compiled member node returning call232 (depth = 5)
  *var_n = call232;
  if (call232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextTokenIndentedAt155(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method findNextTokenIndentedAt");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextTokenIndentedAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for findNextTokenIndentedAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit159 == NULL) {
    strlit159 = alloc_String("eof");
    gc_root(strlit159);
  }
// compiled string node returning strlit159 (depth = 5)
  int op_slot_right_158 = gc_frame_newslot(strlit159);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call162 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe161);
// compiled call node returning call162 (depth = 6)
// compiled member node returning call162 (depth = 5)
  int op_slot_left_158 = gc_frame_newslot(call162);
  params[0] = strlit159;
  partcv[0] = 1;
  Object opresult163 = callmethod(call162, "==", 1, partcv, params);
// compiled op node returning opresult163 (depth = 4)
  int op_slot_right_157 = gc_frame_newslot(opresult163);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call168 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe167);
// compiled call node returning call168 (depth = 7)
// compiled member node returning call168 (depth = 6)
  int op_slot_right_166 = gc_frame_newslot(call168);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe170 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call171 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe170);
// compiled call node returning call171 (depth = 7)
// compiled member node returning call171 (depth = 6)
  int op_slot_left_166 = gc_frame_newslot(call171);
  params[0] = call168;
  partcv[0] = 1;
  Object opresult172 = callmethod(call171, "<=", 1, partcv, params);
// compiled op node returning opresult172 (depth = 5)
  int op_slot_right_165 = gc_frame_newslot(opresult172);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe175 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  partcv[0] = 0;
  Object call176 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe175);
// compiled call node returning call176 (depth = 7)
// compiled member node returning call176 (depth = 6)
  int op_slot_right_174 = gc_frame_newslot(call176);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call179 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe178);
// compiled call node returning call179 (depth = 7)
// compiled member node returning call179 (depth = 6)
  int op_slot_left_174 = gc_frame_newslot(call179);
  params[0] = call176;
  partcv[0] = 1;
  Object opresult180 = callmethod(call179, ">", 1, partcv, params);
// compiled op node returning opresult180 (depth = 5)
  int op_slot_left_165 = gc_frame_newslot(opresult180);
  params[0] = opresult172;
  partcv[0] = 1;
  Object opresult181 = callmethod(opresult180, "&&", 1, partcv, params);
// compiled op node returning opresult181 (depth = 4)
  int op_slot_left_157 = gc_frame_newslot(opresult181);
  params[0] = opresult163;
  partcv[0] = 1;
  Object opresult182 = callmethod(opresult181, "||", 1, partcv, params);
// compiled op node returning opresult182 (depth = 3)
  Object if156 = done;
  if (istrue(opresult182)) {
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  return *var_sym;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if156 = undefined;
  } else {
  }
// compiled if node returning if156 (depth = 2)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool183 = alloc_Boolean(0);
// compiled identifier node returning bool183 (depth = 3)
  *var_nextTok = bool183;
  if (bool183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe184 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block185 = alloc_Block(NULL, NULL, "parser", 94);
  gc_frame_newslot(block185);
// method _apply
  block_savedest(block185);
  Object closure186 = createclosure(3, "_apply");
  setclosureframe(closure186, stackframe);
  addtoclosure(closure186, var_nextTok);
  addtoclosure(closure186, var_n);
  addtoclosure(closure186, selfslot);
  struct UserObject *uo186 = (struct UserObject*)block185;
  uo186->data[0] = (Object)closure186;
  Method *meth_meth_parser__apply186 = addmethod2pos(block185, "_apply", &meth_parser__apply186, 0);
  int argcv_meth_parser__apply186[] = {0};
  meth_meth_parser__apply186->type = alloc_MethodType(1, argcv_meth_parser__apply186);
  meth_meth_parser__apply186->definitionModule = modulename;
  meth_meth_parser__apply186->definitionLine = 89;
// compiled block node returning block185 (depth = 3)
  gc_frame_newslot(block185);
// starting to compile block node (depth = 3)
  Object block201 = alloc_Block(NULL, NULL, "parser", 94);
  gc_frame_newslot(block201);
// method _apply
  block_savedest(block201);
  Object closure202 = createclosure(5, "_apply");
  setclosureframe(closure202, stackframe);
  addtoclosure(closure202, var_sym);
  addtoclosure(closure202, var_tok);
  addtoclosure(closure202, var_n);
  addtoclosure(closure202, var_nextTok);
  addtoclosure(closure202, selfslot);
  struct UserObject *uo202 = (struct UserObject*)block201;
  uo202->data[0] = (Object)closure202;
  Method *meth_meth_parser__apply202 = addmethod2pos(block201, "_apply", &meth_parser__apply202, 0);
  int argcv_meth_parser__apply202[] = {0};
  meth_meth_parser__apply202->type = alloc_MethodType(1, argcv_meth_parser__apply202);
  meth_meth_parser__apply202->definitionModule = modulename;
  meth_meth_parser__apply202->definitionLine = 89;
// compiled block node returning block201 (depth = 3)
  gc_frame_newslot(block201);
// call case 5: prelude request
  params[0] = block185;
  params[1] = block201;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call235 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe184);
// compiled call node returning call235 (depth = 2)
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_nextTok (depth = 2)
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply248(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit250 == NULL) {
    strlit250 = alloc_String("eof");
    gc_root(strlit250);
  }
// compiled string node returning strlit250 (depth = 5)
  int op_slot_right_249 = gc_frame_newslot(strlit250);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call253 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe252);
// compiled call node returning call253 (depth = 6)
// compiled member node returning call253 (depth = 5)
  int op_slot_left_249 = gc_frame_newslot(call253);
  params[0] = strlit250;
  partcv[0] = 1;
  Object opresult254 = callmethod(call253, "!=", 1, partcv, params);
// compiled op node returning opresult254 (depth = 4)
  gc_frame_end(frame);
  return opresult254;
}
Object meth_parser__apply257(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe259 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe260 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_validToken (depth = 8)
  partcv[0] = 0;
  Object call261 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe260);
// compiled call node returning call261 (depth = 7)
// compiled member node returning call261 (depth = 6)
  gc_frame_newslot(call261);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validFollowTokens (depth = 6)
  params[0] = call261;
  partcv[0] = 1;
  Object call262 = callmethod(*var_validFollowTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe259);
// compiled call node returning call262 (depth = 5)
  Object if258 = done;
  if (istrue(call262)) {
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if258 = undefined;
  } else {
  }
// compiled if node returning if258 (depth = 4)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe264 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe265 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe266 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_validToken (depth = 9)
  partcv[0] = 0;
  Object call267 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe266);
// compiled call node returning call267 (depth = 8)
// compiled member node returning call267 (depth = 7)
  gc_frame_newslot(call267);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_invalidTokens (depth = 7)
  params[0] = call267;
  partcv[0] = 1;
  Object call268 = callmethod(*var_invalidTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe265);
// compiled call node returning call268 (depth = 6)
  partcv[0] = 0;
  Object call269 = callmethod(call268, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe264);
// compiled call node returning call269 (depth = 5)
  Object if263 = done;
  if (istrue(call269)) {
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_validToken (depth = 6)
  block_return(realself, *var_validToken);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if263 = undefined;
  } else {
  }
// compiled if node returning if263 (depth = 4)
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe270 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_validToken (depth = 7)
  partcv[0] = 0;
  Object call271 = callmethod(*var_validToken, "next",
    1, partcv, params);
  gc_frame_end(callframe270);
// compiled call node returning call271 (depth = 6)
// compiled member node returning call271 (depth = 5)
  *var_validToken = call271;
  if (call271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextValidToken236(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextValidToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_validFollowTokens = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_validFollowTokens, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = var_init_validFollowTokens;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile array node (depth = 3)
  Object array237 = alloc_BuiltinList();
  gc_pause();
// starting to compile string node (depth = 4)
  if (strlit238 == NULL) {
    strlit238 = alloc_String("dot");
    gc_root(strlit238);
  }
// compiled string node returning strlit238 (depth = 4)
  params[0] = strlit238;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit239 == NULL) {
    strlit239 = alloc_String("comma");
    gc_root(strlit239);
  }
// compiled string node returning strlit239 (depth = 4)
  params[0] = strlit239;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit240 == NULL) {
    strlit240 = alloc_String("colon");
    gc_root(strlit240);
  }
// compiled string node returning strlit240 (depth = 4)
  params[0] = strlit240;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit241 == NULL) {
    strlit241 = alloc_String("rparen");
    gc_root(strlit241);
  }
// compiled string node returning strlit241 (depth = 4)
  params[0] = strlit241;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit242 == NULL) {
    strlit242 = alloc_String("rbrace");
    gc_root(strlit242);
  }
// compiled string node returning strlit242 (depth = 4)
  params[0] = strlit242;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit243 == NULL) {
    strlit243 = alloc_String("rsquare");
    gc_root(strlit243);
  }
// compiled string node returning strlit243 (depth = 4)
  params[0] = strlit243;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit244 == NULL) {
    strlit244 = alloc_String("arrow");
    gc_root(strlit244);
  }
// compiled string node returning strlit244 (depth = 4)
  params[0] = strlit244;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
// starting to compile string node (depth = 4)
  if (strlit245 == NULL) {
    strlit245 = alloc_String("bind");
    gc_root(strlit245);
  }
// compiled string node returning strlit245 (depth = 4)
  params[0] = strlit245;
  partcv[0] = 1;
  callmethod(array237, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array237 (depth = 3)
  *var_invalidTokens = array237;
  if (array237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe246 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block247 = alloc_Block(NULL, NULL, "parser", 107);
  gc_frame_newslot(block247);
// method _apply
  block_savedest(block247);
  Object closure248 = createclosure(2, "_apply");
  setclosureframe(closure248, stackframe);
  addtoclosure(closure248, var_validToken);
  addtoclosure(closure248, selfslot);
  struct UserObject *uo248 = (struct UserObject*)block247;
  uo248->data[0] = (Object)closure248;
  Method *meth_meth_parser__apply248 = addmethod2pos(block247, "_apply", &meth_parser__apply248, 0);
  int argcv_meth_parser__apply248[] = {0};
  meth_meth_parser__apply248->type = alloc_MethodType(1, argcv_meth_parser__apply248);
  meth_meth_parser__apply248->definitionModule = modulename;
  meth_meth_parser__apply248->definitionLine = 98;
// compiled block node returning block247 (depth = 3)
  gc_frame_newslot(block247);
// starting to compile block node (depth = 3)
  Object block256 = alloc_Block(NULL, NULL, "parser", 107);
  gc_frame_newslot(block256);
// method _apply
  block_savedest(block256);
  Object closure257 = createclosure(4, "_apply");
  setclosureframe(closure257, stackframe);
  addtoclosure(closure257, var_validToken);
  addtoclosure(closure257, var_validFollowTokens);
  addtoclosure(closure257, var_invalidTokens);
  addtoclosure(closure257, selfslot);
  struct UserObject *uo257 = (struct UserObject*)block256;
  uo257->data[0] = (Object)closure257;
  Method *meth_meth_parser__apply257 = addmethod2pos(block256, "_apply", &meth_parser__apply257, 0);
  int argcv_meth_parser__apply257[] = {0};
  meth_meth_parser__apply257->type = alloc_MethodType(1, argcv_meth_parser__apply257);
  meth_meth_parser__apply257->definitionModule = modulename;
  meth_meth_parser__apply257->definitionLine = 107;
// compiled block node returning block256 (depth = 3)
  gc_frame_newslot(block256);
// call case 5: prelude request
  params[0] = block247;
  params[1] = block256;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call274 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe246);
// compiled call node returning call274 (depth = 2)
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_validToken (depth = 3)
  return *var_validToken;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply286(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe289 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call290 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe289);
// compiled call node returning call290 (depth = 7)
// compiled member node returning call290 (depth = 6)
  int op_slot_right_288 = gc_frame_newslot(call290);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe292 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call293 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe292);
// compiled call node returning call293 (depth = 7)
// compiled member node returning call293 (depth = 6)
  int op_slot_left_288 = gc_frame_newslot(call293);
  params[0] = call290;
  partcv[0] = 1;
  Object opresult294 = callmethod(call293, "==", 1, partcv, params);
// compiled op node returning opresult294 (depth = 5)
  int op_slot_right_287 = gc_frame_newslot(opresult294);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit297 == NULL) {
    strlit297 = alloc_String("eof");
    gc_root(strlit297);
  }
// compiled string node returning strlit297 (depth = 6)
  int op_slot_right_296 = gc_frame_newslot(strlit297);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call300 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe299);
// compiled call node returning call300 (depth = 7)
// compiled member node returning call300 (depth = 6)
  int op_slot_left_296 = gc_frame_newslot(call300);
  params[0] = strlit297;
  partcv[0] = 1;
  Object opresult301 = callmethod(call300, "!=", 1, partcv, params);
// compiled op node returning opresult301 (depth = 5)
  int op_slot_left_287 = gc_frame_newslot(opresult301);
  params[0] = opresult294;
  partcv[0] = 1;
  Object opresult302 = callmethod(opresult301, "&&", 1, partcv, params);
// compiled op node returning opresult302 (depth = 4)
  gc_frame_end(frame);
  return opresult302;
}
Object meth_parser__apply305(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit308 == NULL) {
    strlit308 = alloc_String("lbrace");
    gc_root(strlit308);
  }
// compiled string node returning strlit308 (depth = 6)
  int op_slot_right_307 = gc_frame_newslot(strlit308);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call311 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe310);
// compiled call node returning call311 (depth = 7)
// compiled member node returning call311 (depth = 6)
  int op_slot_left_307 = gc_frame_newslot(call311);
  params[0] = strlit308;
  partcv[0] = 1;
  Object opresult312 = callmethod(call311, "==", 1, partcv, params);
// compiled op node returning opresult312 (depth = 5)
  Object if306 = done;
  if (istrue(opresult312)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num314 = alloc_Float64(1);
// compiled num node returning num314 (depth = 7)
  int op_slot_right_313 = gc_frame_newslot(num314);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_313 = gc_frame_newslot(*var_numOpening);
  params[0] = num314;
  partcv[0] = 1;
  Object sum316 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum316 (depth = 6)
  *var_numOpening = sum316;
  if (sum316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if306 = done;
  } else {
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit320 == NULL) {
    strlit320 = alloc_String("rbrace");
    gc_root(strlit320);
  }
// compiled string node returning strlit320 (depth = 7)
  int op_slot_right_319 = gc_frame_newslot(strlit320);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe322 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call323 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe322);
// compiled call node returning call323 (depth = 8)
// compiled member node returning call323 (depth = 7)
  int op_slot_left_319 = gc_frame_newslot(call323);
  params[0] = strlit320;
  partcv[0] = 1;
  Object opresult324 = callmethod(call323, "==", 1, partcv, params);
// compiled op node returning opresult324 (depth = 6)
  Object if318 = done;
  if (istrue(opresult324)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num326 = alloc_Float64(1);
// compiled num node returning num326 (depth = 8)
  int op_slot_right_325 = gc_frame_newslot(num326);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_325 = gc_frame_newslot(*var_numClosing);
  params[0] = num326;
  partcv[0] = 1;
  Object sum328 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum328 (depth = 7)
  *var_numClosing = sum328;
  if (sum328 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if318 = done;
  } else {
  }
// compiled if node returning if318 (depth = 5)
    gc_frame_newslot(if318);
    if306 = if318;
  }
// compiled if node returning if306 (depth = 4)
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe330 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call331 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe330);
// compiled call node returning call331 (depth = 6)
// compiled member node returning call331 (depth = 5)
  *var_n = call331;
  if (call331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply337(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe340 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call341 = callmethod(*var_token, "indent",
    1, partcv, params);
  gc_frame_end(callframe340);
// compiled call node returning call341 (depth = 7)
// compiled member node returning call341 (depth = 6)
  int op_slot_right_339 = gc_frame_newslot(call341);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call344 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe343);
// compiled call node returning call344 (depth = 7)
// compiled member node returning call344 (depth = 6)
  int op_slot_left_339 = gc_frame_newslot(call344);
  params[0] = call341;
  partcv[0] = 1;
  Object opresult345 = callmethod(call344, ">", 1, partcv, params);
// compiled op node returning opresult345 (depth = 5)
  int op_slot_right_338 = gc_frame_newslot(opresult345);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("eof");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 6)
  int op_slot_right_347 = gc_frame_newslot(strlit348);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe350 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call351 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe350);
// compiled call node returning call351 (depth = 7)
// compiled member node returning call351 (depth = 6)
  int op_slot_left_347 = gc_frame_newslot(call351);
  params[0] = strlit348;
  partcv[0] = 1;
  Object opresult352 = callmethod(call351, "!=", 1, partcv, params);
// compiled op node returning opresult352 (depth = 5)
  int op_slot_left_338 = gc_frame_newslot(opresult352);
  params[0] = opresult345;
  partcv[0] = 1;
  Object opresult353 = callmethod(opresult352, "&&", 1, partcv, params);
// compiled op node returning opresult353 (depth = 4)
  gc_frame_end(frame);
  return opresult353;
}
Object meth_parser__apply356(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit359 == NULL) {
    strlit359 = alloc_String("lbrace");
    gc_root(strlit359);
  }
// compiled string node returning strlit359 (depth = 6)
  int op_slot_right_358 = gc_frame_newslot(strlit359);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe361 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call362 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe361);
// compiled call node returning call362 (depth = 7)
// compiled member node returning call362 (depth = 6)
  int op_slot_left_358 = gc_frame_newslot(call362);
  params[0] = strlit359;
  partcv[0] = 1;
  Object opresult363 = callmethod(call362, "==", 1, partcv, params);
// compiled op node returning opresult363 (depth = 5)
  Object if357 = done;
  if (istrue(opresult363)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num365 = alloc_Float64(1);
// compiled num node returning num365 (depth = 7)
  int op_slot_right_364 = gc_frame_newslot(num365);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_numOpening (depth = 7)
  int op_slot_left_364 = gc_frame_newslot(*var_numOpening);
  params[0] = num365;
  partcv[0] = 1;
  Object sum367 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compiled op node returning sum367 (depth = 6)
  *var_numOpening = sum367;
  if (sum367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if357 = done;
  } else {
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit371 == NULL) {
    strlit371 = alloc_String("rbrace");
    gc_root(strlit371);
  }
// compiled string node returning strlit371 (depth = 7)
  int op_slot_right_370 = gc_frame_newslot(strlit371);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe373 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_n (depth = 9)
  partcv[0] = 0;
  Object call374 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe373);
// compiled call node returning call374 (depth = 8)
// compiled member node returning call374 (depth = 7)
  int op_slot_left_370 = gc_frame_newslot(call374);
  params[0] = strlit371;
  partcv[0] = 1;
  Object opresult375 = callmethod(call374, "==", 1, partcv, params);
// compiled op node returning opresult375 (depth = 6)
  Object if369 = done;
  if (istrue(opresult375)) {
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num377 = alloc_Float64(1);
// compiled num node returning num377 (depth = 8)
  int op_slot_right_376 = gc_frame_newslot(num377);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_numClosing (depth = 8)
  int op_slot_left_376 = gc_frame_newslot(*var_numClosing);
  params[0] = num377;
  partcv[0] = 1;
  Object sum379 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compiled op node returning sum379 (depth = 7)
  *var_numClosing = sum379;
  if (sum379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if369 = done;
  } else {
  }
// compiled if node returning if369 (depth = 5)
    gc_frame_newslot(if369);
    if357 = if369;
  }
// compiled if node returning if357 (depth = 4)
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_n (depth = 7)
  partcv[0] = 0;
  Object call382 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe381);
// compiled call node returning call382 (depth = 6)
// compiled member node returning call382 (depth = 5)
  *var_n = call382;
  if (call382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findClosingBrace275(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method findClosingBrace");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findClosingBrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for findClosingBrace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// Begin line 129
  setline(129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inserted (depth = 4)
  Object if276 = done;
struct StackFrameObject *iftmpstackframe276 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe276);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num277 = alloc_Float64(1);
// compiled num node returning num277 (depth = 4)
    gc_frame_newslot(num277);
    if276 = num277;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe276);
  gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 4)
  Object num278 = alloc_Float64(0);
// compiled num node returning num278 (depth = 4)
    gc_frame_newslot(num278);
    if276 = num278;
  }
stackframe = iftmpstackframe276;
// compiled if node returning if276 (depth = 3)
  *var_numOpening = if276;
  if (if276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num279 = alloc_Float64(0);
// compiled num node returning num279 (depth = 3)
  *var_numClosing = num279;
  if (num279 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject280 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj280 = alloc_userobj2(4,4, objclass280);
  gc_frame_newslot(obj280);
// OBJECT OUTER DEC outer
  adddatum2(obj280, self, 0);
  addmethodreal(obj280,"outer", &reader_parser_outer_281);
  Object oldself280 = self;
  struct StackFrameObject *oldstackframe280 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe280);
  gc_frame_newslot((Object)stackframe);
  self = obj280;
  Object *oldselfslot280 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter280 = (*(struct UserObject *)self).data[0], lowerouter280 = thisouter280;
  if (inheritingObject280) {
    struct UserObject *inho280 = (struct UserObject *)inheritingObject280;
    while (inho280->super != GraceDefaultObject) inho280 = (struct UserObject *)inho280->super;
    inho280->super = obj280;
    self = inheritingObject280;
    *selfslot = self;
    lowerouter280 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter280;
  }
if (objclass280 == NULL) {
  Method *reader282 = addmethodrealflags(obj280, "found",&reader_parser_found_282, 0);
  Method *writer282 = addmethodrealflags(obj280, "found:=",&writer_parser_found_282, 0);
  reader282->definitionModule = modulename;
  writer282->definitionModule = modulename;
  reader282->definitionLine = 133;
  writer282->definitionLine = 133;
}
obj280->flags |= OFLAG_MUTABLE;
adddatum2(obj280, alloc_Undefined(), 1);
if (objclass280 == NULL) {
  Method *reader283 = addmethodrealflags(obj280, "tok",&reader_parser_tok_283, 0);
  Method *writer283 = addmethodrealflags(obj280, "tok:=",&writer_parser_tok_283, 0);
  reader283->definitionModule = modulename;
  writer283->definitionModule = modulename;
  reader283->definitionLine = 134;
  writer283->definitionLine = 134;
}
obj280->flags |= OFLAG_MUTABLE;
adddatum2(obj280, alloc_Undefined(), 2);
  sourceObject = obj280;
  adddatum2(obj280, undefined, 1);
  sourceObject = obj280;
  adddatum2(obj280, undefined, 2);
objclass280 = obj280->class;
  objclass280->definitionModule = modulename;
  objclass280->definitionLine = 131;
  (*(struct UserObject *)self).data[0] = lowerouter280;
  self = oldself280;
  selfslot = oldselfslot280;
  stackframe = oldstackframe280;
// compiled object node returning obj280 (depth = 3)
  *var_result = obj280;
  if (obj280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe284 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block285 = alloc_Block(NULL, NULL, "parser", 136);
  gc_frame_newslot(block285);
// method _apply
  block_savedest(block285);
  Object closure286 = createclosure(3, "_apply");
  setclosureframe(closure286, stackframe);
  addtoclosure(closure286, var_token);
  addtoclosure(closure286, var_n);
  addtoclosure(closure286, selfslot);
  struct UserObject *uo286 = (struct UserObject*)block285;
  uo286->data[0] = (Object)closure286;
  Method *meth_meth_parser__apply286 = addmethod2pos(block285, "_apply", &meth_parser__apply286, 0);
  int argcv_meth_parser__apply286[] = {0};
  meth_meth_parser__apply286->type = alloc_MethodType(1, argcv_meth_parser__apply286);
  meth_meth_parser__apply286->definitionModule = modulename;
  meth_meth_parser__apply286->definitionLine = 117;
// compiled block node returning block285 (depth = 3)
  gc_frame_newslot(block285);
// starting to compile block node (depth = 3)
  Object block304 = alloc_Block(NULL, NULL, "parser", 136);
  gc_frame_newslot(block304);
// method _apply
  block_savedest(block304);
  Object closure305 = createclosure(4, "_apply");
  setclosureframe(closure305, stackframe);
  addtoclosure(closure305, var_n);
  addtoclosure(closure305, var_numOpening);
  addtoclosure(closure305, var_numClosing);
  addtoclosure(closure305, selfslot);
  struct UserObject *uo305 = (struct UserObject*)block304;
  uo305->data[0] = (Object)closure305;
  Method *meth_meth_parser__apply305 = addmethod2pos(block304, "_apply", &meth_parser__apply305, 0);
  int argcv_meth_parser__apply305[] = {0};
  meth_meth_parser__apply305->type = alloc_MethodType(1, argcv_meth_parser__apply305);
  meth_meth_parser__apply305->definitionModule = modulename;
  meth_meth_parser__apply305->definitionLine = 136;
// compiled block node returning block304 (depth = 3)
  gc_frame_newslot(block304);
// call case 5: prelude request
  params[0] = block285;
  params[1] = block304;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call334 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe284);
// compiled call node returning call334 (depth = 2)
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe335 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block336 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block336);
// method _apply
  block_savedest(block336);
  Object closure337 = createclosure(3, "_apply");
  setclosureframe(closure337, stackframe);
  addtoclosure(closure337, var_token);
  addtoclosure(closure337, var_n);
  addtoclosure(closure337, selfslot);
  struct UserObject *uo337 = (struct UserObject*)block336;
  uo337->data[0] = (Object)closure337;
  Method *meth_meth_parser__apply337 = addmethod2pos(block336, "_apply", &meth_parser__apply337, 0);
  int argcv_meth_parser__apply337[] = {0};
  meth_meth_parser__apply337->type = alloc_MethodType(1, argcv_meth_parser__apply337);
  meth_meth_parser__apply337->definitionModule = modulename;
  meth_meth_parser__apply337->definitionLine = 139;
// compiled block node returning block336 (depth = 3)
  gc_frame_newslot(block336);
// starting to compile block node (depth = 3)
  Object block355 = alloc_Block(NULL, NULL, "parser", 142);
  gc_frame_newslot(block355);
// method _apply
  block_savedest(block355);
  Object closure356 = createclosure(4, "_apply");
  setclosureframe(closure356, stackframe);
  addtoclosure(closure356, var_n);
  addtoclosure(closure356, var_numOpening);
  addtoclosure(closure356, var_numClosing);
  addtoclosure(closure356, selfslot);
  struct UserObject *uo356 = (struct UserObject*)block355;
  uo356->data[0] = (Object)closure356;
  Method *meth_meth_parser__apply356 = addmethod2pos(block355, "_apply", &meth_parser__apply356, 0);
  int argcv_meth_parser__apply356[] = {0};
  meth_meth_parser__apply356->type = alloc_MethodType(1, argcv_meth_parser__apply356);
  meth_meth_parser__apply356->definitionModule = modulename;
  meth_meth_parser__apply356->definitionLine = 142;
// compiled block node returning block355 (depth = 3)
  gc_frame_newslot(block355);
// call case 5: prelude request
  params[0] = block336;
  params[1] = block355;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call385 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe335);
// compiled call node returning call385 (depth = 2)
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit388 == NULL) {
    strlit388 = alloc_String("rbrace");
    gc_root(strlit388);
  }
// compiled string node returning strlit388 (depth = 4)
  int op_slot_right_387 = gc_frame_newslot(strlit388);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe390 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  partcv[0] = 0;
  Object call391 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe390);
// compiled call node returning call391 (depth = 5)
// compiled member node returning call391 (depth = 4)
  int op_slot_left_387 = gc_frame_newslot(call391);
  params[0] = strlit388;
  partcv[0] = 1;
  Object opresult392 = callmethod(call391, "==", 1, partcv, params);
// compiled op node returning opresult392 (depth = 3)
  Object if386 = done;
  if (istrue(opresult392)) {
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe393 = gc_frame_new();
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool394 = alloc_Boolean(1);
// compiled identifier node returning bool394 (depth = 5)
  gc_frame_newslot(bool394);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = bool394;
  partcv[0] = 1;
  Object call395 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe393);
// compiled call node returning call395 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 147
  setline(147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe396 = gc_frame_new();
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call397 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe396);
// compiled call node returning call397 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if386 = done;
  } else {
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numClosing (depth = 6)
  int op_slot_right_400 = gc_frame_newslot(*var_numClosing);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_numOpening (depth = 6)
  int op_slot_left_400 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult402 = callmethod(*var_numOpening, "==", 1, partcv, params);
// compiled op node returning opresult402 (depth = 5)
  int op_slot_right_399 = gc_frame_newslot(opresult402);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit405 == NULL) {
    strlit405 = alloc_String("rbrace");
    gc_root(strlit405);
  }
// compiled string node returning strlit405 (depth = 6)
  int op_slot_right_404 = gc_frame_newslot(strlit405);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe407 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call409 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe408);
// compiled call node returning call409 (depth = 9)
// compiled member node returning call409 (depth = 8)
  partcv[0] = 0;
  Object call410 = callmethod(call409, "kind",
    1, partcv, params);
  gc_frame_end(callframe407);
// compiled call node returning call410 (depth = 7)
// compiled member node returning call410 (depth = 6)
  int op_slot_left_404 = gc_frame_newslot(call410);
  params[0] = strlit405;
  partcv[0] = 1;
  Object opresult411 = callmethod(call410, "==", 1, partcv, params);
// compiled op node returning opresult411 (depth = 5)
  int op_slot_left_399 = gc_frame_newslot(opresult411);
  params[0] = opresult402;
  partcv[0] = 1;
  Object opresult412 = callmethod(opresult411, "&&", 1, partcv, params);
// compiled op node returning opresult412 (depth = 4)
  Object if398 = done;
  if (istrue(opresult412)) {
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe413 = gc_frame_new();
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool414 = alloc_Boolean(1);
// compiled identifier node returning bool414 (depth = 6)
  gc_frame_newslot(bool414);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = bool414;
  partcv[0] = 1;
  Object call415 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe413);
// compiled call node returning call415 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe416 = gc_frame_new();
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call418 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe417);
// compiled call node returning call418 (depth = 7)
// compiled member node returning call418 (depth = 6)
  gc_frame_newslot(call418);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = call418;
  partcv[0] = 1;
  Object call419 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe416);
// compiled call node returning call419 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if398 = done;
  } else {
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe420 = gc_frame_new();
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool421 = alloc_Boolean(0);
// compiled identifier node returning bool421 (depth = 6)
  gc_frame_newslot(bool421);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = bool421;
  partcv[0] = 1;
  Object call422 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe420);
// compiled call node returning call422 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe423 = gc_frame_new();
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call425 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe424);
// compiled call node returning call425 (depth = 7)
// compiled member node returning call425 (depth = 6)
  gc_frame_newslot(call425);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = call425;
  partcv[0] = 1;
  Object call426 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe423);
// compiled call node returning call426 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if398 = done;
  }
// compiled if node returning if398 (depth = 3)
    gc_frame_newslot(if398);
    if386 = if398;
  }
// compiled if node returning if386 (depth = 2)
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_accept427(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  int op_slot_right_428 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe430 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call431 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe430);
// compiled call node returning call431 (depth = 4)
// compiled member node returning call431 (depth = 3)
  int op_slot_left_428 = gc_frame_newslot(call431);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult432 = callmethod(call431, "==", 1, partcv, params);
// compiled op node returning opresult432 (depth = 2)
  gc_frame_end(frame);
  return opresult432;
}
Object meth_parser_acceptSameLine433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method acceptSameLine");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastline = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for acceptSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for acceptSameLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastIndent (depth = 5)
  int op_slot_right_436 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call439 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe438);
// compiled call node returning call439 (depth = 6)
// compiled member node returning call439 (depth = 5)
  int op_slot_left_436 = gc_frame_newslot(call439);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult440 = callmethod(call439, ">", 1, partcv, params);
// compiled op node returning opresult440 (depth = 4)
  int op_slot_right_435 = gc_frame_newslot(opresult440);
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe443 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call444 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe443);
// compiled call node returning call444 (depth = 6)
// compiled member node returning call444 (depth = 5)
  int op_slot_right_442 = gc_frame_newslot(call444);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastline (depth = 5)
  int op_slot_left_442 = gc_frame_newslot(*var_lastline);
  params[0] = call444;
  partcv[0] = 1;
  Object opresult446 = callmethod(*var_lastline, "==", 1, partcv, params);
// compiled op node returning opresult446 (depth = 4)
  int op_slot_left_435 = gc_frame_newslot(opresult446);
  params[0] = opresult440;
  partcv[0] = 1;
  Object opresult447 = callmethod(opresult446, "||", 1, partcv, params);
// compiled op node returning opresult447 (depth = 3)
  int op_slot_right_434 = gc_frame_newslot(opresult447);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_449 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe451 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call452 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe451);
// compiled call node returning call452 (depth = 5)
// compiled member node returning call452 (depth = 4)
  int op_slot_left_449 = gc_frame_newslot(call452);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult453 = callmethod(call452, "==", 1, partcv, params);
// compiled op node returning opresult453 (depth = 3)
  int op_slot_left_434 = gc_frame_newslot(opresult453);
  params[0] = opresult447;
  partcv[0] = 1;
  Object opresult454 = callmethod(opresult453, "&&", 1, partcv, params);
// compiled op node returning opresult454 (depth = 2)
  gc_frame_end(frame);
  return opresult454;
}
Object meth_parser_accept_40__41_onLineOf455(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()onLineOf");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()onLineOf");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call460 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe459);
// compiled call node returning call460 (depth = 6)
// compiled member node returning call460 (depth = 5)
  int op_slot_right_458 = gc_frame_newslot(call460);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call463 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe462);
// compiled call node returning call463 (depth = 6)
// compiled member node returning call463 (depth = 5)
  int op_slot_left_458 = gc_frame_newslot(call463);
  params[0] = call460;
  partcv[0] = 1;
  Object opresult464 = callmethod(call463, ">", 1, partcv, params);
// compiled op node returning opresult464 (depth = 4)
  int op_slot_right_457 = gc_frame_newslot(opresult464);
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe467 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call468 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe467);
// compiled call node returning call468 (depth = 6)
// compiled member node returning call468 (depth = 5)
  int op_slot_right_466 = gc_frame_newslot(call468);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  partcv[0] = 0;
  Object call471 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe470);
// compiled call node returning call471 (depth = 6)
// compiled member node returning call471 (depth = 5)
  int op_slot_left_466 = gc_frame_newslot(call471);
  params[0] = call468;
  partcv[0] = 1;
  Object opresult472 = callmethod(call471, "==", 1, partcv, params);
// compiled op node returning opresult472 (depth = 4)
  int op_slot_left_457 = gc_frame_newslot(opresult472);
  params[0] = opresult464;
  partcv[0] = 1;
  Object opresult473 = callmethod(opresult472, "||", 1, partcv, params);
// compiled op node returning opresult473 (depth = 3)
  int op_slot_right_456 = gc_frame_newslot(opresult473);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_475 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe477 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call478 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe477);
// compiled call node returning call478 (depth = 5)
// compiled member node returning call478 (depth = 4)
  int op_slot_left_475 = gc_frame_newslot(call478);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult479 = callmethod(call478, "==", 1, partcv, params);
// compiled op node returning opresult479 (depth = 3)
  int op_slot_left_456 = gc_frame_newslot(opresult479);
  params[0] = opresult473;
  partcv[0] = 1;
  Object opresult480 = callmethod(opresult479, "&&", 1, partcv, params);
// compiled op node returning opresult480 (depth = 2)
  gc_frame_end(frame);
  return opresult480;
}
Object meth_parser_accept_40__41_onLineOfLastOr481(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOfLastOr");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method accept()onLineOfLastOr");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method accept()onLineOfLastOr");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()onLineOfLastOr (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for onLineOfLastOr");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call486 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe485);
// compiled call node returning call486 (depth = 6)
// compiled member node returning call486 (depth = 5)
  int op_slot_right_484 = gc_frame_newslot(call486);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call489 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe488);
// compiled call node returning call489 (depth = 6)
// compiled member node returning call489 (depth = 5)
  int op_slot_left_484 = gc_frame_newslot(call489);
  params[0] = call486;
  partcv[0] = 1;
  Object opresult490 = callmethod(call489, "==", 1, partcv, params);
// compiled op node returning opresult490 (depth = 4)
  int op_slot_right_483 = gc_frame_newslot(opresult490);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call495 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe494);
// compiled call node returning call495 (depth = 7)
// compiled member node returning call495 (depth = 6)
  int op_slot_right_493 = gc_frame_newslot(call495);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe497 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call498 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe497);
// compiled call node returning call498 (depth = 7)
// compiled member node returning call498 (depth = 6)
  int op_slot_left_493 = gc_frame_newslot(call498);
  params[0] = call495;
  partcv[0] = 1;
  Object opresult499 = callmethod(call498, ">", 1, partcv, params);
// compiled op node returning opresult499 (depth = 5)
  int op_slot_right_492 = gc_frame_newslot(opresult499);
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call503 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe502);
// compiled call node returning call503 (depth = 7)
// compiled member node returning call503 (depth = 6)
  int op_slot_right_501 = gc_frame_newslot(call503);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe505 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_other (depth = 8)
  partcv[0] = 0;
  Object call506 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe505);
// compiled call node returning call506 (depth = 7)
// compiled member node returning call506 (depth = 6)
  int op_slot_left_501 = gc_frame_newslot(call506);
  params[0] = call503;
  partcv[0] = 1;
  Object opresult507 = callmethod(call506, "==", 1, partcv, params);
// compiled op node returning opresult507 (depth = 5)
  int op_slot_left_492 = gc_frame_newslot(opresult507);
  params[0] = opresult499;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "||", 1, partcv, params);
// compiled op node returning opresult508 (depth = 4)
  int op_slot_left_483 = gc_frame_newslot(opresult508);
  params[0] = opresult490;
  partcv[0] = 1;
  Object opresult509 = callmethod(opresult508, "||", 1, partcv, params);
// compiled op node returning opresult509 (depth = 3)
  int op_slot_right_482 = gc_frame_newslot(opresult509);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  int op_slot_right_511 = gc_frame_newslot(*var_t);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe513 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call514 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe513);
// compiled call node returning call514 (depth = 5)
// compiled member node returning call514 (depth = 4)
  int op_slot_left_511 = gc_frame_newslot(call514);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult515 = callmethod(call514, "==", 1, partcv, params);
// compiled op node returning opresult515 (depth = 3)
  int op_slot_left_482 = gc_frame_newslot(opresult515);
  params[0] = opresult509;
  partcv[0] = 1;
  Object opresult516 = callmethod(opresult515, "&&", 1, partcv, params);
// compiled op node returning opresult516 (depth = 2)
  gc_frame_end(frame);
  return opresult516;
}
Object meth_parser_tokenOnSameLine517(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastline = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokenOnSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for tokenOnSameLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastIndent (depth = 4)
  int op_slot_right_519 = gc_frame_newslot(*var_lastIndent);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call522 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe521);
// compiled call node returning call522 (depth = 5)
// compiled member node returning call522 (depth = 4)
  int op_slot_left_519 = gc_frame_newslot(call522);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult523 = callmethod(call522, ">", 1, partcv, params);
// compiled op node returning opresult523 (depth = 3)
  int op_slot_right_518 = gc_frame_newslot(opresult523);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call527 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe526);
// compiled call node returning call527 (depth = 5)
// compiled member node returning call527 (depth = 4)
  int op_slot_right_525 = gc_frame_newslot(call527);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastline (depth = 4)
  int op_slot_left_525 = gc_frame_newslot(*var_lastline);
  params[0] = call527;
  partcv[0] = 1;
  Object opresult529 = callmethod(*var_lastline, "==", 1, partcv, params);
// compiled op node returning opresult529 (depth = 3)
  int op_slot_left_518 = gc_frame_newslot(opresult529);
  params[0] = opresult523;
  partcv[0] = 1;
  Object opresult530 = callmethod(opresult529, "||", 1, partcv, params);
// compiled op node returning opresult530 (depth = 2)
  gc_frame_end(frame);
  return opresult530;
}
Object meth_parser_didConsume531(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method didConsume");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for didConsume (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for didConsume");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe532 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call533 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe532);
// compiled call node returning call533 (depth = 4)
// compiled member node returning call533 (depth = 3)
  *var_sz = call533;
  if (call533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe534 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ablock (depth = 4)
  partcv[0] = 0;
  Object call535 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe534);
// compiled call node returning call535 (depth = 3)
// compiled member node returning call535 (depth = 2)
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_536 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call539 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe538);
// compiled call node returning call539 (depth = 4)
// compiled member node returning call539 (depth = 3)
  int op_slot_left_536 = gc_frame_newslot(call539);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult540 = callmethod(call539, "!=", 1, partcv, params);
// compiled op node returning opresult540 (depth = 2)
  gc_frame_end(frame);
  return opresult540;
}
Object meth_parser_ifConsume_40__41_then541(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifConsume()then");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method ifConsume()then");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method ifConsume()then");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for ifConsume()then (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for ifConsume");
  Object *var_tblock = &(stackframe->slots[1]);
  *var_tblock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for then");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sz");
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call543 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe542);
// compiled call node returning call543 (depth = 4)
// compiled member node returning call543 (depth = 3)
  *var_sz = call543;
  if (call543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ablock (depth = 4)
  partcv[0] = 0;
  Object call545 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe544);
// compiled call node returning call545 (depth = 3)
// compiled member node returning call545 (depth = 2)
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_547 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tokens (depth = 6)
  partcv[0] = 0;
  Object call550 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe549);
// compiled call node returning call550 (depth = 5)
// compiled member node returning call550 (depth = 4)
  int op_slot_left_547 = gc_frame_newslot(call550);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult551 = callmethod(call550, "!=", 1, partcv, params);
// compiled op node returning opresult551 (depth = 3)
  Object if546 = done;
  if (istrue(opresult551)) {
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe552 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tblock (depth = 5)
  partcv[0] = 0;
  Object call553 = callmethod(*var_tblock, "apply",
    1, partcv, params);
  gc_frame_end(callframe552);
// compiled call node returning call553 (depth = 4)
// compiled member node returning call553 (depth = 3)
    gc_frame_newslot(call553);
    if546 = call553;
  } else {
  }
// compiled if node returning if546 (depth = 2)
  gc_frame_end(frame);
  return if546;
}
Object meth_parser_pushnum554(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushnum (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushnum");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe555 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call557 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe556);
// compiled call node returning call557 (depth = 5)
// compiled member node returning call557 (depth = 4)
  gc_frame_newslot(call557);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe558 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call559 = callmethod(*var_ast, "numNode",
    1, partcv, params);
  gc_frame_end(callframe558);
// compiled call node returning call559 (depth = 5)
// compiled member node returning call559 (depth = 4)
  params[0] = call557;
  partcv[0] = 1;
  Object call560 = callmethod(call559, "new",
    1, partcv, params);
  gc_frame_end(callframe555);
// compiled call node returning call560 (depth = 3)
  *var_o = call560;
  if (call560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe561 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call562 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe561);
// compiled call node returning call562 (depth = 2)
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe563 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call564 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe563);
// compiled call node returning call564 (depth = 3)
// compiled member node returning call564 (depth = 2)
  gc_frame_end(frame);
  return call564;
}
Object meth_parser_pushoctets565(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushoctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushoctets (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushoctets");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe566 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call568 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe567);
// compiled call node returning call568 (depth = 5)
// compiled member node returning call568 (depth = 4)
  gc_frame_newslot(call568);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call570 = callmethod(*var_ast, "octetsNode",
    1, partcv, params);
  gc_frame_end(callframe569);
// compiled call node returning call570 (depth = 5)
// compiled member node returning call570 (depth = 4)
  params[0] = call568;
  partcv[0] = 1;
  Object call571 = callmethod(call570, "new",
    1, partcv, params);
  gc_frame_end(callframe566);
// compiled call node returning call571 (depth = 3)
  *var_o = call571;
  if (call571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe572 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call573 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe572);
// compiled call node returning call573 (depth = 2)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call575 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe574);
// compiled call node returning call575 (depth = 3)
// compiled member node returning call575 (depth = 2)
  gc_frame_end(frame);
  return call575;
}
Object meth_parser_pushstring576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushstring (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushstring");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe577 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe578 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call579 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe578);
// compiled call node returning call579 (depth = 5)
// compiled member node returning call579 (depth = 4)
  gc_frame_newslot(call579);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call581 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe580);
// compiled call node returning call581 (depth = 5)
// compiled member node returning call581 (depth = 4)
  params[0] = call579;
  partcv[0] = 1;
  Object call582 = callmethod(call581, "new",
    1, partcv, params);
  gc_frame_end(callframe577);
// compiled call node returning call582 (depth = 3)
  *var_o = call582;
  if (call582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe583 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call584 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe583);
// compiled call node returning call584 (depth = 2)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe585 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call586 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe585);
// compiled call node returning call586 (depth = 3)
// compiled member node returning call586 (depth = 2)
  gc_frame_end(frame);
  return call586;
}
Object meth_parser_pushidentifier587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushidentifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for pushidentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe588 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe589 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call590 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe589);
// compiled call node returning call590 (depth = 4)
// compiled member node returning call590 (depth = 3)
  gc_frame_newslot(call590);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call592 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe591);
// compiled call node returning call592 (depth = 4)
// compiled member node returning call592 (depth = 3)
  gc_frame_newslot(call592);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call590;
  params[1] = call592;
  partcv[0] = 2;
  Object call593 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe588);
// compiled call node returning call593 (depth = 2)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe594 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call596 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe595);
// compiled call node returning call596 (depth = 5)
// compiled member node returning call596 (depth = 4)
  gc_frame_newslot(call596);
// starting to compile identifier node (depth = 4)
  Object bool597 = alloc_Boolean(0);
// compiled identifier node returning bool597 (depth = 4)
  gc_frame_newslot(bool597);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call599 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe598);
// compiled call node returning call599 (depth = 5)
// compiled member node returning call599 (depth = 4)
  params[0] = call596;
  params[1] = bool597;
  partcv[0] = 2;
  Object call600 = callmethod(call599, "new",
    1, partcv, params);
  gc_frame_end(callframe594);
// compiled call node returning call600 (depth = 3)
  *var_o = call600;
  if (call600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit603 == NULL) {
    strlit603 = alloc_String("_");
    gc_root(strlit603);
  }
// compiled string node returning strlit603 (depth = 4)
  int op_slot_right_602 = gc_frame_newslot(strlit603);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  partcv[0] = 0;
  Object call606 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe605);
// compiled call node returning call606 (depth = 5)
// compiled member node returning call606 (depth = 4)
  int op_slot_left_602 = gc_frame_newslot(call606);
  params[0] = strlit603;
  partcv[0] = 1;
  Object opresult607 = callmethod(call606, "==", 1, partcv, params);
// compiled op node returning opresult607 (depth = 3)
  Object if601 = done;
  if (istrue(opresult607)) {
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe608 = gc_frame_new();
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_auto_count (depth = 6)
  int op_slot_right_609 = gc_frame_newslot(*var_auto_count);
// starting to compile string node (depth = 6)
  if (strlit611 == NULL) {
    strlit611 = alloc_String("__");
    gc_root(strlit611);
  }
// compiled string node returning strlit611 (depth = 6)
  int op_slot_left_609 = gc_frame_newslot(strlit611);
  params[0] = *var_auto_count;
  partcv[0] = 1;
  Object opresult612 = callmethod(strlit611, "++", 1, partcv, params);
// compiled op node returning opresult612 (depth = 5)
  gc_frame_newslot(opresult612);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = opresult612;
  partcv[0] = 1;
  Object call613 = callmethod(*var_o, "value:=",
    1, partcv, params);
  gc_frame_end(callframe608);
// compiled call node returning call613 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe614 = gc_frame_new();
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool615 = alloc_Boolean(1);
// compiled identifier node returning bool615 (depth = 5)
  gc_frame_newslot(bool615);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = bool615;
  partcv[0] = 1;
  Object call616 = callmethod(*var_o, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe614);
// compiled call node returning call616 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num618 = alloc_Float64(1);
// compiled num node returning num618 (depth = 5)
  int op_slot_right_617 = gc_frame_newslot(num618);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_617 = gc_frame_newslot(*var_auto_count);
  params[0] = num618;
  partcv[0] = 1;
  Object sum620 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum620 (depth = 4)
  *var_auto_count = sum620;
  if (sum620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if601 = done;
  } else {
  }
// compiled if node returning if601 (depth = 2)
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe622 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call623 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe622);
// compiled call node returning call623 (depth = 2)
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call625 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe624);
// compiled call node returning call625 (depth = 3)
// compiled member node returning call625 (depth = 2)
  gc_frame_end(frame);
  return call625;
}
Object meth_parser__apply635(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit638 == NULL) {
    strlit638 = alloc_String("identifier");
    gc_root(strlit638);
  }
// compiled string node returning strlit638 (depth = 6)
  int op_slot_right_637 = gc_frame_newslot(strlit638);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe640 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call641 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe640);
// compiled call node returning call641 (depth = 7)
// compiled member node returning call641 (depth = 6)
  int op_slot_left_637 = gc_frame_newslot(call641);
  params[0] = strlit638;
  partcv[0] = 1;
  Object opresult642 = callmethod(call641, "==", 1, partcv, params);
// compiled op node returning opresult642 (depth = 5)
  Object if636 = done;
  if (istrue(opresult642)) {
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit645 == NULL) {
    strlit645 = alloc_String("public");
    gc_root(strlit645);
  }
// compiled string node returning strlit645 (depth = 7)
  int op_slot_right_644 = gc_frame_newslot(strlit645);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call648 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe647);
// compiled call node returning call648 (depth = 8)
// compiled member node returning call648 (depth = 7)
  int op_slot_left_644 = gc_frame_newslot(call648);
  params[0] = strlit645;
  partcv[0] = 1;
  Object opresult649 = callmethod(call648, "==", 1, partcv, params);
// compiled op node returning opresult649 (depth = 6)
  Object if643 = done;
  if (istrue(opresult649)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if643 = undefined;
  } else {
  }
// compiled if node returning if643 (depth = 5)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit652 == NULL) {
    strlit652 = alloc_String("readable");
    gc_root(strlit652);
  }
// compiled string node returning strlit652 (depth = 7)
  int op_slot_right_651 = gc_frame_newslot(strlit652);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe654 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call655 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe654);
// compiled call node returning call655 (depth = 8)
// compiled member node returning call655 (depth = 7)
  int op_slot_left_651 = gc_frame_newslot(call655);
  params[0] = strlit652;
  partcv[0] = 1;
  Object opresult656 = callmethod(call655, "==", 1, partcv, params);
// compiled op node returning opresult656 (depth = 6)
  Object if650 = done;
  if (istrue(opresult656)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if650 = undefined;
  } else {
  }
// compiled if node returning if650 (depth = 5)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit659 == NULL) {
    strlit659 = alloc_String("confidential");
    gc_root(strlit659);
  }
// compiled string node returning strlit659 (depth = 7)
  int op_slot_right_658 = gc_frame_newslot(strlit659);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call662 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe661);
// compiled call node returning call662 (depth = 8)
// compiled member node returning call662 (depth = 7)
  int op_slot_left_658 = gc_frame_newslot(call662);
  params[0] = strlit659;
  partcv[0] = 1;
  Object opresult663 = callmethod(call662, "==", 1, partcv, params);
// compiled op node returning opresult663 (depth = 6)
  Object if657 = done;
  if (istrue(opresult663)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if657 = undefined;
  } else {
  }
// compiled if node returning if657 (depth = 5)
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit666 == NULL) {
    strlit666 = alloc_String("writable");
    gc_root(strlit666);
  }
// compiled string node returning strlit666 (depth = 7)
  int op_slot_right_665 = gc_frame_newslot(strlit666);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_a (depth = 9)
  partcv[0] = 0;
  Object call669 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe668);
// compiled call node returning call669 (depth = 8)
// compiled member node returning call669 (depth = 7)
  int op_slot_left_665 = gc_frame_newslot(call669);
  params[0] = strlit666;
  partcv[0] = 1;
  Object opresult670 = callmethod(call669, "==", 1, partcv, params);
// compiled op node returning opresult670 (depth = 6)
  Object if664 = done;
  if (istrue(opresult670)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_done (depth = 7)
  block_return(realself, *var_done);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if664 = undefined;
  } else {
  }
// compiled if node returning if664 (depth = 5)
    gc_frame_newslot(if664);
    if636 = if664;
  } else {
  }
// compiled if node returning if636 (depth = 4)
  gc_frame_end(frame);
  return if636;
}
Object meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "adjustVisibilityOf()withSpecialDefault()overriding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method adjustVisibilityOf()withSpecialDefault()overriding");
  Object params[2];
  int partcv[2];
  Object *var_done = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for adjustVisibilityOf()withSpecialDefault()overriding (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for adjustVisibilityOf");
  Object *var_sd = &(stackframe->slots[1]);
  *var_sd = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for withSpecialDefault");
  Object *var_nd = &(stackframe->slots[2]);
  *var_nd = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for overriding");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newAnn = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newAnn");
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nd (depth = 4)
  int op_slot_right_628 = gc_frame_newslot(*var_nd);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sd (depth = 4)
  int op_slot_left_628 = gc_frame_newslot(*var_sd);
  params[0] = *var_nd;
  partcv[0] = 1;
  Object opresult630 = callmethod(*var_sd, "==", 1, partcv, params);
// compiled op node returning opresult630 (depth = 3)
  Object if627 = done;
  if (istrue(opresult630)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_done (depth = 4)
  return *var_done;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if627 = undefined;
  } else {
  }
// compiled if node returning if627 (depth = 2)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe631 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call633 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe632);
// compiled call node returning call633 (depth = 4)
// compiled member node returning call633 (depth = 3)
  gc_frame_newslot(call633);
// starting to compile block node (depth = 3)
  Object block634 = alloc_Block(NULL, NULL, "parser", 246);
  gc_frame_newslot(block634);
// method _apply
  block_savedest(block634);
  Object closure635 = createclosure(2, "_apply");
  setclosureframe(closure635, stackframe);
  addtoclosure(closure635, var_done);
  addtoclosure(closure635, selfslot);
  struct UserObject *uo635 = (struct UserObject*)block634;
  uo635->data[0] = (Object)closure635;
  Method *meth_meth_parser__apply635 = addmethod2pos(block634, "_apply", &meth_parser__apply635, 0);
  int argcv_meth_parser__apply635[] = {1};
  meth_meth_parser__apply635->type = alloc_MethodType(1, argcv_meth_parser__apply635);
  meth_meth_parser__apply635->definitionModule = modulename;
  meth_meth_parser__apply635->definitionLine = 246;
// compiled block node returning block634 (depth = 3)
  gc_frame_newslot(block634);
// call case 5: prelude request
  params[0] = call633;
  params[1] = block634;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call672 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe631);
// compiled call node returning call672 (depth = 2)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe673 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sd (depth = 4)
  gc_frame_newslot(*var_sd);
// starting to compile identifier node (depth = 4)
  Object bool674 = alloc_Boolean(0);
// compiled identifier node returning bool674 (depth = 4)
  gc_frame_newslot(bool674);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call676 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe675);
// compiled call node returning call676 (depth = 5)
// compiled member node returning call676 (depth = 4)
  params[0] = *var_sd;
  params[1] = bool674;
  partcv[0] = 2;
  Object call677 = callmethod(call676, "new",
    1, partcv, params);
  gc_frame_end(callframe673);
// compiled call node returning call677 (depth = 3)
  *var_newAnn = call677;
  if (call677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe678 = gc_frame_new();
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_node (depth = 4)
  gc_frame_newslot(*var_node);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newAnn (depth = 4)
  params[0] = *var_node;
  partcv[0] = 1;
  Object call679 = callmethod(*var_newAnn, "parent:=",
    1, partcv, params);
  gc_frame_end(callframe678);
// compiled call node returning call679 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe680 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newAnn (depth = 3)
  gc_frame_newslot(*var_newAnn);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe681 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_node (depth = 5)
  partcv[0] = 0;
  Object call682 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe681);
// compiled call node returning call682 (depth = 4)
// compiled member node returning call682 (depth = 3)
  params[0] = *var_newAnn;
  partcv[0] = 1;
  Object call683 = callmethod(call682, "push",
    1, partcv, params);
  gc_frame_end(callframe680);
// compiled call node returning call683 (depth = 2)
  gc_frame_end(frame);
  return call683;
}
Object meth_parser__apply705(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool707 = alloc_Boolean(0);
// compiled identifier node returning bool707 (depth = 11)
  int op_slot_right_706 = gc_frame_newslot(bool707);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call710 = callmethod(*var_a, "dtype",
    1, partcv, params);
  gc_frame_end(callframe709);
// compiled call node returning call710 (depth = 12)
// compiled member node returning call710 (depth = 11)
  int op_slot_left_706 = gc_frame_newslot(call710);
  params[0] = bool707;
  partcv[0] = 1;
  Object opresult711 = callmethod(call710, "!=", 1, partcv, params);
// compiled op node returning opresult711 (depth = 10)
  gc_frame_end(frame);
  return opresult711;
}
Object meth_parser__apply722(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit724 == NULL) {
    strlit724 = alloc_String(":");
    gc_root(strlit724);
  }
// compiled string node returning strlit724 (depth = 11)
  int op_slot_right_723 = gc_frame_newslot(strlit724);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe726 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call727 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe726);
// compiled call node returning call727 (depth = 12)
// compiled member node returning call727 (depth = 11)
  int op_slot_left_723 = gc_frame_newslot(call727);
  params[0] = strlit724;
  partcv[0] = 1;
  Object opresult728 = callmethod(call727, "!=", 1, partcv, params);
// compiled op node returning opresult728 (depth = 10)
  gc_frame_end(frame);
  return opresult728;
}
Object meth_parser__apply731(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe732 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call733 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe732);
// compiled call node returning call733 (depth = 12)
// compiled member node returning call733 (depth = 11)
  *var_tok = call733;
  if (call733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply701(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe703 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block704 = alloc_Block(NULL, NULL, "parser", 262);
  gc_frame_newslot(block704);
// method _apply
  block_savedest(block704);
  Object closure705 = createclosure(2, "_apply");
  setclosureframe(closure705, stackframe);
  addtoclosure(closure705, var_a);
  addtoclosure(closure705, selfslot);
  struct UserObject *uo705 = (struct UserObject*)block704;
  uo705->data[0] = (Object)closure705;
  Method *meth_meth_parser__apply705 = addmethod2pos(block704, "_apply", &meth_parser__apply705, 0);
  int argcv_meth_parser__apply705[] = {0};
  meth_meth_parser__apply705->type = alloc_MethodType(1, argcv_meth_parser__apply705);
  meth_meth_parser__apply705->definitionModule = modulename;
  meth_meth_parser__apply705->definitionLine = 261;
// compiled block node returning block704 (depth = 9)
  gc_frame_newslot(block704);
// call case 6: other member request
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit714 == NULL) {
    strlit714 = alloc_String("identifier");
    gc_root(strlit714);
  }
// compiled string node returning strlit714 (depth = 10)
  int op_slot_right_713 = gc_frame_newslot(strlit714);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  partcv[0] = 0;
  Object call717 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe716);
// compiled call node returning call717 (depth = 11)
// compiled member node returning call717 (depth = 10)
  int op_slot_left_713 = gc_frame_newslot(call717);
  params[0] = strlit714;
  partcv[0] = 1;
  Object opresult718 = callmethod(call717, "==", 1, partcv, params);
// compiled op node returning opresult718 (depth = 9)
  params[0] = block704;
  partcv[0] = 1;
  Object call719 = callmethod(opresult718, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe703);
// compiled call node returning call719 (depth = 8)
  Object if702 = done;
  if (istrue(call719)) {
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe720 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block721 = alloc_Block(NULL, NULL, "parser", 265);
  gc_frame_newslot(block721);
// method _apply
  block_savedest(block721);
  Object closure722 = createclosure(2, "_apply");
  setclosureframe(closure722, stackframe);
  addtoclosure(closure722, var_tok);
  addtoclosure(closure722, selfslot);
  struct UserObject *uo722 = (struct UserObject*)block721;
  uo722->data[0] = (Object)closure722;
  Method *meth_meth_parser__apply722 = addmethod2pos(block721, "_apply", &meth_parser__apply722, 0);
  int argcv_meth_parser__apply722[] = {0};
  meth_meth_parser__apply722->type = alloc_MethodType(1, argcv_meth_parser__apply722);
  meth_meth_parser__apply722->definitionModule = modulename;
  meth_meth_parser__apply722->definitionLine = 262;
// compiled block node returning block721 (depth = 9)
  gc_frame_newslot(block721);
// starting to compile block node (depth = 9)
  Object block730 = alloc_Block(NULL, NULL, "parser", 265);
  gc_frame_newslot(block730);
// method _apply
  block_savedest(block730);
  Object closure731 = createclosure(2, "_apply");
  setclosureframe(closure731, stackframe);
  addtoclosure(closure731, var_tok);
  addtoclosure(closure731, selfslot);
  struct UserObject *uo731 = (struct UserObject*)block730;
  uo731->data[0] = (Object)closure731;
  Method *meth_meth_parser__apply731 = addmethod2pos(block730, "_apply", &meth_parser__apply731, 0);
  int argcv_meth_parser__apply731[] = {0};
  meth_meth_parser__apply731->type = alloc_MethodType(1, argcv_meth_parser__apply731);
  meth_meth_parser__apply731->definitionModule = modulename;
  meth_meth_parser__apply731->definitionLine = 265;
// compiled block node returning block730 (depth = 9)
  gc_frame_newslot(block730);
// call case 5: prelude request
  params[0] = block721;
  params[1] = block730;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call736 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe720);
// compiled call node returning call736 (depth = 8)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe737 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe738 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call739 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe738);
// compiled call node returning call739 (depth = 12)
// compiled member node returning call739 (depth = 11)
  partcv[0] = 0;
  Object call740 = callmethod(call739, "new",
    1, partcv, params);
  gc_frame_end(callframe737);
// compiled call node returning call740 (depth = 10)
// compiled member node returning call740 (depth = 9)
  *var_suggestion = call740;
  if (call740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe741 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call743 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe742);
// compiled call node returning call743 (depth = 10)
// compiled member node returning call743 (depth = 9)
  gc_frame_newslot(call743);
// starting to compile identifier node (depth = 9)
  Object bool744 = alloc_Boolean(1);
// compiled identifier node returning bool744 (depth = 9)
  gc_frame_newslot(bool744);
// starting to compile identifier node (depth = 9)
  Object bool745 = alloc_Boolean(0);
// compiled identifier node returning bool745 (depth = 9)
  gc_frame_newslot(bool745);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_tok;
  params[1] = call743;
  params[2] = bool744;
  params[3] = bool745;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call746 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe741);
// compiled call node returning call746 (depth = 8)
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe747 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit748 == NULL) {
    strlit748 = alloc_String("An argument to an annotation cannot have a type.");
    gc_root(strlit748);
  }
// compiled string node returning strlit748 (depth = 9)
  gc_frame_newslot(strlit748);
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call750 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe749);
// compiled call node returning call750 (depth = 10)
// compiled member node returning call750 (depth = 9)
  gc_frame_newslot(call750);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe751 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tok (depth = 11)
  partcv[0] = 0;
  Object call752 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe751);
// compiled call node returning call752 (depth = 10)
// compiled member node returning call752 (depth = 9)
  gc_frame_newslot(call752);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num754 = alloc_Float64(1);
// compiled num node returning num754 (depth = 10)
  int op_slot_right_753 = gc_frame_newslot(num754);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe757 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call759 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe758);
// compiled call node returning call759 (depth = 14)
// compiled member node returning call759 (depth = 13)
  partcv[0] = 0;
  Object call760 = callmethod(call759, "size",
    1, partcv, params);
  gc_frame_end(callframe757);
// compiled call node returning call760 (depth = 12)
// compiled member node returning call760 (depth = 11)
  int op_slot_right_756 = gc_frame_newslot(call760);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe762 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call764 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe763);
// compiled call node returning call764 (depth = 14)
// compiled member node returning call764 (depth = 13)
  partcv[0] = 0;
  Object call765 = callmethod(call764, "linePos",
    1, partcv, params);
  gc_frame_end(callframe762);
// compiled call node returning call765 (depth = 12)
// compiled member node returning call765 (depth = 11)
  int op_slot_left_756 = gc_frame_newslot(call765);
  params[0] = call760;
  partcv[0] = 1;
  Object sum766 = callmethod(call765, "+", 1, partcv, params);
// compiled op node returning sum766 (depth = 10)
  int op_slot_left_753 = gc_frame_newslot(sum766);
  params[0] = num754;
  partcv[0] = 1;
  Object diff767 = callmethod(sum766, "-", 1, partcv, params);
// compiled op node returning diff767 (depth = 9)
  gc_frame_newslot(diff767);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit748;
  params[1] = call750;
  params[2] = call752;
  params[3] = diff767;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call768 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe747);
// compiled call node returning call768 (depth = 8)
    gc_frame_newslot(call768);
    if702 = call768;
  } else {
  }
// compiled if node returning if702 (depth = 7)
  gc_frame_end(frame);
  return if702;
}
Object meth_parser__apply696(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe697 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_p (depth = 8)
  partcv[0] = 0;
  Object call699 = callmethod(*var_p, "args",
    1, partcv, params);
  gc_frame_end(callframe698);
// compiled call node returning call699 (depth = 7)
// compiled member node returning call699 (depth = 6)
  gc_frame_newslot(call699);
// starting to compile block node (depth = 6)
  Object block700 = alloc_Block(NULL, NULL, "parser", 261);
  gc_frame_newslot(block700);
// method _apply
  block_savedest(block700);
  Object closure701 = createclosure(3, "_apply");
  setclosureframe(closure701, stackframe);
  addtoclosure(closure701, var_sym);
  addtoclosure(closure701, var_errormessages);
  addtoclosure(closure701, selfslot);
  struct UserObject *uo701 = (struct UserObject*)block700;
  uo701->data[0] = (Object)closure701;
  Method *meth_meth_parser__apply701 = addmethod2pos(block700, "_apply", &meth_parser__apply701, 0);
  int argcv_meth_parser__apply701[] = {1};
  meth_meth_parser__apply701->type = alloc_MethodType(1, argcv_meth_parser__apply701);
  meth_meth_parser__apply701->definitionModule = modulename;
  meth_meth_parser__apply701->definitionLine = 261;
// compiled block node returning block700 (depth = 6)
  gc_frame_newslot(block700);
// call case 5: prelude request
  params[0] = call699;
  params[1] = block700;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call770 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe697);
// compiled call node returning call770 (depth = 5)
  gc_frame_end(frame);
  return call770;
}
Object meth_parser_checkAnnotation684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method checkAnnotation");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for checkAnnotation");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit687 == NULL) {
    strlit687 = alloc_String("call");
    gc_root(strlit687);
  }
// compiled string node returning strlit687 (depth = 4)
  int op_slot_right_686 = gc_frame_newslot(strlit687);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call690 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe689);
// compiled call node returning call690 (depth = 5)
// compiled member node returning call690 (depth = 4)
  int op_slot_left_686 = gc_frame_newslot(call690);
  params[0] = strlit687;
  partcv[0] = 1;
  Object opresult691 = callmethod(call690, "==", 1, partcv, params);
// compiled op node returning opresult691 (depth = 3)
  Object if685 = done;
  if (istrue(opresult691)) {
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe692 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ann (depth = 6)
  partcv[0] = 0;
  Object call694 = callmethod(*var_ann, "with",
    1, partcv, params);
  gc_frame_end(callframe693);
// compiled call node returning call694 (depth = 5)
// compiled member node returning call694 (depth = 4)
  gc_frame_newslot(call694);
// starting to compile block node (depth = 4)
  Object block695 = alloc_Block(NULL, NULL, "parser", 260);
  gc_frame_newslot(block695);
// method _apply
  block_savedest(block695);
  Object closure696 = createclosure(3, "_apply");
  setclosureframe(closure696, stackframe);
  addtoclosure(closure696, var_sym);
  addtoclosure(closure696, var_errormessages);
  addtoclosure(closure696, selfslot);
  struct UserObject *uo696 = (struct UserObject*)block695;
  uo696->data[0] = (Object)closure696;
  Method *meth_meth_parser__apply696 = addmethod2pos(block695, "_apply", &meth_parser__apply696, 0);
  int argcv_meth_parser__apply696[] = {1};
  meth_meth_parser__apply696->type = alloc_MethodType(1, argcv_meth_parser__apply696);
  meth_meth_parser__apply696->definitionModule = modulename;
  meth_meth_parser__apply696->definitionLine = 260;
// compiled block node returning block695 (depth = 4)
  gc_frame_newslot(block695);
// call case 5: prelude request
  params[0] = call694;
  params[1] = block695;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call772 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe692);
// compiled call node returning call772 (depth = 3)
    gc_frame_newslot(call772);
    if685 = call772;
  } else {
  }
// compiled if node returning if685 (depth = 2)
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ann (depth = 2)
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser__apply777(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit779 == NULL) {
    strlit779 = alloc_String("is");
    gc_root(strlit779);
  }
// compiled string node returning strlit779 (depth = 6)
  int op_slot_right_778 = gc_frame_newslot(strlit779);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call782 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe781);
// compiled call node returning call782 (depth = 7)
// compiled member node returning call782 (depth = 6)
  int op_slot_left_778 = gc_frame_newslot(call782);
  params[0] = strlit779;
  partcv[0] = 1;
  Object opresult783 = callmethod(call782, "!=", 1, partcv, params);
// compiled op node returning opresult783 (depth = 5)
  gc_frame_end(frame);
  return opresult783;
}
Object meth_parser__apply802(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe803 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_noBlocks (depth = 8)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call804 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe803);
// compiled call node returning call804 (depth = 7)
  gc_frame_end(frame);
  return call804;
}
Object meth_parser__apply863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe864 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit865 == NULL) {
    strlit865 = alloc_String("comma");
    gc_root(strlit865);
  }
// compiled string node returning strlit865 (depth = 5)
  gc_frame_newslot(strlit865);
// call case 4: self request
  params[0] = strlit865;
  partcv[0] = 1;
  Object call866 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe864);
// compiled call node returning call866 (depth = 4)
  gc_frame_end(frame);
  return call866;
}
Object meth_parser__apply882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe883 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_noBlocks (depth = 10)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call884 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe883);
// compiled call node returning call884 (depth = 9)
  gc_frame_end(frame);
  return call884;
}
Object meth_parser__apply869(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe870 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe871 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe872 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call873 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe872);
// compiled call node returning call873 (depth = 7)
// compiled member node returning call873 (depth = 6)
  gc_frame_newslot(call873);
// call case 4: self request
  params[0] = call873;
  partcv[0] = 1;
  Object call874 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe871);
// compiled call node returning call874 (depth = 5)
  gc_frame_newslot(call874);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  params[0] = call874;
  partcv[0] = 1;
  Object call875 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe870);
// compiled call node returning call875 (depth = 4)
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe876 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call877 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe876);
// compiled call node returning call877 (depth = 5)
// compiled member node returning call877 (depth = 4)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe879 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe880 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block881 = alloc_Block(NULL, NULL, "parser", 301);
  gc_frame_newslot(block881);
// method _apply
  block_savedest(block881);
  Object closure882 = createclosure(2, "_apply");
  setclosureframe(closure882, stackframe);
  addtoclosure(closure882, var_noBlocks);
  addtoclosure(closure882, selfslot);
  struct UserObject *uo882 = (struct UserObject*)block881;
  uo882->data[0] = (Object)closure882;
  Method *meth_meth_parser__apply882 = addmethod2pos(block881, "_apply", &meth_parser__apply882, 0);
  int argcv_meth_parser__apply882[] = {0};
  meth_meth_parser__apply882->type = alloc_MethodType(1, argcv_meth_parser__apply882);
  meth_meth_parser__apply882->definitionModule = modulename;
  meth_meth_parser__apply882->definitionLine = 301;
// compiled block node returning block881 (depth = 8)
  gc_frame_newslot(block881);
// call case 4: self request
  params[0] = block881;
  partcv[0] = 1;
  Object call886 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe880);
// compiled call node returning call886 (depth = 7)
  partcv[0] = 0;
  Object call887 = callmethod(call886, "not",
    1, partcv, params);
  gc_frame_end(callframe879);
// compiled call node returning call887 (depth = 6)
// compiled member node returning call887 (depth = 5)
  Object if878 = done;
  if (istrue(call887)) {
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array888 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array888 (depth = 6)
  *var_suggestions = array888;
  if (array888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe889 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call891 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe890);
// compiled call node returning call891 (depth = 9)
// compiled member node returning call891 (depth = 8)
  partcv[0] = 0;
  Object call892 = callmethod(call891, "new",
    1, partcv, params);
  gc_frame_end(callframe889);
// compiled call node returning call892 (depth = 7)
// compiled member node returning call892 (depth = 6)
  *var_suggestion = call892;
  if (call892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe893 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit894 == NULL) {
    strlit894 = alloc_String("bind");
    gc_root(strlit894);
  }
// compiled string node returning strlit894 (depth = 7)
  gc_frame_newslot(strlit894);
// call case 4: self request
  params[0] = strlit894;
  partcv[0] = 1;
  Object call895 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe893);
// compiled call node returning call895 (depth = 6)
  *var_nextTok = call895;
  if (call895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_897 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_897 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult899 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult899 (depth = 6)
  Object if896 = done;
  if (istrue(opresult899)) {
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe900 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit901 == NULL) {
    strlit901 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit901);
  }
// compiled string node returning strlit901 (depth = 7)
  gc_frame_newslot(strlit901);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit901;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call902 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe900);
// compiled call node returning call902 (depth = 6)
    gc_frame_newslot(call902);
    if896 = call902;
  } else {
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe903 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call905 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe904);
// compiled call node returning call905 (depth = 8)
// compiled member node returning call905 (depth = 7)
  gc_frame_newslot(call905);
// starting to compile identifier node (depth = 7)
  Object bool906 = alloc_Boolean(1);
// compiled identifier node returning bool906 (depth = 7)
  gc_frame_newslot(bool906);
// starting to compile identifier node (depth = 7)
  Object bool907 = alloc_Boolean(0);
// compiled identifier node returning bool907 (depth = 7)
  gc_frame_newslot(bool907);
// starting to compile string node (depth = 7)
  if (strlit908 == NULL) {
    strlit908 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit908);
  }
// compiled string node returning strlit908 (depth = 7)
  gc_frame_newslot(strlit908);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call905;
  params[2] = bool906;
  params[3] = bool907;
  params[4] = strlit908;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call909 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe903);
// compiled call node returning call909 (depth = 6)
    gc_frame_newslot(call909);
    if896 = call909;
  }
// compiled if node returning if896 (depth = 5)
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe910 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call911 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe910);
// compiled call node returning call911 (depth = 5)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe912 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe913 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call914 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe913);
// compiled call node returning call914 (depth = 9)
// compiled member node returning call914 (depth = 8)
  partcv[0] = 0;
  Object call915 = callmethod(call914, "new",
    1, partcv, params);
  gc_frame_end(callframe912);
// compiled call node returning call915 (depth = 7)
// compiled member node returning call915 (depth = 6)
  *var_suggestion = call915;
  if (call915 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe917 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call919 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe918);
// compiled call node returning call919 (depth = 7)
// compiled member node returning call919 (depth = 6)
  gc_frame_newslot(call919);
// starting to compile identifier node (depth = 6)
  Object bool920 = alloc_Boolean(1);
// compiled identifier node returning bool920 (depth = 6)
  gc_frame_newslot(bool920);
// starting to compile identifier node (depth = 6)
  Object bool921 = alloc_Boolean(0);
// compiled identifier node returning bool921 (depth = 6)
  gc_frame_newslot(bool921);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call919;
  params[2] = bool920;
  params[3] = bool921;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call922 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe917);
// compiled call node returning call922 (depth = 5)
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe923 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call924 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe923);
// compiled call node returning call924 (depth = 5)
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe925 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit926 == NULL) {
    strlit926 = alloc_String("One or more annotations separated by commas must follow 'is'.");
    gc_root(strlit926);
  }
// compiled string node returning strlit926 (depth = 6)
  gc_frame_newslot(strlit926);
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe927 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call928 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe927);
// compiled call node returning call928 (depth = 7)
// compiled member node returning call928 (depth = 6)
  gc_frame_newslot(call928);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num930 = alloc_Float64(1);
// compiled num node returning num930 (depth = 7)
  int op_slot_right_929 = gc_frame_newslot(num930);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call934 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe933);
// compiled call node returning call934 (depth = 9)
// compiled member node returning call934 (depth = 8)
  int op_slot_right_932 = gc_frame_newslot(call934);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call937 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 9)
// compiled member node returning call937 (depth = 8)
  int op_slot_left_932 = gc_frame_newslot(call937);
  params[0] = call934;
  partcv[0] = 1;
  Object sum938 = callmethod(call937, "+", 1, partcv, params);
// compiled op node returning sum938 (depth = 7)
  int op_slot_left_929 = gc_frame_newslot(sum938);
  params[0] = num930;
  partcv[0] = 1;
  Object sum939 = callmethod(sum938, "+", 1, partcv, params);
// compiled op node returning sum939 (depth = 6)
  gc_frame_newslot(sum939);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit926;
  params[1] = call928;
  params[2] = sum939;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call940 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe925);
// compiled call node returning call940 (depth = 5)
    gc_frame_newslot(call940);
    if878 = call940;
  } else {
  }
// compiled if node returning if878 (depth = 4)
  gc_frame_end(frame);
  return if878;
}
Object meth_parser_doannotation773(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_collections = getfromclosure(closure, 1);
  Object *var_noBlocks = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doannotation (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doannotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe775 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block776 = alloc_Block(NULL, NULL, "parser", 277);
  gc_frame_newslot(block776);
// method _apply
  block_savedest(block776);
  Object closure777 = createclosure(2, "_apply");
  setclosureframe(closure777, stackframe);
  addtoclosure(closure777, var_sym);
  addtoclosure(closure777, selfslot);
  struct UserObject *uo777 = (struct UserObject*)block776;
  uo777->data[0] = (Object)closure777;
  Method *meth_meth_parser__apply777 = addmethod2pos(block776, "_apply", &meth_parser__apply777, 0);
  int argcv_meth_parser__apply777[] = {0};
  meth_meth_parser__apply777->type = alloc_MethodType(1, argcv_meth_parser__apply777);
  meth_meth_parser__apply777->definitionModule = modulename;
  meth_meth_parser__apply777->definitionLine = 269;
// compiled block node returning block776 (depth = 4)
  gc_frame_newslot(block776);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe785 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe786 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit787 == NULL) {
    strlit787 = alloc_String("keyword");
    gc_root(strlit787);
  }
// compiled string node returning strlit787 (depth = 6)
  gc_frame_newslot(strlit787);
// call case 4: self request
  params[0] = strlit787;
  partcv[0] = 1;
  Object call788 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe786);
// compiled call node returning call788 (depth = 5)
  partcv[0] = 0;
  Object call789 = callmethod(call788, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe785);
// compiled call node returning call789 (depth = 4)
  params[0] = block776;
  partcv[0] = 1;
  Object call790 = callmethod(call789, "orElse",
    1, partcv, params);
  gc_frame_end(callframe775);
// compiled call node returning call790 (depth = 3)
  Object if774 = done;
  if (istrue(call790)) {
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool791 = alloc_Boolean(0);
// compiled identifier node returning bool791 (depth = 4)
  return bool791;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if774 = undefined;
  } else {
  }
// compiled if node returning if774 (depth = 2)
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe792 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call793 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe792);
// compiled call node returning call793 (depth = 3)
// compiled member node returning call793 (depth = 2)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe794 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_collections (depth = 7)
  partcv[0] = 0;
  Object call796 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe795);
// compiled call node returning call796 (depth = 6)
// compiled member node returning call796 (depth = 5)
  partcv[0] = 0;
  Object call797 = callmethod(call796, "new",
    1, partcv, params);
  gc_frame_end(callframe794);
// compiled call node returning call797 (depth = 4)
// compiled member node returning call797 (depth = 3)
  *var_anns = call797;
  if (call797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe799 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe800 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block801 = alloc_Block(NULL, NULL, "parser", 282);
  gc_frame_newslot(block801);
// method _apply
  block_savedest(block801);
  Object closure802 = createclosure(2, "_apply");
  setclosureframe(closure802, stackframe);
  addtoclosure(closure802, var_noBlocks);
  addtoclosure(closure802, selfslot);
  struct UserObject *uo802 = (struct UserObject*)block801;
  uo802->data[0] = (Object)closure802;
  Method *meth_meth_parser__apply802 = addmethod2pos(block801, "_apply", &meth_parser__apply802, 0);
  int argcv_meth_parser__apply802[] = {0};
  meth_meth_parser__apply802->type = alloc_MethodType(1, argcv_meth_parser__apply802);
  meth_meth_parser__apply802->definitionModule = modulename;
  meth_meth_parser__apply802->definitionLine = 282;
// compiled block node returning block801 (depth = 6)
  gc_frame_newslot(block801);
// call case 4: self request
  params[0] = block801;
  partcv[0] = 1;
  Object call806 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe800);
// compiled call node returning call806 (depth = 5)
  partcv[0] = 0;
  Object call807 = callmethod(call806, "not",
    1, partcv, params);
  gc_frame_end(callframe799);
// compiled call node returning call807 (depth = 4)
// compiled member node returning call807 (depth = 3)
  Object if798 = done;
  if (istrue(call807)) {
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array808 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array808 (depth = 4)
  *var_suggestions = array808;
  if (array808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe809 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call811 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe810);
// compiled call node returning call811 (depth = 7)
// compiled member node returning call811 (depth = 6)
  partcv[0] = 0;
  Object call812 = callmethod(call811, "new",
    1, partcv, params);
  gc_frame_end(callframe809);
// compiled call node returning call812 (depth = 5)
// compiled member node returning call812 (depth = 4)
  *var_suggestion = call812;
  if (call812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe813 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit814 == NULL) {
    strlit814 = alloc_String("bind");
    gc_root(strlit814);
  }
// compiled string node returning strlit814 (depth = 5)
  gc_frame_newslot(strlit814);
// call case 4: self request
  params[0] = strlit814;
  partcv[0] = 1;
  Object call815 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe813);
// compiled call node returning call815 (depth = 4)
  *var_nextTok = call815;
  if (call815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_817 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_817 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult819 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult819 (depth = 4)
  Object if816 = done;
  if (istrue(opresult819)) {
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe820 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit821 == NULL) {
    strlit821 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit821);
  }
// compiled string node returning strlit821 (depth = 5)
  gc_frame_newslot(strlit821);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit821;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call822 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe820);
// compiled call node returning call822 (depth = 4)
    gc_frame_newslot(call822);
    if816 = call822;
  } else {
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe823 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call825 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe824);
// compiled call node returning call825 (depth = 6)
// compiled member node returning call825 (depth = 5)
  gc_frame_newslot(call825);
// starting to compile identifier node (depth = 5)
  Object bool826 = alloc_Boolean(1);
// compiled identifier node returning bool826 (depth = 5)
  gc_frame_newslot(bool826);
// starting to compile identifier node (depth = 5)
  Object bool827 = alloc_Boolean(0);
// compiled identifier node returning bool827 (depth = 5)
  gc_frame_newslot(bool827);
// starting to compile string node (depth = 5)
  if (strlit828 == NULL) {
    strlit828 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit828);
  }
// compiled string node returning strlit828 (depth = 5)
  gc_frame_newslot(strlit828);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call825;
  params[2] = bool826;
  params[3] = bool827;
  params[4] = strlit828;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call829 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call829 (depth = 4)
    gc_frame_newslot(call829);
    if816 = call829;
  }
// compiled if node returning if816 (depth = 3)
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe830 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call831 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe830);
// compiled call node returning call831 (depth = 3)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe832 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe833 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call834 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe833);
// compiled call node returning call834 (depth = 7)
// compiled member node returning call834 (depth = 6)
  partcv[0] = 0;
  Object call835 = callmethod(call834, "new",
    1, partcv, params);
  gc_frame_end(callframe832);
// compiled call node returning call835 (depth = 5)
// compiled member node returning call835 (depth = 4)
  *var_suggestion = call835;
  if (call835 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe837 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe838 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  partcv[0] = 0;
  Object call839 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe838);
// compiled call node returning call839 (depth = 5)
// compiled member node returning call839 (depth = 4)
  gc_frame_newslot(call839);
// starting to compile identifier node (depth = 4)
  Object bool840 = alloc_Boolean(1);
// compiled identifier node returning bool840 (depth = 4)
  gc_frame_newslot(bool840);
// starting to compile identifier node (depth = 4)
  Object bool841 = alloc_Boolean(0);
// compiled identifier node returning bool841 (depth = 4)
  gc_frame_newslot(bool841);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_lastToken;
  params[1] = call839;
  params[2] = bool840;
  params[3] = bool841;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call842 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe837);
// compiled call node returning call842 (depth = 3)
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe843 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call844 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe843);
// compiled call node returning call844 (depth = 3)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe845 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit846 == NULL) {
    strlit846 = alloc_String("One or more annotations separated by commas must follow 'is'.");
    gc_root(strlit846);
  }
// compiled string node returning strlit846 (depth = 4)
  gc_frame_newslot(strlit846);
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe847 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call848 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe847);
// compiled call node returning call848 (depth = 5)
// compiled member node returning call848 (depth = 4)
  gc_frame_newslot(call848);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num850 = alloc_Float64(1);
// compiled num node returning num850 (depth = 5)
  int op_slot_right_849 = gc_frame_newslot(num850);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe853 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call854 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe853);
// compiled call node returning call854 (depth = 7)
// compiled member node returning call854 (depth = 6)
  int op_slot_right_852 = gc_frame_newslot(call854);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call857 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe856);
// compiled call node returning call857 (depth = 7)
// compiled member node returning call857 (depth = 6)
  int op_slot_left_852 = gc_frame_newslot(call857);
  params[0] = call854;
  partcv[0] = 1;
  Object sum858 = callmethod(call857, "+", 1, partcv, params);
// compiled op node returning sum858 (depth = 5)
  int op_slot_left_849 = gc_frame_newslot(sum858);
  params[0] = num850;
  partcv[0] = 1;
  Object sum859 = callmethod(sum858, "+", 1, partcv, params);
// compiled op node returning sum859 (depth = 4)
  gc_frame_newslot(sum859);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit846;
  params[1] = call848;
  params[2] = sum859;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call860 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe845);
// compiled call node returning call860 (depth = 3)
    gc_frame_newslot(call860);
    if798 = call860;
  } else {
  }
// compiled if node returning if798 (depth = 2)
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe861 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block862 = alloc_Block(NULL, NULL, "parser", 298);
  gc_frame_newslot(block862);
// method _apply
  block_savedest(block862);
  Object closure863 = createclosure(1, "_apply");
  setclosureframe(closure863, stackframe);
  addtoclosure(closure863, selfslot);
  struct UserObject *uo863 = (struct UserObject*)block862;
  uo863->data[0] = (Object)closure863;
  Method *meth_meth_parser__apply863 = addmethod2pos(block862, "_apply", &meth_parser__apply863, 0);
  int argcv_meth_parser__apply863[] = {0};
  meth_meth_parser__apply863->type = alloc_MethodType(1, argcv_meth_parser__apply863);
  meth_meth_parser__apply863->definitionModule = modulename;
  meth_meth_parser__apply863->definitionLine = 296;
// compiled block node returning block862 (depth = 3)
  gc_frame_newslot(block862);
// starting to compile block node (depth = 3)
  Object block868 = alloc_Block(NULL, NULL, "parser", 298);
  gc_frame_newslot(block868);
// method _apply
  block_savedest(block868);
  Object closure869 = createclosure(7, "_apply");
  setclosureframe(closure869, stackframe);
  addtoclosure(closure869, var_values);
  addtoclosure(closure869, var_anns);
  addtoclosure(closure869, var_noBlocks);
  addtoclosure(closure869, var_errormessages);
  addtoclosure(closure869, var_sym);
  addtoclosure(closure869, var_lastToken);
  addtoclosure(closure869, selfslot);
  struct UserObject *uo869 = (struct UserObject*)block868;
  uo869->data[0] = (Object)closure869;
  Method *meth_meth_parser__apply869 = addmethod2pos(block868, "_apply", &meth_parser__apply869, 0);
  int argcv_meth_parser__apply869[] = {0};
  meth_meth_parser__apply869->type = alloc_MethodType(1, argcv_meth_parser__apply869);
  meth_meth_parser__apply869->definitionModule = modulename;
  meth_meth_parser__apply869->definitionLine = 296;
// compiled block node returning block868 (depth = 3)
  gc_frame_newslot(block868);
// call case 5: prelude request
  params[0] = block862;
  params[1] = block868;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call942 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe861);
// compiled call node returning call942 (depth = 2)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe943 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe944 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe945 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call946 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe945);
// compiled call node returning call946 (depth = 5)
// compiled member node returning call946 (depth = 4)
  gc_frame_newslot(call946);
// call case 4: self request
  params[0] = call946;
  partcv[0] = 1;
  Object call947 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe944);
// compiled call node returning call947 (depth = 3)
  gc_frame_newslot(call947);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_anns (depth = 3)
  params[0] = call947;
  partcv[0] = 1;
  Object call948 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe943);
// compiled call node returning call948 (depth = 2)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_anns (depth = 2)
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser_blank949(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_util = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blank (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for blank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num953 = alloc_Float64(1);
// compiled num node returning num953 (depth = 5)
  int op_slot_right_952 = gc_frame_newslot(num953);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call956 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe955);
// compiled call node returning call956 (depth = 6)
// compiled member node returning call956 (depth = 5)
  int op_slot_left_952 = gc_frame_newslot(call956);
  params[0] = num953;
  partcv[0] = 1;
  Object sum957 = callmethod(call956, "+", 1, partcv, params);
// compiled op node returning sum957 (depth = 4)
  int op_slot_right_951 = gc_frame_newslot(sum957);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call960 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe959);
// compiled call node returning call960 (depth = 5)
// compiled member node returning call960 (depth = 4)
  int op_slot_left_951 = gc_frame_newslot(call960);
  params[0] = sum957;
  partcv[0] = 1;
  Object opresult961 = callmethod(call960, ">", 1, partcv, params);
// compiled op node returning opresult961 (depth = 3)
  Object if950 = done;
  if (istrue(opresult961)) {
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num964 = alloc_Float64(0);
// compiled num node returning num964 (depth = 5)
  int op_slot_right_963 = gc_frame_newslot(num964);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe966 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call967 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe966);
// compiled call node returning call967 (depth = 6)
// compiled member node returning call967 (depth = 5)
  int op_slot_left_963 = gc_frame_newslot(call967);
  params[0] = num964;
  partcv[0] = 1;
  Object opresult968 = callmethod(call967, ">", 1, partcv, params);
// compiled op node returning opresult968 (depth = 4)
  Object if962 = done;
  if (istrue(opresult968)) {
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit971 == NULL) {
    strlit971 = alloc_String("blank");
    gc_root(strlit971);
  }
// compiled string node returning strlit971 (depth = 6)
  int op_slot_right_970 = gc_frame_newslot(strlit971);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe973 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call975 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe974);
// compiled call node returning call975 (depth = 9)
// compiled member node returning call975 (depth = 8)
  partcv[0] = 0;
  Object call976 = callmethod(call975, "kind",
    1, partcv, params);
  gc_frame_end(callframe973);
// compiled call node returning call976 (depth = 7)
// compiled member node returning call976 (depth = 6)
  int op_slot_left_970 = gc_frame_newslot(call976);
  params[0] = strlit971;
  partcv[0] = 1;
  Object opresult977 = callmethod(call976, "!=", 1, partcv, params);
// compiled op node returning opresult977 (depth = 5)
  Object if969 = done;
  if (istrue(opresult977)) {
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe978 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num980 = alloc_Float64(1);
// compiled num node returning num980 (depth = 7)
  int op_slot_right_979 = gc_frame_newslot(num980);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe982 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call983 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe982);
// compiled call node returning call983 (depth = 8)
// compiled member node returning call983 (depth = 7)
  int op_slot_left_979 = gc_frame_newslot(call983);
  params[0] = num980;
  partcv[0] = 1;
  Object sum984 = callmethod(call983, "+", 1, partcv, params);
// compiled op node returning sum984 (depth = 6)
  gc_frame_newslot(sum984);
// starting to compile num node (depth = 6)
  Object num985 = alloc_Float64(0);
// compiled num node returning num985 (depth = 6)
  gc_frame_newslot(num985);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  params[0] = sum984;
  params[1] = num985;
  partcv[0] = 2;
  Object call986 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe978);
// compiled call node returning call986 (depth = 5)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe987 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe988 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call990 = callmethod(*var_ast, "blankNode",
    1, partcv, params);
  gc_frame_end(callframe989);
// compiled call node returning call990 (depth = 9)
// compiled member node returning call990 (depth = 8)
  partcv[0] = 0;
  Object call991 = callmethod(call990, "new",
    1, partcv, params);
  gc_frame_end(callframe988);
// compiled call node returning call991 (depth = 7)
// compiled member node returning call991 (depth = 6)
  gc_frame_newslot(call991);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = call991;
  partcv[0] = 1;
  Object call992 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe987);
// compiled call node returning call992 (depth = 5)
    gc_frame_newslot(call992);
    if969 = call992;
  } else {
  }
// compiled if node returning if969 (depth = 4)
    gc_frame_newslot(if969);
    if962 = if969;
  } else {
  }
// compiled if node returning if962 (depth = 3)
    gc_frame_newslot(if962);
    if950 = if962;
  } else {
  }
// compiled if node returning if950 (depth = 2)
  gc_frame_end(frame);
  return if950;
}
Object meth_parser__apply1007(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1009 == NULL) {
    strlit1009 = alloc_String("type");
    gc_root(strlit1009);
  }
// compiled string node returning strlit1009 (depth = 7)
  int op_slot_right_1008 = gc_frame_newslot(strlit1009);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1011 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1012 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1011);
// compiled call node returning call1012 (depth = 8)
// compiled member node returning call1012 (depth = 7)
  int op_slot_left_1008 = gc_frame_newslot(call1012);
  params[0] = strlit1009;
  partcv[0] = 1;
  Object opresult1013 = callmethod(call1012, "==", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 6)
  gc_frame_end(frame);
  return opresult1013;
}
Object meth_parser_dotypeterm993(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotypeterm (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dotypeterm");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe995 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit996 == NULL) {
    strlit996 = alloc_String("identifier");
    gc_root(strlit996);
  }
// compiled string node returning strlit996 (depth = 4)
  gc_frame_newslot(strlit996);
// call case 4: self request
  params[0] = strlit996;
  partcv[0] = 1;
  Object call997 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe995);
// compiled call node returning call997 (depth = 3)
  Object if994 = done;
  if (istrue(call997)) {
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe998 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call999 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe998);
// compiled call node returning call999 (depth = 4)
// compiled member node returning call999 (depth = 3)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1000 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1001 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1000);
// compiled call node returning call1001 (depth = 4)
// compiled member node returning call1001 (depth = 3)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1002 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1003 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1002);
// compiled call node returning call1003 (depth = 3)
    gc_frame_newslot(call1003);
    if994 = call1003;
  } else {
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1005 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block1006 = alloc_Block(NULL, NULL, "parser", 339);
  gc_frame_newslot(block1006);
// method _apply
  block_savedest(block1006);
  Object closure1007 = createclosure(2, "_apply");
  setclosureframe(closure1007, stackframe);
  addtoclosure(closure1007, var_sym);
  addtoclosure(closure1007, selfslot);
  struct UserObject *uo1007 = (struct UserObject*)block1006;
  uo1007->data[0] = (Object)closure1007;
  Method *meth_meth_parser__apply1007 = addmethod2pos(block1006, "_apply", &meth_parser__apply1007, 0);
  int argcv_meth_parser__apply1007[] = {0};
  meth_meth_parser__apply1007->type = alloc_MethodType(1, argcv_meth_parser__apply1007);
  meth_meth_parser__apply1007->definitionModule = modulename;
  meth_meth_parser__apply1007->definitionLine = 336;
// compiled block node returning block1006 (depth = 5)
  gc_frame_newslot(block1006);
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe1015 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1016 == NULL) {
    strlit1016 = alloc_String("keyword");
    gc_root(strlit1016);
  }
// compiled string node returning strlit1016 (depth = 6)
  gc_frame_newslot(strlit1016);
// call case 4: self request
  params[0] = strlit1016;
  partcv[0] = 1;
  Object call1017 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1015);
// compiled call node returning call1017 (depth = 5)
  params[0] = block1006;
  partcv[0] = 1;
  Object call1018 = callmethod(call1017, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe1005);
// compiled call node returning call1018 (depth = 4)
  Object if1004 = done;
  if (istrue(call1018)) {
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1019 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1020 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1019);
// compiled call node returning call1020 (depth = 5)
// compiled member node returning call1020 (depth = 4)
    gc_frame_newslot(call1020);
    if1004 = call1020;
  } else {
  }
// compiled if node returning if1004 (depth = 3)
    gc_frame_newslot(if1004);
    if994 = if1004;
  }
// compiled if node returning if994 (depth = 2)
  gc_frame_end(frame);
  return if994;
}
Object meth_parser__apply1035(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1037 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1036);
// compiled call node returning call1037 (depth = 9)
// compiled member node returning call1037 (depth = 8)
  gc_frame_end(frame);
  return call1037;
}
Object meth_parser_typeexpression1021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_noBlocks = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeexpression (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeexpression");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
  Object *var_prevStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "prevStatementToken");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1022 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call1023 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1022);
// compiled call node returning call1023 (depth = 4)
// compiled member node returning call1023 (depth = 3)
  *var_sz = call1023;
  if (call1023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1025 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1026 == NULL) {
    strlit1026 = alloc_String("lparen");
    gc_root(strlit1026);
  }
// compiled string node returning strlit1026 (depth = 4)
  gc_frame_newslot(strlit1026);
// call case 4: self request
  params[0] = strlit1026;
  partcv[0] = 1;
  Object call1027 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1025);
// compiled call node returning call1027 (depth = 3)
  Object if1024 = done;
  if (istrue(call1027)) {
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_prevStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1030 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1029);
// compiled call node returning call1030 (depth = 4)
// compiled member node returning call1030 (depth = 3)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1032 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1033 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1034 = alloc_Block(NULL, NULL, "parser", 351);
  gc_frame_newslot(block1034);
// method _apply
  block_savedest(block1034);
  Object closure1035 = createclosure(1, "_apply");
  setclosureframe(closure1035, stackframe);
  addtoclosure(closure1035, selfslot);
  struct UserObject *uo1035 = (struct UserObject*)block1034;
  uo1035->data[0] = (Object)closure1035;
  Method *meth_meth_parser__apply1035 = addmethod2pos(block1034, "_apply", &meth_parser__apply1035, 0);
  int argcv_meth_parser__apply1035[] = {0};
  meth_meth_parser__apply1035->type = alloc_MethodType(1, argcv_meth_parser__apply1035);
  meth_meth_parser__apply1035->definitionModule = modulename;
  meth_meth_parser__apply1035->definitionLine = 351;
// compiled block node returning block1034 (depth = 7)
  gc_frame_newslot(block1034);
// call case 4: self request
  params[0] = block1034;
  partcv[0] = 1;
  Object call1039 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1033);
// compiled call node returning call1039 (depth = 6)
  partcv[0] = 0;
  Object call1040 = callmethod(call1039, "not",
    1, partcv, params);
  gc_frame_end(callframe1032);
// compiled call node returning call1040 (depth = 5)
// compiled member node returning call1040 (depth = 4)
  Object if1031 = done;
  if (istrue(call1040)) {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1041 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1043 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1042);
// compiled call node returning call1043 (depth = 8)
// compiled member node returning call1043 (depth = 7)
  partcv[0] = 0;
  Object call1044 = callmethod(call1043, "new",
    1, partcv, params);
  gc_frame_end(callframe1041);
// compiled call node returning call1044 (depth = 6)
// compiled member node returning call1044 (depth = 5)
  *var_suggestion = call1044;
  if (call1044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1045 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1046 == NULL) {
    strlit1046 = alloc_String("rparen");
    gc_root(strlit1046);
  }
// compiled string node returning strlit1046 (depth = 6)
  gc_frame_newslot(strlit1046);
// call case 4: self request
  params[0] = strlit1046;
  partcv[0] = 1;
  Object call1047 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1045);
// compiled call node returning call1047 (depth = 5)
  *var_nextTok = call1047;
  if (call1047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_1049 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1049 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1051 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1051 (depth = 5)
  Object if1048 = done;
  if (istrue(opresult1051)) {
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1052 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1053 == NULL) {
    strlit1053 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1053);
  }
// compiled string node returning strlit1053 (depth = 6)
  gc_frame_newslot(strlit1053);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1053;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1054 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1052);
// compiled call node returning call1054 (depth = 5)
    gc_frame_newslot(call1054);
    if1048 = call1054;
  } else {
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1055 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call1057 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1056);
// compiled call node returning call1057 (depth = 7)
// compiled member node returning call1057 (depth = 6)
  gc_frame_newslot(call1057);
// starting to compile identifier node (depth = 6)
  Object bool1058 = alloc_Boolean(1);
// compiled identifier node returning bool1058 (depth = 6)
  gc_frame_newslot(bool1058);
// starting to compile identifier node (depth = 6)
  Object bool1059 = alloc_Boolean(0);
// compiled identifier node returning bool1059 (depth = 6)
  gc_frame_newslot(bool1059);
// starting to compile string node (depth = 6)
  if (strlit1060 == NULL) {
    strlit1060 = alloc_String("""\xc2""""\xab""type expression""\xc2""""\xbb""");
    gc_root(strlit1060);
  }
// compiled string node returning strlit1060 (depth = 6)
  gc_frame_newslot(strlit1060);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call1057;
  params[2] = bool1058;
  params[3] = bool1059;
  params[4] = strlit1060;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1061 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1055);
// compiled call node returning call1061 (depth = 5)
    gc_frame_newslot(call1061);
    if1048 = call1061;
  }
// compiled if node returning if1048 (depth = 4)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1062 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1063 == NULL) {
    strlit1063 = alloc_String("Parentheses must contain a valid type expression.");
    gc_root(strlit1063);
  }
// compiled string node returning strlit1063 (depth = 5)
  gc_frame_newslot(strlit1063);
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1065 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1064);
// compiled call node returning call1065 (depth = 6)
// compiled member node returning call1065 (depth = 5)
  gc_frame_newslot(call1065);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1066 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1067 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1066);
// compiled call node returning call1067 (depth = 6)
// compiled member node returning call1067 (depth = 5)
  gc_frame_newslot(call1067);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1063;
  params[1] = call1065;
  params[2] = call1067;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1068 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1062);
// compiled call node returning call1068 (depth = 4)
    gc_frame_newslot(call1068);
    if1031 = call1068;
  } else {
  }
// compiled if node returning if1031 (depth = 3)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1071 == NULL) {
    strlit1071 = alloc_String("rparen");
    gc_root(strlit1071);
  }
// compiled string node returning strlit1071 (depth = 5)
  int op_slot_right_1070 = gc_frame_newslot(strlit1071);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1073 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1074 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1073);
// compiled call node returning call1074 (depth = 6)
// compiled member node returning call1074 (depth = 5)
  int op_slot_left_1070 = gc_frame_newslot(call1074);
  params[0] = strlit1071;
  partcv[0] = 1;
  Object opresult1075 = callmethod(call1074, "!=", 1, partcv, params);
// compiled op node returning opresult1075 (depth = 4)
  Object if1069 = done;
  if (istrue(opresult1075)) {
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1076 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1077 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1076);
// compiled call node returning call1077 (depth = 5)
// compiled member node returning call1077 (depth = 4)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1078 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1079 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1080 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1079);
// compiled call node returning call1080 (depth = 8)
// compiled member node returning call1080 (depth = 7)
  partcv[0] = 0;
  Object call1081 = callmethod(call1080, "new",
    1, partcv, params);
  gc_frame_end(callframe1078);
// compiled call node returning call1081 (depth = 6)
// compiled member node returning call1081 (depth = 5)
  *var_suggestion = call1081;
  if (call1081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1082 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1083 == NULL) {
    strlit1083 = alloc_String(")");
    gc_root(strlit1083);
  }
// compiled string node returning strlit1083 (depth = 5)
  gc_frame_newslot(strlit1083);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1083;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1084 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1082);
// compiled call node returning call1084 (depth = 4)
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1085 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1086 == NULL) {
    strlit1086 = alloc_String("A type expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1086);
  }
// compiled string node returning strlit1086 (depth = 5)
  gc_frame_newslot(strlit1086);
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1088 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1087);
// compiled call node returning call1088 (depth = 6)
// compiled member node returning call1088 (depth = 5)
  gc_frame_newslot(call1088);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1091 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1090);
// compiled call node returning call1091 (depth = 7)
// compiled member node returning call1091 (depth = 6)
  int op_slot_right_1089 = gc_frame_newslot(call1091);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1093 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1094 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1093);
// compiled call node returning call1094 (depth = 7)
// compiled member node returning call1094 (depth = 6)
  int op_slot_left_1089 = gc_frame_newslot(call1094);
  params[0] = call1091;
  partcv[0] = 1;
  Object sum1095 = callmethod(call1094, "+", 1, partcv, params);
// compiled op node returning sum1095 (depth = 5)
  gc_frame_newslot(sum1095);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1086;
  params[1] = call1088;
  params[2] = sum1095;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1096 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1085);
// compiled call node returning call1096 (depth = 4)
    gc_frame_newslot(call1096);
    if1069 = call1096;
  } else {
  }
// compiled if node returning if1069 (depth = 3)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_prevStatementToken (depth = 4)
  *var_statementToken = *var_prevStatementToken;
  if (*var_prevStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1098 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1099 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1098);
// compiled call node returning call1099 (depth = 4)
// compiled member node returning call1099 (depth = 3)
    gc_frame_newslot(call1099);
    if1024 = call1099;
  } else {
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1101 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1100);
// compiled call node returning call1101 (depth = 4)
// compiled member node returning call1101 (depth = 3)
    gc_frame_newslot(call1101);
    if1024 = call1101;
  }
// compiled if node returning if1024 (depth = 2)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_1103 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1105 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1106 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1105);
// compiled call node returning call1106 (depth = 5)
// compiled member node returning call1106 (depth = 4)
  int op_slot_left_1103 = gc_frame_newslot(call1106);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult1107 = callmethod(call1106, ">", 1, partcv, params);
// compiled op node returning opresult1107 (depth = 3)
  Object if1102 = done;
  if (istrue(opresult1107)) {
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1108 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call1109 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1108);
// compiled call node returning call1109 (depth = 3)
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1110 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1111 = callmethodflags(self, "typeexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1110);
// compiled call node returning call1111 (depth = 4)
// compiled member node returning call1111 (depth = 3)
    gc_frame_newslot(call1111);
    if1102 = call1111;
  } else {
  }
// compiled if node returning if1102 (depth = 2)
  gc_frame_end(frame);
  return if1102;
}
Object meth_parser_newIf1112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "newIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method newIf");
  Object params[3];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for newIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenList = &(stackframe->slots[1]);
  *var_thenList = args[curarg];
  curarg++;
  Object *var_elseList = &(stackframe->slots[2]);
  *var_elseList = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for newIf");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_thenBlock = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "thenBlock");
  Object *var_elseBlock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "elseBlock");
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1113 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array1114 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1114 (depth = 4)
  gc_frame_newslot(array1114);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_thenList (depth = 4)
  gc_frame_newslot(*var_thenList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1116 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1115);
// compiled call node returning call1116 (depth = 5)
// compiled member node returning call1116 (depth = 4)
  params[0] = array1114;
  params[1] = *var_thenList;
  partcv[0] = 2;
  Object call1117 = callmethod(call1116, "new",
    1, partcv, params);
  gc_frame_end(callframe1113);
// compiled call node returning call1117 (depth = 3)
  *var_thenBlock = call1117;
  if (call1117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1118 = gc_frame_new();
// starting to compile array node (depth = 4)
  Object array1119 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1119 (depth = 4)
  gc_frame_newslot(array1119);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseList (depth = 4)
  gc_frame_newslot(*var_elseList);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1120 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call1121 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1120);
// compiled call node returning call1121 (depth = 5)
// compiled member node returning call1121 (depth = 4)
  params[0] = array1119;
  params[1] = *var_elseList;
  partcv[0] = 2;
  Object call1122 = callmethod(call1121, "new",
    1, partcv, params);
  gc_frame_end(callframe1118);
// compiled call node returning call1122 (depth = 3)
  *var_elseBlock = call1122;
  if (call1122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1123 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cond (depth = 3)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_thenBlock (depth = 3)
  gc_frame_newslot(*var_thenBlock);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elseBlock (depth = 3)
  gc_frame_newslot(*var_elseBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1124 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ast (depth = 5)
  partcv[0] = 0;
  Object call1125 = callmethod(*var_ast, "ifNode",
    1, partcv, params);
  gc_frame_end(callframe1124);
// compiled call node returning call1125 (depth = 4)
// compiled member node returning call1125 (depth = 3)
  params[0] = *var_cond;
  params[1] = *var_thenBlock;
  params[2] = *var_elseBlock;
  partcv[0] = 3;
  Object call1126 = callmethod(call1125, "new",
    1, partcv, params);
  gc_frame_end(callframe1123);
// compiled call node returning call1126 (depth = 2)
  gc_frame_end(frame);
  return call1126;
}
Object meth_parser__apply1156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe1157 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1158 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1157);
// compiled call node returning call1158 (depth = 5)
  gc_frame_end(frame);
  return call1158;
}
Object meth_parser__apply1193(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe1194 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1195 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1194);
// compiled call node returning call1195 (depth = 12)
  gc_frame_end(frame);
  return call1195;
}
Object meth_parser__apply1268(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe1269 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1270 == NULL) {
    strlit1270 = alloc_String("comma");
    gc_root(strlit1270);
  }
// compiled string node returning strlit1270 (depth = 10)
  gc_frame_newslot(strlit1270);
// call case 4: self request
  params[0] = strlit1270;
  partcv[0] = 1;
  Object call1271 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1269);
// compiled call node returning call1271 (depth = 9)
  gc_frame_end(frame);
  return call1271;
}
Object meth_parser__apply1278(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1280 == NULL) {
    strlit1280 = alloc_String("arrow");
    gc_root(strlit1280);
  }
// compiled string node returning strlit1280 (depth = 11)
  int op_slot_right_1279 = gc_frame_newslot(strlit1280);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1283 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1282);
// compiled call node returning call1283 (depth = 12)
// compiled member node returning call1283 (depth = 11)
  int op_slot_left_1279 = gc_frame_newslot(call1283);
  params[0] = strlit1280;
  partcv[0] = 1;
  Object opresult1284 = callmethod(call1283, "==", 1, partcv, params);
// compiled op node returning opresult1284 (depth = 10)
  gc_frame_end(frame);
  return opresult1284;
}
Object meth_parser__apply1326(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1327 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1328 == NULL) {
    strlit1328 = alloc_String("comma");
    gc_root(strlit1328);
  }
// compiled string node returning strlit1328 (depth = 9)
  gc_frame_newslot(strlit1328);
// call case 4: self request
  params[0] = strlit1328;
  partcv[0] = 1;
  Object call1329 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1327);
// compiled call node returning call1329 (depth = 8)
  gc_frame_end(frame);
  return call1329;
}
Object meth_parser__apply1332(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1334 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1333);
// compiled call node returning call1334 (depth = 9)
// compiled member node returning call1334 (depth = 8)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1335 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1336 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1335);
// compiled call node returning call1336 (depth = 9)
// compiled member node returning call1336 (depth = 8)
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1337 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1338 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1337);
// compiled call node returning call1338 (depth = 10)
// compiled member node returning call1338 (depth = 9)
  *var_expr1 = call1338;
  if (call1338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1340 = gc_frame_new();
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool1341 = alloc_Boolean(1);
// compiled identifier node returning bool1341 (depth = 10)
  gc_frame_newslot(bool1341);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  params[0] = bool1341;
  partcv[0] = 1;
  Object call1342 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1340);
// compiled call node returning call1342 (depth = 9)
// compiled bind node returning done (depth = 8)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1344 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1345 == NULL) {
    strlit1345 = alloc_String("colon");
    gc_root(strlit1345);
  }
// compiled string node returning strlit1345 (depth = 10)
  gc_frame_newslot(strlit1345);
// call case 4: self request
  params[0] = strlit1345;
  partcv[0] = 1;
  Object call1346 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1344);
// compiled call node returning call1346 (depth = 9)
  Object if1343 = done;
  if (istrue(call1346)) {
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1347 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1348 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1347);
// compiled call node returning call1348 (depth = 10)
// compiled member node returning call1348 (depth = 9)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1350 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1349);
// compiled call node returning call1350 (depth = 10)
// compiled member node returning call1350 (depth = 9)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1351 = gc_frame_new();
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1352 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  partcv[0] = 0;
  Object call1353 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1352);
// compiled call node returning call1353 (depth = 12)
// compiled member node returning call1353 (depth = 11)
  gc_frame_newslot(call1353);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_expr1 (depth = 11)
  params[0] = call1353;
  partcv[0] = 1;
  Object call1354 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1351);
// compiled call node returning call1354 (depth = 10)
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1343 = done;
  } else {
  }
// compiled if node returning if1343 (depth = 8)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1355 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1356 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1355);
// compiled call node returning call1356 (depth = 8)
  gc_frame_end(frame);
  return call1356;
}
Object meth_parser__apply1471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 13)
  int callframe1472 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_blocksOK (depth = 14)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1473 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1472);
// compiled call node returning call1473 (depth = 13)
  gc_frame_end(frame);
  return call1473;
}
Object meth_parser__apply1161(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_expr1 = getfromclosure(closure, 1);
  Object *var_braceIsType = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_params = getfromclosure(closure, 7);
  Object *var_isMatchingBlock = getfromclosure(closure, 8);
  Object *var_body = getfromclosure(closure, 9);
  Object *var_indentFreePass = getfromclosure(closure, 10);
  Object *var_ast = getfromclosure(closure, 11);
  Object self = *(getfromclosure(closure, 12));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arrow = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arrow");
  Object *var_lhs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lhs");
  Object *var_rhs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rhs");
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1164 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1165 == NULL) {
    strlit1165 = alloc_String("colon");
    gc_root(strlit1165);
  }
// compiled string node returning strlit1165 (depth = 8)
  gc_frame_newslot(strlit1165);
// call case 4: self request
  params[0] = strlit1165;
  partcv[0] = 1;
  Object call1166 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled call node returning call1166 (depth = 7)
  int op_slot_right_1163 = gc_frame_newslot(call1166);
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1169 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1170 == NULL) {
    strlit1170 = alloc_String("arrow");
    gc_root(strlit1170);
  }
// compiled string node returning strlit1170 (depth = 9)
  gc_frame_newslot(strlit1170);
// call case 4: self request
  params[0] = strlit1170;
  partcv[0] = 1;
  Object call1171 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1169);
// compiled call node returning call1171 (depth = 8)
  int op_slot_right_1168 = gc_frame_newslot(call1171);
// starting to compile call node (depth = 8)
  int callframe1173 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1174 == NULL) {
    strlit1174 = alloc_String("comma");
    gc_root(strlit1174);
  }
// compiled string node returning strlit1174 (depth = 9)
  gc_frame_newslot(strlit1174);
// call case 4: self request
  params[0] = strlit1174;
  partcv[0] = 1;
  Object call1175 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1173);
// compiled call node returning call1175 (depth = 8)
  int op_slot_left_1168 = gc_frame_newslot(call1175);
  params[0] = call1171;
  partcv[0] = 1;
  Object opresult1176 = callmethod(call1175, "||", 1, partcv, params);
// compiled op node returning opresult1176 (depth = 7)
  int op_slot_left_1163 = gc_frame_newslot(opresult1176);
  params[0] = call1166;
  partcv[0] = 1;
  Object opresult1177 = callmethod(opresult1176, "||", 1, partcv, params);
// compiled op node returning opresult1177 (depth = 6)
  Object if1162 = done;
  if (istrue(opresult1177)) {
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1178 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call1179 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1178);
// compiled call node returning call1179 (depth = 8)
// compiled member node returning call1179 (depth = 7)
  *var_expr1 = call1179;
  if (call1179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1182 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1183 == NULL) {
    strlit1183 = alloc_String("colon");
    gc_root(strlit1183);
  }
// compiled string node returning strlit1183 (depth = 8)
  gc_frame_newslot(strlit1183);
// call case 4: self request
  params[0] = strlit1183;
  partcv[0] = 1;
  Object call1184 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1182);
// compiled call node returning call1184 (depth = 7)
  Object if1181 = done;
  if (istrue(call1184)) {
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1185 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1186 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1185);
// compiled call node returning call1186 (depth = 8)
// compiled member node returning call1186 (depth = 7)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool1187 = alloc_Boolean(1);
// compiled identifier node returning bool1187 (depth = 8)
  *var_braceIsType = bool1187;
  if (bool1187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1190 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe1191 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block1192 = alloc_Block(NULL, NULL, "parser", 419);
  gc_frame_newslot(block1192);
// method _apply
  block_savedest(block1192);
  Object closure1193 = createclosure(2, "_apply");
  setclosureframe(closure1193, stackframe);
  addtoclosure(closure1193, var_blocksOK);
  addtoclosure(closure1193, selfslot);
  struct UserObject *uo1193 = (struct UserObject*)block1192;
  uo1193->data[0] = (Object)closure1193;
  Method *meth_meth_parser__apply1193 = addmethod2pos(block1192, "_apply", &meth_parser__apply1193, 0);
  int argcv_meth_parser__apply1193[] = {0};
  meth_meth_parser__apply1193->type = alloc_MethodType(1, argcv_meth_parser__apply1193);
  meth_meth_parser__apply1193->definitionModule = modulename;
  meth_meth_parser__apply1193->definitionLine = 419;
// compiled block node returning block1192 (depth = 11)
  gc_frame_newslot(block1192);
// call case 4: self request
  params[0] = block1192;
  partcv[0] = 1;
  Object call1197 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compiled call node returning call1197 (depth = 10)
  partcv[0] = 0;
  Object call1198 = callmethod(call1197, "not",
    1, partcv, params);
  gc_frame_end(callframe1190);
// compiled call node returning call1198 (depth = 9)
// compiled member node returning call1198 (depth = 8)
  Object if1189 = done;
  if (istrue(call1198)) {
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array1199 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1199 (depth = 9)
  *var_suggestions = array1199;
  if (array1199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1200 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1201 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1202 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1201);
// compiled call node returning call1202 (depth = 12)
// compiled member node returning call1202 (depth = 11)
  partcv[0] = 0;
  Object call1203 = callmethod(call1202, "new",
    1, partcv, params);
  gc_frame_end(callframe1200);
// compiled call node returning call1203 (depth = 10)
// compiled member node returning call1203 (depth = 9)
  *var_suggestion = call1203;
  if (call1203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1204 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1205 == NULL) {
    strlit1205 = alloc_String("arrow");
    gc_root(strlit1205);
  }
// compiled string node returning strlit1205 (depth = 10)
  gc_frame_newslot(strlit1205);
// starting to compile string node (depth = 10)
  if (strlit1206 == NULL) {
    strlit1206 = alloc_String("rbrace");
    gc_root(strlit1206);
  }
// compiled string node returning strlit1206 (depth = 10)
  gc_frame_newslot(strlit1206);
// call case 4: self request
  params[0] = strlit1205;
  params[1] = strlit1206;
  partcv[0] = 2;
  Object call1207 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1204);
// compiled call node returning call1207 (depth = 9)
  *var_nextTok = call1207;
  if (call1207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1209 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1209 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1211 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1211 (depth = 9)
  Object if1208 = done;
  if (istrue(opresult1211)) {
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1212 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1213 == NULL) {
    strlit1213 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1213);
  }
// compiled string node returning strlit1213 (depth = 10)
  gc_frame_newslot(strlit1213);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1213;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1214 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1212);
// compiled call node returning call1214 (depth = 9)
    gc_frame_newslot(call1214);
    if1208 = call1214;
  } else {
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1215 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1216 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1217 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1216);
// compiled call node returning call1217 (depth = 11)
// compiled member node returning call1217 (depth = 10)
  gc_frame_newslot(call1217);
// starting to compile identifier node (depth = 10)
  Object bool1218 = alloc_Boolean(1);
// compiled identifier node returning bool1218 (depth = 10)
  gc_frame_newslot(bool1218);
// starting to compile identifier node (depth = 10)
  Object bool1219 = alloc_Boolean(0);
// compiled identifier node returning bool1219 (depth = 10)
  gc_frame_newslot(bool1219);
// starting to compile string node (depth = 10)
  if (strlit1220 == NULL) {
    strlit1220 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1220);
  }
// compiled string node returning strlit1220 (depth = 10)
  gc_frame_newslot(strlit1220);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call1217;
  params[2] = bool1218;
  params[3] = bool1219;
  params[4] = strlit1220;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1221 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1215);
// compiled call node returning call1221 (depth = 9)
    gc_frame_newslot(call1221);
    if1208 = call1221;
  }
// compiled if node returning if1208 (depth = 8)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1222 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1223 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1222);
// compiled call node returning call1223 (depth = 8)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1224 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1226 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1225);
// compiled call node returning call1226 (depth = 12)
// compiled member node returning call1226 (depth = 11)
  partcv[0] = 0;
  Object call1227 = callmethod(call1226, "new",
    1, partcv, params);
  gc_frame_end(callframe1224);
// compiled call node returning call1227 (depth = 10)
// compiled member node returning call1227 (depth = 9)
  *var_suggestion = call1227;
  if (call1227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1229 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1230 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1231 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1230);
// compiled call node returning call1231 (depth = 10)
// compiled member node returning call1231 (depth = 9)
  gc_frame_newslot(call1231);
// starting to compile identifier node (depth = 9)
  Object bool1232 = alloc_Boolean(1);
// compiled identifier node returning bool1232 (depth = 9)
  gc_frame_newslot(bool1232);
// starting to compile identifier node (depth = 9)
  Object bool1233 = alloc_Boolean(0);
// compiled identifier node returning bool1233 (depth = 9)
  gc_frame_newslot(bool1233);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call1231;
  params[2] = bool1232;
  params[3] = bool1233;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1234 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1229);
// compiled call node returning call1234 (depth = 8)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1235 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1236 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1235);
// compiled call node returning call1236 (depth = 8)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1237 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1238 == NULL) {
    strlit1238 = alloc_String("A block must have an expression after the ':'.");
    gc_root(strlit1238);
  }
// compiled string node returning strlit1238 (depth = 9)
  gc_frame_newslot(strlit1238);
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1240 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1239);
// compiled call node returning call1240 (depth = 10)
// compiled member node returning call1240 (depth = 9)
  gc_frame_newslot(call1240);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1241 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call1242 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1241);
// compiled call node returning call1242 (depth = 10)
// compiled member node returning call1242 (depth = 9)
  gc_frame_newslot(call1242);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit1238;
  params[1] = call1240;
  params[2] = call1242;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1243 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1237);
// compiled call node returning call1243 (depth = 8)
    gc_frame_newslot(call1243);
    if1189 = call1243;
  } else {
  }
// compiled if node returning if1189 (depth = 7)
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool1244 = alloc_Boolean(0);
// compiled identifier node returning bool1244 (depth = 8)
  *var_braceIsType = bool1244;
  if (bool1244 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1246 = gc_frame_new();
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1247 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1248 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1247);
// compiled call node returning call1248 (depth = 10)
// compiled member node returning call1248 (depth = 9)
  gc_frame_newslot(call1248);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = call1248;
  partcv[0] = 1;
  Object call1249 = callmethod(*var_expr1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1246);
// compiled call node returning call1249 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1181 = done;
  } else {
  }
// compiled if node returning if1181 (depth = 6)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1250 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr1 (depth = 7)
  gc_frame_newslot(*var_expr1);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_params (depth = 7)
  params[0] = *var_expr1;
  partcv[0] = 1;
  Object call1251 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1250);
// compiled call node returning call1251 (depth = 6)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1254 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_expr1 (depth = 10)
  partcv[0] = 0;
  Object call1255 = callmethod(*var_expr1, "isIdentifier",
    1, partcv, params);
  gc_frame_end(callframe1254);
// compiled call node returning call1255 (depth = 9)
// compiled member node returning call1255 (depth = 8)
  int op_slot_right_1253 = gc_frame_newslot(call1255);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1257 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_isMatchingBlock (depth = 10)
  partcv[0] = 0;
  Object call1258 = callmethod(*var_isMatchingBlock, "not",
    1, partcv, params);
  gc_frame_end(callframe1257);
// compiled call node returning call1258 (depth = 9)
// compiled member node returning call1258 (depth = 8)
  int op_slot_left_1253 = gc_frame_newslot(call1258);
  params[0] = call1255;
  partcv[0] = 1;
  Object opresult1259 = callmethod(call1258, "&&", 1, partcv, params);
// compiled op node returning opresult1259 (depth = 7)
  Object if1252 = done;
  if (istrue(opresult1259)) {
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1260 = gc_frame_new();
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool1261 = alloc_Boolean(1);
// compiled identifier node returning bool1261 (depth = 9)
  gc_frame_newslot(bool1261);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr1 (depth = 9)
  params[0] = bool1261;
  partcv[0] = 1;
  Object call1262 = callmethod(*var_expr1, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe1260);
// compiled call node returning call1262 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1252 = done;
  } else {
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool1263 = alloc_Boolean(1);
// compiled identifier node returning bool1263 (depth = 8)
  *var_isMatchingBlock = bool1263;
  if (bool1263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if1252 = done;
  }
// compiled if node returning if1252 (depth = 6)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1267 = alloc_Block(NULL, NULL, "parser", 444);
  gc_frame_newslot(block1267);
// method _apply
  block_savedest(block1267);
  Object closure1268 = createclosure(1, "_apply");
  setclosureframe(closure1268, stackframe);
  addtoclosure(closure1268, selfslot);
  struct UserObject *uo1268 = (struct UserObject*)block1267;
  uo1268->data[0] = (Object)closure1268;
  Method *meth_meth_parser__apply1268 = addmethod2pos(block1267, "_apply", &meth_parser__apply1268, 0);
  int argcv_meth_parser__apply1268[] = {0};
  meth_meth_parser__apply1268->type = alloc_MethodType(1, argcv_meth_parser__apply1268);
  meth_meth_parser__apply1268->definitionModule = modulename;
  meth_meth_parser__apply1268->definitionLine = 439;
// compiled block node returning block1267 (depth = 8)
  int op_slot_right_1266 = gc_frame_newslot(block1267);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isMatchingBlock (depth = 8)
  int op_slot_left_1266 = gc_frame_newslot(*var_isMatchingBlock);
  params[0] = block1267;
  partcv[0] = 1;
  Object opresult1274 = callmethod(*var_isMatchingBlock, "&&", 1, partcv, params);
// compiled op node returning opresult1274 (depth = 7)
  Object if1265 = done;
  if (istrue(opresult1274)) {
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array1275 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1275 (depth = 8)
  *var_suggestions = array1275;
  if (array1275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 7)
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1276 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1277 = alloc_Block(NULL, NULL, "parser", 447);
  gc_frame_newslot(block1277);
// method _apply
  block_savedest(block1277);
  Object closure1278 = createclosure(1, "_apply");
  setclosureframe(closure1278, stackframe);
  addtoclosure(closure1278, selfslot);
  struct UserObject *uo1278 = (struct UserObject*)block1277;
  uo1278->data[0] = (Object)closure1278;
  Method *meth_meth_parser__apply1278 = addmethod2pos(block1277, "_apply", &meth_parser__apply1278, 0);
  int argcv_meth_parser__apply1278[] = {1};
  meth_meth_parser__apply1278->type = alloc_MethodType(1, argcv_meth_parser__apply1278);
  meth_meth_parser__apply1278->definitionModule = modulename;
  meth_meth_parser__apply1278->definitionLine = 439;
// compiled block node returning block1277 (depth = 9)
  gc_frame_newslot(block1277);
// call case 4: self request
  params[0] = block1277;
  partcv[0] = 1;
  Object call1286 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1276);
// compiled call node returning call1286 (depth = 8)
  *var_arrow = call1286;
  if (call1286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool1289 = alloc_Boolean(0);
// compiled identifier node returning bool1289 (depth = 9)
  int op_slot_right_1288 = gc_frame_newslot(bool1289);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arrow (depth = 9)
  int op_slot_left_1288 = gc_frame_newslot(*var_arrow);
  params[0] = bool1289;
  partcv[0] = 1;
  Object opresult1291 = callmethod(*var_arrow, "!=", 1, partcv, params);
// compiled op node returning opresult1291 (depth = 8)
  Object if1287 = done;
  if (istrue(opresult1291)) {
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1292 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call1294 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1293);
// compiled call node returning call1294 (depth = 12)
// compiled member node returning call1294 (depth = 11)
  partcv[0] = 0;
  Object call1295 = callmethod(call1294, "new",
    1, partcv, params);
  gc_frame_end(callframe1292);
// compiled call node returning call1295 (depth = 10)
// compiled member node returning call1295 (depth = 9)
  *var_suggestion = call1295;
  if (call1295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1297 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arrow (depth = 11)
  partcv[0] = 0;
  Object call1299 = callmethod(*var_arrow, "prev",
    1, partcv, params);
  gc_frame_end(callframe1298);
// compiled call node returning call1299 (depth = 10)
// compiled member node returning call1299 (depth = 9)
  gc_frame_newslot(call1299);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call1299;
  partcv[0] = 2;
  Object call1300 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe1297);
// compiled call node returning call1300 (depth = 8)
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1301 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1302 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1301);
// compiled call node returning call1302 (depth = 8)
    gc_frame_newslot(call1302);
    if1287 = call1302;
  } else {
  }
// compiled if node returning if1287 (depth = 7)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1303 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1304 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1305 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1304);
// compiled call node returning call1305 (depth = 11)
// compiled member node returning call1305 (depth = 10)
  partcv[0] = 0;
  Object call1306 = callmethod(call1305, "new",
    1, partcv, params);
  gc_frame_end(callframe1303);
// compiled call node returning call1306 (depth = 9)
// compiled member node returning call1306 (depth = 8)
  *var_suggestion = call1306;
  if (call1306 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1308 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool1309 = alloc_Boolean(1);
// compiled identifier node returning bool1309 (depth = 8)
  gc_frame_newslot(bool1309);
// starting to compile identifier node (depth = 8)
  Object bool1310 = alloc_Boolean(0);
// compiled identifier node returning bool1310 (depth = 8)
  gc_frame_newslot(bool1310);
// starting to compile string node (depth = 8)
  if (strlit1311 == NULL) {
    strlit1311 = alloc_String(" |");
    gc_root(strlit1311);
  }
// compiled string node returning strlit1311 (depth = 8)
  gc_frame_newslot(strlit1311);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool1309;
  params[2] = bool1310;
  params[3] = strlit1311;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1312 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1308);
// compiled call node returning call1312 (depth = 7)
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1313 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1314 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1313);
// compiled call node returning call1314 (depth = 7)
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1315 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1316 == NULL) {
    strlit1316 = alloc_String("A matching block may only have one parameter.");
    gc_root(strlit1316);
  }
// compiled string node returning strlit1316 (depth = 8)
  gc_frame_newslot(strlit1316);
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1317 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1318 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1317);
// compiled call node returning call1318 (depth = 9)
// compiled member node returning call1318 (depth = 8)
  gc_frame_newslot(call1318);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1320 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1319);
// compiled call node returning call1320 (depth = 9)
// compiled member node returning call1320 (depth = 8)
  gc_frame_newslot(call1320);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1321 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1322 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1321);
// compiled call node returning call1322 (depth = 9)
// compiled member node returning call1322 (depth = 8)
  gc_frame_newslot(call1322);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1316;
  params[1] = call1318;
  params[2] = call1320;
  params[3] = call1322;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1323 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1315);
// compiled call node returning call1323 (depth = 7)
    gc_frame_newslot(call1323);
    if1265 = call1323;
  } else {
  }
// compiled if node returning if1265 (depth = 6)
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1324 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1325 = alloc_Block(NULL, NULL, "parser", 459);
  gc_frame_newslot(block1325);
// method _apply
  block_savedest(block1325);
  Object closure1326 = createclosure(1, "_apply");
  setclosureframe(closure1326, stackframe);
  addtoclosure(closure1326, selfslot);
  struct UserObject *uo1326 = (struct UserObject*)block1325;
  uo1326->data[0] = (Object)closure1326;
  Method *meth_meth_parser__apply1326 = addmethod2pos(block1325, "_apply", &meth_parser__apply1326, 0);
  int argcv_meth_parser__apply1326[] = {0};
  meth_meth_parser__apply1326->type = alloc_MethodType(1, argcv_meth_parser__apply1326);
  meth_meth_parser__apply1326->definitionModule = modulename;
  meth_meth_parser__apply1326->definitionLine = 457;
// compiled block node returning block1325 (depth = 7)
  gc_frame_newslot(block1325);
// starting to compile block node (depth = 7)
  Object block1331 = alloc_Block(NULL, NULL, "parser", 459);
  gc_frame_newslot(block1331);
// method _apply
  block_savedest(block1331);
  Object closure1332 = createclosure(4, "_apply");
  setclosureframe(closure1332, stackframe);
  addtoclosure(closure1332, var_values);
  addtoclosure(closure1332, var_expr1);
  addtoclosure(closure1332, var_params);
  addtoclosure(closure1332, selfslot);
  struct UserObject *uo1332 = (struct UserObject*)block1331;
  uo1332->data[0] = (Object)closure1332;
  Method *meth_meth_parser__apply1332 = addmethod2pos(block1331, "_apply", &meth_parser__apply1332, 0);
  int argcv_meth_parser__apply1332[] = {0};
  meth_meth_parser__apply1332->type = alloc_MethodType(1, argcv_meth_parser__apply1332);
  meth_meth_parser__apply1332->definitionModule = modulename;
  meth_meth_parser__apply1332->definitionLine = 457;
// compiled block node returning block1331 (depth = 7)
  gc_frame_newslot(block1331);
// call case 5: prelude request
  params[0] = block1325;
  params[1] = block1331;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1358 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1324);
// compiled call node returning call1358 (depth = 6)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1360 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe1361 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1362 == NULL) {
    strlit1362 = alloc_String("arrow");
    gc_root(strlit1362);
  }
// compiled string node returning strlit1362 (depth = 10)
  gc_frame_newslot(strlit1362);
// call case 4: self request
  params[0] = strlit1362;
  partcv[0] = 1;
  Object call1363 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1361);
// compiled call node returning call1363 (depth = 9)
  partcv[0] = 0;
  Object call1364 = callmethod(call1363, "not",
    1, partcv, params);
  gc_frame_end(callframe1360);
// compiled call node returning call1364 (depth = 8)
// compiled member node returning call1364 (depth = 7)
  Object if1359 = done;
  if (istrue(call1364)) {
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1365 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call1367 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1366);
// compiled call node returning call1367 (depth = 11)
// compiled member node returning call1367 (depth = 10)
  partcv[0] = 0;
  Object call1368 = callmethod(call1367, "new",
    1, partcv, params);
  gc_frame_end(callframe1365);
// compiled call node returning call1368 (depth = 9)
// compiled member node returning call1368 (depth = 8)
  *var_suggestion = call1368;
  if (call1368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("=");
    gc_root(strlit1372);
  }
// compiled string node returning strlit1372 (depth = 10)
  int op_slot_right_1371 = gc_frame_newslot(strlit1372);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1375 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1374);
// compiled call node returning call1375 (depth = 11)
// compiled member node returning call1375 (depth = 10)
  int op_slot_left_1371 = gc_frame_newslot(call1375);
  params[0] = strlit1372;
  partcv[0] = 1;
  Object opresult1376 = callmethod(call1375, "==", 1, partcv, params);
// compiled op node returning opresult1376 (depth = 9)
  int op_slot_right_1370 = gc_frame_newslot(opresult1376);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1379 == NULL) {
    strlit1379 = alloc_String("bind");
    gc_root(strlit1379);
  }
// compiled string node returning strlit1379 (depth = 10)
  int op_slot_right_1378 = gc_frame_newslot(strlit1379);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1381 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1382 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1381);
// compiled call node returning call1382 (depth = 11)
// compiled member node returning call1382 (depth = 10)
  int op_slot_left_1378 = gc_frame_newslot(call1382);
  params[0] = strlit1379;
  partcv[0] = 1;
  Object opresult1383 = callmethod(call1382, "==", 1, partcv, params);
// compiled op node returning opresult1383 (depth = 9)
  int op_slot_left_1370 = gc_frame_newslot(opresult1383);
  params[0] = opresult1376;
  partcv[0] = 1;
  Object opresult1384 = callmethod(opresult1383, "||", 1, partcv, params);
// compiled op node returning opresult1384 (depth = 8)
  Object if1369 = done;
  if (istrue(opresult1384)) {
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1385 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 9)
  if (strlit1386 == NULL) {
    strlit1386 = alloc_String("->");
    gc_root(strlit1386);
  }
// compiled string node returning strlit1386 (depth = 9)
  gc_frame_newslot(strlit1386);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = strlit1386;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1387 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe1385);
// compiled call node returning call1387 (depth = 8)
    gc_frame_newslot(call1387);
    if1369 = call1387;
  } else {
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1388 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1389 == NULL) {
    strlit1389 = alloc_String(" ->");
    gc_root(strlit1389);
  }
// compiled string node returning strlit1389 (depth = 9)
  gc_frame_newslot(strlit1389);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1389;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1390 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1388);
// compiled call node returning call1390 (depth = 8)
    gc_frame_newslot(call1390);
    if1369 = call1390;
  }
// compiled if node returning if1369 (depth = 7)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1391 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1392 == NULL) {
    strlit1392 = alloc_String("A block must have one or more parameters followed by '->' and an expression.");
    gc_root(strlit1392);
  }
// compiled string node returning strlit1392 (depth = 8)
  gc_frame_newslot(strlit1392);
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1394 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1393);
// compiled call node returning call1394 (depth = 9)
// compiled member node returning call1394 (depth = 8)
  gc_frame_newslot(call1394);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call1396 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1395);
// compiled call node returning call1396 (depth = 9)
// compiled member node returning call1396 (depth = 8)
  gc_frame_newslot(call1396);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit1392;
  params[1] = call1394;
  params[2] = call1396;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1397 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1391);
// compiled call node returning call1397 (depth = 7)
    gc_frame_newslot(call1397);
    if1359 = call1397;
  } else {
  }
// compiled if node returning if1359 (depth = 6)
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1398 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1399 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1398);
// compiled call node returning call1399 (depth = 7)
// compiled member node returning call1399 (depth = 6)
    gc_frame_newslot(call1399);
    if1162 = call1399;
  } else {
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1401 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1402 == NULL) {
    strlit1402 = alloc_String("semicolon");
    gc_root(strlit1402);
  }
// compiled string node returning strlit1402 (depth = 8)
  gc_frame_newslot(strlit1402);
// call case 4: self request
  params[0] = strlit1402;
  partcv[0] = 1;
  Object call1403 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1401);
// compiled call node returning call1403 (depth = 7)
  Object if1400 = done;
  if (istrue(call1403)) {
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1404 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call1406 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1405);
// compiled call node returning call1406 (depth = 9)
// compiled member node returning call1406 (depth = 8)
  gc_frame_newslot(call1406);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call1406;
  partcv[0] = 1;
  Object call1407 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1404);
// compiled call node returning call1407 (depth = 7)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1408 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1409 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1408);
// compiled call node returning call1409 (depth = 8)
// compiled member node returning call1409 (depth = 7)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1411 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1412 == NULL) {
    strlit1412 = alloc_String("semicolon");
    gc_root(strlit1412);
  }
// compiled string node returning strlit1412 (depth = 9)
  gc_frame_newslot(strlit1412);
// call case 4: self request
  params[0] = strlit1412;
  partcv[0] = 1;
  Object call1413 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1411);
// compiled call node returning call1413 (depth = 8)
  Object if1410 = done;
  if (istrue(call1413)) {
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1414 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1415 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1414);
// compiled call node returning call1415 (depth = 9)
// compiled member node returning call1415 (depth = 8)
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call1419 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1418);
// compiled call node returning call1419 (depth = 11)
// compiled member node returning call1419 (depth = 10)
  int op_slot_right_1417 = gc_frame_newslot(call1419);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1421 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1422 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1421);
// compiled call node returning call1422 (depth = 11)
// compiled member node returning call1422 (depth = 10)
  int op_slot_left_1417 = gc_frame_newslot(call1422);
  params[0] = call1419;
  partcv[0] = 1;
  Object opresult1423 = callmethod(call1422, "==", 1, partcv, params);
// compiled op node returning opresult1423 (depth = 9)
  Object if1416 = done;
  if (istrue(opresult1423)) {
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
  Object bool1424 = alloc_Boolean(1);
// compiled identifier node returning bool1424 (depth = 10)
  *var_indentFreePass = bool1424;
  if (bool1424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1416 = done;
  } else {
  }
// compiled if node returning if1416 (depth = 8)
    gc_frame_newslot(if1416);
    if1410 = if1416;
  } else {
  }
// compiled if node returning if1410 (depth = 7)
    gc_frame_newslot(if1410);
    if1400 = if1410;
  } else {
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1428 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1429 == NULL) {
    strlit1429 = alloc_String("bind");
    gc_root(strlit1429);
  }
// compiled string node returning strlit1429 (depth = 10)
  gc_frame_newslot(strlit1429);
// call case 4: self request
  params[0] = strlit1429;
  partcv[0] = 1;
  Object call1430 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1428);
// compiled call node returning call1430 (depth = 9)
  int op_slot_right_1427 = gc_frame_newslot(call1430);
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1434 == NULL) {
    strlit1434 = alloc_String("index");
    gc_root(strlit1434);
  }
// compiled string node returning strlit1434 (depth = 11)
  int op_slot_right_1433 = gc_frame_newslot(strlit1434);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1436 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call1438 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1437);
// compiled call node returning call1438 (depth = 14)
// compiled member node returning call1438 (depth = 13)
  partcv[0] = 0;
  Object call1439 = callmethod(call1438, "kind",
    1, partcv, params);
  gc_frame_end(callframe1436);
// compiled call node returning call1439 (depth = 12)
// compiled member node returning call1439 (depth = 11)
  int op_slot_left_1433 = gc_frame_newslot(call1439);
  params[0] = strlit1434;
  partcv[0] = 1;
  Object opresult1440 = callmethod(call1439, "==", 1, partcv, params);
// compiled op node returning opresult1440 (depth = 10)
  int op_slot_right_1432 = gc_frame_newslot(opresult1440);
// starting to compile op node (depth = 10)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1444 == NULL) {
    strlit1444 = alloc_String("identifier");
    gc_root(strlit1444);
  }
// compiled string node returning strlit1444 (depth = 12)
  int op_slot_right_1443 = gc_frame_newslot(strlit1444);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1446 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1447 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1448 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1447);
// compiled call node returning call1448 (depth = 15)
// compiled member node returning call1448 (depth = 14)
  partcv[0] = 0;
  Object call1449 = callmethod(call1448, "kind",
    1, partcv, params);
  gc_frame_end(callframe1446);
// compiled call node returning call1449 (depth = 13)
// compiled member node returning call1449 (depth = 12)
  int op_slot_left_1443 = gc_frame_newslot(call1449);
  params[0] = strlit1444;
  partcv[0] = 1;
  Object opresult1450 = callmethod(call1449, "==", 1, partcv, params);
// compiled op node returning opresult1450 (depth = 11)
  int op_slot_right_1442 = gc_frame_newslot(opresult1450);
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit1453 == NULL) {
    strlit1453 = alloc_String("member");
    gc_root(strlit1453);
  }
// compiled string node returning strlit1453 (depth = 12)
  int op_slot_right_1452 = gc_frame_newslot(strlit1453);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1455 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_values (depth = 16)
  partcv[0] = 0;
  Object call1457 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1456);
// compiled call node returning call1457 (depth = 15)
// compiled member node returning call1457 (depth = 14)
  partcv[0] = 0;
  Object call1458 = callmethod(call1457, "kind",
    1, partcv, params);
  gc_frame_end(callframe1455);
// compiled call node returning call1458 (depth = 13)
// compiled member node returning call1458 (depth = 12)
  int op_slot_left_1452 = gc_frame_newslot(call1458);
  params[0] = strlit1453;
  partcv[0] = 1;
  Object opresult1459 = callmethod(call1458, "==", 1, partcv, params);
// compiled op node returning opresult1459 (depth = 11)
  int op_slot_left_1442 = gc_frame_newslot(opresult1459);
  params[0] = opresult1450;
  partcv[0] = 1;
  Object opresult1460 = callmethod(opresult1459, "||", 1, partcv, params);
// compiled op node returning opresult1460 (depth = 10)
  int op_slot_left_1432 = gc_frame_newslot(opresult1460);
  params[0] = opresult1440;
  partcv[0] = 1;
  Object opresult1461 = callmethod(opresult1460, "||", 1, partcv, params);
// compiled op node returning opresult1461 (depth = 9)
  int op_slot_left_1427 = gc_frame_newslot(opresult1461);
  params[0] = call1430;
  partcv[0] = 1;
  Object opresult1462 = callmethod(opresult1461, "&&", 1, partcv, params);
// compiled op node returning opresult1462 (depth = 8)
  Object if1426 = done;
  if (istrue(opresult1462)) {
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1463 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1464 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1463);
// compiled call node returning call1464 (depth = 10)
// compiled member node returning call1464 (depth = 9)
  *var_lhs = call1464;
  if (call1464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1466 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1465);
// compiled call node returning call1466 (depth = 9)
// compiled member node returning call1466 (depth = 8)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1468 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe1469 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block1470 = alloc_Block(NULL, NULL, "parser", 498);
  gc_frame_newslot(block1470);
// method _apply
  block_savedest(block1470);
  Object closure1471 = createclosure(2, "_apply");
  setclosureframe(closure1471, stackframe);
  addtoclosure(closure1471, var_blocksOK);
  addtoclosure(closure1471, selfslot);
  struct UserObject *uo1471 = (struct UserObject*)block1470;
  uo1471->data[0] = (Object)closure1471;
  Method *meth_meth_parser__apply1471 = addmethod2pos(block1470, "_apply", &meth_parser__apply1471, 0);
  int argcv_meth_parser__apply1471[] = {0};
  meth_meth_parser__apply1471->type = alloc_MethodType(1, argcv_meth_parser__apply1471);
  meth_meth_parser__apply1471->definitionModule = modulename;
  meth_meth_parser__apply1471->definitionLine = 498;
// compiled block node returning block1470 (depth = 12)
  gc_frame_newslot(block1470);
// call case 4: self request
  params[0] = block1470;
  partcv[0] = 1;
  Object call1475 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1469);
// compiled call node returning call1475 (depth = 11)
  partcv[0] = 0;
  Object call1476 = callmethod(call1475, "not",
    1, partcv, params);
  gc_frame_end(callframe1468);
// compiled call node returning call1476 (depth = 10)
// compiled member node returning call1476 (depth = 9)
  Object if1467 = done;
  if (istrue(call1476)) {
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 10)
  Object array1477 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1477 (depth = 10)
  *var_suggestions = array1477;
  if (array1477 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 9)
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1478 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1479 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1480 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1479);
// compiled call node returning call1480 (depth = 13)
// compiled member node returning call1480 (depth = 12)
  partcv[0] = 0;
  Object call1481 = callmethod(call1480, "new",
    1, partcv, params);
  gc_frame_end(callframe1478);
// compiled call node returning call1481 (depth = 11)
// compiled member node returning call1481 (depth = 10)
  *var_suggestion = call1481;
  if (call1481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 9)
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1482 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1483 == NULL) {
    strlit1483 = alloc_String("rbrace");
    gc_root(strlit1483);
  }
// compiled string node returning strlit1483 (depth = 11)
  gc_frame_newslot(strlit1483);
// call case 4: self request
  params[0] = strlit1483;
  partcv[0] = 1;
  Object call1484 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1482);
// compiled call node returning call1484 (depth = 10)
  *var_nextTok = call1484;
  if (call1484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_1486 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_1486 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1488 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1488 (depth = 10)
  Object if1485 = done;
  if (istrue(opresult1488)) {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1489 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit1490 == NULL) {
    strlit1490 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1490);
  }
// compiled string node returning strlit1490 (depth = 11)
  gc_frame_newslot(strlit1490);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit1490;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1491 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1489);
// compiled call node returning call1491 (depth = 10)
    gc_frame_newslot(call1491);
    if1485 = call1491;
  } else {
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe1492 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1493 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call1494 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1493);
// compiled call node returning call1494 (depth = 12)
// compiled member node returning call1494 (depth = 11)
  gc_frame_newslot(call1494);
// starting to compile identifier node (depth = 11)
  Object bool1495 = alloc_Boolean(1);
// compiled identifier node returning bool1495 (depth = 11)
  gc_frame_newslot(bool1495);
// starting to compile identifier node (depth = 11)
  Object bool1496 = alloc_Boolean(0);
// compiled identifier node returning bool1496 (depth = 11)
  gc_frame_newslot(bool1496);
// starting to compile string node (depth = 11)
  if (strlit1497 == NULL) {
    strlit1497 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1497);
  }
// compiled string node returning strlit1497 (depth = 11)
  gc_frame_newslot(strlit1497);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = call1494;
  params[2] = bool1495;
  params[3] = bool1496;
  params[4] = strlit1497;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1498 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1492);
// compiled call node returning call1498 (depth = 10)
    gc_frame_newslot(call1498);
    if1485 = call1498;
  }
// compiled if node returning if1485 (depth = 9)
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1499 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1500 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1499);
// compiled call node returning call1500 (depth = 9)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1501 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call1503 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1502);
// compiled call node returning call1503 (depth = 13)
// compiled member node returning call1503 (depth = 12)
  partcv[0] = 0;
  Object call1504 = callmethod(call1503, "new",
    1, partcv, params);
  gc_frame_end(callframe1501);
// compiled call node returning call1504 (depth = 11)
// compiled member node returning call1504 (depth = 10)
  *var_suggestion = call1504;
  if (call1504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1506 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1507 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1508 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1507);
// compiled call node returning call1508 (depth = 11)
// compiled member node returning call1508 (depth = 10)
  gc_frame_newslot(call1508);
// starting to compile identifier node (depth = 10)
  Object bool1509 = alloc_Boolean(1);
// compiled identifier node returning bool1509 (depth = 10)
  gc_frame_newslot(bool1509);
// starting to compile identifier node (depth = 10)
  Object bool1510 = alloc_Boolean(0);
// compiled identifier node returning bool1510 (depth = 10)
  gc_frame_newslot(bool1510);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = call1508;
  params[2] = bool1509;
  params[3] = bool1510;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1511 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1506);
// compiled call node returning call1511 (depth = 9)
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1512 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1513 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1512);
// compiled call node returning call1513 (depth = 9)
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1514 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1515 == NULL) {
    strlit1515 = alloc_String("A valid expression must follow ':='.");
    gc_root(strlit1515);
  }
// compiled string node returning strlit1515 (depth = 10)
  gc_frame_newslot(strlit1515);
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1516 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1517 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1516);
// compiled call node returning call1517 (depth = 11)
// compiled member node returning call1517 (depth = 10)
  gc_frame_newslot(call1517);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call1519 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1518);
// compiled call node returning call1519 (depth = 11)
// compiled member node returning call1519 (depth = 10)
  gc_frame_newslot(call1519);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit1515;
  params[1] = call1517;
  params[2] = call1519;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1520 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1514);
// compiled call node returning call1520 (depth = 9)
    gc_frame_newslot(call1520);
    if1467 = call1520;
  } else {
  }
// compiled if node returning if1467 (depth = 8)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1521 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1522 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1521);
// compiled call node returning call1522 (depth = 10)
// compiled member node returning call1522 (depth = 9)
  *var_rhs = call1522;
  if (call1522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1523 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1524 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lhs (depth = 10)
  gc_frame_newslot(*var_lhs);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rhs (depth = 10)
  gc_frame_newslot(*var_rhs);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_ast (depth = 12)
  partcv[0] = 0;
  Object call1526 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe1525);
// compiled call node returning call1526 (depth = 11)
// compiled member node returning call1526 (depth = 10)
  params[0] = *var_lhs;
  params[1] = *var_rhs;
  partcv[0] = 2;
  Object call1527 = callmethod(call1526, "new",
    1, partcv, params);
  gc_frame_end(callframe1524);
// compiled call node returning call1527 (depth = 9)
  gc_frame_newslot(call1527);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1527;
  partcv[0] = 1;
  Object call1528 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1523);
// compiled call node returning call1528 (depth = 8)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1530 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1531 == NULL) {
    strlit1531 = alloc_String("semicolon");
    gc_root(strlit1531);
  }
// compiled string node returning strlit1531 (depth = 10)
  gc_frame_newslot(strlit1531);
// call case 4: self request
  params[0] = strlit1531;
  partcv[0] = 1;
  Object call1532 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1530);
// compiled call node returning call1532 (depth = 9)
  Object if1529 = done;
  if (istrue(call1532)) {
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1533 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1534 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1533);
// compiled call node returning call1534 (depth = 10)
// compiled member node returning call1534 (depth = 9)
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_lastToken (depth = 13)
  partcv[0] = 0;
  Object call1538 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1537);
// compiled call node returning call1538 (depth = 12)
// compiled member node returning call1538 (depth = 11)
  int op_slot_right_1536 = gc_frame_newslot(call1538);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1540 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call1541 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1540);
// compiled call node returning call1541 (depth = 12)
// compiled member node returning call1541 (depth = 11)
  int op_slot_left_1536 = gc_frame_newslot(call1541);
  params[0] = call1538;
  partcv[0] = 1;
  Object opresult1542 = callmethod(call1541, "==", 1, partcv, params);
// compiled op node returning opresult1542 (depth = 10)
  Object if1535 = done;
  if (istrue(opresult1542)) {
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 11)
  Object bool1543 = alloc_Boolean(1);
// compiled identifier node returning bool1543 (depth = 11)
  *var_indentFreePass = bool1543;
  if (bool1543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
    gc_frame_newslot(done);
    if1535 = done;
  } else {
  }
// compiled if node returning if1535 (depth = 9)
    gc_frame_newslot(if1535);
    if1529 = if1535;
  } else {
  }
// compiled if node returning if1529 (depth = 8)
    gc_frame_newslot(if1529);
    if1426 = if1529;
  } else {
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1545 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1546 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1545);
// compiled call node returning call1546 (depth = 9)
// compiled member node returning call1546 (depth = 8)
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1547 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call1549 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1548);
// compiled call node returning call1549 (depth = 10)
// compiled member node returning call1549 (depth = 9)
  gc_frame_newslot(call1549);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_body (depth = 9)
  params[0] = call1549;
  partcv[0] = 1;
  Object call1550 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1547);
// compiled call node returning call1550 (depth = 8)
    gc_frame_newslot(call1550);
    if1426 = call1550;
  }
// compiled if node returning if1426 (depth = 7)
    gc_frame_newslot(if1426);
    if1400 = if1426;
  }
// compiled if node returning if1400 (depth = 6)
    gc_frame_newslot(if1400);
    if1162 = if1400;
  }
// compiled if node returning if1162 (depth = 5)
  gc_frame_end(frame);
  return if1162;
}
Object meth_parser__apply1577(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1578 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe1579 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String("rbrace");
    gc_root(strlit1580);
  }
// compiled string node returning strlit1580 (depth = 8)
  gc_frame_newslot(strlit1580);
// call case 4: self request
  params[0] = strlit1580;
  partcv[0] = 1;
  Object call1581 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1579);
// compiled call node returning call1581 (depth = 7)
  partcv[0] = 0;
  Object call1582 = callmethod(call1581, "not",
    1, partcv, params);
  gc_frame_end(callframe1578);
// compiled call node returning call1582 (depth = 6)
// compiled member node returning call1582 (depth = 5)
  gc_frame_end(frame);
  return call1582;
}
Object meth_parser__apply1590(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1592 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1591);
// compiled call node returning call1592 (depth = 11)
// compiled member node returning call1592 (depth = 10)
  gc_frame_end(frame);
  return call1592;
}
Object meth_parser__apply1585(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_body = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1587 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1588 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block1589 = alloc_Block(NULL, NULL, "parser", 537);
  gc_frame_newslot(block1589);
// method _apply
  block_savedest(block1589);
  Object closure1590 = createclosure(1, "_apply");
  setclosureframe(closure1590, stackframe);
  addtoclosure(closure1590, selfslot);
  struct UserObject *uo1590 = (struct UserObject*)block1589;
  uo1590->data[0] = (Object)closure1590;
  Method *meth_meth_parser__apply1590 = addmethod2pos(block1589, "_apply", &meth_parser__apply1590, 0);
  int argcv_meth_parser__apply1590[] = {0};
  meth_meth_parser__apply1590->type = alloc_MethodType(1, argcv_meth_parser__apply1590);
  meth_meth_parser__apply1590->definitionModule = modulename;
  meth_meth_parser__apply1590->definitionLine = 537;
// compiled block node returning block1589 (depth = 9)
  gc_frame_newslot(block1589);
// call case 4: self request
  params[0] = block1589;
  partcv[0] = 1;
  Object call1594 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compiled call node returning call1594 (depth = 8)
  partcv[0] = 0;
  Object call1595 = callmethod(call1594, "not",
    1, partcv, params);
  gc_frame_end(callframe1587);
// compiled call node returning call1595 (depth = 7)
// compiled member node returning call1595 (depth = 6)
  Object if1586 = done;
  if (istrue(call1595)) {
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1596 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call1598 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1597);
// compiled call node returning call1598 (depth = 10)
// compiled member node returning call1598 (depth = 9)
  partcv[0] = 0;
  Object call1599 = callmethod(call1598, "new",
    1, partcv, params);
  gc_frame_end(callframe1596);
// compiled call node returning call1599 (depth = 8)
// compiled member node returning call1599 (depth = 7)
  *var_suggestion = call1599;
  if (call1599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1600 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1601 == NULL) {
    strlit1601 = alloc_String("}");
    gc_root(strlit1601);
  }
// compiled string node returning strlit1601 (depth = 7)
  gc_frame_newslot(strlit1601);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1601;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1602 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1600);
// compiled call node returning call1602 (depth = 6)
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1603 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1604 == NULL) {
    strlit1604 = alloc_String("A block must end with a '}'.");
    gc_root(strlit1604);
  }
// compiled string node returning strlit1604 (depth = 7)
  gc_frame_newslot(strlit1604);
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1606 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1605);
// compiled call node returning call1606 (depth = 8)
// compiled member node returning call1606 (depth = 7)
  gc_frame_newslot(call1606);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1607 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1608 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1607);
// compiled call node returning call1608 (depth = 8)
// compiled member node returning call1608 (depth = 7)
  gc_frame_newslot(call1608);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1604;
  params[1] = call1606;
  params[2] = call1608;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1609 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1603);
// compiled call node returning call1609 (depth = 6)
    gc_frame_newslot(call1609);
    if1586 = call1609;
  } else {
  }
// compiled if node returning if1586 (depth = 5)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1610 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call1611 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1610);
// compiled call node returning call1611 (depth = 7)
// compiled member node returning call1611 (depth = 6)
  *var_tmp = call1611;
  if (call1611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1613 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call1614 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1613);
// compiled call node returning call1614 (depth = 5)
  gc_frame_end(frame);
  return call1614;
}
Object meth_parser_block1127(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_braceIsType = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_indentFreePass = getfromclosure(closure, 8);
  Object *var_ast = getfromclosure(closure, 9);
  Object *var_minIndentLevel = getfromclosure(closure, 10);
  Object *var_util = getfromclosure(closure, 11);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for block (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for block");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minInd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minInd");
  Object *var_startIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startIndent");
  Object *var_expr1 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "expr1");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_params = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "params");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_havearrow = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "havearrow");
  Object *var_found = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "found");
  Object *var_i = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "i");
  Object *var_isMatchingBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "isMatchingBlock");
  Object *var_o = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "o");
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1129 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit1130 == NULL) {
    strlit1130 = alloc_String("lbrace");
    gc_root(strlit1130);
  }
// compiled string node returning strlit1130 (depth = 4)
  gc_frame_newslot(strlit1130);
// call case 4: self request
  params[0] = strlit1130;
  partcv[0] = 1;
  Object call1131 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1129);
// compiled call node returning call1131 (depth = 3)
  Object if1128 = done;
  if (istrue(call1131)) {
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1132 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1133 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compiled call node returning call1133 (depth = 4)
// compiled member node returning call1133 (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1135 = alloc_Float64(1);
// compiled num node returning num1135 (depth = 5)
  int op_slot_right_1134 = gc_frame_newslot(num1135);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1134 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1135;
  partcv[0] = 1;
  Object sum1137 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum1137 (depth = 4)
  *var_minInd = sum1137;
  if (sum1137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_startIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_expr1 = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_s = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1138 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1138 (depth = 4)
  *var_params = array1138;
  if (array1138 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1139 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1139 (depth = 4)
  *var_body = array1139;
  if (array1139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1140 = alloc_Boolean(1);
// compiled identifier node returning bool1140 (depth = 4)
  *var_havearrow = bool1140;
  if (bool1140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1141 = alloc_Boolean(0);
// compiled identifier node returning bool1141 (depth = 4)
  *var_found = bool1141;
  if (bool1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num1142 = alloc_Float64(0);
// compiled num node returning num1142 (depth = 4)
  *var_i = num1142;
  if (num1142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool1143 = alloc_Boolean(0);
// compiled identifier node returning bool1143 (depth = 4)
  *var_isMatchingBlock = bool1143;
  if (bool1143 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1147 == NULL) {
    strlit1147 = alloc_String("lparen");
    gc_root(strlit1147);
  }
// compiled string node returning strlit1147 (depth = 5)
  int op_slot_right_1146 = gc_frame_newslot(strlit1147);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1150 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1149);
// compiled call node returning call1150 (depth = 6)
// compiled member node returning call1150 (depth = 5)
  int op_slot_left_1146 = gc_frame_newslot(call1150);
  params[0] = strlit1147;
  partcv[0] = 1;
  Object opresult1151 = callmethod(call1150, "==", 1, partcv, params);
// compiled op node returning opresult1151 (depth = 4)
  Object if1145 = done;
  if (istrue(opresult1151)) {
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool1152 = alloc_Boolean(1);
// compiled identifier node returning bool1152 (depth = 5)
  *var_isMatchingBlock = bool1152;
  if (bool1152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1145 = done;
  } else {
  }
// compiled if node returning if1145 (depth = 3)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1154 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1155 = alloc_Block(NULL, NULL, "parser", 410);
  gc_frame_newslot(block1155);
// method _apply
  block_savedest(block1155);
  Object closure1156 = createclosure(2, "_apply");
  setclosureframe(closure1156, stackframe);
  addtoclosure(closure1156, var_blocksOK);
  addtoclosure(closure1156, selfslot);
  struct UserObject *uo1156 = (struct UserObject*)block1155;
  uo1156->data[0] = (Object)closure1156;
  Method *meth_meth_parser__apply1156 = addmethod2pos(block1155, "_apply", &meth_parser__apply1156, 0);
  int argcv_meth_parser__apply1156[] = {0};
  meth_meth_parser__apply1156->type = alloc_MethodType(1, argcv_meth_parser__apply1156);
  meth_meth_parser__apply1156->definitionModule = modulename;
  meth_meth_parser__apply1156->definitionLine = 405;
// compiled block node returning block1155 (depth = 4)
  gc_frame_newslot(block1155);
// starting to compile block node (depth = 4)
  Object block1160 = alloc_Block(NULL, NULL, "parser", 410);
  gc_frame_newslot(block1160);
// method _apply
  block_savedest(block1160);
  Object closure1161 = createclosure(13, "_apply");
  setclosureframe(closure1161, stackframe);
  addtoclosure(closure1161, var_values);
  addtoclosure(closure1161, var_expr1);
  addtoclosure(closure1161, var_braceIsType);
  addtoclosure(closure1161, var_blocksOK);
  addtoclosure(closure1161, var_errormessages);
  addtoclosure(closure1161, var_sym);
  addtoclosure(closure1161, var_lastToken);
  addtoclosure(closure1161, var_params);
  addtoclosure(closure1161, var_isMatchingBlock);
  addtoclosure(closure1161, var_body);
  addtoclosure(closure1161, var_indentFreePass);
  addtoclosure(closure1161, var_ast);
  addtoclosure(closure1161, selfslot);
  struct UserObject *uo1161 = (struct UserObject*)block1160;
  uo1161->data[0] = (Object)closure1161;
  Method *meth_meth_parser__apply1161 = addmethod2pos(block1160, "_apply", &meth_parser__apply1161, 0);
  int argcv_meth_parser__apply1161[] = {0};
  meth_meth_parser__apply1161->type = alloc_MethodType(1, argcv_meth_parser__apply1161);
  meth_meth_parser__apply1161->definitionModule = modulename;
  meth_meth_parser__apply1161->definitionLine = 405;
// compiled block node returning block1160 (depth = 4)
  gc_frame_newslot(block1160);
// call case 4: self request
  params[0] = block1155;
  params[1] = block1160;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1552 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1154);
// compiled call node returning call1552 (depth = 3)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1554 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1555 == NULL) {
    strlit1555 = alloc_String("arrow");
    gc_root(strlit1555);
  }
// compiled string node returning strlit1555 (depth = 5)
  gc_frame_newslot(strlit1555);
// call case 4: self request
  params[0] = strlit1555;
  partcv[0] = 1;
  Object call1556 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1554);
// compiled call node returning call1556 (depth = 4)
  Object if1553 = done;
  if (istrue(call1556)) {
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1558 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1557);
// compiled call node returning call1558 (depth = 5)
// compiled member node returning call1558 (depth = 4)
    gc_frame_newslot(call1558);
    if1553 = call1558;
  } else {
  }
// compiled if node returning if1553 (depth = 3)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1562 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1561);
// compiled call node returning call1562 (depth = 6)
// compiled member node returning call1562 (depth = 5)
  int op_slot_right_1560 = gc_frame_newslot(call1562);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1564 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1565 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1564);
// compiled call node returning call1565 (depth = 6)
// compiled member node returning call1565 (depth = 5)
  int op_slot_left_1560 = gc_frame_newslot(call1565);
  params[0] = call1562;
  partcv[0] = 1;
  Object opresult1566 = callmethod(call1565, "==", 1, partcv, params);
// compiled op node returning opresult1566 (depth = 4)
  Object if1559 = done;
  if (istrue(opresult1566)) {
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1568 = alloc_Float64(1);
// compiled num node returning num1568 (depth = 6)
  int op_slot_right_1567 = gc_frame_newslot(num1568);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1571 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1570);
// compiled call node returning call1571 (depth = 7)
// compiled member node returning call1571 (depth = 6)
  int op_slot_left_1567 = gc_frame_newslot(call1571);
  params[0] = num1568;
  partcv[0] = 1;
  Object diff1572 = callmethod(call1571, "-", 1, partcv, params);
// compiled op node returning diff1572 (depth = 5)
  *var_minIndentLevel = diff1572;
  if (diff1572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1559 = done;
  } else {
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if1559 = done;
  }
// compiled if node returning if1559 (depth = 3)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1575 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block1576 = alloc_Block(NULL, NULL, "parser", 535);
  gc_frame_newslot(block1576);
// method _apply
  block_savedest(block1576);
  Object closure1577 = createclosure(1, "_apply");
  setclosureframe(closure1577, stackframe);
  addtoclosure(closure1577, selfslot);
  struct UserObject *uo1577 = (struct UserObject*)block1576;
  uo1577->data[0] = (Object)closure1577;
  Method *meth_meth_parser__apply1577 = addmethod2pos(block1576, "_apply", &meth_parser__apply1577, 0);
  int argcv_meth_parser__apply1577[] = {0};
  meth_meth_parser__apply1577->type = alloc_MethodType(1, argcv_meth_parser__apply1577);
  meth_meth_parser__apply1577->definitionModule = modulename;
  meth_meth_parser__apply1577->definitionLine = 531;
// compiled block node returning block1576 (depth = 4)
  gc_frame_newslot(block1576);
// starting to compile block node (depth = 4)
  Object block1584 = alloc_Block(NULL, NULL, "parser", 535);
  gc_frame_newslot(block1584);
// method _apply
  block_savedest(block1584);
  Object closure1585 = createclosure(7, "_apply");
  setclosureframe(closure1585, stackframe);
  addtoclosure(closure1585, var_errormessages);
  addtoclosure(closure1585, var_lastToken);
  addtoclosure(closure1585, var_sym);
  addtoclosure(closure1585, var_values);
  addtoclosure(closure1585, var_tmp);
  addtoclosure(closure1585, var_body);
  addtoclosure(closure1585, selfslot);
  struct UserObject *uo1585 = (struct UserObject*)block1584;
  uo1585->data[0] = (Object)closure1585;
  Method *meth_meth_parser__apply1585 = addmethod2pos(block1584, "_apply", &meth_parser__apply1585, 0);
  int argcv_meth_parser__apply1585[] = {0};
  meth_meth_parser__apply1585->type = alloc_MethodType(1, argcv_meth_parser__apply1585);
  meth_meth_parser__apply1585->definitionModule = modulename;
  meth_meth_parser__apply1585->definitionLine = 535;
// compiled block node returning block1584 (depth = 4)
  gc_frame_newslot(block1584);
// call case 5: prelude request
  params[0] = block1576;
  params[1] = block1584;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1616 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1575);
// compiled call node returning call1616 (depth = 3)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1618 = alloc_Float64(1);
// compiled num node returning num1618 (depth = 5)
  int op_slot_right_1617 = gc_frame_newslot(num1618);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minInd (depth = 5)
  int op_slot_left_1617 = gc_frame_newslot(*var_minInd);
  params[0] = num1618;
  partcv[0] = 1;
  Object diff1620 = callmethod(*var_minInd, "-", 1, partcv, params);
// compiled op node returning diff1620 (depth = 4)
  *var_minIndentLevel = diff1620;
  if (diff1620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startIndent (depth = 4)
  *var_statementIndent = *var_startIndent;
  if (*var_startIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 548
  setline(548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1623 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1624 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1623);
// compiled call node returning call1624 (depth = 4)
// compiled member node returning call1624 (depth = 3)
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1625 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call1627 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1626);
// compiled call node returning call1627 (depth = 5)
// compiled member node returning call1627 (depth = 4)
  gc_frame_newslot(call1627);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call1627;
  partcv[0] = 1;
  Object call1628 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe1625);
// compiled call node returning call1628 (depth = 3)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1629 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call1631 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1630);
// compiled call node returning call1631 (depth = 6)
// compiled member node returning call1631 (depth = 5)
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1632 = callmethod(call1631, "new",
    1, partcv, params);
  gc_frame_end(callframe1629);
// compiled call node returning call1632 (depth = 4)
  *var_o = call1632;
  if (call1632 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_isMatchingBlock (depth = 4)
  Object if1633 = done;
  if (istrue(*var_isMatchingBlock)) {
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1636 = alloc_Float64(0);
// compiled num node returning num1636 (depth = 6)
  int op_slot_right_1635 = gc_frame_newslot(num1636);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  partcv[0] = 0;
  Object call1639 = callmethod(*var_params, "size",
    1, partcv, params);
  gc_frame_end(callframe1638);
// compiled call node returning call1639 (depth = 7)
// compiled member node returning call1639 (depth = 6)
  int op_slot_left_1635 = gc_frame_newslot(call1639);
  params[0] = num1636;
  partcv[0] = 1;
  Object opresult1640 = callmethod(call1639, ">", 1, partcv, params);
// compiled op node returning opresult1640 (depth = 5)
  Object if1634 = done;
  if (istrue(opresult1640)) {
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1641 = gc_frame_new();
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_params (depth = 9)
  partcv[0] = 0;
  Object call1643 = callmethod(*var_params, "first",
    1, partcv, params);
  gc_frame_end(callframe1642);
// compiled call node returning call1643 (depth = 8)
// compiled member node returning call1643 (depth = 7)
  gc_frame_newslot(call1643);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  params[0] = call1643;
  partcv[0] = 1;
  Object call1644 = callmethod(*var_o, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1641);
// compiled call node returning call1644 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1634 = done;
  } else {
  }
// compiled if node returning if1634 (depth = 4)
    gc_frame_newslot(if1634);
    if1633 = if1634;
  } else {
  }
// compiled if node returning if1633 (depth = 3)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1645 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1646 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1645);
// compiled call node returning call1646 (depth = 3)
    gc_frame_newslot(call1646);
    if1128 = call1646;
  } else {
  }
// compiled if node returning if1128 (depth = 2)
  gc_frame_end(frame);
  return if1128;
}
Object meth_parser__apply1676(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1681 == NULL) {
    strlit1681 = alloc_String("then");
    gc_root(strlit1681);
  }
// compiled string node returning strlit1681 (depth = 11)
  int op_slot_right_1680 = gc_frame_newslot(strlit1681);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1683 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1684 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe1683);
// compiled call node returning call1684 (depth = 12)
// compiled member node returning call1684 (depth = 11)
  int op_slot_left_1680 = gc_frame_newslot(call1684);
  params[0] = strlit1681;
  partcv[0] = 1;
  Object opresult1685 = callmethod(call1684, "==", 1, partcv, params);
// compiled op node returning opresult1685 (depth = 10)
  int op_slot_right_1679 = gc_frame_newslot(opresult1685);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1688 == NULL) {
    strlit1688 = alloc_String("identifier");
    gc_root(strlit1688);
  }
// compiled string node returning strlit1688 (depth = 11)
  int op_slot_right_1687 = gc_frame_newslot(strlit1688);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1690 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1691 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1690);
// compiled call node returning call1691 (depth = 12)
// compiled member node returning call1691 (depth = 11)
  int op_slot_left_1687 = gc_frame_newslot(call1691);
  params[0] = strlit1688;
  partcv[0] = 1;
  Object opresult1692 = callmethod(call1691, "==", 1, partcv, params);
// compiled op node returning opresult1692 (depth = 10)
  int op_slot_left_1679 = gc_frame_newslot(opresult1692);
  params[0] = opresult1685;
  partcv[0] = 1;
  Object opresult1693 = callmethod(opresult1692, "&&", 1, partcv, params);
// compiled op node returning opresult1693 (depth = 9)
  int op_slot_right_1678 = gc_frame_newslot(opresult1693);
// starting to compile op node (depth = 9)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1697 == NULL) {
    strlit1697 = alloc_String("lbrace");
    gc_root(strlit1697);
  }
// compiled string node returning strlit1697 (depth = 11)
  int op_slot_right_1696 = gc_frame_newslot(strlit1697);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1700 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1699);
// compiled call node returning call1700 (depth = 12)
// compiled member node returning call1700 (depth = 11)
  int op_slot_left_1696 = gc_frame_newslot(call1700);
  params[0] = strlit1697;
  partcv[0] = 1;
  Object opresult1701 = callmethod(call1700, "==", 1, partcv, params);
// compiled op node returning opresult1701 (depth = 10)
  int op_slot_right_1695 = gc_frame_newslot(opresult1701);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1704 == NULL) {
    strlit1704 = alloc_String("rparen");
    gc_root(strlit1704);
  }
// compiled string node returning strlit1704 (depth = 11)
  int op_slot_right_1703 = gc_frame_newslot(strlit1704);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1706 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call1707 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1706);
// compiled call node returning call1707 (depth = 12)
// compiled member node returning call1707 (depth = 11)
  int op_slot_left_1703 = gc_frame_newslot(call1707);
  params[0] = strlit1704;
  partcv[0] = 1;
  Object opresult1708 = callmethod(call1707, "==", 1, partcv, params);
// compiled op node returning opresult1708 (depth = 10)
  int op_slot_left_1695 = gc_frame_newslot(opresult1708);
  params[0] = opresult1701;
  partcv[0] = 1;
  Object opresult1709 = callmethod(opresult1708, "||", 1, partcv, params);
// compiled op node returning opresult1709 (depth = 9)
  int op_slot_left_1678 = gc_frame_newslot(opresult1709);
  params[0] = opresult1693;
  partcv[0] = 1;
  Object opresult1710 = callmethod(opresult1709, "||", 1, partcv, params);
// compiled op node returning opresult1710 (depth = 8)
  int op_slot_right_1677 = gc_frame_newslot(opresult1710);
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1713 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  partcv[0] = 0;
  Object call1714 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1713);
// compiled call node returning call1714 (depth = 10)
// compiled member node returning call1714 (depth = 9)
  int op_slot_right_1712 = gc_frame_newslot(call1714);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1717 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1716);
// compiled call node returning call1717 (depth = 10)
// compiled member node returning call1717 (depth = 9)
  int op_slot_left_1712 = gc_frame_newslot(call1717);
  params[0] = call1714;
  partcv[0] = 1;
  Object opresult1718 = callmethod(call1717, "==", 1, partcv, params);
// compiled op node returning opresult1718 (depth = 8)
  int op_slot_left_1677 = gc_frame_newslot(opresult1718);
  params[0] = opresult1710;
  partcv[0] = 1;
  Object opresult1719 = callmethod(opresult1718, "&&", 1, partcv, params);
// compiled op node returning opresult1719 (depth = 7)
  gc_frame_end(frame);
  return opresult1719;
}
Object meth_parser__apply1806(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe1807 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call1808 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1807);
// compiled call node returning call1808 (depth = 8)
  gc_frame_end(frame);
  return call1808;
}
Object meth_parser__apply1818(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1821 == NULL) {
    strlit1821 = alloc_String("rparen");
    gc_root(strlit1821);
  }
// compiled string node returning strlit1821 (depth = 9)
  int op_slot_right_1820 = gc_frame_newslot(strlit1821);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1824 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1823);
// compiled call node returning call1824 (depth = 10)
// compiled member node returning call1824 (depth = 9)
  int op_slot_left_1820 = gc_frame_newslot(call1824);
  params[0] = strlit1821;
  partcv[0] = 1;
  Object opresult1825 = callmethod(call1824, "==", 1, partcv, params);
// compiled op node returning opresult1825 (depth = 8)
  int op_slot_right_1819 = gc_frame_newslot(opresult1825);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1828 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call1829 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1828);
// compiled call node returning call1829 (depth = 10)
// compiled member node returning call1829 (depth = 9)
  int op_slot_right_1827 = gc_frame_newslot(call1829);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call1832 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1831);
// compiled call node returning call1832 (depth = 10)
// compiled member node returning call1832 (depth = 9)
  int op_slot_left_1827 = gc_frame_newslot(call1832);
  params[0] = call1829;
  partcv[0] = 1;
  Object opresult1833 = callmethod(call1832, "==", 1, partcv, params);
// compiled op node returning opresult1833 (depth = 8)
  int op_slot_left_1819 = gc_frame_newslot(opresult1833);
  params[0] = opresult1825;
  partcv[0] = 1;
  Object opresult1834 = callmethod(opresult1833, "&&", 1, partcv, params);
// compiled op node returning opresult1834 (depth = 7)
  gc_frame_end(frame);
  return opresult1834;
}
Object meth_parser__apply2039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2040 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe2041 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2042 == NULL) {
    strlit2042 = alloc_String("rbrace");
    gc_root(strlit2042);
  }
// compiled string node returning strlit2042 (depth = 9)
  gc_frame_newslot(strlit2042);
// call case 4: self request
  params[0] = strlit2042;
  partcv[0] = 1;
  Object call2043 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2041);
// compiled call node returning call2043 (depth = 8)
  partcv[0] = 0;
  Object call2044 = callmethod(call2043, "not",
    1, partcv, params);
  gc_frame_end(callframe2040);
// compiled call node returning call2044 (depth = 7)
// compiled member node returning call2044 (depth = 6)
  gc_frame_end(frame);
  return call2044;
}
Object meth_parser__apply2052(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2054 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled call node returning call2054 (depth = 12)
// compiled member node returning call2054 (depth = 11)
  gc_frame_end(frame);
  return call2054;
}
Object meth_parser__apply2047(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2049 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2050 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2051 = alloc_Block(NULL, NULL, "parser", 673);
  gc_frame_newslot(block2051);
// method _apply
  block_savedest(block2051);
  Object closure2052 = createclosure(1, "_apply");
  setclosureframe(closure2052, stackframe);
  addtoclosure(closure2052, selfslot);
  struct UserObject *uo2052 = (struct UserObject*)block2051;
  uo2052->data[0] = (Object)closure2052;
  Method *meth_meth_parser__apply2052 = addmethod2pos(block2051, "_apply", &meth_parser__apply2052, 0);
  int argcv_meth_parser__apply2052[] = {0};
  meth_meth_parser__apply2052->type = alloc_MethodType(1, argcv_meth_parser__apply2052);
  meth_meth_parser__apply2052->definitionModule = modulename;
  meth_meth_parser__apply2052->definitionLine = 673;
// compiled block node returning block2051 (depth = 10)
  gc_frame_newslot(block2051);
// call case 4: self request
  params[0] = block2051;
  partcv[0] = 1;
  Object call2056 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2050);
// compiled call node returning call2056 (depth = 9)
  partcv[0] = 0;
  Object call2057 = callmethod(call2056, "not",
    1, partcv, params);
  gc_frame_end(callframe2049);
// compiled call node returning call2057 (depth = 8)
// compiled member node returning call2057 (depth = 7)
  Object if2048 = done;
  if (istrue(call2057)) {
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2058 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2060 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2059);
// compiled call node returning call2060 (depth = 11)
// compiled member node returning call2060 (depth = 10)
  partcv[0] = 0;
  Object call2061 = callmethod(call2060, "new",
    1, partcv, params);
  gc_frame_end(callframe2058);
// compiled call node returning call2061 (depth = 9)
// compiled member node returning call2061 (depth = 8)
  *var_suggestion = call2061;
  if (call2061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2062 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2063 = alloc_Boolean(0);
// compiled identifier node returning bool2063 (depth = 9)
  gc_frame_newslot(bool2063);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2063;
  partcv[0] = 2;
  Object call2064 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2062);
// compiled call node returning call2064 (depth = 8)
  *var_closingBrace = call2064;
  if (call2064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 676
  setline(676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2067 = alloc_Boolean(0);
// compiled identifier node returning bool2067 (depth = 9)
  int op_slot_right_2066 = gc_frame_newslot(bool2067);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2070 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2069);
// compiled call node returning call2070 (depth = 10)
// compiled member node returning call2070 (depth = 9)
  int op_slot_left_2066 = gc_frame_newslot(call2070);
  params[0] = bool2067;
  partcv[0] = 1;
  Object opresult2071 = callmethod(call2070, "==", 1, partcv, params);
// compiled op node returning opresult2071 (depth = 8)
  Object if2065 = done;
  if (istrue(opresult2071)) {
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2073 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2076 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2075);
// compiled call node returning call2076 (depth = 11)
// compiled member node returning call2076 (depth = 10)
  int op_slot_left_2073 = gc_frame_newslot(call2076);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2077 = callmethod(call2076, "==", 1, partcv, params);
// compiled op node returning opresult2077 (depth = 9)
  Object if2072 = done;
  if (istrue(opresult2077)) {
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2078 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2079 == NULL) {
    strlit2079 = alloc_String("}");
    gc_root(strlit2079);
  }
// compiled string node returning strlit2079 (depth = 10)
  gc_frame_newslot(strlit2079);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2079;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2080 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2078);
// compiled call node returning call2080 (depth = 9)
    gc_frame_newslot(call2080);
    if2072 = call2080;
  } else {
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2081 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2083 = alloc_Float64(0.1);
// compiled num node returning num2083 (depth = 11)
  int op_slot_right_2082 = gc_frame_newslot(num2083);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2085 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2087 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2086);
// compiled call node returning call2087 (depth = 14)
// compiled member node returning call2087 (depth = 13)
  partcv[0] = 0;
  Object call2088 = callmethod(call2087, "line",
    1, partcv, params);
  gc_frame_end(callframe2085);
// compiled call node returning call2088 (depth = 12)
// compiled member node returning call2088 (depth = 11)
  int op_slot_left_2082 = gc_frame_newslot(call2088);
  params[0] = num2083;
  partcv[0] = 1;
  Object sum2089 = callmethod(call2088, "+", 1, partcv, params);
// compiled op node returning sum2089 (depth = 10)
  gc_frame_newslot(sum2089);
// starting to compile string node (depth = 10)
  if (strlit2090 == NULL) {
    strlit2090 = alloc_String("}");
    gc_root(strlit2090);
  }
// compiled string node returning strlit2090 (depth = 10)
  gc_frame_newslot(strlit2090);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2089;
  params[1] = strlit2090;
  partcv[0] = 2;
  Object call2091 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2081);
// compiled call node returning call2091 (depth = 9)
    gc_frame_newslot(call2091);
    if2072 = call2091;
  }
// compiled if node returning if2072 (depth = 8)
    gc_frame_newslot(if2072);
    if2065 = if2072;
  } else {
  }
// compiled if node returning if2065 (depth = 7)
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2092 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2093 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2092);
// compiled call node returning call2093 (depth = 7)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2094 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2095 == NULL) {
    strlit2095 = alloc_String("An if statement must end with a '}'.");
    gc_root(strlit2095);
  }
// compiled string node returning strlit2095 (depth = 8)
  gc_frame_newslot(strlit2095);
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2097 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2096);
// compiled call node returning call2097 (depth = 9)
// compiled member node returning call2097 (depth = 8)
  gc_frame_newslot(call2097);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2099 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2098);
// compiled call node returning call2099 (depth = 9)
// compiled member node returning call2099 (depth = 8)
  gc_frame_newslot(call2099);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2095;
  params[1] = call2097;
  params[2] = call2099;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2100 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2094);
// compiled call node returning call2100 (depth = 7)
    gc_frame_newslot(call2100);
    if2048 = call2100;
  } else {
  }
// compiled if node returning if2048 (depth = 6)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2101 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2102 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2101);
// compiled call node returning call2102 (depth = 8)
// compiled member node returning call2102 (depth = 7)
  *var_v = call2102;
  if (call2102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2104 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2105 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe2104);
// compiled call node returning call2105 (depth = 6)
  gc_frame_end(frame);
  return call2105;
}
Object meth_parser__apply2112(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2115 == NULL) {
    strlit2115 = alloc_String("elseif");
    gc_root(strlit2115);
  }
// compiled string node returning strlit2115 (depth = 8)
  int op_slot_right_2114 = gc_frame_newslot(strlit2115);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2118 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2117);
// compiled call node returning call2118 (depth = 9)
// compiled member node returning call2118 (depth = 8)
  int op_slot_left_2114 = gc_frame_newslot(call2118);
  params[0] = strlit2115;
  partcv[0] = 1;
  Object opresult2119 = callmethod(call2118, "==", 1, partcv, params);
// compiled op node returning opresult2119 (depth = 7)
  int op_slot_right_2113 = gc_frame_newslot(opresult2119);
// starting to compile call node (depth = 7)
  int callframe2121 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2122 == NULL) {
    strlit2122 = alloc_String("identifier");
    gc_root(strlit2122);
  }
// compiled string node returning strlit2122 (depth = 8)
  gc_frame_newslot(strlit2122);
// call case 4: self request
  params[0] = strlit2122;
  partcv[0] = 1;
  Object call2123 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2121);
// compiled call node returning call2123 (depth = 7)
  int op_slot_left_2113 = gc_frame_newslot(call2123);
  params[0] = opresult2119;
  partcv[0] = 1;
  Object opresult2124 = callmethod(call2123, "&&", 1, partcv, params);
// compiled op node returning opresult2124 (depth = 6)
  gc_frame_end(frame);
  return opresult2124;
}
Object meth_parser__apply2134(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2136 == NULL) {
    strlit2136 = alloc_String("lbrace");
    gc_root(strlit2136);
  }
// compiled string node returning strlit2136 (depth = 11)
  int op_slot_right_2135 = gc_frame_newslot(strlit2136);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call2139 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2138);
// compiled call node returning call2139 (depth = 12)
// compiled member node returning call2139 (depth = 11)
  int op_slot_left_2135 = gc_frame_newslot(call2139);
  params[0] = strlit2136;
  partcv[0] = 1;
  Object opresult2140 = callmethod(call2139, "==", 1, partcv, params);
// compiled op node returning opresult2140 (depth = 10)
  gc_frame_end(frame);
  return opresult2140;
}
Object meth_parser__apply2176(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2181 == NULL) {
    strlit2181 = alloc_String("then");
    gc_root(strlit2181);
  }
// compiled string node returning strlit2181 (depth = 14)
  int op_slot_right_2180 = gc_frame_newslot(strlit2181);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2183 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2184 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe2183);
// compiled call node returning call2184 (depth = 15)
// compiled member node returning call2184 (depth = 14)
  int op_slot_left_2180 = gc_frame_newslot(call2184);
  params[0] = strlit2181;
  partcv[0] = 1;
  Object opresult2185 = callmethod(call2184, "==", 1, partcv, params);
// compiled op node returning opresult2185 (depth = 13)
  int op_slot_right_2179 = gc_frame_newslot(opresult2185);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2188 == NULL) {
    strlit2188 = alloc_String("identifier");
    gc_root(strlit2188);
  }
// compiled string node returning strlit2188 (depth = 14)
  int op_slot_right_2187 = gc_frame_newslot(strlit2188);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2190 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2191 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2190);
// compiled call node returning call2191 (depth = 15)
// compiled member node returning call2191 (depth = 14)
  int op_slot_left_2187 = gc_frame_newslot(call2191);
  params[0] = strlit2188;
  partcv[0] = 1;
  Object opresult2192 = callmethod(call2191, "==", 1, partcv, params);
// compiled op node returning opresult2192 (depth = 13)
  int op_slot_left_2179 = gc_frame_newslot(opresult2192);
  params[0] = opresult2185;
  partcv[0] = 1;
  Object opresult2193 = callmethod(opresult2192, "&&", 1, partcv, params);
// compiled op node returning opresult2193 (depth = 12)
  int op_slot_right_2178 = gc_frame_newslot(opresult2193);
// starting to compile op node (depth = 12)
// Begin line 709
  setline(709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit2197 == NULL) {
    strlit2197 = alloc_String("lbrace");
    gc_root(strlit2197);
  }
// compiled string node returning strlit2197 (depth = 14)
  int op_slot_right_2196 = gc_frame_newslot(strlit2197);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2199 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_t (depth = 16)
  partcv[0] = 0;
  Object call2200 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2199);
// compiled call node returning call2200 (depth = 15)
// compiled member node returning call2200 (depth = 14)
  int op_slot_left_2196 = gc_frame_newslot(call2200);
  params[0] = strlit2197;
  partcv[0] = 1;
  Object opresult2201 = callmethod(call2200, "==", 1, partcv, params);
// compiled op node returning opresult2201 (depth = 13)
  int op_slot_right_2195 = gc_frame_newslot(opresult2201);
// starting to compile op node (depth = 13)
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2205 == NULL) {
    strlit2205 = alloc_String("rbrace");
    gc_root(strlit2205);
  }
// compiled string node returning strlit2205 (depth = 15)
  int op_slot_right_2204 = gc_frame_newslot(strlit2205);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2208 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2207);
// compiled call node returning call2208 (depth = 16)
// compiled member node returning call2208 (depth = 15)
  int op_slot_left_2204 = gc_frame_newslot(call2208);
  params[0] = strlit2205;
  partcv[0] = 1;
  Object opresult2209 = callmethod(call2208, "==", 1, partcv, params);
// compiled op node returning opresult2209 (depth = 14)
  int op_slot_right_2203 = gc_frame_newslot(opresult2209);
// starting to compile op node (depth = 14)
// starting to compile string node (depth = 15)
  if (strlit2212 == NULL) {
    strlit2212 = alloc_String("rparen");
    gc_root(strlit2212);
  }
// compiled string node returning strlit2212 (depth = 15)
  int op_slot_right_2211 = gc_frame_newslot(strlit2212);
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2214 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_t (depth = 17)
  partcv[0] = 0;
  Object call2215 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2214);
// compiled call node returning call2215 (depth = 16)
// compiled member node returning call2215 (depth = 15)
  int op_slot_left_2211 = gc_frame_newslot(call2215);
  params[0] = strlit2212;
  partcv[0] = 1;
  Object opresult2216 = callmethod(call2215, "==", 1, partcv, params);
// compiled op node returning opresult2216 (depth = 14)
  int op_slot_left_2203 = gc_frame_newslot(opresult2216);
  params[0] = opresult2209;
  partcv[0] = 1;
  Object opresult2217 = callmethod(opresult2216, "||", 1, partcv, params);
// compiled op node returning opresult2217 (depth = 13)
  int op_slot_left_2195 = gc_frame_newslot(opresult2217);
  params[0] = opresult2201;
  partcv[0] = 1;
  Object opresult2218 = callmethod(opresult2217, "||", 1, partcv, params);
// compiled op node returning opresult2218 (depth = 12)
  int op_slot_left_2178 = gc_frame_newslot(opresult2218);
  params[0] = opresult2193;
  partcv[0] = 1;
  Object opresult2219 = callmethod(opresult2218, "||", 1, partcv, params);
// compiled op node returning opresult2219 (depth = 11)
  int op_slot_right_2177 = gc_frame_newslot(opresult2219);
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_statementToken (depth = 14)
  partcv[0] = 0;
  Object call2223 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2222);
// compiled call node returning call2223 (depth = 13)
// compiled member node returning call2223 (depth = 12)
  int op_slot_right_2221 = gc_frame_newslot(call2223);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2226 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2225);
// compiled call node returning call2226 (depth = 13)
// compiled member node returning call2226 (depth = 12)
  int op_slot_left_2221 = gc_frame_newslot(call2226);
  params[0] = call2223;
  partcv[0] = 1;
  Object opresult2227 = callmethod(call2226, "==", 1, partcv, params);
// compiled op node returning opresult2227 (depth = 11)
  int op_slot_left_2177 = gc_frame_newslot(opresult2227);
  params[0] = opresult2219;
  partcv[0] = 1;
  Object opresult2228 = callmethod(opresult2227, "&&", 1, partcv, params);
// compiled op node returning opresult2228 (depth = 10)
  gc_frame_end(frame);
  return opresult2228;
}
Object meth_parser__apply2315(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe2316 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call2317 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2316);
// compiled call node returning call2317 (depth = 11)
  gc_frame_end(frame);
  return call2317;
}
Object meth_parser__apply2327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2331 == NULL) {
    strlit2331 = alloc_String("rbrace");
    gc_root(strlit2331);
  }
// compiled string node returning strlit2331 (depth = 13)
  int op_slot_right_2330 = gc_frame_newslot(strlit2331);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2333 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2334 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2333);
// compiled call node returning call2334 (depth = 14)
// compiled member node returning call2334 (depth = 13)
  int op_slot_left_2330 = gc_frame_newslot(call2334);
  params[0] = strlit2331;
  partcv[0] = 1;
  Object opresult2335 = callmethod(call2334, "==", 1, partcv, params);
// compiled op node returning opresult2335 (depth = 12)
  int op_slot_right_2329 = gc_frame_newslot(opresult2335);
// starting to compile op node (depth = 12)
// starting to compile string node (depth = 13)
  if (strlit2338 == NULL) {
    strlit2338 = alloc_String("rparen");
    gc_root(strlit2338);
  }
// compiled string node returning strlit2338 (depth = 13)
  int op_slot_right_2337 = gc_frame_newslot(strlit2338);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2340 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_t (depth = 15)
  partcv[0] = 0;
  Object call2341 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2340);
// compiled call node returning call2341 (depth = 14)
// compiled member node returning call2341 (depth = 13)
  int op_slot_left_2337 = gc_frame_newslot(call2341);
  params[0] = strlit2338;
  partcv[0] = 1;
  Object opresult2342 = callmethod(call2341, "==", 1, partcv, params);
// compiled op node returning opresult2342 (depth = 12)
  int op_slot_left_2329 = gc_frame_newslot(opresult2342);
  params[0] = opresult2335;
  partcv[0] = 1;
  Object opresult2343 = callmethod(opresult2342, "||", 1, partcv, params);
// compiled op node returning opresult2343 (depth = 11)
  int op_slot_right_2328 = gc_frame_newslot(opresult2343);
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_lastToken (depth = 14)
  partcv[0] = 0;
  Object call2347 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2346);
// compiled call node returning call2347 (depth = 13)
// compiled member node returning call2347 (depth = 12)
  int op_slot_right_2345 = gc_frame_newslot(call2347);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2349 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call2350 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2349);
// compiled call node returning call2350 (depth = 13)
// compiled member node returning call2350 (depth = 12)
  int op_slot_left_2345 = gc_frame_newslot(call2350);
  params[0] = call2347;
  partcv[0] = 1;
  Object opresult2351 = callmethod(call2350, "==", 1, partcv, params);
// compiled op node returning opresult2351 (depth = 11)
  int op_slot_left_2328 = gc_frame_newslot(opresult2351);
  params[0] = opresult2343;
  partcv[0] = 1;
  Object opresult2352 = callmethod(opresult2351, "&&", 1, partcv, params);
// compiled op node returning opresult2352 (depth = 10)
  gc_frame_end(frame);
  return opresult2352;
}
Object meth_parser__apply2663(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2664 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2665 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2666 == NULL) {
    strlit2666 = alloc_String("rbrace");
    gc_root(strlit2666);
  }
// compiled string node returning strlit2666 (depth = 11)
  gc_frame_newslot(strlit2666);
// call case 4: self request
  params[0] = strlit2666;
  partcv[0] = 1;
  Object call2667 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2665);
// compiled call node returning call2667 (depth = 10)
  partcv[0] = 0;
  Object call2668 = callmethod(call2667, "not",
    1, partcv, params);
  gc_frame_end(callframe2664);
// compiled call node returning call2668 (depth = 9)
// compiled member node returning call2668 (depth = 8)
  gc_frame_end(frame);
  return call2668;
}
Object meth_parser__apply2676(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2677 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2678 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2677);
// compiled call node returning call2678 (depth = 14)
// compiled member node returning call2678 (depth = 13)
  gc_frame_end(frame);
  return call2678;
}
Object meth_parser__apply2671(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2673 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 11)
  int callframe2674 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block2675 = alloc_Block(NULL, NULL, "parser", 831);
  gc_frame_newslot(block2675);
// method _apply
  block_savedest(block2675);
  Object closure2676 = createclosure(1, "_apply");
  setclosureframe(closure2676, stackframe);
  addtoclosure(closure2676, selfslot);
  struct UserObject *uo2676 = (struct UserObject*)block2675;
  uo2676->data[0] = (Object)closure2676;
  Method *meth_meth_parser__apply2676 = addmethod2pos(block2675, "_apply", &meth_parser__apply2676, 0);
  int argcv_meth_parser__apply2676[] = {0};
  meth_meth_parser__apply2676->type = alloc_MethodType(1, argcv_meth_parser__apply2676);
  meth_meth_parser__apply2676->definitionModule = modulename;
  meth_meth_parser__apply2676->definitionLine = 831;
// compiled block node returning block2675 (depth = 12)
  gc_frame_newslot(block2675);
// call case 4: self request
  params[0] = block2675;
  partcv[0] = 1;
  Object call2680 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2674);
// compiled call node returning call2680 (depth = 11)
  partcv[0] = 0;
  Object call2681 = callmethod(call2680, "not",
    1, partcv, params);
  gc_frame_end(callframe2673);
// compiled call node returning call2681 (depth = 10)
// compiled member node returning call2681 (depth = 9)
  Object if2672 = done;
  if (istrue(call2681)) {
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2682 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2683 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call2684 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2683);
// compiled call node returning call2684 (depth = 13)
// compiled member node returning call2684 (depth = 12)
  partcv[0] = 0;
  Object call2685 = callmethod(call2684, "new",
    1, partcv, params);
  gc_frame_end(callframe2682);
// compiled call node returning call2685 (depth = 11)
// compiled member node returning call2685 (depth = 10)
  *var_suggestion = call2685;
  if (call2685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2686 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_btok (depth = 11)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 11)
  Object bool2687 = alloc_Boolean(0);
// compiled identifier node returning bool2687 (depth = 11)
  gc_frame_newslot(bool2687);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2687;
  partcv[0] = 2;
  Object call2688 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2686);
// compiled call node returning call2688 (depth = 10)
  *var_closingBrace = call2688;
  if (call2688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 9)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool2691 = alloc_Boolean(0);
// compiled identifier node returning bool2691 (depth = 11)
  int op_slot_right_2690 = gc_frame_newslot(bool2691);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2694 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2693);
// compiled call node returning call2694 (depth = 12)
// compiled member node returning call2694 (depth = 11)
  int op_slot_left_2690 = gc_frame_newslot(call2694);
  params[0] = bool2691;
  partcv[0] = 1;
  Object opresult2695 = callmethod(call2694, "==", 1, partcv, params);
// compiled op node returning opresult2695 (depth = 10)
  Object if2689 = done;
  if (istrue(opresult2695)) {
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  int op_slot_right_2697 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2700 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2699);
// compiled call node returning call2700 (depth = 13)
// compiled member node returning call2700 (depth = 12)
  int op_slot_left_2697 = gc_frame_newslot(call2700);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2701 = callmethod(call2700, "==", 1, partcv, params);
// compiled op node returning opresult2701 (depth = 11)
  Object if2696 = done;
  if (istrue(opresult2701)) {
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2702 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2703 == NULL) {
    strlit2703 = alloc_String("}");
    gc_root(strlit2703);
  }
// compiled string node returning strlit2703 (depth = 12)
  gc_frame_newslot(strlit2703);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2703;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2704 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2702);
// compiled call node returning call2704 (depth = 11)
    gc_frame_newslot(call2704);
    if2696 = call2704;
  } else {
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2705 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num2707 = alloc_Float64(0.1);
// compiled num node returning num2707 (depth = 13)
  int op_slot_right_2706 = gc_frame_newslot(num2707);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2709 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 15)
// starting to compile call node (depth = 16)
  int callframe2710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 17)
// compiled identifier node returning *var_closingBrace (depth = 17)
  partcv[0] = 0;
  Object call2711 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2710);
// compiled call node returning call2711 (depth = 16)
// compiled member node returning call2711 (depth = 15)
  partcv[0] = 0;
  Object call2712 = callmethod(call2711, "line",
    1, partcv, params);
  gc_frame_end(callframe2709);
// compiled call node returning call2712 (depth = 14)
// compiled member node returning call2712 (depth = 13)
  int op_slot_left_2706 = gc_frame_newslot(call2712);
  params[0] = num2707;
  partcv[0] = 1;
  Object sum2713 = callmethod(call2712, "+", 1, partcv, params);
// compiled op node returning sum2713 (depth = 12)
  gc_frame_newslot(sum2713);
// starting to compile string node (depth = 12)
  if (strlit2714 == NULL) {
    strlit2714 = alloc_String("}");
    gc_root(strlit2714);
  }
// compiled string node returning strlit2714 (depth = 12)
  gc_frame_newslot(strlit2714);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = sum2713;
  params[1] = strlit2714;
  partcv[0] = 2;
  Object call2715 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2705);
// compiled call node returning call2715 (depth = 11)
    gc_frame_newslot(call2715);
    if2696 = call2715;
  }
// compiled if node returning if2696 (depth = 10)
    gc_frame_newslot(if2696);
    if2689 = if2696;
  } else {
  }
// compiled if node returning if2689 (depth = 9)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2716 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2717 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2716);
// compiled call node returning call2717 (depth = 9)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2718 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2719 == NULL) {
    strlit2719 = alloc_String("An elseif statement must end with a '}'.");
    gc_root(strlit2719);
  }
// compiled string node returning strlit2719 (depth = 10)
  gc_frame_newslot(strlit2719);
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2720 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2721 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2720);
// compiled call node returning call2721 (depth = 11)
// compiled member node returning call2721 (depth = 10)
  gc_frame_newslot(call2721);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2722 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2723 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2722);
// compiled call node returning call2723 (depth = 11)
// compiled member node returning call2723 (depth = 10)
  gc_frame_newslot(call2723);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2719;
  params[1] = call2721;
  params[2] = call2723;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2724 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2718);
// compiled call node returning call2724 (depth = 9)
    gc_frame_newslot(call2724);
    if2672 = call2724;
  } else {
  }
// compiled if node returning if2672 (depth = 8)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2725 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call2726 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2725);
// compiled call node returning call2726 (depth = 10)
// compiled member node returning call2726 (depth = 9)
  *var_v = call2726;
  if (call2726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2728 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_v (depth = 9)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ebody (depth = 9)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2729 = callmethod(*var_ebody, "push",
    1, partcv, params);
  gc_frame_end(callframe2728);
// compiled call node returning call2729 (depth = 8)
  gc_frame_end(frame);
  return call2729;
}
Object meth_parser__apply2127(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_econd = getfromclosure(closure, 6);
  Object *var_ebody = getfromclosure(closure, 7);
  Object *var_btok = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_minInd = getfromclosure(closure, 10);
  Object *var_v = getfromclosure(closure, 11);
  Object *var_newelse = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_opener = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "opener");
  Object *var_closer = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closer");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_closingBrace = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "closingBrace");
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2129 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2130 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2129);
// compiled call node returning call2130 (depth = 7)
// compiled member node returning call2130 (depth = 6)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2132 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2133 = alloc_Block(NULL, NULL, "parser", 701);
  gc_frame_newslot(block2133);
// method _apply
  block_savedest(block2133);
  Object closure2134 = createclosure(2, "_apply");
  setclosureframe(closure2134, stackframe);
  addtoclosure(closure2134, var_sym);
  addtoclosure(closure2134, selfslot);
  struct UserObject *uo2134 = (struct UserObject*)block2133;
  uo2134->data[0] = (Object)closure2134;
  Method *meth_meth_parser__apply2134 = addmethod2pos(block2133, "_apply", &meth_parser__apply2134, 0);
  int argcv_meth_parser__apply2134[] = {0};
  meth_meth_parser__apply2134->type = alloc_MethodType(1, argcv_meth_parser__apply2134);
  meth_meth_parser__apply2134->definitionModule = modulename;
  meth_meth_parser__apply2134->definitionLine = 700;
// compiled block node returning block2133 (depth = 9)
  gc_frame_newslot(block2133);
// call case 6: other member request
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2143 == NULL) {
    strlit2143 = alloc_String("lparen");
    gc_root(strlit2143);
  }
// compiled string node returning strlit2143 (depth = 10)
  int op_slot_right_2142 = gc_frame_newslot(strlit2143);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2146 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2145);
// compiled call node returning call2146 (depth = 11)
// compiled member node returning call2146 (depth = 10)
  int op_slot_left_2142 = gc_frame_newslot(call2146);
  params[0] = strlit2143;
  partcv[0] = 1;
  Object opresult2147 = callmethod(call2146, "==", 1, partcv, params);
// compiled op node returning opresult2147 (depth = 9)
  params[0] = block2133;
  partcv[0] = 1;
  Object call2148 = callmethod(opresult2147, "orElse",
    1, partcv, params);
  gc_frame_end(callframe2132);
// compiled call node returning call2148 (depth = 8)
  Object if2131 = done;
struct StackFrameObject *iftmpstackframe2131 = stackframe;
  if (istrue(call2148)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2131);
gc_frame_newslot((Object)stackframe);
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2150 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2149);
// compiled call node returning call2150 (depth = 9)
// compiled member node returning call2150 (depth = 8)
    gc_frame_newslot(call2150);
    if2131 = call2150;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2131);
  gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2151 == NULL) {
    strlit2151 = alloc_String("-missing-");
    gc_root(strlit2151);
  }
// compiled string node returning strlit2151 (depth = 8)
    gc_frame_newslot(strlit2151);
    if2131 = strlit2151;
  }
stackframe = iftmpstackframe2131;
// compiled if node returning if2131 (depth = 7)
  *var_opener = if2131;
  if (if2131 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile if node (depth = 7)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2154 == NULL) {
    strlit2154 = alloc_String("(");
    gc_root(strlit2154);
  }
// compiled string node returning strlit2154 (depth = 9)
  int op_slot_right_2153 = gc_frame_newslot(strlit2154);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_opener (depth = 9)
  int op_slot_left_2153 = gc_frame_newslot(*var_opener);
  params[0] = strlit2154;
  partcv[0] = 1;
  Object opresult2156 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult2156 (depth = 8)
  Object if2152 = done;
struct StackFrameObject *iftmpstackframe2152 = stackframe;
  if (istrue(opresult2156)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2152);
gc_frame_newslot((Object)stackframe);
// starting to compile string node (depth = 8)
  if (strlit2157 == NULL) {
    strlit2157 = alloc_String(")");
    gc_root(strlit2157);
  }
// compiled string node returning strlit2157 (depth = 8)
    gc_frame_newslot(strlit2157);
    if2152 = strlit2157;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe2152);
  gc_frame_newslot((Object)stackframe);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2160 == NULL) {
    strlit2160 = alloc_String("{");
    gc_root(strlit2160);
  }
// compiled string node returning strlit2160 (depth = 10)
  int op_slot_right_2159 = gc_frame_newslot(strlit2160);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_opener (depth = 10)
  int op_slot_left_2159 = gc_frame_newslot(*var_opener);
  params[0] = strlit2160;
  partcv[0] = 1;
  Object opresult2162 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult2162 (depth = 9)
  Object if2158 = done;
  if (istrue(opresult2162)) {
// starting to compile string node (depth = 9)
  if (strlit2163 == NULL) {
    strlit2163 = alloc_String("}");
    gc_root(strlit2163);
  }
// compiled string node returning strlit2163 (depth = 9)
    gc_frame_newslot(strlit2163);
    if2158 = strlit2163;
  } else {
// starting to compile string node (depth = 9)
  if (strlit2164 == NULL) {
    strlit2164 = alloc_String("-nothing-");
    gc_root(strlit2164);
  }
// compiled string node returning strlit2164 (depth = 9)
    gc_frame_newslot(strlit2164);
    if2158 = strlit2164;
  }
// compiled if node returning if2158 (depth = 8)
    gc_frame_newslot(if2158);
    if2152 = if2158;
  }
stackframe = iftmpstackframe2152;
// compiled if node returning if2152 (depth = 7)
  *var_closer = if2152;
  if (if2152 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2167 == NULL) {
    strlit2167 = alloc_String("-missing-");
    gc_root(strlit2167);
  }
// compiled string node returning strlit2167 (depth = 8)
  int op_slot_right_2166 = gc_frame_newslot(strlit2167);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opener (depth = 8)
  int op_slot_left_2166 = gc_frame_newslot(*var_opener);
  params[0] = strlit2167;
  partcv[0] = 1;
  Object opresult2169 = callmethod(*var_opener, "==", 1, partcv, params);
// compiled op node returning opresult2169 (depth = 7)
  Object if2165 = done;
  if (istrue(opresult2169)) {
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2170 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2172 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2171);
// compiled call node returning call2172 (depth = 11)
// compiled member node returning call2172 (depth = 10)
  partcv[0] = 0;
  Object call2173 = callmethod(call2172, "new",
    1, partcv, params);
  gc_frame_end(callframe2170);
// compiled call node returning call2173 (depth = 9)
// compiled member node returning call2173 (depth = 8)
  *var_suggestion = call2173;
  if (call2173 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2174 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2175 = alloc_Block(NULL, NULL, "parser", 708);
  gc_frame_newslot(block2175);
// method _apply
  block_savedest(block2175);
  Object closure2176 = createclosure(2, "_apply");
  setclosureframe(closure2176, stackframe);
  addtoclosure(closure2176, var_statementToken);
  addtoclosure(closure2176, selfslot);
  struct UserObject *uo2176 = (struct UserObject*)block2175;
  uo2176->data[0] = (Object)closure2176;
  Method *meth_meth_parser__apply2176 = addmethod2pos(block2175, "_apply", &meth_parser__apply2176, 0);
  int argcv_meth_parser__apply2176[] = {1};
  meth_meth_parser__apply2176->type = alloc_MethodType(1, argcv_meth_parser__apply2176);
  meth_meth_parser__apply2176->definitionModule = modulename;
  meth_meth_parser__apply2176->definitionLine = 706;
// compiled block node returning block2175 (depth = 9)
  gc_frame_newslot(block2175);
// call case 4: self request
  params[0] = block2175;
  partcv[0] = 1;
  Object call2230 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2174);
// compiled call node returning call2230 (depth = 8)
  *var_nextTok = call2230;
  if (call2230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2233 = alloc_Boolean(0);
// compiled identifier node returning bool2233 (depth = 9)
  int op_slot_right_2232 = gc_frame_newslot(bool2233);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_2232 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2233;
  partcv[0] = 1;
  Object opresult2235 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2235 (depth = 8)
  Object if2231 = done;
  if (istrue(opresult2235)) {
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2236 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2237 == NULL) {
    strlit2237 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2237);
  }
// compiled string node returning strlit2237 (depth = 9)
  gc_frame_newslot(strlit2237);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_statementToken (depth = 9)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit2237;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2238 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2236);
// compiled call node returning call2238 (depth = 8)
    gc_frame_newslot(call2238);
    if2231 = call2238;
  } else {
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit2241 == NULL) {
    strlit2241 = alloc_String("rparen");
    gc_root(strlit2241);
  }
// compiled string node returning strlit2241 (depth = 10)
  int op_slot_right_2240 = gc_frame_newslot(strlit2241);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2243 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2244 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2243);
// compiled call node returning call2244 (depth = 11)
// compiled member node returning call2244 (depth = 10)
  int op_slot_left_2240 = gc_frame_newslot(call2244);
  params[0] = strlit2241;
  partcv[0] = 1;
  Object opresult2245 = callmethod(call2244, "==", 1, partcv, params);
// compiled op node returning opresult2245 (depth = 9)
  Object if2239 = done;
  if (istrue(opresult2245)) {
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2247 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  int op_slot_left_2247 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2249 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2249 (depth = 10)
  Object if2246 = done;
  if (istrue(opresult2249)) {
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2250 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2251 == NULL) {
    strlit2251 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2251);
  }
// compiled string node returning strlit2251 (depth = 11)
  gc_frame_newslot(strlit2251);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2251;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2252 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2250);
// compiled call node returning call2252 (depth = 10)
    gc_frame_newslot(call2252);
    if2246 = call2252;
  } else {
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2253 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2254 == NULL) {
    strlit2254 = alloc_String("(");
    gc_root(strlit2254);
  }
// compiled string node returning strlit2254 (depth = 11)
  gc_frame_newslot(strlit2254);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2254;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2255 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2253);
// compiled call node returning call2255 (depth = 10)
    gc_frame_newslot(call2255);
    if2246 = call2255;
  }
// compiled if node returning if2246 (depth = 9)
    gc_frame_newslot(if2246);
    if2239 = if2246;
  } else {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2258 == NULL) {
    strlit2258 = alloc_String("lbrace");
    gc_root(strlit2258);
  }
// compiled string node returning strlit2258 (depth = 11)
  int op_slot_right_2257 = gc_frame_newslot(strlit2258);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2260 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2261 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2260);
// compiled call node returning call2261 (depth = 12)
// compiled member node returning call2261 (depth = 11)
  int op_slot_left_2257 = gc_frame_newslot(call2261);
  params[0] = strlit2258;
  partcv[0] = 1;
  Object opresult2262 = callmethod(call2261, "==", 1, partcv, params);
// compiled op node returning opresult2262 (depth = 10)
  Object if2256 = done;
  if (istrue(opresult2262)) {
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  int op_slot_right_2264 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  int op_slot_left_2264 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2266 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2266 (depth = 11)
  Object if2263 = done;
  if (istrue(opresult2266)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2267 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2268 == NULL) {
    strlit2268 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit2268);
  }
// compiled string node returning strlit2268 (depth = 12)
  gc_frame_newslot(strlit2268);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_statementToken (depth = 12)
  gc_frame_newslot(*var_statementToken);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2268;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2269 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2267);
// compiled call node returning call2269 (depth = 11)
    gc_frame_newslot(call2269);
    if2263 = call2269;
  } else {
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2270 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2271 == NULL) {
    strlit2271 = alloc_String("(");
    gc_root(strlit2271);
  }
// compiled string node returning strlit2271 (depth = 12)
  gc_frame_newslot(strlit2271);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2271;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2272 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2270);
// compiled call node returning call2272 (depth = 11)
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe2273 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit2274 == NULL) {
    strlit2274 = alloc_String(") then");
    gc_root(strlit2274);
  }
// compiled string node returning strlit2274 (depth = 12)
  gc_frame_newslot(strlit2274);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2276 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2275);
// compiled call node returning call2276 (depth = 13)
// compiled member node returning call2276 (depth = 12)
  gc_frame_newslot(call2276);
// starting to compile identifier node (depth = 12)
  Object bool2277 = alloc_Boolean(1);
// compiled identifier node returning bool2277 (depth = 12)
  gc_frame_newslot(bool2277);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_suggestion (depth = 12)
  params[0] = strlit2274;
  params[1] = call2276;
  params[2] = bool2277;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2278 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2273);
// compiled call node returning call2278 (depth = 11)
    gc_frame_newslot(call2278);
    if2263 = call2278;
  }
// compiled if node returning if2263 (depth = 10)
    gc_frame_newslot(if2263);
    if2256 = if2263;
  } else {
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit2281 == NULL) {
    strlit2281 = alloc_String("identifier");
    gc_root(strlit2281);
  }
// compiled string node returning strlit2281 (depth = 12)
  int op_slot_right_2280 = gc_frame_newslot(strlit2281);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_nextTok (depth = 14)
  partcv[0] = 0;
  Object call2284 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2283);
// compiled call node returning call2284 (depth = 13)
// compiled member node returning call2284 (depth = 12)
  int op_slot_left_2280 = gc_frame_newslot(call2284);
  params[0] = strlit2281;
  partcv[0] = 1;
  Object opresult2285 = callmethod(call2284, "==", 1, partcv, params);
// compiled op node returning opresult2285 (depth = 11)
  Object if2279 = done;
  if (istrue(opresult2285)) {
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  int op_slot_right_2287 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  int op_slot_left_2287 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2289 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2289 (depth = 12)
  Object if2286 = done;
  if (istrue(opresult2289)) {
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2290 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2291 == NULL) {
    strlit2291 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit2291);
  }
// compiled string node returning strlit2291 (depth = 13)
  gc_frame_newslot(strlit2291);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2291;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2292 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2290);
// compiled call node returning call2292 (depth = 12)
    gc_frame_newslot(call2292);
    if2286 = call2292;
  } else {
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2293 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2294 == NULL) {
    strlit2294 = alloc_String("(");
    gc_root(strlit2294);
  }
// compiled string node returning strlit2294 (depth = 13)
  gc_frame_newslot(strlit2294);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2294;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2295 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2293);
// compiled call node returning call2295 (depth = 12)
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe2296 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit2297 == NULL) {
    strlit2297 = alloc_String(")");
    gc_root(strlit2297);
  }
// compiled string node returning strlit2297 (depth = 13)
  gc_frame_newslot(strlit2297);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_nextTok (depth = 15)
  partcv[0] = 0;
  Object call2299 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2298);
// compiled call node returning call2299 (depth = 14)
// compiled member node returning call2299 (depth = 13)
  gc_frame_newslot(call2299);
// starting to compile identifier node (depth = 13)
  Object bool2300 = alloc_Boolean(1);
// compiled identifier node returning bool2300 (depth = 13)
  gc_frame_newslot(bool2300);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_suggestion (depth = 13)
  params[0] = strlit2297;
  params[1] = call2299;
  params[2] = bool2300;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2301 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2296);
// compiled call node returning call2301 (depth = 12)
    gc_frame_newslot(call2301);
    if2286 = call2301;
  }
// compiled if node returning if2286 (depth = 11)
    gc_frame_newslot(if2286);
    if2279 = if2286;
  } else {
  }
// compiled if node returning if2279 (depth = 10)
    gc_frame_newslot(if2279);
    if2256 = if2279;
  }
// compiled if node returning if2256 (depth = 9)
    gc_frame_newslot(if2256);
    if2239 = if2256;
  }
// compiled if node returning if2239 (depth = 8)
    gc_frame_newslot(if2239);
    if2231 = if2239;
  }
// compiled if node returning if2231 (depth = 7)
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2302 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2303 == NULL) {
    strlit2303 = alloc_String("An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2303);
  }
// compiled string node returning strlit2303 (depth = 8)
  gc_frame_newslot(strlit2303);
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2304 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2305 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2304);
// compiled call node returning call2305 (depth = 9)
// compiled member node returning call2305 (depth = 8)
  gc_frame_newslot(call2305);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2306 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2307 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2306);
// compiled call node returning call2307 (depth = 9)
// compiled member node returning call2307 (depth = 8)
  gc_frame_newslot(call2307);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2303;
  params[1] = call2305;
  params[2] = call2307;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2308 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2302);
// compiled call node returning call2308 (depth = 7)
    gc_frame_newslot(call2308);
    if2165 = call2308;
  } else {
  }
// compiled if node returning if2165 (depth = 6)
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2309 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2310 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2309);
// compiled call node returning call2310 (depth = 7)
// compiled member node returning call2310 (depth = 6)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2312 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2313 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block2314 = alloc_Block(NULL, NULL, "parser", 738);
  gc_frame_newslot(block2314);
// method _apply
  block_savedest(block2314);
  Object closure2315 = createclosure(2, "_apply");
  setclosureframe(closure2315, stackframe);
  addtoclosure(closure2315, var_blocksOK);
  addtoclosure(closure2315, selfslot);
  struct UserObject *uo2315 = (struct UserObject*)block2314;
  uo2315->data[0] = (Object)closure2315;
  Method *meth_meth_parser__apply2315 = addmethod2pos(block2314, "_apply", &meth_parser__apply2315, 0);
  int argcv_meth_parser__apply2315[] = {0};
  meth_meth_parser__apply2315->type = alloc_MethodType(1, argcv_meth_parser__apply2315);
  meth_meth_parser__apply2315->definitionModule = modulename;
  meth_meth_parser__apply2315->definitionLine = 738;
// compiled block node returning block2314 (depth = 10)
  gc_frame_newslot(block2314);
// call case 4: self request
  params[0] = block2314;
  partcv[0] = 1;
  Object call2319 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2313);
// compiled call node returning call2319 (depth = 9)
  partcv[0] = 0;
  Object call2320 = callmethod(call2319, "not",
    1, partcv, params);
  gc_frame_end(callframe2312);
// compiled call node returning call2320 (depth = 8)
// compiled member node returning call2320 (depth = 7)
  Object if2311 = done;
  if (istrue(call2320)) {
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2321 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2322 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2323 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2322);
// compiled call node returning call2323 (depth = 11)
// compiled member node returning call2323 (depth = 10)
  partcv[0] = 0;
  Object call2324 = callmethod(call2323, "new",
    1, partcv, params);
  gc_frame_end(callframe2321);
// compiled call node returning call2324 (depth = 9)
// compiled member node returning call2324 (depth = 8)
  *var_suggestion = call2324;
  if (call2324 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2325 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block2326 = alloc_Block(NULL, NULL, "parser", 741);
  gc_frame_newslot(block2326);
// method _apply
  block_savedest(block2326);
  Object closure2327 = createclosure(2, "_apply");
  setclosureframe(closure2327, stackframe);
  addtoclosure(closure2327, var_lastToken);
  addtoclosure(closure2327, selfslot);
  struct UserObject *uo2327 = (struct UserObject*)block2326;
  uo2327->data[0] = (Object)closure2327;
  Method *meth_meth_parser__apply2327 = addmethod2pos(block2326, "_apply", &meth_parser__apply2327, 0);
  int argcv_meth_parser__apply2327[] = {1};
  meth_meth_parser__apply2327->type = alloc_MethodType(1, argcv_meth_parser__apply2327);
  meth_meth_parser__apply2327->definitionModule = modulename;
  meth_meth_parser__apply2327->definitionLine = 739;
// compiled block node returning block2326 (depth = 9)
  gc_frame_newslot(block2326);
// call case 4: self request
  params[0] = block2326;
  partcv[0] = 1;
  Object call2354 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2325);
// compiled call node returning call2354 (depth = 8)
  *var_nextTok = call2354;
  if (call2354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2357 = alloc_Boolean(0);
// compiled identifier node returning bool2357 (depth = 9)
  int op_slot_right_2356 = gc_frame_newslot(bool2357);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_2356 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2357;
  partcv[0] = 1;
  Object opresult2359 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2359 (depth = 8)
  Object if2355 = done;
  if (istrue(opresult2359)) {
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2360 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2361 == NULL) {
    strlit2361 = alloc_String("rparen");
    gc_root(strlit2361);
  }
// compiled string node returning strlit2361 (depth = 10)
  gc_frame_newslot(strlit2361);
// call case 4: self request
  params[0] = strlit2361;
  partcv[0] = 1;
  Object call2362 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2360);
// compiled call node returning call2362 (depth = 9)
  *var_nextTok = call2362;
  if (call2362 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2365 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2365 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2367 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2367 (depth = 9)
  Object if2364 = done;
  if (istrue(opresult2367)) {
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2368 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2369 == NULL) {
    strlit2369 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2369);
  }
// compiled string node returning strlit2369 (depth = 10)
  gc_frame_newslot(strlit2369);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2369;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2370 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2368);
// compiled call node returning call2370 (depth = 9)
    gc_frame_newslot(call2370);
    if2364 = call2370;
  } else {
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2371 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2372 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2373 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2372);
// compiled call node returning call2373 (depth = 11)
// compiled member node returning call2373 (depth = 10)
  gc_frame_newslot(call2373);
// starting to compile identifier node (depth = 10)
  Object bool2374 = alloc_Boolean(1);
// compiled identifier node returning bool2374 (depth = 10)
  gc_frame_newslot(bool2374);
// starting to compile identifier node (depth = 10)
  Object bool2375 = alloc_Boolean(0);
// compiled identifier node returning bool2375 (depth = 10)
  gc_frame_newslot(bool2375);
// starting to compile string node (depth = 10)
  if (strlit2376 == NULL) {
    strlit2376 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2376);
  }
// compiled string node returning strlit2376 (depth = 10)
  gc_frame_newslot(strlit2376);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2373;
  params[2] = bool2374;
  params[3] = bool2375;
  params[4] = strlit2376;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2377 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2371);
// compiled call node returning call2377 (depth = 9)
    gc_frame_newslot(call2377);
    if2364 = call2377;
  }
// compiled if node returning if2364 (depth = 8)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2378 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2379 == NULL) {
    strlit2379 = alloc_String("An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2379);
  }
// compiled string node returning strlit2379 (depth = 9)
  gc_frame_newslot(strlit2379);
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2381 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2380);
// compiled call node returning call2381 (depth = 10)
// compiled member node returning call2381 (depth = 9)
  gc_frame_newslot(call2381);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2382 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2383 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2382);
// compiled call node returning call2383 (depth = 10)
// compiled member node returning call2383 (depth = 9)
  gc_frame_newslot(call2383);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2379;
  params[1] = call2381;
  params[2] = call2383;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2384 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2378);
// compiled call node returning call2384 (depth = 8)
    gc_frame_newslot(call2384);
    if2355 = call2384;
  } else {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_2386 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_2386 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2388 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult2388 (depth = 9)
  Object if2385 = done;
  if (istrue(opresult2388)) {
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2389 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2390 == NULL) {
    strlit2390 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2390);
  }
// compiled string node returning strlit2390 (depth = 10)
  gc_frame_newslot(strlit2390);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2390;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2391 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2389);
// compiled call node returning call2391 (depth = 9)
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2392 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2393 == NULL) {
    strlit2393 = alloc_String("An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2393);
  }
// compiled string node returning strlit2393 (depth = 10)
  gc_frame_newslot(strlit2393);
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2395 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2394);
// compiled call node returning call2395 (depth = 11)
// compiled member node returning call2395 (depth = 10)
  gc_frame_newslot(call2395);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2397 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2396);
// compiled call node returning call2397 (depth = 11)
// compiled member node returning call2397 (depth = 10)
  gc_frame_newslot(call2397);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2393;
  params[1] = call2395;
  params[2] = call2397;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2398 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2392);
// compiled call node returning call2398 (depth = 9)
    gc_frame_newslot(call2398);
    if2385 = call2398;
  } else {
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2399 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2400 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call2401 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2400);
// compiled call node returning call2401 (depth = 11)
// compiled member node returning call2401 (depth = 10)
  gc_frame_newslot(call2401);
// starting to compile identifier node (depth = 10)
  Object bool2402 = alloc_Boolean(0);
// compiled identifier node returning bool2402 (depth = 10)
  gc_frame_newslot(bool2402);
// starting to compile identifier node (depth = 10)
  Object bool2403 = alloc_Boolean(1);
// compiled identifier node returning bool2403 (depth = 10)
  gc_frame_newslot(bool2403);
// starting to compile string node (depth = 10)
  if (strlit2404 == NULL) {
    strlit2404 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2404);
  }
// compiled string node returning strlit2404 (depth = 10)
  gc_frame_newslot(strlit2404);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call2401;
  params[2] = bool2402;
  params[3] = bool2403;
  params[4] = strlit2404;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2405 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2399);
// compiled call node returning call2405 (depth = 9)
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2406 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2407 == NULL) {
    strlit2407 = alloc_String("4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2407);
  }
// compiled string node returning strlit2407 (depth = 10)
  gc_frame_newslot(strlit2407);
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2408 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2409 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2408);
// compiled call node returning call2409 (depth = 11)
// compiled member node returning call2409 (depth = 10)
  gc_frame_newslot(call2409);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2410 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call2411 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2410);
// compiled call node returning call2411 (depth = 11)
// compiled member node returning call2411 (depth = 10)
  gc_frame_newslot(call2411);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2413 = alloc_Float64(1);
// compiled num node returning num2413 (depth = 11)
  int op_slot_right_2412 = gc_frame_newslot(num2413);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2415 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_nextTok (depth = 13)
  partcv[0] = 0;
  Object call2416 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2415);
// compiled call node returning call2416 (depth = 12)
// compiled member node returning call2416 (depth = 11)
  int op_slot_left_2412 = gc_frame_newslot(call2416);
  params[0] = num2413;
  partcv[0] = 1;
  Object diff2417 = callmethod(call2416, "-", 1, partcv, params);
// compiled op node returning diff2417 (depth = 10)
  gc_frame_newslot(diff2417);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit2407;
  params[1] = call2409;
  params[2] = call2411;
  params[3] = diff2417;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2418 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2406);
// compiled call node returning call2418 (depth = 9)
    gc_frame_newslot(call2418);
    if2385 = call2418;
  }
// compiled if node returning if2385 (depth = 8)
    gc_frame_newslot(if2385);
    if2355 = if2385;
  }
// compiled if node returning if2355 (depth = 7)
    gc_frame_newslot(if2355);
    if2311 = if2355;
  } else {
  }
// compiled if node returning if2311 (depth = 6)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closer (depth = 8)
  int op_slot_right_2420 = gc_frame_newslot(*var_closer);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2422 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2423 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2422);
// compiled call node returning call2423 (depth = 9)
// compiled member node returning call2423 (depth = 8)
  int op_slot_left_2420 = gc_frame_newslot(call2423);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2424 = callmethod(call2423, "!=", 1, partcv, params);
// compiled op node returning opresult2424 (depth = 7)
  Object if2419 = done;
  if (istrue(opresult2424)) {
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2425 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2426 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2425);
// compiled call node returning call2426 (depth = 8)
// compiled member node returning call2426 (depth = 7)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2427 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2428 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2429 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2428);
// compiled call node returning call2429 (depth = 11)
// compiled member node returning call2429 (depth = 10)
  partcv[0] = 0;
  Object call2430 = callmethod(call2429, "new",
    1, partcv, params);
  gc_frame_end(callframe2427);
// compiled call node returning call2430 (depth = 9)
// compiled member node returning call2430 (depth = 8)
  *var_suggestion = call2430;
  if (call2430 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2431 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2432 == NULL) {
    strlit2432 = alloc_String(")");
    gc_root(strlit2432);
  }
// compiled string node returning strlit2432 (depth = 8)
  gc_frame_newslot(strlit2432);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2432;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2433 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2431);
// compiled call node returning call2433 (depth = 7)
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2434 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2436 == NULL) {
    strlit2436 = alloc_String("'.");
    gc_root(strlit2436);
  }
// compiled string node returning strlit2436 (depth = 9)
  int op_slot_right_2435 = gc_frame_newslot(strlit2436);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closer (depth = 10)
  int op_slot_right_2438 = gc_frame_newslot(*var_closer);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit2441 == NULL) {
    strlit2441 = alloc_String("' must end with a '");
    gc_root(strlit2441);
  }
// compiled string node returning strlit2441 (depth = 11)
  int op_slot_right_2440 = gc_frame_newslot(strlit2441);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_opener (depth = 12)
  int op_slot_right_2443 = gc_frame_newslot(*var_opener);
// starting to compile string node (depth = 12)
  if (strlit2445 == NULL) {
    strlit2445 = alloc_String("An expression beginning with a '");
    gc_root(strlit2445);
  }
// compiled string node returning strlit2445 (depth = 12)
  int op_slot_left_2443 = gc_frame_newslot(strlit2445);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult2446 = callmethod(strlit2445, "++", 1, partcv, params);
// compiled op node returning opresult2446 (depth = 11)
  int op_slot_left_2440 = gc_frame_newslot(opresult2446);
  params[0] = strlit2441;
  partcv[0] = 1;
  Object opresult2447 = callmethod(opresult2446, "++", 1, partcv, params);
// compiled op node returning opresult2447 (depth = 10)
  int op_slot_left_2438 = gc_frame_newslot(opresult2447);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2448 = callmethod(opresult2447, "++", 1, partcv, params);
// compiled op node returning opresult2448 (depth = 9)
  int op_slot_left_2435 = gc_frame_newslot(opresult2448);
  params[0] = strlit2436;
  partcv[0] = 1;
  Object opresult2449 = callmethod(opresult2448, "++", 1, partcv, params);
// compiled op node returning opresult2449 (depth = 8)
  gc_frame_newslot(opresult2449);
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2451 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2450);
// compiled call node returning call2451 (depth = 9)
// compiled member node returning call2451 (depth = 8)
  gc_frame_newslot(call2451);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2453 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2454 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2453);
// compiled call node returning call2454 (depth = 10)
// compiled member node returning call2454 (depth = 9)
  int op_slot_right_2452 = gc_frame_newslot(call2454);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2457 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2456);
// compiled call node returning call2457 (depth = 10)
// compiled member node returning call2457 (depth = 9)
  int op_slot_left_2452 = gc_frame_newslot(call2457);
  params[0] = call2454;
  partcv[0] = 1;
  Object sum2458 = callmethod(call2457, "+", 1, partcv, params);
// compiled op node returning sum2458 (depth = 8)
  gc_frame_newslot(sum2458);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = opresult2449;
  params[1] = call2451;
  params[2] = sum2458;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2459 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2434);
// compiled call node returning call2459 (depth = 7)
    gc_frame_newslot(call2459);
    if2419 = call2459;
  } else {
  }
// compiled if node returning if2419 (depth = 6)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2461 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2460);
// compiled call node returning call2461 (depth = 7)
// compiled member node returning call2461 (depth = 6)
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2462 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call2463 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2462);
// compiled call node returning call2463 (depth = 8)
// compiled member node returning call2463 (depth = 7)
  *var_econd = call2463;
  if (call2463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2468 == NULL) {
    strlit2468 = alloc_String("then");
    gc_root(strlit2468);
  }
// compiled string node returning strlit2468 (depth = 9)
  int op_slot_right_2467 = gc_frame_newslot(strlit2468);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2471 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2470);
// compiled call node returning call2471 (depth = 10)
// compiled member node returning call2471 (depth = 9)
  int op_slot_left_2467 = gc_frame_newslot(call2471);
  params[0] = strlit2468;
  partcv[0] = 1;
  Object opresult2472 = callmethod(call2471, "==", 1, partcv, params);
// compiled op node returning opresult2472 (depth = 8)
  int op_slot_right_2466 = gc_frame_newslot(opresult2472);
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2474 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2475 == NULL) {
    strlit2475 = alloc_String("identifier");
    gc_root(strlit2475);
  }
// compiled string node returning strlit2475 (depth = 9)
  gc_frame_newslot(strlit2475);
// call case 4: self request
  params[0] = strlit2475;
  partcv[0] = 1;
  Object call2476 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2474);
// compiled call node returning call2476 (depth = 8)
  int op_slot_left_2466 = gc_frame_newslot(call2476);
  params[0] = opresult2472;
  partcv[0] = 1;
  Object opresult2477 = callmethod(call2476, "&&", 1, partcv, params);
// compiled op node returning opresult2477 (depth = 7)
  Object if2465 = done;
  if (istrue(opresult2477)) {
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2478 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2479 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2478);
// compiled call node returning call2479 (depth = 8)
// compiled member node returning call2479 (depth = 7)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array2480 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2480 (depth = 8)
  *var_ebody = array2480;
  if (array2480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2465 = done;
  } else {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2482 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2484 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2483);
// compiled call node returning call2484 (depth = 11)
// compiled member node returning call2484 (depth = 10)
  partcv[0] = 0;
  Object call2485 = callmethod(call2484, "new",
    1, partcv, params);
  gc_frame_end(callframe2482);
// compiled call node returning call2485 (depth = 9)
// compiled member node returning call2485 (depth = 8)
  *var_suggestion = call2485;
  if (call2485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit2488 == NULL) {
    strlit2488 = alloc_String("lbrace");
    gc_root(strlit2488);
  }
// compiled string node returning strlit2488 (depth = 9)
  int op_slot_right_2487 = gc_frame_newslot(strlit2488);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2490 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2491 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2490);
// compiled call node returning call2491 (depth = 10)
// compiled member node returning call2491 (depth = 9)
  int op_slot_left_2487 = gc_frame_newslot(call2491);
  params[0] = strlit2488;
  partcv[0] = 1;
  Object opresult2492 = callmethod(call2491, "==", 1, partcv, params);
// compiled op node returning opresult2492 (depth = 8)
  Object if2486 = done;
  if (istrue(opresult2492)) {
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2493 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2494 = alloc_Boolean(0);
// compiled identifier node returning bool2494 (depth = 10)
  gc_frame_newslot(bool2494);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2494;
  partcv[0] = 2;
  Object call2495 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2493);
// compiled call node returning call2495 (depth = 9)
  *var_closingBrace = call2495;
  if (call2495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2498 = alloc_Boolean(0);
// compiled identifier node returning bool2498 (depth = 10)
  int op_slot_right_2497 = gc_frame_newslot(bool2498);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2501 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2500);
// compiled call node returning call2501 (depth = 11)
// compiled member node returning call2501 (depth = 10)
  int op_slot_left_2497 = gc_frame_newslot(call2501);
  params[0] = bool2498;
  partcv[0] = 1;
  Object opresult2502 = callmethod(call2501, "==", 1, partcv, params);
// compiled op node returning opresult2502 (depth = 9)
  Object if2496 = done;
  if (istrue(opresult2502)) {
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  int op_slot_right_2504 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2507 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2506);
// compiled call node returning call2507 (depth = 12)
// compiled member node returning call2507 (depth = 11)
  int op_slot_left_2504 = gc_frame_newslot(call2507);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2508 = callmethod(call2507, "==", 1, partcv, params);
// compiled op node returning opresult2508 (depth = 10)
  Object if2503 = done;
  if (istrue(opresult2508)) {
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2509 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2510 = alloc_Boolean(1);
// compiled identifier node returning bool2510 (depth = 11)
  gc_frame_newslot(bool2510);
// starting to compile identifier node (depth = 11)
  Object bool2511 = alloc_Boolean(0);
// compiled identifier node returning bool2511 (depth = 11)
  gc_frame_newslot(bool2511);
// starting to compile string node (depth = 11)
  if (strlit2512 == NULL) {
    strlit2512 = alloc_String(" then {}");
    gc_root(strlit2512);
  }
// compiled string node returning strlit2512 (depth = 11)
  gc_frame_newslot(strlit2512);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2510;
  params[2] = bool2511;
  params[3] = strlit2512;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2513 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2509);
// compiled call node returning call2513 (depth = 10)
    gc_frame_newslot(call2513);
    if2503 = call2513;
  } else {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2514 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 11)
  Object bool2515 = alloc_Boolean(1);
// compiled identifier node returning bool2515 (depth = 11)
  gc_frame_newslot(bool2515);
// starting to compile identifier node (depth = 11)
  Object bool2516 = alloc_Boolean(0);
// compiled identifier node returning bool2516 (depth = 11)
  gc_frame_newslot(bool2516);
// starting to compile string node (depth = 11)
  if (strlit2517 == NULL) {
    strlit2517 = alloc_String(" then {");
    gc_root(strlit2517);
  }
// compiled string node returning strlit2517 (depth = 11)
  gc_frame_newslot(strlit2517);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = *var_sym;
  params[1] = bool2515;
  params[2] = bool2516;
  params[3] = strlit2517;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2518 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2514);
// compiled call node returning call2518 (depth = 10)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2519 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2521 = alloc_Float64(0.1);
// compiled num node returning num2521 (depth = 12)
  int op_slot_right_2520 = gc_frame_newslot(num2521);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2523 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2525 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2524);
// compiled call node returning call2525 (depth = 15)
// compiled member node returning call2525 (depth = 14)
  partcv[0] = 0;
  Object call2526 = callmethod(call2525, "line",
    1, partcv, params);
  gc_frame_end(callframe2523);
// compiled call node returning call2526 (depth = 13)
// compiled member node returning call2526 (depth = 12)
  int op_slot_left_2520 = gc_frame_newslot(call2526);
  params[0] = num2521;
  partcv[0] = 1;
  Object sum2527 = callmethod(call2526, "+", 1, partcv, params);
// compiled op node returning sum2527 (depth = 11)
  gc_frame_newslot(sum2527);
// starting to compile string node (depth = 11)
  if (strlit2528 == NULL) {
    strlit2528 = alloc_String("}");
    gc_root(strlit2528);
  }
// compiled string node returning strlit2528 (depth = 11)
  gc_frame_newslot(strlit2528);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2527;
  params[1] = strlit2528;
  partcv[0] = 2;
  Object call2529 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2519);
// compiled call node returning call2529 (depth = 10)
    gc_frame_newslot(call2529);
    if2503 = call2529;
  }
// compiled if node returning if2503 (depth = 9)
    gc_frame_newslot(if2503);
    if2496 = if2503;
  } else {
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2530 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
  Object bool2531 = alloc_Boolean(1);
// compiled identifier node returning bool2531 (depth = 10)
  gc_frame_newslot(bool2531);
// starting to compile identifier node (depth = 10)
  Object bool2532 = alloc_Boolean(0);
// compiled identifier node returning bool2532 (depth = 10)
  gc_frame_newslot(bool2532);
// starting to compile string node (depth = 10)
  if (strlit2533 == NULL) {
    strlit2533 = alloc_String(" then {");
    gc_root(strlit2533);
  }
// compiled string node returning strlit2533 (depth = 10)
  gc_frame_newslot(strlit2533);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = bool2531;
  params[2] = bool2532;
  params[3] = strlit2533;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2534 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2530);
// compiled call node returning call2534 (depth = 9)
    gc_frame_newslot(call2534);
    if2496 = call2534;
  }
// compiled if node returning if2496 (depth = 8)
    gc_frame_newslot(if2496);
    if2486 = if2496;
  } else {
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2535 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_statementToken (depth = 10)
  gc_frame_newslot(*var_statementToken);
// starting to compile identifier node (depth = 10)
  Object bool2536 = alloc_Boolean(1);
// compiled identifier node returning bool2536 (depth = 10)
  gc_frame_newslot(bool2536);
// call case 4: self request
  params[0] = *var_statementToken;
  params[1] = bool2536;
  partcv[0] = 2;
  Object call2537 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2535);
// compiled call node returning call2537 (depth = 9)
  *var_closingBrace = call2537;
  if (call2537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2540 = alloc_Boolean(0);
// compiled identifier node returning bool2540 (depth = 10)
  int op_slot_right_2539 = gc_frame_newslot(bool2540);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2543 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2542);
// compiled call node returning call2543 (depth = 11)
// compiled member node returning call2543 (depth = 10)
  int op_slot_left_2539 = gc_frame_newslot(call2543);
  params[0] = bool2540;
  partcv[0] = 1;
  Object opresult2544 = callmethod(call2543, "==", 1, partcv, params);
// compiled op node returning opresult2544 (depth = 9)
  Object if2538 = done;
  if (istrue(opresult2544)) {
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2546 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2549 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2548);
// compiled call node returning call2549 (depth = 12)
// compiled member node returning call2549 (depth = 11)
  int op_slot_left_2546 = gc_frame_newslot(call2549);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2550 = callmethod(call2549, "==", 1, partcv, params);
// compiled op node returning opresult2550 (depth = 10)
  Object if2545 = done;
  if (istrue(opresult2550)) {
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2551 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2552 == NULL) {
    strlit2552 = alloc_String(" then {}");
    gc_root(strlit2552);
  }
// compiled string node returning strlit2552 (depth = 11)
  gc_frame_newslot(strlit2552);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2552;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2553 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2551);
// compiled call node returning call2553 (depth = 10)
    gc_frame_newslot(call2553);
    if2545 = call2553;
  } else {
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2554 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2555 == NULL) {
    strlit2555 = alloc_String(" then {");
    gc_root(strlit2555);
  }
// compiled string node returning strlit2555 (depth = 11)
  gc_frame_newslot(strlit2555);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2555;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2556 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2554);
// compiled call node returning call2556 (depth = 10)
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2557 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2559 = alloc_Float64(0.1);
// compiled num node returning num2559 (depth = 12)
  int op_slot_right_2558 = gc_frame_newslot(num2559);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2561 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2563 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2562);
// compiled call node returning call2563 (depth = 15)
// compiled member node returning call2563 (depth = 14)
  partcv[0] = 0;
  Object call2564 = callmethod(call2563, "line",
    1, partcv, params);
  gc_frame_end(callframe2561);
// compiled call node returning call2564 (depth = 13)
// compiled member node returning call2564 (depth = 12)
  int op_slot_left_2558 = gc_frame_newslot(call2564);
  params[0] = num2559;
  partcv[0] = 1;
  Object sum2565 = callmethod(call2564, "+", 1, partcv, params);
// compiled op node returning sum2565 (depth = 11)
  gc_frame_newslot(sum2565);
// starting to compile string node (depth = 11)
  if (strlit2566 == NULL) {
    strlit2566 = alloc_String("}");
    gc_root(strlit2566);
  }
// compiled string node returning strlit2566 (depth = 11)
  gc_frame_newslot(strlit2566);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2565;
  params[1] = strlit2566;
  partcv[0] = 2;
  Object call2567 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2557);
// compiled call node returning call2567 (depth = 10)
    gc_frame_newslot(call2567);
    if2545 = call2567;
  }
// compiled if node returning if2545 (depth = 9)
    gc_frame_newslot(if2545);
    if2538 = if2545;
  } else {
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2568 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2569 == NULL) {
    strlit2569 = alloc_String(" then {");
    gc_root(strlit2569);
  }
// compiled string node returning strlit2569 (depth = 10)
  gc_frame_newslot(strlit2569);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit2569;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2570 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2568);
// compiled call node returning call2570 (depth = 9)
    gc_frame_newslot(call2570);
    if2538 = call2570;
  }
// compiled if node returning if2538 (depth = 8)
    gc_frame_newslot(if2538);
    if2486 = if2538;
  }
// compiled if node returning if2486 (depth = 7)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2571 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2572 == NULL) {
    strlit2572 = alloc_String("An elseif statement must have 'then' after the expression in parentheses.");
    gc_root(strlit2572);
  }
// compiled string node returning strlit2572 (depth = 8)
  gc_frame_newslot(strlit2572);
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2573 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2574 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2573);
// compiled call node returning call2574 (depth = 9)
// compiled member node returning call2574 (depth = 8)
  gc_frame_newslot(call2574);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2575 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2576 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2575);
// compiled call node returning call2576 (depth = 9)
// compiled member node returning call2576 (depth = 8)
  gc_frame_newslot(call2576);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2572;
  params[1] = call2574;
  params[2] = call2576;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2577 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2571);
// compiled call node returning call2577 (depth = 7)
    gc_frame_newslot(call2577);
    if2465 = call2577;
  }
// compiled if node returning if2465 (depth = 6)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 808
  setline(808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2580 == NULL) {
    strlit2580 = alloc_String("lbrace");
    gc_root(strlit2580);
  }
// compiled string node returning strlit2580 (depth = 8)
  int op_slot_right_2579 = gc_frame_newslot(strlit2580);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2582 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2583 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2582);
// compiled call node returning call2583 (depth = 9)
// compiled member node returning call2583 (depth = 8)
  int op_slot_left_2579 = gc_frame_newslot(call2583);
  params[0] = strlit2580;
  partcv[0] = 1;
  Object opresult2584 = callmethod(call2583, "!=", 1, partcv, params);
// compiled op node returning opresult2584 (depth = 7)
  Object if2578 = done;
  if (istrue(opresult2584)) {
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2585 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2586 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call2587 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2586);
// compiled call node returning call2587 (depth = 11)
// compiled member node returning call2587 (depth = 10)
  partcv[0] = 0;
  Object call2588 = callmethod(call2587, "new",
    1, partcv, params);
  gc_frame_end(callframe2585);
// compiled call node returning call2588 (depth = 9)
// compiled member node returning call2588 (depth = 8)
  *var_suggestion = call2588;
  if (call2588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2589 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 9)
  Object bool2590 = alloc_Boolean(1);
// compiled identifier node returning bool2590 (depth = 9)
  gc_frame_newslot(bool2590);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2590;
  partcv[0] = 2;
  Object call2591 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2589);
// compiled call node returning call2591 (depth = 8)
  *var_closingBrace = call2591;
  if (call2591 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool2594 = alloc_Boolean(0);
// compiled identifier node returning bool2594 (depth = 9)
  int op_slot_right_2593 = gc_frame_newslot(bool2594);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2596 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2597 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2596);
// compiled call node returning call2597 (depth = 10)
// compiled member node returning call2597 (depth = 9)
  int op_slot_left_2593 = gc_frame_newslot(call2597);
  params[0] = bool2594;
  partcv[0] = 1;
  Object opresult2598 = callmethod(call2597, "==", 1, partcv, params);
// compiled op node returning opresult2598 (depth = 8)
  Object if2592 = done;
  if (istrue(opresult2598)) {
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  int op_slot_right_2600 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2602 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2603 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2602);
// compiled call node returning call2603 (depth = 11)
// compiled member node returning call2603 (depth = 10)
  int op_slot_left_2600 = gc_frame_newslot(call2603);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2604 = callmethod(call2603, "==", 1, partcv, params);
// compiled op node returning opresult2604 (depth = 9)
  Object if2599 = done;
  if (istrue(opresult2604)) {
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2605 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2606 = alloc_Boolean(0);
// compiled identifier node returning bool2606 (depth = 10)
  gc_frame_newslot(bool2606);
// starting to compile identifier node (depth = 10)
  Object bool2607 = alloc_Boolean(1);
// compiled identifier node returning bool2607 (depth = 10)
  gc_frame_newslot(bool2607);
// starting to compile string node (depth = 10)
  if (strlit2608 == NULL) {
    strlit2608 = alloc_String("then {}");
    gc_root(strlit2608);
  }
// compiled string node returning strlit2608 (depth = 10)
  gc_frame_newslot(strlit2608);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2606;
  params[2] = bool2607;
  params[3] = strlit2608;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2609 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2605);
// compiled call node returning call2609 (depth = 9)
    gc_frame_newslot(call2609);
    if2599 = call2609;
  } else {
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2610 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num2612 = alloc_Float64(0.1);
// compiled num node returning num2612 (depth = 11)
  int op_slot_right_2611 = gc_frame_newslot(num2612);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2614 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe2615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_closingBrace (depth = 15)
  partcv[0] = 0;
  Object call2616 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2615);
// compiled call node returning call2616 (depth = 14)
// compiled member node returning call2616 (depth = 13)
  partcv[0] = 0;
  Object call2617 = callmethod(call2616, "line",
    1, partcv, params);
  gc_frame_end(callframe2614);
// compiled call node returning call2617 (depth = 12)
// compiled member node returning call2617 (depth = 11)
  int op_slot_left_2611 = gc_frame_newslot(call2617);
  params[0] = num2612;
  partcv[0] = 1;
  Object sum2618 = callmethod(call2617, "+", 1, partcv, params);
// compiled op node returning sum2618 (depth = 10)
  gc_frame_newslot(sum2618);
// starting to compile string node (depth = 10)
  if (strlit2619 == NULL) {
    strlit2619 = alloc_String("}");
    gc_root(strlit2619);
  }
// compiled string node returning strlit2619 (depth = 10)
  gc_frame_newslot(strlit2619);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = sum2618;
  params[1] = strlit2619;
  partcv[0] = 2;
  Object call2620 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2610);
// compiled call node returning call2620 (depth = 9)
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe2621 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 10)
  Object bool2622 = alloc_Boolean(0);
// compiled identifier node returning bool2622 (depth = 10)
  gc_frame_newslot(bool2622);
// starting to compile identifier node (depth = 10)
  Object bool2623 = alloc_Boolean(1);
// compiled identifier node returning bool2623 (depth = 10)
  gc_frame_newslot(bool2623);
// starting to compile string node (depth = 10)
  if (strlit2624 == NULL) {
    strlit2624 = alloc_String("then {");
    gc_root(strlit2624);
  }
// compiled string node returning strlit2624 (depth = 10)
  gc_frame_newslot(strlit2624);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  params[1] = bool2622;
  params[2] = bool2623;
  params[3] = strlit2624;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2625 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2621);
// compiled call node returning call2625 (depth = 9)
    gc_frame_newslot(call2625);
    if2599 = call2625;
  }
// compiled if node returning if2599 (depth = 8)
    gc_frame_newslot(if2599);
    if2592 = if2599;
  } else {
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2626 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2627 = alloc_Boolean(0);
// compiled identifier node returning bool2627 (depth = 9)
  gc_frame_newslot(bool2627);
// starting to compile identifier node (depth = 9)
  Object bool2628 = alloc_Boolean(1);
// compiled identifier node returning bool2628 (depth = 9)
  gc_frame_newslot(bool2628);
// starting to compile string node (depth = 9)
  if (strlit2629 == NULL) {
    strlit2629 = alloc_String("then {");
    gc_root(strlit2629);
  }
// compiled string node returning strlit2629 (depth = 9)
  gc_frame_newslot(strlit2629);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2627;
  params[2] = bool2628;
  params[3] = strlit2629;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2630 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2626);
// compiled call node returning call2630 (depth = 8)
    gc_frame_newslot(call2630);
    if2592 = call2630;
  }
// compiled if node returning if2592 (depth = 7)
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2631 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2632 == NULL) {
    strlit2632 = alloc_String("An elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2632);
  }
// compiled string node returning strlit2632 (depth = 8)
  gc_frame_newslot(strlit2632);
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2633 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2634 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2633);
// compiled call node returning call2634 (depth = 9)
// compiled member node returning call2634 (depth = 8)
  gc_frame_newslot(call2634);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2636 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2637 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2636);
// compiled call node returning call2637 (depth = 10)
// compiled member node returning call2637 (depth = 9)
  int op_slot_right_2635 = gc_frame_newslot(call2637);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2639 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call2640 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2639);
// compiled call node returning call2640 (depth = 10)
// compiled member node returning call2640 (depth = 9)
  int op_slot_left_2635 = gc_frame_newslot(call2640);
  params[0] = call2637;
  partcv[0] = 1;
  Object sum2641 = callmethod(call2640, "+", 1, partcv, params);
// compiled op node returning sum2641 (depth = 8)
  gc_frame_newslot(sum2641);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit2632;
  params[1] = call2634;
  params[2] = sum2641;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2642 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2631);
// compiled call node returning call2642 (depth = 7)
    gc_frame_newslot(call2642);
    if2578 = call2642;
  } else {
  }
// compiled if node returning if2578 (depth = 6)
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2644 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2643);
// compiled call node returning call2644 (depth = 7)
// compiled member node returning call2644 (depth = 6)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2647 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2648 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2647);
// compiled call node returning call2648 (depth = 9)
// compiled member node returning call2648 (depth = 8)
  int op_slot_right_2646 = gc_frame_newslot(call2648);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2651 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2650);
// compiled call node returning call2651 (depth = 9)
// compiled member node returning call2651 (depth = 8)
  int op_slot_left_2646 = gc_frame_newslot(call2651);
  params[0] = call2648;
  partcv[0] = 1;
  Object opresult2652 = callmethod(call2651, "==", 1, partcv, params);
// compiled op node returning opresult2652 (depth = 7)
  Object if2645 = done;
  if (istrue(opresult2652)) {
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 9)
  Object num2654 = alloc_Float64(1);
// compiled num node returning num2654 (depth = 9)
  int op_slot_right_2653 = gc_frame_newslot(num2654);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2656 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2657 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2656);
// compiled call node returning call2657 (depth = 10)
// compiled member node returning call2657 (depth = 9)
  int op_slot_left_2653 = gc_frame_newslot(call2657);
  params[0] = num2654;
  partcv[0] = 1;
  Object diff2658 = callmethod(call2657, "-", 1, partcv, params);
// compiled op node returning diff2658 (depth = 8)
  *var_minIndentLevel = diff2658;
  if (diff2658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2645 = done;
  } else {
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minInd (depth = 8)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if2645 = done;
  }
// compiled if node returning if2645 (depth = 6)
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2661 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2662 = alloc_Block(NULL, NULL, "parser", 830);
  gc_frame_newslot(block2662);
// method _apply
  block_savedest(block2662);
  Object closure2663 = createclosure(1, "_apply");
  setclosureframe(closure2663, stackframe);
  addtoclosure(closure2663, selfslot);
  struct UserObject *uo2663 = (struct UserObject*)block2662;
  uo2663->data[0] = (Object)closure2663;
  Method *meth_meth_parser__apply2663 = addmethod2pos(block2662, "_apply", &meth_parser__apply2663, 0);
  int argcv_meth_parser__apply2663[] = {0};
  meth_meth_parser__apply2663->type = alloc_MethodType(1, argcv_meth_parser__apply2663);
  meth_meth_parser__apply2663->definitionModule = modulename;
  meth_meth_parser__apply2663->definitionLine = 826;
// compiled block node returning block2662 (depth = 7)
  gc_frame_newslot(block2662);
// starting to compile block node (depth = 7)
  Object block2670 = alloc_Block(NULL, NULL, "parser", 830);
  gc_frame_newslot(block2670);
// method _apply
  block_savedest(block2670);
  Object closure2671 = createclosure(8, "_apply");
  setclosureframe(closure2671, stackframe);
  addtoclosure(closure2671, var_errormessages);
  addtoclosure(closure2671, var_btok);
  addtoclosure(closure2671, var_lastToken);
  addtoclosure(closure2671, var_sym);
  addtoclosure(closure2671, var_values);
  addtoclosure(closure2671, var_v);
  addtoclosure(closure2671, var_ebody);
  addtoclosure(closure2671, selfslot);
  struct UserObject *uo2671 = (struct UserObject*)block2670;
  uo2671->data[0] = (Object)closure2671;
  Method *meth_meth_parser__apply2671 = addmethod2pos(block2670, "_apply", &meth_parser__apply2671, 0);
  int argcv_meth_parser__apply2671[] = {0};
  meth_meth_parser__apply2671->type = alloc_MethodType(1, argcv_meth_parser__apply2671);
  meth_meth_parser__apply2671->definitionModule = modulename;
  meth_meth_parser__apply2671->definitionLine = 830;
// compiled block node returning block2670 (depth = 7)
  gc_frame_newslot(block2670);
// call case 5: prelude request
  params[0] = block2662;
  params[1] = block2670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2731 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2661);
// compiled call node returning call2731 (depth = 6)
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2732 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2733 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2732);
// compiled call node returning call2733 (depth = 7)
// compiled member node returning call2733 (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array2734 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array2734 (depth = 7)
  *var_newelse = array2734;
  if (array2734 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2736 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_econd (depth = 8)
  gc_frame_newslot(*var_econd);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ebody (depth = 8)
  gc_frame_newslot(*var_ebody);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_newelse (depth = 8)
  gc_frame_newslot(*var_newelse);
// call case 4: self request
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2737 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2736);
// compiled call node returning call2737 (depth = 7)
  *var_eif = call2737;
  if (call2737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2739 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_eif (depth = 7)
  gc_frame_newslot(*var_eif);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_curelse (depth = 7)
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2740 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2739);
// compiled call node returning call2740 (depth = 6)
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newelse (depth = 7)
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply2844(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2845 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe2846 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit2847 == NULL) {
    strlit2847 = alloc_String("rbrace");
    gc_root(strlit2847);
  }
// compiled string node returning strlit2847 (depth = 10)
  gc_frame_newslot(strlit2847);
// call case 4: self request
  params[0] = strlit2847;
  partcv[0] = 1;
  Object call2848 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2846);
// compiled call node returning call2848 (depth = 9)
  partcv[0] = 0;
  Object call2849 = callmethod(call2848, "not",
    1, partcv, params);
  gc_frame_end(callframe2845);
// compiled call node returning call2849 (depth = 8)
// compiled member node returning call2849 (depth = 7)
  gc_frame_end(frame);
  return call2849;
}
Object meth_parser__apply2857(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2858 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2859 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2858);
// compiled call node returning call2859 (depth = 13)
// compiled member node returning call2859 (depth = 12)
  gc_frame_end(frame);
  return call2859;
}
Object meth_parser__apply2852(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2854 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe2855 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block2856 = alloc_Block(NULL, NULL, "parser", 885);
  gc_frame_newslot(block2856);
// method _apply
  block_savedest(block2856);
  Object closure2857 = createclosure(1, "_apply");
  setclosureframe(closure2857, stackframe);
  addtoclosure(closure2857, selfslot);
  struct UserObject *uo2857 = (struct UserObject*)block2856;
  uo2857->data[0] = (Object)closure2857;
  Method *meth_meth_parser__apply2857 = addmethod2pos(block2856, "_apply", &meth_parser__apply2857, 0);
  int argcv_meth_parser__apply2857[] = {0};
  meth_meth_parser__apply2857->type = alloc_MethodType(1, argcv_meth_parser__apply2857);
  meth_meth_parser__apply2857->definitionModule = modulename;
  meth_meth_parser__apply2857->definitionLine = 885;
// compiled block node returning block2856 (depth = 11)
  gc_frame_newslot(block2856);
// call case 4: self request
  params[0] = block2856;
  partcv[0] = 1;
  Object call2861 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2855);
// compiled call node returning call2861 (depth = 10)
  partcv[0] = 0;
  Object call2862 = callmethod(call2861, "not",
    1, partcv, params);
  gc_frame_end(callframe2854);
// compiled call node returning call2862 (depth = 9)
// compiled member node returning call2862 (depth = 8)
  Object if2853 = done;
  if (istrue(call2862)) {
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2863 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call2865 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2864);
// compiled call node returning call2865 (depth = 12)
// compiled member node returning call2865 (depth = 11)
  partcv[0] = 0;
  Object call2866 = callmethod(call2865, "new",
    1, partcv, params);
  gc_frame_end(callframe2863);
// compiled call node returning call2866 (depth = 10)
// compiled member node returning call2866 (depth = 9)
  *var_suggestion = call2866;
  if (call2866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2867 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_btok (depth = 10)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 10)
  Object bool2868 = alloc_Boolean(0);
// compiled identifier node returning bool2868 (depth = 10)
  gc_frame_newslot(bool2868);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2868;
  partcv[0] = 2;
  Object call2869 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2867);
// compiled call node returning call2869 (depth = 9)
  *var_closingBrace = call2869;
  if (call2869 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool2872 = alloc_Boolean(0);
// compiled identifier node returning bool2872 (depth = 10)
  int op_slot_right_2871 = gc_frame_newslot(bool2872);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2874 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call2875 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2874);
// compiled call node returning call2875 (depth = 11)
// compiled member node returning call2875 (depth = 10)
  int op_slot_left_2871 = gc_frame_newslot(call2875);
  params[0] = bool2872;
  partcv[0] = 1;
  Object opresult2876 = callmethod(call2875, "==", 1, partcv, params);
// compiled op node returning opresult2876 (depth = 9)
  Object if2870 = done;
  if (istrue(opresult2876)) {
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  int op_slot_right_2878 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2880 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2881 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2880);
// compiled call node returning call2881 (depth = 12)
// compiled member node returning call2881 (depth = 11)
  int op_slot_left_2878 = gc_frame_newslot(call2881);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2882 = callmethod(call2881, "==", 1, partcv, params);
// compiled op node returning opresult2882 (depth = 10)
  Object if2877 = done;
  if (istrue(opresult2882)) {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2883 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit2884 == NULL) {
    strlit2884 = alloc_String("}");
    gc_root(strlit2884);
  }
// compiled string node returning strlit2884 (depth = 11)
  gc_frame_newslot(strlit2884);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit2884;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2885 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2883);
// compiled call node returning call2885 (depth = 10)
    gc_frame_newslot(call2885);
    if2877 = call2885;
  } else {
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe2886 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num2888 = alloc_Float64(0.1);
// compiled num node returning num2888 (depth = 12)
  int op_slot_right_2887 = gc_frame_newslot(num2888);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2890 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe2891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_closingBrace (depth = 16)
  partcv[0] = 0;
  Object call2892 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2891);
// compiled call node returning call2892 (depth = 15)
// compiled member node returning call2892 (depth = 14)
  partcv[0] = 0;
  Object call2893 = callmethod(call2892, "line",
    1, partcv, params);
  gc_frame_end(callframe2890);
// compiled call node returning call2893 (depth = 13)
// compiled member node returning call2893 (depth = 12)
  int op_slot_left_2887 = gc_frame_newslot(call2893);
  params[0] = num2888;
  partcv[0] = 1;
  Object sum2894 = callmethod(call2893, "+", 1, partcv, params);
// compiled op node returning sum2894 (depth = 11)
  gc_frame_newslot(sum2894);
// starting to compile string node (depth = 11)
  if (strlit2895 == NULL) {
    strlit2895 = alloc_String("}");
    gc_root(strlit2895);
  }
// compiled string node returning strlit2895 (depth = 11)
  gc_frame_newslot(strlit2895);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = sum2894;
  params[1] = strlit2895;
  partcv[0] = 2;
  Object call2896 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2886);
// compiled call node returning call2896 (depth = 10)
    gc_frame_newslot(call2896);
    if2877 = call2896;
  }
// compiled if node returning if2877 (depth = 9)
    gc_frame_newslot(if2877);
    if2870 = if2877;
  } else {
  }
// compiled if node returning if2870 (depth = 8)
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2897 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2898 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2897);
// compiled call node returning call2898 (depth = 8)
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2899 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit2900 == NULL) {
    strlit2900 = alloc_String("An else statement must end with a '}'.");
    gc_root(strlit2900);
  }
// compiled string node returning strlit2900 (depth = 9)
  gc_frame_newslot(strlit2900);
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2902 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2901);
// compiled call node returning call2902 (depth = 10)
// compiled member node returning call2902 (depth = 9)
  gc_frame_newslot(call2902);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2903 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call2904 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2903);
// compiled call node returning call2904 (depth = 10)
// compiled member node returning call2904 (depth = 9)
  gc_frame_newslot(call2904);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit2900;
  params[1] = call2902;
  params[2] = call2904;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2905 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2899);
// compiled call node returning call2905 (depth = 8)
    gc_frame_newslot(call2905);
    if2853 = call2905;
  } else {
  }
// compiled if node returning if2853 (depth = 7)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2906 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call2907 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2906);
// compiled call node returning call2907 (depth = 9)
// compiled member node returning call2907 (depth = 8)
  *var_v = call2907;
  if (call2907 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2909 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curelse (depth = 8)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2910 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2909);
// compiled call node returning call2910 (depth = 7)
  gc_frame_end(frame);
  return call2910;
}
Object meth_parser_doif1647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_statementIndent = getfromclosure(closure, 6);
  Object *var_statementToken = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doif (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doif");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_cond = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "cond");
  Object *var_body = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "body");
  Object *var_elseblock = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "elseblock");
  Object *var_curelse = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "curelse");
  Object *var_v = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "v");
  Object *var_localMin = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "minInd");
  Object *var_closingBrace = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "closingBrace");
  Object *var_econd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "econd");
  Object *var_eif = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "eif");
  Object *var_newelse = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "newelse");
  Object *var_ebody = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "ebody");
  Object *var_o = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "o");
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1651 == NULL) {
    strlit1651 = alloc_String("if");
    gc_root(strlit1651);
  }
// compiled string node returning strlit1651 (depth = 5)
  int op_slot_right_1650 = gc_frame_newslot(strlit1651);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1653 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1654 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1653);
// compiled call node returning call1654 (depth = 6)
// compiled member node returning call1654 (depth = 5)
  int op_slot_left_1650 = gc_frame_newslot(call1654);
  params[0] = strlit1651;
  partcv[0] = 1;
  Object opresult1655 = callmethod(call1654, "==", 1, partcv, params);
// compiled op node returning opresult1655 (depth = 4)
  int op_slot_right_1649 = gc_frame_newslot(opresult1655);
// starting to compile call node (depth = 4)
  int callframe1657 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1658 == NULL) {
    strlit1658 = alloc_String("identifier");
    gc_root(strlit1658);
  }
// compiled string node returning strlit1658 (depth = 5)
  gc_frame_newslot(strlit1658);
// call case 4: self request
  params[0] = strlit1658;
  partcv[0] = 1;
  Object call1659 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1657);
// compiled call node returning call1659 (depth = 4)
  int op_slot_left_1649 = gc_frame_newslot(call1659);
  params[0] = opresult1655;
  partcv[0] = 1;
  Object opresult1660 = callmethod(call1659, "&&", 1, partcv, params);
// compiled op node returning opresult1660 (depth = 3)
  Object if1648 = done;
  if (istrue(opresult1660)) {
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1661 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1662 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1661);
// compiled call node returning call1662 (depth = 4)
// compiled member node returning call1662 (depth = 3)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1665 == NULL) {
    strlit1665 = alloc_String("lparen");
    gc_root(strlit1665);
  }
// compiled string node returning strlit1665 (depth = 5)
  int op_slot_right_1664 = gc_frame_newslot(strlit1665);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1668 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1667);
// compiled call node returning call1668 (depth = 6)
// compiled member node returning call1668 (depth = 5)
  int op_slot_left_1664 = gc_frame_newslot(call1668);
  params[0] = strlit1665;
  partcv[0] = 1;
  Object opresult1669 = callmethod(call1668, "!=", 1, partcv, params);
// compiled op node returning opresult1669 (depth = 4)
  Object if1663 = done;
  if (istrue(opresult1669)) {
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1670 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1672 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1671);
// compiled call node returning call1672 (depth = 8)
// compiled member node returning call1672 (depth = 7)
  partcv[0] = 0;
  Object call1673 = callmethod(call1672, "new",
    1, partcv, params);
  gc_frame_end(callframe1670);
// compiled call node returning call1673 (depth = 6)
// compiled member node returning call1673 (depth = 5)
  *var_suggestion = call1673;
  if (call1673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1674 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1675 = alloc_Block(NULL, NULL, "parser", 570);
  gc_frame_newslot(block1675);
// method _apply
  block_savedest(block1675);
  Object closure1676 = createclosure(2, "_apply");
  setclosureframe(closure1676, stackframe);
  addtoclosure(closure1676, var_btok);
  addtoclosure(closure1676, selfslot);
  struct UserObject *uo1676 = (struct UserObject*)block1675;
  uo1676->data[0] = (Object)closure1676;
  Method *meth_meth_parser__apply1676 = addmethod2pos(block1675, "_apply", &meth_parser__apply1676, 0);
  int argcv_meth_parser__apply1676[] = {1};
  meth_meth_parser__apply1676->type = alloc_MethodType(1, argcv_meth_parser__apply1676);
  meth_meth_parser__apply1676->definitionModule = modulename;
  meth_meth_parser__apply1676->definitionLine = 568;
// compiled block node returning block1675 (depth = 6)
  gc_frame_newslot(block1675);
// call case 4: self request
  params[0] = block1675;
  partcv[0] = 1;
  Object call1721 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1674);
// compiled call node returning call1721 (depth = 5)
  *var_nextTok = call1721;
  if (call1721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1724 = alloc_Boolean(0);
// compiled identifier node returning bool1724 (depth = 6)
  int op_slot_right_1723 = gc_frame_newslot(bool1724);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1723 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1724;
  partcv[0] = 1;
  Object opresult1726 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1726 (depth = 5)
  Object if1722 = done;
  if (istrue(opresult1726)) {
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1727 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1728 == NULL) {
    strlit1728 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1728);
  }
// compiled string node returning strlit1728 (depth = 6)
  gc_frame_newslot(strlit1728);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit1728;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1729 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1727);
// compiled call node returning call1729 (depth = 5)
    gc_frame_newslot(call1729);
    if1722 = call1729;
  } else {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1732 == NULL) {
    strlit1732 = alloc_String("rparen");
    gc_root(strlit1732);
  }
// compiled string node returning strlit1732 (depth = 7)
  int op_slot_right_1731 = gc_frame_newslot(strlit1732);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1735 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1734);
// compiled call node returning call1735 (depth = 8)
// compiled member node returning call1735 (depth = 7)
  int op_slot_left_1731 = gc_frame_newslot(call1735);
  params[0] = strlit1732;
  partcv[0] = 1;
  Object opresult1736 = callmethod(call1735, "==", 1, partcv, params);
// compiled op node returning opresult1736 (depth = 6)
  Object if1730 = done;
  if (istrue(opresult1736)) {
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_1738 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_1738 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1740 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1740 (depth = 7)
  Object if1737 = done;
  if (istrue(opresult1740)) {
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1741 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1742 == NULL) {
    strlit1742 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1742);
  }
// compiled string node returning strlit1742 (depth = 8)
  gc_frame_newslot(strlit1742);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1742;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1743 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1741);
// compiled call node returning call1743 (depth = 7)
    gc_frame_newslot(call1743);
    if1737 = call1743;
  } else {
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1744 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1745 == NULL) {
    strlit1745 = alloc_String("(");
    gc_root(strlit1745);
  }
// compiled string node returning strlit1745 (depth = 8)
  gc_frame_newslot(strlit1745);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit1745;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1746 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1744);
// compiled call node returning call1746 (depth = 7)
    gc_frame_newslot(call1746);
    if1737 = call1746;
  }
// compiled if node returning if1737 (depth = 6)
    gc_frame_newslot(if1737);
    if1730 = if1737;
  } else {
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1749 == NULL) {
    strlit1749 = alloc_String("lbrace");
    gc_root(strlit1749);
  }
// compiled string node returning strlit1749 (depth = 8)
  int op_slot_right_1748 = gc_frame_newslot(strlit1749);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1751 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1752 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1751);
// compiled call node returning call1752 (depth = 9)
// compiled member node returning call1752 (depth = 8)
  int op_slot_left_1748 = gc_frame_newslot(call1752);
  params[0] = strlit1749;
  partcv[0] = 1;
  Object opresult1753 = callmethod(call1752, "==", 1, partcv, params);
// compiled op node returning opresult1753 (depth = 7)
  Object if1747 = done;
  if (istrue(opresult1753)) {
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_1755 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_1755 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1757 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1757 (depth = 8)
  Object if1754 = done;
  if (istrue(opresult1757)) {
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1758 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1759 == NULL) {
    strlit1759 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit1759);
  }
// compiled string node returning strlit1759 (depth = 9)
  gc_frame_newslot(strlit1759);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_btok (depth = 9)
  gc_frame_newslot(*var_btok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1759;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1760 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1758);
// compiled call node returning call1760 (depth = 8)
    gc_frame_newslot(call1760);
    if1754 = call1760;
  } else {
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1761 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1762 == NULL) {
    strlit1762 = alloc_String("(");
    gc_root(strlit1762);
  }
// compiled string node returning strlit1762 (depth = 9)
  gc_frame_newslot(strlit1762);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1762;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1763 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1761);
// compiled call node returning call1763 (depth = 8)
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1764 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit1765 == NULL) {
    strlit1765 = alloc_String(") then");
    gc_root(strlit1765);
  }
// compiled string node returning strlit1765 (depth = 9)
  gc_frame_newslot(strlit1765);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1767 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1766);
// compiled call node returning call1767 (depth = 10)
// compiled member node returning call1767 (depth = 9)
  gc_frame_newslot(call1767);
// starting to compile identifier node (depth = 9)
  Object bool1768 = alloc_Boolean(1);
// compiled identifier node returning bool1768 (depth = 9)
  gc_frame_newslot(bool1768);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit1765;
  params[1] = call1767;
  params[2] = bool1768;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1769 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1764);
// compiled call node returning call1769 (depth = 8)
    gc_frame_newslot(call1769);
    if1754 = call1769;
  }
// compiled if node returning if1754 (depth = 7)
    gc_frame_newslot(if1754);
    if1747 = if1754;
  } else {
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String("identifier");
    gc_root(strlit1772);
  }
// compiled string node returning strlit1772 (depth = 9)
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1774 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call1775 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1774);
// compiled call node returning call1775 (depth = 10)
// compiled member node returning call1775 (depth = 9)
  int op_slot_left_1771 = gc_frame_newslot(call1775);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1776 = callmethod(call1775, "==", 1, partcv, params);
// compiled op node returning opresult1776 (depth = 8)
  Object if1770 = done;
  if (istrue(opresult1776)) {
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_1778 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_1778 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1780 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1780 (depth = 9)
  Object if1777 = done;
  if (istrue(opresult1780)) {
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1781 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1782 == NULL) {
    strlit1782 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit1782);
  }
// compiled string node returning strlit1782 (depth = 10)
  gc_frame_newslot(strlit1782);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1782;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1783 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1781);
// compiled call node returning call1783 (depth = 9)
    gc_frame_newslot(call1783);
    if1777 = call1783;
  } else {
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1784 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1785 == NULL) {
    strlit1785 = alloc_String("(");
    gc_root(strlit1785);
  }
// compiled string node returning strlit1785 (depth = 10)
  gc_frame_newslot(strlit1785);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1785;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1786 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1784);
// compiled call node returning call1786 (depth = 9)
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe1787 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit1788 == NULL) {
    strlit1788 = alloc_String(")");
    gc_root(strlit1788);
  }
// compiled string node returning strlit1788 (depth = 10)
  gc_frame_newslot(strlit1788);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call1790 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1789);
// compiled call node returning call1790 (depth = 11)
// compiled member node returning call1790 (depth = 10)
  gc_frame_newslot(call1790);
// starting to compile identifier node (depth = 10)
  Object bool1791 = alloc_Boolean(1);
// compiled identifier node returning bool1791 (depth = 10)
  gc_frame_newslot(bool1791);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit1788;
  params[1] = call1790;
  params[2] = bool1791;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1792 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1787);
// compiled call node returning call1792 (depth = 9)
    gc_frame_newslot(call1792);
    if1777 = call1792;
  }
// compiled if node returning if1777 (depth = 8)
    gc_frame_newslot(if1777);
    if1770 = if1777;
  } else {
  }
// compiled if node returning if1770 (depth = 7)
    gc_frame_newslot(if1770);
    if1747 = if1770;
  }
// compiled if node returning if1747 (depth = 6)
    gc_frame_newslot(if1747);
    if1730 = if1747;
  }
// compiled if node returning if1730 (depth = 5)
    gc_frame_newslot(if1730);
    if1722 = if1730;
  }
// compiled if node returning if1722 (depth = 4)
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1793 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1794 == NULL) {
    strlit1794 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1794);
  }
// compiled string node returning strlit1794 (depth = 5)
  gc_frame_newslot(strlit1794);
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1796 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1795);
// compiled call node returning call1796 (depth = 6)
// compiled member node returning call1796 (depth = 5)
  gc_frame_newslot(call1796);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1797 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1798 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1797);
// compiled call node returning call1798 (depth = 6)
// compiled member node returning call1798 (depth = 5)
  gc_frame_newslot(call1798);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1794;
  params[1] = call1796;
  params[2] = call1798;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1799 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1793);
// compiled call node returning call1799 (depth = 4)
    gc_frame_newslot(call1799);
    if1663 = call1799;
  } else {
  }
// compiled if node returning if1663 (depth = 3)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1800 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1801 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1800);
// compiled call node returning call1801 (depth = 4)
// compiled member node returning call1801 (depth = 3)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1803 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe1804 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1805 = alloc_Block(NULL, NULL, "parser", 600);
  gc_frame_newslot(block1805);
// method _apply
  block_savedest(block1805);
  Object closure1806 = createclosure(2, "_apply");
  setclosureframe(closure1806, stackframe);
  addtoclosure(closure1806, var_blocksOK);
  addtoclosure(closure1806, selfslot);
  struct UserObject *uo1806 = (struct UserObject*)block1805;
  uo1806->data[0] = (Object)closure1806;
  Method *meth_meth_parser__apply1806 = addmethod2pos(block1805, "_apply", &meth_parser__apply1806, 0);
  int argcv_meth_parser__apply1806[] = {0};
  meth_meth_parser__apply1806->type = alloc_MethodType(1, argcv_meth_parser__apply1806);
  meth_meth_parser__apply1806->definitionModule = modulename;
  meth_meth_parser__apply1806->definitionLine = 600;
// compiled block node returning block1805 (depth = 7)
  gc_frame_newslot(block1805);
// call case 4: self request
  params[0] = block1805;
  partcv[0] = 1;
  Object call1810 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1804);
// compiled call node returning call1810 (depth = 6)
  partcv[0] = 0;
  Object call1811 = callmethod(call1810, "not",
    1, partcv, params);
  gc_frame_end(callframe1803);
// compiled call node returning call1811 (depth = 5)
// compiled member node returning call1811 (depth = 4)
  Object if1802 = done;
  if (istrue(call1811)) {
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1812 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1814 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1813);
// compiled call node returning call1814 (depth = 8)
// compiled member node returning call1814 (depth = 7)
  partcv[0] = 0;
  Object call1815 = callmethod(call1814, "new",
    1, partcv, params);
  gc_frame_end(callframe1812);
// compiled call node returning call1815 (depth = 6)
// compiled member node returning call1815 (depth = 5)
  *var_suggestion = call1815;
  if (call1815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1816 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1817 = alloc_Block(NULL, NULL, "parser", 603);
  gc_frame_newslot(block1817);
// method _apply
  block_savedest(block1817);
  Object closure1818 = createclosure(2, "_apply");
  setclosureframe(closure1818, stackframe);
  addtoclosure(closure1818, var_lastToken);
  addtoclosure(closure1818, selfslot);
  struct UserObject *uo1818 = (struct UserObject*)block1817;
  uo1818->data[0] = (Object)closure1818;
  Method *meth_meth_parser__apply1818 = addmethod2pos(block1817, "_apply", &meth_parser__apply1818, 0);
  int argcv_meth_parser__apply1818[] = {1};
  meth_meth_parser__apply1818->type = alloc_MethodType(1, argcv_meth_parser__apply1818);
  meth_meth_parser__apply1818->definitionModule = modulename;
  meth_meth_parser__apply1818->definitionLine = 601;
// compiled block node returning block1817 (depth = 6)
  gc_frame_newslot(block1817);
// call case 4: self request
  params[0] = block1817;
  partcv[0] = 1;
  Object call1836 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1816);
// compiled call node returning call1836 (depth = 5)
  *var_nextTok = call1836;
  if (call1836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1839 = alloc_Boolean(0);
// compiled identifier node returning bool1839 (depth = 6)
  int op_slot_right_1838 = gc_frame_newslot(bool1839);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_1838 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1839;
  partcv[0] = 1;
  Object opresult1841 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1841 (depth = 5)
  Object if1837 = done;
  if (istrue(opresult1841)) {
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1842 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1843 == NULL) {
    strlit1843 = alloc_String("rparen");
    gc_root(strlit1843);
  }
// compiled string node returning strlit1843 (depth = 7)
  gc_frame_newslot(strlit1843);
// call case 4: self request
  params[0] = strlit1843;
  partcv[0] = 1;
  Object call1844 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1842);
// compiled call node returning call1844 (depth = 6)
  *var_nextTok = call1844;
  if (call1844 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1847 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1847 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1849 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1849 (depth = 6)
  Object if1846 = done;
  if (istrue(opresult1849)) {
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1850 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1851 == NULL) {
    strlit1851 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1851);
  }
// compiled string node returning strlit1851 (depth = 7)
  gc_frame_newslot(strlit1851);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1851;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1852 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1850);
// compiled call node returning call1852 (depth = 6)
    gc_frame_newslot(call1852);
    if1846 = call1852;
  } else {
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1853 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1854 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1855 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1854);
// compiled call node returning call1855 (depth = 8)
// compiled member node returning call1855 (depth = 7)
  gc_frame_newslot(call1855);
// starting to compile identifier node (depth = 7)
  Object bool1856 = alloc_Boolean(1);
// compiled identifier node returning bool1856 (depth = 7)
  gc_frame_newslot(bool1856);
// starting to compile identifier node (depth = 7)
  Object bool1857 = alloc_Boolean(0);
// compiled identifier node returning bool1857 (depth = 7)
  gc_frame_newslot(bool1857);
// starting to compile string node (depth = 7)
  if (strlit1858 == NULL) {
    strlit1858 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1858);
  }
// compiled string node returning strlit1858 (depth = 7)
  gc_frame_newslot(strlit1858);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1855;
  params[2] = bool1856;
  params[3] = bool1857;
  params[4] = strlit1858;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1859 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1853);
// compiled call node returning call1859 (depth = 6)
    gc_frame_newslot(call1859);
    if1846 = call1859;
  }
// compiled if node returning if1846 (depth = 5)
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1860 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1861 == NULL) {
    strlit1861 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1861);
  }
// compiled string node returning strlit1861 (depth = 6)
  gc_frame_newslot(strlit1861);
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1862 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1863 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1862);
// compiled call node returning call1863 (depth = 7)
// compiled member node returning call1863 (depth = 6)
  gc_frame_newslot(call1863);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1865 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1864);
// compiled call node returning call1865 (depth = 7)
// compiled member node returning call1865 (depth = 6)
  gc_frame_newslot(call1865);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit1861;
  params[1] = call1863;
  params[2] = call1865;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1866 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1860);
// compiled call node returning call1866 (depth = 5)
    gc_frame_newslot(call1866);
    if1837 = call1866;
  } else {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_1868 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_1868 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1870 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult1870 (depth = 6)
  Object if1867 = done;
  if (istrue(opresult1870)) {
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1871 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1872 == NULL) {
    strlit1872 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1872);
  }
// compiled string node returning strlit1872 (depth = 7)
  gc_frame_newslot(strlit1872);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit1872;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1873 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1871);
// compiled call node returning call1873 (depth = 6)
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1874 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1875 == NULL) {
    strlit1875 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1875);
  }
// compiled string node returning strlit1875 (depth = 7)
  gc_frame_newslot(strlit1875);
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1876 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1877 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1876);
// compiled call node returning call1877 (depth = 8)
// compiled member node returning call1877 (depth = 7)
  gc_frame_newslot(call1877);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1879 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1878);
// compiled call node returning call1879 (depth = 8)
// compiled member node returning call1879 (depth = 7)
  gc_frame_newslot(call1879);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1875;
  params[1] = call1877;
  params[2] = call1879;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1880 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1874);
// compiled call node returning call1880 (depth = 6)
    gc_frame_newslot(call1880);
    if1867 = call1880;
  } else {
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1881 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1882 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call1883 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1882);
// compiled call node returning call1883 (depth = 8)
// compiled member node returning call1883 (depth = 7)
  gc_frame_newslot(call1883);
// starting to compile identifier node (depth = 7)
  Object bool1884 = alloc_Boolean(0);
// compiled identifier node returning bool1884 (depth = 7)
  gc_frame_newslot(bool1884);
// starting to compile identifier node (depth = 7)
  Object bool1885 = alloc_Boolean(1);
// compiled identifier node returning bool1885 (depth = 7)
  gc_frame_newslot(bool1885);
// starting to compile string node (depth = 7)
  if (strlit1886 == NULL) {
    strlit1886 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1886);
  }
// compiled string node returning strlit1886 (depth = 7)
  gc_frame_newslot(strlit1886);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call1883;
  params[2] = bool1884;
  params[3] = bool1885;
  params[4] = strlit1886;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1887 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1881);
// compiled call node returning call1887 (depth = 6)
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1888 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit1889 == NULL) {
    strlit1889 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1889);
  }
// compiled string node returning strlit1889 (depth = 7)
  gc_frame_newslot(strlit1889);
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1891 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1890);
// compiled call node returning call1891 (depth = 8)
// compiled member node returning call1891 (depth = 7)
  gc_frame_newslot(call1891);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call1893 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1892);
// compiled call node returning call1893 (depth = 8)
// compiled member node returning call1893 (depth = 7)
  gc_frame_newslot(call1893);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1895 = alloc_Float64(1);
// compiled num node returning num1895 (depth = 8)
  int op_slot_right_1894 = gc_frame_newslot(num1895);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1897 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call1898 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1897);
// compiled call node returning call1898 (depth = 9)
// compiled member node returning call1898 (depth = 8)
  int op_slot_left_1894 = gc_frame_newslot(call1898);
  params[0] = num1895;
  partcv[0] = 1;
  Object diff1899 = callmethod(call1898, "-", 1, partcv, params);
// compiled op node returning diff1899 (depth = 7)
  gc_frame_newslot(diff1899);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit1889;
  params[1] = call1891;
  params[2] = call1893;
  params[3] = diff1899;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1900 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1888);
// compiled call node returning call1900 (depth = 6)
    gc_frame_newslot(call1900);
    if1867 = call1900;
  }
// compiled if node returning if1867 (depth = 5)
    gc_frame_newslot(if1867);
    if1837 = if1867;
  }
// compiled if node returning if1837 (depth = 4)
    gc_frame_newslot(if1837);
    if1802 = if1837;
  } else {
  }
// compiled if node returning if1802 (depth = 3)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1903 == NULL) {
    strlit1903 = alloc_String("rparen");
    gc_root(strlit1903);
  }
// compiled string node returning strlit1903 (depth = 5)
  int op_slot_right_1902 = gc_frame_newslot(strlit1903);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1905 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call1906 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1905);
// compiled call node returning call1906 (depth = 6)
// compiled member node returning call1906 (depth = 5)
  int op_slot_left_1902 = gc_frame_newslot(call1906);
  params[0] = strlit1903;
  partcv[0] = 1;
  Object opresult1907 = callmethod(call1906, "!=", 1, partcv, params);
// compiled op node returning opresult1907 (depth = 4)
  Object if1901 = done;
  if (istrue(opresult1907)) {
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1908 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1909 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1908);
// compiled call node returning call1909 (depth = 5)
// compiled member node returning call1909 (depth = 4)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1910 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call1912 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1911);
// compiled call node returning call1912 (depth = 8)
// compiled member node returning call1912 (depth = 7)
  partcv[0] = 0;
  Object call1913 = callmethod(call1912, "new",
    1, partcv, params);
  gc_frame_end(callframe1910);
// compiled call node returning call1913 (depth = 6)
// compiled member node returning call1913 (depth = 5)
  *var_suggestion = call1913;
  if (call1913 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1914 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1915 == NULL) {
    strlit1915 = alloc_String(")");
    gc_root(strlit1915);
  }
// compiled string node returning strlit1915 (depth = 5)
  gc_frame_newslot(strlit1915);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit1915;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1916 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1914);
// compiled call node returning call1916 (depth = 4)
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1917 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1918 == NULL) {
    strlit1918 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit1918);
  }
// compiled string node returning strlit1918 (depth = 5)
  gc_frame_newslot(strlit1918);
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call1920 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1919);
// compiled call node returning call1920 (depth = 6)
// compiled member node returning call1920 (depth = 5)
  gc_frame_newslot(call1920);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1923 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe1922);
// compiled call node returning call1923 (depth = 7)
// compiled member node returning call1923 (depth = 6)
  int op_slot_right_1921 = gc_frame_newslot(call1923);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call1926 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1925);
// compiled call node returning call1926 (depth = 7)
// compiled member node returning call1926 (depth = 6)
  int op_slot_left_1921 = gc_frame_newslot(call1926);
  params[0] = call1923;
  partcv[0] = 1;
  Object sum1927 = callmethod(call1926, "+", 1, partcv, params);
// compiled op node returning sum1927 (depth = 5)
  gc_frame_newslot(sum1927);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit1918;
  params[1] = call1920;
  params[2] = sum1927;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1928 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1917);
// compiled call node returning call1928 (depth = 4)
    gc_frame_newslot(call1928);
    if1901 = call1928;
  } else {
  }
// compiled if node returning if1901 (depth = 3)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1929 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1930 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compiled call node returning call1930 (depth = 4)
// compiled member node returning call1930 (depth = 3)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call1932 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1931);
// compiled call node returning call1932 (depth = 5)
// compiled member node returning call1932 (depth = 4)
  *var_cond = call1932;
  if (call1932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1933 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1933 (depth = 4)
  *var_body = array1933;
  if (array1933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 642
  setline(642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array1934 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1934 (depth = 4)
  *var_elseblock = array1934;
  if (array1934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elseblock (depth = 4)
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_v = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementIndent (depth = 4)
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num1936 = alloc_Float64(1);
// compiled num node returning num1936 (depth = 5)
  int op_slot_right_1935 = gc_frame_newslot(num1936);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_statementIndent (depth = 5)
  int op_slot_left_1935 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1936;
  partcv[0] = 1;
  Object sum1938 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compiled op node returning sum1938 (depth = 4)
  *var_minInd = sum1938;
  if (sum1938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1942 == NULL) {
    strlit1942 = alloc_String("then");
    gc_root(strlit1942);
  }
// compiled string node returning strlit1942 (depth = 6)
  int op_slot_right_1941 = gc_frame_newslot(strlit1942);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1945 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1944);
// compiled call node returning call1945 (depth = 7)
// compiled member node returning call1945 (depth = 6)
  int op_slot_left_1941 = gc_frame_newslot(call1945);
  params[0] = strlit1942;
  partcv[0] = 1;
  Object opresult1946 = callmethod(call1945, "==", 1, partcv, params);
// compiled op node returning opresult1946 (depth = 5)
  int op_slot_right_1940 = gc_frame_newslot(opresult1946);
// starting to compile call node (depth = 5)
  int callframe1948 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit1949 == NULL) {
    strlit1949 = alloc_String("identifier");
    gc_root(strlit1949);
  }
// compiled string node returning strlit1949 (depth = 6)
  gc_frame_newslot(strlit1949);
// call case 4: self request
  params[0] = strlit1949;
  partcv[0] = 1;
  Object call1950 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1948);
// compiled call node returning call1950 (depth = 5)
  int op_slot_left_1940 = gc_frame_newslot(call1950);
  params[0] = opresult1946;
  partcv[0] = 1;
  Object opresult1951 = callmethod(call1950, "&&", 1, partcv, params);
// compiled op node returning opresult1951 (depth = 4)
  Object if1939 = done;
  if (istrue(opresult1951)) {
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1952 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1953 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1952);
// compiled call node returning call1953 (depth = 5)
// compiled member node returning call1953 (depth = 4)
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit1956 == NULL) {
    strlit1956 = alloc_String("lbrace");
    gc_root(strlit1956);
  }
// compiled string node returning strlit1956 (depth = 6)
  int op_slot_right_1955 = gc_frame_newslot(strlit1956);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1958 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call1959 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1958);
// compiled call node returning call1959 (depth = 7)
// compiled member node returning call1959 (depth = 6)
  int op_slot_left_1955 = gc_frame_newslot(call1959);
  params[0] = strlit1956;
  partcv[0] = 1;
  Object opresult1960 = callmethod(call1959, "!=", 1, partcv, params);
// compiled op node returning opresult1960 (depth = 5)
  Object if1954 = done;
  if (istrue(opresult1960)) {
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 651
  setline(651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1961 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call1963 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1962);
// compiled call node returning call1963 (depth = 9)
// compiled member node returning call1963 (depth = 8)
  partcv[0] = 0;
  Object call1964 = callmethod(call1963, "new",
    1, partcv, params);
  gc_frame_end(callframe1961);
// compiled call node returning call1964 (depth = 7)
// compiled member node returning call1964 (depth = 6)
  *var_suggestion = call1964;
  if (call1964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1965 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool1966 = alloc_Boolean(1);
// compiled identifier node returning bool1966 (depth = 7)
  gc_frame_newslot(bool1966);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool1966;
  partcv[0] = 2;
  Object call1967 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1965);
// compiled call node returning call1967 (depth = 6)
  *var_closingBrace = call1967;
  if (call1967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1970 = alloc_Boolean(0);
// compiled identifier node returning bool1970 (depth = 7)
  int op_slot_right_1969 = gc_frame_newslot(bool1970);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call1973 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe1972);
// compiled call node returning call1973 (depth = 8)
// compiled member node returning call1973 (depth = 7)
  int op_slot_left_1969 = gc_frame_newslot(call1973);
  params[0] = bool1970;
  partcv[0] = 1;
  Object opresult1974 = callmethod(call1973, "==", 1, partcv, params);
// compiled op node returning opresult1974 (depth = 6)
  Object if1968 = done;
  if (istrue(opresult1974)) {
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_1976 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call1979 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe1978);
// compiled call node returning call1979 (depth = 9)
// compiled member node returning call1979 (depth = 8)
  int op_slot_left_1976 = gc_frame_newslot(call1979);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult1980 = callmethod(call1979, "==", 1, partcv, params);
// compiled op node returning opresult1980 (depth = 7)
  Object if1975 = done;
  if (istrue(opresult1980)) {
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1981 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1982 = alloc_Boolean(0);
// compiled identifier node returning bool1982 (depth = 8)
  gc_frame_newslot(bool1982);
// starting to compile identifier node (depth = 8)
  Object bool1983 = alloc_Boolean(1);
// compiled identifier node returning bool1983 (depth = 8)
  gc_frame_newslot(bool1983);
// starting to compile string node (depth = 8)
  if (strlit1984 == NULL) {
    strlit1984 = alloc_String("then {}");
    gc_root(strlit1984);
  }
// compiled string node returning strlit1984 (depth = 8)
  gc_frame_newslot(strlit1984);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1982;
  params[2] = bool1983;
  params[3] = strlit1984;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1985 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1981);
// compiled call node returning call1985 (depth = 7)
    gc_frame_newslot(call1985);
    if1975 = call1985;
  } else {
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1986 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1988 = alloc_Float64(0.1);
// compiled num node returning num1988 (depth = 9)
  int op_slot_right_1987 = gc_frame_newslot(num1988);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1990 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1991 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call1992 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe1991);
// compiled call node returning call1992 (depth = 12)
// compiled member node returning call1992 (depth = 11)
  partcv[0] = 0;
  Object call1993 = callmethod(call1992, "line",
    1, partcv, params);
  gc_frame_end(callframe1990);
// compiled call node returning call1993 (depth = 10)
// compiled member node returning call1993 (depth = 9)
  int op_slot_left_1987 = gc_frame_newslot(call1993);
  params[0] = num1988;
  partcv[0] = 1;
  Object sum1994 = callmethod(call1993, "+", 1, partcv, params);
// compiled op node returning sum1994 (depth = 8)
  gc_frame_newslot(sum1994);
// starting to compile string node (depth = 8)
  if (strlit1995 == NULL) {
    strlit1995 = alloc_String("}");
    gc_root(strlit1995);
  }
// compiled string node returning strlit1995 (depth = 8)
  gc_frame_newslot(strlit1995);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum1994;
  params[1] = strlit1995;
  partcv[0] = 2;
  Object call1996 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe1986);
// compiled call node returning call1996 (depth = 7)
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1997 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool1998 = alloc_Boolean(0);
// compiled identifier node returning bool1998 (depth = 8)
  gc_frame_newslot(bool1998);
// starting to compile identifier node (depth = 8)
  Object bool1999 = alloc_Boolean(1);
// compiled identifier node returning bool1999 (depth = 8)
  gc_frame_newslot(bool1999);
// starting to compile string node (depth = 8)
  if (strlit2000 == NULL) {
    strlit2000 = alloc_String("then {");
    gc_root(strlit2000);
  }
// compiled string node returning strlit2000 (depth = 8)
  gc_frame_newslot(strlit2000);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool1998;
  params[2] = bool1999;
  params[3] = strlit2000;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2001 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1997);
// compiled call node returning call2001 (depth = 7)
    gc_frame_newslot(call2001);
    if1975 = call2001;
  }
// compiled if node returning if1975 (depth = 6)
    gc_frame_newslot(if1975);
    if1968 = if1975;
  } else {
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2002 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool2003 = alloc_Boolean(0);
// compiled identifier node returning bool2003 (depth = 7)
  gc_frame_newslot(bool2003);
// starting to compile identifier node (depth = 7)
  Object bool2004 = alloc_Boolean(1);
// compiled identifier node returning bool2004 (depth = 7)
  gc_frame_newslot(bool2004);
// starting to compile string node (depth = 7)
  if (strlit2005 == NULL) {
    strlit2005 = alloc_String("then {");
    gc_root(strlit2005);
  }
// compiled string node returning strlit2005 (depth = 7)
  gc_frame_newslot(strlit2005);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool2003;
  params[2] = bool2004;
  params[3] = strlit2005;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2006 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2002);
// compiled call node returning call2006 (depth = 6)
    gc_frame_newslot(call2006);
    if1968 = call2006;
  }
// compiled if node returning if1968 (depth = 5)
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2007 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit2008 == NULL) {
    strlit2008 = alloc_String("An if statement must have a '{' after the 'then'.");
    gc_root(strlit2008);
  }
// compiled string node returning strlit2008 (depth = 6)
  gc_frame_newslot(strlit2008);
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2010 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2009);
// compiled call node returning call2010 (depth = 7)
// compiled member node returning call2010 (depth = 6)
  gc_frame_newslot(call2010);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2013 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2012);
// compiled call node returning call2013 (depth = 8)
// compiled member node returning call2013 (depth = 7)
  int op_slot_right_2011 = gc_frame_newslot(call2013);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2015 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2016 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2015);
// compiled call node returning call2016 (depth = 8)
// compiled member node returning call2016 (depth = 7)
  int op_slot_left_2011 = gc_frame_newslot(call2016);
  params[0] = call2013;
  partcv[0] = 1;
  Object sum2017 = callmethod(call2016, "+", 1, partcv, params);
// compiled op node returning sum2017 (depth = 6)
  gc_frame_newslot(sum2017);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit2008;
  params[1] = call2010;
  params[2] = sum2017;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2018 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2007);
// compiled call node returning call2018 (depth = 5)
    gc_frame_newslot(call2018);
    if1954 = call2018;
  } else {
  }
// compiled if node returning if1954 (depth = 4)
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2019 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2020 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2019);
// compiled call node returning call2020 (depth = 5)
// compiled member node returning call2020 (depth = 4)
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call2024 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2023);
// compiled call node returning call2024 (depth = 7)
// compiled member node returning call2024 (depth = 6)
  int op_slot_right_2022 = gc_frame_newslot(call2024);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2027 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2026);
// compiled call node returning call2027 (depth = 7)
// compiled member node returning call2027 (depth = 6)
  int op_slot_left_2022 = gc_frame_newslot(call2027);
  params[0] = call2024;
  partcv[0] = 1;
  Object opresult2028 = callmethod(call2027, "==", 1, partcv, params);
// compiled op node returning opresult2028 (depth = 5)
  Object if2021 = done;
  if (istrue(opresult2028)) {
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num2030 = alloc_Float64(1);
// compiled num node returning num2030 (depth = 7)
  int op_slot_right_2029 = gc_frame_newslot(num2030);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2032 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2033 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2032);
// compiled call node returning call2033 (depth = 8)
// compiled member node returning call2033 (depth = 7)
  int op_slot_left_2029 = gc_frame_newslot(call2033);
  params[0] = num2030;
  partcv[0] = 1;
  Object diff2034 = callmethod(call2033, "-", 1, partcv, params);
// compiled op node returning diff2034 (depth = 6)
  *var_minIndentLevel = diff2034;
  if (diff2034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2021 = done;
  } else {
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_minInd (depth = 6)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2021 = done;
  }
// compiled if node returning if2021 (depth = 4)
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2037 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2038 = alloc_Block(NULL, NULL, "parser", 672);
  gc_frame_newslot(block2038);
// method _apply
  block_savedest(block2038);
  Object closure2039 = createclosure(1, "_apply");
  setclosureframe(closure2039, stackframe);
  addtoclosure(closure2039, selfslot);
  struct UserObject *uo2039 = (struct UserObject*)block2038;
  uo2039->data[0] = (Object)closure2039;
  Method *meth_meth_parser__apply2039 = addmethod2pos(block2038, "_apply", &meth_parser__apply2039, 0);
  int argcv_meth_parser__apply2039[] = {0};
  meth_meth_parser__apply2039->type = alloc_MethodType(1, argcv_meth_parser__apply2039);
  meth_meth_parser__apply2039->definitionModule = modulename;
  meth_meth_parser__apply2039->definitionLine = 668;
// compiled block node returning block2038 (depth = 5)
  gc_frame_newslot(block2038);
// starting to compile block node (depth = 5)
  Object block2046 = alloc_Block(NULL, NULL, "parser", 672);
  gc_frame_newslot(block2046);
// method _apply
  block_savedest(block2046);
  Object closure2047 = createclosure(8, "_apply");
  setclosureframe(closure2047, stackframe);
  addtoclosure(closure2047, var_errormessages);
  addtoclosure(closure2047, var_btok);
  addtoclosure(closure2047, var_lastToken);
  addtoclosure(closure2047, var_sym);
  addtoclosure(closure2047, var_values);
  addtoclosure(closure2047, var_v);
  addtoclosure(closure2047, var_body);
  addtoclosure(closure2047, selfslot);
  struct UserObject *uo2047 = (struct UserObject*)block2046;
  uo2047->data[0] = (Object)closure2047;
  Method *meth_meth_parser__apply2047 = addmethod2pos(block2046, "_apply", &meth_parser__apply2047, 0);
  int argcv_meth_parser__apply2047[] = {0};
  meth_meth_parser__apply2047->type = alloc_MethodType(1, argcv_meth_parser__apply2047);
  meth_meth_parser__apply2047->definitionModule = modulename;
  meth_meth_parser__apply2047->definitionLine = 672;
// compiled block node returning block2046 (depth = 5)
  gc_frame_newslot(block2046);
// call case 5: prelude request
  params[0] = block2038;
  params[1] = block2046;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2107 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2037);
// compiled call node returning call2107 (depth = 4)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2109 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2108);
// compiled call node returning call2109 (depth = 5)
// compiled member node returning call2109 (depth = 4)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_econd = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_eif = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_newelse = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_ebody = undefined;
// compiled vardec node returning done (depth = 4)
// starting to compile call node (depth = 4)
  int callframe2110 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2111 = alloc_Block(NULL, NULL, "parser", 695);
  gc_frame_newslot(block2111);
// method _apply
  block_savedest(block2111);
  Object closure2112 = createclosure(2, "_apply");
  setclosureframe(closure2112, stackframe);
  addtoclosure(closure2112, var_sym);
  addtoclosure(closure2112, selfslot);
  struct UserObject *uo2112 = (struct UserObject*)block2111;
  uo2112->data[0] = (Object)closure2112;
  Method *meth_meth_parser__apply2112 = addmethod2pos(block2111, "_apply", &meth_parser__apply2112, 0);
  int argcv_meth_parser__apply2112[] = {0};
  meth_meth_parser__apply2112->type = alloc_MethodType(1, argcv_meth_parser__apply2112);
  meth_meth_parser__apply2112->definitionModule = modulename;
  meth_meth_parser__apply2112->definitionLine = 690;
// compiled block node returning block2111 (depth = 5)
  gc_frame_newslot(block2111);
// starting to compile block node (depth = 5)
  Object block2126 = alloc_Block(NULL, NULL, "parser", 695);
  gc_frame_newslot(block2126);
// method _apply
  block_savedest(block2126);
  Object closure2127 = createclosure(16, "_apply");
  setclosureframe(closure2127, stackframe);
  addtoclosure(closure2127, var_sym);
  addtoclosure(closure2127, var_statementToken);
  addtoclosure(closure2127, var_errormessages);
  addtoclosure(closure2127, var_blocksOK);
  addtoclosure(closure2127, var_lastToken);
  addtoclosure(closure2127, var_values);
  addtoclosure(closure2127, var_econd);
  addtoclosure(closure2127, var_ebody);
  addtoclosure(closure2127, var_btok);
  addtoclosure(closure2127, var_minIndentLevel);
  addtoclosure(closure2127, var_minInd);
  addtoclosure(closure2127, var_v);
  addtoclosure(closure2127, var_newelse);
  addtoclosure(closure2127, var_eif);
  addtoclosure(closure2127, var_curelse);
  addtoclosure(closure2127, selfslot);
  struct UserObject *uo2127 = (struct UserObject*)block2126;
  uo2127->data[0] = (Object)closure2127;
  Method *meth_meth_parser__apply2127 = addmethod2pos(block2126, "_apply", &meth_parser__apply2127, 0);
  int argcv_meth_parser__apply2127[] = {0};
  meth_meth_parser__apply2127->type = alloc_MethodType(1, argcv_meth_parser__apply2127);
  meth_meth_parser__apply2127->definitionModule = modulename;
  meth_meth_parser__apply2127->definitionLine = 695;
// compiled block node returning block2126 (depth = 5)
  gc_frame_newslot(block2126);
// call case 5: prelude request
  params[0] = block2111;
  params[1] = block2126;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2743 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2110);
// compiled call node returning call2743 (depth = 4)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2747 == NULL) {
    strlit2747 = alloc_String("else");
    gc_root(strlit2747);
  }
// compiled string node returning strlit2747 (depth = 7)
  int op_slot_right_2746 = gc_frame_newslot(strlit2747);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2750 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2749);
// compiled call node returning call2750 (depth = 8)
// compiled member node returning call2750 (depth = 7)
  int op_slot_left_2746 = gc_frame_newslot(call2750);
  params[0] = strlit2747;
  partcv[0] = 1;
  Object opresult2751 = callmethod(call2750, "==", 1, partcv, params);
// compiled op node returning opresult2751 (depth = 6)
  int op_slot_right_2745 = gc_frame_newslot(opresult2751);
// starting to compile call node (depth = 6)
  int callframe2753 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2754 == NULL) {
    strlit2754 = alloc_String("identifier");
    gc_root(strlit2754);
  }
// compiled string node returning strlit2754 (depth = 7)
  gc_frame_newslot(strlit2754);
// call case 4: self request
  params[0] = strlit2754;
  partcv[0] = 1;
  Object call2755 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2753);
// compiled call node returning call2755 (depth = 6)
  int op_slot_left_2745 = gc_frame_newslot(call2755);
  params[0] = opresult2751;
  partcv[0] = 1;
  Object opresult2756 = callmethod(call2755, "&&", 1, partcv, params);
// compiled op node returning opresult2756 (depth = 5)
  Object if2744 = done;
  if (istrue(opresult2756)) {
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2757 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2758 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2757);
// compiled call node returning call2758 (depth = 6)
// compiled member node returning call2758 (depth = 5)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2761 == NULL) {
    strlit2761 = alloc_String("lbrace");
    gc_root(strlit2761);
  }
// compiled string node returning strlit2761 (depth = 7)
  int op_slot_right_2760 = gc_frame_newslot(strlit2761);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2764 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2763);
// compiled call node returning call2764 (depth = 8)
// compiled member node returning call2764 (depth = 7)
  int op_slot_left_2760 = gc_frame_newslot(call2764);
  params[0] = strlit2761;
  partcv[0] = 1;
  Object opresult2765 = callmethod(call2764, "!=", 1, partcv, params);
// compiled op node returning opresult2765 (depth = 6)
  Object if2759 = done;
  if (istrue(opresult2765)) {
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2766 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2767 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call2768 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2767);
// compiled call node returning call2768 (depth = 10)
// compiled member node returning call2768 (depth = 9)
  partcv[0] = 0;
  Object call2769 = callmethod(call2768, "new",
    1, partcv, params);
  gc_frame_end(callframe2766);
// compiled call node returning call2769 (depth = 8)
// compiled member node returning call2769 (depth = 7)
  *var_suggestion = call2769;
  if (call2769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2770 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_btok (depth = 8)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 8)
  Object bool2771 = alloc_Boolean(1);
// compiled identifier node returning bool2771 (depth = 8)
  gc_frame_newslot(bool2771);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2771;
  partcv[0] = 2;
  Object call2772 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2770);
// compiled call node returning call2772 (depth = 7)
  *var_closingBrace = call2772;
  if (call2772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool2775 = alloc_Boolean(0);
// compiled identifier node returning bool2775 (depth = 8)
  int op_slot_right_2774 = gc_frame_newslot(bool2775);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2777 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2778 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2777);
// compiled call node returning call2778 (depth = 9)
// compiled member node returning call2778 (depth = 8)
  int op_slot_left_2774 = gc_frame_newslot(call2778);
  params[0] = bool2775;
  partcv[0] = 1;
  Object opresult2779 = callmethod(call2778, "==", 1, partcv, params);
// compiled op node returning opresult2779 (depth = 7)
  Object if2773 = done;
  if (istrue(opresult2779)) {
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  int op_slot_right_2781 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2783 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_closingBrace (depth = 11)
  partcv[0] = 0;
  Object call2784 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2783);
// compiled call node returning call2784 (depth = 10)
// compiled member node returning call2784 (depth = 9)
  int op_slot_left_2781 = gc_frame_newslot(call2784);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2785 = callmethod(call2784, "==", 1, partcv, params);
// compiled op node returning opresult2785 (depth = 8)
  Object if2780 = done;
  if (istrue(opresult2785)) {
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2786 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2787 = alloc_Boolean(0);
// compiled identifier node returning bool2787 (depth = 9)
  gc_frame_newslot(bool2787);
// starting to compile identifier node (depth = 9)
  Object bool2788 = alloc_Boolean(1);
// compiled identifier node returning bool2788 (depth = 9)
  gc_frame_newslot(bool2788);
// starting to compile string node (depth = 9)
  if (strlit2789 == NULL) {
    strlit2789 = alloc_String("else {}");
    gc_root(strlit2789);
  }
// compiled string node returning strlit2789 (depth = 9)
  gc_frame_newslot(strlit2789);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2787;
  params[2] = bool2788;
  params[3] = strlit2789;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2790 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2786);
// compiled call node returning call2790 (depth = 8)
    gc_frame_newslot(call2790);
    if2780 = call2790;
  } else {
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2791 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num2793 = alloc_Float64(0.1);
// compiled num node returning num2793 (depth = 10)
  int op_slot_right_2792 = gc_frame_newslot(num2793);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2795 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe2796 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_closingBrace (depth = 14)
  partcv[0] = 0;
  Object call2797 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2796);
// compiled call node returning call2797 (depth = 13)
// compiled member node returning call2797 (depth = 12)
  partcv[0] = 0;
  Object call2798 = callmethod(call2797, "line",
    1, partcv, params);
  gc_frame_end(callframe2795);
// compiled call node returning call2798 (depth = 11)
// compiled member node returning call2798 (depth = 10)
  int op_slot_left_2792 = gc_frame_newslot(call2798);
  params[0] = num2793;
  partcv[0] = 1;
  Object sum2799 = callmethod(call2798, "+", 1, partcv, params);
// compiled op node returning sum2799 (depth = 9)
  gc_frame_newslot(sum2799);
// starting to compile string node (depth = 9)
  if (strlit2800 == NULL) {
    strlit2800 = alloc_String("}");
    gc_root(strlit2800);
  }
// compiled string node returning strlit2800 (depth = 9)
  gc_frame_newslot(strlit2800);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = sum2799;
  params[1] = strlit2800;
  partcv[0] = 2;
  Object call2801 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2791);
// compiled call node returning call2801 (depth = 8)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2802 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool2803 = alloc_Boolean(0);
// compiled identifier node returning bool2803 (depth = 9)
  gc_frame_newslot(bool2803);
// starting to compile identifier node (depth = 9)
  Object bool2804 = alloc_Boolean(1);
// compiled identifier node returning bool2804 (depth = 9)
  gc_frame_newslot(bool2804);
// starting to compile string node (depth = 9)
  if (strlit2805 == NULL) {
    strlit2805 = alloc_String("else {");
    gc_root(strlit2805);
  }
// compiled string node returning strlit2805 (depth = 9)
  gc_frame_newslot(strlit2805);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = bool2803;
  params[2] = bool2804;
  params[3] = strlit2805;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2806 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2802);
// compiled call node returning call2806 (depth = 8)
    gc_frame_newslot(call2806);
    if2780 = call2806;
  }
// compiled if node returning if2780 (depth = 7)
    gc_frame_newslot(if2780);
    if2773 = if2780;
  } else {
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2807 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool2808 = alloc_Boolean(0);
// compiled identifier node returning bool2808 (depth = 8)
  gc_frame_newslot(bool2808);
// starting to compile identifier node (depth = 8)
  Object bool2809 = alloc_Boolean(1);
// compiled identifier node returning bool2809 (depth = 8)
  gc_frame_newslot(bool2809);
// starting to compile string node (depth = 8)
  if (strlit2810 == NULL) {
    strlit2810 = alloc_String("else {");
    gc_root(strlit2810);
  }
// compiled string node returning strlit2810 (depth = 8)
  gc_frame_newslot(strlit2810);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool2808;
  params[2] = bool2809;
  params[3] = strlit2810;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2811 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2807);
// compiled call node returning call2811 (depth = 7)
    gc_frame_newslot(call2811);
    if2773 = call2811;
  }
// compiled if node returning if2773 (depth = 6)
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2812 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit2813 == NULL) {
    strlit2813 = alloc_String("An else statement must have a '{' after the 'else'.");
    gc_root(strlit2813);
  }
// compiled string node returning strlit2813 (depth = 7)
  gc_frame_newslot(strlit2813);
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2815 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2814);
// compiled call node returning call2815 (depth = 8)
// compiled member node returning call2815 (depth = 7)
  gc_frame_newslot(call2815);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2817 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2818 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2817);
// compiled call node returning call2818 (depth = 9)
// compiled member node returning call2818 (depth = 8)
  int op_slot_right_2816 = gc_frame_newslot(call2818);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2820 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call2821 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2820);
// compiled call node returning call2821 (depth = 9)
// compiled member node returning call2821 (depth = 8)
  int op_slot_left_2816 = gc_frame_newslot(call2821);
  params[0] = call2818;
  partcv[0] = 1;
  Object sum2822 = callmethod(call2821, "+", 1, partcv, params);
// compiled op node returning sum2822 (depth = 7)
  gc_frame_newslot(sum2822);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit2813;
  params[1] = call2815;
  params[2] = sum2822;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2823 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2812);
// compiled call node returning call2823 (depth = 6)
    gc_frame_newslot(call2823);
    if2759 = call2823;
  } else {
  }
// compiled if node returning if2759 (depth = 5)
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2824 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2825 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2824);
// compiled call node returning call2825 (depth = 6)
// compiled member node returning call2825 (depth = 5)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2828 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call2829 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2828);
// compiled call node returning call2829 (depth = 8)
// compiled member node returning call2829 (depth = 7)
  int op_slot_right_2827 = gc_frame_newslot(call2829);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call2832 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2831);
// compiled call node returning call2832 (depth = 8)
// compiled member node returning call2832 (depth = 7)
  int op_slot_left_2827 = gc_frame_newslot(call2832);
  params[0] = call2829;
  partcv[0] = 1;
  Object opresult2833 = callmethod(call2832, "==", 1, partcv, params);
// compiled op node returning opresult2833 (depth = 6)
  Object if2826 = done;
  if (istrue(opresult2833)) {
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num2835 = alloc_Float64(1);
// compiled num node returning num2835 (depth = 8)
  int op_slot_right_2834 = gc_frame_newslot(num2835);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2837 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call2838 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2837);
// compiled call node returning call2838 (depth = 9)
// compiled member node returning call2838 (depth = 8)
  int op_slot_left_2834 = gc_frame_newslot(call2838);
  params[0] = num2835;
  partcv[0] = 1;
  Object diff2839 = callmethod(call2838, "-", 1, partcv, params);
// compiled op node returning diff2839 (depth = 7)
  *var_minIndentLevel = diff2839;
  if (diff2839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2826 = done;
  } else {
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_minInd (depth = 7)
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2826 = done;
  }
// compiled if node returning if2826 (depth = 5)
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2842 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block2843 = alloc_Block(NULL, NULL, "parser", 884);
  gc_frame_newslot(block2843);
// method _apply
  block_savedest(block2843);
  Object closure2844 = createclosure(1, "_apply");
  setclosureframe(closure2844, stackframe);
  addtoclosure(closure2844, selfslot);
  struct UserObject *uo2844 = (struct UserObject*)block2843;
  uo2844->data[0] = (Object)closure2844;
  Method *meth_meth_parser__apply2844 = addmethod2pos(block2843, "_apply", &meth_parser__apply2844, 0);
  int argcv_meth_parser__apply2844[] = {0};
  meth_meth_parser__apply2844->type = alloc_MethodType(1, argcv_meth_parser__apply2844);
  meth_meth_parser__apply2844->definitionModule = modulename;
  meth_meth_parser__apply2844->definitionLine = 880;
// compiled block node returning block2843 (depth = 6)
  gc_frame_newslot(block2843);
// starting to compile block node (depth = 6)
  Object block2851 = alloc_Block(NULL, NULL, "parser", 884);
  gc_frame_newslot(block2851);
// method _apply
  block_savedest(block2851);
  Object closure2852 = createclosure(8, "_apply");
  setclosureframe(closure2852, stackframe);
  addtoclosure(closure2852, var_errormessages);
  addtoclosure(closure2852, var_btok);
  addtoclosure(closure2852, var_lastToken);
  addtoclosure(closure2852, var_sym);
  addtoclosure(closure2852, var_values);
  addtoclosure(closure2852, var_v);
  addtoclosure(closure2852, var_curelse);
  addtoclosure(closure2852, selfslot);
  struct UserObject *uo2852 = (struct UserObject*)block2851;
  uo2852->data[0] = (Object)closure2852;
  Method *meth_meth_parser__apply2852 = addmethod2pos(block2851, "_apply", &meth_parser__apply2852, 0);
  int argcv_meth_parser__apply2852[] = {0};
  meth_meth_parser__apply2852->type = alloc_MethodType(1, argcv_meth_parser__apply2852);
  meth_meth_parser__apply2852->definitionModule = modulename;
  meth_meth_parser__apply2852->definitionLine = 884;
// compiled block node returning block2851 (depth = 6)
  gc_frame_newslot(block2851);
// call case 5: prelude request
  params[0] = block2843;
  params[1] = block2851;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2912 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2842);
// compiled call node returning call2912 (depth = 5)
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2913 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2914 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2913);
// compiled call node returning call2914 (depth = 6)
// compiled member node returning call2914 (depth = 5)
    gc_frame_newslot(call2914);
    if2744 = call2914;
  } else {
  }
// compiled if node returning if2744 (depth = 4)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2915 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cond (depth = 6)
  gc_frame_newslot(*var_cond);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elseblock (depth = 6)
  gc_frame_newslot(*var_elseblock);
// call case 4: self request
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call2916 = callmethodflags(self, "newIf", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2915);
// compiled call node returning call2916 (depth = 5)
  *var_o = call2916;
  if (call2916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2917 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call2918 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe2917);
// compiled call node returning call2918 (depth = 4)
    gc_frame_newslot(call2918);
    if1939 = call2918;
  } else {
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2919 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2920 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call2921 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2920);
// compiled call node returning call2921 (depth = 8)
// compiled member node returning call2921 (depth = 7)
  partcv[0] = 0;
  Object call2922 = callmethod(call2921, "new",
    1, partcv, params);
  gc_frame_end(callframe2919);
// compiled call node returning call2922 (depth = 6)
// compiled member node returning call2922 (depth = 5)
  *var_suggestion = call2922;
  if (call2922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2925 == NULL) {
    strlit2925 = alloc_String("lbrace");
    gc_root(strlit2925);
  }
// compiled string node returning strlit2925 (depth = 6)
  int op_slot_right_2924 = gc_frame_newslot(strlit2925);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2927 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call2928 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2927);
// compiled call node returning call2928 (depth = 7)
// compiled member node returning call2928 (depth = 6)
  int op_slot_left_2924 = gc_frame_newslot(call2928);
  params[0] = strlit2925;
  partcv[0] = 1;
  Object opresult2929 = callmethod(call2928, "==", 1, partcv, params);
// compiled op node returning opresult2929 (depth = 5)
  Object if2923 = done;
  if (istrue(opresult2929)) {
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2930 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2931 = alloc_Boolean(0);
// compiled identifier node returning bool2931 (depth = 7)
  gc_frame_newslot(bool2931);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2931;
  partcv[0] = 2;
  Object call2932 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2930);
// compiled call node returning call2932 (depth = 6)
  *var_closingBrace = call2932;
  if (call2932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2935 = alloc_Boolean(0);
// compiled identifier node returning bool2935 (depth = 7)
  int op_slot_right_2934 = gc_frame_newslot(bool2935);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2938 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2937);
// compiled call node returning call2938 (depth = 8)
// compiled member node returning call2938 (depth = 7)
  int op_slot_left_2934 = gc_frame_newslot(call2938);
  params[0] = bool2935;
  partcv[0] = 1;
  Object opresult2939 = callmethod(call2938, "==", 1, partcv, params);
// compiled op node returning opresult2939 (depth = 6)
  Object if2933 = done;
  if (istrue(opresult2939)) {
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_2941 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2943 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2944 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2943);
// compiled call node returning call2944 (depth = 9)
// compiled member node returning call2944 (depth = 8)
  int op_slot_left_2941 = gc_frame_newslot(call2944);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2945 = callmethod(call2944, "==", 1, partcv, params);
// compiled op node returning opresult2945 (depth = 7)
  Object if2940 = done;
  if (istrue(opresult2945)) {
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2946 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2947 = alloc_Boolean(1);
// compiled identifier node returning bool2947 (depth = 8)
  gc_frame_newslot(bool2947);
// starting to compile identifier node (depth = 8)
  Object bool2948 = alloc_Boolean(0);
// compiled identifier node returning bool2948 (depth = 8)
  gc_frame_newslot(bool2948);
// starting to compile string node (depth = 8)
  if (strlit2949 == NULL) {
    strlit2949 = alloc_String(" then {}");
    gc_root(strlit2949);
  }
// compiled string node returning strlit2949 (depth = 8)
  gc_frame_newslot(strlit2949);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2947;
  params[2] = bool2948;
  params[3] = strlit2949;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2950 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2946);
// compiled call node returning call2950 (depth = 7)
    gc_frame_newslot(call2950);
    if2940 = call2950;
  } else {
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2951 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool2952 = alloc_Boolean(1);
// compiled identifier node returning bool2952 (depth = 8)
  gc_frame_newslot(bool2952);
// starting to compile identifier node (depth = 8)
  Object bool2953 = alloc_Boolean(0);
// compiled identifier node returning bool2953 (depth = 8)
  gc_frame_newslot(bool2953);
// starting to compile string node (depth = 8)
  if (strlit2954 == NULL) {
    strlit2954 = alloc_String(" then {");
    gc_root(strlit2954);
  }
// compiled string node returning strlit2954 (depth = 8)
  gc_frame_newslot(strlit2954);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool2952;
  params[2] = bool2953;
  params[3] = strlit2954;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2955 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2951);
// compiled call node returning call2955 (depth = 7)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2956 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2958 = alloc_Float64(0.1);
// compiled num node returning num2958 (depth = 9)
  int op_slot_right_2957 = gc_frame_newslot(num2958);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2960 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call2962 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2961);
// compiled call node returning call2962 (depth = 12)
// compiled member node returning call2962 (depth = 11)
  partcv[0] = 0;
  Object call2963 = callmethod(call2962, "line",
    1, partcv, params);
  gc_frame_end(callframe2960);
// compiled call node returning call2963 (depth = 10)
// compiled member node returning call2963 (depth = 9)
  int op_slot_left_2957 = gc_frame_newslot(call2963);
  params[0] = num2958;
  partcv[0] = 1;
  Object sum2964 = callmethod(call2963, "+", 1, partcv, params);
// compiled op node returning sum2964 (depth = 8)
  gc_frame_newslot(sum2964);
// starting to compile string node (depth = 8)
  if (strlit2965 == NULL) {
    strlit2965 = alloc_String("}");
    gc_root(strlit2965);
  }
// compiled string node returning strlit2965 (depth = 8)
  gc_frame_newslot(strlit2965);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum2964;
  params[1] = strlit2965;
  partcv[0] = 2;
  Object call2966 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2956);
// compiled call node returning call2966 (depth = 7)
    gc_frame_newslot(call2966);
    if2940 = call2966;
  }
// compiled if node returning if2940 (depth = 6)
    gc_frame_newslot(if2940);
    if2933 = if2940;
  } else {
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2967 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool2968 = alloc_Boolean(1);
// compiled identifier node returning bool2968 (depth = 7)
  gc_frame_newslot(bool2968);
// starting to compile identifier node (depth = 7)
  Object bool2969 = alloc_Boolean(0);
// compiled identifier node returning bool2969 (depth = 7)
  gc_frame_newslot(bool2969);
// starting to compile string node (depth = 7)
  if (strlit2970 == NULL) {
    strlit2970 = alloc_String(" then {");
    gc_root(strlit2970);
  }
// compiled string node returning strlit2970 (depth = 7)
  gc_frame_newslot(strlit2970);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool2968;
  params[2] = bool2969;
  params[3] = strlit2970;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2971 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2967);
// compiled call node returning call2971 (depth = 6)
    gc_frame_newslot(call2971);
    if2933 = call2971;
  }
// compiled if node returning if2933 (depth = 5)
    gc_frame_newslot(if2933);
    if2923 = if2933;
  } else {
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2972 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool2973 = alloc_Boolean(1);
// compiled identifier node returning bool2973 (depth = 7)
  gc_frame_newslot(bool2973);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool2973;
  partcv[0] = 2;
  Object call2974 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2972);
// compiled call node returning call2974 (depth = 6)
  *var_closingBrace = call2974;
  if (call2974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2977 = alloc_Boolean(0);
// compiled identifier node returning bool2977 (depth = 7)
  int op_slot_right_2976 = gc_frame_newslot(bool2977);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2979 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call2980 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2979);
// compiled call node returning call2980 (depth = 8)
// compiled member node returning call2980 (depth = 7)
  int op_slot_left_2976 = gc_frame_newslot(call2980);
  params[0] = bool2977;
  partcv[0] = 1;
  Object opresult2981 = callmethod(call2980, "==", 1, partcv, params);
// compiled op node returning opresult2981 (depth = 6)
  Object if2975 = done;
  if (istrue(opresult2981)) {
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  int op_slot_right_2983 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call2986 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2985);
// compiled call node returning call2986 (depth = 9)
// compiled member node returning call2986 (depth = 8)
  int op_slot_left_2983 = gc_frame_newslot(call2986);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2987 = callmethod(call2986, "==", 1, partcv, params);
// compiled op node returning opresult2987 (depth = 7)
  Object if2982 = done;
  if (istrue(opresult2987)) {
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2988 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2989 == NULL) {
    strlit2989 = alloc_String(" then {}");
    gc_root(strlit2989);
  }
// compiled string node returning strlit2989 (depth = 8)
  gc_frame_newslot(strlit2989);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2989;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2990 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2988);
// compiled call node returning call2990 (depth = 7)
    gc_frame_newslot(call2990);
    if2982 = call2990;
  } else {
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2991 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit2992 == NULL) {
    strlit2992 = alloc_String(" then {");
    gc_root(strlit2992);
  }
// compiled string node returning strlit2992 (depth = 8)
  gc_frame_newslot(strlit2992);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit2992;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2993 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2991);
// compiled call node returning call2993 (depth = 7)
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe2994 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2996 = alloc_Float64(0.1);
// compiled num node returning num2996 (depth = 9)
  int op_slot_right_2995 = gc_frame_newslot(num2996);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2998 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe2999 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call3000 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2999);
// compiled call node returning call3000 (depth = 12)
// compiled member node returning call3000 (depth = 11)
  partcv[0] = 0;
  Object call3001 = callmethod(call3000, "line",
    1, partcv, params);
  gc_frame_end(callframe2998);
// compiled call node returning call3001 (depth = 10)
// compiled member node returning call3001 (depth = 9)
  int op_slot_left_2995 = gc_frame_newslot(call3001);
  params[0] = num2996;
  partcv[0] = 1;
  Object sum3002 = callmethod(call3001, "+", 1, partcv, params);
// compiled op node returning sum3002 (depth = 8)
  gc_frame_newslot(sum3002);
// starting to compile string node (depth = 8)
  if (strlit3003 == NULL) {
    strlit3003 = alloc_String("}");
    gc_root(strlit3003);
  }
// compiled string node returning strlit3003 (depth = 8)
  gc_frame_newslot(strlit3003);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum3002;
  params[1] = strlit3003;
  partcv[0] = 2;
  Object call3004 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2994);
// compiled call node returning call3004 (depth = 7)
    gc_frame_newslot(call3004);
    if2982 = call3004;
  }
// compiled if node returning if2982 (depth = 6)
    gc_frame_newslot(if2982);
    if2975 = if2982;
  } else {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3005 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3006 == NULL) {
    strlit3006 = alloc_String(" then {");
    gc_root(strlit3006);
  }
// compiled string node returning strlit3006 (depth = 7)
  gc_frame_newslot(strlit3006);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3006;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3007 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3005);
// compiled call node returning call3007 (depth = 6)
    gc_frame_newslot(call3007);
    if2975 = call3007;
  }
// compiled if node returning if2975 (depth = 5)
    gc_frame_newslot(if2975);
    if2923 = if2975;
  }
// compiled if node returning if2923 (depth = 4)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3008 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3009 == NULL) {
    strlit3009 = alloc_String("An if statement must have 'then' after the expression in parentheses.");
    gc_root(strlit3009);
  }
// compiled string node returning strlit3009 (depth = 5)
  gc_frame_newslot(strlit3009);
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3010 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3011 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3010);
// compiled call node returning call3011 (depth = 6)
// compiled member node returning call3011 (depth = 5)
  gc_frame_newslot(call3011);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3013 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3012);
// compiled call node returning call3013 (depth = 6)
// compiled member node returning call3013 (depth = 5)
  gc_frame_newslot(call3013);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3009;
  params[1] = call3011;
  params[2] = call3013;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3014 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3008);
// compiled call node returning call3014 (depth = 4)
    gc_frame_newslot(call3014);
    if1939 = call3014;
  }
// compiled if node returning if1939 (depth = 3)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMin (depth = 4)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localStatementIndent (depth = 4)
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if1648 = done;
  } else {
  }
// compiled if node returning if1648 (depth = 2)
  gc_frame_end(frame);
  return if1648;
}
Object meth_parser_identifier3017(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifier (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for identifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3019 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3020 == NULL) {
    strlit3020 = alloc_String("identifier");
    gc_root(strlit3020);
  }
// compiled string node returning strlit3020 (depth = 4)
  gc_frame_newslot(strlit3020);
// call case 4: self request
  params[0] = strlit3020;
  partcv[0] = 1;
  Object call3021 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3019);
// compiled call node returning call3021 (depth = 3)
  Object if3018 = done;
  if (istrue(call3021)) {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3024 == NULL) {
    strlit3024 = alloc_String("if");
    gc_root(strlit3024);
  }
// compiled string node returning strlit3024 (depth = 5)
  int op_slot_right_3023 = gc_frame_newslot(strlit3024);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3026 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3027 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3026);
// compiled call node returning call3027 (depth = 6)
// compiled member node returning call3027 (depth = 5)
  int op_slot_left_3023 = gc_frame_newslot(call3027);
  params[0] = strlit3024;
  partcv[0] = 1;
  Object opresult3028 = callmethod(call3027, "==", 1, partcv, params);
// compiled op node returning opresult3028 (depth = 4)
  Object if3022 = done;
  if (istrue(opresult3028)) {
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3030 = callmethodflags(self, "doif", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3029);
// compiled call node returning call3030 (depth = 5)
// compiled member node returning call3030 (depth = 4)
    gc_frame_newslot(call3030);
    if3022 = call3030;
  } else {
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3031 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3032 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3031);
// compiled call node returning call3032 (depth = 5)
// compiled member node returning call3032 (depth = 4)
    gc_frame_newslot(call3032);
    if3022 = call3032;
  }
// compiled if node returning if3022 (depth = 3)
    gc_frame_newslot(if3022);
    if3018 = if3022;
  } else {
  }
// compiled if node returning if3018 (depth = 2)
  gc_frame_end(frame);
  return if3018;
}
Object meth_parser__apply3052(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe3053 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3054 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3053);
// compiled call node returning call3054 (depth = 9)
  gc_frame_end(frame);
  return call3054;
}
Object meth_parser__apply3120(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3121 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3122 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3121);
// compiled call node returning call3122 (depth = 10)
// compiled member node returning call3122 (depth = 9)
  gc_frame_end(frame);
  return call3122;
}
Object meth_parser_prefixop3033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for prefixop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for prefixop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_op = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "op");
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_mem = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "mem");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3035 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3036 == NULL) {
    strlit3036 = alloc_String("op");
    gc_root(strlit3036);
  }
// compiled string node returning strlit3036 (depth = 4)
  gc_frame_newslot(strlit3036);
// call case 4: self request
  params[0] = strlit3036;
  partcv[0] = 1;
  Object call3037 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3035);
// compiled call node returning call3037 (depth = 3)
  Object if3034 = done;
  if (istrue(call3037)) {
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3039 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3038);
// compiled call node returning call3039 (depth = 5)
// compiled member node returning call3039 (depth = 4)
  *var_op = call3039;
  if (call3039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_val = undefined;
// compiled vardec node returning done (depth = 3)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3040 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3041 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3040);
// compiled call node returning call3041 (depth = 4)
// compiled member node returning call3041 (depth = 3)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3043 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3044 == NULL) {
    strlit3044 = alloc_String("lparen");
    gc_root(strlit3044);
  }
// compiled string node returning strlit3044 (depth = 5)
  gc_frame_newslot(strlit3044);
// call case 4: self request
  params[0] = strlit3044;
  partcv[0] = 1;
  Object call3045 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3043);
// compiled call node returning call3045 (depth = 4)
  Object if3042 = done;
  if (istrue(call3045)) {
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3046 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3047 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3046);
// compiled call node returning call3047 (depth = 5)
// compiled member node returning call3047 (depth = 4)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3049 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3050 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3051 = alloc_Block(NULL, NULL, "parser", 961);
  gc_frame_newslot(block3051);
// method _apply
  block_savedest(block3051);
  Object closure3052 = createclosure(2, "_apply");
  setclosureframe(closure3052, stackframe);
  addtoclosure(closure3052, var_blocksOK);
  addtoclosure(closure3052, selfslot);
  struct UserObject *uo3052 = (struct UserObject*)block3051;
  uo3052->data[0] = (Object)closure3052;
  Method *meth_meth_parser__apply3052 = addmethod2pos(block3051, "_apply", &meth_parser__apply3052, 0);
  int argcv_meth_parser__apply3052[] = {0};
  meth_meth_parser__apply3052->type = alloc_MethodType(1, argcv_meth_parser__apply3052);
  meth_meth_parser__apply3052->definitionModule = modulename;
  meth_meth_parser__apply3052->definitionLine = 961;
// compiled block node returning block3051 (depth = 8)
  gc_frame_newslot(block3051);
// call case 4: self request
  params[0] = block3051;
  partcv[0] = 1;
  Object call3056 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3050);
// compiled call node returning call3056 (depth = 7)
  partcv[0] = 0;
  Object call3057 = callmethod(call3056, "not",
    1, partcv, params);
  gc_frame_end(callframe3049);
// compiled call node returning call3057 (depth = 6)
// compiled member node returning call3057 (depth = 5)
  Object if3048 = done;
  if (istrue(call3057)) {
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3058 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3060 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3059);
// compiled call node returning call3060 (depth = 9)
// compiled member node returning call3060 (depth = 8)
  partcv[0] = 0;
  Object call3061 = callmethod(call3060, "new",
    1, partcv, params);
  gc_frame_end(callframe3058);
// compiled call node returning call3061 (depth = 7)
// compiled member node returning call3061 (depth = 6)
  *var_suggestion = call3061;
  if (call3061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3062 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3063 == NULL) {
    strlit3063 = alloc_String("rparen");
    gc_root(strlit3063);
  }
// compiled string node returning strlit3063 (depth = 7)
  gc_frame_newslot(strlit3063);
// call case 4: self request
  params[0] = strlit3063;
  partcv[0] = 1;
  Object call3064 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3062);
// compiled call node returning call3064 (depth = 6)
  *var_nextTok = call3064;
  if (call3064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3066 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3066 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3068 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3068 (depth = 6)
  Object if3065 = done;
  if (istrue(opresult3068)) {
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3069 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3070 == NULL) {
    strlit3070 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3070);
  }
// compiled string node returning strlit3070 (depth = 7)
  gc_frame_newslot(strlit3070);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3070;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3071 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3069);
// compiled call node returning call3071 (depth = 6)
    gc_frame_newslot(call3071);
    if3065 = call3071;
  } else {
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3072 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3073 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3074 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3073);
// compiled call node returning call3074 (depth = 8)
// compiled member node returning call3074 (depth = 7)
  gc_frame_newslot(call3074);
// starting to compile identifier node (depth = 7)
  Object bool3075 = alloc_Boolean(1);
// compiled identifier node returning bool3075 (depth = 7)
  gc_frame_newslot(bool3075);
// starting to compile identifier node (depth = 7)
  Object bool3076 = alloc_Boolean(0);
// compiled identifier node returning bool3076 (depth = 7)
  gc_frame_newslot(bool3076);
// starting to compile string node (depth = 7)
  if (strlit3077 == NULL) {
    strlit3077 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3077);
  }
// compiled string node returning strlit3077 (depth = 7)
  gc_frame_newslot(strlit3077);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3074;
  params[2] = bool3075;
  params[3] = bool3076;
  params[4] = strlit3077;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3078 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3072);
// compiled call node returning call3078 (depth = 6)
    gc_frame_newslot(call3078);
    if3065 = call3078;
  }
// compiled if node returning if3065 (depth = 5)
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3079 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3080 == NULL) {
    strlit3080 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit3080);
  }
// compiled string node returning strlit3080 (depth = 6)
  gc_frame_newslot(strlit3080);
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3081 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3082 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3081);
// compiled call node returning call3082 (depth = 7)
// compiled member node returning call3082 (depth = 6)
  gc_frame_newslot(call3082);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3083 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3084 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3083);
// compiled call node returning call3084 (depth = 7)
// compiled member node returning call3084 (depth = 6)
  gc_frame_newslot(call3084);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3080;
  params[1] = call3082;
  params[2] = call3084;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3085 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3079);
// compiled call node returning call3085 (depth = 5)
    gc_frame_newslot(call3085);
    if3048 = call3085;
  } else {
  }
// compiled if node returning if3048 (depth = 4)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3088 == NULL) {
    strlit3088 = alloc_String("rparen");
    gc_root(strlit3088);
  }
// compiled string node returning strlit3088 (depth = 6)
  int op_slot_right_3087 = gc_frame_newslot(strlit3088);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3091 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3090);
// compiled call node returning call3091 (depth = 7)
// compiled member node returning call3091 (depth = 6)
  int op_slot_left_3087 = gc_frame_newslot(call3091);
  params[0] = strlit3088;
  partcv[0] = 1;
  Object opresult3092 = callmethod(call3091, "!=", 1, partcv, params);
// compiled op node returning opresult3092 (depth = 5)
  Object if3086 = done;
  if (istrue(opresult3092)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3093 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3094 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3093);
// compiled call node returning call3094 (depth = 6)
// compiled member node returning call3094 (depth = 5)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3095 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3097 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3096);
// compiled call node returning call3097 (depth = 9)
// compiled member node returning call3097 (depth = 8)
  partcv[0] = 0;
  Object call3098 = callmethod(call3097, "new",
    1, partcv, params);
  gc_frame_end(callframe3095);
// compiled call node returning call3098 (depth = 7)
// compiled member node returning call3098 (depth = 6)
  *var_suggestion = call3098;
  if (call3098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3099 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3100 == NULL) {
    strlit3100 = alloc_String(")");
    gc_root(strlit3100);
  }
// compiled string node returning strlit3100 (depth = 6)
  gc_frame_newslot(strlit3100);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3100;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3101 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3099);
// compiled call node returning call3101 (depth = 5)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3102 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3103 == NULL) {
    strlit3103 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3103);
  }
// compiled string node returning strlit3103 (depth = 6)
  gc_frame_newslot(strlit3103);
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3104 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3105 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3104);
// compiled call node returning call3105 (depth = 7)
// compiled member node returning call3105 (depth = 6)
  gc_frame_newslot(call3105);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3108 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3107);
// compiled call node returning call3108 (depth = 8)
// compiled member node returning call3108 (depth = 7)
  int op_slot_right_3106 = gc_frame_newslot(call3108);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3111 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3110);
// compiled call node returning call3111 (depth = 8)
// compiled member node returning call3111 (depth = 7)
  int op_slot_left_3106 = gc_frame_newslot(call3111);
  params[0] = call3108;
  partcv[0] = 1;
  Object sum3112 = callmethod(call3111, "+", 1, partcv, params);
// compiled op node returning sum3112 (depth = 6)
  gc_frame_newslot(sum3112);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3103;
  params[1] = call3105;
  params[2] = sum3112;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3113 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3102);
// compiled call node returning call3113 (depth = 5)
    gc_frame_newslot(call3113);
    if3086 = call3113;
  } else {
  }
// compiled if node returning if3086 (depth = 4)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3114 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3115 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3114);
// compiled call node returning call3115 (depth = 5)
// compiled member node returning call3115 (depth = 4)
    gc_frame_newslot(call3115);
    if3042 = call3115;
  } else {
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3117 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3118 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block3119 = alloc_Block(NULL, NULL, "parser", 981);
  gc_frame_newslot(block3119);
// method _apply
  block_savedest(block3119);
  Object closure3120 = createclosure(1, "_apply");
  setclosureframe(closure3120, stackframe);
  addtoclosure(closure3120, selfslot);
  struct UserObject *uo3120 = (struct UserObject*)block3119;
  uo3120->data[0] = (Object)closure3120;
  Method *meth_meth_parser__apply3120 = addmethod2pos(block3119, "_apply", &meth_parser__apply3120, 0);
  int argcv_meth_parser__apply3120[] = {0};
  meth_meth_parser__apply3120->type = alloc_MethodType(1, argcv_meth_parser__apply3120);
  meth_meth_parser__apply3120->definitionModule = modulename;
  meth_meth_parser__apply3120->definitionLine = 981;
// compiled block node returning block3119 (depth = 8)
  gc_frame_newslot(block3119);
// call case 4: self request
  params[0] = block3119;
  partcv[0] = 1;
  Object call3124 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compiled call node returning call3124 (depth = 7)
  partcv[0] = 0;
  Object call3125 = callmethod(call3124, "not",
    1, partcv, params);
  gc_frame_end(callframe3117);
// compiled call node returning call3125 (depth = 6)
// compiled member node returning call3125 (depth = 5)
  Object if3116 = done;
  if (istrue(call3125)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array3126 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3126 (depth = 6)
  *var_suggestions = array3126;
  if (array3126 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3127 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3129 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3128);
// compiled call node returning call3129 (depth = 9)
// compiled member node returning call3129 (depth = 8)
  partcv[0] = 0;
  Object call3130 = callmethod(call3129, "new",
    1, partcv, params);
  gc_frame_end(callframe3127);
// compiled call node returning call3130 (depth = 7)
// compiled member node returning call3130 (depth = 6)
  *var_suggestion = call3130;
  if (call3130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3131 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3132 == NULL) {
    strlit3132 = alloc_String("rparen");
    gc_root(strlit3132);
  }
// compiled string node returning strlit3132 (depth = 7)
  gc_frame_newslot(strlit3132);
// call case 4: self request
  params[0] = strlit3132;
  partcv[0] = 1;
  Object call3133 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3131);
// compiled call node returning call3133 (depth = 6)
  *var_nextTok = call3133;
  if (call3133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_3135 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3135 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3137 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3137 (depth = 6)
  Object if3134 = done;
  if (istrue(opresult3137)) {
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3138 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3139 == NULL) {
    strlit3139 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3139);
  }
// compiled string node returning strlit3139 (depth = 7)
  gc_frame_newslot(strlit3139);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3139;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3140 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3138);
// compiled call node returning call3140 (depth = 6)
    gc_frame_newslot(call3140);
    if3134 = call3140;
  } else {
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3141 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3143 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3142);
// compiled call node returning call3143 (depth = 8)
// compiled member node returning call3143 (depth = 7)
  gc_frame_newslot(call3143);
// starting to compile identifier node (depth = 7)
  Object bool3144 = alloc_Boolean(1);
// compiled identifier node returning bool3144 (depth = 7)
  gc_frame_newslot(bool3144);
// starting to compile identifier node (depth = 7)
  Object bool3145 = alloc_Boolean(0);
// compiled identifier node returning bool3145 (depth = 7)
  gc_frame_newslot(bool3145);
// starting to compile string node (depth = 7)
  if (strlit3146 == NULL) {
    strlit3146 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3146);
  }
// compiled string node returning strlit3146 (depth = 7)
  gc_frame_newslot(strlit3146);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call3143;
  params[2] = bool3144;
  params[3] = bool3145;
  params[4] = strlit3146;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3147 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3141);
// compiled call node returning call3147 (depth = 6)
    gc_frame_newslot(call3147);
    if3134 = call3147;
  }
// compiled if node returning if3134 (depth = 5)
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3148 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3149 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3148);
// compiled call node returning call3149 (depth = 5)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3152 == NULL) {
    strlit3152 = alloc_String("bind");
    gc_root(strlit3152);
  }
// compiled string node returning strlit3152 (depth = 7)
  int op_slot_right_3151 = gc_frame_newslot(strlit3152);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3154 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3155 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3156 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3155);
// compiled call node returning call3156 (depth = 10)
// compiled member node returning call3156 (depth = 9)
  partcv[0] = 0;
  Object call3157 = callmethod(call3156, "kind",
    1, partcv, params);
  gc_frame_end(callframe3154);
// compiled call node returning call3157 (depth = 8)
// compiled member node returning call3157 (depth = 7)
  int op_slot_left_3151 = gc_frame_newslot(call3157);
  params[0] = strlit3152;
  partcv[0] = 1;
  Object opresult3158 = callmethod(call3157, "==", 1, partcv, params);
// compiled op node returning opresult3158 (depth = 6)
  Object if3150 = done;
  if (istrue(opresult3158)) {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3159 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3161 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 10)
// compiled member node returning call3161 (depth = 9)
  partcv[0] = 0;
  Object call3162 = callmethod(call3161, "new",
    1, partcv, params);
  gc_frame_end(callframe3159);
// compiled call node returning call3162 (depth = 8)
// compiled member node returning call3162 (depth = 7)
  *var_suggestion = call3162;
  if (call3162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3164 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3165 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3166 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3165);
// compiled call node returning call3166 (depth = 8)
// compiled member node returning call3166 (depth = 7)
  gc_frame_newslot(call3166);
// starting to compile identifier node (depth = 7)
  Object bool3167 = alloc_Boolean(1);
// compiled identifier node returning bool3167 (depth = 7)
  gc_frame_newslot(bool3167);
// starting to compile identifier node (depth = 7)
  Object bool3168 = alloc_Boolean(0);
// compiled identifier node returning bool3168 (depth = 7)
  gc_frame_newslot(bool3168);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call3166;
  params[2] = bool3167;
  params[3] = bool3168;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3169 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3164);
// compiled call node returning call3169 (depth = 6)
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3170 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3171 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3172 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3171);
// compiled call node returning call3172 (depth = 8)
// compiled member node returning call3172 (depth = 7)
  gc_frame_newslot(call3172);
// starting to compile identifier node (depth = 7)
  Object bool3173 = alloc_Boolean(1);
// compiled identifier node returning bool3173 (depth = 7)
  gc_frame_newslot(bool3173);
// starting to compile identifier node (depth = 7)
  Object bool3174 = alloc_Boolean(0);
// compiled identifier node returning bool3174 (depth = 7)
  gc_frame_newslot(bool3174);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call3172;
  params[1] = bool3173;
  params[2] = bool3174;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3175 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3170);
// compiled call node returning call3175 (depth = 6)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3176 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3177 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3176);
// compiled call node returning call3177 (depth = 6)
    gc_frame_newslot(call3177);
    if3150 = call3177;
  } else {
  }
// compiled if node returning if3150 (depth = 5)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3178 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3179 == NULL) {
    strlit3179 = alloc_String("A prefix operator must be followed by an expression.");
    gc_root(strlit3179);
  }
// compiled string node returning strlit3179 (depth = 6)
  gc_frame_newslot(strlit3179);
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3181 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3180);
// compiled call node returning call3181 (depth = 7)
// compiled member node returning call3181 (depth = 6)
  gc_frame_newslot(call3181);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3183 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3184 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3183);
// compiled call node returning call3184 (depth = 8)
// compiled member node returning call3184 (depth = 7)
  int op_slot_right_3182 = gc_frame_newslot(call3184);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3187 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3186);
// compiled call node returning call3187 (depth = 8)
// compiled member node returning call3187 (depth = 7)
  int op_slot_left_3182 = gc_frame_newslot(call3187);
  params[0] = call3184;
  partcv[0] = 1;
  Object sum3188 = callmethod(call3187, "+", 1, partcv, params);
// compiled op node returning sum3188 (depth = 6)
  gc_frame_newslot(sum3188);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3179;
  params[1] = call3181;
  params[2] = sum3188;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3189 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3178);
// compiled call node returning call3189 (depth = 5)
    gc_frame_newslot(call3189);
    if3116 = call3189;
  } else {
  }
// compiled if node returning if3116 (depth = 4)
    gc_frame_newslot(if3116);
    if3042 = if3116;
  }
// compiled if node returning if3042 (depth = 3)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3190 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3191 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3190);
// compiled call node returning call3191 (depth = 3)
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3192 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3193 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3192);
// compiled call node returning call3193 (depth = 3)
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3195 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3194);
// compiled call node returning call3195 (depth = 4)
// compiled member node returning call3195 (depth = 3)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3197 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3196);
// compiled call node returning call3197 (depth = 5)
// compiled member node returning call3197 (depth = 4)
  *var_val = call3197;
  if (call3197 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3199 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_op (depth = 6)
  int op_slot_right_3200 = gc_frame_newslot(*var_op);
// starting to compile string node (depth = 6)
  if (strlit3202 == NULL) {
    strlit3202 = alloc_String("prefix");
    gc_root(strlit3202);
  }
// compiled string node returning strlit3202 (depth = 6)
  int op_slot_left_3200 = gc_frame_newslot(strlit3202);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3203 = callmethod(strlit3202, "++", 1, partcv, params);
// compiled op node returning opresult3203 (depth = 5)
  gc_frame_newslot(opresult3203);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3205 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3204);
// compiled call node returning call3205 (depth = 6)
// compiled member node returning call3205 (depth = 5)
  params[0] = opresult3203;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call3206 = callmethod(call3205, "new",
    1, partcv, params);
  gc_frame_end(callframe3199);
// compiled call node returning call3206 (depth = 4)
  *var_mem = call3206;
  if (call3206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3207 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_mem (depth = 5)
  gc_frame_newslot(*var_mem);
// starting to compile array node (depth = 5)
  Object array3208 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 6)
  int callframe3209 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_mem (depth = 9)
  partcv[0] = 0;
  Object call3211 = callmethod(*var_mem, "value",
    1, partcv, params);
  gc_frame_end(callframe3210);
// compiled call node returning call3211 (depth = 8)
// compiled member node returning call3211 (depth = 7)
  gc_frame_newslot(call3211);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call3213 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe3212);
// compiled call node returning call3213 (depth = 8)
// compiled member node returning call3213 (depth = 7)
  params[0] = call3211;
  partcv[0] = 1;
  Object call3214 = callmethod(call3213, "new",
    1, partcv, params);
  gc_frame_end(callframe3209);
// compiled call node returning call3214 (depth = 6)
  params[0] = call3214;
  partcv[0] = 1;
  callmethod(array3208, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3208 (depth = 5)
  gc_frame_newslot(array3208);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3216 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe3215);
// compiled call node returning call3216 (depth = 6)
// compiled member node returning call3216 (depth = 5)
  params[0] = *var_mem;
  params[1] = array3208;
  partcv[0] = 2;
  Object call3217 = callmethod(call3216, "new",
    1, partcv, params);
  gc_frame_end(callframe3207);
// compiled call node returning call3217 (depth = 4)
  *var_call = call3217;
  if (call3217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3218 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3219 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3218);
// compiled call node returning call3219 (depth = 3)
    gc_frame_newslot(call3219);
    if3034 = call3219;
  } else {
  }
// compiled if node returning if3034 (depth = 2)
  gc_frame_end(frame);
  return if3034;
}
Object meth_parser__apply3235(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3236 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String("identifier");
    gc_root(strlit3237);
  }
// compiled string node returning strlit3237 (depth = 6)
  gc_frame_newslot(strlit3237);
// call case 4: self request
  params[0] = strlit3237;
  partcv[0] = 1;
  Object call3238 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3236);
// compiled call node returning call3238 (depth = 5)
  gc_frame_end(frame);
  return call3238;
}
Object meth_parser__apply3246(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe3247 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3248 == NULL) {
    strlit3248 = alloc_String("dot");
    gc_root(strlit3248);
  }
// compiled string node returning strlit3248 (depth = 8)
  gc_frame_newslot(strlit3248);
// call case 4: self request
  params[0] = strlit3248;
  partcv[0] = 1;
  Object call3249 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3247);
// compiled call node returning call3249 (depth = 7)
  gc_frame_end(frame);
  return call3249;
}
Object meth_parser__apply3252(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
  Object *var_memberNd = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "memberNd");
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3253 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3254 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3253);
// compiled call node returning call3254 (depth = 8)
// compiled member node returning call3254 (depth = 7)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3255 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3256 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3255);
// compiled call node returning call3256 (depth = 9)
// compiled member node returning call3256 (depth = 8)
  *var_memberIn = call3256;
  if (call3256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3259 == NULL) {
    strlit3259 = alloc_String("identifier");
    gc_root(strlit3259);
  }
// compiled string node returning strlit3259 (depth = 9)
  int op_slot_right_3258 = gc_frame_newslot(strlit3259);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call3262 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3261);
// compiled call node returning call3262 (depth = 10)
// compiled member node returning call3262 (depth = 9)
  int op_slot_left_3258 = gc_frame_newslot(call3262);
  params[0] = strlit3259;
  partcv[0] = 1;
  Object opresult3263 = callmethod(call3262, "!=", 1, partcv, params);
// compiled op node returning opresult3263 (depth = 8)
  Object if3257 = done;
  if (istrue(opresult3263)) {
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array3264 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3264 (depth = 9)
  *var_suggestions = array3264;
  if (array3264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3265 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3266 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3267 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3266);
// compiled call node returning call3267 (depth = 12)
// compiled member node returning call3267 (depth = 11)
  partcv[0] = 0;
  Object call3268 = callmethod(call3267, "new",
    1, partcv, params);
  gc_frame_end(callframe3265);
// compiled call node returning call3268 (depth = 10)
// compiled member node returning call3268 (depth = 9)
  *var_suggestion = call3268;
  if (call3268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3269 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3270 == NULL) {
    strlit3270 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3270);
  }
// compiled string node returning strlit3270 (depth = 9)
  gc_frame_newslot(strlit3270);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3270;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3271 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3269);
// compiled call node returning call3271 (depth = 8)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3272 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3273 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3272);
// compiled call node returning call3273 (depth = 8)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3274 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3276 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3275);
// compiled call node returning call3276 (depth = 12)
// compiled member node returning call3276 (depth = 11)
  partcv[0] = 0;
  Object call3277 = callmethod(call3276, "new",
    1, partcv, params);
  gc_frame_end(callframe3274);
// compiled call node returning call3277 (depth = 10)
// compiled member node returning call3277 (depth = 9)
  *var_suggestion = call3277;
  if (call3277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3279 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3280 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3279);
// compiled call node returning call3280 (depth = 8)
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3281 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3282 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3281);
// compiled call node returning call3282 (depth = 8)
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3283 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3284 == NULL) {
    strlit3284 = alloc_String("A type name must follow the '.'.");
    gc_root(strlit3284);
  }
// compiled string node returning strlit3284 (depth = 9)
  gc_frame_newslot(strlit3284);
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3285 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3286 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3285);
// compiled call node returning call3286 (depth = 10)
// compiled member node returning call3286 (depth = 9)
  gc_frame_newslot(call3286);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num3288 = alloc_Float64(1);
// compiled num node returning num3288 (depth = 10)
  int op_slot_right_3287 = gc_frame_newslot(num3288);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call3291 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3290);
// compiled call node returning call3291 (depth = 11)
// compiled member node returning call3291 (depth = 10)
  int op_slot_left_3287 = gc_frame_newslot(call3291);
  params[0] = num3288;
  partcv[0] = 1;
  Object sum3292 = callmethod(call3291, "+", 1, partcv, params);
// compiled op node returning sum3292 (depth = 9)
  gc_frame_newslot(sum3292);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit3284;
  params[1] = call3286;
  params[2] = sum3292;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3293 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3283);
// compiled call node returning call3293 (depth = 8)
    gc_frame_newslot(call3293);
    if3257 = call3293;
  } else {
  }
// compiled if node returning if3257 (depth = 7)
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3294 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3295 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3294);
// compiled call node returning call3295 (depth = 8)
// compiled member node returning call3295 (depth = 7)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3296 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call3297 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3296);
// compiled call node returning call3297 (depth = 9)
// compiled member node returning call3297 (depth = 8)
  *var_memberName = call3297;
  if (call3297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3298 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3300 = callmethod(*var_memberName, "value",
    1, partcv, params);
  gc_frame_end(callframe3299);
// compiled call node returning call3300 (depth = 10)
// compiled member node returning call3300 (depth = 9)
  gc_frame_newslot(call3300);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberIn (depth = 9)
  gc_frame_newslot(*var_memberIn);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3301 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_ast (depth = 11)
  partcv[0] = 0;
  Object call3302 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3301);
// compiled call node returning call3302 (depth = 10)
// compiled member node returning call3302 (depth = 9)
  params[0] = call3300;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3303 = callmethod(call3302, "new",
    1, partcv, params);
  gc_frame_end(callframe3298);
// compiled call node returning call3303 (depth = 8)
  *var_memberNd = call3303;
  if (call3303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3304 = gc_frame_new();
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3305 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3306 = callmethod(*var_memberName, "line",
    1, partcv, params);
  gc_frame_end(callframe3305);
// compiled call node returning call3306 (depth = 10)
// compiled member node returning call3306 (depth = 9)
  gc_frame_newslot(call3306);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberNd (depth = 9)
  params[0] = call3306;
  partcv[0] = 1;
  Object call3307 = callmethod(*var_memberNd, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3304);
// compiled call node returning call3307 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3308 = gc_frame_new();
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_memberName (depth = 11)
  partcv[0] = 0;
  Object call3310 = callmethod(*var_memberName, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3309);
// compiled call node returning call3310 (depth = 10)
// compiled member node returning call3310 (depth = 9)
  gc_frame_newslot(call3310);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_memberNd (depth = 9)
  params[0] = call3310;
  partcv[0] = 1;
  Object call3311 = callmethod(*var_memberNd, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe3308);
// compiled call node returning call3311 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3312 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_memberNd (depth = 8)
  gc_frame_newslot(*var_memberNd);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_memberNd;
  partcv[0] = 1;
  Object call3313 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3312);
// compiled call node returning call3313 (depth = 7)
  gc_frame_end(frame);
  return call3313;
}
Object meth_parser__apply3241(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3243 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3242);
// compiled call node returning call3243 (depth = 6)
// compiled member node returning call3243 (depth = 5)
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3244 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3245 = alloc_Block(NULL, NULL, "parser", 1019);
  gc_frame_newslot(block3245);
// method _apply
  block_savedest(block3245);
  Object closure3246 = createclosure(1, "_apply");
  setclosureframe(closure3246, stackframe);
  addtoclosure(closure3246, selfslot);
  struct UserObject *uo3246 = (struct UserObject*)block3245;
  uo3246->data[0] = (Object)closure3246;
  Method *meth_meth_parser__apply3246 = addmethod2pos(block3245, "_apply", &meth_parser__apply3246, 0);
  int argcv_meth_parser__apply3246[] = {0};
  meth_meth_parser__apply3246->type = alloc_MethodType(1, argcv_meth_parser__apply3246);
  meth_meth_parser__apply3246->definitionModule = modulename;
  meth_meth_parser__apply3246->definitionLine = 1018;
// compiled block node returning block3245 (depth = 6)
  gc_frame_newslot(block3245);
// starting to compile block node (depth = 6)
  Object block3251 = alloc_Block(NULL, NULL, "parser", 1019);
  gc_frame_newslot(block3251);
// method _apply
  block_savedest(block3251);
  Object closure3252 = createclosure(6, "_apply");
  setclosureframe(closure3252, stackframe);
  addtoclosure(closure3252, var_values);
  addtoclosure(closure3252, var_sym);
  addtoclosure(closure3252, var_errormessages);
  addtoclosure(closure3252, var_lastToken);
  addtoclosure(closure3252, var_ast);
  addtoclosure(closure3252, selfslot);
  struct UserObject *uo3252 = (struct UserObject*)block3251;
  uo3252->data[0] = (Object)closure3252;
  Method *meth_meth_parser__apply3252 = addmethod2pos(block3251, "_apply", &meth_parser__apply3252, 0);
  int argcv_meth_parser__apply3252[] = {0};
  meth_meth_parser__apply3252->type = alloc_MethodType(1, argcv_meth_parser__apply3252);
  meth_meth_parser__apply3252->definitionModule = modulename;
  meth_meth_parser__apply3252->definitionLine = 1018;
// compiled block node returning block3251 (depth = 6)
  gc_frame_newslot(block3251);
// call case 5: prelude request
  params[0] = block3245;
  params[1] = block3251;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3315 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3244);
// compiled call node returning call3315 (depth = 5)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3316 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3317 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3316);
// compiled call node returning call3317 (depth = 6)
// compiled member node returning call3317 (depth = 5)
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3318 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call3320 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3319);
// compiled call node returning call3320 (depth = 7)
// compiled member node returning call3320 (depth = 6)
  gc_frame_newslot(call3320);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_gens (depth = 6)
  params[0] = call3320;
  partcv[0] = 1;
  Object call3321 = callmethod(*var_gens, "push",
    1, partcv, params);
  gc_frame_end(callframe3318);
// compiled call node returning call3321 (depth = 5)
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3323 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3324 == NULL) {
    strlit3324 = alloc_String("comma");
    gc_root(strlit3324);
  }
// compiled string node returning strlit3324 (depth = 7)
  gc_frame_newslot(strlit3324);
// call case 4: self request
  params[0] = strlit3324;
  partcv[0] = 1;
  Object call3325 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3323);
// compiled call node returning call3325 (depth = 6)
  Object if3322 = done;
  if (istrue(call3325)) {
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3326 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3327 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3326);
// compiled call node returning call3327 (depth = 7)
// compiled member node returning call3327 (depth = 6)
    gc_frame_newslot(call3327);
    if3322 = call3327;
  } else {
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3330 == NULL) {
    strlit3330 = alloc_String("rgeneric");
    gc_root(strlit3330);
  }
// compiled string node returning strlit3330 (depth = 8)
  int op_slot_right_3329 = gc_frame_newslot(strlit3330);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3333 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3332);
// compiled call node returning call3333 (depth = 9)
// compiled member node returning call3333 (depth = 8)
  int op_slot_left_3329 = gc_frame_newslot(call3333);
  params[0] = strlit3330;
  partcv[0] = 1;
  Object opresult3334 = callmethod(call3333, "!=", 1, partcv, params);
// compiled op node returning opresult3334 (depth = 7)
  Object if3328 = done;
  if (istrue(opresult3334)) {
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3335 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3337 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3336);
// compiled call node returning call3337 (depth = 11)
// compiled member node returning call3337 (depth = 10)
  partcv[0] = 0;
  Object call3338 = callmethod(call3337, "new",
    1, partcv, params);
  gc_frame_end(callframe3335);
// compiled call node returning call3338 (depth = 9)
// compiled member node returning call3338 (depth = 8)
  *var_suggestion = call3338;
  if (call3338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3339 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3340 == NULL) {
    strlit3340 = alloc_String(">");
    gc_root(strlit3340);
  }
// compiled string node returning strlit3340 (depth = 8)
  gc_frame_newslot(strlit3340);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3340;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3341 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3339);
// compiled call node returning call3341 (depth = 7)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3342 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3343 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3344 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3343);
// compiled call node returning call3344 (depth = 11)
// compiled member node returning call3344 (depth = 10)
  partcv[0] = 0;
  Object call3345 = callmethod(call3344, "new",
    1, partcv, params);
  gc_frame_end(callframe3342);
// compiled call node returning call3345 (depth = 9)
// compiled member node returning call3345 (depth = 8)
  *var_suggestion2 = call3345;
  if (call3345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3346 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3347 == NULL) {
    strlit3347 = alloc_String(" ");
    gc_root(strlit3347);
  }
// compiled string node returning strlit3347 (depth = 8)
  gc_frame_newslot(strlit3347);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startToken (depth = 8)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion2 (depth = 8)
  params[0] = strlit3347;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3348 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3346);
// compiled call node returning call3348 (depth = 7)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array3349 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3349, "push", 1, partcv, params);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion2 (depth = 9)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3349, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3349 (depth = 8)
  *var_suggestions = array3349;
  if (array3349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3350 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3351 == NULL) {
    strlit3351 = alloc_String("A type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3351);
  }
// compiled string node returning strlit3351 (depth = 8)
  gc_frame_newslot(strlit3351);
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3352 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3353 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3352);
// compiled call node returning call3353 (depth = 9)
// compiled member node returning call3353 (depth = 8)
  gc_frame_newslot(call3353);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3356 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3355);
// compiled call node returning call3356 (depth = 10)
// compiled member node returning call3356 (depth = 9)
  int op_slot_right_3354 = gc_frame_newslot(call3356);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3358 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3359 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3358);
// compiled call node returning call3359 (depth = 10)
// compiled member node returning call3359 (depth = 9)
  int op_slot_left_3354 = gc_frame_newslot(call3359);
  params[0] = call3356;
  partcv[0] = 1;
  Object sum3360 = callmethod(call3359, "+", 1, partcv, params);
// compiled op node returning sum3360 (depth = 8)
  gc_frame_newslot(sum3360);
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3351;
  params[1] = call3353;
  params[2] = sum3360;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3361 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3350);
// compiled call node returning call3361 (depth = 7)
    gc_frame_newslot(call3361);
    if3328 = call3361;
  } else {
  }
// compiled if node returning if3328 (depth = 6)
    gc_frame_newslot(if3328);
    if3322 = if3328;
  }
// compiled if node returning if3322 (depth = 5)
  gc_frame_end(frame);
  return if3322;
}
Object meth_parser_generic3220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for generic (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for generic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3222 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3223 == NULL) {
    strlit3223 = alloc_String("lgeneric");
    gc_root(strlit3223);
  }
// compiled string node returning strlit3223 (depth = 4)
  gc_frame_newslot(strlit3223);
// call case 4: self request
  params[0] = strlit3223;
  partcv[0] = 1;
  Object call3224 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3222);
// compiled call node returning call3224 (depth = 3)
  Object if3221 = done;
  if (istrue(call3224)) {
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3226 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3225);
// compiled call node returning call3226 (depth = 5)
// compiled member node returning call3226 (depth = 4)
  *var_id = call3226;
  if (call3226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3227 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3228 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call3229 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3228);
// compiled call node returning call3229 (depth = 7)
// compiled member node returning call3229 (depth = 6)
  partcv[0] = 0;
  Object call3230 = callmethod(call3229, "empty",
    1, partcv, params);
  gc_frame_end(callframe3227);
// compiled call node returning call3230 (depth = 5)
// compiled member node returning call3230 (depth = 4)
  *var_gens = call3230;
  if (call3230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1016
  setline(1016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3231 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3232 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3231);
// compiled call node returning call3232 (depth = 4)
// compiled member node returning call3232 (depth = 3)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3233 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3234 = alloc_Block(NULL, NULL, "parser", 1017);
  gc_frame_newslot(block3234);
// method _apply
  block_savedest(block3234);
  Object closure3235 = createclosure(1, "_apply");
  setclosureframe(closure3235, stackframe);
  addtoclosure(closure3235, selfslot);
  struct UserObject *uo3235 = (struct UserObject*)block3234;
  uo3235->data[0] = (Object)closure3235;
  Method *meth_meth_parser__apply3235 = addmethod2pos(block3234, "_apply", &meth_parser__apply3235, 0);
  int argcv_meth_parser__apply3235[] = {0};
  meth_meth_parser__apply3235->type = alloc_MethodType(1, argcv_meth_parser__apply3235);
  meth_meth_parser__apply3235->definitionModule = modulename;
  meth_meth_parser__apply3235->definitionLine = 1016;
// compiled block node returning block3234 (depth = 4)
  gc_frame_newslot(block3234);
// starting to compile block node (depth = 4)
  Object block3240 = alloc_Block(NULL, NULL, "parser", 1017);
  gc_frame_newslot(block3240);
// method _apply
  block_savedest(block3240);
  Object closure3241 = createclosure(8, "_apply");
  setclosureframe(closure3241, stackframe);
  addtoclosure(closure3241, var_values);
  addtoclosure(closure3241, var_sym);
  addtoclosure(closure3241, var_errormessages);
  addtoclosure(closure3241, var_lastToken);
  addtoclosure(closure3241, var_ast);
  addtoclosure(closure3241, var_gens);
  addtoclosure(closure3241, var_startToken);
  addtoclosure(closure3241, selfslot);
  struct UserObject *uo3241 = (struct UserObject*)block3240;
  uo3241->data[0] = (Object)closure3241;
  Method *meth_meth_parser__apply3241 = addmethod2pos(block3240, "_apply", &meth_parser__apply3241, 0);
  int argcv_meth_parser__apply3241[] = {0};
  meth_meth_parser__apply3241->type = alloc_MethodType(1, argcv_meth_parser__apply3241);
  meth_meth_parser__apply3241->definitionModule = modulename;
  meth_meth_parser__apply3241->definitionLine = 1016;
// compiled block node returning block3240 (depth = 4)
  gc_frame_newslot(block3240);
// call case 5: prelude request
  params[0] = block3234;
  params[1] = block3240;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3363 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3233);
// compiled call node returning call3363 (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3366 == NULL) {
    strlit3366 = alloc_String("rgeneric");
    gc_root(strlit3366);
  }
// compiled string node returning strlit3366 (depth = 5)
  int op_slot_right_3365 = gc_frame_newslot(strlit3366);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3368 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3369 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3368);
// compiled call node returning call3369 (depth = 6)
// compiled member node returning call3369 (depth = 5)
  int op_slot_left_3365 = gc_frame_newslot(call3369);
  params[0] = strlit3366;
  partcv[0] = 1;
  Object opresult3370 = callmethod(call3369, "!=", 1, partcv, params);
// compiled op node returning opresult3370 (depth = 4)
  Object if3364 = done;
  if (istrue(opresult3370)) {
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3371 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3372 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3373 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3372);
// compiled call node returning call3373 (depth = 8)
// compiled member node returning call3373 (depth = 7)
  partcv[0] = 0;
  Object call3374 = callmethod(call3373, "new",
    1, partcv, params);
  gc_frame_end(callframe3371);
// compiled call node returning call3374 (depth = 6)
// compiled member node returning call3374 (depth = 5)
  *var_suggestion = call3374;
  if (call3374 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3375 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3376 == NULL) {
    strlit3376 = alloc_String(">");
    gc_root(strlit3376);
  }
// compiled string node returning strlit3376 (depth = 5)
  gc_frame_newslot(strlit3376);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3376;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3377 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3375);
// compiled call node returning call3377 (depth = 4)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3378 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3379 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3380 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3379);
// compiled call node returning call3380 (depth = 8)
// compiled member node returning call3380 (depth = 7)
  partcv[0] = 0;
  Object call3381 = callmethod(call3380, "new",
    1, partcv, params);
  gc_frame_end(callframe3378);
// compiled call node returning call3381 (depth = 6)
// compiled member node returning call3381 (depth = 5)
  *var_suggestion2 = call3381;
  if (call3381 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3382 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3383 == NULL) {
    strlit3383 = alloc_String(" ");
    gc_root(strlit3383);
  }
// compiled string node returning strlit3383 (depth = 5)
  gc_frame_newslot(strlit3383);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startToken (depth = 5)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = strlit3383;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3384 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3382);
// compiled call node returning call3384 (depth = 4)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array3385 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3385, "push", 1, partcv, params);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion2 (depth = 6)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3385, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array3385 (depth = 5)
  *var_suggestions = array3385;
  if (array3385 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3386 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3387 == NULL) {
    strlit3387 = alloc_String("A type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3387);
  }
// compiled string node returning strlit3387 (depth = 5)
  gc_frame_newslot(strlit3387);
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3388 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3389 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3388);
// compiled call node returning call3389 (depth = 6)
// compiled member node returning call3389 (depth = 5)
  gc_frame_newslot(call3389);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3392 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3391);
// compiled call node returning call3392 (depth = 7)
// compiled member node returning call3392 (depth = 6)
  int op_slot_right_3390 = gc_frame_newslot(call3392);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3395 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3394);
// compiled call node returning call3395 (depth = 7)
// compiled member node returning call3395 (depth = 6)
  int op_slot_left_3390 = gc_frame_newslot(call3395);
  params[0] = call3392;
  partcv[0] = 1;
  Object sum3396 = callmethod(call3395, "+", 1, partcv, params);
// compiled op node returning sum3396 (depth = 5)
  gc_frame_newslot(sum3396);
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3387;
  params[1] = call3389;
  params[2] = sum3396;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3397 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3386);
// compiled call node returning call3397 (depth = 4)
    gc_frame_newslot(call3397);
    if3364 = call3397;
  } else {
  }
// compiled if node returning if3364 (depth = 3)
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3398 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3399 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3398);
// compiled call node returning call3399 (depth = 4)
// compiled member node returning call3399 (depth = 3)
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3400 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3401 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_id (depth = 5)
  gc_frame_newslot(*var_id);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call3403 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe3402);
// compiled call node returning call3403 (depth = 6)
// compiled member node returning call3403 (depth = 5)
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3404 = callmethod(call3403, "new",
    1, partcv, params);
  gc_frame_end(callframe3401);
// compiled call node returning call3404 (depth = 4)
  gc_frame_newslot(call3404);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call3404;
  partcv[0] = 1;
  Object call3405 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3400);
// compiled call node returning call3405 (depth = 3)
    gc_frame_newslot(call3405);
    if3221 = call3405;
  } else {
  }
// compiled if node returning if3221 (depth = 2)
  gc_frame_end(frame);
  return if3221;
}
Object meth_parser__apply3444(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3448 == NULL) {
    strlit3448 = alloc_String("catch");
    gc_root(strlit3448);
  }
// compiled string node returning strlit3448 (depth = 10)
  int op_slot_right_3447 = gc_frame_newslot(strlit3448);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3451 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe3450);
// compiled call node returning call3451 (depth = 11)
// compiled member node returning call3451 (depth = 10)
  int op_slot_left_3447 = gc_frame_newslot(call3451);
  params[0] = strlit3448;
  partcv[0] = 1;
  Object opresult3452 = callmethod(call3451, "==", 1, partcv, params);
// compiled op node returning opresult3452 (depth = 9)
  int op_slot_right_3446 = gc_frame_newslot(opresult3452);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3455 == NULL) {
    strlit3455 = alloc_String("identifier");
    gc_root(strlit3455);
  }
// compiled string node returning strlit3455 (depth = 10)
  int op_slot_right_3454 = gc_frame_newslot(strlit3455);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3458 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3457);
// compiled call node returning call3458 (depth = 11)
// compiled member node returning call3458 (depth = 10)
  int op_slot_left_3454 = gc_frame_newslot(call3458);
  params[0] = strlit3455;
  partcv[0] = 1;
  Object opresult3459 = callmethod(call3458, "==", 1, partcv, params);
// compiled op node returning opresult3459 (depth = 9)
  int op_slot_left_3446 = gc_frame_newslot(opresult3459);
  params[0] = opresult3452;
  partcv[0] = 1;
  Object opresult3460 = callmethod(opresult3459, "&&", 1, partcv, params);
// compiled op node returning opresult3460 (depth = 8)
  int op_slot_right_3445 = gc_frame_newslot(opresult3460);
// starting to compile op node (depth = 8)
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3465 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_catchTok (depth = 13)
  partcv[0] = 0;
  Object call3466 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3465);
// compiled call node returning call3466 (depth = 12)
// compiled member node returning call3466 (depth = 11)
  int op_slot_right_3464 = gc_frame_newslot(call3466);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3469 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe3468);
// compiled call node returning call3469 (depth = 12)
// compiled member node returning call3469 (depth = 11)
  int op_slot_left_3464 = gc_frame_newslot(call3469);
  params[0] = call3466;
  partcv[0] = 1;
  Object opresult3470 = callmethod(call3469, "==", 1, partcv, params);
// compiled op node returning opresult3470 (depth = 10)
  int op_slot_right_3463 = gc_frame_newslot(opresult3470);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit3473 == NULL) {
    strlit3473 = alloc_String("rparen");
    gc_root(strlit3473);
  }
// compiled string node returning strlit3473 (depth = 11)
  int op_slot_right_3472 = gc_frame_newslot(strlit3473);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3475 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call3476 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3475);
// compiled call node returning call3476 (depth = 12)
// compiled member node returning call3476 (depth = 11)
  int op_slot_left_3472 = gc_frame_newslot(call3476);
  params[0] = strlit3473;
  partcv[0] = 1;
  Object opresult3477 = callmethod(call3476, "==", 1, partcv, params);
// compiled op node returning opresult3477 (depth = 10)
  int op_slot_left_3463 = gc_frame_newslot(opresult3477);
  params[0] = opresult3470;
  partcv[0] = 1;
  Object opresult3478 = callmethod(opresult3477, "&&", 1, partcv, params);
// compiled op node returning opresult3478 (depth = 9)
  int op_slot_right_3462 = gc_frame_newslot(opresult3478);
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3481 == NULL) {
    strlit3481 = alloc_String("rbrace");
    gc_root(strlit3481);
  }
// compiled string node returning strlit3481 (depth = 10)
  int op_slot_right_3480 = gc_frame_newslot(strlit3481);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call3484 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3483);
// compiled call node returning call3484 (depth = 11)
// compiled member node returning call3484 (depth = 10)
  int op_slot_left_3480 = gc_frame_newslot(call3484);
  params[0] = strlit3481;
  partcv[0] = 1;
  Object opresult3485 = callmethod(call3484, "==", 1, partcv, params);
// compiled op node returning opresult3485 (depth = 9)
  int op_slot_left_3462 = gc_frame_newslot(opresult3485);
  params[0] = opresult3478;
  partcv[0] = 1;
  Object opresult3486 = callmethod(opresult3485, "||", 1, partcv, params);
// compiled op node returning opresult3486 (depth = 8)
  int op_slot_left_3445 = gc_frame_newslot(opresult3486);
  params[0] = opresult3460;
  partcv[0] = 1;
  Object opresult3487 = callmethod(opresult3486, "||", 1, partcv, params);
// compiled op node returning opresult3487 (depth = 7)
  gc_frame_end(frame);
  return opresult3487;
}
Object meth_parser__apply3562(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe3563 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3564 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3563);
// compiled call node returning call3564 (depth = 8)
  gc_frame_end(frame);
  return call3564;
}
Object meth_parser__apply3632(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3635 == NULL) {
    strlit3635 = alloc_String("catch");
    gc_root(strlit3635);
  }
// compiled string node returning strlit3635 (depth = 6)
  int op_slot_right_3634 = gc_frame_newslot(strlit3635);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3637 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3638 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3637);
// compiled call node returning call3638 (depth = 7)
// compiled member node returning call3638 (depth = 6)
  int op_slot_left_3634 = gc_frame_newslot(call3638);
  params[0] = strlit3635;
  partcv[0] = 1;
  Object opresult3639 = callmethod(call3638, "==", 1, partcv, params);
// compiled op node returning opresult3639 (depth = 5)
  int op_slot_right_3633 = gc_frame_newslot(opresult3639);
// starting to compile call node (depth = 5)
  int callframe3641 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3642 == NULL) {
    strlit3642 = alloc_String("identifier");
    gc_root(strlit3642);
  }
// compiled string node returning strlit3642 (depth = 6)
  gc_frame_newslot(strlit3642);
// call case 4: self request
  params[0] = strlit3642;
  partcv[0] = 1;
  Object call3643 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3641);
// compiled call node returning call3643 (depth = 5)
  int op_slot_left_3633 = gc_frame_newslot(call3643);
  params[0] = opresult3639;
  partcv[0] = 1;
  Object opresult3644 = callmethod(call3643, "&&", 1, partcv, params);
// compiled op node returning opresult3644 (depth = 4)
  gc_frame_end(frame);
  return opresult3644;
}
Object meth_parser__apply3666(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe3667 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3668 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3667);
// compiled call node returning call3668 (depth = 11)
  gc_frame_end(frame);
  return call3668;
}
Object meth_parser__apply3647(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3648 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3649 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3648);
// compiled call node returning call3649 (depth = 5)
// compiled member node returning call3649 (depth = 4)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3651 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3652 == NULL) {
    strlit3652 = alloc_String("lbrace");
    gc_root(strlit3652);
  }
// compiled string node returning strlit3652 (depth = 6)
  gc_frame_newslot(strlit3652);
// call case 4: self request
  params[0] = strlit3652;
  partcv[0] = 1;
  Object call3653 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3651);
// compiled call node returning call3653 (depth = 5)
  Object if3650 = done;
  if (istrue(call3653)) {
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3654 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3655 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3654);
// compiled call node returning call3655 (depth = 6)
// compiled member node returning call3655 (depth = 5)
    gc_frame_newslot(call3655);
    if3650 = call3655;
  } else {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3657 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3658 == NULL) {
    strlit3658 = alloc_String("lparen");
    gc_root(strlit3658);
  }
// compiled string node returning strlit3658 (depth = 7)
  gc_frame_newslot(strlit3658);
// call case 4: self request
  params[0] = strlit3658;
  partcv[0] = 1;
  Object call3659 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3657);
// compiled call node returning call3659 (depth = 6)
  Object if3656 = done;
  if (istrue(call3659)) {
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3661 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3660);
// compiled call node returning call3661 (depth = 7)
// compiled member node returning call3661 (depth = 6)
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3663 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe3664 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block3665 = alloc_Block(NULL, NULL, "parser", 1134);
  gc_frame_newslot(block3665);
// method _apply
  block_savedest(block3665);
  Object closure3666 = createclosure(2, "_apply");
  setclosureframe(closure3666, stackframe);
  addtoclosure(closure3666, var_blocksOK);
  addtoclosure(closure3666, selfslot);
  struct UserObject *uo3666 = (struct UserObject*)block3665;
  uo3666->data[0] = (Object)closure3666;
  Method *meth_meth_parser__apply3666 = addmethod2pos(block3665, "_apply", &meth_parser__apply3666, 0);
  int argcv_meth_parser__apply3666[] = {0};
  meth_meth_parser__apply3666->type = alloc_MethodType(1, argcv_meth_parser__apply3666);
  meth_meth_parser__apply3666->definitionModule = modulename;
  meth_meth_parser__apply3666->definitionLine = 1134;
// compiled block node returning block3665 (depth = 10)
  gc_frame_newslot(block3665);
// call case 4: self request
  params[0] = block3665;
  partcv[0] = 1;
  Object call3670 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3664);
// compiled call node returning call3670 (depth = 9)
  partcv[0] = 0;
  Object call3671 = callmethod(call3670, "not",
    1, partcv, params);
  gc_frame_end(callframe3663);
// compiled call node returning call3671 (depth = 8)
// compiled member node returning call3671 (depth = 7)
  Object if3662 = done;
  if (istrue(call3671)) {
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3672 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3674 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3673);
// compiled call node returning call3674 (depth = 11)
// compiled member node returning call3674 (depth = 10)
  partcv[0] = 0;
  Object call3675 = callmethod(call3674, "new",
    1, partcv, params);
  gc_frame_end(callframe3672);
// compiled call node returning call3675 (depth = 9)
// compiled member node returning call3675 (depth = 8)
  *var_suggestion = call3675;
  if (call3675 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3676 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3677 == NULL) {
    strlit3677 = alloc_String("rparen");
    gc_root(strlit3677);
  }
// compiled string node returning strlit3677 (depth = 9)
  gc_frame_newslot(strlit3677);
// call case 4: self request
  params[0] = strlit3677;
  partcv[0] = 1;
  Object call3678 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3676);
// compiled call node returning call3678 (depth = 8)
  *var_nextTok = call3678;
  if (call3678 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3680 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3680 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3682 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3682 (depth = 8)
  Object if3679 = done;
  if (istrue(opresult3682)) {
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3683 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3684 == NULL) {
    strlit3684 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3684);
  }
// compiled string node returning strlit3684 (depth = 9)
  gc_frame_newslot(strlit3684);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3684;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3685 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3683);
// compiled call node returning call3685 (depth = 8)
    gc_frame_newslot(call3685);
    if3679 = call3685;
  } else {
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3686 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3687 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3688 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3687);
// compiled call node returning call3688 (depth = 10)
// compiled member node returning call3688 (depth = 9)
  gc_frame_newslot(call3688);
// starting to compile identifier node (depth = 9)
  Object bool3689 = alloc_Boolean(1);
// compiled identifier node returning bool3689 (depth = 9)
  gc_frame_newslot(bool3689);
// starting to compile identifier node (depth = 9)
  Object bool3690 = alloc_Boolean(0);
// compiled identifier node returning bool3690 (depth = 9)
  gc_frame_newslot(bool3690);
// starting to compile string node (depth = 9)
  if (strlit3691 == NULL) {
    strlit3691 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3691);
  }
// compiled string node returning strlit3691 (depth = 9)
  gc_frame_newslot(strlit3691);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call3688;
  params[2] = bool3689;
  params[3] = bool3690;
  params[4] = strlit3691;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3692 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3686);
// compiled call node returning call3692 (depth = 8)
    gc_frame_newslot(call3692);
    if3679 = call3692;
  }
// compiled if node returning if3679 (depth = 7)
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3693 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3694 == NULL) {
    strlit3694 = alloc_String("A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3694);
  }
// compiled string node returning strlit3694 (depth = 8)
  gc_frame_newslot(strlit3694);
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3696 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3695);
// compiled call node returning call3696 (depth = 9)
// compiled member node returning call3696 (depth = 8)
  gc_frame_newslot(call3696);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3697 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3698 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3697);
// compiled call node returning call3698 (depth = 9)
// compiled member node returning call3698 (depth = 8)
  gc_frame_newslot(call3698);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3694;
  params[1] = call3696;
  params[2] = call3698;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3699 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3693);
// compiled call node returning call3699 (depth = 7)
    gc_frame_newslot(call3699);
    if3662 = call3699;
  } else {
  }
// compiled if node returning if3662 (depth = 6)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3702 == NULL) {
    strlit3702 = alloc_String("rparen");
    gc_root(strlit3702);
  }
// compiled string node returning strlit3702 (depth = 8)
  int op_slot_right_3701 = gc_frame_newslot(strlit3702);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call3705 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3704);
// compiled call node returning call3705 (depth = 9)
// compiled member node returning call3705 (depth = 8)
  int op_slot_left_3701 = gc_frame_newslot(call3705);
  params[0] = strlit3702;
  partcv[0] = 1;
  Object opresult3706 = callmethod(call3705, "!=", 1, partcv, params);
// compiled op node returning opresult3706 (depth = 7)
  Object if3700 = done;
  if (istrue(opresult3706)) {
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3707 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3708 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3707);
// compiled call node returning call3708 (depth = 8)
// compiled member node returning call3708 (depth = 7)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3709 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3710 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3711 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3710);
// compiled call node returning call3711 (depth = 11)
// compiled member node returning call3711 (depth = 10)
  partcv[0] = 0;
  Object call3712 = callmethod(call3711, "new",
    1, partcv, params);
  gc_frame_end(callframe3709);
// compiled call node returning call3712 (depth = 9)
// compiled member node returning call3712 (depth = 8)
  *var_suggestion = call3712;
  if (call3712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3713 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3714 == NULL) {
    strlit3714 = alloc_String(")");
    gc_root(strlit3714);
  }
// compiled string node returning strlit3714 (depth = 8)
  gc_frame_newslot(strlit3714);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3714;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3715 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3713);
// compiled call node returning call3715 (depth = 7)
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3716 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3717 == NULL) {
    strlit3717 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3717);
  }
// compiled string node returning strlit3717 (depth = 8)
  gc_frame_newslot(strlit3717);
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3719 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3718);
// compiled call node returning call3719 (depth = 9)
// compiled member node returning call3719 (depth = 8)
  gc_frame_newslot(call3719);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3721 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3722 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3721);
// compiled call node returning call3722 (depth = 10)
// compiled member node returning call3722 (depth = 9)
  int op_slot_right_3720 = gc_frame_newslot(call3722);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call3725 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3724);
// compiled call node returning call3725 (depth = 10)
// compiled member node returning call3725 (depth = 9)
  int op_slot_left_3720 = gc_frame_newslot(call3725);
  params[0] = call3722;
  partcv[0] = 1;
  Object sum3726 = callmethod(call3725, "+", 1, partcv, params);
// compiled op node returning sum3726 (depth = 8)
  gc_frame_newslot(sum3726);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit3717;
  params[1] = call3719;
  params[2] = sum3726;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3727 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3716);
// compiled call node returning call3727 (depth = 7)
    gc_frame_newslot(call3727);
    if3700 = call3727;
  } else {
  }
// compiled if node returning if3700 (depth = 6)
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3728 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3729 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3728);
// compiled call node returning call3729 (depth = 7)
// compiled member node returning call3729 (depth = 6)
    gc_frame_newslot(call3729);
    if3656 = call3729;
  } else {
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array3730 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3730 (depth = 7)
  *var_suggestions = array3730;
  if (array3730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3731 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3732 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3731);
// compiled call node returning call3732 (depth = 7)
  *var_nextTok = call3732;
  if (call3732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3733 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3735 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3734);
// compiled call node returning call3735 (depth = 10)
// compiled member node returning call3735 (depth = 9)
  partcv[0] = 0;
  Object call3736 = callmethod(call3735, "new",
    1, partcv, params);
  gc_frame_end(callframe3733);
// compiled call node returning call3736 (depth = 8)
// compiled member node returning call3736 (depth = 7)
  *var_suggestion = call3736;
  if (call3736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool3739 = alloc_Boolean(0);
// compiled identifier node returning bool3739 (depth = 8)
  int op_slot_right_3738 = gc_frame_newslot(bool3739);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3738 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3739;
  partcv[0] = 1;
  Object opresult3741 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3741 (depth = 7)
  Object if3737 = done;
  if (istrue(opresult3741)) {
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3742 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3743 == NULL) {
    strlit3743 = alloc_String(" }");
    gc_root(strlit3743);
  }
// compiled string node returning strlit3743 (depth = 8)
  gc_frame_newslot(strlit3743);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call3745 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe3744);
// compiled call node returning call3745 (depth = 9)
// compiled member node returning call3745 (depth = 8)
  gc_frame_newslot(call3745);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3743;
  params[1] = call3745;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3746 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3742);
// compiled call node returning call3746 (depth = 7)
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3747 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3748 == NULL) {
    strlit3748 = alloc_String(" {");
    gc_root(strlit3748);
  }
// compiled string node returning strlit3748 (depth = 8)
  gc_frame_newslot(strlit3748);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3748;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3749 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3747);
// compiled call node returning call3749 (depth = 7)
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3750 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3751 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3750);
// compiled call node returning call3751 (depth = 7)
    gc_frame_newslot(call3751);
    if3737 = call3751;
  } else {
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3753 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3753 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3755 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3755 (depth = 8)
  Object if3752 = done;
  if (istrue(opresult3755)) {
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3756 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3757 == NULL) {
    strlit3757 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3757);
  }
// compiled string node returning strlit3757 (depth = 9)
  gc_frame_newslot(strlit3757);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3757;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3758 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3756);
// compiled call node returning call3758 (depth = 8)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3759 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3760 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3759);
// compiled call node returning call3760 (depth = 8)
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3761 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call3763 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3762);
// compiled call node returning call3763 (depth = 12)
// compiled member node returning call3763 (depth = 11)
  partcv[0] = 0;
  Object call3764 = callmethod(call3763, "new",
    1, partcv, params);
  gc_frame_end(callframe3761);
// compiled call node returning call3764 (depth = 10)
// compiled member node returning call3764 (depth = 9)
  *var_suggestion = call3764;
  if (call3764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3766 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3767 == NULL) {
    strlit3767 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3767);
  }
// compiled string node returning strlit3767 (depth = 9)
  gc_frame_newslot(strlit3767);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3767;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3768 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3766);
// compiled call node returning call3768 (depth = 8)
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3769 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3770 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3769);
// compiled call node returning call3770 (depth = 8)
    gc_frame_newslot(call3770);
    if3752 = call3770;
  } else {
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3771 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3772 == NULL) {
    strlit3772 = alloc_String(" }");
    gc_root(strlit3772);
  }
// compiled string node returning strlit3772 (depth = 9)
  gc_frame_newslot(strlit3772);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3773 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3774 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3773);
// compiled call node returning call3774 (depth = 10)
// compiled member node returning call3774 (depth = 9)
  gc_frame_newslot(call3774);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3772;
  params[1] = call3774;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3775 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3771);
// compiled call node returning call3775 (depth = 8)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3776 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3777 == NULL) {
    strlit3777 = alloc_String(" {");
    gc_root(strlit3777);
  }
// compiled string node returning strlit3777 (depth = 9)
  gc_frame_newslot(strlit3777);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3777;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3778 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3776);
// compiled call node returning call3778 (depth = 8)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3779 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3780 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3779);
// compiled call node returning call3780 (depth = 8)
    gc_frame_newslot(call3780);
    if3752 = call3780;
  }
// compiled if node returning if3752 (depth = 7)
    gc_frame_newslot(if3752);
    if3737 = if3752;
  }
// compiled if node returning if3737 (depth = 6)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3781 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3782 == NULL) {
    strlit3782 = alloc_String("A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3782);
  }
// compiled string node returning strlit3782 (depth = 7)
  gc_frame_newslot(strlit3782);
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3783 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3784 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3783);
// compiled call node returning call3784 (depth = 8)
// compiled member node returning call3784 (depth = 7)
  gc_frame_newslot(call3784);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3785 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3786 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3785);
// compiled call node returning call3786 (depth = 8)
// compiled member node returning call3786 (depth = 7)
  gc_frame_newslot(call3786);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3782;
  params[1] = call3784;
  params[2] = call3786;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3787 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3781);
// compiled call node returning call3787 (depth = 6)
    gc_frame_newslot(call3787);
    if3656 = call3787;
  }
// compiled if node returning if3656 (depth = 5)
    gc_frame_newslot(if3656);
    if3650 = if3656;
  }
// compiled if node returning if3650 (depth = 4)
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3788 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call3790 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3789);
// compiled call node returning call3790 (depth = 6)
// compiled member node returning call3790 (depth = 5)
  gc_frame_newslot(call3790);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call3790;
  partcv[0] = 1;
  Object call3791 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe3788);
// compiled call node returning call3791 (depth = 4)
  gc_frame_end(frame);
  return call3791;
}
Object meth_parser__apply3866(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe3867 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call3868 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3867);
// compiled call node returning call3868 (depth = 10)
  gc_frame_end(frame);
  return call3868;
}
Object meth_parser_trycatch3406(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_blocksOK = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trycatch (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for trycatch");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3408 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit3411 == NULL) {
    strlit3411 = alloc_String("try");
    gc_root(strlit3411);
  }
// compiled string node returning strlit3411 (depth = 6)
  int op_slot_right_3410 = gc_frame_newslot(strlit3411);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3413 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3414 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3413);
// compiled call node returning call3414 (depth = 7)
// compiled member node returning call3414 (depth = 6)
  int op_slot_left_3410 = gc_frame_newslot(call3414);
  params[0] = strlit3411;
  partcv[0] = 1;
  Object opresult3415 = callmethod(call3414, "==", 1, partcv, params);
// compiled op node returning opresult3415 (depth = 5)
  int op_slot_right_3409 = gc_frame_newslot(opresult3415);
// starting to compile call node (depth = 5)
  int callframe3417 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3418 == NULL) {
    strlit3418 = alloc_String("identifier");
    gc_root(strlit3418);
  }
// compiled string node returning strlit3418 (depth = 6)
  gc_frame_newslot(strlit3418);
// call case 4: self request
  params[0] = strlit3418;
  partcv[0] = 1;
  Object call3419 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3417);
// compiled call node returning call3419 (depth = 5)
  int op_slot_left_3409 = gc_frame_newslot(call3419);
  params[0] = opresult3415;
  partcv[0] = 1;
  Object opresult3420 = callmethod(call3419, "&&", 1, partcv, params);
// compiled op node returning opresult3420 (depth = 4)
  partcv[0] = 0;
  Object call3421 = callmethod(opresult3420, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3408);
// compiled call node returning call3421 (depth = 3)
  Object if3407 = done;
  if (istrue(call3421)) {
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num3422 = alloc_Float64(0);
// compiled num node returning num3422 (depth = 4)
  return num3422;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3407 = undefined;
  } else {
  }
// compiled if node returning if3407 (depth = 2)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3423 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3424 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3423);
// compiled call node returning call3424 (depth = 3)
// compiled member node returning call3424 (depth = 2)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3426 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit3427 == NULL) {
    strlit3427 = alloc_String("lbrace");
    gc_root(strlit3427);
  }
// compiled string node returning strlit3427 (depth = 4)
  gc_frame_newslot(strlit3427);
// call case 4: self request
  params[0] = strlit3427;
  partcv[0] = 1;
  Object call3428 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3426);
// compiled call node returning call3428 (depth = 3)
  Object if3425 = done;
  if (istrue(call3428)) {
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3429 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3430 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3429);
// compiled call node returning call3430 (depth = 4)
// compiled member node returning call3430 (depth = 3)
    gc_frame_newslot(call3430);
    if3425 = call3430;
  } else {
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3433 == NULL) {
    strlit3433 = alloc_String("lparen");
    gc_root(strlit3433);
  }
// compiled string node returning strlit3433 (depth = 5)
  int op_slot_right_3432 = gc_frame_newslot(strlit3433);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3435 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3436 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3435);
// compiled call node returning call3436 (depth = 6)
// compiled member node returning call3436 (depth = 5)
  int op_slot_left_3432 = gc_frame_newslot(call3436);
  params[0] = strlit3433;
  partcv[0] = 1;
  Object opresult3437 = callmethod(call3436, "!=", 1, partcv, params);
// compiled op node returning opresult3437 (depth = 4)
  Object if3431 = done;
  if (istrue(opresult3437)) {
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3438 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3440 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3439);
// compiled call node returning call3440 (depth = 8)
// compiled member node returning call3440 (depth = 7)
  partcv[0] = 0;
  Object call3441 = callmethod(call3440, "new",
    1, partcv, params);
  gc_frame_end(callframe3438);
// compiled call node returning call3441 (depth = 6)
// compiled member node returning call3441 (depth = 5)
  *var_suggestion = call3441;
  if (call3441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3442 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block3443 = alloc_Block(NULL, NULL, "parser", 1084);
  gc_frame_newslot(block3443);
// method _apply
  block_savedest(block3443);
  Object closure3444 = createclosure(2, "_apply");
  setclosureframe(closure3444, stackframe);
  addtoclosure(closure3444, var_catchTok);
  addtoclosure(closure3444, selfslot);
  struct UserObject *uo3444 = (struct UserObject*)block3443;
  uo3444->data[0] = (Object)closure3444;
  Method *meth_meth_parser__apply3444 = addmethod2pos(block3443, "_apply", &meth_parser__apply3444, 0);
  int argcv_meth_parser__apply3444[] = {1};
  meth_meth_parser__apply3444->type = alloc_MethodType(1, argcv_meth_parser__apply3444);
  meth_meth_parser__apply3444->definitionModule = modulename;
  meth_meth_parser__apply3444->definitionLine = 1082;
// compiled block node returning block3443 (depth = 6)
  gc_frame_newslot(block3443);
// call case 4: self request
  params[0] = block3443;
  partcv[0] = 1;
  Object call3489 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3442);
// compiled call node returning call3489 (depth = 5)
  *var_nextTok = call3489;
  if (call3489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3492 = alloc_Boolean(0);
// compiled identifier node returning bool3492 (depth = 6)
  int op_slot_right_3491 = gc_frame_newslot(bool3492);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3491 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3492;
  partcv[0] = 1;
  Object opresult3494 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3494 (depth = 5)
  Object if3490 = done;
  if (istrue(opresult3494)) {
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3495 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3496 == NULL) {
    strlit3496 = alloc_String(" {}");
    gc_root(strlit3496);
  }
// compiled string node returning strlit3496 (depth = 6)
  gc_frame_newslot(strlit3496);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3496;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3497 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3495);
// compiled call node returning call3497 (depth = 5)
    gc_frame_newslot(call3497);
    if3490 = call3497;
  } else {
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3500 == NULL) {
    strlit3500 = alloc_String("rbrace");
    gc_root(strlit3500);
  }
// compiled string node returning strlit3500 (depth = 7)
  int op_slot_right_3499 = gc_frame_newslot(strlit3500);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call3503 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3502);
// compiled call node returning call3503 (depth = 8)
// compiled member node returning call3503 (depth = 7)
  int op_slot_left_3499 = gc_frame_newslot(call3503);
  params[0] = strlit3500;
  partcv[0] = 1;
  Object opresult3504 = callmethod(call3503, "==", 1, partcv, params);
// compiled op node returning opresult3504 (depth = 6)
  Object if3498 = done;
  if (istrue(opresult3504)) {
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3505 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3506 == NULL) {
    strlit3506 = alloc_String(" {");
    gc_root(strlit3506);
  }
// compiled string node returning strlit3506 (depth = 7)
  gc_frame_newslot(strlit3506);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3506;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3507 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3505);
// compiled call node returning call3507 (depth = 6)
    gc_frame_newslot(call3507);
    if3498 = call3507;
  } else {
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3510 == NULL) {
    strlit3510 = alloc_String("rparen");
    gc_root(strlit3510);
  }
// compiled string node returning strlit3510 (depth = 8)
  int op_slot_right_3509 = gc_frame_newslot(strlit3510);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3512 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3513 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3512);
// compiled call node returning call3513 (depth = 9)
// compiled member node returning call3513 (depth = 8)
  int op_slot_left_3509 = gc_frame_newslot(call3513);
  params[0] = strlit3510;
  partcv[0] = 1;
  Object opresult3514 = callmethod(call3513, "==", 1, partcv, params);
// compiled op node returning opresult3514 (depth = 7)
  Object if3508 = done;
  if (istrue(opresult3514)) {
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_3516 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_3516 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3518 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3518 (depth = 8)
  Object if3515 = done;
  if (istrue(opresult3518)) {
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3519 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3520 == NULL) {
    strlit3520 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3520);
  }
// compiled string node returning strlit3520 (depth = 9)
  gc_frame_newslot(strlit3520);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3521 = alloc_Boolean(1);
// compiled identifier node returning bool3521 (depth = 9)
  gc_frame_newslot(bool3521);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3520;
  params[1] = *var_lastToken;
  params[2] = bool3521;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3522 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3519);
// compiled call node returning call3522 (depth = 8)
    gc_frame_newslot(call3522);
    if3515 = call3522;
  } else {
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3523 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3524 == NULL) {
    strlit3524 = alloc_String("(");
    gc_root(strlit3524);
  }
// compiled string node returning strlit3524 (depth = 9)
  gc_frame_newslot(strlit3524);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool3525 = alloc_Boolean(1);
// compiled identifier node returning bool3525 (depth = 9)
  gc_frame_newslot(bool3525);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3524;
  params[1] = *var_lastToken;
  params[2] = bool3525;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3526 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3523);
// compiled call node returning call3526 (depth = 8)
    gc_frame_newslot(call3526);
    if3515 = call3526;
  }
// compiled if node returning if3515 (depth = 7)
    gc_frame_newslot(if3515);
    if3508 = if3515;
  } else {
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit3529 == NULL) {
    strlit3529 = alloc_String("identifier");
    gc_root(strlit3529);
  }
// compiled string node returning strlit3529 (depth = 9)
  int op_slot_right_3528 = gc_frame_newslot(strlit3529);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3531 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call3532 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3531);
// compiled call node returning call3532 (depth = 10)
// compiled member node returning call3532 (depth = 9)
  int op_slot_left_3528 = gc_frame_newslot(call3532);
  params[0] = strlit3529;
  partcv[0] = 1;
  Object opresult3533 = callmethod(call3532, "==", 1, partcv, params);
// compiled op node returning opresult3533 (depth = 8)
  Object if3527 = done;
  if (istrue(opresult3533)) {
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3534 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3535 == NULL) {
    strlit3535 = alloc_String(" {");
    gc_root(strlit3535);
  }
// compiled string node returning strlit3535 (depth = 9)
  gc_frame_newslot(strlit3535);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3535;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3536 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3534);
// compiled call node returning call3536 (depth = 8)
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe3537 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit3538 == NULL) {
    strlit3538 = alloc_String("} ");
    gc_root(strlit3538);
  }
// compiled string node returning strlit3538 (depth = 9)
  gc_frame_newslot(strlit3538);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit3538;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3539 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3537);
// compiled call node returning call3539 (depth = 8)
    gc_frame_newslot(call3539);
    if3527 = call3539;
  } else {
  }
// compiled if node returning if3527 (depth = 7)
    gc_frame_newslot(if3527);
    if3508 = if3527;
  }
// compiled if node returning if3508 (depth = 6)
    gc_frame_newslot(if3508);
    if3498 = if3508;
  }
// compiled if node returning if3498 (depth = 5)
    gc_frame_newslot(if3498);
    if3490 = if3498;
  }
// compiled if node returning if3490 (depth = 4)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3540 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3541 == NULL) {
    strlit3541 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3541);
  }
// compiled string node returning strlit3541 (depth = 5)
  gc_frame_newslot(strlit3541);
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  partcv[0] = 0;
  Object call3543 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3542);
// compiled call node returning call3543 (depth = 6)
// compiled member node returning call3543 (depth = 5)
  gc_frame_newslot(call3543);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3545 = alloc_Float64(1);
// compiled num node returning num3545 (depth = 6)
  int op_slot_right_3544 = gc_frame_newslot(num3545);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3548 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3549 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe3548);
// compiled call node returning call3549 (depth = 8)
// compiled member node returning call3549 (depth = 7)
  int op_slot_right_3547 = gc_frame_newslot(call3549);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call3552 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3551);
// compiled call node returning call3552 (depth = 8)
// compiled member node returning call3552 (depth = 7)
  int op_slot_left_3547 = gc_frame_newslot(call3552);
  params[0] = call3549;
  partcv[0] = 1;
  Object sum3553 = callmethod(call3552, "+", 1, partcv, params);
// compiled op node returning sum3553 (depth = 6)
  int op_slot_left_3544 = gc_frame_newslot(sum3553);
  params[0] = num3545;
  partcv[0] = 1;
  Object sum3554 = callmethod(sum3553, "+", 1, partcv, params);
// compiled op node returning sum3554 (depth = 5)
  gc_frame_newslot(sum3554);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3541;
  params[1] = call3543;
  params[2] = sum3554;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3555 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3540);
// compiled call node returning call3555 (depth = 4)
    gc_frame_newslot(call3555);
    if3431 = call3555;
  } else {
  }
// compiled if node returning if3431 (depth = 3)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3556 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3557 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3556);
// compiled call node returning call3557 (depth = 4)
// compiled member node returning call3557 (depth = 3)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3559 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3560 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block3561 = alloc_Block(NULL, NULL, "parser", 1105);
  gc_frame_newslot(block3561);
// method _apply
  block_savedest(block3561);
  Object closure3562 = createclosure(2, "_apply");
  setclosureframe(closure3562, stackframe);
  addtoclosure(closure3562, var_blocksOK);
  addtoclosure(closure3562, selfslot);
  struct UserObject *uo3562 = (struct UserObject*)block3561;
  uo3562->data[0] = (Object)closure3562;
  Method *meth_meth_parser__apply3562 = addmethod2pos(block3561, "_apply", &meth_parser__apply3562, 0);
  int argcv_meth_parser__apply3562[] = {0};
  meth_meth_parser__apply3562->type = alloc_MethodType(1, argcv_meth_parser__apply3562);
  meth_meth_parser__apply3562->definitionModule = modulename;
  meth_meth_parser__apply3562->definitionLine = 1105;
// compiled block node returning block3561 (depth = 7)
  gc_frame_newslot(block3561);
// call case 4: self request
  params[0] = block3561;
  partcv[0] = 1;
  Object call3566 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3560);
// compiled call node returning call3566 (depth = 6)
  partcv[0] = 0;
  Object call3567 = callmethod(call3566, "not",
    1, partcv, params);
  gc_frame_end(callframe3559);
// compiled call node returning call3567 (depth = 5)
// compiled member node returning call3567 (depth = 4)
  Object if3558 = done;
  if (istrue(call3567)) {
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3568 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3570 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3569);
// compiled call node returning call3570 (depth = 8)
// compiled member node returning call3570 (depth = 7)
  partcv[0] = 0;
  Object call3571 = callmethod(call3570, "new",
    1, partcv, params);
  gc_frame_end(callframe3568);
// compiled call node returning call3571 (depth = 6)
// compiled member node returning call3571 (depth = 5)
  *var_suggestion = call3571;
  if (call3571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3572 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3573 == NULL) {
    strlit3573 = alloc_String("rparen");
    gc_root(strlit3573);
  }
// compiled string node returning strlit3573 (depth = 6)
  gc_frame_newslot(strlit3573);
// call case 4: self request
  params[0] = strlit3573;
  partcv[0] = 1;
  Object call3574 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3572);
// compiled call node returning call3574 (depth = 5)
  *var_nextTok = call3574;
  if (call3574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_3576 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_3576 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3578 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3578 (depth = 5)
  Object if3575 = done;
  if (istrue(opresult3578)) {
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3579 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3580 == NULL) {
    strlit3580 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3580);
  }
// compiled string node returning strlit3580 (depth = 6)
  gc_frame_newslot(strlit3580);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit3580;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3581 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3579);
// compiled call node returning call3581 (depth = 5)
    gc_frame_newslot(call3581);
    if3575 = call3581;
  } else {
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3582 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call3584 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3583);
// compiled call node returning call3584 (depth = 7)
// compiled member node returning call3584 (depth = 6)
  gc_frame_newslot(call3584);
// starting to compile identifier node (depth = 6)
  Object bool3585 = alloc_Boolean(1);
// compiled identifier node returning bool3585 (depth = 6)
  gc_frame_newslot(bool3585);
// starting to compile identifier node (depth = 6)
  Object bool3586 = alloc_Boolean(0);
// compiled identifier node returning bool3586 (depth = 6)
  gc_frame_newslot(bool3586);
// starting to compile string node (depth = 6)
  if (strlit3587 == NULL) {
    strlit3587 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3587);
  }
// compiled string node returning strlit3587 (depth = 6)
  gc_frame_newslot(strlit3587);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call3584;
  params[2] = bool3585;
  params[3] = bool3586;
  params[4] = strlit3587;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3588 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3582);
// compiled call node returning call3588 (depth = 5)
    gc_frame_newslot(call3588);
    if3575 = call3588;
  }
// compiled if node returning if3575 (depth = 4)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3589 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3590 == NULL) {
    strlit3590 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3590);
  }
// compiled string node returning strlit3590 (depth = 5)
  gc_frame_newslot(strlit3590);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3591 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3592 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3591);
// compiled call node returning call3592 (depth = 6)
// compiled member node returning call3592 (depth = 5)
  gc_frame_newslot(call3592);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3593 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3594 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3593);
// compiled call node returning call3594 (depth = 6)
// compiled member node returning call3594 (depth = 5)
  gc_frame_newslot(call3594);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3590;
  params[1] = call3592;
  params[2] = call3594;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3595 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3589);
// compiled call node returning call3595 (depth = 4)
    gc_frame_newslot(call3595);
    if3558 = call3595;
  } else {
  }
// compiled if node returning if3558 (depth = 3)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3598 == NULL) {
    strlit3598 = alloc_String("rparen");
    gc_root(strlit3598);
  }
// compiled string node returning strlit3598 (depth = 5)
  int op_slot_right_3597 = gc_frame_newslot(strlit3598);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3601 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3600);
// compiled call node returning call3601 (depth = 6)
// compiled member node returning call3601 (depth = 5)
  int op_slot_left_3597 = gc_frame_newslot(call3601);
  params[0] = strlit3598;
  partcv[0] = 1;
  Object opresult3602 = callmethod(call3601, "!=", 1, partcv, params);
// compiled op node returning opresult3602 (depth = 4)
  Object if3596 = done;
  if (istrue(opresult3602)) {
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3603 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3604 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3603);
// compiled call node returning call3604 (depth = 5)
// compiled member node returning call3604 (depth = 4)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3605 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call3607 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3606);
// compiled call node returning call3607 (depth = 8)
// compiled member node returning call3607 (depth = 7)
  partcv[0] = 0;
  Object call3608 = callmethod(call3607, "new",
    1, partcv, params);
  gc_frame_end(callframe3605);
// compiled call node returning call3608 (depth = 6)
// compiled member node returning call3608 (depth = 5)
  *var_suggestion = call3608;
  if (call3608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3609 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3610 == NULL) {
    strlit3610 = alloc_String(")");
    gc_root(strlit3610);
  }
// compiled string node returning strlit3610 (depth = 5)
  gc_frame_newslot(strlit3610);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit3610;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3611 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3609);
// compiled call node returning call3611 (depth = 4)
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3612 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3613 == NULL) {
    strlit3613 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3613);
  }
// compiled string node returning strlit3613 (depth = 5)
  gc_frame_newslot(strlit3613);
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call3615 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3614);
// compiled call node returning call3615 (depth = 6)
// compiled member node returning call3615 (depth = 5)
  gc_frame_newslot(call3615);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3617 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3618 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3617);
// compiled call node returning call3618 (depth = 7)
// compiled member node returning call3618 (depth = 6)
  int op_slot_right_3616 = gc_frame_newslot(call3618);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call3621 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3620);
// compiled call node returning call3621 (depth = 7)
// compiled member node returning call3621 (depth = 6)
  int op_slot_left_3616 = gc_frame_newslot(call3621);
  params[0] = call3618;
  partcv[0] = 1;
  Object sum3622 = callmethod(call3621, "+", 1, partcv, params);
// compiled op node returning sum3622 (depth = 5)
  gc_frame_newslot(sum3622);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit3613;
  params[1] = call3615;
  params[2] = sum3622;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3623 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3612);
// compiled call node returning call3623 (depth = 4)
    gc_frame_newslot(call3623);
    if3596 = call3623;
  } else {
  }
// compiled if node returning if3596 (depth = 3)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3624 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3625 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3624);
// compiled call node returning call3625 (depth = 4)
// compiled member node returning call3625 (depth = 3)
    gc_frame_newslot(call3625);
    if3425 = call3625;
  }
// compiled if node returning if3425 (depth = 2)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call3627 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3626);
// compiled call node returning call3627 (depth = 4)
// compiled member node returning call3627 (depth = 3)
  *var_mainblock = call3627;
  if (call3627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array3628 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3628 (depth = 3)
  *var_cases = array3628;
  if (array3628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool3629 = alloc_Boolean(0);
// compiled identifier node returning bool3629 (depth = 3)
  *var_finally = bool3629;
  if (bool3629 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3630 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3631 = alloc_Block(NULL, NULL, "parser", 1128);
  gc_frame_newslot(block3631);
// method _apply
  block_savedest(block3631);
  Object closure3632 = createclosure(2, "_apply");
  setclosureframe(closure3632, stackframe);
  addtoclosure(closure3632, var_sym);
  addtoclosure(closure3632, selfslot);
  struct UserObject *uo3632 = (struct UserObject*)block3631;
  uo3632->data[0] = (Object)closure3632;
  Method *meth_meth_parser__apply3632 = addmethod2pos(block3631, "_apply", &meth_parser__apply3632, 0);
  int argcv_meth_parser__apply3632[] = {0};
  meth_meth_parser__apply3632->type = alloc_MethodType(1, argcv_meth_parser__apply3632);
  meth_meth_parser__apply3632->definitionModule = modulename;
  meth_meth_parser__apply3632->definitionLine = 1125;
// compiled block node returning block3631 (depth = 3)
  gc_frame_newslot(block3631);
// starting to compile block node (depth = 3)
  Object block3646 = alloc_Block(NULL, NULL, "parser", 1128);
  gc_frame_newslot(block3646);
// method _apply
  block_savedest(block3646);
  Object closure3647 = createclosure(8, "_apply");
  setclosureframe(closure3647, stackframe);
  addtoclosure(closure3647, var_blocksOK);
  addtoclosure(closure3647, var_errormessages);
  addtoclosure(closure3647, var_sym);
  addtoclosure(closure3647, var_lastToken);
  addtoclosure(closure3647, var_tokens);
  addtoclosure(closure3647, var_values);
  addtoclosure(closure3647, var_cases);
  addtoclosure(closure3647, selfslot);
  struct UserObject *uo3647 = (struct UserObject*)block3646;
  uo3647->data[0] = (Object)closure3647;
  Method *meth_meth_parser__apply3647 = addmethod2pos(block3646, "_apply", &meth_parser__apply3647, 0);
  int argcv_meth_parser__apply3647[] = {0};
  meth_meth_parser__apply3647->type = alloc_MethodType(1, argcv_meth_parser__apply3647);
  meth_meth_parser__apply3647->definitionModule = modulename;
  meth_meth_parser__apply3647->definitionLine = 1128;
// compiled block node returning block3646 (depth = 3)
  gc_frame_newslot(block3646);
// call case 5: prelude request
  params[0] = block3631;
  params[1] = block3646;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3793 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3630);
// compiled call node returning call3793 (depth = 2)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3797 == NULL) {
    strlit3797 = alloc_String("case");
    gc_root(strlit3797);
  }
// compiled string node returning strlit3797 (depth = 5)
  int op_slot_right_3796 = gc_frame_newslot(strlit3797);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3799 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3800 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3799);
// compiled call node returning call3800 (depth = 6)
// compiled member node returning call3800 (depth = 5)
  int op_slot_left_3796 = gc_frame_newslot(call3800);
  params[0] = strlit3797;
  partcv[0] = 1;
  Object opresult3801 = callmethod(call3800, "==", 1, partcv, params);
// compiled op node returning opresult3801 (depth = 4)
  int op_slot_right_3795 = gc_frame_newslot(opresult3801);
// starting to compile call node (depth = 4)
  int callframe3803 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3804 == NULL) {
    strlit3804 = alloc_String("identifier");
    gc_root(strlit3804);
  }
// compiled string node returning strlit3804 (depth = 5)
  gc_frame_newslot(strlit3804);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_catchTok (depth = 5)
  gc_frame_newslot(*var_catchTok);
// call case 4: self request
  params[0] = strlit3804;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3805 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3803);
// compiled call node returning call3805 (depth = 4)
  int op_slot_left_3795 = gc_frame_newslot(call3805);
  params[0] = opresult3801;
  partcv[0] = 1;
  Object opresult3806 = callmethod(call3805, "&&", 1, partcv, params);
// compiled op node returning opresult3806 (depth = 3)
  Object if3794 = done;
  if (istrue(opresult3806)) {
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3807 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call3809 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3808);
// compiled call node returning call3809 (depth = 7)
// compiled member node returning call3809 (depth = 6)
  partcv[0] = 0;
  Object call3810 = callmethod(call3809, "new",
    1, partcv, params);
  gc_frame_end(callframe3807);
// compiled call node returning call3810 (depth = 5)
// compiled member node returning call3810 (depth = 4)
  *var_suggestion = call3810;
  if (call3810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3811 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 4)
  if (strlit3812 == NULL) {
    strlit3812 = alloc_String("catch");
    gc_root(strlit3812);
  }
// compiled string node returning strlit3812 (depth = 4)
  gc_frame_newslot(strlit3812);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = *var_sym;
  params[1] = strlit3812;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3813 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe3811);
// compiled call node returning call3813 (depth = 3)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3814 = gc_frame_new();
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3816 == NULL) {
    strlit3816 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3816);
  }
// compiled string node returning strlit3816 (depth = 5)
  int op_slot_right_3815 = gc_frame_newslot(strlit3816);
// starting to compile op node (depth = 5)
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3819 == NULL) {
    strlit3819 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit3819);
  }
// compiled string node returning strlit3819 (depth = 6)
  int op_slot_right_3818 = gc_frame_newslot(strlit3819);
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit3821 == NULL) {
    strlit3821 = alloc_String("A try-catch statement starts with a ");
    gc_root(strlit3821);
  }
// compiled string node returning strlit3821 (depth = 6)
  int op_slot_left_3818 = gc_frame_newslot(strlit3821);
  params[0] = strlit3819;
  partcv[0] = 1;
  Object opresult3822 = callmethod(strlit3821, "++", 1, partcv, params);
// compiled op node returning opresult3822 (depth = 5)
  int op_slot_left_3815 = gc_frame_newslot(opresult3822);
  params[0] = strlit3816;
  partcv[0] = 1;
  Object opresult3823 = callmethod(opresult3822, "++", 1, partcv, params);
// compiled op node returning opresult3823 (depth = 4)
  gc_frame_newslot(opresult3823);
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3825 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3824);
// compiled call node returning call3825 (depth = 5)
// compiled member node returning call3825 (depth = 4)
  gc_frame_newslot(call3825);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call3827 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3826);
// compiled call node returning call3827 (depth = 5)
// compiled member node returning call3827 (depth = 4)
  gc_frame_newslot(call3827);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3829 = alloc_Float64(3);
// compiled num node returning num3829 (depth = 5)
  int op_slot_right_3828 = gc_frame_newslot(num3829);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3832 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3831);
// compiled call node returning call3832 (depth = 6)
// compiled member node returning call3832 (depth = 5)
  int op_slot_left_3828 = gc_frame_newslot(call3832);
  params[0] = num3829;
  partcv[0] = 1;
  Object sum3833 = callmethod(call3832, "+", 1, partcv, params);
// compiled op node returning sum3833 (depth = 4)
  gc_frame_newslot(sum3833);
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult3823;
  params[1] = call3825;
  params[2] = call3827;
  params[3] = sum3833;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3834 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3814);
// compiled call node returning call3834 (depth = 3)
    gc_frame_newslot(call3834);
    if3794 = call3834;
  } else {
  }
// compiled if node returning if3794 (depth = 2)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3838 == NULL) {
    strlit3838 = alloc_String("finally");
    gc_root(strlit3838);
  }
// compiled string node returning strlit3838 (depth = 5)
  int op_slot_right_3837 = gc_frame_newslot(strlit3838);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3840 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call3841 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3840);
// compiled call node returning call3841 (depth = 6)
// compiled member node returning call3841 (depth = 5)
  int op_slot_left_3837 = gc_frame_newslot(call3841);
  params[0] = strlit3838;
  partcv[0] = 1;
  Object opresult3842 = callmethod(call3841, "==", 1, partcv, params);
// compiled op node returning opresult3842 (depth = 4)
  int op_slot_right_3836 = gc_frame_newslot(opresult3842);
// starting to compile call node (depth = 4)
  int callframe3844 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3845 == NULL) {
    strlit3845 = alloc_String("identifier");
    gc_root(strlit3845);
  }
// compiled string node returning strlit3845 (depth = 5)
  gc_frame_newslot(strlit3845);
// call case 4: self request
  params[0] = strlit3845;
  partcv[0] = 1;
  Object call3846 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3844);
// compiled call node returning call3846 (depth = 4)
  int op_slot_left_3836 = gc_frame_newslot(call3846);
  params[0] = opresult3842;
  partcv[0] = 1;
  Object opresult3847 = callmethod(call3846, "&&", 1, partcv, params);
// compiled op node returning opresult3847 (depth = 3)
  Object if3835 = done;
  if (istrue(opresult3847)) {
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3849 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3848);
// compiled call node returning call3849 (depth = 4)
// compiled member node returning call3849 (depth = 3)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3851 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit3852 == NULL) {
    strlit3852 = alloc_String("lbrace");
    gc_root(strlit3852);
  }
// compiled string node returning strlit3852 (depth = 5)
  gc_frame_newslot(strlit3852);
// call case 4: self request
  params[0] = strlit3852;
  partcv[0] = 1;
  Object call3853 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3851);
// compiled call node returning call3853 (depth = 4)
  Object if3850 = done;
  if (istrue(call3853)) {
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3854 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3855 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3854);
// compiled call node returning call3855 (depth = 5)
// compiled member node returning call3855 (depth = 4)
    gc_frame_newslot(call3855);
    if3850 = call3855;
  } else {
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3857 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3858 == NULL) {
    strlit3858 = alloc_String("lparen");
    gc_root(strlit3858);
  }
// compiled string node returning strlit3858 (depth = 6)
  gc_frame_newslot(strlit3858);
// call case 4: self request
  params[0] = strlit3858;
  partcv[0] = 1;
  Object call3859 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3857);
// compiled call node returning call3859 (depth = 5)
  Object if3856 = done;
  if (istrue(call3859)) {
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3860 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3861 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3860);
// compiled call node returning call3861 (depth = 6)
// compiled member node returning call3861 (depth = 5)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3863 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3864 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block3865 = alloc_Block(NULL, NULL, "parser", 1192);
  gc_frame_newslot(block3865);
// method _apply
  block_savedest(block3865);
  Object closure3866 = createclosure(2, "_apply");
  setclosureframe(closure3866, stackframe);
  addtoclosure(closure3866, var_blocksOK);
  addtoclosure(closure3866, selfslot);
  struct UserObject *uo3866 = (struct UserObject*)block3865;
  uo3866->data[0] = (Object)closure3866;
  Method *meth_meth_parser__apply3866 = addmethod2pos(block3865, "_apply", &meth_parser__apply3866, 0);
  int argcv_meth_parser__apply3866[] = {0};
  meth_meth_parser__apply3866->type = alloc_MethodType(1, argcv_meth_parser__apply3866);
  meth_meth_parser__apply3866->definitionModule = modulename;
  meth_meth_parser__apply3866->definitionLine = 1192;
// compiled block node returning block3865 (depth = 9)
  gc_frame_newslot(block3865);
// call case 4: self request
  params[0] = block3865;
  partcv[0] = 1;
  Object call3870 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3864);
// compiled call node returning call3870 (depth = 8)
  partcv[0] = 0;
  Object call3871 = callmethod(call3870, "not",
    1, partcv, params);
  gc_frame_end(callframe3863);
// compiled call node returning call3871 (depth = 7)
// compiled member node returning call3871 (depth = 6)
  Object if3862 = done;
  if (istrue(call3871)) {
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3872 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3874 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3873);
// compiled call node returning call3874 (depth = 10)
// compiled member node returning call3874 (depth = 9)
  partcv[0] = 0;
  Object call3875 = callmethod(call3874, "new",
    1, partcv, params);
  gc_frame_end(callframe3872);
// compiled call node returning call3875 (depth = 8)
// compiled member node returning call3875 (depth = 7)
  *var_suggestion = call3875;
  if (call3875 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3876 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3877 == NULL) {
    strlit3877 = alloc_String("rparen");
    gc_root(strlit3877);
  }
// compiled string node returning strlit3877 (depth = 8)
  gc_frame_newslot(strlit3877);
// call case 4: self request
  params[0] = strlit3877;
  partcv[0] = 1;
  Object call3878 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3876);
// compiled call node returning call3878 (depth = 7)
  *var_nextTok = call3878;
  if (call3878 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3880 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3880 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3882 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3882 (depth = 7)
  Object if3879 = done;
  if (istrue(opresult3882)) {
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3883 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3884 == NULL) {
    strlit3884 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3884);
  }
// compiled string node returning strlit3884 (depth = 8)
  gc_frame_newslot(strlit3884);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3884;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3885 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3883);
// compiled call node returning call3885 (depth = 7)
    gc_frame_newslot(call3885);
    if3879 = call3885;
  } else {
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3886 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3888 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3887);
// compiled call node returning call3888 (depth = 9)
// compiled member node returning call3888 (depth = 8)
  gc_frame_newslot(call3888);
// starting to compile identifier node (depth = 8)
  Object bool3889 = alloc_Boolean(1);
// compiled identifier node returning bool3889 (depth = 8)
  gc_frame_newslot(bool3889);
// starting to compile identifier node (depth = 8)
  Object bool3890 = alloc_Boolean(0);
// compiled identifier node returning bool3890 (depth = 8)
  gc_frame_newslot(bool3890);
// starting to compile string node (depth = 8)
  if (strlit3891 == NULL) {
    strlit3891 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3891);
  }
// compiled string node returning strlit3891 (depth = 8)
  gc_frame_newslot(strlit3891);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call3888;
  params[2] = bool3889;
  params[3] = bool3890;
  params[4] = strlit3891;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3892 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3886);
// compiled call node returning call3892 (depth = 7)
    gc_frame_newslot(call3892);
    if3879 = call3892;
  }
// compiled if node returning if3879 (depth = 6)
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3893 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3894 == NULL) {
    strlit3894 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3894);
  }
// compiled string node returning strlit3894 (depth = 7)
  gc_frame_newslot(strlit3894);
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3895 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3896 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3895);
// compiled call node returning call3896 (depth = 8)
// compiled member node returning call3896 (depth = 7)
  gc_frame_newslot(call3896);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3897 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3898 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3897);
// compiled call node returning call3898 (depth = 8)
// compiled member node returning call3898 (depth = 7)
  gc_frame_newslot(call3898);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3894;
  params[1] = call3896;
  params[2] = call3898;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3899 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3893);
// compiled call node returning call3899 (depth = 6)
    gc_frame_newslot(call3899);
    if3862 = call3899;
  } else {
  }
// compiled if node returning if3862 (depth = 5)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3902 == NULL) {
    strlit3902 = alloc_String("rparen");
    gc_root(strlit3902);
  }
// compiled string node returning strlit3902 (depth = 7)
  int op_slot_right_3901 = gc_frame_newslot(strlit3902);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3904 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call3905 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3904);
// compiled call node returning call3905 (depth = 8)
// compiled member node returning call3905 (depth = 7)
  int op_slot_left_3901 = gc_frame_newslot(call3905);
  params[0] = strlit3902;
  partcv[0] = 1;
  Object opresult3906 = callmethod(call3905, "!=", 1, partcv, params);
// compiled op node returning opresult3906 (depth = 6)
  Object if3900 = done;
  if (istrue(opresult3906)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3907 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3908 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compiled call node returning call3908 (depth = 7)
// compiled member node returning call3908 (depth = 6)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3909 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3910 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call3911 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3910);
// compiled call node returning call3911 (depth = 10)
// compiled member node returning call3911 (depth = 9)
  partcv[0] = 0;
  Object call3912 = callmethod(call3911, "new",
    1, partcv, params);
  gc_frame_end(callframe3909);
// compiled call node returning call3912 (depth = 8)
// compiled member node returning call3912 (depth = 7)
  *var_suggestion = call3912;
  if (call3912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3913 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3914 == NULL) {
    strlit3914 = alloc_String(")");
    gc_root(strlit3914);
  }
// compiled string node returning strlit3914 (depth = 7)
  gc_frame_newslot(strlit3914);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3914;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3915 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3913);
// compiled call node returning call3915 (depth = 6)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3916 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3917 == NULL) {
    strlit3917 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3917);
  }
// compiled string node returning strlit3917 (depth = 7)
  gc_frame_newslot(strlit3917);
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call3919 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3918);
// compiled call node returning call3919 (depth = 8)
// compiled member node returning call3919 (depth = 7)
  gc_frame_newslot(call3919);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3922 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3921);
// compiled call node returning call3922 (depth = 9)
// compiled member node returning call3922 (depth = 8)
  int op_slot_right_3920 = gc_frame_newslot(call3922);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call3925 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3924);
// compiled call node returning call3925 (depth = 9)
// compiled member node returning call3925 (depth = 8)
  int op_slot_left_3920 = gc_frame_newslot(call3925);
  params[0] = call3922;
  partcv[0] = 1;
  Object sum3926 = callmethod(call3925, "+", 1, partcv, params);
// compiled op node returning sum3926 (depth = 7)
  gc_frame_newslot(sum3926);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit3917;
  params[1] = call3919;
  params[2] = sum3926;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3927 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3916);
// compiled call node returning call3927 (depth = 6)
    gc_frame_newslot(call3927);
    if3900 = call3927;
  } else {
  }
// compiled if node returning if3900 (depth = 5)
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3928 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3929 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3928);
// compiled call node returning call3929 (depth = 6)
// compiled member node returning call3929 (depth = 5)
    gc_frame_newslot(call3929);
    if3856 = call3929;
  } else {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array3930 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array3930 (depth = 6)
  *var_suggestions = array3930;
  if (array3930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3931 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3932 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3931);
// compiled call node returning call3932 (depth = 6)
  *var_nextTok = call3932;
  if (call3932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3933 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3934 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call3935 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3934);
// compiled call node returning call3935 (depth = 9)
// compiled member node returning call3935 (depth = 8)
  partcv[0] = 0;
  Object call3936 = callmethod(call3935, "new",
    1, partcv, params);
  gc_frame_end(callframe3933);
// compiled call node returning call3936 (depth = 7)
// compiled member node returning call3936 (depth = 6)
  *var_suggestion = call3936;
  if (call3936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3939 = alloc_Boolean(0);
// compiled identifier node returning bool3939 (depth = 7)
  int op_slot_right_3938 = gc_frame_newslot(bool3939);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_3938 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3939;
  partcv[0] = 1;
  Object opresult3941 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3941 (depth = 6)
  Object if3937 = done;
  if (istrue(opresult3941)) {
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3942 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3943 == NULL) {
    strlit3943 = alloc_String(" }");
    gc_root(strlit3943);
  }
// compiled string node returning strlit3943 (depth = 7)
  gc_frame_newslot(strlit3943);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call3945 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe3944);
// compiled call node returning call3945 (depth = 8)
// compiled member node returning call3945 (depth = 7)
  gc_frame_newslot(call3945);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3943;
  params[1] = call3945;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3946 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3942);
// compiled call node returning call3946 (depth = 6)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3947 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit3948 == NULL) {
    strlit3948 = alloc_String(" {");
    gc_root(strlit3948);
  }
// compiled string node returning strlit3948 (depth = 7)
  gc_frame_newslot(strlit3948);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit3948;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3949 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3947);
// compiled call node returning call3949 (depth = 6)
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe3950 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3951 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3950);
// compiled call node returning call3951 (depth = 6)
    gc_frame_newslot(call3951);
    if3937 = call3951;
  } else {
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_3953 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_3953 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3955 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult3955 (depth = 7)
  Object if3952 = done;
  if (istrue(opresult3955)) {
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3956 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3957 == NULL) {
    strlit3957 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3957);
  }
// compiled string node returning strlit3957 (depth = 8)
  gc_frame_newslot(strlit3957);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3957;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3958 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3956);
// compiled call node returning call3958 (depth = 7)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3959 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3960 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3959);
// compiled call node returning call3960 (depth = 7)
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3961 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe3962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call3963 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3962);
// compiled call node returning call3963 (depth = 11)
// compiled member node returning call3963 (depth = 10)
  partcv[0] = 0;
  Object call3964 = callmethod(call3963, "new",
    1, partcv, params);
  gc_frame_end(callframe3961);
// compiled call node returning call3964 (depth = 9)
// compiled member node returning call3964 (depth = 8)
  *var_suggestion = call3964;
  if (call3964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3966 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3967 == NULL) {
    strlit3967 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit3967);
  }
// compiled string node returning strlit3967 (depth = 8)
  gc_frame_newslot(strlit3967);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3967;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3968 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3966);
// compiled call node returning call3968 (depth = 7)
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3969 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3970 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3969);
// compiled call node returning call3970 (depth = 7)
    gc_frame_newslot(call3970);
    if3952 = call3970;
  } else {
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3971 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3972 == NULL) {
    strlit3972 = alloc_String(" }");
    gc_root(strlit3972);
  }
// compiled string node returning strlit3972 (depth = 8)
  gc_frame_newslot(strlit3972);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe3973 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call3974 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3973);
// compiled call node returning call3974 (depth = 9)
// compiled member node returning call3974 (depth = 8)
  gc_frame_newslot(call3974);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3972;
  params[1] = call3974;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3975 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3971);
// compiled call node returning call3975 (depth = 7)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3976 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit3977 == NULL) {
    strlit3977 = alloc_String(" {");
    gc_root(strlit3977);
  }
// compiled string node returning strlit3977 (depth = 8)
  gc_frame_newslot(strlit3977);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit3977;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3978 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3976);
// compiled call node returning call3978 (depth = 7)
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe3979 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3980 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3979);
// compiled call node returning call3980 (depth = 7)
    gc_frame_newslot(call3980);
    if3952 = call3980;
  }
// compiled if node returning if3952 (depth = 6)
    gc_frame_newslot(if3952);
    if3937 = if3952;
  }
// compiled if node returning if3937 (depth = 5)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3981 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit3982 == NULL) {
    strlit3982 = alloc_String("A try-finally statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit3982);
  }
// compiled string node returning strlit3982 (depth = 6)
  gc_frame_newslot(strlit3982);
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3984 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3983);
// compiled call node returning call3984 (depth = 7)
// compiled member node returning call3984 (depth = 6)
  gc_frame_newslot(call3984);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call3986 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3985);
// compiled call node returning call3986 (depth = 7)
// compiled member node returning call3986 (depth = 6)
  gc_frame_newslot(call3986);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit3982;
  params[1] = call3984;
  params[2] = call3986;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3987 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3981);
// compiled call node returning call3987 (depth = 5)
    gc_frame_newslot(call3987);
    if3856 = call3987;
  }
// compiled if node returning if3856 (depth = 4)
    gc_frame_newslot(if3856);
    if3850 = if3856;
  }
// compiled if node returning if3850 (depth = 3)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call3989 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3988);
// compiled call node returning call3989 (depth = 5)
// compiled member node returning call3989 (depth = 4)
  *var_finally = call3989;
  if (call3989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if3835 = done;
  } else {
  }
// compiled if node returning if3835 (depth = 2)
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3991 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe3992 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call3994 = callmethod(*var_ast, "catchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe3993);
// compiled call node returning call3994 (depth = 5)
// compiled member node returning call3994 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call3995 = callmethod(call3994, "new",
    1, partcv, params);
  gc_frame_end(callframe3992);
// compiled call node returning call3995 (depth = 3)
  gc_frame_newslot(call3995);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call3995;
  partcv[0] = 1;
  Object call3996 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3991);
// compiled call node returning call3996 (depth = 2)
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4047(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4051 == NULL) {
    strlit4051 = alloc_String("case");
    gc_root(strlit4051);
  }
// compiled string node returning strlit4051 (depth = 10)
  int op_slot_right_4050 = gc_frame_newslot(strlit4051);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call4054 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4053);
// compiled call node returning call4054 (depth = 11)
// compiled member node returning call4054 (depth = 10)
  int op_slot_left_4050 = gc_frame_newslot(call4054);
  params[0] = strlit4051;
  partcv[0] = 1;
  Object opresult4055 = callmethod(call4054, "==", 1, partcv, params);
// compiled op node returning opresult4055 (depth = 9)
  int op_slot_right_4049 = gc_frame_newslot(opresult4055);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4058 == NULL) {
    strlit4058 = alloc_String("identifier");
    gc_root(strlit4058);
  }
// compiled string node returning strlit4058 (depth = 10)
  int op_slot_right_4057 = gc_frame_newslot(strlit4058);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call4061 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4060);
// compiled call node returning call4061 (depth = 11)
// compiled member node returning call4061 (depth = 10)
  int op_slot_left_4057 = gc_frame_newslot(call4061);
  params[0] = strlit4058;
  partcv[0] = 1;
  Object opresult4062 = callmethod(call4061, "==", 1, partcv, params);
// compiled op node returning opresult4062 (depth = 9)
  int op_slot_left_4049 = gc_frame_newslot(opresult4062);
  params[0] = opresult4055;
  partcv[0] = 1;
  Object opresult4063 = callmethod(opresult4062, "&&", 1, partcv, params);
// compiled op node returning opresult4063 (depth = 8)
  int op_slot_right_4048 = gc_frame_newslot(opresult4063);
// starting to compile op node (depth = 8)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_catchTok (depth = 13)
  partcv[0] = 0;
  Object call4069 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4068);
// compiled call node returning call4069 (depth = 12)
// compiled member node returning call4069 (depth = 11)
  int op_slot_right_4067 = gc_frame_newslot(call4069);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call4072 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4071);
// compiled call node returning call4072 (depth = 12)
// compiled member node returning call4072 (depth = 11)
  int op_slot_left_4067 = gc_frame_newslot(call4072);
  params[0] = call4069;
  partcv[0] = 1;
  Object opresult4073 = callmethod(call4072, "==", 1, partcv, params);
// compiled op node returning opresult4073 (depth = 10)
  int op_slot_right_4066 = gc_frame_newslot(opresult4073);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit4076 == NULL) {
    strlit4076 = alloc_String("rparen");
    gc_root(strlit4076);
  }
// compiled string node returning strlit4076 (depth = 11)
  int op_slot_right_4075 = gc_frame_newslot(strlit4076);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4078 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_t (depth = 13)
  partcv[0] = 0;
  Object call4079 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4078);
// compiled call node returning call4079 (depth = 12)
// compiled member node returning call4079 (depth = 11)
  int op_slot_left_4075 = gc_frame_newslot(call4079);
  params[0] = strlit4076;
  partcv[0] = 1;
  Object opresult4080 = callmethod(call4079, "==", 1, partcv, params);
// compiled op node returning opresult4080 (depth = 10)
  int op_slot_left_4066 = gc_frame_newslot(opresult4080);
  params[0] = opresult4073;
  partcv[0] = 1;
  Object opresult4081 = callmethod(opresult4080, "&&", 1, partcv, params);
// compiled op node returning opresult4081 (depth = 9)
  int op_slot_right_4065 = gc_frame_newslot(opresult4081);
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4084 == NULL) {
    strlit4084 = alloc_String("rbrace");
    gc_root(strlit4084);
  }
// compiled string node returning strlit4084 (depth = 10)
  int op_slot_right_4083 = gc_frame_newslot(strlit4084);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call4087 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4086);
// compiled call node returning call4087 (depth = 11)
// compiled member node returning call4087 (depth = 10)
  int op_slot_left_4083 = gc_frame_newslot(call4087);
  params[0] = strlit4084;
  partcv[0] = 1;
  Object opresult4088 = callmethod(call4087, "==", 1, partcv, params);
// compiled op node returning opresult4088 (depth = 9)
  int op_slot_left_4065 = gc_frame_newslot(opresult4088);
  params[0] = opresult4081;
  partcv[0] = 1;
  Object opresult4089 = callmethod(opresult4088, "||", 1, partcv, params);
// compiled op node returning opresult4089 (depth = 8)
  int op_slot_left_4048 = gc_frame_newslot(opresult4089);
  params[0] = opresult4063;
  partcv[0] = 1;
  Object opresult4090 = callmethod(opresult4089, "||", 1, partcv, params);
// compiled op node returning opresult4090 (depth = 7)
  gc_frame_end(frame);
  return opresult4090;
}
Object meth_parser__apply4165(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe4166 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4167 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4166);
// compiled call node returning call4167 (depth = 8)
  gc_frame_end(frame);
  return call4167;
}
Object meth_parser__apply4235(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4238 == NULL) {
    strlit4238 = alloc_String("case");
    gc_root(strlit4238);
  }
// compiled string node returning strlit4238 (depth = 6)
  int op_slot_right_4237 = gc_frame_newslot(strlit4238);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4240 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4241 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4240);
// compiled call node returning call4241 (depth = 7)
// compiled member node returning call4241 (depth = 6)
  int op_slot_left_4237 = gc_frame_newslot(call4241);
  params[0] = strlit4238;
  partcv[0] = 1;
  Object opresult4242 = callmethod(call4241, "==", 1, partcv, params);
// compiled op node returning opresult4242 (depth = 5)
  int op_slot_right_4236 = gc_frame_newslot(opresult4242);
// starting to compile call node (depth = 5)
  int callframe4244 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4245 == NULL) {
    strlit4245 = alloc_String("identifier");
    gc_root(strlit4245);
  }
// compiled string node returning strlit4245 (depth = 6)
  gc_frame_newslot(strlit4245);
// call case 4: self request
  params[0] = strlit4245;
  partcv[0] = 1;
  Object call4246 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4244);
// compiled call node returning call4246 (depth = 5)
  int op_slot_left_4236 = gc_frame_newslot(call4246);
  params[0] = opresult4242;
  partcv[0] = 1;
  Object opresult4247 = callmethod(call4246, "&&", 1, partcv, params);
// compiled op node returning opresult4247 (depth = 4)
  gc_frame_end(frame);
  return opresult4247;
}
Object meth_parser__apply4269(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe4270 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4271 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4270);
// compiled call node returning call4271 (depth = 11)
  gc_frame_end(frame);
  return call4271;
}
Object meth_parser__apply4250(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4252 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4251);
// compiled call node returning call4252 (depth = 5)
// compiled member node returning call4252 (depth = 4)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4254 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4255 == NULL) {
    strlit4255 = alloc_String("lbrace");
    gc_root(strlit4255);
  }
// compiled string node returning strlit4255 (depth = 6)
  gc_frame_newslot(strlit4255);
// call case 4: self request
  params[0] = strlit4255;
  partcv[0] = 1;
  Object call4256 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4254);
// compiled call node returning call4256 (depth = 5)
  Object if4253 = done;
  if (istrue(call4256)) {
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4257 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4258 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4257);
// compiled call node returning call4258 (depth = 6)
// compiled member node returning call4258 (depth = 5)
    gc_frame_newslot(call4258);
    if4253 = call4258;
  } else {
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4260 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4261 == NULL) {
    strlit4261 = alloc_String("lparen");
    gc_root(strlit4261);
  }
// compiled string node returning strlit4261 (depth = 7)
  gc_frame_newslot(strlit4261);
// call case 4: self request
  params[0] = strlit4261;
  partcv[0] = 1;
  Object call4262 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4260);
// compiled call node returning call4262 (depth = 6)
  Object if4259 = done;
  if (istrue(call4262)) {
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4263 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4264 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4263);
// compiled call node returning call4264 (depth = 7)
// compiled member node returning call4264 (depth = 6)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4266 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe4267 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block4268 = alloc_Block(NULL, NULL, "parser", 1304);
  gc_frame_newslot(block4268);
// method _apply
  block_savedest(block4268);
  Object closure4269 = createclosure(2, "_apply");
  setclosureframe(closure4269, stackframe);
  addtoclosure(closure4269, var_blocksOK);
  addtoclosure(closure4269, selfslot);
  struct UserObject *uo4269 = (struct UserObject*)block4268;
  uo4269->data[0] = (Object)closure4269;
  Method *meth_meth_parser__apply4269 = addmethod2pos(block4268, "_apply", &meth_parser__apply4269, 0);
  int argcv_meth_parser__apply4269[] = {0};
  meth_meth_parser__apply4269->type = alloc_MethodType(1, argcv_meth_parser__apply4269);
  meth_meth_parser__apply4269->definitionModule = modulename;
  meth_meth_parser__apply4269->definitionLine = 1304;
// compiled block node returning block4268 (depth = 10)
  gc_frame_newslot(block4268);
// call case 4: self request
  params[0] = block4268;
  partcv[0] = 1;
  Object call4273 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4267);
// compiled call node returning call4273 (depth = 9)
  partcv[0] = 0;
  Object call4274 = callmethod(call4273, "not",
    1, partcv, params);
  gc_frame_end(callframe4266);
// compiled call node returning call4274 (depth = 8)
// compiled member node returning call4274 (depth = 7)
  Object if4265 = done;
  if (istrue(call4274)) {
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4275 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4276 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4277 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4276);
// compiled call node returning call4277 (depth = 11)
// compiled member node returning call4277 (depth = 10)
  partcv[0] = 0;
  Object call4278 = callmethod(call4277, "new",
    1, partcv, params);
  gc_frame_end(callframe4275);
// compiled call node returning call4278 (depth = 9)
// compiled member node returning call4278 (depth = 8)
  *var_suggestion = call4278;
  if (call4278 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4279 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4280 == NULL) {
    strlit4280 = alloc_String("rparen");
    gc_root(strlit4280);
  }
// compiled string node returning strlit4280 (depth = 9)
  gc_frame_newslot(strlit4280);
// call case 4: self request
  params[0] = strlit4280;
  partcv[0] = 1;
  Object call4281 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4279);
// compiled call node returning call4281 (depth = 8)
  *var_nextTok = call4281;
  if (call4281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4283 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4283 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4285 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4285 (depth = 8)
  Object if4282 = done;
  if (istrue(opresult4285)) {
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4286 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4287 == NULL) {
    strlit4287 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4287);
  }
// compiled string node returning strlit4287 (depth = 9)
  gc_frame_newslot(strlit4287);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4287;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4288 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4286);
// compiled call node returning call4288 (depth = 8)
    gc_frame_newslot(call4288);
    if4282 = call4288;
  } else {
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4289 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4291 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4290);
// compiled call node returning call4291 (depth = 10)
// compiled member node returning call4291 (depth = 9)
  gc_frame_newslot(call4291);
// starting to compile identifier node (depth = 9)
  Object bool4292 = alloc_Boolean(1);
// compiled identifier node returning bool4292 (depth = 9)
  gc_frame_newslot(bool4292);
// starting to compile identifier node (depth = 9)
  Object bool4293 = alloc_Boolean(0);
// compiled identifier node returning bool4293 (depth = 9)
  gc_frame_newslot(bool4293);
// starting to compile string node (depth = 9)
  if (strlit4294 == NULL) {
    strlit4294 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4294);
  }
// compiled string node returning strlit4294 (depth = 9)
  gc_frame_newslot(strlit4294);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4291;
  params[2] = bool4292;
  params[3] = bool4293;
  params[4] = strlit4294;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4295 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4289);
// compiled call node returning call4295 (depth = 8)
    gc_frame_newslot(call4295);
    if4282 = call4295;
  }
// compiled if node returning if4282 (depth = 7)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4296 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4297 == NULL) {
    strlit4297 = alloc_String("A catch statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4297);
  }
// compiled string node returning strlit4297 (depth = 8)
  gc_frame_newslot(strlit4297);
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4299 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4298);
// compiled call node returning call4299 (depth = 9)
// compiled member node returning call4299 (depth = 8)
  gc_frame_newslot(call4299);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4300 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4301 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4300);
// compiled call node returning call4301 (depth = 9)
// compiled member node returning call4301 (depth = 8)
  gc_frame_newslot(call4301);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4297;
  params[1] = call4299;
  params[2] = call4301;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4302 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4296);
// compiled call node returning call4302 (depth = 7)
    gc_frame_newslot(call4302);
    if4265 = call4302;
  } else {
  }
// compiled if node returning if4265 (depth = 6)
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4305 == NULL) {
    strlit4305 = alloc_String("rparen");
    gc_root(strlit4305);
  }
// compiled string node returning strlit4305 (depth = 8)
  int op_slot_right_4304 = gc_frame_newslot(strlit4305);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4307 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4308 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4307);
// compiled call node returning call4308 (depth = 9)
// compiled member node returning call4308 (depth = 8)
  int op_slot_left_4304 = gc_frame_newslot(call4308);
  params[0] = strlit4305;
  partcv[0] = 1;
  Object opresult4309 = callmethod(call4308, "!=", 1, partcv, params);
// compiled op node returning opresult4309 (depth = 7)
  Object if4303 = done;
  if (istrue(opresult4309)) {
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4310 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4311 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4310);
// compiled call node returning call4311 (depth = 8)
// compiled member node returning call4311 (depth = 7)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4312 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4314 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4313);
// compiled call node returning call4314 (depth = 11)
// compiled member node returning call4314 (depth = 10)
  partcv[0] = 0;
  Object call4315 = callmethod(call4314, "new",
    1, partcv, params);
  gc_frame_end(callframe4312);
// compiled call node returning call4315 (depth = 9)
// compiled member node returning call4315 (depth = 8)
  *var_suggestion = call4315;
  if (call4315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4316 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4317 == NULL) {
    strlit4317 = alloc_String(")");
    gc_root(strlit4317);
  }
// compiled string node returning strlit4317 (depth = 8)
  gc_frame_newslot(strlit4317);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4317;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4318 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4316);
// compiled call node returning call4318 (depth = 7)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4319 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4320 == NULL) {
    strlit4320 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4320);
  }
// compiled string node returning strlit4320 (depth = 8)
  gc_frame_newslot(strlit4320);
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4321 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4322 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4321);
// compiled call node returning call4322 (depth = 9)
// compiled member node returning call4322 (depth = 8)
  gc_frame_newslot(call4322);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4324 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4325 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 10)
// compiled member node returning call4325 (depth = 9)
  int op_slot_right_4323 = gc_frame_newslot(call4325);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4328 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4327);
// compiled call node returning call4328 (depth = 10)
// compiled member node returning call4328 (depth = 9)
  int op_slot_left_4323 = gc_frame_newslot(call4328);
  params[0] = call4325;
  partcv[0] = 1;
  Object sum4329 = callmethod(call4328, "+", 1, partcv, params);
// compiled op node returning sum4329 (depth = 8)
  gc_frame_newslot(sum4329);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4320;
  params[1] = call4322;
  params[2] = sum4329;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4330 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4319);
// compiled call node returning call4330 (depth = 7)
    gc_frame_newslot(call4330);
    if4303 = call4330;
  } else {
  }
// compiled if node returning if4303 (depth = 6)
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4332 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4331);
// compiled call node returning call4332 (depth = 7)
// compiled member node returning call4332 (depth = 6)
    gc_frame_newslot(call4332);
    if4259 = call4332;
  } else {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array4333 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4333 (depth = 7)
  *var_suggestions = array4333;
  if (array4333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4334 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4335 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4334);
// compiled call node returning call4335 (depth = 7)
  *var_nextTok = call4335;
  if (call4335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4336 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4337 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4338 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4337);
// compiled call node returning call4338 (depth = 10)
// compiled member node returning call4338 (depth = 9)
  partcv[0] = 0;
  Object call4339 = callmethod(call4338, "new",
    1, partcv, params);
  gc_frame_end(callframe4336);
// compiled call node returning call4339 (depth = 8)
// compiled member node returning call4339 (depth = 7)
  *var_suggestion = call4339;
  if (call4339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4342 = alloc_Boolean(0);
// compiled identifier node returning bool4342 (depth = 8)
  int op_slot_right_4341 = gc_frame_newslot(bool4342);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4341 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4342;
  partcv[0] = 1;
  Object opresult4344 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4344 (depth = 7)
  Object if4340 = done;
  if (istrue(opresult4344)) {
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4345 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4346 == NULL) {
    strlit4346 = alloc_String(" }");
    gc_root(strlit4346);
  }
// compiled string node returning strlit4346 (depth = 8)
  gc_frame_newslot(strlit4346);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4347 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4348 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4347);
// compiled call node returning call4348 (depth = 9)
// compiled member node returning call4348 (depth = 8)
  gc_frame_newslot(call4348);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4346;
  params[1] = call4348;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4349 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4345);
// compiled call node returning call4349 (depth = 7)
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4350 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4351 == NULL) {
    strlit4351 = alloc_String(" {");
    gc_root(strlit4351);
  }
// compiled string node returning strlit4351 (depth = 8)
  gc_frame_newslot(strlit4351);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4351;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4352 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4350);
// compiled call node returning call4352 (depth = 7)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4353 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4354 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4353);
// compiled call node returning call4354 (depth = 7)
    gc_frame_newslot(call4354);
    if4340 = call4354;
  } else {
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4356 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4356 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4358 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4358 (depth = 8)
  Object if4355 = done;
  if (istrue(opresult4358)) {
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4359 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4360 == NULL) {
    strlit4360 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4360);
  }
// compiled string node returning strlit4360 (depth = 9)
  gc_frame_newslot(strlit4360);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4360;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4361 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4361 (depth = 8)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4362 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4363 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4362);
// compiled call node returning call4363 (depth = 8)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4364 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4365 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4366 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4365);
// compiled call node returning call4366 (depth = 12)
// compiled member node returning call4366 (depth = 11)
  partcv[0] = 0;
  Object call4367 = callmethod(call4366, "new",
    1, partcv, params);
  gc_frame_end(callframe4364);
// compiled call node returning call4367 (depth = 10)
// compiled member node returning call4367 (depth = 9)
  *var_suggestion = call4367;
  if (call4367 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4369 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4370 == NULL) {
    strlit4370 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4370);
  }
// compiled string node returning strlit4370 (depth = 9)
  gc_frame_newslot(strlit4370);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4370;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4371 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4369);
// compiled call node returning call4371 (depth = 8)
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4372 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4373 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4372);
// compiled call node returning call4373 (depth = 8)
    gc_frame_newslot(call4373);
    if4355 = call4373;
  } else {
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4374 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4375 == NULL) {
    strlit4375 = alloc_String(" }");
    gc_root(strlit4375);
  }
// compiled string node returning strlit4375 (depth = 9)
  gc_frame_newslot(strlit4375);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4377 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4376);
// compiled call node returning call4377 (depth = 10)
// compiled member node returning call4377 (depth = 9)
  gc_frame_newslot(call4377);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4375;
  params[1] = call4377;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4378 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4374);
// compiled call node returning call4378 (depth = 8)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4379 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4380 == NULL) {
    strlit4380 = alloc_String(" {");
    gc_root(strlit4380);
  }
// compiled string node returning strlit4380 (depth = 9)
  gc_frame_newslot(strlit4380);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4380;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4381 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4379);
// compiled call node returning call4381 (depth = 8)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4382 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4383 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4382);
// compiled call node returning call4383 (depth = 8)
    gc_frame_newslot(call4383);
    if4355 = call4383;
  }
// compiled if node returning if4355 (depth = 7)
    gc_frame_newslot(if4355);
    if4340 = if4355;
  }
// compiled if node returning if4340 (depth = 6)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4384 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4385 == NULL) {
    strlit4385 = alloc_String("A catch statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4385);
  }
// compiled string node returning strlit4385 (depth = 7)
  gc_frame_newslot(strlit4385);
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4386 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4387 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4386);
// compiled call node returning call4387 (depth = 8)
// compiled member node returning call4387 (depth = 7)
  gc_frame_newslot(call4387);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4388 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4389 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4388);
// compiled call node returning call4389 (depth = 8)
// compiled member node returning call4389 (depth = 7)
  gc_frame_newslot(call4389);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4385;
  params[1] = call4387;
  params[2] = call4389;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4390 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4384);
// compiled call node returning call4390 (depth = 6)
    gc_frame_newslot(call4390);
    if4259 = call4390;
  }
// compiled if node returning if4259 (depth = 5)
    gc_frame_newslot(if4259);
    if4253 = if4259;
  }
// compiled if node returning if4253 (depth = 4)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4391 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4392 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4393 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4392);
// compiled call node returning call4393 (depth = 6)
// compiled member node returning call4393 (depth = 5)
  gc_frame_newslot(call4393);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4393;
  partcv[0] = 1;
  Object call4394 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4391);
// compiled call node returning call4394 (depth = 4)
  gc_frame_end(frame);
  return call4394;
}
Object meth_parser__apply4428(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe4429 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4430 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4429);
// compiled call node returning call4430 (depth = 10)
  gc_frame_end(frame);
  return call4430;
}
Object meth_parser_catchcase3998(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_tokens = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchcase (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for catchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4000 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4003 == NULL) {
    strlit4003 = alloc_String("catch");
    gc_root(strlit4003);
  }
// compiled string node returning strlit4003 (depth = 6)
  int op_slot_right_4002 = gc_frame_newslot(strlit4003);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4005 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4006 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4005);
// compiled call node returning call4006 (depth = 7)
// compiled member node returning call4006 (depth = 6)
  int op_slot_left_4002 = gc_frame_newslot(call4006);
  params[0] = strlit4003;
  partcv[0] = 1;
  Object opresult4007 = callmethod(call4006, "==", 1, partcv, params);
// compiled op node returning opresult4007 (depth = 5)
  int op_slot_right_4001 = gc_frame_newslot(opresult4007);
// starting to compile call node (depth = 5)
  int callframe4009 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4010 == NULL) {
    strlit4010 = alloc_String("identifier");
    gc_root(strlit4010);
  }
// compiled string node returning strlit4010 (depth = 6)
  gc_frame_newslot(strlit4010);
// call case 4: self request
  params[0] = strlit4010;
  partcv[0] = 1;
  Object call4011 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4009);
// compiled call node returning call4011 (depth = 5)
  int op_slot_left_4001 = gc_frame_newslot(call4011);
  params[0] = opresult4007;
  partcv[0] = 1;
  Object opresult4012 = callmethod(call4011, "&&", 1, partcv, params);
// compiled op node returning opresult4012 (depth = 4)
  partcv[0] = 0;
  Object call4013 = callmethod(opresult4012, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4000);
// compiled call node returning call4013 (depth = 3)
  Object if3999 = done;
  if (istrue(call4013)) {
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num4014 = alloc_Float64(0);
// compiled num node returning num4014 (depth = 4)
  return num4014;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3999 = undefined;
  } else {
  }
// compiled if node returning if3999 (depth = 2)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4015 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4016 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4015);
// compiled call node returning call4016 (depth = 3)
// compiled member node returning call4016 (depth = 2)
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4017 = gc_frame_new();
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4019 == NULL) {
    strlit4019 = alloc_String("instead.");
    gc_root(strlit4019);
  }
// compiled string node returning strlit4019 (depth = 4)
  int op_slot_right_4018 = gc_frame_newslot(strlit4019);
// starting to compile op node (depth = 4)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4022 == NULL) {
    strlit4022 = alloc_String("removed in a future version of the compiler. Use try-catch ");
    gc_root(strlit4022);
  }
// compiled string node returning strlit4022 (depth = 5)
  int op_slot_right_4021 = gc_frame_newslot(strlit4022);
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4024 == NULL) {
    strlit4024 = alloc_String("The catch-case statement is deprecated and will be ");
    gc_root(strlit4024);
  }
// compiled string node returning strlit4024 (depth = 5)
  int op_slot_left_4021 = gc_frame_newslot(strlit4024);
  params[0] = strlit4022;
  partcv[0] = 1;
  Object opresult4025 = callmethod(strlit4024, "++", 1, partcv, params);
// compiled op node returning opresult4025 (depth = 4)
  int op_slot_left_4018 = gc_frame_newslot(opresult4025);
  params[0] = strlit4019;
  partcv[0] = 1;
  Object opresult4026 = callmethod(opresult4025, "++", 1, partcv, params);
// compiled op node returning opresult4026 (depth = 3)
  gc_frame_newslot(opresult4026);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = opresult4026;
  partcv[0] = 1;
  Object call4027 = callmethod(*var_util, "warning",
    1, partcv, params);
  gc_frame_end(callframe4017);
// compiled call node returning call4027 (depth = 2)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4029 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4030 == NULL) {
    strlit4030 = alloc_String("lbrace");
    gc_root(strlit4030);
  }
// compiled string node returning strlit4030 (depth = 4)
  gc_frame_newslot(strlit4030);
// call case 4: self request
  params[0] = strlit4030;
  partcv[0] = 1;
  Object call4031 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4029);
// compiled call node returning call4031 (depth = 3)
  Object if4028 = done;
  if (istrue(call4031)) {
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4032 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4033 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4032);
// compiled call node returning call4033 (depth = 4)
// compiled member node returning call4033 (depth = 3)
    gc_frame_newslot(call4033);
    if4028 = call4033;
  } else {
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4036 == NULL) {
    strlit4036 = alloc_String("lparen");
    gc_root(strlit4036);
  }
// compiled string node returning strlit4036 (depth = 5)
  int op_slot_right_4035 = gc_frame_newslot(strlit4036);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4038 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4039 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4038);
// compiled call node returning call4039 (depth = 6)
// compiled member node returning call4039 (depth = 5)
  int op_slot_left_4035 = gc_frame_newslot(call4039);
  params[0] = strlit4036;
  partcv[0] = 1;
  Object opresult4040 = callmethod(call4039, "!=", 1, partcv, params);
// compiled op node returning opresult4040 (depth = 4)
  Object if4034 = done;
  if (istrue(opresult4040)) {
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4041 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4042 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4043 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4042);
// compiled call node returning call4043 (depth = 8)
// compiled member node returning call4043 (depth = 7)
  partcv[0] = 0;
  Object call4044 = callmethod(call4043, "new",
    1, partcv, params);
  gc_frame_end(callframe4041);
// compiled call node returning call4044 (depth = 6)
// compiled member node returning call4044 (depth = 5)
  *var_suggestion = call4044;
  if (call4044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4045 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4046 = alloc_Block(NULL, NULL, "parser", 1254);
  gc_frame_newslot(block4046);
// method _apply
  block_savedest(block4046);
  Object closure4047 = createclosure(2, "_apply");
  setclosureframe(closure4047, stackframe);
  addtoclosure(closure4047, var_catchTok);
  addtoclosure(closure4047, selfslot);
  struct UserObject *uo4047 = (struct UserObject*)block4046;
  uo4047->data[0] = (Object)closure4047;
  Method *meth_meth_parser__apply4047 = addmethod2pos(block4046, "_apply", &meth_parser__apply4047, 0);
  int argcv_meth_parser__apply4047[] = {1};
  meth_meth_parser__apply4047->type = alloc_MethodType(1, argcv_meth_parser__apply4047);
  meth_meth_parser__apply4047->definitionModule = modulename;
  meth_meth_parser__apply4047->definitionLine = 1252;
// compiled block node returning block4046 (depth = 6)
  gc_frame_newslot(block4046);
// call case 4: self request
  params[0] = block4046;
  partcv[0] = 1;
  Object call4092 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4045);
// compiled call node returning call4092 (depth = 5)
  *var_nextTok = call4092;
  if (call4092 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4095 = alloc_Boolean(0);
// compiled identifier node returning bool4095 (depth = 6)
  int op_slot_right_4094 = gc_frame_newslot(bool4095);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4094 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4095;
  partcv[0] = 1;
  Object opresult4097 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4097 (depth = 5)
  Object if4093 = done;
  if (istrue(opresult4097)) {
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4098 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4099 == NULL) {
    strlit4099 = alloc_String(" {}");
    gc_root(strlit4099);
  }
// compiled string node returning strlit4099 (depth = 6)
  gc_frame_newslot(strlit4099);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_catchTok (depth = 6)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4099;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4100 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4098);
// compiled call node returning call4100 (depth = 5)
    gc_frame_newslot(call4100);
    if4093 = call4100;
  } else {
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4103 == NULL) {
    strlit4103 = alloc_String("rbrace");
    gc_root(strlit4103);
  }
// compiled string node returning strlit4103 (depth = 7)
  int op_slot_right_4102 = gc_frame_newslot(strlit4103);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4105 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4106 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4105);
// compiled call node returning call4106 (depth = 8)
// compiled member node returning call4106 (depth = 7)
  int op_slot_left_4102 = gc_frame_newslot(call4106);
  params[0] = strlit4103;
  partcv[0] = 1;
  Object opresult4107 = callmethod(call4106, "==", 1, partcv, params);
// compiled op node returning opresult4107 (depth = 6)
  Object if4101 = done;
  if (istrue(opresult4107)) {
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4108 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4109 == NULL) {
    strlit4109 = alloc_String(" {");
    gc_root(strlit4109);
  }
// compiled string node returning strlit4109 (depth = 7)
  gc_frame_newslot(strlit4109);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4109;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4110 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4108);
// compiled call node returning call4110 (depth = 6)
    gc_frame_newslot(call4110);
    if4101 = call4110;
  } else {
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4113 == NULL) {
    strlit4113 = alloc_String("rparen");
    gc_root(strlit4113);
  }
// compiled string node returning strlit4113 (depth = 8)
  int op_slot_right_4112 = gc_frame_newslot(strlit4113);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4116 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4115);
// compiled call node returning call4116 (depth = 9)
// compiled member node returning call4116 (depth = 8)
  int op_slot_left_4112 = gc_frame_newslot(call4116);
  params[0] = strlit4113;
  partcv[0] = 1;
  Object opresult4117 = callmethod(call4116, "==", 1, partcv, params);
// compiled op node returning opresult4117 (depth = 7)
  Object if4111 = done;
  if (istrue(opresult4117)) {
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4119 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4119 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4121 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4121 (depth = 8)
  Object if4118 = done;
  if (istrue(opresult4121)) {
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4122 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4123 == NULL) {
    strlit4123 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4123);
  }
// compiled string node returning strlit4123 (depth = 9)
  gc_frame_newslot(strlit4123);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool4124 = alloc_Boolean(1);
// compiled identifier node returning bool4124 (depth = 9)
  gc_frame_newslot(bool4124);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4123;
  params[1] = *var_lastToken;
  params[2] = bool4124;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4125 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4122);
// compiled call node returning call4125 (depth = 8)
    gc_frame_newslot(call4125);
    if4118 = call4125;
  } else {
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4126 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4127 == NULL) {
    strlit4127 = alloc_String("(");
    gc_root(strlit4127);
  }
// compiled string node returning strlit4127 (depth = 9)
  gc_frame_newslot(strlit4127);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 9)
  Object bool4128 = alloc_Boolean(1);
// compiled identifier node returning bool4128 (depth = 9)
  gc_frame_newslot(bool4128);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4127;
  params[1] = *var_lastToken;
  params[2] = bool4128;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4129 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4126);
// compiled call node returning call4129 (depth = 8)
    gc_frame_newslot(call4129);
    if4118 = call4129;
  }
// compiled if node returning if4118 (depth = 7)
    gc_frame_newslot(if4118);
    if4111 = if4118;
  } else {
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4132 == NULL) {
    strlit4132 = alloc_String("identifier");
    gc_root(strlit4132);
  }
// compiled string node returning strlit4132 (depth = 9)
  int op_slot_right_4131 = gc_frame_newslot(strlit4132);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4135 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4134);
// compiled call node returning call4135 (depth = 10)
// compiled member node returning call4135 (depth = 9)
  int op_slot_left_4131 = gc_frame_newslot(call4135);
  params[0] = strlit4132;
  partcv[0] = 1;
  Object opresult4136 = callmethod(call4135, "==", 1, partcv, params);
// compiled op node returning opresult4136 (depth = 8)
  Object if4130 = done;
  if (istrue(opresult4136)) {
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4137 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4138 == NULL) {
    strlit4138 = alloc_String(" {");
    gc_root(strlit4138);
  }
// compiled string node returning strlit4138 (depth = 9)
  gc_frame_newslot(strlit4138);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  gc_frame_newslot(*var_catchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4138;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4139 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4137);
// compiled call node returning call4139 (depth = 8)
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4140 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4141 == NULL) {
    strlit4141 = alloc_String("} ");
    gc_root(strlit4141);
  }
// compiled string node returning strlit4141 (depth = 9)
  gc_frame_newslot(strlit4141);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  gc_frame_newslot(*var_nextTok);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4141;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4142 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4140);
// compiled call node returning call4142 (depth = 8)
    gc_frame_newslot(call4142);
    if4130 = call4142;
  } else {
  }
// compiled if node returning if4130 (depth = 7)
    gc_frame_newslot(if4130);
    if4111 = if4130;
  }
// compiled if node returning if4111 (depth = 6)
    gc_frame_newslot(if4111);
    if4101 = if4111;
  }
// compiled if node returning if4101 (depth = 5)
    gc_frame_newslot(if4101);
    if4093 = if4101;
  }
// compiled if node returning if4093 (depth = 4)
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4143 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4144 == NULL) {
    strlit4144 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4144);
  }
// compiled string node returning strlit4144 (depth = 5)
  gc_frame_newslot(strlit4144);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_catchTok (depth = 7)
  partcv[0] = 0;
  Object call4146 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4145);
// compiled call node returning call4146 (depth = 6)
// compiled member node returning call4146 (depth = 5)
  gc_frame_newslot(call4146);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4148 = alloc_Float64(1);
// compiled num node returning num4148 (depth = 6)
  int op_slot_right_4147 = gc_frame_newslot(num4148);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4151 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call4152 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4151);
// compiled call node returning call4152 (depth = 8)
// compiled member node returning call4152 (depth = 7)
  int op_slot_right_4150 = gc_frame_newslot(call4152);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_catchTok (depth = 9)
  partcv[0] = 0;
  Object call4155 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4154);
// compiled call node returning call4155 (depth = 8)
// compiled member node returning call4155 (depth = 7)
  int op_slot_left_4150 = gc_frame_newslot(call4155);
  params[0] = call4152;
  partcv[0] = 1;
  Object sum4156 = callmethod(call4155, "+", 1, partcv, params);
// compiled op node returning sum4156 (depth = 6)
  int op_slot_left_4147 = gc_frame_newslot(sum4156);
  params[0] = num4148;
  partcv[0] = 1;
  Object sum4157 = callmethod(sum4156, "+", 1, partcv, params);
// compiled op node returning sum4157 (depth = 5)
  gc_frame_newslot(sum4157);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4144;
  params[1] = call4146;
  params[2] = sum4157;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4158 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4143);
// compiled call node returning call4158 (depth = 4)
    gc_frame_newslot(call4158);
    if4034 = call4158;
  } else {
  }
// compiled if node returning if4034 (depth = 3)
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4159 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4160 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4159);
// compiled call node returning call4160 (depth = 4)
// compiled member node returning call4160 (depth = 3)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4162 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4163 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block4164 = alloc_Block(NULL, NULL, "parser", 1275);
  gc_frame_newslot(block4164);
// method _apply
  block_savedest(block4164);
  Object closure4165 = createclosure(2, "_apply");
  setclosureframe(closure4165, stackframe);
  addtoclosure(closure4165, var_blocksOK);
  addtoclosure(closure4165, selfslot);
  struct UserObject *uo4165 = (struct UserObject*)block4164;
  uo4165->data[0] = (Object)closure4165;
  Method *meth_meth_parser__apply4165 = addmethod2pos(block4164, "_apply", &meth_parser__apply4165, 0);
  int argcv_meth_parser__apply4165[] = {0};
  meth_meth_parser__apply4165->type = alloc_MethodType(1, argcv_meth_parser__apply4165);
  meth_meth_parser__apply4165->definitionModule = modulename;
  meth_meth_parser__apply4165->definitionLine = 1275;
// compiled block node returning block4164 (depth = 7)
  gc_frame_newslot(block4164);
// call case 4: self request
  params[0] = block4164;
  partcv[0] = 1;
  Object call4169 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4163);
// compiled call node returning call4169 (depth = 6)
  partcv[0] = 0;
  Object call4170 = callmethod(call4169, "not",
    1, partcv, params);
  gc_frame_end(callframe4162);
// compiled call node returning call4170 (depth = 5)
// compiled member node returning call4170 (depth = 4)
  Object if4161 = done;
  if (istrue(call4170)) {
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4171 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4173 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4172);
// compiled call node returning call4173 (depth = 8)
// compiled member node returning call4173 (depth = 7)
  partcv[0] = 0;
  Object call4174 = callmethod(call4173, "new",
    1, partcv, params);
  gc_frame_end(callframe4171);
// compiled call node returning call4174 (depth = 6)
// compiled member node returning call4174 (depth = 5)
  *var_suggestion = call4174;
  if (call4174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4175 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4176 == NULL) {
    strlit4176 = alloc_String("rparen");
    gc_root(strlit4176);
  }
// compiled string node returning strlit4176 (depth = 6)
  gc_frame_newslot(strlit4176);
// call case 4: self request
  params[0] = strlit4176;
  partcv[0] = 1;
  Object call4177 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4175);
// compiled call node returning call4177 (depth = 5)
  *var_nextTok = call4177;
  if (call4177 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_4179 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_4179 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4181 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4181 (depth = 5)
  Object if4178 = done;
  if (istrue(opresult4181)) {
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4182 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4183 == NULL) {
    strlit4183 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4183);
  }
// compiled string node returning strlit4183 (depth = 6)
  gc_frame_newslot(strlit4183);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit4183;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4184 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4182);
// compiled call node returning call4184 (depth = 5)
    gc_frame_newslot(call4184);
    if4178 = call4184;
  } else {
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4185 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4186 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4187 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4186);
// compiled call node returning call4187 (depth = 7)
// compiled member node returning call4187 (depth = 6)
  gc_frame_newslot(call4187);
// starting to compile identifier node (depth = 6)
  Object bool4188 = alloc_Boolean(1);
// compiled identifier node returning bool4188 (depth = 6)
  gc_frame_newslot(bool4188);
// starting to compile identifier node (depth = 6)
  Object bool4189 = alloc_Boolean(0);
// compiled identifier node returning bool4189 (depth = 6)
  gc_frame_newslot(bool4189);
// starting to compile string node (depth = 6)
  if (strlit4190 == NULL) {
    strlit4190 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4190);
  }
// compiled string node returning strlit4190 (depth = 6)
  gc_frame_newslot(strlit4190);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call4187;
  params[2] = bool4188;
  params[3] = bool4189;
  params[4] = strlit4190;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4191 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4185);
// compiled call node returning call4191 (depth = 5)
    gc_frame_newslot(call4191);
    if4178 = call4191;
  }
// compiled if node returning if4178 (depth = 4)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4192 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4193 == NULL) {
    strlit4193 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4193);
  }
// compiled string node returning strlit4193 (depth = 5)
  gc_frame_newslot(strlit4193);
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4194 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4195 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4194);
// compiled call node returning call4195 (depth = 6)
// compiled member node returning call4195 (depth = 5)
  gc_frame_newslot(call4195);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4197 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4196);
// compiled call node returning call4197 (depth = 6)
// compiled member node returning call4197 (depth = 5)
  gc_frame_newslot(call4197);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4193;
  params[1] = call4195;
  params[2] = call4197;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4198 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4192);
// compiled call node returning call4198 (depth = 4)
    gc_frame_newslot(call4198);
    if4161 = call4198;
  } else {
  }
// compiled if node returning if4161 (depth = 3)
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4201 == NULL) {
    strlit4201 = alloc_String("rparen");
    gc_root(strlit4201);
  }
// compiled string node returning strlit4201 (depth = 5)
  int op_slot_right_4200 = gc_frame_newslot(strlit4201);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4203 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4204 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4203);
// compiled call node returning call4204 (depth = 6)
// compiled member node returning call4204 (depth = 5)
  int op_slot_left_4200 = gc_frame_newslot(call4204);
  params[0] = strlit4201;
  partcv[0] = 1;
  Object opresult4205 = callmethod(call4204, "!=", 1, partcv, params);
// compiled op node returning opresult4205 (depth = 4)
  Object if4199 = done;
  if (istrue(opresult4205)) {
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4206 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4207 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4206);
// compiled call node returning call4207 (depth = 5)
// compiled member node returning call4207 (depth = 4)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4208 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4209 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call4210 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4209);
// compiled call node returning call4210 (depth = 8)
// compiled member node returning call4210 (depth = 7)
  partcv[0] = 0;
  Object call4211 = callmethod(call4210, "new",
    1, partcv, params);
  gc_frame_end(callframe4208);
// compiled call node returning call4211 (depth = 6)
// compiled member node returning call4211 (depth = 5)
  *var_suggestion = call4211;
  if (call4211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4212 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4213 == NULL) {
    strlit4213 = alloc_String(")");
    gc_root(strlit4213);
  }
// compiled string node returning strlit4213 (depth = 5)
  gc_frame_newslot(strlit4213);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4213;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4214 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4212);
// compiled call node returning call4214 (depth = 4)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4215 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4216 == NULL) {
    strlit4216 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4216);
  }
// compiled string node returning strlit4216 (depth = 5)
  gc_frame_newslot(strlit4216);
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4217 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4218 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4217);
// compiled call node returning call4218 (depth = 6)
// compiled member node returning call4218 (depth = 5)
  gc_frame_newslot(call4218);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4221 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4220);
// compiled call node returning call4221 (depth = 7)
// compiled member node returning call4221 (depth = 6)
  int op_slot_right_4219 = gc_frame_newslot(call4221);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call4224 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4223);
// compiled call node returning call4224 (depth = 7)
// compiled member node returning call4224 (depth = 6)
  int op_slot_left_4219 = gc_frame_newslot(call4224);
  params[0] = call4221;
  partcv[0] = 1;
  Object sum4225 = callmethod(call4224, "+", 1, partcv, params);
// compiled op node returning sum4225 (depth = 5)
  gc_frame_newslot(sum4225);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit4216;
  params[1] = call4218;
  params[2] = sum4225;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4226 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4215);
// compiled call node returning call4226 (depth = 4)
    gc_frame_newslot(call4226);
    if4199 = call4226;
  } else {
  }
// compiled if node returning if4199 (depth = 3)
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4227 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4228 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4227);
// compiled call node returning call4228 (depth = 4)
// compiled member node returning call4228 (depth = 3)
    gc_frame_newslot(call4228);
    if4028 = call4228;
  }
// compiled if node returning if4028 (depth = 2)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4229 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4230 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4229);
// compiled call node returning call4230 (depth = 4)
// compiled member node returning call4230 (depth = 3)
  *var_mainblock = call4230;
  if (call4230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4231 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4231 (depth = 3)
  *var_cases = array4231;
  if (array4231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4232 = alloc_Boolean(0);
// compiled identifier node returning bool4232 (depth = 3)
  *var_finally = bool4232;
  if (bool4232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4233 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4234 = alloc_Block(NULL, NULL, "parser", 1298);
  gc_frame_newslot(block4234);
// method _apply
  block_savedest(block4234);
  Object closure4235 = createclosure(2, "_apply");
  setclosureframe(closure4235, stackframe);
  addtoclosure(closure4235, var_sym);
  addtoclosure(closure4235, selfslot);
  struct UserObject *uo4235 = (struct UserObject*)block4234;
  uo4235->data[0] = (Object)closure4235;
  Method *meth_meth_parser__apply4235 = addmethod2pos(block4234, "_apply", &meth_parser__apply4235, 0);
  int argcv_meth_parser__apply4235[] = {0};
  meth_meth_parser__apply4235->type = alloc_MethodType(1, argcv_meth_parser__apply4235);
  meth_meth_parser__apply4235->definitionModule = modulename;
  meth_meth_parser__apply4235->definitionLine = 1295;
// compiled block node returning block4234 (depth = 3)
  gc_frame_newslot(block4234);
// starting to compile block node (depth = 3)
  Object block4249 = alloc_Block(NULL, NULL, "parser", 1298);
  gc_frame_newslot(block4249);
// method _apply
  block_savedest(block4249);
  Object closure4250 = createclosure(8, "_apply");
  setclosureframe(closure4250, stackframe);
  addtoclosure(closure4250, var_blocksOK);
  addtoclosure(closure4250, var_errormessages);
  addtoclosure(closure4250, var_sym);
  addtoclosure(closure4250, var_lastToken);
  addtoclosure(closure4250, var_tokens);
  addtoclosure(closure4250, var_values);
  addtoclosure(closure4250, var_cases);
  addtoclosure(closure4250, selfslot);
  struct UserObject *uo4250 = (struct UserObject*)block4249;
  uo4250->data[0] = (Object)closure4250;
  Method *meth_meth_parser__apply4250 = addmethod2pos(block4249, "_apply", &meth_parser__apply4250, 0);
  int argcv_meth_parser__apply4250[] = {0};
  meth_meth_parser__apply4250->type = alloc_MethodType(1, argcv_meth_parser__apply4250);
  meth_meth_parser__apply4250->definitionModule = modulename;
  meth_meth_parser__apply4250->definitionLine = 1298;
// compiled block node returning block4249 (depth = 3)
  gc_frame_newslot(block4249);
// call case 5: prelude request
  params[0] = block4234;
  params[1] = block4249;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4396 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4233);
// compiled call node returning call4396 (depth = 2)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4400 == NULL) {
    strlit4400 = alloc_String("finally");
    gc_root(strlit4400);
  }
// compiled string node returning strlit4400 (depth = 5)
  int op_slot_right_4399 = gc_frame_newslot(strlit4400);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4402 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call4403 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4402);
// compiled call node returning call4403 (depth = 6)
// compiled member node returning call4403 (depth = 5)
  int op_slot_left_4399 = gc_frame_newslot(call4403);
  params[0] = strlit4400;
  partcv[0] = 1;
  Object opresult4404 = callmethod(call4403, "==", 1, partcv, params);
// compiled op node returning opresult4404 (depth = 4)
  int op_slot_right_4398 = gc_frame_newslot(opresult4404);
// starting to compile call node (depth = 4)
  int callframe4406 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4407 == NULL) {
    strlit4407 = alloc_String("identifier");
    gc_root(strlit4407);
  }
// compiled string node returning strlit4407 (depth = 5)
  gc_frame_newslot(strlit4407);
// call case 4: self request
  params[0] = strlit4407;
  partcv[0] = 1;
  Object call4408 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4406);
// compiled call node returning call4408 (depth = 4)
  int op_slot_left_4398 = gc_frame_newslot(call4408);
  params[0] = opresult4404;
  partcv[0] = 1;
  Object opresult4409 = callmethod(call4408, "&&", 1, partcv, params);
// compiled op node returning opresult4409 (depth = 3)
  Object if4397 = done;
  if (istrue(opresult4409)) {
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4410 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4411 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4410);
// compiled call node returning call4411 (depth = 4)
// compiled member node returning call4411 (depth = 3)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4413 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4414 == NULL) {
    strlit4414 = alloc_String("lbrace");
    gc_root(strlit4414);
  }
// compiled string node returning strlit4414 (depth = 5)
  gc_frame_newslot(strlit4414);
// call case 4: self request
  params[0] = strlit4414;
  partcv[0] = 1;
  Object call4415 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4413);
// compiled call node returning call4415 (depth = 4)
  Object if4412 = done;
  if (istrue(call4415)) {
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4416 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4417 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4416);
// compiled call node returning call4417 (depth = 5)
// compiled member node returning call4417 (depth = 4)
    gc_frame_newslot(call4417);
    if4412 = call4417;
  } else {
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4419 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4420 == NULL) {
    strlit4420 = alloc_String("lparen");
    gc_root(strlit4420);
  }
// compiled string node returning strlit4420 (depth = 6)
  gc_frame_newslot(strlit4420);
// call case 4: self request
  params[0] = strlit4420;
  partcv[0] = 1;
  Object call4421 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4419);
// compiled call node returning call4421 (depth = 5)
  Object if4418 = done;
  if (istrue(call4421)) {
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4423 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4422);
// compiled call node returning call4423 (depth = 6)
// compiled member node returning call4423 (depth = 5)
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4425 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe4426 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block4427 = alloc_Block(NULL, NULL, "parser", 1353);
  gc_frame_newslot(block4427);
// method _apply
  block_savedest(block4427);
  Object closure4428 = createclosure(2, "_apply");
  setclosureframe(closure4428, stackframe);
  addtoclosure(closure4428, var_blocksOK);
  addtoclosure(closure4428, selfslot);
  struct UserObject *uo4428 = (struct UserObject*)block4427;
  uo4428->data[0] = (Object)closure4428;
  Method *meth_meth_parser__apply4428 = addmethod2pos(block4427, "_apply", &meth_parser__apply4428, 0);
  int argcv_meth_parser__apply4428[] = {0};
  meth_meth_parser__apply4428->type = alloc_MethodType(1, argcv_meth_parser__apply4428);
  meth_meth_parser__apply4428->definitionModule = modulename;
  meth_meth_parser__apply4428->definitionLine = 1353;
// compiled block node returning block4427 (depth = 9)
  gc_frame_newslot(block4427);
// call case 4: self request
  params[0] = block4427;
  partcv[0] = 1;
  Object call4432 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4426);
// compiled call node returning call4432 (depth = 8)
  partcv[0] = 0;
  Object call4433 = callmethod(call4432, "not",
    1, partcv, params);
  gc_frame_end(callframe4425);
// compiled call node returning call4433 (depth = 7)
// compiled member node returning call4433 (depth = 6)
  Object if4424 = done;
  if (istrue(call4433)) {
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4434 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4435 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4436 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4435);
// compiled call node returning call4436 (depth = 10)
// compiled member node returning call4436 (depth = 9)
  partcv[0] = 0;
  Object call4437 = callmethod(call4436, "new",
    1, partcv, params);
  gc_frame_end(callframe4434);
// compiled call node returning call4437 (depth = 8)
// compiled member node returning call4437 (depth = 7)
  *var_suggestion = call4437;
  if (call4437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4438 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4439 == NULL) {
    strlit4439 = alloc_String("rparen");
    gc_root(strlit4439);
  }
// compiled string node returning strlit4439 (depth = 8)
  gc_frame_newslot(strlit4439);
// call case 4: self request
  params[0] = strlit4439;
  partcv[0] = 1;
  Object call4440 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4438);
// compiled call node returning call4440 (depth = 7)
  *var_nextTok = call4440;
  if (call4440 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4442 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4442 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4444 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4444 (depth = 7)
  Object if4441 = done;
  if (istrue(opresult4444)) {
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4445 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4446 == NULL) {
    strlit4446 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4446);
  }
// compiled string node returning strlit4446 (depth = 8)
  gc_frame_newslot(strlit4446);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4446;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4447 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4445);
// compiled call node returning call4447 (depth = 7)
    gc_frame_newslot(call4447);
    if4441 = call4447;
  } else {
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4448 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4450 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4449);
// compiled call node returning call4450 (depth = 9)
// compiled member node returning call4450 (depth = 8)
  gc_frame_newslot(call4450);
// starting to compile identifier node (depth = 8)
  Object bool4451 = alloc_Boolean(1);
// compiled identifier node returning bool4451 (depth = 8)
  gc_frame_newslot(bool4451);
// starting to compile identifier node (depth = 8)
  Object bool4452 = alloc_Boolean(0);
// compiled identifier node returning bool4452 (depth = 8)
  gc_frame_newslot(bool4452);
// starting to compile string node (depth = 8)
  if (strlit4453 == NULL) {
    strlit4453 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4453);
  }
// compiled string node returning strlit4453 (depth = 8)
  gc_frame_newslot(strlit4453);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call4450;
  params[2] = bool4451;
  params[3] = bool4452;
  params[4] = strlit4453;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4454 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4448);
// compiled call node returning call4454 (depth = 7)
    gc_frame_newslot(call4454);
    if4441 = call4454;
  }
// compiled if node returning if4441 (depth = 6)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4455 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4456 == NULL) {
    strlit4456 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4456);
  }
// compiled string node returning strlit4456 (depth = 7)
  gc_frame_newslot(strlit4456);
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4457 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4458 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4457);
// compiled call node returning call4458 (depth = 8)
// compiled member node returning call4458 (depth = 7)
  gc_frame_newslot(call4458);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4460 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4459);
// compiled call node returning call4460 (depth = 8)
// compiled member node returning call4460 (depth = 7)
  gc_frame_newslot(call4460);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4456;
  params[1] = call4458;
  params[2] = call4460;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4461 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4455);
// compiled call node returning call4461 (depth = 6)
    gc_frame_newslot(call4461);
    if4424 = call4461;
  } else {
  }
// compiled if node returning if4424 (depth = 5)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4464 == NULL) {
    strlit4464 = alloc_String("rparen");
    gc_root(strlit4464);
  }
// compiled string node returning strlit4464 (depth = 7)
  int op_slot_right_4463 = gc_frame_newslot(strlit4464);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4466 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4467 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4466);
// compiled call node returning call4467 (depth = 8)
// compiled member node returning call4467 (depth = 7)
  int op_slot_left_4463 = gc_frame_newslot(call4467);
  params[0] = strlit4464;
  partcv[0] = 1;
  Object opresult4468 = callmethod(call4467, "!=", 1, partcv, params);
// compiled op node returning opresult4468 (depth = 6)
  Object if4462 = done;
  if (istrue(opresult4468)) {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4470 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4469);
// compiled call node returning call4470 (depth = 7)
// compiled member node returning call4470 (depth = 6)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4471 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4472 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4473 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4472);
// compiled call node returning call4473 (depth = 10)
// compiled member node returning call4473 (depth = 9)
  partcv[0] = 0;
  Object call4474 = callmethod(call4473, "new",
    1, partcv, params);
  gc_frame_end(callframe4471);
// compiled call node returning call4474 (depth = 8)
// compiled member node returning call4474 (depth = 7)
  *var_suggestion = call4474;
  if (call4474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4475 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4476 == NULL) {
    strlit4476 = alloc_String(")");
    gc_root(strlit4476);
  }
// compiled string node returning strlit4476 (depth = 7)
  gc_frame_newslot(strlit4476);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4476;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4477 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4475);
// compiled call node returning call4477 (depth = 6)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4478 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4479 == NULL) {
    strlit4479 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4479);
  }
// compiled string node returning strlit4479 (depth = 7)
  gc_frame_newslot(strlit4479);
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call4481 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4480);
// compiled call node returning call4481 (depth = 8)
// compiled member node returning call4481 (depth = 7)
  gc_frame_newslot(call4481);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4483 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4484 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4483);
// compiled call node returning call4484 (depth = 9)
// compiled member node returning call4484 (depth = 8)
  int op_slot_right_4482 = gc_frame_newslot(call4484);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4487 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4486);
// compiled call node returning call4487 (depth = 9)
// compiled member node returning call4487 (depth = 8)
  int op_slot_left_4482 = gc_frame_newslot(call4487);
  params[0] = call4484;
  partcv[0] = 1;
  Object sum4488 = callmethod(call4487, "+", 1, partcv, params);
// compiled op node returning sum4488 (depth = 7)
  gc_frame_newslot(sum4488);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4479;
  params[1] = call4481;
  params[2] = sum4488;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4489 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4478);
// compiled call node returning call4489 (depth = 6)
    gc_frame_newslot(call4489);
    if4462 = call4489;
  } else {
  }
// compiled if node returning if4462 (depth = 5)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4490 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4491 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4490);
// compiled call node returning call4491 (depth = 6)
// compiled member node returning call4491 (depth = 5)
    gc_frame_newslot(call4491);
    if4418 = call4491;
  } else {
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array4492 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4492 (depth = 6)
  *var_suggestions = array4492;
  if (array4492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4493 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4494 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4493);
// compiled call node returning call4494 (depth = 6)
  *var_nextTok = call4494;
  if (call4494 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 1375
  setline(1375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4495 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call4497 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4496);
// compiled call node returning call4497 (depth = 9)
// compiled member node returning call4497 (depth = 8)
  partcv[0] = 0;
  Object call4498 = callmethod(call4497, "new",
    1, partcv, params);
  gc_frame_end(callframe4495);
// compiled call node returning call4498 (depth = 7)
// compiled member node returning call4498 (depth = 6)
  *var_suggestion = call4498;
  if (call4498 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool4501 = alloc_Boolean(0);
// compiled identifier node returning bool4501 (depth = 7)
  int op_slot_right_4500 = gc_frame_newslot(bool4501);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4500 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4501;
  partcv[0] = 1;
  Object opresult4503 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4503 (depth = 6)
  Object if4499 = done;
  if (istrue(opresult4503)) {
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4504 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4505 == NULL) {
    strlit4505 = alloc_String(" }");
    gc_root(strlit4505);
  }
// compiled string node returning strlit4505 (depth = 7)
  gc_frame_newslot(strlit4505);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call4507 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe4506);
// compiled call node returning call4507 (depth = 8)
// compiled member node returning call4507 (depth = 7)
  gc_frame_newslot(call4507);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4505;
  params[1] = call4507;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4508 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4504);
// compiled call node returning call4508 (depth = 6)
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4509 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4510 == NULL) {
    strlit4510 = alloc_String(" {");
    gc_root(strlit4510);
  }
// compiled string node returning strlit4510 (depth = 7)
  gc_frame_newslot(strlit4510);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4510;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4511 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4509);
// compiled call node returning call4511 (depth = 6)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4512 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4513 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4512);
// compiled call node returning call4513 (depth = 6)
    gc_frame_newslot(call4513);
    if4499 = call4513;
  } else {
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_4515 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4515 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4517 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4517 (depth = 7)
  Object if4514 = done;
  if (istrue(opresult4517)) {
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4518 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4519 == NULL) {
    strlit4519 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4519);
  }
// compiled string node returning strlit4519 (depth = 8)
  gc_frame_newslot(strlit4519);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4519;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4520 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4518);
// compiled call node returning call4520 (depth = 7)
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4521 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4522 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4521);
// compiled call node returning call4522 (depth = 7)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4523 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4525 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4524);
// compiled call node returning call4525 (depth = 11)
// compiled member node returning call4525 (depth = 10)
  partcv[0] = 0;
  Object call4526 = callmethod(call4525, "new",
    1, partcv, params);
  gc_frame_end(callframe4523);
// compiled call node returning call4526 (depth = 9)
// compiled member node returning call4526 (depth = 8)
  *var_suggestion = call4526;
  if (call4526 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4528 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4529 == NULL) {
    strlit4529 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4529);
  }
// compiled string node returning strlit4529 (depth = 8)
  gc_frame_newslot(strlit4529);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4529;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4530 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4528);
// compiled call node returning call4530 (depth = 7)
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4531 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4532 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4531);
// compiled call node returning call4532 (depth = 7)
    gc_frame_newslot(call4532);
    if4514 = call4532;
  } else {
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4533 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4534 == NULL) {
    strlit4534 = alloc_String(" }");
    gc_root(strlit4534);
  }
// compiled string node returning strlit4534 (depth = 8)
  gc_frame_newslot(strlit4534);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call4536 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4535);
// compiled call node returning call4536 (depth = 9)
// compiled member node returning call4536 (depth = 8)
  gc_frame_newslot(call4536);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4534;
  params[1] = call4536;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4537 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4533);
// compiled call node returning call4537 (depth = 7)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4538 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4539 == NULL) {
    strlit4539 = alloc_String(" {");
    gc_root(strlit4539);
  }
// compiled string node returning strlit4539 (depth = 8)
  gc_frame_newslot(strlit4539);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4539;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4540 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4538);
// compiled call node returning call4540 (depth = 7)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4541 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4542 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4541);
// compiled call node returning call4542 (depth = 7)
    gc_frame_newslot(call4542);
    if4514 = call4542;
  }
// compiled if node returning if4514 (depth = 6)
    gc_frame_newslot(if4514);
    if4499 = if4514;
  }
// compiled if node returning if4499 (depth = 5)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4543 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4544 == NULL) {
    strlit4544 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4544);
  }
// compiled string node returning strlit4544 (depth = 6)
  gc_frame_newslot(strlit4544);
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4545 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4546 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4545);
// compiled call node returning call4546 (depth = 7)
// compiled member node returning call4546 (depth = 6)
  gc_frame_newslot(call4546);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4548 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4547);
// compiled call node returning call4548 (depth = 7)
// compiled member node returning call4548 (depth = 6)
  gc_frame_newslot(call4548);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit4544;
  params[1] = call4546;
  params[2] = call4548;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4549 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4543);
// compiled call node returning call4549 (depth = 5)
    gc_frame_newslot(call4549);
    if4418 = call4549;
  }
// compiled if node returning if4418 (depth = 4)
    gc_frame_newslot(if4418);
    if4412 = if4418;
  }
// compiled if node returning if4412 (depth = 3)
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call4551 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4550);
// compiled call node returning call4551 (depth = 5)
// compiled member node returning call4551 (depth = 4)
  *var_finally = call4551;
  if (call4551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if4397 = done;
  } else {
  }
// compiled if node returning if4397 (depth = 2)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4553 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4554 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_mainblock (depth = 4)
  gc_frame_newslot(*var_mainblock);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_finally (depth = 4)
  gc_frame_newslot(*var_finally);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4555 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4556 = callmethod(*var_ast, "catchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4555);
// compiled call node returning call4556 (depth = 5)
// compiled member node returning call4556 (depth = 4)
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4557 = callmethod(call4556, "new",
    1, partcv, params);
  gc_frame_end(callframe4554);
// compiled call node returning call4557 (depth = 3)
  gc_frame_newslot(call4557);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4557;
  partcv[0] = 1;
  Object call4558 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4553);
// compiled call node returning call4558 (depth = 2)
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4592(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4596 == NULL) {
    strlit4596 = alloc_String("case");
    gc_root(strlit4596);
  }
// compiled string node returning strlit4596 (depth = 9)
  int op_slot_right_4595 = gc_frame_newslot(strlit4596);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4599 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4598);
// compiled call node returning call4599 (depth = 10)
// compiled member node returning call4599 (depth = 9)
  int op_slot_left_4595 = gc_frame_newslot(call4599);
  params[0] = strlit4596;
  partcv[0] = 1;
  Object opresult4600 = callmethod(call4599, "==", 1, partcv, params);
// compiled op node returning opresult4600 (depth = 8)
  int op_slot_right_4594 = gc_frame_newslot(opresult4600);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4603 == NULL) {
    strlit4603 = alloc_String("identifier");
    gc_root(strlit4603);
  }
// compiled string node returning strlit4603 (depth = 9)
  int op_slot_right_4602 = gc_frame_newslot(strlit4603);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4606 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4605);
// compiled call node returning call4606 (depth = 10)
// compiled member node returning call4606 (depth = 9)
  int op_slot_left_4602 = gc_frame_newslot(call4606);
  params[0] = strlit4603;
  partcv[0] = 1;
  Object opresult4607 = callmethod(call4606, "==", 1, partcv, params);
// compiled op node returning opresult4607 (depth = 8)
  int op_slot_left_4594 = gc_frame_newslot(opresult4607);
  params[0] = opresult4600;
  partcv[0] = 1;
  Object opresult4608 = callmethod(opresult4607, "&&", 1, partcv, params);
// compiled op node returning opresult4608 (depth = 7)
  int op_slot_right_4593 = gc_frame_newslot(opresult4608);
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_matchTok (depth = 11)
  partcv[0] = 0;
  Object call4613 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4612);
// compiled call node returning call4613 (depth = 10)
// compiled member node returning call4613 (depth = 9)
  int op_slot_right_4611 = gc_frame_newslot(call4613);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4615 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4616 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4615);
// compiled call node returning call4616 (depth = 10)
// compiled member node returning call4616 (depth = 9)
  int op_slot_left_4611 = gc_frame_newslot(call4616);
  params[0] = call4613;
  partcv[0] = 1;
  Object opresult4617 = callmethod(call4616, "==", 1, partcv, params);
// compiled op node returning opresult4617 (depth = 8)
  int op_slot_right_4610 = gc_frame_newslot(opresult4617);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4620 == NULL) {
    strlit4620 = alloc_String("rparen");
    gc_root(strlit4620);
  }
// compiled string node returning strlit4620 (depth = 9)
  int op_slot_right_4619 = gc_frame_newslot(strlit4620);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call4623 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4622);
// compiled call node returning call4623 (depth = 10)
// compiled member node returning call4623 (depth = 9)
  int op_slot_left_4619 = gc_frame_newslot(call4623);
  params[0] = strlit4620;
  partcv[0] = 1;
  Object opresult4624 = callmethod(call4623, "==", 1, partcv, params);
// compiled op node returning opresult4624 (depth = 8)
  int op_slot_left_4610 = gc_frame_newslot(opresult4624);
  params[0] = opresult4617;
  partcv[0] = 1;
  Object opresult4625 = callmethod(opresult4624, "&&", 1, partcv, params);
// compiled op node returning opresult4625 (depth = 7)
  int op_slot_left_4593 = gc_frame_newslot(opresult4625);
  params[0] = opresult4608;
  partcv[0] = 1;
  Object opresult4626 = callmethod(opresult4625, "||", 1, partcv, params);
// compiled op node returning opresult4626 (depth = 6)
  gc_frame_end(frame);
  return opresult4626;
}
Object meth_parser__apply4688(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe4689 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_blocksOK (depth = 8)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4690 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4689);
// compiled call node returning call4690 (depth = 7)
  gc_frame_end(frame);
  return call4690;
}
Object meth_parser__apply4758(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4761 == NULL) {
    strlit4761 = alloc_String("case");
    gc_root(strlit4761);
  }
// compiled string node returning strlit4761 (depth = 6)
  int op_slot_right_4760 = gc_frame_newslot(strlit4761);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4764 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4763);
// compiled call node returning call4764 (depth = 7)
// compiled member node returning call4764 (depth = 6)
  int op_slot_left_4760 = gc_frame_newslot(call4764);
  params[0] = strlit4761;
  partcv[0] = 1;
  Object opresult4765 = callmethod(call4764, "==", 1, partcv, params);
// compiled op node returning opresult4765 (depth = 5)
  int op_slot_right_4759 = gc_frame_newslot(opresult4765);
// starting to compile call node (depth = 5)
  int callframe4767 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4768 == NULL) {
    strlit4768 = alloc_String("identifier");
    gc_root(strlit4768);
  }
// compiled string node returning strlit4768 (depth = 6)
  gc_frame_newslot(strlit4768);
// call case 4: self request
  params[0] = strlit4768;
  partcv[0] = 1;
  Object call4769 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4767);
// compiled call node returning call4769 (depth = 5)
  int op_slot_left_4759 = gc_frame_newslot(call4769);
  params[0] = opresult4765;
  partcv[0] = 1;
  Object opresult4770 = callmethod(call4769, "&&", 1, partcv, params);
// compiled op node returning opresult4770 (depth = 4)
  gc_frame_end(frame);
  return opresult4770;
}
Object meth_parser__apply4792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe4793 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call4794 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4793);
// compiled call node returning call4794 (depth = 11)
  gc_frame_end(frame);
  return call4794;
}
Object meth_parser__apply4773(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_cases = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4775 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4774);
// compiled call node returning call4775 (depth = 5)
// compiled member node returning call4775 (depth = 4)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4777 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4778 == NULL) {
    strlit4778 = alloc_String("lbrace");
    gc_root(strlit4778);
  }
// compiled string node returning strlit4778 (depth = 6)
  gc_frame_newslot(strlit4778);
// call case 4: self request
  params[0] = strlit4778;
  partcv[0] = 1;
  Object call4779 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4777);
// compiled call node returning call4779 (depth = 5)
  Object if4776 = done;
  if (istrue(call4779)) {
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4780 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4781 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4780);
// compiled call node returning call4781 (depth = 6)
// compiled member node returning call4781 (depth = 5)
    gc_frame_newslot(call4781);
    if4776 = call4781;
  } else {
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4783 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4784 == NULL) {
    strlit4784 = alloc_String("lparen");
    gc_root(strlit4784);
  }
// compiled string node returning strlit4784 (depth = 7)
  gc_frame_newslot(strlit4784);
// call case 4: self request
  params[0] = strlit4784;
  partcv[0] = 1;
  Object call4785 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4783);
// compiled call node returning call4785 (depth = 6)
  Object if4782 = done;
  if (istrue(call4785)) {
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4786 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4787 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4786);
// compiled call node returning call4787 (depth = 7)
// compiled member node returning call4787 (depth = 6)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4789 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe4790 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block4791 = alloc_Block(NULL, NULL, "parser", 1455);
  gc_frame_newslot(block4791);
// method _apply
  block_savedest(block4791);
  Object closure4792 = createclosure(2, "_apply");
  setclosureframe(closure4792, stackframe);
  addtoclosure(closure4792, var_blocksOK);
  addtoclosure(closure4792, selfslot);
  struct UserObject *uo4792 = (struct UserObject*)block4791;
  uo4792->data[0] = (Object)closure4792;
  Method *meth_meth_parser__apply4792 = addmethod2pos(block4791, "_apply", &meth_parser__apply4792, 0);
  int argcv_meth_parser__apply4792[] = {0};
  meth_meth_parser__apply4792->type = alloc_MethodType(1, argcv_meth_parser__apply4792);
  meth_meth_parser__apply4792->definitionModule = modulename;
  meth_meth_parser__apply4792->definitionLine = 1455;
// compiled block node returning block4791 (depth = 10)
  gc_frame_newslot(block4791);
// call case 4: self request
  params[0] = block4791;
  partcv[0] = 1;
  Object call4796 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4790);
// compiled call node returning call4796 (depth = 9)
  partcv[0] = 0;
  Object call4797 = callmethod(call4796, "not",
    1, partcv, params);
  gc_frame_end(callframe4789);
// compiled call node returning call4797 (depth = 8)
// compiled member node returning call4797 (depth = 7)
  Object if4788 = done;
  if (istrue(call4797)) {
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4798 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4799 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4800 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4799);
// compiled call node returning call4800 (depth = 11)
// compiled member node returning call4800 (depth = 10)
  partcv[0] = 0;
  Object call4801 = callmethod(call4800, "new",
    1, partcv, params);
  gc_frame_end(callframe4798);
// compiled call node returning call4801 (depth = 9)
// compiled member node returning call4801 (depth = 8)
  *var_suggestion = call4801;
  if (call4801 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4802 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4803 == NULL) {
    strlit4803 = alloc_String("rparen");
    gc_root(strlit4803);
  }
// compiled string node returning strlit4803 (depth = 9)
  gc_frame_newslot(strlit4803);
// call case 4: self request
  params[0] = strlit4803;
  partcv[0] = 1;
  Object call4804 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4802);
// compiled call node returning call4804 (depth = 8)
  *var_nextTok = call4804;
  if (call4804 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4806 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4806 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4808 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4808 (depth = 8)
  Object if4805 = done;
  if (istrue(opresult4808)) {
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4809 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4810 == NULL) {
    strlit4810 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4810);
  }
// compiled string node returning strlit4810 (depth = 9)
  gc_frame_newslot(strlit4810);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4810;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4811 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4809);
// compiled call node returning call4811 (depth = 8)
    gc_frame_newslot(call4811);
    if4805 = call4811;
  } else {
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4812 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4814 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4813);
// compiled call node returning call4814 (depth = 10)
// compiled member node returning call4814 (depth = 9)
  gc_frame_newslot(call4814);
// starting to compile identifier node (depth = 9)
  Object bool4815 = alloc_Boolean(1);
// compiled identifier node returning bool4815 (depth = 9)
  gc_frame_newslot(bool4815);
// starting to compile identifier node (depth = 9)
  Object bool4816 = alloc_Boolean(0);
// compiled identifier node returning bool4816 (depth = 9)
  gc_frame_newslot(bool4816);
// starting to compile string node (depth = 9)
  if (strlit4817 == NULL) {
    strlit4817 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4817);
  }
// compiled string node returning strlit4817 (depth = 9)
  gc_frame_newslot(strlit4817);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call4814;
  params[2] = bool4815;
  params[3] = bool4816;
  params[4] = strlit4817;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4818 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4812);
// compiled call node returning call4818 (depth = 8)
    gc_frame_newslot(call4818);
    if4805 = call4818;
  }
// compiled if node returning if4805 (depth = 7)
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4819 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4820 == NULL) {
    strlit4820 = alloc_String("A match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4820);
  }
// compiled string node returning strlit4820 (depth = 8)
  gc_frame_newslot(strlit4820);
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4821 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4822 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4821);
// compiled call node returning call4822 (depth = 9)
// compiled member node returning call4822 (depth = 8)
  gc_frame_newslot(call4822);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4823 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4824 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4823);
// compiled call node returning call4824 (depth = 9)
// compiled member node returning call4824 (depth = 8)
  gc_frame_newslot(call4824);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4820;
  params[1] = call4822;
  params[2] = call4824;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4825 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4819);
// compiled call node returning call4825 (depth = 7)
    gc_frame_newslot(call4825);
    if4788 = call4825;
  } else {
  }
// compiled if node returning if4788 (depth = 6)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4828 == NULL) {
    strlit4828 = alloc_String("rparen");
    gc_root(strlit4828);
  }
// compiled string node returning strlit4828 (depth = 8)
  int op_slot_right_4827 = gc_frame_newslot(strlit4828);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4831 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4830);
// compiled call node returning call4831 (depth = 9)
// compiled member node returning call4831 (depth = 8)
  int op_slot_left_4827 = gc_frame_newslot(call4831);
  params[0] = strlit4828;
  partcv[0] = 1;
  Object opresult4832 = callmethod(call4831, "!=", 1, partcv, params);
// compiled op node returning opresult4832 (depth = 7)
  Object if4826 = done;
  if (istrue(opresult4832)) {
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4834 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4833);
// compiled call node returning call4834 (depth = 8)
// compiled member node returning call4834 (depth = 7)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4835 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4836 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call4837 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4836);
// compiled call node returning call4837 (depth = 11)
// compiled member node returning call4837 (depth = 10)
  partcv[0] = 0;
  Object call4838 = callmethod(call4837, "new",
    1, partcv, params);
  gc_frame_end(callframe4835);
// compiled call node returning call4838 (depth = 9)
// compiled member node returning call4838 (depth = 8)
  *var_suggestion = call4838;
  if (call4838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4839 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String(")");
    gc_root(strlit4840);
  }
// compiled string node returning strlit4840 (depth = 8)
  gc_frame_newslot(strlit4840);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4840;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4841 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4839);
// compiled call node returning call4841 (depth = 7)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4842 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4843 == NULL) {
    strlit4843 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4843);
  }
// compiled string node returning strlit4843 (depth = 8)
  gc_frame_newslot(strlit4843);
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4844 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call4845 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4844);
// compiled call node returning call4845 (depth = 9)
// compiled member node returning call4845 (depth = 8)
  gc_frame_newslot(call4845);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4847 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4848 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4847);
// compiled call node returning call4848 (depth = 10)
// compiled member node returning call4848 (depth = 9)
  int op_slot_right_4846 = gc_frame_newslot(call4848);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call4851 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4850);
// compiled call node returning call4851 (depth = 10)
// compiled member node returning call4851 (depth = 9)
  int op_slot_left_4846 = gc_frame_newslot(call4851);
  params[0] = call4848;
  partcv[0] = 1;
  Object sum4852 = callmethod(call4851, "+", 1, partcv, params);
// compiled op node returning sum4852 (depth = 8)
  gc_frame_newslot(sum4852);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit4843;
  params[1] = call4845;
  params[2] = sum4852;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4853 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4842);
// compiled call node returning call4853 (depth = 7)
    gc_frame_newslot(call4853);
    if4826 = call4853;
  } else {
  }
// compiled if node returning if4826 (depth = 6)
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4854 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4855 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4854);
// compiled call node returning call4855 (depth = 7)
// compiled member node returning call4855 (depth = 6)
    gc_frame_newslot(call4855);
    if4782 = call4855;
  } else {
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array4856 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4856 (depth = 7)
  *var_suggestions = array4856;
  if (array4856 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4857 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4858 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4857);
// compiled call node returning call4858 (depth = 7)
  *var_nextTok = call4858;
  if (call4858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4859 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4860 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call4861 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4860);
// compiled call node returning call4861 (depth = 10)
// compiled member node returning call4861 (depth = 9)
  partcv[0] = 0;
  Object call4862 = callmethod(call4861, "new",
    1, partcv, params);
  gc_frame_end(callframe4859);
// compiled call node returning call4862 (depth = 8)
// compiled member node returning call4862 (depth = 7)
  *var_suggestion = call4862;
  if (call4862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4865 = alloc_Boolean(0);
// compiled identifier node returning bool4865 (depth = 8)
  int op_slot_right_4864 = gc_frame_newslot(bool4865);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_4864 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4865;
  partcv[0] = 1;
  Object opresult4867 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4867 (depth = 7)
  Object if4863 = done;
  if (istrue(opresult4867)) {
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4868 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4869 == NULL) {
    strlit4869 = alloc_String(" }");
    gc_root(strlit4869);
  }
// compiled string node returning strlit4869 (depth = 8)
  gc_frame_newslot(strlit4869);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4870 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call4871 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4870);
// compiled call node returning call4871 (depth = 9)
// compiled member node returning call4871 (depth = 8)
  gc_frame_newslot(call4871);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4869;
  params[1] = call4871;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4872 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4868);
// compiled call node returning call4872 (depth = 7)
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4873 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4874 == NULL) {
    strlit4874 = alloc_String(" {");
    gc_root(strlit4874);
  }
// compiled string node returning strlit4874 (depth = 8)
  gc_frame_newslot(strlit4874);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit4874;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4875 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4873);
// compiled call node returning call4875 (depth = 7)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe4876 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4877 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4876);
// compiled call node returning call4877 (depth = 7)
    gc_frame_newslot(call4877);
    if4863 = call4877;
  } else {
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_4879 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_4879 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4881 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4881 (depth = 8)
  Object if4878 = done;
  if (istrue(opresult4881)) {
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4882 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4883 == NULL) {
    strlit4883 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4883);
  }
// compiled string node returning strlit4883 (depth = 9)
  gc_frame_newslot(strlit4883);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4883;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4884 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4882);
// compiled call node returning call4884 (depth = 8)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4885 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4886 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4885);
// compiled call node returning call4886 (depth = 8)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4887 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe4888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call4889 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4888);
// compiled call node returning call4889 (depth = 12)
// compiled member node returning call4889 (depth = 11)
  partcv[0] = 0;
  Object call4890 = callmethod(call4889, "new",
    1, partcv, params);
  gc_frame_end(callframe4887);
// compiled call node returning call4890 (depth = 10)
// compiled member node returning call4890 (depth = 9)
  *var_suggestion = call4890;
  if (call4890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4892 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4893 == NULL) {
    strlit4893 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4893);
  }
// compiled string node returning strlit4893 (depth = 9)
  gc_frame_newslot(strlit4893);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4893;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4894 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4892);
// compiled call node returning call4894 (depth = 8)
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4895 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4896 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4895);
// compiled call node returning call4896 (depth = 8)
    gc_frame_newslot(call4896);
    if4878 = call4896;
  } else {
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4897 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4898 == NULL) {
    strlit4898 = alloc_String(" }");
    gc_root(strlit4898);
  }
// compiled string node returning strlit4898 (depth = 9)
  gc_frame_newslot(strlit4898);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4899 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call4900 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4899);
// compiled call node returning call4900 (depth = 10)
// compiled member node returning call4900 (depth = 9)
  gc_frame_newslot(call4900);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4898;
  params[1] = call4900;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4901 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4897);
// compiled call node returning call4901 (depth = 8)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4902 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4903 == NULL) {
    strlit4903 = alloc_String(" {");
    gc_root(strlit4903);
  }
// compiled string node returning strlit4903 (depth = 9)
  gc_frame_newslot(strlit4903);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit4903;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4904 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4902);
// compiled call node returning call4904 (depth = 8)
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe4905 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4906 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4905);
// compiled call node returning call4906 (depth = 8)
    gc_frame_newslot(call4906);
    if4878 = call4906;
  }
// compiled if node returning if4878 (depth = 7)
    gc_frame_newslot(if4878);
    if4863 = if4878;
  }
// compiled if node returning if4863 (depth = 6)
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4907 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4908 == NULL) {
    strlit4908 = alloc_String("A match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4908);
  }
// compiled string node returning strlit4908 (depth = 7)
  gc_frame_newslot(strlit4908);
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4910 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4909);
// compiled call node returning call4910 (depth = 8)
// compiled member node returning call4910 (depth = 7)
  gc_frame_newslot(call4910);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call4912 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4911);
// compiled call node returning call4912 (depth = 8)
// compiled member node returning call4912 (depth = 7)
  gc_frame_newslot(call4912);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit4908;
  params[1] = call4910;
  params[2] = call4912;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4913 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4907);
// compiled call node returning call4913 (depth = 6)
    gc_frame_newslot(call4913);
    if4782 = call4913;
  }
// compiled if node returning if4782 (depth = 5)
    gc_frame_newslot(if4782);
    if4776 = if4782;
  }
// compiled if node returning if4776 (depth = 4)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4914 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4915 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call4916 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4915);
// compiled call node returning call4916 (depth = 6)
// compiled member node returning call4916 (depth = 5)
  gc_frame_newslot(call4916);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cases (depth = 5)
  params[0] = call4916;
  partcv[0] = 1;
  Object call4917 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4914);
// compiled call node returning call4917 (depth = 4)
  gc_frame_end(frame);
  return call4917;
}
Object meth_parser_matchcase4560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchcase (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for matchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_elsecase = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "elsecase");
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4562 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4565 == NULL) {
    strlit4565 = alloc_String("match");
    gc_root(strlit4565);
  }
// compiled string node returning strlit4565 (depth = 6)
  int op_slot_right_4564 = gc_frame_newslot(strlit4565);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call4568 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4567);
// compiled call node returning call4568 (depth = 7)
// compiled member node returning call4568 (depth = 6)
  int op_slot_left_4564 = gc_frame_newslot(call4568);
  params[0] = strlit4565;
  partcv[0] = 1;
  Object opresult4569 = callmethod(call4568, "==", 1, partcv, params);
// compiled op node returning opresult4569 (depth = 5)
  int op_slot_right_4563 = gc_frame_newslot(opresult4569);
// starting to compile call node (depth = 5)
  int callframe4571 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4572 == NULL) {
    strlit4572 = alloc_String("identifier");
    gc_root(strlit4572);
  }
// compiled string node returning strlit4572 (depth = 6)
  gc_frame_newslot(strlit4572);
// call case 4: self request
  params[0] = strlit4572;
  partcv[0] = 1;
  Object call4573 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4571);
// compiled call node returning call4573 (depth = 5)
  int op_slot_left_4563 = gc_frame_newslot(call4573);
  params[0] = opresult4569;
  partcv[0] = 1;
  Object opresult4574 = callmethod(call4573, "&&", 1, partcv, params);
// compiled op node returning opresult4574 (depth = 4)
  partcv[0] = 0;
  Object call4575 = callmethod(opresult4574, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4562);
// compiled call node returning call4575 (depth = 3)
  Object if4561 = done;
  if (istrue(call4575)) {
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num4576 = alloc_Float64(0);
// compiled num node returning num4576 (depth = 4)
  return num4576;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if4561 = undefined;
  } else {
  }
// compiled if node returning if4561 (depth = 2)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4577 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4578 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4577);
// compiled call node returning call4578 (depth = 3)
// compiled member node returning call4578 (depth = 2)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4581 == NULL) {
    strlit4581 = alloc_String("lparen");
    gc_root(strlit4581);
  }
// compiled string node returning strlit4581 (depth = 4)
  int op_slot_right_4580 = gc_frame_newslot(strlit4581);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4584 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4583);
// compiled call node returning call4584 (depth = 5)
// compiled member node returning call4584 (depth = 4)
  int op_slot_left_4580 = gc_frame_newslot(call4584);
  params[0] = strlit4581;
  partcv[0] = 1;
  Object opresult4585 = callmethod(call4584, "!=", 1, partcv, params);
// compiled op node returning opresult4585 (depth = 3)
  Object if4579 = done;
  if (istrue(opresult4585)) {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1407
  setline(1407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4586 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4587 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4588 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4587);
// compiled call node returning call4588 (depth = 7)
// compiled member node returning call4588 (depth = 6)
  partcv[0] = 0;
  Object call4589 = callmethod(call4588, "new",
    1, partcv, params);
  gc_frame_end(callframe4586);
// compiled call node returning call4589 (depth = 5)
// compiled member node returning call4589 (depth = 4)
  *var_suggestion = call4589;
  if (call4589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4590 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4591 = alloc_Block(NULL, NULL, "parser", 1409);
  gc_frame_newslot(block4591);
// method _apply
  block_savedest(block4591);
  Object closure4592 = createclosure(2, "_apply");
  setclosureframe(closure4592, stackframe);
  addtoclosure(closure4592, var_matchTok);
  addtoclosure(closure4592, selfslot);
  struct UserObject *uo4592 = (struct UserObject*)block4591;
  uo4592->data[0] = (Object)closure4592;
  Method *meth_meth_parser__apply4592 = addmethod2pos(block4591, "_apply", &meth_parser__apply4592, 0);
  int argcv_meth_parser__apply4592[] = {1};
  meth_meth_parser__apply4592->type = alloc_MethodType(1, argcv_meth_parser__apply4592);
  meth_meth_parser__apply4592->definitionModule = modulename;
  meth_meth_parser__apply4592->definitionLine = 1407;
// compiled block node returning block4591 (depth = 5)
  gc_frame_newslot(block4591);
// call case 4: self request
  params[0] = block4591;
  partcv[0] = 1;
  Object call4628 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4590);
// compiled call node returning call4628 (depth = 4)
  *var_nextTok = call4628;
  if (call4628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4631 = alloc_Boolean(0);
// compiled identifier node returning bool4631 (depth = 5)
  int op_slot_right_4630 = gc_frame_newslot(bool4631);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4630 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4631;
  partcv[0] = 1;
  Object opresult4633 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4633 (depth = 4)
  Object if4629 = done;
  if (istrue(opresult4633)) {
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4634 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4635 == NULL) {
    strlit4635 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4635);
  }
// compiled string node returning strlit4635 (depth = 5)
  gc_frame_newslot(strlit4635);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_matchTok (depth = 5)
  gc_frame_newslot(*var_matchTok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4635;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4636 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4634);
// compiled call node returning call4636 (depth = 4)
    gc_frame_newslot(call4636);
    if4629 = call4636;
  } else {
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4639 == NULL) {
    strlit4639 = alloc_String("rparen");
    gc_root(strlit4639);
  }
// compiled string node returning strlit4639 (depth = 6)
  int op_slot_right_4638 = gc_frame_newslot(strlit4639);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call4642 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4641);
// compiled call node returning call4642 (depth = 7)
// compiled member node returning call4642 (depth = 6)
  int op_slot_left_4638 = gc_frame_newslot(call4642);
  params[0] = strlit4639;
  partcv[0] = 1;
  Object opresult4643 = callmethod(call4642, "==", 1, partcv, params);
// compiled op node returning opresult4643 (depth = 5)
  Object if4637 = done;
  if (istrue(opresult4643)) {
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_4645 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_4645 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4647 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4647 (depth = 6)
  Object if4644 = done;
  if (istrue(opresult4647)) {
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4648 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4649 == NULL) {
    strlit4649 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4649);
  }
// compiled string node returning strlit4649 (depth = 7)
  gc_frame_newslot(strlit4649);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4649;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4650 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4648);
// compiled call node returning call4650 (depth = 6)
    gc_frame_newslot(call4650);
    if4644 = call4650;
  } else {
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4651 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4652 == NULL) {
    strlit4652 = alloc_String("(");
    gc_root(strlit4652);
  }
// compiled string node returning strlit4652 (depth = 7)
  gc_frame_newslot(strlit4652);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4652;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4653 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4651);
// compiled call node returning call4653 (depth = 6)
    gc_frame_newslot(call4653);
    if4644 = call4653;
  }
// compiled if node returning if4644 (depth = 5)
    gc_frame_newslot(if4644);
    if4637 = if4644;
  } else {
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4656 == NULL) {
    strlit4656 = alloc_String("identifier");
    gc_root(strlit4656);
  }
// compiled string node returning strlit4656 (depth = 7)
  int op_slot_right_4655 = gc_frame_newslot(strlit4656);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4658 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4659 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4658);
// compiled call node returning call4659 (depth = 8)
// compiled member node returning call4659 (depth = 7)
  int op_slot_left_4655 = gc_frame_newslot(call4659);
  params[0] = strlit4656;
  partcv[0] = 1;
  Object opresult4660 = callmethod(call4659, "==", 1, partcv, params);
// compiled op node returning opresult4660 (depth = 6)
  Object if4654 = done;
  if (istrue(opresult4660)) {
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4661 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4662 == NULL) {
    strlit4662 = alloc_String("(");
    gc_root(strlit4662);
  }
// compiled string node returning strlit4662 (depth = 7)
  gc_frame_newslot(strlit4662);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4662;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4663 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4661);
// compiled call node returning call4663 (depth = 6)
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe4664 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit4665 == NULL) {
    strlit4665 = alloc_String(")");
    gc_root(strlit4665);
  }
// compiled string node returning strlit4665 (depth = 7)
  gc_frame_newslot(strlit4665);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4666 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call4667 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4666);
// compiled call node returning call4667 (depth = 8)
// compiled member node returning call4667 (depth = 7)
  gc_frame_newslot(call4667);
// starting to compile identifier node (depth = 7)
  Object bool4668 = alloc_Boolean(1);
// compiled identifier node returning bool4668 (depth = 7)
  gc_frame_newslot(bool4668);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit4665;
  params[1] = call4667;
  params[2] = bool4668;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4669 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4664);
// compiled call node returning call4669 (depth = 6)
    gc_frame_newslot(call4669);
    if4654 = call4669;
  } else {
  }
// compiled if node returning if4654 (depth = 5)
    gc_frame_newslot(if4654);
    if4637 = if4654;
  }
// compiled if node returning if4637 (depth = 4)
    gc_frame_newslot(if4637);
    if4629 = if4637;
  }
// compiled if node returning if4629 (depth = 3)
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4670 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4671 == NULL) {
    strlit4671 = alloc_String("A match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4671);
  }
// compiled string node returning strlit4671 (depth = 4)
  gc_frame_newslot(strlit4671);
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4672 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_matchTok (depth = 6)
  partcv[0] = 0;
  Object call4673 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4672);
// compiled call node returning call4673 (depth = 5)
// compiled member node returning call4673 (depth = 4)
  gc_frame_newslot(call4673);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4676 = callmethod(*var_matchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4675);
// compiled call node returning call4676 (depth = 6)
// compiled member node returning call4676 (depth = 5)
  int op_slot_right_4674 = gc_frame_newslot(call4676);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4678 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_matchTok (depth = 7)
  partcv[0] = 0;
  Object call4679 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4678);
// compiled call node returning call4679 (depth = 6)
// compiled member node returning call4679 (depth = 5)
  int op_slot_left_4674 = gc_frame_newslot(call4679);
  params[0] = call4676;
  partcv[0] = 1;
  Object sum4680 = callmethod(call4679, "+", 1, partcv, params);
// compiled op node returning sum4680 (depth = 4)
  gc_frame_newslot(sum4680);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4671;
  params[1] = call4673;
  params[2] = sum4680;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4681 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4670);
// compiled call node returning call4681 (depth = 3)
    gc_frame_newslot(call4681);
    if4579 = call4681;
  } else {
  }
// compiled if node returning if4579 (depth = 2)
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4682 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4683 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4682);
// compiled call node returning call4683 (depth = 3)
// compiled member node returning call4683 (depth = 2)
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4685 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe4686 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block4687 = alloc_Block(NULL, NULL, "parser", 1427);
  gc_frame_newslot(block4687);
// method _apply
  block_savedest(block4687);
  Object closure4688 = createclosure(2, "_apply");
  setclosureframe(closure4688, stackframe);
  addtoclosure(closure4688, var_blocksOK);
  addtoclosure(closure4688, selfslot);
  struct UserObject *uo4688 = (struct UserObject*)block4687;
  uo4688->data[0] = (Object)closure4688;
  Method *meth_meth_parser__apply4688 = addmethod2pos(block4687, "_apply", &meth_parser__apply4688, 0);
  int argcv_meth_parser__apply4688[] = {0};
  meth_meth_parser__apply4688->type = alloc_MethodType(1, argcv_meth_parser__apply4688);
  meth_meth_parser__apply4688->definitionModule = modulename;
  meth_meth_parser__apply4688->definitionLine = 1427;
// compiled block node returning block4687 (depth = 6)
  gc_frame_newslot(block4687);
// call case 4: self request
  params[0] = block4687;
  partcv[0] = 1;
  Object call4692 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4686);
// compiled call node returning call4692 (depth = 5)
  partcv[0] = 0;
  Object call4693 = callmethod(call4692, "not",
    1, partcv, params);
  gc_frame_end(callframe4685);
// compiled call node returning call4693 (depth = 4)
// compiled member node returning call4693 (depth = 3)
  Object if4684 = done;
  if (istrue(call4693)) {
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4694 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4695 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4696 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4695);
// compiled call node returning call4696 (depth = 7)
// compiled member node returning call4696 (depth = 6)
  partcv[0] = 0;
  Object call4697 = callmethod(call4696, "new",
    1, partcv, params);
  gc_frame_end(callframe4694);
// compiled call node returning call4697 (depth = 5)
// compiled member node returning call4697 (depth = 4)
  *var_suggestion = call4697;
  if (call4697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4698 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4699 == NULL) {
    strlit4699 = alloc_String("rparen");
    gc_root(strlit4699);
  }
// compiled string node returning strlit4699 (depth = 5)
  gc_frame_newslot(strlit4699);
// call case 4: self request
  params[0] = strlit4699;
  partcv[0] = 1;
  Object call4700 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4698);
// compiled call node returning call4700 (depth = 4)
  *var_nextTok = call4700;
  if (call4700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  int op_slot_right_4702 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nextTok (depth = 5)
  int op_slot_left_4702 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4704 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult4704 (depth = 4)
  Object if4701 = done;
  if (istrue(opresult4704)) {
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4705 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4706 == NULL) {
    strlit4706 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4706);
  }
// compiled string node returning strlit4706 (depth = 5)
  gc_frame_newslot(strlit4706);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit4706;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4707 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4705);
// compiled call node returning call4707 (depth = 4)
    gc_frame_newslot(call4707);
    if4701 = call4707;
  } else {
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4708 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4709 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call4710 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4709);
// compiled call node returning call4710 (depth = 6)
// compiled member node returning call4710 (depth = 5)
  gc_frame_newslot(call4710);
// starting to compile identifier node (depth = 5)
  Object bool4711 = alloc_Boolean(1);
// compiled identifier node returning bool4711 (depth = 5)
  gc_frame_newslot(bool4711);
// starting to compile identifier node (depth = 5)
  Object bool4712 = alloc_Boolean(0);
// compiled identifier node returning bool4712 (depth = 5)
  gc_frame_newslot(bool4712);
// starting to compile string node (depth = 5)
  if (strlit4713 == NULL) {
    strlit4713 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4713);
  }
// compiled string node returning strlit4713 (depth = 5)
  gc_frame_newslot(strlit4713);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = call4710;
  params[2] = bool4711;
  params[3] = bool4712;
  params[4] = strlit4713;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4714 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4708);
// compiled call node returning call4714 (depth = 4)
    gc_frame_newslot(call4714);
    if4701 = call4714;
  }
// compiled if node returning if4701 (depth = 3)
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4715 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4716 == NULL) {
    strlit4716 = alloc_String("A match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4716);
  }
// compiled string node returning strlit4716 (depth = 4)
  gc_frame_newslot(strlit4716);
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4717 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4718 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4717);
// compiled call node returning call4718 (depth = 5)
// compiled member node returning call4718 (depth = 4)
  gc_frame_newslot(call4718);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4719 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4720 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4719);
// compiled call node returning call4720 (depth = 5)
// compiled member node returning call4720 (depth = 4)
  gc_frame_newslot(call4720);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4716;
  params[1] = call4718;
  params[2] = call4720;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4721 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4715);
// compiled call node returning call4721 (depth = 3)
    gc_frame_newslot(call4721);
    if4684 = call4721;
  } else {
  }
// compiled if node returning if4684 (depth = 2)
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4722 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call4723 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4722);
// compiled call node returning call4723 (depth = 4)
// compiled member node returning call4723 (depth = 3)
  *var_matchee = call4723;
  if (call4723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit4726 == NULL) {
    strlit4726 = alloc_String("rparen");
    gc_root(strlit4726);
  }
// compiled string node returning strlit4726 (depth = 4)
  int op_slot_right_4725 = gc_frame_newslot(strlit4726);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call4729 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4728);
// compiled call node returning call4729 (depth = 5)
// compiled member node returning call4729 (depth = 4)
  int op_slot_left_4725 = gc_frame_newslot(call4729);
  params[0] = strlit4726;
  partcv[0] = 1;
  Object opresult4730 = callmethod(call4729, "!=", 1, partcv, params);
// compiled op node returning opresult4730 (depth = 3)
  Object if4724 = done;
  if (istrue(opresult4730)) {
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4731 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4732 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4731);
// compiled call node returning call4732 (depth = 4)
// compiled member node returning call4732 (depth = 3)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4733 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call4735 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4734);
// compiled call node returning call4735 (depth = 7)
// compiled member node returning call4735 (depth = 6)
  partcv[0] = 0;
  Object call4736 = callmethod(call4735, "new",
    1, partcv, params);
  gc_frame_end(callframe4733);
// compiled call node returning call4736 (depth = 5)
// compiled member node returning call4736 (depth = 4)
  *var_suggestion = call4736;
  if (call4736 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1442
  setline(1442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4737 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4738 == NULL) {
    strlit4738 = alloc_String(")");
    gc_root(strlit4738);
  }
// compiled string node returning strlit4738 (depth = 4)
  gc_frame_newslot(strlit4738);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit4738;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4739 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4737);
// compiled call node returning call4739 (depth = 3)
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4740 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4741 == NULL) {
    strlit4741 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4741);
  }
// compiled string node returning strlit4741 (depth = 4)
  gc_frame_newslot(strlit4741);
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4742 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call4743 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4742);
// compiled call node returning call4743 (depth = 5)
// compiled member node returning call4743 (depth = 4)
  gc_frame_newslot(call4743);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4746 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4745);
// compiled call node returning call4746 (depth = 6)
// compiled member node returning call4746 (depth = 5)
  int op_slot_right_4744 = gc_frame_newslot(call4746);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4748 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call4749 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4748);
// compiled call node returning call4749 (depth = 6)
// compiled member node returning call4749 (depth = 5)
  int op_slot_left_4744 = gc_frame_newslot(call4749);
  params[0] = call4746;
  partcv[0] = 1;
  Object sum4750 = callmethod(call4749, "+", 1, partcv, params);
// compiled op node returning sum4750 (depth = 4)
  gc_frame_newslot(sum4750);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit4741;
  params[1] = call4743;
  params[2] = sum4750;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4751 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4740);
// compiled call node returning call4751 (depth = 3)
    gc_frame_newslot(call4751);
    if4724 = call4751;
  } else {
  }
// compiled if node returning if4724 (depth = 2)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4753 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4752);
// compiled call node returning call4753 (depth = 3)
// compiled member node returning call4753 (depth = 2)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array4754 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array4754 (depth = 3)
  *var_cases = array4754;
  if (array4754 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool4755 = alloc_Boolean(0);
// compiled identifier node returning bool4755 (depth = 3)
  *var_elsecase = bool4755;
  if (bool4755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4756 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4757 = alloc_Block(NULL, NULL, "parser", 1449);
  gc_frame_newslot(block4757);
// method _apply
  block_savedest(block4757);
  Object closure4758 = createclosure(2, "_apply");
  setclosureframe(closure4758, stackframe);
  addtoclosure(closure4758, var_sym);
  addtoclosure(closure4758, selfslot);
  struct UserObject *uo4758 = (struct UserObject*)block4757;
  uo4758->data[0] = (Object)closure4758;
  Method *meth_meth_parser__apply4758 = addmethod2pos(block4757, "_apply", &meth_parser__apply4758, 0);
  int argcv_meth_parser__apply4758[] = {0};
  meth_meth_parser__apply4758->type = alloc_MethodType(1, argcv_meth_parser__apply4758);
  meth_meth_parser__apply4758->definitionModule = modulename;
  meth_meth_parser__apply4758->definitionLine = 1446;
// compiled block node returning block4757 (depth = 3)
  gc_frame_newslot(block4757);
// starting to compile block node (depth = 3)
  Object block4772 = alloc_Block(NULL, NULL, "parser", 1449);
  gc_frame_newslot(block4772);
// method _apply
  block_savedest(block4772);
  Object closure4773 = createclosure(8, "_apply");
  setclosureframe(closure4773, stackframe);
  addtoclosure(closure4773, var_blocksOK);
  addtoclosure(closure4773, var_errormessages);
  addtoclosure(closure4773, var_sym);
  addtoclosure(closure4773, var_lastToken);
  addtoclosure(closure4773, var_tokens);
  addtoclosure(closure4773, var_values);
  addtoclosure(closure4773, var_cases);
  addtoclosure(closure4773, selfslot);
  struct UserObject *uo4773 = (struct UserObject*)block4772;
  uo4773->data[0] = (Object)closure4773;
  Method *meth_meth_parser__apply4773 = addmethod2pos(block4772, "_apply", &meth_parser__apply4773, 0);
  int argcv_meth_parser__apply4773[] = {0};
  meth_meth_parser__apply4773->type = alloc_MethodType(1, argcv_meth_parser__apply4773);
  meth_meth_parser__apply4773->definitionModule = modulename;
  meth_meth_parser__apply4773->definitionLine = 1449;
// compiled block node returning block4772 (depth = 3)
  gc_frame_newslot(block4772);
// call case 5: prelude request
  params[0] = block4757;
  params[1] = block4772;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4919 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4756);
// compiled call node returning call4919 (depth = 2)
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4920 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4921 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_matchee (depth = 4)
  gc_frame_newslot(*var_matchee);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cases (depth = 4)
  gc_frame_newslot(*var_cases);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elsecase (depth = 4)
  gc_frame_newslot(*var_elsecase);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call4923 = callmethod(*var_ast, "matchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4922);
// compiled call node returning call4923 (depth = 5)
// compiled member node returning call4923 (depth = 4)
  params[0] = *var_matchee;
  params[1] = *var_cases;
  params[2] = *var_elsecase;
  partcv[0] = 3;
  Object call4924 = callmethod(call4923, "new",
    1, partcv, params);
  gc_frame_end(callframe4921);
// compiled call node returning call4924 (depth = 3)
  gc_frame_newslot(call4924);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = call4924;
  partcv[0] = 1;
  Object call4925 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4920);
// compiled call node returning call4925 (depth = 2)
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_localmin (depth = 3)
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply5021(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 13)
// starting to compile string node (depth = 14)
  if (strlit5023 == NULL) {
    strlit5023 = alloc_String("type");
    gc_root(strlit5023);
  }
// compiled string node returning strlit5023 (depth = 14)
  int op_slot_right_5022 = gc_frame_newslot(strlit5023);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe5025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call5026 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5025);
// compiled call node returning call5026 (depth = 15)
// compiled member node returning call5026 (depth = 14)
  int op_slot_left_5022 = gc_frame_newslot(call5026);
  params[0] = strlit5023;
  partcv[0] = 1;
  Object opresult5027 = callmethod(call5026, "==", 1, partcv, params);
// compiled op node returning opresult5027 (depth = 13)
  gc_frame_end(frame);
  return opresult5027;
}
Object meth_parser_term4927(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for term (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for term");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4928 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4929 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4930 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4929);
// compiled call node returning call4930 (depth = 4)
// compiled member node returning call4930 (depth = 3)
  gc_frame_newslot(call4930);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call4932 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4931);
// compiled call node returning call4932 (depth = 4)
// compiled member node returning call4932 (depth = 3)
  gc_frame_newslot(call4932);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call4930;
  params[1] = call4932;
  partcv[0] = 2;
  Object call4933 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe4928);
// compiled call node returning call4933 (depth = 2)
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4935 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit4936 == NULL) {
    strlit4936 = alloc_String("num");
    gc_root(strlit4936);
  }
// compiled string node returning strlit4936 (depth = 4)
  gc_frame_newslot(strlit4936);
// call case 4: self request
  params[0] = strlit4936;
  partcv[0] = 1;
  Object call4937 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4935);
// compiled call node returning call4937 (depth = 3)
  Object if4934 = done;
  if (istrue(call4937)) {
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4938 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4939 = callmethodflags(self, "pushnum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4938);
// compiled call node returning call4939 (depth = 4)
// compiled member node returning call4939 (depth = 3)
    gc_frame_newslot(call4939);
    if4934 = call4939;
  } else {
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4941 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit4942 == NULL) {
    strlit4942 = alloc_String("string");
    gc_root(strlit4942);
  }
// compiled string node returning strlit4942 (depth = 5)
  gc_frame_newslot(strlit4942);
// call case 4: self request
  params[0] = strlit4942;
  partcv[0] = 1;
  Object call4943 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4941);
// compiled call node returning call4943 (depth = 4)
  Object if4940 = done;
  if (istrue(call4943)) {
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4945 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4944);
// compiled call node returning call4945 (depth = 5)
// compiled member node returning call4945 (depth = 4)
    gc_frame_newslot(call4945);
    if4940 = call4945;
  } else {
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4947 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4948 == NULL) {
    strlit4948 = alloc_String("octets");
    gc_root(strlit4948);
  }
// compiled string node returning strlit4948 (depth = 6)
  gc_frame_newslot(strlit4948);
// call case 4: self request
  params[0] = strlit4948;
  partcv[0] = 1;
  Object call4949 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4947);
// compiled call node returning call4949 (depth = 5)
  Object if4946 = done;
  if (istrue(call4949)) {
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4950 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4951 = callmethodflags(self, "pushoctets", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4950);
// compiled call node returning call4951 (depth = 6)
// compiled member node returning call4951 (depth = 5)
    gc_frame_newslot(call4951);
    if4946 = call4951;
  } else {
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4955 == NULL) {
    strlit4955 = alloc_String("match");
    gc_root(strlit4955);
  }
// compiled string node returning strlit4955 (depth = 8)
  int op_slot_right_4954 = gc_frame_newslot(strlit4955);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4957 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call4958 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4957);
// compiled call node returning call4958 (depth = 9)
// compiled member node returning call4958 (depth = 8)
  int op_slot_left_4954 = gc_frame_newslot(call4958);
  params[0] = strlit4955;
  partcv[0] = 1;
  Object opresult4959 = callmethod(call4958, "==", 1, partcv, params);
// compiled op node returning opresult4959 (depth = 7)
  int op_slot_right_4953 = gc_frame_newslot(opresult4959);
// starting to compile call node (depth = 7)
  int callframe4961 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit4962 == NULL) {
    strlit4962 = alloc_String("identifier");
    gc_root(strlit4962);
  }
// compiled string node returning strlit4962 (depth = 8)
  gc_frame_newslot(strlit4962);
// call case 4: self request
  params[0] = strlit4962;
  partcv[0] = 1;
  Object call4963 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4961);
// compiled call node returning call4963 (depth = 7)
  int op_slot_left_4953 = gc_frame_newslot(call4963);
  params[0] = opresult4959;
  partcv[0] = 1;
  Object opresult4964 = callmethod(call4963, "&&", 1, partcv, params);
// compiled op node returning opresult4964 (depth = 6)
  Object if4952 = done;
  if (istrue(opresult4964)) {
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4965 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4966 = callmethodflags(self, "matchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4965);
// compiled call node returning call4966 (depth = 7)
// compiled member node returning call4966 (depth = 6)
    gc_frame_newslot(call4966);
    if4952 = call4966;
  } else {
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4970 == NULL) {
    strlit4970 = alloc_String("catch");
    gc_root(strlit4970);
  }
// compiled string node returning strlit4970 (depth = 9)
  int op_slot_right_4969 = gc_frame_newslot(strlit4970);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4972 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call4973 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4972);
// compiled call node returning call4973 (depth = 10)
// compiled member node returning call4973 (depth = 9)
  int op_slot_left_4969 = gc_frame_newslot(call4973);
  params[0] = strlit4970;
  partcv[0] = 1;
  Object opresult4974 = callmethod(call4973, "==", 1, partcv, params);
// compiled op node returning opresult4974 (depth = 8)
  int op_slot_right_4968 = gc_frame_newslot(opresult4974);
// starting to compile call node (depth = 8)
  int callframe4976 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit4977 == NULL) {
    strlit4977 = alloc_String("identifier");
    gc_root(strlit4977);
  }
// compiled string node returning strlit4977 (depth = 9)
  gc_frame_newslot(strlit4977);
// call case 4: self request
  params[0] = strlit4977;
  partcv[0] = 1;
  Object call4978 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4976);
// compiled call node returning call4978 (depth = 8)
  int op_slot_left_4968 = gc_frame_newslot(call4978);
  params[0] = opresult4974;
  partcv[0] = 1;
  Object opresult4979 = callmethod(call4978, "&&", 1, partcv, params);
// compiled op node returning opresult4979 (depth = 7)
  Object if4967 = done;
  if (istrue(opresult4979)) {
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4980 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4981 = callmethodflags(self, "catchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4980);
// compiled call node returning call4981 (depth = 8)
// compiled member node returning call4981 (depth = 7)
    gc_frame_newslot(call4981);
    if4967 = call4981;
  } else {
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit4985 == NULL) {
    strlit4985 = alloc_String("try");
    gc_root(strlit4985);
  }
// compiled string node returning strlit4985 (depth = 10)
  int op_slot_right_4984 = gc_frame_newslot(strlit4985);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe4987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call4988 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4987);
// compiled call node returning call4988 (depth = 11)
// compiled member node returning call4988 (depth = 10)
  int op_slot_left_4984 = gc_frame_newslot(call4988);
  params[0] = strlit4985;
  partcv[0] = 1;
  Object opresult4989 = callmethod(call4988, "==", 1, partcv, params);
// compiled op node returning opresult4989 (depth = 9)
  int op_slot_right_4983 = gc_frame_newslot(opresult4989);
// starting to compile call node (depth = 9)
  int callframe4991 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4992 == NULL) {
    strlit4992 = alloc_String("identifier");
    gc_root(strlit4992);
  }
// compiled string node returning strlit4992 (depth = 10)
  gc_frame_newslot(strlit4992);
// call case 4: self request
  params[0] = strlit4992;
  partcv[0] = 1;
  Object call4993 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4991);
// compiled call node returning call4993 (depth = 9)
  int op_slot_left_4983 = gc_frame_newslot(call4993);
  params[0] = opresult4989;
  partcv[0] = 1;
  Object opresult4994 = callmethod(call4993, "&&", 1, partcv, params);
// compiled op node returning opresult4994 (depth = 8)
  Object if4982 = done;
  if (istrue(opresult4994)) {
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4995 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4996 = callmethodflags(self, "trycatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4995);
// compiled call node returning call4996 (depth = 9)
// compiled member node returning call4996 (depth = 8)
    gc_frame_newslot(call4996);
    if4982 = call4996;
  } else {
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe4998 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit4999 == NULL) {
    strlit4999 = alloc_String("identifier");
    gc_root(strlit4999);
  }
// compiled string node returning strlit4999 (depth = 10)
  gc_frame_newslot(strlit4999);
// call case 4: self request
  params[0] = strlit4999;
  partcv[0] = 1;
  Object call5000 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4998);
// compiled call node returning call5000 (depth = 9)
  Object if4997 = done;
  if (istrue(call5000)) {
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5001 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5002 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5001);
// compiled call node returning call5002 (depth = 10)
// compiled member node returning call5002 (depth = 9)
    gc_frame_newslot(call5002);
    if4997 = call5002;
  } else {
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit5006 == NULL) {
    strlit5006 = alloc_String("object");
    gc_root(strlit5006);
  }
// compiled string node returning strlit5006 (depth = 12)
  int op_slot_right_5005 = gc_frame_newslot(strlit5006);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call5009 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5008);
// compiled call node returning call5009 (depth = 13)
// compiled member node returning call5009 (depth = 12)
  int op_slot_left_5005 = gc_frame_newslot(call5009);
  params[0] = strlit5006;
  partcv[0] = 1;
  Object opresult5010 = callmethod(call5009, "==", 1, partcv, params);
// compiled op node returning opresult5010 (depth = 11)
  int op_slot_right_5004 = gc_frame_newslot(opresult5010);
// starting to compile call node (depth = 11)
  int callframe5012 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5013 == NULL) {
    strlit5013 = alloc_String("keyword");
    gc_root(strlit5013);
  }
// compiled string node returning strlit5013 (depth = 12)
  gc_frame_newslot(strlit5013);
// call case 4: self request
  params[0] = strlit5013;
  partcv[0] = 1;
  Object call5014 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5012);
// compiled call node returning call5014 (depth = 11)
  int op_slot_left_5004 = gc_frame_newslot(call5014);
  params[0] = opresult5010;
  partcv[0] = 1;
  Object opresult5015 = callmethod(call5014, "&&", 1, partcv, params);
// compiled op node returning opresult5015 (depth = 10)
  Object if5003 = done;
  if (istrue(opresult5015)) {
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5016 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5017 = callmethodflags(self, "doobject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5016);
// compiled call node returning call5017 (depth = 11)
// compiled member node returning call5017 (depth = 10)
    gc_frame_newslot(call5017);
    if5003 = call5017;
  } else {
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe5019 = gc_frame_new();
// starting to compile block node (depth = 12)
  Object block5020 = alloc_Block(NULL, NULL, "parser", 1570);
  gc_frame_newslot(block5020);
// method _apply
  block_savedest(block5020);
  Object closure5021 = createclosure(2, "_apply");
  setclosureframe(closure5021, stackframe);
  addtoclosure(closure5021, var_sym);
  addtoclosure(closure5021, selfslot);
  struct UserObject *uo5021 = (struct UserObject*)block5020;
  uo5021->data[0] = (Object)closure5021;
  Method *meth_meth_parser__apply5021 = addmethod2pos(block5020, "_apply", &meth_parser__apply5021, 0);
  int argcv_meth_parser__apply5021[] = {0};
  meth_meth_parser__apply5021->type = alloc_MethodType(1, argcv_meth_parser__apply5021);
  meth_meth_parser__apply5021->definitionModule = modulename;
  meth_meth_parser__apply5021->definitionLine = 1569;
// compiled block node returning block5020 (depth = 12)
  gc_frame_newslot(block5020);
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe5029 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5030 == NULL) {
    strlit5030 = alloc_String("keyword");
    gc_root(strlit5030);
  }
// compiled string node returning strlit5030 (depth = 13)
  gc_frame_newslot(strlit5030);
// call case 4: self request
  params[0] = strlit5030;
  partcv[0] = 1;
  Object call5031 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5029);
// compiled call node returning call5031 (depth = 12)
  params[0] = block5020;
  partcv[0] = 1;
  Object call5032 = callmethod(call5031, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5019);
// compiled call node returning call5032 (depth = 11)
  Object if5018 = done;
  if (istrue(call5032)) {
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5033 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5034 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5033);
// compiled call node returning call5034 (depth = 12)
// compiled member node returning call5034 (depth = 11)
    gc_frame_newslot(call5034);
    if5018 = call5034;
  } else {
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 11)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 12)
  int callframe5036 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5037 == NULL) {
    strlit5037 = alloc_String("lbrace");
    gc_root(strlit5037);
  }
// compiled string node returning strlit5037 (depth = 13)
  gc_frame_newslot(strlit5037);
// call case 4: self request
  params[0] = strlit5037;
  partcv[0] = 1;
  Object call5038 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5036);
// compiled call node returning call5038 (depth = 12)
  Object if5035 = done;
  if (istrue(call5038)) {
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe5039 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5040 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5039);
// compiled call node returning call5040 (depth = 13)
// compiled member node returning call5040 (depth = 12)
    gc_frame_newslot(call5040);
    if5035 = call5040;
  } else {
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 12)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 13)
  int callframe5042 = gc_frame_new();
// starting to compile string node (depth = 14)
  if (strlit5043 == NULL) {
    strlit5043 = alloc_String("lsquare");
    gc_root(strlit5043);
  }
// compiled string node returning strlit5043 (depth = 14)
  gc_frame_newslot(strlit5043);
// call case 4: self request
  params[0] = strlit5043;
  partcv[0] = 1;
  Object call5044 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5042);
// compiled call node returning call5044 (depth = 13)
  Object if5041 = done;
  if (istrue(call5044)) {
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe5045 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5046 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5045);
// compiled call node returning call5046 (depth = 14)
// compiled member node returning call5046 (depth = 13)
    gc_frame_newslot(call5046);
    if5041 = call5046;
  } else {
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 13)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 14)
  int callframe5048 = gc_frame_new();
// starting to compile string node (depth = 15)
  if (strlit5049 == NULL) {
    strlit5049 = alloc_String("op");
    gc_root(strlit5049);
  }
// compiled string node returning strlit5049 (depth = 15)
  gc_frame_newslot(strlit5049);
// call case 4: self request
  params[0] = strlit5049;
  partcv[0] = 1;
  Object call5050 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5048);
// compiled call node returning call5050 (depth = 14)
  Object if5047 = done;
  if (istrue(call5050)) {
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe5051 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5052 = callmethodflags(self, "prefixop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5051);
// compiled call node returning call5052 (depth = 15)
// compiled member node returning call5052 (depth = 14)
    gc_frame_newslot(call5052);
    if5047 = call5052;
  } else {
  }
// compiled if node returning if5047 (depth = 13)
    gc_frame_newslot(if5047);
    if5041 = if5047;
  }
// compiled if node returning if5041 (depth = 12)
    gc_frame_newslot(if5041);
    if5035 = if5041;
  }
// compiled if node returning if5035 (depth = 11)
    gc_frame_newslot(if5035);
    if5018 = if5035;
  }
// compiled if node returning if5018 (depth = 10)
    gc_frame_newslot(if5018);
    if5003 = if5018;
  }
// compiled if node returning if5003 (depth = 9)
    gc_frame_newslot(if5003);
    if4997 = if5003;
  }
// compiled if node returning if4997 (depth = 8)
    gc_frame_newslot(if4997);
    if4982 = if4997;
  }
// compiled if node returning if4982 (depth = 7)
    gc_frame_newslot(if4982);
    if4967 = if4982;
  }
// compiled if node returning if4967 (depth = 6)
    gc_frame_newslot(if4967);
    if4952 = if4967;
  }
// compiled if node returning if4952 (depth = 5)
    gc_frame_newslot(if4952);
    if4946 = if4952;
  }
// compiled if node returning if4946 (depth = 4)
    gc_frame_newslot(if4946);
    if4940 = if4946;
  }
// compiled if node returning if4940 (depth = 3)
    gc_frame_newslot(if4940);
    if4934 = if4940;
  }
// compiled if node returning if4934 (depth = 2)
  gc_frame_end(frame);
  return if4934;
}
Object meth_parser__apply5079(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_acceptBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe5080 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_acceptBlocks (depth = 9)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5081 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5080);
// compiled call node returning call5081 (depth = 8)
  gc_frame_end(frame);
  return call5081;
}
Object meth_parser_expression5053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method expression");
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_statementToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expression (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for expression");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
  Object *var_tmpStatementToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tmpStatementToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5054 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5055 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5054);
// compiled call node returning call5055 (depth = 4)
// compiled member node returning call5055 (depth = 3)
  *var_sz = call5055;
  if (call5055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5056 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5057 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5058 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5057);
// compiled call node returning call5058 (depth = 4)
// compiled member node returning call5058 (depth = 3)
  gc_frame_newslot(call5058);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5059 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5060 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5059);
// compiled call node returning call5060 (depth = 4)
// compiled member node returning call5060 (depth = 3)
  gc_frame_newslot(call5060);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call5058;
  params[1] = call5060;
  partcv[0] = 2;
  Object call5061 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5056);
// compiled call node returning call5061 (depth = 2)
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5063 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5064 == NULL) {
    strlit5064 = alloc_String("lparen");
    gc_root(strlit5064);
  }
// compiled string node returning strlit5064 (depth = 4)
  gc_frame_newslot(strlit5064);
// call case 4: self request
  params[0] = strlit5064;
  partcv[0] = 1;
  Object call5065 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5063);
// compiled call node returning call5065 (depth = 3)
  Object if5062 = done;
  if (istrue(call5065)) {
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_statementToken (depth = 4)
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5067 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5069 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5068);
// compiled call node returning call5069 (depth = 5)
// compiled member node returning call5069 (depth = 4)
  gc_frame_newslot(call5069);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5071 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5070);
// compiled call node returning call5071 (depth = 5)
// compiled member node returning call5071 (depth = 4)
  gc_frame_newslot(call5071);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5069;
  params[1] = call5071;
  partcv[0] = 2;
  Object call5072 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5067);
// compiled call node returning call5072 (depth = 3)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5073 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5074 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5073);
// compiled call node returning call5074 (depth = 4)
// compiled member node returning call5074 (depth = 3)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5076 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe5077 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5078 = alloc_Block(NULL, NULL, "parser", 1594);
  gc_frame_newslot(block5078);
// method _apply
  block_savedest(block5078);
  Object closure5079 = createclosure(2, "_apply");
  setclosureframe(closure5079, stackframe);
  addtoclosure(closure5079, var_acceptBlocks);
  addtoclosure(closure5079, selfslot);
  struct UserObject *uo5079 = (struct UserObject*)block5078;
  uo5079->data[0] = (Object)closure5079;
  Method *meth_meth_parser__apply5079 = addmethod2pos(block5078, "_apply", &meth_parser__apply5079, 0);
  int argcv_meth_parser__apply5079[] = {0};
  meth_meth_parser__apply5079->type = alloc_MethodType(1, argcv_meth_parser__apply5079);
  meth_meth_parser__apply5079->definitionModule = modulename;
  meth_meth_parser__apply5079->definitionLine = 1594;
// compiled block node returning block5078 (depth = 7)
  gc_frame_newslot(block5078);
// call case 4: self request
  params[0] = block5078;
  partcv[0] = 1;
  Object call5083 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5077);
// compiled call node returning call5083 (depth = 6)
  partcv[0] = 0;
  Object call5084 = callmethod(call5083, "not",
    1, partcv, params);
  gc_frame_end(callframe5076);
// compiled call node returning call5084 (depth = 5)
// compiled member node returning call5084 (depth = 4)
  Object if5075 = done;
  if (istrue(call5084)) {
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5085 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5087 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5086);
// compiled call node returning call5087 (depth = 8)
// compiled member node returning call5087 (depth = 7)
  partcv[0] = 0;
  Object call5088 = callmethod(call5087, "new",
    1, partcv, params);
  gc_frame_end(callframe5085);
// compiled call node returning call5088 (depth = 6)
// compiled member node returning call5088 (depth = 5)
  *var_suggestion = call5088;
  if (call5088 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5089 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5090 == NULL) {
    strlit5090 = alloc_String("rparen");
    gc_root(strlit5090);
  }
// compiled string node returning strlit5090 (depth = 6)
  gc_frame_newslot(strlit5090);
// call case 4: self request
  params[0] = strlit5090;
  partcv[0] = 1;
  Object call5091 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5089);
// compiled call node returning call5091 (depth = 5)
  *var_nextTok = call5091;
  if (call5091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_5093 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_5093 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5095 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5095 (depth = 5)
  Object if5092 = done;
  if (istrue(opresult5095)) {
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5096 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5097 == NULL) {
    strlit5097 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5097);
  }
// compiled string node returning strlit5097 (depth = 6)
  gc_frame_newslot(strlit5097);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5097;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5098 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5096);
// compiled call node returning call5098 (depth = 5)
    gc_frame_newslot(call5098);
    if5092 = call5098;
  } else {
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5099 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5100 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5101 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5100);
// compiled call node returning call5101 (depth = 7)
// compiled member node returning call5101 (depth = 6)
  gc_frame_newslot(call5101);
// starting to compile identifier node (depth = 6)
  Object bool5102 = alloc_Boolean(1);
// compiled identifier node returning bool5102 (depth = 6)
  gc_frame_newslot(bool5102);
// starting to compile identifier node (depth = 6)
  Object bool5103 = alloc_Boolean(0);
// compiled identifier node returning bool5103 (depth = 6)
  gc_frame_newslot(bool5103);
// starting to compile string node (depth = 6)
  if (strlit5104 == NULL) {
    strlit5104 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5104);
  }
// compiled string node returning strlit5104 (depth = 6)
  gc_frame_newslot(strlit5104);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call5101;
  params[2] = bool5102;
  params[3] = bool5103;
  params[4] = strlit5104;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5105 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5099);
// compiled call node returning call5105 (depth = 5)
    gc_frame_newslot(call5105);
    if5092 = call5105;
  }
// compiled if node returning if5092 (depth = 4)
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5106 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5107 == NULL) {
    strlit5107 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit5107);
  }
// compiled string node returning strlit5107 (depth = 5)
  gc_frame_newslot(strlit5107);
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5109 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5108);
// compiled call node returning call5109 (depth = 6)
// compiled member node returning call5109 (depth = 5)
  gc_frame_newslot(call5109);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5110 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5111 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5110);
// compiled call node returning call5111 (depth = 6)
// compiled member node returning call5111 (depth = 5)
  gc_frame_newslot(call5111);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5107;
  params[1] = call5109;
  params[2] = call5111;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5112 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5106);
// compiled call node returning call5112 (depth = 4)
    gc_frame_newslot(call5112);
    if5075 = call5112;
  } else {
  }
// compiled if node returning if5075 (depth = 3)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5115 == NULL) {
    strlit5115 = alloc_String("rparen");
    gc_root(strlit5115);
  }
// compiled string node returning strlit5115 (depth = 5)
  int op_slot_right_5114 = gc_frame_newslot(strlit5115);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5118 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5117);
// compiled call node returning call5118 (depth = 6)
// compiled member node returning call5118 (depth = 5)
  int op_slot_left_5114 = gc_frame_newslot(call5118);
  params[0] = strlit5115;
  partcv[0] = 1;
  Object opresult5119 = callmethod(call5118, "!=", 1, partcv, params);
// compiled op node returning opresult5119 (depth = 4)
  Object if5113 = done;
  if (istrue(opresult5119)) {
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5120 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5121 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5120);
// compiled call node returning call5121 (depth = 5)
// compiled member node returning call5121 (depth = 4)
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5122 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5123 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5124 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5123);
// compiled call node returning call5124 (depth = 8)
// compiled member node returning call5124 (depth = 7)
  partcv[0] = 0;
  Object call5125 = callmethod(call5124, "new",
    1, partcv, params);
  gc_frame_end(callframe5122);
// compiled call node returning call5125 (depth = 6)
// compiled member node returning call5125 (depth = 5)
  *var_suggestion = call5125;
  if (call5125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5126 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5127 == NULL) {
    strlit5127 = alloc_String(")");
    gc_root(strlit5127);
  }
// compiled string node returning strlit5127 (depth = 5)
  gc_frame_newslot(strlit5127);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5127;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5128 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5126);
// compiled call node returning call5128 (depth = 4)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5129 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5130 == NULL) {
    strlit5130 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5130);
  }
// compiled string node returning strlit5130 (depth = 5)
  gc_frame_newslot(strlit5130);
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5131 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call5132 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5131);
// compiled call node returning call5132 (depth = 6)
// compiled member node returning call5132 (depth = 5)
  gc_frame_newslot(call5132);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5135 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5134);
// compiled call node returning call5135 (depth = 7)
// compiled member node returning call5135 (depth = 6)
  int op_slot_right_5133 = gc_frame_newslot(call5135);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5137 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5138 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5137);
// compiled call node returning call5138 (depth = 7)
// compiled member node returning call5138 (depth = 6)
  int op_slot_left_5133 = gc_frame_newslot(call5138);
  params[0] = call5135;
  partcv[0] = 1;
  Object sum5139 = callmethod(call5138, "+", 1, partcv, params);
// compiled op node returning sum5139 (depth = 5)
  gc_frame_newslot(sum5139);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5130;
  params[1] = call5132;
  params[2] = sum5139;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5140 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5129);
// compiled call node returning call5140 (depth = 4)
    gc_frame_newslot(call5140);
    if5113 = call5140;
  } else {
  }
// compiled if node returning if5113 (depth = 3)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_tmpStatementToken (depth = 4)
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5142 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5143 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5142);
// compiled call node returning call5143 (depth = 4)
// compiled member node returning call5143 (depth = 3)
    gc_frame_newslot(call5143);
    if5062 = call5143;
  } else {
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5144 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5145 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5144);
// compiled call node returning call5145 (depth = 4)
// compiled member node returning call5145 (depth = 3)
    gc_frame_newslot(call5145);
    if5062 = call5145;
  }
// compiled if node returning if5062 (depth = 2)
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_5147 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5150 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5149);
// compiled call node returning call5150 (depth = 5)
// compiled member node returning call5150 (depth = 4)
  int op_slot_left_5147 = gc_frame_newslot(call5150);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult5151 = callmethod(call5150, ">", 1, partcv, params);
// compiled op node returning opresult5151 (depth = 3)
  Object if5146 = done;
  if (istrue(opresult5151)) {
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5152 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5153 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compiled call node returning call5153 (depth = 3)
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5154 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_acceptBlocks (depth = 4)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5155 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5154);
// compiled call node returning call5155 (depth = 3)
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5156 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5157 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5156);
// compiled call node returning call5157 (depth = 4)
// compiled member node returning call5157 (depth = 3)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5158 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5159 = callmethodflags(self, "valueexpressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5158);
// compiled call node returning call5159 (depth = 4)
// compiled member node returning call5159 (depth = 3)
    gc_frame_newslot(call5159);
    if5146 = call5159;
  } else {
  }
// compiled if node returning if5146 (depth = 2)
  gc_frame_end(frame);
  return if5146;
}
Object meth_parser__apply5173(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe5174 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_blocksOK (depth = 9)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5175 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5174);
// compiled call node returning call5175 (depth = 8)
  gc_frame_end(frame);
  return call5175;
}
Object meth_parser_postfixsquare5160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "postfixsquare");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for postfixsquare (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for postfixsquare");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_index = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "index");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5162 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5163 == NULL) {
    strlit5163 = alloc_String("lsquare");
    gc_root(strlit5163);
  }
// compiled string node returning strlit5163 (depth = 4)
  gc_frame_newslot(strlit5163);
// call case 4: self request
  params[0] = strlit5163;
  partcv[0] = 1;
  Object call5164 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5162);
// compiled call node returning call5164 (depth = 3)
  Object if5161 = done;
  if (istrue(call5164)) {
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5165 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5166 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5165);
// compiled call node returning call5166 (depth = 4)
// compiled member node returning call5166 (depth = 3)
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5168 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5167);
// compiled call node returning call5168 (depth = 5)
// compiled member node returning call5168 (depth = 4)
  *var_expr = call5168;
  if (call5168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5170 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe5171 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block5172 = alloc_Block(NULL, NULL, "parser", 1631);
  gc_frame_newslot(block5172);
// method _apply
  block_savedest(block5172);
  Object closure5173 = createclosure(2, "_apply");
  setclosureframe(closure5173, stackframe);
  addtoclosure(closure5173, var_blocksOK);
  addtoclosure(closure5173, selfslot);
  struct UserObject *uo5173 = (struct UserObject*)block5172;
  uo5173->data[0] = (Object)closure5173;
  Method *meth_meth_parser__apply5173 = addmethod2pos(block5172, "_apply", &meth_parser__apply5173, 0);
  int argcv_meth_parser__apply5173[] = {0};
  meth_meth_parser__apply5173->type = alloc_MethodType(1, argcv_meth_parser__apply5173);
  meth_meth_parser__apply5173->definitionModule = modulename;
  meth_meth_parser__apply5173->definitionLine = 1631;
// compiled block node returning block5172 (depth = 7)
  gc_frame_newslot(block5172);
// call case 4: self request
  params[0] = block5172;
  partcv[0] = 1;
  Object call5177 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5171);
// compiled call node returning call5177 (depth = 6)
  partcv[0] = 0;
  Object call5178 = callmethod(call5177, "not",
    1, partcv, params);
  gc_frame_end(callframe5170);
// compiled call node returning call5178 (depth = 5)
// compiled member node returning call5178 (depth = 4)
  Object if5169 = done;
  if (istrue(call5178)) {
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array5179 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5179 (depth = 5)
  *var_suggestions = array5179;
  if (array5179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5180 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5181 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5182 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5181);
// compiled call node returning call5182 (depth = 8)
// compiled member node returning call5182 (depth = 7)
  partcv[0] = 0;
  Object call5183 = callmethod(call5182, "new",
    1, partcv, params);
  gc_frame_end(callframe5180);
// compiled call node returning call5183 (depth = 6)
// compiled member node returning call5183 (depth = 5)
  *var_suggestion = call5183;
  if (call5183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5184 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5185 == NULL) {
    strlit5185 = alloc_String("rsquare");
    gc_root(strlit5185);
  }
// compiled string node returning strlit5185 (depth = 6)
  gc_frame_newslot(strlit5185);
// call case 4: self request
  params[0] = strlit5185;
  partcv[0] = 1;
  Object call5186 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5184);
// compiled call node returning call5186 (depth = 5)
  *var_nextTok = call5186;
  if (call5186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_5188 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_5188 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5190 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5190 (depth = 5)
  Object if5187 = done;
  if (istrue(opresult5190)) {
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5191 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5192 == NULL) {
    strlit5192 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit5192);
  }
// compiled string node returning strlit5192 (depth = 6)
  gc_frame_newslot(strlit5192);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5192;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5193 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5191);
// compiled call node returning call5193 (depth = 5)
    gc_frame_newslot(call5193);
    if5187 = call5193;
  } else {
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5194 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5195 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5196 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5195);
// compiled call node returning call5196 (depth = 7)
// compiled member node returning call5196 (depth = 6)
  gc_frame_newslot(call5196);
// starting to compile identifier node (depth = 6)
  Object bool5197 = alloc_Boolean(1);
// compiled identifier node returning bool5197 (depth = 6)
  gc_frame_newslot(bool5197);
// starting to compile identifier node (depth = 6)
  Object bool5198 = alloc_Boolean(0);
// compiled identifier node returning bool5198 (depth = 6)
  gc_frame_newslot(bool5198);
// starting to compile string node (depth = 6)
  if (strlit5199 == NULL) {
    strlit5199 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit5199);
  }
// compiled string node returning strlit5199 (depth = 6)
  gc_frame_newslot(strlit5199);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call5196;
  params[2] = bool5197;
  params[3] = bool5198;
  params[4] = strlit5199;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5200 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5194);
// compiled call node returning call5200 (depth = 5)
    gc_frame_newslot(call5200);
    if5187 = call5200;
  }
// compiled if node returning if5187 (depth = 4)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5201 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5202 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5201);
// compiled call node returning call5202 (depth = 4)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5205 == NULL) {
    strlit5205 = alloc_String("rsquare");
    gc_root(strlit5205);
  }
// compiled string node returning strlit5205 (depth = 6)
  int op_slot_right_5204 = gc_frame_newslot(strlit5205);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call5208 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe5207);
// compiled call node returning call5208 (depth = 7)
// compiled member node returning call5208 (depth = 6)
  int op_slot_left_5204 = gc_frame_newslot(call5208);
  params[0] = strlit5205;
  partcv[0] = 1;
  Object opresult5209 = callmethod(call5208, "==", 1, partcv, params);
// compiled op node returning opresult5209 (depth = 5)
  Object if5203 = done;
  if (istrue(opresult5209)) {
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5210 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5212 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5211);
// compiled call node returning call5212 (depth = 9)
// compiled member node returning call5212 (depth = 8)
  partcv[0] = 0;
  Object call5213 = callmethod(call5212, "new",
    1, partcv, params);
  gc_frame_end(callframe5210);
// compiled call node returning call5213 (depth = 7)
// compiled member node returning call5213 (depth = 6)
  *var_suggestion = call5213;
  if (call5213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5215 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  gc_frame_newslot(*var_nextTok);
// starting to compile identifier node (depth = 6)
  Object bool5216 = alloc_Boolean(1);
// compiled identifier node returning bool5216 (depth = 6)
  gc_frame_newslot(bool5216);
// starting to compile identifier node (depth = 6)
  Object bool5217 = alloc_Boolean(0);
// compiled identifier node returning bool5217 (depth = 6)
  gc_frame_newslot(bool5217);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = *var_nextTok;
  params[2] = bool5216;
  params[3] = bool5217;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5218 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5215);
// compiled call node returning call5218 (depth = 5)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5219 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5220 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5219);
// compiled call node returning call5220 (depth = 5)
    gc_frame_newslot(call5220);
    if5203 = call5220;
  } else {
  }
// compiled if node returning if5203 (depth = 4)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5221 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5222 == NULL) {
    strlit5222 = alloc_String("A '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit5222);
  }
// compiled string node returning strlit5222 (depth = 5)
  gc_frame_newslot(strlit5222);
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5224 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5223);
// compiled call node returning call5224 (depth = 6)
// compiled member node returning call5224 (depth = 5)
  gc_frame_newslot(call5224);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5225 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5226 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5225);
// compiled call node returning call5226 (depth = 6)
// compiled member node returning call5226 (depth = 5)
  gc_frame_newslot(call5226);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5222;
  params[1] = call5224;
  params[2] = call5226;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5227 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5221);
// compiled call node returning call5227 (depth = 4)
    gc_frame_newslot(call5227);
    if5169 = call5227;
  } else {
  }
// compiled if node returning if5169 (depth = 3)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5229 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5228);
// compiled call node returning call5229 (depth = 5)
// compiled member node returning call5229 (depth = 4)
  *var_index = call5229;
  if (call5229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5232 == NULL) {
    strlit5232 = alloc_String("rsquare");
    gc_root(strlit5232);
  }
// compiled string node returning strlit5232 (depth = 5)
  int op_slot_right_5231 = gc_frame_newslot(strlit5232);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5235 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5234);
// compiled call node returning call5235 (depth = 6)
// compiled member node returning call5235 (depth = 5)
  int op_slot_left_5231 = gc_frame_newslot(call5235);
  params[0] = strlit5232;
  partcv[0] = 1;
  Object opresult5236 = callmethod(call5235, "!=", 1, partcv, params);
// compiled op node returning opresult5236 (depth = 4)
  Object if5230 = done;
  if (istrue(opresult5236)) {
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5237 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5238 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5239 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5238);
// compiled call node returning call5239 (depth = 8)
// compiled member node returning call5239 (depth = 7)
  partcv[0] = 0;
  Object call5240 = callmethod(call5239, "new",
    1, partcv, params);
  gc_frame_end(callframe5237);
// compiled call node returning call5240 (depth = 6)
// compiled member node returning call5240 (depth = 5)
  *var_suggestion = call5240;
  if (call5240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5241 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5242 == NULL) {
    strlit5242 = alloc_String("]");
    gc_root(strlit5242);
  }
// compiled string node returning strlit5242 (depth = 5)
  gc_frame_newslot(strlit5242);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5242;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5243 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5241);
// compiled call node returning call5243 (depth = 4)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5244 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5245 == NULL) {
    strlit5245 = alloc_String("A '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit5245);
  }
// compiled string node returning strlit5245 (depth = 5)
  gc_frame_newslot(strlit5245);
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5246 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call5247 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5246);
// compiled call node returning call5247 (depth = 6)
// compiled member node returning call5247 (depth = 5)
  gc_frame_newslot(call5247);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5249 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5250 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5249);
// compiled call node returning call5250 (depth = 7)
// compiled member node returning call5250 (depth = 6)
  int op_slot_right_5248 = gc_frame_newslot(call5250);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5253 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5252);
// compiled call node returning call5253 (depth = 7)
// compiled member node returning call5253 (depth = 6)
  int op_slot_left_5248 = gc_frame_newslot(call5253);
  params[0] = call5250;
  partcv[0] = 1;
  Object sum5254 = callmethod(call5253, "+", 1, partcv, params);
// compiled op node returning sum5254 (depth = 5)
  gc_frame_newslot(sum5254);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5245;
  params[1] = call5247;
  params[2] = sum5254;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5255 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5244);
// compiled call node returning call5255 (depth = 4)
    gc_frame_newslot(call5255);
    if5230 = call5255;
  } else {
  }
// compiled if node returning if5230 (depth = 3)
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5256 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5257 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5256);
// compiled call node returning call5257 (depth = 4)
// compiled member node returning call5257 (depth = 3)
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5258 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_expr (depth = 5)
  gc_frame_newslot(*var_expr);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_index (depth = 5)
  gc_frame_newslot(*var_index);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5260 = callmethod(*var_ast, "indexNode",
    1, partcv, params);
  gc_frame_end(callframe5259);
// compiled call node returning call5260 (depth = 6)
// compiled member node returning call5260 (depth = 5)
  params[0] = *var_expr;
  params[1] = *var_index;
  partcv[0] = 2;
  Object call5261 = callmethod(call5260, "new",
    1, partcv, params);
  gc_frame_end(callframe5258);
// compiled call node returning call5261 (depth = 4)
  *var_o = call5261;
  if (call5261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5262 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5263 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5262);
// compiled call node returning call5263 (depth = 3)
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5264 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5265 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5264);
// compiled call node returning call5265 (depth = 3)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5266 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5267 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5266);
// compiled call node returning call5267 (depth = 3)
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5268 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5269 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5268);
// compiled call node returning call5269 (depth = 4)
// compiled member node returning call5269 (depth = 3)
    gc_frame_newslot(call5269);
    if5161 = call5269;
  } else {
  }
// compiled if node returning if5161 (depth = 2)
  gc_frame_end(frame);
  return if5161;
}
Object meth_parser_oprec5270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method oprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for oprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for oprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5273 == NULL) {
    strlit5273 = alloc_String("*");
    gc_root(strlit5273);
  }
// compiled string node returning strlit5273 (depth = 4)
  int op_slot_right_5272 = gc_frame_newslot(strlit5273);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  int op_slot_left_5272 = gc_frame_newslot(*var_o);
  params[0] = strlit5273;
  partcv[0] = 1;
  Object opresult5275 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 3)
  Object if5271 = done;
  if (istrue(opresult5275)) {
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num5276 = alloc_Float64(10);
// compiled num node returning num5276 (depth = 4)
  return num5276;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5271 = undefined;
  } else {
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5279 == NULL) {
    strlit5279 = alloc_String("/");
    gc_root(strlit5279);
  }
// compiled string node returning strlit5279 (depth = 5)
  int op_slot_right_5278 = gc_frame_newslot(strlit5279);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  int op_slot_left_5278 = gc_frame_newslot(*var_o);
  params[0] = strlit5279;
  partcv[0] = 1;
  Object opresult5281 = callmethod(*var_o, "==", 1, partcv, params);
// compiled op node returning opresult5281 (depth = 4)
  Object if5277 = done;
  if (istrue(opresult5281)) {
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num5282 = alloc_Float64(10);
// compiled num node returning num5282 (depth = 5)
  return num5282;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5277 = undefined;
  } else {
  }
// compiled if node returning if5277 (depth = 3)
    gc_frame_newslot(if5277);
    if5271 = if5277;
  }
// compiled if node returning if5271 (depth = 2)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num5283 = alloc_Float64(5);
// compiled num node returning num5283 (depth = 3)
  return num5283;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_toprec5284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method toprec");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for toprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5287 = alloc_Float64(0);
// compiled num node returning num5287 (depth = 4)
  int op_slot_right_5286 = gc_frame_newslot(num5287);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5289 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call5290 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5289);
// compiled call node returning call5290 (depth = 5)
// compiled member node returning call5290 (depth = 4)
  int op_slot_left_5286 = gc_frame_newslot(call5290);
  params[0] = num5287;
  partcv[0] = 1;
  Object opresult5291 = callmethod(call5290, ">", 1, partcv, params);
// compiled op node returning opresult5291 (depth = 3)
  Object if5285 = done;
  if (istrue(opresult5291)) {
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5292 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ops (depth = 6)
  partcv[0] = 0;
  Object call5293 = callmethod(*var_ops, "last",
    1, partcv, params);
  gc_frame_end(callframe5292);
// compiled call node returning call5293 (depth = 5)
// compiled member node returning call5293 (depth = 4)
  *var_o = call5293;
  if (call5293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5294 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5295 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5294);
// compiled call node returning call5295 (depth = 4)
  return call5295;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5285 = undefined;
  } else {
  }
// compiled if node returning if5285 (depth = 2)
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num5296 = alloc_Float64(0);
// compiled num node returning num5296 (depth = 2)
  gc_frame_end(frame);
  return num5296;
}
Object meth_parser__apply5305(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5306 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5307 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5306);
// compiled call node returning call5307 (depth = 6)
// compiled member node returning call5307 (depth = 5)
  gc_frame_end(frame);
  return call5307;
}
Object meth_parser_typeexpressionrest5297(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5299 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5300 == NULL) {
    strlit5300 = alloc_String("op");
    gc_root(strlit5300);
  }
// compiled string node returning strlit5300 (depth = 4)
  gc_frame_newslot(strlit5300);
// call case 4: self request
  params[0] = strlit5300;
  partcv[0] = 1;
  Object call5301 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5299);
// compiled call node returning call5301 (depth = 3)
  Object if5298 = done;
  if (istrue(call5301)) {
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5302 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5303 == NULL) {
    strlit5303 = alloc_String("type expression");
    gc_root(strlit5303);
  }
// compiled string node returning strlit5303 (depth = 4)
  gc_frame_newslot(strlit5303);
// starting to compile block node (depth = 4)
  Object block5304 = alloc_Block(NULL, NULL, "parser", 1689);
  gc_frame_newslot(block5304);
// method _apply
  block_savedest(block5304);
  Object closure5305 = createclosure(1, "_apply");
  setclosureframe(closure5305, stackframe);
  addtoclosure(closure5305, selfslot);
  struct UserObject *uo5305 = (struct UserObject*)block5304;
  uo5305->data[0] = (Object)closure5305;
  Method *meth_meth_parser__apply5305 = addmethod2pos(block5304, "_apply", &meth_parser__apply5305, 0);
  int argcv_meth_parser__apply5305[] = {0};
  meth_meth_parser__apply5305->type = alloc_MethodType(1, argcv_meth_parser__apply5305);
  meth_meth_parser__apply5305->definitionModule = modulename;
  meth_meth_parser__apply5305->definitionLine = 1680;
// compiled block node returning block5304 (depth = 4)
  gc_frame_newslot(block5304);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_noBlocks (depth = 4)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = strlit5303;
  params[1] = block5304;
  params[2] = *var_noBlocks;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5309 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5302);
// compiled call node returning call5309 (depth = 3)
    gc_frame_newslot(call5309);
    if5298 = call5309;
  } else {
  }
// compiled if node returning if5298 (depth = 2)
  gc_frame_end(frame);
  return if5298;
}
Object meth_parser__apply5318(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5319 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call5320 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5319);
// compiled call node returning call5320 (depth = 5)
  gc_frame_end(frame);
  return call5320;
}
Object meth_parser_valueexpressionrest5310(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valueexpressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for valueexpressionrest (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for valueexpressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5312 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5313 == NULL) {
    strlit5313 = alloc_String("op");
    gc_root(strlit5313);
  }
// compiled string node returning strlit5313 (depth = 4)
  gc_frame_newslot(strlit5313);
// call case 4: self request
  params[0] = strlit5313;
  partcv[0] = 1;
  Object call5314 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5312);
// compiled call node returning call5314 (depth = 3)
  Object if5311 = done;
  if (istrue(call5314)) {
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5315 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5316 == NULL) {
    strlit5316 = alloc_String("expression");
    gc_root(strlit5316);
  }
// compiled string node returning strlit5316 (depth = 4)
  gc_frame_newslot(strlit5316);
// starting to compile block node (depth = 4)
  Object block5317 = alloc_Block(NULL, NULL, "parser", 1695);
  gc_frame_newslot(block5317);
// method _apply
  block_savedest(block5317);
  Object closure5318 = createclosure(2, "_apply");
  setclosureframe(closure5318, stackframe);
  addtoclosure(closure5318, var_blocksOK);
  addtoclosure(closure5318, selfslot);
  struct UserObject *uo5318 = (struct UserObject*)block5317;
  uo5318->data[0] = (Object)closure5318;
  Method *meth_meth_parser__apply5318 = addmethod2pos(block5317, "_apply", &meth_parser__apply5318, 0);
  int argcv_meth_parser__apply5318[] = {0};
  meth_meth_parser__apply5318->type = alloc_MethodType(1, argcv_meth_parser__apply5318);
  meth_meth_parser__apply5318->definitionModule = modulename;
  meth_meth_parser__apply5318->definitionLine = 1689;
// compiled block node returning block5317 (depth = 4)
  gc_frame_newslot(block5317);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blocksOK (depth = 4)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = strlit5316;
  params[1] = block5317;
  params[2] = *var_blocksOK;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5322 = callmethodflags(self, "expressionrest()recursingWith()blocks", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5315);
// compiled call node returning call5322 (depth = 3)
    gc_frame_newslot(call5322);
    if5311 = call5322;
  } else {
  }
// compiled if node returning if5311 (depth = 2)
  gc_frame_end(frame);
  return if5311;
}
Object meth_parser__apply5338(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5340 == NULL) {
    strlit5340 = alloc_String("=");
    gc_root(strlit5340);
  }
// compiled string node returning strlit5340 (depth = 7)
  int op_slot_right_5339 = gc_frame_newslot(strlit5340);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5342 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5343 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5342);
// compiled call node returning call5343 (depth = 8)
// compiled member node returning call5343 (depth = 7)
  int op_slot_left_5339 = gc_frame_newslot(call5343);
  params[0] = strlit5340;
  partcv[0] = 1;
  Object opresult5344 = callmethod(call5343, "!=", 1, partcv, params);
// compiled op node returning opresult5344 (depth = 6)
  gc_frame_end(frame);
  return opresult5344;
}
Object meth_parser__apply5335(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5336 = gc_frame_new();
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block5337 = alloc_Block(NULL, NULL, "parser", 1717);
  gc_frame_newslot(block5337);
// method _apply
  block_savedest(block5337);
  Object closure5338 = createclosure(2, "_apply");
  setclosureframe(closure5338, stackframe);
  addtoclosure(closure5338, var_sym);
  addtoclosure(closure5338, selfslot);
  struct UserObject *uo5338 = (struct UserObject*)block5337;
  uo5338->data[0] = (Object)closure5338;
  Method *meth_meth_parser__apply5338 = addmethod2pos(block5337, "_apply", &meth_parser__apply5338, 0);
  int argcv_meth_parser__apply5338[] = {0};
  meth_meth_parser__apply5338->type = alloc_MethodType(1, argcv_meth_parser__apply5338);
  meth_meth_parser__apply5338->definitionModule = modulename;
  meth_meth_parser__apply5338->definitionLine = 1710;
// compiled block node returning block5337 (depth = 5)
  gc_frame_newslot(block5337);
// call case 6: other member request
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5346 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5347 == NULL) {
    strlit5347 = alloc_String("op");
    gc_root(strlit5347);
  }
// compiled string node returning strlit5347 (depth = 6)
  gc_frame_newslot(strlit5347);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_statementToken (depth = 6)
  gc_frame_newslot(*var_statementToken);
// call case 4: self request
  params[0] = strlit5347;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5348 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5346);
// compiled call node returning call5348 (depth = 5)
  params[0] = block5337;
  partcv[0] = 1;
  Object call5349 = callmethod(call5348, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5336);
// compiled call node returning call5349 (depth = 4)
  gc_frame_end(frame);
  return call5349;
}
Object meth_parser__apply5460(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5463 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  gc_frame_newslot(*var_ops);
// call case 4: self request
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call5464 = callmethodflags(self, "toprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5463);
// compiled call node returning call5464 (depth = 8)
  int op_slot_right_5462 = gc_frame_newslot(call5464);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_prec (depth = 8)
  int op_slot_left_5462 = gc_frame_newslot(*var_prec);
  params[0] = call5464;
  partcv[0] = 1;
  Object opresult5466 = callmethod(*var_prec, "<=", 1, partcv, params);
// compiled op node returning opresult5466 (depth = 7)
  int op_slot_right_5461 = gc_frame_newslot(opresult5466);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num5469 = alloc_Float64(0);
// compiled num node returning num5469 (depth = 8)
  int op_slot_right_5468 = gc_frame_newslot(num5469);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ops (depth = 10)
  partcv[0] = 0;
  Object call5472 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5471);
// compiled call node returning call5472 (depth = 9)
// compiled member node returning call5472 (depth = 8)
  int op_slot_left_5468 = gc_frame_newslot(call5472);
  params[0] = num5469;
  partcv[0] = 1;
  Object opresult5473 = callmethod(call5472, ">", 1, partcv, params);
// compiled op node returning opresult5473 (depth = 7)
  int op_slot_left_5461 = gc_frame_newslot(opresult5473);
  params[0] = opresult5466;
  partcv[0] = 1;
  Object opresult5474 = callmethod(opresult5473, "&&", 1, partcv, params);
// compiled op node returning opresult5474 (depth = 6)
  gc_frame_end(frame);
  return opresult5474;
}
Object meth_parser__apply5477(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5478 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ops (depth = 9)
  partcv[0] = 0;
  Object call5479 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5478);
// compiled call node returning call5479 (depth = 8)
// compiled member node returning call5479 (depth = 7)
  *var_o2 = call5479;
  if (call5479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5482 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5481);
// compiled call node returning call5482 (depth = 8)
// compiled member node returning call5482 (depth = 7)
  *var_tmp2 = call5482;
  if (call5482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5484 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_terms (depth = 9)
  partcv[0] = 0;
  Object call5485 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5484);
// compiled call node returning call5485 (depth = 8)
// compiled member node returning call5485 (depth = 7)
  *var_tmp = call5485;
  if (call5485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5487 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o2 (depth = 8)
  gc_frame_newslot(*var_o2);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp2 (depth = 8)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5488 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call5489 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5488);
// compiled call node returning call5489 (depth = 9)
// compiled member node returning call5489 (depth = 8)
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5490 = callmethod(call5489, "new",
    1, partcv, params);
  gc_frame_end(callframe5487);
// compiled call node returning call5490 (depth = 7)
  *var_tmp = call5490;
  if (call5490 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5492 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tmp (depth = 7)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5493 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5492);
// compiled call node returning call5493 (depth = 6)
  gc_frame_end(frame);
  return call5493;
}
Object meth_parser__apply5668(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5669 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5670 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5669);
// compiled call node returning call5670 (depth = 11)
// compiled member node returning call5670 (depth = 10)
  gc_frame_end(frame);
  return call5670;
}
Object meth_parser__apply5352(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_ast = getfromclosure(closure, 13);
  Object *var_recurse = getfromclosure(closure, 14);
  Object *var_name = getfromclosure(closure, 15);
  Object *var_util = getfromclosure(closure, 16);
  Object *var_acceptBlocks = getfromclosure(closure, 17);
  Object *var_values = getfromclosure(closure, 18);
  Object self = *(getfromclosure(closure, 19));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num5354 = alloc_Float64(1);
// compiled num node returning num5354 (depth = 6)
  int op_slot_right_5353 = gc_frame_newslot(num5354);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_opcount (depth = 6)
  int op_slot_left_5353 = gc_frame_newslot(*var_opcount);
  params[0] = num5354;
  partcv[0] = 1;
  Object sum5356 = callmethod(*var_opcount, "+", 1, partcv, params);
// compiled op node returning sum5356 (depth = 5)
  *var_opcount = sum5356;
  if (sum5356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5358 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5359 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5358);
// compiled call node returning call5359 (depth = 6)
// compiled member node returning call5359 (depth = 5)
  *var_o = call5359;
  if (call5359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5361 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5362 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5361);
// compiled call node returning call5362 (depth = 5)
// compiled member node returning call5362 (depth = 4)
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5363 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// call case 4: self request
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5364 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5363);
// compiled call node returning call5364 (depth = 5)
  *var_prec = call5364;
  if (call5364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5369 == NULL) {
    strlit5369 = alloc_String("-");
    gc_root(strlit5369);
  }
// compiled string node returning strlit5369 (depth = 7)
  int op_slot_right_5368 = gc_frame_newslot(strlit5369);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  int op_slot_left_5368 = gc_frame_newslot(*var_o);
  params[0] = strlit5369;
  partcv[0] = 1;
  Object opresult5371 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5371 (depth = 6)
  int op_slot_right_5367 = gc_frame_newslot(opresult5371);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5375 == NULL) {
    strlit5375 = alloc_String("+");
    gc_root(strlit5375);
  }
// compiled string node returning strlit5375 (depth = 8)
  int op_slot_right_5374 = gc_frame_newslot(strlit5375);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_left_5374 = gc_frame_newslot(*var_o);
  params[0] = strlit5375;
  partcv[0] = 1;
  Object opresult5377 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5377 (depth = 7)
  int op_slot_right_5373 = gc_frame_newslot(opresult5377);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5381 == NULL) {
    strlit5381 = alloc_String("/");
    gc_root(strlit5381);
  }
// compiled string node returning strlit5381 (depth = 9)
  int op_slot_right_5380 = gc_frame_newslot(strlit5381);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_5380 = gc_frame_newslot(*var_o);
  params[0] = strlit5381;
  partcv[0] = 1;
  Object opresult5383 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5383 (depth = 8)
  int op_slot_right_5379 = gc_frame_newslot(opresult5383);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5386 == NULL) {
    strlit5386 = alloc_String("*");
    gc_root(strlit5386);
  }
// compiled string node returning strlit5386 (depth = 9)
  int op_slot_right_5385 = gc_frame_newslot(strlit5386);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  int op_slot_left_5385 = gc_frame_newslot(*var_o);
  params[0] = strlit5386;
  partcv[0] = 1;
  Object opresult5388 = callmethod(*var_o, "!=", 1, partcv, params);
// compiled op node returning opresult5388 (depth = 8)
  int op_slot_left_5379 = gc_frame_newslot(opresult5388);
  params[0] = opresult5383;
  partcv[0] = 1;
  Object opresult5389 = callmethod(opresult5388, "&&", 1, partcv, params);
// compiled op node returning opresult5389 (depth = 7)
  int op_slot_left_5373 = gc_frame_newslot(opresult5389);
  params[0] = opresult5377;
  partcv[0] = 1;
  Object opresult5390 = callmethod(opresult5389, "&&", 1, partcv, params);
// compiled op node returning opresult5390 (depth = 6)
  int op_slot_left_5367 = gc_frame_newslot(opresult5390);
  params[0] = opresult5371;
  partcv[0] = 1;
  Object opresult5391 = callmethod(opresult5390, "&&", 1, partcv, params);
// compiled op node returning opresult5391 (depth = 5)
  Object if5366 = done;
  if (istrue(opresult5391)) {
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool5392 = alloc_Boolean(0);
// compiled identifier node returning bool5392 (depth = 6)
  *var_allarith = bool5392;
  if (bool5392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if5366 = done;
  } else {
  }
// compiled if node returning if5366 (depth = 4)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_allarith (depth = 8)
  partcv[0] = 0;
  Object call5397 = callmethod(*var_allarith, "not",
    1, partcv, params);
  gc_frame_end(callframe5396);
// compiled call node returning call5397 (depth = 7)
// compiled member node returning call5397 (depth = 6)
  int op_slot_right_5395 = gc_frame_newslot(call5397);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  int op_slot_right_5400 = gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_5400 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult5402 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compiled op node returning opresult5402 (depth = 7)
  int op_slot_right_5399 = gc_frame_newslot(opresult5402);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5405 == NULL) {
    strlit5405 = alloc_String("");
    gc_root(strlit5405);
  }
// compiled string node returning strlit5405 (depth = 8)
  int op_slot_right_5404 = gc_frame_newslot(strlit5405);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_opdtype (depth = 8)
  int op_slot_left_5404 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit5405;
  partcv[0] = 1;
  Object opresult5407 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compiled op node returning opresult5407 (depth = 7)
  int op_slot_left_5399 = gc_frame_newslot(opresult5407);
  params[0] = opresult5402;
  partcv[0] = 1;
  Object opresult5408 = callmethod(opresult5407, "&&", 1, partcv, params);
// compiled op node returning opresult5408 (depth = 6)
  int op_slot_left_5395 = gc_frame_newslot(opresult5408);
  params[0] = call5397;
  partcv[0] = 1;
  Object opresult5409 = callmethod(opresult5408, "&&", 1, partcv, params);
// compiled op node returning opresult5409 (depth = 5)
  Object if5394 = done;
  if (istrue(opresult5409)) {
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array5410 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5410 (depth = 6)
  *var_suggestions = array5410;
  if (array5410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5411 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5413 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5412);
// compiled call node returning call5413 (depth = 9)
// compiled member node returning call5413 (depth = 8)
  partcv[0] = 0;
  Object call5414 = callmethod(call5413, "new",
    1, partcv, params);
  gc_frame_end(callframe5411);
// compiled call node returning call5414 (depth = 7)
// compiled member node returning call5414 (depth = 6)
  *var_suggestion = call5414;
  if (call5414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5415 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5416 == NULL) {
    strlit5416 = alloc_String(")");
    gc_root(strlit5416);
  }
// compiled string node returning strlit5416 (depth = 6)
  gc_frame_newslot(strlit5416);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5416;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5417 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5415);
// compiled call node returning call5417 (depth = 5)
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5418 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5419 == NULL) {
    strlit5419 = alloc_String("(");
    gc_root(strlit5419);
  }
// compiled string node returning strlit5419 (depth = 6)
  gc_frame_newslot(strlit5419);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5421 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5420);
// compiled call node returning call5421 (depth = 7)
// compiled member node returning call5421 (depth = 6)
  gc_frame_newslot(call5421);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5419;
  params[1] = call5421;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5422 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5418);
// compiled call node returning call5422 (depth = 5)
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5423 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5424 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5423);
// compiled call node returning call5424 (depth = 5)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5425 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call5427 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5426);
// compiled call node returning call5427 (depth = 9)
// compiled member node returning call5427 (depth = 8)
  partcv[0] = 0;
  Object call5428 = callmethod(call5427, "new",
    1, partcv, params);
  gc_frame_end(callframe5425);
// compiled call node returning call5428 (depth = 7)
// compiled member node returning call5428 (depth = 6)
  *var_suggestion = call5428;
  if (call5428 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5430 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5431 == NULL) {
    strlit5431 = alloc_String(")");
    gc_root(strlit5431);
  }
// compiled string node returning strlit5431 (depth = 6)
  gc_frame_newslot(strlit5431);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5432 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call5433 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5432);
// compiled call node returning call5433 (depth = 7)
// compiled member node returning call5433 (depth = 6)
  gc_frame_newslot(call5433);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5431;
  params[1] = call5433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5434 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5430);
// compiled call node returning call5434 (depth = 5)
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5435 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5436 == NULL) {
    strlit5436 = alloc_String("(");
    gc_root(strlit5436);
  }
// compiled string node returning strlit5436 (depth = 6)
  gc_frame_newslot(strlit5436);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5437 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5438 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call5440 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5439);
// compiled call node returning call5440 (depth = 11)
// compiled member node returning call5440 (depth = 10)
  partcv[0] = 0;
  Object call5441 = callmethod(call5440, "prev",
    1, partcv, params);
  gc_frame_end(callframe5438);
// compiled call node returning call5441 (depth = 9)
// compiled member node returning call5441 (depth = 8)
  partcv[0] = 0;
  Object call5442 = callmethod(call5441, "prev",
    1, partcv, params);
  gc_frame_end(callframe5437);
// compiled call node returning call5442 (depth = 7)
// compiled member node returning call5442 (depth = 6)
  gc_frame_newslot(call5442);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit5436;
  params[1] = call5442;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5443 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5435);
// compiled call node returning call5443 (depth = 5)
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5444 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5445 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5444);
// compiled call node returning call5445 (depth = 5)
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5446 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5447 == NULL) {
    strlit5447 = alloc_String("An expression containing both mathematical and non-mathematical operators requires parentheses.");
    gc_root(strlit5447);
  }
// compiled string node returning strlit5447 (depth = 6)
  gc_frame_newslot(strlit5447);
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5448 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5449 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5450 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5449);
// compiled call node returning call5450 (depth = 9)
// compiled member node returning call5450 (depth = 8)
  partcv[0] = 0;
  Object call5451 = callmethod(call5450, "line",
    1, partcv, params);
  gc_frame_end(callframe5448);
// compiled call node returning call5451 (depth = 7)
// compiled member node returning call5451 (depth = 6)
  gc_frame_newslot(call5451);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5452 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5453 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5454 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5453);
// compiled call node returning call5454 (depth = 9)
// compiled member node returning call5454 (depth = 8)
  partcv[0] = 0;
  Object call5455 = callmethod(call5454, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5452);
// compiled call node returning call5455 (depth = 7)
// compiled member node returning call5455 (depth = 6)
  gc_frame_newslot(call5455);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit5447;
  params[1] = call5451;
  params[2] = call5455;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5456 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5446);
// compiled call node returning call5456 (depth = 5)
    gc_frame_newslot(call5456);
    if5394 = call5456;
  } else {
  }
// compiled if node returning if5394 (depth = 4)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5458 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block5459 = alloc_Block(NULL, NULL, "parser", 1742);
  gc_frame_newslot(block5459);
// method _apply
  block_savedest(block5459);
  Object closure5460 = createclosure(3, "_apply");
  setclosureframe(closure5460, stackframe);
  addtoclosure(closure5460, var_ops);
  addtoclosure(closure5460, var_prec);
  addtoclosure(closure5460, selfslot);
  struct UserObject *uo5460 = (struct UserObject*)block5459;
  uo5460->data[0] = (Object)closure5460;
  Method *meth_meth_parser__apply5460 = addmethod2pos(block5459, "_apply", &meth_parser__apply5460, 0);
  int argcv_meth_parser__apply5460[] = {0};
  meth_meth_parser__apply5460->type = alloc_MethodType(1, argcv_meth_parser__apply5460);
  meth_meth_parser__apply5460->definitionModule = modulename;
  meth_meth_parser__apply5460->definitionLine = 1739;
// compiled block node returning block5459 (depth = 5)
  gc_frame_newslot(block5459);
// starting to compile block node (depth = 5)
  Object block5476 = alloc_Block(NULL, NULL, "parser", 1742);
  gc_frame_newslot(block5476);
// method _apply
  block_savedest(block5476);
  Object closure5477 = createclosure(7, "_apply");
  setclosureframe(closure5477, stackframe);
  addtoclosure(closure5477, var_ops);
  addtoclosure(closure5477, var_o2);
  addtoclosure(closure5477, var_terms);
  addtoclosure(closure5477, var_tmp2);
  addtoclosure(closure5477, var_tmp);
  addtoclosure(closure5477, var_ast);
  addtoclosure(closure5477, selfslot);
  struct UserObject *uo5477 = (struct UserObject*)block5476;
  uo5477->data[0] = (Object)closure5477;
  Method *meth_meth_parser__apply5477 = addmethod2pos(block5476, "_apply", &meth_parser__apply5477, 0);
  int argcv_meth_parser__apply5477[] = {0};
  meth_meth_parser__apply5477->type = alloc_MethodType(1, argcv_meth_parser__apply5477);
  meth_meth_parser__apply5477->definitionModule = modulename;
  meth_meth_parser__apply5477->definitionLine = 1742;
// compiled block node returning block5476 (depth = 5)
  gc_frame_newslot(block5476);
// call case 5: prelude request
  params[0] = block5459;
  params[1] = block5476;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5495 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5458);
// compiled call node returning call5495 (depth = 4)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5496 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ops (depth = 5)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5497 = callmethod(*var_ops, "push",
    1, partcv, params);
  gc_frame_end(callframe5496);
// compiled call node returning call5497 (depth = 4)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5499 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5500 == NULL) {
    strlit5500 = alloc_String("lparen");
    gc_root(strlit5500);
  }
// compiled string node returning strlit5500 (depth = 6)
  gc_frame_newslot(strlit5500);
// call case 4: self request
  params[0] = strlit5500;
  partcv[0] = 1;
  Object call5501 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5499);
// compiled call node returning call5501 (depth = 5)
  Object if5498 = done;
  if (istrue(call5501)) {
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5502 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5503 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5502);
// compiled call node returning call5503 (depth = 6)
// compiled member node returning call5503 (depth = 5)
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5505 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5506 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_recurse (depth = 9)
  gc_frame_newslot(*var_recurse);
// call case 4: self request
  params[0] = *var_recurse;
  partcv[0] = 1;
  Object call5507 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5506);
// compiled call node returning call5507 (depth = 8)
  partcv[0] = 0;
  Object call5508 = callmethod(call5507, "not",
    1, partcv, params);
  gc_frame_end(callframe5505);
// compiled call node returning call5508 (depth = 7)
// compiled member node returning call5508 (depth = 6)
  Object if5504 = done;
  if (istrue(call5508)) {
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5509 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5511 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5510);
// compiled call node returning call5511 (depth = 10)
// compiled member node returning call5511 (depth = 9)
  partcv[0] = 0;
  Object call5512 = callmethod(call5511, "new",
    1, partcv, params);
  gc_frame_end(callframe5509);
// compiled call node returning call5512 (depth = 8)
// compiled member node returning call5512 (depth = 7)
  *var_suggestion = call5512;
  if (call5512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5513 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5514 == NULL) {
    strlit5514 = alloc_String("rparen");
    gc_root(strlit5514);
  }
// compiled string node returning strlit5514 (depth = 8)
  gc_frame_newslot(strlit5514);
// call case 4: self request
  params[0] = strlit5514;
  partcv[0] = 1;
  Object call5515 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5513);
// compiled call node returning call5515 (depth = 7)
  *var_nextTok = call5515;
  if (call5515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5517 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5517 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5519 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5519 (depth = 7)
  Object if5516 = done;
  if (istrue(opresult5519)) {
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5520 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5522 == NULL) {
    strlit5522 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5522);
  }
// compiled string node returning strlit5522 (depth = 9)
  int op_slot_right_5521 = gc_frame_newslot(strlit5522);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5524 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5526 == NULL) {
    strlit5526 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5526);
  }
// compiled string node returning strlit5526 (depth = 10)
  int op_slot_left_5524 = gc_frame_newslot(strlit5526);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5527 = callmethod(strlit5526, "++", 1, partcv, params);
// compiled op node returning opresult5527 (depth = 9)
  int op_slot_left_5521 = gc_frame_newslot(opresult5527);
  params[0] = strlit5522;
  partcv[0] = 1;
  Object opresult5528 = callmethod(opresult5527, "++", 1, partcv, params);
// compiled op node returning opresult5528 (depth = 8)
  gc_frame_newslot(opresult5528);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5528;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5529 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5520);
// compiled call node returning call5529 (depth = 7)
    gc_frame_newslot(call5529);
    if5516 = call5529;
  } else {
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5530 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5531 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5532 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5531);
// compiled call node returning call5532 (depth = 9)
// compiled member node returning call5532 (depth = 8)
  gc_frame_newslot(call5532);
// starting to compile identifier node (depth = 8)
  Object bool5533 = alloc_Boolean(1);
// compiled identifier node returning bool5533 (depth = 8)
  gc_frame_newslot(bool5533);
// starting to compile identifier node (depth = 8)
  Object bool5534 = alloc_Boolean(0);
// compiled identifier node returning bool5534 (depth = 8)
  gc_frame_newslot(bool5534);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5536 == NULL) {
    strlit5536 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5536);
  }
// compiled string node returning strlit5536 (depth = 9)
  int op_slot_right_5535 = gc_frame_newslot(strlit5536);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5538 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5540 == NULL) {
    strlit5540 = alloc_String("""\xc2""""\xab""");
    gc_root(strlit5540);
  }
// compiled string node returning strlit5540 (depth = 10)
  int op_slot_left_5538 = gc_frame_newslot(strlit5540);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5541 = callmethod(strlit5540, "++", 1, partcv, params);
// compiled op node returning opresult5541 (depth = 9)
  int op_slot_left_5535 = gc_frame_newslot(opresult5541);
  params[0] = strlit5536;
  partcv[0] = 1;
  Object opresult5542 = callmethod(opresult5541, "++", 1, partcv, params);
// compiled op node returning opresult5542 (depth = 8)
  gc_frame_newslot(opresult5542);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5532;
  params[2] = bool5533;
  params[3] = bool5534;
  params[4] = opresult5542;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5543 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5530);
// compiled call node returning call5543 (depth = 7)
    gc_frame_newslot(call5543);
    if5516 = call5543;
  }
// compiled if node returning if5516 (depth = 6)
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5544 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5546 == NULL) {
    strlit5546 = alloc_String(".");
    gc_root(strlit5546);
  }
// compiled string node returning strlit5546 (depth = 8)
  int op_slot_right_5545 = gc_frame_newslot(strlit5546);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5548 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5550 == NULL) {
    strlit5550 = alloc_String("Parentheses must contain a valid ");
    gc_root(strlit5550);
  }
// compiled string node returning strlit5550 (depth = 9)
  int op_slot_left_5548 = gc_frame_newslot(strlit5550);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5551 = callmethod(strlit5550, "++", 1, partcv, params);
// compiled op node returning opresult5551 (depth = 8)
  int op_slot_left_5545 = gc_frame_newslot(opresult5551);
  params[0] = strlit5546;
  partcv[0] = 1;
  Object opresult5552 = callmethod(opresult5551, "++", 1, partcv, params);
// compiled op node returning opresult5552 (depth = 7)
  gc_frame_newslot(opresult5552);
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5553 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5554 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5553);
// compiled call node returning call5554 (depth = 8)
// compiled member node returning call5554 (depth = 7)
  gc_frame_newslot(call5554);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5555 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5556 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5555);
// compiled call node returning call5556 (depth = 8)
// compiled member node returning call5556 (depth = 7)
  gc_frame_newslot(call5556);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5552;
  params[1] = call5554;
  params[2] = call5556;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5557 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5544);
// compiled call node returning call5557 (depth = 6)
    gc_frame_newslot(call5557);
    if5504 = call5557;
  } else {
  }
// compiled if node returning if5504 (depth = 5)
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1774
  setline(1774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5560 == NULL) {
    strlit5560 = alloc_String("rparen");
    gc_root(strlit5560);
  }
// compiled string node returning strlit5560 (depth = 7)
  int op_slot_right_5559 = gc_frame_newslot(strlit5560);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5563 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5562);
// compiled call node returning call5563 (depth = 8)
// compiled member node returning call5563 (depth = 7)
  int op_slot_left_5559 = gc_frame_newslot(call5563);
  params[0] = strlit5560;
  partcv[0] = 1;
  Object opresult5564 = callmethod(call5563, "!=", 1, partcv, params);
// compiled op node returning opresult5564 (depth = 6)
  Object if5558 = done;
  if (istrue(opresult5564)) {
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5565 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5566 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5565);
// compiled call node returning call5566 (depth = 7)
// compiled member node returning call5566 (depth = 6)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5567 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5569 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5568);
// compiled call node returning call5569 (depth = 10)
// compiled member node returning call5569 (depth = 9)
  partcv[0] = 0;
  Object call5570 = callmethod(call5569, "new",
    1, partcv, params);
  gc_frame_end(callframe5567);
// compiled call node returning call5570 (depth = 8)
// compiled member node returning call5570 (depth = 7)
  *var_suggestion = call5570;
  if (call5570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5571 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5572 == NULL) {
    strlit5572 = alloc_String(")");
    gc_root(strlit5572);
  }
// compiled string node returning strlit5572 (depth = 7)
  gc_frame_newslot(strlit5572);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit5572;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5573 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5571);
// compiled call node returning call5573 (depth = 6)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5574 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5575 == NULL) {
    strlit5575 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5575);
  }
// compiled string node returning strlit5575 (depth = 7)
  gc_frame_newslot(strlit5575);
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5577 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5576);
// compiled call node returning call5577 (depth = 8)
// compiled member node returning call5577 (depth = 7)
  gc_frame_newslot(call5577);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5580 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5579);
// compiled call node returning call5580 (depth = 9)
// compiled member node returning call5580 (depth = 8)
  int op_slot_right_5578 = gc_frame_newslot(call5580);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5582 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5583 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5582);
// compiled call node returning call5583 (depth = 9)
// compiled member node returning call5583 (depth = 8)
  int op_slot_left_5578 = gc_frame_newslot(call5583);
  params[0] = call5580;
  partcv[0] = 1;
  Object sum5584 = callmethod(call5583, "+", 1, partcv, params);
// compiled op node returning sum5584 (depth = 7)
  gc_frame_newslot(sum5584);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit5575;
  params[1] = call5577;
  params[2] = sum5584;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5585 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5574);
// compiled call node returning call5585 (depth = 6)
    gc_frame_newslot(call5585);
    if5558 = call5585;
  } else {
  }
// compiled if node returning if5558 (depth = 5)
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5586 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5587 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5586);
// compiled call node returning call5587 (depth = 6)
// compiled member node returning call5587 (depth = 5)
    gc_frame_newslot(call5587);
    if5498 = call5587;
  } else {
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5589 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5590 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5591 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5590);
// compiled call node returning call5591 (depth = 8)
// compiled member node returning call5591 (depth = 7)
  partcv[0] = 0;
  Object call5592 = callmethod(call5591, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe5589);
// compiled call node returning call5592 (depth = 6)
  Object if5588 = done;
  if (istrue(call5592)) {
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array5593 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5593 (depth = 7)
  *var_suggestions = array5593;
  if (array5593 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5594 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5596 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5595);
// compiled call node returning call5596 (depth = 10)
// compiled member node returning call5596 (depth = 9)
  partcv[0] = 0;
  Object call5597 = callmethod(call5596, "new",
    1, partcv, params);
  gc_frame_end(callframe5594);
// compiled call node returning call5597 (depth = 8)
// compiled member node returning call5597 (depth = 7)
  *var_suggestion = call5597;
  if (call5597 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5598 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool5599 = alloc_Boolean(1);
// compiled identifier node returning bool5599 (depth = 7)
  gc_frame_newslot(bool5599);
// starting to compile identifier node (depth = 7)
  Object bool5600 = alloc_Boolean(0);
// compiled identifier node returning bool5600 (depth = 7)
  gc_frame_newslot(bool5600);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = bool5599;
  params[2] = bool5600;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5601 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5598);
// compiled call node returning call5601 (depth = 6)
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5602 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5603 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5602);
// compiled call node returning call5603 (depth = 6)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5604 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5605 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5606 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5605);
// compiled call node returning call5606 (depth = 10)
// compiled member node returning call5606 (depth = 9)
  partcv[0] = 0;
  Object call5607 = callmethod(call5606, "new",
    1, partcv, params);
  gc_frame_end(callframe5604);
// compiled call node returning call5607 (depth = 8)
// compiled member node returning call5607 (depth = 7)
  *var_suggestion = call5607;
  if (call5607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5609 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5611 == NULL) {
    strlit5611 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5611);
  }
// compiled string node returning strlit5611 (depth = 8)
  int op_slot_right_5610 = gc_frame_newslot(strlit5611);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_name (depth = 9)
  int op_slot_right_5613 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 9)
  if (strlit5615 == NULL) {
    strlit5615 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5615);
  }
// compiled string node returning strlit5615 (depth = 9)
  int op_slot_left_5613 = gc_frame_newslot(strlit5615);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5616 = callmethod(strlit5615, "++", 1, partcv, params);
// compiled op node returning opresult5616 (depth = 8)
  int op_slot_left_5610 = gc_frame_newslot(opresult5616);
  params[0] = strlit5611;
  partcv[0] = 1;
  Object opresult5617 = callmethod(opresult5616, "++", 1, partcv, params);
// compiled op node returning opresult5617 (depth = 7)
  gc_frame_newslot(opresult5617);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5617;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5618 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5609);
// compiled call node returning call5618 (depth = 6)
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5619 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5620 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5619);
// compiled call node returning call5620 (depth = 6)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5621 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5623 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5622);
// compiled call node returning call5623 (depth = 10)
// compiled member node returning call5623 (depth = 9)
  partcv[0] = 0;
  Object call5624 = callmethod(call5623, "new",
    1, partcv, params);
  gc_frame_end(callframe5621);
// compiled call node returning call5624 (depth = 8)
// compiled member node returning call5624 (depth = 7)
  *var_suggestion = call5624;
  if (call5624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5626 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5628 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call5629 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5628);
// compiled call node returning call5629 (depth = 10)
// compiled member node returning call5629 (depth = 9)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5630 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call5631 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5630);
// compiled call node returning call5631 (depth = 10)
// compiled member node returning call5631 (depth = 9)
  params[0] = call5631;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5632 = callmethod(call5629, "[]", 1, partcv, params);
// compiled index node returning idxres5632 (depth = 8)
  int op_slot_right_5627 = gc_frame_newslot(idxres5632);
// starting to compile string node (depth = 8)
  if (strlit5634 == NULL) {
    strlit5634 = alloc_String(" ");
    gc_root(strlit5634);
  }
// compiled string node returning strlit5634 (depth = 8)
  int op_slot_left_5627 = gc_frame_newslot(strlit5634);
  params[0] = idxres5632;
  partcv[0] = 1;
  Object opresult5635 = callmethod(strlit5634, "++", 1, partcv, params);
// compiled op node returning opresult5635 (depth = 7)
  gc_frame_newslot(opresult5635);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = opresult5635;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5636 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5626);
// compiled call node returning call5636 (depth = 6)
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5637 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call5639 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5638);
// compiled call node returning call5639 (depth = 8)
// compiled member node returning call5639 (depth = 7)
  gc_frame_newslot(call5639);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = call5639;
  partcv[0] = 1;
  Object call5640 = callmethod(*var_suggestion, "deleteLine",
    1, partcv, params);
  gc_frame_end(callframe5637);
// compiled call node returning call5640 (depth = 6)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5641 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5642 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5641);
// compiled call node returning call5642 (depth = 6)
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5643 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5645 == NULL) {
    strlit5645 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5645);
  }
// compiled string node returning strlit5645 (depth = 8)
  int op_slot_right_5644 = gc_frame_newslot(strlit5645);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5648 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5649 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5648);
// compiled call node returning call5649 (depth = 10)
// compiled member node returning call5649 (depth = 9)
  int op_slot_right_5647 = gc_frame_newslot(call5649);
// starting to compile string node (depth = 9)
  if (strlit5651 == NULL) {
    strlit5651 = alloc_String("A valid expression must follow '");
    gc_root(strlit5651);
  }
// compiled string node returning strlit5651 (depth = 9)
  int op_slot_left_5647 = gc_frame_newslot(strlit5651);
  params[0] = call5649;
  partcv[0] = 1;
  Object opresult5652 = callmethod(strlit5651, "++", 1, partcv, params);
// compiled op node returning opresult5652 (depth = 8)
  int op_slot_left_5644 = gc_frame_newslot(opresult5652);
  params[0] = strlit5645;
  partcv[0] = 1;
  Object opresult5653 = callmethod(opresult5652, "++", 1, partcv, params);
// compiled op node returning opresult5653 (depth = 7)
  gc_frame_newslot(opresult5653);
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5654 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5655 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5654);
// compiled call node returning call5655 (depth = 8)
// compiled member node returning call5655 (depth = 7)
  gc_frame_newslot(call5655);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5657 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5658 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5657);
// compiled call node returning call5658 (depth = 9)
// compiled member node returning call5658 (depth = 8)
  int op_slot_right_5656 = gc_frame_newslot(call5658);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5661 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5660);
// compiled call node returning call5661 (depth = 9)
// compiled member node returning call5661 (depth = 8)
  int op_slot_left_5656 = gc_frame_newslot(call5661);
  params[0] = call5658;
  partcv[0] = 1;
  Object sum5662 = callmethod(call5661, "+", 1, partcv, params);
// compiled op node returning sum5662 (depth = 7)
  gc_frame_newslot(sum5662);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5653;
  params[1] = call5655;
  params[2] = sum5662;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5663 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5643);
// compiled call node returning call5663 (depth = 6)
    gc_frame_newslot(call5663);
    if5588 = call5663;
  } else {
  }
// compiled if node returning if5588 (depth = 5)
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5665 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe5666 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block5667 = alloc_Block(NULL, NULL, "parser", 1798);
  gc_frame_newslot(block5667);
// method _apply
  block_savedest(block5667);
  Object closure5668 = createclosure(1, "_apply");
  setclosureframe(closure5668, stackframe);
  addtoclosure(closure5668, selfslot);
  struct UserObject *uo5668 = (struct UserObject*)block5667;
  uo5668->data[0] = (Object)closure5668;
  Method *meth_meth_parser__apply5668 = addmethod2pos(block5667, "_apply", &meth_parser__apply5668, 0);
  int argcv_meth_parser__apply5668[] = {0};
  meth_meth_parser__apply5668->type = alloc_MethodType(1, argcv_meth_parser__apply5668);
  meth_meth_parser__apply5668->definitionModule = modulename;
  meth_meth_parser__apply5668->definitionLine = 1798;
// compiled block node returning block5667 (depth = 9)
  gc_frame_newslot(block5667);
// call case 4: self request
  params[0] = block5667;
  partcv[0] = 1;
  Object call5672 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5666);
// compiled call node returning call5672 (depth = 8)
  partcv[0] = 0;
  Object call5673 = callmethod(call5672, "not",
    1, partcv, params);
  gc_frame_end(callframe5665);
// compiled call node returning call5673 (depth = 7)
// compiled member node returning call5673 (depth = 6)
  Object if5664 = done;
  if (istrue(call5673)) {
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array5674 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5674 (depth = 7)
  *var_suggestions = array5674;
  if (array5674 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5675 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5676 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5677 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5676);
// compiled call node returning call5677 (depth = 10)
// compiled member node returning call5677 (depth = 9)
  partcv[0] = 0;
  Object call5678 = callmethod(call5677, "new",
    1, partcv, params);
  gc_frame_end(callframe5675);
// compiled call node returning call5678 (depth = 8)
// compiled member node returning call5678 (depth = 7)
  *var_suggestion = call5678;
  if (call5678 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5679 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5680 == NULL) {
    strlit5680 = alloc_String("comma");
    gc_root(strlit5680);
  }
// compiled string node returning strlit5680 (depth = 8)
  gc_frame_newslot(strlit5680);
// starting to compile string node (depth = 8)
  if (strlit5681 == NULL) {
    strlit5681 = alloc_String("rparen");
    gc_root(strlit5681);
  }
// compiled string node returning strlit5681 (depth = 8)
  gc_frame_newslot(strlit5681);
// starting to compile string node (depth = 8)
  if (strlit5682 == NULL) {
    strlit5682 = alloc_String("rsquare");
    gc_root(strlit5682);
  }
// compiled string node returning strlit5682 (depth = 8)
  gc_frame_newslot(strlit5682);
// starting to compile string node (depth = 8)
  if (strlit5683 == NULL) {
    strlit5683 = alloc_String("rbrace");
    gc_root(strlit5683);
  }
// compiled string node returning strlit5683 (depth = 8)
  gc_frame_newslot(strlit5683);
// call case 4: self request
  params[0] = strlit5680;
  params[1] = strlit5681;
  params[2] = strlit5682;
  params[3] = strlit5683;
  partcv[0] = 4;
  Object call5684 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5679);
// compiled call node returning call5684 (depth = 7)
  *var_nextTok = call5684;
  if (call5684 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_5686 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_5686 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5688 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult5688 (depth = 7)
  Object if5685 = done;
  if (istrue(opresult5688)) {
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5689 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5691 == NULL) {
    strlit5691 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5691);
  }
// compiled string node returning strlit5691 (depth = 9)
  int op_slot_right_5690 = gc_frame_newslot(strlit5691);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5693 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5695 == NULL) {
    strlit5695 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5695);
  }
// compiled string node returning strlit5695 (depth = 10)
  int op_slot_left_5693 = gc_frame_newslot(strlit5695);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5696 = callmethod(strlit5695, "++", 1, partcv, params);
// compiled op node returning opresult5696 (depth = 9)
  int op_slot_left_5690 = gc_frame_newslot(opresult5696);
  params[0] = strlit5691;
  partcv[0] = 1;
  Object opresult5697 = callmethod(opresult5696, "++", 1, partcv, params);
// compiled op node returning opresult5697 (depth = 8)
  gc_frame_newslot(opresult5697);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = opresult5697;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5698 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5689);
// compiled call node returning call5698 (depth = 7)
    gc_frame_newslot(call5698);
    if5685 = call5698;
  } else {
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe5699 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5700 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call5701 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5700);
// compiled call node returning call5701 (depth = 9)
// compiled member node returning call5701 (depth = 8)
  gc_frame_newslot(call5701);
// starting to compile identifier node (depth = 8)
  Object bool5702 = alloc_Boolean(1);
// compiled identifier node returning bool5702 (depth = 8)
  gc_frame_newslot(bool5702);
// starting to compile identifier node (depth = 8)
  Object bool5703 = alloc_Boolean(0);
// compiled identifier node returning bool5703 (depth = 8)
  gc_frame_newslot(bool5703);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5705 == NULL) {
    strlit5705 = alloc_String("""\xc2""""\xbb""");
    gc_root(strlit5705);
  }
// compiled string node returning strlit5705 (depth = 9)
  int op_slot_right_5704 = gc_frame_newslot(strlit5705);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_name (depth = 10)
  int op_slot_right_5707 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 10)
  if (strlit5709 == NULL) {
    strlit5709 = alloc_String(" ""\xc2""""\xab""");
    gc_root(strlit5709);
  }
// compiled string node returning strlit5709 (depth = 10)
  int op_slot_left_5707 = gc_frame_newslot(strlit5709);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5710 = callmethod(strlit5709, "++", 1, partcv, params);
// compiled op node returning opresult5710 (depth = 9)
  int op_slot_left_5704 = gc_frame_newslot(opresult5710);
  params[0] = strlit5705;
  partcv[0] = 1;
  Object opresult5711 = callmethod(opresult5710, "++", 1, partcv, params);
// compiled op node returning opresult5711 (depth = 8)
  gc_frame_newslot(opresult5711);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call5701;
  params[2] = bool5702;
  params[3] = bool5703;
  params[4] = opresult5711;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5712 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5699);
// compiled call node returning call5712 (depth = 7)
    gc_frame_newslot(call5712);
    if5685 = call5712;
  }
// compiled if node returning if5685 (depth = 6)
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5713 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5714 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5713);
// compiled call node returning call5714 (depth = 6)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5715 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call5717 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5716);
// compiled call node returning call5717 (depth = 10)
// compiled member node returning call5717 (depth = 9)
  partcv[0] = 0;
  Object call5718 = callmethod(call5717, "new",
    1, partcv, params);
  gc_frame_end(callframe5715);
// compiled call node returning call5718 (depth = 8)
// compiled member node returning call5718 (depth = 7)
  *var_suggestion = call5718;
  if (call5718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5720 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5721 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call5722 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5721);
// compiled call node returning call5722 (depth = 8)
// compiled member node returning call5722 (depth = 7)
  gc_frame_newslot(call5722);
// starting to compile identifier node (depth = 7)
  Object bool5723 = alloc_Boolean(1);
// compiled identifier node returning bool5723 (depth = 7)
  gc_frame_newslot(bool5723);
// starting to compile identifier node (depth = 7)
  Object bool5724 = alloc_Boolean(0);
// compiled identifier node returning bool5724 (depth = 7)
  gc_frame_newslot(bool5724);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call5722;
  params[2] = bool5723;
  params[3] = bool5724;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5725 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5720);
// compiled call node returning call5725 (depth = 6)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5726 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5727 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5726);
// compiled call node returning call5727 (depth = 6)
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5728 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5730 == NULL) {
    strlit5730 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5730);
  }
// compiled string node returning strlit5730 (depth = 8)
  int op_slot_right_5729 = gc_frame_newslot(strlit5730);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call5734 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5733);
// compiled call node returning call5734 (depth = 10)
// compiled member node returning call5734 (depth = 9)
  int op_slot_right_5732 = gc_frame_newslot(call5734);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit5737 == NULL) {
    strlit5737 = alloc_String(" must follow '");
    gc_root(strlit5737);
  }
// compiled string node returning strlit5737 (depth = 10)
  int op_slot_right_5736 = gc_frame_newslot(strlit5737);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_name (depth = 11)
  int op_slot_right_5739 = gc_frame_newslot(*var_name);
// starting to compile string node (depth = 11)
  if (strlit5741 == NULL) {
    strlit5741 = alloc_String("A valid ");
    gc_root(strlit5741);
  }
// compiled string node returning strlit5741 (depth = 11)
  int op_slot_left_5739 = gc_frame_newslot(strlit5741);
  params[0] = *var_name;
  partcv[0] = 1;
  Object opresult5742 = callmethod(strlit5741, "++", 1, partcv, params);
// compiled op node returning opresult5742 (depth = 10)
  int op_slot_left_5736 = gc_frame_newslot(opresult5742);
  params[0] = strlit5737;
  partcv[0] = 1;
  Object opresult5743 = callmethod(opresult5742, "++", 1, partcv, params);
// compiled op node returning opresult5743 (depth = 9)
  int op_slot_left_5732 = gc_frame_newslot(opresult5743);
  params[0] = call5734;
  partcv[0] = 1;
  Object opresult5744 = callmethod(opresult5743, "++", 1, partcv, params);
// compiled op node returning opresult5744 (depth = 8)
  int op_slot_left_5729 = gc_frame_newslot(opresult5744);
  params[0] = strlit5730;
  partcv[0] = 1;
  Object opresult5745 = callmethod(opresult5744, "++", 1, partcv, params);
// compiled op node returning opresult5745 (depth = 7)
  gc_frame_newslot(opresult5745);
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5746 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call5747 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5746);
// compiled call node returning call5747 (depth = 8)
// compiled member node returning call5747 (depth = 7)
  gc_frame_newslot(call5747);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5750 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5749);
// compiled call node returning call5750 (depth = 9)
// compiled member node returning call5750 (depth = 8)
  int op_slot_right_5748 = gc_frame_newslot(call5750);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5752 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call5753 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5752);
// compiled call node returning call5753 (depth = 9)
// compiled member node returning call5753 (depth = 8)
  int op_slot_left_5748 = gc_frame_newslot(call5753);
  params[0] = call5750;
  partcv[0] = 1;
  Object sum5754 = callmethod(call5753, "+", 1, partcv, params);
// compiled op node returning sum5754 (depth = 7)
  gc_frame_newslot(sum5754);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = opresult5745;
  params[1] = call5747;
  params[2] = sum5754;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5755 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5728);
// compiled call node returning call5755 (depth = 6)
    gc_frame_newslot(call5755);
    if5664 = call5755;
  } else {
  }
// compiled if node returning if5664 (depth = 5)
    gc_frame_newslot(if5664);
    if5498 = if5664;
  }
// compiled if node returning if5498 (depth = 4)
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5756 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5757 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5756);
// compiled call node returning call5757 (depth = 4)
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5758 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptBlocks (depth = 5)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5759 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5758);
// compiled call node returning call5759 (depth = 4)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5761 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5760);
// compiled call node returning call5761 (depth = 5)
// compiled member node returning call5761 (depth = 4)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call5763 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5762);
// compiled call node returning call5763 (depth = 6)
// compiled member node returning call5763 (depth = 5)
  *var_tmp = call5763;
  if (call5763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5765 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5766 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5765);
// compiled call node returning call5766 (depth = 4)
  gc_frame_end(frame);
  return call5766;
}
Object meth_parser__apply5771(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5773 = alloc_Float64(0);
// compiled num node returning num5773 (depth = 5)
  int op_slot_right_5772 = gc_frame_newslot(num5773);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5776 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5775);
// compiled call node returning call5776 (depth = 6)
// compiled member node returning call5776 (depth = 5)
  int op_slot_left_5772 = gc_frame_newslot(call5776);
  params[0] = num5773;
  partcv[0] = 1;
  Object opresult5777 = callmethod(call5776, ">", 1, partcv, params);
// compiled op node returning opresult5777 (depth = 4)
  gc_frame_end(frame);
  return opresult5777;
}
Object meth_parser__apply5780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5781 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ops (depth = 7)
  partcv[0] = 0;
  Object call5782 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5781);
// compiled call node returning call5782 (depth = 6)
// compiled member node returning call5782 (depth = 5)
  *var_o = call5782;
  if (call5782 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5785 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5784);
// compiled call node returning call5785 (depth = 6)
// compiled member node returning call5785 (depth = 5)
  *var_tmp2 = call5785;
  if (call5785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5787 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_terms (depth = 7)
  partcv[0] = 0;
  Object call5788 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5787);
// compiled call node returning call5788 (depth = 6)
// compiled member node returning call5788 (depth = 5)
  *var_tmp = call5788;
  if (call5788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5790 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp2 (depth = 6)
  gc_frame_newslot(*var_tmp2);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5791 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5792 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5791);
// compiled call node returning call5792 (depth = 7)
// compiled member node returning call5792 (depth = 6)
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5793 = callmethod(call5792, "new",
    1, partcv, params);
  gc_frame_end(callframe5790);
// compiled call node returning call5793 (depth = 5)
  *var_tmp = call5793;
  if (call5793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5795 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tmp (depth = 5)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5796 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5795);
// compiled call node returning call5796 (depth = 4)
  gc_frame_end(frame);
  return call5796;
}
Object meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(14, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest()recursingWith()blocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method expressionrest()recursingWith()blocks");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method expressionrest()recursingWith()blocks");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for expressionrest()recursingWith()blocks (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for expressionrest");
  Object *var_recurse = &(stackframe->slots[1]);
  *var_recurse = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    gracedie("wrong number of arguments for recursingWith");
  Object *var_acceptBlocks = &(stackframe->slots[2]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    gracedie("wrong number of arguments for blocks");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_terms = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "terms");
  Object *var_ops = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "ops");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_o2 = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o2");
  Object *var_tmp2 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tmp2");
  Object *var_tmp = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tmp");
  Object *var_prec = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "prec");
  Object *var_allarith = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "allarith");
  Object *var_opcount = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "opcount");
  Object *var_opdtype = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "opdtype");
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5324 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5324 (depth = 3)
  *var_terms = array5324;
  if (array5324 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5325 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5325 (depth = 3)
  *var_ops = array5325;
  if (array5325 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_o2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_tmp2 = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5326 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5327 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5326);
// compiled call node returning call5327 (depth = 4)
// compiled member node returning call5327 (depth = 3)
  *var_tmp = call5327;
  if (call5327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5328 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_terms (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5329 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5328);
// compiled call node returning call5329 (depth = 2)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_prec = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5330 = alloc_Boolean(1);
// compiled identifier node returning bool5330 (depth = 3)
  *var_allarith = bool5330;
  if (bool5330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num5331 = alloc_Float64(0);
// compiled num node returning num5331 (depth = 3)
  *var_opcount = num5331;
  if (num5331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5332 == NULL) {
    strlit5332 = alloc_String("");
    gc_root(strlit5332);
  }
// compiled string node returning strlit5332 (depth = 3)
  *var_opdtype = strlit5332;
  if (strlit5332 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5333 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5334 = alloc_Block(NULL, NULL, "parser", 1716);
  gc_frame_newslot(block5334);
// method _apply
  block_savedest(block5334);
  Object closure5335 = createclosure(3, "_apply");
  setclosureframe(closure5335, stackframe);
  addtoclosure(closure5335, var_sym);
  addtoclosure(closure5335, var_statementToken);
  addtoclosure(closure5335, selfslot);
  struct UserObject *uo5335 = (struct UserObject*)block5334;
  uo5335->data[0] = (Object)closure5335;
  Method *meth_meth_parser__apply5335 = addmethod2pos(block5334, "_apply", &meth_parser__apply5335, 0);
  int argcv_meth_parser__apply5335[] = {0};
  meth_meth_parser__apply5335->type = alloc_MethodType(1, argcv_meth_parser__apply5335);
  meth_meth_parser__apply5335->definitionModule = modulename;
  meth_meth_parser__apply5335->definitionLine = 1710;
// compiled block node returning block5334 (depth = 3)
  gc_frame_newslot(block5334);
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5351 = alloc_Block(NULL, NULL, "parser", 1717);
  gc_frame_newslot(block5351);
// method _apply
  block_savedest(block5351);
  Object closure5352 = createclosure(20, "_apply");
  setclosureframe(closure5352, stackframe);
  addtoclosure(closure5352, var_opcount);
  addtoclosure(closure5352, var_sym);
  addtoclosure(closure5352, var_o);
  addtoclosure(closure5352, var_prec);
  addtoclosure(closure5352, var_allarith);
  addtoclosure(closure5352, var_opdtype);
  addtoclosure(closure5352, var_errormessages);
  addtoclosure(closure5352, var_lastToken);
  addtoclosure(closure5352, var_ops);
  addtoclosure(closure5352, var_o2);
  addtoclosure(closure5352, var_terms);
  addtoclosure(closure5352, var_tmp2);
  addtoclosure(closure5352, var_tmp);
  addtoclosure(closure5352, var_ast);
  addtoclosure(closure5352, var_recurse);
  addtoclosure(closure5352, var_name);
  addtoclosure(closure5352, var_util);
  addtoclosure(closure5352, var_acceptBlocks);
  addtoclosure(closure5352, var_values);
  addtoclosure(closure5352, selfslot);
  struct UserObject *uo5352 = (struct UserObject*)block5351;
  uo5352->data[0] = (Object)closure5352;
  Method *meth_meth_parser__apply5352 = addmethod2pos(block5351, "_apply", &meth_parser__apply5352, 0);
  int argcv_meth_parser__apply5352[] = {0};
  meth_meth_parser__apply5352->type = alloc_MethodType(1, argcv_meth_parser__apply5352);
  meth_meth_parser__apply5352->definitionModule = modulename;
  meth_meth_parser__apply5352->definitionLine = 1717;
// compiled block node returning block5351 (depth = 3)
  gc_frame_newslot(block5351);
// call case 5: prelude request
  params[0] = block5334;
  params[1] = block5351;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5768 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5333);
// compiled call node returning call5768 (depth = 2)
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5769 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5770 = alloc_Block(NULL, NULL, "parser", 1826);
  gc_frame_newslot(block5770);
// method _apply
  block_savedest(block5770);
  Object closure5771 = createclosure(2, "_apply");
  setclosureframe(closure5771, stackframe);
  addtoclosure(closure5771, var_ops);
  addtoclosure(closure5771, selfslot);
  struct UserObject *uo5771 = (struct UserObject*)block5770;
  uo5771->data[0] = (Object)closure5771;
  Method *meth_meth_parser__apply5771 = addmethod2pos(block5770, "_apply", &meth_parser__apply5771, 0);
  int argcv_meth_parser__apply5771[] = {0};
  meth_meth_parser__apply5771->type = alloc_MethodType(1, argcv_meth_parser__apply5771);
  meth_meth_parser__apply5771->definitionModule = modulename;
  meth_meth_parser__apply5771->definitionLine = 1823;
// compiled block node returning block5770 (depth = 3)
  gc_frame_newslot(block5770);
// starting to compile block node (depth = 3)
  Object block5779 = alloc_Block(NULL, NULL, "parser", 1826);
  gc_frame_newslot(block5779);
// method _apply
  block_savedest(block5779);
  Object closure5780 = createclosure(7, "_apply");
  setclosureframe(closure5780, stackframe);
  addtoclosure(closure5780, var_ops);
  addtoclosure(closure5780, var_o);
  addtoclosure(closure5780, var_terms);
  addtoclosure(closure5780, var_tmp2);
  addtoclosure(closure5780, var_tmp);
  addtoclosure(closure5780, var_ast);
  addtoclosure(closure5780, selfslot);
  struct UserObject *uo5780 = (struct UserObject*)block5779;
  uo5780->data[0] = (Object)closure5780;
  Method *meth_meth_parser__apply5780 = addmethod2pos(block5779, "_apply", &meth_parser__apply5780, 0);
  int argcv_meth_parser__apply5780[] = {0};
  meth_meth_parser__apply5780->type = alloc_MethodType(1, argcv_meth_parser__apply5780);
  meth_meth_parser__apply5780->definitionModule = modulename;
  meth_meth_parser__apply5780->definitionLine = 1826;
// compiled block node returning block5779 (depth = 3)
  gc_frame_newslot(block5779);
// call case 5: prelude request
  params[0] = block5770;
  params[1] = block5779;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5798 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5769);
// compiled call node returning call5798 (depth = 2)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5799 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_terms (depth = 5)
  partcv[0] = 0;
  Object call5800 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5799);
// compiled call node returning call5800 (depth = 4)
// compiled member node returning call5800 (depth = 3)
  *var_tmp = call5800;
  if (call5800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5802 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tmp (depth = 3)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5803 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5802);
// compiled call node returning call5803 (depth = 2)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5806 = alloc_Float64(0);
// compiled num node returning num5806 (depth = 4)
  int op_slot_right_5805 = gc_frame_newslot(num5806);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5808 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_terms (depth = 6)
  partcv[0] = 0;
  Object call5809 = callmethod(*var_terms, "size",
    1, partcv, params);
  gc_frame_end(callframe5808);
// compiled call node returning call5809 (depth = 5)
// compiled member node returning call5809 (depth = 4)
  int op_slot_left_5805 = gc_frame_newslot(call5809);
  params[0] = num5806;
  partcv[0] = 1;
  Object opresult5810 = callmethod(call5809, ">", 1, partcv, params);
// compiled op node returning opresult5810 (depth = 3)
  Object if5804 = done;
  if (istrue(opresult5810)) {
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5811 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5812 == NULL) {
    strlit5812 = alloc_String("Values left on term stack.");
    gc_root(strlit5812);
  }
// compiled string node returning strlit5812 (depth = 4)
  gc_frame_newslot(strlit5812);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5814 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5813);
// compiled call node returning call5814 (depth = 5)
// compiled member node returning call5814 (depth = 4)
  gc_frame_newslot(call5814);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5815 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5816 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5815);
// compiled call node returning call5816 (depth = 5)
// compiled member node returning call5816 (depth = 4)
  gc_frame_newslot(call5816);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit5812;
  params[1] = call5814;
  params[2] = call5816;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5817 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe5811);
// compiled call node returning call5817 (depth = 3)
    gc_frame_newslot(call5817);
    if5804 = call5817;
  } else {
  }
// compiled if node returning if5804 (depth = 2)
  gc_frame_end(frame);
  return if5804;
}
Object meth_parser_dotrest5818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method dotrest");
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for dotrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lookuptarget = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lookuptarget");
  Object *var_dro = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "dro");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_suggestion = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion");
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5820 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5821 == NULL) {
    strlit5821 = alloc_String("dot");
    gc_root(strlit5821);
  }
// compiled string node returning strlit5821 (depth = 4)
  gc_frame_newslot(strlit5821);
// call case 4: self request
  params[0] = strlit5821;
  partcv[0] = 1;
  Object call5822 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5820);
// compiled call node returning call5822 (depth = 3)
  Object if5819 = done;
  if (istrue(call5822)) {
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5823 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5825 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5824);
// compiled call node returning call5825 (depth = 5)
// compiled member node returning call5825 (depth = 4)
  gc_frame_newslot(call5825);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5826 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call5827 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5826);
// compiled call node returning call5827 (depth = 5)
// compiled member node returning call5827 (depth = 4)
  gc_frame_newslot(call5827);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call5825;
  params[1] = call5827;
  partcv[0] = 2;
  Object call5828 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5823);
// compiled call node returning call5828 (depth = 3)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5829 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5830 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5829);
// compiled call node returning call5830 (depth = 5)
// compiled member node returning call5830 (depth = 4)
  *var_lookuptarget = call5830;
  if (call5830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5831 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5832 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5831);
// compiled call node returning call5832 (depth = 4)
// compiled member node returning call5832 (depth = 3)
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5834 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5835 == NULL) {
    strlit5835 = alloc_String("identifier");
    gc_root(strlit5835);
  }
// compiled string node returning strlit5835 (depth = 5)
  gc_frame_newslot(strlit5835);
// call case 4: self request
  params[0] = strlit5835;
  partcv[0] = 1;
  Object call5836 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5834);
// compiled call node returning call5836 (depth = 4)
  Object if5833 = done;
  if (istrue(call5836)) {
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5837 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5838 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5839 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5838);
// compiled call node returning call5839 (depth = 6)
// compiled member node returning call5839 (depth = 5)
  gc_frame_newslot(call5839);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5840 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5841 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5840);
// compiled call node returning call5841 (depth = 6)
// compiled member node returning call5841 (depth = 5)
  gc_frame_newslot(call5841);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_util (depth = 5)
  params[0] = call5839;
  params[1] = call5841;
  partcv[0] = 2;
  Object call5842 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5837);
// compiled call node returning call5842 (depth = 4)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5843 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5844 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call5845 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5844);
// compiled call node returning call5845 (depth = 7)
// compiled member node returning call5845 (depth = 6)
  gc_frame_newslot(call5845);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lookuptarget (depth = 6)
  gc_frame_newslot(*var_lookuptarget);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5846 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call5847 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5846);
// compiled call node returning call5847 (depth = 7)
// compiled member node returning call5847 (depth = 6)
  params[0] = call5845;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5848 = callmethod(call5847, "new",
    1, partcv, params);
  gc_frame_end(callframe5843);
// compiled call node returning call5848 (depth = 5)
  *var_dro = call5848;
  if (call5848 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5849 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dro (depth = 5)
  gc_frame_newslot(*var_dro);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5850 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5849);
// compiled call node returning call5850 (depth = 4)
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5851 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5852 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5851);
// compiled call node returning call5852 (depth = 5)
// compiled member node returning call5852 (depth = 4)
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5854 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5855 == NULL) {
    strlit5855 = alloc_String("dot");
    gc_root(strlit5855);
  }
// compiled string node returning strlit5855 (depth = 6)
  gc_frame_newslot(strlit5855);
// call case 4: self request
  params[0] = strlit5855;
  partcv[0] = 1;
  Object call5856 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5854);
// compiled call node returning call5856 (depth = 5)
  Object if5853 = done;
  if (istrue(call5856)) {
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5857 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_acceptBlocks (depth = 6)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5858 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5857);
// compiled call node returning call5858 (depth = 5)
    gc_frame_newslot(call5858);
    if5853 = call5858;
  } else {
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5861 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit5862 == NULL) {
    strlit5862 = alloc_String("lgeneric");
    gc_root(strlit5862);
  }
// compiled string node returning strlit5862 (depth = 8)
  gc_frame_newslot(strlit5862);
// call case 4: self request
  params[0] = strlit5862;
  partcv[0] = 1;
  Object call5863 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5861);
// compiled call node returning call5863 (depth = 7)
  int op_slot_right_5860 = gc_frame_newslot(call5863);
// starting to compile op node (depth = 7)
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe5866 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit5867 == NULL) {
    strlit5867 = alloc_String("lsquare");
    gc_root(strlit5867);
  }
// compiled string node returning strlit5867 (depth = 9)
  gc_frame_newslot(strlit5867);
// call case 4: self request
  params[0] = strlit5867;
  partcv[0] = 1;
  Object call5868 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5866);
// compiled call node returning call5868 (depth = 8)
  int op_slot_right_5865 = gc_frame_newslot(call5868);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5871 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit5872 == NULL) {
    strlit5872 = alloc_String("string");
    gc_root(strlit5872);
  }
// compiled string node returning strlit5872 (depth = 10)
  gc_frame_newslot(strlit5872);
// call case 4: self request
  params[0] = strlit5872;
  partcv[0] = 1;
  Object call5873 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5871);
// compiled call node returning call5873 (depth = 9)
  int op_slot_right_5870 = gc_frame_newslot(call5873);
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe5876 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit5877 == NULL) {
    strlit5877 = alloc_String("num");
    gc_root(strlit5877);
  }
// compiled string node returning strlit5877 (depth = 11)
  gc_frame_newslot(strlit5877);
// call case 4: self request
  params[0] = strlit5877;
  partcv[0] = 1;
  Object call5878 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5876);
// compiled call node returning call5878 (depth = 10)
  int op_slot_right_5875 = gc_frame_newslot(call5878);
// starting to compile op node (depth = 10)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe5882 = gc_frame_new();
// starting to compile string node (depth = 13)
  if (strlit5883 == NULL) {
    strlit5883 = alloc_String("lbrace");
    gc_root(strlit5883);
  }
// compiled string node returning strlit5883 (depth = 13)
  gc_frame_newslot(strlit5883);
// call case 4: self request
  params[0] = strlit5883;
  partcv[0] = 1;
  Object call5884 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5882);
// compiled call node returning call5884 (depth = 12)
  int op_slot_right_5881 = gc_frame_newslot(call5884);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_acceptBlocks (depth = 12)
  int op_slot_left_5881 = gc_frame_newslot(*var_acceptBlocks);
  params[0] = call5884;
  partcv[0] = 1;
  Object opresult5886 = callmethod(*var_acceptBlocks, "&&", 1, partcv, params);
// compiled op node returning opresult5886 (depth = 11)
  int op_slot_right_5880 = gc_frame_newslot(opresult5886);
// starting to compile call node (depth = 11)
  int callframe5888 = gc_frame_new();
// starting to compile string node (depth = 12)
  if (strlit5889 == NULL) {
    strlit5889 = alloc_String("lparen");
    gc_root(strlit5889);
  }
// compiled string node returning strlit5889 (depth = 12)
  gc_frame_newslot(strlit5889);
// call case 4: self request
  params[0] = strlit5889;
  partcv[0] = 1;
  Object call5890 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5888);
// compiled call node returning call5890 (depth = 11)
  int op_slot_left_5880 = gc_frame_newslot(call5890);
  params[0] = opresult5886;
  partcv[0] = 1;
  Object opresult5891 = callmethod(call5890, "||", 1, partcv, params);
// compiled op node returning opresult5891 (depth = 10)
  int op_slot_left_5875 = gc_frame_newslot(opresult5891);
  params[0] = call5878;
  partcv[0] = 1;
  Object opresult5892 = callmethod(opresult5891, "||", 1, partcv, params);
// compiled op node returning opresult5892 (depth = 9)
  int op_slot_left_5870 = gc_frame_newslot(opresult5892);
  params[0] = call5873;
  partcv[0] = 1;
  Object opresult5893 = callmethod(opresult5892, "||", 1, partcv, params);
// compiled op node returning opresult5893 (depth = 8)
  int op_slot_left_5865 = gc_frame_newslot(opresult5893);
  params[0] = call5868;
  partcv[0] = 1;
  Object opresult5894 = callmethod(opresult5893, "||", 1, partcv, params);
// compiled op node returning opresult5894 (depth = 7)
  int op_slot_left_5860 = gc_frame_newslot(opresult5894);
  params[0] = call5863;
  partcv[0] = 1;
  Object opresult5895 = callmethod(opresult5894, "||", 1, partcv, params);
// compiled op node returning opresult5895 (depth = 6)
  Object if5859 = done;
  if (istrue(opresult5895)) {
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5896 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call5897 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5896);
// compiled call node returning call5897 (depth = 6)
    gc_frame_newslot(call5897);
    if5859 = call5897;
  } else {
  }
// compiled if node returning if5859 (depth = 5)
    gc_frame_newslot(if5859);
    if5853 = if5859;
  }
// compiled if node returning if5853 (depth = 4)
    gc_frame_newslot(if5853);
    if5833 = if5853;
  } else {
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array5898 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5898 (depth = 5)
  *var_suggestions = array5898;
  if (array5898 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5899 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5901 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5900);
// compiled call node returning call5901 (depth = 8)
// compiled member node returning call5901 (depth = 7)
  partcv[0] = 0;
  Object call5902 = callmethod(call5901, "new",
    1, partcv, params);
  gc_frame_end(callframe5899);
// compiled call node returning call5902 (depth = 6)
// compiled member node returning call5902 (depth = 5)
  *var_suggestion = call5902;
  if (call5902 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5903 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5904 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe5903);
// compiled call node returning call5904 (depth = 4)
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5905 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5906 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5905);
// compiled call node returning call5906 (depth = 4)
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5907 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call5909 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5908);
// compiled call node returning call5909 (depth = 8)
// compiled member node returning call5909 (depth = 7)
  partcv[0] = 0;
  Object call5910 = callmethod(call5909, "new",
    1, partcv, params);
  gc_frame_end(callframe5907);
// compiled call node returning call5910 (depth = 6)
// compiled member node returning call5910 (depth = 5)
  *var_suggestion = call5910;
  if (call5910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5912 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5913 == NULL) {
    strlit5913 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5913);
  }
// compiled string node returning strlit5913 (depth = 5)
  gc_frame_newslot(strlit5913);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit5913;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5914 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5912);
// compiled call node returning call5914 (depth = 4)
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5915 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5916 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5915);
// compiled call node returning call5916 (depth = 4)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5917 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit5918 == NULL) {
    strlit5918 = alloc_String("A field or method name must follow a '.'.");
    gc_root(strlit5918);
  }
// compiled string node returning strlit5918 (depth = 5)
  gc_frame_newslot(strlit5918);
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5920 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5919);
// compiled call node returning call5920 (depth = 6)
// compiled member node returning call5920 (depth = 5)
  gc_frame_newslot(call5920);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5922 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5921);
// compiled call node returning call5922 (depth = 6)
// compiled member node returning call5922 (depth = 5)
  gc_frame_newslot(call5922);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit5918;
  params[1] = call5920;
  params[2] = call5922;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5923 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5917);
// compiled call node returning call5923 (depth = 4)
    gc_frame_newslot(call5923);
    if5833 = call5923;
  }
// compiled if node returning if5833 (depth = 3)
    gc_frame_newslot(if5833);
    if5819 = if5833;
  } else {
  }
// compiled if node returning if5819 (depth = 2)
  gc_frame_end(frame);
  return if5819;
}
Object meth_parser__apply6002(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe6003 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6004 == NULL) {
    strlit6004 = alloc_String("lbrace");
    gc_root(strlit6004);
  }
// compiled string node returning strlit6004 (depth = 7)
  gc_frame_newslot(strlit6004);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6004;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6005 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6003);
// compiled call node returning call6005 (depth = 6)
  gc_frame_end(frame);
  return call6005;
}
Object meth_parser__apply6086(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6088 == NULL) {
    strlit6088 = alloc_String("member");
    gc_root(strlit6088);
  }
// compiled string node returning strlit6088 (depth = 10)
  int op_slot_right_6087 = gc_frame_newslot(strlit6088);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call6091 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe6090);
// compiled call node returning call6091 (depth = 11)
// compiled member node returning call6091 (depth = 10)
  int op_slot_left_6087 = gc_frame_newslot(call6091);
  params[0] = strlit6088;
  partcv[0] = 1;
  Object opresult6092 = callmethod(call6091, "==", 1, partcv, params);
// compiled op node returning opresult6092 (depth = 9)
  gc_frame_end(frame);
  return opresult6092;
}
Object meth_parser__apply6095(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object *var_outroot = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1930
  setline(1930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_root (depth = 10)
  *var_outroot = *var_root;
  if (*var_root == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6097 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_root (depth = 12)
  partcv[0] = 0;
  Object call6098 = callmethod(*var_root, "in",
    1, partcv, params);
  gc_frame_end(callframe6097);
// compiled call node returning call6098 (depth = 11)
// compiled member node returning call6098 (depth = 10)
  *var_root = call6098;
  if (call6098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_callrest5924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method callrest");
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_acceptBlocks = &(stackframe->slots[0]);
  *var_acceptBlocks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for callrest");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_lnum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lnum");
  Object *var_lpos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lpos");
  Object *var_methn = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "methn");
  Object *var_btok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "btok");
  Object *var_signature = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "signature");
  Object *var_part = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "part");
  Object *var_hadcall = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "hadcall");
  Object *var_tok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "tok");
  Object *var_startInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "startInd");
  Object *var_genericIdents = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "genericIdents");
  Object *var_ar = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "ar");
  Object *var_root = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "root");
  Object *var_outroot = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "outroot");
  Object *var_meth_39_ = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "meth'");
  Object *var_call = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "call");
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5927 = alloc_Float64(0);
// compiled num node returning num5927 (depth = 4)
  int op_slot_right_5926 = gc_frame_newslot(num5927);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5929 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call5930 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5929);
// compiled call node returning call5930 (depth = 5)
// compiled member node returning call5930 (depth = 4)
  int op_slot_left_5926 = gc_frame_newslot(call5930);
  params[0] = num5927;
  partcv[0] = 1;
  Object opresult5931 = callmethod(call5930, "==", 1, partcv, params);
// compiled op node returning opresult5931 (depth = 3)
  Object if5925 = done;
  if (istrue(opresult5931)) {
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num5932 = alloc_Float64(0);
// compiled num node returning num5932 (depth = 4)
  return num5932;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if5925 = undefined;
  } else {
  }
// compiled if node returning if5925 (depth = 2)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call5934 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5933);
// compiled call node returning call5934 (depth = 4)
// compiled member node returning call5934 (depth = 3)
  *var_meth = call5934;
  if (call5934 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5937 == NULL) {
    strlit5937 = alloc_String("identifier");
    gc_root(strlit5937);
  }
// compiled string node returning strlit5937 (depth = 4)
  int op_slot_right_5936 = gc_frame_newslot(strlit5937);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call5940 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5939);
// compiled call node returning call5940 (depth = 5)
// compiled member node returning call5940 (depth = 4)
  int op_slot_left_5936 = gc_frame_newslot(call5940);
  params[0] = strlit5937;
  partcv[0] = 1;
  Object opresult5941 = callmethod(call5940, "!=", 1, partcv, params);
// compiled op node returning opresult5941 (depth = 3)
  Object if5935 = done;
  if (istrue(opresult5941)) {
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5944 == NULL) {
    strlit5944 = alloc_String("member");
    gc_root(strlit5944);
  }
// compiled string node returning strlit5944 (depth = 5)
  int op_slot_right_5943 = gc_frame_newslot(strlit5944);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5946 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call5947 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5946);
// compiled call node returning call5947 (depth = 6)
// compiled member node returning call5947 (depth = 5)
  int op_slot_left_5943 = gc_frame_newslot(call5947);
  params[0] = strlit5944;
  partcv[0] = 1;
  Object opresult5948 = callmethod(call5947, "!=", 1, partcv, params);
// compiled op node returning opresult5948 (depth = 4)
  Object if5942 = done;
  if (istrue(opresult5948)) {
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5949 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5950 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5949);
// compiled call node returning call5950 (depth = 4)
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num5951 = alloc_Float64(0);
// compiled num node returning num5951 (depth = 5)
  return num5951;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if5942 = undefined;
  } else {
  }
// compiled if node returning if5942 (depth = 3)
    gc_frame_newslot(if5942);
    if5935 = if5942;
  } else {
  }
// compiled if node returning if5935 (depth = 2)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5952 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5953 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe5952);
// compiled call node returning call5953 (depth = 4)
// compiled member node returning call5953 (depth = 3)
  *var_lnum = call5953;
  if (call5953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5955 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5954);
// compiled call node returning call5955 (depth = 4)
// compiled member node returning call5955 (depth = 3)
  *var_lpos = call5955;
  if (call5955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call5957 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe5956);
// compiled call node returning call5957 (depth = 4)
// compiled member node returning call5957 (depth = 3)
  *var_methn = call5957;
  if (call5957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5958 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5960 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5959);
// compiled call node returning call5960 (depth = 4)
// compiled member node returning call5960 (depth = 3)
  gc_frame_newslot(call5960);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5961 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call5962 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5961);
// compiled call node returning call5962 (depth = 4)
// compiled member node returning call5962 (depth = 3)
  gc_frame_newslot(call5962);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = call5960;
  params[1] = call5962;
  partcv[0] = 2;
  Object call5963 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5958);
// compiled call node returning call5963 (depth = 2)
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array5964 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array5964 (depth = 3)
  *var_signature = array5964;
  if (array5964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5965 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5966 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call5967 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe5966);
// compiled call node returning call5967 (depth = 6)
// compiled member node returning call5967 (depth = 5)
  partcv[0] = 0;
  Object call5968 = callmethod(call5967, "new",
    1, partcv, params);
  gc_frame_end(callframe5965);
// compiled call node returning call5968 (depth = 4)
// compiled member node returning call5968 (depth = 3)
  *var_part = call5968;
  if (call5968 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5969 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5970 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe5969);
// compiled call node returning call5970 (depth = 2)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5971 = alloc_Boolean(0);
// compiled identifier node returning bool5971 (depth = 3)
  *var_hadcall = bool5971;
  if (bool5971 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  *var_startInd = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5972 = alloc_Boolean(0);
// compiled identifier node returning bool5972 (depth = 3)
  *var_genericIdents = bool5972;
  if (bool5972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5974 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5975 == NULL) {
    strlit5975 = alloc_String("lgeneric");
    gc_root(strlit5975);
  }
// compiled string node returning strlit5975 (depth = 4)
  gc_frame_newslot(strlit5975);
// call case 4: self request
  params[0] = strlit5975;
  partcv[0] = 1;
  Object call5976 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5974);
// compiled call node returning call5976 (depth = 3)
  Object if5973 = done;
  if (istrue(call5976)) {
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5977 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5978 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5977);
// compiled call node returning call5978 (depth = 5)
// compiled member node returning call5978 (depth = 4)
  *var_genericIdents = call5978;
  if (call5978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if5973 = done;
  } else {
  }
// compiled if node returning if5973 (depth = 2)
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5981 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5982 == NULL) {
    strlit5982 = alloc_String("lparen");
    gc_root(strlit5982);
  }
// compiled string node returning strlit5982 (depth = 4)
  gc_frame_newslot(strlit5982);
// call case 4: self request
  params[0] = strlit5982;
  partcv[0] = 1;
  Object call5983 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5981);
// compiled call node returning call5983 (depth = 3)
  Object if5980 = done;
  if (istrue(call5983)) {
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5984 = gc_frame_new();
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5985 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5986 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5985);
// compiled call node returning call5986 (depth = 6)
// compiled member node returning call5986 (depth = 5)
  gc_frame_newslot(call5986);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call5986;
  partcv[0] = 1;
  Object call5987 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5984);
// compiled call node returning call5987 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5988 = gc_frame_new();
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call5990 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5989);
// compiled call node returning call5990 (depth = 6)
// compiled member node returning call5990 (depth = 5)
  gc_frame_newslot(call5990);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call5990;
  partcv[0] = 1;
  Object call5991 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5988);
// compiled call node returning call5991 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5992 = gc_frame_new();
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methn (depth = 5)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call5993 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe5992);
// compiled call node returning call5993 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool5995 = alloc_Boolean(1);
// compiled identifier node returning bool5995 (depth = 4)
  *var_hadcall = bool5995;
  if (bool5995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5997 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_part (depth = 4)
  gc_frame_newslot(*var_part);
// call case 4: self request
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5998 = callmethodflags(self, "parenthesizedArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5997);
// compiled call node returning call5998 (depth = 3)
    gc_frame_newslot(call5998);
    if5980 = call5998;
  } else {
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile block node (depth = 5)
  Object block6001 = alloc_Block(NULL, NULL, "parser", 1912);
  gc_frame_newslot(block6001);
// method _apply
  block_savedest(block6001);
  Object closure6002 = createclosure(2, "_apply");
  setclosureframe(closure6002, stackframe);
  addtoclosure(closure6002, var_tok);
  addtoclosure(closure6002, selfslot);
  struct UserObject *uo6002 = (struct UserObject*)block6001;
  uo6002->data[0] = (Object)closure6002;
  Method *meth_meth_parser__apply6002 = addmethod2pos(block6001, "_apply", &meth_parser__apply6002, 0);
  int argcv_meth_parser__apply6002[] = {0};
  meth_meth_parser__apply6002->type = alloc_MethodType(1, argcv_meth_parser__apply6002);
  meth_meth_parser__apply6002->definitionModule = modulename;
  meth_meth_parser__apply6002->definitionLine = 1907;
// compiled block node returning block6001 (depth = 5)
  int op_slot_right_6000 = gc_frame_newslot(block6001);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6008 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_acceptBlocks (depth = 7)
  partcv[0] = 0;
  Object call6009 = callmethod(*var_acceptBlocks, "not",
    1, partcv, params);
  gc_frame_end(callframe6008);
// compiled call node returning call6009 (depth = 6)
// compiled member node returning call6009 (depth = 5)
  int op_slot_left_6000 = gc_frame_newslot(call6009);
  params[0] = block6001;
  partcv[0] = 1;
  Object opresult6010 = callmethod(call6009, "&&", 1, partcv, params);
// compiled op node returning opresult6010 (depth = 4)
  Object if5999 = done;
  if (istrue(opresult6010)) {
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6011 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6012 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6011);
// compiled call node returning call6012 (depth = 4)
    gc_frame_newslot(call6012);
    if5999 = call6012;
  } else {
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6018 == NULL) {
    strlit6018 = alloc_String("false");
    gc_root(strlit6018);
  }
// compiled string node returning strlit6018 (depth = 9)
  int op_slot_right_6017 = gc_frame_newslot(strlit6018);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6020 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6021 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6020);
// compiled call node returning call6021 (depth = 10)
// compiled member node returning call6021 (depth = 9)
  int op_slot_left_6017 = gc_frame_newslot(call6021);
  params[0] = strlit6018;
  partcv[0] = 1;
  Object opresult6022 = callmethod(call6021, "==", 1, partcv, params);
// compiled op node returning opresult6022 (depth = 8)
  int op_slot_right_6016 = gc_frame_newslot(opresult6022);
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6025 == NULL) {
    strlit6025 = alloc_String("true");
    gc_root(strlit6025);
  }
// compiled string node returning strlit6025 (depth = 9)
  int op_slot_right_6024 = gc_frame_newslot(strlit6025);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6027 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6028 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6027);
// compiled call node returning call6028 (depth = 10)
// compiled member node returning call6028 (depth = 9)
  int op_slot_left_6024 = gc_frame_newslot(call6028);
  params[0] = strlit6025;
  partcv[0] = 1;
  Object opresult6029 = callmethod(call6028, "==", 1, partcv, params);
// compiled op node returning opresult6029 (depth = 8)
  int op_slot_left_6016 = gc_frame_newslot(opresult6029);
  params[0] = opresult6022;
  partcv[0] = 1;
  Object opresult6030 = callmethod(opresult6029, "||", 1, partcv, params);
// compiled op node returning opresult6030 (depth = 7)
  int op_slot_right_6015 = gc_frame_newslot(opresult6030);
// starting to compile call node (depth = 7)
  int callframe6032 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6033 == NULL) {
    strlit6033 = alloc_String("identifier");
    gc_root(strlit6033);
  }
// compiled string node returning strlit6033 (depth = 8)
  gc_frame_newslot(strlit6033);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6033;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6034 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6032);
// compiled call node returning call6034 (depth = 7)
  int op_slot_left_6015 = gc_frame_newslot(call6034);
  params[0] = opresult6030;
  partcv[0] = 1;
  Object opresult6035 = callmethod(call6034, "&&", 1, partcv, params);
// compiled op node returning opresult6035 (depth = 6)
  int op_slot_right_6014 = gc_frame_newslot(opresult6035);
// starting to compile op node (depth = 6)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6038 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6039 == NULL) {
    strlit6039 = alloc_String("lbrace");
    gc_root(strlit6039);
  }
// compiled string node returning strlit6039 (depth = 8)
  gc_frame_newslot(strlit6039);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6039;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6040 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6038);
// compiled call node returning call6040 (depth = 7)
  int op_slot_right_6037 = gc_frame_newslot(call6040);
// starting to compile op node (depth = 7)
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6043 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6044 == NULL) {
    strlit6044 = alloc_String("num");
    gc_root(strlit6044);
  }
// compiled string node returning strlit6044 (depth = 9)
  gc_frame_newslot(strlit6044);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6044;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6045 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6043);
// compiled call node returning call6045 (depth = 8)
  int op_slot_right_6042 = gc_frame_newslot(call6045);
// starting to compile call node (depth = 8)
  int callframe6047 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6048 == NULL) {
    strlit6048 = alloc_String("string");
    gc_root(strlit6048);
  }
// compiled string node returning strlit6048 (depth = 9)
  gc_frame_newslot(strlit6048);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6048;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6049 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6047);
// compiled call node returning call6049 (depth = 8)
  int op_slot_left_6042 = gc_frame_newslot(call6049);
  params[0] = call6045;
  partcv[0] = 1;
  Object opresult6050 = callmethod(call6049, "||", 1, partcv, params);
// compiled op node returning opresult6050 (depth = 7)
  int op_slot_left_6037 = gc_frame_newslot(opresult6050);
  params[0] = call6040;
  partcv[0] = 1;
  Object opresult6051 = callmethod(opresult6050, "||", 1, partcv, params);
// compiled op node returning opresult6051 (depth = 6)
  int op_slot_left_6014 = gc_frame_newslot(opresult6051);
  params[0] = opresult6035;
  partcv[0] = 1;
  Object opresult6052 = callmethod(opresult6051, "||", 1, partcv, params);
// compiled op node returning opresult6052 (depth = 5)
  Object if6013 = done;
  if (istrue(opresult6052)) {
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool6054 = alloc_Boolean(1);
// compiled identifier node returning bool6054 (depth = 6)
  *var_hadcall = bool6054;
  if (bool6054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6056 = gc_frame_new();
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_methn (depth = 7)
  gc_frame_newslot(*var_methn);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call6057 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6056);
// compiled call node returning call6057 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6059 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6058);
// compiled call node returning call6059 (depth = 6)
// compiled member node returning call6059 (depth = 5)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6061 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6060);
// compiled call node returning call6061 (depth = 7)
// compiled member node returning call6061 (depth = 6)
  *var_ar = call6061;
  if (call6061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6062 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ar (depth = 6)
  gc_frame_newslot(*var_ar);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6063 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call6064 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6063);
// compiled call node returning call6064 (depth = 7)
// compiled member node returning call6064 (depth = 6)
  params[0] = *var_ar;
  partcv[0] = 1;
  Object call6065 = callmethod(call6064, "push",
    1, partcv, params);
  gc_frame_end(callframe6062);
// compiled call node returning call6065 (depth = 5)
    gc_frame_newslot(call6065);
    if6013 = call6065;
  } else {
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6068 == NULL) {
    strlit6068 = alloc_String("identifier");
    gc_root(strlit6068);
  }
// compiled string node returning strlit6068 (depth = 7)
  int op_slot_right_6067 = gc_frame_newslot(strlit6068);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call6071 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6070);
// compiled call node returning call6071 (depth = 8)
// compiled member node returning call6071 (depth = 7)
  int op_slot_left_6067 = gc_frame_newslot(call6071);
  params[0] = strlit6068;
  partcv[0] = 1;
  Object opresult6072 = callmethod(call6071, "==", 1, partcv, params);
// compiled op node returning opresult6072 (depth = 6)
  Object if6066 = done;
  if (istrue(opresult6072)) {
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6073 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6074 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6073);
// compiled call node returning call6074 (depth = 6)
    gc_frame_newslot(call6074);
    if6066 = call6074;
  } else {
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6077 == NULL) {
    strlit6077 = alloc_String("member");
    gc_root(strlit6077);
  }
// compiled string node returning strlit6077 (depth = 8)
  int op_slot_right_6076 = gc_frame_newslot(strlit6077);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6079 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call6080 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6079);
// compiled call node returning call6080 (depth = 9)
// compiled member node returning call6080 (depth = 8)
  int op_slot_left_6076 = gc_frame_newslot(call6080);
  params[0] = strlit6077;
  partcv[0] = 1;
  Object opresult6081 = callmethod(call6080, "==", 1, partcv, params);
// compiled op node returning opresult6081 (depth = 7)
  Object if6075 = done;
  if (istrue(opresult6081)) {
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6082 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call6083 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe6082);
// compiled call node returning call6083 (depth = 9)
// compiled member node returning call6083 (depth = 8)
  *var_root = call6083;
  if (call6083 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  *var_outroot = *var_meth;
  if (*var_meth == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6084 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block6085 = alloc_Block(NULL, NULL, "parser", 1929);
  gc_frame_newslot(block6085);
// method _apply
  block_savedest(block6085);
  Object closure6086 = createclosure(2, "_apply");
  setclosureframe(closure6086, stackframe);
  addtoclosure(closure6086, var_root);
  addtoclosure(closure6086, selfslot);
  struct UserObject *uo6086 = (struct UserObject*)block6085;
  uo6086->data[0] = (Object)closure6086;
  Method *meth_meth_parser__apply6086 = addmethod2pos(block6085, "_apply", &meth_parser__apply6086, 0);
  int argcv_meth_parser__apply6086[] = {0};
  meth_meth_parser__apply6086->type = alloc_MethodType(1, argcv_meth_parser__apply6086);
  meth_meth_parser__apply6086->definitionModule = modulename;
  meth_meth_parser__apply6086->definitionLine = 1927;
// compiled block node returning block6085 (depth = 8)
  gc_frame_newslot(block6085);
// starting to compile block node (depth = 8)
  Object block6094 = alloc_Block(NULL, NULL, "parser", 1929);
  gc_frame_newslot(block6094);
// method _apply
  block_savedest(block6094);
  Object closure6095 = createclosure(3, "_apply");
  setclosureframe(closure6095, stackframe);
  addtoclosure(closure6095, var_root);
  addtoclosure(closure6095, var_outroot);
  addtoclosure(closure6095, selfslot);
  struct UserObject *uo6095 = (struct UserObject*)block6094;
  uo6095->data[0] = (Object)closure6095;
  Method *meth_meth_parser__apply6095 = addmethod2pos(block6094, "_apply", &meth_parser__apply6095, 0);
  int argcv_meth_parser__apply6095[] = {0};
  meth_meth_parser__apply6095->type = alloc_MethodType(1, argcv_meth_parser__apply6095);
  meth_meth_parser__apply6095->definitionModule = modulename;
  meth_meth_parser__apply6095->definitionLine = 1929;
// compiled block node returning block6094 (depth = 8)
  gc_frame_newslot(block6094);
// call case 5: prelude request
  params[0] = block6085;
  params[1] = block6094;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6101 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6084);
// compiled call node returning call6101 (depth = 7)
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6104 == NULL) {
    strlit6104 = alloc_String("identifier");
    gc_root(strlit6104);
  }
// compiled string node returning strlit6104 (depth = 9)
  int op_slot_right_6103 = gc_frame_newslot(strlit6104);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_root (depth = 11)
  partcv[0] = 0;
  Object call6107 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe6106);
// compiled call node returning call6107 (depth = 10)
// compiled member node returning call6107 (depth = 9)
  int op_slot_left_6103 = gc_frame_newslot(call6107);
  params[0] = strlit6104;
  partcv[0] = 1;
  Object opresult6108 = callmethod(call6107, "==", 1, partcv, params);
// compiled op node returning opresult6108 (depth = 8)
  Object if6102 = done;
  if (istrue(opresult6108)) {
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6109 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6110 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6109);
// compiled call node returning call6110 (depth = 8)
    gc_frame_newslot(call6110);
    if6102 = call6110;
  } else {
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6111 = gc_frame_new();
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_genericIdents (depth = 10)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6112 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6111);
// compiled call node returning call6112 (depth = 9)
// compiled bind node returning done (depth = 8)
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6113 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6114 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6113);
// compiled call node returning call6114 (depth = 8)
    gc_frame_newslot(call6114);
    if6102 = call6114;
  }
// compiled if node returning if6102 (depth = 7)
    gc_frame_newslot(if6102);
    if6075 = if6102;
  } else {
  }
// compiled if node returning if6075 (depth = 6)
    gc_frame_newslot(if6075);
    if6066 = if6075;
  }
// compiled if node returning if6066 (depth = 5)
    gc_frame_newslot(if6066);
    if6013 = if6066;
  }
// compiled if node returning if6013 (depth = 4)
    gc_frame_newslot(if6013);
    if5999 = if6013;
  }
// compiled if node returning if5999 (depth = 3)
    gc_frame_newslot(if5999);
    if5980 = if5999;
  }
// compiled if node returning if5980 (depth = 2)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_hadcall (depth = 3)
  Object if6115 = done;
  if (istrue(*var_hadcall)) {
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6117 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit6118 == NULL) {
    strlit6118 = alloc_String("identifier");
    gc_root(strlit6118);
  }
// compiled string node returning strlit6118 (depth = 5)
  gc_frame_newslot(strlit6118);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tok (depth = 5)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6118;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6119 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6117);
// compiled call node returning call6119 (depth = 4)
  Object if6116 = done;
  if (istrue(call6119)) {
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6120 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  gc_frame_newslot(*var_methn);
// starting to compile identifier node (depth = 6)
  Object bool6121 = alloc_Boolean(0);
// compiled identifier node returning bool6121 (depth = 6)
  gc_frame_newslot(bool6121);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call6123 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe6122);
// compiled call node returning call6123 (depth = 7)
// compiled member node returning call6123 (depth = 6)
  params[0] = *var_methn;
  params[1] = bool6121;
  partcv[0] = 2;
  Object call6124 = callmethod(call6123, "new",
    1, partcv, params);
  gc_frame_end(callframe6120);
// compiled call node returning call6124 (depth = 5)
  *var_meth_39_ = call6124;
  if (call6124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6125 = gc_frame_new();
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lnum (depth = 6)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call6126 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6125);
// compiled call node returning call6126 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6127 = gc_frame_new();
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lpos (depth = 6)
  gc_frame_newslot(*var_lpos);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  params[0] = *var_lpos;
  partcv[0] = 1;
  Object call6128 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6127);
// compiled call node returning call6128 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6129 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth_39_ (depth = 6)
  gc_frame_newslot(*var_meth_39_);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = *var_meth_39_;
  params[1] = *var_signature;
  params[2] = *var_tok;
  partcv[0] = 3;
  Object call6130 = callmethodflags(self, "callmprest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6129);
// compiled call node returning call6130 (depth = 5)
  *var_methn = call6130;
  if (call6130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6134 == NULL) {
    strlit6134 = alloc_String("member");
    gc_root(strlit6134);
  }
// compiled string node returning strlit6134 (depth = 6)
  int op_slot_right_6133 = gc_frame_newslot(strlit6134);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call6137 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6136);
// compiled call node returning call6137 (depth = 7)
// compiled member node returning call6137 (depth = 6)
  int op_slot_left_6133 = gc_frame_newslot(call6137);
  params[0] = strlit6134;
  partcv[0] = 1;
  Object opresult6138 = callmethod(call6137, "==", 1, partcv, params);
// compiled op node returning opresult6138 (depth = 5)
  Object if6132 = done;
  if (istrue(opresult6138)) {
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6139 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call6141 = callmethod(*var_methn, "value",
    1, partcv, params);
  gc_frame_end(callframe6140);
// compiled call node returning call6141 (depth = 8)
// compiled member node returning call6141 (depth = 7)
  gc_frame_newslot(call6141);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call6143 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe6142);
// compiled call node returning call6143 (depth = 8)
// compiled member node returning call6143 (depth = 7)
  gc_frame_newslot(call6143);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6144 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call6145 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe6144);
// compiled call node returning call6145 (depth = 8)
// compiled member node returning call6145 (depth = 7)
  params[0] = call6141;
  params[1] = call6143;
  partcv[0] = 2;
  Object call6146 = callmethod(call6145, "new",
    1, partcv, params);
  gc_frame_end(callframe6139);
// compiled call node returning call6146 (depth = 6)
  *var_meth = call6146;
  if (call6146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6148 = gc_frame_new();
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call6150 = callmethod(*var_methn, "line",
    1, partcv, params);
  gc_frame_end(callframe6149);
// compiled call node returning call6150 (depth = 8)
// compiled member node returning call6150 (depth = 7)
  gc_frame_newslot(call6150);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  params[0] = call6150;
  partcv[0] = 1;
  Object call6151 = callmethod(*var_meth, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6148);
// compiled call node returning call6151 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6152 = gc_frame_new();
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6153 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methn (depth = 9)
  partcv[0] = 0;
  Object call6154 = callmethod(*var_methn, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6153);
// compiled call node returning call6154 (depth = 8)
// compiled member node returning call6154 (depth = 7)
  gc_frame_newslot(call6154);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  params[0] = call6154;
  partcv[0] = 1;
  Object call6155 = callmethod(*var_meth, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6152);
// compiled call node returning call6155 (depth = 6)
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6132 = done;
  } else {
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methn (depth = 6)
  *var_meth = *var_methn;
  if (*var_methn == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6132 = done;
  }
// compiled if node returning if6132 (depth = 4)
    gc_frame_newslot(if6132);
    if6116 = if6132;
  } else {
  }
// compiled if node returning if6116 (depth = 3)
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6157 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lnum (depth = 4)
  gc_frame_newslot(*var_lnum);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call6158 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe6157);
// compiled call node returning call6158 (depth = 3)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6159 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call6161 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe6160);
// compiled call node returning call6161 (depth = 6)
// compiled member node returning call6161 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  partcv[0] = 2;
  Object call6162 = callmethod(call6161, "new",
    1, partcv, params);
  gc_frame_end(callframe6159);
// compiled call node returning call6162 (depth = 4)
  *var_call = call6162;
  if (call6162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6163 = gc_frame_new();
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_call (depth = 5)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6164 = callmethod(*var_call, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6163);
// compiled call node returning call6164 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6165 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_call (depth = 4)
  gc_frame_newslot(*var_call);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_call;
  partcv[0] = 1;
  Object call6166 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6165);
// compiled call node returning call6166 (depth = 3)
    gc_frame_newslot(call6166);
    if6115 = call6166;
  } else {
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool6169 = alloc_Boolean(0);
// compiled identifier node returning bool6169 (depth = 5)
  int op_slot_right_6168 = gc_frame_newslot(bool6169);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_genericIdents (depth = 5)
  int op_slot_left_6168 = gc_frame_newslot(*var_genericIdents);
  params[0] = bool6169;
  partcv[0] = 1;
  Object opresult6171 = callmethod(*var_genericIdents, "!=", 1, partcv, params);
// compiled op node returning opresult6171 (depth = 4)
  Object if6167 = done;
  if (istrue(opresult6171)) {
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6172 = gc_frame_new();
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_genericIdents (depth = 6)
  gc_frame_newslot(*var_genericIdents);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6173 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6172);
// compiled call node returning call6173 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if6167 = done;
  } else {
  }
// compiled if node returning if6167 (depth = 3)
    gc_frame_newslot(if6167);
    if6115 = if6167;
  }
// compiled if node returning if6115 (depth = 2)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startInd (depth = 3)
  *var_minIndentLevel = *var_startInd;
  if (*var_startInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6175 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_acceptBlocks (depth = 3)
  gc_frame_newslot(*var_acceptBlocks);
// call case 4: self request
  params[0] = *var_acceptBlocks;
  partcv[0] = 1;
  Object call6176 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6175);
// compiled call node returning call6176 (depth = 2)
  gc_frame_end(frame);
  return call6176;
}
Object meth_parser__apply6182(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6183 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_blocksOK (depth = 5)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6184 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6183);
// compiled call node returning call6184 (depth = 4)
  gc_frame_end(frame);
  return call6184;
}
Object meth_parser__apply6261(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 10)
  int callframe6262 = gc_frame_new();
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_blocksOK (depth = 11)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6263 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6262);
// compiled call node returning call6263 (depth = 10)
  gc_frame_end(frame);
  return call6263;
}
Object meth_parser__apply6321(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe6322 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6323 == NULL) {
    strlit6323 = alloc_String("comma");
    gc_root(strlit6323);
  }
// compiled string node returning strlit6323 (depth = 7)
  gc_frame_newslot(strlit6323);
// call case 4: self request
  params[0] = strlit6323;
  partcv[0] = 1;
  Object call6324 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6322);
// compiled call node returning call6324 (depth = 6)
  gc_frame_end(frame);
  return call6324;
}
Object meth_parser__apply6340(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6341 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6342 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6341);
// compiled call node returning call6342 (depth = 11)
  gc_frame_end(frame);
  return call6342;
}
Object meth_parser__apply6461(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe6462 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6463 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6462);
// compiled call node returning call6463 (depth = 12)
  gc_frame_end(frame);
  return call6463;
}
Object meth_parser__apply6327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_blocksOK = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arg = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arg");
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6328 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6329 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call6330 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6329);
// compiled call node returning call6330 (depth = 8)
// compiled member node returning call6330 (depth = 7)
  gc_frame_newslot(call6330);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6331 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call6332 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6331);
// compiled call node returning call6332 (depth = 8)
// compiled member node returning call6332 (depth = 7)
  params[0] = call6330;
  partcv[0] = 1;
  Object call6333 = callmethod(call6332, "push",
    1, partcv, params);
  gc_frame_end(callframe6328);
// compiled call node returning call6333 (depth = 6)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6334 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6335 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6334);
// compiled call node returning call6335 (depth = 7)
// compiled member node returning call6335 (depth = 6)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6337 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6338 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6339 = alloc_Block(NULL, NULL, "parser", 2011);
  gc_frame_newslot(block6339);
// method _apply
  block_savedest(block6339);
  Object closure6340 = createclosure(2, "_apply");
  setclosureframe(closure6340, stackframe);
  addtoclosure(closure6340, var_blocksOK);
  addtoclosure(closure6340, selfslot);
  struct UserObject *uo6340 = (struct UserObject*)block6339;
  uo6340->data[0] = (Object)closure6340;
  Method *meth_meth_parser__apply6340 = addmethod2pos(block6339, "_apply", &meth_parser__apply6340, 0);
  int argcv_meth_parser__apply6340[] = {0};
  meth_meth_parser__apply6340->type = alloc_MethodType(1, argcv_meth_parser__apply6340);
  meth_meth_parser__apply6340->definitionModule = modulename;
  meth_meth_parser__apply6340->definitionLine = 2011;
// compiled block node returning block6339 (depth = 10)
  gc_frame_newslot(block6339);
// call case 4: self request
  params[0] = block6339;
  partcv[0] = 1;
  Object call6344 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6338);
// compiled call node returning call6344 (depth = 9)
  partcv[0] = 0;
  Object call6345 = callmethod(call6344, "not",
    1, partcv, params);
  gc_frame_end(callframe6337);
// compiled call node returning call6345 (depth = 8)
// compiled member node returning call6345 (depth = 7)
  Object if6336 = done;
  if (istrue(call6345)) {
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array6346 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6346 (depth = 8)
  *var_suggestions = array6346;
  if (array6346 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6347 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6348 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6349 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6348);
// compiled call node returning call6349 (depth = 11)
// compiled member node returning call6349 (depth = 10)
  partcv[0] = 0;
  Object call6350 = callmethod(call6349, "new",
    1, partcv, params);
  gc_frame_end(callframe6347);
// compiled call node returning call6350 (depth = 9)
// compiled member node returning call6350 (depth = 8)
  *var_suggestion = call6350;
  if (call6350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6351 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6352 == NULL) {
    strlit6352 = alloc_String("rparen");
    gc_root(strlit6352);
  }
// compiled string node returning strlit6352 (depth = 9)
  gc_frame_newslot(strlit6352);
// call case 4: self request
  params[0] = strlit6352;
  partcv[0] = 1;
  Object call6353 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6351);
// compiled call node returning call6353 (depth = 8)
  *var_nextTok = call6353;
  if (call6353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6355 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6355 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6357 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6357 (depth = 8)
  Object if6354 = done;
  if (istrue(opresult6357)) {
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6358 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6359 == NULL) {
    strlit6359 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6359);
  }
// compiled string node returning strlit6359 (depth = 9)
  gc_frame_newslot(strlit6359);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6359;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6360 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6358);
// compiled call node returning call6360 (depth = 8)
    gc_frame_newslot(call6360);
    if6354 = call6360;
  } else {
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6361 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6363 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6362);
// compiled call node returning call6363 (depth = 10)
// compiled member node returning call6363 (depth = 9)
  gc_frame_newslot(call6363);
// starting to compile identifier node (depth = 9)
  Object bool6364 = alloc_Boolean(1);
// compiled identifier node returning bool6364 (depth = 9)
  gc_frame_newslot(bool6364);
// starting to compile identifier node (depth = 9)
  Object bool6365 = alloc_Boolean(0);
// compiled identifier node returning bool6365 (depth = 9)
  gc_frame_newslot(bool6365);
// starting to compile string node (depth = 9)
  if (strlit6366 == NULL) {
    strlit6366 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6366);
  }
// compiled string node returning strlit6366 (depth = 9)
  gc_frame_newslot(strlit6366);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6363;
  params[2] = bool6364;
  params[3] = bool6365;
  params[4] = strlit6366;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6367 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6361);
// compiled call node returning call6367 (depth = 8)
    gc_frame_newslot(call6367);
    if6354 = call6367;
  }
// compiled if node returning if6354 (depth = 7)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6368 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6369 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6368);
// compiled call node returning call6369 (depth = 7)
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2021
  setline(2021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6370 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6372 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6371);
// compiled call node returning call6372 (depth = 11)
// compiled member node returning call6372 (depth = 10)
  partcv[0] = 0;
  Object call6373 = callmethod(call6372, "new",
    1, partcv, params);
  gc_frame_end(callframe6370);
// compiled call node returning call6373 (depth = 9)
// compiled member node returning call6373 (depth = 8)
  *var_suggestion = call6373;
  if (call6373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6375 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6376 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call6377 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6376);
// compiled call node returning call6377 (depth = 9)
// compiled member node returning call6377 (depth = 8)
  gc_frame_newslot(call6377);
// starting to compile identifier node (depth = 8)
  Object bool6378 = alloc_Boolean(1);
// compiled identifier node returning bool6378 (depth = 8)
  gc_frame_newslot(bool6378);
// starting to compile identifier node (depth = 8)
  Object bool6379 = alloc_Boolean(0);
// compiled identifier node returning bool6379 (depth = 8)
  gc_frame_newslot(bool6379);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call6377;
  params[2] = bool6378;
  params[3] = bool6379;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6380 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6375);
// compiled call node returning call6380 (depth = 7)
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6381 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6382 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6381);
// compiled call node returning call6382 (depth = 7)
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6383 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6384 == NULL) {
    strlit6384 = alloc_String("A method request must have an expression after a ','.");
    gc_root(strlit6384);
  }
// compiled string node returning strlit6384 (depth = 8)
  gc_frame_newslot(strlit6384);
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6386 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6385);
// compiled call node returning call6386 (depth = 9)
// compiled member node returning call6386 (depth = 8)
  gc_frame_newslot(call6386);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6387 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6388 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6387);
// compiled call node returning call6388 (depth = 9)
// compiled member node returning call6388 (depth = 8)
  gc_frame_newslot(call6388);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6384;
  params[1] = call6386;
  params[2] = call6388;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6389 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6383);
// compiled call node returning call6389 (depth = 7)
    gc_frame_newslot(call6389);
    if6336 = call6389;
  } else {
  }
// compiled if node returning if6336 (depth = 6)
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6391 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6392 == NULL) {
    strlit6392 = alloc_String("colon");
    gc_root(strlit6392);
  }
// compiled string node returning strlit6392 (depth = 8)
  gc_frame_newslot(strlit6392);
// call case 4: self request
  params[0] = strlit6392;
  partcv[0] = 1;
  Object call6393 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6391);
// compiled call node returning call6393 (depth = 7)
  Object if6390 = done;
  if (istrue(call6393)) {
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6394 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6395 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6394);
// compiled call node returning call6395 (depth = 9)
// compiled member node returning call6395 (depth = 8)
  *var_arg = call6395;
  if (call6395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6398 == NULL) {
    strlit6398 = alloc_String("identifier");
    gc_root(strlit6398);
  }
// compiled string node returning strlit6398 (depth = 9)
  int op_slot_right_6397 = gc_frame_newslot(strlit6398);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6400 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_arg (depth = 11)
  partcv[0] = 0;
  Object call6401 = callmethod(*var_arg, "kind",
    1, partcv, params);
  gc_frame_end(callframe6400);
// compiled call node returning call6401 (depth = 10)
// compiled member node returning call6401 (depth = 9)
  int op_slot_left_6397 = gc_frame_newslot(call6401);
  params[0] = strlit6398;
  partcv[0] = 1;
  Object opresult6402 = callmethod(call6401, "!=", 1, partcv, params);
// compiled op node returning opresult6402 (depth = 8)
  Object if6396 = done;
  if (istrue(opresult6402)) {
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6403 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6404 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6405 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6404);
// compiled call node returning call6405 (depth = 12)
// compiled member node returning call6405 (depth = 11)
  partcv[0] = 0;
  Object call6406 = callmethod(call6405, "new",
    1, partcv, params);
  gc_frame_end(callframe6403);
// compiled call node returning call6406 (depth = 10)
// compiled member node returning call6406 (depth = 9)
  *var_suggestion = call6406;
  if (call6406 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit6409 == NULL) {
    strlit6409 = alloc_String("identifier");
    gc_root(strlit6409);
  }
// compiled string node returning strlit6409 (depth = 10)
  int op_slot_right_6408 = gc_frame_newslot(strlit6409);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6411 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6413 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6412);
// compiled call node returning call6413 (depth = 13)
// compiled member node returning call6413 (depth = 12)
  partcv[0] = 0;
  Object call6414 = callmethod(call6413, "kind",
    1, partcv, params);
  gc_frame_end(callframe6411);
// compiled call node returning call6414 (depth = 11)
// compiled member node returning call6414 (depth = 10)
  int op_slot_left_6408 = gc_frame_newslot(call6414);
  params[0] = strlit6409;
  partcv[0] = 1;
  Object opresult6415 = callmethod(call6414, "==", 1, partcv, params);
// compiled op node returning opresult6415 (depth = 9)
  Object if6407 = done;
  if (istrue(opresult6415)) {
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6416 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6418 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6417);
// compiled call node returning call6418 (depth = 11)
// compiled member node returning call6418 (depth = 10)
  gc_frame_newslot(call6418);
// starting to compile identifier node (depth = 10)
  Object bool6419 = alloc_Boolean(1);
// compiled identifier node returning bool6419 (depth = 10)
  gc_frame_newslot(bool6419);
// starting to compile identifier node (depth = 10)
  Object bool6420 = alloc_Boolean(0);
// compiled identifier node returning bool6420 (depth = 10)
  gc_frame_newslot(bool6420);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6418;
  params[2] = bool6419;
  params[3] = bool6420;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6421 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6416);
// compiled call node returning call6421 (depth = 9)
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6422 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6423 == NULL) {
    strlit6423 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6423);
  }
// compiled string node returning strlit6423 (depth = 10)
  gc_frame_newslot(strlit6423);
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6424 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6425 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6424);
// compiled call node returning call6425 (depth = 11)
// compiled member node returning call6425 (depth = 10)
  gc_frame_newslot(call6425);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6427 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6426);
// compiled call node returning call6427 (depth = 11)
// compiled member node returning call6427 (depth = 10)
  gc_frame_newslot(call6427);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num6429 = alloc_Float64(1);
// compiled num node returning num6429 (depth = 11)
  int op_slot_right_6428 = gc_frame_newslot(num6429);
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe6433 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call6434 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6433);
// compiled call node returning call6434 (depth = 15)
// compiled member node returning call6434 (depth = 14)
  partcv[0] = 0;
  Object call6435 = callmethod(call6434, "size",
    1, partcv, params);
  gc_frame_end(callframe6432);
// compiled call node returning call6435 (depth = 13)
// compiled member node returning call6435 (depth = 12)
  int op_slot_right_6431 = gc_frame_newslot(call6435);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6437 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe6438 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 16)
// compiled identifier node returning *var_sym (depth = 16)
  partcv[0] = 0;
  Object call6439 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6438);
// compiled call node returning call6439 (depth = 15)
// compiled member node returning call6439 (depth = 14)
  partcv[0] = 0;
  Object call6440 = callmethod(call6439, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6437);
// compiled call node returning call6440 (depth = 13)
// compiled member node returning call6440 (depth = 12)
  int op_slot_left_6431 = gc_frame_newslot(call6440);
  params[0] = call6435;
  partcv[0] = 1;
  Object sum6441 = callmethod(call6440, "+", 1, partcv, params);
// compiled op node returning sum6441 (depth = 11)
  int op_slot_left_6428 = gc_frame_newslot(sum6441);
  params[0] = num6429;
  partcv[0] = 1;
  Object diff6442 = callmethod(sum6441, "-", 1, partcv, params);
// compiled op node returning diff6442 (depth = 10)
  gc_frame_newslot(diff6442);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6423;
  params[1] = call6425;
  params[2] = call6427;
  params[3] = diff6442;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6443 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6422);
// compiled call node returning call6443 (depth = 9)
    gc_frame_newslot(call6443);
    if6407 = call6443;
  } else {
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6444 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6445 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe6444);
// compiled call node returning call6445 (depth = 9)
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6446 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6447 == NULL) {
    strlit6447 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6447);
  }
// compiled string node returning strlit6447 (depth = 10)
  gc_frame_newslot(strlit6447);
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6449 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6448);
// compiled call node returning call6449 (depth = 11)
// compiled member node returning call6449 (depth = 10)
  gc_frame_newslot(call6449);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6451 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6450);
// compiled call node returning call6451 (depth = 11)
// compiled member node returning call6451 (depth = 10)
  gc_frame_newslot(call6451);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6453 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6452);
// compiled call node returning call6453 (depth = 11)
// compiled member node returning call6453 (depth = 10)
  gc_frame_newslot(call6453);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  params[0] = strlit6447;
  params[1] = call6449;
  params[2] = call6451;
  params[3] = call6453;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6454 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6446);
// compiled call node returning call6454 (depth = 9)
    gc_frame_newslot(call6454);
    if6407 = call6454;
  }
// compiled if node returning if6407 (depth = 8)
    gc_frame_newslot(if6407);
    if6396 = if6407;
  } else {
  }
// compiled if node returning if6396 (depth = 7)
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6455 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6456 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6455);
// compiled call node returning call6456 (depth = 8)
// compiled member node returning call6456 (depth = 7)
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6458 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6459 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block6460 = alloc_Block(NULL, NULL, "parser", 2043);
  gc_frame_newslot(block6460);
// method _apply
  block_savedest(block6460);
  Object closure6461 = createclosure(2, "_apply");
  setclosureframe(closure6461, stackframe);
  addtoclosure(closure6461, var_blocksOK);
  addtoclosure(closure6461, selfslot);
  struct UserObject *uo6461 = (struct UserObject*)block6460;
  uo6461->data[0] = (Object)closure6461;
  Method *meth_meth_parser__apply6461 = addmethod2pos(block6460, "_apply", &meth_parser__apply6461, 0);
  int argcv_meth_parser__apply6461[] = {0};
  meth_meth_parser__apply6461->type = alloc_MethodType(1, argcv_meth_parser__apply6461);
  meth_meth_parser__apply6461->definitionModule = modulename;
  meth_meth_parser__apply6461->definitionLine = 2043;
// compiled block node returning block6460 (depth = 11)
  gc_frame_newslot(block6460);
// call case 4: self request
  params[0] = block6460;
  partcv[0] = 1;
  Object call6465 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6459);
// compiled call node returning call6465 (depth = 10)
  partcv[0] = 0;
  Object call6466 = callmethod(call6465, "not",
    1, partcv, params);
  gc_frame_end(callframe6458);
// compiled call node returning call6466 (depth = 9)
// compiled member node returning call6466 (depth = 8)
  Object if6457 = done;
  if (istrue(call6466)) {
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6467 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6468 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6467);
// compiled call node returning call6468 (depth = 9)
// compiled member node returning call6468 (depth = 8)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array6469 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6469 (depth = 9)
  *var_suggestions = array6469;
  if (array6469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6470 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6471 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6472 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6471);
// compiled call node returning call6472 (depth = 12)
// compiled member node returning call6472 (depth = 11)
  partcv[0] = 0;
  Object call6473 = callmethod(call6472, "new",
    1, partcv, params);
  gc_frame_end(callframe6470);
// compiled call node returning call6473 (depth = 10)
// compiled member node returning call6473 (depth = 9)
  *var_suggestion = call6473;
  if (call6473 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6474 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6475 == NULL) {
    strlit6475 = alloc_String("rparen");
    gc_root(strlit6475);
  }
// compiled string node returning strlit6475 (depth = 10)
  gc_frame_newslot(strlit6475);
// call case 4: self request
  params[0] = strlit6475;
  partcv[0] = 1;
  Object call6476 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6474);
// compiled call node returning call6476 (depth = 9)
  *var_nextTok = call6476;
  if (call6476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_6478 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_6478 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6480 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6480 (depth = 9)
  Object if6477 = done;
  if (istrue(opresult6480)) {
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6481 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6482 == NULL) {
    strlit6482 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6482);
  }
// compiled string node returning strlit6482 (depth = 10)
  gc_frame_newslot(strlit6482);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit6482;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6483 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6481);
// compiled call node returning call6483 (depth = 9)
    gc_frame_newslot(call6483);
    if6477 = call6483;
  } else {
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe6484 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6485 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call6486 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6485);
// compiled call node returning call6486 (depth = 11)
// compiled member node returning call6486 (depth = 10)
  gc_frame_newslot(call6486);
// starting to compile identifier node (depth = 10)
  Object bool6487 = alloc_Boolean(1);
// compiled identifier node returning bool6487 (depth = 10)
  gc_frame_newslot(bool6487);
// starting to compile identifier node (depth = 10)
  Object bool6488 = alloc_Boolean(0);
// compiled identifier node returning bool6488 (depth = 10)
  gc_frame_newslot(bool6488);
// starting to compile string node (depth = 10)
  if (strlit6489 == NULL) {
    strlit6489 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6489);
  }
// compiled string node returning strlit6489 (depth = 10)
  gc_frame_newslot(strlit6489);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call6486;
  params[2] = bool6487;
  params[3] = bool6488;
  params[4] = strlit6489;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6490 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6484);
// compiled call node returning call6490 (depth = 9)
    gc_frame_newslot(call6490);
    if6477 = call6490;
  }
// compiled if node returning if6477 (depth = 8)
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6491 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6492 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6491);
// compiled call node returning call6492 (depth = 8)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6493 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6494 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6495 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6494);
// compiled call node returning call6495 (depth = 12)
// compiled member node returning call6495 (depth = 11)
  partcv[0] = 0;
  Object call6496 = callmethod(call6495, "new",
    1, partcv, params);
  gc_frame_end(callframe6493);
// compiled call node returning call6496 (depth = 10)
// compiled member node returning call6496 (depth = 9)
  *var_suggestion = call6496;
  if (call6496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6498 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6499 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6500 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6499);
// compiled call node returning call6500 (depth = 10)
// compiled member node returning call6500 (depth = 9)
  gc_frame_newslot(call6500);
// starting to compile identifier node (depth = 9)
  Object bool6501 = alloc_Boolean(1);
// compiled identifier node returning bool6501 (depth = 9)
  gc_frame_newslot(bool6501);
// starting to compile identifier node (depth = 9)
  Object bool6502 = alloc_Boolean(0);
// compiled identifier node returning bool6502 (depth = 9)
  gc_frame_newslot(bool6502);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call6500;
  params[2] = bool6501;
  params[3] = bool6502;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6503 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6498);
// compiled call node returning call6503 (depth = 8)
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6504 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6505 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6504);
// compiled call node returning call6505 (depth = 8)
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6506 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6507 == NULL) {
    strlit6507 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit6507);
  }
// compiled string node returning strlit6507 (depth = 9)
  gc_frame_newslot(strlit6507);
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6509 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6508);
// compiled call node returning call6509 (depth = 10)
// compiled member node returning call6509 (depth = 9)
  gc_frame_newslot(call6509);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6511 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6510);
// compiled call node returning call6511 (depth = 10)
// compiled member node returning call6511 (depth = 9)
  gc_frame_newslot(call6511);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6507;
  params[1] = call6509;
  params[2] = call6511;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6512 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6506);
// compiled call node returning call6512 (depth = 8)
    gc_frame_newslot(call6512);
    if6457 = call6512;
  } else {
  }
// compiled if node returning if6457 (depth = 7)
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6513 = gc_frame_new();
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6514 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call6515 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6514);
// compiled call node returning call6515 (depth = 10)
// compiled member node returning call6515 (depth = 9)
  gc_frame_newslot(call6515);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_arg (depth = 9)
  params[0] = call6515;
  partcv[0] = 1;
  Object call6516 = callmethod(*var_arg, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6513);
// compiled call node returning call6516 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6517 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_arg (depth = 8)
  gc_frame_newslot(*var_arg);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  params[0] = *var_arg;
  partcv[0] = 1;
  Object call6518 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6517);
// compiled call node returning call6518 (depth = 7)
    gc_frame_newslot(call6518);
    if6390 = call6518;
  } else {
  }
// compiled if node returning if6390 (depth = 6)
  gc_frame_end(frame);
  return if6390;
}
Object meth_parser__apply6187(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6189 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6190 == NULL) {
    strlit6190 = alloc_String("colon");
    gc_root(strlit6190);
  }
// compiled string node returning strlit6190 (depth = 6)
  gc_frame_newslot(strlit6190);
// call case 4: self request
  params[0] = strlit6190;
  partcv[0] = 1;
  Object call6191 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6189);
// compiled call node returning call6191 (depth = 5)
  Object if6188 = done;
  if (istrue(call6191)) {
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6193 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6192);
// compiled call node returning call6193 (depth = 7)
// compiled member node returning call6193 (depth = 6)
  *var_expr = call6193;
  if (call6193 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6196 == NULL) {
    strlit6196 = alloc_String("identifier");
    gc_root(strlit6196);
  }
// compiled string node returning strlit6196 (depth = 7)
  int op_slot_right_6195 = gc_frame_newslot(strlit6196);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_expr (depth = 9)
  partcv[0] = 0;
  Object call6199 = callmethod(*var_expr, "kind",
    1, partcv, params);
  gc_frame_end(callframe6198);
// compiled call node returning call6199 (depth = 8)
// compiled member node returning call6199 (depth = 7)
  int op_slot_left_6195 = gc_frame_newslot(call6199);
  params[0] = strlit6196;
  partcv[0] = 1;
  Object opresult6200 = callmethod(call6199, "!=", 1, partcv, params);
// compiled op node returning opresult6200 (depth = 6)
  Object if6194 = done;
  if (istrue(opresult6200)) {
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6201 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6202 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6203 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6202);
// compiled call node returning call6203 (depth = 10)
// compiled member node returning call6203 (depth = 9)
  partcv[0] = 0;
  Object call6204 = callmethod(call6203, "new",
    1, partcv, params);
  gc_frame_end(callframe6201);
// compiled call node returning call6204 (depth = 8)
// compiled member node returning call6204 (depth = 7)
  *var_suggestion = call6204;
  if (call6204 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6207 == NULL) {
    strlit6207 = alloc_String("identifier");
    gc_root(strlit6207);
  }
// compiled string node returning strlit6207 (depth = 8)
  int op_slot_right_6206 = gc_frame_newslot(strlit6207);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6209 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call6211 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6210);
// compiled call node returning call6211 (depth = 11)
// compiled member node returning call6211 (depth = 10)
  partcv[0] = 0;
  Object call6212 = callmethod(call6211, "kind",
    1, partcv, params);
  gc_frame_end(callframe6209);
// compiled call node returning call6212 (depth = 9)
// compiled member node returning call6212 (depth = 8)
  int op_slot_left_6206 = gc_frame_newslot(call6212);
  params[0] = strlit6207;
  partcv[0] = 1;
  Object opresult6213 = callmethod(call6212, "==", 1, partcv, params);
// compiled op node returning opresult6213 (depth = 7)
  Object if6205 = done;
  if (istrue(opresult6213)) {
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6214 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6216 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6215);
// compiled call node returning call6216 (depth = 9)
// compiled member node returning call6216 (depth = 8)
  gc_frame_newslot(call6216);
// starting to compile identifier node (depth = 8)
  Object bool6217 = alloc_Boolean(1);
// compiled identifier node returning bool6217 (depth = 8)
  gc_frame_newslot(bool6217);
// starting to compile identifier node (depth = 8)
  Object bool6218 = alloc_Boolean(0);
// compiled identifier node returning bool6218 (depth = 8)
  gc_frame_newslot(bool6218);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call6216;
  params[2] = bool6217;
  params[3] = bool6218;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6219 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6214);
// compiled call node returning call6219 (depth = 7)
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6220 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6221 == NULL) {
    strlit6221 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6221);
  }
// compiled string node returning strlit6221 (depth = 8)
  gc_frame_newslot(strlit6221);
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6222 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6223 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6222);
// compiled call node returning call6223 (depth = 9)
// compiled member node returning call6223 (depth = 8)
  gc_frame_newslot(call6223);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6225 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6224);
// compiled call node returning call6225 (depth = 9)
// compiled member node returning call6225 (depth = 8)
  gc_frame_newslot(call6225);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num6227 = alloc_Float64(1);
// compiled num node returning num6227 (depth = 9)
  int op_slot_right_6226 = gc_frame_newslot(num6227);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6230 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6232 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6231);
// compiled call node returning call6232 (depth = 13)
// compiled member node returning call6232 (depth = 12)
  partcv[0] = 0;
  Object call6233 = callmethod(call6232, "size",
    1, partcv, params);
  gc_frame_end(callframe6230);
// compiled call node returning call6233 (depth = 11)
// compiled member node returning call6233 (depth = 10)
  int op_slot_right_6229 = gc_frame_newslot(call6233);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6235 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe6236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call6237 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6236);
// compiled call node returning call6237 (depth = 13)
// compiled member node returning call6237 (depth = 12)
  partcv[0] = 0;
  Object call6238 = callmethod(call6237, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6235);
// compiled call node returning call6238 (depth = 11)
// compiled member node returning call6238 (depth = 10)
  int op_slot_left_6229 = gc_frame_newslot(call6238);
  params[0] = call6233;
  partcv[0] = 1;
  Object sum6239 = callmethod(call6238, "+", 1, partcv, params);
// compiled op node returning sum6239 (depth = 9)
  int op_slot_left_6226 = gc_frame_newslot(sum6239);
  params[0] = num6227;
  partcv[0] = 1;
  Object diff6240 = callmethod(sum6239, "-", 1, partcv, params);
// compiled op node returning diff6240 (depth = 8)
  gc_frame_newslot(diff6240);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6221;
  params[1] = call6223;
  params[2] = call6225;
  params[3] = diff6240;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6241 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6220);
// compiled call node returning call6241 (depth = 7)
    gc_frame_newslot(call6241);
    if6205 = call6241;
  } else {
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6242 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool6243 = alloc_Boolean(1);
// compiled identifier node returning bool6243 (depth = 8)
  gc_frame_newslot(bool6243);
// starting to compile identifier node (depth = 8)
  Object bool6244 = alloc_Boolean(0);
// compiled identifier node returning bool6244 (depth = 8)
  gc_frame_newslot(bool6244);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool6243;
  params[2] = bool6244;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6245 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6242);
// compiled call node returning call6245 (depth = 7)
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6246 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6247 == NULL) {
    strlit6247 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6247);
  }
// compiled string node returning strlit6247 (depth = 8)
  gc_frame_newslot(strlit6247);
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6248 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6249 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6248);
// compiled call node returning call6249 (depth = 9)
// compiled member node returning call6249 (depth = 8)
  gc_frame_newslot(call6249);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6250 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6251 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6250);
// compiled call node returning call6251 (depth = 9)
// compiled member node returning call6251 (depth = 8)
  gc_frame_newslot(call6251);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6252 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6253 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6252);
// compiled call node returning call6253 (depth = 9)
// compiled member node returning call6253 (depth = 8)
  gc_frame_newslot(call6253);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6247;
  params[1] = call6249;
  params[2] = call6251;
  params[3] = call6253;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6254 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6246);
// compiled call node returning call6254 (depth = 7)
    gc_frame_newslot(call6254);
    if6205 = call6254;
  }
// compiled if node returning if6205 (depth = 6)
    gc_frame_newslot(if6205);
    if6194 = if6205;
  } else {
  }
// compiled if node returning if6194 (depth = 5)
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6256 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6255);
// compiled call node returning call6256 (depth = 6)
// compiled member node returning call6256 (depth = 5)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6258 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe6259 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block6260 = alloc_Block(NULL, NULL, "parser", 1988);
  gc_frame_newslot(block6260);
// method _apply
  block_savedest(block6260);
  Object closure6261 = createclosure(2, "_apply");
  setclosureframe(closure6261, stackframe);
  addtoclosure(closure6261, var_blocksOK);
  addtoclosure(closure6261, selfslot);
  struct UserObject *uo6261 = (struct UserObject*)block6260;
  uo6261->data[0] = (Object)closure6261;
  Method *meth_meth_parser__apply6261 = addmethod2pos(block6260, "_apply", &meth_parser__apply6261, 0);
  int argcv_meth_parser__apply6261[] = {0};
  meth_meth_parser__apply6261->type = alloc_MethodType(1, argcv_meth_parser__apply6261);
  meth_meth_parser__apply6261->definitionModule = modulename;
  meth_meth_parser__apply6261->definitionLine = 1988;
// compiled block node returning block6260 (depth = 9)
  gc_frame_newslot(block6260);
// call case 4: self request
  params[0] = block6260;
  partcv[0] = 1;
  Object call6265 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6259);
// compiled call node returning call6265 (depth = 8)
  partcv[0] = 0;
  Object call6266 = callmethod(call6265, "not",
    1, partcv, params);
  gc_frame_end(callframe6258);
// compiled call node returning call6266 (depth = 7)
// compiled member node returning call6266 (depth = 6)
  Object if6257 = done;
  if (istrue(call6266)) {
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6267 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6268 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6267);
// compiled call node returning call6268 (depth = 7)
// compiled member node returning call6268 (depth = 6)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 7)
  Object array6269 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6269 (depth = 7)
  *var_suggestions = array6269;
  if (array6269 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6270 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6271 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6272 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6271);
// compiled call node returning call6272 (depth = 10)
// compiled member node returning call6272 (depth = 9)
  partcv[0] = 0;
  Object call6273 = callmethod(call6272, "new",
    1, partcv, params);
  gc_frame_end(callframe6270);
// compiled call node returning call6273 (depth = 8)
// compiled member node returning call6273 (depth = 7)
  *var_suggestion = call6273;
  if (call6273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6274 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6275 == NULL) {
    strlit6275 = alloc_String("rparen");
    gc_root(strlit6275);
  }
// compiled string node returning strlit6275 (depth = 8)
  gc_frame_newslot(strlit6275);
// call case 4: self request
  params[0] = strlit6275;
  partcv[0] = 1;
  Object call6276 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6274);
// compiled call node returning call6276 (depth = 7)
  *var_nextTok = call6276;
  if (call6276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_6278 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_6278 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6280 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6280 (depth = 7)
  Object if6277 = done;
  if (istrue(opresult6280)) {
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6281 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6282 == NULL) {
    strlit6282 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6282);
  }
// compiled string node returning strlit6282 (depth = 8)
  gc_frame_newslot(strlit6282);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit6282;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6283 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6281);
// compiled call node returning call6283 (depth = 7)
    gc_frame_newslot(call6283);
    if6277 = call6283;
  } else {
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6284 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6285 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call6286 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6285);
// compiled call node returning call6286 (depth = 9)
// compiled member node returning call6286 (depth = 8)
  gc_frame_newslot(call6286);
// starting to compile identifier node (depth = 8)
  Object bool6287 = alloc_Boolean(1);
// compiled identifier node returning bool6287 (depth = 8)
  gc_frame_newslot(bool6287);
// starting to compile identifier node (depth = 8)
  Object bool6288 = alloc_Boolean(0);
// compiled identifier node returning bool6288 (depth = 8)
  gc_frame_newslot(bool6288);
// starting to compile string node (depth = 8)
  if (strlit6289 == NULL) {
    strlit6289 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6289);
  }
// compiled string node returning strlit6289 (depth = 8)
  gc_frame_newslot(strlit6289);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call6286;
  params[2] = bool6287;
  params[3] = bool6288;
  params[4] = strlit6289;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6290 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6284);
// compiled call node returning call6290 (depth = 7)
    gc_frame_newslot(call6290);
    if6277 = call6290;
  }
// compiled if node returning if6277 (depth = 6)
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6291 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6292 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6291);
// compiled call node returning call6292 (depth = 6)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6293 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6294 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call6295 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6294);
// compiled call node returning call6295 (depth = 10)
// compiled member node returning call6295 (depth = 9)
  partcv[0] = 0;
  Object call6296 = callmethod(call6295, "new",
    1, partcv, params);
  gc_frame_end(callframe6293);
// compiled call node returning call6296 (depth = 8)
// compiled member node returning call6296 (depth = 7)
  *var_suggestion = call6296;
  if (call6296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6298 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call6300 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6299);
// compiled call node returning call6300 (depth = 8)
// compiled member node returning call6300 (depth = 7)
  gc_frame_newslot(call6300);
// starting to compile identifier node (depth = 7)
  Object bool6301 = alloc_Boolean(1);
// compiled identifier node returning bool6301 (depth = 7)
  gc_frame_newslot(bool6301);
// starting to compile identifier node (depth = 7)
  Object bool6302 = alloc_Boolean(0);
// compiled identifier node returning bool6302 (depth = 7)
  gc_frame_newslot(bool6302);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_lastToken;
  params[1] = call6300;
  params[2] = bool6301;
  params[3] = bool6302;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6303 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6298);
// compiled call node returning call6303 (depth = 6)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6304 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6305 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6304);
// compiled call node returning call6305 (depth = 6)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6306 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6307 == NULL) {
    strlit6307 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit6307);
  }
// compiled string node returning strlit6307 (depth = 7)
  gc_frame_newslot(strlit6307);
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6309 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6308);
// compiled call node returning call6309 (depth = 8)
// compiled member node returning call6309 (depth = 7)
  gc_frame_newslot(call6309);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6310 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6311 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6310);
// compiled call node returning call6311 (depth = 8)
// compiled member node returning call6311 (depth = 7)
  gc_frame_newslot(call6311);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6307;
  params[1] = call6309;
  params[2] = call6311;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6312 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6306);
// compiled call node returning call6312 (depth = 6)
    gc_frame_newslot(call6312);
    if6257 = call6312;
  } else {
  }
// compiled if node returning if6257 (depth = 5)
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6313 = gc_frame_new();
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6314 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call6315 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6314);
// compiled call node returning call6315 (depth = 8)
// compiled member node returning call6315 (depth = 7)
  gc_frame_newslot(call6315);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_expr (depth = 7)
  params[0] = call6315;
  partcv[0] = 1;
  Object call6316 = callmethod(*var_expr, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6313);
// compiled call node returning call6316 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6317 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_expr (depth = 6)
  gc_frame_newslot(*var_expr);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  params[0] = *var_expr;
  partcv[0] = 1;
  Object call6318 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6317);
// compiled call node returning call6318 (depth = 5)
    gc_frame_newslot(call6318);
    if6188 = call6318;
  } else {
  }
// compiled if node returning if6188 (depth = 4)
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6319 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6320 = alloc_Block(NULL, NULL, "parser", 2008);
  gc_frame_newslot(block6320);
// method _apply
  block_savedest(block6320);
  Object closure6321 = createclosure(1, "_apply");
  setclosureframe(closure6321, stackframe);
  addtoclosure(closure6321, selfslot);
  struct UserObject *uo6321 = (struct UserObject*)block6320;
  uo6321->data[0] = (Object)closure6321;
  Method *meth_meth_parser__apply6321 = addmethod2pos(block6320, "_apply", &meth_parser__apply6321, 0);
  int argcv_meth_parser__apply6321[] = {0};
  meth_meth_parser__apply6321->type = alloc_MethodType(1, argcv_meth_parser__apply6321);
  meth_meth_parser__apply6321->definitionModule = modulename;
  meth_meth_parser__apply6321->definitionLine = 2005;
// compiled block node returning block6320 (depth = 5)
  gc_frame_newslot(block6320);
// starting to compile block node (depth = 5)
  Object block6326 = alloc_Block(NULL, NULL, "parser", 2008);
  gc_frame_newslot(block6326);
// method _apply
  block_savedest(block6326);
  Object closure6327 = createclosure(7, "_apply");
  setclosureframe(closure6327, stackframe);
  addtoclosure(closure6327, var_values);
  addtoclosure(closure6327, var_part);
  addtoclosure(closure6327, var_blocksOK);
  addtoclosure(closure6327, var_errormessages);
  addtoclosure(closure6327, var_sym);
  addtoclosure(closure6327, var_lastToken);
  addtoclosure(closure6327, selfslot);
  struct UserObject *uo6327 = (struct UserObject*)block6326;
  uo6327->data[0] = (Object)closure6327;
  Method *meth_meth_parser__apply6327 = addmethod2pos(block6326, "_apply", &meth_parser__apply6327, 0);
  int argcv_meth_parser__apply6327[] = {0};
  meth_meth_parser__apply6327->type = alloc_MethodType(1, argcv_meth_parser__apply6327);
  meth_meth_parser__apply6327->definitionModule = modulename;
  meth_meth_parser__apply6327->definitionLine = 2005;
// compiled block node returning block6326 (depth = 5)
  gc_frame_newslot(block6326);
// call case 5: prelude request
  params[0] = block6320;
  params[1] = block6326;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6520 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6319);
// compiled call node returning call6520 (depth = 4)
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6521 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6522 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6523 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6522);
// compiled call node returning call6523 (depth = 6)
// compiled member node returning call6523 (depth = 5)
  gc_frame_newslot(call6523);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6524 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call6525 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6524);
// compiled call node returning call6525 (depth = 6)
// compiled member node returning call6525 (depth = 5)
  params[0] = call6523;
  partcv[0] = 1;
  Object call6526 = callmethod(call6525, "push",
    1, partcv, params);
  gc_frame_end(callframe6521);
// compiled call node returning call6526 (depth = 4)
  gc_frame_end(frame);
  return call6526;
}
Object meth_parser_parenthesizedArg6177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parenthesizedArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parenthesizedArg");
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parenthesizedArg (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parenthesizedArg");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6178 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6179 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6178);
// compiled call node returning call6179 (depth = 3)
// compiled member node returning call6179 (depth = 2)
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6180 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6181 = alloc_Block(NULL, NULL, "parser", 1971);
  gc_frame_newslot(block6181);
// method _apply
  block_savedest(block6181);
  Object closure6182 = createclosure(2, "_apply");
  setclosureframe(closure6182, stackframe);
  addtoclosure(closure6182, var_blocksOK);
  addtoclosure(closure6182, selfslot);
  struct UserObject *uo6182 = (struct UserObject*)block6181;
  uo6182->data[0] = (Object)closure6182;
  Method *meth_meth_parser__apply6182 = addmethod2pos(block6181, "_apply", &meth_parser__apply6182, 0);
  int argcv_meth_parser__apply6182[] = {0};
  meth_meth_parser__apply6182->type = alloc_MethodType(1, argcv_meth_parser__apply6182);
  meth_meth_parser__apply6182->definitionModule = modulename;
  meth_meth_parser__apply6182->definitionLine = 1970;
// compiled block node returning block6181 (depth = 3)
  gc_frame_newslot(block6181);
// starting to compile block node (depth = 3)
  Object block6186 = alloc_Block(NULL, NULL, "parser", 1971);
  gc_frame_newslot(block6186);
// method _apply
  block_savedest(block6186);
  Object closure6187 = createclosure(7, "_apply");
  setclosureframe(closure6187, stackframe);
  addtoclosure(closure6187, var_values);
  addtoclosure(closure6187, var_errormessages);
  addtoclosure(closure6187, var_sym);
  addtoclosure(closure6187, var_blocksOK);
  addtoclosure(closure6187, var_lastToken);
  addtoclosure(closure6187, var_part);
  addtoclosure(closure6187, selfslot);
  struct UserObject *uo6187 = (struct UserObject*)block6186;
  uo6187->data[0] = (Object)closure6187;
  Method *meth_meth_parser__apply6187 = addmethod2pos(block6186, "_apply", &meth_parser__apply6187, 0);
  int argcv_meth_parser__apply6187[] = {0};
  meth_meth_parser__apply6187->type = alloc_MethodType(1, argcv_meth_parser__apply6187);
  meth_meth_parser__apply6187->definitionModule = modulename;
  meth_meth_parser__apply6187->definitionLine = 1970;
// compiled block node returning block6186 (depth = 3)
  gc_frame_newslot(block6186);
// call case 4: self request
  params[0] = block6181;
  params[1] = block6186;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6528 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6180);
// compiled call node returning call6528 (depth = 2)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6531 == NULL) {
    strlit6531 = alloc_String("rparen");
    gc_root(strlit6531);
  }
// compiled string node returning strlit6531 (depth = 4)
  int op_slot_right_6530 = gc_frame_newslot(strlit6531);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6533 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6534 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6533);
// compiled call node returning call6534 (depth = 5)
// compiled member node returning call6534 (depth = 4)
  int op_slot_left_6530 = gc_frame_newslot(call6534);
  params[0] = strlit6531;
  partcv[0] = 1;
  Object opresult6535 = callmethod(call6534, "!=", 1, partcv, params);
// compiled op node returning opresult6535 (depth = 3)
  Object if6529 = done;
  if (istrue(opresult6535)) {
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6536 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6537 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6536);
// compiled call node returning call6537 (depth = 4)
// compiled member node returning call6537 (depth = 3)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6538 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6539 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6540 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6539);
// compiled call node returning call6540 (depth = 7)
// compiled member node returning call6540 (depth = 6)
  partcv[0] = 0;
  Object call6541 = callmethod(call6540, "new",
    1, partcv, params);
  gc_frame_end(callframe6538);
// compiled call node returning call6541 (depth = 5)
// compiled member node returning call6541 (depth = 4)
  *var_suggestion = call6541;
  if (call6541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6542 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6543 == NULL) {
    strlit6543 = alloc_String(")");
    gc_root(strlit6543);
  }
// compiled string node returning strlit6543 (depth = 4)
  gc_frame_newslot(strlit6543);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6543;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6544 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6542);
// compiled call node returning call6544 (depth = 3)
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6545 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6546 == NULL) {
    strlit6546 = alloc_String("A method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6546);
  }
// compiled string node returning strlit6546 (depth = 4)
  gc_frame_newslot(strlit6546);
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6548 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6547);
// compiled call node returning call6548 (depth = 5)
// compiled member node returning call6548 (depth = 4)
  gc_frame_newslot(call6548);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6551 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6550);
// compiled call node returning call6551 (depth = 6)
// compiled member node returning call6551 (depth = 5)
  int op_slot_right_6549 = gc_frame_newslot(call6551);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6553 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6554 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6553);
// compiled call node returning call6554 (depth = 6)
// compiled member node returning call6554 (depth = 5)
  int op_slot_left_6549 = gc_frame_newslot(call6554);
  params[0] = call6551;
  partcv[0] = 1;
  Object sum6555 = callmethod(call6554, "+", 1, partcv, params);
// compiled op node returning sum6555 (depth = 4)
  gc_frame_newslot(sum6555);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit6546;
  params[1] = call6548;
  params[2] = sum6555;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6556 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6545);
// compiled call node returning call6556 (depth = 3)
    gc_frame_newslot(call6556);
    if6529 = call6556;
  } else {
  }
// compiled if node returning if6529 (depth = 2)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6559 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call6560 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe6559);
// compiled call node returning call6560 (depth = 5)
// compiled member node returning call6560 (depth = 4)
  int op_slot_right_6558 = gc_frame_newslot(call6560);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6563 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6562);
// compiled call node returning call6563 (depth = 5)
// compiled member node returning call6563 (depth = 4)
  int op_slot_left_6558 = gc_frame_newslot(call6563);
  params[0] = call6560;
  partcv[0] = 1;
  Object opresult6564 = callmethod(call6563, "==", 1, partcv, params);
// compiled op node returning opresult6564 (depth = 3)
  Object if6557 = done;
  if (istrue(opresult6564)) {
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2073
  setline(2073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6565 = gc_frame_new();
// Begin line 2075
  setline(2075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6567 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call6568 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6567);
// compiled call node returning call6568 (depth = 7)
// compiled member node returning call6568 (depth = 6)
  int op_slot_right_6566 = gc_frame_newslot(call6568);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6570 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6571 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6570);
// compiled call node returning call6571 (depth = 7)
// compiled member node returning call6571 (depth = 6)
  int op_slot_left_6566 = gc_frame_newslot(call6571);
  params[0] = call6568;
  partcv[0] = 1;
  Object diff6572 = callmethod(call6571, "-", 1, partcv, params);
// compiled op node returning diff6572 (depth = 5)
  gc_frame_newslot(diff6572);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = diff6572;
  partcv[0] = 1;
  Object call6573 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe6565);
// compiled call node returning call6573 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if6557 = done;
  } else {
  }
// compiled if node returning if6557 (depth = 2)
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6574 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6575 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6574);
// compiled call node returning call6575 (depth = 3)
// compiled member node returning call6575 (depth = 2)
  gc_frame_end(frame);
  return call6575;
}
Object meth_parser__apply6595(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6596 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6597 = callmethodflags(self, "typeArg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6596);
// compiled call node returning call6597 (depth = 7)
// compiled member node returning call6597 (depth = 6)
  gc_frame_end(frame);
  return call6597;
}
Object meth_parser__apply6592(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe6593 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6594 = alloc_Block(NULL, NULL, "parser", 2085);
  gc_frame_newslot(block6594);
// method _apply
  block_savedest(block6594);
  Object closure6595 = createclosure(1, "_apply");
  setclosureframe(closure6595, stackframe);
  addtoclosure(closure6595, selfslot);
  struct UserObject *uo6595 = (struct UserObject*)block6594;
  uo6595->data[0] = (Object)closure6595;
  Method *meth_meth_parser__apply6595 = addmethod2pos(block6594, "_apply", &meth_parser__apply6595, 0);
  int argcv_meth_parser__apply6595[] = {0};
  meth_meth_parser__apply6595->type = alloc_MethodType(1, argcv_meth_parser__apply6595);
  meth_meth_parser__apply6595->definitionModule = modulename;
  meth_meth_parser__apply6595->definitionLine = 2084;
// compiled block node returning block6594 (depth = 5)
  gc_frame_newslot(block6594);
// call case 4: self request
  params[0] = block6594;
  partcv[0] = 1;
  Object call6599 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6593);
// compiled call node returning call6599 (depth = 4)
  gc_frame_end(frame);
  return call6599;
}
Object meth_parser__apply6602(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_args = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6603 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6604 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6605 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6604);
// compiled call node returning call6605 (depth = 6)
// compiled member node returning call6605 (depth = 5)
  gc_frame_newslot(call6605);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_args (depth = 5)
  params[0] = call6605;
  partcv[0] = 1;
  Object call6606 = callmethod(*var_args, "add",
    1, partcv, params);
  gc_frame_end(callframe6603);
// compiled call node returning call6606 (depth = 4)
// Begin line 2088
  setline(2088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2087
  setline(2087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6609 == NULL) {
    strlit6609 = alloc_String("comma");
    gc_root(strlit6609);
  }
// compiled string node returning strlit6609 (depth = 6)
  int op_slot_right_6608 = gc_frame_newslot(strlit6609);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6611 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call6612 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6611);
// compiled call node returning call6612 (depth = 7)
// compiled member node returning call6612 (depth = 6)
  int op_slot_left_6608 = gc_frame_newslot(call6612);
  params[0] = strlit6609;
  partcv[0] = 1;
  Object opresult6613 = callmethod(call6612, "==", 1, partcv, params);
// compiled op node returning opresult6613 (depth = 5)
  Object if6607 = done;
  if (istrue(opresult6613)) {
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6614 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6615 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6614);
// compiled call node returning call6615 (depth = 6)
// compiled member node returning call6615 (depth = 5)
    gc_frame_newslot(call6615);
    if6607 = call6615;
  } else {
  }
// compiled if node returning if6607 (depth = 4)
  gc_frame_end(frame);
  return if6607;
}
Object meth_parser_typeArgs6576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArgs");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeArgs (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeArgs");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_startToken = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "startToken");
  Object *var_args = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "args");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 2081
  setline(2081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6577 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6578 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6579 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6578);
// compiled call node returning call6579 (depth = 6)
// compiled member node returning call6579 (depth = 5)
  partcv[0] = 0;
  Object call6580 = callmethod(call6579, "empty",
    1, partcv, params);
  gc_frame_end(callframe6577);
// compiled call node returning call6580 (depth = 4)
// compiled member node returning call6580 (depth = 3)
  *var_args = call6580;
  if (call6580 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6583 == NULL) {
    strlit6583 = alloc_String("lgeneric");
    gc_root(strlit6583);
  }
// compiled string node returning strlit6583 (depth = 4)
  int op_slot_right_6582 = gc_frame_newslot(strlit6583);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6585 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6586 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6585);
// compiled call node returning call6586 (depth = 5)
// compiled member node returning call6586 (depth = 4)
  int op_slot_left_6582 = gc_frame_newslot(call6586);
  params[0] = strlit6583;
  partcv[0] = 1;
  Object opresult6587 = callmethod(call6586, "!=", 1, partcv, params);
// compiled op node returning opresult6587 (depth = 3)
  Object if6581 = done;
  if (istrue(opresult6587)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_args (depth = 4)
  return *var_args;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6581 = undefined;
  } else {
  }
// compiled if node returning if6581 (depth = 2)
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6589 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6588);
// compiled call node returning call6589 (depth = 3)
// compiled member node returning call6589 (depth = 2)
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe6590 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6591 = alloc_Block(NULL, NULL, "parser", 2085);
  gc_frame_newslot(block6591);
// method _apply
  block_savedest(block6591);
  Object closure6592 = createclosure(1, "_apply");
  setclosureframe(closure6592, stackframe);
  addtoclosure(closure6592, selfslot);
  struct UserObject *uo6592 = (struct UserObject*)block6591;
  uo6592->data[0] = (Object)closure6592;
  Method *meth_meth_parser__apply6592 = addmethod2pos(block6591, "_apply", &meth_parser__apply6592, 0);
  int argcv_meth_parser__apply6592[] = {0};
  meth_meth_parser__apply6592->type = alloc_MethodType(1, argcv_meth_parser__apply6592);
  meth_meth_parser__apply6592->definitionModule = modulename;
  meth_meth_parser__apply6592->definitionLine = 2084;
// compiled block node returning block6591 (depth = 3)
  gc_frame_newslot(block6591);
// starting to compile block node (depth = 3)
  Object block6601 = alloc_Block(NULL, NULL, "parser", 2085);
  gc_frame_newslot(block6601);
// method _apply
  block_savedest(block6601);
  Object closure6602 = createclosure(4, "_apply");
  setclosureframe(closure6602, stackframe);
  addtoclosure(closure6602, var_values);
  addtoclosure(closure6602, var_args);
  addtoclosure(closure6602, var_sym);
  addtoclosure(closure6602, selfslot);
  struct UserObject *uo6602 = (struct UserObject*)block6601;
  uo6602->data[0] = (Object)closure6602;
  Method *meth_meth_parser__apply6602 = addmethod2pos(block6601, "_apply", &meth_parser__apply6602, 0);
  int argcv_meth_parser__apply6602[] = {0};
  meth_meth_parser__apply6602->type = alloc_MethodType(1, argcv_meth_parser__apply6602);
  meth_meth_parser__apply6602->definitionModule = modulename;
  meth_meth_parser__apply6602->definitionLine = 2085;
// compiled block node returning block6601 (depth = 3)
  gc_frame_newslot(block6601);
// call case 5: prelude request
  params[0] = block6591;
  params[1] = block6601;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6617 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6590);
// compiled call node returning call6617 (depth = 2)
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2089
  setline(2089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6620 == NULL) {
    strlit6620 = alloc_String("rgeneric");
    gc_root(strlit6620);
  }
// compiled string node returning strlit6620 (depth = 4)
  int op_slot_right_6619 = gc_frame_newslot(strlit6620);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call6623 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6622);
// compiled call node returning call6623 (depth = 5)
// compiled member node returning call6623 (depth = 4)
  int op_slot_left_6619 = gc_frame_newslot(call6623);
  params[0] = strlit6620;
  partcv[0] = 1;
  Object opresult6624 = callmethod(call6623, "!=", 1, partcv, params);
// compiled op node returning opresult6624 (depth = 3)
  Object if6618 = done;
  if (istrue(opresult6624)) {
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6625 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6627 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6626);
// compiled call node returning call6627 (depth = 7)
// compiled member node returning call6627 (depth = 6)
  partcv[0] = 0;
  Object call6628 = callmethod(call6627, "new",
    1, partcv, params);
  gc_frame_end(callframe6625);
// compiled call node returning call6628 (depth = 5)
// compiled member node returning call6628 (depth = 4)
  *var_suggestion = call6628;
  if (call6628 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2091
  setline(2091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6629 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6630 == NULL) {
    strlit6630 = alloc_String(">");
    gc_root(strlit6630);
  }
// compiled string node returning strlit6630 (depth = 4)
  gc_frame_newslot(strlit6630);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit6630;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6631 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6629);
// compiled call node returning call6631 (depth = 3)
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6632 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6633 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call6634 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6633);
// compiled call node returning call6634 (depth = 7)
// compiled member node returning call6634 (depth = 6)
  partcv[0] = 0;
  Object call6635 = callmethod(call6634, "new",
    1, partcv, params);
  gc_frame_end(callframe6632);
// compiled call node returning call6635 (depth = 5)
// compiled member node returning call6635 (depth = 4)
  *var_suggestion2 = call6635;
  if (call6635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6636 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6637 == NULL) {
    strlit6637 = alloc_String(" ");
    gc_root(strlit6637);
  }
// compiled string node returning strlit6637 (depth = 4)
  gc_frame_newslot(strlit6637);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startToken (depth = 4)
  gc_frame_newslot(*var_startToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion2 (depth = 4)
  params[0] = strlit6637;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6638 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe6636);
// compiled call node returning call6638 (depth = 3)
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array6639 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array6639, "push", 1, partcv, params);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion2 (depth = 5)
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array6639, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array6639 (depth = 4)
  *var_suggestions = array6639;
  if (array6639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6640 = gc_frame_new();
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6642 == NULL) {
    strlit6642 = alloc_String("If '<' is intended as an operator, precede it by a space.");
    gc_root(strlit6642);
  }
// compiled string node returning strlit6642 (depth = 5)
  int op_slot_right_6641 = gc_frame_newslot(strlit6642);
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit6644 == NULL) {
    strlit6644 = alloc_String("A method request containing a '<' must have a matching '>'. ");
    gc_root(strlit6644);
  }
// compiled string node returning strlit6644 (depth = 5)
  int op_slot_left_6641 = gc_frame_newslot(strlit6644);
  params[0] = strlit6642;
  partcv[0] = 1;
  Object opresult6645 = callmethod(strlit6644, "++", 1, partcv, params);
// compiled op node returning opresult6645 (depth = 4)
  gc_frame_newslot(opresult6645);
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6646 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call6647 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6646);
// compiled call node returning call6647 (depth = 5)
// compiled member node returning call6647 (depth = 4)
  gc_frame_newslot(call6647);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6649 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6650 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6649);
// compiled call node returning call6650 (depth = 6)
// compiled member node returning call6650 (depth = 5)
  int op_slot_right_6648 = gc_frame_newslot(call6650);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6652 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call6653 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6652);
// compiled call node returning call6653 (depth = 6)
// compiled member node returning call6653 (depth = 5)
  int op_slot_left_6648 = gc_frame_newslot(call6653);
  params[0] = call6650;
  partcv[0] = 1;
  Object sum6654 = callmethod(call6653, "+", 1, partcv, params);
// compiled op node returning sum6654 (depth = 4)
  gc_frame_newslot(sum6654);
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestions (depth = 4)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = opresult6645;
  params[1] = call6647;
  params[2] = sum6654;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6655 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6640);
// compiled call node returning call6655 (depth = 3)
    gc_frame_newslot(call6655);
    if6618 = call6655;
  } else {
  }
// compiled if node returning if6618 (depth = 2)
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe6656 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6657 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6656);
// compiled call node returning call6657 (depth = 3)
// compiled member node returning call6657 (depth = 2)
// Begin line 2102
  setline(2102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_args (depth = 3)
  return *var_args;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply6685(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6686 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6687 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6686);
// compiled call node returning call6687 (depth = 7)
// compiled member node returning call6687 (depth = 6)
  gc_frame_end(frame);
  return call6687;
}
Object meth_parser_typeArg6658(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeArg");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeArg (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typeArg");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6660 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6661 == NULL) {
    strlit6661 = alloc_String("identifier");
    gc_root(strlit6661);
  }
// compiled string node returning strlit6661 (depth = 4)
  gc_frame_newslot(strlit6661);
// call case 4: self request
  params[0] = strlit6661;
  partcv[0] = 1;
  Object call6662 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6660);
// compiled call node returning call6662 (depth = 3)
  Object if6659 = done;
  if (istrue(call6662)) {
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6664 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6663);
// compiled call node returning call6664 (depth = 4)
// compiled member node returning call6664 (depth = 3)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit6667 == NULL) {
    strlit6667 = alloc_String("lgeneric");
    gc_root(strlit6667);
  }
// compiled string node returning strlit6667 (depth = 5)
  int op_slot_right_6666 = gc_frame_newslot(strlit6667);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6669 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call6670 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6669);
// compiled call node returning call6670 (depth = 6)
// compiled member node returning call6670 (depth = 5)
  int op_slot_left_6666 = gc_frame_newslot(call6670);
  params[0] = strlit6667;
  partcv[0] = 1;
  Object opresult6671 = callmethod(call6670, "==", 1, partcv, params);
// compiled op node returning opresult6671 (depth = 4)
  Object if6665 = done;
  if (istrue(opresult6671)) {
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6672 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe6673 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6674 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call6675 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6674);
// compiled call node returning call6675 (depth = 7)
// compiled member node returning call6675 (depth = 6)
  gc_frame_newslot(call6675);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6676 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6677 = callmethodflags(self, "typeArgs", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6676);
// compiled call node returning call6677 (depth = 7)
// compiled member node returning call6677 (depth = 6)
  gc_frame_newslot(call6677);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6678 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call6679 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe6678);
// compiled call node returning call6679 (depth = 7)
// compiled member node returning call6679 (depth = 6)
  params[0] = call6675;
  params[1] = call6677;
  partcv[0] = 2;
  Object call6680 = callmethod(call6679, "new",
    1, partcv, params);
  gc_frame_end(callframe6673);
// compiled call node returning call6680 (depth = 5)
  gc_frame_newslot(call6680);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = call6680;
  partcv[0] = 1;
  Object call6681 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6672);
// compiled call node returning call6681 (depth = 4)
    gc_frame_newslot(call6681);
    if6665 = call6681;
  } else {
  }
// compiled if node returning if6665 (depth = 3)
    gc_frame_newslot(if6665);
    if6659 = if6665;
  } else {
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2115
  setline(2115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6683 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block6684 = alloc_Block(NULL, NULL, "parser", 2115);
  gc_frame_newslot(block6684);
// method _apply
  block_savedest(block6684);
  Object closure6685 = createclosure(1, "_apply");
  setclosureframe(closure6685, stackframe);
  addtoclosure(closure6685, selfslot);
  struct UserObject *uo6685 = (struct UserObject*)block6684;
  uo6685->data[0] = (Object)closure6685;
  Method *meth_meth_parser__apply6685 = addmethod2pos(block6684, "_apply", &meth_parser__apply6685, 0);
  int argcv_meth_parser__apply6685[] = {0};
  meth_meth_parser__apply6685->type = alloc_MethodType(1, argcv_meth_parser__apply6685);
  meth_meth_parser__apply6685->definitionModule = modulename;
  meth_meth_parser__apply6685->definitionLine = 2111;
// compiled block node returning block6684 (depth = 5)
  gc_frame_newslot(block6684);
// call case 4: self request
  params[0] = block6684;
  partcv[0] = 1;
  Object call6689 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6683);
// compiled call node returning call6689 (depth = 4)
  Object if6682 = done;
  if (istrue(call6689)) {
    gc_frame_newslot(done);
    if6682 = done;
  } else {
  }
// compiled if node returning if6682 (depth = 3)
    gc_frame_newslot(if6682);
    if6659 = if6682;
  }
// compiled if node returning if6659 (depth = 2)
  gc_frame_end(frame);
  return if6659;
}
Object meth_parser__apply6697(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6699 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6700 == NULL) {
    strlit6700 = alloc_String("identifier");
    gc_root(strlit6700);
  }
// compiled string node returning strlit6700 (depth = 6)
  gc_frame_newslot(strlit6700);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 4: self request
  params[0] = strlit6700;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6701 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6699);
// compiled call node returning call6701 (depth = 5)
  int op_slot_right_6698 = gc_frame_newslot(call6701);
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6703 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6704 == NULL) {
    strlit6704 = alloc_String("identifier");
    gc_root(strlit6704);
  }
// compiled string node returning strlit6704 (depth = 6)
  gc_frame_newslot(strlit6704);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tok (depth = 6)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6704;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6705 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6703);
// compiled call node returning call6705 (depth = 5)
  int op_slot_left_6698 = gc_frame_newslot(call6705);
  params[0] = call6701;
  partcv[0] = 1;
  Object opresult6706 = callmethod(call6705, "||", 1, partcv, params);
// compiled op node returning opresult6706 (depth = 4)
  gc_frame_end(frame);
  return opresult6706;
}
Object meth_parser__apply6929(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe6930 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call6931 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6930);
// compiled call node returning call6931 (depth = 11)
  gc_frame_end(frame);
  return call6931;
}
Object meth_parser__apply6981(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe6982 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6983 == NULL) {
    strlit6983 = alloc_String("comma");
    gc_root(strlit6983);
  }
// compiled string node returning strlit6983 (depth = 8)
  gc_frame_newslot(strlit6983);
// call case 4: self request
  params[0] = strlit6983;
  partcv[0] = 1;
  Object call6984 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6982);
// compiled call node returning call6984 (depth = 7)
  gc_frame_end(frame);
  return call6984;
}
Object meth_parser__apply7001(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe7002 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7003 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7002);
// compiled call node returning call7003 (depth = 12)
  gc_frame_end(frame);
  return call7003;
}
Object meth_parser__apply6987(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_nxt = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6988 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call6989 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6988);
// compiled call node returning call6989 (depth = 9)
// compiled member node returning call6989 (depth = 8)
  *var_nxt = call6989;
  if (call6989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6991 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6992 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call6993 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6992);
// compiled call node returning call6993 (depth = 9)
// compiled member node returning call6993 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6994 = callmethod(call6993, "push",
    1, partcv, params);
  gc_frame_end(callframe6991);
// compiled call node returning call6994 (depth = 7)
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6995 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6996 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6995);
// compiled call node returning call6996 (depth = 8)
// compiled member node returning call6996 (depth = 7)
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2210
  setline(2210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6998 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6999 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block7000 = alloc_Block(NULL, NULL, "parser", 2210);
  gc_frame_newslot(block7000);
// method _apply
  block_savedest(block7000);
  Object closure7001 = createclosure(2, "_apply");
  setclosureframe(closure7001, stackframe);
  addtoclosure(closure7001, var_blocksOK);
  addtoclosure(closure7001, selfslot);
  struct UserObject *uo7001 = (struct UserObject*)block7000;
  uo7001->data[0] = (Object)closure7001;
  Method *meth_meth_parser__apply7001 = addmethod2pos(block7000, "_apply", &meth_parser__apply7001, 0);
  int argcv_meth_parser__apply7001[] = {0};
  meth_meth_parser__apply7001->type = alloc_MethodType(1, argcv_meth_parser__apply7001);
  meth_meth_parser__apply7001->definitionModule = modulename;
  meth_meth_parser__apply7001->definitionLine = 2210;
// compiled block node returning block7000 (depth = 11)
  gc_frame_newslot(block7000);
// call case 4: self request
  params[0] = block7000;
  partcv[0] = 1;
  Object call7005 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6999);
// compiled call node returning call7005 (depth = 10)
  partcv[0] = 0;
  Object call7006 = callmethod(call7005, "not",
    1, partcv, params);
  gc_frame_end(callframe6998);
// compiled call node returning call7006 (depth = 9)
// compiled member node returning call7006 (depth = 8)
  Object if6997 = done;
  if (istrue(call7006)) {
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array7007 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7007 (depth = 9)
  *var_suggestions = array7007;
  if (array7007 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 2212
  setline(2212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7008 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7010 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7009);
// compiled call node returning call7010 (depth = 12)
// compiled member node returning call7010 (depth = 11)
  partcv[0] = 0;
  Object call7011 = callmethod(call7010, "new",
    1, partcv, params);
  gc_frame_end(callframe7008);
// compiled call node returning call7011 (depth = 10)
// compiled member node returning call7011 (depth = 9)
  *var_suggestion = call7011;
  if (call7011 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7012 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7013 == NULL) {
    strlit7013 = alloc_String("rparen");
    gc_root(strlit7013);
  }
// compiled string node returning strlit7013 (depth = 10)
  gc_frame_newslot(strlit7013);
// call case 4: self request
  params[0] = strlit7013;
  partcv[0] = 1;
  Object call7014 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7012);
// compiled call node returning call7014 (depth = 9)
  *var_nextTok = call7014;
  if (call7014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7016 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7016 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7018 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7018 (depth = 9)
  Object if7015 = done;
  if (istrue(opresult7018)) {
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7019 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7020 == NULL) {
    strlit7020 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7020);
  }
// compiled string node returning strlit7020 (depth = 10)
  gc_frame_newslot(strlit7020);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7020;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7021 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7019);
// compiled call node returning call7021 (depth = 9)
    gc_frame_newslot(call7021);
    if7015 = call7021;
  } else {
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7022 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call7024 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7023);
// compiled call node returning call7024 (depth = 11)
// compiled member node returning call7024 (depth = 10)
  gc_frame_newslot(call7024);
// starting to compile identifier node (depth = 10)
  Object bool7025 = alloc_Boolean(1);
// compiled identifier node returning bool7025 (depth = 10)
  gc_frame_newslot(bool7025);
// starting to compile identifier node (depth = 10)
  Object bool7026 = alloc_Boolean(0);
// compiled identifier node returning bool7026 (depth = 10)
  gc_frame_newslot(bool7026);
// starting to compile string node (depth = 10)
  if (strlit7027 == NULL) {
    strlit7027 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7027);
  }
// compiled string node returning strlit7027 (depth = 10)
  gc_frame_newslot(strlit7027);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7024;
  params[2] = bool7025;
  params[3] = bool7026;
  params[4] = strlit7027;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7028 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7022);
// compiled call node returning call7028 (depth = 9)
    gc_frame_newslot(call7028);
    if7015 = call7028;
  }
// compiled if node returning if7015 (depth = 8)
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7029 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7030 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7029);
// compiled call node returning call7030 (depth = 8)
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7031 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7032 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7033 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7032);
// compiled call node returning call7033 (depth = 12)
// compiled member node returning call7033 (depth = 11)
  partcv[0] = 0;
  Object call7034 = callmethod(call7033, "new",
    1, partcv, params);
  gc_frame_end(callframe7031);
// compiled call node returning call7034 (depth = 10)
// compiled member node returning call7034 (depth = 9)
  *var_suggestion = call7034;
  if (call7034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7036 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7037 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7038 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7037);
// compiled call node returning call7038 (depth = 10)
// compiled member node returning call7038 (depth = 9)
  gc_frame_newslot(call7038);
// starting to compile identifier node (depth = 9)
  Object bool7039 = alloc_Boolean(1);
// compiled identifier node returning bool7039 (depth = 9)
  gc_frame_newslot(bool7039);
// starting to compile identifier node (depth = 9)
  Object bool7040 = alloc_Boolean(0);
// compiled identifier node returning bool7040 (depth = 9)
  gc_frame_newslot(bool7040);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7038;
  params[2] = bool7039;
  params[3] = bool7040;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7041 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7036);
// compiled call node returning call7041 (depth = 8)
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7042 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7043 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7042);
// compiled call node returning call7043 (depth = 8)
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7044 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7045 == NULL) {
    strlit7045 = alloc_String("A method request must have an expression after a ','.");
    gc_root(strlit7045);
  }
// compiled string node returning strlit7045 (depth = 9)
  gc_frame_newslot(strlit7045);
// Begin line 2224
  setline(2224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7047 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7046);
// compiled call node returning call7047 (depth = 10)
// compiled member node returning call7047 (depth = 9)
  gc_frame_newslot(call7047);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7049 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7048);
// compiled call node returning call7049 (depth = 10)
// compiled member node returning call7049 (depth = 9)
  gc_frame_newslot(call7049);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7045;
  params[1] = call7047;
  params[2] = call7049;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7050 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7044);
// compiled call node returning call7050 (depth = 8)
    gc_frame_newslot(call7050);
    if6997 = call7050;
  } else {
  }
// compiled if node returning if6997 (depth = 7)
  gc_frame_end(frame);
  return if6997;
}
Object meth_parser__apply6709(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_signature = getfromclosure(closure, 2);
  Object *var_methname = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_nxt = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object *var_lastToken = getfromclosure(closure, 8);
  Object *var_tok = getfromclosure(closure, 9);
  Object *var_blocksOK = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isTerm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "isTerm");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_isEmpty = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isEmpty");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6710 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6711 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call6712 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe6711);
// compiled call node returning call6712 (depth = 8)
// compiled member node returning call6712 (depth = 7)
  partcv[0] = 0;
  Object call6713 = callmethod(call6712, "new",
    1, partcv, params);
  gc_frame_end(callframe6710);
// compiled call node returning call6713 (depth = 6)
// compiled member node returning call6713 (depth = 5)
  *var_part = call6713;
  if (call6713 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe6715 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6716 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe6715);
// compiled call node returning call6716 (depth = 4)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit6718 == NULL) {
    strlit6718 = alloc_String("()");
    gc_root(strlit6718);
  }
// compiled string node returning strlit6718 (depth = 6)
  int op_slot_right_6717 = gc_frame_newslot(strlit6718);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6717 = gc_frame_newslot(*var_methname);
  params[0] = strlit6718;
  partcv[0] = 1;
  Object opresult6720 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6720 (depth = 5)
  *var_methname = opresult6720;
  if (opresult6720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2136
  setline(2136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6723 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6722);
// compiled call node returning call6723 (depth = 5)
// compiled member node returning call6723 (depth = 4)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call6725 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6724);
// compiled call node returning call6725 (depth = 6)
// compiled member node returning call6725 (depth = 5)
  *var_nxt = call6725;
  if (call6725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call6729 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6728);
// compiled call node returning call6729 (depth = 7)
// compiled member node returning call6729 (depth = 6)
  int op_slot_right_6727 = gc_frame_newslot(call6729);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_6727 = gc_frame_newslot(*var_methname);
  params[0] = call6729;
  partcv[0] = 1;
  Object opresult6731 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult6731 (depth = 5)
  *var_methname = opresult6731;
  if (opresult6731 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6733 = gc_frame_new();
// Begin line 2139
  setline(2139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call6735 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6734);
// compiled call node returning call6735 (depth = 7)
// compiled member node returning call6735 (depth = 6)
  gc_frame_newslot(call6735);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = call6735;
  partcv[0] = 1;
  Object call6736 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6733);
// compiled call node returning call6736 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool6737 = alloc_Boolean(0);
// compiled identifier node returning bool6737 (depth = 5)
  *var_isTerm = bool6737;
  if (bool6737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6740 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe6741 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6742 == NULL) {
    strlit6742 = alloc_String("num");
    gc_root(strlit6742);
  }
// compiled string node returning strlit6742 (depth = 9)
  gc_frame_newslot(strlit6742);
// call case 4: self request
  params[0] = strlit6742;
  partcv[0] = 1;
  Object call6743 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6741);
// compiled call node returning call6743 (depth = 8)
  partcv[0] = 0;
  Object call6744 = callmethod(call6743, "not",
    1, partcv, params);
  gc_frame_end(callframe6740);
// compiled call node returning call6744 (depth = 7)
// compiled member node returning call6744 (depth = 6)
  int op_slot_right_6739 = gc_frame_newslot(call6744);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6747 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6748 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit6749 == NULL) {
    strlit6749 = alloc_String("string");
    gc_root(strlit6749);
  }
// compiled string node returning strlit6749 (depth = 10)
  gc_frame_newslot(strlit6749);
// call case 4: self request
  params[0] = strlit6749;
  partcv[0] = 1;
  Object call6750 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6748);
// compiled call node returning call6750 (depth = 9)
  partcv[0] = 0;
  Object call6751 = callmethod(call6750, "not",
    1, partcv, params);
  gc_frame_end(callframe6747);
// compiled call node returning call6751 (depth = 8)
// compiled member node returning call6751 (depth = 7)
  int op_slot_right_6746 = gc_frame_newslot(call6751);
// starting to compile op node (depth = 7)
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6754 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6755 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit6756 == NULL) {
    strlit6756 = alloc_String("lbrace");
    gc_root(strlit6756);
  }
// compiled string node returning strlit6756 (depth = 11)
  gc_frame_newslot(strlit6756);
// call case 4: self request
  params[0] = strlit6756;
  partcv[0] = 1;
  Object call6757 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6755);
// compiled call node returning call6757 (depth = 10)
  partcv[0] = 0;
  Object call6758 = callmethod(call6757, "not",
    1, partcv, params);
  gc_frame_end(callframe6754);
// compiled call node returning call6758 (depth = 9)
// compiled member node returning call6758 (depth = 8)
  int op_slot_right_6753 = gc_frame_newslot(call6758);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6760 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe6761 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit6762 == NULL) {
    strlit6762 = alloc_String("lparen");
    gc_root(strlit6762);
  }
// compiled string node returning strlit6762 (depth = 11)
  gc_frame_newslot(strlit6762);
// call case 4: self request
  params[0] = strlit6762;
  partcv[0] = 1;
  Object call6763 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6761);
// compiled call node returning call6763 (depth = 10)
  partcv[0] = 0;
  Object call6764 = callmethod(call6763, "not",
    1, partcv, params);
  gc_frame_end(callframe6760);
// compiled call node returning call6764 (depth = 9)
// compiled member node returning call6764 (depth = 8)
  int op_slot_left_6753 = gc_frame_newslot(call6764);
  params[0] = call6758;
  partcv[0] = 1;
  Object opresult6765 = callmethod(call6764, "&&", 1, partcv, params);
// compiled op node returning opresult6765 (depth = 7)
  int op_slot_left_6746 = gc_frame_newslot(opresult6765);
  params[0] = call6751;
  partcv[0] = 1;
  Object opresult6766 = callmethod(opresult6765, "&&", 1, partcv, params);
// compiled op node returning opresult6766 (depth = 6)
  int op_slot_left_6739 = gc_frame_newslot(opresult6766);
  params[0] = call6744;
  partcv[0] = 1;
  Object opresult6767 = callmethod(opresult6766, "&&", 1, partcv, params);
// compiled op node returning opresult6767 (depth = 5)
  Object if6738 = done;
  if (istrue(opresult6767)) {
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6768 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6769 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call6770 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6769);
// compiled call node returning call6770 (depth = 9)
// compiled member node returning call6770 (depth = 8)
  partcv[0] = 0;
  Object call6771 = callmethod(call6770, "new",
    1, partcv, params);
  gc_frame_end(callframe6768);
// compiled call node returning call6771 (depth = 7)
// compiled member node returning call6771 (depth = 6)
  *var_suggestion = call6771;
  if (call6771 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6774 == NULL) {
    strlit6774 = alloc_String("identifier");
    gc_root(strlit6774);
  }
// compiled string node returning strlit6774 (depth = 7)
  int op_slot_right_6773 = gc_frame_newslot(strlit6774);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6776 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6777 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6776);
// compiled call node returning call6777 (depth = 8)
// compiled member node returning call6777 (depth = 7)
  int op_slot_left_6773 = gc_frame_newslot(call6777);
  params[0] = strlit6774;
  partcv[0] = 1;
  Object opresult6778 = callmethod(call6777, "==", 1, partcv, params);
// compiled op node returning opresult6778 (depth = 6)
  Object if6772 = done;
  if (istrue(opresult6778)) {
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6779 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool6780 = alloc_Boolean(1);
// compiled identifier node returning bool6780 (depth = 7)
  gc_frame_newslot(bool6780);
// starting to compile identifier node (depth = 7)
  Object bool6781 = alloc_Boolean(0);
// compiled identifier node returning bool6781 (depth = 7)
  gc_frame_newslot(bool6781);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6783 == NULL) {
    strlit6783 = alloc_String(")");
    gc_root(strlit6783);
  }
// compiled string node returning strlit6783 (depth = 8)
  int op_slot_right_6782 = gc_frame_newslot(strlit6783);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6787 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6786);
// compiled call node returning call6787 (depth = 10)
// compiled member node returning call6787 (depth = 9)
  int op_slot_right_6785 = gc_frame_newslot(call6787);
// starting to compile string node (depth = 9)
  if (strlit6789 == NULL) {
    strlit6789 = alloc_String("(");
    gc_root(strlit6789);
  }
// compiled string node returning strlit6789 (depth = 9)
  int op_slot_left_6785 = gc_frame_newslot(strlit6789);
  params[0] = call6787;
  partcv[0] = 1;
  Object opresult6790 = callmethod(strlit6789, "++", 1, partcv, params);
// compiled op node returning opresult6790 (depth = 8)
  int op_slot_left_6782 = gc_frame_newslot(opresult6790);
  params[0] = strlit6783;
  partcv[0] = 1;
  Object opresult6791 = callmethod(opresult6790, "++", 1, partcv, params);
// compiled op node returning opresult6791 (depth = 7)
  gc_frame_newslot(opresult6791);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool6780;
  params[2] = bool6781;
  params[3] = opresult6791;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6792 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6779);
// compiled call node returning call6792 (depth = 6)
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6795 == NULL) {
    strlit6795 = alloc_String("while()do");
    gc_root(strlit6795);
  }
// compiled string node returning strlit6795 (depth = 8)
  int op_slot_right_6794 = gc_frame_newslot(strlit6795);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methname (depth = 8)
  int op_slot_left_6794 = gc_frame_newslot(*var_methname);
  params[0] = strlit6795;
  partcv[0] = 1;
  Object opresult6797 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6797 (depth = 7)
  Object if6793 = done;
  if (istrue(opresult6797)) {
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6798 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6799 == NULL) {
    strlit6799 = alloc_String("A while loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6799);
  }
// compiled string node returning strlit6799 (depth = 8)
  gc_frame_newslot(strlit6799);
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6800 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6801 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6800);
// compiled call node returning call6801 (depth = 9)
// compiled member node returning call6801 (depth = 8)
  gc_frame_newslot(call6801);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6802 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6803 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6802);
// compiled call node returning call6803 (depth = 9)
// compiled member node returning call6803 (depth = 8)
  gc_frame_newslot(call6803);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6799;
  params[1] = call6801;
  params[2] = call6803;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6804 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6798);
// compiled call node returning call6804 (depth = 7)
    gc_frame_newslot(call6804);
    if6793 = call6804;
  } else {
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6807 == NULL) {
    strlit6807 = alloc_String("for()do");
    gc_root(strlit6807);
  }
// compiled string node returning strlit6807 (depth = 9)
  int op_slot_right_6806 = gc_frame_newslot(strlit6807);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6806 = gc_frame_newslot(*var_methname);
  params[0] = strlit6807;
  partcv[0] = 1;
  Object opresult6809 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6809 (depth = 8)
  Object if6805 = done;
  if (istrue(opresult6809)) {
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6810 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6811 == NULL) {
    strlit6811 = alloc_String("A for loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6811);
  }
// compiled string node returning strlit6811 (depth = 9)
  gc_frame_newslot(strlit6811);
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6813 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6812);
// compiled call node returning call6813 (depth = 10)
// compiled member node returning call6813 (depth = 9)
  gc_frame_newslot(call6813);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6815 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6814);
// compiled call node returning call6815 (depth = 10)
// compiled member node returning call6815 (depth = 9)
  gc_frame_newslot(call6815);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6811;
  params[1] = call6813;
  params[2] = call6815;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6816 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6810);
// compiled call node returning call6816 (depth = 8)
    gc_frame_newslot(call6816);
    if6805 = call6816;
  } else {
  }
// compiled if node returning if6805 (depth = 7)
    gc_frame_newslot(if6805);
    if6793 = if6805;
  }
// compiled if node returning if6793 (depth = 6)
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe6817 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6818 == NULL) {
    strlit6818 = alloc_String("Each argument list in a multi-part method request must be parenthesized, unless it is self-delimiting.");
    gc_root(strlit6818);
  }
// compiled string node returning strlit6818 (depth = 7)
  gc_frame_newslot(strlit6818);
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6820 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6819);
// compiled call node returning call6820 (depth = 8)
// compiled member node returning call6820 (depth = 7)
  gc_frame_newslot(call6820);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6821 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6822 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6821);
// compiled call node returning call6822 (depth = 8)
// compiled member node returning call6822 (depth = 7)
  gc_frame_newslot(call6822);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit6818;
  params[1] = call6820;
  params[2] = call6822;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6823 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6817);
// compiled call node returning call6823 (depth = 6)
    gc_frame_newslot(call6823);
    if6772 = call6823;
  } else {
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit6826 == NULL) {
    strlit6826 = alloc_String("while()do");
    gc_root(strlit6826);
  }
// compiled string node returning strlit6826 (depth = 8)
  int op_slot_right_6825 = gc_frame_newslot(strlit6826);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_methname (depth = 8)
  int op_slot_left_6825 = gc_frame_newslot(*var_methname);
  params[0] = strlit6826;
  partcv[0] = 1;
  Object opresult6828 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6828 (depth = 7)
  Object if6824 = done;
  if (istrue(opresult6828)) {
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6829 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6830 == NULL) {
    strlit6830 = alloc_String(" {}");
    gc_root(strlit6830);
  }
// compiled string node returning strlit6830 (depth = 8)
  gc_frame_newslot(strlit6830);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit6830;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6831 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6829);
// compiled call node returning call6831 (depth = 7)
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6832 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6833 == NULL) {
    strlit6833 = alloc_String("A while loop must have a body.");
    gc_root(strlit6833);
  }
// compiled string node returning strlit6833 (depth = 8)
  gc_frame_newslot(strlit6833);
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6834 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6835 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6834);
// compiled call node returning call6835 (depth = 9)
// compiled member node returning call6835 (depth = 8)
  gc_frame_newslot(call6835);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6836 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6837 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6836);
// compiled call node returning call6837 (depth = 9)
// compiled member node returning call6837 (depth = 8)
  gc_frame_newslot(call6837);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6833;
  params[1] = call6835;
  params[2] = call6837;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6838 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6832);
// compiled call node returning call6838 (depth = 7)
    gc_frame_newslot(call6838);
    if6824 = call6838;
  } else {
// Begin line 2164
  setline(2164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6841 == NULL) {
    strlit6841 = alloc_String("for()do");
    gc_root(strlit6841);
  }
// compiled string node returning strlit6841 (depth = 9)
  int op_slot_right_6840 = gc_frame_newslot(strlit6841);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_methname (depth = 9)
  int op_slot_left_6840 = gc_frame_newslot(*var_methname);
  params[0] = strlit6841;
  partcv[0] = 1;
  Object opresult6843 = callmethod(*var_methname, "==", 1, partcv, params);
// compiled op node returning opresult6843 (depth = 8)
  Object if6839 = done;
  if (istrue(opresult6843)) {
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6844 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6845 == NULL) {
    strlit6845 = alloc_String(" {}");
    gc_root(strlit6845);
  }
// compiled string node returning strlit6845 (depth = 9)
  gc_frame_newslot(strlit6845);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6845;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6846 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6844);
// compiled call node returning call6846 (depth = 8)
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6847 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6848 == NULL) {
    strlit6848 = alloc_String("A for loop must have a body.");
    gc_root(strlit6848);
  }
// compiled string node returning strlit6848 (depth = 9)
  gc_frame_newslot(strlit6848);
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6849 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6850 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6849);
// compiled call node returning call6850 (depth = 10)
// compiled member node returning call6850 (depth = 9)
  gc_frame_newslot(call6850);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6851 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6852 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6851);
// compiled call node returning call6852 (depth = 10)
// compiled member node returning call6852 (depth = 9)
  gc_frame_newslot(call6852);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6848;
  params[1] = call6850;
  params[2] = call6852;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6853 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6847);
// compiled call node returning call6853 (depth = 8)
    gc_frame_newslot(call6853);
    if6839 = call6853;
  } else {
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6854 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6855 == NULL) {
    strlit6855 = alloc_String("()");
    gc_root(strlit6855);
  }
// compiled string node returning strlit6855 (depth = 9)
  gc_frame_newslot(strlit6855);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6855;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6856 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6854);
// compiled call node returning call6856 (depth = 8)
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6857 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6858 == NULL) {
    strlit6858 = alloc_String("A multi-part method request must end with '()'.");
    gc_root(strlit6858);
  }
// compiled string node returning strlit6858 (depth = 9)
  gc_frame_newslot(strlit6858);
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6859 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6860 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6859);
// compiled call node returning call6860 (depth = 10)
// compiled member node returning call6860 (depth = 9)
  gc_frame_newslot(call6860);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6862 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6861);
// compiled call node returning call6862 (depth = 10)
// compiled member node returning call6862 (depth = 9)
  gc_frame_newslot(call6862);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit6858;
  params[1] = call6860;
  params[2] = call6862;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6863 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6857);
// compiled call node returning call6863 (depth = 8)
    gc_frame_newslot(call6863);
    if6839 = call6863;
  }
// compiled if node returning if6839 (depth = 7)
    gc_frame_newslot(if6839);
    if6824 = if6839;
  }
// compiled if node returning if6824 (depth = 6)
    gc_frame_newslot(if6824);
    if6772 = if6824;
  }
// compiled if node returning if6772 (depth = 5)
    gc_frame_newslot(if6772);
    if6738 = if6772;
  } else {
  }
// compiled if node returning if6738 (depth = 4)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6869 == NULL) {
    strlit6869 = alloc_String("false");
    gc_root(strlit6869);
  }
// compiled string node returning strlit6869 (depth = 9)
  int op_slot_right_6868 = gc_frame_newslot(strlit6869);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6871 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6872 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6871);
// compiled call node returning call6872 (depth = 10)
// compiled member node returning call6872 (depth = 9)
  int op_slot_left_6868 = gc_frame_newslot(call6872);
  params[0] = strlit6869;
  partcv[0] = 1;
  Object opresult6873 = callmethod(call6872, "==", 1, partcv, params);
// compiled op node returning opresult6873 (depth = 8)
  int op_slot_right_6867 = gc_frame_newslot(opresult6873);
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit6876 == NULL) {
    strlit6876 = alloc_String("true");
    gc_root(strlit6876);
  }
// compiled string node returning strlit6876 (depth = 9)
  int op_slot_right_6875 = gc_frame_newslot(strlit6876);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6878 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call6879 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6878);
// compiled call node returning call6879 (depth = 10)
// compiled member node returning call6879 (depth = 9)
  int op_slot_left_6875 = gc_frame_newslot(call6879);
  params[0] = strlit6876;
  partcv[0] = 1;
  Object opresult6880 = callmethod(call6879, "==", 1, partcv, params);
// compiled op node returning opresult6880 (depth = 8)
  int op_slot_left_6867 = gc_frame_newslot(opresult6880);
  params[0] = opresult6873;
  partcv[0] = 1;
  Object opresult6881 = callmethod(opresult6880, "||", 1, partcv, params);
// compiled op node returning opresult6881 (depth = 7)
  int op_slot_right_6866 = gc_frame_newslot(opresult6881);
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6883 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6884 == NULL) {
    strlit6884 = alloc_String("identifier");
    gc_root(strlit6884);
  }
// compiled string node returning strlit6884 (depth = 8)
  gc_frame_newslot(strlit6884);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6884;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6885 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6883);
// compiled call node returning call6885 (depth = 7)
  int op_slot_left_6866 = gc_frame_newslot(call6885);
  params[0] = opresult6881;
  partcv[0] = 1;
  Object opresult6886 = callmethod(call6885, "&&", 1, partcv, params);
// compiled op node returning opresult6886 (depth = 6)
  int op_slot_right_6865 = gc_frame_newslot(opresult6886);
// starting to compile op node (depth = 6)
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6889 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6890 == NULL) {
    strlit6890 = alloc_String("num");
    gc_root(strlit6890);
  }
// compiled string node returning strlit6890 (depth = 8)
  gc_frame_newslot(strlit6890);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6890;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6891 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6889);
// compiled call node returning call6891 (depth = 7)
  int op_slot_right_6888 = gc_frame_newslot(call6891);
// starting to compile op node (depth = 7)
// Begin line 2172
  setline(2172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6894 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6895 == NULL) {
    strlit6895 = alloc_String("string");
    gc_root(strlit6895);
  }
// compiled string node returning strlit6895 (depth = 9)
  gc_frame_newslot(strlit6895);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6895;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6896 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6894);
// compiled call node returning call6896 (depth = 8)
  int op_slot_right_6893 = gc_frame_newslot(call6896);
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6898 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6899 == NULL) {
    strlit6899 = alloc_String("lbrace");
    gc_root(strlit6899);
  }
// compiled string node returning strlit6899 (depth = 9)
  gc_frame_newslot(strlit6899);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// call case 4: self request
  params[0] = strlit6899;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6900 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6898);
// compiled call node returning call6900 (depth = 8)
  int op_slot_left_6893 = gc_frame_newslot(call6900);
  params[0] = call6896;
  partcv[0] = 1;
  Object opresult6901 = callmethod(call6900, "||", 1, partcv, params);
// compiled op node returning opresult6901 (depth = 7)
  int op_slot_left_6888 = gc_frame_newslot(opresult6901);
  params[0] = call6891;
  partcv[0] = 1;
  Object opresult6902 = callmethod(opresult6901, "||", 1, partcv, params);
// compiled op node returning opresult6902 (depth = 6)
  int op_slot_left_6865 = gc_frame_newslot(opresult6902);
  params[0] = opresult6886;
  partcv[0] = 1;
  Object opresult6903 = callmethod(opresult6902, "||", 1, partcv, params);
// compiled op node returning opresult6903 (depth = 5)
  Object if6864 = done;
  if (istrue(opresult6903)) {
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool6904 = alloc_Boolean(1);
// compiled identifier node returning bool6904 (depth = 6)
  *var_isTerm = bool6904;
  if (bool6904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6864 = done;
  } else {
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6906 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6907 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6906);
// compiled call node returning call6907 (depth = 6)
// compiled member node returning call6907 (depth = 5)
    gc_frame_newslot(call6907);
    if6864 = call6907;
  }
// compiled if node returning if6864 (depth = 4)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool6908 = alloc_Boolean(0);
// compiled identifier node returning bool6908 (depth = 5)
  *var_isEmpty = bool6908;
  if (bool6908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6910 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit6911 == NULL) {
    strlit6911 = alloc_String("rparen");
    gc_root(strlit6911);
  }
// compiled string node returning strlit6911 (depth = 6)
  gc_frame_newslot(strlit6911);
// call case 4: self request
  params[0] = strlit6911;
  partcv[0] = 1;
  Object call6912 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6910);
// compiled call node returning call6912 (depth = 5)
  Object if6909 = done;
  if (istrue(call6912)) {
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool6913 = alloc_Boolean(1);
// compiled identifier node returning bool6913 (depth = 6)
  *var_isEmpty = bool6913;
  if (bool6913 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if6909 = done;
  } else {
  }
// compiled if node returning if6909 (depth = 4)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2185
  setline(2185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isTerm (depth = 5)
  Object if6915 = done;
  if (istrue(*var_isTerm)) {
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6916 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call6917 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6916);
// compiled call node returning call6917 (depth = 6)
// compiled member node returning call6917 (depth = 5)
    gc_frame_newslot(call6917);
    if6915 = call6917;
  } else {
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit6920 == NULL) {
    strlit6920 = alloc_String("rparen");
    gc_root(strlit6920);
  }
// compiled string node returning strlit6920 (depth = 7)
  int op_slot_right_6919 = gc_frame_newslot(strlit6920);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call6923 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6922);
// compiled call node returning call6923 (depth = 8)
// compiled member node returning call6923 (depth = 7)
  int op_slot_left_6919 = gc_frame_newslot(call6923);
  params[0] = strlit6920;
  partcv[0] = 1;
  Object opresult6924 = callmethod(call6923, "!=", 1, partcv, params);
// compiled op node returning opresult6924 (depth = 6)
  Object if6918 = done;
  if (istrue(opresult6924)) {
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2189
  setline(2189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6926 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe6927 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block6928 = alloc_Block(NULL, NULL, "parser", 2189);
  gc_frame_newslot(block6928);
// method _apply
  block_savedest(block6928);
  Object closure6929 = createclosure(2, "_apply");
  setclosureframe(closure6929, stackframe);
  addtoclosure(closure6929, var_blocksOK);
  addtoclosure(closure6929, selfslot);
  struct UserObject *uo6929 = (struct UserObject*)block6928;
  uo6929->data[0] = (Object)closure6929;
  Method *meth_meth_parser__apply6929 = addmethod2pos(block6928, "_apply", &meth_parser__apply6929, 0);
  int argcv_meth_parser__apply6929[] = {0};
  meth_meth_parser__apply6929->type = alloc_MethodType(1, argcv_meth_parser__apply6929);
  meth_meth_parser__apply6929->definitionModule = modulename;
  meth_meth_parser__apply6929->definitionLine = 2189;
// compiled block node returning block6928 (depth = 10)
  gc_frame_newslot(block6928);
// call case 4: self request
  params[0] = block6928;
  partcv[0] = 1;
  Object call6933 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6927);
// compiled call node returning call6933 (depth = 9)
  partcv[0] = 0;
  Object call6934 = callmethod(call6933, "not",
    1, partcv, params);
  gc_frame_end(callframe6926);
// compiled call node returning call6934 (depth = 8)
// compiled member node returning call6934 (depth = 7)
  Object if6925 = done;
  if (istrue(call6934)) {
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array6935 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array6935 (depth = 8)
  *var_suggestions = array6935;
  if (array6935 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe6937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call6938 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6937);
// compiled call node returning call6938 (depth = 11)
// compiled member node returning call6938 (depth = 10)
  partcv[0] = 0;
  Object call6939 = callmethod(call6938, "new",
    1, partcv, params);
  gc_frame_end(callframe6936);
// compiled call node returning call6939 (depth = 9)
// compiled member node returning call6939 (depth = 8)
  *var_suggestion = call6939;
  if (call6939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6940 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6941 == NULL) {
    strlit6941 = alloc_String("rparen");
    gc_root(strlit6941);
  }
// compiled string node returning strlit6941 (depth = 9)
  gc_frame_newslot(strlit6941);
// call case 4: self request
  params[0] = strlit6941;
  partcv[0] = 1;
  Object call6942 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6940);
// compiled call node returning call6942 (depth = 8)
  *var_nextTok = call6942;
  if (call6942 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_6944 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_6944 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6946 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult6946 (depth = 8)
  Object if6943 = done;
  if (istrue(opresult6946)) {
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6947 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit6948 == NULL) {
    strlit6948 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6948);
  }
// compiled string node returning strlit6948 (depth = 9)
  gc_frame_newslot(strlit6948);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit6948;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6949 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6947);
// compiled call node returning call6949 (depth = 8)
    gc_frame_newslot(call6949);
    if6943 = call6949;
  } else {
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6950 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6951 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6952 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6951);
// compiled call node returning call6952 (depth = 10)
// compiled member node returning call6952 (depth = 9)
  gc_frame_newslot(call6952);
// starting to compile identifier node (depth = 9)
  Object bool6953 = alloc_Boolean(1);
// compiled identifier node returning bool6953 (depth = 9)
  gc_frame_newslot(bool6953);
// starting to compile identifier node (depth = 9)
  Object bool6954 = alloc_Boolean(0);
// compiled identifier node returning bool6954 (depth = 9)
  gc_frame_newslot(bool6954);
// starting to compile string node (depth = 9)
  if (strlit6955 == NULL) {
    strlit6955 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6955);
  }
// compiled string node returning strlit6955 (depth = 9)
  gc_frame_newslot(strlit6955);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6952;
  params[2] = bool6953;
  params[3] = bool6954;
  params[4] = strlit6955;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6956 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6950);
// compiled call node returning call6956 (depth = 8)
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6957 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6958 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6957);
// compiled call node returning call6958 (depth = 8)
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6959 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe6960 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call6961 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6960);
// compiled call node returning call6961 (depth = 12)
// compiled member node returning call6961 (depth = 11)
  partcv[0] = 0;
  Object call6962 = callmethod(call6961, "new",
    1, partcv, params);
  gc_frame_end(callframe6959);
// compiled call node returning call6962 (depth = 10)
// compiled member node returning call6962 (depth = 9)
  *var_suggestion = call6962;
  if (call6962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe6964 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe6965 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call6966 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6965);
// compiled call node returning call6966 (depth = 10)
// compiled member node returning call6966 (depth = 9)
  gc_frame_newslot(call6966);
// starting to compile identifier node (depth = 9)
  Object bool6967 = alloc_Boolean(1);
// compiled identifier node returning bool6967 (depth = 9)
  gc_frame_newslot(bool6967);
// starting to compile identifier node (depth = 9)
  Object bool6968 = alloc_Boolean(0);
// compiled identifier node returning bool6968 (depth = 9)
  gc_frame_newslot(bool6968);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call6966;
  params[2] = bool6967;
  params[3] = bool6968;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6969 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6964);
// compiled call node returning call6969 (depth = 8)
    gc_frame_newslot(call6969);
    if6943 = call6969;
  }
// compiled if node returning if6943 (depth = 7)
// Begin line 2201
  setline(2201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6970 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6971 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6970);
// compiled call node returning call6971 (depth = 7)
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe6972 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit6973 == NULL) {
    strlit6973 = alloc_String("A method request must have an expression or a ')' after a '('.");
    gc_root(strlit6973);
  }
// compiled string node returning strlit6973 (depth = 8)
  gc_frame_newslot(strlit6973);
// Begin line 2203
  setline(2203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6974 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6975 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6974);
// compiled call node returning call6975 (depth = 9)
// compiled member node returning call6975 (depth = 8)
  gc_frame_newslot(call6975);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe6976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call6977 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6976);
// compiled call node returning call6977 (depth = 9)
// compiled member node returning call6977 (depth = 8)
  gc_frame_newslot(call6977);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit6973;
  params[1] = call6975;
  params[2] = call6977;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6978 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6972);
// compiled call node returning call6978 (depth = 7)
    gc_frame_newslot(call6978);
    if6925 = call6978;
  } else {
  }
// compiled if node returning if6925 (depth = 6)
    gc_frame_newslot(if6925);
    if6918 = if6925;
  } else {
  }
// compiled if node returning if6918 (depth = 5)
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6979 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block6980 = alloc_Block(NULL, NULL, "parser", 2206);
  gc_frame_newslot(block6980);
// method _apply
  block_savedest(block6980);
  Object closure6981 = createclosure(1, "_apply");
  setclosureframe(closure6981, stackframe);
  addtoclosure(closure6981, selfslot);
  struct UserObject *uo6981 = (struct UserObject*)block6980;
  uo6981->data[0] = (Object)closure6981;
  Method *meth_meth_parser__apply6981 = addmethod2pos(block6980, "_apply", &meth_parser__apply6981, 0);
  int argcv_meth_parser__apply6981[] = {0};
  meth_meth_parser__apply6981->type = alloc_MethodType(1, argcv_meth_parser__apply6981);
  meth_meth_parser__apply6981->definitionModule = modulename;
  meth_meth_parser__apply6981->definitionLine = 2203;
// compiled block node returning block6980 (depth = 6)
  gc_frame_newslot(block6980);
// starting to compile block node (depth = 6)
  Object block6986 = alloc_Block(NULL, NULL, "parser", 2206);
  gc_frame_newslot(block6986);
// method _apply
  block_savedest(block6986);
  Object closure6987 = createclosure(8, "_apply");
  setclosureframe(closure6987, stackframe);
  addtoclosure(closure6987, var_values);
  addtoclosure(closure6987, var_nxt);
  addtoclosure(closure6987, var_part);
  addtoclosure(closure6987, var_blocksOK);
  addtoclosure(closure6987, var_errormessages);
  addtoclosure(closure6987, var_sym);
  addtoclosure(closure6987, var_lastToken);
  addtoclosure(closure6987, selfslot);
  struct UserObject *uo6987 = (struct UserObject*)block6986;
  uo6987->data[0] = (Object)closure6987;
  Method *meth_meth_parser__apply6987 = addmethod2pos(block6986, "_apply", &meth_parser__apply6987, 0);
  int argcv_meth_parser__apply6987[] = {0};
  meth_meth_parser__apply6987->type = alloc_MethodType(1, argcv_meth_parser__apply6987);
  meth_meth_parser__apply6987->definitionModule = modulename;
  meth_meth_parser__apply6987->definitionLine = 2203;
// compiled block node returning block6986 (depth = 6)
  gc_frame_newslot(block6986);
// call case 5: prelude request
  params[0] = block6980;
  params[1] = block6986;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7052 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6979);
// compiled call node returning call7052 (depth = 5)
    gc_frame_newslot(call7052);
    if6915 = call7052;
  }
// compiled if node returning if6915 (depth = 4)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7054 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_isEmpty (depth = 6)
  partcv[0] = 0;
  Object call7055 = callmethod(*var_isEmpty, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7054);
// compiled call node returning call7055 (depth = 5)
  Object if7053 = done;
  if (istrue(call7055)) {
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2229
  setline(2229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7057 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7056);
// compiled call node returning call7057 (depth = 7)
// compiled member node returning call7057 (depth = 6)
  *var_nxt = call7057;
  if (call7057 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7059 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nxt (depth = 6)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call7061 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe7060);
// compiled call node returning call7061 (depth = 7)
// compiled member node returning call7061 (depth = 6)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call7062 = callmethod(call7061, "push",
    1, partcv, params);
  gc_frame_end(callframe7059);
// compiled call node returning call7062 (depth = 5)
    gc_frame_newslot(call7062);
    if7053 = call7062;
  } else {
  }
// compiled if node returning if7053 (depth = 4)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7064 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_isTerm (depth = 7)
  partcv[0] = 0;
  Object call7065 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe7064);
// compiled call node returning call7065 (depth = 6)
// compiled member node returning call7065 (depth = 5)
  Object if7063 = done;
  if (istrue(call7065)) {
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7068 == NULL) {
    strlit7068 = alloc_String("rparen");
    gc_root(strlit7068);
  }
// compiled string node returning strlit7068 (depth = 7)
  int op_slot_right_7067 = gc_frame_newslot(strlit7068);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7071 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7070);
// compiled call node returning call7071 (depth = 8)
// compiled member node returning call7071 (depth = 7)
  int op_slot_left_7067 = gc_frame_newslot(call7071);
  params[0] = strlit7068;
  partcv[0] = 1;
  Object opresult7072 = callmethod(call7071, "!=", 1, partcv, params);
// compiled op node returning opresult7072 (depth = 6)
  Object if7066 = done;
  if (istrue(opresult7072)) {
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7073 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7074 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7073);
// compiled call node returning call7074 (depth = 7)
// compiled member node returning call7074 (depth = 6)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 2235
  setline(2235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7075 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7076 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call7077 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7076);
// compiled call node returning call7077 (depth = 10)
// compiled member node returning call7077 (depth = 9)
  partcv[0] = 0;
  Object call7078 = callmethod(call7077, "new",
    1, partcv, params);
  gc_frame_end(callframe7075);
// compiled call node returning call7078 (depth = 8)
// compiled member node returning call7078 (depth = 7)
  *var_suggestion = call7078;
  if (call7078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2236
  setline(2236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7079 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7080 == NULL) {
    strlit7080 = alloc_String(")");
    gc_root(strlit7080);
  }
// compiled string node returning strlit7080 (depth = 7)
  gc_frame_newslot(strlit7080);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7080;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7081 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7079);
// compiled call node returning call7081 (depth = 6)
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7082 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7083 == NULL) {
    strlit7083 = alloc_String("A part of a multi-part method request beginning with a '(' must end with a ')'.");
    gc_root(strlit7083);
  }
// compiled string node returning strlit7083 (depth = 7)
  gc_frame_newslot(strlit7083);
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7084 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7085 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7084);
// compiled call node returning call7085 (depth = 8)
// compiled member node returning call7085 (depth = 7)
  gc_frame_newslot(call7085);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7088 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7087);
// compiled call node returning call7088 (depth = 9)
// compiled member node returning call7088 (depth = 8)
  int op_slot_right_7086 = gc_frame_newslot(call7088);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7090 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7091 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7090);
// compiled call node returning call7091 (depth = 9)
// compiled member node returning call7091 (depth = 8)
  int op_slot_left_7086 = gc_frame_newslot(call7091);
  params[0] = call7088;
  partcv[0] = 1;
  Object sum7092 = callmethod(call7091, "+", 1, partcv, params);
// compiled op node returning sum7092 (depth = 7)
  gc_frame_newslot(sum7092);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2237
  setline(2237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit7083;
  params[1] = call7085;
  params[2] = sum7092;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7093 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7082);
// compiled call node returning call7093 (depth = 6)
    gc_frame_newslot(call7093);
    if7066 = call7093;
  } else {
  }
// compiled if node returning if7066 (depth = 5)
    gc_frame_newslot(if7066);
    if7063 = if7066;
  } else {
  }
// compiled if node returning if7063 (depth = 4)
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_isTerm (depth = 8)
  partcv[0] = 0;
  Object call7097 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe7096);
// compiled call node returning call7097 (depth = 7)
// compiled member node returning call7097 (depth = 6)
  int op_slot_right_7095 = gc_frame_newslot(call7097);
// starting to compile call node (depth = 6)
  int callframe7099 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7100 == NULL) {
    strlit7100 = alloc_String("rparen");
    gc_root(strlit7100);
  }
// compiled string node returning strlit7100 (depth = 7)
  gc_frame_newslot(strlit7100);
// call case 4: self request
  params[0] = strlit7100;
  partcv[0] = 1;
  Object call7101 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7099);
// compiled call node returning call7101 (depth = 6)
  int op_slot_left_7095 = gc_frame_newslot(call7101);
  params[0] = call7097;
  partcv[0] = 1;
  Object opresult7102 = callmethod(call7101, "&&", 1, partcv, params);
// compiled op node returning opresult7102 (depth = 5)
  Object if7094 = done;
  if (istrue(opresult7102)) {
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7103 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7104 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7103);
// compiled call node returning call7104 (depth = 6)
// compiled member node returning call7104 (depth = 5)
    gc_frame_newslot(call7104);
    if7094 = call7104;
  } else {
  }
// compiled if node returning if7094 (depth = 4)
  gc_frame_end(frame);
  return if7094;
}
Object meth_parser_callmprest6690(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callmprest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method callmprest");
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callmprest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  *var_tok = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    gracedie("wrong number of arguments for callmprest");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methname");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_lp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "lp");
  Object *var_part = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "part");
  Object *var_meth_39_ = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "meth'");
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6692 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6691);
// compiled call node returning call6692 (depth = 4)
// compiled member node returning call6692 (depth = 3)
  *var_methname = call6692;
  if (call6692 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe6693 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  partcv[0] = 0;
  Object call6694 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6693);
// compiled call node returning call6694 (depth = 4)
// compiled member node returning call6694 (depth = 3)
  *var_lp = call6694;
  if (call6694 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_part = undefined;
// compiled vardec node returning done (depth = 2)
// starting to compile call node (depth = 2)
  int callframe6695 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block6696 = alloc_Block(NULL, NULL, "parser", 2129);
  gc_frame_newslot(block6696);
// method _apply
  block_savedest(block6696);
  Object closure6697 = createclosure(3, "_apply");
  setclosureframe(closure6697, stackframe);
  addtoclosure(closure6697, var_lastToken);
  addtoclosure(closure6697, var_tok);
  addtoclosure(closure6697, selfslot);
  struct UserObject *uo6697 = (struct UserObject*)block6696;
  uo6697->data[0] = (Object)closure6697;
  Method *meth_meth_parser__apply6697 = addmethod2pos(block6696, "_apply", &meth_parser__apply6697, 0);
  int argcv_meth_parser__apply6697[] = {0};
  meth_meth_parser__apply6697->type = alloc_MethodType(1, argcv_meth_parser__apply6697);
  meth_meth_parser__apply6697->definitionModule = modulename;
  meth_meth_parser__apply6697->definitionLine = 2127;
// compiled block node returning block6696 (depth = 3)
  gc_frame_newslot(block6696);
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block6708 = alloc_Block(NULL, NULL, "parser", 2130);
  gc_frame_newslot(block6708);
// method _apply
  block_savedest(block6708);
  Object closure6709 = createclosure(12, "_apply");
  setclosureframe(closure6709, stackframe);
  addtoclosure(closure6709, var_ast);
  addtoclosure(closure6709, var_part);
  addtoclosure(closure6709, var_signature);
  addtoclosure(closure6709, var_methname);
  addtoclosure(closure6709, var_values);
  addtoclosure(closure6709, var_nxt);
  addtoclosure(closure6709, var_errormessages);
  addtoclosure(closure6709, var_sym);
  addtoclosure(closure6709, var_lastToken);
  addtoclosure(closure6709, var_tok);
  addtoclosure(closure6709, var_blocksOK);
  addtoclosure(closure6709, selfslot);
  struct UserObject *uo6709 = (struct UserObject*)block6708;
  uo6709->data[0] = (Object)closure6709;
  Method *meth_meth_parser__apply6709 = addmethod2pos(block6708, "_apply", &meth_parser__apply6709, 0);
  int argcv_meth_parser__apply6709[] = {0};
  meth_meth_parser__apply6709->type = alloc_MethodType(1, argcv_meth_parser__apply6709);
  meth_meth_parser__apply6709->definitionModule = modulename;
  meth_meth_parser__apply6709->definitionLine = 2127;
// compiled block node returning block6708 (depth = 3)
  gc_frame_newslot(block6708);
// call case 5: prelude request
  params[0] = block6696;
  params[1] = block6708;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7106 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6695);
// compiled call node returning call7106 (depth = 2)
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe7107 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool7108 = alloc_Boolean(0);
// compiled identifier node returning bool7108 (depth = 4)
  gc_frame_newslot(bool7108);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7110 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7109);
// compiled call node returning call7110 (depth = 5)
// compiled member node returning call7110 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool7108;
  partcv[0] = 2;
  Object call7111 = callmethod(call7110, "new",
    1, partcv, params);
  gc_frame_end(callframe7107);
// compiled call node returning call7111 (depth = 3)
  *var_meth_39_ = call7111;
  if (call7111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7112 = gc_frame_new();
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7113 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call7114 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe7113);
// compiled call node returning call7114 (depth = 5)
// compiled member node returning call7114 (depth = 4)
  gc_frame_newslot(call7114);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth_39_ (depth = 4)
  params[0] = call7114;
  partcv[0] = 1;
  Object call7115 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7112);
// compiled call node returning call7115 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7116 = gc_frame_new();
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7117 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call7118 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7117);
// compiled call node returning call7118 (depth = 5)
// compiled member node returning call7118 (depth = 4)
  gc_frame_newslot(call7118);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth_39_ (depth = 4)
  params[0] = call7118;
  partcv[0] = 1;
  Object call7119 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe7116);
// compiled call node returning call7119 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_meth_39_ (depth = 2)
  gc_frame_end(frame);
  return *var_meth_39_;
}
Object meth_parser__apply7153(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7157 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7156);
// compiled call node returning call7157 (depth = 10)
// compiled member node returning call7157 (depth = 9)
  int op_slot_right_7155 = gc_frame_newslot(call7157);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7160 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7159);
// compiled call node returning call7160 (depth = 10)
// compiled member node returning call7160 (depth = 9)
  int op_slot_left_7155 = gc_frame_newslot(call7160);
  params[0] = call7157;
  partcv[0] = 1;
  Object opresult7161 = callmethod(call7160, "==", 1, partcv, params);
// compiled op node returning opresult7161 (depth = 8)
  int op_slot_right_7154 = gc_frame_newslot(opresult7161);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7165 == NULL) {
    strlit7165 = alloc_String("=");
    gc_root(strlit7165);
  }
// compiled string node returning strlit7165 (depth = 10)
  int op_slot_right_7164 = gc_frame_newslot(strlit7165);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call7168 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe7167);
// compiled call node returning call7168 (depth = 11)
// compiled member node returning call7168 (depth = 10)
  int op_slot_left_7164 = gc_frame_newslot(call7168);
  params[0] = strlit7165;
  partcv[0] = 1;
  Object opresult7169 = callmethod(call7168, "==", 1, partcv, params);
// compiled op node returning opresult7169 (depth = 9)
  int op_slot_right_7163 = gc_frame_newslot(opresult7169);
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit7172 == NULL) {
    strlit7172 = alloc_String("op");
    gc_root(strlit7172);
  }
// compiled string node returning strlit7172 (depth = 10)
  int op_slot_right_7171 = gc_frame_newslot(strlit7172);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7174 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  partcv[0] = 0;
  Object call7175 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7174);
// compiled call node returning call7175 (depth = 11)
// compiled member node returning call7175 (depth = 10)
  int op_slot_left_7171 = gc_frame_newslot(call7175);
  params[0] = strlit7172;
  partcv[0] = 1;
  Object opresult7176 = callmethod(call7175, "==", 1, partcv, params);
// compiled op node returning opresult7176 (depth = 9)
  int op_slot_left_7163 = gc_frame_newslot(opresult7176);
  params[0] = opresult7169;
  partcv[0] = 1;
  Object opresult7177 = callmethod(opresult7176, "&&", 1, partcv, params);
// compiled op node returning opresult7177 (depth = 8)
  int op_slot_left_7154 = gc_frame_newslot(opresult7177);
  params[0] = opresult7161;
  partcv[0] = 1;
  Object opresult7178 = callmethod(opresult7177, "&&", 1, partcv, params);
// compiled op node returning opresult7178 (depth = 7)
  gc_frame_end(frame);
  return opresult7178;
}
Object meth_parser__apply7252(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe7253 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7254 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7253);
// compiled call node returning call7254 (depth = 9)
  gc_frame_end(frame);
  return call7254;
}
Object meth_parser_defdec7120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_defaultDefVisibility = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defdec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for defdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_defTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "defTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_name = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "name");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_nextTok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "nextTok");
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2325
  setline(2325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7124 == NULL) {
    strlit7124 = alloc_String("def");
    gc_root(strlit7124);
  }
// compiled string node returning strlit7124 (depth = 5)
  int op_slot_right_7123 = gc_frame_newslot(strlit7124);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7126 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7127 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7126);
// compiled call node returning call7127 (depth = 6)
// compiled member node returning call7127 (depth = 5)
  int op_slot_left_7123 = gc_frame_newslot(call7127);
  params[0] = strlit7124;
  partcv[0] = 1;
  Object opresult7128 = callmethod(call7127, "==", 1, partcv, params);
// compiled op node returning opresult7128 (depth = 4)
  int op_slot_right_7122 = gc_frame_newslot(opresult7128);
// starting to compile call node (depth = 4)
  int callframe7130 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7131 == NULL) {
    strlit7131 = alloc_String("keyword");
    gc_root(strlit7131);
  }
// compiled string node returning strlit7131 (depth = 5)
  gc_frame_newslot(strlit7131);
// call case 4: self request
  params[0] = strlit7131;
  partcv[0] = 1;
  Object call7132 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7130);
// compiled call node returning call7132 (depth = 4)
  int op_slot_left_7122 = gc_frame_newslot(call7132);
  params[0] = opresult7128;
  partcv[0] = 1;
  Object opresult7133 = callmethod(call7132, "&&", 1, partcv, params);
// compiled op node returning opresult7133 (depth = 3)
  Object if7121 = done;
  if (istrue(opresult7133)) {
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2254
  setline(2254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7134 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7135 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7134);
// compiled call node returning call7135 (depth = 5)
// compiled member node returning call7135 (depth = 4)
  *var_line = call7135;
  if (call7135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7137 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7136);
// compiled call node returning call7137 (depth = 5)
// compiled member node returning call7137 (depth = 4)
  *var_pos = call7137;
  if (call7137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2257
  setline(2257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7138 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7139 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7138);
// compiled call node returning call7139 (depth = 4)
// compiled member node returning call7139 (depth = 3)
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7142 == NULL) {
    strlit7142 = alloc_String("identifier");
    gc_root(strlit7142);
  }
// compiled string node returning strlit7142 (depth = 5)
  int op_slot_right_7141 = gc_frame_newslot(strlit7142);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7144 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7145 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7144);
// compiled call node returning call7145 (depth = 6)
// compiled member node returning call7145 (depth = 5)
  int op_slot_left_7141 = gc_frame_newslot(call7145);
  params[0] = strlit7142;
  partcv[0] = 1;
  Object opresult7146 = callmethod(call7145, "!=", 1, partcv, params);
// compiled op node returning opresult7146 (depth = 4)
  Object if7140 = done;
  if (istrue(opresult7146)) {
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7147 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7149 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7148);
// compiled call node returning call7149 (depth = 8)
// compiled member node returning call7149 (depth = 7)
  partcv[0] = 0;
  Object call7150 = callmethod(call7149, "new",
    1, partcv, params);
  gc_frame_end(callframe7147);
// compiled call node returning call7150 (depth = 6)
// compiled member node returning call7150 (depth = 5)
  *var_suggestion = call7150;
  if (call7150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7151 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7152 = alloc_Block(NULL, NULL, "parser", 2260);
  gc_frame_newslot(block7152);
// method _apply
  block_savedest(block7152);
  Object closure7153 = createclosure(2, "_apply");
  setclosureframe(closure7153, stackframe);
  addtoclosure(closure7153, var_sym);
  addtoclosure(closure7153, selfslot);
  struct UserObject *uo7153 = (struct UserObject*)block7152;
  uo7153->data[0] = (Object)closure7153;
  Method *meth_meth_parser__apply7153 = addmethod2pos(block7152, "_apply", &meth_parser__apply7153, 0);
  int argcv_meth_parser__apply7153[] = {1};
  meth_meth_parser__apply7153->type = alloc_MethodType(1, argcv_meth_parser__apply7153);
  meth_meth_parser__apply7153->definitionModule = modulename;
  meth_meth_parser__apply7153->definitionLine = 2259;
// compiled block node returning block7152 (depth = 6)
  gc_frame_newslot(block7152);
// call case 4: self request
  params[0] = block7152;
  partcv[0] = 1;
  Object call7180 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7151);
// compiled call node returning call7180 (depth = 5)
  *var_nextToken = call7180;
  if (call7180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7183 = alloc_Boolean(0);
// compiled identifier node returning bool7183 (depth = 6)
  int op_slot_right_7182 = gc_frame_newslot(bool7183);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextToken (depth = 6)
  int op_slot_left_7182 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7183;
  partcv[0] = 1;
  Object opresult7185 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7185 (depth = 5)
  Object if7181 = done;
  if (istrue(opresult7185)) {
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7186 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7187 == NULL) {
    strlit7187 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit7187);
  }
// compiled string node returning strlit7187 (depth = 6)
  gc_frame_newslot(strlit7187);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7187;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7188 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7186);
// compiled call node returning call7188 (depth = 5)
    gc_frame_newslot(call7188);
    if7181 = call7188;
  } else {
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7190 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_7190 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7192 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7192 (depth = 6)
  Object if7189 = done;
  if (istrue(opresult7192)) {
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7193 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7194 == NULL) {
    strlit7194 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7194);
  }
// compiled string node returning strlit7194 (depth = 7)
  gc_frame_newslot(strlit7194);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7194;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7195 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7193);
// compiled call node returning call7195 (depth = 6)
    gc_frame_newslot(call7195);
    if7189 = call7195;
  } else {
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7196 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7197 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextToken (depth = 9)
  partcv[0] = 0;
  Object call7198 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7197);
// compiled call node returning call7198 (depth = 8)
// compiled member node returning call7198 (depth = 7)
  gc_frame_newslot(call7198);
// starting to compile identifier node (depth = 7)
  Object bool7199 = alloc_Boolean(0);
// compiled identifier node returning bool7199 (depth = 7)
  gc_frame_newslot(bool7199);
// starting to compile identifier node (depth = 7)
  Object bool7200 = alloc_Boolean(1);
// compiled identifier node returning bool7200 (depth = 7)
  gc_frame_newslot(bool7200);
// starting to compile string node (depth = 7)
  if (strlit7201 == NULL) {
    strlit7201 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7201);
  }
// compiled string node returning strlit7201 (depth = 7)
  gc_frame_newslot(strlit7201);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7198;
  params[2] = bool7199;
  params[3] = bool7200;
  params[4] = strlit7201;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7202 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7196);
// compiled call node returning call7202 (depth = 6)
    gc_frame_newslot(call7202);
    if7189 = call7202;
  }
// compiled if node returning if7189 (depth = 5)
    gc_frame_newslot(if7189);
    if7181 = if7189;
  }
// compiled if node returning if7181 (depth = 4)
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7203 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7204 == NULL) {
    strlit7204 = alloc_String("A definition must have a name, '=', and a value after the 'def'.");
    gc_root(strlit7204);
  }
// compiled string node returning strlit7204 (depth = 5)
  gc_frame_newslot(strlit7204);
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7206 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7205);
// compiled call node returning call7206 (depth = 6)
// compiled member node returning call7206 (depth = 5)
  gc_frame_newslot(call7206);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7208 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7207);
// compiled call node returning call7208 (depth = 6)
// compiled member node returning call7208 (depth = 5)
  gc_frame_newslot(call7208);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7204;
  params[1] = call7206;
  params[2] = call7208;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7209 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7203);
// compiled call node returning call7209 (depth = 4)
    gc_frame_newslot(call7209);
    if7140 = call7209;
  } else {
  }
// compiled if node returning if7140 (depth = 3)
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7210 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7211 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7210);
// compiled call node returning call7211 (depth = 4)
// compiled member node returning call7211 (depth = 3)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7212 = alloc_Boolean(0);
// compiled identifier node returning bool7212 (depth = 4)
  *var_val = bool7212;
  if (bool7212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7214 = callmethod(*var_ast, "unknownType",
    1, partcv, params);
  gc_frame_end(callframe7213);
// compiled call node returning call7214 (depth = 5)
// compiled member node returning call7214 (depth = 4)
  *var_dtype = call7214;
  if (call7214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7215 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7216 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7215);
// compiled call node returning call7216 (depth = 5)
// compiled member node returning call7216 (depth = 4)
  *var_name = call7216;
  if (call7216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2275
  setline(2275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7217 = gc_frame_new();
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool7218 = alloc_Boolean(1);
// compiled identifier node returning bool7218 (depth = 5)
  gc_frame_newslot(bool7218);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  params[0] = bool7218;
  partcv[0] = 1;
  Object call7219 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7217);
// compiled call node returning call7219 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2277
  setline(2277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7221 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7222 == NULL) {
    strlit7222 = alloc_String("colon");
    gc_root(strlit7222);
  }
// compiled string node returning strlit7222 (depth = 5)
  gc_frame_newslot(strlit7222);
// call case 4: self request
  params[0] = strlit7222;
  partcv[0] = 1;
  Object call7223 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7221);
// compiled call node returning call7223 (depth = 4)
  Object if7220 = done;
  if (istrue(call7223)) {
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7224 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7225 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7224);
// compiled call node returning call7225 (depth = 5)
// compiled member node returning call7225 (depth = 4)
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7226 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7227 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7226);
// compiled call node returning call7227 (depth = 5)
// compiled member node returning call7227 (depth = 4)
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2280
  setline(2280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7229 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7228);
// compiled call node returning call7229 (depth = 6)
// compiled member node returning call7229 (depth = 5)
  *var_dtype = call7229;
  if (call7229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7220 = done;
  } else {
  }
// compiled if node returning if7220 (depth = 3)
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7231 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7232 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7231);
// compiled call node returning call7232 (depth = 5)
// compiled member node returning call7232 (depth = 4)
  *var_anns = call7232;
  if (call7232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit7236 == NULL) {
    strlit7236 = alloc_String("=");
    gc_root(strlit7236);
  }
// compiled string node returning strlit7236 (depth = 6)
  int op_slot_right_7235 = gc_frame_newslot(strlit7236);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7238 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7239 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7238);
// compiled call node returning call7239 (depth = 7)
// compiled member node returning call7239 (depth = 6)
  int op_slot_left_7235 = gc_frame_newslot(call7239);
  params[0] = strlit7236;
  partcv[0] = 1;
  Object opresult7240 = callmethod(call7239, "==", 1, partcv, params);
// compiled op node returning opresult7240 (depth = 5)
  int op_slot_right_7234 = gc_frame_newslot(opresult7240);
// starting to compile call node (depth = 5)
  int callframe7242 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7243 == NULL) {
    strlit7243 = alloc_String("op");
    gc_root(strlit7243);
  }
// compiled string node returning strlit7243 (depth = 6)
  gc_frame_newslot(strlit7243);
// call case 4: self request
  params[0] = strlit7243;
  partcv[0] = 1;
  Object call7244 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7242);
// compiled call node returning call7244 (depth = 5)
  int op_slot_left_7234 = gc_frame_newslot(call7244);
  params[0] = opresult7240;
  partcv[0] = 1;
  Object opresult7245 = callmethod(call7244, "&&", 1, partcv, params);
// compiled op node returning opresult7245 (depth = 4)
  Object if7233 = done;
  if (istrue(opresult7245)) {
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7246 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7247 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7246);
// compiled call node returning call7247 (depth = 5)
// compiled member node returning call7247 (depth = 4)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7249 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7250 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7251 = alloc_Block(NULL, NULL, "parser", 2285);
  gc_frame_newslot(block7251);
// method _apply
  block_savedest(block7251);
  Object closure7252 = createclosure(2, "_apply");
  setclosureframe(closure7252, stackframe);
  addtoclosure(closure7252, var_blocksOK);
  addtoclosure(closure7252, selfslot);
  struct UserObject *uo7252 = (struct UserObject*)block7251;
  uo7252->data[0] = (Object)closure7252;
  Method *meth_meth_parser__apply7252 = addmethod2pos(block7251, "_apply", &meth_parser__apply7252, 0);
  int argcv_meth_parser__apply7252[] = {0};
  meth_meth_parser__apply7252->type = alloc_MethodType(1, argcv_meth_parser__apply7252);
  meth_meth_parser__apply7252->definitionModule = modulename;
  meth_meth_parser__apply7252->definitionLine = 2285;
// compiled block node returning block7251 (depth = 8)
  gc_frame_newslot(block7251);
// call case 4: self request
  params[0] = block7251;
  partcv[0] = 1;
  Object call7256 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7250);
// compiled call node returning call7256 (depth = 7)
  partcv[0] = 0;
  Object call7257 = callmethod(call7256, "not",
    1, partcv, params);
  gc_frame_end(callframe7249);
// compiled call node returning call7257 (depth = 6)
// compiled member node returning call7257 (depth = 5)
  Object if7248 = done;
  if (istrue(call7257)) {
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7258 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7260 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7259);
// compiled call node returning call7260 (depth = 9)
// compiled member node returning call7260 (depth = 8)
  partcv[0] = 0;
  Object call7261 = callmethod(call7260, "new",
    1, partcv, params);
  gc_frame_end(callframe7258);
// compiled call node returning call7261 (depth = 7)
// compiled member node returning call7261 (depth = 6)
  *var_suggestion = call7261;
  if (call7261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7262 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7263 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7262);
// compiled call node returning call7263 (depth = 6)
  *var_nextTok = call7263;
  if (call7263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7265 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_7265 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7267 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7267 (depth = 6)
  Object if7264 = done;
  if (istrue(opresult7267)) {
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7268 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7269 == NULL) {
    strlit7269 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7269);
  }
// compiled string node returning strlit7269 (depth = 7)
  gc_frame_newslot(strlit7269);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7269;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7270 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7268);
// compiled call node returning call7270 (depth = 6)
    gc_frame_newslot(call7270);
    if7264 = call7270;
  } else {
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7271 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call7273 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7272);
// compiled call node returning call7273 (depth = 8)
// compiled member node returning call7273 (depth = 7)
  gc_frame_newslot(call7273);
// starting to compile identifier node (depth = 7)
  Object bool7274 = alloc_Boolean(1);
// compiled identifier node returning bool7274 (depth = 7)
  gc_frame_newslot(bool7274);
// starting to compile identifier node (depth = 7)
  Object bool7275 = alloc_Boolean(0);
// compiled identifier node returning bool7275 (depth = 7)
  gc_frame_newslot(bool7275);
// starting to compile string node (depth = 7)
  if (strlit7276 == NULL) {
    strlit7276 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7276);
  }
// compiled string node returning strlit7276 (depth = 7)
  gc_frame_newslot(strlit7276);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7273;
  params[2] = bool7274;
  params[3] = bool7275;
  params[4] = strlit7276;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7277 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7271);
// compiled call node returning call7277 (depth = 6)
    gc_frame_newslot(call7277);
    if7264 = call7277;
  }
// compiled if node returning if7264 (depth = 5)
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7278 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7279 == NULL) {
    strlit7279 = alloc_String("A definition must have a value after the '='.");
    gc_root(strlit7279);
  }
// compiled string node returning strlit7279 (depth = 6)
  gc_frame_newslot(strlit7279);
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7280 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7281 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7280);
// compiled call node returning call7281 (depth = 7)
// compiled member node returning call7281 (depth = 6)
  gc_frame_newslot(call7281);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7283 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7284 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7283);
// compiled call node returning call7284 (depth = 8)
// compiled member node returning call7284 (depth = 7)
  int op_slot_right_7282 = gc_frame_newslot(call7284);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7287 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7286);
// compiled call node returning call7287 (depth = 8)
// compiled member node returning call7287 (depth = 7)
  int op_slot_left_7282 = gc_frame_newslot(call7287);
  params[0] = call7284;
  partcv[0] = 1;
  Object sum7288 = callmethod(call7287, "+", 1, partcv, params);
// compiled op node returning sum7288 (depth = 6)
  gc_frame_newslot(sum7288);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7279;
  params[1] = call7281;
  params[2] = sum7288;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7289 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7278);
// compiled call node returning call7289 (depth = 5)
    gc_frame_newslot(call7289);
    if7248 = call7289;
  } else {
  }
// compiled if node returning if7248 (depth = 4)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7291 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7290);
// compiled call node returning call7291 (depth = 6)
// compiled member node returning call7291 (depth = 5)
  *var_val = call7291;
  if (call7291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7233 = done;
  } else {
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7294 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7295 == NULL) {
    strlit7295 = alloc_String("bind");
    gc_root(strlit7295);
  }
// compiled string node returning strlit7295 (depth = 6)
  gc_frame_newslot(strlit7295);
// call case 4: self request
  params[0] = strlit7295;
  partcv[0] = 1;
  Object call7296 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7294);
// compiled call node returning call7296 (depth = 5)
  Object if7293 = done;
  if (istrue(call7296)) {
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array7297 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7297 (depth = 6)
  *var_suggestions = array7297;
  if (array7297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7298 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7299 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7300 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7299);
// compiled call node returning call7300 (depth = 9)
// compiled member node returning call7300 (depth = 8)
  partcv[0] = 0;
  Object call7301 = callmethod(call7300, "new",
    1, partcv, params);
  gc_frame_end(callframe7298);
// compiled call node returning call7301 (depth = 7)
// compiled member node returning call7301 (depth = 6)
  *var_suggestion = call7301;
  if (call7301 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7302 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit7303 == NULL) {
    strlit7303 = alloc_String("=");
    gc_root(strlit7303);
  }
// compiled string node returning strlit7303 (depth = 6)
  gc_frame_newslot(strlit7303);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit7303;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7304 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7302);
// compiled call node returning call7304 (depth = 5)
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7305 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7306 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7305);
// compiled call node returning call7306 (depth = 5)
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7307 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7308 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7309 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7308);
// compiled call node returning call7309 (depth = 9)
// compiled member node returning call7309 (depth = 8)
  partcv[0] = 0;
  Object call7310 = callmethod(call7309, "new",
    1, partcv, params);
  gc_frame_end(callframe7307);
// compiled call node returning call7310 (depth = 7)
// compiled member node returning call7310 (depth = 6)
  *var_suggestion = call7310;
  if (call7310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2303
  setline(2303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7312 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit7313 == NULL) {
    strlit7313 = alloc_String("var");
    gc_root(strlit7313);
  }
// compiled string node returning strlit7313 (depth = 6)
  gc_frame_newslot(strlit7313);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit7313;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7314 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7312);
// compiled call node returning call7314 (depth = 5)
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7315 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7316 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7315);
// compiled call node returning call7316 (depth = 5)
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7317 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7318 == NULL) {
    strlit7318 = alloc_String("A definition must use '=' instead of ':='. A variable declaration uses 'var' and ':='.");
    gc_root(strlit7318);
  }
// compiled string node returning strlit7318 (depth = 6)
  gc_frame_newslot(strlit7318);
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7320 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7319);
// compiled call node returning call7320 (depth = 7)
// compiled member node returning call7320 (depth = 6)
  gc_frame_newslot(call7320);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7321 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7322 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7321);
// compiled call node returning call7322 (depth = 7)
// compiled member node returning call7322 (depth = 6)
  gc_frame_newslot(call7322);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num7324 = alloc_Float64(1);
// compiled num node returning num7324 (depth = 7)
  int op_slot_right_7323 = gc_frame_newslot(num7324);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7326 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7327 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7326);
// compiled call node returning call7327 (depth = 8)
// compiled member node returning call7327 (depth = 7)
  int op_slot_left_7323 = gc_frame_newslot(call7327);
  params[0] = num7324;
  partcv[0] = 1;
  Object sum7328 = callmethod(call7327, "+", 1, partcv, params);
// compiled op node returning sum7328 (depth = 6)
  gc_frame_newslot(sum7328);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7318;
  params[1] = call7320;
  params[2] = call7322;
  params[3] = sum7328;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7329 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7317);
// compiled call node returning call7329 (depth = 5)
    gc_frame_newslot(call7329);
    if7293 = call7329;
  } else {
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array7330 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7330 (depth = 6)
  *var_suggestions = array7330;
  if (array7330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7331 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7333 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7332);
// compiled call node returning call7333 (depth = 9)
// compiled member node returning call7333 (depth = 8)
  partcv[0] = 0;
  Object call7334 = callmethod(call7333, "new",
    1, partcv, params);
  gc_frame_end(callframe7331);
// compiled call node returning call7334 (depth = 7)
// compiled member node returning call7334 (depth = 6)
  *var_suggestion = call7334;
  if (call7334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7335 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7336 == NULL) {
    strlit7336 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7336);
  }
// compiled string node returning strlit7336 (depth = 6)
  gc_frame_newslot(strlit7336);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7336;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7337 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7335);
// compiled call node returning call7337 (depth = 5)
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7338 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7339 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7338);
// compiled call node returning call7339 (depth = 5)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7340 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7342 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7341);
// compiled call node returning call7342 (depth = 9)
// compiled member node returning call7342 (depth = 8)
  partcv[0] = 0;
  Object call7343 = callmethod(call7342, "new",
    1, partcv, params);
  gc_frame_end(callframe7340);
// compiled call node returning call7343 (depth = 7)
// compiled member node returning call7343 (depth = 6)
  *var_suggestion = call7343;
  if (call7343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7345 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defTok (depth = 6)
  gc_frame_newslot(*var_defTok);
// starting to compile string node (depth = 6)
  if (strlit7346 == NULL) {
    strlit7346 = alloc_String("var");
    gc_root(strlit7346);
  }
// compiled string node returning strlit7346 (depth = 6)
  gc_frame_newslot(strlit7346);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_defTok;
  params[1] = strlit7346;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7347 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7345);
// compiled call node returning call7347 (depth = 5)
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7348 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7349 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7348);
// compiled call node returning call7349 (depth = 5)
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7350 = gc_frame_new();
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7352 == NULL) {
    strlit7352 = alloc_String("A variable declaration does not require a value and uses 'var' instead of 'def'.");
    gc_root(strlit7352);
  }
// compiled string node returning strlit7352 (depth = 7)
  int op_slot_right_7351 = gc_frame_newslot(strlit7352);
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7354 == NULL) {
    strlit7354 = alloc_String("A definition must have '=' and a value after the name. ");
    gc_root(strlit7354);
  }
// compiled string node returning strlit7354 (depth = 7)
  int op_slot_left_7351 = gc_frame_newslot(strlit7354);
  params[0] = strlit7352;
  partcv[0] = 1;
  Object opresult7355 = callmethod(strlit7354, "++", 1, partcv, params);
// compiled op node returning opresult7355 (depth = 6)
  gc_frame_newslot(opresult7355);
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7356 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7357 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7356);
// compiled call node returning call7357 (depth = 7)
// compiled member node returning call7357 (depth = 6)
  gc_frame_newslot(call7357);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7358 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7359 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7358);
// compiled call node returning call7359 (depth = 7)
// compiled member node returning call7359 (depth = 6)
  gc_frame_newslot(call7359);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7355;
  params[1] = call7357;
  params[2] = call7359;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7360 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7350);
// compiled call node returning call7360 (depth = 5)
    gc_frame_newslot(call7360);
    if7293 = call7360;
  }
// compiled if node returning if7293 (depth = 4)
    gc_frame_newslot(if7293);
    if7233 = if7293;
  }
// compiled if node returning if7233 (depth = 3)
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7361 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7363 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe7362);
// compiled call node returning call7363 (depth = 6)
// compiled member node returning call7363 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7364 = callmethod(call7363, "new",
    1, partcv, params);
  gc_frame_end(callframe7361);
// compiled call node returning call7364 (depth = 4)
  *var_o = call7364;
  if (call7364 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7367 = alloc_Boolean(0);
// compiled identifier node returning bool7367 (depth = 5)
  int op_slot_right_7366 = gc_frame_newslot(bool7367);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_7366 = gc_frame_newslot(*var_anns);
  params[0] = bool7367;
  partcv[0] = 1;
  Object opresult7369 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult7369 (depth = 4)
  Object if7365 = done;
  if (istrue(opresult7369)) {
// starting to compile call node (depth = 4)
  int callframe7370 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7372 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7371);
// compiled call node returning call7372 (depth = 6)
// compiled member node returning call7372 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7373 = callmethod(call7372, "extend",
    1, partcv, params);
  gc_frame_end(callframe7370);
// compiled call node returning call7373 (depth = 4)
    gc_frame_newslot(call7373);
    if7365 = call7373;
  } else {
  }
// compiled if node returning if7365 (depth = 3)
// Begin line 2321
  setline(2321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7374 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultDefVisibility (depth = 4)
  gc_frame_newslot(*var_defaultDefVisibility);
// starting to compile string node (depth = 4)
  if (strlit7375 == NULL) {
    strlit7375 = alloc_String("confidential");
    gc_root(strlit7375);
  }
// compiled string node returning strlit7375 (depth = 4)
  gc_frame_newslot(strlit7375);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultDefVisibility;
  params[2] = strlit7375;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7376 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7374);
// compiled call node returning call7376 (depth = 3)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7377 = gc_frame_new();
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_defTok (depth = 5)
  gc_frame_newslot(*var_defTok);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call7378 = callmethod(*var_o, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe7377);
// compiled call node returning call7378 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7379 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7380 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7379);
// compiled call node returning call7380 (depth = 3)
    gc_frame_newslot(call7380);
    if7121 = call7380;
  } else {
  }
// compiled if node returning if7121 (depth = 2)
  gc_frame_end(frame);
  return if7121;
}
Object meth_parser__apply7414(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7418 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7417);
// compiled call node returning call7418 (depth = 10)
// compiled member node returning call7418 (depth = 9)
  int op_slot_right_7416 = gc_frame_newslot(call7418);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7421 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7420);
// compiled call node returning call7421 (depth = 10)
// compiled member node returning call7421 (depth = 9)
  int op_slot_left_7416 = gc_frame_newslot(call7421);
  params[0] = call7418;
  partcv[0] = 1;
  Object opresult7422 = callmethod(call7421, "==", 1, partcv, params);
// compiled op node returning opresult7422 (depth = 8)
  int op_slot_right_7415 = gc_frame_newslot(opresult7422);
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit7425 == NULL) {
    strlit7425 = alloc_String("bind");
    gc_root(strlit7425);
  }
// compiled string node returning strlit7425 (depth = 9)
  int op_slot_right_7424 = gc_frame_newslot(strlit7425);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7427 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call7428 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7427);
// compiled call node returning call7428 (depth = 10)
// compiled member node returning call7428 (depth = 9)
  int op_slot_left_7424 = gc_frame_newslot(call7428);
  params[0] = strlit7425;
  partcv[0] = 1;
  Object opresult7429 = callmethod(call7428, "==", 1, partcv, params);
// compiled op node returning opresult7429 (depth = 8)
  int op_slot_left_7415 = gc_frame_newslot(opresult7429);
  params[0] = opresult7422;
  partcv[0] = 1;
  Object opresult7430 = callmethod(opresult7429, "&&", 1, partcv, params);
// compiled op node returning opresult7430 (depth = 7)
  gc_frame_end(frame);
  return opresult7430;
}
Object meth_parser__apply7436(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_7437 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  int op_slot_left_7437 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7439 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7439 (depth = 7)
  gc_frame_end(frame);
  return opresult7439;
}
Object meth_parser__apply7496(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe7497 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7498 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7497);
// compiled call node returning call7498 (depth = 9)
  gc_frame_end(frame);
  return call7498;
}
Object meth_parser_vardec7381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(16, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_blocksOK = getfromclosure(closure, 5);
  Object *var_defaultVarVisibility = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for vardec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for vardec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_varTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "varTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_name = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "name");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_suggestions = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "suggestions");
  Object *var_nextTok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "nextTok");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2329
  setline(2329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7385 == NULL) {
    strlit7385 = alloc_String("var");
    gc_root(strlit7385);
  }
// compiled string node returning strlit7385 (depth = 5)
  int op_slot_right_7384 = gc_frame_newslot(strlit7385);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7387 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7388 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7387);
// compiled call node returning call7388 (depth = 6)
// compiled member node returning call7388 (depth = 5)
  int op_slot_left_7384 = gc_frame_newslot(call7388);
  params[0] = strlit7385;
  partcv[0] = 1;
  Object opresult7389 = callmethod(call7388, "==", 1, partcv, params);
// compiled op node returning opresult7389 (depth = 4)
  int op_slot_right_7383 = gc_frame_newslot(opresult7389);
// starting to compile call node (depth = 4)
  int callframe7391 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7392 == NULL) {
    strlit7392 = alloc_String("keyword");
    gc_root(strlit7392);
  }
// compiled string node returning strlit7392 (depth = 5)
  gc_frame_newslot(strlit7392);
// call case 4: self request
  params[0] = strlit7392;
  partcv[0] = 1;
  Object call7393 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7391);
// compiled call node returning call7393 (depth = 4)
  int op_slot_left_7383 = gc_frame_newslot(call7393);
  params[0] = opresult7389;
  partcv[0] = 1;
  Object opresult7394 = callmethod(call7393, "&&", 1, partcv, params);
// compiled op node returning opresult7394 (depth = 3)
  Object if7382 = done;
  if (istrue(opresult7394)) {
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7396 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7395);
// compiled call node returning call7396 (depth = 5)
// compiled member node returning call7396 (depth = 4)
  *var_line = call7396;
  if (call7396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2331
  setline(2331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7397 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call7398 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7397);
// compiled call node returning call7398 (depth = 5)
// compiled member node returning call7398 (depth = 4)
  *var_pos = call7398;
  if (call7398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2332
  setline(2332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7399 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7400 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7399);
// compiled call node returning call7400 (depth = 4)
// compiled member node returning call7400 (depth = 3)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2334
  setline(2334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7403 == NULL) {
    strlit7403 = alloc_String("identifier");
    gc_root(strlit7403);
  }
// compiled string node returning strlit7403 (depth = 5)
  int op_slot_right_7402 = gc_frame_newslot(strlit7403);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7405 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7406 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7405);
// compiled call node returning call7406 (depth = 6)
// compiled member node returning call7406 (depth = 5)
  int op_slot_left_7402 = gc_frame_newslot(call7406);
  params[0] = strlit7403;
  partcv[0] = 1;
  Object opresult7407 = callmethod(call7406, "!=", 1, partcv, params);
// compiled op node returning opresult7407 (depth = 4)
  Object if7401 = done;
  if (istrue(opresult7407)) {
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7408 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7409 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7410 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7409);
// compiled call node returning call7410 (depth = 8)
// compiled member node returning call7410 (depth = 7)
  partcv[0] = 0;
  Object call7411 = callmethod(call7410, "new",
    1, partcv, params);
  gc_frame_end(callframe7408);
// compiled call node returning call7411 (depth = 6)
// compiled member node returning call7411 (depth = 5)
  *var_suggestion = call7411;
  if (call7411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7412 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7413 = alloc_Block(NULL, NULL, "parser", 2336);
  gc_frame_newslot(block7413);
// method _apply
  block_savedest(block7413);
  Object closure7414 = createclosure(2, "_apply");
  setclosureframe(closure7414, stackframe);
  addtoclosure(closure7414, var_sym);
  addtoclosure(closure7414, selfslot);
  struct UserObject *uo7414 = (struct UserObject*)block7413;
  uo7414->data[0] = (Object)closure7414;
  Method *meth_meth_parser__apply7414 = addmethod2pos(block7413, "_apply", &meth_parser__apply7414, 0);
  int argcv_meth_parser__apply7414[] = {1};
  meth_meth_parser__apply7414->type = alloc_MethodType(1, argcv_meth_parser__apply7414);
  meth_meth_parser__apply7414->definitionModule = modulename;
  meth_meth_parser__apply7414->definitionLine = 2335;
// compiled block node returning block7413 (depth = 6)
  gc_frame_newslot(block7413);
// call case 4: self request
  params[0] = block7413;
  partcv[0] = 1;
  Object call7432 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7412);
// compiled call node returning call7432 (depth = 5)
  *var_nextToken = call7432;
  if (call7432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7434 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7435 = alloc_Block(NULL, NULL, "parser", 2338);
  gc_frame_newslot(block7435);
// method _apply
  block_savedest(block7435);
  Object closure7436 = createclosure(3, "_apply");
  setclosureframe(closure7436, stackframe);
  addtoclosure(closure7436, var_sym);
  addtoclosure(closure7436, var_nextToken);
  addtoclosure(closure7436, selfslot);
  struct UserObject *uo7436 = (struct UserObject*)block7435;
  uo7436->data[0] = (Object)closure7436;
  Method *meth_meth_parser__apply7436 = addmethod2pos(block7435, "_apply", &meth_parser__apply7436, 0);
  int argcv_meth_parser__apply7436[] = {0};
  meth_meth_parser__apply7436->type = alloc_MethodType(1, argcv_meth_parser__apply7436);
  meth_meth_parser__apply7436->definitionModule = modulename;
  meth_meth_parser__apply7436->definitionLine = 2336;
// compiled block node returning block7435 (depth = 6)
  gc_frame_newslot(block7435);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool7442 = alloc_Boolean(0);
// compiled identifier node returning bool7442 (depth = 7)
  int op_slot_right_7441 = gc_frame_newslot(bool7442);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextToken (depth = 7)
  int op_slot_left_7441 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7442;
  partcv[0] = 1;
  Object opresult7444 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compiled op node returning opresult7444 (depth = 6)
  params[0] = block7435;
  partcv[0] = 1;
  Object call7445 = callmethod(opresult7444, "orElse",
    1, partcv, params);
  gc_frame_end(callframe7434);
// compiled call node returning call7445 (depth = 5)
  Object if7433 = done;
  if (istrue(call7445)) {
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7446 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7447 == NULL) {
    strlit7447 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7447);
  }
// compiled string node returning strlit7447 (depth = 6)
  gc_frame_newslot(strlit7447);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7447;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7448 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7446);
// compiled call node returning call7448 (depth = 5)
    gc_frame_newslot(call7448);
    if7433 = call7448;
  } else {
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7449 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7450 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextToken (depth = 8)
  partcv[0] = 0;
  Object call7451 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7450);
// compiled call node returning call7451 (depth = 7)
// compiled member node returning call7451 (depth = 6)
  gc_frame_newslot(call7451);
// starting to compile identifier node (depth = 6)
  Object bool7452 = alloc_Boolean(0);
// compiled identifier node returning bool7452 (depth = 6)
  gc_frame_newslot(bool7452);
// starting to compile identifier node (depth = 6)
  Object bool7453 = alloc_Boolean(1);
// compiled identifier node returning bool7453 (depth = 6)
  gc_frame_newslot(bool7453);
// starting to compile string node (depth = 6)
  if (strlit7454 == NULL) {
    strlit7454 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7454);
  }
// compiled string node returning strlit7454 (depth = 6)
  gc_frame_newslot(strlit7454);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7451;
  params[2] = bool7452;
  params[3] = bool7453;
  params[4] = strlit7454;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7455 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7449);
// compiled call node returning call7455 (depth = 5)
    gc_frame_newslot(call7455);
    if7433 = call7455;
  }
// compiled if node returning if7433 (depth = 4)
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7456 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7457 == NULL) {
    strlit7457 = alloc_String("A variable declaration must have a name after the 'var'.");
    gc_root(strlit7457);
  }
// compiled string node returning strlit7457 (depth = 5)
  gc_frame_newslot(strlit7457);
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7459 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7458);
// compiled call node returning call7459 (depth = 6)
// compiled member node returning call7459 (depth = 5)
  gc_frame_newslot(call7459);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7460 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7461 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7460);
// compiled call node returning call7461 (depth = 6)
// compiled member node returning call7461 (depth = 5)
  gc_frame_newslot(call7461);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7457;
  params[1] = call7459;
  params[2] = call7461;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7462 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7456);
// compiled call node returning call7462 (depth = 4)
    gc_frame_newslot(call7462);
    if7401 = call7462;
  } else {
  }
// compiled if node returning if7401 (depth = 3)
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7463 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7464 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7463);
// compiled call node returning call7464 (depth = 4)
// compiled member node returning call7464 (depth = 3)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2347
  setline(2347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool7465 = alloc_Boolean(0);
// compiled identifier node returning bool7465 (depth = 4)
  *var_val = bool7465;
  if (bool7465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7466 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call7467 = callmethod(*var_ast, "unknownType",
    1, partcv, params);
  gc_frame_end(callframe7466);
// compiled call node returning call7467 (depth = 5)
// compiled member node returning call7467 (depth = 4)
  *var_dtype = call7467;
  if (call7467 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7468 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call7469 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7468);
// compiled call node returning call7469 (depth = 5)
// compiled member node returning call7469 (depth = 4)
  *var_name = call7469;
  if (call7469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7470 = gc_frame_new();
// Begin line 2350
  setline(2350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool7471 = alloc_Boolean(1);
// compiled identifier node returning bool7471 (depth = 5)
  gc_frame_newslot(bool7471);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  params[0] = bool7471;
  partcv[0] = 1;
  Object call7472 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe7470);
// compiled call node returning call7472 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7474 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7475 == NULL) {
    strlit7475 = alloc_String("colon");
    gc_root(strlit7475);
  }
// compiled string node returning strlit7475 (depth = 5)
  gc_frame_newslot(strlit7475);
// call case 4: self request
  params[0] = strlit7475;
  partcv[0] = 1;
  Object call7476 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7474);
// compiled call node returning call7476 (depth = 4)
  Object if7473 = done;
  if (istrue(call7476)) {
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7477 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7478 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7477);
// compiled call node returning call7478 (depth = 5)
// compiled member node returning call7478 (depth = 4)
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7479 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7480 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7479);
// compiled call node returning call7480 (depth = 5)
// compiled member node returning call7480 (depth = 4)
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7481 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7482 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7481);
// compiled call node returning call7482 (depth = 6)
// compiled member node returning call7482 (depth = 5)
  *var_dtype = call7482;
  if (call7482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7473 = done;
  } else {
  }
// compiled if node returning if7473 (depth = 3)
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7484 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7485 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7484);
// compiled call node returning call7485 (depth = 5)
// compiled member node returning call7485 (depth = 4)
  *var_anns = call7485;
  if (call7485 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7487 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7488 == NULL) {
    strlit7488 = alloc_String("bind");
    gc_root(strlit7488);
  }
// compiled string node returning strlit7488 (depth = 5)
  gc_frame_newslot(strlit7488);
// call case 4: self request
  params[0] = strlit7488;
  partcv[0] = 1;
  Object call7489 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7487);
// compiled call node returning call7489 (depth = 4)
  Object if7486 = done;
  if (istrue(call7489)) {
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7490 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7491 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7490);
// compiled call node returning call7491 (depth = 5)
// compiled member node returning call7491 (depth = 4)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7493 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe7494 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block7495 = alloc_Block(NULL, NULL, "parser", 2359);
  gc_frame_newslot(block7495);
// method _apply
  block_savedest(block7495);
  Object closure7496 = createclosure(2, "_apply");
  setclosureframe(closure7496, stackframe);
  addtoclosure(closure7496, var_blocksOK);
  addtoclosure(closure7496, selfslot);
  struct UserObject *uo7496 = (struct UserObject*)block7495;
  uo7496->data[0] = (Object)closure7496;
  Method *meth_meth_parser__apply7496 = addmethod2pos(block7495, "_apply", &meth_parser__apply7496, 0);
  int argcv_meth_parser__apply7496[] = {0};
  meth_meth_parser__apply7496->type = alloc_MethodType(1, argcv_meth_parser__apply7496);
  meth_meth_parser__apply7496->definitionModule = modulename;
  meth_meth_parser__apply7496->definitionLine = 2359;
// compiled block node returning block7495 (depth = 8)
  gc_frame_newslot(block7495);
// call case 4: self request
  params[0] = block7495;
  partcv[0] = 1;
  Object call7500 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7494);
// compiled call node returning call7500 (depth = 7)
  partcv[0] = 0;
  Object call7501 = callmethod(call7500, "not",
    1, partcv, params);
  gc_frame_end(callframe7493);
// compiled call node returning call7501 (depth = 6)
// compiled member node returning call7501 (depth = 5)
  Object if7492 = done;
  if (istrue(call7501)) {
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array7502 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7502 (depth = 6)
  *var_suggestions = array7502;
  if (array7502 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7503 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7504 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7505 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7504);
// compiled call node returning call7505 (depth = 9)
// compiled member node returning call7505 (depth = 8)
  partcv[0] = 0;
  Object call7506 = callmethod(call7505, "new",
    1, partcv, params);
  gc_frame_end(callframe7503);
// compiled call node returning call7506 (depth = 7)
// compiled member node returning call7506 (depth = 6)
  *var_suggestion = call7506;
  if (call7506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7507 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7508 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7507);
// compiled call node returning call7508 (depth = 6)
  *var_nextTok = call7508;
  if (call7508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_7510 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_7510 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7512 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7512 (depth = 6)
  Object if7509 = done;
  if (istrue(opresult7512)) {
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7513 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7514 == NULL) {
    strlit7514 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7514);
  }
// compiled string node returning strlit7514 (depth = 7)
  gc_frame_newslot(strlit7514);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit7514;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7515 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7513);
// compiled call node returning call7515 (depth = 6)
    gc_frame_newslot(call7515);
    if7509 = call7515;
  } else {
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe7516 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7517 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call7518 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7517);
// compiled call node returning call7518 (depth = 8)
// compiled member node returning call7518 (depth = 7)
  gc_frame_newslot(call7518);
// starting to compile identifier node (depth = 7)
  Object bool7519 = alloc_Boolean(1);
// compiled identifier node returning bool7519 (depth = 7)
  gc_frame_newslot(bool7519);
// starting to compile identifier node (depth = 7)
  Object bool7520 = alloc_Boolean(0);
// compiled identifier node returning bool7520 (depth = 7)
  gc_frame_newslot(bool7520);
// starting to compile string node (depth = 7)
  if (strlit7521 == NULL) {
    strlit7521 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7521);
  }
// compiled string node returning strlit7521 (depth = 7)
  gc_frame_newslot(strlit7521);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call7518;
  params[2] = bool7519;
  params[3] = bool7520;
  params[4] = strlit7521;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7522 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7516);
// compiled call node returning call7522 (depth = 6)
    gc_frame_newslot(call7522);
    if7509 = call7522;
  }
// compiled if node returning if7509 (depth = 5)
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7523 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7524 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7523);
// compiled call node returning call7524 (depth = 5)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2369
  setline(2369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7525 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7527 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7526);
// compiled call node returning call7527 (depth = 9)
// compiled member node returning call7527 (depth = 8)
  partcv[0] = 0;
  Object call7528 = callmethod(call7527, "new",
    1, partcv, params);
  gc_frame_end(callframe7525);
// compiled call node returning call7528 (depth = 7)
// compiled member node returning call7528 (depth = 6)
  *var_suggestion = call7528;
  if (call7528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7530 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7531 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7532 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7531);
// compiled call node returning call7532 (depth = 7)
// compiled member node returning call7532 (depth = 6)
  gc_frame_newslot(call7532);
// starting to compile identifier node (depth = 6)
  Object bool7533 = alloc_Boolean(1);
// compiled identifier node returning bool7533 (depth = 6)
  gc_frame_newslot(bool7533);
// starting to compile identifier node (depth = 6)
  Object bool7534 = alloc_Boolean(0);
// compiled identifier node returning bool7534 (depth = 6)
  gc_frame_newslot(bool7534);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = call7532;
  params[2] = bool7533;
  params[3] = bool7534;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7535 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7530);
// compiled call node returning call7535 (depth = 5)
// Begin line 2371
  setline(2371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7536 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7537 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7536);
// compiled call node returning call7537 (depth = 5)
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7538 = gc_frame_new();
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7540 == NULL) {
    strlit7540 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit7540);
  }
// compiled string node returning strlit7540 (depth = 7)
  int op_slot_right_7539 = gc_frame_newslot(strlit7540);
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 7)
  if (strlit7542 == NULL) {
    strlit7542 = alloc_String("A variable declaration must have a value after the ':='. ");
    gc_root(strlit7542);
  }
// compiled string node returning strlit7542 (depth = 7)
  int op_slot_left_7539 = gc_frame_newslot(strlit7542);
  params[0] = strlit7540;
  partcv[0] = 1;
  Object opresult7543 = callmethod(strlit7542, "++", 1, partcv, params);
// compiled op node returning opresult7543 (depth = 6)
  gc_frame_newslot(opresult7543);
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7544 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7545 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7544);
// compiled call node returning call7545 (depth = 7)
// compiled member node returning call7545 (depth = 6)
  gc_frame_newslot(call7545);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7548 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7547);
// compiled call node returning call7548 (depth = 8)
// compiled member node returning call7548 (depth = 7)
  int op_slot_right_7546 = gc_frame_newslot(call7548);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7551 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7550);
// compiled call node returning call7551 (depth = 8)
// compiled member node returning call7551 (depth = 7)
  int op_slot_left_7546 = gc_frame_newslot(call7551);
  params[0] = call7548;
  partcv[0] = 1;
  Object sum7552 = callmethod(call7551, "+", 1, partcv, params);
// compiled op node returning sum7552 (depth = 6)
  gc_frame_newslot(sum7552);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = opresult7543;
  params[1] = call7545;
  params[2] = sum7552;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7553 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7538);
// compiled call node returning call7553 (depth = 5)
    gc_frame_newslot(call7553);
    if7492 = call7553;
  } else {
  }
// compiled if node returning if7492 (depth = 4)
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7555 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7554);
// compiled call node returning call7555 (depth = 6)
// compiled member node returning call7555 (depth = 5)
  *var_val = call7555;
  if (call7555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if7486 = done;
  } else {
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7560 == NULL) {
    strlit7560 = alloc_String("=");
    gc_root(strlit7560);
  }
// compiled string node returning strlit7560 (depth = 7)
  int op_slot_right_7559 = gc_frame_newslot(strlit7560);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7562 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7563 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7562);
// compiled call node returning call7563 (depth = 8)
// compiled member node returning call7563 (depth = 7)
  int op_slot_left_7559 = gc_frame_newslot(call7563);
  params[0] = strlit7560;
  partcv[0] = 1;
  Object opresult7564 = callmethod(call7563, "==", 1, partcv, params);
// compiled op node returning opresult7564 (depth = 6)
  int op_slot_right_7558 = gc_frame_newslot(opresult7564);
// starting to compile call node (depth = 6)
  int callframe7566 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit7567 == NULL) {
    strlit7567 = alloc_String("op");
    gc_root(strlit7567);
  }
// compiled string node returning strlit7567 (depth = 7)
  gc_frame_newslot(strlit7567);
// call case 4: self request
  params[0] = strlit7567;
  partcv[0] = 1;
  Object call7568 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7566);
// compiled call node returning call7568 (depth = 6)
  int op_slot_left_7558 = gc_frame_newslot(call7568);
  params[0] = opresult7564;
  partcv[0] = 1;
  Object opresult7569 = callmethod(call7568, "&&", 1, partcv, params);
// compiled op node returning opresult7569 (depth = 5)
  Object if7557 = done;
  if (istrue(opresult7569)) {
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2379
  setline(2379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array7570 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7570 (depth = 6)
  *var_suggestions = array7570;
  if (array7570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7571 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7572 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7573 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7572);
// compiled call node returning call7573 (depth = 9)
// compiled member node returning call7573 (depth = 8)
  partcv[0] = 0;
  Object call7574 = callmethod(call7573, "new",
    1, partcv, params);
  gc_frame_end(callframe7571);
// compiled call node returning call7574 (depth = 7)
// compiled member node returning call7574 (depth = 6)
  *var_suggestion = call7574;
  if (call7574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7575 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 6)
  if (strlit7576 == NULL) {
    strlit7576 = alloc_String(":=");
    gc_root(strlit7576);
  }
// compiled string node returning strlit7576 (depth = 6)
  gc_frame_newslot(strlit7576);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = strlit7576;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7577 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7575);
// compiled call node returning call7577 (depth = 5)
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7578 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7579 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7578);
// compiled call node returning call7579 (depth = 5)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7580 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7581 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call7582 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7581);
// compiled call node returning call7582 (depth = 9)
// compiled member node returning call7582 (depth = 8)
  partcv[0] = 0;
  Object call7583 = callmethod(call7582, "new",
    1, partcv, params);
  gc_frame_end(callframe7580);
// compiled call node returning call7583 (depth = 7)
// compiled member node returning call7583 (depth = 6)
  *var_suggestion = call7583;
  if (call7583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7585 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varTok (depth = 6)
  gc_frame_newslot(*var_varTok);
// starting to compile string node (depth = 6)
  if (strlit7586 == NULL) {
    strlit7586 = alloc_String("def");
    gc_root(strlit7586);
  }
// compiled string node returning strlit7586 (depth = 6)
  gc_frame_newslot(strlit7586);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_varTok;
  params[1] = strlit7586;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7587 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7585);
// compiled call node returning call7587 (depth = 5)
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7588 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7589 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7588);
// compiled call node returning call7589 (depth = 5)
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7590 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7591 == NULL) {
    strlit7591 = alloc_String("A variable declaration must use ':=' instead of '='. A definition uses 'def' and '='.");
    gc_root(strlit7591);
  }
// compiled string node returning strlit7591 (depth = 6)
  gc_frame_newslot(strlit7591);
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7592 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7593 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7592);
// compiled call node returning call7593 (depth = 7)
// compiled member node returning call7593 (depth = 6)
  gc_frame_newslot(call7593);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7594 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7595 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7594);
// compiled call node returning call7595 (depth = 7)
// compiled member node returning call7595 (depth = 6)
  gc_frame_newslot(call7595);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7596 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7597 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7596);
// compiled call node returning call7597 (depth = 7)
// compiled member node returning call7597 (depth = 6)
  gc_frame_newslot(call7597);
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit7591;
  params[1] = call7593;
  params[2] = call7595;
  params[3] = call7597;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7598 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7590);
// compiled call node returning call7598 (depth = 5)
    gc_frame_newslot(call7598);
    if7557 = call7598;
  } else {
  }
// compiled if node returning if7557 (depth = 4)
    gc_frame_newslot(if7557);
    if7486 = if7557;
  }
// compiled if node returning if7486 (depth = 3)
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7599 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7601 = callmethod(*var_ast, "varDecNode",
    1, partcv, params);
  gc_frame_end(callframe7600);
// compiled call node returning call7601 (depth = 6)
// compiled member node returning call7601 (depth = 5)
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7602 = callmethod(call7601, "new",
    1, partcv, params);
  gc_frame_end(callframe7599);
// compiled call node returning call7602 (depth = 4)
  *var_o = call7602;
  if (call7602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool7605 = alloc_Boolean(0);
// compiled identifier node returning bool7605 (depth = 5)
  int op_slot_right_7604 = gc_frame_newslot(bool7605);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_7604 = gc_frame_newslot(*var_anns);
  params[0] = bool7605;
  partcv[0] = 1;
  Object opresult7607 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult7607 (depth = 4)
  Object if7603 = done;
  if (istrue(opresult7607)) {
// starting to compile call node (depth = 4)
  int callframe7608 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call7610 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7609);
// compiled call node returning call7610 (depth = 6)
// compiled member node returning call7610 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7611 = callmethod(call7610, "extend",
    1, partcv, params);
  gc_frame_end(callframe7608);
// compiled call node returning call7611 (depth = 4)
    gc_frame_newslot(call7611);
    if7603 = call7611;
  } else {
  }
// compiled if node returning if7603 (depth = 3)
// Begin line 2393
  setline(2393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7612 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultVarVisibility (depth = 4)
  gc_frame_newslot(*var_defaultVarVisibility);
// starting to compile string node (depth = 4)
  if (strlit7613 == NULL) {
    strlit7613 = alloc_String("confidential");
    gc_root(strlit7613);
  }
// compiled string node returning strlit7613 (depth = 4)
  gc_frame_newslot(strlit7613);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultVarVisibility;
  params[2] = strlit7613;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7614 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compiled call node returning call7614 (depth = 3)
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7615 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7616 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7615);
// compiled call node returning call7616 (depth = 3)
    gc_frame_newslot(call7616);
    if7382 = call7616;
  } else {
  }
// compiled if node returning if7382 (depth = 2)
  gc_frame_end(frame);
  return if7382;
}
Object meth_parser__apply7627(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe7628 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7629 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7628);
// compiled call node returning call7629 (depth = 5)
  gc_frame_end(frame);
  return call7629;
}
Object meth_parser__apply7635(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 7)
  int callframe7636 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit7637 == NULL) {
    strlit7637 = alloc_String("comma");
    gc_root(strlit7637);
  }
// compiled string node returning strlit7637 (depth = 8)
  gc_frame_newslot(strlit7637);
// call case 4: self request
  params[0] = strlit7637;
  partcv[0] = 1;
  Object call7638 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7636);
// compiled call node returning call7638 (depth = 7)
  gc_frame_end(frame);
  return call7638;
}
Object meth_parser__apply7653(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 12)
  int callframe7654 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_blocksOK (depth = 13)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call7655 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7654);
// compiled call node returning call7655 (depth = 12)
  gc_frame_end(frame);
  return call7655;
}
Object meth_parser__apply7641(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call7643 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7642);
// compiled call node returning call7643 (depth = 9)
// compiled member node returning call7643 (depth = 8)
  *var_tmp = call7643;
  if (call7643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe7645 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tmp (depth = 8)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_params (depth = 8)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7646 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7645);
// compiled call node returning call7646 (depth = 7)
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7647 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7648 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7647);
// compiled call node returning call7648 (depth = 8)
// compiled member node returning call7648 (depth = 7)
// Begin line 2425
  setline(2425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7650 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 10)
  int callframe7651 = gc_frame_new();
// starting to compile block node (depth = 11)
  Object block7652 = alloc_Block(NULL, NULL, "parser", 2409);
  gc_frame_newslot(block7652);
// method _apply
  block_savedest(block7652);
  Object closure7653 = createclosure(2, "_apply");
  setclosureframe(closure7653, stackframe);
  addtoclosure(closure7653, var_blocksOK);
  addtoclosure(closure7653, selfslot);
  struct UserObject *uo7653 = (struct UserObject*)block7652;
  uo7653->data[0] = (Object)closure7653;
  Method *meth_meth_parser__apply7653 = addmethod2pos(block7652, "_apply", &meth_parser__apply7653, 0);
  int argcv_meth_parser__apply7653[] = {0};
  meth_meth_parser__apply7653->type = alloc_MethodType(1, argcv_meth_parser__apply7653);
  meth_meth_parser__apply7653->definitionModule = modulename;
  meth_meth_parser__apply7653->definitionLine = 2409;
// compiled block node returning block7652 (depth = 11)
  gc_frame_newslot(block7652);
// call case 4: self request
  params[0] = block7652;
  partcv[0] = 1;
  Object call7657 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7651);
// compiled call node returning call7657 (depth = 10)
  partcv[0] = 0;
  Object call7658 = callmethod(call7657, "not",
    1, partcv, params);
  gc_frame_end(callframe7650);
// compiled call node returning call7658 (depth = 9)
// compiled member node returning call7658 (depth = 8)
  Object if7649 = done;
  if (istrue(call7658)) {
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array7659 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7659 (depth = 9)
  *var_suggestions = array7659;
  if (array7659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7660 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7662 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7661);
// compiled call node returning call7662 (depth = 12)
// compiled member node returning call7662 (depth = 11)
  partcv[0] = 0;
  Object call7663 = callmethod(call7662, "new",
    1, partcv, params);
  gc_frame_end(callframe7660);
// compiled call node returning call7663 (depth = 10)
// compiled member node returning call7663 (depth = 9)
  *var_suggestion = call7663;
  if (call7663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2412
  setline(2412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7664 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7665 == NULL) {
    strlit7665 = alloc_String("rsquare");
    gc_root(strlit7665);
  }
// compiled string node returning strlit7665 (depth = 10)
  gc_frame_newslot(strlit7665);
// call case 4: self request
  params[0] = strlit7665;
  partcv[0] = 1;
  Object call7666 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7664);
// compiled call node returning call7666 (depth = 9)
  *var_nextTok = call7666;
  if (call7666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  int op_slot_right_7668 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  int op_slot_left_7668 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7670 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7670 (depth = 9)
  Object if7667 = done;
  if (istrue(opresult7670)) {
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7671 = gc_frame_new();
// starting to compile string node (depth = 10)
  if (strlit7672 == NULL) {
    strlit7672 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7672);
  }
// compiled string node returning strlit7672 (depth = 10)
  gc_frame_newslot(strlit7672);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = strlit7672;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7673 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7671);
// compiled call node returning call7673 (depth = 9)
    gc_frame_newslot(call7673);
    if7667 = call7673;
  } else {
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe7674 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe7675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_nextTok (depth = 12)
  partcv[0] = 0;
  Object call7676 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7675);
// compiled call node returning call7676 (depth = 11)
// compiled member node returning call7676 (depth = 10)
  gc_frame_newslot(call7676);
// starting to compile identifier node (depth = 10)
  Object bool7677 = alloc_Boolean(1);
// compiled identifier node returning bool7677 (depth = 10)
  gc_frame_newslot(bool7677);
// starting to compile identifier node (depth = 10)
  Object bool7678 = alloc_Boolean(0);
// compiled identifier node returning bool7678 (depth = 10)
  gc_frame_newslot(bool7678);
// starting to compile string node (depth = 10)
  if (strlit7679 == NULL) {
    strlit7679 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7679);
  }
// compiled string node returning strlit7679 (depth = 10)
  gc_frame_newslot(strlit7679);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_sym;
  params[1] = call7676;
  params[2] = bool7677;
  params[3] = bool7678;
  params[4] = strlit7679;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7680 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7674);
// compiled call node returning call7680 (depth = 9)
    gc_frame_newslot(call7680);
    if7667 = call7680;
  }
// compiled if node returning if7667 (depth = 8)
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7681 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7682 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7681);
// compiled call node returning call7682 (depth = 8)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 2419
  setline(2419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7683 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe7684 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call7685 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7684);
// compiled call node returning call7685 (depth = 12)
// compiled member node returning call7685 (depth = 11)
  partcv[0] = 0;
  Object call7686 = callmethod(call7685, "new",
    1, partcv, params);
  gc_frame_end(callframe7683);
// compiled call node returning call7686 (depth = 10)
// compiled member node returning call7686 (depth = 9)
  *var_suggestion = call7686;
  if (call7686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7688 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7689 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call7690 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7689);
// compiled call node returning call7690 (depth = 10)
// compiled member node returning call7690 (depth = 9)
  gc_frame_newslot(call7690);
// starting to compile identifier node (depth = 9)
  Object bool7691 = alloc_Boolean(1);
// compiled identifier node returning bool7691 (depth = 9)
  gc_frame_newslot(bool7691);
// starting to compile identifier node (depth = 9)
  Object bool7692 = alloc_Boolean(0);
// compiled identifier node returning bool7692 (depth = 9)
  gc_frame_newslot(bool7692);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  params[1] = call7690;
  params[2] = bool7691;
  params[3] = bool7692;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7693 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7688);
// compiled call node returning call7693 (depth = 8)
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7694 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7695 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7694);
// compiled call node returning call7695 (depth = 8)
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe7696 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit7697 == NULL) {
    strlit7697 = alloc_String("A list must contain zero or more valid expressions separated by commas.");
    gc_root(strlit7697);
  }
// compiled string node returning strlit7697 (depth = 9)
  gc_frame_newslot(strlit7697);
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7698 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7699 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7698);
// compiled call node returning call7699 (depth = 10)
// compiled member node returning call7699 (depth = 9)
  gc_frame_newslot(call7699);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe7700 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call7701 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7700);
// compiled call node returning call7701 (depth = 10)
// compiled member node returning call7701 (depth = 9)
  gc_frame_newslot(call7701);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2422
  setline(2422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit7697;
  params[1] = call7699;
  params[2] = call7701;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7702 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7696);
// compiled call node returning call7702 (depth = 8)
    gc_frame_newslot(call7702);
    if7649 = call7702;
  } else {
  }
// compiled if node returning if7649 (depth = 7)
  gc_frame_end(frame);
  return if7649;
}
Object meth_parser__apply7632(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7633 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7634 = alloc_Block(NULL, NULL, "parser", 2405);
  gc_frame_newslot(block7634);
// method _apply
  block_savedest(block7634);
  Object closure7635 = createclosure(1, "_apply");
  setclosureframe(closure7635, stackframe);
  addtoclosure(closure7635, selfslot);
  struct UserObject *uo7635 = (struct UserObject*)block7634;
  uo7635->data[0] = (Object)closure7635;
  Method *meth_meth_parser__apply7635 = addmethod2pos(block7634, "_apply", &meth_parser__apply7635, 0);
  int argcv_meth_parser__apply7635[] = {0};
  meth_meth_parser__apply7635->type = alloc_MethodType(1, argcv_meth_parser__apply7635);
  meth_meth_parser__apply7635->definitionModule = modulename;
  meth_meth_parser__apply7635->definitionLine = 2401;
// compiled block node returning block7634 (depth = 6)
  gc_frame_newslot(block7634);
// starting to compile block node (depth = 6)
  Object block7640 = alloc_Block(NULL, NULL, "parser", 2405);
  gc_frame_newslot(block7640);
// method _apply
  block_savedest(block7640);
  Object closure7641 = createclosure(8, "_apply");
  setclosureframe(closure7641, stackframe);
  addtoclosure(closure7641, var_values);
  addtoclosure(closure7641, var_tmp);
  addtoclosure(closure7641, var_params);
  addtoclosure(closure7641, var_blocksOK);
  addtoclosure(closure7641, var_errormessages);
  addtoclosure(closure7641, var_sym);
  addtoclosure(closure7641, var_lastToken);
  addtoclosure(closure7641, selfslot);
  struct UserObject *uo7641 = (struct UserObject*)block7640;
  uo7641->data[0] = (Object)closure7641;
  Method *meth_meth_parser__apply7641 = addmethod2pos(block7640, "_apply", &meth_parser__apply7641, 0);
  int argcv_meth_parser__apply7641[] = {0};
  meth_meth_parser__apply7641->type = alloc_MethodType(1, argcv_meth_parser__apply7641);
  meth_meth_parser__apply7641->definitionModule = modulename;
  meth_meth_parser__apply7641->definitionLine = 2401;
// compiled block node returning block7640 (depth = 6)
  gc_frame_newslot(block7640);
// call case 5: prelude request
  params[0] = block7634;
  params[1] = block7640;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7704 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7633);
// compiled call node returning call7704 (depth = 5)
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7705 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call7706 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7705);
// compiled call node returning call7706 (depth = 7)
// compiled member node returning call7706 (depth = 6)
  *var_tmp = call7706;
  if (call7706 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7708 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tmp (depth = 6)
  gc_frame_newslot(*var_tmp);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_params (depth = 6)
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7709 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7708);
// compiled call node returning call7709 (depth = 5)
  gc_frame_end(frame);
  return call7709;
}
Object meth_parser_doarray7617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doarray (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doarray");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7619 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit7620 == NULL) {
    strlit7620 = alloc_String("lsquare");
    gc_root(strlit7620);
  }
// compiled string node returning strlit7620 (depth = 4)
  gc_frame_newslot(strlit7620);
// call case 4: self request
  params[0] = strlit7620;
  partcv[0] = 1;
  Object call7621 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7619);
// compiled call node returning call7621 (depth = 3)
  Object if7618 = done;
  if (istrue(call7621)) {
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7622 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7623 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7622);
// compiled call node returning call7623 (depth = 4)
// compiled member node returning call7623 (depth = 3)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_tmp = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array7624 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7624 (depth = 4)
  *var_params = array7624;
  if (array7624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7625 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block7626 = alloc_Block(NULL, NULL, "parser", 2404);
  gc_frame_newslot(block7626);
// method _apply
  block_savedest(block7626);
  Object closure7627 = createclosure(2, "_apply");
  setclosureframe(closure7627, stackframe);
  addtoclosure(closure7627, var_blocksOK);
  addtoclosure(closure7627, selfslot);
  struct UserObject *uo7627 = (struct UserObject*)block7626;
  uo7627->data[0] = (Object)closure7627;
  Method *meth_meth_parser__apply7627 = addmethod2pos(block7626, "_apply", &meth_parser__apply7627, 0);
  int argcv_meth_parser__apply7627[] = {0};
  meth_meth_parser__apply7627->type = alloc_MethodType(1, argcv_meth_parser__apply7627);
  meth_meth_parser__apply7627->definitionModule = modulename;
  meth_meth_parser__apply7627->definitionLine = 2401;
// compiled block node returning block7626 (depth = 4)
  gc_frame_newslot(block7626);
// starting to compile block node (depth = 4)
  Object block7631 = alloc_Block(NULL, NULL, "parser", 2404);
  gc_frame_newslot(block7631);
// method _apply
  block_savedest(block7631);
  Object closure7632 = createclosure(8, "_apply");
  setclosureframe(closure7632, stackframe);
  addtoclosure(closure7632, var_values);
  addtoclosure(closure7632, var_tmp);
  addtoclosure(closure7632, var_params);
  addtoclosure(closure7632, var_blocksOK);
  addtoclosure(closure7632, var_errormessages);
  addtoclosure(closure7632, var_sym);
  addtoclosure(closure7632, var_lastToken);
  addtoclosure(closure7632, selfslot);
  struct UserObject *uo7632 = (struct UserObject*)block7631;
  uo7632->data[0] = (Object)closure7632;
  Method *meth_meth_parser__apply7632 = addmethod2pos(block7631, "_apply", &meth_parser__apply7632, 0);
  int argcv_meth_parser__apply7632[] = {0};
  meth_meth_parser__apply7632->type = alloc_MethodType(1, argcv_meth_parser__apply7632);
  meth_meth_parser__apply7632->definitionModule = modulename;
  meth_meth_parser__apply7632->definitionLine = 2401;
// compiled block node returning block7631 (depth = 4)
  gc_frame_newslot(block7631);
// call case 4: self request
  params[0] = block7626;
  params[1] = block7631;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7711 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7625);
// compiled call node returning call7711 (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2429
  setline(2429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7714 == NULL) {
    strlit7714 = alloc_String("rsquare");
    gc_root(strlit7714);
  }
// compiled string node returning strlit7714 (depth = 5)
  int op_slot_right_7713 = gc_frame_newslot(strlit7714);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7717 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7716);
// compiled call node returning call7717 (depth = 6)
// compiled member node returning call7717 (depth = 5)
  int op_slot_left_7713 = gc_frame_newslot(call7717);
  params[0] = strlit7714;
  partcv[0] = 1;
  Object opresult7718 = callmethod(call7717, "!=", 1, partcv, params);
// compiled op node returning opresult7718 (depth = 4)
  Object if7712 = done;
  if (istrue(opresult7718)) {
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7719 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7720 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7721 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7720);
// compiled call node returning call7721 (depth = 8)
// compiled member node returning call7721 (depth = 7)
  partcv[0] = 0;
  Object call7722 = callmethod(call7721, "new",
    1, partcv, params);
  gc_frame_end(callframe7719);
// compiled call node returning call7722 (depth = 6)
// compiled member node returning call7722 (depth = 5)
  *var_suggestion = call7722;
  if (call7722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7723 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7724 == NULL) {
    strlit7724 = alloc_String("]");
    gc_root(strlit7724);
  }
// compiled string node returning strlit7724 (depth = 5)
  gc_frame_newslot(strlit7724);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit7724;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7725 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7723);
// compiled call node returning call7725 (depth = 4)
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7726 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7727 == NULL) {
    strlit7727 = alloc_String("A list beginning with a '[' must end with a ']'.");
    gc_root(strlit7727);
  }
// compiled string node returning strlit7727 (depth = 5)
  gc_frame_newslot(strlit7727);
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7729 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7728);
// compiled call node returning call7729 (depth = 6)
// compiled member node returning call7729 (depth = 5)
  gc_frame_newslot(call7729);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7731 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7732 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7731);
// compiled call node returning call7732 (depth = 7)
// compiled member node returning call7732 (depth = 6)
  int op_slot_right_7730 = gc_frame_newslot(call7732);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7735 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7734);
// compiled call node returning call7735 (depth = 7)
// compiled member node returning call7735 (depth = 6)
  int op_slot_left_7730 = gc_frame_newslot(call7735);
  params[0] = call7732;
  partcv[0] = 1;
  Object sum7736 = callmethod(call7735, "+", 1, partcv, params);
// compiled op node returning sum7736 (depth = 5)
  gc_frame_newslot(sum7736);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7727;
  params[1] = call7729;
  params[2] = sum7736;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7737 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7726);
// compiled call node returning call7737 (depth = 4)
    gc_frame_newslot(call7737);
    if7712 = call7737;
  } else {
  }
// compiled if node returning if7712 (depth = 3)
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7738 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_params (depth = 5)
  gc_frame_newslot(*var_params);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7740 = callmethod(*var_ast, "arrayNode",
    1, partcv, params);
  gc_frame_end(callframe7739);
// compiled call node returning call7740 (depth = 6)
// compiled member node returning call7740 (depth = 5)
  params[0] = *var_params;
  partcv[0] = 1;
  Object call7741 = callmethod(call7740, "new",
    1, partcv, params);
  gc_frame_end(callframe7738);
// compiled call node returning call7741 (depth = 4)
  *var_o = call7741;
  if (call7741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7742 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7743 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7742);
// compiled call node returning call7743 (depth = 3)
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7745 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7744);
// compiled call node returning call7745 (depth = 4)
// compiled member node returning call7745 (depth = 3)
    gc_frame_newslot(call7745);
    if7618 = call7745;
  } else {
  }
// compiled if node returning if7618 (depth = 2)
  gc_frame_end(frame);
  return if7618;
}
Object meth_parser_dodialect7746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dodialect (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dodialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// Begin line 2461
  setline(2461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7750 == NULL) {
    strlit7750 = alloc_String("dialect");
    gc_root(strlit7750);
  }
// compiled string node returning strlit7750 (depth = 5)
  int op_slot_right_7749 = gc_frame_newslot(strlit7750);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7752 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7753 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7752);
// compiled call node returning call7753 (depth = 6)
// compiled member node returning call7753 (depth = 5)
  int op_slot_left_7749 = gc_frame_newslot(call7753);
  params[0] = strlit7750;
  partcv[0] = 1;
  Object opresult7754 = callmethod(call7753, "==", 1, partcv, params);
// compiled op node returning opresult7754 (depth = 4)
  int op_slot_right_7748 = gc_frame_newslot(opresult7754);
// starting to compile call node (depth = 4)
  int callframe7756 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7757 == NULL) {
    strlit7757 = alloc_String("keyword");
    gc_root(strlit7757);
  }
// compiled string node returning strlit7757 (depth = 5)
  gc_frame_newslot(strlit7757);
// call case 4: self request
  params[0] = strlit7757;
  partcv[0] = 1;
  Object call7758 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7756);
// compiled call node returning call7758 (depth = 4)
  int op_slot_left_7748 = gc_frame_newslot(call7758);
  params[0] = opresult7754;
  partcv[0] = 1;
  Object opresult7759 = callmethod(call7758, "&&", 1, partcv, params);
// compiled op node returning opresult7759 (depth = 3)
  Object if7747 = done;
  if (istrue(opresult7759)) {
// Begin line 2444
  setline(2444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7760 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7761 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7760);
// compiled call node returning call7761 (depth = 4)
// compiled member node returning call7761 (depth = 3)
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7764 == NULL) {
    strlit7764 = alloc_String("string");
    gc_root(strlit7764);
  }
// compiled string node returning strlit7764 (depth = 5)
  int op_slot_right_7763 = gc_frame_newslot(strlit7764);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7767 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7766);
// compiled call node returning call7767 (depth = 6)
// compiled member node returning call7767 (depth = 5)
  int op_slot_left_7763 = gc_frame_newslot(call7767);
  params[0] = strlit7764;
  partcv[0] = 1;
  Object opresult7768 = callmethod(call7767, "!=", 1, partcv, params);
// compiled op node returning opresult7768 (depth = 4)
  Object if7762 = done;
  if (istrue(opresult7768)) {
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7769 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7770 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7771 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7770);
// compiled call node returning call7771 (depth = 8)
// compiled member node returning call7771 (depth = 7)
  partcv[0] = 0;
  Object call7772 = callmethod(call7771, "new",
    1, partcv, params);
  gc_frame_end(callframe7769);
// compiled call node returning call7772 (depth = 6)
// compiled member node returning call7772 (depth = 5)
  *var_suggestion = call7772;
  if (call7772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7776 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7777 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7776);
// compiled call node returning call7777 (depth = 8)
// compiled member node returning call7777 (depth = 7)
  int op_slot_right_7775 = gc_frame_newslot(call7777);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7780 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7779);
// compiled call node returning call7780 (depth = 8)
// compiled member node returning call7780 (depth = 7)
  int op_slot_left_7775 = gc_frame_newslot(call7780);
  params[0] = call7777;
  partcv[0] = 1;
  Object opresult7781 = callmethod(call7780, "==", 1, partcv, params);
// compiled op node returning opresult7781 (depth = 6)
  int op_slot_right_7774 = gc_frame_newslot(opresult7781);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7784 == NULL) {
    strlit7784 = alloc_String("identifier");
    gc_root(strlit7784);
  }
// compiled string node returning strlit7784 (depth = 7)
  int op_slot_right_7783 = gc_frame_newslot(strlit7784);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call7787 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7786);
// compiled call node returning call7787 (depth = 8)
// compiled member node returning call7787 (depth = 7)
  int op_slot_left_7783 = gc_frame_newslot(call7787);
  params[0] = strlit7784;
  partcv[0] = 1;
  Object opresult7788 = callmethod(call7787, "==", 1, partcv, params);
// compiled op node returning opresult7788 (depth = 6)
  int op_slot_left_7774 = gc_frame_newslot(opresult7788);
  params[0] = opresult7781;
  partcv[0] = 1;
  Object opresult7789 = callmethod(opresult7788, "&&", 1, partcv, params);
// compiled op node returning opresult7789 (depth = 5)
  Object if7773 = done;
  if (istrue(opresult7789)) {
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7790 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit7792 == NULL) {
    strlit7792 = alloc_String("""\x22""");
    gc_root(strlit7792);
  }
// compiled string node returning strlit7792 (depth = 7)
  int op_slot_right_7791 = gc_frame_newslot(strlit7792);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7795 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call7796 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7795);
// compiled call node returning call7796 (depth = 9)
// compiled member node returning call7796 (depth = 8)
  int op_slot_right_7794 = gc_frame_newslot(call7796);
// starting to compile string node (depth = 8)
  if (strlit7798 == NULL) {
    strlit7798 = alloc_String("""\x22""");
    gc_root(strlit7798);
  }
// compiled string node returning strlit7798 (depth = 8)
  int op_slot_left_7794 = gc_frame_newslot(strlit7798);
  params[0] = call7796;
  partcv[0] = 1;
  Object opresult7799 = callmethod(strlit7798, "++", 1, partcv, params);
// compiled op node returning opresult7799 (depth = 7)
  int op_slot_left_7791 = gc_frame_newslot(opresult7799);
  params[0] = strlit7792;
  partcv[0] = 1;
  Object opresult7800 = callmethod(opresult7799, "++", 1, partcv, params);
// compiled op node returning opresult7800 (depth = 6)
  gc_frame_newslot(opresult7800);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult7800;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7801 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7790);
// compiled call node returning call7801 (depth = 5)
// Begin line 2451
  setline(2451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7802 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call7803 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7802);
// compiled call node returning call7803 (depth = 7)
// compiled member node returning call7803 (depth = 6)
  *var_errorPos = call7803;
  if (call7803 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7773 = done;
  } else {
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7805 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7806 == NULL) {
    strlit7806 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7806);
  }
// compiled string node returning strlit7806 (depth = 6)
  gc_frame_newslot(strlit7806);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7806;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7807 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7805);
// compiled call node returning call7807 (depth = 5)
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num7809 = alloc_Float64(1);
// compiled num node returning num7809 (depth = 7)
  int op_slot_right_7808 = gc_frame_newslot(num7809);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7812 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7813 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7812);
// compiled call node returning call7813 (depth = 9)
// compiled member node returning call7813 (depth = 8)
  int op_slot_right_7811 = gc_frame_newslot(call7813);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7815 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call7816 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7815);
// compiled call node returning call7816 (depth = 9)
// compiled member node returning call7816 (depth = 8)
  int op_slot_left_7811 = gc_frame_newslot(call7816);
  params[0] = call7813;
  partcv[0] = 1;
  Object sum7817 = callmethod(call7816, "+", 1, partcv, params);
// compiled op node returning sum7817 (depth = 7)
  int op_slot_left_7808 = gc_frame_newslot(sum7817);
  params[0] = num7809;
  partcv[0] = 1;
  Object sum7818 = callmethod(sum7817, "+", 1, partcv, params);
// compiled op node returning sum7818 (depth = 6)
  *var_errorPos = sum7818;
  if (sum7818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if7773 = done;
  }
// compiled if node returning if7773 (depth = 4)
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7820 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7821 == NULL) {
    strlit7821 = alloc_String("A dialect statement must have the name of the dialect in quotes after the 'dialect'.");
    gc_root(strlit7821);
  }
// compiled string node returning strlit7821 (depth = 5)
  gc_frame_newslot(strlit7821);
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7823 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7822);
// compiled call node returning call7823 (depth = 6)
// compiled member node returning call7823 (depth = 5)
  gc_frame_newslot(call7823);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2455
  setline(2455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7821;
  params[1] = call7823;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7824 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7820);
// compiled call node returning call7824 (depth = 4)
    gc_frame_newslot(call7824);
    if7762 = call7824;
  } else {
  }
// compiled if node returning if7762 (depth = 3)
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7825 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe7826 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7827 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7828 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7827);
// compiled call node returning call7828 (depth = 6)
// compiled member node returning call7828 (depth = 5)
  gc_frame_newslot(call7828);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7829 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7830 = callmethod(*var_ast, "dialectNode",
    1, partcv, params);
  gc_frame_end(callframe7829);
// compiled call node returning call7830 (depth = 6)
// compiled member node returning call7830 (depth = 5)
  params[0] = call7828;
  partcv[0] = 1;
  Object call7831 = callmethod(call7830, "new",
    1, partcv, params);
  gc_frame_end(callframe7826);
// compiled call node returning call7831 (depth = 4)
  gc_frame_newslot(call7831);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = call7831;
  partcv[0] = 1;
  Object call7832 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7825);
// compiled call node returning call7832 (depth = 3)
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7833 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7834 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7833);
// compiled call node returning call7834 (depth = 4)
// compiled member node returning call7834 (depth = 3)
    gc_frame_newslot(call7834);
    if7747 = call7834;
  } else {
  }
// compiled if node returning if7747 (depth = 2)
  gc_frame_end(frame);
  return if7747;
}
Object meth_parser__apply7857(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe7858 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_noBlocks (depth = 9)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call7859 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7858);
// compiled call node returning call7859 (depth = 8)
  gc_frame_end(frame);
  return call7859;
}
Object meth_parser_inheritsdec7835(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_noBlocks = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsdec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for inheritsdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_inhNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "inhNode");
// Begin line 2489
  setline(2489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2465
  setline(2465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7839 == NULL) {
    strlit7839 = alloc_String("inherits");
    gc_root(strlit7839);
  }
// compiled string node returning strlit7839 (depth = 5)
  int op_slot_right_7838 = gc_frame_newslot(strlit7839);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7841 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7842 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7841);
// compiled call node returning call7842 (depth = 6)
// compiled member node returning call7842 (depth = 5)
  int op_slot_left_7838 = gc_frame_newslot(call7842);
  params[0] = strlit7839;
  partcv[0] = 1;
  Object opresult7843 = callmethod(call7842, "==", 1, partcv, params);
// compiled op node returning opresult7843 (depth = 4)
  int op_slot_right_7837 = gc_frame_newslot(opresult7843);
// starting to compile call node (depth = 4)
  int callframe7845 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7846 == NULL) {
    strlit7846 = alloc_String("keyword");
    gc_root(strlit7846);
  }
// compiled string node returning strlit7846 (depth = 5)
  gc_frame_newslot(strlit7846);
// call case 4: self request
  params[0] = strlit7846;
  partcv[0] = 1;
  Object call7847 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7845);
// compiled call node returning call7847 (depth = 4)
  int op_slot_left_7837 = gc_frame_newslot(call7847);
  params[0] = opresult7843;
  partcv[0] = 1;
  Object opresult7848 = callmethod(call7847, "&&", 1, partcv, params);
// compiled op node returning opresult7848 (depth = 3)
  Object if7836 = done;
  if (istrue(opresult7848)) {
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2467
  setline(2467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7849 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7850 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7849);
// compiled call node returning call7850 (depth = 4)
// compiled member node returning call7850 (depth = 3)
// Begin line 2468
  setline(2468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7851 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7852 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7851);
// compiled call node returning call7852 (depth = 4)
// compiled member node returning call7852 (depth = 3)
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7854 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe7855 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block7856 = alloc_Block(NULL, NULL, "parser", 2469);
  gc_frame_newslot(block7856);
// method _apply
  block_savedest(block7856);
  Object closure7857 = createclosure(2, "_apply");
  setclosureframe(closure7857, stackframe);
  addtoclosure(closure7857, var_noBlocks);
  addtoclosure(closure7857, selfslot);
  struct UserObject *uo7857 = (struct UserObject*)block7856;
  uo7857->data[0] = (Object)closure7857;
  Method *meth_meth_parser__apply7857 = addmethod2pos(block7856, "_apply", &meth_parser__apply7857, 0);
  int argcv_meth_parser__apply7857[] = {0};
  meth_meth_parser__apply7857->type = alloc_MethodType(1, argcv_meth_parser__apply7857);
  meth_meth_parser__apply7857->definitionModule = modulename;
  meth_meth_parser__apply7857->definitionLine = 2469;
// compiled block node returning block7856 (depth = 7)
  gc_frame_newslot(block7856);
// call case 4: self request
  params[0] = block7856;
  partcv[0] = 1;
  Object call7861 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7855);
// compiled call node returning call7861 (depth = 6)
  partcv[0] = 0;
  Object call7862 = callmethod(call7861, "not",
    1, partcv, params);
  gc_frame_end(callframe7854);
// compiled call node returning call7862 (depth = 5)
// compiled member node returning call7862 (depth = 4)
  Object if7853 = done;
  if (istrue(call7862)) {
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array7863 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array7863 (depth = 5)
  *var_suggestions = array7863;
  if (array7863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7864 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7865 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7866 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7865);
// compiled call node returning call7866 (depth = 8)
// compiled member node returning call7866 (depth = 7)
  partcv[0] = 0;
  Object call7867 = callmethod(call7866, "new",
    1, partcv, params);
  gc_frame_end(callframe7864);
// compiled call node returning call7867 (depth = 6)
// compiled member node returning call7867 (depth = 5)
  *var_suggestion = call7867;
  if (call7867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7868 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7869 == NULL) {
    strlit7869 = alloc_String("rsquare");
    gc_root(strlit7869);
  }
// compiled string node returning strlit7869 (depth = 6)
  gc_frame_newslot(strlit7869);
// call case 4: self request
  params[0] = strlit7869;
  partcv[0] = 1;
  Object call7870 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7868);
// compiled call node returning call7870 (depth = 5)
  *var_nextTok = call7870;
  if (call7870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_7872 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_7872 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7874 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7874 (depth = 5)
  Object if7871 = done;
  if (istrue(opresult7874)) {
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7875 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7876 == NULL) {
    strlit7876 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7876);
  }
// compiled string node returning strlit7876 (depth = 6)
  gc_frame_newslot(strlit7876);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7876;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7877 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7875);
// compiled call node returning call7877 (depth = 5)
    gc_frame_newslot(call7877);
    if7871 = call7877;
  } else {
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7878 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call7880 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7879);
// compiled call node returning call7880 (depth = 7)
// compiled member node returning call7880 (depth = 6)
  gc_frame_newslot(call7880);
// starting to compile identifier node (depth = 6)
  Object bool7881 = alloc_Boolean(1);
// compiled identifier node returning bool7881 (depth = 6)
  gc_frame_newslot(bool7881);
// starting to compile identifier node (depth = 6)
  Object bool7882 = alloc_Boolean(0);
// compiled identifier node returning bool7882 (depth = 6)
  gc_frame_newslot(bool7882);
// starting to compile string node (depth = 6)
  if (strlit7883 == NULL) {
    strlit7883 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit7883);
  }
// compiled string node returning strlit7883 (depth = 6)
  gc_frame_newslot(strlit7883);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call7880;
  params[2] = bool7881;
  params[3] = bool7882;
  params[4] = strlit7883;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7884 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7878);
// compiled call node returning call7884 (depth = 5)
    gc_frame_newslot(call7884);
    if7871 = call7884;
  }
// compiled if node returning if7871 (depth = 4)
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7885 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7886 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7885);
// compiled call node returning call7886 (depth = 4)
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7887 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7889 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7888);
// compiled call node returning call7889 (depth = 8)
// compiled member node returning call7889 (depth = 7)
  partcv[0] = 0;
  Object call7890 = callmethod(call7889, "new",
    1, partcv, params);
  gc_frame_end(callframe7887);
// compiled call node returning call7890 (depth = 6)
// compiled member node returning call7890 (depth = 5)
  *var_suggestion = call7890;
  if (call7890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7892 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7893 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  partcv[0] = 0;
  Object call7894 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7893);
// compiled call node returning call7894 (depth = 6)
// compiled member node returning call7894 (depth = 5)
  gc_frame_newslot(call7894);
// starting to compile identifier node (depth = 5)
  Object bool7895 = alloc_Boolean(1);
// compiled identifier node returning bool7895 (depth = 5)
  gc_frame_newslot(bool7895);
// starting to compile identifier node (depth = 5)
  Object bool7896 = alloc_Boolean(0);
// compiled identifier node returning bool7896 (depth = 5)
  gc_frame_newslot(bool7896);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_lastToken;
  params[1] = call7894;
  params[2] = bool7895;
  params[3] = bool7896;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7897 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7892);
// compiled call node returning call7897 (depth = 4)
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7898 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7899 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7898);
// compiled call node returning call7899 (depth = 4)
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7900 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7901 == NULL) {
    strlit7901 = alloc_String("The inherits keyword must be followed by an expression that creates the object being inherited.");
    gc_root(strlit7901);
  }
// compiled string node returning strlit7901 (depth = 5)
  gc_frame_newslot(strlit7901);
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7902 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7903 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7902);
// compiled call node returning call7903 (depth = 6)
// compiled member node returning call7903 (depth = 5)
  gc_frame_newslot(call7903);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num7905 = alloc_Float64(1);
// compiled num node returning num7905 (depth = 6)
  int op_slot_right_7904 = gc_frame_newslot(num7905);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7908 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7909 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7908);
// compiled call node returning call7909 (depth = 8)
// compiled member node returning call7909 (depth = 7)
  int op_slot_right_7907 = gc_frame_newslot(call7909);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7911 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call7912 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7911);
// compiled call node returning call7912 (depth = 8)
// compiled member node returning call7912 (depth = 7)
  int op_slot_left_7907 = gc_frame_newslot(call7912);
  params[0] = call7909;
  partcv[0] = 1;
  Object sum7913 = callmethod(call7912, "+", 1, partcv, params);
// compiled op node returning sum7913 (depth = 6)
  int op_slot_left_7904 = gc_frame_newslot(sum7913);
  params[0] = num7905;
  partcv[0] = 1;
  Object sum7914 = callmethod(sum7913, "+", 1, partcv, params);
// compiled op node returning sum7914 (depth = 5)
  gc_frame_newslot(sum7914);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7901;
  params[1] = call7903;
  params[2] = sum7914;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7915 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7900);
// compiled call node returning call7915 (depth = 4)
    gc_frame_newslot(call7915);
    if7853 = call7915;
  } else {
  }
// compiled if node returning if7853 (depth = 3)
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7916 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7917 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call7918 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe7917);
// compiled call node returning call7918 (depth = 5)
// compiled member node returning call7918 (depth = 4)
  gc_frame_newslot(call7918);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call7920 = callmethod(*var_btok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7919);
// compiled call node returning call7920 (depth = 5)
// compiled member node returning call7920 (depth = 4)
  gc_frame_newslot(call7920);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call7918;
  params[1] = call7920;
  partcv[0] = 2;
  Object call7921 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe7916);
// compiled call node returning call7921 (depth = 3)
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7922 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7923 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call7924 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7923);
// compiled call node returning call7924 (depth = 6)
// compiled member node returning call7924 (depth = 5)
  gc_frame_newslot(call7924);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call7926 = callmethod(*var_ast, "inheritsNode",
    1, partcv, params);
  gc_frame_end(callframe7925);
// compiled call node returning call7926 (depth = 6)
// compiled member node returning call7926 (depth = 5)
  params[0] = call7924;
  partcv[0] = 1;
  Object call7927 = callmethod(call7926, "new",
    1, partcv, params);
  gc_frame_end(callframe7922);
// compiled call node returning call7927 (depth = 4)
  *var_inhNode = call7927;
  if (call7927 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2487
  setline(2487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7928 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inhNode (depth = 4)
  gc_frame_newslot(*var_inhNode);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_inhNode;
  partcv[0] = 1;
  Object call7929 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7928);
// compiled call node returning call7929 (depth = 3)
    gc_frame_newslot(call7929);
    if7836 = call7929;
  } else {
  }
// compiled if node returning if7836 (depth = 2)
  gc_frame_end(frame);
  return if7836;
}
Object meth_parser__apply7959(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit7961 == NULL) {
    strlit7961 = alloc_String("rbrace");
    gc_root(strlit7961);
  }
// compiled string node returning strlit7961 (depth = 8)
  int op_slot_right_7960 = gc_frame_newslot(strlit7961);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe7963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call7964 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7963);
// compiled call node returning call7964 (depth = 9)
// compiled member node returning call7964 (depth = 8)
  int op_slot_left_7960 = gc_frame_newslot(call7964);
  params[0] = strlit7961;
  partcv[0] = 1;
  Object opresult7965 = callmethod(call7964, "==", 1, partcv, params);
// compiled op node returning opresult7965 (depth = 7)
  gc_frame_end(frame);
  return opresult7965;
}
Object meth_parser__apply8027(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8028 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8029 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8030 == NULL) {
    strlit8030 = alloc_String("rbrace");
    gc_root(strlit8030);
  }
// compiled string node returning strlit8030 (depth = 8)
  gc_frame_newslot(strlit8030);
// call case 4: self request
  params[0] = strlit8030;
  partcv[0] = 1;
  Object call8031 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8029);
// compiled call node returning call8031 (depth = 7)
  partcv[0] = 0;
  Object call8032 = callmethod(call8031, "not",
    1, partcv, params);
  gc_frame_end(callframe8028);
// compiled call node returning call8032 (depth = 6)
// compiled member node returning call8032 (depth = 5)
  gc_frame_end(frame);
  return call8032;
}
Object meth_parser__apply8035(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sz = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8036 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8037 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8036);
// compiled call node returning call8037 (depth = 6)
// compiled member node returning call8037 (depth = 5)
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8038 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8039 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8038);
// compiled call node returning call8039 (depth = 6)
// compiled member node returning call8039 (depth = 5)
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8040 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8041 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8040);
// compiled call node returning call8041 (depth = 6)
// compiled member node returning call8041 (depth = 5)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8044 == NULL) {
    strlit8044 = alloc_String("eof");
    gc_root(strlit8044);
  }
// compiled string node returning strlit8044 (depth = 7)
  int op_slot_right_8043 = gc_frame_newslot(strlit8044);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8046 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8047 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8046);
// compiled call node returning call8047 (depth = 8)
// compiled member node returning call8047 (depth = 7)
  int op_slot_left_8043 = gc_frame_newslot(call8047);
  params[0] = strlit8044;
  partcv[0] = 1;
  Object opresult8048 = callmethod(call8047, "==", 1, partcv, params);
// compiled op node returning opresult8048 (depth = 6)
  Object if8042 = done;
  if (istrue(opresult8048)) {
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8051 == NULL) {
    strlit8051 = alloc_String("rbrace");
    gc_root(strlit8051);
  }
// compiled string node returning strlit8051 (depth = 8)
  int op_slot_right_8050 = gc_frame_newslot(strlit8051);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8053 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8054 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8053);
// compiled call node returning call8054 (depth = 9)
// compiled member node returning call8054 (depth = 8)
  int op_slot_left_8050 = gc_frame_newslot(call8054);
  params[0] = strlit8051;
  partcv[0] = 1;
  Object opresult8055 = callmethod(call8054, "!=", 1, partcv, params);
// compiled op node returning opresult8055 (depth = 7)
  Object if8049 = done;
  if (istrue(opresult8055)) {
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 2529
  setline(2529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8056 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8057 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call8058 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8057);
// compiled call node returning call8058 (depth = 11)
// compiled member node returning call8058 (depth = 10)
  partcv[0] = 0;
  Object call8059 = callmethod(call8058, "new",
    1, partcv, params);
  gc_frame_end(callframe8056);
// compiled call node returning call8059 (depth = 9)
// compiled member node returning call8059 (depth = 8)
  *var_suggestion = call8059;
  if (call8059 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8060 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8061 == NULL) {
    strlit8061 = alloc_String("}");
    gc_root(strlit8061);
  }
// compiled string node returning strlit8061 (depth = 8)
  gc_frame_newslot(strlit8061);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8061;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8062 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8060);
// compiled call node returning call8062 (depth = 7)
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8063 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8064 == NULL) {
    strlit8064 = alloc_String("An object literal must end with a '}'.");
    gc_root(strlit8064);
  }
// compiled string node returning strlit8064 (depth = 8)
  gc_frame_newslot(strlit8064);
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call8066 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8065);
// compiled call node returning call8066 (depth = 9)
// compiled member node returning call8066 (depth = 8)
  gc_frame_newslot(call8066);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8069 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8068);
// compiled call node returning call8069 (depth = 10)
// compiled member node returning call8069 (depth = 9)
  int op_slot_right_8067 = gc_frame_newslot(call8069);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8071 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8072 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8071);
// compiled call node returning call8072 (depth = 10)
// compiled member node returning call8072 (depth = 9)
  int op_slot_left_8067 = gc_frame_newslot(call8072);
  params[0] = call8069;
  partcv[0] = 1;
  Object sum8073 = callmethod(call8072, "+", 1, partcv, params);
// compiled op node returning sum8073 (depth = 8)
  gc_frame_newslot(sum8073);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2531
  setline(2531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit8064;
  params[1] = call8066;
  params[2] = sum8073;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8074 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8063);
// compiled call node returning call8074 (depth = 7)
    gc_frame_newslot(call8074);
    if8049 = call8074;
  } else {
  }
// compiled if node returning if8049 (depth = 6)
    gc_frame_newslot(if8049);
    if8042 = if8049;
  } else {
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2534
  setline(2534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit8078 == NULL) {
    strlit8078 = alloc_String("semicolon");
    gc_root(strlit8078);
  }
// compiled string node returning strlit8078 (depth = 9)
  int op_slot_right_8077 = gc_frame_newslot(strlit8078);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8081 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe8080);
// compiled call node returning call8081 (depth = 10)
// compiled member node returning call8081 (depth = 9)
  int op_slot_left_8077 = gc_frame_newslot(call8081);
  params[0] = strlit8078;
  partcv[0] = 1;
  Object opresult8082 = callmethod(call8081, "!=", 1, partcv, params);
// compiled op node returning opresult8082 (depth = 8)
  int op_slot_right_8076 = gc_frame_newslot(opresult8082);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sz (depth = 9)
  int op_slot_right_8084 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call8087 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8086);
// compiled call node returning call8087 (depth = 10)
// compiled member node returning call8087 (depth = 9)
  int op_slot_left_8084 = gc_frame_newslot(call8087);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult8088 = callmethod(call8087, "==", 1, partcv, params);
// compiled op node returning opresult8088 (depth = 8)
  int op_slot_left_8076 = gc_frame_newslot(opresult8088);
  params[0] = opresult8082;
  partcv[0] = 1;
  Object opresult8089 = callmethod(opresult8088, "&&", 1, partcv, params);
// compiled op node returning opresult8089 (depth = 7)
  Object if8075 = done;
  if (istrue(opresult8089)) {
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8090 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8091 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call8092 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8091);
// compiled call node returning call8092 (depth = 11)
// compiled member node returning call8092 (depth = 10)
  partcv[0] = 0;
  Object call8093 = callmethod(call8092, "new",
    1, partcv, params);
  gc_frame_end(callframe8090);
// compiled call node returning call8093 (depth = 9)
// compiled member node returning call8093 (depth = 8)
  *var_suggestion = call8093;
  if (call8093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8094 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8095 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8094);
// compiled call node returning call8095 (depth = 7)
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8096 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8097 == NULL) {
    strlit8097 = alloc_String("An object literal can contain only definitions, variable and method declarations, and statements.");
    gc_root(strlit8097);
  }
// compiled string node returning strlit8097 (depth = 8)
  gc_frame_newslot(strlit8097);
// Begin line 2538
  setline(2538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8098 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8099 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8098);
// compiled call node returning call8099 (depth = 9)
// compiled member node returning call8099 (depth = 8)
  gc_frame_newslot(call8099);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8100 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8101 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8100);
// compiled call node returning call8101 (depth = 9)
// compiled member node returning call8101 (depth = 8)
  gc_frame_newslot(call8101);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8103 = alloc_Float64(1);
// compiled num node returning num8103 (depth = 9)
  int op_slot_right_8102 = gc_frame_newslot(num8103);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8106 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call8107 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe8106);
// compiled call node returning call8107 (depth = 11)
// compiled member node returning call8107 (depth = 10)
  int op_slot_right_8105 = gc_frame_newslot(call8107);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8109 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call8110 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8109);
// compiled call node returning call8110 (depth = 11)
// compiled member node returning call8110 (depth = 10)
  int op_slot_left_8105 = gc_frame_newslot(call8110);
  params[0] = call8107;
  partcv[0] = 1;
  Object sum8111 = callmethod(call8110, "+", 1, partcv, params);
// compiled op node returning sum8111 (depth = 9)
  int op_slot_left_8102 = gc_frame_newslot(sum8111);
  params[0] = num8103;
  partcv[0] = 1;
  Object diff8112 = callmethod(sum8111, "-", 1, partcv, params);
// compiled op node returning diff8112 (depth = 8)
  gc_frame_newslot(diff8112);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit8097;
  params[1] = call8099;
  params[2] = call8101;
  params[3] = diff8112;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8113 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8096);
// compiled call node returning call8113 (depth = 7)
    gc_frame_newslot(call8113);
    if8075 = call8113;
  } else {
  }
// compiled if node returning if8075 (depth = 6)
    gc_frame_newslot(if8075);
    if8042 = if8075;
  }
// compiled if node returning if8042 (depth = 5)
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8114 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8115 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8114);
// compiled call node returning call8115 (depth = 7)
// compiled member node returning call8115 (depth = 6)
  *var_sz = call8115;
  if (call8115 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8126(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8128 == NULL) {
    strlit8128 = alloc_String("lbrace");
    gc_root(strlit8128);
  }
// compiled string node returning strlit8128 (depth = 6)
  int op_slot_right_8127 = gc_frame_newslot(strlit8128);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  partcv[0] = 0;
  Object call8131 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe8130);
// compiled call node returning call8131 (depth = 7)
// compiled member node returning call8131 (depth = 6)
  int op_slot_left_8127 = gc_frame_newslot(call8131);
  params[0] = strlit8128;
  partcv[0] = 1;
  Object opresult8132 = callmethod(call8131, "!=", 1, partcv, params);
// compiled op node returning opresult8132 (depth = 5)
  gc_frame_end(frame);
  return opresult8132;
}
Object meth_parser__apply8135(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_rbody = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8136 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rbody (depth = 6)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8137 = callmethod(*var_rbody, "push",
    1, partcv, params);
  gc_frame_end(callframe8136);
// compiled call node returning call8137 (depth = 5)
// Begin line 2548
  setline(2548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2547
  setline(2547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8139 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8138);
// compiled call node returning call8139 (depth = 7)
// compiled member node returning call8139 (depth = 6)
  *var_n = call8139;
  if (call8139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8148(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_rbody = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8149 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_rbody (depth = 8)
  partcv[0] = 0;
  Object call8150 = callmethod(*var_rbody, "pop",
    1, partcv, params);
  gc_frame_end(callframe8149);
// compiled call node returning call8150 (depth = 7)
// compiled member node returning call8150 (depth = 6)
  *var_p = call8150;
  if (call8150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8151 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_p (depth = 6)
  gc_frame_newslot(*var_p);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  params[0] = *var_p;
  partcv[0] = 1;
  Object call8152 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8151);
// compiled call node returning call8152 (depth = 5)
  gc_frame_end(frame);
  return call8152;
}
Object meth_parser_doobject7930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_statementToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doobject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doobject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_sz = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "sz");
  Object *var_rbody = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rbody");
  Object *var_n = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "n");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_o = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "o");
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7934 == NULL) {
    strlit7934 = alloc_String("object");
    gc_root(strlit7934);
  }
// compiled string node returning strlit7934 (depth = 5)
  int op_slot_right_7933 = gc_frame_newslot(strlit7934);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7937 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7936);
// compiled call node returning call7937 (depth = 6)
// compiled member node returning call7937 (depth = 5)
  int op_slot_left_7933 = gc_frame_newslot(call7937);
  params[0] = strlit7934;
  partcv[0] = 1;
  Object opresult7938 = callmethod(call7937, "==", 1, partcv, params);
// compiled op node returning opresult7938 (depth = 4)
  int op_slot_right_7932 = gc_frame_newslot(opresult7938);
// starting to compile call node (depth = 4)
  int callframe7940 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7941 == NULL) {
    strlit7941 = alloc_String("keyword");
    gc_root(strlit7941);
  }
// compiled string node returning strlit7941 (depth = 5)
  gc_frame_newslot(strlit7941);
// call case 4: self request
  params[0] = strlit7941;
  partcv[0] = 1;
  Object call7942 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7940);
// compiled call node returning call7942 (depth = 4)
  int op_slot_left_7932 = gc_frame_newslot(call7942);
  params[0] = opresult7938;
  partcv[0] = 1;
  Object opresult7943 = callmethod(call7942, "&&", 1, partcv, params);
// compiled op node returning opresult7943 (depth = 3)
  Object if7931 = done;
  if (istrue(opresult7943)) {
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call7945 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7944);
// compiled call node returning call7945 (depth = 4)
// compiled member node returning call7945 (depth = 3)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit7948 == NULL) {
    strlit7948 = alloc_String("lbrace");
    gc_root(strlit7948);
  }
// compiled string node returning strlit7948 (depth = 5)
  int op_slot_right_7947 = gc_frame_newslot(strlit7948);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call7951 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7950);
// compiled call node returning call7951 (depth = 6)
// compiled member node returning call7951 (depth = 5)
  int op_slot_left_7947 = gc_frame_newslot(call7951);
  params[0] = strlit7948;
  partcv[0] = 1;
  Object opresult7952 = callmethod(call7951, "!=", 1, partcv, params);
// compiled op node returning opresult7952 (depth = 4)
  Object if7946 = done;
  if (istrue(opresult7952)) {
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7953 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe7954 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call7955 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7954);
// compiled call node returning call7955 (depth = 8)
// compiled member node returning call7955 (depth = 7)
  partcv[0] = 0;
  Object call7956 = callmethod(call7955, "new",
    1, partcv, params);
  gc_frame_end(callframe7953);
// compiled call node returning call7956 (depth = 6)
// compiled member node returning call7956 (depth = 5)
  *var_suggestion = call7956;
  if (call7956 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe7957 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block7958 = alloc_Block(NULL, NULL, "parser", 2500);
  gc_frame_newslot(block7958);
// method _apply
  block_savedest(block7958);
  Object closure7959 = createclosure(1, "_apply");
  setclosureframe(closure7959, stackframe);
  addtoclosure(closure7959, selfslot);
  struct UserObject *uo7959 = (struct UserObject*)block7958;
  uo7959->data[0] = (Object)closure7959;
  Method *meth_meth_parser__apply7959 = addmethod2pos(block7958, "_apply", &meth_parser__apply7959, 0);
  int argcv_meth_parser__apply7959[] = {1};
  meth_meth_parser__apply7959->type = alloc_MethodType(1, argcv_meth_parser__apply7959);
  meth_meth_parser__apply7959->definitionModule = modulename;
  meth_meth_parser__apply7959->definitionLine = 2499;
// compiled block node returning block7958 (depth = 6)
  gc_frame_newslot(block7958);
// call case 4: self request
  params[0] = block7958;
  partcv[0] = 1;
  Object call7967 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7957);
// compiled call node returning call7967 (depth = 5)
  *var_nextTok = call7967;
  if (call7967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2501
  setline(2501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool7970 = alloc_Boolean(0);
// compiled identifier node returning bool7970 (depth = 6)
  int op_slot_right_7969 = gc_frame_newslot(bool7970);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_7969 = gc_frame_newslot(*var_nextTok);
  params[0] = bool7970;
  partcv[0] = 1;
  Object opresult7972 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult7972 (depth = 5)
  Object if7968 = done;
  if (istrue(opresult7972)) {
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7973 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7974 == NULL) {
    strlit7974 = alloc_String(" {}");
    gc_root(strlit7974);
  }
// compiled string node returning strlit7974 (depth = 6)
  gc_frame_newslot(strlit7974);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7974;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7975 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7973);
// compiled call node returning call7975 (depth = 5)
    gc_frame_newslot(call7975);
    if7968 = call7975;
  } else {
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe7976 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit7977 == NULL) {
    strlit7977 = alloc_String(" {");
    gc_root(strlit7977);
  }
// compiled string node returning strlit7977 (depth = 6)
  gc_frame_newslot(strlit7977);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit7977;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7978 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7976);
// compiled call node returning call7978 (depth = 5)
    gc_frame_newslot(call7978);
    if7968 = call7978;
  }
// compiled if node returning if7968 (depth = 4)
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe7979 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit7980 == NULL) {
    strlit7980 = alloc_String("An object literal must have a '{' after the 'object'.");
    gc_root(strlit7980);
  }
// compiled string node returning strlit7980 (depth = 5)
  gc_frame_newslot(strlit7980);
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe7981 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call7982 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7981);
// compiled call node returning call7982 (depth = 6)
// compiled member node returning call7982 (depth = 5)
  gc_frame_newslot(call7982);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7984 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7985 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7984);
// compiled call node returning call7985 (depth = 7)
// compiled member node returning call7985 (depth = 6)
  int op_slot_right_7983 = gc_frame_newslot(call7985);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe7987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call7988 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7987);
// compiled call node returning call7988 (depth = 7)
// compiled member node returning call7988 (depth = 6)
  int op_slot_left_7983 = gc_frame_newslot(call7988);
  params[0] = call7985;
  partcv[0] = 1;
  Object sum7989 = callmethod(call7988, "+", 1, partcv, params);
// compiled op node returning sum7989 (depth = 5)
  gc_frame_newslot(sum7989);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit7980;
  params[1] = call7982;
  params[2] = sum7989;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7990 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7979);
// compiled call node returning call7990 (depth = 4)
    gc_frame_newslot(call7990);
    if7946 = call7990;
  } else {
  }
// compiled if node returning if7946 (depth = 3)
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe7991 = gc_frame_new();
// starting to compile object node (depth = 4)
  Object inheritingObject7992 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7992 = alloc_userobj2(4,4, objclass7992);
  gc_frame_newslot(obj7992);
// OBJECT OUTER DEC outer
  adddatum2(obj7992, self, 0);
  addmethodreal(obj7992,"outer", &reader_parser_outer_7993);
  Object oldself7992 = self;
  struct StackFrameObject *oldstackframe7992 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7992);
  gc_frame_newslot((Object)stackframe);
  self = obj7992;
  Object *oldselfslot7992 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7992 = (*(struct UserObject *)self).data[0], lowerouter7992 = thisouter7992;
  if (inheritingObject7992) {
    struct UserObject *inho7992 = (struct UserObject *)inheritingObject7992;
    while (inho7992->super != GraceDefaultObject) inho7992 = (struct UserObject *)inho7992->super;
    inho7992->super = obj7992;
    self = inheritingObject7992;
    *selfslot = self;
    lowerouter7992 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7992;
  }
if (objclass7992 == NULL) {
  Method *reader7994 = addmethodrealflags(obj7992, "kind",&reader_parser_kind_7994, 0);
  Method *writer7994 = addmethodrealflags(obj7992, "kind:=",&writer_parser_kind_7994, 0);
  reader7994->definitionModule = modulename;
  writer7994->definitionModule = modulename;
  reader7994->definitionLine = 2511;
  writer7994->definitionLine = 2511;
}
obj7992->flags |= OFLAG_MUTABLE;
adddatum2(obj7992, alloc_Undefined(), 1);
if (objclass7992 == NULL) {
  Method *reader7995 = addmethodrealflags(obj7992, "register",&reader_parser_register_7995, 0);
  Method *writer7995 = addmethodrealflags(obj7992, "register:=",&writer_parser_register_7995, 0);
  reader7995->definitionModule = modulename;
  writer7995->definitionModule = modulename;
  reader7995->definitionLine = 2512;
  writer7995->definitionLine = 2512;
}
obj7992->flags |= OFLAG_MUTABLE;
adddatum2(obj7992, alloc_Undefined(), 2);
  sourceObject = obj7992;
// Begin line 2510
  setline(2510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7996 == NULL) {
    strlit7996 = alloc_String("lbrace");
    gc_root(strlit7996);
  }
// compiled string node returning strlit7996 (depth = 5)
  adddatum2(obj7992, strlit7996, 1);
  sourceObject = obj7992;
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit7997 == NULL) {
    strlit7997 = alloc_String("");
    gc_root(strlit7997);
  }
// compiled string node returning strlit7997 (depth = 5)
  adddatum2(obj7992, strlit7997, 2);
objclass7992 = obj7992->class;
  objclass7992->definitionModule = modulename;
  objclass7992->definitionLine = 2509;
  (*(struct UserObject *)self).data[0] = lowerouter7992;
  self = oldself7992;
  selfslot = oldselfslot7992;
  stackframe = oldstackframe7992;
// compiled object node returning obj7992 (depth = 4)
  gc_frame_newslot(obj7992);
// call case 6: other member request
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = obj7992;
  partcv[0] = 1;
  Object call7998 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7991);
// compiled call node returning call7998 (depth = 3)
// Begin line 2513
  setline(2513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe7999 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8000 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7999);
// compiled call node returning call8000 (depth = 4)
// compiled member node returning call8000 (depth = 3)
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8003 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call8004 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8003);
// compiled call node returning call8004 (depth = 6)
// compiled member node returning call8004 (depth = 5)
  int op_slot_right_8002 = gc_frame_newslot(call8004);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8006 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8007 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8006);
// compiled call node returning call8007 (depth = 6)
// compiled member node returning call8007 (depth = 5)
  int op_slot_left_8002 = gc_frame_newslot(call8007);
  params[0] = call8004;
  partcv[0] = 1;
  Object opresult8008 = callmethod(call8007, "==", 1, partcv, params);
// compiled op node returning opresult8008 (depth = 4)
  Object if8001 = done;
  if (istrue(opresult8008)) {
// Begin line 2516
  setline(2516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2515
  setline(2515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num8010 = alloc_Float64(1);
// compiled num node returning num8010 (depth = 6)
  int op_slot_right_8009 = gc_frame_newslot(num8010);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8012 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8013 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8012);
// compiled call node returning call8013 (depth = 7)
// compiled member node returning call8013 (depth = 6)
  int op_slot_left_8009 = gc_frame_newslot(call8013);
  params[0] = num8010;
  partcv[0] = 1;
  Object diff8014 = callmethod(call8013, "-", 1, partcv, params);
// compiled op node returning diff8014 (depth = 5)
  *var_minIndentLevel = diff8014;
  if (diff8014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8001 = done;
  } else {
// Begin line 2518
  setline(2518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num8017 = alloc_Float64(1);
// compiled num node returning num8017 (depth = 6)
  int op_slot_right_8016 = gc_frame_newslot(num8017);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  partcv[0] = 0;
  Object call8020 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8019);
// compiled call node returning call8020 (depth = 7)
// compiled member node returning call8020 (depth = 6)
  int op_slot_left_8016 = gc_frame_newslot(call8020);
  params[0] = num8017;
  partcv[0] = 1;
  Object sum8021 = callmethod(call8020, "+", 1, partcv, params);
// compiled op node returning sum8021 (depth = 5)
  *var_minIndentLevel = sum8021;
  if (sum8021 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8001 = done;
  }
// compiled if node returning if8001 (depth = 3)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8024 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8023);
// compiled call node returning call8024 (depth = 5)
// compiled member node returning call8024 (depth = 4)
  *var_sz = call8024;
  if (call8024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8025 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8026 = alloc_Block(NULL, NULL, "parser", 2520);
  gc_frame_newslot(block8026);
// method _apply
  block_savedest(block8026);
  Object closure8027 = createclosure(1, "_apply");
  setclosureframe(closure8027, stackframe);
  addtoclosure(closure8027, selfslot);
  struct UserObject *uo8027 = (struct UserObject*)block8026;
  uo8027->data[0] = (Object)closure8027;
  Method *meth_meth_parser__apply8027 = addmethod2pos(block8026, "_apply", &meth_parser__apply8027, 0);
  int argcv_meth_parser__apply8027[] = {0};
  meth_meth_parser__apply8027->type = alloc_MethodType(1, argcv_meth_parser__apply8027);
  meth_meth_parser__apply8027->definitionModule = modulename;
  meth_meth_parser__apply8027->definitionLine = 2519;
// compiled block node returning block8026 (depth = 4)
  gc_frame_newslot(block8026);
// starting to compile block node (depth = 4)
  Object block8034 = alloc_Block(NULL, NULL, "parser", 2520);
  gc_frame_newslot(block8034);
// method _apply
  block_savedest(block8034);
  Object closure8035 = createclosure(6, "_apply");
  setclosureframe(closure8035, stackframe);
  addtoclosure(closure8035, var_sym);
  addtoclosure(closure8035, var_errormessages);
  addtoclosure(closure8035, var_lastToken);
  addtoclosure(closure8035, var_sz);
  addtoclosure(closure8035, var_values);
  addtoclosure(closure8035, selfslot);
  struct UserObject *uo8035 = (struct UserObject*)block8034;
  uo8035->data[0] = (Object)closure8035;
  Method *meth_meth_parser__apply8035 = addmethod2pos(block8034, "_apply", &meth_parser__apply8035, 0);
  int argcv_meth_parser__apply8035[] = {0};
  meth_meth_parser__apply8035->type = alloc_MethodType(1, argcv_meth_parser__apply8035);
  meth_meth_parser__apply8035->definitionModule = modulename;
  meth_meth_parser__apply8035->definitionLine = 2520;
// compiled block node returning block8034 (depth = 4)
  gc_frame_newslot(block8034);
// call case 5: prelude request
  params[0] = block8026;
  params[1] = block8034;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8118 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8025);
// compiled call node returning call8118 (depth = 3)
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8119 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8120 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8119);
// compiled call node returning call8120 (depth = 4)
// compiled member node returning call8120 (depth = 3)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array8121 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8121 (depth = 4)
  *var_rbody = array8121;
  if (array8121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8122 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call8123 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8122);
// compiled call node returning call8123 (depth = 5)
// compiled member node returning call8123 (depth = 4)
  *var_n = call8123;
  if (call8123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8124 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8125 = alloc_Block(NULL, NULL, "parser", 2545);
  gc_frame_newslot(block8125);
// method _apply
  block_savedest(block8125);
  Object closure8126 = createclosure(2, "_apply");
  setclosureframe(closure8126, stackframe);
  addtoclosure(closure8126, var_n);
  addtoclosure(closure8126, selfslot);
  struct UserObject *uo8126 = (struct UserObject*)block8125;
  uo8126->data[0] = (Object)closure8126;
  Method *meth_meth_parser__apply8126 = addmethod2pos(block8125, "_apply", &meth_parser__apply8126, 0);
  int argcv_meth_parser__apply8126[] = {0};
  meth_meth_parser__apply8126->type = alloc_MethodType(1, argcv_meth_parser__apply8126);
  meth_meth_parser__apply8126->definitionModule = modulename;
  meth_meth_parser__apply8126->definitionLine = 2544;
// compiled block node returning block8125 (depth = 4)
  gc_frame_newslot(block8125);
// starting to compile block node (depth = 4)
  Object block8134 = alloc_Block(NULL, NULL, "parser", 2545);
  gc_frame_newslot(block8134);
// method _apply
  block_savedest(block8134);
  Object closure8135 = createclosure(4, "_apply");
  setclosureframe(closure8135, stackframe);
  addtoclosure(closure8135, var_n);
  addtoclosure(closure8135, var_rbody);
  addtoclosure(closure8135, var_values);
  addtoclosure(closure8135, selfslot);
  struct UserObject *uo8135 = (struct UserObject*)block8134;
  uo8135->data[0] = (Object)closure8135;
  Method *meth_meth_parser__apply8135 = addmethod2pos(block8134, "_apply", &meth_parser__apply8135, 0);
  int argcv_meth_parser__apply8135[] = {0};
  meth_meth_parser__apply8135->type = alloc_MethodType(1, argcv_meth_parser__apply8135);
  meth_meth_parser__apply8135->definitionModule = modulename;
  meth_meth_parser__apply8135->definitionLine = 2545;
// compiled block node returning block8134 (depth = 4)
  gc_frame_newslot(block8134);
// call case 5: prelude request
  params[0] = block8125;
  params[1] = block8134;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8142 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8124);
// compiled call node returning call8142 (depth = 3)
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2549
  setline(2549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array8143 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8143 (depth = 4)
  *var_body = array8143;
  if (array8143 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8144 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rbody (depth = 6)
  partcv[0] = 0;
  Object call8146 = callmethod(*var_rbody, "indices",
    1, partcv, params);
  gc_frame_end(callframe8145);
// compiled call node returning call8146 (depth = 5)
// compiled member node returning call8146 (depth = 4)
  gc_frame_newslot(call8146);
// starting to compile block node (depth = 4)
  Object block8147 = alloc_Block(NULL, NULL, "parser", 2550);
  gc_frame_newslot(block8147);
// method _apply
  block_savedest(block8147);
  Object closure8148 = createclosure(3, "_apply");
  setclosureframe(closure8148, stackframe);
  addtoclosure(closure8148, var_rbody);
  addtoclosure(closure8148, var_body);
  addtoclosure(closure8148, selfslot);
  struct UserObject *uo8148 = (struct UserObject*)block8147;
  uo8148->data[0] = (Object)closure8148;
  Method *meth_meth_parser__apply8148 = addmethod2pos(block8147, "_apply", &meth_parser__apply8148, 0);
  int argcv_meth_parser__apply8148[] = {1};
  meth_meth_parser__apply8148->type = alloc_MethodType(1, argcv_meth_parser__apply8148);
  meth_meth_parser__apply8148->definitionModule = modulename;
  meth_meth_parser__apply8148->definitionLine = 2550;
// compiled block node returning block8147 (depth = 4)
  gc_frame_newslot(block8147);
// call case 5: prelude request
  params[0] = call8146;
  params[1] = block8147;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8154 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8144);
// compiled call node returning call8154 (depth = 3)
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8155 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8157 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8156);
// compiled call node returning call8157 (depth = 5)
// compiled member node returning call8157 (depth = 4)
  gc_frame_newslot(call8157);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8157;
  partcv[0] = 1;
  Object call8158 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8155);
// compiled call node returning call8158 (depth = 3)
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8159 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
  Object bool8160 = alloc_Boolean(0);
// compiled identifier node returning bool8160 (depth = 5)
  gc_frame_newslot(bool8160);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8162 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8161);
// compiled call node returning call8162 (depth = 6)
// compiled member node returning call8162 (depth = 5)
  params[0] = *var_body;
  params[1] = bool8160;
  partcv[0] = 2;
  Object call8163 = callmethod(call8162, "new",
    1, partcv, params);
  gc_frame_end(callframe8159);
// compiled call node returning call8163 (depth = 4)
  *var_o = call8163;
  if (call8163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8164 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8165 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8164);
// compiled call node returning call8165 (depth = 3)
// Begin line 2559
  setline(2559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if7931 = done;
  } else {
  }
// compiled if node returning if7931 (depth = 2)
  gc_frame_end(frame);
  return if7931;
}
Object meth_parser__apply8363(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit8365 == NULL) {
    strlit8365 = alloc_String("eof");
    gc_root(strlit8365);
  }
// compiled string node returning strlit8365 (depth = 8)
  int op_slot_right_8364 = gc_frame_newslot(strlit8365);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8367 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call8368 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8367);
// compiled call node returning call8368 (depth = 9)
// compiled member node returning call8368 (depth = 8)
  int op_slot_left_8364 = gc_frame_newslot(call8368);
  params[0] = strlit8365;
  partcv[0] = 1;
  Object opresult8369 = callmethod(call8368, "!=", 1, partcv, params);
// compiled op node returning opresult8369 (depth = 7)
  gc_frame_end(frame);
  return opresult8369;
}
Object meth_parser__apply8360(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe8361 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8362 = alloc_Block(NULL, NULL, "parser", 2626);
  gc_frame_newslot(block8362);
// method _apply
  block_savedest(block8362);
  Object closure8363 = createclosure(2, "_apply");
  setclosureframe(closure8363, stackframe);
  addtoclosure(closure8363, var_sym);
  addtoclosure(closure8363, selfslot);
  struct UserObject *uo8363 = (struct UserObject*)block8362;
  uo8363->data[0] = (Object)closure8363;
  Method *meth_meth_parser__apply8363 = addmethod2pos(block8362, "_apply", &meth_parser__apply8363, 0);
  int argcv_meth_parser__apply8363[] = {0};
  meth_meth_parser__apply8363->type = alloc_MethodType(1, argcv_meth_parser__apply8363);
  meth_meth_parser__apply8363->definitionModule = modulename;
  meth_meth_parser__apply8363->definitionLine = 2623;
// compiled block node returning block8362 (depth = 6)
  gc_frame_newslot(block8362);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8371 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe8372 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit8373 == NULL) {
    strlit8373 = alloc_String("rbrace");
    gc_root(strlit8373);
  }
// compiled string node returning strlit8373 (depth = 9)
  gc_frame_newslot(strlit8373);
// call case 4: self request
  params[0] = strlit8373;
  partcv[0] = 1;
  Object call8374 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8372);
// compiled call node returning call8374 (depth = 8)
  partcv[0] = 0;
  Object call8375 = callmethod(call8374, "not",
    1, partcv, params);
  gc_frame_end(callframe8371);
// compiled call node returning call8375 (depth = 7)
// compiled member node returning call8375 (depth = 6)
  params[0] = block8362;
  partcv[0] = 1;
  Object call8376 = callmethod(call8375, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8361);
// compiled call node returning call8376 (depth = 5)
  gc_frame_end(frame);
  return call8376;
}
Object meth_parser__apply8382(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8383 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8384 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8383);
// compiled call node returning call8384 (depth = 8)
// compiled member node returning call8384 (depth = 7)
  gc_frame_end(frame);
  return call8384;
}
Object meth_parser__apply8387(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2628
  setline(2628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8388 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8389 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8390 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8389);
// compiled call node returning call8390 (depth = 9)
// compiled member node returning call8390 (depth = 8)
  gc_frame_newslot(call8390);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8390;
  partcv[0] = 1;
  Object call8391 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8388);
// compiled call node returning call8391 (depth = 7)
  gc_frame_end(frame);
  return call8391;
}
Object meth_parser__apply8396(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8398 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8397);
// compiled call node returning call8398 (depth = 8)
// compiled member node returning call8398 (depth = 7)
  gc_frame_end(frame);
  return call8398;
}
Object meth_parser__apply8401(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8402 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8403 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8404 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8403);
// compiled call node returning call8404 (depth = 9)
// compiled member node returning call8404 (depth = 8)
  gc_frame_newslot(call8404);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8404;
  partcv[0] = 1;
  Object call8405 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8402);
// compiled call node returning call8405 (depth = 7)
  gc_frame_end(frame);
  return call8405;
}
Object meth_parser__apply8410(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8411 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8412 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8411);
// compiled call node returning call8412 (depth = 8)
// compiled member node returning call8412 (depth = 7)
  gc_frame_end(frame);
  return call8412;
}
Object meth_parser__apply8415(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8416 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8417 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8418 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8417);
// compiled call node returning call8418 (depth = 9)
// compiled member node returning call8418 (depth = 8)
  gc_frame_newslot(call8418);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8418;
  partcv[0] = 1;
  Object call8419 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8416);
// compiled call node returning call8419 (depth = 7)
  gc_frame_end(frame);
  return call8419;
}
Object meth_parser__apply8379(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8380 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8381 = alloc_Block(NULL, NULL, "parser", 2627);
  gc_frame_newslot(block8381);
// method _apply
  block_savedest(block8381);
  Object closure8382 = createclosure(1, "_apply");
  setclosureframe(closure8382, stackframe);
  addtoclosure(closure8382, selfslot);
  struct UserObject *uo8382 = (struct UserObject*)block8381;
  uo8382->data[0] = (Object)closure8382;
  Method *meth_meth_parser__apply8382 = addmethod2pos(block8381, "_apply", &meth_parser__apply8382, 0);
  int argcv_meth_parser__apply8382[] = {0};
  meth_meth_parser__apply8382->type = alloc_MethodType(1, argcv_meth_parser__apply8382);
  meth_meth_parser__apply8382->definitionModule = modulename;
  meth_meth_parser__apply8382->definitionLine = 2626;
// compiled block node returning block8381 (depth = 6)
  gc_frame_newslot(block8381);
// starting to compile block node (depth = 6)
  Object block8386 = alloc_Block(NULL, NULL, "parser", 2627);
  gc_frame_newslot(block8386);
// method _apply
  block_savedest(block8386);
  Object closure8387 = createclosure(3, "_apply");
  setclosureframe(closure8387, stackframe);
  addtoclosure(closure8387, var_values);
  addtoclosure(closure8387, var_body);
  addtoclosure(closure8387, selfslot);
  struct UserObject *uo8387 = (struct UserObject*)block8386;
  uo8387->data[0] = (Object)closure8387;
  Method *meth_meth_parser__apply8387 = addmethod2pos(block8386, "_apply", &meth_parser__apply8387, 0);
  int argcv_meth_parser__apply8387[] = {0};
  meth_meth_parser__apply8387->type = alloc_MethodType(1, argcv_meth_parser__apply8387);
  meth_meth_parser__apply8387->definitionModule = modulename;
  meth_meth_parser__apply8387->definitionLine = 2627;
// compiled block node returning block8386 (depth = 6)
  gc_frame_newslot(block8386);
// call case 4: self request
  params[0] = block8381;
  params[1] = block8386;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8393 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8380);
// compiled call node returning call8393 (depth = 5)
// Begin line 2630
  setline(2630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8394 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8395 = alloc_Block(NULL, NULL, "parser", 2630);
  gc_frame_newslot(block8395);
// method _apply
  block_savedest(block8395);
  Object closure8396 = createclosure(1, "_apply");
  setclosureframe(closure8396, stackframe);
  addtoclosure(closure8396, selfslot);
  struct UserObject *uo8396 = (struct UserObject*)block8395;
  uo8396->data[0] = (Object)closure8396;
  Method *meth_meth_parser__apply8396 = addmethod2pos(block8395, "_apply", &meth_parser__apply8396, 0);
  int argcv_meth_parser__apply8396[] = {0};
  meth_meth_parser__apply8396->type = alloc_MethodType(1, argcv_meth_parser__apply8396);
  meth_meth_parser__apply8396->definitionModule = modulename;
  meth_meth_parser__apply8396->definitionLine = 2628;
// compiled block node returning block8395 (depth = 6)
  gc_frame_newslot(block8395);
// starting to compile block node (depth = 6)
  Object block8400 = alloc_Block(NULL, NULL, "parser", 2630);
  gc_frame_newslot(block8400);
// method _apply
  block_savedest(block8400);
  Object closure8401 = createclosure(3, "_apply");
  setclosureframe(closure8401, stackframe);
  addtoclosure(closure8401, var_values);
  addtoclosure(closure8401, var_body);
  addtoclosure(closure8401, selfslot);
  struct UserObject *uo8401 = (struct UserObject*)block8400;
  uo8401->data[0] = (Object)closure8401;
  Method *meth_meth_parser__apply8401 = addmethod2pos(block8400, "_apply", &meth_parser__apply8401, 0);
  int argcv_meth_parser__apply8401[] = {0};
  meth_meth_parser__apply8401->type = alloc_MethodType(1, argcv_meth_parser__apply8401);
  meth_meth_parser__apply8401->definitionModule = modulename;
  meth_meth_parser__apply8401->definitionLine = 2630;
// compiled block node returning block8400 (depth = 6)
  gc_frame_newslot(block8400);
// call case 4: self request
  params[0] = block8395;
  params[1] = block8400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8407 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8394);
// compiled call node returning call8407 (depth = 5)
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8408 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8409 = alloc_Block(NULL, NULL, "parser", 2633);
  gc_frame_newslot(block8409);
// method _apply
  block_savedest(block8409);
  Object closure8410 = createclosure(1, "_apply");
  setclosureframe(closure8410, stackframe);
  addtoclosure(closure8410, selfslot);
  struct UserObject *uo8410 = (struct UserObject*)block8409;
  uo8410->data[0] = (Object)closure8410;
  Method *meth_meth_parser__apply8410 = addmethod2pos(block8409, "_apply", &meth_parser__apply8410, 0);
  int argcv_meth_parser__apply8410[] = {0};
  meth_meth_parser__apply8410->type = alloc_MethodType(1, argcv_meth_parser__apply8410);
  meth_meth_parser__apply8410->definitionModule = modulename;
  meth_meth_parser__apply8410->definitionLine = 2631;
// compiled block node returning block8409 (depth = 6)
  gc_frame_newslot(block8409);
// starting to compile block node (depth = 6)
  Object block8414 = alloc_Block(NULL, NULL, "parser", 2633);
  gc_frame_newslot(block8414);
// method _apply
  block_savedest(block8414);
  Object closure8415 = createclosure(3, "_apply");
  setclosureframe(closure8415, stackframe);
  addtoclosure(closure8415, var_values);
  addtoclosure(closure8415, var_body);
  addtoclosure(closure8415, selfslot);
  struct UserObject *uo8415 = (struct UserObject*)block8414;
  uo8415->data[0] = (Object)closure8415;
  Method *meth_meth_parser__apply8415 = addmethod2pos(block8414, "_apply", &meth_parser__apply8415, 0);
  int argcv_meth_parser__apply8415[] = {0};
  meth_meth_parser__apply8415->type = alloc_MethodType(1, argcv_meth_parser__apply8415);
  meth_meth_parser__apply8415->definitionModule = modulename;
  meth_meth_parser__apply8415->definitionLine = 2633;
// compiled block node returning block8414 (depth = 6)
  gc_frame_newslot(block8414);
// call case 4: self request
  params[0] = block8409;
  params[1] = block8414;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8421 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8408);
// compiled call node returning call8421 (depth = 5)
  gc_frame_end(frame);
  return call8421;
}
Object meth_parser_doclass8167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[6];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_statementToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doclass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doclass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_cname = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cname");
  Object *var_s = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "s");
  Object *var_csig = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "csig");
  Object *var_methodName = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "methodName");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_anns = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "anns");
  Object *var_body = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "body");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8171 == NULL) {
    strlit8171 = alloc_String("class");
    gc_root(strlit8171);
  }
// compiled string node returning strlit8171 (depth = 5)
  int op_slot_right_8170 = gc_frame_newslot(strlit8171);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8174 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8173);
// compiled call node returning call8174 (depth = 6)
// compiled member node returning call8174 (depth = 5)
  int op_slot_left_8170 = gc_frame_newslot(call8174);
  params[0] = strlit8171;
  partcv[0] = 1;
  Object opresult8175 = callmethod(call8174, "==", 1, partcv, params);
// compiled op node returning opresult8175 (depth = 4)
  int op_slot_right_8169 = gc_frame_newslot(opresult8175);
// starting to compile call node (depth = 4)
  int callframe8177 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8178 == NULL) {
    strlit8178 = alloc_String("keyword");
    gc_root(strlit8178);
  }
// compiled string node returning strlit8178 (depth = 5)
  gc_frame_newslot(strlit8178);
// call case 4: self request
  params[0] = strlit8178;
  partcv[0] = 1;
  Object call8179 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8177);
// compiled call node returning call8179 (depth = 4)
  int op_slot_left_8169 = gc_frame_newslot(call8179);
  params[0] = opresult8175;
  partcv[0] = 1;
  Object opresult8180 = callmethod(call8179, "&&", 1, partcv, params);
// compiled op node returning opresult8180 (depth = 3)
  Object if8168 = done;
  if (istrue(opresult8180)) {
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8182 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8181);
// compiled call node returning call8182 (depth = 4)
// compiled member node returning call8182 (depth = 3)
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8185 == NULL) {
    strlit8185 = alloc_String("identifier");
    gc_root(strlit8185);
  }
// compiled string node returning strlit8185 (depth = 5)
  int op_slot_right_8184 = gc_frame_newslot(strlit8185);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8188 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8187);
// compiled call node returning call8188 (depth = 6)
// compiled member node returning call8188 (depth = 5)
  int op_slot_left_8184 = gc_frame_newslot(call8188);
  params[0] = strlit8185;
  partcv[0] = 1;
  Object opresult8189 = callmethod(call8188, "!=", 1, partcv, params);
// compiled op node returning opresult8189 (depth = 4)
  Object if8183 = done;
  if (istrue(opresult8189)) {
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array8190 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8190 (depth = 5)
  *var_suggestions = array8190;
  if (array8190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8193 == NULL) {
    strlit8193 = alloc_String("lbrace");
    gc_root(strlit8193);
  }
// compiled string node returning strlit8193 (depth = 6)
  int op_slot_right_8192 = gc_frame_newslot(strlit8193);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8195 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8196 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8195);
// compiled call node returning call8196 (depth = 7)
// compiled member node returning call8196 (depth = 6)
  int op_slot_left_8192 = gc_frame_newslot(call8196);
  params[0] = strlit8193;
  partcv[0] = 1;
  Object opresult8197 = callmethod(call8196, "==", 1, partcv, params);
// compiled op node returning opresult8197 (depth = 5)
  Object if8191 = done;
  if (istrue(opresult8197)) {
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2577
  setline(2577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8198 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8199 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8200 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8199);
// compiled call node returning call8200 (depth = 9)
// compiled member node returning call8200 (depth = 8)
  partcv[0] = 0;
  Object call8201 = callmethod(call8200, "new",
    1, partcv, params);
  gc_frame_end(callframe8198);
// compiled call node returning call8201 (depth = 7)
// compiled member node returning call8201 (depth = 6)
  *var_suggestion = call8201;
  if (call8201 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8202 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8203 == NULL) {
    strlit8203 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit8203);
  }
// compiled string node returning strlit8203 (depth = 6)
  gc_frame_newslot(strlit8203);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8203;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8204 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8202);
// compiled call node returning call8204 (depth = 5)
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8205 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8206 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8205);
// compiled call node returning call8206 (depth = 5)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2580
  setline(2580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8207 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8209 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8208);
// compiled call node returning call8209 (depth = 9)
// compiled member node returning call8209 (depth = 8)
  partcv[0] = 0;
  Object call8210 = callmethod(call8209, "new",
    1, partcv, params);
  gc_frame_end(callframe8207);
// compiled call node returning call8210 (depth = 7)
// compiled member node returning call8210 (depth = 6)
  *var_suggestion = call8210;
  if (call8210 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8212 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8213 == NULL) {
    strlit8213 = alloc_String("object");
    gc_root(strlit8213);
  }
// compiled string node returning strlit8213 (depth = 6)
  gc_frame_newslot(strlit8213);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8213;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8214 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8212);
// compiled call node returning call8214 (depth = 5)
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8215 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8216 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8215);
// compiled call node returning call8216 (depth = 5)
    gc_frame_newslot(call8216);
    if8191 = call8216;
  } else {
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8217 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8218 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8219 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8218);
// compiled call node returning call8219 (depth = 9)
// compiled member node returning call8219 (depth = 8)
  partcv[0] = 0;
  Object call8220 = callmethod(call8219, "new",
    1, partcv, params);
  gc_frame_end(callframe8217);
// compiled call node returning call8220 (depth = 7)
// compiled member node returning call8220 (depth = 6)
  *var_suggestion = call8220;
  if (call8220 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8221 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8222 == NULL) {
    strlit8222 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit8222);
  }
// compiled string node returning strlit8222 (depth = 6)
  gc_frame_newslot(strlit8222);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8222;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8223 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8221);
// compiled call node returning call8223 (depth = 5)
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8224 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8225 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8224);
// compiled call node returning call8225 (depth = 5)
    gc_frame_newslot(call8225);
    if8191 = call8225;
  }
// compiled if node returning if8191 (depth = 4)
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8226 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8227 == NULL) {
    strlit8227 = alloc_String("A class must have a name after the 'class'.");
    gc_root(strlit8227);
  }
// compiled string node returning strlit8227 (depth = 5)
  gc_frame_newslot(strlit8227);
// Begin line 2589
  setline(2589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8228 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8229 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8228);
// compiled call node returning call8229 (depth = 6)
// compiled member node returning call8229 (depth = 5)
  gc_frame_newslot(call8229);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8231 = alloc_Float64(1);
// compiled num node returning num8231 (depth = 6)
  int op_slot_right_8230 = gc_frame_newslot(num8231);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8235 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8234);
// compiled call node returning call8235 (depth = 8)
// compiled member node returning call8235 (depth = 7)
  int op_slot_right_8233 = gc_frame_newslot(call8235);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8237 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8238 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8237);
// compiled call node returning call8238 (depth = 8)
// compiled member node returning call8238 (depth = 7)
  int op_slot_left_8233 = gc_frame_newslot(call8238);
  params[0] = call8235;
  partcv[0] = 1;
  Object sum8239 = callmethod(call8238, "+", 1, partcv, params);
// compiled op node returning sum8239 (depth = 6)
  int op_slot_left_8230 = gc_frame_newslot(sum8239);
  params[0] = num8231;
  partcv[0] = 1;
  Object sum8240 = callmethod(sum8239, "+", 1, partcv, params);
// compiled op node returning sum8240 (depth = 5)
  gc_frame_newslot(sum8240);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2588
  setline(2588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8227;
  params[1] = call8229;
  params[2] = sum8240;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8241 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8226);
// compiled call node returning call8241 (depth = 4)
    gc_frame_newslot(call8241);
    if8183 = call8241;
  } else {
  }
// compiled if node returning if8183 (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// Begin line 2591
  setline(2591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8244 == NULL) {
    strlit8244 = alloc_String("dot");
    gc_root(strlit8244);
  }
// compiled string node returning strlit8244 (depth = 6)
  int op_slot_right_8243 = gc_frame_newslot(strlit8244);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8246 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8247 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call8248 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8247);
// compiled call node returning call8248 (depth = 9)
// compiled member node returning call8248 (depth = 8)
  partcv[0] = 0;
  Object call8249 = callmethod(call8248, "kind",
    1, partcv, params);
  gc_frame_end(callframe8246);
// compiled call node returning call8249 (depth = 7)
// compiled member node returning call8249 (depth = 6)
  int op_slot_left_8243 = gc_frame_newslot(call8249);
  params[0] = strlit8244;
  partcv[0] = 1;
  Object opresult8250 = callmethod(call8249, "==", 1, partcv, params);
// compiled op node returning opresult8250 (depth = 5)
  Object if8242 = done;
struct StackFrameObject *iftmpstackframe8242 = stackframe;
  if (istrue(opresult8250)) {
stackframe = alloc_StackFrame(2, iftmpstackframe8242);
gc_frame_newslot((Object)stackframe);
  Object *var_cname_39_ = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "cname'");
// Begin line 2592
  setline(2592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8251 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8252 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8251);
// compiled call node returning call8252 (depth = 6)
// compiled member node returning call8252 (depth = 5)
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call8254 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8253);
// compiled call node returning call8254 (depth = 7)
// compiled member node returning call8254 (depth = 6)
  *var_cname_39_ = call8254;
  if (call8254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2593
  setline(2593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8255 = gc_frame_new();
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool8256 = alloc_Boolean(1);
// compiled identifier node returning bool8256 (depth = 7)
  gc_frame_newslot(bool8256);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_cname_39_ (depth = 7)
  params[0] = bool8256;
  partcv[0] = 1;
  Object call8257 = callmethod(*var_cname_39_, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8255);
// compiled call node returning call8257 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8259 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8260 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8261 == NULL) {
    strlit8261 = alloc_String("dot");
    gc_root(strlit8261);
  }
// compiled string node returning strlit8261 (depth = 8)
  gc_frame_newslot(strlit8261);
// call case 4: self request
  params[0] = strlit8261;
  partcv[0] = 1;
  Object call8262 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8260);
// compiled call node returning call8262 (depth = 7)
  partcv[0] = 0;
  Object call8263 = callmethod(call8262, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8259);
// compiled call node returning call8263 (depth = 6)
  Object if8258 = done;
  if (istrue(call8263)) {
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8264 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8265 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call8266 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8265);
// compiled call node returning call8266 (depth = 10)
// compiled member node returning call8266 (depth = 9)
  partcv[0] = 0;
  Object call8267 = callmethod(call8266, "new",
    1, partcv, params);
  gc_frame_end(callframe8264);
// compiled call node returning call8267 (depth = 8)
// compiled member node returning call8267 (depth = 7)
  *var_suggestion = call8267;
  if (call8267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8268 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 7)
  if (strlit8269 == NULL) {
    strlit8269 = alloc_String(".");
    gc_root(strlit8269);
  }
// compiled string node returning strlit8269 (depth = 7)
  gc_frame_newslot(strlit8269);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = strlit8269;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8270 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8268);
// compiled call node returning call8270 (depth = 6)
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8271 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8272 == NULL) {
    strlit8272 = alloc_String("A class must have a dot after the object name.");
    gc_root(strlit8272);
  }
// compiled string node returning strlit8272 (depth = 7)
  gc_frame_newslot(strlit8272);
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8273 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8274 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8273);
// compiled call node returning call8274 (depth = 8)
// compiled member node returning call8274 (depth = 7)
  gc_frame_newslot(call8274);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8276 = alloc_Float64(1);
// compiled num node returning num8276 (depth = 8)
  int op_slot_right_8275 = gc_frame_newslot(num8276);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8280 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8279);
// compiled call node returning call8280 (depth = 10)
// compiled member node returning call8280 (depth = 9)
  int op_slot_right_8278 = gc_frame_newslot(call8280);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call8283 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8282);
// compiled call node returning call8283 (depth = 10)
// compiled member node returning call8283 (depth = 9)
  int op_slot_left_8278 = gc_frame_newslot(call8283);
  params[0] = call8280;
  partcv[0] = 1;
  Object sum8284 = callmethod(call8283, "+", 1, partcv, params);
// compiled op node returning sum8284 (depth = 8)
  int op_slot_left_8275 = gc_frame_newslot(sum8284);
  params[0] = num8276;
  partcv[0] = 1;
  Object sum8285 = callmethod(sum8284, "+", 1, partcv, params);
// compiled op node returning sum8285 (depth = 7)
  gc_frame_newslot(sum8285);
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errormessages (depth = 7)
  params[0] = strlit8272;
  params[1] = call8274;
  params[2] = sum8285;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8286 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8271);
// compiled call node returning call8286 (depth = 6)
    gc_frame_newslot(call8286);
    if8258 = call8286;
  } else {
  }
// compiled if node returning if8258 (depth = 5)
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8287 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8288 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8287);
// compiled call node returning call8288 (depth = 6)
// compiled member node returning call8288 (depth = 5)
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cname_39_ (depth = 5)
    gc_frame_newslot(*var_cname_39_);
    if8242 = *var_cname_39_;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8242);
  gc_frame_newslot((Object)stackframe);
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool8289 = alloc_Boolean(0);
// compiled identifier node returning bool8289 (depth = 5)
    gc_frame_newslot(bool8289);
    if8242 = bool8289;
  }
stackframe = iftmpstackframe8242;
// compiled if node returning if8242 (depth = 4)
  *var_cname = if8242;
  if (if8242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8290 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8291 = alloc_Boolean(0);
// compiled identifier node returning bool8291 (depth = 5)
  gc_frame_newslot(bool8291);
// call case 4: self request
  params[0] = bool8291;
  partcv[0] = 1;
  Object call8292 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8290);
// compiled call node returning call8292 (depth = 4)
  *var_s = call8292;
  if (call8292 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2608
  setline(2608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8294 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8293);
// compiled call node returning call8294 (depth = 5)
// compiled member node returning call8294 (depth = 4)
  *var_csig = call8294;
  if (call8294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8295 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8296 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8295);
// compiled call node returning call8296 (depth = 5)
// compiled member node returning call8296 (depth = 4)
  *var_methodName = call8296;
  if (call8296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8297 = gc_frame_new();
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool8298 = alloc_Boolean(1);
// compiled identifier node returning bool8298 (depth = 5)
  gc_frame_newslot(bool8298);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  params[0] = bool8298;
  partcv[0] = 1;
  Object call8299 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8297);
// compiled call node returning call8299 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8300 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8301 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8300);
// compiled call node returning call8301 (depth = 5)
// compiled member node returning call8301 (depth = 4)
  *var_dtype = call8301;
  if (call8301 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2612
  setline(2612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8302 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8303 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8302);
// compiled call node returning call8303 (depth = 5)
// compiled member node returning call8303 (depth = 4)
  *var_anns = call8303;
  if (call8303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8305 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8306 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8307 == NULL) {
    strlit8307 = alloc_String("lbrace");
    gc_root(strlit8307);
  }
// compiled string node returning strlit8307 (depth = 6)
  gc_frame_newslot(strlit8307);
// call case 4: self request
  params[0] = strlit8307;
  partcv[0] = 1;
  Object call8308 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8306);
// compiled call node returning call8308 (depth = 5)
  partcv[0] = 0;
  Object call8309 = callmethod(call8308, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8305);
// compiled call node returning call8309 (depth = 4)
  Object if8304 = done;
  if (istrue(call8309)) {
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8310 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8311 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8312 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8311);
// compiled call node returning call8312 (depth = 8)
// compiled member node returning call8312 (depth = 7)
  partcv[0] = 0;
  Object call8313 = callmethod(call8312, "new",
    1, partcv, params);
  gc_frame_end(callframe8310);
// compiled call node returning call8313 (depth = 6)
// compiled member node returning call8313 (depth = 5)
  *var_suggestion = call8313;
  if (call8313 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2615
  setline(2615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8314 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8315 == NULL) {
    strlit8315 = alloc_String(" {");
    gc_root(strlit8315);
  }
// compiled string node returning strlit8315 (depth = 5)
  gc_frame_newslot(strlit8315);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8315;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8316 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8314);
// compiled call node returning call8316 (depth = 4)
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8317 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8318 == NULL) {
    strlit8318 = alloc_String("A class must have a '{' after the method name.");
    gc_root(strlit8318);
  }
// compiled string node returning strlit8318 (depth = 5)
  gc_frame_newslot(strlit8318);
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8319 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8320 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8319);
// compiled call node returning call8320 (depth = 6)
// compiled member node returning call8320 (depth = 5)
  gc_frame_newslot(call8320);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8322 = alloc_Float64(1);
// compiled num node returning num8322 (depth = 6)
  int op_slot_right_8321 = gc_frame_newslot(num8322);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8326 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8325);
// compiled call node returning call8326 (depth = 8)
// compiled member node returning call8326 (depth = 7)
  int op_slot_right_8324 = gc_frame_newslot(call8326);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8328 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8329 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8328);
// compiled call node returning call8329 (depth = 8)
// compiled member node returning call8329 (depth = 7)
  int op_slot_left_8324 = gc_frame_newslot(call8329);
  params[0] = call8326;
  partcv[0] = 1;
  Object sum8330 = callmethod(call8329, "+", 1, partcv, params);
// compiled op node returning sum8330 (depth = 6)
  int op_slot_left_8321 = gc_frame_newslot(sum8330);
  params[0] = num8322;
  partcv[0] = 1;
  Object sum8331 = callmethod(sum8330, "+", 1, partcv, params);
// compiled op node returning sum8331 (depth = 5)
  gc_frame_newslot(sum8331);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8318;
  params[1] = call8320;
  params[2] = sum8331;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8332 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8317);
// compiled call node returning call8332 (depth = 4)
    gc_frame_newslot(call8332);
    if8304 = call8332;
  } else {
  }
// compiled if node returning if8304 (depth = 3)
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8334 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8333);
// compiled call node returning call8334 (depth = 4)
// compiled member node returning call8334 (depth = 3)
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8337 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call8338 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8337);
// compiled call node returning call8338 (depth = 6)
// compiled member node returning call8338 (depth = 5)
  int op_slot_right_8336 = gc_frame_newslot(call8338);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8340 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8341 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8340);
// compiled call node returning call8341 (depth = 6)
// compiled member node returning call8341 (depth = 5)
  int op_slot_left_8336 = gc_frame_newslot(call8341);
  params[0] = call8338;
  partcv[0] = 1;
  Object opresult8342 = callmethod(call8341, "==", 1, partcv, params);
// compiled op node returning opresult8342 (depth = 4)
  Object if8335 = done;
  if (istrue(opresult8342)) {
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num8344 = alloc_Float64(1);
// compiled num node returning num8344 (depth = 6)
  int op_slot_right_8343 = gc_frame_newslot(num8344);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8347 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8346);
// compiled call node returning call8347 (depth = 7)
// compiled member node returning call8347 (depth = 6)
  int op_slot_left_8343 = gc_frame_newslot(call8347);
  params[0] = num8344;
  partcv[0] = 1;
  Object diff8348 = callmethod(call8347, "-", 1, partcv, params);
// compiled op node returning diff8348 (depth = 5)
  *var_minIndentLevel = diff8348;
  if (diff8348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8335 = done;
  } else {
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num8351 = alloc_Float64(1);
// compiled num node returning num8351 (depth = 6)
  int op_slot_right_8350 = gc_frame_newslot(num8351);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8353 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  partcv[0] = 0;
  Object call8354 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8353);
// compiled call node returning call8354 (depth = 7)
// compiled member node returning call8354 (depth = 6)
  int op_slot_left_8350 = gc_frame_newslot(call8354);
  params[0] = num8351;
  partcv[0] = 1;
  Object sum8355 = callmethod(call8354, "+", 1, partcv, params);
// compiled op node returning sum8355 (depth = 5)
  *var_minIndentLevel = sum8355;
  if (sum8355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8335 = done;
  }
// compiled if node returning if8335 (depth = 3)
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2625
  setline(2625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array8357 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8357 (depth = 4)
  *var_body = array8357;
  if (array8357 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8358 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8359 = alloc_Block(NULL, NULL, "parser", 2626);
  gc_frame_newslot(block8359);
// method _apply
  block_savedest(block8359);
  Object closure8360 = createclosure(2, "_apply");
  setclosureframe(closure8360, stackframe);
  addtoclosure(closure8360, var_sym);
  addtoclosure(closure8360, selfslot);
  struct UserObject *uo8360 = (struct UserObject*)block8359;
  uo8360->data[0] = (Object)closure8360;
  Method *meth_meth_parser__apply8360 = addmethod2pos(block8359, "_apply", &meth_parser__apply8360, 0);
  int argcv_meth_parser__apply8360[] = {0};
  meth_meth_parser__apply8360->type = alloc_MethodType(1, argcv_meth_parser__apply8360);
  meth_meth_parser__apply8360->definitionModule = modulename;
  meth_meth_parser__apply8360->definitionLine = 2623;
// compiled block node returning block8359 (depth = 4)
  gc_frame_newslot(block8359);
// starting to compile block node (depth = 4)
  Object block8378 = alloc_Block(NULL, NULL, "parser", 2626);
  gc_frame_newslot(block8378);
// method _apply
  block_savedest(block8378);
  Object closure8379 = createclosure(3, "_apply");
  setclosureframe(closure8379, stackframe);
  addtoclosure(closure8379, var_values);
  addtoclosure(closure8379, var_body);
  addtoclosure(closure8379, selfslot);
  struct UserObject *uo8379 = (struct UserObject*)block8378;
  uo8379->data[0] = (Object)closure8379;
  Method *meth_meth_parser__apply8379 = addmethod2pos(block8378, "_apply", &meth_parser__apply8379, 0);
  int argcv_meth_parser__apply8379[] = {0};
  meth_meth_parser__apply8379->type = alloc_MethodType(1, argcv_meth_parser__apply8379);
  meth_meth_parser__apply8379->definitionModule = modulename;
  meth_meth_parser__apply8379->definitionLine = 2626;
// compiled block node returning block8378 (depth = 4)
  gc_frame_newslot(block8378);
// call case 5: prelude request
  params[0] = block8359;
  params[1] = block8378;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8423 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8358);
// compiled call node returning call8423 (depth = 3)
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8424 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8425 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8424);
// compiled call node returning call8425 (depth = 4)
// compiled member node returning call8425 (depth = 3)
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8426 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8427 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8428 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8427);
// compiled call node returning call8428 (depth = 5)
// compiled member node returning call8428 (depth = 4)
  gc_frame_newslot(call8428);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8428;
  partcv[0] = 1;
  Object call8429 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8426);
// compiled call node returning call8429 (depth = 3)
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile if node (depth = 4)
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cname (depth = 6)
  int op_slot_right_8431 = gc_frame_newslot(*var_cname);
// starting to compile identifier node (depth = 6)
  Object bool8433 = alloc_Boolean(0);
// compiled identifier node returning bool8433 (depth = 6)
  int op_slot_left_8431 = gc_frame_newslot(bool8433);
  params[0] = *var_cname;
  partcv[0] = 1;
  Object opresult8434 = callmethod(bool8433, "==", 1, partcv, params);
// compiled op node returning opresult8434 (depth = 5)
  Object if8430 = done;
struct StackFrameObject *iftmpstackframe8430 = stackframe;
  if (istrue(opresult8434)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8430);
gc_frame_newslot((Object)stackframe);
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8435 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodName (depth = 6)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_csig (depth = 6)
  gc_frame_newslot(*var_csig);
// Begin line 2641
  setline(2641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array8436 = alloc_BuiltinList();
  gc_pause();
// starting to compile call node (depth = 7)
  int callframe8437 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 8)
  Object bool8438 = alloc_Boolean(0);
// compiled identifier node returning bool8438 (depth = 8)
  gc_frame_newslot(bool8438);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call8440 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8439);
// compiled call node returning call8440 (depth = 9)
// compiled member node returning call8440 (depth = 8)
  params[0] = *var_body;
  params[1] = bool8438;
  partcv[0] = 2;
  Object call8441 = callmethod(call8440, "new",
    1, partcv, params);
  gc_frame_end(callframe8437);
// compiled call node returning call8441 (depth = 7)
  params[0] = call8441;
  partcv[0] = 1;
  callmethod(array8436, "push", 1, partcv, params);
  gc_unpause();
// compiled array node returning array8436 (depth = 6)
  gc_frame_newslot(array8436);
// starting to compile identifier node (depth = 6)
  Object bool8442 = alloc_Boolean(0);
// compiled identifier node returning bool8442 (depth = 6)
  gc_frame_newslot(bool8442);
// call case 6: other member request
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8443 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8444 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8443);
// compiled call node returning call8444 (depth = 7)
// compiled member node returning call8444 (depth = 6)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = array8436;
  params[3] = bool8442;
  partcv[0] = 4;
  Object call8445 = callmethod(call8444, "new",
    1, partcv, params);
  gc_frame_end(callframe8435);
// compiled call node returning call8445 (depth = 5)
    gc_frame_newslot(call8445);
    if8430 = call8445;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe8430);
  gc_frame_newslot((Object)stackframe);
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8446 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_cname (depth = 6)
  gc_frame_newslot(*var_cname);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_csig (depth = 6)
  gc_frame_newslot(*var_csig);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_body (depth = 6)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 6)
  Object bool8447 = alloc_Boolean(0);
// compiled identifier node returning bool8447 (depth = 6)
  gc_frame_newslot(bool8447);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methodName (depth = 6)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_dtype (depth = 6)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call8449 = callmethod(*var_ast, "classNode",
    1, partcv, params);
  gc_frame_end(callframe8448);
// compiled call node returning call8449 (depth = 7)
// compiled member node returning call8449 (depth = 6)
  params[0] = *var_cname;
  params[1] = *var_csig;
  params[2] = *var_body;
  params[3] = bool8447;
  params[4] = *var_methodName;
  params[5] = *var_dtype;
  partcv[0] = 6;
  Object call8450 = callmethod(call8449, "new",
    1, partcv, params);
  gc_frame_end(callframe8446);
// compiled call node returning call8450 (depth = 5)
    gc_frame_newslot(call8450);
    if8430 = call8450;
  }
stackframe = iftmpstackframe8430;
// compiled if node returning if8430 (depth = 4)
  *var_o = if8430;
  if (if8430 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8451 = gc_frame_new();
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8452 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  partcv[0] = 0;
  Object call8453 = callmethod(*var_s, "generics",
    1, partcv, params);
  gc_frame_end(callframe8452);
// compiled call node returning call8453 (depth = 6)
// compiled member node returning call8453 (depth = 5)
  gc_frame_newslot(call8453);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = call8453;
  partcv[0] = 1;
  Object call8454 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8451);
// compiled call node returning call8454 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8456 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8458 = alloc_Boolean(0);
// compiled identifier node returning bool8458 (depth = 5)
  int op_slot_left_8456 = gc_frame_newslot(bool8458);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8459 = callmethod(bool8458, "!=", 1, partcv, params);
// compiled op node returning opresult8459 (depth = 4)
  Object if8455 = done;
  if (istrue(opresult8459)) {
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8460 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call8462 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8461);
// compiled call node returning call8462 (depth = 6)
// compiled member node returning call8462 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8463 = callmethod(call8462, "extend",
    1, partcv, params);
  gc_frame_end(callframe8460);
// compiled call node returning call8463 (depth = 4)
    gc_frame_newslot(call8463);
    if8455 = call8463;
  } else {
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8466 == NULL) {
    strlit8466 = alloc_String("confidential");
    gc_root(strlit8466);
  }
// compiled string node returning strlit8466 (depth = 6)
  int op_slot_right_8465 = gc_frame_newslot(strlit8466);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 6)
  int op_slot_left_8465 = gc_frame_newslot(*var_defaultMethodVisibility);
  params[0] = strlit8466;
  partcv[0] = 1;
  Object opresult8468 = callmethod(*var_defaultMethodVisibility, "==", 1, partcv, params);
// compiled op node returning opresult8468 (depth = 5)
  Object if8464 = done;
  if (istrue(opresult8468)) {
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8469 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe8470 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8471 == NULL) {
    strlit8471 = alloc_String("confidential");
    gc_root(strlit8471);
  }
// compiled string node returning strlit8471 (depth = 7)
  gc_frame_newslot(strlit8471);
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool8472 = alloc_Boolean(0);
// compiled identifier node returning bool8472 (depth = 7)
  gc_frame_newslot(bool8472);
// call case 6: other member request
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8473 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call8474 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8473);
// compiled call node returning call8474 (depth = 8)
// compiled member node returning call8474 (depth = 7)
  params[0] = strlit8471;
  params[1] = bool8472;
  partcv[0] = 2;
  Object call8475 = callmethod(call8474, "new",
    1, partcv, params);
  gc_frame_end(callframe8470);
// compiled call node returning call8475 (depth = 6)
  gc_frame_newslot(call8475);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call8477 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8476);
// compiled call node returning call8477 (depth = 7)
// compiled member node returning call8477 (depth = 6)
  params[0] = call8475;
  partcv[0] = 1;
  Object call8478 = callmethod(call8477, "push",
    1, partcv, params);
  gc_frame_end(callframe8469);
// compiled call node returning call8478 (depth = 5)
    gc_frame_newslot(call8478);
    if8464 = call8478;
  } else {
  }
// compiled if node returning if8464 (depth = 4)
    gc_frame_newslot(if8464);
    if8455 = if8464;
  }
// compiled if node returning if8455 (depth = 3)
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8479 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8480 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8479);
// compiled call node returning call8480 (depth = 3)
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2655
  setline(2655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8168 = done;
  } else {
  }
// compiled if node returning if8168 (depth = 2)
  gc_frame_end(frame);
  return if8168;
}
Object meth_parser__apply8486(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8488 == NULL) {
    strlit8488 = alloc_String("method");
    gc_root(strlit8488);
  }
// compiled string node returning strlit8488 (depth = 6)
  int op_slot_right_8487 = gc_frame_newslot(strlit8488);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8490 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call8492 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8491);
// compiled call node returning call8492 (depth = 9)
// compiled member node returning call8492 (depth = 8)
  partcv[0] = 0;
  Object call8493 = callmethod(call8492, "value",
    1, partcv, params);
  gc_frame_end(callframe8490);
// compiled call node returning call8493 (depth = 7)
// compiled member node returning call8493 (depth = 6)
  int op_slot_left_8487 = gc_frame_newslot(call8493);
  params[0] = strlit8488;
  partcv[0] = 1;
  Object opresult8494 = callmethod(call8493, "==", 1, partcv, params);
// compiled op node returning opresult8494 (depth = 5)
  gc_frame_end(frame);
  return opresult8494;
}
Object meth_parser__apply8498(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8500 == NULL) {
    strlit8500 = alloc_String("keyword");
    gc_root(strlit8500);
  }
// compiled string node returning strlit8500 (depth = 7)
  int op_slot_right_8499 = gc_frame_newslot(strlit8500);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8502 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8503 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_tokens (depth = 11)
  partcv[0] = 0;
  Object call8504 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8503);
// compiled call node returning call8504 (depth = 10)
// compiled member node returning call8504 (depth = 9)
  partcv[0] = 0;
  Object call8505 = callmethod(call8504, "kind",
    1, partcv, params);
  gc_frame_end(callframe8502);
// compiled call node returning call8505 (depth = 8)
// compiled member node returning call8505 (depth = 7)
  int op_slot_left_8499 = gc_frame_newslot(call8505);
  params[0] = strlit8500;
  partcv[0] = 1;
  Object opresult8506 = callmethod(call8505, "==", 1, partcv, params);
// compiled op node returning opresult8506 (depth = 6)
  gc_frame_end(frame);
  return opresult8506;
}
Object meth_parser__apply8655(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8656 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe8657 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8658 == NULL) {
    strlit8658 = alloc_String("rbrace");
    gc_root(strlit8658);
  }
// compiled string node returning strlit8658 (depth = 8)
  gc_frame_newslot(strlit8658);
// call case 4: self request
  params[0] = strlit8658;
  partcv[0] = 1;
  Object call8659 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8657);
// compiled call node returning call8659 (depth = 7)
  partcv[0] = 0;
  Object call8660 = callmethod(call8659, "not",
    1, partcv, params);
  gc_frame_end(callframe8656);
// compiled call node returning call8660 (depth = 6)
// compiled member node returning call8660 (depth = 5)
  gc_frame_end(frame);
  return call8660;
}
Object meth_parser__apply8666(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8667 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8668 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8667);
// compiled call node returning call8668 (depth = 8)
// compiled member node returning call8668 (depth = 7)
  gc_frame_end(frame);
  return call8668;
}
Object meth_parser__apply8671(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8672 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8674 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8673);
// compiled call node returning call8674 (depth = 9)
// compiled member node returning call8674 (depth = 8)
  gc_frame_newslot(call8674);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8674;
  partcv[0] = 1;
  Object call8675 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8672);
// compiled call node returning call8675 (depth = 7)
  gc_frame_end(frame);
  return call8675;
}
Object meth_parser__apply8680(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8682 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8681);
// compiled call node returning call8682 (depth = 8)
// compiled member node returning call8682 (depth = 7)
  gc_frame_end(frame);
  return call8682;
}
Object meth_parser__apply8685(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2709
  setline(2709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8686 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8687 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8688 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8687);
// compiled call node returning call8688 (depth = 9)
// compiled member node returning call8688 (depth = 8)
  gc_frame_newslot(call8688);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8688;
  partcv[0] = 1;
  Object call8689 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8686);
// compiled call node returning call8689 (depth = 7)
  gc_frame_end(frame);
  return call8689;
}
Object meth_parser__apply8694(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8695 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8696 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8695);
// compiled call node returning call8696 (depth = 8)
// compiled member node returning call8696 (depth = 7)
  gc_frame_end(frame);
  return call8696;
}
Object meth_parser__apply8699(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8700 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8701 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call8702 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8701);
// compiled call node returning call8702 (depth = 9)
// compiled member node returning call8702 (depth = 8)
  gc_frame_newslot(call8702);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_body (depth = 8)
  params[0] = call8702;
  partcv[0] = 1;
  Object call8703 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8700);
// compiled call node returning call8703 (depth = 7)
  gc_frame_end(frame);
  return call8703;
}
Object meth_parser__apply8663(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8664 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8665 = alloc_Block(NULL, NULL, "parser", 2705);
  gc_frame_newslot(block8665);
// method _apply
  block_savedest(block8665);
  Object closure8666 = createclosure(1, "_apply");
  setclosureframe(closure8666, stackframe);
  addtoclosure(closure8666, selfslot);
  struct UserObject *uo8666 = (struct UserObject*)block8665;
  uo8666->data[0] = (Object)closure8666;
  Method *meth_meth_parser__apply8666 = addmethod2pos(block8665, "_apply", &meth_parser__apply8666, 0);
  int argcv_meth_parser__apply8666[] = {0};
  meth_meth_parser__apply8666->type = alloc_MethodType(1, argcv_meth_parser__apply8666);
  meth_meth_parser__apply8666->definitionModule = modulename;
  meth_meth_parser__apply8666->definitionLine = 2704;
// compiled block node returning block8665 (depth = 6)
  gc_frame_newslot(block8665);
// starting to compile block node (depth = 6)
  Object block8670 = alloc_Block(NULL, NULL, "parser", 2705);
  gc_frame_newslot(block8670);
// method _apply
  block_savedest(block8670);
  Object closure8671 = createclosure(3, "_apply");
  setclosureframe(closure8671, stackframe);
  addtoclosure(closure8671, var_values);
  addtoclosure(closure8671, var_body);
  addtoclosure(closure8671, selfslot);
  struct UserObject *uo8671 = (struct UserObject*)block8670;
  uo8671->data[0] = (Object)closure8671;
  Method *meth_meth_parser__apply8671 = addmethod2pos(block8670, "_apply", &meth_parser__apply8671, 0);
  int argcv_meth_parser__apply8671[] = {0};
  meth_meth_parser__apply8671->type = alloc_MethodType(1, argcv_meth_parser__apply8671);
  meth_meth_parser__apply8671->definitionModule = modulename;
  meth_meth_parser__apply8671->definitionLine = 2705;
// compiled block node returning block8670 (depth = 6)
  gc_frame_newslot(block8670);
// call case 4: self request
  params[0] = block8665;
  params[1] = block8670;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8677 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8664);
// compiled call node returning call8677 (depth = 5)
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8678 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8679 = alloc_Block(NULL, NULL, "parser", 2708);
  gc_frame_newslot(block8679);
// method _apply
  block_savedest(block8679);
  Object closure8680 = createclosure(1, "_apply");
  setclosureframe(closure8680, stackframe);
  addtoclosure(closure8680, selfslot);
  struct UserObject *uo8680 = (struct UserObject*)block8679;
  uo8680->data[0] = (Object)closure8680;
  Method *meth_meth_parser__apply8680 = addmethod2pos(block8679, "_apply", &meth_parser__apply8680, 0);
  int argcv_meth_parser__apply8680[] = {0};
  meth_meth_parser__apply8680->type = alloc_MethodType(1, argcv_meth_parser__apply8680);
  meth_meth_parser__apply8680->definitionModule = modulename;
  meth_meth_parser__apply8680->definitionLine = 2706;
// compiled block node returning block8679 (depth = 6)
  gc_frame_newslot(block8679);
// starting to compile block node (depth = 6)
  Object block8684 = alloc_Block(NULL, NULL, "parser", 2708);
  gc_frame_newslot(block8684);
// method _apply
  block_savedest(block8684);
  Object closure8685 = createclosure(3, "_apply");
  setclosureframe(closure8685, stackframe);
  addtoclosure(closure8685, var_values);
  addtoclosure(closure8685, var_body);
  addtoclosure(closure8685, selfslot);
  struct UserObject *uo8685 = (struct UserObject*)block8684;
  uo8685->data[0] = (Object)closure8685;
  Method *meth_meth_parser__apply8685 = addmethod2pos(block8684, "_apply", &meth_parser__apply8685, 0);
  int argcv_meth_parser__apply8685[] = {0};
  meth_meth_parser__apply8685->type = alloc_MethodType(1, argcv_meth_parser__apply8685);
  meth_meth_parser__apply8685->definitionModule = modulename;
  meth_meth_parser__apply8685->definitionLine = 2708;
// compiled block node returning block8684 (depth = 6)
  gc_frame_newslot(block8684);
// call case 4: self request
  params[0] = block8679;
  params[1] = block8684;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8691 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8678);
// compiled call node returning call8691 (depth = 5)
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8692 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block8693 = alloc_Block(NULL, NULL, "parser", 2711);
  gc_frame_newslot(block8693);
// method _apply
  block_savedest(block8693);
  Object closure8694 = createclosure(1, "_apply");
  setclosureframe(closure8694, stackframe);
  addtoclosure(closure8694, selfslot);
  struct UserObject *uo8694 = (struct UserObject*)block8693;
  uo8694->data[0] = (Object)closure8694;
  Method *meth_meth_parser__apply8694 = addmethod2pos(block8693, "_apply", &meth_parser__apply8694, 0);
  int argcv_meth_parser__apply8694[] = {0};
  meth_meth_parser__apply8694->type = alloc_MethodType(1, argcv_meth_parser__apply8694);
  meth_meth_parser__apply8694->definitionModule = modulename;
  meth_meth_parser__apply8694->definitionLine = 2709;
// compiled block node returning block8693 (depth = 6)
  gc_frame_newslot(block8693);
// starting to compile block node (depth = 6)
  Object block8698 = alloc_Block(NULL, NULL, "parser", 2711);
  gc_frame_newslot(block8698);
// method _apply
  block_savedest(block8698);
  Object closure8699 = createclosure(3, "_apply");
  setclosureframe(closure8699, stackframe);
  addtoclosure(closure8699, var_values);
  addtoclosure(closure8699, var_body);
  addtoclosure(closure8699, selfslot);
  struct UserObject *uo8699 = (struct UserObject*)block8698;
  uo8699->data[0] = (Object)closure8699;
  Method *meth_meth_parser__apply8699 = addmethod2pos(block8698, "_apply", &meth_parser__apply8699, 0);
  int argcv_meth_parser__apply8699[] = {0};
  meth_meth_parser__apply8699->type = alloc_MethodType(1, argcv_meth_parser__apply8699);
  meth_meth_parser__apply8699->definitionModule = modulename;
  meth_meth_parser__apply8699->definitionLine = 2711;
// compiled block node returning block8698 (depth = 6)
  gc_frame_newslot(block8698);
// call case 4: self request
  params[0] = block8693;
  params[1] = block8698;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8705 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8692);
// compiled call node returning call8705 (depth = 5)
  gc_frame_end(frame);
  return call8705;
}
Object meth_parser_dofactoryMethod8482(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dofactoryMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_statementToken = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_collections = getfromclosure(closure, 9);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 10);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dofactoryMethod (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dofactoryMethod");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_csig = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "csig");
  Object *var_methodName = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "methodName");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_body = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "body");
  Object *var_obj = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "obj");
  Object *var_meth = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "meth");
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8484 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8485 = alloc_Block(NULL, NULL, "parser", 2662);
  gc_frame_newslot(block8485);
// method _apply
  block_savedest(block8485);
  Object closure8486 = createclosure(2, "_apply");
  setclosureframe(closure8486, stackframe);
  addtoclosure(closure8486, var_tokens);
  addtoclosure(closure8486, selfslot);
  struct UserObject *uo8486 = (struct UserObject*)block8485;
  uo8486->data[0] = (Object)closure8486;
  Method *meth_meth_parser__apply8486 = addmethod2pos(block8485, "_apply", &meth_parser__apply8486, 0);
  int argcv_meth_parser__apply8486[] = {0};
  meth_meth_parser__apply8486->type = alloc_MethodType(1, argcv_meth_parser__apply8486);
  meth_meth_parser__apply8486->definitionModule = modulename;
  meth_meth_parser__apply8486->definitionLine = 2650;
// compiled block node returning block8485 (depth = 4)
  gc_frame_newslot(block8485);
// call case 6: other member request
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8496 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8497 = alloc_Block(NULL, NULL, "parser", 2661);
  gc_frame_newslot(block8497);
// method _apply
  block_savedest(block8497);
  Object closure8498 = createclosure(2, "_apply");
  setclosureframe(closure8498, stackframe);
  addtoclosure(closure8498, var_tokens);
  addtoclosure(closure8498, selfslot);
  struct UserObject *uo8498 = (struct UserObject*)block8497;
  uo8498->data[0] = (Object)closure8498;
  Method *meth_meth_parser__apply8498 = addmethod2pos(block8497, "_apply", &meth_parser__apply8498, 0);
  int argcv_meth_parser__apply8498[] = {0};
  meth_meth_parser__apply8498->type = alloc_MethodType(1, argcv_meth_parser__apply8498);
  meth_meth_parser__apply8498->definitionModule = modulename;
  meth_meth_parser__apply8498->definitionLine = 2663;
// compiled block node returning block8497 (depth = 5)
  gc_frame_newslot(block8497);
// call case 6: other member request
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8510 == NULL) {
    strlit8510 = alloc_String("factory");
    gc_root(strlit8510);
  }
// compiled string node returning strlit8510 (depth = 7)
  int op_slot_right_8509 = gc_frame_newslot(strlit8510);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8512 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8513 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8512);
// compiled call node returning call8513 (depth = 8)
// compiled member node returning call8513 (depth = 7)
  int op_slot_left_8509 = gc_frame_newslot(call8513);
  params[0] = strlit8510;
  partcv[0] = 1;
  Object opresult8514 = callmethod(call8513, "==", 1, partcv, params);
// compiled op node returning opresult8514 (depth = 6)
  int op_slot_right_8508 = gc_frame_newslot(opresult8514);
// starting to compile call node (depth = 6)
  int callframe8516 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8517 == NULL) {
    strlit8517 = alloc_String("keyword");
    gc_root(strlit8517);
  }
// compiled string node returning strlit8517 (depth = 7)
  gc_frame_newslot(strlit8517);
// call case 4: self request
  params[0] = strlit8517;
  partcv[0] = 1;
  Object call8518 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8516);
// compiled call node returning call8518 (depth = 6)
  int op_slot_left_8508 = gc_frame_newslot(call8518);
  params[0] = opresult8514;
  partcv[0] = 1;
  Object opresult8519 = callmethod(call8518, "&&", 1, partcv, params);
// compiled op node returning opresult8519 (depth = 5)
  params[0] = block8497;
  partcv[0] = 1;
  Object call8520 = callmethod(opresult8519, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8496);
// compiled call node returning call8520 (depth = 4)
  params[0] = block8485;
  partcv[0] = 1;
  Object call8521 = callmethod(call8520, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe8484);
// compiled call node returning call8521 (depth = 3)
  Object if8483 = done;
  if (istrue(call8521)) {
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2665
  setline(2665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8522 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8523 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8522);
// compiled call node returning call8523 (depth = 4)
// compiled member node returning call8523 (depth = 3)
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8524 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8525 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8524);
// compiled call node returning call8525 (depth = 4)
// compiled member node returning call8525 (depth = 3)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2667
  setline(2667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_minIndentLevel (depth = 4)
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8528 == NULL) {
    strlit8528 = alloc_String("identifier");
    gc_root(strlit8528);
  }
// compiled string node returning strlit8528 (depth = 5)
  int op_slot_right_8527 = gc_frame_newslot(strlit8528);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8531 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8530);
// compiled call node returning call8531 (depth = 6)
// compiled member node returning call8531 (depth = 5)
  int op_slot_left_8527 = gc_frame_newslot(call8531);
  params[0] = strlit8528;
  partcv[0] = 1;
  Object opresult8532 = callmethod(call8531, "!=", 1, partcv, params);
// compiled op node returning opresult8532 (depth = 4)
  Object if8526 = done;
  if (istrue(opresult8532)) {
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array8533 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8533 (depth = 5)
  *var_suggestions = array8533;
  if (array8533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8536 == NULL) {
    strlit8536 = alloc_String("lbrace");
    gc_root(strlit8536);
  }
// compiled string node returning strlit8536 (depth = 6)
  int op_slot_right_8535 = gc_frame_newslot(strlit8536);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8539 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8538);
// compiled call node returning call8539 (depth = 7)
// compiled member node returning call8539 (depth = 6)
  int op_slot_left_8535 = gc_frame_newslot(call8539);
  params[0] = strlit8536;
  partcv[0] = 1;
  Object opresult8540 = callmethod(call8539, "==", 1, partcv, params);
// compiled op node returning opresult8540 (depth = 5)
  Object if8534 = done;
  if (istrue(opresult8540)) {
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 2671
  setline(2671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8541 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8542 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8543 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8542);
// compiled call node returning call8543 (depth = 9)
// compiled member node returning call8543 (depth = 8)
  partcv[0] = 0;
  Object call8544 = callmethod(call8543, "new",
    1, partcv, params);
  gc_frame_end(callframe8541);
// compiled call node returning call8544 (depth = 7)
// compiled member node returning call8544 (depth = 6)
  *var_suggestion = call8544;
  if (call8544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8545 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8546 == NULL) {
    strlit8546 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit8546);
  }
// compiled string node returning strlit8546 (depth = 6)
  gc_frame_newslot(strlit8546);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8546;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8547 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8545);
// compiled call node returning call8547 (depth = 5)
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8548 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8549 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8548);
// compiled call node returning call8549 (depth = 5)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8550 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8551 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8552 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8551);
// compiled call node returning call8552 (depth = 9)
// compiled member node returning call8552 (depth = 8)
  partcv[0] = 0;
  Object call8553 = callmethod(call8552, "new",
    1, partcv, params);
  gc_frame_end(callframe8550);
// compiled call node returning call8553 (depth = 7)
// compiled member node returning call8553 (depth = 6)
  *var_suggestion = call8553;
  if (call8553 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 2675
  setline(2675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8555 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit8556 == NULL) {
    strlit8556 = alloc_String("object");
    gc_root(strlit8556);
  }
// compiled string node returning strlit8556 (depth = 6)
  gc_frame_newslot(strlit8556);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit8556;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8557 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8555);
// compiled call node returning call8557 (depth = 5)
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8558 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8559 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8558);
// compiled call node returning call8559 (depth = 5)
    gc_frame_newslot(call8559);
    if8534 = call8559;
  } else {
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8560 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8561 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8562 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8561);
// compiled call node returning call8562 (depth = 9)
// compiled member node returning call8562 (depth = 8)
  partcv[0] = 0;
  Object call8563 = callmethod(call8562, "new",
    1, partcv, params);
  gc_frame_end(callframe8560);
// compiled call node returning call8563 (depth = 7)
// compiled member node returning call8563 (depth = 6)
  *var_suggestion = call8563;
  if (call8563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8564 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8565 == NULL) {
    strlit8565 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb"" {}");
    gc_root(strlit8565);
  }
// compiled string node returning strlit8565 (depth = 6)
  gc_frame_newslot(strlit8565);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8565;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8566 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8564);
// compiled call node returning call8566 (depth = 5)
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8567 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8568 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8567);
// compiled call node returning call8568 (depth = 5)
    gc_frame_newslot(call8568);
    if8534 = call8568;
  }
// compiled if node returning if8534 (depth = 4)
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8569 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8570 == NULL) {
    strlit8570 = alloc_String("A factory method must have a name after the 'method'.");
    gc_root(strlit8570);
  }
// compiled string node returning strlit8570 (depth = 5)
  gc_frame_newslot(strlit8570);
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8572 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8571);
// compiled call node returning call8572 (depth = 6)
// compiled member node returning call8572 (depth = 5)
  gc_frame_newslot(call8572);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8574 = alloc_Float64(1);
// compiled num node returning num8574 (depth = 6)
  int op_slot_right_8573 = gc_frame_newslot(num8574);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8577 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8578 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8577);
// compiled call node returning call8578 (depth = 8)
// compiled member node returning call8578 (depth = 7)
  int op_slot_right_8576 = gc_frame_newslot(call8578);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8580 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8581 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8580);
// compiled call node returning call8581 (depth = 8)
// compiled member node returning call8581 (depth = 7)
  int op_slot_left_8576 = gc_frame_newslot(call8581);
  params[0] = call8578;
  partcv[0] = 1;
  Object sum8582 = callmethod(call8581, "+", 1, partcv, params);
// compiled op node returning sum8582 (depth = 6)
  int op_slot_left_8573 = gc_frame_newslot(sum8582);
  params[0] = num8574;
  partcv[0] = 1;
  Object sum8583 = callmethod(sum8582, "+", 1, partcv, params);
// compiled op node returning sum8583 (depth = 5)
  gc_frame_newslot(sum8583);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2682
  setline(2682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8570;
  params[1] = call8572;
  params[2] = sum8583;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8584 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8569);
// compiled call node returning call8584 (depth = 4)
    gc_frame_newslot(call8584);
    if8526 = call8584;
  } else {
  }
// compiled if node returning if8526 (depth = 3)
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8585 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8586 = alloc_Boolean(0);
// compiled identifier node returning bool8586 (depth = 5)
  gc_frame_newslot(bool8586);
// call case 4: self request
  params[0] = bool8586;
  partcv[0] = 1;
  Object call8587 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8585);
// compiled call node returning call8587 (depth = 4)
  *var_s = call8587;
  if (call8587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8588 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8589 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8588);
// compiled call node returning call8589 (depth = 5)
// compiled member node returning call8589 (depth = 4)
  *var_csig = call8589;
  if (call8589 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8591 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8590);
// compiled call node returning call8591 (depth = 5)
// compiled member node returning call8591 (depth = 4)
  *var_methodName = call8591;
  if (call8591 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8592 = gc_frame_new();
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool8593 = alloc_Boolean(1);
// compiled identifier node returning bool8593 (depth = 5)
  gc_frame_newslot(bool8593);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  params[0] = bool8593;
  partcv[0] = 1;
  Object call8594 = callmethod(*var_methodName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe8592);
// compiled call node returning call8594 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8595 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  partcv[0] = 0;
  Object call8596 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8595);
// compiled call node returning call8596 (depth = 5)
// compiled member node returning call8596 (depth = 4)
  *var_dtype = call8596;
  if (call8596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8597 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8598 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8597);
// compiled call node returning call8598 (depth = 5)
// compiled member node returning call8598 (depth = 4)
  *var_anns = call8598;
  if (call8598 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8600 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe8601 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8602 == NULL) {
    strlit8602 = alloc_String("lbrace");
    gc_root(strlit8602);
  }
// compiled string node returning strlit8602 (depth = 6)
  gc_frame_newslot(strlit8602);
// call case 4: self request
  params[0] = strlit8602;
  partcv[0] = 1;
  Object call8603 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8601);
// compiled call node returning call8603 (depth = 5)
  partcv[0] = 0;
  Object call8604 = callmethod(call8603, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8600);
// compiled call node returning call8604 (depth = 4)
  Object if8599 = done;
  if (istrue(call8604)) {
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8605 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8606 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8607 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8606);
// compiled call node returning call8607 (depth = 8)
// compiled member node returning call8607 (depth = 7)
  partcv[0] = 0;
  Object call8608 = callmethod(call8607, "new",
    1, partcv, params);
  gc_frame_end(callframe8605);
// compiled call node returning call8608 (depth = 6)
// compiled member node returning call8608 (depth = 5)
  *var_suggestion = call8608;
  if (call8608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8609 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8610 == NULL) {
    strlit8610 = alloc_String(" {");
    gc_root(strlit8610);
  }
// compiled string node returning strlit8610 (depth = 5)
  gc_frame_newslot(strlit8610);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit8610;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8611 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8609);
// compiled call node returning call8611 (depth = 4)
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8612 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8613 == NULL) {
    strlit8613 = alloc_String("A factory method must have a '{' after the name.");
    gc_root(strlit8613);
  }
// compiled string node returning strlit8613 (depth = 5)
  gc_frame_newslot(strlit8613);
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8614 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8615 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8614);
// compiled call node returning call8615 (depth = 6)
// compiled member node returning call8615 (depth = 5)
  gc_frame_newslot(call8615);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num8617 = alloc_Float64(1);
// compiled num node returning num8617 (depth = 6)
  int op_slot_right_8616 = gc_frame_newslot(num8617);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8621 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8620);
// compiled call node returning call8621 (depth = 8)
// compiled member node returning call8621 (depth = 7)
  int op_slot_right_8619 = gc_frame_newslot(call8621);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call8624 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8623);
// compiled call node returning call8624 (depth = 8)
// compiled member node returning call8624 (depth = 7)
  int op_slot_left_8619 = gc_frame_newslot(call8624);
  params[0] = call8621;
  partcv[0] = 1;
  Object sum8625 = callmethod(call8624, "+", 1, partcv, params);
// compiled op node returning sum8625 (depth = 6)
  int op_slot_left_8616 = gc_frame_newslot(sum8625);
  params[0] = num8617;
  partcv[0] = 1;
  Object sum8626 = callmethod(sum8625, "+", 1, partcv, params);
// compiled op node returning sum8626 (depth = 5)
  gc_frame_newslot(sum8626);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8613;
  params[1] = call8615;
  params[2] = sum8626;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8627 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8612);
// compiled call node returning call8627 (depth = 4)
    gc_frame_newslot(call8627);
    if8599 = call8627;
  } else {
  }
// compiled if node returning if8599 (depth = 3)
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8628 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8629 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8628);
// compiled call node returning call8629 (depth = 4)
// compiled member node returning call8629 (depth = 3)
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8632 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_statementToken (depth = 7)
  partcv[0] = 0;
  Object call8633 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8632);
// compiled call node returning call8633 (depth = 6)
// compiled member node returning call8633 (depth = 5)
  int op_slot_right_8631 = gc_frame_newslot(call8633);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8635 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8636 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8635);
// compiled call node returning call8636 (depth = 6)
// compiled member node returning call8636 (depth = 5)
  int op_slot_left_8631 = gc_frame_newslot(call8636);
  params[0] = call8633;
  partcv[0] = 1;
  Object opresult8637 = callmethod(call8636, "==", 1, partcv, params);
// compiled op node returning opresult8637 (depth = 4)
  Object if8630 = done;
  if (istrue(opresult8637)) {
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num8639 = alloc_Float64(1);
// compiled num node returning num8639 (depth = 6)
  int op_slot_right_8638 = gc_frame_newslot(num8639);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8642 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8641);
// compiled call node returning call8642 (depth = 7)
// compiled member node returning call8642 (depth = 6)
  int op_slot_left_8638 = gc_frame_newslot(call8642);
  params[0] = num8639;
  partcv[0] = 1;
  Object diff8643 = callmethod(call8642, "-", 1, partcv, params);
// compiled op node returning diff8643 (depth = 5)
  *var_minIndentLevel = diff8643;
  if (diff8643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8630 = done;
  } else {
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num8646 = alloc_Float64(1);
// compiled num node returning num8646 (depth = 6)
  int op_slot_right_8645 = gc_frame_newslot(num8646);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8648 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_statementToken (depth = 8)
  partcv[0] = 0;
  Object call8649 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8648);
// compiled call node returning call8649 (depth = 7)
// compiled member node returning call8649 (depth = 6)
  int op_slot_left_8645 = gc_frame_newslot(call8649);
  params[0] = num8646;
  partcv[0] = 1;
  Object sum8650 = callmethod(call8649, "+", 1, partcv, params);
// compiled op node returning sum8650 (depth = 5)
  *var_minIndentLevel = sum8650;
  if (sum8650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8630 = done;
  }
// compiled if node returning if8630 (depth = 3)
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array8652 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8652 (depth = 4)
  *var_body = array8652;
  if (array8652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8653 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block8654 = alloc_Block(NULL, NULL, "parser", 2704);
  gc_frame_newslot(block8654);
// method _apply
  block_savedest(block8654);
  Object closure8655 = createclosure(1, "_apply");
  setclosureframe(closure8655, stackframe);
  addtoclosure(closure8655, selfslot);
  struct UserObject *uo8655 = (struct UserObject*)block8654;
  uo8655->data[0] = (Object)closure8655;
  Method *meth_meth_parser__apply8655 = addmethod2pos(block8654, "_apply", &meth_parser__apply8655, 0);
  int argcv_meth_parser__apply8655[] = {0};
  meth_meth_parser__apply8655->type = alloc_MethodType(1, argcv_meth_parser__apply8655);
  meth_meth_parser__apply8655->definitionModule = modulename;
  meth_meth_parser__apply8655->definitionLine = 2701;
// compiled block node returning block8654 (depth = 4)
  gc_frame_newslot(block8654);
// starting to compile block node (depth = 4)
  Object block8662 = alloc_Block(NULL, NULL, "parser", 2704);
  gc_frame_newslot(block8662);
// method _apply
  block_savedest(block8662);
  Object closure8663 = createclosure(3, "_apply");
  setclosureframe(closure8663, stackframe);
  addtoclosure(closure8663, var_values);
  addtoclosure(closure8663, var_body);
  addtoclosure(closure8663, selfslot);
  struct UserObject *uo8663 = (struct UserObject*)block8662;
  uo8663->data[0] = (Object)closure8663;
  Method *meth_meth_parser__apply8663 = addmethod2pos(block8662, "_apply", &meth_parser__apply8663, 0);
  int argcv_meth_parser__apply8663[] = {0};
  meth_meth_parser__apply8663->type = alloc_MethodType(1, argcv_meth_parser__apply8663);
  meth_meth_parser__apply8663->definitionModule = modulename;
  meth_meth_parser__apply8663->definitionLine = 2704;
// compiled block node returning block8662 (depth = 4)
  gc_frame_newslot(block8662);
// call case 5: prelude request
  params[0] = block8654;
  params[1] = block8662;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8707 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8653);
// compiled call node returning call8707 (depth = 3)
// Begin line 2715
  setline(2715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8708 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8709 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8708);
// compiled call node returning call8709 (depth = 4)
// compiled member node returning call8709 (depth = 3)
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8710 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8711 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8712 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8711);
// compiled call node returning call8712 (depth = 5)
// compiled member node returning call8712 (depth = 4)
  gc_frame_newslot(call8712);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8712;
  partcv[0] = 1;
  Object call8713 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8710);
// compiled call node returning call8713 (depth = 3)
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8714 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
  Object bool8715 = alloc_Boolean(0);
// compiled identifier node returning bool8715 (depth = 5)
  gc_frame_newslot(bool8715);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8717 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8716);
// compiled call node returning call8717 (depth = 6)
// compiled member node returning call8717 (depth = 5)
  params[0] = *var_body;
  params[1] = bool8715;
  partcv[0] = 2;
  Object call8718 = callmethod(call8717, "new",
    1, partcv, params);
  gc_frame_end(callframe8714);
// compiled call node returning call8718 (depth = 4)
  *var_obj = call8718;
  if (call8718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8719 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_methodName (depth = 5)
  gc_frame_newslot(*var_methodName);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_csig (depth = 5)
  gc_frame_newslot(*var_csig);
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8720 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_obj (depth = 6)
  gc_frame_newslot(*var_obj);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8721 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_collections (depth = 8)
  partcv[0] = 0;
  Object call8722 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe8721);
// compiled call node returning call8722 (depth = 7)
// compiled member node returning call8722 (depth = 6)
  params[0] = *var_obj;
  partcv[0] = 1;
  Object call8723 = callmethod(call8722, "new",
    1, partcv, params);
  gc_frame_end(callframe8720);
// compiled call node returning call8723 (depth = 5)
  gc_frame_newslot(call8723);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8725 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8724);
// compiled call node returning call8725 (depth = 6)
// compiled member node returning call8725 (depth = 5)
  params[0] = *var_methodName;
  params[1] = *var_csig;
  params[2] = call8723;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8726 = callmethod(call8725, "new",
    1, partcv, params);
  gc_frame_end(callframe8719);
// compiled call node returning call8726 (depth = 4)
  *var_meth = call8726;
  if (call8726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8727 = gc_frame_new();
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8728 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  partcv[0] = 0;
  Object call8729 = callmethod(*var_s, "generics",
    1, partcv, params);
  gc_frame_end(callframe8728);
// compiled call node returning call8729 (depth = 6)
// compiled member node returning call8729 (depth = 5)
  gc_frame_newslot(call8729);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = call8729;
  partcv[0] = 1;
  Object call8730 = callmethod(*var_meth, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8727);
// compiled call node returning call8730 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_8732 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool8734 = alloc_Boolean(0);
// compiled identifier node returning bool8734 (depth = 5)
  int op_slot_left_8732 = gc_frame_newslot(bool8734);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8735 = callmethod(bool8734, "!=", 1, partcv, params);
// compiled op node returning opresult8735 (depth = 4)
  Object if8731 = done;
  if (istrue(opresult8735)) {
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8736 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8737 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meth (depth = 7)
  partcv[0] = 0;
  Object call8738 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8737);
// compiled call node returning call8738 (depth = 6)
// compiled member node returning call8738 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8739 = callmethod(call8738, "extend",
    1, partcv, params);
  gc_frame_end(callframe8736);
// compiled call node returning call8739 (depth = 4)
    gc_frame_newslot(call8739);
    if8731 = call8739;
  } else {
// Begin line 2728
  setline(2728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8742 == NULL) {
    strlit8742 = alloc_String("confidential");
    gc_root(strlit8742);
  }
// compiled string node returning strlit8742 (depth = 6)
  int op_slot_right_8741 = gc_frame_newslot(strlit8742);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 6)
  int op_slot_left_8741 = gc_frame_newslot(*var_defaultMethodVisibility);
  params[0] = strlit8742;
  partcv[0] = 1;
  Object opresult8744 = callmethod(*var_defaultMethodVisibility, "==", 1, partcv, params);
// compiled op node returning opresult8744 (depth = 5)
  Object if8740 = done;
  if (istrue(opresult8744)) {
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8745 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe8746 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8747 == NULL) {
    strlit8747 = alloc_String("confidential");
    gc_root(strlit8747);
  }
// compiled string node returning strlit8747 (depth = 7)
  gc_frame_newslot(strlit8747);
// Begin line 2726
  setline(2726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool8748 = alloc_Boolean(0);
// compiled identifier node returning bool8748 (depth = 7)
  gc_frame_newslot(bool8748);
// call case 6: other member request
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call8750 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8749);
// compiled call node returning call8750 (depth = 8)
// compiled member node returning call8750 (depth = 7)
  params[0] = strlit8747;
  params[1] = bool8748;
  partcv[0] = 2;
  Object call8751 = callmethod(call8750, "new",
    1, partcv, params);
  gc_frame_end(callframe8746);
// compiled call node returning call8751 (depth = 6)
  gc_frame_newslot(call8751);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8752 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call8753 = callmethod(*var_meth, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8752);
// compiled call node returning call8753 (depth = 7)
// compiled member node returning call8753 (depth = 6)
  params[0] = call8751;
  partcv[0] = 1;
  Object call8754 = callmethod(call8753, "push",
    1, partcv, params);
  gc_frame_end(callframe8745);
// compiled call node returning call8754 (depth = 5)
    gc_frame_newslot(call8754);
    if8740 = call8754;
  } else {
  }
// compiled if node returning if8740 (depth = 4)
    gc_frame_newslot(if8740);
    if8731 = if8740;
  }
// compiled if node returning if8731 (depth = 3)
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8755 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  gc_frame_newslot(*var_meth);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call8756 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8755);
// compiled call node returning call8756 (depth = 3)
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_localMinIndentLevel (depth = 4)
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if8483 = done;
  } else {
  }
// compiled if node returning if8483 (depth = 2)
  gc_frame_end(frame);
  return if8483;
}
Object meth_parser__apply8836(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit8838 == NULL) {
    strlit8838 = alloc_String("lbrace");
    gc_root(strlit8838);
  }
// compiled string node returning strlit8838 (depth = 7)
  int op_slot_right_8837 = gc_frame_newslot(strlit8838);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8840 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  partcv[0] = 0;
  Object call8841 = callmethod(*var_s, "kind",
    1, partcv, params);
  gc_frame_end(callframe8840);
// compiled call node returning call8841 (depth = 8)
// compiled member node returning call8841 (depth = 7)
  int op_slot_left_8837 = gc_frame_newslot(call8841);
  params[0] = strlit8838;
  partcv[0] = 1;
  Object opresult8842 = callmethod(call8841, "!=", 1, partcv, params);
// compiled op node returning opresult8842 (depth = 6)
  gc_frame_end(frame);
  return opresult8842;
}
Object meth_parser__apply8845(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2769
  setline(2769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8846 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_body (depth = 7)
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8847 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8846);
// compiled call node returning call8847 (depth = 6)
// Begin line 2770
  setline(2770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8849 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8848);
// compiled call node returning call8849 (depth = 7)
// compiled member node returning call8849 (depth = 6)
// Begin line 2772
  setline(2772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2771
  setline(2771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call8851 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8850);
// compiled call node returning call8851 (depth = 8)
// compiled member node returning call8851 (depth = 7)
  *var_s = call8851;
  if (call8851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_methoddec8758(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methoddec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for methoddec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_stok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "stok");
  Object *var_m = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "m");
  Object *var_meth = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "meth");
  Object *var_signature = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "signature");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_varargs = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "varargs");
  Object *var_generics = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "generics");
  Object *var_body = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "body");
  Object *var_localMin = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "localMin");
  Object *var_anns = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "anns");
  Object *var_s = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "s");
  Object *var_suggestion = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
  Object *var_o = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "o");
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit8762 == NULL) {
    strlit8762 = alloc_String("method");
    gc_root(strlit8762);
  }
// compiled string node returning strlit8762 (depth = 5)
  int op_slot_right_8761 = gc_frame_newslot(strlit8762);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8764 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call8765 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8764);
// compiled call node returning call8765 (depth = 6)
// compiled member node returning call8765 (depth = 5)
  int op_slot_left_8761 = gc_frame_newslot(call8765);
  params[0] = strlit8762;
  partcv[0] = 1;
  Object opresult8766 = callmethod(call8765, "==", 1, partcv, params);
// compiled op node returning opresult8766 (depth = 4)
  int op_slot_right_8760 = gc_frame_newslot(opresult8766);
// starting to compile call node (depth = 4)
  int callframe8768 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8769 == NULL) {
    strlit8769 = alloc_String("keyword");
    gc_root(strlit8769);
  }
// compiled string node returning strlit8769 (depth = 5)
  gc_frame_newslot(strlit8769);
// call case 4: self request
  params[0] = strlit8769;
  partcv[0] = 1;
  Object call8770 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8768);
// compiled call node returning call8770 (depth = 4)
  int op_slot_left_8760 = gc_frame_newslot(call8770);
  params[0] = opresult8766;
  partcv[0] = 1;
  Object opresult8771 = callmethod(call8770, "&&", 1, partcv, params);
// compiled op node returning opresult8771 (depth = 3)
  Object if8759 = done;
  if (istrue(opresult8771)) {
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8772 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8773 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8772);
// compiled call node returning call8773 (depth = 4)
// compiled member node returning call8773 (depth = 3)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_stok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8775 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8776 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8775);
// compiled call node returning call8776 (depth = 4)
// compiled member node returning call8776 (depth = 3)
// Begin line 2742
  setline(2742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8777 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool8778 = alloc_Boolean(0);
// compiled identifier node returning bool8778 (depth = 5)
  gc_frame_newslot(bool8778);
// call case 4: self request
  params[0] = bool8778;
  partcv[0] = 1;
  Object call8779 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8777);
// compiled call node returning call8779 (depth = 4)
  *var_m = call8779;
  if (call8779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8780 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8781 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe8780);
// compiled call node returning call8781 (depth = 5)
// compiled member node returning call8781 (depth = 4)
  *var_meth = call8781;
  if (call8781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8782 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8783 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe8782);
// compiled call node returning call8783 (depth = 5)
// compiled member node returning call8783 (depth = 4)
  *var_signature = call8783;
  if (call8783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2745
  setline(2745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8784 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8785 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8784);
// compiled call node returning call8785 (depth = 5)
// compiled member node returning call8785 (depth = 4)
  *var_dtype = call8785;
  if (call8785 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8787 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe8786);
// compiled call node returning call8787 (depth = 5)
// compiled member node returning call8787 (depth = 4)
  *var_varargs = call8787;
  if (call8787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call8789 = callmethod(*var_m, "generics",
    1, partcv, params);
  gc_frame_end(callframe8788);
// compiled call node returning call8789 (depth = 5)
// compiled member node returning call8789 (depth = 4)
  *var_generics = call8789;
  if (call8789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2748
  setline(2748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array8790 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array8790 (depth = 4)
  *var_body = array8790;
  if (array8790 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_localMin = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8791 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8792 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8791);
// compiled call node returning call8792 (depth = 5)
// compiled member node returning call8792 (depth = 4)
  *var_anns = call8792;
  if (call8792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2751
  setline(2751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8794 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8795 == NULL) {
    strlit8795 = alloc_String("lbrace");
    gc_root(strlit8795);
  }
// compiled string node returning strlit8795 (depth = 5)
  gc_frame_newslot(strlit8795);
// call case 4: self request
  params[0] = strlit8795;
  partcv[0] = 1;
  Object call8796 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8794);
// compiled call node returning call8796 (depth = 4)
  Object if8793 = done;
  if (istrue(call8796)) {
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8797 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8798 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8797);
// compiled call node returning call8798 (depth = 5)
// compiled member node returning call8798 (depth = 4)
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_minIndentLevel (depth = 5)
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8802 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_stok (depth = 8)
  partcv[0] = 0;
  Object call8803 = callmethod(*var_stok, "line",
    1, partcv, params);
  gc_frame_end(callframe8802);
// compiled call node returning call8803 (depth = 7)
// compiled member node returning call8803 (depth = 6)
  int op_slot_right_8801 = gc_frame_newslot(call8803);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8805 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8806 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8805);
// compiled call node returning call8806 (depth = 7)
// compiled member node returning call8806 (depth = 6)
  int op_slot_left_8801 = gc_frame_newslot(call8806);
  params[0] = call8803;
  partcv[0] = 1;
  Object opresult8807 = callmethod(call8806, "==", 1, partcv, params);
// compiled op node returning opresult8807 (depth = 5)
  Object if8800 = done;
  if (istrue(opresult8807)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num8809 = alloc_Float64(1);
// compiled num node returning num8809 (depth = 7)
  int op_slot_right_8808 = gc_frame_newslot(num8809);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8811 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call8812 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8811);
// compiled call node returning call8812 (depth = 8)
// compiled member node returning call8812 (depth = 7)
  int op_slot_left_8808 = gc_frame_newslot(call8812);
  params[0] = num8809;
  partcv[0] = 1;
  Object diff8813 = callmethod(call8812, "-", 1, partcv, params);
// compiled op node returning diff8813 (depth = 6)
  *var_minIndentLevel = diff8813;
  if (diff8813 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8800 = done;
  } else {
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num8816 = alloc_Float64(1);
// compiled num node returning num8816 (depth = 7)
  int op_slot_right_8815 = gc_frame_newslot(num8816);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8818 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_stok (depth = 9)
  partcv[0] = 0;
  Object call8819 = callmethod(*var_stok, "indent",
    1, partcv, params);
  gc_frame_end(callframe8818);
// compiled call node returning call8819 (depth = 8)
// compiled member node returning call8819 (depth = 7)
  int op_slot_left_8815 = gc_frame_newslot(call8819);
  params[0] = num8816;
  partcv[0] = 1;
  Object sum8820 = callmethod(call8819, "+", 1, partcv, params);
// compiled op node returning sum8820 (depth = 6)
  *var_minIndentLevel = sum8820;
  if (sum8820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if8800 = done;
  }
// compiled if node returning if8800 (depth = 4)
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8822 = gc_frame_new();
// starting to compile object node (depth = 5)
  Object inheritingObject8823 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8823 = alloc_userobj2(4,4, objclass8823);
  gc_frame_newslot(obj8823);
// OBJECT OUTER DEC outer
  adddatum2(obj8823, self, 0);
  addmethodreal(obj8823,"outer", &reader_parser_outer_8824);
  Object oldself8823 = self;
  struct StackFrameObject *oldstackframe8823 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8823);
  gc_frame_newslot((Object)stackframe);
  self = obj8823;
  Object *oldselfslot8823 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8823 = (*(struct UserObject *)self).data[0], lowerouter8823 = thisouter8823;
  if (inheritingObject8823) {
    struct UserObject *inho8823 = (struct UserObject *)inheritingObject8823;
    while (inho8823->super != GraceDefaultObject) inho8823 = (struct UserObject *)inho8823->super;
    inho8823->super = obj8823;
    self = inheritingObject8823;
    *selfslot = self;
    lowerouter8823 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8823;
  }
if (objclass8823 == NULL) {
  Method *reader8825 = addmethodrealflags(obj8823, "kind",&reader_parser_kind_8825, 0);
  Method *writer8825 = addmethodrealflags(obj8823, "kind:=",&writer_parser_kind_8825, 0);
  reader8825->definitionModule = modulename;
  writer8825->definitionModule = modulename;
  reader8825->definitionLine = 2761;
  writer8825->definitionLine = 2761;
}
obj8823->flags |= OFLAG_MUTABLE;
adddatum2(obj8823, alloc_Undefined(), 1);
if (objclass8823 == NULL) {
  Method *reader8826 = addmethodrealflags(obj8823, "register",&reader_parser_register_8826, 0);
  Method *writer8826 = addmethodrealflags(obj8823, "register:=",&writer_parser_register_8826, 0);
  reader8826->definitionModule = modulename;
  writer8826->definitionModule = modulename;
  reader8826->definitionLine = 2762;
  writer8826->definitionLine = 2762;
}
obj8823->flags |= OFLAG_MUTABLE;
adddatum2(obj8823, alloc_Undefined(), 2);
  sourceObject = obj8823;
// Begin line 2760
  setline(2760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8827 == NULL) {
    strlit8827 = alloc_String("lbrace");
    gc_root(strlit8827);
  }
// compiled string node returning strlit8827 (depth = 6)
  adddatum2(obj8823, strlit8827, 1);
  sourceObject = obj8823;
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit8828 == NULL) {
    strlit8828 = alloc_String("");
    gc_root(strlit8828);
  }
// compiled string node returning strlit8828 (depth = 6)
  adddatum2(obj8823, strlit8828, 2);
objclass8823 = obj8823->class;
  objclass8823->definitionModule = modulename;
  objclass8823->definitionLine = 2759;
  (*(struct UserObject *)self).data[0] = lowerouter8823;
  self = oldself8823;
  selfslot = oldselfslot8823;
  stackframe = oldstackframe8823;
// compiled object node returning obj8823 (depth = 5)
  gc_frame_newslot(obj8823);
// call case 6: other member request
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  params[0] = obj8823;
  partcv[0] = 1;
  Object call8829 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8822);
// compiled call node returning call8829 (depth = 4)
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8830 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8831 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8830);
// compiled call node returning call8831 (depth = 5)
// compiled member node returning call8831 (depth = 4)
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2764
  setline(2764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8832 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call8833 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8832);
// compiled call node returning call8833 (depth = 6)
// compiled member node returning call8833 (depth = 5)
  *var_s = call8833;
  if (call8833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8834 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block8835 = alloc_Block(NULL, NULL, "parser", 2765);
  gc_frame_newslot(block8835);
// method _apply
  block_savedest(block8835);
  Object closure8836 = createclosure(2, "_apply");
  setclosureframe(closure8836, stackframe);
  addtoclosure(closure8836, var_s);
  addtoclosure(closure8836, selfslot);
  struct UserObject *uo8836 = (struct UserObject*)block8835;
  uo8836->data[0] = (Object)closure8836;
  Method *meth_meth_parser__apply8836 = addmethod2pos(block8835, "_apply", &meth_parser__apply8836, 0);
  int argcv_meth_parser__apply8836[] = {0};
  meth_meth_parser__apply8836->type = alloc_MethodType(1, argcv_meth_parser__apply8836);
  meth_meth_parser__apply8836->definitionModule = modulename;
  meth_meth_parser__apply8836->definitionLine = 2764;
// compiled block node returning block8835 (depth = 5)
  gc_frame_newslot(block8835);
// starting to compile block node (depth = 5)
  Object block8844 = alloc_Block(NULL, NULL, "parser", 2765);
  gc_frame_newslot(block8844);
// method _apply
  block_savedest(block8844);
  Object closure8845 = createclosure(4, "_apply");
  setclosureframe(closure8845, stackframe);
  addtoclosure(closure8845, var_s);
  addtoclosure(closure8845, var_body);
  addtoclosure(closure8845, var_values);
  addtoclosure(closure8845, selfslot);
  struct UserObject *uo8845 = (struct UserObject*)block8844;
  uo8845->data[0] = (Object)closure8845;
  Method *meth_meth_parser__apply8845 = addmethod2pos(block8844, "_apply", &meth_parser__apply8845, 0);
  int argcv_meth_parser__apply8845[] = {0};
  meth_meth_parser__apply8845->type = alloc_MethodType(1, argcv_meth_parser__apply8845);
  meth_meth_parser__apply8845->definitionModule = modulename;
  meth_meth_parser__apply8845->definitionLine = 2765;
// compiled block node returning block8844 (depth = 5)
  gc_frame_newslot(block8844);
// call case 5: prelude request
  params[0] = block8835;
  params[1] = block8844;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8854 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8834);
// compiled call node returning call8854 (depth = 4)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2773
  setline(2773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit8857 == NULL) {
    strlit8857 = alloc_String("rbrace");
    gc_root(strlit8857);
  }
// compiled string node returning strlit8857 (depth = 6)
  int op_slot_right_8856 = gc_frame_newslot(strlit8857);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8859 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8860 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8859);
// compiled call node returning call8860 (depth = 7)
// compiled member node returning call8860 (depth = 6)
  int op_slot_left_8856 = gc_frame_newslot(call8860);
  params[0] = strlit8857;
  partcv[0] = 1;
  Object opresult8861 = callmethod(call8860, "!=", 1, partcv, params);
// compiled op node returning opresult8861 (depth = 5)
  Object if8855 = done;
  if (istrue(opresult8861)) {
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2774
  setline(2774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8862 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8863 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call8864 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8863);
// compiled call node returning call8864 (depth = 9)
// compiled member node returning call8864 (depth = 8)
  partcv[0] = 0;
  Object call8865 = callmethod(call8864, "new",
    1, partcv, params);
  gc_frame_end(callframe8862);
// compiled call node returning call8865 (depth = 7)
// compiled member node returning call8865 (depth = 6)
  *var_suggestion = call8865;
  if (call8865 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8866 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_btok (depth = 7)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 7)
  Object bool8867 = alloc_Boolean(0);
// compiled identifier node returning bool8867 (depth = 7)
  gc_frame_newslot(bool8867);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8867;
  partcv[0] = 2;
  Object call8868 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8866);
// compiled call node returning call8868 (depth = 6)
  *var_closingBrace = call8868;
  if (call8868 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool8871 = alloc_Boolean(0);
// compiled identifier node returning bool8871 (depth = 7)
  int op_slot_right_8870 = gc_frame_newslot(bool8871);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8873 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8874 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8873);
// compiled call node returning call8874 (depth = 8)
// compiled member node returning call8874 (depth = 7)
  int op_slot_left_8870 = gc_frame_newslot(call8874);
  params[0] = bool8871;
  partcv[0] = 1;
  Object opresult8875 = callmethod(call8874, "==", 1, partcv, params);
// compiled op node returning opresult8875 (depth = 6)
  Object if8869 = done;
  if (istrue(opresult8875)) {
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_8877 = gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_closingBrace (depth = 10)
  partcv[0] = 0;
  Object call8880 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8879);
// compiled call node returning call8880 (depth = 9)
// compiled member node returning call8880 (depth = 8)
  int op_slot_left_8877 = gc_frame_newslot(call8880);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8881 = callmethod(call8880, "==", 1, partcv, params);
// compiled op node returning opresult8881 (depth = 7)
  Object if8876 = done;
  if (istrue(opresult8881)) {
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8882 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit8883 == NULL) {
    strlit8883 = alloc_String("}");
    gc_root(strlit8883);
  }
// compiled string node returning strlit8883 (depth = 8)
  gc_frame_newslot(strlit8883);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit8883;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8884 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8882);
// compiled call node returning call8884 (depth = 7)
    gc_frame_newslot(call8884);
    if8876 = call8884;
  } else {
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe8885 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num8887 = alloc_Float64(0.1);
// compiled num node returning num8887 (depth = 9)
  int op_slot_right_8886 = gc_frame_newslot(num8887);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe8889 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe8890 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_closingBrace (depth = 13)
  partcv[0] = 0;
  Object call8891 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8890);
// compiled call node returning call8891 (depth = 12)
// compiled member node returning call8891 (depth = 11)
  partcv[0] = 0;
  Object call8892 = callmethod(call8891, "line",
    1, partcv, params);
  gc_frame_end(callframe8889);
// compiled call node returning call8892 (depth = 10)
// compiled member node returning call8892 (depth = 9)
  int op_slot_left_8886 = gc_frame_newslot(call8892);
  params[0] = num8887;
  partcv[0] = 1;
  Object sum8893 = callmethod(call8892, "+", 1, partcv, params);
// compiled op node returning sum8893 (depth = 8)
  gc_frame_newslot(sum8893);
// starting to compile string node (depth = 8)
  if (strlit8894 == NULL) {
    strlit8894 = alloc_String("}");
    gc_root(strlit8894);
  }
// compiled string node returning strlit8894 (depth = 8)
  gc_frame_newslot(strlit8894);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = sum8893;
  params[1] = strlit8894;
  partcv[0] = 2;
  Object call8895 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8885);
// compiled call node returning call8895 (depth = 7)
    gc_frame_newslot(call8895);
    if8876 = call8895;
  }
// compiled if node returning if8876 (depth = 6)
    gc_frame_newslot(if8876);
    if8869 = if8876;
  } else {
  }
// compiled if node returning if8869 (depth = 5)
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8896 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8897 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8896);
// compiled call node returning call8897 (depth = 5)
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8898 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8899 == NULL) {
    strlit8899 = alloc_String("A method must end with a '}'.");
    gc_root(strlit8899);
  }
// compiled string node returning strlit8899 (depth = 6)
  gc_frame_newslot(strlit8899);
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8901 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8900);
// compiled call node returning call8901 (depth = 7)
// compiled member node returning call8901 (depth = 6)
  gc_frame_newslot(call8901);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8902 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call8903 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8902);
// compiled call node returning call8903 (depth = 7)
// compiled member node returning call8903 (depth = 6)
  gc_frame_newslot(call8903);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit8899;
  params[1] = call8901;
  params[2] = call8903;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8904 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8898);
// compiled call node returning call8904 (depth = 5)
    gc_frame_newslot(call8904);
    if8855 = call8904;
  } else {
  }
// compiled if node returning if8855 (depth = 4)
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8905 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call8906 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8905);
// compiled call node returning call8906 (depth = 5)
// compiled member node returning call8906 (depth = 4)
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_localMin (depth = 5)
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8793 = done;
  } else {
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8908 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call8910 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8909);
// compiled call node returning call8910 (depth = 8)
// compiled member node returning call8910 (depth = 7)
  partcv[0] = 0;
  Object call8911 = callmethod(call8910, "new",
    1, partcv, params);
  gc_frame_end(callframe8908);
// compiled call node returning call8911 (depth = 6)
// compiled member node returning call8911 (depth = 5)
  *var_suggestion = call8911;
  if (call8911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8912 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  gc_frame_newslot(*var_btok);
// starting to compile identifier node (depth = 6)
  Object bool8913 = alloc_Boolean(1);
// compiled identifier node returning bool8913 (depth = 6)
  gc_frame_newslot(bool8913);
// call case 4: self request
  params[0] = *var_btok;
  params[1] = bool8913;
  partcv[0] = 2;
  Object call8914 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8912);
// compiled call node returning call8914 (depth = 5)
  *var_closingBrace = call8914;
  if (call8914 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2792
  setline(2792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool8917 = alloc_Boolean(0);
// compiled identifier node returning bool8917 (depth = 6)
  int op_slot_right_8916 = gc_frame_newslot(bool8917);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_closingBrace (depth = 8)
  partcv[0] = 0;
  Object call8920 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8919);
// compiled call node returning call8920 (depth = 7)
// compiled member node returning call8920 (depth = 6)
  int op_slot_left_8916 = gc_frame_newslot(call8920);
  params[0] = bool8917;
  partcv[0] = 1;
  Object opresult8921 = callmethod(call8920, "==", 1, partcv, params);
// compiled op node returning opresult8921 (depth = 5)
  Object if8915 = done;
  if (istrue(opresult8921)) {
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  int op_slot_right_8923 = gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe8925 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_closingBrace (depth = 9)
  partcv[0] = 0;
  Object call8926 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8925);
// compiled call node returning call8926 (depth = 8)
// compiled member node returning call8926 (depth = 7)
  int op_slot_left_8923 = gc_frame_newslot(call8926);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult8927 = callmethod(call8926, "==", 1, partcv, params);
// compiled op node returning opresult8927 (depth = 6)
  Object if8922 = done;
  if (istrue(opresult8927)) {
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8928 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8929 == NULL) {
    strlit8929 = alloc_String(" {}");
    gc_root(strlit8929);
  }
// compiled string node returning strlit8929 (depth = 7)
  gc_frame_newslot(strlit8929);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8930 = alloc_Boolean(1);
// compiled identifier node returning bool8930 (depth = 7)
  gc_frame_newslot(bool8930);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8929;
  params[1] = *var_lastToken;
  params[2] = bool8930;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8931 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8928);
// compiled call node returning call8931 (depth = 6)
    gc_frame_newslot(call8931);
    if8922 = call8931;
  } else {
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8932 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num8934 = alloc_Float64(0.1);
// compiled num node returning num8934 (depth = 8)
  int op_slot_right_8933 = gc_frame_newslot(num8934);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe8936 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe8937 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_closingBrace (depth = 12)
  partcv[0] = 0;
  Object call8938 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8937);
// compiled call node returning call8938 (depth = 11)
// compiled member node returning call8938 (depth = 10)
  partcv[0] = 0;
  Object call8939 = callmethod(call8938, "line",
    1, partcv, params);
  gc_frame_end(callframe8936);
// compiled call node returning call8939 (depth = 9)
// compiled member node returning call8939 (depth = 8)
  int op_slot_left_8933 = gc_frame_newslot(call8939);
  params[0] = num8934;
  partcv[0] = 1;
  Object sum8940 = callmethod(call8939, "+", 1, partcv, params);
// compiled op node returning sum8940 (depth = 7)
  gc_frame_newslot(sum8940);
// starting to compile string node (depth = 7)
  if (strlit8941 == NULL) {
    strlit8941 = alloc_String("}");
    gc_root(strlit8941);
  }
// compiled string node returning strlit8941 (depth = 7)
  gc_frame_newslot(strlit8941);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = sum8940;
  params[1] = strlit8941;
  partcv[0] = 2;
  Object call8942 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8932);
// compiled call node returning call8942 (depth = 6)
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe8943 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit8944 == NULL) {
    strlit8944 = alloc_String(" {");
    gc_root(strlit8944);
  }
// compiled string node returning strlit8944 (depth = 7)
  gc_frame_newslot(strlit8944);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 7)
  Object bool8945 = alloc_Boolean(1);
// compiled identifier node returning bool8945 (depth = 7)
  gc_frame_newslot(bool8945);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit8944;
  params[1] = *var_lastToken;
  params[2] = bool8945;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8946 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8943);
// compiled call node returning call8946 (depth = 6)
    gc_frame_newslot(call8946);
    if8922 = call8946;
  }
// compiled if node returning if8922 (depth = 5)
    gc_frame_newslot(if8922);
    if8915 = if8922;
  } else {
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8947 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit8948 == NULL) {
    strlit8948 = alloc_String(" {");
    gc_root(strlit8948);
  }
// compiled string node returning strlit8948 (depth = 6)
  gc_frame_newslot(strlit8948);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 6)
  Object bool8949 = alloc_Boolean(1);
// compiled identifier node returning bool8949 (depth = 6)
  gc_frame_newslot(bool8949);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit8948;
  params[1] = *var_lastToken;
  params[2] = bool8949;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8950 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8947);
// compiled call node returning call8950 (depth = 5)
    gc_frame_newslot(call8950);
    if8915 = call8950;
  }
// compiled if node returning if8915 (depth = 4)
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8951 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit8952 == NULL) {
    strlit8952 = alloc_String("A method must have a '{' after the name.");
    gc_root(strlit8952);
  }
// compiled string node returning strlit8952 (depth = 5)
  gc_frame_newslot(strlit8952);
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8953 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call8954 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8953);
// compiled call node returning call8954 (depth = 6)
// compiled member node returning call8954 (depth = 5)
  gc_frame_newslot(call8954);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8957 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8956);
// compiled call node returning call8957 (depth = 7)
// compiled member node returning call8957 (depth = 6)
  int op_slot_right_8955 = gc_frame_newslot(call8957);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe8959 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call8960 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8959);
// compiled call node returning call8960 (depth = 7)
// compiled member node returning call8960 (depth = 6)
  int op_slot_left_8955 = gc_frame_newslot(call8960);
  params[0] = call8957;
  partcv[0] = 1;
  Object sum8961 = callmethod(call8960, "+", 1, partcv, params);
// compiled op node returning sum8961 (depth = 5)
  gc_frame_newslot(sum8961);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit8952;
  params[1] = call8954;
  params[2] = sum8961;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8962 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8951);
// compiled call node returning call8962 (depth = 4)
    gc_frame_newslot(call8962);
    if8793 = call8962;
  }
// compiled if node returning if8793 (depth = 3)
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8963 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe8964 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_btok (depth = 6)
  partcv[0] = 0;
  Object call8965 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8964);
// compiled call node returning call8965 (depth = 5)
// compiled member node returning call8965 (depth = 4)
  gc_frame_newslot(call8965);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = call8965;
  partcv[0] = 1;
  Object call8966 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8963);
// compiled call node returning call8966 (depth = 3)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8967 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_body (depth = 5)
  gc_frame_newslot(*var_body);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8968 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call8969 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8968);
// compiled call node returning call8969 (depth = 6)
// compiled member node returning call8969 (depth = 5)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8970 = callmethod(call8969, "new",
    1, partcv, params);
  gc_frame_end(callframe8967);
// compiled call node returning call8970 (depth = 4)
  *var_o = call8970;
  if (call8970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_varargs (depth = 4)
  Object if8971 = done;
  if (istrue(*var_varargs)) {
// Begin line 2809
  setline(2809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe8972 = gc_frame_new();
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool8973 = alloc_Boolean(1);
// compiled identifier node returning bool8973 (depth = 6)
  gc_frame_newslot(bool8973);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  params[0] = bool8973;
  partcv[0] = 1;
  Object call8974 = callmethod(*var_o, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe8972);
// compiled call node returning call8974 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if8971 = done;
  } else {
  }
// compiled if node returning if8971 (depth = 3)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe8975 = gc_frame_new();
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_generics (depth = 5)
  gc_frame_newslot(*var_generics);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_o (depth = 5)
  params[0] = *var_generics;
  partcv[0] = 1;
  Object call8976 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8975);
// compiled call node returning call8976 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool8979 = alloc_Boolean(0);
// compiled identifier node returning bool8979 (depth = 5)
  int op_slot_right_8978 = gc_frame_newslot(bool8979);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_8978 = gc_frame_newslot(*var_anns);
  params[0] = bool8979;
  partcv[0] = 1;
  Object opresult8981 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult8981 (depth = 4)
  Object if8977 = done;
  if (istrue(opresult8981)) {
// starting to compile call node (depth = 4)
  int callframe8982 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call8984 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8983);
// compiled call node returning call8984 (depth = 6)
// compiled member node returning call8984 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8985 = callmethod(call8984, "extend",
    1, partcv, params);
  gc_frame_end(callframe8982);
// compiled call node returning call8985 (depth = 4)
    gc_frame_newslot(call8985);
    if8977 = call8985;
  } else {
  }
// compiled if node returning if8977 (depth = 3)
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8986 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 4)
  gc_frame_newslot(*var_defaultMethodVisibility);
// starting to compile string node (depth = 4)
  if (strlit8987 == NULL) {
    strlit8987 = alloc_String("public");
    gc_root(strlit8987);
  }
// compiled string node returning strlit8987 (depth = 4)
  gc_frame_newslot(strlit8987);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultMethodVisibility;
  params[2] = strlit8987;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8988 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8986);
// compiled call node returning call8988 (depth = 3)
// Begin line 2813
  setline(2813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe8989 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8990 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8989);
// compiled call node returning call8990 (depth = 3)
    gc_frame_newslot(call8990);
    if8759 = call8990;
  } else {
  }
// compiled if node returning if8759 (depth = 2)
  gc_frame_end(frame);
  return if8759;
}
Object meth_parser__apply9000(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9002 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9003 == NULL) {
    strlit9003 = alloc_String("identifier");
    gc_root(strlit9003);
  }
// compiled string node returning strlit9003 (depth = 6)
  gc_frame_newslot(strlit9003);
// call case 4: self request
  params[0] = strlit9003;
  partcv[0] = 1;
  Object call9004 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9002);
// compiled call node returning call9004 (depth = 5)
  int op_slot_right_9001 = gc_frame_newslot(call9004);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9007 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9008 == NULL) {
    strlit9008 = alloc_String("identifier");
    gc_root(strlit9008);
  }
// compiled string node returning strlit9008 (depth = 7)
  gc_frame_newslot(strlit9008);
// call case 4: self request
  params[0] = strlit9008;
  partcv[0] = 1;
  Object call9009 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9007);
// compiled call node returning call9009 (depth = 6)
  int op_slot_right_9006 = gc_frame_newslot(call9009);
// starting to compile call node (depth = 6)
  int callframe9011 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9012 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9011);
// compiled call node returning call9012 (depth = 6)
  int op_slot_left_9006 = gc_frame_newslot(call9012);
  params[0] = call9009;
  partcv[0] = 1;
  Object opresult9013 = callmethod(call9012, "&&", 1, partcv, params);
// compiled op node returning opresult9013 (depth = 5)
  int op_slot_left_9001 = gc_frame_newslot(opresult9013);
  params[0] = call9004;
  partcv[0] = 1;
  Object opresult9014 = callmethod(opresult9013, "||", 1, partcv, params);
// compiled op node returning opresult9014 (depth = 4)
  gc_frame_end(frame);
  return opresult9014;
}
Object meth_parser__apply9068(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9072 == NULL) {
    strlit9072 = alloc_String("*");
    gc_root(strlit9072);
  }
// compiled string node returning strlit9072 (depth = 9)
  int op_slot_right_9071 = gc_frame_newslot(strlit9072);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9074 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9075 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9074);
// compiled call node returning call9075 (depth = 10)
// compiled member node returning call9075 (depth = 9)
  int op_slot_left_9071 = gc_frame_newslot(call9075);
  params[0] = strlit9072;
  partcv[0] = 1;
  Object opresult9076 = callmethod(call9075, "==", 1, partcv, params);
// compiled op node returning opresult9076 (depth = 8)
  int op_slot_right_9070 = gc_frame_newslot(opresult9076);
// starting to compile call node (depth = 8)
  int callframe9078 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9079 == NULL) {
    strlit9079 = alloc_String("op");
    gc_root(strlit9079);
  }
// compiled string node returning strlit9079 (depth = 9)
  gc_frame_newslot(strlit9079);
// call case 4: self request
  params[0] = strlit9079;
  partcv[0] = 1;
  Object call9080 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9078);
// compiled call node returning call9080 (depth = 8)
  int op_slot_left_9070 = gc_frame_newslot(call9080);
  params[0] = opresult9076;
  partcv[0] = 1;
  Object opresult9081 = callmethod(call9080, "&&", 1, partcv, params);
// compiled op node returning opresult9081 (depth = 7)
  int op_slot_right_9069 = gc_frame_newslot(opresult9081);
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9083 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9084 == NULL) {
    strlit9084 = alloc_String("identifier");
    gc_root(strlit9084);
  }
// compiled string node returning strlit9084 (depth = 8)
  gc_frame_newslot(strlit9084);
// call case 4: self request
  params[0] = strlit9084;
  partcv[0] = 1;
  Object call9085 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9083);
// compiled call node returning call9085 (depth = 7)
  int op_slot_left_9069 = gc_frame_newslot(call9085);
  params[0] = opresult9081;
  partcv[0] = 1;
  Object opresult9086 = callmethod(call9085, "||", 1, partcv, params);
// compiled op node returning opresult9086 (depth = 6)
  gc_frame_end(frame);
  return opresult9086;
}
Object meth_parser__apply9089(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_vararg = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_comma = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_nxt = getfromclosure(closure, 6);
  Object *var_part = getfromclosure(closure, 7);
  Object *var_tm = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tp = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tp");
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9091 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9092 == NULL) {
    strlit9092 = alloc_String("op");
    gc_root(strlit9092);
  }
// compiled string node returning strlit9092 (depth = 8)
  gc_frame_newslot(strlit9092);
// call case 4: self request
  params[0] = strlit9092;
  partcv[0] = 1;
  Object call9093 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9091);
// compiled call node returning call9093 (depth = 7)
  Object if9090 = done;
  if (istrue(call9093)) {
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9095 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9094);
// compiled call node returning call9095 (depth = 8)
// compiled member node returning call9095 (depth = 7)
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool9096 = alloc_Boolean(1);
// compiled identifier node returning bool9096 (depth = 8)
  *var_vararg = bool9096;
  if (bool9096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2848
  setline(2848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9100 == NULL) {
    strlit9100 = alloc_String("identifier");
    gc_root(strlit9100);
  }
// compiled string node returning strlit9100 (depth = 9)
  int op_slot_right_9099 = gc_frame_newslot(strlit9100);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9102 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9103 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9102);
// compiled call node returning call9103 (depth = 10)
// compiled member node returning call9103 (depth = 9)
  int op_slot_left_9099 = gc_frame_newslot(call9103);
  params[0] = strlit9100;
  partcv[0] = 1;
  Object opresult9104 = callmethod(call9103, "!=", 1, partcv, params);
// compiled op node returning opresult9104 (depth = 8)
  Object if9098 = done;
  if (istrue(opresult9104)) {
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array9105 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9105 (depth = 9)
  *var_suggestions = array9105;
  if (array9105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9106 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9108 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9107);
// compiled call node returning call9108 (depth = 12)
// compiled member node returning call9108 (depth = 11)
  partcv[0] = 0;
  Object call9109 = callmethod(call9108, "new",
    1, partcv, params);
  gc_frame_end(callframe9106);
// compiled call node returning call9109 (depth = 10)
// compiled member node returning call9109 (depth = 9)
  *var_suggestion = call9109;
  if (call9109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 2851
  setline(2851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9110 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9111 == NULL) {
    strlit9111 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit9111);
  }
// compiled string node returning strlit9111 (depth = 9)
  gc_frame_newslot(strlit9111);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9111;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9112 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9110);
// compiled call node returning call9112 (depth = 8)
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9113 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9114 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9113);
// compiled call node returning call9114 (depth = 8)
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 2853
  setline(2853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool9117 = alloc_Boolean(0);
// compiled identifier node returning bool9117 (depth = 10)
  int op_slot_right_9116 = gc_frame_newslot(bool9117);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comma (depth = 10)
  int op_slot_left_9116 = gc_frame_newslot(*var_comma);
  params[0] = bool9117;
  partcv[0] = 1;
  Object opresult9119 = callmethod(*var_comma, "==", 1, partcv, params);
// compiled op node returning opresult9119 (depth = 9)
  Object if9115 = done;
  if (istrue(opresult9119)) {
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 2854
  setline(2854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9120 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call9122 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9121);
// compiled call node returning call9122 (depth = 13)
// compiled member node returning call9122 (depth = 12)
  partcv[0] = 0;
  Object call9123 = callmethod(call9122, "new",
    1, partcv, params);
  gc_frame_end(callframe9120);
// compiled call node returning call9123 (depth = 11)
// compiled member node returning call9123 (depth = 10)
  *var_suggestion = call9123;
  if (call9123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 2855
  setline(2855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9125 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call9126 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9125);
// compiled call node returning call9126 (depth = 9)
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9127 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9128 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9127);
// compiled call node returning call9128 (depth = 9)
    gc_frame_newslot(call9128);
    if9115 = call9128;
  } else {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 9)
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9129 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_errormessages (depth = 14)
  partcv[0] = 0;
  Object call9131 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9130);
// compiled call node returning call9131 (depth = 13)
// compiled member node returning call9131 (depth = 12)
  partcv[0] = 0;
  Object call9132 = callmethod(call9131, "new",
    1, partcv, params);
  gc_frame_end(callframe9129);
// compiled call node returning call9132 (depth = 11)
// compiled member node returning call9132 (depth = 10)
  *var_suggestion = call9132;
  if (call9132 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9134 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_comma (depth = 10)
  gc_frame_newslot(*var_comma);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call9135 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe9134);
// compiled call node returning call9135 (depth = 9)
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe9136 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestion (depth = 10)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_suggestions (depth = 10)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9137 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9136);
// compiled call node returning call9137 (depth = 9)
    gc_frame_newslot(call9137);
    if9115 = call9137;
  }
// compiled if node returning if9115 (depth = 8)
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9138 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9139 == NULL) {
    strlit9139 = alloc_String("A variable length parameter (a parameter beginning with '*') must have a name after the '*'.");
    gc_root(strlit9139);
  }
// compiled string node returning strlit9139 (depth = 9)
  gc_frame_newslot(strlit9139);
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9140 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9141 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9140);
// compiled call node returning call9141 (depth = 10)
// compiled member node returning call9141 (depth = 9)
  gc_frame_newslot(call9141);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9143 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9144 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9143);
// compiled call node returning call9144 (depth = 11)
// compiled member node returning call9144 (depth = 10)
  int op_slot_right_9142 = gc_frame_newslot(call9144);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9146 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9147 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9146);
// compiled call node returning call9147 (depth = 11)
// compiled member node returning call9147 (depth = 10)
  int op_slot_left_9142 = gc_frame_newslot(call9147);
  params[0] = call9144;
  partcv[0] = 1;
  Object sum9148 = callmethod(call9147, "+", 1, partcv, params);
// compiled op node returning sum9148 (depth = 9)
  gc_frame_newslot(sum9148);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2862
  setline(2862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9139;
  params[1] = call9141;
  params[2] = sum9148;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9149 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9138);
// compiled call node returning call9149 (depth = 8)
    gc_frame_newslot(call9149);
    if9098 = call9149;
  } else {
  }
// compiled if node returning if9098 (depth = 7)
    gc_frame_newslot(if9098);
    if9090 = if9098;
  } else {
  }
// compiled if node returning if9090 (depth = 6)
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9151 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9150);
// compiled call node returning call9151 (depth = 7)
// compiled member node returning call9151 (depth = 6)
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call9153 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9152);
// compiled call node returning call9153 (depth = 8)
// compiled member node returning call9153 (depth = 7)
  *var_nxt = call9153;
  if (call9153 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9155 = gc_frame_new();
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
  Object bool9156 = alloc_Boolean(1);
// compiled identifier node returning bool9156 (depth = 8)
  gc_frame_newslot(bool9156);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  params[0] = bool9156;
  partcv[0] = 1;
  Object call9157 = callmethod(*var_nxt, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9155);
// compiled call node returning call9157 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9159 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9160 == NULL) {
    strlit9160 = alloc_String("colon");
    gc_root(strlit9160);
  }
// compiled string node returning strlit9160 (depth = 8)
  gc_frame_newslot(strlit9160);
// call case 4: self request
  params[0] = strlit9160;
  partcv[0] = 1;
  Object call9161 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9159);
// compiled call node returning call9161 (depth = 7)
  Object if9158 = done;
  if (istrue(call9161)) {
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9162 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9163 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9162);
// compiled call node returning call9163 (depth = 8)
// compiled member node returning call9163 (depth = 7)
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9165 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9164);
// compiled call node returning call9165 (depth = 8)
// compiled member node returning call9165 (depth = 7)
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call9167 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9166);
// compiled call node returning call9167 (depth = 9)
// compiled member node returning call9167 (depth = 8)
  *var_tp = call9167;
  if (call9167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9168 = gc_frame_new();
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tp (depth = 9)
  gc_frame_newslot(*var_tp);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nxt (depth = 9)
  params[0] = *var_tp;
  partcv[0] = 1;
  Object call9169 = callmethod(*var_nxt, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9168);
// compiled call node returning call9169 (depth = 8)
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9158 = done;
  } else {
  }
// compiled if node returning if9158 (depth = 6)
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vararg (depth = 7)
  Object if9170 = done;
  if (istrue(*var_vararg)) {
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9171 = gc_frame_new();
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nxt (depth = 9)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call9172 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9171);
// compiled call node returning call9172 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9173 = gc_frame_new();
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
  Object bool9174 = alloc_Boolean(1);
// compiled identifier node returning bool9174 (depth = 9)
  gc_frame_newslot(bool9174);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tm (depth = 9)
  params[0] = bool9174;
  partcv[0] = 1;
  Object call9175 = callmethod(*var_tm, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe9173);
// compiled call node returning call9175 (depth = 8)
// compiled bind node returning done (depth = 7)
// Begin line 2884
  setline(2884);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9178 == NULL) {
    strlit9178 = alloc_String("rparen");
    gc_root(strlit9178);
  }
// compiled string node returning strlit9178 (depth = 9)
  int op_slot_right_9177 = gc_frame_newslot(strlit9178);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9180 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9181 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9180);
// compiled call node returning call9181 (depth = 10)
// compiled member node returning call9181 (depth = 9)
  int op_slot_left_9177 = gc_frame_newslot(call9181);
  params[0] = strlit9178;
  partcv[0] = 1;
  Object opresult9182 = callmethod(call9181, "!=", 1, partcv, params);
// compiled op node returning opresult9182 (depth = 8)
  Object if9176 = done;
  if (istrue(opresult9182)) {
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9183 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9184 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9185 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9184);
// compiled call node returning call9185 (depth = 12)
// compiled member node returning call9185 (depth = 11)
  partcv[0] = 0;
  Object call9186 = callmethod(call9185, "new",
    1, partcv, params);
  gc_frame_end(callframe9183);
// compiled call node returning call9186 (depth = 10)
// compiled member node returning call9186 (depth = 9)
  *var_suggestion = call9186;
  if (call9186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9187 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9188 == NULL) {
    strlit9188 = alloc_String(")");
    gc_root(strlit9188);
  }
// compiled string node returning strlit9188 (depth = 9)
  gc_frame_newslot(strlit9188);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9188;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9189 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9187);
// compiled call node returning call9189 (depth = 8)
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9190 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9191 == NULL) {
    strlit9191 = alloc_String("A part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit9191);
  }
// compiled string node returning strlit9191 (depth = 9)
  gc_frame_newslot(strlit9191);
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9193 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9192);
// compiled call node returning call9193 (depth = 10)
// compiled member node returning call9193 (depth = 9)
  gc_frame_newslot(call9193);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9195 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9196 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9195);
// compiled call node returning call9196 (depth = 11)
// compiled member node returning call9196 (depth = 10)
  int op_slot_right_9194 = gc_frame_newslot(call9196);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9198 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9199 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9198);
// compiled call node returning call9199 (depth = 11)
// compiled member node returning call9199 (depth = 10)
  int op_slot_left_9194 = gc_frame_newslot(call9199);
  params[0] = call9196;
  partcv[0] = 1;
  Object sum9200 = callmethod(call9199, "+", 1, partcv, params);
// compiled op node returning sum9200 (depth = 9)
  gc_frame_newslot(sum9200);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2881
  setline(2881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9191;
  params[1] = call9193;
  params[2] = sum9200;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9201 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9190);
// compiled call node returning call9201 (depth = 8)
    gc_frame_newslot(call9201);
    if9176 = call9201;
  } else {
  }
// compiled if node returning if9176 (depth = 7)
    gc_frame_newslot(if9176);
    if9170 = if9176;
  } else {
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9202 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  gc_frame_newslot(*var_nxt);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9203 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_part (depth = 10)
  partcv[0] = 0;
  Object call9204 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9203);
// compiled call node returning call9204 (depth = 9)
// compiled member node returning call9204 (depth = 8)
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call9205 = callmethod(call9204, "push",
    1, partcv, params);
  gc_frame_end(callframe9202);
// compiled call node returning call9205 (depth = 7)
    gc_frame_newslot(call9205);
    if9170 = call9205;
  }
// compiled if node returning if9170 (depth = 6)
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9207 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9208 == NULL) {
    strlit9208 = alloc_String("comma");
    gc_root(strlit9208);
  }
// compiled string node returning strlit9208 (depth = 8)
  gc_frame_newslot(strlit9208);
// call case 4: self request
  params[0] = strlit9208;
  partcv[0] = 1;
  Object call9209 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9207);
// compiled call node returning call9209 (depth = 7)
  Object if9206 = done;
  if (istrue(call9209)) {
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 2889
  setline(2889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9211 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9212 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9211);
// compiled call node returning call9212 (depth = 8)
// compiled member node returning call9212 (depth = 7)
    gc_frame_newslot(call9212);
    if9206 = call9212;
  } else {
  }
// compiled if node returning if9206 (depth = 6)
  gc_frame_end(frame);
  return if9206;
}
Object meth_parser__apply9017(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_methname = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_nxt = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_tm = getfromclosure(closure, 7);
  Object *var_signature = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
  Object *var_vararg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "vararg");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_comma = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "comma");
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9019 == NULL) {
    strlit9019 = alloc_String("()");
    gc_root(strlit9019);
  }
// compiled string node returning strlit9019 (depth = 6)
  int op_slot_right_9018 = gc_frame_newslot(strlit9019);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_9018 = gc_frame_newslot(*var_methname);
  params[0] = strlit9019;
  partcv[0] = 1;
  Object opresult9021 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult9021 (depth = 5)
  *var_methname = opresult9021;
  if (opresult9021 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9023 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9024 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ast (depth = 9)
  partcv[0] = 0;
  Object call9025 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe9024);
// compiled call node returning call9025 (depth = 8)
// compiled member node returning call9025 (depth = 7)
  partcv[0] = 0;
  Object call9026 = callmethod(call9025, "new",
    1, partcv, params);
  gc_frame_end(callframe9023);
// compiled call node returning call9026 (depth = 6)
// compiled member node returning call9026 (depth = 5)
  *var_part = call9026;
  if (call9026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9027 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9028 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9027);
// compiled call node returning call9028 (depth = 5)
// compiled member node returning call9028 (depth = 4)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9029 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call9030 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9029);
// compiled call node returning call9030 (depth = 6)
// compiled member node returning call9030 (depth = 5)
  *var_nxt = call9030;
  if (call9030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9033 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call9034 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe9033);
// compiled call node returning call9034 (depth = 7)
// compiled member node returning call9034 (depth = 6)
  int op_slot_right_9032 = gc_frame_newslot(call9034);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_methname (depth = 6)
  int op_slot_left_9032 = gc_frame_newslot(*var_methname);
  params[0] = call9034;
  partcv[0] = 1;
  Object opresult9036 = callmethod(*var_methname, "++", 1, partcv, params);
// compiled op node returning opresult9036 (depth = 5)
  *var_methname = opresult9036;
  if (opresult9036 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9038 = gc_frame_new();
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nxt (depth = 8)
  partcv[0] = 0;
  Object call9040 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe9039);
// compiled call node returning call9040 (depth = 7)
// compiled member node returning call9040 (depth = 6)
  gc_frame_newslot(call9040);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = call9040;
  partcv[0] = 1;
  Object call9041 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9038);
// compiled call node returning call9041 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2834
  setline(2834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool9042 = alloc_Boolean(0);
// compiled identifier node returning bool9042 (depth = 5)
  *var_vararg = bool9042;
  if (bool9042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9044 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe9045 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9046 == NULL) {
    strlit9046 = alloc_String("lparen");
    gc_root(strlit9046);
  }
// compiled string node returning strlit9046 (depth = 8)
  gc_frame_newslot(strlit9046);
// call case 4: self request
  params[0] = strlit9046;
  partcv[0] = 1;
  Object call9047 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9045);
// compiled call node returning call9047 (depth = 7)
  partcv[0] = 0;
  Object call9048 = callmethod(call9047, "not",
    1, partcv, params);
  gc_frame_end(callframe9044);
// compiled call node returning call9048 (depth = 6)
// compiled member node returning call9048 (depth = 5)
  Object if9043 = done;
  if (istrue(call9048)) {
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9049 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9050 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9051 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9050);
// compiled call node returning call9051 (depth = 9)
// compiled member node returning call9051 (depth = 8)
  partcv[0] = 0;
  Object call9052 = callmethod(call9051, "new",
    1, partcv, params);
  gc_frame_end(callframe9049);
// compiled call node returning call9052 (depth = 7)
// compiled member node returning call9052 (depth = 6)
  *var_suggestion = call9052;
  if (call9052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2837
  setline(2837);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9053 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9054 == NULL) {
    strlit9054 = alloc_String("()");
    gc_root(strlit9054);
  }
// compiled string node returning strlit9054 (depth = 6)
  gc_frame_newslot(strlit9054);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9054;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9055 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9053);
// compiled call node returning call9055 (depth = 5)
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9056 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9057 == NULL) {
    strlit9057 = alloc_String("A multi-part method must have parentheses around each parameter list.");
    gc_root(strlit9057);
  }
// compiled string node returning strlit9057 (depth = 6)
  gc_frame_newslot(strlit9057);
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9058 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9059 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9058);
// compiled call node returning call9059 (depth = 7)
// compiled member node returning call9059 (depth = 6)
  gc_frame_newslot(call9059);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9060 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9061 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9060);
// compiled call node returning call9061 (depth = 7)
// compiled member node returning call9061 (depth = 6)
  gc_frame_newslot(call9061);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9057;
  params[1] = call9059;
  params[2] = call9061;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9062 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9056);
// compiled call node returning call9062 (depth = 5)
    gc_frame_newslot(call9062);
    if9043 = call9062;
  } else {
  }
// compiled if node returning if9043 (depth = 4)
// Begin line 2841
  setline(2841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9064 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9063);
// compiled call node returning call9064 (depth = 5)
// compiled member node returning call9064 (depth = 4)
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool9065 = alloc_Boolean(0);
// compiled identifier node returning bool9065 (depth = 5)
  *var_comma = bool9065;
  if (bool9065 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9066 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block9067 = alloc_Block(NULL, NULL, "parser", 2843);
  gc_frame_newslot(block9067);
// method _apply
  block_savedest(block9067);
  Object closure9068 = createclosure(2, "_apply");
  setclosureframe(closure9068, stackframe);
  addtoclosure(closure9068, var_sym);
  addtoclosure(closure9068, selfslot);
  struct UserObject *uo9068 = (struct UserObject*)block9067;
  uo9068->data[0] = (Object)closure9068;
  Method *meth_meth_parser__apply9068 = addmethod2pos(block9067, "_apply", &meth_parser__apply9068, 0);
  int argcv_meth_parser__apply9068[] = {0};
  meth_meth_parser__apply9068->type = alloc_MethodType(1, argcv_meth_parser__apply9068);
  meth_meth_parser__apply9068->definitionModule = modulename;
  meth_meth_parser__apply9068->definitionLine = 2841;
// compiled block node returning block9067 (depth = 5)
  gc_frame_newslot(block9067);
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 5)
  Object block9088 = alloc_Block(NULL, NULL, "parser", 2844);
  gc_frame_newslot(block9088);
// method _apply
  block_savedest(block9088);
  Object closure9089 = createclosure(10, "_apply");
  setclosureframe(closure9089, stackframe);
  addtoclosure(closure9089, var_vararg);
  addtoclosure(closure9089, var_sym);
  addtoclosure(closure9089, var_errormessages);
  addtoclosure(closure9089, var_lastToken);
  addtoclosure(closure9089, var_comma);
  addtoclosure(closure9089, var_values);
  addtoclosure(closure9089, var_nxt);
  addtoclosure(closure9089, var_part);
  addtoclosure(closure9089, var_tm);
  addtoclosure(closure9089, selfslot);
  struct UserObject *uo9089 = (struct UserObject*)block9088;
  uo9089->data[0] = (Object)closure9089;
  Method *meth_meth_parser__apply9089 = addmethod2pos(block9088, "_apply", &meth_parser__apply9089, 0);
  int argcv_meth_parser__apply9089[] = {0};
  meth_meth_parser__apply9089->type = alloc_MethodType(1, argcv_meth_parser__apply9089);
  meth_meth_parser__apply9089->definitionModule = modulename;
  meth_meth_parser__apply9089->definitionLine = 2844;
// compiled block node returning block9088 (depth = 5)
  gc_frame_newslot(block9088);
// call case 5: prelude request
  params[0] = block9067;
  params[1] = block9088;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9214 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9066);
// compiled call node returning call9214 (depth = 4)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9217 == NULL) {
    strlit9217 = alloc_String("rparen");
    gc_root(strlit9217);
  }
// compiled string node returning strlit9217 (depth = 6)
  int op_slot_right_9216 = gc_frame_newslot(strlit9217);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9219 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9220 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9219);
// compiled call node returning call9220 (depth = 7)
// compiled member node returning call9220 (depth = 6)
  int op_slot_left_9216 = gc_frame_newslot(call9220);
  params[0] = strlit9217;
  partcv[0] = 1;
  Object opresult9221 = callmethod(call9220, "!=", 1, partcv, params);
// compiled op node returning opresult9221 (depth = 5)
  Object if9215 = done;
  if (istrue(opresult9221)) {
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9222 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9223 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9224 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9223);
// compiled call node returning call9224 (depth = 9)
// compiled member node returning call9224 (depth = 8)
  partcv[0] = 0;
  Object call9225 = callmethod(call9224, "new",
    1, partcv, params);
  gc_frame_end(callframe9222);
// compiled call node returning call9225 (depth = 7)
// compiled member node returning call9225 (depth = 6)
  *var_suggestion = call9225;
  if (call9225 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9226 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9227 == NULL) {
    strlit9227 = alloc_String(")");
    gc_root(strlit9227);
  }
// compiled string node returning strlit9227 (depth = 6)
  gc_frame_newslot(strlit9227);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9227;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9228 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9226);
// compiled call node returning call9228 (depth = 5)
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9229 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9230 == NULL) {
    strlit9230 = alloc_String("A part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit9230);
  }
// compiled string node returning strlit9230 (depth = 6)
  gc_frame_newslot(strlit9230);
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9232 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9231);
// compiled call node returning call9232 (depth = 7)
// compiled member node returning call9232 (depth = 6)
  gc_frame_newslot(call9232);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9235 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9234);
// compiled call node returning call9235 (depth = 8)
// compiled member node returning call9235 (depth = 7)
  int op_slot_right_9233 = gc_frame_newslot(call9235);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9237 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9238 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9237);
// compiled call node returning call9238 (depth = 8)
// compiled member node returning call9238 (depth = 7)
  int op_slot_left_9233 = gc_frame_newslot(call9238);
  params[0] = call9235;
  partcv[0] = 1;
  Object sum9239 = callmethod(call9238, "+", 1, partcv, params);
// compiled op node returning sum9239 (depth = 6)
  gc_frame_newslot(sum9239);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2895
  setline(2895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9230;
  params[1] = call9232;
  params[2] = sum9239;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9240 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9229);
// compiled call node returning call9240 (depth = 5)
    gc_frame_newslot(call9240);
    if9215 = call9240;
  } else {
  }
// compiled if node returning if9215 (depth = 4)
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9241 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9242 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9241);
// compiled call node returning call9242 (depth = 5)
// compiled member node returning call9242 (depth = 4)
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9243 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_signature (depth = 5)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9244 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9243);
// compiled call node returning call9244 (depth = 4)
  gc_frame_end(frame);
  return call9244;
}
Object meth_parser_parsempmndecrest8991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parsempmndecrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method parsempmndecrest");
  Object params[2];
  int partcv[2];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parsempmndecrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    gracedie("wrong number of arguments for parsempmndecrest");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "methname");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_newName = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "newName");
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8992 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe8993 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tm (depth = 7)
  partcv[0] = 0;
  Object call8994 = callmethod(*var_tm, "value",
    1, partcv, params);
  gc_frame_end(callframe8993);
// compiled call node returning call8994 (depth = 6)
// compiled member node returning call8994 (depth = 5)
  partcv[0] = 0;
  Object call8995 = callmethod(call8994, "value",
    1, partcv, params);
  gc_frame_end(callframe8992);
// compiled call node returning call8995 (depth = 4)
// compiled member node returning call8995 (depth = 3)
  *var_methname = call8995;
  if (call8995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe8996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tm (depth = 5)
  partcv[0] = 0;
  Object call8997 = callmethod(*var_tm, "signature",
    1, partcv, params);
  gc_frame_end(callframe8996);
// compiled call node returning call8997 (depth = 4)
// compiled member node returning call8997 (depth = 3)
  *var_signature = call8997;
  if (call8997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_nxt = undefined;
// compiled vardec node returning done (depth = 2)
// starting to compile call node (depth = 2)
  int callframe8998 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block8999 = alloc_Block(NULL, NULL, "parser", 2827);
  gc_frame_newslot(block8999);
// method _apply
  block_savedest(block8999);
  Object closure9000 = createclosure(2, "_apply");
  setclosureframe(closure9000, stackframe);
  addtoclosure(closure9000, var_sameline);
  addtoclosure(closure9000, selfslot);
  struct UserObject *uo9000 = (struct UserObject*)block8999;
  uo9000->data[0] = (Object)closure9000;
  Method *meth_meth_parser__apply9000 = addmethod2pos(block8999, "_apply", &meth_parser__apply9000, 0);
  int argcv_meth_parser__apply9000[] = {0};
  meth_meth_parser__apply9000->type = alloc_MethodType(1, argcv_meth_parser__apply9000);
  meth_meth_parser__apply9000->definitionModule = modulename;
  meth_meth_parser__apply9000->definitionLine = 2825;
// compiled block node returning block8999 (depth = 3)
  gc_frame_newslot(block8999);
// starting to compile block node (depth = 3)
  Object block9016 = alloc_Block(NULL, NULL, "parser", 2827);
  gc_frame_newslot(block9016);
// method _apply
  block_savedest(block9016);
  Object closure9017 = createclosure(10, "_apply");
  setclosureframe(closure9017, stackframe);
  addtoclosure(closure9017, var_methname);
  addtoclosure(closure9017, var_ast);
  addtoclosure(closure9017, var_values);
  addtoclosure(closure9017, var_nxt);
  addtoclosure(closure9017, var_errormessages);
  addtoclosure(closure9017, var_lastToken);
  addtoclosure(closure9017, var_sym);
  addtoclosure(closure9017, var_tm);
  addtoclosure(closure9017, var_signature);
  addtoclosure(closure9017, selfslot);
  struct UserObject *uo9017 = (struct UserObject*)block9016;
  uo9017->data[0] = (Object)closure9017;
  Method *meth_meth_parser__apply9017 = addmethod2pos(block9016, "_apply", &meth_parser__apply9017, 0);
  int argcv_meth_parser__apply9017[] = {0};
  meth_meth_parser__apply9017->type = alloc_MethodType(1, argcv_meth_parser__apply9017);
  meth_meth_parser__apply9017->definitionModule = modulename;
  meth_meth_parser__apply9017->definitionLine = 2825;
// compiled block node returning block9016 (depth = 3)
  gc_frame_newslot(block9016);
// call case 5: prelude request
  params[0] = block8999;
  params[1] = block9016;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9246 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8998);
// compiled call node returning call9246 (depth = 2)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9247 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_methname (depth = 4)
  gc_frame_newslot(*var_methname);
// starting to compile identifier node (depth = 4)
  Object bool9248 = alloc_Boolean(0);
// compiled identifier node returning bool9248 (depth = 4)
  gc_frame_newslot(bool9248);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9249 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9250 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe9249);
// compiled call node returning call9250 (depth = 5)
// compiled member node returning call9250 (depth = 4)
  params[0] = *var_methname;
  params[1] = bool9248;
  partcv[0] = 2;
  Object call9251 = callmethod(call9250, "new",
    1, partcv, params);
  gc_frame_end(callframe9247);
// compiled call node returning call9251 (depth = 3)
  *var_newName = call9251;
  if (call9251 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9252 = gc_frame_new();
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9253 = alloc_Boolean(1);
// compiled identifier node returning bool9253 (depth = 4)
  gc_frame_newslot(bool9253);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newName (depth = 4)
  params[0] = bool9253;
  partcv[0] = 1;
  Object call9254 = callmethod(*var_newName, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9252);
// compiled call node returning call9254 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2903
  setline(2903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newName (depth = 2)
  gc_frame_end(frame);
  return *var_newName;
}
Object meth_parser__apply9341(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9343 == NULL) {
    strlit9343 = alloc_String("rsquare");
    gc_root(strlit9343);
  }
// compiled string node returning strlit9343 (depth = 9)
  int op_slot_right_9342 = gc_frame_newslot(strlit9343);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9345 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tokens (depth = 13)
  partcv[0] = 0;
  Object call9347 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9346);
// compiled call node returning call9347 (depth = 12)
// compiled member node returning call9347 (depth = 11)
  partcv[0] = 0;
  Object call9348 = callmethod(call9347, "kind",
    1, partcv, params);
  gc_frame_end(callframe9345);
// compiled call node returning call9348 (depth = 10)
// compiled member node returning call9348 (depth = 9)
  int op_slot_left_9342 = gc_frame_newslot(call9348);
  params[0] = strlit9343;
  partcv[0] = 1;
  Object opresult9349 = callmethod(call9348, "==", 1, partcv, params);
// compiled op node returning opresult9349 (depth = 8)
  gc_frame_end(frame);
  return opresult9349;
}
Object meth_parser__apply9468(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe9469 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9470 == NULL) {
    strlit9470 = alloc_String("identifier");
    gc_root(strlit9470);
  }
// compiled string node returning strlit9470 (depth = 6)
  gc_frame_newslot(strlit9470);
// call case 4: self request
  params[0] = strlit9470;
  partcv[0] = 1;
  Object call9471 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9469);
// compiled call node returning call9471 (depth = 5)
  gc_frame_end(frame);
  return call9471;
}
Object meth_parser__apply9474(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_genericIdents = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9475 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9476 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9475);
// compiled call node returning call9476 (depth = 6)
// compiled member node returning call9476 (depth = 5)
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9477 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9478 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9477);
// compiled call node returning call9478 (depth = 7)
// compiled member node returning call9478 (depth = 6)
  *var_id = call9478;
  if (call9478 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9479 = gc_frame_new();
// Begin line 2953
  setline(2953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool9480 = alloc_Boolean(1);
// compiled identifier node returning bool9480 (depth = 7)
  gc_frame_newslot(bool9480);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  params[0] = bool9480;
  partcv[0] = 1;
  Object call9481 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9479);
// compiled call node returning call9481 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9482 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_id (depth = 6)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_genericIdents (depth = 6)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9483 = callmethod(*var_genericIdents, "push",
    1, partcv, params);
  gc_frame_end(callframe9482);
// compiled call node returning call9483 (depth = 5)
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9485 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9486 == NULL) {
    strlit9486 = alloc_String("comma");
    gc_root(strlit9486);
  }
// compiled string node returning strlit9486 (depth = 7)
  gc_frame_newslot(strlit9486);
// call case 4: self request
  params[0] = strlit9486;
  partcv[0] = 1;
  Object call9487 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9485);
// compiled call node returning call9487 (depth = 6)
  Object if9484 = done;
  if (istrue(call9487)) {
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9489 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9488);
// compiled call node returning call9489 (depth = 7)
// compiled member node returning call9489 (depth = 6)
    gc_frame_newslot(call9489);
    if9484 = call9489;
  } else {
  }
// compiled if node returning if9484 (depth = 5)
  gc_frame_end(frame);
  return if9484;
}
Object meth_parser__apply9591(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9595 == NULL) {
    strlit9595 = alloc_String("*");
    gc_root(strlit9595);
  }
// compiled string node returning strlit9595 (depth = 8)
  int op_slot_right_9594 = gc_frame_newslot(strlit9595);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9598 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9597);
// compiled call node returning call9598 (depth = 9)
// compiled member node returning call9598 (depth = 8)
  int op_slot_left_9594 = gc_frame_newslot(call9598);
  params[0] = strlit9595;
  partcv[0] = 1;
  Object opresult9599 = callmethod(call9598, "==", 1, partcv, params);
// compiled op node returning opresult9599 (depth = 7)
  int op_slot_right_9593 = gc_frame_newslot(opresult9599);
// starting to compile call node (depth = 7)
  int callframe9601 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9602 == NULL) {
    strlit9602 = alloc_String("op");
    gc_root(strlit9602);
  }
// compiled string node returning strlit9602 (depth = 8)
  gc_frame_newslot(strlit9602);
// call case 4: self request
  params[0] = strlit9602;
  partcv[0] = 1;
  Object call9603 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9601);
// compiled call node returning call9603 (depth = 7)
  int op_slot_left_9593 = gc_frame_newslot(call9603);
  params[0] = opresult9599;
  partcv[0] = 1;
  Object opresult9604 = callmethod(call9603, "&&", 1, partcv, params);
// compiled op node returning opresult9604 (depth = 6)
  int op_slot_right_9592 = gc_frame_newslot(opresult9604);
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9606 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9607 == NULL) {
    strlit9607 = alloc_String("identifier");
    gc_root(strlit9607);
  }
// compiled string node returning strlit9607 (depth = 7)
  gc_frame_newslot(strlit9607);
// call case 4: self request
  params[0] = strlit9607;
  partcv[0] = 1;
  Object call9608 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9606);
// compiled call node returning call9608 (depth = 6)
  int op_slot_left_9592 = gc_frame_newslot(call9608);
  params[0] = opresult9604;
  partcv[0] = 1;
  Object opresult9609 = callmethod(call9608, "||", 1, partcv, params);
// compiled op node returning opresult9609 (depth = 5)
  gc_frame_end(frame);
  return opresult9609;
}
Object meth_parser__apply9694(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9695 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9696 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9695);
// compiled call node returning call9696 (depth = 10)
// compiled member node returning call9696 (depth = 9)
  gc_frame_end(frame);
  return call9696;
}
Object meth_parser__apply9750(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9753 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call9754 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9753);
// compiled call node returning call9754 (depth = 13)
// compiled member node returning call9754 (depth = 12)
  int op_slot_right_9752 = gc_frame_newslot(call9754);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9756 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call9757 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9756);
// compiled call node returning call9757 (depth = 13)
// compiled member node returning call9757 (depth = 12)
  int op_slot_left_9752 = gc_frame_newslot(call9757);
  params[0] = call9754;
  partcv[0] = 1;
  Object opresult9758 = callmethod(call9757, "==", 1, partcv, params);
// compiled op node returning opresult9758 (depth = 11)
  int op_slot_right_9751 = gc_frame_newslot(opresult9758);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit9761 == NULL) {
    strlit9761 = alloc_String("rparen");
    gc_root(strlit9761);
  }
// compiled string node returning strlit9761 (depth = 12)
  int op_slot_right_9760 = gc_frame_newslot(strlit9761);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe9763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_t (depth = 14)
  partcv[0] = 0;
  Object call9764 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9763);
// compiled call node returning call9764 (depth = 13)
// compiled member node returning call9764 (depth = 12)
  int op_slot_left_9760 = gc_frame_newslot(call9764);
  params[0] = strlit9761;
  partcv[0] = 1;
  Object opresult9765 = callmethod(call9764, "==", 1, partcv, params);
// compiled op node returning opresult9765 (depth = 11)
  int op_slot_left_9751 = gc_frame_newslot(opresult9765);
  params[0] = opresult9758;
  partcv[0] = 1;
  Object opresult9766 = callmethod(opresult9765, "&&", 1, partcv, params);
// compiled op node returning opresult9766 (depth = 10)
  gc_frame_end(frame);
  return opresult9766;
}
Object meth_parser__apply9612(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_comma = getfromclosure(closure, 3);
  Object *var_vararg = getfromclosure(closure, 4);
  Object *var_varargs = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_id = getfromclosure(closure, 7);
  Object *var_dtype = getfromclosure(closure, 8);
  Object *var_part = getfromclosure(closure, 9);
  Object *var_lparen = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_rparen = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "rparen");
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9614 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9615 == NULL) {
    strlit9615 = alloc_String("op");
    gc_root(strlit9615);
  }
// compiled string node returning strlit9615 (depth = 7)
  gc_frame_newslot(strlit9615);
// call case 4: self request
  params[0] = strlit9615;
  partcv[0] = 1;
  Object call9616 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9614);
// compiled call node returning call9616 (depth = 6)
  Object if9613 = done;
  if (istrue(call9616)) {
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9617 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9618 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9617);
// compiled call node returning call9618 (depth = 7)
// compiled member node returning call9618 (depth = 6)
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9621 == NULL) {
    strlit9621 = alloc_String("identifier");
    gc_root(strlit9621);
  }
// compiled string node returning strlit9621 (depth = 8)
  int op_slot_right_9620 = gc_frame_newslot(strlit9621);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9623 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9624 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9623);
// compiled call node returning call9624 (depth = 9)
// compiled member node returning call9624 (depth = 8)
  int op_slot_left_9620 = gc_frame_newslot(call9624);
  params[0] = strlit9621;
  partcv[0] = 1;
  Object opresult9625 = callmethod(call9624, "!=", 1, partcv, params);
// compiled op node returning opresult9625 (depth = 7)
  Object if9619 = done;
  if (istrue(opresult9625)) {
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 2992
  setline(2992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array9626 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9626 (depth = 8)
  *var_suggestions = array9626;
  if (array9626 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9627 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9628 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9629 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9628);
// compiled call node returning call9629 (depth = 11)
// compiled member node returning call9629 (depth = 10)
  partcv[0] = 0;
  Object call9630 = callmethod(call9629, "new",
    1, partcv, params);
  gc_frame_end(callframe9627);
// compiled call node returning call9630 (depth = 9)
// compiled member node returning call9630 (depth = 8)
  *var_suggestion = call9630;
  if (call9630 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9631 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9632 == NULL) {
    strlit9632 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit9632);
  }
// compiled string node returning strlit9632 (depth = 8)
  gc_frame_newslot(strlit9632);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit9632;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9633 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9631);
// compiled call node returning call9633 (depth = 7)
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9634 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9635 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9634);
// compiled call node returning call9635 (depth = 7)
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 2996
  setline(2996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
  Object bool9638 = alloc_Boolean(0);
// compiled identifier node returning bool9638 (depth = 9)
  int op_slot_right_9637 = gc_frame_newslot(bool9638);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_comma (depth = 9)
  int op_slot_left_9637 = gc_frame_newslot(*var_comma);
  params[0] = bool9638;
  partcv[0] = 1;
  Object opresult9640 = callmethod(*var_comma, "==", 1, partcv, params);
// compiled op node returning opresult9640 (depth = 8)
  Object if9636 = done;
  if (istrue(opresult9640)) {
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9641 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9642 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9643 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9642);
// compiled call node returning call9643 (depth = 12)
// compiled member node returning call9643 (depth = 11)
  partcv[0] = 0;
  Object call9644 = callmethod(call9643, "new",
    1, partcv, params);
  gc_frame_end(callframe9641);
// compiled call node returning call9644 (depth = 10)
// compiled member node returning call9644 (depth = 9)
  *var_suggestion = call9644;
  if (call9644 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9646 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call9647 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9646);
// compiled call node returning call9647 (depth = 8)
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9648 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9649 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9648);
// compiled call node returning call9649 (depth = 8)
    gc_frame_newslot(call9649);
    if9636 = call9649;
  } else {
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 3001
  setline(3001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9650 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9652 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9651);
// compiled call node returning call9652 (depth = 12)
// compiled member node returning call9652 (depth = 11)
  partcv[0] = 0;
  Object call9653 = callmethod(call9652, "new",
    1, partcv, params);
  gc_frame_end(callframe9650);
// compiled call node returning call9653 (depth = 10)
// compiled member node returning call9653 (depth = 9)
  *var_suggestion = call9653;
  if (call9653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9655 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_comma (depth = 9)
  gc_frame_newslot(*var_comma);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call9656 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe9655);
// compiled call node returning call9656 (depth = 8)
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9657 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9658 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9657);
// compiled call node returning call9658 (depth = 8)
    gc_frame_newslot(call9658);
    if9636 = call9658;
  }
// compiled if node returning if9636 (depth = 7)
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9659 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9660 == NULL) {
    strlit9660 = alloc_String("A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.");
    gc_root(strlit9660);
  }
// compiled string node returning strlit9660 (depth = 8)
  gc_frame_newslot(strlit9660);
// Begin line 3006
  setline(3006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9661 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call9662 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9661);
// compiled call node returning call9662 (depth = 9)
// compiled member node returning call9662 (depth = 8)
  gc_frame_newslot(call9662);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9664 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9665 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9664);
// compiled call node returning call9665 (depth = 10)
// compiled member node returning call9665 (depth = 9)
  int op_slot_right_9663 = gc_frame_newslot(call9665);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9667 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9668 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9667);
// compiled call node returning call9668 (depth = 10)
// compiled member node returning call9668 (depth = 9)
  int op_slot_left_9663 = gc_frame_newslot(call9668);
  params[0] = call9665;
  partcv[0] = 1;
  Object sum9669 = callmethod(call9668, "+", 1, partcv, params);
// compiled op node returning sum9669 (depth = 8)
  gc_frame_newslot(sum9669);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit9660;
  params[1] = call9662;
  params[2] = sum9669;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9670 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9659);
// compiled call node returning call9670 (depth = 7)
    gc_frame_newslot(call9670);
    if9619 = call9670;
  } else {
  }
// compiled if node returning if9619 (depth = 6)
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool9671 = alloc_Boolean(1);
// compiled identifier node returning bool9671 (depth = 7)
  *var_vararg = bool9671;
  if (bool9671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool9673 = alloc_Boolean(1);
// compiled identifier node returning bool9673 (depth = 7)
  *var_varargs = bool9673;
  if (bool9673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if9613 = done;
  } else {
  }
// compiled if node returning if9613 (depth = 5)
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9676 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9675);
// compiled call node returning call9676 (depth = 6)
// compiled member node returning call9676 (depth = 5)
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9677 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_values (depth = 8)
  partcv[0] = 0;
  Object call9678 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9677);
// compiled call node returning call9678 (depth = 7)
// compiled member node returning call9678 (depth = 6)
  *var_id = call9678;
  if (call9678 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9680 = gc_frame_new();
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool9681 = alloc_Boolean(1);
// compiled identifier node returning bool9681 (depth = 7)
  gc_frame_newslot(bool9681);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  params[0] = bool9681;
  partcv[0] = 1;
  Object call9682 = callmethod(*var_id, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9680);
// compiled call node returning call9682 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3014
  setline(3014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool9683 = alloc_Boolean(0);
// compiled identifier node returning bool9683 (depth = 6)
  *var_dtype = bool9683;
  if (bool9683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9686 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9687 == NULL) {
    strlit9687 = alloc_String("colon");
    gc_root(strlit9687);
  }
// compiled string node returning strlit9687 (depth = 7)
  gc_frame_newslot(strlit9687);
// call case 4: self request
  params[0] = strlit9687;
  partcv[0] = 1;
  Object call9688 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9686);
// compiled call node returning call9688 (depth = 6)
  Object if9685 = done;
  if (istrue(call9688)) {
// Begin line 3016
  setline(3016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9689 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9690 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9689);
// compiled call node returning call9690 (depth = 7)
// compiled member node returning call9690 (depth = 6)
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9692 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block9693 = alloc_Block(NULL, NULL, "parser", 3017);
  gc_frame_newslot(block9693);
// method _apply
  block_savedest(block9693);
  Object closure9694 = createclosure(1, "_apply");
  setclosureframe(closure9694, stackframe);
  addtoclosure(closure9694, selfslot);
  struct UserObject *uo9694 = (struct UserObject*)block9693;
  uo9694->data[0] = (Object)closure9694;
  Method *meth_meth_parser__apply9694 = addmethod2pos(block9693, "_apply", &meth_parser__apply9694, 0);
  int argcv_meth_parser__apply9694[] = {0};
  meth_meth_parser__apply9694->type = alloc_MethodType(1, argcv_meth_parser__apply9694);
  meth_meth_parser__apply9694->definitionModule = modulename;
  meth_meth_parser__apply9694->definitionLine = 3016;
// compiled block node returning block9693 (depth = 8)
  gc_frame_newslot(block9693);
// call case 4: self request
  params[0] = block9693;
  partcv[0] = 1;
  Object call9698 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9692);
// compiled call node returning call9698 (depth = 7)
  Object if9691 = done;
  if (istrue(call9698)) {
// Begin line 3019
  setline(3019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9699 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_values (depth = 10)
  partcv[0] = 0;
  Object call9700 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9699);
// compiled call node returning call9700 (depth = 9)
// compiled member node returning call9700 (depth = 8)
  *var_dtype = call9700;
  if (call9700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if9691 = done;
  } else {
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9702 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9703 = callmethodflags(self, "checkBadTypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9702);
// compiled call node returning call9703 (depth = 8)
// compiled member node returning call9703 (depth = 7)
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array9704 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9704 (depth = 8)
  *var_suggestions = array9704;
  if (array9704 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9705 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9706 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9707 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9706);
// compiled call node returning call9707 (depth = 11)
// compiled member node returning call9707 (depth = 10)
  partcv[0] = 0;
  Object call9708 = callmethod(call9707, "new",
    1, partcv, params);
  gc_frame_end(callframe9705);
// compiled call node returning call9708 (depth = 9)
// compiled member node returning call9708 (depth = 8)
  *var_suggestion = call9708;
  if (call9708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9709 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9710 == NULL) {
    strlit9710 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit9710);
  }
// compiled string node returning strlit9710 (depth = 8)
  gc_frame_newslot(strlit9710);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit9710;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9711 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9709);
// compiled call node returning call9711 (depth = 7)
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9712 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9713 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9712);
// compiled call node returning call9713 (depth = 7)
// Begin line 3026
  setline(3026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9714 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9716 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9715);
// compiled call node returning call9716 (depth = 11)
// compiled member node returning call9716 (depth = 10)
  partcv[0] = 0;
  Object call9717 = callmethod(call9716, "new",
    1, partcv, params);
  gc_frame_end(callframe9714);
// compiled call node returning call9717 (depth = 9)
// compiled member node returning call9717 (depth = 8)
  *var_suggestion = call9717;
  if (call9717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3026
  setline(3026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9719 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile identifier node (depth = 8)
  Object bool9720 = alloc_Boolean(1);
// compiled identifier node returning bool9720 (depth = 8)
  gc_frame_newslot(bool9720);
// starting to compile identifier node (depth = 8)
  Object bool9721 = alloc_Boolean(0);
// compiled identifier node returning bool9721 (depth = 8)
  gc_frame_newslot(bool9721);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = bool9720;
  params[2] = bool9721;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9722 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9719);
// compiled call node returning call9722 (depth = 7)
// Begin line 3027
  setline(3027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9723 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9724 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9723);
// compiled call node returning call9724 (depth = 7)
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9725 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit9726 == NULL) {
    strlit9726 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit9726);
  }
// compiled string node returning strlit9726 (depth = 8)
  gc_frame_newslot(strlit9726);
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9728 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9727);
// compiled call node returning call9728 (depth = 9)
// compiled member node returning call9728 (depth = 8)
  gc_frame_newslot(call9728);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9729 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9730 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9729);
// compiled call node returning call9730 (depth = 9)
// compiled member node returning call9730 (depth = 8)
  gc_frame_newslot(call9730);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit9726;
  params[1] = call9728;
  params[2] = call9730;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9731 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9725);
// compiled call node returning call9731 (depth = 7)
    gc_frame_newslot(call9731);
    if9691 = call9731;
  }
// compiled if node returning if9691 (depth = 6)
    gc_frame_newslot(if9691);
    if9685 = if9691;
  } else {
  }
// compiled if node returning if9685 (depth = 5)
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9732 = gc_frame_new();
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_dtype (depth = 7)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  params[0] = *var_dtype;
  partcv[0] = 1;
  Object call9733 = callmethod(*var_id, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9732);
// compiled call node returning call9733 (depth = 6)
// compiled bind node returning done (depth = 5)
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_vararg (depth = 6)
  Object if9734 = done;
  if (istrue(*var_vararg)) {
// Begin line 3035
  setline(3035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9735 = gc_frame_new();
// Begin line 3034
  setline(3034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_id (depth = 8)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9736 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9735);
// compiled call node returning call9736 (depth = 7)
// compiled bind node returning done (depth = 6)
// Begin line 3049
  setline(3049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3035
  setline(3035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9739 == NULL) {
    strlit9739 = alloc_String("rparen");
    gc_root(strlit9739);
  }
// compiled string node returning strlit9739 (depth = 8)
  int op_slot_right_9738 = gc_frame_newslot(strlit9739);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9741 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9742 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9741);
// compiled call node returning call9742 (depth = 9)
// compiled member node returning call9742 (depth = 8)
  int op_slot_left_9738 = gc_frame_newslot(call9742);
  params[0] = strlit9739;
  partcv[0] = 1;
  Object opresult9743 = callmethod(call9742, "!=", 1, partcv, params);
// compiled op node returning opresult9743 (depth = 7)
  Object if9737 = done;
  if (istrue(opresult9743)) {
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9744 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9745 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call9746 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9745);
// compiled call node returning call9746 (depth = 11)
// compiled member node returning call9746 (depth = 10)
  partcv[0] = 0;
  Object call9747 = callmethod(call9746, "new",
    1, partcv, params);
  gc_frame_end(callframe9744);
// compiled call node returning call9747 (depth = 9)
// compiled member node returning call9747 (depth = 8)
  *var_suggestion = call9747;
  if (call9747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9748 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block9749 = alloc_Block(NULL, NULL, "parser", 3037);
  gc_frame_newslot(block9749);
// method _apply
  block_savedest(block9749);
  Object closure9750 = createclosure(2, "_apply");
  setclosureframe(closure9750, stackframe);
  addtoclosure(closure9750, var_sym);
  addtoclosure(closure9750, selfslot);
  struct UserObject *uo9750 = (struct UserObject*)block9749;
  uo9750->data[0] = (Object)closure9750;
  Method *meth_meth_parser__apply9750 = addmethod2pos(block9749, "_apply", &meth_parser__apply9750, 0);
  int argcv_meth_parser__apply9750[] = {1};
  meth_meth_parser__apply9750->type = alloc_MethodType(1, argcv_meth_parser__apply9750);
  meth_meth_parser__apply9750->definitionModule = modulename;
  meth_meth_parser__apply9750->definitionLine = 3036;
// compiled block node returning block9749 (depth = 9)
  gc_frame_newslot(block9749);
// call case 4: self request
  params[0] = block9749;
  partcv[0] = 1;
  Object call9768 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9748);
// compiled call node returning call9768 (depth = 8)
  *var_rparen = call9768;
  if (call9768 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool9772 = alloc_Boolean(0);
// compiled identifier node returning bool9772 (depth = 10)
  int op_slot_right_9771 = gc_frame_newslot(bool9772);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_rparen (depth = 10)
  int op_slot_left_9771 = gc_frame_newslot(*var_rparen);
  params[0] = bool9772;
  partcv[0] = 1;
  Object opresult9774 = callmethod(*var_rparen, "!=", 1, partcv, params);
// compiled op node returning opresult9774 (depth = 9)
  int op_slot_right_9770 = gc_frame_newslot(opresult9774);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9777 == NULL) {
    strlit9777 = alloc_String("comma");
    gc_root(strlit9777);
  }
// compiled string node returning strlit9777 (depth = 10)
  int op_slot_right_9776 = gc_frame_newslot(strlit9777);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9779 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9780 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9779);
// compiled call node returning call9780 (depth = 11)
// compiled member node returning call9780 (depth = 10)
  int op_slot_left_9776 = gc_frame_newslot(call9780);
  params[0] = strlit9777;
  partcv[0] = 1;
  Object opresult9781 = callmethod(call9780, "==", 1, partcv, params);
// compiled op node returning opresult9781 (depth = 9)
  int op_slot_left_9770 = gc_frame_newslot(opresult9781);
  params[0] = opresult9774;
  partcv[0] = 1;
  Object opresult9782 = callmethod(opresult9781, "&&", 1, partcv, params);
// compiled op node returning opresult9782 (depth = 8)
  Object if9769 = done;
  if (istrue(opresult9782)) {
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9783 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit9785 == NULL) {
    strlit9785 = alloc_String("");
    gc_root(strlit9785);
  }
// compiled string node returning strlit9785 (depth = 10)
  int op_slot_right_9784 = gc_frame_newslot(strlit9785);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9788 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_id (depth = 13)
  partcv[0] = 0;
  Object call9789 = callmethod(*var_id, "value",
    1, partcv, params);
  gc_frame_end(callframe9788);
// compiled call node returning call9789 (depth = 12)
// compiled member node returning call9789 (depth = 11)
  int op_slot_right_9787 = gc_frame_newslot(call9789);
// starting to compile string node (depth = 11)
  if (strlit9791 == NULL) {
    strlit9791 = alloc_String(",*");
    gc_root(strlit9791);
  }
// compiled string node returning strlit9791 (depth = 11)
  int op_slot_left_9787 = gc_frame_newslot(strlit9791);
  params[0] = call9789;
  partcv[0] = 1;
  Object opresult9792 = callmethod(strlit9791, "++", 1, partcv, params);
// compiled op node returning opresult9792 (depth = 10)
  int op_slot_left_9784 = gc_frame_newslot(opresult9792);
  params[0] = strlit9785;
  partcv[0] = 1;
  Object opresult9793 = callmethod(opresult9792, "++", 1, partcv, params);
// compiled op node returning opresult9793 (depth = 9)
  gc_frame_newslot(opresult9793);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_rparen (depth = 9)
  gc_frame_newslot(*var_rparen);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = opresult9793;
  params[1] = *var_rparen;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9794 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe9783);
// compiled call node returning call9794 (depth = 8)
// Begin line 3040
  setline(3040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9795 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9796 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lparen (depth = 11)
  partcv[0] = 0;
  Object call9797 = callmethod(*var_lparen, "next",
    1, partcv, params);
  gc_frame_end(callframe9796);
// compiled call node returning call9797 (depth = 10)
// compiled member node returning call9797 (depth = 9)
  gc_frame_newslot(call9797);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
  Object bool9798 = alloc_Boolean(1);
// compiled identifier node returning bool9798 (depth = 9)
  gc_frame_newslot(bool9798);
// starting to compile identifier node (depth = 9)
  Object bool9799 = alloc_Boolean(0);
// compiled identifier node returning bool9799 (depth = 9)
  gc_frame_newslot(bool9799);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = call9797;
  params[1] = *var_sym;
  params[2] = bool9798;
  params[3] = bool9799;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9800 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9795);
// compiled call node returning call9800 (depth = 8)
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9801 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9802 == NULL) {
    strlit9802 = alloc_String("A variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.");
    gc_root(strlit9802);
  }
// compiled string node returning strlit9802 (depth = 9)
  gc_frame_newslot(strlit9802);
// Begin line 3042
  setline(3042);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9804 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9803);
// compiled call node returning call9804 (depth = 10)
// compiled member node returning call9804 (depth = 9)
  gc_frame_newslot(call9804);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9805 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9806 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9805);
// compiled call node returning call9806 (depth = 10)
// compiled member node returning call9806 (depth = 9)
  gc_frame_newslot(call9806);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num9808 = alloc_Float64(1);
// compiled num node returning num9808 (depth = 10)
  int op_slot_right_9807 = gc_frame_newslot(num9808);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9810 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_rparen (depth = 12)
  partcv[0] = 0;
  Object call9811 = callmethod(*var_rparen, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9810);
// compiled call node returning call9811 (depth = 11)
// compiled member node returning call9811 (depth = 10)
  int op_slot_left_9807 = gc_frame_newslot(call9811);
  params[0] = num9808;
  partcv[0] = 1;
  Object diff9812 = callmethod(call9811, "-", 1, partcv, params);
// compiled op node returning diff9812 (depth = 9)
  gc_frame_newslot(diff9812);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9802;
  params[1] = call9804;
  params[2] = call9806;
  params[3] = diff9812;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9813 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9801);
// compiled call node returning call9813 (depth = 8)
    gc_frame_newslot(call9813);
    if9769 = call9813;
  } else {
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9814 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9815 == NULL) {
    strlit9815 = alloc_String(")");
    gc_root(strlit9815);
  }
// compiled string node returning strlit9815 (depth = 9)
  gc_frame_newslot(strlit9815);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9815;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9816 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9814);
// compiled call node returning call9816 (depth = 8)
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9817 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9818 == NULL) {
    strlit9818 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9818);
  }
// compiled string node returning strlit9818 (depth = 9)
  gc_frame_newslot(strlit9818);
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9819 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9820 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9819);
// compiled call node returning call9820 (depth = 10)
// compiled member node returning call9820 (depth = 9)
  gc_frame_newslot(call9820);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9823 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9822);
// compiled call node returning call9823 (depth = 11)
// compiled member node returning call9823 (depth = 10)
  int op_slot_right_9821 = gc_frame_newslot(call9823);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9825 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9826 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9825);
// compiled call node returning call9826 (depth = 11)
// compiled member node returning call9826 (depth = 10)
  int op_slot_left_9821 = gc_frame_newslot(call9826);
  params[0] = call9823;
  partcv[0] = 1;
  Object sum9827 = callmethod(call9826, "+", 1, partcv, params);
// compiled op node returning sum9827 (depth = 9)
  gc_frame_newslot(sum9827);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9818;
  params[1] = call9820;
  params[2] = sum9827;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9828 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9817);
// compiled call node returning call9828 (depth = 8)
    gc_frame_newslot(call9828);
    if9769 = call9828;
  }
// compiled if node returning if9769 (depth = 7)
    gc_frame_newslot(if9769);
    if9737 = if9769;
  } else {
  }
// compiled if node returning if9737 (depth = 6)
    gc_frame_newslot(if9737);
    if9734 = if9737;
  } else {
// Begin line 3050
  setline(3050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9829 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_id (depth = 7)
  gc_frame_newslot(*var_id);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9830 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call9831 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9830);
// compiled call node returning call9831 (depth = 8)
// compiled member node returning call9831 (depth = 7)
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9832 = callmethod(call9831, "push",
    1, partcv, params);
  gc_frame_end(callframe9829);
// compiled call node returning call9832 (depth = 6)
    gc_frame_newslot(call9832);
    if9734 = call9832;
  }
// compiled if node returning if9734 (depth = 5)
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3052
  setline(3052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9834 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9835 == NULL) {
    strlit9835 = alloc_String("comma");
    gc_root(strlit9835);
  }
// compiled string node returning strlit9835 (depth = 7)
  gc_frame_newslot(strlit9835);
// call case 4: self request
  params[0] = strlit9835;
  partcv[0] = 1;
  Object call9836 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9834);
// compiled call node returning call9836 (depth = 6)
  Object if9833 = done;
  if (istrue(call9836)) {
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9838 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9839 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9838);
// compiled call node returning call9839 (depth = 7)
// compiled member node returning call9839 (depth = 6)
    gc_frame_newslot(call9839);
    if9833 = call9839;
  } else {
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9842 == NULL) {
    strlit9842 = alloc_String("rparen");
    gc_root(strlit9842);
  }
// compiled string node returning strlit9842 (depth = 8)
  int op_slot_right_9841 = gc_frame_newslot(strlit9842);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9844 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call9845 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9844);
// compiled call node returning call9845 (depth = 9)
// compiled member node returning call9845 (depth = 8)
  int op_slot_left_9841 = gc_frame_newslot(call9845);
  params[0] = strlit9842;
  partcv[0] = 1;
  Object opresult9846 = callmethod(call9845, "!=", 1, partcv, params);
// compiled op node returning opresult9846 (depth = 7)
  Object if9840 = done;
  if (istrue(opresult9846)) {
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9849 == NULL) {
    strlit9849 = alloc_String("rparen");
    gc_root(strlit9849);
  }
// compiled string node returning strlit9849 (depth = 9)
  int op_slot_right_9848 = gc_frame_newslot(strlit9849);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9851 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9852 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9851);
// compiled call node returning call9852 (depth = 10)
// compiled member node returning call9852 (depth = 9)
  int op_slot_left_9848 = gc_frame_newslot(call9852);
  params[0] = strlit9849;
  partcv[0] = 1;
  Object opresult9853 = callmethod(call9852, "!=", 1, partcv, params);
// compiled op node returning opresult9853 (depth = 8)
  Object if9847 = done;
  if (istrue(opresult9853)) {
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9854 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe9855 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call9856 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9855);
// compiled call node returning call9856 (depth = 12)
// compiled member node returning call9856 (depth = 11)
  partcv[0] = 0;
  Object call9857 = callmethod(call9856, "new",
    1, partcv, params);
  gc_frame_end(callframe9854);
// compiled call node returning call9857 (depth = 10)
// compiled member node returning call9857 (depth = 9)
  *var_suggestion = call9857;
  if (call9857 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9858 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9859 == NULL) {
    strlit9859 = alloc_String(")");
    gc_root(strlit9859);
  }
// compiled string node returning strlit9859 (depth = 9)
  gc_frame_newslot(strlit9859);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit9859;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9860 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9858);
// compiled call node returning call9860 (depth = 8)
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe9861 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit9862 == NULL) {
    strlit9862 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9862);
  }
// compiled string node returning strlit9862 (depth = 9)
  gc_frame_newslot(strlit9862);
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9863 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9864 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9863);
// compiled call node returning call9864 (depth = 10)
// compiled member node returning call9864 (depth = 9)
  gc_frame_newslot(call9864);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9866 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9867 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9866);
// compiled call node returning call9867 (depth = 11)
// compiled member node returning call9867 (depth = 10)
  int op_slot_right_9865 = gc_frame_newslot(call9867);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9869 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_lastToken (depth = 12)
  partcv[0] = 0;
  Object call9870 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9869);
// compiled call node returning call9870 (depth = 11)
// compiled member node returning call9870 (depth = 10)
  int op_slot_left_9865 = gc_frame_newslot(call9870);
  params[0] = call9867;
  partcv[0] = 1;
  Object sum9871 = callmethod(call9870, "+", 1, partcv, params);
// compiled op node returning sum9871 (depth = 9)
  gc_frame_newslot(sum9871);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = strlit9862;
  params[1] = call9864;
  params[2] = sum9871;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9872 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9861);
// compiled call node returning call9872 (depth = 8)
    gc_frame_newslot(call9872);
    if9847 = call9872;
  } else {
  }
// compiled if node returning if9847 (depth = 7)
    gc_frame_newslot(if9847);
    if9840 = if9847;
  } else {
  }
// compiled if node returning if9840 (depth = 6)
    gc_frame_newslot(if9840);
    if9833 = if9840;
  }
// compiled if node returning if9833 (depth = 5)
  gc_frame_end(frame);
  return if9833;
}
Object meth_parser__apply9888(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9891 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call9892 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9891);
// compiled call node returning call9892 (depth = 10)
// compiled member node returning call9892 (depth = 9)
  int op_slot_right_9890 = gc_frame_newslot(call9892);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call9895 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9894);
// compiled call node returning call9895 (depth = 10)
// compiled member node returning call9895 (depth = 9)
  int op_slot_left_9890 = gc_frame_newslot(call9895);
  params[0] = call9892;
  partcv[0] = 1;
  Object opresult9896 = callmethod(call9895, "==", 1, partcv, params);
// compiled op node returning opresult9896 (depth = 8)
  int op_slot_right_9889 = gc_frame_newslot(opresult9896);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9899 == NULL) {
    strlit9899 = alloc_String("rparen");
    gc_root(strlit9899);
  }
// compiled string node returning strlit9899 (depth = 9)
  int op_slot_right_9898 = gc_frame_newslot(strlit9899);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_t (depth = 11)
  partcv[0] = 0;
  Object call9902 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9901);
// compiled call node returning call9902 (depth = 10)
// compiled member node returning call9902 (depth = 9)
  int op_slot_left_9898 = gc_frame_newslot(call9902);
  params[0] = strlit9899;
  partcv[0] = 1;
  Object opresult9903 = callmethod(call9902, "==", 1, partcv, params);
// compiled op node returning opresult9903 (depth = 8)
  int op_slot_left_9889 = gc_frame_newslot(opresult9903);
  params[0] = opresult9896;
  partcv[0] = 1;
  Object opresult9904 = callmethod(opresult9903, "&&", 1, partcv, params);
// compiled op node returning opresult9904 (depth = 7)
  gc_frame_end(frame);
  return opresult9904;
}
Object meth_parser_methodsignature9255(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(21, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method methodsignature");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_genericIdents = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "genericIdents");
  Object *var_suggestions = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestions");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_varargs = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "varargs");
  Object *var_vararg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "vararg");
  Object *var_lparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "lparen");
  Object *var_id = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "id");
  Object *var_comma = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "comma");
  Object *var_rparen = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "rparen");
  Object *var_tm = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "tm");
  Object *var_o = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "o");
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9259 == NULL) {
    strlit9259 = alloc_String("lsquare");
    gc_root(strlit9259);
  }
// compiled string node returning strlit9259 (depth = 5)
  int op_slot_right_9258 = gc_frame_newslot(strlit9259);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9262 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9261);
// compiled call node returning call9262 (depth = 6)
// compiled member node returning call9262 (depth = 5)
  int op_slot_left_9258 = gc_frame_newslot(call9262);
  params[0] = strlit9259;
  partcv[0] = 1;
  Object opresult9263 = callmethod(call9262, "!=", 1, partcv, params);
// compiled op node returning opresult9263 (depth = 4)
  int op_slot_right_9257 = gc_frame_newslot(opresult9263);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9267 == NULL) {
    strlit9267 = alloc_String("op");
    gc_root(strlit9267);
  }
// compiled string node returning strlit9267 (depth = 6)
  int op_slot_right_9266 = gc_frame_newslot(strlit9267);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9269 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9270 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9269);
// compiled call node returning call9270 (depth = 7)
// compiled member node returning call9270 (depth = 6)
  int op_slot_left_9266 = gc_frame_newslot(call9270);
  params[0] = strlit9267;
  partcv[0] = 1;
  Object opresult9271 = callmethod(call9270, "!=", 1, partcv, params);
// compiled op node returning opresult9271 (depth = 5)
  int op_slot_right_9265 = gc_frame_newslot(opresult9271);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9274 == NULL) {
    strlit9274 = alloc_String("identifier");
    gc_root(strlit9274);
  }
// compiled string node returning strlit9274 (depth = 6)
  int op_slot_right_9273 = gc_frame_newslot(strlit9274);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9276 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call9277 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9276);
// compiled call node returning call9277 (depth = 7)
// compiled member node returning call9277 (depth = 6)
  int op_slot_left_9273 = gc_frame_newslot(call9277);
  params[0] = strlit9274;
  partcv[0] = 1;
  Object opresult9278 = callmethod(call9277, "!=", 1, partcv, params);
// compiled op node returning opresult9278 (depth = 5)
  int op_slot_left_9265 = gc_frame_newslot(opresult9278);
  params[0] = opresult9271;
  partcv[0] = 1;
  Object opresult9279 = callmethod(opresult9278, "&&", 1, partcv, params);
// compiled op node returning opresult9279 (depth = 4)
  int op_slot_left_9257 = gc_frame_newslot(opresult9279);
  params[0] = opresult9263;
  partcv[0] = 1;
  Object opresult9280 = callmethod(opresult9279, "&&", 1, partcv, params);
// compiled op node returning opresult9280 (depth = 3)
  Object if9256 = done;
  if (istrue(opresult9280)) {
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9281 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9282 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call9283 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9282);
// compiled call node returning call9283 (depth = 7)
// compiled member node returning call9283 (depth = 6)
  partcv[0] = 0;
  Object call9284 = callmethod(call9283, "new",
    1, partcv, params);
  gc_frame_end(callframe9281);
// compiled call node returning call9284 (depth = 5)
// compiled member node returning call9284 (depth = 4)
  *var_suggestion = call9284;
  if (call9284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2910
  setline(2910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9285 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9286 == NULL) {
    strlit9286 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit9286);
  }
// compiled string node returning strlit9286 (depth = 4)
  gc_frame_newslot(strlit9286);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  params[0] = strlit9286;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9287 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9285);
// compiled call node returning call9287 (depth = 3)
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9288 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9289 == NULL) {
    strlit9289 = alloc_String("A method name must start with an identifier, an operator, or '[]'.");
    gc_root(strlit9289);
  }
// compiled string node returning strlit9289 (depth = 4)
  gc_frame_newslot(strlit9289);
// Begin line 2912
  setline(2912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9290 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call9291 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9290);
// compiled call node returning call9291 (depth = 5)
// compiled member node returning call9291 (depth = 4)
  gc_frame_newslot(call9291);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9294 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9293);
// compiled call node returning call9294 (depth = 6)
// compiled member node returning call9294 (depth = 5)
  int op_slot_right_9292 = gc_frame_newslot(call9294);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9296 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9297 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9296);
// compiled call node returning call9297 (depth = 6)
// compiled member node returning call9297 (depth = 5)
  int op_slot_left_9292 = gc_frame_newslot(call9297);
  params[0] = call9294;
  partcv[0] = 1;
  Object sum9298 = callmethod(call9297, "+", 1, partcv, params);
// compiled op node returning sum9298 (depth = 4)
  gc_frame_newslot(sum9298);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion (depth = 4)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit9289;
  params[1] = call9291;
  params[2] = sum9298;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9299 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9288);
// compiled call node returning call9299 (depth = 3)
    gc_frame_newslot(call9299);
    if9256 = call9299;
  } else {
  }
// compiled if node returning if9256 (depth = 2)
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9300 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9301 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9300);
// compiled call node returning call9301 (depth = 3)
// compiled member node returning call9301 (depth = 2)
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_values (depth = 5)
  partcv[0] = 0;
  Object call9303 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9302);
// compiled call node returning call9303 (depth = 4)
// compiled member node returning call9303 (depth = 3)
  *var_meth = call9303;
  if (call9303 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9304 = gc_frame_new();
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9305 = alloc_Boolean(1);
// compiled identifier node returning bool9305 (depth = 4)
  gc_frame_newslot(bool9305);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  params[0] = bool9305;
  partcv[0] = 1;
  Object call9306 = callmethod(*var_meth, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe9304);
// compiled call node returning call9306 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9307 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9308 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9309 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9308);
// compiled call node returning call9309 (depth = 6)
// compiled member node returning call9309 (depth = 5)
  partcv[0] = 0;
  Object call9310 = callmethod(call9309, "empty",
    1, partcv, params);
  gc_frame_end(callframe9307);
// compiled call node returning call9310 (depth = 4)
// compiled member node returning call9310 (depth = 3)
  *var_signature = call9310;
  if (call9310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe9311 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9312 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9313 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9312);
// compiled call node returning call9313 (depth = 5)
// compiled member node returning call9313 (depth = 4)
  gc_frame_newslot(call9313);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9314 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call9315 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe9314);
// compiled call node returning call9315 (depth = 5)
// compiled member node returning call9315 (depth = 4)
  params[0] = call9313;
  partcv[0] = 1;
  Object call9316 = callmethod(call9315, "new",
    1, partcv, params);
  gc_frame_end(callframe9311);
// compiled call node returning call9316 (depth = 3)
  *var_part = call9316;
  if (call9316 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9317 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9318 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9319 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9318);
// compiled call node returning call9319 (depth = 6)
// compiled member node returning call9319 (depth = 5)
  partcv[0] = 0;
  Object call9320 = callmethod(call9319, "empty",
    1, partcv, params);
  gc_frame_end(callframe9317);
// compiled call node returning call9320 (depth = 4)
// compiled member node returning call9320 (depth = 3)
  *var_genericIdents = call9320;
  if (call9320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe9321 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_part (depth = 3)
  gc_frame_newslot(*var_part);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_signature (depth = 3)
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9322 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9321);
// compiled call node returning call9322 (depth = 2)
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2921
  setline(2921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit9325 == NULL) {
    strlit9325 = alloc_String("[");
    gc_root(strlit9325);
  }
// compiled string node returning strlit9325 (depth = 4)
  int op_slot_right_9324 = gc_frame_newslot(strlit9325);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call9328 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9327);
// compiled call node returning call9328 (depth = 5)
// compiled member node returning call9328 (depth = 4)
  int op_slot_left_9324 = gc_frame_newslot(call9328);
  params[0] = strlit9325;
  partcv[0] = 1;
  Object opresult9329 = callmethod(call9328, "==", 1, partcv, params);
// compiled op node returning opresult9329 (depth = 3)
  Object if9323 = done;
  if (istrue(opresult9329)) {
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9332 == NULL) {
    strlit9332 = alloc_String("rsquare");
    gc_root(strlit9332);
  }
// compiled string node returning strlit9332 (depth = 5)
  int op_slot_right_9331 = gc_frame_newslot(strlit9332);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9334 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9335 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9334);
// compiled call node returning call9335 (depth = 6)
// compiled member node returning call9335 (depth = 5)
  int op_slot_left_9331 = gc_frame_newslot(call9335);
  params[0] = strlit9332;
  partcv[0] = 1;
  Object opresult9336 = callmethod(call9335, "!=", 1, partcv, params);
// compiled op node returning opresult9336 (depth = 4)
  Object if9330 = done;
  if (istrue(opresult9336)) {
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9339 = gc_frame_new();
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 7)
  Object block9340 = alloc_Block(NULL, NULL, "parser", 2924);
  gc_frame_newslot(block9340);
// method _apply
  block_savedest(block9340);
  Object closure9341 = createclosure(2, "_apply");
  setclosureframe(closure9341, stackframe);
  addtoclosure(closure9341, var_tokens);
  addtoclosure(closure9341, selfslot);
  struct UserObject *uo9341 = (struct UserObject*)block9340;
  uo9341->data[0] = (Object)closure9341;
  Method *meth_meth_parser__apply9341 = addmethod2pos(block9340, "_apply", &meth_parser__apply9341, 0);
  int argcv_meth_parser__apply9341[] = {0};
  meth_meth_parser__apply9341->type = alloc_MethodType(1, argcv_meth_parser__apply9341);
  meth_meth_parser__apply9341->definitionModule = modulename;
  meth_meth_parser__apply9341->definitionLine = 2922;
// compiled block node returning block9340 (depth = 7)
  gc_frame_newslot(block9340);
// call case 6: other member request
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num9352 = alloc_Float64(0);
// compiled num node returning num9352 (depth = 8)
  int op_slot_right_9351 = gc_frame_newslot(num9352);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9354 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9355 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9354);
// compiled call node returning call9355 (depth = 9)
// compiled member node returning call9355 (depth = 8)
  int op_slot_left_9351 = gc_frame_newslot(call9355);
  params[0] = num9352;
  partcv[0] = 1;
  Object opresult9356 = callmethod(call9355, "==", 1, partcv, params);
// compiled op node returning opresult9356 (depth = 7)
  params[0] = block9340;
  partcv[0] = 1;
  Object call9357 = callmethod(opresult9356, "orElse",
    1, partcv, params);
  gc_frame_end(callframe9339);
// compiled call node returning call9357 (depth = 6)
  int op_slot_right_9338 = gc_frame_newslot(call9357);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit9360 == NULL) {
    strlit9360 = alloc_String("identifier");
    gc_root(strlit9360);
  }
// compiled string node returning strlit9360 (depth = 7)
  int op_slot_right_9359 = gc_frame_newslot(strlit9360);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9362 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9363 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9362);
// compiled call node returning call9363 (depth = 8)
// compiled member node returning call9363 (depth = 7)
  int op_slot_left_9359 = gc_frame_newslot(call9363);
  params[0] = strlit9360;
  partcv[0] = 1;
  Object opresult9364 = callmethod(call9363, "==", 1, partcv, params);
// compiled op node returning opresult9364 (depth = 6)
  int op_slot_left_9338 = gc_frame_newslot(opresult9364);
  params[0] = call9357;
  partcv[0] = 1;
  Object opresult9365 = callmethod(opresult9364, "&&", 1, partcv, params);
// compiled op node returning opresult9365 (depth = 5)
  Object if9337 = done;
  if (istrue(opresult9365)) {
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9366 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9367 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call9368 = callmethodflags(prelude, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9367);
// compiled call node returning call9368 (depth = 9)
// compiled member node returning call9368 (depth = 8)
  partcv[0] = 0;
  Object call9369 = callmethod(call9368, "empty",
    1, partcv, params);
  gc_frame_end(callframe9366);
// compiled call node returning call9369 (depth = 7)
// compiled member node returning call9369 (depth = 6)
  *var_suggestions = call9369;
  if (call9369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9370 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9372 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9371);
// compiled call node returning call9372 (depth = 9)
// compiled member node returning call9372 (depth = 8)
  partcv[0] = 0;
  Object call9373 = callmethod(call9372, "new",
    1, partcv, params);
  gc_frame_end(callframe9370);
// compiled call node returning call9373 (depth = 7)
// compiled member node returning call9373 (depth = 6)
  *var_suggestion = call9373;
  if (call9373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num9376 = alloc_Float64(0);
// compiled num node returning num9376 (depth = 7)
  int op_slot_right_9375 = gc_frame_newslot(num9376);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9378 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tokens (depth = 9)
  partcv[0] = 0;
  Object call9379 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9378);
// compiled call node returning call9379 (depth = 8)
// compiled member node returning call9379 (depth = 7)
  int op_slot_left_9375 = gc_frame_newslot(call9379);
  params[0] = num9376;
  partcv[0] = 1;
  Object opresult9380 = callmethod(call9379, "==", 1, partcv, params);
// compiled op node returning opresult9380 (depth = 6)
  Object if9374 = done;
  if (istrue(opresult9380)) {
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9381 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit9383 == NULL) {
    strlit9383 = alloc_String(")");
    gc_root(strlit9383);
  }
// compiled string node returning strlit9383 (depth = 8)
  int op_slot_right_9382 = gc_frame_newslot(strlit9383);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe9386 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call9387 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9386);
// compiled call node returning call9387 (depth = 10)
// compiled member node returning call9387 (depth = 9)
  int op_slot_right_9385 = gc_frame_newslot(call9387);
// starting to compile string node (depth = 9)
  if (strlit9389 == NULL) {
    strlit9389 = alloc_String("](");
    gc_root(strlit9389);
  }
// compiled string node returning strlit9389 (depth = 9)
  int op_slot_left_9385 = gc_frame_newslot(strlit9389);
  params[0] = call9387;
  partcv[0] = 1;
  Object opresult9390 = callmethod(strlit9389, "++", 1, partcv, params);
// compiled op node returning opresult9390 (depth = 8)
  int op_slot_left_9382 = gc_frame_newslot(opresult9390);
  params[0] = strlit9383;
  partcv[0] = 1;
  Object opresult9391 = callmethod(opresult9390, "++", 1, partcv, params);
// compiled op node returning opresult9391 (depth = 7)
  gc_frame_newslot(opresult9391);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = opresult9391;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9392 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9381);
// compiled call node returning call9392 (depth = 6)
// Begin line 2929
  setline(2929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe9393 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9394 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9393);
// compiled call node returning call9394 (depth = 6)
    gc_frame_newslot(call9394);
    if9374 = call9394;
  } else {
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9397 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_meth (depth = 10)
  partcv[0] = 0;
  Object call9398 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9397);
// compiled call node returning call9398 (depth = 9)
// compiled member node returning call9398 (depth = 8)
  int op_slot_right_9396 = gc_frame_newslot(call9398);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9400 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9401 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  partcv[0] = 0;
  Object call9402 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9401);
// compiled call node returning call9402 (depth = 11)
// compiled member node returning call9402 (depth = 10)
  partcv[0] = 0;
  Object call9403 = callmethod(call9402, "line",
    1, partcv, params);
  gc_frame_end(callframe9400);
// compiled call node returning call9403 (depth = 9)
// compiled member node returning call9403 (depth = 8)
  int op_slot_left_9396 = gc_frame_newslot(call9403);
  params[0] = call9398;
  partcv[0] = 1;
  Object opresult9404 = callmethod(call9403, "==", 1, partcv, params);
// compiled op node returning opresult9404 (depth = 7)
  Object if9395 = done;
  if (istrue(opresult9404)) {
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9405 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9406 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tokens (depth = 10)
  partcv[0] = 0;
  Object call9407 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9406);
// compiled call node returning call9407 (depth = 9)
// compiled member node returning call9407 (depth = 8)
  gc_frame_newslot(call9407);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit9409 == NULL) {
    strlit9409 = alloc_String(")");
    gc_root(strlit9409);
  }
// compiled string node returning strlit9409 (depth = 9)
  int op_slot_right_9408 = gc_frame_newslot(strlit9409);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe9412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call9413 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9412);
// compiled call node returning call9413 (depth = 11)
// compiled member node returning call9413 (depth = 10)
  int op_slot_right_9411 = gc_frame_newslot(call9413);
// starting to compile string node (depth = 10)
  if (strlit9415 == NULL) {
    strlit9415 = alloc_String("](");
    gc_root(strlit9415);
  }
// compiled string node returning strlit9415 (depth = 10)
  int op_slot_left_9411 = gc_frame_newslot(strlit9415);
  params[0] = call9413;
  partcv[0] = 1;
  Object opresult9416 = callmethod(strlit9415, "++", 1, partcv, params);
// compiled op node returning opresult9416 (depth = 9)
  int op_slot_left_9408 = gc_frame_newslot(opresult9416);
  params[0] = strlit9409;
  partcv[0] = 1;
  Object opresult9417 = callmethod(opresult9416, "++", 1, partcv, params);
// compiled op node returning opresult9417 (depth = 8)
  gc_frame_newslot(opresult9417);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = call9407;
  params[2] = opresult9417;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9418 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9405);
// compiled call node returning call9418 (depth = 7)
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe9419 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9420 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9419);
// compiled call node returning call9420 (depth = 7)
    gc_frame_newslot(call9420);
    if9395 = call9420;
  } else {
  }
// compiled if node returning if9395 (depth = 6)
    gc_frame_newslot(if9395);
    if9374 = if9395;
  }
// compiled if node returning if9374 (depth = 5)
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9421 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9422 == NULL) {
    strlit9422 = alloc_String("A declaration of a method named '[]' must have the parameter name in parentheses after the '[]'.");
    gc_root(strlit9422);
  }
// compiled string node returning strlit9422 (depth = 6)
  gc_frame_newslot(strlit9422);
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9424 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9423);
// compiled call node returning call9424 (depth = 7)
// compiled member node returning call9424 (depth = 6)
  gc_frame_newslot(call9424);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9426 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9427 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9426);
// compiled call node returning call9427 (depth = 8)
// compiled member node returning call9427 (depth = 7)
  int op_slot_right_9425 = gc_frame_newslot(call9427);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9429 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9430 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9429);
// compiled call node returning call9430 (depth = 8)
// compiled member node returning call9430 (depth = 7)
  int op_slot_left_9425 = gc_frame_newslot(call9430);
  params[0] = call9427;
  partcv[0] = 1;
  Object sum9431 = callmethod(call9430, "+", 1, partcv, params);
// compiled op node returning sum9431 (depth = 6)
  gc_frame_newslot(sum9431);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 2934
  setline(2934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9422;
  params[1] = call9424;
  params[2] = sum9431;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9432 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9421);
// compiled call node returning call9432 (depth = 5)
    gc_frame_newslot(call9432);
    if9337 = call9432;
  } else {
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9433 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe9434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call9435 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9434);
// compiled call node returning call9435 (depth = 9)
// compiled member node returning call9435 (depth = 8)
  partcv[0] = 0;
  Object call9436 = callmethod(call9435, "new",
    1, partcv, params);
  gc_frame_end(callframe9433);
// compiled call node returning call9436 (depth = 7)
// compiled member node returning call9436 (depth = 6)
  *var_suggestion = call9436;
  if (call9436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9437 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9438 == NULL) {
    strlit9438 = alloc_String("]");
    gc_root(strlit9438);
  }
// compiled string node returning strlit9438 (depth = 6)
  gc_frame_newslot(strlit9438);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit9438;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9439 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9437);
// compiled call node returning call9439 (depth = 5)
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9440 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9441 == NULL) {
    strlit9441 = alloc_String("A method name must start with either an identifier or '[]'.");
    gc_root(strlit9441);
  }
// compiled string node returning strlit9441 (depth = 6)
  gc_frame_newslot(strlit9441);
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9442 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9443 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9442);
// compiled call node returning call9443 (depth = 7)
// compiled member node returning call9443 (depth = 6)
  gc_frame_newslot(call9443);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9445 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9446 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9445);
// compiled call node returning call9446 (depth = 8)
// compiled member node returning call9446 (depth = 7)
  int op_slot_right_9444 = gc_frame_newslot(call9446);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call9449 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9448);
// compiled call node returning call9449 (depth = 8)
// compiled member node returning call9449 (depth = 7)
  int op_slot_left_9444 = gc_frame_newslot(call9449);
  params[0] = call9446;
  partcv[0] = 1;
  Object sum9450 = callmethod(call9449, "+", 1, partcv, params);
// compiled op node returning sum9450 (depth = 6)
  gc_frame_newslot(sum9450);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit9441;
  params[1] = call9443;
  params[2] = sum9450;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9451 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9440);
// compiled call node returning call9451 (depth = 5)
    gc_frame_newslot(call9451);
    if9337 = call9451;
  }
// compiled if node returning if9337 (depth = 4)
    gc_frame_newslot(if9337);
    if9330 = if9337;
  } else {
  }
// compiled if node returning if9330 (depth = 3)
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9452 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9453 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9452);
// compiled call node returning call9453 (depth = 4)
// compiled member node returning call9453 (depth = 3)
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9454 = gc_frame_new();
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit9455 == NULL) {
    strlit9455 = alloc_String("[]");
    gc_root(strlit9455);
  }
// compiled string node returning strlit9455 (depth = 5)
  gc_frame_newslot(strlit9455);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = strlit9455;
  partcv[0] = 1;
  Object call9456 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9454);
// compiled call node returning call9456 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9323 = done;
  } else {
  }
// compiled if node returning if9323 (depth = 2)
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2946
  setline(2946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9458 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9459 == NULL) {
    strlit9459 = alloc_String("lgeneric");
    gc_root(strlit9459);
  }
// compiled string node returning strlit9459 (depth = 4)
  gc_frame_newslot(strlit9459);
// call case 4: self request
  params[0] = strlit9459;
  partcv[0] = 1;
  Object call9460 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9458);
// compiled call node returning call9460 (depth = 3)
  Object if9457 = done;
  if (istrue(call9460)) {
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9461 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9462 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9461);
// compiled call node returning call9462 (depth = 4)
// compiled member node returning call9462 (depth = 3)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9463 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  partcv[0] = 0;
  Object call9464 = callmethod(*var_part, "generics",
    1, partcv, params);
  gc_frame_end(callframe9463);
// compiled call node returning call9464 (depth = 5)
// compiled member node returning call9464 (depth = 4)
  *var_genericIdents = call9464;
  if (call9464 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 2950
  setline(2950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9466 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9467 = alloc_Block(NULL, NULL, "parser", 2950);
  gc_frame_newslot(block9467);
// method _apply
  block_savedest(block9467);
  Object closure9468 = createclosure(1, "_apply");
  setclosureframe(closure9468, stackframe);
  addtoclosure(closure9468, selfslot);
  struct UserObject *uo9468 = (struct UserObject*)block9467;
  uo9468->data[0] = (Object)closure9468;
  Method *meth_meth_parser__apply9468 = addmethod2pos(block9467, "_apply", &meth_parser__apply9468, 0);
  int argcv_meth_parser__apply9468[] = {0};
  meth_meth_parser__apply9468->type = alloc_MethodType(1, argcv_meth_parser__apply9468);
  meth_meth_parser__apply9468->definitionModule = modulename;
  meth_meth_parser__apply9468->definitionLine = 2949;
// compiled block node returning block9467 (depth = 4)
  gc_frame_newslot(block9467);
// starting to compile block node (depth = 4)
  Object block9473 = alloc_Block(NULL, NULL, "parser", 2950);
  gc_frame_newslot(block9473);
// method _apply
  block_savedest(block9473);
  Object closure9474 = createclosure(3, "_apply");
  setclosureframe(closure9474, stackframe);
  addtoclosure(closure9474, var_values);
  addtoclosure(closure9474, var_genericIdents);
  addtoclosure(closure9474, selfslot);
  struct UserObject *uo9474 = (struct UserObject*)block9473;
  uo9474->data[0] = (Object)closure9474;
  Method *meth_meth_parser__apply9474 = addmethod2pos(block9473, "_apply", &meth_parser__apply9474, 0);
  int argcv_meth_parser__apply9474[] = {0};
  meth_meth_parser__apply9474->type = alloc_MethodType(1, argcv_meth_parser__apply9474);
  meth_meth_parser__apply9474->definitionModule = modulename;
  meth_meth_parser__apply9474->definitionLine = 2949;
// compiled block node returning block9473 (depth = 4)
  gc_frame_newslot(block9473);
// call case 5: prelude request
  params[0] = block9467;
  params[1] = block9473;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9491 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9466);
// compiled call node returning call9491 (depth = 3)
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9494 == NULL) {
    strlit9494 = alloc_String("rgeneric");
    gc_root(strlit9494);
  }
// compiled string node returning strlit9494 (depth = 5)
  int op_slot_right_9493 = gc_frame_newslot(strlit9494);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9496 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9497 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9496);
// compiled call node returning call9497 (depth = 6)
// compiled member node returning call9497 (depth = 5)
  int op_slot_left_9493 = gc_frame_newslot(call9497);
  params[0] = strlit9494;
  partcv[0] = 1;
  Object opresult9498 = callmethod(call9497, "!=", 1, partcv, params);
// compiled op node returning opresult9498 (depth = 4)
  Object if9492 = done;
  if (istrue(opresult9498)) {
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9499 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9500 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9501 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9500);
// compiled call node returning call9501 (depth = 8)
// compiled member node returning call9501 (depth = 7)
  partcv[0] = 0;
  Object call9502 = callmethod(call9501, "new",
    1, partcv, params);
  gc_frame_end(callframe9499);
// compiled call node returning call9502 (depth = 6)
// compiled member node returning call9502 (depth = 5)
  *var_suggestion = call9502;
  if (call9502 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9503 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9504 == NULL) {
    strlit9504 = alloc_String(">");
    gc_root(strlit9504);
  }
// compiled string node returning strlit9504 (depth = 5)
  gc_frame_newslot(strlit9504);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit9504;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9505 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9503);
// compiled call node returning call9505 (depth = 4)
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9506 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9507 == NULL) {
    strlit9507 = alloc_String("A type containing a '<' must end with a '>'.");
    gc_root(strlit9507);
  }
// compiled string node returning strlit9507 (depth = 5)
  gc_frame_newslot(strlit9507);
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9509 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9508);
// compiled call node returning call9509 (depth = 6)
// compiled member node returning call9509 (depth = 5)
  gc_frame_newslot(call9509);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9511 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9512 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9511);
// compiled call node returning call9512 (depth = 7)
// compiled member node returning call9512 (depth = 6)
  int op_slot_right_9510 = gc_frame_newslot(call9512);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9514 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call9515 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9514);
// compiled call node returning call9515 (depth = 7)
// compiled member node returning call9515 (depth = 6)
  int op_slot_left_9510 = gc_frame_newslot(call9515);
  params[0] = call9512;
  partcv[0] = 1;
  Object sum9516 = callmethod(call9515, "+", 1, partcv, params);
// compiled op node returning sum9516 (depth = 5)
  gc_frame_newslot(sum9516);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9507;
  params[1] = call9509;
  params[2] = sum9516;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9517 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9506);
// compiled call node returning call9517 (depth = 4)
    gc_frame_newslot(call9517);
    if9492 = call9517;
  } else {
  }
// compiled if node returning if9492 (depth = 3)
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9518 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9519 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9518);
// compiled call node returning call9519 (depth = 4)
// compiled member node returning call9519 (depth = 3)
    gc_frame_newslot(call9519);
    if9457 = call9519;
  } else {
  }
// compiled if node returning if9457 (depth = 2)
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9521 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9522 == NULL) {
    strlit9522 = alloc_String("bind");
    gc_root(strlit9522);
  }
// compiled string node returning strlit9522 (depth = 4)
  gc_frame_newslot(strlit9522);
// call case 4: self request
  params[0] = strlit9522;
  partcv[0] = 1;
  Object call9523 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9521);
// compiled call node returning call9523 (depth = 3)
  Object if9520 = done;
  if (istrue(call9523)) {
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9524 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9525 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9524);
// compiled call node returning call9525 (depth = 4)
// compiled member node returning call9525 (depth = 3)
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9526 = gc_frame_new();
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9528 == NULL) {
    strlit9528 = alloc_String(":=");
    gc_root(strlit9528);
  }
// compiled string node returning strlit9528 (depth = 6)
  int op_slot_right_9527 = gc_frame_newslot(strlit9528);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9530 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9531 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9530);
// compiled call node returning call9531 (depth = 7)
// compiled member node returning call9531 (depth = 6)
  int op_slot_left_9527 = gc_frame_newslot(call9531);
  params[0] = strlit9528;
  partcv[0] = 1;
  Object opresult9532 = callmethod(call9531, "++", 1, partcv, params);
// compiled op node returning opresult9532 (depth = 5)
  gc_frame_newslot(opresult9532);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meth (depth = 5)
  params[0] = opresult9532;
  partcv[0] = 1;
  Object call9533 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9526);
// compiled call node returning call9533 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9534 = gc_frame_new();
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit9536 == NULL) {
    strlit9536 = alloc_String(":=");
    gc_root(strlit9536);
  }
// compiled string node returning strlit9536 (depth = 6)
  int op_slot_right_9535 = gc_frame_newslot(strlit9536);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_part (depth = 8)
  partcv[0] = 0;
  Object call9539 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9538);
// compiled call node returning call9539 (depth = 7)
// compiled member node returning call9539 (depth = 6)
  int op_slot_left_9535 = gc_frame_newslot(call9539);
  params[0] = strlit9536;
  partcv[0] = 1;
  Object opresult9540 = callmethod(call9539, "++", 1, partcv, params);
// compiled op node returning opresult9540 (depth = 5)
  gc_frame_newslot(opresult9540);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = opresult9540;
  partcv[0] = 1;
  Object call9541 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9534);
// compiled call node returning call9541 (depth = 4)
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9520 = done;
  } else {
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit9545 == NULL) {
    strlit9545 = alloc_String("prefix");
    gc_root(strlit9545);
  }
// compiled string node returning strlit9545 (depth = 6)
  int op_slot_right_9544 = gc_frame_newslot(strlit9545);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9547 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_meth (depth = 8)
  partcv[0] = 0;
  Object call9548 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9547);
// compiled call node returning call9548 (depth = 7)
// compiled member node returning call9548 (depth = 6)
  int op_slot_left_9544 = gc_frame_newslot(call9548);
  params[0] = strlit9545;
  partcv[0] = 1;
  Object opresult9549 = callmethod(call9548, "==", 1, partcv, params);
// compiled op node returning opresult9549 (depth = 5)
  int op_slot_right_9543 = gc_frame_newslot(opresult9549);
// starting to compile call node (depth = 5)
  int callframe9551 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9552 == NULL) {
    strlit9552 = alloc_String("op");
    gc_root(strlit9552);
  }
// compiled string node returning strlit9552 (depth = 6)
  gc_frame_newslot(strlit9552);
// call case 4: self request
  params[0] = strlit9552;
  partcv[0] = 1;
  Object call9553 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9551);
// compiled call node returning call9553 (depth = 5)
  int op_slot_left_9543 = gc_frame_newslot(call9553);
  params[0] = opresult9549;
  partcv[0] = 1;
  Object opresult9554 = callmethod(call9553, "&&", 1, partcv, params);
// compiled op node returning opresult9554 (depth = 4)
  Object if9542 = done;
  if (istrue(opresult9554)) {
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9555 = gc_frame_new();
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9557 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9558 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9557);
// compiled call node returning call9558 (depth = 8)
// compiled member node returning call9558 (depth = 7)
  int op_slot_right_9556 = gc_frame_newslot(call9558);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9560 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_meth (depth = 9)
  partcv[0] = 0;
  Object call9561 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9560);
// compiled call node returning call9561 (depth = 8)
// compiled member node returning call9561 (depth = 7)
  int op_slot_left_9556 = gc_frame_newslot(call9561);
  params[0] = call9558;
  partcv[0] = 1;
  Object opresult9562 = callmethod(call9561, "++", 1, partcv, params);
// compiled op node returning opresult9562 (depth = 6)
  gc_frame_newslot(opresult9562);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  params[0] = opresult9562;
  partcv[0] = 1;
  Object call9563 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9555);
// compiled call node returning call9563 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9564 = gc_frame_new();
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9566 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9567 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9566);
// compiled call node returning call9567 (depth = 8)
// compiled member node returning call9567 (depth = 7)
  int op_slot_right_9565 = gc_frame_newslot(call9567);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9569 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call9570 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9569);
// compiled call node returning call9570 (depth = 8)
// compiled member node returning call9570 (depth = 7)
  int op_slot_left_9565 = gc_frame_newslot(call9570);
  params[0] = call9567;
  partcv[0] = 1;
  Object opresult9571 = callmethod(call9570, "++", 1, partcv, params);
// compiled op node returning opresult9571 (depth = 6)
  gc_frame_newslot(opresult9571);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = opresult9571;
  partcv[0] = 1;
  Object call9572 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9564);
// compiled call node returning call9572 (depth = 5)
// compiled bind node returning done (depth = 4)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9573 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9574 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9573);
// compiled call node returning call9574 (depth = 5)
// compiled member node returning call9574 (depth = 4)
    gc_frame_newslot(call9574);
    if9542 = call9574;
  } else {
  }
// compiled if node returning if9542 (depth = 3)
    gc_frame_newslot(if9542);
    if9520 = if9542;
  }
// compiled if node returning if9520 (depth = 2)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9575 = alloc_Boolean(0);
// compiled identifier node returning bool9575 (depth = 3)
  *var_dtype = bool9575;
  if (bool9575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9576 = alloc_Boolean(0);
// compiled identifier node returning bool9576 (depth = 3)
  *var_varargs = bool9576;
  if (bool9576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool9577 = alloc_Boolean(0);
// compiled identifier node returning bool9577 (depth = 3)
  *var_vararg = bool9577;
  if (bool9577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9579 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9580 == NULL) {
    strlit9580 = alloc_String("lparen");
    gc_root(strlit9580);
  }
// compiled string node returning strlit9580 (depth = 4)
  gc_frame_newslot(strlit9580);
// call case 4: self request
  params[0] = strlit9580;
  partcv[0] = 1;
  Object call9581 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9579);
// compiled call node returning call9581 (depth = 3)
  Object if9578 = done;
  if (istrue(call9581)) {
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9582 = gc_frame_new();
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9583 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9584 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9583);
// compiled call node returning call9584 (depth = 6)
// compiled member node returning call9584 (depth = 5)
  gc_frame_newslot(call9584);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_part (depth = 5)
  params[0] = call9584;
  partcv[0] = 1;
  Object call9585 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9582);
// compiled call node returning call9585 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9586 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9587 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9586);
// compiled call node returning call9587 (depth = 4)
// compiled member node returning call9587 (depth = 3)
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_id = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9588 = alloc_Boolean(0);
// compiled identifier node returning bool9588 (depth = 4)
  *var_comma = bool9588;
  if (bool9588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9589 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block9590 = alloc_Block(NULL, NULL, "parser", 2985);
  gc_frame_newslot(block9590);
// method _apply
  block_savedest(block9590);
  Object closure9591 = createclosure(2, "_apply");
  setclosureframe(closure9591, stackframe);
  addtoclosure(closure9591, var_sym);
  addtoclosure(closure9591, selfslot);
  struct UserObject *uo9591 = (struct UserObject*)block9590;
  uo9591->data[0] = (Object)closure9591;
  Method *meth_meth_parser__apply9591 = addmethod2pos(block9590, "_apply", &meth_parser__apply9591, 0);
  int argcv_meth_parser__apply9591[] = {0};
  meth_meth_parser__apply9591->type = alloc_MethodType(1, argcv_meth_parser__apply9591);
  meth_meth_parser__apply9591->definitionModule = modulename;
  meth_meth_parser__apply9591->definitionLine = 2982;
// compiled block node returning block9590 (depth = 4)
  gc_frame_newslot(block9590);
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block9611 = alloc_Block(NULL, NULL, "parser", 2986);
  gc_frame_newslot(block9611);
// method _apply
  block_savedest(block9611);
  Object closure9612 = createclosure(12, "_apply");
  setclosureframe(closure9612, stackframe);
  addtoclosure(closure9612, var_sym);
  addtoclosure(closure9612, var_errormessages);
  addtoclosure(closure9612, var_lastToken);
  addtoclosure(closure9612, var_comma);
  addtoclosure(closure9612, var_vararg);
  addtoclosure(closure9612, var_varargs);
  addtoclosure(closure9612, var_values);
  addtoclosure(closure9612, var_id);
  addtoclosure(closure9612, var_dtype);
  addtoclosure(closure9612, var_part);
  addtoclosure(closure9612, var_lparen);
  addtoclosure(closure9612, selfslot);
  struct UserObject *uo9612 = (struct UserObject*)block9611;
  uo9612->data[0] = (Object)closure9612;
  Method *meth_meth_parser__apply9612 = addmethod2pos(block9611, "_apply", &meth_parser__apply9612, 0);
  int argcv_meth_parser__apply9612[] = {0};
  meth_meth_parser__apply9612->type = alloc_MethodType(1, argcv_meth_parser__apply9612);
  meth_meth_parser__apply9612->definitionModule = modulename;
  meth_meth_parser__apply9612->definitionLine = 2986;
// compiled block node returning block9611 (depth = 4)
  gc_frame_newslot(block9611);
// call case 5: prelude request
  params[0] = block9590;
  params[1] = block9611;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9874 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9589);
// compiled call node returning call9874 (depth = 3)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9877 == NULL) {
    strlit9877 = alloc_String("rparen");
    gc_root(strlit9877);
  }
// compiled string node returning strlit9877 (depth = 5)
  int op_slot_right_9876 = gc_frame_newslot(strlit9877);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9879 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9880 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9879);
// compiled call node returning call9880 (depth = 6)
// compiled member node returning call9880 (depth = 5)
  int op_slot_left_9876 = gc_frame_newslot(call9880);
  params[0] = strlit9877;
  partcv[0] = 1;
  Object opresult9881 = callmethod(call9880, "!=", 1, partcv, params);
// compiled op node returning opresult9881 (depth = 4)
  Object if9875 = done;
  if (istrue(opresult9881)) {
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3065
  setline(3065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9882 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9883 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call9884 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9883);
// compiled call node returning call9884 (depth = 8)
// compiled member node returning call9884 (depth = 7)
  partcv[0] = 0;
  Object call9885 = callmethod(call9884, "new",
    1, partcv, params);
  gc_frame_end(callframe9882);
// compiled call node returning call9885 (depth = 6)
// compiled member node returning call9885 (depth = 5)
  *var_suggestion = call9885;
  if (call9885 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9886 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block9887 = alloc_Block(NULL, NULL, "parser", 3066);
  gc_frame_newslot(block9887);
// method _apply
  block_savedest(block9887);
  Object closure9888 = createclosure(2, "_apply");
  setclosureframe(closure9888, stackframe);
  addtoclosure(closure9888, var_lastToken);
  addtoclosure(closure9888, selfslot);
  struct UserObject *uo9888 = (struct UserObject*)block9887;
  uo9888->data[0] = (Object)closure9888;
  Method *meth_meth_parser__apply9888 = addmethod2pos(block9887, "_apply", &meth_parser__apply9888, 0);
  int argcv_meth_parser__apply9888[] = {1};
  meth_meth_parser__apply9888->type = alloc_MethodType(1, argcv_meth_parser__apply9888);
  meth_meth_parser__apply9888->definitionModule = modulename;
  meth_meth_parser__apply9888->definitionLine = 3065;
// compiled block node returning block9887 (depth = 6)
  gc_frame_newslot(block9887);
// call case 4: self request
  params[0] = block9887;
  partcv[0] = 1;
  Object call9906 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9886);
// compiled call node returning call9906 (depth = 5)
  *var_rparen = call9906;
  if (call9906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool9909 = alloc_Boolean(0);
// compiled identifier node returning bool9909 (depth = 6)
  int op_slot_right_9908 = gc_frame_newslot(bool9909);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rparen (depth = 6)
  int op_slot_left_9908 = gc_frame_newslot(*var_rparen);
  params[0] = bool9909;
  partcv[0] = 1;
  Object opresult9911 = callmethod(*var_rparen, "==", 1, partcv, params);
// compiled op node returning opresult9911 (depth = 5)
  Object if9907 = done;
  if (istrue(opresult9911)) {
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9912 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// starting to compile string node (depth = 6)
  if (strlit9913 == NULL) {
    strlit9913 = alloc_String(")");
    gc_root(strlit9913);
  }
// compiled string node returning strlit9913 (depth = 6)
  gc_frame_newslot(strlit9913);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_lastToken;
  params[1] = strlit9913;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9914 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9912);
// compiled call node returning call9914 (depth = 5)
    gc_frame_newslot(call9914);
    if9907 = call9914;
  } else {
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9915 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9916 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9915);
// compiled call node returning call9916 (depth = 5)
    gc_frame_newslot(call9916);
    if9907 = call9916;
  }
// compiled if node returning if9907 (depth = 4)
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe9917 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit9918 == NULL) {
    strlit9918 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9918);
  }
// compiled string node returning strlit9918 (depth = 5)
  gc_frame_newslot(strlit9918);
// Begin line 3073
  setline(3073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9919 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9920 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9919);
// compiled call node returning call9920 (depth = 6)
// compiled member node returning call9920 (depth = 5)
  gc_frame_newslot(call9920);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9921 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9922 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9921);
// compiled call node returning call9922 (depth = 6)
// compiled member node returning call9922 (depth = 5)
  gc_frame_newslot(call9922);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9923 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call9924 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9923);
// compiled call node returning call9924 (depth = 6)
// compiled member node returning call9924 (depth = 5)
  gc_frame_newslot(call9924);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit9918;
  params[1] = call9920;
  params[2] = call9922;
  params[3] = call9924;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9925 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9917);
// compiled call node returning call9925 (depth = 4)
    gc_frame_newslot(call9925);
    if9875 = call9925;
  } else {
  }
// compiled if node returning if9875 (depth = 3)
// Begin line 3078
  setline(3078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9928 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_part (depth = 7)
  partcv[0] = 0;
  Object call9929 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9928);
// compiled call node returning call9929 (depth = 6)
// compiled member node returning call9929 (depth = 5)
  int op_slot_right_9927 = gc_frame_newslot(call9929);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9931 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call9932 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9931);
// compiled call node returning call9932 (depth = 6)
// compiled member node returning call9932 (depth = 5)
  int op_slot_left_9927 = gc_frame_newslot(call9932);
  params[0] = call9929;
  partcv[0] = 1;
  Object opresult9933 = callmethod(call9932, "==", 1, partcv, params);
// compiled op node returning opresult9933 (depth = 4)
  Object if9926 = done;
  if (istrue(opresult9933)) {
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe9934 = gc_frame_new();
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 3076
  setline(3076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_part (depth = 9)
  partcv[0] = 0;
  Object call9937 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9936);
// compiled call node returning call9937 (depth = 8)
// compiled member node returning call9937 (depth = 7)
  int op_slot_right_9935 = gc_frame_newslot(call9937);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe9939 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call9940 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9939);
// compiled call node returning call9940 (depth = 8)
// compiled member node returning call9940 (depth = 7)
  int op_slot_left_9935 = gc_frame_newslot(call9940);
  params[0] = call9937;
  partcv[0] = 1;
  Object diff9941 = callmethod(call9940, "-", 1, partcv, params);
// compiled op node returning diff9941 (depth = 6)
  gc_frame_newslot(diff9941);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_part (depth = 6)
  params[0] = diff9941;
  partcv[0] = 1;
  Object call9942 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9934);
// compiled call node returning call9942 (depth = 5)
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9926 = done;
  } else {
  }
// compiled if node returning if9926 (depth = 3)
// Begin line 3078
  setline(3078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9943 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9944 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9943);
// compiled call node returning call9944 (depth = 4)
// compiled member node returning call9944 (depth = 3)
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9947 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit9948 == NULL) {
    strlit9948 = alloc_String("identifier");
    gc_root(strlit9948);
  }
// compiled string node returning strlit9948 (depth = 6)
  gc_frame_newslot(strlit9948);
// call case 4: self request
  params[0] = strlit9948;
  partcv[0] = 1;
  Object call9949 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9947);
// compiled call node returning call9949 (depth = 5)
  int op_slot_right_9946 = gc_frame_newslot(call9949);
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe9952 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit9953 == NULL) {
    strlit9953 = alloc_String("identifier");
    gc_root(strlit9953);
  }
// compiled string node returning strlit9953 (depth = 7)
  gc_frame_newslot(strlit9953);
// call case 4: self request
  params[0] = strlit9953;
  partcv[0] = 1;
  Object call9954 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9952);
// compiled call node returning call9954 (depth = 6)
  int op_slot_right_9951 = gc_frame_newslot(call9954);
// starting to compile call node (depth = 6)
  int callframe9956 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sameline (depth = 7)
  partcv[0] = 0;
  Object call9957 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9956);
// compiled call node returning call9957 (depth = 6)
  int op_slot_left_9951 = gc_frame_newslot(call9957);
  params[0] = call9954;
  partcv[0] = 1;
  Object opresult9958 = callmethod(call9957, "&&", 1, partcv, params);
// compiled op node returning opresult9958 (depth = 5)
  int op_slot_left_9946 = gc_frame_newslot(opresult9958);
  params[0] = call9949;
  partcv[0] = 1;
  Object opresult9959 = callmethod(opresult9958, "||", 1, partcv, params);
// compiled op node returning opresult9959 (depth = 4)
  Object if9945 = done;
  if (istrue(opresult9959)) {
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9960 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  gc_frame_newslot(*var_meth);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_signature (depth = 6)
  gc_frame_newslot(*var_signature);
// starting to compile array node (depth = 6)
  Object array9961 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array9961 (depth = 6)
  gc_frame_newslot(array9961);
// starting to compile identifier node (depth = 6)
  Object bool9962 = alloc_Boolean(0);
// compiled identifier node returning bool9962 (depth = 6)
  gc_frame_newslot(bool9962);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9963 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call9964 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9963);
// compiled call node returning call9964 (depth = 7)
// compiled member node returning call9964 (depth = 6)
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9961;
  params[3] = bool9962;
  partcv[0] = 4;
  Object call9965 = callmethod(call9964, "new",
    1, partcv, params);
  gc_frame_end(callframe9960);
// compiled call node returning call9965 (depth = 5)
  *var_tm = call9965;
  if (call9965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9966 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_tm (depth = 6)
  gc_frame_newslot(*var_tm);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sameline (depth = 6)
  gc_frame_newslot(*var_sameline);
// call case 4: self request
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9967 = callmethodflags(self, "parsempmndecrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9966);
// compiled call node returning call9967 (depth = 5)
  *var_meth = call9967;
  if (call9967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// Begin line 3085
  setline(3085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe9970 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tm (depth = 8)
  partcv[0] = 0;
  Object call9971 = callmethod(*var_tm, "varargs",
    1, partcv, params);
  gc_frame_end(callframe9970);
// compiled call node returning call9971 (depth = 7)
// compiled member node returning call9971 (depth = 6)
  int op_slot_right_9969 = gc_frame_newslot(call9971);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_varargs (depth = 6)
  int op_slot_left_9969 = gc_frame_newslot(*var_varargs);
  params[0] = call9971;
  partcv[0] = 1;
  Object opresult9973 = callmethod(*var_varargs, "||", 1, partcv, params);
// compiled op node returning opresult9973 (depth = 5)
  *var_varargs = opresult9973;
  if (opresult9973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if9945 = done;
  } else {
  }
// compiled if node returning if9945 (depth = 3)
    gc_frame_newslot(if9945);
    if9578 = if9945;
  } else {
  }
// compiled if node returning if9578 (depth = 2)
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe9976 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit9977 == NULL) {
    strlit9977 = alloc_String("arrow");
    gc_root(strlit9977);
  }
// compiled string node returning strlit9977 (depth = 4)
  gc_frame_newslot(strlit9977);
// call case 4: self request
  params[0] = strlit9977;
  partcv[0] = 1;
  Object call9978 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9976);
// compiled call node returning call9978 (depth = 3)
  Object if9975 = done;
  if (istrue(call9978)) {
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9979 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9980 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9979);
// compiled call node returning call9980 (depth = 4)
// compiled member node returning call9980 (depth = 3)
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe9981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call9982 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9981);
// compiled call node returning call9982 (depth = 4)
// compiled member node returning call9982 (depth = 3)
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3092
  setline(3092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe9983 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call9984 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9983);
// compiled call node returning call9984 (depth = 5)
// compiled member node returning call9984 (depth = 4)
  *var_dtype = call9984;
  if (call9984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9975 = done;
  } else {
// Begin line 3095
  setline(3095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3094
  setline(3094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool9986 = alloc_Boolean(0);
// compiled identifier node returning bool9986 (depth = 4)
  *var_dtype = bool9986;
  if (bool9986 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if9975 = done;
  }
// compiled if node returning if9975 (depth = 2)
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile object node (depth = 3)
  Object inheritingObject9988 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9988 = alloc_userobj2(10,6, objclass9988);
  gc_frame_newslot(obj9988);
// OBJECT OUTER DEC outer
  adddatum2(obj9988, self, 0);
  addmethodreal(obj9988,"outer", &reader_parser_outer_9989);
  Object oldself9988 = self;
  struct StackFrameObject *oldstackframe9988 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9988);
  gc_frame_newslot((Object)stackframe);
  self = obj9988;
  Object *oldselfslot9988 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9988 = (*(struct UserObject *)self).data[0], lowerouter9988 = thisouter9988;
  if (inheritingObject9988) {
    struct UserObject *inho9988 = (struct UserObject *)inheritingObject9988;
    while (inho9988->super != GraceDefaultObject) inho9988 = (struct UserObject *)inho9988->super;
    inho9988->super = obj9988;
    self = inheritingObject9988;
    *selfslot = self;
    lowerouter9988 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9988;
  }
if (objclass9988 == NULL) {
  Method *reader9990 = addmethodrealflags(obj9988, "m",&reader_parser_m_9990, 0);
  Method *writer9990 = addmethodrealflags(obj9988, "m:=",&writer_parser_m_9990, 0);
  reader9990->definitionModule = modulename;
  writer9990->definitionModule = modulename;
  reader9990->definitionLine = 3098;
  writer9990->definitionLine = 3098;
}
obj9988->flags |= OFLAG_MUTABLE;
adddatum2(obj9988, alloc_Undefined(), 1);
if (objclass9988 == NULL) {
  Method *reader9991 = addmethodrealflags(obj9988, "sig",&reader_parser_sig_9991, 0);
  Method *writer9991 = addmethodrealflags(obj9988, "sig:=",&writer_parser_sig_9991, 0);
  reader9991->definitionModule = modulename;
  writer9991->definitionModule = modulename;
  reader9991->definitionLine = 3099;
  writer9991->definitionLine = 3099;
}
obj9988->flags |= OFLAG_MUTABLE;
adddatum2(obj9988, alloc_Undefined(), 2);
if (objclass9988 == NULL) {
  Method *reader9992 = addmethodrealflags(obj9988, "rtype",&reader_parser_rtype_9992, 0);
  Method *writer9992 = addmethodrealflags(obj9988, "rtype:=",&writer_parser_rtype_9992, 0);
  reader9992->definitionModule = modulename;
  writer9992->definitionModule = modulename;
  reader9992->definitionLine = 3100;
  writer9992->definitionLine = 3100;
}
obj9988->flags |= OFLAG_MUTABLE;
adddatum2(obj9988, alloc_Undefined(), 3);
if (objclass9988 == NULL) {
  Method *reader9993 = addmethodrealflags(obj9988, "v",&reader_parser_v_9993, 0);
  Method *writer9993 = addmethodrealflags(obj9988, "v:=",&writer_parser_v_9993, 0);
  reader9993->definitionModule = modulename;
  writer9993->definitionModule = modulename;
  reader9993->definitionLine = 3101;
  writer9993->definitionLine = 3101;
}
obj9988->flags |= OFLAG_MUTABLE;
adddatum2(obj9988, alloc_Undefined(), 4);
if (objclass9988 == NULL) {
  Method *reader9994 = addmethodrealflags(obj9988, "generics",&reader_parser_generics_9994, 0);
  Method *writer9994 = addmethodrealflags(obj9988, "generics:=",&writer_parser_generics_9994, 0);
  reader9994->definitionModule = modulename;
  writer9994->definitionModule = modulename;
  reader9994->definitionLine = 3102;
  writer9994->definitionLine = 3102;
}
obj9988->flags |= OFLAG_MUTABLE;
adddatum2(obj9988, alloc_Undefined(), 5);
  sourceObject = obj9988;
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_meth (depth = 4)
  adddatum2(obj9988, *var_meth, 1);
  sourceObject = obj9988;
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature (depth = 4)
  adddatum2(obj9988, *var_signature, 2);
  sourceObject = obj9988;
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  adddatum2(obj9988, *var_dtype, 3);
  sourceObject = obj9988;
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_varargs (depth = 4)
  adddatum2(obj9988, *var_varargs, 4);
  sourceObject = obj9988;
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_genericIdents (depth = 4)
  adddatum2(obj9988, *var_genericIdents, 5);
objclass9988 = obj9988->class;
  objclass9988->definitionModule = modulename;
  objclass9988->definitionLine = 3096;
  (*(struct UserObject *)self).data[0] = lowerouter9988;
  self = oldself9988;
  selfslot = oldselfslot9988;
  stackframe = oldstackframe9988;
// compiled object node returning obj9988 (depth = 3)
  *var_o = obj9988;
  if (obj9988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3103
  setline(3103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_o (depth = 2)
  gc_frame_end(frame);
  return *var_o;
}
Object meth_parser_doimport9995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(12, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_defaultDefVisibility = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doimport (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doimport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_importline = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importline");
  Object *var_dtype = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "dtype");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_errorPos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "errorPos");
  Object *var_p = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "p");
  Object *var_name = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "name");
  Object *var_o = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "o");
  Object *var_anns = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "anns");
// Begin line 3167
  setline(3167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3109
  setline(3109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit9999 == NULL) {
    strlit9999 = alloc_String("import");
    gc_root(strlit9999);
  }
// compiled string node returning strlit9999 (depth = 5)
  int op_slot_right_9998 = gc_frame_newslot(strlit9999);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10001 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10002 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10001);
// compiled call node returning call10002 (depth = 6)
// compiled member node returning call10002 (depth = 5)
  int op_slot_left_9998 = gc_frame_newslot(call10002);
  params[0] = strlit9999;
  partcv[0] = 1;
  Object opresult10003 = callmethod(call10002, "==", 1, partcv, params);
// compiled op node returning opresult10003 (depth = 4)
  int op_slot_right_9997 = gc_frame_newslot(opresult10003);
// starting to compile call node (depth = 4)
  int callframe10005 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10006 == NULL) {
    strlit10006 = alloc_String("keyword");
    gc_root(strlit10006);
  }
// compiled string node returning strlit10006 (depth = 5)
  gc_frame_newslot(strlit10006);
// call case 4: self request
  params[0] = strlit10006;
  partcv[0] = 1;
  Object call10007 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10005);
// compiled call node returning call10007 (depth = 4)
  int op_slot_left_9997 = gc_frame_newslot(call10007);
  params[0] = opresult10003;
  partcv[0] = 1;
  Object opresult10008 = callmethod(call10007, "&&", 1, partcv, params);
// compiled op node returning opresult10008 (depth = 3)
  Object if9996 = done;
  if (istrue(opresult10008)) {
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3110
  setline(3110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10009 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10010 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10009);
// compiled call node returning call10010 (depth = 5)
// compiled member node returning call10010 (depth = 4)
  *var_importline = call10010;
  if (call10010 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10011 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call10012 = callmethod(*var_ast, "unknownType",
    1, partcv, params);
  gc_frame_end(callframe10011);
// compiled call node returning call10012 (depth = 5)
// compiled member node returning call10012 (depth = 4)
  *var_dtype = call10012;
  if (call10012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10014 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10013);
// compiled call node returning call10014 (depth = 4)
// compiled member node returning call10014 (depth = 3)
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10017 == NULL) {
    strlit10017 = alloc_String("string");
    gc_root(strlit10017);
  }
// compiled string node returning strlit10017 (depth = 5)
  int op_slot_right_10016 = gc_frame_newslot(strlit10017);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10019 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10020 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10019);
// compiled call node returning call10020 (depth = 6)
// compiled member node returning call10020 (depth = 5)
  int op_slot_left_10016 = gc_frame_newslot(call10020);
  params[0] = strlit10017;
  partcv[0] = 1;
  Object opresult10021 = callmethod(call10020, "!=", 1, partcv, params);
// compiled op node returning opresult10021 (depth = 4)
  Object if10015 = done;
  if (istrue(opresult10021)) {
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 3114
  setline(3114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10022 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10023 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10024 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10023);
// compiled call node returning call10024 (depth = 8)
// compiled member node returning call10024 (depth = 7)
  partcv[0] = 0;
  Object call10025 = callmethod(call10024, "new",
    1, partcv, params);
  gc_frame_end(callframe10022);
// compiled call node returning call10025 (depth = 6)
// compiled member node returning call10025 (depth = 5)
  *var_suggestion = call10025;
  if (call10025 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10029 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10030 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10029);
// compiled call node returning call10030 (depth = 8)
// compiled member node returning call10030 (depth = 7)
  int op_slot_right_10028 = gc_frame_newslot(call10030);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10032 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10033 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10032);
// compiled call node returning call10033 (depth = 8)
// compiled member node returning call10033 (depth = 7)
  int op_slot_left_10028 = gc_frame_newslot(call10033);
  params[0] = call10030;
  partcv[0] = 1;
  Object opresult10034 = callmethod(call10033, "==", 1, partcv, params);
// compiled op node returning opresult10034 (depth = 6)
  int op_slot_right_10027 = gc_frame_newslot(opresult10034);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10037 == NULL) {
    strlit10037 = alloc_String("identifier");
    gc_root(strlit10037);
  }
// compiled string node returning strlit10037 (depth = 7)
  int op_slot_right_10036 = gc_frame_newslot(strlit10037);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10039 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10040 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10039);
// compiled call node returning call10040 (depth = 8)
// compiled member node returning call10040 (depth = 7)
  int op_slot_left_10036 = gc_frame_newslot(call10040);
  params[0] = strlit10037;
  partcv[0] = 1;
  Object opresult10041 = callmethod(call10040, "==", 1, partcv, params);
// compiled op node returning opresult10041 (depth = 6)
  int op_slot_left_10027 = gc_frame_newslot(opresult10041);
  params[0] = opresult10034;
  partcv[0] = 1;
  Object opresult10042 = callmethod(opresult10041, "&&", 1, partcv, params);
// compiled op node returning opresult10042 (depth = 5)
  Object if10026 = done;
  if (istrue(opresult10042)) {
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10043 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10045 == NULL) {
    strlit10045 = alloc_String("""\x22""");
    gc_root(strlit10045);
  }
// compiled string node returning strlit10045 (depth = 7)
  int op_slot_right_10044 = gc_frame_newslot(strlit10045);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10048 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10049 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10048);
// compiled call node returning call10049 (depth = 9)
// compiled member node returning call10049 (depth = 8)
  int op_slot_right_10047 = gc_frame_newslot(call10049);
// starting to compile string node (depth = 8)
  if (strlit10051 == NULL) {
    strlit10051 = alloc_String("""\x22""");
    gc_root(strlit10051);
  }
// compiled string node returning strlit10051 (depth = 8)
  int op_slot_left_10047 = gc_frame_newslot(strlit10051);
  params[0] = call10049;
  partcv[0] = 1;
  Object opresult10052 = callmethod(strlit10051, "++", 1, partcv, params);
// compiled op node returning opresult10052 (depth = 7)
  int op_slot_left_10044 = gc_frame_newslot(opresult10052);
  params[0] = strlit10045;
  partcv[0] = 1;
  Object opresult10053 = callmethod(opresult10052, "++", 1, partcv, params);
// compiled op node returning opresult10053 (depth = 6)
  gc_frame_newslot(opresult10053);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult10053;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10054 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10043);
// compiled call node returning call10054 (depth = 5)
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10055 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10056 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10055);
// compiled call node returning call10056 (depth = 7)
// compiled member node returning call10056 (depth = 6)
  *var_errorPos = call10056;
  if (call10056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10026 = done;
  } else {
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10058 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10059 == NULL) {
    strlit10059 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit10059);
  }
// compiled string node returning strlit10059 (depth = 6)
  gc_frame_newslot(strlit10059);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10059;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10060 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10058);
// compiled call node returning call10060 (depth = 5)
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3121
  setline(3121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num10062 = alloc_Float64(1);
// compiled num node returning num10062 (depth = 7)
  int op_slot_right_10061 = gc_frame_newslot(num10062);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10065 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10066 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10065);
// compiled call node returning call10066 (depth = 9)
// compiled member node returning call10066 (depth = 8)
  int op_slot_right_10064 = gc_frame_newslot(call10066);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10069 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10068);
// compiled call node returning call10069 (depth = 9)
// compiled member node returning call10069 (depth = 8)
  int op_slot_left_10064 = gc_frame_newslot(call10069);
  params[0] = call10066;
  partcv[0] = 1;
  Object sum10070 = callmethod(call10069, "+", 1, partcv, params);
// compiled op node returning sum10070 (depth = 7)
  int op_slot_left_10061 = gc_frame_newslot(sum10070);
  params[0] = num10062;
  partcv[0] = 1;
  Object sum10071 = callmethod(sum10070, "+", 1, partcv, params);
// compiled op node returning sum10071 (depth = 6)
  *var_errorPos = sum10071;
  if (sum10071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10026 = done;
  }
// compiled if node returning if10026 (depth = 4)
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10073 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10074 == NULL) {
    strlit10074 = alloc_String("An import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit10074);
  }
// compiled string node returning strlit10074 (depth = 5)
  gc_frame_newslot(strlit10074);
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10075 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10076 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10075);
// compiled call node returning call10076 (depth = 6)
// compiled member node returning call10076 (depth = 5)
  gc_frame_newslot(call10076);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10074;
  params[1] = call10076;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10077 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10073);
// compiled call node returning call10077 (depth = 4)
    gc_frame_newslot(call10077);
    if10015 = call10077;
  } else {
  }
// compiled if node returning if10015 (depth = 3)
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10078 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10079 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10078);
// compiled call node returning call10079 (depth = 4)
// compiled member node returning call10079 (depth = 3)
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10081 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10080);
// compiled call node returning call10081 (depth = 5)
// compiled member node returning call10081 (depth = 4)
  *var_p = call10081;
  if (call10081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3138
  setline(3138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10085 == NULL) {
    strlit10085 = alloc_String("as");
    gc_root(strlit10085);
  }
// compiled string node returning strlit10085 (depth = 6)
  int op_slot_right_10084 = gc_frame_newslot(strlit10085);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10087 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10088 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10087);
// compiled call node returning call10088 (depth = 7)
// compiled member node returning call10088 (depth = 6)
  int op_slot_left_10084 = gc_frame_newslot(call10088);
  params[0] = strlit10085;
  partcv[0] = 1;
  Object opresult10089 = callmethod(call10088, "!=", 1, partcv, params);
// compiled op node returning opresult10089 (depth = 5)
  int op_slot_right_10083 = gc_frame_newslot(opresult10089);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10092 == NULL) {
    strlit10092 = alloc_String("identifier");
    gc_root(strlit10092);
  }
// compiled string node returning strlit10092 (depth = 6)
  int op_slot_right_10091 = gc_frame_newslot(strlit10092);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10094 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10095 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10094);
// compiled call node returning call10095 (depth = 7)
// compiled member node returning call10095 (depth = 6)
  int op_slot_left_10091 = gc_frame_newslot(call10095);
  params[0] = strlit10092;
  partcv[0] = 1;
  Object opresult10096 = callmethod(call10095, "!=", 1, partcv, params);
// compiled op node returning opresult10096 (depth = 5)
  int op_slot_left_10083 = gc_frame_newslot(opresult10096);
  params[0] = opresult10089;
  partcv[0] = 1;
  Object opresult10097 = callmethod(opresult10096, "||", 1, partcv, params);
// compiled op node returning opresult10097 (depth = 4)
  Object if10082 = done;
  if (istrue(opresult10097)) {
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10098 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10099 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10100 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10099);
// compiled call node returning call10100 (depth = 8)
// compiled member node returning call10100 (depth = 7)
  partcv[0] = 0;
  Object call10101 = callmethod(call10100, "new",
    1, partcv, params);
  gc_frame_end(callframe10098);
// compiled call node returning call10101 (depth = 6)
// compiled member node returning call10101 (depth = 5)
  *var_suggestion = call10101;
  if (call10101 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3130
  setline(3130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10105 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10106 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10105);
// compiled call node returning call10106 (depth = 8)
// compiled member node returning call10106 (depth = 7)
  int op_slot_right_10104 = gc_frame_newslot(call10106);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10108 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10109 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10108);
// compiled call node returning call10109 (depth = 8)
// compiled member node returning call10109 (depth = 7)
  int op_slot_left_10104 = gc_frame_newslot(call10109);
  params[0] = call10106;
  partcv[0] = 1;
  Object opresult10110 = callmethod(call10109, "==", 1, partcv, params);
// compiled op node returning opresult10110 (depth = 6)
  int op_slot_right_10103 = gc_frame_newslot(opresult10110);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10113 == NULL) {
    strlit10113 = alloc_String("identifier");
    gc_root(strlit10113);
  }
// compiled string node returning strlit10113 (depth = 7)
  int op_slot_right_10112 = gc_frame_newslot(strlit10113);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10115 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10116 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10115);
// compiled call node returning call10116 (depth = 8)
// compiled member node returning call10116 (depth = 7)
  int op_slot_left_10112 = gc_frame_newslot(call10116);
  params[0] = strlit10113;
  partcv[0] = 1;
  Object opresult10117 = callmethod(call10116, "==", 1, partcv, params);
// compiled op node returning opresult10117 (depth = 6)
  int op_slot_left_10103 = gc_frame_newslot(opresult10117);
  params[0] = opresult10110;
  partcv[0] = 1;
  Object opresult10118 = callmethod(opresult10117, "&&", 1, partcv, params);
// compiled op node returning opresult10118 (depth = 5)
  Object if10102 = done;
  if (istrue(opresult10118)) {
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10119 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10120 == NULL) {
    strlit10120 = alloc_String(" as");
    gc_root(strlit10120);
  }
// compiled string node returning strlit10120 (depth = 6)
  gc_frame_newslot(strlit10120);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10120;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10121 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10119);
// compiled call node returning call10121 (depth = 5)
    gc_frame_newslot(call10121);
    if10102 = call10121;
  } else {
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10122 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10124 == NULL) {
    strlit10124 = alloc_String("");
    gc_root(strlit10124);
  }
// compiled string node returning strlit10124 (depth = 7)
  int op_slot_right_10123 = gc_frame_newslot(strlit10124);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10127 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call10128 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10127);
// compiled call node returning call10128 (depth = 9)
// compiled member node returning call10128 (depth = 8)
  int op_slot_right_10126 = gc_frame_newslot(call10128);
// starting to compile string node (depth = 8)
  if (strlit10130 == NULL) {
    strlit10130 = alloc_String(" as ");
    gc_root(strlit10130);
  }
// compiled string node returning strlit10130 (depth = 8)
  int op_slot_left_10126 = gc_frame_newslot(strlit10130);
  params[0] = call10128;
  partcv[0] = 1;
  Object opresult10131 = callmethod(strlit10130, "++", 1, partcv, params);
// compiled op node returning opresult10131 (depth = 7)
  int op_slot_left_10123 = gc_frame_newslot(opresult10131);
  params[0] = strlit10124;
  partcv[0] = 1;
  Object opresult10132 = callmethod(opresult10131, "++", 1, partcv, params);
// compiled op node returning opresult10132 (depth = 6)
  gc_frame_newslot(opresult10132);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult10132;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10133 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10122);
// compiled call node returning call10133 (depth = 5)
    gc_frame_newslot(call10133);
    if10102 = call10133;
  }
// compiled if node returning if10102 (depth = 4)
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10134 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10135 == NULL) {
    strlit10135 = alloc_String("An import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit10135);
  }
// compiled string node returning strlit10135 (depth = 5)
  gc_frame_newslot(strlit10135);
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10136 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10137 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10136);
// compiled call node returning call10137 (depth = 6)
// compiled member node returning call10137 (depth = 5)
  gc_frame_newslot(call10137);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10139 = alloc_Float64(1);
// compiled num node returning num10139 (depth = 6)
  int op_slot_right_10138 = gc_frame_newslot(num10139);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10142 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10143 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10142);
// compiled call node returning call10143 (depth = 8)
// compiled member node returning call10143 (depth = 7)
  int op_slot_right_10141 = gc_frame_newslot(call10143);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10145 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10146 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10145);
// compiled call node returning call10146 (depth = 8)
// compiled member node returning call10146 (depth = 7)
  int op_slot_left_10141 = gc_frame_newslot(call10146);
  params[0] = call10143;
  partcv[0] = 1;
  Object sum10147 = callmethod(call10146, "+", 1, partcv, params);
// compiled op node returning sum10147 (depth = 6)
  int op_slot_left_10138 = gc_frame_newslot(sum10147);
  params[0] = num10139;
  partcv[0] = 1;
  Object sum10148 = callmethod(sum10147, "+", 1, partcv, params);
// compiled op node returning sum10148 (depth = 5)
  gc_frame_newslot(sum10148);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10135;
  params[1] = call10137;
  params[2] = sum10148;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10149 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10134);
// compiled call node returning call10149 (depth = 4)
    gc_frame_newslot(call10149);
    if10082 = call10149;
  } else {
  }
// compiled if node returning if10082 (depth = 3)
// Begin line 3138
  setline(3138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10150 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10151 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10150);
// compiled call node returning call10151 (depth = 4)
// compiled member node returning call10151 (depth = 3)
// Begin line 3152
  setline(3152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10154 == NULL) {
    strlit10154 = alloc_String("identifier");
    gc_root(strlit10154);
  }
// compiled string node returning strlit10154 (depth = 5)
  int op_slot_right_10153 = gc_frame_newslot(strlit10154);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10157 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10156);
// compiled call node returning call10157 (depth = 6)
// compiled member node returning call10157 (depth = 5)
  int op_slot_left_10153 = gc_frame_newslot(call10157);
  params[0] = strlit10154;
  partcv[0] = 1;
  Object opresult10158 = callmethod(call10157, "!=", 1, partcv, params);
// compiled op node returning opresult10158 (depth = 4)
  Object if10152 = done;
  if (istrue(opresult10158)) {
// Begin line 3141
  setline(3141);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 3140
  setline(3140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10159 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10160 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10161 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10160);
// compiled call node returning call10161 (depth = 8)
// compiled member node returning call10161 (depth = 7)
  partcv[0] = 0;
  Object call10162 = callmethod(call10161, "new",
    1, partcv, params);
  gc_frame_end(callframe10159);
// compiled call node returning call10162 (depth = 6)
// compiled member node returning call10162 (depth = 5)
  *var_suggestion = call10162;
  if (call10162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_errorPos = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10166 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10167 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10166);
// compiled call node returning call10167 (depth = 8)
// compiled member node returning call10167 (depth = 7)
  int op_slot_right_10165 = gc_frame_newslot(call10167);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10170 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10169);
// compiled call node returning call10170 (depth = 8)
// compiled member node returning call10170 (depth = 7)
  int op_slot_left_10165 = gc_frame_newslot(call10170);
  params[0] = call10167;
  partcv[0] = 1;
  Object opresult10171 = callmethod(call10170, "==", 1, partcv, params);
// compiled op node returning opresult10171 (depth = 6)
  int op_slot_right_10164 = gc_frame_newslot(opresult10171);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10174 == NULL) {
    strlit10174 = alloc_String("string");
    gc_root(strlit10174);
  }
// compiled string node returning strlit10174 (depth = 7)
  int op_slot_right_10173 = gc_frame_newslot(strlit10174);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10176 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10177 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10176);
// compiled call node returning call10177 (depth = 8)
// compiled member node returning call10177 (depth = 7)
  int op_slot_left_10173 = gc_frame_newslot(call10177);
  params[0] = strlit10174;
  partcv[0] = 1;
  Object opresult10178 = callmethod(call10177, "==", 1, partcv, params);
// compiled op node returning opresult10178 (depth = 6)
  int op_slot_left_10164 = gc_frame_newslot(opresult10178);
  params[0] = opresult10171;
  partcv[0] = 1;
  Object opresult10179 = callmethod(opresult10178, "&&", 1, partcv, params);
// compiled op node returning opresult10179 (depth = 5)
  Object if10163 = done;
  if (istrue(opresult10179)) {
// Begin line 3143
  setline(3143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10180 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10182 == NULL) {
    strlit10182 = alloc_String("");
    gc_root(strlit10182);
  }
// compiled string node returning strlit10182 (depth = 7)
  int op_slot_right_10181 = gc_frame_newslot(strlit10182);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10186 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10185);
// compiled call node returning call10186 (depth = 9)
// compiled member node returning call10186 (depth = 8)
  int op_slot_right_10184 = gc_frame_newslot(call10186);
// starting to compile string node (depth = 8)
  if (strlit10188 == NULL) {
    strlit10188 = alloc_String("");
    gc_root(strlit10188);
  }
// compiled string node returning strlit10188 (depth = 8)
  int op_slot_left_10184 = gc_frame_newslot(strlit10188);
  params[0] = call10186;
  partcv[0] = 1;
  Object opresult10189 = callmethod(strlit10188, "++", 1, partcv, params);
// compiled op node returning opresult10189 (depth = 7)
  int op_slot_left_10181 = gc_frame_newslot(opresult10189);
  params[0] = strlit10182;
  partcv[0] = 1;
  Object opresult10190 = callmethod(opresult10189, "++", 1, partcv, params);
// compiled op node returning opresult10190 (depth = 6)
  gc_frame_newslot(opresult10190);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = opresult10190;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10191 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10180);
// compiled call node returning call10191 (depth = 5)
// Begin line 3145
  setline(3145);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10192 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10193 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10192);
// compiled call node returning call10193 (depth = 7)
// compiled member node returning call10193 (depth = 6)
  *var_errorPos = call10193;
  if (call10193 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10163 = done;
  } else {
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10195 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10197 == NULL) {
    strlit10197 = alloc_String("");
    gc_root(strlit10197);
  }
// compiled string node returning strlit10197 (depth = 7)
  int op_slot_right_10196 = gc_frame_newslot(strlit10197);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_p (depth = 10)
  partcv[0] = 0;
  Object call10201 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10200);
// compiled call node returning call10201 (depth = 9)
// compiled member node returning call10201 (depth = 8)
  int op_slot_right_10199 = gc_frame_newslot(call10201);
// starting to compile string node (depth = 8)
  if (strlit10203 == NULL) {
    strlit10203 = alloc_String(" ");
    gc_root(strlit10203);
  }
// compiled string node returning strlit10203 (depth = 8)
  int op_slot_left_10199 = gc_frame_newslot(strlit10203);
  params[0] = call10201;
  partcv[0] = 1;
  Object opresult10204 = callmethod(strlit10203, "++", 1, partcv, params);
// compiled op node returning opresult10204 (depth = 7)
  int op_slot_left_10196 = gc_frame_newslot(opresult10204);
  params[0] = strlit10197;
  partcv[0] = 1;
  Object opresult10205 = callmethod(opresult10204, "++", 1, partcv, params);
// compiled op node returning opresult10205 (depth = 6)
  gc_frame_newslot(opresult10205);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = opresult10205;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10206 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10195);
// compiled call node returning call10206 (depth = 5)
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num10208 = alloc_Float64(1);
// compiled num node returning num10208 (depth = 7)
  int op_slot_right_10207 = gc_frame_newslot(num10208);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10211 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10212 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10211);
// compiled call node returning call10212 (depth = 9)
// compiled member node returning call10212 (depth = 8)
  int op_slot_right_10210 = gc_frame_newslot(call10212);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10214 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call10215 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10214);
// compiled call node returning call10215 (depth = 9)
// compiled member node returning call10215 (depth = 8)
  int op_slot_left_10210 = gc_frame_newslot(call10215);
  params[0] = call10212;
  partcv[0] = 1;
  Object sum10216 = callmethod(call10215, "+", 1, partcv, params);
// compiled op node returning sum10216 (depth = 7)
  int op_slot_left_10207 = gc_frame_newslot(sum10216);
  params[0] = num10208;
  partcv[0] = 1;
  Object sum10217 = callmethod(sum10216, "+", 1, partcv, params);
// compiled op node returning sum10217 (depth = 6)
  *var_errorPos = sum10217;
  if (sum10217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if10163 = done;
  }
// compiled if node returning if10163 (depth = 4)
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10219 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10220 == NULL) {
    strlit10220 = alloc_String("An import statement must have an identifier after 'as'.");
    gc_root(strlit10220);
  }
// compiled string node returning strlit10220 (depth = 5)
  gc_frame_newslot(strlit10220);
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10221 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10222 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10221);
// compiled call node returning call10222 (depth = 6)
// compiled member node returning call10222 (depth = 5)
  gc_frame_newslot(call10222);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errorPos (depth = 5)
  gc_frame_newslot(*var_errorPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10220;
  params[1] = call10222;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10223 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10219);
// compiled call node returning call10223 (depth = 4)
    gc_frame_newslot(call10223);
    if10152 = call10223;
  } else {
  }
// compiled if node returning if10152 (depth = 3)
// Begin line 3152
  setline(3152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10224 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10225 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10224);
// compiled call node returning call10225 (depth = 4)
// compiled member node returning call10225 (depth = 3)
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10226 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10227 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10226);
// compiled call node returning call10227 (depth = 5)
// compiled member node returning call10227 (depth = 4)
  *var_name = call10227;
  if (call10227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10228 = gc_frame_new();
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool10229 = alloc_Boolean(1);
// compiled identifier node returning bool10229 (depth = 5)
  gc_frame_newslot(bool10229);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  params[0] = bool10229;
  partcv[0] = 1;
  Object call10230 = callmethod(*var_name, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10228);
// compiled call node returning call10230 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10232 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10233 == NULL) {
    strlit10233 = alloc_String("colon");
    gc_root(strlit10233);
  }
// compiled string node returning strlit10233 (depth = 5)
  gc_frame_newslot(strlit10233);
// call case 4: self request
  params[0] = strlit10233;
  partcv[0] = 1;
  Object call10234 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10232);
// compiled call node returning call10234 (depth = 4)
  Object if10231 = done;
  if (istrue(call10234)) {
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10235 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10236 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10235);
// compiled call node returning call10236 (depth = 5)
// compiled member node returning call10236 (depth = 4)
// Begin line 3157
  setline(3157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10237 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10238 = callmethodflags(self, "typeexpression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10237);
// compiled call node returning call10238 (depth = 5)
// compiled member node returning call10238 (depth = 4)
// Begin line 3159
  setline(3159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3158
  setline(3158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10239 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10240 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10239);
// compiled call node returning call10240 (depth = 6)
// compiled member node returning call10240 (depth = 5)
  *var_dtype = call10240;
  if (call10240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10231 = done;
  } else {
  }
// compiled if node returning if10231 (depth = 3)
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10242 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_importline (depth = 4)
  gc_frame_newslot(*var_importline);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_util (depth = 4)
  params[0] = *var_importline;
  partcv[0] = 1;
  Object call10243 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe10242);
// compiled call node returning call10243 (depth = 3)
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10244 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call10246 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10245);
// compiled call node returning call10246 (depth = 6)
// compiled member node returning call10246 (depth = 5)
  gc_frame_newslot(call10246);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_name (depth = 5)
  gc_frame_newslot(*var_name);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_dtype (depth = 5)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10247 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10248 = callmethod(*var_ast, "importNode",
    1, partcv, params);
  gc_frame_end(callframe10247);
// compiled call node returning call10248 (depth = 6)
// compiled member node returning call10248 (depth = 5)
  params[0] = call10246;
  params[1] = *var_name;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call10249 = callmethod(call10248, "new",
    1, partcv, params);
  gc_frame_end(callframe10244);
// compiled call node returning call10249 (depth = 4)
  *var_o = call10249;
  if (call10249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10251 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10250);
// compiled call node returning call10251 (depth = 5)
// compiled member node returning call10251 (depth = 4)
  *var_anns = call10251;
  if (call10251 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool10254 = alloc_Boolean(0);
// compiled identifier node returning bool10254 (depth = 5)
  int op_slot_right_10253 = gc_frame_newslot(bool10254);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_left_10253 = gc_frame_newslot(*var_anns);
  params[0] = bool10254;
  partcv[0] = 1;
  Object opresult10256 = callmethod(*var_anns, "!=", 1, partcv, params);
// compiled op node returning opresult10256 (depth = 4)
  Object if10252 = done;
  if (istrue(opresult10256)) {
// starting to compile call node (depth = 4)
  int callframe10257 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10258 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call10259 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10258);
// compiled call node returning call10259 (depth = 6)
// compiled member node returning call10259 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10260 = callmethod(call10259, "extend",
    1, partcv, params);
  gc_frame_end(callframe10257);
// compiled call node returning call10260 (depth = 4)
    gc_frame_newslot(call10260);
    if10252 = call10260;
  } else {
  }
// compiled if node returning if10252 (depth = 3)
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10261 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_defaultDefVisibility (depth = 4)
  gc_frame_newslot(*var_defaultDefVisibility);
// starting to compile string node (depth = 4)
  if (strlit10262 == NULL) {
    strlit10262 = alloc_String("confidential");
    gc_root(strlit10262);
  }
// compiled string node returning strlit10262 (depth = 4)
  gc_frame_newslot(strlit10262);
// call case 4: self request
  params[0] = *var_o;
  params[1] = *var_defaultDefVisibility;
  params[2] = strlit10262;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10263 = callmethodflags(self, "adjustVisibilityOf()withSpecialDefault()overriding", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10261);
// compiled call node returning call10263 (depth = 3)
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10264 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10265 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10264);
// compiled call node returning call10265 (depth = 3)
    gc_frame_newslot(call10265);
    if9996 = call10265;
  } else {
  }
// compiled if node returning if9996 (depth = 2)
  gc_frame_end(frame);
  return if9996;
}
Object meth_parser__apply10285(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10286 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe10287 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit10288 == NULL) {
    strlit10288 = alloc_String("rbrace");
    gc_root(strlit10288);
  }
// compiled string node returning strlit10288 (depth = 9)
  gc_frame_newslot(strlit10288);
// call case 4: self request
  params[0] = strlit10288;
  partcv[0] = 1;
  Object call10289 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10287);
// compiled call node returning call10289 (depth = 8)
  partcv[0] = 0;
  Object call10290 = callmethod(call10289, "not",
    1, partcv, params);
  gc_frame_end(callframe10286);
// compiled call node returning call10290 (depth = 7)
// compiled member node returning call10290 (depth = 6)
  gc_frame_end(frame);
  return call10290;
}
Object meth_parser__apply10299(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 9)
  int callframe10300 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_blocksOK (depth = 10)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call10301 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10300);
// compiled call node returning call10301 (depth = 9)
  gc_frame_end(frame);
  return call10301;
}
Object meth_parser_doreturn10266(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doreturn (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for doreturn");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_retval = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retval");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_o = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "o");
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10270 == NULL) {
    strlit10270 = alloc_String("return");
    gc_root(strlit10270);
  }
// compiled string node returning strlit10270 (depth = 5)
  int op_slot_right_10269 = gc_frame_newslot(strlit10270);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10273 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10272);
// compiled call node returning call10273 (depth = 6)
// compiled member node returning call10273 (depth = 5)
  int op_slot_left_10269 = gc_frame_newslot(call10273);
  params[0] = strlit10270;
  partcv[0] = 1;
  Object opresult10274 = callmethod(call10273, "==", 1, partcv, params);
// compiled op node returning opresult10274 (depth = 4)
  int op_slot_right_10268 = gc_frame_newslot(opresult10274);
// starting to compile call node (depth = 4)
  int callframe10276 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10277 == NULL) {
    strlit10277 = alloc_String("keyword");
    gc_root(strlit10277);
  }
// compiled string node returning strlit10277 (depth = 5)
  gc_frame_newslot(strlit10277);
// call case 4: self request
  params[0] = strlit10277;
  partcv[0] = 1;
  Object call10278 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10276);
// compiled call node returning call10278 (depth = 4)
  int op_slot_left_10268 = gc_frame_newslot(call10278);
  params[0] = opresult10274;
  partcv[0] = 1;
  Object opresult10279 = callmethod(call10278, "&&", 1, partcv, params);
// compiled op node returning opresult10279 (depth = 3)
  Object if10267 = done;
  if (istrue(opresult10279)) {
// Begin line 3173
  setline(3173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10280 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10281 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10280);
// compiled call node returning call10281 (depth = 4)
// compiled member node returning call10281 (depth = 3)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
  *var_retval = undefined;
// compiled vardec node returning done (depth = 3)
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10283 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block10284 = alloc_Block(NULL, NULL, "parser", 3175);
  gc_frame_newslot(block10284);
// method _apply
  block_savedest(block10284);
  Object closure10285 = createclosure(1, "_apply");
  setclosureframe(closure10285, stackframe);
  addtoclosure(closure10285, selfslot);
  struct UserObject *uo10285 = (struct UserObject*)block10284;
  uo10285->data[0] = (Object)closure10285;
  Method *meth_meth_parser__apply10285 = addmethod2pos(block10284, "_apply", &meth_parser__apply10285, 0);
  int argcv_meth_parser__apply10285[] = {0};
  meth_meth_parser__apply10285->type = alloc_MethodType(1, argcv_meth_parser__apply10285);
  meth_meth_parser__apply10285->definitionModule = modulename;
  meth_meth_parser__apply10285->definitionLine = 3173;
// compiled block node returning block10284 (depth = 5)
  gc_frame_newslot(block10284);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10292 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10293 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10292);
// compiled call node returning call10293 (depth = 6)
// compiled member node returning call10293 (depth = 5)
  params[0] = block10284;
  partcv[0] = 1;
  Object call10294 = callmethod(call10293, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10283);
// compiled call node returning call10294 (depth = 4)
  Object if10282 = done;
  if (istrue(call10294)) {
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3176
  setline(3176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10296 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10297 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block10298 = alloc_Block(NULL, NULL, "parser", 3176);
  gc_frame_newslot(block10298);
// method _apply
  block_savedest(block10298);
  Object closure10299 = createclosure(2, "_apply");
  setclosureframe(closure10299, stackframe);
  addtoclosure(closure10299, var_blocksOK);
  addtoclosure(closure10299, selfslot);
  struct UserObject *uo10299 = (struct UserObject*)block10298;
  uo10299->data[0] = (Object)closure10299;
  Method *meth_meth_parser__apply10299 = addmethod2pos(block10298, "_apply", &meth_parser__apply10299, 0);
  int argcv_meth_parser__apply10299[] = {0};
  meth_meth_parser__apply10299->type = alloc_MethodType(1, argcv_meth_parser__apply10299);
  meth_meth_parser__apply10299->definitionModule = modulename;
  meth_meth_parser__apply10299->definitionLine = 3176;
// compiled block node returning block10298 (depth = 8)
  gc_frame_newslot(block10298);
// call case 4: self request
  params[0] = block10298;
  partcv[0] = 1;
  Object call10303 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10297);
// compiled call node returning call10303 (depth = 7)
  partcv[0] = 0;
  Object call10304 = callmethod(call10303, "not",
    1, partcv, params);
  gc_frame_end(callframe10296);
// compiled call node returning call10304 (depth = 6)
// compiled member node returning call10304 (depth = 5)
  Object if10295 = done;
  if (istrue(call10304)) {
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 6)
  Object array10305 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10305 (depth = 6)
  *var_suggestions = array10305;
  if (array10305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 5)
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10306 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10307 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10308 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10307);
// compiled call node returning call10308 (depth = 9)
// compiled member node returning call10308 (depth = 8)
  partcv[0] = 0;
  Object call10309 = callmethod(call10308, "new",
    1, partcv, params);
  gc_frame_end(callframe10306);
// compiled call node returning call10309 (depth = 7)
// compiled member node returning call10309 (depth = 6)
  *var_suggestion = call10309;
  if (call10309 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 5)
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10310 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit10311 == NULL) {
    strlit10311 = alloc_String("rbrace");
    gc_root(strlit10311);
  }
// compiled string node returning strlit10311 (depth = 7)
  gc_frame_newslot(strlit10311);
// call case 4: self request
  params[0] = strlit10311;
  partcv[0] = 1;
  Object call10312 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10310);
// compiled call node returning call10312 (depth = 6)
  *var_nextTok = call10312;
  if (call10312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  int op_slot_right_10314 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_10314 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10316 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10316 (depth = 6)
  Object if10313 = done;
  if (istrue(opresult10316)) {
// Begin line 3181
  setline(3181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10317 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit10318 == NULL) {
    strlit10318 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10318);
  }
// compiled string node returning strlit10318 (depth = 7)
  gc_frame_newslot(strlit10318);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = strlit10318;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10319 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10317);
// compiled call node returning call10319 (depth = 6)
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10320 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10321 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10320);
// compiled call node returning call10321 (depth = 6)
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10322 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10323 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call10324 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10323);
// compiled call node returning call10324 (depth = 10)
// compiled member node returning call10324 (depth = 9)
  partcv[0] = 0;
  Object call10325 = callmethod(call10324, "new",
    1, partcv, params);
  gc_frame_end(callframe10322);
// compiled call node returning call10325 (depth = 8)
// compiled member node returning call10325 (depth = 7)
  *var_suggestion = call10325;
  if (call10325 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10327 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool10328 = alloc_Boolean(1);
// compiled identifier node returning bool10328 (depth = 7)
  gc_frame_newslot(bool10328);
// starting to compile identifier node (depth = 7)
  Object bool10329 = alloc_Boolean(0);
// compiled identifier node returning bool10329 (depth = 7)
  gc_frame_newslot(bool10329);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool10328;
  params[2] = bool10329;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10330 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10327);
// compiled call node returning call10330 (depth = 6)
    gc_frame_newslot(call10330);
    if10313 = call10330;
  } else {
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10331 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10332 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call10333 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10332);
// compiled call node returning call10333 (depth = 8)
// compiled member node returning call10333 (depth = 7)
  gc_frame_newslot(call10333);
// starting to compile identifier node (depth = 7)
  Object bool10334 = alloc_Boolean(1);
// compiled identifier node returning bool10334 (depth = 7)
  gc_frame_newslot(bool10334);
// starting to compile identifier node (depth = 7)
  Object bool10335 = alloc_Boolean(0);
// compiled identifier node returning bool10335 (depth = 7)
  gc_frame_newslot(bool10335);
// starting to compile string node (depth = 7)
  if (strlit10336 == NULL) {
    strlit10336 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10336);
  }
// compiled string node returning strlit10336 (depth = 7)
  gc_frame_newslot(strlit10336);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call10333;
  params[2] = bool10334;
  params[3] = bool10335;
  params[4] = strlit10336;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10337 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10331);
// compiled call node returning call10337 (depth = 6)
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10338 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10339 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10338);
// compiled call node returning call10339 (depth = 6)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10340 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10341 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call10342 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10341);
// compiled call node returning call10342 (depth = 10)
// compiled member node returning call10342 (depth = 9)
  partcv[0] = 0;
  Object call10343 = callmethod(call10342, "new",
    1, partcv, params);
  gc_frame_end(callframe10340);
// compiled call node returning call10343 (depth = 8)
// compiled member node returning call10343 (depth = 7)
  *var_suggestion = call10343;
  if (call10343 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3189
  setline(3189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10345 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10346 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  partcv[0] = 0;
  Object call10347 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10346);
// compiled call node returning call10347 (depth = 8)
// compiled member node returning call10347 (depth = 7)
  gc_frame_newslot(call10347);
// starting to compile identifier node (depth = 7)
  Object bool10348 = alloc_Boolean(1);
// compiled identifier node returning bool10348 (depth = 7)
  gc_frame_newslot(bool10348);
// starting to compile identifier node (depth = 7)
  Object bool10349 = alloc_Boolean(0);
// compiled identifier node returning bool10349 (depth = 7)
  gc_frame_newslot(bool10349);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = call10347;
  params[2] = bool10348;
  params[3] = bool10349;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10350 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10345);
// compiled call node returning call10350 (depth = 6)
    gc_frame_newslot(call10350);
    if10313 = call10350;
  }
// compiled if node returning if10313 (depth = 5)
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10351 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10352 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10351);
// compiled call node returning call10352 (depth = 5)
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10353 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10354 == NULL) {
    strlit10354 = alloc_String("A return statement must have either an expression or a new-line after 'return'.");
    gc_root(strlit10354);
  }
// compiled string node returning strlit10354 (depth = 6)
  gc_frame_newslot(strlit10354);
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10355 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10356 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10355);
// compiled call node returning call10356 (depth = 7)
// compiled member node returning call10356 (depth = 6)
  gc_frame_newslot(call10356);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10357 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10358 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10357);
// compiled call node returning call10358 (depth = 7)
// compiled member node returning call10358 (depth = 6)
  gc_frame_newslot(call10358);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10360 = alloc_Float64(1);
// compiled num node returning num10360 (depth = 7)
  int op_slot_right_10359 = gc_frame_newslot(num10360);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10364 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe10363);
// compiled call node returning call10364 (depth = 9)
// compiled member node returning call10364 (depth = 8)
  int op_slot_right_10362 = gc_frame_newslot(call10364);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10366 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10367 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10366);
// compiled call node returning call10367 (depth = 9)
// compiled member node returning call10367 (depth = 8)
  int op_slot_left_10362 = gc_frame_newslot(call10367);
  params[0] = call10364;
  partcv[0] = 1;
  Object sum10368 = callmethod(call10367, "+", 1, partcv, params);
// compiled op node returning sum10368 (depth = 7)
  int op_slot_left_10359 = gc_frame_newslot(sum10368);
  params[0] = num10360;
  partcv[0] = 1;
  Object diff10369 = callmethod(sum10368, "-", 1, partcv, params);
// compiled op node returning diff10369 (depth = 6)
  gc_frame_newslot(diff10369);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit10354;
  params[1] = call10356;
  params[2] = call10358;
  params[3] = diff10369;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10370 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10353);
// compiled call node returning call10370 (depth = 5)
    gc_frame_newslot(call10370);
    if10295 = call10370;
  } else {
  }
// compiled if node returning if10295 (depth = 4)
// Begin line 3196
  setline(3196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10371 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10372 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10371);
// compiled call node returning call10372 (depth = 6)
// compiled member node returning call10372 (depth = 5)
  *var_retval = call10372;
  if (call10372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10282 = done;
  } else {
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10374 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10375 == NULL) {
    strlit10375 = alloc_String("done");
    gc_root(strlit10375);
  }
// compiled string node returning strlit10375 (depth = 6)
  gc_frame_newslot(strlit10375);
// starting to compile identifier node (depth = 6)
  Object bool10376 = alloc_Boolean(0);
// compiled identifier node returning bool10376 (depth = 6)
  gc_frame_newslot(bool10376);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10377 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ast (depth = 8)
  partcv[0] = 0;
  Object call10378 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10377);
// compiled call node returning call10378 (depth = 7)
// compiled member node returning call10378 (depth = 6)
  params[0] = strlit10375;
  params[1] = bool10376;
  partcv[0] = 2;
  Object call10379 = callmethod(call10378, "new",
    1, partcv, params);
  gc_frame_end(callframe10374);
// compiled call node returning call10379 (depth = 5)
  *var_retval = call10379;
  if (call10379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10282 = done;
  }
// compiled if node returning if10282 (depth = 3)
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10381 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_retval (depth = 5)
  gc_frame_newslot(*var_retval);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10382 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10383 = callmethod(*var_ast, "returnNode",
    1, partcv, params);
  gc_frame_end(callframe10382);
// compiled call node returning call10383 (depth = 6)
// compiled member node returning call10383 (depth = 5)
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call10384 = callmethod(call10383, "new",
    1, partcv, params);
  gc_frame_end(callframe10381);
// compiled call node returning call10384 (depth = 4)
  *var_o = call10384;
  if (call10384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3200
  setline(3200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10385 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10386 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10385);
// compiled call node returning call10386 (depth = 3)
    gc_frame_newslot(call10386);
    if10267 = call10386;
  } else {
  }
// compiled if node returning if10267 (depth = 2)
  gc_frame_end(frame);
  return if10267;
}
Object meth_parser_domethodtype10387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for domethodtype (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for domethodtype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_m = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "m");
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_signature = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "signature");
  Object *var_dtype = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "dtype");
  Object *var_varargs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "varargs");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_suggestion = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestion");
  Object *var_newLine = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "newLine");
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10388 = gc_frame_new();
// starting to compile identifier node (depth = 4)
  Object bool10389 = alloc_Boolean(1);
// compiled identifier node returning bool10389 (depth = 4)
  gc_frame_newslot(bool10389);
// call case 4: self request
  params[0] = bool10389;
  partcv[0] = 1;
  Object call10390 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10388);
// compiled call node returning call10390 (depth = 3)
  *var_m = call10390;
  if (call10390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10391 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10392 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe10391);
// compiled call node returning call10392 (depth = 4)
// compiled member node returning call10392 (depth = 3)
  *var_meth = call10392;
  if (call10392 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10393 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10394 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe10393);
// compiled call node returning call10394 (depth = 4)
// compiled member node returning call10394 (depth = 3)
  *var_signature = call10394;
  if (call10394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10395 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10396 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe10395);
// compiled call node returning call10396 (depth = 4)
// compiled member node returning call10396 (depth = 3)
  *var_dtype = call10396;
  if (call10396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3211
  setline(3211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10397 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  partcv[0] = 0;
  Object call10398 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe10397);
// compiled call node returning call10398 (depth = 4)
// compiled member node returning call10398 (depth = 3)
  *var_varargs = call10398;
  if (call10398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3211
  setline(3211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool10401 = alloc_Boolean(0);
// compiled identifier node returning bool10401 (depth = 4)
  int op_slot_right_10400 = gc_frame_newslot(bool10401);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  int op_slot_left_10400 = gc_frame_newslot(*var_dtype);
  params[0] = bool10401;
  partcv[0] = 1;
  Object opresult10403 = callmethod(*var_dtype, "==", 1, partcv, params);
// compiled op node returning opresult10403 (depth = 3)
  Object if10399 = done;
  if (istrue(opresult10403)) {
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10404 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10405 == NULL) {
    strlit10405 = alloc_String("Done");
    gc_root(strlit10405);
  }
// compiled string node returning strlit10405 (depth = 5)
  gc_frame_newslot(strlit10405);
// starting to compile identifier node (depth = 5)
  Object bool10406 = alloc_Boolean(0);
// compiled identifier node returning bool10406 (depth = 5)
  gc_frame_newslot(bool10406);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10408 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10407);
// compiled call node returning call10408 (depth = 6)
// compiled member node returning call10408 (depth = 5)
  params[0] = strlit10405;
  params[1] = bool10406;
  partcv[0] = 2;
  Object call10409 = callmethod(call10408, "new",
    1, partcv, params);
  gc_frame_end(callframe10404);
// compiled call node returning call10409 (depth = 4)
  *var_dtype = call10409;
  if (call10409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10399 = done;
  } else {
  }
// compiled if node returning if10399 (depth = 2)
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10411 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_meth (depth = 6)
  partcv[0] = 0;
  Object call10413 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe10412);
// compiled call node returning call10413 (depth = 5)
// compiled member node returning call10413 (depth = 4)
  gc_frame_newslot(call10413);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_signature (depth = 4)
  gc_frame_newslot(*var_signature);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_dtype (depth = 4)
  gc_frame_newslot(*var_dtype);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10414 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ast (depth = 6)
  partcv[0] = 0;
  Object call10415 = callmethod(*var_ast, "methodTypeNode",
    1, partcv, params);
  gc_frame_end(callframe10414);
// compiled call node returning call10415 (depth = 5)
// compiled member node returning call10415 (depth = 4)
  params[0] = call10413;
  params[1] = *var_signature;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call10416 = callmethod(call10415, "new",
    1, partcv, params);
  gc_frame_end(callframe10411);
// compiled call node returning call10416 (depth = 3)
  *var_o = call10416;
  if (call10416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10417 = gc_frame_new();
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10418 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_m (depth = 6)
  partcv[0] = 0;
  Object call10419 = callmethod(*var_m, "generics",
    1, partcv, params);
  gc_frame_end(callframe10418);
// compiled call node returning call10419 (depth = 5)
// compiled member node returning call10419 (depth = 4)
  gc_frame_newslot(call10419);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_o (depth = 4)
  params[0] = call10419;
  partcv[0] = 1;
  Object call10420 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10417);
// compiled call node returning call10420 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe10421 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10422 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10421);
// compiled call node returning call10422 (depth = 2)
// Begin line 3231
  setline(3231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10424 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10425 == NULL) {
    strlit10425 = alloc_String("semicolon");
    gc_root(strlit10425);
  }
// compiled string node returning strlit10425 (depth = 4)
  gc_frame_newslot(strlit10425);
// call case 4: self request
  params[0] = strlit10425;
  partcv[0] = 1;
  Object call10426 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10424);
// compiled call node returning call10426 (depth = 3)
  Object if10423 = done;
  if (istrue(call10426)) {
// Begin line 3218
  setline(3218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10427 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10428 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10427);
// compiled call node returning call10428 (depth = 4)
// compiled member node returning call10428 (depth = 3)
    gc_frame_newslot(call10428);
    if10423 = call10428;
  } else {
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3220
  setline(3220);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10430 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe10431 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10432 == NULL) {
    strlit10432 = alloc_String("rbrace");
    gc_root(strlit10432);
  }
// compiled string node returning strlit10432 (depth = 6)
  gc_frame_newslot(strlit10432);
// call case 4: self request
  params[0] = strlit10432;
  partcv[0] = 1;
  Object call10433 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10431);
// compiled call node returning call10433 (depth = 5)
  partcv[0] = 0;
  Object call10434 = callmethod(call10433, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10430);
// compiled call node returning call10434 (depth = 4)
  Object if10429 = done;
  if (istrue(call10434)) {
// Begin line 3229
  setline(3229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3221
  setline(3221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10437 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10438 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10437);
// compiled call node returning call10438 (depth = 7)
// compiled member node returning call10438 (depth = 6)
  int op_slot_right_10436 = gc_frame_newslot(call10438);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10440 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call10441 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10440);
// compiled call node returning call10441 (depth = 7)
// compiled member node returning call10441 (depth = 6)
  int op_slot_left_10436 = gc_frame_newslot(call10441);
  params[0] = call10438;
  partcv[0] = 1;
  Object opresult10442 = callmethod(call10441, "==", 1, partcv, params);
// compiled op node returning opresult10442 (depth = 5)
  Object if10435 = done;
  if (istrue(opresult10442)) {
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 3222
  setline(3222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10443 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10444 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call10445 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10444);
// compiled call node returning call10445 (depth = 9)
// compiled member node returning call10445 (depth = 8)
  partcv[0] = 0;
  Object call10446 = callmethod(call10445, "new",
    1, partcv, params);
  gc_frame_end(callframe10443);
// compiled call node returning call10446 (depth = 7)
// compiled member node returning call10446 (depth = 6)
  *var_suggestion = call10446;
  if (call10446 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile op node (depth = 6)
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10449 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10448);
// compiled call node returning call10449 (depth = 8)
// compiled member node returning call10449 (depth = 7)
  int op_slot_right_10447 = gc_frame_newslot(call10449);
// starting to compile call node (depth = 7)
  int callframe10451 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num10452 = alloc_Float64(1);
// compiled num node returning num10452 (depth = 8)
  gc_frame_newslot(num10452);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num10454 = alloc_Float64(1);
// compiled num node returning num10454 (depth = 9)
  int op_slot_right_10453 = gc_frame_newslot(num10454);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10456 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call10457 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10456);
// compiled call node returning call10457 (depth = 10)
// compiled member node returning call10457 (depth = 9)
  int op_slot_left_10453 = gc_frame_newslot(call10457);
  params[0] = num10454;
  partcv[0] = 1;
  Object diff10458 = callmethod(call10457, "-", 1, partcv, params);
// compiled op node returning diff10458 (depth = 8)
  gc_frame_newslot(diff10458);
// call case 6: other member request
// starting to compile index node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_util (depth = 11)
  partcv[0] = 0;
  Object call10460 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10459);
// compiled call node returning call10460 (depth = 10)
// compiled member node returning call10460 (depth = 9)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10461 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10462 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10461);
// compiled call node returning call10462 (depth = 10)
// compiled member node returning call10462 (depth = 9)
  params[0] = call10462;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10463 = callmethod(call10460, "[]", 1, partcv, params);
// compiled index node returning idxres10463 (depth = 8)
  params[0] = num10452;
  params[1] = diff10458;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10464 = callmethod(idxres10463, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe10451);
// compiled call node returning call10464 (depth = 7)
  int op_slot_left_10447 = gc_frame_newslot(call10464);
  params[0] = call10449;
  partcv[0] = 1;
  Object opresult10465 = callmethod(call10464, "++", 1, partcv, params);
// compiled op node returning opresult10465 (depth = 6)
  *var_newLine = opresult10465;
  if (opresult10465 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10466 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num10468 = alloc_Float64(0.1);
// compiled num node returning num10468 (depth = 7)
  int op_slot_right_10467 = gc_frame_newslot(num10468);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10470 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10471 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10470);
// compiled call node returning call10471 (depth = 8)
// compiled member node returning call10471 (depth = 7)
  int op_slot_left_10467 = gc_frame_newslot(call10471);
  params[0] = num10468;
  partcv[0] = 1;
  Object sum10472 = callmethod(call10471, "+", 1, partcv, params);
// compiled op node returning sum10472 (depth = 6)
  gc_frame_newslot(sum10472);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum10472;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call10473 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10466);
// compiled call node returning call10473 (depth = 5)
// Begin line 3225
  setline(3225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10474 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool10475 = alloc_Boolean(1);
// compiled identifier node returning bool10475 (depth = 6)
  gc_frame_newslot(bool10475);
// starting to compile identifier node (depth = 6)
  Object bool10476 = alloc_Boolean(1);
// compiled identifier node returning bool10476 (depth = 6)
  gc_frame_newslot(bool10476);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool10475;
  params[2] = bool10476;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10477 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10474);
// compiled call node returning call10477 (depth = 5)
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10478 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10479 == NULL) {
    strlit10479 = alloc_String("Methods in a type literal must be on separate lines, or separated by semicolons.");
    gc_root(strlit10479);
  }
// compiled string node returning strlit10479 (depth = 6)
  gc_frame_newslot(strlit10479);
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10480 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10481 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10480);
// compiled call node returning call10481 (depth = 7)
// compiled member node returning call10481 (depth = 6)
  gc_frame_newslot(call10481);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10482 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10483 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10482);
// compiled call node returning call10483 (depth = 7)
// compiled member node returning call10483 (depth = 6)
  gc_frame_newslot(call10483);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit10479;
  params[1] = call10481;
  params[2] = call10483;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10484 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10478);
// compiled call node returning call10484 (depth = 5)
    gc_frame_newslot(call10484);
    if10435 = call10484;
  } else {
  }
// compiled if node returning if10435 (depth = 4)
    gc_frame_newslot(if10435);
    if10429 = if10435;
  } else {
  }
// compiled if node returning if10429 (depth = 3)
    gc_frame_newslot(if10429);
    if10423 = if10429;
  }
// compiled if node returning if10423 (depth = 2)
  gc_frame_end(frame);
  return if10423;
}
Object meth_parser__apply10489(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10491 == NULL) {
    strlit10491 = alloc_String("type");
    gc_root(strlit10491);
  }
// compiled string node returning strlit10491 (depth = 6)
  int op_slot_right_10490 = gc_frame_newslot(strlit10491);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10493 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10494 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10493);
// compiled call node returning call10494 (depth = 7)
// compiled member node returning call10494 (depth = 6)
  int op_slot_left_10490 = gc_frame_newslot(call10494);
  params[0] = strlit10491;
  partcv[0] = 1;
  Object opresult10495 = callmethod(call10494, "==", 1, partcv, params);
// compiled op node returning opresult10495 (depth = 5)
  gc_frame_end(frame);
  return opresult10495;
}
Object meth_parser__apply10538(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10539 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10540 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10541 == NULL) {
    strlit10541 = alloc_String("rbrace");
    gc_root(strlit10541);
  }
// compiled string node returning strlit10541 (depth = 8)
  gc_frame_newslot(strlit10541);
// call case 4: self request
  params[0] = strlit10541;
  partcv[0] = 1;
  Object call10542 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10540);
// compiled call node returning call10542 (depth = 7)
  partcv[0] = 0;
  Object call10543 = callmethod(call10542, "not",
    1, partcv, params);
  gc_frame_end(callframe10539);
// compiled call node returning call10543 (depth = 6)
// compiled member node returning call10543 (depth = 5)
  gc_frame_end(frame);
  return call10543;
}
Object meth_parser__apply10550(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10552 == NULL) {
    strlit10552 = alloc_String("type");
    gc_root(strlit10552);
  }
// compiled string node returning strlit10552 (depth = 9)
  int op_slot_right_10551 = gc_frame_newslot(strlit10552);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10555 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10554);
// compiled call node returning call10555 (depth = 10)
// compiled member node returning call10555 (depth = 9)
  int op_slot_left_10551 = gc_frame_newslot(call10555);
  params[0] = strlit10552;
  partcv[0] = 1;
  Object opresult10556 = callmethod(call10555, "==", 1, partcv, params);
// compiled op node returning opresult10556 (depth = 8)
  gc_frame_end(frame);
  return opresult10556;
}
Object meth_parser__apply10546(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_types = getfromclosure(closure, 2);
  Object *var_meths = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10548 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block10549 = alloc_Block(NULL, NULL, "parser", 3252);
  gc_frame_newslot(block10549);
// method _apply
  block_savedest(block10549);
  Object closure10550 = createclosure(2, "_apply");
  setclosureframe(closure10550, stackframe);
  addtoclosure(closure10550, var_sym);
  addtoclosure(closure10550, selfslot);
  struct UserObject *uo10550 = (struct UserObject*)block10549;
  uo10550->data[0] = (Object)closure10550;
  Method *meth_meth_parser__apply10550 = addmethod2pos(block10549, "_apply", &meth_parser__apply10550, 0);
  int argcv_meth_parser__apply10550[] = {0};
  meth_meth_parser__apply10550->type = alloc_MethodType(1, argcv_meth_parser__apply10550);
  meth_meth_parser__apply10550->definitionModule = modulename;
  meth_meth_parser__apply10550->definitionLine = 3251;
// compiled block node returning block10549 (depth = 7)
  gc_frame_newslot(block10549);
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe10558 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit10559 == NULL) {
    strlit10559 = alloc_String("keyword");
    gc_root(strlit10559);
  }
// compiled string node returning strlit10559 (depth = 8)
  gc_frame_newslot(strlit10559);
// call case 4: self request
  params[0] = strlit10559;
  partcv[0] = 1;
  Object call10560 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10558);
// compiled call node returning call10560 (depth = 7)
  params[0] = block10549;
  partcv[0] = 1;
  Object call10561 = callmethod(call10560, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10548);
// compiled call node returning call10561 (depth = 6)
  Object if10547 = done;
  if (istrue(call10561)) {
// Begin line 3253
  setline(3253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10563 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10562);
// compiled call node returning call10563 (depth = 7)
// compiled member node returning call10563 (depth = 6)
// Begin line 3254
  setline(3254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10564 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10565 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10566 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10565);
// compiled call node returning call10566 (depth = 8)
// compiled member node returning call10566 (depth = 7)
  gc_frame_newslot(call10566);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_types (depth = 7)
  params[0] = call10566;
  partcv[0] = 1;
  Object call10567 = callmethod(*var_types, "push",
    1, partcv, params);
  gc_frame_end(callframe10564);
// compiled call node returning call10567 (depth = 6)
    gc_frame_newslot(call10567);
    if10547 = call10567;
  } else {
// Begin line 3256
  setline(3256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10568 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10569 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10568);
// compiled call node returning call10569 (depth = 7)
// compiled member node returning call10569 (depth = 6)
// Begin line 3257
  setline(3257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10570 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10571 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call10572 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10571);
// compiled call node returning call10572 (depth = 8)
// compiled member node returning call10572 (depth = 7)
  gc_frame_newslot(call10572);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_meths (depth = 7)
  params[0] = call10572;
  partcv[0] = 1;
  Object call10573 = callmethod(*var_meths, "push",
    1, partcv, params);
  gc_frame_end(callframe10570);
// compiled call node returning call10573 (depth = 6)
    gc_frame_newslot(call10573);
    if10547 = call10573;
  }
// compiled if node returning if10547 (depth = 5)
  gc_frame_end(frame);
  return if10547;
}
Object meth_parser_dotypeLiteral10485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for dotypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_meths = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meths");
  Object *var_types = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "types");
  Object *var_mc = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "mc");
  Object *var_t = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "t");
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3235
  setline(3235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10487 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10488 = alloc_Block(NULL, NULL, "parser", 3235);
  gc_frame_newslot(block10488);
// method _apply
  block_savedest(block10488);
  Object closure10489 = createclosure(2, "_apply");
  setclosureframe(closure10489, stackframe);
  addtoclosure(closure10489, var_sym);
  addtoclosure(closure10489, selfslot);
  struct UserObject *uo10489 = (struct UserObject*)block10488;
  uo10489->data[0] = (Object)closure10489;
  Method *meth_meth_parser__apply10489 = addmethod2pos(block10488, "_apply", &meth_parser__apply10489, 0);
  int argcv_meth_parser__apply10489[] = {0};
  meth_meth_parser__apply10489->type = alloc_MethodType(1, argcv_meth_parser__apply10489);
  meth_meth_parser__apply10489->definitionModule = modulename;
  meth_meth_parser__apply10489->definitionLine = 3227;
// compiled block node returning block10488 (depth = 4)
  gc_frame_newslot(block10488);
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe10497 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10498 == NULL) {
    strlit10498 = alloc_String("keyword");
    gc_root(strlit10498);
  }
// compiled string node returning strlit10498 (depth = 5)
  gc_frame_newslot(strlit10498);
// call case 4: self request
  params[0] = strlit10498;
  partcv[0] = 1;
  Object call10499 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10497);
// compiled call node returning call10499 (depth = 4)
  params[0] = block10488;
  partcv[0] = 1;
  Object call10500 = callmethod(call10499, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10487);
// compiled call node returning call10500 (depth = 3)
  Object if10486 = done;
  if (istrue(call10500)) {
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10501 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10502 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10501);
// compiled call node returning call10502 (depth = 4)
// compiled member node returning call10502 (depth = 3)
// Begin line 3244
  setline(3244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10504 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 5)
  int callframe10505 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10506 == NULL) {
    strlit10506 = alloc_String("lbrace");
    gc_root(strlit10506);
  }
// compiled string node returning strlit10506 (depth = 6)
  gc_frame_newslot(strlit10506);
// call case 4: self request
  params[0] = strlit10506;
  partcv[0] = 1;
  Object call10507 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10505);
// compiled call node returning call10507 (depth = 5)
  partcv[0] = 0;
  Object call10508 = callmethod(call10507, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10504);
// compiled call node returning call10508 (depth = 4)
  Object if10503 = done;
  if (istrue(call10508)) {
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3238
  setline(3238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10509 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10510 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10511 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10510);
// compiled call node returning call10511 (depth = 8)
// compiled member node returning call10511 (depth = 7)
  partcv[0] = 0;
  Object call10512 = callmethod(call10511, "new",
    1, partcv, params);
  gc_frame_end(callframe10509);
// compiled call node returning call10512 (depth = 6)
// compiled member node returning call10512 (depth = 5)
  *var_suggestion = call10512;
  if (call10512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10513 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile string node (depth = 5)
  if (strlit10514 == NULL) {
    strlit10514 = alloc_String("{");
    gc_root(strlit10514);
  }
// compiled string node returning strlit10514 (depth = 5)
  gc_frame_newslot(strlit10514);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = *var_sym;
  params[1] = strlit10514;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10515 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10513);
// compiled call node returning call10515 (depth = 4)
// Begin line 3240
  setline(3240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10516 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10517 == NULL) {
    strlit10517 = alloc_String("type literals must open with a brace.");
    gc_root(strlit10517);
  }
// compiled string node returning strlit10517 (depth = 5)
  gc_frame_newslot(strlit10517);
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10518 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10519 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10518);
// compiled call node returning call10519 (depth = 6)
// compiled member node returning call10519 (depth = 5)
  gc_frame_newslot(call10519);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10520 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10521 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10520);
// compiled call node returning call10521 (depth = 6)
// compiled member node returning call10521 (depth = 5)
  gc_frame_newslot(call10521);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3240
  setline(3240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10517;
  params[1] = call10519;
  params[2] = call10521;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10522 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10516);
// compiled call node returning call10522 (depth = 4)
// Begin line 3243
  setline(3243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_done (depth = 5)
  return *var_done;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if10503 = undefined;
  } else {
  }
// compiled if node returning if10503 (depth = 3)
    gc_frame_newslot(if10503);
    if10486 = if10503;
  } else {
  }
// compiled if node returning if10486 (depth = 2)
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10524 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10525 == NULL) {
    strlit10525 = alloc_String("lbrace");
    gc_root(strlit10525);
  }
// compiled string node returning strlit10525 (depth = 4)
  gc_frame_newslot(strlit10525);
// call case 4: self request
  params[0] = strlit10525;
  partcv[0] = 1;
  Object call10526 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10524);
// compiled call node returning call10526 (depth = 3)
  Object if10523 = done;
  if (istrue(call10526)) {
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array10527 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10527 (depth = 4)
  *var_meths = array10527;
  if (array10527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array10528 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10528 (depth = 4)
  *var_types = array10528;
  if (array10528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_auto_count (depth = 4)
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3250
  setline(3250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile op node (depth = 4)
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num10530 = alloc_Float64(1);
// compiled num node returning num10530 (depth = 5)
  int op_slot_right_10529 = gc_frame_newslot(num10530);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_auto_count (depth = 5)
  int op_slot_left_10529 = gc_frame_newslot(*var_auto_count);
  params[0] = num10530;
  partcv[0] = 1;
  Object sum10532 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compiled op node returning sum10532 (depth = 4)
  *var_auto_count = sum10532;
  if (sum10532 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3250
  setline(3250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10534 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10535 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10534);
// compiled call node returning call10535 (depth = 4)
// compiled member node returning call10535 (depth = 3)
// Begin line 3251
  setline(3251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10536 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10537 = alloc_Block(NULL, NULL, "parser", 3251);
  gc_frame_newslot(block10537);
// method _apply
  block_savedest(block10537);
  Object closure10538 = createclosure(1, "_apply");
  setclosureframe(closure10538, stackframe);
  addtoclosure(closure10538, selfslot);
  struct UserObject *uo10538 = (struct UserObject*)block10537;
  uo10538->data[0] = (Object)closure10538;
  Method *meth_meth_parser__apply10538 = addmethod2pos(block10537, "_apply", &meth_parser__apply10538, 0);
  int argcv_meth_parser__apply10538[] = {0};
  meth_meth_parser__apply10538->type = alloc_MethodType(1, argcv_meth_parser__apply10538);
  meth_meth_parser__apply10538->definitionModule = modulename;
  meth_meth_parser__apply10538->definitionLine = 3250;
// compiled block node returning block10537 (depth = 4)
  gc_frame_newslot(block10537);
// starting to compile block node (depth = 4)
  Object block10545 = alloc_Block(NULL, NULL, "parser", 3251);
  gc_frame_newslot(block10545);
// method _apply
  block_savedest(block10545);
  Object closure10546 = createclosure(5, "_apply");
  setclosureframe(closure10546, stackframe);
  addtoclosure(closure10546, var_sym);
  addtoclosure(closure10546, var_values);
  addtoclosure(closure10546, var_types);
  addtoclosure(closure10546, var_meths);
  addtoclosure(closure10546, selfslot);
  struct UserObject *uo10546 = (struct UserObject*)block10545;
  uo10546->data[0] = (Object)closure10546;
  Method *meth_meth_parser__apply10546 = addmethod2pos(block10545, "_apply", &meth_parser__apply10546, 0);
  int argcv_meth_parser__apply10546[] = {0};
  meth_meth_parser__apply10546->type = alloc_MethodType(1, argcv_meth_parser__apply10546);
  meth_meth_parser__apply10546->definitionModule = modulename;
  meth_meth_parser__apply10546->definitionLine = 3251;
// compiled block node returning block10545 (depth = 4)
  gc_frame_newslot(block10545);
// call case 5: prelude request
  params[0] = block10537;
  params[1] = block10545;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10575 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10536);
// compiled call node returning call10575 (depth = 3)
// Begin line 3260
  setline(3260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10576 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10577 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10576);
// compiled call node returning call10577 (depth = 4)
// compiled member node returning call10577 (depth = 3)
// Begin line 3261
  setline(3261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10578 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_meths (depth = 5)
  gc_frame_newslot(*var_meths);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_types (depth = 5)
  gc_frame_newslot(*var_types);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10580 = callmethod(*var_ast, "typeLiteralNode",
    1, partcv, params);
  gc_frame_end(callframe10579);
// compiled call node returning call10580 (depth = 6)
// compiled member node returning call10580 (depth = 5)
  params[0] = *var_meths;
  params[1] = *var_types;
  partcv[0] = 2;
  Object call10581 = callmethod(call10580, "new",
    1, partcv, params);
  gc_frame_end(callframe10578);
// compiled call node returning call10581 (depth = 4)
  *var_t = call10581;
  if (call10581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10582 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call10583 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10582);
// compiled call node returning call10583 (depth = 3)
    gc_frame_newslot(call10583);
    if10523 = call10583;
  } else {
  }
// compiled if node returning if10523 (depth = 2)
  gc_frame_end(frame);
  return if10523;
}
Object meth_parser__apply10662(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe10663 = gc_frame_new();
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
  Object bool10664 = alloc_Boolean(1);
// compiled identifier node returning bool10664 (depth = 7)
  gc_frame_newslot(bool10664);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  params[0] = bool10664;
  partcv[0] = 1;
  Object call10665 = callmethod(*var_each, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10663);
// compiled call node returning call10665 (depth = 6)
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply10692(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10694 == NULL) {
    strlit10694 = alloc_String("lbrace");
    gc_root(strlit10694);
  }
// compiled string node returning strlit10694 (depth = 8)
  int op_slot_right_10693 = gc_frame_newslot(strlit10694);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_t (depth = 10)
  partcv[0] = 0;
  Object call10697 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe10696);
// compiled call node returning call10697 (depth = 9)
// compiled member node returning call10697 (depth = 8)
  int op_slot_left_10693 = gc_frame_newslot(call10697);
  params[0] = strlit10694;
  partcv[0] = 1;
  Object opresult10698 = callmethod(call10697, "==", 1, partcv, params);
// compiled op node returning opresult10698 (depth = 7)
  gc_frame_end(frame);
  return opresult10698;
}
Object meth_parser__apply10704(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  int op_slot_right_10705 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  int op_slot_left_10705 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10707 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10707 (depth = 7)
  gc_frame_end(frame);
  return opresult10707;
}
Object meth_parser_typedec10584(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typedec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_noBlocks = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typedec (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for typedec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
  Object *var_gens = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "gens");
  Object *var_anns = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "anns");
  Object *var_nextTok = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "nextTok");
  Object *var_nt = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "nt");
// Begin line 3314
  setline(3314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10588 == NULL) {
    strlit10588 = alloc_String("type");
    gc_root(strlit10588);
  }
// compiled string node returning strlit10588 (depth = 5)
  int op_slot_right_10587 = gc_frame_newslot(strlit10588);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10590 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10591 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10590);
// compiled call node returning call10591 (depth = 6)
// compiled member node returning call10591 (depth = 5)
  int op_slot_left_10587 = gc_frame_newslot(call10591);
  params[0] = strlit10588;
  partcv[0] = 1;
  Object opresult10592 = callmethod(call10591, "==", 1, partcv, params);
// compiled op node returning opresult10592 (depth = 4)
  int op_slot_right_10586 = gc_frame_newslot(opresult10592);
// starting to compile call node (depth = 4)
  int callframe10594 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10595 == NULL) {
    strlit10595 = alloc_String("keyword");
    gc_root(strlit10595);
  }
// compiled string node returning strlit10595 (depth = 5)
  gc_frame_newslot(strlit10595);
// call case 4: self request
  params[0] = strlit10595;
  partcv[0] = 1;
  Object call10596 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10594);
// compiled call node returning call10596 (depth = 4)
  int op_slot_left_10586 = gc_frame_newslot(call10596);
  params[0] = opresult10592;
  partcv[0] = 1;
  Object opresult10597 = callmethod(call10596, "&&", 1, partcv, params);
// compiled op node returning opresult10597 (depth = 3)
  Object if10585 = done;
  if (istrue(opresult10597)) {
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3269
  setline(3269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10598 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10599 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10598);
// compiled call node returning call10599 (depth = 5)
// compiled member node returning call10599 (depth = 4)
  *var_line = call10599;
  if (call10599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3271
  setline(3271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10600 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call10601 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10600);
// compiled call node returning call10601 (depth = 5)
// compiled member node returning call10601 (depth = 4)
  *var_pos = call10601;
  if (call10601 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3271
  setline(3271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10602 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10603 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10602);
// compiled call node returning call10603 (depth = 4)
// compiled member node returning call10603 (depth = 3)
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10606 == NULL) {
    strlit10606 = alloc_String("identifier");
    gc_root(strlit10606);
  }
// compiled string node returning strlit10606 (depth = 5)
  int op_slot_right_10605 = gc_frame_newslot(strlit10606);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10608 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10609 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10608);
// compiled call node returning call10609 (depth = 6)
// compiled member node returning call10609 (depth = 5)
  int op_slot_left_10605 = gc_frame_newslot(call10609);
  params[0] = strlit10606;
  partcv[0] = 1;
  Object opresult10610 = callmethod(call10609, "!=", 1, partcv, params);
// compiled op node returning opresult10610 (depth = 4)
  Object if10604 = done;
  if (istrue(opresult10610)) {
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3273
  setline(3273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10611 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10612 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10613 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10612);
// compiled call node returning call10613 (depth = 8)
// compiled member node returning call10613 (depth = 7)
  partcv[0] = 0;
  Object call10614 = callmethod(call10613, "new",
    1, partcv, params);
  gc_frame_end(callframe10611);
// compiled call node returning call10614 (depth = 6)
// compiled member node returning call10614 (depth = 5)
  *var_suggestion = call10614;
  if (call10614 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3274
  setline(3274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10615 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10616 == NULL) {
    strlit10616 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit10616);
  }
// compiled string node returning strlit10616 (depth = 5)
  gc_frame_newslot(strlit10616);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lastToken (depth = 5)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  params[0] = strlit10616;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10617 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10615);
// compiled call node returning call10617 (depth = 4)
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10618 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10619 == NULL) {
    strlit10619 = alloc_String("A type declaration must have a name after the 'type'.");
    gc_root(strlit10619);
  }
// compiled string node returning strlit10619 (depth = 5)
  gc_frame_newslot(strlit10619);
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10620 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10621 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10620);
// compiled call node returning call10621 (depth = 6)
// compiled member node returning call10621 (depth = 5)
  gc_frame_newslot(call10621);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10623 = alloc_Float64(1);
// compiled num node returning num10623 (depth = 6)
  int op_slot_right_10622 = gc_frame_newslot(num10623);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10626 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10627 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10626);
// compiled call node returning call10627 (depth = 8)
// compiled member node returning call10627 (depth = 7)
  int op_slot_right_10625 = gc_frame_newslot(call10627);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10630 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10629);
// compiled call node returning call10630 (depth = 8)
// compiled member node returning call10630 (depth = 7)
  int op_slot_left_10625 = gc_frame_newslot(call10630);
  params[0] = call10627;
  partcv[0] = 1;
  Object sum10631 = callmethod(call10630, "+", 1, partcv, params);
// compiled op node returning sum10631 (depth = 6)
  int op_slot_left_10622 = gc_frame_newslot(sum10631);
  params[0] = num10623;
  partcv[0] = 1;
  Object sum10632 = callmethod(sum10631, "+", 1, partcv, params);
// compiled op node returning sum10632 (depth = 5)
  gc_frame_newslot(sum10632);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10619;
  params[1] = call10621;
  params[2] = sum10632;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10633 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10618);
// compiled call node returning call10633 (depth = 4)
    gc_frame_newslot(call10633);
    if10604 = call10633;
  } else {
  }
// compiled if node returning if10604 (depth = 3)
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10634 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10635 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10634);
// compiled call node returning call10635 (depth = 4)
// compiled member node returning call10635 (depth = 3)
// Begin line 3279
  setline(3279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10636 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10637 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10636);
// compiled call node returning call10637 (depth = 4)
// compiled member node returning call10637 (depth = 3)
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10638 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_values (depth = 6)
  partcv[0] = 0;
  Object call10639 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10638);
// compiled call node returning call10639 (depth = 5)
// compiled member node returning call10639 (depth = 4)
  *var_p = call10639;
  if (call10639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10640 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10641 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call10642 = callmethodflags(prelude, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10641);
// compiled call node returning call10642 (depth = 7)
// compiled member node returning call10642 (depth = 6)
  partcv[0] = 0;
  Object call10643 = callmethod(call10642, "empty",
    1, partcv, params);
  gc_frame_end(callframe10640);
// compiled call node returning call10643 (depth = 5)
// compiled member node returning call10643 (depth = 4)
  *var_gens = call10643;
  if (call10643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3282
  setline(3282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10646 == NULL) {
    strlit10646 = alloc_String("generic");
    gc_root(strlit10646);
  }
// compiled string node returning strlit10646 (depth = 5)
  int op_slot_right_10645 = gc_frame_newslot(strlit10646);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10648 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call10649 = callmethod(*var_p, "kind",
    1, partcv, params);
  gc_frame_end(callframe10648);
// compiled call node returning call10649 (depth = 6)
// compiled member node returning call10649 (depth = 5)
  int op_slot_left_10645 = gc_frame_newslot(call10649);
  params[0] = strlit10646;
  partcv[0] = 1;
  Object opresult10650 = callmethod(call10649, "==", 1, partcv, params);
// compiled op node returning opresult10650 (depth = 4)
  Object if10644 = done;
  if (istrue(opresult10650)) {
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10651 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call10652 = callmethod(*var_p, "params",
    1, partcv, params);
  gc_frame_end(callframe10651);
// compiled call node returning call10652 (depth = 6)
// compiled member node returning call10652 (depth = 5)
  *var_gens = call10652;
  if (call10652 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 3285
  setline(3285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10654 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_p (depth = 7)
  partcv[0] = 0;
  Object call10655 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10654);
// compiled call node returning call10655 (depth = 6)
// compiled member node returning call10655 (depth = 5)
  *var_p = call10655;
  if (call10655 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if10644 = done;
  } else {
  }
// compiled if node returning if10644 (depth = 3)
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10657 = gc_frame_new();
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool10658 = alloc_Boolean(1);
// compiled identifier node returning bool10658 (depth = 5)
  gc_frame_newslot(bool10658);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  params[0] = bool10658;
  partcv[0] = 1;
  Object call10659 = callmethod(*var_p, "isBindingOccurrence:=",
    1, partcv, params);
  gc_frame_end(callframe10657);
// compiled call node returning call10659 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10660 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block10661 = alloc_Block(NULL, NULL, "parser", 3287);
  gc_frame_newslot(block10661);
// method _apply
  block_savedest(block10661);
  Object closure10662 = createclosure(1, "_apply");
  setclosureframe(closure10662, stackframe);
  addtoclosure(closure10662, selfslot);
  struct UserObject *uo10662 = (struct UserObject*)block10661;
  uo10662->data[0] = (Object)closure10662;
  Method *meth_meth_parser__apply10662 = addmethod2pos(block10661, "_apply", &meth_parser__apply10662, 0);
  int argcv_meth_parser__apply10662[] = {1};
  meth_meth_parser__apply10662->type = alloc_MethodType(1, argcv_meth_parser__apply10662);
  meth_meth_parser__apply10662->definitionModule = modulename;
  meth_meth_parser__apply10662->definitionLine = 3284;
// compiled block node returning block10661 (depth = 4)
  gc_frame_newslot(block10661);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_gens (depth = 4)
  params[0] = block10661;
  partcv[0] = 1;
  Object call10667 = callmethod(*var_gens, "do",
    1, partcv, params);
  gc_frame_end(callframe10660);
// compiled call node returning call10667 (depth = 3)
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10668 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10669 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10668);
// compiled call node returning call10669 (depth = 5)
// compiled member node returning call10669 (depth = 4)
  *var_anns = call10669;
  if (call10669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10673 == NULL) {
    strlit10673 = alloc_String("=");
    gc_root(strlit10673);
  }
// compiled string node returning strlit10673 (depth = 6)
  int op_slot_right_10672 = gc_frame_newslot(strlit10673);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10675 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10676 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10675);
// compiled call node returning call10676 (depth = 7)
// compiled member node returning call10676 (depth = 6)
  int op_slot_left_10672 = gc_frame_newslot(call10676);
  params[0] = strlit10673;
  partcv[0] = 1;
  Object opresult10677 = callmethod(call10676, "!=", 1, partcv, params);
// compiled op node returning opresult10677 (depth = 5)
  int op_slot_right_10671 = gc_frame_newslot(opresult10677);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10680 == NULL) {
    strlit10680 = alloc_String("op");
    gc_root(strlit10680);
  }
// compiled string node returning strlit10680 (depth = 6)
  int op_slot_right_10679 = gc_frame_newslot(strlit10680);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10682 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10683 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10682);
// compiled call node returning call10683 (depth = 7)
// compiled member node returning call10683 (depth = 6)
  int op_slot_left_10679 = gc_frame_newslot(call10683);
  params[0] = strlit10680;
  partcv[0] = 1;
  Object opresult10684 = callmethod(call10683, "!=", 1, partcv, params);
// compiled op node returning opresult10684 (depth = 5)
  int op_slot_left_10671 = gc_frame_newslot(opresult10684);
  params[0] = opresult10677;
  partcv[0] = 1;
  Object opresult10685 = callmethod(opresult10684, "||", 1, partcv, params);
// compiled op node returning opresult10685 (depth = 4)
  Object if10670 = done;
  if (istrue(opresult10685)) {
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// Begin line 3290
  setline(3290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10686 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10687 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call10688 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10687);
// compiled call node returning call10688 (depth = 8)
// compiled member node returning call10688 (depth = 7)
  partcv[0] = 0;
  Object call10689 = callmethod(call10688, "new",
    1, partcv, params);
  gc_frame_end(callframe10686);
// compiled call node returning call10689 (depth = 6)
// compiled member node returning call10689 (depth = 5)
  *var_suggestion = call10689;
  if (call10689 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10690 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10691 = alloc_Block(NULL, NULL, "parser", 3291);
  gc_frame_newslot(block10691);
// method _apply
  block_savedest(block10691);
  Object closure10692 = createclosure(1, "_apply");
  setclosureframe(closure10692, stackframe);
  addtoclosure(closure10692, selfslot);
  struct UserObject *uo10692 = (struct UserObject*)block10691;
  uo10692->data[0] = (Object)closure10692;
  Method *meth_meth_parser__apply10692 = addmethod2pos(block10691, "_apply", &meth_parser__apply10692, 0);
  int argcv_meth_parser__apply10692[] = {1};
  meth_meth_parser__apply10692->type = alloc_MethodType(1, argcv_meth_parser__apply10692);
  meth_meth_parser__apply10692->definitionModule = modulename;
  meth_meth_parser__apply10692->definitionLine = 3290;
// compiled block node returning block10691 (depth = 6)
  gc_frame_newslot(block10691);
// call case 4: self request
  params[0] = block10691;
  partcv[0] = 1;
  Object call10700 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10690);
// compiled call node returning call10700 (depth = 5)
  *var_nextTok = call10700;
  if (call10700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3297
  setline(3297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10702 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block10703 = alloc_Block(NULL, NULL, "parser", 3292);
  gc_frame_newslot(block10703);
// method _apply
  block_savedest(block10703);
  Object closure10704 = createclosure(3, "_apply");
  setclosureframe(closure10704, stackframe);
  addtoclosure(closure10704, var_sym);
  addtoclosure(closure10704, var_nextTok);
  addtoclosure(closure10704, selfslot);
  struct UserObject *uo10704 = (struct UserObject*)block10703;
  uo10704->data[0] = (Object)closure10704;
  Method *meth_meth_parser__apply10704 = addmethod2pos(block10703, "_apply", &meth_parser__apply10704, 0);
  int argcv_meth_parser__apply10704[] = {0};
  meth_meth_parser__apply10704->type = alloc_MethodType(1, argcv_meth_parser__apply10704);
  meth_meth_parser__apply10704->definitionModule = modulename;
  meth_meth_parser__apply10704->definitionLine = 3291;
// compiled block node returning block10703 (depth = 6)
  gc_frame_newslot(block10703);
// call case 6: other member request
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool10710 = alloc_Boolean(0);
// compiled identifier node returning bool10710 (depth = 7)
  int op_slot_right_10709 = gc_frame_newslot(bool10710);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nextTok (depth = 7)
  int op_slot_left_10709 = gc_frame_newslot(*var_nextTok);
  params[0] = bool10710;
  partcv[0] = 1;
  Object opresult10712 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult10712 (depth = 6)
  params[0] = block10703;
  partcv[0] = 1;
  Object call10713 = callmethod(opresult10712, "orElse",
    1, partcv, params);
  gc_frame_end(callframe10702);
// compiled call node returning call10713 (depth = 5)
  Object if10701 = done;
  if (istrue(call10713)) {
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10714 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit10715 == NULL) {
    strlit10715 = alloc_String(" =");
    gc_root(strlit10715);
  }
// compiled string node returning strlit10715 (depth = 6)
  gc_frame_newslot(strlit10715);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = strlit10715;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10716 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10714);
// compiled call node returning call10716 (depth = 5)
    gc_frame_newslot(call10716);
    if10701 = call10716;
  } else {
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe10717 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10718 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call10719 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10718);
// compiled call node returning call10719 (depth = 7)
// compiled member node returning call10719 (depth = 6)
  gc_frame_newslot(call10719);
// starting to compile string node (depth = 6)
  if (strlit10720 == NULL) {
    strlit10720 = alloc_String("=");
    gc_root(strlit10720);
  }
// compiled string node returning strlit10720 (depth = 6)
  gc_frame_newslot(strlit10720);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call10719;
  params[2] = strlit10720;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10721 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe10717);
// compiled call node returning call10721 (depth = 5)
    gc_frame_newslot(call10721);
    if10701 = call10721;
  }
// compiled if node returning if10701 (depth = 4)
// Begin line 3297
  setline(3297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10722 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10723 == NULL) {
    strlit10723 = alloc_String("A type declaration must have a '=' after the type name.");
    gc_root(strlit10723);
  }
// compiled string node returning strlit10723 (depth = 5)
  gc_frame_newslot(strlit10723);
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10724 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lastToken (depth = 7)
  partcv[0] = 0;
  Object call10725 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10724);
// compiled call node returning call10725 (depth = 6)
// compiled member node returning call10725 (depth = 5)
  gc_frame_newslot(call10725);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num10727 = alloc_Float64(1);
// compiled num node returning num10727 (depth = 6)
  int op_slot_right_10726 = gc_frame_newslot(num10727);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10731 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10730);
// compiled call node returning call10731 (depth = 8)
// compiled member node returning call10731 (depth = 7)
  int op_slot_right_10729 = gc_frame_newslot(call10731);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call10734 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10733);
// compiled call node returning call10734 (depth = 8)
// compiled member node returning call10734 (depth = 7)
  int op_slot_left_10729 = gc_frame_newslot(call10734);
  params[0] = call10731;
  partcv[0] = 1;
  Object sum10735 = callmethod(call10734, "+", 1, partcv, params);
// compiled op node returning sum10735 (depth = 6)
  int op_slot_left_10726 = gc_frame_newslot(sum10735);
  params[0] = num10727;
  partcv[0] = 1;
  Object sum10736 = callmethod(sum10735, "+", 1, partcv, params);
// compiled op node returning sum10736 (depth = 5)
  gc_frame_newslot(sum10736);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestion (depth = 5)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3297
  setline(3297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit10723;
  params[1] = call10725;
  params[2] = sum10736;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10737 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10722);
// compiled call node returning call10737 (depth = 4)
    gc_frame_newslot(call10737);
    if10670 = call10737;
  } else {
  }
// compiled if node returning if10670 (depth = 3)
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10739 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10738);
// compiled call node returning call10739 (depth = 4)
// compiled member node returning call10739 (depth = 3)
// Begin line 3307
  setline(3307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3302
  setline(3302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10741 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit10742 == NULL) {
    strlit10742 = alloc_String("lbrace");
    gc_root(strlit10742);
  }
// compiled string node returning strlit10742 (depth = 5)
  gc_frame_newslot(strlit10742);
// call case 4: self request
  params[0] = strlit10742;
  partcv[0] = 1;
  Object call10743 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10741);
// compiled call node returning call10743 (depth = 4)
  Object if10740 = done;
  if (istrue(call10743)) {
// Begin line 3303
  setline(3303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10744 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10745 = callmethodflags(self, "dotypeLiteral", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10744);
// compiled call node returning call10745 (depth = 5)
// compiled member node returning call10745 (depth = 4)
    gc_frame_newslot(call10745);
    if10740 = call10745;
  } else {
// Begin line 3305
  setline(3305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10746 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_noBlocks (depth = 5)
  gc_frame_newslot(*var_noBlocks);
// call case 4: self request
  params[0] = *var_noBlocks;
  partcv[0] = 1;
  Object call10747 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10746);
// compiled call node returning call10747 (depth = 4)
    gc_frame_newslot(call10747);
    if10740 = call10747;
  }
// compiled if node returning if10740 (depth = 3)
// Begin line 3307
  setline(3307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10748 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  gc_frame_newslot(*var_p);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  partcv[0] = 0;
  Object call10750 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10749);
// compiled call node returning call10750 (depth = 6)
// compiled member node returning call10750 (depth = 5)
  gc_frame_newslot(call10750);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10751 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ast (depth = 7)
  partcv[0] = 0;
  Object call10752 = callmethod(*var_ast, "typeDecNode",
    1, partcv, params);
  gc_frame_end(callframe10751);
// compiled call node returning call10752 (depth = 6)
// compiled member node returning call10752 (depth = 5)
  params[0] = *var_p;
  params[1] = call10750;
  partcv[0] = 2;
  Object call10753 = callmethod(call10752, "new",
    1, partcv, params);
  gc_frame_end(callframe10748);
// compiled call node returning call10753 (depth = 4)
  *var_nt = call10753;
  if (call10753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3307
  setline(3307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10754 = gc_frame_new();
// Begin line 3308
  setline(3308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_gens (depth = 5)
  gc_frame_newslot(*var_gens);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_nt (depth = 5)
  params[0] = *var_gens;
  partcv[0] = 1;
  Object call10755 = callmethod(*var_nt, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10754);
// compiled call node returning call10755 (depth = 4)
// compiled bind node returning done (depth = 3)
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  int op_slot_right_10757 = gc_frame_newslot(*var_anns);
// starting to compile identifier node (depth = 5)
  Object bool10759 = alloc_Boolean(0);
// compiled identifier node returning bool10759 (depth = 5)
  int op_slot_left_10757 = gc_frame_newslot(bool10759);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult10760 = callmethod(bool10759, "!=", 1, partcv, params);
// compiled op node returning opresult10760 (depth = 4)
  Object if10756 = done;
  if (istrue(opresult10760)) {
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe10761 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_anns (depth = 5)
  gc_frame_newslot(*var_anns);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_nt (depth = 7)
  partcv[0] = 0;
  Object call10763 = callmethod(*var_nt, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10762);
// compiled call node returning call10763 (depth = 6)
// compiled member node returning call10763 (depth = 5)
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10764 = callmethod(call10763, "extend",
    1, partcv, params);
  gc_frame_end(callframe10761);
// compiled call node returning call10764 (depth = 4)
    gc_frame_newslot(call10764);
    if10756 = call10764;
  } else {
  }
// compiled if node returning if10756 (depth = 3)
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10765 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_nt (depth = 4)
  gc_frame_newslot(*var_nt);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_values (depth = 4)
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call10766 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10765);
// compiled call node returning call10766 (depth = 3)
    gc_frame_newslot(call10766);
    if10585 = call10766;
  } else {
  }
// compiled if node returning if10585 (depth = 2)
  gc_frame_end(frame);
  return if10585;
}
Object meth_parser__apply10846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_suggestion = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3330
  setline(3330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 10)
  int callframe10847 = gc_frame_new();
// starting to compile string node (depth = 11)
  if (strlit10848 == NULL) {
    strlit10848 = alloc_String(" ");
    gc_root(strlit10848);
  }
// compiled string node returning strlit10848 (depth = 11)
  gc_frame_newslot(strlit10848);
// starting to compile num node (depth = 11)
  Object num10849 = alloc_Float64(1);
// compiled num node returning num10849 (depth = 11)
  gc_frame_newslot(num10849);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10850 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call10851 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10850);
// compiled call node returning call10851 (depth = 12)
// compiled member node returning call10851 (depth = 11)
  gc_frame_newslot(call10851);
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_suggestion (depth = 11)
  params[0] = strlit10848;
  params[1] = num10849;
  params[2] = call10851;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10852 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe10847);
// compiled call node returning call10852 (depth = 10)
  gc_frame_end(frame);
  return call10852;
}
Object meth_parser__apply10864(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_minIndentLevel (depth = 12)
  int op_slot_right_10866 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10868 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call10869 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10868);
// compiled call node returning call10869 (depth = 13)
// compiled member node returning call10869 (depth = 12)
  int op_slot_left_10866 = gc_frame_newslot(call10869);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10870 = callmethod(call10869, ">=", 1, partcv, params);
// compiled op node returning opresult10870 (depth = 11)
  int op_slot_right_10865 = gc_frame_newslot(opresult10870);
// starting to compile op node (depth = 11)
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num10874 = alloc_Float64(1);
// compiled num node returning num10874 (depth = 13)
  int op_slot_right_10873 = gc_frame_newslot(num10874);
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe10876 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_tok (depth = 15)
  partcv[0] = 0;
  Object call10877 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10876);
// compiled call node returning call10877 (depth = 14)
// compiled member node returning call10877 (depth = 13)
  int op_slot_left_10873 = gc_frame_newslot(call10877);
  params[0] = num10874;
  partcv[0] = 1;
  Object sum10878 = callmethod(call10877, "+", 1, partcv, params);
// compiled op node returning sum10878 (depth = 12)
  int op_slot_right_10872 = gc_frame_newslot(sum10878);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10880 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_tok (depth = 14)
  partcv[0] = 0;
  Object call10881 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10880);
// compiled call node returning call10881 (depth = 13)
// compiled member node returning call10881 (depth = 12)
  int op_slot_left_10872 = gc_frame_newslot(call10881);
  params[0] = sum10878;
  partcv[0] = 1;
  Object opresult10882 = callmethod(call10881, "!=", 1, partcv, params);
// compiled op node returning opresult10882 (depth = 11)
  int op_slot_left_10865 = gc_frame_newslot(opresult10882);
  params[0] = opresult10870;
  partcv[0] = 1;
  Object opresult10883 = callmethod(opresult10882, "||", 1, partcv, params);
// compiled op node returning opresult10883 (depth = 10)
  gc_frame_end(frame);
  return opresult10883;
}
Object meth_parser__apply10886(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_tok (depth = 13)
  partcv[0] = 0;
  Object call10888 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10887);
// compiled call node returning call10888 (depth = 12)
// compiled member node returning call10888 (depth = 11)
  *var_tok = call10888;
  if (call10888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply10901(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3340
  setline(3340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 10)
// starting to compile op node (depth = 11)
// Begin line 3339
  setline(3339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 12)
  if (strlit10903 == NULL) {
    strlit10903 = alloc_String(" ");
    gc_root(strlit10903);
  }
// compiled string node returning strlit10903 (depth = 12)
  int op_slot_right_10902 = gc_frame_newslot(strlit10903);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_line (depth = 12)
  int op_slot_left_10902 = gc_frame_newslot(*var_line);
  params[0] = strlit10903;
  partcv[0] = 1;
  Object opresult10905 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult10905 (depth = 11)
  *var_line = opresult10905;
  if (opresult10905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 10)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_checkIndent10767(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tok");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
// Begin line 3350
  setline(3350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3317
  setline(3317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  Object if10768 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// Begin line 3318
  setline(3318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool10769 = alloc_Boolean(0);
// compiled identifier node returning bool10769 (depth = 4)
  *var_indentFreePass = bool10769;
  if (bool10769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if10768 = done;
  } else {
// Begin line 3321
  setline(3321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10773 == NULL) {
    strlit10773 = alloc_String("semicolon");
    gc_root(strlit10773);
  }
// compiled string node returning strlit10773 (depth = 5)
  int op_slot_right_10772 = gc_frame_newslot(strlit10773);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10776 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10775);
// compiled call node returning call10776 (depth = 6)
// compiled member node returning call10776 (depth = 5)
  int op_slot_left_10772 = gc_frame_newslot(call10776);
  params[0] = strlit10773;
  partcv[0] = 1;
  Object opresult10777 = callmethod(call10776, "==", 1, partcv, params);
// compiled op node returning opresult10777 (depth = 4)
  Object if10771 = done;
  if (istrue(opresult10777)) {
    gc_frame_newslot(done);
    if10771 = done;
  } else {
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3322
  setline(3322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10781 == NULL) {
    strlit10781 = alloc_String("rsquare");
    gc_root(strlit10781);
  }
// compiled string node returning strlit10781 (depth = 7)
  int op_slot_right_10780 = gc_frame_newslot(strlit10781);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10783 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10784 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10783);
// compiled call node returning call10784 (depth = 8)
// compiled member node returning call10784 (depth = 7)
  int op_slot_left_10780 = gc_frame_newslot(call10784);
  params[0] = strlit10781;
  partcv[0] = 1;
  Object opresult10785 = callmethod(call10784, "==", 1, partcv, params);
// compiled op node returning opresult10785 (depth = 6)
  int op_slot_right_10779 = gc_frame_newslot(opresult10785);
// starting to compile op node (depth = 6)
// Begin line 3321
  setline(3321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10789 == NULL) {
    strlit10789 = alloc_String("rparen");
    gc_root(strlit10789);
  }
// compiled string node returning strlit10789 (depth = 8)
  int op_slot_right_10788 = gc_frame_newslot(strlit10789);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10791 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10792 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10791);
// compiled call node returning call10792 (depth = 9)
// compiled member node returning call10792 (depth = 8)
  int op_slot_left_10788 = gc_frame_newslot(call10792);
  params[0] = strlit10789;
  partcv[0] = 1;
  Object opresult10793 = callmethod(call10792, "==", 1, partcv, params);
// compiled op node returning opresult10793 (depth = 7)
  int op_slot_right_10787 = gc_frame_newslot(opresult10793);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10796 == NULL) {
    strlit10796 = alloc_String("rbrace");
    gc_root(strlit10796);
  }
// compiled string node returning strlit10796 (depth = 8)
  int op_slot_right_10795 = gc_frame_newslot(strlit10796);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10798 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10799 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10798);
// compiled call node returning call10799 (depth = 9)
// compiled member node returning call10799 (depth = 8)
  int op_slot_left_10795 = gc_frame_newslot(call10799);
  params[0] = strlit10796;
  partcv[0] = 1;
  Object opresult10800 = callmethod(call10799, "==", 1, partcv, params);
// compiled op node returning opresult10800 (depth = 7)
  int op_slot_left_10787 = gc_frame_newslot(opresult10800);
  params[0] = opresult10793;
  partcv[0] = 1;
  Object opresult10801 = callmethod(opresult10800, "||", 1, partcv, params);
// compiled op node returning opresult10801 (depth = 6)
  int op_slot_left_10779 = gc_frame_newslot(opresult10801);
  params[0] = opresult10785;
  partcv[0] = 1;
  Object opresult10802 = callmethod(opresult10801, "||", 1, partcv, params);
// compiled op node returning opresult10802 (depth = 5)
  Object if10778 = done;
  if (istrue(opresult10802)) {
    gc_frame_newslot(done);
    if10778 = done;
  } else {
// Begin line 3325
  setline(3325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10805 == NULL) {
    strlit10805 = alloc_String("eof");
    gc_root(strlit10805);
  }
// compiled string node returning strlit10805 (depth = 7)
  int op_slot_right_10804 = gc_frame_newslot(strlit10805);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10808 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10807);
// compiled call node returning call10808 (depth = 8)
// compiled member node returning call10808 (depth = 7)
  int op_slot_left_10804 = gc_frame_newslot(call10808);
  params[0] = strlit10805;
  partcv[0] = 1;
  Object opresult10809 = callmethod(call10808, "==", 1, partcv, params);
// compiled op node returning opresult10809 (depth = 6)
  Object if10803 = done;
  if (istrue(opresult10809)) {
    gc_frame_newslot(done);
    if10803 = done;
  } else {
// Begin line 3347
  setline(3347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3325
  setline(3325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_minIndentLevel (depth = 8)
  int op_slot_right_10811 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10813 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10814 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10813);
// compiled call node returning call10814 (depth = 9)
// compiled member node returning call10814 (depth = 8)
  int op_slot_left_10811 = gc_frame_newslot(call10814);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10815 = callmethod(call10814, "<", 1, partcv, params);
// compiled op node returning opresult10815 (depth = 7)
  Object if10810 = done;
  if (istrue(opresult10815)) {
// Begin line 3347
  setline(3347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3326
  setline(3326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_10817 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10820 = alloc_Float64(1);
// compiled num node returning num10820 (depth = 10)
  int op_slot_right_10819 = gc_frame_newslot(num10820);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10822 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10823 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10822);
// compiled call node returning call10823 (depth = 11)
// compiled member node returning call10823 (depth = 10)
  int op_slot_left_10819 = gc_frame_newslot(call10823);
  params[0] = num10820;
  partcv[0] = 1;
  Object diff10824 = callmethod(call10823, "-", 1, partcv, params);
// compiled op node returning diff10824 (depth = 9)
  int op_slot_left_10817 = gc_frame_newslot(diff10824);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10825 = callmethod(diff10824, "!=", 1, partcv, params);
// compiled op node returning opresult10825 (depth = 8)
  Object if10816 = done;
  if (istrue(opresult10825)) {
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// Begin line 3327
  setline(3327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 9)
  Object array10826 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array10826 (depth = 9)
  *var_suggestions = array10826;
  if (array10826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 3329
  setline(3329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10827 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10828 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call10829 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10828);
// compiled call node returning call10829 (depth = 12)
// compiled member node returning call10829 (depth = 11)
  partcv[0] = 0;
  Object call10830 = callmethod(call10829, "new",
    1, partcv, params);
  gc_frame_end(callframe10827);
// compiled call node returning call10830 (depth = 10)
// compiled member node returning call10830 (depth = 9)
  *var_suggestion = call10830;
  if (call10830 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3329
  setline(3329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10831 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num10835 = alloc_Float64(1);
// compiled num node returning num10835 (depth = 12)
  int op_slot_right_10834 = gc_frame_newslot(num10835);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe10837 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call10838 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10837);
// compiled call node returning call10838 (depth = 13)
// compiled member node returning call10838 (depth = 12)
  int op_slot_left_10834 = gc_frame_newslot(call10838);
  params[0] = num10835;
  partcv[0] = 1;
  Object diff10839 = callmethod(call10838, "-", 1, partcv, params);
// compiled op node returning diff10839 (depth = 11)
  int op_slot_right_10833 = gc_frame_newslot(diff10839);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_left_10833 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff10839;
  partcv[0] = 1;
  Object diff10841 = callmethod(*var_minIndentLevel, "-", 1, partcv, params);
// compiled op node returning diff10841 (depth = 10)
  int op_slot_right_10832 = gc_frame_newslot(diff10841);
// starting to compile num node (depth = 10)
  Object num10843 = alloc_Float64(1);
// compiled num node returning num10843 (depth = 10)
  int op_slot_left_10832 = gc_frame_newslot(num10843);
  params[0] = diff10841;
  partcv[0] = 1;
  Object opresult10844 = callmethod(num10843, "..", 1, partcv, params);
// compiled op node returning opresult10844 (depth = 9)
  gc_frame_newslot(opresult10844);
// starting to compile block node (depth = 9)
  Object block10845 = alloc_Block(NULL, NULL, "parser", 3329);
  gc_frame_newslot(block10845);
// method _apply
  block_savedest(block10845);
  Object closure10846 = createclosure(3, "_apply");
  setclosureframe(closure10846, stackframe);
  addtoclosure(closure10846, var_sym);
  addtoclosure(closure10846, var_suggestion);
  addtoclosure(closure10846, selfslot);
  struct UserObject *uo10846 = (struct UserObject*)block10845;
  uo10846->data[0] = (Object)closure10846;
  Method *meth_meth_parser__apply10846 = addmethod2pos(block10845, "_apply", &meth_parser__apply10846, 0);
  int argcv_meth_parser__apply10846[] = {1};
  meth_meth_parser__apply10846->type = alloc_MethodType(1, argcv_meth_parser__apply10846);
  meth_meth_parser__apply10846->definitionModule = modulename;
  meth_meth_parser__apply10846->definitionLine = 3329;
// compiled block node returning block10845 (depth = 9)
  gc_frame_newslot(block10845);
// call case 5: prelude request
  params[0] = opresult10844;
  params[1] = block10845;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10854 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10831);
// compiled call node returning call10854 (depth = 8)
// Begin line 3332
  setline(3332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10855 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10856 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10855);
// compiled call node returning call10856 (depth = 8)
// Begin line 3335
  setline(3335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 3333
  setline(3333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10857 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe10858 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_errormessages (depth = 13)
  partcv[0] = 0;
  Object call10859 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10858);
// compiled call node returning call10859 (depth = 12)
// compiled member node returning call10859 (depth = 11)
  partcv[0] = 0;
  Object call10860 = callmethod(call10859, "new",
    1, partcv, params);
  gc_frame_end(callframe10857);
// compiled call node returning call10860 (depth = 10)
// compiled member node returning call10860 (depth = 9)
  *var_suggestion = call10860;
  if (call10860 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 3335
  setline(3335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10862 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block10863 = alloc_Block(NULL, NULL, "parser", 3336);
  gc_frame_newslot(block10863);
// method _apply
  block_savedest(block10863);
  Object closure10864 = createclosure(3, "_apply");
  setclosureframe(closure10864, stackframe);
  addtoclosure(closure10864, var_minIndentLevel);
  addtoclosure(closure10864, var_tok);
  addtoclosure(closure10864, selfslot);
  struct UserObject *uo10864 = (struct UserObject*)block10863;
  uo10864->data[0] = (Object)closure10864;
  Method *meth_meth_parser__apply10864 = addmethod2pos(block10863, "_apply", &meth_parser__apply10864, 0);
  int argcv_meth_parser__apply10864[] = {0};
  meth_meth_parser__apply10864->type = alloc_MethodType(1, argcv_meth_parser__apply10864);
  meth_meth_parser__apply10864->definitionModule = modulename;
  meth_meth_parser__apply10864->definitionLine = 3333;
// compiled block node returning block10863 (depth = 9)
  gc_frame_newslot(block10863);
// starting to compile block node (depth = 9)
  Object block10885 = alloc_Block(NULL, NULL, "parser", 3336);
  gc_frame_newslot(block10885);
// method _apply
  block_savedest(block10885);
  Object closure10886 = createclosure(2, "_apply");
  setclosureframe(closure10886, stackframe);
  addtoclosure(closure10886, var_tok);
  addtoclosure(closure10886, selfslot);
  struct UserObject *uo10886 = (struct UserObject*)block10885;
  uo10886->data[0] = (Object)closure10886;
  Method *meth_meth_parser__apply10886 = addmethod2pos(block10885, "_apply", &meth_parser__apply10886, 0);
  int argcv_meth_parser__apply10886[] = {0};
  meth_meth_parser__apply10886->type = alloc_MethodType(1, argcv_meth_parser__apply10886);
  meth_meth_parser__apply10886->definitionModule = modulename;
  meth_meth_parser__apply10886->definitionLine = 3336;
// compiled block node returning block10885 (depth = 9)
  gc_frame_newslot(block10885);
// call case 5: prelude request
  params[0] = block10863;
  params[1] = block10885;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10891 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10862);
// compiled call node returning call10891 (depth = 8)
// Begin line 3338
  setline(3338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 8)
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 9)
  if (strlit10892 == NULL) {
    strlit10892 = alloc_String("");
    gc_root(strlit10892);
  }
// compiled string node returning strlit10892 (depth = 9)
  *var_line = strlit10892;
  if (strlit10892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 8)
// Begin line 3338
  setline(3338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10893 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10895 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tok (depth = 12)
  partcv[0] = 0;
  Object call10896 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10895);
// compiled call node returning call10896 (depth = 11)
// compiled member node returning call10896 (depth = 10)
  int op_slot_right_10894 = gc_frame_newslot(call10896);
// starting to compile num node (depth = 10)
  Object num10898 = alloc_Float64(1);
// compiled num node returning num10898 (depth = 10)
  int op_slot_left_10894 = gc_frame_newslot(num10898);
  params[0] = call10896;
  partcv[0] = 1;
  Object opresult10899 = callmethod(num10898, "..", 1, partcv, params);
// compiled op node returning opresult10899 (depth = 9)
  gc_frame_newslot(opresult10899);
// starting to compile block node (depth = 9)
  Object block10900 = alloc_Block(NULL, NULL, "parser", 3338);
  gc_frame_newslot(block10900);
// method _apply
  block_savedest(block10900);
  Object closure10901 = createclosure(2, "_apply");
  setclosureframe(closure10901, stackframe);
  addtoclosure(closure10901, var_line);
  addtoclosure(closure10901, selfslot);
  struct UserObject *uo10901 = (struct UserObject*)block10900;
  uo10901->data[0] = (Object)closure10901;
  Method *meth_meth_parser__apply10901 = addmethod2pos(block10900, "_apply", &meth_parser__apply10901, 0);
  int argcv_meth_parser__apply10901[] = {1};
  meth_meth_parser__apply10901->type = alloc_MethodType(1, argcv_meth_parser__apply10901);
  meth_meth_parser__apply10901->definitionModule = modulename;
  meth_meth_parser__apply10901->definitionLine = 3338;
// compiled block node returning block10900 (depth = 9)
  gc_frame_newslot(block10900);
// call case 5: prelude request
  params[0] = opresult10899;
  params[1] = block10900;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10908 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10893);
// compiled call node returning call10908 (depth = 8)
// Begin line 3342
  setline(3342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// Begin line 3341
  setline(3341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit10910 == NULL) {
    strlit10910 = alloc_String("}");
    gc_root(strlit10910);
  }
// compiled string node returning strlit10910 (depth = 10)
  int op_slot_right_10909 = gc_frame_newslot(strlit10910);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_line (depth = 10)
  int op_slot_left_10909 = gc_frame_newslot(*var_line);
  params[0] = strlit10910;
  partcv[0] = 1;
  Object opresult10912 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult10912 (depth = 9)
  *var_line = opresult10912;
  if (opresult10912 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 3342
  setline(3342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10914 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num10916 = alloc_Float64(0.9);
// compiled num node returning num10916 (depth = 10)
  int op_slot_right_10915 = gc_frame_newslot(num10916);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe10918 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call10919 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10918);
// compiled call node returning call10919 (depth = 11)
// compiled member node returning call10919 (depth = 10)
  int op_slot_left_10915 = gc_frame_newslot(call10919);
  params[0] = num10916;
  partcv[0] = 1;
  Object diff10920 = callmethod(call10919, "-", 1, partcv, params);
// compiled op node returning diff10920 (depth = 9)
  gc_frame_newslot(diff10920);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = diff10920;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call10921 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10914);
// compiled call node returning call10921 (depth = 8)
// Begin line 3343
  setline(3343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10922 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10923 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10922);
// compiled call node returning call10923 (depth = 8)
// Begin line 3344
  setline(3344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe10924 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit10926 == NULL) {
    strlit10926 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit10926);
  }
// compiled string node returning strlit10926 (depth = 10)
  int op_slot_right_10925 = gc_frame_newslot(strlit10926);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_minIndentLevel (depth = 11)
  int op_slot_right_10928 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile string node (depth = 11)
  if (strlit10930 == NULL) {
    strlit10930 = alloc_String("The indentation for this line must be at least ");
    gc_root(strlit10930);
  }
// compiled string node returning strlit10930 (depth = 11)
  int op_slot_left_10928 = gc_frame_newslot(strlit10930);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10931 = callmethod(strlit10930, "++", 1, partcv, params);
// compiled op node returning opresult10931 (depth = 10)
  int op_slot_left_10925 = gc_frame_newslot(opresult10931);
  params[0] = strlit10926;
  partcv[0] = 1;
  Object opresult10932 = callmethod(opresult10931, "++", 1, partcv, params);
// compiled op node returning opresult10932 (depth = 9)
  gc_frame_newslot(opresult10932);
// Begin line 3345
  setline(3345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10933 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10934 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10933);
// compiled call node returning call10934 (depth = 10)
// compiled member node returning call10934 (depth = 9)
  gc_frame_newslot(call10934);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10935 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10936 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10935);
// compiled call node returning call10936 (depth = 10)
// compiled member node returning call10936 (depth = 9)
  gc_frame_newslot(call10936);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestions (depth = 9)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3344
  setline(3344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  params[0] = opresult10932;
  params[1] = call10934;
  params[2] = call10936;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10937 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10924);
// compiled call node returning call10937 (depth = 8)
    gc_frame_newslot(call10937);
    if10816 = call10937;
  } else {
  }
// compiled if node returning if10816 (depth = 7)
    gc_frame_newslot(if10816);
    if10810 = if10816;
  } else {
// Begin line 3350
  setline(3350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3347
  setline(3347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_minIndentLevel (depth = 9)
  int op_slot_right_10939 = gc_frame_newslot(*var_minIndentLevel);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10942 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10941);
// compiled call node returning call10942 (depth = 10)
// compiled member node returning call10942 (depth = 9)
  int op_slot_left_10939 = gc_frame_newslot(call10942);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10943 = callmethod(call10942, ">", 1, partcv, params);
// compiled op node returning opresult10943 (depth = 8)
  Object if10938 = done;
  if (istrue(opresult10943)) {
// Begin line 3349
  setline(3349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// Begin line 3348
  setline(3348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10944 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10945 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10944);
// compiled call node returning call10945 (depth = 10)
// compiled member node returning call10945 (depth = 9)
  *var_minIndentLevel = call10945;
  if (call10945 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
    gc_frame_newslot(done);
    if10938 = done;
  } else {
  }
// compiled if node returning if10938 (depth = 7)
    gc_frame_newslot(if10938);
    if10810 = if10938;
  }
// compiled if node returning if10810 (depth = 6)
    gc_frame_newslot(if10810);
    if10803 = if10810;
  }
// compiled if node returning if10803 (depth = 5)
    gc_frame_newslot(if10803);
    if10778 = if10803;
  }
// compiled if node returning if10778 (depth = 4)
    gc_frame_newslot(if10778);
    if10771 = if10778;
  }
// compiled if node returning if10771 (depth = 3)
    gc_frame_newslot(if10771);
    if10768 = if10771;
  }
// compiled if node returning if10768 (depth = 2)
  gc_frame_end(frame);
  return if10768;
}
Object meth_parser__apply11034(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe11035 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_blocksOK (depth = 6)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call11036 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11035);
// compiled call node returning call11036 (depth = 5)
  gc_frame_end(frame);
  return call11036;
}
Object meth_parser__apply11085(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 11)
  int callframe11086 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call11087 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11086);
// compiled call node returning call11087 (depth = 11)
  gc_frame_end(frame);
  return call11087;
}
Object meth_parser__apply11039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_blocksOK = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dest = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "dest");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3409
  setline(3409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3386
  setline(3386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11042 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11043 == NULL) {
    strlit11043 = alloc_String("bind");
    gc_root(strlit11043);
  }
// compiled string node returning strlit11043 (depth = 8)
  gc_frame_newslot(strlit11043);
// call case 4: self request
  params[0] = strlit11043;
  partcv[0] = 1;
  Object call11044 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11042);
// compiled call node returning call11044 (depth = 7)
  int op_slot_right_11041 = gc_frame_newslot(call11044);
// Begin line 3385
  setline(3385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11048 == NULL) {
    strlit11048 = alloc_String("index");
    gc_root(strlit11048);
  }
// compiled string node returning strlit11048 (depth = 9)
  int op_slot_right_11047 = gc_frame_newslot(strlit11048);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11050 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11051 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_values (depth = 13)
  partcv[0] = 0;
  Object call11052 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11051);
// compiled call node returning call11052 (depth = 12)
// compiled member node returning call11052 (depth = 11)
  partcv[0] = 0;
  Object call11053 = callmethod(call11052, "kind",
    1, partcv, params);
  gc_frame_end(callframe11050);
// compiled call node returning call11053 (depth = 10)
// compiled member node returning call11053 (depth = 9)
  int op_slot_left_11047 = gc_frame_newslot(call11053);
  params[0] = strlit11048;
  partcv[0] = 1;
  Object opresult11054 = callmethod(call11053, "==", 1, partcv, params);
// compiled op node returning opresult11054 (depth = 8)
  int op_slot_right_11046 = gc_frame_newslot(opresult11054);
// starting to compile op node (depth = 8)
// Begin line 3384
  setline(3384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11058 == NULL) {
    strlit11058 = alloc_String("member");
    gc_root(strlit11058);
  }
// compiled string node returning strlit11058 (depth = 10)
  int op_slot_right_11057 = gc_frame_newslot(strlit11058);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11060 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11061 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11062 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11061);
// compiled call node returning call11062 (depth = 13)
// compiled member node returning call11062 (depth = 12)
  partcv[0] = 0;
  Object call11063 = callmethod(call11062, "kind",
    1, partcv, params);
  gc_frame_end(callframe11060);
// compiled call node returning call11063 (depth = 11)
// compiled member node returning call11063 (depth = 10)
  int op_slot_left_11057 = gc_frame_newslot(call11063);
  params[0] = strlit11058;
  partcv[0] = 1;
  Object opresult11064 = callmethod(call11063, "==", 1, partcv, params);
// compiled op node returning opresult11064 (depth = 9)
  int op_slot_right_11056 = gc_frame_newslot(opresult11064);
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11067 == NULL) {
    strlit11067 = alloc_String("identifier");
    gc_root(strlit11067);
  }
// compiled string node returning strlit11067 (depth = 10)
  int op_slot_right_11066 = gc_frame_newslot(strlit11067);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11069 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11070 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11071 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11070);
// compiled call node returning call11071 (depth = 13)
// compiled member node returning call11071 (depth = 12)
  partcv[0] = 0;
  Object call11072 = callmethod(call11071, "kind",
    1, partcv, params);
  gc_frame_end(callframe11069);
// compiled call node returning call11072 (depth = 11)
// compiled member node returning call11072 (depth = 10)
  int op_slot_left_11066 = gc_frame_newslot(call11072);
  params[0] = strlit11067;
  partcv[0] = 1;
  Object opresult11073 = callmethod(call11072, "==", 1, partcv, params);
// compiled op node returning opresult11073 (depth = 9)
  int op_slot_left_11056 = gc_frame_newslot(opresult11073);
  params[0] = opresult11064;
  partcv[0] = 1;
  Object opresult11074 = callmethod(opresult11073, "||", 1, partcv, params);
// compiled op node returning opresult11074 (depth = 8)
  int op_slot_left_11046 = gc_frame_newslot(opresult11074);
  params[0] = opresult11054;
  partcv[0] = 1;
  Object opresult11075 = callmethod(opresult11074, "||", 1, partcv, params);
// compiled op node returning opresult11075 (depth = 7)
  int op_slot_left_11041 = gc_frame_newslot(opresult11075);
  params[0] = call11044;
  partcv[0] = 1;
  Object opresult11076 = callmethod(opresult11075, "&&", 1, partcv, params);
// compiled op node returning opresult11076 (depth = 6)
  Object if11040 = done;
  if (istrue(opresult11076)) {
// Begin line 3388
  setline(3388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 3387
  setline(3387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11077 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11078 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe11077);
// compiled call node returning call11078 (depth = 8)
// compiled member node returning call11078 (depth = 7)
  *var_dest = call11078;
  if (call11078 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3388
  setline(3388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11079 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11080 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11079);
// compiled call node returning call11080 (depth = 7)
// compiled member node returning call11080 (depth = 6)
// Begin line 3405
  setline(3405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11082 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe11083 = gc_frame_new();
// starting to compile block node (depth = 10)
  Object block11084 = alloc_Block(NULL, NULL, "parser", 3389);
  gc_frame_newslot(block11084);
// method _apply
  block_savedest(block11084);
  Object closure11085 = createclosure(2, "_apply");
  setclosureframe(closure11085, stackframe);
  addtoclosure(closure11085, var_blocksOK);
  addtoclosure(closure11085, selfslot);
  struct UserObject *uo11085 = (struct UserObject*)block11084;
  uo11085->data[0] = (Object)closure11085;
  Method *meth_meth_parser__apply11085 = addmethod2pos(block11084, "_apply", &meth_parser__apply11085, 0);
  int argcv_meth_parser__apply11085[] = {0};
  meth_meth_parser__apply11085->type = alloc_MethodType(1, argcv_meth_parser__apply11085);
  meth_meth_parser__apply11085->definitionModule = modulename;
  meth_meth_parser__apply11085->definitionLine = 3389;
// compiled block node returning block11084 (depth = 10)
  gc_frame_newslot(block11084);
// call case 4: self request
  params[0] = block11084;
  partcv[0] = 1;
  Object call11089 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11083);
// compiled call node returning call11089 (depth = 9)
  partcv[0] = 0;
  Object call11090 = callmethod(call11089, "not",
    1, partcv, params);
  gc_frame_end(callframe11082);
// compiled call node returning call11090 (depth = 8)
// compiled member node returning call11090 (depth = 7)
  Object if11081 = done;
  if (istrue(call11090)) {
// Begin line 3391
  setline(3391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// Begin line 3390
  setline(3390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 8)
  Object array11091 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11091 (depth = 8)
  *var_suggestions = array11091;
  if (array11091 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 7)
// Begin line 3391
  setline(3391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11092 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11093 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11094 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11093);
// compiled call node returning call11094 (depth = 11)
// compiled member node returning call11094 (depth = 10)
  partcv[0] = 0;
  Object call11095 = callmethod(call11094, "new",
    1, partcv, params);
  gc_frame_end(callframe11092);
// compiled call node returning call11095 (depth = 9)
// compiled member node returning call11095 (depth = 8)
  *var_suggestion = call11095;
  if (call11095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 7)
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11096 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit11097 == NULL) {
    strlit11097 = alloc_String("rbrace");
    gc_root(strlit11097);
  }
// compiled string node returning strlit11097 (depth = 9)
  gc_frame_newslot(strlit11097);
// call case 4: self request
  params[0] = strlit11097;
  partcv[0] = 1;
  Object call11098 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11096);
// compiled call node returning call11098 (depth = 8)
  *var_nextTok = call11098;
  if (call11098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 7)
// Begin line 3398
  setline(3398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3393
  setline(3393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  int op_slot_right_11100 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_nextTok (depth = 9)
  int op_slot_left_11100 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult11102 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult11102 (depth = 8)
  Object if11099 = done;
  if (istrue(opresult11102)) {
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11103 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit11104 == NULL) {
    strlit11104 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit11104);
  }
// compiled string node returning strlit11104 (depth = 9)
  gc_frame_newslot(strlit11104);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = strlit11104;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11105 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe11103);
// compiled call node returning call11105 (depth = 8)
    gc_frame_newslot(call11105);
    if11099 = call11105;
  } else {
// Begin line 3396
  setline(3396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11106 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11107 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_nextTok (depth = 11)
  partcv[0] = 0;
  Object call11108 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11107);
// compiled call node returning call11108 (depth = 10)
// compiled member node returning call11108 (depth = 9)
  gc_frame_newslot(call11108);
// starting to compile identifier node (depth = 9)
  Object bool11109 = alloc_Boolean(1);
// compiled identifier node returning bool11109 (depth = 9)
  gc_frame_newslot(bool11109);
// starting to compile identifier node (depth = 9)
  Object bool11110 = alloc_Boolean(0);
// compiled identifier node returning bool11110 (depth = 9)
  gc_frame_newslot(bool11110);
// starting to compile string node (depth = 9)
  if (strlit11111 == NULL) {
    strlit11111 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit11111);
  }
// compiled string node returning strlit11111 (depth = 9)
  gc_frame_newslot(strlit11111);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_suggestion (depth = 9)
  params[0] = *var_sym;
  params[1] = call11108;
  params[2] = bool11109;
  params[3] = bool11110;
  params[4] = strlit11111;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11112 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11106);
// compiled call node returning call11112 (depth = 8)
    gc_frame_newslot(call11112);
    if11099 = call11112;
  }
// compiled if node returning if11099 (depth = 7)
// Begin line 3398
  setline(3398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11113 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11114 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11113);
// compiled call node returning call11114 (depth = 7)
// Begin line 3400
  setline(3400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11115 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11116 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11117 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11116);
// compiled call node returning call11117 (depth = 11)
// compiled member node returning call11117 (depth = 10)
  partcv[0] = 0;
  Object call11118 = callmethod(call11117, "new",
    1, partcv, params);
  gc_frame_end(callframe11115);
// compiled call node returning call11118 (depth = 9)
// compiled member node returning call11118 (depth = 8)
  *var_suggestion = call11118;
  if (call11118 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3400
  setline(3400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11120 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  gc_frame_newslot(*var_lastToken);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11121 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_nextTok (depth = 10)
  partcv[0] = 0;
  Object call11122 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11121);
// compiled call node returning call11122 (depth = 9)
// compiled member node returning call11122 (depth = 8)
  gc_frame_newslot(call11122);
// starting to compile identifier node (depth = 8)
  Object bool11123 = alloc_Boolean(1);
// compiled identifier node returning bool11123 (depth = 8)
  gc_frame_newslot(bool11123);
// starting to compile identifier node (depth = 8)
  Object bool11124 = alloc_Boolean(0);
// compiled identifier node returning bool11124 (depth = 8)
  gc_frame_newslot(bool11124);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_lastToken;
  params[1] = call11122;
  params[2] = bool11123;
  params[3] = bool11124;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11125 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe11120);
// compiled call node returning call11125 (depth = 7)
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11126 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11127 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11126);
// compiled call node returning call11127 (depth = 7)
// Begin line 3402
  setline(3402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11128 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11129 == NULL) {
    strlit11129 = alloc_String("A valid expression must follow ':='.");
    gc_root(strlit11129);
  }
// compiled string node returning strlit11129 (depth = 8)
  gc_frame_newslot(strlit11129);
// Begin line 3403
  setline(3403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11130 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11131 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11130);
// compiled call node returning call11131 (depth = 9)
// compiled member node returning call11131 (depth = 8)
  gc_frame_newslot(call11131);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11132 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11133 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11132);
// compiled call node returning call11133 (depth = 9)
// compiled member node returning call11133 (depth = 8)
  gc_frame_newslot(call11133);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3402
  setline(3402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  params[0] = strlit11129;
  params[1] = call11131;
  params[2] = call11133;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11134 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11128);
// compiled call node returning call11134 (depth = 7)
    gc_frame_newslot(call11134);
    if11081 = call11134;
  } else {
  }
// compiled if node returning if11081 (depth = 6)
// Begin line 3406
  setline(3406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// Begin line 3405
  setline(3405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11135 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11136 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe11135);
// compiled call node returning call11136 (depth = 8)
// compiled member node returning call11136 (depth = 7)
  *var_val = call11136;
  if (call11136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3406
  setline(3406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11137 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_dest (depth = 8)
  gc_frame_newslot(*var_dest);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_val (depth = 8)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11138 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ast (depth = 10)
  partcv[0] = 0;
  Object call11139 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe11138);
// compiled call node returning call11139 (depth = 9)
// compiled member node returning call11139 (depth = 8)
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call11140 = callmethod(call11139, "new",
    1, partcv, params);
  gc_frame_end(callframe11137);
// compiled call node returning call11140 (depth = 7)
  *var_o = call11140;
  if (call11140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 3407
  setline(3407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11141 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_values (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call11142 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe11141);
// compiled call node returning call11142 (depth = 6)
    gc_frame_newslot(call11142);
    if11040 = call11142;
  } else {
  }
// compiled if node returning if11040 (depth = 5)
  gc_frame_end(frame);
  return if11040;
}
Object meth_parser_statement10947(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_blocksOK = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  Object *var_indentFreePass = getfromclosure(closure, 8);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for statement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_oldLine = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "oldLine");
// Begin line 3359
  setline(3359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3358
  setline(3358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe10948 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  partcv[0] = 0;
  Object call10949 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10948);
// compiled call node returning call10949 (depth = 4)
// compiled member node returning call10949 (depth = 3)
  *var_statementIndent = call10949;
  if (call10949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3359
  setline(3359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10952 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10953 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10952);
// compiled call node returning call10953 (depth = 3)
// compiled member node returning call10953 (depth = 2)
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3361
  setline(3361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe10955 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit10956 == NULL) {
    strlit10956 = alloc_String("keyword");
    gc_root(strlit10956);
  }
// compiled string node returning strlit10956 (depth = 4)
  gc_frame_newslot(strlit10956);
// call case 4: self request
  params[0] = strlit10956;
  partcv[0] = 1;
  Object call10957 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10955);
// compiled call node returning call10957 (depth = 3)
  Object if10954 = done;
  if (istrue(call10957)) {
// Begin line 3381
  setline(3381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3362
  setline(3362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit10960 == NULL) {
    strlit10960 = alloc_String("var");
    gc_root(strlit10960);
  }
// compiled string node returning strlit10960 (depth = 5)
  int op_slot_right_10959 = gc_frame_newslot(strlit10960);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call10963 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10962);
// compiled call node returning call10963 (depth = 6)
// compiled member node returning call10963 (depth = 5)
  int op_slot_left_10959 = gc_frame_newslot(call10963);
  params[0] = strlit10960;
  partcv[0] = 1;
  Object opresult10964 = callmethod(call10963, "==", 1, partcv, params);
// compiled op node returning opresult10964 (depth = 4)
  Object if10958 = done;
  if (istrue(opresult10964)) {
// Begin line 3363
  setline(3363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe10965 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10966 = callmethodflags(self, "vardec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10965);
// compiled call node returning call10966 (depth = 5)
// compiled member node returning call10966 (depth = 4)
    gc_frame_newslot(call10966);
    if10958 = call10966;
  } else {
// Begin line 3366
  setline(3366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3364
  setline(3364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit10969 == NULL) {
    strlit10969 = alloc_String("def");
    gc_root(strlit10969);
  }
// compiled string node returning strlit10969 (depth = 6)
  int op_slot_right_10968 = gc_frame_newslot(strlit10969);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10971 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call10972 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10971);
// compiled call node returning call10972 (depth = 7)
// compiled member node returning call10972 (depth = 6)
  int op_slot_left_10968 = gc_frame_newslot(call10972);
  params[0] = strlit10969;
  partcv[0] = 1;
  Object opresult10973 = callmethod(call10972, "==", 1, partcv, params);
// compiled op node returning opresult10973 (depth = 5)
  Object if10967 = done;
  if (istrue(opresult10973)) {
// Begin line 3365
  setline(3365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe10974 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10975 = callmethodflags(self, "defdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10974);
// compiled call node returning call10975 (depth = 6)
// compiled member node returning call10975 (depth = 5)
    gc_frame_newslot(call10975);
    if10967 = call10975;
  } else {
// Begin line 3368
  setline(3368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3366
  setline(3366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit10978 == NULL) {
    strlit10978 = alloc_String("import");
    gc_root(strlit10978);
  }
// compiled string node returning strlit10978 (depth = 7)
  int op_slot_right_10977 = gc_frame_newslot(strlit10978);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10980 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call10981 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10980);
// compiled call node returning call10981 (depth = 8)
// compiled member node returning call10981 (depth = 7)
  int op_slot_left_10977 = gc_frame_newslot(call10981);
  params[0] = strlit10978;
  partcv[0] = 1;
  Object opresult10982 = callmethod(call10981, "==", 1, partcv, params);
// compiled op node returning opresult10982 (depth = 6)
  Object if10976 = done;
  if (istrue(opresult10982)) {
// Begin line 3367
  setline(3367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe10983 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10984 = callmethodflags(self, "doimport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10983);
// compiled call node returning call10984 (depth = 7)
// compiled member node returning call10984 (depth = 6)
    gc_frame_newslot(call10984);
    if10976 = call10984;
  } else {
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3368
  setline(3368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit10987 == NULL) {
    strlit10987 = alloc_String("dialect");
    gc_root(strlit10987);
  }
// compiled string node returning strlit10987 (depth = 8)
  int op_slot_right_10986 = gc_frame_newslot(strlit10987);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe10989 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call10990 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10989);
// compiled call node returning call10990 (depth = 9)
// compiled member node returning call10990 (depth = 8)
  int op_slot_left_10986 = gc_frame_newslot(call10990);
  params[0] = strlit10987;
  partcv[0] = 1;
  Object opresult10991 = callmethod(call10990, "==", 1, partcv, params);
// compiled op node returning opresult10991 (depth = 7)
  Object if10985 = done;
  if (istrue(opresult10991)) {
// Begin line 3369
  setline(3369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe10992 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call10993 = callmethodflags(self, "dodialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10992);
// compiled call node returning call10993 (depth = 8)
// compiled member node returning call10993 (depth = 7)
    gc_frame_newslot(call10993);
    if10985 = call10993;
  } else {
// Begin line 3372
  setline(3372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit10996 == NULL) {
    strlit10996 = alloc_String("type");
    gc_root(strlit10996);
  }
// compiled string node returning strlit10996 (depth = 9)
  int op_slot_right_10995 = gc_frame_newslot(strlit10996);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe10998 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call10999 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10998);
// compiled call node returning call10999 (depth = 10)
// compiled member node returning call10999 (depth = 9)
  int op_slot_left_10995 = gc_frame_newslot(call10999);
  params[0] = strlit10996;
  partcv[0] = 1;
  Object opresult11000 = callmethod(call10999, "==", 1, partcv, params);
// compiled op node returning opresult11000 (depth = 8)
  Object if10994 = done;
  if (istrue(opresult11000)) {
// Begin line 3371
  setline(3371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11001 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11002 = callmethodflags(self, "typedec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11001);
// compiled call node returning call11002 (depth = 9)
// compiled member node returning call11002 (depth = 8)
    gc_frame_newslot(call11002);
    if10994 = call11002;
  } else {
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// Begin line 3372
  setline(3372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11005 == NULL) {
    strlit11005 = alloc_String("class");
    gc_root(strlit11005);
  }
// compiled string node returning strlit11005 (depth = 10)
  int op_slot_right_11004 = gc_frame_newslot(strlit11005);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11007 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11008 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11007);
// compiled call node returning call11008 (depth = 11)
// compiled member node returning call11008 (depth = 10)
  int op_slot_left_11004 = gc_frame_newslot(call11008);
  params[0] = strlit11005;
  partcv[0] = 1;
  Object opresult11009 = callmethod(call11008, "==", 1, partcv, params);
// compiled op node returning opresult11009 (depth = 9)
  Object if11003 = done;
  if (istrue(opresult11009)) {
// Begin line 3373
  setline(3373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11010 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11011 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11010);
// compiled call node returning call11011 (depth = 10)
// compiled member node returning call11011 (depth = 9)
    gc_frame_newslot(call11011);
    if11003 = call11011;
  } else {
// Begin line 3376
  setline(3376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit11014 == NULL) {
    strlit11014 = alloc_String("factory");
    gc_root(strlit11014);
  }
// compiled string node returning strlit11014 (depth = 11)
  int op_slot_right_11013 = gc_frame_newslot(strlit11014);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11016 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_sym (depth = 13)
  partcv[0] = 0;
  Object call11017 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11016);
// compiled call node returning call11017 (depth = 12)
// compiled member node returning call11017 (depth = 11)
  int op_slot_left_11013 = gc_frame_newslot(call11017);
  params[0] = strlit11014;
  partcv[0] = 1;
  Object opresult11018 = callmethod(call11017, "==", 1, partcv, params);
// compiled op node returning opresult11018 (depth = 10)
  Object if11012 = done;
  if (istrue(opresult11018)) {
// Begin line 3375
  setline(3375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11019 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11020 = callmethodflags(self, "dofactoryMethod", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11019);
// compiled call node returning call11020 (depth = 11)
// compiled member node returning call11020 (depth = 10)
    gc_frame_newslot(call11020);
    if11012 = call11020;
  } else {
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 10)
// Begin line 3376
  setline(3376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit11023 == NULL) {
    strlit11023 = alloc_String("return");
    gc_root(strlit11023);
  }
// compiled string node returning strlit11023 (depth = 12)
  int op_slot_right_11022 = gc_frame_newslot(strlit11023);
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11025 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_sym (depth = 14)
  partcv[0] = 0;
  Object call11026 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11025);
// compiled call node returning call11026 (depth = 13)
// compiled member node returning call11026 (depth = 12)
  int op_slot_left_11022 = gc_frame_newslot(call11026);
  params[0] = strlit11023;
  partcv[0] = 1;
  Object opresult11027 = callmethod(call11026, "==", 1, partcv, params);
// compiled op node returning opresult11027 (depth = 11)
  Object if11021 = done;
  if (istrue(opresult11027)) {
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11028 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11029 = callmethodflags(self, "doreturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11028);
// compiled call node returning call11029 (depth = 12)
// compiled member node returning call11029 (depth = 11)
    gc_frame_newslot(call11029);
    if11021 = call11029;
  } else {
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 11)
  int callframe11030 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_blocksOK (depth = 12)
  gc_frame_newslot(*var_blocksOK);
// call case 4: self request
  params[0] = *var_blocksOK;
  partcv[0] = 1;
  Object call11031 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11030);
// compiled call node returning call11031 (depth = 11)
    gc_frame_newslot(call11031);
    if11021 = call11031;
  }
// compiled if node returning if11021 (depth = 10)
    gc_frame_newslot(if11021);
    if11012 = if11021;
  }
// compiled if node returning if11012 (depth = 9)
    gc_frame_newslot(if11012);
    if11003 = if11012;
  }
// compiled if node returning if11003 (depth = 8)
    gc_frame_newslot(if11003);
    if10994 = if11003;
  }
// compiled if node returning if10994 (depth = 7)
    gc_frame_newslot(if10994);
    if10985 = if10994;
  }
// compiled if node returning if10985 (depth = 6)
    gc_frame_newslot(if10985);
    if10976 = if10985;
  }
// compiled if node returning if10976 (depth = 5)
    gc_frame_newslot(if10976);
    if10967 = if10976;
  }
// compiled if node returning if10967 (depth = 4)
    gc_frame_newslot(if10967);
    if10958 = if10967;
  }
// compiled if node returning if10958 (depth = 3)
    gc_frame_newslot(if10958);
    if10954 = if10958;
  } else {
// Begin line 3382
  setline(3382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11032 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block11033 = alloc_Block(NULL, NULL, "parser", 3382);
  gc_frame_newslot(block11033);
// method _apply
  block_savedest(block11033);
  Object closure11034 = createclosure(2, "_apply");
  setclosureframe(closure11034, stackframe);
  addtoclosure(closure11034, var_blocksOK);
  addtoclosure(closure11034, selfslot);
  struct UserObject *uo11034 = (struct UserObject*)block11033;
  uo11034->data[0] = (Object)closure11034;
  Method *meth_meth_parser__apply11034 = addmethod2pos(block11033, "_apply", &meth_parser__apply11034, 0);
  int argcv_meth_parser__apply11034[] = {0};
  meth_meth_parser__apply11034->type = alloc_MethodType(1, argcv_meth_parser__apply11034);
  meth_meth_parser__apply11034->definitionModule = modulename;
  meth_meth_parser__apply11034->definitionLine = 3377;
// compiled block node returning block11033 (depth = 4)
  gc_frame_newslot(block11033);
// starting to compile block node (depth = 4)
  Object block11038 = alloc_Block(NULL, NULL, "parser", 3382);
  gc_frame_newslot(block11038);
// method _apply
  block_savedest(block11038);
  Object closure11039 = createclosure(7, "_apply");
  setclosureframe(closure11039, stackframe);
  addtoclosure(closure11039, var_values);
  addtoclosure(closure11039, var_blocksOK);
  addtoclosure(closure11039, var_errormessages);
  addtoclosure(closure11039, var_sym);
  addtoclosure(closure11039, var_lastToken);
  addtoclosure(closure11039, var_ast);
  addtoclosure(closure11039, selfslot);
  struct UserObject *uo11039 = (struct UserObject*)block11038;
  uo11039->data[0] = (Object)closure11039;
  Method *meth_meth_parser__apply11039 = addmethod2pos(block11038, "_apply", &meth_parser__apply11039, 0);
  int argcv_meth_parser__apply11039[] = {0};
  meth_meth_parser__apply11039->type = alloc_MethodType(1, argcv_meth_parser__apply11039);
  meth_meth_parser__apply11039->definitionModule = modulename;
  meth_meth_parser__apply11039->definitionLine = 3377;
// compiled block node returning block11038 (depth = 4)
  gc_frame_newslot(block11038);
// call case 4: self request
  params[0] = block11033;
  params[1] = block11038;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11144 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11032);
// compiled call node returning call11144 (depth = 3)
    gc_frame_newslot(call11144);
    if10954 = call11144;
  }
// compiled if node returning if10954 (depth = 2)
// Begin line 3414
  setline(3414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11146 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11147 == NULL) {
    strlit11147 = alloc_String("eof");
    gc_root(strlit11147);
  }
// compiled string node returning strlit11147 (depth = 4)
  gc_frame_newslot(strlit11147);
// call case 4: self request
  params[0] = strlit11147;
  partcv[0] = 1;
  Object call11148 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11146);
// compiled call node returning call11148 (depth = 3)
  Object if11145 = done;
  if (istrue(call11148)) {
// Begin line 3413
  setline(3413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 3412
  setline(3412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool11149 = alloc_Boolean(1);
// compiled identifier node returning bool11149 (depth = 4)
  return bool11149;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11145 = undefined;
  } else {
  }
// compiled if node returning if11145 (depth = 2)
// Begin line 3423
  setline(3423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3414
  setline(3414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11151 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11152 == NULL) {
    strlit11152 = alloc_String("semicolon");
    gc_root(strlit11152);
  }
// compiled string node returning strlit11152 (depth = 4)
  gc_frame_newslot(strlit11152);
// call case 4: self request
  params[0] = strlit11152;
  partcv[0] = 1;
  Object call11153 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11151);
// compiled call node returning call11153 (depth = 3)
  Object if11150 = done;
  if (istrue(call11153)) {
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3415
  setline(3415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11154 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11155 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11154);
// compiled call node returning call11155 (depth = 5)
// compiled member node returning call11155 (depth = 4)
  *var_oldLine = call11155;
  if (call11155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11156 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11157 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11156);
// compiled call node returning call11157 (depth = 4)
// compiled member node returning call11157 (depth = 3)
// Begin line 3420
  setline(3420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3417
  setline(3417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_oldLine (depth = 5)
  int op_slot_right_11159 = gc_frame_newslot(*var_oldLine);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11161 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11162 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11161);
// compiled call node returning call11162 (depth = 6)
// compiled member node returning call11162 (depth = 5)
  int op_slot_left_11159 = gc_frame_newslot(call11162);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult11163 = callmethod(call11162, "==", 1, partcv, params);
// compiled op node returning opresult11163 (depth = 4)
  Object if11158 = done;
  if (istrue(opresult11163)) {
// Begin line 3419
  setline(3419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3418
  setline(3418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool11164 = alloc_Boolean(1);
// compiled identifier node returning bool11164 (depth = 5)
  *var_indentFreePass = bool11164;
  if (bool11164 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
    gc_frame_newslot(done);
    if11158 = done;
  } else {
  }
// compiled if node returning if11158 (depth = 3)
    gc_frame_newslot(if11158);
    if11150 = if11158;
  } else {
// Begin line 3421
  setline(3421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11167 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11166);
// compiled call node returning call11167 (depth = 4)
// compiled member node returning call11167 (depth = 3)
    gc_frame_newslot(call11167);
    if11150 = call11167;
  }
// compiled if node returning if11150 (depth = 2)
  gc_frame_end(frame);
  return if11150;
}
Object meth_parser_checkBadOperators11168(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkBadOperators (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkBadOperators");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3433
  setline(3433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3426
  setline(3426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11171 == NULL) {
    strlit11171 = alloc_String("=");
    gc_root(strlit11171);
  }
// compiled string node returning strlit11171 (depth = 4)
  int op_slot_right_11170 = gc_frame_newslot(strlit11171);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11173 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11174 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11173);
// compiled call node returning call11174 (depth = 5)
// compiled member node returning call11174 (depth = 4)
  int op_slot_left_11170 = gc_frame_newslot(call11174);
  params[0] = strlit11171;
  partcv[0] = 1;
  Object opresult11175 = callmethod(call11174, "==", 1, partcv, params);
// compiled op node returning opresult11175 (depth = 3)
  Object if11169 = done;
  if (istrue(opresult11175)) {
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11176 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11177 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11178 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11177);
// compiled call node returning call11178 (depth = 7)
// compiled member node returning call11178 (depth = 6)
  partcv[0] = 0;
  Object call11179 = callmethod(call11178, "new",
    1, partcv, params);
  gc_frame_end(callframe11176);
// compiled call node returning call11179 (depth = 5)
// compiled member node returning call11179 (depth = 4)
  *var_sugg = call11179;
  if (call11179 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11180 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11181 == NULL) {
    strlit11181 = alloc_String("=");
    gc_root(strlit11181);
  }
// compiled string node returning strlit11181 (depth = 4)
  gc_frame_newslot(strlit11181);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11181;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11182 = callmethod(*var_sugg, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe11180);
// compiled call node returning call11182 (depth = 3)
// Begin line 3429
  setline(3429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11183 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11184 == NULL) {
    strlit11184 = alloc_String("Use '==' to test equality, not '='.");
    gc_root(strlit11184);
  }
// compiled string node returning strlit11184 (depth = 4)
  gc_frame_newslot(strlit11184);
// Begin line 3430
  setline(3430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11186 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11185);
// compiled call node returning call11186 (depth = 5)
// compiled member node returning call11186 (depth = 4)
  gc_frame_newslot(call11186);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11188 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11187);
// compiled call node returning call11188 (depth = 5)
// compiled member node returning call11188 (depth = 4)
  gc_frame_newslot(call11188);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11189 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11190 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11189);
// compiled call node returning call11190 (depth = 5)
// compiled member node returning call11190 (depth = 4)
  gc_frame_newslot(call11190);
// Begin line 3431
  setline(3431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3429
  setline(3429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11184;
  params[1] = call11186;
  params[2] = call11188;
  params[3] = call11190;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11191 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11183);
// compiled call node returning call11191 (depth = 3)
    gc_frame_newslot(call11191);
    if11169 = call11191;
  } else {
  }
// compiled if node returning if11169 (depth = 2)
// Begin line 3440
  setline(3440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3433
  setline(3433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11194 == NULL) {
    strlit11194 = alloc_String("rgeneric");
    gc_root(strlit11194);
  }
// compiled string node returning strlit11194 (depth = 4)
  int op_slot_right_11193 = gc_frame_newslot(strlit11194);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11196 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11197 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11196);
// compiled call node returning call11197 (depth = 5)
// compiled member node returning call11197 (depth = 4)
  int op_slot_left_11193 = gc_frame_newslot(call11197);
  params[0] = strlit11194;
  partcv[0] = 1;
  Object opresult11198 = callmethod(call11197, "==", 1, partcv, params);
// compiled op node returning opresult11198 (depth = 3)
  Object if11192 = done;
  if (istrue(opresult11198)) {
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3434
  setline(3434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11199 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11200 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11201 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11200);
// compiled call node returning call11201 (depth = 7)
// compiled member node returning call11201 (depth = 6)
  partcv[0] = 0;
  Object call11202 = callmethod(call11201, "new",
    1, partcv, params);
  gc_frame_end(callframe11199);
// compiled call node returning call11202 (depth = 5)
// compiled member node returning call11202 (depth = 4)
  *var_sugg = call11202;
  if (call11202 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11203 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11204 == NULL) {
    strlit11204 = alloc_String(" ");
    gc_root(strlit11204);
  }
// compiled string node returning strlit11204 (depth = 4)
  gc_frame_newslot(strlit11204);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11204;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11205 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11203);
// compiled call node returning call11205 (depth = 3)
// Begin line 3436
  setline(3436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11206 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11207 == NULL) {
    strlit11207 = alloc_String("The '>' operator must be preceded by a space.");
    gc_root(strlit11207);
  }
// compiled string node returning strlit11207 (depth = 4)
  gc_frame_newslot(strlit11207);
// Begin line 3437
  setline(3437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11208 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11209 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11208);
// compiled call node returning call11209 (depth = 5)
// compiled member node returning call11209 (depth = 4)
  gc_frame_newslot(call11209);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11211 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11210);
// compiled call node returning call11211 (depth = 5)
// compiled member node returning call11211 (depth = 4)
  gc_frame_newslot(call11211);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11212 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11213 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11212);
// compiled call node returning call11213 (depth = 5)
// compiled member node returning call11213 (depth = 4)
  gc_frame_newslot(call11213);
// Begin line 3438
  setline(3438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3436
  setline(3436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11207;
  params[1] = call11209;
  params[2] = call11211;
  params[3] = call11213;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11214 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11206);
// compiled call node returning call11214 (depth = 3)
    gc_frame_newslot(call11214);
    if11192 = call11214;
  } else {
  }
// compiled if node returning if11192 (depth = 2)
  gc_frame_end(frame);
  return if11192;
}
Object meth_parser_checkBadTypeLiteral11215(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadTypeLiteral");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkBadTypeLiteral (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkBadTypeLiteral");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3450
  setline(3450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3443
  setline(3443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit11218 == NULL) {
    strlit11218 = alloc_String("lbrace");
    gc_root(strlit11218);
  }
// compiled string node returning strlit11218 (depth = 4)
  int op_slot_right_11217 = gc_frame_newslot(strlit11218);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11220 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11221 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11220);
// compiled call node returning call11221 (depth = 5)
// compiled member node returning call11221 (depth = 4)
  int op_slot_left_11217 = gc_frame_newslot(call11221);
  params[0] = strlit11218;
  partcv[0] = 1;
  Object opresult11222 = callmethod(call11221, "==", 1, partcv, params);
// compiled op node returning opresult11222 (depth = 3)
  Object if11216 = done;
  if (istrue(opresult11222)) {
// Begin line 3445
  setline(3445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3444
  setline(3444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11223 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11224 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11225 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11224);
// compiled call node returning call11225 (depth = 7)
// compiled member node returning call11225 (depth = 6)
  partcv[0] = 0;
  Object call11226 = callmethod(call11225, "new",
    1, partcv, params);
  gc_frame_end(callframe11223);
// compiled call node returning call11226 (depth = 5)
// compiled member node returning call11226 (depth = 4)
  *var_sugg = call11226;
  if (call11226 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3445
  setline(3445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11227 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11228 == NULL) {
    strlit11228 = alloc_String("type ");
    gc_root(strlit11228);
  }
// compiled string node returning strlit11228 (depth = 4)
  gc_frame_newslot(strlit11228);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = strlit11228;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11229 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11227);
// compiled call node returning call11229 (depth = 3)
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11230 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11231 == NULL) {
    strlit11231 = alloc_String("type literals must start with the keyword 'type'.");
    gc_root(strlit11231);
  }
// compiled string node returning strlit11231 (depth = 4)
  gc_frame_newslot(strlit11231);
// Begin line 3447
  setline(3447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11232 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11233 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11232);
// compiled call node returning call11233 (depth = 5)
// compiled member node returning call11233 (depth = 4)
  gc_frame_newslot(call11233);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11235 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11234);
// compiled call node returning call11235 (depth = 5)
// compiled member node returning call11235 (depth = 4)
  gc_frame_newslot(call11235);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11236 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11237 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11236);
// compiled call node returning call11237 (depth = 5)
// compiled member node returning call11237 (depth = 4)
  gc_frame_newslot(call11237);
// Begin line 3448
  setline(3448);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11231;
  params[1] = call11233;
  params[2] = call11235;
  params[3] = call11237;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11238 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11230);
// compiled call node returning call11238 (depth = 3)
    gc_frame_newslot(call11238);
    if11216 = call11238;
  } else {
  }
// compiled if node returning if11216 (depth = 2)
  gc_frame_end(frame);
  return if11216;
}
Object meth_parser__apply11346(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// Begin line 3482
  setline(3482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 10)
  if (strlit11348 == NULL) {
    strlit11348 = alloc_String("identifier");
    gc_root(strlit11348);
  }
// compiled string node returning strlit11348 (depth = 10)
  int op_slot_right_11347 = gc_frame_newslot(strlit11348);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11350 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11351 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11350);
// compiled call node returning call11351 (depth = 11)
// compiled member node returning call11351 (depth = 10)
  int op_slot_left_11347 = gc_frame_newslot(call11351);
  params[0] = strlit11348;
  partcv[0] = 1;
  Object opresult11352 = callmethod(call11351, "==", 1, partcv, params);
// compiled op node returning opresult11352 (depth = 9)
  gc_frame_end(frame);
  return opresult11352;
}
Object meth_parser__apply11356(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3481
  setline(3481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// Begin line 3480
  setline(3480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 11)
  if (strlit11358 == NULL) {
    strlit11358 = alloc_String("member");
    gc_root(strlit11358);
  }
// compiled string node returning strlit11358 (depth = 11)
  int op_slot_right_11357 = gc_frame_newslot(strlit11358);
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe11360 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe11361 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 15)
// compiled identifier node returning *var_values (depth = 15)
  partcv[0] = 0;
  Object call11362 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11361);
// compiled call node returning call11362 (depth = 14)
// compiled member node returning call11362 (depth = 13)
  partcv[0] = 0;
  Object call11363 = callmethod(call11362, "kind",
    1, partcv, params);
  gc_frame_end(callframe11360);
// compiled call node returning call11363 (depth = 12)
// compiled member node returning call11363 (depth = 11)
  int op_slot_left_11357 = gc_frame_newslot(call11363);
  params[0] = strlit11358;
  partcv[0] = 1;
  Object opresult11364 = callmethod(call11363, "==", 1, partcv, params);
// compiled op node returning opresult11364 (depth = 10)
  gc_frame_end(frame);
  return opresult11364;
}
Object meth_parser__apply11343(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3481
  setline(3481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11344 = gc_frame_new();
// starting to compile block node (depth = 8)
  Object block11345 = alloc_Block(NULL, NULL, "parser", 3481);
  gc_frame_newslot(block11345);
// method _apply
  block_savedest(block11345);
  Object closure11346 = createclosure(2, "_apply");
  setclosureframe(closure11346, stackframe);
  addtoclosure(closure11346, var_sym);
  addtoclosure(closure11346, selfslot);
  struct UserObject *uo11346 = (struct UserObject*)block11345;
  uo11346->data[0] = (Object)closure11346;
  Method *meth_meth_parser__apply11346 = addmethod2pos(block11345, "_apply", &meth_parser__apply11346, 0);
  int argcv_meth_parser__apply11346[] = {0};
  meth_meth_parser__apply11346->type = alloc_MethodType(1, argcv_meth_parser__apply11346);
  meth_meth_parser__apply11346->definitionModule = modulename;
  meth_meth_parser__apply11346->definitionLine = 3475;
// compiled block node returning block11345 (depth = 8)
  gc_frame_newslot(block11345);
// call case 6: other member request
// Begin line 3479
  setline(3479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe11354 = gc_frame_new();
// starting to compile block node (depth = 9)
  Object block11355 = alloc_Block(NULL, NULL, "parser", 3479);
  gc_frame_newslot(block11355);
// method _apply
  block_savedest(block11355);
  Object closure11356 = createclosure(2, "_apply");
  setclosureframe(closure11356, stackframe);
  addtoclosure(closure11356, var_values);
  addtoclosure(closure11356, selfslot);
  struct UserObject *uo11356 = (struct UserObject*)block11355;
  uo11356->data[0] = (Object)closure11356;
  Method *meth_meth_parser__apply11356 = addmethod2pos(block11355, "_apply", &meth_parser__apply11356, 0);
  int argcv_meth_parser__apply11356[] = {0};
  meth_meth_parser__apply11356->type = alloc_MethodType(1, argcv_meth_parser__apply11356);
  meth_meth_parser__apply11356->definitionModule = modulename;
  meth_meth_parser__apply11356->definitionLine = 3482;
// compiled block node returning block11355 (depth = 9)
  gc_frame_newslot(block11355);
// call case 6: other member request
// Begin line 3479
  setline(3479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit11367 == NULL) {
    strlit11367 = alloc_String("identifier");
    gc_root(strlit11367);
  }
// compiled string node returning strlit11367 (depth = 10)
  int op_slot_right_11366 = gc_frame_newslot(strlit11367);
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11369 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe11370 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_values (depth = 14)
  partcv[0] = 0;
  Object call11371 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11370);
// compiled call node returning call11371 (depth = 13)
// compiled member node returning call11371 (depth = 12)
  partcv[0] = 0;
  Object call11372 = callmethod(call11371, "kind",
    1, partcv, params);
  gc_frame_end(callframe11369);
// compiled call node returning call11372 (depth = 11)
// compiled member node returning call11372 (depth = 10)
  int op_slot_left_11366 = gc_frame_newslot(call11372);
  params[0] = strlit11367;
  partcv[0] = 1;
  Object opresult11373 = callmethod(call11372, "==", 1, partcv, params);
// compiled op node returning opresult11373 (depth = 9)
  params[0] = block11355;
  partcv[0] = 1;
  Object call11374 = callmethod(opresult11373, "orElse",
    1, partcv, params);
  gc_frame_end(callframe11354);
// compiled call node returning call11374 (depth = 8)
  params[0] = block11345;
  partcv[0] = 1;
  Object call11375 = callmethod(call11374, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11344);
// compiled call node returning call11375 (depth = 7)
  gc_frame_end(frame);
  return call11375;
}
Object meth_parser_checkUnexpectedTokenAfterStatement11239(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkUnexpectedTokenAfterStatement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for checkUnexpectedTokenAfterStatement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// Begin line 3519
  setline(3519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3453
  setline(3453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11242 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lastToken (depth = 6)
  partcv[0] = 0;
  Object call11243 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11242);
// compiled call node returning call11243 (depth = 5)
// compiled member node returning call11243 (depth = 4)
  int op_slot_right_11241 = gc_frame_newslot(call11243);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11246 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11245);
// compiled call node returning call11246 (depth = 5)
// compiled member node returning call11246 (depth = 4)
  int op_slot_left_11241 = gc_frame_newslot(call11246);
  params[0] = call11243;
  partcv[0] = 1;
  Object opresult11247 = callmethod(call11246, "==", 1, partcv, params);
// compiled op node returning opresult11247 (depth = 3)
  Object if11240 = done;
  if (istrue(opresult11247)) {
// Begin line 3467
  setline(3467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3455
  setline(3455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit11251 == NULL) {
    strlit11251 = alloc_String("identifier");
    gc_root(strlit11251);
  }
// compiled string node returning strlit11251 (depth = 6)
  int op_slot_right_11250 = gc_frame_newslot(strlit11251);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11253 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call11254 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe11253);
// compiled call node returning call11254 (depth = 7)
// compiled member node returning call11254 (depth = 6)
  int op_slot_left_11250 = gc_frame_newslot(call11254);
  params[0] = strlit11251;
  partcv[0] = 1;
  Object opresult11255 = callmethod(call11254, "==", 1, partcv, params);
// compiled op node returning opresult11255 (depth = 5)
  int op_slot_right_11249 = gc_frame_newslot(opresult11255);
// starting to compile op node (depth = 5)
// Begin line 3454
  setline(3454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11259 == NULL) {
    strlit11259 = alloc_String("=");
    gc_root(strlit11259);
  }
// compiled string node returning strlit11259 (depth = 7)
  int op_slot_right_11258 = gc_frame_newslot(strlit11259);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11262 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11261);
// compiled call node returning call11262 (depth = 8)
// compiled member node returning call11262 (depth = 7)
  int op_slot_left_11258 = gc_frame_newslot(call11262);
  params[0] = strlit11259;
  partcv[0] = 1;
  Object opresult11263 = callmethod(call11262, "==", 1, partcv, params);
// compiled op node returning opresult11263 (depth = 6)
  int op_slot_right_11257 = gc_frame_newslot(opresult11263);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11266 == NULL) {
    strlit11266 = alloc_String("op");
    gc_root(strlit11266);
  }
// compiled string node returning strlit11266 (depth = 7)
  int op_slot_right_11265 = gc_frame_newslot(strlit11266);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11268 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11269 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11268);
// compiled call node returning call11269 (depth = 8)
// compiled member node returning call11269 (depth = 7)
  int op_slot_left_11265 = gc_frame_newslot(call11269);
  params[0] = strlit11266;
  partcv[0] = 1;
  Object opresult11270 = callmethod(call11269, "==", 1, partcv, params);
// compiled op node returning opresult11270 (depth = 6)
  int op_slot_left_11257 = gc_frame_newslot(opresult11270);
  params[0] = opresult11263;
  partcv[0] = 1;
  Object opresult11271 = callmethod(opresult11270, "&&", 1, partcv, params);
// compiled op node returning opresult11271 (depth = 5)
  int op_slot_left_11249 = gc_frame_newslot(opresult11271);
  params[0] = opresult11255;
  partcv[0] = 1;
  Object opresult11272 = callmethod(opresult11271, "&&", 1, partcv, params);
// compiled op node returning opresult11272 (depth = 4)
  Object if11248 = done;
  if (istrue(opresult11272)) {
// Begin line 3457
  setline(3457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3456
  setline(3456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11273 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11274 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11275 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11274);
// compiled call node returning call11275 (depth = 8)
// compiled member node returning call11275 (depth = 7)
  partcv[0] = 0;
  Object call11276 = callmethod(call11275, "new",
    1, partcv, params);
  gc_frame_end(callframe11273);
// compiled call node returning call11276 (depth = 6)
// compiled member node returning call11276 (depth = 5)
  *var_sugg = call11276;
  if (call11276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3458
  setline(3458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3457
  setline(3457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array11277 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11277 (depth = 5)
  *var_suggestions = array11277;
  if (array11277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3458
  setline(3458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11278 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool11279 = alloc_Boolean(0);
// compiled identifier node returning bool11279 (depth = 5)
  gc_frame_newslot(bool11279);
// starting to compile identifier node (depth = 5)
  Object bool11280 = alloc_Boolean(0);
// compiled identifier node returning bool11280 (depth = 5)
  gc_frame_newslot(bool11280);
// starting to compile string node (depth = 5)
  if (strlit11281 == NULL) {
    strlit11281 = alloc_String(":=");
    gc_root(strlit11281);
  }
// compiled string node returning strlit11281 (depth = 5)
  gc_frame_newslot(strlit11281);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = *var_sym;
  params[1] = bool11279;
  params[2] = bool11280;
  params[3] = strlit11281;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11282 = callmethod(*var_sugg, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11278);
// compiled call node returning call11282 (depth = 4)
// Begin line 3459
  setline(3459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11283 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call11284 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11283);
// compiled call node returning call11284 (depth = 4)
// Begin line 3461
  setline(3461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3460
  setline(3460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11285 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11286 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11287 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11286);
// compiled call node returning call11287 (depth = 8)
// compiled member node returning call11287 (depth = 7)
  partcv[0] = 0;
  Object call11288 = callmethod(call11287, "new",
    1, partcv, params);
  gc_frame_end(callframe11285);
// compiled call node returning call11288 (depth = 6)
// compiled member node returning call11288 (depth = 5)
  *var_sugg2 = call11288;
  if (call11288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3461
  setline(3461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11289 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sym (depth = 5)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 5)
  Object bool11290 = alloc_Boolean(0);
// compiled identifier node returning bool11290 (depth = 5)
  gc_frame_newslot(bool11290);
// starting to compile identifier node (depth = 5)
  Object bool11291 = alloc_Boolean(0);
// compiled identifier node returning bool11291 (depth = 5)
  gc_frame_newslot(bool11291);
// starting to compile string node (depth = 5)
  if (strlit11292 == NULL) {
    strlit11292 = alloc_String("==");
    gc_root(strlit11292);
  }
// compiled string node returning strlit11292 (depth = 5)
  gc_frame_newslot(strlit11292);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  params[0] = *var_sym;
  params[1] = bool11290;
  params[2] = bool11291;
  params[3] = strlit11292;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11293 = callmethod(*var_sugg2, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11289);
// compiled call node returning call11293 (depth = 4)
// Begin line 3462
  setline(3462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11294 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg2 (depth = 5)
  gc_frame_newslot(*var_sugg2);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call11295 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11294);
// compiled call node returning call11295 (depth = 4)
// Begin line 3463
  setline(3463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11296 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11297 == NULL) {
    strlit11297 = alloc_String("Assignment uses ':=', not '='.");
    gc_root(strlit11297);
  }
// compiled string node returning strlit11297 (depth = 5)
  gc_frame_newslot(strlit11297);
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11298 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11299 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11298);
// compiled call node returning call11299 (depth = 6)
// compiled member node returning call11299 (depth = 5)
  gc_frame_newslot(call11299);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11300 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11301 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11300);
// compiled call node returning call11301 (depth = 6)
// compiled member node returning call11301 (depth = 5)
  gc_frame_newslot(call11301);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11302 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11303 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11302);
// compiled call node returning call11303 (depth = 6)
// compiled member node returning call11303 (depth = 5)
  gc_frame_newslot(call11303);
// Begin line 3465
  setline(3465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3463
  setline(3463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11297;
  params[1] = call11299;
  params[2] = call11301;
  params[3] = call11303;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11304 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11296);
// compiled call node returning call11304 (depth = 4)
    gc_frame_newslot(call11304);
    if11248 = call11304;
  } else {
  }
// compiled if node returning if11248 (depth = 3)
// Begin line 3475
  setline(3475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3467
  setline(3467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11307 == NULL) {
    strlit11307 = alloc_String("rgeneric");
    gc_root(strlit11307);
  }
// compiled string node returning strlit11307 (depth = 5)
  int op_slot_right_11306 = gc_frame_newslot(strlit11307);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11309 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11310 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11309);
// compiled call node returning call11310 (depth = 6)
// compiled member node returning call11310 (depth = 5)
  int op_slot_left_11306 = gc_frame_newslot(call11310);
  params[0] = strlit11307;
  partcv[0] = 1;
  Object opresult11311 = callmethod(call11310, "==", 1, partcv, params);
// compiled op node returning opresult11311 (depth = 4)
  Object if11305 = done;
  if (istrue(opresult11311)) {
// Begin line 3469
  setline(3469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3468
  setline(3468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11312 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11313 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errormessages (depth = 9)
  partcv[0] = 0;
  Object call11314 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11313);
// compiled call node returning call11314 (depth = 8)
// compiled member node returning call11314 (depth = 7)
  partcv[0] = 0;
  Object call11315 = callmethod(call11314, "new",
    1, partcv, params);
  gc_frame_end(callframe11312);
// compiled call node returning call11315 (depth = 6)
// compiled member node returning call11315 (depth = 5)
  *var_sugg = call11315;
  if (call11315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3469
  setline(3469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11316 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11317 == NULL) {
    strlit11317 = alloc_String(" ");
    gc_root(strlit11317);
  }
// compiled string node returning strlit11317 (depth = 5)
  gc_frame_newslot(strlit11317);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11318 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11319 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11318);
// compiled call node returning call11319 (depth = 6)
// compiled member node returning call11319 (depth = 5)
  gc_frame_newslot(call11319);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11320 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11321 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11320);
// compiled call node returning call11321 (depth = 6)
// compiled member node returning call11321 (depth = 5)
  gc_frame_newslot(call11321);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  params[0] = strlit11317;
  params[1] = call11319;
  params[2] = call11321;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11322 = callmethod(*var_sugg, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe11316);
// compiled call node returning call11322 (depth = 4)
// Begin line 3470
  setline(3470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11323 = gc_frame_new();
// Begin line 3471
  setline(3471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit11324 == NULL) {
    strlit11324 = alloc_String("The '>' operator must have a space before it.");
    gc_root(strlit11324);
  }
// compiled string node returning strlit11324 (depth = 5)
  gc_frame_newslot(strlit11324);
// Begin line 3472
  setline(3472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11326 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11325);
// compiled call node returning call11326 (depth = 6)
// compiled member node returning call11326 (depth = 5)
  gc_frame_newslot(call11326);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11327 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11328 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11327);
// compiled call node returning call11328 (depth = 6)
// compiled member node returning call11328 (depth = 5)
  gc_frame_newslot(call11328);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11329 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11330 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11329);
// compiled call node returning call11330 (depth = 6)
// compiled member node returning call11330 (depth = 5)
  gc_frame_newslot(call11330);
// Begin line 3473
  setline(3473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sugg (depth = 5)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3470
  setline(3470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11324;
  params[1] = call11326;
  params[2] = call11328;
  params[3] = call11330;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11331 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11323);
// compiled call node returning call11331 (depth = 4)
    gc_frame_newslot(call11331);
    if11305 = call11331;
  } else {
  }
// compiled if node returning if11305 (depth = 3)
// Begin line 3518
  setline(3518);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// Begin line 3475
  setline(3475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit11334 == NULL) {
    strlit11334 = alloc_String("rbrace");
    gc_root(strlit11334);
  }
// compiled string node returning strlit11334 (depth = 5)
  int op_slot_right_11333 = gc_frame_newslot(strlit11334);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11336 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11337 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11336);
// compiled call node returning call11337 (depth = 6)
// compiled member node returning call11337 (depth = 5)
  int op_slot_left_11333 = gc_frame_newslot(call11337);
  params[0] = strlit11334;
  partcv[0] = 1;
  Object opresult11338 = callmethod(call11337, "!=", 1, partcv, params);
// compiled op node returning opresult11338 (depth = 4)
  Object if11332 = done;
  if (istrue(opresult11338)) {
// Begin line 3477
  setline(3477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// Begin line 3476
  setline(3476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 5)
  Object array11339 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11339 (depth = 5)
  *var_suggestions = array11339;
  if (array11339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
  *var_suggestion = undefined;
// compiled vardec node returning done (depth = 4)
// Begin line 3503
  setline(3503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11341 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block11342 = alloc_Block(NULL, NULL, "parser", 3478);
  gc_frame_newslot(block11342);
// method _apply
  block_savedest(block11342);
  Object closure11343 = createclosure(3, "_apply");
  setclosureframe(closure11343, stackframe);
  addtoclosure(closure11343, var_sym);
  addtoclosure(closure11343, var_values);
  addtoclosure(closure11343, selfslot);
  struct UserObject *uo11343 = (struct UserObject*)block11342;
  uo11343->data[0] = (Object)closure11343;
  Method *meth_meth_parser__apply11343 = addmethod2pos(block11342, "_apply", &meth_parser__apply11343, 0);
  int argcv_meth_parser__apply11343[] = {0};
  meth_meth_parser__apply11343->type = alloc_MethodType(1, argcv_meth_parser__apply11343);
  meth_meth_parser__apply11343->definitionModule = modulename;
  meth_meth_parser__apply11343->definitionLine = 3475;
// compiled block node returning block11342 (depth = 6)
  gc_frame_newslot(block11342);
// call case 6: other member request
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11378 = alloc_Float64(0);
// compiled num node returning num11378 (depth = 7)
  int op_slot_right_11377 = gc_frame_newslot(num11378);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11380 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_values (depth = 9)
  partcv[0] = 0;
  Object call11381 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe11380);
// compiled call node returning call11381 (depth = 8)
// compiled member node returning call11381 (depth = 7)
  int op_slot_left_11377 = gc_frame_newslot(call11381);
  params[0] = num11378;
  partcv[0] = 1;
  Object opresult11382 = callmethod(call11381, ">", 1, partcv, params);
// compiled op node returning opresult11382 (depth = 6)
  params[0] = block11342;
  partcv[0] = 1;
  Object call11383 = callmethod(opresult11382, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11341);
// compiled call node returning call11383 (depth = 5)
  Object if11340 = done;
  if (istrue(call11383)) {
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3485
  setline(3485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11384 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11386 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11385);
// compiled call node returning call11386 (depth = 9)
// compiled member node returning call11386 (depth = 8)
  partcv[0] = 0;
  Object call11387 = callmethod(call11386, "new",
    1, partcv, params);
  gc_frame_end(callframe11384);
// compiled call node returning call11387 (depth = 7)
// compiled member node returning call11387 (depth = 6)
  *var_suggestion = call11387;
  if (call11387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11389 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
  Object bool11390 = alloc_Boolean(1);
// compiled identifier node returning bool11390 (depth = 6)
  gc_frame_newslot(bool11390);
// starting to compile identifier node (depth = 6)
  Object bool11391 = alloc_Boolean(0);
// compiled identifier node returning bool11391 (depth = 6)
  gc_frame_newslot(bool11391);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11393 == NULL) {
    strlit11393 = alloc_String(")");
    gc_root(strlit11393);
  }
// compiled string node returning strlit11393 (depth = 7)
  int op_slot_right_11392 = gc_frame_newslot(strlit11393);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11396 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11397 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11396);
// compiled call node returning call11397 (depth = 9)
// compiled member node returning call11397 (depth = 8)
  int op_slot_right_11395 = gc_frame_newslot(call11397);
// starting to compile string node (depth = 8)
  if (strlit11399 == NULL) {
    strlit11399 = alloc_String("(");
    gc_root(strlit11399);
  }
// compiled string node returning strlit11399 (depth = 8)
  int op_slot_left_11395 = gc_frame_newslot(strlit11399);
  params[0] = call11397;
  partcv[0] = 1;
  Object opresult11400 = callmethod(strlit11399, "++", 1, partcv, params);
// compiled op node returning opresult11400 (depth = 7)
  int op_slot_left_11392 = gc_frame_newslot(opresult11400);
  params[0] = strlit11393;
  partcv[0] = 1;
  Object opresult11401 = callmethod(opresult11400, "++", 1, partcv, params);
// compiled op node returning opresult11401 (depth = 6)
  gc_frame_newslot(opresult11401);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = bool11390;
  params[2] = bool11391;
  params[3] = opresult11401;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11402 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11389);
// compiled call node returning call11402 (depth = 5)
// Begin line 3487
  setline(3487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11403 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11404 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11403);
// compiled call node returning call11404 (depth = 5)
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3488
  setline(3488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11407 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11408 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11407);
// compiled call node returning call11408 (depth = 8)
// compiled member node returning call11408 (depth = 7)
  int op_slot_right_11406 = gc_frame_newslot(call11408);
// starting to compile identifier node (depth = 7)
  Object bool11410 = alloc_Boolean(0);
// compiled identifier node returning bool11410 (depth = 7)
  int op_slot_left_11406 = gc_frame_newslot(bool11410);
  params[0] = call11408;
  partcv[0] = 1;
  Object opresult11411 = callmethod(bool11410, "!=", 1, partcv, params);
// compiled op node returning opresult11411 (depth = 6)
  Object if11405 = done;
  if (istrue(opresult11411)) {
// Begin line 3490
  setline(3490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11412 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11413 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11412);
// compiled call node returning call11413 (depth = 8)
// compiled member node returning call11413 (depth = 7)
  *var_n = call11413;
  if (call11413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 3490
  setline(3490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11416 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11417 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11416);
// compiled call node returning call11417 (depth = 9)
// compiled member node returning call11417 (depth = 8)
  int op_slot_right_11415 = gc_frame_newslot(call11417);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11419 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_n (depth = 10)
  partcv[0] = 0;
  Object call11420 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe11419);
// compiled call node returning call11420 (depth = 9)
// compiled member node returning call11420 (depth = 8)
  int op_slot_left_11415 = gc_frame_newslot(call11420);
  params[0] = call11417;
  partcv[0] = 1;
  Object opresult11421 = callmethod(call11420, "==", 1, partcv, params);
// compiled op node returning opresult11421 (depth = 7)
  Object if11414 = done;
  if (istrue(opresult11421)) {
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// Begin line 3491
  setline(3491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11422 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11423 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_errormessages (depth = 12)
  partcv[0] = 0;
  Object call11424 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11423);
// compiled call node returning call11424 (depth = 11)
// compiled member node returning call11424 (depth = 10)
  partcv[0] = 0;
  Object call11425 = callmethod(call11424, "new",
    1, partcv, params);
  gc_frame_end(callframe11422);
// compiled call node returning call11425 (depth = 9)
// compiled member node returning call11425 (depth = 8)
  *var_suggestion = call11425;
  if (call11425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11427 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 8)
  Object bool11428 = alloc_Boolean(1);
// compiled identifier node returning bool11428 (depth = 8)
  gc_frame_newslot(bool11428);
// starting to compile identifier node (depth = 8)
  Object bool11429 = alloc_Boolean(0);
// compiled identifier node returning bool11429 (depth = 8)
  gc_frame_newslot(bool11429);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit11431 == NULL) {
    strlit11431 = alloc_String("");
    gc_root(strlit11431);
  }
// compiled string node returning strlit11431 (depth = 9)
  int op_slot_right_11430 = gc_frame_newslot(strlit11431);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11434 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11435 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11434);
// compiled call node returning call11435 (depth = 11)
// compiled member node returning call11435 (depth = 10)
  int op_slot_right_11433 = gc_frame_newslot(call11435);
// starting to compile string node (depth = 10)
  if (strlit11437 == NULL) {
    strlit11437 = alloc_String("(");
    gc_root(strlit11437);
  }
// compiled string node returning strlit11437 (depth = 10)
  int op_slot_left_11433 = gc_frame_newslot(strlit11437);
  params[0] = call11435;
  partcv[0] = 1;
  Object opresult11438 = callmethod(strlit11437, "++", 1, partcv, params);
// compiled op node returning opresult11438 (depth = 9)
  int op_slot_left_11430 = gc_frame_newslot(opresult11438);
  params[0] = strlit11431;
  partcv[0] = 1;
  Object opresult11439 = callmethod(opresult11438, "++", 1, partcv, params);
// compiled op node returning opresult11439 (depth = 8)
  gc_frame_newslot(opresult11439);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = *var_sym;
  params[1] = bool11428;
  params[2] = bool11429;
  params[3] = opresult11439;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11440 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11427);
// compiled call node returning call11440 (depth = 7)
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11441 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit11442 == NULL) {
    strlit11442 = alloc_String(")");
    gc_root(strlit11442);
  }
// compiled string node returning strlit11442 (depth = 8)
  gc_frame_newslot(strlit11442);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11443 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11444 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11443);
// compiled call node returning call11444 (depth = 9)
// compiled member node returning call11444 (depth = 8)
  gc_frame_newslot(call11444);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  params[0] = strlit11442;
  params[1] = call11444;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11445 = callmethod(*var_suggestion, "append()onLine",
    2, partcv, params);
  gc_frame_end(callframe11441);
// compiled call node returning call11445 (depth = 7)
// Begin line 3494
  setline(3494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe11446 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestion (depth = 8)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_suggestions (depth = 8)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11447 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11446);
// compiled call node returning call11447 (depth = 7)
    gc_frame_newslot(call11447);
    if11414 = call11447;
  } else {
  }
// compiled if node returning if11414 (depth = 6)
    gc_frame_newslot(if11414);
    if11405 = if11414;
  } else {
  }
// compiled if node returning if11405 (depth = 5)
// Begin line 3502
  setline(3502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit11450 == NULL) {
    strlit11450 = alloc_String("identifier");
    gc_root(strlit11450);
  }
// compiled string node returning strlit11450 (depth = 7)
  int op_slot_right_11449 = gc_frame_newslot(strlit11450);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11452 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11453 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_values (depth = 11)
  partcv[0] = 0;
  Object call11454 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11453);
// compiled call node returning call11454 (depth = 10)
// compiled member node returning call11454 (depth = 9)
  partcv[0] = 0;
  Object call11455 = callmethod(call11454, "kind",
    1, partcv, params);
  gc_frame_end(callframe11452);
// compiled call node returning call11455 (depth = 8)
// compiled member node returning call11455 (depth = 7)
  int op_slot_left_11449 = gc_frame_newslot(call11455);
  params[0] = strlit11450;
  partcv[0] = 1;
  Object opresult11456 = callmethod(call11455, "==", 1, partcv, params);
// compiled op node returning opresult11456 (depth = 6)
  Object if11448 = done;
  if (istrue(opresult11456)) {
// Begin line 3499
  setline(3499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// Begin line 3498
  setline(3498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11457 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11458 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_errormessages (depth = 11)
  partcv[0] = 0;
  Object call11459 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11458);
// compiled call node returning call11459 (depth = 10)
// compiled member node returning call11459 (depth = 9)
  partcv[0] = 0;
  Object call11460 = callmethod(call11459, "new",
    1, partcv, params);
  gc_frame_end(callframe11457);
// compiled call node returning call11460 (depth = 8)
// compiled member node returning call11460 (depth = 7)
  *var_suggestion = call11460;
  if (call11460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 3499
  setline(3499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11462 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 7)
  Object bool11463 = alloc_Boolean(0);
// compiled identifier node returning bool11463 (depth = 7)
  gc_frame_newslot(bool11463);
// starting to compile identifier node (depth = 7)
  Object bool11464 = alloc_Boolean(0);
// compiled identifier node returning bool11464 (depth = 7)
  gc_frame_newslot(bool11464);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit11466 == NULL) {
    strlit11466 = alloc_String("""\x22""");
    gc_root(strlit11466);
  }
// compiled string node returning strlit11466 (depth = 8)
  int op_slot_right_11465 = gc_frame_newslot(strlit11466);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11469 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_sym (depth = 11)
  partcv[0] = 0;
  Object call11470 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11469);
// compiled call node returning call11470 (depth = 10)
// compiled member node returning call11470 (depth = 9)
  int op_slot_right_11468 = gc_frame_newslot(call11470);
// starting to compile string node (depth = 9)
  if (strlit11472 == NULL) {
    strlit11472 = alloc_String("""\x22""");
    gc_root(strlit11472);
  }
// compiled string node returning strlit11472 (depth = 9)
  int op_slot_left_11468 = gc_frame_newslot(strlit11472);
  params[0] = call11470;
  partcv[0] = 1;
  Object opresult11473 = callmethod(strlit11472, "++", 1, partcv, params);
// compiled op node returning opresult11473 (depth = 8)
  int op_slot_left_11465 = gc_frame_newslot(opresult11473);
  params[0] = strlit11466;
  partcv[0] = 1;
  Object opresult11474 = callmethod(opresult11473, "++", 1, partcv, params);
// compiled op node returning opresult11474 (depth = 7)
  gc_frame_newslot(opresult11474);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  params[0] = *var_sym;
  params[1] = bool11463;
  params[2] = bool11464;
  params[3] = opresult11474;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11475 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11462);
// compiled call node returning call11475 (depth = 6)
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe11476 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestion (depth = 7)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_suggestions (depth = 7)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11477 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11476);
// compiled call node returning call11477 (depth = 6)
    gc_frame_newslot(call11477);
    if11448 = call11477;
  } else {
  }
// compiled if node returning if11448 (depth = 5)
    gc_frame_newslot(if11448);
    if11340 = if11448;
  } else {
  }
// compiled if node returning if11340 (depth = 4)
// Begin line 3503
  setline(3503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11478 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit11479 == NULL) {
    strlit11479 = alloc_String("rbrace");
    gc_root(strlit11479);
  }
// compiled string node returning strlit11479 (depth = 6)
  gc_frame_newslot(strlit11479);
// call case 4: self request
  params[0] = strlit11479;
  partcv[0] = 1;
  Object call11480 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11478);
// compiled call node returning call11480 (depth = 5)
  *var_nextTok = call11480;
  if (call11480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 3515
  setline(3515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3504
  setline(3504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  int op_slot_right_11482 = gc_frame_newslot(*var_sym);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_nextTok (depth = 6)
  int op_slot_left_11482 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult11484 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compiled op node returning opresult11484 (depth = 5)
  Object if11481 = done;
  if (istrue(opresult11484)) {
// Begin line 3506
  setline(3506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3505
  setline(3505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11485 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11486 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11487 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11486);
// compiled call node returning call11487 (depth = 9)
// compiled member node returning call11487 (depth = 8)
  partcv[0] = 0;
  Object call11488 = callmethod(call11487, "new",
    1, partcv, params);
  gc_frame_end(callframe11485);
// compiled call node returning call11488 (depth = 7)
// compiled member node returning call11488 (depth = 6)
  *var_suggestion = call11488;
  if (call11488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3506
  setline(3506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11490 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11491 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lastToken (depth = 8)
  partcv[0] = 0;
  Object call11492 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11491);
// compiled call node returning call11492 (depth = 7)
// compiled member node returning call11492 (depth = 6)
  gc_frame_newslot(call11492);
// starting to compile call node (depth = 6)
  int callframe11493 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num11494 = alloc_Float64(1);
// compiled num node returning num11494 (depth = 7)
  gc_frame_newslot(num11494);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num11496 = alloc_Float64(1);
// compiled num node returning num11496 (depth = 8)
  int op_slot_right_11495 = gc_frame_newslot(num11496);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11499 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call11500 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe11499);
// compiled call node returning call11500 (depth = 10)
// compiled member node returning call11500 (depth = 9)
  int op_slot_right_11498 = gc_frame_newslot(call11500);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe11502 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_lastToken (depth = 11)
  partcv[0] = 0;
  Object call11503 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11502);
// compiled call node returning call11503 (depth = 10)
// compiled member node returning call11503 (depth = 9)
  int op_slot_left_11498 = gc_frame_newslot(call11503);
  params[0] = call11500;
  partcv[0] = 1;
  Object sum11504 = callmethod(call11503, "+", 1, partcv, params);
// compiled op node returning sum11504 (depth = 8)
  int op_slot_left_11495 = gc_frame_newslot(sum11504);
  params[0] = num11496;
  partcv[0] = 1;
  Object diff11505 = callmethod(sum11504, "-", 1, partcv, params);
// compiled op node returning diff11505 (depth = 7)
  gc_frame_newslot(diff11505);
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11506 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11507 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11506);
// compiled call node returning call11507 (depth = 9)
// compiled member node returning call11507 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11508 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lastToken (depth = 10)
  partcv[0] = 0;
  Object call11509 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11508);
// compiled call node returning call11509 (depth = 9)
// compiled member node returning call11509 (depth = 8)
  params[0] = call11509;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11510 = callmethod(call11507, "[]", 1, partcv, params);
// compiled index node returning idxres11510 (depth = 7)
  params[0] = num11494;
  params[1] = diff11505;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11511 = callmethod(idxres11510, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11493);
// compiled call node returning call11511 (depth = 6)
  gc_frame_newslot(call11511);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = call11492;
  params[1] = call11511;
  partcv[0] = 2;
  Object call11512 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11490);
// compiled call node returning call11512 (depth = 5)
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11513 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11514 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_sym (depth = 9)
  partcv[0] = 0;
  Object call11515 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11514);
// compiled call node returning call11515 (depth = 8)
// compiled member node returning call11515 (depth = 7)
  gc_frame_newslot(call11515);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11516 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11517 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_util (depth = 12)
  partcv[0] = 0;
  Object call11518 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11517);
// compiled call node returning call11518 (depth = 11)
// compiled member node returning call11518 (depth = 10)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11519 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_sym (depth = 12)
  partcv[0] = 0;
  Object call11520 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11519);
// compiled call node returning call11520 (depth = 11)
// compiled member node returning call11520 (depth = 10)
  params[0] = call11520;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11521 = callmethod(call11518, "[]", 1, partcv, params);
// compiled index node returning idxres11521 (depth = 9)
  partcv[0] = 0;
  Object call11522 = callmethod(idxres11521, "size",
    1, partcv, params);
  gc_frame_end(callframe11516);
// compiled call node returning call11522 (depth = 8)
// compiled member node returning call11522 (depth = 7)
  gc_frame_newslot(call11522);
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11523 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11524 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11523);
// compiled call node returning call11524 (depth = 9)
// compiled member node returning call11524 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11525 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11526 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11525);
// compiled call node returning call11526 (depth = 9)
// compiled member node returning call11526 (depth = 8)
  params[0] = call11526;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11527 = callmethod(call11524, "[]", 1, partcv, params);
// compiled index node returning idxres11527 (depth = 7)
  params[0] = call11515;
  params[1] = call11522;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11528 = callmethod(idxres11527, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11513);
// compiled call node returning call11528 (depth = 6)
  *var_newLine = call11528;
  if (call11528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3508
  setline(3508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11529 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11531 = alloc_Float64(0.1);
// compiled num node returning num11531 (depth = 7)
  int op_slot_right_11530 = gc_frame_newslot(num11531);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe11533 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lastToken (depth = 9)
  partcv[0] = 0;
  Object call11534 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11533);
// compiled call node returning call11534 (depth = 8)
// compiled member node returning call11534 (depth = 7)
  int op_slot_left_11530 = gc_frame_newslot(call11534);
  params[0] = num11531;
  partcv[0] = 1;
  Object sum11535 = callmethod(call11534, "+", 1, partcv, params);
// compiled op node returning sum11535 (depth = 6)
  gc_frame_newslot(sum11535);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newLine (depth = 6)
  gc_frame_newslot(*var_newLine);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = sum11535;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call11536 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11529);
// compiled call node returning call11536 (depth = 5)
// Begin line 3509
  setline(3509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11537 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11538 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11537);
// compiled call node returning call11538 (depth = 5)
    gc_frame_newslot(call11538);
    if11481 = call11538;
  } else {
// Begin line 3512
  setline(3512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// Begin line 3511
  setline(3511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11539 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11540 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11541 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11540);
// compiled call node returning call11541 (depth = 9)
// compiled member node returning call11541 (depth = 8)
  partcv[0] = 0;
  Object call11542 = callmethod(call11541, "new",
    1, partcv, params);
  gc_frame_end(callframe11539);
// compiled call node returning call11542 (depth = 7)
// compiled member node returning call11542 (depth = 6)
  *var_suggestion = call11542;
  if (call11542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 3512
  setline(3512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11544 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11545 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_nextTok (depth = 8)
  partcv[0] = 0;
  Object call11546 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11545);
// compiled call node returning call11546 (depth = 7)
// compiled member node returning call11546 (depth = 6)
  gc_frame_newslot(call11546);
// starting to compile identifier node (depth = 6)
  Object bool11547 = alloc_Boolean(1);
// compiled identifier node returning bool11547 (depth = 6)
  gc_frame_newslot(bool11547);
// starting to compile identifier node (depth = 6)
  Object bool11548 = alloc_Boolean(0);
// compiled identifier node returning bool11548 (depth = 6)
  gc_frame_newslot(bool11548);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  params[1] = call11546;
  params[2] = bool11547;
  params[3] = bool11548;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11549 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe11544);
// compiled call node returning call11549 (depth = 5)
// Begin line 3513
  setline(3513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11550 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestions (depth = 6)
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11551 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11550);
// compiled call node returning call11551 (depth = 5)
    gc_frame_newslot(call11551);
    if11481 = call11551;
  }
// compiled if node returning if11481 (depth = 4)
// Begin line 3515
  setline(3515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe11552 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11553 == NULL) {
    strlit11553 = alloc_String("Multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.");
    gc_root(strlit11553);
  }
// compiled string node returning strlit11553 (depth = 5)
  gc_frame_newslot(strlit11553);
// Begin line 3516
  setline(3516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11554 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11555 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11554);
// compiled call node returning call11555 (depth = 6)
// compiled member node returning call11555 (depth = 5)
  gc_frame_newslot(call11555);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sym (depth = 7)
  partcv[0] = 0;
  Object call11557 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11556);
// compiled call node returning call11557 (depth = 6)
// compiled member node returning call11557 (depth = 5)
  gc_frame_newslot(call11557);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_suggestions (depth = 5)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// Begin line 3515
  setline(3515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errormessages (depth = 5)
  params[0] = strlit11553;
  params[1] = call11555;
  params[2] = call11557;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11558 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11552);
// compiled call node returning call11558 (depth = 4)
    gc_frame_newslot(call11558);
    if11332 = call11558;
  } else {
  }
// compiled if node returning if11332 (depth = 3)
    gc_frame_newslot(if11332);
    if11240 = if11332;
  } else {
  }
// compiled if node returning if11240 (depth = 2)
  gc_frame_end(frame);
  return if11240;
}
Object meth_parser__apply11711(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num11713 = alloc_Float64(0);
// compiled num node returning num11713 (depth = 5)
  int op_slot_right_11712 = gc_frame_newslot(num11713);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11716 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11715);
// compiled call node returning call11716 (depth = 6)
// compiled member node returning call11716 (depth = 5)
  int op_slot_left_11712 = gc_frame_newslot(call11716);
  params[0] = num11713;
  partcv[0] = 1;
  Object opresult11717 = callmethod(call11716, ">", 1, partcv, params);
// compiled op node returning opresult11717 (depth = 4)
  gc_frame_end(frame);
  return opresult11717;
}
Object meth_parser__apply11720(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_oldlength = getfromclosure(closure, 0);
  Object *var_tokens = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 3569
  setline(3569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11721 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11722 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11721);
// compiled call node returning call11722 (depth = 5)
// compiled member node returning call11722 (depth = 4)
// Begin line 3570
  setline(3570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11723 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11724 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11723);
// compiled call node returning call11724 (depth = 5)
// compiled member node returning call11724 (depth = 4)
// Begin line 3571
  setline(3571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11725 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11726 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11725);
// compiled call node returning call11726 (depth = 5)
// compiled member node returning call11726 (depth = 4)
// Begin line 3572
  setline(3572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11727 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11728 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11727);
// compiled call node returning call11728 (depth = 5)
// compiled member node returning call11728 (depth = 4)
// Begin line 3573
  setline(3573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11730 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11729);
// compiled call node returning call11730 (depth = 5)
// compiled member node returning call11730 (depth = 4)
// Begin line 3574
  setline(3574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11731 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11732 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11731);
// compiled call node returning call11732 (depth = 5)
// compiled member node returning call11732 (depth = 4)
// Begin line 3581
  setline(3581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// Begin line 3575
  setline(3575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldlength (depth = 6)
  int op_slot_right_11734 = gc_frame_newslot(*var_oldlength);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11736 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call11737 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11736);
// compiled call node returning call11737 (depth = 7)
// compiled member node returning call11737 (depth = 6)
  int op_slot_left_11734 = gc_frame_newslot(call11737);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult11738 = callmethod(call11737, "==", 1, partcv, params);
// compiled op node returning opresult11738 (depth = 5)
  Object if11733 = done;
  if (istrue(opresult11738)) {
// Begin line 3577
  setline(3577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// Begin line 3576
  setline(3576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11739 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11740 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_errormessages (depth = 10)
  partcv[0] = 0;
  Object call11741 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11740);
// compiled call node returning call11741 (depth = 9)
// compiled member node returning call11741 (depth = 8)
  partcv[0] = 0;
  Object call11742 = callmethod(call11741, "new",
    1, partcv, params);
  gc_frame_end(callframe11739);
// compiled call node returning call11742 (depth = 7)
// compiled member node returning call11742 (depth = 6)
  *var_suggestion = call11742;
  if (call11742 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 3577
  setline(3577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11743 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  gc_frame_newslot(*var_sym);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call11744 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe11743);
// compiled call node returning call11744 (depth = 5)
// Begin line 3578
  setline(3578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe11745 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit11746 == NULL) {
    strlit11746 = alloc_String("Invalid statement. This is often caused by an extra '}', ')', or ']'.");
    gc_root(strlit11746);
  }
// compiled string node returning strlit11746 (depth = 6)
  gc_frame_newslot(strlit11746);
// Begin line 3579
  setline(3579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11747 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11748 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11747);
// compiled call node returning call11748 (depth = 7)
// compiled member node returning call11748 (depth = 6)
  gc_frame_newslot(call11748);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11749 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sym (depth = 8)
  partcv[0] = 0;
  Object call11750 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11749);
// compiled call node returning call11750 (depth = 7)
// compiled member node returning call11750 (depth = 6)
  gc_frame_newslot(call11750);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num11752 = alloc_Float64(1);
// compiled num node returning num11752 (depth = 7)
  int op_slot_right_11751 = gc_frame_newslot(num11752);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11755 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11756 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe11755);
// compiled call node returning call11756 (depth = 9)
// compiled member node returning call11756 (depth = 8)
  int op_slot_right_11754 = gc_frame_newslot(call11756);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11758 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_sym (depth = 10)
  partcv[0] = 0;
  Object call11759 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11758);
// compiled call node returning call11759 (depth = 9)
// compiled member node returning call11759 (depth = 8)
  int op_slot_left_11754 = gc_frame_newslot(call11759);
  params[0] = call11756;
  partcv[0] = 1;
  Object sum11760 = callmethod(call11759, "+", 1, partcv, params);
// compiled op node returning sum11760 (depth = 7)
  int op_slot_left_11751 = gc_frame_newslot(sum11760);
  params[0] = num11752;
  partcv[0] = 1;
  Object diff11761 = callmethod(sum11760, "-", 1, partcv, params);
// compiled op node returning diff11761 (depth = 6)
  gc_frame_newslot(diff11761);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_suggestion (depth = 6)
  gc_frame_newslot(*var_suggestion);
// call case 6: other member request
// Begin line 3578
  setline(3578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_errormessages (depth = 6)
  params[0] = strlit11746;
  params[1] = call11748;
  params[2] = call11750;
  params[3] = diff11761;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11762 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11745);
// compiled call node returning call11762 (depth = 5)
    gc_frame_newslot(call11762);
    if11733 = call11762;
  } else {
  }
// compiled if node returning if11733 (depth = 4)
// Begin line 3582
  setline(3582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// Begin line 3581
  setline(3581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11763 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tokens (depth = 7)
  partcv[0] = 0;
  Object call11764 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11763);
// compiled call node returning call11764 (depth = 6)
// compiled member node returning call11764 (depth = 5)
  *var_oldlength = call11764;
  if (call11764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_parse11559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method parse");
  Object params[5];
  int partcv[3];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_defaultDefVisibility = getfromclosure(closure, 2);
  Object *var_defaultVarVisibility = getfromclosure(closure, 3);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_errormessages = getfromclosure(closure, 7);
  Object *var_lastToken = getfromclosure(closure, 8);
  Object *var_linenum = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parse (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for parse");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sugg");
  Object *var_oldlength = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldlength");
// Begin line 3524
  setline(3524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11560 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit11561 == NULL) {
    strlit11561 = alloc_String("processing tokens.");
    gc_root(strlit11561);
  }
// compiled string node returning strlit11561 (depth = 3)
  gc_frame_newslot(strlit11561);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit11561;
  partcv[0] = 1;
  Object call11562 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11560);
// compiled call node returning call11562 (depth = 2)
// Begin line 3526
  setline(3526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3525
  setline(3525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array11563 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11563 (depth = 3)
  *var_values = array11563;
  if (array11563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3531
  setline(3531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3526
  setline(3526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11566 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11567 == NULL) {
    strlit11567 = alloc_String("DefaultVisibility");
    gc_root(strlit11567);
  }
// compiled string node returning strlit11567 (depth = 4)
  gc_frame_newslot(strlit11567);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11568 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11569 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11568);
// compiled call node returning call11569 (depth = 5)
// compiled member node returning call11569 (depth = 4)
  params[0] = strlit11567;
  partcv[0] = 1;
  Object call11570 = callmethod(call11569, "contains",
    1, partcv, params);
  gc_frame_end(callframe11566);
// compiled call node returning call11570 (depth = 3)
  Object if11565 = done;
  if (istrue(call11570)) {
// Begin line 3527
  setline(3527);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11571 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11572 == NULL) {
    strlit11572 = alloc_String("DefaultVisibility");
    gc_root(strlit11572);
  }
// compiled string node returning strlit11572 (depth = 5)
  gc_frame_newslot(strlit11572);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11573 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11574 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11573);
// compiled call node returning call11574 (depth = 6)
// compiled member node returning call11574 (depth = 5)
  params[0] = strlit11572;
  partcv[0] = 1;
  Object call11575 = callmethod(call11574, "get",
    1, partcv, params);
  gc_frame_end(callframe11571);
// compiled call node returning call11575 (depth = 4)
  *var_defaultDefVisibility = call11575;
  if (call11575 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3528
  setline(3528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11577 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11578 == NULL) {
    strlit11578 = alloc_String("DefaultVisibility");
    gc_root(strlit11578);
  }
// compiled string node returning strlit11578 (depth = 5)
  gc_frame_newslot(strlit11578);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11579 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11580 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11579);
// compiled call node returning call11580 (depth = 6)
// compiled member node returning call11580 (depth = 5)
  params[0] = strlit11578;
  partcv[0] = 1;
  Object call11581 = callmethod(call11580, "get",
    1, partcv, params);
  gc_frame_end(callframe11577);
// compiled call node returning call11581 (depth = 4)
  *var_defaultVarVisibility = call11581;
  if (call11581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
// Begin line 3529
  setline(3529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11583 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11584 == NULL) {
    strlit11584 = alloc_String("DefaultVisibility");
    gc_root(strlit11584);
  }
// compiled string node returning strlit11584 (depth = 5)
  gc_frame_newslot(strlit11584);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11585 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11586 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11585);
// compiled call node returning call11586 (depth = 6)
// compiled member node returning call11586 (depth = 5)
  params[0] = strlit11584;
  partcv[0] = 1;
  Object call11587 = callmethod(call11586, "get",
    1, partcv, params);
  gc_frame_end(callframe11583);
// compiled call node returning call11587 (depth = 4)
  *var_defaultMethodVisibility = call11587;
  if (call11587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11565 = done;
  } else {
  }
// compiled if node returning if11565 (depth = 2)
// Begin line 3534
  setline(3534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3531
  setline(3531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11590 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11591 == NULL) {
    strlit11591 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11591);
  }
// compiled string node returning strlit11591 (depth = 4)
  gc_frame_newslot(strlit11591);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11592 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11593 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11592);
// compiled call node returning call11593 (depth = 5)
// compiled member node returning call11593 (depth = 4)
  params[0] = strlit11591;
  partcv[0] = 1;
  Object call11594 = callmethod(call11593, "contains",
    1, partcv, params);
  gc_frame_end(callframe11590);
// compiled call node returning call11594 (depth = 3)
  Object if11589 = done;
  if (istrue(call11594)) {
// Begin line 3532
  setline(3532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11595 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11596 == NULL) {
    strlit11596 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11596);
  }
// compiled string node returning strlit11596 (depth = 5)
  gc_frame_newslot(strlit11596);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11597 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11598 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11597);
// compiled call node returning call11598 (depth = 6)
// compiled member node returning call11598 (depth = 5)
  params[0] = strlit11596;
  partcv[0] = 1;
  Object call11599 = callmethod(call11598, "get",
    1, partcv, params);
  gc_frame_end(callframe11595);
// compiled call node returning call11599 (depth = 4)
  *var_defaultDefVisibility = call11599;
  if (call11599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11589 = done;
  } else {
  }
// compiled if node returning if11589 (depth = 2)
// Begin line 3537
  setline(3537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3534
  setline(3534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11602 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11603 == NULL) {
    strlit11603 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11603);
  }
// compiled string node returning strlit11603 (depth = 4)
  gc_frame_newslot(strlit11603);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11604 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11605 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11604);
// compiled call node returning call11605 (depth = 5)
// compiled member node returning call11605 (depth = 4)
  params[0] = strlit11603;
  partcv[0] = 1;
  Object call11606 = callmethod(call11605, "contains",
    1, partcv, params);
  gc_frame_end(callframe11602);
// compiled call node returning call11606 (depth = 3)
  Object if11601 = done;
  if (istrue(call11606)) {
// Begin line 3535
  setline(3535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11607 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11608 == NULL) {
    strlit11608 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11608);
  }
// compiled string node returning strlit11608 (depth = 5)
  gc_frame_newslot(strlit11608);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11609 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11610 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11609);
// compiled call node returning call11610 (depth = 6)
// compiled member node returning call11610 (depth = 5)
  params[0] = strlit11608;
  partcv[0] = 1;
  Object call11611 = callmethod(call11610, "get",
    1, partcv, params);
  gc_frame_end(callframe11607);
// compiled call node returning call11611 (depth = 4)
  *var_defaultVarVisibility = call11611;
  if (call11611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11601 = done;
  } else {
  }
// compiled if node returning if11601 (depth = 2)
// Begin line 3540
  setline(3540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3537
  setline(3537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11614 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11615 == NULL) {
    strlit11615 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit11615);
  }
// compiled string node returning strlit11615 (depth = 4)
  gc_frame_newslot(strlit11615);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_util (depth = 6)
  partcv[0] = 0;
  Object call11617 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11616);
// compiled call node returning call11617 (depth = 5)
// compiled member node returning call11617 (depth = 4)
  params[0] = strlit11615;
  partcv[0] = 1;
  Object call11618 = callmethod(call11617, "contains",
    1, partcv, params);
  gc_frame_end(callframe11614);
// compiled call node returning call11618 (depth = 3)
  Object if11613 = done;
  if (istrue(call11618)) {
// Begin line 3538
  setline(3538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11619 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit11620 == NULL) {
    strlit11620 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit11620);
  }
// compiled string node returning strlit11620 (depth = 5)
  gc_frame_newslot(strlit11620);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11621 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call11622 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11621);
// compiled call node returning call11622 (depth = 6)
// compiled member node returning call11622 (depth = 5)
  params[0] = strlit11620;
  partcv[0] = 1;
  Object call11623 = callmethod(call11622, "get",
    1, partcv, params);
  gc_frame_end(callframe11619);
// compiled call node returning call11623 (depth = 4)
  *var_defaultMethodVisibility = call11623;
  if (call11623 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
    gc_frame_newslot(done);
    if11613 = done;
  } else {
  }
// compiled if node returning if11613 (depth = 2)
// Begin line 3543
  setline(3543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3540
  setline(3540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11627 = alloc_Float64(0);
// compiled num node returning num11627 (depth = 4)
  int op_slot_right_11626 = gc_frame_newslot(num11627);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11629 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_toks (depth = 6)
  partcv[0] = 0;
  Object call11630 = callmethod(*var_toks, "size",
    1, partcv, params);
  gc_frame_end(callframe11629);
// compiled call node returning call11630 (depth = 5)
// compiled member node returning call11630 (depth = 4)
  int op_slot_left_11626 = gc_frame_newslot(call11630);
  params[0] = num11627;
  partcv[0] = 1;
  Object opresult11631 = callmethod(call11630, "==", 1, partcv, params);
// compiled op node returning opresult11631 (depth = 3)
  Object if11625 = done;
  if (istrue(opresult11631)) {
// Begin line 3542
  setline(3542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// Begin line 3541
  setline(3541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 4)
  Object array11632 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11632 (depth = 4)
  return array11632;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if11625 = undefined;
  } else {
  }
// compiled if node returning if11625 (depth = 2)
// Begin line 3544
  setline(3544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3543
  setline(3543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_toks (depth = 3)
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3545
  setline(3545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3544
  setline(3544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11634 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call11635 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe11634);
// compiled call node returning call11635 (depth = 4)
// compiled member node returning call11635 (depth = 3)
  *var_sym = call11635;
  if (call11635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3552
  setline(3552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// Begin line 3545
  setline(3545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num11639 = alloc_Float64(0);
// compiled num node returning num11639 (depth = 4)
  int op_slot_right_11638 = gc_frame_newslot(num11639);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11641 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11642 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11641);
// compiled call node returning call11642 (depth = 5)
// compiled member node returning call11642 (depth = 4)
  int op_slot_left_11638 = gc_frame_newslot(call11642);
  params[0] = num11639;
  partcv[0] = 1;
  Object opresult11643 = callmethod(call11642, ">", 1, partcv, params);
// compiled op node returning opresult11643 (depth = 3)
  Object if11637 = done;
  if (istrue(opresult11643)) {
// Begin line 3547
  setline(3547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// Begin line 3546
  setline(3546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11644 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11645 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errormessages (depth = 8)
  partcv[0] = 0;
  Object call11646 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11645);
// compiled call node returning call11646 (depth = 7)
// compiled member node returning call11646 (depth = 6)
  partcv[0] = 0;
  Object call11647 = callmethod(call11646, "new",
    1, partcv, params);
  gc_frame_end(callframe11644);
// compiled call node returning call11647 (depth = 5)
// compiled member node returning call11647 (depth = 4)
  *var_sugg = call11647;
  if (call11647 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 3547
  setline(3547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11648 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num11649 = alloc_Float64(1);
// compiled num node returning num11649 (depth = 4)
  gc_frame_newslot(num11649);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11650 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11651 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11650);
// compiled call node returning call11651 (depth = 5)
// compiled member node returning call11651 (depth = 4)
  gc_frame_newslot(call11651);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11652 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11653 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11652);
// compiled call node returning call11653 (depth = 5)
// compiled member node returning call11653 (depth = 4)
  gc_frame_newslot(call11653);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  params[0] = num11649;
  params[1] = call11651;
  params[2] = call11653;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call11654 = callmethod(*var_sugg, "deleteRange()onLine",
    2, partcv, params);
  gc_frame_end(callframe11648);
// compiled call node returning call11654 (depth = 3)
// Begin line 3548
  setline(3548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11655 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit11656 == NULL) {
    strlit11656 = alloc_String("The first line must not be indented.");
    gc_root(strlit11656);
  }
// compiled string node returning strlit11656 (depth = 4)
  gc_frame_newslot(strlit11656);
// Begin line 3549
  setline(3549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11657 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11658 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11657);
// compiled call node returning call11658 (depth = 5)
// compiled member node returning call11658 (depth = 4)
  gc_frame_newslot(call11658);
// starting to compile num node (depth = 4)
  Object num11659 = alloc_Float64(1);
// compiled num node returning num11659 (depth = 4)
  gc_frame_newslot(num11659);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11660 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_sym (depth = 6)
  partcv[0] = 0;
  Object call11661 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe11660);
// compiled call node returning call11661 (depth = 5)
// compiled member node returning call11661 (depth = 4)
  gc_frame_newslot(call11661);
// Begin line 3550
  setline(3550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sugg (depth = 4)
  gc_frame_newslot(*var_sugg);
// call case 6: other member request
// Begin line 3548
  setline(3548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_errormessages (depth = 4)
  params[0] = strlit11656;
  params[1] = call11658;
  params[2] = num11659;
  params[3] = call11661;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11662 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11655);
// compiled call node returning call11662 (depth = 3)
    gc_frame_newslot(call11662);
    if11637 = call11662;
  } else {
  }
// compiled if node returning if11637 (depth = 2)
// Begin line 3554
  setline(3554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3549
  setline(3549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe11663 = gc_frame_new();
// Begin line 3552
  setline(3552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lastToken (depth = 4)
  gc_frame_newslot(*var_lastToken);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sym (depth = 4)
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call11664 = callmethod(*var_sym, "prev:=",
    1, partcv, params);
  gc_frame_end(callframe11663);
// compiled call node returning call11664 (depth = 3)
// compiled bind node returning done (depth = 2)
// Begin line 3554
  setline(3554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11665 = gc_frame_new();
// starting to compile object node (depth = 3)
  Object inheritingObject11666 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11666 = alloc_userobj2(15,9, objclass11666);
  gc_frame_newslot(obj11666);
// OBJECT OUTER DEC outer
  adddatum2(obj11666, self, 0);
  addmethodreal(obj11666,"outer", &reader_parser_outer_11667);
  Object oldself11666 = self;
  struct StackFrameObject *oldstackframe11666 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11666);
  gc_frame_newslot((Object)stackframe);
  self = obj11666;
  Object *oldselfslot11666 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11666 = (*(struct UserObject *)self).data[0], lowerouter11666 = thisouter11666;
  if (inheritingObject11666) {
    struct UserObject *inho11666 = (struct UserObject *)inheritingObject11666;
    while (inho11666->super != GraceDefaultObject) inho11666 = (struct UserObject *)inho11666->super;
    inho11666->super = obj11666;
    self = inheritingObject11666;
    *selfslot = self;
    lowerouter11666 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11666;
  }
if (objclass11666 == NULL) {
  Method *reader11668 = addmethodrealflags(obj11666, "kind",&reader_parser_kind_11668, 0);
  Method *writer11668 = addmethodrealflags(obj11666, "kind:=",&writer_parser_kind_11668, 0);
  reader11668->definitionModule = modulename;
  writer11668->definitionModule = modulename;
  reader11668->definitionLine = 3556;
  writer11668->definitionLine = 3556;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 1);
if (objclass11666 == NULL) {
  Method *reader11669 = addmethodrealflags(obj11666, "line",&reader_parser_line_11669, 0);
  Method *writer11669 = addmethodrealflags(obj11666, "line:=",&writer_parser_line_11669, 0);
  reader11669->definitionModule = modulename;
  writer11669->definitionModule = modulename;
  reader11669->definitionLine = 3557;
  writer11669->definitionLine = 3557;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 2);
if (objclass11666 == NULL) {
  Method *reader11670 = addmethodrealflags(obj11666, "linePos",&reader_parser_linePos_11670, 0);
  Method *writer11670 = addmethodrealflags(obj11666, "linePos:=",&writer_parser_linePos_11670, 0);
  reader11670->definitionModule = modulename;
  writer11670->definitionModule = modulename;
  reader11670->definitionLine = 3558;
  writer11670->definitionLine = 3558;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 3);
if (objclass11666 == NULL) {
  Method *reader11671 = addmethodrealflags(obj11666, "indent",&reader_parser_indent_11671, 0);
  Method *writer11671 = addmethodrealflags(obj11666, "indent:=",&writer_parser_indent_11671, 0);
  reader11671->definitionModule = modulename;
  writer11671->definitionModule = modulename;
  reader11671->definitionLine = 3559;
  writer11671->definitionLine = 3559;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 4);
if (objclass11666 == NULL) {
  Method *reader11672 = addmethodrealflags(obj11666, "value",&reader_parser_value_11672, 0);
  Method *writer11672 = addmethodrealflags(obj11666, "value:=",&writer_parser_value_11672, 0);
  reader11672->definitionModule = modulename;
  writer11672->definitionModule = modulename;
  reader11672->definitionLine = 3560;
  writer11672->definitionLine = 3560;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 5);
if (objclass11666 == NULL) {
  Method *reader11673 = addmethodrealflags(obj11666, "size",&reader_parser_size_11673, MFLAG_DEF);
  reader11673->definitionModule = modulename;
  reader11673->definitionLine = 3561;
}
adddatum2(obj11666, alloc_Undefined(), 6);
if (objclass11666 == NULL) {
  Method *reader11674 = addmethodrealflags(obj11666, "next",&reader_parser_next_11674, 0);
  Method *writer11674 = addmethodrealflags(obj11666, "next:=",&writer_parser_next_11674, 0);
  reader11674->definitionModule = modulename;
  writer11674->definitionModule = modulename;
  reader11674->definitionLine = 3562;
  writer11674->definitionLine = 3562;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 7);
if (objclass11666 == NULL) {
  Method *reader11675 = addmethodrealflags(obj11666, "prev",&reader_parser_prev_11675, 0);
  Method *writer11675 = addmethodrealflags(obj11666, "prev:=",&writer_parser_prev_11675, 0);
  reader11675->definitionModule = modulename;
  writer11675->definitionModule = modulename;
  reader11675->definitionLine = 3563;
  writer11675->definitionLine = 3563;
}
obj11666->flags |= OFLAG_MUTABLE;
adddatum2(obj11666, alloc_Undefined(), 8);
  sourceObject = obj11666;
// Begin line 3555
  setline(3555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit11676 == NULL) {
    strlit11676 = alloc_String("eof");
    gc_root(strlit11676);
  }
// compiled string node returning strlit11676 (depth = 4)
  adddatum2(obj11666, strlit11676, 1);
  sourceObject = obj11666;
// Begin line 3556
  setline(3556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe11677 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe11678 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tokens (depth = 8)
  partcv[0] = 0;
  Object call11679 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe11678);
// compiled call node returning call11679 (depth = 7)
// compiled member node returning call11679 (depth = 6)
  partcv[0] = 0;
  Object call11680 = callmethod(call11679, "line",
    1, partcv, params);
  gc_frame_end(callframe11677);
// compiled call node returning call11680 (depth = 5)
// compiled member node returning call11680 (depth = 4)
  adddatum2(obj11666, call11680, 2);
  sourceObject = obj11666;
// Begin line 3558
  setline(3558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// Begin line 3557
  setline(3557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num11682 = alloc_Float64(1);
// compiled num node returning num11682 (depth = 5)
  int op_slot_right_11681 = gc_frame_newslot(num11682);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe11684 = gc_frame_new();
// call case 6: other member request
// starting to compile index node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11685 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_util (depth = 10)
  partcv[0] = 0;
  Object call11686 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11685);
// compiled call node returning call11686 (depth = 9)
// compiled member node returning call11686 (depth = 8)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe11687 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe11688 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_tokens (depth = 12)
  partcv[0] = 0;
  Object call11689 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe11688);
// compiled call node returning call11689 (depth = 11)
// compiled member node returning call11689 (depth = 10)
  partcv[0] = 0;
  Object call11690 = callmethod(call11689, "line",
    1, partcv, params);
  gc_frame_end(callframe11687);
// compiled call node returning call11690 (depth = 9)
// compiled member node returning call11690 (depth = 8)
  params[0] = call11690;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11691 = callmethod(call11686, "[]", 1, partcv, params);
// compiled index node returning idxres11691 (depth = 7)
  partcv[0] = 0;
  Object call11692 = callmethod(idxres11691, "size",
    1, partcv, params);
  gc_frame_end(callframe11684);
// compiled call node returning call11692 (depth = 6)
// compiled member node returning call11692 (depth = 5)
  int op_slot_left_11681 = gc_frame_newslot(call11692);
  params[0] = num11682;
  partcv[0] = 1;
  Object sum11693 = callmethod(call11692, "+", 1, partcv, params);
// compiled op node returning sum11693 (depth = 4)
  adddatum2(obj11666, sum11693, 3);
  sourceObject = obj11666;
// Begin line 3558
  setline(3558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num11694 = alloc_Float64(0);
// compiled num node returning num11694 (depth = 4)
  adddatum2(obj11666, num11694, 4);
  sourceObject = obj11666;
// Begin line 3559
  setline(3559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 4)
  if (strlit11695 == NULL) {
    strlit11695 = alloc_String("");
    gc_root(strlit11695);
  }
// compiled string node returning strlit11695 (depth = 4)
  adddatum2(obj11666, strlit11695, 5);
  sourceObject = obj11666;
// Begin line 3560
  setline(3560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 4)
  Object num11696 = alloc_Float64(0);
// compiled num node returning num11696 (depth = 4)
  adddatum2(obj11666, num11696, 6);
  sourceObject = obj11666;
// Begin line 3561
  setline(3561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool11697 = alloc_Boolean(0);
// compiled identifier node returning bool11697 (depth = 4)
  adddatum2(obj11666, bool11697, 7);
  sourceObject = obj11666;
// Begin line 3562
  setline(3562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
  Object bool11698 = alloc_Boolean(0);
// compiled identifier node returning bool11698 (depth = 4)
  adddatum2(obj11666, bool11698, 8);
objclass11666 = obj11666->class;
  objclass11666->definitionModule = modulename;
  objclass11666->definitionLine = 3554;
  (*(struct UserObject *)self).data[0] = lowerouter11666;
  self = oldself11666;
  selfslot = oldselfslot11666;
  stackframe = oldstackframe11666;
// compiled object node returning obj11666 (depth = 3)
  gc_frame_newslot(obj11666);
// call case 6: other member request
// Begin line 3554
  setline(3554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  params[0] = obj11666;
  partcv[0] = 1;
  Object call11699 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe11665);
// compiled call node returning call11699 (depth = 2)
// Begin line 3564
  setline(3564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11700 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit11701 == NULL) {
    strlit11701 = alloc_String("parsing.");
    gc_root(strlit11701);
  }
// compiled string node returning strlit11701 (depth = 3)
  gc_frame_newslot(strlit11701);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = strlit11701;
  partcv[0] = 1;
  Object call11702 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11700);
// compiled call node returning call11702 (depth = 2)
// Begin line 3566
  setline(3566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// Begin line 3565
  setline(3565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11703 = alloc_Float64(1);
// compiled num node returning num11703 (depth = 3)
  *var_linenum = num11703;
  if (num11703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 3566
  setline(3566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11705 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11706 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11705);
// compiled call node returning call11706 (depth = 3)
// compiled member node returning call11706 (depth = 2)
// Begin line 3568
  setline(3568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// Begin line 3567
  setline(3567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe11707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_tokens (depth = 5)
  partcv[0] = 0;
  Object call11708 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11707);
// compiled call node returning call11708 (depth = 4)
// compiled member node returning call11708 (depth = 3)
  *var_oldlength = call11708;
  if (call11708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 3568
  setline(3568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe11709 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block11710 = alloc_Block(NULL, NULL, "parser", 3568);
  gc_frame_newslot(block11710);
// method _apply
  block_savedest(block11710);
  Object closure11711 = createclosure(2, "_apply");
  setclosureframe(closure11711, stackframe);
  addtoclosure(closure11711, var_tokens);
  addtoclosure(closure11711, selfslot);
  struct UserObject *uo11711 = (struct UserObject*)block11710;
  uo11711->data[0] = (Object)closure11711;
  Method *meth_meth_parser__apply11711 = addmethod2pos(block11710, "_apply", &meth_parser__apply11711, 0);
  int argcv_meth_parser__apply11711[] = {0};
  meth_meth_parser__apply11711->type = alloc_MethodType(1, argcv_meth_parser__apply11711);
  meth_meth_parser__apply11711->definitionModule = modulename;
  meth_meth_parser__apply11711->definitionLine = 3567;
// compiled block node returning block11710 (depth = 3)
  gc_frame_newslot(block11710);
// starting to compile block node (depth = 3)
  Object block11719 = alloc_Block(NULL, NULL, "parser", 3568);
  gc_frame_newslot(block11719);
// method _apply
  block_savedest(block11719);
  Object closure11720 = createclosure(5, "_apply");
  setclosureframe(closure11720, stackframe);
  addtoclosure(closure11720, var_oldlength);
  addtoclosure(closure11720, var_tokens);
  addtoclosure(closure11720, var_errormessages);
  addtoclosure(closure11720, var_sym);
  addtoclosure(closure11720, selfslot);
  struct UserObject *uo11720 = (struct UserObject*)block11719;
  uo11720->data[0] = (Object)closure11720;
  Method *meth_meth_parser__apply11720 = addmethod2pos(block11719, "_apply", &meth_parser__apply11720, 0);
  int argcv_meth_parser__apply11720[] = {0};
  meth_meth_parser__apply11720->type = alloc_MethodType(1, argcv_meth_parser__apply11720);
  meth_meth_parser__apply11720->definitionModule = modulename;
  meth_meth_parser__apply11720->definitionLine = 3568;
// compiled block node returning block11719 (depth = 3)
  gc_frame_newslot(block11719);
// call case 5: prelude request
  params[0] = block11710;
  params[1] = block11719;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11767 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11709);
// compiled call node returning call11767 (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe11768 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call11769 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11768);
// compiled call node returning call11769 (depth = 3)
// compiled member node returning call11769 (depth = 2)
// Begin line 3584
  setline(3584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_values (depth = 2)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_don_39_tBreak11771(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "don'tBreak");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_don_39_tBreak = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for don'tBreak (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹don'tBreak›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_don_39_tBreak (depth = 3)
  gc_frame_end(frame);
  return *var_don_39_tBreak;
}
Object meth_parser_lastline11773(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastline");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastline = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastline (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹lastline›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastline (depth = 3)
  gc_frame_end(frame);
  return *var_lastline;
}
Object meth_parser_lastline_58__61_11774(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastline:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lastline:=");
  Object params[1];
  int partcv[1];
  Object *var_lastline = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastline:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹lastline:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastline = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_linenum11777(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "linenum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_linenum = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for linenum (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹linenum›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_linenum (depth = 3)
  gc_frame_end(frame);
  return *var_linenum;
}
Object meth_parser_linenum_58__61_11778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "linenum:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method linenum:=");
  Object params[1];
  int partcv[1];
  Object *var_linenum = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for linenum:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹linenum:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_linenum = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastIndent11781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹lastIndent›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastIndent (depth = 3)
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_lastIndent_58__61_11782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lastIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹lastIndent:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_indentFreePass11785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indentFreePass (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹indentFreePass›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indentFreePass (depth = 3)
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_indentFreePass_58__61_11786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method indentFreePass:=");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indentFreePass:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹indentFreePass:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_minIndentLevel11789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for minIndentLevel (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹minIndentLevel›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_minIndentLevel (depth = 3)
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_minIndentLevel_58__61_11790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method minIndentLevel:=");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for minIndentLevel:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹minIndentLevel:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementIndent11793(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementIndent (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹statementIndent›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementIndent (depth = 3)
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_statementIndent_58__61_11794(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method statementIndent:=");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹statementIndent:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_tokens11797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹tokens›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_tokens (depth = 3)
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_tokens_58__61_11798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method tokens:=");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹tokens:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_values11801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹values›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_values (depth = 3)
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_values_58__61_11802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method values:=");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹values:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_auto_count11805(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for auto_count (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹auto_count›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_auto_count (depth = 3)
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_auto_count_58__61_11806(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method auto_count:=");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for auto_count:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹auto_count:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_noBlocks11809(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "noBlocks");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_noBlocks = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for noBlocks (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹noBlocks›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_noBlocks (depth = 3)
  gc_frame_end(frame);
  return *var_noBlocks;
}
Object meth_parser_blocksOK11811(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blocksOK");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blocksOK = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blocksOK (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹blocksOK›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_blocksOK (depth = 3)
  gc_frame_end(frame);
  return *var_blocksOK;
}
Object meth_parser_braceIsType11813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for braceIsType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹braceIsType›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_braceIsType (depth = 3)
  gc_frame_end(frame);
  return *var_braceIsType;
}
Object meth_parser_braceIsType_58__61_11814(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method braceIsType:=");
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for braceIsType:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹braceIsType:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_braceIsType = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultDefVisibility11817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultDefVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹defaultDefVisibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultDefVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultDefVisibility;
}
Object meth_parser_defaultDefVisibility_58__61_11818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method defaultDefVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultDefVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹defaultDefVisibility:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultDefVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultVarVisibility11821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultVarVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹defaultVarVisibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultVarVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultVarVisibility;
}
Object meth_parser_defaultVarVisibility_58__61_11822(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method defaultVarVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultVarVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹defaultVarVisibility:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultVarVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultMethodVisibility11825(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultMethodVisibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹defaultMethodVisibility›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_defaultMethodVisibility (depth = 3)
  gc_frame_end(frame);
  return *var_defaultMethodVisibility;
}
Object meth_parser_defaultMethodVisibility_58__61_11826(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method defaultMethodVisibility:=");
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultMethodVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹defaultMethodVisibility:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_defaultMethodVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_sym11828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 97, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sym (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹sym›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sym (depth = 3)
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_sym_58__61_11829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 98, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method sym:=");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sym:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹sym:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastToken11845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 99, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹lastToken›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lastToken (depth = 3)
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_lastToken_58__61_11846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 100, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method lastToken:=");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹lastToken:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementToken11848(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 101, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementToken (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹statementToken›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_statementToken (depth = 3)
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_statementToken_58__61_11849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 102, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method statementToken:=");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹statementToken:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comment11852(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 103, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comment (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    gracedie("wrong number of arguments for IdentifierBinding‹comment›");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_comment (depth = 3)
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_comment_58__61_11853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 104, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method comment:=");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comment:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    gracedie("wrong number of arguments for Identifier‹comment:=›");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__var_assign_tmp (depth = 4)
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 3)
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(106, 106);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(106, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
Object *var_io = alloc_var();
Object *var_ast = alloc_var();
Object *var_util = alloc_var();
Object *var_collections = alloc_var();
Object *var_errormessages = alloc_var();
  Object *var_don_39_tBreak = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "don'tBreak");
  Object *var_lastline = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lastline");
  Object *var_linenum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "linenum");
  Object *var_lastIndent = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "statementIndent");
  Object *var_tokens = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tokens");
  Object *var_values = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "values");
  Object *var_auto_count = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "auto_count");
  Object *var_noBlocks = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "noBlocks");
  Object *var_blocksOK = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "blocksOK");
  Object *var_braceIsType = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "braceIsType");
  Object *var_defaultDefVisibility = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "defaultDefVisibility");
  Object *var_defaultVarVisibility = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "defaultVarVisibility");
  Object *var_defaultMethodVisibility = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "defaultMethodVisibility");
  Object *var_sym = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "sym");
  Object *var_lastToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "lastToken");
  Object *var_statementToken = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "statementToken");
  Object *var_comment = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "comment");
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method next
  block_savedest(self);
  Object closure0 = createclosure(9, "next");
  setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_sym);
  addtoclosure(closure0, var_lastToken);
  addtoclosure(closure0, var_tokens);
  addtoclosure(closure0, var_linenum);
  addtoclosure(closure0, var_lastline);
  addtoclosure(closure0, var_lastIndent);
  addtoclosure(closure0, var_comment);
  addtoclosure(closure0, var_util);
  addtoclosure(closure0, var_errormessages);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_parser_next0 = addmethod2pos(self, "next", &meth_parser_next0, 1);
  int argcv_meth_parser_next0[] = {0};
  meth_meth_parser_next0->type = alloc_MethodType(1, argcv_meth_parser_next0);
  meth_meth_parser_next0->definitionModule = modulename;
  meth_meth_parser_next0->definitionLine = 41;
// compiled method node returning  (depth = 1)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findNextToken
  block_savedest(self);
  Object closure110 = createclosure(2, "findNextToken");
  setclosureframe(closure110, stackframe);
  addtoclosure(closure110, var_sym);
  addtoclosure(closure110, var_lastToken);
  struct UserObject *uo110 = (struct UserObject*)self;
  uo110->data[2] = (Object)closure110;
  Method *meth_meth_parser_findNextToken110 = addmethod2pos(self, "findNextToken", &meth_parser_findNextToken110, 2);
  int argcv_meth_parser_findNextToken110[] = {1};
  meth_meth_parser_findNextToken110->type = alloc_MethodType(1, argcv_meth_parser_findNextToken110);
  meth_meth_parser_findNextToken110->definitionModule = modulename;
  meth_meth_parser_findNextToken110->definitionLine = 73;
// compiled method node returning  (depth = 1)
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findNextTokenIndentedAt
  block_savedest(self);
  Object closure155 = createclosure(1, "findNextTokenIndentedAt");
  setclosureframe(closure155, stackframe);
  addtoclosure(closure155, var_sym);
  struct UserObject *uo155 = (struct UserObject*)self;
  uo155->data[3] = (Object)closure155;
  Method *meth_meth_parser_findNextTokenIndentedAt155 = addmethod2pos(self, "findNextTokenIndentedAt", &meth_parser_findNextTokenIndentedAt155, 3);
  int argcv_meth_parser_findNextTokenIndentedAt155[] = {1};
  meth_meth_parser_findNextTokenIndentedAt155->type = alloc_MethodType(1, argcv_meth_parser_findNextTokenIndentedAt155);
  meth_meth_parser_findNextTokenIndentedAt155->definitionModule = modulename;
  meth_meth_parser_findNextTokenIndentedAt155->definitionLine = 88;
// compiled method node returning  (depth = 1)
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findNextValidToken
  block_savedest(self);
  Object closure236 = createclosure(1, "findNextValidToken");
  setclosureframe(closure236, stackframe);
  addtoclosure(closure236, var_sym);
  struct UserObject *uo236 = (struct UserObject*)self;
  uo236->data[4] = (Object)closure236;
  Method *meth_meth_parser_findNextValidToken236 = addmethod2pos(self, "findNextValidToken", &meth_parser_findNextValidToken236, 4);
  int argcv_meth_parser_findNextValidToken236[] = {0};
  meth_meth_parser_findNextValidToken236->type = alloc_MethodType(1, argcv_meth_parser_findNextValidToken236);
  meth_meth_parser_findNextValidToken236->definitionModule = modulename;
  meth_meth_parser_findNextValidToken236->definitionLine = 103;
// compiled method node returning  (depth = 1)
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method findClosingBrace
  block_savedest(self);
  Object closure275 = createclosure(1, "findClosingBrace");
  setclosureframe(closure275, stackframe);
  addtoclosure(closure275, var_sym);
  struct UserObject *uo275 = (struct UserObject*)self;
  uo275->data[5] = (Object)closure275;
  Method *meth_meth_parser_findClosingBrace275 = addmethod2pos(self, "findClosingBrace", &meth_parser_findClosingBrace275, 5);
  int argcv_meth_parser_findClosingBrace275[] = {2};
  meth_meth_parser_findClosingBrace275->type = alloc_MethodType(1, argcv_meth_parser_findClosingBrace275);
  meth_meth_parser_findClosingBrace275->definitionModule = modulename;
  meth_meth_parser_findClosingBrace275->definitionLine = 127;
// compiled method node returning  (depth = 1)
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method accept
  block_savedest(self);
  Object closure427 = createclosure(1, "accept");
  setclosureframe(closure427, stackframe);
  addtoclosure(closure427, var_sym);
  struct UserObject *uo427 = (struct UserObject*)self;
  uo427->data[6] = (Object)closure427;
  Method *meth_meth_parser_accept427 = addmethod2pos(self, "accept", &meth_parser_accept427, 6);
  int argcv_meth_parser_accept427[] = {1};
  meth_meth_parser_accept427->type = alloc_MethodType(1, argcv_meth_parser_accept427);
  meth_meth_parser_accept427->definitionModule = modulename;
  meth_meth_parser_accept427->definitionLine = 163;
// compiled method node returning  (depth = 1)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method acceptSameLine
  block_savedest(self);
  Object closure433 = createclosure(3, "acceptSameLine");
  setclosureframe(closure433, stackframe);
  addtoclosure(closure433, var_lastIndent);
  addtoclosure(closure433, var_sym);
  addtoclosure(closure433, var_lastline);
  struct UserObject *uo433 = (struct UserObject*)self;
  uo433->data[7] = (Object)closure433;
  Method *meth_meth_parser_acceptSameLine433 = addmethod2pos(self, "acceptSameLine", &meth_parser_acceptSameLine433, 7);
  int argcv_meth_parser_acceptSameLine433[] = {1};
  meth_meth_parser_acceptSameLine433->type = alloc_MethodType(1, argcv_meth_parser_acceptSameLine433);
  meth_meth_parser_acceptSameLine433->definitionModule = modulename;
  meth_meth_parser_acceptSameLine433->definitionLine = 170;
// compiled method node returning  (depth = 1)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method accept()onLineOf
  block_savedest(self);
  Object closure455 = createclosure(1, "accept()onLineOf");
  setclosureframe(closure455, stackframe);
  addtoclosure(closure455, var_sym);
  struct UserObject *uo455 = (struct UserObject*)self;
  uo455->data[8] = (Object)closure455;
  Method *meth_meth_parser_accept_40__41_onLineOf455 = addmethod2pos(self, "accept()onLineOf", &meth_parser_accept_40__41_onLineOf455, 8);
  int argcv_meth_parser_accept_40__41_onLineOf455[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOf455->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOf455);
  meth_meth_parser_accept_40__41_onLineOf455->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOf455->definitionLine = 177;
// compiled method node returning  (depth = 1)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method accept()onLineOfLastOr
  block_savedest(self);
  Object closure481 = createclosure(2, "accept()onLineOfLastOr");
  setclosureframe(closure481, stackframe);
  addtoclosure(closure481, var_sym);
  addtoclosure(closure481, var_lastToken);
  struct UserObject *uo481 = (struct UserObject*)self;
  uo481->data[9] = (Object)closure481;
  Method *meth_meth_parser_accept_40__41_onLineOfLastOr481 = addmethod2pos(self, "accept()onLineOfLastOr", &meth_parser_accept_40__41_onLineOfLastOr481, 9);
  int argcv_meth_parser_accept_40__41_onLineOfLastOr481[] = {1, 1};
  meth_meth_parser_accept_40__41_onLineOfLastOr481->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOfLastOr481);
  meth_meth_parser_accept_40__41_onLineOfLastOr481->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOfLastOr481->definitionLine = 183;
// compiled method node returning  (depth = 1)
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method tokenOnSameLine
  block_savedest(self);
  Object closure517 = createclosure(3, "tokenOnSameLine");
  setclosureframe(closure517, stackframe);
  addtoclosure(closure517, var_lastIndent);
  addtoclosure(closure517, var_sym);
  addtoclosure(closure517, var_lastline);
  struct UserObject *uo517 = (struct UserObject*)self;
  uo517->data[10] = (Object)closure517;
  Method *meth_meth_parser_tokenOnSameLine517 = addmethod2pos(self, "tokenOnSameLine", &meth_parser_tokenOnSameLine517, 10);
  int argcv_meth_parser_tokenOnSameLine517[] = {0};
  meth_meth_parser_tokenOnSameLine517->type = alloc_MethodType(1, argcv_meth_parser_tokenOnSameLine517);
  meth_meth_parser_tokenOnSameLine517->definitionModule = modulename;
  meth_meth_parser_tokenOnSameLine517->definitionLine = 188;
// compiled method node returning  (depth = 1)
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method didConsume
  block_savedest(self);
  Object closure531 = createclosure(1, "didConsume");
  setclosureframe(closure531, stackframe);
  addtoclosure(closure531, var_tokens);
  struct UserObject *uo531 = (struct UserObject*)self;
  uo531->data[11] = (Object)closure531;
  Method *meth_meth_parser_didConsume531 = addmethod2pos(self, "didConsume", &meth_parser_didConsume531, 11);
  int argcv_meth_parser_didConsume531[] = {1};
  meth_meth_parser_didConsume531->type = alloc_MethodType(1, argcv_meth_parser_didConsume531);
  meth_meth_parser_didConsume531->definitionModule = modulename;
  meth_meth_parser_didConsume531->definitionLine = 192;
// compiled method node returning  (depth = 1)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method ifConsume()then
  block_savedest(self);
  Object closure541 = createclosure(1, "ifConsume()then");
  setclosureframe(closure541, stackframe);
  addtoclosure(closure541, var_tokens);
  struct UserObject *uo541 = (struct UserObject*)self;
  uo541->data[12] = (Object)closure541;
  Method *meth_meth_parser_ifConsume_40__41_then541 = addmethod2pos(self, "ifConsume()then", &meth_parser_ifConsume_40__41_then541, 12);
  int argcv_meth_parser_ifConsume_40__41_then541[] = {1, 1};
  meth_meth_parser_ifConsume_40__41_then541->type = alloc_MethodType(2, argcv_meth_parser_ifConsume_40__41_then541);
  meth_meth_parser_ifConsume_40__41_then541->definitionModule = modulename;
  meth_meth_parser_ifConsume_40__41_then541->definitionLine = 198;
// compiled method node returning  (depth = 1)
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushnum
  block_savedest(self);
  Object closure554 = createclosure(3, "pushnum");
  setclosureframe(closure554, stackframe);
  addtoclosure(closure554, var_sym);
  addtoclosure(closure554, var_ast);
  addtoclosure(closure554, var_values);
  struct UserObject *uo554 = (struct UserObject*)self;
  uo554->data[13] = (Object)closure554;
  Method *meth_meth_parser_pushnum554 = addmethod2pos(self, "pushnum", &meth_parser_pushnum554, 13);
  int argcv_meth_parser_pushnum554[] = {0};
  meth_meth_parser_pushnum554->type = alloc_MethodType(1, argcv_meth_parser_pushnum554);
  meth_meth_parser_pushnum554->definitionModule = modulename;
  meth_meth_parser_pushnum554->definitionLine = 207;
// compiled method node returning  (depth = 1)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushoctets
  block_savedest(self);
  Object closure565 = createclosure(3, "pushoctets");
  setclosureframe(closure565, stackframe);
  addtoclosure(closure565, var_sym);
  addtoclosure(closure565, var_ast);
  addtoclosure(closure565, var_values);
  struct UserObject *uo565 = (struct UserObject*)self;
  uo565->data[14] = (Object)closure565;
  Method *meth_meth_parser_pushoctets565 = addmethod2pos(self, "pushoctets", &meth_parser_pushoctets565, 14);
  int argcv_meth_parser_pushoctets565[] = {0};
  meth_meth_parser_pushoctets565->type = alloc_MethodType(1, argcv_meth_parser_pushoctets565);
  meth_meth_parser_pushoctets565->definitionModule = modulename;
  meth_meth_parser_pushoctets565->definitionLine = 214;
// compiled method node returning  (depth = 1)
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushstring
  block_savedest(self);
  Object closure576 = createclosure(3, "pushstring");
  setclosureframe(closure576, stackframe);
  addtoclosure(closure576, var_sym);
  addtoclosure(closure576, var_ast);
  addtoclosure(closure576, var_values);
  struct UserObject *uo576 = (struct UserObject*)self;
  uo576->data[15] = (Object)closure576;
  Method *meth_meth_parser_pushstring576 = addmethod2pos(self, "pushstring", &meth_parser_pushstring576, 15);
  int argcv_meth_parser_pushstring576[] = {0};
  meth_meth_parser_pushstring576->type = alloc_MethodType(1, argcv_meth_parser_pushstring576);
  meth_meth_parser_pushstring576->definitionModule = modulename;
  meth_meth_parser_pushstring576->definitionLine = 221;
// compiled method node returning  (depth = 1)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method pushidentifier
  block_savedest(self);
  Object closure587 = createclosure(5, "pushidentifier");
  setclosureframe(closure587, stackframe);
  addtoclosure(closure587, var_sym);
  addtoclosure(closure587, var_util);
  addtoclosure(closure587, var_ast);
  addtoclosure(closure587, var_auto_count);
  addtoclosure(closure587, var_values);
  struct UserObject *uo587 = (struct UserObject*)self;
  uo587->data[16] = (Object)closure587;
  Method *meth_meth_parser_pushidentifier587 = addmethod2pos(self, "pushidentifier", &meth_parser_pushidentifier587, 16);
  int argcv_meth_parser_pushidentifier587[] = {0};
  meth_meth_parser_pushidentifier587->type = alloc_MethodType(1, argcv_meth_parser_pushidentifier587);
  meth_meth_parser_pushidentifier587->definitionModule = modulename;
  meth_meth_parser_pushidentifier587->definitionLine = 229;
// compiled method node returning  (depth = 1)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method adjustVisibilityOf()withSpecialDefault()overriding
  block_savedest(self);
  Object closure626 = createclosure(2, "adjustVisibilityOf()withSpecialDefault()overriding");
  setclosureframe(closure626, stackframe);
  addtoclosure(closure626, var_done);
  addtoclosure(closure626, var_ast);
  struct UserObject *uo626 = (struct UserObject*)self;
  uo626->data[17] = (Object)closure626;
  Method *meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626 = addmethod2pos(self, "adjustVisibilityOf()withSpecialDefault()overriding", &meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626, 17);
  int argcv_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626[] = {1, 1, 1};
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626->type = alloc_MethodType(3, argcv_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626);
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626->definitionModule = modulename;
  meth_meth_parser_adjustVisibilityOf_40__41_withSpecialDefault_40__41_overriding626->definitionLine = 241;
// compiled method node returning  (depth = 1)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkAnnotation
  block_savedest(self);
  Object closure684 = createclosure(2, "checkAnnotation");
  setclosureframe(closure684, stackframe);
  addtoclosure(closure684, var_sym);
  addtoclosure(closure684, var_errormessages);
  struct UserObject *uo684 = (struct UserObject*)self;
  uo684->data[18] = (Object)closure684;
  Method *meth_meth_parser_checkAnnotation684 = addmethod2pos(self, "checkAnnotation", &meth_parser_checkAnnotation684, 18);
  int argcv_meth_parser_checkAnnotation684[] = {1};
  meth_meth_parser_checkAnnotation684->type = alloc_MethodType(1, argcv_meth_parser_checkAnnotation684);
  meth_meth_parser_checkAnnotation684->definitionModule = modulename;
  meth_meth_parser_checkAnnotation684->definitionLine = 258;
// compiled method node returning  (depth = 1)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doannotation
  block_savedest(self);
  Object closure773 = createclosure(6, "doannotation");
  setclosureframe(closure773, stackframe);
  addtoclosure(closure773, var_sym);
  addtoclosure(closure773, var_collections);
  addtoclosure(closure773, var_noBlocks);
  addtoclosure(closure773, var_errormessages);
  addtoclosure(closure773, var_lastToken);
  addtoclosure(closure773, var_values);
  struct UserObject *uo773 = (struct UserObject*)self;
  uo773->data[19] = (Object)closure773;
  Method *meth_meth_parser_doannotation773 = addmethod2pos(self, "doannotation", &meth_parser_doannotation773, 19);
  int argcv_meth_parser_doannotation773[] = {0};
  meth_meth_parser_doannotation773->type = alloc_MethodType(1, argcv_meth_parser_doannotation773);
  meth_meth_parser_doannotation773->definitionModule = modulename;
  meth_meth_parser_doannotation773->definitionLine = 276;
// compiled method node returning  (depth = 1)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method blank
  block_savedest(self);
  Object closure949 = createclosure(5, "blank");
  setclosureframe(closure949, stackframe);
  addtoclosure(closure949, var_lastToken);
  addtoclosure(closure949, var_sym);
  addtoclosure(closure949, var_values);
  addtoclosure(closure949, var_util);
  addtoclosure(closure949, var_ast);
  struct UserObject *uo949 = (struct UserObject*)self;
  uo949->data[20] = (Object)closure949;
  Method *meth_meth_parser_blank949 = addmethod2pos(self, "blank", &meth_parser_blank949, 20);
  int argcv_meth_parser_blank949[] = {0};
  meth_meth_parser_blank949->type = alloc_MethodType(1, argcv_meth_parser_blank949);
  meth_meth_parser_blank949->definitionModule = modulename;
  meth_meth_parser_blank949->definitionLine = 322;
// compiled method node returning  (depth = 1)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dotypeterm
  block_savedest(self);
  Object closure993 = createclosure(2, "dotypeterm");
  setclosureframe(closure993, stackframe);
  addtoclosure(closure993, var_noBlocks);
  addtoclosure(closure993, var_sym);
  struct UserObject *uo993 = (struct UserObject*)self;
  uo993->data[21] = (Object)closure993;
  Method *meth_meth_parser_dotypeterm993 = addmethod2pos(self, "dotypeterm", &meth_parser_dotypeterm993, 21);
  int argcv_meth_parser_dotypeterm993[] = {0};
  meth_meth_parser_dotypeterm993->type = alloc_MethodType(1, argcv_meth_parser_dotypeterm993);
  meth_meth_parser_dotypeterm993->definitionModule = modulename;
  meth_meth_parser_dotypeterm993->definitionLine = 333;
// compiled method node returning  (depth = 1)
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeexpression
  block_savedest(self);
  Object closure1021 = createclosure(6, "typeexpression");
  setclosureframe(closure1021, stackframe);
  addtoclosure(closure1021, var_values);
  addtoclosure(closure1021, var_statementToken);
  addtoclosure(closure1021, var_sym);
  addtoclosure(closure1021, var_errormessages);
  addtoclosure(closure1021, var_lastToken);
  addtoclosure(closure1021, var_noBlocks);
  struct UserObject *uo1021 = (struct UserObject*)self;
  uo1021->data[22] = (Object)closure1021;
  Method *meth_meth_parser_typeexpression1021 = addmethod2pos(self, "typeexpression", &meth_parser_typeexpression1021, 22);
  int argcv_meth_parser_typeexpression1021[] = {0};
  meth_meth_parser_typeexpression1021->type = alloc_MethodType(1, argcv_meth_parser_typeexpression1021);
  meth_meth_parser_typeexpression1021->definitionModule = modulename;
  meth_meth_parser_typeexpression1021->definitionLine = 345;
// compiled method node returning  (depth = 1)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method newIf
  block_savedest(self);
  Object closure1112 = createclosure(1, "newIf");
  setclosureframe(closure1112, stackframe);
  addtoclosure(closure1112, var_ast);
  struct UserObject *uo1112 = (struct UserObject*)self;
  uo1112->data[23] = (Object)closure1112;
  Method *meth_meth_parser_newIf1112 = addmethod2pos(self, "newIf", &meth_parser_newIf1112, 23);
  int argcv_meth_parser_newIf1112[] = {3};
  meth_meth_parser_newIf1112->type = alloc_MethodType(1, argcv_meth_parser_newIf1112);
  meth_meth_parser_newIf1112->definitionModule = modulename;
  meth_meth_parser_newIf1112->definitionLine = 382;
// compiled method node returning  (depth = 1)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method block
  block_savedest(self);
  Object closure1127 = createclosure(12, "block");
  setclosureframe(closure1127, stackframe);
  addtoclosure(closure1127, var_sym);
  addtoclosure(closure1127, var_statementIndent);
  addtoclosure(closure1127, var_statementToken);
  addtoclosure(closure1127, var_blocksOK);
  addtoclosure(closure1127, var_values);
  addtoclosure(closure1127, var_braceIsType);
  addtoclosure(closure1127, var_errormessages);
  addtoclosure(closure1127, var_lastToken);
  addtoclosure(closure1127, var_indentFreePass);
  addtoclosure(closure1127, var_ast);
  addtoclosure(closure1127, var_minIndentLevel);
  addtoclosure(closure1127, var_util);
  struct UserObject *uo1127 = (struct UserObject*)self;
  uo1127->data[24] = (Object)closure1127;
  Method *meth_meth_parser_block1127 = addmethod2pos(self, "block", &meth_parser_block1127, 24);
  int argcv_meth_parser_block1127[] = {0};
  meth_meth_parser_block1127->type = alloc_MethodType(1, argcv_meth_parser_block1127);
  meth_meth_parser_block1127->definitionModule = modulename;
  meth_meth_parser_block1127->definitionLine = 389;
// compiled method node returning  (depth = 1)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doif
  block_savedest(self);
  Object closure1647 = createclosure(8, "doif");
  setclosureframe(closure1647, stackframe);
  addtoclosure(closure1647, var_sym);
  addtoclosure(closure1647, var_errormessages);
  addtoclosure(closure1647, var_blocksOK);
  addtoclosure(closure1647, var_lastToken);
  addtoclosure(closure1647, var_values);
  addtoclosure(closure1647, var_minIndentLevel);
  addtoclosure(closure1647, var_statementIndent);
  addtoclosure(closure1647, var_statementToken);
  struct UserObject *uo1647 = (struct UserObject*)self;
  uo1647->data[25] = (Object)closure1647;
  Method *meth_meth_parser_doif1647 = addmethod2pos(self, "doif", &meth_parser_doif1647, 25);
  int argcv_meth_parser_doif1647[] = {0};
  meth_meth_parser_doif1647->type = alloc_MethodType(1, argcv_meth_parser_doif1647);
  meth_meth_parser_doif1647->definitionModule = modulename;
  meth_meth_parser_doif1647->definitionLine = 563;
// compiled method node returning  (depth = 1)
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method identifier
  block_savedest(self);
  Object closure3017 = createclosure(1, "identifier");
  setclosureframe(closure3017, stackframe);
  addtoclosure(closure3017, var_sym);
  struct UserObject *uo3017 = (struct UserObject*)self;
  uo3017->data[26] = (Object)closure3017;
  Method *meth_meth_parser_identifier3017 = addmethod2pos(self, "identifier", &meth_parser_identifier3017, 26);
  int argcv_meth_parser_identifier3017[] = {0};
  meth_meth_parser_identifier3017->type = alloc_MethodType(1, argcv_meth_parser_identifier3017);
  meth_meth_parser_identifier3017->definitionModule = modulename;
  meth_meth_parser_identifier3017->definitionLine = 944;
// compiled method node returning  (depth = 1)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method prefixop
  block_savedest(self);
  Object closure3033 = createclosure(6, "prefixop");
  setclosureframe(closure3033, stackframe);
  addtoclosure(closure3033, var_sym);
  addtoclosure(closure3033, var_blocksOK);
  addtoclosure(closure3033, var_errormessages);
  addtoclosure(closure3033, var_lastToken);
  addtoclosure(closure3033, var_values);
  addtoclosure(closure3033, var_ast);
  struct UserObject *uo3033 = (struct UserObject*)self;
  uo3033->data[27] = (Object)closure3033;
  Method *meth_meth_parser_prefixop3033 = addmethod2pos(self, "prefixop", &meth_parser_prefixop3033, 27);
  int argcv_meth_parser_prefixop3033[] = {0};
  meth_meth_parser_prefixop3033->type = alloc_MethodType(1, argcv_meth_parser_prefixop3033);
  meth_meth_parser_prefixop3033->definitionModule = modulename;
  meth_meth_parser_prefixop3033->definitionLine = 954;
// compiled method node returning  (depth = 1)
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method generic
  block_savedest(self);
  Object closure3220 = createclosure(5, "generic");
  setclosureframe(closure3220, stackframe);
  addtoclosure(closure3220, var_values);
  addtoclosure(closure3220, var_sym);
  addtoclosure(closure3220, var_errormessages);
  addtoclosure(closure3220, var_lastToken);
  addtoclosure(closure3220, var_ast);
  struct UserObject *uo3220 = (struct UserObject*)self;
  uo3220->data[28] = (Object)closure3220;
  Method *meth_meth_parser_generic3220 = addmethod2pos(self, "generic", &meth_parser_generic3220, 28);
  int argcv_meth_parser_generic3220[] = {0};
  meth_meth_parser_generic3220->type = alloc_MethodType(1, argcv_meth_parser_generic3220);
  meth_meth_parser_generic3220->definitionModule = modulename;
  meth_meth_parser_generic3220->definitionLine = 1011;
// compiled method node returning  (depth = 1)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method trycatch
  block_savedest(self);
  Object closure3406 = createclosure(8, "trycatch");
  setclosureframe(closure3406, stackframe);
  addtoclosure(closure3406, var_sym);
  addtoclosure(closure3406, var_minIndentLevel);
  addtoclosure(closure3406, var_errormessages);
  addtoclosure(closure3406, var_lastToken);
  addtoclosure(closure3406, var_blocksOK);
  addtoclosure(closure3406, var_values);
  addtoclosure(closure3406, var_tokens);
  addtoclosure(closure3406, var_ast);
  struct UserObject *uo3406 = (struct UserObject*)self;
  uo3406->data[29] = (Object)closure3406;
  Method *meth_meth_parser_trycatch3406 = addmethod2pos(self, "trycatch", &meth_parser_trycatch3406, 29);
  int argcv_meth_parser_trycatch3406[] = {0};
  meth_meth_parser_trycatch3406->type = alloc_MethodType(1, argcv_meth_parser_trycatch3406);
  meth_meth_parser_trycatch3406->definitionModule = modulename;
  meth_meth_parser_trycatch3406->definitionLine = 1071;
// compiled method node returning  (depth = 1)
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method catchcase
  block_savedest(self);
  Object closure3998 = createclosure(9, "catchcase");
  setclosureframe(closure3998, stackframe);
  addtoclosure(closure3998, var_sym);
  addtoclosure(closure3998, var_minIndentLevel);
  addtoclosure(closure3998, var_util);
  addtoclosure(closure3998, var_errormessages);
  addtoclosure(closure3998, var_lastToken);
  addtoclosure(closure3998, var_blocksOK);
  addtoclosure(closure3998, var_values);
  addtoclosure(closure3998, var_tokens);
  addtoclosure(closure3998, var_ast);
  struct UserObject *uo3998 = (struct UserObject*)self;
  uo3998->data[30] = (Object)closure3998;
  Method *meth_meth_parser_catchcase3998 = addmethod2pos(self, "catchcase", &meth_parser_catchcase3998, 30);
  int argcv_meth_parser_catchcase3998[] = {0};
  meth_meth_parser_catchcase3998->type = alloc_MethodType(1, argcv_meth_parser_catchcase3998);
  meth_meth_parser_catchcase3998->definitionModule = modulename;
  meth_meth_parser_catchcase3998->definitionLine = 1238;
// compiled method node returning  (depth = 1)
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method matchcase
  block_savedest(self);
  Object closure4560 = createclosure(8, "matchcase");
  setclosureframe(closure4560, stackframe);
  addtoclosure(closure4560, var_sym);
  addtoclosure(closure4560, var_minIndentLevel);
  addtoclosure(closure4560, var_errormessages);
  addtoclosure(closure4560, var_blocksOK);
  addtoclosure(closure4560, var_lastToken);
  addtoclosure(closure4560, var_values);
  addtoclosure(closure4560, var_tokens);
  addtoclosure(closure4560, var_ast);
  struct UserObject *uo4560 = (struct UserObject*)self;
  uo4560->data[31] = (Object)closure4560;
  Method *meth_meth_parser_matchcase4560 = addmethod2pos(self, "matchcase", &meth_parser_matchcase4560, 31);
  int argcv_meth_parser_matchcase4560[] = {0};
  meth_meth_parser_matchcase4560->type = alloc_MethodType(1, argcv_meth_parser_matchcase4560);
  meth_meth_parser_matchcase4560->definitionModule = modulename;
  meth_meth_parser_matchcase4560->definitionLine = 1399;
// compiled method node returning  (depth = 1)
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method term
  block_savedest(self);
  Object closure4927 = createclosure(2, "term");
  setclosureframe(closure4927, stackframe);
  addtoclosure(closure4927, var_sym);
  addtoclosure(closure4927, var_util);
  struct UserObject *uo4927 = (struct UserObject*)self;
  uo4927->data[32] = (Object)closure4927;
  Method *meth_meth_parser_term4927 = addmethod2pos(self, "term", &meth_parser_term4927, 32);
  int argcv_meth_parser_term4927[] = {0};
  meth_meth_parser_term4927->type = alloc_MethodType(1, argcv_meth_parser_term4927);
  meth_meth_parser_term4927->definitionModule = modulename;
  meth_meth_parser_term4927->definitionLine = 1552;
// compiled method node returning  (depth = 1)
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method expression
  block_savedest(self);
  Object closure5053 = createclosure(6, "expression");
  setclosureframe(closure5053, stackframe);
  addtoclosure(closure5053, var_values);
  addtoclosure(closure5053, var_sym);
  addtoclosure(closure5053, var_util);
  addtoclosure(closure5053, var_statementToken);
  addtoclosure(closure5053, var_errormessages);
  addtoclosure(closure5053, var_lastToken);
  struct UserObject *uo5053 = (struct UserObject*)self;
  uo5053->data[33] = (Object)closure5053;
  Method *meth_meth_parser_expression5053 = addmethod2pos(self, "expression", &meth_parser_expression5053, 33);
  int argcv_meth_parser_expression5053[] = {1};
  meth_meth_parser_expression5053->type = alloc_MethodType(1, argcv_meth_parser_expression5053);
  meth_meth_parser_expression5053->definitionModule = modulename;
  meth_meth_parser_expression5053->definitionLine = 1586;
// compiled method node returning  (depth = 1)
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method postfixsquare
  block_savedest(self);
  Object closure5160 = createclosure(6, "postfixsquare");
  setclosureframe(closure5160, stackframe);
  addtoclosure(closure5160, var_values);
  addtoclosure(closure5160, var_blocksOK);
  addtoclosure(closure5160, var_errormessages);
  addtoclosure(closure5160, var_sym);
  addtoclosure(closure5160, var_lastToken);
  addtoclosure(closure5160, var_ast);
  struct UserObject *uo5160 = (struct UserObject*)self;
  uo5160->data[34] = (Object)closure5160;
  Method *meth_meth_parser_postfixsquare5160 = addmethod2pos(self, "postfixsquare", &meth_parser_postfixsquare5160, 34);
  int argcv_meth_parser_postfixsquare5160[] = {0};
  meth_meth_parser_postfixsquare5160->type = alloc_MethodType(1, argcv_meth_parser_postfixsquare5160);
  meth_meth_parser_postfixsquare5160->definitionModule = modulename;
  meth_meth_parser_postfixsquare5160->definitionLine = 1627;
// compiled method node returning  (depth = 1)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method oprec
  struct UserObject *uo5270 = (struct UserObject*)self;
  uo5270->data[35] = emptyclosure;
  Method *meth_meth_parser_oprec5270 = addmethod2pos(self, "oprec", &meth_parser_oprec5270, 35);
  int argcv_meth_parser_oprec5270[] = {1};
  meth_meth_parser_oprec5270->type = alloc_MethodType(1, argcv_meth_parser_oprec5270);
  meth_meth_parser_oprec5270->definitionModule = modulename;
  meth_meth_parser_oprec5270->definitionLine = 1668;
// compiled method node returning  (depth = 1)
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method toprec
  struct UserObject *uo5284 = (struct UserObject*)self;
  uo5284->data[36] = emptyclosure;
  Method *meth_meth_parser_toprec5284 = addmethod2pos(self, "toprec", &meth_parser_toprec5284, 36);
  int argcv_meth_parser_toprec5284[] = {1};
  meth_meth_parser_toprec5284->type = alloc_MethodType(1, argcv_meth_parser_toprec5284);
  meth_meth_parser_toprec5284->definitionModule = modulename;
  meth_meth_parser_toprec5284->definitionLine = 1678;
// compiled method node returning  (depth = 1)
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeexpressionrest
  block_savedest(self);
  Object closure5297 = createclosure(1, "typeexpressionrest");
  setclosureframe(closure5297, stackframe);
  addtoclosure(closure5297, var_noBlocks);
  struct UserObject *uo5297 = (struct UserObject*)self;
  uo5297->data[37] = (Object)closure5297;
  Method *meth_meth_parser_typeexpressionrest5297 = addmethod2pos(self, "typeexpressionrest", &meth_parser_typeexpressionrest5297, 37);
  int argcv_meth_parser_typeexpressionrest5297[] = {0};
  meth_meth_parser_typeexpressionrest5297->type = alloc_MethodType(1, argcv_meth_parser_typeexpressionrest5297);
  meth_meth_parser_typeexpressionrest5297->definitionModule = modulename;
  meth_meth_parser_typeexpressionrest5297->definitionLine = 1687;
// compiled method node returning  (depth = 1)
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method valueexpressionrest
  block_savedest(self);
  Object closure5310 = createclosure(1, "valueexpressionrest");
  setclosureframe(closure5310, stackframe);
  addtoclosure(closure5310, var_blocksOK);
  struct UserObject *uo5310 = (struct UserObject*)self;
  uo5310->data[38] = (Object)closure5310;
  Method *meth_meth_parser_valueexpressionrest5310 = addmethod2pos(self, "valueexpressionrest", &meth_parser_valueexpressionrest5310, 38);
  int argcv_meth_parser_valueexpressionrest5310[] = {0};
  meth_meth_parser_valueexpressionrest5310->type = alloc_MethodType(1, argcv_meth_parser_valueexpressionrest5310);
  meth_meth_parser_valueexpressionrest5310->definitionModule = modulename;
  meth_meth_parser_valueexpressionrest5310->definitionLine = 1693;
// compiled method node returning  (depth = 1)
// Begin line 1699
  setline(1699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method expressionrest()recursingWith()blocks
  block_savedest(self);
  Object closure5323 = createclosure(7, "expressionrest()recursingWith()blocks");
  setclosureframe(closure5323, stackframe);
  addtoclosure(closure5323, var_values);
  addtoclosure(closure5323, var_sym);
  addtoclosure(closure5323, var_statementToken);
  addtoclosure(closure5323, var_errormessages);
  addtoclosure(closure5323, var_lastToken);
  addtoclosure(closure5323, var_ast);
  addtoclosure(closure5323, var_util);
  struct UserObject *uo5323 = (struct UserObject*)self;
  uo5323->data[39] = (Object)closure5323;
  Method *meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323 = addmethod2pos(self, "expressionrest()recursingWith()blocks", &meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323, 39);
  int argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323[] = {1, 1, 1};
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323->type = alloc_MethodType(3, argcv_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323);
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323->definitionModule = modulename;
  meth_meth_parser_expressionrest_40__41_recursingWith_40__41_blocks5323->definitionLine = 1699;
// compiled method node returning  (depth = 1)
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dotrest
  block_savedest(self);
  Object closure5818 = createclosure(6, "dotrest");
  setclosureframe(closure5818, stackframe);
  addtoclosure(closure5818, var_sym);
  addtoclosure(closure5818, var_util);
  addtoclosure(closure5818, var_values);
  addtoclosure(closure5818, var_ast);
  addtoclosure(closure5818, var_errormessages);
  addtoclosure(closure5818, var_lastToken);
  struct UserObject *uo5818 = (struct UserObject*)self;
  uo5818->data[40] = (Object)closure5818;
  Method *meth_meth_parser_dotrest5818 = addmethod2pos(self, "dotrest", &meth_parser_dotrest5818, 40);
  int argcv_meth_parser_dotrest5818[] = {1};
  meth_meth_parser_dotrest5818->type = alloc_MethodType(1, argcv_meth_parser_dotrest5818);
  meth_meth_parser_dotrest5818->definitionModule = modulename;
  meth_meth_parser_dotrest5818->definitionLine = 1844;
// compiled method node returning  (depth = 1)
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method callrest
  block_savedest(self);
  Object closure5924 = createclosure(6, "callrest");
  setclosureframe(closure5924, stackframe);
  addtoclosure(closure5924, var_values);
  addtoclosure(closure5924, var_sym);
  addtoclosure(closure5924, var_util);
  addtoclosure(closure5924, var_ast);
  addtoclosure(closure5924, var_lastToken);
  addtoclosure(closure5924, var_minIndentLevel);
  struct UserObject *uo5924 = (struct UserObject*)self;
  uo5924->data[41] = (Object)closure5924;
  Method *meth_meth_parser_callrest5924 = addmethod2pos(self, "callrest", &meth_parser_callrest5924, 41);
  int argcv_meth_parser_callrest5924[] = {1};
  meth_meth_parser_callrest5924->type = alloc_MethodType(1, argcv_meth_parser_callrest5924);
  meth_meth_parser_callrest5924->definitionModule = modulename;
  meth_meth_parser_callrest5924->definitionLine = 1879;
// compiled method node returning  (depth = 1)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method parenthesizedArg
  block_savedest(self);
  Object closure6177 = createclosure(5, "parenthesizedArg");
  setclosureframe(closure6177, stackframe);
  addtoclosure(closure6177, var_blocksOK);
  addtoclosure(closure6177, var_values);
  addtoclosure(closure6177, var_errormessages);
  addtoclosure(closure6177, var_sym);
  addtoclosure(closure6177, var_lastToken);
  struct UserObject *uo6177 = (struct UserObject*)self;
  uo6177->data[42] = (Object)closure6177;
  Method *meth_meth_parser_parenthesizedArg6177 = addmethod2pos(self, "parenthesizedArg", &meth_parser_parenthesizedArg6177, 42);
  int argcv_meth_parser_parenthesizedArg6177[] = {1};
  meth_meth_parser_parenthesizedArg6177->type = alloc_MethodType(1, argcv_meth_parser_parenthesizedArg6177);
  meth_meth_parser_parenthesizedArg6177->definitionModule = modulename;
  meth_meth_parser_parenthesizedArg6177->definitionLine = 1969;
// compiled method node returning  (depth = 1)
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeArgs
  block_savedest(self);
  Object closure6576 = createclosure(4, "typeArgs");
  setclosureframe(closure6576, stackframe);
  addtoclosure(closure6576, var_sym);
  addtoclosure(closure6576, var_values);
  addtoclosure(closure6576, var_errormessages);
  addtoclosure(closure6576, var_lastToken);
  struct UserObject *uo6576 = (struct UserObject*)self;
  uo6576->data[43] = (Object)closure6576;
  Method *meth_meth_parser_typeArgs6576 = addmethod2pos(self, "typeArgs", &meth_parser_typeArgs6576, 43);
  int argcv_meth_parser_typeArgs6576[] = {0};
  meth_meth_parser_typeArgs6576->type = alloc_MethodType(1, argcv_meth_parser_typeArgs6576);
  meth_meth_parser_typeArgs6576->definitionModule = modulename;
  meth_meth_parser_typeArgs6576->definitionLine = 2079;
// compiled method node returning  (depth = 1)
// Begin line 2104
  setline(2104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typeArg
  block_savedest(self);
  Object closure6658 = createclosure(3, "typeArg");
  setclosureframe(closure6658, stackframe);
  addtoclosure(closure6658, var_sym);
  addtoclosure(closure6658, var_values);
  addtoclosure(closure6658, var_ast);
  struct UserObject *uo6658 = (struct UserObject*)self;
  uo6658->data[44] = (Object)closure6658;
  Method *meth_meth_parser_typeArg6658 = addmethod2pos(self, "typeArg", &meth_parser_typeArg6658, 44);
  int argcv_meth_parser_typeArg6658[] = {0};
  meth_meth_parser_typeArg6658->type = alloc_MethodType(1, argcv_meth_parser_typeArg6658);
  meth_meth_parser_typeArg6658->definitionModule = modulename;
  meth_meth_parser_typeArg6658->definitionLine = 2104;
// compiled method node returning  (depth = 1)
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method callmprest
  block_savedest(self);
  Object closure6690 = createclosure(6, "callmprest");
  setclosureframe(closure6690, stackframe);
  addtoclosure(closure6690, var_lastToken);
  addtoclosure(closure6690, var_ast);
  addtoclosure(closure6690, var_values);
  addtoclosure(closure6690, var_errormessages);
  addtoclosure(closure6690, var_sym);
  addtoclosure(closure6690, var_blocksOK);
  struct UserObject *uo6690 = (struct UserObject*)self;
  uo6690->data[45] = (Object)closure6690;
  Method *meth_meth_parser_callmprest6690 = addmethod2pos(self, "callmprest", &meth_parser_callmprest6690, 45);
  int argcv_meth_parser_callmprest6690[] = {3};
  meth_meth_parser_callmprest6690->type = alloc_MethodType(1, argcv_meth_parser_callmprest6690);
  meth_meth_parser_callmprest6690->definitionModule = modulename;
  meth_meth_parser_callmprest6690->definitionLine = 2120;
// compiled method node returning  (depth = 1)
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method defdec
  block_savedest(self);
  Object closure7120 = createclosure(7, "defdec");
  setclosureframe(closure7120, stackframe);
  addtoclosure(closure7120, var_sym);
  addtoclosure(closure7120, var_errormessages);
  addtoclosure(closure7120, var_lastToken);
  addtoclosure(closure7120, var_ast);
  addtoclosure(closure7120, var_values);
  addtoclosure(closure7120, var_blocksOK);
  addtoclosure(closure7120, var_defaultDefVisibility);
  struct UserObject *uo7120 = (struct UserObject*)self;
  uo7120->data[46] = (Object)closure7120;
  Method *meth_meth_parser_defdec7120 = addmethod2pos(self, "defdec", &meth_parser_defdec7120, 46);
  int argcv_meth_parser_defdec7120[] = {0};
  meth_meth_parser_defdec7120->type = alloc_MethodType(1, argcv_meth_parser_defdec7120);
  meth_meth_parser_defdec7120->definitionModule = modulename;
  meth_meth_parser_defdec7120->definitionLine = 2252;
// compiled method node returning  (depth = 1)
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method vardec
  block_savedest(self);
  Object closure7381 = createclosure(7, "vardec");
  setclosureframe(closure7381, stackframe);
  addtoclosure(closure7381, var_sym);
  addtoclosure(closure7381, var_errormessages);
  addtoclosure(closure7381, var_lastToken);
  addtoclosure(closure7381, var_ast);
  addtoclosure(closure7381, var_values);
  addtoclosure(closure7381, var_blocksOK);
  addtoclosure(closure7381, var_defaultVarVisibility);
  struct UserObject *uo7381 = (struct UserObject*)self;
  uo7381->data[47] = (Object)closure7381;
  Method *meth_meth_parser_vardec7381 = addmethod2pos(self, "vardec", &meth_parser_vardec7381, 47);
  int argcv_meth_parser_vardec7381[] = {0};
  meth_meth_parser_vardec7381->type = alloc_MethodType(1, argcv_meth_parser_vardec7381);
  meth_meth_parser_vardec7381->definitionModule = modulename;
  meth_meth_parser_vardec7381->definitionLine = 2328;
// compiled method node returning  (depth = 1)
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doarray
  block_savedest(self);
  Object closure7617 = createclosure(6, "doarray");
  setclosureframe(closure7617, stackframe);
  addtoclosure(closure7617, var_blocksOK);
  addtoclosure(closure7617, var_values);
  addtoclosure(closure7617, var_errormessages);
  addtoclosure(closure7617, var_sym);
  addtoclosure(closure7617, var_lastToken);
  addtoclosure(closure7617, var_ast);
  struct UserObject *uo7617 = (struct UserObject*)self;
  uo7617->data[48] = (Object)closure7617;
  Method *meth_meth_parser_doarray7617 = addmethod2pos(self, "doarray", &meth_parser_doarray7617, 48);
  int argcv_meth_parser_doarray7617[] = {0};
  meth_meth_parser_doarray7617->type = alloc_MethodType(1, argcv_meth_parser_doarray7617);
  meth_meth_parser_doarray7617->definitionModule = modulename;
  meth_meth_parser_doarray7617->definitionLine = 2399;
// compiled method node returning  (depth = 1)
// Begin line 2442
  setline(2442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dodialect
  block_savedest(self);
  Object closure7746 = createclosure(5, "dodialect");
  setclosureframe(closure7746, stackframe);
  addtoclosure(closure7746, var_sym);
  addtoclosure(closure7746, var_errormessages);
  addtoclosure(closure7746, var_lastToken);
  addtoclosure(closure7746, var_ast);
  addtoclosure(closure7746, var_values);
  struct UserObject *uo7746 = (struct UserObject*)self;
  uo7746->data[49] = (Object)closure7746;
  Method *meth_meth_parser_dodialect7746 = addmethod2pos(self, "dodialect", &meth_parser_dodialect7746, 49);
  int argcv_meth_parser_dodialect7746[] = {0};
  meth_meth_parser_dodialect7746->type = alloc_MethodType(1, argcv_meth_parser_dodialect7746);
  meth_meth_parser_dodialect7746->definitionModule = modulename;
  meth_meth_parser_dodialect7746->definitionLine = 2442;
// compiled method node returning  (depth = 1)
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method inheritsdec
  block_savedest(self);
  Object closure7835 = createclosure(7, "inheritsdec");
  setclosureframe(closure7835, stackframe);
  addtoclosure(closure7835, var_sym);
  addtoclosure(closure7835, var_noBlocks);
  addtoclosure(closure7835, var_errormessages);
  addtoclosure(closure7835, var_lastToken);
  addtoclosure(closure7835, var_util);
  addtoclosure(closure7835, var_values);
  addtoclosure(closure7835, var_ast);
  struct UserObject *uo7835 = (struct UserObject*)self;
  uo7835->data[50] = (Object)closure7835;
  Method *meth_meth_parser_inheritsdec7835 = addmethod2pos(self, "inheritsdec", &meth_parser_inheritsdec7835, 50);
  int argcv_meth_parser_inheritsdec7835[] = {0};
  meth_meth_parser_inheritsdec7835->type = alloc_MethodType(1, argcv_meth_parser_inheritsdec7835);
  meth_meth_parser_inheritsdec7835->definitionModule = modulename;
  meth_meth_parser_inheritsdec7835->definitionLine = 2464;
// compiled method node returning  (depth = 1)
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doobject
  block_savedest(self);
  Object closure7930 = createclosure(8, "doobject");
  setclosureframe(closure7930, stackframe);
  addtoclosure(closure7930, var_sym);
  addtoclosure(closure7930, var_minIndentLevel);
  addtoclosure(closure7930, var_errormessages);
  addtoclosure(closure7930, var_lastToken);
  addtoclosure(closure7930, var_values);
  addtoclosure(closure7930, var_statementToken);
  addtoclosure(closure7930, var_util);
  addtoclosure(closure7930, var_ast);
  struct UserObject *uo7930 = (struct UserObject*)self;
  uo7930->data[51] = (Object)closure7930;
  Method *meth_meth_parser_doobject7930 = addmethod2pos(self, "doobject", &meth_parser_doobject7930, 51);
  int argcv_meth_parser_doobject7930[] = {0};
  meth_meth_parser_doobject7930->type = alloc_MethodType(1, argcv_meth_parser_doobject7930);
  meth_meth_parser_doobject7930->definitionModule = modulename;
  meth_meth_parser_doobject7930->definitionLine = 2492;
// compiled method node returning  (depth = 1)
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doclass
  block_savedest(self);
  Object closure8167 = createclosure(10, "doclass");
  setclosureframe(closure8167, stackframe);
  addtoclosure(closure8167, var_sym);
  addtoclosure(closure8167, var_minIndentLevel);
  addtoclosure(closure8167, var_errormessages);
  addtoclosure(closure8167, var_lastToken);
  addtoclosure(closure8167, var_tokens);
  addtoclosure(closure8167, var_values);
  addtoclosure(closure8167, var_statementToken);
  addtoclosure(closure8167, var_util);
  addtoclosure(closure8167, var_ast);
  addtoclosure(closure8167, var_defaultMethodVisibility);
  struct UserObject *uo8167 = (struct UserObject*)self;
  uo8167->data[52] = (Object)closure8167;
  Method *meth_meth_parser_doclass8167 = addmethod2pos(self, "doclass", &meth_parser_doclass8167, 52);
  int argcv_meth_parser_doclass8167[] = {0};
  meth_meth_parser_doclass8167->type = alloc_MethodType(1, argcv_meth_parser_doclass8167);
  meth_meth_parser_doclass8167->definitionModule = modulename;
  meth_meth_parser_doclass8167->definitionLine = 2569;
// compiled method node returning  (depth = 1)
// Begin line 2660
  setline(2660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dofactoryMethod
  block_savedest(self);
  Object closure8482 = createclosure(11, "dofactoryMethod");
  setclosureframe(closure8482, stackframe);
  addtoclosure(closure8482, var_tokens);
  addtoclosure(closure8482, var_sym);
  addtoclosure(closure8482, var_minIndentLevel);
  addtoclosure(closure8482, var_errormessages);
  addtoclosure(closure8482, var_lastToken);
  addtoclosure(closure8482, var_statementToken);
  addtoclosure(closure8482, var_values);
  addtoclosure(closure8482, var_util);
  addtoclosure(closure8482, var_ast);
  addtoclosure(closure8482, var_collections);
  addtoclosure(closure8482, var_defaultMethodVisibility);
  struct UserObject *uo8482 = (struct UserObject*)self;
  uo8482->data[53] = (Object)closure8482;
  Method *meth_meth_parser_dofactoryMethod8482 = addmethod2pos(self, "dofactoryMethod", &meth_parser_dofactoryMethod8482, 53);
  int argcv_meth_parser_dofactoryMethod8482[] = {0};
  meth_meth_parser_dofactoryMethod8482->type = alloc_MethodType(1, argcv_meth_parser_dofactoryMethod8482);
  meth_meth_parser_dofactoryMethod8482->definitionModule = modulename;
  meth_meth_parser_dofactoryMethod8482->definitionLine = 2660;
// compiled method node returning  (depth = 1)
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method methoddec
  block_savedest(self);
  Object closure8758 = createclosure(9, "methoddec");
  setclosureframe(closure8758, stackframe);
  addtoclosure(closure8758, var_sym);
  addtoclosure(closure8758, var_statementToken);
  addtoclosure(closure8758, var_minIndentLevel);
  addtoclosure(closure8758, var_values);
  addtoclosure(closure8758, var_errormessages);
  addtoclosure(closure8758, var_lastToken);
  addtoclosure(closure8758, var_util);
  addtoclosure(closure8758, var_ast);
  addtoclosure(closure8758, var_defaultMethodVisibility);
  struct UserObject *uo8758 = (struct UserObject*)self;
  uo8758->data[54] = (Object)closure8758;
  Method *meth_meth_parser_methoddec8758 = addmethod2pos(self, "methoddec", &meth_parser_methoddec8758, 54);
  int argcv_meth_parser_methoddec8758[] = {0};
  meth_meth_parser_methoddec8758->type = alloc_MethodType(1, argcv_meth_parser_methoddec8758);
  meth_meth_parser_methoddec8758->definitionModule = modulename;
  meth_meth_parser_methoddec8758->definitionLine = 2735;
// compiled method node returning  (depth = 1)
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method parsempmndecrest
  block_savedest(self);
  Object closure8991 = createclosure(5, "parsempmndecrest");
  setclosureframe(closure8991, stackframe);
  addtoclosure(closure8991, var_ast);
  addtoclosure(closure8991, var_values);
  addtoclosure(closure8991, var_errormessages);
  addtoclosure(closure8991, var_lastToken);
  addtoclosure(closure8991, var_sym);
  struct UserObject *uo8991 = (struct UserObject*)self;
  uo8991->data[55] = (Object)closure8991;
  Method *meth_meth_parser_parsempmndecrest8991 = addmethod2pos(self, "parsempmndecrest", &meth_parser_parsempmndecrest8991, 55);
  int argcv_meth_parser_parsempmndecrest8991[] = {2};
  meth_meth_parser_parsempmndecrest8991->type = alloc_MethodType(1, argcv_meth_parser_parsempmndecrest8991);
  meth_meth_parser_parsempmndecrest8991->definitionModule = modulename;
  meth_meth_parser_parsempmndecrest8991->definitionLine = 2823;
// compiled method node returning  (depth = 1)
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method methodsignature
  block_savedest(self);
  Object closure9255 = createclosure(6, "methodsignature");
  setclosureframe(closure9255, stackframe);
  addtoclosure(closure9255, var_sym);
  addtoclosure(closure9255, var_errormessages);
  addtoclosure(closure9255, var_lastToken);
  addtoclosure(closure9255, var_values);
  addtoclosure(closure9255, var_ast);
  addtoclosure(closure9255, var_tokens);
  struct UserObject *uo9255 = (struct UserObject*)self;
  uo9255->data[56] = (Object)closure9255;
  Method *meth_meth_parser_methodsignature9255 = addmethod2pos(self, "methodsignature", &meth_parser_methodsignature9255, 56);
  int argcv_meth_parser_methodsignature9255[] = {1};
  meth_meth_parser_methodsignature9255->type = alloc_MethodType(1, argcv_meth_parser_methodsignature9255);
  meth_meth_parser_methodsignature9255->definitionModule = modulename;
  meth_meth_parser_methodsignature9255->definitionLine = 2907;
// compiled method node returning  (depth = 1)
// Begin line 3106
  setline(3106);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doimport
  block_savedest(self);
  Object closure9995 = createclosure(7, "doimport");
  setclosureframe(closure9995, stackframe);
  addtoclosure(closure9995, var_sym);
  addtoclosure(closure9995, var_ast);
  addtoclosure(closure9995, var_errormessages);
  addtoclosure(closure9995, var_lastToken);
  addtoclosure(closure9995, var_values);
  addtoclosure(closure9995, var_util);
  addtoclosure(closure9995, var_defaultDefVisibility);
  struct UserObject *uo9995 = (struct UserObject*)self;
  uo9995->data[57] = (Object)closure9995;
  Method *meth_meth_parser_doimport9995 = addmethod2pos(self, "doimport", &meth_parser_doimport9995, 57);
  int argcv_meth_parser_doimport9995[] = {0};
  meth_meth_parser_doimport9995->type = alloc_MethodType(1, argcv_meth_parser_doimport9995);
  meth_meth_parser_doimport9995->definitionModule = modulename;
  meth_meth_parser_doimport9995->definitionLine = 3106;
// compiled method node returning  (depth = 1)
// Begin line 3171
  setline(3171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method doreturn
  block_savedest(self);
  Object closure10266 = createclosure(6, "doreturn");
  setclosureframe(closure10266, stackframe);
  addtoclosure(closure10266, var_sym);
  addtoclosure(closure10266, var_blocksOK);
  addtoclosure(closure10266, var_errormessages);
  addtoclosure(closure10266, var_lastToken);
  addtoclosure(closure10266, var_values);
  addtoclosure(closure10266, var_ast);
  struct UserObject *uo10266 = (struct UserObject*)self;
  uo10266->data[58] = (Object)closure10266;
  Method *meth_meth_parser_doreturn10266 = addmethod2pos(self, "doreturn", &meth_parser_doreturn10266, 58);
  int argcv_meth_parser_doreturn10266[] = {0};
  meth_meth_parser_doreturn10266->type = alloc_MethodType(1, argcv_meth_parser_doreturn10266);
  meth_meth_parser_doreturn10266->definitionModule = modulename;
  meth_meth_parser_doreturn10266->definitionLine = 3171;
// compiled method node returning  (depth = 1)
// Begin line 3204
  setline(3204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method domethodtype
  block_savedest(self);
  Object closure10387 = createclosure(6, "domethodtype");
  setclosureframe(closure10387, stackframe);
  addtoclosure(closure10387, var_ast);
  addtoclosure(closure10387, var_values);
  addtoclosure(closure10387, var_sym);
  addtoclosure(closure10387, var_lastToken);
  addtoclosure(closure10387, var_errormessages);
  addtoclosure(closure10387, var_util);
  struct UserObject *uo10387 = (struct UserObject*)self;
  uo10387->data[59] = (Object)closure10387;
  Method *meth_meth_parser_domethodtype10387 = addmethod2pos(self, "domethodtype", &meth_parser_domethodtype10387, 59);
  int argcv_meth_parser_domethodtype10387[] = {0};
  meth_meth_parser_domethodtype10387->type = alloc_MethodType(1, argcv_meth_parser_domethodtype10387);
  meth_meth_parser_domethodtype10387->definitionModule = modulename;
  meth_meth_parser_domethodtype10387->definitionLine = 3204;
// compiled method node returning  (depth = 1)
// Begin line 3233
  setline(3233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method dotypeLiteral
  block_savedest(self);
  Object closure10485 = createclosure(6, "dotypeLiteral");
  setclosureframe(closure10485, stackframe);
  addtoclosure(closure10485, var_sym);
  addtoclosure(closure10485, var_errormessages);
  addtoclosure(closure10485, var_done);
  addtoclosure(closure10485, var_auto_count);
  addtoclosure(closure10485, var_values);
  addtoclosure(closure10485, var_ast);
  struct UserObject *uo10485 = (struct UserObject*)self;
  uo10485->data[60] = (Object)closure10485;
  Method *meth_meth_parser_dotypeLiteral10485 = addmethod2pos(self, "dotypeLiteral", &meth_parser_dotypeLiteral10485, 60);
  int argcv_meth_parser_dotypeLiteral10485[] = {0};
  meth_meth_parser_dotypeLiteral10485->type = alloc_MethodType(1, argcv_meth_parser_dotypeLiteral10485);
  meth_meth_parser_dotypeLiteral10485->definitionModule = modulename;
  meth_meth_parser_dotypeLiteral10485->definitionLine = 3233;
// compiled method node returning  (depth = 1)
// Begin line 3266
  setline(3266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method typedec
  block_savedest(self);
  Object closure10584 = createclosure(6, "typedec");
  setclosureframe(closure10584, stackframe);
  addtoclosure(closure10584, var_sym);
  addtoclosure(closure10584, var_errormessages);
  addtoclosure(closure10584, var_lastToken);
  addtoclosure(closure10584, var_values);
  addtoclosure(closure10584, var_noBlocks);
  addtoclosure(closure10584, var_ast);
  struct UserObject *uo10584 = (struct UserObject*)self;
  uo10584->data[61] = (Object)closure10584;
  Method *meth_meth_parser_typedec10584 = addmethod2pos(self, "typedec", &meth_parser_typedec10584, 61);
  int argcv_meth_parser_typedec10584[] = {0};
  meth_meth_parser_typedec10584->type = alloc_MethodType(1, argcv_meth_parser_typedec10584);
  meth_meth_parser_typedec10584->definitionModule = modulename;
  meth_meth_parser_typedec10584->definitionLine = 3266;
// compiled method node returning  (depth = 1)
// Begin line 3316
  setline(3316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkIndent
  block_savedest(self);
  Object closure10767 = createclosure(5, "checkIndent");
  setclosureframe(closure10767, stackframe);
  addtoclosure(closure10767, var_indentFreePass);
  addtoclosure(closure10767, var_sym);
  addtoclosure(closure10767, var_minIndentLevel);
  addtoclosure(closure10767, var_errormessages);
  addtoclosure(closure10767, var_lastToken);
  struct UserObject *uo10767 = (struct UserObject*)self;
  uo10767->data[62] = (Object)closure10767;
  Method *meth_meth_parser_checkIndent10767 = addmethod2pos(self, "checkIndent", &meth_parser_checkIndent10767, 62);
  int argcv_meth_parser_checkIndent10767[] = {0};
  meth_meth_parser_checkIndent10767->type = alloc_MethodType(1, argcv_meth_parser_checkIndent10767);
  meth_meth_parser_checkIndent10767->definitionModule = modulename;
  meth_meth_parser_checkIndent10767->definitionLine = 3316;
// compiled method node returning  (depth = 1)
// Begin line 3357
  setline(3357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method statement
  block_savedest(self);
  Object closure10947 = createclosure(9, "statement");
  setclosureframe(closure10947, stackframe);
  addtoclosure(closure10947, var_sym);
  addtoclosure(closure10947, var_statementIndent);
  addtoclosure(closure10947, var_statementToken);
  addtoclosure(closure10947, var_blocksOK);
  addtoclosure(closure10947, var_values);
  addtoclosure(closure10947, var_errormessages);
  addtoclosure(closure10947, var_lastToken);
  addtoclosure(closure10947, var_ast);
  addtoclosure(closure10947, var_indentFreePass);
  struct UserObject *uo10947 = (struct UserObject*)self;
  uo10947->data[63] = (Object)closure10947;
  Method *meth_meth_parser_statement10947 = addmethod2pos(self, "statement", &meth_parser_statement10947, 63);
  int argcv_meth_parser_statement10947[] = {0};
  meth_meth_parser_statement10947->type = alloc_MethodType(1, argcv_meth_parser_statement10947);
  meth_meth_parser_statement10947->definitionModule = modulename;
  meth_meth_parser_statement10947->definitionLine = 3357;
// compiled method node returning  (depth = 1)
// Begin line 3425
  setline(3425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkBadOperators
  block_savedest(self);
  Object closure11168 = createclosure(2, "checkBadOperators");
  setclosureframe(closure11168, stackframe);
  addtoclosure(closure11168, var_sym);
  addtoclosure(closure11168, var_errormessages);
  struct UserObject *uo11168 = (struct UserObject*)self;
  uo11168->data[64] = (Object)closure11168;
  Method *meth_meth_parser_checkBadOperators11168 = addmethod2pos(self, "checkBadOperators", &meth_parser_checkBadOperators11168, 64);
  int argcv_meth_parser_checkBadOperators11168[] = {0};
  meth_meth_parser_checkBadOperators11168->type = alloc_MethodType(1, argcv_meth_parser_checkBadOperators11168);
  meth_meth_parser_checkBadOperators11168->definitionModule = modulename;
  meth_meth_parser_checkBadOperators11168->definitionLine = 3425;
// compiled method node returning  (depth = 1)
// Begin line 3442
  setline(3442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkBadTypeLiteral
  block_savedest(self);
  Object closure11215 = createclosure(2, "checkBadTypeLiteral");
  setclosureframe(closure11215, stackframe);
  addtoclosure(closure11215, var_sym);
  addtoclosure(closure11215, var_errormessages);
  struct UserObject *uo11215 = (struct UserObject*)self;
  uo11215->data[65] = (Object)closure11215;
  Method *meth_meth_parser_checkBadTypeLiteral11215 = addmethod2pos(self, "checkBadTypeLiteral", &meth_parser_checkBadTypeLiteral11215, 65);
  int argcv_meth_parser_checkBadTypeLiteral11215[] = {0};
  meth_meth_parser_checkBadTypeLiteral11215->type = alloc_MethodType(1, argcv_meth_parser_checkBadTypeLiteral11215);
  meth_meth_parser_checkBadTypeLiteral11215->definitionModule = modulename;
  meth_meth_parser_checkBadTypeLiteral11215->definitionLine = 3442;
// compiled method node returning  (depth = 1)
// Begin line 3452
  setline(3452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method checkUnexpectedTokenAfterStatement
  block_savedest(self);
  Object closure11239 = createclosure(5, "checkUnexpectedTokenAfterStatement");
  setclosureframe(closure11239, stackframe);
  addtoclosure(closure11239, var_lastToken);
  addtoclosure(closure11239, var_sym);
  addtoclosure(closure11239, var_errormessages);
  addtoclosure(closure11239, var_values);
  addtoclosure(closure11239, var_util);
  struct UserObject *uo11239 = (struct UserObject*)self;
  uo11239->data[66] = (Object)closure11239;
  Method *meth_meth_parser_checkUnexpectedTokenAfterStatement11239 = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_checkUnexpectedTokenAfterStatement11239, 66);
  int argcv_meth_parser_checkUnexpectedTokenAfterStatement11239[] = {0};
  meth_meth_parser_checkUnexpectedTokenAfterStatement11239->type = alloc_MethodType(1, argcv_meth_parser_checkUnexpectedTokenAfterStatement11239);
  meth_meth_parser_checkUnexpectedTokenAfterStatement11239->definitionModule = modulename;
  meth_meth_parser_checkUnexpectedTokenAfterStatement11239->definitionLine = 3452;
// compiled method node returning  (depth = 1)
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method parse
  block_savedest(self);
  Object closure11559 = createclosure(10, "parse");
  setclosureframe(closure11559, stackframe);
  addtoclosure(closure11559, var_util);
  addtoclosure(closure11559, var_values);
  addtoclosure(closure11559, var_defaultDefVisibility);
  addtoclosure(closure11559, var_defaultVarVisibility);
  addtoclosure(closure11559, var_defaultMethodVisibility);
  addtoclosure(closure11559, var_tokens);
  addtoclosure(closure11559, var_sym);
  addtoclosure(closure11559, var_errormessages);
  addtoclosure(closure11559, var_lastToken);
  addtoclosure(closure11559, var_linenum);
  struct UserObject *uo11559 = (struct UserObject*)self;
  uo11559->data[67] = (Object)closure11559;
  Method *meth_meth_parser_parse11559 = addmethod2pos(self, "parse", &meth_parser_parse11559, 67);
  int argcv_meth_parser_parse11559[] = {1};
  meth_meth_parser_parse11559->type = alloc_MethodType(1, argcv_meth_parser_parse11559);
  meth_meth_parser_parse11559->definitionModule = modulename;
  meth_meth_parser_parse11559->definitionLine = 3523;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = module_ast_init();
  *var_ast = module_ast;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of mgcollections as collections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_collections = module_mgcollections;
// compiled import node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = module_errormessages_init();
  *var_errormessages = module_errormessages;
// compiled import node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11770 = alloc_Boolean(1);
// compiled identifier node returning bool11770 (depth = 2)
  *var_don_39_tBreak = bool11770;
  if (bool11770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method don'tBreak
  block_savedest(self);
  Object closure11771 = createclosure(1, "don'tBreak");
  setclosureframe(closure11771, stackframe);
  addtoclosure(closure11771, var_don_39_tBreak);
  struct UserObject *uo11771 = (struct UserObject*)self;
  uo11771->data[68] = (Object)closure11771;
  Method *meth_meth_parser_don_39_tBreak11771 = addmethod2pos(self, "don'tBreak", &meth_parser_don_39_tBreak11771, 68);
  int argcv_meth_parser_don_39_tBreak11771[] = {0};
  meth_meth_parser_don_39_tBreak11771->type = alloc_MethodType(1, argcv_meth_parser_don_39_tBreak11771);
  meth_meth_parser_don_39_tBreak11771->definitionModule = modulename;
  meth_meth_parser_don_39_tBreak11771->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num11772 = alloc_Float64(0);
// compiled num node returning num11772 (depth = 2)
  *var_lastline = num11772;
  if (num11772 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastline
  block_savedest(self);
  Object closure11773 = createclosure(1, "lastline");
  setclosureframe(closure11773, stackframe);
  addtoclosure(closure11773, var_lastline);
  struct UserObject *uo11773 = (struct UserObject*)self;
  uo11773->data[69] = (Object)closure11773;
  Method *meth_meth_parser_lastline11773 = addmethod2pos(self, "lastline", &meth_parser_lastline11773, 69);
  int argcv_meth_parser_lastline11773[] = {0};
  meth_meth_parser_lastline11773->type = alloc_MethodType(1, argcv_meth_parser_lastline11773);
  meth_meth_parser_lastline11773->definitionModule = modulename;
  meth_meth_parser_lastline11773->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastline:=
  block_savedest(self);
  Object closure11774 = createclosure(1, "lastline:=");
  setclosureframe(closure11774, stackframe);
  addtoclosure(closure11774, var_lastline);
  struct UserObject *uo11774 = (struct UserObject*)self;
  uo11774->data[70] = (Object)closure11774;
  Method *meth_meth_parser_lastline_58__61_11774 = addmethod2pos(self, "lastline:=", &meth_parser_lastline_58__61_11774, 70);
  int argcv_meth_parser_lastline_58__61_11774[] = {1};
  meth_meth_parser_lastline_58__61_11774->type = alloc_MethodType(1, argcv_meth_parser_lastline_58__61_11774);
  meth_meth_parser_lastline_58__61_11774->definitionModule = modulename;
  meth_meth_parser_lastline_58__61_11774->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num11776 = alloc_Float64(0);
// compiled num node returning num11776 (depth = 2)
  *var_linenum = num11776;
  if (num11776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method linenum
  block_savedest(self);
  Object closure11777 = createclosure(1, "linenum");
  setclosureframe(closure11777, stackframe);
  addtoclosure(closure11777, var_linenum);
  struct UserObject *uo11777 = (struct UserObject*)self;
  uo11777->data[71] = (Object)closure11777;
  Method *meth_meth_parser_linenum11777 = addmethod2pos(self, "linenum", &meth_parser_linenum11777, 71);
  int argcv_meth_parser_linenum11777[] = {0};
  meth_meth_parser_linenum11777->type = alloc_MethodType(1, argcv_meth_parser_linenum11777);
  meth_meth_parser_linenum11777->definitionModule = modulename;
  meth_meth_parser_linenum11777->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method linenum:=
  block_savedest(self);
  Object closure11778 = createclosure(1, "linenum:=");
  setclosureframe(closure11778, stackframe);
  addtoclosure(closure11778, var_linenum);
  struct UserObject *uo11778 = (struct UserObject*)self;
  uo11778->data[72] = (Object)closure11778;
  Method *meth_meth_parser_linenum_58__61_11778 = addmethod2pos(self, "linenum:=", &meth_parser_linenum_58__61_11778, 72);
  int argcv_meth_parser_linenum_58__61_11778[] = {1};
  meth_meth_parser_linenum_58__61_11778->type = alloc_MethodType(1, argcv_meth_parser_linenum_58__61_11778);
  meth_meth_parser_linenum_58__61_11778->definitionModule = modulename;
  meth_meth_parser_linenum_58__61_11778->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num11780 = alloc_Float64(0);
// compiled num node returning num11780 (depth = 2)
  *var_lastIndent = num11780;
  if (num11780 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastIndent
  block_savedest(self);
  Object closure11781 = createclosure(1, "lastIndent");
  setclosureframe(closure11781, stackframe);
  addtoclosure(closure11781, var_lastIndent);
  struct UserObject *uo11781 = (struct UserObject*)self;
  uo11781->data[73] = (Object)closure11781;
  Method *meth_meth_parser_lastIndent11781 = addmethod2pos(self, "lastIndent", &meth_parser_lastIndent11781, 73);
  int argcv_meth_parser_lastIndent11781[] = {0};
  meth_meth_parser_lastIndent11781->type = alloc_MethodType(1, argcv_meth_parser_lastIndent11781);
  meth_meth_parser_lastIndent11781->definitionModule = modulename;
  meth_meth_parser_lastIndent11781->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastIndent:=
  block_savedest(self);
  Object closure11782 = createclosure(1, "lastIndent:=");
  setclosureframe(closure11782, stackframe);
  addtoclosure(closure11782, var_lastIndent);
  struct UserObject *uo11782 = (struct UserObject*)self;
  uo11782->data[74] = (Object)closure11782;
  Method *meth_meth_parser_lastIndent_58__61_11782 = addmethod2pos(self, "lastIndent:=", &meth_parser_lastIndent_58__61_11782, 74);
  int argcv_meth_parser_lastIndent_58__61_11782[] = {1};
  meth_meth_parser_lastIndent_58__61_11782->type = alloc_MethodType(1, argcv_meth_parser_lastIndent_58__61_11782);
  meth_meth_parser_lastIndent_58__61_11782->definitionModule = modulename;
  meth_meth_parser_lastIndent_58__61_11782->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11784 = alloc_Boolean(0);
// compiled identifier node returning bool11784 (depth = 2)
  *var_indentFreePass = bool11784;
  if (bool11784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method indentFreePass
  block_savedest(self);
  Object closure11785 = createclosure(1, "indentFreePass");
  setclosureframe(closure11785, stackframe);
  addtoclosure(closure11785, var_indentFreePass);
  struct UserObject *uo11785 = (struct UserObject*)self;
  uo11785->data[75] = (Object)closure11785;
  Method *meth_meth_parser_indentFreePass11785 = addmethod2pos(self, "indentFreePass", &meth_parser_indentFreePass11785, 75);
  int argcv_meth_parser_indentFreePass11785[] = {0};
  meth_meth_parser_indentFreePass11785->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass11785);
  meth_meth_parser_indentFreePass11785->definitionModule = modulename;
  meth_meth_parser_indentFreePass11785->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method indentFreePass:=
  block_savedest(self);
  Object closure11786 = createclosure(1, "indentFreePass:=");
  setclosureframe(closure11786, stackframe);
  addtoclosure(closure11786, var_indentFreePass);
  struct UserObject *uo11786 = (struct UserObject*)self;
  uo11786->data[76] = (Object)closure11786;
  Method *meth_meth_parser_indentFreePass_58__61_11786 = addmethod2pos(self, "indentFreePass:=", &meth_parser_indentFreePass_58__61_11786, 76);
  int argcv_meth_parser_indentFreePass_58__61_11786[] = {1};
  meth_meth_parser_indentFreePass_58__61_11786->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass_58__61_11786);
  meth_meth_parser_indentFreePass_58__61_11786->definitionModule = modulename;
  meth_meth_parser_indentFreePass_58__61_11786->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num11788 = alloc_Float64(0);
// compiled num node returning num11788 (depth = 2)
  *var_minIndentLevel = num11788;
  if (num11788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method minIndentLevel
  block_savedest(self);
  Object closure11789 = createclosure(1, "minIndentLevel");
  setclosureframe(closure11789, stackframe);
  addtoclosure(closure11789, var_minIndentLevel);
  struct UserObject *uo11789 = (struct UserObject*)self;
  uo11789->data[77] = (Object)closure11789;
  Method *meth_meth_parser_minIndentLevel11789 = addmethod2pos(self, "minIndentLevel", &meth_parser_minIndentLevel11789, 77);
  int argcv_meth_parser_minIndentLevel11789[] = {0};
  meth_meth_parser_minIndentLevel11789->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel11789);
  meth_meth_parser_minIndentLevel11789->definitionModule = modulename;
  meth_meth_parser_minIndentLevel11789->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method minIndentLevel:=
  block_savedest(self);
  Object closure11790 = createclosure(1, "minIndentLevel:=");
  setclosureframe(closure11790, stackframe);
  addtoclosure(closure11790, var_minIndentLevel);
  struct UserObject *uo11790 = (struct UserObject*)self;
  uo11790->data[78] = (Object)closure11790;
  Method *meth_meth_parser_minIndentLevel_58__61_11790 = addmethod2pos(self, "minIndentLevel:=", &meth_parser_minIndentLevel_58__61_11790, 78);
  int argcv_meth_parser_minIndentLevel_58__61_11790[] = {1};
  meth_meth_parser_minIndentLevel_58__61_11790->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel_58__61_11790);
  meth_meth_parser_minIndentLevel_58__61_11790->definitionModule = modulename;
  meth_meth_parser_minIndentLevel_58__61_11790->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num11792 = alloc_Float64(0);
// compiled num node returning num11792 (depth = 2)
  *var_statementIndent = num11792;
  if (num11792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementIndent
  block_savedest(self);
  Object closure11793 = createclosure(1, "statementIndent");
  setclosureframe(closure11793, stackframe);
  addtoclosure(closure11793, var_statementIndent);
  struct UserObject *uo11793 = (struct UserObject*)self;
  uo11793->data[79] = (Object)closure11793;
  Method *meth_meth_parser_statementIndent11793 = addmethod2pos(self, "statementIndent", &meth_parser_statementIndent11793, 79);
  int argcv_meth_parser_statementIndent11793[] = {0};
  meth_meth_parser_statementIndent11793->type = alloc_MethodType(1, argcv_meth_parser_statementIndent11793);
  meth_meth_parser_statementIndent11793->definitionModule = modulename;
  meth_meth_parser_statementIndent11793->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementIndent:=
  block_savedest(self);
  Object closure11794 = createclosure(1, "statementIndent:=");
  setclosureframe(closure11794, stackframe);
  addtoclosure(closure11794, var_statementIndent);
  struct UserObject *uo11794 = (struct UserObject*)self;
  uo11794->data[80] = (Object)closure11794;
  Method *meth_meth_parser_statementIndent_58__61_11794 = addmethod2pos(self, "statementIndent:=", &meth_parser_statementIndent_58__61_11794, 80);
  int argcv_meth_parser_statementIndent_58__61_11794[] = {1};
  meth_meth_parser_statementIndent_58__61_11794->type = alloc_MethodType(1, argcv_meth_parser_statementIndent_58__61_11794);
  meth_meth_parser_statementIndent_58__61_11794->definitionModule = modulename;
  meth_meth_parser_statementIndent_58__61_11794->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11796 = alloc_Boolean(0);
// compiled identifier node returning bool11796 (depth = 2)
  *var_tokens = bool11796;
  if (bool11796 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method tokens
  block_savedest(self);
  Object closure11797 = createclosure(1, "tokens");
  setclosureframe(closure11797, stackframe);
  addtoclosure(closure11797, var_tokens);
  struct UserObject *uo11797 = (struct UserObject*)self;
  uo11797->data[81] = (Object)closure11797;
  Method *meth_meth_parser_tokens11797 = addmethod2pos(self, "tokens", &meth_parser_tokens11797, 81);
  int argcv_meth_parser_tokens11797[] = {0};
  meth_meth_parser_tokens11797->type = alloc_MethodType(1, argcv_meth_parser_tokens11797);
  meth_meth_parser_tokens11797->definitionModule = modulename;
  meth_meth_parser_tokens11797->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method tokens:=
  block_savedest(self);
  Object closure11798 = createclosure(1, "tokens:=");
  setclosureframe(closure11798, stackframe);
  addtoclosure(closure11798, var_tokens);
  struct UserObject *uo11798 = (struct UserObject*)self;
  uo11798->data[82] = (Object)closure11798;
  Method *meth_meth_parser_tokens_58__61_11798 = addmethod2pos(self, "tokens:=", &meth_parser_tokens_58__61_11798, 82);
  int argcv_meth_parser_tokens_58__61_11798[] = {1};
  meth_meth_parser_tokens_58__61_11798->type = alloc_MethodType(1, argcv_meth_parser_tokens_58__61_11798);
  meth_meth_parser_tokens_58__61_11798->definitionModule = modulename;
  meth_meth_parser_tokens_58__61_11798->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 2)
  Object array11800 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array11800 (depth = 2)
  *var_values = array11800;
  if (array11800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method values
  block_savedest(self);
  Object closure11801 = createclosure(1, "values");
  setclosureframe(closure11801, stackframe);
  addtoclosure(closure11801, var_values);
  struct UserObject *uo11801 = (struct UserObject*)self;
  uo11801->data[83] = (Object)closure11801;
  Method *meth_meth_parser_values11801 = addmethod2pos(self, "values", &meth_parser_values11801, 83);
  int argcv_meth_parser_values11801[] = {0};
  meth_meth_parser_values11801->type = alloc_MethodType(1, argcv_meth_parser_values11801);
  meth_meth_parser_values11801->definitionModule = modulename;
  meth_meth_parser_values11801->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method values:=
  block_savedest(self);
  Object closure11802 = createclosure(1, "values:=");
  setclosureframe(closure11802, stackframe);
  addtoclosure(closure11802, var_values);
  struct UserObject *uo11802 = (struct UserObject*)self;
  uo11802->data[84] = (Object)closure11802;
  Method *meth_meth_parser_values_58__61_11802 = addmethod2pos(self, "values:=", &meth_parser_values_58__61_11802, 84);
  int argcv_meth_parser_values_58__61_11802[] = {1};
  meth_meth_parser_values_58__61_11802->type = alloc_MethodType(1, argcv_meth_parser_values_58__61_11802);
  meth_meth_parser_values_58__61_11802->definitionModule = modulename;
  meth_meth_parser_values_58__61_11802->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num11804 = alloc_Float64(0);
// compiled num node returning num11804 (depth = 2)
  *var_auto_count = num11804;
  if (num11804 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method auto_count
  block_savedest(self);
  Object closure11805 = createclosure(1, "auto_count");
  setclosureframe(closure11805, stackframe);
  addtoclosure(closure11805, var_auto_count);
  struct UserObject *uo11805 = (struct UserObject*)self;
  uo11805->data[85] = (Object)closure11805;
  Method *meth_meth_parser_auto_count11805 = addmethod2pos(self, "auto_count", &meth_parser_auto_count11805, 85);
  int argcv_meth_parser_auto_count11805[] = {0};
  meth_meth_parser_auto_count11805->type = alloc_MethodType(1, argcv_meth_parser_auto_count11805);
  meth_meth_parser_auto_count11805->definitionModule = modulename;
  meth_meth_parser_auto_count11805->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method auto_count:=
  block_savedest(self);
  Object closure11806 = createclosure(1, "auto_count:=");
  setclosureframe(closure11806, stackframe);
  addtoclosure(closure11806, var_auto_count);
  struct UserObject *uo11806 = (struct UserObject*)self;
  uo11806->data[86] = (Object)closure11806;
  Method *meth_meth_parser_auto_count_58__61_11806 = addmethod2pos(self, "auto_count:=", &meth_parser_auto_count_58__61_11806, 86);
  int argcv_meth_parser_auto_count_58__61_11806[] = {1};
  meth_meth_parser_auto_count_58__61_11806->type = alloc_MethodType(1, argcv_meth_parser_auto_count_58__61_11806);
  meth_meth_parser_auto_count_58__61_11806->definitionModule = modulename;
  meth_meth_parser_auto_count_58__61_11806->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11808 = alloc_Boolean(0);
// compiled identifier node returning bool11808 (depth = 2)
  *var_noBlocks = bool11808;
  if (bool11808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method noBlocks
  block_savedest(self);
  Object closure11809 = createclosure(1, "noBlocks");
  setclosureframe(closure11809, stackframe);
  addtoclosure(closure11809, var_noBlocks);
  struct UserObject *uo11809 = (struct UserObject*)self;
  uo11809->data[87] = (Object)closure11809;
  Method *meth_meth_parser_noBlocks11809 = addmethod2pos(self, "noBlocks", &meth_parser_noBlocks11809, 87);
  int argcv_meth_parser_noBlocks11809[] = {0};
  meth_meth_parser_noBlocks11809->type = alloc_MethodType(1, argcv_meth_parser_noBlocks11809);
  meth_meth_parser_noBlocks11809->definitionModule = modulename;
  meth_meth_parser_noBlocks11809->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11810 = alloc_Boolean(1);
// compiled identifier node returning bool11810 (depth = 2)
  *var_blocksOK = bool11810;
  if (bool11810 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method blocksOK
  block_savedest(self);
  Object closure11811 = createclosure(1, "blocksOK");
  setclosureframe(closure11811, stackframe);
  addtoclosure(closure11811, var_blocksOK);
  struct UserObject *uo11811 = (struct UserObject*)self;
  uo11811->data[88] = (Object)closure11811;
  Method *meth_meth_parser_blocksOK11811 = addmethod2pos(self, "blocksOK", &meth_parser_blocksOK11811, 88);
  int argcv_meth_parser_blocksOK11811[] = {0};
  meth_meth_parser_blocksOK11811->type = alloc_MethodType(1, argcv_meth_parser_blocksOK11811);
  meth_meth_parser_blocksOK11811->definitionModule = modulename;
  meth_meth_parser_blocksOK11811->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11812 = alloc_Boolean(0);
// compiled identifier node returning bool11812 (depth = 2)
  *var_braceIsType = bool11812;
  if (bool11812 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method braceIsType
  block_savedest(self);
  Object closure11813 = createclosure(1, "braceIsType");
  setclosureframe(closure11813, stackframe);
  addtoclosure(closure11813, var_braceIsType);
  struct UserObject *uo11813 = (struct UserObject*)self;
  uo11813->data[89] = (Object)closure11813;
  Method *meth_meth_parser_braceIsType11813 = addmethod2pos(self, "braceIsType", &meth_parser_braceIsType11813, 89);
  int argcv_meth_parser_braceIsType11813[] = {0};
  meth_meth_parser_braceIsType11813->type = alloc_MethodType(1, argcv_meth_parser_braceIsType11813);
  meth_meth_parser_braceIsType11813->definitionModule = modulename;
  meth_meth_parser_braceIsType11813->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method braceIsType:=
  block_savedest(self);
  Object closure11814 = createclosure(1, "braceIsType:=");
  setclosureframe(closure11814, stackframe);
  addtoclosure(closure11814, var_braceIsType);
  struct UserObject *uo11814 = (struct UserObject*)self;
  uo11814->data[90] = (Object)closure11814;
  Method *meth_meth_parser_braceIsType_58__61_11814 = addmethod2pos(self, "braceIsType:=", &meth_parser_braceIsType_58__61_11814, 90);
  int argcv_meth_parser_braceIsType_58__61_11814[] = {1};
  meth_meth_parser_braceIsType_58__61_11814->type = alloc_MethodType(1, argcv_meth_parser_braceIsType_58__61_11814);
  meth_meth_parser_braceIsType_58__61_11814->definitionModule = modulename;
  meth_meth_parser_braceIsType_58__61_11814->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit11816 == NULL) {
    strlit11816 = alloc_String("confidential");
    gc_root(strlit11816);
  }
// compiled string node returning strlit11816 (depth = 2)
  *var_defaultDefVisibility = strlit11816;
  if (strlit11816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultDefVisibility
  block_savedest(self);
  Object closure11817 = createclosure(1, "defaultDefVisibility");
  setclosureframe(closure11817, stackframe);
  addtoclosure(closure11817, var_defaultDefVisibility);
  struct UserObject *uo11817 = (struct UserObject*)self;
  uo11817->data[91] = (Object)closure11817;
  Method *meth_meth_parser_defaultDefVisibility11817 = addmethod2pos(self, "defaultDefVisibility", &meth_parser_defaultDefVisibility11817, 91);
  int argcv_meth_parser_defaultDefVisibility11817[] = {0};
  meth_meth_parser_defaultDefVisibility11817->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility11817);
  meth_meth_parser_defaultDefVisibility11817->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility11817->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultDefVisibility:=
  block_savedest(self);
  Object closure11818 = createclosure(1, "defaultDefVisibility:=");
  setclosureframe(closure11818, stackframe);
  addtoclosure(closure11818, var_defaultDefVisibility);
  struct UserObject *uo11818 = (struct UserObject*)self;
  uo11818->data[92] = (Object)closure11818;
  Method *meth_meth_parser_defaultDefVisibility_58__61_11818 = addmethod2pos(self, "defaultDefVisibility:=", &meth_parser_defaultDefVisibility_58__61_11818, 92);
  int argcv_meth_parser_defaultDefVisibility_58__61_11818[] = {1};
  meth_meth_parser_defaultDefVisibility_58__61_11818->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility_58__61_11818);
  meth_meth_parser_defaultDefVisibility_58__61_11818->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility_58__61_11818->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit11820 == NULL) {
    strlit11820 = alloc_String("confidential");
    gc_root(strlit11820);
  }
// compiled string node returning strlit11820 (depth = 2)
  *var_defaultVarVisibility = strlit11820;
  if (strlit11820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultVarVisibility
  block_savedest(self);
  Object closure11821 = createclosure(1, "defaultVarVisibility");
  setclosureframe(closure11821, stackframe);
  addtoclosure(closure11821, var_defaultVarVisibility);
  struct UserObject *uo11821 = (struct UserObject*)self;
  uo11821->data[93] = (Object)closure11821;
  Method *meth_meth_parser_defaultVarVisibility11821 = addmethod2pos(self, "defaultVarVisibility", &meth_parser_defaultVarVisibility11821, 93);
  int argcv_meth_parser_defaultVarVisibility11821[] = {0};
  meth_meth_parser_defaultVarVisibility11821->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility11821);
  meth_meth_parser_defaultVarVisibility11821->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility11821->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultVarVisibility:=
  block_savedest(self);
  Object closure11822 = createclosure(1, "defaultVarVisibility:=");
  setclosureframe(closure11822, stackframe);
  addtoclosure(closure11822, var_defaultVarVisibility);
  struct UserObject *uo11822 = (struct UserObject*)self;
  uo11822->data[94] = (Object)closure11822;
  Method *meth_meth_parser_defaultVarVisibility_58__61_11822 = addmethod2pos(self, "defaultVarVisibility:=", &meth_parser_defaultVarVisibility_58__61_11822, 94);
  int argcv_meth_parser_defaultVarVisibility_58__61_11822[] = {1};
  meth_meth_parser_defaultVarVisibility_58__61_11822->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility_58__61_11822);
  meth_meth_parser_defaultVarVisibility_58__61_11822->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility_58__61_11822->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit11824 == NULL) {
    strlit11824 = alloc_String("public");
    gc_root(strlit11824);
  }
// compiled string node returning strlit11824 (depth = 2)
  *var_defaultMethodVisibility = strlit11824;
  if (strlit11824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultMethodVisibility
  block_savedest(self);
  Object closure11825 = createclosure(1, "defaultMethodVisibility");
  setclosureframe(closure11825, stackframe);
  addtoclosure(closure11825, var_defaultMethodVisibility);
  struct UserObject *uo11825 = (struct UserObject*)self;
  uo11825->data[95] = (Object)closure11825;
  Method *meth_meth_parser_defaultMethodVisibility11825 = addmethod2pos(self, "defaultMethodVisibility", &meth_parser_defaultMethodVisibility11825, 95);
  int argcv_meth_parser_defaultMethodVisibility11825[] = {0};
  meth_meth_parser_defaultMethodVisibility11825->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility11825);
  meth_meth_parser_defaultMethodVisibility11825->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility11825->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method defaultMethodVisibility:=
  block_savedest(self);
  Object closure11826 = createclosure(1, "defaultMethodVisibility:=");
  setclosureframe(closure11826, stackframe);
  addtoclosure(closure11826, var_defaultMethodVisibility);
  struct UserObject *uo11826 = (struct UserObject*)self;
  uo11826->data[96] = (Object)closure11826;
  Method *meth_meth_parser_defaultMethodVisibility_58__61_11826 = addmethod2pos(self, "defaultMethodVisibility:=", &meth_parser_defaultMethodVisibility_58__61_11826, 96);
  int argcv_meth_parser_defaultMethodVisibility_58__61_11826[] = {1};
  meth_meth_parser_defaultMethodVisibility_58__61_11826->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility_58__61_11826);
  meth_meth_parser_defaultMethodVisibility_58__61_11826->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility_58__61_11826->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
  *var_sym = undefined;
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method sym
  block_savedest(self);
  Object closure11828 = createclosure(1, "sym");
  setclosureframe(closure11828, stackframe);
  addtoclosure(closure11828, var_sym);
  struct UserObject *uo11828 = (struct UserObject*)self;
  uo11828->data[97] = (Object)closure11828;
  Method *meth_meth_parser_sym11828 = addmethod2pos(self, "sym", &meth_parser_sym11828, 97);
  int argcv_meth_parser_sym11828[] = {0};
  meth_meth_parser_sym11828->type = alloc_MethodType(1, argcv_meth_parser_sym11828);
  meth_meth_parser_sym11828->definitionModule = modulename;
  meth_meth_parser_sym11828->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method sym:=
  block_savedest(self);
  Object closure11829 = createclosure(1, "sym:=");
  setclosureframe(closure11829, stackframe);
  addtoclosure(closure11829, var_sym);
  struct UserObject *uo11829 = (struct UserObject*)self;
  uo11829->data[98] = (Object)closure11829;
  Method *meth_meth_parser_sym_58__61_11829 = addmethod2pos(self, "sym:=", &meth_parser_sym_58__61_11829, 98);
  int argcv_meth_parser_sym_58__61_11829[] = {1};
  meth_meth_parser_sym_58__61_11829->type = alloc_MethodType(1, argcv_meth_parser_sym_58__61_11829);
  meth_meth_parser_sym_58__61_11829->definitionModule = modulename;
  meth_meth_parser_sym_58__61_11829->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject11831 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11831 = alloc_userobj2(11,7, objclass11831);
  gc_frame_newslot(obj11831);
// OBJECT OUTER DEC outer
  adddatum2(obj11831, self, 0);
  addmethodreal(obj11831,"outer", &reader_parser_outer_11832);
  Object oldself11831 = self;
  struct StackFrameObject *oldstackframe11831 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11831);
  gc_frame_newslot((Object)stackframe);
  self = obj11831;
  Object *oldselfslot11831 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11831 = (*(struct UserObject *)self).data[0], lowerouter11831 = thisouter11831;
  if (inheritingObject11831) {
    struct UserObject *inho11831 = (struct UserObject *)inheritingObject11831;
    while (inho11831->super != GraceDefaultObject) inho11831 = (struct UserObject *)inho11831->super;
    inho11831->super = obj11831;
    self = inheritingObject11831;
    *selfslot = self;
    lowerouter11831 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11831;
  }
if (objclass11831 == NULL) {
  Method *reader11833 = addmethodrealflags(obj11831, "kind",&reader_parser_kind_11833, 0);
  Method *writer11833 = addmethodrealflags(obj11831, "kind:=",&writer_parser_kind_11833, 0);
  reader11833->definitionModule = modulename;
  writer11833->definitionModule = modulename;
  reader11833->definitionLine = 29;
  writer11833->definitionLine = 29;
}
obj11831->flags |= OFLAG_MUTABLE;
adddatum2(obj11831, alloc_Undefined(), 1);
if (objclass11831 == NULL) {
  Method *reader11834 = addmethodrealflags(obj11831, "line",&reader_parser_line_11834, 0);
  Method *writer11834 = addmethodrealflags(obj11831, "line:=",&writer_parser_line_11834, 0);
  reader11834->definitionModule = modulename;
  writer11834->definitionModule = modulename;
  reader11834->definitionLine = 30;
  writer11834->definitionLine = 30;
}
obj11831->flags |= OFLAG_MUTABLE;
adddatum2(obj11831, alloc_Undefined(), 2);
if (objclass11831 == NULL) {
  Method *reader11835 = addmethodrealflags(obj11831, "linePos",&reader_parser_linePos_11835, 0);
  Method *writer11835 = addmethodrealflags(obj11831, "linePos:=",&writer_parser_linePos_11835, 0);
  reader11835->definitionModule = modulename;
  writer11835->definitionModule = modulename;
  reader11835->definitionLine = 31;
  writer11835->definitionLine = 31;
}
obj11831->flags |= OFLAG_MUTABLE;
adddatum2(obj11831, alloc_Undefined(), 3);
if (objclass11831 == NULL) {
  Method *reader11836 = addmethodrealflags(obj11831, "indent",&reader_parser_indent_11836, 0);
  Method *writer11836 = addmethodrealflags(obj11831, "indent:=",&writer_parser_indent_11836, 0);
  reader11836->definitionModule = modulename;
  writer11836->definitionModule = modulename;
  reader11836->definitionLine = 32;
  writer11836->definitionLine = 32;
}
obj11831->flags |= OFLAG_MUTABLE;
adddatum2(obj11831, alloc_Undefined(), 4);
if (objclass11831 == NULL) {
  Method *reader11837 = addmethodrealflags(obj11831, "value",&reader_parser_value_11837, 0);
  Method *writer11837 = addmethodrealflags(obj11831, "value:=",&writer_parser_value_11837, 0);
  reader11837->definitionModule = modulename;
  writer11837->definitionModule = modulename;
  reader11837->definitionLine = 33;
  writer11837->definitionLine = 33;
}
obj11831->flags |= OFLAG_MUTABLE;
adddatum2(obj11831, alloc_Undefined(), 5);
if (objclass11831 == NULL) {
  Method *reader11838 = addmethodrealflags(obj11831, "size",&reader_parser_size_11838, MFLAG_DEF);
  reader11838->definitionModule = modulename;
  reader11838->definitionLine = 34;
}
adddatum2(obj11831, alloc_Undefined(), 6);
  sourceObject = obj11831;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11839 == NULL) {
    strlit11839 = alloc_String("start");
    gc_root(strlit11839);
  }
// compiled string node returning strlit11839 (depth = 3)
  adddatum2(obj11831, strlit11839, 1);
  sourceObject = obj11831;
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11840 = alloc_Float64(1);
// compiled num node returning num11840 (depth = 3)
  adddatum2(obj11831, num11840, 2);
  sourceObject = obj11831;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11841 = alloc_Float64(0);
// compiled num node returning num11841 (depth = 3)
  adddatum2(obj11831, num11841, 3);
  sourceObject = obj11831;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11842 = alloc_Float64(0);
// compiled num node returning num11842 (depth = 3)
  adddatum2(obj11831, num11842, 4);
  sourceObject = obj11831;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit11843 == NULL) {
    strlit11843 = alloc_String("");
    gc_root(strlit11843);
  }
// compiled string node returning strlit11843 (depth = 3)
  adddatum2(obj11831, strlit11843, 5);
  sourceObject = obj11831;
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num11844 = alloc_Float64(0);
// compiled num node returning num11844 (depth = 3)
  adddatum2(obj11831, num11844, 6);
objclass11831 = obj11831->class;
  objclass11831->definitionModule = modulename;
  objclass11831->definitionLine = 27;
  (*(struct UserObject *)self).data[0] = lowerouter11831;
  self = oldself11831;
  selfslot = oldselfslot11831;
  stackframe = oldstackframe11831;
// compiled object node returning obj11831 (depth = 2)
  *var_lastToken = obj11831;
  if (obj11831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastToken
  block_savedest(self);
  Object closure11845 = createclosure(1, "lastToken");
  setclosureframe(closure11845, stackframe);
  addtoclosure(closure11845, var_lastToken);
  struct UserObject *uo11845 = (struct UserObject*)self;
  uo11845->data[99] = (Object)closure11845;
  Method *meth_meth_parser_lastToken11845 = addmethod2pos(self, "lastToken", &meth_parser_lastToken11845, 99);
  int argcv_meth_parser_lastToken11845[] = {0};
  meth_meth_parser_lastToken11845->type = alloc_MethodType(1, argcv_meth_parser_lastToken11845);
  meth_meth_parser_lastToken11845->definitionModule = modulename;
  meth_meth_parser_lastToken11845->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method lastToken:=
  block_savedest(self);
  Object closure11846 = createclosure(1, "lastToken:=");
  setclosureframe(closure11846, stackframe);
  addtoclosure(closure11846, var_lastToken);
  struct UserObject *uo11846 = (struct UserObject*)self;
  uo11846->data[100] = (Object)closure11846;
  Method *meth_meth_parser_lastToken_58__61_11846 = addmethod2pos(self, "lastToken:=", &meth_parser_lastToken_58__61_11846, 100);
  int argcv_meth_parser_lastToken_58__61_11846[] = {1};
  meth_meth_parser_lastToken_58__61_11846->type = alloc_MethodType(1, argcv_meth_parser_lastToken_58__61_11846);
  meth_meth_parser_lastToken_58__61_11846->definitionModule = modulename;
  meth_meth_parser_lastToken_58__61_11846->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 35
  setline(35);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lastToken (depth = 2)
  *var_statementToken = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementToken
  block_savedest(self);
  Object closure11848 = createclosure(1, "statementToken");
  setclosureframe(closure11848, stackframe);
  addtoclosure(closure11848, var_statementToken);
  struct UserObject *uo11848 = (struct UserObject*)self;
  uo11848->data[101] = (Object)closure11848;
  Method *meth_meth_parser_statementToken11848 = addmethod2pos(self, "statementToken", &meth_parser_statementToken11848, 101);
  int argcv_meth_parser_statementToken11848[] = {0};
  meth_meth_parser_statementToken11848->type = alloc_MethodType(1, argcv_meth_parser_statementToken11848);
  meth_meth_parser_statementToken11848->definitionModule = modulename;
  meth_meth_parser_statementToken11848->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method statementToken:=
  block_savedest(self);
  Object closure11849 = createclosure(1, "statementToken:=");
  setclosureframe(closure11849, stackframe);
  addtoclosure(closure11849, var_statementToken);
  struct UserObject *uo11849 = (struct UserObject*)self;
  uo11849->data[102] = (Object)closure11849;
  Method *meth_meth_parser_statementToken_58__61_11849 = addmethod2pos(self, "statementToken:=", &meth_parser_statementToken_58__61_11849, 102);
  int argcv_meth_parser_statementToken_58__61_11849[] = {1};
  meth_meth_parser_statementToken_58__61_11849->type = alloc_MethodType(1, argcv_meth_parser_statementToken_58__61_11849);
  meth_meth_parser_statementToken_58__61_11849->definitionModule = modulename;
  meth_meth_parser_statementToken_58__61_11849->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 1)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool11851 = alloc_Boolean(0);
// compiled identifier node returning bool11851 (depth = 2)
  *var_comment = bool11851;
  if (bool11851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method comment
  block_savedest(self);
  Object closure11852 = createclosure(1, "comment");
  setclosureframe(closure11852, stackframe);
  addtoclosure(closure11852, var_comment);
  struct UserObject *uo11852 = (struct UserObject*)self;
  uo11852->data[103] = (Object)closure11852;
  Method *meth_meth_parser_comment11852 = addmethod2pos(self, "comment", &meth_parser_comment11852, 103);
  int argcv_meth_parser_comment11852[] = {0};
  meth_meth_parser_comment11852->type = alloc_MethodType(1, argcv_meth_parser_comment11852);
  meth_meth_parser_comment11852->definitionModule = modulename;
  meth_meth_parser_comment11852->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// Begin line 3583
  setline(3583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method comment:=
  block_savedest(self);
  Object closure11853 = createclosure(1, "comment:=");
  setclosureframe(closure11853, stackframe);
  addtoclosure(closure11853, var_comment);
  struct UserObject *uo11853 = (struct UserObject*)self;
  uo11853->data[104] = (Object)closure11853;
  Method *meth_meth_parser_comment_58__61_11853 = addmethod2pos(self, "comment:=", &meth_parser_comment_58__61_11853, 104);
  int argcv_meth_parser_comment_58__61_11853[] = {1};
  meth_meth_parser_comment_58__61_11853->type = alloc_MethodType(1, argcv_meth_parser_comment_58__61_11853);
  meth_meth_parser_comment_58__61_11853->definitionModule = modulename;
  meth_meth_parser_comment_58__61_11853->definitionLine = 3583;
// compiled method node returning  (depth = 2)
// compiled vardec node returning done (depth = 1)
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2078
  setline(2078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2103
  setline(2103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2490
  setline(2490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2658
  setline(2658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2733
  setline(2733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2816
  setline(2816);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3265
  setline(3265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3315
  setline(3315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3424
  setline(3424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3451
  setline(3451);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3520
  setline(3520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
